#---  12/13/2024  -------
This package was built using CMake and is compatible with Hera, Jet, Orion/Hercules, Gaea C6, and WCOSS2.
This version was cloned from TC_tracker repo on Github and is seperate from ens_tracker.

#---  04/19/2023  -------
This package could be run on wcoss2, hera, jet, orion.
The EPIC/hpc-stack is applied for compile on hera, jet, orion.

#---  12/09/2021  ------
Cactus: /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5

(1) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/sorc
Module_ens_tracker.v1.1.15_for_Wcoss2   ---- added-----
build.sh   ---- updated ----
README.build  ---- updated ----

(2) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/versions ---- added-----
build.ver
run.ver

(3) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/modulefiles  ---- added-----
build.module_load_wcoss2  
run.module_load_wcoss2
tracker_wcoss2.lua

(4) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/ush/FSUgenesisPY
renamed  ---- pathlib.py  ---- as ---- pathlibTC.py
renamed  ---- pathlib.pyc  ---- as ---- pathlibTC.pyc

(5) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/control/wcoss2  ---- added ---
jfsu_tc_genesis_00.ecf_wcoss2
jfv3_cyclone_track_00.ecf_wcoss2
jfv3_cyclone_genesis_00.ecf_wcoss2
jfv3gdas_cyclone_track_00.ecf_wcoss2

(6) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/jobs
JFSU_TC_GENESIS_JP ---- updated ----
JFV3_CYCLONE_TRACK_JP  ---- updated ----
JFV3_CYCLONE_GENESIS_JP ---- updated ----
JFV3GDAS_CYCLONE_TRACK_JP  ---- updated ----

(7) /lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.5/scripts
exgfs_fsu_genesis.sh  ---- updated ----
exgfs_tc_track.sh  ---- updated ----
exgfs_tc_genesis.sh  ---- updated ----
exgdas_tc_track.sh  ---- updated ----

(8) the output:
/lfs/h2/emc/vpppg/noscrub/Jiayi.Peng/canned_output_v1.1.15.5


#---  03/11/2021  -------
It is copied from /gpfs/dell2/emc/modeling/save/Kate.Friedman/git/ens_tracker/ens_tracker.v1.1.15.4_4_Kate
Venus: /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.4/sorc
The update includes:

(1) All of icc in makefile/makefile_hera/makefile_orion will be updated as "mpiicc"
All of ifort in makefile/makefile_hera/makefile_orion will be updated as "mpiifort"

*.fd/makefile
*.fd/makefile_hera
*.fd/makefile_orion

(2)./sorc/Module_ens_tracker.v1.1.15_for_Dell
./sorc/Module_ens_tracker.v1.1.15_for_Hera
./sorc/Module_ens_tracker.v1.1.15_for_Orion

(3)./sorc/build.sh

#---  03/02/2021  -------
Venus: /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.4_Kate
Update for hpc-stack module. The changes include:
(1)./sorc/Module_ens_tracker.v1.1.15_for_Dell

(2)./sorc/build.sh



#---  08/06/2020  -------
Mars: /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.3_4_Kate

The new FSU-genesis package is added in this package.
The GFS and TC-vital data path has been updated:
export COMPONENT=${COMPONENT:-atmos}
gfsdir=${gfsdir:-${COMINgfs:?}/${cyc}/${COMPONENT}} ;
synvitdir=${COMINgfs:?}/${cyc}/${COMPONENT}

(1) FSU-genesis
The source python scripts: ./ush/FSUgenesisPY
Please read: README_4_tclogg for compile and run
./control/dell/jfsu_tc_genesis_00.ecf_dell
./jobs/JFSU_TC_GENESIS_JP
./scripts/exgfs_fsu_genesis.sh
  export gfsdir=/gpfs/dell1/nco/ops/com/gfs/prod
./ush/data_check_gfs_180hr.sh
  export COMPONENT=${COMPONENT:-atmos} .... missing
  datdir=${gfsdir}/gfs.${PDY}/${cyc}/${COMPONENT}
./ush/extrkr_fsu.sh
  export COMPONENT=${COMPONENT:-atmos}
  export file_name=${gfsdir}/gfs.{date:%Y%m%d}/{date:%H}/${COMPONENT}/gfs.t{date:%H}z.pgrb2.0p25.f{fhr:03}

(2) GFS-track
./control/dell/jfv3_cyclone_track_00.ecf_dell
./jobs/JFV3_CYCLONE_TRACK_JP
./scripts/exgfs_tc_track.sh
  export COMPONENT=${COMPONENT:-atmos}
  export gfsdir=${COMINgfs}/${cyc}/${COMPONENT}
./ush/data_check_gfs.sh
./ush/extrkr_gfs.sh
  gfsdir=${gfsdir:-${COMINgfs:?}/${cyc}/${COMPONENT}} ;
  synvitdir=${COMINgfs:?}/${cyc}/${COMPONENT}
  synvitold_dir=${synvitdir%.*}.${old_4ymd}/${old_hh}/${COMPONENT}
  synvitfuture_dir=${synvitdir%.*}.${future_4ymd}/${future_hh}/${COMPONENT}

(3) GDAS-track
./control/dell/jfv3gdas_cyclone_track_00.ecf_dell
./jobs/JFV3GDAS_CYCLONE_TRACK_JP
./scripts/exgdas_tc_track.sh
  export COMPONENT=${COMPONENT:-atmos}
  export gdasdir=${COMINgdas}/${cyc}/${COMPONENT}
./ush/data_check_gdas.sh
./ush/extrkr_gfs.sh
  gdasdir=${gdasdir:-${COMINgdas:?}/${cyc}/${COMPONENT}}    ;

(4) GFS-genesis
./control/dell/jfv3_cyclone_genesis_00.ecf_dell
./jobs/JFV3_CYCLONE_GENESIS_JP
./scripts/exgfs_tc_genesis.sh
  export COMPONENT=${COMPONENT:-atmos}
  export gfsdir=${COMINgfs}/${cyc}/${COMPONENT}
./ush/data_check_gfs.sh
./ush/extrkr_tcv_gfs.sh
  gfsdir=${gfsdir:-${COMINgfs:?}/${cyc}/${COMPONENT}}  ;
  synvitdir=${COMINgfs:?}/${cyc}/${COMPONENT}
  synvitold_dir=${synvitdir%.*}.${old_4ymd}/${old_hh}/${COMPONENT}
  synvitfuture_dir=${synvitdir%.*}.${future_4ymd}/${future_hh}/${COMPONENT}
./ush/extrkr_gen_gfs.sh
  gfsdir=${gfsdir:-${COMINgfs:?}/${cyc}/${COMPONENT}} ;
  synvitdir=${COMINgfs:?}/${cyc}/${COMPONENT}
  synvitold_dir=${synvitdir%.*}.${old_4ymd}/${old_hh}/${COMPONENT}
  synvitfuture_dir=${synvitdir%.*}.${future_4ymd}/${future_hh}/${COMPONENT}
#
#---  06/11/2020  -------#
This version is copied from HERA: /scratch2/NCEPDEV/ensemble/Jiayi.Peng/noscrub/ens_tracker.v1.1.15.2
It is tested for JET.

#---  06/08/2020  -------
The same as: https://github.com/NOAA-EMC/TC_tracker/tree/TC_tracker.v1.1.15.2

#---  06/05/2020  -------
/gpfs/hps3/emc/ensemble/save/Jiayi.Peng/ens_tracker.v1.1.15.4 (Venus/Surge)
This version is created by adding FSU TC genesis calculation package.
How to compile/run  FSU TC genesis: (see ./tclogg/README_4_tclogg)

The development includes:
$$$$$$$$$$$$$$$$$$$$$$$$$
#---  02/28/2020   updated for python/3.6.3  -------
(1) /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.3/tclogg/bin
tclogg_track  .... updated  (python2 changed as python)

(2) /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.3/tclogg
make_modulefile_4_dell.py  .... updated for python/3.6.3 on DELL  by adding:
prepend-path PYTHONPATH /usrx/local/prod/packages/python/3.6.3/lib/python3.6
make -f Makefile_4_dell   ....to create a module file

make_modulefile_4_cray.py .... updated for python/3.6.3 on CRAY  by adding:
prepend-path PYTHONPATH /usrx/local/prod/python/3.6.3/lib/python3.6
make -f Makefile_4_cray   ....to create a module file

(3)/gpfs/hps3/emc/ensemble/save/Jiayi.Peng/ens_tracker.v1.1.15.3/control/cray
jfsu_tc_genesis_00.ecf_cray .... added for Cray

#---  12/17/2019  -------
Mars: /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.3
(1)change the file: /tclogg/genesis_guidance/model_config.cfg
commnet out the line:
#fname_template = /gpfs/dell1/nco/ops/com/gfs/prod/gfs.{date:%Y%m%d}/{date:%H}/gfs.t{date:%H}z.pgrb2.0p25.f{fhr:03}

(2)./ush/extrkr_fsu.sh   define the "fname_template"
tclogg_track --date ${ymdh} --odir $TRKDATA --fname_template=${file_name}

#---  12/10/2019  -------
The FSU TC genesis package is added here (based on ens_tracker.v1.1.15.1):

Mars: /gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.2/tclogg
(1)cd ./tclogg
make -f Makefile   ....to create a module file
chmod +x ./bin/tclogg_track

(2)./control/dell/jfsu_tc_genesis_00.ecf_dell is added
Inside: module use ${NWROOT}/ens_tracker.${ens_tracker_ver}/tclogg/modulefiles
        module load tclogg

(3)./jobs/JFSU_TC_GENESIS_JP is added.

(4)./ush/
data_check_gfs_180hr.sh   ....added
extrkr_fsu.sh    ....added

$$$$$$$$$$$$$$$$$$$$$$$$$
#---  06/03/2020  -------
This version is created for GFS-V16 TC-track/genesis parallel/retrospective runs.
It could be run on Dell/Cray/Hera/Orion  machine, including netcdf_parallel on Dell/Hera/Orion.
extrkr_tcv_gfs.sh .... updated with ${COMINgfs)/$(cyc)
extrkr_gen_gfs.sh .... updated with ${COMINgfs)/$(cyc)
#
#---  10/16/2019  -------
This version is created for GFS-V16 TC-track/genesis parallel/retrospective runs.
It could be run on Dell/Cray/Hera machine.

#---  10/07/2019  -------
This version is modified for HERA machine.
export ROOT=/scratch2/NCEPDEV/ensemble/Jiayi.Peng/noscrub/ens_tracker.v1.1.15.1

(1) THE CODE:
1. gettrk_main_gfs.f ....updated in ${ROOT}/sorc/gettrk_gfs.fd
LINE 17781:
 c J.Peng---07/26/2019 to free the memory in reading GRIB2 data
           call gf_free (gfld) 
LINE 18053:
c J.Peng---10/07/2019 to free the memory in reading GRIB2 data
              call gf_free (gfld)
LINE 20718:
c J.Peng---10/07/2019 to free the memory in reading GRIB2 data
              call gf_free (gfld)

2. gettrk_gen_main_gfs.f .... added in ${ROOT}/sorc/gettrk_gen_gfs.fd
   the new code for GFS TC genesis.

LINE 18454:
 c J.Peng---07/29/2019 to free the memory in reading GRIB2 data
           call gf_free (gfld)
LINE 18725:
c J.Peng---10/07/2019 to free the memory in reading GRIB2 data
              call gf_free (gfld)
LINE 21392:
c J.Peng---10/07/2019 to free the memory in reading GRIB2 data
              call gf_free (gfld)


(2)The COMPILE: ${ROOT}/sorc/
Module_ens_tracker.v1.1.15_for_Hera .... added

#---07262019-------
This version is copied from Luna/Surge:
/gpfs/hps/nco/ops/nwprod/ens_tracker.v1.1.15

It is modified for GFS-V16.0 parallel runs. The update includes (on MARS):
export ROOT=/gpfs/dell2/emc/modeling/noscrub/Jiayi.Peng/ens_tracker.v1.1.15.1

(1) THE CODE:

1. gettrk_main_gfs.f ....updated in ${ROOT}/sorc/gettrk_gfs.fd
 c J.Peng---07/26/2019 to free the memory in reading GRIB2 data
           call gf_free (gfld)
2. leadtime.f .... added in ${ROOT}/sorc/leadtime.fd
   creating forecast leading hours with maxhrs/dthrs
3. gettrk_gen_main_gfs.f .... added in ${ROOT}/sorc/gettrk_gen_gfs.fd
   the new code for GFS TC genesis.


(2)The COMPILE: ${ROOT}/sorc/
Removing: Module_ens_tracker_v1.1 and Module_ens_tracker.v1.1.8_Cray-intel-haswell
Adding: Module_ens_tracker.v1.1.15_for_Cray/Dell/Jet/Theia/Wcoss
        makefile_cray  makefile_dell  makefile_jet  makefile_wcoss in *.fd
Updating: README.build and build.sh

(3) The job-control: ${ROOT}/control/dell
jfv3_cyclone_track_00.ecf_dell .... updated
jfv3_cyclone_genesis_00.ecf_dell .... updated
jfv3gdas_cyclone_track_00.ecf_dell .... updated

(4) The jobs: ${ROOT}/jobs
JFV3_CYCLONE_TRACK_JP .... updated
JFV3_CYCLONE_GENESIS_JP .... updated
JFV3GDAS_CYCLONE_TRACK_JP .... updated

(5) The ush:
data_check_gfs.sh .... added
data_check_gdas.sh .... added
extrkr_gfs.sh .... updated
extrkr_tcv_gfs.sh .... added
extrkr_gen_gfs.sh .... added


(6) The scripts:
exgfs_tc_genesis.sh .... updated

# fit2obs
Software necessary to ...

To install:

Clone repository:
```bash
git clone https://github.com/noaa-emc/fit2obs
```

Move into desired branch and then run:

```bash
INSTALL_PREFIX=/path/you/wish/to/install/fit2obs ./ush/build.sh
```

or install in local clone space:

```bash
./ush/build.sh
```

There is also the option to build and install in your local clone space but install the modulefile elsewhere:
```bash
MODULEFILE_INSTALL_PREFIX=/path/you/wish/to/install/fit2obs/module ./ush/build.sh
```
Installation is complete.

# prepobs 
Software necessary to process bufr dump files to generate prepbufr files.

To install:

Clone repository:
```bash
git clone https://github.com/noaa-emc/prepobs
```

Move into desired branch and then run:

```bash
INSTALL_PREFIX=/path/you/wish/to/install/prepobs ./ush/build.sh
```

build.sh default to building for WCOSS2, but it also supports NOAA R&Ds by setting `INSTALL_TARGET=hera/orion/hercules/gaeac6/ursa/wcoss2`

or install in local clone space:

```bash
./ush/build.sh
```

There is also the option to build and install in your local clone space but install the modulefile elsewhere:
```bash
MODULEFILE_INSTALL_PREFIX=/path/you/wish/to/install/prepobs/module ./ush/build.sh
```
Installation is complete.

# obsproc
Installation instructions for obsproc code adhere to NCO's working practices, so are slightly modified from industry practices. obsproc code will be built and installed in the same space as the local clone.

Clone the obsproc repository:
```bash
git clone https://github.com/noaa-emc/obsproc
```

Then
```bash
ls
cd obsproc
branch -a
git checkout feature/branchname
ls
```

You may do the following instructions from develop or any feature branch.

You will see a `build.sh` script in the ush/ directory. You will run this to build and install the obsproc code in your local clone space:
```bash
cd ush
./build.sh
```

You will have a new `exec/` directory in your clone space.

Installation is complete.

## Dependencies
To run the obsproc suite there are two required modules: <br />
- bufr_dump<br />
- prepobs<br />

You may either load NCO's installations. Or you may make local installations by cloning and building their respective github repositories.<br />
- https://github.com/noaa-emc/bufr-dump<br />
- https://github.com/noaa-emc/prepobs

## For reference purposes only!!
This is a unified listing of sample trigger scripts that work in a user/development environment.<br />
Usage instructions are contained within each trigger, near the top, just below the PBS job cards.

## OBSPROC CDAS trigger script files
- jcdas_dump.wc2.pbs
- jcdas_dump_post.wc2.pbs
- jcdas_prep1.wc2.pbs
- jcdas_prep2.wc2.pbs
- jcdas_prep1_post.wc2.pbs
- jcdas_prep2_post.wc2.pbs

## OBSPROC GLOBAL trigger script files
- jglobal_dump.wc2.pbs
- jglobal_dump_post.wc2.pbs
- jglobal_prep.wc2.pbs
- jglobal_prep_post.wc2.pbs

## OBSPROC NAM trigger script files
- jnam_dump.wc2.pbs
- jnam_dump2.wc2.pbs
- jnam_dump_post.wc2.pbs
- jnam_prep.wc2.pbs
- jnam_prep_post.wc2.pbs

## OBSPROC RAP trigger script files
- jrap_dump.wc2.pbs
- jrap_dump_post.wc2.pbs
- jrap_prep.wc2.pbs
- jrap_prep_post.wc2.pbs

## OBSPROC RTMA trigger script files
- jrtma_dump.wc2.pbs
- jrtma_dump_post.wc2.pbs
- jrtma_prep.wc2.pbs
- jrtma_prep_post.wc2.pbs

## OBSPROC URMA trigger script files
- jurma_dump.wc2.pbs
- jurma_dump_post.wc2.pbs
- jurma_prep.wc2.pbs
- jurma_prep_post.wc2.pbs

## MODS trigger script file
- jmods.wc2.pbs

## DUMP_MONITOR trigger script file
- jdump_monitor.wc2.pbs

## DUMP_ALERT trigger script file
- jdump_alert.wc2.pbs

## AIRNOW trigger script file
- jairnow_dump.wc2.pbs

# TCLOGG Tracker

This contains a pared down wcoss python 2.7 version of the NHC TCLOGG tracker.

The tracker ingests GFS grib files, follows MSLET minima and outputs text files
containing track locations and pertinent storm relative variables.

This version has been developed to work around significant operational limitations and
extra files in this directory are to simulate external dependencies which can not be utilized
in the operational system.

tclogg source files are within the genesis_guidance directory.


## Installation

Installation is a simple 1 step process, just run `make`.
`make` will just create a modulefile to make sure the other modules are loaded in the right order and that `PATH` and `PYTHONPATH` are set up.  
This is generated for the current working directory so it the code moves, the file will need to be remade.  Code in make_modulefile.py. 


## Running the tracker

    module use ./modulefiles
    module load tclogg 
    tclogg_track --date 2019111312  


## Setup

`genesis_guidance/model_config.cfg` specfies input data parameters.  
Default is to run on realtime gfs output on wcoss.  
`fname_template` is a python date time string format,  
`date` = the init time of the forecast   
`fhr` = forecast hour of the file  
 

## Scripting

This tracker can also be called from a python script

    from genesis_guidance import tracker

    tracker.tctracker('gfs', rundate, './', ['natl','epac'])

#------  07/23/2020 ---------------------------------------
The FSU genesis package could be run on CRAY/DELL, it needs pygrib.
(1)cd ./ush/FSUgenesisPY  .... for compile
make -f Makefile_4_cray   ....to create a module file
chmod +x ./bin/tclogg_track

module unload anaconda2/latest .... for dell
make -f Makefile_4_dell   ....to create a module file

(2)./control/dell/jfsu_tc_genesis_00.ecf_dell 
./control/cray/jfsu_tc_genesis_00.ecf_cray

Inside: module use ${NWROOT}/ens_tracker.${ens_tracker_ver}/ush/FSUgenesisPY/modulefiles
        module load tclogg
bsub < jfsu_tc_genesis_00.ecf_dell
.OR.  bsub < jfsu_tc_genesis_00.ecf_cray

      program ushear
c
c     ABSTRACT: This program calculates the U-shear from an input
c     grib file and produces an output grib file containing the
c     U-shear between the 200mb and 850mb layer.
c
c     fort.11----input grib file
c     fort.31----input gribindex file
c     fort.51----output U-shear grib file at 501hPa
c     Written by J.Peng--09-26-2014

      USE params
      USE grib_mod

      implicit none

      type(gribfield) :: holdgfld
      integer, parameter :: lugb=11,lulv=16,lugi=31,lout=51
      integer, parameter :: nlevsout=1,nlevsin=2
      integer  kpds(200),kgds(200)
      integer  iriret,iogret,kf,iggret,igdret,iidret,gribver,g2_jpdtn
cJ.Peng---------------------------------------------
      integer  g2_model

      integer  iha,iho,iva,irfa,iodret,ifcsthour,iia,iparm
      integer  ilevs(nlevsin)
      real, allocatable :: xinptmp(:,:),xouttmp(:)
      logical(1), allocatable :: valid_pt(:),readflag(:)
      real     xoutlev
cJ.Peng-----------------------------------
      namelist/timein/ifcsthour,iparm,gribver,g2_jpdtn,g2_model
c
      data ilevs   /200, 850/
      xoutlev = 501.
c
      read (5,NML=timein,END=201)
  201 continue
      print *,' '
      print *,'*---------------------------------------------*'
      print *,' '
      print *,' +++ Top of ushear +++ '
      print *,' '
      print *,'After ushe namelist read, input forecast hour= '
     &       ,ifcsthour
      print *,'                          input GRIB parm= ',iparm
      print *,'                          GRIB version= ',gribver
      print *,'                         GRIB2 g2_jpdtn= ',g2_jpdtn
      print *,'                         g2_model= ',g2_model

c      ilevs = -999
c      call read_input_levels (lulv,nlevsin,ilevs,iriret)
c
c      if (iriret /= 0) then
c        print *,' '
c        print *,'!!! RETURN CODE FROM read_input_levels /= 0'
c        print *,'!!! RETURN CODE = iriret = ',iriret
c        print *,'!!! EXITING....'
c        print *,' '
c        goto 899
c      endif

      call open_grib_files (lugb,lugi,lout,gribver,iogret)
      if (iogret /= 0) then
      print '(/,a35,a5,i4,/)','!!! ERROR: in ushear open_grib_files,'
     &        ,' rc= ',iogret
        STOP 93
      endif
      call getgridinfo (lugb,lugi,kf,kpds,kgds,holdgfld,ifcsthour,iparm
     &                 ,gribver,g2_jpdtn,iggret)

      allocate (xinptmp(kf,nlevsin),stat=iha)
      allocate (xouttmp(kf),stat=iho)
      allocate (valid_pt(kf),stat=iva)
      allocate (readflag(nlevsin),stat=irfa)
      if (iha /= 0 .or. iho /= 0 .or. iva /= 0 .or. irfa /= 0) then
        print *,' '
        print *,'!!! ERROR in ushe allocating arrays.'
        print *,'!!! ERROR allocating the xinptmp, readflag, or the'
        print *,'!!! valid_pt array, iha= ',iha,' iva= ',iva
        print *,'!!! irfa= ',irfa,' iho= ',iho
        print *,'  '
        STOP 96
      endif
cJ.Peng-------------------------
      call getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs
     &             ,readflag,xinptmp,ifcsthour,iparm,gribver
     &             ,g2_jpdtn,g2_model,igdret)

      call ushear_data (kf,valid_pt,nlevsin,ilevs,readflag
     &                  ,xinptmp,xouttmp,iidret)
cJ.Peng-------------------------
      call output_data (lout,kf,kpds,kgds,holdgfld,xouttmp,valid_pt
     &     ,xoutlev,nlevsout,gribver,ifcsthour,g2_model,iodret)

      deallocate (xinptmp)
      deallocate (xouttmp)
      deallocate (valid_pt)
      deallocate (readflag)

  899 continue
c 
      stop
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_input_levels (lulv,nlevsin,ilevs,iriret)
c 
c     ABSTRACT: This subroutine reads in a text file that contains
c     the number of input pressure levels for a given model.  The
c     format of the file goes like this, from upper levels to 
c     lower, for example:
c
c        1       200
c        2       400
c        3       500
c        4       700
c        5       850
c        6       925
c        7      1000
c
c
      implicit none

      integer    lulv,nlevsin,iriret,inplev,ict,lvix
      integer    ilevs(nlevsin)
c
      iriret=0
      ict = 0
      do while (.true.)
        
        print *,'Top of while loop in ushe read_input_levels'

        read (lulv,85,end=130) lvix,inplev

        if (inplev > 0 .and. inplev <= 1000) then
          ict = ict + 1
          ilevs(ict) = inplev
        else
          print *,' '
          print *,'!!! ERROR: Input level not between 0 and 1000'
          print *,'!!!        in ushe.  inplev= ',inplev
          print *,'!!! STOPPING EXECUTION'
          STOP 91
        endif

        print *,'ushe readloop, ict= ',ict,' inplev= ',inplev

      enddo

   85 format (i4,1x,i4)
  130 continue

      nlevsin = ict

      print *,' '
      print *,'Total number of ushe levels read in = ',nlevsin
c 
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getgridinfo (lugb,lugi,kf,kpds,kgds,holdgfld,ifcsthour
     &                       ,iparm,gribver,g2_jpdtn,iggret)
c
c     ABSTRACT: The purpose of this subroutine is just to get the max
c     values of i and j and the dx and dy grid spacing intervals for the
c     grid to be used in the rest of the program.  So just read the
c     grib file to get the lon and lat data.  Also, get the info for
c     the data grids boundaries.  This boundary information will be
c     used later in the tracking algorithm, and is accessed via Module
c     grid_bounds.
c
C     INPUT:
C     lugb     The Fortran unit number for the GRIB data file
C     lugi     The Fortran unit number for the GRIB index file
c     ifcsthour input forecast hour to search for
c     iparm    input grib parm to search for
c     gribver  integer (1 or 2) to indicate if using GRIB1 / GRIB2
c     g2_jpdtn If GRIB2 data being read, this is the value for JPDTN
c              that is input to getgb2.
C
C     OUTPUT:
c     kf       Number of gridpoints on the grid
c     kpds     pds array for a GRIB1 record
c     kgds     gds array for a GRIB1 record
c     holdgfld info for a GRIB2 record
c     
C     iggret   The return code from this subroutine
c
      USE params
      USE grib_mod

      implicit none
c
      CHARACTER(len=8) :: ctemp
      CHARACTER(len=80) :: ftemplate
      type(gribfield) :: gfld,prevfld,holdgfld
      integer,dimension(200) :: jids,jpdt,jgdt
      logical(1), allocatable :: lb(:)
      integer, parameter :: jf=4000000
      integer   jpds(200),jgds(200)
      integer   kpds(200),kgds(200)
      integer :: listsec1(13)
      integer   ila,ifa,iret,ifcsthour,imax,jmax,jskp,jdisc
      integer   lugb,lugi,kf,j,k,iggret,iparm,gribver,g2_jpdtn
      integer   jpdtn,jgdtn,npoints,icount,ipack,krec
      integer :: listsec0(2)=(/0,2/)
      integer :: igds(5)=(/0,0,0,0,0/),previgds(5)
      integer :: idrstmpl(200)
      integer :: currlen=1000000
      logical :: unpack=.true.
      logical :: open_grb=.false.
      real, allocatable :: f(:)
      real      dx,dy
c
      iggret = 0

      allocate (lb(jf),stat=ila) 
      allocate (f(jf),stat=ifa)
      if (ila /= 0 .or. ifa /= 0) then
        print *,' '
        print *,'!!! ERROR in ushe.'
        print *,'!!! ERROR in getgridinfo allocating either lb or f'
        print *,'!!! ila = ',ila,' ifa= ',ifa
        iggret = 97
        return
      endif

      if (gribver == 2) then

        ! Search for a record from a GRIB2 file

        !
        ! ---  Initialize Variables ---
        !

        gfld%idsect => NULL()
        gfld%local => NULL()
        gfld%list_opt => NULL()
        gfld%igdtmpl => NULL()
        gfld%ipdtmpl => NULL()
        gfld%coord_list => NULL()
        gfld%idrtmpl => NULL()
        gfld%bmap => NULL()
        gfld%fld => NULL()

        jdisc=0  ! Meteorological products
        jids=-9999
        jpdtn=g2_jpdtn  ! 0 = analysis or forecast; 1 = ens fcst
        jgdtn=0  ! lat/lon grid
        jgdt=-9999
        jpdt=-9999

        npoints=0
        icount=0
        jskp=0

c       Search for Temperature by production template 4.0

        JPDT(1:15)=(/ -9999,-9999,-9999,-9999,-9999,-9999,-9999,-9999
     &             ,-9999,-9999,-9999,-9999,-9999,-9999,-9999/)

        call getgb2(lugb,lugi,jskp,jdisc,jids,jpdtn,jpdt,jgdtn,jgdt
     &             ,unpack,krec,gfld,iret)
        if ( iret.ne.0) then
          print *,' '
          print *,' ERROR: getgb2 error in getgridinfo = ',iret
        endif

c       Determine packing information from GRIB2 file
c       The default packing is 40  JPEG 2000

        ipack = 40

        print *,' gfld%idrtnum = ', gfld%idrtnum

        !   Set DRT info  ( packing info )
        if ( gfld%idrtnum.eq.0 ) then      ! Simple packing
          ipack = 0
        elseif ( gfld%idrtnum.eq.2 ) then  ! Complex packing
          ipack = 2
        elseif ( gfld%idrtnum.eq.3 ) then  ! Complex & spatial packing
          ipack = 31
        elseif ( gfld%idrtnum.eq.40.or.gfld%idrtnum.eq.15 ) then  
          ! JPEG 2000 packing
          ipack = 40
        elseif ( gfld%idrtnum.eq.41 ) then  ! PNG packing
          ipack = 41
        endif

        print *,'After check of idrtnum, ipack= ',ipack

        print *,'Number of gridpts= gfld%ngrdpts= ',gfld%ngrdpts
        print *,'Number of elements= gfld%igdtlen= ',gfld%igdtlen
        print *,'PDT num= gfld%ipdtnum= ',gfld%ipdtnum
        print *,'GDT num= gfld%igdtnum= ',gfld%igdtnum

        imax = gfld%igdtmpl(8)
        jmax = gfld%igdtmpl(9)
        dx   = float(gfld%igdtmpl(17))/1.e6
        dy   = float(gfld%igdtmpl(17))/1.e6
        kf   = gfld%ngrdpts

        holdgfld = gfld
    
      else

        ! Search for a record from a GRIB1 file

        jpds = -1
        jgds = -1

        j=0

        jpds(5)  = iparm  ! Get a temperature record
        jpds(6)  = 100    ! Get a record on a standard pressure level
        jpds(14) = ifcsthour
         
        call getgb(lugb,lugi,jf,j,jpds,jgds,
     &                       kf,k,kpds,kgds,lb,f,iret)

        if (iret.ne.0) then
          print *,' '
          print *,'!!! ERROR in ushe  getgridinfo calling getgb'
          print *,'!!! Return code from getgb = iret = ',iret
          iggret = iret
          return
        else
          iggret=0
          imax = kgds(2)
          jmax = kgds(3)
          dx   = float(kgds(9))/1000.
          dy   = float(kgds(10))/1000.
        endif

      endif

      print *,' '
      print *,'In getgridinfo, grid dimensions follow:'
      print *,'imax= ',imax,' jmax= ',jmax
      print *,'  dx= ',dx,'  dy= ',dy
      print *,'number of gridpoints = ',kf
      
      deallocate (lb); deallocate(f)
      
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs
     &             ,readflag,xinptmp,ifcsthour,iparm,gribver
     &             ,g2_jpdtn,g2_model,igdret)
c
c     ABSTRACT: This subroutine reads the input GRIB file for the
c     tracked parameters.

      USE params
      USE grib_mod

      implicit none
c
      type(gribfield) :: gfld,prevfld
      CHARACTER(len=8) :: ctemp,pabbrev
      CHARACTER(len=80) :: ftemplate
      integer,dimension(200) :: jids,jpdt,jgdt
      integer, parameter :: jf=4000000
      integer   ilevs(nlevsin)
      integer   jpds(200),jgds(200),kpds(200),kgds(200)
      integer   lugb,lugi,kf,nlevsin,igdret,iparm,jskp,jdisc
      integer   jpdtn,jgdtn,npoints,icount,ipack,krec
      integer   i,j,k,ict,np,lev,ifcsthour,iret,gribver,g2_jpdtn
cJ.Peng ----------------------------
      integer   g2_model

      integer   pdt_4p0_vert_level,pdt_4p0_vtime,mm
      integer :: listsec0(2)=(/0,2/)
      integer :: listsec1(13)
      integer :: igds(5)=(/0,0,0,0,0/),previgds(5)
      integer :: idrstmpl(200)
      integer :: currlen=1000000
      logical :: unpack=.true.
      logical :: open_grb=.false.
      logical(1)  valid_pt(kf),lb(kf),readflag(nlevsin)
      real      f(kf),xinptmp(kf,nlevsin),xtemp(kf)
      real      dmin,dmax,firstval,lastval
c
      igdret=0
      ict = 0

      print *,'At top of getdata, ifcsthour= ',ifcsthour

      level_loop: do lev = 1,nlevsin

        print *,' '
        print *,'------------------------------------------------'
        print *,'In ushe  getdata read loop, lev= ',lev,' level= '
     &         ,ilevs(lev)

        if (gribver == 2) then

          !
          ! ---  Initialize Variables ---
          !

          gfld%idsect => NULL()
          gfld%local => NULL()
          gfld%list_opt => NULL()
          gfld%igdtmpl => NULL()
          gfld%ipdtmpl => NULL()
          gfld%coord_list => NULL()
          gfld%idrtmpl => NULL()
          gfld%bmap => NULL()
          gfld%fld => NULL()

          jdisc=0  ! Meteorological products
          jids=-9999
          jpdtn=g2_jpdtn ! 0 = analysis or forecast; 1 = ens fcst
          jgdtn=0  ! lat/lon grid
          jgdt=-9999
          jpdt=-9999

          npoints=0
          icount=0
          jskp=0

c         Search for input parameter by production template 4.0.  This
c         ushe program is used primarily for temperature, but still we
c         will leave that as a variable and not-hard wire it in case we
c         choose to average something else in the future.

          if (iparm == 33) then

            ! Set defaults for JPDT, then override in array 
            ! assignments below...

            JPDT(1:15)=(/ -9999,-9999,-9999,-9999,-9999,-9999,-9999
     &             ,-9999,-9999,-9999,-9999,-9999,-9999,-9999,-9999/)
            JPDT(1)  = 2   ! Param category from Table 4.1
            JPDT(2)  = 2   ! Param number from Table 4.2
            JPDT(9)  = ifcsthour

cJ.Peng-------------------------------------------------
            print *, "g2_model=", g2_model
            if(g2_model == 1 .or. g2_model == 10 
     &         .or. g2_model == 7 .or. g2_model == 22) then
              JPDT(10) = 100 ! Isobaric surface requested (Table 4.5)
              JPDT(11) =  0
              JPDT(12) = ilevs(lev) * 100 ! value of specific level
            elseif (g2_model == 16 .or. g2_model == 15) then
              JPDT(10) = 100
              if (ilevs(lev) == 200 )then
                JPDT(11) =  -4
                JPDT(12) = ilevs(lev)/100
              elseif(ilevs(lev) == 850 ) then
                JPDT(11) =  -3
                JPDT(12) = ilevs(lev)/10
             endif
             endif

            print *,'In getdata, just set JPDT inputs....'

          endif

          print *,'before getgb2 call, value of unpack = ',unpack
 
          do mm = 1,15
            print *,'ushe getdata mm= ',mm,' JPDT(mm)= ',JPDT(mm)
          enddo

          call getgb2(lugb,lugi,jskp,jdisc,jids,jpdtn,jpdt,jgdtn,jgdt
     &             ,unpack,krec,gfld,iret)

          print *,'iret from getgb2 in getdata = ',iret

          print *,'after getgb2 call, value of unpacked = '
     &           ,gfld%unpacked

          print *,'after getgb2 call, gfld%ndpts = ',gfld%ndpts
          print *,'after getgb2 call, gfld%ibmap = ',gfld%ibmap

          if ( iret == 0) then

c           Determine packing information from GRIB2 file
c           The default packing is 40  JPEG 2000

            ipack = 40

            print *,' gfld%idrtnum = ', gfld%idrtnum

            !   Set DRT info  ( packing info )
            if ( gfld%idrtnum.eq.0 ) then      ! Simple packing
              ipack = 0
            elseif ( gfld%idrtnum.eq.2 ) then  ! Complex packing
              ipack = 2
            elseif ( gfld%idrtnum.eq.3 ) then  ! Complex & spatial 
     &                                         ! packing
              ipack = 31
            elseif ( gfld%idrtnum.eq.40.or.gfld%idrtnum.eq.15 ) then
              ! JPEG 2000 packing
              ipack = 40
            elseif ( gfld%idrtnum.eq.41 ) then  ! PNG packing
              ipack = 41
            endif

            print *,'After check of idrtnum, ipack= ',ipack

            print *,'Number of gridpts= gfld%ngrdpts= ',gfld%ngrdpts
            print *,'Number of elements= gfld%igdtlen= ',gfld%igdtlen
            print *,'GDT num= gfld%igdtnum= ',gfld%igdtnum

            kf = gfld%ndpts  ! Number of gridpoints returned from read

            do np = 1,kf
              xinptmp(np,lev)  = gfld%fld(np)
              xtemp(np)        = gfld%fld(np)
              if (gfld%ibmap == 0) then
                valid_pt(np)     = gfld%bmap(np)
              else
                valid_pt(np)     = .true.
              endif
            enddo

            readflag(lev) = .TRUE.
c            call bitmapchk(kf,gfld%bmap,gfld%fld,dmin,dmax)
            call bitmapchk(kf,valid_pt,xtemp,dmin,dmax)

            if (ict == 0) then
c              do np = 1,kf
c                valid_pt(np) = gfld%bmap(np)
c              enddo
              ict = ict + 1
            endif

            firstval=gfld%fld(1)
            lastval=gfld%fld(kf)

            print *,' '
            print *,' SECTION 0: discipl= ',gfld%discipline
     &             ,' gribver= ',gfld%version

            print *,' '
            print *,' SECTION 1: '

            do j = 1,gfld%idsectlen
              print *,'     sect1, j= ',j,' gfld%idsect(j)= '
     &               ,gfld%idsect(j)
            enddo

            if ( associated(gfld%local).AND.gfld%locallen.gt.0) then
              print *,' '
              print *,' SECTION 2: ',gfld%locallen,' bytes'
            else 
              print *,' '
              print *,' SECTION 2 DOES NOT EXIST IN THIS RECORD'
            endif

            print *,' '
            print *,' SECTION 3: griddef= ',gfld%griddef
            print *,'            ngrdpts= ',gfld%ngrdpts
            print *,'            numoct_opt= ',gfld%numoct_opt
            print *,'            interp_opt= ',gfld%interp_opt
            print *,'            igdtnum= ',gfld%igdtnum
            print *,'            igdtlen= ',gfld%igdtlen

            print *,' '
            print '(a17,i3,a2)',' GRID TEMPLATE 3.',gfld%igdtnum,': '
            do j=1,gfld%igdtlen
              print *,'    j= ',j,' gfld%igdtmpl(j)= ',gfld%igdtmpl(j)
            enddo

            print *,' '
            print *,'     PDT num (gfld%ipdtnum) = ',gfld%ipdtnum
            print *,' '
            print '(a20,i3,a2)',' PRODUCT TEMPLATE 4.',gfld%ipdtnum,': '
            do j=1,gfld%ipdtlen
              print *,'    sect 4  j= ',j,' gfld%ipdtmpl(j)= '
     &               ,gfld%ipdtmpl(j)
            enddo 

c           Print out values for data representation type

            print *,' '
            print '(a21,i3,a2)',' DATA REP TEMPLATE 5.',gfld%idrtnum
     &            ,': '
            do j=1,gfld%idrtlen
              print *,'    sect 5  j= ',j,' gfld%idrtmpl(j)= '
     &               ,gfld%idrtmpl(j)
            enddo

            pdt_4p0_vtime      = gfld%ipdtmpl(9)

cJ.Peng---------------------------------------------------            
            pdt_4p0_vert_level = gfld%ipdtmpl(12)

c           Get parameter abbrev for record that was retrieved

            pabbrev=param_get_abbrev(gfld%discipline,gfld%ipdtmpl(1)
     &                              ,gfld%ipdtmpl(2))

            print *,' '
            write (6,131)
 131        format (' rec#   param     level  byy  bmm  bdd  bhh  '
     &             ,'fhr      npts  firstval    lastval     minval   '
     &             ,'   maxval')
            print '(i5,3x,a8,2x,6i5,2x,i8,4g12.4)'
     &          ,krec,pabbrev,pdt_4p0_vert_level,gfld%idsect(6)
     &             ,gfld%idsect(7),gfld%idsect(8),gfld%idsect(9)
     &             ,pdt_4p0_vtime,gfld%ndpts,firstval,lastval,dmin,dmax
c &          ,krec,pabbrev,pdt_4p0_vert_level/100,gfld%idsect(6)

c            do np = 1,kf
c              xinptmp(np,lev) = gfld%fld(np)
c            enddo

          else

            print *,' '
            print *,'!!! ERROR: GRIB2 TAVE READ IN GETDATA FAILED FOR '
     &             ,'LEVEL LEV= ',LEV
            print *,' '

            readflag(lev) = .FALSE.

            do np = 1,kf
              xinptmp(np,lev) = -99999.0
            enddo

          endif

        else

          ! Reading a GRIB1 file....

          jpds = -1
          jgds = -1
          j=0

          jpds(5) = iparm       ! parameter id for temperature
          jpds(6) = 100         ! level id to indicate a pressure level
          jpds(7) = ilevs(lev)  ! actual level of the layer
          jpds(14) = ifcsthour  ! lead time to search for

          call getgb (lugb,lugi,jf,j,jpds,jgds,
     &                          kf,k,kpds,kgds,lb,f,iret)

          print *,' '
          print *,'After ushe getgb call, j= ',j,' k= ',k,' level= '
     &           ,ilevs(lev),' iret= ',iret

          if (iret == 0) then

            readflag(lev) = .TRUE.
            call bitmapchk(kf,lb,f,dmin,dmax)

            if (ict == 0) then
              do np = 1,kf
                valid_pt(np) = lb(np)
              enddo
              ict = ict + 1
            endif

            write (6,31)
  31        format (' rec#  parm# levt lev  byy   bmm  bdd  bhh  fhr  '
     &             ,'npts  minval       maxval')
            print '(i4,2x,8i5,i8,2g12.4)',
     &           k,(kpds(i),i=5,11),kpds(14),kf,dmin,dmax

            do np = 1,kf
              xinptmp(np,lev) = f(np) 
            enddo

          else
  
            print *,' '
            print *,'!!! ERROR: TAVE READ FAILED FOR LEVEL LEV= ',LEV
            print *,' '

            readflag(lev) = .FALSE.

            do np = 1,kf
              xinptmp(np,lev) = -99999.0
            enddo

          endif

        endif

      enddo level_loop
c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine ushear_data (kf,valid_pt,nlevsin,ilevs,readflag
     &                 ,xinptmp,xouttmp,iidret)
c
c     ABSTRACT: This routine averages data between 300 and 500 mb to get
c     a mean temperature at 400 mb.  The input data should be at 50 mb 
c     resolution, giving 5 input levels in total.

      implicit none

      logical(1)   valid_pt(kf),readflag(nlevsin)
      integer      ilevs(nlevsin)
      integer      nlevsin,kf,k,n,iidret
      real         xinptmp(kf,nlevsin),xouttmp(kf)
      real         xinlevs_p(nlevsin),xinlevs_lnp(nlevsin)
      real         xsum
c
      iidret=0
      print *,'*----------------------------------------------*'
      print *,'         Top of average data routine'
      print *,'*----------------------------------------------*'
      print *,' '

c      do n = 1,kf
c        xsum = 0.0
c        print *,' '
c        do k = 1,nlevsin
c          xsum = xsum + xinptmp(n,k)
c          print *,'n= ',n,' k= ',k,' xsum= ',xsum
c        enddo
c        xouttmp(n) = xsum / float(nlevsin)
c        print *,'n= ',n,' mean= ',xouttmp(n)
c      enddo

      do n = 1,kf
        xouttmp(n) = xinptmp(n,1) - xinptmp(n,2)
      enddo

c
      return
      end
c
c----------------------------------------------------------------------
c
c-----J.Peng----------------------------------------------------
      subroutine output_data (lout,kf,kpds,kgds,holdgfld,xouttmp
     &  ,valid_pt,xoutlev,nlevsout,gribver,ifcsthour,g2_model,iodret)
c
c     ABSTRACT: This routine writes out the  output data on the 
c     specified output pressure levels.

      USE params
      USE grib_mod

      implicit none

      CHARACTER(len=1),pointer,dimension(:) :: cgrib
c      CHARACTER(len=1),pointer,allocatable :: cgrib(:)
      type(gribfield) :: holdgfld
      logical(1) valid_pt(kf),bmap(kf)
      integer  lout,kf,lugb,lugi,iodret,nlevsout,igoret,ipret,lev
      integer  gribver,ierr,ipack,lengrib,npoints,newlen,idrsnum
      integer  numcoord,ica,n,j,ifcsthour
      integer :: idrstmpl(200)
      integer :: currlen=1000000
      integer :: listsec0(2)=(/0,2/)
      integer :: igds(5)=(/0,0,0,0,0/),previgds(5)
      integer  kpds(200),kgds(200)

cJ.Peng----------------------------
      integer  g2_model, ijk

      integer(4), parameter::idefnum=1
      integer(4) ideflist(idefnum),ibmap
      real     xouttmp(kf),xoutlev,coordlist
c
      iodret=0
c      call baopenw (lout,"fort.51",igoret)
c      print *,'baopenw: igoret= ',igoret
c
c      if (igoret /= 0) then
c        print *,' '
c        print *,'!!! ERROR in sub output_data opening'
c        print *,'!!! **OUTPUT** grib file.  baopenw return codes:'
c        print *,'!!! grib file 1 return code = igoret = ',igoret
c        STOP 95
c        return
c      endif

      if (gribver == 2) then

        ! Write data out as a GRIB2 message....

        allocate(cgrib(currlen),stat=ica)
        if (ica /= 0) then
          print *,' '
          print *,'ERROR in output_data allocating cgrib'
          print *,'ica=  ',ica
          iodret=95
          return
        endif
          

        !  Ensure that cgrib array is large enough
        
        if (holdgfld%ifldnum == 1 ) then     ! start new GRIB2 message
           npoints=holdgfld%ngrdpts
        else
           npoints=npoints+holdgfld%ngrdpts
        endif
        newlen=npoints*4
        if ( newlen.gt.currlen ) then
ccc          if (allocated(cgrib)) deallocate(cgrib)
          if (associated(cgrib)) deallocate(cgrib)
          allocate(cgrib(newlen),stat=ierr)
c          call realloc (cgrib,currlen,newlen,ierr)
          if (ierr == 0) then
            print *,' '
            print *,'re-allocate for large grib msg: '
            print *,'  currlen= ',currlen
            print *,'  newlen=  ',newlen
            currlen=newlen
          else
            print *,'ERROR returned from 2nd allocate cgrib = ',ierr
            stop 95
          endif
        endif

        !  Create new GRIB Message
        listsec0(1)=holdgfld%discipline
        listsec0(2)=holdgfld%version

        print *,'output, holdgfld%idsectlen= ',holdgfld%idsectlen
        do j = 1,holdgfld%idsectlen
          print *,'     sect1, j= ',j,' holdgfld%idsect(j)= '
     &           ,holdgfld%idsect(j)
        enddo

        call gribcreate(cgrib,currlen,listsec0,holdgfld%idsect,ierr)
        if (ierr.ne.0) then
           write(6,*) ' ERROR creating new GRIB2 field (gribcreate)= '
     &                ,ierr
           stop 95
        endif

        previgds=igds
        igds(1)=holdgfld%griddef
        igds(2)=holdgfld%ngrdpts
        igds(3)=holdgfld%numoct_opt
        igds(4)=holdgfld%interp_opt
        igds(5)=holdgfld%igdtnum

        if (igds(3) == 0) then
          ideflist = 0
        endif

        call addgrid (cgrib,currlen,igds,holdgfld%igdtmpl
     &               ,holdgfld%igdtlen,ideflist,idefnum,ierr)

        if (ierr.ne.0) then
          write(6,*) ' ERROR from addgrid adding GRIB2 grid = ',ierr
          stop 95
        endif

c        xoutlev = 501.
c        holdgfld%ipdtmpl(12) = int(xoutlev) * 100 
CJ.Peng---2014-10-03------------------------------
        holdgfld%ipdtmpl(1) = 2
        holdgfld%ipdtmpl(2) = 2
        holdgfld%ipdtmpl(9) = ifcsthour 

        ijk = int(xoutlev)
        if(g2_model == 1 .or. g2_model == 10 .or. g2_model == 16
     & .or. g2_model == 7 .or. g2_model == 22 .or. g2_model == 15) then
          holdgfld%ipdtmpl(10) = 100
          holdgfld%ipdtmpl(11) =  0
          holdgfld%ipdtmpl(12) = ijk * 100
        elseif(g2_model == 26) then
          holdgfld%ipdtmpl(10) = 100
          holdgfld%ipdtmpl(11) = -2
          holdgfld%ipdtmpl(12) = ijk
        endif

        ipack      = 40
        idrsnum    = ipack
        idrstmpl   = 0

        idrstmpl(2)= holdgfld%idrtmpl(2)
        idrstmpl(3)= holdgfld%idrtmpl(3)
        idrstmpl(6)= 0
        idrstmpl(7)= 255

        numcoord=0
        coordlist=0.0  ! Only needed for hybrid vertical coordinate,
                       ! not here, so set it to 0.0

       ! 0   - A bit map applies to this product and is specified in
       ! this section
       ! 255 - A bit map does not apply to this product
       ibmap=255     ! Bitmap indicator (see Code Table 6.0)

       print *,' '
       print *,'output, holdgfld%ipdtlen= ',holdgfld%ipdtlen
       do n = 1,holdgfld%ipdtlen
         print *,'output, n= ',n,' holdgfld%ipdtmpl= '
     &          ,holdgfld%ipdtmpl(n)
       enddo

       print *,'output, kf= ',kf

c       if (ifcsthour < 6) then
c         do n = 1,kf
cc           print *,'output, n= ',n,' xouttmp(n)= ',xouttmp(n)
c           write (92,151) n,xouttmp(n)
c  151      format (1x,'n= ',i6,'  xouttmp(n)= ',f10.4)
c         enddo
c       endif

       call addfield (cgrib,currlen,holdgfld%ipdtnum,holdgfld%ipdtmpl
     &               ,holdgfld%ipdtlen,coordlist
     &               ,numcoord
     &               ,idrsnum,idrstmpl,200
     &               ,xouttmp,kf,ibmap,bmap,ierr)

        if (ierr /= 0) then
          write(6,*) ' ERROR from addfield adding GRIB2 data = ',ierr
          stop 95
        endif

!       Finalize  GRIB message after all grids
!       and fields have been added.  It adds the End Section ( "7777" )

        call gribend(cgrib,currlen,lengrib,ierr)
        call wryte(lout,lengrib,cgrib)

        if (ierr == 0) then
          print *,' '
          print *,'+++ GRIB2 write successful. '
          print *,'    Len of message = currlen= ',currlen
          print *,'    Len of entire GRIB2 message = lengrib= ',lengrib
        else
          print *,' ERROR from gribend writing GRIB2 msg = ',ierr
          stop 95
        endif

      else

        ! Write data out as a GRIB1 message....

        kpds(6) = 100

        do lev = 1,nlevsout 

          kpds(7) = int(xoutlev)

          print *,'ushe:  just before call to putgb, kf= ',kf

          print *,'output, kf= ',kf
c          do n = 1,kf
c            print *,'output, n= ',n,' xouttmp(n)= ',xouttmp(n)
c          enddo

          if (ifcsthour < 6) then
            do n = 1,kf
c              print *,'output, n= ',n,' xouttmp(n)= ',xouttmp(n)
              write (91,161) n,xouttmp(n)
  161         format (1x,'n= ',i6,'  xouttmp(n)= ',f10.4)
            enddo
          endif

          call putgb (lout,kf,kpds,kgds,valid_pt,xouttmp,ipret)
          print *,'ushe:  just after call to putgb, kf= ',kf
          if (ipret == 0) then
            print *,' '
            print *,'+++ IPRET = 0 after call to putgb'
            print *,' '
          else
            print *,' '
            print *,'!!!!!! ERROR in ushe'
            print *,'!!!!!! ERROR: IPRET NE 0 AFTER CALL TO PUTGB !!!'
            print *,'!!!!!!        Level index= ',lev
            print *,'!!!!!!           pressure= ',xoutlev
            print *,' '
          endif

          write(*,980) kpds(1),kpds(2)
          write(*,981) kpds(3),kpds(4)
          write(*,982) kpds(5),kpds(6)
          write(*,983) kpds(7),kpds(8)
          write(*,984) kpds(9),kpds(10)
          write(*,985) kpds(11),kpds(12)
          write(*,986) kpds(13),kpds(14)
          write(*,987) kpds(15),kpds(16)
          write(*,988) kpds(17),kpds(18)
          write(*,989) kpds(19),kpds(20)
          write(*,990) kpds(21),kpds(22)
          write(*,991) kpds(23),kpds(24)
          write(*,992) kpds(25)
          write(*,880) kgds(1),kgds(2)
          write(*,881) kgds(3),kgds(4)
          write(*,882) kgds(5),kgds(6)
          write(*,883) kgds(7),kgds(8)
          write(*,884) kgds(9),kgds(10)
          write(*,885) kgds(11),kgds(12)
          write(*,886) kgds(13),kgds(14)
          write(*,887) kgds(15),kgds(16)
          write(*,888) kgds(17),kgds(18)
          write(*,889) kgds(19),kgds(20)
          write(*,890) kgds(21),kgds(22)

        enddo

  980   format('    kpds(1)  = ',i7,'  kpds(2)  = ',i7)
  981   format('    kpds(3)  = ',i7,'  kpds(4)  = ',i7)
  982   format('    kpds(5)  = ',i7,'  kpds(6)  = ',i7)
  983   format('    kpds(7)  = ',i7,'  kpds(8)  = ',i7)
  984   format('    kpds(9)  = ',i7,'  kpds(10) = ',i7)
  985   format('    kpds(11) = ',i7,'  kpds(12) = ',i7)
  986   format('    kpds(13) = ',i7,'  kpds(14) = ',i7)
  987   format('    kpds(15) = ',i7,'  kpds(16) = ',i7)
  988   format('    kpds(17) = ',i7,'  kpds(18) = ',i7)
  989   format('    kpds(19) = ',i7,'  kpds(20) = ',i7)
  990   format('    kpds(21) = ',i7,'  kpds(22) = ',i7)
  991   format('    kpds(23) = ',i7,'  kpds(24) = ',i7)
  992   format('    kpds(25) = ',i7)
  880   format('    kgds(1)  = ',i7,'  kgds(2)  = ',i7)
  881   format('    kgds(3)  = ',i7,'  kgds(4)  = ',i7)
  882   format('    kgds(5)  = ',i7,'  kgds(6)  = ',i7)
  883   format('    kgds(7)  = ',i7,'  kgds(8)  = ',i7)
  884   format('    kgds(9)  = ',i7,'  kgds(10) = ',i7)
  885   format('    kgds(11) = ',i7,'  kgds(12) = ',i7)
  886   format('    kgds(13) = ',i7,'  kgds(14) = ',i7)
  887   format('    kgds(15) = ',i7,'  kgds(16) = ',i7)
  888   format('    kgds(17) = ',i7,'  kgds(18) = ',i7)
  889   format('    kgds(19) = ',i7,'  kgds(20) = ',i7)
  890   format('    kgds(20) = ',i7,'  kgds(22) = ',i7)

      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine open_grib_files (lugb,lugi,lout,gribver,iret)

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to read from the input GRIB files.  The GRIB and index files
C     are opened with a call to baopenr.  This call to baopenr was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB-reading
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lugb     The Fortran unit number for the GRIB data file
C     lugi     The Fortran unit number for the GRIB index file
C     lout     The Fortran unit number for the  output grib file
c     gribver  integer (1 or 2) to indicate if using GRIB1 / GRIB2
C
C     OUTPUT:
C     iret     The return code from this subroutine

      implicit none

      character(2)   lugb_c,lugi_c,lout_c
c     character(120) fnameg,fnamei,fnameo
cPeng 05/28/2018 Bug Fixed for FV3-GFS Job Crashed.
      character(255) fnameg,fnamei,fnameo
      character(6)   enameb,enamei,enameo
      integer   iret,gribver,lugb,lugi,lout,igoret,iioret,iooret

      iret=0
      write(lugb_c,'(i2)')lugb
      write(lugi_c,'(i2)')lugi
      write(lout_c,'(i2)')lout
      enameb='FORT'//adjustl(lugb_c)
      enamei='FORT'//adjustl(lugi_c)
      enameo='FORT'//adjustl(lout_c)
      call get_environment_variable(enameb, fnameg, status=igoret)
      call get_environment_variable(enamei, fnamei, status=iioret)
      call get_environment_variable(enameo, fnameo, status=iooret)

      if (igoret .ge. 2 .or. iioret .ge. 2 .or. iooret .ge. 2) then
        write (*,*) 'failed: the processor does not support env var'
        write (*,*) 'igoret=',igoret,'iioret=',iioret,'iooret=',iooret 
        stop 99
      end if
      if (igoret .eq. 1 .or. iioret .eq. 1 .or. iooret .eq. 1) then
        write (*,*) 'failed: env var does not exist'
        stop 99
      end if
      if (igoret .eq. -1 .or. iioret .eq. -1 .or. iooret .eq. -1) then
        write (*,*) 'failed: env var is truncated to 255'
        stop 99
      end if

      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        fnameg(1:5) = "fort."
        fnamei(1:5) = "fort."
        fnameo(1:5) = "fort."
        write(fnameg(6:7),'(I2)') lugb
        write(fnamei(6:7),'(I2)') lugi
        write(fnameo(6:7),'(I2)') lout
      endif
      call baopenr (lugb,fnameg,igoret)
      call baopenr (lugi,fnamei,iioret)
      call baopenw (lout,fnameo,iooret)

      print *,' '
      print *,'ushe baopen: igoret= ',igoret,' iioret= ',iioret
     &       ,' iooret= ',iooret
      
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        print *,' '
        print *,'!!! ERROR in ushe'
        print *,'!!! ERROR in sub open_grib_files opening grib file'
        print *,'!!! or grib index file.  baopen return codes:'
        print *,'!!! grib  file return code = igoret = ',igoret
        print *,'!!! index file return code = iioret = ',iioret
        print *,'!!! output file return code = iooret = ',iooret
        iret = 93
        return
      endif

      return
      end
c
c-------------------------------------------------------------------
c
c-------------------------------------------------------------------
      subroutine bitmapchk (n,ld,d,dmin,dmax)
c
c     This subroutine checks the bitmap for non-existent data values.
c     Since the data from the regional models have been interpolated
c     from either a polar stereographic or lambert conformal grid
c     onto a lat/lon grid, there will be some gridpoints around the
c     edges of this lat/lon grid that have no data; these grid
c     points have been bitmapped out by Mark Iredell's interpolater.
c     To provide another means of checking for invalid data points
c     later in the program, set these bitmapped data values to a
c     value of -999.0.  The min and max of this array are also
c     returned if a user wants to check for reasonable values.
c
      logical(1) ld
      dimension  ld(n),d(n)
c
      dmin=1.E15
      dmax=-1.E15
c
      do i=1,n
        if (ld(i)) then
          dmin=min(dmin,d(i))
          dmax=max(dmax,d(i))
        else
          d(i) = -999.0
        endif
      enddo
c
      return
      end

c$$$  Subprogram Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Subprogram: output_acqc_prof 
c   Programmer: D. Keyser       Org: NP22       Date: 2016-12-09
c
c Abstract: Reads in sorted NRLACQC quality controlled single-level aircraft reports and
c   constructs profiles from ascending or descending flights.  Encodes these profiles as
c   merged (mass and wind) reports (subsets) along with (when l_prof1lvl=T) merged
c   single(flight)-level aircraft reports not part of any profile into a PREPBUFR-like file
c   containing only these data.  Single-level reports get PREPBUFR report type 3xx (where xx
c   is original type in 1xx mass and 2xx wind reports), ascending profile reports get
c   PREPBUFR report type 4xx, and descending profile reports get PREPBUFR report type 5xx.
c
c Program History Log:
c 2010-11-15  S. Bender  -- Original Author
c 2012-05-08  D. Keyser  -- Prepared for operational implementation
c 2012-11-20  J. Woollen -- Initial port to WCOSS
c 2013-02-07  D. Keyser  -- Final changes to run on WCOSS: use formatted print statements
c                           where previously unformatted print was > 80 characters
c 2016-12-09  D. Keyser  --
c                 - Nomenclature change: replaced "MDCRS/ACARS" with just "MDCRS".
c                 - Latitude/longitdue arrays "alat" and "alon" passed into of this subroutine
c                   now double precision. XOB and YOB in PREPBUFR file now scaled to 10**5
c                   (was 10**2) to handle new v7 AMDAR and MDCRS reports which have this
c                   higher precision.
c                   BENEFIT: Retains exact precison here. Improves QC processing.
c                         - The format for all print statements containing latitude and longitude
c                           changed to print to 5 decimal places.
c
c Usage: call output_acqc_prof(proflun,nrpts4QC_pre,max_reps,mxnmev,
c                              mxlv,bmiss,cdtg_an,alat,alon,ht_ft,
c                              idt,c_qc,trad,l_otw,l_nhonly,sortidx,
c                              c_acftreg,c_acftid,ob_t,nevents,hdr,
c                              acid,rct,drinfo,acft_seq,mstq,cat,
c                              pob_ev,pqm_ev,ppc_ev,prc_ev,pbg,ppp,
c                              zob_ev,zqm_ev,zpc_ev,zrc_ev,zbg,zpp,
c                              tob_ev,tqm_ev,tpc_ev,trc_ev,tbg,tpp,
c                              qob_ev,qqm_ev,qpc_ev,qrc_ev,qbg,qpp,
c                              uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,
c                              wbg,wpp,ddo_ev,ffo_ev,dfq_ev,dfp_ev,
c                              dfr_ev,nrlacqc_pc,l_allev_pf,
c                              l_prof1lvl,l_mandlvl,tsplines,l_operational,lwr)
c
c   Input argument list:
c     proflun      - Unit number for the output post-PREPACQC PREPBUFR-like file containing
c                    merged profile reports (always) and single(flight)-level reports not
c                    part of any profile (when l_prof1lvl=T) with added NRLACQC events
c                    (aircraft data only)
c     nrpts4QC_pre - Number of reports in the "merged" single-level aircraft report arrays
c     max_reps     - Maximum number of reports accepted by acftobs_qc
c     mxnmev       - Maximum number of events allowed, per variable type
c     mxlv         - Maximum number of levels allowed in a report profile
c     bmiss        - BUFRLIB missing value (set in main program)
c     cdtg_an      - Date/analysis time (YYYYMMDDCC)
c     alat         - Array of latitudes for the "merged" reports
c     alon         - Array of longitudes for the "merged" reports
c     ht_ft        - Array of altitudes for the "merged" reports
c     idt          - Array of ob-cycle times for the "merged" reports (in seconds)
c     c_qc         - Array of NRLACQC quality information (11 char. string) ("merged" reports)
c     trad         - Time window radius for outputting reports (if l_otw=T) (read in via
c                    namelist)
c     l_otw        - Logical whether or not to eliminate reports outside the time window
c                    radius (trad) (read in via namelist)
c     l_nhonly     - Logical Whether or not to eliminate reports south of 20S latitude (i.e,
c                    outside the tropics and N. Hemisphere) (read in via namelist)
c     sortidx      - Sort index that specifies the order in which the reports should be
c                     written to the output PREPBUFR-like profiles file
c     c_acftreg    - Array of aircraft tail numbers for the "merged" reports as used in
c                    NRL QC processing
c     c_acftid     - Array of aircraft flight numbers for the "merged" reports as used in
c                    NRL QC processing
c     ob_t         - Array of aircraft temperatures for the "merged" reports
c     nevents      - Array tracking number of events for variables for each report
c     hdr          - Array containing header information for the "merged" reports {word 1 is
c                    flight number for AIREPs, tail number for AMDARs (all types) and MDCRS,
c                    and manfactured id for PIREPs and TAMDARs  - this will be later be
c                    encoded into 'SID' for aircraft reports in output  PREPBUFR-like file)
c     acid         - Array containing flight numbers for the "merged" MDCRS and AMDAR (LATAM
c                    only) reports {this will be encoded into 'ACID' for MDCRS and AMDAR
c                    (LATAM only) reports in output PREPBUFR-like profiles file}
c     rct          - Array containing receipt times for the "merged" reports
c     drinfo       - Array containing drift information for the "merged" reports
c     acft_seq     - Array containing temperature precision and phase of flight for the
c                    "merged" reports
c     mstq         - Array containing moisture quality flags for the "merged" reports
c     cat          - Array containing level category for the "merged" reports
c     pob_ev       - Pressure event obs
c     pqm_ev       - Pressure event quality marks
c     ppc_ev       - Pressure event program codes
c     prc_ev       - Pressure event reason codes
c     pbg          - Pressure background data (POE PFC PFCMOD)
c     ppp          - Pressure post-processing info (PAN PCL PCS)
c     zob_ev       - Altitude event obs
c     zqm_ev       - Altitude event quality marks
c     zpc_ev       - Altitude event program codes
c     zrc_ev       - Altitude event reason codes
c     zbg          - Altitude background data (ZOE ZFC ZFCMOD)
c     zpp          - Altitude post-processing info (ZAN ZCL ZCS)
c     tob_ev       - Temperature event obs
c     tqm_ev       - Temperature event quality marks
c     tpc_ev       - Temperature event program codes
c     trc_ev       - Temperature event reason codes
c     tbg          - Temperature background data (TOE TFC TFCMOD)
c     tpp          - Temperature post-processing info (TAN TCL TCS)
c     qob_ev       - Moisture event obs
c     qqm_ev       - Moisture event quality marks
c     qpc_ev       - Moisture event program codes
c     qrc_ev       - Moisture event reason codes
c     qbg          - Moisture background data (QOE QFC QFCMOD)
c     qpp          - Moisture post-processing info (QAN QCL QCS)
c     uob_ev       - Wind/u-comp event obs
c     vob_ev       - Wind/v-comp event obs
c     wqm_ev       - Wind event quality marks
c     wpc_ev       - Wind event program codes
c     wrc_ev       - Wind event reason codes
c     wbg          - Wind background data (WOE UFC VFC UFCMOD VFCMOD)
c     wpp          - Wind post-processing info (UAN VAN UCL VCL UCS VCS)
c     ddo_ev       - Wind direction event obs
c     ffo_ev       - Wind speed event obs
c     dfq_ev       - Wind direction/speed quality mark
c     dfp_ev       - Wind direction/speed program code
c     dfr_ev       - Wind direction/speed reason code
c     nrlacqc_pc   - PREPBUFR program code for the NRLACQC step
c     l_allev_pf   - Logical whether to process latest (likely NRLACQC) event plus all prior
c                    events (TRUE) or only latest event (FALSE) into profiles PREPBUFR-like
c                    file
c     l_prof1lvl   - Logical whether to encode merged single(flight)-level aircraft reports
c                    with NRLACQC events that are not part of any profile into PREPBUFR-like
c                    file (along with, always, merged profiles from aircraft ascents and
c                    descents)
c     l_mandlvl    - Logical whether to interpolate to mandatory levels in profile generation
c     tsplines     - Logical whether to use tension-splines for aircraft vertical velocity
c                    calculation
c     l_operational- Run program in operational mode if true
c     lwr          - Machine word length in bytes (either 4 or 8)
c
c   Output files:
c     Unit proflun - PREPBUFR-like file containing merged (mass and wind) profile reports
c                    (always) and single(flight)-level reports not part of any profile (when
c                    l_prof1lvl=T) with NRLACQC events
c     Unit 06      - Standard output print
c     Unit 52      - Text file containing listing of all QC'd merged aircraft reports written
c                    to profiles PREPBUFR-like file
c
c   Subprograms called:
c     Unique:    SUB2MEM_MER SUB2MEM_UM
c     Library:
c       SYSTEM:  SYSTEM
c       BUFRLIB: OPENMB      WRITSB
c
c   Exit States:
c     Cond =  0 - successful run
c
c Remarks: Called by main program.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine output_acqc_prof(proflun,nrpts4QC_pre,max_reps,mxnmev,
     +                            mxlv,bmiss,cdtg_an,alat,alon,ht_ft,
     +                            idt,c_qc,trad,l_otw,l_nhonly,sortidx,
     +                            c_acftreg,c_acftid,ob_t,nevents,hdr,
     +                            acid,rct,drinfo,acft_seq,mstq,cat,
     +                            pob_ev,pqm_ev,ppc_ev,prc_ev,pbg,ppp,
     +                            zob_ev,zqm_ev,zpc_ev,zrc_ev,zbg,zpp,
     +                            tob_ev,tqm_ev,tpc_ev,trc_ev,tbg,tpp,
     +                            qob_ev,qqm_ev,qpc_ev,qrc_ev,qbg,qpp,
     +                            uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,
     +                            wbg,wpp,ddo_ev,ffo_ev,dfq_ev,dfp_ev,
     +                            dfr_ev,nrlacqc_pc,l_allev_pf,
     +                            l_prof1lvl,l_mandlvl,tsplines,
     +                            l_operational,lwr)

      implicit none
      integer mevwrt(1)   ! DAK: This is a "dummy" variable, not used anywhere.  For some
                          !      reason if one removes this, moves it to any other place in
                          !      this subr., changes the dimension, or does not initialize it
                          !      as zero (look below)  the compiler can fail under -O3 with
                          !      debugging turned on ("An error occurred during code
                          !      generation.  The code generation return code was 40." 
                          !     "Compilation failed for file output_acqc_prof.f."

c ------------------------------
c Parameter statements/constants
c ------------------------------
      integer    proflun              ! output unit number for post-PREPACQC PREPBUFR-like
                                      !  file containing merged profile reports (always) and
                                      !  single(flight)-level reports not part of any profile
                                      !  (when l_prof1lvl=T) with added NRLACQC events

      integer    max_reps             ! maximum number of input merged (mass + wind piece)
                                      !  aircraft-type reports allowed
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c replace above with this in event of future switch to dynamic memory allocation

calloc  integer    max_reps           ! original number of input reports obtained from
calloc                                !  first pass through to get total for array allocation
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      real*8     bmiss                ! BUFRLIB missing value (set in main program)

c ----------------------
c Declaration statements
c ----------------------

c Variables for BUFRLIB interface
c -------------------------------
      character*10 cdtg_an            ! date-time group for analysis (YYYYMMDDCC)
                                      !  (all messages in a PREPBUFR-like file should have
      integer      icdtg_an           !   same YYYYMMDDCC)

c Indices/counters 
c ----------------
      integer      i,j,k,ii           ! loop indices

      integer      nrpts4QC_pre       ! original number of input merged (mass + wind piece)
                                      !  aircraft-type reports (read in from PREPBUFR file)

      integer      sortidx(max_reps)  ! index if reports are to be written back out in a 
                                      !  certain order (determined by calling routine)

      character*11 c_qc(max_reps)     ! character QC flags output from NRL QC code
                                      !   1st char - info about reject (if ob was rejected)
                                      !   2nd char - reason why time was rejected
                                      !   3rd char - reason why latitude was rejected
                                      !   4th char - reason why longitude was rejected
                                      !   5th char - reason why pressure/atitude was rejected
                                      !   6th char - readon why temperature was rejected
                                      !   7th char - reason why wind direction was rejected
                                      !   8th char - reason why wind speed was rejected
                                      !   9th char - reason why mixing ratio was rejected
                                      !  10th char - reason for blacklisting the aircraft
                                      !  11th char - info about flight phase

      real*8       alat(max_reps)     ! latitude
     +,            alon(max_reps)     ! longitude
      real         ht_ft(max_reps)    ! altitude in feet

      integer      idt(max_reps)      ! time in seconds to anal. time (- before, + after)
      character*8  c_acftreg(max_reps)! aircraft registration (tail) number as used in NRL
                                      !  QC processing
      character*9  c_acftid(max_reps) ! aircraft flight number as used in NRL QC processing

      real         ob_t(max_reps)     ! temperature

c Logicals controlling processing (read in from namelist in main program)
c -----------------------------------------------------------------------
      real      trad            ! Time window radius for outputting reports (if l_otw=T)
      logical   l_otw           ! T=eliminate reports outside cycle time window radius (trad)
     +,         l_nhonly        ! T=filter out obs outside tropics and Northern Hemisphere
     +,         l_allev_pf      ! T=process latest (likely NRLACQC) events plus all prior
                                !   events into profiles PREPBUFR-like file
                                !   **CAUTION: More complete option, but will make code take
                                !              longer to run!!!
                                ! F=process ONLY latest (likely NRLACQC) events into profiles
                                !   PREPBUFR-like file
                                !
                                ! Note : All pre-existing events plus latest (likely NRLACQC)
                                !        events are always encoded into full PREPBUFR file)

     +,         l_prof1lvl      ! T=encode merged single(flight)-level aircraft reports with
                                !   NRLACQC events that are not part of any profile into
                                !   PREPBUFR-like file, along with merged profiles from
                                !   aircraft ascents and descents
                                !   **CAUTION: Will make code take a bit longer to run!!
                                ! F=do not encode merged single(flight)-level aircraft
                                !   reports with NRLACQC events into PREPBUFR-like file -
                                !   only merged profiles from aircraft ascents and descents
                                !   will be encoded into this file
     +,         l_mandlvl       ! T=interpolate to mandatory levels in profile generation
                                ! F=do not interpolate to mandatory levels in profile
                                !   generation
     +,         tsplines        ! T=use tension-splines for aircraft vertical velocity
                                !   calculation
                                ! F=use finite-differencing for aircraft vertical velocity
                                !   calculation


c Logicals controlling processing (not read in from namelist in main program)
c ---------------------------------------------------------------------------
      logical   l_operational   ! Run program  in operational mode if true

c Counters
c --------
      integer   elim_knt(3)     ! Count of reports eliminated and kept
                                !   1 - # of merged reports outside time radius (prior to any
                                !         geographical domain checking)
                                !   2 - # of merged reports outside geographical domain (had
                                !         passed time window radius check)
                                !   3 - # of merged reports passing both time window radius
                                !         and geographical domain checks and thus retained
                                !         for eventual processing into PREPBUFR-like profiles
                                !         file

c Variables used to write data to output PREPBUFR-like file in sorted order
c -------------------------------------------------------------------------
      character*8 msgtyp2wrt       ! BUFR message type to write to output PREPBUFR-like file

      integer      mxlv            ! maximum number of report levels allowed in aircraft
                                   !  profiles
      character*6  cmxlv           ! character form of mxlv

      integer mxnmev               ! maximum number of events allowed in stack

      integer lvlsinprof(mxlv)     ! array containing a list of pressure levels that are
                                   !  present in the current profile

      logical l_newprofile         ! T = start a new profile

      integer nprofiles	           ! number of "profile" reports identified
     +,       nprofiles_encoded    ! number of "profile" reports actually encoded into
                                   !  PREPBUFR-like file 
     +,       mxe4prof             ! maximum number of events in a single-level merged report
                                   !  (i.e., the maximum amongst the number of pressure,
                                   !  moisture, temperature, altitude, u/v wind and dir/speed
                                   !  wind events)
     +,       nlvinprof	           ! number of levels in a profile
     +,       nlvinprof_last       ! index for level number of last level (for duplicate
                                   !  pressure level removal option #1)
     +,       nlvinprof_temp       ! temporary level number index needed for duplicate
                                   !  pressure level removal

      character*8   tail_curr,     ! aircraft registration (tail) number of current report
     +              tail_prev      ! aircraft registration (tail) number of previous report

      character*9   flt_curr,      ! flight number of current report
     +              flt_prev       ! flight number of previous report

      real          elv_curr,      ! elevation of current report
     +              elv_prev       ! elevation of previous report

      integer       idt_curr,      ! time of current report
     +	            idt_prev       ! time of previous report

      integer       idz_curr,      ! altitude of current report
     +              idz_prev       ! altitude of previous report

      real*8   hdr2wrt(15)              ! array used to pass header info to subroutine
                                        !  sub2mem_mer 
      character*8 c_sid                 ! SID from PREPBUFR file = Site ID
      equivalence(c_sid,hdr2wrt(1))

      real*8   drinfo_accum(3,mxlv)	! array used to accumulate drift info across profile
                                        !  levels

      real*8   acft_seq_accum(2,mxlv)   ! array used to accumulate ACFT_SEQ (PCAT -
                                        !  temperature precision, POAF - phase of flight)
                                        !  info across profile levels
     +,	       mstq_accum(1,mxlv)       ! array used to accumulate moisture QC marks across
                                        !  profile levels
     +,	       cat_accum(1,mxlv)        ! array used to accumulate level category markers
                                        !  across profile levels
     +,	       elv_accum(1,mxlv)        ! array used to accumulate elevation across profile
                                        !  levels
     +,	       rpt_accum(1,mxlv)        ! array used to accumulate reported obs time across
                                        !  profile levels
     +,	       tcor_accum(1,mxlv)       ! array used to accumulate time correction indicator
                                        !  across profile levels
     +,	       rct_accum(1,mxlv)        ! array used to accumulate receipt time across
                                        !  profile levels

      real*8   pevn_accum(4,mxlv,mxnmev)! array used to accumulate pressure data/events for a
                                        !  single profile, across profile levels
     +,	       pbg_accum(3,mxlv)        ! array used to accumulate pressure background info
                                        !  (POE, PFC, PFCMOD) for a single profile, across
                                        !  profile levels
     +,        ppp_accum(3,mxlv)        ! array used to accumulate pressure post-processing
                                        !  info (PAN, PCL, PCS) for a single profile, across
                                        !  profile levels

      real*8   qevn_accum(4,mxlv,mxnmev)! array used to accumulate moisture data/events for a
                                        !  single profile, across profile levels
     +,        qbg_accum(3,mxlv)        ! array used to accumulate moisture background info
                                        !  (QOE, QFC, QFCMOD) for a single profile, across
                                        !  profile levels
     +,        qpp_accum(3,mxlv)        ! array used to accumulate moisture post-processing
                                        !  info (QAN, QCL, QCS) for a single profile, across
                                        !  profile levels

      real*8   tevn_accum(4,mxlv,mxnmev)! array used to accumulate temperature data/events
                                        !  for a single profile, across profile levels
     +,	       tbg_accum(3,mxlv)        ! array used to accumulate temperature background
                                        !  info (TOE, TFC, TFCMOD) for a single profile,
                                        !  across profile levels
     +,        tpp_accum(3,mxlv)	! array used to accumulate temperature post-
                                        !  processing info (TAN, TCL, TCS) for a single
                                        !  profile, across profile levels

      real*8   zevn_accum(4,mxlv,mxnmev)! array used to accumulate altitude data/events for a
                                        !  single profile, across profile levels
     +,        zbg_accum(3,mxlv)        ! array used to accumulate altitude background info
                                        !  (ZOE, ZFC, ZFCMOD) for a single profile, across
                                        !  profile levels
     +,        zpp_accum(3,mxlv)        ! array used to accumulate altitude post-processing
                                        !  info (ZAN, ZCL, ZCS) for a single profile, across
                                        !  profile levels

      real*8   wuvevn_accum(5,mxlv,mxnmev)! array used to accumulate wind data/events (u/v
                                          !  components) for a single profile, across profile
                                          !  levels
     +,        wuvbg_accum(5,mxlv)      ! array used to accumulate wind background info (WOE,
                                        !  UFC, VFC, UFCMOD, VFCMOD)  for a single profile,
                                        !  across profile levels
     +,        wuvpp_accum(6,mxlv)      ! array used to accumulate wind post-processing info
                                        !  (UAN, VAN, UCL, VCL, UCS, VCS) for a single
                                        !  profile, across profile levels

      real*8   wdsevn_accum(5,mxlv,mxnmev)! array used to accumulate wind data/events
                                          !  (direction/speed) for a single profile, across
                                          !  profile levels

      character*11 c_qc_accum(mxlv)    ! array used to accumulate NRLACQC quality information
                                       !  on individual obs in a profile, across profile
                                       !  levels

c Summary counters
c ----------------
      integer num_events_prof          ! total number of events on an ob, across all levels,
                                       !  across all reports, written in the PREPBUFR-like
                                       !  (profiles) file (this value is the same for each
                                       !  ob type)

c Mandatory levels settings
c -------------------------
      integer maxmandlvls              ! maxmum number of mandatory pressure levels to
                                       !  consider for aircraft profiles
      parameter(maxmandlvls = 9)

      integer mandlvls(maxmandlvls)    ! list of mandatory pressure levels to consider for
                                       !  aircraft profiles

      data mandlvls/1000,1500,2000,3000,4000,5000,7000,8500,10000/

c Variables used to hold original aircraft data read from input PREPBUFR file - necessary for
c  carrying data through program so that it can be later written to output PREPBUFR-like
c  profiles file from memory instead of going back to input PREPBUFR file and re-reading that
c  file before adding any NRLACQC events
c -------------------------------------------------------------------------------------------
      integer nevents(max_reps,6)     ! array tracking number of events for variables for
                                      ! each report:
                                      !   1 - number of pressure events
                                      !   2 - number of moisture events
                                      !   3 - number of temperature events
                                      !   4 - number of altitude events
                                      !   5 - number of wind (u/v) events
                                      !   6 - number of wind (direction/speed) events

      real*8  pob_ev(max_reps,mxnmev) ! POB values for each report, including all events
     +,       pqm_ev(max_reps,mxnmev) ! PQM values for each report, including all events
     +,       ppc_ev(max_reps,mxnmev) ! PPC values for each report, including all events
     +,       prc_ev(max_reps,mxnmev) ! PRC values for each report, including all events
     +,       zob_ev(max_reps,mxnmev) ! ZOB values for each report, including all events
     +,       zqm_ev(max_reps,mxnmev) ! ZQM values for each report, including all events
     +,       zpc_ev(max_reps,mxnmev) ! ZPC values for each report, including all events
     +,       zrc_ev(max_reps,mxnmev) ! ZRC values for each report, including all events
     +,       tob_ev(max_reps,mxnmev) ! TOB values for each report, including all events
     +,       tqm_ev(max_reps,mxnmev) ! TQM values for each report, including all events
     +,       tpc_ev(max_reps,mxnmev) ! TPC values for each report, including all events
     +,       trc_ev(max_reps,mxnmev) ! TRC values for each report, including all events
     +,       qob_ev(max_reps,mxnmev) ! QOB values for each report, including all events
     +,       qqm_ev(max_reps,mxnmev) ! QQM values for each report, including all events
     +,       qpc_ev(max_reps,mxnmev) ! QPC values for each report, including all events
     +,       qrc_ev(max_reps,mxnmev) ! QRC values for each report, including all events
     +,       uob_ev(max_reps,mxnmev) ! UOB values for each report, including all events
     +,       vob_ev(max_reps,mxnmev) ! VOB values for each report, including all events
     +,       wqm_ev(max_reps,mxnmev) ! WQM values for each report, including all events
     +,       wpc_ev(max_reps,mxnmev) ! WPC values for each report, including all events
     +,       wrc_ev(max_reps,mxnmev) ! WRC values for each report, including all events
     +,       ddo_ev(max_reps,mxnmev) ! DDO values for each report, including all events
     +,       ffo_ev(max_reps,mxnmev) ! FFO values for each report, including all events
     +,       dfq_ev(max_reps,mxnmev) ! DFQ values for each report, including all events
     +,       dfp_ev(max_reps,mxnmev) ! DFP values for each report, including all events
     +,       dfr_ev(max_reps,mxnmev) ! DFR values for each report, including all events

     +,       hdr(max_reps,15)        ! SID XOB YOB DHR ELV TYP T29 TSB ITP SQN PROCN RPT
                                      !  TCOR RSRD EXRSRD
     +,       acid(max_reps)          ! ACID
     +,       rct(max_reps)           ! RCT
     +,       mstq(max_reps)          ! MSTQ
     +,       cat(max_reps)           ! CAT

     +,       pbg(max_reps,3)         ! POE PFC PFCMOD
     +,       zbg(max_reps,3)         ! ZOE ZFC ZFCMOD
     +,       tbg(max_reps,3)         ! TOE TFC TFCMOD
     +,       qbg(max_reps,3)         ! QOE QFC QFCMOD
     +,       wbg(max_reps,5)         ! WOE UFC VFC UFCMOD VFCMOD

     +,       ppp(max_reps,3)         ! PAN PCL PCS
     +,       zpp(max_reps,3)         ! ZAN ZCL ZCS
     +,       tpp(max_reps,3)         ! TAN TCL TCS
     +,       qpp(max_reps,3)         ! QAN QCL QCS
     +,       wpp(max_reps,6)         ! UAN VAN UCL VCL UCS VCS

     +,       drinfo(max_reps,3)      ! XOB YOB DHR
     +,       acft_seq(max_reps,2)    ! PCAT POAF

      real*8  acid_last_profile       ! ACID (aircraft flight number) for last (or only)
                                      !  MDCRS or AMDAR (LATAM only) report in profile (passed
                                      !  into subroutine sub2mem_mer)

      character*9  c_acftid_last_profile  ! aircraft flight number (as processed by NRL QC
                                          !  procesing) for last (or only) report in profile
                                          !  (passed into subroutine sub2mem_mer for printing
                                          !  purposes only)

      character*8  c_acftreg_last_profile ! aircraft tail number (as processed by NRL QC
                                          !  procesing) for last (or only) report in profile
                                          !  (passed into subroutine sub2mem_mer for printing
                                          !  purposes only)

      real    del_time                ! report time difference between two levels, used by
                                      !  profile gross check
     +,       del_hght                ! report time difference between two levels, used by
                                      !  profile gross check
     +,       vvel                    ! vertical velocity between two levels, used by profile
                                      !  gross check

c Misc.
c -----
      integer i_option                ! Duplicate pressure removal option (1 or 2)
     +,       lwr                     ! machine word length in bytes (either 4 or 8)

      real    nrlacqc_pc              ! PREPBUFR program code for the NRLACQC step

ccccc integer iprint                  ! Switch controlling extra diagnostic printout

c *******************************************************************

c Initialize variables
c --------------------

      tail_prev = 'XXXXXXXX'
      flt_prev = 'XXXXXXXXX'
      elv_prev = 99999
      idt_prev = 99999
      idz_prev = 99999

      mxe4prof       = 0
      nlvinprof      = 0
      nlvinprof_last = 0

      lvlsinprof = 99999

      pevn_accum = bmiss 
      pbg_accum  = bmiss 
      ppp_accum  = bmiss 
	
      tevn_accum = bmiss 
      tbg_accum  = bmiss 
      tpp_accum  = bmiss 

      qevn_accum = bmiss 
      qbg_accum  = bmiss 
      qpp_accum  = bmiss 
	
      zevn_accum = bmiss 
      zbg_accum  = bmiss 
      zpp_accum  = bmiss 

      wuvevn_accum = bmiss 
      wuvbg_accum  = bmiss 
      wuvpp_accum  = bmiss 

      wdsevn_accum = bmiss 

      drinfo_accum   = bmiss
      acft_seq_accum = bmiss
      mstq_accum     = bmiss 
      cat_accum      = bmiss 
      elv_accum      = bmiss 
      rpt_accum      = bmiss 
      tcor_accum     = bmiss 
      rct_accum      = bmiss 

      c_qc_accum = 'XXXXXXXXXXX'

      hdr2wrt = bmiss 

      acid_last_profile      = bmiss
      c_acftid_last_profile  = '         '
      c_acftreg_last_profile = '        '

      nprofiles         = 0
      nprofiles_encoded = 0
      mevwrt            = 0 ! DAK: This is a "dummy" variable, not used anywhere.  For some
                            !      reason if one removes this, moves its declaration (look
                            !      above) to any other place in this subr., changes the
                            !      dimension, or does not initialize it as zero (here) the
                            !      CCS XLF compiler can fail under -O3 with debugging turned
                            !      on ("An error occurred during code generation.  The code
                            !      generation return code was 40." "Compilation failed for
                            !      file output_acqc_prof.f."  -- Not sure what might happen
                            !      with ifort compiler on WCOSS

      elim_knt          = 0
      num_events_prof   = 0


c Start subroutine
c ----------------
      write(*,*)
      write(*,*) '***************************'
      write(*,*) 'Welcome to output_acqc_prof'
      call system('date')
      write(*,*) '***************************'
      write(*,*)

      write(*,*)
      write(*,'(" --> Output to PREPBUFR-like file (holding merged QCd",
     +          " aircraft profile rpts & when l_prof1lvl=T single",
     +          "(flight)-level aircraft rpts)")')
      write(*,*)

      if(.not.l_operational) then  ! this is currently invoked because l_operational
                                   !  is hardwired to F for l_ncep=T

c Write merged profile reports and resulting QC decisions to an output file for later perusal
c -------------------------------------------------------------------------------------------

        open(52,file='merged.profile_reports.post_acftobs_qc.sorted',
     +       form='formatted')
        write(52,*)
        write(52,'(" Final listing of all aircraft profile reports in ",
     +             "pseudo-PREPBUFR file after NRLACQC")')
        write(52,'(" -------------------------------------------------",
     +             "----------------------------------")')
        write(52,*)
        write(52,'(" TAMDAR reports here replace characters 1-3 of ",
     +             "manufactured flight # (''000'') with (''TAM'') in ",
     +             "order to create truncated tail # ''TAM'' for ",
     +             "NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode ''000'' in")')
        write(52,'("  characters 1-3 of manufactured flight # for ",
     +             "TAMDAR (stored as both ''SID'' and ''ACID'')")')

        write(52,*)
        write(52,'(" AIREP and PIREP reports report only a flight # ",
     +             "(manufactured for PIREPs) - a tail # for NRLACQC ",
     +             "sorting is created by truncating the flight # - ",
     +             "the PREPBUFR file will not encode these truncated ",
     +             "tail #''s")')

        write(52,*)
        write(52,'(" All AMDAR reports except LATAM report only a tail",
     +            " # - this is stored as both flight # and tail # for",
     +             " NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode only tail # (stored in ''SID'')")')
        write(52,*)
        write(52,'(" AMDAR reports from LATAM report both a tail # and",
     +             " a flight # - these are used as reported for ",
     +             "NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode both tail # and flight # (as ''SID'' and ",
     +             "''ACID'',")')
        write(52,*) 'resp.)'
        write(52,*)
        write(52,'(" MDCRS reports from ARINC report both a tail # and",
     +             " a flight # - these are used as reported for",
     +             " NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode both tail # and flight # (as ''SID'' and ",
     +             "''ACID'',")')
        write(52,*) 'resp.)'

        write(52,*)
        write(52,3001)
 3001   format(172x,'! _PREPBUFR_QMs_!NRLACQC_REASON_CODE'/
     +         'index flight    tail num itp pf       lat       lon',
     +         '    time  hght   pres temp/evnt spec_h/evnt  uwnd   ',
     +         'vwnd/evnt t-prec !__qc_flag__!rcptm mstq cat  wspd ',
     +         'wdir rtyp         ! Pq Zq Tq Qq Wq!Prc Zrc Trc Qrc ',
     +         'Wrc'/
     +         '----- --------- -------- --- --   -------- --------',
     +         '- ------ ----- ------ --------- ----------- ------  ',
     +         '--------- ------  -----------!----- ---- --- ----- ',
     +         '---- ----         ! -- -- -- -- --!--- --- --- --- ',
     +         '---')
      endif
C--------------------------------------------------------------------------------------------
C  Options for handling duplicate pressures read in for a profile:
C  Option 1: For duplicate pressures read in for a profile, the first duplicate read in is
C            tossed and the second one is kept.  Note: This is how the code originally
C            performed this duplicate check.  Updated logic to make code run faster may cause
C            this option to not always work as expected - not sure.  Also, when debugging is
C            turned on, this option may not compile unless -qhot is added to FFLAGS in
C            makefile (not always the case, however).
C  Option 2: For duplicate pressures read in for a profile, the second duplicate read in is
C            tossed.  This appears to be less problematic than option 1.
C  Currently Option 2 is selected in this code.
      i_option = 2
C--------------------------------------------------------------------------------------------

c Now, loop over NRLACQC arrays and write aircraft type reports to output file in sorted
c  order as specified by sortidx
c --------------------------------------------------------------------------------------
      loop1: do i = 1,nrpts4QC_pre
        j = sortidx(i)

ccccc   print 4077, j,acid(j),rct(j)
c4077   format(1x,'for j = ',i6,', acid(j) = ',a8,', rct(j) = ',f10.3)

c Check to be sure the report is within the requested time window (defined by namelist switch
c  trad) and it is within the requested geographical domain (here north of 20S latitude, if
c  namelist switch l_nhonly is true)
c  {Note: alat(j) and idt(j) will have already been updated with rehabilitated values if
c         NRLACQC performed this task, so these checks will be more precise ...}
c -------------------------------------------------------------------------------------------

        if(l_otw) then ! check if report is outside time window (prior to any geographical
                       !  domain checking)
          if(idt(j).lt.-trad*3600..or.idt(j).gt.trad*3600.) then
	    elim_knt(1) = elim_knt(1) + 1
            cycle ! skip processing of this report, move on to next report
          endif
        endif

        if(l_nhonly) then ! if report passed time window radius check, then check to see if
                          !  it is outside geographical domain (i.e., south of 20S)
          if(alat(j).lt.-20.0) then
	    elim_knt(2) = elim_knt(2) + 1
            cycle ! skip processing of this report, move on to next report
          endif
        endif

c If this point is reached, the report is not to be eliminated
c ------------------------------------------------------------
ccccc   print *, 'keep this report!'

c Counter for number of merged reports kept
        elim_knt(3) = elim_knt(3) + 1

c Check if this ob should be included in current profile
c ------------------------------------------------------
        l_newprofile = .false.

        tail_curr = c_acftreg(j)
        flt_curr  = c_acftid(j)
        elv_curr  = ht_ft(j)
        idt_curr  = idt(j)
        idz_curr  = zob_ev(j,nevents(j,4))

        if(tail_curr.eq.tail_prev .and.flt_curr.eq.flt_prev) then   ! report may be part of current profile; need to make
                                        !  sure it's not the start of a separate profile from
                                        !  the same aircraft and flight

ccccc     iprint=0
ccccc     if(tail_curr.eq.'MSHWUURA ') iprint=1
ccccc     if(flt_curr.eq.'AFZA41   ') iprint=1

c By this point, reports have been sorted with a sort key of:
c
c  type//phase-of-flight//tail//flight//time//elevation//lat//lon
c
c  (see csort_wbad in main program) - phase-of-flight in c_qc(11:11) indicates that the
c  report is indeed part of an ascent or descent - if tail and flight number are equal, check
c  for elev(n)<= for ascents (c_qc(11:11) = a or A) and for elev(n) >=elev(n-1) for descents
c  (c_qc(11:11) = d or D) -- reaching these elevation criteria will signal the start of a new
c  profile
c -------------------------------------------------------------------------------------------
          if(
     +	   ((c_qc(j)(11:11).eq.'a' .or.
     +	     c_qc(j)(11:11).eq.'A') .and.
     +	    (elv_curr .lt. elv_prev)) .or.  ! new profile from the same aircraft/flight
     +       c_qc(j)(11:11).eq.'I'    .or.  !  perhaps the aircraft made a stop
     +       c_qc(j)(11:11).eq.'L'    .or.  !  somewhere and the flight number didn't
     +       c_qc(j)(11:11).eq.'N'    .or.  !  change - or, this report is isolated (I),
     +       c_qc(j)(11:11).eq.'U'    .or.  !  level (L), or its ascent/descent status is
     +	     c_qc(j)(11:11).eq.'-'    .or.  !  unknown (U).  Need to close off the
     +	   ((c_qc(j)(11:11).eq.'d' .or.     !  current profile, write it to output,
     +	     c_qc(j)(11:11).eq.'D') .and.   !  and start a new one
     +	    (elv_curr .gt. elv_prev))     
     +	    ) then

ccccc       if(iprint.eq.1)  print *,'new profile - same flight number'

	    l_newprofile = .true.
	    nprofiles = nprofiles + 1

          else  

ccccc       if(iprint.eq.1)  print *,'keep accumulating'

                 ! keep accumulating data into the current profile

c Perform a gross check on the report times of adjacent levels in the "profile" ...
C  Stop accumulating levels and start a new profile on this level if either:
C     1) The report time difference between this level and the previous level is > 1500 sec
C     2) The report time difference between this level and the previous level is > 1000 sec
C        and </= 1500 sec and the calculated vertical velocity magnitude is < 1.0 m/s {where
C        vertical velocity magnitude = abs(altitude this level minus altitude previous level)
C        divided by abs(time this level minus time previous level)}

            if(abs(idt_curr-idt_prev).gt.1000) then
              if(abs(idt_curr-idt_prev).le.1500) then
                del_time = abs(idt_curr-idt_prev)
                del_hght = abs(idz_curr-idz_prev)
                vvel = del_hght/del_time
                if(vvel.lt.1.00) then
                  print 66, idt_curr,idt_prev,tail_curr,flt_curr,j,
     +                      sortidx(i-1),idz_curr,idz_prev,vvel
   66 format(' Gross time chk exceeded (start new profile): idt_curr ',
     + 'idt_prev tail_curr flt_curr index_curr index_prev idz_curr ',
     + 'idz_prev vvel(m/s)'/48x,i6,3x,i6,2x,a8,2x,a9,2x,i6,5x,i6,4x,i5,
     + 4x,i5,3x,f7.3/)
	          l_newprofile = .true.
	          nprofiles = nprofiles + 1
                endif
              else
                print 67, idt_curr,idt_prev,tail_curr,flt_curr,j,
     +                    sortidx(i-1)
   67 format(' Gross time chk exceeded (start new profile): idt_curr ',
     + 'idt_prev tail_curr flt_curr index_curr index_prev'/,48x,i6,3x,
     + i6,2x,a8,2x,a9,2x,i6,5x,i6/)
	        l_newprofile = .true.
	        nprofiles = nprofiles + 1
              endif
            endif

          endif

        else ! tail, flights not equal, start a new profile

ccccc     if(iprint.eq.1)  print *,'new profile - new flight number'


	  l_newprofile = .true.
	  nprofiles = nprofiles + 1

        endif ! check if tail, flights equal for current and previous reports

	if(l_newprofile.and.nprofiles.gt.1) then ! need to close off current profile and
                                                 !  write to output
          if(l_prof1lvl.or.nlvinprof.gt.1) then

c Open message if necessary
c -------------------------
            call openmb(proflun,msgtyp2wrt,icdtg_an)

c Store contents of the current observation (profile or single/flight-level) into BUFRLIB
c  memory via subroutine sub2mem_mer
c ---------------------------------------------------------------------------------------

ccccc       if(iprint.eq.1)  print *,'call sub2mem_mer - 1st location'

ccccc       print 4078, sortidx(i-1),acid(sortidx(i-1)),acid_last_profile
c4078       format(1x,'1-call sub2mem_mer, last report j-1 = ',i6,
ccccc+             ', acid(j-1) = ',a8,', acid_last_profile = ',a8)
ccccc       if(iprint.eq.1)
ccccc+       print *, 'rct_accum: ',rct_accum(1,1),rct_accum(1,2),
ccccc+                rct_accum(1,3),rct_accum(1,4),
ccccc+                rct_accum(1,5),rct_accum(1,6),
ccccc+                rct_accum(1,7),rct_accum(1,8),
ccccc+                rct_accum(1,9),rct_accum(1,10),
ccccc+                rct_accum(1,11),rct_accum(1,12)

            call sub2mem_mer(proflun,bmiss,mxlv,mxnmev,maxmandlvls,
     +                       mandlvls,msgtyp2wrt,hdr2wrt,
     +	                     acid_last_profile, ! use ACID of last (or only) report in profile
     +	                     c_acftid_last_profile, ! use aircraft flight # (from NRLACQC) of
                                                    ! last (or only) report in profile
     +                       c_acftreg_last_profile,! use aircraft tail # (from NRLACQC) of
                                                    ! last (or only) report in profile
     +                       rct_accum,drinfo_accum,acft_seq_accum,
     +                       mstq_accum,cat_accum,elv_accum,rpt_accum,
     +                       tcor_accum,
     +                       pevn_accum,pbg_accum,ppp_accum,
     +                       qevn_accum,qbg_accum,qpp_accum,
     +                       tevn_accum,tbg_accum,tpp_accum,
     +                       zevn_accum,zbg_accum,zpp_accum,
     +                       wuvevn_accum,wuvbg_accum,wuvpp_accum,
     +                       wdsevn_accum,mxe4prof,c_qc_accum,
     +                       num_events_prof,lvlsinprof,nlvinprof,
     +                       nrlacqc_pc,l_mandlvl,tsplines,
     +                       l_operational,lwr)

c Write the current profile to output
c -----------------------------------
            if(hdr2wrt(6).gt.399.or.l_prof1lvl) then  ! sometimes reports with nlvinprof > 1
                                                      !  still come back as single-level
                                                      !  reports - this check keeps them
                                                      !  out of PREPBUFR-like file when
                                                      !  l_prof1lvl=F
              nprofiles_encoded = nprofiles_encoded + 1

ccccc         if(iprint.eq.1)  print *,'call writsb - 1st location'

              call writsb(proflun)
            endif
          endif

c Clear out accumulation arrays and start over with clear arrays for next profile
c -------------------------------------------------------------------------------
          nlvinprof      = 0
          nlvinprof_last = 0

          lvlsinprof = 99999

          pevn_accum = bmiss 
          pbg_accum  = bmiss 
          ppp_accum  = bmiss 

          qevn_accum = bmiss 
          qbg_accum  = bmiss 
          qpp_accum  = bmiss 

          tevn_accum = bmiss 
          tbg_accum  = bmiss 
          tpp_accum  = bmiss 

          zevn_accum = bmiss 
          zbg_accum  = bmiss 
          zpp_accum  = bmiss 

    	  wuvevn_accum = bmiss 
          wuvbg_accum  = bmiss 
          wuvpp_accum  = bmiss

          wdsevn_accum = bmiss 

          drinfo_accum   = bmiss 
          acft_seq_accum = bmiss
          mstq_accum     = bmiss 
          cat_accum      = bmiss 
          elv_accum      = bmiss
          rpt_accum      = bmiss
          tcor_accum     = bmiss
          rct_accum      = bmiss

          c_qc_accum = 'XXXXXXXXXXX'

          hdr2wrt = bmiss 

	  mxe4prof = 0

	endif ! l_newprofile

c Determine message date and type for output PREPBUFR-like file
c -------------------------------------------------------------
	read(cdtg_an,'(i10.10)') icdtg_an
        if(mod(int(hdr(j,6)),100).eq.33) then
          msgtyp2wrt = 'AIRCAR'
        else
          msgtyp2wrt = 'AIRCFT'
        endif

        if(i_option.eq.1) then
          nlvinprof = nlvinprof_last + 1
        else
          nlvinprof = nlvinprof + 1
        endif

        if(nlvinprof.gt.mxlv) then
C.......................................................................
C There are more levels in profile than "mxlv" -- do not process any more levels
C ------------------------------------------------------------------------------
          print 53, mxlv,mxlv
   53 format(/' #####> WARNING: THERE ARE MORE THAN ',I6,' LEVELS IN ',
     + 'THIS PROFILE -- WILL CONTINUE ON PROCESSING ONLY ',I6,' LEVELS',
     + ' FOR THIS PROFILE'/)
          write(cmxlv,'(i6)') mxlv
          call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     +     ' "$jlogfile" "***WARNING:'//cmxlv//' AIRCRAFT PROFILE '//
     +     'LEVEL LIMIT EXCEEDED IN PREPOBS_PREPACQC, ONLY '//
     +     cmxlv//' LEVELS PROCESSED"')
          exit loop1
C.......................................................................
        endif

c Subroutine sub2mem_um will update events in memory for this single-level "merged" report -
c  upon output the *_ev arrays will contain the events generated from the NRLACQC decisions
c ------------------------------------------------------------------------------------------

ccccc   if(iprint.eq.1)  print *,'call sub2mem_um'

	call sub2mem_um(c_qc(j),max_reps,mxnmev,j,nevents,
     +                  pob_ev,pqm_ev,ppc_ev,prc_ev,
     +                  zob_ev,zqm_ev,zpc_ev,zrc_ev,
     +                  tob_ev,tqm_ev,tpc_ev,trc_ev,
     +                  qob_ev,qqm_ev,qpc_ev,qrc_ev,
     +                  uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,
     +                  nrlacqc_pc,l_allev_pf)

        mxe4prof = max(mxe4prof,nevents(j,1),nevents(j,2),nevents(j,3),
     +                          nevents(j,4),nevents(j,5),nevents(j,6))


c Gather data into profile arrays before actually writing profile to output file
c ------------------------------------------------------------------------------

c Get header data
c ---------------
        hdr2wrt(:) = hdr(j,:) 

ccccc   if(iprint.eq.1)  print *,'HDR2WRT: ',hdr2wrt

c ------------------------------------------------------------
c Store pressure events, background data, analysis, climo data
c ------------------------------------------------------------
        lvlsinprof(nlvinprof) = int(pob_ev(j,nevents(j,1))*10)
        if(i_option.eq.1) nlvinprof_last = nlvinprof
        nlvinprof_temp = 0

ccccc   if(iprint.eq.1)  print *,'nlvinprof = ',nlvinprof

        if(nlvinprof.gt.1) then
          do ii=1,nlvinprof-1

ccccc       if(iprint.eq.1)  print *,'new ii: lvlsinprof(nlvinprof), ',
ccccc+                               'lvlsinprof(ii): ',
ccccc+                               lvlsinprof(nlvinprof),
ccccc+                               lvlsinprof(ii)

            if(lvlsinprof(nlvinprof).eq.lvlsinprof(ii)) then

ccccc         if(i_option.eq.1) then
ccccc           print'(" WARNING: Pressure level ",I0," was previously",
ccccc+                 " filled for this report - index ",I0," refill ",
ccccc+                 "with this one !!")', lvlsinprof(nlvinprof),ii
ccccc         else
ccccc           print'(" WARNING: Pressure level ",I0," was previously",
ccccc+                 " filled for this report - index ',I0,'keep it,",
ccccc+                 " toss this one !!")', lvlsinprof(nlvinprof),ii
ccccc         endif
ccccc         print *, hdr2wrt

              nlvinprof_temp = ii
              exit
            endif
          enddo
        endif
        if(nlvinprof_temp.gt.0) then
          if(i_option.eq.1) then
            nlvinprof_last = nlvinprof - 1
            nlvinprof = nlvinprof_temp ! DAK: W/ DEBUG ON **MAY** NOT COMPFILE UNLESS ADD
                                       !      -qhot
          else
            nlvinprof = nlvinprof - 1
            cycle ! skip processing
          endif
        endif

        if(l_prof1lvl.or.nlvinprof.gt.1) then
          acid_last_profile = acid(j)
          c_acftid_last_profile = c_acftid(j)
          c_acftreg_last_profile = c_acftreg(j)
        endif

c Store non-NRLACQC events in the "profile" arrays before adding any new events (done later
c  in subroutine sub2mem_mer)
c -----------------------------------------------------------------------------------------
        pevn_accum(1,nlvinprof,1:nevents(j,1))= pob_ev(j,1:nevents(j,1))
	pevn_accum(2,nlvinprof,1:nevents(j,1))= pqm_ev(j,1:nevents(j,1))
	pevn_accum(3,nlvinprof,1:nevents(j,1))= ppc_ev(j,1:nevents(j,1))
	pevn_accum(4,nlvinprof,1:nevents(j,1))= prc_ev(j,1:nevents(j,1))

c Background info
c ---------------
	pbg_accum(:,nlvinprof) = pbg(j,:) ! single-level upon input

c Post processing info
c --------------------
        ppp_accum(:,nlvinprof) = ppp(j,:) ! single-level upon input

c ------------------------------------------------------------
c Store altitude events, background data, analysis, climo data
c ------------------------------------------------------------

c Store non-NRLACQC events in the "profile" arrays before adding any new events (done later
c  in subroutine sub2mem_mer)
c -----------------------------------------------------------------------------------------
        zevn_accum(1,nlvinprof,1:nevents(j,4))= zob_ev(j,1:nevents(j,4))
        zevn_accum(2,nlvinprof,1:nevents(j,4))= zqm_ev(j,1:nevents(j,4))
        zevn_accum(3,nlvinprof,1:nevents(j,4))= zpc_ev(j,1:nevents(j,4))
        zevn_accum(4,nlvinprof,1:nevents(j,4))= zrc_ev(j,1:nevents(j,4))

c Background info
c ---------------
        zbg_accum(:,nlvinprof) = zbg(j,:) ! single-level upon input

c Post processing info
c --------------------
        zpp_accum(:,nlvinprof) = zpp(j,:) ! single-level upon input

c Get drift data - use XOB YOB DHR for drift coordinates when accumulating data into profiles
c -------------------------------------------------------------------------------------------
	drinfo_accum(:,nlvinprof) = drinfo(j,:)

c Get time correction factor
c --------------------------
        tcor_accum(1,nlvinprof) = hdr(j,13)

c -------------------------------------------------------------------------
c -------------------------------------------------------------------------
c Take into account possible rehabilitation of certain paramters by NRLACQC
c  - these will be written into profiles rather than original values
c  - Note: Right now we do not encode updates to XORG, XCOR, YORG or YCOR
c          into PREPBUFR-like profiles file!!
c -------------------------------------------------------------------------


        if(c_qc(j)(2:2).eq.'R'.or.           ! time reabilitated
     +     c_qc(j)(3:3).eq.'R'.or.           ! latitude reabilitated
     +     c_qc(j)(4:4).eq.'R'.or.           ! longitude reabilitated
     +     c_qc(j)(5:5).eq.'R'.or.           ! pressure/altitude reabilitated
     +     c_qc(j)(6:6).eq.'R'.or.           ! temperature reabilitated
     +     c_qc(j)(5:5).eq.'r') then         ! pressure/altitude reabilitated
          print 61
   61     format(131('v'))

          if(c_qc(j)(2:2).eq.'R') then

c Case where time was rehabiltated by NRLACQC, make note of it
c ------------------------------------------------------------
            print 62, j,hdr(j,1),hdr(j,3),hdr(j,2),hdr(j,4),
     +                nint(hdr(j,5)),c_qc(j)
   62 format(' TIME rehab. (prof): input rpt # ',i6,': id ',a8,', lat ',
     + f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,', NRLQMS "',
     + A11,'"')
            print 63, hdr(j,4),nint(hdr(j,4)*3600.)
   63 format(' INPUT time from PRE-QC PREPBUFR file [DHR,idt(sec)] ',
     + 'is: ',f10.5,i8)
            print 64, idt(j)/3600.,idt(j)
   64 format(' REHAB. (prof) time from  acftobs_qc  [DHR,idt(sec)] ',
     + 'is: ',f10.5,i8,' use this in profile if created')
            hdr2wrt(4) = idt(j)/3600.
            drinfo_accum(3,nlvinprof) = idt(j)/3600.
            hdr2wrt(13) = 3
            tcor_accum(1,nlvinprof) = 3 ! Set time correction indicator (TCOR) to 3
            print 44, tcor_accum(1,nlvinprof)
   44 format('   --> Time correction indicator (TCOR) changed to ',f3.0)
          endif
          if(c_qc(j)(3:3).eq.'R') then

c Case where latitude was rehabiltated by NRLACQC, make note of it
c ----------------------------------------------------------------
            print 72, j,hdr(j,1),hdr(j,3),hdr(j,2),hdr(j,4),
     +                nint(hdr(j,5)),c_qc(j)
   72 format(' LAT  rehab. (prof): input rpt # ',i6,': id ',A8,', lat ',
     + f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,', NRLQMS "',
     + A11,'"')
            print 73, hdr(j,3)
   73 format(' INPUT latitude from PRE-QC PREPBUFR file (YOB) is: ',
     + f9.5)
            print 74, alat(j)
   74 format(' REHAB. (prof) latitude from  acftobs_qc  (YOB) is: ',
     + f9.5,' use this in profile if created')
            hdr2wrt(3) = alat(j)
	    drinfo_accum(2,nlvinprof) = alat(j)
          endif
          if(c_qc(j)(4:4).eq.'R') then

c Case where longitude was rehabiltated by NRLACQC, make note of it
c -----------------------------------------------------------------
            print 82, j,hdr(j,1),hdr(j,3),hdr(j,2),hdr(j,4),
     +                nint(hdr(j,5)),c_qc(j)
   82 format(' LON  rehab. (prof): input rpt # ',i6,': id ',A8,', lat ',
     + f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,', NRLQMS "',
     + A11,'"')
            print 83, hdr(j,2)
   83 format(' INPUT longitude from PRE-QC PREPBUFR file (XOB) is: ',
     + f9.5)
            print 84, alon(j)
   84 format(' REHAB. (prof) longitude from  acftobs_qc  (XOB) is: ',
     + f9.5,' use this in profile if created')
            hdr2wrt(2) = alon(j)
	    drinfo_accum(1,nlvinprof) = alon(j)
          endif
          if(c_qc(j)(5:5).eq.'R'.or.c_qc(j)(5:5).eq.'r') then

c Case where pressure/altitude was rehabiltated by NRLACQC, make note of it
c -------------------------------------------------------------------------
            print 92, j,hdr(j,1),hdr(j,3),hdr(j,2),hdr(j,4),
     +                nint(hdr(j,5)),c_qc(j)
   92 format(' P/A  rehab. (prof): input rpt # ',i6,': id ',A8,', lat ',
     + f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,', NRLQMS "',
     + A11,'"')
            print 93
   93 format(' %%%%%%%%%%'/' %%%%% Currently not accounted for in ',
     + 'output PREPBUFR-like profiles file'/' %%%%%%%%%%')
          endif
          if(c_qc(j)(6:6).eq.'R') then

c Case where temperature was rehabiltated by NRLACQC, make note of it
c -------------------------------------------------------------------
            print 102, j,hdr(j,1),hdr(j,3),hdr(j,2),hdr(j,4),
     +                 nint(hdr(j,5)),c_qc(j)
  102 format(' TMP  rehabilitated: input rpt # ',i6,': id ',A8,', lat ',
     + f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,', NRLQMS "',
     + A11,'"')
            print 93
          endif
          print 65
   65     format(131('^'))
        endif
c -------------------------------------------------------------------------
c -------------------------------------------------------------------------

c Get ACFT_SEQ data
c -----------------
	acft_seq_accum(:,nlvinprof) = acft_seq(j,:)

c Get MSTQ
c --------
        mstq_accum(1,nlvinprof) = mstq(j)

c Get level category, elevation, reported observation time
c --------------------------------------------------------
        cat_accum(1,nlvinprof)  = cat(j)
        elv_accum(1,nlvinprof)  = hdr(j,5)
        rpt_accum(1,nlvinprof)  = hdr(j,12)
        rct_accum(1,nlvinprof)  = rct(j)

c Check for mandatory levels (CAT = 1), present temperatures (CAT = 2), missing temperatures
c  (CAT = 3)

        if(ob_t(j).eq.-9999.) then ! temperature is missing
	  cat_accum(1,nlvinprof) = 3
	else
	  cat_accum(1,nlvinprof) = 2
	endif

c Mandatory level can override other CAT settings

	do k = 1,maxmandlvls
	  if(lvlsinprof(nlvinprof).eq.mandlvls(k)) then
	    cat_accum(1,nlvinprof) = 1
	    exit ! exit do loop
	  endif
	enddo 

c Get NRLACQC quality string for this ob in the profile
c -----------------------------------------------------
	c_qc_accum(nlvinprof) = c_qc(j)

c ----------------------------------------------------------
c Get moisture events, background data, analysis, climo data
c ----------------------------------------------------------

c Store non-NRLACQC events in the "profile" arrays before adding any new events (done later
c  in subroutine sub2mem_mer)
c -----------------------------------------------------------------------------------------
        qevn_accum(1,nlvinprof,1:nevents(j,2))= qob_ev(j,1:nevents(j,2))
        qevn_accum(2,nlvinprof,1:nevents(j,2))= qqm_ev(j,1:nevents(j,2))
        qevn_accum(3,nlvinprof,1:nevents(j,2))= qpc_ev(j,1:nevents(j,2))
        qevn_accum(4,nlvinprof,1:nevents(j,2))= qrc_ev(j,1:nevents(j,2))

c Background info
c ---------------
        qbg_accum(:,nlvinprof) = qbg(j,:) ! single-level upon input

c Post processing info
c --------------------
        qpp_accum(:,nlvinprof) = qpp(j,:) ! single-level upon input

c -------------------------------------------------------------
c Get temperature events, background data, analysis, climo data
c -------------------------------------------------------------

c Store non-NRLACQC events in the "profile" arrays before adding any new events (done later
c  in subroutine sub2mem_mer)
c -----------------------------------------------------------------------------------------
        tevn_accum(1,nlvinprof,1:nevents(j,3))= tob_ev(j,1:nevents(j,3))
        tevn_accum(2,nlvinprof,1:nevents(j,3))= tqm_ev(j,1:nevents(j,3))
        tevn_accum(3,nlvinprof,1:nevents(j,3))= tpc_ev(j,1:nevents(j,3))
        tevn_accum(4,nlvinprof,1:nevents(j,3))= trc_ev(j,1:nevents(j,3))

c Background info
c ---------------
        tbg_accum(:,nlvinprof) = tbg(j,:) ! single-level upon input

c Post processing info
c --------------------
        tpp_accum(:,nlvinprof) = tpp(j,:) ! single-level upon input

c -----------------------------------------------------------------------
c Get wind (u/v components) events, background data, analysis, climo data
c -----------------------------------------------------------------------

c Store non-NRLACQC events in the "profile" arrays before adding any new events (done later
c  in subroutine sub2mem_mer)
c -----------------------------------------------------------------------------------------
        wuvevn_accum(1,nlvinprof,1:nevents(j,5)) =
     +  uob_ev(j,1:nevents(j,5))
        wuvevn_accum(2,nlvinprof,1:nevents(j,5)) =
     +   vob_ev(j,1:nevents(j,5))
        wuvevn_accum(3,nlvinprof,1:nevents(j,5)) =
     +   wqm_ev(j,1:nevents(j,5))
        wuvevn_accum(4,nlvinprof,1:nevents(j,5)) =
     +   wpc_ev(j,1:nevents(j,5))
        wuvevn_accum(5,nlvinprof,1:nevents(j,5)) =
     +   wrc_ev(j,1:nevents(j,5))

c Background info
c ---------------
        wuvbg_accum(:,nlvinprof) = wbg(j,:) ! single-level upon input

c Post Processing info
c --------------------
        wuvpp_accum(:,nlvinprof) = wpp(j,:) ! single-level upon input

c ---------------------------
c Get wind (dir/speed) events
c ---------------------------
        wdsevn_accum(1,nlvinprof,1:nevents(j,6)) =
     +   ddo_ev(j,1:nevents(j,6))
        wdsevn_accum(2,nlvinprof,1:nevents(j,6)) =
     +   ffo_ev(j,1:nevents(j,6))
        wdsevn_accum(3,nlvinprof,1:nevents(j,6)) =
     +   dfq_ev(j,1:nevents(j,6))
        wdsevn_accum(4,nlvinprof,1:nevents(j,6)) =
     +   dfp_ev(j,1:nevents(j,6))
        wdsevn_accum(5,nlvinprof,1:nevents(j,6)) =
     +   dfr_ev(j,1:nevents(j,6))
     
c Set tail_prev, flt_prev, elv_prev, idt_prev for comparison to next report to see if we need
c  to start a new profile - also set idz_prev for possible gross check
c -------------------------------------------------------------------------------------------
        tail_prev = c_acftreg(j)
        flt_prev  = c_acftid(j)
        elv_prev  = ht_ft(j)
        idt_prev  = idt(j)
        idz_prev  = zob_ev(j,nevents(j,4))

c Close loops here
c ----------------
      enddo loop1 ! i=1,nrpts4QC_pre 

      if(l_prof1lvl.or.nlvinprof.gt.1) then

c Close out last remaining profile and write it to output - open message if necessary
c -----------------------------------------------------------------------------------
        call openmb(proflun,msgtyp2wrt,icdtg_an)

c Store contents of the current observation (profile or single/flight-level) into BUFRLIB
c  memory via subroutine sub2mem_mer
c ---------------------------------------------------------------------------------------

ccccc     print 4079, sortidx(i-1),acid(sortidx(i-1)),acid_last_profile
c4079     format(1x,'2-call sub2mem_mer, last report j-1 = ',i6,
ccccc+     ', acid(j-1) = ',a8,', acid_last_profile = ',a8)

        call sub2mem_mer(proflun,bmiss,mxlv,mxnmev,maxmandlvls,mandlvls,
     +                   msgtyp2wrt,hdr2wrt,
     +	                 acid_last_profile, ! use ACID of last (or only) report in profile
     +	                 c_acftid_last_profile, ! use aircraft flight # (from NRLACQC) of
                                                ! last (or only) report in profile
     +                   c_acftreg_last_profile,! use aircraft tail # (from NRLACQC) of last
                                                ! (or only) report in profile
     +                   rct_accum,drinfo_accum,acft_seq_accum,
     +                   mstq_accum,cat_accum,elv_accum,rpt_accum,
     +                   tcor_accum,
     +                   pevn_accum,pbg_accum,ppp_accum,
     +                   qevn_accum,qbg_accum,qpp_accum,
     +                   tevn_accum,tbg_accum,tpp_accum,
     +                   zevn_accum,zbg_accum,zpp_accum,
     +                   wuvevn_accum,wuvbg_accum,wuvpp_accum,
     +                   wdsevn_accum,mxe4prof,c_qc_accum,
     +                   num_events_prof,lvlsinprof,nlvinprof,
     +                   nrlacqc_pc,l_mandlvl,tsplines,
     +                   l_operational,lwr)

c Write the current profile to output
c -----------------------------------
        if(hdr2wrt(6).gt.399.or.l_prof1lvl) then  ! sometimes reports with nlvinprof > 1
                                                  !  still come back as single-level reports
                                                  !  - this check keeps them out of PREPBUFR-
                                                  !  like file when when l_prof1lvl=F
          nprofiles_encoded = nprofiles_encoded + 1
          call writsb(proflun)
        endif
      endif

      if(.not.l_operational) close(52)

c Output counts
c -------------

c Detailed counts of reports eliminated from final PREPBUFR-like file
c -------------------------------------------------------------------
      print *
      print *, '----------------------------------------------------'
      print *, 'Info about merged aircraft reports not encoded into '
      print *, 'output PREPBUFR-like (profiles) file:'
      print *, '----------------------------------------------------'
      print *
      if(l_otw) then
        print 76, trad,elim_knt(1)
   76 format(' Number of merged reports tossed because outside req. ',
     +       'time window radius of',F6.2,'hrs (prior to geographical ',
     +       'domain checking):',i6/)
      else
        print *, 'Time window radius check NOT performed, l_otw=',l_otw,
     +           ' (ZERO reports tossed)'
      endif
      print *
      if(l_nhonly) then
        print'(" Number of merged reports passing time window radius ",
     +         "chk but tossed because outside geographical domain ",
     +         "(i.e., S of 20S lat): ",I0)', elim_knt(2)
      else
        print *, 'Geographical domain check not performed, l_nhonly=',
     +           l_nhonly,' (ZERO reports tossed)'
      endif
      print *
      print *, 'Number of merged reports passing checks and kept: ',
     +         elim_knt(3)
      print *

c Info about PREPBUFR-like files containing merged profile and (maybe) single(flight)-level
c  reports
c -----------------------------------------------------------------------------------------
      print *
      print'(" -------------------------------------------------------",
     +       "-------------------------")'
      print'(" Info about QMs applied to merged mass and wind reports",
     +       " in the PREPBUFR-like file")'
      print'(" -------------------------------------------------------",
     +       "-------------------------")'
      print *
      print'(" Number of merged ""profile"" reports written to output ",
     +       "PREPBUFR-like file = "I0)', nprofiles_encoded
      print *
! DAK: num_events_prof does not seem to be the right number when single level reports are not
!      encoded...
      print'(" Total number of events for an ob type, across all ",
     +       "levels, across all reports, written to output PREPBUFR-",
     +       "like")'
      print'("  (profiles) file = ",I0," (this value is the same for ",
     +       "each ob type)")',  num_events_prof
      print *

      write(*,*)
      write(*,*) '**************************'
      write(*,*) 'output_acqc_prof has ended'
      call system('date')
      write(*,*) '**************************'
      write(*,*)

      return

      end

program ukmhires                                        

!-----------------------------------------------------------------
!  Merges ukm hires data in 8 regional patches into one global array
!   Data Source: /dcom/us007003/yyyymmdd/wgrbbul/ukmet_hires
!  Use bi-linear interpolation to create a 1-deg global dataset.
! Fanglin Yang, June 2014
!-----------------------------------------------------------------

!--------------------------------------
!---input data info
!--------------------------------------
integer, parameter :: np=8                          !number of patches
integer, parameter :: nx=108                        !number of longtudinal points for each patch       
integer, parameter :: ny=162                        !number of latitudinal points for each patch       
integer, parameter :: nxny=nx*ny                    !total points for each patch         
integer, parameter :: mmax=200000                   !maximum number of points to unpack 
real,  parameter :: resy=556.0, resx=833.0        !data resolution (x1000)

logical*1     :: lb(mmax)
character*200 :: input,output    
integer       :: iargc
external      :: iargc
integer       :: nargs       ! number of command-line arguments
character*200 :: argument    ! space for command-line argument
integer       :: jpds(200),jgds(200), fhr
integer       :: kpds(200),kgds(200)

real :: varp(mmax,np)                               !data from each patch                
real :: var(nx*4+1,ny*2)                            !a global high-res array             
real :: xs(np), xe(np), ys(np), ye(np)              !starting and ending lat-lon of patches
real :: lon(nx*4+1),lat(ny*2)                       !lat-lon positions                     

!--------------------------------------
!---output data, 1x1 deg global      
!--------------------------------------
real, parameter    :: resg=1000.0
integer, parameter :: mx=360000/resg,my=180000/resg+1                        
integer, parameter :: mxmy=mx*my                  
real             :: varg(mx,my),varg1(mx*my)             
real             :: long(mx),latg(my)        
real             :: dy1(my),dy2(my),dx1(mx),dx2(mx)
integer          :: ix(mx),iy(my)
real             :: tmp1,tmp2,sums,sumn

!-------------------------------------------------------------------------------------
!--starting and ending lat and lon of each patch (x1000)
data xs/341250,  71250, 161250, 251250, 341250,  71250, 161250, 251250/
data xe/ 70416, 160416, 250416, 340416,  70416, 160416, 250416, 340416/
data ys/   279,    279,    279,    279, -89721, -89721, -89721, -89721/
data ye/ 89722,  89722,  89722,  89722,   -278,   -278,   -278,   -278/

!---source data position
do n=1,4
  i0=(n-1)*nx
 do i=i0+1,i0+nx
  lon(i)=xs(n)+resx*(i-i0-1)
  if(lon(i).gt.360000) lon(i)=lon(i)-360000
 enddo
!!print*,n,xe(n),lon(i0+nx)
enddo
lon(4*nx+1)=lon(1)
do j=1,ny        
  lat(j)=ys(5)+resy*(j-1)    !southern hemisphere
enddo
do j=ny+1,ny*2        
  lat(j)=ys(1)+resy*(j-ny-1) !northern hemisphere
enddo

!---output data position
do i=1,mx
 long(i)=(i-1)*resg
enddo
do j=1,my
 latg(j)=-90000.0+(j-1)*resg
enddo

!---temporary arrays used for linear interpolation
do j=1,my
do jj=1,2*ny-1
 if(latg(j).ge.lat(jj).and.latg(j).lt.lat(jj+1)) then
  dy1(j)=latg(j)-lat(jj)
  dy2(j)=lat(jj+1)-latg(j)
  iy(j)=jj
 endif
enddo
enddo

!special case at 0E
i=1; ii=23; ix(i)=23
dx1(i)=360000.0-lon(ii)
dx2(i)=lon(ii+1)

do i=2,mx
do ii=1,4*nx
 if(long(i).ge.lon(ii).and.long(i).lt.lon(ii+1)) then
  dx1(i)=long(i)-lon(ii)
  dx2(i)=lon(ii+1)-long(i)
  ix(i)=ii
 endif
enddo
enddo
!-----------------------------------------------------

 
 nargs = iargc()              !  iargc() - number of arguments
 if (nargs.lt.3) then
   write(*,*)'usage : ukm_hires_merge.x input output fcst_hour'
   stop
 endif
 call getarg(1,argument)      
 read(argument,*) input      
 call getarg(2,argument)      
 read(argument,*) output      
 call getarg(3,argument)      
 read(argument,*) fhr         
 print*, trim(input)," ",trim(output), " fcst hour=",fhr
 fhrm6=fhr-6
 fhrm12=fhr-12

 call baopenr(10,trim(input),iret)
 if (iret .ne. 0) write(6,*)" failed to open ", input
 call baopen(20,trim(output),iret)
 if (iret .ne. 0) write(6,*)" failed to open ", output  
 if (iret .ne. 0) goto 200    

nrec=-1
10 continue
   jpds=-1; jgds=-1
do n=1,np
     jgds(2)=nx; jgds(3)=ny; jgds(9)=resx; jgds(10)=resy 
     jgds(4)=ys(n); jgds(5)=xs(n); jgds(7)=ye(n); jgds(8)=xe(n)
     call getgb(10,0,mmax,nrec,jpds,jgds,kf,k,kpds,kgds,lb,varp(1,n),iret)
     if(iret.ne.0) goto 100   !reached end of record or incorrect file 

!     write(1,*)
!      write(1,'("patch=",i3," iret=",i2," irec=",i10," nxny=",i10)') n,iret,k,kf
!      write(1,'("jpds=",16i8)') (jpds(k),k=1,16)
!      write(1,'("kpds=",16i8)') (kpds(k),k=1,16)
!      write(1,'("jgds=",16i8)') (jgds(k),k=1,16)
!      write(1,'("kgds=",16i8)') (kgds(k),k=1,16)
     
!--look for the same variable in different patches and for the same forecast time
     do k=1,16
      jpds(k)=kpds(k)
     enddo
nrec=nrec-1
enddo

!---assemble a global arrary for right forecast hour 
!-- for precipitation APCP, jpds(15)=fhr
if((jpds(14).eq.fhr) .or. (jpds(5).eq.61 .and. jpds(15).eq.fhr) ) then
 do n=1,4     !patches in northern hemisphere
  do j=1,ny  
  do i=1,nx
   jj=ny+j        
   ii=(n-1)*nx+i
   var(ii,jj)=varp((j-1)*nx+i,n)
  enddo
  enddo
 enddo
 do n=5,8     !patches in southern hemisphere
  do j=1,ny  
  do i=1,nx
   jj=j        
   ii=(n-5)*nx+i
   var(ii,jj)=varp((j-1)*nx+i,n)
  enddo
  enddo
 enddo
 do jj=1,2*ny
  var(4*nx+1,jj)=var(1,jj)
 enddo

!--interpolate to resg-deg global array
!--for north pole and south pole
 sums=0.0; sumn=0.0
 do i=1,4*nx
  sums=sums+var(i,1)
  sumn=sumn+var(i,2*ny)
 enddo
 do i=1,mx
  varg(i,1)=sums/(4*nx)         
  varg(i,my)=sumn/(4*nx)         
 enddo

!--for other points               
 do j=2,my-1
 do i=1,mx
  tmp1=(var(ix(i),iy(j))*dy2(j)+var(ix(i),iy(j)+1)*dy1(j))/(dy1(j)+dy2(j))
  tmp2=(var(ix(i)+1,iy(j))*dy2(j)+var(ix(i)+1,iy(j)+1)*dy1(j))/(dy1(j)+dy2(j))
  varg(i,j)=(tmp1*dx2(i)+tmp2*dx1(i))/(dx1(i)+dx2(i))
 enddo
 enddo
 
 do j=1,my
 do i=1,mx
  varg1((j-1)*mx+i)=varg(i,j)
 enddo
 enddo

!--write out grib1 global array
     kgds(2)=mx; kgds(3)=my; kgds(9)=resg; kgds(10)=resg 
     kgds(4)=-90000; kgds(5)=0; kgds(7)=90000; kgds(8)=(mx-1)*resg
     call putgb(20,mxmy,kpds,kgds,lb,varg1,iret)
endif

goto 10

100  call baclose(10,iret)
     call baclose(20,iret)

200  end

!
!                                **********************************************
!                                *             MODULE pmat2                   *
!                                *  R. J. Purser, NOAA/NCEP/EMC  1994/1999    *
!                                *  jim.purser@noaa.gov                       *
!                                *  Tsukasa Fujita (JMA)             1999     *
!                                *                                            *
!                                **********************************************
!
! Routines dealing with the operations of banded matrices
! The three special routines allow the construction of compact or
! conventional interpolation and differencing stencils to a general
! order of accuracy. These are:
! AVCO:  Averaging, or interpolating;
! DFCO:  Differentiating (once);
! DFCO2: Differentiating (twice).
!
! Other routines provide the tools for applying compact schemes, and for
! the construction and application of recursive filters.
!
! Programmers:  R. J. Purser and T. Fujita
!               National Centers for Environmental Prediction.
! Last modified (Purser):                              January 6th 2005
!  added nonredundant ldltb and ltdlbv routines for symmetric matrices,
!  and remove obsolescent routines.
!  Keyser (2014-12-12) - print written to unit 41 rather than stdout (for use in
!                        prepobs_prepacqc program - limits amount of stdout)
!
! DIRECT DEPENDENCIES
! Libraries[their modules]: pmat[pmat]
! Additional Modules      : pkind
!
!=============================================================================
module pmat2
!============================================================================
use    pkind
implicit none
private
public:: avco,dfco,dfco2, clipb,cad1b,csb1b,cad2b,csb2b,                    &
         ldub,ldltb,udlb,l1ubb,l1ueb,ltdlbv,                                &
         udlbv,udlbx,udlby,udlvb,udlxb,udlyb,u1lbv,u1lbx,u1lby,u1lvb,u1lxb, &
         u1lyb,linbv,wrtb
real(dp),parameter:: zero=0

interface AVCO;   module procedure AVCO,  DAVCO,  TAVCO;   end interface
interface DFCO;   module procedure DFCO,  DDFCO,  TDFCO;   end interface
interface DFCO2;  module procedure DFCO2, DDFCO2, TDFCO2;  end interface
interface CLIPB;  module procedure clib,  clib_d, clib_c;  end interface
interface CAD1B;  module procedure CAD1B;                  end interface
interface CSB1B;  module procedure CSB1B;                  end interface
interface CAD2B;  module procedure CAD2B;                  end interface
interface CSB2B;  module procedure CSB2B;                  end interface
interface LDUB;   module procedure LDUB,  DLDUB;           end interface
interface LDLTB;  module procedure LDLTB, DLDLTB;          end interface
interface L1UBB;  module procedure L1UBB, DL1UBB;          end interface
interface L1UEB;  module procedure L1UEB, DL1UEB;          end interface
interface ltDLBV; module procedure ltdlbv,dltdlbv;         end interface
interface UDLB;   module procedure UDLB,  DUDLB;           end interface
interface UDLBV;  module procedure UDLBV, dudlbv;          end interface
interface UDLBX;  module procedure UDLBX;                  end interface
interface UDLBY;  module procedure UDLBY;                  end interface
interface UDLVB;  module procedure UDLVB;                  end interface
interface UDLXB;  module procedure UDLXB;                  end interface
interface UDLYB;  module procedure UDLYB;                  end interface
interface U1LBV;  module procedure U1LBV;                  end interface
interface U1LBX;  module procedure U1LBX;                  end interface
interface U1LBY;  module procedure U1LBY;                  end interface
interface U1LVB;  module procedure U1LVB;                  end interface
interface U1LXB;  module procedure U1LXB;                  end interface
interface U1LYB;  module procedure U1LYB;                  end interface
interface LINBV;  module procedure LINBV;                  end interface
interface WRTB;   module procedure WRTB;                   end interface
contains

!=============================================================================
subroutine AVCO(na,nb,za,zb,z0,a,b) !                                   [AVCO]
!=============================================================================
!		    SUBROUTINE AVCO
!   R.J.Purser, National Centers for Environmental Prediction, Washington D.C.
!   jim.purser@noaa.gov					      1999
!
!  Compute one row of the coefficients for the compact mid-interval
!  interpolation scheme characterized by matrix equation of the form,
!			 A.t = B.s			       (*)
!  Where s is the vector of "source" values, t the staggered "target" values.
!
! --> NA:   number of t-points operated on by this row of the A of (*)
! --> NB:   number of s-points operated on by this row of the B of (*)
! --> ZA:   coordinates of t-points used in this row of (*)
! --> ZB:   coordinates of s-points used in this row of (*)
! --> Z0:   nominal point of application of this row of (*)
! <-- A:    the NA coefficients A for this scheme
! <-- B:    the NB coefficients B for this scheme
!=============================================================================
use pmat, only: inv
integer, intent(IN )        :: na,nb
real,    intent(IN )        :: za(na),zb(nb),z0
real,    intent(OUT)        :: a(na),b(nb)
!-----------------------------------------------------------------------------
integer                     :: na1,nab,i
real, dimension(na+nb,na+nb):: w
real, dimension(na)         :: za0,pa
real, dimension(nb)         :: zb0,pb
real, dimension(na+nb)      :: ab
!=============================================================================
na1=na+1; nab=na+nb
za0=za-z0; zb0=zb-z0
pa=1.;     pb=-1.
w=0.;         ab=0.
w(1,1:na)=1.; ab(1)=1.
do i=2,nab; w(i,1:na)=pa;    pa=pa*za0; w(i,na1:nab)=pb; pb=pb*zb0; enddo
call INV(w,ab)
a=ab(1:na); b=ab(na1:nab)
end subroutine AVCO 
!=============================================================================
subroutine DAVCO(na,nb,za,zb,z0,a,b) !                                  [AVCO]
!=============================================================================
use pmat, only: inv
integer,  intent(IN )          :: na,nb
real(dp), intent(IN )          :: za(na),zb(nb),z0
real(dp), intent(OUT)          :: a(na),b(nb)
!-----------------------------------------------------------------------------
integer                        :: na1,nab,i
real(dp),dimension(na+nb,na+nb):: w
real(dp),dimension(na)         :: za0,pa
real(dp),dimension(nb)         :: zb0,pb
real(dp),dimension(na+nb)      :: ab
!=============================================================================
na1=na+1; nab=na+nb
za0=za-z0; zb0=zb-z0
pa=1.;     pb=-1.
w=0.;         ab=0.
w(1,1:na)=1.; ab(1)=1.
do i=2,nab; w(i,1:na)=pa;    pa=pa*za0; w(i,na1:nab)=pb; pb=pb*zb0; enddo
call INV(w,ab)
a=ab(1:na); b=ab(na1:nab)
end subroutine DAVCO
!=============================================================================
subroutine TAVCO(xa,xb,a,b)!                                            [AVCO]
!=============================================================================
real(dp),dimension(:),intent(IN ):: xa,xb
real(dp),dimension(:),intent(OUT):: a,b
!-----------------------------------------------------------------------------
integer:: na,nb
!=============================================================================
na=size(xa); if(na /= size(a))stop 'In tavco; sizes of a and xa different'
nb=size(xb); if(nb /= size(b))stop 'In tavco; sizes of b and xb different'
call DAVCO(na,nb,xa,xb,zero,a,b)
end subroutine TAVCO

!=============================================================================
subroutine DFCO(na,nb,za,zb,z0,a,b)!                                    [DFCO]
!=============================================================================
!   R.J.Purser, National Centers for Environmental Prediction, Washington D.C.
!   jim.purser@noaa.gov					      1999
!		    SUBROUTINE DFCO
!
!  Compute one row of the coefficients for either the compact differencing or
!  quadrature scheme characterized by matrix equation of the form,
!			 A.d = B.c			       (*)
!  In either case, d is the derivative of c.
!
! --> NA:   number of d-points operated on by this row of the A of (*)
! --> NB:   number of c-points operated on by this row of the B of (*)
! --> ZA:   coordinates of d-points used in this row of (*)
! --> ZB:   coordinates of c-points used in this row of (*)
! --> Z0:   nominal point of application of this row of (*)
! <-- A:    the A-coefficients for this scheme
! <-- B:    the B-coefficients for this scheme
!=============================================================================
use pmat, only: inv
integer, intent(IN )        :: na,nb
real,    intent(IN )        :: za(na),zb(nb),z0
real,    intent(OUT)        :: a(na),b(nb)
!-----------------------------------------------------------------------------
integer:: na1,nab,i
real, dimension(na+nb,na+nb):: w
real, dimension(na)         :: za0,pa
real, dimension(nb)         :: zb0,pb
real, dimension(na+nb)      :: ab
!=============================================================================
na1=na+1; nab=na+nb
za0=za-z0; zb0=zb-z0
pa=1.;     pb=-1.
w=0.;         ab=0.
w(1,1:na)=1.; ab(1)=1.
do i=3,nab; w(i,1:na)   =pa*(i-2); pa=pa*za0; enddo
do i=2,nab; w(i,na1:nab)=pb;       pb=pb*zb0; enddo
call INV(w,ab)
a=ab(1:na); b=ab(na1:nab)
end subroutine DFCO 
!=============================================================================
subroutine DDFCO(na,nb,za,zb,z0,a,b) ! Real(dp) version of              [DFCO]
!=============================================================================
use pmat, only: inv
integer,  intent(IN)            :: na,nb
real(dp), intent(IN)            :: za(na),zb(nb),z0
real(dp), intent(OUT)           :: a(na),b(nb)
!-----------------------------------------------------------------------------
integer                         :: na1,nab,i
real(dp), dimension(na+nb,na+nb):: w
real(dp), dimension(na)         :: za0,pa
real(dp), dimension(nb)         :: zb0,pb
real(dp), dimension(na+nb)      :: ab
!=============================================================================
na1=na+1; nab=na+nb
za0=za-z0; zb0=zb-z0
pa=1.;     pb=-1.
w=0.;         ab=0.
w(1,1:na)=1.; ab(1)=1.
do i=3,nab; w(i,1:na)   =pa*(i-2); pa=pa*za0; enddo
do i=2,nab; w(i,na1:nab)=pb;       pb=pb*zb0; enddo
call INV(w,ab)
a=ab(1:na); b=ab(na1:nab)
end subroutine DDFCO 
!=============================================================================
subroutine TDFCO(xa,xb,a,b)!                                            [DFCO]
!=============================================================================
real(dp),dimension(:),intent(IN ):: xa,xb
real(dp),dimension(:),intent(OUT):: a,b
!-----------------------------------------------------------------------------
integer:: na,nb
!=============================================================================
na=size(xa); if(na /= size(a))stop 'In tdfco; sizes of a and xa different'
nb=size(xb); if(nb /= size(b))stop 'In tdfco; sizes of b and xb different'
call DDFCO(na,nb,xa,xb,zero,a,b)
end subroutine TDFCO


!=============================================================================
subroutine DFCO2(na,nb,za,zb,z0,a,b)!                                  [DFCO2] 
!=============================================================================
!		    SUBROUTINE DFCO2
!   R.J.Purser, National Centers for Environmental Prediction, Washington D.C.
!   jim.purser@noaa.gov					      1999
!
!  Compute one row of the coefficients for either the compact second-
!  differencing scheme characterized by matrix equation of the form,
!			 A.d = B.c			       (*)
!  Where d is the second-derivative of c.
!
! --> NA:   number of d-points operated on by this row of the A of (*)
! --> NB:   number of c-points operated on by this row of the B of (*)
! --> ZA:   coordinates of d-points used in this row of (*)
! --> ZB:   coordinates of c-points used in this row of (*)
! --> Z0:   nominal point of application of this row of (*)
! <-- A:    the NA coefficients A for this scheme
! <-- B:    the NB coefficients B for this scheme
!=============================================================================
use pmat, only: inv
integer, intent(IN )        :: na,nb
real,    intent(IN )        :: za(na),zb(nb),z0
real,    intent(OUT)        :: a(na),b(nb)
!-----------------------------------------------------------------------------
integer:: na1,nab,i
real, dimension(na+nb,na+nb):: w
real, dimension(na)         :: za0,pa
real, dimension(nb)         :: zb0,pb
real, dimension(na+nb)      :: ab
!=============================================================================
na1=na+1; nab=na+nb
za0=za-z0; zb0=zb-z0
pa=1.;     pb=-1.
w=0.;         ab=0.
w(1,1:na)=1.; ab(1)=1.
do i=4,nab; w(i,1:na)   =pa*(i-2)*(i-3); pa=pa*za0; enddo
do i=2,nab; w(i,na1:nab)=pb;             pb=pb*zb0; enddo
call INV(w,ab)
a=ab(1:na); b=ab(na1:nab)
end subroutine DFCO2 
!=============================================================================
subroutine DDFCO2(na,nb,za,zb,z0,a,b) ! Real(dp) version of            [DFCO2]
!=============================================================================
use pmat, only: inv
integer,  intent(IN )           :: na,nb
real(dp), intent(IN )           :: za(na),zb(nb),z0
real(dp), intent(OUT)           :: a(na),b(nb)
!-----------------------------------------------------------------------------
integer                         :: na1,nab,i
real(dp), dimension(na+nb,na+nb):: w
real(dp), dimension(na)         :: za0,pa
real(dp), dimension(nb)         :: zb0,pb
real(dp), dimension(na+nb)      :: ab
!=============================================================================
na1=na+1; nab=na+nb
za0=za-z0; zb0=zb-z0
pa=1.;     pb=-1.
w=0.;         ab=0.
w(1,1:na)=1.; ab(1)=1.
do i=4,nab; w(i,1:na)   =pa*(i-2)*(i-3); pa=pa*za0; enddo
do i=2,nab; w(i,na1:nab)=pb;             pb=pb*zb0; enddo
call INV(w,ab)
a=ab(1:na); b=ab(na1:nab)
end subroutine ddfco2 
!=============================================================================
subroutine TDFCO2(xa,xb,a,b)!                                          [DFCO2]
!=============================================================================
real(dp),dimension(:),intent(IN ):: xa,xb
real(dp),dimension(:),intent(OUT):: a,b
!-----------------------------------------------------------------------------
integer:: na,nb
!=============================================================================
na=size(xa); if(na /= size(a))stop 'In tdfco2; sizes of a and xa different'
nb=size(xb); if(nb /= size(b))stop 'In tdfco2; sizes of b and xb different'
call DDFCO2(na,nb,xa,xb,zero,a,b)
end subroutine TDFCO2


!=============================================================================
pure subroutine CLIB(m1,m2,mah1,mah2,a)!                               [CLIPB]
!=============================================================================
integer, intent(IN   ) :: m1, m2, mah1, mah2
real,    intent(INOUT) :: a(m1,-mah1:mah2)
integer                :: j
do j=1,mah1; a(1:min(m1,j),-j)=0.; enddo
do j=m2-m1+1,mah2; a(max(1,m2-j+1):m1,j)=0.; enddo
end subroutine CLIB
!=============================================================================
pure subroutine clib_d(m1,m2,mah1,mah2,a)!                             [CLIPB]
!=============================================================================
integer,  intent(IN   ) :: m1, m2, mah1, mah2
real(dp), intent(INOUT) :: a(m1,-mah1:mah2)
integer                 :: j
do j=1,mah1; a(1:min(m1,j),-j)=0; enddo
do j=m2-m1+1,mah2; a(max(1,m2-j+1):m1,j)=0; enddo
end subroutine clib_d
!=============================================================================
pure subroutine clib_c(m1,m2,mah1,mah2,a)!                              [CLIPB]
!=============================================================================
integer,  intent(IN   ) :: m1, m2, mah1, mah2
complex(dpc), intent(INOUT) :: a(m1,-mah1:mah2)
integer                 :: j
do j=1,mah1; a(1:min(m1,j),-j)=0; enddo
do j=m2-m1+1,mah2; a(max(1,m2-j+1):m1,j)=0; enddo
end subroutine clib_c

!=============================================================================
subroutine CAD1B(m1,mah1,mah2,mirror2,a)!                              [CAD1B]
!=============================================================================
! Incorporate operand symmetry near end-1 of a band matrix operator
!
! <-> A:      Input as unclipped operator, output as symmetrized and clipped.
! m1, m2:     Sizes of implied full matrix
! mah1, mah2: Left and right semi-bandwidths of A.
! mirror2:    2*location of symmetry axis relative to end-1 operand element.
!      Note: although m2 is not used here, it IS used in companion routines
!            cad2b and csb2b; it is retained in the interests of uniformity.
!=============================================================================
integer,  intent(IN   ):: m1,mah1,mah2,mirror2
real,     intent(INOUT):: a(0:m1-1,-mah1:mah2)
!-----------------------------------------------------------------------------
integer                :: i,i2,jm,jp,jpmax
!=============================================================================
if(mirror2+mah1 > mah2)stop 'In CAD1B; mah2 insufficient'
do i=0,m1-1; i2=i*2; jpmax=mirror2+mah1-i2; if(jpmax <= -mah1)exit
   do jm=-mah1,mah2; jp=mirror2-jm-i2; if(jp <= jm)exit
      a(i,jp)=a(i,jp)+a(i,jm) ! Reflect and add
      a(i,jm)=0.              ! zero the exterior part
   enddo
enddo
end subroutine CAD1B

!=============================================================================
subroutine CSB1B(m1,mah1,mah2,mirror2,a)!                              [CSB1B]
!=============================================================================
! Like cad1b, but for antisymmetric operand
!=============================================================================
integer,  intent(IN   ):: m1,mah1,mah2,mirror2
real,     intent(INOUT):: a(0:m1-1,-mah1:mah2)
!-----------------------------------------------------------------------------
integer                :: i,i2,jm,jp,jpmax
!=============================================================================
if(mirror2+mah1 > mah2)stop 'In CSB1B; mah2 insufficient'
do i=0,m1-1; i2=i*2; jpmax=mirror2+mah1-i2; if(jpmax < -mah1)exit
   do jm=-mah1,mah2; jp=mirror2-jm-i2; if(jp < jm)exit
      a(i,jp)=a(i,jp)-a(i,jm) ! Reflect and subtract
      a(i,jm)=0.              ! zero the exterior part
   enddo
enddo
end subroutine CSB1B

!=============================================================================
subroutine CAD2B(m1,m2,mah1,mah2,mirror2,a)!                           [CAD2B]
!=============================================================================
! Incorporate operand symmetry near end-2 of a band matrix operator
!
! <-> A:      Input as unclipped operator, output as symmetrized and clipped.
! m1, m2:     Sizes of implied full matrix
! mah1, mah2: Left and right semi-bandwidths of A.
! mirror2:    2*location of symmetry axis relative to end-2 operand element.
!=============================================================================
integer,  intent(IN   ):: m1,m2,mah1,mah2,mirror2
real,     intent(INOUT):: a(1-m1:0,m1-m2-mah1:m1-m2+mah2)
!-----------------------------------------------------------------------------
integer                :: i,i2,jm,jp,jmmin,nah1,nah2
!=============================================================================
nah1=mah1+m2-m1; nah2=mah2+m1-m2 ! Effective 2nd-index bounds of A
if(mirror2-nah1 > -nah2)stop 'In CAD2B; mah1 insufficient'
do i=0,1-m1,-1; i2=i*2; jmmin=mirror2-nah2-i2; if(jmmin >= nah2)exit
   do jp=nah2,nah1,-1; jm=mirror2-jp-i2; if(jm >= jp)exit
      a(i,jm)=a(i,jm)+a(i,jp) ! Reflect and add
      a(i,jp)=0.              ! zero the exterior part
   enddo
enddo
end subroutine CAD2B

!=============================================================================
subroutine CSB2B(m1,m2,mah1,mah2,mirror2,a)!                           [CSB2B]
!=============================================================================
integer,  intent(IN   ):: m1,m2,mah1,mah2,mirror2
real,     intent(INOUT):: a(1-m1:0,m1-m2-mah1:m1-m2+mah2)
!-----------------------------------------------------------------------------
integer                :: i,i2,jm,jp,jmmin,nah1,nah2
!=============================================================================
nah1=mah1+m2-m1; nah2=mah2+m1-m2 ! Effective 2nd-index bounds of A
if(mirror2-nah1 > -nah2)stop 'In CSB2B; mah1 insufficient'
do i=0,1-m1,-1; i2=i*2; jmmin=mirror2-nah2-i2; if(jmmin > nah2)exit
   do jp=nah2,nah1,-1; jm=mirror2-jp-i2; if(jm > jp)exit
      a(i,jm)=a(i,jm)-a(i,jp) ! Reflect and subtract
      a(i,jp)=0.              ! zero the exterior part
   enddo
enddo
end subroutine CSB2B

!=============================================================================
!SUBROUTINE CEX2B(a,m1,m2,mah1,mah2,mirror2)
!=============================================================================
!INTEGER,  INTENT(IN)   :: m1,m2,mah1,mah2,mirror2
!REAL,     INTENT(INOUT):: a(1-m1:0,m1-m2-mah1:m1-m2+mah2)
!-----------------------------------------------------------------------------
!INTEGER                :: i,i2,jm,jp,jmmin,nah1,nah2,mirror,j0
!=============================================================================
!nah1=mah1+m2-m1; nah2=mah2+m1-m2 ! Effective 2nd-index bounds of A
!IF(mirror2-nah1 > -nah2)STOP 'In CEX2B; mah1 insufficient'
!mirror=mirror2/2
!IF(mirror*2 /= mirror2)STOP 'In CEX2B; mirror2 is not even'
!DO i=0,1-m1,-1; i2=i*2; jmmin=mirror2-nah2-i2; IF(jmmin >= nah2)EXIT
!   j0=mirror-i
!   DO jp=nah2,nah1,-1; jm=mirror2-jp-i2; IF(jm >= jp)EXIT
!      a(i,jm)=a(i,jm)-a(i,jp)    ! Reflect and subtract
!      a(i,j0)=a(i,j0)+2.*a(i,jp) ! Apply double the coefficient to end
!      a(i,jp)=0.                 ! zero the exterior part
!   ENDDO
!ENDDO
!END SUBROUTINE CEX2B

!=============================================================================
subroutine LDUB(m,mah1,mah2,a)!                                         [LDUB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE LDUB
!  Compute [L]*[D**-1]*[U] decomposition of asymmetric band-matrix
!
! <-> A: input as the asymmetric band matrix. On output, it contains
!     the [L]*[D**-1]*[U] factorization of the input matrix, where
!     [L] is lower triangular with unit main diagonal
!     [D] is a diagonal matrix
!     [U] is upper triangular with unit main diagonal
! --> M:    The number of rows of array A
! --> MAH1: the left half-bandwidth of fortran array A
! --> MAH2: the right half-bandwidth of fortran array A
!=============================================================================
integer, intent(IN   ) :: m,mah1, mah2 
real,    intent(INOUT) :: a(m,-mah1:mah2) 
!-----------------------------------------------------------------------------
integer                :: j, imost, jmost, jp, i
real                   :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jmost=min(m,j+mah2)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0.)then
    write(41,'(" Failure in LDUB:"/" Matrix requires pivoting or is singular")')
    stop
  endif
  ajji=1./ajj
  a(j,0)=ajji
  do i=jp,imost
    aij=ajji*a(i,j-i)
    a(i,j-i)=aij
    a(i,jp-i:jmost-i)=a(i,jp-i:jmost-i)-aij*a(j,1:jmost-j)
  enddo
  a(j,1:jmost-j)=ajji*a(j,1:jmost-j)
enddo
end subroutine LDUB
!=============================================================================
subroutine DLDUB(m,mah1,mah2,a) ! Real(dp) version of                   [LDUB]
!=============================================================================
integer,   intent(IN   ) :: m,mah1, mah2 
real(dp),  intent(INOUT) :: a(m,-mah1:mah2) 
!-----------------------------------------------------------------------------
integer                  :: j, imost, jmost, jp, i
real(dp)                 :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jmost=min(m,j+mah2)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0)then
    write(41,'(" Fails in LDUB_d:"/" Matrix requires pivoting or is singular")')
    stop
  endif
  ajji=1./ajj
  a(j,0)=ajji
  do i=jp,imost
    aij=ajji*a(i,j-i)
    a(i,j-i)=aij
    a(i,jp-i:jmost-i)=a(i,jp-i:jmost-i)-aij*a(j,1:jmost-j)
  enddo
  a(j,1:jmost-j)=ajji*a(j,1:jmost-j)
enddo
end subroutine DLDUB

!=============================================================================
subroutine LDLTB(m,mah1,a) ! Real(sp) version of                       [LDLTB]
!=============================================================================
integer,   intent(IN   ) :: m,mah1
real(sp),  intent(INOUT) :: a(m,-mah1:0) 
!-----------------------------------------------------------------------------
integer                  :: j, imost, jp, i,k
real(sp)                 :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0)then
    write(41,'(" Fails in LDLTB:"/" Matrix requires pivoting or is singular")')
    stop
  endif
  ajji=1./ajj
  a(j,0)=ajji
  do i=jp,imost
    aij=a(i,j-i)
    a(i,j-i)=ajji*aij
    do k=jp,i
       a(i,k-i)=a(i,k-i)-aij*a(k,j-k)
    enddo
  enddo
enddo
end subroutine LDLTB
!=============================================================================
subroutine DLDLTB(m,mah1,a) ! Real(dp) version of                   [LDLTB]
!=============================================================================
integer,   intent(IN   ) :: m,mah1
real(dp),  intent(INOUT) :: a(m,-mah1:0) 
!-----------------------------------------------------------------------------
integer                  :: j, imost, jp, i,k
real(dp)                 :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0)then
    write(41,'(" Fails in LDLTB_d:"/" Matrix requires pivoting or is singular")')
    stop
  endif
  ajji=1./ajj
  a(j,0)=ajji
  do i=jp,imost
    aij=a(i,j-i)
    a(i,j-i)=ajji*aij
    do k=jp,i
       a(i,k-i)=a(i,k-i)-aij*a(k,j-k)
    enddo
  enddo
enddo
end subroutine DLDLTB


!=============================================================================
subroutine UDLB(m,mah1,mah2,a) ! Reversed-index version of ldub        [UDLB]
!=============================================================================
integer,                        intent(IN   ) :: m,mah1,mah2
real,   dimension(m,-mah1:mah2),intent(INOUT) :: a(m,-mah1:mah2)
!-----------------------------------------------------------------------------
real,   dimension(m,-mah2:mah1)               :: at
!=============================================================================
at=a(m:1:-1,mah2:-mah1:-1); call LDUB(m,mah2,mah1,at)
a=at(m:1:-1,mah1:-mah2:-1)
end subroutine UDLB 
!=============================================================================
subroutine DUDLB(m,mah1,mah2,a) ! real(dp) version of udlb              [UDLB]
!=============================================================================
integer,                         intent(IN   ) :: m,mah1,mah2
real(dp),dimension(m,-mah1:mah2),intent(INOUT) :: a(m,-mah1:mah2)
!-----------------------------------------------------------------------------
real(dp),dimension(m,-mah2:mah1)               :: at
!=============================================================================
at=a(m:1:-1,mah2:-mah1:-1); call DLDUB(m,mah2,mah1,at)
a=at(m:1:-1,mah1:-mah2:-1)
end subroutine DUDLB 

!=============================================================================
subroutine L1UBB(m,mah1,mah2,mbh1,mbh2,a,b)!                           [L1UBB] 
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE L1UBB
!  Form the [L]*[D]*[U] decomposition of asymmetric band-matrix  [A] replace
!  lower triangular elements of [A] by [D**-1]*[L]*[D], the upper by [U],
!  replace matrix [B] by [D**-1]*[B].
!
! <-> A input as band matrix, output as lower and upper triangulars with 1s
!     implicitly assumed to lie on the main diagonal. The product of these
!     triangular matrices is [D**-1]*[A], where [D] is a diagonal matrix.
! <-> B in as band matrix, out as same but premultiplied by diagonal [D**-1]
! --> M    Number of rows of A and B
! --> MAH1 left half-width of fortran array A
! --> MAH2 right half-width of fortran array A
! --> MBH1 left half-width of fortran array B
! --> MBH2 right half-width of fortran array B
!=============================================================================
integer, intent(IN   ) ::  m,mah1, mah2, mbh1, mbh2 
real,    intent(INOUT) :: a(m,-mah1:mah2), b(m,-mbh1:mbh2)
!-----------------------------------------------------------------------------
integer                :: j, imost, jmost, jleast, jp, i
real                   :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jmost=min(m,j+mah2)
  jleast=max(1,j-mah1)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0.)stop 'In L1UBB; zero element found in diagonal factor'
  ajji=1./ajj
  a(j,jleast-j:jmost-j) = ajji * a(j,jleast-j:jmost-j)
  do i=jp,imost
    aij=a(i,j-i)
    a(i,jp-i:jmost-i) = a(i,jp-i:jmost-i) - aij*a(j,jp-j:jmost-j)
  enddo
  a(j,0)=1.
  b(j,-mbh1:mbh2) = ajji * b(j,-mbh1:mbh2)
enddo
end subroutine L1UBB
!=============================================================================
subroutine DL1UBB(m,mah1,mah2,mbh1,mbh2,a,b) ! Real(dp) version of     [L1UBB]
!=============================================================================
integer,  intent(IN   ) ::  m,mah1, mah2, mbh1, mbh2 
real(dp), intent(INOUT) :: a(m,-mah1:mah2), b(m,-mbh1:mbh2)
!-----------------------------------------------------------------------------
integer                 :: j, imost, jmost, jleast, jp, i
real(dp)                :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jmost=min(m,j+mah2)
  jleast=max(1,j-mah1)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0)stop 'In L1UBB_d; zero element found in diagonal factor'
  ajji=1./ajj
  a(j,jleast-j:jmost-j) = ajji * a(j,jleast-j:jmost-j)
  do i=jp,imost
    aij=a(i,j-i)
    a(i,jp-i:jmost-i) = a(i,jp-i:jmost-i) - aij*a(j,jp-j:jmost-j)
  enddo
  a(j,0)=1.
  b(j,-mbh1:mbh2) = ajji * b(j,-mbh1:mbh2)
enddo
end subroutine DL1UBB

!=============================================================================
subroutine L1UEB(m,mah1,mah2,mbh1,mbh2,a,b)!                           [L1UEB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1998
!		    SUBROUTINE L1UEB
!  Form the [L]*[D]*[U] decomposition of asymmetric band-matrix  [A] replace
!  all but row zero of the
!  lower triangular elements of [A] by [D**-1]*[L]*[D], the upper by [U],
!  replace matrix [B] by [D**-1]*[B].
!  This is a special adaptation of L1UBB used to process quadarature weights
!  for QEDBV etc in which the initial quadrature value is provided as input
!  instead of being implicitly assumed zero (which is the case for QZDBV etc).
!
! <-> A input as band matrix, output as lower and upper triangulars with 1s
!     implicitly assumed to lie on the main diagonal. The product of these
!     triangular matrices is [D**-1]*[A], where [D] is a diagonal matrix.
! <-> B in as band matrix, out as same but premultiplied by diagonal [D**-1]
! --> M    number of rows of B, one less than the rows of A (which has "row 0")
! --> MAH1 left half-width of fortran array A
! --> MAH2 right half-width of fortran array A
! --> MBH1 left half-width of fortran array B
! --> MBH2 right half-width of fortran array B
!=============================================================================
integer, intent(IN   ) :: m,mah1, mah2, mbh1, mbh2 
real,    intent(INOUT) :: a(0:m,-mah1:mah2), b(m,-mbh1:mbh2)
!-----------------------------------------------------------------------------
integer                :: j, imost, jmost, jleast, jp, i
real                   :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jmost=min(m,j+mah2)
  jleast=max(0,j-mah1)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0.)stop 'In L1UEB; zero element found in diagonal factor'
  ajji=1./ajj
  a(j,jleast-j:jmost-j) = ajji * a(j,jleast-j:jmost-j)
  do i=jp,imost
    aij=a(i,j-i)
    a(i,jp-i:jmost-i) = a(i,jp-i:jmost-i) - aij*a(j,jp-j:jmost-j)
  enddo
  a(j,0)=1.
  b(j,-mbh1:mbh2) = ajji * b(j,-mbh1:mbh2)
enddo
end subroutine L1UEB
!=============================================================================
subroutine DL1UEB(m,mah1,mah2,mbh1,mbh2,a,b) ! Real(dp) version of     [L1UEB]
!=============================================================================
integer,   intent(IN   ):: m,mah1, mah2, mbh1, mbh2 
real(dp),  intent(INOUT):: a(0:,-mah1:), b(:,-mbh1:)
!-----------------------------------------------------------------------------
integer                 :: j, imost, jmost, jleast, jp, i
real(dp)                :: ajj, ajji, aij
!=============================================================================
do j=1,m
  imost=min(m,j+mah1)
  jmost=min(m,j+mah2)
  jleast=max(0,j-mah1)
  jp=j+1
  ajj=a(j,0)
  if(ajj == 0)stop 'In L1UEB_D; zero element found in diagonal factor'
  ajji=1./ajj
  a(j,jleast-j:jmost-j) = ajji * a(j,jleast-j:jmost-j)
  do i=jp,imost
    aij=a(i,j-i)
    a(i,jp-i:jmost-i) = a(i,jp-i:jmost-i) - aij*a(j,jp-j:jmost-j)
  enddo
  a(j,0)=1.
  b(j,-mbh1:mbh2) = ajji * b(j,-mbh1:mbh2)
enddo
end subroutine DL1UEB

!=============================================================================
subroutine UDLBV(m,mah1,mah2,a,v)!                                    [UDLBV]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE UDLBV
!  BACk-substitution step of linear inversion involving
!  Banded matrix and Vector.
!
! --> A encodes the (L)*(D**-1)*(U) factorization of the linear-system
!     matrix, as supplied by subroutine LDUB
! <-> V input as right-hand-side vector, output as solution vector
! --> M the number of rows assumed for A and for V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
!=============================================================================
integer,  intent(IN   ) :: m, mah1, mah2
real,     intent(IN   ) :: a(m,-mah1:mah2)
real,     intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                 :: i, j
real                    :: vj
!=============================================================================
do j=1,m
   vj=v(j)
   do i=j+1,min(m,j+mah1); v(i)=v(i)-a(i,j-i)*vj; enddo; v(j)=a(j,0)*vj
enddo
do j=m,2,-1
   vj=v(j)
   do i=max(1,j-mah2),j-1; v(i)=v(i)-a(i,j-i)*vj; enddo
enddo
end subroutine UDLBV
!=============================================================================
subroutine dudlbv(m,mah1,mah2,a,v)!                                    [udlbv]
!=============================================================================
integer,  intent(IN   ) :: m, mah1, mah2
real(dp), intent(IN   ) :: a(m,-mah1:mah2)
real(dp), intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                 :: i, j
real(dp)                :: vj
!=============================================================================
do j=1,m
   vj=v(j)
   do i=j+1,min(m,j+mah1); v(i)=v(i)-a(i,j-i)*vj; enddo; v(j)=a(j,0)*vj
enddo
do j=m,2,-1
   vj=v(j)
   do i=max(1,j-mah2),j-1; v(i)=v(i)-a(i,j-i)*vj; enddo
enddo
end subroutine dudlbv

!=============================================================================
subroutine ltdlbv(m,mah1,a,v)!                                        [ltdlbv]
!=============================================================================
! Like udlbv, except assuming a is the ltdl decomposition of a SYMMETRIC
! banded matrix, with only the non-upper part provided (to avoid redundancy)
!=============================================================================
integer,  intent(IN   ) :: m, mah1
real(sp), intent(IN   ) :: a(m,-mah1:0)
real(sp), intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                 :: i, j
real(sp)                :: vj
!=============================================================================
do j=1,m
   vj=v(j)
   do i=j+1,min(m,j+mah1); v(i)=v(i)-a(i,j-i)*vj; enddo; v(j)=a(j,0)*vj
enddo
do j=m,2,-1
   vj=v(j)
   do i=max(1,j-mah1),j-1; v(i)=v(i)-a(j,i-j)*vj; enddo
enddo
end subroutine ltdlbv
!=============================================================================
subroutine dltdlbv(m,mah1,a,v)!                                       [ltdlbv]
!=============================================================================
! Like udlbv, except assuming a is the ltdl decomposition of a SYMMETRIC
! banded matrix, with only the non-upper part provided (to avoid redundancy)
!=============================================================================
integer,  intent(IN   ) :: m, mah1
real(dp), intent(IN   ) :: a(m,-mah1:0)
real(dp), intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                 :: i, j
real(dp)                :: vj
!=============================================================================
do j=1,m
   vj=v(j)
   do i=j+1,min(m,j+mah1); v(i)=v(i)-a(i,j-i)*vj; enddo; v(j)=a(j,0)*vj
enddo
do j=m,2,-1
   vj=v(j)
   do i=max(1,j-mah1),j-1; v(i)=v(i)-a(j,i-j)*vj; enddo
enddo
end subroutine dltdlbv

!=============================================================================
subroutine UDLBX(mx,mah1,mah2,my,a,v)!                                [UDLBX]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE UDLBX
!  BACk-substitution step of parallel linear inversion involving
!  Banded matrix and X-Vectors.
!
! --> A encodes the (L)*(D**-1)*(U) factorization of the linear-system
!     matrix, as supplied by subroutine LDUB or, if N=NA, by LDUB
! <-> V input as right-hand-side vectors, output as solution vectors
! --> MX the number of rows assumed for A and length of
!     X-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MY number of parallel X-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: mx, mah1, mah2, my
real,     intent(IN   ) :: a(mx,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: jx, ix
!=============================================================================
do jx=1,mx
   do ix=jx+1,min(mx,jx+mah1); v(ix,:) = v(ix,:) - a(ix,jx-ix)*v(jx,:); enddo
   v(jx,:) = a(jx,0) * v(jx,:)
enddo
do jx=mx,2,-1
   do ix=max(1,jx-mah2),jx-1; v(ix,:) = v(ix,:) - a(ix,jx-ix)*v(jx,:); enddo
enddo
end subroutine UDLBX

!=============================================================================
subroutine UDLBY(my,mah1,mah2,mx,a,v)!                                [UDLBY]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE UDLBY
!  BACk-substitution step of parallel linear inversion involving
!  Banded matrix and Y-Vectors.
!
! --> A encodes the (L)*(D**-1)*(U) factorization of the linear-system
!     matrix, as supplied by subroutine LDUB or, if N=NA, by LDUB
! <-> V input as right-hand-side vectors, output as solution vectors
! --> MY the number of rows assumed for A and length of
!     Y-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MX number of parallel Y-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: my, mah1, mah2, mx
real,     intent(IN   ) :: a(my,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: iy, jy
!=============================================================================
do jy=1,my
   do iy=jy+1,min(my,jy+mah1); v(:,iy) = v(:,iy)-a(iy,jy-iy)*v(:,jy); enddo
   v(:,jy)=a(jy,0)*v(:,jy)
enddo
do jy=my,2,-1
   do iy=max(1,jy-mah2),jy-1; v(:,iy)=v(:,iy)-a(iy,jy-iy)*v(:,jy); enddo
enddo
end subroutine UDLBY

!=============================================================================
subroutine UDLVB(m,mah1,mah2,v,a)!                                    [UDLVB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE UDLVB
!  BACk-substitution step of linear inversion involving
!  row-Vector and Banded matrix.
!
! <-> V input as right-hand-side row-vector, output as solution vector
! --> A encodes the (L)*(D**-1)*(U) factorization of the linear-system
!     matrix, as supplied by subroutine LDUB
! --> M the number of rows assumed for A and columns for V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
!=============================================================================
integer,  intent(IN   ) :: m, mah1, mah2
real,     intent(IN   ) :: a(m,-mah1:mah2)
real,     intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                 :: i, j
real                    :: vi
!=============================================================================
do i=1,m
   vi=v(i)
   do j=i+1,min(m,i+mah2); v(j)=v(j)-vi*a(i,j-i); enddo
   v(i)=vi*a(i,0)
enddo
do i=m,2,-1
   vi=v(i)
   do j=max(1,i-mah1),i-1; v(j)=v(j)-vi*a(i,j-i); enddo
enddo
end subroutine UDLVB

!=============================================================================
subroutine UDLXB(mx,mah1,mah2,my,v,a)!                                [UDLXB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE UDLXB
!  BACk-substitution step of parallel linear inversion involving
!  Banded matrix and row-X-Vectors.
!
! <-> V input as right-hand-side vectors, output as solution vectors
! --> A encodes the (L)*(D**-1)*(U) factorization of the linear-system
!     matrix, as supplied by subroutine LDUB
! --> MX the number of rows assumed for A and length of
!     X-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MY number of parallel X-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: mx, mah1, mah2, my
real,     intent(IN   ) :: a(mx,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: ix, jx
!=============================================================================
do ix=1,mx
   do jx=ix+1,min(mx,ix+mah2); v(jx,:)=v(jx,:)-v(ix,:)*a(ix,jx-ix); enddo
   v(ix,:)=v(ix,:)*a(ix,0)
enddo
do ix=mx,2,-1
   do jx=max(1,ix-mah1),ix-1; v(jx,:)=v(jx,:)-v(ix,:)*a(ix,jx-ix); enddo
enddo
end subroutine UDLXB

!=============================================================================
subroutine UDLYB(my,mah1,mah2,mx,v,a)!                                [UDLYB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE UDLYB
!  BACk-substitution step of parallel linear inversion involving
!  Banded matrix and row-Y-Vectors.
!
! <-> V input as right-hand-side vectors, output as solution vectors
! --> A encodes the (L)*(D**-1)*(U) factorization of the linear-system
!     matrix, as supplied by subroutine LDUB
! --> MY the number of rows assumed for A and length of
!     Y-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MX number of parallel Y-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: my, mah1, mah2, mx
real,     intent(IN   ) :: a(my,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: iy, jy
!=============================================================================
do iy=1,my
   do jy=iy+1,min(my,iy+mah2); v(:,jy)=v(:,jy)-v(:,iy)*a(iy,jy-iy); enddo
   v(:,iy)=v(:,iy)*a(iy,0)
enddo
do iy=my,2,-1
   do jy=max(1,iy-mah1),iy-1; v(:,jy)=v(:,jy)-v(:,iy)*a(iy,jy-iy); enddo
enddo
end subroutine UDLYB

!=============================================================================
subroutine U1LBV(m,mah1,mah2,a,v)!                                    [U1LBV]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE U1LBV
!  BACk-substitution step ((U**-1)*(L**-1)) of linear inversion involving
!  special Banded matrix and right-Vector.
!
! --> A encodes the [L]*[U] factorization of the linear-system
!     matrix, as supplied by subroutine L1UBB
! <-> V input as right-hand-side vector, output as solution vector
! --> M the number of rows assumed for A and for V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
!=============================================================================
integer,  intent(IN   ) :: m, mah1, mah2
real,     intent(IN   ) :: a(m,-mah1:mah2)
real,     intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                 :: i, j
real                    :: vj
!=============================================================================
do j=1,m
   vj=v(j)
   do i=j+1,min(m,j+mah1); v(i)=v(i)-a(i,j-i)*vj; enddo
enddo
do j=m,2,-1
   vj=v(j)
   do i=max(1,j-mah2),j-1; v(i)=v(i)-a(i,j-i)*vj; enddo
enddo
end subroutine U1LBV

!=============================================================================
subroutine U1LBX(mx,mah1,mah2,my,a,v)!                                [U1LBX]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE U1LBX
!  Special BaCk-substitution step of parallel linear inversion involving
!  Banded matrix and X-right-Vectors.
!
! --> A encodes the [L]*[U] factorization of the linear-system
!     matrix, as supplied by subroutine L1UBB
! <-> V input as right-hand-side vectors, output as solution vectors
! --> MX the number of rows assumed for A and length of
!     X-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MY number of parallel X-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: mx, mah1, mah2, my
real,     intent(IN   ) :: a(mx,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: ix, jx
!=============================================================================
do jx=1,mx
   do ix=jx+1,min(mx,jx+mah1); v(ix,:)=v(ix,:)-a(ix,jx-ix)*v(jx,:); enddo
enddo
do jx=mx,2,-1
   do ix=max(1,jx-mah2),jx-1; v(ix,:)=v(ix,:)-a(ix,jx-ix)*v(jx,:); enddo
enddo
end subroutine U1LBX

!=============================================================================
subroutine U1LBY(my,mah1,mah2,mx,a,v)!                                [U1LBY]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE U1LBY
!  Special BaCk-substitution step of parallel linear inversion involving
!  Banded matrix and Y-right-Vectors.
!
! --> A encodes the [L]*[U] factorization of the linear-system
!     matrix, as supplied by subroutine L1UBB
! <-> V input as right-hand-side vectors, output as solution vectors
! --> MY the number of rows assumed for A and length of
!     Y-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MX number of parallel Y-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: my, mah1, mah2, mx
real,     intent(IN   ) :: a(my,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: iy, jy
!=============================================================================
do jy=1,my
   do iy=jy+1,min(my,jy+mah1); v(:,iy)=v(:,iy)-a(iy,jy-iy)*v(:,jy); enddo
enddo
do jy=my,2,-1
   do iy=max(1,jy-mah2),jy-1; v(:,iy)=v(:,iy)-a(iy,jy-iy)*v(:,jy); enddo
enddo
end subroutine U1LBY

!=============================================================================
subroutine U1LVB(m,mah1,mah2,v,a)!                                    [U1LVB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE U1LVB
!  Special BaCk-substitution step of linear inversion involving
!  left-Vector and Banded matrix.
!
! <-> V input as right-hand-side row-vector, output as solution vector
! --> A encodes the special [L]*[U] factorization of the linear-system
!     matrix, as supplied by subroutine L1UBB
! --> M the number of rows assumed for A and columns for V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
!=============================================================================
integer, intent(IN   ) :: m, mah1, mah2
real,    intent(IN   ) :: a(m,-mah1:mah2)
real,    intent(INOUT) :: v(m)
!-----------------------------------------------------------------------------
integer                :: i, j
real                   :: vi
!=============================================================================
do i=1,m
   vi=v(i)
   do j=i+1,min(m,i+mah2); v(j)=v(j)-vi*a(i,j-i); enddo
enddo
do i=m,2,-1
   vi=v(i)
   do j=max(1,i-mah1),i-1; v(j)=v(j)-vi*a(i,j-i); enddo
enddo
end subroutine U1LVB

!=============================================================================
subroutine U1LXB(mx,mah1,mah2,my,v,a)!                                [U1LXB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE U1LXB
!  Special BaCk-substitution step of parallel linear inversion involving
!  Banded matrix and X-left-Vectors.
!
! <-> V input as right-hand-side vectors, output as solution vectors
! --> A encodes the special [L]*[U] factorization of the linear-system
!     matrix, as supplied by subroutine L1UBB
! --> MX the number of rows assumed for A and length of
!     X-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MY number of parallel X-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: mx, mah1, mah2, my
real,     intent(IN   ) :: a(mx,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: ix, jx
!=============================================================================
do ix=1,mx
   do jx=ix+1,min(mx,ix+mah2); v(jx,:)=v(jx,:)-v(ix,:)*a(ix,jx-ix); enddo
enddo
do ix=mx,2,-1
   do jx=max(1,ix-mah1),ix-1;  v(jx,:)=v(jx,:)-v(ix,:)*a(ix,jx-ix); enddo
enddo
end subroutine U1LXB

!=============================================================================
subroutine U1LYB(my,mah1,mah2,mx,v,a)!                                [U1LYB]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1996
!		    SUBROUTINE U1LYB
!  Special BaCk-substitution step of parallel linear inversion involving
!  special Banded matrix and Y-left-Vectors.
!
! <-> V input as right-hand-side vectors, output as solution vectors
! --> A encodes the [L]*[U] factorization of the linear-system
!     matrix, as supplied by subroutine L1UBB
! --> MY the number of rows assumed for A and length of
!     Y-vectors stored in V
! --> MAH1 the left half-bandwidth of fortran array A
! --> MAH2 the right half-bandwidth of fortran array A
! --> MX number of parallel Y-vectors inverted
!=============================================================================
integer,  intent(IN   ) :: my, mah1, mah2, mx
real,     intent(IN   ) :: a(my,-mah1:mah2)
real,     intent(INOUT) :: v(mx,my)
!-----------------------------------------------------------------------------
integer                 :: iy, jy
!=============================================================================
do iy=1,my
   do jy=iy+1,min(my,iy+mah2); v(:,jy)=v(:,jy)-v(:,iy)*a(iy,jy-iy); enddo
enddo
do iy=my,2,-1
   do jy=max(1,iy-mah1),iy-1;  v(:,jy)=v(:,jy)-v(:,iy)*a(iy,jy-iy); enddo
enddo
end subroutine U1LYB

!=============================================================================
subroutine LINBV(m,mah1,mah2,a,v)!                                     [LINBV]
!=============================================================================
!   R.J.Purser, National Meteorological Center, Washington D.C.  1994
!		    SUBROUTINE LINBV
!   Solve LINear system with square Banded-matrix and vector V
!
! <-> A system matrix on input, its [L]*[D**-1]*[U] factorization on exit
! <-> V vector of right-hand-sides on input, solution vector on exit
! --> M order of matrix A
! --> MAH1 left half-bandwidth of A
! --> MAH2 right half-bandwidth of A
!=============================================================================
integer, intent(IN   ) :: m, mah1, mah2
real,    intent(INOUT) :: a(m,-mah1:mah2), v(m)
!=============================================================================
call LDUB(m,mah1,mah2,a)
call UDLBV(m,mah1,mah2,a,v)
end subroutine LINBV

!=============================================================================
subroutine WRTB(m1,m2,mah1,mah2,a)!                                     [WRTB]
!=============================================================================
integer,  intent(IN) :: m1, m2, mah1, mah2
real,     intent(IN) :: a(m1,-mah1:mah2)
!-----------------------------------------------------------------------------
integer              :: i1, i2, i, j1, j2, j, nj1
!=============================================================================
do i1=1,m1,20
   i2=min(i1+19,m1)
   write(41,'(7x,6(i2,10x))'),(j,j=-mah1,mah2)
   do i=i1,i2
      j1=max(-mah1,1-i)
      j2=min(mah2,m2-i)
      nj1=j1+mah1
      if(nj1==0) write(41,'(1x,i3,6(1x,e12.5))'),    i,(a(i,j),j=j1,j2)
      if(nj1==1) write(41,'(1x,i3,12x,5(1x,e12.5))'),i,(a(i,j),j=j1,j2)
      if(nj1==2) write(41,'(1x,i3,24x,4(1x,e12.5))'),i,(a(i,j),j=j1,j2)
      if(nj1==3) write(41,'(1x,i3,36x,3(1x,e12.5))'),i,(a(i,j),j=j1,j2)
      if(nj1==4) write(41,'(1x,i3,48x,2(1x,e12.5))'),i,(a(i,j),j=j1,j2)
      if(nj1==5) write(41,'(1x,i3,60x,1(1x,e12.5))'),i,(a(i,j),j=j1,j2)
   enddo
   read(*,*)
enddo
end subroutine WRTB

end module pmat2

module glerl_dictionary
  implicit none
  integer(4),parameter::dictmax=9999
  integer(4),parameter::misint=-999
  character(len=8),parameter::mischar="MISSING "
  real(8),parameter::adjust=1. !adjusted ob reason code
  real(8),parameter::moved=2. !moved ob reason code
contains
  subroutine finddict2(stname,names,lat,lon,olats,olons,stnum)
    integer(4),intent(out)::stnum
    real(4),intent(in)::lat,lon
    real(4),dimension(:),intent(in)::olats(dictmax),olons(dictmax)!,llats(dictmax),llons(dictmax)
    character(len=8),dimension(:),intent(in)::names(dictmax)
    character(len=8),intent(in)::stname
    real(4)::wlat,wlon,llat,llon
    integer(4)::a,act

    !initial/default values
    stnum=misint
    dictloop: do a=1,dictmax
       namecheck: if (stname.eq.names(a)) then
          if (abs(olats(a)-lat).lt.0.1.and.abs(olons(a)-lon).lt.0.1) then
             stnum=a
             return
          elseif (names(a).eq.mischar) then
             return
          endif
       endif namecheck
    enddo dictloop
  end subroutine finddict2
end module glerl_dictionary

c$$$ Main Program Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Main Program: PREPOBS_PREPACQC
c   Programmer: D. Keyser       Org: NP22       Date: 2016-12-09
c
c Abstract: Performs the NRL aircraft data quality control on all types of reports (AIREP,
c   PIREP, AMDAR, TAMDAR, MDCRS).  Replaces the previous routine of the same name originally
c   written by Paul Julian (which was less comprehensive and did not handle MDCRS reports).
c   It reads in a PREPBUFR file containing all reports, pulls out "AIRCAR" and "AIRCFT"
c   reports, merges the mass and wind pieces, translates information into NRL "standards" and
c   stores in internal memory.  These are then passed into the NRL quality control kernel
c   (acftqc_obs).  Once the NRL quality control is completed, translates information back to
c   NCEP/PREPBUFR "standards" and encodes the updated information into the full PREPBUFR file
c   as "events" with new NRLACQC reason codes.  The events consist of quality mark changes,
c   although NRLACQC can also remove duplicate reports and rehabilitate (update) the report
c   time, latitude and longitude for some AIREP reports.  An option is to also generate a
c   PREPBUFR-like profiles file containing only aircraft reports in "raob-lookalike"
c   profiles (merged mass and wind data).  These can be used for air quality and verification
c   codes.
c
c Program History Log:
c 2010-11-15  S. Bender  -- Original Author
c 2012-05-08  D. Keyser  -- Prepared for operational implementation
c 2012-11-20  J. Woollen -- Initial port to WCOSS
c 2012-12-11  S. Hsiao   -- Increased maximum number of merged reports that can be processed
c                           "max_reps" from 150K to 155K to handle increase in MDCRS reports
c 2013-02-07  D. Keyser  -- Interface with input PREPBUFR file will now store pressure and
c                           pressure-altitude only from the first (mass) piece of a mass/wind
c                           piece pair rather than re-store it again from the second (wind)
c                           piece - even though they "should" be the same in both pieces (see
c                           % below for exception), there can be rare cases when at least
c                           pressure-altitude is missing in the wind piece (due to a bug in
c                           PREPDATA where unreasonably-high winds are set to missing and an
c                           "empty" wind piece is still encoded into PREPBUFR, this can lead
c                           to floating point exception errors in construction of profiles
c                           {note that pressure & pressure-altitude from reports with only a
c                           wind piece will be read since it is the first (only) piece of the
c                           report}: % - there can be cases where the pressure qualty mark
c                           (PQM) is different in the mass piece vs. the wind piece (e.g.,
c                           when it is set to 10 for reports near tropical systems by
c                           SYNDATA), so it is better to pick up PQM from the mass report for
c                           use in the merged mass/wind profiles, an added benefit of this
c                           change; increased maximum number of merged reports that can be
c                           processed "max_reps" from 155K to 185K to handle future increase
c                           all types of aircraft rpts; if the total number of merged (mass
c                           + wind piece) aircraft-type reports read in from PREPBUFR file is
c                           at least 90% of the maximum allowed, print diagnostic warning
c                           message to production joblog file prior to returning from
c                           subroutine INPUT_ACQC; if the maximum number of merged reports
c                           that can be processed ("max_reps") is exceeded when updating
c                           reports in PREPBUFR file with QC changes in subroutine
c                           OUTPUT_ACQC_NOPROF, program will no longer stop with r.c. 31, as
c                           though there is an indexing error, instead all original reports
c                           above "max_reps" will be written out without any QC and a message
c                           will be printed to stdout (a diagnostic will have already been
c                           sent to the production joblog file in this case when reports were
c                           first read in by subroutine INPUT_ACQC)
c 2013-02-07  D. Keyser  -- Final changes to run on WCOSS: Set BUFRLIB missing (BMISS) to
c                           10E8 rather than 10E10 to avoid integer overflow; use formatted
c                           print statements where previously unformatted print was > 80
c                           characters
c 2014-03-06  D. Keyser  -- Moved BUFRLIB routine OPENMB call in subroutine
c                           output_acqc_noprof to after time window and geographic domain
c                           checks to prevent creation of an empty, but open, BUFR message
c                           (type AIRCAR) in (rare) cases where absolutely no aircraft
c                           reports pass these checks (would cause a BUFRLIB abort due to
c                           previous message being open when attempting to copy first non-
c                           aircraft message from input to output PREPBUFR file
c 2014-07-18  D. Keyser  --
c                 - Increased maximum number of flights that can be processed "maxflt" from
c                   5000 to 7500 to account for increase in aircraft reports.
c                 - Increased maximum number of merged reports that can be processed
c                   "max_reps" from 185K to 220K to handle future increase in all types of
c                   aircraft reports.
c                 - If subroutine acftobs_qc returns abnormally to main program due to the
c                   maximum value for number of flights calculated at some point during its
c                   processing exceeding the allowed limit ("maxflt"), no longer stop with
c                   r.c. 98.  Instead continue on with processing and post a diagnostic
c                   warning message to the production joblog file.  The assumption is that
c                   the resultant PREPBUFR file may not contain fully QC'd aircraft data,
c                   especially if the actual number of flights calculated greatly exceeds
c                   "maxflt" (since obs in flights above the "maxflt" limit may partially be
c                   skipped over in the QC process), but the vast majority should be QC'd,
c                   and all reports originally in the PREPBUFR file will be at least be
c                   retained. (Note that a gradual increase will trigger a warning in the
c                   production joblog now when numbers get too close to the limit - see
c                   change to subroutine acftobs_qc below).
c                 - Increased format width from I5 to I6 in all places where aircraft obs
c                   index is listed out (since there now can be > 99999 reports).
c                 - Subroutine acftobs_qc and its child subroutines:
c                    - Keep track of maximum value for number of flights calculated at some
c                      point during the processing of subroutine acftobs_qc.  If, at the end
c                      of acftobs_qc, this value is at least 90% of the allowed limit
c                      ("maxflt", set in the main program), post a diagnostic warning message
c                      to the production joblog file prior to exiting from acftobs_qc.
c                    - In subr. do_flt and do_reg, return (abnormally) immediately if
c                      "maxflt" is exceeded rather than waiting to test for this at end of
c                      do_flt and do_reg and then return (abnormally).  Prior to return
c                      subtract 1 from number of flights so it will remain at "maxflt". The
c                      immediate return avoids clobbering of memory in these cases.
c                    - In subr. reorder, where any new flight exceeding "maxflt" replaces the
c                      previous flight at index "maxflt" in the arrays to avoid an array
c                      overflow (done in two places in original NRL version), post diagnostic
c                      warning message to the production joblog file (found a third instance
c                      where this needs to be done in subr. reorder - original NRL version
c                      did not trap it and arrays limited to length "maxflt" would have
c                      overflowed).
c                    - If "maxflt" is exceeded in subr. dupchk (1 place possible) or in subr.
c                      do_flt (2 places possible), the abnormal return back to subr.
c                      acftobs_qc results in subr. acftobs_qc now continuing on but setting a
c                      flag for "maxflt_exceeded".  Prior to this, subr.  acftobs_qc itself
c                      immediately performed an abnormal return back to main program in such
c                      cases resulting in no more NRL QC processing.  Now NRL QC processing
c                      will continue on to the end of subr. acftobs_qc where the abnormal
c                      return back to the main program will be triggered by the
c                      "maxflt_exceeded" flag.
c                    - There is one, apparently rare, condition where "maxflt" could be
c                      exceeded in subr. acft_obs itself (within logic which generates master
c                      list of tail numbers and counts).  Since it can't be determined if
c                      continuing on without processing (QC'ing) any more data would yield
c                      acceptable results, the program now immediately stops with condition
c                      code 98 and a diagnostic warning message is posted to the production
c                      joblog file noting that "maxflt" needs to be increased.  Prior to this
c                      it returned to the main program where it also immediately stopped with
c                      condition code 98 (so no real change in what happens here, just where
c                      it happens).
c 2014-09-03  D. Keyser  -- If no aircraft reports of any type are read from input PREPBUFR
c                      file by subr. input_acqc, no further processing is performed in this
c                      subr. other than the usual stdout print summary at its end.  After its
c                      return back to the calling main program, the main program also, in
c                      this case, does no further processing.  Instead the main program stops
c                      with condition code 4 (to alert executing script prepobs_prepacqc.sh)
c                      after printing a diagnostic message to stdout.
c 2014-12-09  J. Purser/Y. Zhu     -- Added new namelist switches "l_mandlvl" and "tsplines",
c                      used by subroutine sub2mem_mer to modify the calculation of vertical
c                      velocity rate in the profiles {l_mandlvl=F excludes interpolation to
c                      mandatory levels; tsplines=T calculates vertical velocity rate using
c                      Jim Purser's tension-spline interpolation utility (source in-lined in
c                      this program at this time) to get continuous gradient results in a
c                      profile and mitigate missing time information; tsplines=F uses finite-
c                      difference method to obtain vertical velocity rate, calculated for
c                      both ascents and descents using the nearest neighboring pair which are
c                      at least one minute apart (before, only finite-difference method was
c                      used to obtain vertical velocity rate and it could only be calculated
c                      for descents).
c 2014-12-12  D. Keyser  -- Printout from vertical velocity rate calculation information for
c                      QC'd merged aircraft reports written to profiles PREPBUFR-like file is
c                      written to unit 41 rather than stdout.
c 2015-03-16  D. Keyser  --
c                 - Increased maximum number of merged reports that can be processed
c                   "max_reps" from 220K to 300K to handle future increase in all types of
c                   aircraft reports.
c                 - In subr. output_acqc_prof, fixed a bug which, for cases where the maximum
c                   number of merged reports that can be processed ("max_reps") is exceeded,
c                   prevented any original reports above "max_reps" from being written out
c                   (without any QC).
c 2015-04-17  J. Purser   -- Updates to tension-spline interpolation utility pspl:
c                   In April 2015 some significant changes were made to pspl.f90 to improve
c                   the robustness of the algorithm and the usefulness of the energy
c                   diagnostic:
c                       1) The allowance of B iterations was increased from 40 to 80 owing to
c                          a single failure in a parallel run (where 43 iterations were
c                          required) (and the halfgate parameter was increased to 30 for all
c                          data in the parallels, which also increases robustness).
c                       2) There was included an explicit energy check at each A iteration to
c                          force an exit when this energy fails to decrease. This change was
c                          prompted by a single failure in a parallel run (courtesy Russ
c                          Treadon) in which the A and B iterations flip-flopped at zero
c                          energy change in a case of grazing contact with a gatepost.
c                       3) The energy is now normalized by the energy that would be computed
c                          from a spline that fits only the first and last gateposts. The
c                          renormalized energy diagnostic tells how sinuous the final profile
c                          is -- very large values are indiciative of a halfgate chosen to be
c                          too narrow for the given profile data.
c                       4) The normalized time data are now handled as integer arrays instead
c                          of reals in those parts of the code dealing with the combinatorics
c                          of routes.  This is just better coding practice.
c 2015-04-17  Y. Zhu -- Updates to subroutine sub2mem_mer:
c                       1) Subroutine is more robust.  If there is an error in the generation
c                          of vertical velocity rate in the tension-spline interpolation
c                          utility pspl (called in this subroutine), this subroutine (and thus
c                          the program itself) will no longer abort (with either c. code 62,
c                          63 or 64 depending upon which routine inside pspl generated the
c                          error) but will instead revert to the finite difference method for
c                          calculating vertical velocity rate.
c                       2) Previously, halfgate was set to be 30 for the data profiles that
c                          don't have second information in time, but a tighter value of 10
c                          for the data profiles that do have second information in time. Now
c                          halfgate is relaxed to be 30 for the data profiles that do have
c                          complete time information.
c 2016-11-09  C. Hill -----
c                 - Increased the maximum number of flights that can be processed, "MAXFLT",
c                   from 7500 to 12500 to resolve >90% warning.
c 2016-12-09  D. Keyser  --
c                 - Nomenclature change: replaced "MDCRS/ACARS" with just "MDCRS".
c                 - New LATAM AMDARs contain an encrypted flight number (in addition to a tail
c                   number, all other AMDARs have only a tail number which is copied into
c                   flight number). Read this in and use in QC processing.
c                   BENEFIT: Improves track-checking and other QC for LATAM AMDARs.
c                 - Since "ACARS" as referred to in NRL QC kernal (acftobs_qc.f) is not used
c                   there and we earlier decided to use this to provide a separate category
c                   for TAMDARs in the NRL QC kernal (for stratifying statistics), all
c                   printout in acftobs_qc.f changes the term "ACARS" to "TAMDAR".  In
c                   addition, all comments now refer to "TAMDAR" instead of "ACARS".
c                 - Variables holding latitude and longitude data (including arrays "alat" and
c                   "alon" passed between subroutines) now double precision. XOB and YOB in
c                   PREPBUFR file now scaled to 10**5 (was 10**2) to handle new v7 AMDAR and
c                   MDCRS reports which have this higher precision.
c                   BENEFIT: Retains exact precison here. Improves QC processing.
c                      - Note: QC here can be improved further by changing logic in many
c                              places to account for the increased precision. This needs to be
c                              investigated.  For now, locations in code where this seems
c                              possible are noted by the spanning comments:
c                    ! vvvv DAK-future change perhaps to account for incr. lat/lon precision
c                    ! ^^^^ DAK-future change perhaps to account for incr. lat/lon precision
c                      - The format for all print statements containing latitude and longitude
c                        changed to print to 5 decimal places.
c
c Usage:
c   Input files:
c     Unit 05  - Standard input (namelist)
c     Unit 11  - PREPBUFR file containing all obs, prior to any processing by this program
c
c   Output files:
c     Unit 06  - Standard output print
c     Unit 08  - Text file containing full log of all NRL QC information
c     Unit 30  - Text file containing duplicate data check information
c     Unit 31  - Text file containing spike data check information
c     Unit 32  - Text file containing invalid data check information
c     Unit 33  - Text file containing stuck data check information
c     Unit 34  - Text file containing gross check information
c     Unit 35  - Text file containing position check information
c     Unit 36  - Text file containing ordering check information
c     Unit 37  - Text file containing suspect data check information
c     Unit 38  - Text file containing reject list information
c     Unit 41  - Text file containing vertical velocity rate calculation information for QC'd
c                merged aircraft reports written to profiles PREPBUFR-like file
c     Unit 51  - Text file containing sorted listing of all single-level QC'd aircraft
c                reports written back to full PREPBUFR file
c     Unit 52  - Text file containing sorted listing of all QC'd merged aircraft reports
c                written to profiles PREPBUFR-like file
c     Unit 61  - PREPBUFR file identical to input except containing NRLACQC events
c     Unit 62  - PREPBUFR-like file containing merged (mass and wind) profile reports
c                (always) and single(flight)-level reports not part of any profile (when
c                l_prof1lvl=T) with NRLACQC events
c
c   Subprograms called:
c     Unique:    - ACFTOBS_QC        PR_WORKDATA INDEXC             DUPCHEK_QC
c                - REORDER           DO_FLT      DO_REG             INNOV_QC
c                - BENFORD_QC        INVALID_QC  STK_VAL_QC         GRCHEK_QC
c                - POSCHEK_QC        ORDDUP_QC   ORDCHEK_QC         SUSPECT_QC
c                - REJLIST_QC        P2HT_QC     HT2FL_QC           P_DDTG
c                - SPIKE_QC          SLEN        INSTY_OB_FUN       C_INSTY_OB
c                - GCIRC_QC          INDEXC40    INPUT_ACQC         OUTPUT_ACQC_NOPROF
c                - OUTPUT_ACQC_PROF  SUB2MEM_MER SUB2MEM_UM         TRANQCFLAGS
C     LIBRARY:
c       SYSTEM:  - SYSTEM
c       W3NCO:   - ERREXIT    W3TAGB     W3TAGE     W3MOVDAT   MOVA2I     W3FI04
c       W3EMC:   - W3FC05     ORDERS
c       BUFRLIB: - IREADMG    IREADSB    UFBINT     UFBSEQ     UFBEVN     READNS     IBFMS
c                - COPYMG     OPENMB     UFBCPY     WRITSB     WRITLC     CLOSMG     DATELEN
c                - OPENBF     CLOSBF     UFBQCD     SETBMISS   GETBMISS
c                
c   Exit states:
c     Cond =   0 - successful run
c              4 - no aircraft reports of any type read in
c             23 - unexpected return code from readns; problems reading BUFR file
c             31 - indexing problem encountered when trying to match QC'd data in arrays to
c                  mass and wind pieces in original PREPBUFR file (subroutine
c                  output_acqc_noprof)
c             59 - nlvinprof is zero coming into subroutine sub2mem_mer (should never
c                  happen!)
c             61 - index "j is .le. 1 meaning "iord" array underflow (should never happen!)
c                  (subroutine sub2mem_mer)
c             69 - row number for input data matrix is outside range of 1-34 (subroutine
c                  tranQCflags)
c             79 - characters on this machine are not ASCII, conversion of quality flag to
c                  row number in subroutine tranQCflags cannot be made
c             98 - too many flights in input PREPBUFR file, must increase size of parameter
c                  "maxflt" (in some places code continues but in this case can't be sure
c                  continuing on w/o processing any more data would turn out ok)
calloc        99 - unable to allocate one or more array
c
c   Remarks:
c      Input Namelist switches (namelist &nrlacqcinput)):
c            trad           - time window radius in hours for outputting reports (if l_otw=T)
c                             (default=3.0)
c            l_otw          - logical:
c                                 TRUE  - eliminate reports outside the time window radius
c                                         +/- trad when writing out reports
c                                   
c                                 FALSE - DO NOT eliminate reports outside the time window
c                                         radius +/- trad when writing out reports
c                                 (default=FALSE)
c            l_nhonly       - logical:
c                                 TRUE  - eliminate reports outside tropics & N. Hemisphere
c                                         when writing out reports
c                                 FALSE - DO NOT eliminate reports outside tropics & N.
c                                         Hemisphere when writing out reports
c                                 (default=FALSE)
c            l_doprofiles   - logical:
c                                 TRUE  - create merged raob lookalike QC'd profiles from
c                                         aircraft ascents and descents (always) and output
c                                         these as well as QC'd merged single(flight)-level
c                                         aircraft reports not part of any profile (when
c                                         l_prof1lvl=T) to a PREPBUFR-like file
c                                         **CAUTION: Will make code take quite a bit longer
c                                                    to run!
c                                 FALSE - SKIP creation of merged raob lookalike QC'd
c                                         profiles from aircraft ascents and descents into
c                                         PREPBUFR-like file
c                                 (default=FALSE)
c            l_allev_pf     - logical:
c                                 TRUE  - process latest (likely NRLACQC) events plus all
c                                         prior events into profiles PREPBUFR-like file
c                                         **CAUTION: More complete option, but will make code
c                                                    take longer to run!
c                                 FALSE - process ONLY latest (likely NRLACQC) events into
c                                         profiles PREPBUFR-like file
c                                 (Note 1: Hardwired to FALSE if l_doprofiles=FALSE)
c                                 {Note 2: All pre-existing events plus latest (likely
c                                          NRLACQC) events are always encoded into full
c                                          PREPBUFR file}
c                                 (default=FALSE)
c            l_prof1lvl     - logical:
c                                 TRUE  - encode merged single(flight)-level aircraft reports
c                                         with NRLACQC events that are not part of any
c                                         profile into PREPBUFR-like file, along with merged
c                                         profiles from aircraft ascents and descents
c                                         **CAUTION: Will make code take a bit longer to run!
c                                 FALSE - DO NOT encode merged single(flight)-level aircraft
c                                         reports with NRLACQC events that are not part of
c                                         any profile into PREPBUFR-like file
c                                         - only merged profiles from aircraft ascents and
c                                         descents will be encoded into this file
c                                 (Note:  Applicable only when l_doprofiles=TRUE)
c                                 (default=FALSE)
c            l_mandlvl      - logical:
c                                 TRUE  - interpolate obs data to mandatory levels in profile
c                                         generation
c                                 FALSE - DO NOT interpolate obs data to mandatory levels in
c                                         profile generation
c                                 (Note:  Applicable only when l_doprofiles=TRUE)
c                                 (default=TRUE)
c            tsplines       - logical:
c                                 TRUE  - use Jim Purser's tension-spline interpolation
c                                         utility to generate aircraft vertical velocity rate
c                                         in profile generation
c                                 FALSE - use finite-difference method based on nearest
c                                         neighboring pair of obs which are at least one
c                                         minute apart to generate aircraft vertical velocity
c                                         rate in profile generation
c                                 (Note:  Applicable only when l_doprofiles=TRUE)
c                                 (default=TRUE)
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      program prepobs_prepacqc 

      implicit none

c ------------------------------
c Parameter statements/constants
c ------------------------------
      integer    inlun                ! input unit number (for pre-prepacqc PREPBUFR file
                                      !  containing all obs)
      parameter (inlun = 11)

      integer    outlun               ! output unit number for post-PREPACQC PREPBUFR file
                                      !  with added NRLACQC events
      parameter (outlun=61)

      integer    proflun              ! output unit number for post-PREPACQC PREPBUFR-like
                                      !  file containing merged profile reports (always) and
      parameter (proflun=62)

      integer    max_reps             ! maximum number of input merged (mass + wind piece)
                                      !  aircraft-type reports allowed
      parameter (max_reps = 300000)

cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c replace above with this in event of future switch to dynamic memory allocation

calloc  integer      max_reps          ! original number of input merged (mass + wind piece)
calloc                                 !  aircraft-type reports (obtained from first pass
calloc                                 !  through input PREPBUFR file to get total for array
calloc                                 !  allocation should = nrpts4QC_pre)
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

      integer    maxflt               ! maximum number of flights allowed (inside NRL QC)
      parameter (maxflt = 12500)
      character*6  cmaxflt            ! character form of maxflt

      integer    imiss                ! NRL integer missing value flag
      parameter (imiss = 99999)

      real       amiss                ! NRL real missing value flag
      parameter (amiss = -9999.)

      real*8     bmiss                ! BUFR missing value
      real*8     getbmiss             ! Function to return current bmiss value from BUFRLIB

      real         m2ft               ! NRL conversion factor to convert m to ft

      parameter (m2ft = 3.28084)

c ----------------------
c Declaration statements
c ----------------------

c Indices/counters
c ----------------
      integer      i,j                ! loop indeces

      integer      nrpts4QC_pre       ! original number of input merged (mass + wind piece)
                                      !  aircraft-type reports (read in from PREPBUFR file)
                                      !  (after all is said and done, should equal nrpts4QC +
                                      !   krej)

      integer      nrpts4QC           ! number of merged (mass + wind piece) reports going
                                      !  through NRL QC code  (initially equals nrpts4QC_pre,
                                      !  then reduced as processing continues - ultimately
                                      !  includes only "good" reports)

      integer      krej               ! number of merged (mass + wind piece) reports
                                      !  ulimately rejected by NRL QC code

c Observation variables required by the NRL aircraft QC routine
c -------------------------------------------------------------
      character*10   cdtg_an          ! date-time group for analysis (YYYYMMDDCC)


      character*11 c_qc(max_reps)     ! character QC flags output from NRL QC code
                                      !   1st char - info about reject (if ob was rejected)
                                      !   2nd char - reason why time was rejected
                                      !   3rd char - reason why latitude was rejected
                                      !   4th char - reason why longitude was rejected
                                      !   5th char - reason why pressure/atitude was rejected
                                      !   6th char - readon why temperature was rejected
                                      !   7th char - reason why wind direction was rejected
                                      !   8th char - reason why wind speed was rejected
                                      !   9th char - reason why mixing ratio was rejected
                                      !  10th char - reason for blacklisting the aircraft
                                      !  11th char - info about flight phase

      character*25 csort(max_reps)    ! variable (sort key) used for sorting data in NRL QC
                                      !  code

      integer      itype(max_reps)     ! instrument (aircraft) type
      real*8       alat(max_reps)      ! latitude
     +,            alon(max_reps)      ! longitude
      real         pres(max_reps)      ! pressure
     +,            ht_ft(max_reps)     ! altitude in feet
      integer      idt(max_reps)       ! time in seconds to anal. time (- before, + after)
      integer      idp(max_reps)       ! surface pressure change at ob location (not created
                                       !  anywhere, set to missing)
      integer      ncep_qm_p(max_reps) ! NCEP PREPBUFR quality mark pressure (PQM)
     +,            ncep_rc_p(max_reps) ! NCEP PREPBUFR NRLACQC pressure event reason code(PRC)
     +,            ncep_qm_z(max_reps) ! NCEP PREPBUFR quality mark on altitude (ZQM)
     +,            ncep_rc_z(max_reps) ! NCEP PREPBUFR NRLACQC alt/hght event reason code(ZRC)
     +,            ncep_qm_t(max_reps) ! NCEP PREPBUFR quality mark on temperature (TQM)
     +,            ncep_rc_t(max_reps) ! NCEP PREPBUFR NRLACQC temperature evnt rea. code(TRC)
     +,            ncep_qm_q(max_reps) ! NCEP PREPBUFR quality mark on moisture (QQM)
     +,            ncep_rc_q(max_reps) ! NCEP PREPBUFR NRLACQC moisture reason code (QRC)
     +,            ncep_qm_w(max_reps) ! NCEP PREPBUFR quality mark on wind (WQM)
     +,            ncep_rc_w(max_reps) ! NCEP PREPBUFR NRLACQC wind event reason code (WRC)
     +,            ncep_rej(max_reps)  ! NCEP PREPBUFR rejection indicator

      character*14 c_dtg(max_reps)     ! full date-time group (yyyymmddhhmmss)
      character*8  c_acftreg(max_reps) ! aircraft registration (tail) number (used in NRL QC
                                       !  QC processing)
      character*9  c_acftid(max_reps)  ! aircraft flight number (used in NRL QC processing)

      real         t_prcn(max_reps)    ! temperature precision
     +,            ob_t(max_reps)      ! temperature
     +,            ob_q(max_reps)      ! moisture (specific humidity)
     +,            ob_dir(max_reps)    ! wind direction
     +,            ob_spd(max_reps)    ! wind speed
     +,            xiv_t(max_reps)     ! temperature innovation/increment (ob-bg)
     +,            xiv_q(max_reps)     ! specific humidity innovation/increment (ob-bg)
     +,            xiv_d(max_reps)     ! wind direction innovation/increment (ob-bg)
     +,            xiv_s(max_reps)     ! wind speed innovation/increment (ob-bg)

      integer      ichk_t(max_reps)    ! NRL QC flag for temperature ob
     +,            ichk_q(max_reps)    ! NRL QC flag for specific humidity ob
     +,            ichk_d(max_reps)    ! NRL QC flag for wind direction ob
     +,            ichk_s(max_reps)    ! NRL QC flag for wind speed ob
     +,            nchk_t(max_reps)    ! NCEP QC flag for temperature ob
     +,            nchk_q(max_reps)    ! NCEP QC flag for specific humidity ob
     +,            nchk_d(max_reps)    ! NCEP QC flag for wind direction ob
     +,            nchk_s(max_reps)    ! NCEP QC flag for wind speed ob
     +,            phase(max_reps)     ! phase of flight for aircraft

      logical      l_minus9c(max_reps) ! true for MDCRS -9C temperatures

c Pointers
c --------
      integer      indx(max_reps)      ! pointer index in NRL QC for good reports
     +,            in_bad(max_reps)    ! pointer index in NRL QC for bad reports
     +,            isave(max_reps)     ! second pointer index in NRL QC

c **************************************************
c  All below are output from NRL acftobs_qc routine
c **************************************************

c Flight statistics
c -----------------
      character*8  creg_flt(maxflt)    ! tail number for each flight
      character*9  cid_flt(maxflt)     ! flight id for each flight
     +,            cid_flt_old(maxflt) ! previous value of cid_flt
      integer      nobs_flt(maxflt)    ! number of reports per flight
     +,            ntot_flt(maxflt)    ! total number of reports per flight
     +,            ntot_flt_old(maxflt)! previous value of total num of reports per flt
     +,            nrej_flt(maxflt)    ! number of reports rejected per flight
     +,            nrej_flt_old(maxflt)! previous value of num of reports rejected per flt
     +,            iobs_flt(maxflt)    ! index for first report in each flight
     +,            kflight             ! number of flights in dataset
      logical      l_newflt(maxflt)    ! true if flight is new flight

c Tail number statistics
c ----------------------
      character*8  creg_reg(maxflt)    ! tail numbers
      integer      nobs_reg(maxflt,5)  ! number of reports per tail number per type
     +,            ntot_reg(maxflt,5)  ! total number of reports rejected per tail number
     +,            nrej_reg(maxflt,5)  ! number of reports rejected per tail number
     +,            ntemp_reg(maxflt,5) ! number of reports with rejected temperature
     +,            nwind_reg(maxflt,5) ! number of reports with rejected wind
     +,            nwhol_reg(maxflt,5) ! number of reports with temperature in whole degrees

      character*10 creg_reg_tot(maxflt)     ! master list of tail numbers
      integer      nobs_reg_tot(maxflt,5)   ! number of reports per tail number
     +,            nwhol_reg_tot(maxflt,5)  ! number of temperatures in whole degs/tail number
     +,            nrej_reg_tot(maxflt,5)   ! number of reports rejected per tail number
     +,            ntemp_reg_tot(maxflt,5)  ! number of temperatures rejected per tail number
     +,            nwind_reg_tot(maxflt,5)  ! number of winds rejected per tail number
     +,            nrej_inv_tot(maxflt,5)   ! number of reports rejected in subr. invalid
     +,            nrej_stk_tot(maxflt,5)   ! number of reports rejected in subr. stkchek
     +,            nrej_grc_tot(maxflt,5)   ! number of reports rejected in subr. grchek
     +,            nrej_pos_tot(maxflt,5)   ! number of reports rejected in subr. poschek
     +,            nrej_ord_tot(maxflt,5)   ! number of reports rejected in subr. ordchek
     +,            nrej_sus_tot(maxflt,5)   ! number of reports rejected in suspect data check

      integer      lead_t_tot(maxflt,11,2)  ! distribution of temperature innovations
     +,            lead_d_tot(maxflt,11,2)  ! distribution of wind direction innovations
     +,            lead_s_tot(maxflt,11,2)  ! distribution of wind speed innovations
     +,            n_xiv_t(maxflt,2)        ! number of temperature innovations
     +,            n_xiv_d(maxflt,2)        ! number of wind direction innovations
     +,            n_xiv_s(maxflt,2)        ! number of wind speed innovations

      real         sum_xiv_t(maxflt,2)      ! sum of temperature innovations
     +,            sum_xiv_d(maxflt,2)      ! sum of wind direction innovations
     +,            sum_xiv_s(maxflt,2)      ! sum of wind speed innovations
     +,            sumabs_xiv_t(maxflt,2)   ! sum of absolute value of temperature innovations
     +,            sumabs_xiv_d(maxflt,2)   ! sum of absolute value of wind dir. innovations
     +,            sumabs_xiv_s(maxflt,2)   ! sum of absolute value of wind speed innovations

c **************************************************

c Variables for sorting data by type, tail, flight, etc., including bad reports - will be
c  used AFTER NRL QC code in the generation of profiles PREPBUFR-like profiles file
c ---------------------------------------------------------------------------------------
      integer      iob                      ! loop index
     +,            kidt                     ! idt + 100000 (converted to charcter c_idt and
                                            !  added to csort_wbad sort key string)
     +,            iht_ft                   ! integer of ht_ft (converted to charcter c_ht_ft
                                            !  and added to csort_wbad sort key string)
     +,            ilon                     ! integer of alon (converted to charcter c_lon
                                            !  and added to csort_wbad sort key string)
     +,            ilat                     ! integer of alat (converted to charcter c_lat
                                            !  and added to csort_wbad sort key string)
      character*6  c_lon                    ! character form of ilon (added to csort_wbad
                                            !  sort key string)
      character*7  c_idt                    ! character form of kidt (added to csort_wbad
                                            !  sort key string)
      character*5  c_ht_ft                  ! character form of iht_ft (added to csort_wbad
                                            !  sort key string)
     +,            c_lat                    ! character form of ilat (added to csort_wbad
                                            !  sort key string)
      character*4  c_type                   ! first 4 characters defining aircraft type
                                            !  (added to csort_wbad sort key string)
      character*1  c_qc11                   ! value of 11th char in NRL c_qc string,
                                            !  specifies whether report is part of an ascent,
                                            !  descent, level leg, etc. (added to csort_wbad
                                            !  sort key string)
      character*16 c_insty_ob               ! function - convers aircraft type to character
                                            !  string ((added to csort_wbad sort key string)
      character*40 csort_wbad(max_reps)     ! variable (sort key) used to sort data after NRL
                                            !  QC code - used in generation of profiles
                                            !  PREPBUFR-like profiles file
      integer indx_wbad(max_reps)           ! sorted array index (specifies the order in
                                            !  which reports should be written to the
                                            !  PREPBUFR-like profiles file
c Namelist variables
c ------------------
      namelist /nrlacqcinput/ trad,l_otw,l_nhonly,l_doprofiles,
     +                        l_allev_pf,l_prof1lvl,l_mandlvl,tsplines

      real trad               ! Time window radius for outputting reports (if l_otw=T)
      logical l_otw           ! T=eliminate reports outside the time window radius +/- trad
     +,       l_nhonly        ! T=eliminate reports outside tropics & N. Hemisphere
     +,       l_doprofiles    ! T=create merged raob lookalike QC'd profiles from aircraft
                              !   ascents and descents (always) and output these as well as
                              !   QC'd merged single(flight)-level aircraft reports not part
                              !   of any profile (when l_prof1lvl=T) to a PREPBUFR-like file
                              !   **CAUTION: Will make code take quite a bit longer to run!
                              ! F=skip creation of merged raob lookalike QC'd profiles from
                              !   aircraft ascents and descents into PREPBUFR-like file
     +,       l_allev_pf      ! T=process latest (likely NRLACQC) events plus all prior
                              !   events into profiles PREPBUFR-like file
                              !   **CAUTION: More complete option, but will make code take
                              !              longer to run!
                              ! F=process ONLY latest (likely NRLACQC) events into profiles
                              !   PREPBUFR-like file
                              !
                              ! Note 1: Hardwired to F if l_doprofiles=F
                              ! Note 2: All pre-existing events plus latest (likely NRLACQC)
                              !         events are always encoded into full PREPBUFR file)
     +,       l_prof1lvl      ! T=encode merged single(flight)-level aircraft reports with
                              !   NRLACQC events that are not part of any profile into
                              !   PREPBUFR-like file, along with merged profiles from
                              !   aircraft ascents and descents
                              !   **CAUTION: Will make code take a bit longer to run!
                              ! F=do not encode merged single(flight)-level aircraft reports
                              !   with NRLACQC events that are not part of any profile into
                              !   PREPBUFR-like file - only merged profiles from aircraft
                              !   ascents and descents will be encoded into this file
                              ! Note : Applicable only when l_doprofiles=T
     +,       l_mandlvl       ! T=interpolate to mandatory levels in profile generation
                              ! F=do not interpolate to mandatory levels in profile
                              !   generation
     +,       tsplines        ! T=use tension-splines for aircraft vertical velocity
                              !   calculation
                              ! F=use finite-differencing for aircraft vertical velocity
                              !   calculation
                              ! Note : Applicable only when l_doprofiles=T

c Variables used to hold original aircraft data read from the input PREPBUFR file - necessary
c  for carrying data through program so that it can be written to output profiles PREPBUFR-
c  like file from memory instead of going back to input PREPBUFR file and re-reading that
c  file before adding any QC events resulting from a decision made by the NRL QC routine (not
c  applicable for case of single-level QC'd reports written back to full PREPBUFR file)
c --------------------------------------------------------------------------------------------
      integer      mxnmev             ! maximum number of events allowed in stack
      parameter (mxnmev = 15)

      integer      mxlv               ! maximum number of report levels allowed in aircraft
                                      !  profiles
      parameter(mxlv = 255)


      integer nevents(max_reps,6)     ! array tracking number of events for variables for
                                      !  each report:
                                      !   1 - number of pressure events
                                      !   2 - number of specific humidity events
                                      !   3 - number of temperature events
                                      !   4 - number of altitude events
                                      !   5 - number of wind (u/v) events
                                      !   6 - number of wind (direction/speed) events
      integer nnestreps(4,max_reps)   ! number of "nested replications" for TURB3SEQ,
                                      !  PREWXSEQ, CLOUDSEQ, AFIC_SEQ

      real*8  pob_ev(max_reps,mxnmev) ! POB values for each report, including all events
     +,       pqm_ev(max_reps,mxnmev) ! PQM values for each report, including all events
     +,       ppc_ev(max_reps,mxnmev) ! PPC values for each report, including all events
     +,       prc_ev(max_reps,mxnmev) ! PRC values for each report, including all events
     +,       zob_ev(max_reps,mxnmev) ! ZOB values for each report, including all events
     +,       zqm_ev(max_reps,mxnmev) ! ZQM values for each report, including all events
     +,       zpc_ev(max_reps,mxnmev) ! ZPC values for each report, including all events
     +,       zrc_ev(max_reps,mxnmev) ! ZRC values for each report, including all events
     +,       tob_ev(max_reps,mxnmev) ! TOB values for each report, including all events
     +,       tqm_ev(max_reps,mxnmev) ! TQM values for each report, including all events
     +,       tpc_ev(max_reps,mxnmev) ! TPC values for each report, including all events
     +,       trc_ev(max_reps,mxnmev) ! TRC values for each report, including all events
     +,       qob_ev(max_reps,mxnmev) ! QOB values for each report, including all events
     +,       qqm_ev(max_reps,mxnmev) ! QQM values for each report, including all events
     +,       qpc_ev(max_reps,mxnmev) ! QPC values for each report, including all events
     +,       qrc_ev(max_reps,mxnmev) ! QRC values for each report, including all events
     +,       uob_ev(max_reps,mxnmev) ! UOB values for each report, including all events
     +,       vob_ev(max_reps,mxnmev) ! VOB values for each report, including all events
     +,       wqm_ev(max_reps,mxnmev) ! WQM values for each report, including all events
     +,       wpc_ev(max_reps,mxnmev) ! WPC values for each report, including all events
     +,       wrc_ev(max_reps,mxnmev) ! WRC values for each report, including all events
     +,       ddo_ev(max_reps,mxnmev) ! DDO values for each report, including all events
     +,       ffo_ev(max_reps,mxnmev) ! FFO values for each report, including all events
     +,       dfq_ev(max_reps,mxnmev) ! DFQ values for each report, including all events
     +,       dfp_ev(max_reps,mxnmev) ! DFP values for each report, including all events
     +,       dfr_ev(max_reps,mxnmev) ! DFR values for each report, including all events

     +,       hdr(max_reps,15)        ! SID XOB YOB DHR ELV TYP T29 TSB ITP SQN PROCN RPT
                                      !  TCOR RSRD EXRSRD
     +,       acid(max_reps)          ! ACID
     +,       rct(max_reps)           ! RCT

     +,       pbg(max_reps,3)         ! POE PFC PFCMOD
     +,       zbg(max_reps,3)         ! ZOE ZFC ZFCMOD
     +,       tbg(max_reps,3)         ! TOE TFC TFCMOD
     +,       qbg(max_reps,3)         ! QOE QFC QFCMOD
     +,       wbg(max_reps,5)         ! WOE UFC VFC UFCMOD VFCMOD

     +,       ppp(max_reps,3)         ! PAN PCL PCS
     +,       zpp(max_reps,3)         ! ZAN ZCL ZCS
     +,       tpp(max_reps,3)         ! TAN TCL TCS
     +,       qpp(max_reps,3)         ! QAN QCL QCS
     +,       wpp(max_reps,6)         ! UAN VAN UCL VCL UCS VCS

     +,       drinfo(max_reps,3)      ! XOB YOB DHR
     +,       acft_seq(max_reps,2)    ! PCAT POAF

     +,       turb1seq(max_reps)      ! TRBX
     +,       turb2seq(max_reps,4)    ! TRBX10 TRBX21 TRBX32 TRBX43
     +,       turb3seq(3,max_reps,5)  ! DGOT HBOT HTOT
     +,       prewxseq(1,max_reps,5)  ! PRWE
     +,       cloudseq(5,max_reps,5)  ! VSSO CLAM CLTP HOCB HOCT
     +,       afic_seq(3,max_reps,5)  ! AFIC HBOI HTOI
     +,       mstq(max_reps)          ! MSTQ
     +,       cat(max_reps)           ! CAT
     +,       rolf(max_reps)          ! ROLF

     +,       sqn(max_reps,2)         ! SQN (1=SQN for mass, 2=SQN for wind)
     +,       procn(max_reps,2)       ! PROCN (1=PROCN for mass, 2=PROCN for wind)

cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c add these in place of above declar. in event of future switch to dynamic memory allocation

calloc  character*11,allocatable :: c_qc(:)
calloc  character*25,allocatable :: csort(:)
calloc  integer,allocatable :: itype(:)
calloc  real*8, allocatable :: alat(:)
calloc  real*8, allocatable :: alon(:)
calloc  real,   allocatable :: pres(:)
calloc  real,   allocatable :: ht_ft(:)
calloc  integer,allocatable :: idt(:)
calloc  integer,allocatable :: idp(:)
calloc  character*14,allocatable :: c_dtg(:)
calloc  character*8, allocatable :: c_acftreg(:)
calloc  character*9, allocatable :: c_acftid(:)
calloc  real,   allocatable :: t_prcn(:)
calloc  real,   allocatable :: ob_t(:)
calloc  real,   allocatable :: ob_q(:)
calloc  real,   allocatable :: ob_dir(:)
calloc  real,   allocatable :: ob_spd(:)
calloc  real,   allocatable :: xiv_t(:)
calloc  real,   allocatable :: xiv_q(:)
calloc  real,   allocatable :: xiv_d(:)
calloc  real,   allocatable :: xiv_s(:)
calloc  integer,allocatable :: ichk_t(:)
calloc  integer,allocatable :: ichk_q(:)
calloc  integer,allocatable :: ichk_d(:)
calloc  integer,allocatable :: ichk_s(:)
calloc  integer,allocatable :: nchk_t(:)
calloc  integer,allocatable :: nchk_q(:)
calloc  integer,allocatable :: nchk_d(:)
calloc  integer,allocatable :: nchk_s(:)
calloc  integer,allocatable :: phase(:)
calloc  logical,allocatable :: l_minus9c(:)
calloc  integer,allocatable :: indx(:)
calloc  integer,allocatable :: in_bad(:)
calloc  integer,allocatable :: isave(:)
calloc  character*40,allocatable :: csort_wbad(:)
calloc  integer,allocatable :: indx_wbad(:)
calloc  integer,allocatable :: nevents(:,:)
calloc  integer,allocatable :: nnestreps(:,:)
calloc  real*8,allocatable :: pob_ev(:,:)
calloc  real*8,allocatable :: pqm_ev(:,:)
calloc  real*8,allocatable :: ppc_ev(:,:)
calloc  real*8,allocatable :: prc_ev(:,:)
calloc  real*8,allocatable :: zob_ev(:,:)
calloc  real*8,allocatable :: zqm_ev(:,:)
calloc  real*8,allocatable :: zpc_ev(:,:)
calloc  real*8,allocatable :: zrc_ev(:,:)
calloc  real*8,allocatable :: tob_ev(:,:)
calloc  real*8,allocatable :: tqm_ev(:,:)
calloc  real*8,allocatable :: tpc_ev(:,:)
calloc  real*8,allocatable :: trc_ev(:,:)
calloc  real*8,allocatable :: qob_ev(:,:)
calloc  real*8,allocatable :: qqm_ev(:,:)
calloc  real*8,allocatable :: qpc_ev(:,:)
CAlloc  real*8,allocatable :: qrc_ev(:,:)
calloc  real*8,allocatable :: uob_ev(:,:)
calloc  real*8,allocatable :: vob_ev(:,:)
calloc  real*8,allocatable :: wqm_ev(:,:)
calloc  real*8,allocatable :: wpc_ev(:,:)
calloc  real*8,allocatable :: wrc_ev(:,:)
calloc  real*8,allocatable :: ddo_ev(:,:)
calloc  real*8,allocatable :: ffo_ev(:,:)
calloc  real*8,allocatable :: dfq_ev(:,:)
calloc  real*8,allocatable :: dfp_ev(:,:)
calloc  real*8,allocatable :: dfr_ev(:,:)
calloc  real*8,allocatable :: hdr(:,:)
calloc  real*8,allocatable :: acid(:)
calloc  real*8,allocatable :: rct(:)
calloc  real*8,allocatable :: pbg(:,:)
calloc  real*8,allocatable :: zbg(:,:)
calloc  real*8,allocatable :: tbg(:,:)
calloc  real*8,allocatable :: qbg(:,:)
calloc  real*8,allocatable :: wbg(:,:)
calloc  real*8,allocatable :: ppp(:,:)
calloc  real*8,allocatable :: zpp(:,:)
calloc  real*8,allocatable :: tpp(:,:)
calloc  real*8,allocatable :: qpp(:,:)
calloc  real*8,allocatable :: wpp(:,:)
calloc  real*8,allocatable :: drinfo(:,:)
calloc  real*8,allocatable :: acft_seq(:,:)
calloc  real*8,allocatable :: turb1seq(:)
calloc  real*8,allocatable :: turb2seq(:,:)
calloc  real*8,allocatable :: turb3seq(:,:,:)
calloc  real*8,allocatable :: prewxseq(:,:,:)
calloc  real*8,allocatable :: cloudseq(:,:,:)
calloc  real*8,allocatable :: afic_seq(:,:,:)
calloc  real*8,allocatable :: mstq(:)
calloc  real*8,allocatable :: cat(:)
calloc  real*8,allocatable :: rolf(:)
calloc  real*8,allocatable :: sqn(:,:)
calloc  real*8,allocatable :: procn(:,:)

c Variables for reading numeric data out of BUFR files via BUFRLIB
c ----------------------------------------------------------------
calloc  real*8       sqn_8             ! array holding BUFR subset sequence number from
calloc                                 !  BUFRLIB call to input PREPBUFR file
calloc  integer      nlev              ! number of report levels returned from BUFRLIB call
calloc  Integer      iret              ! return code for call to BUFRLIB routine readns

c Functions
c ---------
calloc  integer      ireadmg           ! for reading messages
callo+,              ireadsb           ! for reading subsets


c Variables for BUFRLIB interface
c -------------------------------
calloc  character*8  mesgtype          ! mesgtype of message
calloc  integer      mesgdate          ! date time from BUFR message

c Variables for determining whether consecutive reports are mass and wind pieces that belong
c  together
c ------------------------------------------------------------------------------------------
calloc  logical l_match
calloc  real sqn_current, sqn_next

c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

c Miscellaneous
c -------------
      integer    nrlacqc_pc              ! PREPBUFR program code for the NRL PREPACQC step

      logical    l_first_date            ! true for first date (used inside NRL QC code)
      data       l_first_date /.true./   ! always initialize as T

      logical    l_operational           ! run program in operational mode if true
      data       l_operational /.true./  ! will get reset to F within acftobs_qc since
                                         !  l_ncep=T; must be set to true here so that the
                                         !  first l_operational=F section of the if block in
                                         !  acftobs_qc.f will get skipped over
                              ! DAK: would code run faster if l_operational=F?, does it give
                              !      same answers I wonder ??
      logical    l_pc                    ! true if running checkout at NRL (used inside NRL
                                         !  QC code)
      data       l_pc /.false./          ! always set to F
      logical    l_last                  ! true if last time subroutine acftobs_qc is called
      data       l_last /.true./         ! DAK: I think this should be set to T
      logical    l_ncep                  ! run NRL QC code using NCEP preferences if true
      data       l_ncep /.true./         ! always set to T

c Machine characteristics (obtained from W3FI04)
c ----------------------------------------------
      integer    lwr                     ! machine word length in bytes (either 4 or 8)
     +,          ichtp                   ! machine charatcer type (either 0 for ASCII or 1
                                         !  for EBCDIC)
     +,          iendn                   ! machine Endian configuration (either 0 for Big-
                                         !  Endian or 1 for Little-Endian)

c **********************************************************************************

c Start program
c -------------
      call w3tagb('PREPOBS_PREPACQC',2016,344,1927,'NP22')

      write(*,*)
      write(*,*) '************************************************'
      write(*,*) 'Welcome to PREPOBS_PREPACQC, version 2016-12-09 '
      call system('date')
      write(*,*) '************************************************'
      write(*,*)

C On WCOSS should always set BUFRLIB missing (BMISS) to 10E8 to avoid overflow when either an
C  INTEGER*4 variable is set to BMISS or a REAL*8 (or REAL*4) variable that is missing is
C  NINT'd
C -------------------------------------------------------------------------------------------
ccccc call setbmiss(10E10_8)
      call setbmiss(10E8_8)
      bmiss = getbmiss()
      print *
      print *, 'BUFRLIB value for missing is: ',bmiss
      print *

c Initialize observation arrays
c -----------------------------
      c_qc      = '-----------'
      idp       = imiss  ! this is not created anywhere (even inside acftobs_qc)

c Call W3FI04 to determine machine characteristics {word length (bytes), character type
c  (ASCII or EBCDIC), and Endian-type (Big or Little)}
c -------------------------------------------------------------------------------------
      call w3fi04(iendn,ichtp,lwr)
      print 2213, lwr, ichtp, iendn
 2213 format(/' ---> CALL TO W3FI04 RETURNS: LWR = ',I3,', ICHTP = ',i3,
     + ', IENDN = ',I3/)

c......................................................
      if(ichtp.ne.0)  then

C Characters on this machine are not ASCII!! -- stop 79
c -----------------------------------------------------
        print 217
  217 format(/5x,'++ CHARACTERS ON THIS MACHINE ARE NOT ASCII - STOP ',
     + '79'/)
        call w3tage('PREPOBS_PREPACQC')
        call errexit(79)
      endif
c......................................................

c Read in namelist nrlacqcinput, but set namelist defaults first
c --------------------------------------------------------------
      trad         =    3.0
      l_otw        = .false.
      l_nhonly     = .false.
      l_doprofiles = .false.
      l_allev_pf   = .false.
      l_prof1lvl   = .false.
      l_mandlvl    = .true.
      tsplines     = .true.

      read(5,nrlacqcinput,end=10)
   10 continue
      write(6,nrlacqcinput)

      if(.not.l_doprofiles) l_allev_pf = .false. ! l_allev_pf always set to FALSE if profiles
                                                 !  are not being generated

      call datelen(10)

c Open input PREPBUFR file (contains mass and wind reports for all data types, no NRLACQC
c  events on reports in AIRCAR and AIRCFT message types)
c ---------------------------------------------------------------------------------------
      call openbf(inlun,'IN',inlun)
      print *
      print'(" Opened input PREPBUFR file with all data, including ",
     +       "pre-NRLACQC aircraft data; unit number ",I0)', inlun
      print *

c Open output PREPBUFR file (will eventually be identical to input PREPBUFR file but with
c  NRLACQC events on reports in AIRCAR and AIRCFT message types)
c ---------------------------------------------------------------------------------------
      call openbf(outlun,'OUT',inlun)
      print *
      print'(" Opened output PREPBUFR file - will hold all data, ",
     +       "including post-NRLACQC aircraft data; unit number ",I0)',
     +     outlun
      print *

      if(l_doprofiles) then

c Open output PREPBUFR-like file (will eventually contain merged aircraft mass/wind data in
c  AIRCAR and AIRCFT message types, including constructed profiles, with NRLACQC events on
c  reports)
c -----------------------------------------------------------------------------------------
        call openbf(proflun,'OUT',inlun)
        print *
        print'(" Opened output PREPBUFR-like file - will hold only ",
     +         "post-NRLACQC merged aircraft profile data; unit ",
     +         "number ",I0)', proflun
        print *
      endif

c Get the program code for NRLACQC
c --------------------------------
      call ufbqcd(outlun,'NRLACQC',nrlacqc_pc)

      print *
      print *, 'NRLACQC PROGRAM CODE IS: ', nrlacqc_pc
      print *

cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c add this in event of future switch to dynamic memory allocation

calloc  CALL SYSTEM('date')
calloc  max_reps = 0
calloc  l_match = .false.
calloc  write(*,*) 'First time through just get count of number of ',
callo+   'merged reports for dynamic array allocation'
calloc  loop1: do while(ireadmg(inlun,mesgtype,mesgdate).eq.0)
calloc    if((mesgtype.eq.'AIRCFT').or.
callo+       (mesgtype.eq.'AIRCAR')) then
calloc      do while(ireadsb(inlun).eq.0)
c4051         continue
calloc        l_match = .false.
calloc        if(mesgtype.ne.'AIRCAR' .and. mesgtype.ne. 'AIRCFT')
callo+         cycle loop1
c5051         continue
calloc        max_reps = max_reps + 1
calloc        call ufbint(inlun,sqn_8,1,1,nlev,'SQN')
calloc        sqn_current = sqn_8
c6051         continue
calloc        if(l_match) then
calloc          call readns(inlun,mesgtype,mesgdate,iret)
calloc          if(iret.eq.-1) then
calloc            exit
calloc          elseif(iret.eq.0) then
calloc            go to 4051
calloc          else
calloc            print *, 'Unexpected return code(iret=',iret,
callo+                     ') from readns!'
calloc            call w3tage('PREPOBS_PREPACQC')
calloc            call errexit(23) ! Problems reading BUFR file
calloc          endif
calloc        endif
calloc        call readns(inlun,mesgtype,mesgdate,iret)
calloc        if(iret.eq.-1) then
calloc          exit
calloc        elseif(iret.eq.0) then
calloc          if(mesgtype.ne.'AIRCAR' .and. mesgtype.ne. 'AIRCFT')
callo+           cycle loop1
calloc          call ufbint(inlun,sqn_8,1,1,nlev,'SQN')
calloc          sqn_next = sqn_8
calloc          if(sqn_next.eq.sqn_current) then
calloc            l_match = .true.
calloc            go to 6051
calloc          else
calloc            l_match = .false.
calloc            go to 5051
calloc          endif
calloc        else
calloc          print *, 'Unexpected return code(iret=',iret,
callo+                   ') from readns!'
calloc          call w3tage('PREPOBS_PREPACQC')
calloc          call errexit(23) ! Problems reading BUFR file
calloc        endif
calloc      enddo
calloc    endif
calloc  enddo loop1
calloc  write(*,*)
calloc  write(*,*) 'TOTAL NUM OF RPTS IN FIRST READ THROUGH: ',
callo+   max_reps
calloc  call closbf(inlun)
calloc  call openbf(inlun,'IN',inlun)
calloc  CALL SYSTEM('date')
calloc  allocate(c_qc(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(csort(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(itype(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(alat(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(alon(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(pres(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ht_ft(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(idt(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(idp(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(c_dtg(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(c_acftreg(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(c_acftid(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(t_prcn(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ob_t(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ob_q(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ob_dir(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ob_spd(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(xiv_t(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(xiv_q(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(xiv_d(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(xiv_s(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ichk_t(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ichk_q(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ichk_d(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(ichk_s(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(nchk_t(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(nchk_q(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(nchk_d(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(nchk_s(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(phase(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(l_minus9c(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(indx(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(in_bad(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(isave(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(csort_wbad(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(indx_wbad(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(nevents(max_reps,6),stat=i);if(i.ne.0) go to 901
calloc  allocate(nnestreps(4,max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(pob_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(pqm_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(ppc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(prc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(zob_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(zqm_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(zpc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(zrc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(tob_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(tqm_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(tpc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(trc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(qob_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(qqm_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(qpc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(qrc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(uob_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(vob_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(wqm_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(wpc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(wrc_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(ddo_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(ffo_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(dfq_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(dfp_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(dfr_ev(max_reps,mxnmev),stat=i);if(i.ne.0) go to 901
calloc  allocate(hdr(max_reps,15),stat=i);if(i.ne.0) go to 901
calloc  allocate(acid(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(rct(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(pbg(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(zbg(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(tbg(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(qbg(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(wbg(max_reps,5),stat=i);if(i.ne.0) go to 901
calloc  allocate(ppp(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(zpp(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(tpp(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(qpp(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(wpp(max_reps,6),stat=i);if(i.ne.0) go to 901
calloc  allocate(drinfo(max_reps,3),stat=i);if(i.ne.0) go to 901
calloc  allocate(acft_seq(max_reps,2),stat=i);if(i.ne.0) go to 901
calloc  allocate(turb1seq(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(turb2seq(max_reps,4),stat=i);if(i.ne.0) go to 901
calloc  allocate(turb3seq(3,max_reps,5),stat=i);if(i.ne.0) go to 901
calloc  allocate(prewxseq(1,max_reps,5),stat=i);if(i.ne.0) go to 901
calloc  allocate(cloudseq(5,max_reps,5),stat=i);if(i.ne.0) go to 901
calloc  allocate(afic_seq(3,max_reps,5),stat=i);if(i.ne.0) go to 901
calloc  allocate(mstq(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(cat(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(rolf(max_reps),stat=i);if(i.ne.0) go to 901
calloc  allocate(sqn(max_reps,2),stat=i);if(i.ne.0) go to 901
calloc  allocate(procn(max_reps,2),stat=i);if(i.ne.0) go to 901
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

c Call input routine input_acqc to read the input PREPBUFR file, merge the mass and wind
c  pieces, translate some values to NRL standards and store in memory (arrays)
c --------------------------------------------------------------------------------------
      write(*,*)
      write(*,*) 'Calling input_acqc....'
      write(*,*)

      call input_acqc(inlun,max_reps,mxnmev,bmiss,imiss,amiss,m2ft,mxlv,
     +                nrpts4QC_pre,cdtg_an,alat,alon,ht_ft,idt,c_dtg,
     +                itype,phase,t_prcn,c_acftreg,c_acftid,
     +                pres,ob_t,ob_q,ob_dir,ob_spd,
     +                ichk_t,ichk_q,ichk_d,ichk_s,
     +                nchk_t,nchk_q,nchk_d,nchk_s,
     +                xiv_t,xiv_q,xiv_d,xiv_s,l_minus9C,nevents,
     +                hdr,acid,rct,drinfo,acft_seq,turb1seq,turb2seq,
     +                turb3seq,prewxseq,cloudseq,afic_seq,mstq,cat,rolf,
     +                nnestreps,sqn,procn,
     +                pob_ev,pqm_ev,ppc_ev,prc_ev,pbg,ppp,
     +                zob_ev,zqm_ev,zpc_ev,zrc_ev,zbg,zpp,
     +                tob_ev,tqm_ev,tpc_ev,trc_ev,tbg,tpp,
     +                qob_ev,qqm_ev,qpc_ev,qrc_ev,qbg,qpp,
     +                uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,wbg,wpp,
     +                ddo_ev,ffo_ev,dfq_ev,dfp_ev,dfr_ev,l_allev_pf)

c Close input PREPBUFR file
c -------------------------
      call closbf(inlun)
      print *
      print'(" Closed input PREPBUFR file with all data, including ",
     +       "pre-NRLACQC aircraft data; unit number ",I0)', inlun
      print *

      write(*,*)
      write(*,*) 'Back from input_acqc....'
      write(*,'(" There are ",I0," merged reports for acftobs_qc (NRL ",
     +          "aircraft data QC routine).")') nrpts4QC_pre
      write(*,*)

      if(nrpts4QC_pre.gt.0) then

c Now that we are done reading in data from the input PREPBUFR file, need to call acftobs_qc
c  (actual NRL aircraft QC code)
c ------------------------------------------------------------------------------------------
      write(*,*) 'Passing ',nrpts4QC_pre,'obs to acftobs_qc.f...'
      write(*,*)
      write(*,*) 'Calling acftobs_qc...'

c NRPTS4QC_PRE is returned from input_acqc and represents the original number of "merged"
c  reports (mass and wind pieces put together) read in from the PREPBUFR file - we need to
c  save this value now as it will be used later (e.g., to correctly match the QC decisions
c  made by acftobs_qc to the reports originally in the input PREPBUFR file) - we will set
c  NRPTS4qc to NRPTS4QC_PRE at this point and then pass NRPTS4QC into acftobs_qc - the value
c  for NRPTS4Qc gets reduced in the various subroutines in acftobs_qc as it only represents
c  the number of "good" reports coming out of each subroutine
c-------------------------------------------------------------------------------------------  
      nrpts4QC = nrpts4QC_pre

      call acftobs_qc(max_reps,cdtg_an,nrpts4QC,krej,c_acftreg,c_acftid,
     +                itype,idt,idp,alon,alat,pres,ht_ft,ob_t,ob_q,
     +                ob_dir,ob_spd,t_prcn,xiv_t,xiv_q,xiv_d,xiv_s,
     +                ichk_t,ichk_q,ichk_d,ichk_s,nchk_t,nchk_q,nchk_d,
     +                nchk_s,indx,isave,in_bad,c_qc,csort,maxflt,
     +                kflight,creg_flt,cid_flt,cid_flt_old,l_newflt,
     +                nobs_flt,iobs_flt,ntot_flt,nrej_flt,ntot_flt_old,
     +                nrej_flt_old,creg_reg,nobs_reg,ntot_reg,nrej_reg,
     +                ntemp_reg,nwind_reg,nwhol_reg,creg_reg_tot,
     +                nobs_reg_tot,nwhol_reg_tot,nrej_reg_tot,
     +                ntemp_reg_tot,nwind_reg_tot,nrej_inv_tot,
     +                nrej_stk_tot,nrej_grc_tot,nrej_pos_tot,
     +                nrej_ord_tot,nrej_sus_tot,lead_t_tot,lead_d_tot,
     +                lead_s_tot,n_xiv_t,n_xiv_d,n_xiv_s,sum_xiv_t,
     +                sum_xiv_d,sum_xiv_s,sumabs_xiv_t,sumabs_xiv_d,
     +                sumabs_xiv_s,l_minus9c,l_last,l_first_date,
     +                l_operational,l_pc,l_ncep,*99)

      go to 34

c-----------------------------------
   99 continue  ! return 1 out of subr. acftobs_qc comes here - keep going but post message
      print 153, maxflt,maxflt
  153 format(/' #####> WARNING: THERE ARE MORE THAN ',I6,' AIRCRAFT ',
     + '"FLIGHTS" IN INPUT FILE -- MUST INCREASE SIZE OF PARAMETER ',
     +'NAME "MAXFLT" - WILL CONTINUE ON PROCESSING ONLY ',I6,' FLTS-0'/)
      write(cmaxflt,'(i6)') maxflt
      call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     + ' "$jlogfile" "***WARNING:'//cmaxflt//' AIRCRAFT "FLIGHT" '//
     + 'LIMIT EXCEEDED IN PREPOBS_PREPACQC, ONLY '//
     + cmaxflt//' FLIGHTS PROCESSED-0"')
c-----------------------------------

   34 continue

      write(*,'(" After running acftobs_qc, there are ",I0," good ",
     +          "reports, ",I0," bad reports (total rpts = ",I0,")")')
     +        nrpts4QC,krej,nrpts4QC_pre
      write(*,*)
      write(*,*)

c Sort reports (including bad ones) into profiles (sort logic and sort key construction
c  borrowed from acftobs_qc) (note this is done even if l_doprofiles = FALSE because it
c  is used in the final listing of single-level aircraft reports)
c -------------------------------------------------------------------------------------

c Initialize sort key and sort index
c ----------------------------------
      do i=1,max_reps
        csort_wbad(i)   = 'zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz'
        indx_wbad(i) = i 
      enddo

c Form variable to sort / sort key
c --------------------------------
      write(*,'(" Sorting reports and creating sort index, including ",
     +          "reports marked as bad....")')
 
      do iob=1,nrpts4QC_pre
 
        kidt = idt(iob) + 100000
        if(kidt.ge.1000000) then
          write(*,*)
          write(*,*) '** WARNING: kidt too large (=',kidt,')'
          write(*,*)
          write (*,8073) iob,c_insty_ob(itype(iob)),c_acftreg(iob),
     +                   c_acftid(iob),idt(iob),alat(iob),alon(iob),
     +                   pres(iob),ht_ft(iob),t_prcn(iob),ob_t(iob),
     +                   xiv_t(iob),ichk_t(iob),ob_q(iob),xiv_q(iob),
     +                   ichk_q(iob),ob_dir(iob),xiv_d(iob),ichk_d(iob),
     +                   ob_spd(iob),xiv_s(iob),ichk_s(iob),idp(iob)
 8073 format(i5,1x,a8,1x,a8,1x,a9,1x,i7,1x,2f11.5,1x,f8.1,1x,f7.0,1x,
     +       f5.2,4(2(1x,f8.2),1x,i5),1x,i4)
          write(*,*)
          kidt = 999999
        endif
        write(c_idt,'(i6)') kidt
 
        if(ht_ft(iob).eq.amiss) then
          c_ht_ft = '99999'
        else
          iht_ft = nint(ht_ft(iob))
          if(iht_ft.ge.100000) then
            write(*,*)
            write(*,*) '** WARNING: iht_ft too large (=',iht_ft,')'
            write (*,8073) iob,c_insty_ob(itype(iob)),c_acftreg(iob),
     +                     c_acftid(iob),idt(iob),alat(iob),alon(iob),
     +                     pres(iob),ht_ft(iob),t_prcn(iob),ob_t(iob),
     +                     xiv_t(iob),ichk_t(iob),ob_q(iob),xiv_q(iob),
     +                     ichk_q(iob),ob_dir(iob),xiv_d(iob),
     +                     ichk_d(iob),ob_spd(iob),xiv_s(iob),
     +                     ichk_s(iob),idp(iob)
            write(*,*)
            iht_ft = 99999
          endif

c Make descents look like ascents for sorting purposes (complication comes in when a descent
c  has two obs with the same time, but different altitudes)
c
c *** -> Need to make sure to reverse order upon writing to output in output_acqc_prof for
c         descents - profile levels need to be ordered by decreasing pressure (for example,
c         1st lvl = 1010 mb, 2nd lvl = 987 mb, 3rd lvl = 764 mb, etc.)
c -----------------------------------------------------------------------------------------
	  if(c_qc(iob)(11:11).eq.'d' .or. c_qc(iob)(11:11).eq.'D')
     +     iht_ft = 50000 + (-1)*iht_ft

          if(iht_ft.ge.0) then
            write(c_ht_ft,'(i5.5)') iht_ft
          else
            write(c_ht_ft,'(i5.4)') iht_ft
          endif
        endif
 
! vvvv DAK-future change perhaps to account for incr. lat/lon precision
        if(alat(iob).eq.amiss) then
          c_lat = '99999'
        else
          ilat = nint(alat(iob)*100.)
          if(abs(ilat).ge.100000) then
            write(*,*)
            write(*,*) '** WARNING: ilat too large (=',ilat,')'
            write (*,8073) iob,c_insty_ob(itype(iob)),c_acftreg(iob),
     +                     c_acftid(iob),idt(iob),alat(iob),alon(iob),
     +                     pres(iob),ht_ft(iob),t_prcn(iob),ob_t(iob),
     +                     xiv_t(iob),ichk_t(iob),ob_q(iob),xiv_q(iob),
     +                     ichk_q(iob),ob_dir(iob),xiv_d(iob),
     +                     ichk_d(iob),ob_spd(iob),xiv_s(iob),
     +                     ichk_s(iob),idp(iob)
            write(*,*)
            ilat = 99999
          endif
          write(c_lat,'(i5)') ilat
        endif
 
        if(alon(iob).eq.amiss) then
          c_lon = '999999'
        else
          ilon = nint(alon(iob)*100.)
          if(abs(ilon).ge.1000000) then
            write(*,*)
            write(*,*) '** WARNING: ilon too large (=',ilon,')'
            write (*,8073) iob,c_insty_ob(itype(iob)),c_acftreg(iob),
     +                     c_acftid(iob),idt(iob),alat(iob),alon(iob),
     +                     pres(iob),ht_ft(iob),t_prcn(iob),ob_t(iob),
     +                     xiv_t(iob),ichk_t(iob),ob_q(iob),xiv_q(iob),
     +                     ichk_q(iob),ob_dir(iob),xiv_d(iob),
     +                     ichk_d(iob),ob_spd(iob),xiv_s(iob),
     +                     ichk_s(iob),idp(iob)
            write(*,*)
            ilon = 999999
          endif
          write(c_lon,'(i6)') ilon
        endif
! ^^^^ DAK-future change perhaps to account for incr. lat/lon precision
 
        c_type = c_insty_ob(itype(iob))

c NRL sort key: 
c -------------
cc Option 1: not used
cc      csort_wbad(iob) = c_idt(1:6)          ! time
cc   +                  //c_ht_ft(1:5)        ! altitude
cc   +                  //c_lat(1:5)          ! latitude
cc   +                  //c_lon(1:6)          ! longitude
cc   +                  //c_type(1:2)         ! aircraft type

cc Option 2: not used (tail number first)
cc      csort_wbad(iob) = c_acftreg(iob)(1:7) ! tail number
cc   +                  //c_acftid(iob)(1:7)  ! flight number
cc   +                  //c_idt(1:6)          ! time
cc   +                  //c_ht_ft(1:5)        ! altitude
cc   +                  //c_lat(1:5)          ! latitude
cc   +                  //c_type(1:2)         ! aircraft type

cc Option 3: not used (use type first to group AIRCFT and AIRCAR message types together)
cc      csort_wbad(iob) = c_type(1:2)         ! aircraft type
cc   +                  //c_acftreg(iob)(1:7) ! tail number
cc   +                  //c_acftid(iob)(1:7)  ! flight number
cc   +                  //c_idt(1:6)          ! time
cc   +                  //c_ht_ft(1:5)        ! altitude
cc   +                  //c_lat(1:5)          ! latitude
cc   +                  //c_lon(1:6)          ! longitude

c Option 4: not used
c Sort by altitude before time... want descents in order with an increasing vertical
c  coordinate - but if you have two obs in a descent with the same time but different
c  altitude, the altitudes will show up reversed -- use offset to get around this
c -----------------------------------------------------------------------------------
c
c Option 5: USE THIS (sort by time then altitude that is adjusted for descents)
c -----------------------------------------------------------------------------
        if(c_qc(iob)(11:11).eq.'A') then    ! change 'A' to 'a'
          c_qc11 = 'a'
        elseif(c_qc(iob)(11:11).eq.'D') then
          c_qc11 = 'd'                      ! change 'D' to 'd'
        else
          c_qc11 = c_qc(iob)(11:11)
        endif

c Option 6: not used {sort by altitude first, then time... trust vertical coordinate more
c  than position (many less bad marks in c_qc(5:5)'s vs c_qc(2:4))}
c ---------------------------------------------------------------------------------------
        csort_wbad(iob) = c_type(1:2)//c_qc11               ! aircraft type + ascent/descent
     +                               //c_acftreg(iob)(1:8)  ! tail number
     +                               //c_acftid(iob)(1:7)   ! flight number
ccccc+                               //c_ht_ft(1:5)
ccccc+                               //c_idt(1:6)
     +                               //c_idt(1:6)           ! time
     +                               //c_ht_ft(1:5)         ! altitude
! vvvv DAK-future change perhaps to account for incr. lat/lon precision
     +                               //c_lat(1:5)           ! latitude
     +                               //c_lon(1:6)           ! longitude
! ^^^^ DAK-future change perhaps to account for incr. lat/lon precision

      enddo
 
c Sort reports in file according to array csort_wbad
c --------------------------------------------------
      call indexc40(nrpts4QC_pre,csort_wbad,indx_wbad)

      if(l_doprofiles) then ! takes longer to run, because it outputs profiles in separate
                            !  PREPBUFR-like file

c ----------------------------------------------------------------------------------
c Translate NRL QC flags to NCEP events and add events to PREPBUFRlike profiles file
c ----------------------------------------------------------------------------------
        write(*,*) 'Calling output_acqc_prof....'
        write(*,*)

        call output_acqc_prof(proflun,nrpts4QC_pre,max_reps,mxnmev,mxlv,
     +                        bmiss,cdtg_an,alat,alon,ht_ft,idt,c_qc,
     +	                      trad,l_otw,l_nhonly,indx_wbad,c_acftreg,
     +                        c_acftid,ob_t,nevents,hdr,acid,rct,drinfo,
     +                        acft_seq,mstq,cat,
     +                        pob_ev,pqm_ev,ppc_ev,prc_ev,pbg,ppp,
     +                        zob_ev,zqm_ev,zpc_ev,zrc_ev,zbg,zpp,
     +                        tob_ev,tqm_ev,tpc_ev,trc_ev,tbg,tpp,
     +                        qob_ev,qqm_ev,qpc_ev,qrc_ev,qbg,qpp,
     +                        uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,
     +                        wbg,wpp,
     +	                      ddo_ev,ffo_ev,dfq_ev,dfp_ev,dfr_ev,
     +                        real(nrlacqc_pc),l_allev_pf,l_prof1lvl,
     +                        l_mandlvl,tsplines,
     +                        l_operational,lwr)

        write(*,*)
        write(*,*)
        write(*,*) 'Back from output_acqc_prof ....'
        write(*,'(" PREPBUFR-like (profiles) file has been updated ",
     +            "with events representing the QC marks applied by ",
     +            "the NRLACQC routine acftobs_qc.")')
        write(*,*)
        write(*,*)

c Close output PREPBUFR-like (profiles) file 
c ------------------------------------------
        call closbf(proflun) ! closbf will take care of flushing last message
        print *
        print'(" Closed output PREPBUFR-like file - now holds post-",
     +         "NRLACQC merged aircraft profile data; unit number ",
     +         I0)', proflun
        print *
      endif

c ----------------------------------------------------------------------
c Always output single-level QC'd aircraft data in regular PREPBUFR file
C ----------------------------------------------------------------------

c Re-open input PREPBUFR file (contains mass and wind reports for all data types, no NRLACQC
c  events on reports in AIRCAR and AIRCFT message types)
c ------------------------------------------------------------------------------------------
      call openbf(inlun,'IN',inlun)
      print *
      print'(" Again opened input PREPBUFR file with all data, ",
     +       "including pre-NRLACQC aircraft data; unit number ",I0)',
     +     inlun
      print *


C Initialize some variables that will be set in output_acqc_noprof and used in printout
c -------------------------------------------------------------------------------------
      ncep_qm_p = 9999
      ncep_rc_p = 9999
      ncep_qm_z = 9999
      ncep_rc_z = 9999
      ncep_qm_t = 9999
      ncep_rc_t = 9999
      ncep_qm_q = 9999
      ncep_rc_q = 9999
      ncep_qm_w = 9999
      ncep_rc_w = 9999
      ncep_rej  =    0

c Translate NRL QC flags to NCEP events and add events to aircraft reports in "AIRCAR" and
c  "AIRCFT" message types in full PREPBUFR file (split mass and wind pieces)
c ----------------------------------------------------------------------------------------
      call output_acqc_noprof(inlun,outlun,nrpts4QC_pre,max_reps,bmiss,
     +                        alat,alon,ht_ft,idt,c_qc,trad,l_otw,
     +                        l_nhonly,
     +                        ncep_qm_p,ncep_rc_p,
     +                        ncep_qm_z,ncep_rc_z,
     +                        ncep_qm_t,ncep_rc_t,
     +                        ncep_qm_q,ncep_rc_q,
     +                        ncep_qm_w,ncep_rc_w,
     +                        ncep_rej,real(nrlacqc_pc))

      write(*,*)
      write(*,*)
      write(*,*) 'Back from output_acqc_noprof ....'
      write(*,'(" PREPBUFR file has been updated with events ",
     +          "representing the QC marks applied by the NRL aircraft",
     +          " QC routine acftobs_qc")')
      write(*,*)
      write(*,*)

c Close input PREPBUFR file
c -------------------------
      call closbf(inlun)
      print *
      print'(" Closed input PREPBUFR file with all data, including ",
     +       "pre-NRLACQC aircraft data; unit number ",I0)', inlun
      print *

c Close output PREPBUFR file 
c --------------------------
      call closbf(outlun) ! closbf will take care of flushing last message
      print *
      print'(" Closed output PREPBUFR file - now holds all data, ",
     +       "including post-NRLACQC aircraft data; unit number ",I0)',
     +     outlun
      print *

      if(.not.l_operational) then

c Write merged reports and resulting NRL QC decisions (array c_qc) to an output file for
c  later perusal
c --------------------------------------------------------------------------------------

        open(51,file='merged.reports.post_acftobs_qc.sorted',form=
     +       'formatted')
        write(51,*)
        write(51,'(" Final listing of all aircraft reports in PREPBUFR",
     +             " file after NRL QC (sorted according to array ",
     +             "csort_wbad)")')
        if(nrpts4QC_pre.eq.max_reps) write(51,'(" (since max report ",
     +   "limit hit, only reports going through QC listed here)")')
        write(51,'(" -------------------------------------------------",
     +             "--------------------------------------------------",
     +             "-------")')
        write(51,*)
        write(51,'(" TAMDAR reports here replace characters 1-3 of ",
     +             "manufactured flight # (''000'') with (''TAM'') in ",
     +             "order to create truncated tail # ''TAM'' for ",
     +             "NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode ''000'' in")')
        write(51,'("  characters 1-3 of manufactured flight # for ",
     +             "TAMDAR (stored as both ''SID'' and ''ACID'')")')

        write(51,*)
        write(51,'(" AIREP and PIREP reports report only a flight # ",
     +             "(manufactured for PIREPs) - a tail # for NRLACQC ",
     +             "sorting is created by truncating the flight # - ",
     +             "the PREPBUFR file will not encode these truncated ",
     +             "tail #''s")')

        write(51,*)
        write(51,'(" All AMDAR reports except LATAM report only a tail",
     +            " # - this is stored as both flight # and tail # for",
     +             " NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode only tail # (stored in ''SID'')")')
        write(51,*)
        write(51,'(" AMDAR reports from LATAM report both a tail # and",
     +             " a flight # - these are used as reported for ",
     +             "NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode both tail # and flight # (as ''SID'' and ",
     +             "''ACID'',")')
        write(51,*) 'resp.)'
        write(51,*)
        write(51,'(" MDCRS reports from ARINC report both a tail # and",
     +             " a flight # - these are used as reported for ",
     +             "NRLACQC sorting - the PREPBUFR file continues to ",
     +             "encode both tail # and flight # (as ''SID'' and ",
     +             "''ACID'',")')
        write(51,*) 'resp.)'

        write(51,*)
        write(51,3001)
 3001   format(173x,'! _PREPBUFR_QMs_!NRLACQC_REASON_CODE'/' index ',
     +         'flight    tail num itp ph      lat       lon    ',
     +         'time  hght   pres  temp/chk spec_h/chk  wspd/chk ',
     +         'wdir/chk t-prec !__qc_flag__!_______________',
     +         'csort_wbad_______________! Pq Zq Tq Qq Wq!Prc Zrc Trc ',
     +         'Qrc Wrc'/'------ --------- -------- --- --  ',
     +         '-------- --------- ------ ----- ------ --------- ',
     +         '---------- --------- -------- ------ !-----------!',
     +         '----------------------------------------! -- -- -- ',
     +         '-- --!--- --- --- --- ---')

        do i=1,nrpts4QC_pre
          j=indx_wbad(i)

          if(ncep_rej(j).eq.0) then
            write(51,fmt=8001) j,c_acftid(j),c_acftreg(j),itype(j),
     +       phase(j),alat(j),alon(j),idt(j),nint(ht_ft(j)),pres(j),
     +       ob_t(j),ichk_t(j),ob_q(j),ichk_q(j),ob_spd(j),ichk_s(j),
     +       nint(ob_dir(j)),ichk_d(j),t_prcn(j),c_qc(j),csort_wbad(j),
     +       ncep_qm_p(j),ncep_qm_z(j),ncep_qm_t(j),ncep_qm_q(j),
     +       ncep_qm_w(j),ncep_rc_p(j),ncep_rc_z(j),ncep_rc_t(j),
     +       ncep_rc_q(j),ncep_rc_w(j)
c           if(ncep_rc_p(j).ge.1000) write(51,fmt=9001) ncep_rc_p(j)
c9001       format(' PRC too large = ',i10)
c           if(ncep_rc_z(j).ge.1000) write(51,fmt=9002) ncep_rc_z(j)
c9002       format(' ZRC too large = ',i10)
c           if(ncep_rc_t(j).ge.1000) write(51,fmt=9003) ncep_rc_t(j)
c9003       format(' TRC too large = ',i10)
c           if(ncep_rc_q(j).ge.1000) write(51,fmt=9004) ncep_rc_q(j)
c9004       format(' QRC too large = ',i10)
c           if(ncep_rc_w(j).ge.1000) write(51,fmt=9005) ncep_rc_w(j)
c9005       format(' WRC too large = ',i10)
          endif
	enddo

 8001 format(i6,1x,a9,1x,a8,i4,1x,i2,2f10.5,1x,i6,1x,i5,1x,f6.1,1x,
     +       f6.2,i3,1x,f7.2,i3,1x,f6.1,i3,2x,i4,i3,1x,f6.2,1x,
     +       '!',a11,'!',a40,'!',5(1x,i2.2),'!',i3.3,4(1x,i3.3))

c Close data listing file
c -----------------------
	close(51)

      endif

c End program
c -----------

      write(*,*)
      write(*,*) '**************************'
      write(*,*) 'PREPOBS_PREPACQC has ended'
      call system('date')
      write(*,*) '**************************'
      write(*,*)
      call w3tage('PREPOBS_PREPACQC')

      else  ! nrpts4QC_pre.le.0

c Input PREPBUFR file contains NO aircraft data of any kind -- STOP 4
c -------------------------------------------------------------------

         WRITE(6,108)
  108 FORMAT(/' INPUT PREPBUFR FILE CONTAINS NO "AIRCAR" OR "AIRCFT" ',
     $ 'MESSAGES WITH REPORTS - STOP 4'/)
         CALL ERREXIT(4)

      endif ! nrpts4QC_pre.gt.0

      stop

cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c add this event of future switch to dynamic memory allocation

ca901 continue

calloc  print *, '#####PREPOBS_PREPACQC - UNABLE TO ALLOCATE ARRAYS'
calloc  call w3tage('PREPOBS_PREPACQC')
calloc  call errexit(99)
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

      end

!
!   Author: Suranjana Saha
C-----------------------------------------------------------------------
C  MAIN PROGRAM SURUFIT
C-----------------------------------------------------------------------
      PROGRAM SURUFIT
 
      PARAMETER (IDBUG=0,IPR=1)
      PARAMETER (NSTC=9)
      PARAMETER (NPLV=21)
      PARAMETER (NVAR=5)
      PARAMETER (NREG=7)
      PARAMETER (NSUB=1)
      PARAMETER (NBAK=2)
 
      CHARACTER*80 HDSTR,OBSTR,FCSTR,ANSTR,QMSTR,PSTR
      CHARACTER*8  SUBSET

      real(8)    HDR(14)
      real(8)    PSOB(4),PSPR(4)
      real(8)    BAK(10,255,NBAK)
      real(8)    OBS(10,255),QMS(10,255)

      real(8)    SPRS(NSTC,NPLV,NVAR,NREG,NSUB,NBAK)
      real(8)    CNTO,CNTN,RAT1,RAT2,WT1,WT2
      real(8)    PMAND(NPLV),PMID(NPLV)
      real(8)    STC(NSTC,5,NBAK)

      real(4)    GDATA(NREG,NSUB)

      INTEGER    INDEXV(NVAR),LEVP(1200)
      LOGICAL    MANDONLY,REGION

      DATA PMAND / 1000, 925, 850, 700, 500, 400, 300,
     .              250, 200, 150, 100,  70,  50,  30,
     .               20,  10,   7,   5,   3,   2,   1/
 
      DATA HDSTR
     ./'SID XOB YOB DHR ELV TYP T29 ITP SQN RQM DUP PRG SRC RUD'/
      DATA PSTR /'POB PAN PFC PQM CAT=0'/
      DATA OBSTR/'POB QOB TOB ZOB UOB VOB'/
      DATA FCSTR/'PFC QFC TFC ZFC UFC VFC'/
      DATA ANSTR/'PAN QAN TAN ZAN UAN VAN'/
      DATA QMSTR/'PQM QQM TQM ZQM WQM CAT'/
 
      real(8) BMISS /10E10/

      DATA RMISS / -9.99E+33 /
      DATA LUBFR/11/
      data indexv/3,4,5,2,1/
c...  t,z,w,q,ps
c
       CALL OPENBF(LUBFR,'IN ',LUBFR)
c
C-----------------------------------------------------------------------
 
C  ZERO THE FIT ARRAYS
C  -------------------
 
      SPRS = 0.
      bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

C  --------------------------------------
 
      MANDONLY = .TRUE.     ! don't use sig levels in averages
      MANDONLY = .FALSE.    ! use sig levels in averages
 
      DO I=1,1200
      LEVP(I) = 0
      ENDDO
 
      IF(.NOT.MANDONLY) THEN
         DO L=1,NPLV
         PD = PMAND(L)
         IF(L.LT.NPLV) PU = PMAND(L+1)
         IF(L.EQ.NPLV) PU = -PMAND(L)
         PMID(L) = .5*(PD+PU)
         ENDDO
 
         DO 1 I=1,1200
         DO L=1,NPLV
         IF(FLOAT(I).GT.PMID(L)) THEN
            LEVP(I) = L
            GO TO 1
         ENDIF
         ENDDO
1        ENDDO
      ELSE
         DO I=1,1200
         DO L=1,NPLV
         IF(FLOAT(I).EQ.PMAND(L)) LEVP(I) = L
         ENDDO
         ENDDO
      ENDIF
 
C  READ AND "SURU-FIT" THE PREPDA/BUFR RECORDS
C  -------------------------------------------
 
10    DO WHILE(IREADMG(LUBFR,SUBSET,IDATE).EQ.0)
c... check for subset...
      IF(ITYP(SUBSET).EQ.0) GO TO 10
11    DO WHILE(IREADSB(LUBFR).EQ.0)

c... check for raobs only...
      CALL UFBINT(LUBFR,HDR,14,  1,NLEV,HDSTR)
      if(subset.eq.'ADPUPA') then
        typx=hdr(6)
        if((typx.eq.220.).or.(typx.eq.120.)) then
          GO TO 1335
        else
          GO TO 11
        endif
      endif

1335  continue

c... check for region...
      XOB=hdr(2)
      YOB=hdr(3)
c
      IF(.NOT.REGION(XOB,YOB,0)) GO TO 11
 
C  READ THE DATA
C  -------------
      STC=0.
c... first surface pressure...
       do nn=1,4
       psob(nn)=bmiss
       enddo
       CALL UFBINT(LUBFR,PSOB, 4,1,NLEV,PSTR)
       if(nlev.eq.1) then
c
       pso =  psob(1)
       psa =  psob(2)
       psf =  psob(3)
       psq =  psob(4)
         IF(psq.LE.3 .and. psa.lt.1E10) THEN
c
            STC(1,1,1) = 1.
            STC(2,1,1) = psf
            STC(3,1,1) = pso
            STC(4,1,1) = psf*pso
            STC(5,1,1) = psf*psf
            STC(6,1,1) = pso*pso
c
            STC(1,1,2) = 1.
            STC(2,1,2) = psa
            STC(3,1,2) = pso
            STC(4,1,2) = psa*pso
            STC(5,1,2) = psa*psa
            STC(6,1,2) = pso*pso
c
c... j  is level (21)
c... k  is variable (5)
c... ll is region (7)
c... m  is subset (1)
c... n  is background (2)
c
         J=1
         K=1
         M = ITYP(SUBSET)
c
         if (M > 0) then
         DO N=1   ,NBAK
         DO LL=1  ,NREG
C
         IF(REGION(XOB,YOB,LL)) THEN
C
            cnto = SPRS(1,J,K,LL,M,N) 
            SPRS(1,J,K,LL,M,N) = SPRS(1,J,K,LL,M,N) + STC(1,K,N)
            cntn = SPRS(1,J,K,LL,M,N) 

            if(cntn.gt.cnto) then
            wt1 = cnto/cntn
            wt2 = 1.-wt1
c
            DO I=2,6
c
            sprso = SPRS(I,J,K,LL,M,N)
            rat1 = wt1*SPRS(I,J,K,LL,M,N)
            rat2 = wt2*STC(I,K,N)
c
            SPRS(I,J,K,LL,M,N) = rat1 + rat2
            sprsn = SPRS(I,J,K,LL,M,N)
c
c           if((i.eq.2).and.(n.eq.1)) then
c           write(6,3000) ll,cnto,cntn,wt1,wt2,sprso,STC(I,K,N),
c    *      rat1,rat2,sprsn
c           endif
c
c... end stat-loop
            ENDDO
c
            endif

         ENDIF
c... end region-loop
         ENDDO
C
c... end forecast-loop
         ENDDO
         endif     ! if itype > 0
C
       endif
       endif
c
c... now do the rest of the variables....
c
C  GENERATE A PRESSURE LEVEL LOOKUP TABLE
      CALL UFBINT(LUBFR,OBS,10,255,NLEV,OBSTR)
      CALL UFBINT(LUBFR,BAK(1,1,1),10,255,NLFC,FCSTR)
      CALL UFBINT(LUBFR,BAK(1,1,2),10,255,NLAN,ANSTR)
      CALL UFBINT(LUBFR,QMS,10,255,NLQM,QMSTR)

      IF(NLEV.NE.NLQM) THEN
      PRINT *,'***SURUFIT***QM LEVELS NE OB LEVELS'
      CALL ABORT
      ENDIF
      IF(NLEV.NE.NLFC) THEN
      PRINT *,'***SURUFIT***FC LEVELS NE OB LEVELS'
      CALL ABORT
      ENDIF
      IF(NLEV.NE.NLAN) THEN
      PRINT *,'***SURUFIT***AN LEVELS NE OB LEVELS'
      CALL ABORT
      ENDIF
 
C  CREATE AND ACCUMULATE THE STATISTICS ARRAY FOR EACH REALIZATION
C  ---------------------------------------------------------------
 
c... start level-loop
      DO L=1,NLEV
      STC = 0.

      qms(4,l) = max(qms(3,l),qms(4,l)) ! use tqm for zqm

      POB = OBS(1,L)
      PQM = QMS(1,L)
      CAT = QMS(6,L)

      if(idbug.eq.1) print *,' pob ',pob,' pqm ',pqm,' cat ',cat

      IF(PQM.LE.3) THEN
      J=LEVP(NINT(POB))
      IF(J.GT.0) THEN
C
c... start forecast-loop
         DO IB=1,2
C
c... start variable-loop
         DO IQ=2,5
c
         IF(OBS(IQ,L)   >=BMISS) GO TO 2234 ! protect from missing observation !
         IF(BAK(IQ,L,IB)>=BMISS) GO TO 2234 ! protect from missing background  !
         IR = IQ+1
C
         IF(QMS(IQ,L).LE.3 .AND. IQ.LT.5 .AND. CAT.NE.4) THEN
c
            IF(IQ.EQ.2) THEN
               IF(IB.EQ.1) OBS(IQ,L)=OBS(IQ,L)*1.E-3
               BAK(IQ,L,IB)=BAK(IQ,L,IB)*1.E-3
            ENDIF
c  count
            STC(1,IQ,IB) = 1.
c  f
            STC(2,IQ,IB) = BAK(IQ,L,IB)
c  o
            STC(3,IQ,IB) = OBS(IQ,L)
c  f * o
            STC(4,IQ,IB) = BAK(IQ,L,IB)*OBS(IQ,L)
c  f**2
            STC(5,IQ,IB) = BAK(IQ,L,IB)**2
c  o**2
            STC(6,IQ,IB) = OBS(IQ,L)**2
C
         ELSEIF(QMS(IQ,L).LE.3 .AND. IQ.EQ.5) THEN
c  count
            STC(1,IQ,IB) = 1.
c  uf
            STC(2,IQ,IB) = BAK(IQ,L,IB)
c  vf
            STC(3,IQ,IB) = BAK(IR,L,IB)
c  uo
            STC(4,IQ,IB) = OBS(IQ,L)
c  vo
            STC(5,IQ,IB) = OBS(IR,L)
c  uf*uo + vf*vo
            STC(6,IQ,IB) = BAK(IQ,L,IB)*OBS(IQ,L)+BAK(IR,L,IB)*OBS(IR,L)
c  uf**2 + vf**2
            STC(7,IQ,IB) = BAK(IQ,L,IB)**2 + BAK(IR,L,IB)**2
c  uo**2 + vo**2
            STC(8,IQ,IB) = OBS(IQ,L)**2 + OBS(IR,L)**2
c  sqrt (uf**2 + vf**2) - sqrt (uo**2 + vo**2)
            STC(9,IQ,IB) = SQRT(STC(7,IQ,IB)) - SQRT(STC(8,IQ,IB))
C
         ENDIF
C
         if(idbug.eq.1) then
         if(j.eq.5) print *,' ib ',ib,' iq ',iq,' stc ',
     *              (stc(k,iq,ib),k=1,3)
         endif
c
 2234    continue
c
c... end variable-loop
         ENDDO
c... end forecast-loop
         ENDDO
 
         M = ITYP(SUBSET)

         if (M > 0) then
         DO N=1   ,NBAK
         DO LL=1  ,NREG
C
         IF(REGION(XOB,YOB,LL)) THEN
C
            DO K=2,NVAR
            nstat=6
            if(k.eq.5) nstat=9

            cnto = SPRS(1,J,K,LL,M,N) 
            SPRS(1,J,K,LL,M,N) = SPRS(1,J,K,LL,M,N) + STC(1,K,N)
            cntn = SPRS(1,J,K,LL,M,N) 

            if(cntn.gt.cnto) then
            wt1 = cnto/cntn
            wt2 = 1.-wt1
c
            DO I=2,nstat
c
            sprso = SPRS(I,J,K,LL,M,N)
            rat1 = wt1*SPRS(I,J,K,LL,M,N)
            rat2 = wt2*STC(I,K,N)
c
            SPRS(I,J,K,LL,M,N) = rat1 + rat2
            sprsn = SPRS(I,J,K,LL,M,N)
c
            if((idbug.eq.1).and.(i.eq.2)) then
            if((j.eq.5).and.(k.eq.2)) then
            if((m.eq.1).and.(n.eq.1)) then
            write(6,3000) ll,cnto,cntn,wt1,wt2,sprso,STC(I,K,N),
     *      rat1,rat2,sprsn
            endif
            endif
            endif
c
c... end stat-loop
            ENDDO
c
            endif

c... end variable-loop
            ENDDO
C
         ENDIF
c... end region-loop
         ENDDO
C
c... end forecast-loop
         ENDDO
         endif     ! if itype > 0
C
c...  only if correct qc flag
      ENDIF
c...  only if correct level
      ENDIF
c... end level-loop
      ENDDO
 
      ENDDO
c... end subset-loop
      ENDDO
 
       CALL CLOSBF(LUBFR)

C  FINISH UP
C  ---------
C   write out grads data file...
 
      iw=50
      do ibak=1,nbak
      iw=iw+1
c
      do ivarx=1,nvar
      ivar=indexv(ivarx)
      nstat=6
      if(ivar.eq.5) nstat=9
      if(idbug.eq.1) print *,ibak,' ivar ',ivar,' nstat ',nstat
c
      do nst=1,nstat
c
      nlx=nplv
      if(ivar.eq.1) nlx=1
      do iplv=1,nlx
c
      do isub=1,nsub
      do ireg=1,nreg
c
      gdata(ireg,isub)=sprs(nst,iplv,ivar,ireg,isub,ibak)
c
c... end region-loop
      enddo
c... end subset-loop
      enddo
c
      write(iw) gdata
c
      if(ipr.eq.1) then
      if(ibak.eq.1) then
      if((iplv.eq.1).and.(ivar.eq.1))
     *write(6,1231) ibak,nst,ilev,(gdata(ireg,1),ireg=1,nreg)
      if(iplv.eq.5) then
      ilev=pmand(iplv)
      if(ivar.eq.2)
     *write(6,1232) ibak,nst,ilev,(gdata(ireg,1),ireg=1,nreg)
      if(ivar.eq.3)
     *write(6,1233) ibak,nst,ilev,(gdata(ireg,1),ireg=1,nreg)
      if(ivar.eq.4)
     *write(6,1234) ibak,nst,ilev,(gdata(ireg,1),ireg=1,nreg)
      if(ivar.eq.5)
     *write(6,1235) ibak,nst,ilev,(gdata(ireg,1),ireg=1,nreg)
      endif
      endif
      endif
c
c... end level-loop
      enddo
c... end stat-loop
      enddo
c
c... end variable-loop
      enddo
c
      close(iw)
c... end forecast-loop
      enddo
c
 1231  format('p fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1232  format('q fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1233  format('t fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1234  format('z fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1235  format('w fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
c
 3000  format('reg ',i2,' cnto ',f4.0,' cntn ',f4.0,
     *        ' wt1 ',f5.2,' wt2 ',f5.2,2x,5f12.2)
c
      PRINT'("SURUFIT PROCESSING COMPLETED")'
      STOP
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      LOGICAL FUNCTION REGION(X,Y,I)
 
      PARAMETER(NREG=7)
 
      DIMENSION X1(NREG),X2(NREG),Y1(NREG),Y2(NREG)
 
C.... X goes from east to west
C.... Y goes from south to north
c... global,nh,sh,tr,na,eu,as
      DATA X1(1),X2(1),Y1(1),Y2(1) /0.,360.,-90.,90./
      DATA X1(2),X2(2),Y1(2),Y2(2) /0.,360.,20.,80./
      DATA X1(3),X2(3),Y1(3),Y2(3) /0.,360.,-80.,-20./
      DATA X1(4),X2(4),Y1(4),Y2(4) /0.,360.,-20.,20./
      DATA X1(5),X2(5),Y1(5),Y2(5) /235.,295.,25.,55./
      DATA X1(6),X2(6),Y1(6),Y2(6) /350.,25.,35.,70./
      DATA X1(7),X2(7),Y1(7),Y2(7) /65.,145.,5.,45./

C-----------------------------------------------------------------------
 
C  CHECK FOR A VALID REGION INDEX AND BE OPTIMISTIC
C  ------------------------------------------------
 
      IF(I.LT.0.OR.I.GT.NREG) THEN
         REGION = .FALSE.
         RETURN
      ELSE
         REGION = .TRUE.
      ENDIF
 
C  SETUP THE SEARCH PARAMETERS
C  ---------------------------
 
      IF(I.EQ.0) THEN
         I1 = 1
         I2 = NREG
      ELSE
         I1 = I
         I2 = I
      ENDIF
 
C  LOOK FOR A REGION MATCH
C  -----------------------
 
      DO I0=I1,I2
      IF(Y.GE.Y1(I0) .AND. Y.LE.Y2(I0)) THEN
         IF(X1(I0).LE.X2(I0)) THEN
            IF(X.GE.X1(I0) .AND. X.LE.X2(I0)) RETURN
         ELSEIF(X1(I0).GT.X2(I0)) THEN
            IF(X.GE.X1(I0) .OR.  X.LE.X2(I0)) RETURN
         ENDIF
      ENDIF
      ENDDO
 
C  IF NO MATCH, RETURN FALSE
C  -------------------------
 
      REGION = .FALSE.
      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER FUNCTION ITYP(SUBSET)
 
      PARAMETER(NSUB=1)
 
      CHARACTER*8 SUBSET,SUBTYP(1)
      DATA SUBTYP /'ADPUPA'/
C
C     CHARACTER*8 SUBSET,SUBTYP(15)
C     DATA SUBTYP /'ADPUPA','AIRCAR','AIRCFT','SATWND','PROFLR',
C    .             'VADWND','SATBOG','SATEMP','ADPSFC','SFCSHP',
C    .             'SFCBOG','SPSSMI','SYNDAT','ERS1DA','GOESND'/
 
C  LOOK FOR A MATCH TO RETURN NON-ZERO
C  -----------------------------------
 
      DO I=1,NSUB
      ITYP = I
      IF(SUBSET.EQ.SUBTYP(I)) RETURN
      ENDDO
 
C  IF NO MATCH, RETURN ZERO
C  ------------------------
 
      ITYP = 0
      RETURN
      END

subroutine finddict2(stname,lat,lon,newlat,newlon,stnum,llats,llons,wlats,wlons,acts,names,dsize)

  implicit none

  integer(4),parameter,intent(in)::dsize
  integer(4),dimension(:),intent(in)::acts(dsize)
  integer(4),intent(out)::stnum
  real(8),intent(out)::newlat,newlon
  real(8),intent(in)::lat,lon
  real(8),dimension(:),intent(in)::wlats(dsize),wlons(dsize),llats(dsize),llons(dsize)
  character(len=8),dimension(:),intent(in)::names(dsize)
  character(len=8),intent(in)::stname
  real(8)::wlat,wlon,llat,llon
  integer(4)::a,act

  !initial/default values
  stnum=10**11
  newlat=10**11
  newlon=10**11

  !print*, "TEST2 first name in dictionary=",names(1)
  indict: do a=1,dsize
     !print*, "Looking in dictionary at station number:",a
     found: if (stname.eq.names(a)) then
        print*, "Found station:",stname
        stnum=a
        act=acts(a)
        if (act.eq.1) then
           newlat=wlats(a)
           newlon=wlons(a)
        else !act eq 0
           newlat=llats(a)
           newlon=llons(a)
        endif
        return
     endif found
  enddo indict

end subroutine finddict2

C> @file
C> @brief Pre/Post processing of of prepbufr events
      MODULE GBLEVN_MODULE

      IMPLICIT NONE

      SAVE

      INTEGER IMAX,JMAX,KMAX,KMAXS
      INTEGER*4 IDVC,IDSL,NVCOORD,SFCPRESS_ID,THERMODYN_ID
      REAL (KIND=8), ALLOCATABLE :: IAR14T(:,:,:), IAR15U(:,:,:),
     $                              IAR16V(:,:,:), IAR17Q(:,:,:),
     $                              IAR12Z(:,:),   IAR13P(:,:),
     $                              IARPSI(:,:,:), IARPSL(:,:,:),
     $                              IARPSD(:,:,:)
      REAL (KIND=4), ALLOCATABLE :: VCOORD(:,:)
      REAL DLAT,DLON

      END MODULE GBLEVN_MODULE

C> SUBPROGRAM:    GBLEVENTS   PRE/POST PROCESSING OF PREPBUFR EVENTS 
C>   PRGMMR: DENNIS KEYSER    ORG: EMC        DATE: 2017-02-22
C>
C> RUNS IN TWO MODES: "PREVENTS" AND "POSTEVENTS".  IN THE
C> PREVENTS MODE, PREPARES OBSERVATIONAL PREPBUFR REPORTS FOR
C> SUBSEQUENT QUALITY CONTROL AND ANALYSIS PROGRAMS.  THIS IS DONE
C> THROUGH THE FOLLOWING: INTERPOLATION OF GLOBAL FIRST GUESS {FROM
C> EITHER SIGIO (SIGMA OR HYBRID) OR NEMSIO INPUT} TO PREPBUFR
C> OBSERVATION LOCATIONS WITH ENCODING OF FIRST GUESS VALUES INTO
C> PREPBUFR REPORTS; ENCODING OF "PREVENT" AND/OR "VIRTMP" EVENTS INTO
C> PREPBUFR REPORTS; IN CERTAIN CASES, ENCODING OF A DERIVED PMSL INTO
C> SURFACE PREPBUFR REPORTS; AND ENCODING OF OBSERVATION ERRORS FROM
C> THE ERROR SPECIFICATION FILE INTO PREPBUFR REPORTS.  IN THE
C> POSTEVENTS MODE, AFTER ALL QUALITY CONTROL AND ANALYSIS PROGRAMS
C> HAVE RUN, INTERPOLATES THE GLOBAL ANALYSIS {FROM EITHER SIGIO
C> (SIGMA OR HYBRID) INPUT OR NEMSIO INPUT} TO PREPBUFR OBSERVATION
C> LOCATIONS AND ENCODES THESE ANALYZED VALUES INTO PREPBUFR REPORTS.
C> THE REMAINDER OF THIS ABSTRACT APPLIES ONLY TO THE PREVENTS MODE.
C> THE "PREVENT" EVENT CAN CHANGE A QUALITY MARKER TO FLAG AN
C> OBSERVATION DATUM FOR NON-USE BY SUBSEQUENT QC AND ANALYSIS
C> PROGRAMS (FILTERING).  EXAMPLES WHERE THIS SUBROUTINE WILL WRITE
C> AN EVENT TO FLAG A DATUM INCLUDE: THE OBSERVATION ERROR FOR THAT
C> DATUM IS READ IN AS MISSING IN THE INPUT ERROR FILE, THE DATUM
C> ITSELF VIOLATES A GROSS OR "SANITY" CHECK, OR THE OBSERVED
C> PRESSURE DATUM IS MORE THAN 100 MB BELOW THE GUESS SURFACE
C> PRESSURE.  THE "VIRTMP" EVENT CAN CHANGE THE SPECIFIC HUMIDITY
C> OBSERVATION (RE-CALCULATED) AS WELL AS THE TEMPERATURE
C> OBSERVATION (FROM SENSIBLE TO VIRTUAL TEMPERATURE, BASED ON
C> JUST-CALCULATED SPECIFIC HUMIDITY).  CURRENTLY THIS APPLIES ONLY
C> TO SURFACE (LAND, MARINE AND MESONET) DATA TYPES, POSSIBLY TO
C> RAOB, DROP AND MULTI-LEVEL RECCO DATA TYPES IF THE SWITCH
C> "ADPUPA_VIRT" IS TRUE (NORMALLY, HOWEVER IT IS FALSE) [OTHER DATA
C> TYPES WITH REPORTED SENSIBLE TEMPERATURE EITHER HAVE MISSING
C> MOISTURE (E.G., ALL AIRCRAFT TYPES EXCEPT FOR SOME ACARS, SATELLITE
C> WIND TYPES), FLAGGED MOISTURE (E.G., SOME ACARS) OR CALCULATE
C> SPECIFIC HUMIDITY/VIRTUAL TEMPERATURE IN SUBSEQUENT PROGRAMS (E.G.,
C> RAOBS, DROPS AND MULTI-LEVEL RECCOS WHICH CALCULATE THESE IN
C> PROGRAM "CQCBUFR", IN WHICH CASE THE SWITCH "ADPUPA_VIRT" HERE MUST
C> BE FALSE!)]. FOR CASES WHERE THE SWITCH "DOBERR" IS FALSE, THE
C> OBSERVATION ERROR FOR ALL DATA REMAINS MISSING IN THE PREPBUFR
C> FILE.  IN THIS CASE, THE INPUT ERROR FILE IS USUALLY A NULL FILE
C> AND THE "PREVENT" EVENT TO FLAG THE DATUM IS NOT INVOKED.  FOR
C> CASES WHERE THE SWITCH "DOFCST" IS FALSE, IF THE SWITCH "SOME_FCST"
C> IS ALSO FALSE, THEN FORECAST VALUES ARE NOT ENCODED FOR ANY MESSAGE
C> TYPE; IF "SOME_FCST" IS TRUE THEN FORECAST VALUES ARE ENCODED, BUT
C> ONLY FOR REPORTS IN THOSE MESSAGE TYPES FOR WHICH A GUESS VALUE IS
C> NEEDED BY SUBSEQUENT QC PROGRAMS.  IT SHOULD BE NOTED THAT THE
C> FILTERING OF DATA ASSOCIATED WITH THE "PREVENT" EVENT PROCESSING IS
C> NOT INVOKED IF ALL THREE ARE TRUE: DOBERR= FALSE, THE FORECAST
C> VALUES ARE MISSING (DOFCST=FALSE & SOME_FCST=TRUE & MESSAGE TYPE IS
C> NOT "ADPUPA", "AIRCFT", "AIRCAR", "PROFLR", OR "VADWND" -- OR  --
C> DOFCST=FALSE & SOME_FCST=FALSE), AND "VIRTMP" EVENT PROCESSING IS
C> NOT INVOKED (EITHER MESSAGE TYPE IS NOT "ADPSFC", "SFCSHP" OR
C> "MSONET" WHEN "ADPUPA_VIRT" IS FALSE, OR MESSAGE TYPE IS NOT
C> "ADPSFC", "SFCSHP", "MSONET" OR "ADPUPA" WHEN "ADPUPA_VIRT" IS
C> TRUE). ALSO, IF VIRTUAL TEMPERATURE PROCESSING IS PERFORMED, ALL
C> SURFACE REPORTS WITH MISSING PMSL WILL ENCODE A DERIVED PMSL INTO
C> PREPBUFR IF THE SWITCH DOPMSL IS TRUE AND A VIRTUAL TEMPERATURE WAS
C> SUCCESSFULLY CALCULATED.
C>
C> PROGRAM HISTORY LOG:
C> -1999-07-01 D. A. KEYSER -- ORIGINAL AUTHOR (ADAPTED FROM PREVENTS
C>     SUBROUTINE IN PREPDATA PROGRAM, BUT NOW GENERALIZED FOR
C>     POSTEVENTS MODE)
C> -1999-07-12 D. A. KEYSER -- MODIFIED TO INTERPOLATE MODEL SPECIFIC
C>     HUMIDITY TO OBSERVATION LOCATION WHEN OBS. SPECIFIC HUMIDITY IS
C>     MISSING AS LONG AS OBS. TEMPERATURE IS NON-MISSING
C> -1999-09-09 D. A. KEYSER -- ADDED "VADWND" TO THE LIST OF MESSAGE
C>     TYPES FOR WHICH FORECAST VALUES MUST BE ENCODED, EVEN WHEN
C>     DOFCST=FALSE (NECESSARY BECAUSE THE NEW PROGRAM CQCVAD NEEDS THE
C>     BACKGROUND DATA)
C> -1999-09-09 D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE; 
C>     'TFC' NOW GENERATED FOR VADWND MESSAGE TYPES EVEN THOUGH TOB IS
C>     MISSING (NEEDED BY CQCVAD PROGRAM)
C> -1999-12-01 D. A. KEYSER -- SPEC. HUMIDITY AND VIRT. TEMPERATURE ARE
C>     NOW CALCULATED WHEN SPEC. HUMIDITY QUAL. MARKER IS BAD (SUBJECT
C>     TO A SANITY CHECK), HOWEVER THE VIRT. TEMPERATURE GETS A BAD
C>     QUAL. MARKER (8)
C> -2000-09-21 D. A. KEYSER -- THE PRESSURE LEVEL ABOVE WHICH ALL SPEC.
C>     HUMIDITY QUAL. MARKERS ARE "REJECTED" (Q.M. SET TO 9) IS NOW READ
C>     IN AS A N-LIST SWITCH (QTOP_REJ), BEFORE IT WAS HARDWIRED TO 300
C>     MB
C> -2000-12-13 D. A. KEYSER -- WILL NO LONGER PERFORM VIRTUAL TEMPERATURE
C>     PROCESSING FOR ACARS DATA SINCE MOISTURE IS FLAGGED RIGHT NOW
C>     (ACARS MOISTURE ONLY WRITTEN INTO PREPBUFR FILE FOR STATISTICAL
C>     REASONS)
C> -2001-02-02 D. A. KEYSER -- RESTORED LEGACY LOGIC TO FLAG CERTAIN
C>     SATELLITE TEMPERATURE SOUNDINGS EITHER BELOW 100 MB (TEMP. OBS)
C>     OR ON ALL LEVELS (SPEC. HUM. OBS), CONTROLLED BY NEW NAMELIST
C>     SWITCH "SATMQC"
C> -2001-09-27 D. A. KEYSER -- 'TFC' AND 'QFC' NOW GENERATED FOR REPORT
C>     TYPE 111 (SYNDAT REPORTS AT STORM CENTER) EVEN THOUGH "TOB" AND
C>     "QOB" ARE MISSING (NEEDED BY SYNDATA PROGRAM); IN PREPARATION FOR
C>     CHANGE FROM T170L42 TO T254L64 SGES, NOW MAKES COEFFICIENT ARRAYS
C>     ALLOCATABLE TO ALLOW THEM TO OBTAIN MEMORY FROM "HEAP" RATHER
C>     THAN FROM "STACK", ALSO HAVE INCREASED THE MAX NUMBER OF LEVELS
C>     IN ARRAYS FROM 42 TO 64, FINALLY ALSO NO LONGER STOPS WITH C.
C>     CODE 70 IF EVEN NUMBER OF LONGITUDES IN SIGMA GUESS (IMAX,
C>     HARDWIRED TO 384) IS .LT. SPECTRAL RESOLUTION (JCAP) * 2
C> -2001-10-10 D. A. KEYSER -- AT PREPBUFR CENTER DATES WITH AN HOUR THAT
C>     IS NOT A MULTIPLE OF 3 (WHEN A GLOBAL SIGMA GUESS/ANAL FILE IS
C>     NOT AVAILABLE; E.G., IN RUC2A RUNS) NOW PERFORMS A LINEAR
C>     INTERPOLATION BETWEEN SPECTRAL COEFFICIENTS IN 2 SPANNING SIGMA
C>     GUESS/ANAL FILES 3-HRS APART TO CENERATE A GUESS/ANAL FILE VALID
C>     AT THE PREPBUFR CENTER TIME
C> -2002-05-10 D. A. KEYSER -- ADDED "AIRCAR" TO THE LIST OF TABLE A
C>     MESSAGE TYPES THAT WILL STILL HAVE THE BACKGROUND ENCODED WHEN
C>     DOFCST IS FALSE (BECAUSE ACARS ARE NOW Q.C.'d IN PREPOBS_ACARSQC
C>     PROGRAM)
C> -2003-09-02 D. A. KEYSER -- ADDED "MSONET" TO THE LIST OF TABLE A
C>     MESSAGE TYPES THAT WILL HAVE THE VIRTUAL TEMPERATURE CALCULATED;
C>     DOES NOT CALL UFBINT FOR OUTPUTTING DATA IF "NLEV" (4'TH
C>     ARGUMENT) IS ZERO (NOW CAN ONLY HAPPEN FOR GOESND FORECAST DATA
C>     WHEN ONLY RADIANCES ARE PRESENT)
C> -2004-08-30 D. A. KEYSER -- NOW INCLUDES THE 4 LAYER PWATERS, THESE
C>     GET AN OBS. ERROR (EACH THE SAME AS TOTAL PWATER) AND AN EVENT
C>     IS GENERATED WITH A REJECTED Q.M. FOR THE 4 LAYER PWATERS IF THE
C>     PWATER OBS. ERROR READ IN IS MISSING (THIS CHANGE ALLOWS THE ETA/
C>     GSI TO PROCESS OBS. ERRORS IN THE PREPBUFR FILE THE SAME AS THE
C>     ETA/3DVAR DID WHEN READING THE OBS. ERRORS FROM AN EXTERNAL
C>     FILE); FOR "RASSDA" TYPES, ENCODES A SIMPLE COPY OF THE REPORTED
C>     (VIRTUAL) TEMPERATURE AS A "VIRTMP" EVENT IF DOVTMP IS TRUE, GETS
C>     NEW REASON CODE 3
C> -2004-09-10 D. T. KLEIST -- ADDED CAPABILITY TO READ GUESS FIELDS FROM
C>     EITHER HYBRID OR, AS BEFORE, SIGMA GLOBAL FORECAST FILES
C> -2005-01-03 D. A. KEYSER -- FIXED ERROR READING CDAS SGES FILE WHICH
C>     STILL HAS A 207-WORD HEADER (T62) {2004-09-10 CHANGE ASSUMED ALL
C>     SGES FILES HAD A 226-WORD HEADER (T254), BUT THIS IS VALID ONLY
C>     FOR GFS SGES)
C> -2006-05-05 R. E. TREADON -- CHANGE VERTICAL INTERPOLATION TO DIRECTLY
C>     USE PRESSURE PROFILE, NOT PRESSURE PROFILE CONVERTED TO SIGMA.  
C>     THIS CHANGE IS IN SUBROUTINE GBLEVN03.  AS A RESULT OF THIS 
C>     CHANGE, SUBROUTINE GBLEVN07 WAS REMOVED.
C> -2006-07-14 D. A. KEYSER -- ADDED NEW NAMELIST SWITCH "SOME_FCST"
C>     WHICH APPLIES ONLY WHEN EXISTING SWITCH "DOFCST" IS FALSE: IF
C>     DOFCST=F AND SOME_FCST=T THEN, JUST AS BEFORE WHEN DOFCST=F, A
C>     FORECAST WILL STILL BE ENCODED FOR REPORTS IN CERTAIN MESSAGE
C>     TYPES USED IN SUBSEQUENT Q.C. PROGRAMS (I.E, "ADPUPA", "AIRCFT",
C>     "AIRCAR", "PROFLR" OR "VADWND") (THE DEFAULT FOR SOME_FCST IS
C>     TRUE); HOWEVER IF DOFCST=F AND SOME_FCST=F THEN A FORECAST WILL
C>     NOT BE ENCODED INTO REPORTS IN ANY MESSAGE TYPE (THIS ALLOWS
C>     THIS PROGRAM TO ENCODE OBS ERRORS AND/OR VIRTUAL TEMPERATURE
C>     EVENTS INTO A PREPBUFR FILE WITHOUT ENCODING A FORECAST); ADDED
C>     NEW NAMELIST SWITCH "ADPUPA_VIRT" WHICH, WHEN TRUE, INCLUDES
C>     REPORTS IN MESSAGE TYPE ADPUPA (I.E., RAOBS, DROPS, MULTI-LEVEL
C>     RECCOS) IN THE "VIRTMP" PROCESSING (PROCESSING THEM WITH SAME
C>     LOGIC AS IN SUBROUTINE VTPEVN OF PROGRAM PREPOBS_CQCBUFR)
C>     {NORMALLY "ADPUPA_VIRT" IS FALSE (DEFAULT) BECAUSE SUBSEQUENT
C>     PROGRAM PREPOBS_CQCBUFR PERFORMS THIS FUNCTION}
C> -2007-09-14 S. MOORTHI -- ADDED CAPABILITY TO READ GENERALIZED SIGMA/
C>     HYBRID FILES FROM THE GFS USING "SIGIO" UTILITY; ALSO, CLEANED UP
C>     SOME CODE; NEW ERROR CONDITION CODES 70 AND 71 ADDED
C> -2007-09-14 D. A. KEYSER -- FUNCTION OEFG01, WHICH RETURNS THE OBS
C>     ERROR FOR A REQUESTED VARIABLE INTERP. TO A DEFINED PRESSURE
C>     LEVEL FOR A DEFINED REPORT TYPE, MODIFIED TO USE EXACT LOGIC AS
C>     IN GSI (MINIMUM LIMITING VALUE FOR OBS ERROR BASED ON VARIABLE
C>     TYPE, LEVEL PRESSURE LIMITED TO MAX OF 2000 MB AND MIN OF ZERO
C>     MB, A FEW OTHER MINOR CHANGES) - THIS WILL ALLOW GSI TO READ OBS
C>     ERROR DIRECTLY OUT OF PREPBUFR FILE RATHER THAN OUT OF AN
C>     EXTERNAL FILE; FOR PW TYPES, NOW PASSES REPORTED SURFACE PRESSURE
C>     (PRSS * 0.01) INTO FUNCTION OEFG01 RATHER THAN VERTICAL
C>     COORDINATE PRESSURE (POB), SINCE LATTER IS ALWAYS MISSING FOR
C>     THESE TYPES (DOESN'T CHANGE VALUE COMING OUT OF OEFG01 SINCE IT
C>     IS CONSTANT ON ALL LEVELS ANYWAY FOR PW); IN SUBR. GBLEVN02, Q.M.
C>     9 IS NOW ASSIGNED TO A VARIABLE ONLY IF ITS OBS ERROR IS MISSING,
C>     OR IN THE CASE OF MOISTURE IF THE LEVEL IS ABOVE PRESSURE LEVEL
C>     "QTOP_REJ" OR IF ITS TEMPERATURE OBS ERROR IS MISSING, ALL OTHER
C>     EVENT (E.G., GROSS CHECK ERRORS) ASSIGN Q.M. 8 (EVEN IF OBS ERROR
C>     IS MISSING), PRIOR TO THIS ONLY REJECTION OF PRESSURE ON LEVEL
C>     RESULTED IN Q.M. 8, ALL OTHER REJECTIONS GOT Q.M. 9 - THIS MEANS
C>     TRULY "BAD" OBS WILL NOW ALWAYS GET Q.M. 8 AND ONLY OBS FLAGGED
C>     FOR NON-USE BY ASSIMILATION (BUT STILL "GOOD") WILL NOW GET Q.M.
C>     9 (GSI MONITORS, BUT DOES NOT USE, OBS WITH Q.M. 9, BUT IT DOES
C>     NOT EVEN CONSIDER OBS WITH Q.M. 8); CORRECTED ERROR WHICH
C>     MISTAKENLY ASSIGNED REASON CODE OF 9 INSTEAD OF 3 TO MOISTURE
C>     WITH MISSING OBS ERROR; IN SUBR. GBLEVN02, Q.M. 9 WILL NOT BE
C>     ASSIGNED TO A VARIABLE IF THAT VARIABLE ALREADY HAS A "BAD" Q.M.
C>     (I.E., > 3 BUT < 15), IN FACT THE "PREVENT" EVENT WHICH WOULD
C>     ASSIGN Q.M. 9 IS SKIPPED ENTIRELY (DO NOT WANT THE GSI TO MONITOR
C>     THE OBS WHICH REALLY ARE ARE "BAD"); IN SUBR. GBLEVN08, FOR NON-
C>     "ADPUPA" TYPES, Q.M. 9 IS NOW ASSIGNED TO CALCULATED VIRT. TEMPS
C>     IF THE MOISTURE Q.M.  IS 9 OR 15 AND ORIG. TEMP NOT "BAD", THESE
C>     "VIRTMP" EVENTS RECEIVE NEW REASON CODE 4, HAD RECEIVED Q.M. 8
C>     WITH REASON CODE 2 LIKE VIRT. TEMPS CALCULATED FROM "BAD"
C>     MOISTURE - THIS MEANS ONLY TRULY "BAD" VIRT. TEMPS WILL NOW GET
C>     Q.M. 8 AND VIRT. TEMPS FLAGGED FOR NON-USE BY ASSIMILATION (BUT
C>     STILL "GOOD") WILL NOW GET Q.M. 9 (GSI MONITORS, BUT DOES NOT
C>     USE, OBS WITH Q.M. 9, BUT IT DOES NOT EVEN CONSIDER OBS WITH Q.M.
C>     8); IN SUBR. GBLEVN08, FOR "ADPUPA" TYPES, Q.M. 3 IS NOW ASSIGNED
C>     TO CALCULATED VIRT. TEMPS ONLY IF THE MOISTURE Q.M. IS TRULY BAD
C>     (I.E. > 3 BUT NOT 9 OR 15) (AND, AS BEFORE, ORIG. TQM IS 1 OR 2
C>     AND POB IS BELOW 700 MB) - BEFORE, TQM SET TO 3 WHEN QQM WAS 9 OR
C>     15 AND ALL OTHER CONDITIONS MET; FOR "SATEMP" TYPES, ENCODES A
C>     SIMPLE COPY OF THE REPORTED (VIRTUAL) TEMPERATURE AS A "VIRTMP"
C>     EVENT IF DOVTMP IS TRUE, GETS REASON CODE 3 (SIMILAR TO WHAT IS
C>     ALREADY DONE FOR "RASSDA" TYPES)
C> -2010-01-29 D. A. KEYSER -- ADDED NEW NAMELIST SWITCH "RECALC_Q"
C>     WHICH APPLIES ONLY WHEN EXISTING SWITCH "DOVTMP" IS FALSE: IF
C>     DOVTMP=F AND RECALC_Q=T THEN, JUST AS BEFORE WHEN DOVTMP=F, SPEC.
C>     HUMIDITY IS STILL RE-CALCULATED AND THE EVENT IS ENCODED INTO THE
C>     PREPBUFR FILE (BUT VIRTUAL TEMP. IS NOT ENCODED) (THE DEFAULT FOR
C>     RECALC_Q IS TRUE), HOWEVER IF DOVTMP=F AND RECALC_Q=F THEN SPEC.
C>     HUMIDITY IS NOT RE-CALCULATED (AND NEITHER IS VIRTUAL
C>     TEMPERATURE) (THIS ALLOWS THIS PROGRAM TO BYPASS ALL "VIRTMP"
C>     EVENT PROCESSING); ADDED NEW NAMELIST SWITCH "DOPREV" WHICH,
C>     WHEN TRUE, WRITES "PREVENT" EVENTS INTO THE PREPBUFR FILE (IT
C>     ALWAYS DID THIS BEFORE) (DEFAULT), BUT NOW ALLOWS THE PROGRAM
C>     TO BYPASS "PREVENT" EVENT PROCESSING WHEN DOPREV=F; INITIALIZED
C>     ARRAY IDATE AS ZERO IN SUBR. GBLEVN10, CORRECTED BUG WHICH
C>     EXPOSED PREVIOUSLY HIDDEN MEMORY CLOBBERING WHEN CALLING PROGRAMS
C>     WERE LINKED TO NEW BUFRLIB; RULES IN SUBROUTINE GBLEVN02 REFINED
C>     TO INCLUDE FULL SFC PRESSURE SANITY CHECK FOR ALL SFC REPORTS
C>     (MASS, 18x, & WIND, 28x), BEFORE ONLY DONE FOR SFC MASS REPORTS
C>     (18x) AND STILL NOT DONE FOR NON-SFC WIND REPORTS SINCE LOWEST
C>     LEVEL PRESSURE NOT NECESSARILY AT THE SFC), AS A RESULT 28x WINDS
C>     WILL NOW GET QM=8 IF PRESSURE FAILS SANITY CHECK (OFTEN HAPPENS
C>     IN MESONET REPORTS) (GSI WAS ALREADY NOT USING THESE WINDS SINCE
C>     PRESSURE QM SET TO 8 ALL ALONG)
C> -2012-11-20  J. WOOLLEN  INITIAL PORT TO WCOSS. ADDED CALL TO BUFRLIB
C>     ROUTINE GETBMISS TO ADAPT BMISS TO LINUX ENVIRONMENT IF NEED BE
C>     {I.E., OBTAINS BUFRLIB MISSING (BMISS) VIA CALL TO GETBMISS
C>     RATHER THAN HARDWIRING IT TO 10E10 (10E10 CAN CAUSE INTEGER
C>     OVERFLOW ON WCOSS - SEE CALLING PROGRAM FOR MORE INFO)}
C> -2013-02-13  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS: USE
C>     FORMATTED PRINT STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS
C>     > 80 CHARACTERS; RENAME ALL REAL(8) VARIABLES AS *_8
C> -2013-04-12  D. A. KEYSER -- IN SUBROUTINE GBLEVN08, DON'T ALLOW
C>     CALCULATED Q TO BE < 0 WHICH CAN OCCUR ON WCOSS FOR CASES OF
C>     HORRIBLY BAD MESONET DATA
C> -2014-03-25 S. MELCHIOR -- ADDED NEW NAMELIST SWITCH "DOPMSL" WHICH,
C>     WHEN TRUE, DERIVES PMSL (MNEMONIC "PMO") FROM REPORTED STATION
C>     PRESSURE ("POB"), STATION HEIGHT/ELEVATION ("ZOB") AND THE JUST-
C>     COMPUTED VIRTUAL TEMPERATURE FOR SURFACE REPORTS IN CASES WHEN
C>     REPORTED PMSL IS MISSING (DONE IN SUBROUTINE GBLEVN08).  DOVTMP
C>     MUST BE TRUE AND DOANLS MUST BE FALSE ("PREVENTS" MODE). THE
C>     DERIVED PMSL EITHER GETS A QUALITY MARK ("PMQ") OF 3 OR INHERITS
C>     THE STATION PRESSURE QUALITY MARK ("PQM"), WHICHEVER IS GREATER.
C>     THE VALUE OF THE PMSL INDICATOR (NEW MNEMONIC "PMIN") IS SET TO 1
C>     TO DENOTE PMSL WAS DERIVED RATHER THAN OBSERVED.  THE DEFAULT FOR
C>     "DOPMSL" IS FALSE (NORMALLY ONLY TRUE IN RTMA AND URMA RUNS).  IT
C>     IS FORCED TO BE FALSE IN "POSTEVENTS" MODE (DOANLS=TRUE). IN
C>     SUBROUTINE GBLEVN02, SFCSHP REPORTS WITH CALM WINDS AND NON-
C>     MISSING BACKGROUND U- OR V-COMPONENT WIND .GE. 5 M/SEC ARE
C>     FLAGGED WITH Q.M. 8 (EVENT PGM "PREVENT", REASON CODE 8).
C> -2014-05-08 JWhiting -- altered print statement (2 format) in GBLEVN10 
C>     subroutine; increased field width for spectral resolution to 
C>     accommodate models w/ up to 5-digit resolution (I3 to I5).
C> -2016-06-13 FANGLIN YANG AND RUSS TREADON -- HANG LEI ADDED NEMSIO 
C>     TO SUBROUTINE GBLEVN10 AND REMOVED ALL SIGIO CAPABILITY.
C>     THIS UPDATE RESTORES GBLEVN10 FOR PROCESSING SIGIO INPUT, AND 
C>     ADDS A NEW GBLEVN12 FOR PROCESSING NEMSIO INPUT. THE INPUT GFS 
C>     FILE TYPE SIGIO VS NEMSIO IS NOW DETERMINED IN THE MAIN PROGRAM. 
C>     THE CODE IS ALSO UPDATED TO REMOVE BUGS. SUBROUTINE SIGIO_MODPR
C>     IS USED TO COMPUTE LAYER AND INTERFACE PRESSURE FOR NEMSIO INPUT.
C> -2017-02-17 D Keyser & J Whiting -- In subroutine GBLEVN12, removed
C>     references to multiple input files, since only 1 nemsio formatted
C>     input is needed (no interpolation is attempted; c.f.; what is
C>     done with sigio formatted inputs); GBLEVN12 routine still retains
c     some structures (esp array references) left over from multi file
C>     input. Updated comments and docblock to account for new NEMSIO
C>     input.
C> -2017-02-22 D. Keyser -- Further changes to subr. GBLEVN12 to remove
C>     array and logic references to multiple input files.
C> -2019-10-31 Hang Lei -- Add GBLEVN13 to process netcdf input.
C>     
C>
C> USAGE:    CALL GBLEVENTS(IDATEP,IUNITF,IUNITE,IUNITP,IUNITS,SUBSET,
C>          $               NEWTYP)
C>
C>   INPUT ARGUMENT LIST:
C> @param IDATEP   - CENTER DATE FOR PREPBUFR FILE IN THE FORM YYYYMMDDHH
C> @param IUNITF   - 2-WORD ARRAY:
C>        For SIGIO input:
C>              - WORD 1 - UNIT NUMBER OF FIRST INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS VALID AT THE DATE IN IDATEP, IF HH IN
C>                IDATEP IS NOT A MULTIPLE OF 3 THEN THIS FILE IS VALID
C>                AT THE CLOSEST TIME PRIOR TO THE DATE IN IDATEP THAT
C>                IS A MULTIPLE OF 3
C>              - WORD 2 - UNIT NUMBER OF SECOND INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS EMPTY, IF HH IN IDATEP IS NOT A MULTIPLE
C>                OF 3 THEN THIS FILE IS VALID AT THE CLOSEST TIME AFTER
C>                THE DATE IN IDATEP THAT IS A MULTIPLE OF 3
C>        For NEMSIO input:
C>              - WORD 1 - UNIT NUMBER OF INPUT NEMSIO-BASED GLOBAL FILE
C>                (EITHER FIRST GUESS OR ANALYSIS); ALWAYS VALID AT AT
C>                THE DATE IN IDATEP
C>              - WORD 2 - NOT USED, SHOULD BE A NULL FILE
C> @param IUNITE   - UNIT NUMBER OF INPUT OBSERVATION ERROR FILE
C>              - (USED ONLY IN PREVENTS MODE)
C> @param IUNITP   - UNIT NUMBER OF OUTPUT PREPBUFR DATA SET
C> @param IUNITS   - UNIT NUMBER OF "PREVENT" EVENTS DATA FILTERING
C>              - SUMMARY PRINT FILE
C>              - (USED ONLY IN PREVENTS MODE)
C> @param SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C>              - REPORT BEING PROCESSED
C> @param NEWTYP   - INDICATOR IF THE BUFR MESSAGE TABLE A ENTRY HAS
C>              - CHANGED FROM THAT OF THE PREVIOUS REPORT (=0 - NO,
C>              - =1 - YES)
C>                
C>
C>   INPUT FILES:
C>   -  UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C>                DOCUMENTATION BELOW)
C>                (NOTE: IF STANDARD INPUT FILE IS NULL, THEN THIS
C>                       SUBROUTINE RUNS IN POSTEVENTS MODE)
C>   -  UNIT AA  - PREPBUFR DATA SET
C>                (WHERE AA IS UNIT NUMBER DEFINED AS IUNITP IN
C>                INPUT ARGUMENT LIST)
C>   -  UNIT BB  - GUESS (PREVENTS MODE) OR ANALYSIS (POSTEVENTS MODE)
C>                FILE
C>                (WHERE BB IS UNIT NUMBER DEFINED AS IUNITF(1) IN
C>                INPUT ARGUMENT LIST)
C>   -  UNIT CC  - GUESS (PREVENTS MODE) OR ANALYSIS (POSTEVENTS MODE)
C>                FILE
C>                (WHERE CC IS UNIT NUMBER DEFINED AS IUNITF(2) IN
C>                INPUT ARGUMENT LIST)
C>                NOTE: only valid for SIGIO input
C>   -  UNIT DD  - OBSERVATION ERROR FILE (WHERE DD IS UNIT NUMBER
C>                DEFINED AS IUNITE IN INPUT ARGUMENT LIST)
C>                (USED ONLY IN PREVENTS MODE)
C>
C>   OUTPUT FILES:
C>   -  UNIT 06  - STANDARD OUTPUT PRINT
C>   -  UNIT AA  - PREPBUFR DATA SET
C>                (WHERE AA IS UNIT NUMBER DEFINED AS IUNITP IN
C>                INPUT ARGUMENT LIST)
C>   -  UNIT DD  - "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C>                (WHERE DD IS UNIT NUMBER DEFINED AS IUNITS IN
C>                INPUT ARGUMENT LIST)
C>                (USED ONLY IN PREVENTS MODE)
C>
C>   SUBPROGRAMS CALLED:
C>     UNIQUE:      GBLEVN02  GBLEVN03  GBLEVN04  GBLEVN06  OEFG01
C>                  GBLEVN08  GBLEVN10  GBLEVN11  GBLEVN11D GBLEVN12
C>                  GBLEVN13
C>                  GETLATS
C>                  MODULES: GBLEVN_MODULE SIGIO_MODULE     SIGIO_R_MODULE
C>                           NEMSIO_MODULE NEMSIO_OPENCLOSE NEMSIO_READ
C>                           NEMSIO_WRITE
C>     LIBRARY:
C>       SIGIO    - SIGIO_RROPEN       SIGIO_RRHEAD    SIGIO_SCLOSE  SIGIO_ALDATS
C>                  SIGIO_ALDATM       SIGIO_RRDATS    SIGIO_RRDATM  SIGIO_AXDATS
C>                  SIGIO_AXDATM       SIGIO_MODPR     SIGIO_CNVTDV
C>       SPLIB    - SPTEZM             SPTEZMV         SPLAT
C>       W3NCO    - W3MOVDAT           ERREXIT
C>       BUFRLIB  - UFBINT             UFBQCD          GETBMISS      IBFMS
C>       NEMSIO   - NEMSIO_OPEN        NEMSIO_CLOSE    NEMSIO_INIT
C>                  NEMSIO_GETFILEHEAD NEMSIO_READRECV NEMSIO_FINALIZE
C>                  NEMSIO_GETHEADVAR  NEMSIO_READRECVw34
C>
C>   EXIT STATES:
C>   -  COND =   0 - SUCCESSFUL RUN
C>   -  COND =  60 - OBSERVATION ERROR TABLE EMPTY OR DOES NOT EXIST
C>   -  COND =  61 - VARIABLE NLTD .NE. VARIABLE NLEV
C>   -  COND =  62 - VARIABLE NLTQ .NE. VARIABLE NLEV
C>   -  COND =  63 - VARIABLE NLQQ .NE. VARIABLE NLEV
C>   -  COND =  68 - DATE OF FIRST GUESS/ANALYSIS FILE(S) DOES NOT MATCH,
C>                  OR AT LEAST SPAN, THE CENTER DATE FOR THE PREPBUFR
C>                  FILE
C>   -  COND =  69 - FOR SIGIO INPUT GLOBAL FILES, VARIABLE KMAX TOO BIG
C>                 - UNABLE TO TRANSFORM FIRST GUESS OR ANALYSIS FILE(S)
C>   -  COND =  70 - FOR SIGIO INPUT GLOBAL FILES, CALL TO SIGIO_RROPEN
C>                  RETURNED WITH NON-ZERO R.C.
C>   -  COND =  71 - FOR SIGIO INPUT GLOBAL FILES, CALL TO SIGIO_RRHEAD
C>                  RETURNED WITH NON-ZERO R.C.
C>
C>
C> REMARKS: THIS SUBROUTINE MAY NOT WORK CORRECTLY IN THE EIGHT BYTE
C>     INTEGER W3NCO (_8) LIBRARY.  PLEASE COMPILE APPLICATION CODE
C>     USING A FOUR BYTE REAL W3NCO LIBRARY (_4 OR _d).
C>
C>     THIS ROUTINE PROCESSES ONE REPORT AT A TIME.  IT EXPECTS THAT THE
C>     CALLING PROGRAM HAS ALREADY ENCODED THE REPORT INTO THE PREPBUFR
C>     FILE VIA THE UFBINT OR UFBCPY ROUTINES.  THE CALLING PROGRAM
C>     SHOULD THEN CALL THIS ROUTINE AND, UPON ITS RETURN, THE CALLING
C>     PROGRAM SHOULD CALL WRITSB TO ACTUALLY WRITE THE UPDATED SUBSET
C>     (REPORT) INTO THE BUFR MESSAGE.
C>C
C>  ***** VARIABLES IN NAMELIST PREVDATA READ IN BY THIS SUBROUTINE *****
C>               (NOTE: IF STANDARD INPUT FILE IS NULL, THEN THIS
C>                      SUBROUTINE RUNS IN POSTEVENTS MODE - DOANLS=TRUE
C>                      AND ALL OTHER VARIABLES ARE SET TO FALSE)
C>C
C>C
C>  -  DOPREV  - WRITE "PREVENT" EVENT INTO THE PREPBUFR FILE?
C>              DOPREV = .TRUE.  ---> YES                       (DEFAULT)
C>              DOPREV = .FALSE. ---> NO
C>  -  DOVTMP, ADPUPA_VIRT & RECALC_Q:
C>      DOVTMP  - WRITE VIRTUAL TEMPERATURE EVENT ("VIRTMP") INTO THE
C>                PREPBUFR FILE (I.E., RE-CALCULATE SPECIFIC HUMIDITY
C>                THEN CALCULATE VIRTUAL TEMPERATURE) FOR THE FOLLOWING
C>                TYPES OF REPORTS:
C>                 ADPUPA_VIRT = .FALSE.  ---> SURFACE LAND, MARINE,
C>                                             MESONET AND RASS REPORTS?
C>                 ADPUPA_VIRT = .TRUE.   ---> SURFACE LAND, MARINE,
C>                                             MESONET RASS, RAOB, DROP
C>                                             AND MULTI-LEVEL RECCO
C>                                             REPORTS?
C>              FOR ALL TYPES EXCEPT RASS, THIS WILL ATTEMPT TO
C>              CALCULATE VIRTUAL TEMPERATURE FROM SENSIBLE TEMPERATURE
C>              AND THE JUST RE-CALCULATED SPECIFIC HUMIDITY AND ENCODE
C>              IT AS A STACKED EVENT IN THE PREPBUFR FILE.  FOR RASS
C>              REPORTS THIS WILL JUST ENCODE THE REPORTED TEMPERATURE
C>              AS A STACKED EVENT IN THE PREPBUFR FILE SINCE THE
C>              REPORTED TEMPERATURE IS ALREADY VIRTUAL (NO MOISTURE IS
C>              PRESENT SO Q IS NOT RE-CALCULATED FOR RASS REPORTS).
C>                DOVTMP = .TRUE.  ---> YES                     (DEFAULT)
C>                DOVTMP = .FALSE.
C>                  RECALC_Q = .TRUE.  ---> RE-CALCULATE SPECIFIC
C>                                           HUMIDITY BUT DO NOT THEN
C>                                           CALCULATE VIRTUAL
C>                                           TEMPERATURE        (DEFAULT)
C>                  RECALC_Q = .FALSE. ---> NO, DO NOT RE-CALCULATE
C>                                           SPECIFIC HUMIDITY AND DO
C>                                           NOT CALCULATE VIRTUAL
C>                                           TEMPERATURE
C>      {NOTE1: FOR SURFACE LAND, MARINE AND MESONET REPORTS, (AND
C>              RAOB, DROP AND MULTI-LEVEL RECCO REPORTS IF
C>              "ADPUPA_VIRT"=TRUE) DOVTMP=FALSE WILL STILL RE-CALCULATE
C>              SPECIFIC HUMIDITY AND ENCODE IT AS A STACKED EVENT IN
C>              THE PREPBUFR FILE UNLESS EITHER DOANLS IS TRUE OR
C>              RECALC_Q IS FALSE.)
C>      (NOTE2: DOES NOT APPLY TO ANY REPORT TYPES OTHER THAN THOSE
C>              MENTIONED ABOVE)
C>      (NOTE3: IF DOANLS=TRUE, THEN DOVTMP IS NOT ONLY FORCED TO BE
C>              FALSE, BUT ALSO SPECIFIC HUMIDITY IS NOT RE-CALCULATED.)
C>      (NOTE4: ADPUPA_VIRT DEFAULTS TO FALSE.)
C>      (NOTE5: IF DOVTMP=TRUE, THEN RECALC_Q IS MEANINGLESS.)
C>      (NOTE6: RECALC_Q DEFAULTS TO TRUE.)
C>
C>  -  DOFCST & SOME_FCST:
C>      DOFCST  - ENCODE FORECAST (FIRST GUESS) VALUES, INTERPOLATED FROM
C>                EITHER A SIGIO (SIGMA OR HYBRID) INPUT OR NEMSIO INPUT
C>                GLOBAL FILE, INTO THE PREPBUFR FILE FOR ALL MESSAGE
C>                TYPES OR AT LEAST SOME MESSAGE TYPES?
C>                DOFCST = .TRUE.  ---> YES, ENCODE FORECST FOR ALL
C>                                       MESSAGE TYPES          (DEFAULT)
C>                DOFCST = .FALSE.
C>                  SOME_FCST = .FALSE. ---> NO, DO NOT ENCODE FORECAST
C>                                            FOR ANY MESSAGE TYPE
C>                                            (VALUES REMAIN MISSING)
C>                  SOME_FCST = .TRUE.  ---> YES, BUT ONLY FOR MESSAGE
C>                                            TYPES "ADPUPA", "AIRCFT",
C>                                            "AIRCAR", "PROFLR" OR
C>                                            "VADWND" (VALUES REMAIN
C>                                            MISSING FOR ALL OTHER
C>                                            MESSAGE TYPES)
C>      (NOTE1: THE CASE DOFCST=FALSE & SOME_FCST=TRUE WRITES THE
C>              FORECAST VALUES FOR THE TYPES MENTIONED ABOVE BECAUSE
C>              THEY ARE NEEDED BY SUBSEQUENT QUALITY CONTROL PROGRAMS.)
C>      (NOTE2: THIS WAS ADDED AS A TIME SAVING FEATURE IN THE
C>              NON-GLOBAL VERSIONS SINCE ONLY THE GLOBAL REQUIRES A
C>              FIRST GUESS TO BE PRESENT FOR ALL CONVENTIONAL MESSAGE
C>              TYPES IN THE PREPBUFR FILE.)
C>      (NOTE3: IF DOANLS=TRUE, THEN DOFCST & SOME_FCST ARE FORCED TO BE
C>              FALSE, MEANING A GUESS WILL NOT BE ENCODED FOR ANY
C>              MESSAGE TYPE.)
C>      (NOTE4: IF DOFCST=TRUE, THEN SOME_FCST IS MEANINGLESS.)
C>      (NOTE5: SOME_FCST DEFAULTS TO TRUE.)
C>
C>  -  DOANLS  - ENCODE ANALYZED VALUES, INTERPOLATED FROM EITHER A SIGIO
C>    (SIGMA OR HYBRID)  INPUT OR NEMSIO INPUT GLOBAL FILE,
C>              INTO THE PREPBUFR FILE -
C>              POSTEVENTS MODE - ?
C>              DOANLS = .TRUE.  ---> YES, FOR ALL MESSAGE TYPES
C>              DOANLS = .FALSE. ---> NO,  FOR ALL MESSAGE TYPES
C>                                          - PREVENTS MODE -   (DEFAULT)
C>      (NOTE:  DOANLS=TRUE WILL OVERRIDE AND FORCE TO FALSE ALL OTHER
C>              SWITCHES. IN ADDITION, THE FORECAST VALUES WILL NOT
C>              BE ENCODED FOR ANY MESSAGE TYPE AND SPECIFIC HUMIDITY
C>              WILL NOT BE RE-CALCULATED.)
C>
C>  -  DOBERR  - ENCODE OBSERVATIONAL ERROR VALUES, AS READ FROM OBS.
C>              ERROR FILE, INTO THE PREPBUFR FILE?
C>              DOBERR = .TRUE.  ---> YES                       (DEFAULT)
C>              DOBERR = .FALSE. ---> NO (VALUES REMAIN MISSING)
C>      (NOTE1: THIS WAS ADDED AS A TIME SAVING FEATURE IN THE
C>              RAP -AND PREVIOUS RUC- VERSION SINCE IT DOES NOT REQUIRE
C>              OBSERVATIONAL ERRORS TO BE PRESENT IN THE PREPBUFR FILE.)
C>      (NOTE2: IF DOANLS=TRUE, THEN DOBERR IS FORCED TO BE FALSE.)
C>
C>  -  QTOP_REJ  - THE PRESSURE LEVEL (IN MB) ABOVE WHICH ALL SPECIFIC
C>                HUMIDITY QUALITY MARKERS ARE "REJECTED" (THE QUALITY
C>                MARKER IS SET TO 9 ON ALL PRESSURE LEVELS LESS THAN
C>                THIS LEVEL)                              (DEFAULT=300.)
C>
C>  -  SATMQC  - PERFORM SPECIAL QUALITY CONTROL ON SATELLITE TEMPERATURE
C>              SOUNDINGS IN REPORT TYPES 160-179?
C>              SATMQC = .TRUE.  ---> YES
C>              SATMQC = .FALSE. ---> NO                        (DEFAULT)
C>      (NOTE: THIS APPLIES ONLY TO THE CDAS OR HISTORICAL RE-RUNS
C>             WITH TEMPERATURE SOUNDINGS IN THESE REPORT TYPES)
C>
C>  -  DOPMSL  - ENCODE DERIVED PMSL ("PMO") FOR ALL SURFACE REPORTS WHEN
C>              REPORTED PMSL IS MISSING - ?
C>              DOPMSL = .TRUE.  ---> YES
C>              DOPMSL = .FALSE. ---> NO ("PMO" REMAINS MISSING)(DEFAULT)
C>      {NOTE: THIS APPLIES ONLY WHEN DOVTMP=TRUE AND DOANLS=FALSE
C>             ("PREVENTS" MODE), VIRTUAL TEMPERATURE CAN BE CALCULATED,
C>             AND STATION PRESSURE AND SURFACE HEIGHT/ELEVATION ARE
C>             BOTH PRESENT.  THE DERIVED PMSL EITHER GETS A QUALITY
C>             MARK ("PMQ") OF 3 OR INHERITS THE STATION PRESSURE
C>             QUALITY MARK ("PQM") PQM, WHICHEVER IS GREATER. THE VALUE
C>             OF THE PMSL INDICATOR ("PMIN") IS SET TO 1 TO DENOTE PMSL
C>             WAS DERIVED RATHER THAN OBSERVED.}
C>
      SUBROUTINE GBLEVENTS(IDATEP,IUNITF,IUNITE,IUNITP,IUNITS,SUBSET,
     $                     NEWTYP)

      USE SIGIO_MODULE
      USE SIGIO_R_MODULE
      USE NEMSIO_MODULE
      USE NEMSIO_OPENCLOSE
      USE NEMSIO_READ
      USE GBLEVN_MODULE
      use netcdf

      INTEGER, PARAMETER :: IM=384, JM=IM/2+1
      integer :: idrt = 0

      CHARACTER*80 HEADR,OBSTR,QMSTR,FCSTR,OESTR,ANSTR
      CHARACTER*8  SUBSET
      REAL(8)      OBS_8,QMS_8,BAK_8,SID_8,HDR_8(10)
      REAL(8)      BMISS,GETBMISS
      LOGICAL      DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,DOANLS,
     $             SATMQC,ADPUPA_VIRT,RECALC_Q,DOPREV,dopmsl
      INTEGER*4 IRET,IRET1
      INTEGER*4    IUNITF(2),ncid

      CHARACTER*20 CFILE1
      TYPE(SIGIO_HEAD) :: HEAD1
      TYPE(NEMSIO_GFILE) :: GFILE1  

      COMMON /GBEVAA/ SID_8,OBS_8(13,255),QMS_8(12,255),BAK_8(12,255),
     $ XOB,YOB,DHR,TYP,NLEV
      COMMON /GBEVBB/ IPVCD,IVTCD
      COMMON /GBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT,RECALC_Q,DOPREV,dopmsl
      COMMON /GBEVDD/ ERRS(300,33,6)
      COMMON /GBEVFF/ BMISS

      SAVE

      DATA IFIRST/0/

      DATA HEADR /
     $ 'SID XOB YOB DHR TYP                                       '/
      DATA OBSTR /
     $ 'POB QOB TOB ZOB UOB VOB PWO  PW1O PW2O PW3O PW4O CAT PRSS '/
      DATA QMSTR /
     $ 'PQM QQM TQM ZQM WQM PWQ PW1Q PW2Q PW3Q PW4Q NUL  NUL      '/
      DATA FCSTR /
     $ 'PFC QFC TFC ZFC UFC VFC PWF  PW1F PW2F PW3F PW4F NUL      '/
      DATA ANSTR /
     $ 'PAN QAN TAN ZAN UAN VAN PWA  PW1A PW2A PW3A PW4A NUL      '/
      DATA OESTR /
     $ 'POE QOE TOE ZOE WOE PWE PW1E PW2E PW3E PW4E NUL  NUL      '/

      NAMELIST /PREVDATA/DOVTMP,DOFCST,SOME_FCST,DOBERR,DOANLS,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT,RECALC_Q,DOPREV,dopmsl

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      IF(IFIRST.EQ.0)  THEN

C -------------------------------
C FIRST TIME IN DO A FEW THINGS...
C -------------------------------

         IFIRST = 1
         PRINT 700
  700 FORMAT(/1X,100('#')/' =====> SUBROUTINE GBLEVENTS INVOKED FOR ',
     $ 'THE FIRST TIME - VERSION LAST UPDATED 2017-02-22'/)

         BMISS = GETBMISS()
         print *
         print *, 'BUFRLIB value for missing passed into GBLEVENTS ',
     $    'is: ',bmiss
         print *

C  INITIALIZE NAMELIST SWITCHES TO DEFAULT VALUES
C  ----------------------------------------------

         DOVTMP      = .TRUE.
         DOPREV      = .TRUE.
         RECALC_Q    = .TRUE.
         DOFCST      = .TRUE.
         SOME_FCST   = .TRUE.
         DOBERR      = .TRUE.
         DOANLS      = .FALSE.
         QTOP_REJ    = 300.
         SATMQC      = .FALSE.
         ADPUPA_VIRT = .FALSE.
         dopmsl      = .false.
         READ(5,PREVDATA,ERR=101,END=102)
         GO TO 103
C-----------------------------------------------------------------------
  101    CONTINUE

C  ERROR READING STANDARD INPUT - THIS DEFAULTS TO POSTEVENTS MODE
C  ---------------------------------------------------------------

         PRINT 7013
 7013 FORMAT(/' ##> GBLEVENTS: ERROR READING STANDARD INPUT DATA CARDS',
     $ ' -- DEFAULTS TO "POSTEVENTS" MODE'/)
         DOANLS = .TRUE.
         GO TO 103

C-----------------------------------------------------------------------
  102    CONTINUE

C  STANDARD INPUT IS EMPTY - THIS DEFAULTS TO POSTEVENTS MODE
C  ----------------------------------------------------------

         PRINT 7014
 7014 FORMAT(/' ##> GBLEVENTS: STANDARD INPUT DATA CARDS DO NOT ',
     $ 'EXIST -- DEFAULTS TO "POSTEVENTS" MODE'/)
         DOANLS = .TRUE.

C-----------------------------------------------------------------------
  103    CONTINUE
         IF(DOANLS) THEN
            DOVTMP      = .FALSE.
            DOPREV      = .FALSE.
            DOFCST      = .FALSE.
            SOME_FCST   = .FALSE.
            DOBERR      = .FALSE.
            ADPUPA_VIRT = .FALSE.
            dopmsl      = .false.
         ENDIF
         IF(DOVTMP)  RECALC_Q=.TRUE. ! RECALC_Q must be T if DOVTMP is T
         WRITE (6,PREVDATA)

         FCST = DOFCST
         VIRT = .FALSE.

C  CHECK VALID-TIME DATE OF GUESS/ANALYSIS FILE(S) AGAINST THE CENTER
C   DATE FOR THE PREPBUFR FILE AND OBTAIN THE FIRST GUESS/ANALYSIS
C   UNLESS ALL OF DOFCST, SOME_FCST, DOANLS ARE FALSE
C  ------------------------------------------------------------------

         IF(.NOT.DOANLS)  THEN
            IF(.NOT.DOFCST.AND..NOT.SOME_FCST)  THEN
               PRINT 901
  901 FORMAT(/' --> GBLEVENTS: PREVENTS MODE - FIRST GUESS NOT READ ',
     $ 'IN'/)
            ELSE
               PRINT 701
  701 FORMAT(/' --> GBLEVENTS: PREVENTS MODE - DATE CHECK AND ',
     $ 'TRANSFORM THE FIRST GUESS'/)
            ENDIF
         ELSE
            PRINT 7701
 7701 FORMAT(/' --> GBLEVENTS: POSTEVENTS MODE - DATE CHECK AND ',
     $ 'TRANSFORM THE ANALYSIS'/)
         ENDIF

         IF(DOFCST .OR. SOME_FCST .OR. DOANLS) THEN
            WRITE(CFILE1,'("fort.",I2.2)') IUNITF(1)

            iret = nf90_open(trim(cfile1),nf90_nowrite,ncid)
            if (iret == 0) then
               print *,' ===> GFS FCST/ANAL INPUT IS NETCDF'
               CALL GBLEVN13(IUNITF,IDATEP,IM,JM,IDRT)
            else
               CALL SIGIO_RROPEN(IUNITF(1),CFILE1,IRET)
               CALL SIGIO_SRHEAD(IUNITF(1),HEAD1,IRET1)
               IF(IRET == 0 .AND. IRET1 == 0) THEN
                  print *,' ===> GLOBAL FCST/ANAL INPUT IS SIGIO'
                  CALL SIGIO_SCLOSE(IUNITF(1),IRET)
                  CALL GBLEVN10(IUNITF,IDATEP,IM,JM,IDRT)
               ELSE
                  CALL NEMSIO_OPEN(GFILE1,trim(CFILE1),'read',IRET=IRET)
                  IF(IRET == 0) THEN
                     CALL NEMSIO_CLOSE(GFILE1,IRET=IRET)
                     print *,' ===> GFS FCST/ANAL INPUT IS NEMSIO'
                     CALL GBLEVN12(IUNITF,IDATEP,IM,JM,IDRT)
                  ENDIF
               ENDIF
            ENDIF 
         ENDIF

         print*,'after returning from GBLEVN10, GBLEVN12,',
     $    ' or GBLEVN13.   idrt=',idrt

         IF(DOBERR)  THEN

C  IF REQUESTED, READ ERROR FILES (ONLY POSSIBLE IN PREVENTS MODE)
C  ---------------------------------------------------------------

            PRINT 702
  702 FORMAT(/' --> GBLEVENTS: READ ERROR FILES'/)

            CALL GBLEVN01(IUNITE)

         ELSE

            ERRS = 0
            IF(.NOT.DOANLS)  PRINT 3702
 3702 FORMAT(/' --> GBLEVENTS: OBS. ERROR NOT ENCODED IN PREPBUFR ',
     $ '(BY CHOICE)'/)

         ENDIF

C  OBTAIN NECESSARY PROGRAM CODES (ONLY USED IN PREVENTS MODE)
C  -----------------------------------------------------------

         CALL UFBQCD(IUNITP,'PREVENT',IPVCD)
         CALL UFBQCD(IUNITP,'VIRTMP ',IVTCD)

         PRINT 703
  703 FORMAT(/1X,100('#')/)

C  SET-UP OUTPUT "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C  (ONLY USED IN PREVENTS MODE)
C  ----------------------------------------------------------------

         IF(.NOT.DOANLS)  WRITE(IUNITS,1701) IDATEP
 1701 FORMAT(//130('#')//38X,'*** "PREVENT" EVENTS DATA FILTERING ',
     $ 'SUMMARY ***'/35X,'--> CENTER DATE FOR PREPBUFR FILE IS: ',I10,
     $ ' <--'//)

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      ENDIF

      IF(.NOT.DOANLS)  THEN

         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1702)  SUBSET
 1702 FORMAT(130('-')/39X,'--> SUMMARY FOR TABLE A ENTRY "',A8,'" <--'/)

         IF(.NOT.DOFCST .AND. SOME_FCST)  FCST = (SUBSET.EQ.'ADPUPA  '
     $    .OR.SUBSET.EQ.'PROFLR  '.OR.SUBSET .EQ.'AIRCFT  '.OR.SUBSET
     $    .EQ.'AIRCAR  '.OR.SUBSET .EQ.'VADWND  ')

C   Will not subject ACARS reports to virtual temp. processing until
C    spec. humidity is used in production

ccccc    VIRT = (SUBSET.EQ.'ADPSFC  '.OR.SUBSET.EQ.'SFCSHP  '.OR.
ccccc$           SUBSET.EQ.'MSONET  '.OR.SUBSET.EQ.'AIRCAR  '.OR.
ccccc$           SUBSET.EQ.'RASSDA  '.OR.SUBSET.EQ.'SATEMP  '.OR.
ccccc$           (SUBSET.EQ.'ADPUPA  '.AND.ADPUPA_VIRT))
         VIRT = (RECALC_Q.AND.(SUBSET.EQ.'ADPSFC  '.OR.
     $                         SUBSET.EQ.'SFCSHP  '.OR.
     $                         SUBSET.EQ.'MSONET  '.OR.
     $                         SUBSET.EQ.'RASSDA  '.OR.
     $                         SUBSET.EQ.'SATEMP  '.OR.
     $                       (SUBSET.EQ.'ADPUPA  '.AND.ADPUPA_VIRT)))


         IF(.NOT.(FCST.OR.DOBERR.OR.VIRT.OR.DOPREV)) THEN
            IF(NEWTYP.EQ.1)  WRITE(IUNITS,1703)
 1703 FORMAT(/'  ==> DATA FILTERING NOT PERFORMED FOR THIS TABLE A ',
     $ 'ENTRY -- FORECAST, OBS ERROR, "VIRTMP", "PREVENT" PROCESSING ',
     $ 'NOT DONE'/)
            RETURN
         ENDIF

      ENDIF

C  READY TO RETRIEVE NECESSARY INFORMATION OUT OF THE NEXT REPORT WHICH
C  HAS BEEN "UFB" ENCODED INTO THE PREPBUFR FILE BY THE CALLING PROGRAM
C  (USE NEGATIVE UNIT NUMBER HERE SINCE FILE OPEN FOR OUTPUT)
C  (NOTE: THE CALLING PROGRAM HAS NOT YET WRIITEN THE REPORT INTO
C         THE PREPBUFR FILE VIA WRITSB!)
C  ----------------------------------------------------------------

      CALL UFBINT(-IUNITP,OBS_8,13,255,NLEV,OBSTR)
      CALL UFBINT(-IUNITP,QMS_8,12,255,NLEV,QMSTR)
      CALL UFBINT(-IUNITP,HDR_8,10,  1,IRET,HEADR)
      SID_8 = HDR_8(1)
      XOB   = HDR_8(2)
      YOB   = HDR_8(3)
      DHR   = HDR_8(4)
      TYP   = HDR_8(5)

      IF(FCST.OR.DOANLS)  THEN

C  PREVENTS MODE:   ENCODE FIRST GUESS VALUES INTO PREPBUFR FILE
C  ------------------------------------------------------------

C  POSTEVENTS MODE: ENCODE ANALYSIS VALUES INTO REPORT AND RETURN TO
C                   CALLING PROGRAM TO WRITE GBL-EVENTED REPORT
C                   (SUBSET) INTO PREPBUFR FILE
C  -----------------------------------------------------------------

         CALL GBLEVN03(SUBSET)
         IF(NLEV.GT.0)  THEN
            IF(FCST)   THEN
               CALL UFBINT(IUNITP,BAK_8,12,NLEV,IRET,FCSTR)
            ELSE
               CALL UFBINT(IUNITP,BAK_8,12,NLEV,IRET,ANSTR)
               RETURN
            ENDIF
         ENDIF
      ENDIF

C  --------------------------------------------------------------------
C  LOGIC FROM HERE ON PERTAINS ONLY TO PREVENTS MODE OF THIS SUBROUTINE
C  --------------------------------------------------------------------

C  ENCODE OBSERVATION ERRORS INTO REPORT
C  -------------------------------------

      IF(DOBERR)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1710)
 1710 FORMAT(/'  ==> OBS ERROR VALUES ARE ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA MISSING OBS ERROR TEST IS  ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE OBS ERROR VALUES ARE ',
     $ 'PROCESSED/STORED'/)
         CALL GBLEVN04
         IF(NLEV.GT.0)  CALL UFBINT(IUNITP,BAK_8,12,NLEV,IRET,OESTR)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1705)
 1705 FORMAT(/'  ==> OBS ERROR VALUES NOT ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA MISSING OBS ERROR TEST NOT ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE OBS ERROR VALUES NOT ',
     $ 'PROCESSED/STORED'/)
      ENDIF

C  MAKE THE GBLEVENTS EVENTS AND ENCODE INTO REPORT
C  ------------------------------------------------

      IF(.NOT.FCST)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1704)
 1704 FORMAT(/'  ==> FORECAST VALUES NOT ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA POB VS. GESS PSFC TEST NOT ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE FORECAST VALUES NOT ',
     $ 'PROCESSED/STORED'/)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1708)
 1708 FORMAT(/'  ==> FORECAST VALUES ARE ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA POB VS. GESS PSFC TEST IS  ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE FORECAST VALUES ARE ',
     $ 'PROCESSED/STORED'/)
      ENDIF

      IF(DOPREV)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1807)
 1807 FORMAT(/'  ==> "PREVENT" EVENT PROCESSING IS  PERFORMED FOR THIS',
     $ ' TABLE A ENTRY'/)
         CALL GBLEVN02(IUNITP,IUNITS,NEWTYP,subset)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1806)
 1806 FORMAT(/'  ==> "PREVENT" EVENT PROCESSING NOT PERFORMED FOR THIS',
     $ ' TABLE A ENTRY'/)
      ENDIF

C  MAKE THE VIRTUAL TEMPERATURE EVENTS AND ENCODE INTO REPORT
C  ----------------------------------------------------------

      IF(.NOT.VIRT)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1706)
 1706 FORMAT(/'  ==> "VIRTMP" EVENT PROCESSING NOT PERFORMED FOR THIS ',
     $ 'TABLE A ENTRY'/)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1707)
 1707 FORMAT(/'  ==> "VIRTMP" EVENT PROCESSING IS  PERFORMED FOR THIS ',
     $ 'TABLE A ENTRY'/)
         CALL GBLEVN08(IUNITP,SUBSET)
      ENDIF

C  RETURN TO CALLING PROGRAM TO WRITE GBL-EVENTED REPORT (SUBSET) INTO
C   PREPBUFR FILE
C  -------------------------------------------------------------------

      RETURN

      END
C***********************************************************************
C***********************************************************************
C> Read observation error table
C> @param IUNITE   - UNIT NUMBER OF INPUT OBSERVATION ERROR FILE (USED ONLY IN PREVENTS MODE)
      SUBROUTINE GBLEVN01(IUNITE) ! FORMERLY SUBROUTINE ETABLE

      COMMON /GBEVDD/ ERRS(300,33,6)

C  READ THE OBSERVATION ERROR TABLES
C  ---------------------------------

      REWIND IUNITE

      IREC = 0

   10 CONTINUE
      READ(IUNITE,'(1X,I3)',END=100) KX
      IREC = IREC + 1
      DO K=1,33
         READ(IUNITE,'(1X,6E12.5)') (ERRS(KX,K,M),M=1,6)
      ENDDO
      GO TO 10

  100 CONTINUE
      IF(IREC.LE.0) THEN
         PRINT'(" ##GBLEVENTS/GBLEVN01 - OBS. ERROR TABLE EMPTY OR ",
     $    "DOES NOT EXIST - STOP 60")'
         CALL ERREXIT(60)
      ENDIF

      RETURN

      END
C***********************************************************************
C***********************************************************************
C> Filter data
C> @param IUNITP   - UNIT NUMBER OF OUTPUT PREPBUFR DATA SET
C> @param IUNITS   - UNIT NUMBER OF "PREVENT" EVENTS DATA FILTERING
C>              - SUMMARY PRINT FILE
C>              - (USED ONLY IN PREVENTS MODE)
C> @param SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C>              - REPORT BEING PROCESSED
C> @param NEWTYP   - INDICATOR IF THE BUFR MESSAGE TABLE A ENTRY HAS
C>              - CHANGED FROM THAT OF THE PREVIOUS REPORT (=0 - NO,
C>              - =1 - YES)
C>                
      SUBROUTINE GBLEVN02(IUNITP,IUNITS,NEWTYP,subset)
                                         ! FORMERLY SUBROUTINE FILTAN

      DIMENSION    NFLGRT(100:299,12),OEMIN(2:6)
      CHARACTER*8  STNID,subset
      CHARACTER*40 PEVN,QEVN,TEVN,WEVN,PWVN,PW1VN,PW2VN,PW3VN,PW4VN
      REAL(8)      PEV_8(4,255),QEV_8(4,255),TEV_8(4,255),WEV_8(5,255),
     $             PWV_8(4,255),PW1V_8(4,255),PW2V_8(4,255),
     $             PW3V_8(4,255),PW4V_8(4,255),OBS_8,QMS_8,BAK_8,SID_8,
     $             ufc_8,vfc_8
      LOGICAL      FCST,REJP_PS,REJPS,REJT,REJQ,REJW,REJPW,REJPW1,
     $             REJPW2,REJPW3,REJPW4,SATMQC,SATEMP,SOLN60,SOLS60,
     $             MOERR_P,MOERR_T,ADPUPA_VIRT,DOBERR,DOFCST,SOME_FCST,
     $             DOVTMP,VIRT,RECALC_Q,DOPREV
      REAL(8)      BMISS

      COMMON /GBEVAA/ SID_8,OBS_8(13,255),QMS_8(12,255),BAK_8(12,255),
     $ XOB,YOB,DHR,TYP,NLEV
      COMMON /GBEVBB/ IPVCD,IVTCD
      COMMON /GBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT,RECALC_Q,DOPREV,dopmsl
      COMMON /GBEVEE/PSG01,ZSG01,TG01(500),UG01(500),VG01(500),
     x     QG01(500),zint(500),pint(500),pintlog(500),plev(500),
     x     plevlog(500)
      COMMON /GBEVFF/ BMISS

      EQUIVALENCE (SID_8,STNID)

      DATA PEVN  /'POB  PQM  PPC  PRC      '/
      DATA QEVN  /'QOB  QQM  QPC  QRC      '/
      DATA TEVN  /'TOB  TQM  TPC  TRC      '/
      DATA WEVN  /'UOB  VOB  WQM  WPC  WRC '/
      DATA PWVN  /'PWO  PWQ  PWP  PWR      '/
      DATA PW1VN /'PW1O PW1Q PW1P PW1R     '/
      DATA PW2VN /'PW2O PW2Q PW2P PW2R     '/
      DATA PW3VN /'PW3O PW3Q PW3P PW3R     '/
      DATA PW4VN /'PW4O PW4Q PW4P PW4R     '/

      DATA NFLGRT/2400*0/

      DATA OEMIN /0.5,0.1,1.0,0.5,1.0/

      NI  = MOD((NINT(TYP)/10),10)

      IF(NEWTYP.EQ.1)  NFLGRT = 0

C  LOGICAL SWITCHES FOR OBSERVATION LOCATION FILTERING
C  ---------------------------------------------------

      SATEMP = ((TYP.GE.160.AND.TYP.LE.179).AND.SATMQC)
      SOLN60 = ((TYP.GE.160.AND.TYP.LE.163).AND.YOB.GE.-60.AND.SATMQC)
      SOLS60 = ((TYP.EQ.160.OR.TYP.EQ.162.OR.TYP.EQ.163).AND.YOB.LT.-60
     $ .AND.SATMQC)

C  CLEAR THE EVENT ARRAYS
C  ----------------------

      PEV_8  = BMISS
      QEV_8  = BMISS
      TEV_8  = BMISS
      WEV_8  = BMISS
      PWV_8  = BMISS
      PW1V_8 = BMISS
      PW2V_8 = BMISS
      PW3V_8 = BMISS
      PW4V_8 = BMISS

      MAXPEV  = 0
      MAXQEV  = 0
      MAXTEV  = 0
      MAXWEV  = 0
      MAXPWV  = 0
      MAXPW1V = 0
      MAXPW2V = 0
      MAXPW3V = 0
      MAXPW4V = 0

C  LOOP OVER LEVELS APPLYING UNDERGROUND FILTERING AND SPECIAL RULES
C  -----------------------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV

         POB  = OBS_8( 1,L)
         QOB  = OBS_8( 2,L)
         TOB  = OBS_8( 3,L)
         UOB  = OBS_8( 5,L)
         VOB  = OBS_8( 6,L)
         PWO  = OBS_8( 7,L)
         PW1O = OBS_8( 8,L)
         PW2O = OBS_8( 9,L)
         PW3O = OBS_8(10,L)
         PW4O = OBS_8(11,L)
         CAT  = OBS_8(12,L)
         PRSS = OBS_8(13,L)

         PQM  = QMS_8( 1,L)
         QQM  = QMS_8( 2,L)
         TQM  = QMS_8( 3,L)
         ZQM  = QMS_8( 4,L)
         WQM  = QMS_8( 5,L)
         PWQ  = QMS_8( 6,L)
         PW1Q = QMS_8( 7,L)
         PW2Q = QMS_8( 8,L)
         PW3Q = QMS_8( 9,L)
         PW4Q = QMS_8(10,L)

         REJP_PS = .FALSE.
         MOERR_P = .FALSE.
         MOERR_T = .FALSE.
         RCD = 99999

C  -------------------------------------------------------------------
C  RULES FOR PRESSURE (ON ANY LEVEL) -- ALL DATA (MASS AND WIND) ON
C   LEVEL REJECTED IF:
C    - PRESSURE MORE THAN 100 MB BELOW MODEL (GUESS) SURFACE PRESSURE
C       (AND SWITCH FCST=TRUE) -- "PREVENT" PGM REASON CODE 1
C    - PRESSURE IS ZERO OR IS NEGATIVE -- "PREVENT" PGM REASON CODE 2
C    - SURFACE (MASS OR WIND) REPORT PRESSURE IS REPORTED ABOVE 450 MB
C       OR BELOW 1100 MB -- "PREVENT" PGM REASON CODE 2
C  REJECTION MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

         IF(POB.LT.BMISS)  THEN
            IF(.NOT.FCST)  PSG01 = POB
            IF(POB-PSG01.GE.100. .OR. POB.LE.0. .OR.
     $       ((POB.LE.450..OR.POB.GE.1100.) .AND. NI.EQ.8)) THEN
               IF(POB.LE.0..OR.POB.LE.450..OR.POB.GE.1100.) THEN
                  IF(NI.EQ.8)  THEN
                     WRITE(IUNITS,302) STNID,NINT(TYP),YOB,XOB,POB
  302 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, FAILS SANITY ',
     $ 'CHECK')
                  ELSE
                     WRITE(IUNITS,101) STNID,NINT(TYP),YOB,XOB,POB
  101 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $'E, REJECT ALL DATA ON LVL - POB=',F6.1,' MB, FAILS SANITY CHECK')
                  ENDIF
                  RCD = 2
               ELSE
                  IF(NI.EQ.8)  THEN
                     WRITE(IUNITS,303) STNID,NINT(TYP),YOB,XOB,POB,PSG01
  303 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, > 100 MB ',
     $ 'BELOW GES PSFC(=',F6.1,'MB)')
                  ELSE
                     WRITE(IUNITS,102) STNID,NINT(TYP),YOB,XOB,POB,PSG01
  102 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON LVL - POB=',F6.1,' MB, > 100 MB BELOW ',
     $ 'GES PSFC(=',F6.1,' MB)')
                  ENDIF
                  RCD = 1
               ENDIF
               REJ = 8
               REJP_PS = .TRUE.
               PEV_8(1,L) = POB
               PEV_8(2,L) = REJ
               PEV_8(3,L) = IPVCD
               PEV_8(4,L) = RCD
               MAXPEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR SURFACE PRESSURE -- ALL MASS DATA ON SURFACE LEVEL
C   REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - PRESSURE IS MORE THAN 100 MB ABOVE OR BELOW MODEL (GUESS)
C       SURFACE PRESSURE (AND SWITCH FCST=TRUE) -- 
C       "PREVENT" PGM REASON CODE 4
C    - PRESSURE IS REPORTED ABOVE 450 MB OR BELOW 1100 MB -- "PREVENT"
C       PGM REASON CODE 2 (NOTE: DOES NOT APPLY TO SURFACE REPORTS,
C       THESE WERE TESTED FOR THIS CRITERION IN ABOVE PRESSURE TEST)
C    - PRESSURE VIOLATES RULES FOR PRESSURE ON ANY LEVEL (SEE ABOVE)
C  REJECTION FOR FIRST RULE MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(POB.LT.BMISS .AND. CAT.EQ.0) THEN
            IF(.NOT.FCST)  PSG01 = POB
            REJPS = OEFG01(POB,TYP,5,OEMIN(5)).GE.BMISS   .OR.
     $              ABS(POB-PSG01).GE.100.                .OR.
     $              POB.LE.450.                           .OR.
     $              POB.GE.1100.
            IF(REJPS.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS)  THEN
                  IF(ABS(POB-PSG01).GE.100.)  THEN
                     WRITE(IUNITS,104) STNID,NINT(TYP),YOB,XOB,POB,PSG01
  104 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, > 100 MB ',
     $ 'ABOVE GES PSFC(=',F6.1,'MB)')
                     RCD = 4
                  ELSE IF(POB.LE.450..OR.POB.GE.1100.)  THEN
                     WRITE(IUNITS,105) STNID,NINT(TYP),YOB,XOB,POB
  105 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, FAILS SANITY ',
     $ 'CHECK - this should never be printed since test now made in ',
     $ 'section above ')
                     RCD = 2
                  ELSE
                     IF(NFLGRT(NINT(TYP),1).EQ.0)  THEN
                        WRITE(IUNITS,201) NINT(TYP)
  201 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'ALL DATA ON SURFACE LEVEL DUE TO MISSING SFC-P OBS ERROR'/)
                        NFLGRT(NINT(TYP),1) = 1
                     ENDIF
CDAK CDAK CDAK CDAK  WRITE(IUNITS,103) STNID,NINT(TYP),YOB,XOB,POB
CD103 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
CDAK $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,'MB, MISSING OBS.',
CDAK $ ' ERROR')
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               REJP_PS = .TRUE.
               IF(RCD.EQ.3)  MOERR_P = .TRUE.
               IF(REJ.EQ.9.AND.(PQM.GT.3.AND.PQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1401) STNID,NINT(TYP),YOB,XOB,PQM
 1401 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PQM =',F4.0,' -- DO NOT APPLY PSFC QM=9 EVENT')
               ELSE
                  PEV_8(1,L) = POB
                  PEV_8(2,L) = REJ
                  PEV_8(3,L) = IPVCD
                  PEV_8(4,L) = RCD
                  MAXPEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR TEMPERATURE -- TOB AND QOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND OBSERVATION ERROR FOR SFC PRESSURE IS
C       MISSING (AND SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - REPORT IS TYPE 160-163 (LAND TOVS/RTOVS/ATOVS TEMPERATURE
C       SOUNDINGS, ALL PATHS), AND IS AT OR NORTH OF 60 DEGREES SOUTH
C       LATITUDE, AND PRESSURE ON LEVEL IS AT OR BELOW 100 MB (AND
C       SWITCH SATMQC=TRUE)  -- "PREVENT" PGM REASON CODE 6
C    - REPORT IS TYPE 160,162,163 (LAND TOVS/RTOVS/ATOVS TEMPERATURE
C       SOUNDINGS, ALL PATHS BUT CLEAR), AND IS SOUTH OF 60 DEGREES
C       SOUTH LATITUDE, AND PRESSURE ON LEVEL IS BELOW 100 MB (AND
C       SWITCH SATMQC=TRUE) -- "PREVENT" PGM REASON CODE 6
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (EXCEPT FOR MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE
C       2 ABOVE) (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR FIRST TWO RULES MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(TOB.LT.BMISS) THEN
            REJT = OEFG01(POB,TYP,2,OEMIN(2)).GE.BMISS  .OR.
     $             (SOLN60.AND.NINT(POB*10.).GE.1000)   .OR.
     $             (SOLS60.AND.NINT(POB*10.).GT.1000)
            IF(REJT.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS)  THEN
                  IF(SOLN60.AND.NINT(POB*10.).GE.1000)  THEN
                     IF(NFLGRT(NINT(TYP),6).EQ.0)  THEN
                        WRITE(IUNITS,7304) NINT(TYP)
 7304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $'TOB/QOB AT AND BELOW 100 MB IF REPORT IS NORTH OF 60S LATITUDE'/)
                        NFLGRT(NINT(TYP),6) = 1
                     ENDIF
                     RCD = 6
                  ELSE  IF(SOLS60.AND.NINT(POB*10.).GT.1000)  THEN
                     IF(NFLGRT(NINT(TYP),7).EQ.0)  THEN
                        WRITE(IUNITS,7305) NINT(TYP)
 7305 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB BELOW 100 MB IF REPORT IS SOUTH OF 60S LATITUDE'/)
                        NFLGRT(NINT(TYP),7) = 1
                     ENDIF
                     RCD = 6
                  ELSE
                     IF(NFLGRT(NINT(TYP),2).EQ.0)  THEN
                        IF(NI.EQ.8)  THEN
                           WRITE(IUNITS,304) NINT(TYP)
  304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                        ELSE
                           WRITE(IUNITS,202) NINT(TYP)
  202 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB ON AT LEAST ONE LVL (IF AVAILABLE ON THAT LVL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                        ENDIF
                        NFLGRT(NINT(TYP),2) = 1
cdak cdak cdak cdak cdakWRITE(IUNITS,106) STNID,NINT(TYP),YOB,XOB,TOB
cd106 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $ 'E, REJECT TOB/QOB ON LVL - TOB=',F5.1,'C, MISSING OBS. ERROR')
                     ENDIF
                     RCD = 3
                     REJ = 9
                  ENDIF
               ELSE
                  IF(MOERR_P)  THEN
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               IF(RCD.EQ.3)  MOERR_T = .TRUE.
               IF(REJ.EQ.9.AND.(TQM.GT.3.AND.TQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1402) STNID,NINT(TYP),YOB,XOB,TQM
 1402 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT TQM =',F4.0,' -- DO NOT APPLY TEMP QM=9 EVENT')
               ELSE
                  TEV_8(1,L) = TOB
                  TEV_8(2,L) = REJ
                  TEV_8(3,L) = IPVCD
                  TEV_8(4,L) = RCD
                  MAXTEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR SPECIFIC HUMIDITY -- QOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - PRESSURE ON LEVEL IS ABOVE "QTOP_REJ" MB {WHERE QTOP_REJ IS
C       READ IN FROM NAMELIST "PREVDATA" (SEE DOCBLOCK)} -- "PREVENT"
C       PGM REASON CODE 5
C    - OBSERVATION ERROR FOR TEMPERATURE ON LEVEL IS MISSING (AND
C       SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND OBSERVATION ERROR FOR SFC PRESSURE IS
C       MISSING (AND SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - TEMPERATURE ON LEVEL IS MISSING OR IS LESS THAN -150 DEG. C --
C       "PREVENT" PGM REASON CODE 2
C    - SPECIFIC HUMIDITY IS ZERO OR IS NEGATIVE -- "PREVENT" PGM REASON
C       CODE 2
C    - REPORT IS TYPE 160-179 (SATELLITE TEMPERATURE SOUNDINGS, ALL
C       TYPES, ALL PATHS, LAND AND SEA), ALL PRESSURE LEVELS (AND
C       SWITCH SATMQC=TRUE) -- "PREVENT" PGM REASON CODE 7
C    - TEMPERATURE ON LEVEL VIOLATES RULES FOR TEMPERATURE (EXCEPT FOR
C       MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE 2 ABOVE)
C       (SEE ABOVE)
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (EXCEPT FOR MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE
C       4 ABOVE) (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR FIRST FOUR RULES MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(QOB.LT.BMISS) THEN
            REJQ = OEFG01(POB,TYP,3,OEMIN(3)).GE.BMISS        .OR.
     $             TOB.GE.BMISS                               .OR.
     $             TOB.LE.-150.                               .OR.
     $             NINT(POB * 10.).LT.NINT(QTOP_REJ * 10.)    .OR.
     $             QOB.LE.0.                                  .OR.
     $             SATEMP                                     .OR.
     $             REJT
            IF(REJQ.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS.AND..NOT.REJT)  THEN
                  IF(SATEMP)  THEN
                     IF(NFLGRT(NINT(TYP),8).EQ.0)  THEN
                        WRITE(IUNITS,7306) NINT(TYP)
 7306 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON ALL LEVELS'/)
                        NFLGRT(NINT(TYP),8) = 1
                     ENDIF
                     RCD = 7
                  ELSE IF(QOB.LE.0..OR.TOB.GE.BMISS.OR.TOB.LE.-150.)THEN
                     WRITE(IUNITS,111) STNID,NINT(TYP),YOB,XOB,
     $                QOB/1000.,TOB
  111 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT QOB ON LVL - QOB=',F6.3,' G/KG, FAILS SANITY CHECK ',
     $ '(TOB=',F5.1,' C)')
                     RCD = 2
                  ELSE IF(OEFG01(POB,TYP,3,OEMIN(3)).GE.BMISS)  THEN
                     IF(NFLGRT(NINT(TYP),3).EQ.0)  THEN
                        IF(NI.EQ.8)  THEN
                           WRITE(IUNITS,305) NINT(TYP)
  305 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                        ELSE
                           WRITE(IUNITS,203) NINT(TYP)
  203 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON AT LEAST ONE LEVEL (IF AVAILABLE ON THAT LEVEL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                        ENDIF
                        NFLGRT(NINT(TYP),3) = 1
                     ENDIF
                     RCD = 3
                     REJ = 9
cdak cdak cdak cdak  WRITE(IUNITS,108) STNID,NINT(TYP),YOB,XOB,QOB/1000.
cd108 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT QOB ON LVL - QOB=',F6.3,'G/KG, MISSING OBS. ERROR')
                  ELSE
                     WRITE(IUNITS,109) STNID,NINT(TYP),YOB,XOB,
     $                QOB/1000.,QTOP_REJ,POB
  109 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT QOB ON LVL - QOB=',F6.3,' G/KG, ABOVE ',F6.1,
     $ 'MB (POB=',F6.1,' MB)')
                     RCD = 5
                     REJ = 9
                  ENDIF
               ELSE
                  IF(MOERR_P.OR.MOERR_T)  THEN
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               IF(REJ.EQ.9.AND.(QQM.GT.3.AND.QQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1403) STNID,NINT(TYP),YOB,XOB,QQM
 1403 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT QQM =',F4.0,' -- DO NOT APPLY MSTR QM=9 EVENT')
               ELSE
                  QEV_8(1,L) = QOB
                  QEV_8(2,L) = REJ
                  QEV_8(3,L) = IPVCD
                  QEV_8(4,L) = RCD
                  MAXQEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR WIND -- UOB AND VOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND OBSERVATION ERROR FOR SFC PRESSURE IS
C       MISSING (AND SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C       (Note: This can currently never happen because earlier check
C              for missing obs error for sfc pressure is only done if
C              "surface" level is category 0 and this is not possible
C              for wind reports.)
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (EXCEPT FOR MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE
C       2 ABOVE) (SEE ABOVE)
C    - This is a SFCSHP report with calm winds and non-missing
C      background u- or v-component wind is .GE. 5 m/sec --
C      "PREVENT" PGM REASON CODE 8, Q.M. set to 8
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR FIRST TWO RULES MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(MIN(UOB,VOB).LT.BMISS) THEN
            REJW = OEFG01(POB,TYP,4,OEMIN(4)).GE.BMISS
            IF(REJW.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS)  THEN
                  IF(NFLGRT(NINT(TYP),4).EQ.0)  THEN
                     IF(NI.EQ.8)  THEN
                        WRITE(IUNITS,1304) NINT(TYP)
 1304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'UOB/VOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                     ELSE
                        WRITE(IUNITS,204) NINT(TYP)
  204 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'UOB/VOB ON AT LEAST ONE LVL (IF AVAILABLE ON THAT LVL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                     ENDIF
                     NFLGRT(NINT(TYP),4) = 1
                  ENDIF
cdak cdak cdak    WRITE(IUNITS,112) STNID,NINT(TYP),YOB,XOB
cd112 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT UOB/VOB ON LVL - MISSING OBS. ERROR')
                  RCD = 3
                  REJ = 9
               ELSE
                  IF(MOERR_P)  THEN  ! This currently can never be TRUE
                                     ! since CAT is never 0 for "sfc"
                                     ! level of wind reports
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               IF(REJ.EQ.9.AND.(WQM.GT.3.AND.WQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1404) STNID,NINT(TYP),YOB,XOB,WQM
 1404 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT WQM =',F4.0,' -- DO NOT APPLY WIND QM=9 EVENT')
               ELSE
                  WEV_8(1,L) = UOB
                  WEV_8(2,L) = VOB
                  WEV_8(3,L) = REJ
                  WEV_8(4,L) = IPVCD
                  WEV_8(5,L) = RCD
                  MAXWEV = L
               ENDIF
            ENDIF
c  Reject calm sfc marine winds if background u- or v- wind .ge. 5 m/s
            if(subset.eq."SFCSHP".and.uob.eq.0..and.vob.eq.0.) then
              call ufbint(-iunitp,ufc_8,1,1,iret,'UFC')
              call ufbint(-iunitp,vfc_8,1,1,iret,'VFC')
cccccccc      if(ibfms(ufc_8).eq.0.or.ibfms(vfc_8).eq.0) then
                          ! DAK: changed to only allow this test if
                          !      both UFC and VFC are non-missing
              if(ibfms(ufc_8).eq.0.and.ibfms(vfc_8).eq.0) then
                if(abs(ufc_8).ge.5..or.abs(vfc_8).ge.5.) then
                  if(wqm.le.3) then
                    write(iunits,1504) stnid,nint(typ),ufc_8,vfc_8
 1504 FORMAT(/' --> ID ',A8,', (RTP ',I3,' UFC=',F5.2,' VFC=',F5.2,') ',
     $ 'NEW WIND EVENT, UOB/VOB CALM (0 M/S) WHILE |UFC| AND/OR |VFC| ',
     $ '>= 5 M/S, QM SET TO 8'/)
                    wev_8(1,1) = uob
                    wev_8(2,1) = vob
                    wev_8(3,1) = 8
                    wev_8(4,1) = Ipvcd
                    wev_8(5,1) = 8
                    maxwev = 1
                  end if
                end if
              end if
            end if
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR TOTAL COLUMN PRECIPITABLE WATER -- PWO REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PWO.LT.BMISS) THEN
            REJPW = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW) THEN
               IF(NFLGRT(NINT(TYP),5).EQ.0)  THEN
                  WRITE(IUNITS,205) NINT(TYP)
  205 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PWO DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),5) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,113) STNID,NINT(TYP),YOB,XOB,PWO
cd113 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PWO ON LVL - PWO=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PWQ.GT.3.AND.PWQ.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1405) STNID,NINT(TYP),YOB,XOB,PWQ
 1405 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PWQ =',F4.0,' -- DO NOT APPLY PWtO QM=9 EVENT')
               ELSE
                  PWV_8(1,L) = PWO
                  PWV_8(2,L) = 9
                  PWV_8(3,L) = IPVCD
                  PWV_8(4,L) = 3
                  MAXPWV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 1 PRECIPITABLE WATER -- PW1O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW1O.LT.BMISS) THEN
            REJPW1 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW1) THEN
               IF(NFLGRT(NINT(TYP),9).EQ.0)  THEN
                  WRITE(IUNITS,206) NINT(TYP)
  206 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW1O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),9) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,114) STNID,NINT(TYP),YOB,XOB,PW1O
cd114 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW1O ON LVL - PW1O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW1Q.GT.3.AND.PW1Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1406) STNID,NINT(TYP),YOB,XOB,PW1Q
 1406 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW1Q =',F4.0,' -- DO NOT APPLY PW1O QM=9 EVENT')
               ELSE
                  PW1V_8(1,L) = PW1O
                  PW1V_8(2,L) = 9
                  PW1V_8(3,L) = IPVCD
                  PW1V_8(4,L) = 3
                  MAXPW1V = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 2 PRECIPITABLE WATER -- PW2O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW2O.LT.BMISS) THEN
            REJPW2 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW2) THEN
               IF(NFLGRT(NINT(TYP),10).EQ.0)  THEN
                  WRITE(IUNITS,207) NINT(TYP)
  207 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW2O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),10) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,115) STNID,NINT(TYP),YOB,XOB,PW2O
cd115 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW2O ON LVL - PW2O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW2Q.GT.3.AND.PW2Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1407) STNID,NINT(TYP),YOB,XOB,PW2Q
 1407 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW2Q =',F4.0,' -- DO NOT APPLY PW2O QM=9 EVENT')
               ELSE
                  PW2V_8(1,L) = PW2O
                  PW2V_8(2,L) = 9
                  PW2V_8(3,L) = IPVCD
                  PW2V_8(4,L) = 3
                  MAXPW2V = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 3 PRECIPITABLE WATER -- PW3O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW3O.LT.BMISS) THEN
            REJPW3 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW3) THEN
               IF(NFLGRT(NINT(TYP),11).EQ.0)  THEN
                  WRITE(IUNITS,208) NINT(TYP)
  208 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW3O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),11) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,116) STNID,NINT(TYP),YOB,XOB,PW3O
cd116 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW3O ON LVL - PW3O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW3Q.GT.3.AND.PW3Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1408) STNID,NINT(TYP),YOB,XOB,PW3Q
 1408 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW3Q =',F4.0,' -- DO NOT APPLY PW3O QM=9 EVENT')
               ELSE
                  PW3V_8(1,L) = PW3O
                  PW3V_8(2,L) = 9
                  PW3V_8(3,L) = IPVCD
                  PW3V_8(4,L) = 3
                  MAXPW3V = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 4 PRECIPITABLE WATER -- PW4O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW4O.LT.BMISS) THEN
            REJPW4 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW4) THEN
               IF(NFLGRT(NINT(TYP),12).EQ.0)  THEN
                  WRITE(IUNITS,209) NINT(TYP)
  209 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW4O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),12) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,117) STNID,NINT(TYP),YOB,XOB,PW4O
cd117 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW4O ON LVL - PW4O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW4Q.GT.3.AND.PW4Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1409) STNID,NINT(TYP),YOB,XOB,PW4Q
 1409 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW4Q =',F4.0,' -- DO NOT APPLY PW4O QM=9 EVENT')
               ELSE
                  PW4V_8(1,L) = PW4O
                  PW4V_8(2,L) = 9
                  PW4V_8(3,L) = IPVCD
                  PW4V_8(4,L) = 3
                  MAXPW4V = L
               ENDIF
            ENDIF
         ENDIF

      ENDDO
      ENDIF

C  APPLY THE PROPER EVENTS
C  -----------------------

      IF(MAXPEV .GT.0) CALL UFBINT(IUNITP,PEV_8, 4,MAXPEV, IRET,PEVN)
      IF(MAXQEV .GT.0) CALL UFBINT(IUNITP,QEV_8, 4,MAXQEV, IRET,QEVN)
      IF(MAXTEV .GT.0) CALL UFBINT(IUNITP,TEV_8, 4,MAXTEV, IRET,TEVN)
      IF(MAXWEV .GT.0) CALL UFBINT(IUNITP,WEV_8, 5,MAXWEV, IRET,WEVN)
      IF(MAXPWV .GT.0) CALL UFBINT(IUNITP,PWV_8, 4,MAXPWV, IRET,PWVN)
      IF(MAXPW1V.GT.0) CALL UFBINT(IUNITP,PW1V_8,4,MAXPW1V,IRET,PW1VN)
      IF(MAXPW2V.GT.0) CALL UFBINT(IUNITP,PW2V_8,4,MAXPW2V,IRET,PW2VN)
      IF(MAXPW3V.GT.0) CALL UFBINT(IUNITP,PW3V_8,4,MAXPW3V,IRET,PW3VN)
      IF(MAXPW4V.GT.0) CALL UFBINT(IUNITP,PW4V_8,4,MAXPW4V,IRET,PW4VN)

      RETURN
      END
C***********************************************************************
C***********************************************************************
C>  GBLEVN03 - INTERPOLATE MODEL DATA (FIRST GUESS OR ANALYSIS) TO OB LOCATIONS
C> @param SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR REPORT BEING PROCESSED
C-----------------------------------------------------------------------
      SUBROUTINE GBLEVN03(SUBSET) ! FORMERLY SUBROUTINE GETFC

      USE GBLEVN_MODULE

      REAL(8)   OBS_8,QMS_8,BAK_8,SID_8
      REAL(8)   BMISS
      CHARACTER*8  SUBSET

      COMMON /GBEVAA/ SID_8,OBS_8(13,255),QMS_8(12,255),BAK_8(12,255),
     $ XOB,YOB,DHR,TYP,NLEV
      COMMON /GBEVEE/PSG01,ZSG01,TG01(500),UG01(500),VG01(500),
     x     QG01(500),zint(500),pint(500),pintlog(500),plev(500),
     x     plevlog(500)
      COMMON /GBEVFF/ BMISS


      DATA TZERO / 273.15 /
      DATA BETAP / .0552  /
      DATA BETA  / .00650 /
      DATA ROG   / 29.261 /

C  CLEAR THE BACKGROUND EVENT ARRAY
C  --------------------------------

      BAK_8 = BMISS

C  GET GUESS PROFILE AT OB LOCATION
C  --------------------------------
      CALL GBLEVN06(XOB,YOB)

      
C  INTERPOLATE GUESS PROFILES TO OB PRESSURES
C  ------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO 10 L=1,NLEV

         POB  = OBS_8( 1,L)
         QOB  = OBS_8( 2,L)
         TOB  = OBS_8( 3,L)
         ZOB  = OBS_8( 4,L)
         UOB  = OBS_8( 5,L)
         VOB  = OBS_8( 6,L)
         PWO  = OBS_8( 7,L)
         PW1O = OBS_8( 8,L)
         PW2O = OBS_8( 9,L)
         PW3O = OBS_8(10,L)
         PW4O = OBS_8(11,L)
         CAT  = OBS_8(12,L)

         IF(POB.LE.0. .OR. POB.GE.BMISS) GOTO 10

         poblog = log(pob)
         
         la = -999
         lb = -999
         do k=1,kmax-1
            if (poblog<=plevlog(k) .and. poblog>plevlog(k+1)) then
               la = k
               lb = k+1
               exit
            endif
         enddo
         if (la > 0) then
            wt = (poblog-plevlog(lb)) / (plevlog(la)-plevlog(lb))
         else
            la = 1
            lb = la+1
            wt = 0.0
         endif
         
         li=0
         do k=1,kmax-1
            if (poblog<=pintlog(k) .and. poblog>pintlog(k+1)) then
               li = k
               exit
            endif
         enddo

C  SURFACE PRESSURE
C  ----------------

         IF(CAT.EQ.0 .AND. ZOB.LT.BMISS) THEN
            TS = TG01(1) + (PSG01-PLEV(1))*BETAP
            DZ  = ZOB-ZSG01
            TM  = TS - DZ*BETA*.5
            PFC = PSG01*EXP(-DZ/(TM*ROG))
         ELSE
            PFC = BMISS
         ENDIF

C  SPECIFIC HUMIDITY
C  -----------------

         IF(QOB.LT.BMISS.OR.TOB.LT.BMISS.OR.TYP.EQ.111) THEN

C  (QFC NEEDED BY SYNDATA PROGRAM BUT ONLY FOR REPORT TYPE 111)

            QOB = QG01(LB) + (QG01(LA)-QG01(LB))*WT
         ENDIF

C  TEMPERATURE
C  -----------

         IF(TOB.LT.BMISS.OR.SUBSET.EQ.'VADWND  '.OR.TYP.EQ.111) THEN

C  (TFC NEEDED BY CQCVAD AND SYNDATA PROGRAMS, LATTER ONLY FOR REPORT
C   TYPE 111)

            IF(POB.GT.PLEV(1)) THEN
               TOB = TG01(1) + (POB-PLEV(1))*BETAP
            ELSE
               TOB = TG01(LB) + (TG01(LA)-TG01(LB))*WT
            ENDIF
            TOB = TOB - TZERO
         ENDIF

C  HEIGHT
C  ------

         IF(ZOB.LT.BMISS) THEN
            IF(POB.GT.PLEV(1)) THEN
               TM = TG01(1) + (.5*(PINT(1)+POB)-PLEV(1))*BETAP
               ZOB = ZINT(1) - ROG*TM*LOG(POB/PINT(1))
            ELSE
               TM = TG01(LB) + (TG01(LA)-TG01(LB))*WT
               ZOB = ZINT(LI) - ROG*TM*LOG(POB/PINT(LI))
            ENDIF
         ENDIF

C  U AND V COMPONENTS
C  ------------------

         IF(UOB.LT.BMISS .OR. VOB.LT.BMISS) THEN
            UOB = UG01(LB) + (UG01(LA)-UG01(LB))*WT
            VOB = VG01(LB) + (VG01(LA)-VG01(LB))*WT
         ENDIF


C  PRECIPITABLE WATER
C  ------------------

         PWO  = BMISS
         PW1O = BMISS
         PW2O = BMISS
         PW3O = BMISS
         PW4O = BMISS

C  RELATIVE HUMIDITY
C  -----------------

         RHO = BMISS

C  SCATTER THE PROPER FIRST GUESS/ANALYSIS VALUES
C  ----------------------------------------------

         BAK_8(1,L)  = PFC
         BAK_8(2,L)  = QOB
         BAK_8(3,L)  = TOB
         BAK_8(4,L)  = ZOB
         BAK_8(5,L)  = UOB
         BAK_8(6,L)  = VOB
         BAK_8(7,L)  = PWO
         BAK_8(8,L)  = PW1O
         BAK_8(9,L)  = PW2O
         BAK_8(10,L) = PW3O
         BAK_8(11,L) = PW4O
         BAK_8(12,L) = RHO

   10 ENDDO
      ENDIF

      RETURN
      END
C***********************************************************************
C***********************************************************************
C>  Get observation error
      SUBROUTINE GBLEVN04 ! FORMERLY SUBROUTINE GETOE

      DIMENSION OEMIN(2:6)
      REAL(8)   OBS_8,QMS_8,BAK_8,SID_8
      REAL(8)   BMISS

      COMMON /GBEVAA/ SID_8,OBS_8(13,255),QMS_8(12,255),BAK_8(12,255),
     $ XOB,YOB,DHR,TYP,NLEV
      COMMON /GBEVFF/ BMISS

      DATA OEMIN /0.5,0.1,1.0,0.5,1.0/

C  CLEAR THE EVENT ARRAY
C  ---------------------

      BAK_8 = BMISS

C  LOOP OVER LEVELS LOOKING UP THE OBSERVATION ERROR
C  -------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV

         POB  = OBS_8( 1,L)
         QOB  = OBS_8( 2,L)
         TOB  = OBS_8( 3,L)
         WOB  = MAX(OBS_8(5,L),OBS_8(6,L))
         PWO  = OBS_8( 7,L)
         PW1O = OBS_8( 8,L)
         PW2O = OBS_8( 9,L)
         PW3O = OBS_8(10,L)
         PW4O = OBS_8(11,L)
         CAT  = OBS_8(12,L)

         IF(CAT .EQ.0    ) BAK_8( 1,L) = OEFG01(POB,TYP,5,OEMIN(5))
         IF(QOB .LT.BMISS) BAK_8( 2,L) = OEFG01(POB,TYP,3,OEMIN(3))
         IF(TOB .LT.BMISS) BAK_8( 3,L) = OEFG01(POB,TYP,2,OEMIN(2))
         IF(WOB .LT.BMISS) BAK_8( 5,L) = OEFG01(POB,TYP,4,OEMIN(4))
         IF(PWO .LT.BMISS) BAK_8( 6,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW1O.LT.BMISS) BAK_8( 7,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW2O.LT.BMISS) BAK_8( 8,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW3O.LT.BMISS) BAK_8( 9,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW4O.LT.BMISS) BAK_8(10,L) = OEFG01(POB,TYP,6,OEMIN(6))

      ENDDO
      ENDIF

      RETURN
      END
C***********************************************************************
C***********************************************************************
C>  SUBROUTINE GBLEVN06 - 2D LINEAR HORIZONTAL INTERPOLATION
C-----------------------------------------------------------------------
      SUBROUTINE GBLEVN06(XOB,YOB) ! FORMERLY SUBROUTINE HTERP

      USE GBLEVN_MODULE

      COMMON /GBEVEE/ PSI,ZSI,TI(500),UI(500),VI(500),QI(500),
     x     zint(500),pint(500),pintlog(500),plev(500),plevlog(500)

      DATA ROG   / 29.261 /


C  CALCULATE HORIZONTAL WEIGHTS AND INTERPOLATE
C  --------------------------------------------

      WX = XOB/DLON + 1.0
      I0 = WX
      I1 = MOD(I0,IMAX) + 1
      WX = WX-I0

      WY = (YOB+90.)/DLAT + 1.0
      J0 = WY
      J1 = MIN(J0+1,JMAX)
      WY = WY-J0

C  HTERP FOR SURFACE HEIGHT
C  ------------------------

      P1  = iar12z(I0,J0)
      P2  = iar12z(I0,J1)
      P3  = iar12z(I1,J0)
      P4  = iar12z(I1,J1)
      P5  = P1+(P2-P1)*WY
      P6  = P3+(P4-P3)*WY
      ZSI = P5+(P6-P5)*WX

C  HTERP FOR SURFACE PRESSURE
C  --------------------------

      P1  = iar13p(I0,J0)
      P2  = iar13p(I0,J1)
      P3  = iar13p(I1,J0)
      P4  = iar13p(I1,J1)
      P5  = P1+(P2-P1)*WY
      P6  = P3+(P4-P3)*WY
      PSI = P5+(P6-P5)*WX

C  HTERP FOR UPA T,U,V,Q
C  ---------------------

      DO K=1,KMAX

         P1 = iar14t(I0,J0,K)
         P2 = iar14t(I0,J1,K)
         P3 = iar14t(I1,J0,K)
         P4 = iar14t(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         TI(K) = P5+(P6-P5)*WX

         P1 = iar15u(I0,J0,K)
         P2 = iar15u(I0,J1,K)
         P3 = iar15u(I1,J0,K)
         P4 = iar15u(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         UI(K) = P5+(P6-P5)*WX

         P1 = iar16v(I0,J0,K)
         P2 = iar16v(I0,J1,K)
         P3 = iar16v(I1,J0,K)
         P4 = iar16v(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         VI(K) = P5+(P6-P5)*WX

         P1 = iar17q(I0,J0,K)
         P2 = iar17q(I0,J1,K)
         P3 = iar17q(I1,J0,K)
         P4 = iar17q(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         QI(K) = P5+(P6-P5)*WX

C  Layer Pressure
C  --------------

         P1 = iarpsl(I0,J0,K)
         P2 = iarpsl(I0,J1,K)
         P3 = iarpsl(I1,J0,K)
         P4 = iarpsl(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         PLEV(K) = P5+(P6-P5)*WX

C  Interface Pressure
C  ------------------

         P1 = iarpsi(I0,J0,K+1)
         P2 = iarpsi(I0,J1,K+1)
         P3 = iarpsi(I1,J0,K+1)
         P4 = iarpsi(I1,J1,K+1)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         PINT(K+1) = P5+(P6-P5)*WX

      ENDDO

C  Compute interface heights
C  -------------------------

      zint(1) = zsi
      pint(1) = psi
      pintlog(1) = log(pint(1))
      do k=2,kmax
         k0 = k-1
         zint(k) = zint(k0) - rog*ti(k0)*log(pint(k)/pint(k0))
         pintlog(k) = log(pint(k))
      enddo
      pint(kmax+1) = 0.0

C  Compute log(pressure) at layer midpoints
C  ----------------------------------------

      do k=1,kmax
         plevlog(k) = log(plev(k))
      enddo

ccccc print *,' pint=',pint(1:kmax)
ccccc print *,' zint=',zint(1:kmax)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C>
C> SUBPROGRAM:    OEFG01
C>   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2007-09-14
C>
C> ABSTRACT: FUNCTION WHICH RETURNS THE OBSERVATION ERROR FOR A
C>   REQUESTED VARIABLE INTERPOLATED TO A DEFINED PRESSURE LEVEL FOR A
C>   DEFINED REPORT TYPE.  IT IS OBTAINED FROM AN INPUT ARRAY CONTAINING
C>   OBSERVATION ERRORS ON FIXED PRESSURE LEVELS BY VARIABLE AND REPORT
C>   TYPE (READ EARLIER FROM THE EXTERNAL OBSERVATION ERROR TABLE)
C>
C> PROGRAM HISTORY LOG:
C> 1995-05-17  J. WOOLLEN (NP20) - ORIGINAL AUTHOR (FUNCTION OEF)
C> 2007-09-14 D. A. KEYSER -- MODIFIED TO USE EXACT LOGIC AS IN GSI
C>    (MINIMUM LIMITING VALUE FOR OBS ERROR BASED ON VARIABLE TYPE,
C>     LEVEL PRESSURE LIMITED TO MAX OF 2000 MB AND MIN OF ZERO MB, A
C>     FEW OTHER MINOR CHANGES)
C>
C> USAGE:    XX = OEFG01(P,TYP,IE,OEMIN)
C>   INPUT ARGUMENT LIST:
C> @param P        - REAL PRESSURE LEVEL (MB) TO INTERPOLATE OBS ERROR TO
C> @param TYP      - REAL PREPBUFR REPORT TYPE
C> @param IE       - VARIABLE TYPE BEING INTERPOLATED (=2 - TEMPERATURE,
C>              - =3 - MOISTURE, =4 - WIND, =5 - SURFACE PRESSURE, =6 -
C>              - PRECIPITABLE WATER)
C>              - (USED ONLY IN PREVENTS MODE)
C> @param OEMIN    - REAL MINIMUM VALUE FOR OBS ERROR (FOR VARIABLE BEING
C>              - INTERPOLATED)
C>
C> REMARKS: 'OEFG01' RETURNED IS OBSERVATION ERROR FOR VARIABLE "IE" IN
C>     REPORT TYPE "TYP", INTERPOLATED TO PRESSURE LEVEL "P".
C>
C>
C> ATTRIBUTES:
C>   LANGUAGE: FORTRAN 90
C>   MACHINE:  NCEP WCOSS
C>
      FUNCTION OEFG01(P,TYP,IE,OEMIN)

      REAL(8) BMISS

      COMMON /GBEVDD/ERRS(300,33,6)
      COMMON /GBEVFF/ BMISS

      OEFG01 = BMISS

C  LOOK UP ERRORS FOR PARTICULAR OB TYPES
C  --------------------------------------

      KX = TYP

      P = MAX(0.,MIN(P,2000.))

      IF(P.GE.ERRS(KX,1,1)) K1 = 1

      DO KL = 1,32
         IF(P.GE.ERRS(KX,KL+1,1).AND.P.LE.ERRS(KX,KL,1))  K1 = KL
      ENDDO

      IF(P.LE.ERRS(KX,33,1)) K1 = 5

      K2 = K1 + 1

      EDIFF = ERRS(KX,K2,1) - ERRS(KX,K1,1)
      IF(ABS(EDIFF).GT.0.0)  THEN
         DEL = (P - ERRS(KX,K1,1))/EDIFF
      ELSE
         DEL = BMISS
      ENDIF

      DEL = MAX(0.,MIN(DEL,1.0))

      OEFG01 = ((1.0 - DEL) * ERRS(KX,K1,IE)) + (DEL * ERRS(KX,K2,IE))
      OEFG01 = MAX(OEFG01,OEMIN)

C  SET MISSING ERROR VALUE TO "BMISS"
C  ----------------------------------

      IF(OEFG01.GE.5E5) OEFG01 = BMISS

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C>
C> SUBPROGRAM:    GBLEVN08
C>   PRGMMR: S. MELCHIOR      ORG: NP22       DATE: 2014-03-25
C>
C> ABSTRACT: CREATE VIRTUAL TEMPERATURE EVENTS WITHIN GBLEVENTS
C>   SUBROUTINE.  FOR ALL TYPES EXCEPT RASS, THIS CONSISTS OF FIRST RE-
C>   CALCULATING THE SPECIFIC HUMIDITY FROM THE REPORTED DEWPOINT
C>   TEMPERATURE AND PRESSURE, FOLLOWED BY THE CALCULATION OF VIRTUAL
C>   TEMPERATURE FROM THE JUST-CALCULATED SPECIFIC HUMIDITY AND THE
C>   REPORTED (SENSIBLE) TEMPERATURE.  THE RE-CALCULATED SPECIFIC
C>   HUMIDITY IS THEN ENCODED AS A STACKED EVENT TO BE LATER WRITTEN
C>   INTO THE PREPBUFR FILE (UNDER PROGRAM "VIRTMP", REASON CODE 0).
C>   IF THE NAMELIST SWITCH DOVTMP IS TRUE, THEN THE JUST-CALCULATED
C>   VIRTUAL TEMPERATURE IS THEN ALSO ENCODED AS A STACKED EVENT TO BE
C>   LATER WRITTEN INTO THE PREPBUFR FILE (UNDER PROGRAM "VIRTMP",
C>   REASON CODE 0, 2 OR 6).  FOR RASS DATA, SPECIFIC HUMIDITY IS
C>   MISSING HOWEVER IF THE NAMELIST SWITCH DOVTMP IS TRUE, A SIMPLE
C>   COPY OF THE REPORTED (VIRTUAL) TEMPERATURE IS ENCODED AS A STACKED
C>   EVENT TO BE LATER WRITTEN INTO THE PREPBUFR FILE (UNDER PROGRAM
C>   "VIRTMP", REASON CODE 3).  FOR SURFACE DATA WITH A MISSING PMSL, IF
C>   DOVTMP=T AND DOPMSL=T AND A VIRTUAL TEMPERATURE HAS BEEN COMPUTED,
C>   CALCULATE AN ESTIMATED PMSL AND ENCODE IT INTO PREPBUFR FILE ALONG
C>   WITH AN INDICATOR THAT IS WAS DERIVED HERE. THIS SUBROUTINE IS
C>   CURRENTLY ONLY CALLED FOR SURFACE LAND ("ADPSFC"), MARINE
C>   ("SFCSHP"), MESONET ("MSONET"), RASS ("RASSDA") OR SATELLITE
C>   TEMPERATURE RETRIEVAL ("SATEMP") DATA TYPES WHEN SWITCH
C>   "ADPUPA_VIRT" IS FALSE AND ONLY FOR SURFACE LAND ("ADPSFC"), MARINE
C>   ("SFCSHP"), MESONET ("MSONET"), RASS ("RASSDA"), SATELLITE
C>   TEMPERATURE RETRIEVAL ("SATEMP") OR RAOB/DROP/MULTI-LVL RECCO
C>   ("ADPUPA") DATA TYPES WHEN SWITCH "ADPUPA_VIRT" IS TRUE.  IT IS
C>   ALSO ONLY CALLED IN THE PREVENTS MODE.  THIS ROUTINE IS CALLED ONCE
C>   FOR EACH VALID REPORT IN THE PREPBUFR FILE.
C>
C> PROGRAM HISTORY LOG:
C> 1995-05-17  J. WOOLLEN (NP20) - ORIGINAL AUTHOR
C> 1997-06-01  D.A. KEYSER - STREAMLINED, ADDED SWITCH DOVTMP
C> 1999-12-01 D. A. KEYSER -- SPEC. HUMIDITY AND VIRT. TEMPERATURE ARE
C>     NOW CALCULATED WHEN SPEC. HUMIDITY QUAL. MARKER IS BAD (SUBJECT
C>     TO A SANITY CHECK), HOWEVER THE VIRT. TEMPERATURE GETS A BAD
C>     QUAL. MARKER (8)
C> 2004-08-30 D. A. KEYSER -- FOR "RASSDA" TYPES, ENCODES A SIMPLE COPY
C>     OF THE REPORTED (VIRTUAL) TEMPERATURE AS A "VIRTMP" EVENT IF
C>     DOVTMP IS TRUE, GETS NEW REASON CODE 3
C> 2006-07-14 D. A. KEYSER --  PROCESSES REPORTS IN MESSAGE TYPE ADPUPA
C>     (I.E., RAOBS, DROPS, MULTI-LEVEL RECCOS) WITH SAME LOGIC AS IN
C>     SUBROUTINE VTPEVN OF PROGRAM PREPOBS_CQCBUFR WHEN NEW NAMELIST
C>     SWITCH "ADPUPA_VIRT" IS TRUE {NORMALLY "ADPUPA_VIRT" IS FALSE
C>     (DEFAULT) BECAUSE SUBSEQUENT PROGRAM PREPOBS_CQCBUFR PERFORMS
C>     THIS FUNCTION}
C> 2007-09-14 D. A. KEYSER -- FOR NON-"ADPUPA" TYPES, Q.M. 9 IS NOW
C>     ASSIGNED TO CALCULATED VIRT. TEMPS IF THE MOISTURE Q.M. IS 9 OR
C>     15 AND ORIG. TEMP NOT "BAD", THESE "VIRTMP" EVENTS RECEIVE NEW
C>     REASON CODE 4, HAD RECEIVED Q.M. 8 WITH REASON CODE 2 LIKE VIRT.
C>     TEMPS CALCULATED FROM "BAD" MOISTURE - THIS MEANS ONLY TRULY
C>     "BAD" VIRT. TEMPS WILL NOW GET Q.M. 8 AND VIRT. TEMPS FLAGGED FOR
C>     NON-USE BY ASSIMILATION (BUT STILL "GOOD") WILL NOW GET Q.M. 9
C>     (GSI MONITORS, BUT DOES NOT USE, OBS WITH Q.M. 9, BUT IT DOES NOT
C>     EVEN CONSIDER OBS WITH Q.M. 8); FOR "ADPUPA" TYPES, Q.M. 3 IS NOW
C>     ASSIGNED TO CALCULATED VIRT. TEMPS ONLY IF THE MOISTURE Q.M. IS
C>     TRULY BAD (I.E. > 3 BUT NOT 9 OR 15) (AND, AS BEFORE, ORIG. TQM
C>     IS 1 OR 2 AND POB IS BELOW 700 MB) - BEFORE, TQM SET TO 3 WHEN
C>     QQM WAS 9 OR 15 AND ALL OTHER CONDITIONS MET; FOR "SATEMP" TYPES,
C>     ENCODES A SIMPLE COPY OF THE REPORTED (VIRTUAL) TEMPERATURE AS A
C>     "VIRTMP" EVENT IF DOVTMP IS TRUE, GETS REASON CODE 3 (SIMILAR TO
C>     WHAT IS ALREADY DONE FOR "RASSDA" TYPES)
C> 2013-04-12  D. A. KEYSER -- DON'T ALLOW CALCULATED Q TO BE < 0 WHICH
C>     CAN OCCUR ON WCOSS FOR CASES OF HORRIBLY BAD MESONET DATA
C> 2014-03-25 S. MELCHIOR -- ADDED NEW NAMELIST SWITCH "DOPMSL" WHICH,
C>     WHEN TRUE, DERIVES PMSL (MNEMONIC "PMO") FROM REPORTED STATION
C>     PRESSURE ("POB"), STATION HEIGHT/ELEVATION ("ZOB") AND THE JUST-
C>     COMPUTED VIRTUAL TEMPERATURE FOR SURFACE REPORTS IN CASES WHEN
C>     REPORTED PMSL IS MISSING.  DOVTMP MUST BE TRUE AND DOANLS MUST BE
C>     FALSE ("PREVENTS" MODE). THE DERIVED PMSL EITHER GETS A QUALITY
C>     MARK ("PMQ") OF 3 OR INHERITS THE STATION PRESSURE QUALITY MARK
C>     ("PQM"), WHICHEVER IS GREATER. THE VALUE OF THE PMSL INDICATOR
C>     (NEW MNEMONIC "PMIN") IS SET TO 1 TO DENOTE PMSL WAS DERIVED
C>     RATHER THAN OBSERVED.  THE DEFAULT FOR "DOPMSL" IS FALSE
C>     (NORMALLY ONLY TRUE IN RTMA AND URMA RUNS).  IT IS FORCED TO BE
C>     FALSE IN "POSTEVENTS" MODE (DOANLS=TRUE).
C>
C> USAGE:    CALL GBLEVN08(IUNITP)
C>   INPUT ARGUMENT LIST:
C> @param IUNITP   - BUFR OUTPUT FILE UNIT
C> @param SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C>              - REPORT BEING PROCESSED
C>
C> REMARKS: WILL IMMEDIATELY RETURN TO CALLING PROGRAM IF ANY OF THE
C>   FOLLOWING CONDITIONS EXIST: THERE ARE NO LEVELS OF VALID DEWPOINT,
C>   OBS, TEMPERATURE Q.M. OR SPEC. HUMIDITY Q.M. IN THE INPUT PREPBUFR
C>   FILE FOR THE REPORT.  WILL NOT ATTEMPT EITHER SPEC. HUMIDITY NOR
C>   VIRT. TEMP CALC. ON A GIVEN LEVEL IF ANY OF THE FOLLOWING
C>   CONDITIONS EXIST: REPORTED PRESSURE OBS IS MISSING, REPORTED
C>   (SENSIBLE) TEMPERATURE OBS IS MISSING, OR REPORTED DEWPOINT OBS IS
C>   MISSING.
C> 
C> ATTRIBUTES:
C>   LANGUAGE: FORTRAN 90
C>   MACHINE:  NCEP WCOSS
C>
      SUBROUTINE GBLEVN08(IUNITP,SUBSET) ! FORMERLY SUBROUTINE VTPEVN

      parameter    (Rd=287.04, g=9.81)
      CHARACTER*80 EVNSTQ,EVNSTV,evnstp
      CHARACTER*8  SUBSET,stnid
      REAL(8)      TDP_8(255),TQM_8(255),QQM_8(255),BAKQ_8(4,255),
     $             BAKV_8(4,255),bakp_8(3),OBS_8,QMS_8,BAK_8,
     $             SID_8,pqm_8
      real(8)      pmo_8,zob_8,pmsl_8
      REAL(8)      BMISS

      LOGICAL      EVNQ,EVNV,DOVTMP,TROP,ADPUPA_VIRT,DOBERR,DOFCST,
     $             SOME_FCST,FCST,VIRT,SATMQC,RECALC_Q,DOPREV,
     $             evnp,dopmsl,surf

      COMMON /GBEVAA/ SID_8,OBS_8(13,255),QMS_8(12,255),BAK_8(12,255),
     $ XOB,YOB,DHR,TYP,NLEV
      COMMON /GBEVBB/ IPVCD,IVTCD
      COMMON /GBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT,RECALC_Q,DOPREV,dopmsl
      COMMON /GBEVFF/ BMISS

      DATA EVNSTQ /'QOB QQM QPC QRC'/
      DATA EVNSTV /'TOB TQM TPC TRC'/
      data evnstp /'PMO PMQ PMIN'/

      equivalence (sid_8,stnid)

C-----------------------------------------------------------------------
C FCNS BELOW CONVERT TEMP/TD (K) & PRESS (MB) INTO SAT./ SPEC. HUM.(G/G)
C-----------------------------------------------------------------------
      ES(T) = 6.1078*EXP((17.269*(T - 273.16))/((T - 273.16)+237.3))
      QS(T,P) = (0.622*ES(T))/(P-(0.378*ES(T)))
C-----------------------------------------------------------------------
C FCN BELOW derives mean sea-level pressure (mb)from P (station
C  pressure, mb), Tv (virtual temperature, K), and Z (station height/
C  elevation, m) for surface reports
C-----------------------------------------------------------------------
      PMSL_fcn(P,Tv,Z) = P*exp((g*Z)/(Rd*Tv))
C-----------------------------------------------------------------------

C  CLEAR TEMPERATURE AND SPECIFIC HUMIDITY EVENTS
C  ----------------------------------------------

      EVNQ   = .FALSE.
      EVNV   = .FALSE.
      evnp   = .false.
      BAKQ_8 = BMISS
      BAKV_8 = BMISS
      bakp_8 = bmiss
      TROP   = .FALSE.

      surf = (subset.eq.'ADPSFC'.or.subset.eq.'SFCSHP'.or.
     $           subset.eq.'MSONET')

C  GET DEWPOINT TEMPERATURE AND CURRENT T,Q QUALITY MARKERS
C  Also get mean sea level pressure, station pressure quality mark,
C   and station height (elevation) for surface reports if dopmsl=T
C  ----------------------------------------------------------------

      CALL UFBINT(-IUNITP,TDP_8,1,255,NLTD,'TDO')
      CALL UFBINT(-IUNITP,QQM_8,1,255,NLQQ,'QQM')
      CALL UFBINT(-IUNITP,TQM_8,1,255,NLTQ,'TQM')
      if(surf.and.dopmsl) then
         call ufbint(-iunitp,pmo_8,1,1,nlpm,'PMO')
         call ufbint(-iunitp,zob_8,1,1,nlzo,'ZOB')
         call ufbint(-iunitp,pqm_8,1,1,nlpq,'PQM')
      endif
      IF(SUBSET.NE.'RASSDA  '.AND.SUBSET.NE.'SATEMP  ') THEN
         IF(NLTD.EQ.0) RETURN
         IF(NLQQ.EQ.0) RETURN
      ENDIF
      IF(NLTQ.EQ.0) RETURN
      IF(SUBSET.NE.'RASSDA  '.AND.SUBSET.NE.'SATEMP  ') THEN
         IF(NLTD.NE.NLEV) THEN
            PRINT'(" ##GBLEVENTS/GBLEVN08 - NLTD .NE. NLEV - STOP 61")'
            CALL ERREXIT(61)
         ENDIF
         IF(NLQQ.NE.NLEV) THEN
            PRINT'(" ##GBLEVENTS/GBLEVN08 - NLQQ .NE. NLEV - STOP 63")'
            CALL ERREXIT(63)
         ENDIF
      ENDIF
      IF(NLTQ.NE.NLEV) THEN
         PRINT'(" ##GBLEVENTS/GBLEVN08 - NLTQ .NE. NLEV - STOP 62")'
         CALL ERREXIT(62)
      ENDIF

C  COMPUTE SPECIFIC HUMIDITY AND VIRTUAL TEMPERATURE USING REPORTED DEWP
C  For surface reports, also calculate PMSL if it is missing, dopmsl=T,
C   and a virtual temperature has been computed
C  ---------------------------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV
         POB = OBS_8(1,L)
         TDO = TDP_8(L)
         TOB = OBS_8(3,L)
         CAT = OBS_8(12,L)
         IF(DOVTMP) THEN
            IF(SUBSET.EQ.'RASSDA  '.OR.SUBSET.EQ.'SATEMP  ') THEN
               IF(TOB.LT.BMISS) THEN
                  BAKV_8(1,L) = TOB
                  BAKV_8(2,L) = TQM_8(L)
                  BAKV_8(3,L) = IVTCD
                  BAKV_8(4,L) = 3
                  EVNV = .TRUE.
                  CYCLE
               ENDIF
            ENDIF
         ENDIF
         IF(POB.LT.BMISS .AND. TOB.LT.BMISS
     $                   .AND. TDO.LT.BMISS) THEN
            IF(QQM_8(L).GT.3) THEN
C  Don't update q or calculate Tv if bad moisture obs fails sanity check
C   (also don't calc. PMSL if it is missing and dopmsl=T for sfc rpts)
cdak           IF(TDO.LT.-103.15 .OR. TDO.GT.46.83 .OR. POB.LT.0.1 .OR.
cdak $          POB.GT.1100.)
cdak $ print *, '&&& bad QM fails sanity check'
               IF(TDO.LT.-103.15 .OR. TDO.GT.46.83 .OR. POB.LT.0.1 .OR.
     $          POB.GT.1100.)  CYCLE
            ENDIF
            QOB = QS(TDO+273.16,POB)
ccccc       BAKQ_8(1,L) = QOB*1E6 ! dak fix 2/27/13: can't be > bmiss
                                  !  else flting pt overflow in BUFRLIB
ccc         IF(QOB*1E6.LT.BMISS) BAKQ_8(1,L) = QOB*1E6
                                  ! dak add'l fix 4/12/13: don't allow
                                  !  calc. q to be < 0 which can occur
                                  !  on WCOSS for cases of horribly bad
                                  !  mesonet data
            IF(QOB*1E6.LT.BMISS .AND. QOB.GT.0.) BAKQ_8(1,L) = QOB*1E6
            BAKQ_8(2,L) = QQM_8(L)  ! Moist qm same as before for
                                    !  re-calc. q
            BAKQ_8(3,L) = IVTCD
            BAKQ_8(4,L) = 0     ! Re-calc. q gets unique reason code 0
            EVNQ = .TRUE.
C  If message type ADPUPA, test this level to see if at or above trop
C   (trop must be above 500 mb to pass test; if no trop level found
C   assume it's at 80 mb)
C  Don't calculate Tv on this level if at or above trop (doesn't affect
C   q calculation)
            TROP = (SUBSET.EQ.'ADPUPA  ' .AND.
     $       ((CAT.EQ.5 .AND. POB.LT.500.) .OR. POB.LT. 80. .OR. TROP))
            IF(DOVTMP .AND. .NOT.TROP) THEN
               BAKV_8(1,L) = (TOB+273.16)*(1.+.61*QOB)-273.16
               BAKV_8(3,L) = IVTCD
               IF(SUBSET.EQ.'ADPUPA  ') THEN
C  Message type ADPUPA comes here
                  IF((QQM_8(L).LT.4.OR.QQM_8(L).EQ.9.OR.QQM_8(L).EQ.15)
     $             .OR. TQM_8(L).EQ.0 .OR. TQM_8(L).GT.3
     $             .OR. POB.LE.700.) THEN
                     BAKV_8(2,L) = TQM_8(L) ! Tv qm same as for T when
                                            !  q ok or q flagged by
                                            !  PREPRO (but not bad) 
                     BAKV_8(4,L) = 0    ! Tv gets unique reason code 0
                  ELSE
                     BAKV_8(2,L) = 3    !Tv qm susp for bad moist below
                                        ! 700 mb
                     BAKV_8(4,L) = 6    !Tv gets unique reason code 6
                  ENDIF
               ELSE
C  All other message types come here
                  IF(QQM_8(L).LT.4) THEN
                     BAKV_8(2,L) = TQM_8(L) ! Tv qm same as for T when
                                            !  q ok
                     BAKV_8(4,L) = 0    ! Tv gets unique reason code 0
                  ELSE IF((QQM_8(L).EQ.9.OR.QQM_8(L).EQ.15).AND.
     $                    (TQM_8(L).LE.3.OR.TQM_8(L).GE.15.OR.
     $                    TQM_8(L).EQ.9)) THEN
cdak  print'(" %%% process tvirt on lvl ",I0," for missing moist obs ",
cdak $ "error/high-up moist case when orig. T not ""bad"" (set TQM_8=",
cdak $ "9)")', l
                     BAKV_8(2,L) = 9 ! Tv qm 9 for moist w/ missing obs
                                     !  error or moist flagged by
                                     !  PREPRO (but not bad) and T qm
                                     !  orig not "bad"
                     BAKV_8(4,L) = 4 ! Tv gets unique reason code 4
                  ELSE
cdak  print'(" %%% process tvirt on lvl ",I0," for ""bad"" QQM_8 case ",
cdak $ "or missing moist obs error/high-up moist w/ ""bad"" TQM_8 case",
cdak $ " (set TQM_8=8)")', l
                     BAKV_8(2,L) = 8 ! Tv qm 8 (bad) for "bad" moist or
                                     !  moist w/ missing obs error or
                                     !  moist flagged by PREPRO (but
                                     !  not bad) and T qm orig "bad"
                     BAKV_8(4,L) = 2 ! Tv gets unique reason code 2
                  ENDIF
                  if(surf) then
c  For sfc rpts & dopmsl=T, derive Pmsl in cases when it is not reported
c  DAK: Note right now this can only happen for sfc rpts where a Tv is
c       set to be calculated and where it is successfully calculated.
c       Eventually this may be able to be relaxed such that PMSL can be
c       derived even if, e.g., no moisture were reported (in this case
c       Ts would have to be used, still a decent estimate of PMSL could
c       liekly be made). Might also be able to be derived if no T rpted.
                    if(dopmsl) then
                      if(ibfms(pmo_8).ne.0) then
                        tv = bakv_8(1,1) + 273.16
                        zob=zob_8
                        pmsl_8=PMSL_fcn(pob,tv,zob)
                        bakp_8(1) = pmsl_8
                        bakp_8(2) = max(3,int(pqm_8))! qm>=3 b/c derived
                        bakp_8(3) = 1. ! pmin=1 for derived value
cccccccccc              write(*,4000) stnid,bakp_8(3),bakp_8(2)
 4000 format('--> ID ',A8,' Pmsl missing - derived from Pstn; ',
     $ 'PMIN = ',F4.1,' PMQ = ',F4.1,'')
                        evnp = .true.
c Diagnostics for Pmsl values that are suspiciously high
                        if(pmsl_8.gt.1060) then
                          write(*,4001) stnid,pob,bakp_8(1)
 4001 format('--> ID ',A8,' Derived PMSL unrealistic; FLAG; ',
     $ 'POB = ',F7.2,' PMO = ',F7.2,'')
                        end if
                      end if
                    end if
                  end if
               ENDIF
               EVNV = .TRUE.
            ENDIF
         ENDIF
      ENDDO
      ENDIF

C  ENCODE EVENTS INTO REPORT
C  -------------------------

      IF(NLEV.GT.0)  THEN
         IF(EVNQ) CALL UFBINT(IUNITP,BAKQ_8,4,NLEV,IRET,EVNSTQ)
         IF(EVNV) CALL UFBINT(IUNITP,BAKV_8,4,NLEV,IRET,EVNSTV)
         if(nlev.eq.1.and.evnp)
     $    call ufbint(iunitp,bakp_8,3,nlev,iret,evnstp)
      ENDIF

      RETURN
      END
C#######################
C#######################
C#######################
C#######################
C#######################
C#######################
C***********************************************************************
C***********************************************************************
C> Do something
C> @param IUNITF   - 2-WORD ARRAY:
C>        For SIGIO input:
C>              - WORD 1 - UNIT NUMBER OF FIRST INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS VALID AT THE DATE IN IDATEP, IF HH IN
C>                IDATEP IS NOT A MULTIPLE OF 3 THEN THIS FILE IS VALID
C>                AT THE CLOSEST TIME PRIOR TO THE DATE IN IDATEP THAT
C>                IS A MULTIPLE OF 3
C>              - WORD 2 - UNIT NUMBER OF SECOND INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS EMPTY, IF HH IN IDATEP IS NOT A MULTIPLE
C>                OF 3 THEN THIS FILE IS VALID AT THE CLOSEST TIME AFTER
C>                THE DATE IN IDATEP THAT IS A MULTIPLE OF 3
C>        For NEMSIO input:
C>              - WORD 1 - UNIT NUMBER OF INPUT NEMSIO-BASED GLOBAL FILE
C>                (EITHER FIRST GUESS OR ANALYSIS); ALWAYS VALID AT AT
C>                THE DATE IN IDATEP
C>              - WORD 2 - NOT USED, SHOULD BE A NULL FILE
C>                
C> @param IDATEP   - CENTER DATE FOR PREPBUFR FILE IN THE FORM YYYYMMDDHH
C> @param im
C> @param jm
C> @param IDRT INTEGER GRID IDENTIFIER
C>             (IDRT=4 FOR GAUSSIAN GRID,
C>             IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C>             IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
      SUBROUTINE GBLEVN10(IUNITF,IDATEP,IM,JM,IDRT) ! FORMERLY
                                                    ! SUBROUTINE GESRES
      USE GBLEVN_MODULE
      USE SIGIO_MODULE
      USE SIGIO_R_MODULE
      use sp_mod

      IMPLICIT NONE
      INTEGER IUNITF(2), IDATEP, IM, JM, IDRT
      REAL, PARAMETER :: PI180=.0174532
      INTEGER*4, PARAMETER :: ONE=1, TEN=10

      TYPE(SIGIO_HEAD) :: HEAD(2)
      TYPE(SIGIO_DATS) :: DATS
      TYPE(SIGIO_DATM) :: DATM

      INTEGER*4 IRET,IRET1,IRETS,IMJM4,KM4,IDVM,NTRAC,IUNIT4(2)

      INTEGER KFILES,IFILE,JFILE,IDATGS_COR,JCAP,JCAP1,JCAP2,JCAP1X2,
     $ MDIMA,MDIMB,MDIMC,IROMB,MAXWV,IDIR,NS,I,J,K,L,II,JJ,IB,IE

      INTEGER IDATE(8,2),JDATE(8,2),KDATE(8,2),KINDX(2)

      CHARACTER*6  COORD(3)
      CHARACTER*20 CFILE

      REAL FHOUR,RINC(5)

      DATA COORD /'SIGMA ','HYBRID','GENHYB'/

      REAL,         ALLOCATABLE :: cofs(:,:),     cofv(:,:,:)
      REAL,         ALLOCATABLE :: cofs_f(:,:,:), cofv_f(:,:,:,:)
      REAL (KIND=4),ALLOCATABLE :: grds(:,:,:),   grdv(:,:,:,:),
     $                             wrk1(:,:),     wrk2(:,:)

      IMAX  = IM
      JMAX  = JM
      IMJM4 = IM*JM
      IUNIT4(:) = IUNITF(:)

      IF(MOD(MOD(IDATEP,100),3).EQ.0)  THEN
         KFILES = 1
         KINDX = 0
         PRINT 331, MOD(IDATEP,100)
  331    FORMAT(/' --> GBLEVENTS: THE PREPBUFR CENTER HOUR (',I2.2,
     $    ') IS A MULTIPLE OF 3 - ONLY ONE SIGIO (SIGMA OR HYBRID) ',
     $    'INPUT GLOBAL FILE IS READ,'/16X,'NO TIME INTERPOLATION OF ',
     $    'SPECTRAL COEFFICIENTS IS PERFORMED'/)
      ELSE
         KFILES = 2
         KINDX(1) = MOD(MOD(IDATEP,100),3)
         KINDX(2) = KINDX(1) - 3
         PRINT 332, MOD(IDATEP,100)
  332    FORMAT(/' --> GBLEVENTS: THE PREPBUFR CENTER HOUR (',I2.2,
     $    ') IS NOT A MULTIPLE OF 3 - TWO SPANNING SIGIO (SIGMA OR ',
     $    'HYBRID) INPUT GLOBAL FILES'/16X,'ARE READ AND THE SPECTRAL ',
     $    'COEFFICIENTS ARE INTERPOLATED TO THE PREPBUFR CENTER TIME'/)
      ENDIF

C  GET VALID-TIME DATE OF SIGMA OR HYBRID FILE(S), ALSO READ HEADERS
C  -----------------------------------------------------------------

      JFILE = 0
      RINC  = 0
      DO IFILE=1,KFILES
         JFILE = IFILE

         WRITE(CFILE,'("fort.",I2.2)') IUNITF(IFILE)

         CALL SIGIO_RROPEN(IUNIT4(IFILE),CFILE,IRET)
         CALL SIGIO_RRHEAD(IUNIT4(IFILE),HEAD(IFILE),IRET1)
         print *,' cfile_sig=',cfile,'sigio_rropen: iret=',iret,
     $   'sigio_rrhead: iret1=',iret1

         IF(IRET.NE.0)  GO TO 903
         IF(IRET1.NE.0) GO TO 904

         IDATE(:,IFILE)   = 0

         IDATE(1,IFILE)   = HEAD(IFILE)%IDATE(4)
         IDATE(2:3,IFILE) = HEAD(IFILE)%IDATE(2:3)
         IDATE(5,IFILE)   = HEAD(IFILE)%IDATE(1)

         FHOUR = HEAD(IFILE)%FHOUR
         print'("  idate=",I5,7I3.2,"  fhour=",F7.3)', idate(:,ifile),
     $    head(ifile)%fhour

         IF(IDATE(1,IFILE).LT.100)  THEN

C IF 2-DIGIT YEAR FOUND IN GLOBAL SIMGA FILE INITIAL DATE
C  (IDATE(1,IFILE)), MUST USE "WINDOWING" TECHNIQUE TO CREATE A 4-DIGIT
C  YEAR (NOTE: THE T170 IMPLEMENTATION IN JUNE 1998 WAS TO INCLUDE THE
C  WRITING OF A 4-DIGIT YEAR HERE.  PRIOR TO THIS, THE YEAR HERE WAS
C  2-DIGIT.)

            PRINT'(" ##GBLEVENTS/GBLEVN10 - 2-DIGIT YEAR FOUND IN ",
     $       "SIGIO (SIGMA OR HYBRID) INPUT GLOBAL FILE ",I0,
     $       "; INITIAL DATE (YEAR IS: ",I0,")")', IFILE,idate(1,IFILE)
            PRINT'("      - USE WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT",
     $       " YEAR")'
            IF(IDATE(1,IFILE).GT.20)  THEN
               IDATE(1,IFILE) = 1900 + IDATE(1,IFILE)
            ELSE
               IDATE(1,IFILE) = 2000 + IDATE(1,IFILE)
            ENDIF
            PRINT'(" ##GBLEVENTS/GBLEVN10 - CORRECTED 4-DIGIT YEAR IS",
     $       " NOW: ",I0)', IDATE(1,IFILE)
         ENDIF

         RINC(2) = FHOUR
         CALL W3MOVDAT(RINC,IDATE(:,IFILE),JDATE(:,IFILE))

         PRINT 1, IFILE,HEAD(IFILE)%FHOUR,
     $    (IDATE(II,IFILE),II=1,3),IDATE(5,IFILE),(JDATE(II,IFILE),
     $    II=1,3),JDATE(5,IFILE)
    1    FORMAT(' --> GBLEVENTS: SIGIO (SIGMA OR HYBRID) INPUT GLOBAL ',
     $    'FILE',I2,' HERE IS A ',F5.1,' HOUR FORECAST FROM ',I5.4,
     $    3I3.2,' VALID AT ',I5.4,3I3.2)

         KDATE(:,IFILE) = JDATE(:,IFILE)

         IF(KFILES.EQ.2) THEN
            RINC(2) = REAL(KINDX(IFILE))
            CALL W3MOVDAT(RINC,JDATE(:,IFILE),KDATE(:,IFILE))
         ENDIF

         IDATGS_COR = (KDATE(1,IFILE) * 1000000) + (KDATE(2,IFILE) *
     $    10000) + (KDATE(3,IFILE) * 100) + KDATE(5,IFILE)

C  VALID DATES MUST MATCH
C  ----------------------

         IF(IDATEP.NE.IDATGS_COR)  GO TO 901

      ENDDO


C  EXTRACT HEADER INFO
C  -------------------
 
      JCAP    = HEAD(1)%JCAP
      KMAX    = HEAD(1)%LEVS
      KM4     = KMAX
      IDVC    = HEAD(1)%IDVC
      IDSL    = head(1)%IDSL
      IDVM    = HEAD(1)%IDVM
      NTRAC   = HEAD(1)%NTRAC
      NVCOORD = HEAD(1)%NVCOORD
      ALLOCATE (VCOORD(KMAX+1,NVCOORD))
      VCOORD  = 0.0
      VCOORD  = HEAD(1)%VCOORD

      SFCPRESS_ID  = MOD(HEAD(1)%IDVM,TEN)
      THERMODYN_ID = MOD(HEAD(1)%IDVM/TEN,TEN)
      IF(IDVC == 3 .AND. THERMODYN_ID == 3) THEN
         KMAXS = (NTRAC+1)*KMAX + 2
      ELSE
         KMAXS = 2*KMAX + 2
         NTRAC = 1
      ENDIF

      ALLOCATE (iar12z(im,jm), iar13p(im,jm))
      ALLOCATE (iar14t(im,jm,kmax),  iar15u(im,jm,kmax),
     $          iar16v(im,jm,kmax),  iar17q(im,jm,kmax),
     $          iarpsl(im,jm,kmax),  iarpsi(im,jm,kmax+1))


      if(idvc.eq.0)  idvc = 1  ! Reset IDVC=0 to 1 (sigma coord.)
      IF(IDVC < 0 .or. IDVC > 3) THEN
         PRINT *, '##GBLEVENTS/GBLEVN10: INVALID VERT COORD ID (=',IDVC
      ENDIF


C  DEFINE THE OTHER RESOLUTION PARAMETERS
C  --------------------------------------
 
      JCAP1   = JCAP+1
      JCAP2   = JCAP+2
      JCAP1X2 = JCAP1*2
      MDIMA   = JCAP1*JCAP2
      MDIMB   = MDIMA/2+JCAP1
      MDIMC   = MDIMB*2
      IMAX    = 384
      JMAX    = IMAX/2+1
 
      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX
 
      PRINT 2, JCAP,IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,COORD(IDVC)
    2 FORMAT(/' --> GBLEVENTS: GLOBAL MODEL SPECS: T',I5,' ',
     $ I5,' x ',I5,' GRID WITH ',I3,' LEVELS ',I3,
     $' SCALARS -------> ',F5.2,' X ',F5.2,' VERT. ',
     $ 'COORD: ',A)

      GO TO 902

  901 CONTINUE
      PRINT 9901, JFILE,(JDATE(II,JFILE),II=1,3),JDATE(5,JFILE),IDATEP
 9901 FORMAT(/' ##GBLEVENTS/GBLEVN10 - SIGMA OR HYBRID FILE',I2,' DATE',
     $ ' (',I4.4,3(I2.2),'), DOES NOT MATCH -OR SPAN- PREPBUFR FILE ',
     $ 'CENTER DATE (',I10,') -STOP 68'/)
      CALL ERREXIT(68)
  903 CONTINUE
      PRINT 9903, JFILE,IRET
 9903 FORMAT(/' ##GBLEVENTS/GBLEVN10 - SIGMA OR HYBRID FILE',I2,
     $ ' RETURNED FROM SIGIO_RROPEN WITH R.C.',I3,' -STOP 70'/)
      CALL ERREXIT(70)
  904 CONTINUE
      PRINT 9904, JFILE,IRET1
 9904 FORMAT(/' ##GBLEVENTS/GBLEVN10 - SIGMA OR HYBRID FILE',I2,
     $ ' RETURNED FROM SIGIO_RRHEAD WITH R.C.',I3,' -STOP 71'/)
      CALL ERREXIT(71)
  902 CONTINUE
      IF(KMAX.GT.500) then
         PRINT'(" ##GBLEVENTS/GBLEVN10 - KMAX TOO BIG = ",I0,
     $    " - UNABLE TO TRANSFORM GLOBAL SIGMA FILE(S) - STOP 69")',
     $    KMAX
         CALL ERREXIT(69)
      ENDIF

C***********************************************************************
C***********************************************************************

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C USAGE:    CALL SPTEZM(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,WAVE,GRID,IDIR)
C   INPUT ARGUMENTS:
C     IROMB    - INTEGER SPECTRAL DOMAIN SHAPE
C                (0 FOR TRIANGULAR, 1 FOR RHOMBOIDAL)
C     MAXWV    - INTEGER SPECTRAL TRUNCATION
C     IDRT     - INTEGER GRID IDENTIFIER
C                (IDRT=4 FOR GAUSSIAN GRID,
C                 IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C                 IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
C     IMAX     - INTEGER EVEN NUMBER OF LONGITUDES
C     JMAX     - INTEGER NUMBER OF LATITUDES
C     KMAX     - INTEGER NUMBER OF FIELDS TO TRANSFORM
C     WAVE     - REAL (2*MX,KMAX) WAVE FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRID     - REAL (IMAX,JMAX,KMAX) GRID FIELD (E->W,N->S) IF IDIR<0
C     IDIR     - INTEGER TRANSFORM FLAG
C                (IDIR>0 FOR WAVE TO GRID, IDIR<0 FOR GRID TO WAVE)
C   OUTPUT ARGUMENTS:
C     WAVE     - REAL (2*MX,KMAX) WAVE FIELD IF IDIR<0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRID     - REAL (IMAX,JMAX,KMAX) GRID FIELD (E->W,N->S) IF IDIR>0


C USAGE:    CALL SPTEZMV(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
C    &                   WAVED,WAVEZ,GRIDU,GRIDV,IDIR)
C   INPUT ARGUMENTS:
C     WAVED    - REAL (2*MX,KMAX) WAVE DIVERGENCE FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     WAVEZ    - REAL (2*MX,KMAX) WAVE VORTICITY FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRIDU    - REAL (IMAX,JMAX,KMAX) GRID U-WIND (E->W,N->S) IF IDIR<0
C     GRIDV    - REAL (IMAX,JMAX,KMAX) GRID V-WIND (E->W,N->S) IF IDIR<0
C   OUTPUT ARGUMENTS:
C     WAVED    - REAL (2*MX,KMAX) WAVE DIVERGENCE FIELD IF IDIR<0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     WAVEZ    - REAL (2*MX,KMAX) WAVE VORTICITY FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRIDU    - REAL (IMAX,JMAX,KMAX) GRID U-WIND (E->W,N->S) IF IDIR>0
C     GRIDV    - REAL (IMAX,JMAX,KMAX) GRID V-WIND (E->W,N->S) IF IDIR>0

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      allocate (cofs_f(mdima,kmaxs,2), cofv_f(mdima,kmax,2,2))

      IROMB = 0
      MAXWV = JCAP
      if (idrt < 0 .or. idrt > 256) IDRT  = 0
      IDIR  = 1

      IF(KINDX(1).EQ.0)  THEN
         KFILES = 1
      ELSE
         KFILES = 2
      ENDIF

C  Allocate for sigio read
C  -----------------------

      SFCPRESS_ID  = MOD(HEAD(1)%IDVM,TEN)
      THERMODYN_ID = MOD(HEAD(1)%IDVM/TEN,TEN)

      print *,'in sig sfcpress_id=',sfcpress_id,' thermodyn_id=',
     $ thermodyn_id,' ntrac=',ntrac
      print *,' idvc=',idvc,' idsl=',idsl,' idvm=',idvm,
     $     ' nvcoord=',nvcoord

      DO IFILE=1,KFILES
         CALL SIGIO_ALDATS(HEAD(IFILE),DATS,IRETS)
         CALL SIGIO_ALDATM(HEAD(IFILE),ONE,KM4,DATM,IRETS)
                                          ! Read surface fields
         CALL SIGIO_RRDATS(IUNIT4(IFILE),HEAD(IFILE),DATS,IRETS)

         IF(IRETS.NE.0) THEN
            print *,' irets from sigio_rrdats = ', irets
            RETURN
         ENDIF

         DO I=1,MDIMA
            COFS_F(I,1,IFILE) = DATS%HS(I)
            COFS_F(I,2,IFILE) = DATS%PS(I)
         ENDDO

                                 ! Read fields on levels 1 through kmax
         CALL SIGIO_RRDATM(IUNIT4(IFILE),HEAD(IFILE),DATM,IRETS)
         IF(IRETS.NE.0) THEN
            print *,' irets from sigio_rrdatm = ', irets
            RETURN
         ENDIF
ccccc    print *,' aft sigio_rrdatm irets=',irets

         IE = KMAX + 2
         COFS_F(:,3:IE,IFILE)        = DATM%T
         DO I=1,NTRAC
           IB = IE + 1
           IE = IB + KMAX - 1
           COFS_F(:,IB:IE,IFILE) = DATM%Q(:,1:KMAX,I)
         ENDDO
         COFV_F(:,:,1,IFILE)             = DATM%D
         COFV_F(:,:,2,IFILE)             = DATM%Z

         CALL SIGIO_AXDATS(DATS,IRETS)
         CALL SIGIO_AXDATM(DATM,IRETS)
      ENDDO

ccccc print *,' after sigio_axdatm'

      ALLOCATE (COFS(MDIMA,KMAXS),     COFV(MDIMA,KMAX,2))
      ALLOCATE (GRDS(imax,jmax,KMAXS), GRDV(imax,jmax,KMAX,2))
      ALLOCATE (WRK1(imax*jmax,KMAX),  WRK2(imax*jmax,KMAX+1))

      IF(KFILES.EQ.1)  THEN
         DO I = 1,MDIMA
            COFS(I,1:KMAXS)    = COFS_f(I,1:KMAXS,1)
            COFV(I,1:KMAX,1:2) = COFV_f(I,1:KMAX,1:2,1)
         ENDDO

      ELSE
         COFS=
     $   ((ABS(KINDX(2))*COFS_f(:,:,1))  +(KINDX(1)*COFS_f(:,:,2)))/3.
         COFV=
     $   ((ABS(KINDX(2))*COFV_f(:,:,:,1))+(KINDX(1)*COFV_f(:,:,:,2)))/3.
      ENDIF

      DEALLOCATE (COFS_F, COFV_F)

      CALL SPTEZM(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAXS,COFS,GRDS,IDIR)
      CALL SPTEZMV(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
     &         COFV(1,1,1),COFV(1,1,2),GRDV(1,1,1,1),GRDV(1,1,1,2),IDIR)

      IF( SFCPRESS_ID == 2 ) THEN   ! for enthalpy version
         GRDS(:,:,2) = 1000.0*GRDS(:,:,2)         ! Now in Pa
      ELSE
         GRDS(:,:,2) = 1000.0*EXP(GRDS(:,:,2))    ! Now in Pa
      ENDIF

      DO NS=1, KMAXS
         CALL GBLEVN11(IMAX,JMAX,GRDS(1,1,NS))
      ENDDO
      DO J=1,JMAX
         DO I=1,IMAX
            IAR12Z(I,J) = GRDS(I,J,1)         ! Orography
            IAR13P(I,J) = GRDS(I,J,2) * 0.01  ! Surface Pressure in hPa
         ENDDO
      ENDDO

      IF(THERMODYN_ID == 3 .AND. IDVC == 3) THEN
         GRDS(:,:,3:2+KMAX) = GRDS(:,:,3:2+KMAX) / HEAD(1)%CPI(1)
         print *,' cpi(0)=',head(1)%cpi(1)
      ENDIF
      CALL SIGIO_MODPR(IMJM4,IMJM4,KM4,NVCOORD,IDVC,IDSL,VCOORD,IRET,
     $                 GRDS(1,1,2),GRDS(1,1,3),PM=WRK1,PD=WRK2(1,2))

      DO J=1,JMAX
         JJ = (J-1)*IMAX
         DO I=1,IMAX
            WRK2(I+JJ,1) = GRDS(I,J,2)                     ! in Pa
         ENDDO
      ENDDO
      DO L=1,KMAX
         WRK2(:,L+1) = WRK2(:,L) - WRK2(:,L+1)             ! in Pa
      ENDDO

ccccc print *,' wrk1=',wrk1(1001,:)
ccccc print *,' wrk2=',wrk2(1001,:)

ccccc CALL GBLEVN11(IMAX,JMAX,WRK2(1,KMAX+1))
ccccc DO L=1,KMAX
ccccc    CALL GBLEVN11(IMAX,JMAX,WRK1(1,L))
ccccc    CALL GBLEVN11(IMAX,JMAX,WRK2(1,L))
ccccc ENDDO

      IF(THERMODYN_ID == 3 .AND. IDVC == 3) THEN
                                 ! Convert from enthalpy to temperature
         GRDS(:,:,3:2+KMAX) = GRDS(:,:,3:2+KMAX) * HEAD(1)%CPI(1)
         CALL SIGIO_CNVTDV(IMJM4,IMJM4,KM4,IDVC,IDVM,NTRAC,IRET,
     $                     GRDS(1,1,3),GRDS(1,1,3+KMAX),HEAD(1)%CPI,1_4)
                                 ! Convert back to virtual temperature
         GRDS(:,:,3:KMAX+2) = GRDS(:,:,3:KMAX+2) *
     $            (1.+(461.50/287.05-1)*GRDS(:,:,3+KMAX:2+KMAX*2))
      ENDIF

      DO L=1,KMAX
         DO K=1,2
            CALL GBLEVN11(IMAX,JMAX,GRDV(1,1,L,K))
         ENDDO
         DO J=1,JMAX
            JJ = (J-1)*IMAX
            DO I=1,IMAX
               IAR14T(I,J,L) = GRDS(I,J,2+L)        ! Temp (virtual)
               IAR15U(I,J,L) = GRDV(I,J,L,1)        ! U component
               IAR16V(I,J,L) = GRDV(I,J,L,2)        ! V component
                                                    ! specific humidity
               IAR17Q(I,J,L) = MAX(0.0,GRDS(I,J,2+KMAX+L)*1.0E6)
               IARPSL(I,J,L) = WRK1(I+JJ,L)*0.01    ! 3D layer pres(hPa)
            ENDDO
         ENDDO
      ENDDO
      DO L=1,KMAX+1
         DO J=1,JMAX
            JJ = (J-1)*IMAX
            DO I=1,IMAX
               IARPSI(I,J,L) = WRK2(I+JJ,L)*0.01 ! 3D interface pressure
                                                 ! (hPa)
            ENDDO
         ENDDO
      ENDDO


ccccc print *,' iar14t=',iar14t(1,80,:)
ccccc print *,' iar15u=',iar15u(1,80,:)
ccccc print *,' iar16v=',iar16v(1,80,:)
ccccc print *,' iarpsi=',iarpsi(1,80,:)
ccccc print *,' iarpsl=',iarpsl(1,80,:)

      DEALLOCATE (COFS, COFV)
      DEALLOCATE (GRDS, GRDV, WRK1, WRK2)

      print *,' RETURNING from GBLENV10'

      RETURN

      END
C***********************************************************************
C***********************************************************************
C>    North-south swap
      subroutine gblevn11(imax,jmax,grid) ! formerly subroutine n_s_swap

      implicit none
      integer imax, jmax
      real grid(imax,jmax)
      real temp (imax)
      integer i, j, jj

      do j=1,jmax/2
        jj = jmax-j+1
        do i=1,imax
          temp(i)    = grid(i,j)
          grid(i,j)  = grid(i,jj)
          grid(i,jj) = temp(i)
        enddo
      enddo
      return
      end
C***********************************************************************
C***********************************************************************
C>    Does something   
      subroutine gblevn11d(imax,jmax,grid)
      implicit none
      integer imax, jmax
      real(kind=8) grid(imax,jmax)
      real(kind=8) temp (imax)
      integer i, j, jj

      do j=1,jmax/2
        jj = jmax-j+1
        do i=1,imax
          temp(i)    = grid(i,j)
          grid(i,j)  = grid(i,jj)
          grid(i,jj) = temp(i)
        enddo
      enddo
      return
      end
!---------------------------------------------------------
C> Does something
C> @param iunitf 
C> @param idatep 
C> @param im 
C> @param jm
C> @param IUNITF   - 2-WORD ARRAY:
C>        For SIGIO input:
C>              - WORD 1 - UNIT NUMBER OF FIRST INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS VALID AT THE DATE IN IDATEP, IF HH IN
C>                IDATEP IS NOT A MULTIPLE OF 3 THEN THIS FILE IS VALID
C>                AT THE CLOSEST TIME PRIOR TO THE DATE IN IDATEP THAT
C>                IS A MULTIPLE OF 3
C>              - WORD 2 - UNIT NUMBER OF SECOND INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS EMPTY, IF HH IN IDATEP IS NOT A MULTIPLE
C>                OF 3 THEN THIS FILE IS VALID AT THE CLOSEST TIME AFTER
C>                THE DATE IN IDATEP THAT IS A MULTIPLE OF 3
C>        For NEMSIO input:
C>              - WORD 1 - UNIT NUMBER OF INPUT NEMSIO-BASED GLOBAL FILE
C>                (EITHER FIRST GUESS OR ANALYSIS); ALWAYS VALID AT AT
C>                THE DATE IN IDATEP
C>              - WORD 2 - NOT USED, SHOULD BE A NULL FILE
C> @param IDATEP   - CENTER DATE FOR PREPBUFR FILE IN THE FORM YYYYMMDDHH      
C> @param im
C> @param jm
C> @param IDRT INTEGER GRID IDENTIFIER
C>              (IDRT=4 FOR GAUSSIAN GRID,
C>              IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C>              IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
      SUBROUTINE GBLEVN12(IUNITF,IDATEP,IM,JM,IDRT)
!---------------------------------------------------------
!--INITIALLY DEVELOPED BY HANG LEI BASED ON GBLEVN10 FOR NEMSIO
!--AND SUBSEQUENTLY MODIFIED BY FANGLIN YANG AND RUSS TREADON

      USE GBLEVN_MODULE
      USE NEMSIO_MODULE
      USE nemsio_openclose
      USE nemsio_read
      USE nemsio_write
      use sigio_module

      IMPLICIT NONE
      INTEGER IUNITF(2), IDATEP, IM, JM, IDRT
      REAL(KIND=8),PARAMETER:: CON_RV=4.6150E+2,CON_RD=2.8705E+2,
     $          FV=CON_RV/CON_RD-1.,ONER=1.0,QMIN=1.0E-10
      INTEGER*4, PARAMETER :: TEN=10

      INTEGER*4 IDRTNEMS
      INTEGER*4 IRET,IMJM4,KM4,IDVM,NTRAC

      INTEGER IDATGS_COR,JCAP,JCAP1,JCAP2,JCAP1X2,MDIMA,MDIMB,MDIMC,
     $ IROMB,MAXWV,IDIR,I,J,K,L,II,JJ

      INTEGER(4) IDATE7(7),JCAP4,IDVC4,DIMZ4,K4,IM4,JM4,KINDREAL,KINDINT
      INTEGER(4) NFHOUR,NFMINUTE,NFSECONDN,NFSECONDD,idsl4,idvm4
      REAL(8) tfac
      REAL(4),ALLOCATABLE :: VCOORD4(:,:,:),CPI(:)
      REAL,ALLOCATABLE :: tmp(:)
      TYPE(NEMSIO_GFILE) :: GFILE

      INTEGER IDATE(8),JDATE(8)
      CHARACTER*20 CFILE2
      REAL FHOUR,RINC(5)
      REAL (KIND=4),ALLOCATABLE :: psfc(:,:), tv(:,:,:),
     $                             wrk1(:,:), wrk2(:,:)

      IMAX  = IM
      JMAX  = JM
      IMJM4 = IM*JM

! no time interpolation needed for nemsio input since files are
!  available every hour - original logic to perform time interpolation
!  is flawed and has been removed in this revision
! --------------------------------------------------------------------

      print 331, mod(idatep,100)
  331 format(/' --> GBLEVENTS: ONLY ONE NEMSIO INPUT GLOBAL FILE IS ',
     $ 'READ SINCE FILES ARE AVAILABLE EACH HOUR (NO NEED TO ',
     $ 'INTERPOLATE'/16X,'SPANNING FILES WHEN THE PREPBUFR CENTER HOUR',
     $ ' (',I2.2,') IS NOT A MULTIPLE OF 3)'/)

C  GET VALID-TIME DATE OF NEMSIO INPUT FILE, ALSO READ HEADERS
C  -----------------------------------------------------------
      CALL NEMSIO_INIT()

      RINC  = 0
      IDATE = 0
      WRITE(CFILE2,'("fort.",I2.2)') IUNITF(1)

      CALL NEMSIO_OPEN(GFILE,trim(CFILE2),'read',iret=iret)
      print *,' cfile_nems2=',cfile2,'nemsio open,iret=',iret

         IDRTNEMS=IDRT
         CALL NEMSIO_GETFILEHEAD(GFILE,IDATE=IDATE7,
     &        JCAP=JCAP4,DIMX=IM4,DIMY=JM4,
     &         DIMZ=DIMZ4,IDVC=IDVC4,NTRAC=NTRAC,IDRT=IDRTNEMS,
     &         NFHOUR=NFHOUR,NFMINUTE=NFMINUTE,NFSECONDN=NFSECONDN,
     &         NFSECONDD=NFSECONDD,idsl=idsl4,idvm=idvm4,IRET=IRET)
      JCAP=JCAP4
      IDVC=IDVC4
      idsl=idsl4
      idvm=idvm4
      IMAX=IM4
      JMAX=JM4
      KMAX=DIMZ4
      if(IDRT==-9999) IDRT=4 ! default for gaussian grid
      IDATE(1:3)=IDATE7(1:3)
      IDATE(5)=IDATE7(4)

      ALLOCATE(VCOORD(KMAX+1,3))
      VCOORD=0.0

      IF(NFSECONDD/=0.AND. NFSECONDD/=-9999) THEN
         FHOUR=REAL(NFHOUR,8)+REAL(NFMINUTE/60.,8)+
     $    REAL(NFSECONDN*1./(NFSECONDD*360.),8)
      ELSE
         FHOUR=REAL(NFHOUR,8)+REAL(NFMINUTE/60.,8)
      ENDIF
      print'("  idate=",I5,7I3.2,"  fhour=",F7.3)', idate,fhour

      ALLOCATE(VCOORD4(KMAX+1,3,2))
      CALL NEMSIO_GETFILEHEAD(GFILE,VCOORD=VCOORD4,IRET=IRET)
      NVCOORD=3
      IF(MAXVAL(VCOORD4(:,3,1))==0..AND.MINVAL(VCOORD4(:,3,1))==0.) THEN
         NVCOORD=2
         IF(MAXVAL(VCOORD4(:,2,1))==0..AND.MINVAL(VCOORD4(:,2,1))==0.)
     $    NVCOORD=1
      ENDIF

      VCOORD(1:KMAX+1,1:NVCOORD)=VCOORD4(1:KMAX+1,1:NVCOORD,1)
      DEALLOCATE(VCOORD4)

      ALLOCATE(CPI(NTRAC+1))
      CALL NEMSIO_GETHEADVAR(GFILE,'CPI',CPI,IRET=IRET)

      RINC(2) = FHOUR
      CALL W3MOVDAT(RINC,IDATE,JDATE)

      PRINT 1, FHOUR,(IDATE(II),II=1,3),IDATE(5),(JDATE(II),II=1,3),
     $ JDATE(5)
    1 FORMAT(' --> GBLEVENTS: GLOBAL NEMSIO FILE: HERE IS A ',F5.1,
     $ ' HOUR FORECAST FROM ',I5.4,3I3.2,' VALID AT ',I5.4,3I3.2)

      IDATGS_COR = (JDATE(1) * 1000000) + (JDATE(2) * 10000) +
     $ (JDATE(3) * 100) + JDATE(5)

C  VALID DATES MUST MATCH
C  ----------------------

      IF(IDATEP.NE.IDATGS_COR)  GO TO 901

C------------------------------------------

      SFCPRESS_ID  = MOD(IDVM,TEN)
      THERMODYN_ID = MOD(IDVM/TEN,TEN)

      IF(IDVC == 3 .AND. THERMODYN_ID == 3) THEN
         KMAXS = (NTRAC+1)*KMAX + 2
      ELSE
         KMAXS = 2*KMAX + 2
         NTRAC = 1
      ENDIF

      ALLOCATE (iar12z(imax,jmax), iar13p(imax,jmax))
      ALLOCATE (iar14t(imax,jmax,kmax),  iar15u(imax,jmax,kmax),
     $          iar16v(imax,jmax,kmax),  iar17q(imax,jmax,kmax),
     $          iarpsl(imax,jmax,kmax),  iarpsi(imax,jmax,kmax+1),
     $          iarpsd(imax,jmax,kmax))

!!! DAK: is this right???????
      if(idvc.eq.0)  idvc = 1  ! Reset IDVC=0 to 1 (sigma coord.)
      IF(IDVC < 0 .or. IDVC > 3) THEN
         PRINT *, '##GBLEVENTS/GBLEVN12: INVALID VERT COORD ID (=',IDVC
      ENDIF


C  DEFINE THE OTHER RESOLUTION PARAMETERS
C  --------------------------------------

      JCAP1   = JCAP+1
      JCAP2   = JCAP+2
      JCAP1X2 = JCAP1*2
      MDIMA   = JCAP1*JCAP2
      MDIMB   = MDIMA/2+JCAP1
      MDIMC   = MDIMB*2

      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX

      PRINT 2, JCAP,IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,idvc

! DAK: is below correct??????????
    2 FORMAT(/' --> GBLEVENTS: GLOBAL MODEL SPECS: T',I5,' ',
     $ I5,' x ',I5,' GRID WITH ',I3,' LEVELS ',I3,
     $' SCALARS -------> ',F5.2,' X ',F5.2,' VERT. ',
     $ 'COORD ID IS: ',I0,' (not sure what this means!')

C***********************************************************************

      IROMB = 0
      MAXWV = JCAP
      if (idrt < 0 .or. idrt > 256) IDRT  = 0
      IDIR  = 1

      print *,'in nem sfcpress_id=',sfcpress_id,' thermodyn_id=',
     $ thermodyn_id,' ntrac=',ntrac
      print *,' idvc=',idvc,' idsl=',idsl,' idvm=',idvm,' nvcoord=',
     $ nvcoord

      call w3kind(kindreal,kindint)

!     print *,'in gblevent, get fields,imax,jmax
      allocate(tmp(imax*jmax))
!
! hgt
      K4=1
      if(kindreal==4) then
         CALL NEMSIO_READRECVw34(GFILE,'hgt','sfc',K4,tmp,iret=iret)
      else
         CALL NEMSIO_READRECV(GFILE,'hgt','sfc',K4,tmp,iret=iret)
      endif
!     print *,'in getnemsio,hgtsfc,',maxval(tmp),minval(tmp),iret
      if(iret==0) THEN
         IAR12Z(:,:)=reshape(tmp,(/imax,jmax/))
         call gblevn11d(imax,jmax,IAR12Z)
      ENDIF

!sfc pres, input in Pa, out in hPa
      if(kindreal==4) then
         CALL NEMSIO_READRECVw34(GFILE,'pres','sfc',K4,tmp,iret=iret)
      else
         CALL NEMSIO_READRECV(GFILE,'pres','sfc',K4,tmp,iret=iret)
      endif
!     print *,'in getnemsio,pressfc,',maxval(tmp),minval(tmp),iret
      if(iret==0) THEN
         IAR13P(:,:)=reshape(tmp*0.01,(/imax,jmax/))
         call gblevn11d(imax,jmax,IAR13P)
      ENDIF
!dpres
!     DO K4=1,KMAX
!        if(kindreal==4) then
!           CALL NEMSIO_READRECVw34(GFILE,'dpres','mid layer',K4,tmp,
!    $       iret=iret)
!        else
!           CALL NEMSIO_READRECV(GFILE,'dpres','mid layer',K4,tmp,
!    $       iret=iret)
!        endif
!        print *,'in getnemsio,dpres,k4=',k4,maxval(tmp),minval(tmp),
!    $    iret
!        if(iret==0) THEN
!           IARPSI(:,:,K4+1)=reshape(tmp*0.01,(/imax,jmax/))
!        ENDIF
!     ENDDO

!pres
!     DO K4=1,KMAX
!        if(kindreal==4) then
!           CALL NEMSIO_READRECVw34(GFILE,'pres','mid layer',K4,tmp,
!    $       iret=iret)
!        else
!           CALL NEMSIO_READRECV(GFILE,'pres','mid layer',K4,tmp,
!    $       iret=iret)
!        endif
!        print *,'in getnemsio,pres,k4=',k4,maxval(tmp),minval(tmp),iret
!        if(iret==0) THEN
!           IARPSL(:,:,k4)=reshape(tmp*0.01,(/imax,jmax/))
!        ENDIF
!     ENDDO
! tmp
      DO K4=1,kmax
         if(kindreal==4) then
            CALL NEMSIO_READRECVw34(GFILE,'tmp','mid layer',K4,tmp,
     $       iret=iret)
         else
            CALL NEMSIO_READRECV(GFILE,'tmp','mid layer',K4,tmp,
     $       iret=iret)
         endif
!        print *,'in getnemsio,tmp,k4=',k4,maxval(tmp),minval(tmp),iret
         if(iret==0) THEN
            IAR14T(:,:,K4)=reshape(tmp,(/imax,jmax/))
            call gblevn11d(imax,jmax,IAR14T(1,1,K4))
         ENDIF
      ENDDO
!u
      DO K4=1,kmax
         if(kindreal==4) then
            CALL NEMSIO_READRECVw34(GFILE,'ugrd','mid layer',K4,tmp,
     $       iret=iret)
         else
            CALL NEMSIO_READRECV(GFILE,'ugrd','mid layer',K4,tmp,
     $       iret=iret)
         endif
!        print *,'in getnemsio,utmp,k4=',k4,maxval(tmp),minval(tmp),iret
         if(iret==0) THEN
            IAR15U(:,:,k4)=reshape(tmp,(/imax,jmax/))
            call gblevn11d(imax,jmax,IAR15U(1,1,K4))
         ENDIF
      ENDDO
!     do k=1,kmax
!        print *,'in getnemsio,i15u,k=',k,maxval(iar15u(:,:,k)),
!    $    minval(iar15u(:,:,k)),iret
!     end do
!     print *,'in getnemsio,IAR15U.1,',maxval(IAR15U),minval(IAR15U)

!v
      DO K4=1,kmax
         if(kindreal==4) then
            CALL NEMSIO_READRECVw34(GFILE,'vgrd','mid layer',K4,tmp,
     $       iret=iret)
         else
            CALL NEMSIO_READRECV(GFILE,'vgrd','mid layer',K4,tmp,
     $       iret=iret)
         endif
         if(iret==0) THEN
            IAR16V(:,:,K4)=reshape(tmp,(/imax,jmax/))
            call gblevn11d(imax,jmax,IAR16V(1,1,K4))
         ENDIF
      ENDDO
!     print *,'in getnemsio,IAR15U.2,',maxval(IAR15U),minval(IAR15U)
!q
      DO K4=1,kmax
         if(kindreal==4) then
            CALL NEMSIO_READRECVw34(GFILE,'spfh','mid layer',K4,tmp,
     $       iret=iret)
         else
            CALL NEMSIO_READRECV(GFILE,'spfh','mid layer',K4,tmp,
     $       iret=iret)
         endif
         if(iret==0) THEN
            IAR17Q(:,:,K4)=max(0.0,reshape(tmp*1.0E6,(/imax,jmax/)) )
            call gblevn11d(imax,jmax,IAR17Q(1,1,K4))
         endif
      ENDDO
!     print *,'in getnemsio,IAR15U.3,',maxval(IAR15U),minval(IAR15U)

!
      deallocate(tmp)
      CALL NEMSIO_CLOSE(GFILE,iret=iret)
!     print *,'end of nemsio'
!

!     print *,'in getnemsio,IAR15U.4,',maxval(IAR15U),minval(IAR15U)

!--compute Tv from temp
      DO K=1,KMAX
         DO J=1,JMAX
            DO i=1,IMAX
               TFAC=ONER+FV*MAX(IAR17Q(I,J,K)*1.0E-6,QMIN)
               IAR14T(I,J,K)=IAR14T(I,J,K)*TFAC
            ENDDO
         ENDDO
      ENDDO

!     print *,'in getnemsio,IAR15U.5,',maxval(IAR15U),minval(IAR15U)

!--COMPUTE PM AND PD
      ALLOCATE (psfc(imax,jmax), tv(imax,jmax,kmax))
      ALLOCATE (WRK1(imax*jmax,KMAX),  WRK2(imax*jmax,KMAX+1))

      imjm4=imax*jmax
      km4=kmax
      psfc(:,:) = iar13p(:,:)*100.
      tv(:,:,:) = iar14t(:,:,:)

      IF(THERMODYN_ID == 3 .AND. IDVC == 3) THEN
         tv(:,:,:) = tv(:,:,:) / CPI(1)
         print *,' cpi(1)=',cpi(1)
      ENDIF

      CALL SIGIO_MODPR(IMJM4,IMJM4,KM4,NVCOORD,IDVC,IDSL,VCOORD,IRET,
     $ psfc,tv,PM=WRK1,PD=WRK2(1,2))
      DO J=1,JMAX
         JJ = (J-1)*IMAX
         DO I=1,IMAX
            WRK2(I+JJ,1) = psfc(i,j)                       ! in Pa
         ENDDO
      ENDDO
      DO L=1,KMAX
         WRK2(:,L+1) = WRK2(:,L) - WRK2(:,L+1)             ! in Pa
      ENDDO

      DO L=1,KMAX
         DO J=1,JMAX
            JJ = (J-1)*IMAX
            DO I=1,IMAX
               IARPSL(I,J,L) = WRK1(I+JJ,L)*0.01    ! 3D layer pres(hPa)
            ENDDO
         ENDDO
      ENDDO
      DO L=1,KMAX+1
         DO J=1,JMAX
            JJ = (J-1)*IMAX
            DO I=1,IMAX
               IARPSI(I,J,L) = WRK2(I+JJ,L)*0.01 ! 3D interface pressure
                                                 !  (hPa)
            ENDDO
         ENDDO
      ENDDO

!     print*,'GBLEVN12 IARPSI,',maxval(IARPSI),minval(IARPSI)
!     print*,'GBLEVN12 IARPSL,',maxval(IARPSL),minval(IARPSL)

      CALL NEMSIO_FINALIZE()
!
      CALL GETLATS(IDRT)

      RETURN

  901 CONTINUE
      PRINT 9901, (JDATE(II),II=1,3),JDATE(5),IDATEP
 9901 FORMAT(/' ##GBLEVENTS/GBLEVN12 - NEMSIO INPUT GLOBAL FILE DATE',
     $ ' (',I4.4,3(I2.2),'), DOES NOT MATCH PREPBUFR FILE CENTER ',
     $ 'DATE (',I10,') -STOP 68'/)
      CALL ERREXIT(68)

      END
! --------------------------------------------------------------------
C> NetCDF Input
C> @param IUNITF   - 2-WORD ARRAY:
C>        For SIGIO input:
C>              - WORD 1 - UNIT NUMBER OF FIRST INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS VALID AT THE DATE IN IDATEP, IF HH IN
C>                IDATEP IS NOT A MULTIPLE OF 3 THEN THIS FILE IS VALID
C>                AT THE CLOSEST TIME PRIOR TO THE DATE IN IDATEP THAT
C>                IS A MULTIPLE OF 3
C>              - WORD 2 - UNIT NUMBER OF SECOND INPUT SIGIO-BASED GLOBAL
C>                (SIGMA OR HYBRID) FILE (EITHER FIRST GUESS OR
C>                ANALYSIS); IF HH IN IDATEP IS A MULTIPLE OF 3 THEN
C>                THIS FILE IS EMPTY, IF HH IN IDATEP IS NOT A MULTIPLE
C>                OF 3 THEN THIS FILE IS VALID AT THE CLOSEST TIME AFTER
C>                THE DATE IN IDATEP THAT IS A MULTIPLE OF 3
C>        For NEMSIO input:
C>              - WORD 1 - UNIT NUMBER OF INPUT NEMSIO-BASED GLOBAL FILE
C>                (EITHER FIRST GUESS OR ANALYSIS); ALWAYS VALID AT AT
C>                THE DATE IN IDATEP
C>              - WORD 2 - NOT USED, SHOULD BE A NULL FILE
C> @param IDATEP   - CENTER DATE FOR PREPBUFR FILE IN THE FORM YYYYMMDDHH     
C> @param IMX
C> @param JMX
C> @param IDRT INTEGER GRID IDENTIFIER
C>                (IDRT=4 FOR GAUSSIAN GRID,
C>                 IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C>                 IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
      SUBROUTINE GBLEVN13(IUNITF,IDATEP,IMX,JMX,IDRT) 
!---------------------------------------------------------
!--INITIALLY DEVELOPED BY HANG LEI BASED ON GBLEVN10 FOR NETCDF INPUT
                                                   
      USE GBLEVN_MODULE
      use sigio_module
      use netcdf

      IMPLICIT NONE
      INTEGER IUNITF(2), IDATEP, IDRT,IMX,JMX
      INTEGER yyyy,mm,dd,hh
      INTEGER*4 ncid
      integer*4  error, id_var, dimid, len
      integer*4  im,jm,km, lm,n, k,nargs
      REAL(KIND=8),PARAMETER:: CON_RV=4.6150E+2,CON_RD=2.8705E+2,
     $          FV=CON_RV/CON_RD-1.,ONER=1.0,QMIN=1.0E-10         
      INTEGER*4, PARAMETER :: TEN=10

      INTEGER*4 IRET,IMJM4,KM4,IDVM,NTRAC

      INTEGER IDATGS_COR,JCAP,JCAP1,JCAP2,JCAP1X2,MDIMA,MDIMB,MDIMC,
     $ IROMB,MAXWV,IDIR,I,J,L,II,JJ

      INTEGER(4) IDATE7(7),JCAP4,IDVC4,DIMZ4,K4,IM4,JM4,KINDREAL,KINDINT
      INTEGER(4) NFHOUR,NFMINUTE,NFSECONDN,NFSECONDD,idsl4,idvm4,kr
      REAL(8) tfac, time
      REAL(4),ALLOCATABLE :: VCOORD4(:,:,:),CPI(:),ak(:),bk(:)
      REAL,ALLOCATABLE :: temp(:,:), temp3d(:,:,:)
!      CHARACTER,ALLOCATABLE :: attone(:)
      character (len = 80) :: attone
      INTEGER nt1, nt2
      character(len=10) :: dim_nam, grid
      CHARACTER*20 gfname

      INTEGER(4) IDATE(8),JDATE(8)
      REAL(4) FHOUR,RINC(5)

      REAL (KIND=4),ALLOCATABLE :: psfc(:,:), tv(:,:,:),
     $                             wrk1(:,:), wrk2(:,:)

      IMAX  = IM
      JMAX  = JM

! no time interpolation needed for netcdf input since files are
!  available every hour - original logic to perform time interpolation
!  is flawed and has been removed in this revision
! --------------------------------------------------------------------

      print 331, mod(idatep,100)
  331 format(/' --> GBLEVENTS: ONLY ONE NETCDF INPUT GLOBAL FILE IS ',
     $ 'READ SINCE FILES ARE AVAILABLE EACH HOUR (NO NEED TO ',
     $ 'INTERPOLATE'/16X,'SPANNING FILES WHEN THE PREPBUFR CENTER HOUR',
     $ ' (',I2.2,') IS NOT A MULTIPLE OF 3)'/)

C  GET VALID-TIME DATE OF NETCDF INPUT FILE, ALSO READ HEADERS
C  -----------------------------------------------------------

      WRITE(gfname,'("fort.",I2.2)') IUNITF(1)

       error=nf90_open(trim(gfname),nf90_nowrite,ncid)
       error=nf90_inq_dimid(ncid,"grid_xt",dimid)
       error=nf90_inquire_dimension(ncid,dimid,dim_nam,im)
       error=nf90_inq_dimid(ncid,"grid_yt",dimid)
       error=nf90_inquire_dimension(ncid,dimid,dim_nam,jm)
       error=nf90_inq_dimid(ncid,"pfull",dimid)
       error=nf90_inquire_dimension(ncid,dimid,dim_nam,km)
       error=nf90_inq_dimid(ncid,"phalf",dimid)
       error=nf90_inquire_dimension(ncid,dimid,dim_nam,lm)
       print*, "im,jm,kmi,lm:",im,jm,km,lm
       print*, "IMX, JMX:", IMX, JMX
       IF (IMX .NE. IM .OR. JMX .NE. JM) print*, "Different Resolutions"
       imax = im
       jmax = jm
       kmax = km

!      error=nf90_inq_varid(ncid, 'pfull', id_var)
!      error=nf90_get_var(ncid, id_var, )      
 

!      CALL W3MOVDAT(RINC,IDATE,JDATE)



C  VALID DATES MUST MATCH
C  ----------------------
      error=nf90_inq_varid(ncid, "time", id_var)
      error=nf90_inquire_attribute(ncid, id_var, "units", len=len)
!      ALLOCATE (attone(len))
      error=nf90_get_att(ncid, id_var, "units", attone)
        read(attone(len-18:len-15),'(i4)') yyyy
        read(attone(len-13:len-12),'(i2)') mm
        read(attone(len-10:len-9),'(i2)') dd
        read(attone(len-7:len-6),'(i2)') hh
      IF(attone(1:5) .NE. "hours") THEN
      print*, "checkout the time unit, not hourly",attone
      ELSE
      print*, "base time", yyyy,mm,dd,hh
      ENDIF
!      DEALLOCATE (attone)
       error=nf90_get_var(ncid, id_var, time)
      fhour=time

      idate = 0
      idate(1)=yyyy
      idate(2)=mm
      idate(3)=dd
      idate(5)=hh

      rinc=0.0
      rinc(2)=fhour

      CALL W3MOVDAT(RINC,IDATE,JDATE)

      PRINT 1, FHOUR,(IDATE(II),II=1,3),IDATE(5),(JDATE(II),II=1,3),
     $ JDATE(5)
 1     FORMAT(' --> GBLEVENTS: GLOBAL NEMSIO FILE: HERE IS A ',F5.1,
     $ ' HOUR FORECAST FROM ',I5.4,3I3.2,' VALID AT ',I5.4,3I3.2)

      IDATGS_COR = (JDATE(1) * 1000000) + (JDATE(2) * 10000) +
     $ (JDATE(3) * 100) + JDATE(5)

C  VALID DATES MUST MATCH
C  ----------------------

      IF(IDATEP.NE.IDATGS_COR)  GO TO 901

C------------------------------------------

      ALLOCATE (iar12z(im,jm), iar13p(im,jm))
      ALLOCATE (iar14t(im,jm,km),  iar15u(im,jm,km),
     $          iar16v(im,jm,km),  iar17q(im,jm,km),
     $          iarpsl(im,jm,km),  iarpsi(im,jm,km+1),
     $          iarpsd(im,jm,km))

      error=nf90_get_att(ncid, NF90_GLOBAL, "grid", grid)
      IF (grid == "gaussian")THEN
        IDRT=4
      ENDIF

      NVCOORD=2     !for idvc=2, nvcoord=2: hybrid interface a and b
      IDVC=2        !(1 for sigma and 2 for hybrid)
      IDSL=1        !(1 for phillips or 2 for mean)
      idvm=1
      jcap = -9999

      SFCPRESS_ID  = MOD(IDVM,TEN)
      THERMODYN_ID = MOD(IDVM/TEN,TEN)

      IF(IDVC == 3 .AND. THERMODYN_ID == 3) THEN
         KMAXS = (NTRAC+1)*KMAX + 2
      ELSE
         KMAXS = 2*KMAX + 2
         NTRAC = 1
      ENDIF

C  DEFINE THE OTHER RESOLUTION PARAMETERS
C  --------------------------------------

      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX

      PRINT 2, JCAP,IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,idvc

 2     FORMAT(/' --> GBLEVENTS: GLOBAL MODEL SPECS: T',I5,' ',
     $ I5,' x ',I5,' GRID WITH ',I3,' LEVELS ',I3,
     $' SCALARS -------> ',F5.2,' X ',F5.2,' VERT. ',
     $ 'COORD ID IS: ',I0)

      print *,'in netcdf sfcpress_id=',sfcpress_id,' thermodyn_id=',
     $ thermodyn_id,' ntrac=',ntrac
      print *,' idvc=',idvc,' idsl=',idsl,' idvm=',idvm,' nvcoord=',
     $ nvcoord

      ALLOCATE(VCOORD(km+1,3))
      VCOORD=0.0
      allocate(ak(km+1))
      allocate(bk(km+1))

      error=nf90_get_att(ncid, NF90_GLOBAL, "ak", ak)
      error=nf90_get_att(ncid, NF90_GLOBAL, "bk", bk)

      do k=1,km+1
         kr=km+2-k
         vcoord(k,1) = ak(kr)
         vcoord(k,2) = bk(kr)
      end do
      
      deallocate(ak,bk)

      allocate(temp(im,jm))
      error=nf90_inq_varid(ncid, 'hgtsfc', id_var)
      error=nf90_get_var(ncid, id_var, temp)
      
      IAR12Z(:,:)=temp(:,:)
      call gblevn11d(imax,jmax,IAR12Z)
      

      error=nf90_inq_varid(ncid, 'pressfc', id_var)
      error=nf90_get_var(ncid, id_var, temp)

      IAR13P(:,:)=temp(:,:)*0.01
      call gblevn11d(imax,jmax,IAR13P)

      deallocate(temp)

!!      write(6,111)'hgtsfc', 1,minval(iar12z),maxval(iar12z)
!!      write(6,111)'pressfc',1,minval(iar13p),maxval(iar13p)
!! 111  format(a8,1x,i3,1x,2(g13.6,1x))


      allocate(temp3d(im,jm,km))
      error=nf90_inq_varid(ncid, 'tmp', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         IAR14T(:,:,K4)=temp3d(:,:,kr)
         call gblevn11d(imax,jmax,IAR14T(1,1,K4))
!!         write(6,111)'tmp',k4,minval(iar14t(:,:,k4)),
!!     &        maxval(iar14t(:,:,k4))
      ENDDO

      error=nf90_inq_varid(ncid, 'ugrd', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         IAR15U(:,:,k4)=temp3d(:,:,kr)
         call gblevn11d(imax,jmax,IAR15U(1,1,K4))
!!         write(6,111)'ugrd',k4,minval(iar15u(:,:,k4)),
!!     &        maxval(iar15u(:,:,k4))
      ENDDO

      error=nf90_inq_varid(ncid, 'vgrd', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         IAR16V(:,:,k4)=temp3d(:,:,kr)
         call gblevn11d(imax,jmax,IAR16V(1,1,K4))
!!         write(6,111)'vgrd',k4,minval(iar16v(:,:,k4)),
!!     &        maxval(iar16v(:,:,k4))
      ENDDO

      error=nf90_inq_varid(ncid, 'spfh', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         IAR17Q(:,:,k4)=max(0.0,temp3d(:,:,kr)*1.e6)
         call gblevn11d(imax,jmax,IAR17Q(1,1,K4))
!!         write(6,111)'spfh',k4,minval(iar17q(:,:,k4)),
!!     &        maxval(iar17q(:,:,k4))
      ENDDO

      deallocate(temp3d)
!


!--compute Tv from temp
      DO K=1,km
         DO J=1,jm
            DO i=1,im
               TFAC=ONER+FV*MAX(IAR17Q(I,J,K)*1.0E-6,QMIN)
               IAR14T(I,J,K)=IAR14T(I,J,K)*TFAC
            ENDDO
         ENDDO
      ENDDO

!     print *,'in getnemsio,IAR15U.5,',maxval(IAR15U),minval(IAR15U)



!--COMPUTE PM AND PD
      ALLOCATE (psfc(im,jm), tv(im,jm,km))
      ALLOCATE (WRK1(im*jm,km),  WRK2(im*jm,km+1))

      imjm4=im*jm
      km4=km
      psfc(:,:) = iar13p(:,:)*100.
      tv(:,:,:) = iar14t(:,:,:)

      IF(THERMODYN_ID == 3 .AND. IDVC == 3) THEN
         tv(:,:,:) = tv(:,:,:) / CPI(1)
         print *,' cpi(1)=',cpi(1)
      ENDIF

      CALL SIGIO_MODPR(imjm4,imjm4,km4,NVCOORD,IDVC,IDSL,VCOORD,IRET,
     $ psfc,tv,PM=WRK1,PD=WRK2(1,2))
      DO J=1,jm
         JJ = (J-1)*im
         DO I=1,im
            WRK2(I+JJ,1) = psfc(i,j)                       ! in Pa
         ENDDO
      ENDDO
      DO L=1,km
         WRK2(:,L+1) = WRK2(:,L) - WRK2(:,L+1)             ! in Pa
      ENDDO

      DO L=1,km
         DO J=1,jm
            JJ = (J-1)*im
            DO I=1,im
               IARPSL(I,J,L) = WRK1(I+JJ,L)*0.01    ! 3D layer pres(hPa)
            ENDDO
         ENDDO
      ENDDO
      DO L=1,km+1
         DO J=1,jm
            JJ = (J-1)*im
            DO I=1,im
               IARPSI(I,J,L) = WRK2(I+JJ,L)*0.01 ! 3D interface pressure
                                                 !  (hPa)
            ENDDO
         ENDDO
      ENDDO
      
      error=nf90_close(ncid)        
!     print*,'GBLEVN13 IARPSI,',maxval(IARPSI),minval(IARPSI)
!     print*,'GBLEVN13 IARPSL,',maxval(IARPSL),minval(IARPSL)

!
      CALL GETLATS(IDRT)

      RETURN

  901 CONTINUE
      PRINT 9901, IDATEP,IDATGS_COR
 9901 FORMAT(/' ##GBLEVENTS/GBLEVN13 - NETCDF INPUT GLOBAL FILE DATE',
     $ ' (',I4.4,3(I2.2),'), DOES NOT MATCH PREPBUFR FILE CENTER ',
     $ 'DATE (',I10,') -STOP 68'/)
      CALL ERREXIT(68)

      END

!-----------------------------------------------------------------
!-----------------------------------------------------------------
C> get latitudes
C> @param IDRT INTEGER GRID IDENTIFIER
C>               (IDRT=4 FOR GAUSSIAN GRID,
C>               IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C>               IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
      subroutine getlats(idrt)

      USE GBLEVN_MODULE
      use sp_mod
!      integer :: jmax
!      real,allocatable :: slat(:),wlat(:)
!      real :: rad2deg
      real,allocatable :: slats(:)
      real(4) slat(jmax),wlat(jmax),rad2deg
!get gaussian or regular latitude array based on idrt

!      print *,'in getlats,idrt=',idrt
      call splat(idrt,jmax,slat,wlat)
      rad2deg=180./acos(-1.)
      allocate(slats(jmax));
      rad2deg=180./acos(-1.)
      slats(:)=-asin(slat(:))*rad2deg
      dlat=180./float(jmax-1)

      return
      end

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      subroutine mpicast

      use gblevn_module

      include "mpif.h"

C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
      mcom = mpi_comm_world
      mre4 = mpi_real
      mre8 = mpi_real8
      mint = mpi_integer
      mchr = mpi_character
C-----------------------------------------------------------------------


      do kbak=1,nbak; kbam=kbak-1

      call mpi_barrier(mcom,ierr)

      if(myid==0)print*,'mpicast - background',kbak

!  broadcast background grid parameters 

      if(kbak==1) then
         call mpi_bcast(imax,1,mint,kbam,mcom,ierr)
         call mpi_bcast(jmax,1,mint,kbam,mcom,ierr)
         call mpi_bcast(kmax,1,mint,kbam,mcom,ierr)
         call mpi_bcast(dlat,1,mre4,kbam,mcom,ierr)
         call mpi_bcast(dlon,1,mre4,kbam,mcom,ierr)
         call suterps ! sets up the interpolation latitudes  
         if(myid>=nbak) call allobaks
      endif

!  broadcast background time levels

      ijmax=imax*jmax;ikmax=ijmax*kmax
      call mpi_bcast(iarps(1,1,kbak)  ,ijmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iarzs(1,1,kbak)  ,ijmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iarqq(1,1,1,kbak),ikmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iartt(1,1,1,kbak),ikmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iaruu(1,1,1,kbak),ikmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iarvv(1,1,1,kbak),ikmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iarpl(1,1,1,kbak),ikmax,mre4,kbam,mcom,ierr)
      call mpi_bcast(iarzl(1,1,1,kbak),ikmax,mre4,kbam,mcom,ierr)

      enddo ! broadcast finished

      return
      end
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      subroutine allobaks

      use gblevn_module

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

      if(.not.allocated(iarps)) allocate (iarps(imax,jmax,nbak))
      if(.not.allocated(iarzs)) allocate (iarzs(imax,jmax,nbak))
      if(.not.allocated(iarqq)) allocate (iarqq(imax,jmax,kmax,nbak))
      if(.not.allocated(iartt)) allocate (iartt(imax,jmax,kmax,nbak))
      if(.not.allocated(iaruu)) allocate (iaruu(imax,jmax,kmax,nbak))
      if(.not.allocated(iarvv)) allocate (iarvv(imax,jmax,kmax,nbak))
      if(.not.allocated(iarpl)) allocate (iarpl(imax,jmax,kmax,nbak))
      if(.not.allocated(iarzl)) allocate (iarzl(imax,jmax,kmax,nbak))

      return
      end

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      subroutine sortbufr(lunot)

      character(80) fili
      character(8)  subset

      character(8), ALLOCATABLE :: subs(:)
      integer     , ALLOCATABLE :: indx(:)
      integer     , ALLOCATABLE :: isrt(:)

      data lumpi/60/
      data lumpo/61/

      include "mpif.h"

!--------------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
!--------------------------------------------------------------------------

      if(myid/=0) return

!  concatenate the mpi bufr files back into one

      do n=1,nprc
      write(fili,'("mpi.fort.",i2.2)')n          
      open(lumpi,file=fili,form='unformatted')
      call openbf(lumpi,'IN',lumpi)
      if(n==1) call openbf(lumpo,'OUT',lumpi)
       do while(ireadmg(lumpi,subset,idate)==0)
       call copymg(lumpi,lumpo)         
       enddo
      call closbf(lumpi)
      enddo

!  itemize the message contents by subsets and sort

      call closbf(lumpo)
      call ufbmem(lumpo,0,nret,lumpo)
      allocate(subs(nret),indx(nret),isrt(nret))
      
      do n=1,nret
      call rdmemm(n,subset,idate,iret)
      subs(n)=subset    
      indx(n)=n
      enddo

      call orders(0,isrt,subs,indx,nret,1,8,i2)
      
!  collate the subsets into the output file

      call openbf(lunot,'OUT',lumpo)
      do n=1,nret
      call rdmemm(indx(n),subset,idate,iret)
      call copymg(lumpo,lunot)
      enddo

!  closed and finished

      call closbf(lunot)
      return
      end

c mbuoyb.f
c  process BUFR format moored buoy data for MODSBUFR
c
c modification history
c  19 Oct 2021  production implementation
c---
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE MBUOYB(LUBFR,LUBFO,SUBSET,IDATE,NRPT)
 
c      implicit none

      COMMON /MNEMONIC/ NEMOS(10),NEMS,COMPRESS
 
      CHARACTER*80 NEMOS
      CHARACTER*8  SUBSET
      LOGICAL      COMPRESS,NOTIME
      REAL*8             CLONH,CLATH,ADATE,DATE(5)
      REAL*8       BBYSTSL(3,25),ARR(10,255)
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

C  READ THE TIME PERIOD INFORMATION AND HIGH RES LON/LAT
C  -----------------------------------------------------
 
c      CALL CLONLAT(LUBFR,CLONH,CLATH)
 
C  CHECK IF THERE IS A TIME FRAME HERE AND SETUP FIRST IDATE
C  ---------------------------------------------------------
 

 

C  CREATE TIDE GAUGE REPORTS
C  -------------------------

      ADATE = IDATE
      JDATE = ADATE
c      DATE(1) = JDATE/1000000
c      DATE(2) = MOD(JDATE/10000,100)
c      DATE(3) = MOD(JDATE/100  ,100)
c      DATE(4) = MOD(JDATE      ,100)
c      DATE(5) = (ADATE-JDATE)*60.          

      CALL OPENMB(LUBFO,SUBSET,IDATE)
 
c      CALL UFBINT(LUBFO,CLONH,1,1,IRET,'CLONH')
c      CALL UFBINT(LUBFO,CLATH,1,1,IRET,'CLATH')

      CALL UFBINT(LUBFR,DATE,5,1,IRET,'YEAR MNTH DAYS HOUR MINU')
      CALL UFBINT(LUBFO,DATE,5,1,IRET,'YEAR MNTH DAYS HOUR MINU')
 
      DO N=1,NEMS
         CALL UFBINT(LUBFR,ARR,10,255,NRET,NEMOS(N))
         IF(NRET.GT.0) CALL UFBINT(LUBFO,ARR,10,NRET,IRET,NEMOS(N))
      ENDDO
 
      CALL UFBSEQ(LUBFR,BBYSTSL,3,25,IRET,'BBYSTSL')
      NLVL = 0
      DO I=1,25
         IF (BBYSTSL(1,I) .LT. 9999.) THEN
            NLVL = NLVL + 1
         ENDIF
      ENDDO
      IF (NLVL .EQ. 0) THEN
         DO I=1,3
            BBYSTSL(I,1) = 1.0E+10
         ENDDO
c         NLVL = 1
      ENDIF
      CALL DRFINI(LUBFO,NLVL,1,'{BBYSTSL}')
c      if (NLVL .gt. 1) then
c         NLVL = 1
c      endif
      IRET = NLVL
      CALL UFBSEQ(LUBFO,BBYSTSL,3,NLVL,IRET,'BBYSTSL')
 
 
c Disable compression (due to problem porting to Cirrus; fails on wrcmps)
c  (this should be revisited after update to Cirrus BLib)
ccc   IF(.NOT.COMPRESS) CALL WRITSB(LUBFO)
ccc   IF(     COMPRESS) CALL WRITCP(LUBFO)
      CALL WRITSB(LUBFO)

      NRPT = 1
  
      RETURN
      END

!----------------------------------------------------------------------
!----------------------------------------------------------------------
      SUBROUTINE GBLEVN10netc(IUNITF,IDATEP,IM,JM,kbak) 
                                                   
      USE GBLEVN_MODULE
      use sigio_module
      use netcdf

!     IMPLICIT NONE

      INTEGER IUNITF, IDATEP, IM, JM, kbak
      REAL, PARAMETER :: PI180 = .0174532
      REAL, PARAMETER :: ROG   = 29.261
      REAL, PARAMETER :: tzero = 273.15
      REAL :: ZBLO,TMID,PWGT
      REAL :: p,q,t,virt,esph

      INTEGER*4 IDRTNEMS
      INTEGER*4 IDVC,IDSL,SFCPRESS_ID,THERMODYN_ID
      INTEGER*4 NRET,NRET1,NRETS,IMJM,KM4,IDVM,NTRAC
      INTEGER*4 JCAP,I,J,K,KK,L,IRET,imx,jmx,ii,nvcoord
      INTEGER*4 NFDAY,NFHOUR,NFMINUTE,NFSECONDN,NFSECONDD,IDATGS_COR
      integer nk,nlev

      CHARACTER*6  COORD(3)
      CHARACTER*20 CFILE

      DATA COORD /'SIGMA ','HYBRID','GENHYB'/


      INTEGER yyyy,mm,dd,hh
      INTEGER*4 ncid
      integer*4  error, id_var, dimid, len
      integer*4  km, lm,n, nargs
      REAL(KIND=8),PARAMETER:: CON_RV=4.6150E+2,CON_RD=2.8705E+2,FV=CON_RV/CON_RD-1.,ONER=1.0,QMIN=1.0E-10         
      INTEGER*4, PARAMETER :: TEN=10


      INTEGER(4) JCAP4,IDVC4,DIMZ4,K4,IM4,JM4,KINDREAL,KINDINT
      INTEGER(4) idsl4,idvm4,kr
      REAL(8) tfac, time
      REAL(4),ALLOCATABLE :: VCOORD4(:,:,:),CPI(:),ak(:),bk(:)
      REAL,ALLOCATABLE :: temp(:,:), temp3d(:,:,:)
      REAL, ALLOCATABLE   :: DPRS(:,:)
      character (len = 80) :: attone
      INTEGER nt1, nt2
      character(len=10) :: dim_nam, grid
      CHARACTER*20 gfname

      INTEGER(4) IDATE(8),JDATE(8)
      REAL(4) FHOUR,RINC(5)

!----------------------------------------------------------------------
!--INITIALLY DEVELOPED BY HANG LEI BASED ON GBLEVN10 FOR NETCDF INPUT
!----------------------------------------------------------------------

!  GET VALID-TIME DATE OF NETCDF INPUT FILE, ALSO READ HEADERS
!  -----------------------------------------------------------

       WRITE(gfname,'("fort.",I2.2)') IUNITF
       print*,'opening ',gfname

!  open the file and find the dimension of the arrays

       call check( nf90_open(gfname,NF90_NOWRITE,ncid),"opening PL file")
       call getdim(ncid,"grid_xt",im)
       call getdim(ncid,"grid_yt",jm)
       call getdim(ncid,"pfull  ",km)
       call getdim(ncid,"phalf  ",lm)

       print*
       print*, "im,jm,kmi,lm:",im,jm,km,lm
       imax = im
       jmax = jm
       kmax = km
       lmax = lm

       imjm=im*jm

!  VALID DATES MUST MATCH
!  ----------------------

      call getatt(ncid,"time","units",attone); print*,trim(attone)
      read(attone,'(12x,i4,x,i2,x,i2,x,i2)') yyyy,mm,dd,hh

      IF(attone(1:5) .NE. "hours") THEN
         print*, "checkout the time unit, not hourly",attone
      ELSE
         print*, "base time", yyyy,mm,dd,hh
         print*
      ENDIF

      error=nf90_inq_varid(ncid,"time", id_var)
      error=nf90_get_var(ncid, id_var, time)
      fhour=time

      idate = 0
      idate(1)=yyyy
      idate(2)=mm
      idate(3)=dd
      idate(5)=hh

      rinc=0.0
      rinc(2)=fhour

      CALL W3MOVDAT(RINC,IDATE,JDATE)

      PRINT 1, FHOUR,(IDATE(II),II=1,3),IDATE(5),(JDATE(II),II=1,3),JDATE(5)

 1    FORMAT(' --> GBLEVENTS: GLOBAL NEMSIO FILE: HERE IS A ',F5.1,' HOUR FORECAST FROM ',I5.4,3I3.2,' VALID AT ',I5.4,3I3.2)

      IDATGS_COR = (JDATE(1) * 1000000) + (JDATE(2) * 10000) + (JDATE(3) * 100) + JDATE(5)
      print*,IDATGS_COR,idatep

      error=nf90_get_att(ncid, NF90_GLOBAL, "grid", grid)
      IF (grid == "gaussian")THEN
        IDRTnems=4
      ENDIF

      NVCOORD=2     !for idvc=2, nvcoord=2: hybrid interface a and b
      IDVC=2        !(1 for sigma and 2 for hybrid)
      IDSL=1        !(1 for phillips or 2 for mean)
      idvm=1
      jcap = -9999

      SFCPRESS_ID  = MOD(IDVM,TEN)
      THERMODYN_ID = MOD(IDVM/TEN,TEN)

      IF(IDVC == 3 .AND. THERMODYN_ID == 3) THEN
         KMAXS = (NTRAC+1)*KMAX + 2
      ELSE
         KMAXS = 2*KMAX + 2
         NTRAC = 1
      ENDIF

!  DEFINE THE OTHER RESOLUTION PARAMETERS
!  --------------------------------------

      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX

      PRINT 2, JCAP,IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,idvc
 2    FORMAT(/' --> GBLEVENTS: GLOBAL MODEL SPECS: T',I5,' ',I5,' x ',I5,' GRID WITH ',I3,' LEVELS ',I3,' SCALARS -------> ',F5.2,' X ',F5.2,&
             //' VERT. ', $ 'COORD ID IS: ',I0)

      print *,'sfcpress_id=',sfcpress_id,' thermodyn_id=',thermodyn_id,' ntrac=',ntrac
      print *
      print *,' idvc=',idvc,' idsl=',idsl,' idvm=',idvm,' nvcoord=',nvcoord
      print *

!  read the hybrid level definition coefficients ak and bk
!  -------------------------------------------------------

      allocate(ak(km+1))
      allocate(bk(km+1))

      error=nf90_get_att(ncid, NF90_GLOBAL, "ak", ak)
      error=nf90_get_att(ncid, NF90_GLOBAL, "bk", bk)

      ak(:)=ak(:)*.001

      if(kbak==1) call prttime('read dims & atts')

!***********************************************************************
!**********  read netcdf file
!***********************************************************************

      CALL ALLOBAKs ! aloocates the nbak background arrays

      allocate (dprs(imjm,kmax))
      allocate (temp(im,jm))

      error=nf90_inq_varid(ncid, 'hgtsfc', id_var)
      error=nf90_get_var(ncid, id_var, temp)
      call gblevn11(imax,jmax,temp)
      iarzs(:,:,kbak)=temp(:,:)
      write(6,111)'hgtsfc', 1,minval(temp),maxval(temp)
      

      error=nf90_inq_varid(ncid, 'pressfc', id_var)
      error=nf90_get_var(ncid, id_var, temp)
      call gblevn11(imax,jmax,temp)
      iarps(:,:,kbak)=temp(:,:)*0.01
      write(6,111)'pressfc',1,minval(temp),maxval(temp)

      if(kbak==1) call prttime('read surface')

      deallocate(temp)

      allocate(temp3d(im,jm,km))
      error=nf90_inq_varid(ncid, 'tmp', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
         DO K4=1,km
         kr=km+1-k4
         call gblevn11(imax,jmax,temp3d(:,:,kr))          
         iartt(:,:,K4,kbak)=temp3d(:,:,kr)
         !write(6,111)'tmp',k4,minval(iartt(:,:,k4,kbak)),maxval(iartt(:,:,k4,kbak))
      ENDDO

      error=nf90_inq_varid(ncid, 'ugrd', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         call gblevn11(imax,jmax,temp3d(:,:,kr))
         iaruu(:,:,k4,kbak)=temp3d(:,:,kr)
         !write(6,111)'ugrd',k4,minval(iaruu(:,:,k4,kbak)),maxval(iaruu(:,:,k4,kbak))
      ENDDO

      error=nf90_inq_varid(ncid, 'vgrd', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         call gblevn11(imax,jmax,temp3d(:,:,kr))
         iarvv(:,:,k4,kbak)=temp3d(:,:,kr)
         !write(6,111)'vgrd',k4,minval(iarvv(:,:,k4,kbak)),maxval(iarvv(:,:,k4,kbak))
      ENDDO

      error=nf90_inq_varid(ncid, 'spfh', id_var)
      error=nf90_get_var(ncid, id_var, temp3d)
      DO K4=1,km
         kr=km+1-k4
         call gblevn11(imax,jmax,temp3d(:,:,kr))
         iarqq(:,:,k4,kbak)=max(0.0,temp3d(:,:,kr)*1.e6)
         !write(6,111)'spfh',k4,minval(iarqq(:,:,k4,kbak)),maxval(iarqq(:,:,k4,kbak))
      ENDDO

 111  format(a8,1x,i3,1x,2(g13.6,1x))

      deallocate(temp3d)

      if(kbak==1) call prttime('read upper air')

!***********************************************************************
!**********  make temperatures virtual
!***********************************************************************
!     1) ESVP(T     ) - SATURATION WATER VAPOR PRESSURE FROM T
!     2) ERLH(P,R,T ) - WATER VAPOR PRESSURE FROM P,R,T
!     3) EMIX(P,W   ) - WATER VAPOR PRESSURE FROM P,W
!     4) ESPH(P,Q   ) - WATER VAPOR PRESSURE FROM P,Q
!     5) EDEW(DP    ) - WATER VAPOR PRESSURE FROM DP
!     6) RELH(P,E,T ) - RELATIVE HUMIDITY FROM P,E,T
!     7) WMIX(P,E   ) - MIXING RATIO FROM P,E
!     8) QSPH(P,E   ) - SPECIFIC HUMIDITY FROM P,E
!     9) DPAL(E     ) - DEW POINT FROM E   (ALGEBRAIC)
!    10) VIRT(P,E,TS) - VIRTUAL  TEMPERATURE FROM P,E,TS
!    11) SENT(P,E,TV) - SENSIBLE TEMPERATURE FROM P,E,TV
!***********************************************************************

!***********************************************************************
!**********  compute mid layer pressures and heights
!***********************************************************************

! use gsm routine to derive mid layer pressures

      call hyb2pres(imjm,kmax,ak,bk,iarps(1,1,kbak),iarpl(1,1,1,kbak),dprs)
      if(kbak==1) call prttime('hyb2pres')

! compute and store height profiles the gsi way

      do k=1,kmax
      do j=1,jmax
      do i=1,imax

      ! make temps virtual
      p=iarpl(i,j,k,kbak)
      q=iarqq(i,j,k,kbak)*1.e-6
      t=iartt(i,j,k,kbak)-tzero
      iartt(i,j,k,kbak)=virt(p,esph(p,q),t)+tzero

      ! create height profiles
      if(k==1) then
         pwgt=log(iarpl(i,j,k,kbak)/iarps(i,j,kbak))
         tmid=iartt(i,j,k,kbak) ! this is not quite right, but copied from gsi
         zblo=iarzs(i,j,kbak)
         iarzl(i,j,k,kbak)=zblo-rog*tmid*pwgt
         iarzl(i,j,k,kbak)=iarzl(i,j,k,kbak)-iarzs(i,j,kbak) ! convert to height above the surface
      else
         pwgt=log(iarpl(i,j,k,kbak)/iarpl(i,j,k-1,kbak))
         tmid=.5*(iartt(i,j,k-1,kbak)+iartt(i,j,k,kbak))
         zblo=iarzl(i,j,k-1,kbak)
         iarzl(i,j,k,kbak)=zblo-rog*tmid*pwgt
      endif

!!test
      if ((kbak==1) .and. (i==imax/2) .and. (j==jmax/2)) then
         if (k==1) then
            write(6,122) kbak,i,j,iarzs(i,j,kbak)
 122        format('kbak,i,j=',3(i6,1x),' zsfc=',g13.6)
         endif
         write(6,123) k,p,iarzl(i,j,k,kbak),t,q
 123     format('k= ',i3,' p,z,t,q= ',4(g14.6,1x))
      endif
!!test

      enddo
      enddo
      enddo

      if(kbak==1) call prttime('zprofiles,etc')

      !print*
      !print*,iarpl(1,1,:,1)
      !print*
      !print*,iarzl(1,1,:,1)
      !print*
      !call bort('end of test')


!***********************************************************************
!**********  normal exit
!***********************************************************************

      ! don't forget to deallocate !

      deallocate (ak,bk,dprs)

      RETURN
      END
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine getdim(ncid,dimname,dim)

      use netcdf

      character(*)  dimname
      integer       dim,dimid

      call check( nf90_inq_dimid(ncid,dimname,dimid)          ,"getting "//dimname//" dimid") 
      call check( nf90_inquire_dimension(ncid,dimid,len = dim),"getting "//dimname//" dim")

      end subroutine getdim
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine getatt(ncid,varname,attname,attout)

      use netcdf

      character(*)    varname,attname,attout
      !!character(80) varname
      integer         idvarR,len

      call check( nf90_inq_varid(ncid, varname, idvar)                    ,"getting "//varname//" idvar")
      call check( nf90_inquire_attribute(ncid, idvar, attname, len=len)   ,"getting "//attname//" dim")
      call check( nf90_get_att(ncid, idvar, attname, attout)              ,"getting "//attout//" dim")

      !error=nf90_inq_varid(ncid, "time", id_var)
      !error=nf90_inquire_attribute(ncid, id_var, "units", len=len)
      !error=nf90_get_att(ncid, id_var, "units", attone)


      end subroutine getatt
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine check(status, loc)

         use netcdf

         integer, intent(in) :: status
         character(len=*), intent(in) :: loc

         if(status /= NF90_NOERR) then
            write (*,*) "Error at ", loc
            write (*,*) NF90_STRERROR(status)
         end if

      end subroutine check
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------

      program tave
c
c     ABSTRACT: This program averages the temperatures from an input 
c     grib file and produces an output grib file containing the mean
c     temperature in the 300-500 mb layer.  For each model and each
c     lead time, there will need to be data from 300 to 500 mb in 
c     50 mb increments, such that all 5 of these layers then get
c     averaged together.
c
c     Written by Tim Marchok

      implicit none

      integer, parameter :: lugb=11,lulv=16,lugi=31,lout=51
      integer, parameter :: nlevsout=1,nlevsin=5
      integer  kpds(200),kgds(200)
      integer  iriret,iogret,kf,iggret,igdret,iidret
      integer  iha,iho,iva,irfa,iodret,ifcsthour,iia,iparm
      integer  ilevs(nlevsin)
      real, allocatable :: xinptmp(:,:),xouttmp(:)
      logical(1), allocatable :: valid_pt(:),readflag(:)
      real     xoutlev

      namelist/timein/ifcsthour,iparm
c
      data ilevs   /300, 350, 400, 450, 500/
      xoutlev = 401.
c
      read (5,NML=timein,END=201)
  201 continue
      print *,' '
      print *,'*---------------------------------------------*'
      print *,' '
      print *,' +++ Top of tave +++ '
      print *,' '
      print *,'After tave namelist read, input forecast hour= '
     &       ,ifcsthour
      print *,'                          input GRIB parm= ',iparm

c      ilevs = -999
c      call read_input_levels (lulv,nlevsin,ilevs,iriret)
c
c      if (iriret /= 0) then
c        print *,' '
c        print *,'!!! RETURN CODE FROM read_input_levels /= 0'
c        print *,'!!! RETURN CODE = iriret = ',iriret
c        print *,'!!! EXITING....'
c        print *,' '
c        goto 899
c      endif

      call open_grib_files (lugb,lugi,lout,iogret)

      if (iogret /= 0) then
        print '(/,a45,i4,/)','!!! ERROR: in tave open_grib_files, rc= '
     &        ,iogret
        STOP 93
      endif

      call getgridinfo (lugb,lugi,kf,kpds,kgds,ifcsthour,iparm,iggret)

      allocate (xinptmp(kf,nlevsin),stat=iha)
      allocate (xouttmp(kf),stat=iho)
      allocate (valid_pt(kf),stat=iva)
      allocate (readflag(nlevsin),stat=irfa)
      if (iha /= 0 .or. iho /= 0 .or. iva /= 0 .or. irfa /= 0) then
        print *,' '
        print *,'!!! ERROR in tave allocating arrays.'
        print *,'!!! ERROR allocating the xinptmp, readflag, or the'
        print *,'!!! valid_pt array, iha= ',iha,' iva= ',iva
        print *,'!!! irfa= ',irfa,' iho= ',iho
        print *,'  '
        STOP 96
      endif

      call getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs
     &             ,readflag,xinptmp,ifcsthour,iparm,igdret)

      call average_data (kf,valid_pt,nlevsin,ilevs,readflag
     &                  ,xinptmp,xouttmp,iidret)

      call output_data (lout,kf,kpds,kgds,xouttmp,valid_pt
     &                ,xoutlev,nlevsout,iodret)

      deallocate (xinptmp)
      deallocate (xouttmp)
      deallocate (valid_pt)
      deallocate (readflag)

  899 continue
c 
      stop
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_input_levels (lulv,nlevsin,ilevs,iriret)
c 
c     ABSTRACT: This subroutine reads in a text file that contains
c     the number of input pressure levels for a given model.  The
c     format of the file goes like this, from upper levels to 
c     lower, for example:
c
c        1       200
c        2       400
c        3       500
c        4       700
c        5       850
c        6       925
c        7      1000
c
c
      implicit none

      integer    lulv,nlevsin,iriret,inplev,ict,lvix
      integer    ilevs(nlevsin)
c
      ict = 0
      do while (.true.)
        
        print *,'Top of while loop in tave read_input_levels'

        read (lulv,85,end=130) lvix,inplev

        if (inplev > 0 .and. inplev <= 1000) then
          ict = ict + 1
          ilevs(ict) = inplev
        else
          print *,' '
          print *,'!!! ERROR: Input level not between 0 and 1000'
          print *,'!!!        in tave.  inplev= ',inplev
          print *,'!!! STOPPING EXECUTION'
          STOP 91
        endif

        print *,'tave readloop, ict= ',ict,' inplev= ',inplev

      enddo

   85 format (i4,1x,i4)
  130 continue

      nlevsin = ict

      print *,' '
      print *,'Total number of tave levels read in = ',nlevsin
c 
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getgridinfo (lugb,lugi,kf,kpds,kgds,ifcsthour,iparm
     &                       ,iggret)
c
c     ABSTRACT: The purpose of this subroutine is just to get the max
c     values of i and j and the dx and dy grid spacing intervals for the
c     grid to be used in the rest of the program.  So just read the
c     grib file to get the lon and lat data.  Also, get the info for
c     the data grid's boundaries.  This boundary information will be
c     used later in the tracking algorithm, and is accessed via Module
c     grid_bounds.
c
      implicit none
c
      logical(1), allocatable :: lb(:)
      integer, parameter :: jf=4000000
      integer   jpds(200),jgds(200)
      integer   kpds(200),kgds(200)
      integer   ila,ifa,iret,ifcsthour,imax,jmax
      integer   lugb,lugi,kf,j,k,iggret,iparm
      real, allocatable :: f(:)
      real      dx,dy
c
      iggret = 0

      allocate (lb(jf),stat=ila) 
      allocate (f(jf),stat=ifa)
      if (ila /= 0 .or. ifa /= 0) then
        print *,' '
        print *,'!!! ERROR in tave.'
        print *,'!!! ERROR in getgridinfo allocating either lb or f'
        print *,'!!! ila = ',ila,' ifa= ',ifa
        iggret = 97
        return
      endif

      jpds = -1
      jgds = -1

      j=0

      jpds(5)  = iparm  ! Get a temperature record
      jpds(6)  = 100    ! Get a record on a standard pressure level
      jpds(14) = ifcsthour
         
      call getgb(lugb,lugi,jf,j,jpds,jgds,
     &                     kf,k,kpds,kgds,lb,f,iret)

      if (iret.ne.0) then
        print *,' '
        print *,'!!! ERROR in tave getgridinfo calling getgb'
        print *,'!!! Return code from getgb = iret = ',iret
        iggret = iret
        return
      else
        iggret=0
        imax = kgds(2)
        jmax = kgds(3)
        dx   = float(kgds(9))/1000.
        dy   = float(kgds(10))/1000.
      endif

      print *,' '
      print *,'In getgridinfo, grid dimensions follow:'
      print *,'imax= ',imax,' jmax= ',jmax
      print *,'  dx= ',dx,'  dy= ',dy
      print *,'number of gridpoints = ',kf
      
      deallocate (lb); deallocate(f)
      
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs
     &             ,readflag,xinptmp,ifcsthour,iparm,igdret)
c
c     ABSTRACT: This subroutine reads the input GRIB file for the
c     tracked parameters.

      implicit none
c
      logical(1)  valid_pt(kf),lb(kf),readflag(nlevsin)
      integer, parameter :: jf=4000000
      integer   ilevs(nlevsin)
      integer   jpds(200),jgds(200),kpds(200),kgds(200)
      integer   lugb,lugi,kf,nlevsin,igdret,iparm
      integer   i,j,k,ict,np,lev,ifcsthour,iret
      real      f(kf),xinptmp(kf,nlevsin)
      real      dmin,dmax
c
      ict = 0

      level_loop: do lev = 1,nlevsin

        print *,' '
        print *,'In tave getdata read loop, lev= ',lev,' level= '
     &         ,ilevs(lev)

        jpds = -1
        jgds = -1
        j=0

        jpds(5) = iparm       ! parameter id for temperature
        jpds(6) = 100         ! level id to indicate a pressure level
        jpds(7) = ilevs(lev)  ! actual level of the layer
        jpds(14) = ifcsthour  ! lead time to search for

        call getgb (lugb,lugi,jf,j,jpds,jgds,
     &                        kf,k,kpds,kgds,lb,f,iret)

        print *,' '
        print *,'After tave getgb call, j= ',j,' k= ',k,' level= '
     &         ,ilevs(lev),' iret= ',iret

        if (iret == 0) then

          readflag(lev) = .TRUE.
          call bitmapchk(kf,lb,f,dmin,dmax)

          if (ict == 0) then
            do np = 1,kf
              valid_pt(np) = lb(np)
            enddo
            ict = ict + 1
          endif

          write (6,31)
  31      format (' rec#  parm# levt lev  byy   bmm  bdd  bhh  fhr   np'
     &           ,'ts  minval       maxval')
          print '(i4,2x,8i5,i8,2g12.4)',
     &         k,(kpds(i),i=5,11),kpds(14),kf,dmin,dmax

          do np = 1,kf
            xinptmp(np,lev) = f(np) 
          enddo

        else

          print *,' '
          print *,'!!! ERROR: TAVE READ FAILED FOR LEVEL LEV= ',LEV
          print *,' '

          readflag(lev) = .FALSE.

          do np = 1,kf
            xinptmp(np,lev) = -99999.0
          enddo

        endif

      enddo level_loop
c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine average_data (kf,valid_pt,nlevsin,ilevs,readflag
     &                 ,xinptmp,xouttmp,iidret)
c
c     ABSTRACT: This routine averages data between 300 and 500 mb to get
c     a mean temperature at 400 mb.  The input data should be at 50 mb 
c     resolution, giving 5 input levels in total.

      implicit none

      logical(1)   valid_pt(kf),readflag(nlevsin)
      integer      ilevs(nlevsin)
      integer      nlevsin,kf,k,n,iidret
      real         xinptmp(kf,nlevsin),xouttmp(kf)
      real         xinlevs_p(nlevsin),xinlevs_lnp(nlevsin)
      real         xsum
c
      print *,'*----------------------------------------------*'
      print *,'         Top of average data routine'
      print *,'*----------------------------------------------*'
      print *,' '

      do n = 1,kf
        xsum = 0.0
        do k = 1,nlevsin
          xsum = xsum + xinptmp(n,k)
        enddo
        xouttmp(n) = xsum / float(nlevsin)
      enddo
c
      return
      end
c
c----------------------------------------------------------------------
c
c----------------------------------------------------------------------
      subroutine output_data (lout,kf,kpds,kgds,xouttmp,valid_pt
     &                      ,xoutlev,nlevsout,iodret)
c
c     ABSTRACT: This routine writes out the  output data on the 
c     specified output pressure levels.

      implicit none

      logical(1) valid_pt(kf)
      integer  lout,kf,lugb,lugi,iodret,nlevsout,igoret,ipret,lev
      integer  kpds(200),kgds(200)
      real     xouttmp(kf),xoutlev
c
c      call baopenw (lout,"fort.51",igoret)
c      print *,'baopenw: igoret= ',igoret
c
c      if (igoret /= 0) then
c        print *,' '
c        print *,'!!! ERROR in sub output_data opening'
c        print *,'!!! **OUTPUT** grib file.  baopenw return codes:'
c        print *,'!!! grib file 1 return code = igoret = ',igoret
c        STOP 95
c        return
c      endif

c      kpds(7)  =     850  ;    kpds(8)  =      02
c      kpds(9)  =      11  ;    kpds(10) =       4
c      kpds(11) =       0  ;    kpds(12) =       0
c      kpds(13) =       1  ;    kpds(14) =  ifcsthour
c      kpds(15) =       0  ;    kpds(16) =      10
c      kpds(17) =       0  ;    kpds(18) =       1
c      kpds(19) =       2  ;    kpds(20) =       0
c      kpds(21) =      21  ;    kpds(22) =       0
c      kpds(23) =       0  ;    kpds(24) =       0
c      kpds(25) =       0
c      kgds(1)  =       0  ;    kgds(2)  =    imax
c      kgds(3)  =    jmax  ;    kgds(4)  =   90000
c      kgds(5)  =       0  ;    kgds(6)  =     128
c      kgds(7)  =  -90000  ;    kgds(8)  =   -1000
c      kgds(9)  =    1000  ;    kgds(10) =    1000
c      kgds(11) =       0  ;    kgds(12) =       0
c      kgds(13) =       0  ;    kgds(14) =       0
c      kgds(15) =       0  ;    kgds(16) =       0
c      kgds(17) =       0  ;    kgds(18) =       0
c      kgds(19) =       0  ;    kgds(20) =     255

      kpds(6) = 100

      do lev = 1,nlevsout 

        kpds(7) = int(xoutlev)

        print *,'tave:  just before call to putgb, kf= ',kf
        call putgb (lout,kf,kpds,kgds,valid_pt,xouttmp,ipret)
        print *,'tave:  just after call to putgb, kf= ',kf
        if (ipret == 0) then
          print *,' '
          print *,'+++ IPRET = 0 after call to putgb'
          print *,' '
        else
          print *,' '
          print *,'!!!!!! ERROR in tave'
          print *,'!!!!!! ERROR: IPRET NE 0 AFTER CALL TO PUTGB !!!'
          print *,'!!!!!!        Level index= ',lev
          print *,'!!!!!!           pressure= ',xoutlev
          print *,' '
        endif

        write(*,980) kpds(1),kpds(2)
        write(*,981) kpds(3),kpds(4)
        write(*,982) kpds(5),kpds(6)
        write(*,983) kpds(7),kpds(8)
        write(*,984) kpds(9),kpds(10)
        write(*,985) kpds(11),kpds(12)
        write(*,986) kpds(13),kpds(14)
        write(*,987) kpds(15),kpds(16)
        write(*,988) kpds(17),kpds(18)
        write(*,989) kpds(19),kpds(20)
        write(*,990) kpds(21),kpds(22)
        write(*,991) kpds(23),kpds(24)
        write(*,992) kpds(25)
        write(*,880) kgds(1),kgds(2)
        write(*,881) kgds(3),kgds(4)
        write(*,882) kgds(5),kgds(6)
        write(*,883) kgds(7),kgds(8)
        write(*,884) kgds(9),kgds(10)
        write(*,885) kgds(11),kgds(12)
        write(*,886) kgds(13),kgds(14)
        write(*,887) kgds(15),kgds(16)
        write(*,888) kgds(17),kgds(18)
        write(*,889) kgds(19),kgds(20)
        write(*,890) kgds(21),kgds(22)

      enddo

  980 format('    kpds(1)  = ',i7,'  kpds(2)  = ',i7)
  981 format('    kpds(3)  = ',i7,'  kpds(4)  = ',i7)
  982 format('    kpds(5)  = ',i7,'  kpds(6)  = ',i7)
  983 format('    kpds(7)  = ',i7,'  kpds(8)  = ',i7)
  984 format('    kpds(9)  = ',i7,'  kpds(10) = ',i7)
  985 format('    kpds(11) = ',i7,'  kpds(12) = ',i7)
  986 format('    kpds(13) = ',i7,'  kpds(14) = ',i7)
  987 format('    kpds(15) = ',i7,'  kpds(16) = ',i7)
  988 format('    kpds(17) = ',i7,'  kpds(18) = ',i7)
  989 format('    kpds(19) = ',i7,'  kpds(20) = ',i7)
  990 format('    kpds(21) = ',i7,'  kpds(22) = ',i7)
  991 format('    kpds(23) = ',i7,'  kpds(24) = ',i7)
  992 format('    kpds(25) = ',i7)
  880 format('    kgds(1)  = ',i7,'  kgds(2)  = ',i7)
  881 format('    kgds(3)  = ',i7,'  kgds(4)  = ',i7)
  882 format('    kgds(5)  = ',i7,'  kgds(6)  = ',i7)
  883 format('    kgds(7)  = ',i7,'  kgds(8)  = ',i7)
  884 format('    kgds(9)  = ',i7,'  kgds(10) = ',i7)
  885 format('    kgds(11) = ',i7,'  kgds(12) = ',i7)
  886 format('    kgds(13) = ',i7,'  kgds(14) = ',i7)
  887 format('    kgds(15) = ',i7,'  kgds(16) = ',i7)
  888 format('    kgds(17) = ',i7,'  kgds(18) = ',i7)
  889 format('    kgds(19) = ',i7,'  kgds(20) = ',i7)
  890 format('    kgds(20) = ',i7,'  kgds(22) = ',i7)

c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine open_grib_files (lugb,lugi,lout,iret)

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to read from the input GRIB files.  The GRIB and index files
C     are opened with a call to baopenr.  This call to baopenr was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB-reading
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lugb     The Fortran unit number for the GRIB data file
C     lugi     The Fortran unit number for the GRIB index file
C     lout     The Fortran unit number for the  output grib file
C
C     OUTPUT:
C     iret     The return code from this subroutine

      implicit none

      character(2)   lugb_c,lugi_c,lout_c
c      character(120) fnameg,fnamei,fnameo
cPeng 05/28/2018 Bug Fixed for FV3-GFS Job Crashed.
      character(255) fnameg,fnamei,fnameo
      character(6)   enameb,enamei,enameo
      integer   iret,gribver,lugb,lugi,lout,igoret,iioret,iooret

      iret=0
      write(lugb_c,'(i2)')lugb
      write(lugi_c,'(i2)')lugi
      write(lout_c,'(i2)')lout
      enameb='FORT'//adjustl(lugb_c)
      enamei='FORT'//adjustl(lugi_c)
      enameo='FORT'//adjustl(lout_c)
      call get_environment_variable(enameb, fnameg, status=igoret)
      call get_environment_variable(enamei, fnamei, status=iioret)
      call get_environment_variable(enameo, fnameo, status=iooret)
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        fnameg(1:5) = "fort."
        fnamei(1:5) = "fort."
        fnameo(1:5) = "fort."
        write(fnameg(6:7),'(I2)') lugb
        write(fnamei(6:7),'(I2)') lugi
        write(fnameo(6:7),'(I2)') lout
      endif
      call baopenr (lugb,fnameg,igoret)
      call baopenr (lugi,fnamei,iioret)
      call baopenw (lout,fnameo,iooret)

      print *,' '
      print *,'tave baopen: igoret= ',igoret,' iioret= ',iioret
     &       ,' iooret= ',iooret
      
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        print *,' '
        print *,'!!! ERROR in tave'
        print *,'!!! ERROR in sub open_grib_files opening grib file'
        print *,'!!! or grib index file.  baopen return codes:'
        print *,'!!! grib  file return code = igoret = ',igoret
        print *,'!!! index file return code = iioret = ',iioret
        print *,'!!! output file return code = iooret = ',iooret
        iret = 93
        return
      endif

      return
      end
c
c-------------------------------------------------------------------
c
c-------------------------------------------------------------------
      subroutine bitmapchk (n,ld,d,dmin,dmax)
c
c     This subroutine checks the bitmap for non-existent data values.
c     Since the data from the regional models have been interpolated
c     from either a polar stereographic or lambert conformal grid
c     onto a lat/lon grid, there will be some gridpoints around the
c     edges of this lat/lon grid that have no data; these grid
c     points have been bitmapped out by Mark Iredell's interpolater.
c     To provide another means of checking for invalid data points
c     later in the program, set these bitmapped data values to a
c     value of -999.0.  The min and max of this array are also
c     returned if a user wants to check for reasonable values.
c
      logical(1) ld
      dimension  ld(n),d(n)
c
      dmin=1.E15
      dmax=-1.E15
c
      do i=1,n
        if (ld(i)) then
          dmin=min(dmin,d(i))
          dmax=max(dmax,d(i))
        else
          d(i) = -999.0
        endif
      enddo
c
      return
      end

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GBLEVENTS_CDAS  PRE/POST PROCESSING OF PREPBUFR EVENTS 
C   PRGMMR: J. Dong          ORG: EMC        DATE: 2020-01-09
C
C ABSTRACT: THIS IS A FROZEN VERSION OF THE 2006-07-14 VERSION OF W3LIB
C   (LATER W3NCO) ROUTINE GBLEVENTS (OTHER THAN CHANGES TO RENAME
C   GBLEVENTS TO GBLEVENTS_CDAS).  IT IS NEEDED TO READ THE CDAS-STYLE
C   SIGMA FIRST GUESS {THE NEW SIGIO VERSION OF W3LIB (LATER W3NCO)
C   ROUTINE GBLEVENTS CANNOT READ THE OLD CDAS-STYLE SIGMA FIRST
C   GUESS}.  THE REMAINDER OF THIS DOCBLOCK IS JUST A COPY FROM THE
C   2006-07-14 VERSION OF ROUTINE GBLEVENTS.
C           RUNS IN TWO MODES: "PREVENTS" AND "POSTEVENTS".  IN THE
C   PREVENTS MODE, PREPARES OBSERVATIONAL PREPBUFR REPORTS FOR
C   SUBSEQUENT QUALITY CONTROL AND ANALYSIS PROGRAMS.  THIS IS DONE
C   THROUGH THE FOLLOWING: INTERPOLATION OF GLOBAL SPECTRAL SIMGA
C   FIRST GUESS TO PREPBUFR OBSERVATION LOCATIONS WITH ENCODING OF
C   FIRST GUESS VALUES INTO PREPBUFR REPORTS; ENCODING OF "PREVENT"
C   AND/OR "VIRTMP" EVENTS INTO PREPBUFR REPORTS; AND ENCODING OF
C   OBSERVATION ERRORS FROM THE ERROR SPECIFICATION FILE INTO
C   PREPBUFR REPORTS.  IN THE POSTEVENTS MODE, AFTER ALL QUALITY
C   CONTROL AND ANALYSIS PROGRAMS HAVE RUN, INTERPOLATES THE GLOBAL
C   SPECTRAL SIMGA ANALYSIS TO PREPBUFR OBSERVATION LOCATIONS AND
C   ENCODES THESE ANALYZED VALUES INTO PREPBUFR REPORTS.  THE
C   REMAINDER OF THIS ABSTRACT APPLIES ONLY TO THE PREVENTS MODE.
C   THE "PREVENT" EVENT CAN CHANGE A QUALITY MARKER TO FLAG AN
C   OBSERVATION DATUM FOR NON-USE BY SUBSEQUENT QC AND ANALYSIS
C   PROGRAMS (FILTERING).  EXAMPLES WHERE THIS SUBROUTINE WILL WRITE
C   AN EVENT TO FLAG A DATUM INCLUDE: THE OBSERVATION ERROR FOR THAT
C   DATUM IS READ IN AS MISSING IN THE INPUT ERROR FILE, THE DATUM
C   ITSELF VIOLATES A GROSS OR "SANITY" CHECK, OR THE OBSERVED
C   PRESSURE DATUM IS MORE THAN 100 MB BELOW THE GUESS SURFACE
C   PRESSURE.  THE "VIRTMP" EVENT CAN CHANGE THE SPECIFIC HUMIDITY
C   OBSERVATION (RE-CALCULATED) AS WELL AS THE TEMPERATURE
C   OBSERVATION (FROM SENSIBLE TO VIRTUAL TEMPERATURE, BASED ON
C   JUST-CALCULATED SPECIFIC HUMIDITY).  CURRENTLY THIS APPLIES ONLY
C   TO SURFACE (LAND, MARINE AND MESONET) DATA TYPES, POSSIBLY TO
C   RAOB, DROP AND MULTI-LEVEL RECCO DAA TYPES IF THE SWITCH
C   "ADPUPA_VIRT" IS TRUE (NORMALLY, HOWEVER IT IS FALSE) [OTHER DATA
C   TYPES WITH REPORTED SENSIBLE TEMPERATURE EITHER HAVE MISSING
C   MOISTURE (E.G., ALL AIRCRAFT TYPES EXCEPT FOR SOME ACARS, SATELLITE
C   WIND TYPES), FLAGGED MOISTURE (E.G., SOME ACARS) OR CALCULATE
C   SPECIFIC HUMIDITY/VIRTUAL TEMPERATURE IN SUBSEQUENT PROGRAMS (E.G.,
C   RAOBS, DROPS AND MULTI-LEVEL RECCOS WHICH CALCULATE THESE IN
C   PROGRAM "CQCBUFR", IN WHICH CASE THE SWITCH "ADPUPA_VIRT" HERE MUST
C   BE FALSE!)]. FOR CASES WHERE THE SWITCH "DOBERR" IS FALSE, THE
C   OBSERVATION ERROR FOR ALL DATA REMAINS MISSING IN THE PREPBUFR
C   FILE.  IN THIS CASE, THE INPUT ERROR FILE IS USUALLY A NULL FILE
C   AND THE "PREVENT" EVENT TO FLAG THE DATUM IS NOT INVOKED.  FOR
C   CASES WHERE THE SWITCH "DOFCST" IS FALSE, IF THE SWITCH "SOME_FCST"
C   IS ALSO FALSE, THEN FORECAST VALUES ARE NOT ENCODED FOR ANY MESSAGE
C   TYPE; IF "SOME_FCST" IS TRUE THEN FORECAST VALUES ARE ENCODED, BUT
C   ONLY FOR REPORTS IN THOSE MESSAGE TYPES FOR WHICH A GUESS VALUE IS
C   NEEDED BY SUBSEQUENT QC PROGRAMS.  IT SHOULD BE NOTED THAT THE
C   FILTERING OF DATA ASSOCIATED WITH THE "PREVENT" EVENT PROCESSING IS
C   NOT INVOKED IF ALL THREE ARE TRUE: DOBERR= FALSE, THE FORECAST
C   VALUES ARE MISSING (DOFCST=FALSE & SOME_FCST=TRUE & MESSAGE TYPE IS
C   NOT "ADPUPA", "AIRCFT", "AIRCAR", "PROFLR", OR "VADWND" -- OR  --
C   DOFCST=FALSE & SOME_FCST=FALSE), AND "VIRTMP" EVENT PROCESSING IS
C   NOT INVOKED (EITHER MESSAGE TYPE IS NOT "ADPSFC", "SFCSHP" OR
C   "MSONET" WHEN "ADPUPA_VIRT" IS FALSE, OR MESSAGE TYPE IS NOT
C   "ADPSFC", "SFCSHP", "MSONET" OR "ADPUPA" WHEN "ADPUPA_VIRT" IS
C   TRUE).
C
C PROGRAM HISTORY LOG:
C
C AS W3LIB (LATER W3NCO) ROUTINE GBLEVENTS:
C
C 1999-07-01 D. A. KEYSER -- ORIGINAL AUTHOR (ADAPTED FROM PREVENTS
C     SUBROUTINE IN PREPDATA PROGRAM, BUT NOW GENERALIZED FOR
C     POSTEVENTS MODE)
C 1999-07-12 D. A. KEYSER -- MODIFIED TO INTERPOLATE MODEL SPECIFIC
C     HUMIDITY TO OBSERVATION LOCATION WHEN OBS. SPECIFIC HUMIDITY IS
C     MISSING AS LONG AS OBS. TEMPERATURE IS NON-MISSING
C 1999-09-09 D. A. KEYSER -- ADDED "VADWND" TO THE LIST OF MESSAGE
C     TYPES FOR WHICH FORECAST VALUES MUST BE ENCODED, EVEN WHEN
C     DOFCST=FALSE (NECESSARY BECAUSE THE NEW PROGRAM CQCVAD NEEDS THE
C     BACKGROUND DATA)
C 1999-09-09 D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE; 
C     'TFC' NOW GENERATED FOR VADWND MESSAGE TYPES EVEN THOUGH TOB IS
C     MISSING (NEEDED BY CQCVAD PROGRAM)
C 1999-12-01 D. A. KEYSER -- SPEC. HUMIDITY AND VIRT. TEMPERATURE ARE
C     NOW CALCULATED WHEN SPEC. HUMIDITY QUAL. MARKER IS BAD (SUBJECT
C     TO A SANITY CHECK), HOWEVER THE VIRT. TEMPERATURE GETS A BAD
C     QUAL. MARKER (8)
C 2000-09-21 D. A. KEYSER -- THE PRESSURE LEVEL ABOVE WHICH ALL SPEC.
C     HUMIDITY QUAL. MARKERS ARE "REJECTED" (Q.M. SET TO 9) IS NOW READ
C     IN AS A N-LIST SWITCH (QTOP_REJ), BEFORE IT WAS HARDWIRED TO 300
C     MB
C 2000-12-13 D. A. KEYSER -- WILL NO LONGER PERFORM VIRTUAL TEMPERATURE
C     PROCESSING FOR ACARS DATA SINCE MOISTURE IS FLAGGED RIGHT NOW
C     (ACARS MOISTURE ONLY WRITTEN INTO PREPBUFR FILE FOR STATISTICAL
C     REASONS)
C 2001-02-02 D. A. KEYSER -- RESTORED LEGACY LOGIC TO FLAG CERTAIN
C     SATELLITE TEMPERATURE SOUNDINGS EITHER BELOW 100 MB (TEMP. OBS)
C     OR ON ALL LEVELS (SPEC. HUM. OBS), CONTROLLED BY NEW NAMELIST
C     SWITCH "SATMQC"
C 2001-09-27 D. A. KEYSER -- 'TFC' AND 'QFC' NOW GENERATED FOR REPORT
C     TYPE 111 (SYNDAT REPORTS AT STORM CENTER) EVEN THOUGH "TOB" AND
C     "QOB" ARE MISSING (NEEDED BY SYNDATA PROGRAM); IN PREPARATION FOR
C     CHANGE FROM T170L42 TO T254L64 SGES, NOW MAKES COEFFICIENT ARRAYS
C     ALLOCATABLE TO ALLOW THEM TO OBTAIN MEMORY FROM "HEAP" RATHER
C     THAN FROM "STACK", ALSO HAVE INCREASED THE MAX NUMBER OF LEVELS
C     IN ARRAYS FROM 42 TO 64, FINALLY ALSO NO LONGER STOPS WITH C.
C     CODE 70 IF EVEN NUMBER OF LONGITUDES IN SIGMA GUESS (IMAX,
C     HARDWIRED TO 384) IS .LT. SPECTRAL RESOLUTION (JCAP) * 2
C 2001-10-10 D. A. KEYSER -- AT PREPBUFR CENTER DATES WITH AN HOUR THAT
C     IS NOT A MULTIPLE OF 3 (WHEN A GLOBAL SIGMA GUESS/ANAL FILE IS
C     NOT AVAILABLE; E.G., IN RUC2A RUNS) NOW PERFORMS A LINEAR
C     INTERPOLATION BETWEEN SPECTRAL COEFFICIENTS IN 2 SPANNING SIGMA
C     GUESS/ANAL FILES 3-HRS APART TO CENERATE A GUESS/ANAL FILE VALID
C     AT THE PREPBUFR CENTER TIME
C 2002-05-10 D. A. KEYSER -- ADDED "AIRCAR" TO THE LIST OF TABLE A
C     MESSAGE TYPES THAT WILL STILL HAVE THE BACKGROUND ENCODED WHEN
C     DOFCST IS FALSE (BECAUSE ACARS ARE NOW Q.C.'d IN PREPOBS_ACARSQC
C     PROGRAM)
C 2003-09-02 D. A. KEYSER -- ADDED "MSONET" TO THE LIST OF TABLE A
C     MESSAGE TYPES THAT WILL HAVE THE VIRTUAL TEMPERATURE CALCULATED;
C     DOES NOT CALL UFBINT FOR OUTPUTTING DATA IF "NLEV" (4'TH
C     ARGUMENT) IS ZERO (NOW CAN ONLY HAPPEN FOR GOESND FORECAST DATA
C     WHEN ONLY RADIANCES ARE PRESENT)
C 2004-08-30 D. A. KEYSER -- NOW INCLUDES THE 4 LAYER PWATERS, THESE
C     GET AN OBS. ERROR (EACH THE SAME AS TOTAL PWATER) AND AN EVENT
C     IS GENERATED WITH A REJECTED Q.M. FOR THE 4 LAYER PWATERS IF THE
C     PWATER OBS. ERROR READ IN IS MISSING (THIS CHANGE ALLOWS THE ETA/
C     GSI TO PROCESS OBS. ERRORS IN THE PREPBUFR FILE THE SAME AS THE
C     ETA/3DVAR DID WHEN READING THE OBS. ERRORS FROM AN EXTERNAL
C     FILE); FOR "RASSDA" TYPES, ENCODES A SIMPLE COPY OF THE REPORTED
C     (VIRTUAL) TEMPERATURE AS A "VIRTMP" EVENT IF DOVTMP IS TRUE, GETS
C     NEW REASON CODE 3
C 2004-09-10 D. T. KLEIST -- ADDED CAPABILITY TO READ GUESS FIELDS FROM
C     EITHER HYBRID OR, AS BEFORE, SIGMA GLOBAL FORECAST FILES
C 2005-01-03 D. A. KEYSER -- FIXED ERROR READING CDAS SGES FILE WHICH
C     STILL HAS A 207-WORD HEADER (T62) {2004-09-10 CHANGE ASSUMED ALL
C     SGES FILES HAD A 226-WORD HEADER (T254), BUT THIS IS VALID ONLY
C     FOR GFS SGES)
C 2006-05-05 R. E. TREADON -- CHANGE VERTICAL INTERPOLATION TO DIRECTLY
C     USE PRESSURE PROFILE, NOT PRESSURE PROFILE CONVERTED TO SIGMA.  
C     THIS CHANGE IS IN SUBROUTINE CGBLEVN03.  AS A RESULT OF THIS 
C     CHANGE, SUBROUTINE CGBLEVN07 WAS REMOVED.
C 2006-07-14 D. A. KEYSER -- ADDED NEW NAMELIST SWITCH "SOME_FCST"
C     WHICH APPLIES ONLY WHEN EXISTING SWITCH "DOFCST" IS FALSE: IF
C     DOFCST=F AND SOME_FCST=T THEN, JUST AS BEFORE WHEN DOFCST=F, A
C     FORECAST WILL STILL BE ENCODED FOR REPORTS IN CERTAIN MESSAGE
C     TYPES USED IN SUBSEQUENT Q.C. PROGRAMS (I.E, "ADPUPA", "AIRCFT",
C     "AIRCAR", "PROFLR" OR "VADWND") (THE DEFAULT FOR SOME_FCST IS
C     TRUE); HOWEVER IF DOFCST=F AND SOME_FCST=F THEN A FORECAST WILL
C     NOT BE ENCODED INTO REPORTS IN ANY MESSAGE TYPE (THIS ALLOWS
C     THIS PROGRAM TO ENCODE OBS ERRORS AND/OR VIRTUAL TEMPERATURE
C     EVENTS INTO A PREPBUFR FILE WITHOUT ENCODING A FORECAST); ADDED
C     NEW NAMELIST SWITCH "ADPUPA_VIRT" WHICH, WHEN TRUE, INCLUDES
C     REPORTS IN MESSAGE TYPE ADPUPA (I.E., RAOBS, DROPS, MULTI-LEVEL
C     RECCOS) IN THE "VIRTMP" PROCESSING (PROCESSING THEM WITH SAME
C     LOGIC AS IN SUBROUTINE VTPEVN OF PROGRAM PREPOBS_CQCBUFR)
C     {NORMALLY "ADPUPA_VIRT" IS FALSE (DEFAULT) BECAUSE SUBSEQUENT
C     PROGRAM PREPOBS_CQCBUFR PERFORMS THIS FUNCTION}
C 2012-11-20  J. WOOLLEN  INITIAL PORT TO WCOSS 
C
C AS IN-LINE ROUTINE GBLEVENTS_CDAS:
C
C 2007-11-20 D. A. KEYSER -- RENAMED FROZEN 2006-07-14 VERSION OF W3LIB
C     ROUTINE GBLEVENTS TO GBLEVENTS_CDAS AND ADDED AS IN-LINE ROUTINE
C     TO PROGRAM PREPOBS_PREVENTS, IT IS NEEDED TO READ THE CDAS-STYLE
C     SIGMA FIRST GUESS (THE NEW SIGIO VERSION OF W3LIB ROUTINE
C     GBLEVENTS CANNOT READ THE OLD CDAS-STYLE SIGMA FIRST GUESS)
C 2012-11-20  J. WOOLLEN   -- INITIAL PORT TO WCOSS
C 2013-02-13  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS: OBTAINS
C     BUFRLIB MISSING (BMISS) VIA CALL TO GETBMISS RATHER THAN
C     HARDWIRING IT TO 10E10 (10E10 CAN CAUSE INTEGER OVERFLOW ON
C     WCOSS - SEE CALLING PROGRAM FOR MORE INFO); USE FORMATTED PRINT
C     STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS > 80
C     CHARACTERS; RENAME ALL REAL(8) VARIABLES AS *_8
C 2014-01-24 JWhiting - added logic to trap input XOB=360.0 values and
C     reset them to zero; left untrapped, this value leads to out of 
C     bounds referencing of IAR_8 array in the CGBLEVN06() subroutine.
C 2017-07-12 D. Keyser - Initializes REJT as TRUE in "RULES FOR
C     TEMPERATURE" section in subroutine cgblevn02 so it will be set in
C     the rare case where TOB is missing and QOB is not missing (since
C     REJT is referenced in the next "RULES FOR SPECIFIC HUMIDITY"
C     section). BENEFIT: Prevents a code failure due to undefined REJT
C     in this case (when full debugging is turned on).
C 2020-01-06  J. Dong -- In subroutine CGBLEVN10, changed the windowing
C     decade from 20 to 40 for cases when the year is represented by
C     2 digits instead of 4.
C
C USAGE:    CALL GBLEVENTS_CDAS(IDATEP,IUNITF,IUNITE,IUNITP,IUNITS,
C          $                    SUBSET,NEWTYP)
C   INPUT ARGUMENT LIST:
C     IDATEP   - CENTER DATE FOR PREPBUFR FILE IN THE FORM YYYYMMDDHH
C     IUNITF   - 2-WORD ARRAY:
C              - WORD 1 - UNIT NUMBER OF FIRST INPUT SPECTRAL (GLOBAL)
C              - SIGMA FILE (EITHER FIRST GUESS OR ANALYSIS); IF HH IN
C              - IDATEP IS A MULTIPLE OF 3 THEN THIS FILE IS VALID AT
C              - THE DATE IN IDATEP, IF HH IN IDATEP IS NOT A
C              - MULTIPLE OF 3 THEN THIS FILE IS VALID AT THE CLOSEST
C              - TIME PRIOR TO THE DATE IN IDATEP THAT IS A MULTIPLE
C              - OF 3
C              - WORD 2 - UNIT NUMBER OF SECOND INPUT SPECTRAL (GLOBAL)
C              - SIGMA FILE (EITHER FIRST GUESS OR ANALYSIS); IF HH IN
C              - IDATEP IS A MULTIPLE OF 3 THEN THIS FILE IS EMPTY, IF
C              - HH IN IDATEP IS NOT A MULTIPLE OF 3 THEN THIS FILE IS
C              - VALID AT THE CLOSEST TIME AFTER THE DATE IN IDATEP
C              - THAT IS A MULTIPLE OF 3
C     IUNITE   - UNIT NUMBER OF INPUT OBSERVATION ERROR FILE
C              - (USED ONLY IN PREVENTS MODE)
C     IUNITP   - UNIT NUMBER OF OUTPUT PREPBUFR DATA SET
C     IUNITS   - UNIT NUMBER OF "PREVENT" EVENTS DATA FILTERING
C              - SUMMARY PRINT FILE
C              - (USED ONLY IN PREVENTS MODE)
C     SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C              - REPORT BEING PROCESSED
C     NEWTYP   - INDICATOR IF THE BUFR MESSAGE TABLE A ENTRY HAS
C              - CHANGED FROM THAT OF THE PREVIOUS REPORT (=0 - NO,
C              - =1 - YES)
C                
C
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C                DOCUMENTATION BELOW)
C                (NOTE: IF STANDARD INPUT FILE IS NULL, THEN THIS
C                       SUBROUTINE RUNS IN POSTEVENTS MODE)
C     UNIT AA  - PREPBUFR DATA SET
C              - (WHERE AA IS UNIT NUMBER DEFINED AS IUNITP IN
C              - INPUT ARGUMENT LIST)
C     UNIT BB  - SPECTRAL (GLOBAL) SIGMA GUESS (PREVENTS MODE) OR
C              - ANALYSIS (POSTEVENTS MODE) FILE
C              - (WHERE BB IS UNIT NUMBER DEFINED AS IUNITF(1) IN
C              - INPUT ARGUMENT LIST)
C     UNIT CC  - SPECTRAL (GLOBAL) SIGMA GUESS (PREVENTS MODE) OR
C              - ANALYSIS (POSTEVENTS MODE) FILE
C              - (WHERE CC IS UNIT NUMBER DEFINED AS IUNITF(2) IN
C              - INPUT ARGUMENT LIST)
C     UNIT DD  - OBSERVATION ERROR FILE (WHERE DD IS UNIT NUMBER
C              - DEFINED AS IUNITE IN INPUT ARGUMENT LIST)
C              - (USED ONLY IN PREVENTS MODE)
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT AA  - PREPBUFR DATA SET
C              - (WHERE AA IS UNIT NUMBER DEFINED AS IUNITP IN
C              - INPUT ARGUMENT LIST)
C     UNIT DD  - "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C              - (WHERE DD IS UNIT NUMBER DEFINED AS IUNITS IN
C              - INPUT ARGUMENT LIST)
C              - (USED ONLY IN PREVENTS MODE)
C
C   SUBPROGRAMS CALLED:
C     UNIQUE:      CGBLEVN01 CGBLEVN02   CGBLEVN03    CGBLEVN04
C                  CGBLEVN05 CGBLEVN06   OEFG01_C
C                  CGBLEVN08 CGBLEVN09   CGBLEVN10    CGBLEVN11
C                  ZSG01_C   CGBLEVN12   PSG01_C      CGBLEVN13
C                  TG01_C    CGBLEVN14   UG01_C       CGBLEVN15
C                  VG01_C    CGBLEVN16   QG01_C       CGBLEVN17
C     LIBRARY:
C       SPLIB    - SPTEZM   SPTEZMV
C       W3NCO    - W3MOVDAT ERREXIT
C       BUFRLIB  - UFBINT   UFBQCD   GETBMISS
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C     COND =  60 - OBSERVATION ERROR TABLE EMPTY OR DOES NOT EXIST
C     COND =  61 - VARIABLE NLTD .NE. VARIABLE NLEV
C     COND =  62 - VARIABLE NLTQ .NE. VARIABLE NLEV
C     COND =  63 - VARIABLE NLQQ .NE. VARIABLE NLEV
C     COND =  64 - END OF FILE READING SIGMA FIRST GUESS OR ANALYSIS
C                - - UNABLE TO TRANSFORM FIRST GUESS OR ANALYSIS
C     COND =  65 - ERROR READING FIRST GUESS OR ANALYSIS - UNABLE TO
C                - TRANSFORM FIRST GUESS OR ANALYSIS
C     COND =  66 - VARIABLE IDIM NOT FACTORABLE - UNABLE TO TRANSFORM
C                  FIRST GUESS OR ANALYSIS
C     COND =  67 - BAD OR MISSING FIRST GUESS OR ANALYSIS FILE(S)
C     COND =  68 - DATE OF FIRST GUESS/ANALYSIS FILE(S) DOES NOT MATCH,
C                - OR AT LEAST SPAN, THE CENTER DATE FOR THE PREPBUFR
C                - FILE
C     COND =  69 - VARIABLE KMAX TOO BIG - UNABLE TO TRANSFORM FIRST
C                - GUESS OR ANALYSIS FILE(S)
C     COND =  70 - VARIABLE IMAX TOO SMALL - UNABLE TO TRANSFORM FIRST
C                - GUESS OR ANALYSIS FILE(S) (NOTE: Effective 9/27/01
C                - this can never occur)
C     COND =  71 - ONE OR MORE HEADER VALUES DO NOT MATCH WHEN TWO
C                - SIGMA FILES SPANNING THE CENTER DATE FOR THE
C                - PREPBUFR FILE ARE READ
C
C
C REMARKS: THIS ROUTINE PROCESSES ONE REPORT AT A TIME.  IT EXPECTS
C     THAT THE CALLING PROGRAM HAS ALREADY ENCODED THE REPORT INTO
C     THE PREPBUFR FILE VIA THE UFBINT OR UFBCPY ROUTINES.  THE CALLING
C     PROGRAM SHOULD THEN CALL THIS ROUTINE AND, UPON ITS RETURN, THE
C     CALLING PROGRAM SHOULD CALL WRITSB TO ACTUALLY WRITE THE UPDATED
C     SUBSET (REPORT) INTO THE BUFR MESSAGE.
CC
C  ***** VARIABLES IN NAMELIST PREVDATA READ IN BY THIS SUBROUTINE *****
C               (NOTE: IF STANDARD INPUT FILE IS NULL, THEN THIS
C                      SUBROUTINE RUNS IN POSTEVENTS MODE - DOANLS=TRUE
C                      AND ALL OTHER VARIABLES ARE SET TO FALSE)
CC
CC
C    DOVTMP & ADPUPA_VIRT:
C      DOVTMP  - WRITE VIRTUAL TEMPERATURE EVENT FOR THE FOLLOWING
C                TYPES OF REPORTS:
C                ADPUPA_VIRT = .FALSE.  ---> SURFACE LAND, MARINE,
C                                             MESONET AND RASS REPORTS?
C                ADPUPA_VIRT = .TRUE.   ---> SURFACE LAND, MARINE,
C                                             MESONET RASS, RAOB, DROP
C                                             AND MULTI-LEVEL RECCO
C                                             REPORTS?
C              FOR ALL TYPES EXCEPT RASS, THIS WILL ATTEMPT TO
C              CALCULATE VIRTUAL TEMPERATURE FROM SENSIBLE TEMPERATURE
C              AND ENCODE IT AS A STACKED EVENT IN THE PREPBUFR FILE.
C              FOR RASS REPORTS THIS WILL JUST ENCODE THE REPORTED
C              TEMPERATURE AS A STACKED EVENT IN THE PREPBUFR FILE
C              SINCE THE REPORTED TEMPERATURE IS ALREADY VIRTUAL.
C                DOVTMP = .TRUE.  ---> YES                     (DEFAULT)
C                DOVTMP = .FALSE. ---> NO
C      {NOTE1: FOR SURFACE LAND, MARINE AND MESONET REPORTS, (AND
C              RAOB, DROP AND MULTI-LEVEL RECCO REPORTS IF
C              "ADPUPA_VIRT"=TRUE) DOVTMP=FALSE WILL STILL RE-CALCULATE
C              SPECIFIC HUMIDITY AND ENCODE IT AS A STACKED EVENT IN
C              THE PREPBUFR FILE UNLESS DOANLS IS TRUE.)
C      (NOTE2: DOES NOT APPLY TO ANY REPORT TYPES OTHER THAN THOSE
C              MENTIONED ABOVE)
C      (NOTE3: IF DOANLS=TRUE, THEN DOVTMP IS NOT ONLY FORCED TO BE
C              FALSE, BUT ALSO SPECIFIC HUMIDITY IS NOT RE-CALCULATED.)
C      (NOTE4: ADPUPA_VIRT DEFAULTS TO FALSE.)
C
C    DOFCST & SOME_FCST:
C      DOFCST  - ENCODE FORECAST (FIRST GUESS) VALUES, INTERPOLATED
C                FROM THE SPECTRAL SIGMA GUESS FILE, INTO THE PREPBUFR
C                FILE FOR ALL MESSAGE TYPES OR AT LEAST SOME MESSAGE
C                TYPES?
C                DOFCST = .TRUE.  ---> YES, ENCODE FORECST FOR ALL
C                                       MESSAGE TYPES          (DEFAULT)
C                DOFCST = .FALSE.
C                  SOME_FCST = .FALSE. ---> NO, DO NOT ENCODE FORECAST
C                                            FOR ANY MESSAGE TYPE
C                                            (VALUES REMAIN MISSING)
C                  SOME_FCST = .TRUE.  ---> YES, BUT ONLY FOR MESSAGE
C                                            TYPES "ADPUPA", "AIRCFT",
C                                            "AIRCAR", "PROFLR" OR
C                                            "VADWND" (VALUES REMAIN
C                                            MISSING FOR ALL OTHER
C                                            MESSAGE TYPES)
C      (NOTE1: THE CASE DOFCST=FALSE & SOME_FCST=TRUE WRITES THE
C              FORECAST VALUES FOR THE TYPES MENTIONED ABOVE BECAUSE
C              THEY ARE NEEDED BY SUBSEQUENT QUALITY CONTROL PROGRAMS.)
C      (NOTE2: THIS WAS ADDED AS A TIME SAVING FEATURE IN THE
C              NON-GLOBAL VERSIONS SINCE ONLY THE GLOBAL-SSI REQUIRES
C              A FIRST GUESS TO BE PRESENT FOR ALL CONVENTIONAL MESSAGE
C              TYPES IN THE PREPBUFR FILE.)
C      (NOTE3: IF DOANLS=TRUE, THEN DOFCST & SOME_FCST ARE FORCED TO BE
C              FALSE, MEANING A GUESS WILL NOT BE ENCODED FOR ANY
C              MESSAGE TYPE.)
C      (NOTE4: IF DOFCST=TRUE, THEN SOME_FCST IS MEANINGLESS.)
C      (NOTE5: SOME_FCST DEFAULTS TO TRUE.)
C
C    DOANLS  - ENCODE ANALYZED VALUES, INTERPOLATED FROM THE SPECTRAL
C              SIGMA ANALYSIS FILE, INTO THE PREPBUFR FILE - POSTEVENTS
C              MODE - ?
C              DOANLS = .TRUE.  ---> YES, FOR ALL MESSAGE TYPES
C              DOANLS = .FALSE. ---> NO,  FOR ALL MESSAGE TYPES
C                                          - PREVENTS MODE -   (DEFAULT)
C      (NOTE:  DOANLS=TRUE WILL OVERRIDE AND FORCE TO FALSE ALL OTHER
C              SWITCHES. IN ADDITION, THE FORECAST VALUES WILL NOT
C              BE ENCODED FOR ANY MESSAGE TYPE AND SPECIFIC HUMIDITY
C              WILL NOT BE RE-CALCULATED.)
C
C    DOBERR  - ENCODE OBSERVATIONAL ERROR VALUES, AS READ FROM OBS.
C              ERROR FILE, INTO THE PREPBUFR FILE?
C              DOBERR = .TRUE.  ---> YES                       (DEFAULT)
C              DOBERR = .FALSE. ---> NO (VALUES REMAIN MISSING)
C      (NOTE1: THIS WAS ADDED AS A TIME SAVING FEATURE IN THE
C              RAP -AND PREVIOUS RUC- VERSION SINCE IT DOES NOT REQUIRE
C              OBSERVATIONAL ERRORS TO BE PRESENT IN THE PREPBUFR FILE.)
C      (NOTE2: IF DOANLS=TRUE, THEN DOBERR IS FORCED TO BE FALSE.)
C
C    QTOP_REJ  - THE PRESSURE LEVEL (IN MB) ABOVE WHICH ALL SPECIFIC
C                HUMIDITY QUALITY MARKERS ARE "REJECTED" (THE QUALITY
C                MARKER IS SET TO 9 ON ALL PRESSURE LEVELS LESS THAN
C                THIS LEVEL)                              (DEFAULT=300.)
C
C    SATMQC  - PERFORM SPECIAL QUALITY CONTROL ON SATELLITE TEMPERATURE
C              SOUNDINGS IN REPORT TYPES 160-179?
C              SATMQC = .TRUE.  ---> YES
C              SATMQC = .FALSE. ---> NO                        (DEFAULT)
C      (NOTE: THIS APPLIES ONLY TO THE CDAS OR HISTORICAL RE-RUNS
C             WITH TEMPERATURE SOUNDINGS IN THESE REPORT TYPES)
C
CC
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE GBLEVENTS_CDAS(IDATEP,IUNITF,IUNITE,IUNITP,IUNITS,
     $                         SUBSET,NEWTYP)

      CHARACTER*80 HEADR,OBSTR,FCSTR,OESTR,ANSTR
      CHARACTER*8  SUBSET
      REAL(8)      OBS_8,BAK_8,SID_8,HDR_8(10)
      REAL(8)      BMISS,GETBMISS
      LOGICAL      DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,DOANLS,
     $             SATMQC,ADPUPA_VIRT

      DIMENSION    IUNITF(2)

      COMMON /CGBEVAA/ SID_8,OBS_8(12,255),BAK_8(12,255),NLEV,XOB,YOB,
     $ DHR,TYP
      COMMON /CGBEVBB/ IPVCD,IVTCD
      COMMON /CGBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT
      COMMON /CGBEVDD/ ERRS(300,33,6)
      COMMON /CGBEVGG/ BMISS

      SAVE

      DATA IFIRST/0/

      DATA HEADR /
     $ 'SID XOB YOB DHR TYP                                  '/
      DATA OBSTR /
     $ 'POB QOB TOB ZOB UOB VOB PWO  PW1O PW2O PW3O PW4O CAT '/
      DATA FCSTR /
     $ 'PFC QFC TFC ZFC UFC VFC PWF  PW1F PW2F PW3F PW4F NUL '/
      DATA ANSTR /
     $ 'PAN QAN TAN ZAN UAN VAN PWA  PW1A PW2A PW3A PW4A NUL '/
      DATA OESTR /
     $ 'POE QOE TOE ZOE WOE PWE PW1E PW2E PW3E PW4E NUL  NUL '/

      NAMELIST /PREVDATA/DOVTMP,DOFCST,SOME_FCST,DOBERR,DOANLS,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      IF(IFIRST.EQ.0)  THEN

C -------------------------------
C FIRST TIME IN DO A FEW THINGS...
C -------------------------------

         IFIRST = 1
         PRINT 700
  700 FORMAT(/1X,100('#')/' =====> SUBROUTINE GBLEVENTS_CDAS INVOKED ',
     $ 'FOR THE FIRST TIME - VERSION LAST UPDATED 2020-01-09'/)

C  INITIALIZE NAMELIST SWITCHES TO DEFAULT VALUES
C  ----------------------------------------------

         DOVTMP      = .TRUE.
         DOFCST      = .TRUE.
         SOME_FCST   = .TRUE.
         DOBERR      = .TRUE.
         DOANLS      = .FALSE.
         QTOP_REJ    = 300.
         SATMQC      = .FALSE.
         ADPUPA_VIRT = .FALSE.
         READ(5,PREVDATA,ERR=101,END=102)
         GO TO 103
C-----------------------------------------------------------------------
  101    CONTINUE

C  ERROR READING STANDARD INPUT - THIS DEFAULTS TO POSTEVENTS MODE
C  ---------------------------------------------------------------

         PRINT 7013
 7013 FORMAT(/' ##> GBLEVENTS_CDAS: ERROR READING STANDARD INPUT DATA ',
     $ 'CARDS -- DEFAULTS TO "POSTEVENTS" MODE'/)
         DOANLS = .TRUE.
         GO TO 103

C-----------------------------------------------------------------------
  102    CONTINUE

C  STANDARD INPUT IS EMPTY - THIS DEFAULTS TO POSTEVENTS MODE
C  ----------------------------------------------------------

         PRINT 7014
 7014 FORMAT(/' ##> GBLEVENTS_CDAS: STANDARD INPUT DATA CARDS DO NOT ',
     $ 'EXIST -- DEFAULTS TO "POSTEVENTS" MODE'/)
         DOANLS = .TRUE.

C-----------------------------------------------------------------------
  103    CONTINUE
         IF(DOANLS) THEN
            DOVTMP      = .FALSE.
            DOFCST      = .FALSE.
            SOME_FCST   = .FALSE.
            DOBERR      = .FALSE.
            ADPUPA_VIRT = .FALSE.
         ENDIF
         WRITE (6,PREVDATA)

         BMISS = GETBMISS()
         print *
         print'(" BUFRLIB value for missing passed into GBLEVENTS_CDAS",
     $    " is: ",G0)', bmiss
cccc $    " is: ",F21.5)', bmiss
         print *

         FCST = DOFCST
         VIRT = .FALSE.

         FCST = DOFCST
         VIRT = .FALSE.

C  CHECK VALID-TIME DATE OF GUESS/ANALYSIS FILE(S) AGAINST THE CENTER
C   DATE FOR THE PREPBUFR FILE AND OBTAIN THE FIRST GUESS/ANALYSIS
C   UNLESS ALL OF DOFCST, SOME_FCST, DOANLS ARE FALSE
C  ------------------------------------------------------------------

         IF(.NOT.DOANLS)  THEN
            IF(.NOT.DOFCST.AND..NOT.SOME_FCST)  THEN
               PRINT 901
  901 FORMAT(/' --> GBLEVENTS_CDAS: PREVENTS MODE - FIRST GUESS NOT ',
     $ 'READ IN'/)
            ELSE
               PRINT 701
  701 FORMAT(/' --> GBLEVENTS_CDAS: PREVENTS MODE - DATE CHECK AND ',
     $ 'TRANSFORM THE FIRST GUESS'/)
            END IF
         ELSE
            PRINT 7701
 7701 FORMAT(/' --> GBLEVENTS_CDAS: POSTEVENTS MODE - DATE CHECK AND ',
     $ 'TRANSFORM THE ANALYSIS'/)
         END IF

         IF(DOFCST .OR. SOME_FCST .OR. DOANLS)
     $    CALL CGBLEVN10(IUNITF,IDATEP)

         IF(DOBERR)  THEN

C  IF REQUESTED, READ ERROR FILES (ONLY POSSIBLE IN PREVENTS MODE)
C  ---------------------------------------------------------------

            PRINT 702
  702 FORMAT(/' --> GBLEVENTS_CDAS: READ ERROR FILES'/)

            CALL CGBLEVN01(IUNITE)

         ELSE

            ERRS = 0
            IF(.NOT.DOANLS)  PRINT 3702
 3702 FORMAT(/' --> GBLEVENTS_CDAS: OBS. ERROR NOT ENCODED IN PREPBUFR',
     $ ' (BY CHOICE)'/)

         END IF

C  OBTAIN NECESSARY PROGRAM CODES (ONLY USED IN PREVENTS MODE)
C  -----------------------------------------------------------

         CALL UFBQCD(IUNITP,'PREVENT',IPVCD)
         CALL UFBQCD(IUNITP,'VIRTMP ',IVTCD)

         PRINT 703
  703 FORMAT(/1X,100('#')/)

C  SET-UP OUTPUT "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C  (ONLY USED IN PREVENTS MODE)
C  ----------------------------------------------------------------

         IF(.NOT.DOANLS)  WRITE(IUNITS,1701) IDATEP
 1701 FORMAT(//130('#')//38X,'*** "PREVENT" EVENTS DATA FILTERING ',
     $ 'SUMMARY ***'/35X,'--> CENTER DATE FOR PREPBUFR FILE IS: ',I10,
     $ ' <--'//)

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      END IF

      IF(.NOT.DOANLS)  THEN

         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1702)  SUBSET
 1702 FORMAT(130('-')/39X,'--> SUMMARY FOR TABLE A ENTRY "',A8,'" <--'/)

         IF(.NOT.DOFCST .AND. SOME_FCST)  FCST = (SUBSET.EQ.'ADPUPA  '
     $    .OR.SUBSET.EQ.'PROFLR  '.OR.SUBSET .EQ.'AIRCFT  '.OR.SUBSET
     $    .EQ.'AIRCAR  '.OR.SUBSET .EQ.'VADWND  ')

C   Will not subject ACARS reports to virtual temp. processing until
C    spec. humidity is used in production

ccccc    VIRT = (SUBSET.EQ.'ADPSFC  '.OR.SUBSET.EQ.'SFCSHP  '.OR.
ccccc$           SUBSET.EQ.'MSONET  '.OR.SUBSET.EQ.'AIRCAR  '.OR.
ccccc$           SUBSET.EQ.'RASSDA  '.OR.(SUBSET.EQ.'ADPUPA  '.AND.
ccccc$           ADPUPA_VIRT)))
         VIRT = (SUBSET.EQ.'ADPSFC  '.OR.SUBSET.EQ.'SFCSHP  '.OR.
     $           SUBSET.EQ.'MSONET  '.OR.SUBSET.EQ.'RASSDA  '.OR.
     $           (SUBSET.EQ.'ADPUPA  '.AND.ADPUPA_VIRT))


         IF(.NOT.(FCST.OR.DOBERR.OR.VIRT)) THEN
            IF(NEWTYP.EQ.1)  WRITE(IUNITS,1703)
 1703 FORMAT(/'  ==> DATA FILTERING NOT PERFORMED FOR THIS TABLE A ',
     $ 'ENTRY -- FORECAST, OBS ERROR, "VIRTMP" PROCESSING NOT DONE'/)
            RETURN
         ENDIF

      END IF

C  READY TO RETRIEVE NECESSARY INFORMATION OUT OF THE NEXT REPORT WHICH
C  HAS BEEN "UFB" ENCODED INTO THE PREPBUFR FILE BY THE CALLING PROGRAM
C  (USE NEGATIVE UNIT NUMBER HERE SINCE FILE OPEN FOR OUTPUT)
C  (NOTE: THE CALLING PROGRAM HAS NOT YET WRIITEN THE REPORT INTO
C         THE PREPBUFR FILE VIA WRITSB!)
C  ----------------------------------------------------------------

      CALL UFBINT(-IUNITP,OBS_8,12,255,NLEV,OBSTR)
      CALL UFBINT(-IUNITP,HDR_8,10,  1,IRET,HEADR)
      SID_8 = HDR_8(1)
      XOB   = HDR_8(2)

c Trap cases where XOB comes in w/ a value of 360.0 and reset to 0.0
      fuzzy_bound = XOB-360.0
      if (fuzzy_bound .ge. -0.0001 .and. fuzzy_bound .le. .0001) then 
c        print*, 'xob fuzzb:',xob,fuzzy_bound
c        write(*,*) 'failed the fuzzy check', xob
         XOB=0.0
      endif

      YOB   = HDR_8(3)
      DHR   = HDR_8(4)
      TYP   = HDR_8(5)

      IF(FCST.OR.DOANLS)  THEN

C  PREVENTS MODE:   ENCODE FIRST GUESS VALUES INTO PREPBUFR FILE
C  ------------------------------------------------------------

C  POSTEVENTS MODE: ENCODE ANALYSIS VALUES INTO REPORT AND RETURN TO
C                   CALLING PROGRAM TO WRITE GBL-EVENTED REPORT
C                   (SUBSET) INTO PREPBUFR FILE
C  -----------------------------------------------------------------

         CALL CGBLEVN03(SUBSET)
         IF(NLEV.GT.0)  THEN
            IF(FCST)   THEN
               CALL UFBINT(IUNITP,BAK_8,12,NLEV,IRET,FCSTR)
            ELSE
               CALL UFBINT(IUNITP,BAK_8,12,NLEV,IRET,ANSTR)
               RETURN
            END IF
         END IF
      END IF

C  --------------------------------------------------------------------
C  LOGIC FROM HERE ON PERTAINS ONLY TO PREVENTS MODE OF THIS SUBROUTINE
C  --------------------------------------------------------------------


      IF(DOBERR)  THEN

C  ENCODE OBSERVATION ERRORS INTO REPORT
C  -------------------------------------

         CALL CGBLEVN04
         IF(NLEV.GT.0)  CALL UFBINT(IUNITP,BAK_8,12,NLEV,IRET,OESTR)
      END IF

C  MAKE THE GBLEVENTS_CDAS EVENTS AND ENCODE INTO REPORT
C  -----------------------------------------------------

      IF(.NOT.FCST)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1704)
 1704 FORMAT(/'  ==> FORECAST VALUES NOT ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA POB VS. GESS PSFC TEST NOT ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE FORECAST VALUES NOT ',
     $ 'PROCESSED/STORED'/)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1708)
 1708 FORMAT(/'  ==> FORECAST VALUES ARE ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA POB VS. GESS PSFC TEST IS  ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE FORECAST VALUES ARE ',
     $ 'PROCESSED/STORED'/)
      ENDIF

      IF(.NOT.DOBERR)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1705)
 1705 FORMAT(/'  ==> FILTERING VIA MISSING OBS ERROR TEST NOT POSSIBLE',
     $ ' FOR THIS TABLE A ENTRY SINCE OBS ERROR VALUES NOT PROCESSED/',
     $ 'STORED'/)
      ENDIF

      CALL CGBLEVN02(IUNITP,IUNITS,NEWTYP)

C  MAKE THE VIRTUAL TEMPERATURE EVENTS AND ENCODE INTO REPORT
C  ----------------------------------------------------------

      IF(.NOT.VIRT)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1706)
 1706 FORMAT(/'  ==> "VIRTMP" EVENT PROCESSING NOT PERFORMED FOR THIS ',
     $ 'TABLE A ENTRY'/)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1707)
 1707 FORMAT(/'  ==> "VIRTMP" EVENT PROCESSING IS  PERFORMED FOR THIS ',
     $ 'TABLE A ENTRY'/)
         CALL CGBLEVN08(IUNITP,SUBSET)
      ENDIF

C  RETURN TO CALLING PROGRAM TO WRITE GBL-EVENTED REPORT (SUBSET) INTO
C   PREPBUFR FILE
C  -------------------------------------------------------------------

      RETURN

      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN01(IUNITE) ! FORMERLY SUBROUTINE ETABLE

      COMMON /CGBEVDD/ ERRS(300,33,6)

C  READ THE OBSERVATION ERROR TABLES
C  ---------------------------------

      REWIND IUNITE

      IREC = 0

   10 CONTINUE
      READ(IUNITE,'(1X,I3)',END=100) KX
      IREC = IREC + 1
      DO K=1,33
         READ(IUNITE,'(1X,6E12.5)') (ERRS(KX,K,M),M=1,6)
      ENDDO
      GO TO 10

  100 CONTINUE
      IF(IREC.EQ.0) THEN
         PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN01 - OBS. ERROR TABLE EMPTY",
     $    " OR DOES NOT EXIST - STOP 60")'
         CALL ERREXIT(60)
      END IF

      RETURN

      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN02(IUNITP,IUNITS,NEWTYP)
                                         ! FORMERLY SUBROUTINE FILTAN

      DIMENSION    NFLGRT(100:299,12)
      CHARACTER*8  STNID
      CHARACTER*40 PEVN,QEVN,TEVN,WEVN,PWVN,PW1VN,PW2VN,PW3VN,PW4VN
      REAL(8)      PEV_8(4,255),QEV_8(4,255),TEV_8(4,255),WEV_8(5,255),
     $             PWV_8(4,255),PW1V_8(4,255),PW2V_8(4,255),
     $             PW3V_8(4,255),PW4V_8(4,255),OBS_8,BAK_8,SID_8
      REAL(8)      BMISS
      LOGICAL      FCST,DN2FAR,REJPS,REJT,REJQ,REJW,REJPW,REJPW1,REJPW2,
     $             REJPW3,REJPW4,SATMQC,SATEMP,SOLN60,SOLS60

      COMMON /CGBEVAA/ SID_8,OBS_8(12,255),BAK_8(12,255),NLEV,XOB,YOB,
     $ DHR,TYP
      COMMON /CGBEVBB/ IPVCD,IVTCD
      COMMON /CGBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT
      COMMON /CGBEVEE/PSG01_C,ZSG01_C,TG01_C(100),UG01_C(100),
     x     VG01_C(100),QG01_C(100),zint(100),pint(100),pintlog(100),
     x     plev(100),plevlog(100)
      COMMON /CGBEVGG/ BMISS

      EQUIVALENCE (SID_8,STNID)

      DATA PEVN  /'POB  PQM  PPC  PRC      '/
      DATA QEVN  /'QOB  QQM  QPC  QRC      '/
      DATA TEVN  /'TOB  TQM  TPC  TRC      '/
      DATA WEVN  /'UOB  VOB  WQM  WPC  WRC '/
      DATA PWVN  /'PWO  PWQ  PWP  PWR      '/
      DATA PW1VN /'PW1O PW1Q PW1P PW1R     '/
      DATA PW2VN /'PW2O PW2Q PW2P PW2R     '/
      DATA PW3VN /'PW3O PW3Q PW3P PW3R     '/
      DATA PW4VN /'PW4O PW4Q PW4P PW4R     '/

      DATA NFLGRT/2400*0/

      NI  = MOD((NINT(TYP)/10),10)

      IF(NEWTYP.EQ.1)  NFLGRT = 0

C  LOGICAL SWITCHES FOR OBSERVATION LOCATION FILTERING
C  ---------------------------------------------------

      SATEMP = ((TYP.GE.160.AND.TYP.LE.179).AND.SATMQC)
      SOLN60 = ((TYP.GE.160.AND.TYP.LE.163).AND.YOB.GE.-60.AND.SATMQC)
      SOLS60 = ((TYP.EQ.160.OR.TYP.EQ.162.OR.TYP.EQ.163).AND.YOB.LT.-60
     $ .AND.SATMQC)

C  CLEAR THE EVENT ARRAYS
C  ----------------------

      PEV_8  = BMISS
      QEV_8  = BMISS
      TEV_8  = BMISS
      WEV_8  = BMISS
      PWV_8  = BMISS
      PW1V_8 = BMISS
      PW2V_8 = BMISS
      PW3V_8 = BMISS
      PW4V_8 = BMISS

      MAXPEV  = 0
      MAXQEV  = 0
      MAXTEV  = 0
      MAXWEV  = 0
      MAXPWV  = 0
      MAXPW1V = 0
      MAXPW2V = 0
      MAXPW3V = 0
      MAXPW4V = 0

C  LOOP OVER LEVELS APPLYING UNDERGROUND FILTERING AND SPECIAL RULES
C  -----------------------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV

         POB  = OBS_8( 1,L)
         QOB  = OBS_8( 2,L)
         TOB  = OBS_8( 3,L)
         UOB  = OBS_8( 5,L)
         VOB  = OBS_8( 6,L)
         PWO  = OBS_8( 7,L)
         PW1O = OBS_8( 8,L)
         PW2O = OBS_8( 9,L)
         PW3O = OBS_8(10,L)
         PW4O = OBS_8(11,L)
         CAT  = OBS_8(12,L)

         DN2FAR = .FALSE.
         REJ = 9
         RCD = 9

C  -------------------------------------------------------------------
C  RULES FOR PRESSURE (ON ANY LEVEL) -- ALL DATA ON LEVEL REJECTED IF:
C    - PRESSURE MORE THAN 100 MB BELOW MODEL (GUESS) SURFACE PRESSURE
C       (AND SWITCH FCST=TRUE) -- "PREVENT" PGM REASON CODE 1
C    - PRESSURE IS ZERO OR IS NEGATIVE -- "PREVENT" PGM REASON CODE 2
C  REJECTION MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

         IF(POB.LT.BMISS)  THEN
            IF(.NOT.FCST)  PSG01_C = POB
            IF(POB-PSG01_C.GE.100. .OR. POB.LE.0.) THEN
               IF(POB.LE.0.) THEN
                  IF(NI.EQ.8)  THEN
                     WRITE(IUNITS,302) STNID,NINT(TYP),YOB,XOB,POB
  302 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, FAILS SANITY ',
     $'CHECK')
                  ELSE
                     WRITE(IUNITS,101) STNID,NINT(TYP),YOB,XOB,POB
  101 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $'E, REJECT ALL DATA ON LVL - POB=',F6.1,' MB, FAILS SANITY CHECK')
                  ENDIF
                  RCD = 2
               ELSE
                  IF(NI.EQ.8)  THEN
                     WRITE(IUNITS,303) STNID,NINT(TYP),YOB,XOB,POB,
     $                PSG01_C
  303 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, > 100 MB ',
     $ 'BELOW GES PSFC(=',F6.1,'MB)')
                  ELSE
                     WRITE(IUNITS,102) STNID,NINT(TYP),YOB,XOB,POB,
     $                PSG01_C
  102 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON LVL - POB=',F6.1,' MB, > 100 MB BELOW ',
     $ 'GES PSFC(=',F6.1,' MB)')
                  ENDIF
                  RCD = 1
               END IF
               REJ = 8
               DN2FAR = .TRUE.
               PEV_8(1,L) = POB
               PEV_8(2,L) = REJ
               PEV_8(3,L) = IPVCD
               PEV_8(4,L) = RCD
               MAXPEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR SURFACE PRESSURE -- ALL DATA ON SURFACE LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - PRESSURE IS MORE THAN 100 MB ABOVE OR BELOW MODEL (GUESS)
C       SURFACE PRESSURE (AND SWITCH FCST=TRUE) -- 
C       "PREVENT" PGM REASON CODE 4
C    - PRESSURE IS REPORTED ABOVE 450 MB OR BELOW 1100 MB -- "PREVENT"
C       PGM REASON CODE 2
C    - PRESSURE VIOLATES RULES FOR PRESSURE ON ANY LEVEL (SEE ABOVE)
C  REJECTION FOR ALL BUT LAST RULE MEANS Q.M. SET TO 9
C  REJECTION FOR LAST RULE MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

         IF(POB.LT.BMISS .AND. CAT.EQ.0) THEN
            IF(.NOT.FCST)  PSG01_C = POB
            REJPS = OEFG01_C(POB,TYP,5).GE.BMISS          .OR.
     $              ABS(POB-PSG01_C).GE.100.              .OR.
     $              POB.LE.450.                           .OR.
     $              POB.GE.1100.
            IF(REJPS.OR.DN2FAR) THEN
               IF(.NOT.DN2FAR)  THEN
                  IF(OEFG01_C(POB,TYP,5).GE.BMISS)  THEN
                     IF(NFLGRT(NINT(TYP),1).EQ.0)  THEN
                        WRITE(IUNITS,201) NINT(TYP)
  201 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'ALL DATA ON SURFACE LEVEL DUE TO MISSING SFC-P OBS ERROR'/)
                        NFLGRT(NINT(TYP),1) = 1
                     ENDIF
CDAK CDAK CDAK CDAK  WRITE(IUNITS,103) STNID,NINT(TYP),YOB,XOB,POB
CD103 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
CDAK $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,'MB, MISSING OBS.',
CDAK $ ' ERROR')
                     RCD = 3
                  ELSE  IF(ABS(POB-PSG01_C).GE.100.)  THEN
                     WRITE(IUNITS,104) STNID,NINT(TYP),YOB,XOB,POB,
     $                PSG01_C
  104 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, > 100 MB ',
     $ 'ABOVE GES PSFC(=',F6.1,'MB)')
                     RCD = 4
                  ELSE
                     WRITE(IUNITS,105) STNID,NINT(TYP),YOB,XOB,POB
  105 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, FAILS SANITY ',
     $ 'CHECK')
                     RCD = 2
                  ENDIF
               ENDIF
               DN2FAR = .TRUE.
               PEV_8(1,L) = POB
               PEV_8(2,L) = REJ
               PEV_8(3,L) = IPVCD
               PEV_8(4,L) = RCD
               MAXPEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR TEMPERATURE -- TOB AND QOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - REPORT IS TYPE 160-163 (LAND TOVS/RTOVS/ATOVS TEMPERATURE
C       SOUNDINGS, ALL PATHS), AND IS AT OR NORTH OF 60 DEGREES SOUTH
C       LATITUDE, AND PRESSURE ON LEVEL IS AT OR BELOW 100 MB (AND
C       SWITCH SATMQC=TRUE)  -- "PREVENT" PGM REASON CODE 6
C    - REPORT IS TYPE 160,162,163 (LAND TOVS/RTOVS/ATOVS TEMPERATURE
C       SOUNDINGS, ALL PATHS BUT CLEAR), AND IS SOUTH OF 60 DEGREES
C       SOUTH LATITUDE, AND PRESSURE ON LEVEL IS BELOW 100 MB (AND
C       SWITCH SATMQC=TRUE) -- "PREVENT" PGM REASON CODE 6
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR ALL BUT LAST RULE MEANS Q.M. SET TO 9
C  REJECTION FOR LAST RULE MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

! initialize REJT as T so it will be set if TOB is missing (since
!  referenced in "RULES FOR SPECIFIC HUMIDITY" below)
         REJT = .TRUE.
         IF(TOB.LT.BMISS) THEN
            REJT = OEFG01_C(POB,TYP,2).GE.BMISS         .OR. 
     $             (SOLN60.AND.NINT(POB*10.).GE.1000)   .OR.
     $             (SOLS60.AND.NINT(POB*10.).GT.1000)
            IF(REJT.OR.DN2FAR) THEN
               IF(.NOT.DN2FAR)  THEN
                  IF(OEFG01_C(POB,TYP,2).GE.BMISS)  THEN
                     IF(NFLGRT(NINT(TYP),2).EQ.0)  THEN
                        IF(NI.EQ.8)  THEN
                           WRITE(IUNITS,304) NINT(TYP)
  304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                        ELSE
                           WRITE(IUNITS,202) NINT(TYP)
  202 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB ON AT LEAST ONE LVL (IF AVAILABLE ON THAT LVL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                        ENDIF
                        NFLGRT(NINT(TYP),2) = 1
cdak cdak cdak cdak cdakWRITE(IUNITS,106) STNID,NINT(TYP),YOB,XOB,TOB
cd106 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $ 'E, REJECT TOB/QOB ON LVL - TOB=',F5.1,'C, MISSING OBS. ERROR')
                     ENDIF
                     RCD = 3
                  ELSE  IF(SOLN60.AND.NINT(POB*10.).GE.1000)  THEN
                     IF(NFLGRT(NINT(TYP),6).EQ.0)  THEN
                        WRITE(IUNITS,7304) NINT(TYP)
 7304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $'TOB/QOB AT AND BELOW 100 MB IF REPORT IS NORTH OF 60S LATITUDE'/)
                        NFLGRT(NINT(TYP),6) = 1
                     ENDIF
                     RCD = 6
                  ELSE  IF(SOLS60.AND.NINT(POB*10.).GT.1000)  THEN
                     IF(NFLGRT(NINT(TYP),7).EQ.0)  THEN
                        WRITE(IUNITS,7305) NINT(TYP)
 7305 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB BELOW 100 MB IF REPORT IS SOUTH OF 60S LATITUDE'/)
                        NFLGRT(NINT(TYP),7) = 1
                     ENDIF
                     RCD = 6
                  ENDIF
               ENDIF
               TEV_8(1,L) = TOB
               TEV_8(2,L) = REJ
               TEV_8(3,L) = IPVCD
               TEV_8(4,L) = RCD
               MAXTEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR SPECIFIC HUMIDITY -- QOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - TEMPERATURE ON LEVEL IS MISSING OR IS LESS THAN -150 DEG. C --
C       "PREVENT" PGM REASON CODE 2
C    - PRESSURE ON LEVEL IS ABOVE "QTOP_REJ" MB {WHERE QTOP_REJ IS
C       READ IN FROM NAMELIST "PREVDATA" (SEE DOCBLOCK)} -- "PREVENT"
C       PGM REASON CODE 5
C    - SPECIFIC HUMIDITY IS ZERO OR IS NEGATIVE -- "PREVENT" PGM REASON
C       CODE 2
C    - REPORT IS TYPE 160-179 (SATELLITE TEMPERATURE SOUNDINGS, ALL
C       TYPES, ALL PATHS, LAND AND SEA), ALL PRESSURE LEVELS (AND
C       SWITCH SATMQC=TRUE) -- "PREVENT" PGM REASON CODE 7
C    - TEMPERATURE ON LEVEL VIOLATES RULES FOR TEMPERATURE (SEE ABOVE)
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR ALL BUT LAST RULE MEANS Q.M. SET TO 9
C  REJECTION FOR LAST RULE MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

         IF(QOB.LT.BMISS) THEN
            REJQ = OEFG01_C(POB,TYP,3).GE.BMISS               .OR.
     $             TOB.GE.BMISS                               .OR.
     $             TOB.LE.-150.                               .OR.
     $             NINT(POB * 10.).LT.NINT(QTOP_REJ * 10.)    .OR.
     $             QOB.LE.0.                                  .OR.
     $             SATEMP                                     .OR.
     $             REJT
            IF(REJQ.OR.DN2FAR) THEN
               IF(.NOT.DN2FAR.AND..NOT.REJT)  THEN
                  IF(OEFG01_C(POB,TYP,3).GE.BMISS)  THEN
                     IF(NFLGRT(NINT(TYP),3).EQ.0)  THEN
                        IF(NI.EQ.8)  THEN
                           WRITE(IUNITS,305) NINT(TYP)
  305 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                        ELSE
                           WRITE(IUNITS,203) NINT(TYP)
  203 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON AT LEAST ONE LEVEL (IF AVAILABLE ON THAT LEVEL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                        ENDIF
                        NFLGRT(NINT(TYP),3) = 1
                     ENDIF
cdak cdak cdak cdak  WRITE(IUNITS,108) STNID,NINT(TYP),YOB,XOB,QOB/1000.
cd108 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT QOB ON LVL - QOB=',F6.3,'G/KG, MISSING OBS. ERROR')
                  ELSE  IF(NINT(POB*10.).LT.NINT(QTOP_REJ*10.))  THEN
                     WRITE(IUNITS,109) STNID,NINT(TYP),YOB,XOB,
     $                QOB/1000.,QTOP_REJ,POB
  109 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT QOB ON LVL - QOB=',F6.3,' G/KG, ABOVE ',F6.1,
     $ 'MB (POB=',F6.1,' MB)')
                     RCD = 5
                  ELSE  IF(SATEMP)  THEN
                     IF(NFLGRT(NINT(TYP),8).EQ.0)  THEN
                        WRITE(IUNITS,7306) NINT(TYP)
 7306 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON ALL LEVELS'/)
                        NFLGRT(NINT(TYP),8) = 1
                     ENDIF
                     RCD = 7
                  ELSE
                     WRITE(IUNITS,111) STNID,NINT(TYP),YOB,XOB,
     $                QOB/1000.,TOB
  111 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT QOB ON LVL - QOB=',F6.3,' G/KG, FAILS SANITY CHECK ',
     $ '(TOB=',F5.1,' C)')
                     RCD = 2
                  ENDIF
               ENDIF
               QEV_8(1,L) = QOB
               QEV_8(2,L) = REJ
               QEV_8(3,L) = IPVCD
               QEV_8(4,L) = RCD
               MAXQEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR WINDS -- UOB AND VOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR ALL BUT LAST RULE MEANS Q.M. SET TO 9
C  REJECTION FOR LAST RULE MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

         IF(MIN(UOB,VOB).LT.BMISS) THEN
            REJW = OEFG01_C(POB,TYP,4).GE.BMISS
            IF(REJW.OR.DN2FAR) THEN
               IF(.NOT.DN2FAR)  THEN
                  IF(NFLGRT(NINT(TYP),4).EQ.0)  THEN
                     IF(NI.EQ.8)  THEN
                        WRITE(IUNITS,1304) NINT(TYP)
 1304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'UOB/VOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                     ELSE
                        WRITE(IUNITS,204) NINT(TYP)
  204 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'UOB/VOB ON AT LEAST ONE LVL (IF AVAILABLE ON THAT LVL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                     ENDIF
                     NFLGRT(NINT(TYP),4) = 1
                  ENDIF
cdak cdak cdak    WRITE(IUNITS,112) STNID,NINT(TYP),YOB,XOB
cd112 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT UOB/VOB ON LVL - MISSING OBS. ERROR')
                  RCD = 3
               ENDIF
               WEV_8(1,L) = UOB
               WEV_8(2,L) = VOB
               WEV_8(3,L) = REJ
               WEV_8(4,L) = IPVCD
               WEV_8(5,L) = RCD
               MAXWEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR TOTAL COLUMN PRECIPITABLE WATER -- PWO REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9
C  -------------------------------------------------------------------

         IF(PWO.LT.BMISS) THEN
            REJPW = OEFG01_C(POB,TYP,6).GE.BMISS
            IF(REJPW) THEN
               IF(NFLGRT(NINT(TYP),5).EQ.0)  THEN
                  WRITE(IUNITS,205) NINT(TYP)
  205 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PWO DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),5) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,113) STNID,NINT(TYP),YOB,XOB,PWO
cd113 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PWO ON LVL - PWO=',F5.1,'MM, MISSING OBS. ERROR')
               PWV_8(1,L) = PWO
               PWV_8(2,L) = 9
               PWV_8(3,L) = IPVCD
               PWV_8(4,L) = 3
               MAXPWV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 1 PRECIPITABLE WATER -- PW1O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9
C  -------------------------------------------------------------------

         IF(PW1O.LT.BMISS) THEN
            REJPW1 = OEFG01_C(POB,TYP,6).GE.BMISS
            IF(REJPW1) THEN
               IF(NFLGRT(NINT(TYP),9).EQ.0)  THEN
                  WRITE(IUNITS,206) NINT(TYP)
  206 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW1O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),9) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,114) STNID,NINT(TYP),YOB,XOB,PW1O
cd114 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW1O ON LVL - PW1O=',F5.1,'MM, MISSING OBS. ERROR')
               PW1V_8(1,L) = PW1O
               PW1V_8(2,L) = 9
               PW1V_8(3,L) = IPVCD
               PW1V_8(4,L) = 3
               MAXPW1V = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 2 PRECIPITABLE WATER -- PW2O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9
C  -------------------------------------------------------------------

         IF(PW2O.LT.BMISS) THEN
            REJPW2 = OEFG01_C(POB,TYP,6).GE.BMISS
            IF(REJPW2) THEN
               IF(NFLGRT(NINT(TYP),10).EQ.0)  THEN
                  WRITE(IUNITS,207) NINT(TYP)
  207 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW2O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),10) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,115) STNID,NINT(TYP),YOB,XOB,PW2O
cd115 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW2O ON LVL - PW2O=',F5.1,'MM, MISSING OBS. ERROR')
               PW2V_8(1,L) = PW2O
               PW2V_8(2,L) = 9
               PW2V_8(3,L) = IPVCD
               PW2V_8(4,L) = 3
               MAXPW2V = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 3 PRECIPITABLE WATER -- PW3O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9
C  -------------------------------------------------------------------

         IF(PW3O.LT.BMISS) THEN
            REJPW3 = OEFG01_C(POB,TYP,6).GE.BMISS
            IF(REJPW3) THEN
               IF(NFLGRT(NINT(TYP),11).EQ.0)  THEN
                  WRITE(IUNITS,208) NINT(TYP)
  208 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW3O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),11) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,116) STNID,NINT(TYP),YOB,XOB,PW3O
cd116 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW3O ON LVL - PW3O=',F5.1,'MM, MISSING OBS. ERROR')
               PW3V_8(1,L) = PW3O
               PW3V_8(2,L) = 9
               PW3V_8(3,L) = IPVCD
               PW3V_8(4,L) = 3
               MAXPW3V = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 4 PRECIPITABLE WATER -- PW4O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9
C  -------------------------------------------------------------------

         IF(PW4O.LT.BMISS) THEN
            REJPW4 = OEFG01_C(POB,TYP,6).GE.BMISS
            IF(REJPW4) THEN
               IF(NFLGRT(NINT(TYP),12).EQ.0)  THEN
                  WRITE(IUNITS,209) NINT(TYP)
  209 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW4O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),12) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,117) STNID,NINT(TYP),YOB,XOB,PW4O
cd117 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW4O ON LVL - PW4O=',F5.1,'MM, MISSING OBS. ERROR')
               PW4V_8(1,L) = PW4O
               PW4V_8(2,L) = 9
               PW4V_8(3,L) = IPVCD
               PW4V_8(4,L) = 3
               MAXPW4V = L
            ENDIF
         ENDIF

      ENDDO
      ENDIF

C  APPLY THE PROPER EVENTS
C  -----------------------

      IF(MAXPEV .GT.0) CALL UFBINT(IUNITP,PEV_8, 4,MAXPEV, IRET,PEVN)
      IF(MAXQEV .GT.0) CALL UFBINT(IUNITP,QEV_8, 4,MAXQEV, IRET,QEVN)
      IF(MAXTEV .GT.0) CALL UFBINT(IUNITP,TEV_8, 4,MAXTEV, IRET,TEVN)
      IF(MAXWEV .GT.0) CALL UFBINT(IUNITP,WEV_8, 5,MAXWEV, IRET,WEVN)
      IF(MAXPWV .GT.0) CALL UFBINT(IUNITP,PWV_8, 4,MAXPWV, IRET,PWVN)
      IF(MAXPW1V.GT.0) CALL UFBINT(IUNITP,PW1V_8,4,MAXPW1V,IRET,PW1VN)
      IF(MAXPW2V.GT.0) CALL UFBINT(IUNITP,PW2V_8,4,MAXPW2V,IRET,PW2VN)
      IF(MAXPW3V.GT.0) CALL UFBINT(IUNITP,PW3V_8,4,MAXPW3V,IRET,PW3VN)
      IF(MAXPW4V.GT.0) CALL UFBINT(IUNITP,PW4V_8,4,MAXPW4V,IRET,PW4VN)

      RETURN
      END
C***********************************************************************
C***********************************************************************
C  CGBLEVN03 - INTERPOLATE MODEL DATA (FIRST GUESS OR ANALYSIS) TO OB
C              LOCATIONS
C-----------------------------------------------------------------------
      SUBROUTINE CGBLEVN03(SUBSET) ! FORMERLY SUBROUTINE GETFC

      REAL(8)   OBS_8,BAK_8,SID_8
      REAL(8)   BMISS
      CHARACTER*8  SUBSET

      COMMON /CGBEVAA/ SID_8,OBS_8(12,255),BAK_8(12,255),NLEV,XOB,YOB,
     $ DHR,TYP
      COMMON /CGBEVFF/IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,IDVC,SL(100),
     x     SI(101)
      COMMON /CGBEVEE/PSG01_C,ZSG01_C,TG01_C(100),UG01_C(100),
     x     VG01_C(100),QG01_C(100),zint(100),pint(100),pintlog(100),
     x     plev(100),plevlog(100)
      COMMON /CGBEVGG/ BMISS


      DATA TZERO / 273.15 /
      DATA BETAP / .0552  /
      DATA BETA  / .00650 /
      DATA ROG   / 29.261 /

C  CLEAR THE BACKGROUND EVENT ARRAY
C  --------------------------------

      BAK_8 = BMISS

C  GET GUESS PROFILE AT OB LOCATION
C  --------------------------------
      CALL CGBLEVN06(XOB,YOB)

      
C  INTERPOLATE GUESS PROFILES TO OB PRESSURES
C  ------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO 10 L=1,NLEV

         POB  = OBS_8( 1,L)
         QOB  = OBS_8( 2,L)
         TOB  = OBS_8( 3,L)
         ZOB  = OBS_8( 4,L)
         UOB  = OBS_8( 5,L)
         VOB  = OBS_8( 6,L)
         PWO  = OBS_8( 7,L)
         PW1O = OBS_8( 8,L)
         PW2O = OBS_8( 9,L)
         PW3O = OBS_8(10,L)
         PW4O = OBS_8(11,L)
         CAT  = OBS_8(12,L)

         IF(POB.LE.0. .OR. POB.GE.BMISS) GOTO 10

         poblog = log(pob)
         
         la = -999
         lb = -999
         do k=1,kmax-1
            if (poblog<=plevlog(k) .and. poblog>plevlog(k+1)) then
               la = k
               lb = k+1
               exit
            endif
         end do
         if (la > 0) then
            wt = (poblog-plevlog(lb)) / (plevlog(la)-plevlog(lb))
         else
            la = 1
            lb = la+1
            wt = 0.0
         endif
         
         li=0
         do k=1,kmax-1
            if (poblog<=pintlog(k) .and. poblog>pintlog(k+1)) then
               li = k
               exit
            endif
         end do

C  SURFACE PRESSURE
C  ----------------

         IF(CAT.EQ.0 .AND. ZOB.LT.BMISS) THEN
            TS = TG01_C(1) + (PSG01_C-PLEV(1))*BETAP
            DZ  = ZOB-ZSG01_C
            TM  = TS - DZ*BETA*.5
            PFC = PSG01_C*EXP(-DZ/(TM*ROG))
         ELSE
            PFC = BMISS
         ENDIF

C  SPECIFIC HUMIDITY
C  -----------------

         IF(QOB.LT.BMISS.OR.TOB.LT.BMISS.OR.TYP.EQ.111) THEN

C  (QFC NEEDED BY SYNDATA PROGRAM BUT ONLY FOR REPORT TYPE 111)

            QOB = QG01_C(LB) + (QG01_C(LA)-QG01_C(LB))*WT
         ENDIF

C  TEMPERATURE
C  -----------

         IF(TOB.LT.BMISS.OR.SUBSET.EQ.'VADWND  '.OR.TYP.EQ.111) THEN

C  (TFC NEEDED BY CQCVAD AND SYNDATA PROGRAMS, LATTER ONLY FOR REPORT
C   TYPE 111)

            IF(POB.GT.PLEV(1)) THEN
               TOB = TG01_C(1) + (POB-PLEV(1))*BETAP
            ELSE
               TOB = TG01_C(LB) + (TG01_C(LA)-TG01_C(LB))*WT
            ENDIF
            TOB = TOB - TZERO
         ENDIF

C  HEIGHT
C  ------

         IF(ZOB.LT.BMISS) THEN
            IF(POB.GT.PLEV(1)) THEN
               TM = TG01_C(1) + (.5*(PINT(1)+POB)-PLEV(1))*BETAP
               ZOB = ZINT(1) - ROG*TM*LOG(POB/PINT(1))
            ELSE if(li.gt.0) then
! DAK: 2/14/13: added test for LI = 0 as this can happen and cause
!               zint array to go out of bounds when WCOSS debugging
!               turned on - now if LI = 0, zob-gess is stored as
!               missing rather than as -infinity
               TM = TG01_C(LB) + (TG01_C(LA)-TG01_C(LB))*WT
               ZOB = ZINT(LI) - ROG*TM*LOG(POB/PINT(LI))
            else
               zob = bmiss
            ENDIF
         ENDIF

C  U AND V COMPONENTS
C  ------------------

         IF(UOB.LT.BMISS .OR. VOB.LT.BMISS) THEN
            UOB = UG01_C(LB) + (UG01_C(LA)-UG01_C(LB))*WT
            VOB = VG01_C(LB) + (VG01_C(LA)-VG01_C(LB))*WT
         ENDIF


C  PRECIPITABLE WATER
C  ------------------

         PWO  = BMISS
         PW1O = BMISS
         PW2O = BMISS
         PW3O = BMISS
         PW4O = BMISS

C  RELATIVE HUMIDITY
C  -----------------

         RHO = BMISS

C  SCATTER THE PROPER FIRST GUESS/ANALYSIS VALUES
C  ----------------------------------------------

         BAK_8(1,L)  = PFC
         BAK_8(2,L)  = QOB
         BAK_8(3,L)  = TOB
         BAK_8(4,L)  = ZOB
         BAK_8(5,L)  = UOB
         BAK_8(6,L)  = VOB
         BAK_8(7,L)  = PWO
         BAK_8(8,L)  = PW1O
         BAK_8(9,L)  = PW2O
         BAK_8(10,L) = PW3O
         BAK_8(11,L) = PW4O
         BAK_8(12,L) = RHO

   10 ENDDO
      ENDIF

      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN04 ! FORMERLY SUBROUTINE GETOE

      REAL(8)   OBS_8,BAK_8,SID_8
      REAL(8)   BMISS

      COMMON /CGBEVAA/ SID_8,OBS_8(12,255),BAK_8(12,255),NLEV,XOB,YOB,
     $ DHR,TYP
      COMMON /CGBEVGG/ BMISS

C  CLEAR THE EVENT ARRAY
C  ---------------------

      BAK_8 = BMISS

C  LOOP OVER LEVELS LOOKING UP THE OBSERVATION ERROR
C  -------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV

         POB  = OBS_8( 1,L)
         QOB  = OBS_8( 2,L)
         TOB  = OBS_8( 3,L)
         WOB  = MAX(OBS_8(5,L),OBS_8(6,L))
         PWO  = OBS_8( 7,L)
         PW1O = OBS_8( 8,L)
         PW2O = OBS_8( 9,L)
         PW3O = OBS_8(10,L)
         PW4O = OBS_8(11,L)
         CAT  = OBS_8(12,L)

         IF(CAT .EQ.0    ) BAK_8( 1,L) = OEFG01_C(POB,TYP,5)
         IF(QOB .LT.BMISS) BAK_8( 2,L) = OEFG01_C(POB,TYP,3)
         IF(TOB .LT.BMISS) BAK_8( 3,L) = OEFG01_C(POB,TYP,2)
         IF(WOB .LT.BMISS) BAK_8( 5,L) = OEFG01_C(POB,TYP,4)
         IF(PWO .LT.BMISS) BAK_8( 6,L) = OEFG01_C(POB,TYP,6)
         IF(PW1O.LT.BMISS) BAK_8( 7,L) = OEFG01_C(POB,TYP,6)
         IF(PW2O.LT.BMISS) BAK_8( 8,L) = OEFG01_C(POB,TYP,6)
         IF(PW3O.LT.BMISS) BAK_8( 9,L) = OEFG01_C(POB,TYP,6)
         IF(PW4O.LT.BMISS) BAK_8(10,L) = OEFG01_C(POB,TYP,6)

      ENDDO
      ENDIF

      RETURN
      END
C***********************************************************************
C***********************************************************************
C  SUBROUTINE CGBLEVN05 - GUSER (CGBLEVN10) USER INTERFACE FOR
C                         PREPFIT (PSG01_C,ZSG01_C,TG01_C,UG01_C,VG01_C)
C-----------------------------------------------------------------------
      SUBROUTINE CGBLEVN05(GRD,IQ,LEV) ! FORMERLY SUBROUTINE GUSER

      COMMON /CGBEVFF/IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,IDVC,SL(100),
     x     SI(101)

      DIMENSION   GRD(IMAX,JMAX,2)

C  PACK 2D FIRST GUESS/ANALYSIS FIELD INTO BIT PACKED ARRAYS
C  ---------------------------------------------------------

      IF(IQ.EQ.1) THEN
         DO J=1,JMAX
            DO I=1,IMAX
               CALL CGBLEVN12(I,J,GRD(I,J,1))
            ENDDO
         ENDDO
      ELSEIF(IQ.EQ.2) THEN
         DO J=1,JMAX
            DO I=1,IMAX
               CALL CGBLEVN13(I,J,GRD(I,J,1))
            ENDDO
         ENDDO
      ELSEIF(IQ.EQ.3) THEN
         DO J=1,JMAX
            DO I=1,IMAX
               CALL CGBLEVN14(I,J,LEV,GRD(I,J,1))
            ENDDO
         ENDDO
      ELSEIF(IQ.EQ.4) THEN
         DO J=1,JMAX
            DO I=1,IMAX
               CALL CGBLEVN15(I,J,LEV,GRD(I,J,1))
               CALL CGBLEVN16(I,J,LEV,GRD(I,J,2))
            ENDDO
         ENDDO
      ELSEIF(IQ.EQ.5) THEN
         DO J=1,JMAX
            DO I=1,IMAX
               CALL CGBLEVN17(I,J,LEV,MAX(0.,GRD(I,J,1))*1E6)
            ENDDO
         ENDDO
      ENDIF

      RETURN
      END
C***********************************************************************
C***********************************************************************
C  SUBROUTINE CGBLEVN06 - 2D LINEAR HORIZONTAL INTERPOLATION
C-----------------------------------------------------------------------
      SUBROUTINE CGBLEVN06(XOB,YOB) ! FORMERLY SUBROUTINE HTERP
      REAL KAP1,KAPR


      COMMON /CGBEVFF/IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,IDVC,SL(100),
     x     SI(101)
      COMMON /CGBEVEE/ PSI,ZSI,TI(100),UI(100),VI(100),QI(100),
     x     zint(100),pint(100),pintlog(100),plev(100),plevlog(100)

      DATA ROG   / 29.261 /
      DATA KAP1 / 1.2857 /, KAPR / 3.4997 /


C  CALCULATE HORIZONTAL WEIGHTS AND INTERPOLATE
C  --------------------------------------------

      WX = XOB/DLON + 1.0
      I0 = WX
      I1 = MOD(I0,IMAX) + 1
      WX = WX-I0

      WY = (YOB+90.)/DLAT + 1.0
      J0 = WY
      J1 = MIN(J0+1,JMAX)
      WY = WY-J0

C  HTERP FOR SURFACE HEIGHT
C  ------------------------

      P1  = ZSG01_C(I0,J0)
      P2  = ZSG01_C(I0,J1)
      P3  = ZSG01_C(I1,J0)
      P4  = ZSG01_C(I1,J1)
      P5  = P1+(P2-P1)*WY
      P6  = P3+(P4-P3)*WY
      ZSI = P5+(P6-P5)*WX

C  HTERP FOR SURFACE PRESSURE
C  --------------------------

      P1  = PSG01_C(I0,J0)
      P2  = PSG01_C(I0,J1)
      P3  = PSG01_C(I1,J0)
      P4  = PSG01_C(I1,J1)
      P5  = P1+(P2-P1)*WY
      P6  = P3+(P4-P3)*WY
      PSI = P5+(P6-P5)*WX

C  HTERP FOR UPA T,U,V,Q
C  ---------------------

      DO K=1,KMAX

         P1 = TG01_C(I0,J0,K)
         P2 = TG01_C(I0,J1,K)
         P3 = TG01_C(I1,J0,K)
         P4 = TG01_C(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         TI(K) = P5+(P6-P5)*WX

         P1 = UG01_C(I0,J0,K)
         P2 = UG01_C(I0,J1,K)
         P3 = UG01_C(I1,J0,K)
         P4 = UG01_C(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         UI(K) = P5+(P6-P5)*WX

         P1 = VG01_C(I0,J0,K)
         P2 = VG01_C(I0,J1,K)
         P3 = VG01_C(I1,J0,K)
         P4 = VG01_C(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         VI(K) = P5+(P6-P5)*WX

         P1 = QG01_C(I0,J0,K)
         P2 = QG01_C(I0,J1,K)
         P3 = QG01_C(I1,J0,K)
         P4 = QG01_C(I1,J1,K)
         P5 = P1+(P2-P1)*WY
         P6 = P3+(P4-P3)*WY
         QI(K) = P5+(P6-P5)*WX

      ENDDO

c     Compute interface pressures and heights
      zint(1) = zsi
      pint(1) = psi
      pintlog(1) = log(pint(1))
      do k=2,kmax
        k0 = k-1
         if(idvc.eq.1) then
            pint(k) = psi*si(k)
         else if(idvc.eq.2) then
            pint(k)=si(k)+sl(k)*psi
         end if
         zint(k) = zint(k0) - rog*ti(k0)*log(pint(k)/pint(k0))
         pintlog(k) = log(pint(k))
      enddo
      pint(kmax+1) = 0.0

C     Compute pressure at layer midpoints
      do k=1,kmax
         if (idvc.eq.1) then
            plev(k) = psi*sl(k)
         else if (idvc.eq.2) then
            plev(k) = ((PINT(k)**KAP1-PINT(k+1)**KAP1)/
     $           (KAP1*(PINT(k)-PINT(k+1))))**KAPR
         endif
         plevlog(k) = log(plev(k))
      end do


      RETURN
      END
C***********************************************************************
C***********************************************************************
      FUNCTION OEFG01_C(P,TYP,IE) ! FORMERLY FUNCTION OEF

      REAL(8) BMISS

      COMMON /CGBEVDD/ERRS(300,33,6)
      COMMON /CGBEVGG/ BMISS

      OEFG01_C = BMISS
      KX  = TYP

C  LOOK UP ERRORS FOR PARTICULAR OB TYPES
C  --------------------------------------

      IF(IE.GE.2 .AND. IE.LE.4) THEN
         DO LA=1,33
            IF(P.GE.ERRS(KX,LA,1)) GOTO 10
         ENDDO
   10    CONTINUE
         LB = LA-1
         IF(LB.EQ.33) LA = 6
         IF(LB.EQ.33) LB = 5
         IF(LB.EQ. 0) THEN
            OEFG01_C = ERRS(KX,1,IE)
         ELSE
            DEL = (P-ERRS(KX,LB,1))/(ERRS(KX,LA,1)-ERRS(KX,LB,1))
            OEFG01_C = (1.-DEL)*ERRS(KX,LB,IE) + DEL*ERRS(KX,LA,IE)
         ENDIF
      ELSEIF(IE.EQ.5) THEN
         OEFG01_C = ERRS(KX,1,5)
      ELSEIF(IE.EQ.6) THEN
         OEFG01_C = ERRS(KX,1,6)
      ENDIF

C  SET MISSING ERROR VALUE TO "BMISS"
C  ----------------------------------

      IF(OEFG01_C.GE.5E5) OEFG01_C = BMISS

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    CGBLEVN08   CALCULATE SPEC. HUMIDITY AND VIRTUAL TEMP
C   PRGMMR: D.A. KEYSER      ORG: NP22       DATE: 2006-07-14
C
C ABSTRACT: CREATE VIRTUAL TEMPERATURE EVENTS WITHIN GBLEVENTS_CDAS
C   SUBROUTINE.  FOR ALL TYPES EXCEPT RASS, THIS CONSISTS OF FIRST RE-
C   CALCULATING THE SPECIFIC HUMIDITY FROM THE REPORTED DEWPOINT
C   TEMPERATURE AND PRESSURE, FOLLOWED BY THE CALCULATION OF VIRTUAL
C   TEMPERATURE FROM THE JUST-CALCULATED SPECIFIC HUMIDITY AND THE
C   REPORTED (SENSIBLE) TEMPERATURE.  THE RE-CALCULATED SPECIFIC
C   HUMIDITY IS THEN ENCODED AS A STACKED EVENT TO BE LATER WRITTEN
C   INTO THE PREPBUFR FILE (UNDER PROGRAM "VIRTMP", REASON CODE 0).
C   IF THE NAMELIST SWITCH DOVTMP IS TRUE, THEN THE JUST-CALCULATED
C   VIRTUAL TEMPERATURE IS THEN ALSO ENCODED AS A STACKED EVENT TO BE
C   LATER WRITTEN INTO THE PREPBUFR FILE (UNDER PROGRAM "VIRTMP",
C   REASON CODE 0, 2 OR 6).  FOR RASS DATA, SPECIFIC HUMIDITY IS
C   MISSING HOWEVER IF THE NAMELIST SWITCH DOVTMP IS TRUE, A SIMPLE
C   COPY OF THE REPORTED (VIRTUAL) TEMPERATURE IS ENCODED AS A STACKED
C   EVENT TO BE LATER WRITTEN INTO THE PREPBUFR FILE (UNDER PROGRAM
C   "VIRTMP", REASON CODE 3).  THIS SUBROUTINE IS CURRENTLY ONLY
C   CALLED FOR SURFACE LAND ("ADPSFC"), MARINE ("SFCSHP"), MESONET
C   ("MSONET") OR RASS ("RASSDA") DATA TYPES WHEN SWITCH "ADPUPA_VIRT"
C   IS FALSE AND ONLY FOR SURFACE LAND ("ADPSFC"), MARINE ("SFCSHP"),
C   MESONET ("MSONET"), RASS ("RASSDA"), RAOB/DROP/MULTI-LVL RECCO
C   ("ADPUPA") DATA TYPES WHEN SWITCH "ADPUPA_VIRT" IS TRUE.  IT IS
C   ALSO ONLY CALLED IN THE PREVENTS MODE.  THIS ROUTINE IS CALLED ONCE
C   FOR EACH VALID REPORT IN THE PREPBUFR FILE.
C
C PROGRAM HISTORY LOG:
C 1995-05-17  J. WOOLLEN (NP20) - ORIGINAL AUTHOR
C 1997-06-01  D.A. KEYSER - STREAMLINED, ADDED SWITCH DOVTMP
C 1999-12-01 D. A. KEYSER -- SPEC. HUMIDITY AND VIRT. TEMPERATURE ARE
C     NOW CALCULATED WHEN SPEC. HUMIDITY QUAL. MARKER IS BAD (SUBJECT
C     TO A SANITY CHECK), HOWEVER THE VIRT. TEMPERATURE GETS A BAD
C     QUAL. MARKER (8)
C 2004-08-30 D. A. KEYSER -- FOR "RASSDA" TYPES, ENCODES A SIMPLE COPY
C     OF THE REPORTED (VIRTUAL) TEMPERATURE AS A "VIRTMP" EVENT IF
C     DOVTMP IS TRUE, GETS NEW REASON CODE 3
C 2006-07-14 D. A. KEYSER --  PROCESSES REPORTS IN MESSAGE TYPE ADPUPA
C     (I.E., RAOBS, DROPS, MULTI-LEVEL RECCOS) WITH SAME LOGIC AS IN
C     SUBROUTINE VTPEVN OF PROGRAM PREPOBS_CQCBUFR WHEN NEW NAMELIST
C     SWITCH "ADPUPA_VIRT" IS TRUE {NORMALLY "ADPUPA_VIRT" IS FALSE
C     (DEFAULT) BECAUSE SUBSEQUENT PROGRAM PREPOBS_CQCBUFR PERFORMS
C     THIS FUNCTION}
C
C USAGE:    CALL CGBLEVN08(IUNITP)
C   INPUT ARGUMENT LIST:
C     IUNITP   - BUFR OUTPUT FILE UNIT
C     SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C              - REPORT BEING PROCESSED
C
C REMARKS: WILL IMMEDIATELY RETURN TO CALLING PROGRAM IF ANY OF THE
C   FOLLOWING CONDITIONS EXIST: THERE ARE NO LEVELS OF VALID DEWPOINT,
C   OBS, TEMPERATURE Q.M. OR SPEC. HUMIDITY Q.M. IN THE INPUT PREPBUFR
C   FILE FOR THE REPORT.  WILL NOT ATTEMPT EITHER SPEC. HUMIDITY NOR
C   VIRT. TEMP CALC. ON A GIVEN LEVEL IF ANY OF THE FOLLOWING
C   CONDITIONS EXIST: REPORTED PRESSURE OBS IS MISSING, REPORTED
C   (SENSIBLE) TEMPERATURE OBS IS MISSING, OR REPORTED DEWPOINT OBS IS
C   MISSING.
C 
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE CGBLEVN08(IUNITP,SUBSET) ! FORMERLY SUBROUTINE VTPEVN

      CHARACTER*80 EVNSTQ,EVNSTV
      CHARACTER*8  SUBSET
      REAL(8)      TDP_8(255),TQM_8(255),QQM_8(255),BAKQ_8(4,255),
     $             BAKV_8(4,255),OBS_8,BAK_8,SID_8
      REAL(8)      BMISS

      LOGICAL      EVNQ,EVNV,DOVTMP,TROP

      COMMON /CGBEVAA/ SID_8,OBS_8(12,255),BAK_8(12,255),NLEV,XOB,YOB,
     $ DHR,TYP
      COMMON /CGBEVBB/ IPVCD,IVTCD
      COMMON /CGBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT
      COMMON /CGBEVGG/ BMISS

      DATA EVNSTQ /'QOB QQM QPC QRC'/
      DATA EVNSTV /'TOB TQM TPC TRC'/

C-----------------------------------------------------------------------
C FCNS BELOW CONVERT TEMP/TD (K) & PRESS (MB) INTO SAT./ SPEC. HUM.(G/G)
C-----------------------------------------------------------------------
      ES(T) = 6.1078*EXP((17.269*(T - 273.16))/((T - 273.16)+237.3))
      QS(T,P) = (0.622*ES(T))/(P-(0.378*ES(T)))
C-----------------------------------------------------------------------

C  CLEAR TEMPERATURE AND SPECIFIC HUMIDITY EVENTS
C  ----------------------------------------------

      EVNQ   = .FALSE.
      EVNV   = .FALSE.
      BAKQ_8 = BMISS
      BAKV_8 = BMISS
      TROP   = .FALSE.

C  GET DEWPOINT TEMPERATURE AND CURRENT T,Q QUALITY MARKERS
C  --------------------------------------------------------

      CALL UFBINT(-IUNITP,TDP_8,1,255,NLTD,'TDO')
      CALL UFBINT(-IUNITP,QQM_8,1,255,NLQQ,'QQM')
      CALL UFBINT(-IUNITP,TQM_8,1,255,NLTQ,'TQM')
      IF(SUBSET.NE.'RASSDA  ') THEN
         IF(NLTD.EQ.0) RETURN
         IF(NLQQ.EQ.0) RETURN
      END IF
      IF(NLTQ.EQ.0) RETURN
      IF(SUBSET.NE.'RASSDA  ') THEN
         IF(NLTD.NE.NLEV) THEN
            PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN08 - NLTD .NE. NLEV - ",
     $       "STOP 61")'
            CALL ERREXIT(61)
         END IF
         IF(NLQQ.NE.NLEV) THEN
            PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN08 - NLQQ .NE. NLEV - ",
     $       "STOP 63")'
            CALL ERREXIT(63)
         END IF
      END IF
      IF(NLTQ.NE.NLEV) THEN
         PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN08 - NLTQ .NE. NLEV - STOP ",
     $    "62")'
         CALL ERREXIT(62)
      END IF

C  COMPUTE VIRTUAL TEMPERATURE AND SPECIFIC HUMIDITY USING REPORTED DEWP
C  ---------------------------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV
         POB = OBS_8(1,L)
         TDO = TDP_8(L)
         TOB = OBS_8(3,L)
         CAT = OBS_8(12,L)
         IF(DOVTMP) THEN
            IF(SUBSET.EQ.'RASSDA  ') THEN
               IF(TOB.LT.BMISS) THEN
                  BAKV_8(1,L) = TOB
                  BAKV_8(2,L) = TQM_8(L)
                  BAKV_8(3,L) = IVTCD
                  BAKV_8(4,L) = 3
                  EVNV = .TRUE.
                  CYCLE
               END IF
            END IF
         END IF
         IF(POB.LT.BMISS .AND. TOB.LT.BMISS
     $                   .AND. TDO.LT.BMISS) THEN
            IF(QQM_8(L).GT.3) THEN
C  Don't update q or calculate Tv if bad moisture obs fails sanity check
cdak           IF(TDO.LT.-103.15 .OR. TDO.GT.46.83 .OR. POB.LT.0.1 .OR.
cdak $          POB.GT.1100.)
cdak $ print *, '&&& bad QM fails sanity check'
               IF(TDO.LT.-103.15 .OR. TDO.GT.46.83 .OR. POB.LT.0.1 .OR.
     $          POB.GT.1100.)  CYCLE
            ENDIF
            QOB = QS(TDO+273.16,POB)
            BAKQ_8(1,L) = QOB*1E6
            BAKQ_8(2,L) = QQM_8(L)  ! Moist qm same as before for
                                    !  re-calc. q
            BAKQ_8(3,L) = IVTCD
            BAKQ_8(4,L) = 0     ! Re-calc. q gets unique reason code 0
            EVNQ = .TRUE.
C  If message type ADPUPA, test this level to see if at or above trop
C   (trop must be above 500 mb to pass test; if no trop level found
C   assume it's at 80 mb)
C  Don't calculate Tv on this level if at or above trop (doesn't affect
C   q calculation)
            TROP = (SUBSET.EQ.'ADPUPA  ' .AND.
     $       ((CAT.EQ.5 .AND. POB.LT.500.) .OR. POB.LT. 80. .OR. TROP))
            IF(DOVTMP .AND. .NOT.TROP) THEN
               BAKV_8(1,L) = (TOB+273.16)*(1.+.61*QOB)-273.16
               BAKV_8(3,L) = IVTCD
               IF(SUBSET.EQ.'ADPUPA  ') THEN
C  Message type ADPUPA comes here
                  IF(QQM_8(L).LT.4 .OR. TQM_8(L).EQ.0 .OR.
     $             TQM_8(L).GT.3 .OR. POB.LE.700.) THEN
                     BAKV_8(2,L) = TQM_8(L) ! Tv qm same as for T when
                                            !  q ok
                     BAKV_8(4,L) = 0    ! Tv gets unique reason code 0
                  ELSE
                     BAKV_8(2,L) = 3    !Tv qm susp for bad moist below
                                        ! 700 mb
                     BAKV_8(4,L) = 6 !Tv gets unique reason code 6
                  ENDIF
               ELSE
C  All other message types come here
                  IF(QQM_8(L).LT.4) THEN
                     BAKV_8(2,L) = TQM_8(L) ! Tv qm same as for T when
                                            !  q ok
                     BAKV_8(4,L) = 0    ! Tv gets unique reason code 0
                  ELSE
cdak  print *, '%%% process tvirt on lvl ',l,' for bad QQM case'
                     BAKV_8(2,L) = 8 ! Tv qm bad for bad moist
                     BAKV_8(4,L) = 2 ! Tv gets unique reason code 2
                  ENDIF
               ENDIF
               EVNV = .TRUE.
            ENDIF
         ENDIF
      ENDDO
      ENDIF

C  ENCODE EVENTS INTO REPORT
C  -------------------------

      IF(NLEV.GT.0)  THEN
         IF(EVNQ) CALL UFBINT(IUNITP,BAKQ_8,4,NLEV,IRET,EVNSTQ)
         IF(EVNV) CALL UFBINT(IUNITP,BAKV_8,4,NLEV,IRET,EVNSTV)
      ENDIF

      RETURN
      END
C#######################
C#######################
C#######################
C#######################
C#######################
C#######################
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN10(IUNITF,IDATEP) ! FORMERLY SUBROUTINE GESRES
 
      COMMON /CGBEVFF/IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,IDVC,SL(100),
     x     SI(101)
      COMMON /CGBEVHH/ JCAP,JCAP1,JCAP2,JCAP1X2,MDIMA,MDIMB,MDIMC

      DIMENSION  IDATE(8,2),JDATE(8,2),KDATE(8,2),IUNITF(2),FHR(2),
     $           KINDX(2)
 
      DIMENSION HEADR2(226,2)

      REAL RINC(5)

      CHARACTER*6 COORD(2)

      DATA COORD /'SIGMA ','HYBRID'/

      IF(MOD(MOD(IDATEP,100),3).EQ.0)  THEN
         KFILES = 1
         KINDX = 0
         PRINT 331, MOD(IDATEP,100)
  331    FORMAT(/' --> GBLEVENTS_CDAS: THE PREPBUFR CENTER HOUR (',I2.2,
     $    ') IS A MULTIPLE OF 3 - ONLY ONE GLOBAL SIGMA FILE IS READ,'/
     $    21X,'NO INTERPOLATION OF SPECTRAL COEFFICIENTS IS PERFORMED'/)
      ELSE
         KFILES = 2
         KINDX(1) = MOD(MOD(IDATEP,100),3)
         KINDX(2) = KINDX(1) - 3
         PRINT 332, MOD(IDATEP,100)
  332    FORMAT(/' --> GBLEVENTS_CDAS: THE PREPBUFR CENTER HOUR (',I2.2,
     $    ') IS NOT A MULTIPLE OF 3 - TWO SPANNING GLOBAL SIGMA FILES'/
     $    21X,'ARE READ AND THE SPECTRAL COEFFICIENTS ARE INTERPOLATED',
     $    ' TO THE PREPBUFR CENTER TIME'/)
      END IF

C  GET VALID-TIME DATE OF SIGMA FILE(S), ALSO READ HEADERS
C  -------------------------------------------------------

      JFILE = 0
      RINC  = 0
      DO IFILE=1,KFILES
         JFILE = IFILE
         REWIND IUNITF(IFILE)
         READ(IUNITF(IFILE),ERR=900) DUMMY
         IDATE(:,IFILE) = 0
         READ(IUNITF(IFILE),END=800,ERR=800) FHR(IFILE),idate(5,IFILE),
     $    idate(2,IFILE),idate(3,IFILE),idate(1,IFILE),HEADR2(:,IFILE)
         IHEADR2_SIZE = 226
cppppp
      print *
      print *, '##GBLEVENTS_CDAS/CGBLEVN10 - Guess file has a 226 word',
     $ ' header'
      print *
cppppp
         GO TO 801
  800    CONTINUE
         REWIND IUNITF(IFILE)
         READ(IUNITF(IFILE),ERR=900) DUMMY
         IDATE(:,IFILE) = 0
         READ(IUNITF(IFILE),END=900,ERR=900) FHR(IFILE),idate(5,IFILE),
     $    idate(2,IFILE),idate(3,IFILE),idate(1,IFILE),
     $    HEADR2(1:207,IFILE)
         IHEADR2_SIZE = 207
cppppp
      print *
      print *, '##GBLEVENTS_CDAS/CGBLEVN10 - Guess file has a 207 word',
     $ ' header'
      print *, '                           - most likely a CDAS sges ',
     $ 'file'
      print *
cppppp
  801    CONTINUE
         IF(IDATE(1,IFILE).LT.100)  THEN

C IF 2-DIGIT YEAR FOUND IN GLOBAL SIMGA FILE INITIAL DATE
C  (IDATE(1,IFILE)), MUST USE "WINDOWING" TECHNIQUE TO CREATE A 4-DIGIT
C  YEAR (NOTE: THE T170 IMPLEMENTATION IN JUNE 1998 WAS TO INCLUDE THE
C  WRITING OF A 4-DIGIT YEAR HERE.  PRIOR TO THIS, THE YEAR HERE WAS
C  2-DIGIT.)

            PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10 - 2-DIGIT YEAR FOUND ",
     $       "IN GLOBAL SIGMA FILE ",I0,"; INITIAL DATE (YEAR IS: ",I0,
     $       ") - USE WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT YEAR")',
     $       IFILE,idate(1,IFILE)
C IF IDATE=41~99 THEN IDATE=1941~1999
C IF IDATE=00~40 THEN IDATE=2000~2040
            IF(IDATE(1,IFILE).GT.40)  THEN
               IDATE(1,IFILE) = 1900 + IDATE(1,IFILE)
            ELSE
               IDATE(1,IFILE) = 2000 + IDATE(1,IFILE)
            ENDIF
            PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10 - CORRECTED 4-DIGIT ",
     $       "YEAR IS NOW: ",I0)', IDATE(1,IFILE)
         ENDIF
         RINC(2) = ANINT(FHR(IFILE))
         CALL W3MOVDAT(RINC,IDATE(:,IFILE),JDATE(:,IFILE))
         PRINT 1, IFILE,ANINT(FHR(IFILE)),(IDATE(II,IFILE),II=1,3),
     $    IDATE(5,IFILE),(JDATE(II,IFILE),II=1,3),JDATE(5,IFILE)
    1    FORMAT(' --> GBLEVENTS_CDAS: GLOBAL SIGMA FILE',I2,' HERE IS ',
     $    'A ',F5.1,' HOUR FORECAST FROM ',I5.4,3I3.2,' VALID AT ',I5.4,
     $    3I3.2)
         KDATE(:,IFILE) = JDATE(:,IFILE)
         IF(KFILES.EQ.2) THEN
            RINC(2) = REAL(KINDX(IFILE))
            CALL W3MOVDAT(RINC,JDATE(:,IFILE),KDATE(:,IFILE))
         ENDIF
         IDATGS_COR = (KDATE(1,IFILE) * 1000000) + (KDATE(2,IFILE) *
     $    10000) + (KDATE(3,IFILE) * 100) + KDATE(5,IFILE)

C  VALID DATES MUST MATCH
C  ----------------------

         IF(IDATEP.NE.IDATGS_COR)  GO TO 901

      ENDDO

      IF(KFILES.EQ.2)  THEN

C  IF THERE ARE TWO SIGMA FILES, THEIR HEADERS MUST MATCH
C  -------------------------------------------------------

         JNDEX = 0
         DO  INDEX=1,IHEADR2_SIZE
            JNDEX = INDEX
            IF(HEADR2(INDEX,1).NE.HEADR2(INDEX,2)) GO TO 904
         ENDDO
      ENDIF

C  EXTRACT HEADER INFO
C  -------------------
 
      JCAP  = HEADR2(202,1)
      KMAX  = HEADR2(203,1)
      IF(IHEADR2_SIZE.EQ.226) THEN
         IDVC  = HEADR2(220,1)
      ELSE
         IDVC=0
      END IF
      kmaxs = 2*kmax+2

      if(idvc.eq.0)  idvc = 1  ! Reset IDVC=0 to 1 (sigma coord.)
      IF(IDVC.NE.1.AND.IDVC.NE.2) THEN
         PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10: INVALID VERT COORD ID ",
     $    "(=",I0,"), DEFAULTING TO SIGMA COORD, RESETTING IDVC = 1")',
     $    IDVC
        IDVC = 1
      END IF

      IF(KMAX.GT.100) GO TO 902
 
      IF(IDVC.EQ.1) THEN

C  SIGMA COORDINATE COEFFICIENTS
C  -----------------------------

         DO  L = 1,KMAX
            SI(L) = HEADR2(L,1)
            SL(L) = HEADR2(KMAX+1+L,1)
         ENDDO
         SI(KMAX+1) = HEADR2(KMAX+1,1)
      ELSEIF(IDVC.EQ.2) THEN

C  HYBRID COORDINATE COEFFICIENTS
C  ------------------------------

         DO  L = 1,KMAX+1

C  Convert AK HYBRID coeff for use in HPA
C  --------------------------------------

            SI(L) = (0.01)*HEADR2(L,1)
            SL(L) = HEADR2(KMAX+1+L,1)
         END DO
      END IF

C  DEFINE THE OTHER RESOLUTION PARAMETERS
C  --------------------------------------
 
      JCAP1   = JCAP+1
      JCAP2   = JCAP+2
      JCAP1X2 = JCAP1*2
      MDIMA   = JCAP1*JCAP2
      MDIMB   = MDIMA/2+JCAP1
      MDIMC   = MDIMB*2
      IMAX    = 384
      JMAX    = IMAX/2+1
 
cdak  IF(IMAX.LT.JCAP1X2) GO TO 903   ! commented out 9/27/01
 
      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX
 
      PRINT 2, JCAP,KMAX,kmaxs,DLAT,DLON,COORD(IDVC)
    2 FORMAT(/' --> GBLEVENTS_CDAS: GLOBAL MODEL SPECS: T',I3,' ',I3,
     $ ' LEVELS ',I3,' SCALARS -------> ',F5.2,' X ',F5.2,' VERT. ',
     $ 'COORD: ',A)
 
      CALL CGBLEVN09(IUNITF,KINDX)
 
      RETURN

  900 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10 - BAD OR MISSING GLOBAL ",
     $ "SIGMA FILE ",I0," - STOP 67")', JFILE
      CALL ERREXIT(67)
  901 CONTINUE
      PRINT 9901, JFILE,(JDATE(II,JFILE),II=1,3),JDATE(5,JFILE),IDATEP
 9901 FORMAT(/' ##GBLEVENTS_CDAS/CGBLEVN10 - SIGMA FILE',I2,' DATE (',
     $ I4.4,3(I2.2),'), DOES NOT MATCH -OR SPAN- PREPBUFR FILE CENTER ',
     $ 'DATE (',I10,') -STOP 68'/)
      CALL ERREXIT(68)
  902 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10 - KMAX TOO BIG = ",I0," - ",
     $ "UNABLE TO TRANSFORM GLOBAL SIGMA FILE(S) - STOP 69")', KMAX
      CALL ERREXIT(69)
  903 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10 - IMAX TOO SMALL = ",I0," - ",
     $ "UNABLE TO TRANSFORM GLOBAL SIGMA FILE(S) - STOP 70")', IMAX
      CALL ERREXIT(70)
  904 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN10 - HEADER INDEX ",I0," FOR ",
     $ "SIGMA FILE 1 (=",F8.3,") DOES NOT MATCH THAT FOR SIGMA FILE 2 ",
     $ "(=",F8.3," - STOP 71")', JNDEX,HEADR2(JNDEX,1),HEADR2(JNDEX,2)
      CALL ERREXIT(71)
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN09(IUNITF,KINDX)
                                         ! FORMERLY SUBROUTINE COF2GRD
 
      use sp_mod

      parameter (PI180=.0174532)

      COMMON /CGBEVFF/IMAX,JMAX,KMAX,kmaxs,DLAT,DLON,IDVC,SL(100),
     x     SI(101)
      COMMON /CGBEVHH/ JCAP,JCAP1,JCAP2,JCAP1X2,MDIMA,MDIMB,MDIMC
 
      DIMENSION IUNITF(2),KINDX(2)

C Changes below allocates arrays from "heap" rather than "stack"
C     real      cofs(mdima,kmaxs), cofv(mdima,kmax,2)
C     real      cofs_f(mdima,kmaxs,2), cofv_f(mdima,kmax,2,2)
C     real      grds(IMAX,JMAX,kmaxs), grdv(IMAX,JMAX,kmax,2)
C     real      grd2(IMAX,JMAX,2)
      real,allocatable:: cofs(:,:), cofv(:,:,:)
      real,allocatable:: cofs_f(:,:,:), cofv_f(:,:,:,:)
      real,allocatable:: grds(:,:,:), grdv(:,:,:,:)
      real,allocatable:: grd2(:,:,:)

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C USAGE:    CALL SPTEZM(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,WAVE,GRID,IDIR)
C   INPUT ARGUMENTS:
C     IROMB    - INTEGER SPECTRAL DOMAIN SHAPE
C                (0 FOR TRIANGULAR, 1 FOR RHOMBOIDAL)
C     MAXWV    - INTEGER SPECTRAL TRUNCATION
C     IDRT     - INTEGER GRID IDENTIFIER
C                (IDRT=4 FOR GAUSSIAN GRID,
C                 IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C                 IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
C     IMAX     - INTEGER EVEN NUMBER OF LONGITUDES
C     JMAX     - INTEGER NUMBER OF LATITUDES
C     KMAX     - INTEGER NUMBER OF FIELDS TO TRANSFORM
C     WAVE     - REAL (2*MX,KMAX) WAVE FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRID     - REAL (IMAX,JMAX,KMAX) GRID FIELD (E->W,N->S) IF IDIR<0
C     IDIR     - INTEGER TRANSFORM FLAG
C                (IDIR>0 FOR WAVE TO GRID, IDIR<0 FOR GRID TO WAVE)
C   OUTPUT ARGUMENTS:
C     WAVE     - REAL (2*MX,KMAX) WAVE FIELD IF IDIR<0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRID     - REAL (IMAX,JMAX,KMAX) GRID FIELD (E->W,N->S) IF IDIR>0


C USAGE:    CALL SPTEZMV(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
C    &                   WAVED,WAVEZ,GRIDU,GRIDV,IDIR)
C   INPUT ARGUMENTS:
C     WAVED    - REAL (2*MX,KMAX) WAVE DIVERGENCE FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     WAVEZ    - REAL (2*MX,KMAX) WAVE VORTICITY FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRIDU    - REAL (IMAX,JMAX,KMAX) GRID U-WIND (E->W,N->S) IF IDIR<0
C     GRIDV    - REAL (IMAX,JMAX,KMAX) GRID V-WIND (E->W,N->S) IF IDIR<0
C   OUTPUT ARGUMENTS:
C     WAVED    - REAL (2*MX,KMAX) WAVE DIVERGENCE FIELD IF IDIR<0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     WAVEZ    - REAL (2*MX,KMAX) WAVE VORTICITY FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRIDU    - REAL (IMAX,JMAX,KMAX) GRID U-WIND (E->W,N->S) IF IDIR>0
C     GRIDV    - REAL (IMAX,JMAX,KMAX) GRID V-WIND (E->W,N->S) IF IDIR>0

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      allocate (cofs(mdima,kmaxs), cofv(mdima,kmax,2))
      allocate (cofs_f(mdima,kmaxs,2), cofv_f(mdima,kmax,2,2))
      allocate (grds(IMAX,JMAX,kmaxs), grdv(IMAX,JMAX,kmax,2))
      allocate (grd2(IMAX,JMAX,2))

      IROMB=0
      MAXWV=JCAP
      IDRT=0
      IDIR=1


      IF(KINDX(1).EQ.0)  THEN
         KFILES = 1
      ELSE
         KFILES = 2
      ENDIF

      DO IFILE=1,KFILES
         ns=1
         DO I=1,5
            if (i.ne.4) then
                LEV = KMAX
                IF(I.LE.2) LEV = 1
                DO L=1,LEV
                  READ(IUNITF(IFILE),END=900,ERR=901)
     $             (COFS_f(II,NS,IFILE),II=1,MDIMA)
                  ns=ns+1
                enddo
            else
                NRD = 2
                DO L=1,LEV
                   DO K=1,NRD
                      READ(IUNITF(IFILE),END=900,ERR=901)
     $                 (COFV_f(II,L,K,IFILE),II=1,MDIMA)
                   ENDDO
                enddo
             endif
         enddo
      ENDDO

      IF(KFILES.EQ.1)  THEN
         DO I = 1,MDIMA
            COFS(I,1:KMAXS) = COFS_f(I,1:KMAXS,1)
            COFV(I,1:KMAX,1:2) = COFV_f(I,1:KMAX,1:2,1)
         ENDDO

      ELSE
         COFS=
     $   ((ABS(KINDX(2))*COFS_f(:,:,1))  +(KINDX(1)*COFS_f(:,:,2)))/3.
         COFV=
     $   ((ABS(KINDX(2))*COFV_f(:,:,:,1))+(KINDX(1)*COFV_f(:,:,:,2)))/3.
      ENDIF

      CALL SPTEZM(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAXS,COFS,GRDS,IDIR)
      CALL SPTEZMV(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
     &         COFV(1,1,1),COFV(1,1,2),GRDV(1,1,1,1),GRDV(1,1,1,2),IDIR)
      ns=1
      DO I=1,5
         if (i.ne.4) then
             LEV = KMAX
             IF(I.LE.2) LEV = 1
             DO L=1,LEV
                 call cgblevn11(imax,jmax,grds(1,1,ns))
                 if (ns.eq.2) then
                     DO J=1,JMAX
                         DO II=1,IMAX
                             GRDS(II,J,NS) = 10.*EXP(GRDS(II,J,NS))
                         ENDDO
                     ENDDO
                 endif
                 !print'(2i5,2e13.6)',i,l,grds(1,1,ns),GRDs(1,jmax/2,ns)
                 CALL CGBLEVN05(GRDS(1,1,NS),I,L)
                 ns=ns+1
             enddo
         else
             NRD = 2
             DO L=1,LEV
                DO K=1,NRD
                    call cgblevn11(imax,jmax,grdv(1,1,l,k))
                    do J=1,jmax
                        grd2(1:imax,j,k)=grdv(1:imax,j,l,k)
                    enddo
                enddo
                !print'(2i5,2e13.6)',i,l,grd2(1,1,1),GRD2(1,jmax/2,1)
                CALL CGBLEVN05(GRD2,I,L)
             enddo
         endif
      enddo
 
      deallocate (cofs, cofv)
      deallocate (cofs_f, cofv_f)
      deallocate (grds, grdv)
      deallocate (grd2)

      RETURN

  900 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN09 - EOF READING GLOBAL SIGMA ",
     $ "FILE - UNABLE TO TRANSFORM GLOBAL SIGMA FILE - STOP 64")'
      CALL ERREXIT(64)
  901 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN09 - ERROR READING GLOBAL SIGMA",
     $ " FILE - UNABLE TO TRANSFORM GLOBAL SIGMA FILE - STOP 65")'
      CALL ERREXIT(65)
  902 CONTINUE
      PRINT'(" ##GBLEVENTS_CDAS/CGBLEVN09 - IDIM NOT FACTORABLE - ",
     $ "UNABLE TO TRANSFORM GLOBAL SIGMA FILE - STOP 66")'
      CALL ERREXIT(66)
      END
C***********************************************************************
C***********************************************************************
      subroutine cgblevn11(imax,jmax,grid)! formerly subroutine n_s_swap
      real grid(imax,jmax)
      real temp (imax)

      do j=1,jmax/2
          jj=jmax-j+1
          temp(1:imax)   =grid(1:imax,j)
          grid(1:imax,j) =grid(1:imax,jj)
          grid(1:imax,jj)=temp(1:imax)
      enddo
      return
      end
C####################
C####################
C####################
C####################
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                  C
C ==============================================================   C
C | DESCRIPTION | NAME   | BITS | MAX VALUE  | DIMENSIONS      |   C
C |=============*========*======*============*=================|   C
C | ZSG01_C     | ZSG01_C| WORD | REAL       | 384,193         |   C
C |-------------+--------+------+------------+-----------------|   C
C | PSG01_C     | PSG01_C| WORD | REAL       | 384,193         |   C
C |-------------+--------+------+------------+-----------------|   C
C | TG01_C      | TG01_C | WORD | REAL       | 384,193,64      |   C
C |-------------+--------+------+------------+-----------------|   C
C | UG01_C      | UG01_C | WORD | REAL       | 384,193,64      |   C
C |-------------+--------+------+------------+-----------------|   C
C | VG01_C      | VG01_C | WORD | REAL       | 384,193,64      |   C
C |-------------+--------+------+------------+-----------------|   C
C | QG01_C      | QG01_C | WORD | REAL       | 384,193,64      |   C
C ==============^========^======^============^==================   C
C                                                                  C
C***********************************************************************
C***********************************************************************
      FUNCTION ZSG01_C(I,J) ! FORMERLY FUNCTION ZS
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      COMMON /CGBEVJJ/IAR_8(IM,JM)
      REAL(8) IAR_8
      REAL ZSG01_C
      ZSG01_C = IAR_8(I,J)
      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN12(I,J,V) ! FORMERLY SUBROUTINE ZSP
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      COMMON /CGBEVJJ/IAR_8(IM,JM)
      REAL(8) IAR_8
      REAL V
      IAR_8(I,J) = V
      RETURN
      END
C***********************************************************************
C***********************************************************************
      FUNCTION PSG01_C(I,J) ! FORMERLY FUNCTION PS
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      COMMON /CGBEVKK/IAR_8(IM,JM)
      REAL(8) IAR_8
      REAL PSG01_C
      PSG01_C = IAR_8(I,J)
      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN13(I,J,V) ! FORMERLY SUBROUTINE PSP
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      COMMON /CGBEVKK/IAR_8(IM,JM)
      REAL(8) IAR_8
      REAL V
      IAR_8(I,J) = V
      RETURN
      END
C***********************************************************************
C***********************************************************************
      FUNCTION TG01_C(I,J,K) ! FORMERLY FUNCTION T
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVLL/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL TG01_C
      TG01_C = IAR_8(I,J,K)
      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN14(I,J,K,V) ! FORMERLY SUBROUTINE TP
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVLL/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL V
      IAR_8(I,J,K) = V
      RETURN
      END
C***********************************************************************
C***********************************************************************
      FUNCTION UG01_C(I,J,K) ! FORMERLY FUNCTION U
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVMM/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL UG01_C
      UG01_C = IAR_8(I,J,K)
      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN15(I,J,K,V) ! FORMERLY SUBROUTINE UP
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVMM/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL V
      IAR_8(I,J,K) = V
      RETURN
      END
C***********************************************************************
C***********************************************************************
      FUNCTION VG01_C(I,J,K) ! FORMERLY FUNCTION V
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVNN/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL VG01_C
      VG01_C = IAR_8(I,J,K)
      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN16(I,J,K,V) ! FORMERLY SUBROUTINE VP
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVNN/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL V
      IAR_8(I,J,K) = V
      RETURN
      END
C***********************************************************************
C***********************************************************************
      FUNCTION QG01_C(I,J,K) ! FORMERLY FUNCTION Q
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVOO/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL QG01_C
      QG01_C = IAR_8(I,J,K)
      RETURN
      END
C***********************************************************************
C***********************************************************************
      SUBROUTINE CGBLEVN17(I,J,K,V) ! FORMERLY SUBROUTINE QP
      PARAMETER (IM = 384)
      PARAMETER (JM = 193)
      PARAMETER (KM = 64)
      COMMON /CGBEVOO/IAR_8(IM,JM,KM)
      REAL(8) IAR_8
      REAL V
      IAR_8(I,J,K) = V
      RETURN
      END

ccc  output lead-time in minutes  ccccccccccccccccccccccccccc
      program leadtime
      parameter (nt=81)
      integer time(nt)
      integer maxhrs,dthrs
      namelist/timein/maxhrs,dthrs

      read (5,NML=timein,END=201)
  201 continue
      print *,' '
      print *,'*---------------------------------------------*'
      print *,' '
      print *,' +++ Top of LEADTIME +++ '
      print *,' '
      print *,'After LEADTIME namelist read, input forecast max-hours= '
     &       ,maxhrs
      print *,'       input forecast hour interval= ',dthrs

c      open (10,file="tracker_leadtime")

      IDT=dthrs*60
      nhrs=maxhrs/dthrs

      do k=1,nhrs+1
        time(k)= (k-1)*IDT
        write(10,102) k, time(k)
      enddo

c      close(10)

102   format(2x,i2,1x,i5)
      stop
      end

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      SUBROUTINE SELECTFILE(IUNITF,INPTYP)
      
      USE SIGIO_MODULE
      USE SIGIO_R_MODULE
      use nemsio_module, only: nemsio_gfile,nemsio_init, nemsio_open,nemsio_close
      use netcdf

      IMPLICIT NONE

      CHARACTER*20 CFILE
      INTEGER*4 IRET,JRET,IUNIT,ncid
      INTEGER*4 IUNITF, INPTYP
      TYPE(SIGIO_HEAD) :: CHEAD
      TYPE(NEMSIO_GFILE) :: GFILE

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      WRITE(CFILE,'("fort.",I2.2)') IUNITF
      inptyp=0
      print*

! check for netcdf file

      iret = nf90_open(trim(cfile),nf90_nowrite,ncid)
      if (iret == 0) then
         print *,' ===> GFS FCST/ANAL INPUT IS NETCDF'
         inptyp=3 ; return
      endif 

! check for sigio file

      CALL SIGIO_RROPEN(IUNITF,CFILE,IRET)
      CALL SIGIO_SRHEAD(IUNITF,CHEAD,JRET)
      IF(IRET == 0 .AND. JRET == 0) THEN
         print *,' ===> GLOBAL FCST/ANAL INPUT IS SIGIO'
         CALL SIGIO_SCLOSE(IUNITF,IRET)
         inptyp=1 ; return
      endif

! check for nemsio file (this has a bomb in it - put it last)

      CALL NEMSIO_OPEN(GFILE,trim(CFILE),'read',IRET=IRET)
      IF(IRET == 0) THEN
         CALL NEMSIO_CLOSE(GFILE,IRET=IRET)
         print *,' ===> GFS FCST/ANAL INPUT IS NEMSIO'
         inptyp=2 ; return
      ENDIF

      if(inptyp==0) call bort('selecetfile cannot id filetype')

      RETURN
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C  
C MAIN PROGRAM:  BUILD
C   PRGMMR: Bill FACEY        ORG: WX12        DATE: 2003-04-9
C
C ABSTRACT: PROGRAM READS DATA COUNTS FROM THE 00Z, 06Z, 12Z, AND 
C           18Z GDAS CREATED BY THE SCRIPTS 18Z.  PROGRAM USES THIS 
C           DATA TO CREATE MONTHLY STATISTICS FOR INPUT TO A
C           SCRIPT THAT BUILDS AN HTML FILE.  THE STATISTICS ARE 
C           BASED UPON DOCUMENTATION THAT CAN BE FOUND AT
C           http://www.emc.ncep.noaa.gov/mmb/papers/keyser/
C           data dumping.doc/
C           User Guide to Interpreting Data Dump Counts.html 
C
C PROGRAM HISTORY LOG:
C   03-04-09  bill facey
C
C USAGE:
C   INPUT FILES:
C     UNIT 10  - 00Z DATA COUNTS FROM RUNSTAT.SH
C     UNIT 11  - 06Z DATA COUNTS FROM RUNSTAT.SH
C     UNIT 13  - 12Z DATA COUNTS FROM RUNSTAT.SH
C     UNIT 14  - 18Z DATA COUNTS FROM RUNSTAT.SH
C
C   OUTPUT FILES: 
C     UNIT 50  - MONTHLY STATISTICS.
C     UNIT 06  - UNIT 6 (STANDARD PRINTFILE)
C
C   WORK FILES:  (INCLUDING SCRATCH FILES)
C     UNIT XX  - UNITS 80 THRU 99 
C
C   SUBPROGRAMS CALLED: (LIST ALL CALLED FROM ANYWHERE IN CODES)
C     UNIQUE:    - NONE
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C
C REMARKS: NONE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C   MACHINE:  IBM SP
C
C$$$
          INTEGER DUMP
          REAL SYNOP,METAR,SHIPS,DBUOY,MBUOY,LCMAN,TIDEG,
     1    MSLPB,RAOBF,RAOBM,RAOBS,DROPW,PIBAL,PRFL1,PRFL2,NXRDW,GEOST,
     1    ATOVS,AIREP,PIREP,ASDAR,ACARS,RECCO,INFUS,VISUS,PTRUS,
     1    INFJA,VISJA,WVIJA,INFEU,OSBUV,SSMIT,SSMIP,
     1    TRMM,TRMSO,SSMIN,QKSCA,QKSRE,HIRS2,MSU,AMSUA,AMSUB,HIRS3,
     1    GEOIM,SSMIC
          DATA SYNOP,METAR,SHIPS,DBUOY,MBUOY,LCMAN,TIDEG,
     1    MSLPB,RAOBF,RAOBM,RAOBS,DROPW,PIBAL,PRFL1,PRFL2,NXRDW,GEOST,
     1    ATOVS,AIREP,PIREP,ASDAR,ACARS,RECCO,INFUS,VISUS,PTRUS,
     1    INFJA,VISJA,WVIJA,INFEU,OSBUV,SSMIT,SSMIP,
     1    TRMM,TRMSO,SSMIN,QKSCA,QKSRE,HIRS2,MSU,AMSUA,AMSUB,HIRS3,
     1    GEOIM,SSMIC /45*0./
          INTEGER IUNIT(4)
          INTEGER IVAL(6,59)
          DATA IUNIT/10,11,12,13/
          NAMELIST/DATA/SYNOP,METAR,SHIPS,DBUOY,MBUOY,LCMAN,TIDEG,
     1    MSLPB,RAOBF,RAOBM,RAOBS,DROPW,PIBAL,PRFL1,PRFL2,NXRDW,GEOST,
     1    ATOVS,AIREP,PIREP,ASDAR,ACARS,RECCO,INFUS,VISUS,PTRUS,
     1    INFJA,VISJA,WVIJA,INFEU,OSBUV,SSMIT,SSMIP,
     1    TRMM,TRMSO,SSMIN,QKSCA,QKSRE,HIRS2,MSU,AMSUA,AMSUB,HIRS3,
     1    GEOIM,SSMIC
          CHARACTER*10 CHAROUT(6,59)
          CHARACTER*1 EQUAL
          DATA EQUAL /'='/
          CHARACTER*10 WORDOUT
          DATA CHAROUT/ 
     1    'syn00z=','syn06z=','syn12z=','syn18z=','syntot=','syninp=',
     2    'metar00z=','metar06z=','metar12z=','metar18z=','metartot=',
     2    'metarinp=',
     2    'lz00z=','lz06z=','lz12z=','lz18z=','lztot=','lzinp=',
     2    'ship00z=','ship06z=','ship12z=','ship18z=','shiptot=',
     2    'shipinp=',
     2    'dbuoy00z=','dbuoy06z=','dbuoy12z=','dbuoy18z=','dbuoytot=',
     2    'dbuoyinp=',
     2    'mbuoy00z=','mbuoy06z=','mbuoy12z=','mbuoy18z=','mbuoytot=',
     2    'mbuoyinp=',
     2    'cman00z=','cman06z=','cman12z=','cman18z=','cmantot=',
     2    'cmaninp=',
     2    'tideg00z=','tideg06z=','tideg12z=','tideg18z=','tidegtot=',
     2    'tideginp=',
     2    'mslpb00z=','mslpb06z=','mslpb12z=','mslpb18z=','mslpbtot=',
     2    ' ',
     2    'mar00z=','mar06z=','mar12z=','mar18z=','martot=','marinp=',
     2    'fxr00z=','fxr06z=','fxr12z=','fxr18z=','fxrtot=','fxrinp=',
     2    'mlr00z=','mlr06z=','mlr12z=','mlr18z=','mlrtot=','mlrinp=',
     2    'shp00z=','shp06z=','shp12z=','shp18z=','shptot=','shpinp=',
     2    'drop00z=','drop06z=','drop12z=','drop18z=','droptot=',
     2    'dropinp=',
     2    'pibal00z=','pibal06z=','pibal12z=','pibal18z=','pibaltot=',
     2    'pibalinp=',
     2    'prof00z=','prof06z=','prof12z=','prof18z=','proftot=',
     2    'profinp=',
     2    'nexrd00z=','nexrd06z=','nexrd12z=','nexrd18z=','nexrdtot=',
     2    'nexrdinp=',
     2    'lsnd00z=','lsnd06z=','lsnd12z=','lsnd18z=','lsndtot=',
     2    'lsndinp=',
     2    'air00z=','air06z=','air12z=','air18z=','airtot=','airinp=',
     2    'pir00z=','pir06z=','pir12z=','pir18z=','pirtot=','pirinp=',
     2    'amdr00z=','amdr06z=','amdr12z=','amdr18z=','amdrtot=',
     2    'amdrinp=',
     2    'acar00z=','acar06z=','acar12z=','acar18z=','acartot=',
     2    'acarinp=',
     2    'rec00z=','rec06z=','rec12z=','rec18z=','rectot=','recinp=',
     2    'acft00z=','acft06z=','acft12z=','acft18z=','acfttot=',
     2    'acftinp=',
     2    'nons00z=','nons06z=','nons12z=','nons18z=','nonstot=',
     2    'nonsinp=',
     2    'goes00z=','goes06z=','goes12z=','goes18z=','goestot=',
     2    'goesinp=',
     2    'atov00z=','atov06z=','atov12z=','atov18z=','atovtot=',
     2    ' ',
     2    'oz00z=','oz06z=','oz12z=','oz18z=','oztot=','ozinp=',
     2    'sat00z=','sat06z=','sat12z=','sat18z=','sattot=','satinp=',
     2    'usir00z=','usir06z=','usir12z=','usir18z=','usirtot=',
     2    'usirinp=',
     2    'usvi00z=','usvi06z=','usvi12z=','usvi18z=','usvitot=',
     2    ' ',
     2    'usp300z=','usp306z=','usp312z=','usp318z=','usp3tot=',
     2    'usp3inp=',
     2    'jair00z=','jair06z=','jair12z=','jair18z=','jairtot=',
     2    'jairinp=',
     2    'javi00z=','javi06z=','javi12z=','javi18z=','javitot=',
     2    'javiinp=',
     2    'jawv00z=','jawv06z=','jawv12z=','jawv18z=','jawvtot=',
     2    ' ',
     2    'eur00z=','eur06z=','eur12z=','eur18z=','eurtot=','eurinp=',
     2    'swnd00z=','swnd06z=','swnd12z=','swnd18z=','swndtot=',
     2    'swndinp=',
     2    'ssmp00z=','ssmp06z=','ssmp12z=','ssmp18z=','ssmptot=',' ',
     2    'smps00z=','smps06z=','smps12z=','smps18z=','smpstot=',
     2    'smpsinp=',
     2    'ssmt00z=','ssmt06z=','ssmt12z=','ssmt18z=','ssmttot=',' ',
     2    'ssmn00z=','ssmn06z=','ssmn12z=','ssmn18z=','ssmntot=',' ',
     2    'smns00z=','smns06z=','smns12z=','smns18z=','smnstot=',
     2    'smnsinp=',
     2    'dmsp00z=','dmsp06z=','dmsp12z=','dmsp18z=','dmsptot=',' ',
     2    'dmin00z=','dmin06z=','dmin12z=','dmin18z=','dmintot=',
     2    'dmininp=',
     2    'trm00z=','trm06z=','trm12z=','trm18z=','trmtot=',' ',
     2    'trmso00z=','trmso06z=','trmso12z=','trmso18z=','trmsotot=',
     2    'trmsoinp=',
     2    'qks00z=','qks06z=','qks12z=','qks18z=','qkstot=',' ',
     2    'qksqc00z=','qksqc06z=','qksqc12z=','qksqc18z=','qksqctot=',
     2    'qksqcinp=',
     2    'tsfc00z=','tsfc06z=','tsfc12z=','tsfc18z=','tsfctot=',
     2    ' ',
     2    'ssfc00z=','ssfc06z=','ssfc12z=','ssfc18z=','ssfctot=',
     2    'ssfcinp=',
     2    'hirs200z=','hirs206z=','hirs212z=','hirs218z=','hirs2tot=',
     2    'hirs2inp=',
     2    'hirs300z=','hirs306z=','hirs312z=','hirs318z=','hirs3tot=',
     2    'hirs3inp=',
     2    'msu00z=','msu06z=','msu12z=','msu18z=','msutot=','msuinp=',
     2    'msua00z=','msua06z=','msua12z=','msua18z=','msuatot=',
     2    'msuainp=',
     2    'msub00z=','msub06z=','msub12z=','msub18z=','msubtot=',
     2    'msubinp=',
     2    'geor00z=','geor06z=','geor12z=','geor18z=',
     2    'geortot=','georinp=',
     2    'rsat00z=','rsat06z=','rsat12z=','rsat18z=','rsattot=',
     2    'rsatinp=',
     2    'satusd00z=','satusd06z=','satusd12z=','satusd18z=',
     2    'satusdtot=',' ',
     2    'satinp00z=','satinp06z=','satinp12z=','satinp18z=',
     2    'satinptot=','satinpinp='/
          CHARACTER*10 PERCENT(11)
          DATA PERCENT/'prcntls=','prcntmr=','prcntlsnd=',
     1                 'prcntacft=','prcntnsat=','prcntss=',
     1                 'swndprcnt=','dmspprcnt=','ssfcprcnt=',
     1                 'prcntrad=','prcntsat='/
          DO 20 I=1,4
          LUNIT=IUNIT(i)
C --- READ MONTHLY STATS FOR EACH CYCLE AND STORE IN IVAL.  IVAL HAS 
C     VALUE FOR EACH LINE IN THE TABLE DISPLAYED IN THE HTML FILE.
          READ (LUNIT,DATA)
          IVAL(I,1)=SYNOP+0.5
          IVAL(I,2)=METAR +0.5
          IVAL(I,3)=IVAL(I,1)+IVAL(I,2)
          IVAL(I,4)=SHIPS + 0.5
          IVAL(I,5)=DBUOY + 0.5
          IVAL(I,6)=MBUOY + 0.5
          IVAL(I,7)=LCMAN + 0.5
          IVAL(I,8)=TIDEG + 0.5
          IVAL(I,9)=MSLPB + 0.5
          IVAL(I,10)=IVAL(I,4)+IVAL(I,5)+IVAL(I,6)+IVAL(I,7)+IVAL(I,8)
          IVAL(I,11)=RAOBF + 0.5
          IVAL(I,12)=RAOBM + 0.5
          IVAL(I,13)=RAOBS + 0.5
          IVAL(I,14)=DROPW + 0.5
          IVAL(I,15)=PIBAL + 0.5
          IVAL(I,16)=PRFL1 + PRFL2 + 0.5
          IVAL(I,17)=NXRDW + 0.5
          IVAL(I,18)=IVAL(I,11)+IVAL(I,12)+IVAL(I,13)
     a              +IVAL(I,14)+IVAL(I,15)+IVAL(I,16)+IVAL(I,17)
          IVAL(I,19)=AIREP+0.5
          IVAL(I,20)=PIREP+0.5
          IVAL(I,21)=ASDAR+0.5
          IVAL(I,22)=ACARS+0.5
          IVAL(I,23)=RECCO+0.5
          IVAL(I,24)=IVAL(I,19)+IVAL(I,20)+IVAL(I,21)+IVAL(I,22)
     1              +IVAL(I,23)
          IVAL(I,25)=IVAL(I,3)+IVAL(I,10)+IVAL(I,18)+IVAL(I,24)
          IVAL(I,26)=GEOST + 0.5
          IVAL(I,27)=ATOVS + 0.5
          IVAL(I,28)=OSBUV + 0.5
          IVAL(I,29)=IVAL(I,26)+IVAL(I,27)
          IVAL(I,30)=INFUS+0.5
          IVAL(I,31)=VISUS+0.5
          IVAL(I,32)=PTRUS+0.5
          IVAL(I,33)=INFJA+0.5
          IVAL(I,34)=VISJA+0.5
          IVAL(I,35)=WVIJA+0.5
          IVAL(I,36)=INFEU+0.5
          IVAL(I,37)=IVAL(I,30)+IVAL(I,32)+IVAL(I,33)
     1              + IVAL(I,34)+IVAL(I,35)+IVAL(I,36) 
          IVAL(I,38)=(SSMIP+0.5)*0.66*56
          IVAL(I,39)=SSMIC*0.5+0.5
          IVAL(I,40)=(SSMIT+0.5)*0.66*63
          IVAL(I,41)=(SSMIN+0.5)*0.66*31  
          IVAL(I,42)=(SSMIC+0.5)*0.5
          IVAL(I,43)=IVAL(I,38)+IVAL(I,41)
          IVAL(I,44)=IVAL(I,39)+IVAL(I,42)
          IVAL(I,45)=TRMM+0.5
          IVAL(I,46)=TRMSO+0.5
          IVAL(I,47)=QKSCA+0.5
          IVAL(I,48)=QKSRE+0.5
          IVAL(I,49)=IVAL(I,45)+IVAL(I,47)
          IVAL(I,50)=IVAL(I,46)+IVAL(I,48)
          IVAL(I,51)=HIRS2+0.5
          IVAL(I,52)=HIRS3+0.5
          IVAL(I,53)=MSU+0.5
          IVAL(I,54)=AMSUA+0.5
          IVAL(I,55)=AMSUB+0.5
          IVAL(I,56)=GEOIM+0.5
          IVAL(I,57)=IVAL(I,51)+IVAL(I,52)+IVAL(I,53)+IVAL(I,54)
     1              +IVAL(I,55)+IVAL(I,56)
          IVAL(I,58)=IVAL(I,29)+IVAL(I,37)+IVAL(I,43)+IVAL(I,49)
     1              +IVAL(I,57)
          IVAL(I,59)=IVAL(I,27)+IVAL(I,28)+IVAL(I,37)+IVAL(I,44)
     1              +IVAL(I,50)+IVAL(I,57)
  20      CONTINUE
C --- CREATE COLUMN 5.  THESE ARE THE GROSS TOTALS FOR EACH DATA TYPE.
          DO 30 I=1,59
            IVAL(5,I)=IVAL(1,I)+IVAL(2,I)+IVAL(3,I)+IVAL(4,I)
  30      CONTINUE
C --- CREATE COLUMN 6.  THESE ARE THE ACTUAL AMOUNTS INPUT TO THE
C     ANALYSIS.
           DO 40 I=1,59
            IF(CHAROUT(6,I).NE.' ')THEN
              IVAL(6,I)=IVAL(1,I)+IVAL(2,I)+IVAL(3,I)+IVAL(4,I)
            ENDIF
  40      CONTINUE
C --- THESE LINES DO NOT FOLLOW THE GENERAL RULE AND NEED TO BE 
C     ADJUSTED.
          IVAL(6,10)=IVAL(6,4)+IVAL(6,5)+IVAL(6,6)+IVAL(6,7)+IVAL(6,8)
          IVAL(6,29)=IVAL(6,26)+IVAL(6,28)
          IVAL(6,37)=IVAL(6,30)+IVAL(6,32)+IVAL(6,33)
     1              + IVAL(6,34)+IVAL(6,35)+IVAL(6,36) 
          IVAL(6,59)=IVAL(6,27)+IVAL(6,28)+IVAL(6,37)+IVAL(6,44)
     1              +IVAL(6,50)+IVAL(6,57)
C --- JOIN LABELS AND VALUES AND WRITE OUT.
          DO 50 I=1,59
            WORDOUT=CHAROUT(1,I)
            J=INDEX(WORDOUT,EQUAL)
            WRITE(50,*)WORDOUT(1:J),IVAL(1,I)
            WORDOUT=CHAROUT(2,I)
            J=INDEX(WORDOUT,EQUAL)
            WRITE(50,*)WORDOUT(1:J),IVAL(2,I)
            WORDOUT=CHAROUT(3,I)
            J=INDEX(WORDOUT,EQUAL)
            WRITE(50,*)WORDOUT(1:J),IVAL(3,I)
            WORDOUT=CHAROUT(4,I)
            J=INDEX(WORDOUT,EQUAL)
            WRITE(50,*)WORDOUT(1:J),IVAL(4,I)
            WORDOUT=CHAROUT(5,I)
            J=INDEX(WORDOUT,EQUAL)
            WRITE(50,*)WORDOUT(1:J),IVAL(5,I)
            WORDOUT=CHAROUT(6,I)
            J=INDEX(WORDOUT,EQUAL)
            IF(J.GT.1) THEN
              WRITE(50,*)WORDOUT(1:J),IVAL(6,I)
            ENDIF
  50      continue
C  CALCULATE percents 
          P1=IVAL(6,3)
          print *, 'P1=',P1
          P2=(IVAL(6,24)+IVAL(6,59))
          print *, 'P2=',P2
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(1),EQUAL)
          WRITE(50,99)PERCENT(1)(1:J),PRCNT
          P1=IVAL(6,10)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(2),EQUAL)
          WRITE(50,99)PERCENT(2)(1:J),PRCNT
          P1=IVAL(6,18)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(3),EQUAL)
          WRITE(50,99)PERCENT(3)(1:J),PRCNT
          P1=IVAL(5,24)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(4),EQUAL)
          WRITE(50,99)PERCENT(4)(1:J),PRCNT
          P1=IVAL(6,25)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(5),EQUAL)
          WRITE(50,99)PERCENT(5)(1:J),PRCNT
          P1=IVAL(5,29)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(6),EQUAL)
          WRITE(50,99)PERCENT(6)(1:J),PRCNT
          P1=IVAL(6,37)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(7),EQUAL)
          WRITE(50,99)PERCENT(7)(1:J),PRCNT
          P1=IVAL(6,44)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(8),EQUAL)
          WRITE(50,99)PERCENT(8)(1:J),PRCNT
          P1=IVAL(6,50)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(9),EQUAL)
          WRITE(50,99)PERCENT(9)(1:J),PRCNT
          P1=IVAL(6,57)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(10),EQUAL)
          WRITE(50,99)PERCENT(10)(1:J),PRCNT
          P1=IVAL(6,59)
          PRCNT=(P1/P2)*100.
          J=INDEX(PERCENT(11),EQUAL)
          WRITE(50,99)PERCENT(11)(1:J),PRCNT
 99      FORMAT(' ',A,f10.7)
          STOP 
          END

         

C***********************************************************************
C***********************************************************************
      SUBROUTINE GBLEVN01(IUNITE) ! FORMERLY SUBROUTINE ETABLE

      COMMON /GBEVDD/ ERRS(300,33,6)

C  READ THE OBSERVATION ERROR TABLES
C  ---------------------------------

      REWIND IUNITE

      IREC = 0

   10 CONTINUE
      READ(IUNITE,'(1X,I3)',END=100) KX
      IREC = IREC + 1
      DO K=1,33
         READ(IUNITE,'(1X,6E12.5)') (ERRS(KX,K,M),M=1,6)
      ENDDO
      GO TO 10

  100 CONTINUE
      IF(IREC.LE.0) THEN
         PRINT *, '##GBLEVENTS/GBLEVN01 - OBS. ERROR TABLE EMPTY OR ',
     $    'DOES NOT EXIST - STOP 60'
         CALL ERREXIT(60)
      ENDIF

      RETURN

      END

c$$$  subprogram documentation block
c
c subprogram: indexc40
c   Programmer: D. Keyser       Org: NP22       Date: 2012-05-08
c
c Abstract: Uses efficient sort algorithm to produce index sort list for a 40-character
c   array.  Does not rearrange the file.
c
c Program History Log:
c 1993-06-05  R  Kistler -- FORTRAN version of C-program
c 1993-07-15  P. Julian  -- Modified to sort 12-character array
c 1994-08-25  D. Keyser  -- Modified to sort 16-character array
c 1995-05-30  D. Keyser  -- Tests for < 2 elements in sort list, if so returns without
c                            sorting (but fills indx array)
c ????-??-??  P. M. Pauley (NRL) -- Size of carrin changed to character*24
c 2010-11-15  S. Bender  -- Size of carrin changed to character*40
c 2012-05-08  D. Keyser  -- Prepared for operational implementation
c             
c Usage:    call indexc40(n,carrin,indx)
c
c   Input argument list:
c     n        - Size of array to be sorted
c     carrin   - 40-character array to be sorted
c
c   Output argument list:
c     indx     - Array of pointers giving sort order of carrin in ascending order {e.g.,
c                carrin(indx(i)) is sorted in ascending order for original i = 1, ... ,n}
c
c Remarks: Called by main program.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine indexc40(n,carrin,indx)

      implicit none

      integer      n              ! dimension of array to be sorted
     +,            j              ! do loop index, sort variable
     +,            i              ! sort variable
     +,            l              ! variable used to decide if sort is finished
     +,            ir             !           "                 "
     +,            indx(n)        ! pointer array
     +,            indxt          ! pointer used in sort

      character*40 carrin(n)      ! input array to be sorted
     +,            cc             ! character variable used in sort

c # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

      do j = 1,n
        indx(j) = j
      enddo

c Must be > 1 element in sort list, else return
c ---------------------------------------------

      if(n.le.1)  return

      l = n/2 + 1
      ir = n

   33 continue
      if(l.gt.1) then
         l = l - 1
         indxt = indx(l)
         cc = carrin(indxt)
      else
         indxt = indx(ir)
         cc = carrin(indxt)
         indx(ir) = indx(1)
         ir = ir - 1
         if(ir.eq.1) then
            indx(1) = indxt
            return
         endif
      endif

      i = l
      j = l * 2

   30 continue
      if(j.le.ir)  then
        if(j.lt.ir)  then
          if(carrin(indx(j)).lt.carrin(indx(j+1)))  j = j + 1
        endif
        if(cc.lt.carrin(indx(j))) then
          indx(i) = indx(j)
          i = j
          j = j + i
        else
          j = ir + 1
        endif
      endif

      if(j.le.ir) go to 30
      indx(i) = indxt
      go to 33

      end

subroutine uvspd(spd,dir,u,v,bmiss)

  use glerl_dictionary

  implicit none

  real(4),intent(in)::spd,dir
  real(4),intent(out)::u,v
  real(4)::rad
  real(8)::bmiss

  rad=4.0*atan(1.0)/180
  u = -spd*sin(rad*dir)
  v = -spd*cos(rad*dir)

  if (spd.gt.9999) then
     u=bmiss
     v=bmiss
  endif

end subroutine uvspd

      module def_vitals
        type tcvcard         ! Define a new type for a TC Vitals card
          sequence
          character*4   tcv_center      ! Hurricane Center Acronym
          character*3   tcv_storm_id    ! Storm Identifier (03L, etc)
          character*9   tcv_storm_name  ! Storm name
          integer       tcv_century     ! 2-digit century id (19 or 20)
          integer       tcv_yymmdd      ! Date of observation
          integer       tcv_hhmm        ! Time of observation (UTC)
          integer       tcv_lat         ! Storm Lat (*10), always >0
          character*1   tcv_latns       ! 'N' or 'S'
          integer       tcv_lon         ! Storm Lon (*10), always >0
          character*1   tcv_lonew       ! 'E' or 'W'
          integer       tcv_stdir       ! Storm motion vector (in degr)
          integer       tcv_stspd       ! Spd of storm movement (m/s*10)
          integer       tcv_pcen        ! Min central pressure (mb)
          integer       tcv_penv        ! val outrmost closed isobar(mb)
          integer       tcv_penvrad     ! rad outrmost closed isobar(km)
          integer       tcv_vmax        ! max sfc wind speed (m/s)
          integer       tcv_vmaxrad     ! rad of max sfc wind spd (km)
          integer       tcv_r15ne       ! NE rad of 15 m/s winds (km)
          integer       tcv_r15se       ! SE rad of 15 m/s winds (km)
          integer       tcv_r15sw       ! SW rad of 15 m/s winds (km)
          integer       tcv_r15nw       ! NW rad of 15 m/s winds (km)
          character*1   tcv_depth       ! Storm depth (S,M,D) X=missing
        end type tcvcard
      end module def_vitals
c
      module inparms
        type datecard  ! Define a new type for the input namelist parms
          sequence
          integer       byy    ! Beginning yy of date to search for 
          integer       bmm    ! Beginning mm of date to search for 
          integer       bdd    ! Beginning dd of date to search for 
          integer       bhh    ! Beginning hh of date to search for 
          integer       model  ! integer identifier for model data used
        end type datecard
      end module inparms
c
      module atcf
        integer         atcfnum   ! ATCF ID of model (63 for GFDL...)
        character*4     atcfname  ! ATCF Name of model (AVNO for AVN...)
      end module atcf
c
      module tracked_parms
          real, save, allocatable  ::  zeta(:,:,:)
          real, save, allocatable  ::  u(:,:,:)
          real, save, allocatable  ::  v(:,:,:)
          real, save, allocatable  ::  hgt(:,:,:)
          real, save, allocatable  ::  slp(:,:)
      end module tracked_parms
c
      module radii
c       For Barnes smoothing of parameters for tracking, e-folding
c       radius = retrk (km), influence radius = ritrk (km). Max radius 
c       for searching for the max vorticity = rads (km).  There is an 
c       important distinction between rads and ritrk.  rads is used to
c       determine the maximum distance from the guess position that 
c       we'll allow points to be in order to be considered as a 
c       candidate location for the updated fix position.  On the other
c       hand, ritrk is used once you're doing the barnes analysis on
c       data for that candidate location, so that if data is not within
c       distance ritrk of the candidate location, we ignore it.  Also, 
c       for use in find_maxmin, nhalf = the number of times to halve the
c       spacing of the search grid.  Note that different values are used
c       for the magnitude of the wind than for other parameters; this is
c       so that the search area is restricted in order to avoid a 
c       problem of the program finding one wind minimum near the center
c       and another one out near the storm's edge.
c
c       redlm and ridlm = the e-folding radius (km) and influence radius
c       (km) for Barnes analysis of u,v for updating first guess lat,lon
c       for search.  dlm = deep layer mean.
c
c        real, parameter :: retrk_most=60.0, retrk_vmag=60.0
c        real, parameter :: ritrk_most=120.0, ritrk_vmag=120.0
c        real, parameter :: rads_most=120.0, rads_vmag=120.0
c        real, parameter :: retrk_most=150.0, retrk_vmag=60.0
c        real, parameter :: ritrk_most=300.0, ritrk_vmag=120.0
c        real, parameter :: rads_most=300.0, rads_vmag=120.0
        real, parameter :: retrk_most=75.0, retrk_vmag=60.0
        real, parameter :: ritrk_most=150.0, ritrk_vmag=120.0
        real, parameter :: rads_most=300.0, rads_vmag=120.0
        real, parameter :: retrk_coarse=150.0
        real, parameter :: ritrk_coarse=300.0
        real, parameter :: rads_coarse=350.0
        real, parameter :: redlm=500.0, ridlm=2000.0
        integer, parameter :: maxvgrid = 8  ! In find_maxmin, determines
c                    what size grid to send to subroutine  barnes. e.g.,
c                    maxvgrid = 8 means send an 8x8 grid. 
        integer, parameter :: nhalf = 5
      end module radii
c
      module grid_bounds
        real, save ::  glatmin, glatmax, glonmin, glonmax  ! These 
                       ! define the boundaries of the input data grid
        real, save, allocatable ::  glat(:), glon(:)  ! Will be filled
                       ! with lat/lon values for each pt on input grid
      end module grid_bounds
c
      module error_parms
        real, parameter :: err_avn_init=275.0 ! init errmax for avn,mrf
                                              ! and gdas
        real, parameter :: err_reg_init=300.0 ! init errmax for others
        real, parameter :: err_ecm_max=330.0  ! errmax for ecmwf
        real, parameter :: err_reg_max=225.0  ! errmax for others for
                                              ! remaining fcst times
        real, parameter :: maxspeed=60  ! max speed of storm movement
C        real, parameter :: errpgro=1.25, errpmax=600.0
        real, parameter :: errpgro=1.25, errpmax=485.0
        real, parameter :: stermn = 0.1   ! Min Std dev for trk errors
        real, parameter :: uverrmax = 225.0  ! For use in get_uv_guess
      end module error_parms
c
      module set_max_parms
        integer, parameter :: maxstorm=15  ! max # of storms pgm can
                                           ! handle
        integer, parameter :: maxtime=65   ! max # of fcst times pgm 
                                           ! can handle
        integer, parameter :: maxtp=9      ! max # of tracked parms 
        integer, parameter :: maxmodel=20  ! max # of models currently 
                                           ! available
        integer, save :: interval_fhr      ! # of hrs between fcst times
      end module set_max_parms
c
      module level_parms
        integer, parameter :: nlevs=4   ! max # of vert levs to be read
        integer, parameter :: nlevg=3   ! # of vert levs to be used for
                                        ! figuring next guess position
        integer, parameter :: nlevm1=2  ! # tracked levs for hgt & zeta
        integer, parameter :: levsfc=4  ! array position of sfc winds.
        integer, parameter :: nlev850=1 ! array position in u and v
        integer, parameter :: nlev700=2 ! arrays for 850, 700 & 500
        integer, parameter :: nlev500=3 ! winds.  Used in get_uv_center
        real, save      :: wgts(nlevg)  ! Wghts for use in get_next_ges
        data wgts /0.25, 0.50, 0.25/    ! 850, 700 & 500 mb wgts
      end module level_parms
c
      module trig_vals
        real, save :: pi, dtr
        real, save :: dtk = 111.1949     ! Dist (km) over 1 deg lat
                                         ! using erad=6371.0e+3
        real, save :: erad = 6371.0e+3   ! Earth's radius (m)
        real, save :: ecircum = 40030.2  ! Earth's circumference
                                         ! (km) using erad=6371.e3
        real, save :: omega = 7.292e-5
      end module trig_vals
c
c---------------------------------------------------------------------c
c

C-----------------------------------------------------------------------
C  MAIN PROGRAM SURUFIT
C-----------------------------------------------------------------------
      PROGRAM SURUFIT

      PARAMETER (IDBUG=0,IPR=1)
      PARAMETER (NSTC=9)
      PARAMETER (NPLV=1)
      PARAMETER (NVAR=5)
      PARAMETER (NREG=7)
      PARAMETER (NSUB=2)
      PARAMETER (NBAK=2)

      CHARACTER*80 HDSTR,OBSTR,FCSTR,ANSTR,QMSTR,VMSTR,PSTR
      CHARACTER*8  SUBSET

      real(8)    HDR(14)
      real(8)    PSOB(4),PSPR(4)
      real(8)    BAK(10,255,NBAK)
      real(8)    OBS(10,255),QMS(10,255),vms(10,255)


      real(8)    SPRS(NSTC,NPLV,NVAR,NREG,NSUB,NBAK)
      real(8)    CNTO,CNTN,RAT1,RAT2,WT1,WT2
      real(8)    STC(NSTC,5,NBAK)

      real(4)    GDATA(NREG,NSUB)

      LOGICAL    MANDONLY,REGION
      INTEGER    INDEXV(NVAR)

!     DATA PMAND / 1000, 925, 850, 700, 500, 400, 300,
!    .              250, 200, 150, 100,  70,  50,  30,
!    .               20,  10,   7,   5,   3,   2,   1/

      DATA HDSTR
     ./'SID XOB YOB DHR ELV TYP T29 ITP SQN RQM DUP PRG SRC RUD'/
      DATA PSTR /'POB PAN PFC PQM CAT=0'/
      DATA OBSTR/'POB QOB TOB ZOB UOB VOB'/
      DATA FCSTR/'PFC QFC TFC ZFC UFC VFC'/
      DATA ANSTR/'PAN QAN TAN ZAN UAN VAN'/
      DATA QMSTR/'PQM QQM TQM ZQM WQM CAT'/
      DATA VMSTR/'PQM QVWTA TVWTA ZQM WVWTA CAT'/

      real(8) BMISS /10E10/

      DATA RMISS / -9.99E+33 /
      DATA LUBFR/11/
      data indexv/3,4,5,2,1/
c...  t,z,w,q,ps
c
       CALL OPENBF(LUBFR,'IN ',LUBFR)
c
C-----------------------------------------------------------------------
c... j  is level (21)
c... k  is variable (5)
c... ll is region (7)
c... m  is subset (1)
c... n  is background (2)
C-----------------------------------------------------------------------

C  ZERO THE FIT ARRAYS
C  -------------------

      SPRS = 0.

      bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

C  READ AND "SURU-FIT" THE PREPDA/BUFR RECORDS
C  -------------------------------------------

10    DO WHILE(IREADMG(LUBFR,SUBSET,IDATE).EQ.0)
      IF(SUBSET/='ADPSFC'.AND.SUBSET/='SFCSHP') cycle
11    DO WHILE(IREADSB(LUBFR).EQ.0)
      CALL UFBINT(LUBFR,HDR,14,1,NLEV,HDSTR)

c... check for report type 
      kx=mod(nint(hdr(6)),100)
      if(kx==80)then      !ships
         itype=2
      elseif(kx==81.or.kx==87)then  !synops
         itype=1
      else
         cycle
      endif

c... check for region...
      XOB=hdr(2)
      YOB=hdr(3)
      IF(.NOT.REGION(XOB,YOB,0)) GO TO 11

c... set parameters
      STC=0; M=ITYPE

c... first surface pressure...
      CALL UFBINT(LUBFR,PSOB,4,1,NLEV,PSTR)
      pso =  psob(1)-984.
      psa =  psob(2)-984.
      psf =  psob(3)-984.
      psq =  psob(4)
      IF(psq.LE.3 .and. psa.lt.1E10) THEN
         STC(1,1,1) = 1.
         STC(2,1,1) = psf
         STC(3,1,1) = pso
         STC(4,1,1) = psf*pso
         STC(5,1,1) = psf*psf
         STC(6,1,1) = pso*pso
         STC(1,1,2) = 1.
         STC(2,1,2) = psa
         STC(3,1,2) = pso
         STC(4,1,2) = psa*pso
         STC(5,1,2) = psa*psa
         STC(6,1,2) = pso*pso
         J=1
         K=1
         DO N=1   ,NBAK
         DO LL=1  ,NREG
         IF(REGION(XOB,YOB,LL)) THEN
            cnto = SPRS(1,J,K,LL,M,N)
            SPRS(1,J,K,LL,M,N) = SPRS(1,J,K,LL,M,N) + STC(1,K,N)
            cntn = SPRS(1,J,K,LL,M,N)
            if(cntn.gt.cnto) then
               wt1 = cnto/cntn
               wt2 = 1.-wt1
               DO I=2,6
               sprso = SPRS(I,J,K,LL,M,N)
               rat1 = wt1*SPRS(I,J,K,LL,M,N)
               rat2 = wt2*STC(I,K,N)
               SPRS(I,J,K,LL,M,N) = rat1 + rat2
               sprsn = SPRS(I,J,K,LL,M,N)
               ENDDO
            endif
         ENDIF
         ENDDO
         ENDDO
       endif

c... now do the rest of the variables....

      CALL UFBINT(LUBFR,OBS,10,255,NLEV,OBSTR)
      CALL UFBINT(LUBFR,BAK(1,1,1),10,255,NLFC,FCSTR)
      CALL UFBINT(LUBFR,BAK(1,1,2),10,255,NLAN,ANSTR)
      CALL UFBINT(LUBFR,QMS,10,255,NLQM,QMSTR)
      CALL UFBINT(LUBFR,VMS,10,255,NLQM,VMSTR)

      if(subset=='ADPSFC') then
         do i=2,5 ! set qm based on varqc marks
         if(qms(i,1)==8.or.qms(i,1)>9) cycle
         if(vms(i,1)>79.and.vms(i,1)<101) qms(i,1)=1
         enddo
      endif

      IF(NLEV.NE.NLQM) THEN
      PRINT *,'***SURUFIT***QM LEVELS NE OB LEVELS'
      CALL ABORT
      ENDIF
      IF(NLEV.NE.NLFC) THEN
      PRINT *,'***SURUFIT***FC LEVELS NE OB LEVELS'
      CALL ABORT
      ENDIF
      IF(NLEV.NE.NLAN) THEN
      PRINT *,'***SURUFIT***AN LEVELS NE OB LEVELS'
      CALL ABORT
      ENDIF

C  CREATE AND ACCUMULATE THE STATISTICS ARRAY FOR EACH REALIZATION
C  ---------------------------------------------------------------

      DO L=1,1 !!NLEV
      STC = 0.

      qms(4,l) = max(qms(3,l),qms(4,l)) ! use tqm for zqm
      POB = OBS(1,L); PQM = QMS(1,L); if(pqm>3) cycle
      CAT = QMS(6,L)
      if(idbug.eq.1) print *,' pob ',pob,' pqm ',pqm,' cat ',cat

      DO IB=1,2  ! background field
      DO IQ=2,5  ! vars q,t,z,w        
      IF(OBS(IQ,L)   >=BMISS) cycle ! protect from missing observation !
      IF(BAK(IQ,L,IB)>=BMISS) cycle ! protect from missing background  !
      IR = IQ+1
      IF(QMS(IQ,L).LE.3 .AND. IQ.LT.5 .AND. CAT.NE.4) THEN
         IF(IQ.EQ.2) THEN
            IF(IB.EQ.1) OBS(IQ,L)=OBS(IQ,L)*1.E-3
            BAK(IQ,L,IB)=BAK(IQ,L,IB)*1.E-3
         ENDIF
         STC(1,IQ,IB) = 1                            ! count
         STC(2,IQ,IB) = BAK(IQ,L,IB)                 ! background
         STC(3,IQ,IB) = OBS(IQ,L)                    ! observation
         STC(4,IQ,IB) = BAK(IQ,L,IB)*OBS(IQ,L)       ! f*o
         STC(5,IQ,IB) = BAK(IQ,L,IB)**2              ! f**2
         STC(6,IQ,IB) = OBS(IQ,L)**2                 ! o**2
      ELSEIF(QMS(IQ,L).LE.3 .AND. IQ.EQ.5) THEN
         STC(1,IQ,IB) = 1                                              ! count
         STC(2,IQ,IB) = BAK(IQ,L,IB)                                   ! u background
         STC(3,IQ,IB) = BAK(IR,L,IB)                                   ! v background
         STC(4,IQ,IB) = OBS(IQ,L)                                      ! u observation
         STC(5,IQ,IB) = OBS(IR,L)                                      ! v observation
         STC(6,IQ,IB) = BAK(IQ,L,IB)*OBS(IQ,L)+BAK(IR,L,IB)*OBS(IR,L)  ! uf*uo + vf*vo
         STC(7,IQ,IB) = BAK(IQ,L,IB)**2 + BAK(IR,L,IB)**2              ! uf**2 + vf**2
         STC(8,IQ,IB) = OBS(IQ,L)**2 + OBS(IR,L)**2                    ! uo**2 + vo**2
         STC(9,IQ,IB) = SQRT(STC(7,IQ,IB)) - SQRT(STC(8,IQ,IB))        ! sqrt(uf**2+vf**2)-sqrt(uo**2+vo**2)
      endif
      ENDDO
      ENDDO

!  store the stats from this ob

      DO N=1   ,NBAK
      DO LL=1  ,NREG
      IF(REGION(XOB,YOB,LL)) THEN
         DO K=2,NVAR
         nstat=6
         if(k.eq.5) nstat=9
         cnto = SPRS(1,L,K,LL,M,N)
         SPRS(1,L,K,LL,M,N) = SPRS(1,L,K,LL,M,N) + STC(1,K,N)
         cntn = SPRS(1,L,K,LL,M,N)
         if(cntn.gt.cnto) then
            wt1 = cnto/cntn
            wt2 = 1.-wt1
            DO I=2,nstat
            sprso = SPRS(I,L,K,LL,M,N)
            rat1 = wt1*SPRS(I,L,K,LL,M,N)
            rat2 = wt2*STC(I,K,N)
            SPRS(I,L,K,LL,M,N) = rat1 + rat2
            sprsn = SPRS(I,L,K,LL,M,N)
            ENDDO
         endif
         ENDDO
      ENDIF
! end region-backg-level-loop
      ENDDO
      ENDDO
      ENDDO
! end ireadsb-ireadmg-loop
      ENDDO
      ENDDO
      CALL CLOSBF(LUBFR)

! FINISH UP - write out grads data file...
! ----------------------------------------

      iw=50
      do ibak=1,nbak
      iw=iw+1
c
      do ivarx=1,nvar
      ivar=indexv(ivarx)
      nstat=6
      if(ivar.eq.5) nstat=9
      if(idbug.eq.1) print *,ibak,' ivar ',ivar,' nstat ',nstat
c
      do nst=1,nstat
c
      nlx=nplv
      if(ivar.eq.1) nlx=1
      do iplv=1,nlx
c
      do isub=1,nsub
      do ireg=1,nreg
c
      gdata(ireg,isub)=sprs(nst,iplv,ivar,ireg,isub,ibak)
c
c... end region-loop
      enddo
c... end subset-loop
      enddo
c
      write(iw) gdata
c
c... end level-loop
      enddo
c... end stat-loop
      enddo
c
c... end variable-loop
      enddo
c
      close(iw)
c... end forecast-loop
      enddo
c
 1231  format('p fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1232  format('q fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1233  format('t fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1234  format('z fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
 1235  format('w fcs=',i2,2x,'stat = ',i2,2x,'lev = ',i6,2x,7f12.2)
c
 3000  format('reg ',i2,' cnto ',f4.0,' cntn ',f4.0,
     *        ' wt1 ',f5.2,' wt2 ',f5.2,2x,5f12.2)
c
      PRINT'("SURUFIT PROCESSING COMPLETED")'
      STOP
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      LOGICAL FUNCTION REGION(X,Y,I)

      PARAMETER(NREG=7)

      DIMENSION X1(NREG),X2(NREG),Y1(NREG),Y2(NREG)

C.... X goes from east to west
C.... Y goes from south to north
c... global,nh,sh,tr,na,eu,as
      DATA X1(1),X2(1),Y1(1),Y2(1) /0.,360.,-90.,90./
      DATA X1(2),X2(2),Y1(2),Y2(2) /0.,360.,20.,80./
      DATA X1(3),X2(3),Y1(3),Y2(3) /0.,360.,-80.,-20./
      DATA X1(4),X2(4),Y1(4),Y2(4) /0.,360.,-20.,20./
      DATA X1(5),X2(5),Y1(5),Y2(5) /235.,295.,25.,55./
      DATA X1(6),X2(6),Y1(6),Y2(6) /350.,25.,35.,70./
      DATA X1(7),X2(7),Y1(7),Y2(7) /65.,145.,5.,45./

C-----------------------------------------------------------------------

C  CHECK FOR A VALID REGION INDEX AND BE OPTIMISTIC
C  ------------------------------------------------

      IF(I.LT.0.OR.I.GT.NREG) THEN
         REGION = .FALSE.
         RETURN
      ELSE
         REGION = .TRUE.
      ENDIF

C  SETUP THE SEARCH PARAMETERS
C  ---------------------------

      IF(I.EQ.0) THEN
         I1 = 1
         I2 = NREG
      ELSE
         I1 = I
         I2 = I
      ENDIF

C  LOOK FOR A REGION MATCH
C  -----------------------

      DO I0=I1,I2
      IF(Y.GE.Y1(I0) .AND. Y.LE.Y2(I0)) THEN
         IF(X1(I0).LE.X2(I0)) THEN
            IF(X.GE.X1(I0) .AND. X.LE.X2(I0)) RETURN
         ELSEIF(X1(I0).GT.X2(I0)) THEN
            IF(X.GE.X1(I0) .OR.  X.LE.X2(I0)) RETURN
         ENDIF
      ENDIF
      ENDDO

C  IF NO MATCH, RETURN FALSE
C  -------------------------

      REGION = .FALSE.
      RETURN
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: BUFR_AVGDATA
C   PRGMMR: Whiting          ORG: EMC         DATE: 2017-11-20
C
C ABSTRACT: GENERATES A TABLE CONTAINING THE AVERAGE COUNTS FOR EACH
C   BUFR TYPE/SUBTYPE DUMPED IN A PARTICULAR NETWORK BY CYCLE OVER A
C   PERIOD OF TIME (NORMALLY 30-DAYS).  ALL OF THE INDIVIDUAL DAYS'
C   COUNTS ARE READ IN.  THE USH SCRIPT CONTROLS HOW MANY DAYS ARE
C   ACCUMULATED IN THESE INPUT FILES.  THIS TABLE IS READ BY THE
C   PROGRAM BUFR_DATACOUNT.
C
C PROGRAM HISTORY LOG:
C 2000-08-22  D. KEYSER   ORIGINAL AUTHOR
C 2001-01-05  D. KEYSER   CORRECTED ERROR WHICH LED TO PREVIOUS
C     TYPE/SUBTYPE AVERAGE FOR SAME CYCLE BEING PRINTED IN UNIT 51
C     WHEN THE NUMBER OF DAYS IN AVERAGE IS ZERO (CORRECTED AVERAGE
C     TO ALWAYS BE ZERO IN THIS CASE); CAN NOW GENERATE AVERAGE FOR
C     HOURLY DUMPS WHICH RUN AS PART OF A NEW MONITORING SYSTEM ("DUMP"
C     NETWORK), ACCUMULATED DUMP COUNT FILES (BY CYCLE) NOW OPENED BY
C     THIS PGM RATHER THAN BEING ASSIGNED TO UNIT NUMBERS IN USH
C     SCRIPT, GENERALIZED TO HANDLE 24 CYCLES FOR "DUMP" NETWORK AND
C     STILL 4 CYCLES FOR OTHER NETWORKS
C 2001-05-16  D. KEYSER   ADDED RUC2A, RUCS1 (EARLY CUTOFF SURFACE
C     RUC) AND RUCS2 (LATE CUTOFF SURFACE RUC), ALL 24 CYCLES
C 2002-03-19  D. KEYSER   INCREASED PARAMETER IMAX_BTYPE FROM 101
C     TO 255 TO ACCOUNT FOR NEW MESONET DATA IN BUFR TYPE 255
C 2006-03-08  D. KEYSER  REMOVED PROCESSING OF 1B SATELLITE REPORTS
C     WHICH WERE IN THE LONG-OBSOLETE IEEE DUMP STATUS FILE (THESE
C     HAVE LONG BEEN INCLUDED IN THE BUFR DUMP STATUS FILE ALONG WITH
C     ALL OTHER REPORTS); INPUT NAME LIST CHARACTER STRING IN VARIABLE
C     "NETWORK" IS NOW EXPECTED TO BE IN UPPER-CASE RATHER THAN IN
C     LOWER-CASE
C 2006-07-14  D. KEYSER   ADDED RTMA (REAL TIME MESOSCALE ANALYSIS),
C     ALL 24 CYCLES
C 2011-10-15  D. A. KEYSER -- RAP (RAPID REFRESH) NETWORK REPLACES
C     RUC2A (RAPID UPDATE CYCLE)
C 2013-01-10  D. A. KEYSER -- REMOVED RUCS1 (EARLY CUTOFF SURFACE RUC)
C     AND RUCS2 (LATE CUTOFF SURFACE RUC) AS THIS MODEL NO LONGER RUNS
C     IN PRODUCTION; ADDED URMA (UnRestricted Mesoscale Analysis)
C 2013-03-20  JWhiting  ported for use on WCOSS (linux) platforms:
C     Updated documentation (no logic changes necessary).
C 2017-11-20  D. A. KEYSER -- ACCOUNTS FOR NAM NOW HAVING tm06 THROUGH
C     tm00 TIME MARKERS (ONLY tm00 IS EXPECTED HERE FOR THIS AND ALL
C     oTHER NETWORKS).
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C                DOCUMENTATION BELOW)
C     UNIT 10  - TABLE CONTAINING MNEMONIC NAME (A6), BUFR TYPE (I3)
C                AND BUFR SUBTYPE (I3) FOR ALL CURRENTLY VALID BUFR
C                TYPES AND SUBTYPES (THIS IS GENERATED FROM THE
C                bufr_dumplist FILE, SEE SCRIPT), FMT:'(1X,A6,8X,I3,I3)'
C     UNIT 21  - TABLE CONTAINING BUFR TYPE (A3), BUFR SUBTYPE (A3) AND
C                DUMP COUNT (I7) FOR ALL OBSERVATIONS IN A CYCLE OVER A
C                SPECIFIED NUMBER OF DAYS (THIS IS GENERATED FROM AN
C                ARCHIVE OF THE INDIVIDUAL DAYS' DUMP STATUS FILES, SEE
C                SCRIPT), FORMAT: '(A3,1X,A3,1X,I7)', WITH THE STRING
C                'EOF @@@' IN COLUMNS 1-7 SEPARATING TWO DIFFERENT DAYS
C                (EACH INDIVIDUAL FILE FOR A CYCLE IS CONNECTED TO THIS
C                UNIT)
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C     UNIT 51  - TABLE CONTAINING AVERAGE COUNTS AND NUMBER OF DAYS BY
C                CYCLE TIME (4(1X,I7,'/',I3,1X)) FOR EACH BUFR TYPE
C                AND SUBTYPE READ IN FROM ALL VALID CYCLES IN UNIT 21,
C                FMT:'('#',3X,A6,2X,I3.3,'/',I3.3,4(1X,I7,'/',I3,1X))'
C                (MNEMONIC NAME, BUFR TYPE, BUFR SUBTYPE, 00Z AVERAGE/
C                # OF DAYS, 06Z AVERAGE/# OF DAYS, 12Z AVERAGE/# OF 
C                DAYS, 18Z AVERAGE/# OF DAYS); ALSO CONTAINS A HEADING
C     
C   SUBPROGRAMS CALLED:
C     LIBRARY:
C       W3NCO    - W3TAGB W3TAGE ERREXIT
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN, ALL DATA RECEIPT NORMAL
C          =  30 - FAILED RUN, ERROR READING SUBSET OF DUMPLIST FILE IN
C                   UNIT 10
C          =  31 - FAILED RUN, INVALID BUFR TYPE READ FROM SUBSET OF
C                   DUMPLIST FILE IN UNIT 10
C          =  32 - FAILED RUN, INVALID BUFR SUBTYPE READ FROM SUBSET OF
C                   DUMPLIST FILE IN UNIT 10
C          =  40 - FAILED RUN, ERROR READING SUBSET OF ACCUMULATED
C                   DUMP STATUS FILES IN UNIT 21
C          =  41 - FAILED RUN, INVALID BUFR TYPE READ FROM SUBSET OF
C                   ACCUMULATED DUMP STATUS FILES IN UNIT 21
C          =  42 - FAILED RUN, INVALID BUFR SUBTYPE READ FROM SUBSET OF
C                   ACCUMULATED DUMP STATUS FILES IN UNIT 21
C
C REMARKS:
C     VARIABLES IN NAMELIST "INPUT" READ IN MAIN PROGRAM
C       NETWORK  - C*5,  NETWORK {either 'NAM  '(tm00), 'GFS  ',
C                                 'GDAS ', 'RAP', 'RTMA', 'URMA' or
C                                 'DUMP'}
C                        (NOTE: 'DUMP' is the dump monitoring network
C                               which runs hourly)
C       CURRDATE - C*10, CURRENT DATE IN FORM "MM/DD/YYYY"
C
C ATTRIBUTES:
C   LANGUAGE: Intel Fortran
C   MACHINE:  WCOSS (linux)
C
C$$$

      PROGRAM BUFR_AVGDATA

      PARAMETER (IMAX_BTYPE=255)
      PARAMETER (IMAX_STYPE=255)

      PARAMETER (IMAX_BS_TYPE=(IMAX_BTYPE + 1) * (IMAX_STYPE + 1))

      CHARACTER*21  filename
      CHARACTER*10  currdate
      CHARACTER*6   mnemon,mnemonic(000:imax_btype,000:imax_stype)
      CHARACTER*5   network
      CHARACTER*3   atype,asub
      CHARACTER*2   cyc

      INTEGER         isum(000:imax_btype,000:imax_stype,0:23),
     $              icount(000:imax_btype,000:imax_stype,0:23),
     $            isum_day(000:imax_btype,000:imax_stype),
     $          icount_day(000:imax_btype,000:imax_stype),
     $           ivalid_st(000:imax_btype,000:imax_stype)

      REAL          avg_count(0:23)

      NAMELIST/INPUT/NETWORK,CURRDATE

      DATA    infile /21/

      CALL W3TAGB('BUFR_AVGDATA',2017,0324,0079,'NP22')

      READ(5,INPUT)

      print *, ' '
      print *, '#####  Welcome to AVGDATA - Version 11/20/2017'
      print *, ' '
      print *, '   --> Network is: ',network,' tm00'
      print *, ' '

      ierr = 0

      isum       = 0
      icount     = 0
      isum_day   = 0
      icount_day = 0
      mnemonic   = '      '
      ivalid_st  = 0

C     Parse out information from the subset of the dumplist file
C     ----------------------------------------------------------

      print *, ' '
      print *,'  ==> Parsing through the subset of the dumplist file'
      print *, ' '

      DO WHILE (ierr .eq. 0)
         READ(10,101,end=10,err=997) mnemon,jtype,jsub
  101 FORMAT(1x,a6,8x,i3,i3)
         IF(jtype.lt.0. .or. jtype.gt.imax_btype) THEN
            print *,' ###  INVALID VALUE FOR BUFR TYPE IN SUBSET OF ',
     $       'DUMPLIST FILE (=',jtype,') -- STOP 31'
            CALL W3TAGE('BUFR_AVGDATA')
            CALL ERREXIT(31)
         ELSE IF(jsub.lt.0. .or. jsub.gt.imax_stype) THEN
            print *,' ### INVALID VALUE FOR BUFR SUBTYPE IN SUBSET OF ',
     $       'DUMPLIST FILE (=',jsub,') -- STOP 32'
            CALL W3TAGE('BUFR_AVGDATA')
            CALL ERREXIT(32)
         END IF
         mnemonic(jtype,jsub) = mnemon
         PRINT 103, mnemonic(jtype,jsub),jtype,jsub
  103    FORMAT(32('-')/' mnemonic "',a6,'"'/' type ',i4.3,' subtype ',
     $    i4.3)
      END DO

   10 CONTINUE

      print *, '--------------------------------'
      print *, ' '

C     Parse out information from the subset of the accumulated
C     dump status files
C     --------------------------------------------------------

      print *, ' '
      print *,'  ==> Parsing through the subsets of the accumulated ',
     $ 'dump status files'
      print *, ' '

      if(network.eq.'DUMP'.or.network.eq.'RAP'.or.network.eq.'RTMA'.or.
     $   network.eq.'URMA') then
         icycle_iter = 1
      else
         icycle_iter = 6
      end if

      loop1: do icycle=0,23,icycle_iter
         write(cyc,'(i2.2)') icycle
         filename='accum.obs.counts.t'//cyc//'z'
         open(infile,file=filename,form='FORMATTED')

         loop2: do while (ierr .eq. 0)
            read(infile,*,end=20,err=998) atype,asub,jreps
cppppp
cdak        print *, 'atype,asub,jreps = ',atype,asub,jreps
cppppp
            if(atype.eq.'EOF'.and.asub.eq.'@@@') then

C     --> Finished reading counts for this cycle for a particular day
C         (this logic is needed if a type/subtype is ever split up)

               isum(:,:,icycle)   = isum(:,:,icycle)   + isum_day(:,:)
               icount(:,:,icycle) = icount(:,:,icycle) + icount_day(:,:)
               isum_day   = 0
               icount_day = 0
               cycle loop2
            end if
            read(atype,'(i3)') jtype
            read(asub ,'(i3)') jsub
            if(jtype.lt.0. .or. jtype.gt.imax_btype)   then
               print *,' ### INVALID VALUE FOR BUFR TYPE IN SUBSET OF ',
     $          'ACCUMULATED DUMP STATUS FILES FOR CYCLE ',cyc,'Z (=',
     $          jtype,') -- STOP 41'
               call w3tage('BUFR_AVGDATA')
               call errexit(41)
            else if(jsub.lt.0. .or. jsub.gt.imax_stype) THEN
               print *,' ### INVALID VALUE FOR BUFR SUBTYPE IN SUBSET ',
     $          'OF ACCUMULATED DUMP STATUS FILES FOR CYCLE ',cyc,
     $          'Z (=',jsub,') -- STOP 42'
               call w3tage('BUFR_AVGDATA')
               call errexit(42)
            end if
            isum_day(jtype,jsub)   = isum_day(jtype,jsub) + jreps
            icount_day(jtype,jsub) = 1
            ivalid_st(jtype,jsub)  = 1
         end do loop2

   20    continue

         close(infile)

      end do loop1

C     Generate the new 30-day average file
C     ------------------------------------

      print *, ' '
      print *,'  ==> Ready to generate new 30-day average file for ',
     $ network,' network - tm00'
      print *, ' '

C        --> Headings

      if(network.ne.'DUMP'.and.network.ne.'RAP'.and.network.ne.'RTMA'
     $ .and.network.ne.'URMA') then
         write(51,104) network,currdate
  104 format(4x,69('-')/4x,'Mean dump counts at each cycle for ',a5,
     $ ' tm00 network, ','listed by'/5x,'BUFR message type/subtype.'//
     $ 4x,'Averages calculated through (and including): ',a10,' .'//4x,
     $ 'This file is generated by the program BUFR_AVGDATA.'/4x,
     $ 'This file is input to the program BUFR_DATACOUNT.'//4x,
     $ 'WARNING: LINES WITH "#" IN COLUMN 1 ARE READ BY ',
     $ 'BUFR_DATACOUNT'/13x,'PROGRAM.  DO NOT CHANGE THE COLUMNAR ',
     $ 'POSITION OF ANY'/13x,'CHARACTERS IN THESE LINES!!!'//4x,69('-')/
     $ 4x,'-----type------ ------00Z-- -------06Z-- -------12Z-- ',
     $ '-------18Z--'/4x,'mnemon  typ sub',4(5x,'avg/days')/4x,
     $ '------  --- ---',4(' ------- --- '))
      else
         write(51,5104) network,currdate
 5104 format(4x,69('-')/4x,'Mean dump counts at each cycle for ',a5,
     $ ' network, ','listed by'/5x,'BUFR message type/subtype.'//4x,
     $ 'Averages calculated through (and including): ',a10,' .'//4x,
     $ 'This file is generated by the program BUFR_AVGDATA.'/4x,
     $ 'This file is input to the program BUFR_DATACOUNT.'//4x,
     $ 'WARNING: LINES WITH "#" IN COLUMN 1 ARE READ BY ',
     $ 'BUFR_DATACOUNT'/13x,'PROGRAM.  DO NOT CHANGE THE COLUMNAR ',
     $ 'POSITION OF ANY'/13x,'CHARACTERS IN THESE LINES!!!'//4x,69('-')/
     $ 4x,'-----type------ ------00Z-- -------01Z-- -------02Z-- ',
     $ '-------03Z-- -------04Z-- -------05Z-- -------06Z-- ',
     $ '-------07Z-- -------08Z-- -------09Z-- -------10Z-- ',
     $ '-------11Z-- -------12Z-- -------13Z-- -------14Z-- ',
     $ '-------15Z-- -------16Z-- -------17Z-- -------18Z-- ',
     $ '-------19Z-- -------20Z-- -------21Z-- -------22Z-- ',
     $ '-------23Z--'/4x,'mnemon  typ sub',24(5x,'avg/days')/4x,
     $ '------  --- ---',24(' ------- --- '))
      end if

C        --> Calculated averages

      LOOP5: DO jtype = 0,imax_btype
         new_jtype = 1
         LOOP6: DO jsub = 0,imax_stype
            IF(mnemonic(jtype,jsub).eq.'      ')  CYCLE LOOP6
            IF(ivalid_st(jtype,jsub).eq.0) CYCLE LOOP6
            PRINT 105, jtype,jsub,mnemonic(jtype,jsub)
  105 FORMAT(32('-')/' Type   ',i3.3,2x,i3.3,' "',a6,'" located in ',
     $ 'subset of accumulated status files')
            avg_count = 0.0
            do icycle=0,23,icycle_iter
               write(cyc,'(i2.2)') icycle
               if(icount(jtype,jsub,icycle).gt.0)  avg_count(icycle)=
     $    real(isum(jtype,jsub,icycle))/real(icount(jtype,jsub,icycle))
               PRINT 106, jtype,jsub,cyc,isum(jtype,jsub,icycle),
     $          icount(jtype,jsub,icycle),nint(avg_count(icycle))
  106 FORMAT(' -- for BUFR type =',i4.3,', subtype =',i4.3,', cycle = ',
     $ a2,'Z -- isum =',i10,', icount =',i4,'; average =',i7)
            end do
            if(new_jtype.eq.1)  write(51,107)
  107       format(1x)
            write(51,108) mnemonic(jtype,jsub),jtype,jsub,(nint
     $       (avg_count(icycle)),icount(jtype,jsub,icycle),
     $       icycle=0,23,icycle_iter)
  108       format('#',3x,a6,2x,i3.3,'/',i3.3,24(1x,i7,'/',i3,1x))
            new_jtype = 0
         END DO LOOP6
      END DO LOOP5

      print *, '--------------------------------'
      print *, ' '

      write(51,107)

C     All done
C     --------

      print *, ' '
      print *, ' '
      print *,' ** AVGDATA COMPLETED SUCCESSFULLY **'
      print *, ' '

      CALL W3TAGE('BUFR_AVGDATA')

      STOP

C-----------------------------------------------------------------------
  997 CONTINUE
      print *,' ###  ERROR READING SUBSET OF DUMPLIST FILE IN UNIT 10 ',
     $ '-- STOP 30'
      CALL W3TAGE('BUFR_AVGDATA')
      CALL ERREXIT(30)
C-----------------------------------------------------------------------
  998 CONTINUE
      print *,' ###  ERROR READING SUBSET OF ACCUMULATED DUMP STATUS',
     $ ' FILES IN FILE ',filename,' FOR CYCLE ',cyc,'Z -- STOP 40'
      CALL W3TAGE('BUFR_AVGDATA')
      CALL ERREXIT(40)
C-----------------------------------------------------------------------

      END

c##### filtering for TC genesis ######################
c###J.Peng  2012-05-09  ###############################
c mean RH>=80%     mean U shear < 0.0
c Tmax-Tmin >1.0 Vorticity(850hPa)>150
c######################################################
c-----------------------------------------------------------------------
      module define_atcfunix_rec
        type atcfunix_card    ! Define a new type for an atcfunix card
          sequence
          character*2   atx_basin       ! Hurricane Center Acronym
          character*2   atx_storm_num   ! Storm number (03, etc)
          character*10  atx_ymdh        ! Fcst start date (yyyymmddhh)
          character*2   atx_technum     ! Always equal to 03 for models
          character*4   atx_model       ! Name of forecast model
          integer       atx_fcsthr      ! Fcst hour (i3.3)
          integer       atx_lat         ! Storm Lat (*10), always >0
          character*1   atx_latns       ! 'N' or 'S'
          integer       atx_lon         ! Storm Lon (*10), always >0
          character*1   atx_lonew       ! 'E' or 'W'
          integer       atx_vmax        ! max sfc wind speed (knots)
          integer       atx_pcen        ! Min central pressure (mb)
          character*2   atx_stype       ! Storm type (= 'XX' for now)
          integer       atx_wthresh     ! Wind threshold (34, 50, 64 kt)
          character*3   atx_quad_id     ! NEQ = start with NE quadrant
          integer       atx_ne_quad     ! Wind radius in NE quad (nm)
          integer       atx_se_quad     ! Wind radius in SE quad (nm)
          integer       atx_sw_quad     ! Wind radius in SW quad (nm)
          integer       atx_nw_quad     ! Wind radius in NW quad (nm)
        end type atcfunix_card
      end module define_atcfunix_rec

c---------------------------------------------------------------------
      module define_atcf_gen_rec
        type atcf_gen_card    ! Define a new type for an atcf_gen card
          sequence
          character*2   gen_basin       ! Hurricane Center Acronym
          character*4   gen_storm_num   ! Storm number (03, etc)
          character*30  gen_storm_id    ! Storm ID
          character*10  gen_ymdh        ! Fcst start date (yyyymmddhh)
          character*2   gen_technum     ! Always equal to 03 for models
          character*4   gen_model       ! Name of forecast model
          integer       gen_fcsthr      ! Fcst hour (i3.3)
          integer       gen_lat         ! Storm Lat (*10), always >0
          character*1   gen_latns       ! 'N' or 'S'
          integer       gen_lon         ! Storm Lon (*10), always >0
          character*1   gen_lonew       ! 'E' or 'W'
          integer       gen_vmax        ! max sfc wind speed (knots)
          integer       gen_pcen        ! Min central pressure (mb)
          character*2   gen_stype       ! Storm type (= 'XX' for now)
          integer       gen_wthresh     ! Wind threshold (34, 50, 64 kt)
          character*3   gen_quad_id     ! NEQ = start with NE quadrant
          integer       gen_ne_quad     ! Wind radius in NE quad (nm)
          integer       gen_se_quad     ! Wind radius in SE quad (nm)
          integer       gen_sw_quad     ! Wind radius in SW quad (nm)
          integer       gen_nw_quad     ! Wind radius in NW quad (nm)
          integer       gen_pclose      ! pressure (mb) outer circle
          integer       gen_rpclose     ! Radius of pressure (mb) outer circle
          integer       gen_rmw         ! Radius of Maximum Wind
          integer       gen_cps1        ! CPS Parameter_B
          integer       gen_cps2        ! CPS VTL
          integer       gen_cps3        ! CPS VTU
          character*1   gen_wcore       ! Warm core 300-500mb mean
          integer       gen_mdir        ! Vortex translational direction
          integer       gen_mspd        ! Vortex translational speed
          integer       gen_cbm850      ! Vorticity Barnes mean at 850mb
          integer       gen_cgrd850     ! Vorticity grid maximum at 850mb
          integer       gen_cbm700      ! Vorticity Barnes mean at 700mb
          integer       gen_cgrd700     ! Vorticity grid maximum at 700mb
          real          gen_tbm1        ! Temperature Barnes mean at 300-500mb
          real          gen_tmean       ! Temperature mean(10X10) at 300-500mb
          real          gen_ush_min     ! Ushear 200-850mb minimum
          real          gen_ush_mean    ! Ushear 200-850mb mean (10X10 degree)
          real          gen_rh_min      ! RH minimum 500mb
          real          gen_rh_mean     ! RH mean (10X10 degree) 500mb
          real          gen_tbm2        ! Temperature Barnes mean at 300-500mb
          real          gen_tgrd        ! Temperature grid maximum at 300-500mb
        end type atcf_gen_card
      end module define_atcf_gen_rec

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      program filter_gen_track
      USE define_atcfunix_rec
      USE define_atcf_gen_rec

      type (atcfunix_card) inprec
      type (atcf_gen_card) stm
      real tdif

      readloop: do while (.true.)

        read (41,85,end=870) stm

        if(stm%gen_basin/='TG') then

        tdif=stm%gen_tgrd-stm%gen_tmean  

c        if(stm%gen_vmax.ge.10.and.tdif.ge.0.5
c     &     .and.abs(stm%gen_cgrd850).ge.100
c     &     .and.stm%gen_ush_min.lt.0.0
c     &     .and.stm%gen_rh_mean.ge.60.0 ) then

c        print *,stm%gen_basin, stm%gen_vmax, tdif, abs(stm%gen_cgrd850)
cJ.Peng----2012-06-12------------------------
c        if(stm%gen_vmax.ge.10.and.tdif.ge.0.5
c     &     .and.abs(stm%gen_cgrd850).ge.100 ) then

          write (42,86) stm

          inprec%atx_basin=stm%gen_basin
          inprec%atx_storm_num=stm%gen_storm_num(2:3)
          inprec%atx_ymdh=stm%gen_ymdh
          inprec%atx_technum=stm%gen_technum
          inprec%atx_model=stm%gen_model
          inprec%atx_fcsthr=stm%gen_fcsthr
          inprec%atx_lat=stm%gen_lat
          inprec%atx_latns=stm%gen_latns 
          inprec%atx_lon=stm%gen_lon
          inprec%atx_lonew=stm%gen_lonew
          inprec%atx_vmax=stm%gen_vmax
          inprec%atx_pcen=stm%gen_pcen
          inprec%atx_stype=stm%gen_stype
          inprec%atx_wthresh=stm%gen_wthresh
          inprec%atx_quad_id=stm%gen_quad_id          
          inprec%atx_ne_quad=stm%gen_ne_quad
          inprec%atx_se_quad=stm%gen_se_quad
          inprec%atx_sw_quad=stm%gen_sw_quad
          inprec%atx_nw_quad=stm%gen_nw_quad

          write (43,81) inprec%atx_basin, inprec%atx_storm_num,
     & inprec%atx_ymdh, inprec%atx_technum, inprec%atx_model,
     & inprec%atx_fcsthr, inprec%atx_lat, inprec%atx_latns,
     $ inprec%atx_lon, inprec%atx_lonew, inprec%atx_vmax,
     & inprec%atx_pcen, inprec%atx_stype, inprec%atx_wthresh,
     & inprec%atx_quad_id, inprec%atx_ne_quad, inprec%atx_se_quad,
     & inprec%atx_sw_quad, inprec%atx_nw_quad
c        endif
        endif
      enddo readloop

 85   format (a2,2x,a4,2x,a30,2x,a10,2x,a2,2x,a4,2x,i3
     &       ,2x,i3,a1,2x,i4,a1,2x
     &       ,i3,2x,i4,2x,a2,2x,i3,2x,a3,4(2x,i4),3(2x,i4),3(2x,i6)
     &       ,2x,a1,6(2x,i4),8(2x,f8.1))
 86   format (a2,', ',a4,', ',a30,', ',a10,', ',a2
     &       ,', ',a4,', ',i3.3,', ',i3,a1 ,', ',i4,a1
     &       ,', ',i3,', ',i4,', ',a2,', ',i3,', '
     &       ,a3,4(', ',i4.4),3(', ',i4),3(', ',i6),', ',a1
     &       ,6(', ',i4),8(', ',f8.1))
 81   format (a2,', ',a2,', ',a10,', ',a2,', ',a4,
     &       ', ',i3.3,', ',i3,a1,', ',i4,a1,', '
     &       ,i3,', ',i4,', ',a2,', ',i3,', ',a3,4(', ',i4.4))
 870  continue
      stop
      end
c-----------------------------------------------------------------------

c$$$  Subprogram Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Subprogram: input_acqc
c   Programmer: D. Keyser       Org: NP22       Date: 2016-12-09
c
c Abstract: Reads aircraft reports (mass and wind pieces) out of the input PREPBUFR file (in
c   message types 'AIRCAR' and 'AIRCFT') and stores merged (mass and wind) data into memory
c   (e.g., alat, alon, ht_ft, idt, ob_*, xiv_* and ichk_* arrays) for later use by the NRL QC
c   kernel (acftobs_qc).  Some NCEP data values are translated to NRL standards (e.g., u/v to
c   dir/spd, quality information, and report type).  Also stores merged input "event"
c   information into memory (e.g., nevents, *ob_ev, *qm_ev, *pc_ev, *rc_ev, *pg and *pp
c   arrays) for use when later constructing merged (mass and wind) profile reports in
c   PREPBUFR-like file (if requested, i.e., l_doprofiles=T).
c
c Program History Log:
c 2010-11-15  S. Bender  -- Original Author
c 2012-05-08  D. Keyser  -- Prepared for operational implementation
c 2012-11-20  J. Woollen -- Initial port to WCOSS
c 2013-02-07  D. Keyser  -- Will now store pressure and pressure-altitude only from the first
c                           (mass) piece of a mass/wind piece pair rather than re-store it
c                           again from the second (wind) piece - even though they "should" be
c                           the same in both pieces (see % below for exception), there can be
c                           rare cases when at least pressure-altitude is missing in the wind
c                           piece (due to a bug in PREPDATA where unreasonably-high winds are
c                           set to missing and an "empty" wind piece is still encoded into
c                           PREPBUFR, this can lead to floating point exception errors in the
c                           construction of profiles {note that pressure & pressure-altitude
c                           from reports with only a wind piece will be read since it is the
c                           first (only) piece of the report}: % - there can be cases where
c                           the pressure qualty mark (PQM) is different in the mass piece vs.
c                           the wind piece (e.g., when it is set to 10 for reports near
c                           tropical systems by SYNDATA), so it is better to pick up PQM from
c                           the mass report for use in the merged mass/wind profiles, an added
c                           benefit of this chg; if the total number of merged (mass + wind
c                           piece) aircraft-type reports read in from PREPBUFR file is at
c                           least 90% of maximum allowed, print diagnostic warning message
c                           to production joblog file prior to returning from this subroutine
c 2013-02-07  D. Keyser  -- Final changes to run on WCOSS: use formatted print statements
c                           where previously unformatted print was > 80 characters
c 2014-09-03  D. Keyser  -- If no aircraft reports of any type are read from input PREPBUFR
c                           file, no further processing is performed other than the usual
c                           stdout print summary at the end.
c 2016-12-09  D. Keyser  --
c                 - Nomenclature change: replaced "MDCRS/ACARS" with just "MDCRS".
c                 - New LATAM AMDARs contain an encrypted flight number (in addition to a tail
c                   number, all other AMDARs have only a tail number which is copied into
c                   flight number). Read this in and use in QC processing.
c                   BENEFIT: Improves track-checking and other QC for LATAM AMDARs.
c                 - Latitude/longitdue arrays "alat" and "alon" passed out of this subroutine
c                   now double precision. XOB and YOB in PREPBUFR file now scaled to 10**5
c                   (was 10**2) to handle new v7 AMDAR and MDCRS reports which have this
c                   higher precision.
c                   BENEFIT: Retains exact precison here. Improves QC processing.
c                      - Note: QC here can be improved further by changing logic to account
c                              for the increased precision. This needs to be investigated.
c                              For now, location in code where this seems possible is noted by
c                              the spanning comments:
c                      ! vvvv DAK-future change perhaps to account for incr. lat/lon precision
c                      ! ^^^^ DAK-future change perhaps to account for incr. lat/lon precision
c
c Usage: call input_acqc(inlun,max_reps,mxnmev,bmiss,imiss,amiss,
c                        m2ft,mxlv,nrpts4QC,cdtg_an,alat,alon,ht_ft,
c                        idt,c_dtg,itype,phase,t_prcn,c_acftreg,
c                        c_acftid,pres,ob_t,ob_q,ob_dir,ob_spd,
c                        ichk_t,ichk_q,ichk_d,ichk_s,
c                        nchk_t,nchk_q,nchk_d,nchk_s,
c                        xiv_t,xiv_q,xiv_d,xiv_s,
c                        l_minus9C,nevents,hdr,acid,rct,drinfo,
c                        acft_seq,turb1seq,turb2seq,turb3seq,
c                        prewxseq,cloudseq,afic_seq,mstq,cat,rolf,
c                        nnestreps,sqn,procn,
c                        pob_ev,pqm_ev,ppc_ev,prc_ev,pbg,ppp,
c                        zob_ev,zqm_ev,zpc_ev,zrc_ev,zbg,zpp,
c                        tob_ev,tqm_ev,tpc_ev,trc_ev,tbg,tpp,
c                        qob_ev,qqm_ev,qpc_ev,qrc_ev,qbg,qpp,
c                        uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,wbg,wpp,
c                        ddo_ev,ffo_ev,dfq_ev,dfp_ev,dfr_ev,
c                        l_allev_pf)
c
c   Input argument list:
c     inlun        - Unit number for the input pre-PREPACQC PREPBUFR file containing all data
c                    (separate mass/wind pieces)
c     max_reps     - Maximum number of reports accepted by acftobs_qc
c     mxnmev       - Maximum number of events allowed, per variable type
c     bmiss        - BUFRLIB missing value (set in main program)
c     imiss        - NRL integer missing value flag (99999)
c     amiss        - NRL real missing value flag (-9999.)
c     m2ft         - NRL conversion factor to convert meters to feet
c     mxlv         - Maximum number of levels allowed in a report profile
c     l_allev_pf   - Logical whether to process latest (likely NRLACQC) event plus all prior
c                    events (TRUE) or only latest event (FALSE) into profiles PREPBUFR-like
c                    file (if TRUE means read in these pre-existing events here)
c
c   Output argument list:
c     nrpts4QC     - Total number of input merged (mass + wind piece) aircraft-type reports
c                    read in from PREPBUFR file
c     cdtg_an      - Date/analysis time (YYYYMMDDCC)
c     alat         - Array of latitudes for the "merged" reports
c     alon         - Array of longitudes for the "merged" reports
c     ht_ft        - Array of altitudes for the "merged" reports
c     idt          - Array of ob-cycle times for the "merged" reports (in seconds)
c     itype        - Array of aircraft type for the "merged" reports
c     phase        - Array of phase of flight for aircraft for the "merged" reports
c     t_prcn       - Array of temperature precision for the "merged" reports
c     c_acftreg    - Array of aircraft tail numbers for the "merged" reports to later be used
c                    in NRL QC processing
c     c_acftid     - Array of aircraft flight numbers for the "merged" reports to later be
c                    used in NRL QC processing
c     pres         - Array of pressure for the "merged" reports
c     ob_t         - Array of aircraft temperature for the "merged" reports
c     ob_q         - Array of aircraft moisture (specific humidity) for the "merged" reports
c     ob_dir       - Array of aircraft wind direction for the "merged" reports
c     ob_spd       - Array of aircraft wind speed for the "merged" reports
c     ichk_t       - NRL QC flag for temperature ob
c     ichk_q       - NRL QC flag for moisture ob
c     ichk_d       - NRL QC flag for wind direction ob
c     ichk_s       - NRL QC flag for wind speed ob
c     nchk_t       - NCEP PREPBUFR QC flag for temperature ob
c     nchk_q       - NCEP PREPBUFR QC flag for moisture ob
c     nchk_d       - NCEP PREPBUFR QC flag for wind direction ob
c     nchk_s       - NCEP PREPBUFR QC flag for wind speed ob
c     xiv_t        - Array of aircraft temperature innovations (ob-bg) for "merged" reports
c     xiv_q        - Array of aircraft moisture innovations (ob-bg) for "merged" reports
c     xiv_d        - Array of aircraft wind direction innovations (ob-bg) for "merged" reports
c     xiv_s        - Array of aircraft wind speed innovations (ob-bg) for "merged" reports
c     l_minus9C    - Array of logicals denoting aircraft with -9C temperature for "merged"
c                    reports
c     nevents      - Array tracking number of events for all variables (p, q, t, z, u/v,
c                    dir/spd) for "merged" reports
c     hdr          - Array of aircraft report headers info for "merged" reports
c     acid         - Array of aircraft report flight numbers for "merged" MDCRS and AMDAR
c                    (LATAM only) reports (read in from 'ACID' in input PREPBUFR file)
c     rct          - Array of aircraft report receipt times for "merged" reports
c     drinfo       - Array of aircraft "drift" info (just XOB, YOB, DHR right now) for
c                    "merged" reports
c     acft_seq     - Array of temperature precision and phase of flight for aircraft for the
c                    "merged" reports
c     turb1seq     - Array of type 1 aircraft turbulence for the "merged" reports
c     turb2seq     - Array of type 2 aircraft turbulence for the "merged" reports
c     turb3seq     - Array of type 3 aircraft turbulence for the "merged" reports
c     prewxseq     - Array of present weather info for the "merged" reports
c     cloudseq     - Array of cloud info for the "merged" reports
c     afic_seq     - Array of aircraft icing info for the "merged" reports
c     mstq         - Array of aircraft moisture flags for the "merged" reports
c     cat          - Array of PREPBUFR level category values ("CAT") for the "merged" reports
c     rolf         - Aircraft of aircraft roll angle flags for the "merged" reports
c     nnestreps    - Array containing the Number of "nested replications" for turbulence,
c                    present weather, cloud and icing for the "merged" reports
c     sqn          - Array containing the original PREPBUFR mass and wind piece sequence
c                    numbers ("SQN") for the "merged" reports
c     procn        - Array containing the original PREPBUFR mass and wind piece poe process
c                    numbers ("PROCN") for the "merged" reports
c     pob_ev       - Array of pressure event obs for "merged" reports
c     pqm_ev       - Array of pressure event quality marks for "merged" reports
c     ppc_ev       - Array of pressure event program codes for "merged" reports
c     prc_ev       - Array of pressure event reason codes for "merged" reports
c     pbg          - Array of pressure background data for "merged" reports
c     ppp          - Array of pressure post-processing info for "merged" reports
c     zob_ev       - Array of altitude event obs for "merged" reports
c     zqm_ev       - Array of altitude event quality marks for "merged" reports
c     zpc_ev       - Array of altitude event program codes for "merged" reports
c     zrc_ev       - Array of altitude event reason codes for "merged" reports
c     zbg          - Array of altitude background data for "merged" reports
c     zpp          - Array of altitude post-processing info for "merged" reports
c     tob_ev       - Array of temperature event obs for "merged" reports
c     tqm_ev       - Array of temperature event quality marks for "merged" reports
c     tpc_ev       - Array of temperature event program codes for "merged" reports
c     trc_ev       - Array of temperature event reason codes for "merged" reports
c     tbg          - Array of temperature background data "merged" reports
c     tpp          - Array of temperature post-processing info for "merged" reports
c     qob_ev       - Array of moisture event obs for "merged" reports
c     qqm_ev       - Array of moisture event quality marks for "merged" reports
c     qpc_ev       - Array of moisture event program codes for "merged" reports
c     qrc_ev       - Array of moisture event reason codes for "merged" reports
c     qbg          - Array of moisture background data for "merged" reports
c     qpp          - Array of moisture post-processing info for "merged" reports
c     uob_ev       - Array of wind/u-comp event obs for "merged" reports
c     vob_ev       - Array of wind/v-comp event obs for "merged" reports
c     wqm_ev       - Array of wind event quality marks for "merged" reports
c     wpc_ev       - Array of wind event program codes for "merged" reports
c     wrc_ev       - Array of wind event reason codes for "merged" reports
c     wbg          - Array of wind background data for "merged" reports
c     wpp          - Array of wind post-processing info for "merged" reports
c     ddo_ev       - Array of wind direction event obs for "merged" reports
c     ffo_ev       - Array of wind speed event obs for "merged" reports
c     dfq_ev       - Array of wind direction/speed quality marks  for "merged" reports
c     dfp_ev       - Array of wind direction/speed program codes for "merged" reports
c     dfr_ev       - Array of wind direction/speed reason codes for "merged" reports
c
c   Input files:
c     Unit inlun   - PREPBUFR file containing all obs, prior to any processing by this program
c
c   Output files:
c     Unit 06      - Standard output print
c
c   Subprograms called:
c     Unique:    none
c     Library:
c       SYSTEM:  SYSTEM
c       W3NCO:   ERREXIT    W3TAGE     W3MOVDAT
c       W3EMC:   W3FC05
c       BUFRLIB: IREADMG    IREADSB    UFBINT     UFBSEQ     UFBEVN     READNS     IBFMS
c
c   Exit States:
c     Cond =  0 - successful run
c            23 - unexpected return code from readns; problems reading BUFR file
c
c Remarks: Called by main program.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine input_acqc(inlun,max_reps,mxnmev,bmiss,imiss,amiss,
     +                      m2ft,mxlv,nrpts4QC,cdtg_an,alat,alon,ht_ft,
     +                      idt,c_dtg,itype,phase,t_prcn,c_acftreg,
     +                      c_acftid,pres,ob_t,ob_q,ob_dir,ob_spd,
     +                      ichk_t,ichk_q,ichk_d,ichk_s,
     +                      nchk_t,nchk_q,nchk_d,nchk_s,
     +                      xiv_t,xiv_q,xiv_d,xiv_s,
     +                      l_minus9C,nevents,hdr,acid,rct,drinfo,
     +                      acft_seq,turb1seq,turb2seq,turb3seq,
     +                      prewxseq,cloudseq,afic_seq,mstq,cat,rolf,
     +                      nnestreps,sqn,procn,
     +                      pob_ev,pqm_ev,ppc_ev,prc_ev,pbg,ppp,
     +                      zob_ev,zqm_ev,zpc_ev,zrc_ev,zbg,zpp,
     +                      tob_ev,tqm_ev,tpc_ev,trc_ev,tbg,tpp,
     +                      qob_ev,qqm_ev,qpc_ev,qrc_ev,qbg,qpp,
     +                      uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,wbg,wpp,
     +                      ddo_ev,ffo_ev,dfq_ev,dfp_ev,dfr_ev,
     +                      l_allev_pf)

      implicit none

c ------------------------------
c Parameter statements/constants
c ------------------------------
      integer inlun             ! input unit number (for pre-prepacqc PREPBUFR file
                                !  containing all obs)
      integer max_reps	        ! maximum number of input merged (mass + wind piece)
                                !  aircraft-type reports allowed
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c replace above with this in event of future switch to dynamic memory allocation

calloc  integer max_reps           ! original number of input merged (mass + wind piece)
calloc                             !  aircraft-type reports (obtained from first pass through
calloc                             !  input PREPBUFR file to get total for array
calloc                             !  allocation should = nrpts4QC)
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      character*6  cmax_reps    ! character form of max_reps
      integer      imiss        ! NRL integer missing value flag
      real         amiss        ! NRL real missing value flag
      real*8       bmiss        ! BUFRLIB missing value (set in main program)
      real         m2ft         ! NRL conversion factor to convert m to ft
      integer      mxlv         ! maximum number of report levels allowed in aircraft
                                !  profiles

c ----------------------
c Declaration statements
c ----------------------

c Variables for BUFRLIB interface
c -------------------------------
      character*8  mesgtype     ! BUFR message type (e.g., 'AIRCFT  ')
      integer      mesgdate     ! date time from BUFR message (YYYYMMDDHH)

c Logicals controlling processing (read in from namelist in main program)
c -----------------------------------------------------------------------
      logical l_allev_pf        ! T=process latest (likely NRLACQC) events plus all prior
                                !   events into profiles PREPBUFR-like file (here means must
                                !   read in these pre-existing events)
                                !   **CAUTION: More complete option, but will make code take
                                !              longer to run!!!
                                ! F=process ONLY latest (likely NRLACQC) events into profiles
                                !   PREPBUFR-like file (here means read in only latest events
                                !   which will likely be written over later by NRLACQC events)
                                !
                                ! Note 1: Hardwired to F if l_doprofiles=F
                                ! Note 2: All pre-existing events plus latest (likely NRLACQC)
                                !         events are always encoded into full PREPBUFR file)

c Indices/counters 
c ----------------
      integer      i,j          ! loop indeces
     +,            invi         ! "inverse" of the i counter

c for BUFR messages:
      integer      nACmsg_tot   ! number of acft-type BUFR messages in input PREPBUFR file

c for BUFR subsets/reports:
      integer      nrptsaircar         ! number of AIRCAR BUFR subsets read from PREPBUFR file
                                       !  (should = nmswd(2,1) + nmswd(2,2))
     +,	           nrptsaircft         ! number of AIRCFT BUFR subsets read from PREPBUFR file
                                       !  (should = nmswd(1,1) + nmswd(1,2))
     +,	           nmswd(2,2)          ! number of ((AIRCFT,AIRCAR),(mass,wind)) BUFR subsets
                                       !  read from PREPBUFR file
     +,	           nrpts_rd            ! total number of aircraft-type BUFR subsets read from
                                       !  PREPBUFR file (should =
                                       !  nmswd(1,1) + nmswd(1,2) + nmswd(2,1) + nmswd(2,2))
     +,	           nrpts4QC            ! total number of input merged (mass + wind piece)
                                       !  aircraft-type reports read in from PREPBUFR file
                                       !  (should = numpairs + numorph)

      integer      numpairs  	       ! number of input merged (mass + wind piece) aircraft-
                                       !  type reports read in from PREPBUFR file where there
                                       !  is BOTH mass and wind data
                                       !  (should = numAIRCFTpairs + numAIRCARpairs)
     +,            numorph             ! number of input merged (mass + wind piece) aircraft-
                                       !  type reports read in from PREPBUFR file where there
                                       !  is either ONLY mass data or only wind data (deemed
                                       !  "orphans", of course in reality there is no merging
                                       !  here) (should = numAIRCFTorph + numAIRCARorph)
     +,            numAIRCFTpairs      ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  where there is BOTH mass and wind data
     +,            numAIRCARpairs      ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCAR BUFR messages in PREPBUFR file
                                       !  where there is BOTH mass and wind data
     +,            numAIRCFTorph       ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  where there is either ONLY mass data or only wind
                                       !  data (deemed "orphans", of course in reality there
                                       !  is no merging here)
     +,	           numAIRCARorph       ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCAR BUFR messages in PREPBUFR file
                                       !  where there is either ONLY mass data or only wind
                                       !  data (deemed "orphans", of course in reality there
                                       !  is no merging here)

      integer      nPIREP 	       ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  that are deemed to be "PIREP" reports
     +,	           nAUTOAIREP          ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  that are deemed to be automated AIREP reports
     +,	           nMANAIREP           ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  that are deemed to be Manual AIREP (all "voice")
                                       !  reports
     +,	           nAMDAR              ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  that are deemed to be AMDAR reports (excluding
                                       !  Canadian AMDAR)
     +,	           nAMDARcan           ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  that are deemed to be Canadian AMDAR reports
     +,	           nMDCRS              ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCAR BUFR messages in PREPBUFR file
                                       !  (all are MDCRS reports)
     +,            nTAMDAR             ! number of input merged (mass + wind piece) reports
                                       !  read in from AIRCFT BUFR messages in PREPBUFR file
                                       !  that are deemed to be TAMDAR reports

c Functions
c ---------
      integer      ireadmg             ! BUFRLIB - for reading messages 
     +,            ireadsb             ! BUFRLIB - for reading subsets
     +,            ibfms               ! BUFRLIB - for testing for missing

c Observation arrays
c ------------------
      character*10   cdtg_an             ! date-time group for analysis (YYYYMMDDCC)
      character*14   c_dtg(max_reps)     ! full date-time group (yyyymmddhhmmss)
      character*8    c_acftreg(max_reps) ! aircraft registration (tail) number (used in NRL
                                         !  QC processing)
      character*9    c_acftid(max_reps)  ! aircraft flight number (used in NRL QC processing)
      real*8         alat(max_reps)    ! latitude
     +,              alon(max_reps)    ! longitude
      real           pres(max_reps)    ! pressure
     +,              ht_ft(max_reps)   ! altitude in feet
     +,              t_prcn(max_reps)  ! temperature precision
     +,              ob_t(max_reps)    ! temperature
     +,              ob_q(max_reps)    ! moisture (specific humidity)
     +,              ob_dir(max_reps)  ! wind direction
     +,              ob_spd(max_reps)  ! wind speed
     +,              xiv_t(max_reps)   ! temperature innovation/increment (ob-bg)
     +,              xiv_q(max_reps)   ! specific humidity innovation/increment (ob-bg)
     +,              xiv_d(max_reps)   ! wind direction innovation/increment (ob-bg)
     +,              xiv_s(max_reps)   ! wind speed innovation/increment (ob-bg)
      integer        itype(max_reps)   ! instrument (aircraft) type 
     +,              idt(max_reps)     ! time in seconds to anal. time (- before, + after)
     +,              ichk_t(max_reps)  ! NRL QC flag for temperature ob
     +,              ichk_q(max_reps)  ! NRL QC flag for specific humidity ob
     +,              ichk_d(max_reps)  ! NRL QC flag for wind direction ob
     +,              ichk_s(max_reps)  ! NRL QC flag for wind speed ob
     +,              nchk_t(max_reps)  ! NCEP QC flag for temperature ob
     +,              nchk_q(max_reps)  ! NCEP QC flag for specific humidity ob
     +,              nchk_d(max_reps)  ! NCEP QC flag for wind direction ob
     +,              nchk_s(max_reps)  ! NCEP QC flag for wind speed ob
     +,              phase(max_reps)   ! phase of flight for aircraft

      logical        l_minus9c(max_reps) ! true for MDCRS -9C temperatures

c Variables for reading numeric data out of BUFR files via BUFRLIB
c ----------------------------------------------------------------
      real*8         arr_8(15,10)      ! array holding BUFR subset values from BUFRLIB call to
                                       !  input PREPBUFR file
      integer        nlev              ! number of report levels returned from BUFRLIB call
     +,              iret              ! return code for call to BUFRLIB routine readns

c Variables for reading character data out of BUFR files w/ BUFRLIB
c -----------------------------------------------------------------
      real*8         c_arr_8           ! real*8 PREPBUFR report id ("SID")
      character*8    charstr           ! character*8 equivalent of c_arr_8

      equivalence(charstr,c_arr_8)

c Variables for reading event values out of BUFR files w/ BUFRLIB
c --------------------------------------- -----------------------
      integer mxevdt                   ! maximum number of events allowed for each ob type
      parameter (mxevdt = 10)

      integer mxnmev                   ! maximum number of events allowed in stack
     +,       mxvt                     ! maximum number of variable types (P, Q, T, Z, U, V)
      parameter (mxvt = 6)

      integer      qms(4)              ! pointers to ichk_[t,q,d,s]
      character*1  QM_types(4)         ! characters for QM variable types
     +                         /'T','Q','D','S'/

      real*8  pqtzuvEV(mxevdt,mxlv,mxnmev,mxvt) ! holds values read from PREPBUFR file
                                                !  (according to type,level,event,variable)

      character*80    EVstr(mxvt)                ! mnemonic string for populating pqtzuvEV
     +                 /'POB PQM PPC PRC PFC PAN CAT', ! pressure
     +                  'QOB QQM QPC QRC QFC QAN CAT', ! moisture
     +                  'TOB TQM TPC TRC TFC TAN CAT', ! temperature
     +                  'ZOB ZQM ZPC ZRC ZFC ZAN CAT', ! altitude
     +                  'UOB WQM WPC WRC UFC UAN CAT', ! u-wind
     +                  'VOB WQM WPC WRC VFC VAN CAT'/ ! v-wind

      real    uob                      ! u-component wind for a single report
     +,       vob                      ! v-component wind for a single report
     +,       ufc                      ! u-component background wind for a single report
     +,       vfc                      ! v-component background wind for a single report
     +,       dir_fc                   ! wind direction background for a single report
     +,       spd_fc                   ! wind speed background for a single report

      integer evknt                    ! counter used when determining number of events per
                                       !  variable type

      real*8  df_arr(5,mxlv,mxnmev)    ! array used to read out wind (dir/spd) events

c Variables for determining whether consecutive reports are mass and wind pieces that belong
c  together
c ------------------------------------------------------------------------------------------
      logical l_massrpt                ! TRUE if report read in from PREPBUFR is a mass piece
     +,       l_windrpt                ! TRUE if report read in from PREPBUFR is a wind piece
     +,       l_match                  ! TRUE if mass and wind reports currently being
                                       !  processed match (they are part of the same total
                                       !  aircraft report)

      real    sqn_current              ! PREPBUFR sequence number ("SQN") of current report
     +,       sqn_next                 ! PREPBUFR sequence number ("SQN") of previous report
     +,       procn_current            ! PREPBUFR poes process number ("PROC") of current
                                       !  report

c Variables for converting idt to YYYYMMDDHHMMSS format (stored in array c_dtg)
c -----------------------------------------------------------------------------
      integer year                     ! year of analysis time
     +,       month                    ! month of analysis time
     +,       day                      ! day of analysis time
     +,       hour                     ! hour of analysis time
     +,       idat(8)                  ! input array for call to w3movdat
     +,       jdat(8)                  ! output array for call to w3movdat
      real    rinc(5)                  ! array containing time increment for w3movdat


c Variables used to hold original aircraft data read from the input PREPBUFR file - necessary
c  for carrying data through program so that it can be written to output profiles PREPBUFR-
c  like file from memory instead of going back to input PREPBUFR file and re-reading that
c  file before adding any QC events resulting from a decision made by the NRL QC routine (not
c  applicable for case of single-level QC'd reports written back to full PREPBUFR file)
c --------------------------------------------------------------------------------------------
      integer nevents(max_reps,6)      ! array tracking number of events for variables for
                                       !  each report:
                                       !   1 - number of pressure events
                                       !   2 - number of specific humidity events
                                       !   3 - number of temperature events
                                       !   4 - number of altitude events
                                       !   5 - number of wind (u/v) events
                                       !   6 - number of wind (direction/speed) events

      integer nnestreps(4,max_reps)    ! number of "nested replications" for TURB3SEQ,
                                       !  PREWXSEQ, CLOUDSEQ, AFIC_SEQ

      integer nrep                     ! number of "nested replications" for TURB3SEQ
                                       !  PREWXSEQ, CLOUDSEQ, AFIC_SEQ prior to setting to
                                       !  nnestreps

      real*8  pob_ev(max_reps,mxnmev)  ! POB values for each report, including all events
     +,       pqm_ev(max_reps,mxnmev)  ! PQM values for each report, including all events
     +,       ppc_ev(max_reps,mxnmev)  ! PPC values for each report, including all events
     +,       prc_ev(max_reps,mxnmev)  ! PRC values for each report, including all events
     +,       zob_ev(max_reps,mxnmev)  ! ZOB values for each report, including all events
     +,       zqm_ev(max_reps,mxnmev)  ! ZQM values for each report, including all events
     +,       zpc_ev(max_reps,mxnmev)  ! ZPC values for each report, including all events
     +,       zrc_ev(max_reps,mxnmev)  ! ZRC values for each report, including all events
     +,       tob_ev(max_reps,mxnmev)  ! TOB values for each report, including all events
     +,       tqm_ev(max_reps,mxnmev)  ! TQM values for each report, including all events
     +,       tpc_ev(max_reps,mxnmev)  ! TPC values for each report, including all events
     +,       trc_ev(max_reps,mxnmev)  ! TRC values for each report, including all events
     +,       qob_ev(max_reps,mxnmev)  ! QOB values for each report, including all events
     +,       qqm_ev(max_reps,mxnmev)  ! QQM values for each report, including all events
     +,       qpc_ev(max_reps,mxnmev)  ! QPC values for each report, including all events
     +,       qrc_ev(max_reps,mxnmev)  ! QRC values for each report, including all events
     +,       uob_ev(max_reps,mxnmev)  ! UOB values for each report, including all events
     +,       vob_ev(max_reps,mxnmev)  ! VOB values for each report, including all events
     +,       wqm_ev(max_reps,mxnmev)  ! WQM values for each report, including all events
     +,       wpc_ev(max_reps,mxnmev)  ! WPC values for each report, including all events
     +,       wrc_ev(max_reps,mxnmev)  ! WRC values for each report, including all events
     +,       ddo_ev(max_reps,mxnmev)  ! DDO values for each report, including all events
     +,       ffo_ev(max_reps,mxnmev)  ! FFO values for each report, including all events
     +,       dfq_ev(max_reps,mxnmev)  ! DFQ values for each report, including all events
     +,       dfp_ev(max_reps,mxnmev)  ! DFP values for each report, including all events
     +,       dfr_ev(max_reps,mxnmev)  ! DFR values for each report, including all events

     +,       hdr(max_reps,15)         ! SID XOB YOB DHR ELV TYP T29 TSB ITP SQN PROCN RPT
                                       !  TCOR RSRD EXRSRD
     +,       acid(max_reps)           ! ACID
     +,       rct(max_reps)            ! RCT

     +,       pbg(max_reps,3)          ! POE PFC PFCMOD
     +,       zbg(max_reps,3)          ! ZOE ZFC ZFCMOD
     +,       tbg(max_reps,3)          ! TOE TFC TFCMOD
     +,       qbg(max_reps,3)          ! QOE QFC QFCMOD
     +,       wbg(max_reps,5)          ! WOE UFC VFC UFCMOD VFCMOD

     +,       ppp(max_reps,3)          ! PAN PCL PCS
     +,       zpp(max_reps,3)          ! ZAN ZCL ZCS
     +,       tpp(max_reps,3)          ! TAN TCL TCS
     +,       qpp(max_reps,3)          ! QAN QCL QCS
     +,       wpp(max_reps,6)          ! UAN VAN UCL VCL UCS VCS

     +,       drinfo(max_reps,3)       ! XOB YOB DHR
     +,       acft_seq(max_reps,2)     ! PCAT POAF

     +,       turb1seq(max_reps)       ! TRBX
     +,       turb2seq(max_reps,4)     ! TRBX10 TRBX21 TRBX32 TRBX43
     +,       turb3seq(3,max_reps,5)   ! DGOT HBOT HTOT
     +,       prewxseq(1,max_reps,5)   ! PRWE
     +,       cloudseq(5,max_reps,5)   ! VSSO CLAM CLTP HOCB HOCT
     +,       afic_seq(3,max_reps,5)   ! AFIC HBOI HTOI 
     +,       mstq(max_reps)           ! MSTQ
     +,       cat(max_reps)            ! CAT
     +,       rolf(max_reps)           ! ROLF

     +,       sqn(max_reps,2)          ! SQN (1=SQN for mass, 2=SQN for wind)
     +,       procn(max_reps,2)        ! PROCN (1=PROCN for mass, 2=PROCN for wind)

c *******************************************************************

c Start subroutine
c ----------------
      write(*,*)
      write(*,*) '**********************'
      write(*,*) 'Welcome to input_acqc.'
      call system('date')
      write(*,*) '**********************'
      write(*,*)

c Input PREPBUFR file is open and ready for reading by BUFRLIB
c ------------------------------------------------------------

      print *, 'Initializing...'

c Initialize observation arrays
c -----------------------------
      ob_t   = amiss
      ob_q   = amiss
      ob_dir = amiss
      ob_spd = amiss
      xiv_t  = amiss
      xiv_q  = amiss
      xiv_d  = amiss
      xiv_s  = amiss

      nchk_t = -9
      nchk_q = -9
      nchk_d = -9
      nchk_s = -9

! vvvv DAK-future change perhaps to account for incr. lat/lon precision
      alat   = amiss
      alon   = amiss
! ^^^^ DAK-future change perhaps to account for incr. lat/lon precision
      pres   = amiss
      ht_ft  = amiss
      itype  = imiss
      idt    = imiss

      c_acftreg = '        '
      c_acftid  = '         '
      c_dtg     = '              '

      nevents = 0

      pob_ev = bmiss
      pqm_ev = bmiss
      ppc_ev = bmiss
      prc_ev = bmiss

      zob_ev = bmiss
      zqm_ev = bmiss
      zpc_ev = bmiss
      zrc_ev = bmiss

      tob_ev = bmiss
      tqm_ev = bmiss
      tpc_ev = bmiss
      trc_ev = bmiss

      qob_ev = bmiss
      qqm_ev = bmiss
      qpc_ev = bmiss
      qrc_ev = bmiss

      uob_ev = bmiss
      vob_ev = bmiss
      wqm_ev = bmiss
      wpc_ev = bmiss
      wrc_ev = bmiss

      ddo_ev = bmiss
      ffo_ev = bmiss
      dfq_ev = bmiss
      dfp_ev = bmiss
      dfr_ev = bmiss

      hdr  = bmiss
      rct  = bmiss
      acid = bmiss

      pbg = bmiss
      zbg = bmiss
      qbg = bmiss
      tbg = bmiss
      wbg = bmiss

      ppp = bmiss
      zpp = bmiss
      qpp = bmiss
      tpp = bmiss
      wpp = bmiss

      drinfo   = bmiss
      turb1seq = bmiss
      turb2seq = bmiss
      turb3seq = bmiss
      prewxseq = bmiss
      cloudseq = bmiss
      afic_seq = bmiss
      mstq     = bmiss
      cat      = bmiss
      rolf     = bmiss

      sqn   = 999999
      procn = 999999

      nnestreps = 0

      l_minus9C = .false.

      print *, 'Done initializing arrays...'

c Initialize counters
c -------------------
      nACmsg_tot = 0
      numpairs   = 0
      numorph    = 0

      nrptsaircar = 0
      nrptsaircft = 0

      nrpts_rd = 0
      nrpts4QC = 0

      numAIRCFTpairs = 0
      numAIRCARpairs = 0
      numAIRCFTorph  = 0
      numAIRCARorph  = 0

      nPIREP     = 0
      nAUTOAIREP = 0
      nMANAIREP  = 0
      nAMDAR     = 0
      nAMDARcan  = 0
      nMDCRS     = 0
      nTAMDAR    = 0

      print *, 'Done initializing counters...'
	
c Initialize logicals
c -------------------
      l_massrpt = .false.
      l_windrpt = .false.

      l_match   = .false.

      print *, 'Done initializing logicals...'

c Read data from pre-QC PREPBUFR file
c -----------------------------------
      write(*,*) 'Beginning data read!'

c Start reading messages
c ----------------------
      loop2: do while(ireadmg(inlun,mesgtype,mesgdate).eq.0)

c Only consider reports from messages with type 'AIRCFT' or 'AIRCAR'
c ------------------------------------------------------------------
        if(mesgtype.eq.'AIRCFT'.or.mesgtype.eq.'AIRCAR') then

c Update counters of messages read in and considered
c --------------------------------------------------
          nACmsg_tot = nACmsg_tot + 1

c The date in all NCEP PREPBUFR messages is the date/cycle time - use this for the variable
c  cdtg_an - no need to read in the cycle time from std input
c -----------------------------------------------------------------------------------------
          if(nACmsg_tot.eq.1) then ! obtain date/cycle from the first PREPBUFR message read
            write(cdtg_an,'(i10)') mesgdate ! Convert mesgdate to character
            write(*,*) 'Cycle date/time in PREPBUFR messages: ',cdtg_an
          endif

c Using the function ireadsb, read the PREPBUFR subsets/reports, which are separated into
c  mass and wind pieces (NCEP convention) - we will need to pull out values and populate the
c  following arrays, which will be used by the NRL aircraft QC routine:
c    itype, alat, alon, pres, ht_ft,idt, c_dtg, c_acftreg, c_acftid, t_prcn, ob_t, ob_q,
c    ob_dir, ob_spd, ichk_t, ichk_q, ichk_d, ichk_s, l_minus9C
c ------------------------------------------------------------------------------------------
          do while(ireadsb(inlun).eq.0)

 4001  	    continue
            l_match = .false. ! Reset match indicator. second halves of matches are read
                              !  starting at statement 6001

            if(mesgtype.eq.'AIRCAR') then
              nrptsaircar = nrptsaircar + 1
            elseif (mesgtype.eq.'AIRCFT') then
              nrptsaircft = nrptsaircft + 1
            else ! not an aircraft-type message, cycle back to message reading loop & see if
                 !  there are more in file
              print *, '---> MESGTYPE NOT AIRCRAFT TYPE!!!',' "', 
     +                 mesgtype,'"'
              print *, '---> keep looping through messages in case any',
     +                 ' more are in file'
              cycle loop2
            endif
            nrpts_rd = nrpts_rd + 1 ! number of aircraft-type BUFR subsets read from
                                    !  PREPBUFR file 

 5001  	    continue ! will come here if we've just stored the second of a pair or an orphan;
                     !  need to increment index for the report-oriented arrays
            if(nrpts4QC+1.gt.max_reps) then
c.......................................................................
c There are more reports in input file than "max_reps" -- do not process any more reports
c ---------------------------------------------------------------------------------------
              print 53, max_reps,max_reps
   53 format(/' #####> WARNING: THERE ARE MORE THAN ',I6,' AIRCRAFT ',
     + 'REPORTS IN INPUT FILE -- MUST INCREASE SIZE OF PARAMETER NAME',
     + ' "MAX_REPS" - WILL CONTINUE ON PROCESSING ONLY ',I6,' REPORTS'/)
              write(cmax_reps,'(i6)') max_reps
              call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     +         ' "$jlogfile" "***WARNING:'//cmax_reps//' AIRCRAFT '//
     +         'REPORT LIMIT EXCEEDED IN PREPOBS_PREPACQC, ONLY '//
     +         cmax_reps//' RPTS PROCESSED"')
              exit loop2
c.......................................................................
            endif
            nrpts4QC = nrpts4QC + 1 ! number of input merged (mass + wind piece) aircraft-
                                    !  type reports read in from PREPBUFR file (for QC code/
                                    !  index for arrays that will be used by acftobs_qc)
 6001       continue ! will come here if we need to check subset n+1 and see if it matches
                     !  the one just stored (treat subset n+1 as a new subset n)

c Pull out the "header" info for subset n, which will either be a mass or wind piece - header
c  mnemonics are: YOB XOB ELV DHR POAF TYP  PCAT, along w/ SID
c -------------------------------------------------------------------------------------------
            arr_8 = bmiss

            call ufbint(inlun,arr_8,15,10,nlev,
     +'YOB XOB ELV DHR TYP T29 TSB ITP SQN PROCN RPT TCOR RSRD EXPRSRD')

cccccc      hdr(nrpts4QC,1) = SID - stored later in code
            hdr(nrpts4QC,2) = arr_8(2,1) ! XOB
            hdr(nrpts4QC,3) = arr_8(1,1) ! YOB
            hdr(nrpts4QC,4) = arr_8(4,1) ! DHR 
            hdr(nrpts4QC,5) = arr_8(3,1) ! ELV 
            hdr(nrpts4QC,6:15) = arr_8(5:14,1) ! TYP T29 TSB ITP SQN PROCN RPT TCOR RSRD
                                               !  EXRSRD

c Drift information
c -----------------
            drinfo(nrpts4QC,1) = arr_8(2,1) ! XOB/XDR
            drinfo(nrpts4QC,2) = arr_8(1,1) ! YOB/YDR
            drinfo(nrpts4QC,3) = arr_8(4,1) ! DHR/HRDR

c Arrays used in NRL QC routine itself
c ------------------------------------
            alat(nrpts4QC) = arr_8(1,1) ! YOB
            alon(nrpts4QC) = arr_8(2,1) ! XOB
            ht_ft(nrpts4QC) = nint(arr_8(3,1)*m2ft) ! ELV in PREPBUFR is in meters NRL QC
                                                    !  wants feet
            idt(nrpts4QC) = nint(arr_8(4,1)*3600.)  ! NRL QC expects idt in sec

c Determine whether this is a temperature or a wind report
c --------------------------------------------------------
            if(int(arr_8(5,1))/100.eq.1) then
              l_massrpt = .true.
              l_windrpt = .false.

              if(mesgtype.eq.'AIRCFT') then
                nmswd(1,1) = nmswd(1,1) + 1
              elseif(mesgtype.eq.'AIRCAR') then
                nmswd(2,1) = nmswd(2,1) + 1
              endif

            elseif(int(arr_8(5,1))/100.eq.2) then
              l_massrpt = .false.
              l_windrpt = .true.

              if(mesgtype.eq.'AIRCFT') then
                nmswd(1,2) = nmswd(1,2) + 1
              elseif(mesgtype.eq.'AIRCAR') then
                nmswd(2,2) = nmswd(2,2) + 1
              endif

            endif

            itype(nrpts4QC) = mod(int(hdr(nrpts4QC,6)),100) 
                             ! 30 = NCEP: AIREP (NRL Manual AIREP/voice)
                             ! 30 = NCEP: PIREP (NRL Manual AIREP/voice)
                             ! 31 = NCEP: AMDAR (all types except Canadian) (NRL: AMDAR)
                             ! 32 = NCEP; RECCOs, but these are in ADPUPA msgs
                             ! 33 = NCEP: MDCRS (NRL: MDCRS)
                             ! 34 = NCEP: TAMDAR (NRL: ACARS)
                             ! 35 = NCEP: Canadian AMDAR (NRL: AMDAR)

c Process SQN/PROCN - they will be used to construct full reports from mass and wind pieces
c -----------------------------------------------------------------------------------------
            sqn_current = hdr(nrpts4QC,10)
            procn_current = hdr(nrpts4QC,11)

c Get turbulence values, present weather (PRWE), cloud data, etc. (these are all nested-
c  replicated)
c
c Note: These values, while there may be multiple replications of them, should be present
c       only on a single level upon input (aircraft data is organized as single-level data
c       upon input to this program - prior step is PREPDATA)
c ----------------------------------------------------------------------------------------

c turb3seq values: DGOT HBOT HTOT                
c  -- since this is not encoded to PREPBUFR-like (profiles) right now, no need to read in
ccccc       arr_8 = bmiss
ccccc
ccccc       call ufbseq(inlun,arr_8,15,10,nrep,'TURB3SEQ')
ccccc
ccccc       nnestreps(1,nrpts4QC) = nrep
ccccc
ccccc       if(nrep.ne.0) then ! There is turb3seq data to store
ccccc         do i = 1,nrep
ccccc
ccccc           if(nrep.le.5) then
ccccc             turb3seq(:,nrpts4QC,nnestreps(1,nrpts4QC)-nrep+i)
ccccc+             = arr_8(1:3,i)
ccccc           else ! there are more than 5 replications of TURB3SEQ 
ccccc             print *,'there are more than 5 reps of TURB3SEQ'
ccccc             print *,'report #', nrpts4QC
ccccc           endif ! if(nrep.le.5)
ccccc
ccccc         enddo ! do i = 1,nrep
ccccc       endif ! if(nrep.ne.0)

c prewxseq values: PRWE
c  -- since this is not encoded to PREPBUFR-like (profiles) right now, no need to read in
ccccc       arr_8 = bmiss
ccccc
ccccc       call ufbseq(inlun,arr_8,15,10,nrep,'PREWXSEQ')
ccccc
ccccc       nnestreps(2,nrpts4QC) = nrep
ccccc
ccccc       if(nrep.gt.0) then
ccccc         do i = 1,nrep
ccccc
ccccc           if(nrep.le.5) then
ccccc             prewxseq(1,nrpts4QC,nnestreps(2,nrpts4QC)-nrep+i) 
ccccc+             = arr_8(1,i)
ccccc           else ! there are more than 5 replications of PREWXSEQ
ccccc             print *,'there are more than 5 reps of PREWXSEQ'
ccccc             print *,'report #', nrpts4QC
ccccc           endif ! if(nrep.le.5)
ccccc
ccccc         enddo ! do i = 1,nrep
ccccc       endif ! if(nrep.gt.0)
 
c cloudseq values: VSSO CLAM CLTP HOCB HOCT 
c  -- since this is not encoded to PREPBUFR-like (profiles) right now, no need to read in
ccccc       arr_8 = bmiss
ccccc
ccccc       call ufbseq(inlun,arr_8,15,10,nrep,'CLOUDSEQ')
ccccc
ccccc       nnestreps(3,nrpts4QC) = nrep
ccccc
ccccc       if(nrep.gt.0) then
ccccc         do i = 1,nrep
ccccc
ccccc           if(nrep.le.5) then
ccccc             cloudseq(:,nrpts4QC,nnestreps(3,nrpts4QC)-nrep+i) 
ccccc+             = arr_8(1:5,i) 
ccccc         else ! there are more than 5 replications of the cloud data
ccccc             print *,'there are more than 5 reps of CLOUDSEQ'
ccccc             print *,'report #', nrpts4QC
ccccc           endif ! if(nrep.le.5)
ccccc        
ccccc         enddo ! do i = 1,nrep
ccccc       endif ! if(nrep.gt.0)

c afic_seq values: AFIC HBOI HTOI
c  -- since this is not encoded to PREPBUFR-like (profiles) right now, no need to read in
ccccc       arr_8 = bmiss
ccccc
ccccc       call ufbseq(inlun,arr_8,15,10,nrep,'AFIC_SEQ')
ccccc         
ccccc       nnestreps(4,nrpts4QC) = nrep
ccccc        
ccccc       if(nrep.gt.0) then
ccccc         do i = 1,nrep
ccccc
ccccc           if(nrep.le.5) then
ccccc             afic_seq(:,nrpts4QC,nnestreps(4,nrpts4QC)-nrep+i) 
ccccc+              = arr_8(1:3,i)
ccccc           else ! there are more than 5 replications of the aircraft icing data
ccccc             print *,'there are more than 5 reps of AFIC_SEQ'
ccccc             print *,'report #', nrpts4QC
ccccc           endif ! if(nrep.le.5)
ccccc
ccccc         enddo ! do i = 1,nrep		
ccccc       endif ! if(nrep.gt.0)

c Start pulling out non-nested-replicated values
c ----------------------------------------------

c acft_seq values: PCAT POAF
            arr_8 = bmiss

            call ufbint(inlun,arr_8,15,10,nlev,'PCAT POAF')

            acft_seq(nrpts4QC,:) = arr_8(1:2,1)

            if(ibfms(arr_8(2,1)).ne.0 .or. arr_8(2,1).eq.7.) then
              phase(nrpts4QC) = 9                   ! NRL sets a missing value of
            else                                    !  phase of flight = 9
              phase(nrpts4QC) = int(arr_8(2,1))
            endif

            t_prcn(nrpts4QC) = arr_8(1,1)

c turb[1,2]seq values: TRBX TRBX10 TRBX21 TRBX32 TRBX43
            arr_8 = bmiss

            call ufbint(inlun,arr_8,15,10,nlev,
     +                 'TRBX TRBX10 TRBX21 TRBX32 TRBX43')

            turb1seq(nrpts4QC) = arr_8(1,1)
            turb2seq(nrpts4QC,:) = arr_8(2:5,1)

c Other misc. values: RCT, ROLF, MSTQ, CAT
            arr_8 = bmiss

            call ufbint(inlun,arr_8,15,10,nlev,'RCT ROLF MSTQ CAT')

            rct(nrpts4QC) = arr_8(1,1)
            mstq(nrpts4QC) = arr_8(3,1)
            cat(nrpts4QC) = arr_8(4,1)
            rolf(nrpts4QC) = arr_8(2,1)

c ----------------------------------------------------------------------------------------
c ----------------------------------------------------------------------------------------
c Populate flight number and tail number arrays (c_acftid and c_acftreg, resp.)
c ----------------------------------------------------------------------------------------
            call ufbint(inlun,c_arr_8,1,1,nlev,'SID')

            hdr(nrpts4QC,1) = c_arr_8

            if(mesgtype.eq.'AIRCFT') then
              if(itype(nrpts4QC).eq.31 .or.
     +           itype(nrpts4QC).eq.35) then

c All AMDAR types currently store tail number in 'SID', while flight number is missing or all
c  blanks for all types except for LATAM (Chile) - if flight number is missing or all blanks,
c  copy 'SID' into BOTH tail number and flight number locations in NRL arrays; if flight
c  number is present and nnot all blanks (LATAM), copy flight number (from 'ACID') into flight
c  number location in NRL array
c  (Note: European AMDARs may have a valid flight number but it is not yet available in
c         PREPBUFR, when it is it will be in mnemonic 'ACID' - DAK)
c ------------------------------------------------------------------------------------------
                c_acftreg(nrpts4QC) = charstr   ! tail number
                c_acftid(nrpts4QC)  = charstr   ! flight number (default is tail number)
                call ufbint(inlun,c_arr_8,1,1,nlev,'ACID')
                if(ibfms(c_arr_8).eq.0) then
                   if(charstr.ne.'        ') then
                      c_acftid(nrpts4QC) = charstr    ! flight number ('ACID' if present, always)
                      acid(nrpts4QC) = c_arr_8        !  the case for LATAM AMDAR
                   endif
                endif

              elseif(itype(nrpts4QC).eq.30 .or.
     +               itype(nrpts4QC).eq.34) then

c AIREP currently stores flight number in 'SID', while PIREP and TAMDAR currently store a
c  manufactured ID in 'SID' - copy this into ONLY flight number location in NRL array
c  (tail number location will store an all blank tail number - missing)
c ---------------------------------------------------------------------------------------
                c_acftid(nrpts4QC)  = charstr   ! flight number
                c_acftreg(nrpts4QC) = '        '! tail number

                if(itype(nrpts4QC).eq.34)       ! TAMDARs replace '000' in characters 1-3
     +           c_acftid(nrpts4QC)(1:3) = 'TAM'!  of flight # with 'TAM' so they will pass
                                                !  "invalid data" check in acftobs_qc
              endif
            
            elseif(mesgtype.eq.'AIRCAR') then

c MDCRS from ARINC currently store tail number in 'SID' and flight number in 'ACID' - copy
c  these into  tail number and flight number locations in NRL arrays
c  (Note: MDCRS from AFWA was a rarely used backup to those from ARINC until it was
c         discontinued on 10/30/2009 - it apparently stored flight number in 'SID' and
c         in 'ACID' - store flight number in 'SID' as tail number and flight number in
c         'ACID' (if present) as flight number (even those would be the same here)
c ---------------------------------------------------------------------------------------
              c_acftreg(nrpts4QC) = charstr     ! tail number
              call ufbint(inlun,c_arr_8,1,1,nlev,'ACID')
              if(ibfms(c_arr_8).eq.0) then
                c_acftid(nrpts4QC) = charstr    ! flight number ('ACID' if present, always)
                acid(nrpts4QC) = c_arr_8        !  the case for MDCRS from ARINC)
              else
                c_acftid(nrpts4QC) = '         '! store flight number as missing (all blanks)
                                                !  if not present (may be the case for MDCRS
                                                !  from AWFA)
              endif
            endif
c ----------------------------------------------------------------------------------------
c ----------------------------------------------------------------------------------------

c Pull out obs and events for subset n
c ------------------------------------

c ********************************
c PRES, OB_T, OB_Q, OB_DIR, OB_SPD
c ********************************

c If l_allev_pf is TRUE, use ufbevn to get at data values & events - all pre-existing events
c  will be encoded into output PREPBUFR-like (profiles) file, (if l_doprofiles=T) along with
c  any new NRLQCQC events on top of them (Note: All pre-existing events are always encoded
c  into full PREPBUFR file)
c
c          |---------> data types (1=ob, 2=qm, 3=pc, 4=rc, 5=fc, 6=an, 7=cat)
c          | |-------> number of levels in the rpt (aircraft data is single level data;
c          | |         set j=1)
c          | | |-----> number of events (will store all events, but only use latest event in
c          | | |        in the top of the stack (k=1) is used by the core NRL QC code)
c          | | | |---> variable types (1=p,2=q,3=t,4=z,5=u,6=v)
c pqtzuvEV(i,j,k,l)
c
c example: pqtzuvEV(2,1,1,5) = QM for U in latest (top-of-stack) event on the 1st level

c OTHERWISE:
c If l_allev_pf is FALSE, use ufbint to get at data values for only latest (top-of-stack)
c  event - only latest event will be encoded into output PREPBUFR-like (profiles) file, (if
c  l_doprofiles=T) along with any new NRLQCQC events on top of it (runs faster but pre-
c  existing events are not recorded in output PREPBUFR-like file) (Note: All pre-existing
c  events are always encoded into full PREPBUFR file)
c
c          |---------> data types (1=ob, 2=qm, 3=pc, 4=rc, 5=fc, 6=an, 7=cat)
c          | |-------> number of levels in the rpt (aircraft data is single level data;
c          | |         set j=1)
c          | | |-----> always 1 since only one (the latest top-of-stack) event is returned
c          | | |       here
c          | | | |---> variable types (1=p,2=q,3=t,4=z,5=u,6=v)
c pqtzuvEV(i,j,1,l)
c
c example: pqtzuvEV(2,1,1,5) = QM for U in latest (top-of-stack) event on the 1st level
c ------------------------------------------------------------------------------------------
            if(.not.l_allev_pf) then
              do i = 1,mxvt
                call ufbint(inlun,pqtzuvEV(1,1,1,i),mxevdt,mxlv,nlev,
     +                      EVstr(i))
              enddo
            else
              do i = 1,mxvt
                call ufbevn(inlun,pqtzuvEV(1,1,1,i),mxevdt,mxlv,mxnmev,
     +                      nlev,EVstr(i))
              enddo
            endif

            if(.not.l_match) then

c pressure and pressure/altitude will only be read in and stored from the first (mass) piece
c  of a mass/wind piece report pair or from the first (only) piece of a wind-only report
c  rather than being re-read and re-stored again from the second (wind) piece (if a second
c  piece exists) - this not only avoids wasted processing time (since the pressure and
c  pressure-altitude should be the same in both pieces), it also prevents this code from
c  reading a missing pressure-altitude in the second piece for those rare cases when
c  unreasonably-high winds can be set to missing in PREPDATA resulting in an "empty" wind
c  piece being encoded into PREPBUFR (and leading to problems in later profile generation in
c  this code) (this is a bug in PREPDATA which will eventually be corrected)

c Count the number of pressure/altitude events in this report
c -----------------------------------------------------------
c pressure (1)
c ------------
              if(l_allev_pf) then
                evknt = 0
                do j = 1,mxnmev
c                                         |---> pressure
                  if(ibfms(pqtzuvEV(1,1,j,1)).ne.0) then
                    nevents(nrpts4QC,1) = evknt
                    exit ! exit j do loop
                  else
                    evknt = evknt + 1
                  endif
                enddo
              else
                nevents(nrpts4QC,1) = 1
              endif

c altitude (4)
c ------------
              if(l_allev_pf) then
                evknt = 0
                do j = 1,mxnmev
c                                         |---> altitude
                  if(ibfms(pqtzuvEV(1,1,j,4)).ne.0) then
                    nevents(nrpts4QC,4) = evknt
                    exit ! exit j do loop
                  else
                    evknt = evknt + 1
                  endif
                enddo
              else
                nevents(nrpts4QC,4) = 1
              endif

c Store pressure in array needed by subroutine acftobs_qc
c -------------------------------------------------------
              if(ibfms(pqtzuvEV(1,1,1,1)).eq.0) then
                pres(nrpts4QC) = pqtzuvEV(1,1,1,1) ! POB at top of stack = pressure fed to
                                                   !  NRL QC
              endif

c Store pressure events in "corral" arrays to carry through this code
c -------------------------------------------------------------------
              if(nevents(nrpts4QC,1).gt.0) then
                do i = 1,nevents(nrpts4QC,1)
                  invi = nevents(nrpts4QC,1)-i+1

c                                                 |---> acft data upon input = "single level"/
c                                                 |      1 replication of PRSLVLA
c                                                 |      |---> pressure
                  pob_ev(nrpts4QC,i) = pqtzuvEV(1,1,invi,1)
                  pqm_ev(nrpts4QC,i) = pqtzuvEV(2,1,invi,1)
                  ppc_ev(nrpts4QC,i) = pqtzuvEV(3,1,invi,1)
                  prc_ev(nrpts4QC,i) = pqtzuvEV(4,1,invi,1)
                enddo
              endif

c Store pressure background info in "corral" arrays to carry through this code
c ----------------------------------------------------------------------------
              call ufbint(inlun,arr_8,15,10,nlev,'POE PFC PFCMOD') ! only one occurence of bg
                                                                   !  info per report/level
              pbg(nrpts4QC,:) = arr_8(1:3,1)

              call ufbint(inlun,arr_8,15,10,nlev,'PAN PCL PCS') ! only one occurence of post-p
                                                                !  info per report/level
              ppp(nrpts4QC,:) = arr_8(1:3,1)

c Store altitude events in "corral" arrays to carry through this code - the actual value of
c  altitude is pulled from ELV and stored in the ht_ft array (needed by acftobs_qc) when the
c  rest of the report header information is pulled
c ------------------------------------------------------------------------------------------
              if(nevents(nrpts4QC,4).gt.0) then
                do i = 1,nevents(nrpts4QC,4)
                  invi = nevents(nrpts4QC,4)-i+1

c                                                        |---> altitude
                  zob_ev(nrpts4QC,i) = pqtzuvEV(1,1,invi,4)
                  zqm_ev(nrpts4QC,i) = pqtzuvEV(2,1,invi,4)
                  zpc_ev(nrpts4QC,i) = pqtzuvEV(3,1,invi,4)
                  zrc_ev(nrpts4QC,i) = pqtzuvEV(4,1,invi,4)
                enddo
              endif

c Store altitude background info in "corral" arrays to carry through this code
c ----------------------------------------------------------------------------
              call ufbint(inlun,arr_8,15,10,nlev,'ZOE ZFC ZFCMOD') ! only one occurence of bg
                                                                   !  info per report/level
              zbg(nrpts4QC,:) = arr_8(1:3,1)

              call ufbint(inlun,arr_8,15,10,nlev,'ZAN ZCL ZCS') ! only one occurence of post-p
                                                                !  info per report/level
              zpp(nrpts4QC,:) = arr_8(1:3,1)

            endif

c Get temperature & moisture obs, increments, quality marks
c ---------------------------------------------------------
            if(l_massrpt) then ! pull mass data

              sqn(nrpts4QC,1) = sqn_current     ! SQN (sequence number) for mass piece
              procn(nrpts4QC,1) = procn_current ! PROCN (process number) for mass piece

c Count the number of moisture events in this report
c --------------------------------------------------
c moisture (2)
c ------------
              if(l_allev_pf) then
                evknt = 0
                do j = 1,mxnmev
c                                         |---> moisture
                  if(ibfms(pqtzuvEV(1,1,j,2)).ne.0) then
                    nevents(nrpts4QC,2) = evknt
                    exit ! exit j do loop
                  else
                    evknt = evknt + 1
                  endif
                enddo
              else
                nevents(nrpts4QC,2) = 1
              endif

c Moisture (specific humidity) - use QOB from the top of event stack (pqtzuvEV(1,1,1,2)
c -------------------------------------------------------------------------------------
              if(ibfms(pqtzuvEV(1,1,1,2)).eq.0) then
                ob_q(nrpts4QC) = pqtzuvEV(1,1,1,2)*0.001 ! NRL code requires g/kg; QOB in
                                                         !  PREPBUFR file is in mg/kg
                xiv_q(nrpts4QC) = (pqtzuvEV(1,1,1,2) -
     +                pqtzuvEV(5,1,1,2))*0.001 ! use QOB at top of stack; also, there is only
                                               !  one QFC per report

                nchk_q(nrpts4QC) = int(pqtzuvEV(2,1,1,2)) ! QQM from top of event stack
              endif

c Store moisture events in "corral" arrays to carry through this code
c -------------------------------------------------------------------
              if(nevents(nrpts4QC,2).gt.0) then
                do i = 1,nevents(nrpts4QC,2)
                  invi = nevents(nrpts4QC,2)-i+1

c                                                        |---> moisture
                  qob_ev(nrpts4QC,i) = pqtzuvEV(1,1,invi,2)
                  qqm_ev(nrpts4QC,i) = pqtzuvEV(2,1,invi,2)
                  qpc_ev(nrpts4QC,i) = pqtzuvEV(3,1,invi,2)
                  qrc_ev(nrpts4QC,i) = pqtzuvEV(4,1,invi,2)
                enddo
              endif

c Store moisture background info in "corral" arrays to carry through this code
c ----------------------------------------------------------------------------
              call ufbint(inlun,arr_8,15,10,nlev,'QOE QFC QFCMOD') ! only one occurence of bg
                                                                   !  info per report/level
              qbg(nrpts4QC,:) = arr_8(1:3,1)

              call ufbint(inlun,arr_8,15,10,nlev,'QAN QCL QCS') ! only one occurence of post-
                                                                !  p info per report/level
              qpp(nrpts4QC,:) = arr_8(1:3,1)

c Count the number of temperature events in this report
c -----------------------------------------------------
c temperature (3)
c ---------------
              if(l_allev_pf) then
                evknt = 0
                do j = 1,mxnmev
c                                         |---> temperature
                  if(ibfms(pqtzuvEV(1,1,j,3)).ne.0) then
                    nevents(nrpts4QC,3) = evknt
                    exit ! exit j do loop
                  else
                    evknt = evknt + 1
                  endif
                enddo
              else
                nevents(nrpts4QC,3) = 1
              endif

c Temperature - use TOB from the top of event stack (pqtzuvEV(1,1,1,3)
c --------------------------------------------------------------------
              if(ibfms(pqtzuvEV(1,1,1,3)).eq.0) then
                ob_t(nrpts4QC) = pqtzuvEV(1,1,1,3) + 273.16 ! convert to K
                xiv_t(nrpts4QC) = pqtzuvEV(1,1,1,3) - pqtzuvEV(5,1,1,3) ! use TOB at top of
                                                                        !  stack; also, there
                                                                        !  is only one TFC
                                                                        !  per report
                nchk_t(nrpts4QC) = int(pqtzuvEV(2,1,1,3)) ! TQM from top of event stack

c Check for -9C temperature (MDCRS only)
c --------------------------------------
                l_minus9C(nrpts4QC) = .false.

                if(itype(nrpts4QC).eq.33) then
                  if(abs(ob_t(nrpts4QC)-264.16).lt.0.05) then
                    l_minus9c(nrpts4QC) = .true.
                  endif
                endif ! check for -9C temp in type = 33
              endif ! check for missing

c Store temperature events in "corral" arrays to carry through this code
c ----------------------------------------------------------------------
              if(nevents(nrpts4QC,3).gt.0) then
                do i = 1,nevents(nrpts4QC,3)
                  invi = nevents(nrpts4QC,3)-i+1

c                                                        |---> temperature
                  tob_ev(nrpts4QC,i) = pqtzuvEV(1,1,invi,3)
                  tqm_ev(nrpts4QC,i) = pqtzuvEV(2,1,invi,3)
                  tpc_ev(nrpts4QC,i) = pqtzuvEV(3,1,invi,3)
                  trc_ev(nrpts4QC,i) = pqtzuvEV(4,1,invi,3)
                enddo
              endif

c Store temperature background info in "corral" arrays to carry through this code
c -------------------------------------------------------------------------------
              call ufbint(inlun,arr_8,15,10,nlev,'TOE TFC TFCMOD') ! only one occurence of bg
                                                                   !  info per report/level
                
              tbg(nrpts4QC,:) = arr_8(1:3,1)

              call ufbint(inlun,arr_8,15,10,nlev,'TAN TCL TCS') ! only one occurence of post-
                                                                !  p info per report/level
              tpp(nrpts4QC,:) = arr_8(1:3,1)

c Get u & v obs, increments, quality marks - convert u & v to direction & speed
c -----------------------------------------------------------------------------
            elseif(l_windrpt) then ! pull u, v, convert to direction & speed

              sqn(nrpts4QC,2) = sqn_current     ! SQN (sequence number) for wind piece
              procn(nrpts4QC,2) = procn_current ! PROCN (process number) for wind piece

c Count the number of wind events in this report
c ----------------------------------------------
c Wind (5/6) - use U/VOB from the top of event stack (pqtzuvEV(1,1,1,5) and
c  (pqtzuvEV(1,1,1,6)
c -------------------------------------------------------------------------
              if(l_allev_pf) then
                evknt = 0
                do j = 1,mxnmev
c                                         |---> 5=u-comp, 6=v-comp
                  if(ibfms(pqtzuvEV(1,1,j,5)).ne.0 .or.
     +               ibfms(pqtzuvEV(1,1,j,6)).ne.0) then
                    nevents(nrpts4QC,5) = evknt
                    exit ! exit j do loop
                  else
                    evknt = evknt + 1
                  endif
                enddo
              else
                nevents(nrpts4QC,5) = 1
              endif

              uob = pqtzuvEV(1,1,1,5)
              vob = pqtzuvEV(1,1,1,6)

              ufc = pqtzuvEV(5,1,1,5) ! only one UFC per report
              vfc = pqtzuvEV(5,1,1,6) ! only one VFC per report

              if(ibfms(pqtzuvEV(1,1,1,5)).eq.0 .and.
     +           ibfms(pqtzuvEV(1,1,1,6)).eq.0 ) then

c Calculate speed & direction from U & V components (for both obs and forecast values)
c
c Per Dennis Keyser on 8/29/05, w3fc05 returns a wind direction of true meteorological nature
c  (e.g., a wind w/ dir =270 is a wind from the west)
c
c ALSO NOTE: w3fc05 adds 0.001 to the direction - in order to get around this (without
c            immediately changing this routine in W3EMC), set any wind directions between
c            360.000 and 360.002 back to 360.00 - might be a good idea to remove the addition
c            of 0.001 to the wind direction in the W3EMC routine w3fc05 some day
c -------------------------------------------------------------------------------------------
                call w3fc05(uob,vob,ob_dir(nrpts4QC),ob_spd(nrpts4QC))

c If-statement below is used to negate effect of 0.001 being added to the wind direction in
c  the W3EMC routine w3fc05
c -----------------------------------------------------------------------------------------

                if(ob_dir(nrpts4QC).gt.360.000 .and.
     +             ob_dir(nrpts4QC).lt.360.002) then

                  ob_dir(nrpts4QC) = 360.00

                endif

                call w3fc05(ufc,vfc,dir_fc,spd_fc) ! similar to cqcbufr/incrw
c increments
c ---------
                xiv_s(nrpts4QC) = ob_spd(nrpts4QC) - spd_fc
                xiv_d(nrpts4QC) = ob_dir(nrpts4QC) - dir_fc
c quality marks
c -------------
                nchk_s(nrpts4QC)=
     +                int(pqtzuvEV(2,1,1,5)) ! use u-component QM
                nchk_d(nrpts4QC)=
     +                int(pqtzuvEV(2,1,1,5)) ! use u-component QM

              endif ! Check for missings

c Store wind events in "corral" arrays to carry through this code
c ---------------------------------------------------------------
              if(nevents(nrpts4QC,5).gt.0) then
                do i = 1,nevents(nrpts4QC,5)
                  invi = nevents(nrpts4QC,5)-i+1

c                                                        |---> wind
                  uob_ev(nrpts4QC,i) = pqtzuvEV(1,1,invi,5)
                  vob_ev(nrpts4QC,i) = pqtzuvEV(1,1,invi,6)
                  wqm_ev(nrpts4QC,i) = pqtzuvEV(2,1,invi,5)
                  wpc_ev(nrpts4QC,i) = pqtzuvEV(3,1,invi,5)
                  wrc_ev(nrpts4QC,i) = pqtzuvEV(4,1,invi,5)
                enddo
              endif

c Store wind background info in "corral" arrays to carry through this code
c ------------------------------------------------------------------------
              call ufbint(inlun,arr_8,15,10,nlev,
     +                   'WOE UFC VFC UFCMOD VFCMOD') ! only one occurence of bg info per
                                                      !  report/level
              wbg(nrpts4QC,:) = arr_8(1:5,1)

              call ufbint(inlun,arr_8,15,10,nlev,
     +                    'UAN VAN UCL VCL UCS VCS')  ! only one occurence of post-p info per
                                                      !  report/level
              wpp(nrpts4QC,:) = arr_8(1:6,1)

c Pull wind (direction/speed) events
c ----------------------------------
              if(.not.l_allev_pf) then
                call ufbint(inlun,df_arr,5,mxlv,nlev,
     +                      'DDO FFO DFQ DFP DFR')
              else
                call ufbevn(inlun,df_arr,5,mxlv,mxnmev,nlev,
     +                      'DDO FFO DFQ DFP DFR')
              endif

c Count the number of wind events (dir/speed) events in this report
c -----------------------------------------------------------------
              if(l_allev_pf) then
                ddo_ev(nrpts4QC,:) = df_arr(1,1,:)
                ffo_ev(nrpts4QC,:) = df_arr(2,1,:)
                dfq_ev(nrpts4QC,:) = df_arr(3,1,:)
                dfp_ev(nrpts4QC,:) = df_arr(4,1,:)
                dfr_ev(nrpts4QC,:) = df_arr(5,1,:)
                evknt = 0
                do j = 1,mxnmev
                  if(ibfms(df_arr(1,1,j)).ne.0 .or.
     +               ibfms(df_arr(2,1,j)).ne.0) then
                    nevents(nrpts4QC,6) = evknt
                    exit ! exit j do loop
                  else
                    evknt = evknt + 1
                  endif
                enddo
              else
                ddo_ev(nrpts4QC,1) = df_arr(1,1,1)
                ffo_ev(nrpts4QC,1) = df_arr(2,1,1)
                dfq_ev(nrpts4QC,1) = df_arr(3,1,1)
                dfp_ev(nrpts4QC,1) = df_arr(4,1,1)
                dfr_ev(nrpts4QC,1) = df_arr(5,1,1)
                nevents(nrpts4QC,6) = 1
              endif

            endif ! Check for mass or wind report

            if(l_match) then ! report just stored was the second half
              call readns(inlun,mesgtype,mesgdate,iret) ! Advance pointer to next subset
              if(iret.eq.-1) then    ! there are no more subsets to read in the PREPBUFR file
                print *, 'READNS: NO MORE SUBSETS TO READ IN THE BUFR'//
     +                   ' FILE'
                exit
              elseif(iret.eq.0) then ! there are still subsets to read; pull the next one
                go to 4001
              else
                print *, 'Unexpected return code(iret=',iret,') from ',
     +                   'readns!'
                call w3tage('PREPOBS_PREPACQC')
                call errexit(23) ! Problems reading BUFR file
              endif
            endif

c At this point, we are done reading in subset n - call readns to get subset n+1 - see if it
c  is the wind part for subset n - store in same report in local arrays if so - if subset n+1
c  is not the second piece of subset n, pull its header along with the data values and
c  events, and store it in its own report
c -------------------------------------------------------------------------------------------
            call readns(inlun,mesgtype,mesgdate,iret)
            if(iret.eq.-1) then    ! there are no more subsets to read in the PREPBUFR file
              print *, 'READNS: NO MORE SUBSETS TO READ IN THE BUFR '//
     +                 'FILE'
              exit
            elseif(iret.eq.0) then ! there are still subsets to read; pull the next one

c Update counters
c ---------------
              if(mesgtype.eq.'AIRCFT') then
                nrptsaircft = nrptsaircft + 1
              elseif(mesgtype.eq.'AIRCAR') then
                nrptsaircar = nrptsaircar + 1
              else ! We're done reading the aircraft-type messages out of this file
                print *, '---> MESGTYPE NOT AIRCRAFT TYPE!!!',' "',
     +                   mesgtype,'"'
                print *, '---> keep looping through messages in case',
     +                   ' any more are in file'
                cycle loop2
              endif
      	      nrpts_rd = nrpts_rd + 1

c Pull out the value of SQN for subset n+1, which will wither be a mass piece or a wind piece
c  (most likely a wind piece for subset n).
c -------------------------------------------------------------------------------------------
              call ufbint(inlun,arr_8,15,10,nlev,'SQN')
              sqn_next = arr_8(1,1)

c Check and see if the report pulled by readns (subset n+1) is the second part for the report
c  pulled by an iteration of do ireadsb (subset n)
c -------------------------------------------------------------------------------------------
              if(sqn_next.eq.sqn_current) then  ! subset n+1 is the second part of subset n.
                                                !  alat,alon,ht_ft,c_acftid (or c_acftreg) 
                                                !  and idt have already been populated; no
                                                !  need to pull these twice 
                numpairs = numpairs + 1

                if(mesgtype.eq.'AIRCFT') then
                  numAIRCFTpairs = numAIRCFTpairs + 1
                elseif(mesgtype.eq.'AIRCAR') then
                  numAIRCARpairs = numAIRCARpairs + 1
                endif

                l_match = .true.

                go to 6001 ! SQN will be read again but nrpts4QC won't be incremented -
                           !  we've just found the 2nd half of the report previously read
              else ! subset n+1 is NOT the second part of subset n (n is an orphan)

c If we get here, we know that subsets n and n+1 are not parts of a pair - subset n is an
c  "orphan" and has already been stored - at this point, we don't yet know whether subset
c  n+1 is another orphan or whether it is the second half of a match - whether subset n+1 is
c  an orphan or part of a pair will be determined on the next iteration of this loop
c
c However, we do know that subset n+1 doesn't belong with subset n because their values of
c  SQN are different - so, we need to increment nrpts4QC before storing subset n+1 in the
c  report-oriented arrays (do so by sending the program to statement 5001)
c
c Send subset n+1 back through the program, treating subset n+1 as the new n
c ------------------------------------------------------------------------------------------
                numorph = numorph + 1

                if(mesgtype.eq.'AIRCFT') then
                  numAIRCFTorph = numAIRCFTorph + 1
                elseif(mesgtype.eq.'AIRCAR') then
                  numAIRCARorph = numAIRCARorph + 1
                endif

                l_match = .false.

c Leave BUFRLIB pointers where they are and treat subset n+1 as a new n
c ---------------------------------------------------------------------  
                go to 5001

              endif ! check to see if subset n+1 is the second part of subset n
            else 
              print *, 'Unexpected return code(iret=',iret,') from ',
     +                 'readns!'
              call w3tage('PREPOBS_PREPACQC')
              call errexit(23) ! Problems reading BUFR file 
            endif ! if(iret.eq.-1) then

          enddo ! do loop for reading BUFR subsets/reports (ireadsb)
        endif ! check for message type
      enddo loop2 ! do loop for reading messages
      print *, '---> DONE READING FROM THIS FILE!!!'
      print *, '---> nrpts_rd = ', nrpts_rd

      if(nrpts_rd.gt.0) then

c Determine ITYPE, C_DTG, etc.
c ----------------------------
      do i=1,nrpts4QC

c nevents can never be zero, otherwise array out-of-bounds issues will occur downstream -
c  make sure nevents is always at least 1 for all variables and all reports
c ---------------------------------------------------------------------------------------
        nevents(i,:) = max(nevents(i,:),1)

c ********************************************
c ITYPE --> REMAP FROM NCEP VALUE TO NRL VALUE
c ********************************************

c Determine type of aircraft report (itype)
c
c Need to check phase of flight and PREPBUFR report type
c PREPBUFR report types (mnemonic = TYP) where x is either: 1=mass, 2=wind part:
c       x30 = NCEP: AIREP (NRL Manual AIREP/voice)
c       x30 = NCEP: PIREP (NRL Manual AIREP/voice)
c       x31 = NCEP: AMDAR (all types except Canadian) (NRL: AMDAR)
c       x33 = NCEP: MDCRS (NRL: MDCRS)
c       x34 = NCEP: TAMDAR (NRL: ACARS)
c       x35 = NCEP: Canadian AMDAR (NRL: AMDAR)
c
c NCEP BUFR MNEMONIC POAF (phase of flight)/BUFR desc. 0-08-004:
c       0-1 = reserved
c       2 = Unsteady
c       3 = Level flight, routine observation
c       4 = Level flight, highest wind encountered
c       5 = Ascending
c       6 = Descending
c       7 = missing (set to 9 prior to this to match NRL's missing value)
c   bmiss = missing (set to 9 prior to this to match NRL's missing value)
c
c ##############################################################
c NRL settings for itype (see function insty_ob_fun):
c   --> Use value of POAF to determine whether ob was taken while the aircraft was ascending,
c       descending, etc.
c
c   Below * means used by NCEP
c
c --------------------------------------------------------------
c ---> NRL AIREPs
c     * 25/'man-airep'  = Manual AIREP (header XRXX)/"typical voice AIREP"
c               -- NOTE: Assign PIREPs (used at NCEP but not at NRL) to this "typical voice
c                        AIREP" category
c               -- NOTE: Assign all AIREPs (for now) to this "typical voice AIREP" category
c       26/'man-Yairep' = Manual AIREP (header YRXX)/keypad AIREP
c               -- NOTE: NCEP does not assign anything to this at the current time
c       30/'airep'      = automated "AIREPs" (AMDAR or UAL MDCRS re-encoded as AIREPs by AFWA)
c               -- NOTE: NCEP does not assign anything to this at the current time
c                        AFWA stopped re-encoding AMDAR and MDCRS into AIREP in Oct 2009
c      131/'airep_asc'  = AIREP ascending profile
c               -- NOTE: NCEP does not assign anything to this at the current time
c      132/'airep_des'  = AIREP descending profile
c               -- NOTE: NCEP does not assign anything to this at the current time
c       33/'airep_lvl'  = AIREP level flight
c               -- NOTE: NCEP does not assign anything to this at the current time
C       34/'airep_msg'  = AIREP w/ missing category (if rpt is not 25, 26, or 30)
c               -- NOTE: NCEP does not assign anything to this at the current time
c --------------------------------------------------------------
c ---> NRL AMDARs
c     * 35/'amdar'      = Automated aircraft data (AMDAR) (POAF cannot be determined)
c     *136/'amdar_asc'  = AMDAR ascending profile
c     *137/'amdar_des'  = AMDAR descending profile
c     * 38/'amdar_lvl'  = AMDAR level flight
c --------------------------------------------------------------
c ---> NRL ACARS {NOTE: Originally deemed "ACARS" by NRL, but this is currently not used by
c                       NRL (per email from Pat Pauley 1/12/05); NCEP will use them to provide
c                       a separate category for TAMDARs and rename them as TAMDAR in all
c                       printouts from acftobs_qc.f}
c       40/'acars'      = Automated aircraft (TAMDAR) (POAF cannot be determined)
c      141/'acars_asc'  = TAMDAR ascending profile
c      142/'acars_des'  = TAMDAR descending profile
c       43/'acars_lvl'  = TAMDAR level flight
c --------------------------------------------------------------
c ---> NRL MDCRS
c     * 45/'mdcrs' = Automated aircraft (MDCRS) (POAF cannot be determined)
c     *146/'mdcrs_asc'  = MDCRS ascending profile
c     *147/'mdcrs_des'  = MDCRS descending profile
c     * 48/'mdcrs_lvl'  = MDCRS level flight
c ##############################################################

        if(itype(i).eq.30) then         ! NCEP: AIREP (NRL Manual AIREP/voice) or
                                        ! NCEP: PIREP (NRL Manual AIREP/voice)
          phase(i) = 9                  !  NRL leaves phase of flight as missing for all
                                        !  AIREP/PIREP types (fine since NCEP does not have
                                        !  phase of flight info for AIREPs or PIREPs)

          if(c_acftid(i)(1:1).eq.'P'.and.c_acftid(i)(6:6).eq.'P') then ! NCEP PIREPs (BUFR
                                                                       ! tank b004/xx002)

c SMB: Data type label changed from 34 -> 25 on 5/5/05.  PIREPs are probably more along the
c      lines of "typical voice reports" than AIREPs with a "missing" category
c DAK: Agreed, if we are still going to use PIREPs lump them into Manual AIREP/voice category
            itype(i) = 25
            nPIREP = nPIREP + 1 

          else ! NCEP AIREPs (BUFR tank b004/xx001)
c SMB: Originally set these to 30 (reformatted something else's/"automated AIREPs")
c DAK: Changed these to 25 on 3/23/12 (30 is reserved for AFWA re-encoded AIREPS, orig. AMDAR
c      or MDCRS - there are none of these after Oct. 2009 per Eric Wise/AFWA)
c      We may want to try to isolate ADS's in N. Atlantic as type 30 (NRL does this) but not
c      at this point (right now ADS's go into NCO's airep decoder and come out in b004/xx001
c      tank)
ccccccccc   itype(i) = 30
ccccccccc   nAUTOAIREP = nAUTOAIREP + 1	
            itype(i) = 25
            nMANAIREP = nMANAIREP + 1	
          endif 

        elseif(itype(i).eq.31) then     ! NCEP: AMDAR (all types except Canadian) (NRL: AMDAR)
                                 ! (BUFR tanks b004/xx003, b004/xx006, b004/xx011, b004/xx103)
          nAMDAR = nAMDAR + 1	
          if(phase(i).eq.3 .or. phase(i).eq.4) then
            itype(i) = 38               ! level flight
          elseif(phase(i).eq.5) then
            itype(i) = 136              ! ascending flight
          elseif(phase(i).eq.6) then
            itype(i) = 137              ! descending flight
          else
            itype(i) = 35               ! unknown phase of flight
          endif

        elseif(itype(i).eq.33) then     ! NCEP: MDCRS (NRL: MDCRS) (BUFR tank b004/xx004)
          nMDCRS = nMDCRS + 1	
          if(phase(i).eq.3 .or. phase(i).eq.4) then
            itype(i) = 48               ! level flight
          elseif(phase(i).eq.5) then
            itype(i) = 146              ! ascending flight
          elseif(phase(i).eq.6) then
            itype(i) = 147              ! descending flight
          else
            itype(i) = 45               ! unknown phase of flight
          endif

        elseif(itype(i).eq.34) then     ! NCEP: TAMDAR (NRL: ACARS)
                                 ! (BUFR tanks b004/xx008, b004/xx010, b004/xx012, b004/xx013)
c DAK: Changed these from NRL AMDAR to NRL ACARS at suggestion of P. Pauley (3/2012), (to hold
c      NCEP TAMDARs) - allows them to be treated in a separate category for stratifying
c      statistics - also seems to flag more AMDARs as bad which is a good thing since there
c      are so many anyway
          nTAMDAR = nTAMDAR + 1	
                  ! NOTE: MADIS-feed TAMDARs currently have missing phase of flight and will
                  !       get set to unknown value initially (may later change)
                  !       AirDAT/Panasonic BUFR-feed TAMDARs do contain phase of flight)
          if(phase(i).eq.3 .or. phase(i).eq.4) then
ccccccccccc itype(i) = 38               ! level flight
            itype(i) = 43               ! level flight
          elseif(phase(i).eq.5) then
ccccccccccc itype(i) = 136              ! ascending flight
            itype(i) = 141              ! ascending flight
          elseif(phase(i).eq.6) then
ccccccccccc itype(i) = 137              ! descending flight
            itype(i) = 142              ! descending flight
          else
ccccccccccc itype(i) = 35               ! unknown phase of flight
            itype(i) = 40               ! unknown phase of flight
          endif

        elseif(itype(i).eq.35) then     ! Canadian AMDAR (NRL: AMDAR) (BUFR tank b004/xx009)
          nAMDARcan = nAMDARcan + 1	
          if(phase(i).eq.3 .or. phase(i).eq.4) then
            itype(i) = 38               ! level flight
          elseif(phase(i).eq.5) then
            itype(i) = 136              ! ascending flight
          elseif(phase(i).eq.6) then
            itype(i) = 137              ! descending flight
          else
            itype(i) = 35               ! unknown phase of flight
          endif

        else
          print'(" Unexpected value for PREPBUFR report type! (itype=",
     +           I0," & should be 30, 31, 33, 34, or 35)")', itype(i)
          print *, 'i=',i

        endif

c *****
c C_DTG
c *****

c Convert idt to YYYYMMDDHHMMSS format
c ------------------------------------
        read(cdtg_an(1:4),'(i4.4)') year
        read(cdtg_an(5:6),'(i2.2)') month
        read(cdtg_an(7:8),'(i2.2)') day
        read(cdtg_an(9:10),'(i2.2)') hour

c Time increment (offset from cycle time)
c ---------------------------------------
        rinc(1) = 0. ! days
        rinc(2) = 0. ! hours
        rinc(3) = 0. ! mins
        rinc(4) = idt(i) ! seconds
        rinc(5) = 0. ! milliseconds

c Date/time for cycle time
c ------------------------
        idat(1) = year
        idat(2) = month
        idat(3) = day
        idat(4) = 0 ! time zone
        idat(5) = hour
        idat(6) = 0 ! mins
        idat(7) = 0 ! secs
        idat(8) = 0 ! millisecs

c Use W3NCO routine w3movdat to get date/time of actual observation
c -----------------------------------------------------------------
        call w3movdat(rinc,idat,jdat)

c Convert jdat values to date/time string in yyyymmddhhmmss format
c -----------------------------------------------------------------
        write(c_dtg(i)(1:4),'(i4.4)') jdat(1)
        write(c_dtg(i)(5:6),'(i2.2)') jdat(2)
        write(c_dtg(i)(7:8),'(i2.2)') jdat(3)
        write(c_dtg(i)(9:10),'(i2.2)') jdat(5)
        write(c_dtg(i)(11:12),'(i2.2)') jdat(6)
        write(c_dtg(i)(13:14),'(i2.2)') jdat(7)

c ****************************************
c TRANSLATE NCEP QC FLAGS TO NRL STANDARDS
c (Store in arrays ichk_[t,q,d,s])
c ****************************************

c QM type:                NCEP values:    NRL values:
c                          nchk_*         ichk_*h
c Not checked/neutral     2                0
c Good                    1               -1
c Suspect                 3               -2
c Bad                     4-15            -3
c Initial/missing value  -9               -9
c ---------------------------------------------------
        qms(1) = nchk_t(i)
        qms(2) = nchk_q(i)
        qms(3) = nchk_d(i)
        qms(4) = nchk_s(i)

c DAK: this could be coded up more efficiently!
        do J=1,4
          if(qms(j).eq.2) then 
            qms(j) = 0
          elseif(qms(j).eq.1) then
            qms(j) = -1
          elseif(qms(j).eq.3) then
            qms(j) = -2
          elseif(qms(j).ge.4 .and. qms(j).le.15) then
            qms(j) = -3

cc smb 8/19/05
c For now, let qms(j)/ichk_q = 0 for non-missing q - this is to bypass ichk_q checks in
c  grchek_qc 
c -------------------------------------------------------------------------------------
            if(ob_q(i).ne.amiss) then
              qms(j) = 0
            endif

          elseif(qms(j).eq.-9) then ! leave it as is
            qms(j) = -9
          else ! Store QM = NRL's missing value
            qms(j) = -9
            print'(" Unexpected value of NCEP j=",I0,"/",A," QM  (",I0,
     +             ") for report number",I0,"!")',j,QM_types(j),qms(j),i
          endif

c If ob is missing, then store NRL quality mark as -9
c ---------------------------------------------------
c DAK: this could be coded up more efficiently!
          if(j.eq.1 .and. ob_t(i).eq.amiss) then
            qms(j) = -9
          elseif(j.eq.2 .and. ob_q(i).eq.amiss) then
            qms(j) = -9
          elseif(j.eq.3 .and. ob_dir(i).eq.amiss) then
            qms(j) = -9
          elseif(j.eq.4 .and. ob_spd(i).eq.amiss) then
            qms(j) = -9
          endif

c Store altered quality marks into NRL QM arrays
c ----------------------------------------------
c DAK: this could be coded up more efficiently!
          if(j.eq.1) then
            ichk_t(i) = qms(j)
          elseif(j.eq.2) then
            ichk_q(i) = qms(j)
          elseif(j.eq.3) then
            ichk_d(i) = qms(j)
          elseif(j.eq.4) then
            ichk_s(i) = qms(j)
          endif

        enddo ! over j
      enddo ! over i
      endif ! nrpts_rd.gt.0

c Output counts
c -------------
      write(*,*) 'NUMBER OF "AIRCFT" RPTS: ',nrptsaircft
      write(*,*) '    --> MASS: ', nmswd(1,1)
      write(*,*) '    --> WIND: ', nmswd(1,2)
      write(*,*) 'NUMBER OF "AIRCAR" RPTS: ',nrptsaircar
      write(*,*) '    --> MASS: ', nmswd(2,1)
      write(*,*) '    --> WIND: ', nmswd(2,2)
      write(*,*) 'TOTAL NUMBER OF MASS AND WIND REPORTS READ: ',
     +             nrpts_rd
      write(*,*) 'TOTAL NUMBER OF PAIRS (merged mass+wind): ',numpairs
      write(*,*) 'TOTAL NUMBER OF ORPHANS (only mass or only wind ',
     +             'present): ', numorph
      write(*,*) 'NUMBER OF "AIRCFT" PAIRS/ORPHANS: ', numAIRCFTpairs,
     +             '/', numAIRCFTorph
      write(*,*) 'NUMBER OF "AIRCAR" PAIRS/ORPHANS: ', numAIRCARpairs,
     +             '/', numAIRCARorph


      write(*,*)
      write(*,*) 'TOTAL NUMBER OF REPORTS FOR QC CODE: ', nrpts4QC
  
      write(*,*)
      write(*,*) 'NUMBER OF PIREPS (MANUAL AIREP/voice): ',nPIREP
      write(*,*) 'NUMBER OF AUTO AIREPS: ',nAUTOAIREP
      write(*,*) 'NUMBER OF AIREPS (MANUAL AIREPS/voice): ',nMANAIREP
      write(*,*) 'NUMBER OF AMDAR (excl. Canadian): ',nAMDAR
      write(*,*) 'NUMBER OF CANADIAN AMDAR: ',nAMDARcan
      write(*,*) 'NUMBER OF MDCRS: ',nMDCRS
      write(*,*) 'NUMBER OF TAMDAR: ',nTAMDAR

c End program
c -----------

      if(nrpts4QC/.90.gt.max_reps .and. nrpts4QC.lt.max_reps ) then

c If the total number of merged (mass + wind piece) aircraft-type reports read in from
c  PREPBUFR file is at least 90% of the maximum allowed ("max_reps"), print diagnostic
c  warning message to production joblog file
c ------------------------------------------------------------------------------------

        print 153, nrpts4QC,max_reps
  153   format(/' #####> WARNING: THE ',I6,' AIRCRAFT RPTS IN INPUT ',
     +   'FILE ARE > 90% OF UPPER LIMIT OF ',I6,' -- INCREASE SIZE OF ',
     +   '"MAX_REPS" SOON!'/)
        write(cmax_reps,'(i6)') max_reps
        call system('[ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" '//
     +   '"***WARNING: HIT 90% OF '//cmax_reps//' AIRCRAFT REPORT '//
     +   'LIMIT IN PREPOBS_PREPACQC, INCREASE SIZE OF PARM MAX_REPS"')
      endif

      write(*,*)
      write(*,*) '********************'
      write(*,*) 'input_acqc has ended'
      call system('date')
      write(*,*) '--> # reports = ',nrpts4QC
      write(*,*) '********************'
      write(*,*)

      return 

      end

              PROGRAM PREPOBS_MONOPREPBUFR
!$$$  MAIN PROGRAM DOCUMENTATION BLOCK
!
! MAIN PROGRAM: PREPOBS_MONOPREPBUFR
!   PRGMMR: KEYSER           ORG: NP22        DATE: 2013-03-06
!
! ABSTRACT: MERGES MULTIPLE PARTIAL PREPBUFR FILES INTO A MONOLITHIC
!   PREPBUFR FILE THAT CONTAINS ALL DATA.  GROUPS LIKE-NAMED TABLE A
!   MESSAGES TOGETHER IN THE EXPECTED ORDER.
!
! PROGRAM HISTORY LOG:
! 1999-07-29  KISTLER -- ORIGINAL AUTHOR
! 2013-03-06  KEYSER  -- CHANGES TO RUN ON WCOSS
!
! USAGE:
!   INPUT FILES:
!     PARM     - NAMELIST /NAMIN/ (
!              - VARIABLE "NFILES"   - THE NUMBER OF INPUT BUFR FILES
!                                      TO MERGE;
!              - VARIABLE "NHEADERS" - THE NUMBER OF UNIQUE TABLE A
!                                      ENTRIES FOR BUFR MESSAGES WITHIN
!                                      ALL INPUT PREPBUFR FILES;
!              - VARIABLE "CHEADERS" - LIST OF UNIQUE CHARACTER*8 TABLE
!                                      A ENTRIES FOR BUFR MESSAGES
!                                      WITHIN ALL INPUT PREPBUFR FILES;
!              - VARIABLE "MSGS"     - THE NUMBER OF BUFR MESSAGES FOR
!                                      A PARTICULAR TABLE A ENTRY IN A
!                                      PARTICULAR INPUT PREPBUFR FILE
!     UNIT 11  - PREPBUFR FILE 1
!     UNIT 12  - PREPBUFR FILE 2
!       ...              ...
!       ...              ...
!     UNIT XX  - (WHERE "XX" = 10+"NFILES"), PREPBUFR FILE "NFILES"
!
!   OUTPUT FILES:
!     UNIT 06  - STANDARD PRINTFILE
!     UNIT 51  - MONOLITHIC PREPBUFR FILE
!
!   SUBPROGRAMS CALLED:
!     LIBRARY:
!       W3NCO    - W3TAGB   W3TAGE
!       BUFRLIB  - DATELEN  OPENBF   IREADMG  COPYMG   CLOSMG
!                  CLOSBF
!
!   EXIT STATES:
!     COND =   0 - SUCCESSFUL RUN
!
! REMARKS: NONE.
!
! ATTRIBUTES:
!   LANGUAGE: FORTRAN 90
!   MACHINE:  NCEP WCOSS
!
!$$$

! program PREPOBS_MONOPREPBUFR

implicit none

character*8  subset,sid

integer      maxfiles,maxmsgs
parameter(maxfiles=31,maxmsgs=50)

character*80 filenames(maxfiles)
character*25 file
character*8  cheaders(maxmsgs),cheader
integer      m,i,nfiles ,ier,j,idate,ireadmg
integer      msg,msgs(maxfiles,maxmsgs),nheaders,ksum(maxmsgs)
integer      kend(maxfiles),lunin(maxfiles),lunot,msum(maxmsgs)

namelist /namin/ nfiles,nheaders,cheaders,msgs

      CALL W3TAGB('PREPOBS_MONOPREPBUFR',2013,0065,0085,'NP22')

print'(1X)'
print'(" Welcome to PREPOBS_MONOPREPBUFR - Version 03-07-2013")'
print'(1X)'

filenames=''
cheaders=''
msgs=0
read (5,namin)
write(6,namin)

print'(1X)'
print'(1X)'
print'(1X)'
print'(3x,<nheaders>(a8))',(cheaders(i),i=1,nheaders)
msum=0
do j=1,nfiles
    print'(i2,1x,<nheaders>(i6,2x))',j,(msgs(i,j),i=1,nheaders)
    do i=1,nheaders
        msum(i)=msum(i)+msgs(i,j)
    enddo
enddo


!  open the input and output files
!  -------------------------------

call datelen(10)

do j=1,nfiles
    lunin(j)=10+j
    call openbf(lunin(j),'IN',lunin(1))
enddo
lunot=51

!
! merge the input file messages
! 
!----------------------------------------------------------

call openbf(lunot,'OUT',lunin(1))
do i=1,nheaders
   ksum=0 ! msg count for each type of header
   do j=1,nfiles
      m=0
      print'(" writing",I4," messages of ",A," to unit",I3," for file",I3)', &
       msgs(i,j),cheaders(i),lunot,j
      if(msgs(i,j).gt.0) then
         do while(ireadmg(lunin(j),subset,idate).eq.0)
            if(m.le.msgs(i,j)) then
               m=m+1
               do while ( subset.ne.cheaders(i))
                  print'(" mismatch ",A," .ne. ",A)', subset,cheaders(i)
                  if(ireadmg(lunin(j),subset,idate).ne.0) then
                     print'(" terminating file",I3)', j
                     exit
                  endif
               enddo
!!!!!!!!!!!!!!!print'(" copy file ",I0," ",A,1X,I," of total ",I0)', &
!!!!!!!!!!!!!!! j,subset,m,msgs(i,j)
               call closmg(lunot)
               call copymg(lunin(j),lunot)
               ksum(i)=ksum(i)+1
            endif
            if(m.eq.msgs(i,j)) exit
         enddo
      endif
!!!!!!print'(1X,A," finished with file ",I0)', cheaders(i),j
   enddo
   print'(1X,A," wrote a total of ",I4," messages - expecting to write",I4,&
    " messages")', cheaders(i),ksum(i),msum(i)
   print'(1X)'
enddo
call closbf(lunot)

do j=1,nfiles
   call closbf(lunin(j))
enddo

      print'(1X)'
      print'(" All done.")'
      print'(1X)'
      CALL W3TAGE('PREPOBS_MONOPREPBUFR')

stop
end

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE SSMIPN(LUBFR,LUBFO,SUBSET,IDATE,NRPT)
 
      CHARACTER*8 SUBSET
      REAL*8      DATE(6),REGI(3),SLCA(4,255),SNNP(4,255)
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
 
C  READ THE SSMI REGISTRATION AND SCAN LINE REPORT
C  -----------------------------------------------
 
      CALL UFBINT(LUBFR,DATE,6,1,IRET,'YEAR MNTH DAYS HOUR MINU SECO')
      CALL UFBINT(LUBFR,REGI,3,1,IRET,'SAID ORBN SCNN')
 
      CALL UFBINT(LUBFR,SLCA,4,255,NSC1,'CLAT CLON SFTG POSN')
      CALL UFBINT(LUBFR,SNNP,4,255,NSC2,'WSOS PH2O CH2O SST1')

 
C  KEEP EACH SCAN IN ONE HOUR OF ONE DAY EVEN IF SECO IS ADJUSTED
C  --------------------------------------------------------------
 
      CALL OPENMB(LUBFO,SUBSET,IDATE)
 
C  GENERATE A REPORT FOR EACH SCAN POINT
C  -------------------------------------
 
      DO N=1,MIN(NSC1,NSC2)
 
      CALL UFBINT(LUBFO,DATE,6,1,IRET,'YEAR MNTH DAYS HOUR MINU SECO')
      nrpt = nrpt + 1
      CALL UFBINT(LUBFO,REGI,3,1,IRET,'SAID ORBN SCNN')
 
      CALL UFBINT(LUBFO,SLCA(1,N),4,1,IRET,'CLATH CLONH SFTG POSN')
      CALL UFBINT(LUBFO,SNNP(1,N),4,1,IRET,'WSOS  PH2O  CH2O SST1')
 
c Disable compression (due to problem porting to Cirrus; fails on wrcmps)
c  (this should be revisited after update to Cirrus BLib)
ccc   CALL WRITCP(LUBFO)
      CALL WRITSB(LUBFO)
 
      ENDDO
 
      RETURN
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: PREPOBS_PREVENTS
C   PRGMMR: KEYSER           ORG: NP22        DATE: 2001-10-10
C
C ABSTRACT: PREPARES OBSERVATIONAL PREPBUFR FILE FOR SUBSEQUENT
C   QUALITY CONTROL AND ANALYSIS PROGRAMS.  THIS IS DONE THROUGH THE
C   FOLLOWING: INTERPOLATION OF GLOBAL SPECTRAL SIMGA FIRST GUESS TO
C   PREPBUFR OBSERVATION LOCATIONS WITH ENCODING OF FIRST GUESS VALUES
C   INTO PREPBUFR REPORTS; ENCODING OF "PREVENT" AND/OR "VIRTMP"
C   EVENTS INTO PREPBUFR REPORTS; AND ENCODING OF OBSERVATION ERRORS
C   FROM THE ERROR SPECIFICATION FILE INTO PREPBUFR REPORTS.  FOR
C   MORE INFORMATION ON THE DETAILS OF THE "PREVENT" AND "VIRTMP"
C   EVENTS, SEE THE DOCBLOCK FOR W3LIB ROUTINE "GBLEVENTS".  THIS
C   PROGRAM CALLS GBLEVENTS, WHICH RUNS HERE IN THE "PREVENTS" MODE.
C   W3LIB ROUTINE GBLEVENTS DOES THE BULK OF THE WORK HERE.  AFTER
C   EACH REPORT IS UPDATED BY GBLEVENTS, IT IS WRITTEN OUT TO A
C   "PREPROCESSED" VERSION OF THE PREPBUFR FILE.  
C
C PROGRAM HISTORY LOG:
C 1994-01-06  J. WOOLLEN  ORIGINAL VERSION FOR REANALYSIS
C 1994-09-06  J. WOOLLEN  VERSION FOR IMPLEMENTATION IN GBL SYSTEM
C 1997-10-07  D.A. KEYSER -- ADDED NAMELIST SWITCH TO BYPASS VIRT.
C             TEMPERATURE EVENT FOR NON-RADIOSONDE/SATSND DATA TYPES
C             (INVOKED IN RUC VERSION - TOB NOT CHANGED FROM INPUT)
C 1997-11-24  D.A. KEYSER -- ADDED NAMELIST SWITCH "REDUCE" TO BYPASS
C             ALL PREVENTS PROCESSING (IF TRUE) FOR MESSAGE TYPES NOT
C             EQUAL TO "ADPUPA", "AIRCFT" AND "PROFLR"
C 1998-02-03  D.A. KEYSER -- CORRECTED ERROR FROM PREVIOUS CHANGE THAT
C             RESULTED IN BYPASSING THE VIRT. TEMPERATURE EVENT FOR
C             "ADPUPA" AND "SFCSHP" TYPES WHEN N-LIST SWITCH "REDUCE"
C             IS TRUE - REDUCE=TRUE WILL NOW CONTINUE TO DO ALL
C             PREVENTS PROCESSING FOR MESSAGE TYPES "ADPUPA", "AIRCFT",
C             "PROFLR" AS WELL AS NOW "ADPSFC" AND "SFCSHP"
C 1998-08-25  D.A. KEYSER -- ADDED SWITCHES 'DOBERR' AND 'DOFCST' IN
C             NAMELIST READ FROM DATA CARDS; SUBROUTINE NOW Y2K AND
C             FORTRAN 90 COMPLIANT
C 1998-09-14  J.WOOLLEN - ADDED SWITCH FOR INSTALLING ANALYSED VALUES
C 1998-09-17  D.A. KEYSER -- PROGRAM NOW CALLS EXIT PRIOR TO STOP FOR
C             NON-ZERO EXIT STATES (TRANSFERS EXIT STATE TO UNIX
C             FOREGROUND STATUS CODE)
C 1998-09-21  D. A. KEYSER -- SUBROUTINE NOW Y2K AND FORTRAN 90
C             COMPLIANT
C 1998-07-06  D. A. KEYSER -- MODIFIED TO COMPILE AND RUN ON IBM;
C             NOW CALLS NEW W3LIB ROUTINE "GBLEVENTS" TO PERFORM
C             MOST OF THE FUNCTIONS THAT THIS PROGRAM USED TO DO
C             (THIS W3LIB ROUTINE IS ALSO CALLED BY PREPDATA,
C             SYNDATA AND POSTEVENTS), ONLY THE READING IN OF
C             REPORTS IS DONE BY THIS MAIN PROGRAM NOW
C 1999-09-26  D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE
C 2001-02-02  D. A. KEYSER -- MINOR HOUSKEEPING CHANGES; PICKS UP AN
C             UPDATED W3LIB ROUTINE GBLEVENTS
C 2001-10-10  D. A. KEYSER -- MODIFIED TO NOW PASS TWO SPANNING GLOBAL
C             SIGMA GUESS FILES INTO W3LIB ROUTINE GBLEVENTS IN
C             SITUATIONS WHERE THE CENTER DATE FOR THE PREPBUFR FILE
C             HAS AN HOUR THAT IS NOT A MULTIPLE OF 3 (SEE 2001-10-10
C             CHANGES TO GBLEVENTS)
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C                DOCUMENTATION IN W3LIB ROUTINE GBLEVENTS DOCBLOCK)
C     UNIT 11  - PREPBUFR FILE
C     UNIT 12  - FIRST INPUT SPECTRAL (GLOBAL) SIGMA FIRST GUESS FILE;
C              - IF HOUR IN CENTER DATE FOR PREPBUFR FILE IS A MULTIPLE
C              - OF 3 THEN THIS FILE IS VALID AT THE CENTER DATE OF THE
C              - PREPBUFR FILE, IF THE HOUR IN CENTER DATE FOR PREPBUFR
C              - FILE IS NOT A MULTIPLE OF 3 THEN THIS FILE IS VALID AT
C              - THE CLOSEST TIME PRIOR TO THE CENTER DATE OF THE
C              - PREPBUFR FILE THAT IS A MULTIPLE OF 3
C     UNIT 13  - SECOND INPUT SPECTRAL (GLOBAL) SIGMA FIRST GUESS FILE;
C              - IF HOUR IN CENTER DATE FOR PREPBUFR FILE IS A MULTIPLE
C              - OF 3 THEN THIS FILE IS EMPTY, IF THE HOUR IN CENTER
C              - DATE FOR PREPBUFR FILE IS NOT A MULTIPLE OF 3 THEN
C              - THIS FILE IS VALID AT THE CLOSEST TIME AFTER THE
C              - CENTER DATE OF THE PREPBUFR FILE THAT IS A MULTIPLE OF
C              - 3
C     UNIT 14  - OBSERVATION ERROR FILE
C     UNIT 15  - EXPECTED CENTER DATE IN PREPBUFR FILE IN FORM
C                YYYYMMDDHH
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - PREPBUFR FILE (NOW CONTAINING FIRST GUESS VALUES,
C              - "PREVENT" AND "VIRTMP" EVENTS, AND OBERVATIONAL ERROR
C              - VALUES)
C     UNIT 52  - "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C
C   SUBPROGRAMS CALLED:
C       W3LIB    - W3TAGB    W3TAGE    GBLEVENTS ERREXIT
C       BUFRLIB  - DATELEN   OPENBF    READMG    OPENMB
C                - WRITSB    CLOSBF
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C     COND =  21 - DATE DISAGREEMENT BETWEEN ACTUAL CENTER DATE IN
C                  PREPBUFR FILE AND EXPECTED CENTER DATE READ IN
C                  FROM UNIT 15
C     COND =  22 - BAD OR MISSING DATE READ IN FROM UNIT 15
C     COND =  60-79 - RESERVED FOR W3LIB ROUTINE GBLEVENTS (SEE
C                      GBLEVENTS DOCBLOCK)
C
C
C REMARKS: NONE.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM-SP
C
C$$$

      PROGRAM PREPOBS_PREVENTS

      use gblevn_module, only : bmiss

      character(80) filo
      CHARACTER(8)  SUBSET,LAST

      integer IUNITG

      DATA  LAST/'XXXXXXXX'/

      include "mpif.h"

!--------------------------------------------------------------------------
      call mpi_init(ierr)
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
!--------------------------------------------------------------------------
      bmiss=10e10; call setbmiss(bmiss)
!--------------------------------------------------------------------------

      if(myid==0)then
      CALL W3TAGB('PREPOBS_PREVENTS',2001,0283,0061,'NP22')
      PRINT 700
  700 FORMAT(/'  =====> WELCOME TO PREVENTS PROGRAM -- LAST UPDATED ',
     $ '2001-10-10'/)
      !TODO: ncpus is undefined.  If this is an open_mp function,
      !      then omp_get_num_procs() should be used.  For MPI,
      !      simply print nprc from the mpi_comm_size call above.
      !print*,'num threads=',ncpus()
      call prttime('start')
      endif

      IUNITI    = 11
      IUNITG    = 12
      IUNITG    = 13
      IUNITE    = 14
      IUNITD    = 15
      IUNITP    = 50             
      IUNITO    = 51             
      IUNITS    = 52

C  OPEN INPUT PREPBUFR FILE JUST TO GET MESSAGE DATE (WHICH IS THE
C   ACTUAL CENTER DATE), LATER CLOSE FILE
C  ---------------------------------------------------------------

      CALL DATELEN(10)

      CALL OPENBF(IUNITI,'IN',IUNITI)
      CALL READMG(IUNITI,SUBSET,IDATEP,IRET)

      if(myid==0)PRINT 53, IDATEP
   53 FORMAT(/' --> ACTUAL   CENTER DATE OF PREPBUFR FILE READ FROM ',
     $ ' SEC. 1 MESSAGE DATE IS:',I11/)

      IF(IDATEP.LT.1000000000) call bort('idatep not 10 digits')

C  READ IN EXPECTED CENTER DATE OF PREPBUFR FILE
C  ---------------------------------------------

      REWIND IUNITD
      READ(IUNITD,'(6X,I10)',END=904,ERR=904)  IDATED
      if(myid==0)PRINT 3, IUNITD, IDATED
    3 FORMAT(/' --> EXPECTED CENTER DATE OF PREPBUFR FILE READ FROM ',
     $ 'UNIT',I3,' IS:',13X,I11/)

C  CHECK ACTUAL CENTER DATE OF PREPBUFR FILE VS. EXPECTED CENTER DATE
C  ------------------------------------------------------------------

      IF(IDATEP.NE.IDATED)  GO TO 901

      CALL CLOSBF(IUNITI)

C  CALL W3LIB ROUTINE GBLEVENTS TO store first guess interpolation arrays
C  ----------------------------------------------------------------------

      SUBSET='NONE'
!     CALL GBLEVENTS(IDATED,IUNITG,IUNITE,IUNITP,IUNITS,SUBSET,newtyp)

C  OPEN INPUT AND OUTPUT PREPBUFR FILES FOR DATA PROCESSING
C  --------------------------------------------------------

      CALL OPENBF(IUNITI,'IN ',IUNITI)
      WRITE(FILO,'("mpi.fort.",I2.2)')MYID+1       
      OPEN(IUNITP,FILE=FILO,FORM='UNFORMATTED')
      CALL OPENBF(IUNITP,'OUT',IUNITI)
      CALL MAXOUT(20000)

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      NEWTYP=0; nmsg=-1

C  LOOP THROUGH THE INPUT MESSAGES adding prevents and writing back out
C  --------------------------------------------------------------------

      DO WHILE(IREADMG(IUNITI,SUBSET,JDATEP).EQ.0)
      nmsg=nmsg+1;if(mod(nmsg,nprc)/=myid)cycle
      CALL OPENMB(IUNITP,SUBSET,JDATEP)
      IF(SUBSET.NE.LAST)THEN
         NEWTYP = 1
         IF(MYID==0) print *, 'New input message type read in: ',SUBSET
      END IF

      DO WHILE(IREADSB(IUNITI).EQ.0)
      CALL UFBCPY(IUNITI,IUNITP)
      CALL GBLEVENTS(IDATED,IUNITG,IUNITE,IUNITP,IUNITS,SUBSET,newtyp)
      CALL WRITSB(IUNITP)
      NEWTYP = 0
      ENDDO

      LAST = SUBSET
      ENDDO

C  CLOSE THE BUFR FILES
C  --------------------

      CALL CLOSBF(IUNITI)
      CALL CLOSBF(IUNITP)

C  ALL DONE - now sort it out
C  --------------------------

      call mpi_barrier(MPI_COMM_WORLD,ierr) ! need all processors here 

      IF(MYID==0) THEN
         call prttime('prevents')
         CALL SORTBUFR(IUNITO)
         call prttime('sortbufr')
         CALL W3TAGE('PREPOBS_PREVENTS')
         call prttime('end')
      ENDIF

      CALL MPI_FINALIZE(MRET)

      STOP

c  some error exits
c  ----------------

  901 CONTINUE
      PRINT 9901, IDATEP,IDATED
 9901 FORMAT(/' ##> ACTUAL CENTER DATE OF INPUT PREPBUFR FILE (',I10,
     $ ') DOES NOT MATCH EXPECTED CENTER DATE (',I10,') - STOP 21'/)
      CALL W3TAGE('PREPOBS_PREVENTS')
      CALL ERREXIT(21)

  904 CONTINUE
      PRINT 9902, IUNITD
 9902 FORMAT(/' ##> BAD OR MISSING EXPECTED PREPBUFR CENTER DATE ',
     $ 'READ FROM UNIT',I3,' - STOP 22'/)
      CALL W3TAGE('PREPOBS_PREVENTS')
      CALL ERREXIT(22)

      END

      SUBROUTINE W3XTOVSMND (IBUFTN,JFLAG)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  W3XTOVSMND
C   PRGMMR: KEYSER           ORG: NP22        DATE: 2013-02-14
C
C ABSTRACT: COMPUTES MANDATORY LEVEL HEIGHTS (ACTUALLY THICKNESSES TO
C   1000 MB) AND TEMPERATURES FROM RTOVS OR ATOVS MEAN-LAYER VIRTUAL
C   TEMPERATURE INFORMATION FOR A REPORT PRESENTED IN UNPACKED NMCEDS
C   FORMAT. THE UNPACKED NMCEDS FORMAT IS FILLED ONLY WITH THOSE
C   VALUES NEEDED FOR RTOVS OR ATOVS PROCESSING BY THE PREPDATA
C   PROGRAM.
C
C PROGRAM HISTORY LOG:
C 1979-05-01  D. G. MARKS ---- W/NMC421
C 1988-11-16  R. A. PETERSEN - W/NMC22 - CORRECTED AN ERROR WHICH LED
C        TO SYSTEMATIC WARM BIAS IN LAYERS BETWEEN 300 AND 100 MB.
C 1988-11-23  M. FARLEY      - W/NMC42 - INCORPORATED PETERSEN CHANGES
C        INTO FORTRAN77 VERSION OF W3FA07.
C 1990-01-16  D. A. KEYSER --- W/NMC22 - STREAMLINED; CORRECTED ERRORS
C        IN DO-LOOP INDEXING IN FORTRAN77; GENERALIZED FOR DMSP.
C 1992-05-01  D. A. KEYSER --- W/NMC22 - CONVERT TO CRAY CFT77 FORTRAN
C 1998-02-17  D. A. KEYSER --- NP22 ---- INPUT ARGUMENT CONTAINING
C        UNPACKED NMCEDS FORMAT FOR A REPORT NOW FULL INTEGER WORDS
C        RATHER THAN PACKED 16-BIT WORDS (THIS HAD BEEN NEEDED TO
C        ALLOW THIS SUBR. TO BE HDS/CRAY PORTABLE)
C 1998-06-15  D. A. KEYSER -- RENAMED FROM W3FA07 TO AVOID CONFUSION
C        WITH EXISTING W3LIB ROUTINE; ADAPTED FOR USE ONLY WITH RTOVS
C        DATA (AFTER TOVS DEMISE) (I.E., NO TROP DATA PROCESSED);
C        OTHERWISE STREAMLINED
C 1998-09-21  D. A. KEYSER -- SUBROUTINE NOW Y2K AND FORTRAN 90
C        COMPLIANT
C 1999-01-20 D. A. KEYSER -- INCORPORATED BOB KISTLER'S CHANGES NEEDED
C        TO PORT THE CODE TO THE IBM SP
C 1999-11-19  D. A. KEYSER -- INCLUDES NOAA-15 ATOVS DATA (AS WELL AS
C        RTOVS DATA); RENAMED SUBROUTINE
C 2012-11-30  J. WOOLLEN  INITIAL PORT TO WCOSS 
C 2013-02-14  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS
C
C USAGE:    CALL W3XTOVSMND(IBUFTN,JFLAG)
C   INPUT ARGUMENT LIST:
C     IBUFTN   - ADDRESS HOLDING A SINGLE RTOVS OR ATOVS REPORT
C              - (140 FULL - INTEGER WORDS) IN UNPACKED NMCEDS FORMAT 
C              - (THE - UNPACKED NMCEDS FORMAT IS FILLED ONLY WITH THOSE
C              - VALUES NEEDED FOR RTOVS OR ATOVS PROCESSING BY THE
C              - PREPDATA PROGRAM)
C
C   OUTPUT ARGUMENT LIST:
C     JFLAG    - INTEGER RETURN CODE:
C                  = 0 ==> REPORT PROCESSED
C                  > 0 ==> REPORT NOT PROCESSED DUE TO:
C                     = 1 ==> ALL PRESSURE VALUES ARE MISSING
C                     = 2 ==> THERE ARE NO VALID PRESSURE LAYERS
C                     = 3 ==> A PRESSURE VALUE FAILED GROSS CHECK
C                     = 4 ==> A MEAN LAYER V. TEMP FAILED GROSS CHECK
C                     = 5 ==> FIRST VALID PRESS. LVL ON OR ABOVE 10 MB
C                     = 6 ==> THERE ARE NO VALID PRESSURE LEVELS
C                     = 7 ==> AT LEAST 1 MISSING OR INCONSISTENT LAYER
C                             BETWEEN THE BOTTOM & TOP SPANNING P-LVLS
C
C REMARKS: CURRENTLY CALLED ONLY BY PROGRAM PREPDATA.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
C
      REAL  SLNP(20),EXNS(20),XLVLS(21),EXNER(20),XLNP(20),Q(15),
     $ TXXX(20),ZZ(20),TBARX(19),TBAR(15),SPMID(15),PMID(19)
C
      INTEGER  IP1(15),IP2(15),LVLS(15),IZFX(5),ISLRPT(20),IBUFTN(140)
C
      COMMON/FA07AA/TM(20),Z(20),MLVLS
C
      SAVE
C
      DATA XLVLS/1000.,850.,700.,500.,400.,300.,250.,200.,150.,100.,70.,
     $             50., 30., 20., 10.,  7.,  5.,  3.,  2.,  1., 0.4/
      DATA  LVLS/1000,850,700,500,400,300,200,100,70,50,30,10,5,2,1/
      DATA  ISLRPT/1,1,1,1,1,2,0,2,0,1,1,1,2,0,2,0,2,0,2,0/
      DATA  XMISS/99999./,IZFX/6,8,13,15,17/
C
C FUNCTION...
      XTM(T1,T2,XM,XP1,XP2)=(T2*(ALOG(XP1/XM))+T1*(ALOG(XM/XP2)))
     $        /(ALOG(XP1/XP2))

      G     = 9.80655
      R     = 287.055
      ROG   = R/G
      CP    = 1005.0
      XKAP  = R/CP
      XKAPR = 1.0/XKAP
      ROG   = R/G
      JFLAG = 0
C TSFC IS THE SKIN TEMPERATURE
      TSFC  = IBUFTN(9)/10.0
C SFCEL IS Z(SFC) MINUS Z(1000), WHERE Z(1000) IS SET TO 111.0 METERS
      SFCEL = IBUFTN(8) - 111.0
C ENTER MEAN LAYER VIRT. TEMP (TBAR), BOTTOM PRESSURE (IP1) AND TOP
C  PRESSURE (IP2) VALUES FOR THE LAYER, AND TEMPERATURE QUALITY MARK (Q)
      IP1  = IBUFTN(23:79:4)/10
      IP2  = IBUFTN(24:80:4)/10
      TBAR = IBUFTN(25:81:4)/10.
      Q    = IBUFTN(26:82:4)/10.
C-----------------------------------------------------------------------
C DETERMINE THE LOWEST AND HIGHEST VALID PRESSURE LAYERS FOR THE REPORT
C LL IS FIRST VALID PRESSURE LAYER (0=SFC-850 MB, 1=850-700 MB, ETC.)
C MM IS LAST  VALID PRESSURE LAYER (15=1-.4 MB, 14=2-1 MB, ETC.)
      LL = 0
      DO I = 1,15
         IF(IP1(I).NE.777.AND.IP2(I).NE.777)  GO TO 112
            LL = LL + 1
      ENDDO
C THERE ARE NO VALID PRESSURE LEVELS IN THE REPORT, EXIT WITH JFLAG=1
      JFLAG = 1
      RETURN
  112 CONTINUE
      DO I = 1,15
         MM = 16 - I
         IF(IP1(MM).NE.777.AND.IP2(MM).NE.777)  GO TO 114
      ENDDO
C THERE ARE NO VALID PRESSURE LEVELS IN THE REPORT, EXIT WITH JFLAG=1
      JFLAG = 1
      RETURN
  114 CONTINUE
C-----------------------------------------------------------------------
C ISLP IS THE NUMBER OF VALID PRESSURE LAYERS FOR THE REPORT
      ISLP = MM - LL
      IF(ISLP.GE.1)  GO TO 101
C THERE ARE VALID LAYERS IN THE REPORT, EXIT WITH JFLAG=2
      JFLAG = 2
      RETURN
  101 CONTINUE
      IF(LL.LE.0)  GO TO 78
C IF FIRST VALID LAYER IS ABOVE BASE LAYER (SFC-850 MB), RESET ARRAY
C  ELEMENTS IN IP1, IP2, TBAR, & Q SUCH THAT LVL1 IS THE FIRST VALID LVL
      DO I = 1,ISLP
         IP1(I) = IP1(LL+I)
         IP2(I) = IP2(LL+I)
         TBAR(I) = TBAR(LL+I)
         Q(I) = Q(LL+I)
      ENDDO
   78 CONTINUE
C GROSS CHECK THE PRESSURE AND TEMP, IF FAILS EXIT WITH JFLAG=3 OR 4
      DO I = 1,ISLP
              IF((IP1(I).GT.1000.OR.IP1(I).LT.0).OR.
     $           (IP2(I).GT.1000.OR.IP2(I).LT.0))  JFLAG = 3
              IF(JFLAG.EQ.3)  RETURN
              IF(TBAR(I).GT.500..OR.TBAR(I).LT.100.)  JFLAG = 4
              IF(JFLAG.EQ.4)  RETURN
      ENDDO
C-----------------------------------------------------------------------
C DETERMINE LOWEST (BOTTOM) & HIGHEST (TOP) MAND. PRESS. LVLS FOR WHICH
C  A VALID PRESSURE LAYER WITH V. TEMP EXIST IN THE REPORT
C NL INDEX IS 1ST VALID MAND. PRESSURE LVL (1-SFC/1000 MB,2-850 MB,ETC.)
C MLVLS IS LAST VALID MAND. PRESSURE LEVEL (20-1 MB, 19-2 MB, ETC.)
      DO L = 1,15
         IF(IP1(1).GT.INT(XLVLS(L)))  GO TO 200
      ENDDO
C IF FIRST VALID PRESSURE LEVEL IS AT OR ABOVE 10 MB EXIT WITH JFLAG=5
      JFLAG = 5
      RETURN
  200 CONTINUE
      NL = L - 1
      IF(L.EQ.1)  NL = 1
C KLVLS IS NO. OF MAND. PRESS LVLS UP TO 1 MB BEGINNING AT LVL NL
C  (MAX. IS 20 IF 1000/SFC MB LEVEL IS VALID)
      KLVLS = 21 - NL
      LLVLS = KLVLS - 1
C NLVLS IS NO. OF VALID LAYERS IN RPT (MAX IS 14,1-.4 MB LAYER NOT USED)
      NLVLS = ISLP
      IF(MM.EQ.15)  NLVLS = NLVLS - 1
      MLVLS = 0
      DO MLV = 1,20
         MLVLS = MLVLS + 1
         IF(IP2(NLVLS).GE.INT(XLVLS(MLV)))  GO TO 210
      ENDDO
C IF NO VALID PRESSURE LEVELS FOUND, EXIT WITH JFLAG=6
      JFLAG = 6
      RETURN
  210 CONTINUE
      JLVLS = MLVLS - 1
C-----------------------------------------------------------------------
C VERIFY THAT ALL LVLS BETWEEN THE TWO VALID SPANNING LEVELS ARE PRESENT
      DO I = 2,NLVLS
         J = I + LL
         ICK = IP1(I) - LVLS(J)
         JCK = IP2(I) - LVLS(J+1)
C IF THERE ARE ANY MISSING LEVELS IN HERE, EXIT WITH JFLAG=7
         IF(ICK.EQ.0.AND.JCK.EQ.0)  CYCLE
         JFLAG = 7
         RETURN
      ENDDO
C-----------------------------------------------------------------------
C COMPUTE THE EXNER FUNCTION AND ALOG (HIGHER PRESSURE/LOWER PRESSURE)
C  AT THE MANDATORY LEVELS -- DEFINE LOWEST LEVEL FIRST
      EXNER(1)  = (IP1(1)/1000.)**XKAP
      EXNER(20) = (    1./1000.)** XKAP
      XLNP(1) = ALOG(REAL(IP1(1))/XLVLS(NL+1))
      DO K = 2,KLVLS
         I = (NL - 1) + K
         EXNER(K) = (XLVLS(I)/1000.)**XKAP
         XLNP(K)  = ALOG(XLVLS(I)/XLVLS(I+1))
      ENDDO
C COMPUTE THE MID-LAYER EXNER FUNCTION AND 'COLLINS PRESSURE'
      DO K = 1,LLVLS
         XMID = XKAPR * ((EXNER(K+1) - EXNER(K))/(-XLNP(K)))
         XPON = XKAPR * ALOG(XMID) + ALOG(1000.)
         PMID(K) = EXP(XPON)
      ENDDO
C-----------------------------------------------------------------------
C CHECK TO SEE IF SKIN TEMP IS GOOD; CORRECT IF NECESSARY

C  Note: For previous TOVS processing, the obsolete subr. W3TOVEDS
C        could never return a value greater than 64 -- thus the test
C        .NOT.(BTEST(ITEMP,7)) was always be true since the bit in the
C        7'th position of IBUFTN(11) was always 0 (7'th pos. is from
C        right, where rightmost bit is in position 0)
C        This may not have been the case in the old HDS/true NMCEDS
C        file days - NMCEDS documentation, however, appears to support
C        the fact that bit 7 can ONLY have the value of ZERO.
C        For current RTOVS/ATOVS processing, IBUFTN(11) is set to 7777
C        (missing) in subr. W3XTOVSEDS, while IBUFTN(9) is also set to
C        7777.  This should allow the logic to be the same as for
C        TOVS - as to whether the logic is correct, I do not know
C        (Keyser - 5/7/98)

      ITEMP = IBUFTN(11)
      IF(.NOT.(BTEST(ITEMP,7)).OR.IBUFTN(9).EQ.7777)
     $ TSFC = TBAR(1) + (.0555 * (IP1(1) - PMID(1)))
      TSFC = (TSFC + TBAR(1) + (.0555 * (IP1(1) - PMID(1))))/2
C ESTIMATE MEAN TEMP IN SFC TO 1000 MB LAYER
      TMEAN = TSFC + ((0.0065 * SFCEL)/2.0)
C ESTIMATE SFC PRESSURE USING HYPSOMETRIC EQN. (1000 HGHT SET TO 111 M)
C           Z(1000) - Z(SFC) = - (R/G) * T * (LN(P1000) - LN(PSFC))
      ALNP = ALOG(1000.) - (SFCEL/(ROG * TMEAN))
      PSFC = EXP(ALNP)
C-----------------------------------------------------------------------
C INITIALIZE MANDATORY LEVEL TEMPS AND HEIGHTS(THICKNESSES) TO MISSING
      XVAL = (XMISS/10.) + 273.16
      TM = XVAL
      Z  = XMISS
      ZZ = XMISS
C COMPUTE PRESSURES FOR SATELLITE LEVELS
      SLNP(1:NLVLS) = ALOG(REAL(IP1(1:NLVLS))/IP2(1:NLVLS))
      EXNS(1:NLVLS) = (IP1(1:NLVLS)/1000.)**XKAP
      EXNS(NLVLS+1) = (IP2(NLVLS)/1000.)**XKAP
      DO I = 1,NLVLS
         XMID = XKAPR * ((EXNS(I+1) - EXNS(I))/(-SLNP(I)))
         XPON = (XKAPR * ALOG(XMID)) + ALOG(1000.)
         SPMID(I) = EXP(XPON)
      ENDDO
      ISL = 1
C-----------------------------------------------------------------------
C NOW COMPUTE LAYER TEMPERATURES FOR MANDATORY LAYERS (TBARX)
      LOOP1: DO K = 1,LLVLS
         LOOP1n1: DO JJ = ISL,ISLP
            J = JJ
            IF((PMID(K)-SPMID(J)).GT.-0.001)  EXIT LOOP1n1
         ENDDO LOOP1n1
         ISL = J
      IF(J.EQ.1.OR.(ABS(PMID(K)-SPMID(J)).LE.0.001))  TBARX(K) = TBAR(J)
         IF(J.EQ.1.OR.(ABS(PMID(K)-SPMID(J)).LE.0.001))  CYCLE LOOP1
         TBARX(K) = XTM(TBAR(J-1),TBAR(J),PMID(K),SPMID(J-1),SPMID(J))
      ENDDO LOOP1
      J = 1 - LL
      DO I = 1,JLVLS
         JJ = J
         IF(JJ.LT.1)  JJ = 1
         IF(ISLRPT(I).EQ.0)  CYCLE
         TXXX(I) = TBAR(JJ)
         IF(ISLRPT(I).EQ.2)  TXXX(I+1) = TBAR(JJ)
         J = J + 1
         J = MIN(J,MM-LL)
      ENDDO
C-----------------------------------------------------------------------
C COMPUTE TEMPERATURE AT MANDATORY LEVELS ABOVE GROUND
      ML = NL + 1
      K = 0
      DO I = ML,JLVLS
         K = K + 1
         TM(I) = (TBARX(K+1) * (ALOG(PMID(K) / XLVLS(I)))
     $         + TBARX(K) * (ALOG(XLVLS(I) / PMID(K+1))))
     $         / (ALOG(PMID(K) / PMID(K+1)))
      ENDDO
C-----------------------------------------------------------------------
C HEIGHTS(THICKNESSES TO 1000 MB) WILL NOT BE CALCULATED IF FIRST
C  VALID PRESSURE IS TOO HIGH ABOVE THE SURFACE
      IF(ABS(PSFC-IP1(1)).GT.100.)  GO TO 900
      T1000 = TSFC + (0.0065 * SFCEL)
C SINCE HGHT REALLY THICKNESS TO 1000 MB, 1000 MB HGHT ALWAYS = 0
      Z(1) = 0.0
      IF(NL.LE.1)  GO TO 750
C COMPUTE Z UNDERGROUND USING HYPSOMETRIC EQUATION, ASSUMING STD TEMP
C  LAPSE UNDERGROUND (.0065DEG/M) -- NL = NO. OF MAND. LVLS UNDER GROUND
C  (IF SFC AT OR BELOW 1000 MB, NL = 1 AND NO LEVELS ARE UNDERGROUND)
      Z(2:NL) = ROG * (T1000 * ALOG(1000./XLVLS(2:NL)))/
     $          (1. + (ROG * .0065/2.) * ALOG(1000./XLVLS(2:NL)))
  750 CONTINUE
C ELEVATION IS 0 METERS (OVER WATER), THEN 1000 MB TEMP DETERMINED
      IF(SFCEL.LE.0.0)  TM(1) = T1000
C COMPUTE THE HEIGHTS AT MANDATORY LEVELS
      J = 1
      Z(NL+1) = ROG * TBARX(1) * XLNP(1)
      IF(IP1(1).EQ.1000)  GO TO 755
      Z(NL+1) = Z(NL+1) + SFCEL + ROG * TSFC * ALOG(PSFC/REAL(IP1(1)))
     $ /(1 + (ROG * .0065/2.) * ALOG(PSFC/REAL(IP1(1))))
  755 CONTINUE
      ZZ = Z
      DO I = ML,JLVLS
         J = J + 1
         ZLY = ROG * TBARX(J) * XLNP(J)
         Z(I+1) = Z(I) + ZLY
         ZLYX = ROG * TXXX(I) * XLNP(J)
         ZZ(I+1) = ZZ(I) + ZLYX
      ENDDO
      DO II = 1,5
         I = IZFX(II)
         IF(I+1.LE.JLVLS)  ZZ(I+1) = ZZ(I) + (ZZ(I+2) - ZZ(I)) *
     $    (Z(I+1) - Z(I))/(Z(I+2) - Z(I))
      ENDDO
      Z = ZZ
  900 CONTINUE
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    W3ATOVSUNP
C   PRGMMR: DONG             ORG: NP22        DATE: 2020-01-09
C
C ABSTRACT: READS AND UNPACKS ONE REPORT FROM INPUT ATOVS RETRIEVAL
C   BUFR (DUMP) FILE INTO SPECIFIED FORMAT. RETURNS INFORMATION IN THE
C   FORMAT DESCRIBED BELOW.  INCLUDES SOUNDING DATA ON 40 LEVELS AND
C   ATOVS RADIANCES FROM 35 CHANNELS.  ALSO, INFORMATION ABOUT THE
C   INPUT DATA SET ITSELF (NAME, CENTER DATE, DUMP TIME) IS RETURNED.
C
C PROGRAM HISTORY LOG:
C 1999-11-17  D.A. KEYSER/NP22 -- ORIGINAL AUTHOR
C 2000-12-05  D.A. KEYSER/NP22 -- ACCOUNTS FOR NESDIS ERROR IN SCALING
C      BOTTOM PRESSURE VALUE (AND WILL STILL WORK RIGHT IF THEY FIX
C      IT); PERFORMS A SANITY CHECK ON THE BOTTOM PRESSURE VALUE; IF
C      FILTER FLAG NOT FOUND, SET OUTPUT FILTER FLAG TO "-99" WHICH
C      ALERTS CALLING PROGRAM TO PROCESS ONLY EVERY 11'TH RETRIEVAL TO
C      SIMULATE 250KM SAMPLING (NEEDED FOR CDAS RUNS), WAS SET TO 0
C 2001-07-16  D.A. KEYSER/NP22 -- CONSIDERS RETRIEVALS WITH BOTH CLEAR
C      AND CLOUDY BIT "OFF" (=0) IN SATELLITE DATA PROCESSING
C      TECHNIQUE TO BE CLOUDY (BEFORE THEY WERE UNKNOWN)
C 2001-08-07  D.A. KEYSER/NP22 -- CHECKS IERR ON INPUT, IF .ne. 1
C      ASSUMES INPUT FILE IS A DUMP (AS BEFORE), IF = 1 ASSUMES INPUT
C      FILE IS A TANK (/dcom) AND DOES NOT ATTEMPT TO READ A CENTER
C      OR DUMP TIME BUT DOES LIMIT SOME WARNING PRINTOUTS TO 250 LINES;
C      NOW CLOSES INPUT FILE AFTER ALL REPORTS ARE PROCESSED; UPON
C      EACH CALL, CHECKS TO SEE IF INPUT BUFR FILE IS CLOSED, IF SO
C      PROCESSES AS IF FIRST CALL TO SUBROUTINE (ALLOWS > 1 BUFR FILES
C      - WHETHER THE SAME OR DIFFERENT - TO BE READ THROUGH IN THE SAME
C      PROGRAM)
C 2002-03-05  D.A. KEYSER/NP22 --  ACCOUNTS FOR CHANGE FROM MNEMONIC
C      "SZNT" TO "SAZA" (SATELLITE ZENITH ANGLE) IN INPUT ATOVS BUFR
C      DUMP FILES AFTER 3/2002 (WILL STILL WORK PROPERLY FOR DUMP FILES
C      PRIOR TO 3/2002)
C 2008-03-10  D.A. KEYSER/NP22 -- HANDLES METOP-2 SATELLITE (BUFR
C      SATELLITE ID 004)
C 2012-11-30  J. WOOLLEN       -- INITIAL PORT TO WCOSS; RESET BMISS TO
C      A VALUE (10E08) WHICH WILL NOT CAUSE INTEGER OVERFLOW WHICH CAN
C      BE UNPREDICTABLE (PRIOR BMISS VALUE WAS 10E10)
C 2013-02-14  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS; OBTAIN
C      VALUE OF BMISS SET IN CALLING PROGRAM VIA CALL TO BUFRLIB
C      ROUTINE GETBMISS RATHER THAN HARDWIRING IT TO 10E08 (OR 10E10);
C      USE BUFRLIB FUNCTION IBFMS TO DETERMINE IF A VARIABLE READ FROM
C      BUFR FILE IS MISSING (I.E. RETURNED AS BMISS);  USE FORMATTED
C      PRINT STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS USED
C      (WCOSS SPLITS UNFORMATTED PRINT AT 80 CHARACTERS)
C 2020-01-09  J. Dong -- In subroutine W3ATOVSUNP, changed the windowing
C      decade from 20 to 40 for cases when the year is represented by
C      2 digits instead of 4.
C
C USAGE:    CALL W3ATOVSUNP(IUNIT,IBDATE,PP,TT,QQ,NLEV,IRTCHN,RTRAD,
C                           NCHN,STNID,ISATOB,RSATOB,DSNAME,IDSDAT,
C                           IDSDMP_8,IERR)
C   INPUT ARGUMENT LIST:
C     IUNIT    - UNIT NUMBER OF INPUT FILE CONTAINING RETRIEVAL DATA
C              - IN BUFR FORMAT.
C     IERR     - DUMP FILE VS. TANK FILE INDICATOR (=0 - DUMP FILE,
C              - MEANING CENTER TIME AND DUMP TIME SHOULD BE
C              - RETURNED IN IDSDAT AND IDMDMP, RESP. WITH OUTPUT
C              - IERR=1 AFTER FIRST CALL TO THIS SUBR. TO OPEN AN
C              - INPUT FILE; =1 - TANK FILE, MEANING CENTER TIME AND
C              - DUMP TIME WILL NEVER BE RETURNED IN IDSDAT AND IDMDMP,
C              - RESP. WITH OUTPUT IERR=1 AFTER FIRST CALL TO THIS
C              - SUBR.  TO OPEN AN INPUT FILE - IDSDAT AND IDSDMP_8 ARE
C              - BOTH RETURNED AS 99) (NOTE: THIS IS READ ONLY UPON
C              - FIRST CALL TO THIS SUBROUTINE TO OPEN AN INPUT FILE)
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     IBDATE   - DATE IN SECTION 1 OF BUFR MESSAGE CONTAINING THIS
C              - RETRIEVAL (IN FORM YYYYMMDDHH)
C     PP       - PRESSURE IN MB AT RETRIEVAL LEVELS (MUST BE
C              - DIMENSIONED TO AT LEAST 40 WORDS BY CALLING PROGRAM
C              - - ONLY 40 WORDS WILL BE FILLED HERE)
C     TT       - VIRTUAL TEMPERATURE IN DEG. K AT RETRIEVAL LEVELS
C              - (MUST BE DIMENSIONED TO AT LEAST 40 WORDS BY CALLING
C              - PROGRAM - ONLY 40 WORDS WILL BE FILLED HERE)
C     QQ       - SPECIFIC HUMIDITY IN G/G AT RETRIEVAL LEVELS (MUST
C              - BE DIMENSIONED TO AT LEAST 40 WORDS BY CALLING
C              - PROGRAM - ONLY 40 WORDS WILL BE FILLED HERE)
C     NLEV     - NUMBER OF RETRIEVAL LEVELS (SHOULD ALWAYS BE 40)
C     IRTCHN   - ATOVS RADIANCE CHANNELS (NUMERIC) (MUST BE
C              - DIMENSIONED TO AT LEAST 35 WORDS BY CALLING PROGRAM -
C              - ONLY 35 WORDS WILL BE FILLED HERE)
C     RTRAD    - ATOVS RADIANCES IN DEG. K (MUST BE DIMENSIONED TO AT
C              - LEAST 35 WORDS BY CALLING PROGRAM - ONLY 35 WORDS
C              - WILL BE FILLED HERE)
C     NCHN     - NUMBER OF RADIANCE CHANNELS (SHOULD ALWAYS BE 35)
C     STNID    - STATION ID (CHAR*8)
C     ISATOB   - 11-WORD INTEGER ARRAY CONTAINING RETURNED DATA
C              - (SEE REMARKS FOR CONTENTS)
C     RSATOB   - 16-WORD REAL ARRAY CONTAINING RETURNED DATA
C              - (SEE REMARKS FOR CONTENTS)
C     DSNAME   - CHARACTER*8 DATA SET NAME (SAME FOR ALL REPORTS IN
C              - A COMMON INPUT DATA SET - SEE REMARKS FOR OUTPUT
C              - IERR=1)
C     IDSDAT   - INTEGER DATA SET CENTER DATE IN FORM YYYYMMDDHH (SAME
C              - FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - REMARKS FOR OUTPUT IERR=1) (NOTE: RETURNED AS 99 IF
C              - INPUT IERR IS 1 FOR FIRST CALL TO THIS SUBROUTINE TO
C              - OPEN AN INPUT FILE)
C     IDSDMP_8 - INTEGER*8 DATA SET DUMP TIME IN FORM YYYYMMDDHHMM
C              - (SAME FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - REMARKS FOR OUTPUT IERR=1) (NOTE: RETURNED AS 99 IF
C              - INPUT IERR IS 1 FOR FIRST CALL TO THIS SUBROUTINE TO
C              - OPEN AN INPUT FILE)
C     IERR     - ERROR RETURN CODE
C                 =  0 OBSERVATION READ AND UNPACKED INTO OUTPUT
C                        ARGUMENT LOCATIONS (SEE ABOVE).  SEE REMARKS
C                        FOR CONTENTS. NEXT CALL TO W3ATOVSUNP WILL
C                        RETURN NEXT OBSERVATION IN DATA SET.
C                 =  1 INFORMATION ABOUT THE BUFR DATASET IS RETURNED
C                        IN THE OUTPUT ARGUMENTS DSNAME, IDSDAT,
C                        IDSDMP_8 (SEE OUTPUT ARGUMENT LIST ABOVE)
C
C                        THIS SHOULD ALWAYS OCCUR AFTER THE FIRST CALL
C                        TO THIS SUBROUTINE TO OPEN AN INPUT FILE.  NO
C                        REPORT IS UNPACKED AT THIS POINT, AND ONLY
C                        DSNAME, IDSDAT, AND IDSDMP_8 CONTAIN
C                        INFORMATION. ALL SUBSEQUENT CALLS TO
C                        W3ATOVSUNP SHOULD RETURN THE OBSERVATIONS IN
C                        THIS DATA SET, SEQUENTIALLY, (OUTPUT IERR=0)
C                        UNTIL THE END OF FILE IS ENCOUNTERED (OUTPUT
C                        IERR=2).  THE VALUES STORED IN DSNAME, IDSDAT,
C                        AND IDSDMP_8 WILL CONTINUE TO BE RETURNED
C                        ALONG WITH EACH REPORT OUTPUT WHEN OUTPUT IERR
C                        = 0.
C                 =  2 FOR NORMAL END-OF-FILE ENCOUNTERED.
C                 = -1 FOR END-OF-FILE ON FIRST READ TO OPEN AN INPUT
C                        FILE -- EMPTY FILE
C                 = -2 FOR INPUT BUFR FILE NOT Y2K COMPLIANT -- NO
C                        PROCESSING DONE
C                 = -3 CENTER DATE COULD NOT BE OBTAINED FROM INPUT
C                        FILE -- NO PROCESSING DONE (CAN ONLY HAPPEN
C                        WHEN INPUT IERR IS 0 FOR FIRST CALL TO THIS
C                        SUBROUTINE TO OPEN AN INPUT FILE)
C
C   INPUT FILES:
C     UNIT "IUNIT" - FILE CONTAINING BUFR ATOVS DATA
C
C   OUTPUT FILES:
C     UNIT 06 - STANDARD OUTPUT PRINT
C
C REMARKS:
C
C     CONTENTS OF OUTPUT ARGUMENT ISATOB (11 INTEGER WORDS) FOR EACH
C      RETRIEVAL:
C        WORD  1 - SATELLITE IDENTIFIER
C                                      (BUFR C.T. 0-01-007)
C        WORD  2 - PREPBUFR REPORT TYPE
C                     (=161 FOR CLEAR PATH OVER LAND)
C                     (=163 FOR CLOUDY PATH OVER LAND)
C                     (=171 FOR CLEAR PATH OVER OCEAN)
C                     (=173 FOR CLOUDY PATH OVER OCEAN)
C        WORD  3 - SWATH LOCATION :  1 INDICATES LEFT  LIMB OF SWATH
C                                   56 INDICATES RIGHT LIMB OF SWATH
C                           USED FOR DETERMINING DISTANCE FROM NADIR
C        WORD  4 - ORBIT NUMBER
C        WORD  5 - NESDIS LAND-SEA FLAG
C                     (= 0 FOR SEA)
C                     (= 1 FOR LAND)
C        WORD  6 - SATELLITE DATA PROCESSING TECHNIQUE
C                     (= 1 FOR CLEAR PATH)
C                     (= 3 FOR CLOUDY PATH)
C        WORD  7 - ATOVS FILTER FLAG (=  0 FOR GOOD)
C                                    (=  1 FOR REDUNDANT)
C                                    (=-99 FOR MISSING)
C                   IMPORTANT: REDUNDANT RETRIEVALS ARE AT FULL 40 KM
C                              RESOLUTION; GOOD RETRIEVALS ARE AT
C                              250 KM RESOLUTION
C        WORD  8 - SUPERADIABATIC FLAG (=0 FOR NOT SUPERADIABATIC)
C                                      (.NE. 0 FOR SUPERADIABATIC)
C        WORD  9 - DAY/NIGHT QUALIFIER (=0 FOR NIGHT)
C                                      (=1 FOR DAY)
C                                      (BUFR C.T. 0-08-013)
C        WORD 10 - FRAME COUNT (BUFR C.T. 0-25-071)
C        WORD 11 - SNOW/ICE FLAGS (TERRAIN TYPE)
C                                      (BUFR C.T. 0-13-039)
C
C     CONTENTS OF OUTPUT ARGUMENT RSATOB (17 REAL WORDS) FOR EACH
C      RETRIEVAL:
C        WORD  1 - OBSERVATION TIME IN HOURS GOOD TO 0.01 HOUR.
C        WORD  2 - LATITUDE IN DEGREES (N+,S-)
C        WORD  3 - LONGITUDE IN DEGREES EAST (0.0 to 359.99)
C        WORD  4 - SURFACE HEIGHT IN METERS
C        WORD  5 - FIRST ABOVE-GROUND ATOVS PRESSURE LEVEL IN MB
C        WORD  6 - SKIN TEMPERATURE IN DEGREES K
C        WORD  7 - TOTAL PRECIPITABLE WATER IN MM
C        WORD  8 - TOTAL OZONE IN DOBSONS
C        WORD  9 - SEA SURFACE TEMPERATURE IN DEGREES K
C        WORD 10 - CLOUD-TOP PRESSURE IN MB (MISSING IF CLEAR)
C        WORD 11 - SOLAR ZENITH ANGLE IN DEGREES
C        WORD 12 - SATELLITE ZENITH ANGLE IN DEGREES
C        WORD 13 - CLOUD AMOUNT (C.T. 0-20-011)
C        WORD 14 - HIRS CHANNEL UTILIZATION FLAGS
C        WORD 15 - AMSU-A CHANNEL UTILIZATION FLAGS
C        WORD 16 - AMSU-B CHANNEL UTILIZATION FLAGS
C
C FOR ALL DATA: MISSING VALUES ARE RETURNED AS XMISS (99999.) (REAL) OR
C               IMISS (99999) (INTEGER)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE W3ATOVSUNP(IUNIT,IBDATE,PP,TT,QQ,NLEV,IRTCHN,RTRAD,
     $ NCHN,STNID,ISATOB,RSATOB,DSNAME,IDSDAT,IDSDMP_8,IERR)

      REAL  PP(*),TT(*),QQ(*),RTRAD(*)

      INTEGER  IRTCHN(*),JDATE(5),JDUMP(5),NF(0:3),IBIT(2),IPRINT_CNT(2)

      INTEGER(8) IDSDMP_8,JDUMP_8(5)

      CHARACTER*4 CTYPE

      CHARACTER*8 SUBSET,DSNAME

      CHARACTER*50 IDTSTR
      DATA IDTSTR/'SAID CLAT CLON OBQL HOUR MINU SECO FOVN ORBN SADF '/
      CHARACTER*10 IDTST2
      DATA IDTST2/'DNQL TOFF '/

      CHARACTER*55 INFSTR
      DATA INFSTR
     $ /'SOEL SAZA FRCT OZON SDPT HIRC AMAC AMBC TPWT CLAM SZNT '/

      CHARACTER*32 SRFSTR
      DATA SRFSTR/'PRES SELV LSQL TMSKST SST1 TERN '/

      CHARACTER*25 RETSTR
      DATA RETSTR/'PRLC TMDBST MIXR '/

      CHARACTER*12 BRTSTR
      DATA BRTSTR/'CHNM TMBRST '/

      REAL(8) XIDENT_8(12),XINFO_8(11),SRFDAT_8(6),RETDAT_8(3,41),
     $        BRTDAT_8(2,35),AMAXIMUM_8
      REAL(8) BMISS,GETBMISS

      DIMENSION  KOUNT(0:3,0:3),ISATOB(11),RSATOB(16)

      CHARACTER*8   STNID

      CHARACTER*1   NMCHAR(0:35)

      SAVE

      DATA          NMCHAR/'0','1','2','3','4','5','6','7','8','9',
     $                     'A','B','C','D','E','F','G','H','I','J',
     $                     'K','L','M','N','O','P','Q','R','S','T',
     $                     'U','V','W','X','Y','Z'/
 
      DATA IFIRST/0/,KOUNTR/0/,LWI/0/,LWR/0/,MFIRST/0/,nfirst/0/
      DATA  KOUNT/16*0/,XMISS/99999./,IMISS/99999/,NF/31,13,35,17/,
     $ CTYPE/'DUMP'/,IPRINT_CNT/2*0/

C  FCN PR GETS STD. ATMOS. PRESSURE (MB) FROM HEIGHT (M) (HGHT < 11000M)
C  ---------------------------------------------------------------------

      PR(HGHT) = 1013.25 * (((288.15 - (.0065 * HGHT))/288.15)**5.256)

      CALL STATUS(IUNIT,LUN,IL,IM)

      IF(IL.EQ.0) THEN
         print'(" ~~~ input BUFR file is CLOSED - start fresh")'
         IFIRST = 0
      END IF

      IF(IFIRST.EQ.0) THEN

C  FIRST TIME IN TO OPEN AN INPUT FILE, INITIALIZE COUNTERS,
C   SET DATELEN, GET CENTER AND DUMP TIME FOR FILE, AND GET VALUE FOR
C   "BMISS"
C  ------------------------------------------------------------------

         PRINT'("  ==> W3ATOVSUNP -- WCOSS VERSION 01-09-2020")'
         IFIRST     = 1
         KOUNTR     = 0
         MFIRST     = 0
         nfirst     = 0
         KOUNT      = 0
         IPRINT_CNT = 0
         IDSDAT     = 99
         IDSDMP_8   = 99_8
         CALL DATELEN(10)
         IF(IERR.NE.1) THEN
            CTYPE = 'DUMP'
            CALL DUMPBF(IUNIT,JDATE,JDUMP)
cppppp
            print'(" INPUT FILE IS A DUMP FILE ...")'
            print'("  -- CENTER DATE (JDATE) = ",5(I0,1X))', jdate
            print'("  -- DUMP DATE   (JDUMP) = ",5(I0,1X))', jdump
            print'(1X)'
cppppp
            IF(JDATE(1).LE.0)  then
               PRINT'(" ##W3ATOVSUNP - CENTER DATE COULD NOT BE ",
     $         "OBTAINED FROM INPUT FILE ON UNIT ",I0," -- IERR = -3")',
     $         IUNIT
               IERR = -3
               RETURN
            END IF
            IF(JDATE(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN JDATE(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

               PRINT'(" ##W3ATOVSUNP - THE FOLLOWING SHOULD NEVER ",
     $          "HAPPEN!!!!!")'
               PRINT'(" ##W3ATOVSUNP - 2-DIGIT YEAR IN JDATE(1) ",
     $          "RETURNED FROM DUMPBF (JDATE IS: ",I5,4I3") - USE ",
     $          "WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', JDATE
C IF JDATE=41~99 THEN JDATE=1941~1999
C IF JDATE=00~40 THEN JDATE=2000~2040
               IF(JDATE(1).GT.40)  THEN
                  JDATE(1) = 1900 + JDATE(1)
               ELSE
                  JDATE(1) = 2000 + JDATE(1)
               ENDIF
               PRINT'(" ##W3ATOVSUNP - CORRECTED JDATE(1) WITH 4-DIGIT",
     $          " YEAR, JDATE NOW IS: ",I5,4I3)', JDATE
            ENDIF
            IDSDAT = JDATE(1)*1000000+JDATE(2)*10000+JDATE(3)*100+
     $       JDATE(4)
            IF(JDUMP(1).LE.0)  THEN
               IDSDMP_8 = 999999999999_8
            ELSE
               IF(JDUMP(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN JDUMP(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

                  PRINT'(" ##W3ATOVSUNP - THE FOLLOWING SHOULD NEVER ",
     $             "HAPPEN!!!!!")'
                  PRINT'(" ##W3ATOVSUNP - 2-DIGIT YEAR IN JDUMP(1) ",
     $             "RETURNED FROM DUMPBF (JDUMP IS: ",I5,4I3") - USE ",
     $             "WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', JDUMP
C IF JDUMP=41~99 THEN JDUMP=1941~1999
C IF JDUMP=00~40 THEN JDUMP=2000~2040
                  IF(JDUMP(1).GT.40)  THEN
                     JDUMP(1) = 1900 + JDUMP(1)
                  ELSE
                     JDUMP(1) = 2000 + JDUMP(1)
                  ENDIF
                  PRINT'(" ##W3ATOVSUNP - CORRECTED JDUMP(1) WITH 4-",
     $             "DIGIT YEAR, JDUMP NOW IS: ",I5,4I3)', JDUMP
               END IF
               JDUMP_8 = JDUMP
               IDSDMP_8 = JDUMP_8(1)*100000000+JDUMP_8(2)*1000000+
     $          JDUMP_8(3)*10000+JDUMP_8(4)*100+JDUMP_8(5)
            ENDIF
         ELSE
            CTYPE = 'TANK'
cppppp
            print'(1X)'
            print'(" INPUT FILE IS A TANK FILE ...")'
            print'("  -- CENTER DATE AND DUMP DATE ARE NOT RETURNED")'
            print'(1X)'
cppppp
         ENDIF
c-----------------------------------------------------------------------
c This logic is needed only because SUBSET is not returned in DUMPBF
c  and we need it in order to return dsname - will close data set
c  prior to openbf for ifirst=1 case
         call openbf(iunit,'IN',iunit)
         call readmg(iunit,subset,ibdate,iret)
         if(subset.eq.'NC003104')  then
            dsname = 'ATOVS   '
         else
            dsname = '????????'
         end if
c-----------------------------------------------------------------------

C  GET WORDLENGTH FOR INTEGERS AND REALS
C  -------------------------------------

         CALL WORDLENGTH(LWI,LWR)
         PRINT 678, LWI,LWR
  678 FORMAT('  ===> MACHINE WORD LENGTH: INTEGERS - ',I1,'; REALS - ',
     $ I1/)
c-----------------------------------------------------------------------

C  GET VALUE FOR "BMISS"
C  --------------------

         BMISS = GETBMISS()
         print'(1X)'
         print'(" BUFRLIB value for missing passed into W3ATOVSUNP is:",
     $    1X,G0)', bmiss
         print'(1X)'
c-----------------------------------------------------------------------

         IERR = 1
         RETURN
      ELSE  IF(IFIRST.EQ.1) THEN
c-----------------------------------------------------------------------
c This logic is needed only because SUBSET is not returned in DUMPBF
c  (see a few lines above)
         call closbf(iunit)
c-----------------------------------------------------------------------

C  SECOND TIME IN TO OPEN AN INPUT FILE, OPEN BUFR DATASET FOR INPUT
C   AND DECODE FIRST MESSAGE
C  -----------------------------------------------------------------

         IFIRST = 2
         CALL OPENBF(IUNIT,'IN',IUNIT)
         CALL READMG(IUNIT,SUBSET,IBDATE,IRET)
         IF(IRET.NE.0) THEN
            WRITE(6,1009) IUNIT
 1009       FORMAT('##W3ATOVSUNP ERROR: EMPTY FILE IN UNIT ',I5)
            IERR = -1
            RETURN
         ENDIF
         IF(IBDATE.LT.100000000)  THEN
C IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
C  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
C  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            WRITE(6,1209) IUNIT
 1209       FORMAT('##W3ATOVSUNP ERROR: A 10-DIGIT SECT. 1 BUFR ',
     $       'MESSAGE DATE WAS NOT RETURNED IN UNIT',I5,' - PROBLEM ',
     $       'WITH BUFR FILE')
            IERR = -2
            RETURN
         END IF
      ENDIF

 1000 CONTINUE                                                          

C  EACH CALL TO READSB INCREASES "KOUNTR" BY 1 (REGARDLESS OF RESULT)
C  ------------------------------------------------------------------

      KOUNTR = KOUNTR + 1

      CALL READSB(IUNIT,IRET)
      IF(IRET.NE.0) THEN
        CALL READMG(IUNIT,SUBSET,IBDATE,IRET)
        IF(IRET.NE.0) THEN

C  ALL BUFR MESSAGES HAVE BEEN READ AND DECODED -- ALL DONE
C  --------------------------------------------------------

           WRITE(6,1001) IUNIT
 1001 FORMAT(//' ==> W3ATOVSUNP: END OF FILE ON UNIT',I3,' -- ALL ',
     $ 'DONE'/)
           call closbf(iunit)
           IERR = 2
           RETURN
        ENDIF
         IF(IBDATE.LT.100000000)  THEN
C IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
C  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
c  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            WRITE(6,1209) IUNIT
            IERR = -2
            RETURN
         END IF
        GO TO 1000
      ENDIF

      XIDENT_8 = BMISS
      CALL UFBINT(IUNIT,XIDENT_8,12, 1,IRET,IDTSTR//IDTST2)

      XINFO_8 = BMISS
      CALL UFBINT(IUNIT,XINFO_8 ,11, 1,IRET,INFSTR)

      SRFDAT_8 = BMISS
      CALL UFBINT(IUNIT,SRFDAT_8, 6, 1,IRET,SRFSTR)

      RETDAT_8 = BMISS
      CALL UFBREP(IUNIT,RETDAT_8, 3,41,NLEV,RETSTR)

      BRTDAT_8 = BMISS
      CALL UFBREP(IUNIT,BRTDAT_8, 2,35,NCHN,BRTSTR)

      ISATOB = IMISS
      RSATOB = XMISS
      PP(1:40) = XMISS
      TT(1:40) = XMISS
      QQ(1:40) = XMISS
      IRTCHN(1:35) = IMISS
      RTRAD(1:35) = XMISS

C  SATELLITE IDENTIFIER
C  --------------------

      IF(IBFMS(XIDENT_8(1)).EQ.0)  THEN
         ISATOB(1) = NINT(XIDENT_8(1))
         IF(ISATOB(1).NE.4.AND.
     $     (ISATOB(1).LT.200.OR.ISATOB(1).GT.209)) THEN
            WRITE(6,2071) KOUNTR,ISATOB(1)
 2071 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' AN UNRECOGNIZED SATELLITE ID (=',I5,') - SKIP IT')
            GO TO 1000
         ENDIF
      ELSE
         WRITE(6,2072) KOUNTR
 2072 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING SATELLITE ID - SKIP IT')
         GO TO 1000
      ENDIF

C  LATITUDE
C  --------

      IF(IBFMS(XIDENT_8(2)).EQ.0)  THEN
         RSATOB(2) = XIDENT_8(2)
      ELSE
         WRITE(6,2073) KOUNTR
 2073 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING LATITUDE - SKIP IT')
         GO TO 1000
      ENDIF

C  LONGITUDE
C  ---------

      IF(IBFMS(XIDENT_8(3)).EQ.0)  THEN

C Important: According to BUFR Manual, CLON (0-06-002) - represented
C  here by "XIDENT_8(3)" - should be in units of Degrees West - and
C  East + (-180.0 to +180.0); however some BUFR data sets (e.g.,
C  PREPBUFR) are known to encode 0-06-002 in units of Degrees East
C  (0.0 to 359.99)
C  -- So we use the following conversion to work in either case ...
         RSATOB(3) = 360._8 - MOD(360._8-XIDENT_8(3),360._8)
         IF(RSATOB(3).EQ.360.0)  RSATOB(3) = 0.0
      ELSE
         WRITE(6,2074) KOUNTR
 2074 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING LONGITUDE - SKIP IT')
         GO TO 1000
      ENDIF

C  FILTER FLAG
C  -----------

      IF(IBFMS(XIDENT_8(12)).EQ.0)  THEN
C  If NESDIS starts encoding filter flag in "TOFF" ...
         ISATOB(7) = NINT(XIDENT_8(12))
      ELSE IF(IBFMS(XIDENT_8(4)).EQ.0)  THEN
C  If NESDIS starts encoding filter flag in "OBQL" ...
         ISATOB(7) = NINT(XIDENT_8(4))
      ELSE
cvvvvvdak
C  Currently filter flag is missing - set to "-99" until NESDIS fixes
C   (alerts calling program to process only every 11'th retrieval to
C   simulate 250km sampling - needed for cdas runs)
cdak     WRITE(6,2075) KOUNTR
c2075 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
cdak $ ' A MISSING FILTER FLAG - SKIP IT')
cdak     GO TO 1000
         if(nfirst.eq.0)  then
            write(6,9082)
 9082 format(/'##W3ATOVSUNP WARNING: NESDIS HAS NOT STORED A FILTER ',
     $ 'FLAG SO SET OUTPUT FILTER FLAG TO -99 FOR ALL REPORTS'/)
            nfirst=1
         end if
         isatob(7) = -99
caaaaadak
      ENDIF

C  OBSERVATION TIME
C  ----------------

      AMAXIMUM_8 = MAX(XIDENT_8(5),XIDENT_8(6),XIDENT_8(7))
      IF(IBFMS(AMAXIMUM_8).EQ.0) THEN
         HRFRAC = (60.0 * XIDENT_8(6) + XIDENT_8(7)) / 3600.0
         RSATOB(1) = XIDENT_8(5) + HRFRAC
         RSATOB(1) = 0.01 * AINT(100.0 * RSATOB(1) + 0.5)
      ELSE
         WRITE(6,2076) KOUNTR
 2076 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' ONE OR MORE MISSING TIME UNITS - SKIP IT')
         GO TO 1000
      ENDIF

C  SWATH LOCATION
C  --------------

      IF(IBFMS(XIDENT_8(8)).EQ.0)  THEN
         ISATOB(3) = NINT(XIDENT_8(8))
      ELSE
         WRITE(6,2077) KOUNTR
 2077 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING SWATH LOCATION - SKIP IT')
         GO TO 1000
      ENDIF

C  ORBIT NUMBER
C  ------------

      IF(IBFMS(XIDENT_8(9)).EQ.0)  ISATOB(4) = NINT(XIDENT_8(9))

C  SUPERADIABATIC FLAG
C  -------------------

      IF(IBFMS(XIDENT_8(10)).EQ.0)  ISATOB(8) = NINT(XIDENT_8(10))
      IF(ISATOB(8).NE.0)  THEN
         WRITE(6,2078) KOUNTR,ISATOB(8)
 2078 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') IS ',
     $ 'SUPERADIABATIC (FLAG=',I5,') - SKIP IT')
         GO TO 1000
      ENDIF

C  DAY-NIGHT INDICATOR
C  -------------------

      IF(IBFMS(XIDENT_8(11)).EQ.0)  ISATOB(9) = NINT(XIDENT_8(11))

C  SOLAR ZENITH ANGLE
C  ------------------

      IF(IBFMS(XINFO_8(1)).EQ.0)  RSATOB(11) = XINFO_8(1)

C  SATELLITE ZENITH ANGLE
C  ----------------------

      IF(IBFMS(XINFO_8(2)).EQ.0)  THEN
         RSATOB(12) = XINFO_8(2)  ! SAZA is mnemonic after 3/2002
      ELSE IF(IBFMS(XINFO_8(11)).EQ.0)  THEN
         RSATOB(12) = XINFO_8(11) ! SZNT is mnemonic before 3/2002
      END IF
      
C  FRAME COUNT
C  -----------

      IF(IBFMS(XINFO_8(3)).EQ.0)  ISATOB(10) = XINFO_8(3)

C  OZONE
C  -----

      IF(IBFMS(XINFO_8(4)).EQ.0)  RSATOB(8) = XINFO_8(4)

C  SATELLITE DATA PROCESSING TECHNIQUE
C  -----------------------------------

      IF(IBFMS(XINFO_8(5)).EQ.0)  THEN
         ISDPT = NINT(XINFO_8(5))
         IOFF = (LWI * 8) - 6
         CALL GBYTES(ISDPT,IBIT,IOFF,1,1,2)
cppppp
cdak     print'(" ISDPT,ICLR,ICDY:",3(I0,1X))', ISDPT,IBIT,ICDY
cppppp
      ELSE
         WRITE(6,2079) KOUNTR
 2079 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING SATELLITE DATA PROCESSING TECHNIQUE - SKIP IT')
         GO TO 1000
      ENDIF

C  HIRS CHANNEL UTILIZATION FLAGS
C  ------------------------------

      IF(IBFMS(XINFO_8(6)).EQ.0)  RSATOB(14) = XINFO_8(6)

C  AMSU-A CHANNEL UTILIZATION FLAGS
C  --------------------------------

      IF(IBFMS(XINFO_8(7)).EQ.0)  RSATOB(15) = XINFO_8(7)

C  AMSU-B CHANNEL UTILIZATION FLAGS
C  --------------------------------

      IF(IBFMS(XINFO_8(8)).EQ.0)  RSATOB(16) = XINFO_8(8)

C  TOTAL PRECIPITABLE WATER (IN MM)
C  --------------------------------

      IF(IBFMS(XINFO_8(9)).EQ.0)  RSATOB(7) = XINFO_8(9)

C  CLOUD AMOUNT
C  ------------

      IF(IBFMS(XINFO_8(10)).EQ.0)  RSATOB(13) = XINFO_8(10)

C  STATION ID
C  ----------

      STNID = '      A '
      MODSAT = MOD(ISATOB(1),4)
      ISATOB(6) = IMISS
      IF(IBIT(1).EQ.1.AND.IBIT(2).EQ.0) THEN

C  CLEAR PATH
C  ----------

         ISATOB(6) = 1
         STNID(8:8) = NMCHAR(NF(MODSAT)-3)
      ELSE IF((IBIT(1).EQ.0.AND.IBIT(2).EQ.1).OR.
     $        (IBIT(1).EQ.0.AND.IBIT(2).EQ.0)) THEN

C  CLOUDY PATH
C  -----------

         ISATOB(6) = 3
         STNID(8:8) = NMCHAR(NF(MODSAT)-1)
      ELSE

C  UNKNOWN PATH
C  ------------

         ISATOB(6) = 0
         STNID(8:8) = NMCHAR(NF(MODSAT))
         WRITE(6,2080) KOUNTR,STNID,NINT(XINFO_8(5)),IBIT
 2080 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,',ID=',
     $ A8,') HAS AN UNKNOWN SATELLITE DATA PROCESSING TECH. (=',I5,','/
     $ 24X,'WITH ICLR=',I1,' AND ICDY=',I1,') - SKIP IT')
         GO TO 1000
      ENDIF

      KOUNT(ISATOB(6),MODSAT) = MIN(99999,KOUNT(ISATOB(6),MODSAT) + 1)
      WRITE(STNID(2:6),'(I5.5)') KOUNT(ISATOB(6),MODSAT)

      NADIR = INT(ABS(FLOAT(ISATOB(3)) - 28.5)) / 3
      IF(NADIR.LT.9) NADIR = NADIR + 1
      IF(NADIR.GT.0.AND.NADIR.LT.10)  THEN
         STNID(1:1) = NMCHAR(NADIR)
      ELSE
         WRITE(6,2081) KOUNTR,STNID,NADIR
 2081 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,',ID=',
     $ A8,') HAS AN INVALID NADIR PROX. IND. (=',I5,') - SKIP IT')
         GO TO 1000
      ENDIF

      IF(NLEV.EQ.41)  THEN

C  CLOUD-TOP PRESSURE (ON LEVEL 1)
C  -------------------------------

         IF(IBFMS(RETDAT_8(1,1)).EQ.0) RSATOB(10) = RETDAT_8(1,1) * 0.01

C  Note: A value of 1250 mb means clear conditions, set cloud top
C        pressure to missing in this case

         IF(NINT(RSATOB(10)).EQ.1250)  RSATOB(10) = XMISS

C  FILL IN THE LEVEL SOUNDING DATA - MUST HAVE 40 TEMP LEVELS TO ACCEPT
C  --------------------------------------------------------------------

         DO L = 2,NLEV
            LREV = NLEV + 1 - L
            PP(LREV) = RETDAT_8(1,L) * 0.01
            IF(IBFMS(RETDAT_8(2,L)).EQ.0) THEN
               IF(IBFMS(RETDAT_8(3,L)).NE.0) THEN
                  TT(LREV) = RETDAT_8(2,L)
               ELSE
                  QQ(LREV) = RETDAT_8(3,L) / (1.0 + RETDAT_8(3,L))
                  TT(LREV) = RETDAT_8(2,L) * (1.0 + 0.61 * QQ(LREV))
               ENDIF
            ELSE
C  (The amount of printout is limited if input is a TANK since this
C   is very common and can generate thousands of lines of print.)
               IF(CTYPE.EQ.'DUMP'.OR.IPRINT_CNT(2).LT.250)  THEN
                  WRITE(6,3082) KOUNTR
 3082 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,') ',
     $ 'CONTAINS 1 OR MORE MISSING TEMPERATURES IN ITS SOUNDING - SKIP',
     $ ' IT')
               ELSE IF(IPRINT_CNT(2).EQ.250)  THEN
                  WRITE(6,3088)
 3088 FORMAT(/'##W3ATOVSUNP WARNING: THE NUMBER OF DECODED RETRIEVALS ',
     $ 'CONTAINING 1 OR MORE MISSING TERMPERATURES IN ITS'/22X,
     $ 'SOUNDING HAS HIT THE PRINTOUT LIMIT - NO MORE PRINTOUT WILL BE',
     $ ' GENERATED'/)
               END IF
               IPRINT_CNT(2) = IPRINT_CNT(2) + 1
               GO TO 1000
            ENDIF
         ENDDO
         NLEV = 40
      ELSE
         WRITE(6,2082) STNID,KOUNTR,NLEV
 2082 FORMAT(/'##W3ATOVSUNP WARNING: ID ',A8,' (#',I7,') DOES NOT ',
     $ 'CONTAIN 40 SOUNDING LVLS PLUS 1 CLOUD-TOP LVL (HAS ',I3,
     $ ' LVLS) -- NO SOUNDING LEVEL DATA PROCESSED')
      ENDIF

      IF(NCHN.EQ.35)  THEN

C  FILL IN THE RADIANCE DATA
C  -------------------------

         DO L = 1,NCHN
            IF(IBFMS(BRTDAT_8(1,L)).EQ.0) IRTCHN(L) =NINT(BRTDAT_8(1,L))
            IF(IBFMS(BRTDAT_8(2,L)).EQ.0) RTRAD(L)  = BRTDAT_8(2,L)
         ENDDO
      ELSE
         WRITE(6,2083) STNID,KOUNTR,NCHN
 2083 FORMAT(/'##W3ATOVSUNP WARNING: ID ',A8,' (#',I7,') DOES NOT ',
     $ 'CONTAIN 35 RADIANCE CHANNELS (HAS ',I3,' CHANNELS) -- NO ',
     $ 'RADIANCE DATA PROCESSED')
      ENDIF

C  SURFACE HEIGHT
C  --------------

      IF(IBFMS(SRFDAT_8(2)).EQ.0)  THEN
         RSATOB(4) = SRFDAT_8(2)
      ELSE
         WRITE(6,2085) KOUNTR,STNID
 2085 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,',ID=',
     $ A8,') HAS A MISSING SURFACE HEIGHT - SKIP IT')
         GO TO 1000
      ENDIF

C  BOTTOM LEVEL PRESSURE
C  ---------------------

      IF(SRFDAT_8(1).LT.20000.)  THEN
C --> NESDIS is scaling bottom pressure incorrectly, this accounts for
C      this and for a future fix on their part (fixed on 11/07/2001)
         RSATOB(5) = 0.1 * SRFDAT_8(1)
         IF(MFIRST.EQ.0)  THEN
            WRITE(6,9081)
 9081 FORMAT(/'##W3ATOVSUNP WARNING: NESDIS IS STORING BOTTOM PRESSURE',
     $ ' AS 0.1 PASCALS INSTEAD OF AS PASCALS, THIS SUBROUTINE WILL ',
     $ 'CORRECT'/24X,'FOR THIS UNTIL NESDIS FIXES THEIR ERROR'/)
            MFIRST=1
         END IF
      ELSE IF(IBFMS(SRFDAT_8(1)).EQ.0)  THEN
         RSATOB(5) = 0.01 * SRFDAT_8(1)
      ELSE
         WRITE(6,2084) KOUNTR,STNID
 2084 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,',ID=',
     $ A8,') HAS A MISSING BOTTOM PRESSURE LEVEL - SKIP IT')
         GO TO 1000
      ENDIF
C  Do a SANITY check on pressure (NESDIS can have some strange values)
C  (The amount of printout is limited if input is a TANK since this
C   is very common and can generate thousands of lines of print.)
      DVAL = RSATOB(5) - PR(RSATOB(4))
      IF(DVAL.LE.-75..OR.DVAL.GE.50.)  THEN
         IF(CTYPE.EQ.'DUMP'.OR.IPRINT_CNT(1).LT.250)  THEN
            WRITE(6,2087) KOUNTR,STNID,RSATOB(5),NINT(RSATOB(4))
 2087 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,',ID=',
     $ A8,') HAS A BAD BOTTOM PRES LVL (PBOT=',F6.1,' MB, ELEV=',I4,
     $ ' M) - SKIP IT')
         ELSE IF(IPRINT_CNT(1).EQ.250)  THEN
            WRITE(6,3087)
 3087 FORMAT(/'##W3ATOVSUNP WARNING: THE NUMBER OF DECODED RETRIEVALS ',
     $ 'WITH A BAD BOTTOM PRES LVL HAS HIT THE PRINTOUT LIMIT - '/22X,
     $ 'NO MORE PRINTOUT WILL BE GENERATED'/)
         END IF
         IPRINT_CNT(1) = IPRINT_CNT(1) + 1
         GO TO 1000
      ENDIF

C  REPORT TYPE AND LAND/SEA TAG
C  ----------------------------

      IF(NINT(SRFDAT_8(3)).EQ.1)  THEN
C  Sea (LSQL=1)
         ISATOB(2) = 170 + ISATOB(6)
         ISATOB(5) = 0
      ELSE  IF(NINT(SRFDAT_8(3)).EQ.0.OR.NINT(SRFDAT_8(3)).EQ.2)  THEN
C  Land (LSQL=0) or Coast (LSQL=2)
         ISATOB(2) = 160 + ISATOB(6)
         ISATOB(5) = 1
      ELSE
         WRITE(6,2086) KOUNTR,STNID
 2086 FORMAT(/'##W3ATOVSUNP WARNING: A DECODED RETRIEVAL (#',I7,',ID=',
     $ A8,') HAS A MISSING LAND/SEA INDICATOR - SKIP IT')
         GO TO 1000
      ENDIF

C  SKIN TEMPERATURE
C  ----------------

      IF(IBFMS(SRFDAT_8(4)).EQ.0)  RSATOB(6) = SRFDAT_8(4)

C  SEA-SURFACE TEMPERATURE
C  -----------------------

      IF(IBFMS(SRFDAT_8(5)).EQ.0)  RSATOB(9) = SRFDAT_8(5)

C  TERRAIN INDICATOR
C  -----------------

      IF(IBFMS(SRFDAT_8(6)).EQ.0)  ISATOB(11) = NINT(SRFDAT_8(6))

C  RETURN WITH DECODED ATOVS RETRIEVAL
C  -----------------------------------

      IERR = 0

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    OEFG01
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2007-09-14
C
C ABSTRACT: FUNCTION WHICH RETURNS THE OBSERVATION ERROR FOR A
C   REQUESTED VARIABLE INTERPOLATED TO A DEFINED PRESSURE LEVEL FOR A
C   DEFINED REPORT TYPE.  IT IS OBTAINED FROM AN INPUT ARRAY CONTAINING
C   OBSERVATION ERRORS ON FIXED PRESSURE LEVELS BY VARIABLE AND REPORT
C   TYPE (READ EARLIER FROM THE EXTERNAL OBSERVATION ERROR TABLE)
C
C PROGRAM HISTORY LOG:
C 1995-05-17  J. WOOLLEN (NP20) - ORIGINAL AUTHOR (FUNCTION OEF)
C 2007-09-14 D. A. KEYSER -- MODIFIED TO USE EXACT LOGIC AS IN GSI
C    (MINIMUM LIMITING VALUE FOR OBS ERROR BASED ON VARIABLE TYPE,
C     LEVEL PRESSURE LIMITED TO MAX OF 2000 MB AND MIN OF ZERO MB, A
C     FEW OTHER MINOR CHANGES)
C
C USAGE:    XX = OEFG01(P,TYP,IE,OEMIN)
C   INPUT ARGUMENT LIST:
C     P        - REAL PRESSURE LEVEL (MB) TO INTERPOLATE OBS ERROR TO
C     TYP      - REAL PREPBUFR REPORT TYPE
C     IE       - VARIABLE TYPE BEING INTERPOLATED (=2 - TEMPERATURE,
C              - =3 - MOISTURE, =4 - WIND, =5 - SURFACE PRESSURE, =6 -
C              - PRECIPITABLE WATER)
C              - (USED ONLY IN PREVENTS MODE)
C     OEMIN    - REAL MINIMUM VALUE FOR OBS ERROR (FOR VARIABLE BEING
C              - INTERPOLATED)
C
C REMARKS: 'OEFG01' RETURNED IS OBSERVATION ERROR FOR VARIABLE "IE" IN
C     REPORT TYPE "TYP", INTERPOLATED TO PRESSURE LEVEL "P".
CC
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM-SP
C
C$$$
      FUNCTION OEFG01(P,TYP,IE,OEMIN)

      COMMON /GBEVDD/ERRS(300,33,6)

      OEFG01 = 10E10

C  LOOK UP ERRORS FOR PARTICULAR OB TYPES
C  --------------------------------------

      KX = TYP

      P = MAX(0.,MIN(P,2000.))

      IF(P.GE.ERRS(KX,1,1)) K1 = 1

      DO KL = 1,32
         IF(P.GE.ERRS(KX,KL+1,1).AND.P.LE.ERRS(KX,KL,1))  K1 = KL
      ENDDO

      IF(P.LE.ERRS(KX,33,1)) K1 = 5

      K2 = K1 + 1

      EDIFF = ERRS(KX,K2,1) - ERRS(KX,K1,1)
      IF(ABS(EDIFF).GT.0.0)  THEN
         DEL = (P - ERRS(KX,K1,1))/EDIFF
      ELSE
         DEL = 1.E11
      ENDIF

      DEL = MAX(0.,MIN(DEL,1.0))

      OEFG01 = ((1.0 - DEL) * ERRS(KX,K1,IE)) + (DEL * ERRS(KX,K2,IE))
      OEFG01 = MAX(OEFG01,OEMIN)

C  SET MISSING ERROR VALUE TO 10E10
C  --------------------------------

      IF(OEFG01.GE.5E5) OEFG01 = 10E10

      RETURN

      END

      SUBROUTINE W3CNVXTOVS (IBUFTN,IFLDUN,stnid,INSTR,KINDX,NN)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    W3CNVXTOVS
C   PRGMMR: KEYSER           ORG: NP22       DATE: 2014-11-25
C
C ABSTRACT: CONVERTS AN RTOVS OR ATOVS REPORT ORIGINALLY IN UNPACKED
C   NMCEDS FORMAT TO UNPACKED IW3UNPBF FORMAT (AS DESCRIBED IN ROUTINE
C   IW3UNPBF).  THE UNPACKED NMCEDS FORMAT IS FILLED ONLY WITH THOSE
C   VALUES NEEDED FOR RTOVS OR ATOVS PROCESSING BY THE PREPDATA
C   PROGRAM.
C
C PROGRAM HISTORY LOG:
C 1998-02-17  D. A. KEYSER -- ORIGINAL AUTHOR (ADAPTED FROM W3LIB
C        ROUTINE W3FI43).
C 1998-06-15  D. A. KEYSER -- ADAPTED FOR USE ONLY WITH RTOVS DATA
C        (AFTER TOVS DEMISE) (I.E., NO PARTLY-CLOUDY PATH AVAILABLE,
C        ONLY ESSENTIAL DATA IN UNPACKED NMCEDS FORMAT); WRITES OUT
C        ONLY CATEGORY 1 IW3UNPBF DATA SINCE THIS IS ALL THAT IS
C        PROCESSED IN PREPDATA; OTHERWISE STREAMLINED
C 1998-09-21  D .A. KEYSER -- SUBROUTINE NOW Y2K AND FORTRAN 90
C        COMPLIANT
C 1999-11-19  D. A. KEYSER -- INCLUDES NOAA-15 ATOVS DATA (AS WELL AS
C        RTOVS DATA); RENAMED SUBROUTINE
C 2001-10-29  D. A. KEYSER -- RETURNS SATELLITE ID AS DEFINED IN
C        BUFR CODE TABLE 0-01-007 IN WORD 6 OF UNPACKED IW3UNPBF
C        FORMAT (INTEGER)
C 2004-09-09  D. A. KEYSER -- MODIFIED INDEXING FOR UNPACKED IW3UNPBF
C        FORMAT TO COMPLY WITH CHANGES MADE IN ROUTINES IW3UNPBF AND
C        W3UNPKB7; ALLOW OUTPUT ARGUMENT IFLDUN TO HAVE ADJUSTABLE
C        DIMENSION BASED ON WHATEVER IS PASSED IN FROM CALLING PROGRAM
C        (BEFORE WAS ONLY 273 WORDS WHICH DIDN'T MATCH 2500-WORDS IN
C        prepdata.f - LUCKY MEMORY WASN'T CLOBBERED)
C 2012-11-30  J. WOOLLEN  INITIAL PORT TO WCOSS 
C 2013-02-14  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS
C 2014-11-25  D. A. KEYSER -- NOW OBTAINS THE BUFR SATELLITE ID (FOR
C        STORING INTO WORD 6 OF OUTPUT ARRAY "IDATA") DIRECTLY FROM
C        VALUE NOW STORED IN WORD 2 OF INPUT ARRAY "IBUFTN" (VIA A
C        CORRESPONDING CHANGE TO SUBROUTINE W3XTOVSEDS) RATHER THAN
C        CALCULATING IT FROM THE LOCAL/NESDIS SATELLITE ID STORED IN
C        WORD 1 OF "IBUFTN" (REMOVES CONVOLUTED LOGIC BASED ON CENTRAL
C        DATE YEAR SINCE, UNLIKE THE BUFR SATELLITE ID, THE LOCAL/
C        NESDIS SATELLITE ID IS NOT UNIQUE FOR EACH SATELLITE - ALSO
C        THIS SUBROUTINE WILL NEVER AGAIN HAVE TO BE UPDATED TO ACCOUNT
C        FOR NEW SATELLITES); REMOVED INPUT ARGUMENT "IDATE" (CENTRAL
C        DATE) SINCE YEAR  {IDATE(1)} IS NO LONGER NEEDED TO OBTAIN
C        BUFR SATELLITE ID.
C
C USAGE:    CALL W3CNVXTOVS(IBUFTN,IFLDUN,STNID,INSTR,KINDX,NN)
C   INPUT ARGUMENT LIST:
C     IBUFTN   - ADDRESS HOLDING A SINGLE RTOVS/ATOVS REPORT (140
C              - INTEGER WORDS) IN UNPACKED NMCEDS FORMAT (THE UNPACKED
C              - NMCEDS FORMAT IS FILLED ONLY WITH THOSE VALUES NEEDED
C              - FOR RTOVS/ATOVS PROCESSING BY THE PREPDATA PROGRAM)
C     INSTR    - INDICATOR FOR RETRIEVAL PATH (EITHER 1 FOR CLEAR OR
C              - 3 FOR CLOUDY)
C     KINDX    - INTEGER  1-5 DIGIT NUMBER USED TO GENERATE FIRST
C              - 5 CHARACTERS OF STATION ID (USUALLY JUST A REPORT
C              - COUNTER INDEX EXCEPT FIRST NUMBER MAY BE NADIR
C              - PROXIMITY INDICATOR -- SEE PREPDATA PROGRAM)
C     NN       - SWITCH TO INDICATE RTOVS (NN=1) OR ATOVS (NN=2)
C
C   OUTPUT ARGUMENT LIST:
C     IFLDUN   - INTEGER *-WORD ARRAY HOLDING A SINGLE RTOVS/ATOVS
C              - REPORT IN UNPACKED IW3UNPBF FORMAT (SEE ROUTINE
C              - IW3UNPBF) (NOTE: DOES NOT INCLUDE STATION ID)
C              - (MUST BE DIMENSIONED TO AT LEAST 283-WORDS BY
C              - CALLING PROGRAM, ONLY FIRST 283-WORDS ARE FILLED)
C     STNID    - CHARACTER*8 SINGLE REPORT STATION IDENTIFICATION (UP
C              - TO 8 CHARACTERS, LEFT-JUSTIFIED)
C
C
C REMARKS: MUST BE CALLED AFTER CALL TO W3FA07 WHICH FILLS IN VALUES
C          IN COMMON BLOCK /FA07AA/.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
 
      REAL  RDATA(283),PMAND(20)
 
      INTEGER  IDATA(283),IFLDUN(*),IBUFTN(140)
 
      CHARACTER*1  CSUFX(3,4),CSAT(2)
      CHARACTER*8  STNID
 
      COMMON/FA07AA/TM(20),Z(20),MLVLS
 
      EQUIVALENCE (IDATA,RDATA)
 
      SAVE
 
      DATA  CSUFX /'W','?','Y',    'E','?','G',
     $             'S','?','U',    'A','?','C'/
      DATA  CSAT  /'R','A'/
      DATA  XMISS/99999./,IMISS/99999/
      DATA  PMAND/10000.,8500.,7000.,5000.,4000.,3000.,2500.,2000.,
     $ 1500.,1000.,700.,500.,300.,200.,100.,70.,50.,30.,20.,10./
 

C  INITIALIZE ALL CATEGORY TYPES AND NUMBER OF LEVELS TO ZERO
 
      IDATA(13:52) = 0
 
C  ALLOWS 21 LEVELS FOR CAT. 1 - THIS IS THE ONLY CATEGORY THAT IS
C   PROCESSED  (SET ALL WORDS IN CAT. 1 TO MISSING)
 
      RDATA(53:283) = XMISS
 
C  SET Q.M.'S TO 2 FOR CATEGORY 1 (DEFAULT)
 
      RDATA(59:279:11) = 2.0
      RDATA(60:280:11) = 2.0
      RDATA(61:281:11) = 2.0
      RDATA(62:282:11) = 2.0
      RDATA(63:283:11) = 2.0
 
C  FILL IN IW3UNPBF REPORT HEADER
 
      RDATA(1)  = IBUFTN(5)/100.
      RDATA(2)  = IBUFTN(6)/100.
      IF(IBUFTN(6).LT.0)  RDATA(2) = 360. + IBUFTN(6)/100.
      IF(RDATA(2).EQ.360.0)  RDATA(2) = 0.0
      RDATA(3)  = 0.
      IHR  = MOD(IBUFTN(3),256)
      IB4  = IBUFTN(4)/256
      XMIN = IB4/60.
      RDATA(4)  = IHR + XMIN
      IDATA(5)  = IMISS
      IDATA(6)  = IBUFTN(2)
      RDATA(7)  = IBUFTN(8)
      IDATA(8)  = IMISS
      IDATA(9)  = 61
      RDATA(10) = 0.
      RDATA(11) = XMISS
      IDATA(12) = IMISS
 
C  STN. ID: POS. 1-5 FROM 'KINDX', POS. 6 FROM CHAR. BASED ON SATELLITE
C   NUMBER & RETRIEVAL PATH, POS. 7 INDICATES RTOVS ("R") OR ATOVS ("A")
 
C       POSITION 6 CHARACTER POSSIBILITIES ARE:
C            ODD  SATELLITE NUMBERS 3, 7, 11, 15, ETC.:  A, C
C            ODD  SATELLITE NUMBERS 1, 5,  9, 13, ETC.:  E, G
C            EVEN SATELLITE NUMBERS 2, 6, 10, 14, ETC.:  S, U
C            EVEN SATELLITE NUMBERS 4, 8, 12, 16, ETC.:  W, Y
C    WHERE: CHARACTERS  A, E, S, W  ARE FOR CLEAR PATH (DEFAULT)
C           CHARACTERS  C, G, U, Y  ARE FOR CLOUDY (MICROWAVE) PATH
 
      MODSAT = MOD(IBUFTN(1),4) + 1
 
C  STATION IDENTIFICATION IN "STNID" (8 CHARACTERS)
 
      WRITE(STNID,1)  KINDX,CSUFX(INSTR,MODSAT),CSAT(NN)
    1 FORMAT(I5.5,A1,A1,' ')
 
C  FILL IN IW3UNPBF CATEGORY 1 (MANDATORY LEVEL DATA)
 
      IDATA(13) = MLVLS + 1
      IDATA(14) = 53
      K = 53
 
      DO I = 1,MLVLS
         IF(I.EQ.2)  THEN
            RDATA(K) = 9250.
            K = K + 11
         END IF
         RDATA(K) = PMAND(I)
         RDATA(K+1) = Z(I) + 0.5
         IF(TM(I).LT.10273.)  RDATA(K+2) = (TM(I) - 273.16) * 10.
         K = K + 11
      ENDDO
 
C  COPY IW3UNPBF FIELD (IDATA) TO IFLDUN FOR TRANSFER OUT OF SUBROUTINE
 
      IFLDUN(1:283) = IDATA
 
      RETURN
      END

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      PROGRAM DUPREP
 
      PARAMETER (MXTS=6,MXTB=1500000)
 
      COMMON /QUIET/ IPRT
 
      CHARACTER*255 FILI,FILO
      CHARACTER*80  TSTR,RSTR
      CHARACTER*8   CTAB(MXTS,MXTB),SUBSET
      REAL(8)       ADATE,BDATE,BMISS
      REAL(8)       TAB_8(MXTS,MXTB),RAB_8(MXTS,MXTB)
      DIMENSION     JDUP(MXTB)
      DIMENSION     NDUP(0:4),IWORK(MXTB),IORD(MXTB)
      EQUIVALENCE   (TAB_8(1,1),CTAB(1,1))
      LOGICAL       DUPES
 
      DATA TSTR  /'YOB  XOB  DHR  ELV  TYP      '/
      DATA ADATE /00000000.00/
      DATA BDATE /99999999.00/
      DATA BMISS /10E10/
      DATA LUBFI /20/
      DATA LUBFJ /50/
      DATA DEXY  /0/
      DATA DOUR  /0/
      DATA DELV  /0/
      DATA ISUB  /0/
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
 
      bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

C  READ I/O FILENAMES AND ANY OVERRIDE VALUES FOR THINNING PARAMETERS
C  ------------------------------------------------------------------
C     DEFAULT PARAMETERS:
C     DEXY = 0.0  TOLERANCE FOR LAT/LON CHECKS
C     DOUR = 0.0  TOLERANCE FOR HOUR CHECK
C     DELV = 0.0  TOLERANCE FOR ELEVATION CHECK
C  ------------------------------------------------------------------
 
      READ(5,'(A)',END=900,ERR=900) FILI
      READ(5,'(A)',END=900,ERR=900) FILO
      READ(5,*,END=1) DEXY,DOUR,DELV
    1 CONTINUE
 
      PRINT *,'REQUESTED EARLIEST DATE IS ... ',ADATE
      PRINT *,'REQUESTED LATEST   DATE IS ... ',BDATE
      PRINT *
      PRINT *,'UNCHECKED AND UNCORRECTED INPUT FILE IS'
      PRINT *,'     ',TRIM(FILI)   
      PRINT *,'DUPLICATE CHECKED AND CORRECTED OUTPUT FILE IS'
      PRINT *,'     ',TRIM(FILO)  
      PRINT *
      PRINT *,'DUPCOR PARAMETERS:'
      PRINT *,'TOLERANCE FOR LAT/LON CHECKS (IN DEGREES) .. ',DEXY
      PRINT *,'TOLERANCE FOR HOUR CHECK (IN HOURS) ........ ',DOUR
      PRINT *,'TOLERANCE FOR ELEVATION  (IN METERS) ....... ',DELV
      PRINT *
 
C  MAKE A TABLE OUT OF THE LATS, LONS, AND TIME COORDINATES
C  --------------------------------------------------------
 
      OPEN(LUBFI,FILE=FILI,FORM='UNFORMATTED')
      CALL UFBMEM(LUBFI,0,IRET,IUNIT)
 
C  READ THE INFORMATION FOR DUP CHECKING AND THINNING
C  --------------------------------------------------
 
      CALL UFBTAM(TAB_8,MXTS,MXTB,NTAB,TSTR)
 
C  INITIAL VALUES FOR MARKERS AND COUNTERS AND CORRECTION INDICATORS
C  -----------------------------------------------------------------
 
      JDUP = 0
      NDUP = 0
 
C  GET A SORTED INDEX OF THE REPORTS BY RECEIPT, OB TIME, AND LON/LAT
C  ------------------------------------------------------------------
 
      CALL ORDERS( 2,IWORK,TAB_8(5,1),IORD,NTAB,MXTS,8,2)
      CALL ORDERS(12,IWORK,TAB_8(4,1),IORD,NTAB,MXTS,8,2)
      CALL ORDERS(12,IWORK,TAB_8(3,1),IORD,NTAB,MXTS,8,2)
      CALL ORDERS(12,IWORK,TAB_8(2,1),IORD,NTAB,MXTS,8,2)
      CALL ORDERS(12,IWORK,TAB_8(1,1),IORD,NTAB,MXTS,8,2)
 
C  GO THROUGH THE REPORTS IN ORDER, MARKING DUPLICATES AND CORRECTIONS
C  -------------------------------------------------------------------
 
      DO 2 K=1,NTAB-1
      I = IORD(K)
      DO KK=K+1,MIN(K+200,NTAB)
      J = IORD(KK)
      IF(NINT(ABS(TAB_8(1,I)-TAB_8(1,J))*100.).LT.NINT(DEXY*100.)) THEN
        DUPES = NINT(ABS(TAB_8(1,I)-TAB_8(1,J))*100.).LE.NINT(DEXY*100.)
     . .AND.    NINT(ABS(TAB_8(2,I)-TAB_8(2,J))*100.).LE.NINT(DEXY*100.)
     . .AND.    NINT(ABS(TAB_8(3,I)-TAB_8(3,J))*100.).LE.NINT(DOUR*100.)
     . .AND.    NINT(ABS(TAB_8(4,I)-TAB_8(4,J))*100.).LE.NINT(DELV*100.)
     . .AND.    NINT(ABS(TAB_8(5,I)-TAB_8(5,J))*100.).LE.0000
        !IF(DUPES) print'(5f10.2)',(tab_8(l,i),l=1,5)
        !IF(DUPES) print'(5f10.2)',(tab_8(l,j),l=1,5)
        !IF(DUPES) print*
        IF(DUPES) JDUP(I) = 2
        IF(DUPES) GOTO 2
      ENDIF
      ENDDO
2     ENDDO
 
C  WRITE A DUP-CHECKED FILE
C  ------------------------
 
      CALL CLOSBF(LUBFJ)
      OPEN(LUBFJ,FILE=FILO,FORM='UNFORMATTED')
      CALL OPENBF(LUBFJ,'OUT',LUBFI)
      call maxout(20000)
      IREC = 1
 
      DO WHILE(IREADMM(IREC,SUBSET,IDATE).EQ.0)
      NSUBS = NMSUB(LUBFI)
      DUPES = .FALSE.
 
      DO N=1,NSUBS
      IDUP = JDUP(ISUB+N)
      IF(IDUP.GT.1) DUPES = .TRUE.
      ENDDO
      IF(.NOT.DUPES) THEN
         DO N=1,NSUBS
         IDUP = JDUP(ISUB+N)
         NDUP(IDUP) = NDUP(IDUP)+1
         ENDDO
      ENDIF
 
      IF(DUPES) THEN
         CALL OPENMB(LUBFJ,SUBSET,IDATE)
         DO WHILE(IFBGET(LUBFI).EQ.0)
         ISUB = ISUB+1
         IDUP = JDUP(ISUB)
         IF(IDUP.LE.1) THEN
            CALL COPYSB(LUBFI,LUBFJ,IRET)
            NDUP(IDUP) = NDUP(IDUP)+1
         ELSE
            !print'(5f10.2)',(tab_8(i,isub),i=1,5)
            CALL COPYSB(LUBFI,00000,IRET)
            NDUP(IDUP) = NDUP(IDUP)+1
         ENDIF
         ENDDO
      ELSE
         CALL CLOSMG(LUBFJ)
         CALL COPYMG(LUBFI,LUBFJ)
         ISUB = ISUB+NSUBS
      ENDIF
 
      ENDDO
 
      CALL CLOSBF(LUBFI)
      CALL CLOSBF(LUBFJ)
 
C  GENERATE REPORT
C  ---------------
 
  100 CONTINUE
      PRINT *,'UNIQUE    REPORTS= ',NDUP(0)
      PRINT *,'CORRECTED REPORTS= ',NDUP(1)
      PRINT *,'DUPLICATE REMOVED= ',NDUP(2)
      PRINT *,'DUPLICATE NOT RMV= ',NDUP(3)
      PRINT *,'UNWINDOWD REPORTS= ',NDUP(4)
      PRINT *
      PRINT *,'DUPCOR PROCESSED ',NTAB,' REPORTS '
      PRINT *
 
      STOP
 
C  ERROR EXITS
C  -----------
 
  900 CONTINUE
      CALL BORT('DUPUPA - EOF ON NAMELIST   ')
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: GLOBAL_POSTEVENTS
C   PRGMMR: DONG             ORG: NP22        DATE: 2020-08-20
C
C ABSTRACT: INTERPOLATES GLOBAL SPECTRAL SIMGA ANALYSIS TO PREPBUFR
C   OBSERVATION LOCATIONS, ENCODES THEM INTO PREPBUFR REPORTS AND
C   WRITES OUT A FINAL POSTPROCESSED VERSION OF THE PREPBUFR FILE.
C   THE BULK OF THE WORK IS DONE BY THE W3LIB ROUTINE "GBLEVENTS"
C   WHICH RUNS HERE IN A "POSTEVENTS" MODE.
C
C PROGRAM HISTORY LOG:
C 1999-07-02  D. A. KEYSER -- ORIGINAL AUTHOR
C 1999-09-26  D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE
C 2001-10-10  D. A. KEYSER -- MODIFIED TO NOW PASS TWO SPANNING
C             GLOBAL SIGMA ANALYSIS FILES INTO W3LIB ROUTINE
C             GBLEVENTS IN SITUATIONS WHERE THE CENTER DATE FOR THE
C             PREPBUFR FILE HAS AN HOUR THAT IS NOT A MULTIPLE OF 3
C             (SEE 2001-10-10 CHANGES TO GBLEVENTS)
C 2013-03-13  D. A. KEYSER -- CHANGES TO RUN ON WCOSS: SET BUFRLIB
C             MISSING (BMISS) TO 10E8 RATHER THAN 10E10 TO AVOID
C             INTEGER OVERFLOW; USE FORMATTED PRINT STATEMENTS WHERE
C             PREVIOUSLY UNFORMATTED PRINT WAS > 80 CHARACTERS
C 2020-08-20  J. DONG -- MODIFIED PIVOT YEAR FROM 20 TO 40 TO
C             HANDLE 2-DIGIT YEARS THAT DO NOT DESIGNATE 19 OR 20
C             FOR CENTURY.
C
C USAGE:
C   INPUT FILES:
C     UNIT 11  - PREPBUFR FILE
C     UNIT 12  - FIRST INPUT SPECTRAL (GLOBAL) SIGMA ANALYSIS FILE; IF
C              - HOUR IN CENTER DATE FOR PREPBUFR FILE IS A MULTIPLE
C              - OF 3 THEN THIS FILE IS VALID AT THE CENTER DATE OF THE
C              - PREPBUFR FILE, IF THE HOUR IN CENTER DATE FOR PREPBUFR
C              - FILE IS NOT A MULTIPLE OF 3 THEN THIS FILE IS VALID AT
C              - THE CLOSEST TIME PRIOR TO THE CENTER DATE OF THE
C              - PREPBUFR FILE THAT IS A MULTIPLE OF 3
C     UNIT 13  - SECOND INPUT SPECTRAL (GLOBAL) SIGMA ANALYSIS FILE; IF
C              - HOUR IN CENTER DATE FOR PREPBUFR FILE IS A MULTIPLE
C              - OF 3 THEN THIS FILE IS EMPTY, IF THE HOUR IN CENTER
C              - DATE FOR PREPBUFR FILE IS NOT A MULTIPLE OF 3 THEN
C              - THIS FILE IS VALID AT THE CLOSEST TIME AFTER THE
C              - CENTER DATE OF THE PREPBUFR FILE THAT IS A MULTIPLE OF
C              - 3
C     UNIT 15  - EXPECTED CENTER DATE IN PREPBUFR FILE IN FORM
C                YYYYMMDDHH
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - PREPBUFR FILE (NOW CONTAINING ANALYZED VALUES)
C
C   SUBPROGRAMS CALLED:
C       W3NCO    - W3TAGB    W3TAGE    ERREXIT
C       W3EMC    - GBLEVENTS
C       BUFRLIB  - DATELEN   OPENBF    READMG    OPENMB
C                - WRITSB    CLOSBF    SETBMISS  GETBMISS
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C     COND =  21 - DATE DISAGREEMENT BETWEEN ACTUAL CENTER DATE IN
C                  PREPBUFR FILE AND EXPECTED CENTER DATE READ IN
C                  FROM UNIT 15
C     COND =  22 - BAD OR MISSING DATE READ IN FROM UNIT 15
C     COND =  60-79 - RESERVED FOR W3LIB ROUTINE GBLEVENTS (SEE
C                      GBLEVENTS DOCBLOCK)
C
C
C REMARKS: NONE.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      PROGRAM GLOBAL_POSTEVENTS

      REAL(8)   BMISS,GETBMISS

      DIMENSION IUNITA(2)

      CHARACTER*8  SUBSET,LAST

      DATA  LAST/'XXXXXXXX'/

      CALL W3TAGB('GLOBAL_POSTEVENTS',2020,0233,0061,'NP22')

      PRINT 700
  700 FORMAT(/'  =====> WELCOME TO POSTEVENTS PROGRAM -- LAST UPDATED ',
     $ '2020-08-20'/)

C  On WCOSS should always set BUFRLIB missing (BMISS) to 10E8 to avoid
C   overflow when either an INTEGER*4 variable is set to BMISS or a
C   REAL*8 (or REAL*4) variable that is missing is NINT'd
C  -------------------------------------------------------------------
ccccc CALL SETBMISS(10E10_8)
      CALL SETBMISS(10E8_8)
      BMISS=GETBMISS()
      print *
      print *, 'BUFRLIB value for missing is: ',bmiss
      print *

      IUNITI    = 11
      IUNITA(1) = 12
      IUNITA(2) = 13
      IUNITD    = 15
      IUNITP    = 51

C  OPEN INPUT PREPBUFR FILE JUST TO GET MESSAGE DATE (WHICH IS THE
C   ACTUAL CENTER DATE), LATER CLOSE FILE
C  ---------------------------------------------------------------

      CALL DATELEN(10)

      CALL OPENBF(IUNITI,'IN',IUNITI)
      CALL READMG(IUNITI,SUBSET,IDATEP,IRET)

      PRINT 53, IDATEP
   53 FORMAT(/' --> ACTUAL   CENTER DATE OF PREPBUFR FILE READ FROM ',
     $ ' SEC. 1 MESSAGE DATE IS:',I11/)

      IF(IDATEP.LT.1000000000)  THEN

C If 2-digit year returned in IDATEP, must use "windowing" technique
C  to create a 4-digit year

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

         PRINT *, '##> THE FOLLOWING SHOULD NEVER HAPPEN!!!!!'
         PRINT'(" ##> 2-DIGIT YEAR IN IDATEP RETURNED FROM READMG ",
     $    "(IDATEP IS: ",I0,") - USE WINDOWING TECHNIQUE TO OBTAIN ",
     $    "4-DIGIT YEAR")', IDATEP
C IF IDATEP=41~99 THEN IDATEP=1941~1999
C IF IDATEP=00~40 THEN IDATEP=2000~2040
         IF(IDATEP/1000000.GT.40)  THEN
            IDATEP = 1900000000 + IDATEP
         ELSE
            IDATEP = 2000000000 + IDATEP
         ENDIF
         PRINT *, '##> CORRECTED IDATEP WITH 4-DIGIT YEAR, IDATEP NOW',
     $    ' IS: ',IDATEP
      ENDIF

C  READ IN EXPECTED CENTER DATE OF PREPBUFR FILE
C  ---------------------------------------------

      REWIND IUNITD
      READ(IUNITD,'(6X,I10)',END=904,ERR=904)  IDATED
      PRINT 3, IUNITD, IDATED
    3 FORMAT(/' --> EXPECTED CENTER DATE OF PREPBUFR FILE READ FROM ',
     $ 'UNIT',I3,' IS:',13X,I11/)

C  CHECK ACTUAL CENTER DATE OF PREPBUFR FILE VS. EXPECTED CENTER DATE
C  ------------------------------------------------------------------

      IF(IDATEP.NE.IDATED)  GO TO 901

      CALL CLOSBF(IUNITI)

C  OPEN INPUT AND OUTPUT PREPBUFR FILES FOR DATA PROCESSING
C  --------------------------------------------------------

      CALL OPENBF(IUNITI,'IN ',IUNITI)
      CALL OPENBF(IUNITP,'OUT',IUNITI)

C----------------------------------------------------------------------
C----------------------------------------------------------------------
      NEWTYP = 0

C  LOOP THROUGH THE INPUT MESSAGES
C  -------------------------------

      DO WHILE(IREADMG(IUNITI,SUBSET,JDATEP).EQ.0)
         IF(SUBSET.NE.LAST)  THEN
            NEWTYP = 1
cppppp
            print *, 'New input message type read in: ',SUBSET
cppppp
         END IF

         CALL OPENMB(IUNITP,SUBSET,JDATEP)
         DO WHILE(IREADSB(IUNITI).EQ.0)

C  COPY DECODED REPORT FROM INPUT PREPBUFR FILE TO OUTPUT PREPBUFR FILE
C  --------------------------------------------------------------------

            CALL UFBCPY(IUNITI,IUNITP)

C  CALL W3LIB ROUTINE GBLEVENTS TO ENCODE ANALYZED VALUES FOR THIS RPT
C  -------------------------------------------------------------------

            CALL GBLEVENTS(IDATED,IUNITA,0,IUNITP,0,SUBSET,NEWTYP)

C  WRITE THIS REPORT (SUBSET) INTO BUFR MESSAGE IN OUTPUT PREPBUFR FILE
C  --------------------------------------------------------------------

            CALL WRITSB(IUNITP)

            NEWTYP = 0

         ENDDO

         LAST = SUBSET

      ENDDO

C  CLOSE THE BUFR FILES
C  --------------------

      CALL CLOSBF(IUNITI)
      CALL CLOSBF(IUNITP)

C  ALL DONE
C  --------

      CALL W3TAGE('GLOBAL_POSTEVENTS')

      STOP
C-----------------------------------------------------------------------

  901 CONTINUE
      PRINT 9901, IDATEP,IDATED
 9901 FORMAT(/' ##> ACTUAL CENTER DATE OF INPUT PREPBUFR FILE (',I10,
     $ ') DOES NOT MATCH EXPECTED CENTER DATE (',I10,') - STOP 21'/)
      CALL W3TAGE('GLOBAL_POSTEVENTS')
      CALL ERREXIT(21)

C-----------------------------------------------------------------------

  904 CONTINUE
      PRINT 9902, IUNITD
 9902 FORMAT(/' ##> BAD OR MISSING EXPECTED PREPBUFR CENTER DATE ',
     $ 'READ FROM UNIT',I3,' - STOP 22'/)
      CALL W3TAGE('GLOBAL_POSTEVENTS')
      CALL ERREXIT(22)

C-----------------------------------------------------------------------

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GBLEVN08    CALCULATE SPEC. HUMIDITY AND VIRTUAL TEMP
C   PRGMMR: D.A. KEYSER      ORG: NP22       DATE: 2007-09-14
C
C ABSTRACT: CREATE VIRTUAL TEMPERATURE EVENTS WITHIN GBLEVENTS
C   SUBROUTINE.  FOR ALL TYPES EXCEPT RASS, THIS CONSISTS OF FIRST RE-
C   CALCULATING THE SPECIFIC HUMIDITY FROM THE REPORTED DEWPOINT
C   TEMPERATURE AND PRESSURE, FOLLOWED BY THE CALCULATION OF VIRTUAL
C   TEMPERATURE FROM THE JUST-CALCULATED SPECIFIC HUMIDITY AND THE
C   REPORTED (SENSIBLE) TEMPERATURE.  THE RE-CALCULATED SPECIFIC
C   HUMIDITY IS THEN ENCODED AS A STACKED EVENT TO BE LATER WRITTEN
C   INTO THE PREPBUFR FILE (UNDER PROGRAM "VIRTMP", REASON CODE 0).
C   IF THE NAMELIST SWITCH DOVTMP IS TRUE, THEN THE JUST-CALCULATED
C   VIRTUAL TEMPERATURE IS THEN ALSO ENCODED AS A STACKED EVENT TO BE
C   LATER WRITTEN INTO THE PREPBUFR FILE (UNDER PROGRAM "VIRTMP",
C   REASON CODE 0, 2 OR 6).  FOR RASS DATA, SPECIFIC HUMIDITY IS
C   MISSING HOWEVER IF THE NAMELIST SWITCH DOVTMP IS TRUE, A SIMPLE
C   COPY OF THE REPORTED (VIRTUAL) TEMPERATURE IS ENCODED AS A STACKED
C   EVENT TO BE LATER WRITTEN INTO THE PREPBUFR FILE (UNDER PROGRAM
C   "VIRTMP", REASON CODE 3).  THIS SUBROUTINE IS CURRENTLY ONLY
C   CALLED FOR SURFACE LAND ("ADPSFC"), MARINE ("SFCSHP"), MESONET
C   ("MSONET"), RASS ("RASSDA") OR SATELLITE TEMPERATURE RETRIEVAL
C   ("SATEMP") DATA TYPES WHEN SWITCH "ADPUPA_VIRT" IS FALSE AND ONLY
C   FOR SURFACE LAND ("ADPSFC"), MARINE ("SFCSHP"), MESONET ("MSONET"),
C   RASS ("RASSDA"), SATELLITE TEMPERATURE RETRIEVAL ("SATEMP") OR
C   RAOB/DROP/MULTI-LVL RECCO ("ADPUPA") DATA TYPES WHEN SWITCH
C   "ADPUPA_VIRT" IS TRUE.  IT IS ALSO ONLY CALLED IN THE PREVENTS
C   MODE.  THIS ROUTINE IS CALLED ONCE FOR EACH VALID REPORT IN THE
C   PREPBUFR FILE.
C
C PROGRAM HISTORY LOG:
C 1995-05-17  J. WOOLLEN (NP20) - ORIGINAL AUTHOR
C 1997-06-01  D.A. KEYSER - STREAMLINED, ADDED SWITCH DOVTMP
C 1999-12-01 D. A. KEYSER -- SPEC. HUMIDITY AND VIRT. TEMPERATURE ARE
C     NOW CALCULATED WHEN SPEC. HUMIDITY QUAL. MARKER IS BAD (SUBJECT
C     TO A SANITY CHECK), HOWEVER THE VIRT. TEMPERATURE GETS A BAD
C     QUAL. MARKER (8)
C 2004-08-30 D. A. KEYSER -- FOR "RASSDA" TYPES, ENCODES A SIMPLE COPY
C     OF THE REPORTED (VIRTUAL) TEMPERATURE AS A "VIRTMP" EVENT IF
C     DOVTMP IS TRUE, GETS NEW REASON CODE 3
C 2006-07-14 D. A. KEYSER --  PROCESSES REPORTS IN MESSAGE TYPE ADPUPA
C     (I.E., RAOBS, DROPS, MULTI-LEVEL RECCOS) WITH SAME LOGIC AS IN
C     SUBROUTINE VTPEVN OF PROGRAM PREPOBS_CQCBUFR WHEN NEW NAMELIST
C     SWITCH "ADPUPA_VIRT" IS TRUE {NORMALLY "ADPUPA_VIRT" IS FALSE
C     (DEFAULT) BECAUSE SUBSEQUENT PROGRAM PREPOBS_CQCBUFR PERFORMS
C     THIS FUNCTION}
C 2007-09-14 D. A. KEYSER -- FOR NON-"ADPUPA" TYPES, Q.M. 9 IS NOW
C     ASSIGNED TO CALCULATED VIRT. TEMPS IF THE MOISTURE Q.M. IS 9 OR
C     15 AND ORIG. TEMP NOT "BAD", THESE "VIRTMP" EVENTS RECEIVE NEW
C     REASON CODE 4, HAD RECEIVED Q.M. 8 WITH REASON CODE 2 LIKE VIRT.
C     TEMPS CALCULATED FROM "BAD" MOISTURE - THIS MEANS ONLY TRULY
C     "BAD" VIRT. TEMPS WILL NOW GET Q.M. 8 AND VIRT. TEMPS FLAGGED FOR
C     NON-USE BY ASSIMILATION (BUT STILL "GOOD") WILL NOW GET Q.M. 9
C     (GSI MONITORS, BUT DOES NOT USE, OBS WITH Q.M. 9, BUT IT DOES NOT
C     EVEN CONSIDER OBS WITH Q.M. 8); FOR "ADPUPA" TYPES, Q.M. 3 IS NOW
C     ASSIGNED TO CALCULATED VIRT. TEMPS ONLY IF THE MOISTURE Q.M. IS
C     TRULY BAD (I.E. > 3 BUT NOT 9 OR 15) (AND, AS BEFORE, ORIG. TQM
C     IS 1 OR 2 AND POB IS BELOW 700 MB) - BEFORE, TQM SET TO 3 WHEN
C     QQM WAS 9 OR 15 AND ALL OTHER CONDITIONS MET; FOR "SATEMP" TYPES,
C     ENCODES A SIMPLE COPY OF THE REPORTED (VIRTUAL) TEMPERATURE AS A
C     "VIRTMP" EVENT IF DOVTMP IS TRUE, GETS REASON CODE 3 (SIMILAR TO
C     WHAT IS ALREADY DONE FOR "RASSDA" TYPES)
C
C USAGE:    CALL GBLEVN08(IUNITP)
C   INPUT ARGUMENT LIST:
C     IUNITP   - BUFR OUTPUT FILE UNIT
C     SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C              - REPORT BEING PROCESSED
C
C REMARKS: WILL IMMEDIATELY RETURN TO CALLING PROGRAM IF ANY OF THE
C   FOLLOWING CONDITIONS EXIST: THERE ARE NO LEVELS OF VALID DEWPOINT,
C   OBS, TEMPERATURE Q.M. OR SPEC. HUMIDITY Q.M. IN THE INPUT PREPBUFR
C   FILE FOR THE REPORT.  WILL NOT ATTEMPT EITHER SPEC. HUMIDITY NOR
C   VIRT. TEMP CALC. ON A GIVEN LEVEL IF ANY OF THE FOLLOWING
C   CONDITIONS EXIST: REPORTED PRESSURE OBS IS MISSING, REPORTED
C   (SENSIBLE) TEMPERATURE OBS IS MISSING, OR REPORTED DEWPOINT OBS IS
C   MISSING.
C 
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM-SP
C
C$$$
      SUBROUTINE GBLEVN08(IUNITP,SUBSET) ! FORMERLY SUBROUTINE VTPEVN

      CHARACTER*80 EVNSTQ,EVNSTV
      CHARACTER*8  SUBSET
      REAL(8)      TDP(255),TQM(255),QQM(255),BAKQ(4,255),BAKV(4,255),
     $             OBS,QMS,BAK,SID,BMISS

      LOGICAL      EVNQ,EVNV,DOVTMP,TROP,ADPUPA_VIRT,DOBERR,DOFCST,
     $             SOME_FCST

      COMMON /GBEVAA/ SID,OBS(15,255),QMS(12,255),BAK(12,255),XOB,
     $ YOB,DHR,TYP,NLEV
      COMMON /GBEVBB/ IPVCD,IVTCD
      COMMON /GBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT

      DATA EVNSTQ /'QOB QQM QPC QRC'/
      DATA EVNSTV /'TOB TQM TPC TRC'/
      DATA BMISS /10E10/

C-----------------------------------------------------------------------
C FCNS BELOW CONVERT TEMP/TD (K) & PRESS (MB) INTO SAT./ SPEC. HUM.(G/G)
C-----------------------------------------------------------------------
      ES(T) = 6.1078*EXP((17.269*(T - 273.16))/((T - 273.16)+237.3))
      QS(T,P) = (0.622*ES(T))/(P-(0.378*ES(T)))
C-----------------------------------------------------------------------

C  CLEAR TEMPERATURE AND SPECIFIC HUMIDITY EVENTS
C  ----------------------------------------------

      EVNQ = .FALSE.
      EVNV = .FALSE.
      BAKQ = BMISS
      BAKV = BMISS
      TROP = .FALSE.

C  GET DEWPOINT TEMPERATURE AND CURRENT T,Q QUALITY MARKERS
C  --------------------------------------------------------

      CALL UFBINT(-IUNITP,TDP,1,255,NLTD,'TDO')
      CALL UFBINT(-IUNITP,QQM,1,255,NLQQ,'QQM')
      CALL UFBINT(-IUNITP,TQM,1,255,NLTQ,'TQM')
      IF(SUBSET.NE.'RASSDA  '.AND.SUBSET.NE.'SATEMP  ') THEN
         IF(NLTD.EQ.0) RETURN
         IF(NLQQ.EQ.0) RETURN
      ENDIF
      IF(NLTQ.EQ.0) RETURN
      IF(SUBSET.NE.'RASSDA  '.AND.SUBSET.NE.'SATEMP  ') THEN
         IF(NLTD.NE.NLEV) THEN
            PRINT *, '##GBLEVENTS/GBLEVN08 - NLTD .NE. NLEV - STOP 61'
            CALL ERREXIT(61)
         ENDIF
         IF(NLQQ.NE.NLEV) THEN
            PRINT *, '##GBLEVENTS/GBLEVN08 - NLQQ .NE. NLEV - STOP 63'
            CALL ERREXIT(63)
         ENDIF
      ENDIF
      IF(NLTQ.NE.NLEV) THEN
         PRINT *, '##GBLEVENTS/GBLEVN08 - NLTQ .NE. NLEV - STOP 62'
         CALL ERREXIT(62)
      ENDIF

C  COMPUTE VIRTUAL TEMPERATURE AND SPECIFIC HUMIDITY USING REPORTED DEWP
C  ---------------------------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV
         POB = OBS(1,L)
         TDO = TDP(L)
         TOB = OBS(3,L)
         CAT = OBS(12,L)
         IF(DOVTMP) THEN
            IF(SUBSET.EQ.'RASSDA  '.OR.SUBSET.EQ.'SATEMP  ') THEN
               IF(TOB.LT.BMISS) THEN
                  BAKV(1,L) = TOB
                  BAKV(2,L) = TQM(L)
                  BAKV(3,L) = IVTCD
                  BAKV(4,L) = 3
                  EVNV = .TRUE.
                  CYCLE
               ENDIF
            ENDIF
         ENDIF
         IF(POB.LT.BMISS .AND. TOB.LT.BMISS
     $                   .AND. TDO.LT.BMISS) THEN
            IF(QQM(L).GT.3) THEN
C  Don't update q or calculate Tv if bad moisture obs fails sanity check
cdak           IF(TDO.LT.-103.15 .OR. TDO.GT.46.83 .OR. POB.LT.0.1 .OR.
cdak $          POB.GT.1100.)
cdak $ print *, '&&& bad QM fails sanity check'
               IF(TDO.LT.-103.15 .OR. TDO.GT.46.83 .OR. POB.LT.0.1 .OR.
     $          POB.GT.1100.)  CYCLE
            ENDIF
            QOB = QS(TDO+273.16,POB)
            BAKQ(1,L) = QOB*1E6
            BAKQ(2,L) = QQM(L)  ! Moist qm same as before for re-calc. q
            BAKQ(3,L) = IVTCD
            BAKQ(4,L) = 0       ! Re-calc. q gets unique reason code 0
            EVNQ = .TRUE.
C  If message type ADPUPA, test this level to see if at or above trop
C   (trop must be above 500 mb to pass test; if no trop level found
C   assume it's at 80 mb)
C  Don't calculate Tv on this level if at or above trop (doesn't affect
C   q calculation)
            TROP = (SUBSET.EQ.'ADPUPA  ' .AND.
     $       ((CAT.EQ.5 .AND. POB.LT.500.) .OR. POB.LT. 80. .OR. TROP))
            IF(DOVTMP .AND. .NOT.TROP) THEN
               BAKV(1,L) = (TOB+273.16)*(1.+.61*QOB)-273.16
               BAKV(3,L) = IVTCD
               IF(SUBSET.EQ.'ADPUPA  ') THEN
C  Message type ADPUPA comes here
                  IF((QQM(L).LT.4.OR.QQM(L).EQ.9.OR.QQM(L).EQ.15)
     $             .OR. TQM(L).EQ.0 .OR. TQM(L).GT.3
     $             .OR. POB.LE.700.) THEN
                     BAKV(2,L) = TQM(L) ! Tv qm same as for T when q ok
                                        ! or q flagged by PREPRO (but
                                        ! not bad) 
                     BAKV(4,L) = 0      ! Tv gets unique reason code 0
                  ELSE
                     BAKV(2,L) = 3 !Tv qm susp for bad moist below 700mb
                     BAKV(4,L) = 6 !Tv gets unique reason code 6
                  ENDIF
               ELSE
C  All other message types come here
                  IF(QQM(L).LT.4) THEN
                     BAKV(2,L) = TQM(L) ! Tv qm same as for T when q ok
                     BAKV(4,L) = 0      ! Tv gets unique reason code 0
                  ELSE IF((QQM(L).EQ.9.OR.QQM(L).EQ.15).AND.(TQM(L).LE.
     $             3.OR.TQM(L).GE.15.OR.TQM(L).EQ.9)) THEN
cdak  print *, '%%% process tvirt on lvl ',l,' for missing moist obs ',
cdak $ 'error/high-up moist case when orig. T not "bad" (set TQM=9)'
                     BAKV(2,L) = 9 ! Tv qm 9 for moist w/ missing obs
                                   !  error or moist flagged by PREPRO
                                   !  (but not bad) and T qm orig not
                                   !  "bad"
                     BAKV(4,L) = 4 ! Tv gets unique reason code 4
                  ELSE
cdak  print *, '%%% process tvirt on lvl ',l,' for "bad" QQM case or ',
cdak $ 'missing moist obs error/high-up moist w/ "bad" TQM case (set ',
cdak $ 'TQM=8)
                     BAKV(2,L) = 8 ! Tv qm 8 (bad) for "bad" moist or
                                   !  moist w/ missing obs error or
                                   !  moist flagged by PREPRO (but not
                                   !  bad) and T qm orig "bad"
                     BAKV(4,L) = 2 ! Tv gets unique reason code 2
                  ENDIF
               ENDIF
               EVNV = .TRUE.
            ENDIF
         ENDIF
      ENDDO
      ENDIF

C  ENCODE EVENTS INTO REPORT
C  -------------------------

      IF(NLEV.GT.0)  THEN
         IF(EVNQ) CALL UFBINT(IUNITP,BAKQ,4,NLEV,IRET,EVNSTQ)
         IF(EVNV) CALL UFBINT(IUNITP,BAKV,4,NLEV,IRET,EVNSTV)
      ENDIF

      RETURN
      END

ccc  read out TC probability ccccccccccccccccccccccccccc
      program readprob
      parameter (nx=241, ny=40, nt=29)
      real xprob(nx,ny), xmax(nt)
      character*44 infile, outfile

      call read_nlists (infile,outfile)

      open (52,file=infile,
     &      form='unformatted', access='direct',recl=nx*ny*4)
      irec1=1

      do k=1,nt
        xmax(k)=0.0
      enddo

      do k=1,nt
        read(52,rec=irec1,err=101) ((xprob(i,j),i=1,nx),j=1,ny)
	irec1=irec1+1

	do i=1,nx
	do j=1,ny
          if(xprob(i,j).gt.xmax(k)) then
	    xmax(k)=xprob(i,j)
          endif
        enddo
	enddo
c       write(*,*) 'forecast hour=',(k-1)*6,'xmax(k)=',xmax(k)*100

      enddo
101   continue
      close(52)

c      open(51,file=outfile,
c     &      form='unformatted', access='direct',recl=nt*4)
c      write(51,rec=1) (xmax(k)*100, k=1,nt)
c      close(51)

c      open(53,file='tcgen.dat')
      open(53,file=outfile)

      xmean=0.0
      do k=1,9
	xmean=xmean+xmax(k)
      enddo
      xmean=xmean/9.0
      write(53,103) xmean*100
103   format(1x,f5.1,'% 48h-probability forecast')

      do k=1,nt
c       write(*,*) 'forecast hour=',(k-1)*6,'prob=',xmax(k)*100 
       write(53,102) (k-1)*6,xmax(k)*100
      enddo
      close(53)

102   format(1x,i5,1x,f5.1)
      stop
      end

c-----------------------------------------------------------------------
      subroutine read_nlists (infile,outfile)

c     ABSTRACT: This subroutine simply reads in the namelists that are
c     created in the shell script.
c   infile aemn.trkprob.AL95.65nm.2011062718.indiv.ieee
c   outfile aemn.trkprob.AL95.65nm.2011062718.indiv.data

      character*44 infile, outfile, kymdh0, kymdh1
      namelist/datain0/kymdh0
      namelist/datain1/kymdh1


      read (5,NML=datain0,END=88)
88    continue
      read (5,NML=datain1,END=99)
99    continue

      infile=kymdh0
      outfile=kymdh1

      return
      end

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: BUFR_PREPMODS
C   PRGMMR: WHITING          ORG: EMC         DATE: 2019-02-26
C
C ABSTRACT: GENERATES MODS (MARINE OCEAN DATA-HANDLING SYSTEM)
C   BUFR ARCHIVE FILES FROM INPUT DCOM-FORMATTED DATA DUMPS.  ONLY
C   SELECT INPUT MESSAGE TYPES DEEMED TO BE OF INTEREST TO MARINE
C   APPLICATIONS ARE CONSIDERED AS VALID.  
C
C PROGRAM HISTORY LOG:
C 2004-05-07  JWHITING    ORIGINAL VERSION FOR IMPLEMENTATION
C 2004-06-03  JWOOLLEN    UPDATED  VERSION FOR IMPLEMENTATION
C 2004-06-10  JWhiting    Changed OBNAME 001,002 to point to 
C                           DBUOYSUB rather than DBUOY.
C                         Added reports read/written output.
C 2004-06-22  JWhiting    Added report counting to SSMIPN subr.
C 2005-05-06  JWhiting    Added inline wrcmps() (fr J.Ator lib)
C 2005-05-12  JWhiting    Added REHU (rel humidity); MAX1=11
c                         seqnum needed???
c 2007-01-30  JWhiting    removed inline wrcmps() so as to be 
c                           compatible w/ BUFRLIB upgrade.
c 2007-10-04  JWhiting    enabled MODS type envsal (NC031109)
c 2009-03-11  JWhiting    disabled compression; this is due to a 
c                       problem when running code recompiled on 
c                       Cirrus (debugged to a BUFRLIB memory 
c                       bounds issue);  use of compression should 
c                       be reconsidered after implementation of a 
c                       BUFRLIB fix.
c 2011-03-08  JWhiting  development for restricted SHIPS tanking;
c                        added SHIPSU processing
c                        added restriction mnemonics for SHIPS
c 2011-03-28  JWhiting  enabled support for shpall dump group
C 2013-02-04  JWhiting  Port to WCOSS (linux) platforms:
C                        rm'd unused variables (ADATE, MI);
C                        Updated doc block and comments;
C                        Ready for implementation.
c 2019-02-22  JWhiting  Port to WCOSS (Dell) phase 3 platforms;
c                       Added NRPT_NCO to tideg() args, supports 
c                        fix to handle poorly time-tagged tideg 
c                        reports.
c 2021-10-19  JSmith    Added logic to process BUFR format moored
c                       buoy data.
C
C USAGE:
C   INPUT FILES:
C     UNIT 20  - BUFR DATA FILE (DCOM FORMATTED)
C     UNIT 21  - MODS BUFR MNEMONIC TABLE
C
C   OUTPUT FILES:
C     UNIT 50  - BUFR DATA FILE (MODS FORMATTED)
C     UNIT 06  - UNIT 6 (STANDARD PRINTFILE)
C
C   SUBPROGRAMS CALLED:
C     UNIQUE:   - MNEMONICS OBNAME RADDATE SSMIPN TIDEG  CLONLAT
C
C     LIBRARY:
C      W3LIB    - W3TAGB W3TAGE ERREXIT
C      BUFRLIB  - OPENBF MAXOUT OPENMB UFBINT
C               - WRITSB WRITCP CLOSBF
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C          >   0 - ABNORMAL RUN
C
C REMARKS:
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  WCOSS
C
C$$$
      PROGRAM BUFR_PREPMODS
 
      PARAMETER(MAX1=11,MAX2=2550)
 
      COMMON /MNEMONIC/ NEMOS(10),NEMS,COMPRESS
 
      CHARACTER*80 NEMOS
      CHARACTER*8  SUBSET,NCOSET,NCOSET0,OBNAME
      LOGICAL      COMPRESS
      REAL*8       DATES(5),ARR(MAX1,MAX2),DTCC(2)
      REAL*8       SUBS,CLONH,CLATH
 
      DATA LUBFR/20/
      DATA LUNDX/21/
      DATA LUBFO/50/
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
 
      CALL W3TAGB('BUFR_PREPMODS',2021, 292,50,'EMC')
 
      print *
      print * ,'-> Welcome to BUFR_PREPMODS of  10/19/2021',
     &           ' (include BUFR format marine data)'

      print *

C  OPEN THE INPUT AND OUTPUT BUFR FILES
C  ------------------------------------

      CALL OPENBF(LUBFR,'IN ',LUBFR)
      CALL OPENBF(LUBFO,'OUT',LUNDX)
 
      call maxout(15000)

C  READ THE MESSAGES FROM THE INPUT FILE
C  -------------------------------------
 
      NRPT_NCO = 0
      NRPT_MOD = 0
 
1     DO WHILE(IREADMG(LUBFR,NCOSET,IDATE).EQ.0)
      read(ncoset(3:5),'(i3)') mtp
      read(ncoset(6:8),'(i3)') mst
      subset = obname(mtp,mst)

      if(subset.eq.'        ') then
         print*,ncoset,' >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<'
         print*,ncoset,' >>>>>has no modsbufr equivalent<<<<<'
         print*,ncoset,' >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<'
         print*,'prepmods error - unknown input subset encountered'
         CALL W3TAGE('BUFR_PREPMODS')
         call errexit(99)
      endif

C  INITIALIZE THE MNNEMONIC TEMPLATE FOR THIS MESSAGE TYPE
C  -------------------------------------------------------
 
      CALL MNEMONICS(SUBSET,NEMOS,NEMS,COMPRESS)
 
      if(nems.eq.0) then
         print*,subset,' >>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<'
         print*,subset,' >>>>>has no modsbufr definitions<<<<<'
         print*,subset,' >>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<'
         print*,'prepmods error - modsbufr subset missing definitions'
         CALL W3TAGE('BUFR_PREPMODS')
         call errexit(99)
      endif

C  READ THE SUBSETS IN EACH MESSAGE
C  --------------------------------
 
2     DO WHILE(IREADSB(LUBFR).EQ.0)
 
      NRPT_NCO = NRPT_NCO + 1
 
C  CASES WHERE REPORTS ARE SPLIT UP IN MODSBUFR
C  --------------------------------------------
 
      IF(SUBSET.EQ.'TIDEG') THEN
         NRPT_TID = 0
         CALL TIDEG(LUBFR,LUBFO,SUBSET,IDATE,NRPT_TID,NRPT_NCO)
         NRPT_MOD = NRPT_MOD + NRPT_TID
         GOTO 2
      ENDIF
 
      IF(SUBSET.EQ.'SSMIPN') THEN
         NRPT_SSMI = 0
         CALL SSMIPN(LUBFR,LUBFO,SUBSET,IDATE,NRPT_SSMI)
         NRPT_MOD = NRPT_MOD + NRPT_SSMI
         GOTO 2
      ENDIF

      IF(SUBSET.EQ.'MBUOYB') THEN
         NRPT_MB = 0
         CALL MBUOYB(LUBFR,LUBFO,SUBSET,IDATE,NRPT_MB)
         NRPT_MOD = NRPT_MOD + NRPT_MB
         GOTO 2
      ENDIF	
 
C  CASES WHERE REPORTS ARE JUST COPIES INTO MODSBUFR
C  -------------------------------------------------
 
      CALL OPENMB(LUBFO,SUBSET,IDATE)
 
      CALL CLONLAT(LUBFR,CLONH,CLATH)
      CALL UFBINT(LUBFO,CLONH,1,1,IRET,'CLONH')
      CALL UFBINT(LUBFO,CLATH,1,1,IRET,'CLATH')
      NRPT_MOD = NRPT_MOD + 1
 
      DO N=1,NEMS
      CALL UFBINT(LUBFR,ARR,MAX1,MAX2,LEV2,NEMOS(N))
      if(lev2.gt.0) CALL UFBINT(LUBFO,ARR,MAX1,LEV2,IRET,NEMOS(N))
      ENDDO
 
      IF(SUBSET.EQ.'TESAC') THEN ! TESAC HAS A WEIRD DTCC SITUATION
         CALL UFBINT(LUBFR,DTCC,2,1,IRET,'DTCC')
         IF(DTCC(1).NE.19) IDTCC = 1
         IF(DTCC(2).NE.19) IDTCC = 2
         CALL UFBINT(LUBFO,DTCC(IDTCC),1,1,IRET,'DTCC')
      ENDIF
 
c Disable compression (due to problem porting to Cirrus; fails on wrcmps)
c  (this should be revisited after update to Cirrus BLib)
ccc   IF(.NOT.COMPRESS) CALL WRITSB(LUBFO)
ccc   IF(     COMPRESS) CALL WRITCP(LUBFO)
      CALL WRITSB(LUBFO)
 
C  CHECK FOR POSSIBLE WAVE DATA
C  ----------------------------
 
C     CALL WAVES(LUBFR,IDATE,IWAVE)
 
C  END OF READ AND CONVERT LOOPS
C  -----------------------------
 
      ENDDO  !  end of readSB loop
      NCOSET0 = NCOSET
      ENDDO  !  end of readMG loop
 
      CALL CLOSBF(LUBFO)
 
C  FINISHED
C  --------
 
      PRINT'(/,80("-"))'
      PRINT'("Read    ",I7," reports from BUFR messages with ",
     $       "Table A entry: ",A8)', NRPT_NCO,NCOSET0
      PRINT'("Wrote   ",I7," reports to MODS file type ",
     $          a8)', NRPT_MOD,subset
      PRINT'(80("-"))'
 
      CALL W3TAGE('BUFR_PREPMODS')
      STOP
      END

ccc  read out TC probability ccccccccccccccccccccccccccc
cc  nt=1-29, 28*6=168hrs (7days)
cc  nx=1-241, Lon=105E-345E
cc  ny=1-40, Lat=1N-40N
cc  Jiayi.Peng  04/07/2016
c------------------------------------------------------
      module define_atcfunix_rec
        type atcfunix_card    ! Define a new type for an atcfunix card
          sequence
          character*2   atx_basin       ! Hurricane Center Acronym
          character*2   atx_storm_num   ! Storm number (03, etc)
          character*10  atx_ymdh        ! Fcst start date (yyyymmddhh)
          character*2   atx_technum     ! Always equal to 03 for models
          character*4   atx_model       ! Name of forecast model
          integer       atx_fcsthr      ! Fcst hour (i3.3)
          integer       atx_lat         ! Storm Lat (*10), always >0
          character*1   atx_latns       ! 'N' or 'S'
          integer       atx_lon         ! Storm Lon (*10), always >0
          character*1   atx_lonew       ! 'E' or 'W'
        end type atcfunix_card
      end module define_atcfunix_rec

      module define_atcf_pro_rec
        type atcf_pro_card    ! Define a new type for an atcfunix card
          sequence
          character*2   pro_basin       ! Hurricane Center Acronym
          character*2   pro_storm_num   ! Storm number (03, etc)
          character*10  pro_ymdh        ! Fcst start date (yyyymmddhh)
          character*2   pro_technum     ! Always equal to 03 for models
          character*4   pro_model       ! Name of forecast model
          integer       pro_fcsthr      ! Fcst hour (i3.3)
          integer       pro_lat         ! Storm Lat (*10), always >0
          character*1   pro_latns       ! 'N' or 'S'
          integer       pro_lon         ! Storm Lon (*10), always >0
          character*1   pro_lonew       ! 'E' or 'W'
          integer       pro_prob        ! genesis probability (%)
        end type atcf_pro_card
      end module define_atcf_pro_rec

      program readprob
      USE define_atcfunix_rec
      USE define_atcf_pro_rec

      type (atcfunix_card) inprec
      type (atcf_pro_card) stm

      parameter (nx=241, ny=40, nt=29)
      real xprob(nx,ny), xmax(nt), xlat(nt), xlon(nt)
      character*44 infile, outfile
      character*34 infile2

      call read_nlists (infile,outfile,infile2)

      open (52,file=infile,
     &      form='unformatted', access='direct',recl=nx*ny*4)
      irec1=1

      do k=1,nt
        xmax(k)=0.0
        xlat(k)=999.0
        xlon(k)=999.0
      enddo

      do k=1,nt
        read(52,rec=irec1,err=101) ((xprob(i,j),i=1,nx),j=1,ny)
	irec1=irec1+1

	do i=1,nx
	do j=1,ny
          if(xprob(i,j).gt.xmax(k)) then
	    xmax(k)=xprob(i,j)
            xlon(k)=105.0+(i-1)*1.0
            xlat(k)=40.0-(j-1)*1.0
          endif
        enddo
	enddo

      enddo
101   continue
      close(52)

      open(53,file=outfile)
      open(54,file=infile2)

c      xmean=0.0
c      do k=1,9
c	xmean=xmean+xmax(k)
c      enddo
c      xmean=xmean/9.0
c      write(53,103) xmean*100
c103   format(1x,f5.1,'% 48h-probability forecast')
c      do k=1,nt
c       write(53,102) (k-1)*6,xmax(k)*100,xlat(k),xlon(k)
c      enddo
c102   format(1x,i5,1x,f5.1,1x,f5.1,1x,f5.1)
      readloop: do while (.true.)
        read (54,85,end=870) inprec
          stm%pro_basin=inprec%atx_basin
          stm%pro_storm_num=inprec%atx_storm_num
          stm%pro_ymdh=inprec%atx_ymdh
          stm%pro_technum=inprec%atx_technum
          stm%pro_model=inprec%atx_model
          stm%pro_fcsthr=inprec%atx_fcsthr
          stm%pro_lat=inprec%atx_lat
          stm%pro_latns=inprec%atx_latns
          stm%pro_lon=inprec%atx_lon
          stm%pro_lonew=inprec%atx_lonew

          ihr=stm%pro_fcsthr
          k=ihr/6+1
          stm%pro_prob=xmax(k)*100

          write (53,81) stm%pro_basin, stm%pro_storm_num,
     & stm%pro_ymdh, stm%pro_technum, stm%pro_model,
     & stm%pro_fcsthr, stm%pro_lat, stm%pro_latns,
     $ stm%pro_lon, stm%pro_lonew, stm%pro_prob
      enddo readloop

 85   format (a2,2x,a2,2x,a10,2x,a2,2x,a4,2x,i3
     &       ,2x,i3,a1,2x,i4,a1)

 81   format (a2,', ',a2,', ',a10,', ',a2,', ',a4,
     &       ', ',i3.3,', ',i3,a1,', ',i4,a1,', '
     &       ,i3)

 870  continue
          
      close(54)
      close(53)

      stop
      end

c-----------------------------------------------------------------------
      subroutine read_nlists (infile,outfile,infile2)

c     ABSTRACT: This subroutine simply reads in the namelists that are
c     created in the shell script.
c   infile aemn.trkprob.AL95.65nm.2011062718.indiv.ieee
c   outfile aemn.trkprob.AL95.65nm.2011062718.indiv.data
c   infile2 trak.aemn.atcfunix.2016040500.HC01

      character*44 infile, outfile, kymdh0, kymdh1
      character*34 infile2, kymdh2
      namelist/datain0/kymdh0
      namelist/datain1/kymdh1
      namelist/datain2/kymdh2

      read (5,NML=datain0,END=55)
55    continue
      read (5,NML=datain1,END=66)
66    continue
      read (5,NML=datain2,END=77)
77    continue

      infile=kymdh0
      outfile=kymdh1
      infile2=kymdh2

      return
      end

!
!   Author: Suranjana Saha
C-----------------------------------------------------------------------
C  MAIN PROGRAM SURUFIT
C-----------------------------------------------------------------------
      PROGRAM SURUFIT
 
      PARAMETER (IDBUG=0,IPR=1)
      PARAMETER (FAC=984.0)
      PARAMETER (NSTC=6)
      PARAMETER (NREG=7)
      PARAMETER (NSUB=2)
      PARAMETER (NBAK=2)
 
      CHARACTER*80 HDSTR,PSTR
      CHARACTER*8  SUBSET

      real(8)    HDR(14)
      real(8)    POB(4)

      real(8)    CNTO,CNTN,RAT1,RAT2,WT1,WT2
      real(8)    SPRS(NSTC,NREG,NSUB,NBAK)
      real(8)    STC(NSTC,NBAK)

      real(4)    GDATA(NREG,NSUB)

      LOGICAL      REGION
 
      DATA HDSTR
     ./'SID XOB YOB DHR ELV TYP T29 ITP SQN RQM DUP PRG SRC RUD'/
 
      DATA PSTR /'POB PAN PFC PQM'/

      real(8) BMISS /10E10/

      DATA RMISS /-9.99E+33/
      DATA LUBFR/11/

C-----------------------------------------------------------------------
 
C  ZERO THE FIT ARRAYS
C  -------------------
 
      SPRS = 0.
      STC=0.
 
      bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10
      CALL OPENBF(LUBFR,'IN ',LUBFR)

C  READ AND "SURU-FIT" THE PREPDA/BUFR RECORDS
C  -------------------------------------------
 
10    DO WHILE(IREADMG(LUBFR,SUBSET,IDATE).EQ.0)
c... check for subset...
      IF(ITYP(SUBSET).EQ.0) GOTO 10
11    DO WHILE(IREADSB(LUBFR).EQ.0)

      CALL UFBINT(LUBFR,HDR,14,  1,NLEV,HDSTR)
      typx=hdr(6)

c... check for region...
      XOB=hdr(2)
      YOB=hdr(3)
c     CALL UFBINT(LUBFR,XOB,1,1,IREC,'XOB')
c     CALL UFBINT(LUBFR,YOB,1,1,IREC,'YOB')
      IF(.NOT.REGION(XOB,YOB,0)) GOTO 11
 
C  READ THE DATA
C  -------------
       CALL UFBINT(LUBFR,POB, 4,1,NLEV,PSTR)
       PO=POB(1)
       PA=POB(2)
       PF=POB(3)
       PQ=POB(4)
c
C  CREATE AND ACCUMULATE THE STATISTICS ARRAY FOR EACH REALIZATION
C  ---------------------------------------------------------------
 
      STC = 0.
C
      if((pa.eq.bmiss).or.(pf.eq.bmiss)) go to 11

      IF(PQ.LE.3) THEN
      if(idbug.eq.1) print *,'ob ',po,' ges ',pf, ' anl ',pa
C
c... start forecast-loop
         DO IB=1,2
C
c  count
            STC(1,IB) = 1.
c  f
            if(ib.eq.1) STC(2,IB) = PF-fac
            if(ib.eq.2) STC(2,IB) = PA-fac
c  o
            STC(3,IB) = PO-fac
c  f * o
            STC(4,IB) = STC(2,IB)*STC(3,IB)
c  f**2
            STC(5,IB) = STC(2,IB)**2
c  o**2
            STC(6,IB) = STC(3,IB)**2
C
         if(idbug.eq.1) print *,' ib ',ib,' stc ',(stc(k,ib),k=1,6)
c
c... end forecast-loop
         ENDDO
c
      ENDIF
 
         M = ITYP(SUBSET)
 
         if (m > 0) then
         DO N=1   ,NBAK
         DO LL=1  ,NREG
C
         IF(REGION(XOB,YOB,LL)) THEN
C
            cnto = SPRS(1,LL,M,N) 
            SPRS(1,LL,M,N) = SPRS(1,LL,M,N) + STC(1,N)
            cntn = SPRS(1,LL,M,N) 

            if(cntn.gt.cnto) then
            wt1 = cnto/cntn
            wt2 = 1.-wt1
c
            DO I=2,NSTC

            sprso = SPRS(I,LL,M,N)
            rat1 = wt1*SPRS(I,LL,M,N)
            rat2 = wt2*STC(I,N)
c
            SPRS(I,LL,M,N) = rat1 + rat2
            sprsn = SPRS(I,LL,M,N)
c
            if((idbug.eq.1).and.(i.eq.2)) then
            if((m.eq.1).and.(n.eq.1)) then
            write(6,3000) ll,cnto,cntn,wt1,wt2,sprso,STC(I,N),
     *      rat1,rat2,sprsn
            endif
            endif
c
c... end stat-loop
            ENDDO
c
            endif

         ENDIF
c... end region-loop
         ENDDO
C
c... end forecast-loop
         ENDDO
         endif     ! if itype > 0
C
      ENDDO
c... end subset-loop
      ENDDO
 
       CALL CLOSBF(LUBFR)

C  FINISH UP
C  ---------
C   write out grads data file...
 
      iw=50
      do ibak=1,nbak
      iw=iw+1
c
      do nst=1,6
c
      do isub=1,nsub
      do ireg=1,nreg
      if((nst.eq.2).or.(nst.eq.3)) then
      gdata(ireg,isub)=sprs(nst,ireg,isub,ibak)+fac
      else
      gdata(ireg,isub)=sprs(nst,ireg,isub,ibak)
      endif
      enddo
      enddo
c
      write(iw) gdata
c
      if(ipr.eq.1) 
     *write(6,1232) ibak,nst,(gdata(ireg,1),ireg=1,nreg)
c
c... end stat-loop
      enddo
c
      close(iw)
c... end forecast-loop
      enddo
c
 1232  format('p fcs=',i2,2x,'stat = ',i2,2x,7f12.2)
 3000  format('reg ',i2,' cnto ',f7.0,' cntn ',f7.0,
     *        ' wt1 ',f5.2,' wt2 ',f5.2,2x,5f12.2)
c
      PRINT'("SURUFIT PROCESSING COMPLETED")'
      STOP
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      LOGICAL FUNCTION REGION(X,Y,I)
 
      PARAMETER(NREG=7)
 
      DIMENSION X1(NREG),X2(NREG),Y1(NREG),Y2(NREG)
 
C.... X goes from east to west
C.... Y goes from south to north
      DATA X1(1),X2(1),Y1(1),Y2(1) /0.,360.,-90.,90./
      DATA X1(2),X2(2),Y1(2),Y2(2) /0.,360.,20.,80./
      DATA X1(3),X2(3),Y1(3),Y2(3) /0.,360.,-80.,-20./
      DATA X1(4),X2(4),Y1(4),Y2(4) /0.,360.,-20.,20./
      DATA X1(5),X2(5),Y1(5),Y2(5) /235.,295.,25.,55./
      DATA X1(6),X2(6),Y1(6),Y2(6) /350.,25.,35.,70./
      DATA X1(7),X2(7),Y1(7),Y2(7) /65.,145.,5.,45./

C-----------------------------------------------------------------------
 
C  CHECK FOR A VALID REGION INDEX AND BE OPTIMISTIC
C  ------------------------------------------------
 
      IF(I.LT.0.OR.I.GT.NREG) THEN
         REGION = .FALSE.
         RETURN
      ELSE
         REGION = .TRUE.
      ENDIF
 
C  SETUP THE SEARCH PARAMETERS
C  ---------------------------
 
      IF(I.EQ.0) THEN
         I1 = 1
         I2 = NREG
      ELSE
         I1 = I
         I2 = I
      ENDIF
 
C  LOOK FOR A REGION MATCH
C  -----------------------
 
      DO I0=I1,I2
      IF(Y.GE.Y1(I0) .AND. Y.LE.Y2(I0)) THEN
         IF(X1(I0).LE.X2(I0)) THEN
            IF(X.GE.X1(I0) .AND. X.LE.X2(I0)) RETURN
         ELSEIF(X1(I0).GT.X2(I0)) THEN
            IF(X.GE.X1(I0) .OR.  X.LE.X2(I0)) RETURN
         ENDIF
      ENDIF
      ENDDO
 
C  IF NO MATCH, RETURN FALSE
C  -------------------------
 
      REGION = .FALSE.
      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER FUNCTION ITYP(SUBSET)
 
      PARAMETER(NSUB=2)
 
      CHARACTER*8 SUBSET,SUBTYP(2)
      DATA SUBTYP /'ADPSFC','SFCSHP'/
C
C     CHARACTER*8 SUBSET,SUBTYP(15)
C     DATA SUBTYP /'ADPUPA','AIRCAR','AIRCFT','SATWND','PROFLR',
C    .             'VADWND','SATBOG','SATEMP','ADPSFC','SFCSHP',
C    .             'SFCBOG','SPSSMI','SYNDAT','ERS1DA','GOESND'/
 
C  LOOK FOR A MATCH TO RETURN NON-ZERO
C  -----------------------------------
 
      DO I=1,NSUB
      ITYP = I
      IF(SUBSET.EQ.SUBTYP(I)) RETURN
      ENDDO
 
C  IF NO MATCH, RETURN ZERO
C  ------------------------
 
      ITYP = 0
      RETURN
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C  
C MAIN PROGRAM:  PREPOBS_PREPANOW
C   PRGMMR: Whiting          ORG: EMC         DATE: 2014-10-17
C
C ABSTRACT: REPROCESSES THE DUMP OF "AIRNOW" OZONE CONCENTRATION AND 
C   PARTICULATE MATTER (PM) DATA INTO A PREPBUFR LOOK-A-LIKE FILE.  USED  
C   BY VERIFICATION CODES TO GENERATE A "PREPFITS" COMPARISON FILES.
C
C PROGRAM HISTORY LOG:
C 2004-09-12  D. A. KEYSER -- ORIGINAL AUTHOR
C 2005-02-02  D. A. KEYSER -- MODIFIED TO HANDLE DUMP FILES CONTAINING
C            NEW, NOT-YET-OPERATIONAL, SEPARATE 1-HOUR AND 8-HOUR
C            BACKWARD-AVERAGED DATA WITH MESSAGE TYPES NC008021 AND
C            NC008022, RESPECTIVELY, IT STILL PROPERLY HANDLES THE
C            OPERATIONAL DUMP FILES CONTAINING COMBINED 1-HOUR AND 8-
C            HOUR FORWARD-AVERAGED DATA WITH MESSAGE TYPE NC008020
C 2012-03-14  D. A. KEYSER - IN RESPONSE TO THE LATEST VERSION OF
C            BUFRLIB WHICH CAN HANDLE EMBEDDED DICTIONARY MESSAGES::
C            INCREASES DEGREE OF BUFRLIB PRINTOUT SUCH THAT CODE WILL
C            PRINT A DIAGNOSTIC IF ANY EMBEDDED DICTIONARY MESSAGES ARE
C            FOUND WHEN READING IN MESSAGES; REPLACES SINGLE CALL TO
C            OPENMG AFTER OPENING INPUT AND OUTPUT BUFR FILES WITH CALL
C            TO OPENMB IN INNER DO-LOOP WHERE INFORMATION FROM EACH
C            SUBSET READ IN IS TRANSFERRED TO THE OUTPUT BUFR FILE,
C            THIS FIXES A BUG WHICH HAD CAUSED A BUFRLIB ABORT HERE
C            WHEN THE INPUT BUFR FILE CONTAINS EMBEDDED BUFR DICTIONARY
C            MESSAGES (NOT SURE WHY!); REPLACED CALL TO BUFRLIB ROUTINE
C            UFBSEQ WITH TWO CALLS TO UFBINT TO READ IN SUBSETS (UFBSEQ
C            ASSUMES A PRE-DEFINED ORDER TO PARAMETERS IN A SUBSET,
C            UFBINT DOES NOT)
C 2013-06-21 JWhiting - updated for use on WCOSS (linux) platforms:
C            updated doc block and w3tagb args; no logic changes.
C 2014-10-17 JWhiting - added Particulate Matter (PM) processing
C ------
C
C USAGE:
C   INPUT FILES:
C     UNIT 21  - "AIRNOW" BUFR DATA DUMP FILE
C     UNIT 25  - LOOK-A-LIKE PREPBUFR MNEMONIC BUFRTABLE (FOR ONLY
C                AIRNOW DATA)
C     UNIT 30  - CENTRAL DUMP AND PREPBUFR PROCESSING DATE IN FORM
C                YYYYMMDDHH
C
C   OUTPUT FILES: 
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - LOOK-A-LIKE PREPBUFR FILE CONTAINING ONLY AIRNOW DATA
C
C   SUBPROGRAMS CALLED:
C     LIBRARY:
C       W3NCO    - W3TAGB   W3DIFDAT W3TAGE
C       BUFRLIB  - DATELEN  MESGBC   OPENBF   OPENMB   UFBINT
C                  WRITSB   CLOSBF
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C          >   0 - ABNORMAL TERMINATION
C
C REMARKS:
C
C   INPUT REPORT STRUCTURE FROM AIRNOW BUFR DATA DUMP FILE (RDATA_8):
C
C    FOR MESSAGE TYPE NC008020 WHICH CONTAINS 1- AND 8-HOUR FORWARD
C     AVERAGED DATA IN A SINGLE SUBSET:
C
C      WORD    MNEMONIC
C      ----    --------
C        1       YEAR  \
C        2       MNTH  - starting time from which ozone concentration
C        3       DAYS  - average is caluculated
C        4       HOUR  /
C        5       PTID
C        6       CLATH
C        7       CLONH
C        8       TYPO
C        9       TSIG
C       10       TPHR  - 1-hour average follows
C       11       QCIND    - q.c. indicator
C       12       COPO     - ozone concentration
C       13       TPHR  - 8-hour average follows
C       14       QCIND    - q.c. indicator
C       15       COPO     - ozone concentration
C
C   OUTPUT REPORT STRUCTURE IN AIRNOW LOOK-A-LIKE PREPBUFR FILE:
C      WORD    MNEMONIC
C      ----    --------
C        1       SID
C        2       XOB
C        3       YOB
C        4       DHR   - Observation time (i.e., starting time
C                        from which average is caluclated) minus
C                        cycle (central dump/PREPBUFR) time
C        5       TYP   - PREPBUFR REPORT TYPE (101)
C        6       T29   - INPUT DUMP REPORT TYPE (591)
C        7       SQN
C        8       PROCN - Process number (for MPI) - always 0
C                        (program does not run in "pieces")
C        9       RPT
C       10       CAT   - PREPBUFR data level category (always 6)
C       11       TYPO
C       12       TSIG
C       13       TPHR  - 1-hour average follows
C       14       QCIND    - q.c. indicator
C       15       COPO     - ozone concentration
C       16       TPHR  - 8-hour average follows
C       17       QCIND    - q.c. indicator
C       18       COPO     - ozone concentration
C
C
C    FOR MESSAGE TYPE NC008021 WHICH CONTAINS ONLY 1-HOUR BACKWARD
C     AVERAGED DATA IN A SINGLE SUBSET AND MESSAGE TYPE NC008022 WHICH
C     CONTAINS ONLY 8-HOUR BACKWARD AVERAGED DATA IN A SINGLE SUBSET:
C
C      WORD    MNEMONIC
C      ----    --------
C        1       YEAR  \
C        2       MNTH  - ending time from which ozone concentration
C        3       DAYS  - average is caluculated
C        4       HOUR  /
C        5       PTID
C        6       CLATH
C        7       CLONH
C        8       TYPO
C        9       TSIG
C       10       TPHR  - 1-hour or 8-hour average follows
C       11       QCIND    - q.c. indicator
C       12       COPO     - ozone concentration
C
C   OUTPUT REPORT STRUCTURE IN AIRNOW LOOK-A-LIKE PREPBUFR FILE:
C      WORD    MNEMONIC
C      ----    --------
C        1       SID
C        2       XOB
C        3       YOB
C        4       DHR   - Observation time (i.e., ending time
C                        from which average is caluclated) minus
C                        cycle (central dump/PREPBUFR) time
C        5       TYP   - PREPBUFR REPORT TYPE (101)
C        6       T29   - INPUT DUMP REPORT TYPE (591)
C        7       SQN
C        8       PROCN - Process number (for MPI) - always 0
C                        (program does not run in "pieces")
C        9       RPT
C       10       CAT   - PREPBUFR data level category (always 6)
C       11       TYPO
C       12       TSIG
C       13       TPHR  - 1-hour or 8-hour average follows
C       14       QCIND    - q.c. indicator
C       15       COPO     - ozone concentration
C
C
C    FOR MESSAGE TYPE NC008031 WHICH CONTAINS ONLY 1-HOUR BACKWARD
C     AVERAGED DAILY PARTICULATE MATTER DATA IN A SINGLE SUBSET:
C
C      WORD    MNEMONIC
C      ----    --------
C      1-11      same as for the ozone message types above
C       12       COPOPM   - Concentration of Pollutant
C
C   OUTPUT REPORT STRUCTURE IN AIRNOW LOOK-A-LIKE PREPBUFR FILE:
C      WORD    MNEMONIC
C      ----    --------
C      1-15      same as for the ozone message types above
C       16       TPHR  - 1-hour or 8-hour average follows
C       17       QCIND    - q.c. indicator
C       18       COPOPM   - Concentration of Pollutant
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM CCS
C
C$$$
      PROGRAM PREPOBS_PREPANOW

      CHARACTER*8 SUBOUT,SID,SUBSET, SUBPM
      REAL(8)     RDATA_8(15),RID,DHR,RPT,T29,TYP,CAT,PROCN,SQN
      REAL(8)     PDATA_8(3,2)

      real(8)     rd7_8   ! jaw db debug
      character*3 s3      ! jaw db debug

      DIMENSION   IDAT(8),JDAT(8),RINC(5)

      EQUIVALENCE (RID,SID),(RDATA_8(10),PDATA_8(1,1))

      DATA  SUBOUT/'AIRNOW  '/,IREP/0/, SUBPM/'ANOWPM  '/
      DATA  LUBFI/21/,LINDX/25/,LDATE/30/,LUBFO/51/,LUBPM/52/

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      CALL W3TAGB('PREPOBS_PREPANOW',2014,0290,0050,'EMC')

      print *
      print * ,'---> Welcome to PREPOBS_PREPANOW - Version 10-17-2014'
      print *

      READ(LDATE,'(I10)') IDATE

      CALL DATELEN(10)

      CALL MESGBC(LUBFI,MSGT,ICOMP)
      IF(ICOMP.EQ.1) THEN
         PRINT'(/"INPUT BUFR FILE MESSAGES   C O M P R E S S E D"/'//
     .    '"FIRST MESSAGE TYPE FOUND IS",I5/)', MSGT
      ELSE  IF(ICOMP.EQ.0) THEN
         PRINT'(/"INPUT BUFR FILE MESSAGES   '//
     .    'U N C O M P R E S S E D"/"FIRST MESSAGE TYPE FOUND IS",I5/)',
     .    MSGT
      ELSE IF(ICOMP.EQ.-1)  THEN
         PRINT'(//"ERROR READING INPUT BUFR FILE - MESSAGE '//
     .    'COMPRESSION UNKNOWN"/)'
      ELSE  IF(ICOMP.EQ.-3)  THEN
         PRINT'(/"INPUT BUFR FILE DOES NOT EXIST"/)'
      ELSE  IF(ICOMP.EQ.-2)  THEN
         PRINT'(/"INPUT BUFR FILE HAS NO DATA MESSAGES"/"FIRST '//
     .    'MESSAGE TYPE FOUND IS",I5/)', MSGT
      ENDIF

      CALL OPENBF(LUBFI,'IN',LUBFI)
      CALL OPENBF(0,'QUIET',1) ! incr. degree of diag. prnt from BUFRLIB

      CALL OPENBF(LUBFO,'OUT',LINDX)       ! Ozone output
      CALL OPENBF(LUBPM,'OUT',LINDX)       ! PM output

      IDAT    = 0
      IDAT(1) = IDATE/1000000
      IDAT(2) = MOD((IDATE/10000),100)
      IDAT(3) = MOD((IDATE/100),100)
      IDAT(5) = MOD(IDATE,100)

      nmsg=0   ! debug
      nsb=0    ! debug
      DO WHILE(IREADMG(LUBFI,SUBSET,JDATE).EQ.0)
        if ( nmsub(lubfi).ne.0 ) nmsg=nmsg+1    ! debug
        npr=0    ! debug

        DO WHILE(IREADSB(LUBFI).EQ.0)
          npr=npr+1    ! debug
          nsb=nsb+1    ! debug

cdak      CALL UFBSEQ(LUBFI,RDATA_8,15,1,IRET,SUBSET)
          CALL UFBINT(LUBFI,RDATA_8, 9,1,ILVL,
     .              'YEAR MNTH DAYS HOUR PTID CLATH CLONH TYPO TSIG')
          IF (SUBSET.NE.'NC008031') THEN 
            CALL UFBINT(LUBFI,PDATA_8,3,2,ILVL,'TPHR QCIND COPO')
          ELSE
            CALL UFBINT(LUBFI,PDATA_8,3,1,ILVL,'TPHR QCIND COPOPM')
          ENDIF ! SUBSET NOT PM (NC008031)

cpppppppppp
cc        print 100, ilvl,rdata_8
cc100 format(1x,'ILVL=',I3,'; RPTIN:',4F6.0,F11.0,2F8.2,2F4.0,2(2F4.0,
cc   . F13.9))
cpppppppppp

C  CONVERT REPORT TO PREPBUFR
C  --------------------------

          IF (SUBSET.NE.'NC008031') THEN 
            LUN = LUBFO                       ! Ozone output logical unit
            CALL OPENMB(LUBFO,SUBOUT,IDATE)
          ELSE
            LUN = LUBPM                       ! PM output logical unit
            CALL OPENMB(LUBPM,SUBPM,IDATE)
          ENDIF ! SUBSET NOT PM (NC008031)

c   Convert PLATFORM TRANSMITTER ID NUMBER to STNID (change dec to hex)
c   -------------------------------------------------------------------

          WRITE(SID,'(Z8.8)') NINT(RDATA_8(5))
          CALL UFBINT(LUN  ,RID,1,1,IRET,'SID')

c YEAR MNTH DAYS HOUR PTID CLATH CLONH TYPO TSIG TPHR QCIND COPO[PM] 
      if (npr.le.5 .and. .true.) then 
        s3=subset(6:8)
        write(*,101) 'db: ',s3,nmsg,nsb,(int(rdata_8(i)),i=1,4)
        write(*,102) int(rdata_8(5)), sid
      endif ! npr <=5

c   Convert REPORT DATE to OBSERVATION TIME MINUS CYCLE TIME and to
c    observation time
c   ---------------------------------------------------------------

          JDAT      = 0
          JDAT(1:3) = RDATA_8(1:3)
          JDAT(5)   = RDATA_8(4)
          CALL W3DIFDAT(JDAT,IDAT,2,RINC)
          DHR = RINC(2)
          CALL UFBINT(LUN  ,DHR,1,1,IRET,'DHR')
          RPT =  RDATA_8(4)
          CALL UFBINT(LUN  ,RPT,1,1,IRET,'RPT')

c   Convert HIGH-RES LAT/LON to LOW-RES LAT/LON (LON from -W, +E to E)
c   -----------------------------------------------------------------

      rd7_8 = rdata_8(7)  ! debug

          XOB = RDATA_8(7)
          RDATA_8(7) = 360. - MOD(720.-XOB,360.)
          IF(RDATA_8(7).EQ.360.0)  RDATA_8(7) = 0.0
          CALL UFBINT(LUN  ,RDATA_8(6),2,1,IRET,'YOB XOB')

c   Set DUMP report type & PREPBUFR report type
c         DUMP report type:  ozone = 591   particulate = 592
c     PREPBUFR report type:  ozone = 101   particulate = 102
c   For all types, set Category, Process number and Sequence number:
c             Category = 6        Process number = 0
c      Sequence number = next report number
c   ------------------------------------------------------------

          IF (SUBSET.NE.'NC008031') THEN 
            T29 = 591                         ! Ozone dump rpt type
            TYP = 101                         ! Ozone prepbufr rpt type
          ELSE
            T29 = 592                         ! PM dump rpt type
            TYP = 102                         ! PM prepbufr rpt type
          ENDIF ! SUBSET NOT PM (NC008031)

          CAT = 6                             ! Category
          PROCN = 0                           ! Process number
          IREP = IREP + 1 
          SQN  = IREP                         ! Sequence number

          CALL UFBINT(LUN  ,T29,1,1,IRET,'T29')
          CALL UFBINT(LUN  ,TYP,1,1,IRET,'TYP')
          CALL UFBINT(LUN  ,CAT,1,1,IRET,'CAT')
          CALL UFBINT(LUN  ,PROCN,1,1,IRET,'PROCN')
          CALL UFBINT(LUN  ,SQN,1,1,IRET,'SQN')


c  Finally encode the observational data in PREPBUFR
c  -------------------------------------------------

          CALL UFBINT(LUN  ,RDATA_8(8),2,1,IRET,'TYPO TSIG')
          IF(SUBSET.EQ.'NC008020')  THEN
             NLEV = 2
          ELSE
             NLEV = 1
          ENDIF

          IF (SUBSET.NE.'NC008031') THEN 
            CALL UFBINT(LUBFO,PDATA_8,3,NLEV,IRET,'TPHR QCIND COPO')
          ELSE
            CALL UFBINT(LUBPM,PDATA_8,3,NLEV,IRET,'TPHR QCIND COPOPM')
          ENDIF ! NOT PM MESSAGE TYPE (NC008031)

          CALL WRITSB(LUN  )

      if (npr.le.5) then 
        write(*,103) rdata_8(6), rd7_8, rdata_8(7)
        write(*,104) (int(rdata_8(j)),j=8,11)
        write(*,105) rdata_8(12)*1d9
      endif ! npr <= 5
  101 format(a4,1x,a3,i4,i6,1x,i4,2i2.2,".",i2.2, $) ! s3, mg,sb,ymd.h
  102 format( 1x,i9, 1x,a8, $)                       ! ptid, sid
  103 format( 1x,f10.5,1x,f9.5, 1x,f7.2, $)          ! lat, lon, xob
  104 format( 4(1x,i2), $)                           ! typo,tsig,tphr,qcind
  105 format( 1x,f6.2)                               ! copo | copopm

        END DO ! WHILE IREADSB
      END DO ! WHILE IREADMG

      CALL CLOSBF(LUBFI)
      CALL CLOSBF(LUBFO)
      CALL CLOSBF(LUBPM)
            
      CALL W3TAGE('PREPOBS_PREPANOW')
      STOP
      END

C***********************************************************************
C***********************************************************************
      SUBROUTINE GBLEVN04 ! FORMERLY SUBROUTINE GETOE

      DIMENSION OEMIN(2:6)
      REAL(8)   OBS,QMS,BAK,SID,BMISS

      COMMON /GBEVAA/ SID,OBS(15,255),QMS(12,255),BAK(12,255),XOB,
     $ YOB,DHR,TYP,NLEV

      DATA BMISS /10E10/

      DATA OEMIN /0.5,0.1,1.0,0.5,1.0/

C  CLEAR THE EVENT ARRAY
C  ---------------------

      BAK = BMISS

C  LOOP OVER LEVELS LOOKING UP THE OBSERVATION ERROR
C  -------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV
         POB  = OBS( 1,L)
         QOB  = OBS( 2,L)
         TOB  = OBS( 3,L)
         WOB  = MAX(OBS(5,L),OBS(6,L))
         PWO  = OBS( 7,L)
         PW1O = OBS( 8,L)
         PW2O = OBS( 9,L)
         PW3O = OBS(10,L)
         PW4O = OBS(11,L)
         CAT  = OBS(12,L)

         IF(CAT .EQ.0    ) BAK( 1,L) = OEFG01(POB,TYP,5,OEMIN(5))
         IF(QOB .LT.BMISS) BAK( 2,L) = OEFG01(POB,TYP,3,OEMIN(3))
         IF(TOB .LT.BMISS) BAK( 3,L) = OEFG01(POB,TYP,2,OEMIN(2))
         IF(WOB .LT.BMISS) BAK( 5,L) = OEFG01(POB,TYP,4,OEMIN(4))
         IF(PWO .LT.BMISS) BAK( 6,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW1O.LT.BMISS) BAK( 7,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW2O.LT.BMISS) BAK( 8,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW3O.LT.BMISS) BAK( 9,L) = OEFG01(POB,TYP,6,OEMIN(6))
         IF(PW4O.LT.BMISS) BAK(10,L) = OEFG01(POB,TYP,6,OEMIN(6))
      ENDDO
      ENDIF

      RETURN
      END

      module define_atcfunix_rec
        type atcfunix_card    ! Define a new type for an atcfunix card
          sequence
          character*2   atx_basin       ! Hurricane Center Acronym
          character*2   atx_storm_num   ! Storm number (03, etc)
          character*10  atx_ymdh        ! Fcst start date (yyyymmddhh)
          character*2   atx_technum     ! Always equal to 03 for models
          character*4   atx_model       ! Name of forecast model
          integer       atx_fcsthr      ! Fcst hour (i3.3)
          integer       atx_lat         ! Storm Lat (*10), always >0
          character*1   atx_latns       ! 'N' or 'S'
          integer       atx_lon         ! Storm Lon (*10), always >0
          character*1   atx_lonew       ! 'E' or 'W'
          integer       atx_vmax        ! max sfc wind speed (knots)
          integer       atx_pcen        ! Min central pressure (mb)
          character*2   atx_stype       ! Storm type (= 'XX' for now)
          integer       atx_wthresh     ! Wind threshold (34, 50, 64 kt)
          character*3   atx_quad_id     ! NEQ = start with NE quadrant
          integer       atx_ne_quad     ! Wind radius in NE quad (nm)
          integer       atx_se_quad     ! Wind radius in SE quad (nm)
          integer       atx_sw_quad     ! Wind radius in SW quad (nm)
          integer       atx_nw_quad     ! Wind radius in NW quad (nm)
        end type atcfunix_card
      end module define_atcfunix_rec

      module maxparms
        integer, parameter :: ncmaxmem = 20 ! max # ncep ensemble perts
        integer, parameter :: n0maxmem = 20 ! max # ncep_bc ensemble perts
        integer, parameter :: ukmaxmem = 23 ! max # UKMET ensemble perts

cJ.Peng-------2010-09-29--------------------------------------
        integer, parameter :: gcmaxmem = 20 ! max # gv ensemble perts
        integer, parameter :: g0maxmem = 20 ! max # FNMOC_bc ensemble perts

        integer, parameter :: ccmaxmem = 20 ! max # cmc ensemble perts
        integer, parameter :: c0maxmem = 20 ! max # cmc_bc ensemble perts

        integer, parameter :: ecmaxmem = 50 ! max # ecmwf ensemble perts
        integer, parameter :: srmaxmem = 21 ! max # sref ensemble perts
cJ.Peng-------2010-10-29------------2010-11-02-----------------
        integer, parameter :: c2maxmem = 40 ! max # NCEP+CMC ens pert
        integer, parameter :: c3maxmem = 90 ! max # NCEP+CMC+EC ens pert
        integer, parameter :: n2maxmem = 70 ! max # NCEP+EC ens pert

        integer, parameter :: c4maxmem = 110 ! max # NCEP+CMC+EC+FNMOC
        integer, parameter :: c5maxmem = 133 ! max # NCEP+CMC+EC+FNMOC+UK

        integer, parameter :: n3maxmem = 93 ! max # NCEP+EC+UK

        integer, parameter :: f3maxmem = 60 ! max # NCEP+CMC+FNMOC

        integer, parameter :: s3maxmem =  2 ! max # eemn+2emn ens pert
        integer, parameter :: p3maxmem =  3 ! max # ee/ae/ce+mn ens pert

        integer, parameter :: d3maxmem =  3 ! max # AVNO+CMC+EMX  pert
        integer, parameter :: d6maxmem =  6 ! max # AVNO+CMC+EMX+AEMN+..
        integer, parameter :: d4maxmem =  4 ! max # AVNO+CMC+EMX+3EMN
        integer, parameter :: d2maxmem =  2 ! max # 3EMN+3DET..

c        integer, parameter :: ncminmem =  8 ! min # of ncep ensemble
c  J.Peng----2012-02-28
c  2-member for mean track calculation and at least 10% for probability
        integer, parameter :: ncminmem =  2 ! min # of ncep ensemble 
                         ! perts needed at a given fcst hr to get a mean
        integer, parameter :: n0minmem =  8 ! min # of ncep_bc ensemble
        integer, parameter :: ukminmem =  9 ! min # of UKMET ensemble

cJ.Peng----2010-09-29---------------------------------------------
        integer, parameter :: gcminmem =  2 ! min # of fnmoc ensemble
        integer, parameter :: g0minmem =  8 ! min # of gv ensemble

        integer, parameter :: ccminmem =  2 ! min # of cmc ensemble
        integer, parameter :: c0minmem =  8 ! min # of cmc ensemble


c  integer, parameter :: ecminmem = 20 ! min # of ecmwf ensemble
c  J.Peng----2012-02-28
c  2-member for mean track calculation and at least 4% for probability

        integer, parameter :: ecminmem = 5 ! min # of ecmwf ensemble
                         ! perts needed at a given fcst hr to get a mean
        integer, parameter :: srminmem =  8 ! min # of sref ensemble 
                         ! perts needed at a given fcst hr to get a mean
cJ.Peng-------2010-10-29-------------2010-11-02--------------------------
c        integer, parameter :: c2minmem = 20 ! min # of NCEP+CMC ensemble
c                         ! perts needed at a given fcst hr to get a mean
cJ.Peng------------2010-11-19--------------------------
        integer, parameter :: c2minmem = 22 ! min # of NCEP+CMC ensemble
                         ! perts needed at a given fcst hr to get a mean

        integer, parameter :: c3minmem = 50 ! min # of NCEP+CMC+EC ensemble
        integer, parameter :: n2minmem = 39 ! min # of NCEP+EC ensemble

        integer, parameter :: c4minmem = 61 ! min # of NCEP+CMC+EC+FNMOC
        integer, parameter :: c5minmem = 74 ! min # of NCEP+CMC+EC+FNMOC+UK
        integer, parameter :: n3minmem = 52 ! min # of NCEP+EC+UK

        integer, parameter :: f3minmem = 33 ! min # of NCEP+CMC+FNMOC

        integer, parameter :: s3minmem =  2 ! min # of NCEP+CMC+EC ensemble
        integer, parameter :: p3minmem =  3 ! min # of NCEP+CMC+EC ensemble

        integer, parameter :: d3minmem =  3 ! min # of AVNO+CMC+EMX ensemble
        integer, parameter :: d6minmem =  6 ! min # of AVNO+CMC+EMX+AEMN+.. 
        integer, parameter :: d4minmem =  4 ! min # of AVNO+CMC+EMX+3EMN
        integer, parameter :: d2minmem =  2 ! min # of 3DET+3EMN..

        integer, parameter :: maxstorms  = 15 ! max # storms at a time
        integer, parameter :: maxtimes   = 65 ! max # fcst times (0-384
                                              ! every 6 hrs = 65).
c        integer, parameter :: max_accum_prob_hour = 384 ! Max hour to 
c        integer, parameter :: max_accum_prob_hour = 120 ! Max hour to 
c                              ! which we'll carry out the accum probs
        real, parameter :: grdspc = 1.00      ! grid spacing of our grid
      end module maxparms

      module ensinfo
        USE maxparms
        character*4 :: ncperts(ncmaxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'/)

c        character*4 :: ncperts(ncmaxmem) = (/'GE01','GE02','GE03'
c     &          ,'GE04','GE05','GE06','GE07','GE08','GE09','GE10'
c     &          ,'GE11','GE12','GE13','GE14','GE15','GE16','GE17'
c     &          ,'GE18','GE19','GE20'/)

        character*4 :: n0perts(n0maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'/)

        character*4 :: ukperts(ukmaxmem) = (/'UK01','UK02'
     &   ,'UK03','UK04','UK05','UK06','UK07','UK08','UK09','UK10'
     &          ,'UK11','UK12','UK13','UK14','UK15','UK16','UK17'
     &          ,'UK18','UK19','UK20','UK21','UK22','UK23'/)

c#-------J.Peng----2010-09-29---------------------------------------------
        character*4 :: gcperts(gcmaxmem) = (/'NP01','NP02','NP03'
     &          ,'NP04','NP05','NP06','NP07','NP08','NP09','NP10'
     &          ,'NP11','NP12','NP13','NP14','NP15','NP16','NP17'
     &          ,'NP18','NP19','NP20'/)
        character*4 :: g0perts(g0maxmem) = (/'FP01','FP02','FP03'
     &          ,'FP04','FP05','FP06','FP07','FP08','FP09','FP10'
     &          ,'FP11','FP12','FP13','FP14','FP15','FP16','FP17'
     &          ,'FP18','FP19','FP20'/)


        character*4 :: ccperts(ccmaxmem) = (/'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'/)
        character*4 :: c0perts(c0maxmem) = (/'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'/)

cJ.Peng-------2010-10-29-------------------------------------
        character*4 :: c2perts(c2maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'/)

cJ.Peng-------2010-11-02-------------------------------------------
        character*4 :: c3perts(c3maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'
     &          ,'EN01','EN02','EN03'
     &          ,'EN04','EN05','EN06','EN07','EN08','EN09','EN10'
     &          ,'EN11','EN12','EN13','EN14','EN15','EN16','EN17'
     &          ,'EN18','EN19','EN20','EN21','EN22','EN23','EN24'
     &          ,'EN25','EP01','EP02','EP03','EP04','EP05','EP06'
     &          ,'EP07','EP08','EP09','EP10','EP11','EP12','EP13'
     &          ,'EP14','EP15','EP16','EP17','EP18','EP19','EP20'
     &          ,'EP21','EP22','EP23','EP24','EP25'/)

        character*4 :: n2perts(n2maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'EN01','EN02','EN03'
     &          ,'EN04','EN05','EN06','EN07','EN08','EN09','EN10'
     &          ,'EN11','EN12','EN13','EN14','EN15','EN16','EN17'
     &          ,'EN18','EN19','EN20','EN21','EN22','EN23','EN24'
     &          ,'EN25','EP01','EP02','EP03','EP04','EP05','EP06'
     &          ,'EP07','EP08','EP09','EP10','EP11','EP12','EP13'
     &          ,'EP14','EP15','EP16','EP17','EP18','EP19','EP20'
     &          ,'EP21','EP22','EP23','EP24','EP25'/)

        character*4 :: f3perts(f3maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'
     &          ,'FP01','FP02','FP03'
     &          ,'FP04','FP05','FP06','FP07','FP08','FP09','FP10'
     &          ,'FP11','FP12','FP13','FP14','FP15','FP16','FP17'
     &          ,'FP18','FP19','FP20'/)


        character*4 :: c4perts(c4maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'
     &          ,'EN01','EN02','EN03'
     &          ,'EN04','EN05','EN06','EN07','EN08','EN09','EN10'
     &          ,'EN11','EN12','EN13','EN14','EN15','EN16','EN17'
     &          ,'EN18','EN19','EN20','EN21','EN22','EN23','EN24'
     &          ,'EN25','EP01','EP02','EP03','EP04','EP05','EP06'
     &          ,'EP07','EP08','EP09','EP10','EP11','EP12','EP13'
     &          ,'EP14','EP15','EP16','EP17','EP18','EP19','EP20'
     &          ,'EP21','EP22','EP23','EP24','EP25'
     &          ,'FP01','FP02','FP03'
     &          ,'FP04','FP05','FP06','FP07','FP08','FP09','FP10'
     &          ,'FP11','FP12','FP13','FP14','FP15','FP16','FP17'
     &          ,'FP18','FP19','FP20'/)

        character*4 :: c5perts(c5maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'CP01','CP02','CP03'
     &          ,'CP04','CP05','CP06','CP07','CP08','CP09','CP10'
     &          ,'CP11','CP12','CP13','CP14','CP15','CP16','CP17'
     &          ,'CP18','CP19','CP20'
     &          ,'EN01','EN02','EN03'
     &          ,'EN04','EN05','EN06','EN07','EN08','EN09','EN10'
     &          ,'EN11','EN12','EN13','EN14','EN15','EN16','EN17'
     &          ,'EN18','EN19','EN20','EN21','EN22','EN23','EN24'
     &          ,'EN25','EP01','EP02','EP03','EP04','EP05','EP06'
     &          ,'EP07','EP08','EP09','EP10','EP11','EP12','EP13'
     &          ,'EP14','EP15','EP16','EP17','EP18','EP19','EP20'
     &          ,'EP21','EP22','EP23','EP24','EP25'
     &          ,'FP01','FP02','FP03'
     &          ,'FP04','FP05','FP06','FP07','FP08','FP09','FP10'
     &          ,'FP11','FP12','FP13','FP14','FP15','FP16','FP17'
     &          ,'FP18','FP19','FP20'
     &          ,'UK01','UK02','UK03'
     &          ,'UK04','UK05','UK06','UK07','UK08','UK09','UK10'
     &          ,'UK11','UK12','UK13','UK14','UK15','UK16','UK17'
     &          ,'UK18','UK19','UK20','UK21','UK22','UK23'/)

        character*4 :: n3perts(n3maxmem) = (/'AP01','AP02','AP03'
     &          ,'AP04','AP05','AP06','AP07','AP08','AP09','AP10'
     &          ,'AP11','AP12','AP13','AP14','AP15','AP16','AP17'
     &          ,'AP18','AP19','AP20'
     &          ,'EN01','EN02','EN03'
     &          ,'EN04','EN05','EN06','EN07','EN08','EN09','EN10'
     &          ,'EN11','EN12','EN13','EN14','EN15','EN16','EN17'
     &          ,'EN18','EN19','EN20','EN21','EN22','EN23','EN24'
     &          ,'EN25','EP01','EP02','EP03','EP04','EP05','EP06'
     &          ,'EP07','EP08','EP09','EP10','EP11','EP12','EP13'
     &          ,'EP14','EP15','EP16','EP17','EP18','EP19','EP20'
     &          ,'EP21','EP22','EP23','EP24','EP25'
     &          ,'UK01','UK02','UK03'
     &          ,'UK04','UK05','UK06','UK07','UK08','UK09','UK10'
     &          ,'UK11','UK12','UK13','UK14','UK15','UK16','UK17'
     &          ,'UK18','UK19','UK20','UK21','UK22','UK23'/)

        character*4 :: s3perts(s3maxmem) = (/'EEMN','2EMN'/)
        character*4 :: p3perts(p3maxmem) = (/'EEMN','AEMN','CEMN'/)

        character*4 :: d3perts(d3maxmem) = (/'AVNO',' EMX',' CMC'/)

        character*4 :: d6perts(d6maxmem) = (/'AEMN','CEMN','EEMN'
     &                                      ,'AVNO',' CMC',' EMX'/)

        character*4 :: d4perts(d4maxmem) = (/'AVNO',' EMX',' CMC'
     &                                      ,'3EMN'/)

        character*4 :: d2perts(d2maxmem) = (/'3EMN','3DET'/)


        character*4 :: ecperts(ecmaxmem) = (/'EN01','EN02','EN03'
     &          ,'EN04','EN05','EN06','EN07','EN08','EN09','EN10'
     &          ,'EN11','EN12','EN13','EN14','EN15','EN16','EN17'
     &          ,'EN18','EN19','EN20','EN21','EN22','EN23','EN24'
     &          ,'EN25','EP01','EP02','EP03','EP04','EP05','EP06'
     &          ,'EP07','EP08','EP09','EP10','EP11','EP12','EP13'
     &          ,'EP14','EP15','EP16','EP17','EP18','EP19','EP20'
     &          ,'EP21','EP22','EP23','EP24','EP25'/)
        character*4 :: srperts(srmaxmem) = (/'SEC1','SEC2','SEN1'
     &          ,'SEN2','SEP1','SEP2','SAC1','SAN1','SAN2','SAP1'
     &          ,'SAP2','SRC1','SRN1','SRN2','SRP1','SRP2','SNC1'
     &          ,'SNN1','SNN2','SNP1','SNP2'/)

        integer  :: ncfcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: n0fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: ukfcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
     &               ,108,120,132
     &               ,144,156,168,180,192,204,216,228,240,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

c#-------J.Peng----2010-09-29---------------------------------------------
        integer  :: gcfcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)
        integer  :: g0fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: ccfcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)
        integer  :: c0fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)


cJ.Peng-------2010-10-29-------------------------------------
        integer  :: c2fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)
cJ.Peng-------2010-11-02------------------------------------------
c        integer  :: c3fcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
c     &               ,108,120,132,144,156,168,180,192,204,216,228,240
c     &               ,999,999,999,999,999,999,999,999,999,999,999,999
c     &               ,999,999,999,999,999,999,999,999,999,999,999,999
c     &               ,999,999,999,999,999,999,999,999,999,999,999,999
c     &               ,999,999,999,999,999,999,999,999/)

        integer  :: c3fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: n2fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: f3fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: c4fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: c5fcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
     &               ,108,120,132
     &               ,144,156,168,180,192,204,216,228,240,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: n3fcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
     &               ,108,120,132
     &               ,144,156,168,180,192,204,216,228,240,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: s3fcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
     &               ,108,120,132,144,156,168,180,192,204,216,228,240
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999/)
        integer  :: p3fcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
     &               ,108,120,132,144,156,168,180,192,204,216,228,240
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999/)

        integer  :: d3fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: d6fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: d4fcsthrs(maxtimes) = (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/) 

        integer  :: d2fcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
     &               ,108,120,132,144,156,168,180,192,204,216,228,240
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999/)

c------J.Peng------2011-01-03----------------------------------------
c        integer  :: ecfcsthrs(maxtimes) = (/0,12,24,36,48,60,72,84,96
c     &               ,108,120,132,144,156,168,180,192,204,216,228,240
c     &               ,999,999,999,999,999,999,999,999,999,999,999,999
c     &               ,999,999,999,999,999,999,999,999,999,999,999,999
c     &               ,999,999,999,999,999,999,999,999,999,999,999,999
c     &               ,999,999,999,999,999,999,999,999/)

        integer  :: ecfcsthrs(maxtimes) =  (/0,6,12,18,24,30,36,42,48,54
     &               ,60,66,72,78,84,90,96,102,108,114,120,126,132,138
     &               ,144,150,156,162,168,174,180,186,192,198,204,210
     &               ,216,222,228,234,240,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)

        integer  :: srfcsthrs(maxtimes) = (/0,3,6,9,12,15,18,21,24,27
     &               ,30,33,36,39,42,45,48,51,54,57,60,63,66,69
     &               ,72,75,78,81,84,87,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999,999,999,999,999,999,999,999
     &               ,999,999,999,999,999/)
        character*2, save :: run_basin
      end module ensinfo

      module grid_bounds
cJ.Peng----2012-05-11----------------------------------------
        integer, parameter :: maxbasins = 12
      character*2 :: basin(maxbasins) = (/'AL','EP','WP','HC','CP','SC'
     &                 ,'EC','AU','SP','SI','BB','NA'/)
      real :: xmaxlat(maxbasins) = (/ 40.0, 40.0, 40.0, 40.0,999.0,999.0
     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)
      real :: xminlat(maxbasins) = (/  1.0,  1.0,  1.0,  1.0,999.0,999.0
     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)
      real :: xmaxlon(maxbasins) = (/345.0,345.0,345.0,345.0,999.0,999.0
     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)
      real :: xminlon(maxbasins) = (/105.0,105.0,105.0,105.0,999.0,999.0
     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)

c      real :: xmaxlat(maxbasins) = (/ 60.0, 60.0, 60.0, 60.0,999.0,999.0
c     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)
c      real :: xminlat(maxbasins) = (/  1.0,  1.0,  1.0,  1.0,999.0,999.0
c     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)
c      real :: xmaxlon(maxbasins) = (/345.0,285.0,185.0,345.0,999.0,999.0
c     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)
c      real :: xminlon(maxbasins) = (/250.0,190.0,90.0,110.0,999.0,999.0
c     &                        ,999.0,999.0,999.0,999.0,999.0,999.0/)

      end module grid_bounds

      module trig_vals
        real, save :: pi, dtr
        real, save :: dtk = 111.1949     ! Dist (km) over 1 deg lat
                                         ! using erad=6371.0e+3
        real, save :: erad = 6371.0e+3   ! Earth's radius (m)
        real, save :: ecircum = 40030.2  ! Earth's circumference
                                         ! (km) using erad=6371.e3
        real, save :: omega = 7.292e-5
      end module trig_vals

c
c--------------------------------------------------------------------
c
      program trakave
c
c$$$  MAIN PROGRAM DOCUMENTATION BLOCK
c
c Main Program: TRAKAVE      Get average of ensemble tracks
C   PRGMMR: MARCHOK          ORG: NP22        DATE: 2005-08-01
c
c ABSTRACT: This program reads in the tropical cyclone track files 
c   (in "atcfunix" format) from the various ensemble perturbation
c   members and produces an ensemble mean track.  Currently, the
c   program can handle members from the NCEP, ECMWF and CANADIAN
c   ensembles.
c
c Program history log:
c   2005-08-01  Marchok - Original operational version.
c   2006-08-02  Marchok - Changed pertubation IDs for Canadian ens
c                         (they no longer have "negative" perts).
c   2007-08-08  Marchok - Added code for averaging SREF ensemble tracks.
c
c Input files:
c   unit   11    Text file containing the concatenated atcfunix tracks
c                with all storms for all ensemble members at all 
c                forecast hours.
c
c Output files:
c   unit   52    Opened and closed internally, 1 file for each storm,
c                this series of output files contains the gridded 
c                strike probabilities, both for the individual forecast
c                hours as well as the accumulated probabilities.
c                pt (1,1) is the far NW point on this output grid, 
c                pt (imax,jmax) is the far SE point on this output grid.
c   unit   53    Output atcfunix file with mean ensemble track forecast
c                positions for each storm at each forecast hour.
c   unit   54    Output atcf file with mean ensemble track forecast
c                positions for each storm forecast hours 12-72.
c   unit   55    Output track file with mean ensemble track forecast
c                positions for each storm forecast hours 0-72.
c   unit   56    Output text file with ensemble track forecast spread
c                values for each storm at each forecast hour.
c   unit   57    Output text file with ensemble track forecast mode
c                values for each storm at each forecast hour.
c
c Subprograms called:
c   read_nlists  Read input namelists for input date & storm number info
c
c Attributes:
c   Language: Fortran90
c
c Notes:   
c   maxmem     This is the max number of members expected for a 
c              given Center's ensemble forecast
c   minmem     This is the minimum number of member tracks that need to 
c              exist at a given forecast hour in order to produce a mean
c              
c
c$$$
c
c-------
c
      USE define_atcfunix_rec; USE maxparms; USE trig_vals
      USE ensinfo

      type (atcfunix_card) saverec

      real,allocatable :: traklat(:,:,:)
      real,allocatable :: traklon(:,:,:)
      real    xmeanlat(maxstorms,maxtimes)
      real    xmeanlon(maxstorms,maxtimes)
      real    xspread(maxstorms,maxtimes)
      real    dthresh
      integer  :: fcsthrs(maxtimes)
      integer minmem,maxmem,fcst_interval
      character*4,allocatable :: perts(:)
      character*1 :: do_probs = 'y'
      character*1 :: modeflag = 'y'
      character*4 :: stormarr(maxstorms)
      character*4 :: catcf,catcf_lc
      character*5 :: cmodel
c
      pi = 4. * atan(1.)   ! Both pi and dtr were declared in module
      dtr = pi/180.0       ! trig_vals, but were not yet defined.

      xmeanlat = -9999.0; xmeanlon = -9999.0
      xspread = -999.0

      call read_nlists (dthresh,cmodel)

      select case (cmodel)
        case ('ens');  maxmem = ncmaxmem; fcsthrs(:) = ncfcsthrs(:)
        case ('ensb');  maxmem = n0maxmem; fcsthrs(:) = n0fcsthrs(:)
        case ('ukes');  maxmem = ukmaxmem; fcsthrs(:) = ukfcsthrs(:)

c----------J.Peng----------2010-09-29-------------------------------
c        case ('gve');  maxmem = gcmaxmem; fcsthrs(:) = gcfcsthrs(:)
        case ('fens');  maxmem = gcmaxmem; fcsthrs(:) = gcfcsthrs(:)
        case ('fenb');  maxmem = g0maxmem; fcsthrs(:) = g0fcsthrs(:)

        case ('cens'); maxmem = ccmaxmem; fcsthrs(:) = ccfcsthrs(:)
        case ('cenb'); maxmem = c0maxmem; fcsthrs(:) = c0fcsthrs(:)


cJ.Peng-------2010-10-29--------------2010-11-02---------------
        case ('g2c'); maxmem = c2maxmem; fcsthrs(:) = c2fcsthrs(:)
        case ('gce3'); maxmem = c3maxmem; fcsthrs(:) = c3fcsthrs(:)
        case ('nae2'); maxmem = n2maxmem; fcsthrs(:) = n2fcsthrs(:)

        case ('ncf3'); maxmem = f3maxmem; fcsthrs(:) = f3fcsthrs(:)

        case ('gce4'); maxmem = c4maxmem; fcsthrs(:) = c4fcsthrs(:)
        case ('gce5'); maxmem = c5maxmem; fcsthrs(:) = c5fcsthrs(:)
        case ('neu3'); maxmem = n3maxmem; fcsthrs(:) = n3fcsthrs(:)


        case ('gce3a'); maxmem = s3maxmem; fcsthrs(:) = s3fcsthrs(:)
        case ('gce3b'); maxmem = p3maxmem; fcsthrs(:) = p3fcsthrs(:)

        case ('sing'); maxmem = d3maxmem; fcsthrs(:) = d3fcsthrs(:)
        case ('tot6'); maxmem = d6maxmem; fcsthrs(:) = d6fcsthrs(:)
        case ('tot4'); maxmem = d4maxmem; fcsthrs(:) = d4fcsthrs(:)

        case ('tot2'); maxmem = d2maxmem; fcsthrs(:) = d2fcsthrs(:)

        case ('eens');  maxmem = ecmaxmem; fcsthrs(:) = ecfcsthrs(:)
        case ('sref'); maxmem = srmaxmem; fcsthrs(:) = srfcsthrs(:)
      end select
         
      allocate (traklat(maxstorms,maxmem,maxtimes),stat=itla)
      allocate (traklon(maxstorms,maxmem,maxtimes),stat=itlo)
      allocate (perts(maxmem),stat=ipa)
      if (itla /= 0 .or. itlo /= 0 .or. ipa /= 0) then
        print *,' '
        print *,'!!! ERROR in trakave allocating arrays.'
        print *,'!!! itla = ',itla,' itlo= ',itlo,' ipa= ',ipa
        stop 94
      endif

      traklat = -9999.0;  traklon = -9999.0

      select case (cmodel)
        case ('ens');  perts(:) = ncperts(:)
                       minmem   = ncminmem  
                       catcf    = 'AEMN'  
                       catcf_lc = 'aemn'  
        case ('ensb');  perts(:) = n0perts(:)
                       minmem   = n0minmem
                       catcf    = 'AEMB'
                       catcf_lc = 'aemb'

        case ('ukes');  perts(:) = ukperts(:)
                       minmem   = ukminmem
                       catcf    = 'UKMN'
                       catcf_lc = 'ukmn'

c        case ('gve');  perts(:) = gcperts(:)
c                       minmem   = gcminmem  
c                       catcf    = 'GVMN'  
c                       catcf_lc = 'gvmn'  
c-------J.Peng---------2010-09-29--------------------------
        case ('fens');  perts(:) = gcperts(:)
                       minmem   = gcminmem
c                       catcf    = 'FEMN'
c                       catcf_lc = 'femn'
                       catcf    = 'NEMN'
                       catcf_lc = 'nemn'

        case ('fenb');  perts(:) = g0perts(:)
                       minmem   = g0minmem
                       catcf    = 'FEMB'
                       catcf_lc = 'femb'


        case ('cens'); perts(:) = ccperts(:)
                       minmem   = ccminmem  
                       catcf    = 'CEMN'  
                       catcf_lc = 'cemn'  

        case ('cenb'); perts(:) = c0perts(:)
                       minmem   = c0minmem
                       catcf    = 'CEMB'
                       catcf_lc = 'cemb'

cJ.Peng-------2010-10-29-------------------------------------
        case ('g2c'); perts(:) = c2perts(:)
                       minmem   = c2minmem 
                       catcf    = '2EMN' 
                       catcf_lc = '2emn'
cJ.Peng-------2010-11-02-----------------------------
        case ('gce3'); perts(:) = c3perts(:)
                       minmem   = c3minmem
                       catcf    = '3EMN'
                       catcf_lc = '3emn'

        case ('nae2'); perts(:) = n2perts(:)
                       minmem   = n2minmem
                       catcf    = '2NAE'
                       catcf_lc = '2nae'

        case ('ncf3'); perts(:) = f3perts(:)
                       minmem   = f3minmem
                       catcf    = '3NCF'
                       catcf_lc = '3ncf'

        case ('gce4'); perts(:) = c4perts(:)
                       minmem   = c4minmem
                       catcf    = '4EMN'
                       catcf_lc = '4emn'

        case ('gce5'); perts(:) = c5perts(:)
                       minmem   = c5minmem
                       catcf    = '5EMN'
                       catcf_lc = '5emn'

        case ('neu3'); perts(:) = n3perts(:)
                       minmem   = n3minmem
                       catcf    = '3NEU'
                       catcf_lc = '3neu'

        case ('gce3a'); perts(:) = s3perts(:)
                       minmem   = s3minmem
                       catcf    = 'SEMN'
                       catcf_lc = 'semn'
        case ('gce3b'); perts(:) = p3perts(:)
                       minmem   = p3minmem
                       catcf    = 'PEMN'
                       catcf_lc = 'pemn'

        case ('sing'); perts(:) = d3perts(:)
                       minmem   = d3minmem
                       catcf    = '3DET'
                       catcf_lc = '3det'
        case ('tot6'); perts(:) = d6perts(:)
                       minmem   = d6minmem
                       catcf    = '6EMN'
                       catcf_lc = '6emn'

        case ('tot4'); perts(:) = d4perts(:)
                       minmem   = d4minmem
                       catcf    = 'T4MN'
                       catcf_lc = 't4mn'

        case ('tot2'); perts(:) = d2perts(:)
                       minmem   = d2minmem
                       catcf    = 'S6MN'
                       catcf_lc = 's6mn'


        case ('eens');  perts(:) = ecperts(:)
                       minmem   = ecminmem  
                       catcf    = 'EEMN'  
                       catcf_lc = 'eemn'  
        case ('sref'); perts(:) = srperts(:)
                       minmem   = srminmem  
                       catcf    = 'SFMN'  
                       catcf_lc = 'sfmn'  
      end select
 
      fcst_interval = fcsthrs(2) - fcsthrs(1)

      call read_atcfunix (traklat,traklon,saverec,stormarr,maxmem
     &                   ,fcst_interval,perts)

      do i = 1,maxstorms
        print *,'i= ',i,'  stormarr(i)= ',stormarr(i)
      enddo

      call get_mean_track (traklat,traklon,xmeanlat,xmeanlon
     &            ,stormarr,saverec,maxmem,minmem,catcf,fcsthrs)

      call get_spread (traklat,traklon,xmeanlat,xmeanlon,xspread
     &                ,stormarr,saverec,maxmem,minmem,fcsthrs)

      if (do_probs == 'y') then
        call get_probs (traklat,traklon,xmeanlat,xmeanlon
     &             ,stormarr,saverec%atx_ymdh,dthresh,'indiv'
     &             ,modeflag,catcf,maxmem,fcsthrs,catcf_lc)
        call get_probs (traklat,traklon,xmeanlat,xmeanlon
     &             ,stormarr,saverec%atx_ymdh,dthresh,'accum'
     &             ,modeflag,catcf,maxmem,fcsthrs,catcf_lc)
      endif

      print *,' '
      print *,'NORMAL END TO TRAKAVE....'
      print *,' '

      deallocate (traklat,stat=ictla)
      deallocate (traklon,stat=ictlo)
      deallocate (perts,stat=icpa)

      if (ictla /= 0 .or. ictlo /= 0 .or. icpa /= 0) then
        print *,' '
        print *,'!!! ERROR in trakave deallocating arrays.'
        print *,'!!! ictla = ',ictla,' ictlo= ',ictlo,' icpa= ',icpa
        stop 94
      endif

      stop 
      end

c
c----------------------------------------------------------------------
c
c----------------------------------------------------------------------
      subroutine get_probs (traklat,traklon,xmeanlat,xmeanlon
     &                     ,stormarr,cymdh,dthresh,prob_type
     &                     ,modeflag,catcf,maxmem,fcsthrs,catcf_lc)
c
c     ABSTRACT: This subroutine calculates the probability of a
c     given location (gridpoint) being within a specified distance
c     of an ensemble member trackpoint.  For the domain, we'll sort
c     through all the track points and get the most extreme
c     N, E, S and W points, then add a certain amount onto that on
c     each side.  Then, for all the gridpoints that are included,
c     we'll go one by one to each gridpoint and calculate the 
c     distances from each forecast track point at that hour to 
c     each gridpoint.  If that distance is less than the specified
c     distance threshold, we add it to the total, and then divide
c     that total count by the total number of members to get the 
c     probability at that gridopoint for that forecast hour.
c     
c     NOTE: This particular subroutine can calculate the 
c     probabilities individually for each forecast hour or for
c     the total accumulated probability over the forecast, 
c     depending on the value of the input variable prob_type.
c     If we are doing this for individual cases, then we will
c     also call  get_prob_mode in order to get the ensemble 
c     probability mode and print it out in a separate atcfunix
c     record.


      USE maxparms; USE grid_bounds; USE trig_vals; USE ensinfo

      real  traklat(maxstorms,maxmem,maxtimes)
      real  traklon(maxstorms,maxmem,maxtimes)
      real  xmeanlat(maxstorms,maxtimes)
      real  xmeanlon(maxstorms,maxtimes)
      real, allocatable :: xprob(:,:)
      real  :: xnm_per_degree = 60.0    
      real  xdist,dthresh,xlondiff,xlatdiff,xinterplon,xinterplat
      character*1 :: modeflag,hold_input_modeflag
      character*2 :: cbasin
      character*4 :: stormarr(maxstorms),cstorm,catcf,catcf_lc
      character*5 :: prob_type
      character*10   cymdh
      character*12   cacc
      character*46   outgrfile
      character*33   outtxtfile
      character      cthresh1*1,cthresh2*2,cthresh3*3,cthresh4*4
      integer :: fcsthrs(maxtimes)
      integer  basinix,ifh_interval,ibct
      integer, allocatable :: accum_ct(:,:)
      integer  max_accum_prob_hour
      logical(1),allocatable :: gridpoint_already_hit(:,:,:)
c
c      outtxtfile = 'enstrkprob.'//cymdh//'.ctlinfo.txt'
c      open (unit=51,file=outtxtfile,status='unknown')

      if (catcf_lc == 'sfmn') then
        max_accum_prob_hour = 87   ! SREF max fcst hour = 87 in Aug 2007
      else
c--------J.Peng----2011-01-11---------------------------------------
        max_accum_prob_hour = 48  ! For all others, go out to 120h
      endif

      hold_input_modeflag = modeflag

      stormloop: do ist = 1,maxstorms

        modeflag = hold_input_modeflag

        ! As of June, 2002, we will only compute these probabilities
        ! for storms in the AL, EP and WP basins.  This next code
        ! checks for those basin ID's and will cycle the stormloop
        ! if it's not one of those basins....

        cbasin = stormarr(ist)(1:2)
c--------J.Peng----2012-05-11---------------------------------------
        if (cbasin == 'AL' .or. cbasin == 'EP' .or. cbasin == 'WP' 
     &  .or. cbasin == 'HC') then
          continue
        else
          print *,' '
          print *,'+++ NOTE: In get_probs, we are NOT calculating'
          print *,'+++       the probabilities for storm '
     &                      ,stormarr(ist)
          print *,'+++       It is not in a basin we do probs for.'
          print *,' '
          cycle stormloop
        endif

        ! Get the index for the basin we're in.

        basinix = -99
        ibct = 1
        basinloop: do while (ibct <= maxbasins)
          if (cbasin == basin(ibct)) then
            basinix = ibct
            exit basinloop
          endif
          ibct = ibct + 1
        enddo basinloop
        if (basinix == -99) then
          print *,' '
          print *,'!!! ERROR IN GET_PROBS.  BASIN IS NOT '
          print *,'!!! RECOGNIZED.  BASIN = ',cbasin
          print *,'!!! EXITING....'
          stop 99
        endif

        ! In an older version of this program, we narrowed the area 
        ! over which we computed the probabilities to keep the file 
        ! size smaller, but that meant that each output file had 
        ! different starting and ending points.  In this new version
        ! we just calculate it over the whole basin.

        maxlat = int(xmaxlat(basinix))
        maxlon = int(xmaxlon(basinix))
        minlat = int(xminlat(basinix))
        minlon = int(xminlon(basinix))

        numlat = abs(maxlat-minlat) + 1
        numlon = abs(maxlon-minlon) + 1

        itemp = int(dthresh)
        if (itemp < 10) then
          write (cthresh1,'(i1)') itemp
          outgrfile = catcf_lc//'.trkprob.'//stormarr(ist)//'.'//
     &              cthresh1//'nm.'//cymdh//'.'//prob_type//'.ieee'
        else if (itemp >= 10 .and. itemp < 100) then
          write (cthresh2,'(i2)') itemp
          outgrfile = catcf_lc//'.trkprob.'//stormarr(ist)//'.'//
     &              cthresh2//'nm.'//cymdh//'.'//prob_type//'.ieee'
        else if (itemp >= 100 .and. itemp < 1000) then
          write (cthresh3,'(i3)') itemp
          outgrfile = catcf_lc//'.trkprob.'//stormarr(ist)//'.'//
     &              cthresh3//'nm.'//cymdh//'.'//prob_type//'.ieee'
        else if (itemp >= 1000) then
          write (cthresh4,'(i4)') itemp
          outgrfile = catcf_lc//'.trkprob.'//stormarr(ist)//'.'//
     &              cthresh4//'nm.'//cymdh//'.'//prob_type//'.ieee'
        endif

        print *,' '
        print *,'Before open 52, stormarr(ist) = ',stormarr(ist)
        print *,' '

        if (xmeanlon(ist,1) > 0.0) then
          print *,' '
          print *,'!!! OPEN:  '
          print *,'   open for prob_type = ',prob_type
          print *,'   ist = ',ist,'  xmeanlon = ',xmeanlon(ist,1)
          print *,'   file name = ',outgrfile
          print *,'   dthresh = ',dthresh
          inquire (52,access=cacc) 
          print *,'   cacc 1 = ',cacc
          open (unit=52,file=outgrfile,access='direct'
     &         ,form='unformatted',iostat=ios
     &         ,status='unknown',recl=numlat*numlon*4)
          print *,'   ios = ',ios
          inquire (52,access=cacc) 
          print *,'   cacc 2 = ',cacc
        else
          cycle stormloop
        endif

        cstorm = stormarr(ist)

        if (prob_type == 'indiv') then
          write (51,82) stormarr(ist),cymdh,numlon,minlon,numlat,minlat
        endif

   82   format (a4,1x,a10,' nx= ',i4,' beglon= ',i3
     &                   ,' ny= ',i4,' beglat= ',i3)

        ! Allocate the xprob array.  Pt (1,1) is in the far NW part 
        ! of the subgrid.

        if (.not.allocated(xprob)) then
          allocate (xprob(numlon,numlat),stat=ipa)
          if (ipa /= 0) then
            print *,' '
            print *,'!!! ERROR in sub get_probs allocating xprob array.'
            print *,'!!! ipa = ',ipa
            igpret = 94
            return
          endif
        endif

        if (.not.allocated(gridpoint_already_hit)) then
          allocate (gridpoint_already_hit(numlon,numlat,maxmem)
     &             ,stat=iga)
          if (iga /= 0) then
            print *,' '
            print *,'!!! ERROR in sub get_probs allocating '
            print *,'!!! gridpoint_already_hit array.'
            print *,'!!! iga = ',iga
            igpret = 94
            return
          endif
        endif

        if (.not.allocated(accum_ct)) then
          allocate (accum_ct(numlon,numlat),stat=iaa)
          if (iaa /= 0) then
            print *,' '
            print *,'!!! ERROR in sub get_probs allocating '
            print *,'!!! accum_ct array.'
            print *,'!!! iaa = ',iaa
            igpret = 94
            return
          endif
        endif

        ! Now go through each forecast time and get the
        ! probabilities at each grid point.  We check the xmeanlon
        ! at each forecast time to make sure that we still have a
        ! mean track (i.e., that the forecast isn't over or that
        ! the storm didn't dissipate).
        !
        ! Note below that the indexing of the xprob array will go
        ! so that pt (1,1) is in the upper left (most NW) corner
        ! of the subgrid, and point (maxlon,maxlat) is in the 
        ! lower right (most SE) corner of the subgrid.

        print *,' '
        print *,' '
        print *,'++++++++++++++++++++++++ '
        print *,' +++ NEW STORM +++'
        print *,'++++++++++++++++++++++++ '
        print *,'ist= ',ist,' maxlat= ',maxlat,' minlat= ',minlat
        print *,' '

c--------J.Peng-----2010-10-26---------------------
        gridpoint_already_hit = .false.
        accum_ct = 0

        ifhloop: do ifh = 1,maxtimes

          ifhour = fcsthrs(ifh) 
          print *,' '
          print *,'++++++++++++++++++++++++ '
          print *,' +++ NEW TIME +++'
          print *,'++++++++++++++++++++++++ '
          print *,'ifh= ',ifh,' ist= ',ist,'  forecast hour = ',ifhour

          if (ifhour > max_accum_prob_hour .and. prob_type == 'accum')
     &    then
            print *,' '
            print *,'!!! NOT CALCULATING ACCUM PROBS PAST '
     &             ,max_accum_prob_hour,'hours'
            exit ifhloop
          endif

          if (xmeanlon(ist,ifh) > 0.0) then    ! valid mean fcst at ifh

            xprob = 0.0
            latloop: do jlat = maxlat,minlat,-1

c              print *,'jlat= ',jlat

              jix = maxlat - jlat + 1
              ylat = float(jlat)

              lonloop: do ilon = minlon,maxlon

c                print *,'ilon= ',ilon

                iix = ilon - minlon + 1
                xlon = float(ilon)

                ict = 0
                ipt = 0
                memberloop: do im = 1,maxmem

                  ict = ict + 1
                  if (traklon(ist,im,ifh) > 0.0) then
                    call calcdist (xlon,ylat,traklon(ist,im,ifh)
     &                            ,traklat(ist,im,ifh),dtr,xdist)
                    if (xdist <= dthresh) then
                      if (prob_type == 'accum') then
c--------J.Peng-----2010-10-26---------------------
                        if (gridpoint_already_hit(iix,jix,im)) then
                          continue
                        else
                          accum_ct(iix,jix) = accum_ct(iix,jix) + 1
                          gridpoint_already_hit(iix,jix,im) = .true.
                        endif
c                          accum_ct(iix,jix) = accum_ct(iix,jix) + 1
                      else
                        ipt = ipt + 1
c                        print *,'++YES, dist= ',xdist,' ipt= ',ipt
                      endif
                    endif 
                  endif

                  ! * * * * * * * * * * * * * * * * * * * * * * * * * *
                  ! INTERPOLATE TRACKS FOR "ACCUMULATED" PROBABILITIES:
                  ! For accum probs, interpolate the tracks in between
                  ! time periods to get a smooth track and not miss 
                  ! any "in-between" points.  Don't need to do this for
                  ! the individual, instantaneous track probs at each
                  ! forecast hour.  Currently, since TPC only does their
                  ! accumulated probabilities out to 120h, we will only
                  ! do ours to 120h as well, so don't interpolate if the
                  ! the next forecast hour would be > 120.
                  ! * * * * * * * * * * * * * * * * * * * * * * * * * *

                  if (prob_type == 'accum' .and. ifh < maxtimes .and.
     &                fcsthrs(ifh+1) <= max_accum_prob_hour) then
                    if (traklon(ist,im,ifh)   > 0.0 .and. 
     &                  traklon(ist,im,ifh+1) > 0.0) then
                      ifh_interval = fcsthrs(ifh+1) - fcsthrs(ifh)
                      xlondiff = traklon(ist,im,ifh+1) - 
     &                           traklon(ist,im,ifh)
                      xlatdiff = traklat(ist,im,ifh+1) - 
     &                           traklat(ist,im,ifh)
                      interploop: do iint = 1,ifh_interval-1
                        xinterplon = traklon(ist,im,ifh) + 
     &                               (float(iint)/float(ifh_interval) *
     &                                xlondiff)
                        xinterplat = traklat(ist,im,ifh) + 
     &                               (float(iint)/float(ifh_interval) *
     &                                xlatdiff)
                        call calcdist (xlon,ylat,xinterplon
     &                                ,xinterplat,dtr,xdist)
                        if (xdist <= dthresh) then
c--------J.Peng-----2010-10-26---------------------
                          if (gridpoint_already_hit(iix,jix,im)) then
                            continue
                          else
                            accum_ct(iix,jix) = accum_ct(iix,jix) + 1
                            gridpoint_already_hit(iix,jix,im) = .true.
                          endif
c                            accum_ct(iix,jix) = accum_ct(iix,jix) + 1
                        endif
                      enddo interploop
                    endif
                  endif

                enddo memberloop

                if (maxmem > 0) then
c                  print *,'xprob: ipt= ',ipt,' ict= ',ict,' prob= '
c     &                     ,float(ipt)/float(maxmem)
                  xprob(iix,jix) = float(ipt)/float(maxmem)
                endif

              enddo lonloop

            enddo latloop

c           If the probability type is for an individual forecast hour,
c           then write out the data right now for this hour, and then
c           if the modeflag is set to find the probability mode, call
c           the subroutine  get_prob_mode.

            if (prob_type == 'indiv') then
c              do iii = 1,numlon
c                do jjj = 1,numlat
c                  if (xprob(iii,jjj) > 0.0) then
c                    print *,'HEY, iii= ',iii,' jjj= ',jjj,' xprob= '
c     &                     ,xprob(iii,jjj)
c                  endif
c                enddo
c              enddo 
cccccc-------J.Peng.------2010-09-30--------------------------------
              print *,'JPENG_ifh=',ifh 
              write (52,rec=ifh) ((xprob(i,j),i=1,numlon),j=1,numlat)
              if (modeflag == 'y') then
                call get_prob_mode (numlon,numlat,minlon,maxlon,minlat
     &               ,maxlat,xprob,xmodelon,xmodelat,xmodeval,ifhour
     &               ,cstorm,cymdh,ifh,dthresh,xmeanlon,xmeanlat,ist
     &               ,basinix,catcf,fcsthrs,modeflag)
              endif
            endif

          else

            cycle ifhloop

          endif
              
        enddo ifhloop

        if (prob_type == 'accum') then
          jloop: do jlat = maxlat,minlat,-1
            jix = maxlat - jlat + 1
            ylat = float(jlat)
            iloop: do ilon = minlon,maxlon
              iix = ilon - minlon + 1
              xlon = float(ilon)
              xprob(iix,jix) = float(accum_ct(iix,jix)) /
     &                         float(maxmem)
c              print *,'jix= ',jix,' iix= ',iix,' xprob= ',xprob(iix,jix)
c              write (61,120) jix,iix,float(jlat),float(ilon)
c     &                       ,xprob(iix,jix)
            enddo iloop
          enddo jloop
          irec=1
          write (52,rec=irec) ((xprob(i,j),i=1,numlon),j=1,numlat)
        endif

        deallocate (xprob,stat=icxa)
        if (icxa /= 0) then
          print *,' '
          print *,'!!! ERROR in trakave deallocating xprob array.'
          print *,'!!! icxa = ',icxa
          stop 94
        endif

        close (52)

      enddo stormloop

 120  format (1x,'jix= ',i3,' iix= ',i3,' jlat= ',f6.1,' ilon= '
     &          ,f6.1,' xprob= ',f6.2)

      icgaha = 0
      icaca  = 0

      if (allocated(gridpoint_already_hit)) then
        deallocate (gridpoint_already_hit,stat=icgaha)
      endif

      if (allocated(accum_ct)) then
        deallocate (accum_ct,stat=icaca)
      endif

      if (icgaha /= 0 .or. icaca /= 0) then
        print *,' '
        print *,'!!! ERROR in trakave deallocating gridpoint'
        print *,'!!! or accum_ct arrays.'
        print *,'!!! icgaha = ',icgaha,' icaca= ',icaca
        stop 94
      endif
c
      return
      end
       
c
c----------------------------------------------------------------
c
c----------------------------------------------------------------
      subroutine get_mean_track (traklat,traklon,xmeanlat,xmeanlon
     &              ,stormarr,saverec,maxmem,minmem,catcf,fcsthrs)
c
c     ABSTRACT: This subroutine calculates the mean lat and lon 
c     positions for each storm at each forecast hour.  maxmem is
c     the maximum number of members for a given Center's forecast,
c     while minmem is the minimum number of member tracks that must
c     exist at a given forecast hour in order to produce a forecast
c     track.  Currently, I have this set at ~40% of maxmem, so for
c     NCEP (maxmem=10,minmem=4), CMC (maxmem=16,minmem=6),
c     ECMWF (maxmem=50,minmem=20)

      USE define_atcfunix_rec; USE maxparms

      type (atcfunix_card) saverec

      real  traklat(maxstorms,maxmem,maxtimes)
      real  traklon(maxstorms,maxmem,maxtimes)
      real  xmeanlat(maxstorms,maxtimes)
      real  xmeanlon(maxstorms,maxtimes) 
      integer :: fcsthrs(maxtimes)
      integer pairct
      character*4 :: stormarr(maxstorms)
      character*4 :: catcf
      
c
      print *,' '
      print *,'************************** '
      print *,'*** In get_mean_track.... '
      print *,'************************** '
      print *,' '

      stormloop: do ist = 1,maxstorms

        print *,' '
        print *,'-------------------'
        print *,'storm number = ',ist
        print *,'storm name   = ',stormarr(ist)
        print *,' '

        timeloop: do ifh = 1,maxtimes

          ict = 0
          xlatsum = 0.0
          xlonsum = 0.0

          print *,' '
          print *,' time index (ifh) = ',ifh
          print *,' '

          do imem = 1,maxmem
            if (traklon(ist,imem,ifh) > 0.0) then
              ict = ict + 1
              xlatsum = xlatsum + traklat(ist,imem,ifh)
cJ.Peng------03/27/2015-----------------------------------
c              xlonsum = xlonsum + traklon(ist,imem,ifh)
              if(traklon(ist,imem,ifh) < 30.0) then
                xlonsum = xlonsum + traklon(ist,imem,ifh)+360.0
              else
                xlonsum = xlonsum + traklon(ist,imem,ifh)
              endif
cJ.Peng------03/27/2015-----------------------------------

              print *,'mem= ',imem,' lat= ',traklat(ist,imem,ifh)
     &                            ,' lon= ',traklon(ist,imem,ifh)
            else
              print *,'mem= ',imem,' lat= ',traklat(ist,imem,ifh)
     &                            ,' lon= ',traklon(ist,imem,ifh)
            endif
          enddo


c          pairct = 0
c          if (traklon(ist,1,ifh) > 0.0 .and. traklon(ist,6,ifh) > 0.0)
c     &    then
c            pairct = pairct + 1
c          endif
c          if (traklon(ist,2,ifh) > 0.0 .and. traklon(ist,7,ifh) > 0.0)
c     &    then
c            pairct = pairct + 1
c          endif
c          if (traklon(ist,3,ifh) > 0.0 .and. traklon(ist,8,ifh) > 0.0)
c     &    then
c            pairct = pairct + 1
c          endif
c          if (traklon(ist,4,ifh) > 0.0 .and. traklon(ist,9,ifh) > 0.0)
c     &    then
c            pairct = pairct + 1
c          endif
c          if (traklon(ist,5,ifh) > 0.0 .and. traklon(ist,10,ifh) > 0.0)
c     &    then
c            pairct = pairct + 1
c          endif
c          if (ict > 2 .and. pairct >= 2) then


          if (ict >= minmem) then
            xmeanlat(ist,ifh) = xlatsum / ict
            xmeanlon(ist,ifh) = xlonsum / ict
            print *,'MEAN:  LAT= ',xmeanlat(ist,ifh)
     &                   ,' LON= ',xmeanlon(ist,ifh)
            call output_atcfunix (stormarr(ist),saverec%atx_ymdh
     &           ,xmeanlat(ist,ifh),xmeanlon(ist,ifh),ifh,'mean'
     &           ,-99.0,-99.0,catcf,fcsthrs)
c          else if (ict > 0 .and. ict <= 2) then
          else if (ict > 0 .and. ict < minmem) then
            xmlat = xlatsum / ict
            xmlon = xlonsum / ict
            print *,' '
            print *,'!!! NOT ENOUGH MEMBERS FOR MEAN FOR STORM #',ist
            print *,'!!! STORM NAME = ',stormarr(ist)
            print *,'!!! MODEL NAME = ',catcf
            print *,'!!! NUMBER OF MEMBERS = ',ict,'  TIME INDEX = ',ifh
            print *,'!!! MINIMUM NUMBER OF MEMBERS NEEDED= ',minmem
            print *,'!!! MEAN POSITION WOULD HAVE BEEN: '
            print *,'!!! LAT: ',xmlat,'  LON: ',xmlon
          else
            print *,'!!! UNDEFINED MEAN POSITION !!!'
          endif

        enddo timeloop
c------J.Peng---------2010-09-29------------------------------------
c        if (xmeanlon(ist,1) > 0.0) then
c          call output_atcf (stormarr(ist),xmeanlon,xmeanlat
c     &                      ,saverec%atx_ymdh,ist,catcf)
c          call output_all (stormarr(ist),xmeanlon,xmeanlat
c     &                      ,saverec%atx_ymdh,ist,catcf)
c     &                    
c        endif

      enddo stormloop

      return
      end

c
c------------------------------------------------------------------
c
c------------------------------------------------------------------
      subroutine get_spread (traklat,traklon,xmeanlat,xmeanlon
     &          ,xspread,stormarr,saverec,maxmem,minmem,fcsthrs)
c
c     ABSTRACT: This subroutine calculates the spread of the 
c     ensemble track forecasts, defined as the average distance
c     of the ensemble members to the mean track.

      USE trig_vals; USE maxparms; USE define_atcfunix_rec
      USE ensinfo

      type (atcfunix_card) saverec

      real      traklat(maxstorms,maxmem,maxtimes)
      real      traklon(maxstorms,maxmem,maxtimes)
      real      xmeanlat(maxstorms,maxtimes)
      real      xmeanlon(maxstorms,maxtimes)
      real      xspread(maxstorms,maxtimes)
      real      xdistsum,xdist
      integer :: fcsthrs(maxtimes)
      integer   imemct,ict,ifh_interval,ifhour
      character*4 :: stormarr(maxstorms)
c
      print *,' '
      print *,'************************** '
      print *,'*** In get_spread.... '
      print *,'************************** '
      print *,' '

      ifh_interval = fcsthrs(2) - fcsthrs(1)

      stormloop: do ist = 1,maxstorms

        print *,' '
        print *,'-------------------'
        print *,'Spread calculation '
        print *,'storm number = ',ist
        print *,'storm name   = ',stormarr(ist)
        print *,' '

        timeloop: do ifh = 1,maxtimes

          ifhour = (ifh - 1) * ifh_interval

          print *,' '
          print *,' time index (ifh) = ',ifh,' fhour= '
     &           ,ifhour
          print *,' '

          if (xmeanlat(ist,ifh) > -999.0) then

            ! We have a valid mean for this storm and tau

            xdistsum = 0.0
            imemct   =   0

            write (*,81) 'MEAN:  LAT= ',xmeanlat(ist,ifh)
     &                        ,' LON= ',xmeanlon(ist,ifh)

            do imem = 1,maxmem
              if (traklon(ist,imem,ifh) > 0.0) then
                call calcdist (xmeanlon(ist,ifh),xmeanlat(ist,ifh)
     &              ,traklon(ist,imem,ifh),traklat(ist,imem,ifh)
     &              ,dtr,xdist)
                write (*,83) 'pert:  LAT= ',traklat(ist,imem,ifh)
     &              ,' LON= ',traklon(ist,imem,ifh),'  pert= ',imem
     &              ,'  xdist= ',xdist,' nm'
                xdistsum = xdistsum + xdist
                imemct   = imemct + 1
              endif
            enddo

            if (imemct >= minmem) then
              xspread(ist,ifh) = xdistsum / float(imemct)
              write (*,85) 'SPREAD: ',xspread(ist,ifh),'  nmem= '
     &                    ,imemct,'  ifh= ',ifh
              write (56,95) stormarr(ist),saverec%atx_ymdh,ifhour
     &             ,'SPREAD: ',xspread(ist,ifh),'  nmem= ',imemct
     &             ,'  ifh= ',ifh
            else
              xspread(ist,ifh) = -999.0
              write (*,87) 'SPREAD: NOT ENOUGH MEMBERS, nmem= ',imemct
              write (56,95) stormarr(ist),saverec%atx_ymdh,ifhour
     &                     ,'SPREAD: ',-999.0,'  nmem= ',imemct
     &                     ,'  ifh= ',ifh
            endif
       
          else
 
            write (*,89) 'SPREAD: No mean track for this time'
            write (56,95) stormarr(ist),saverec%atx_ymdh,ifhour
     &                   ,'SPREAD: ',-999.0,'  nmem= ',0
     &                   ,'  ifh= ',ifh
 
          endif

        enddo timeloop

        if (xmeanlat(ist,1) > -999.0) then
          ! We have at least a valid initial time for this storm, so we
          ! should print out the spread array....
          write (65,91) saverec%atx_ymdh,stormarr(ist)
     &                 ,(xspread(ist,ifh),ifh=1,8)
        endif

      enddo stormloop

  81  format (1x,a12,f7.2,2x,a6,f7.2)
  83  format (1x,a12,f7.2,2x,a6,f7.2,2x,a8,i2,2x,a9,f7.2,a3)
  85  format (1x,a8,f7.2,2x,a8,i2,a7,i2)
  87  format (1x,a34,i2)
  89  format (1x,a35)
  91  format (1x,a10,3x,a4,8(3x,f7.2))
  95  format (1x,a4,2x,a10,2x,'fhour= ',i3,3x,a8,f8.2,2x,a8,i2,a7,i2)
      
      return
      end
c
c------------------------------------------------------------------
c
c------------------------------------------------------------------
      subroutine get_prob_mode (numlon,numlat,minlon,maxlon,minlat
     &        ,maxlat,xprob,xmodelon,xmodelat,xmodeval,ifhour
     &        ,cstorm,cymdh,ifh,dthresh,xmeanlon,xmeanlat,ist
     &        ,basinix,catcf,fcsthrs,modeflag)
c
c     ABSTRACT: This subroutine will scan the array of probabilities
c     in order to find the highest probability, or mode.  Since there
c     is a very good chance that you may have bimodal or multimodal
c     cases in which there is more than one probability mode, we need
c     a way to select only one mode.  A barnes analysis, used for 
c     conducting the search, effectively applies a gaussian filter
c     to provide a sort of area-averaged value.  This will help to
c     highlight one area among any other similar areas.
c
c     re      input e-folding radius for barnes analysis
c     ri      input influence radius for searching for min/max

      USE maxparms; USE trig_vals; USE grid_bounds

      real        xprob(numlon,numlat)
      real        rlon(numlon),rlat(numlat)
      real        xmeanlon(maxstorms,maxtimes)
      real        xmeanlat(maxstorms,maxtimes)
      real        re,ri,blat,blon,bval,ctlon,ctlat,dell
      real        tlat,tlon,fixlon,fixlat,dthresh
      real        xmodelon,xmodelat,xmodeval
      integer     fcsthrs(maxtimes)
      integer     numlon,numlat,minlon,minlat,maxlon,maxlat,basinix
     
      character*1 modeflag
      character*4 cstorm,catcf
      character(*) cymdh

c      re   = 150.0
c      ri   = 300.0
      re   = 120.0
      ri   = 240.0
      fmax = -1.0e+10
      dell = grdspc
      nhalf = 3

c     First and foremost we need to check to see if our storm is out
c     of our grid bounds that we have prescribed for this probability
c     mode analysis.  If in fact it is outside those bounds, then
c     quit this analysis and return (this should only happen on very
c     rare occasions, such as if TPC keeps a storm under their control
c     that passes into the central Pacific instead of handing it off
c     to CPHC).

      if (xmeanlon(ist,ifh) > 0.0                 .and.
     &    xmeanlon(ist,ifh) >= xminlon(basinix)   .and.
     &    xmeanlon(ist,ifh) <= xmaxlon(basinix)   .and.
     &    xmeanlat(ist,ifh) >= xminlat(basinix)   .and.
     &    xmeanlat(ist,ifh) <= xmaxlat(basinix)) then
        continue
      else
        print *,' '
        print *,'!!! WARNING: in get_prob_mode, the current storm'
        print *,'!!! mean position is outside the bounds for this'
        print *,'!!! specified ocean domain.  Therefore, we cannot'
        print *,'!!! calculate the mode at this hour.'
        print *,'!!! RETURNING.....'
        print *,' '
        print *,'    Storm info:'
        print *,'       Storm index=         ',ist
        print *,'       Forecast hour index= ',ifh
        print *,'       Mean longitude=      ',xmeanlon(ist,ifh)
        print *,'       Mean latitude=       ',xmeanlat(ist,ifh)
        print *,' '
        print *,'    Grid info:'
        print *,'       basinix= ',basinix
        print *,'       min longitude= ',xminlon(basinix)
        print *,'       max longitude= ',xmaxlon(basinix)
        print *,'       min latitude= ',xminlat(basinix)
        print *,'       max latitude= ',xmaxlat(basinix)
        print *,' '
        return
      endif


c     First we need to be able to narrow our scan.  We will do this
c     by first scanning the array to find the northernmost, southern-
c     most, easternmost and westernmost extent of the probabilities
c     which are > 0.

      mini =  9999
      minj =  9999
      maxi = -9999
      maxj = -9999

      dmax = -1.0e+10
      do i = 1,numlon
        do j = 1,numlat
          if (xprob(i,j) > dmax) then
            dmax = xprob(i,j)
            id   = i
            jd   = j
          endif
          if (xprob(i,j) > 0.0) then
            if (i < mini) mini = i
            if (i > maxi) maxi = i
            if (j < minj) minj = j
            if (j > maxj) maxj = j
          endif
        enddo
      enddo

      print *,' '
      print *,'dmax:  at beg of get_prob_mode, dmax= ',dmax 
      print *,'i= ',id,' j= ',jd
      print *,'mini= ',mini
      print *,'maxi= ',maxi
      print *,'minj= ',minj
      print *,'maxj= ',maxj

      if (mini ==  9999 .or. minj ==  9999 .or. 
     &    maxi == -9999 .or. maxj == -9999) then
        print *,' '
        print *,'!!! ERROR in get_prob_mode, one or more of the max or'
        print *,'!!! min indeces for the xprob array could not '
        print *,'!!! be found.  The xprob array must = 0.'
        print *,'!!! EXITING.... '
        print *,' '
        STOP 99
      endif

c     Load all the lat and lon values into arrays.  Remember that
c     the xprob array goes from upper left (NW) to lower right (SE).

      do i = 1,numlon
        rlon(i) = float(minlon + i - 1)
      enddo

      do j = numlat,1,-1
        jix = numlat - j + 1
        rlat(jix) = float(maxlat - jix + 1)
      enddo

c     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c              First pass through barnes analysis....
c                   
c     For the first round through the  barnes analysis, we use the 
c     full grid resolution, and at each grid point, we look at an
c     area roughly 2x(ri).

      npts = ceiling(ri/(dtk*grdspc)) * 2

      ibct=0
      ibarnes_loopct = 0

c      print *,' '
c      print *,'before first barnes, mini= ',mini,' maxi= ',maxi
c      print *,'before first barnes, minj= ',minj,' maxj= ',maxj
c      print *,'npts= ',npts

      do i = mini,maxi
        do j = minj,maxj

          blon = rlon(i)        
          blat = rlat(j)        

c          write (*,*) ' '
c          write (*,*) ' - - - - - - - - - - - -'
c          write (*,*) ' '
c          write (*,59) cstorm,ifhour
c          write (*,61) 'before 1st barnes, i= ',i,j,blon,360.-blon
c     &                 ,blat,-99.0

          jjbeg = j - npts
          if (jjbeg < 1) jjbeg = 1
          jjend = j + npts
          if (jjend > numlat) jjend = numlat
          iibeg = i - npts
          if (iibeg < 1) iibeg = 1
          iiend = i + npts
          if (iiend > numlon) iiend = numlon

          ibct = ibct + 1
          call barnes (blon,blat,rlon,rlat,numlon,numlat,iibeg,jjbeg
     &                ,iiend,jjend,xprob,re,ri,bval,icount)

c          write (*,61) 'after  1st barnes, i= ',i,j,blon,360.-blon
c     &                 ,blat,bval

          ibarnes_loopct = ibarnes_loopct + icount

          if (bval > fmax) then
            fmax  = bval
            ctlon = blon
            ctlat = blat
          endif

        enddo
      enddo

  59  format (1x,'Storm= ',a4,'  forecast hour= ',i4)
  61  format (1x,a22,i3,' j= ',i3,' blon= ',f7.2,'E (',f7.2,'W) blat= '
     &       ,f7.2,' bval= ',f10.6)

      print *,' '
      print *,'++++ FIRST BARNES LOOP COMPLETED ++++'
      print *,' '
      print *,'After first loop, # calls to barnes = ',ibct
      print *,'Total # of internal barnes loop iterations = '
     &       ,ibarnes_loopct

      write (*,59) cstorm,ifhour
      write (6,63) ctlon,360.-ctlon,ctlat,fmax
  63  format (' After first run, ctlon= ',f8.3,'E (',f8.3,'W) ctlat= '
     &       ,f8.3,' barnval = ',f10.6)
      print *,' '

      if (ctlon <= xminlon(basinix) .or. ctlon >= xmaxlon(basinix) .or.
     &    ctlat <= xminlat(basinix) .or. ctlat >= xmaxlat(basinix)) then
        print *,' '
        print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        print *,'!!! EXIT: In get_prob_mode, the mode position that '
        print *,'!!! was found after 1 iteration of the barnes loop is'
        print *,'!!! equal to or greater than 1 of the boundaries, '
        print *,'!!! meaning that we are pushing up against the'
        print *,'!!! boundary with our search and it is possible that'
        print *,'!!! we are not finding the true mode.'
        print *,'!!! '
        print *,'!!! ctlon= ',ctlon,'  ctlat= ',ctlat
        print *,'!!! grid minlon = ',xminlon(basinix)
        print *,'!!! grid maxlon = ',xmaxlon(basinix)
        print *,'!!! grid minlat = ',xminlat(basinix)
        print *,'!!! grid maxlat = ',xmaxlat(basinix)
        print *,'!!! '
        print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        modeflag = 'n'
        return
      endif

c     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c              Second pass through barnes analysis....
c                   
c     Now that we've gotten a first estimate of the position, we 
c     go through this 3 more times, cutting the grid resolution
c     in half each time through in order to sharpen the estimate.
c     Cut the number of points (npts) in half from what we looked
c     at in the first barnes iteration so that our first position 
c     estimate is restricted from moving too much.

      npts = ceiling(ri/(dtk*grdspc))

      ibct = 0
      ibarnes_loopct = 0
      kloop: do k = 1,nhalf

        dell = 0.5*dell
        tlon = ctlon
        tlat = ctlat
        fmax = -1.0e+15

        print *,' '
        write (*,67) k,ctlon,360.-ctlon,ctlat
 67     format (1x,'In second barnes loop, k= ',i3,' ctlon= ',f8.3
     &         ,'E (',f8.3,'W) ctlat= ',f8.3)
        print *,' '

        jloop: do j = -npts,npts

          blat = tlat + dell*float(j)
         
          if (blat > float(maxlat) .or. blat < float(minlat)) then
            print *,' '
            print *,'!!! WARNING: In get_prob_mode 2nd barnes loop for'
            print *,'!!! nhalf = ',nhalf,', blat is outside of the '
            print *,'!!! grid lat bounds.  blat= ',blat
            print *,'!!! maxlat= ',maxlat,' minlat= ',minlat
            cycle jloop
          endif

          iloop: do i = -npts,npts

            blon = tlon + dell*float(i)

            if (blon > float(maxlon) .or. blon < float(minlon)) then
              print *,' '
              print *,'!!! WARNING: In get_prob_mode 2nd barnes loop' 
              print *,'!!! for nhalf = ',nhalf,', blon is outside of'
              print *,'!!! the grid lon bounds.  blon= ',blon
              print *,'!!! maxlon= ',maxlon,' minlon= ',minlon
              cycle iloop
            endif
      
            ifix = int(blon - float(minlon)) + 1
            jfix = int(float(maxlat) - blat) + 1

c            write (*,*) ' '
c            write (*,*) ' - - - - - - - - - - - -'
c            write (*,*) ' '
c            write (*,59) cstorm,ifhour
c            write (*,71) 'before 2nd barnes, ifix= ',ifix,jfix,k,blon
c     &                   ,360.-blon,blat,-99.0

            ! We cut npts in half so that the center position is
            ! restricted from moving too much in this refinement,
            ! but we need to double it here to make sure we 
            ! include enough points in the  barnes analysis.

            jjbeg = jfix - (npts*2)
            if (jjbeg < 1) jjbeg = 1
            jjend = jfix + (npts*2)
            if (jjend > numlat) jjend = numlat
            iibeg = ifix - (npts*2)
            if (iibeg < 1) iibeg = 1
            iiend = ifix + (npts*2)
            if (iiend > numlon) iiend = numlon

            ibct = ibct + 1
            call barnes (blon,blat,rlon,rlat,numlon,numlat,iibeg,jjbeg
     &                  ,iiend,jjend,xprob,re,ri,bval,icount)

c            write (*,71) 'after  2nd barnes, ifix= ',ifix,jfix,k,blon
c     &                   ,360.-blon,blat,bval

            ibarnes_loopct = ibarnes_loopct + icount

            if (bval > fmax) then
              fmax  = bval
              ctlon = blon
              ctlat = blat
            endif

          enddo iloop

        enddo jloop

        write (6,73) k,ctlon,360.-ctlon,ctlat,fmax

        if (ctlon <= xminlon(basinix) .or. ctlon >= xmaxlon(basinix) 
     &      .or. ctlat <= xminlat(basinix) 
     &      .or. ctlat >= xmaxlat(basinix)) then
          print *,' '
          print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
          print *,'!!! EXIT: In get_prob_mode, the mode position that '
          print *,'!!! was found after iteration nhalf= ',k,' of the '
          print *,'!!! barnes loop is equal to or greater than 1 of the'
          print *,'!!! boundaries, meaning that we are pushing up '
          print *,'!!! against the boundary with our search and it is'
          print *,'!!! possible that we are not finding the true mode.'
          print *,'!!! '
          print *,'!!! ctlon= ',ctlon,'  ctlat= ',ctlat
          print *,'!!! grid minlon = ',xminlon(basinix)
          print *,'!!! grid maxlon = ',xmaxlon(basinix)
          print *,'!!! grid minlat = ',xminlat(basinix)
          print *,'!!! grid maxlat = ',xmaxlat(basinix)
          print *,'!!! '
          print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
          modeflag = 'n'
          return
        endif

      enddo kloop

 71   format (1x,a25,i3,' jfix= ',i3,' k= ',i2,' blon= ',f7.2,'E ('
     &       ,f7.2,'W) blat= ',f7.2,' bval= ',f10.6)

 73   format (' nhalf barnes, k= ',i2,' ctlon= ',f8.3,'E (',f8.3
     &       ,'W)  ctlat= ',f8.3,' barnval = ',f10.6)

      print *,' '
      print *,'++++ SECOND BARNES LOOP COMPLETED ++++'
      print *,' '
      print *,'After second loop, # calls to barnes = ',ibct
      print *,'Total # of internal barnes loop iterations = '
     &       ,ibarnes_loopct

      write (*,59) cstorm,ifhour
      write (6,77) ctlon,360.-ctlon,ctlat,fmax
 77   format (' After second run, ctlon= ',f8.3,'E (',f8.3,'W) ctlat= '
     &       ,f8.3,' barnval = ',f10.6)
      print *,' '
      print *,'+ + + + + + + + + + + + + + + + + + + '

      xmodelon = ctlon
      xmodelat = ctlat
      bmaxval  = fmax


c     We have now gotten the position of the max probability, or
c     the mode, using the  barnes analysis.  This barnes analysis,
c     however, gives us essentially an area-averaged value.  But
c     what we really need is the actual raw probability value 
c     calculated previously in this program.  So we will look at
c     the eight gridpoints surrounding the lat/lon value obtained
c     by the  barnes analysis and pick out the max raw value.
c     For the  output atcfunix mode record, however, we will use
c     the lat/lon position obtained through the barnes analysis.

      print *,' '
      print *,' Getting (i,j) location of max prob mode....'
      print *,' numlon= ',numlon,'  numlat= ',numlat
      print *,' ifix= ',ifix,' jfix= ',jfix
      print *,' '

      ifix = int(ctlon - float(minlon)) + 1
      jfix = int(float(maxlat) - ctlat) + 1

      fmax = -1.0e+15

      if (xprob(ifix,jfix) > fmax) then
        ihold = ifix
        jhold = jfix
        fmax  = xprob(ifix,jfix)
      endif

      if (ifix < numlon) then
        ! Check the point just *east* of our 
        ! found mode position....
        if (xprob(ifix+1,jfix) > fmax) then
          ihold = ifix+1
          jhold = jfix
          fmax  = xprob(ifix+1,jfix)
        endif
      endif

      if (ifix > 1) then
        ! Check the point just *west* of our
        ! found mode position....
        if (xprob(ifix-1,jfix) > fmax) then
          ihold = ifix-1        
          jhold = jfix 
          fmax  = xprob(ifix-1,jfix)
        endif
      endif

      if (jfix < numlat) then
        ! Check the point just *south* of our 
        ! found mode position (remember: j=1 is
        ! the northernmost point....)
        if (xprob(ifix,jfix+1) > fmax) then
          ihold = ifix
          jhold = jfix+1
          fmax  = xprob(ifix,jfix+1)
        endif
      endif

      if (jfix > 1) then
        ! Check the point just *north* of our
        ! found mode position (remember: j=1 is
        ! the northernmost point....)
        if (xprob(ifix,jfix-1) > fmax) then
          ihold = ifix
          jhold = jfix-1
          fmax  = xprob(ifix,jfix-1)
        endif
      endif

      if (ifix < numlon .and. jfix > 1) then
        ! Check the point just *northeast* of our
        ! found mode position (remember: j=1 is
        ! the northernmost point....)
        if (xprob(ifix+1,jfix-1) > fmax) then
          ihold = ifix+1
          jhold = jfix-1
          fmax  = xprob(ifix+1,jfix-1)
        endif
      endif

      if (ifix < numlon .and. jfix < numlat) then
        ! Check the point just *southeast* of our
        ! found mode position (remember: j=1 is
        ! the northernmost point....)   
        if (xprob(ifix+1,jfix+1) > fmax) then
          ihold = ifix+1   
          jhold = jfix+1
          fmax  = xprob(ifix+1,jfix+1)
        endif
      endif

      if (ifix > 1 .and. jfix < numlat) then
        ! Check the point just *southwest* of our
        ! found mode position (remember: j=1 is
        ! the northernmost point....)   
        if (xprob(ifix-1,jfix+1) > fmax) then
          ihold = ifix-1   
          jhold = jfix+1
          fmax  = xprob(ifix-1,jfix+1)
        endif
      endif
        
      if (ifix > 1 .and. jfix > 1) then
        ! Check the point just *northwest* of our
        ! found mode position (remember: j=1 is
        ! the northernmost point....)
        if (xprob(ifix-1,jfix-1) > fmax) then
          ihold = ifix-1
          jhold = jfix-1
          fmax  = xprob(ifix-1,jfix-1)
        endif
      endif

      fixlon   = float(minlon + ihold - 1)
      fixlat   = float(maxlat - jhold + 1)
      xmodeval = fmax

      print *,' '
      print *,' Location (i,j) of max mode: '
      print *,'   i-location: ',ihold,'  fixlon: ',fixlon
      print *,'   j-location: ',jhold,'  fixlat: ',fixlat
      print *,'   fmax = xmodeval = ',xmodeval
      print *,' '

      print *,' '
      print *,'At end of get_prob_mode, '
      write (*,59) cstorm,ifhour
      write (*,81) ctlat,xmodelat
      write (*,83) ctlon,360.-ctlon,xmodelon,360.-xmodelon
      write (*,85) bmaxval,xmodeval
 81   format (1x,'Barnes lat: ',f7.2,'              fixlat: ',f7.2)
 83   format (1x,'Barnes lon: ',f7.2,'E (',f7.2,'W)  fixlon: '
     &       ,f7.2,'E (',f7.2,'W)')
 85   format (1x,'Barnes val: ',f10.6,'  fixval: ',f10.6)
      print *,'ifix= ',ihold,' jfix= ',jhold


c     Now make a call to output_atcfunix to create an output
c     atcfunix record for this mode value....

      call output_atcfunix (cstorm,cymdh,xmodelat,xmodelon
     &               ,ifh,'mode',xmodeval,dthresh,catcf,fcsthrs)
     
c
      return
      end

c
c----------------------------------------------------------------
c
c----------------------------------------------------------------
      subroutine barnes(flon,flat,rlon,rlat,imax,jmax,iibeg,jjbeg
     &                 ,iiend,jjend,fxy,re,ri,favg,icount)
c
c     ABSTRACT: This routine performs a single-pass barnes anaylsis
c     of fxy at the point (flon,flat). The e-folding radius (km)
c     and influence radius (km) are re and ri, respectively.
c
c     NOTE:  The input grid that is searched in this subroutine is most
c     likely NOT the model's full, original grid.  Instead, a smaller
c     subgrid of the original grid is searched, which is determined by
c     the npts value passed into this subroutine. 
c
c     INPUT:
c     flon    Lon value for center point about which barnes anl is done
c     flat    Lat value for center point about which barnes anl is done
c     rlon    Array of lon values for each grid point
c     rlat    Array of lat values for each grid point
c     imax    Max number of pts in x-direction on input grid
c     jmax    Max number of pts in y-direction on input grid
c     iibeg   i index for grid point to start barnes anlysis (upp left)
c     jjbeg   j index for grid point to start barnes anlysis (upp left)
c     iiend   i index for last grid point in barnes anlysis (low right)
c     jjend   j index for last grid point in barnes anlysis (low right)
c     fxy     Real array of data on which to perform barnes analysis
c     re      input e-folding radius for barnes analysis
c     ri      input influence radius for searching for min/max
c
c     OUTPUT:
c     favg    Average value about the point (flon,flat)
c
      real      fxy(imax,jmax), rlon(imax), rlat(jmax)
      real      flon,flat,favg,res,re,ri,wts,dist,wt

c     --------------------------

      res = re*re
      wts = 0.0
      favg = 0.0

      icount = 0

c      write (*,62) iibeg,iiend,jjbeg,jjend
c 62   format (1x,'in barnes, iibeg= ',i3,' iiend= ',i3,' jjbeg= ',i3
c     &       ,' jjend= ',i3)

      do j=jjbeg,jjend
        do i=iibeg,iiend

          icount = icount + 1

          ! Call a different version of calcdist in order to
          ! get the distance in km....

          call calcdistkm(flon,flat,rlon(i),rlat(j),dist)

c          write (*,65) i,j,flon,flat,rlon(i),rlat(j),dist

          if (dist .gt. ri) cycle

c          write (*,66) i,j,flon,flat,rlon(i),rlat(j),dist,fxy(i,j)
c          print *,'+++ dist= ',dist,' fxy= ',fxy(i,j)

          wt   = exp(-1.0*dist*dist/res)
          wts  = wts + wt
          favg = favg + wt*fxy(i,j)

        enddo
      enddo

 65   format (1x,'i= ',i3,' j= ',i3,' flon= ',f6.2,' flat= ',f5.2
     &       ,' rlon(i)= ',f6.2,' rlat(j)= ',f5.2,' dist= ',f7.2)
 66   format (1x,'i= ',i3,' j= ',i3,' flon= ',f6.2,' flat= ',f5.2
     &       ,' rlon(i)= ',f6.2,' rlat(j)= ',f5.2,' dist= ',f7.2
     &       ,' fxy= ',f5.2)

c      write (*,75) 'in barnes before averaging, wts = ',wts,'  favg= '
c     &             ,favg

      if (wts .gt. 1.0E-5) then
         favg = favg/wts
      else
         favg = 0.0
      endif
      iret = 0

c      write (*,75) 'in barnes after  averaging, wts = ',wts,'  favg= '
c     &             ,favg

 75   format (1x,a34,f9.4,a8,f10.6)

c
      return
      end

c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine calcdistkm(rlonb,rlatb,rlonc,rlatc,xdist)
c
c     ABSTRACT: This subroutine computes the distance between two
c               lat/lon points by using spherical coordinates to
c               calculate the great circle distance between the points.
c                       Figure out the angle (a) between pt.B and pt.C,
c             N. Pole   then figure out how much of a % of a great
c               x       circle distance that angle represents.
c              / \
c            b/   \     cos(a) = (cos b)(cos c) + (sin b)(sin c)(cos A)
c            /     \
c        pt./<--A-->\c     NOTE: The latitude arguments passed to the
c        B /         \           subr are the actual lat vals, but in
c                     \          the calculation we use 90-lat.
c               a      \
c                       \pt.  NOTE: You may get strange results if you:
c                         C    (1) use positive values for SH lats AND
c                              you try computing distances across the
c                              equator, or (2) use lon values of 0 to
c                              -180 for WH lons AND you try computing
c                              distances across the 180E meridian.
c
c     NOTE: In the diagram above, (a) is the angle between pt. B and
c     pt. C (with pt. x as the vertex), and (A) is the difference in
c     longitude (in degrees, absolute value) between pt. B and pt. C.
c
c     !!! NOTE !!! -- THE PARAMETER ecircum IS DEFINED (AS OF THE
c     ORIGINAL WRITING OF THIS SYSTEM) IN KM, NOT M, SO BE AWARE THAT
c     THE DISTANCE RETURNED FROM THIS SUBROUTINE IS ALSO IN KM.
c
      USE trig_vals
c
      if (rlatb < 0.0 .or. rlatc < 0.0) then
        pole = -90.
      else
        pole = 90.
      endif
c
      distlatb = (pole - rlatb) * dtr
      distlatc = (pole - rlatc) * dtr
      difflon  = abs( (rlonb - rlonc)*dtr )
c
      cosanga = ( cos(distlatb) * cos(distlatc) +
     &            sin(distlatb) * sin(distlatc) * cos(difflon))

c     This next check of cosanga is needed since I have had ACOS crash
c     when calculating the distance between 2 identical points (should
c     = 0), but the input for ACOS was just slightly over 1
c     (e.g., 1.00000000007), due to (I'm guessing) rounding errors.

      if (cosanga > 1.0) then
        cosanga = 1.0
      endif
c added on 04/28/2016--------------------------
      if (cosanga < -1.0) then
        cosanga = -1.0
      endif
c added on 04/28/2016--------------------------

      degrees    = acos(cosanga) / dtr
      circ_fract = degrees / 360.
      xdist      = circ_fract * ecircum

c     NOTE: whether this subroutine returns the value of the distance
c           in km or m depends on the scale of the parameter ecircum.
c           At the original writing of this subroutine (7/97), ecircum
c           was given in km.

      return
      end

c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine read_atcfunix (traklat,traklon,saverec,stormarr,maxmem
     &                         ,fcst_interval,perts)
c
c     ABSTRACT: This subroutine reads in the atcfunix records from
c     the concatenated file that contains all these records for all 
c     storms, all forecast hours and all ensemble members.

      USE define_atcfunix_rec; USE maxparms; USE ensinfo
      USE grid_bounds
c
      type (atcfunix_card) inprec,saverec

      real    traklat(maxstorms,maxmem,maxtimes)
      real    traklon(maxstorms,maxmem,maxtimes)
      integer maxmem,fcst_interval
      character*4   perts(maxmem)
      character*4   atcfid,stormarr(maxstorms)
      character*1   foundstorm,foundmember,foundmodel
c
      stormarr = 'XXXX'

      ict = 0
      istot = 0
      readloop: do while (.true.)

        read (11,85,end=870) inprec

        if (ict == 0) then
          saverec = inprec
          ict = ict + 1
        endif

        atcfid(1:2) = inprec%atx_basin
        atcfid(3:4) = inprec%atx_storm_num

c       Find the array index for the storm that is being read in.  As 
c       we encounter a new storm in the atcfunix file, we add that 
c       storm to the array and increment the index (istix) by 1.

        foundstorm = 'n'
        stormloop: do istorm = 1,maxstorms
          if (atcfid == stormarr(istorm)) then
            foundstorm = 'y'
            istix = istorm
            exit stormloop
          endif
        enddo stormloop
        if (foundstorm == 'n') then
          istot = istot + 1
          istix = istot
          stormarr(istix) = atcfid
        endif

c       Similarly, find the lat/lon array index for the ensemble member
c       that is being read in.  The members are specified in a module.
c       If the program cannot find the member, chances are the ensemble
c       suite has been updated and new members have been added.

        foundmember = 'n'
        memberloop: do imem = 1,maxmem
          if (inprec%atx_model == perts(imem)) then
            foundmodel = 'y'
            imix = imem
            exit memberloop
          endif
        enddo memberloop
        if (foundmodel == 'n') then
          print *,' '
          print *,'!!! ERROR: IN PROGRAM TRAKAVE, A MODEL/MEMBER NAME'
          print *,'!!!        IS NOT RECOGNIZED.'
          print *,'!!!       '
          print *,'!!!        MODEL/MEMBER NAME = --->'
     &                              ,inprec%atx_model,'<----'
          print *,'!!!       '
          print *,'!!! STOPPING PROGRAM....      '
          print *,'!!!       '
          stop 990
        endif 

c       Calculate the index (ifix) for the forecast hour in lat and
c       lon arrays.

        ifix = (inprec%atx_fcsthr / fcst_interval) + 1

c       Check the lat/lon arrays to see if we've already read in the
c       lat/lon positions for this storm/member/forecast_time (traklat
c       and traklon are initialized to -9999.0).  Yes, it is possible
c       to have more than 1 record for a given storm/member/time, 
c       since there are up to 3 different records written out for each
c       forecast time, each containing the 34-, 50- and 64-kt wind 
c       radii.  Note that if the values read in are zeroes, that means
c       that the tracker could not find the storm; consider these 
c       missing values and ignore them. 

        if (traklat(istix,imix,ifix) < -9998.0 .and. 
     &      traklon(istix,imix,ifix) < -9998.0) then

          if (inprec%atx_lat > 0 .and. inprec%atx_lon > 0) then

            ! Float the integer latitudes and convert any positive 
            ! southern latitudes to be negative.

            if (inprec%atx_latns == 'N') then
              traklat(istix,imix,ifix) = float(inprec%atx_lat)/10.0
            else
              traklat(istix,imix,ifix) = float(inprec%atx_lat)/(-10.0)
            endif

            ! Float the integer longitudes and convert any "western" 
            ! longitudes to be "eastern", 0-360.

            if (inprec%atx_lonew == 'E') then
              traklon(istix,imix,ifix) = float(inprec%atx_lon)/10.0
            else
              traklon(istix,imix,ifix) = float(3600 - inprec%atx_lon)
     &                                        / 10.0
            endif

          endif
  
        endif

      enddo readloop

C      close (11)
cPENG bug fixed on 04/20/2018-----------------------
 85   format (a2,2x,a2,2x,a10,2x,a2,2x,a4,2x,i3,2x,i3,a1,2x,i4,a1,2x
     &       ,i3,2x,i4,2x,a2,3x,i2,2x,a3,4(2x,i4))
c   85 format (a2,2x,a2,2x,a10,2x,a2,2x,a4,2x,i3,2x,i3,a1,2x,i4,a1,2x
c     &       ,i3,2x,i4,2x,a2,2x,i2,2x,a3,4(2x,i3))

  870 goto 1090

 1010 print *,' '
      print *,'!!! ERROR opening input file.  ERROR = ',ios
      print *,' '

 1090 continue

      return
      end

c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine calcdist(rlonb,rlatb,rlonc,rlatc,dtr,xdist)
c
c     ABSTRACT: This subroutine computes the distance between two
c               lat/lon points by using spherical coordinates to
c               calculate the great circle distance between the points.
c                       Figure out the angle (a) between pt.B and pt.C,
c             N. Pole   then figure out how much of a % of a great
c               x       circle distance that angle represents.
c              / \
c            b/   \     cos(a) = (cos b)(cos c) + (sin b)(sin c)(cos A)
c            /     \
c        pt./<--A-->\c     NOTE: The latitude arguments passed to the
c        B /         \           subr are the actual lat vals, but in
c                     \          the calculation we use 90-lat.
c               a      \
c                       \pt.  NOTE: You may get strange results if you:
c                         C    (1) use positive values for SH lats AND
c                              you try computing distances across the
c                              equator, or (2) use lon values of 0 to
c                              -180 for WH lons AND you try computing
c                              distances across the 180E meridian.
c
c     NOTE: In the diagram above, (a) is the angle between pt. B and
c     pt. C (with pt. x as the vertex), and (A) is the difference in
c     longitude (in degrees, absolute value) between pt. B and pt. C.
c
c     !!! NOTE !!! -- THE PARAMETER ecircum IS DEFINED (AS OF THE
c     WRITING OF THIS SYSTEM) IN NM, NOT M or KM, SO BE AWARE THAT
c     THE DISTANCE RETURNED FROM THIS SUBROUTINE IS ALSO IN NM.
c
      real :: dtk = 60.005       ! Dist (nm) over 1 deg lat
                                 ! using erad=6371.0e+3 km
      real :: erad = 6371.0e+3   ! Earth's radius (m)
      real :: ecircum = 21601.8  ! Earth's circumference
                                 ! (nm) using erad=6371.e3
      real    dtr
c
      if (rlatb < 0.0 .or. rlatc < 0.0) then
        pole = -90.
      else
        pole = 90.
      endif
c
      distlatb = (pole - rlatb) * dtr
      distlatc = (pole - rlatc) * dtr
      difflon  = abs( (rlonb - rlonc)*dtr )
c
      cosanga = ( cos(distlatb) * cos(distlatc) +
     &            sin(distlatb) * sin(distlatc) * cos(difflon))

c     This next check of cosanga is needed since I have had ACOS crash
c     when calculating the distance between 2 identical points (should
c     = 0), but the input for ACOS was just slightly over 1
c     (e.g., 1.00000000007), due to (I'm guessing) rounding errors.

      if (cosanga > 1.0) then
        cosanga = 1.0
      endif
c added on 04/28/2016--------------------------
      if (cosanga < -1.0) then
        cosanga = -1.0
      endif
c added on 04/28/2016--------------------------

      degrees    = acos(cosanga) / dtr
      circ_fract = degrees / 360.
      xdist      = circ_fract * ecircum

c     NOTE: whether this subroutine returns the value of the distance in
c           km, m or nm depends on the scale of the parameter ecircum.
c           At the original writing of this subroutine (2/01), ecircum
c           was given in nm.

      return
      end

c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine output_atcfunix (stormid,cymdh,outlat,outlon,ifh
     &                           ,ctype,xprob,dthresh,catcf,fcsthrs)
c
c     ABSTRACT: This subroutine  outputs a 1-line message for a given
c     storm at an input forecast hour in the new ATCF UNIX format.
c     Unlike the old atcf DOS format in which you waited until the
c     whole tracking was over to write the  output for all forecast
c     hours, with this atcfunix format, each time we are calling this
c     subroutine, it is to only write out 1 record, which will be the
c     fix info for a particular storm at a given time.  
c
c     While this new atcfunix format contains much more information than
c     the old 1-line atcf dos message, for the purposes of the ensemble
c     mean track, we will only use the slots for storm location and NOT
c     worry about the intensity parameters.  An example is shown below:
c
c     AL, 13, 2000092500, 03, AEMN, 036, 243N, 675W
c
c     NOTE: The longitudes that are passed into this subroutine are
c     given in 0 - 360, increasing eastward.  The format for the
c     atcfunix system requires that the  output be 0-180E or
c     0-180W, so we must adjust the values, if needed.  Also, the
c     values for southern latitudes must be positive (use 'N' and
c     'S' to distinguish Northern/Southern Hemispheres).
c
c     INPUT:
c     stormid   Storm ID (EP02, AL13, etc...)
c     cymdh     initial date/time of forecast (yyyymmddhh)
c     outlat    latitude fix position for this storm at this time
c               which is to be written out to the  output file
c     outlon    longitude fix position for this storm at this time
c               which is to be written out to the  output file
c     ifh       the index for the current forecast hour being output
c     ctype     'mean' for ens mean, 'mode' for ens prob mode
c     xprob     prob mode value for ctype = 'mode'. Not used for mean
c     dthresh   distance threshold used for prob mode value, to be 
c               used in model output name for 'mode' case.
c
c     LOCAL:
c     intlon    integer that holds the value of outlon*10
c     intlat    integer that holds the value of outlat*10
c
      USE ensinfo; USE maxparms

      real    outlon,outlat,xprob
      integer fcsthrs(maxtimes)
      integer intlon,intlat
      character*1  clatns,clonew
      character*2  basinid,stormnum
      character*4  stormid,ctype,cmode,catcf
      character*10 cymdh
      character*37 outatxfile

c     First convert all of the lat/lon values from reals into integers.
c     These integer values must be 10x their real value (eg. 125.4 will
c     be written out as 1254).  Convert the lon values so that they go
c     from 0-180E or 0-180W, and convert the lat values so that they are
c     positive and use 'N' or 'S' to differentiate hemispheres.

C      outatxfile = 'aemn.'//cymdh//'.cyclone.trackatcfunix'
C      open (unit=53,file=outatxfile,status='unknown',position='append')

      if (outlon < -998.0 .or. outlat < -998.0) then
        intlon = 0
        intlat = 0
        clonew = ' '
        clatns = ' '
      else
        if (outlon >= 180.0) then
c          intlon = 3600 - int(outlon * 10. + 0.5)
c          clonew = 'W'
cJ.Peng-----03/27/2015------------------------------------
          if (outlon < 360.0) then
            intlon = 3600 - int(outlon * 10. + 0.5)
            clonew = 'W'
          else
            intlon =int(outlon * 10. + 0.5) - 3600
            clonew = 'E'
          endif
cJ.Peng-----03/27/2015------------------------------------

        else
          intlon = int(outlon * 10. + 0.5)
          clonew = 'E'
        endif
        intlat = int(abs(outlat) * 10. + 0.5)
        if (outlat < 0.0) then
          clatns = 'S'
        else
          clatns = 'N'
        endif
      endif

      basinid = stormid(1:2)
      stormnum = stormid(3:4)

      if (ctype == 'mean') then
        write (53,81) basinid,stormnum,cymdh,catcf,fcsthrs(ifh)
     &        ,intlat,clatns,intlon,clonew
      else
        itemp = int(dthresh)
        cmode(1:1) = catcf(1:1)
        write (cmode(2:4),'(i3.3)') itemp
c        print *,'atcfunix, cmode= ',cmode,' itemp= ',itemp
c        write (*,79) cmode,itemp
   79   format (1x,' cmode= ....',a4,'....  itemp= ',i3.3)
        write (57,83) basinid,stormnum,cymdh,cmode,fcsthrs(ifh)
     &        ,intlat,clatns,intlon,clonew,int(xprob*100.0)
      endif

   81 format (a2,', ',a2,', ',a10,', 03, ',a4,', ',i3.3,', ',i3,a1
     &       ,', ',i4,a1)
   83 format (a2,', ',a2,', ',a10,', 03, ',a4,', ',i3.3,', ',i3,a1
     &       ,', ',i4,a1,', ',i3)
c
C      close (53)
      return
      end

c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine output_atcf (stormid,xmeanlon,xmeanlat,cymdh,ist,catcf)
c
c     ABSTRACT: This subroutine  outputs a 1-line message for each storm
c     in ATCF format.  This message contains the model identifier, the
c     forecast initial date, and the positions for 12, 24, 36, 48 and
c     72 hours.  This message also contains the intensity
c     estimates (in knots) for those same hours.  The  conversion for
c     m/s to knots is to multiply m/s by 1.9427 (3.281 ft/m,
c     1 naut mile/6080 ft, 3600s/h).
c
c     NOTE: Intensity estimates are NOT included for the ensemble 
c     mean tracks.
c
c     NOTE: The longitudes that are passed into this subroutine are
c     given in 0 - 360, increasing eastward.  The  output of this
c     subroutine is used by the atcf system at TPC for plotting
c     purposes, and the atcf plotting routines need the longitudes in
c     0 - 360, increasing westward.  Thus, a necessary adjustment is
c     made.

      USE maxparms

      character*4  stormid,catcf
      character*10 cymdh
      character*8  yymmddhh
      character*33 outatcffile

      real    xmeanlat(maxstorms,maxtimes)
      real    xmeanlon(maxstorms,maxtimes)
      integer intlon(maxtimes),intlat(maxtimes)
c
C      outatcffile = 'aemn.'//cymdh//'.cyclone.trackatcf'
C      open (unit=54,file=outatcffile,status='unknown',position='append')

      yymmddhh = cymdh(3:10)

      ifhloop: do ifh = 1,maxtimes

        if (xmeanlon(ist,ifh) < -998.0 .or. xmeanlat(ist,ifh) < -998.0)
     &  then

          intlon(ifh) = 0
          intlat(ifh) = 0

        else
          intlon(ifh) = 3600 - int(xmeanlon(ist,ifh) * 10. + 0.5)
          intlat(ifh) = int(abs(xmeanlat(ist,ifh)) * 10. + 0.5)
          if (xmeanlat(ist,ifh) < 0.0) then
            intlat(ifh) = intlat(ifh) * (-1)
          endif

        endif

      enddo ifhloop

      write (54,82) '99',catcf,yymmddhh,intlat(3),intlon(3)
     &           ,intlat(5),intlon(5),intlat(7),intlon(7)
     &           ,intlat(9),intlon(9),intlat(13),intlon(13)
     &           ,0,0,0,0,0,stormid,cymdh(9:10)

   82 format (a2,a4,a8,10i4,5i3,1x,a4,a2)
c

C      close (54)
      return
      end

c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine output_all (stormid,xmeanlon,xmeanlat,cymdh,ist,catcf)
c
c     ABSTRACT: This subroutine  outputs a 1-line message for each
c     storm.  This message contains the model identifier, the forecast
c     initial date, and the positions for 0, 12, 24, 36, 48, 60 and 72
c     hours.  In the case of the regional models (NGM, Eta), which
c     only go out to 48h, zeroes are included for forecast hours
c     60 and 72.
c
c     NOTE: The longitudes that are passed into this subroutine are
c     given in 0 - 360, increasing eastward.  The  output of this
c     subroutine is used by Steve Lord for plotting purposes, and his
c     plotting routines need the longitudes in 0 - 360, increasing
c     westward.  Thus, a necessary adjustment is made.
c
      USE maxparms

      character*4  stormid,catcf
      character*10 cymdh
      character*8  yymmddhh
      character*2  stormnum
      character*3  basinid
      character*32 outallfile

      real    xmeanlat(maxstorms,maxtimes)
      real    xmeanlon(maxstorms,maxtimes)
      integer intlon(maxtimes),intlat(maxtimes)
c
C      outallfile = 'aemn.'//cymdh//'.cyclone.trackall'
C      open (unit=55,file=outallfile,status='unknown',position='append')

      yymmddhh = cymdh(3:10)
      stormnum = stormid(3:4)
c
      ifhloop: do ifh = 1,maxtimes

        if (xmeanlon(ist,ifh) < -998.0 .or. xmeanlat(ist,ifh) < -998.0)
     &  then
          intlon(ifh) = 0
          intlat(ifh) = 0
        else
          intlon(ifh) = 3600 - int(xmeanlon(ist,ifh) * 10. + 0.5)
          intlat(ifh) = int(abs(xmeanlat(ist,ifh)) * 10. + 0.5)
          if (xmeanlat(ist,ifh) < 0.0) then
            intlat(ifh) = intlat(ifh) * (-1)
          endif
        endif

      enddo ifhloop

      select case (stormid(1:2))
        case ('AL');  basinid(3:3) = 'L'
        case ('CP');  basinid(3:3) = 'C'
        case ('EP');  basinid(3:3) = 'E'
        case ('WP');  basinid(3:3) = 'W'
        case ('SC');  basinid(3:3) = 'O'
        case ('EC');  basinid(3:3) = 'T'
        case ('AU');  basinid(3:3) = 'U'
        case ('SP');  basinid(3:3) = 'P'
        case ('SI');  basinid(3:3) = 'S'
        case ('BB');  basinid(3:3) = 'B'
        case ('NA');  basinid(3:3) = 'A'
cJ.Peng----2012-05-11--------------------------
        case ('HC');  basinid(3:3) = 'G'
        case default; basinid(3:3) = '*'
      end select

      basinid(1:2) = stormid(3:4)

      write (55,83) '99',catcf,yymmddhh,intlat(1),intlon(1)
     &           ,intlat(3),intlon(3),intlat(5),intlon(5)
     &           ,intlat(7),intlon(7),intlat(9),intlon(9)
     &           ,intlat(11),intlon(11),intlat(13),intlon(13)
     &           ,basinid

   83 format (a2,a4,a8,14i4,1x,a3)
c
C      close (55)
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_nlists (dthresh,cmodel)
c
c     ABSTRACT: This subroutine simply reads in the namelists that are
c     created in the shell script.  Namelist datain currently contains
c     just the value of the dthresh parameter.
c
      real      dthresh
      character*5 :: cmodel
c
      namelist/datain/dthresh,cmodel
c
      read (5,NML=datain,END=801)
  801 continue

      print *,' '
      print *,'After datain namelist read in trakave.f, '
      print *,'namelist parms follow: ' 
      print *,' '
      print *,'Distance threshold (dthresh) = ',dthresh
      print *,'cmodel = ',cmodel
c
      return
      end

!---------------------------------------------------------------------
!---------------------------------------------------------------------
      subroutine gblevn12(kbak)

      USE GBLEVN_MODULE

      data rog /29.261/

!---------------------------------------------------------------------
!---------------------------------------------------------------------

      call allobaks ! allocate background arrays

! copy a background time level to 4d arrays

      call fill_ns(iarzs(1,1,kbak)  ,iar12z,imax,jmax,1)
      call fill_ns(iarps(1,1,kbak)  ,iar13p,imax,jmax,1)
      call fill_ns(iarqq(1,1,1,kbak),iar17q,imax,jmax,kmax)
      call fill_ns(iartt(1,1,1,kbak),iar14t,imax,jmax,kmax)
      call fill_ns(iaruu(1,1,1,kbak),iar15u,imax,jmax,kmax)
      call fill_ns(iarvv(1,1,1,kbak),iar16v,imax,jmax,kmax)
      call fill_ns(iarpl(1,1,1,kbak),iarpsl,imax,jmax,kmax)

! compute and store height profiles the gsi way                

      do k=1,kmax 
      do j=1,1
!$omp parallel do private(i,pwgt,tmid,zblo)
      do i=1,imax*jmax
      if(k==1) then
         pwgt=log(iarpl(i,j,k,kbak)/iarps(i,j,kbak))
         tmid=iartt(i,j,k,kbak) ! this is not quite right, but copied from gsi
         zblo=iarzs(i,j,kbak)
         iarzl(i,j,k,kbak)=zblo-rog*tmid*pwgt                       
         iarzl(i,j,k,kbak)=iarzl(i,j,k,kbak)-iarzs(i,j,kbak) ! convert to height above the surface
      else
         pwgt=log(iarpl(i,j,k,kbak)/iarpl(i,j,k-1,kbak))
         tmid=.5*(iartt(i,j,k-1,kbak)+iartt(i,j,k,kbak))
         zblo=iarzl(i,j,k-1,kbak)
         iarzl(i,j,k,kbak)=zblo-rog*tmid*pwgt
      endif
      enddo
      enddo
      enddo

      return
      end
c------------------------------------------------------------------
c------------------------------------------------------------------
      subroutine suterps

      USE GBLEVN_MODULE
      USE SP_MOD, ONLY: SPLAT

      real slat(jmax),wlat(jmax)

      print*,'suterps',idrt,imax,jmax,kmax
      call splat(idrt,jmax,slat,wlat)
      rad2deg=180./acos(-1.)

      if(idrt==0.or.idrt==4) then ! equal grid including poles
         allocate(slats(jmax))
         slats(:)=-asin(slat(:))*rad2deg
         dlat=180./float(jmax-1)
      elseif(idrt==256.or.idrt==4) then ! equal grid not incl poles
         allocate(slats(jmax+2))
         slats(1)=-90.00
         slats(2:jmax+1)=-asin(slat(:))*rad2deg
         slats(jmax+2)=90.00
         dlat=180./float(jmax);jmax=jmax+2
      else
         print*,'in suterps, idrt=',idrt
         call bort('suterps - bad idrt value')
      endif

      return

      print*
      print*,'after suterps'
      print*,idrt,imax,jmax,kmax,dlon,dlat
      do j=1,jmax
      print'(i8,2f8.2)',j,slats(j),(j-1)*dlat-90.
      enddo
      print*
         
      return
      end
c------------------------------------------------------------------
c------------------------------------------------------------------
      subroutine fill_ns(gout,gin,ix,jx,kx)
      USE GBLEVN_MODULE

      real(8)  gin(ix,jx,kx)
      real(4) gout(ix,jx,kx)

      if(idrt==0.or.idrt==4) then
         gout(:,:,:)=gin(:,:,:)
      elseif(idrt==4.or.idrt==256) then                       
         gout(:,2:jx+1,:)=gin(:,1:jx,:)
         do k=1,kx
         gout(1:ix,   1,k)=sum(gout(1:ix,   2,k))/float(ix)
         gout(1:ix,jx+2,k)=sum(gout(1:ix,jx+1,k))/float(ix)
         enddo
      endif

      return
      end

              PROGRAM PREPOBS_LISTHEADERS
!$$$  MAIN PROGRAM DOCUMENTATION BLOCK
!
! MAIN PROGRAM: PREPOBS_LISTHEADERS
!   PRGMMR: KEYSER           ORG: NP22        DATE: 2013-03-06
!
! ABSTRACT: GENERATES A LIST OF ALL UNIQUE HEADERS IN A PREPBUFR FILE
!    MATCHING INPUT LIST.  REORDERS THE FILE INTO THE INPUT LIST ORDER.
!
! PROGRAM HISTORY LOG:
! 1999-06-29  KISTLER -- ORIGINAL AUTHOR
! 2000-06-15  KEYSER  -- REPLACED INCORRECT CALL TO W3TAGB WITH CALL
!                        TO W3TAGE AT END OF CODE
! 2000-12-05  KEYSER  -- NOW READS THROUGH THE ENTIRE INPUT FILE WHEN
!                        LOOKING FOR MESSAGES MATCHING A PARTICULAR TYPE
!                        FROM THE INPUT LIST, BEFORE IT STOPPED LOOKING
!                        FOR MESSAGES MATCHING THE TYPE IN THE INPUT LIST
!                        ONCE THE INPUT MESSAGE TYPE CHANGED TO ANOTHER
!                        TYPE (THIS ALLOWS FOR INPUT PREPBUFR FILES WITH
!                        INTERMINGLED MESSAGE TYPES TO BE HANDLED
!                        PROPERLY)
! 2013-03-06  KEYSER  -- CHANGES TO RUN ON WCOSS
!
! USAGE:
!   INPUT FILES:
!     STDIN    - NAMELIST/NAMIN/
!     UNIT 11  - PREPBUFR FILE TO BE LISTED
!
!   OUTPUT FILES:
!     UNIT 06  - STANDARD PRINTFILE
!     UNIT 51  - REORDERED PREPBUFR FILE
!     UNIT 52  - LISTING OF UNIQUE HEADERS
!
!   SUBPROGRAMS CALLED:
!     LIBRARY:
!       BUFRLIB  - DATELEN  OPENBF UFBMEM  RDMEMM  CLOSBF
!       W3NCO    - W3TAGB   W3TAGE
!
!   EXIT STATES:
!     COND =   0 - SUCCESSFUL RUN
!     COND =   1 - BUFR I/O ERROR 
!
! REMARKS: NONE.
!
! ATTRIBUTES:
!   LANGUAGE: FORTRAN 90
!   MACHINE:  NCEP WCOSS
!
!$$$

! program prepobs_listheaders

implicit none

character*8  subset, prvset
character*8, allocatable :: bufrlist(:)
integer,      allocatable :: kount(:)
integer :: iret,jdate,k,m,kmsgs,lunin=11,klist=0,lunot=51,lunlst=52

      CALL W3TAGB('PREPOBS_LISTHEADERS',2013,0065,0057,'NP22')

read(*,*) klist
if (klist.lt.1) then
    write(lunlst,*) ' klist = ',klist, 'not set > 1 on namelist namin'
endif
allocate (bufrlist(klist),kount(klist))

k=0
do k=1,klist
   read(*,'(a6)') bufrlist(k)(1:6)
enddo

call ufbmem(lunin,0,kmsgs,iret)
call datelen(10)
call openbf(lunot,'OUT',lunin)

do k=1,klist
   kount(k)=0
   do m=1,kmsgs+1
      call rdmemm(m,subset,jdate,iret)
      if (iret.ne.0 ) then
! All messages have been read; write out the count associated with the
!  current list type and move on to the next list type
         write(lunlst,*) bufrlist(k)(1:6), kount(k)
         exit
      else  if (subset(1:6) .ne. bufrlist(k)(1:6)) then
! This message does not match the current list type; read in the next
!  message in the input file
         cycle
      else
! This message matches the current list type, count it and copy it to the
!  output file, then read in the next message in the input file
         kount(k)=kount(k)+1
         call copymg(lunin,lunot)
      endif
   enddo
enddo

call closbf(lunin)
      CALL W3TAGE('PREPOBS_LISTHEADERS')
stop
end

       INTEGER FUNCTION nfill(C)
       CHARACTER*(*) C
       NFILL = LEN(C)
       DO J=1,NFILL
         IF(C(J:J).EQ.' ') THEN
           NFILL = J - 1
           RETURN
         ENDIF
       ENDDO
       RETURN
       END

c$$$  Subprogram Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Subprogram: tranQCflags
c   Programmer: D. Keyser       Org: NP22       Date: 2012-05-08
c
c Abstract:  Translates quality information from NRL standards to equivalent NCEP PREPBUFR
c   quality marks.  Also generates the NCEP PREPBUFR reason codes based on the NRL quality
c   information.  This is read in for one observation at a time for each report (e.g.,
c   pressure reads it, then altitude, then temperature, then moisture, then wind).
c
c Program History Log:
c 2010-11-15  S. Bender -- Original Author
c 2012-05-08  D. Keyser -- Prepared for operational implementation
c
c Usage: call tranQCflags(NRLQCstg,type,NCEPqm,NCEPrc,l_badrpt,l_duprpt)
c
c   Input argument list:
c     NRLQCstg     - NRLACQC quality information (11 char. string) for this complete report
c     type         - Type of variable being considered in this call (e.g., 'p', 'z', 't',
c                    'q', 'w')
c
c   Output argument list:
c     NCEPqm       - Equivalent NCEP PREPBUFR quality mark for this variable
c     NCEPrc       - Generated NCEP PREPBUFR reason code for this variable
c     l_badrpt     - Logical indicating if the entire report should be marked as "bad"
c     l_duprpt     - Logical indicating if the entire report should be marked as a duplicate
c
c   Output files:
c     Unit 06     - Standard output print
c
c   Subprograms called:
c     Library:
c       W3NCO:   ERREXIT    W3TAGE     MOVA2I
c
c   Exit States:
c     Cond =  0 - successful run
c            69 - row number for input data matrix is outside range of 1-34
c
c Remarks: Called by subroutines output_acqc_noprof and sub2mem_um.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine tranQCflags(NRLQCstg,type,NCEPqm,NCEPrc,l_badrpt,
     +                       l_duprpt)

      implicit none

      character*11 NRLQCstg
      character*1 type

      logical l_badrpt,l_duprpt

      integer iii(45:118)               ! the "row number" (RN) corresponding to the single
                                        !  character NRLACQC  quality flag pulled out of
                                        !  NRLQCstg, this is the second dimension of table
                                        !  w2d
     +,         mova2i

      integer   cp                      ! character position in c_qc string (1-11), this
                                        !  value minus 1 is the first dimension of table w2d
     +,         RN                      ! row number in w2d/action data table/numerical 
                                        !  equivalent of character value (example: a=1,
                                        !  F=10), this is obtained via integer conversion of
                                        !  the single ASCII character NRLACQC quality flag
                                        !  pulled out of NRLQCstg, obtained from iii

      character*2 w2d(0:10,34)
c             0 = overall report
c              |--- 1 = time
c              |--- |--- 2 = latitude
c              |--- |--- |--- 3 = longitude
c              |--- |--- |--- |--- 4 = pressure/altitude
c              |--- |--- |--- |--- |--- 5 = temperature
c              |--- |--- |--- |--- |--- |--- 6 = wind direction
c              |--- |--- |--- |--- |--- |--- |--- 7 = wind speed
c              |--- |--- |--- |--- |--- |--- |--- |--- 8 = moisture
c              |--- |--- |--- |--- |--- |--- |--- |--- |--- 9 = reject (black) list
c              |--- |--- |--- |--- |--- |--- |--- |--- |--- |--- 10 = flight phase
c              |--- |--- |--- |--- |--- |--- |--- |--- |--- |--- |---
c       i: 0:10 (cp-1) -------------->
      data w2d/'ND','ND','ND','ND','ND','ND','ND','ND','ND','ND','IO', ! a  j:1-34 (RN) 1 |
     +         'RR','ND','ND','ND','ND','ND','ND','RW','ND','ND','IO', ! A	        2 |
     +         'RR','RR','RR','RR','RR','RR','RW','RW','RM','ND','ND', ! B	        3 |
     +         'ND','ND','ND','ND','ND','RT','ND','ND','ND','ND','ND', ! b	        4 V
     +	       'ND','ND','ND','ND','ND','ND','ND','ND','ND','IO','ND', ! C              5
     +	       'DR','ND','ND','ND','ND','ND','ND','ND','ND','ND','IO', ! D              6
     +	       'DR','ND','ND','ND','ND','ND','ND','ND','ND','ND','IO', ! d              7
     +	       'RR','ND','ND','ND','ND','RT','RW','RW','ND','ND','ND', ! E              8
     +	       'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! e              9
     +	       'ND','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! F             10
     +	       'ND','RR','RR','RR','RR','RT','RW','RW','ND','ND','ND', ! I             11
     +	       'ND','ND','ND','ND','RR','ND','ND','ND','ND','ND','IO', ! i             12
     +	       'ND','RR','RR','RR','RR','CW','CT','CT','RM','ND','ND', ! K             13
     +	       'ND','ND','ND','ND','ND','ND','ND','ND','ND','ND','IO', ! L             14
     +	       'ND','RR','RR','RR','RR','CW','CT','CT','RM','IO','IO', ! M             15
     +	       'NU','NU','NU','NU','ND','NU','ND','ND','NU','ND','IO', ! N             16
     +         'RR','ND','ND','ND','ND','ND','ND','ND','ND','RR','ND', ! O             17
     +         'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! P             18
     +         'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! p             19
     +	       'ND','IO','IO','IO','IO','IO','ND','ND','ND','ND','ND', ! R             20
     +	       'RR','ND','ND','ND','IO','ND','ND','ND','ND','ND','ND', ! r             21
     +	       'RR','RR','RR','RR','RR','ND','ND','SW','SM','ND','ND', ! S             22
     +	       'RR','ND','ND','ND','ND','ND','SW','SW','ND','ND','ND', ! s             23
     +	       'ND','ND','ND','ND','ND','ND','ND','ND','ND','RT','ND', ! T             24
     +	       'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! t             25
     +	       'ND','ND','ND','ND','ND','ND','ND','ND','ND','ND','IO', ! U             26
     +	       'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! V             27
     +	       'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! v             28
     +	       'RR','ND','ND','ND','ND','ND','ND','ND','ND','RW','ND', ! W             29
     +	       'RR','ND','ND','ND','ND','ND','ND','ND','ND','ND','ND', ! X             30
     +	       'GR','IO','IO','IO','GV','GT','GW','GW','GM','IO','ND', ! .             31
     +	       'NU','ND','ND','ND','NU','NU','NU','NU','NU','ND','ND', ! -             32
     +	       'IO','ND','ND','ND','ND','ND','ND','ND','SM','ND','ND', ! 2             33
     +	       'ND','ND','ND','ND','ND','ND','ND','ND','SM','ND','ND'  ! 3             34
     +	      /

c  'CT' --  check temperature -> reject wind, or will reject report if temperature also bad
c  'CW' --  check wind -> reject temperature, or will reject report if wind also bad
c  'DR' --  duplicate report
c  'GM' --  good moisture
c  'GR' --  good report
c  'GT' --  good temperature`
c  'GV' --  good pressure/altitude
c  'GW' --  good wind
c  'IO' --  inconclusive (?)
c  'ND' --  not defined
c  'NU' --  neutral report (not checked)
c  'RM' --  reject moisture
c  'RR' --  reject entire report
c  'RT' --  reject temperature
c  'RW' --  reject wind
c  'SM' --  suspect moisture
c  'SW' --  suspect wind
c  'XX' --  initialized value (not yet set)

      character*2 action                ! action value to be passed back to the calling
                                        !  routine (RR,DR,GR,RT,RM,RW,SW,NU,ND,IO)
     +,           bl_action             ! reject (black) list action (c_qc(10:10))
     +,	          pres_action           ! pressure/altitude action (c_qc(5:5))
     +,           temp_action 	        ! temperature action (c_qc(6:6))
     +,           moist_action          ! moisture action (c_qc(9:9))
     +,	          wdir_action           ! wind direction action (c_qc(7:7))
     +,           wspd_action           ! wind speed action (c_qc(8:8))
     +,           lat_action            ! latitude action (c_qc(3:3))
     +,           lon_action            ! longitude action (c_qc(4:4))
     +,	          time_action           ! time action (c_qc(2:2))
     +,           overall_action        ! action per c_qc(1:1)

      integer     NCEPqm                ! value of NCEP quality mark to be passed back to
                                        !  calling routine
     +,           NCEPrc                ! value of NCEP reason code to be passed back to
                                        !  calling routine
     +,           NCEPrc_t              ! intermediate value for temperature quality mark
     +,           NCEPrc_q              ! intermediate value for moisture quality mark
     +,           NCEPrc_w              ! intermediate value for wind quality mark


c Misc.
c -----

c decimal -->     45  46              50  51
c character -->  '-' '.'             '2' '3'
      data iii  / 32, 31,  0,  0,  0, 33, 34,  0,  0,  0,  0,  0,  0,

c decimal -->                                 65  66  67  68  69  70
c character -->                              'A' 'B' 'C' 'D' 'E' 'F'
     +             0,  0,  0,  0,  0,  0,  0,  2,  3,  5,  6,  8, 10,

c decimal -->             73      75  76  77  78  79  80      82  83
c character -->          'I'     'K' 'L' 'M' 'N' 'O' 'P'     'R' 'S'
     +             0,  0, 11,  0, 13, 14, 15, 16, 17, 18,  0, 20, 22,

c decimal -->     84  85  86  87  88
c character -->  'T' 'U' 'V' 'W' 'X'
     +            24, 26, 27, 29, 30,  0,  0,  0,  0,  0,  0,  0,  0,

c decimal -->     97  98     100 101             105
c character -->  'a' 'b'     'd' 'e'             'i'
     +             1,  4,  0,  7,  9,  0,  0,  0, 12,  0,  0,  0,  0,

c decimal -->            112     114 115 116     118
c character -->          'p'     'r' 's' 't'     'v'
     +             0,  0, 19,  0, 21, 23, 25,  0, 28 /

c -----------------------------------------------------------

c Initialize variables
c --------------------
      l_badrpt = .false.
      l_duprpt = .false.

      bl_action      = 'XX'
      pres_action    = 'XX'
      temp_action    = 'XX'
      moist_action   = 'XX'
      wdir_action    = 'XX'
      wspd_action    = 'XX'
      lat_action     = 'XX'
      lon_action     = 'XX'
      time_action    = 'XX'
      overall_action = 'XX'
      action         = 'XX'

      NCEPqm   = 99999
      NCEPrc   = 99999
      NCEPrc_t = 99999
      NCEPrc_q = 99999
      NCEPrc_w = 99999
c -----------------------------------------------------------

C *************************************************************************
c FIRST CHECK FOR UNILATERAL REJECT REPORT - APPLIES TO ALL VARIABLES
C *************************************************************************

c ---------------------------------------------------------------------
c First sub-check is on OVERALL REPORT (first character of c_qc string)
c ---------------------------------------------------------------------
      cp = 1

c iii represents the "row number" corresponding to the single ASCII character NRLACQC
c   quality flag NRLQCstg(cp:cp) and is the second dimension of table w2d (Note: this comment
c   is not repeated for each instance where iii is obtained below)
c -------------------------------------------------------------------------------------------
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'NU', 'GR', 'DR'
      overall_action = action
      if(action.eq.'RR' .or. action.eq.'DR') then
        NCEPrc = (cp-1)*100 + RN ! RC range 001-034
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

c ------------------------------------------------------------------------
C If we make it to here ...
c Second sub-check is on PRESSURE/ALTITUDE (fifth character of c_qc string)
c -------------------------------------------------------------------------
      cp = 5
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'NU', 'GV'
      pres_action = action
      if(action.eq.'RR') then
        NCEPrc = (cp-1)*100 + RN ! RC range 401-434
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

c ------------------------------------------------------------------
C If we make it to here ...
c Third sub-check is on TEMPERATURE (sixth character of c_qc string)
c ------------------------------------------------------------------
      cp = 6
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'NU', 'RT', 'GT', 'CW'
      temp_action = action
      if(temp_action.eq.'RT') then
c If temperature action is reject temperature ('RT'), change reject (black) list value in
c  tenth character of c_qc string from 'O' (reject entire report) to 'W' (reject wind only) -
c  this prevents eighth sub-check below from masking QM (13) & RC associated with this code's
c  reject of temperature {instead it would receive reject (black) list QM (14) and RC}
        if(NRLQCstg(10:10).eq.'O')  NRLQCstg(10:10) = 'W'
      endif
      if(action.eq.'RR') then
        NCEPrc = (cp-1)*100 + RN ! RC range 501-534
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

c -------------------------------------------------------------
C If we make it to here ...
c Fourth sub-check is on TIME (second character of c_qc string)
c -------------------------------------------------------------
      cp = 2
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'NU'
      time_action = action
      if(action.eq.'RR') then
        NCEPrc = (cp-1)*100 + RN ! RC range 101-134
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

c ---------------------------------------------------------------
C If we make it to here ...
c Fifth sub-check is on LATITUDE (third character of c_qc string)
c ---------------------------------------------------------------
      cp = 3
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'NU'
      lat_action = action
      if(action.eq.'RR') then
        NCEPrc = (cp-1)*100 + RN ! RC range 201-234
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

c -----------------------------------------------------------------
C If we make it to here ...
c Sixth sub-check is on LONGITUDE (fourth character of c_qc string)
c -----------------------------------------------------------------
      cp = 4
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'NU'
      lon_action = action
      if(action.eq.'RR') then
        NCEPrc = (cp-1)*100 + RN ! RC range 301-334
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

c -------------------------------------------------------------------------------------------
C If we make it to here ...
c Seventh sub-check is on TEMPERATURE/WIND COMBINATION (sixth thru tenth char of c_qc string)
c -------------------------------------------------------------------------------------------
c We already know temperature action (from sixth character of c_qc string) from above
c  {temp_action, either 'ND', 'IO', 'NU', 'RT', 'GT', 'CW' ('RR' already considered)}

c Obtain wind direction action from seventh character of c_qc string (wdir_action)
      cp = 7
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      wdir_action = w2d(cp-1,RN) ! either 'ND', 'NU', 'RW', 'SW', 'GW', 'CT'
                                 !                              (Note: 'RR' not a choice here)
      if(wdir_action.eq.'RW') then
c If wind direction action is reject wind ('RW'), change reject (black) list value in tenth
c  character of c_qc string from 'O' (reject entire report) to 'T' (reject temperature only)
c  - this prevents eighth sub-check below from masking QM (13) & RC associated with this
c  code's reject of wind {instead it would receive reject (black) list QM (14) & RC}
        if(NRLQCstg(10:10).eq.'O')  NRLQCstg(10:10) = 'T'
      endif

c Obtain wind speed action from eighth character of c_qc string (wspd_action)
      cp = 8
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      wspd_action = w2d(cp-1,RN) ! either 'ND', 'NU', 'RW', 'SW', 'GW', 'CT'
                                 !                              (Note: 'RR' not a choice here)
      if(wspd_action.eq.'RW') then
c If wind speed action is reject wind ('RW'), change reject (black) list value in tenth
c  character of c_qc string from 'O' (reject entire report) to 'T' (reject temperature only)
c  - this prevents eighth sub-check below from masking QM (13) & RC associated with this
c   code's reject of wind {instead it would receive reject (black) list QM (14) and RC}
        if(NRLQCstg(10:10).eq.'O')  NRLQCstg(10:10) = 'T'
      endif

c Obtain moisture action from ninth character of c_qc string (wspd_action)
      cp = 9
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      moist_action = w2d(cp-1,RN) ! either 'ND', 'NU', 'RM', 'SM', 'GM'
                                  !                             (Note: 'RR' not a choice here)

c Obtain reject (black) list action from tenth character of c_qc string (bl_action)
      cp = 10
      RN = iii(mova2i(NRLQCstg(cp:cp)))
      if(RN.lt.0 .or. RN.gt.34) go to 999
      bl_action = w2d(cp-1,RN) ! either 'ND', 'RR', 'IO', 'RT', 'RW'

c If temperature action is to check wind ('CW'), then a "bad" wind will result in the entire
c  report being rejected
      if(temp_action.eq.'CW') then
        action = 'RR'
        cp = 6
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 501-534
c .... first check wind direction to see if it is "bad"
        if(wdir_action.eq.'CT'.or.wdir_action.eq.'RW') then
          cp = 7
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_w = (cp-1)*100 + RN ! wind RC range 601-634
c ........ a bad wind direction rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
	    NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
	    NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        elseif(wspd_action.eq.'CT'.or.wspd_action.eq.'RW') then
c .... next check wind speed to see if it is "bad"
	  cp = 8
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_w = (cp-1)*100 + RN ! wind RC range 701-734
c ........ a bad wind speed rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
	    NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
	    NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        elseif(bl_action.eq.'RW' ) then
c .... finally check reject (black) list to see if wind (direction/speed) is rejected ("bad")
c       (Note: bl_action = 'RR' will be considered separately in eighth sub-check below)
	  cp = 10
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_w = (cp-1)*100 + RN ! wind RC range 901-934
c ........ wind on reject (black) list rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
	    NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
	    NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        else
c .... even though temperature action is to check wind ('CW'), wind is not "bad", so
c      temperature (and wind and moisture if they are present) will be tested later as a
c      single variable unless eighth sub-check below yields a reject entire report
	  action = 'XX' ! reset action back to initialized value
	  NCEPrc_t = 99999  ! reset temperature reason code back to initialized value
        endif
      else
c Temperature action is something other than check wind ('CW') {or, for that matter, reject
c  report ('RR')}, so temperature (and wind and moisture if present) will be tested later as
c  a single variable unless eighth sub-check below yields a reject entire report
        temp_action = temp_action ! dummy statement to allow else branch here
      endif

c If wind direction action is to check temperature ('CT'), then a "bad" temperature will
c  result in the entire report being rejected
      if(wdir_action.eq.'CT') then
        action = 'RR'
        cp = 7
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
	NCEPrc_w = (cp-1)*100 + RN ! wind RC range 601-634
c .... first check temperature to see if it is "bad"
        if(temp_action.eq.'CW'.or.temp_action.eq.'RT') then
	  cp = 6
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 501-534
c ........ a bad temperature rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
	    NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
	    NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        elseif(bl_action.eq.'RT' ) then
c .... finally check reject (black) list to see if temperature is rejected ("bad")
c       (Note: bl_action = 'RR' will be considered separately in eighth sub-check below)
	  cp = 10
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 901-934
c ........ temperature on reject (black) list rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
	    NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
	    NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        else
c .... even though wind direction action is to check temperature ('CT'), temperature is not
c      "bad", so wind (and temperature and moisture if present) will be tested later as a
c      single variable unless either wind speed check (action 'CT' checking against "bad"
c      temperature) just below yields a reject entire report, or eighth sub-check below
c      yields a reject entire report
	  action = 'XX'     ! reset action back to initialized value
	  NCEPrc_w = 99999  ! reset wind reason code back to initialized value
        endif
      else
c Wind direction action is something other than check temperature ('CT') {or, for that
c  matter, reject report ('RR')}, so wind (and temperature and moisture if present) will be
c  tested later as a single variable unless either wind speed check (action 'CT' checking
c  against "bad" temperature) just below yields a reject entire report, or eighth sub-check
c  below yields a reject entire report
        wdir_action = wdir_action ! dummy statement to allow else branch here
      endif

c If wind speed action is to check temperature ('CT'), then a "bad" temperature will result
c  in the entire report being rejected
      if(wspd_action.eq.'CT') then
        action = 'RR'
        cp = 8
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        NCEPrc_w = (cp-1)*100 + RN ! wind RC range 701-734
c .... first check temperature to see if it is "bad"
        if(temp_action.eq.'CW'.or.temp_action.eq.'RT') then
          cp = 6
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 501-534
c ........ a bad temperature rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
	    NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
	    NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        elseif(bl_action.eq.'RT' ) then
c .... finally check reject (black) list to see if temperature is rejected ("bad")
c       (Note: bl_action = 'RR' will be considered separately in eighth sub-check below)
	  cp = 10
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
	  NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 901-934
c ........ temperature on reject (black) list rejects entire report
c ........ set RC for moisture to moisture action if moisture rejected, otherwise set it to
c           RC for temperature
          if(moist_action.eq.'RM') then
            cp = 9
            RN = iii(mova2i(NRLQCstg(cp:cp)))
            if(RN.lt.0 .or. RN.gt.34) go to 999
            NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
          else
            NCEPrc_q = NCEPrc_t ! moisture RC range 501-534
          endif
          go to 2000 ! reject entire report here means we don't need to do anymore testing
        else
c .... even though wind speed action is to check temperature ('CT'), temperature is not"bad",
c      so wind (and temperature and moisture if present) will be tested later as a single
c      variable unless eighth sub-check below yields a reject entire report
	  action = 'XX'     ! reset action back to initialized value
	  NCEPrc_w = 99999  ! reset wind reason code back to initialized value
        endif
      else
c Wind speed action is something other than check temperature ('CT') {or, for that matter,
c  reject report ('RR')}, so wind (and temperature and moisture if present) will be tested
c  later as a single variable unless eighth sub-check below yields a reject entire report
        wspd_action = wspd_action ! dummy statement to allow else branch here
      endif

c ---------------------------------------------------------------------------
C If we make it to here ...
c Eighth sub-check is on REJECT (BLACK) LIST (tenth character of c_qc string)
c ---------------------------------------------------------------------------
c We already know reject (black) list action (from tenth character of c_qc string) from above
c  {bl_action, either 'ND', 'RR', 'IO', 'RT', 'RW'}
      action = bl_action
      if(action.eq.'RR') then
        cp = 10
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        NCEPrc = (cp-1)*100 + RN ! RC range 901-934
        go to 2000 ! reject entire report here means we don't need to do anymore testing
      endif

C *************************************************************************
C If we make it to here ...
c NEXT CHECK SINGLE VARIABLES
C *************************************************************************

      if(type.eq.'p' .or. type.eq.'z') then ! check 5
c *****************
c PRESSURE/ALTITUDE
c *****************
        cp = 5
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        action = w2d(cp-1,RN) ! either 'ND', 'IO', 'NU', 'GV' ('RR' already considered)
        NCEPrc = (cp-1)*100 + RN ! pressure/altitude RC range 401-434
        pres_action = action

      elseif(type.eq.'t') then ! check 6, 10
c ***********
c TEMPERATURE
c ***********
        cp = 6
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        action = w2d(cp-1,RN) ! either 'ND', 'IO', 'NU', 'RT', 'GT', 'CW'
                              !                                      ('RR' already considered)
        NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 501-534

c A temperature action of check wind ('CW') is treated as a reject temperature ('RT') - test
c  for unilateral reject of entire report above has already tested cases where temperature
c  action of 'CW' is combined with a "bad" wind (resulting in a reject of the entire report),
c  so we know here that wind is not bad and only temperature should be rejected
c -------------------------------------------------------------------------------------------
        if(action.eq.'CW') action = 'RT'

c Check reject (black) list flag to see if temperature should be rejected {but ONLY if
c  temperature action is not already set to reject temperature ('RT')}
c ------------------------------------------------------------------------------------
        if(action.ne.'RT') then
	  cp = 10
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
          bl_action = w2d(cp-1,RN) ! either 'ND', 'IO', 'RT', 'RW' ('RR' already considered)
	  if(bl_action.eq.'RT') then
	    action = 'RT' ! reject temperature
	    NCEPrc_t = (cp-1)*100 + RN ! temperature RC range 901-934
	  endif
	endif

      elseif(type.eq.'q') then ! check 9
c ********	
c MOISTURE
c ********	
        cp = 9
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        action = w2d(cp-1,RN) ! either 'ND', 'NU', 'RM', 'SM', 'GM'
                              !                                 (Note: 'RR' not a choice here)
        NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 801-834
        moist_action = action

        if(action.ne.'RM') then

c A reject of temperature forces a reject of moisture (if moisture not already rejected)
c --------------------------------------------------------------------------------------
          cp = 6
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
          temp_action = w2d(cp-1,RN) !  either 'ND', 'IO', 'NU', 'RT', 'GT', 'CW'
                                     !                               ('RR' already considered)
          if(temp_action.eq.'RT') then
            action = 'RM'
            NCEPrc_q = (cp-1)*100 + RN ! moisture RC range 501-534
          endif
        endif

      elseif(type.eq.'w') then ! check 7, 8, 10
c ****
c WIND
c ****

c First, check Wind direction action
c ----------------------------------
        cp = 7
        RN = iii(mova2i(NRLQCstg(cp:cp)))
        if(RN.lt.0 .or. RN.gt.34) go to 999
        wdir_action = w2d(cp-1,RN) ! either 'ND', 'NU', 'RW', 'SW', 'GW', 'CT'
                                   !                            (Note: 'RR' not a choice here)
     	NCEPrc_w = (cp-1)*100 + RN ! initially set overall wind RC to reflect wind direction
                               ! status, wind RC range 601-634 {this may be overwritten later
                               !  by wind speed status if it is inferior to wind direction
                               !  status (quality-wise)})

        action = wdir_action   ! initially set overall wind action to wind direction
                               !  action {this may be overwritten later by wind speed action
                               !  if it is inferior to wind direction action (quality-wise)}

c A wind direction action of check temperature ('CT') is treated as a reject wind ('RW') -
c  test for unilateral reject of entire report above has already tested cases where wind
c  direction action of 'CT' is combined with a "bad" temperature (resulting in a reject of
c  the entire report), so we know here that temperature is not bad and only wind should be
c  rejected
c ----------------------------------------------------------------------------------------
        if(wdir_action.eq.'CT') wdir_action = 'RW'

        if(wdir_action.eq.'RW') then

c If wind direction action is reject wind ('RW') then set overall wind action to 'RW' - no
c  need to examine wind speed action in this case
c ----------------------------------------------------------------------------------------
          action = 'RW'
        else

c Otherwise, check wind speed action to see if it is inferior to wind direction action
C  (quality-wise)
c ------------------------------------------------------------------------------------

          cp = 8
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
          wspd_action = w2d(cp-1,RN) ! either 'ND', 'NU', 'RW', 'SW', 'GW', 'CT'
                                     !                          (Note: 'RR' not a choice here)

c A wind speed action of check temperature ('CT') is treated as a reject wind ('RW') - test
c  for unilateral reject of entire report above has already tested cases where wind speed
c  action of 'CT' is combined with a "bad" temperature (resulting in a reject of the entire
c  report), so we know here that temperature is not bad and only wind should be rejected
c -----------------------------------------------------------------------------------------
          if(wspd_action.eq.'CT') wspd_action = 'RW'

          if(wspd_action.eq.'RW') then

c For cases when wind direction action is not 'RW' but wind speed action is 'RW', use wind
c  speed's RC as overall wind RC value since it is inferior to wind direction action
C  (quality-wise)
c ----------------------------------------------------------------------------------------
            NCEPrc_w = (cp-1)*100 + RN !  wind RC range 701-734
            action = 'RW'
          elseif (wdir_action.eq.'SW') then

c For cases when wind direction action is suspect wind ('SW') and wind speed action is not
c  'RW', set overall wind action to 'SW' and use wind direction's RC as overall wind RC value
c  since it is inferior to wind speed action (quality-wise)
c -------------------------------------------------------------------------------------------
            action = 'SW'
          elseif (wspd_action.eq.'SW') then

c For cases when wind direction action is neither 'RW' nor 'SW' but wind speed action is
c  'SW', set overall wind action to 'SW' and use wind speed's RC as overall wind RC value
c  since it is inferior to wind direction action (quality-wise)
c ---------------------------------------------------------------------------------------
            NCEPrc_w = (cp-1)*100 + RN !  wind RC range 701-734
            action = 'SW'
          endif
        endif

c Check reject (black) list flag to see if wind should be rejected {but ONLY if overall wind
c  action is not already set to reject wind ('RW')}
c ------------------------------------------------------------------------------------------
        if(action.ne.'RW') then
          cp = 10
          RN = iii(mova2i(NRLQCstg(cp:cp)))
          if(RN.lt.0 .or. RN.gt.34) go to 999
          bl_action = w2d(cp-1,RN) ! either 'ND', 'IO', 'RT', 'RW' ('RR' already considered)
          if(bl_action.eq.'RW') then
            action = 'RW' ! reject wind
            NCEPrc_w = (cp-1)*100 + RN ! wind RC range 901-934
          endif
        endif

      endif

C *************************************************************************

 2000 continue

c -------------------------------------------
c Translate actions into NCEP QUALITY MARKERS
c -------------------------------------------
      if(action.eq.'RR') then
        l_badrpt = .true. 		 

      elseif(action.eq.'DR') then 
        l_duprpt = .true.

      elseif(action.eq.'GV'.or.action.eq.'GT' .or.
     +       action.eq.'GM'.or.action.eq.'GW') then
        NCEPqm = 1 ! good (RC already set)

      elseif(action.eq.'NU') then 
        NCEPqm = 2 ! neutral/not checked (RC already set)

      elseif(action.eq.'ND') then ! not defined
        NCEPqm = 2   ! QM -> neutral
        NCEPrc = 099 ! RC -> 099 - override any RCs already set

        print *, 'type: ',type
        print *, 'overall_action: ',overall_action
        print *, 'time_action: ',time_action
        print *, 'lat/lon_action: ',lat_action,'/',lon_action
        print *, 'pres_action: ',pres_action
        print *, 'temp_action: ',temp_action
        print *, 'moist_action: ',moist_action
        print *, 'wdir_action: ',wdir_action
        print *, 'wspd_action: ',wspd_action
        print *, 'bl_action: ',bl_action
        print *, 'c_qc: "',NRLQCstg,'"'

      elseif(action.eq.'RT'.or.action.eq.'RM'.or.action.eq.'RW') then  
        NCEPqm = 13 ! QM -> bad (RC already set)

      elseif(action.eq.'SM'.or.action.eq.'SW') then
        NCEPqm = 3  ! QM -> suspect (RC already set)

      else
        cp = 99 ! this is just a dummy statement
                !  leave QM as is (IO,GR)
      endif

c -------------------------------------------------------------
c Set QM, RC info into arrays to be returned to calling routine
c -------------------------------------------------------------
      if(type.eq.'t' .and. NCEPrc_t.ne.99999) then
        NCEPrc = NCEPrc_t
      elseif(type.eq.'q' .and. NCEPrc_q.ne.99999) then
        NCEPrc = NCEPrc_q
      elseif(type.eq.'w' .and. NCEPrc_w.ne.99999) then
        NCEPrc = NCEPrc_w
      endif

      return

  999 continue
 
      write(*,*) '*** Warning! RN is out of range 1-34, here = ',RN
      call w3tage('PREPOBS_PREPACQC')
      call errexit(69)

      end

module pkind
private:: one_dpi; integer(8),parameter:: one_dpi=1
integer,parameter:: dpi=kind(one_dpi)
integer,parameter:: sp=kind(1.0)
integer,parameter:: dp=kind(1.0d0)
integer,parameter:: spc=kind((1.0,1.0))
integer,parameter:: dpc=kind((1.0d0,1.0d0))
end module pkind

c$$$  Subprogram Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Subprogram: sub2mem_mer
c   Programmer: D. Keyser       Org: NP22       Date: 2016-12-09
c
c Abstract: Takes a merged (mass and wind) aircraft data profile, containing NRLACQC events,
c   (read from input arrays *_accum), adds mandatory levels (via interpolation from spanning
c   levels) and stores it in BUFRLIB internal memory.  The calling routine will then call
c   WRITSB in order to write the profile as a single report (subset) into the output
c   PREPBUFR-like file containing merged (mass and wind) aircraft reports. Single(flight)-
c   level reports that are not part of any profile will also be processed here if namelist
c   switch l_prof1lvl=T.  A maximum of 255 level can be included in a profile report here.
c
c Program History Log:
c 2010-11-15  S. Bender  -- Original Author
c 2012-05-08  D. Keyser  -- Prepared for operational implementation
c 2012-11-20  J. Woollen -- Initial port to WCOSS
c 2013-02-07  D. Keyser  -- Final changes to run on WCOSS: use formatted print statements
c                           where previously unformatted print was > 80 characters
c 2014-12-09  Y. Zhu     -- Modified the calculation of vertical velocity rate (stored in
c                           rate_accum) still using a finite-difference method, but now
c                           calculated for both ascents and descents using the nearest
c                           neighboring pair which are at least one minute apart (before,
c                           only only be calculated for descents)
c 2014-12-09  Y. Zhu     -- Add new namelist switch "l_mandlvl" which, when F, will skip
c                           interpolation to mandatory levels
c 2014-12-09  J. Purser/Y. Zhu -- Add new namelist switch "tsplines" which, when T, will
c                           calculate vertical velocity rate (stored in rate_accum) using
c                           Jim Purser's tension-spline interpolation utility to get
c                           continuous gradient results in a profile and mitigate missing
c                           time information
c 2014-12-12  D. Keyser  -- Printout from vertical velocity rate calculation information for
c                           QC'd merged aircraft reports written to profiles PREPBUFR-like
c                           file is written to unit 41 rather than stdout.
c 2015-04-17  Y. Zhu     -- 
c                       1) This subroutine is more robust.  If there is an error in the
c                          generation of vertical velocity rate in the tension-spline
c                          interpolation utility pspl (called in this subroutine), this
c                          subroutine (and thus the program itself) will no longer abort
c                          (with either c. code 62, 63 or 64 depending upon which routine
c                          inside pspl generated the error) but will instead revert to the
c                          finite difference method for calculating vertical velocity rate.  
c                       2) Previously, halfgate was set to be 30 for the data profiles that
c                          don't have second information in time, but a tighter value of 10
c                          for the data profiles that do have second information in time. Now
c                          halfgate is relaxed to be 30 for the data profiles that do have
c                          complete time information.
c 2016-12-09  D. Keyser  --
c                 - Nomenclature change: replaced "MDCRS/ACARS" with just "MDCRS".
c                 - The format for a print statement containing latitude and longitude changed
c                   to print to 5 decimal places since some aircraft reports contain this
c                   precision.
c
c Usage: call sub2mem_mer(proflun,bmiss,mxlv,mxnmev,maxmandlvls,
c                         mandlvls,mesgtype,hdr2wrt,
c                         acid1,c_acftid1,c_acftreg1,
c                         rct_accum,drinfo_accum,acft_seq_accum,
c                         mstq_accum,cat_accum,elv_accum,rpt_accum,
c                         tcor_accum,
c     	                  pevn_accum,pbg_accum,ppp_accum,
c                         qevn_accum,qbg_accum,qpp_accum,
c                         tevn_accum,tbg_accum,tpp_accum,
c                         zevn_accum,zbg_accum,zpp_accum,
c                         wuvevn_accum,wuvbg_accum,wuvpp_accum,
c                         wdsevn_accum,mxe4prof,c_qc_accum,
c                         num_events_prof,lvlsinprof,nlvinprof,
c                         nrlacqc_pc,l_mandlvl,tsplines,l_operational,lwr)
c
c   Input argument list:
c     proflun      - Unit number for the output post-PREPACQC PREPBUFR-like file containing
c                    merged profile reports (always) and single(flight)-level reports not
c                    part of any profile (when l_prof1lvl=T) with added NRLACQC events
c                    (aircraft data only)
c     bmiss        - BUFRLIB missing value (set in main program)
c     mxlv         - Maximum number of levels allowed in a report profile
c     mxnmev       - Maximum number of events allowed, per variable type
c     maxmandlvls  - Maxmum number of mandatory pressure levels to consider for aircraft
c                    profiles
c     mandlvls     - List of mandatory pressure levels to consider for aircraft profiles
c     mesgtype     - PREPBUFR message type (AIRCAR or AIRCFT) of the profile in question
c     hdr2wrt      - Array containing header information for the profile report
c     acid1        - Aircraft flight number for the profile MDCRS report {this will be encoded
c                    into 'ACID' for MDCRS or AMDAR (LATAM only) reports in output PREPBUFR-
c                    like profiles file}
c     c_acftreg    - Aircraft tail number for the profile report as used in NRL QC processing
c                    (passed into this subroutine only for printing purposes)
c     c_acftid     - Aircraft flight number for the profile report as used in NRL QC
c                    processing (passed into this subroutine only for printing purposes)
c     rct_accum    - Array containing receipt time on all profile levels
c     drinfo_accum - Array containing drift coordinates (lat, lon, time) on all profile
c                    levels
c     acft_seq_accum - Array containing the temperature precision and flight phase on all
c                    profile levels
c     mstq_accum   - Array containing the moisture quality flag on all profile levels
c     cat_accum    - Array containing the PREPBUFR level categories on all profile levels
c     elv_accum    - Array containing elevation on all profile levels
c     rpt_accum    - Array containing reported observation time on all profile levels
c     tcor_accum   - Array containing time correction indicator on all profile levels
c     pevn_accum   - Array containing all pressure events (ob, qm, pc, rc) on all profile
c                    levels
c     pbg_accum    - Array containing pressure background information on all profile levels
c     ppp_accum    - Array containing pressure post-processing information on all profile
c                    levels
c     qevn_accum   - Array containing all moisture events (ob, qm, pc, rc) on all profile
c                    levels
c     qbg_accum    - Array containing moisture background information on all profile levels
c     qpp_accum    - Array containing moisture post-processing information on all profile
c                    levels
c     tevn_accum   - Array containing all temperature events (ob, qm, pc, rc) on all profile
c                    levels
c     tbg_accum    - Array containing temperature background information on all profile
c                    levels
c     tpp_accum    - Array containing temperature post-processing information on all profile
c                    levels
c     zevn_accum   - Array containing all altitude events (ob, qm, pc, rc) on all profile
c                    levels
c     zbg_accum    - Array containing altitude background information on all profile levels
c     zpp_accum    - Array containing altitude post-processing information on all profile
c                    levels
c     wuvevn_accum - Array containing all wind (u/v) events (ob, qm, pc, rc) on all profile
c                    levels
c     wuvbg_accum  - Array containing wind (u/v) background information on all profile levels
c     wuvpp_accum  - Array containing wind (u/v) post-processing information on all profile
c                    levels
c     wdsevn_accum - Array containing all wind (direction/speed) events (ob, qm, pc, rc) on
c                    all profile levels
c     mxe4prof     - Maximum number of events in a single-level merged report (i.e., the
c                    maximum amongst the number of pressure, moisture, temperature, altitude,
c                    u/v wind and dir/speed wind events)
c     c_qc_accum   - Array containing NQLACQC quality information 11-character strings on all
c                    profile levels
c     lvlsinprof   - Array containing a list of pressure levels that are present in the
c                    current profile
c     nlvinprof    - Number of levels in profile
c     nrlacqc_pc   - PREPBUFR program code for the NRLACQC step
c     l_mandlvl    - Logical whether to interpolate to mandatory levels in profile generation
c     tsplines     - Logical whether to use tension-splines for aircraft vertical velocity
c                    calculation
c     l_operational- Run program in operational mode if true
c     lwr          - Machine word length in bytes (either 4 or 8)
c
c   Output argument list:
c     hdr2wrt      - Array containing header information for the profile report (TYP undated,
c                    (also changed to highest/lowest pressure level for ascents/descents)
c     num_events_prof - Total number of events on an ob, across all levels, across all
c                    reports (to this point), written into the PREPBUFR-like file (this value
c                    is the same for each ob type)
c     lvlsinprof   - Array containing a list of pressure levels that are present in the
c                    current profile (now possibly also contains mandatory levels)
c
c   Output files:
c     Unit proflun - PREPBUFR-like file containing merged (mass and wind) profile reports
c                    (always) and single(flight)-level reports not part of any profile (when
c                    l_prof1lvl=T) with NRLACQC events
c     Unit 06      - Standard output print
c     Unit 52      - Text file containing listing of all QC'd merged aircraft reports written
c                    to profiles PREPBUFR-like file
c
c   Subprograms called:
c     Unique:    none
c     Library:
c       SYSTEM:  SYSTEM
c       BUFRLIB: UFBINT      IBFMS
c       W3NCO:   W3TAGE      ERREXIT
c       W3EMC:   ORDERS
c
c   Exit States:
c     Cond =  0 - successful run
c            59 - nlvinprof is zero coming into this subroutine (should never happen!)
c            61 - index "j is .le. 1 meaning "iord" array underflow (should never happen!)
c
c Remarks: Called by subroutine output_acqc_prof.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine sub2mem_mer(proflun,bmiss,mxlv,mxnmev,maxmandlvls,
     +                       mandlvls,mesgtype,hdr2wrt,
     +                       acid1,c_acftid1,c_acftreg1,
     +                       rct_accum,drinfo_accum,acft_seq_accum,
     +                       mstq_accum,cat_accum,elv_accum,rpt_accum,
     +                       tcor_accum,
     +	                     pevn_accum,pbg_accum,ppp_accum,
     +                       qevn_accum,qbg_accum,qpp_accum,
     +                       tevn_accum,tbg_accum,tpp_accum,
     +                       zevn_accum,zbg_accum,zpp_accum,
     +                       wuvevn_accum,wuvbg_accum,wuvpp_accum,
     +                       wdsevn_accum,mxe4prof,c_qc_accum,
     +                       num_events_prof,lvlsinprof,nlvinprof,
     +                       nrlacqc_pc,l_mandlvl,tsplines,
     +                       l_operational,lwr)

      use pkind, only: dp
      use pspl, only: bnewton,best_slalom,count_gates,convertd,
     +                convertd_back
      implicit none

c ------------------------------
c Parameter statements/constants
c ------------------------------
      integer      proflun             ! output unit number for post-PREPACQC PREPBUFR-like
                                       !  file containing merged profile reports (always) and
                                       !  single(flight)-level reports not part of any
                                       !  profile (when l_prof1lvl=T) with added NRLACQC
                                       !  events

      real*8       bmiss               ! BUFRLIB missing value (set in main program)

c Variables used to write data to output PREPBUFR-like file in sorted order
c -------------------------------------------------------------------------
      integer      mxlv                ! maximum number of report levels allowed in aircraft
                                       !  profiles
      character*6  cmxlv               ! character form of mxlv

      integer      mxnmev              ! maximum number of events allowed in stack
     +,            lvlsinprof(mxlv)    ! array containing a list of pressure levels that are
                                       !  present in the current profile (later changed to
                                       !  add mandatory levels)
     +,            mxe4prof            ! maximum number of events in a single-level merged
                                       !  report (i.e., the maximum amongst the number of
                                       !  pressure, moisture, temperature, altitude, u/v wind
                                       !  and dir/speed wind events)
     +,            nlvinprof           ! number of levels in a profile upon input

      real*8   hdr2wrt(15)             ! header info for current profile (passed in)
     +,        drinfo_accum(3,mxlv)    ! array used to accumulate drift info across profile
                                       !  levels
     +,        acft_seq_accum(2,mxlv)  ! array used to accumulate ACFT_SEQ (PCAT -temperature
                                       !  precision, POAF - phase of flight) info across
                                       !  profile levels
     +,        mstq_accum(1,mxlv)      ! array used to accumulate moisture QC marks across
                                       !  profile levels
     +,        cat_accum(1,mxlv)       ! array used to accumulate level category markers
                                       !  across profile levels
     +,        elv_accum(1,mxlv)       ! array used to accumulate elevation across profile
                                       !  levels
     +,        rpt_accum(1,mxlv)       ! array used to accumulate reported obs time across
                                       !  profile levels
     +,        tcor_accum(1,mxlv)      ! array used to accumulate time correction factor
                                       !  across profile levels
     +,        rct_accum(1,mxlv)       ! array used to accumulate receipt time across profile
                                       !  levels

      real*8   pevn_accum(4,mxlv,mxnmev)! array used to accumulate pressure data/events for a
                                        !  single profile, across profile levels
     +,        pbg_accum(3,mxlv)        ! array used to accumulate pressure background info
                                        !  (POE, PFC, PFCMOD) for a single profile, across
                                        !  profile levels
     +,        ppp_accum(3,mxlv)        ! array used to accumulate pressure post-processing
                                        !  info (PAN, PCL, PCS) for a single profile, across
                                        !  profile levels

      real*8   qevn_accum(4,mxlv,mxnmev)! array used to accumulate moisture data/events for a
                                        !  single profile, across profile levels
     +,        qbg_accum(3,mxlv)        ! array used to accumulate moisture background info
                                        !  (QOE, QFC, QFCMOD) for a single profile, across
                                        !  profile levels
     +,        qpp_accum(3,mxlv)        ! array used to accumulate moisture post-processing
                                        !  info (QAN, QCL, QCS) for a single profile, across
                                        !  profile levels

      real*8   tevn_accum(4,mxlv,mxnmev)! array used to accumulate temperature data/events
                                        !  for a single profile, across profile levels
     +,        tbg_accum(3,mxlv)        ! array used to accumulate temperature background
                                        !  info (TOE, TFC, TFCMOD) for a single profile,
                                        !  across profile levels
     +,        tpp_accum(3,mxlv)        ! array used to accumulate temperature post-
                                        !  processing info (TAN, TCL, TCS) for a single
                                        !  profile, across profile levels

      real*8   zevn_accum(4,mxlv,mxnmev)! array used to accumulate altitude data/events for a
                                        !  single profile, across profile levels
     +,        zbg_accum(3,mxlv)        ! array used to accumulate altitude background info
                                        !  (ZOE, ZFC, ZFCMOD) for a single profile, across
                                        !  profile levels
     +,        zpp_accum(3,mxlv)        ! array used to accumulate altitude post-processing
                                        !  info (ZAN, ZCL, ZCS) for a single profile, across
                                        !  profile levels

      real*8   wuvevn_accum(5,mxlv,mxnmev)! array used to accumulate wind data/events (u/v
                                          !  components) for a single profile, across profile
                                          !  levels
     +,        wuvbg_accum(5,mxlv)      ! array used to accumulate wind background info (WOE,
                                        !  UFC, VFC, UFCMOD, VFCMOD)  for a single profile,
                                        !  across profile levels
     +,        wuvpp_accum(6,mxlv)      ! array used to accumulate wind post-processing info
                                        !  (UAN, VAN, UCL, VCL, UCS, VCS) for a single
                                        !  profile, across profile levels

      real*8   wdsevn_accum(5,mxlv,mxnmev)! array used to accumulate wind data/events
                                          !  (direction/speed) for a single profile, across
                                          !  profile levels

      character*11 c_qc_accum(mxlv)    ! array used to accumulate NRLACQC quality information
                                       !  on individual obs in a profile, across profile
                                       !  levels

c Logicals controlling processing (not read in from namelist in main program)
c ---------------------------------------------------------------------------
      logical l_mandlvl                ! T=interpolate to mandatory levels in profile
                                       !   generation
                                       ! F=do not interpolate to mandatory levels in profile
                                       !   generation
      logical tsplines                 ! T=use tension-splines for aircraft vertical velocity
                                       !   calculation
                                       ! F=use finite-differencing for aircraft vertical
                                       !   velocity calculation
      logical l_operational            ! Run program  in operational mode if true

c Summary counters
c ----------------
      integer num_events_prof          ! total number of events on an ob, across all levels,
                                       !  across all reports, written in the PREPBUFR-like
                                       !  (profiles) file (this value is the same for each
                                       !  ob type)
c Mandatory levels settings
c -------------------------
      integer maxmandlvls              ! maxmum number of mandatory pressure levels to
                                       !  consider for aircraft profiles
     +,       mandlvls(maxmandlvls)    ! list of mandatory pressure levels to consider for
                                       !  aircraft profiles
     +,       nmandlvls                ! number of mandatory levels interpolated for this
                                       !  profile
     +,       nmNbtw                   ! number of mandatory levels between "bread of the
                                       !  sandwich" reports

      character*8 mesgtype             ! BUFR message type (e.g., 'AIRCFT  ')

      real*8      acid1                ! aircraft flight number for the profile MDCRS or AMDAR
                                       !  (LATAM only) report
     +,           acid_arr1            ! used with ufbint routine to encode aircraft flight
                                       !  number (ACID) into MDCRS or AMDAR (LATAM only)
                                       !  reports in output PREPBUFR-like file)

      character*9  c_acftid1           ! aircraft flight number (as processed by NRLACQC)
                                       !  for the profile report (used for printing purposes
                                       !  only)

      character*8  c_acftreg1          ! aircraft tail number (as processed by NRLACQC)
                                       !  for the profile report (used for printing purposes
                                       !  only)

      integer     nlv2wrt_tot          ! total number of levels to write in this profile,
                                       !  including any interpolated mandatory levels
      character*6 cnlv2wrt_tot         ! character form of nlv2wrt_tot

      integer     nlv2wrt              ! number of levels in profile to write to output	
      character*6 cnlv2wrt             ! character form of nlv2wrt

      integer     nlvwrt               ! number of levels written to output PREPBUFR-like
                                       !  file

      real*8      pevns4(4,mxlv)       ! array used with ufbint routine to encode pressure
                                       !  events into output PREPBUFR-like file
     +,           qevns4(4,mxlv)       ! array used with ufbint routine to encode moisture
                                       !  events into output PREPBUFR-like file
     +,           tevns4(4,mxlv)       ! array used with ufbint routine to encode temperature
                                       !  events into output PREPBUFR-like file
     +,           zevns4(4,mxlv)       ! array used with ufbint routine to encode altitude
                                       !  events into output PREPBUFR-like file
     +,           wuvevns5(5,mxlv)     ! array used with ufbint routine to encode wind (u/v
                                       !  component) events into output PREPBUFR-like file
     +,	          wdsevns5(5,mxlv)     ! array used with ufbint routine to encode wind
                                       !  (direction/speed) events into output PREPBUFR-like
                                       !  file

c For background/post-processing info
c -----------------------------------
      real*8      pbgarr3(3,mxlv)      ! array used with ufbint routine to encode pressure
                                       !  background info into output PREPBUFR-like file
     +,	          qbgarr3(3,mxlv)      ! array used with ufbint routine to encode moisture
                                       !  background info into output PREPBUFR-like file
     +,	          tbgarr3(3,mxlv)      ! array used with ufbint routine to encode temperature
                                       !  background info into output PREPBUFR-like file
     +,	          zbgarr3(3,mxlv)      ! array used with ufbint routine to encode altitude
                                       !  background info into output PREPBUFR-like file
     +,	          wuvbgarr5(5,mxlv)    ! array used with ufbint routine to encode wind (u/v
                                       !  component) background info into output PREPBUFR-
                                       ! like file
     +,           ppparr3(3,mxlv)      ! array used with ufbint routine to encode pressure
                                       !  post-processing info into output PREPBUFR-like file
     +,           qpparr3(3,mxlv)      ! array used with ufbint routine to encode moisture
                                       !  post-processing info into output PREPBUFR-like file
     +,	          tpparr3(3,mxlv)      ! array used with ufbint routine to encode temperature
                                       !  post-processing info into output PREPBUFR-like file
     +,	          zpparr3(3,mxlv)      ! array used with ufbint routine to encode altitude
                                       !  post-processing info into output PREPBUFR-like file
     +,	          wuvpparr6(6,mxlv)    ! array used with ufbint routine to encode wind (u/v
                                       !  component) info into output PREPBUFR-like file
     +,	          drarr3(3,mxlv)       ! array used with ufbint routine to encode drift info
                                       !  into output PREPBUFR-like file
     +,	          acft_seq_arr2(2,mxlv)! array used with ufbint routine to encode PCAT, POAF
                                       !  into output PREPBUFR-like file
     +,	          mstq_arr1(1,mxlv)    ! array used with ufbint routine to encode moisture QC
                                       !  flag into output PREPBUFR-like file
     +,	          cat_arr1(1,mxlv)     ! array used with ufbint routine to encode level
                                       !  category info into output PREPBUFR-like file
     +,           rct_arr1(1,mxlv)     ! array used with ufbint routine to encode level
                                       !  receipt time info into output PREPBUFR-like file
     +,	          ialr_arr1(1,mxlv)    ! array used with ufbint routine to encode ascent/
                                       !  descent rate into output PREPBUFR-like file
     +,	          turb_arr4(4,mxlv)    ! array used with ufbint routine to encode turbulence
                                       !  data into output PREPBUFR-like file

C Arrays associated with sorting of data
c --------------------------------------
      integer  iwork(mxlv)             ! work array
     +,        iord(mxlv)              ! array containing sorted index

C Loop indices
c ------------
      integer  i,j,k,l                 ! original (unsorted) indices
     +,        iii                     ! index
     +,        jj                      ! sorted (pressure low->high) index pointing to lvl j
     +,        jjp1                    ! sorted index pointing to next level below jj
     +,        jjm1                    ! sorted index pointing to previous level above jj
     +,        jjp2                    ! sorted index pointing to next level below jjp1
     +,        jjm2                    ! sorted index pointing to previous level above jjm1
     +,        jjmaxp                  ! sorted index pointing to level jj with max pressure
     +,        jjminp                  ! sorted index pointing to level jj with min pressure
     +,        jjpnmnbtw               ! sorted index pointing to next level below jj that is
                                       !  not a mandatory pressure level
     +,        jk                      ! index,
     +,        c1_jk                   ! index,
     +,        c2_jk                   ! index,
     +,        jkp                     ! index,
     +,        jkm                     ! index, 
     +,        jjp                     ! index,
     +,        jjm                     ! index,
     +,        kk                      ! sorted (pressure low->high) index pointing to lvl k
     +,        jjpk                    ! sorted index pointing to level jj plus k

      real     pul                     ! pressure ob at level "below" mandatory level (higher
                                       !  pressure, lower altitude)
     +,        pll                     ! pressure ob at level "above" mandatory level (lower
                                       !  pressure, higher altitude)
     +,        pqul                    ! pressure qm at level "below" mandatory level (higher
                                       !  pressure, lower altitude)
     +,        pqll                    ! pressure qm at level "above" mandatory level (lower
                                       !  pressure, higher altitude)
     +,        pml                     ! pressure ob at mandatory level
     +,        tul                     ! temperature ob at level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        tll                     ! temperature ob at level "above" mandatory level
                                       !  (lower pressure, higher altitude)
     +,        tqul                    ! temperature qm at level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        tqll                    ! temperature qm at level "above" mandatory level
                                       !  (lower pressure, higher altitude)
     +,	       tml                     ! temperature ob at mandatory level
     +,	       dt_dlnp                 ! change in temperature w.r.t. change in log-pressure
     +,	       qul                     ! moisture ob at level "below" mandatory level (higher
                                       !  pressure, lower altitude)
     +,	       qll                     ! moisture ob at level "above" mandatory level (lower
                                       !  pressure, higher altitude)
     +,	       qqul                    ! moisture qm at level "below" mandatory level (higher
                                       !  pressure, lower altitude)
     +,        qqll                    ! moisture qm at level "above" mandatory level (lower
                                       !  pressure, higher altitude)
     +,	       qml                     ! moisture ob at mandatory level
     +,	       dq_dlnp                 ! change in moisture w.r.t. change in log-pressure
     +,	       zul                     ! altitude ob at level "below" mandatory level (higher
                                       !  pressure, lower altitude)
     +,	       zll                     ! altitude ob at level "above" mandatory level (lower
                                       !  pressure, higher altitude)
     +,	       zqul                    ! altitude qm at level "below" mandatory level (higher
                                       !  pressure, lower altitude)
     +,        zqll                    ! altitude qm at level "above" mandatory level (lower
                                       !  pressure, higher altitude)
     +,        zml                     ! altitude ob at mandatory level
     +,        dz_dlnp                 ! change in altitude w.r.t. change in log-pressure
     +,        uul                     ! u-comp of wind ob at level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        ull                     ! u-comp of wind ob at level "above" mandatory level
                                       !  (lower pressure, higher altitude)
     +,        uml                     ! u-comp of wind ob at mandatory level
     +,        du_dlnp                 ! change in u-comp of wind w.r.t. change in
                                       !  log-pressure
     +,        vul                     ! v-comp of wind ob at level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        vll                     ! v-comp of wind ob at level "above" mandatory level
                                       !  (lower pressure, higher altitude)
     +,        vml                     ! v-comp of wind ob at mandatory level
     +,        dv_dlnp                 ! change in v-comp of wind w.r.t. change in
                                       !  log-pressure
     +,        uvqul                   ! u/v-comp of wind qm at level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        uvqll                   ! u/v-comp of wind qm at level "above" mandatory level
                                       !  (lower pressure, higher altitude)

      integer  ibfms                   ! BUFRLIB function for testing for missing

      real*8   dtime_dlnp              ! change in time w.r.t. change in log-pressure

      real     dist_pul_pll            ! horizontal distance traveled when going from point
                                       !  at pll to pul
     +,	       spd_pul_pll             ! average speed while traveling from point at pll to
                                       !  pul
     +,        dist2pml                ! horizontal distance traveled when going from point
                                       !  at pll to pml
! vvvv DAK-future change perhaps to account for incr. lat/lon precision
     +,        lat_pul                 ! latitude at data level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        lon_pul                 ! longitude at data level "below" mandatory level
                                       !  (higher pressure, lower altitude)
     +,        lat_pll                 ! latitude at data level "above" mandatory level
                                       !  (lower pressure, higher altitude)
     +,        lon_pll                 ! longitude at data level "above" mandatory level
                                       !  (lower pressure, higher altitude)
! ^^^^ DAK-future change perhaps to account for incr. lat/lon precision
     +,        radius_e                ! radius of the earth in meters
     +,        deg2rad                 ! conversion factor for converting degrees -> radians

      parameter(radius_e = 6371229.)
      parameter(deg2rad = 3.14159274/180.)

      real*8   delx                    ! change in longitude/nmNbtw
     +,        dely                    ! change in latitude/nmNbtw
     +,        dt                      ! delta time (sec) between two levels, used to
                                       !  calculate instantaneous altitude (ascent/descent)
                                       !  rate
     +,        dt_new                  ! delta time
     +,        rate_accum(mxlv)        ! array of instantaneous altitude (ascent/descent)
                                       !  rates on all levels of profile

c Variables used in printing values for a particular report and level
c -------------------------------------------------------------------
      integer  ihdr2wrt9               ! PREPBUFR instrument type ("ITP" from header)
     +,        iacft_seq_accum2        ! temperature precision, and phase of flight
     +,        idrinfo_accum3          ! drift information
     +,        izevn_accum1            ! altitude ob
     +,        iwdsevn_accum1          ! wind direction ob
     +,        ipevn_accum2            ! pressure quality mark
     +,        izevn_accum2            ! altitude quality mark
     +,        itevn_accum2            ! temperature quality mark
     +,        iqevn_accum2            ! moisture quality mark
     +,        iwuvevn_accum3          ! wind quality mark
     +,        ipevn_accum4            ! pressure reason code 
     +,        izevn_accum4            ! altitude reason code
     +,        itevn_accum4            ! temperature reason code
     +,        iqevn_accum4            ! moisture code
     +,        iwuvevn_accum5          ! wind reason code
     +,        nevents_t               ! number of events on temperature
     +,        nevents_q               ! number of events on moisture
     +,        nevents_w               ! number of events on wind
     +,        imstq_accum1            ! moisture qc flag
     +,        icat_accum1             ! PREPBUFR level category ("CAT")
     +,        ihdr2wrt6               ! PREPBUFR report type ("TYP" from header)

      real*8       wspd                ! wind speed ob
     +,            q_sphum             ! moisture (specific humidity) ob
     +,            hdr2wrt1            ! real form of PREPBUFR report id ("SID" from header)

c Misc.
c -----
      real        nrlacqc_pc           ! PREPBUFR program code for the NRLACQC step

      integer     lwr                  ! machine word length in bytes (either 4 or 8)

c Variables related to tspline
      integer, parameter:: nit=30
!     real(dp),parameter:: bigT=120.0,halfgate=30.0,heps=.01
      real(dp),parameter:: bigT=120.0,heps=.01
      integer nh,nh2,m,mh,maxita,maxitb,maxit,maxrts,doru
      integer err_tspline
      real(dp) enbest,timemin
      real(dp) halfgate
      integer, allocatable :: idx(:)
      integer, allocatable :: modebest(:)
      integer, allocatable :: pof(:)
      integer, allocatable :: hgts(:)
      integer, allocatable :: hgtp(:)
      real, allocatable :: tdata(:),hdata(:),wdata(:)
      real(dp), allocatable :: te(:),hs(:),dhdt(:)
      real(dp), allocatable :: hp(:)
      real(dp), allocatable :: qbest(:),habest(:)
      logical descending,FF,nearsec

c ----------------------------------------------------

c Start program
c -------------
ccc   print *, 'in sub2mem_mer for the next merged report'

      rate_accum = bmiss

      if(nlvinprof.eq.0) then
        print *
        print *, '### PROBLEM - into subr, sub2mem_mer with nlvinprof ',
     +           '= ',0
        print *, '              this should never happen!!'
        print *
        call w3tage('PREPOBS_PREPACQC')
        call errexit(59)
      endif

c First sort pressures from lowest to highest, this will also determine the maximum and
c  minimum pressure values in this profile
c -------------------------------------------------------------------------------------
      call orders(1,iwork,lvlsinprof,iord,nlvinprof,1,lwr,2)

ccc   print *, '.. there are originally ',nlvinprof,' p-levels in this',
ccc  +         ' report'

c Interpolate z,t,q,u,v values to mandatory levels - include the levels of 1000, 850, 700,
c  500, 400, 300, 200, 150 and 100 mb in the acceptable mandatory levels for aircraft
c  profiles (not many aircraft flying above 100 mb!)
c ---------------------------------------------------------------------------------------
      nmandlvls = 0
      nlv2wrt_tot = nlvinprof

      if(l_mandlvl .and. nlvinprof.gt.1) then ! do interpolation only for profiles with
                                              !  more than one report!
        loop1: do i = 1,maxmandlvls   ! maxmandlvls=9 - number of mandatory levels to check
          do j = 1,nlvinprof          !  levels will appear in increasing order via index
                                      !  jj... first level might be 247 mb, second might be
                                      !  427 mb, etc.
            jj = iord(j)
            jjp1 = iord(j+1)

            if(j.lt.nlvinprof) then   ! exclude last level in profile (one closest to the
                                      !  ground) (use .lt. instead of .le. to do this); only
                                      !  interpolate for mandatory levels sandwiched by
                                      !  actual data

c Below, jj points to level at a lower pressure/higher altitude and jjp1 points to the
c  adjacent level at a higher pressure, lower altitude)
c ------------------------------------------------------------------------------------
              if(lvlsinprof(jj)  .lt.mandlvls(i) .and.
     +	         lvlsinprof(jjp1).gt.mandlvls(i)) then
 
                if(nlvinprof+nmandlvls+1.gt.mxlv) then
C.......................................................................
C There are more levels in profile than "mxlv" -- do not process any more levels
C ------------------------------------------------------------------------------
                  print 53, mxlv,mxlv
   53 format(/' #####> WARNING: THERE ARE MORE THAN ',I6,' LEVELS IN ',
     + 'THIS PROFILE -- WILL CONTINUE ON PROCESSING ONLY ',I6,' LEVELS',
     + ' FOR THIS PROFILE'/)
                  write(cmxlv,'(i6)') mxlv
                  call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     +             ' "$jlogfile" "***WARNING:'//cmxlv//' AIRCRAFT '//
     +             'PROFILE LEVEL LIMIT EXCEEDED IN '//
     +             'PREPOBS_PREPACQC, ONLY '//cmxlv//' LEVELS '//
     +             'PROCESSED"')
                  exit loop1
C.......................................................................
                endif

                nmandlvls = nmandlvls + 1

c Now calculate values on mandlvls(i) using values at lvlsinprof(j) (ll/lower level and (j+1)
c  (ul/upper level) - USE REASON CODE 98 FOR INTERPOLATED MANDATORY LEVELS (use highest
c  quality mark amongst lower and upper levels)
c -------------------------------------------------------------------------------------------
                pll  = lvlsinprof(jj)       ! pressure ob at level "above" mandatory level
                pul  = lvlsinprof(jjp1)     ! pressure ob at level "below" mandatory level
                pqll = pevn_accum(2,jj,1)   ! pressure qm at level "above" mandatory level
                pqul = pevn_accum(2,jjp1,1) ! pressure qm at level "below" mandatory level
                pml = mandlvls(i)           ! pressure at mandatory level

                lvlsinprof(nlvinprof+nmandlvls) = mandlvls(i)
                pevn_accum(1,nlvinprof+nmandlvls,1) = pml/10.           ! POB
                pevn_accum(2,nlvinprof+nmandlvls,1) = max(pqll,pqul)    ! PQM 
                pevn_accum(3,nlvinprof+nmandlvls,1) = nrlacqc_pc        ! PPC
                pevn_accum(4,nlvinprof+nmandlvls,1) = 98                ! PRC

                cat_accum(1,nlvinprof+nmandlvls) = 7 ! interpolated mand. levels get CAT = 7

c Temperature
c -----------
                if(ibfms(tevn_accum(1,jj,1)).eq.0 .and.
     +             ibfms(tevn_accum(1,jjp1,1)).eq.0 ) then ! temperature isn't missing
                  do iii = mxe4prof,1,-1
                    if(ibfms(tevn_accum(1,jj,iii)).ne.0) then
                      nevents_t = iii
                    else
                      nevents_t = iii
                      exit
                    endif
                  enddo
                  tll  = tevn_accum(1,jj,nevents_t)   ! temp ob at lvl "above" mandatory level
                  tqll = tevn_accum(2,jj,nevents_t)   ! temp qm at lvl "above" mandatory level
                  do iii = mxe4prof,1,-1
                    if(ibfms(tevn_accum(1,jjp1,iii)).ne.0) then
                      nevents_t = iii
                    else
                      nevents_t = iii
                      exit
                    endif
                  enddo
                  tul  = tevn_accum(1,jjp1,nevents_t) ! temp ob at lvl "below" mandatory level
                  tqul = tevn_accum(2,jjp1,nevents_t) ! temp qm at lvl "below" mandatory level
ccccc             print *, 'pmd, pll, pul, tqll,tqul: ',pml, pll, pul,
ccccc+                      tqll,tqul

                  dt_dlnp = (tul - tll)/alog(pul/pll)

                  tml = tll + (dt_dlnp * (alog(pml/pll)))

                  tevn_accum(1,nlvinprof+nmandlvls,1) = tml             ! TOB
                  tevn_accum(2,nlvinprof+nmandlvls,1) = max(tqll,tqul)  ! TQM 
                  tevn_accum(3,nlvinprof+nmandlvls,1) = nrlacqc_pc      ! TPC
                  tevn_accum(4,nlvinprof+nmandlvls,1) = 98              ! TRC

                endif ! temps missing?

c Moisture
c --------
                if(ibfms(qevn_accum(1,jj,1)).eq.0 .and.
     +             ibfms(qevn_accum(1,jjp1,1)).eq.0 ) then ! moisture isn't missing
                  do iii = mxe4prof,1,-1
                    if(ibfms(qevn_accum(1,jj,iii)).ne.0) then
                      nevents_q = iii
                    else
                      nevents_q = iii
                      exit
                    endif
                  enddo
                  qll  = qevn_accum(1,jj,nevents_q)   ! q ob at level "above" mandatory level
                  qqll = qevn_accum(2,jj,nevents_q)   ! q qm at level "above" mandatory level
                  do iii = mxe4prof,1,-1
                    if(ibfms(qevn_accum(1,jjp1,iii)).ne.0) then
                      nevents_q = iii
                    else
                      nevents_q = iii
                      exit
                    endif
                  enddo
                  qul  = qevn_accum(1,jjp1,nevents_q) ! q ob at level "below" mandatory level
                  qqul = qevn_accum(2,jjp1,nevents_q) ! q qm at level "below" mandatory level

                  dq_dlnp = (qul - qll)/alog(pul/pll)

                  qml = qll + (dq_dlnp * (alog(pml/pll)))

                  qevn_accum(1,nlvinprof+nmandlvls,1) = qml             ! QOB
                  qevn_accum(2,nlvinprof+nmandlvls,1) = max(qqll,qqul)  ! QQM 
                  qevn_accum(3,nlvinprof+nmandlvls,1) = nrlacqc_pc      ! QPC
                  qevn_accum(4,nlvinprof+nmandlvls,1) = 98              ! QRC

                else ! if moisture missing, check to see if QFC is present for "bread"
                     !  levels; if so, interpolate QFC
                  if(ibfms(qbg_accum(2,jj)).eq.0 .and.
     +	             ibfms(qbg_accum(2,jjp1)).eq.0 ) then ! QFC isn't missing for "bread"
                                                          !  levels
                    qll = qbg_accum(2,jj)     ! QFC at ob level "above" mandatory level
                    qul = qbg_accum(2,jjp1)   ! QFC at ob level "below" mandatory level

                    dq_dlnp = (qul - qll)/alog(pul/pll)

                    qml = qll + (dq_dlnp * (alog(pml/pll)))

                    qbg_accum(2,nlvinprof+nmandlvls) = qml ! QFC

                  endif ! is QFC present for "bread" levels when moisture missing?
                endif ! moisture missing?

c Altitude
c --------
                if(ibfms(zevn_accum(1,jj,1)).eq.0 .and.
     +             ibfms(zevn_accum(1,jjp1,1)).eq.0 ) then ! altitude isn't missing
                  zll  = zevn_accum(1,jj,1)           ! z ob at level "above" mandatory level
                  zul  = zevn_accum(1,jjp1,1)         ! z ob at level "below" mandatory level
                  zqll = zevn_accum(2,jj,1)           ! z qm at level "above" mandatory level
                  zqul = zevn_accum(2,jjp1,1)         ! z qm at level "below" mandatory level

                  dz_dlnp = (zul - zll)/alog(pul/pll)

                  zml = zll + (dz_dlnp * (alog(pml/pll)))

                  zevn_accum(1,nlvinprof+nmandlvls,1) = zml             ! ZOB
                  zevn_accum(2,nlvinprof+nmandlvls,1) = max(zqll,zqul)  ! ZQM 
                  zevn_accum(3,nlvinprof+nmandlvls,1) = nrlacqc_pc      ! ZPC
                  zevn_accum(4,nlvinprof+nmandlvls,1) = 98              ! ZRC

                endif ! altitude missing?

c u- and v- components of wind
c ----------------------------
                if(ibfms(wuvevn_accum(1,jj,1)).eq.0 .and.
     +             ibfms(wuvevn_accum(1,jjp1,1)).eq.0 .and.
     +             ibfms(wuvevn_accum(2,jj,1)).eq.0 .and.
     +             ibfms(wuvevn_accum(2,jjp1,1)).eq.0) then ! u and v aren't missing
                  do iii = mxe4prof,1,-1
                    if(ibfms(wuvevn_accum(1,jj,iii)).ne.0 .or.
     +                 ibfms(wuvevn_accum(2,jj,iii)).ne.0) then
                      nevents_w = iii
                    else
                      nevents_w = iii
                      exit
                    endif
                  enddo
                  ull   = wuvevn_accum(1,jj,nevents_w)  ! UOB ob at lvl "above" mandatory lvl
                  vll   = wuvevn_accum(2,jj,nevents_w)  ! VOB ob at lvl "above" mandatory lvl
                  uvqll = wuvevn_accum(3,jj,nevents_w)  ! UOB/VOB qm at lvl "above" mandatory
                                                        !  lvl
                  do iii = mxe4prof,1,-1
                    if(ibfms(wuvevn_accum(1,jjp1,iii)).ne.0 .or.
     +                ibfms(wuvevn_accum(2,jjp1,iii)).ne.0) then
                      nevents_w = iii
                    else
                      nevents_w = iii
                      exit
                    endif
                  enddo
                  uul   = wuvevn_accum(1,jjp1,nevents_w) ! UOB ob at lvl "below" mandatory lvl
                  vul   = wuvevn_accum(2,jjp1,nevents_w) ! VOB ob at lvl "below" mandatory lvl
                  uvqul = wuvevn_accum(3,jjp1,nevents_w) ! UOB/VOB qm at lvl "below" mandatory
                                                         !  lvl

                  du_dlnp = (uul - ull)/alog(pul/pll)
                  dv_dlnp = (vul - vll)/alog(pul/pll)

                  uml = ull + (du_dlnp * (alog(pml/pll)))
                  vml = vll + (dv_dlnp * (alog(pml/pll)))

                  wuvevn_accum(1,nlvinprof+nmandlvls,1) = uml           ! UOB
                  wuvevn_accum(2,nlvinprof+nmandlvls,1) = vml           ! VOB
                  wuvevn_accum(3,nlvinprof+nmandlvls,1) =
     +             max(uvqll,uvqul)                                     ! WQM 
                  wuvevn_accum(4,nlvinprof+nmandlvls,1) = nrlacqc_pc    ! WPC
                  wuvevn_accum(5,nlvinprof+nmandlvls,1) = 98            ! WRC

                endif ! wind missing?

              endif ! calc values for this mandatory level?
            endif ! j.lt.nlvinprof
          enddo ! j = 1,nlvinprof
        enddo loop1 ! i = 1,maxmandlvls

        nlv2wrt_tot = nlvinprof + nmandlvls
ccc     print'(" .. there are eventually ",I0," p-levels in this ",
ccc  +         "report (incl. mand. levels to which obs interp. to)")',
ccc          nlv2wrt_tot

c Re-sort pressures (now with mandatory levels inclded) from lowest to highest
c ----------------------------------------------------------------------------
        call orders(1,iwork,lvlsinprof,iord,nlv2wrt_tot,1,lwr,2)

      end if ! l_mandlvl .and. nlvinprof.gt.1

c -----------------------------------------
c Calculate vertical velocity rate_accum
c add ascent/descent rate here
c -----------------------------------------
      write(41,*) 'nlv2wrt_tot=', nlv2wrt_tot,'c_acftreg=',c_acftreg1
      err_tspline = 0

      if ((nlv2wrt_tot.gt.1) .and. tsplines) then
         nh = 0
         do j = 1,nlv2wrt_tot
            jj = iord(j)
            if (ibfms(drinfo_accum(3,jj)).eq.0) then
               nh = nh + 1
c              write(41,*) 'j,ord,z,t=', j, jj,zevn_accum(1,jj,1),
c    +                 drinfo_accum(3,jj)
            end if
         end do
         nh2 = nh * 2

         halfgate=30.0
!        nearsec=.false.
!        do j = 1,nlv2wrt_tot
!           jj = iord(j)
!           if (ibfms(drinfo_accum(3,jj)).eq.0) then
!              timemin=drinfo_accum(3,jj)*60.0
!              timemin=abs(timemin-nint(timemin))
!              if (timemin>=0.01 .and. timemin<=0.99) nearsec=.true.
!           end if
!        end do
!        if (nearsec) halfgate=10.0
         write(41,*) 'halfgate=', halfgate

         allocate(idx(nh),pof(nh))
         allocate(tdata(nh),hdata(nh),wdata(nh))
         allocate(te(nh),hgts(nh),hs(nh),dhdt(nh))
         maxita = 0
         maxitb = 0
         maxrts = 0
         maxit  = 0

         nh = 0
         do j = 1,nlv2wrt_tot
            jj = iord(j)
            if (ibfms(drinfo_accum(3,jj)).eq.0) then
               nh = nh + 1
               tdata(nh) = drinfo_accum(3,jj) ! hours
               hdata(nh) = zevn_accum(1,jj,1) ! meters
               pof(nh)   = nint(acft_seq_accum(2,jj))
               write(41,*) 'tdata,hdata,pof=',nh,tdata(nh),hdata(nh),
     +          pof(nh)
            end if
         end do

c        arrange data with time increase
         call convertd(nh,halfgate,tdata,hdata,pof,
     +        doru,idx,hgts,hs,descending,FF)
!!!!!!!! if (FF) call w3tage('PREPOBS_PREPACQC')
!!!!!!!! if (FF) call errexit(62)
         if (FF) then 
c Error generating vertical velocity rate in tension-spline interpolation utility pspl
c  (coming out of subroutine convertd) - use finite difference method
c ------------------------------------------------------------------------------------
            print*,"WARNING: tspline err in utility pspl, coming out ",
     +             "of subr. convertd - use finite difference method" 
            write(41,*)"WARNING: tspline err in utility pspl, coming ",
     +                 "out of subr. convertd - use finite difference ",
     +                 "method" 
            err_tspline = 1
            go to 666
         end if
         if (descending)then
            write(41,'('' set descending'')')
         else
            write(41,'('' set ascending'')')
         endif

         call count_gates(nh,hgts(1:nh),mh)
         m = mh*2
         allocate(hgtp(m),hp(m),qbest(m),habest(m),modebest(mh))
         call best_slalom(nh,mh,doru,hgts,hs,halfgate,bigT,hgtp,hp,
     +     qbest,habest,enbest,modebest,maxita,maxitb,maxit,maxrts,FF)
          write(41,*) 'maxita,maxitb,maxit,maxrts=',maxita,maxitb,maxit,
     +     maxrts
!!!!!!!! if (FF) call w3tage('PREPOBS_PREPACQC')
!!!!!!!! if (FF) call errexit(63)
         if (FF) then 
c Error generating vertical velocity rate in tension-spline interpolation utility pspl
c  (coming out of subroutine best_slalom) - use finite difference method
c ------------------------------------------------------------------------------------
            print*,"WARNING: tspline err in utility pspl, coming out ",
     +             "of subr. best_slalom - use finite difference method" 
            write(41,*)"WARNING: tspline err in utility pspl, coming ",
     +                 "out of subr. best_slalom - use finite ",
     +                 "difference method" 
            err_tspline = 1
            go to 666
         end if

c        Use bounded Newton iterations to estimate the vertical velocity
         call bnewton(nh,m,bigT,halfgate,hgts,hs,hgtp,habest,
     +        qbest,te(1:nh),dhdt(1:nh),FF)
!!!!!!!! if (FF) call w3tage('PREPOBS_PREPACQC')
!!!!!!!! if (FF) call errexit(64)
         if (FF) then 
c Error generating vertical velocity rate in tension-spline interpolation utility pspl
c  (coming out of subroutine bnewton) - use finite difference method
c ------------------------------------------------------------------------------------
            print*,"WARNING: tspline err in utility pspl, coming out ",
     +             "of subr. bnewton - use finite difference method" 
            write(41,*)"WARNING: tspline err in utility pspl, coming ",
     +                 "out of subr. bnewton - use finite difference ",
     +                 "method" 
            err_tspline = 1
            go to 666
         end if

c        convert back data with time decrease for ascending
         call convertd_back(nh,halfgate,wdata,tdata,dhdt,hgts,idx,
     +                      descending)
         do j = 1, nh
            write(41,*) 'hgts,hs,dhdt,wdata=', j,hgts(j),hs(j),dhdt(j),
     +       wdata(j)
         end do

c        Encode dhdt into PREPBUFR-like file as IALR
         nh = 0
         do j = 1,nlv2wrt_tot
            jj = iord(j)
            if (ibfms(drinfo_accum(3,jj)).eq.0) then
               nh = nh + 1
               rate_accum(jj) = wdata(nh)
               write(41,*) 'j,z,rate=',j,zevn_accum(1,jj,1),
     +          rate_accum(jj)
            end if
         end do

 666     continue

         if(allocated(idx)) deallocate(idx)
         if(allocated(pof)) deallocate(pof)
         if(allocated(tdata)) deallocate(tdata)
         if(allocated(hdata)) deallocate(hdata)
         if(allocated(wdata)) deallocate(wdata)
         if(allocated(te)) deallocate(te)
         if(allocated(hgts)) deallocate(hgts)
         if(allocated(hs)) deallocate(hs)
         if(allocated(dhdt)) deallocate(dhdt)
         if(allocated(hgtp)) deallocate(hgtp)
         if(allocated(hp)) deallocate(hp)
         if(allocated(qbest)) deallocate(qbest)
         if(allocated(habest)) deallocate(habest)
         if(allocated(modebest)) deallocate(modebest)
      end if ! nlv2wrt_tot.gt.1 .and. tsplines

      if (((nlv2wrt_tot.gt.1) .and. (.not.tsplines)) 
     +                           .or. err_tspline>0) then
        do j = 1,nlv2wrt_tot
          jj = iord(j)
          write(41,*) 'j,ord,z,t,pof=', j, jj,zevn_accum(1,jj,1),
     +    drinfo_accum(3,jj),acft_seq_accum(1,jj),acft_seq_accum(2,jj)
        end do

        do j = 1,nlv2wrt_tot
          jj = iord(j)

          jkp = 0
          jkm = 0
          jjp1 = 0
          jjm1 = 0
          if (j .eq. nlv2wrt_tot) then
             if (ibfms(drinfo_accum(3,jj)).eq.0) then
                jjp1 = jj
                jkp = j
             end if
          else
             do jk = j+1,nlv2wrt_tot
                jjp = iord(jk)
                if (jjp > nlvinprof) cycle
                if (ibfms(drinfo_accum(3,jjp)).eq.0) then
                   jjp1 = jjp
                   jkp = jk
                   exit
                end if
             end do
          end if

          if (j .eq. 1 ) then
             if (ibfms(drinfo_accum(3,jj)).eq.0) then
                jjm1 = jj
                jkm = j
             end if
          else
             do jk = j-1,1,-1
                jjm = iord(jk)
                if (jjm > nlvinprof) cycle  ! use real obs only
                if (ibfms(drinfo_accum(3,jjm)).eq.0) then
                   jjm1 = jjm
                   jkm = jk
                   exit
                end if
             end do
          end if

          if ((jjp1 .ne. 0) .and. (jjm1 .ne. 0)) then
             dt = (drinfo_accum(3,jjp1) - drinfo_accum(3,jjm1))*3600. !  seconds 

             c1_jk = 0
             c2_jk = 0
             do while ((abs(dt)<60.) .and. ((jkp+c1_jk<=nlv2wrt_tot)
     +                 .or. (jkm-c2_jk>=1)))
                jjp2 = 0
                jjm2 = 0
                c1_jk = c1_jk+1
                c2_jk = c2_jk+1
                dt_new = dt

                do while (jkp+c1_jk<=nlv2wrt_tot
     +                .and. iord(jkp+c1_jk)>nlvinprof)
                   c1_jk = c1_jk+1   ! skip mandatory level
                end do
                if (jkp+c1_jk<=nlv2wrt_tot
     +                .and. iord(jkp+c1_jk)<=nlvinprof) then
                   jjp = iord(jkp+c1_jk)
                   if (ibfms(drinfo_accum(3,jjp)).eq.0) then
                      jjp2 = jjp
                      dt_new = (drinfo_accum(3,jjp2)
     +                       - drinfo_accum(3,jjm1))*3600.
                   end if
                end if
                if (abs(dt_new) >= 60.) then
                   if (jjp2 .ne. 0) jjp1 = jjp2
                   exit
                end if

                do while (jkm-c2_jk>=1 .and. iord(jkm-c2_jk)>nlvinprof)
                   c2_jk = c2_jk+1   ! skip mandatory level
                end do
                if (jkm-c2_jk>=1 .and. iord(jkm-c2_jk)<=nlvinprof) then
                   jjm = iord(jkm-c2_jk)
                   if (ibfms(drinfo_accum(3,jjm)).eq.0) then
                      jjm2 = jjm
                      dt_new = (drinfo_accum(3,jjp1)
     +                       - drinfo_accum(3,jjm2))*3600.
                   end if
                end if
                if (abs(dt_new) >= 60.) then
                   if (jjm2 .ne. 0) jjm1 = jjm2
                   exit
                end if

                if ((jjp2 .ne. 0) .and. (jjm2 .ne. 0)) then
                   dt_new = (drinfo_accum(3,jjp2)
     +                    - drinfo_accum(3,jjm2))*3600.
                   if (abs(dt_new) >= 60.) then
                      if (jjp2 .ne. 0) jjp1 = jjp2
                      if (jjm2 .ne. 0) jjm1 = jjm2
                      exit
                   end if
                end if
             end do
             dt = (drinfo_accum(3,jjp1) - drinfo_accum(3,jjm1))*3600.

c            write(41,*)' fj,ord1,z1,t1 = ',j,jjp1,zevn_accum(1,jjp1,1),
c    +                               drinfo_accum(3,jjp1)
c            write(41,*)' fj,ord2,z2,t2 = ',j,jjm1,zevn_accum(1,jjm1,1),
c    +                                  drinfo_accum(3,jjm1)
             zul = zevn_accum(1,jjp1,1)   ! meters
             zll = zevn_accum(1,jjm1,1) ! meters

c Need gross checks on ascent/descent rate here?
             if(abs(dt) .gt. 0.)  ! added to avoid divide by zero
     +          rate_accum(jj) = (zul - zll)/dt  ! m/s
                                            ! will be encoded into
                                            ! PREPBUFR-like file as IALR

             write(41,*) ' fj,dt,rate_accum=',j,dt,rate_accum(jj)
             write(41,*) ''
          end if
        end do
      end if ! ((nlv2wrt_tot.gt.1) .and. (.not.tsplines)) .or. err_tspline>0

c Interpolate position and time to mandatory level (will be stored in XDR YDR HRDR) (need to
c   have mandatory levels inserted into the profile before this step)
c ------------------------------------------------------------------------------------------
      if (l_mandlvl .and. nlvinprof.gt.1) then

ccccccc print *, ' nlv2wrt_tot = ',nlv2wrt_tot
        do j = 1,nlv2wrt_tot
          jj = iord(j)
ccccccc   print *, ' j,jj = ',j,jj

          nmNbtw = 0 ! reset 'number of mandatory levels in-between' counter
c------------------------------------------------------------------------------------------
c------------------------------------------------------------------------------------------
! (DAK: verified that logic below gives the correct answer - good news!)
          if(ibfms(drinfo_accum(1,jj)).ne.0 .and.
     +	     ibfms(drinfo_accum(2,jj)).ne.0 .and.
     +       ibfms(drinfo_accum(3,jj)).ne.0) then ! all obs in drift sequence missing likely
                                                  !  means this is a mandatory level for
                                                  !  which these obs must be filled via
                                                  !  interpolation
            nmNbtw = 1 ! set 'number of mandatory levels in-between' counter to 1
ccccc       print *, 'here is a first mand. level - p = ',lvlsinprof(jj)

c see if there is more than one mandatory level in a row for which we need to calculate XDR,
c  YDR and HRDR values
c ------------------------------------------------------------------------------------------
            do k = j+1, nlv2wrt_tot
ccccccc       print *, ' k = ',k
              kk = iord(k)
              if(ibfms(drinfo_accum(1,kk)).ne.0 .and.
     +	         ibfms(drinfo_accum(2,kk)).ne.0 .and.
     +           ibfms(drinfo_accum(3,kk)).ne.0) then ! another mandatory levelw/ missing
                                                      !  XDR, YDR and HRDR
                nmNbtw = nmNbtw + 1    ! increment 'number of mandatory levels in-between'
                                       !  counter by 1

ccccc           print *, 'here is ANOTHER adjacent MANDATORY LEVEL - ',
ccccc+                   'p =',lvlsinprof(kk)
ccccc           print *, 'nmNbtw = ',nmNbtw
              else
                exit ! exit k loop
              endif
            enddo

c At this point, nmNbtw is the number of mandatory levels in a row w/ missing XDR, YDR and
c  HRDR - ow we need to determine the "bread" levels; in other words, levels with real, non-
c  interpolated data, that sandwich the mandatory levels - below, jj points to the mandatory
c  level, jjm1 points to the "bread" level with actual data at the lower pressure/higher
c  altitude and jjpnmNbtw points to the "bread" level with actual data at a higher pressure/
c  lower altitude
c ------------------------------------------------------------------------------------------
            if(j.le.1) then
c DAK: Make sure j is > 1 here !!  (not sure it can ever happen)
              print *
              print *, '### PROBLEM - j .le. 1 (= ',j,') in subr. ',
     +                 'sub2mem_mer, iord array underflow'
              print *, '              this should never happen!!'
              print *
              call w3tage('PREPOBS_PREPACQC')
              call errexit(61)
            endif
            jjm1 = iord(j-1)
            jjpnmNbtw = iord(j+nmNbtw)
            pll = lvlsinprof(jjm1)
            pul = lvlsinprof(jjpnmNbtw)

c Interpolate lat/lon/time to mandatory levels
c --------------------------------------------

c Determine dtime/dlnp, total horizontal distance covered between the two points, and average
c  groundspeed of aircraft between the points
c -------------------------------------------------------------------------------------------
            dtime_dlnp = (drinfo_accum(3,jjpnmNbtw) - 
     +                    drinfo_accum(3,jjm1)) / alog(pul/pll)

c Use Haversine formula to determine distance, given two lat/lons (the same formula is used
c  in the acftobs_qc/gcirc_qc routine and more information is available at
c  http://www.movable-type.co.uk/scripts/GIS-FAQ-5.1.html)
c -----------------------------------------------------------------------------------------
            lat_pul = drinfo_accum(2,jjpnmNbtw)
            lon_pul = drinfo_accum(1,jjpnmNbtw)
            lat_pll = drinfo_accum(2,jjm1)
            lon_pll = drinfo_accum(1,jjm1)

            if(int(lon_pul*100.).eq.int(lon_pll*100.)) then
              dist_pul_pll = radius_e * abs(lat_pul-lat_pll) * deg2rad 
            elseif(int(lat_pul*100.).eq.int(lat_pll*100.)) then
              dist_pul_pll = 2.0*radius_e*
     +         asin(min(1.0,abs(cos(lat_pul*deg2rad)*
     +         sin((lon_pul-lon_pll)*0.5*deg2rad))))
            else
              dist_pul_pll = 2.0*radius_e*
     +         asin(min(1.0,sqrt(
     +                           (sin((lat_pul-lat_pll)*0.5*deg2rad))**2
     +                               +  cos(lat_pul*deg2rad)*
     +                                  cos(lat_pll*deg2rad)*
     +                           (sin((lon_pul-lon_pll)*0.5*deg2rad))**2
     +                                                                 )
     +                                                                 )
     +                                                                 )
            endif

c Check if times are equal, then interpolate lat/lon - assume aircraft is traveling at a
c  constant speed between the locations where pul and pll are observed
c --------------------------------------------------------------------------------------
            if(int(drinfo_accum(3,jjpnmNbtw)*100000.).ne.
     +	       int(drinfo_accum(3,jjm1)*100000.) .and.
     +        dist_pul_pll.ne.0.) then

              spd_pul_pll = dist_pul_pll /
     +                      abs((drinfo_accum(3,jjpnmNbtw) -
     +                           drinfo_accum(3,jjm1))*3600.)

              do k = 0,nmNbtw-1
ccccccc         print *, ' k 2 = ',k
                jjpk = iord(j+k)
                pml = lvlsinprof(jjpk)

c time
                drinfo_accum(3,jjpk) = drinfo_accum(3,jjm1) + 
     +                                 dtime_dlnp*alog(pml/pll)

                dist2pml = spd_pul_pll *
     +                   abs(drinfo_accum(3,jjpk)-drinfo_accum(3,jjm1))*
     +                     3600.         ! sec/hour... drinfo_accum(3,x) values are in hours

c latitude
                drinfo_accum(2,jjpk) = drinfo_accum(2,jjm1) +
     +                                 dist2pml/dist_pul_pll*
     +           (drinfo_accum(2,jjpnmNbtw)-drinfo_accum(2,jjm1))

c longitude
                drinfo_accum(1,jjpk) = drinfo_accum(1,jjm1) +
     +                                 dist2pml/dist_pul_pll*
     +           (drinfo_accum(1,jjpnmNbtw)-drinfo_accum(1,jjm1))

              enddo
            else ! times are equal; assume groundspeed varies linearly -- or, dist_pul_pll=0
                 !  and lat/lons of pul and pll are either equal or very very close

c Determine delx, y
c -----------------
              delx = (drinfo_accum(1,jjpnmNbtw) -
     +                drinfo_accum(1,jjm1))/(nmNbtw+1)
              dely = (drinfo_accum(2,jjpnmNbtw) -
     +                drinfo_accum(2,jjm1))/(nmNbtw+1)

c Store interpolated lat/lon/time values for the levels that need it
c ------------------------------------------------------------------
              do k = 0,nmNbtw-1
ccccccc         print *, ' k 3 = ',k
                jjpk = iord(j+k)
                pml = lvlsinprof(jjpk)
                drinfo_accum(1,jjpk) =
     +           drinfo_accum(1,jjm1) + (k+1)*delx
                drinfo_accum(2,jjpk) =
     +           drinfo_accum(2,jjm1) + (k+1)*dely
                drinfo_accum(3,jjpk) = drinfo_accum(3,jjm1) +
     +                                 dtime_dlnp*alog(pml/pll) ! if times are equal,
                                                                !  dtime_dlnp =0, and then
                                                                !  time at pml = time at pll

cc              drinfo_accum(3,jj) = 
cc   +            drinfo_accum(3,jjpnmNbtw) ! give pml the same time as pul and pll 

              enddo 
            endif ! times of "bread" levels equal?
          endif ! need to interpolate for mandatory level ?
! (DAK: verified that above below gives the correct answer - good news!)
c------------------------------------------------------------------------------------------
c------------------------------------------------------------------------------------------
        enddo ! j = 1,nlv2wrt_tot
      endif ! l_mandlvl .and. nlvinprof.gt.1

c Set TYP to reflect whether or not report is part of a profile, ascending or descending
c --------------------------------------------------------------------------------------
      jjmaxp = iord(nlv2wrt_tot)
      jjminp = iord(1)
      if(nlv2wrt_tot.eq.1) then
        hdr2wrt(6) = 300 + mod(int(hdr2wrt(6)),100)    ! TYP = 3xx for single level merged
                                                       !  (mass + wind) reports
      elseif(nlv2wrt_tot.gt.1 .and.
     +      (c_qc_accum(jjmaxp)(11:11).eq.'a' .or. 
     +	     c_qc_accum(jjmaxp)(11:11).eq.'A')) then   ! ascending profile (merged)
        hdr2wrt(6) = 400 + mod(int(hdr2wrt(6)),100)    !  TYP = 4xx for ascending profile
                                                       !   merged (mass + wind) reports

c Make sure the header information for the ascent is the coordinates, etc, present at the
c  "launch" level (highest pressure/lowest altitude)
c ---------------------------------------------------------------------------------------
        hdr2wrt(2) = drinfo_accum(1,jjmaxp)
        hdr2wrt(3) = drinfo_accum(2,jjmaxp)
        hdr2wrt(4) = drinfo_accum(3,jjmaxp)
        hdr2wrt(5) = elv_accum(1,jjmaxp)
        hdr2wrt(12) = rpt_accum(1,jjmaxp)
        hdr2wrt(13) = tcor_accum(1,jjmaxp)

      elseif(nlv2wrt_tot.gt.1 .and.
     +      (c_qc_accum(jjmaxp)(11:11).eq.'d' .or. 
     +	     c_qc_accum(jjmaxp)(11:11).eq.'D')) then   ! descending profile (merged)
        hdr2wrt(6) = 500 + mod(int(hdr2wrt(6)),100)    !  TYP = 5xx for descending profile
                                                       !   merged (mass + wind) reports

c Make sure the header information for the descent is the coordinates, etc., present at the
c  "launch" level (lowest pressure/highest altitude)
c -----------------------------------------------------------------------------------------
        hdr2wrt(2) = drinfo_accum(1,jjminp)
        hdr2wrt(3) = drinfo_accum(2,jjminp)
        hdr2wrt(4) = drinfo_accum(3,jjminp)
        hdr2wrt(5) = elv_accum(1,jjminp)
        hdr2wrt(12) = rpt_accum(1,jjminp)
        hdr2wrt(13) = tcor_accum(1,jjminp)

      endif
ccc   print *, '.. the report type here is ',hdr2wrt(6)

c Set SQN/PROCN to missing for profiles
c -------------------------------------
      hdr2wrt(10) = bmiss
      hdr2wrt(11) = bmiss

c Write header info/metadata
c --------------------------
      call ufbint(proflun,hdr2wrt,15,1,nlvwrt,
     + 'SID XOB YOB DHR ELV TYP T29 TSB ITP SQN PROCN RPT TCOR '//
     + 'RSRD EXPRSRD')

      acid_arr1 = acid1
      if(ibfms(acid1).eq.0) 
     +  call ufbint(proflun,acid_arr1,1,1,nlvwrt,'ACID')  ! store 'ACID' if present
                                                          !  {currently only in MDCRS or AMDAR
                                                          !  (LATAM only) reports}

      if(mesgtype.ne.'AIRCAR'.and. mesgtype.ne.'AIRCFT') then
        print *, 'Non-compatible message type! (',mesgtype,')'
        print *, 'Skipping this report; it will not be written to ',
     +           'output.'
        go to 9999
      endif

ccc   print *, 'FOR THIS REPORT: mxe4prof = ',mxe4prof

c -------------------------------------
c Process each event set, one at a time
c -------------------------------------
      do i = 1,mxe4prof ! maximum number of events in a single-level merged report (i.e., the
                        !  maximum amongst the number of pressure, moisture,temperature,
                        !  altitude, u/v wind and direction/speed wind events)
ccc     print *, '.. bring in next event for writing out'
ccc     print *, 'Next event is number ',i

c Clear out arrays used with ufbint to store data in memory
c ---------------------------------------------------------
        nlv2wrt   = 0

        pevns4    = bmiss
        qevns4    = bmiss
        tevns4    = bmiss
        zevns4    = bmiss
        wuvevns5  = bmiss
        wdsevns5  = bmiss

        pbgarr3   = bmiss
        qbgarr3   = bmiss
        tbgarr3   = bmiss
        zbgarr3   = bmiss
        wuvbgarr5 = bmiss

        ppparr3   = bmiss
        qpparr3   = bmiss
        tpparr3   = bmiss
        zpparr3   = bmiss
        wuvpparr6 = bmiss

        drarr3    = bmiss

        acft_seq_arr2 = bmiss

        mstq_arr1 = bmiss
        rct_arr1  = bmiss
        cat_arr1  = bmiss
        ialr_arr1 = bmiss
        turb_arr4 = bmiss

c Collapse stacks of events; keep levels where there is pressure data - do this in
c  anticipation of "striping"/layering events onto data upon output - organize data across
c  all levels for each "event set"/"layer"
c ----------------------------------------------------------------------------------------

        do j = nlv2wrt_tot,1,-1

          jj = iord(j)
ccc       print *, 'j: ',j

          nlv2wrt = nlv2wrt + 1 ! nlv2wrt = number of pressure levels to be written out
ccc       print *, 'nlv2wrt = ',nlv2wrt

          if(ibfms(pevn_accum(1,jj,i)).eq.0) then ! if POB is missing, don't process this
                                                  !  event
            pevns4(1:4,nlv2wrt) = pevn_accum(1:4,jj,i)
ccc         print *, 'POB PQM PPC PRC for this level and event:'
ccc         print *, ' pevns4(1,',nlv2wrt,') = ',pevns4(1,nlv2wrt)
ccc         print *, ' pevns4(2,',nlv2wrt,') = ',pevns4(2,nlv2wrt)
ccc         print *, ' pevns4(3,',nlv2wrt,') = ',pevns4(3,nlv2wrt)
ccc         print *, ' pevns4(4,',nlv2wrt,') = ',pevns4(4,nlv2wrt)
ccc       else
ccc         print *, 'POB missing, pevns4 is missing for this level ',
ccc  +               'and event'
          endif

          if(ibfms(qevn_accum(1,jj,i)).eq.0) then ! if QOB is missing, don't process this
                                                  !  event
            qevns4(1:4,nlv2wrt) = qevn_accum(1:4,jj,i)
ccc         print *, 'QOB QQM QPC QRC for this level and event:'
ccc         print *, ' qevns4(1,',nlv2wrt,') = ',qevns4(1,nlv2wrt)
ccc         print *, ' qevns4(2,',nlv2wrt,') = ',qevns4(2,nlv2wrt)
ccc         print *, ' qevns4(3,',nlv2wrt,') = ',qevns4(3,nlv2wrt)
ccc         print *, ' qevns4(4,',nlv2wrt,') = ',qevns4(4,nlv2wrt)
ccc       else
ccc         print *, 'QOB missing, qevns4 is missing for this ',
ccc  +               'level and event'
          endif

          if(ibfms(tevn_accum(1,jj,i)).eq.0) then ! if TOB is missing, don't process this
                                                  !  event
            tevns4(1:4,nlv2wrt) = tevn_accum(1:4,jj,i)
ccc         print *, 'TOB TQM TPC TRC for this level and event:'
ccc         print *, ' tevns4(1,',nlv2wrt,') = ',tevns4(1,nlv2wrt)
ccc         print *, ' tevns4(2,',nlv2wrt,') = ',tevns4(2,nlv2wrt)
ccc         print *, ' tevns4(3,',nlv2wrt,') = ',tevns4(3,nlv2wrt)
ccc         print *, ' tevns4(4,',nlv2wrt,') = ',tevns4(4,nlv2wrt)
ccc       else
ccc         print *, 'TOB missing, tevns4 is missing for this ',
ccc  +               'level and event'
          endif

          if(ibfms(zevn_accum(1,jj,i)).eq.0) then ! if ZOB is missing, don't process this
                                                  !  event
            zevns4(1:4,nlv2wrt) = zevn_accum(1:4,jj,i)
ccc         print *, 'ZOB ZQM ZPC ZRC for this level and event:'
ccc         print *, ' zevns4(1,',nlv2wrt,') = ',zevns4(1,nlv2wrt)
ccc         print *, ' zevns4(2,',nlv2wrt,') = ',zevns4(2,nlv2wrt)
ccc         print *, ' zevns4(3,',nlv2wrt,') = ',zevns4(3,nlv2wrt)
ccc         print *, ' zevns4(4,',nlv2wrt,') = ',zevns4(4,nlv2wrt)
ccc       else
ccc         print *, 'ZOB missing, zevns4 is missing for this level ',
ccc  +               'and event'
          endif

          if(ibfms(wuvevn_accum(1,jj,i)).eq.0 .and.  ! if UOB or VOB are missing, don't
     +       ibfms(wuvevn_accum(2,jj,i)).eq.0) then  !  process this event
            wuvevns5(1:5,nlv2wrt) = wuvevn_accum(1:5,jj,i)
ccc         print *, 'UOB VOB WQM WPC WRC for this level and event:'
ccc         print *, ' wuvevns5(1,',nlv2wrt,') = ',wuvevns5(1,nlv2wrt)
ccc         print *, ' wuvevns5(2,',nlv2wrt,') = ',wuvevns5(2,nlv2wrt)
ccc         print *, ' wuvevns5(3,',nlv2wrt,') = ',wuvevns5(3,nlv2wrt)
ccc         print *, ' wuvevns5(4,',nlv2wrt,') = ',wuvevns5(4,nlv2wrt)
ccc         print *, ' wuvevns5(5,',nlv2wrt,') = ',wuvevns5(5,nlv2wrt)
ccc       else
ccc         print *, 'either UOB or VOB missing, wuvevns5 is missing ',
ccc  +               'for this level and event'
          endif

          wdsevns5(1:5,nlv2wrt) = wdsevn_accum(1:5,jj,i)
ccc       print *, 'DDO FFO DFQ DFP DFR for this level and event:'
ccc       print *, ' wdsevns5(1,',nlv2wrt,') = ',wdsevns5(1,nlv2wrt)
ccc       print *, ' wdsevns5(2,',nlv2wrt,') = ',wdsevns5(2,nlv2wrt)
ccc       print *, ' wdsevns5(3,',nlv2wrt,') = ',wdsevns5(3,nlv2wrt)
ccc       print *, ' wdsevns5(4,',nlv2wrt,') = ',wdsevns5(4,nlv2wrt)
ccc       print *, ' wdsevns5(5,',nlv2wrt,') = ',wdsevns5(5,nlv2wrt)

c Collapse arrays of background, post-processing, drift, acft_seq info - need to accumulate
c  background, etc., across all levels - only write out these values upon writing first
c  "event"/"layer".  These values occur only once per layer, there is no nested replication
c -----------------------------------------------------------------------------------------

          if(i.eq.1) then

            pbgarr3(1:3,nlv2wrt) = pbg_accum(1:3,jj)
ccc         print *, 'POE PFC PFCMOD for this level - NO event:'
ccc         print *, ' pbgarr3(1,',nlv2wrt,') = ',pbgarr3(1,nlv2wrt)
ccc         print *, ' pbgarr3(2,',nlv2wrt,') = ',pbgarr3(2,nlv2wrt)
ccc         print *, ' pbgarr3(3,',nlv2wrt,') = ',pbgarr3(3,nlv2wrt)
            qbgarr3(1:3,nlv2wrt) = qbg_accum(1:3,jj)
ccc         print *, 'QOE QFC QFCMOD for this level - NO event:'
ccc         print *, ' qbgarr3(1,',nlv2wrt,') = ',qbgarr3(1,nlv2wrt)
ccc         print *, ' qbgarr3(2,',nlv2wrt,') = ',qbgarr3(2,nlv2wrt)
ccc         print *, ' qbgarr3(3,',nlv2wrt,') = ',qbgarr3(3,nlv2wrt)
            tbgarr3(1:3,nlv2wrt) = tbg_accum(1:3,jj)
ccc         print *, 'TOE TFC TFCMOD for this level - NO event:'
ccc         print *, ' tbgarr3(1,',nlv2wrt,') = ',tbgarr3(1,nlv2wrt)
ccc         print *, ' tbgarr3(2,',nlv2wrt,') = ',tbgarr3(2,nlv2wrt)
ccc         print *, ' tbgarr3(3,',nlv2wrt,') = ',tbgarr3(3,nlv2wrt)
            zbgarr3(1:3,nlv2wrt) = zbg_accum(1:3,jj)
ccc         print *, 'ZOE ZFC ZFCMOD for this level - NO event:'
ccc         print *, ' zbgarr3(1,',nlv2wrt,') = ',zbgarr3(1,nlv2wrt)
ccc         print *, ' zbgarr3(2,',nlv2wrt,') = ',zbgarr3(2,nlv2wrt)
ccc         print *, ' zbgarr3(3,',nlv2wrt,') = ',zbgarr3(3,nlv2wrt)
            wuvbgarr5(1:5,nlv2wrt) = wuvbg_accum(1:5,jj)
ccc         print *, 'WOE UFC VFC UFCMOD VFCMOD for this level - NO event:'
ccc         print *, ' wuvbgarr5(1,',nlv2wrt,') = ',wuvbgarr5(1,nlv2wrt)
ccc         print *, ' wuvbgarr5(2,',nlv2wrt,') = ',wuvbgarr5(2,nlv2wrt)
ccc         print *, ' wuvbgarr5(3,',nlv2wrt,') = ',wuvbgarr5(3,nlv2wrt)
ccc         print *, ' wuvbgarr5(4,',nlv2wrt,') = ',wuvbgarr5(4,nlv2wrt)
ccc         print *, ' wuvbgarr5(5,',nlv2wrt,') = ',wuvbgarr5(5,nlv2wrt)

            ppparr3(1:3,nlv2wrt) = ppp_accum(1:3,jj)
ccc         print *, 'PAN PCL PCS for this level - NO event:'
ccc         print *, ' ppparr3(1,',nlv2wrt,') = ',ppparr3(1,nlv2wrt)
ccc         print *, ' ppparr3(2,',nlv2wrt,') = ',ppparr3(2,nlv2wrt)
ccc         print *, ' ppparr3(3,',nlv2wrt,') = ',ppparr3(3,nlv2wrt)
            qpparr3(1:3,nlv2wrt) = qpp_accum(1:3,jj)
ccc         print *, 'QAN QCL QCS for this level - NO event:'
ccc         print *, ' qpparr3(1,',nlv2wrt,') = ',qpparr3(1,nlv2wrt)
ccc         print *, ' qpparr3(2,',nlv2wrt,') = ',qpparr3(2,nlv2wrt)
ccc         print *, ' qpparr3(3,',nlv2wrt,') = ',qpparr3(3,nlv2wrt)
            tpparr3(1:3,nlv2wrt) = tpp_accum(1:3,jj)
ccc         print *, 'TAN TCL TCS for this level - NO event:'
ccc         print *, ' tpparr3(1,',nlv2wrt,') = ',tpparr3(1,nlv2wrt)
ccc         print *, ' tpparr3(2,',nlv2wrt,') = ',tpparr3(2,nlv2wrt)
ccc         print *, ' tpparr3(3,',nlv2wrt,') = ',tpparr3(3,nlv2wrt)
            zpparr3(1:3,nlv2wrt) = zpp_accum(1:3,jj)
ccc         print *, 'ZAN ZCL ZCS for this level - NO event:'
ccc         print *, ' zpparr3(1,',nlv2wrt,') = ',zpparr3(1,nlv2wrt)
ccc         print *, ' zpparr3(2,',nlv2wrt,') = ',zpparr3(2,nlv2wrt)
ccc         print *, ' zpparr3(3,',nlv2wrt,') = ',zpparr3(3,nlv2wrt)
            wuvpparr6(1:6,nlv2wrt) = wuvpp_accum(1:6,jj)
ccc         print *, 'UAN VAN UCL UCS VCL VCS for this level - NO event:'
ccc         print *, ' wuvpparr6(1,',nlv2wrt,') = ',wuvpparr6(1,nlv2wrt)
ccc         print *, ' wuvpparr6(2,',nlv2wrt,') = ',wuvpparr6(2,nlv2wrt)
ccc         print *, ' wuvpparr6(3,',nlv2wrt,') = ',wuvpparr6(3,nlv2wrt)
ccc         print *, ' wuvpparr6(4,',nlv2wrt,') = ',wuvpparr6(4,nlv2wrt)
ccc         print *, ' wuvpparr6(5,',nlv2wrt,') = ',wuvpparr6(5,nlv2wrt)
ccc         print *, ' wuvpparr6(6,',nlv2wrt,') = ',wuvpparr6(6,nlv2wrt)

            drarr3(1:3,nlv2wrt) = drinfo_accum(1:3,jj)
ccc         print *, 'XDR YDR HRDR for this level - NO event:'
ccc         print *, ' drarr3(1,',nlv2wrt,') = ',drarr3(1,nlv2wrt)
ccc         print *, ' drarr3(2,',nlv2wrt,') = ',drarr3(2,nlv2wrt)
ccc         print *, ' drarr3(3,',nlv2wrt,') = ',drarr3(3,nlv2wrt)

            acft_seq_arr2(1:2,nlv2wrt) = acft_seq_accum(1:2,jj)
ccc         print *, 'PCAT POAF for this level - NO event:'
ccc         print *, ' acft_seq_arr2(1,',nlv2wrt,') = ',
ccc  +                 acft_seq_arr2(1,nlv2wrt)
ccc         print *, ' acft_seq_arr2(2,',nlv2wrt,') = ',
ccc  +                 acft_seq_arr2(2,nlv2wrt)

            mstq_arr1(1,nlv2wrt) = mstq_accum(1,jj)
ccc         print *, 'MSTQ for this level - NO event:'
ccc         print *, ' mstq_arr1(1,',nlv2wrt,') = ',mstq_arr1(1,nlv2wrt)

            rct_arr1(1,nlv2wrt) = rct_accum(1,jj)
ccc         print *, 'RCT for this level - NO event:'
ccc         print *, ' rct_arr1(1,',nlv2wrt,') = ',rct_arr1(1,nlv2wrt

            cat_arr1(1,nlv2wrt) = cat_accum(1,jj)
ccc         print *, 'CAT for this level - NO event:'
ccc         print *, ' cat_arr1(1,',nlv2wrt,') = ',cat_arr1(1,nlv2wrt)

            ialr_arr1(1,nlv2wrt) = rate_accum(jj)
ccc         print *, 'IALR for this level - NO event:'
ccc         print *, ' ialr_arr1(1,',nlv2wrt,') = ',ialr_arr1(1,nlv2wrt)
          endif

          if(.not.l_operational) then  ! this is currently invoked because l_operational
                                       !  is hardwired to F for l_ncep=T
            if(i.eq.mxe4prof) then
              hdr2wrt1 = hdr2wrt(1)
              if(ibfms(drinfo_accum(3,jj)).ne.0) then
                idrinfo_accum3 = 9999999
              else
                idrinfo_accum3 = nint(drinfo_accum(3,jj) * 3600.)
              endif
              if(ibfms(hdr2wrt(9)).ne.0) then
                ihdr2wrt9 = 99999
              else
                ihdr2wrt9 = nint(hdr2wrt(9))
              endif
              if(ibfms(hdr2wrt(6)).ne.0) then
                ihdr2wrt6 = 9999
              else
                ihdr2wrt6 = nint(hdr2wrt(6))
              endif
              if(ibfms(acft_seq_accum(2,jj)).ne.0) then
                iacft_seq_accum2 = 99
              else
                iacft_seq_accum2 = nint(acft_seq_accum(2,jj))
              endif
              if(ibfms(mstq_accum(1,jj)).ne.0) then
                imstq_accum1 = 9999
              else
                imstq_accum1 = nint(mstq_accum(1,jj))
              endif
              if(ibfms(cat_accum(1,jj)).ne.0) then
                icat_accum1 = 9999
              else
                icat_accum1 = nint(cat_accum(1,jj))
              endif
              do iii = mxe4prof,1,-1
                if(ibfms(tevn_accum(1,jj,iii)).ne.0) then
                  nevents_t = iii
                else
                  nevents_t = iii
                  exit
                endif
              enddo
              if(ibfms(zevn_accum(1,jj,1)).ne.0) then
                izevn_accum1 = 999999
              else
                izevn_accum1 =  nint(zevn_accum(1,jj,1))
              endif
              if(ibfms(wdsevn_accum(1,jj,1)).ne.0) then
                iwdsevn_accum1 = 99999
              else
                iwdsevn_accum1 =  nint(wdsevn_accum(1,jj,1))
              endif
              do iii = mxe4prof,1,-1
                if(ibfms(wuvevn_accum(1,jj,iii)).ne.0 .or.
     +             ibfms(wuvevn_accum(2,jj,iii)).ne.0) then
                  if(iii.eq.1) wspd = bmiss
                  nevents_w = iii
                else
                  wspd = sqrt(wuvevn_accum(1,jj,iii)**2 + 
     +                        wuvevn_accum(2,jj,iii)**2)
                  nevents_w = iii
                  exit
                endif
              enddo
              do iii = mxe4prof,1,-1
                if(ibfms(qevn_accum(1,jj,iii)).ne.0) then
                  if(iii.eq.1) q_sphum = bmiss
                  nevents_q = iii
                else
                  q_sphum = qevn_accum(1,jj,iii) * 0.001
                  nevents_q = iii
                  exit
                endif
              enddo
              if(ibfms(pevn_accum(2,jj,1)).ne.0) then
                ipevn_accum2 = 999
              else
                ipevn_accum2 = nint(pevn_accum(2,jj,1))
              endif
              if(ibfms(zevn_accum(2,jj,1)).ne.0) then
                izevn_accum2 = 999
              else
                izevn_accum2 = nint(zevn_accum(2,jj,1))
              endif
              if(ibfms(tevn_accum(2,jj,nevents_t)).ne.0) then
                itevn_accum2 = 999
              else
                itevn_accum2 = nint(tevn_accum(2,jj,nevents_t))
              endif
              if(ibfms(qevn_accum(2,jj,nevents_q)).ne.0) then
                iqevn_accum2 = 999
              else
                iqevn_accum2 = nint(qevn_accum(2,jj,nevents_q))
              endif
              if(ibfms(wuvevn_accum(3,jj,nevents_w)).ne.0) then
                iwuvevn_accum3 = 999
              else
                iwuvevn_accum3 = nint(wuvevn_accum(3,jj,nevents_w))
              endif
              if(ibfms(pevn_accum(4,jj,1)).ne.0 .or.
     +           nint(pevn_accum(3,jj,1)).ne.nrlacqc_pc) then
                ipevn_accum4 = 9999
              else
                ipevn_accum4 = nint(pevn_accum(4,jj,1))
              endif
              if(ibfms(zevn_accum(4,jj,1)).ne.0 .or.
     +           nint(zevn_accum(3,jj,1)).ne.nrlacqc_pc) then
                izevn_accum4 = 9999
              else
                izevn_accum4 = nint(zevn_accum(4,jj,1))
              endif
              if(ibfms(tevn_accum(4,jj,nevents_t)).ne.0 .or.
     +           nint(tevn_accum(3,jj,nevents_t)).ne.nrlacqc_pc) then
                itevn_accum4 = 9999
              else
                itevn_accum4 = nint(tevn_accum(4,jj,nevents_t))
              endif
              if(ibfms(qevn_accum(4,jj,nevents_q)).ne.0 .or.
     +           nint(qevn_accum(3,jj,nevents_q)).ne.nrlacqc_pc) then
                iqevn_accum4 = 9999
              else
                iqevn_accum4 = nint(qevn_accum(4,jj,nevents_q))
              endif
              if(ibfms(wuvevn_accum(5,jj,nevents_w)).ne.0 .or.
     +           nint(wuvevn_accum(4,jj,nevents_w)).ne.nrlacqc_pc) then
                iwuvevn_accum5 = 9999
              else
                iwuvevn_accum5 = nint(wuvevn_accum(5,jj,nevents_w))
              endif

ccccc         write(52,fmt=7999) i
c7999         format('EVENT # ',i5)
              write(52,fmt=8001) j,c_acftid1,c_acftreg1,ihdr2wrt9,
     +         iacft_seq_accum2,drinfo_accum(2,jj),
     +         drinfo_accum(1,jj),idrinfo_accum3,izevn_accum1,
     +         pevn_accum(1,jj,1),tevn_accum(1,jj,nevents_t)+273.16,
     +         nevents_t,q_sphum,nevents_q,wuvevn_accum(1,jj,nevents_w),
     +         wuvevn_accum(2,jj,nevents_w),nevents_w,
     +         acft_seq_accum(1,jj),c_qc_accum(jj),rct_accum(1,jj),
     +         imstq_accum1,icat_accum1,wspd,iwdsevn_accum1,ihdr2wrt6,
     +         ipevn_accum2,izevn_accum2,itevn_accum2,iqevn_accum2,
     +         iwuvevn_accum3,ipevn_accum4,izevn_accum4,itevn_accum4,
     +         iqevn_accum4,iwuvevn_accum5

 8001 format(i5,1x,a9,1x,a8,1x,i3,2x,i1,1x,2f10.5, 1x,i6,1x,i5,1x,f6.1,
     +       1x,f6.2,i3,1x,f7.2,1x,i3,1x,f6.1,1x,f6.1,1x,i3,1x,f6.2,1x,
     +       '!',a11,'!',f5.2,1x,i3,2x,i2,1x,f6.1,1x,i4,2x,i3,9x,'!',
     +       5(1x,i2.2),'!',i3.3,4(1x,i3.3))

            endif ! i.eq.mxe4prof
          endif ! .not.l_operational
	enddo ! do j = nlv2wrt_tot,1,-1
ccc     print *, '.. will write out ',nlv2wrt,' p-levels for this ',
ccc  +           'report'

c Store pressure events across levels, z events, t, q, w, df events
c -----------------------------------------------------------------
        if(nlv2wrt.gt.0 .and. nlv2wrt.eq.nlv2wrt_tot) then ! should be equal; vertical coord.
                                                           !  is pressure
          call ufbint(proflun,pevns4,4,nlv2wrt,nlvwrt,'POB PQM PPC PRC')
ccc       print *, 'ufbint has stored POB PQM PPC PRC on all levels ',
ccc  +             'for this event:'

          call ufbint(proflun,qevns4,4,nlv2wrt,nlvwrt,'QOB QQM QPC QRC')
ccc       print *, 'ufbint has stored QOB QQM QPC QRC on all levels ',
ccc  +             'for this event:'

          call ufbint(proflun,tevns4,4,nlv2wrt,nlvwrt,'TOB TQM TPC TRC')
ccc       print *, 'ufbint has stored TOB TQM TPC TRC on all levels ',
ccc  +             'for this event:'

          call ufbint(proflun,zevns4,4,nlv2wrt,nlvwrt,'ZOB ZQM ZPC ZRC')
ccc       print *, 'ufbint has stored ZOB ZQM ZPC ZRC on all levels ',
ccc  +             'for this event:'

          call ufbint(proflun,wuvevns5,5,nlv2wrt,nlvwrt,
     +                'UOB VOB WQM WPC WRC')
ccc       print *, 'ufbint has stored UOB VOB WQM WPC WRC on all ',
ccc  +             'levels for this event:'

          call ufbint(proflun,wdsevns5,5,nlv2wrt,nlvwrt,
     +                'DDO FFO DFQ DFP DFR')
ccc       print *, 'ufbint has stored DDO FFO DFQ DFP DFR on all ',
ccc  +             'levels for this event:'

ccc       print *, 'Finished writing p,q,t,u/v,s/d on all ',nlv2wrt,
ccc  +             ' levels for THIS event'
          num_events_prof = num_events_prof + nlv2wrt
ccc       print *, 'Finished writing p,q,t,u/v,s/d on all ',nlv2wrt,
ccc  +             ' levels for THIS event'
ccc       print *, 'num_events_prof = ',num_events_prof

          if(i.eq.1) then ! store/write these only on first event application the following
                          !  values only occur once in the subset; there are no multiple
                          !  events to write out

c -------------------------------------------------------------------------------------------
c Store background and post processing info - each pressure level in the profile gets one set
c  of each (not nested replication like with the events)
c -------------------------------------------------------------------------------------------

ccc         print'(" write background and post-processing info - only ",
ccc  +             "for first "event" since there are no events for ",
ccc  "             "these")'

c write background info
            call ufbint(proflun,pbgarr3,3,nlv2wrt,nlvwrt,
     +                  'POE PFC PFCMOD')	
ccc         print *, 'ufbint has stored POE PFC PFCMOD on all levels -',
ccc  +               ' "event" ',i,' ONLY'

            call ufbint(proflun,qbgarr3,3,nlv2wrt,nlvwrt,
     +                  'QOE QFC QFCMOD')	
ccc         print *, 'ufbint has stored QOE QFC QFCMOD on all levels -',
ccc  +               ' "event" ',i,' ONLY'

            call ufbint(proflun,tbgarr3,3,nlv2wrt,nlvwrt,
     +                  'TOE TFC TFCMOD')	
ccc         print *, 'ufbint has stored TOE TFC TFCMOD on all levels -',
ccc  +               ' "event" ',i,' ONLY'

            call ufbint(proflun,zbgarr3,3,nlv2wrt,nlvwrt,
     +                  'ZOE ZFC ZFCMOD')
ccc         print *, 'ufbint has stored ZOE ZFC ZFCMOD on all levels -',
ccc  +               ' "event" ',i,' ONLY'

            call ufbint(proflun,wuvbgarr5,5,nlv2wrt,nlvwrt,
     +                  'WOE UFC VFC UFCMOD VFCMOD')	
ccc         print *, 'ufbint has stored WOE UFC VFC UFCMOD VFCMOD on',
ccc  +               ' all levels - "event" ',i,' ONLY'

c write post-processing info
            call ufbint(proflun,ppparr3,3,nlv2wrt,nlvwrt,'PAN PCL PCS')	
ccc         print *, 'ufbint has stored PAN PCL PCS on all levels - ',
ccc  +               '"event" ',i,' ONLY'

            call ufbint(proflun,qpparr3,3,nlv2wrt,nlvwrt,'QAN QCL QCS')	
ccc         print *, 'ufbint has stored QAN QCL QCS on all levels - ',
ccc  +               '"event" ',i,' ONLY'

            call ufbint(proflun,tpparr3,3,nlv2wrt,nlvwrt,'TAN TCL TCS')	
ccc         print *, 'ufbint has stored TAN TCL TCS on all levels - ',
ccc  +               '"event" ',i,' ONLY'

            call ufbint(proflun,zpparr3,3,nlv2wrt,nlvwrt,'ZAN ZCL ZCS')	
ccc         print *, 'ufbint has stored ZAN ZCL ZCS on all levels - ',
ccc  +               '"event" ',i,' ONLY'

            call ufbint(proflun,wuvpparr6,6,nlv2wrt,nlvwrt,
     +                  'UAN VAN UCL UCS VCL VCS')	
ccc         print *, 'ufbint has stored UAN VAN UCL UCS VCL VCS on all',
ccc  +               ' levels - "event" ',i,' ONLY'

c write out drift info
            call ufbint(proflun,drarr3,3,nlv2wrt,nlvwrt,'XDR YDR HRDR')
ccc         print *, 'ufbint has stored XDR YDR HRDR on all levels - ',
ccc  +               '"event" ',i,' ONLY'

c write out acft_seq info
            call ufbint(proflun,acft_seq_arr2,2,nlv2wrt,nlvwrt,
     +                  'PCAT POAF')
ccc         print *, 'ufbint has stored PCAT POAF on all levels - ',
ccc  +               '"event" ',i,' ONLY'

c There is no turbulence info carried forth into this subroutine right now, comment out
ccccc       call ufbint(proflun,turb_arr4,4,nlv2wrt,nlvwrt,
ccccc+                  'TRBX10 TRBX21 TRBX32 TRBX43')
ccc         print *, 'ufbint has stored TRBX10 TRBX21 TRBX32 TRBX43 on',
ccc  +               ' all levels - "event" ',i,' ONLY'

c write out moisture QC flag
            call ufbint(proflun,mstq_arr1,1,nlv2wrt,nlvwrt,'MSTQ')
ccc         print *, 'ufbint has stored MSTQ on all levels - "event"',
ccc  +               ' ',i,' ONLY'

c write out level receipt time
            call ufbint(proflun,rct_arr1,1,nlv2wrt,nlvwrt,'RCT')
ccc         print *, 'ufbint has stored RCT on all levels - "event" ',i,
ccc  +               ' ONLY'

c write out level category
            call ufbint(proflun,cat_arr1,1,nlv2wrt,nlvwrt,'CAT')
ccc         print *, 'ufbint has stored CAT on all levels - "event" ',i,
ccc  +               ' ONLY'

c write out the ascent/descent rate
            call ufbint(proflun,ialr_arr1,1,nlv2wrt,nlvwrt,'IALR')
ccc         print *, 'ufbint has stored IALR on all levels - "event" ',
ccc  +               i,' ONLY'

          endif ! i.eq.1/1st event? - only write background/pp info once

        else
C.......................................................................
C For some reason the total number of levels written out (nlv2wrt_tot) does not equal the
c  number of pressure levels written out (nlv2wrt) for this profile report - problems!!!
c  (go on to next profile)
c----------------------------------------------------------------------------------------
          print 54, nlv2wrt_tot,nlv2wrt
   54 format(/' #####> WARNING: THE TOTAL # OF LEVELS WRITTEN OUT ',I6,
     + ' .NE. THE # OF PRESSURE LEVELS WRITTEN OUT ',I6,' FOR THIS ',
     + 'PROFILE -- GO ON TO NEXT PROFILE'/)
          write(cnlv2wrt_tot,'(i3)') nlv2wrt_tot
          write(cnlv2wrt,'(i3)') nlv2wrt
          call system('[ -n "$jlogfile" ] && $DATA/postmsg '//
     +     '"$jlogfile" "***WARNING: LEVEL MISMATCH FOR PREPACQC '//
     +     'PROFILE: TOTAL WRITTEN '//cnlv2wrt_tot//' .ne. # PRESS '//
     +     'LVLS WRITTEN '//cnlv2wrt//' - PROFILE SKIPPED"')
          go to 9999
C.......................................................................
        endif

      enddo ! i = 1,mxnmev

      if(.not.l_operational) then
        write(52,fmt=8002)
 8002 format(208('X'))
      endif

 9999 continue

ccc   print *, 'out of sub2mem_mer for this merged report'

      return

      end

      program rembfr

      character*8 subset,remset

      read(5,'(a)') remset

      call openbf(20,'IN',20)
      call openbf(50,'OUT',20)
      call openbf(51,'OUT',20)

1     do while(ireadmg(20,subset,idate).eq.0)
      if(subset.ne.remset) then    
         call copymg(20,50)
      else
         call copymg(20,51)
      endif
      enddo

      stop
      end

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GBLEVENTS   PRE/POST PROCESSING OF PREPBUFR EVENTS 
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2007-09-14
C
C ABSTRACT: RUNS IN TWO MODES: "PREVENTS" AND "POSTEVENTS".  IN THE
C   PREVENTS MODE, PREPARES OBSERVATIONAL PREPBUFR REPORTS FOR
C   SUBSEQUENT QUALITY CONTROL AND ANALYSIS PROGRAMS.  THIS IS DONE
C   THROUGH THE FOLLOWING: INTERPOLATION OF GLOBAL SPECTRAL SIMGA
C   FIRST GUESS TO PREPBUFR OBSERVATION LOCATIONS WITH ENCODING OF
C   FIRST GUESS VALUES INTO PREPBUFR REPORTS; ENCODING OF "PREVENT"
C   AND/OR "VIRTMP" EVENTS INTO PREPBUFR REPORTS; AND ENCODING OF
C   OBSERVATION ERRORS FROM THE ERROR SPECIFICATION FILE INTO
C   PREPBUFR REPORTS.  IN THE POSTEVENTS MODE, AFTER ALL QUALITY
C   CONTROL AND ANALYSIS PROGRAMS HAVE RUN, INTERPOLATES THE GLOBAL
C   SPECTRAL SIMGA ANALYSIS TO PREPBUFR OBSERVATION LOCATIONS AND
C   ENCODES THESE ANALYZED VALUES INTO PREPBUFR REPORTS.  THE
C   REMAINDER OF THIS ABSTRACT APPLIES ONLY TO THE PREVENTS MODE.
C   THE "PREVENT" EVENT CAN CHANGE A QUALITY MARKER TO FLAG AN
C   OBSERVATION DATUM FOR NON-USE BY SUBSEQUENT QC AND ANALYSIS
C   PROGRAMS (FILTERING).  EXAMPLES WHERE THIS SUBROUTINE WILL WRITE
C   AN EVENT TO FLAG A DATUM INCLUDE: THE OBSERVATION ERROR FOR THAT
C   DATUM IS READ IN AS MISSING IN THE INPUT ERROR FILE, THE DATUM
C   ITSELF VIOLATES A GROSS OR "SANITY" CHECK, OR THE OBSERVED
C   PRESSURE DATUM IS MORE THAN 100 MB BELOW THE GUESS SURFACE
C   PRESSURE.  THE "VIRTMP" EVENT CAN CHANGE THE SPECIFIC HUMIDITY
C   OBSERVATION (RE-CALCULATED) AS WELL AS THE TEMPERATURE
C   OBSERVATION (FROM SENSIBLE TO VIRTUAL TEMPERATURE, BASED ON
C   JUST-CALCULATED SPECIFIC HUMIDITY).  CURRENTLY THIS APPLIES ONLY
C   TO SURFACE (LAND, MARINE AND MESONET) DATA TYPES, POSSIBLY TO
C   RAOB, DROP AND MULTI-LEVEL RECCO DAA TYPES IF THE SWITCH
C   "ADPUPA_VIRT" IS TRUE (NORMALLY, HOWEVER IT IS FALSE) [OTHER DATA
C   TYPES WITH REPORTED SENSIBLE TEMPERATURE EITHER HAVE MISSING
C   MOISTURE (E.G., ALL AIRCRAFT TYPES EXCEPT FOR SOME ACARS, SATELLITE
C   WIND TYPES), FLAGGED MOISTURE (E.G., SOME ACARS) OR CALCULATE
C   SPECIFIC HUMIDITY/VIRTUAL TEMPERATURE IN SUBSEQUENT PROGRAMS (E.G.,
C   RAOBS, DROPS AND MULTI-LEVEL RECCOS WHICH CALCULATE THESE IN
C   PROGRAM "CQCBUFR", IN WHICH CASE THE SWITCH "ADPUPA_VIRT" HERE MUST
C   BE FALSE!)]. FOR CASES WHERE THE SWITCH "DOBERR" IS FALSE, THE
C   OBSERVATION ERROR FOR ALL DATA REMAINS MISSING IN THE PREPBUFR
C   FILE.  IN THIS CASE, THE INPUT ERROR FILE IS USUALLY A NULL FILE
C   AND THE "PREVENT" EVENT TO FLAG THE DATUM IS NOT INVOKED.  FOR
C   CASES WHERE THE SWITCH "DOFCST" IS FALSE, IF THE SWITCH "SOME_FCST"
C   IS ALSO FALSE, THEN FORECAST VALUES ARE NOT ENCODED FOR ANY MESSAGE
C   TYPE; IF "SOME_FCST" IS TRUE THEN FORECAST VALUES ARE ENCODED, BUT
C   ONLY FOR REPORTS IN THOSE MESSAGE TYPES FOR WHICH A GUESS VALUE IS
C   NEEDED BY SUBSEQUENT QC PROGRAMS.  IT SHOULD BE NOTED THAT THE
C   FILTERING OF DATA ASSOCIATED WITH THE "PREVENT" EVENT PROCESSING IS
C   NOT INVOKED IF ALL THREE ARE TRUE: DOBERR= FALSE, THE FORECAST
C   VALUES ARE MISSING (DOFCST=FALSE & SOME_FCST=TRUE & MESSAGE TYPE IS
C   NOT "ADPUPA", "AIRCFT", "AIRCAR", "PROFLR", OR "VADWND" -- OR  --
C   DOFCST=FALSE & SOME_FCST=FALSE), AND "VIRTMP" EVENT PROCESSING IS
C   NOT INVOKED (EITHER MESSAGE TYPE IS NOT "ADPSFC", "SFCSHP" OR
C   "MSONET" WHEN "ADPUPA_VIRT" IS FALSE, OR MESSAGE TYPE IS NOT
C   "ADPSFC", "SFCSHP", "MSONET" OR "ADPUPA" WHEN "ADPUPA_VIRT" IS
C   TRUE).
C
C PROGRAM HISTORY LOG:
C 1999-07-01 D. A. KEYSER -- ORIGINAL AUTHOR (ADAPTED FROM PREVENTS
C     SUBROUTINE IN PREPDATA PROGRAM, BUT NOW GENERALIZED FOR
C     POSTEVENTS MODE)
C 1999-07-12 D. A. KEYSER -- MODIFIED TO INTERPOLATE MODEL SPECIFIC
C     HUMIDITY TO OBSERVATION LOCATION WHEN OBS. SPECIFIC HUMIDITY IS
C     MISSING AS LONG AS OBS. TEMPERATURE IS NON-MISSING
C 1999-09-09 D. A. KEYSER -- ADDED "VADWND" TO THE LIST OF MESSAGE
C     TYPES FOR WHICH FORECAST VALUES MUST BE ENCODED, EVEN WHEN
C     DOFCST=FALSE (NECESSARY BECAUSE THE NEW PROGRAM CQCVAD NEEDS THE
C     BACKGROUND DATA)
C 1999-09-09 D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE; 
C     'TFC' NOW GENERATED FOR VADWND MESSAGE TYPES EVEN THOUGH TOB IS
C     MISSING (NEEDED BY CQCVAD PROGRAM)
C 1999-12-01 D. A. KEYSER -- SPEC. HUMIDITY AND VIRT. TEMPERATURE ARE
C     NOW CALCULATED WHEN SPEC. HUMIDITY QUAL. MARKER IS BAD (SUBJECT
C     TO A SANITY CHECK), HOWEVER THE VIRT. TEMPERATURE GETS A BAD
C     QUAL. MARKER (8)
C 2000-09-21 D. A. KEYSER -- THE PRESSURE LEVEL ABOVE WHICH ALL SPEC.
C     HUMIDITY QUAL. MARKERS ARE "REJECTED" (Q.M. SET TO 9) IS NOW READ
C     IN AS A N-LIST SWITCH (QTOP_REJ), BEFORE IT WAS HARDWIRED TO 300
C     MB
C 2000-12-13 D. A. KEYSER -- WILL NO LONGER PERFORM VIRTUAL TEMPERATURE
C     PROCESSING FOR ACARS DATA SINCE MOISTURE IS FLAGGED RIGHT NOW
C     (ACARS MOISTURE ONLY WRITTEN INTO PREPBUFR FILE FOR STATISTICAL
C     REASONS)
C 2001-02-02 D. A. KEYSER -- RESTORED LEGACY LOGIC TO FLAG CERTAIN
C     SATELLITE TEMPERATURE SOUNDINGS EITHER BELOW 100 MB (TEMP. OBS)
C     OR ON ALL LEVELS (SPEC. HUM. OBS), CONTROLLED BY NEW NAMELIST
C     SWITCH "SATMQC"
C 2001-09-27 D. A. KEYSER -- 'TFC' AND 'QFC' NOW GENERATED FOR REPORT
C     TYPE 111 (SYNDAT REPORTS AT STORM CENTER) EVEN THOUGH "TOB" AND
C     "QOB" ARE MISSING (NEEDED BY SYNDATA PROGRAM); IN PREPARATION FOR
C     CHANGE FROM T170L42 TO T254L64 SGES, NOW MAKES COEFFICIENT ARRAYS
C     ALLOCATABLE TO ALLOW THEM TO OBTAIN MEMORY FROM "HEAP" RATHER
C     THAN FROM "STACK", ALSO HAVE INCREASED THE MAX NUMBER OF LEVELS
C     IN ARRAYS FROM 42 TO 64, FINALLY ALSO NO LONGER STOPS WITH C.
C     CODE 70 IF EVEN NUMBER OF LONGITUDES IN SIGMA GUESS (IMAX,
C     HARDWIRED TO 384) IS .LT. SPECTRAL RESOLUTION (JCAP) * 2
C 2001-10-10 D. A. KEYSER -- AT PREPBUFR CENTER DATES WITH AN HOUR THAT
C     IS NOT A MULTIPLE OF 3 (WHEN A GLOBAL SIGMA GUESS/ANAL FILE IS
C     NOT AVAILABLE; E.G., IN RUC2A RUNS) NOW PERFORMS A LINEAR
C     INTERPOLATION BETWEEN SPECTRAL COEFFICIENTS IN 2 SPANNING SIGMA
C     GUESS/ANAL FILES 3-HRS APART TO CENERATE A GUESS/ANAL FILE VALID
C     AT THE PREPBUFR CENTER TIME
C 2002-05-10 D. A. KEYSER -- ADDED "AIRCAR" TO THE LIST OF TABLE A
C     MESSAGE TYPES THAT WILL STILL HAVE THE BACKGROUND ENCODED WHEN
C     DOFCST IS FALSE (BECAUSE ACARS ARE NOW Q.C.'d IN PREPOBS_ACARSQC
C     PROGRAM)
C 2003-09-02 D. A. KEYSER -- ADDED "MSONET" TO THE LIST OF TABLE A
C     MESSAGE TYPES THAT WILL HAVE THE VIRTUAL TEMPERATURE CALCULATED;
C     DOES NOT CALL UFBINT FOR OUTPUTTING DATA IF "NLEV" (4'TH
C     ARGUMENT) IS ZERO (NOW CAN ONLY HAPPEN FOR GOESND FORECAST DATA
C     WHEN ONLY RADIANCES ARE PRESENT)
C 2004-08-30 D. A. KEYSER -- NOW INCLUDES THE 4 LAYER PWATERS, THESE
C     GET AN OBS. ERROR (EACH THE SAME AS TOTAL PWATER) AND AN EVENT
C     IS GENERATED WITH A REJECTED Q.M. FOR THE 4 LAYER PWATERS IF THE
C     PWATER OBS. ERROR READ IN IS MISSING (THIS CHANGE ALLOWS THE ETA/
C     GSI TO PROCESS OBS. ERRORS IN THE PREPBUFR FILE THE SAME AS THE
C     ETA/3DVAR DID WHEN READING THE OBS. ERRORS FROM AN EXTERNAL
C     FILE); FOR "RASSDA" TYPES, ENCODES A SIMPLE COPY OF THE REPORTED
C     (VIRTUAL) TEMPERATURE AS A "VIRTMP" EVENT IF DOVTMP IS TRUE, GETS
C     NEW REASON CODE 3
C 2004-09-10 D. T. KLEIST -- ADDED CAPABILITY TO READ GUESS FIELDS FROM
C     EITHER HYBRID OR, AS BEFORE, SIGMA GLOBAL FORECAST FILES
C 2005-01-03 D. A. KEYSER -- FIXED ERROR READING CDAS SGES FILE WHICH
C     STILL HAS A 207-WORD HEADER (T62) {2004-09-10 CHANGE ASSUMED ALL
C     SGES FILES HAD A 226-WORD HEADER (T254), BUT THIS IS VALID ONLY
C     FOR GFS SGES)
C 2006-05-05 R. E. TREADON -- CHANGE VERTICAL INTERPOLATION TO DIRECTLY
C     USE PRESSURE PROFILE, NOT PRESSURE PROFILE CONVERTED TO SIGMA.  
C     THIS CHANGE IS IN SUBROUTINE GBLEVN03.  AS A RESULT OF THIS 
C     CHANGE, SUBROUTINE GBLEVN07 WAS REMOVED.
C 2006-07-14 D. A. KEYSER -- ADDED NEW NAMELIST SWITCH "SOME_FCST"
C     WHICH APPLIES ONLY WHEN EXISTING SWITCH "DOFCST" IS FALSE: IF
C     DOFCST=F AND SOME_FCST=T THEN, JUST AS BEFORE WHEN DOFCST=F, A
C     FORECAST WILL STILL BE ENCODED FOR REPORTS IN CERTAIN MESSAGE
C     TYPES USED IN SUBSEQUENT Q.C. PROGRAMS (I.E, "ADPUPA", "AIRCFT",
C     "AIRCAR", "PROFLR" OR "VADWND") (THE DEFAULT FOR SOME_FCST IS
C     TRUE); HOWEVER IF DOFCST=F AND SOME_FCST=F THEN A FORECAST WILL
C     NOT BE ENCODED INTO REPORTS IN ANY MESSAGE TYPE (THIS ALLOWS
C     THIS PROGRAM TO ENCODE OBS ERRORS AND/OR VIRTUAL TEMPERATURE
C     EVENTS INTO A PREPBUFR FILE WITHOUT ENCODING A FORECAST); ADDED
C     NEW NAMELIST SWITCH "ADPUPA_VIRT" WHICH, WHEN TRUE, INCLUDES
C     REPORTS IN MESSAGE TYPE ADPUPA (I.E., RAOBS, DROPS, MULTI-LEVEL
C     RECCOS) IN THE "VIRTMP" PROCESSING (PROCESSING THEM WITH SAME
C     LOGIC AS IN SUBROUTINE VTPEVN OF PROGRAM PREPOBS_CQCBUFR)
C     {NORMALLY "ADPUPA_VIRT" IS FALSE (DEFAULT) BECAUSE SUBSEQUENT
C     PROGRAM PREPOBS_CQCBUFR PERFORMS THIS FUNCTION}
C 2007-09-14 S. MOORTHI -- ADDED CAPABILITY TO READ GENERALIZED SIGMA/
C     HYBRID FILES FROM THE GFS USING "SIGIO" UTILITY; ALSO, CLEANED UP
C     SOME CODE; NEW ERROR CONDITION CODES 70 AND 71 ADDED
C 2007-09-14 D. A. KEYSER -- FUNCTION OEFG01, WHICH RETURNS THE OBS
C     ERROR FOR A REQUESTED VARIABLE INTERP. TO A DEFINED PRESSURE
C     LEVEL FOR A DEFINED REPORT TYPE, MODIFIED TO USE EXACT LOGIC AS
C     IN GSI (MINIMUM LIMITING VALUE FOR OBS ERROR BASED ON VARIABLE
C     TYPE, LEVEL PRESSURE LIMITED TO MAX OF 2000 MB AND MIN OF ZERO
C     MB, A FEW OTHER MINOR CHANGES) - THIS WILL ALLOW GSI TO READ OBS
C     ERROR DIRECTLY OUT OF PREPBUFR FILE RATHER THAN OUT OF AN
C     EXTERNAL FILE; FOR PW TYPES, NOW PASSES REPORTED SURFACE PRESSURE
C     (PRSS * 0.01) INTO FUNCTION OEFG01 RATHER THAN VERTICAL
C     COORDINATE PRESSURE (POB), SINCE LATTER IS ALWAYS MISSING FOR
C     THESE TYPES (DOESN'T CHANGE VALUE COMING OUT OF OEFG01 SINCE IT
C     IS CONSTANT ON ALL LEVELS ANYWAY FOR PW); IN SUBR. GBLEVN02, Q.M.
C     9 IS NOW ASSIGNED TO A VARIABLE ONLY IF ITS OBS ERROR IS MISSING,
C     OR IN THE CASE OF MOISTURE IF THE LEVEL IS ABOVE PRESSURE LEVEL
C     "QTOP_REJ" OR IF ITS TEMPERATURE OBS ERROR IS MISSING, ALL OTHER
C     EVENT (E.G., GROSS CHECK ERRORS) ASSIGN Q.M. 8 (EVEN IF OBS ERROR
C     IS MISSING), PRIOR TO THIS ONLY REJECTION OF PRESSURE ON LEVEL
C     RESULTED IN Q.M. 8, ALL OTHER REJECTIONS GOT Q.M. 9 - THIS MEANS
C     TRULY "BAD" OBS WILL NOW ALWAYS GET Q.M. 8 AND ONLY OBS FLAGGED
C     FOR NON-USE BY ASSIMILATION (BUT STILL "GOOD") WILL NOW GET Q.M.
C     9 (GSI MONITORS, BUT DOES NOT USE, OBS WITH Q.M. 9, BUT IT DOES
C     NOT EVEN CONSIDER OBS WITH Q.M. 8); CORRECTED ERROR WHICH
C     MISTAKENLY ASSIGNED REASON CODE OF 9 INSTEAD OF 3 TO MOISTURE
C     WITH MISSING OBS ERROR; IN SUBR. GBLEVN02, Q.M. 9 WILL NOT BE
C     ASSIGNED TO A VARIABLE IF THAT VARIABLE ALREADY HAS A "BAD" Q.M.
C     (I.E., > 3 BUT < 15), IN FACT THE "PREVENT" EVENT WHICH WOULD
C     ASSIGN Q.M. 9 IS SKIPPED ENTIRELY (DO NOT WANT THE GSI TO MONITOR
C     THE OBS WHICH REALLY ARE ARE "BAD"); IN SUBR. GBLEVN08, FOR NON-
C     "ADPUPA" TYPES, Q.M. 9 IS NOW ASSIGNED TO CALCULATED VIRT. TEMPS
C     IF THE MOISTURE Q.M.  IS 9 OR 15 AND ORIG. TEMP NOT "BAD", THESE
C     "VIRTMP" EVENTS RECEIVE NEW REASON CODE 4, HAD RECEIVED Q.M. 8
C     WITH REASON CODE 2 LIKE VIRT. TEMPS CALCULATED FROM "BAD"
C     MOISTURE - THIS MEANS ONLY TRULY "BAD" VIRT. TEMPS WILL NOW GET
C     Q.M. 8 AND VIRT. TEMPS FLAGGED FOR NON-USE BY ASSIMILATION (BUT
C     STILL "GOOD") WILL NOW GET Q.M. 9 (GSI MONITORS, BUT DOES NOT
C     USE, OBS WITH Q.M. 9, BUT IT DOES NOT EVEN CONSIDER OBS WITH Q.M.
C     8); IN SUBR. GBLEVN08, FOR "ADPUPA" TYPES, Q.M. 3 IS NOW ASSIGNED
C     TO CALCULATED VIRT. TEMPS ONLY IF THE MOISTURE Q.M. IS TRULY BAD
C     (I.E. > 3 BUT NOT 9 OR 15) (AND, AS BEFORE, ORIG. TQM IS 1 OR 2
C     AND POB IS BELOW 700 MB) - BEFORE, TQM SET TO 3 WHEN QQM WAS 9 OR
C     15 AND ALL OTHER CONDITIONS MET; FOR "SATEMP" TYPES, ENCODES A
C     SIMPLE COPY OF THE REPORTED (VIRTUAL) TEMPERATURE AS A "VIRTMP"
C     EVENT IF DOVTMP IS TRUE, GETS REASON CODE 3 (SIMILAR TO WHAT IS
C     ALREADY DONE FOR "RASSDA" TYPES)
C
C USAGE:    CALL GBLEVENTS(IDATEP,IUNITF,IUNITE,IUNITP,IUNITS,SUBSET,
C          $               NEWTYP)
C   INPUT ARGUMENT LIST:
C     IDATEP   - CENTER DATE FOR PREPBUFR FILE IN THE FORM YYYYMMDDHH
C     IUNITF   - 2-WORD ARRAY:
C              - WORD 1 - UNIT NUMBER OF FIRST INPUT SPECTRAL (GLOBAL)
C              - SIGMA OR HYBRID FILE (EITHER FIRST GUESS OR ANALYSIS);
C              - IF HH IN IDATEP IS A MULTIPLE OF 3 THEN THIS FILE IS
C              - VALID AT THE DATE IN IDATEP, IF HH IN IDATEP IS NOT A
C              - MULTIPLE OF 3 THEN THIS FILE IS VALID AT THE CLOSEST
C              - TIME PRIOR TO THE DATE IN IDATEP THAT IS A MULTIPLE
C              - OF 3
C              - WORD 2 - UNIT NUMBER OF SECOND INPUT SPECTRAL (GLOBAL)
C              - SIGMA OR HYBRID FILE (EITHER FIRST GUESS OR ANALYSIS);
C              - IF HH IN IDATEP IS A MULTIPLE OF 3 THEN THIS FILE IS
C              - EMPTY, IF HH IN IDATEP IS NOT A MULTIPLE OF 3 THEN
C              - THIS FILE IS VALID AT THE CLOSEST TIME AFTER THE DATE
C              - IN IDATEP THAT IS A MULTIPLE OF 3
C     IUNITE   - UNIT NUMBER OF INPUT OBSERVATION ERROR FILE
C              - (USED ONLY IN PREVENTS MODE)
C     IUNITP   - UNIT NUMBER OF OUTPUT PREPBUFR DATA SET
C     IUNITS   - UNIT NUMBER OF "PREVENT" EVENTS DATA FILTERING
C              - SUMMARY PRINT FILE
C              - (USED ONLY IN PREVENTS MODE)
C     SUBSET   - THE BUFR MESSAGE TABLE A ENTRY FOR THE PARTICULAR
C              - REPORT BEING PROCESSED
C     NEWTYP   - INDICATOR IF THE BUFR MESSAGE TABLE A ENTRY HAS
C              - CHANGED FROM THAT OF THE PREVIOUS REPORT (=0 - NO,
C              - =1 - YES)
C                
C
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C                DOCUMENTATION BELOW)
C                (NOTE: IF STANDARD INPUT FILE IS NULL, THEN THIS
C                       SUBROUTINE RUNS IN POSTEVENTS MODE)
C     UNIT AA  - PREPBUFR DATA SET
C              - (WHERE AA IS UNIT NUMBER DEFINED AS IUNITP IN
C              - INPUT ARGUMENT LIST)
C     UNIT BB  - SPECTRAL (GLOBAL) SIGMA OR HYBRID GUESS (PREVENTS
C              - MODE) OR ANALYSIS (POSTEVENTS MODE) FILE
C              - (WHERE BB IS UNIT NUMBER DEFINED AS IUNITF(1) IN
C              - INPUT ARGUMENT LIST)
C     UNIT CC  - SPECTRAL (GLOBAL) SIGMA OR HYBRID GUESS (PREVENTS
C              - MODE) OR ANALYSIS (POSTEVENTS MODE) FILE
C              - (WHERE CC IS UNIT NUMBER DEFINED AS IUNITF(2) IN
C              - INPUT ARGUMENT LIST)
C     UNIT DD  - OBSERVATION ERROR FILE (WHERE DD IS UNIT NUMBER
C              - DEFINED AS IUNITE IN INPUT ARGUMENT LIST)
C              - (USED ONLY IN PREVENTS MODE)
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT AA  - PREPBUFR DATA SET
C              - (WHERE AA IS UNIT NUMBER DEFINED AS IUNITP IN
C              - INPUT ARGUMENT LIST)
C     UNIT DD  - "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C              - (WHERE DD IS UNIT NUMBER DEFINED AS IUNITS IN
C              - INPUT ARGUMENT LIST)
C              - (USED ONLY IN PREVENTS MODE)
C
C   SUBPROGRAMS CALLED:
C     UNIQUE:      GBLEVN02 GBLEVN03   GBLEVN04
C                  GBLEVN06 OEFG01      
C                  GBLEVN08 GBLEVN10   GBLEVN11
C                  MODULE: GBLEVN_MODULE
C     LIBRARY:
C       SPLIB    - SPTEZM   SPTEZMV
C       W3LIB    - W3MOVDAT ERREXIT
C       BUFRLIB  - UFBINT   UFBQCD
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C     COND =  60 - OBSERVATION ERROR TABLE EMPTY OR DOES NOT EXIST
C     COND =  61 - VARIABLE NLTD .NE. VARIABLE NLEV
C     COND =  62 - VARIABLE NLTQ .NE. VARIABLE NLEV
C     COND =  63 - VARIABLE NLQQ .NE. VARIABLE NLEV
C     COND =  68 - DATE OF FIRST GUESS/ANALYSIS FILE(S) DOES NOT MATCH,
C                - OR AT LEAST SPAN, THE CENTER DATE FOR THE PREPBUFR
C                - FILE
C     COND =  69 - VARIABLE KMAX TOO BIG - UNABLE TO TRANSFORM FIRST
C                - GUESS OR ANALYSIS FILE(S)
C     COND =  70 - CALL TO SIGIO_RROPEN RETURNED WITH NON-ZERO R.C.
C     COND =  71 - CALL TO SIGIO_RRHEAD RETURNED WITH NON-ZERO R.C.
C
C
C REMARKS: THIS SUBROUTINE WILL NOT WORK CORRECTLY IN THE w3_8 LIBRARY.
C     PLEASE COMPILE APPLICATION CODE USING w3_4 OR w3_d LIBRARIES.
C
C     THIS ROUTINE PROCESSES ONE REPORT AT A TIME.  IT EXPECTS THAT THE
C     CALLING PROGRAM HAS ALREADY ENCODED THE REPORT INTO THE PREPBUFR
C     FILE VIA THE UFBINT OR UFBCPY ROUTINES.  THE CALLING PROGRAM
C     SHOULD THEN CALL THIS ROUTINE AND, UPON ITS RETURN, THE CALLING
C     PROGRAM SHOULD CALL WRITSB TO ACTUALLY WRITE THE UPDATED SUBSET
C    (REPORT) INTO THE BUFR MESSAGE.
CC
C  ***** VARIABLES IN NAMELIST PREVDATA READ IN BY THIS SUBROUTINE *****
C               (NOTE: IF STANDARD INPUT FILE IS NULL, THEN THIS
C                      SUBROUTINE RUNS IN POSTEVENTS MODE - DOANLS=TRUE
C                      AND ALL OTHER VARIABLES ARE SET TO FALSE)
CC
CC
C    DOVTMP & ADPUPA_VIRT:
C      DOVTMP  - WRITE VIRTUAL TEMPERATURE EVENT FOR THE FOLLOWING
C                TYPES OF REPORTS:
C                ADPUPA_VIRT = .FALSE.  ---> SURFACE LAND, MARINE,
C                                             MESONET AND RASS REPORTS?
C                ADPUPA_VIRT = .TRUE.   ---> SURFACE LAND, MARINE,
C                                             MESONET RASS, RAOB, DROP
C                                             AND MULTI-LEVEL RECCO
C                                             REPORTS?
C              FOR ALL TYPES EXCEPT RASS, THIS WILL ATTEMPT TO
C              CALCULATE VIRTUAL TEMPERATURE FROM SENSIBLE TEMPERATURE
C              AND ENCODE IT AS A STACKED EVENT IN THE PREPBUFR FILE.
C              FOR RASS REPORTS THIS WILL JUST ENCODE THE REPORTED
C              TEMPERATURE AS A STACKED EVENT IN THE PREPBUFR FILE
C              SINCE THE REPORTED TEMPERATURE IS ALREADY VIRTUAL.
C                DOVTMP = .TRUE.  ---> YES                     (DEFAULT)
C                DOVTMP = .FALSE. ---> NO
C      {NOTE1: FOR SURFACE LAND, MARINE AND MESONET REPORTS, (AND
C              RAOB, DROP AND MULTI-LEVEL RECCO REPORTS IF
C              "ADPUPA_VIRT"=TRUE) DOVTMP=FALSE WILL STILL RE-CALCULATE
C              SPECIFIC HUMIDITY AND ENCODE IT AS A STACKED EVENT IN
C              THE PREPBUFR FILE UNLESS DOANLS IS TRUE.)
C      (NOTE2: DOES NOT APPLY TO ANY REPORT TYPES OTHER THAN THOSE
C              MENTIONED ABOVE)
C      (NOTE3: IF DOANLS=TRUE, THEN DOVTMP IS NOT ONLY FORCED TO BE
C              FALSE, BUT ALSO SPECIFIC HUMIDITY IS NOT RE-CALCULATED.)
C      (NOTE4: ADPUPA_VIRT DEFAULTS TO FALSE.)
C
C    DOFCST & SOME_FCST:
C      DOFCST  - ENCODE FORECAST (FIRST GUESS) VALUES, INTERPOLATED
C                FROM THE SPECTRAL SIGMA OR HYBRID GUESS FILE, INTO THE
C                PREPBUFR FILE FOR ALL MESSAGE TYPES OR AT LEAST SOME
C                MESSAGE TYPES?
C                DOFCST = .TRUE.  ---> YES, ENCODE FORECST FOR ALL
C                                       MESSAGE TYPES          (DEFAULT)
C                DOFCST = .FALSE.
C                  SOME_FCST = .FALSE. ---> NO, DO NOT ENCODE FORECAST
C                                            FOR ANY MESSAGE TYPE
C                                            (VALUES REMAIN MISSING)
C                  SOME_FCST = .TRUE.  ---> YES, BUT ONLY FOR MESSAGE
C                                            TYPES "ADPUPA", "AIRCFT",
C                                            "AIRCAR", "PROFLR" OR
C                                            "VADWND" (VALUES REMAIN
C                                            MISSING FOR ALL OTHER
C                                            MESSAGE TYPES)
C      (NOTE1: THE CASE DOFCST=FALSE & SOME_FCST=TRUE WRITES THE
C              FORECAST VALUES FOR THE TYPES MENTIONED ABOVE BECAUSE
C              THEY ARE NEEDED BY SUBSEQUENT QUALITY CONTROL PROGRAMS.)
C      (NOTE2: THIS WAS ADDED AS A TIME SAVING FEATURE IN THE
C              NON-GLOBAL VERSIONS SINCE ONLY THE GLOBAL REQUIRES A
C              FIRST GUESS TO BE PRESENT FOR ALL CONVENTIONAL MESSAGE
C              TYPES IN THE PREPBUFR FILE.)
C      (NOTE3: IF DOANLS=TRUE, THEN DOFCST & SOME_FCST ARE FORCED TO BE
C              FALSE, MEANING A GUESS WILL NOT BE ENCODED FOR ANY
C              MESSAGE TYPE.)
C      (NOTE4: IF DOFCST=TRUE, THEN SOME_FCST IS MEANINGLESS.)
C      (NOTE5: SOME_FCST DEFAULTS TO TRUE.)
C
C    DOANLS  - ENCODE ANALYZED VALUES, INTERPOLATED FROM THE SPECTRAL
C              SIGMA OR HYBRID ANALYSIS FILE, INTO THE PREPBUFR FILE -
C              POSTEVENTS MODE - ?
C              DOANLS = .TRUE.  ---> YES, FOR ALL MESSAGE TYPES
C              DOANLS = .FALSE. ---> NO,  FOR ALL MESSAGE TYPES
C                                          - PREVENTS MODE -   (DEFAULT)
C      (NOTE:  DOANLS=TRUE WILL OVERRIDE AND FORCE TO FALSE ALL OTHER
C              SWITCHES. IN ADDITION, THE FORECAST VALUES WILL NOT
C              BE ENCODED FOR ANY MESSAGE TYPE AND SPECIFIC HUMIDITY
C              WILL NOT BE RE-CALCULATED.)
C
C    DOBERR  - ENCODE OBSERVATIONAL ERROR VALUES, AS READ FROM OBS.
C              ERROR FILE, INTO THE PREPBUFR FILE?
C              DOBERR = .TRUE.  ---> YES                       (DEFAULT)
C              DOBERR = .FALSE. ---> NO (VALUES REMAIN MISSING)
C      (NOTE1: THIS WAS ADDED AS A TIME SAVING FEATURE IN THE
C              RUC VERSION SINCE IT DOES NOT REQUIRE OBSERVATIONAL
C              ERRORS TO BE PRESENT IN THE PREPBUFR FILE.  THE GSI WILL
C              REQUIRE THE OBS ERROR IN THE PREPBUFR FILE FOR THE ETA,
C              UNLIKE THE 3DVAR WHICH DID NOT.)
C      (NOTE2: IF DOANLS=TRUE, THEN DOBERR IS FORCED TO BE FALSE.)
C
C    QTOP_REJ  - THE PRESSURE LEVEL (IN MB) ABOVE WHICH ALL SPECIFIC
C                HUMIDITY QUALITY MARKERS ARE "REJECTED" (THE QUALITY
C                MARKER IS SET TO 9 ON ALL PRESSURE LEVELS LESS THAN
C                THIS LEVEL)                              (DEFAULT=300.)
C
C    SATMQC  - PERFORM SPECIAL QUALITY CONTROL ON SATELLITE TEMPERATURE
C              SOUNDINGS IN REPORT TYPES 160-179?
C              SATMQC = .TRUE.  ---> YES
C              SATMQC = .FALSE. ---> NO                        (DEFAULT)
C      (NOTE: THIS APPLIES ONLY TO THE CDAS OR HISTORICAL RE-RUNS
C             WITH TEMPERATURE SOUNDINGS IN THESE REPORT TYPES)
C
CC
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM-SP
C
C$$$
      MODULE GBLEVN_MODULE

      IMPLICIT NONE

      SAVE

      INTEGER   IMAX,JMAX,KMAX,KMAXS,NBAK
      !INTEGER*4 IDVC,IDSL,NVCOORD,SFCPRESS_ID,THERMODYN_ID
      REAL (KIND=8), ALLOCATABLE :: IAR14T(:,:,:), IAR15U(:,:,:),
     $                              IAR16V(:,:,:), IAR17Q(:,:,:),
     $                              IARPSI(:,:,:), IARPSL(:,:,:),
     $                              IAR12Z(:,:),   IAR13P(:,:)

      REAL (KIND=4), ALLOCATABLE :: iarps(:,:,:),iarzs(:,:,:)
      REAL (KIND=4), ALLOCATABLE :: iarqq(:,:,:,:),iartt(:,:,:,:)
      REAL (KIND=4), ALLOCATABLE :: iaruu(:,:,:,:),iarvv(:,:,:,:)
      REAL (KIND=4), ALLOCATABLE :: iarzi(:,:,:,:),iarzl(:,:,:,:)
      REAL (KIND=4), ALLOCATABLE :: iarpi(:,:,:,:),iarpl(:,:,:,:)

      REAL (KIND=4), ALLOCATABLE :: VCOORD(:,:)
      REAL (KIND=4), ALLOCATABLE :: slats(:) 

      REAL(4) DLAT,DLON,TSPAN,stnelev
      REAL(8) XYT(3,255),OBX(15,255),bmiss/10E10/

      INTEGER, PARAMETER :: idrt=4

      logical rsfc,fits,obl

      END MODULE GBLEVN_MODULE

      SUBROUTINE GBLEVENTS(IDATEP,IUNITF,IUNITE,IUNITP,IUNITS,SUBSET,
     $                     NEWTYP)

      USE GBLEVN_MODULE

      !!INTEGER, PARAMETER :: IM=384 , JM=190              ! im==384,768,1152
      !!INTEGER, PARAMETER :: IM=1152, JM=IM/2+1           ! im==384,768,1152
      !!INTEGER, PARAMETER :: IM=1536, JM=IM/2+1           ! im==384,768,1152
      !!INTEGER, PARAMETER :: IM=1760, JM=880              ! im==384,768,1152
        INTEGER            :: IM=0000, JM=000              ! gets latb,lonb from the sigma files

      CHARACTER*255 parm 
      CHARACTER*80 HEADR,OBSTR,QMSTR,FCSTR,OESTR,ANSTR
      CHARACTER*8  SUBSET
      REAL(8)      OBS,QMS,BAK,SID,HDR(10)
      LOGICAL      DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,DOANLS,
     $             SATMQC,ADPUPA_VIRT

      INTEGER      IUNITF

      COMMON /GBEVAA/ SID,OBS(15,255),QMS(12,255),BAK(12,255),XOB,
     $ YOB,DHR,TYP,NLEV
      COMMON /GBEVBB/ IPVCD,IVTCD
      COMMON /GBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT
      COMMON /GBEVDD/ ERRS(300,33,6)

      SAVE

      DATA IFIRST/0/

      DATA HEADR /
     $ 'SID XOB YOB DHR TYP ELV                                   '/
      DATA OBSTR /
     $ 'POB QOB TOB ZOB UOB VOB PWO  PW1O PW2O PW3O PW4O CAT PRSS TVO'/
      DATA QMSTR /
     $ 'PQM QQM TQM ZQM WQM PWQ PW1Q PW2Q PW3Q PW4Q NUL  NUL      '/
      DATA FCSTR /
     $ 'PFC QFC TFC ZFC UFC VFC PWF  PW1F PW2F PW3F PW4F NUL      '/
      DATA ANSTR /
     $ 'PAN QAN TAN ZAN UAN VAN PWA  PW1A PW2A PW3A PW4A NUL      '/
      DATA OESTR /
     $ 'POE QOE TOE ZOE WOE PWE PW1E PW2E PW3E PW4E NUL  NUL      '/

      NAMELIST /PREVDATA/DOVTMP,DOFCST,SOME_FCST,DOBERR,DOANLS,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT,nbax,span,fits,rsfc

      include "mpif.h"

C----------------------------------------------------------------------
C----------------------------------------------------------------------

C -------------------------------
C FIRST TIME IN DO A FEW THINGS...
C -------------------------------

      IF(IFIRST.EQ.0)  THEN
         !BMISS INITIALIZED IN PREVENT MAIN PROGRAM
         call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
         IFIRST = 1
         if(myid==0)PRINT 700
  700 FORMAT(/1X,100('#')/' =====> SUBROUTINE GBLEVENTS INVOKED FOR ',
     $ 'THE FIRST TIME - VERSION LAST UPDATED 2007-09-14'/)

C  INITIALIZE NAMELIST SWITCHES TO DEFAULT VALUES
C  ----------------------------------------------

         DOVTMP      = .TRUE.
         DOFCST      = .TRUE.
         SOME_FCST   = .TRUE.
         DOBERR      = .TRUE.
         DOANLS      = .FALSE.
         QTOP_REJ    = 300.
         SATMQC      = .FALSE.
         ADPUPA_VIRT = .FALSE.
         nbax        = 1
         span        = 0
         rsfc        = .true.
         fits        = .true.

c  open and/or read parmfile with namelist override values
c  -------------------------------------------------------

         NARG=IARGC(); IF(NARG==0) goto 100 ! try to read stdin
         call getarg(1,parm); parm = TRIM(parm)//CHAR(0)
         open(5,file=parm) ! open parm in lieu of stdin
100      READ(5,PREVDATA,ERR=101,END=102)
         GO TO 103

C-----------------------------------------------------------------------
  101    CONTINUE

C  ERROR READING STANDARD INPUT - THIS DEFAULTS TO POSTEVENTS MODE
C  ---------------------------------------------------------------

         PRINT 7013
 7013 FORMAT(/' ##> GBLEVENTS: ERROR READING STANDARD INPUT DATA CARDS',
     $ ' -- DEFAULTS TO "POSTEVENTS" MODE'/)
         DOANLS = .TRUE.
         GO TO 103

C-----------------------------------------------------------------------
  102    CONTINUE

C  STANDARD INPUT IS EMPTY - THIS DEFAULTS TO POSTEVENTS MODE
C  ----------------------------------------------------------

         PRINT 7014
 7014 FORMAT(/' ##> GBLEVENTS: STANDARD INPUT DATA CARDS DO NOT ',
     $ 'EXIST -- DEFAULTS TO "POSTEVENTS" MODE'/)
         DOANLS = .TRUE.

C-----------------------------------------------------------------------
  103    CONTINUE
         IF(DOANLS.or.fits) THEN
            DOVTMP      = .FALSE.
            SOME_FCST   = .FALSE.
            DOBERR      = .FALSE.
            ADPUPA_VIRT = .FALSE.
            fits        = .true. 
         ENDIF
         IF(DOANLS) dofcst=.false.
         if(myid==0) WRITE (6,PREVDATA)

         FCST = DOFCST
         VIRT = .FALSE.

         nbak=nbax;tspan=span ! move nl vals to module level

C  CHECK VALID-TIME DATE OF GUESS/ANALYSIS FILE(S) AGAINST THE CENTER
C   DATE FOR THE PREPBUFR FILE AND OBTAIN THE FIRST GUESS/ANALYSIS
C   UNLESS ALL OF DOFCST, SOME_FCST, DOANLS ARE FALSE
C  ------------------------------------------------------------------

         if(myid==0) then
         IF(.NOT.DOANLS)  THEN
            IF(.NOT.DOFCST.AND..NOT.SOME_FCST)  THEN
               PRINT 901
  901 FORMAT(/' --> GBLEVENTS: PREVENTS MODE - FIRST GUESS NOT READ ',
     $ 'IN'/)
            ELSE
               PRINT 701
  701 FORMAT(/' --> GBLEVENTS: PREVENTS MODE - DATE CHECK AND ',
     $ 'TRANSFORM THE FIRST GUESS'/)
            ENDIF
         ELSE
            PRINT 7701
 7701 FORMAT(/' --> GBLEVENTS: POSTEVENTS MODE - DATE CHECK AND ',
     $ 'TRANSFORM THE ANALYSIS'/)
         ENDIF
         endif

         IF(DOFCST .OR. SOME_FCST .OR. DOANLS) then

            iunitf=20
            CALL SELECTFILE(IUNITF,INPTYP)
            if(inptyp==0) call bort('bad inptyp from selectfile')
            rsfc=(rsfc.and.inptyp==1)

            DO KBAK=1,NBAK
            if(kbak==myid+1) then
               IUNITF=KBAK+19
               idhr=tspan*(kbak-(nbak+1)/2)        
               CALL ADDATE(IDATEP,idhr,IDATEC)
               if(kbak==4) idatec=idatep
               if(inptyp==1) CALL GBLEVN10(IUNITF,IDATEC,IM,JM,kbak)
               if(inptyp==2) CALL GBLEVN10nems(IUNITF,IDATEC,IM,JM,kbak)
               if(inptyp==3) CALL GBLEVN10netc(IUNITF,IDATEC,IM,JM,kbak)
               if(myid==0  ) call prttime('gblevn10')
               if(inptyp==1) CALL GBLEVN12(KBAK) ! copies one background time level to hterpt arrays
               if(myid==0  ) call prttime('gblevn12')
            endif
            lug=kbak+29
            if(rsfc) call readsf(lug,idatec,kbak) ! read surface fields
            ENDDO
           
            !at this barrier broadcast backgrounds to comm world
            !print*,'myid=',myid,' into barrier'
            call mpicast 
            if(myid==0) call prttime('mpicast')
         ENDIF

         if(nbax==4)then
            call comp_amf
            nbak=3
         endif

         IF('KILL'=='KILL')THEN        
            !if(myid==0)CALL W3TAGE('PREPOBS_PREVENTS')
            !call mpi_finalize(mret)
            !stop
         ENDIF

         IF(DOBERR)  THEN

C  IF REQUESTED, READ ERROR FILES (ONLY POSSIBLE IN PREVENTS MODE)
C  ---------------------------------------------------------------

            if(myid==0)PRINT 702
  702 FORMAT(/' --> GBLEVENTS: READ ERROR FILES'/)

            CALL GBLEVN01(IUNITE)

         ELSE

            ERRS = 0
            IF(myid==0.and..NOT.DOANLS)  PRINT 3702
 3702 FORMAT(/' --> GBLEVENTS: OBS. ERROR NOT ENCODED IN PREPBUFR ',
     $ '(BY CHOICE)'/)

         ENDIF

         if(myid==0)PRINT 703
  703 FORMAT(/1X,100('#')/)

C  SET-UP OUTPUT "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C  (ONLY USED IN PREVENTS MODE)
C  ----------------------------------------------------------------

         IF(.NOT.DOANLS.and.myid==0)  WRITE(IUNITS,1701) IDATEP
 1701 FORMAT(//130('#')//38X,'*** "PREVENT" EVENTS DATA FILTERING ',
     $ 'SUMMARY ***'/35X,'--> CENTER DATE FOR PREPBUFR FILE IS: ',I10,
     $ ' <--'//)

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      if(subset=='NONE')return ! this for call before reading any bufr

      ENDIF

C  OBTAIN NECESSARY PROGRAM CODES (ONLY USED IN PREVENTS MODE)
C  -----------------------------------------------------------

         CALL UFBQCD(IUNITP,'PREVENT',IPVCD)
         CALL UFBQCD(IUNITP,'VIRTMP ',IVTCD)

      IF(.NOT.DOANLS)  THEN

         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1702)  SUBSET
 1702 FORMAT(130('-')/39X,'--> SUMMARY FOR TABLE A ENTRY "',A8,'" <--'/)

         IF(.NOT.DOFCST .AND. SOME_FCST)  FCST = (SUBSET.EQ.'ADPUPA  '
     $    .OR.SUBSET.EQ.'PROFLR  '.OR.SUBSET .EQ.'AIRCFT  '.OR.SUBSET
     $    .EQ.'AIRCAR  '.OR.SUBSET .EQ.'VADWND  ')

C   Will not subject ACARS reports to virtual temp. processing until
C    spec. humidity is used in production

ccccc    VIRT = (SUBSET.EQ.'ADPSFC  '.OR.SUBSET.EQ.'SFCSHP  '.OR.
ccccc$           SUBSET.EQ.'MSONET  '.OR.SUBSET.EQ.'AIRCAR  '.OR.
ccccc$           SUBSET.EQ.'RASSDA  '.OR.SUBSET.EQ.'SATEMP  '.OR.
ccccc$           (SUBSET.EQ.'ADPUPA  '.AND.ADPUPA_VIRT))
         VIRT = (SUBSET.EQ.'ADPSFC  '.OR.SUBSET.EQ.'SFCSHP  '.OR.
     $           SUBSET.EQ.'MSONET  '.OR.SUBSET.EQ.'RASSDA  '.OR.
     $           SUBSET.EQ.'SATEMP  '.OR.
     $           (SUBSET.EQ.'ADPUPA  '.AND.ADPUPA_VIRT))


         IF(.NOT.(FCST.OR.DOBERR.OR.VIRT)) THEN
            IF(NEWTYP.EQ.1)  WRITE(IUNITS,1703)
 1703 FORMAT(/'  ==> DATA FILTERING NOT PERFORMED FOR THIS TABLE A ',
     $ 'ENTRY -- FORECAST, OBS ERROR, "VIRTMP" PROCESSING NOT DONE'/)
            RETURN
         ENDIF

      ENDIF

C  READY TO RETRIEVE NECESSARY INFORMATION OUT OF THE NEXT REPORT WHICH
C  HAS BEEN "UFB" ENCODED INTO THE PREPBUFR FILE BY THE CALLING PROGRAM
C  (USE NEGATIVE UNIT NUMBER HERE SINCE FILE OPEN FOR OUTPUT)
C  (NOTE: THE CALLING PROGRAM HAS NOT YET WRIITEN THE REPORT INTO
C         THE PREPBUFR FILE VIA WRITSB!)
C  ----------------------------------------------------------------

      !print*,'into main'

      CALL UFBINT(-IUNITP,OBS,15,255,NLEV,OBSTR); !print*,'after read1'
      CALL UFBINT(-IUNITP,QMS,12,255,NLEV,QMSTR); !print*,'after read2'
      CALL UFBINT(-IUNITP,HDR,10,  1,IRET,HEADR); !print*,'after read3'
      SID = HDR(1)
      XOB = HDR(2)
      YOB = HDR(3)
      DHR = HDR(4)
      TYP = HDR(5)
      stnelev = hdr(6)

      CALL UFBINT(-IUNITP,XYT,3,255,IRET,'XDR YDR HRDR')
      !print*,'after read4'


C  -----------------------------------------------------------------
C  PREVENTS MODE:   ENCODE FIRST GUESS VALUES INTO PREPBUFR FILE 
C                   and return if fits mode 
C  -----------------------------------------------------------------
C  POSTEVENTS MODE: ENCODE ANALYSIS VALUES INTO REPORT AND RETURN TO
C                   CALLING PROGRAM TO WRITE GBL-EVENTED REPORT
C                   (SUBSET) INTO PREPBUFR FILE
C  -----------------------------------------------------------------

      IF(FCST.OR.DOANLS)  THEN
         if(nbak==2) CALL GBLEVN03(SUBSET) 
         if(nbak/=2) CALL GBLEVN35(SUBSET) 
         IF(NLEV.GT.0)  THEN
            IF(FCST)   THEN
               CALL UFBINT(IUNITP,BAK,12,NLEV,IRET,FCSTR)
               IF(FITS) RETURN
            ELSE
               CALL UFBINT(IUNITP,BAK,12,NLEV,IRET,ANSTR)
               RETURN
            ENDIF
         ENDIF
      ENDIF

      !print*,myid,'after gb35'

C  --------------------------------------------------------------------
C  LOGIC FROM HERE ON PERTAINS ONLY TO PREVENTS MODE OF THIS SUBROUTINE
C  --------------------------------------------------------------------


      IF(DOBERR)  THEN

C  ENCODE OBSERVATION ERRORS INTO REPORT
C  -------------------------------------

         CALL GBLEVN04 ;!print*,'after gblevn04'
         IF(NLEV.GT.0)  CALL UFBINT(IUNITP,BAK,12,NLEV,IRET,OESTR)
      ENDIF

C  MAKE THE GBLEVENTS EVENTS AND ENCODE INTO REPORT
C  ------------------------------------------------

      IF(.NOT.FCST)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1704)
 1704 FORMAT(/'  ==> FORECAST VALUES NOT ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA POB VS. GESS PSFC TEST NOT ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE FORECAST VALUES NOT ',
     $ 'PROCESSED/STORED'/)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1708)
 1708 FORMAT(/'  ==> FORECAST VALUES ARE ENCODED FOR THIS TABLE A ',
     $ 'ENTRY'//'  ==> FILTERING VIA POB VS. GESS PSFC TEST IS  ',
     $ 'PERFORMED FOR THIS TABLE A ENTRY SINCE FORECAST VALUES ARE ',
     $ 'PROCESSED/STORED'/)
      ENDIF

      IF(.NOT.DOBERR)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1705)
 1705 FORMAT(/'  ==> FILTERING VIA MISSING OBS ERROR TEST NOT POSSIBLE',
     $ ' FOR THIS TABLE A ENTRY SINCE OBS ERROR VALUES NOT PROCESSED/',
     $ 'STORED'/)
      ENDIF

      CALL GBLEVN02(IUNITP,IUNITS,NEWTYP); !print*,'after gblevn02'

C  MAKE THE VIRTUAL TEMPERATURE EVENTS AND ENCODE INTO REPORT
C  ----------------------------------------------------------

      IF(.NOT.VIRT)  THEN
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1706)
 1706 FORMAT(/'  ==> "VIRTMP" EVENT PROCESSING NOT PERFORMED FOR THIS ',
     $ 'TABLE A ENTRY'/)
      ELSE
         IF(NEWTYP.EQ.1)  WRITE(IUNITS,1707)
 1707 FORMAT(/'  ==> "VIRTMP" EVENT PROCESSING IS  PERFORMED FOR THIS ',
     $ 'TABLE A ENTRY'/)
         CALL GBLEVN08(IUNITP,SUBSET); !print*,'after gblevn08'
      ENDIF

C  RETURN TO CALLING PROGRAM TO WRITE GBL-EVENTED REPORT (SUBSET) INTO
C   PREPBUFR FILE
C  -------------------------------------------------------------------

      RETURN

      END
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      MODULE READSF_MODULE

      IMPLICIT NONE

      SAVE

      INTEGER ni,nj,jg,kg,nsfc                   
      integer,allocatable::nin(:) 
      REAL(4),allocatable::f10(:,:,:)
      REAL(4),allocatable::slat(:),wlat(:),sfclat(:)
      REAL(4) x1,x2,y1,y2,dx,dy 
      DATA    jg/1000000/
      data    nsfc/11/

      END MODULE READSF_MODULE
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine readsf(lug,idateg,kbac)                 

      use gblevn_module
      use readsf_module
      use sp_mod, only: splat
      use sfcio_module, only: sfcio_intkind,sfcio_head,sfcio_data,
     .                        sfcio_srohdc,sfcio_axdata


      character(24) filename

      real(4),allocatable::work(:,:,:) 

      type(sfcio_head):: sfc_head
      type(sfcio_data):: sfc_data

c-----------------------------------------------------------------------
c-----------------------------------------------------------------------

      write(filename,'("fort.",i2.2)')lug

!     Read surface file
      call sfcio_srohdc(lug,filename,sfc_head,sfc_data,irets)
      !print*,lug,filename,irets


!     Check for possible problems
      if (irets /= 00000) then
       write(6,*)'READ_GFSSFC:  ***ERROR*** problem reading ',filename,
     .      ', irets=',irets
       call sfcio_axdata(sfc_data,irets)
       stop
      endif

      latb=sfc_head%latb
      lonb=sfc_head%lonb
      if(kbac==1) allocate(f10(lonb,latb,nbak),nin(latb))

!     Load surface fields into local work array
      allocate(work(lonb,latb,nsfc)); work=0
      do j=1,latb
         do i=1,lonb
            work(i,j,1) = sfc_data%tsea(i,j)     ! skin temperature
            work(i,j,2) = sfc_data%smc(i,j,1)    ! soil moisture
            work(i,j,3) = sfc_data%sheleg(i,j)   ! snow depth
            work(i,j,4) = sfc_data%stc(i,j,1)    ! soil temperature
            work(i,j,5) = sfc_data%slmsk(i,j)    ! sea/land/ice mask
            work(i,j,6) = sfc_data%vfrac(i,j)    ! vegetation cover
            work(i,j,7) = sfc_data%f10m(i,j)     ! 10m wind factor
            work(i,j,8) = sfc_data%vtype(i,j)    ! vegetation type
            work(i,j,9) = sfc_data%stype(i,j)    ! soil type
            work(i,j,10) = sfc_data%zorl(i,j)    ! surface roughness length (cm)
            work(i,j,11) = sfc_data%orog(i,j)    ! terrain
         end do
      end do

      f10(:,:,kbac)=work(:,:,7)

c  save grid parameters first time through
      
      if(kbac==1) then
         !print*,'readsf',latb,lonb
         do i=1,latb/2; j=latb+1-i
         nin(i)=sfc_head%lpl(i)
         nin(j)=sfc_head%lpl(i);!print*,i,nin(i),j,nin(j) 
         enddo
         ni=lonb; nj=latb; rad2deg=180./acos(-1.)
         allocate(slat(latb),wlat(latb),sfclat(latb))
         call splat(4,latb,slat,wlat)
         sfclat(:)=asin(slat)*rad2deg        
         deallocate(slat,wlat) 
      endif

! normal exit

      !print*,'from readsf',kpds(5),kg,iret
      !print*,kgds(2) ,' - N(I) NR POINTS ON LATITUDE CIRCLE'
      !print*,kgds(3) ,' - N(J) NR POINTS ON LONGITUDE MERIDIAN'
      !print*,kgds(4) ,' - LA(1) LATITUDE OF ORIGIN'
      !print*,kgds(5) ,' - LO(1) LONGITUDE OF ORIGIN'
      !print*,kgds(6) ,' - RESOLUTION FLAG (RIGHT ADJ COPY OF OCTET 17)'
      !print*,kgds(7) ,' - LA(2) LATITUDE OF EXTREME POINT'
      !print*,kgds(8) ,' - LO(2) LONGITUDE OF EXTREME POINT'
      !print*,kgds(9) ,' - DI LONGITUDINAL DIRECTION OF INCREMENT'
      !print*,kgds(10),'- DJ LATITUDINAL DIRECTION INCREMENT'
      !print*,kgds(11),'- SCANNING MODE FLAG (RIGHT ADJ COPY OF )'

      deallocate(work) 

      return 
900   print*,iret,' reading ',jpds(5),jpds(6),jpds(7),jg,kg,kgx
      call bort('readsl - error from getgb')          
      end
C-----------------------------------------------------------------------
C  SUBROUTINE HTERPSF - Surface 3D LINEAR INTERPOLATION IN X,Y,T
C-----------------------------------------------------------------------
      SUBROUTINE HTERPSF(XOB,YOB,DHR,GRID,TERP)

      USE GBLEVN_MODULE
      USE READSF_MODULE

      integer ibk
      REAL    GRID(NI,NJ,NBAK),TERP
      REAL    xob,yob,dhr,bak1,bak2

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

C  CALCULATE interpolation parameters for x,y,t
C  --------------------------------------------

      idir=-1; !sign(1.,y1)

      wy=yob;call grdcrd(wy,1,sfclat,nj,idir)
      J0 = WY
      J1 = MIN(J0+1,NJ)
      WY = WY-J0

      DX0 = 360./FLOAT(NIN(J0))
      WX0 = XOB/DX0 + 1.0
      I00 = WX0
      I01 = MOD(I00,NIN(J0)) + 1
      WX0 = WX0-I00

      DX1 = 360./FLOAT(NIN(J1))
      WX1 = XOB/DX1 + 1.0
      I10 = WX1
      I11 = MOD(I10,NIN(J1)) + 1
      WX1 = WX1-I10

      call tterp(dhr,ibk,twt)

c  interpolate from grid in space and time
c  ---------------------------------------

      DO I=IBK,IBK+1; N=MIN(I,NBAK)
      P1 = GRID(I00,J0,N)
      P2 = GRID(I01,J0,N)
      P3 = GRID(I10,J1,N)
      P4 = GRID(I11,J1,N)
      P5 = P1+(P2-P1)*WX0
      P6 = P3+(P4-P3)*WX1
      if(i==ibk) bak1 = P5 + (P6-P5)*WY
      if(i/=ibk) bak2 = P5 + (P6-P5)*WY
      enddo

      terp = bak1+(bak2-bak1)*twt

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    ADDATE
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1994-01-06
C
C ABSTRACT: THIS SUBROUTINE UPDATES AN EIGHT (YYMMDDHH) OR TEN
C   (YYYYMMDDHH) DIGIT INTEGER DATE BY A SPECIFIED NUMBER OF HOURS.
C   IT MAY BE REMOVED FROM THE BUFR ARCHIVE LIBRARY IN A FUTURE VERSION,
C   SINCE IT IS NO LONGER CALLED BY ANY BUFR ARCHIVE LIBRARY ROUTINES
C   AND SINCE THE SAME LOGIC IS AVAILABLE IN THE NCEP W3 LIBRARY
C   (E.G. SUBROUTINE W3MOVDAT).  USERS SHOULD MIGRATE TO THE USE OF
C   THE NCEP W3 LIBRARY INSTEAD.
C
C PROGRAM HISTORY LOG:
C 1994-01-06  J. WOOLLEN -- ORIGINAL AUTHOR
C 1996-12-11  J. WOOLLEN -- NEW DATE ARITHMETIC ROUTINE ADDED
C 2003-11-04  S. BENDER  -- ADDED REMARKS/BUFRLIB ROUTINE
C                           INTERDEPENDENCIES
C 2003-11-04  D. KEYSER  -- UNIFIED/PORTABLE FOR WRF; ADDED
C                           DOCUMENTATION (INCLUDING HISTORY)
C 2004-08-18  J. ATOR    -- FIX BUG FOR YEARS THAT ARE MULTIPLE
C                           OF 100 BUT NOT OF 400
C 2009-03-23  J. ATOR    -- MARKED AS OBSOLETE AND ADDED PRINT
C                           NOTIFICATION USING ERRWRT
C
C USAGE:    CALL ADDATE (IDATE, JH, JDATE)
C   INPUT ARGUMENT LIST:
C     IDATE    - INTEGER: EIGHT- OR TEN-DIGIT DATE
C     JH       - INTEGER: NUMBER OF HOURS (+ OR -) BY WHICH IDATE
C                SHOULD BE UPDATED
C
C   OUTPUT ARGUMENT LIST:
C     JDATE    - INTEGER: EIGHT- OR TEN-DIGIT UPDATED DATE
C
C REMARKS:
C    THIS ROUTINE CALLS:        ERRWRT
C    THIS ROUTINE IS CALLED BY: None
C                               Normally called only by application
C                               programs (W3LIB routine W3MOVDAT is
C                               much better).
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C   MACHINE:  PORTABLE TO ALL PLATFORMS
C
C$$$
      SUBROUTINE ADDATE(IDATE,JH,JDATE)

      COMMON /QUIET / IPRT

      DIMENSION   MON(12)

      CHARACTER*128  ERRSTR

      DATA MON/31,28,31,30,31,30,31,31,30,31,30,31/

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

      IY = IDATE/1000000
      IM = MOD(IDATE/10000  ,100)
      ID = MOD(IDATE/100    ,100)
      IH = MOD(IDATE        ,100)
      IH = IH+JH

      IF(MOD(IY,4).EQ.0) MON(2) = 29
      IF(MOD(IY,100).EQ.0) MON(2) = 28
      IF(MOD(IY,400).EQ.0) MON(2) = 29

1     IF(IH.LT.0) THEN
         IH = IH+24
         ID = ID-1
         IF(ID.EQ.0) THEN
            IM = IM-1
            IF(IM.EQ.0) THEN
               IM = 12
               IY = IY-1
               IF(IY.LT.0) IY = 99
            ENDIF
            ID = MON(IM)
         ENDIF
         GOTO 1
      ELSEIF(IH.GE.24) THEN
         IH = IH-24
         ID = ID+1
         IF(ID.GT.MON(IM)) THEN
            ID = 1
            IM = IM+1
            IF(IM.GT.12) THEN
               IM = 1
               IY = IY+1
               IF(IY.EQ.100) IY = 00
            ENDIF
         ENDIF
         GOTO 1
      ENDIF

      JDATE = IY*1000000 + IM*10000 + ID*100 + IH

      RETURN
      END
c-------------------------------------------------------------------------------------
c  compute the analysis increment to adjust time interpolated guess to analysed values
c-------------------------------------------------------------------------------------
      subroutine comp_amf
      USE GBLEVN_MODULE
      USE READSF_MODULE

!  compute the analysis increments

      iarzs(:,:,4)   = iarzs(:,:,4)-iarzs(:,:,2)
      iarps(:,:,4)   = iarps(:,:,4)-iarps(:,:,2)
      iarqq(:,:,:,4) = iarqq(:,:,:,4)-iarqq(:,:,:,2)
      iartt(:,:,:,4) = iartt(:,:,:,4)-iartt(:,:,:,2)
      iaruu(:,:,:,4) = iaruu(:,:,:,4)-iaruu(:,:,:,2)
      iarvv(:,:,:,4) = iarvv(:,:,:,4)-iarvv(:,:,:,2)
      iarpl(:,:,:,4) = iarpl(:,:,:,4)-iarpl(:,:,:,2)
      iarzl(:,:,:,4) = iarzl(:,:,:,4)-iarzl(:,:,:,2)
      f10(:,:,4) = f10(:,:,4)-f10(:,:,2)

!  increment the background fields to the analysis 

      do i=1,3
      iarzs(:,:,i)   = iarzs(:,:,i)+iarzs(:,:,4)
      iarps(:,:,i)   = iarps(:,:,i)+iarps(:,:,4)
      iarqq(:,:,:,i) = iarqq(:,:,:,i)+iarqq(:,:,:,4)
      iartt(:,:,:,i) = iartt(:,:,:,i)+iartt(:,:,:,4)
      iaruu(:,:,:,i) = iaruu(:,:,:,i)+iaruu(:,:,:,4)
      iarvv(:,:,:,i) = iarvv(:,:,:,i)+iarvv(:,:,:,4)
      iarpl(:,:,:,i) = iarpl(:,:,:,i)+iarpl(:,:,:,4)
      iarzl(:,:,:,i) = iarzl(:,:,:,i)+iarzl(:,:,:,4)
      f10(:,:,i) = f10(:,:,i)+f10(:,:,4)
      enddo

      return
      end
c-----------------------------------------------------------------------------------
c-----------------------------------------------------------------------------------
      subroutine prttime(title)
      character(*) title
      data t0/0.00/
      data t1/0.00/
      data t2/0.00/
      save t0,t1,t2
      if(t0==0.00)then
         call system_clock(ic,ir,im); t0=float(ic)/float(ir)
         call system_clock(ic,ir,im); t1=float(ic)/float(ir)
      endif
      call system_clock(ic,ir,im); t2=float(ic)/float(ir)
      print1,title,t2-t1,t2-t0        
      call system_clock(ic,ir,im); t1=float(ic)/float(ir)
1     format('time>>>',a8,3(2x,f8.2))
      return
      end

!-----------------------------------------------------------------------------
!-----------------------------------------------------------------------------
!  the subroutine is to call the read_convdiag for both guess and analysis
!  conventional diagnostic files   
!
!  PRGMMR:   X. Su       ORG: NP20                 Date: 2007-11-15
!
! dwork_anl   : array for surface pressure data from the analysis
! dwork_ges

   program convdiag
   parameter(maxn=3500000,mxtb=1500000,maxsub=49)

   character(8),dimension(maxn) :: awork,cwork
   real(4),dimension(maxn,0:20) :: bwork,dwork

   character(8),dimension(3,mxtb) :: swork
   character(8),dimension(maxsub) :: subsets 
   real(8),dimension(3,mxtb) :: rwork
   equivalence (rwork,swork)

   character(len=50) :: hdstr,obstr,qmstr,pcstr,rcstr,fcstr,errstr,anstr,vqcstr
   character(len=50) :: file_anl,file_ges,xystr
   data file_anl /'diag_conv_anl'/
   data file_ges /'diag_conv_ges'/

   character(8) subset,sid
   integer iwork(max(maxn,mxtb)),iord(mxtb),jord(maxn),kord(maxn)
   integer jnt(300,0:10),knt(300,0:10),nnt(300,0:10),mmt(300,0:10)
   integer nrep(300),nrex(300,2)
   logical match,pilot,duplev(0:10,255),gbak,gana,vbak,vana,oiqc,pobx,zobx
   real(8) obs(10,255),obs_out(10,255),pob_out(10,255),zob_out(10,255)
   real(8) qms(10,255),qms_out(10,255)
   real(8) pcs(10,255),pcs_out(10,255)
   real(8) rcs(10,255),rcs_out(10,255)
   real(8) fcs(10,255),fcs_out(10,255)
   real(8) ans(10,255),ans_out(10,255)
   real(8) hdr(10),rid,bmiss /10e10/
   real(8) err_out(10,255)
   real(8) vqc_out(10,255)
   real(8) xyt(10,255)     

   data gsicode/16/
   data lunin  /20/
   data lunot  /50/
   data nsub   /00/

!-----------------------------------------------------------------------------
!-----------------------------------------------------------------------------

   jnt=0; knt=0; nnt=0; mmt=0; nrep=0; nrex=0; iwrk=1; nmatch=0
   
   bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

!  read the 1stguess conv_diag events file and sort into shape

   call read_convdiag(file_ges,awork,bwork,mwrk,mmt)
   call read_convdiag(file_anl,cwork,dwork,nwrk,nnt)
   if(mwrk.ne.nwrk) then
      print*,'mwrk,nwrk=',mwrk,nwrk
      call bort('ges and anl diag files not the same size')
   endif; print*,'after READ_CONVDIAG size=',nwrk

!  sort the diag files enough ways to make them line up correctly 

   if(0==0) then
      call orders(0,iwork,awork,kord,nwrk,1,8,2)
      call orders(0,iwork,cwork,jord,nwrk,1,8,2)
      do i=0,8; if(i==5)cycle
      call orders(12,iwork,bwork(1,i),kord,nwrk,1,4,2)
      call orders(12,iwork,dwork(1,i),jord,nwrk,1,4,2)
      enddo
      call orders(10,iwork,awork,kord,nwrk,1,8,2)
      call orders(10,iwork,cwork,jord,nwrk,1,8,2)
   else
      do n=1,nwrk  
      jord(n)=n
      kord(n)=n
      enddo
   endif

!  check to be sure both diag files are the same shape

   do m=0,8 
   if(m==5)cycle
   do n=1,nwrk
   jj=jord(n); kk=kord(n)
   if(bwork(kk,m).ne.dwork(jj,m)) then
      print*,n,m,bwork(kk,m),dwork(jj,m)
      call bort('ges and anl diag files not the same shape')
   endif
   enddo 
   enddo

!  open(6,recl=150)
!  do n=1,100
!  write(6,'(a8,13f10.2)') awork(n),bwork(n,0:12)
!  write(6,'(a8,13f10.2)') cwork(n),dwork(n,0:12)
!  print*
!  enddo
!  call bort('test')

!  read in the prepbufr station ids

   CALL UFBMEM(LUNIN,0,IMSG,MUNIT)
   CALL UFBTAM(RWORK,3,MXTB,NPRP,'SID IREC ISUB')
   CALL ORDERS(0,IWORK,SWORK,IORD,NPRP,3,8,2)
   print*,'after UFBMEM nprp=',nprp

!  define mnemonic strings to screen the prepbufr data elements

    hdstr = 'SID XOB YOB ELV DHR TYP                        '
    obstr = 'POB QOB TOB ZOB UOB VOB CAT                    '
    qmstr = 'PQM QQM TQM ZQM WQM                            '
    pcstr = 'PPC QPC TPC ZPC WPC                            '
    rcstr = 'PRC QRC TRC ZRC WRC                            '
    fcstr = 'PFC QFC TFC ZFC UFC VFC                        '
    anstr = 'PAN QAN TAN ZAN UAN VAN                        '
    errstr= 'POETU QOETU TOETU WOETU ESBAK RF10M            '
    vqcstr= 'PVWTG QVWTG TVWTG WVWTG PVWTA QVWTA TVWTA WVWTA'
    xystr = 'XDR YDR HRDR                                   '

!  read the prepbufr file in order of station id              

    loopp: DO IPRP=1,NPRP 
    np=iord(iprp);irec=rwork(2,np);isub=rwork(3,np)
    call ufbmms(irec,isub,subset,idate)
    sid=swork(1,np); !print*,sid

    obs_out=bmiss; qms_out=bmiss; err_out=bmiss; vqc_out=bmiss
    pcs_out=bmiss; rcs_out=bmiss
    pob_out=bmiss; zob_out=bmiss
    ans_out=bmiss; fcs_out=bmiss; duplev=.false.

    call ufbint(lunin,hdr,10,1,iret,hdstr)   ! read header from one observation
    call ufbint(lunin,obs,10,255,nlev,obstr) ! read the observation elements
    call ufbint(lunin,qms,10,255,iret,qmstr) ! read the current quality marks
    call ufbint(lunin,xyt,10,255,iret,xystr) ! read balloon drift coordinates

    xob=hdr(2);yob=hdr(3);elv=hdr(4);dhr=hdr(5);typ=hdr(6);ntyp=nint(typ)
    pilot=ntyp.eq.221.or.ntyp.eq.223.or.ntyp.eq.224.or.ntyp.eq.228.or.ntyp.eq.229 

! for each prepbufr report find the matching diagnose records

10  loopd: do n=iwrk,nwrk; nd=jord(n); nb=kord(n)
    !print*,n,iwrk,nwrk,nd,cwork(nd),' ',sid
    if(sid.lt.cwork(nd)) exit loopd  !no (more) diags for this report  
    if(sid.gt.cwork(nd)) iwrk=iwrk+1   
    if(sid.gt.cwork(nd)) goto 10         

    xdw = dwork(nd,3); ydw = dwork(nd,2); edw = dwork(nd,4)          
    ddw = dwork(nd,7); tdw = dwork(nd,1)
    !print*,xdw,ydw,edw,ddw,tdw
    if(tdw<0)cycle

    if(typ==290) elv=0.0 ! windsat elevation in diag file

    match = typ.eq.tdw .and. abs(elv-edw)<=1
    if(ntyp.eq.285) match = typ.eq.tdw
    IF(SUBSET.NE.'ADPUPA') then
       match = match .and. abs(xob-xdw).le..001
       match = match .and. abs(yob-ydw).le..001
       match = match .and. abs(dhr-ddw).le..001
    endif

! GSV0GBRA     3.00   133.00    50.78     4.00 11297.00   215.90 11297.00     1.94  
! T0QVVSRA     4.00   233.00    52.97     0.49 11874.00   196.80 11884.00     2.65     1.00a
! 0S26229Q     4.00   285.00    62.36    19.68     0.00  1006.66    10.00     2.72     2.00a

!   if(typ==233 .and. abs(xob-xdw).le..001 .and. abs(yob-ydw).le..001 &
!   .and. typ==tdw .and. edw==11874 .and. .not.match .and. sid=='T0QVVSRA') &
!   print*,'debug',sid,xob,yob,elv,edw,dhr,typ,match

    if(typ>=240.and.typ<=260) cycle ! skip satwinds

    if(typ==999 .and. abs(xob-xdw).le..001 .and. abs(yob-ydw).le..001 &
    .and. typ==tdw                      ) &
    print'(a8,6(f8.2,2x),l1)',sid,xob,yob,elv,edw,dhr,ddw,match

! try and match this diagnose record to a prepbufr level

    if(match) then

       nmatch=nmatch+1

       loopl: do l=1,nlev
       ityp = nint(dwork(nd,0))        ! diagnose record type
       pod=dwork(nd,5); pob=obs(1,l)   ! diagnose and prepbufr record
       zod=dwork(nd,6); zob=obs(4,l)   ! diagnose and prepbufr height
       cid=dwork(nd,09)                ! convinfo useage (0=use 100=nouse)
       gcb=bwork(nb,10)                ! gsi usage (-1=nouse 1=use) from ges
       gca=dwork(nd,10)                ! gsi usage (-1=nouse 1=use) from analysis 
       vcb=bwork(nb,11)                ! qc weight from background
       vca=dwork(nd,11)                ! qc weight from analysis
       
! see if the levels match

       if(duplev(ityp,l))cycle ! don't apply duplicate events in the same place

       if(pilot.and.zob.lt.bmiss) then ! check which vertical coordinate applies
          if(zob.eq.elv) zob=zob+10
          if(zob.ne.zod) cycle
       else
          if(pob.ne.pod.and.ntyp.lt.280) cycle
       endif

       if(xyt(1,l)<bmiss .and. xyt(2,l)<bmiss) then
          if(mod(ntyp,100) /= 32) then
             xdr=xyt(1,l); if(abs(xdr-xdw)>.001) cycle
             ydr=xyt(2,l); if(abs(ydr-ydw)>.001) cycle
          endif
       endif

       dwork(nd,1)=-dwork(nd,1) ! set the oi type not to match any other report
       duplev(ityp,l)=.true.    ! duplev marks which events apply to which levels
       duplev(0000,l)=.true.    ! duplev marks which events apply to which levels

! for matching levels apply the qc results where they are relevant

       if(ityp.eq.1) qmin=qms(1,l) ! ps record
       if(ityp.eq.2) qmin=qms(2,l) ! q  record
       if(ityp.eq.3) qmin=qms(3,l) ! t  record
       if(ityp.eq.4) qmin=qms(5,l) ! w  record
       if(ityp.eq.5) qmin=qms(5,l) ! ws record

       gbak=gcb==1.0;gana=gca==1.0;vbak=vcb>=.25;vana=vca>=.25      

       rcout=0; oiqc=qmin>=4.and.qmin<=7

       if(cid==0)then; 
       if(.not.gbak .and. .not.gana) then; qmout=10; rcout=1; else&
       if(.not.gbak .and.      gana) then; qmout=1 ; rcout=2; else&
       if(     gbak .and. .not.gana) then; qmout=10; rcout=3; endif
       if(gana)then
       if(.not.vbak .and. .not.vana) then; qmout=11; rcout=4; else&
       if(.not.vbak .and.      vana) then; qmout=1 ; rcout=5; else&
       if(     vbak .and. .not.vana) then; qmout=11; rcout=6; endif;endif
       if(rcout==0.and.oiqc) then; qmout=qmin-4; rcout=1; endif
       elseif(qmin.le.3    ) then; qmout=9     ; rcout=1; endif

       if(qmout==11) qmout=1 ! keep data rejected by vqc but passed gross check

! compose any diagnose events for the prepbufr file

       if(ityp.eq.1) then !  ps 
          if(rcout.gt.0.) then
             obs_out(1,l) = obs(1,l) 
             qms_out(1,l) = qmout 
             pcs_out(1,l) = gsicode
             rcs_out(1,l) = rcout 
          endif
          fcs_out(1,l) = bwork(nb,16)     
          ans_out(1,l) = dwork(nd,16)     
          err_out(1,l) = bwork(nb,12)
          vqc_out(1,l) = bwork(nb,11)*100.0
          vqc_out(5,l) = dwork(nd,11)*100.0
       elseif(ityp.eq.2) then !  q  
          if(rcout.gt.0.) then
             obs_out(2,l) = obs(2,l)
             qms_out(2,l) = qmout 
             pcs_out(2,l) = gsicode 
             rcs_out(2,l) = rcout
          endif
          fcs_out(2,l) = max(bwork(nb,16)*1.e6,0.)
          ans_out(2,l) = max(dwork(nd,16)*1.e6,0.)
          err_out(2,l) = (bwork(nb,12)/bwork(nb,17))*10.0
          err_out(5,l) = bwork(nb,17)*1000000.0
          vqc_out(2,l) = bwork(nb,11)*100.0
          vqc_out(6,l) = dwork(nd,11)*100.0
       elseif(ityp.eq.3) then !  t 
          if(rcout.gt.0.) then
             obs_out(3,l) = obs(3,l)
             qms_out(3,l) = qmout 
             pcs_out(3,l) = gsicode
             rcs_out(3,l) = rcout 
          endif
          fcs_out(3,l) = bwork(nb,16)-273.15
          ans_out(3,l) = dwork(nd,16)-273.15
          err_out(3,l) = bwork(nb,12)
          vqc_out(3,l) = bwork(nb,11)*100.0
          vqc_out(7,l) = dwork(nd,11)*100.0
       elseif(ityp.eq.4) then !  uv
          if(rcout.gt.0.) then
             obs_out(5,l) = obs(5,l)
             obs_out(6,l) = obs(6,l)
             qms_out(5,l) = qmout
             pcs_out(5,l) = gsicode
             rcs_out(5,l) = rcout 
          endif
          fcs_out(5,l) = bwork(nb,16)
          fcs_out(6,l) = bwork(nb,18)
          ans_out(5,l) = dwork(nd,16)
          ans_out(6,l) = dwork(nd,18)
          err_out(4,l) = bwork(nb,12)
          err_out(6,l) = bwork(nb,19)
          vqc_out(4,l) = bwork(nb,11)*100.0
          vqc_out(8,l) = dwork(nd,11)*100.0
       elseif(ityp.eq.5) then !  spd
          if(rcout.gt.0.) then
             obs_out(5,l) = 0        
             obs_out(6,l) = bwork(nb,15)
             qms_out(5,l) = qmout 
             pcs_out(5,l) = gsicode
             rcs_out(5,l) = rcout 
          endif
          fcs_out(5,l) = 0        
          fcs_out(6,l) = bwork(nb,16)
          ans_out(5,l) = 0        
          ans_out(6,l) = dwork(nd,16)
          err_out(4,l) = bwork(nb,12)
          err_out(6,l) = bwork(nb,19)
          vqc_out(4,l) = bwork(nb,11)*100.0
          vqc_out(8,l) = dwork(nd,11)*100.0
       else
          print*,'unknown ityp in loopl=',ityp
          call bort('unknown ityp in loopl')
       endif

! check to see if a pressure or height coordinate was modified 

       pobx=pod /= pob.and.max(pod,pob)<bmiss.and.pob_out(1,l)>=bmiss
       zobx=zod /= zob.and.max(zod,zob)<bmiss.and.zob_out(1,l)>=bmiss

       if(pobx.or.zobx)then
       !if(ntyp==250)print'(a8,5(1x,f8.1))',sid,typ,pod,pob,zod,zob
       endif

       if(pobx)nrex(ntyp,1)=nrex(ntyp,1)+1
       if(zobx)nrex(ntyp,2)=nrex(ntyp,2)+1

       if(pobx) pob_out(1,l)=pod
       if(zobx) zob_out(1,l)=zod

! account for this event and end the event and level loops

       knt(ntyp,0000)=knt(ntyp,0000)+1
       knt(ntyp,ityp)=knt(ntyp,ityp)+1
       cycle loopd  
       enddo loopl
       jnt(ntyp,0000)=jnt(ntyp,0000)+1
       jnt(ntyp,ityp)=jnt(ntyp,ityp)+1
    endif
    enddo loopd

! see if any level not found in the convdiag file

      do l=1,nlev
      if(.not.duplev(0,l)) then
         !print*,'---',sid,' ',xob,yob,dhr,typ
         obs_out(1,l)=obs(1,l)
         qms_out(1,l)=9.        
      endif
      enddo

! figure out where to write this report          

      isubset = 0
      do i=1,nsub
      if(subset.eq.subsets(i)) isubset = i
      enddo
      if(isubset.eq.0) then
         if(nsub+1.gt.maxsub) call bort('nsub too big')
         subsets(nsub+1) = subset
         nsub = nsub+1
         isubset = nsub
         open(50+isubset,file='preppost_'//subset,form='unformatted')
         call openbf(50+isubset,'OUT',lunin)
         if(nsub==1) call maxout(20000)
      endif
      lunot=50+isubset

      pobx=.false.
      zobx=.false.

! write out the observation with postevents added

    call openmb(lunot,subset,idate); call ufbcpy(lunin,lunot)
    if(subset /= 'GOESND'.and.subset /= 'GPSIPW') then
       call ufbint(lunot,obs_out,10,nlev,iret,obstr) 
       call ufbint(lunot,qms_out,10,nlev,iret,qmstr)
       call ufbint(lunot,pcs_out,10,nlev,iret,pcstr)
       call ufbint(lunot,rcs_out,10,nlev,iret,rcstr)
       call ufbint(lunot,fcs_out,10,nlev,iret,fcstr)
       call ufbint(lunot,ans_out,10,nlev,iret,anstr)
       call ufbint(lunot,err_out,10,nlev,iret,errstr)
       call ufbint(lunot,vqc_out,10,nlev,iret,vqcstr)
       do l=1,nlev ! this section updates the modified pob or zob values
       if(pob_out(1,l)<bmiss)then
          pob_out(2,l)=qms(1,l)
          pob_out(3,l)=gsicode 
          pob_out(4,l)=000
          pobx=.true.
       endif
       if(zob_out(1,l)<bmiss)then
          zob_out(2,l)=qms(4,l)
          zob_out(3,l)=gsicode 
          zob_out(4,l)=000
          zobx=.true.
       endif
       enddo
       if(pobx)call ufbint(lunot,pob_out,10,nlev,iret,'POB PQM PPC PRC')
       if(zobx)call ufbint(lunot,zob_out,10,nlev,iret,'ZOB ZQM ZPC ZRC')
    endif
    call writsb(lunot)
    nrep(ntyp)=nrep(ntyp)+1

    enddo loopp ! end of prepbufr match and write loop

! be sure to close all bufr output files to get all the data out

    do i=1,nsub
    call closbf(50+i) 
    enddo

! print an accounting of the posting

    nnt=knt-nnt
    print*
    print*,'data counts by report type'
    do i=1,300
    if(nrep(i).gt.0) print'(i3,8(2x,i8))',i,jnt(i,0),knt(i,0),(nnt(i,j),j=0,5)
    enddo

    print*
    print*,'nmatch=',nmatch
    print*

    stop

! print any diagnose records which were not matched to prepbufr data

    iprt=0
    do i=1,nwrk
    ityp = nint(dwork(i,1))
    if(ityp.gt.0) then
       print'(a8,9(1x,f8.2),a)',cwork(i),(dwork(i,j),j=0,8),'a'
       iprt=iprt+1; if(iprt.gt.100)stop
    endif
    enddo

! diagnostic for modifed p or z

    iptot=0;iztot=0

    do i=1,300
    if(nrex(i,1)+nrex(i,2)>0)print'(3i10)',i,nrex(i,1),nrex(i,2)
    iptot=iptot+nrex(i,1); iztot=iztot+nrex(i,2)
    enddo
    print'(a10,2i10)','TOT',iptot,iztot

    stop
    end

C***********************************************************************
C***********************************************************************
C  GBLEVN03 - INTERPOLATE MODEL DATA (FIRST GUESS OR ANALYSIS) TO OB
C             LOCATIONS
C-----------------------------------------------------------------------
      SUBROUTINE GBLEVN35(SUBSET) ! FORMERLY SUBROUTINE GETFC

      USE GBLEVN_MODULE
      USE READSF_MODULE

      COMMON /GBEVAA/ SID,OBS(15,255),QMS(12,255),BAK(12,255),XOB,
     $ YOB,DHR,TYP,NLEV
      COMMON /GBEVEE/PSG01,ZSG01,THE_REST(500,9)


      CHARACTER*8  SUBSET,CID
      real(4)      plev(kmax),zlev(kmax),prof(kmax)
      REAL(8)      SID,OBS,QMS,BAK
      equivalence  (sid,cid)
      logical      newxyt,windp,windz,geomz

      DATA TZERO / 273.15 /
      DATA BETAP / .0552  /
      DATA BETA  / .00650 /
      DATA ROG   / 29.261 /

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------


C  SETUP FOR INTERPOLATING TO THIS OBSERVATION
C  -------------------------------------------

      CALL HTERPS(xob,yob,dhr,iarps,psi);psg01=psi

      ! bmiss is defined in gblevn00

      BAK = BMISS
      OBX = BMISS; OBL = .false.
      S10 = 1. ! default value
      xdx=bmiss; ydx=bmiss; tdx=bmiss

C  INTERPOLATE GUESS PROFILES TO OB PRESSURES
C  ------------------------------------------

      IF(NLEV.GT.0)  THEN

      DO 10 L=1,NLEV

         POB  = OBS( 1,L)
         QOB  = OBS( 2,L) 
         TOB  = OBS( 3,L) 
         ZOB  = OBS( 4,L)
         UOB  = OBS( 5,L)
         VOB  = OBS( 6,L)
         PWO  = OBS( 7,L)
         PW1O = OBS( 8,L)
         PW2O = OBS( 9,L)
         PW3O = OBS(10,L)
         PW4O = OBS(11,L)
         CAT  = OBS(12,L)
         TVO  = OBS(14,L)

         pfc=bmiss;qfc=bmiss;tfc=bmiss;zfc=bmiss;ufc=bmiss;vfc=bmiss

c  x,y,t may be stored as profile values, or not

         IF(POB.LE.0. .OR. POB.GE.BMISS) GOTO 10
         xdr=xyt(1,l); ydr=xyt(2,l); tdr=xyt(3,l)
         if(max(xdr,ydr,tdr)>=bmiss) then
            xdr=xob;ydr=yob;tdr=dhr
         endif

         newxyt=xdr/=xdx.or.ydr/=ydx.or.tdr/=tdx
         xdx=xdr; ydx=ydr; tdx=tdr

c  given x,y,t generate some interpolated coordinates needed for the process

         if(newxyt) then
            CALL HTERPT(xdr,ydr,tdr,iarpl,kmax,plev) ! interpolated mid layer pressures
            CALL HTERPS(xdr,ydr,tdr,iarps,ps)        ! interpolated surface pressure
            CALL HTERPS(xdr,ydr,tdr,iarzs,zs)        ! interpolated surface height
            CALL HTERPT(xdr,ydr,tdr,iartt,1,t1)      ! interpolated sigma 1 temperature

            P1 = PLEV(1)
            TM = T1+(PS-P1)*BETAP*.5          ! mid layer temp between sigma1 and surface
            Z1 = ZS-ROG*TM*LOG(P1/PS)         ! height of sigma 1 (lowest sigma level)
            TS = T1+(Z1-ZS)*BETA              ! surface temperature lapsed from sigma 1

            P10 = PS*EXP(-10./((TS-(5.*beta))*ROG))     ! 10 meter pressure
            if(rsfc) CALL HTERPSF(xdr,ydr,tdr,f10,s10)  ! 10 meter wind factor
         endif

C  SURFACE PRESSURE

         IF(CAT.EQ.0 .AND. ZOB.LT.BMISS) THEN 
            DZ = ZOB-ZS
            TO = TS-DZ*BETA
            IF(TOB<BMISS) THEN
               TM=.5*(TOB+TZERO+TS)
            ELSE
               TM=.5*(TO+TS)
               IF(DZ<0) TM=TM-.5*DZ*BETA
            ENDIF
            PFC = PS*EXP(-DZ/(TM*ROG))
         ENDIF

C  CALCULATE POB LOCATION IN SIGMA MID LAYER PRESSURE PROFILE

         pwt=pilnlnpw(pob,plev,kmax) ! pob location in profile

C  SPECIFIC HUMIDITY - (QFC NEEDED BY SYNDATA PROGRAM BUT ONLY FOR REPORT TYPE 111)

         IF(QOB.LT.BMISS.OR.TOB.LT.BMISS.OR.TYP.EQ.111) THEN
            CALL HTERPTZ(xdr,ydr,tdr,pwt,iarqq,qfc)
         ENDIF

C  TEMPERATURE - (TFC NEEDED BY CQCVAD AND SYNDATA PROGRAMS, LATTER ONLY FOR REPORT TYPE 111)

         IF(TOB.LT.BMISS.OR.SUBSET.EQ.'VADWND'.OR.TYP.EQ.111) THEN 
            CALL HTERPTZ(xdr,ydr,tdr,pwt,iartt,tfc); tfc=tfc-tzero
            if(pob>p1)tfc=tfc+(pob-p1)*betap ! lapse temp below sigma 1 if need be
            if(tob/=tvo.and.fits) then ! convert background tv >> ts for ts ob !
               call hterptz(xdr,ydr,tdr,pwt,iarqq,qft)
               p=pob; e=esph(p,qft*1.e-6); tfc=sent(p,e,tfc)
            endif
         ENDIF

C  U AND V COMPONENTS

         IF(max(uob,vob)<bmiss) then

         ! adjust some reported surface heights to the real world
         kx=typ; oelev=zob; selev=stnelev 
         if(kx >= 280.and.kx < 300 )then
            oelev=10+selev
            if (kx == 280) oelev=20+selev
            if (kx == 282) oelev=20+selev
            if (kx == 285 .or. kx == 289 .or. kx == 290) then
               oelev=selev
               selev=0.0  
            endif
         else if(kx >= 221.and.kx <= 229) then
            if(selev >= oelev) oelev=10+selev
         end if; zow=oelev

         ! decide whether to interpolate in height (geop or geom) or pressure
         windz = (typ>=221.and.typ<=229).or.(typ>=280.and.typ<300)
         geomz = (typ>=223.and.typ<=228).or.(typ>=280.and.typ<300)
         windz = windz .and. zow<bmiss
         windp = .not. windz; swt=1. 

         !if(cid=='94638')print*,cid,pob,zow,uob,vob

         IF(max(uob,vob)<bmiss .and. windp ) THEN ! interpolate in pressure
            CALL HTERPTZ(xdr,ydr,tdr,pwt,iaruu,ufc)
            CALL HTERPTZ(xdr,ydr,tdr,pwt,iarvv,vfc)
            if(pob>plev(1))then ! interpolate between sig01 and the surface if need be
               !print*,pob,ps,t1,p1,s10
               P10 = PS*EXP(-10./(T1*ROG))  ! 10 meter pressure
               po=min(pob,p10); swt=log(po/p1)/log(p10/p1)
               swt=1.+(s10-1.)*swt
            endif
         ELSEIF(max(uob,vob)<bmiss .and. windz ) THEN ! interpolate in height
            CALL HTERPT(xdr,ydr,tdr,iarzl,kmax,zlev)
            if(geomz)call geometric(xdr,ydr,kmax,zlev)

            ! Subtract off combination of surface station elevation and
            ! model elevation depending on how close to surface
            fact = 0.0   
            if(zow-selev > 10.)then
               if(zow-selev > 1000)then
                  fact = 1.0 
               else
                  fact=(zow-selev)*.001  
               end if
            end if
            zow=zow-(selev+fact*(zs-selev)) ! zow and zlev are now height above the surface

            zwt=zilnlnpw(zow,zlev,kmax)
            CALL HTERPTZ(xdr,ydr,tdr,zwt,iaruu,ufc)
            CALL HTERPTZ(xdr,ydr,tdr,zwt,iarvv,vfc)

            !!CALL HTERPZ(zow,zwt,zlev,ps,plev,pob) ! store any pressure adjustments
            !!obx(1,l)=pob;obx(2,l)=qms(1,l)        ! to write into the output file 
            !!obl=.true.

            if(zow<zlev(1)) then ! interpolate between sig01 and the surface if need be
               zow=max(zow,10.)              
               term = (zlev(1)-zow)/(zlev(1)-10.)        
               swt=1.+(s10-1.)*term 
            endif

         endif

         ufc=ufc*swt; vfc=vfc*swt ! apply sfc wind reduction factor

         endif

C  HEIGHT

         IF(ZOB.LT.BMISS) THEN
            IF(POB.GT.PLEV(1)) THEN
               TM  = T1 + (Z1-ZOB)*BETA*.5
               ZFC = Z1 - ROG*TM*LOG(POB/P1)
            ELSE
               CALL HTERPTZ(XDR,YDR,TDR,PWT,IARZL,ZFC)
               ZFC = ZFC+ZS ! add zs to height above surface
            ENDIF
         ENDIF

C  PRECIPITABLE WATER

         PWO  = BMISS
         PW1O = BMISS
         PW2O = BMISS
         PW3O = BMISS
         PW4O = BMISS

C  RELATIVE HUMIDITY

         RHO = BMISS

C  SCATTER THE PROPER FIRST GUESS/ANALYSIS VALUES
C  ----------------------------------------------

         BAK(1,L)  = PFC ! MB
         BAK(2,L)  = QFC ! G/MG    
         BAK(3,L)  = TFC ! C     
         BAK(4,L)  = ZFC ! M
         BAK(5,L)  = UFC ! M/S
         BAK(6,L)  = VFC ! M/S
         BAK(7,L)  = PWO
         BAK(8,L)  = PW1O
         BAK(9,L)  = PW2O
         BAK(10,L) = PW3O
         BAK(11,L) = PW4O
         BAK(12,L) = RHO

   10 ENDDO
      ENDIF

      !print*,'out of getfc'
      RETURN
      END
C-----------------------------------------------------------------------
!  GEOMETRIC - convert geopotential height profile to geometric height
!
!         Convert geopotential height at layer midpoints to geometric
!         height using equations (17, 20, 23) in MJ Mahoney's note
!         "A discussion of various measures of altitude" (2001).
!         Available on the web at
!         http://mtp.jpl.nasa.gov/notes/altitude/altitude.html
!
!         termg = equation 17
!         termr = equation 21
!         z(k)  = equation 23
!
! Parameters below from WGS-84 model software inside GPS receivers.
! real(r_kind),parameter::  semi_major_axis = 6378.1370e3_r_kind     (m)
! real(r_kind),parameter::  semi_minor_axis = 6356.7523142e3_r_kind  (m)
! real(r_kind),parameter::  grav_polar      = 9.8321849378_r_kind    (m/s2)
! real(r_kind),parameter::  grav_equator    = 9.7803253359_r_kind    (m/s2)
! real(r_kind),parameter::  earth_omega     = 7.292115e-5_r_kind     (rad/s)
! real(r_kind),parameter::  grav_constant   = 3.986004418e14_r_kind  (m3/s2)

! Derived geophysical constants:
! real(r_kind),parameter::  flattening = (semi_major_axis-semi_minor_axis)/semi_major_axis
! real(r_kind),parameter::  somigliana = (semi_minor_axis/semi_major_axis) * (grav_polar/grav_equator) - one
! real(r_kind),parameter::  grav_ratio = (earth_omega*earth_omega * semi_major_axis*semi_major_axis * semi_minor_axis) / grav_constant
!
C-----------------------------------------------------------------------
      subroutine geometric(x,y,nz,z)                          

      dimension z(nz)

      parameter (pi      = acos(-1.))
      parameter (grav    = 9.81)                                       
      parameter (deg2rad = pi/180.)
      parameter (smaxis  = 6378.1370e3)
      parameter (smixis  = 6356.7523142e3)
      parameter (grpol   = 9.8321849378)   
      parameter (grequ   = 9.7803253359)   
      parameter (eartho  = 7.292115e-5)    
      parameter (grcon   = 3.986004418e14) 
      parameter (flatn   = (smaxis-smixis)/smaxis)
      parameter (somig   = (smixis/smaxis)*(grpol/grequ)-1.)
!!!   parameter (somig   = (smaxis/smixis)*(grpol/grequ)-1.) !!! wrong
      parameter (grrat   = (eartho**2*smaxis**2*smixis)/grcon)
      parameter (eccen   = sqrt(smaxis**2-smixis**2)/smaxis)    

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

      sin2  = sin(y*deg2rad)**2
      termg = grequ  * (1.+somig*sin2)/sqrt(1.-eccen*eccen*sin2)
      termr = smaxis / (1.+ flatn+grrat-2.*flatn*sin2)
      do k=1,nz   
      z(k) = termr*z(k)/((termg*termr/grav)-z(k))  
      end do

      return
      end
c------------------------------------------------------------------
c------------------------------------------------------------------
      function pilnlnp(p,paray,qaray,kmax)

      dimension paray(kmax),qaray(kmax)

      do 10 la=1,kmax
      if(p.ge.paray(la)) goto 11
10    continue
11    if(la.gt.kmax) then
         la = kmax
         lb = kmax-1
      else if(la.eq.1) then
         la = 1
         lb = 1
      else
         lb = la-1
      endif
      pa = paray(la)
      pb = paray(lb)
      if(pa.ne.pb) then
         wk = log(p/pb) / log(pa/pb)
      else
         wk = 0.
      endif
      pilnlnp = qaray(lb) + (qaray(la)-qaray(lb)) * wk

      return
      end
c------------------------------------------------------------------
c------------------------------------------------------------------
      function zilnlnp(z,zaray,qaray,kmax)

      dimension zaray(kmax),qaray(kmax)

      do 10 la=1,kmax
      if(z<zaray(la)) goto 11
10    continue
11    if(la.gt.kmax) then
         la = kmax
         lb = kmax-1
      else if(la.eq.1) then
         la = 1
         lb = 1
      else
         lb = la-1
      endif
      za = zaray(la)
      zb = zaray(lb)
      if(za.ne.zb) then
         wk = (z-zb)/(za-zb)
      else
         wk = 0.
      endif
      zilnlnp = qaray(lb) + (qaray(la)-qaray(lb)) * wk

      return
      end

      program rhum_g2
c
c     ABSTRACT: This program calculates the relative humidity from an
c     input grib2 files(SPFH/T) and produces an output grib2 file 
c     containing the RH for different layers.
c
c     fort.11----input grib2 file (SPFH/T)
c     fort.31----input gribindex file
c     fort.16----cmc_tmp_levs.txt 
c     fort.51----output RH gri2b file
c     Written by J.Peng--04-10-2017
c

      USE params
      USE grib_mod

      implicit none

      type(gribfield) :: holdgfld
      integer, parameter :: lugb=11,lulv=16,lugi=31,lout=51,maxlev=200
      integer, parameter :: ix=1500,jy=751
      integer  kpds(200),kgds(200)
      integer  nlevsin,iriret,iogret,kf,iggret,igdret,iidret,ixo,k,n
      integer  iho,iva,irfa,iodret,ifcsthour,iia,nlevsout
      integer  ihq,iht,iparmq,iparmt
      integer  gribver,g2_jpdtn
cJ.Peng---------------------------------------------      
      integer  g2_model
      integer  ilevs(maxlev)
      real, allocatable :: xinpdatq(:,:),xoutdat(:,:),xoutlevs_p(:)
      real, allocatable :: xinpdatt(:,:)
      logical(1), allocatable :: valid_pt(:),readflag(:)
cJ.Peng---------------------------------------------
      namelist/timein/ifcsthour,iparmq,iparmt,gribver,g2_jpdtn,g2_model
c
      read (5,NML=timein,END=201)
  201 continue
      print *,' '
      print *,' +++          Top of RH                            +++'
      print *,'*----------------------------------------------------*'
      print *,'After namelist read, input forecast hour = ',ifcsthour
      print *,'            input grib parm = ',iparmq,iparmt
      print *,'                         GRIB version= ',gribver
      print *,'                         GRIB2 g2_jpdtn= ',g2_jpdtn
      print *,'                         g2_model= ',g2_model



      ilevs = -999
      call read_input_levels (lulv,maxlev,nlevsin,ilevs,iriret)

      if (iriret /= 0) then
        print *,' '
        print *,'!!! RETURN CODE FROM read_input_levels /= 0'
        print *,'!!! RETURN CODE = iriret = ',iriret
        print *,'!!! EXITING....'
        print *,' '
        goto 899
      endif

      nlevsout = nlevsin
      allocate (xoutlevs_p(nlevsout),stat=ixo)
      if (ixo /= 0) then
        print *,' '
        print *,'!!! ERROR in RH allocating the xoutlevs_p array.'
        print *,'!!! ixo= ',ixo
        print *,' '
        goto 899
      endif

      do k = 1,nlevsout
        xoutlevs_p(k) = ilevs(k)*1.0
      enddo  

      call open_grib_files (lugb,lugi,lout,gribver,iogret)

      if (iogret /= 0) then
        print '(/,a45,i4,/)','!!! ERROR: in RH open_grib_files, rc= '
     &        ,iogret
        STOP 93
      endif

      call getgridinfo (lugb,lugi,kf,kpds,kgds,holdgfld,ifcsthour,iparmq
     &                 ,gribver,g2_jpdtn,iggret)

      allocate (xinpdatq(kf,nlevsin),stat=ihq)
      allocate (xinpdatt(kf,nlevsin),stat=iht)

      allocate (xoutdat(kf,nlevsout),stat=iho)
      allocate (valid_pt(kf),stat=iva)
      allocate (readflag(nlevsin),stat=irfa)
      if (ihq /= 0 .or. iht /= 0 .or. iho /= 0 
     &   .or. iva /= 0 .or. irfa /= 0) then
        print *,' '
        print *,'!!! ERROR in RH.'
        print *,'!!! ERROR allocating the xinpdatq/t, readflag, or the'
        print *,'!!! valid_pt array, ihq= ',ihq,' iht= ',iht
        print *,'!!! irfa= ',irfa,' iho= ',iho, ' iva= ',iva
        print *,' '
        STOP 96
      endif

      print *,'hold check, holdgfld%ipdtlen = ',holdgfld%ipdtlen
      do n = 1,holdgfld%ipdtlen
        print *,'hold check, n= ',n,' holdgfld%ipdtmpl= '
     &         ,holdgfld%ipdtmpl(n)
      enddo
cJ.Peng-----------------------------------------------------
      call getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs,maxlev
     &           ,readflag,xinpdatq,ifcsthour,iparmq,gribver,g2_jpdtn
     &           ,g2_model,igdret)

      call getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs,maxlev
     &           ,readflag,xinpdatt,ifcsthour,iparmt,gribver,g2_jpdtn
     &           ,g2_model,igdret)

c      call interp_data (kf,valid_pt,nlevsin,ilevs,maxlev,readflag
c     &                 ,xinpdat,xoutdat,xoutlevs_p,nlevsout,iidret)

      call rh_data(kf,ix,jy,nlevsout,xoutlevs_p, 
     &                 xinpdatq,xinpdatt,xoutdat)  
cJ.Peng-----------------------------------------------------
      call output_data (lout,kf,kpds,kgds,holdgfld,xoutdat,valid_pt
     &                ,xoutlevs_p,nlevsout,gribver,g2_model,iodret)
c      call output_data1(lout,kf,holdgfld,xoutdat
c     &                 ,xoutlevs_p,nlevsout,g2_model,iodret) 

      deallocate (xinpdatq)
      deallocate (xinpdatt)
      deallocate (xoutdat)
      deallocate (valid_pt)
      deallocate (readflag)
      deallocate (xoutlevs_p)

  899 continue
c 
      stop
      end
c
c---------------------------------------------------------------------
c
      subroutine rh_data(kf,ix,jy,nlevsout,xoutlevs_p,
     &                    xinpdatq,xinpdatt,xoutdat)
c
c     ABSTRACT: This routine calculates relative humidity

      implicit none
      integer      kf,ix,jy,nlevsout,nn
      integer      i,j,k
      real         xoutlevs_p(nlevsout) 
      real         xinpdatq(kf,nlevsout),
     &             xinpdatt(kf,nlevsout),xoutdat(kf,nlevsout)
      real         p2d(ix,jy),t2d(ix,jy),q2d(ix,jy),rh2d(ix,jy)

      print *,'*----------------------------------------------*'
      print *,'  Top of relative humidity subroutine rh_data'
      print *,'*----------------------------------------------*'
      print *,' '

      do k=1,nlevsout
        nn=0
        do j=1,jy
        do i=1,ix
          nn=nn+1
          p2d(i,j)=xoutlevs_p(k)*100.0
          q2d(i,j)=xinpdatq(nn,k)
          t2d(i,j)=xinpdatt(nn,k)
        enddo
        enddo

        call calrh_gfs(ix,jy,p2d,t2d,q2d,rh2d)

        nn=0
        do j=1,jy
        do i=1,ix
          nn=nn+1
          xoutdat(nn,k)=rh2d(i,j)*100.0
        enddo
        enddo
      enddo

      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_input_levels (lulv,maxlev,nlevsin,ilevs,iriret)
c 
c     ABSTRACT: This subroutine reads in a text file that contains
c     the number of input pressure levels for a given model.  The
c     format of the file goes like this, from upper levels to 
c     lower, for example:
c
c        1       200
c        2       250
c        3       500
c        4       700
c        5       850
c        6       925
c        7      1000
c
c
      implicit none

      integer    lulv,nlevsin,maxlev,iriret,inplev,ict,lvix
      integer    ilevs(maxlev)
c
      iriret=0
      ict = 0
      do while (.true.)
        
        print *,'Top of while loop in RH read_input_levels'

        read (lulv,85,end=130) lvix,inplev

        if (inplev > 0 .and. inplev <= 1000) then
          ict = ict + 1
          ilevs(ict) = inplev
        else
          print *,' '
          print *,'!!! ERROR: Input level not between 0 and 1000'
          print *,'!!!        in RH.  inplev= ',inplev
          print *,'!!! STOPPING EXECUTION'
          STOP 91
        endif

        print *,'RH readloop, ict= ',ict,' inplev= ',inplev

      enddo

   85 format (i4,1x,i4)
  130 continue

      nlevsin = ict

      print *,' '
      print *,'Total number of RH levels read in = ',nlevsin
c 
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getgridinfo (lugb,lugi,kf,kpds,kgds,holdgfld,ifcsthour
     &                       ,iparm,gribver,g2_jpdtn,iggret)      
c
c     ABSTRACT: The purpose of this subroutine is just to get the max
c     values of i and j and the dx and dy grid spacing intervals for the
c     grid to be used in the rest of the program.  So just read the
c     grib file to get the lon and lat data.  Also, get the info for
c     the data grid's boundaries.  This boundary information will be
c     used later in the tracking algorithm, and is accessed via Module
c     grid_bounds.
c
C     INPUT:
C     lugb     The Fortran unit number for the GRIB data file
C     lugi     The Fortran unit number for the GRIB index file
c     ifcsthour input forecast hour to search for
c     iparm    input grib parm to search for
c     gribver  integer (1 or 2) to indicate if using GRIB1 / GRIB2
c     g2_jpdtn If GRIB2 data being read, this is the value for JPDTN
c              that is input to getgb2.
C
C     OUTPUT:
c     kf       Number of gridpoints on the grid
c     kpds     pds array for a GRIB1 record
c     kgds     gds array for a GRIB1 record
c     holdgfld info for a GRIB2 record
c
C     iggret   The return code from this subroutine
c
      USE params
      USE grib_mod

      implicit none
c
      type(gribfield) :: gfld,prevfld,holdgfld
      integer,dimension(200) :: jids,jpdt,jgdt
      logical(1), allocatable :: lb(:)
      integer, parameter :: jf=4000000
      integer   jpds(200),jgds(200)
      integer   kpds(200),kgds(200)
      integer :: listsec1(13)
      integer   ila,ifa,iret,ifcsthour,imax,jmax,jskp,jdisc
      integer   lugb,lugi,kf,j,k,iggret,iparm,gribver,g2_jpdtn
      integer   jpdtn,jgdtn,npoints,icount,ipack,krec
      integer :: listsec0(2)=(/0,2/)
      integer :: igds(5)=(/0,0,0,0,0/),previgds(5)
      integer :: idrstmpl(200)
      integer :: currlen=1000000
      logical :: unpack=.true.
      logical :: open_grb=.false.
      real, allocatable :: f(:)
      real      dx,dy
c
      iggret = 0

      allocate (lb(jf),stat=ila) 
      allocate (f(jf),stat=ifa)
      if (ila /= 0 .or. ifa /= 0) then
        print *,' '
        print *,'!!! ERROR in RH.'
        print *,'!!! ERROR in getgridinfo allocating either lb or f'
        print *,'!!! ila = ',ila,' ifa= ',ifa
        iggret = 97
        return
      endif

      if (gribver == 2) then

        ! Search for a record from a GRIB2 file

        !
        ! ---  Initialize Variables ---
        !

        gfld%idsect => NULL()
        gfld%local => NULL()
        gfld%list_opt => NULL()
        gfld%igdtmpl => NULL()
        gfld%ipdtmpl => NULL()
        gfld%coord_list => NULL()
        gfld%idrtmpl => NULL()
        gfld%bmap => NULL()
        gfld%fld => NULL()

        jdisc=0 ! meteorological products
        jids=-9999
        jpdtn=g2_jpdtn ! 0 = analysis or forecast; 1 = ens fcst
        jgdtn=0 ! lat/lon grid
        jgdt=-9999
        jpdt=-9999

        npoints=0
        icount=0
        jskp=0

c       Search for Temperature or GP Height by production template....

        JPDT(1:15)=(/-9999,-9999,-9999,-9999,-9999,-9999,-9999,-9999
     &             ,-9999,-9999,-9999,-9999,-9999,-9999,-9999/)

        if (iparm == 7) then  ! SPFH
          jpdt(1) = 1   ! Param category from Table 4.1
          jpdt(2) = 0   ! Param number from Table 4.2-0-3
        elseif (iparm == 11) then  ! Temperature
          jpdt(1) = 0   ! Param category from Table 4.1
          jpdt(2) = 0   ! Param category from Table 4.2
        endif

        jpdt(9) = ifcsthour

        call getgb2(lugb,lugi,jskp,jdisc,jids,jpdtn,jpdt,jgdtn,jgdt
     &             ,unpack,krec,gfld,iret)
        if ( iret.ne.0) then
          print *,' '
          print *,' ERROR: getgb2 error in getgridinfo = ',iret
        endif

c       Determine packing information from GRIB2 file
c       The default packing is 40  JPEG 2000

        ipack = 40

        print *,' gfld%idrtnum = ', gfld%idrtnum

        !   Set DRT info  ( packing info )
        if ( gfld%idrtnum.eq.0 ) then      ! Simple packing
          ipack = 0
        elseif ( gfld%idrtnum.eq.2 ) then  ! Complex packing
          ipack = 2
        elseif ( gfld%idrtnum.eq.3 ) then  ! Complex & spatial packing
          ipack = 31
        elseif ( gfld%idrtnum.eq.40.or.gfld%idrtnum.eq.15 ) then
          ! JPEG 2000 packing
          ipack = 40
        elseif ( gfld%idrtnum.eq.41 ) then  ! PNG packing
          ipack = 41
        endif

        print *,'After check of idrtnum, ipack= ',ipack

        print *,'Number of gridpts= gfld%ngrdpts= ',gfld%ngrdpts
        print *,'Number of elements= gfld%igdtlen= ',gfld%igdtlen
        print *,'PDT num= gfld%ipdtnum= ',gfld%ipdtnum
        print *,'GDT num= gfld%igdtnum= ',gfld%igdtnum

        imax = gfld%igdtmpl(8)
        print *,'at A'
        jmax = gfld%igdtmpl(9)
        print *,'at B'
        dx   = float(gfld%igdtmpl(17))/1.e6
        print *,'at C'
        dy   = float(gfld%igdtmpl(17))/1.e6
        print *,'at D'
        kf   = gfld%ngrdpts
        print *,'at E'

        holdgfld = gfld

      else

        ! Search for a record from a GRIB1 file

        jpds = -1
        jgds = -1

        j=0

        jpds(5)  = iparm ! Get a record for the input parm selected
        jpds(6)  = 100   ! Get a record on a standard pressure level
        jpds(14) = ifcsthour
         
        call getgb(lugb,lugi,jf,j,jpds,jgds,
     &                       kf,k,kpds,kgds,lb,f,iret)
      
        if (iret.ne.0) then
          print *,' '
          print *,'!!! ERROR in RH getgridinfo calling getgb'
          print *,'!!! Return code from getgb = iret = ',iret
          iggret = iret
          return
        else
          iggret=0
          imax = kgds(2)
          jmax = kgds(3)
          dx   = float(kgds(9))/1000.
          dy   = float(kgds(10))/1000.
        endif

      endif
      
      print *,' '
      print *,'In RH getgridinfo, grid dimensions follow:'
      print *,'imax= ',imax,' jmax= ',jmax
      print *,'  dx= ',dx,'  dy= ',dy
      print *,'number of gridpoints = ',kf
      
      deallocate (lb); deallocate(f)
      
      return
      end

c---------------------------------------------------------------------
c
cJ.Peng        ------------------------------------------------------
      subroutine getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs,maxlev
     &             ,readflag,xinpdat,ifcsthour,iparm,gribver,g2_jpdtn
     &             ,g2_model,igdret)
c
c     ABSTRACT: This subroutine reads the input GRIB file for the
c     tracked parameters.

      USE params
      USE grib_mod

      implicit none
c
      type(gribfield) :: gfld,prevfld
      CHARACTER(len=8) :: pabbrev
      integer,dimension(200) :: jids,jpdt,jgdt
      logical(1)  valid_pt(kf),lb(kf),readflag(nlevsin)
      integer, parameter :: jf=4000000
      integer   ilevs(maxlev)
      integer   jpds(200),jgds(200),kpds(200),kgds(200)
      integer   lugb,lugi,kf,nlevsin,maxlev,igdret,jskp,jdisc
      integer   i,j,k,ict,np,lev,ifcsthour,iret,iparm,gribver,g2_jpdtn
cJ.Peng -------------------------------------------------------------      
      integer   g2_model
      integer   jpdtn,jgdtn,npoints,icount,ipack,krec
      integer   pdt_4p0_vert_level,pdt_4p0_vtime,mm
      integer :: listsec0(2)=(/0,2/)
      integer :: listsec1(13)
      integer :: igds(5)=(/0,0,0,0,0/),previgds(5)
      integer :: idrstmpl(200)
      integer :: currlen=1000000
      logical :: unpack=.true.
      logical :: open_grb=.false.
      real      f(kf),xinpdat(kf,nlevsin),xtemp(kf)
      real      dmin,dmax,firstval,lastval
c
      igdret=0
      ict = 0

      level_loop: do lev = 1,nlevsin

        print *,' '
        print *,'In RH getdata read loop, lev= ',lev,' level= '
     &         ,ilevs(lev)

        if (gribver == 2) then

          !
          ! ---  Initialize Variables ---
          !

          gfld%idsect => NULL()
          gfld%local => NULL()
          gfld%list_opt => NULL()
          gfld%igdtmpl => NULL()
          gfld%ipdtmpl => NULL()
          gfld%coord_list => NULL()
          gfld%idrtmpl => NULL()
          gfld%bmap => NULL()
          gfld%fld => NULL()

          jdisc=0  ! meteorological products
          jids=-9999
          jpdtn=g2_jpdtn  ! 0 = analysis or forecast; 1 = ens fcst
          jgdtn=0  ! lat/lon grid
          jgdt=-9999
          jpdt=-9999

          npoints=0
          icount=0
          jskp=0

c         Search for input parameter by production template 4.0.  This
c         RH program is used primarily for temperature, but still we
c         will leave that as a variable and not-hard wire it in case we
c         choose to average something else in the future.

          ! We are looking for Temperature or GP Height here.  This 
          ! block of code, or even the smaller subset block of code that
          ! contains the JPDT(1) and JPDT(2) assignments, can of course 
          ! be modified if this program is to be used for interpolating
          ! other variables....

          ! Set defaults for JPDT, then override in array
          ! assignments below...

          JPDT(1:15)=(/-9999,-9999,-9999,-9999,-9999,-9999,-9999,-9999
     &               ,-9999,-9999,-9999,-9999,-9999,-9999,-9999/)

          print *,' '
          print *,'In getdata RH, iparm= ',iparm

          if (iparm == 7) then  ! SPFH
            jpdt(1) = 1   ! Param category from Table 4.1
            jpdt(2) = 0   ! Param number from Table 4.2-0-3
          elseif (iparm == 11) then  ! Temperature
            jpdt(1) = 0   ! Param category from Table 4.1
            jpdt(2) = 0   ! Param category from Table 4.2
          endif

          JPDT(9)  = ifcsthour

cJ.Peng--------------------------------------------------------
          print *, "g2_model=", g2_model
          if(g2_model == 1 .or. g2_model == 10 
     &      .or. g2_model == 7 .or. g2_model == 22) then 
            JPDT(10) = 100 ! Isobaric surface requested (Table 4.5)
            JPDT(11) =  0
            JPDT(12) = ilevs(lev) * 100 ! value of specific level
          elseif (g2_model == 16 .or. g2_model == 15) then
            JPDT(10) = 100
            if (ilevs(lev) == 200 .or. ilevs(lev) == 500
     &       .or. ilevs(lev) == 700) then       
              JPDT(11) =  -4
              JPDT(12) = ilevs(lev)/100
            elseif(ilevs(lev) == 250 .or. ilevs(lev) == 850) then
              JPDT(11) =  -3
              JPDT(12) = ilevs(lev)/10
            elseif(ilevs(lev) == 925) then  
              JPDT(11) =  -2
              JPDT(12) = ilevs(lev)
            elseif(ilevs(lev) == 1000) then
              JPDT(11) =  -5
              JPDT(12) = ilevs(lev)/1000
            endif  
          endif  

          print *,'before getgb2 call, value of unpack = ',unpack

          do mm = 1,15
            print *,'RH getdata mm= ',mm,' JPDT(mm)= ',JPDT(mm)
          enddo

          call getgb2(lugb,lugi,jskp,jdisc,jids,jpdtn,jpdt,jgdtn,jgdt
     &             ,unpack,krec,gfld,iret)

          print *,'iret from getgb2 in getdata = ',iret

          print *,'after getgb2 call, value of unpacked = '
     &           ,gfld%unpacked

          print *,'after getgb2 call, gfld%ndpts = ',gfld%ndpts
          print *,'after getgb2 call, gfld%ibmap = ',gfld%ibmap

          if ( iret == 0) then

c           Determine packing information from GRIB2 file
c           The default packing is 40  JPEG 2000

            ipack = 40

            print *,' gfld%idrtnum = ', gfld%idrtnum

            !   Set DRT info  ( packing info )
            if ( gfld%idrtnum.eq.0 ) then      ! Simple packing
              ipack = 0
            elseif ( gfld%idrtnum.eq.2 ) then  ! Complex packing
              ipack = 2
            elseif ( gfld%idrtnum.eq.3 ) then  ! Complex & spatial
     &                                         ! packing
              ipack = 31
            elseif ( gfld%idrtnum.eq.40.or.gfld%idrtnum.eq.15 ) then
              ! JPEG 2000 packing
              ipack = 40
            elseif ( gfld%idrtnum.eq.41 ) then  ! PNG packing
              ipack = 41
            endif

            print *,'After check of idrtnum, ipack= ',ipack

            print *,'Number of gridpts= gfld%ngrdpts= ',gfld%ngrdpts
            print *,'Number of elements= gfld%igdtlen= ',gfld%igdtlen
            print *,'GDT num= gfld%igdtnum= ',gfld%igdtnum

            kf = gfld%ndpts  ! Number of gridpoints returned from read

            do np = 1,kf
              xinpdat(np,lev)  = gfld%fld(np)
              xtemp(np)        = gfld%fld(np)
              if (gfld%ibmap == 0) then
                valid_pt(np)     = gfld%bmap(np)
              else
                valid_pt(np)     = .true.
              endif
            enddo

            readflag(lev) = .TRUE.
c            call bitmapchk(kf,gfld%bmap,gfld%fld,dmin,dmax)
            call bitmapchk(kf,valid_pt,xtemp,dmin,dmax)

            if (ict == 0) then
c              do np = 1,kf
c                valid_pt(np) = gfld%bmap(np)
c              enddo
              ict = ict + 1
            endif

            firstval=gfld%fld(1)
            lastval=gfld%fld(kf)

            print *,' '
            print *,' SECTION 0: discipl= ',gfld%discipline
     &             ,' gribver= ',gfld%version
            print *,' '
            print *,' SECTION 1: '

            do j = 1,gfld%idsectlen
              print *,'     sect1, j= ',j,' gfld%idsect(j)= '
     &               ,gfld%idsect(j)
            enddo

            if ( associated(gfld%local).AND.gfld%locallen.gt.0) then
              print *,' '
              print *,' SECTION 2: ',gfld%locallen,' bytes'
            else
              print *,' '
              print *,' SECTION 2 DOES NOT EXIST IN THIS RECORD'
            endif

            print *,' '
            print *,' SECTION 3: griddef= ',gfld%griddef
            print *,'            ngrdpts= ',gfld%ngrdpts
            print *,'            numoct_opt= ',gfld%numoct_opt
            print *,'            interp_opt= ',gfld%interp_opt
            print *,'            igdtnum= ',gfld%igdtnum
            print *,'            igdtlen= ',gfld%igdtlen

            print *,' '
            print '(a17,i3,a2)',' GRID TEMPLATE 3.',gfld%igdtnum,': '
            do j=1,gfld%igdtlen
              print *,'    j= ',j,' gfld%igdtmpl(j)= ',gfld%igdtmpl(j)
            enddo

            print *,' '
            print *,'     PDT num (gfld%ipdtnum) = ',gfld%ipdtnum
            print *,' '
            print '(a20,i3,a2)',' PRODUCT TEMPLATE 4.',gfld%ipdtnum,': '
            do j=1,gfld%ipdtlen
              print *,'    sect 4  j= ',j,' gfld%ipdtmpl(j)= '
     &               ,gfld%ipdtmpl(j)
            enddo

c           Print out values for data representation type

            print *,' '
            print '(a21,i3,a2)',' DATA REP TEMPLATE 5.',gfld%idrtnum
     &            ,': '
            do j=1,gfld%idrtlen
              print *,'    sect 5  j= ',j,' gfld%idrtmpl(j)= '
     &               ,gfld%idrtmpl(j)
            enddo

c           Get parameter abbrev for record that was retrieved

            pdt_4p0_vtime      = gfld%ipdtmpl(9)

cJ.Peng---------------------------------------------------            
            pdt_4p0_vert_level = gfld%ipdtmpl(12)

            pabbrev=param_get_abbrev(gfld%discipline,gfld%ipdtmpl(1)
     &                              ,gfld%ipdtmpl(2))

            print *,' '
            write (6,131)
 131        format (' rec#   param     level  byy  bmm  bdd  bhh  '
     &             ,'fhr      npts  firstval    lastval     minval   '
     &             ,'   maxval')
            print '(i5,3x,a8,2x,6i5,2x,i8,4g12.4)'
     &          ,krec,pabbrev,pdt_4p0_vert_level,gfld%idsect(6)
     &             ,gfld%idsect(7),gfld%idsect(8),gfld%idsect(9)
     &             ,pdt_4p0_vtime,gfld%ndpts,firstval,lastval,dmin,dmax
c&          ,krec,pabbrev,pdt_4p0_vert_level/100,gfld%idsect(6)

            do np = 1,kf
              xinpdat(np,lev) = gfld%fld(np)
            enddo

          else

            print *,' '
            print *,'!!! ERROR: GRIB2 VINT READ IN GETDATA FAILED FOR '
     &             ,'LEVEL LEV= ',LEV
            print *,' '

            readflag(lev) = .FALSE.

            do np = 1,kf
              xinpdat(np,lev) = -99999.0
            enddo

          endif

        else

        ! Reading a GRIB1 file....

          jpds = -1
          jgds = -1
          j=0

          jpds(5) = iparm       ! grib parameter id to read in
          jpds(6) = 100         ! level id to indicate a pressure level
          jpds(7) = ilevs(lev)  ! actual level of the layer
          jpds(14) = ifcsthour  ! lead time to search for

          call getgb (lugb,lugi,jf,j,jpds,jgds,
     &                          kf,k,kpds,kgds,lb,f,iret)

          print *,' '
          print *,'After RH getgb call, j= ',j,' k= ',k,' level= '
     &           ,ilevs(lev),' iret= ',iret

          if (iret == 0) then

            readflag(lev) = .TRUE.
            call bitmapchk(kf,lb,f,dmin,dmax)

            if (ict == 0) then
              do np = 1,kf
                valid_pt(np) = lb(np)
              enddo
              ict = ict + 1
            endif

            write (6,31)
  31        format (' rec#  parm# levt lev  byy   bmm  bdd  bhh  fhr   '
     &             ,'npts  minval       maxval')
            print '(i4,2x,8i5,i8,2g12.4)',
     &           k,(kpds(i),i=5,11),kpds(14),kf,dmin,dmax

            do np = 1,kf
              xinpdat(np,lev) = f(np) 
            enddo

          else

            print *,' '
            print *,'!!! ERROR: VINT READ FAILED FOR LEVEL LEV= ',LEV
            print *,' '
  
            readflag(lev) = .FALSE.

            do np = 1,kf
              xinpdat(np,lev) = -99999.0
            enddo

          endif

        endif

      enddo level_loop
c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine interp_data (kf,valid_pt,nlevsin,ilevs,maxlev,readflag
     &                 ,xinpdat,xoutdat,xoutlevs_p,nlevsout,iidret)
c
c     ABSTRACT: This routine interpolates data in between available
c     pressure levels to get data resolution at the 50-mb
c     resolution that we need for the cyclone phase space
c     diagnostics.

      implicit none

      logical(1)   valid_pt(kf),readflag(nlevsin)
      integer      ilevs(maxlev)
      integer      nlevsin,nlevsout,maxlev,kf,kout,kin,k,n,kup,klo
      integer      iidret
      real         xinpdat(kf,nlevsin),xoutdat(kf,nlevsout)
      real         xoutlevs_p(nlevsout),xoutlevs_lnp(nlevsout)
      real         xinlevs_p(nlevsin),xinlevs_lnp(nlevsin)
      real         pdiff,pdiffmin,xu,xo,xl,yu,yl
c
      iidret=0
      print *,' '
      print *,'*----------------------------------------------*'
      print *,' Listing of standard output levels follows....'
      print *,'*----------------------------------------------*'
      print *,' '

      do k = 1,nlevsout
        xoutlevs_lnp(k) = log(xoutlevs_p(k))
        write (6,81) k,xoutlevs_p(k),xoutlevs_lnp(k)
      enddo
   81 format (1x,'k= ',i3,'    p= ',f6.1,'   ln(p)= ',f9.6)

      do k = 1,nlevsin
        xinlevs_p(k) = float(ilevs(k))
        xinlevs_lnp(k) = log(xinlevs_p(k))
      enddo

c     -----------------------------------------------------------------
c     We want to loop through for all the *output* levels that we need.
c     We may have some input levels that match perfectly, often at 
c     least the standard levels like 500, 700, 850.  For these levels, 
c     just take the data directly from the input file.  For other 
c     output levels that fall between the input levels, we need to 
c     find the nearest upper and lower levels.

      output_loop: do kout = 1,nlevsout

        print *,' '
        print *,'+------------------------------------------------+'
        print *,'Top of RH output_loop, kout= ',kout,'  pressure= '
     &         ,xoutlevs_p(kout)
        
        ! Loop through all of the input levels and find the level 
        ! that is closest to the  output level from the *upper* side.
        ! And again, in this upper loop, if we hit a level that 
        ! exactly matches a needed output level, just copy that data
        ! and then cycle back to the top of output_loop.

        kup = -999
        klo = -999

        pdiffmin = 9999.0

        inp_loop_up: do kin = 1,nlevsin
          if (xinlevs_p(kin) == xoutlevs_p(kout)) then
            print *,' '
            print *,'+++ Exact level found.  kout= ',kout
            print *,'+++                    level= ',xoutlevs_p(kout)
            print *,'+++ Data copied.  No interpolation needed.'
            if (readflag(kin)) then
              do n = 1,kf
                xoutdat(n,kout) = xinpdat(n,kin)
              enddo
              cycle  output_loop
            else
              print *,' '
              print *,'!!! ERROR: readflag is FALSE in interp_data for'
              print *,'!!! level kin= ',kin,', which is a level that '
              print *,'!!! exactly matches a required output level, and'
              print *,'!!! the user has identified as being an input '
              print *,'!!! level with valid data for this model.  We '
              print *,'!!! will get the data from a different level.'
            endif
          else
            pdiff = xoutlevs_p(kout) - xinlevs_p(kin)
            if (pdiff > 0.) then  ! We have a level higher than outlev
              if (pdiff < pdiffmin) then
                pdiffmin = pdiff
                kup = kin
              endif
            endif
          endif
        enddo inp_loop_up

        pdiffmin = 9999.0

        inp_loop_lo: do kin = 1,nlevsin
          pdiff = xinlevs_p(kin) - xoutlevs_p(kout)
          if (pdiff > 0.) then  ! We have a level lower than outlev
            if (pdiff < pdiffmin) then
              pdiffmin = pdiff
              klo = kin
            endif
          endif 
        enddo inp_loop_lo

        if (kup == -999 .or. klo == -999) then
          print *,' '
          print *,'!!! ERROR: While interpolating, could not find '
          print *,'!!! either an upper or lower input level to use'
          print *,'!!! for interpolating *from*.'
          print *,'!!! kup= ',kup,' klo= ',klo
          print *,' '
          print *,'!!! STOPPING....'
          stop 91
        endif

        if (.not. readflag(kup) .or. .not. readflag(klo)) then
          print *,' '
          print *,'!!! ERROR: In interp_data, either the upper or the'
          print *,'!!! lower input level closest to the target output'
          print *,'!!! level did not have valid data read in.'
          print *,'!!! '
          write (6,91) '  upper level k= ',kup,xinlevs_p(kup)
     &                ,xinlevs_lnp(kup)
          write (6,101) xoutlevs_p(kout),xoutlevs_lnp(kout)
          write (6,91) '  lower level k= ',klo,xinlevs_p(klo)
     &                ,xinlevs_lnp(klo)
          print *,'!!! readflag upper = ',readflag(kup)
          print *,'!!! readflag lower = ',readflag(klo)
          print *,'!!! EXITING....'
          stop 92
        endif

        print *,' '
        write (6,91) '  upper level k= ',kup,xinlevs_p(kup)
     &              ,xinlevs_lnp(kup)
        write (6,101) xoutlevs_p(kout),xoutlevs_lnp(kout)
        write (6,91) '  lower level k= ',klo,xinlevs_p(klo)
     &              ,xinlevs_lnp(klo)

   91   format (1x,a17,1x,i3,'  pressure= ',f6.1,' ln(p)= ',f9.6)
  101   format (13x,'Target output pressure= ',f6.1,' ln(p)= ',f9.6)

        !--------------------------------------------------------------
        ! Now perform the linear interpolation.  Here is the notation 
        ! used in the interpolation:
        ! 
        !  xu = ln of pressure at upper level
        !  xo = ln of pressure at output level
        !  xl = ln of pressure at lower level
        !  yu = data value at upper level
        !  yl = data value at lower level
        !--------------------------------------------------------------

        xu = xinlevs_lnp(kup)
        xo = xoutlevs_lnp(kout)
        xl = xinlevs_lnp(klo)

        do n = 1,kf
          yu = xinpdat(n,kup)
          yl = xinpdat(n,klo)
          xoutdat(n,kout) = ((yl * (xo - xu)) - (yu * (xo - xl))) 
     &                    / (xl - xu)
        enddo

      enddo output_loop
c
      return
      end
c
c----------------------------------------------------------------------
c
cJ.Peng  -------------------------------------------------------------
      subroutine output_data (lout,kf,kpds,kgds,holdgfld,xoutdat
     &        ,valid_pt,xoutlevs_p,nlevsout,gribver,g2_model,iodret)
c
c     ABSTRACT: This routine writes out the  output data on the 
c     specified output pressure levels.

      USE params
      USE grib_mod

      implicit none

      CHARACTER(len=1),pointer,dimension(:) :: cgrib
      type(gribfield) :: holdgfld
      logical(1) valid_pt(kf),bmap(kf)
      integer  lout,kf,lugb,lugi,iodret,nlevsout,igoret,ipret,lev
      integer  gribver,ierr,ipack,lengrib,npoints,newlen,idrsnum
      integer  numcoord,ica,n,j
      integer :: idrstmpl(200)
      integer :: currlen=1000000
      integer :: listsec0(2)=(/0,2/)
      integer :: igds(5)=(/0,0,0,0,0/),previgds(5)
      integer  kpds(200),kgds(200)
cJ.Peng----------------------------      
      integer  g2_model, ijk
      integer(4), parameter::idefnum=1
      integer(4) ideflist(idefnum),ibmap
      real     coordlist
      real     xoutdat(kf,nlevsout),xoutlevs_p(nlevsout)
c
      iodret=0
c      call baopenw (lout,"fort.51",igoret)
c      print *,'baopenw: igoret= ',igoret
c
c      if (igoret /= 0) then
c        print *,' '
c        print *,'!!! ERROR in RH in sub output_data opening'
c        print *,'!!! **OUTPUT** grib file.  baopenw return codes:'
c        print *,'!!! grib file 1 return code = igoret = ',igoret
c        STOP 95
c        return
c      endif

      levloop: do lev = 1,nlevsout

        if (gribver == 2) then
  
          ! Write data out as a GRIB2 message....

          allocate(cgrib(currlen),stat=ica)
          if (ica /= 0) then
            print *,' '
            print *,'ERROR in output_data allocating cgrib'
            print *,'ica=  ',ica
            iodret=95
            return
          endif

          !  Ensure that cgrib array is large enough

          if (holdgfld%ifldnum == 1 ) then    ! start new GRIB2 message
             npoints=holdgfld%ngrdpts
          else
             npoints=npoints+holdgfld%ngrdpts
          endif
          newlen=npoints*4
          if ( newlen.gt.currlen ) then
ccc            if (allocated(cgrib)) deallocate(cgrib)
            if (associated(cgrib)) deallocate(cgrib)
            allocate(cgrib(newlen),stat=ierr)
c            call realloc (cgrib,currlen,newlen,ierr)
            if (ierr == 0) then
              print *,' '
              print *,'re-allocate for large grib msg: '
              print *,'  currlen= ',currlen
              print *,'  newlen=  ',newlen
              currlen=newlen
            else
              print *,'ERROR returned from 2nd allocate cgrib = ',ierr
              stop 95
            endif
          endif

          !  Create new GRIB Message
          listsec0(1)=holdgfld%discipline
          listsec0(2)=holdgfld%version

          print *,'output, holdgfld%idsectlen= ',holdgfld%idsectlen
          do j = 1,holdgfld%idsectlen
            print *,'     sect1, j= ',j,' holdgfld%idsect(j)= '
     &             ,holdgfld%idsect(j)
          enddo

          call gribcreate(cgrib,currlen,listsec0,holdgfld%idsect,ierr)
          if (ierr.ne.0) then
             write(6,*) ' ERROR creating new GRIB2 field (gribcreate)= '
     &                  ,ierr
             stop 95
          endif

          previgds=igds
          igds(1)=holdgfld%griddef
          igds(2)=holdgfld%ngrdpts
          igds(3)=holdgfld%numoct_opt
          igds(4)=holdgfld%interp_opt
          igds(5)=holdgfld%igdtnum

          if (igds(3) == 0) then
            ideflist = 0
          endif

          call addgrid (cgrib,currlen,igds,holdgfld%igdtmpl
     &                 ,holdgfld%igdtlen,ideflist,idefnum,ierr)

          if (ierr.ne.0) then
            write(6,*) ' ERROR from addgrid adding GRIB2 grid = ',ierr
            stop 95
          endif

cJ.Peng----04-18-2017---definition for RH-------------------------
          holdgfld%ipdtmpl(1) = 1
          holdgfld%ipdtmpl(2) = 1
          holdgfld%ipdtmpl(14) = 0
          holdgfld%ipdtmpl(15) = 0

cJ.Peng-----2014-10-21 --------------------------------------------
c          holdgfld%ipdtmpl(12) = int(xoutlevs_p(lev)) * 100

          ijk = int(xoutlevs_p(lev))
          if(g2_model == 1 .or. g2_model == 10 .or. g2_model == 16
     & .or. g2_model == 7 .or. g2_model == 22 .or. g2_model == 15) then
            holdgfld%ipdtmpl(10) = 100 
            holdgfld%ipdtmpl(11) =  0
            holdgfld%ipdtmpl(12) = ijk * 100
          elseif(g2_model == 26) then
            holdgfld%ipdtmpl(10) = 100
            if( ijk == 300 .or. ijk == 400 .or. ijk == 500
     &       .or. ijk == 600 .or. ijk == 700 .or. ijk == 800
     &       .or. ijk == 900 ) then 
              holdgfld%ipdtmpl(11) = -4 
              holdgfld%ipdtmpl(12) = ijk/100
            elseif( ijk == 350 .or. ijk == 450 .or. ijk == 550
     &       .or. ijk == 650 .or. ijk == 750 .or. ijk == 850
     &       ) then
              holdgfld%ipdtmpl(11) = -3
              holdgfld%ipdtmpl(12) = ijk/10
            endif
          endif

          ipack      = 40
          idrsnum    = ipack
          idrstmpl   = 0

          idrstmpl(2)= holdgfld%idrtmpl(2)
cJ.Peng----04-18-2017---definition for RH-------------------------          
c          idrstmpl(3)= holdgfld%idrtmpl(3)
          idrstmpl(3)= 1

          idrstmpl(6)= 0
          idrstmpl(7)= 255

          numcoord=0
          coordlist=0.0  ! Only needed for hybrid vertical coordinate,
                         ! not here, so set it to 0.0

         ! 0   - A bit map applies to this product and is specified in
         ! this section
         ! 255 - A bit map does not apply to this product
         ibmap=255     ! Bitmap indicator (see Code Table 6.0)

         print *,' '
         print *,'output, holdgfld%ipdtlen= ',holdgfld%ipdtlen
         do n = 1,holdgfld%ipdtlen
           print *,'output, n= ',n,' holdgfld%ipdtmpl= '
     &            ,holdgfld%ipdtmpl(n)
         enddo

         print *,'output, kf= ',kf
c         do n = 1,kf
c           print *,'output, n= ',n,' xoutdat(n)= ',xoutdat(n)
c         enddo

         call addfield (cgrib,currlen,holdgfld%ipdtnum,holdgfld%ipdtmpl
     &                 ,holdgfld%ipdtlen,coordlist
     &                 ,numcoord
     &                 ,idrsnum,idrstmpl,200
     &                 ,xoutdat(1,lev),kf,ibmap,bmap,ierr)

          if (ierr /= 0) then
            write(6,*) ' ERROR from addfield adding GRIB2 data = ',ierr
            stop 95
          endif

!         Finalize  GRIB message after all grids
!         and fields have been added.  It adds the End Section ( "7777" )

          call gribend(cgrib,currlen,lengrib,ierr)
          call wryte(lout,lengrib,cgrib)

          if (ierr == 0) then
            print *,' '
            print *,'+++ GRIB2 write successful. '
            print *,'    Len of message = currlen= ',currlen
            print *,'    Len of entire GRIB2 message = lengrib= '
     &             ,lengrib
          else
            print *,' ERROR from gribend writing GRIB2 msg = ',ierr
            stop 95
          endif

        else

          ! Write data out as a GRIB1 message....

          kpds(7) = int(xoutlevs_p(lev))

          print *,'In RH, just before call to putgb, kf= ',kf
          call putgb (lout,kf,kpds,kgds,valid_pt,xoutdat(1,lev),ipret)
          print *,'In RH, just after call to putgb, kf= ',kf
          if (ipret == 0) then
            print *,' '
            print *,'+++ IPRET = 0 after call to putgb in RH'
            print *,' '
          else
            print *,' '
            print *,'!!!!!! ERROR in RH.'
            print *,'!!!!!! ERROR: IPRET NE 0 AFTER CALL TO PUTGB !!!'
            print *,'!!!!!!        Level index= ',lev
            print *,'!!!!!!           pressure= ',xoutlevs_p(lev)
            print *,' '
          endif

          write(*,980) kpds(1),kpds(2)
          write(*,981) kpds(3),kpds(4)
          write(*,982) kpds(5),kpds(6)
          write(*,983) kpds(7),kpds(8)
          write(*,984) kpds(9),kpds(10)
          write(*,985) kpds(11),kpds(12)
          write(*,986) kpds(13),kpds(14)
          write(*,987) kpds(15),kpds(16)
          write(*,988) kpds(17),kpds(18)
          write(*,989) kpds(19),kpds(20)
          write(*,990) kpds(21),kpds(22)
          write(*,991) kpds(23),kpds(24)
          write(*,992) kpds(25)
          write(*,880) kgds(1),kgds(2)
          write(*,881) kgds(3),kgds(4)
          write(*,882) kgds(5),kgds(6)
          write(*,883) kgds(7),kgds(8)
          write(*,884) kgds(9),kgds(10)
          write(*,885) kgds(11),kgds(12)
          write(*,886) kgds(13),kgds(14)
          write(*,887) kgds(15),kgds(16)
          write(*,888) kgds(17),kgds(18)
          write(*,889) kgds(19),kgds(20)
          write(*,890) kgds(21),kgds(22)

  980     format('    kpds(1)  = ',i7,'  kpds(2)  = ',i7)
  981     format('    kpds(3)  = ',i7,'  kpds(4)  = ',i7)
  982     format('    kpds(5)  = ',i7,'  kpds(6)  = ',i7)
  983     format('    kpds(7)  = ',i7,'  kpds(8)  = ',i7)
  984     format('    kpds(9)  = ',i7,'  kpds(10) = ',i7)
  985     format('    kpds(11) = ',i7,'  kpds(12) = ',i7)
  986     format('    kpds(13) = ',i7,'  kpds(14) = ',i7)
  987     format('    kpds(15) = ',i7,'  kpds(16) = ',i7)
  988     format('    kpds(17) = ',i7,'  kpds(18) = ',i7)
  989     format('    kpds(19) = ',i7,'  kpds(20) = ',i7)
  990     format('    kpds(21) = ',i7,'  kpds(22) = ',i7)
  991     format('    kpds(23) = ',i7,'  kpds(24) = ',i7)
  992     format('    kpds(25) = ',i7)
  880     format('    kgds(1)  = ',i7,'  kgds(2)  = ',i7)
  881     format('    kgds(3)  = ',i7,'  kgds(4)  = ',i7)
  882     format('    kgds(5)  = ',i7,'  kgds(6)  = ',i7)
  883     format('    kgds(7)  = ',i7,'  kgds(8)  = ',i7)
  884     format('    kgds(9)  = ',i7,'  kgds(10) = ',i7)
  885     format('    kgds(11) = ',i7,'  kgds(12) = ',i7)
  886     format('    kgds(13) = ',i7,'  kgds(14) = ',i7)
  887     format('    kgds(15) = ',i7,'  kgds(16) = ',i7)
  888     format('    kgds(17) = ',i7,'  kgds(18) = ',i7)
  889     format('    kgds(19) = ',i7,'  kgds(20) = ',i7)
  890     format('    kgds(20) = ',i7,'  kgds(22) = ',i7)

        endif

      enddo levloop
c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine open_grib_files (lugb,lugi,lout,gribver,iret)

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to read from the input GRIB files.  The GRIB and index files
C     are opened with a call to baopenr.  This call to baopenr was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB-reading
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lugb     The Fortran unit number for the GRIB data file
C     lugi     The Fortran unit number for the GRIB index file
C     lout     The Fortran unit number for the  output grib file
c     gribver  integer (1 or 2) to indicate if using GRIB1 / GRIB2
C
C     OUTPUT:
C     iret     The return code from this subroutine

      implicit none

      character(2)   lugb_c,lugi_c,lout_c
c      character(120) fnameg,fnamei,fnameo
cPeng 05/28/2018 Bug Fixed for FV3-GFS Job Crashed.
      character(255) fnameg,fnamei,fnameo
      character(6)   enameb,enamei,enameo
      integer   iret,gribver,lugb,lugi,lout,igoret,iioret,iooret

      iret=0
      write(lugb_c,'(i2)')lugb
      write(lugi_c,'(i2)')lugi
      write(lout_c,'(i2)')lout
      enameb='FORT'//adjustl(lugb_c)
      enamei='FORT'//adjustl(lugi_c)
      enameo='FORT'//adjustl(lout_c)
      call get_environment_variable(enameb, fnameg, status=igoret)
      call get_environment_variable(enamei, fnamei, status=iioret)
      call get_environment_variable(enameo, fnameo, status=iooret)
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        fnameg(1:5) = "fort."
        fnamei(1:5) = "fort."
        fnameo(1:5) = "fort."
        write(fnameg(6:7),'(I2)') lugb
        write(fnamei(6:7),'(I2)') lugi
        write(fnameo(6:7),'(I2)') lout
      endif
      call baopenr (lugb,fnameg,igoret)
      call baopenr (lugi,fnamei,iioret)
      call baopenw (lout,fnameo,iooret)

      print *,' '
      print *,'RH:  baopen: igoret= ',igoret,' iioret= ',iioret
     &       ,' iooret= ',iooret
      
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        print *,' '
        print *,'!!! ERROR in RH.'
        print *,'!!! ERROR in sub open_grib_files opening grib file'
        print *,'!!! or grib index file.  baopen return codes:'
        print *,'!!! grib  file return code = igoret = ',igoret
        print *,'!!! index file return code = iioret = ',iioret
        print *,'!!! output file return code = iooret = ',iooret
        iret = 93
        return
      endif

      return
      end
c
c-------------------------------------------------------------------
c
c-------------------------------------------------------------------
      subroutine bitmapchk (n,ld,d,dmin,dmax)
c
c     This subroutine checks the bitmap for non-existent data values.
c     Since the data from the regional models have been interpolated
c     from either a polar stereographic or lambert conformal grid
c     onto a lat/lon grid, there will be some gridpoints around the
c     edges of this lat/lon grid that have no data; these grid
c     points have been bitmapped out by Mark Iredell's interpolater.
c     To provide another means of checking for invalid data points
c     later in the program, set these bitmapped data values to a
c     value of -999.0.  The min and max of this array are also
c     returned if a user wants to check for reasonable values.
c
      logical(1) ld
      dimension  ld(n),d(n)
c
      dmin=1.E15
      dmax=-1.E15
c
      do i=1,n
        if (ld(i)) then
          dmin=min(dmin,d(i))
          dmax=max(dmax,d(i))
        else
          d(i) = -999.0
        endif
      enddo
c
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c------------------------------------------------------------------------
      SUBROUTINE CALRH_GFS(ix,jy,P1,T1,Q1,RH)
!$$$  SUBPROGRAM DOCUMENTATION BLOCK
!                .      .    .     
! SUBPROGRAM:    CALRH       COMPUTES RELATIVE HUMIDITY
!   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22       
!     
! ABSTRACT:  
!     THIS ROUTINE COMPUTES RELATIVE HUMIDITY GIVEN PRESSURE, 
!     TEMPERATURE, SPECIFIC HUMIDITY. AN UPPER AND LOWER BOUND
!     OF 100 AND 1 PERCENT RELATIVE HUMIDITY IS ENFORCED.  WHEN
!     THESE BOUNDS ARE APPLIED THE PASSED SPECIFIC HUMIDITY 
!     ARRAY IS ADJUSTED AS NECESSARY TO PRODUCE THE SET RELATIVE
!     HUMIDITY.
!   .     
!     
! PROGRAM HISTORY LOG:
!   ??-??-??  DENNIS DEAVEN
!   92-12-22  RUSS TREADON - MODIFIED AS DESCRIBED ABOVE.
!   98-06-08  T BLACK      - CONVERSION FROM 1-D TO 2-D
!   98-08-18  MIKE BALDWIN - MODIFY TO COMPUTE RH OVER ICE AS IN MODEL
!   98-12-16  GEOFF MANIKIN - UNDO RH COMPUTATION OVER ICE
!   00-01-04  JIM TUCCILLO - MPI VERSION
!   02-06-11  MIKE BALDWIN - WRF VERSION
!     
! USAGE:    CALL CALRH(P1,T1,Q1,RH)
!   INPUT ARGUMENT LIST:
!     P1     - PRESSURE (PA)
!     T1     - TEMPERATURE (K)
!     Q1     - SPECIFIC HUMIDITY (KG/KG)
!
!   OUTPUT ARGUMENT LIST: 
!     RH     - RELATIVE HUMIDITY  (DECIMAL FORM)
!     Q1     - ADJUSTED SPECIFIC HUMIDITY (KG/KG)
!     
!   OUTPUT FILES:
!     NONE
!     
!   SUBPROGRAMS CALLED:
!     UTILITIES:
!     LIBRARY:
!       NONE
!     
!   ATTRIBUTES:
!     LANGUAGE: FORTRAN
!     MACHINE : CRAY C-90
!$$$  
!
c      use params_mod, only: rhmin
c      use ctlblk_mod, only: jsta, jend, spval, im, jm
!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      implicit none
!
      real,parameter:: con_rd      =2.8705e+2 ! gas constant air    (J/kg/K)
      real,parameter:: con_rv      =4.6150e+2 ! gas constant H2O 
      real,parameter:: con_eps     =con_rd/con_rv
      real,parameter:: con_epsm1   =con_rd/con_rv-1

      real :: spval=9.9e10
      real, parameter :: rhmin=1.0E-6     ! minimal RH bound

!      real,external::FPVSNEW

      INTERFACE
        ELEMENTAL FUNCTION FPVSNEW (t)
          REAL  FPVSNEW
          REAL, INTENT(IN) :: t
        END FUNCTION FPVSNEW
      END INTERFACE
!
c      REAL,dimension(IM,JM),intent(in):: P1,T1
c      REAL,dimension(IM,JM),intent(inout):: Q1,RH
      REAL,dimension(ix,jy),intent(in):: P1,T1
      REAL,dimension(ix,jy),intent(inout):: Q1,RH

      REAL ES,QC
      integer :: I,J
      integer :: jsta, jend, im, jm, ix, jy
!***************************************************************
      JSTA=1
      JEND=jy
      IM=ix
      JM=jy
!
!     START CALRH.
!
      DO J=JSTA,JEND
      DO I=1,IM
        IF (T1(I,J).LT.SPVAL .AND. P1(I,J).LT.SPVAL
     &         .AND.Q1(I,J)/=SPVAL) THEN
          IF (ABS(P1(I,J)).GT.1) THEN
	    ES=FPVSNEW(T1(I,J))
	    ES=MIN(ES,P1(I,J))
	    QC=CON_EPS*ES/(P1(I,J)+CON_EPSM1*ES)
!           QC=PQ0/P1(I,J)
!     1          *EXP(A2*(T1(I,J)-A3)/(T1(I,J)-A4))

            RH(I,J)=Q1(I,J)/QC

!   BOUNDS CHECK
!
            IF (RH(I,J).GT.1.0) THEN
              RH(I,J)=1.0
              Q1(I,J)=RH(I,J)*QC
            ENDIF
!           IF (RH(I,J).LT.0.01) THEN
            IF (RH(I,J).LT.RHmin) THEN  !use smaller RH limit for stratosphere
              RH(I,J)=RHmin
              Q1(I,J)=RH(I,J)*QC
            ENDIF
          ENDIF
        ELSE
          RH(I,J)=SPVAL
        ENDIF
      ENDDO
      ENDDO

      RETURN
      END
c-----------------------------------------------------------------------------      
      elemental function fpvsnew(t)
!$$$     Subprogram Documentation Block
!
! Subprogram: fpvsnew         Compute saturation vapor pressure
!   Author: N Phillips            w/NMC2X2   Date: 30 dec 82
!
! Abstract: Compute saturation vapor pressure from the temperature.
!   A linear interpolation is done between values in a lookup table
!   computed in gpvs. See documentation for fpvsx for details.
!   Input values outside table range are reset to table extrema.
!   The interpolation accuracy is almost 6 decimal places.
!   On the Cray, fpvs is about 4 times faster than exact calculation.
!   This function should be expanded inline in the calling routine.
!
! Program History Log:
!   91-05-07  Iredell             made into inlinable function
!   94-12-30  Iredell             expand table
! 1999-03-01  Iredell             f90 module
! 2001-02-26  Iredell             ice phase
!
! Usage:   pvs=fpvsnew(t)
!
!   Input argument list:
!     t          Real(krealfp) temperature in Kelvin
!
!   Output argument list:
!     fpvsnew       Real(krealfp) saturation vapor pressure in Pascals
!
! Attributes:
!   Language: Fortran 90.
!
!$$$
      implicit none
      integer,parameter:: nxpvs=7501
      real,parameter:: con_ttp     =2.7316e+2 ! temp at H2O 3pt
      real,parameter:: con_psat    =6.1078e+2 ! pres at H2O 3pt
      real,parameter:: con_cvap    =1.8460e+3 ! spec heat H2O gas   (J/kg/K)
      real,parameter:: con_cliq    =4.1855e+3 ! spec heat H2O liq
      real,parameter:: con_hvap    =2.5000e+6 ! lat heat H2O cond
      real,parameter:: con_rv      =4.6150e+2 ! gas constant H2O
      real,parameter:: con_csol    =2.1060e+3 ! spec heat H2O ice
      real,parameter:: con_hfus    =3.3358e+5 ! lat heat H2O fusion
      real,parameter:: tliq=con_ttp
      real,parameter:: tice=con_ttp-20.0
      real,parameter:: dldtl=con_cvap-con_cliq
      real,parameter:: heatl=con_hvap
      real,parameter:: xponal=-dldtl/con_rv
      real,parameter:: xponbl=-dldtl/con_rv+heatl/(con_rv*con_ttp)
      real,parameter:: dldti=con_cvap-con_csol
      real,parameter:: heati=con_hvap+con_hfus
      real,parameter:: xponai=-dldti/con_rv
      real,parameter:: xponbi=-dldti/con_rv+heati/(con_rv*con_ttp)
      real tr,w,pvl,pvi
      real fpvsnew
      real,intent(in):: t
      integer jx
      real  xj,x,tbpvs(nxpvs),xp1
      real xmin,xmax,xinc,c2xpvs,c1xpvs
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      xmin=180.0
      xmax=330.0
      xinc=(xmax-xmin)/(nxpvs-1)
!   c1xpvs=1.-xmin/xinc
      c2xpvs=1./xinc
      c1xpvs=1.-xmin*c2xpvs
!    xj=min(max(c1xpvs+c2xpvs*t,1.0),real(nxpvs,krealfp))
      xj=min(max(c1xpvs+c2xpvs*t,1.0),float(nxpvs))
      jx=min(xj,float(nxpvs)-1.0)
      x=xmin+(jx-1)*xinc
      
      tr=con_ttp/x
      if(x.ge.tliq) then
        tbpvs(jx)=con_psat*(tr**xponal)*exp(xponbl*(1.-tr))
      elseif(x.lt.tice) then
        tbpvs(jx)=con_psat*(tr**xponai)*exp(xponbi*(1.-tr))
      else
        w=(t-tice)/(tliq-tice)
        pvl=con_psat*(tr**xponal)*exp(xponbl*(1.-tr))
        pvi=con_psat*(tr**xponai)*exp(xponbi*(1.-tr))
        tbpvs(jx)=w*pvl+(1.-w)*pvi
      endif
      
      xp1=xmin+(jx-1+1)*xinc      
     
      tr=con_ttp/xp1
      if(xp1.ge.tliq) then
        tbpvs(jx+1)=con_psat*(tr**xponal)*exp(xponbl*(1.-tr))
      elseif(xp1.lt.tice) then
        tbpvs(jx+1)=con_psat*(tr**xponai)*exp(xponbi*(1.-tr))
      else
        w=(t-tice)/(tliq-tice)
        pvl=con_psat*(tr**xponal)*exp(xponbl*(1.-tr))
        pvi=con_psat*(tr**xponai)*exp(xponbi*(1.-tr))
        tbpvs(jx+1)=w*pvl+(1.-w)*pvi
      endif
      
      fpvsnew=tbpvs(jx)+(xj-jx)*(tbpvs(jx+1)-tbpvs(jx))
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      end function fpvsnew
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine output_data1(lout,kf,holdgfld,xoutdat
     &                ,xoutlevs_p,nlevsout,g2_model,iodret)
c
c     ABSTRACT: This routine writes out the  output data on the
c     specified output pressure levels.

      USE params
      USE grib_mod
      
      implicit none
      type(gribfield) :: holdgfld
      integer  lout,kf,nlevsout,g2_model,iodret,lev
      integer  ijk,ierr1,nn
      real xoutdat(kf,nlevsout),xoutlevs_p(nlevsout)
      real     f(kf)

      iodret=0
      ierr1=0

      levloop: do lev = 1,nlevsout
cJ.Peng----04-18-2017---definition for RH--
        holdgfld%ipdtmpl(1) = 1
        holdgfld%ipdtmpl(2) = 1
        holdgfld%ipdtmpl(14) =  0
        holdgfld%ipdtmpl(15) =  0

        ijk = int(xoutlevs_p(lev))
        if(g2_model == 1 .or. g2_model == 10 .or. g2_model == 16
     & .or. g2_model == 7 .or. g2_model == 22 .or. g2_model == 15) then
          holdgfld%ipdtmpl(10) = 100
          holdgfld%ipdtmpl(11) =  0
          holdgfld%ipdtmpl(12) = ijk * 100
        endif

cJ.Peng----04-18-2017---definition for RH--decimal scale factor-----
        holdgfld%idrtmpl(3) = 1

        do nn=1,kf
          f(nn)=xoutdat(nn,lev)
        enddo

        holdgfld%fld(1:kf)=f(1:kf)
        call putgb2(lout,holdgfld,ierr1)
        
        if (ierr1 .eq. 0) then
          print *,'+++ GRIB2 write successful. '
          iodret=0
        else
          print *,' ERROR from putgb2 adding GRIB2 data = ',ierr1
          iodret=ierr1
        endif

      enddo levloop
      return
      end

C***********************************************************************
C***********************************************************************
      subroutine gblevn11(imax,jmax,grid) ! formerly subroutine n_s_swap
      implicit none
      integer imax, jmax
      real grid(imax,jmax)
      real temp (imax)
      integer i, j, jj

      do j=1,jmax/2
        jj = jmax-j+1
        do i=1,imax
          temp(i)    = grid(i,j)
          grid(i,j)  = grid(i,jj)
          grid(i,jj) = temp(i)
        enddo
      enddo
      return
      end

      FUNCTION UZ(Z,UM,CD,Z0,FL)  
C 
C  PURPOSE:   
C 
C        TO DETERMINE WIND SPEED AT HEIGHT Z GIVEN WIND SPEED (UM)  
C        AND DRAG COEFFICIENT (CD) FROM ANOTHER HEIGHT AND THE  
C        ROUGHNESS LENGTH (Z0) AND STABILITY LENGTH (FL) OF THE 
C        PROFILE. USUALLY FUNCTION UZ IS USED AFTER SUBROUTINE UZL  
C        IN ORDER TO FIND WIND SPEED AT A DIFFERENT HEIGHT THAN 
C        THE OBSERVATION HEIGHT.  
C 
C  ALGORITHM:   
C 
C        THE WIND PROFILE IS ASSUMED TO CONFORM TO THE BUSINGER-  
C        DYER FORMULATION USED IN SUBROUTINE UZL. 
C 
C  ARGUMENTS:   
C 
C        Z - HEIGHT AT WHICH WIND SPEED IS REQUIRED (METERS)  
C        UM - WIND SPEED AT OBSERVATION HEIGHT (METERS PER SECOND)  
C        CD - DRAG COEFFICIENT CORRESPONDING TO OBSERVATION HEIGHT  
C        Z0 - ROUGHNESS LENGTH (METERS) 
C        FL - STABILITY LENGTH (METERS) 
C 
C  HISTORY:   
C 
C        WRITTEN BY D.J SCHWAB, 1983, GLERL, ANN ARBOR, MI. 
C        SEE SUBROUTINE UZL IN SCHWAB, BENNETT, AND JESSUP (1981) 
C 
      IF(FL.GT.0.) GO TO 10 
C 
C  UNSTABLE PROFILE 
C 
      X1=15./FL 
      ARG1=(1.-X1*Z)**0.25  
      ARG2=(1.-X1*Z0)**0.25 
      B=ALOG((ARG1-1.)*(ARG2+1.)/((ARG1+1.)*(ARG2-0.999999)))+  
     1   2.*(ATAN(ARG1)-ATAN(ARG2)) 
      GO TO 30  
C 
C  STABLE SECTION 
C 
   10 IF(FL.LE.Z) GO TO 20  
C 
C  MILDLY STABLE PROFILE  
C 
      B=ALOG(Z/Z0)+4.7*(Z-Z0)/FL  
      GO TO 30  
C 
C  STRONGLY STABLE PROFILE  
C 
   20 CONTINUE  
      ARG1=FL/Z0  
      X1=ALOG(ARG1) 
      X2=ALOG(Z/FL) 
      ARG1=1.-1./ARG1 
      B=X1+4.7*ARG1+5.7*X2  
C 
C  CALCULATE USTAR AND UZ 
C 
   30 CONTINUE  
      USTAR=UM*SQRT(CD) 
      UZ=USTAR*B/0.35 
      RETURN  
      END 

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    WORDLENGTH
C   PRGMMR: KEYSER           ORG: NP22       DATE: 2013-02-14
C
C ABSTRACT: DETERMINES THE NUMBER OF BYTES IN A FULL WORD, BOTH
C   INTEGER AND REAL, FOR THE PARTICULAR MACHINE.
C
C PROGRAM HISTORY LOG:
C 1999-08-04  KEYSER      ADAPTED FROM W3LIB ROUTINE W3FI01, BUT
C   MODIFIED TO RETURN WORD LENGTH FOR REALS AS WELL AS INTEGERS
C   (W3FI01 RETURNED WORD LENGTH ONLY FOR INTEGERS) - THE IBM SP
C   ALLOWS REAL WORD LENGTH TO BE DIFFERENT FROM INTEGER WORD LENGTH
C 2012-11-30  J. WOOLLEN  INITIAL PORT TO WCOSS 
C 2013-02-14  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS
C
C USAGE:    CALL WORDLENGTH(LWI,LWR)
C   OUTPUT ARGUMENT LIST:
C     LWI      - MACHINE WORD LENGTH FOR INTEGERS (IN BYTES)
C     LWR      - MACHINE WORD LENGTH FOR REALS (IN BYTES)
C
C REMARKS: SUBPROGRAM CAN BE CALLED FROM A MULTIPROCESSING ENVIRONMENT.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE WORDLENGTH(LWI,LWR)

      CHARACTER*8  CTEST1,CTEST2,CTEST3,CTEST4

      INTEGER      ITEST1,ITEST2

      REAL         RTEST3,RTEST4

      EQUIVALENCE  (CTEST1,ITEST1),(CTEST2,ITEST2)

      EQUIVALENCE  (CTEST3,RTEST3),(CTEST4,RTEST4)

      DATA  CTEST1/'12345678'/,CTEST3/'12345678'/

      ITEST2 = ITEST1
      IF (CTEST1 .EQ. CTEST2) THEN
        LWI = 8
      ELSE
        LWI = 4
      END IF

      RTEST4 = RTEST3
      IF (CTEST3 .EQ. CTEST4) THEN
        LWR = 8
      ELSE
        LWR = 4
      END IF

      RETURN
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM:  PREPOBS_OIQCBUFR
C   PRGMMR: WOOLLEN/KEYSER   ORG: NP20        DATE: 2013-06-19
C
C ABSTRACT: QUALITY CONTROLS OBSERVATIONS TO BE USED IN THE GLOBAL
C   ANALYSIS-FORECAST SYSTEM. OBSERVATIONAL DATASET GENERATED BY
C   THE GESTEMP PREPROCESSOR IS INPUT TO OIQC WHICH THEN PERFORMS
C   A "COMPLEX" QUALITY CONTROL (FROM GANDIN,1985) EMPLOYING
C   MULTIVARIATE OI TO CHECK ALL OBSERVATIONS AGAINST NEARBY
C   NEIGHBORS. SEVERAL ITERATIONS OF THE BASIC SCHEME ARE REQUIRED
C   TO COMPLETE THE PROCESS. DURING EACH ITERATION ALL OBSERVATIONS
C   ARE SUBJECTED TO FIVE INTERPOLATION CHECKS. CHECK #1 INTERPOLATES
C   COMPARISON VALUES FROM NEARBY TEMPERATURE DATA. CHECK #2 AND CHECK
C   #3 INTERPOLATE COMPARISON VALUES FROM NEARBY ZONAL AND LONGITUDINAL
C   WIND COMPONENTS RESPECTIVELY. CHECK #4 IS AN INTERPOLATION
C   FROM THE NEAREST OBS IN THE SAME PROFILE AS THE ONE BEING CHECKED.
C   A WEIGHTED COMBINATION OF THE OUTCOME OF THESE FOUR CHECKS IS
C   PRODUCED ON THE BASIS OF FACTORS WHICH DETERMINE WHICH
C   OF THE INTERPOLATIONS (IF ANY) MIGHT BE EXPECTED TO BE MORE
C   RELEVANT THAN THE OTHERS; FOR EXAMPLE THE NUMBER AND LOCATION
C   IN SPACE AND TIME OF OBSERVATIONS USED IN A GIVEN CHECK
C   AS WELL AS RELATIVE QUALITY OF THE OBSERVATIONS INVOLVED IS USED TO
C   INDICATE WHICH OF THE OUTCOMES SHOULD BE RELIED MORE HEAVILY UPON
C   TO MAKE A DECISION IN A PARTICULAR CASE. CHECK #5 INTERPOLATES
C   A VALUE FROM THE MULTIVARIATE SET OF OBS USED IN CHECKS #1-#3,
C   WHICH IS USED TO MEASURE HOW THE ANALYSIS WOULD DRAW (OR NOT DRAW)
C   TO THE OB BEING CHECKED. THE TOLERANCE ALLOWED FOR DEVIATION FROM
C   THE EXPECTED OUTCOME OF THE INTERPOLATION CHECKS IS PROPORTIONAL
C   TO A MEASURE OF THE DRAW COMPUTED USING THE RESULT OF CHECK #5.
C   DURING EACH ITERATION EACH OBSERVATION EITHER PASSES OR FAILS THE
C   COMPLEX OF CHECKS JUST DESCRIBED. A "PASS" MEANS THAT OB MAY BE
C   USED FOR CHECKING OBS DURING THE SUBSEQUENT ITERATION. A "FAIL"
C   INDICATES THE OPPOSITE. THE SYSTEM IS ITERATED UNTIL IDENTICAL
C   RESULTS IN TERMS OF OBS THAT PASS AND FAIL ARE OBTAINED IN TWO
C   CONSECUTIVE ITERATIONS UP TO FOUR COMPLETE ITERATIONS AT WHICH
C   POINT A FINAL ARBITRATION PROCEDURE IS INVOKED TO RESOLVE A (SMALL)
C   NUMBER OF AMBIGUOUS CASES WHICH ARE PREVENTING CONVERGENCE OF THE
C   SYSTEM.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN  ORIGINAL VERSION FOR IMPLEMENTATION
C 1990-04-23  J. WOOLLEN  VERSION FOR IMPLEMENTATION W/ SPECTRAL OI
C 1998-09-25  J. WOOLLEN  Y2K VERSION & RETURN CODE 4 FOR TOO MUCH DATA
C 1999-09-27  J. WOOLLEN  IBM-SP MPI/OMP VERSION IMPLEMENTED
C 1999-12-21  J. WOOLLEN  FIX FOR RECEIVE PROBLEM WITH TOO MUCH DATA
C 2004-09-09  D. KEYSER   CHANGE CALL FROM BUFRLIB ROUTINE BORT TO
C         W3LIB ROUTINE ERREXIT; BUMPED UP MAXREP FROM 200K TO 300K
C         (AND ALL ASSOC. ARRAYS), BUMPED UP MAXLEV FROM 300K TO 400K
C         (AND ALL ASSOC. ARRAYS) - NEEDED TO HANDLE METAR RPTS IN R.
C         TYPE 187; IMPROVED DOCBLOCKS
C 2006-06-06  D. KEYSER   BUMPED UP MAXREP FROM 300K TO 600K (AND ALL
C         ASSOC. ARRAYS), BUMPED UP MAXLEV FROM 400K TO 800K (AND ALL
C         ASSOC. ARRAYS) - NEEDED TO HANDLE WINDSAT RPTS IN R. TYPE
C         289
C 2007-04-23  D. KEYSER   BUMPED UP MAXREP FROM 600K TO 900K (AND ALL
C         ASSOC. ARRAYS), BUMPED UP MAXLEV FROM 800K TO 1100K (AND ALL
C         ASSOC. ARRAYS) - NEEDED TO HANDLE WINDSAT RPTS IN R. TYPE
C         289
C 2007-04-23  J. WOOLLEN  FIX IN SUBR NDDSPLIT TO AVOID LOAD BALANCING
C         ERROR MADE IN UNUSUAL SITUATIONS WITH SMALL AMOUNTS OF DATA
C 2012-08-31  J. WOOLLEN  FIX IN SUBR SEARCHS AND FCN LTX TO AVOID
C         ARRAY OVERFLOW IN IMAP FOR CERTAIN LAT/LON VALUES
C 2012-11-20  J. WOOLLEN  INITIAL PORT TO WCOSS: REMOVE ALL THREADING
C         SO CODE BECOMES STRICTLY MPI FOR SIMPLER AND BETTER LOAD
C         BALANCING
C 2013-03-26  J. WOOLLEN  FIX IN SUBR. PREPQM ADDRESSING ALIGNMENT
C         PROBLEM WHEN THE LAST BUFR MESSAGE CONTAINS NO DATA WHICH IS
C         OIQC PROCESSED
C 2013-03-26  D. KEYSER   FINAL CHANGES TO RUN ON WCOSS
C 2013-06-19  J. WOOLLEN  FIX SUBR. SYNCNDD TO PREVENT HANGUP IN
C         RECEIVE BY A PROCESSOR WHEN THERE IS VERY LITTLE DATA OF A
C         CERTAIN TYPE
C 2019-06-20  S. Melchior Explicit declartion of bmiss in subr. STORE
C
C USAGE:
C   INPUT FILES:
C     UNIT 11  - NCEP PRODUCTION DATE FILE
C     UNIT 14  - OBSERVATION (PREPBUFR) PRIOR TO UPDATED QUALITY MARKS
C     UNIT 17  - OBSERVATION ERROR TABLE FILE SPECIFIC TO THIS PROGRAM
C                (THIS IS NOT THE ANALYSIS OBSERVATION ERROR FILE -
C                 THOSE DATA ARE READ FROM THE PREPBUFR FILE)
C     UNIT 18  - LIST OF IPOINTS FOR DETAILED PRINT IN UNITS 71-80
C     UNIT 20  - TOLERANCE LEVELS (FOR EXPERIMENTATION)
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 61  - DETAILED TOSSLIST FOR SURFACE HEIGHTS
C     UNIT 62  - DETAILED TOSSLIST FOR TEMPS AND WINDS
C     UNIT 63  - DETAILED TOSSLIST FOR SAT TEMPS
C     UNIT 64  - DETAILED TOSSLIST FOR SSMI WIND SPEEDS
C     UNIT 65  - OFFICIAL OPERATIONAL TOSSLIST
C     UNIT 70  - OBSERVATION (PREPBUFR) FILE WITH UPDATED QUALITY MARKS
C     UNIT 71  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 72  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 73  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 74  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 75  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 76  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 77  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 78  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 79  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 80  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 81  - SUMMARY OF QC RESULTS (ASCII)
C     UNIT 82  - SUMMARY OF QC RESULTS (BINARY)
C
C   SUBPROGRAMS CALLED:   (*AUTOTASKED)
C     UNIQUE:    - SETCON   RDOBER   STORE    STOERR   *COOR2
C                  MAKEAMAP SEARCH   CHDIST   QCLOOP   QCPTS
C                  SATPTS   *SELDAT  *QCOI    *COOR1   *DRCTSL
C                  *VSOLVE  *OUTPUT  *SATPUT  OBOGRAM  TOSSLIST
C                  PREPQM   SYNCSTOR MPISPLIT SSMIPUT  SRTPRS
C                  SEARCHS  SSMIPTS  SYNCNDD
C     LIBRARY:
C       MPI      - MPI_BCST MPI_RECV MPI_SEND MPI_INIT
C                  MPI_COMM_RANK     MPI_COMM_SIZE
C                  MPI_FINALIZE
C       MASS     - VSCOS
C       W3NCO    - W3TAGB   W3TAGE   ERREXIT
C       BUFRLIB  - DATEBF   CLOSBF   UFBCPY   OPENMB   IREADMM
C                  OPENBF   UFBQCD   UFBINT   WRITSB   UFBCNT
C                  CLOSMG   COPYMG   ICOPYSB  UFBMEM   IREADSB
C                  READMM
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C     COND =   4 - TOO MUCH DATA, NOT ALL WAS CHECKED - NORMAL
C                  TERMINATION
C     COND =  99 - DISASTOROUS PROBLEM SITUATION DETECTED - ABNORMAL
C                  TERMINATION
C
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
C-----------------------------------------------------------------------
CTREE GETFCER
CTREE PILNLNP
CTREE SATPTS
CTREE SATPUT
C-----------------------------------------------------------------------
      PROGRAM PREPOBS_OIQCBUFR

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC

      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /CKLIST  / NDD,INDD(MAXLEV)
      COMMON /TOSSUNIT/ ITUNIT
      COMMON /RETCODE/ IRETCODE
      REAL*8 SID

      EXTERNAL          QCPTS,SATPTS

      DATA LUDAT /11/
      DATA LUBFI /14/
      DATA LUQCE /17/
      DATA LUBFQ /70/
      DATA ITERS /6/

      include "mpif.h"

C-----------------------------------------------------------------------
      IRETCODE = 0
C-----------------------------------------------------------------------
C  UNIFIED QC ANALYSIS SETUP PROCEDURE IS AS FOLLOWS:
C  -------------------------------------------------
C    -1) IRETCODE - INITIALLY 0, MAY BE CHANGED TO 4 IF TOO MUCH DATA
C     0) W3TAGB   - WRITE AN OPERATIONS START MESSAGE
C     1) SETCON   - SET CONSTANTS AND PARAMETERS
C     2) STORE    - READ IN FERR (OB/INCREMENT) FILE AND STORE IT
C     3) RDOBER   - READ IN THE OBSERVATION ERRORS
C     4) STOERR   - STORE THE OB AND FC ERRORS WITH EACH REPORT LEVEL
C     5) MAKEAMAP - MAKE AN OB POINTER LIST SORTED BY LAT-LON
C-----------------------------------------------------------------------


      call mpi_init(ierr)
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
      if(myid.eq.0) then
      print*
      print*,'nprocs = ',nprc
      print*
      CALL W3TAGB('PREPOBS_OIQCBUFR',2019,0171,0088,'NP22')
      print*
      print*
      print*, '--> WELCOME TO PREPOBS_OIQCBUFR - VERSION 06-20-2019'
      print*
      print*
      endif

      CALL SETCON
      CALL STORE(LUDAT,LUBFI)
      CALL RDOBER (LUQCE)
      CALL STOERR
      CALL MAKEAMAP

C  OIQC CHECKS OF SURFACE HEIGHT/PRESSURE DATA
C  -------------------------------------------

      NDD = 0

      DO IREP=1,NREP
      USEFLG = ABS(FQL(IREP))
      FQL(IREP) = -USEFLG
      IF(FOC(IREP).EQ.'SFC') THEN
         FNL(IREP) = 1
         ILEV      = FLV(IREP)+1
         IF(FOE(ILEV).GT.0.) THEN
            NDD       = NDD+1
            INDD(NDD) = ILEV
            FQL(IREP) = USEFLG
            FLV(IREP) = ILEV
         ENDIF
      ENDIF
      ENDDO

      IF(NDD.GT.0) THEN
         if(myid.eq.0) then
            WRITE(6 ,*)' CHECKING SURFACE HEIGHT DATA ',NDD,' OBS'
         endif
         ITUNIT = 61
         CALL SEARCH          
         CALL QCLOOP(QCPTS,ITERS)
         DO N=1,NDD
         IREP = FHD(INDD(N))
         FLV(IREP) = INDD(N)-1
         ENDDO
      ENDIF

C  OIQC CHECKS OF UPA AND SFC TEMP AND WIND DATA
C  -------------------------------------------

      NDD = 0

      DO IREP=1,NREP
      USEFLG = ABS(FQL(IREP))
      FQL(IREP) = -USEFLG
      IF(FOC(IREP).EQ.'UPA' .OR. FOC(IREP).EQ.'SFC') THEN
         FQL(IREP) = USEFLG
         ILEV  = FLV(IREP)
         KLEV  = ILEV+FNL(IREP)-1
         DO JLEV=ILEV,KLEV
         IF(FOE(JLEV).GT.0.) THEN
            NDD = NDD+1
            INDD(NDD) = JLEV
         ENDIF
         ENDDO
      ENDIF
      ENDDO

      IF(NDD.GT.0) THEN
         if(myid.eq.0) then
            WRITE(6 ,*)' CHECKING TEMP AND WIND DATA ',NDD,' OBS'
         endif
         ITUNIT = 62
         CALL SEARCH             
         CALL QCLOOP(QCPTS,ITERS) 
      ENDIF

C  OIQC CHECKS OF SATEM DATA
C  -------------------------

      NDD = 0

      DO IREP=1,NREP
      USEFLG = ABS(FQL(IREP))
      IF(FOC(IREP).EQ.'SAT') THEN
         FQL(IREP) = 1.
         ILEV  = FLV(IREP)
         KLEV  = ILEV+FNL(IREP)-1
         DO JLEV=ILEV,KLEV
         IF(FOE(JLEV).GT.0.) THEN
            NDD = NDD+1
            INDD(NDD) = JLEV
         ENDIF
         ENDDO
      ELSE
         FQL(IREP) = -USEFLG
      ENDIF
      ENDDO

      IF(NDD.GT.0) THEN
         if(myid.eq.0) then
            WRITE(6 ,*)' CHECKING SAT TEMP DATA ',NDD,' OBS'
         endif
         ITUNIT = 63
         CALL SEARCH
         CALL QCLOOP(SATPTS,1)
      ENDIF

C  DIRECTION ASSIGNMENT AND OIQC CHECKS FOR SSMI DATA
C  --------------------------------------------------

      NDD = 0

      DO IREP=1,NREP
      USEFLG = ABS(FQL(IREP))
      IF(FOC(IREP).EQ.'SMI') THEN
         ILEV  = FLV(IREP)
         IF(FOE(ILEV).GT.0.) THEN
            NDD = NDD+1
            INDD(NDD) = ILEV
            FQL(IREP) = USEFLG
         ENDIF
      ELSE IF(FOC(IREP).EQ.'SAT') THEN
         FQL(IREP) = -USEFLG
      ELSE
         FQL(IREP) = 0.
      ENDIF
      ENDDO

      IF(NDD.GT.0) THEN
         if(myid.eq.0) then
            WRITE(6 ,*)' CHECKING SSMI DATA ',NDD,' OBS'
         endif
         ITUNIT = 64
         CALL SSMIPTS
         call syncndd(fob(1,1),nlev,mpi_real)
         call syncndd(fob(1,2),nlev,mpi_real)
         CALL SEARCH
         CALL QCLOOP(QCPTS,ITERS)
      ENDIF

C  COMPUTE STATISTICS, WRITE LISTS, UPDATE QUALITY MARKS
C  -----------------------------------------------------

      call mpi_barrier(mpi_comm_world,ier)
      if(myid.eq.0) then
         CALL OBOGRAM  (11,81,82)
         CALL TOSSLIST (65)
         CALL PREPQM   (LUBFI,LUBFQ)
         CALL W3TAGE('PREPOBS_OIQCBUFR')
      endif

C  TIE IT TOGETHER AND END UP
C  --------------------------

      call mpi_finalize(mret)
      IF(IRETCODE.NE.0) THEN
         CALL ERREXIT(IRETCODE)
      ELSE
         STOP
      ENDIF

      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    CHDIST
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: COMPUTES CHORD LENGTH DISTANCE FROM A FIXED POINT TO AN
C   ARRAY OF POINTS USING THE FORMULA:
C     S**2/2 = 1 - COS(Y1-Y2) + COS(Y1)*COS(Y2)*(1-COS(X1-X2)).
C   ALSO THE DIRECTION OF EACH POINT IS COMPUTED WITH RESPECT TO THE
C   FIXED POINT AND RETURNED AS WELL.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL CHDIST(X1,Y1,X2,Y2,DIST,DIRN,NIND,NP)
C   INPUT ARGUMENT LIST:
C     X1       - X-COORDINATE  (LONGITUDE) OF FIXED POINT
C     Y1       - Y-COORDINATE  (LATITUDE ) OF FIXED POINT
C     X2       - X-COORDINATES (LONGITUDE) FOR SET OF POINTS
C     Y2       - Y-COORDINATES (LATITUDE ) FOR SET OF POINTS
C     NP       - NUMBER OF OUTPUTS REQUESTED
C
C   OUTPUT ARGUMENT LIST:
C     DIST     - CHORD LENGTH DISTANCES FROM FIXED POINT (KM)
C     DIRN     - DIRECTION FROM FIXED POINT (DEG)
C
C REMARKS: NONE.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE CHDIST(X1,Y1,X2,Y2,DIST,DIRN,NIND,NP)

      DIMENSION  X2(NP),Y2(NP),DIST(NP),DIRN(NP),NIND(NP)
      dimension  cosy2(np),cosdx(np),cosdy(np)

      DATA PI180/.0174532 /,RADE/6371./
      SAVE PI180,RADE

C----------------------------------------------------------------------
      !itab(x) = nint(mod(x+360.,360.)*100.)
C----------------------------------------------------------------------

      IF(NP.EQ.0) RETURN

C  COMPUTE THE DISTANCE
C  --------------------

      COSY1 = cos(y1*pi180) 
      do i=1,np
      cosy2(i) = cos(y2(i)*pi180)
      cosdx(i) = cos((x1-x2(i))*pi180)
      cosdy(i) = cos((y1-y2(i))*pi180)
      enddo

      !call vscos(cosy2,cosy2,np)
      !call vscos(cosdx,cosdx,np)
      !call vscos(cosdy,cosdy,np)

      DO I=1,NP
      S = 1.0-COSDY(I)+COSY1*COSY2(I)*(1.0-COSDX(I))
      S = SQRT(2.*S)
      IF(S.LE..002) S = 0.
      DIST(I) = S*RADE
      ENDDO       

C  COMPUTE DIRECTIONS
C  ------------------

      DO I=1,NP
      DX = (X2(I)-X1)*COSY1
      DY = (Y2(I)-Y1)
      IF(DX.GT.0.) THEN
         DIRN(I) = 0. + ATAN(DY/DX)/PI180
      ELSE IF(DX.LT.0.) THEN
         DIRN(I) = 180. + ATAN(DY/DX)/PI180
      ELSE IF(DX.EQ.0.) THEN
         DIRN(I) = SIGN(90.,DY)
      ENDIF
      IF(DIRN(I).LT.0.) DIRN(I) = DIRN(I) + 360.
      ENDDO

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    COOR1
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: COMPUTES CHORD LENGTH DISTANCE FOR A MATRIX OF LOCATIONS
C   <(X,Y)I,(X,Y)J> USING THE NORMAL ANGLE  FORMULA:
C     S**2/2 = 1 - COS(Y1-Y2) + COS(Y1)*COS(Y2)*(1-COS(X1-X2))
C   DERIVATIVES OF DISTANCE WITH RESPECT TO LAT AND LON ARE ALSO
C   COMPUTED AND COMBINED WITH APPROPRIATE CORRELATION FUNCTIONS AND
C   DERIVATIVES WITH RESPECT TO DISTANCE TO FORM THE MULTI-VARIATE
C   CORRELATIONS FOR THE HEIGHT WIND ANALYSIS.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORINGIAL AUTHOR
C
C USAGE:    CALL COOR1(NP,CH,FL,TZ,X1,Y1,K1,X2,Y2,K2,D,C1,C2)
C   INPUT ARGUMENT LIST:
C     NP       - NUMBER OF OUTPUTS REQUESTED
C     CH       - VECTOR OF CONSTANTS FOR THE GAUSSIAN LENGTH SCALE
C     X1       - X-COORDINATES (LONGITUDE) FOR POINT 1
C     Y1       - Y-COORDINATES (LATITUDE ) FOR POINT 1
C     K1       - VARIABLE TYPE AT POINT 1  (I.E. 1-Z , 2-U , 3-V)
C     X2       - X-COORDINATES (LONGITUDE) FOR POINT 2
C     Y2       - Y-COORDINATES (LATITUDE ) FOR POINT 2
C     K2       - VARIABLE TYPE AT POINT 2  (I.E. 1-Z , 2-U , 3-V)
C     FL       - DECOUPLING FACTOR
C     TZ       - HEIGHT-TEMPERATURE FACTOR
C
C   OUTPUT ARGUMENT LIST:
C     D        - DISTANCES BETWEEN ARRAYS OF POINTS IN RADIANS
C     C1       - CORRELATION COEFFICIENTS AS SPECIFIED
C     C2       - CORRELATION COEFFICIENTS AS SPECIFIED
C
C REMARKS: THIS PROGRAM COMPUTES A GAUSSIAN CORRELATION WITH
C   LENGTH SCALE GIVEN BY THE CHTWV INPUT ARGUMENT.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE COOR1(NP,CH,FL,TZ,X1,Y1,K1,X2,Y2,K2,D,C1,C2)

      DIMENSION  CH(NP),FL(NP),TZ(NP)
      DIMENSION  X1(NP),Y1(NP),K1(NP)
      DIMENSION  X2(NP),Y2(NP),K2(NP)
      DIMENSION  D (NP),C1(NP),C2(NP)

      LOGICAL ZZ,ZU,ZV,UZ,UU,UV,VZ,VU,VV

      DATA PI180 /.0174532 /, SMIN/.002/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      IF(NP.EQ.0) RETURN

C  LOOP OVER SET OF INPUT POINTS
C  -----------------------------

      DO 20 I=1,NP

      C1(I) = 0.
      C2(I) = 0.

C  DETERMINE CORRELATION TYPE
C  --------------------------

      ZZ = K1(I).EQ.1 .AND. K2(I).EQ.1
      ZU = K1(I).EQ.1 .AND. K2(I).EQ.2
      ZV = K1(I).EQ.1 .AND. K2(I).EQ.3
      UZ = K1(I).EQ.2 .AND. K2(I).EQ.1
      UU = K1(I).EQ.2 .AND. K2(I).EQ.2
      UV = K1(I).EQ.2 .AND. K2(I).EQ.3
      VZ = K1(I).EQ.3 .AND. K2(I).EQ.1
      VU = K1(I).EQ.3 .AND. K2(I).EQ.2
      VV = K1(I).EQ.3 .AND. K2(I).EQ.3

C  COMPUTE THE MATRIX OF SINES AND COSINES
C  ---------------------------------------

      COSY1 = COS(Y1(I)*PI180)
      COSY2 = COS(Y2(I)*PI180)
      SINY1 = SIN(Y1(I)*PI180)
      SINY2 = SIN(Y2(I)*PI180)
      COSDX = COS((X1(I)-X2(I))*PI180)
      COSDY = COS((Y1(I)-Y2(I))*PI180)
      SINDX = SIN((X1(I)-X2(I))*PI180)
      SINDY = SIN((Y1(I)-Y2(I))*PI180)

C  COMPUTE THE NORMAL ANGLE
C  ------------------------

      S = 1.0-COSDY+COSY1*COSY2*(1.0-COSDX)
      S = SQRT(2.*S)

C  CALCULATE THE FIRST PARTIALS WITH RESPECT TO X1 AND Y1
C  ------------------------------------------------------

      SI  =  MAX(S,SMIN)
      SI  =  1./SI
      DY1 =  SI*(SINDY-SINY1*COSY2*(1.0-COSDX))
      DX1 =  SI*(COSY1*COSY2*SINDX)
      DY2 = -SI*(SINDY+COSY1*SINY2*(1.0-COSDX))
      DX2 = -DX1

C  CALCULATE THE MIXED PARTIAL DERIVATIVES
C  ---------------------------------------

      DY1Y2=  SI*(SINY1*SINY2*(1.0-COSDX)-COSDY-DY1*DY2)
      DY1X2=  SI*(SINY1*COSY2*SINDX-DY1*DX2)
      DX1X2= -SI*(COSY1*COSY2*COSDX+DX1*DX2)
      DX1Y2= -SI*(COSY1*SINY2*SINDX+DX1*DY2)

C  COMPUTE THE VARIOUS CORRELATIONS
C  --------------------------------

      RHO   = EXP(-CH(I)*S*S)
      DRHO  = -2.*CH(I)*S*RHO
      D2RHO = -2.*CH(I)*(RHO+S*DRHO)

      WW0   = 2.*CH(I)
      SRWW0 = SQRT(WW0)

      D(I)  = S

      IF(S.LT.SMIN) THEN
         IF(ZZ) C1(I) = 1.
         IF(UU) C1(I) = 1.
         IF(VV) C1(I) = 1.
         D(I) = 0.
      ELSE IF(ZZ) THEN
         C1(I) = RHO
      ELSE IF(ZU) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DY2*SIGN(1.,-SINY2)/SRWW0
      ELSE IF(ZV) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DX2*SIGN(1., SINY2)/(SRWW0*COSY2)
      ELSE IF(UZ) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DY1*SIGN(1.,-SINY1)/SRWW0
      ELSE IF(UU) THEN
         C1(I) = DY1*DY2*D2RHO+DY1Y2*DRHO
         C1(I) = C1(I)*SIGN(1., SINY1*SINY2)/WW0
         C1(I) = C1(I)*FL(I)  + RHO*(1.-FL(I))
      ELSE IF(UV) THEN
         C1(I) = DY1*DX2*D2RHO+DY1X2*DRHO
         C1(I) = FL(I) * C1(I)*SIGN(1.,-SINY1*SINY2)/(WW0*COSY2)
      ELSE IF(VZ) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DX1*SIGN(1., SINY1)/(SRWW0*COSY1)
      ELSE IF(VU) THEN
         C1(I) = DX1*DY2*D2RHO+DX1Y2*DRHO
         C1(I) = FL(I) * C1(I)*SIGN(1.,-SINY1*SINY2)/(WW0*COSY1)
      ELSE IF(VV) THEN
         C1(I) = DX1*DX2*D2RHO+DX1X2*DRHO
         C1(I) = C1(I)*SIGN(1., SINY1*SINY2)/(WW0*COSY1*COSY2)
         C1(I) = C1(I)*FL(I)  + RHO*(1.-FL(I))
      ENDIF

20    CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    COOR2
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: COMPUTES CHORD LENGTH DISTANCE FOR A MATRIX OF LOCATIONS
C   <(X,Y)I,(X,Y)J> USING THE NORMAL ANGLE  FORMULA:
C     S**2/2 = 1 - COS(Y1-Y2) + COS(Y1)*COS(Y2)*(1-COS(X1-X2))
C   DERIVATIVES OF DISTANCE WITH RESPECT TO LAT AND LON ARE ALSO
C   COMPUTED AND COMBINED WITH APPROPRIATE CORRELATION FUNCTIONS AND
C   DERIVATIVES WITH RESPECT TO DISTANCE TO FORM THE MULTI-VARIATE
C   CORRELATIONS FOR THE HEIGHT WIND ANALYSIS.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORINGIAL AUTHOR
C
C USAGE:    CALL COOR2(NP,CH,FL,TZ,X1,Y1,K1,X2,Y2,K2,D,C1,C2)
C   INPUT ARGUMENT LIST:
C     NP       - NUMBER OF OUTPUTS REQUESTED
C     CH       - VECTOR OF CONSTANTS FOR THE GAUSSIAN LENGTH SCALE
C     X1       - X-COORDINATES (LONGITUDE) FOR POINT 1
C     Y1       - Y-COORDINATES (LATITUDE ) FOR POINT 1
C     K1       - VARIABLE TYPE AT POINT 1  (I.E. 1-Z , 2-U , 3-V)
C     X2       - X-COORDINATES (LONGITUDE) FOR POINT 2
C     Y2       - Y-COORDINATES (LATITUDE ) FOR POINT 2
C     K2       - VARIABLE TYPE AT POINT 2  (I.E. 1-Z , 2-U , 3-V)
C     FL       - DECOUPLING FACTOR
C     TZ       - HEIGHT-TEMPERATURE FACTOR
C
C   OUTPUT ARGUMENT LIST:
C     D        - DISTANCES BETWEEN ARRAYS OF POINTS IN RADIANS
C     C1       - CORRELATION COEFFICIENTS AS SPECIFIED
C     C2       - CORRELATION COEFFICIENTS AS SPECIFIED
C
C REMARKS: THIS PROGRAM COMPUTES A GAUSSIAN CORRELATION WITH
C   LENGTH SCALE GIVEN BY THE CHTWV INPUT ARGUMENT.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE COOR2(NP,CH,FL,TZ,X1,Y1,K1,X2,Y2,K2,D,C1,C2)


      DIMENSION  CH(NP),FL(NP),TZ(NP)
      DIMENSION  X1(NP),Y1(NP),K1(NP)
      DIMENSION  X2(NP),Y2(NP),K2(NP)
      DIMENSION  D (NP),C1(NP),C2(NP)

      LOGICAL ZZ,ZU,ZV,UZ,UU,UV,VZ,VU,VV

      DATA PI180 /.0174532 /, SMIN/.002/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      IF(NP.EQ.0) RETURN

C  LOOP OVER SET OF INPUT POINTS
C  -----------------------------

      DO 20 I=1,NP

      C1(I) = 0.
      C2(I) = 0.

C  DETERMINE CORRELATION TYPE
C  --------------------------

      ZZ = K1(I).EQ.1 .AND. K2(I).EQ.1
      ZU = K1(I).EQ.1 .AND. K2(I).EQ.2
      ZV = K1(I).EQ.1 .AND. K2(I).EQ.3
      UZ = K1(I).EQ.2 .AND. K2(I).EQ.1
      UU = K1(I).EQ.2 .AND. K2(I).EQ.2
      UV = K1(I).EQ.2 .AND. K2(I).EQ.3
      VZ = K1(I).EQ.3 .AND. K2(I).EQ.1
      VU = K1(I).EQ.3 .AND. K2(I).EQ.2
      VV = K1(I).EQ.3 .AND. K2(I).EQ.3

C  COMPUTE THE MATRIX OF SINES AND COSINES
C  ---------------------------------------

      COSY1 = COS(Y1(I)*PI180)
      COSY2 = COS(Y2(I)*PI180)
      SINY1 = SIN(Y1(I)*PI180)
      SINY2 = SIN(Y2(I)*PI180)
      COSDX = COS((X1(I)-X2(I))*PI180)
      COSDY = COS((Y1(I)-Y2(I))*PI180)
      SINDX = SIN((X1(I)-X2(I))*PI180)
      SINDY = SIN((Y1(I)-Y2(I))*PI180)

C  COMPUTE THE NORMAL ANGLE
C  ------------------------

      S = 1.0-COSDY+COSY1*COSY2*(1.0-COSDX)
      S = SQRT(2.*S)

C  CALCULATE THE FIRST PARTIALS WITH RESPECT TO X1 AND Y1
C  ------------------------------------------------------

      SI  =  MAX(S,SMIN)
      SI  =  1./SI
      DY1 =  SI*(SINDY-SINY1*COSY2*(1.0-COSDX))
      DX1 =  SI*(COSY1*COSY2*SINDX)
      DY2 = -SI*(SINDY+COSY1*SINY2*(1.0-COSDX))
      DX2 = -DX1

C  CALCULATE THE MIXED PARTIAL DERIVATIVES
C  ---------------------------------------

      DY1Y2=  SI*(SINY1*SINY2*(1.0-COSDX)-COSDY-DY1*DY2)
      DY1X2=  SI*(SINY1*COSY2*SINDX-DY1*DX2)
      DX1X2= -SI*(COSY1*COSY2*COSDX+DX1*DX2)
      DX1Y2= -SI*(COSY1*SINY2*SINDX+DX1*DY2)

C  COMPUTE THE VARIOUS CORRELATIONS
C  --------------------------------

      RHO   = EXP(-CH(I)*S*S)
      DRHO  = -2.*CH(I)*S*RHO
      D2RHO = -2.*CH(I)*(RHO+S*DRHO)

      WW0   = 2.*CH(I)
      SRWW0 = SQRT(WW0)

      D(I)  = S

      IF(S.LT.SMIN) THEN
         IF(ZZ) C1(I) = 1.
         IF(ZZ) C2(I) = 1.
         IF(UU) C1(I) = 1.
         IF(VV) C1(I) = 1.
         IF(VU) C2(I) = 1.
         D(I) = 0.
      ELSE IF(ZZ) THEN
         C1(I) = RHO
         C2(I) = C1(I)
      ELSE IF(ZU) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DY2*SIGN(1.,-SINY2)/SRWW0
         C2(I) = FL(I)*TZ(I) * DRHO*DX2*SIGN(1., SINY2)/(SRWW0*COSY2)
      ELSE IF(ZV) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DX2*SIGN(1., SINY2)/(SRWW0*COSY2)
         C2(I) = C1(I)
      ELSE IF(UZ) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DY1*SIGN(1.,-SINY1)/SRWW0
         C2(I) = C1(I)
      ELSE IF(UU) THEN
         C1(I) = DY1*DY2*D2RHO+DY1Y2*DRHO
         C1(I) = C1(I)*SIGN(1., SINY1*SINY2)/WW0
         C1(I) = C1(I)*FL(I)  + RHO*(1.-FL(I))
         C2(I) = DY1*DX2*D2RHO+DY1X2*DRHO
         C2(I) = FL(I) * C2(I)*SIGN(1.,-SINY1*SINY2)/(WW0*COSY2)
      ELSE IF(UV) THEN
         C1(I) = DY1*DX2*D2RHO+DY1X2*DRHO
         C1(I) = FL(I) * C1(I)*SIGN(1.,-SINY1*SINY2)/(WW0*COSY2)
         C2(I) = C1(I)
      ELSE IF(VZ) THEN
         C1(I) = FL(I)*TZ(I) * DRHO*DX1*SIGN(1., SINY1)/(SRWW0*COSY1)
         C2(I) = C1(I)
      ELSE IF(VU) THEN
         C1(I) = DX1*DY2*D2RHO+DX1Y2*DRHO
         C1(I) = FL(I) * C1(I)*SIGN(1.,-SINY1*SINY2)/(WW0*COSY1)
         C2(I) = DX1*DX2*D2RHO+DX1X2*DRHO
         C2(I) = C2(I)*SIGN(1., SINY1*SINY2)/(WW0*COSY1*COSY2)
         C2(I) = C2(I)*FL(I)  + RHO*(1.-FL(I))
      ELSE IF(VV) THEN
         C1(I) = DX1*DX2*D2RHO+DX1X2*DRHO
         C1(I) = C1(I)*SIGN(1., SINY1*SINY2)/(WW0*COSY1*COSY2)
         C1(I) = C1(I)*FL(I)  + RHO*(1.-FL(I))
         C2(I) = C1(I)
      ENDIF

20    CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    DRCTSL
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: DRIVER FOR CHOLESKY TYPE LINEAR EQUATION SOLVER.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL DRCTSL(FA,RA,DP,NDIM,NXXYY)
C   INPUT ARGUMENT LIST:
C     FAALL    - ARRAY OF SYMMETRIC MATRIXES
C     RAALL    - ARRAY OF MATRIX RIGHT HAND SIDES
C     NDIM     - ARRAY OF MATRIX RANKS
C     MAXDIM   - MAXIMUM RANK MATRIX IN MATRIX ARRAY
C     NXXYY    - NUMBER OF MATRIXES IN MATRIX ARRAY
C     NFT      - NUMBER OF RIGHT HAND SIDE VECTORS PER MATRIX
C   OUTPUT ARGUMENT LIST:
C     RAALL    - ARRAY OF MATRIX SOLUTIONS
C     DOTPRD   - ARRAY OF DOT PRODUCTS OF RHS VECTORS WITH MATRIX
C                SOLUTIONS
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C REMARKS: ILL CONDITIONED OR NON POSITIVE DEFINITE MATRIXES ARE
C   IDENTIFIED BY DOT PRODUCTS GT 1 OR LT 0 OR BY A MESSAGE FROM
C   VSOLVE. FIVE ATTEMPTS ARE MADE TO SOLVE BAD ONES, BY RIDGE
C   REGRESSION, AFTER WHICH A NULL SOLUTION IS RETURNED.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE DRCTSL(FA,RA,DP,NDIM,NXXYY)

      PARAMETER( NMX  =  64        ,
     .           NN   =  10*(10+1)/2 ,
     .           N    =  10          )

      DIMENSION FA(NMX,NN), RA(NMX,N,2),  DP(NMX,2), NDIM(NXXYY)
      DIMENSION A (NMX,NN), B (NMX,N,2)
      DIMENSION BAD(NMX), SMOOTH(6)
      LOGICAL   BAD

      DATA SMOOTH /1.00,1.01,1.02,1.05,1.10,2.00/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

C  LOOP FOR POSSIBILITY OF BAD MATRIXS
C  -----------------------------------

      DO 50 ITRY=1,6
      NBAD = 0

C  FIND THE LARGEST MATRIX IN THE STACK
C  ------------------------------------

      MAXDIM = 0
      DO 5 I=1,NXXYY
      MAXDIM = MAX(MAXDIM,NDIM(I))
5     CONTINUE

      IF(MAXDIM.EQ.0) RETURN

C  INITIALIZE THE WORKING ARRAYS
C  -----------------------------

      DO 10 J=1,MAXDIM*(MAXDIM+1)/2
      DO 10 I=1,NXXYY
      A(I,J) = FA(I,J)
10    CONTINUE

      DO 11 J=1,MAXDIM
      DO 11 I=1,NXXYY
      B(I,J,1) = RA(I,J,1)
      B(I,J,2) = RA(I,J,2)
11    CONTINUE

      DO 12 I=1,NXXYY
      DP(I,1) = 0.
      DP(I,2) = 0.
12    CONTINUE

      DO 13 J=1,MAXDIM
      JJ = J*(J+1)/2
      DO 13 I=1,NXXYY
      A(I,JJ) = FA(I,JJ)*SMOOTH(ITRY)
13    CONTINUE

C  CALL THE MATRIX SOLVER
C  ----------------------

      CALL VSOLVE (A,B,NDIM,BAD,NXXYY,MAXDIM)

C  MAKE THE DOT PRODUCTS OF SOLUTIONS WITH RIGHT HAND SIDES
C  --------------------------------------------------------

      DO 20 J=1,MAXDIM
      DO 20 I=1,NXXYY
      DP(I,1) = DP(I,1) + RA(I,J,1)*B(I,J,1)
      DP(I,2) = DP(I,2) + RA(I,J,2)*B(I,J,2)
20    CONTINUE

C  NORMALIZE THE WEIGHTS IF THEY ARE TOO BIG
C  -----------------------------------------

      DO 25 I=1,NXXYY
      IF(DP(I,1).GT.1. .OR. DP(I,2).GT.1.) THEN
         DO 24 J=1,MAXDIM
         B(I,J,1) = B(I,J,1)/DP(I,1)
         B(I,J,2) = B(I,J,2)/DP(I,2)
24       CONTINUE
         DP(I,1) = 1.
         DP(I,2) = 1.
      ENDIF
25    CONTINUE

C  CHECK FOR BAD ONES - DO IT AGAIN IF NECESSARY
C  ---------------------------------------------

      DO 30 I=1,NXXYY
      BAD(I) = BAD(I) .OR. DP(I,1).LT.0. .OR. DP(I,2).LT.0.
      BAD(I) = BAD(I) .OR. DP(I,1).GT.1. .OR. DP(I,2).GT.1.
30    CONTINUE

      DO 40 I=1,NXXYY
      IF(BAD(I)) THEN
         DP(I,1) = 0.
         DP(I,2) = 0.
         DO 35 J=1,MAXDIM
         B(I,J,1) = 0.
         B(I,J,2) = 0.
35       CONTINUE
         NBAD = NBAD + 1
      ENDIF
40    CONTINUE

      IF(NBAD.NE.0) PRINT*, 'NBAD=',NBAD,' ON TRY ',ITRY
      IF(NBAD.EQ.0) GOTO 55

50    CONTINUE

C  COPY SOLUTIONS INTO OUTPUT ARRAY - ZERO BAD ONES OUT
C  ----------------------------------------------------

55    DO 60 J=1,MAXDIM
      DO 60 I=1,NXXYY
      RA(I,J,1) = B(I,J,1)
      RA(I,J,2) = B(I,J,2)
60    CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GETFCER
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1992-07-29
C
C ABSTRACT: FUNCTION WHICH RETURNS A FORECAST ERROR IN THE FORCAST
C   HEIGHT OR WIND FIELD FOR A GIVEN LAT, LON, PRESSURE. ENTRY POINTS
C   GETZER AND GETWER RETURN ERROR VALUES; GETFCER RETURNS 0.
C
C PROGRAM HISTORY LOG:
C 1992-07-29  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL GETZER(SLAT,SLON,PRES)  -  (RETURNS HEIGHT ERROR)
C           CALL GETWER(SLAT,SLON,PRES)  -  (RETURNS WIND   ERROR)
C   INPUT ARGUMENT LIST:
C     SLAT     - LATITUDE
C     SLON     - LONGITUDE
C     PRES     - PRESSURE
C
C   FUNCTION RETURN VALUE:
C     GETZER   - FORECAST HEIGHT ERROR
C     GETWER   - FORECAST WIND   ERROR
C
C REMARKS: NONE.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      FUNCTION GETFCER(SLAT,SLON,PRES)

      COMMON /OBERRS/ QIKE(21,300),PMAND(21),P50(21),CHL(21)
      COMMON /CORP  / CHLP(1500),CVC,FFLAT(91),IFA(10,10)
      COMMON /FCRATS/ RATION(21),RATIOS(21),TROPUV(21)

      LOGICAL WIND

      DATA PI180 /  .0174532  /
      DATA OMEGA /  .72921E-4 /
      DATA RADE  / 6.371E6    /
      DATA GRAV  / 9.8        /

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      GETFCER = 0.
      RETURN

      ENTRY GETZER(SLAT,SLON,PRES)
      WIND = .FALSE.
      GOTO 10

      ENTRY GETWER(SLAT,SLON,PRES)
      WIND = .TRUE.

C  COMPUTE A HEIGHT ERROR PROPORTIONAL TO RAWINSONDE ERROR
C  -------------------------------------------------------

10    RAWZER = PILNLNP(PRES,PMAND,QIKE(1,120),21)

      IF(SLAT.LT.0.) THEN
         ZER = RAWZER/SQRT(PILNLNP(PRES,PMAND,RATIOS,21)) * 1.1
      ELSE
         ZER = RAWZER/SQRT(PILNLNP(PRES,PMAND,RATION,21))
      ENDIF

      IF(.NOT.WIND) THEN
         GETZER = ZER
         RETURN
      ENDIF

C  COMPUTE THE GEOSTROPHIC WIND ERROR FOR GETWER
C  ---------------------------------------------

      TRPWER = PILNLNP(PRES,PMAND,TROPUV,21)
      SRWW0  = SQRT(2.0*CHLP(MAX(IFIX(PRES),1)))
      IF(SLAT.EQ.0.) ALPHA = 0.
      IF(SLAT.NE.0.) ALPHA  = GRAV/(2.*OMEGA*SIN(ABS(SLAT)*PI180)*RADE)
      IY = ABS(SLAT)+1.5
      G = FFLAT(IY)
      GETWER = G*ZER*ALPHA*SRWW0 + (1-G)*TRPWER

      RETURN
      END
C-----------------------------------------------------------------------
C
C-----------------------------------------------------------------------
      SUBROUTINE MAKEAMAP

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      REAL*8 SID

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

C  MAKE SURE NONE OF THE LONGITUDES EQUAL 360.
C  -------------------------------------------

      DO 1 N=1,NREP
      IF(FLN(N).EQ.360.) FLN(N) = 0.
1     CONTINUE

C  LONGITUDE SORT
C  --------------

      NN = 0
      DO 10 NX=1,360
      DO 10 N=1,NREP
      IX = FLN(N)+1.
      IF(IX.EQ.NX) THEN
         NN = NN+1
         INDD(NN) = N
      ENDIF
10    CONTINUE

C  LATITUDE SORT
C  -------------

      NOB = 0
      DO 20 NY=1,181
      DO 20 N=1,NN
      IY = FLT(INDD(N))+91.
      IF(IY.EQ.NY) THEN
         NOB = NOB+1
         INOB(NOB) = INDD(N)
      ENDIF
20    CONTINUE

C  CHECK TO MAKE SURE ALL REPS ARE ACCOUNTED FOR
C  ---------------------------------------------

      IF(NREP.NE.NN .OR. NREP.NE.NOB) THEN
         PRINT*
         PRINT*,'*****************************************************'
         PRINT*,'** WARNING*WARNING*WARNING*WARNING*WARNING*WARNING **'
         PRINT*,'*****************************************************'
         PRINT*,'** IN MAKEAMAP ALL REPORTS HAVE NOT BEEN PROCESSED **'
         PRINT*,'*****************************************************'
         PRINT*,'** WARNING*WARNING*WARNING*WARNING*WARNING*WARNING **'
         PRINT*,'*****************************************************'
         PRINT*
      ENDIF

C  INITIALIZE IMAP ARRAY
C  ---------------------

      IMAP = 0

      DO 30 N=1,NOB
      NX = FLN(INOB(N)) + 1.
      NY = FLT(INOB(N)) + 91.
      IF(IMAP(NX,NY).EQ.0) IMAP(NX,NY) = N
30    CONTINUE

C  FILL GAPS IN IMAP FOR CONTINUITY (BACKWARDS)
C  --------------------------------------------

      LASTN = NOB
      DO 40 NY=181,1,-1
      DO 40 NX=360,1,-1
      IF(IMAP(NX,NY).EQ.0) THEN
         IMAP(NX,NY) = LASTN
      ELSE
         LASTN = IMAP(NX,NY)
      ENDIF
40    CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    OBOGRAM
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: EXAMINES THE RESULTS OF FINAL QC DECISIONS AND MAKES TABLES
C   OF STATISTICS FOR ACCEPTED AND REJECTED REPORTS BY REPORT TYPE AND
C   LEVEL.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL OBOGRAM(LDAT,LASC,LBIN)
C   INPUT ARGUMENT LIST:
C     LDAT     - LOGICAL UNIT FOR NCEP PRODUCTION DATE FILE
C     LASC     - LOGICAL UNIT FOR OUTPUT ASCII FILE
C     LBIN     - LOGICAL UNIT FOR OUTPUT BINARY FILE
C
C   INPUT FILES:
C     UNIT LDAT  - NCEP PRODUCTION DATE FILE
C
C   OUTPUT FILES:
C     UNIT 06    - STANDARD OUTPUT PRINT
C     UNIT LASC  - SUMMARY OF QC RESULTS (ASCII)
C     UNIT LBIN  - SUMMARY OF QC RESULTS (BINARY)
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE OBOGRAM(LDAT,LASC,LBIN)

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /OBERRS/ QIKE(21,300),PMAND(21),P50(21),CHL(21)

      CHARACTER*3 AR(2),TAG
      DIMENSION STAT(300,15,6,2,2,3),IOBS(300),RZONE(6)
      LOGICAL QOBS(300,6)
      REAL*8 SID

      DATA AR/'ACC','REJ'/
      DATA XMSG/32767./

C----------------------------------------------------------------------
C-----------------------------------------------------------------------

      REWIND (LDAT)
      READ(LDAT,1) NMCDATE
1     FORMAT(8X,I8)
      WRITE(LASC,*)
      WRITE(LASC,*)' STATS FOR OBS CHECKED ',NMCDATE
      WRITE(LASC,*)

C  START UP
C  --------

      QOBS = .FALSE.
      STAT = 0

C  GO THROUGH THE BIG BUFFER TO COUNT OBS FOR OBOGRAM
C  --------------------------------------------------

      DO 10 IREP=1,NREP
      X     = FLN(IREP)
      Y     = FLT(IREP)
      KX    = FKX(IREP)
      KK    = KX/100
      LB    = MIN(IFIX((Y+90.)/30.+1.),6)

      TAG   = FOC(IREP)
      IF(TAG.EQ.'SFC')  FNL(IREP) = 2

      ILEV  = FLV(IREP)
      KLEV  = ILEV+FNL(IREP)-1

C  GO THROUGH LEVELS FOR ACCEPT REJECT STATISTICS
C  ----------------------------------------------

      DO 10 JLEV=ILEV,KLEV
      IF(FOI(JLEV).NE.0) THEN

         IF(FOI(JLEV).EQ.1) THEN
            IAR = 1
         ELSE IF(FOI(JLEV).EQ.-1) THEN
            IAR = 2
         ELSE
            GOTO 10
         ENDIF

         BUFF11 = FOB(JLEV,1)
         BUFF12 = FOB(JLEV,2)

         IF(TAG.EQ.'SFC' .AND. JLEV.EQ.KLEV) THEN
            KX = KX - 100
         ELSE
            IF(KK.EQ.1) BUFF12 = BUFF11
         ENDIF

         QOBS(KX,LB) = .TRUE.

         PP = FPR(JLEV)

         DO 5 L=1,15
         IF(L.EQ.1) THEN
            IF(PP.GT.(PMAND(L)+PMAND(L+1))/2.) GOTO 6
         ELSE IF(L.EQ.15) THEN
            IF(PP.LE.(PMAND(L)+PMAND(L-1))/2.) GOTO 6
         ELSE
            IF(PP.GT.(PMAND(L)+PMAND(L+1))/2. .AND.
     .         PP.LE.(PMAND(L)+PMAND(L-1))/2.) GOTO 6
         ENDIF
5        CONTINUE
         PRINT *, 'OBOGRAM - UNABLE TO LOCATE DATA LEVEL'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
6        CONTINUE

         IF(KK.EQ.1) THEN
            STAT(KX,L,LB,IAR,1,1) = STAT(KX,L,LB,IAR,1,1) + 1.
            STAT(KX,L,LB,IAR,1,2) = STAT(KX,L,LB,IAR,1,2) + BUFF12
            STAT(KX,L,LB,IAR,1,3) = STAT(KX,L,LB,IAR,1,3) + BUFF12**2
         ELSE
            STAT(KX,L,LB,IAR,1,1) = STAT(KX,L,LB,IAR,1,1) + 1.
            STAT(KX,L,LB,IAR,1,2) = STAT(KX,L,LB,IAR,1,2) + BUFF11
            STAT(KX,L,LB,IAR,1,3) = STAT(KX,L,LB,IAR,1,3) + BUFF11**2
            STAT(KX,L,LB,IAR,2,1) = STAT(KX,L,LB,IAR,2,1) + 1.
            STAT(KX,L,LB,IAR,2,2) = STAT(KX,L,LB,IAR,2,2) + BUFF12
            STAT(KX,L,LB,IAR,2,3) = STAT(KX,L,LB,IAR,2,3) + BUFF12**2
         ENDIF

      ENDIF

10    CONTINUE

C  COMPUTE THE AVERAGES FOR MEAN AND RMS'S (VECTOR SUMS FOR WINDS)
C  ---------------------------------------------------------------

      DO 20 KX=1,299
      KK = MAX(KX/100,1)
      DO 20 L=1,15
      DO 20 LB=1,6
      DO 20 IAR=1,2
      DO 20 KKX=1,KK
      N = STAT(KX,L,LB,IAR,KKX,1)
      IF(N.NE.0) THEN
         BIAS = STAT(KX,L,LB,IAR,KKX,2)/N
         STAT(KX,L,LB,IAR,KKX,2) = BIAS
         RMS  = SQRT(STAT(KX,L,LB,IAR,KKX,3)/N)
         STAT(KX,L,LB,IAR,KKX,3) = RMS
         IF(KKX.EQ.2) THEN
         STAT(KX,L,LB,IAR,1,2) = SQRT(STAT(KX,L,LB,IAR,1,2)**2+BIAS**2)
         STAT(KX,L,LB,IAR,1,3) = SQRT(STAT(KX,L,LB,IAR,1,3)**2+ RMS**2)
         ENDIF
      ENDIF
20    CONTINUE

C  PRINT THE TOTAL, MEAN, AND RMS FOR ACCEPTS AND REJECTS
C  ------------------------------------------------------

      DO 35 KX=1,300
      DO 35 LB=1,6
      IF(QOBS(KX,LB)) THEN
         KK = KX/100
         WRITE(LASC,*)'------ZONE ',LB,' KX ',KX,' VAR ',KK,'------'
         DO 30 IAR=1,2
         WRITE(LASC,2000) AR(IAR),(STAT(KX,L,LB,IAR,1,1),L=1,15)
         WRITE(LASC,2001) AR(IAR),(STAT(KX,L,LB,IAR,1,2),L=1,15)
         WRITE(LASC,2002) AR(IAR),(STAT(KX,L,LB,IAR,1,3),L=1,15)
         WRITE(LASC,2003)
30       CONTINUE
      ENDIF
35    CONTINUE

C  PRINT THE TOTAL REJECTED OB BY TYPE ZONE LEVEL
C  ----------------------------------------------

      WRITE(LASC,*)
      WRITE(LASC,*) ' NUMBER OF OBS REJECTED BY OB TYPE, AND ZONE'
      WRITE(LASC,*)

      DO 45 KX=1,300
      IF(QOBS(KX,1).OR.QOBS(KX,2).OR.QOBS(KX,3).OR.QOBS(KX,4).OR.
     .   QOBS(KX,5).OR.QOBS(KX,6)) THEN
         RZONE = 0
         DO 40 LB=1,6
         DO 40 L=1,15
         RZONE(LB) = STAT(KX,L,LB,2,1,1) + RZONE(LB)
40       CONTINUE
         WRITE(LASC,2004)KX,(RZONE(LB),LB=1,6)
      ENDIF
45    CONTINUE

C  WRITE A BINARY VERSION OF THE OBOGRAM
C  -------------------------------------

      I = 0
      DO 55 KX=1,300
      DO 50 LB=1,6
      IF(QOBS(KX,LB)) THEN
         I = I+1
         IOBS(I) = KX
         GOTO 55
      ENDIF
50    CONTINUE
55    CONTINUE

      WRITE(LBIN) NMCDATE,
     .          I,(IOBS(II),((((STAT(IOBS(II),LEV,LB,IAR,1,IST),
     .          LEV=1,15),
     .          IST=1,3),
     .          IAR=1,2),
     .          LB=1,6),
     .          II=1,I)

C  FORMAT STATEMENTS FOR THE OBOGRAM
C  ---------------------------------

2000  FORMAT('TOTAL ',A3,15F6.1)
2001  FORMAT('MEAN  ',A3,15F6.1)
2002  FORMAT('RMS   ',A3,15F6.1)
2003  FORMAT('        ')
2004  FORMAT(I5,6F8.1)

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    OUTPUT
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: EXAMINES OUTPUTS FROM OI QUALITY CONTROL INTERPOLATION AND
C   MAKES DECISION WHETHER AN OB PASSES OR FAILS THE CHECKS. ALSO
C   PROVIDES FOR A DETAILED PRINT TRACING ALL DECISIONS MADE IN REGARD
C   TO SPECIFIED OBSERVATIONS IN THE QC PROCESS.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL OUTPUT
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 71  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 72  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 73  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 74  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 75  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 76  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 77  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 78  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 79  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT 80  - DETAILED PRINTOUTS FOR QC DIAGNOSIS (IPOINT IN UNIT 18)
C     UNIT ITUNIT  - DETAILED TOSSLIST (SEE REMARKS)
C
C REMARKS: POSSIBLE VALUES FOR ITUNIT (PASSED IN VIA COMMMON
C   /TOSSUNIT/):
C     61 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR SURFACE HEIGHTS
C     62 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR TEMPS AND WINDS
C     63 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR SAT TEMPS
C     64 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR SSMI WIND SPEEDS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE OUTPUT

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC

      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WT(64,10,4,2),
     .                     FE(64,3)

      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /TOLLER  / ITER,TB,TZ,TSAT,TWND,TJET
      COMMON /OBPRT   / NPT,SIDP(10),PRP(10),KXP(10)
      COMMON /TOSSUNIT/ ITUNIT


      DIMENSION IOMF(3),D(4),DRES(4),NDIM(4),STR(2)
      DIMENSION DU(4),DV(4),TWT(4),TWU(4),TWV(4)
      CHARACTER*8 CKEEP,CHECK(5)
      CHARACTER*3 TAG
      CHARACTER*1 VAR2(2),VAR3(3)
      LOGICAL KEEP
      REAL*8 SID,CKSTA

      DATA CHECK/'Z MATRIX','U MATRIX','V MATRIX','VERTICAL','MULTIVAR'/
      DATA VAR2 / 'Z' , 'W' /
      DATA VAR3 / 'Z' , 'U' , 'V' /
      DATA IOMF /  2  ,  1  ,  2  /


      CHARACTER*1 PLUMIN
      DATA PI180/.017453/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      D   = 0.
      DU  = 0.
      DV  = 0.
      TWT = 0.
      TWU = 0.
      TWV = 0.

C  LOOP OVER EACH OB CHECKED IN THIS GROUP
C  ---------------------------------------

      DO 50 N=1,NXXYY
      I     = MCHK(N,1)
      J     = MCHK(N,2)
      II    = FHD(I)
      PRES  = FPR(I)
      OBER  = FOE(I)
      CKSTA = SID(II)
      CLON  = FLN(II)
      CLAT  = FLT(II)
      KX    = FKX(II)
      TAG   = FOC(II)

C  LOOK FOR A KEEP FLAG
C  --------------------

      IQM = FQM(I)
      IF(IQM.EQ.0) THEN
         KEEP  = .TRUE.
         CKEEP = '  KEEP'
      ELSE
         KEEP = .FALSE.
         CKEEP = ' '
      ENDIF

C  LOOP OVER THE VARIABLE(S) IN EACH OB
C  ------------------------------------

      DO 45 K=J,2*J-1
      KK     = K-J+1
      OMF    = FOB(I,IOMF(K))
      AMFSUM = 0.
      SUMWTS = 0.
      QC     = 0.

C  LOOP OVER THE OUTCOME OF EACH TYPE OF CHECK (MICRO DECISION MAKER)
C  ------------------------------------------------------------------

      DO 20 L=1,4
      AER = AE(N,L,KK)
      FER = FE(N,K)
      AMF = AA(N,L,KK)
      DRES(L) = OMF-AMF
      D(L) = DRES(L)/SQRT(OBER**2+AER**2)
      AWT = 1.-(AER/FER)**2
      TWT(L) = MAX(.01,AWT)
      QC     = QC     + TWT(L)*D(L)**2
      SUMWTS = SUMWTS + TWT(L)
      IF(L.LT.4) AMFSUM = AMFSUM + TWT(L)*AMF
20    CONTINUE

      AMFSUM = AMFSUM/(SUMWTS-TWT(4))
      QC     = SQRT(QC/SUMWTS)
      TWT    = TWT/SUMWTS

C  FOR WINDS CHECK THE VECTOR SUM OF AGAINST THE REFERENCE
C  -------------------------------------------------------

      IF(K.EQ.1) THEN
         OMA = OMF - AMFSUM
      ELSE
         IF(K.EQ.2) THEN
            DU  = D
            TWU = TWT
            QCU = QC
            OMAU = OMF - AMFSUM
            OMFU = OMF
            GOTO 45
         ELSE IF(K.EQ.3) THEN
            DV   = D
            TWV  = TWT
            QCV  = QC
            OMAV = OMF - AMFSUM
            OMFV = OMF
            D    = SQRT(DU**2+DV**2)
            TWT  = SQRT(TWU**2+TWV**2)
            QC   = SQRT(QCU**2+QCV**2)
            OMA  = SQRT(OMAU**2+OMAV**2)
            OMF  = SQRT(OMFU**2+OMFV**2)
         ELSE
            PRINT *, 'OUTPUT - K<>1,2,OR,3'
            CALL W3TAGE('PREPOBS_OIQCBUFR')
            CALL ERREXIT(99)
         ENDIF
      ENDIF

C  ADJUST THE TOLERANCE BY LOCATION AND VARIABLE
C  ---------------------------------------------

      IF(K.EQ.1) THEN
         SINLAT = (SIN(ABS(CLAT)*PI180))
         TT = TB*TZ*SINLAT
         TMIN = 2.0
      ELSE
         GNP = MIN(ABS(CLAT/30.),1.)
         IF(PRES.LE.400. .AND. PRES.GE.150.) THEN
            TT = TB*TJET*GNP
         ELSE
            TT = TB*TWND*GNP
         ENDIF
         TMIN = 3.
      ENDIF

      TT = MAX(TMIN,TT)

      IF(TAG.EQ.'SMI') TT = TT/SQRT(2.)

C  COMPUTE THE MULTIVARIATE REDUCTION RATIO AND ADJUST THE SUM
C  -----------------------------------------------------------

      IF(OMF.NE.0.) THEN
         QCPC = MIN(MAX(ABS(OMA/OMF),.1),1.)
         TTT = TT/QCPC
      ELSE
         TTT = TT
      ENDIF

C  COMPUTE THE NORMALIZED DEVIATION FROM THE FIRST GUESS
C  -----------------------------------------------------

      SDOMF = SQRT(OMF**2/(OBER**2+FER**2))

C  MAKE A MESO DECISION FOR THIS ITERATION
C  ---------------------------------------

      IF(QC.GT.TTT) THEN
         KEEP = KEEP .AND. QC.LT.25.
         IF(.NOT.KEEP) THEN
            FOI(I) = -1
            PLUMIN = '-'
         ELSE
            FOI(I) = 1
            PLUMIN = '+'
         ENDIF
         WRITE(ITUNIT,100)CKSTA,KX,CLON,CLAT,PRES,VAR2(J),OMF,SDOMF,
     .                    (D(L),TWT(L),L=1,4),QC,TTT,CKEEP,PLUMIN
      ELSE
         FOI(I) = 1
         PLUMIN = '+'
      ENDIF

C  THIS WRITES DETAILED INFO ABOUT AN OB
C  -------------------------------------

      DO 41 NN=1,NPT
      LU = 70 + NN
      pdif = abs(pres-prp(nn))
      IF(CKSTA.EQ.SIDP(NN).AND.pdif.lt..1.AND.KX.EQ.KXP(NN)) THEN
         WRITE(LU,100)CKSTA,KX,CLON,CLAT,PRES,VAR2(J),OMF,SDOMF,
     .                (D(L),TWT(L),L=1,4),QC,TTT,CKEEP,PLUMIN
         DO 44 KK=J,J*2-1
         WRITE(LU,*) 'ITERATION=',ITER,' CHECK ON ',VAR3(KK)
         IF(KK.EQ.2) THEN
            SDOMF = SQRT(OMFU**2/(OBER**2+FER**2))
            IF(TT.EQ.TTT) TTTT = TT
            IF(TT.NE.TTT) TTTT = TT/ABS(OMAU/OMFU)
            WRITE(LU,100)CKSTA,KX,CLON,CLAT,PRES,VAR3(KK),OMFU,SDOMF,
     .                   (DU(L),TWU(L),L=1,4),QCU,TTTT,CKEEP
         ELSE IF(KK.EQ.3) THEN
            SDOMF = SQRT(OMFV**2/(OBER**2+FER**2))
            IF(TT.EQ.TTT) TTTT = TT
            IF(TT.NE.TTT) TTTT = TT/ABS(OMAV/OMFV)
            WRITE(LU,100)CKSTA,KX,CLON,CLAT,PRES,VAR3(KK),OMFV,SDOMF,
     .                   (DV(L),TWV(L),L=1,4),QCV,TTTT,CKEEP
         ENDIF
         DO 44 L=1,4
         WRITE(LU,*)CHECK(L),' FOR CHECK ON ',VAR3(KK),' DATUM '
         SOINC = 0.
         DO 43 IOB=1,MDIM(N,L)
         ILEV = MOBS(N,IOB,L,1)
         KIV  = MOBS(N,IOB,L,2)
         KI2  = MAX(KIV-1,1)
         IREP = FHD(ILEV)
         X  = FLN(IREP)
         Y  = FLT(IREP)
         KIX  = FKX(IREP)
         PPP  = FPR(ILEV)
         OMF0 = FOB(ILEV,IOMF(KIV))
         OIWT = WT(N,IOB,L,KI2)
         OINC = OIWT*OMF0
         OMA0 = AA(N,L,KI2)
         AER0 = AE(N,L,KI2)
         WRITE(LU,102)SID(IREP),KIX,X,Y,PPP,VAR3(KIV),OMF0,OIWT,OINC,
     .                OMA0,AER0
         SOINC  = SOINC+OINC
 43      CONTINUE
         WRITE(LU,*) 'INTERPOLATED VALUE=',SOINC
 44      CONTINUE
      ENDIF
 41   CONTINUE


45    CONTINUE
50    CONTINUE

100   FORMAT(A8,I4,2F7.2,F8.2,A4,2F8.2,4(' *',F6.1,' (',F5.2,')' ),
     .       ' *',2F6.2,A6,A1)
101   FORMAT(A8,I4,2F7.2,F8.2,A4,2F8.2,4(' *',F6.1,2X,I2),' *',2F6.2,A6,
     . A1)
102   FORMAT(A8,I4,2F7.2,F8.2,A4,6F8.2)

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION  BLOCK
C
C SUBPROGRAM:    PILNLNP
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1992-07-29
C
C ABSTRACT: FUNCTION WHICH GIVEN AN PROFILE OF DESCENDING PRESSURES AND
C   A PROFILE OF QUANTITIES VALID AT THOSE PRESSURES, RETURNS AN
C   INTERPOLATED QUANTITY VALID AT A GIVEN ARBITRARY PRESSURE.
C
C PROGRAM HISTORY LOG:
C 1986-03-21  G. DIMEGO  - ORINIGAL AUTHOR
C 1988-11-24  D. DEAVEN  - RECODED FOR CYBER 205
C 1992-07-29  J. WOOLLEN - UPDATED FOR OIQC
C
C USAGE:    CALL = PILNLNP(P,PARAY,QARAY,KMAX)
C   INPUT ARGUMENT LIST:
C     P        - PRESSURE TO INTERPOLATE TO
C     PARAY    - GIVEN PRESSURE PROFILE
C     QARAY    - QUANTITIES VALID FOR PRESSURE PROFILE
C     KMAX     - LENGTH OF PROFILE
C
C   FUNCTION RETURN VALUE
C     PILNLNP  - INTERPOLATED QUANTITY
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      FUNCTION PILNLNP(P,PARAY,QARAY,KMAX)

      DIMENSION PARAY(KMAX),QARAY(KMAX)

      DO 10 LA=1,KMAX
      IF(P.GE.PARAY(LA)) GOTO 11
10    CONTINUE
11    IF(LA.GT.KMAX) THEN
         LA = KMAX
         LB = KMAX
      ELSE IF(LA.EQ.1) THEN
         LA = 1
         LB = 1
      ELSE
         LB = LA-1
      ENDIF
      PA = PARAY(LA)
      PB = PARAY(LB)
      IF(PA.NE.PB) THEN
         WK = LOG(P/PB) / LOG(PA/PB)
      ELSE
         WK = 0.
      ENDIF
      PILNLNP = QARAY(LB) + (QARAY(LA)-QARAY(LB)) * WK

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    PREPQM
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 2013-03-26
C
C ABSTRACT: REWRITES THE PREPBUFR FILE WITH UPDATED QUALITY MARKS.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C 2013-03-26  J. WOOLLEN  INITIAL PORT TO WCOSS: FIX ADDRESSING
C         ALIGNMENT PROBLEM WHEN THE LAST BUFR MESSAGE CONTAINS NO DATA
C         WHICH IS OIQC PROCESSED
C
C USAGE:    CALL PREPQM(LUBIN,LUBOT)
C   INPUT ARGUMENT LIST:
C     LUBIN    - LOGICAL UNIT FOR OBSERVATION (PREPBUFR) PRIOR TO
C                UPDATED QUALITY MARKS
C     LUBOT    - LOGICAL UNIT FOR OBSERVATION (PREPBUFR) WITH UPDATED
C                QUALITY MARKS
C
C   INPUT FILES:
C     UNIT LUBIN - OBSERVATION (PREPBUFR) PRIOR TO UPDATED QUALITY
C                  MARKS
C
C   OUTPUT FILES:
C     UNIT 06    - STANDARD OUTPUT PRINT
C     UNIT LUBOT - OBSERVATION (PREPBUFR) FILE WITH UPDATED QUALITY
C                  MARKS
C
C REMARKS: NONE.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE PREPQM(LUBIN,LUBOT)
 
      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC
 
 
      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /DATAZZ/ KLEV,HDR(5),
     .                OBS(8,255),QMS(6,255),PCS(6,255),RCS(6,255),
     .                OBE(8,255),QME(6,255),OES(6,255),FES(6,255),
     .                FCS(7,255)
 
      CHARACTER*30 OSTR,QSTR,PSTR,RSTR
      CHARACTER*8  SUBSET
      CHARACTER*3  TAG
      LOGICAL      EVENT1,EVENTN,SMI,SFC
      REAL*8       OBS,QMS,OBE,QME,PCS,RCS,SID
 
      DATA OSTR /'POB TOB UOB VOB QOB'/
      DATA QSTR /'PQM TQM WQM NUL QQM'/
      DATA PSTR /'PPC TPC WPC NUL QPC'/
      DATA RSTR /'PRC TRC WRC NUL QRC'/
 
      DATA VMAX /10E10/
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
 
      PRINT*
      PRINT*,'******WRITE THE PREPBUFR FILE*******'
      PRINT*
 
C  OPEN THE INPUT AND OUTPUT FILES
C  -------------------------------
 
C     CALL OPENBF(LUBIN,'IN',LUBIN)
      CALL UFBQCD(LUBIN,'OIQC',IQCD)
      CALL OPENBF(LUBOT,'OUT',LUBIN)
      CALL MAXOUT(50000)     !IG
      imsg = 1
      irec = 1
      ifld = 1
 
C  LOOP OVER THE OBS CHECKED BY OIQC
C  ---------------------------------
 
      DO 100 ILEV=1,NLEV
 
      IREP = FHD(ILEV)
      OBM  = FOI(ILEV)
      TAG  = FOC(IREP)
      KX   = FKX(IREP)
      QM   = FQM(ILEV)
 
      SFC = TAG.EQ.'SFC'
      SMI = TAG.EQ.'SMI'
 
      JREC = FPRC(ILEV)
      JFLD = FPFD(ILEV)
      JLEV = FPLV(ILEV)
 
      IF(SFC.AND.FLV(IREP).NE.ILEV) THEN
         JUPD = 1
      ELSE
         JUPD = KX/100+1
      ENDIF
 
C  SEE IF THERE IS AN EVENT TO WRITE AND WHICH KIND IT WOULD BE
C  ------------------------------------------------------------
 
      QMN = QM
      IF(OBM.EQ.-1 .AND. QM.GE.0 .AND. QM.LE.3) QMN = QM + 4
      IF(OBM.EQ. 1 .AND. QM.GE.4 .AND. QM.LE.7) QMN = QM - 4
 
      EVENT1 = QMN.NE.QM .OR. SMI
      EVENTN = EVENT1 .AND. IREC.EQ.JREC .AND. IFLD.EQ.JFLD
      EVENT1 = EVENT1 .AND. .NOT.EVENTN

C-----------------------------------------------------------------------
C  DECIDE HOW TO PROCEED FOR THIS OB/EVENT:
C     IF THE FIRST OB, SYNCHRONIZE THE FILES;
C     IF A SUBSEQUENT OB:
C        FOR THE FIRST EVENT IN A REPORT, POSITION THE OUTPUT FILE
C        FOR SUBSEQUENT EVENTS IN A REPORT, SKIP THE POSITIONING
C        FOR NO EVENT AT ALL, CONTINUE THE LOOP
C-----------------------------------------------------------------------
 
      IF(ILEV.EQ.1) GOTO 49
      IF(EVENT1   ) GOTO 10
      IF(EVENTN   ) GOTO 50
      IF(ILEV.LT.NLEV) CYCLE
 
C  FLUSH A COMPLETED SET OF EVENTS BEFORE POSITIONING THE OUTPUT FILE
C  ------------------------------------------------------------------
 
10    CONTINUE
      CALL UFBINT(LUBOT,OBE,8,KLEV,IRET,OSTR)
      CALL UFBINT(LUBOT,QME,6,KLEV,IRET,QSTR)
      CALL UFBINT(LUBOT,PCS,6,KLEV,IRET,PSTR)
      CALL UFBINT(LUBOT,RCS,6,KLEV,IRET,RSTR)
      CALL WRITSB(LUBOT)
 
C  WIND AND COPY OBS UP TO THE NEXT EVENTED MESSAGE AND SUBSET
C  -----------------------------------------------------------
 
      IF(IREC.LT.JREC.OR.ILEV.EQ.NLEV) THEN
         DO WHILE(ICOPYSB(LUBIN,LUBOT).EQ.0)
         ENDDO
         IF(IREADMM(imsg,SUBSET,IDATE).ne.0) THEN
            IF(ilev.lt.nlev) GOTO 900
            goto 100
         endif
         CALL UFBCNT(LUBIN,IREC,IFLD)
         DO WHILE(IREC.LT.JREC.OR.ILEV.EQ.NLEV)
            CALL CLOSMG(LUBOT)
            CALL COPYMG(LUBIN,LUBOT)
            IF(IREADMM(imsg ,SUBSET,IDATE).NE.0) GOTO 100
            CALL UFBCNT(LUBIN,IREC,IFLD)
         ENDDO
      ENDIF

      DO WHILE(IFLD.LT.JFLD-1)
         CALL OPENMB(LUBOT,SUBSET,IDATE)
         IF(ICOPYSB(LUBIN,LUBOT).NE.0) GOTO 901
         CALL UFBCNT(LUBIN,IREC,IFLD)
      ENDDO
 
C  READ THE NEXT SUBSET TO RECEIVE EVENTS
C  --------------------------------------
 
49    CONTINUE
      IF(IREADSB(LUBIN).NE.0) then        
         IF(IREADMM(imsg,SUBSET,IDATE).NE.0) GOTO 100
         goto 49
      endif
      CALL UFBINT(LUBIN,OBS,8,255,KLEV,OSTR)
      CALL UFBINT(LUBIN,QMS,6,255,KLEV,QSTR)
      CALL OPENMB(LUBOT,SUBSET,IDATE)
      CALL UFBCNT(LUBIN,IREC,IFLD)
      CALL UFBCPY(LUBIN,LUBOT)
      OBE =  VMAX
      QME =  VMAX
      PCS =  VMAX
      RCS =  VMAX
50    CONTINUE
 
C  ADD AN EVENT IF THE OIQC QM <> DATA QM
C  --------------------------------------
 
      IF(QMS(JUPD,JLEV).NE.QMN) THEN
         IF(JUPD.LE.3) OBE(JUPD,JLEV) = OBS(JUPD,JLEV)
         IF(JUPD.EQ.3) OBE(   4,JLEV) = OBS(   4,JLEV)
         QME(JUPD,JLEV) = QMN
         PCS(JUPD,JLEV) = IQCD
         RCS(JUPD,JLEV) = QMN
      ENDIF
 
C  LINK THE MOISTURE QM TO THE PRESSURE/TEMPERATURE QM
C  ---------------------------------------------------
 
      IF(QMN.GE.4 .AND. QMS(5,JLEV).LT.4) THEN
         OBE(5,JLEV) = OBS(5,JLEV)
         QME(5,JLEV) = QMS(5,JLEV)+4
         PCS(5,JLEV) = IQCD
         RCS(5,JLEV) = QMS(5,JLEV)+4
      ENDIF
 
C  ADD AN EVENT CONTAINING ANALYSED SSMI WIND DIRECTION
C  ----------------------------------------------------
 
      IF(SMI) THEN
         OBE(3,JLEV) = FMW(IREP,1) + FOB(ILEV,1)
         OBE(4,JLEV) = FMW(IREP,2) + FOB(ILEV,2)
         QME(3,JLEV) = QM
         PCS(3,JLEV) = IQCD
         RCS(3,JLEV) = QM
      ENDIF
 
C  TRAP THE LAST OIQC RESULT IN ORDER TO COMPLETE THE OUTPUT FILE
C  --------------------------------------------------------------
 
100   CONTINUE
 
C  CLOSE OUT THE FILES AND EXIT
C  ----------------------------
 
      call ufbcnt(lubot,ireo,iflo)
      PRINT*,'PREPQM READ ',IREC,' WROTE ',IREO,' PREPBUFR RECORDS'
      CALL CLOSBF(LUBIN)
      CALL CLOSBF(LUBOT)
      RETURN
900   PRINT *, 'PREPQM - READMG ALIGNMENT PROBLEM'
      CALL W3TAGE('PREPOBS_OIQCBUFR')
      CALL ERREXIT(99)
901   PRINT *, 'PREPQM - COPYSB ALIGNMENT PROBLEM'
      CALL W3TAGE('PREPOBS_OIQCBUFR')
      CALL ERREXIT(99)
902   PRINT *, 'PREPQM - READMM ALIGNMENT PROBLEM'
      CALL W3TAGE('PREPOBS_OIQCBUFR')
      CALL ERREXIT(99)
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    QCLOOP
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: ITERATES THE QC DECSION MAKING PROCESS UNTIL ALL DECISIONS
C   IN TWO CONSEQUETIVE ITERATIONS ARE THE SAME. AFTER FOUR ITERATIONS
C   ONLY REPORTS THAT FAIL THE CHECKS ARE CHECKED FURTHER.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL QCLOOP(QCPTS,MAXTRY)
C   INPUT ARGUMENT LIST:
C     QCPTS    - NAME OF SUBROUTINE TO CALL
C     MAXTRY   - MAXIMUM NUMBER OF TRIES
C
C   INPUT FILES:
C     UNIT 20  - TOLERANCE LEVELS (FOR EXPERIMENTATION)
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE QCLOOP(QCPTS,MAXTRY)

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /FPLIST  / NFL,INFL(MAXLEV)
      COMMON /CKLIST  / NDD,INDD(MAXLEV)
      COMMON /TOLLER  / ITER,T,TZ,TSAT,TWND,TJET
      COMMON /TOSSUNIT/ ITUNIT
      NAMELIST /TOLLS   / TB,TZ,TSAT,TWND,TJET

      LOGICAL DONE

      include "mpif.h"
      dimension istat(mpi_status_size)
      dimension ireq(100)

C----------------------------------------------------------------------
      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,nprc,ierr)
      mdtp = mpi_real
      mdes = 0
      mcom = mpi_comm_world
C-----------------------------------------------------------------------

      IF(NDD.EQ.0) THEN
         PRINT*,'QCLOOP - NDD = 0'
         RETURN
      ENDIF

      ITRY = 1
      ITER = 1
      IFLIP = 0

C  SET UP THE TOLERANCES
C  ---------------------

      TB   = 4.
      TZ   = 5.0
      TSAT = 5.0
      TWND = 4.5
      TJET = 5.5
      REWIND (20)
      READ(20,TOLLS,END=1,err=1)
1     if(myid.eq.0) then
C        WRITE(6,TOLLS)
      endif
      TZ   = TZ/TB
      TSAT = TSAT/TB
      TWND = TWND/TB
      TJET = TJET/TB
      T = TB

C  DO THE QCOI CHECKS ON LIST IN COMMON /CKLIST/
C  ---------------------------------------------

10    continue            
C     REWIND(ITUNIT)
      CALL QCPTS
      call syncndd(foi,nlev,mpi_real)

C  SET OB ERRS TO REFLECT LAST ROUND OF CHECKS - RECORD FLIPS
C  ----------------------------------------------------------

      NBB = 0
      NCK = 0
      NFG = 0
      NFB = 0
      NFL = 0

      DO 20 N=1,NDD      
      ILEV  = INDD(N)
      OBER  = FOE(ILEV)

      IF(OBER.NE.0) THEN
         IF(FOI(ILEV).EQ.1) THEN
            FOE(ILEV) = ABS(OBER)
            IF(OBER.LT.0) THEN
               NFG = NFG + 1
               NFL = NFL + 1
               INFL(NFL) = ILEV
            ENDIF
         ELSE IF(FOI(ILEV).EQ.-1) THEN
            FOE(ILEV) = -ABS(OBER)
            IF(OBER.GT.0) THEN
               NFB = NFB + 1
               NFL = NFL  + 1
               INFL(NFL) = ILEV
            ENDIF
            NBB = NBB + 1
         ENDIF
         NCK = NCK + 1
      ENDIF

20    CONTINUE

C  CHECK STATUS AND WRITE ITERATION REPORT
C  ---------------------------------------

      DONE = NFL.EQ.0 .OR. ITRY.EQ.MAXTRY

      if(myid.eq.0) then
         WRITE(6 ,30)ITRY,NFG,NFB,NFL,NBB,NCK
      endif

30    FORMAT('ITERATION ',I2,' : NFLIP=',3I6,' NBAD=',I6,' NTOT=',I6)

C  FINISHED YET?
C  -------------

      IF(.NOT.DONE) THEN
         ITRY = ITRY+1
         IF(ITRY.LT.MAXTRY) THEN
            ITER = ITRY
            GOTO 10
         ELSE
            ITER = ITRY
            DO 40 N=1,NFL
            FOE(INFL(N)) = -ABS(FOE(INFL(N)))
40          CONTINUE
            GOTO 10
         ENDIF
      ENDIF

C  FINAL REPORT AND AWAY
C  ---------------------

      NBAD = NBB

      if(myid.eq.0) then
         WRITE(6 ,*)' TOTAL BAD OBS=',NBAD
         WRITE(6 ,*)
      endif

      ITRY = 0
      ITER = 0

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION  BLOCK
C
C SUBPROGRAM:    QCOI
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-03-24
C
C ABSTRACT: COMPUTES AND SETS UP THE COEFFICIENT MATRIX AND RIGHT HAND
C   SIDES.  SOLVES THE MATRIX PROBLEMS. APPLIES THE COMPUTED WEIGHTS TO
C   THE RESIDUALS TO OBTAIN THE ANALYSIS INCREMENTS AND ANALYSIS
C   ERRORS.
C
C PROGRAM HISTORY LOG:
C 1988-02-05  DEAVEN     - ORIGINAL AUTHOR
C 1990-03-24  J. WOOLLEN - UPDATED FOR OIQC
C
C USAGE:    CALL QCOI
C
C REMARKS: INPUT INFORMATION IN COMMON /HVECT/:
C     NXXYY    - NUMBER OF OBS IN PACKAGE
C     XX       - LONGITUDES OF OBS IN PACKAGE
C     YY       - LATITUDES OF OBS IN PACKAGE
C     PP       - PRESSURES OF OBS IN PACKAGE
C     II       - INDEXES OF OBS IN PACKAGE
C     LL       - REPORT LEVEL OF OBS IN PACKAGE
C     FESD     - FORECAST ERRORS AT OB LOCATIONS
C     MKOBS    - LIST OF OB INDEXES USED IN EACH INTERPOLATION
C     NDIM     - NUMBER OF OBS USED IN EACH INTERPOLATION
C     JVMAX    - NUMBER OF INTERPOLATING OBS FOR EACH CHECK IN
C                EACH PACKAGE
C
C   OUTPUT INFORMATION IN COMMON /HVECT/:
C     AA       - INTERPOLATED VALUE OF OBS IN PACKAGE
C     AESD     - ANALYSIS ERRORS AT OB LOCATIONS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE QCOI

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      PARAMETER( NQC  =  4         ,
     .           NMX  =  64         ,
     .           NN   =  10*(10+1)/2  ,
     .           N    =  10           ,
     .           LVEC =  64*10      ,
     .           LMAT =  64*NN      )

      COMMON /CORP/ CHLP(1500),CVC,FFLAT(91),IFA(N,N)

      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WT(64,10,4,2),
     .                     FE(64,3)

      DIMENSION    CHLS(LVEC) , XXCP(LVEC) , XXOB(LVEC) , C1(LMAT) ,
     .             FLAT(LVEC) , YYCP(LVEC) , YYOB(LVEC) , C2(LMAT) ,
     .             TZFA(LVEC) , KKCP(LVEC) , KKOB(LVEC) , DD(LMAT) ,
     .             NGRP(LVEC) , PPCP(LVEC) , PPOB(LVEC) , XI(LMAT) ,
     .             NIOB(LVEC) ,              OEOB(LVEC) , YI(LMAT) ,
     .                                       OBOB(LVEC) , KI(LMAT) ,
     .                                                    PI(LMAT) ,
     .                                                    XJ(LMAT) ,
     .                                                    YJ(LMAT) ,
     .                                                    KJ(LMAT) ,
     .                                                    PJ(LMAT) ,
     .                                                    CH(LMAT) ,
     .                                                    FL(LMAT) ,
     .                                                    TZ(LMAT) ,
     .                                                    NG(LMAT) ,
     .                                                    NI(LMAT) ,
     .                                                    NJ(LMAT)

      DIMENSION FA(NMX,NN), RA(NMX,N,2), DP(NMX,2), IVAR(3)

      DATA IVAR/2,1,2/

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

      IF(NXXYY.EQ.0) RETURN

      AA = 0.
      AE = 0.
      WT = 0.

C  LOOP THRU EACH TYPE OF QC CHECK
C  -------------------------------

      DO 100 IQ=1,NQC
      IVMAX = 0

C  CLEAR THE MATRIX ARRAYS
C  -----------------------

      FA = 0.
      RA = 0.
      DP = 0.

C  SET UP VECTORS WITH INFORMATION ABOUT EACH OB TO BE CHECKED
C  -----------------------------------------------------------

      DO 15 IGRP=1,NXXYY
      NDIM = MDIM(IGRP,IQ)
      IF(NDIM.EQ.0) GOTO 15

      ILEV = MCHK(IGRP,1)
      IREP = FHD(ILEV)

      TZF = FTZ(ILEV)
      XXC = FLN(IREP)
      YYC = FLT(IREP)
      PPC = FPR(ILEV)
      KKC = MCHK(IGRP,2)
      CHL = CHLP(INT(MIN(PPC,1500.)))
      FLA = FFLAT(INT(ABS(YYC)+1.51))
      PPC = LOG(PPC)

      DO 10 IOB=1,NDIM

      JLEV  = MOBS(IGRP,IOB,IQ,1)
      JTYP  = MOBS(IGRP,IOB,IQ,2)
      JREP  = FHD(JLEV)
      IVMAX = IVMAX+1

      CHLS(IVMAX) = CHL
      FLAT(IVMAX) = FLA
      TZFA(IVMAX) = TZF
      XXCP(IVMAX) = XXC
      YYCP(IVMAX) = YYC
      KKCP(IVMAX) = KKC
      PPCP(IVMAX) = PPC

      XXOB(IVMAX) = FLN(JREP)
      YYOB(IVMAX) = FLT(JREP)
      PPOB(IVMAX) = LOG(FPR(JLEV))
      KKOB(IVMAX) = JTYP
      OEOB(IVMAX) = FOE(JLEV)
      OBOB(IVMAX) = FOB(JLEV,IVAR(JTYP))

      NGRP(IVMAX) = IGRP
      NIOB(IVMAX) = IOB

10    CONTINUE
15    CONTINUE

      IF(IVMAX.EQ.0) GOTO 61

C  COMPUTE THE RIGHT HAND SIDES
C  ----------------------------

      CALL COOR2(IVMAX,CHLS,FLAT,TZFA,XXOB,YYOB,KKOB,XXCP,YYCP,KKCP,
     .           DD,C1,C2)

      DO 20 I=1,IVMAX
      IGRP = NGRP(I)
      IOB  = NIOB(I)
      VCOR = 1./(1.+CVC*(PPOB(I)-PPCP(I))**2)
      RA(IGRP,IOB,1) = C1(I)*VCOR
      RA(IGRP,IOB,2) = C2(I)*VCOR
20    CONTINUE

C  COMPUTE THE OFF-DIAGONAL MATRIX TERMS
C  -------------------------------------

      K = 0
      L = 0

      DO 40 IGRP=1,NXXYY
      NDIM = MDIM(IGRP,IQ)
      DO 30 IOB = 1,NDIM-1
      DO 30 JOB = IOB+1,NDIM
      I = IOB+K
      J = JOB+K
      L = L+1

      XI(L) = XXOB(I)
      YI(L) = YYOB(I)
      KI(L) = KKOB(I)
      PI(L) = PPOB(I)
      XJ(L) = XXOB(J)
      YJ(L) = YYOB(J)
      KJ(L) = KKOB(J)
      PJ(L) = PPOB(J)
      CH(L) = CHLS(I)
      FL(L) = FLAT(I)
      TZ(L) = TZFA(I)
      NG(L) = NGRP(I)
      NI(L) = NIOB(I)
      NJ(L) = NIOB(J)

30    CONTINUE

      K = K+NDIM
40    CONTINUE

      CALL COOR1(L,CH,FL,TZ,XI,YI,KI,XJ,YJ,KJ,DD,C1,C2)

C  STORE OFF-DIAGONAL MATRIX TERMS IN THE SOLVER ARRAY
C  ---------------------------------------------------

      DO 50 I=1,L
      IGRP = NG(I)
      IOB  = IFA(NI(I),NJ(I))
      FA(IGRP,IOB) = C1(I)/(1.+CVC*(PI(I)-PJ(I))**2)
50    CONTINUE

C  COMPUTE AND STORE THE ON-DIAGONAL MATRIX TERMS
C  ----------------------------------------------

      DO 55 I=1,IVMAX
      IGRP = NGRP(I)
      IOB  = IFA(NIOB(I),NIOB(I))
      FA(IGRP,IOB) = 1. + (OEOB(I)/FE(IGRP,KKOB(I)))**2
55    CONTINUE

C  SOLVE THE LINEAR INTERPOLATION EQUATIONS
C  ----------------------------------------

      CALL DRCTSL(FA,RA,DP,MDIM(1,IQ),NXXYY)

C  COMPUTE AND STORE ANALYSIS INCREMENTS AND ERRORS
C  ------------------------------------------------

      DO 60 I=1,IVMAX
      IGRP              = NGRP(I)
      IOB               = NIOB(I)
      FERAT             = FE(IGRP,KKCP(I))/FE(IGRP,KKOB(I))
      WT(IGRP,IOB,IQ,1) = RA(IGRP,IOB,1) * FERAT
      WT(IGRP,IOB,IQ,2) = RA(IGRP,IOB,2) * FERAT
      AA(IGRP,IQ,1)     = AA(IGRP,IQ,1) + OBOB(I)*WT(IGRP,IOB,IQ,1)
      AA(IGRP,IQ,2)     = AA(IGRP,IQ,2) + OBOB(I)*WT(IGRP,IOB,IQ,2)
60    CONTINUE

61    DO 65 I=1,NXXYY
      AE(I,IQ,1) = FE(I,MCHK(I,2)) * SQRT(1.-DP(I,1))
      AE(I,IQ,2) = FE(I,MCHK(I,2)) * SQRT(1.-DP(I,2))
65    CONTINUE

C  END OF LOOP OVER EACH QC CHECK
C  ------------------------------

100   CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    QCPTS
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: PUTS TOGETHER PACKAGES OF OBSERVATIONS TO BE CHECKED IN A
C   GIVEN ITERATION AND INVOKES AUTOTASKING OF THE DATA SELECTION, OI,
C   AND DECISION MAKING PROCEDURES.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL QCPTS
C
C REMARKS: INPUT INFORMATION IN COMMON /CKLIST/:
C     NDD     - NUMBER OF OBSERVATIONS TO CHECK
C     INDD    - ARRAY OF OBSERVATION INDEXES TO CHECK
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE QCPTS

      PARAMETER (MAXLEV=1100000)

      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WTS(64,10,4,2),
     .                     FE(64,3)

      common /nddspt/ nd1(0:100),nd2(0:100)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      DATA NMX /64/

      include "mpif.h"

C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
c     call nddsplit(myid,nd1,nd2)
C-----------------------------------------------------------------------

C  MULTI-PROCESS QC OB LISTS
C  -------------------------

      DO I=nd1(myid),nd2(myid),nmx
      CALL SELDAT(i,min(nmx,nd2(myid)-i+1))
      CALL QCOI
      CALL OUTPUT
      ENDDO

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION  BLOCK
C
C SUBPROGRAM:    RDOBER
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1992-07-29
C
C ABSTRACT: INITIALIZES ARRAY 'QIKE' WITH OBSERVATION ERRORS FOR ALL
C   KINDS OF OBSERVATION TYPES LISTED IN THE OBSERVATION ERROR FILE.
C
C PROGRAM HISTORY LOG:
C 1986-03-21  G. DIMEGO  - ORIGINAL AUTHOR
C 1988-11-24  D. DEAVEN  - RECODED FOR CYBER 205
C 1992-07-29  J. WOOLLEN - UPDATED FOR OIQC
C
C USAGE:    CALL RDOBER(LU)
C   INPUT ARGUMENT LIST:
C     LU       - LOGICAL UNIT FOR OBSERVATION ERROR TABLE FILE SPECIFIC
C                TO THIS PROGRAM
C
C   INPUT FILES:
C     UNIT LU  - OBSERVATION ERROR TABLE FILE SPECIFIC TO THIS PROGRAM
C                (THIS IS NOT THE ANALYSIS OBSERVATION ERROR FILE -
C                 THOSE DATA ARE READ FROM THE PREPBUFR FILE)
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE RDOBER(LU)

      COMMON /OBERRS/ QIKE(21,300),PMAND(21),P50(21),CHL(21)
      COMMON /OBDESC/ DESC(300)
      COMMON /GETOE/  USEOE

      CHARACTER*80 CKX,DESC
      DIMENSION    RAWERR(21)
      LOGICAL      USEOE

      DATA RAWERR /  7.0 ,  7.5 ,  8.5 , 11.0 , 13.7 , 15.2 , 16.0 ,
     .              16.1 , 17.5 , 19.1 , 20.5 , 24.0 , 24.0 , 24.0 ,
     .              24.0 , 24.0 , 24.0 , 24.0 , 24.0 , 24.0 , 24.0 /

      DATA DUMMY/0./

C----------------------------------------------------------------------
C----------------------------------------------------------------------

C  DEFAULT VALUES FOR OB DESCRIPTIONS AND ERRORS
C  ---------------------------------------------

      DO 1 I=1,300
      DESC(I) = ' '
      DO 1 L=1,21
      QIKE(L,I) = 0.
      IF(I.EQ.120) QIKE(L,I) = RAWERR(L)
1     CONTINUE

      USEOE = .FALSE.

C  READ OB ERROR VALUES FROM OB ERROR FILE
C  ---------------------------------------

10    READ(LU,'(A80)',END=20) CKX
      IF(CKX(1:1).EQ.' ') GOTO 10
      READ(CKX,'(I3)',ERR=15) KX
      IF(KX.GT.0 .AND. KX.LT.300) THEN
         READ(LU,'(7F8.2)',END=20) (QIKE(L,KX),L=1,21)
         DESC(KX) = CKX
         USEOE = .TRUE.
         GOTO 10
      ENDIF

15    PRINT*,'******************************************************'
      PRINT*,'*******  UNRECOGNISED RECORD IN OBERRS FILE  *********'
      PRINT*,                        CKX
      PRINT*,'******************************************************'
      GOTO 10

20    RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    SATPTS
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: PUTS TOGETHER PACKAGES OF OBSERVATIONS TO BE CHECKED IN A
C   GIVEN ITERATION AND INVOKES AUTOTASKING OF THE DATA SELECTION, OI,
C   AND DECISION MAKING PROCEDURES.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL SATPTS
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C REMARKS: INPUT INFORMATION IN COMMON /CKLIST/:
C     NDD     - NUMBER OF OBSERVATIONS TO CHECK
C     INDD    - ARRAY OF OBSERVATION INDEXES TO CHECK
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SATPTS

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      common /nddspt/ nd1(0:100),nd2(0:100)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      DIMENSION IND(5000),NXY(5000)
      DATA NMX /64/

      include "mpif.h"

C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
c     call nddsplit(myid,nd1,nd2)
C-----------------------------------------------------------------------

C  ASSEMBLE LISTS OF OBS FOR MULTI PROCESSING
C  ------------------------------------------

      IND(1) = 1
      NXY    = 0
      IPK    = 1
      NPK    = 0
      LREP   = 0

      DO 5 I=nd1(myid),nd2(myid)
      ILEV = INDD(I)
      IREP = FHD(ILEV)
      IF(IREP.NE.LREP) THEN
         LREP = IREP
         KLEV = FNL(IREP)
         IF(NXY(IPK)+KLEV.GT.NMX) THEN
            IF(IPK+1.GT.5000) THEN
               PRINT *, 'QCPTS - IPK > MAXPAK'
               CALL W3TAGE('PREPOBS_OIQCBUFR')
               CALL ERREXIT(99)
            ENDIF
            IPK = IPK+1
            IND(IPK) = I
            NXY(IPK) = KLEV
         ELSE
            NXY(IPK) = NXY(IPK) + KLEV
         ENDIF
      ENDIF
5     CONTINUE

C  MULTI-PROCESS QC OB LISTS
C  -------------------------

      DO 10 I=1,IPK
      CALL SELDAT(IND(I),NXY(I))
      CALL QCOI
      CALL SATPUT
10    CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    SATPUT
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: EXAMINES OUTPUTS FROM OI QUALITY CONTROL INTERPOLATION AND
C   MAKES DECISION WHETHER A SATELLITE PASSES OR FAILS THE CHECKS. DUE
C   TO SPECIFIC CHARACTERISTIC DIFFERENCES OF SATELLITE RETRIEVALS FROM
C   CONVENTIONAL 'IN-SITU' OBSERVATIONS, A SPECIAL ALGORITHM IS
C   EMPLOYED IN JUDGING THE OUTCOMES OF THE QC CHECKS. ALSO PROVIDES
C   FOR A DETAILED PRINT TRACING ALL DECISIONS MADE IN REGARD TO
C   SPECIFIED OBSERVATIONS IN THE QC PROCESS.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL SATPUT
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT ITUNIT  - DETAILED TOSSLIST (SEE REMARKS)
C
C REMARKS: POSSIBLE VALUES FOR ITUNIT (PASSED IN VIA COMMMON
C   /TOSSUNIT/):
C     61 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR SURFACE HEIGHTS
C     62 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR TEMPS AND WINDS
C     63 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR SAT TEMPS
C     64 - UNIT FOR FILE HOLDING DETAILED TOSSLIST FOR SSMI WIND SPEEDS
C
C INPUT INFORMATION IN COMMON /HVECT/:
C     NXXYY    - NUMBER OF OBS IN PACKAGE
C     XX       - LONGITUDES OF OBS IN PACKAGE
C     YY       - LATITUDES OF OBS IN PACKAGE
C     PP       - PRESSURES OF OBS IN PACKAGE
C     II       - INDEXES OF OBS IN PACKAGE
C     LL       - REPORT LEVEL OF OBS IN PACKAGE
C     FESD     - FORECAST ERRORS AT OB LOCATIONS
C     AA       - INTERPOLATED VALUE OF OBS IN PACKAGE
C     AESD     - ANALYSIS ERRORS AT OB LOCATIONS
C     MKOBS    - LIST OF OB INDEXES USED IN EACH INTERPOLATION
C     NDIM     - NUMBER OF OBS USED IN EACH INTERPOLATION
C     JVMAX    - NUMBER OF INTERPOLATING OBS FOR EACH CHECK IN
C                EACH PACKAGE
C
C   OUTPUT INFORMATION IN COMMON /OBMARK/:
C     OBIND    - CONTAINS QC OUTCOME FOR EACH REPORT AND LEVEL:
C                   -2 = BELOW MODEL SURFACE (SET IN SUB PSFILE)
C                   -1 = FAILED OI CHECKS
C                    0 = NO DATA IN REPORT
C                    1 = PASSED OI CHECKS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SATPUT

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WTS(64,10,4,2),
     .                     FE(64,3)

      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /CORP    / CHLP(1500),CVC,FFLAT(91),IFA(10,10)
      COMMON /SATCOR  / EPSCOR(20)
      COMMON /TOLLER  / ITER,TB,TZ,TSAT,TWND,TJET
      COMMON /TOSSUNIT/ ITUNIT

      CHARACTER*8 SEG(2)
      DIMENSION   OMA1(50),OMA2(50),EPV1(50),EPV2(50),QCT(50),QCS(50)
      DIMENSION   ASD(50,2)
      DIMENSION   RAF(50,2)
      DIMENSION   OMA(50,2)
      DIMENSION   LEV(50,2)
      DIMENSION   OSD(50,2)
      DIMENSION   FSD(50,2)
      DIMENSION   PRS(50,2)
      DIMENSION   NSEG(2)
      REAL*8      SID,STAID

      DATA SEG/'1000-100','099 - 00'/

      LOGICAL LAST
      DATA PI180/.017453/, MAXNSEG/50/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      LLEV = MCHK(1,1)
      LREP = FHD(LLEV)
      NSEG = 0

C  LOOP OVER EACH SAT LEVEL IN THIS GROUP
C  --------------------------------------

      DO 50 I=1,NXXYY
      LAST = I.EQ.NXXYY
      ILEV = MCHK(I,1)
      IREP = FHD(ILEV)

C  ITEMIZE COMPLETE PROFILES INTO SEGMENTS
C  ---------------------------------------

10    IF(IREP.EQ.LREP) THEN
         PRES = FPR(ILEV)
         OBER = FOE(ILEV)
         OMF  = FOB(ILEV,2)

         IF(PRES.LE.2000. .AND. PRES.GE.100.) THEN
            K = 1
         ELSE IF(PRES.LT.100. .AND. PRES.GT.0.) THEN
            K = 2
         ENDIF

         NSEG(K) = NSEG(K) + 1
         IF(NSEG(K).GT.MAXNSEG) THEN
            PRINT *, 'SATPUT - MAX NSEG EXCEEDED'
            CALL W3TAGE('PREPOBS_OIQCBUFR')
            CALL ERREXIT(99)
         ENDIF
         J = NSEG(K)

C  STORE THE RESULTS OF THE CHECKS
C  -------------------------------

         ASD(J,K) = 0.
         OMA(J,K) = 0.
         SWT      = 0.

         DO 20 L=1,3
         AER = AE(I,L,1)
         FER = FE(I,1)
         AMF = AA(I,L,1)
         WT = MAX(.01,1.-(AER/FER)**2)
         ASD(J,K) = ASD(J,K) + WT*AER**2
         OMA(J,K) = OMA(J,K) + (OMF-AMF)*WT
         SWT = SWT + WT
20       CONTINUE

         ASD(J,K) = SQRT(ASD(J,K)/SWT)
         OMA(J,K) = OMA(J,K)/SWT
         RAF(J,K) = ASD(J,K)/FER
         LEV(J,K) = ILEV
         FSD(J,K) = FER
         OSD(J,K) = OBER
         PRS(J,K) = PRES
         IF(.NOT.LAST) GOTO 50
      ENDIF

C  A REPORT IS ITEMIZED AND READY TO JUDGE
C  ---------------------------------------

      STAID = SID(LREP)
      CLAT  = FLT(LREP)
      CLON  = FLN(LREP)
      KX    = FKX(LREP)
      LREP  = IREP

C  COMPUTE THE TOLERANCE VALUE
C  ---------------------------

      SINLAT = SIN(ABS(CLAT)*PI180)
      TT     = TB*TSAT*SINLAT
      TMIN   = 2.0
      TT     = MAX(TMIN,TT)

C  SUM THE RESULTS OVER THE PROFILE SEGMENTS - MAKE AND STORE DECISION
C  -------------------------------------------------------------------

      DO 35 K=1,2
      IF (NSEG(K).EQ.0) GOTO 35
      QC1 = 0.
      QC2 = 0.
      QCT = 0.
      QCS = 0.
      OMA1 = 0.
      OMA2 = 0.
      EPV1 = 0.
      EPV2 = 0.
      TADJ = 0.

      DO 30 J=1,NSEG(K)
      TADJ = TADJ + MAX(1.,(OSD(J,K)/FSD(J,K))**2)
      DT = OMA(J,K)**2
      EPV = (ASD(J,K)**2+OSD(J,K)**2)
      OMA1(J) = DT
      EPV1(J) = EPV
      QCT(J) = SQRT(DT/EPV)
      QC1 = MAX(QC1,QCT(J))

      IF(J.GT.1) THEN
         RPLN = LOG(PRS(J-1,K)/PRS(J,K))
         PL=20.*RPLN + 1.001
         IF(PL.LT.20.) THEN
            KP=PL
            XP=PL-KP
            OBCOR = (1.-XP)*EPSCOR(KP) + XP*EPSCOR(KP+1)
         ELSE
            OBCOR = 0.
         ENDIF
         COVO = OSD(J-1,K)*OSD(J,K)*OBCOR
         FCCOR = 1./(1.+CVC*RPLN**2)
         COVA = ASD(J-1,K)*ASD(J,K)*FCCOR
         STAB = (OMA(J-1,K)-OMA(J,K))**2
         ESTAB  = EPV+EPV0 - 2.*(COVO+COVA)
         OMA2(J-1) = STAB
         EPV2(J-1) = ESTAB
         QCS(J-1) = SQRT(STAB/ESTAB)
         QC2 = MAX(QC2,QCS(J-1))
      ENDIF
      EPV0 = EPV
30    CONTINUE

      TADJ = SQRT(TADJ/NSEG(K))
      TTT = TT/TADJ

      QC = MAX(QC1,QC2)
      IQC = SIGN(1.,TTT-QC)

      IF(IQC.EQ.-1) THEN
         WRITE(ITUNIT,31)STAID,KX,CLON,CLAT,SEG(K),QC1,QC2,QC,TTT
31       FORMAT(A6,I4,2F8.2,A10,4F8.2)
      ENDIF

      DO 32 J=1,NSEG(K)
      KIQC = IQC
      IF(CLAT.LT.0. .OR. PRS(J,K).LE.100.) THEN
         QC = MAX(QCT(J),QCS(J))
         KIQC = SIGN(1.,TTT-QC)
      ENDIF
      FOI(LEV(J,K)) = KIQC
32    CONTINUE

35    CONTINUE

C  WRAP BACK TO START THE NEXT PROFILE
C  -----------------------------------

      IF(.NOT.LAST) THEN
         NSEG = 0
         GOTO 10
      ENDIF

C  END OF LOOP OVER LEVELS
C  -----------------------

50    CONTINUE

      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE SEARCH

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC

      REAL XTW(MAXLEV,10,2),XPF(MAXLEV,5,2)

      PARAMETER (MAXLV=255)
      PARAMETER (MTOTH=10 )
      PARAMETER (MTOTV=5  )

      common /nddspt/ nd1(0:100),nd2(0:100)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      COMMON /OBS/    NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      REAL*8          SID

      include "mpif.h"

C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
C-----------------------------------------------------------------------

!  -------------------------------------------------------
!  divide the obs to check into equal parts for the solver
!  -------------------------------------------------------

      npart=ndd/nprc
      do i=0,nprc-1
      n1=(i*npart)+1
      n2=n1+npart-1
      if(i==nprc-1) n2=ndd
      nd1(i)=n1;nd2(i)=n2
      enddo

C  ------------------------------------------------------------
C  farm out iterations of the search loop to processors in turn
C  ------------------------------------------------------------

      ftw = 0
      fpf = 0

      np1=fhd(indd(1))
      np2=fhd(indd(ndd))

      DO N=np1,np2
      IF(MOD(N,NPRC)/=MYID) CYCLE
      IF(FQL(N)>0) CALL SEARCHS(n)
      ENDDO

c  -------------------------------------------------------------
c  each process puts its result in a section of the global array
c  -------------------------------------------------------------
c  this code combines (reduces) all sections to one for all
c  --------------------------------------------------------


      nftw=maxlev*10*2;nfpf=maxlev*5*2;mcomm=mpi_comm_world
      call mpi_allreduce(ftw,xtw,nftw,mpi_real,mpi_sum,mcomm,ier1)
      call mpi_allreduce(fpf,xpf,nfpf,mpi_real,mpi_sum,mcomm,ier2)
      ftw=xtw; fpf=xpf ! copy the reduction back where it belongs

      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE SEARCHS(NPTR)
 
      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC
 
      COMMON /OBS / NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /OBHEIR/ QUALOB(300),binqadj
      common /trigs/ llnd(-10:10),rcos(181),prln(0:1100)
 
      PARAMETER(IDMX=8)
      PARAMETER(JDMX=5)
      PARAMETER(KDMX=2)
      PARAMETER(PMAX=.5)
      PARAMETER(MXLV=255)
      PARAMETER(MTOTH=10)
      PARAMETER(MTOTV=5)
 
      CHARACTER*8 SID
      CHARACTER*3 TAG
      DIMENSION   NIND(MAXREP),RLAT(MAXREP),RLON(MAXREP),
     .            RDIS(MAXREP),RDIR(MAXREP),INL(MXLV),INI(MXLV),
     .            PATX(IDMX,JDMX,KDMX,MXLV),
     .            MATX(IDMX,JDMX,KDMX,MXLV),NTOT(KDMX)
      LOGICAL     SAME

      DATA PI180  /.0174532/
      DATA RADE   /6371./
      DATA RSCAN  /1000./
      data mmrep/MAXREP/
      SAVE PI180,RADE,MMREP,RSCAN,SAME
 
C----------------------------------------------------------------------
C----------------------------------------------------------------------

 
C  COPY SOME DETAILS ABOUT EACH OBSERVATION TO CHECK
C  -------------------------------------------------
 
      PATX = 9999     
      MATX = 0
 
      RCDR = 1./( 360./FLOAT(IDMX))
      RCDS = 1./(RSCAN/FLOAT(JDMX))
      IPTR = FLV(NPTR)
      JPTR = FLV(NPTR)+FNL(NPTR)-1
      NLVL = FNL(NPTR)
      BLON = FLN(NPTR)
      BLAT = FLT(NPTR)
      BINQ = FQL(NPTR)+binqadj
      NBKX = FKX(NPTR)
      TAG  = FOC(NPTR)

C  MAKE SPECIAL CASE ADJUSTMENTS (RECCOS,SATEMP)
C  ---------------------------------------------
 
      IF(MOD(NBKX,100).EQ.32) NC = 3
      IF(MOD(NBKX,100).NE.32) NC = 8
      IF(TAG.EQ.'SAT') BINQ = BINQ - 1.
 
C  ITEMIZE REPORTS IN THE SEACH CYLINDER
C  -------------------------------------
 
      NPRF = 0
      NOBS = 0
 
      lon = ifix(blon)+1
      lat = ifix(blat)+91.
      lscan = nint(rscan*.01)

      do ltd=-lscan,+lscan
      ltt = lat+ltd
      if(ltt.ge.1.and.ltt.le.181) then
         lnd = min(ceiling(llnd(ltd)*rcos(ltt)),180)
         ln1 = lon-lnd
         ln2 = lon+lnd               
         lt1 = ltx(ln1,ltt)
         lt2 = ltx(ln2,ltt)
         DO N=IMAP(ln1,lt1),IMAP(ln2,lt2)
         NN  = INOB(N)
         QLA = FQL(NN)
         IF(QLA.GE.0. .AND. QLA.LE.BINQ .and. nprf+1.le.mmrep) THEN
            NPRF = NPRF+1
            NIND(NPRF) = NN
            RLON(NPRF) = FLN(NN)
            RLAT(NPRF) = FLT(NN)
         ENDIF
         ENDDO
      endif
      enddo
 
C  COMPUTE DISTANCE AND DIRECTION FROM THE CYLINDER CENTER
C  ------------------------------------------------------
 
      CALL CHDIST(BLON,BLAT,RLON,RLAT,RDIS,RDIR,NIND,NPRF)
 
C  LOOP OVER OBSERVATION PROFILES TO BE USED FOR CHECKING
C  ------------------------------------------------------
 
      DO N=1,NPRF
      SAME = SID(NPTR)(1:NC).EQ.SID(NIND(N))(1:NC)
      IF(RDIS(N).LT.RSCAN.AND..NOT.SAME) THEN
        IDIR = IFIX(RDIR(N)*RCDR)+1
        JDIS = IFIX(RDIS(N)*RCDS)+1
        LTYP = IFIX(FKX(NIND(N))*.01)
        IIND  = FLV(NIND(N))
        JIND  = FLV(NIND(N))+FNL(NIND(N))-1
        DO LIND=IIND,JIND
        IF(FOI(LIND).GT.0) THEN
          DO LPTR=IPTR,JPTR
          plog1 = prln(nint(fpr(lptr)))
          plog2 = prln(nint(fpr(lind)))
          PDIF = ABS(plog1-plog2)             
          LEVL = LPTR-IPTR+1
          
              J = JDIS
              DO WHILE(PDIF.GT.PATX(IDIR,J,LTYP,LEVL).AND.J.LE.JDMX)
              J = J+1
                 if(j.gt.jdmx) exit ! DAK: 3/27/13 - prevents overflow
                                    !      in subscript 2 (J) of array
                                    !      PATX
              ENDDO
              if(j.le.jdmx) then
                 MATX(IDIR,J,LTYP,LEVL) = LIND
                 PATX(IDIR,J,LTYP,LEVL) = PDIF
              endif
         
          ENDDO
        ENDIF
        ENDDO
      ENDIF
      ENDDO
 
C  STORE THE DATA INDEXES SELECTED FOR THE HORIZONTAL AND VERTICAL CHECKS
C  ----------------------------------------------------------------------
 
      DO LPTR=IPTR,JPTR
      LEVL = LPTR-IPTR+1
      NTOT = 0
      DO K=1,KDMX
      IF(NTOT(K).LT.MTOTH) THEN
         DO J=1,JDMX
         DO I=1,IDMX
         LIND = MATX(I,J,K,LEVL)
         IF(LIND.GT.0 .AND. NTOT(K).LT.MTOTH) THEN
            NTOT(K) = NTOT(K)+1
            FTW(LPTR,NTOT(K),K) = LIND
         ENDIF
         ENDDO
         ENDDO
      ENDIF
      ENDDO
      IF(TAG.EQ.'UPA') THEN
         IF(LEVL.EQ.1) CALL SRTPRS(IPTR,NLVL,INL,INI)
         DO J=1,MTOTV
         IF(INL(LEVL)-J.GT.0   ) FPF(LPTR,J,1) = INI(INL(LEVL)-J)
         IF(INL(LEVL)+J.LE.NLVL) FPF(LPTR,J,2) = INI(INL(LEVL)+J)
         ENDDO
      ENDIF
      ENDDO
 
C  END OF INDEPENDENT LOOP ITERATIONS
C  ----------------------------------
 
100   CONTINUE
 
      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE SRTPRS(ILEV,NLV,INL,INI)

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      DIMENSION INL(NLV),INI(NLV),PRS(NLV),SRT(NLV)

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

      DO L=1,NLV
      ILV = ILEV+L-1
      INI(L) = ILV
      PRS(L) = FPR(ILV)
      SRT(L) = PRS(L)
      ENDDO

C  SORT INDEXES IN DESCENDING ORDER OF PRESSURE
C  --------------------------------------------

      DO I=1  ,NLV
      DO J=I+1,NLV
      IF(SRT(I).LT.SRT(J)) THEN
         STMP   = SRT(I)
         SRT(I) = SRT(J)
         SRT(J) = STMP
         ITMP   = INI(I)
         INI(I) = INI(J)
         INI(J) = ITMP
      ENDIF
      ENDDO
      ENDDO

C  MAKE A SET OF LOOK BACK POINTERS
C  --------------------------------

      DO 10 I=1,NLV
      INL(I) = I
      IF(PRS(I).NE.SRT(I)) THEN
         DO J=1,NLV
         IF(PRS(I).EQ.SRT(J)) THEN
            INL(I) = J
            GOTO 10
         ENDIF
         ENDDO
         PRINT *, 'SRTPRS - SORTED PRESSURE NO FOUND'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
      ENDIF
10    ENDDO

      RETURN
      END
C----------------------------------------------------------------------
C----------------------------------------------------------------------
      SUBROUTINE SELDAT(IND,NXY)

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WT(64,10,4,2),
     .                     FE(64,3)
      COMMON      /CKLIST/ NDD,INDD(MAXLEV)

      DIMENSION MAXPIC(4),MAXN(4)
      DATA MAXPIC/10,10,5,5/ , MAXN/10,10,1,1/ , NMX/64/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      MDIM = 0
      M    = 0

      DO 50 NPTR=IND,IND+NXY-1
      I  = INDD(NPTR)
      J  = FHD(I)
      KX = FKX(J)/100

      DO 45 K=KX,KX
      M = M + 1
      MCHK(M,1) = I
      MCHK(M,2) = K
      FE  (M,1) = FFE(I,1)
      FE  (M,2) = FFE(I,2)
      FE  (M,3) = FE (M,2)

C  PICK DATA FROM T AND W GROUPS
C  -----------------------------

      DO 20 IG=1,2
      NPIC = 0
      DO 15 IP=1,MAXPIC(IG)
      IF(NPIC.EQ.MAXN(IG)) GOTO 20
      IPIC = FTW(I,IP,IG)
      IF(IPIC.EQ.0) GOTO 20
      IF(FOE(IPIC).GT.0) THEN
         NPIC = NPIC+1
         DO 10 IQ=IG,IG*2-1
         MDIM(M,IQ)        = NPIC
         MOBS(M,NPIC,IQ,1) = IPIC
         MOBS(M,NPIC,IQ,2) = IQ
10       CONTINUE
      ENDIF
15    CONTINUE
20    CONTINUE

C  PICK DATA FROM SAME PROFILE
C  ---------------------------

      NPIC = 0

      DO 30 IG=1,2
      DO 25 IP=1,5
      IPIC = FPF(I,IP,IG)
      IF(IPIC.EQ.0) GOTO 30
      IF(FOE(IPIC).GT.0) THEN
         DO 24 KK=K,K*2-1
         NPIC             = NPIC+1
         MDIM(M,4)        = NPIC
         MOBS(M,NPIC,4,1) = IPIC
         MOBS(M,NPIC,4,2) = KK
24       CONTINUE
         GOTO 30
      ENDIF
25    CONTINUE
30    CONTINUE

45    CONTINUE
50    CONTINUE

C  CHECK THE NUMBER OF OBS TO STORE
C  --------------------------------

      IF(M.GT.NMX) THEN
         PRINT *, 'SELDAT - M GT NMX'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
      ENDIF

C  STORE THE NUMBER OF OBS TO CHECK
C  --------------------------------

      NXXYY = M

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION  BLOCK
C
C SUBPROGRAM:    SETCON
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1992-07-29
C
C ABSTRACT: INITIALIZES CONSTANTS AND PARAMETERS USING DATA STATEMENTS.
C   ALSO READS A FILE OF OBSERVATION ERRORS FROM UNIT 15.
C
C PROGRAM HISTORY LOG:
C 1986-03-21  G. DIMEGO  - ORIGINAL AUTHOR
C 1988-11-24  D. DEAVEN  - CODED FOR CYBER 205
C 1992-07-29  J. WOOLLEN - UPDATED VERSION FOR OIQC
C
C USAGE:    CALL SETCON
C   INPUT FILES:
C     UNIT 18  - LIST OF IPOINTS FOR DETAILED PRINT IN UNITS 71-80
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SETCON

      COMMON /CORP  / CHLP(1500),CVC,FFLAT(91),IFA(10,10)
      COMMON /FCRATS/ RATION(21),RATIOS(21),TROPUV(21)
      COMMON /OBERRS/ QIKE(21,300),PMAND(21),P50(21),CHL(21)
      COMMON /OBHEIR/ QUALOB(300),binqadj
      COMMON /OBPRT / NPT,IDSTA(10),PSTA(10),KXSTA(10)
      common /trigs/  llnd(-10:10),rcos(181),prln(0:1100)


      CHARACTER*8     IDSTA

      DATA PI180  /.0174532 /

C-------------------------------------------------------------------
C-------------------------------------------------------------------

c  compute trig lookup tables for searching data
c  ---------------------------------------------

      do i=-10,10
      llnd(i) = sqrt(float(100-i*i))
      enddo

      do i=1,181
      rcos(i) = abs(1./cos((float(i)-90.01)*pi180))
      enddo

      do i=1,1100
      prln(i) = log(float(i))
      enddo 
      prln(0) = prln(1)

C  STORE A SYMMETRIC MATRIX MAP
C  ----------------------------

      LLL = 1
      DO 10 I = 1,10
      DO 10 J = 1,I
      IFA(I,J) = LLL
      IFA(J,I) = LLL
      LLL = LLL + 1
10    CONTINUE

C  MAKE A TABLE OF LENGTH SCALES BY MILIBARS
C  -----------------------------------------

      DO 20 I=1,1500
      CHLP(I) = PILNLNP(FLOAT(I),PMAND,CHL,21)
20    CONTINUE

C  READ IN SOME POINTS TO PRINT
C  ----------------------------

      DO 30 I=1,10
      READ(18,'(A6,I5,I4)',END=35,err=35) IDSTA(I),IP,KXSTA(I)
      PSTA(I) = IP
      PRINT'(A6,I5,I4)',IDSTA(I),IP,KXSTA(I)
30    CONTINUE
35    NPT = I-1

C  SET UP SOME DATA PRIORITIES
C  ---------------------------

      binqadj = 0

      DO 5 I=1,300
5     QUALOB(I) = 2.

      QUALOB(120) = 1.
      QUALOB(132) = 1.
      QUALOB(220) = 1.
      QUALOB(221) = 1.
      QUALOB(230) = 1.
      QUALOB(231) = 1.
      QUALOB(232) = 1.
      QUALOB(233) = 1.

      QUALOB(283) = 3.

      QUALOB(161) = 3.
      QUALOB(162) = 4.
      QUALOB(163) = 5.
      QUALOB(166) = 3.
      QUALOB(167) = 4.
      QUALOB(168) = 5.

      QUALOB(171) = 3.
      QUALOB(172) = 4.
      QUALOB(173) = 5.
      QUALOB(176) = 3.
      QUALOB(177) = 4.
      QUALOB(178) = 5.

C  SO LONG FOR NOW
C  ---------------

      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      BLOCKDATA SETCONS

      COMMON /OBERRS/ QIKE(21,300),PMAND(21),P50(21),CHL(21)
      COMMON /CORP  / CHLP(1500),CVC,FFLAT(91),IFA(10,10)
      COMMON /FCRATS/ RATION(21),RATIOS(21),TROPUV(21)
      COMMON /OBPRT / NPT,IDSTA(10),PSTA(10),KXSTA(10)
      COMMON /OBHEIR/ QUALOB(300),binqadj
      COMMON /SATCOR/ EPSCOR(20)

      CHARACTER*8     IDSTA

      DATA RATION /   .7 ,   .7 ,   .7 ,   .7 ,   .7 ,   .7 ,   .7 ,
     .                .7 ,   .7 ,   .7 ,   .6 ,   .5 ,   .5 ,   .5 ,
     .                .5 ,   .5 ,   .5 ,   .5 ,   .5 ,   .5 ,   .5 /

      DATA RATIOS /   .7 ,   .7 ,   .7 ,   .7 ,   .7 ,   .7 ,   .7 ,
     .                .7 ,   .7 ,   .7 ,   .6 ,   .5 ,   .5 ,   .5 ,
     .                .5 ,   .5 ,   .5 ,   .5 ,   .5 ,   .5 ,   .5 /

      DATA TROPUV /  4.0 ,  4.0 ,  4.5 ,  6.5 ,  8.0 ,  8.0 ,  9.0 ,
     .              10.0 , 13.0 , 13.0 , 11.0 ,  8.0 ,  8.0 ,  8.0 ,
     .               8.0 ,  8.0 ,  8.0 ,  8.0 ,  8.0 ,  8.0 ,  8.0 /

      DATA CHL    / 120. , 100. ,  80. ,  80. ,  80. ,  80. ,  80. ,
     .               80. ,  80. ,  60. ,  60. ,  40. ,  40. ,  40. ,
     .               40. ,  40. ,  40. ,  40. ,  40. ,  40. ,  40. /

      DATA FFLAT  / 11*0 , .035 ,  .06 ,  .12 ,  .18 ,  .26 ,  .35 ,
     .               .45 ,  .54 ,  .63 ,  .72 ,  .80 ,  .86 ,  .92 ,
     .               .97 , 66*1 /

      DATA PMAND  / 1000 ,  850 ,  700 ,  500 ,  400 ,  300 ,  250 ,
     .               200 ,  150 ,  100 ,   70 ,   50 ,   30 ,   20 ,
     .                10 ,    7 ,    5 ,    3 ,    2 ,    1 ,   .4 /

      DATA P50    / 1000 ,  950 ,  900 ,  850 ,  800 ,  750 ,  700 ,
     .               650 ,  600 ,  550 ,  500 ,  450 ,  400 ,  350 ,
     .               300 ,  250 ,  200 ,  150 ,  100 ,   50 ,   .4 /

      DATA EPSCOR/ .99, .88,. 61, .36, .18, .05,-.05,-.12,-.15,-.14,
     .            -.11,-.08,-.05,-.03,-.02,-.02,-.01,-.01,  0.,  0./

      DATA  CVC   /  5.0 /

      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    SSMIPTS
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: PUTS TOGETHER PACKAGES OF SSMI OBSERVATION LOCATIONS,
C   PERFORMS A MULTIVARIATE SURFACE WIND ANALYSIS, AND ASSIGNS ANALYSED
C   DIRECTION TO THE SSMI WIND SPEED OBSERVATION TO PRODUCE AN SSMI
C   WIND VECTOR TO BE CHECKED BY OIQC AND PASSED ON THE OBJECTIVE
C   ANALLYSIS PROGRAM.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGNIAL AUTHOR
C
C USAGE:    CALL SSMIPTS
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SSMIPTS

      PARAMETER (MAXLEV=1100000)

      common /nddspt/ nd1(0:100),nd2(0:100)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      COMMON /OBHEIR/ QUALOB(300),binqadj
      DATA NMX /64/

      include "mpif.h"

C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
c     call nddsplit(myid,nd1,nd2)
C-----------------------------------------------------------------------

      binqadj = -1

C  MULTI-PROCESS QC OB LISTS
C  -------------------------

      CALL SEARCH

      DO I=nd1(myid),nd2(myid),nmx
      CALL SELDAT(i,min(nmx,nd2(myid)-i+1))
      CALL QCOI
      CALL SSMIPUT
      ENDDO

      binqadj = 0

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    SSMIPUT
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1992-10-06
C
C ABSTRACT: USES THE OUTPUT OF A MULTIVARIATE INTERPOLATION OF NEARBY
C   OBSERVATIONS TO ASSIGN DIRECTIONS TO SSMI WIND SPEED DATA. ALSO
C   PROVIDES FOR A DETAILED PRINT SHOWING OBSERVATIONS USED IN THE
C   INTERPOLATION ALONG WITH THE WEIGHTS AND INCREMENTS RESULTING.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL SSMIPUT
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SSMIPUT

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WT(64,10,4,2),
     .                     FE(64,3)

      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /OBPRT   / NPT,SIDP(10),PRP(10),KXP(10)

      DIMENSION IOMF(3)
      CHARACTER*1 VAR2(2),VAR3(3)
      REAL*8 SID,CKSTA

      DATA VAR2 / 'Z' , 'W' /
      DATA VAR3 / 'Z' , 'U' , 'V' /
      DATA IOMF /  2  ,  1  ,  2  /

      CHARACTER*1 PLUMIN
      DATA PI180/.017453/

C----------------------------------------------------------------------
C----------------------------------------------------------------------

C  LOOP OVER EACH OB CHECKED IN THIS GROUP
C  ---------------------------------------

      DO 50 N=1,NXXYY
      ILEV  = MCHK(N,1)
      IREP  = FHD(ILEV)
      PRES  = FPR(ILEV)
      OBER  = FOE(ILEV)
      CKSTA = SID(IREP)
      CLON  = FLN(IREP)
      CLAT  = FLT(IREP)
      KX    = FKX(IREP)
      GESU  = FMW(IREP,1)
      GESV  = FMW(IREP,2)

C  COMPUTE THE ANALYSED WIND DIRECTION AT THIS OB
C  ----------------------------------------------

      ANAU = GESU + AA(N,1,1)
      ANAV = GESV + AA(N,1,2)

      IF(ANAU.GT.0.) THEN
         ANADIR = ATAN(ANAV/ANAU)
      ELSE IF(ANAU.LT.0.) THEN
         ANADIR = ATAN(ANAV/ANAU) + 180.*PI180
      ELSE IF(ANAU.EQ.0.) THEN
         ANADIR = SIGN(90.*PI180,ANAV)
      ENDIF

C  COMBINE THE ANA DIRECTION WITH THE SSMI SPEED
C  ---------------------------------------------

      SSMISPD = ABS(FOB(ILEV,2))
      SSMIU = SSMISPD*COS(ANADIR)
      SSMIV = SSMISPD*SIN(ANADIR)

C  COMPUTE THE OBSERVED INCREMENT AND STORE IN THE PROPER PLACE
C  ------------------------------------------------------------

      FOB(ILEV,1) = SSMIU-GESU
      FOB(ILEV,2) = SSMIV-GESV

50    CONTINUE

100   FORMAT(A6,I4,3F8.2,A4,2F8.2,4(' *',F6.1,' (',F5.2,')' ),
     .       ' *',2F6.2,A6,A1)
101   FORMAT(A6,I4,3F8.2,A4,2F8.2,4(' *',F6.1,2X,I2),' *',2F6.2,A6,A1)
102   FORMAT(A6,I4,3F8.2,A4,6F8.2)

      RETURN
      END
C-----------------------------------------------------------------------
C
C-----------------------------------------------------------------------
      SUBROUTINE SSMISRCH(IND,NXY)

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      COMMON /CORP  / CHLP(1500),CVC,FFLAT(91),IFA(10,10)
      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)

      COMMON /HVECT / NXXYY,MCHK(64,2),MOBS(64,10,4,2),
     .                     MDIM(64,4),AA(64,4,2),
     .                     AE(64,4,2),WT(64,10,4,2),
     .                     FE(64,3)

      CHARACTER*3 TAG

      DIMENSION   NIND(MAXREP),RLAT(MAXREP),RLON(MAXREP),
     .            DIST(MAXREP),DIRN(MAXREP),
     .            LIND(50000),LTYP(50000),PRES(50000),
     .            ICOR(50000),IDIR(50000),
     .            IPIC(10),CATCOR(101)

      LOGICAL   CAT(50000,4,4),NONE(4,4),MORE,GO

      REAL*8 SID

      DATA CATCOR /21*5.,30*4.,20*3.,20*2.,10*1./
      DATA PI180  /.0174532/, RADE /6371./, RSCAN /1000./
      DATA MAXCYL /50000/
      DATA MTOTH  /10/ , MTOTV /5/


C----------------------------------------------------------------------
C----------------------------------------------------------------------

      NXXYY = 0
      MDIM  = 0

C  LOOP OVER PROFILES TO BE CHECKED
C  --------------------------------

      DO 60 NPT=IND,IND+NXY-1
      MPTR = INDD(NPT)
      NPTR = FHD(MPTR)
      BLON = FLN(NPTR)
      BLAT = FLT(NPTR)
      BINQ = FQL(NPTR)-1
      TAG  = FOC(NPTR)
      IF(TAG.NE.'SMI') THEN
         PRINT *, 'SSMISRCH - SEARCHING NON SSMI DATA'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
      ENDIF

C  OUTLINE THE SEARCH AREA
C  -----------------------

      DELLAT = RSCAN/(PI180*RADE)
      COSLAT = COS(BLAT*PI180)
      DELLON = MIN(DELLAT/COSLAT,180.0)
      X1 = BLON-DELLON
      X2 = BLON+DELLON
      Y1 = BLAT-DELLAT
      Y2 = BLAT+DELLAT
      IF(X1.LT.  0.) X1 = X1 + 360.
      IF(X2.GE.360.) X2 = X2 - 360.
      IF(Y1.LT.-90.) Y1 = -90.
      IF(Y2.GT. 90.) Y2 = 90.

C  ITEMIZE REPORTS IN THE SEACH CYLINDER
C  -------------------------------------

      NPRF = 0
      NOBS = 0

      I1 = X1 + 1.
      I2 = X2 + 1.
      J1 = Y1 + 91.
      J2 = Y2 + 91.

      DO 10 K=1,2
      IA = I1
      IB = I2
      IF(I1.GT.I2) THEN
         IF(K.EQ.1) IB = 360
         IF(K.EQ.2) IA = 1
      ELSE
         IF(K.EQ.2) GOTO 11
      ENDIF

      DO 10 J=J1,J2
      DO 10 N=IMAP(IA,J),IMAP(IB,J)
      NN  = INOB(N)
      QLA = FQL(NN)
      IF(QLA.GE.0. .AND. QLA.LE.BINQ) THEN
         NPRF = NPRF+1
         NIND(NPRF) = NN
         RLON(NPRF) = FLN(NN)
         RLAT(NPRF) = FLT(NN)
      ENDIF
10    CONTINUE

11    IF(NPRF.GT.MAXREP) THEN
         PRINT *, 'SSMISRCH - NPRF > MAXREP'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
      ENDIF

C  COMPUTE DISTANCE AND DIRECTION FROM THE CYLINDER CENTER
C  -------------------------------------------------------

      CALL CHDIST(BLON,BLAT,RLON,RLAT,DIST,DIRN,NIND,NPRF)

C  STORE ALL LEVELS OF EACH REPORT LOCATED IN THE CYLINDER
C  -------------------------------------------------------

      DO 21 N=1,NPRF
      IF(DIST(N).LE.RSCAN .AND. SID(NPTR).NE.SID(NIND(N))) THEN
         ILEV  = FLV(NIND(N))
         KLEV  = ILEV+FNL(NIND(N))-1
         KX    = FKX(NIND(N))
         DO 20 JLEV=ILEV,KLEV
         IF(FOI(JLEV).GT.0) THEN
            NOBS = NOBS+1
            LIND(NOBS) = JLEV
            PRES(NOBS) = LOG(FPR(JLEV))
            DIST(NOBS) = (DIST(N)/RADE)**2
            DIRN(NOBS) = AMOD(DIRN(N)/90.,4.) + 1.01
            LTYP(NOBS) = KX/100
         ENDIF
20       CONTINUE

         IF(NOBS.GT.MAXCYL) THEN
            PRINT *, 'SSMISRCH - NOBS>MAXCYL'
            CALL W3TAGE('PREPOBS_OIQCBUFR')
            CALL ERREXIT(99)
         ENDIF
      ENDIF
21    CONTINUE

C  LOOP OVER THE OBSERVATION LEVELS TO BE CHECKED
C  ----------------------------------------------

      ILEV = FLV(NPTR)
      KLEV = ILEV+FNL(NPTR)-1

      DO 50 IL=ILEV,KLEV

      BPRS = FPR(IL)
      IPRS = BPRS
      BPRS = LOG(BPRS)

C  INITIALIZE THE SLECTION ARRAYS
C  ------------------------------

      NXXYY = NXXYY + 1
      MCHK(NXXYY,1) = IL
      MCHK(NXXYY,2) = 2
      FE  (NXXYY,1) = FFE(IL,1)
      FE  (NXXYY,2) = FFE(IL,2)
      FE  (NXXYY,3) = FFE(IL,2)

      IF(NOBS.EQ.0) GOTO 50

C  COMPUTE ZZ HRZ AND VRT CORRELATIONS FOR EACH OB AND CATEGORIZE
C  --------------------------------------------------------------

      DO 24 N=1,NOBS
      CHRZ    = EXP(-CHLP(IPRS)*(DIST(N)))
      CVRT    = 1./(1.+ CVC*(BPRS-PRES(N))**2)
      IC      = CHRZ*CVRT*100.+1.
      ICOR(N) = CATCOR(IC)
      IDIR(N) = DIRN(N)
24    CONTINUE

      DO 25 J=1,4
      DO 25 I=1,4
      DO 25 N=1,NOBS
      CAT(N,I,J) = ICOR(N).EQ.J .AND. IDIR(N).EQ.I
25    CONTINUE

C  PICK THE CLOSEST 10 (MULTIVARIATE) HORIZONTAL OBSERVATIONS
C  ----------------------------------------------------------

      DO 28 J=1,4
      DO 28 I=1,4
      NONE(I,J) = .FALSE.
28    CONTINUE

      NTOT = 0
      NPIC = 0

      DO 35 J=1,4
30    MORE = .FALSE.
      DO 34 I=1,4
      IF(NPIC.GE.MTOTH) GOTO 36
      IF(NONE(I,J)   ) GOTO 34
      DO 32 N=1,NOBS
      IF(CAT(N,I,J)) THEN
         NTOT = NTOT+1
         IPIC(NTOT) = N
         NPIC = NPIC+LTYP(N)
         CAT(N,I,J) = .FALSE.
         MORE = .TRUE.
         GOTO 34
      ENDIF
32    CONTINUE
      NONE(I,J) = .TRUE.
34    CONTINUE
      IF(MORE) GOTO 30
35    CONTINUE
36    IF(NPIC.GT.MTOTH) NTOT = NTOT-1

C  STORE THE DATA INDEXES SELECTED FOR HORIZONTAL CHECKS
C  -----------------------------------------------------

      NPIC = 0

      DO 40 N=1,NTOT
      NN = IPIC(N)
      KK = LTYP(NN)
      DO 40 K=KK,KK*2-1
      NPIC = NPIC+1
      MDIM(NXXYY,1) = MDIM(NXXYY,1) + 1
      MOBS(NXXYY,NPIC,1,1) = LIND(NN)
      MOBS(NXXYY,NPIC,1,2) = K
40    CONTINUE

50    CONTINUE

60    CONTINUE

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    STOERR
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: INTERPOLATES TO AND STORES FORECAST AND OBSERVATION ERRORS
C   WITH EACH OBSERVATION IN THE DATASET IN COMMON /DUMMY/.  ALSO MAKES
C   A LIST OF OBS BY 2D LOCATION IN COMMON /TGRID/ IN ORDER TO EXPEDITE
C   VARIOUS DATA SEARCH PROCEDURES. SOME CHECKING ON THE PLAUSIBILITY
C   OF OB COORDINATES IS PERFORMED AS WELL.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL STOERR
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C REMARKS:
C   OUTPUT INFORMATION IN COMMON /TGRID/:
C     NREP       - NUMBER OF REPORT LOCATIONS
C     XQC        - ARRAY OF REPORT LONGITUDES
C     YQC        - ARRAY OF REPORT LATITUDES
C     IQC        - ARRAY OF REPORT INDEXES INTO THE BUFFS ARRAY
C     TQC        - ARRAY OF REPORT TYPES (HEIGHT OR WIND)
C     FERR       - ARRAY OF FORECAST ERRORS AT REPORT LOCATIONS
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE STOERR

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /OBERRS/ QIKE(21,300),PMAND(21),P50(21),CHL(21)
      COMMON /CORP  / CHLP(1500),CVC,FFLAT(91),IFA(10,10)
      COMMON /GETOE / USEOE

      CHARACTER*3  CLASS
      LOGICAL      USEOE
      REAL*8       SID,STID

      DATA XMSG/32700./

      include "mpif.h"

C----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
C-----------------------------------------------------------------------

C  GO THROUGH ALL THE STORED DATA
C  ------------------------------

      DO 30 IREP=1,NREP

      ILEV  = FLV(IREP)
      CLASS = FOC(IREP)
      STID  = SID(IREP)
      DDLAT = FLT(IREP)
      DDLON = FLN(IREP)
      KLEV  = FNL(IREP)
      KX    = FKX(IREP)
      KKX   = KX/100

      IF(KLEV.EQ.0) GOTO 30

C  CHECK FOR UNNATURAL INFORMATION IN THE HEADER
C  ---------------------------------------------

      IF(
     .  ( KX.LT.120 .OR. KX.GT.299         ) .OR.
     .  ( KLEV.LE.0                        ) .OR.
     .  ( DDLAT.LT.-90.  .OR. DDLAT.GT.90. ) .OR.
     .  ( DDLON.LT.-180. .OR. DDLON.GT.360.)
     .                                     ) THEN
         PRINT*,'FROM STOERR---SKIP THIS MESS---FROM STOERR'
         PRINT'(''STATION= '',A8)',STID
         PRINT*,'LAT    = ',DDLAT
         PRINT*,'LON    = ',DDLON
         PRINT*,'KX     = ',KX
         PRINT*,'NLEVS  = ',KLEV
         PRINT*,'FROM STOERR---SKIP THIS MESS---FROM STOERR'
         GOTO 30
      ENDIF

C  LOOP THRU THE REPORT LEVELS
C  ---------------------------

      DO 20 KL=1,KLEV
      L = ILEV+KL-1

C  CHECK TO SEE IF A SURFACE OBSERVATION IS PRESENT
C  ------------------------------------------------

      IF(FOE(L).EQ.0.) THEN
         GOTO 20
      ENDIF

C  GET FORECAST ERRORS FOR THIS REPORT
C  -----------------------------------

      DELP  = FPR(L)*.053
      DDPRS = FPR(L)
      DDPRA = DDPRS - DELP
      DDPRB = DDPRS + DELP

      ZERA  = GETZER(DDLAT,DDLON,DDPRA)
      ZERB  = GETZER(DDLAT,DDLON,DDPRB)
      WERR  = GETWER(DDLAT,DDLON,DDPRS)

C  FIND THE OB ERROR FOR THIS REPORT
C  ---------------------------------

      IF(KKX.EQ.1) THEN
         OBERA = PILNLNP(DDPRA,PMAND,QIKE(1,KX),21)
         OBERB = PILNLNP(DDPRB,PMAND,QIKE(1,KX),21)
         FPE   = 1./(1.+CVC*LOG(DDPRA/DDPRB)**2)
         OBER  = SQRT(OBERA**2 + OBERB**2 - 2*OBERA*OBERB*FPE)
      ELSE IF(KKX.EQ.2) THEN
         OBER  = PILNLNP(DDPRS,P50,QIKE(1,KX),21)
      ENDIF

C  STORE THE ERRORS IN THEIR RIGHTFUL PLACE
C  ----------------------------------------

      IF(ZERA.EQ.0 .OR. ZERB.EQ.0. .OR. WERR.EQ.0.) THEN
         print*,'zera=',zera
         print*,'zerb=',zerb
         print*,'werr=',werr
         print*,'ddprs,ddpra,ddprb',ddprs,ddpra,ddprb
         PRINT *,'STOERR - FORECAST ERROR IS ZERO'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
      ENDIF

      FPE  = 1./(1.+CVC*LOG(DDPRA/DDPRB)**2)
      TER  = SQRT(ZERA**2+ZERB**2-2*ZERA*ZERB*FPE)
      WER  = WERR
      FPE1 = 1./(1.+CVC*LOG(DDPRA/DDPRS)**2)
      FPE2 = 1./(1.+CVC*LOG(DDPRB/DDPRS)**2)
      TZF  = MAX((ZERA*FPE1 - ZERB*FPE2),0.) / TER

      FFE(L,1) = TER
      FFE(L,2) = WER
      FTZ(L)   = TZF

C  SPECIAL TREATMENT FOR SPECIAL CASES
C  -----------------------------------

      IF(CLASS.EQ.'SFC' .AND. KL.EQ.2) THEN
         FFE(L,1) = (ZERA+ZERB)/2.
         OBER = (OBERA+OBERB)/2.
         FTZ(L) = 1.
      ENDIF

      IF(CLASS.NE.'SAT' .AND. DDPRS.GT.700.) THEN
         UPERR = 1.5*DDPRS/700.
         FFE(L,1) = FFE(L,1)*UPERR
      ENDIF

C  STORE AN OIQC OBSERVATION ERROR MAYBE
C  -------------------------------------

      IF(USEOE) FOE(L) = OBER

C  END OF THE LOOPS
C  ----------------

20    CONTINUE
30    CONTINUE

      IF(MYID.EQ.0) PRINT*,' IN STORERR - NREP=',NREP
      IF(MYID.EQ.0) PRINT*

      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION  BLOCK
C
C SUBPROGRAM:    STORE
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1992-07-28
C
C ABSTRACT: STORES ALL DATA AND CORRESPONDING INDEX FOR LATER USE IN
C   DATA COLLECT AND SEARCH ROUTINES.
C
C PROGRAM HISTORY LOG:
C 1986-03-21  G. DIMEGO  - ORIGINAL AUTHOR
C 1988-11-24  D. DEAVEN  - CODED FOR CYBER 205
C 1990-11-06  J. WOOLLEN - MODIFIED COMMON /BUFFS/ FOR QCOI
C 1992-07-28  J. WOOLLEN - MODIFIED FOR STORSTAR VERSION
C 2019-06-20  S. MELCHIOR - Explicit declaration of bmiss
C
C USAGE:    CALL STORE(LUDAT,LUBFI)
C   INPUT ARGUMENT LIST:
C     LUDAT    - LOGICAL UNIT FOR NCEP PRODCUTION DATE FILE
C     LUBFI    - LOGICAL UNIT FOR OBSERVATION (PREPBUFR) PRIOR TO
C                UPDATED QUALITY MARKS
C
C   INPUT FILES:
C     UNIT LUDAT - NCEP PRODUTION DATE FILE
C     UNIT LUBFI - OBSERVATION (PREPBUFR) PRIOR TO UPDATED QUALITY
C                  MARKS
C
C   OUTPUT FILES:
C     UNIT 06    - STANDARD OUTPUT PRINT
C     UNIT LUDAT - NCEP PRODUTION DATE FILE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE STORE(LUDAT,LUBFI)
 
      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC
 
 
      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /OBHEIR/ QUALOB(300),binqadj
      COMMON /RETCODE/ IRETCODE
 
      CHARACTER*80 SUCCESS(3),WARNING(3)
      CHARACTER*80 HDSTR,OBSTR,FCSTR,OESTR,QMSTR
      CHARACTER*8  SUBSET
      CHARACTER*3  TAG
      DIMENSION    HDR(5),OBS(7,255),FCS(6,255),QMS(5,255),OES(5,255)
      LOGICAL      QX(300),STUCK,PCHK
      REAL*8       HDR,OBS,FCS,QMS,OES,SID,BMISS
 
      DATA SUCCESS/'**************************************************',
     .             '**************** STORE SUCCESSFUL ****************',
     .             '**************************************************'/
      DATA WARNING/'**************************************************',
     .             '!!  WARNING: NOT ALL OBS CAN BE STORED :WARNING !!',
     .             '**************************************************'/
 
 
      DATA HDSTR /'SID XOB YOB DHR TYP                   '/
      DATA OBSTR /'POB QOB TOB ZOB UOB VOB CAT           '/
      DATA FCSTR /'PFC QFC TFC ZFC UFC VFC               '/
      DATA QMSTR /'PQM QQM TQM ZQM WQM                   '/
      DATA OESTR /'POE QOE TOE ZOE WOE                   '/
 
      DATA VMAX   / 10E10     /
      DATA ROG    / 29.261    /
      DATA QX     / 300*.TRUE./
 
      include "mpif.h"

C----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
C----------------------------------------------------------------------
 
C  INITIALIZE
C  ----------
 
      STUCK   = .FALSE.
      NREP0   = 0
      NLEV0   = 0
      MAXNLEV = 0
 
C  CHECK THE DATA DATE - PROCEED ANYWAY IF NO NMCDATE FILE TO BE FOUND
C  -------------------------------------------------------------------
 
      CALL DATEBF(LUBFI,IY,IM,ID,IH,IDATE)
      READ(LUDAT,'(8X,I8)',END=1,ERR=900) JDATE
      IF(IDATE.NE.JDATE) GOTO 901     
1     IF(IDATE.NE.JDATE) THEN         
         REWIND LUDAT
         WRITE(LUDAT,'(8X,I8)') IDATE
      ENDIF

C  GET READY TO READ BUFR
C  ----------------------

      bmiss=10e10; call setbmiss(bmiss)
      call ufbmem(lubfi,0,nmsg,iunit)
      call mpisplit(myid,nmsg,m1,m2)
      imsg = m1
 
      if(myid.eq.0) then
         PRINT*
         PRINT*,'******  READING DATA IN STORE  ******'
         PRINT*
      endif
 
C  LOOP THROUGH THE INPUT MESSAGES - READ THE NEXT SUBSET
C  ------------------------------------------------------
 
      DO M=M1,M2
      CALL READMM(IMSG,SUBSET,IDATE,IRET)
10    do while(IREADSB(LUBFI).EQ.0) 
 
      CALL UFBINT(LUBFI,HDR,5,  1,IRET,HDSTR)
      CALL UFBINT(LUBFI,OBS,7,255,KLEV,OBSTR)
      CALL UFBINT(LUBFI,FCS,6,255,KLEV,FCSTR)
      CALL UFBINT(LUBFI,QMS,5,255,KLEV,QMSTR)
      CALL UFBINT(LUBFI,OES,5,255,KLEV,OESTR)
      CALL UFBCNT(LUBFI,IREC,IFLD)
 
C  DECIDE WHETHER OIQC SHOULD PROCESS - SET A TAG
C  ----------------------------------------------
 
      KX = HDR(5)
 
      IF(QX(KX)) THEN
         IF(KX.GE.180 .AND. KX.LE.199) THEN
            TAG = 'SFC'
         ELSEIF(KX.GE.160 .AND. KX.LE.179) THEN
            TAG = 'SAT'
         ELSEIF(KX.EQ.283) THEN
            TAG = 'SMI'
         ELSE
            TAG = 'UPA'
         ENDIF
      ELSE
         GOTO 10
      ENDIF
 
C  STORE THE HEADER
C  ----------------
 
      NREP0 = NREP0+1
      ILEV = 0
 
      IF(NREP0.LE.MAXREP .AND. .NOT.STUCK) THEN
         NREP = NREP0
         NLEV = NLEV0
         SID(NREP) = HDR(1)
         FLN(NREP) = HDR(2)
         FLT(NREP) = HDR(3)
         FTM(NREP) = HDR(4)
         FKX(NREP) = KX
         FNL(NREP) = ILEV
         FLV(NREP) = NLEV+1
         FOC(NREP) = TAG
         FQL(NREP) = QUALOB(KX)
      ELSE
         STUCK = .TRUE.
      ENDIF
 
C  STORE THE OB LEVELS
C  -------------------
 
      DO 20 LEV=1,KLEV
 
      POB = OBS(1,LEV)
      TOB = OBS(3,LEV)
      ZOB = OBS(4,LEV)
      UOB = OBS(5,LEV)
      VOB = OBS(6,LEV)
      CAT = OBS(7,LEV)
 
      PFC = FCS(1,LEV)
      TFC = FCS(3,LEV)
      ZFC = FCS(4,LEV)
      UFC = FCS(5,LEV)
      VFC = FCS(6,LEV)
 
      PQM = QMS(1,LEV)
      TQM = QMS(3,LEV)
      ZQM = QMS(4,LEV)
      WQQ = QMS(5,LEV)
 
      POE = OES(1,LEV)
      TOE = OES(3,LEV)
      ZOE = OES(4,LEV)
      WER = OES(5,LEV)
 
      IF(PQM.GE.8) GOTO 20
      IF(PQM.EQ.8) TQM = MAX(PQM,TQM)
      IF(PQM.EQ.8) ZQM = MAX(PQM,ZQM)
      IF(PQM.EQ.8) WQQ = MAX(PQM,WQQ)
 
      PCHK = TAG.EQ.'SFC'
 
      IQM = 0
      OB1 = 0
      OB2 = 0
      IOI = 0
      OER = 0
 
      IF(TQM.LT.8) THEN
         IQM = TQM
         PRG = .053*POB
         PA  = POB - PRG
         PB  = POB + PRG
         OB1 = TOB-TFC
         OB2 = ROG*OB1*LOG(PB/PA)
         OER = 1
         IOI = 1
      ELSEIF(TQM.EQ.8) THEN
         IOI = -2
      ELSEIF(WQQ.LT.8) THEN
         IQM = WQQ
         OB1 = UOB-UFC
         OB2 = VOB-VFC
         OER = 1
         IOI = 1
      ELSEIF(WQQ.EQ.8) THEN
         IOI = -2
      ELSEIF(.NOT.PCHK) THEN
         GOTO 20
      ENDIF
 
15    CONTINUE
      ILEV = ILEV+1
      NLEV0 = NLEV0+1
      IF(NLEV0.LE.MAXLEV .AND. .NOT.STUCK) THEN
         NLEV = NLEV0
         IF(TAG.EQ.'SMI') THEN
            FMW(NREP,1) = UFC
            FMW(NREP,2) = VFC
            OB1  = 0.
            OB2  = SQRT(UOB**2+VOB**2)
         ENDIF
         IF(ABS(OB1).GT.3000.) OB1 = 3000.
         IF(ABS(OB2).GT.3000.) OB2 = 3000.
         FNL  (NREP) =   ILEV
         FHD  (NLEV) =   NREP
         FPRC (NLEV) =   IREC
         FPFD (NLEV) =   IFLD
         FPLV (NLEV) =   LEV
         FPR  (NLEV) =   POB
         FOB  (NLEV,1) = OB1
         FOB  (NLEV,2) = OB2
         FQM  (NLEV) =   IQM
         FOE  (NLEV) =   OER
         FOI  (NLEV) =   IOI
      ELSE
         STUCK = .TRUE.
      ENDIF
 
      IF(PCHK) THEN
         PCHK = .FALSE.
         IQM  = MAX(PQM,ZQM)
         IF(IQM.LT.8) THEN
            IOI  = 1
            OB1  = 0
            OB2  = ZOB-ZFC
            OER  = 1
         ELSEIF(IQM.EQ.8) THEN
            IOI = -2
            OB1 = 0
            OB2 = 0
            OER = 0
         ELSE
            IOI = 0
            OB1 = 0
            OB2 = 0
            OER = 0
         ENDIF
         GOTO 15
      ENDIF
 
20    CONTINUE
 
C  KEEP TRACK OF MAX LEVELS - GO READ ANOTHER REPORT
C  -------------------------------------------------
 
      MAXNLEV = MAX(ILEV,MAXNLEV)
      IF(ILEV.EQ.0) THEN
         NREP0 = NREP0-1
         IF(.NOT.STUCK) NREP = NREP-1
      ENDIF

      ENDDO     
      ENDDO
 
c  syncronize the input buffers
c  ----------------------------
 
      call syncstor(nrep0,nlev0,maxnlev)
 
C  all procs do the following - set tags 
C  -------------------------------------
 
      DO I=1,NREP
      KX = FKX(I)
      IF(KX.GE.180 .AND. KX.LE.199) THEN
         TAG = 'SFC'
      ELSEIF(KX.GE.160 .AND. KX.LE.179) THEN
         TAG = 'SAT'
      ELSEIF(KX.EQ.283) THEN
         TAG = 'SMI'
      ELSE
         TAG = 'UPA'
      ENDIF
      FOC(I) = TAG
      ENDDO
 
C  ALL DONE - RECORD THE OUTCOME
C  -----------------------------
 
      IF(MYID.EQ.0) THEN
         IF(NREP.EQ.NREP0 .AND. NLEV.EQ.NLEV0) IRETCODE = 0
         IF(NREP.NE.NREP0 .OR . NLEV.NE.NLEV0) IRETCODE = 4
                           WRITE(6,'(A80)')
         IF(IRETCODE.NE.0) WRITE(6,'(A80)') WARNING
         IF(IRETCODE.EQ.0) WRITE(6,'(A80)') SUCCESS
                           WRITE(6,101    ) NMSG
                           WRITE(6,102    ) NREP0,NREP
                           WRITE(6,103    ) NLEV0,NLEV
                           WRITE(6,104    ) MAXNLEV
         IF(IRETCODE.NE.0) WRITE(6,'(A80)') WARNING
         IF(IRETCODE.EQ.0) WRITE(6,'(A80)') SUCCESS
                           WRITE(6,'(A80)')
      ENDIF
 
101   FORMAT('TOTAL RECORDS: ',I6)
102   FORMAT('TOTAL REPORTS: ',I6,'  ---  STORED: ',I6)
103   FORMAT('TOTAL OBS    : ',I6,'  ---  STORED: ',I6)
104   FORMAT('MAX OBS/PRFLE: ',I6)
105   CONTINUE
 
      RETURN
900   PRINT *, 'STORE - BAD OR MISSING NCEP DATE FILE'
      CALL W3TAGE('PREPOBS_OIQCBUFR')
      CALL ERREXIT(99)
901   PRINT *, 'STORE - BUFR AND NCEP DATES DONT MATCH'
      PRINT902,IDATE,JDATE
      CALL W3TAGE('PREPOBS_OIQCBUFR')
      CALL ERREXIT(99)
902   FORMAT(' BUFR DATE= ',I10.8,' NCEP DATE= ',I10.8)
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE MPISPLIT(MYID,NSPLIT,NS1,NS2)
 
      include "mpif.h"
 
C-----------------------------------------------------------------------
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
C-----------------------------------------------------------------------
 
      npart = nsplit/nprc + min(mod(nsplit,nprc),1)
      ns1 = npart*myid+1
      ns2 = min(npart*(myid+1),nsplit)
      return
      end
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE syncstor(nrep0,nlev0,maxnlev)
 
      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC
 
      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      real*8 sid

      dimension nreps(5)

      data mrep/MAXREP/,mlev/MAXLEV/
 
      include "mpif.h"
      dimension istat(mpi_status_size)
      dimension dummy(MAXLEV)
      real*8 dummy
 
C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
      mcom = mpi_comm_world
      mrea = mpi_real
      mre8 = mpi_real8
      mint = mpi_integer
      mchr = mpi_character
      mdes = 0
C-----------------------------------------------------------------------

      nreps(1) = nrep
      nreps(2) = nlev
      nreps(3) = nrep0
      nreps(4) = nlev0
      nreps(5) = maxnlev

      if(myid.ne.mdes) then
         call mpi_send(nreps,5,mint,mdes,myid,mcom,ierr)
         call mpi_send(sid     ,nrep,mre8,mdes,myid,mcom,ierr)
         call mpi_send(flv     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(flt     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fln     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(ftm     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fkx     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fnl     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fms     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fmw(1,1),nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fmw(1,2),nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fql     ,nrep,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fhd     ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fprc    ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fpfd    ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fplv    ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fpr     ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fqm     ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(foi     ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(foe     ,nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fob(1,1),nlev,mrea,mdes,myid,mcom,ierr)
         call mpi_send(fob(1,2),nlev,mrea,mdes,myid,mcom,ierr)
      else
         do i=1,nprc-1
         call mpi_recv(nreps,5,mint,i,i,mcom,istat,ierr)
         jrep = nreps(1)   
         jlev = nreps(2)
         nrep0 = nrep0+nreps(3)
         nlev0 = nlev0+nreps(4)
         maxnlev = max(maxnlev,nreps(5))
         if(nrep+jrep.le.mrep .and. nlev+jlev.le.mlev) then
            k = nrep+1
            l = nlev+1
            call mpi_recv(sid (k  )   ,jrep,mre8,i,i,mcom,istat,ierr)
            call mpi_recv(flv (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(flt (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fln (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(ftm (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fkx (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fnl (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fms (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fmw (k,1)   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fmw (k,2)   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fql (k  )   ,jrep,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fhd (l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fprc(l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fpfd(l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fplv(l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fpr (l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fqm (l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(foi (l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(foe (l  )   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fob (l,1)   ,jlev,mrea,i,i,mcom,istat,ierr)
            call mpi_recv(fob (l,2)   ,jlev,mrea,i,i,mcom,istat,ierr)
            flv(k:nrep+jrep) = flv(k:nrep+jrep)+l-1
            fhd(l:nlev+jlev) = fhd(l:nlev+jlev)+k-1
            nrep = nrep+jrep
            nlev = nlev+jlev
         else
            call mpi_recv(dummy(1),jrep,mre8,i,i,mcom,istat,ierr)
            do n=1,20
            call mpi_recv(dummy(1),jlev,mrea,i,i,mcom,istat,ierr)
            enddo
         endif
         enddo
      endif
 
      call mpi_bcast(nrep,1,mint,mdes,mcom,ierr)
      call mpi_bcast(nlev,1,mint,mdes,mcom,ierr)
      call mpi_bcast(sid     ,nrep,mre8,mdes,mcom,ierr)
      call mpi_bcast(flv     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(flt     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fln     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(ftm     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fkx     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fnl     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fms     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fmw(1,1),nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fmw(1,2),nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fql     ,nrep,mrea,mdes,mcom,ierr)
      call mpi_bcast(fhd     ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fprc    ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fpfd    ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fplv    ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fpr     ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fqm     ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(foi     ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(foe     ,nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fob(1,1),nlev,mrea,mdes,mcom,ierr)
      call mpi_bcast(fob(1,2),nlev,mrea,mdes,mcom,ierr)
 
      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    TOSSLIST
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: WRITES A LIST OF REJECTED OBSERVATIONS PLUS A SUMMARY.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL TOSSLIST(LO)
C   INPUT ARGUMENT LIST:
C     LO       - LOGICAL UNIT FOR TOSSLIST OUTPUT
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT LO  - OFFICIAL OPERATIONAL TOSSLIST
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE TOSSLIST(LO)

      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC


      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)

      CHARACTER*3 TAG
      DIMENSION   IBAD(30,3),ITOT(30),ISFZ(30),PZ(30),PU(30),PT(30)
      LOGICAL     SFZ,SAT
      REAL*8      SID,STAID

      DATA XMSG/32767./

C----------------------------------------------------------------------
C-----------------------------------------------------------------------

C  START UP
C  --------

      IBAD = 0
      ITOT = 0
      ISFZ = 0
      PZ   = 0
      PU   = 0
      PT   = 0

C  COUNT BAD DATA IN THE BIG BUFFER - WRITE THE TOSSLIST
C  -----------------------------------------------------

      N   = 0

      DO 10 IREP=1,NREP
      X      = FLN(IREP)
      Y      = FLT(IREP)
      STAID  = SID(IREP)
      KX     = FKX(IREP)
      TAG    = FOC(IREP)
      ILEV   = FLV(IREP)
      KLEV   = ILEV+FNL(IREP)-1

      DO 10 JLEV=ILEV,KLEV

      SFZ = TAG.EQ.'SFC' .AND. JLEV.EQ.KLEV
      SAT = TAG.EQ.'SAT'

      IF(FOI(JLEV).NE.0) THEN
         IF(SFZ) THEN
            ISFZ(KX/10) = ISFZ(KX/10) + 1
         ELSE
            ITOT(KX/10) = ITOT(KX/10) + 1
         ENDIF
      ENDIF

      IF(FOI(JLEV).LT.0) THEN
         IP     = FPR(JLEV)
         IQ     = FQM(JLEV)
         OBER   = FOE(JLEV)
         BUFF11 = FOB(JLEV,1)
         BUFF12 = FOB(JLEV,2)
         IF(FOI(JLEV).EQ.-1) THEN
            IF(SFZ) THEN
               N = N+1
               WRITE(LO,2002) N,STAID,X,Y,IP,KX,IQ,OBER,BUFF11,BUFF12
               IBAD(KX/10,3) = IBAD(KX/10,3) + 1
            ELSE
               IF(.NOT.SAT) THEN
                  N = N+1
                  WRITE(LO,2000) N,STAID,X,Y,IP,KX,IQ,OBER,BUFF11,BUFF12
               ENDIF
               IBAD(KX/10,1) = IBAD(KX/10,1) + 1
            ENDIF
         ELSE IF(FOI(JLEV).EQ.-2) THEN
            N = N+1
            WRITE(LO,2001) N,STAID,X,Y,IP,KX,IQ,OBER,BUFF11,BUFF12
            IBAD(KX/10,2) = IBAD(KX/10,2) + 1
         ENDIF
      ENDIF
10    CONTINUE

C  COMPUTE GROSS PERCENTAGE OF TOSSES
C  ----------------------------------

      DO 20 I=10,29
      IF(ISFZ(I).GT.0) THEN
         PZ(I) = FLOAT(IBAD(I,3))/FLOAT(ISFZ(I))
      ENDIF
      IF(ITOT(I).GT.0) THEN
         PU(I) = FLOAT(IBAD(I,2))/FLOAT(ITOT(I))
         PT(I) = FLOAT(IBAD(I,1))/FLOAT(ITOT(I))
      ENDIF
20    CONTINUE

C  WRITE A SHORT SUMMARY OF TOSSES
C  -------------------------------

      WRITE( 6,2003)(I,I=100,290,10),(IBAD(I,3),I=10,29),(PZ(I),I=10,29)
      WRITE( 6,2004)(I,I=100,290,10),(IBAD(I,2),I=10,29),(PU(I),I=10,29)
      WRITE( 6,2005)(I,I=100,290,10),(IBAD(I,1),I=10,29),(PT(I),I=10,29)

C  FORMAT STATEMENTS FOR THE TOSS LIST
C  -----------------------------------

2000  FORMAT(' ',I5,1X,'J',3X,A8,2X,4X,2F10.2,I9,2X,2I5,F8.1,F13.1,
     .           5X,F13.1,10X,F6.1)
2001  FORMAT(' ',I5,1X,'P',3X,A8,2X,4X,2F10.2,I9,2X,2I5,F8.1,F13.1,
     .           5X,F13.1,10X,F6.1)
2002  FORMAT(' ',I5,1X,'Z',3X,A8,2X,4X,2F10.2,I9,2X,2I5,F8.1,F13.1,
     .           5X,F13.1,10X,F6.1)
2003  FORMAT(/' SURFACE Z TOSSES   '/20I5/20I5/20F5.2)
2004  FORMAT(/' BELOW GROUND TOSSES'/20I5/20I5/20F5.2)
2005  FORMAT(/' QC OI TOSSES       '/20I5/20I5/20F5.2)

      RETURN
      END
CCBREAKCC
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    VSOLVE
C   PRGMMR: WOOLLEN          ORG: NP20       DATE: 1990-11-06
C
C ABSTRACT: CHOLESKY TYPE SOLUTION FOR ARRAYS OF POSITIVE DEFINITE
C   SYMMETRIC MATRIXES.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN - ORIGINAL AUTHOR
C
C USAGE:    CALL VSOLVE(A,B,NDIM,BAD,NS,MAXDIM)
C   INPUT ARGUMENT LIST:
C     A        - ARRAY OF SYMMETRIC MATRIXES
C     B        - ARRAY OF RIGHT HAND SIDE VECTORS
C     NDIM     - ARRAY OF MATRIX RANKS
C     BAD      - BAD MATRIX INDICATOR
C     NFT      - NUMBER OF RIGHT HAND SIDES PER MATRIX
C     NS       - NUMBER OF MATRIXES TO SOLVE
C     MAXDIM   - LARGEST RANK MATRIX IN STACK
C
C   OUTPUT ARGUMENT LIST:
C     B        - CONTAINS THE SOLUTIONS UPON RETURN
C
C REMARKS: TRIANGULAR REPRESENTATION LISTS ELEMENTS TOWARDS THE
C   DIAGONAL. ALGORITHM FROM H.CARUS.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE VSOLVE (A,B,NDIM,BAD,NS,MAXDIM)

      PARAMETER( NMX  =  64        ,
     .           NN   =  10*(10+1)/2 ,
     .           N    =  10          )

      DIMENSION A(NMX,NN),B(NMX,N,2),NDIM(NMX),BAD(NMX)
      LOGICAL BAD

      DIMENSION T(NMX)

      DATA CNUM/1.E-15/, NFT/2/

C----------------------------------------------------------------------
      IX (I,J) = I*(I-1)/2 + J
C----------------------------------------------------------------------

      DO 1 M=1,NS
1     BAD(M) = .FALSE.

C  DECOMPOSE THE MATRIXES
C  ----------------------

      DO 10 I=1,MAXDIM
      DO 10 J=1,I

      DO 2 M=1,NS
2     T(M) = A(M,IX(I,J))

      DO 3 K=1,J-1
      DO 3 M=1,NS
3     T(M) = T(M) - A(M,IX(I,K)) * A(M,IX(J,K))

      IF(I.GT.J) THEN
         DO 4 M=1,NS
4        A(M,IX(I,J)) = T(M) * A(M,IX(J,J))
      ELSE
         DO 5 M=1,NS
         IF(T(M).LT.CNUM .AND. NDIM(M).GE.I) BAD(M) = .TRUE.
         IF(T(M).LE.0) T(M) = 1.
5        CONTINUE

         DO 6 M=1,NS
6        A(M,IX(I,I)) = 1./SQRT(T(M))
      ENDIF

10    CONTINUE

C  SOLVE FOR ALL RIGHT HAND SIDES
C  ------------------------------

      DO 40 NF=1,NFT

C  FORWARD SUBSTITUTION
C  --------------------

      DO 20 I=1,MAXDIM

      DO 11 M=1,NS
11    T(M) = B(M,I,NF)

      DO 12 J=1,I-1
      DO 12 M=1,NS
12    T(M) = T(M) - A(M,IX(I,J)) * B(M,J,NF)

      DO 20 M=1,NS
20    B(M,I,NF) = T(M) * A(M,IX(I,I))

C  BACKWARD SUBSTITUTION
C  ---------------------

      DO 30 I=MAXDIM,1,-1

      DO 21 M=1,NS
21    T(M) = B(M,I,NF)

      IF(I.NE.MAXDIM) THEN
         DO 22 J=I+1,MAXDIM
         DO 22 M=1,NS
22       T(M) = T(M) - A(M,IX(J,I)) * B(M,J,NF)
      ENDIF

      DO 30 M=1,NS
30    B(M,I,NF) = T(M) * A(M,IX(I,I))

40    CONTINUE

      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE syncndd(arr,n,mdtp)

      PARAMETER (MAXLEV=1100000)

      common /nddspt/ nd1(0:100),nd2(0:100)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)

      dimension arr(n)

      include "mpif.h"
      dimension istat(mpi_status_size)
      dimension ireq(100)

C-----------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
      mcom = mpi_comm_world
      mdes = 0
C-----------------------------------------------------------------------

      if(myid.ne.mdes) then
         ib = indd(nd1(myid))
         ie = indd(nd2(myid))
         mlen = ie-ib+1
         if(nd2(myid).gt.0) 
     .   call mpi_send(arr(ib),mlen,mdtp,mdes,myid,mcom,ierr)
      else
         do i=1,nprc-1
         ib = indd(nd1(i))
         ie = indd(nd2(i))
         mlen = ie-ib+1
         if(nd2(i).gt.0) 
     .   call mpi_recv(arr(ib),mlen,mdtp,i,i,mcom,istat,ierr)
         enddo
      endif
    
      call mpi_bcast (arr,n,mdtp,mdes,mcom,ierr) 

      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE NDDSPLIT(MYID,nd1,nd2)
 
      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC
 
 
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
 
      include "mpif.h"
 
C-----------------------------------------------------------------------
      call mpi_comm_size(MPI_COMM_WORLD,nprc,ierr)
C-----------------------------------------------------------------------
 
C  SUM THE REPORTS PER AMAP BOX
C  ----------------------------
 
      JTOT = 0
      DO N=1,NDD
      JTOT = JTOT+JNDD(N)
      ENDDO

C  COMPUTE THE range within the FREQUENCY DISTRIBUTION
C  ---------------------------------------------------
 
      npart = jtot/nprc + min(mod(jtot,nprc),1)
      ns1 = min(npart*myid,jtot)
      ns2 = min(npart*(myid+1),jtot)
c     print*,'ns',ns1,ns2

c  pick the start and end points for this processor
c  ------------------------------------------------
 
      jntt = 0
      do n=1,ndd
      nd1 = n
      jntt = jntt+jndd(n)
c     print*,'n',n,jntt,ndd
      if(jntt.ge.ns1) then
         do m=min(n+1,ndd),ndd
         nd2 = m
         jntt = jntt+jndd(m)
c        print*,'m',m,jntt,ns2
         if(jntt.ge.ns2) return
         enddo
         if(ndd.eq.1) return
         PRINT *, 'nddsplit inside alignment error'
         CALL W3TAGE('PREPOBS_OIQCBUFR')
         CALL ERREXIT(99)
      endif
      enddo
 
c  bad news if it gets this far!
c  -----------------------------
 
      PRINT *, 'nddsplit outside alignment error'
      CALL W3TAGE('PREPOBS_OIQCBUFR')
      CALL ERREXIT(99)
      end
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      function jndd(n)
 
      PARAMETER (MAXREP=900000)
      PARAMETER (MAXLEV=1100000)

      COMMON /OIQCDATA/   FLV (MAXREP     ) , FLT (MAXREP     ) ,
     .FLN (MAXREP     ) , FTM (MAXREP     ) , FKX (MAXREP     ) ,
     .FNL (MAXREP     ) , FMS (MAXREP     ) , FMW (MAXREP,2   ) ,
     .FQL (MAXREP     ) , FHD (MAXLEV     ) , FPRC(MAXLEV     ) ,
     .FPFD(MAXLEV     ) , FPLV(MAXLEV     ) , FPR (MAXLEV     ) ,
     .FQM (MAXLEV     ) , FOI (MAXLEV     ) , FOB (MAXLEV,2   ) ,
     .FOE (MAXLEV     ) , FFE (MAXLEV,2   ) , FTZ (MAXLEV     ) ,
     .FTW (MAXLEV,10,2) , FPF (MAXLEV,5,2 ) , FOC (MAXREP     )
      CHARACTER*3 FOC
 
 
      COMMON /OBS/ NREP,NLEV,SID(MAXREP),INOB(MAXREP),IMAP(360,181)
      COMMON /CKLIST/ NDD,INDD(MAXLEV)
      REAL*8 SID
 
      DATA PI180  /.0174532/

      save iold,jold

C-----------------------------------------------------------------------
      !ltb(l) = min(max(1,l),181)
      !lnb(l) = min(max(1,l),360)
C-----------------------------------------------------------------------
 
      if(n.eq.1) iold = 0
      irep = fhd(indd(n))
      if(iold.eq.irep) then
         jndd = jold
         return
      else
         iold = irep
         jndd = 1
      endif

      lon = ifix(fln(irep))+1
      lat = ifix(flt(irep))+91.
      ldn = 10
      do ltt=lat-5,lat+5
      if(ltt.ge.2.and.ltt.le.180) then
         ln1 = lon-ldn
         ln2 = lon+ldn               
         lt1 = ltx(ln1,ltt)
         lt2 = ltx(ln2,ltt)
         jndd = jndd+min(abs(imap(ln1,lt1)-imap(ln2,lt2)),ldn*100)
      endif
      enddo

      jold = jndd
      return
      end
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      function ltx(lon,lat)
C-----------------------------------------------------------------------
      ltb(l) = min(max(1,l),181)
C-----------------------------------------------------------------------
      if(lon.lt.1) then
         do while(lon<1);lon=360+lon;enddo
         ltx = ltb(lat-1)
      elseif(lon.gt.360) then
         do while(lon>360);lon=lon-360;enddo
         ltx = ltb(lat+1)
      else
         ltx = lat
      endif
      return
      end
c-----------------------------------------------------------------------------------
c-----------------------------------------------------------------------------------
      subroutine prttime(title)
      character(*) title
      data t0/0.00/
      data t1/0.00/
      save t0,t1
c-----------------------------------------------------------------------------------
      include "mpif.h"
c-----------------------------------------------------------------------------------
      call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr);if(myid/=0)return
c-----------------------------------------------------------------------------------
      if(t0==0.00) t0=secnds(t0)
      print1,title,secnds(t0)-t1,secnds(t0)
      t1=secnds(t0)
1     format('time>>>',a20,3(2x,f8.2))
      return
      end

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: PREPOBS_PROFCQC
C   PRGMMR: DONG             ORG: NP22        DATE: 2020-01-09
C
C ABSTRACT: PERFORMS COMPLEX QUALITY CONTROL OF PROFILER DOPPLER
C   WINDS.  THE INPUT AND OUTPUT ARE IN PREPBUFR FORMAT.  THE
C   CHECKS USED ARE: INCREMENT, VERTICAL STATISTICAL, TEMPORAL
C   STATISTICAL, AND COMBINED VERTICAL-TEMPORAL.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins  I/O is completely new, but the algorithms
C     are identical to those already used in the RUC.
C 1997-05-27  W. Collins  24 hours maximum can be qc'd. The NAMELIST
C     reads in the hour limits with respect to the central data time.
C 1998-09-16  W. Collins  Replace faulty date routine with W3MOVDAT.
C 1998-12-22  W. Collins  Correct copy of reports to output.  Previous
C     implementation introduced skip of first block.
C 2000-12-04  W. Collins  Generalize heights of observations to allow
C     any set heights for each station. Honor pre-existing quality
C     marks.
C 2000-12-14  W. Collins  Modify to perform qc at all hours of data,
C     including first and last.  Also prints results for all hours.
C 2001-02-07  W. Collins  Correct error in DMA that did not flag all
C     bad data.  Logic change that allows some off-time data to be
C     qc'd.
C 2001-04-25  W. Collins  Modify to allow up to 143 levels of profiler
C     winds. (Previous limit was 43.)
C 2004-09-09  D. Keyser   Major changes: 1) To correct errors: Lvl
C     index in all arrays now site specific to allow proper temporal
C     checking at each individual site (each site examined over all
C     rpt times to generate hgt profile containing all possible lvls,
C     times w/ new lvls inserted get missing wind). Incr., temporal,
C     vert. & median chk error limits now directly assoc. w/ a rpted
C     hgt above ground lvl rather than w/ lvl index in arrays (ensures
C     proper error limit used at all lvls & eliminates hgt above ground
C     vs. hgt above sea lvl discrepancy - error limits values remain
C     unchanged). Kurtotis stat. now computed correctly. 2) To
C     account for new CAP & JMA rpts: Max. no. of sites processed
C     incr. from 40 to 120. No. of time periods input now site specific
C     (was hardwired to be same for all rpts). Temporal check for CAPs
C     attempt to get 2-hr. spanning del-time so error limits are valid
C     (since based on NPNs), else del-time must be .ge. half-hr on one
C     side, else temporal check not performed.  Max. del-time on one
C     side is 2-hrs for all rpts. 3) Changes which improve q.c. alg.:
C     Namelist switches added to specify output time window - allows
C     input to have wider time window so temporal chk at all output
C     times can be based on 2-sided diff {before temporal chk on
C     output rpts on time (assimilation) bdry based on 1-sided diff}.
C     4) Cosmetic changes: DOCBLOCKS & comments more descriptive.  DO-
C     LOOP logic more concise (esp. in temporal & vert. chks). Stdout
C     easier to read & more complete.  Excessive stdout print of
C     differencing results can be removed w/ new namelist switch which
C     controls the degree of printout. Reason codes are expanded (see
C     remarks). Rpt lvl info. in various output listings expanded &
C     sorted into bins containing both all data lvls & only lvls w/
C     either suspect or bad q. marks; output written to text files but
C     not incl. in stdout. Stat. output clarified & written to 2 text
C     files separate from stdout.  Computation & printout of stats, as
C     well as combination of stat types printed out controlled via new
C     namelist switches. Stats generated separately for NPN, CAP & JMA
C     rpts and stratified according to hgt above ground.
C 2012-11-20  J. WOOLLEN  INITIAL PORT TO WCOSS 
C 2013-02-05  D. Keyser   Final changes to run on WCOSS: Set BUFRLIB
C     missing (BMISS) to 10E8 rather than 10E10 to avoid integer
C     overflow; rename all REAL(8) variables as *_8; use formatted
C     print statements where previously unformatted print was > 80
C     characters.
C 2016-12-20  Stokes/Keyser  Increase the max allowable number of times
C     per station.  Skip reports and print warning if that limit is 
C     exceeded.
C 2020-01-09  J. Dong  In subroutine READPROF, changed the windowing
C     decade from 20 to 40 for cases when the years is represented by
C     2 digits instead of 4.
C 2020-01-18 J. DONG -- Increase levels NL to 300 throughout the codes. 
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - NAMELIST &RDATA (SEE REMARKS)
C     UNIT 14  - PREPBUFR FILE
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - PREPBUFR FILE
C     UNIT 52  - LISTING (TYPE 1) OF ALL OUTPUT WIND PROFILER LEVELS
C     UNIT 53  - LISTING (TYPE 2) OF ALL OUTPUT WIND PROFILER LEVELS
C     UNIT 54  - LISTING (TYPE 1) OF WIND PROFILER LEVELS WITH EVENTS
C                FROM THIS PROGRAM PLUS PRE-EXISTING PREPBUFR BAD
C                LEVELS
C     UNIT 55  - LISTING (TYPE 2) OF WIND PROFILER LEVELS WITH EVENTS
C                FROM THIS PROGRAM PLUS PRE-EXISTING PREPBUFR BAD
C                LEVELS
C     UNIT 61  - PRINTOUT OF SELECTED STATISTICS OF RESULTS ON EACH 
C                LEVEL (BY REPORT TYPE, REPORT TIME AND FIELD)
C     UNIT 62  - STATISTICS FILE CONTAINING ALL STATISTICS ON EACH
C                LEVEL (BY REPORT TYPE (BY REPORT TYPE AND FIELD, BUT
C                OVER ALL TIMES COMBINED)
C
C   SUBPROGRAMS CALLED:
C     SYSTEM:    - SYSTEM
C     UNIQUE:    - WRITBUFR CHECKS   CSTATS   DIFS
C                  DMA      EVENT    INCR     INDICATE INIT
C                  ISDONE   MODQUAL  PLINT    PRNTDATA
C                  PUTDATA  READPROF RESIDUAL PSTAT    MSTATS
C                  TWODIM   RESTRUCT SORT     ISORT    SHELL
C     LIBRARY:
C       W3NCO    - W3TAGB   W3TAGE   W3MOVDAT ERREXIT
C       BUFRLIB  - CLOSBF   CLOSMG   COPYMG   DATELEN  OPENBF
C                  OPENMG   READMG   READSB   UFBCPY   UFBINT
C                  UFBQCD   WRITSB   UFBCNT   SETBMISS GETBMISS
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C              4 - NO WIND PROFILER REPORTS READ IN
C
C REMARKS: CONTENTS OF INPUT NAMELIST &RDATA:
C               IPRINT   - Include additional diagnostic print
C                          in stdout?  (=0 - No, =1 - Yes)   (Default=0)
C               TIMWIN_E - Earliest time relative to cycle time
C                          for outputting reports (hours)    (Def=-3.00)
C               TIMWIN_L - Latest   time relative to cycle time
C                          for outputting reports (hours)    (Def=+2.99)
C               STATS    - Print out stats to units 61 and 62?
C                   STATS=TRUE  -- Yes
C                   STATS=FALSE -- No                          (Default)
C            If STATS=TRUE:
C               MEAN     - Print mean to unit 61?
C                   MEAN=TRUE  -- Yes                          (Default)
C                   MEAN=FALSE -- No
C               STDDEV   - Print standard deviation to unit 61?
C                   STDDEV=TRUE  -- Yes                        (Default)
C                   STDDEV=FALSE -- No
C               SKEW     - Print skewness to unit 61?
C                   SKEW=TRUE  -- Yes
C                   SKEW=FALSE -- No                           (Default)
C               KURT     - Print kurtosis to unit 61?
C                   KURT=TRUE  -- Yes
C                   KURT=FALSE -- No                           (Default)
C               (Note: IF STATS=TRUE, all four moments above are
C                      printed to unit 62 regardless of switches above)
C
C    Reason Codes:
C       Prior to ??/??/2003:
C           3 - Wind obs found to be of questionable quality (wind
C                quality marker set to "3" for suspect)
C          13 - Wind obs failed quality control checks (wind quality
C                marker set to "13" for bad)
C       After ??/??/2003:
C          The reason code provides detailed information about the
C          nature of the quality marker change.  It is defined as a
C          3-digit number XYZ, where the value of each digit has the
C          following meaning:
C
C          Hundredth's digit (X):
C             1 - Median check and vertical check both passed or not
C                  possible
C             2 - Median check suspect, vertical check passed or not
C                  possible
C             3 - Median check passed or not possible, vertical check
C                  suspect
C             4 - Median check and vertical check both suspect
C             5 - Median check failed, vertical check did not fail (may
C                  have passed, may be suspect, or may not be possible)
C             6 - Median check did not fail (may have passed, may be
C                  suspect, or may not be possible), vertical check
C                  failed
C             7 - Median check and vertical check both failed
C
C          Tenth's digit (Y):
C             1 - Temporal check and increment check both passed or not
C                  possible
C             2 - Temporal check suspect, increment check passed or not
C                  possible
C             3 - Temporal check passed or not possible, increment
C                  check suspect
C             4 - Temporal check and increment check both suspect
C             5 - Temporal check failed, increment check did not fail
C                  (may have passed, may be suspect, or may not be
C                  possible)
C             6 - Temporal check did not fail (may have passed, may be
C                  suspect, or may not be possible), increment check
C                  failed
C             7 - Temporal check and increment check both failed
C
C          Unit's digit (Z):
C             0 - Either: none of the checks failed (but one or more
C                  are suspect, see hundredth's and tenth's digits), or
C                  one or more checks failed (see hundredth's and
C                  tenth's digits) but no vector differences could be
C                  calculated
C             1 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only one vector difference
C                  (increment-temporal, increment-vertical, temporal-
C                  vertical, temporal-median, vertical-median) could be
C                  calculated
C             2 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only increment-temporal
C                  vector difference is small (all others are either
C                  large or could not be calculated)
C             3 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only increment-vertical
C                  vector difference is small (all others are either
C                  large or could not be calculated)
C             4 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only increment-median vector
C                  difference is small (all others are either large or
C                  could not be calculated)
C             5 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only temporal-vertical vector
C                  difference is small (all others are either large or
C                  could not be calculated)
C             6 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only temporal-median vector
C                  difference is small (all others are either large or
C                  could not be calculated)
C             7 - One or more checks failed (see hundredth's and
C                  tenth's digits), where only the vertical-median
C                  vector difference is small (all others are either
C                  large or could not be calculated)
C             8 - One or more checks failed (see hundredth's and
C                  tenth's digits), where any two or three of the
C                  vector differences (increment-temporal, increment-
C                  vertical, temporal-vertical, temporal-median,
C                  vertical-median) are small (all others are either
C                  large or could not be calculated)
C             9 - One or more checks failed (see hundredth's and
C                  tenth's digits), where any four, five or six of the
C                  vector differences (increment-temporal, increment-
C                  vertical, temporal-vertical, temporal-median,
C                  vertical-median) are small (all others are either
C                  large or could not be calculated)
C
C          Note: The wind quality marker is set to suspect ("3") for
C                any reason code XYZ, where X is 1-4, and Y is 1-4, and
C                Z is 0.  Any other reason code (X is 5-7, or Y is 5-7,
C                or Z is 1-9) results in a wind quality marker set to
C                bad ("13"). 
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS (iDataPlex and Cray-XC40)
C
C$$$
      PROGRAM PREPOBS_PROFCQC

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      LOGICAL  DONE,STATS,MEAN,STDDEV,SKEW,KURT
      CHARACTER*8  STN
      REAL(8)   BMISS,GETBMISS

      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/TIMEO/TIMWIN_E,TIMWIN_L
      COMMON/STATZ/UZS(120,0:24,9,3:8),VZS(120,0:24,9,3:8),
     $ UIS(120,0:24,9,3:8),VIS(120,0:24,9,3:8),UTS(120,0:24,9,3:8),
     $ VTS(120,0:24,9,3:8),UVS(120,0:24,9,3:8),VVS(120,0:24,9,3:8),
     $ VVIS(120,0:24,9,3:8),VVTS(120,0:24,9,3:8),VVVS(120,0:24,9,3:8),
     $ VVMS(120,0:24,9,3:8),UMS(120,0:24,9,3:8),VMS(120,0:24,9,3:8)
      COMMON/PST/IOFFSET(3:8),LVLINCR(3:8),ILEVELS(3:8),STATS,MEAN,
     $ STDDEV,SKEW,KURT
      COMMON /BUFRLIB_MISSING/BMISS

      NAMELIST/RDATA/IPRINT,TIMWIN_E,TIMWIN_L,STATS,MEAN,STDDEV,SKEW,
     $ KURT

      CALL W3TAGB('PREPOBS_PROFCQC',2020,0009,1200,'NP22')

      WRITE(6,100)

      IPRINT =       0 ! default is no additional diag. print to stdout
      TIMWIN_E = -3.00 ! default earliest time to output reports
      TIMWIN_L = +2.99 ! default latest   time to output reports
      STATS = .FALSE.  ! default is to NOT calc./print stats
      MEAN  = .TRUE.   ! if STATS=T, default is to print mean
      STDDEV= .TRUE.   ! if STATS=T, default is to print stddev
      SKEW  = .FALSE.  ! if STATS=T, default is to NOT print skewness
      KURT  = .FALSE.  ! if STATS=T, default is to NOT print kurtosis
      READ(5,RDATA)           
      WRITE(6,RDATA)

C  On WCOSS should always set BUFRLIB missing (BMISS) to 10E8 to avoid
C   overflow when either an INTEGER*4 variable is set to BMISS or a
C   REAL*8 (or REAL*4) variable that is missing is NINT'd
C  -------------------------------------------------------------------
ccccc CALL SETBMISS(10E10_8)
      CALL SETBMISS(10E8_8)
      BMISS=GETBMISS()
      print *
      print *, 'BUFRLIB value for missing is: ',bmiss
      print *

      WRITE(52,101)
      WRITE(53,101)
      WRITE(54,101)
      WRITE(55,101)

      CALL INIT               ! initialize
      CALL READPROF           ! read in wind profiler data
      CALL RESTRUCT           ! restructure (sort) vertical & times
      CALL INCR               ! calculate increments

      DO IS=1,NSTN            ! Loop through all the unique stations
         WRITE(6,102) STN(IS)
         NSCAN = 0
         DONE = .FALSE.
         DO WHILE (.NOT.DONE)      ! Loop through scans
            NSCAN = NSCAN + 1
            CALL RESIDUAL(IS)      ! calculate residuals
            CALL INDICATE(IS)      ! calculate indicators
            CALL DIFS(IS,IPRINT)   ! calculate vector differences
            CALL DMA(IS)           ! decision making algorithm
            CALL ISDONE(DONE)      ! check to see if done
         ENDDO
         IF(STATS) CALL CSTATS(IS) ! collect statistics
         CALL MODQUAL(IS)          ! modify quality marks
         CALL PRNTDATA(IS)         ! print data, quality marks
      ENDDO

      IF(STATS) CALL PSTAT ! compute mean, std dev, etc. & prnt stats
      CALL WRITBUFR        ! write PREPBUFR file w/ profiler events

      CALL W3TAGE('PREPOBS_PROFCQC')

      STOP

  100 FORMAT(' WELCOME TO PREPOBS_PROFCQC -- VERSION 01/09/2020'//)
  101 FORMAT(1X,128('*'))
  102 FORMAT(/'xxxxxxxxxxxxxxxxxxxxxxxxxxx'/'Process Stn. ',A8)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    BLOCK DATA
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: BLOCK DATA FOR PREPOBS_PROFCQC.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- XI, XT, XV now expanded to cover all
C     possible levels.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      BLOCK DATA

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      COMMON/PST/IOFFSET(3:8),LVLINCR(3:8),ILEVELS(3:8),STATS,MEAN,
     $ STDDEV,SKEW,KURT
      COMMON/LIMITS/XI(9125), XT(15750), XV(15750)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT

      DATA  NSTN/0/,NSTN1/0/,NREP/0/,NREP1/0/,NREP_OUT/0/,NLEV/143/,
     $ NSCAN/0/,NFIN/14/,NFOUT/51/,NCH/0/

C --> Height index calculation variables:
C                       NPN  n/a  n/a  n/a  CAP  JMA
C                       ---  ---  ---  ---  ---  ---
      DATA  IOFFSET   / 250, -99, -99, -99,   0, 100/ ! Offset
      DATA  LVLINCR   / 250, -99, -99, -99,  50, 300/ ! Increment
      DATA  ILEVELS   /  64, -99, -99, -99, 120,  30/ ! Max. no. lvls

C  FOLLOWING DATA SUITABLE FOR NDAS/NAM ANALYSIS BACKGROUND.
C  ALSO USED FOR RAP (AND BEFORE THAT RUC) BACKGROUND.
C  ---------------------------------------------------------

C               1 -  6875 m : 2.10
C            6876 -  7125 m : 2.20
C            7126 -  7375 m : 2.40
C            7376 -  7625 m : 2.60
C            7626 -  7875 m : 2.80
C            7876 -  8125 m : 3.00
C            8126 -  8375 m : 3.20
C            8376 -  8625 m : 3.40
C            8626 -  8875 m : 3.60
C            8876 -  9125 m : 3.70
C                 >  9125 m : 3.80

      DATA XI/6875*2.10,  250*2.20,  250*2.40,  250*2.60,  250*2.80,
     $         250*3.00,  250*3.20,  250*3.40,  250*3.60,  250*3.70/


C               1 -  7125 m : 1.20
C            7126 -  7375 m : 1.25
C            7376 -  7625 m : 1.30
C            7626 -  7875 m : 1.35
C            7876 -  8125 m : 1.40
C            8126 -  8375 m : 1.45
C            8376 -  8625 m : 1.50
C            8626 -  8875 m : 1.55
C            8876 -  9125 m : 1.60
C            9126 -  9750 m : 1.65
C            9501 - 10750 m : 1.70
C           10751 - 11750 m : 1.75
C           11751 - 12750 m : 1.80
C           12751 - 13750 m : 1.85
C           13751 - 14750 m : 1.90
C           14751 - 15750 m : 1.95
C                 > 15750 m : 2.00

      DATA XT/7125*1.20,  250*1.25,  250*1.30,  250*1.35,  250*1.40,
     $         250*1.45,  250*1.50,  250*1.55,  250*1.60,  625*1.65,
     $        1000*1.70, 1000*1.75, 1000*1.80, 1000*1.85, 1000*1.90,
     $        1000*1.95/


C               1 -   625 m : 2.20
C             626 -   875 m : 2.00
C             876 -  1125 m : 1.80
C            1126 -  1375 m : 1.50
C            1376 -  1625 m : 1.30
C            1626 -  1875 m : 1.00
C            1876 -  8125 m : 0.70
C            8126 -  8375 m : 0.80
C            8376 -  8625 m : 1.00
C            8626 -  8875 m : 1.20
C            8876 -  9125 m : 1.40
C            9126 -  9750 m : 1.60
C            9501 - 10750 m : 1.80
C           10751 - 11750 m : 2.00
C           11751 - 12750 m : 2.20
C           12751 - 13750 m : 2.40
C           13751 - 14750 m : 2.60
C           14751 - 15750 m : 2.80
C                 > 15750 m : 3.00

      DATA XV/ 625*2.20,  250*2.00,  250*1.80,  250*1.50,  250*1.30,
     $         250*1.00, 6250*0.70,  250*0.80,  250*1.00,  250*1.20,
     $         250*1.40,  625*1.60, 1000*1.80, 1000*2.00, 1000*2.20,
     $        1000*2.40, 1000*2.60, 1000*2.80/

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    WRITBUFR
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: WRITE OUTPUT PREPBUFR FILE, IDENTICAL TO INPUT
C   EXCEPT FOR THE ADDITION OF WIND PROFILER Q.C. EVENTS.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Namelist switches added to specify output
C     time window - allows input to have wider time window so temporal
C     chk at all output times can be based on 2-sided diff {before
C     temporal chk on output rpts on time (assimilation) bdry based on
C     1-sided diff}.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL WRITBUFR
C   INPUT FILES:
C     NFIN    - PREPBUFR INPUT TO THIS PROGRAM
C
C   OUTPUT FILES:
C     NFOUT   - PREPBUFR OUTPUT FROM THIS PROGRAM (INCL. WIND PROFILER
C             - EVENTS)
C     UNIT 06 - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE WRITBUFR

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      LOGICAL  FIRST
      CHARACTER*8  STN,LAST,SUBSET,CID
      CHARACTER*40 HSTR, OSTR, ESTR
      REAL  UVO(255,2),VQM(255),VRC(255)
      REAL(8)  SID_8,HDR_8(10),OBS_8(10,255),BMISS
      INTEGER  IND(NL)

      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/DATEZ/JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON/HEADER/SID_8,XOB,YOB,DHR,ELV,XTP,TYP,T29,NLV
      COMMON/PROBS/ZOB(255),UOB(255),VOB(255),WQM(255),POB(255),
     $ UFC(255),VFC(255),CAT(255),SOB(255),DOB(255)
      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),
     $ QZ(NL,NT,NS),PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),
     $ SZ(NL,NT,NS),DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/PROFP/ZP(NL,NT,NS),UP(NL,NT,NS),VP(NL,NT,NS),QP(NL,NT,NS),
     $ PP(NL,NT,NS),UFP(NL,NT,NS),VFP(NL,NT,NS),LEVP(NL,NT,NS)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/TIMEO/TIMWIN_E,TIMWIN_L
      COMMON /BUFRLIB_MISSING/BMISS

      EQUIVALENCE  (SID_8,CID)

      DATA  HSTR/'SID XOB YOB DHR ELV ITP TYP T29        '/
      DATA  OSTR/'ZOB UOB VOB WQM POB UFC VFC CAT FFO DDO'/
      DATA  ESTR/'UOB VOB WQM WPC WRC                    '/

      DATA  LAST/'XXXXXXXX'/ISUBO/0/,ISUBOT/0/,IRECOL/0/,IRECO/0/

      WRITE(6,100)

C  OPEN INPUT FILE AND GET DATE
C  ----------------------------

      REWIND NFIN
      CALL DATELEN(10)
      CALL OPENBF(NFIN,'IN',NFIN)
      WRITE(6,101) NFIN
      CALL OPENBF(NFOUT,'OUT',NFIN)
      WRITE(6,102) NFOUT,NFIN
      CALL UFBQCD(NFIN,'CQCPROF',ICQCPC)

   10 CONTINUE

C  READ NEXT INPUT BUFR MESSAGE
C  ----------------------------

      CALL READMG(NFIN,SUBSET,IDATEP,IRET)
      IF(IRET.NE.0) THEN
C ALL BUFR MESSAGES IN FILE HAVE BEEN READ CLOSE INPUT DATA SET
         IF(LAST.EQ.'PROFLR  ') THEN
            CALL UFBCNT(NFOUT,IRECO,ISUBO)
            ISUBOT = ISUBOT + ISUBO
            WRITE(6,103) IRECO,LAST,ISUBO,ISUBOT
         ENDIF
         WRITE(6,104) IRECO,ISUBOT,NFIN
         CALL CLOSBF(NFOUT)
         WRITE(6,105)  NFOUT,NREP_OUT
         RETURN
      ENDIF
      CALL UFBCNT(NFIN,IRECI,ISUBI)
      IF(SUBSET.EQ.'PROFLR  ')  WRITE(6,106) IRECI,SUBSET
      IF(LAST.NE.SUBSET) THEN
         IF(LAST.EQ.'PROFLR  ') THEN
            CALL UFBCNT(NFOUT,IRECO,ISUBO)
            ISUBOT = ISUBOT + ISUBO
            WRITE(6,103) IRECO,LAST,ISUBO,ISUBOT
C MUST CLOSE THE LAST "PROFLR" TABLE A ENTRY MESSAGE
            CALL CLOSMG(NFOUT)
         ENDIF
         WRITE(6,107) NFOUT,SUBSET,IDATEP
         CALL UFBCNT(NFOUT,IRECOL,ISUBO)
         IRECOL = IRECOL + 1
      ENDIF
      LAST = SUBSET
      IF(SUBSET.NE.'PROFLR  ') THEN
C ALL TABLE A ENTRY BUFR MESSAGES THAT ARE NOT "PROFLR" ARE SIMPLY
C  COPIED FROM INPUT FILE TO OUTPUT FILE AS IS (NO DECODING OF SUBSETS)
         CALL COPYMG(NFIN,NFOUT)
         CALL UFBCNT(NFOUT,IRECO,ISUBO)
         ISUBOT = ISUBOT + ISUBO
         GOTO 10
      ENDIF
C TABLE A ENTRY "PROFLR" MESSAGES COME HERE TO DECODE/ENCODE EACH SUBSET
      CALL OPENMB(NFOUT,SUBSET,IDATEP)

   20 CONTINUE

C READ IN NEXT SUBSET (REPORT) FROM THIS BUFR MESSAGE
      CALL READSB(NFIN,IRET)
C NON-ZERO IRET IN READSB MEANS ALL SUBSETS IN BUFR MSG HAVE BEEN READ
C GO ON TO READ NEXT BUFR MESSAGE
      IF(IRET.NE.0) GOTO 10

C  READ AND STORE HEADER ELEMENTS
C  ------------------------------

      CALL UFBINT(NFIN,HDR_8,10,  1,IRET,HSTR)
      SID_8 = HDR_8(1)
      XOB = HDR_8(2)
      YOB = HDR_8(3)
      DHR = HDR_8(4)
      ELV = HDR_8(5)
      XTP = HDR_8(6)
      TYP = HDR_8(7)
      T29 = HDR_8(8)

ccccc print*, CID,(HDR_8(i),i=2,8)

C  DETERMINE IF THIS REPORT IS WITHIN OUTPUT TIME WINDOW RANGE
C  -----------------------------------------------------------

      IF(NINT(DHR*1000.).LT.NINT(TIMWIN_E*1000.).OR.
     $   NINT(DHR*1000.).GT.NINT(TIMWIN_L*1000.)) THEN
         WRITE(6,108)  CID,YOB,XOB,DHR
         GOTO 20
      ENDIF

C  MATCH REPORT ID TO STORED DATA
C  ------------------------------

      DO NN=1,NSTN
        N = NN
        IF(CID.EQ.STN(N)) THEN

C  MATCH REPORT D-TIME TO STORED DATA
C  ----------------------------------

            DO MM=1,NTIMES(N)
               M = MM
               IF(DHR.EQ.TIM(MM,N))  GOTO 30
            ENDDO
         ENDIF
      ENDDO


C  NO MATCH FOR ID OR TIME; COPY REPORT TO OUTPUT
C  ----------------------------------------------

      WRITE(6,109)  CID,DHR
      NREP_OUT = NREP_OUT + 1
      CALL UFBCPY(NFIN,NFOUT)
      CALL WRITSB(NFOUT)
      GOTO 20

   30 CONTINUE

      WRITE(6,110)  CID,N,M

C  READ DATA OF PROPER SUBSET AND STATION
C  --------------------------------------

      CALL UFBINT(NFIN,OBS_8,10,255,NLV,OSTR)
      DO L=1,NLV
        ZOB(L) = OBS_8(1,L)
        UOB(L) = OBS_8(2,L)
        VOB(L) = OBS_8(3,L)
        WQM(L) = OBS_8(4,L)
        POB(L) = OBS_8(5,L)
        UFC(L) = OBS_8(6,L)
        VFC(L) = OBS_8(7,L)
        CAT(L) = OBS_8(8,L)
        SOB(L) = OBS_8(9,L)
        DOB(L) = OBS_8(10,L)
      ENDDO

C  COPY ORIGINAL REPORT TO OUTPUT
C  ------------------------------

      CALL UFBCPY(NFIN,NFOUT)

C  FORM BUFR EVENTS
C  ----------------

      FIRST = .TRUE.
      LL = 0
      DO LZ=1,NZZ(N)
        IF(IQCC(LZ,M,N).NE.0 .AND. LEVZ(LZ,M,N).GT.0) THEN
          IF(FIRST) THEN
            WRITE(6,111)
            FIRST = .FALSE.
          ENDIF
          LL = LL + 1
          L0 = LEVZ(LZ,M,N)
          UVO(LL,1) = UOB(L0)
          UVO(LL,2) = VOB(L0)
          VQM(LL) = IQCC(LZ,M,N)
          VRC(LL) = IRC(LZ,M,N)
          IND(LL) = L0
          WRITE(6,112) L0,CID,NINT(CAT(L0)),ZOB(L0),LL,LZ,M,N,UVO(LL,1),
     $     UVO(LL,2),IQCC(LZ,M,N)
          IF(L0.GT.1) THEN
            LOOP1: DO LM=L0-1,1,-1
             IF(ZOB(LM).LT.BMISS) EXIT LOOP1
              IF(CAT(LM).EQ.7) THEN
                LL = LL + 1
                UVO(LL,1) = UOB(LM)
                UVO(LL,2) = VOB(LM)
                VQM(LL) = IQCC(LZ,M,N)
                VRC(LL) = IRC(LZ,M,N)
                IND(LL) = LM
                WRITE(6,113) LM,CID,NINT(CAT(LM)),ZOB(LM),LL,LZ,M,N,
     $           UVO(LL,1),UVO(LL,2),IQCC(LZ,M,N)
              ENDIF
            ENDDO LOOP1
          ENDIF
        ENDIF
      ENDDO

C  WRITE EVENTS
C  ------------

      IF(LL.NE.0) THEN
        CALL EVENT(NFOUT,ESTR,NLV,UVO,VQM,VRC,IND,LL,real(ICQCPC))
      ELSE
         WRITE(6,114)
      ENDIF

      NREP_OUT = NREP_OUT + 1
      CALL WRITSB(NFOUT)
      CALL UFBCNT(NFOUT,IRECO,ISUBON)
      IF(IRECO.GT.IRECOL) THEN
         IRECOL = IRECO
         ISUBOT = ISUBOT + ISUBO
         WRITE(6,115) IRECO-1,ISUBO,ISUBOT
      ENDIF
      ISUBO = ISUBON

      GOTO 20

  100 FORMAT(//'READY TO READ ORIGINAL DATA, COPY TO OUTPUT AND ADD ',
     $ 'WIND PROFILER EVENTS'/)
  101 FORMAT(/5X,'+++> PREPBUFR DATA SET IN UNIT ',I3,' SUCCESSFULLY',
     $ ' OPENED FOR INPUT; FIRST MESSAGE CONTAINS BUFR TABLES A,B,D'/)
  102 FORMAT(/5X,'+++> PREPBUFR DATA SET IN UNIT ',I3,' SUCCESSFULLY',
     $ ' OPENED FOR OUTPUT; CUSTOMIZED BUFR TABLES A,B,D IN UNIT ',I3/
     $ 12X,'READ IN AND ENCODED INTO MESSAGE NO. 1 OF OUTPUT DATA SET'/)
  103 FORMAT(/' --- WROTE BUFR DATA MSG NO. ',I10,' -- TABLE A ENTRY "',
     $A8,'" - CONTAINS',I6,' REPORTS (TOTAL NO. RPTS WRITTEN =',I7,')'/)
  104  FORMAT(/' --- ALL TOTAL OF',I11,' BUFR MESSAGES WRITTEN OUT -- ',
     $ 'TOTAL NUMBER OF REPORTS WRITTEN =',I7//5X,'===> PREPBUFR DATA ',
     $ 'SET IN UNIT ',I3,' SUCCESSFULLY CLOSED FROM FINAL READ OF ALL ',
     $ 'OBS')
  105 FORMAT(/5X,'===> PREPBUFR DATA SET IN UNIT ',I3,' SUCCESSFULLY',
     $ ' CLOSED AFTER WRITING OF ALL OBS.'/10X,'THE TOTAL NUMBER OF ',
     $ 'WIND PROFILER REPORTS WRITTEN WAS',I4/25X,' *** ALL DONE ***'/)
  106 FORMAT(' --- READ IN BUFR DATA MESSAGE NUMBER',I6,' WITH TABLE ',
     $ 'A ENTRY "',A8)
  107 FORMAT(/' ===> NEXT MESSAGE IN OUTPUT PREPBUFR DATA SET IN UNIT ',
     $ I3,' HAS NEW TABLE A ENTRY OF "',A6,'" -- DATE IS',I11)
  108 FORMAT(/'##WRITBUFR: RPT OUTSIDE TIME WINDOW, ID ',A8,', LAT=',
     $ F7.2,'N, LON=',F8.2,'E, D-TIM=',F7.3,' -- DO NOT COPY RPT TO ',
     $ 'OUTPUT FILE'/)
  109 FORMAT(/'##WRITBUFR: NO ID AND D-TIME MATCH FOR ID ',A8,' AT ',
     $ 'D-TIME ',F6.2,' -- COPY REPORT TO OUTPUT PREPBUFR FILE W/O ANY',
     $ ' Q.C.'/)
  110 FORMAT(' WRITBUFR: FOUND A MATCH FOR ID ',A8,' (STN. NO.',I4,')',
     $ ' AT TIME PERIOD',I3)
  111 FORMAT(10X,'  STATION   CAT       ZOB EVNT#  LVL  TIM  STN     ',
     $ 'UO      VO IQCC')
  112 FORMAT(' L0: ',I5,2X,A8,I5,2X,F8.0,4I5,2F8.1,I5)
  113 FORMAT(' LM: ',I5,2X,A8,2I5,X,F8.0,4I5,2F8.1,I5)
  114 FORMAT('  ... NO EVENTS WRITTEN')
  115 FORMAT(/' --- THIS REPORT OPENS NEW MSG (SAME TABLE A): LAST ',
     $ 'DATA MSG WAS NO.',I5,' WITH',I5,' REPORTS (TOTAL NO. REPORTS ',
     $ 'WRITTEN =',I7,')'/)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    CHECKS
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: PERFORM INCREMENT, TEMPORAL AND VERTICAL CHECKS FOR
C   A SINGLE UNIQUE STATION.
C
C PROGRAM HISTORY LOG:
C 1995-04-04  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Lvl index in all arrays now site specific
C     to allow proper temporal checking at each individual site. Incr.,
C     temporal, vert. & median chk error limits now directly assoc. w/
C     a rpted hgt above ground lvl rather than w/ lvl index in arrays
C     (ensures proper error limit used at all lvls & eliminates hgt
C     above ground vs. hgt above sea lvl discrepancy - error limits
C     values remain unchanged). Temporal check for CAPs attempt to get
C     2-hr. spanning del-time so error limits are valid (since based on
C     NPNs), else del-time must be .ge. half-hr on one side, else
C     temporal check not performed.  Max. del-time on one side is 2-hrs
C     for all rpts. DO-LOOP logic more concise (esp. in temporal &
C     vert. chks.)
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C 2020-05-08 J. DONG  INITIALIZE VPMX, AND CONTROL THE VARIABLE NZZM2
C     NOT LESS THAN 1 SO THAT THE ARGUMENT FOR AN ARRAY IS NOT LESS THAN
C     1. 
C
C USAGE:   SUBROUTINE CHECKS(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C REMARKS: 
C   VARIABLE NAMES:
C     U        - U-COMPONENT OF WIND (M)
C     V        - V-COMPONENT OF WIND (M)
C     UI       - U-COMPONENT INCREMENT
C     VI       - V-COMPONENT INCREMENT
C     UT       - U-COMPONENT TEMPORAL RESIDUAL
C     VT       - V-COMPONENT TEMPORAL RESIDUAL
C     UV       - U-COMPONENT VERTICAL RESIDUAL
C     VV       - V-COMPONENT VERTICAL RESIDUAL
C     VVI      - VECTOR INCREMENT
C     VVT      - VECTOR TEMPORAL RESIDUAL
C     VVV      - VECTOR VERTICAL RESIDUAL
C     ICQC     - DMA INDEX FOR WIND QUALITY CONTROL
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE CHECKS(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8     STN
      REAL(8)   BMISS

      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),
     $ QZ(NL,NT,NS),PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),
     $ SZ(NL,NT,NS),DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON /QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/LIMITS/XI(9125),XT(15750),XV(15750)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON /BUFRLIB_MISSING/BMISS

C     PERFORM TEMPORAL AND VERTICAL CHECKS.
C     USE ONLY NON-MISSING DATA AT ADJACENT TIME OR LEVEL.
C     DO NOT USE INFLUENCING DATA THAT ARE BAD.
C     CHECKS ARE PERFORMED ON INCREMENTS.
C     ALSO CALCULATE THE VECTOR INCREMENT, TEMPORAL RESIDUAL,
C     AND VERTICAL RESIDUAL.

      NZZM1 = NZZ(IS) - 1
      NZZM2 = NZZ(IS) - 2
c JDONG: ADD BELOW
      IF(NZZM2.LT.1) NZZM2 = 1
      VPMX=BMISS

C  CALCULATE THE VECTOR INCREMENT
C  ------------------------------

      DO N=1,NTIMES(IS)
         DO L=1,NZZ(IS)
            IF(MAX(ABS(UI(L,N,IS)),ABS(VI(L,N,IS))).LT.BMISS) THEN
               VVI(L,N) = SQRT(UI(L,N,IS)**2 + VI(L,N,IS)**2)
            ELSE
               VVI(L,N) = BMISS
            ENDIF
         ENDDO
      ENDDO

      DO N=1,NTIMES(IS)
        LOOP1: DO L=1,NZZ(IS)
          IF(NINT(ZZ(L,N,IS)-Z0(IS)).LT.9126) THEN
             VMX =  10.0 * XI(NINT(ZZ(L,N,IS)-Z0(IS)))
          ELSE
             VMX =  10.0 * 3.80
          ENDIF
          IF(L.NE.NZZ(IS)) THEN
             IF(NINT(ZZ(L+1,N,IS)-Z0(IS)).LT.9126) THEN
                VPMX = 10.0 * XI(NINT(ZZ(L+1,N,IS)-Z0(IS)))
             ELSE
                VPMX = 10.0 * 3.80
             ENDIF
          ENDIF
          IF(L.NE.1) THEN
             IF(NINT(ZZ(L-1,N,IS)-Z0(IS)).LT.9126) THEN
                VMMX = 10.0 * XI(NINT(ZZ(L-1,N,IS)-Z0(IS)))
             ELSE
                VMMX = 10.0 * 3.80
             ENDIF 
          ENDIF 

C  PERFORM TEMPORAL CHECK
C  ----------------------

          UT(L,N)  = BMISS
          VT(L,N)  = BMISS
          VVT(L,N) = BMISS
          IF(NTIMES(IS).LT.2)  GOTO 707
          IF(MAX(UI(L,N,IS),VI(L,N,IS)).GE.BMISS) GOTO 707
          ITRY  = 0
          ITLM1 = 100
          ITLM2 = 100

  606     CONTINUE

          DO NN = 1,NTIMES(IS)-1
            N1 = NN - 1
            IF(N-NN.GE.1) THEN
              IF(NINT(ABS(TIM(N,IS)*100-TIM(N-NN,IS)*100)).LT.ITLM1)THEN
                CYCLE
              ELSE
                N1 = NN
                EXIT
              ENDIF
            ENDIF
            EXIT
          ENDDO
          DO NN = 1,NTIMES(IS)-1
            N2 = NN - 1
            IF(N+NN.LE.NTIMES(IS)) THEN
              IF(NINT(ABS(TIM(N,IS)*100-TIM(N+NN,IS)*100)).LT.ITLM2)THEN
                CYCLE
              ELSE
                N2 = NN
                EXIT
              ENDIF
            ENDIF
            EXIT
          ENDDO
          IF(MAX(N1,N2).EQ.0)  GOTO 707
          IF(MIN(N1,N2).GT.0) THEN
            IF(MAX(ICQC(L,N-N1,IS),ICQC(L,N+N2,IS)).EQ.0) THEN
              IF(MAX(ABS(UI(L,N-N1,IS)),ABS(VI(L,N-N1,IS)),
     $               ABS(UI(L,N+N2,IS)),ABS(VI(L,N+N2,IS))).LT.VMX) THEN
                DT(L,N,IS) = ABS(TIM(N-N1,IS) - TIM(N+N2,IS))
                IF(DT(L,N,IS).LT.2.01) THEN
                  UT(L,N) =UI(L,N,IS) -0.5*(UI(L,N-N1,IS)+UI(L,N+N2,IS))
                  VT(L,N) =VI(L,N,IS) -0.5*(VI(L,N-N1,IS)+VI(L,N+N2,IS))
                  VVT(L,N) = SQRT(UT(L,N)**2 + VT(L,N)**2)
                ELSE
                  ITRY = ITRY + 1
                  IF(ITRY.EQ.1) THEN
                    ITLM1 = 075
                    GOTO 606
                  ELSE IF(ITRY.EQ.2) THEN
                    ITLM2 = 075
                    GOTO 606
                  ELSE IF(ITRY.EQ.3) THEN
                    ITLM1 = 050
                    GOTO 606
                  ELSE IF(ITRY.EQ.4) THEN
                    ITLM2 = 050
                    GOTO 606
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ELSE IF(N1.EQ.0) THEN
C  Use one-sided differences at earliest time
            IF(ICQC(L,N+N2,IS).EQ.0) THEN
              IF(MAX(ABS(UI(L,N+N2,IS)),ABS(VI(L,N+N2,IS))).LT.VMX) THEN
                DT(L,N,IS) = ABS(TIM(N,IS) - TIM(N+N2,IS))
                IF(DT(L,N,IS).LT.1.01) THEN
                  UT(L,N) = UI(L,N,IS) - UI(L,N+N2,IS)
                  VT(L,N) = VI(L,N,IS) - VI(L,N+N2,IS)
                  VVT(L,N) = SQRT(UT(L,N)**2 + VT(L,N)**2)
                ELSE
                  ITRY = ITRY + 1
                  IF(ITRY.EQ.1) THEN
                    ITLM2 = 075
                    GOTO 606
                  ELSE IF(ITRY.EQ.2) THEN
                    ITLM2 = 050
                    GOTO 606
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ELSE IF(N2.EQ.0) THEN
C  Use one-sided differences at latest time
            IF(ICQC(L,N-N1,IS).EQ.0) THEN
              IF(MAX(ABS(UI(L,N-N1,IS)),ABS(VI(L,N-N1,IS))).LT.VMX) THEN
                DT(L,N,IS) = ABS(TIM(N,IS) - TIM(N-N1,IS))
                IF(DT(L,N,IS).LT.1.01) THEN
                  UT(L,N) = UI(L,N,IS) - UI(L,N-N1,IS)
                  VT(L,N) = VI(L,N,IS) - VI(L,N-N1,IS)
                  VVT(L,N) = SQRT(UT(L,N)**2 + VT(L,N)**2)
                ELSE
                  ITRY = ITRY + 1
                  IF(ITRY.EQ.1) THEN
                    ITLM1 = 075
                    GOTO 606
                  ELSE IF(ITRY.EQ.2) THEN
                    ITLM1 = 050
                    GOTO 606
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ENDIF

  707     CONTINUE

C  PERFORM VERTICAL CHECK
C  ----------------------

          UV(L,N)  = BMISS
          VV(L,N)  = BMISS
          VVV(L,N) = BMISS
          IF(L.EQ.1) THEN
C  Use one-sided differences at bottom, allow up to one missing or bad
C   intervening level
            IF(MAX(ABS(UI(1,N,IS)),ABS(VI(1,N,IS))).LT.BMISS) THEN
              DO J = 2,3
                IF(ICQC(J,N,IS).EQ.0) THEN
                  IF(MAX(ABS(UI(J,N,IS)),ABS(VI(J,N,IS))).LT.VPMX) THEN
                    UV(1,N) = UI(1,N,IS) - UI(J,N,IS)
                    VV(1,N) = VI(1,N,IS) - VI(J,N,IS)
                    VVV(1,N) = SQRT(UV(1,N)**2 + VV(1,N)**2)
                    CYCLE LOOP1
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ELSE IF(L.EQ.NZZ(IS)) THEN
C  Use one-sided differences at top, allow up to one missing or bad
C   intervening level
            IF(MAX(ABS(UI(NZZ(IS),N,IS)),ABS(VI(NZZ(IS),N,IS)))
     $       .LT.BMISS) THEN
              DO J = NZZM1,NZZM2,-1
                IF(ICQC(J,N,IS).EQ.0) THEN
                  IF(MAX(ABS(UI(J,N,IS)),ABS(VI(J,N,IS))).LT.VMMX) THEN
                    UV(NZZ(IS),N)  = UI(NZZ(IS),N,IS) - UI(J,N,IS)
                    VV(NZZ(IS),N)  = VI(NZZ(IS),N,IS) - VI(J,N,IS)
                    VVV(NZZ(IS),N) =
     $               SQRT(UV(NZZ(IS),N)**2 + VV(NZZ(IS),N)**2)
                    CYCLE LOOP1
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ELSE IF(L.GT.2 .AND. L.LT.NZZM2) THEN
C  Attempt two-sided differences when two levels or more away from top
C   and two levels or more away from bottom, allow up to one missing or
C   bad intervening level on either side (but NOT on BOTH sides)
            IF(MAX(ABS(UI(L,N,IS)),ABS(VI(L,N,IS))).LT.BMISS) THEN
              DO K = 1,2
                DO J = 1,2
                  IF(MIN(J,K).EQ.2) GOTO 300
                  IF(MAX(ICQC(L+J,N,IS),ICQC(L-K,N,IS)).EQ.0) THEN
                    IF(MAX(ABS(UI(L+J,N,IS)),ABS(VI(L+J,N,IS))).LT.VPMX
     $           .AND. MAX(ABS(UI(L-K,N,IS)),ABS(VI(L-K,N,IS))).LT.VMMX)
     $               THEN
                      UV(L,N)=UI(L,N,IS)-0.5*(UI(L+J,N,IS)+UI(L-K,N,IS))
                      VV(L,N)=VI(L,N,IS)-0.5*(VI(L+J,N,IS)+VI(L-K,N,IS))
                      VVV(L,N) = SQRT(UV(L,N)**2 + VV(L,N)**2)
                      CYCLE LOOP1
                    ENDIF
                  ENDIF
                ENDDO
              ENDDO

  300         CONTINUE

C  Use one-sided differences if two or more missing or bad intervening
C   levels on one side and a non-missing and non-bad neighboring level
C   on the other side (but do NOT allow for any missing or bad
C   intervening levels on the differencing side)
              DO J = 1,-1,-2
                IF(ICQC(L+J,N,IS).EQ.0) THEN
                  IF(MAX(ABS(UI(L+J,N,IS)),ABS(VI(L+J,N,IS))).LT.VPMX)
     $             THEN
                    UV(L,N) = UI(L,N,IS) - UI(L+J,N,IS)
                    VV(L,N) = VI(L,N,IS) - VI(L+J,N,IS)
                    VVV(L,N) = SQRT(UV(L,N)**2 + VV(L,N)**2)
                    CYCLE LOOP1
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ELSE
C  Attempt two-sided differences when either one level away from top or
C   on level away from bottom, do NOT allow any missing or bad
C   intervening levels on EITHER side (even though one may be such on
C   one side)
            IF(MAX(ABS(UI(L,N,IS)),ABS(VI(L,N,IS))).LT.BMISS) THEN
              IF(MAX(ICQC(L+1,N,IS),ICQC(L-1,N,IS)).EQ.0) THEN
                IF(MAX(ABS(UI(L+1,N,IS)),ABS(VI(L+1,N,IS))).LT.VPMX.AND.
     $             MAX(ABS(UI(L-1,N,IS)),ABS(VI(L-1,N,IS))).LT.VMMX)THEN
                  UV(L,N) =UI(L,N,IS) -0.5 *(UI(L+1,N,IS) +UI(L-1,N,IS))
                  VV(L,N) =VI(L,N,IS) -0.5 *(VI(L+1,N,IS) +VI(L-1,N,IS))
                  VVV(L,N) = SQRT(UV(L,N)**2 + VV(L,N)**2)
                  CYCLE LOOP1
                ENDIF
              ENDIF
C  Use one-sided differences if a missing or bad neighboring level on
C   one side and a non-missing and non-bad neighboring level on the
C   other side (but do NOT allow for any missing or bad intervening
C   levels on the differencing side)
              DO J = 1,-1,-2
                IF(ICQC(L+J,N,IS).EQ.0) THEN
                  IF(MAX(ABS(UI(L+J,N,IS)),ABS(VI(L+J,N,IS))).LT.VPMX)
     $             THEN
                    UV(L,N) = UI(L,N,IS) - UI(L+J,N,IS)
                    VV(L,N) = VI(L,N,IS) - VI(L+J,N,IS)
                    VVV(L,N) = SQRT(UV(L,N)**2 + VV(L,N)**2)
                    CYCLE LOOP1
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ENDIF
        ENDDO  LOOP1
      ENDDO

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    CSTATS
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: CALCULATE MOMENTS FOR RESIDUALS FOR A SINGLE STATION.
C
C PROGRAM HISTORY LOG:
C 1995-04-04  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Stats generated separately for NPN, CAP &
C     JMA rpts and stratified according to hgt above ground.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:   SUBROUTINE CSTATS(IS)
C
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C   OUTPUT FILES:
C     UNIT 61  - PRINTOUT OF SELECTED STATISTICS OF RESULTS ON EACH 
C                LEVEL (BY REPORT TYPE, REPORT TIME AND FIELD)
C
C REMARKS: 
C   VARIABLE NAMES:
C     UT       - U-COMPONENT TEMPORAL RESIDUAL
C     VT       - V-COMPONENT TEMPORAL RESIDUAL
C     UV       - U-COMPONENT VERTICAL RESIDUAL
C     VV       - V-COMPONENT VERTICAL RESIDUAL
C     UM       - U-COMPONENT MEDIAN RESIDUAL
C     VM       - V-COMPONENT MEDIAN RESIDUAL
C     VVI      - VECTOR INCREMENT
C     VVT      - VECTOR TEMPORAL RESIDUAL
C     VVV      - VECTOR VERTICAL RESIDUAL
C     VVM      - VECTOR MEDIAN RESIDUAL
C
C   OUTPUT ARGUMENT LIST:
C     ALL PARAMETERS HAVE AN 'S' ADDED TO BASIC INPUT VARIABLE.
C     THE MEANING IS DESCRIBED IN THE COMMENTS BELOW.
C     UZS...VVMS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE CSTATS(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN
      REAL(8)   BMISS

      COMMON/DATEZ/JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),
     $ QZ(NL,NT,NS),PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),
     $ SZ(NL,NT,NS), DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/STATZ/UZS(120,0:24,9,3:8),VZS(120,0:24,9,3:8),
     $ UIS(120,0:24,9,3:8),VIS(120,0:24,9,3:8),UTS(120,0:24,9,3:8),
     $ VTS(120,0:24,9,3:8),UVS(120,0:24,9,3:8),VVS(120,0:24,9,3:8),
     $ VVIS(120,0:24,9,3:8),VVTS(120,0:24,9,3:8),VVVS(120,0:24,9,3:8),
     $ VVMS(120,0:24,9,3:8),UMS(120,0:24,9,3:8),VMS(120,0:24,9,3:8)
      COMMON/PST/IOFFSET(3:8),LVLINCR(3:8),ILEVELS(3:8),STATS,MEAN,
     $ STDDEV,SKEW,KURT
      COMMON/TIMEO/TIMWIN_E,TIMWIN_L
      COMMON /BUFRLIB_MISSING/BMISS

C  HEIGHT INDEX
C  ------------
C
C NOAA PROFILER NETWORK:
C  250 m increments starting at 376 m and ending at 16365 m (64 levels)
C  (height above ground)
C
C COOPERATIVE AGENCY PROFILERS (INCLUDING BOUNDARY LAYER):
C  50 m increments starting at 26 m and ending at 6025 m (120 levels)
C  (height above ground)
C
C JAPANESE METEOROLOGICAL AGENCY PROFILERS:
C  300 m increments starting at 251 m and ending at 9250 m (30 levels)
C  (height above ground)
C
C PROFILERS DECODED FROM PILOT (PIBAL) FORMAT BULLETINS:
C  Currently no statistics are produced

C     COLLECT STATISTICS:
C       EXAMPLE-- UZS(LEVEL,HOUR,STATISTIC)
C       LEVEL     - 1 TO NZZ(IS)
C       HOUR      - 1 TO NTIMES(IS), WHERE NTIMES(IS) IS FOR ALL HOURS
C                                    FOR STATION "IS"
C       STATISTIC - 1: COUNT
C                   2: SUM
C                   3: SUM OF SQUARED VALUE
C                   4: SUM OF CUBED VALUE
C                   5: SUM OF VALUE TO 4TH POWER
C                   6: MEAN
C                   7: STANDARD DEVIATION
C                   8: SKEWNESS
C                   9: KURTOSIS
C     NOTE! STATISTICS 6-9 ARE NOT CALCULATED UNTIL ALL
C           VALUES OF STATISTICS 1-5 ARE COLLECTED FOR ALL STATIONS.
C           THAT CALCULATION IS PERFORMED IN PSTAT.

C What type of station is this? (=3-NPN, =7-CAP, =8=JMA)
      ITYPE = MOD(IRTP(IS),10)
      IF(ITYPE.LT.3.OR.ITYPE.GT.8)  THEN
        write(61,*)
        write(61,'("Stn. ",A," does not have a valid report type (typ=",
     $   I0,") -- it will not be included in statistical database")')
     $  STN(IS),irtp(is)
        write(61,*)
        RETURN
      ENDIF

      LOOP1: DO NN=1,NTIMES(IS)
        IF(KDATE(5,NN,IS).NE.0) THEN
          write(61,*)
          write(61,'("Stn. ",A," at d-time ",F5.2,"is not reporting on",
     $     " the hour -- this time will not be included in statistical",
     $     "database")') STN(IS),TIM(NN,IS)
          write(61,*)
          CYCLE LOOP1
        ENDIF
        N = KDATE(4,NN,IS)
        IF(N.LT.0.OR.N.GT.23) THEN
          write(61,*)
          write(61,'("Stn. ",A," at d-time ",F5.2,"is reporting an ",
     $    "invalid hour -- this time will not be included in ",
     $    "statistical database")') STN(IS),TIM(NN,IS)
          write(61,*)
          CYCLE LOOP1
        ENDIF
        IF(NINT(TIM(NN,IS)*1000.).LT.NINT(TIMWIN_E*1000.).OR.
     $     NINT(TIM(NN,IS)*1000.).GT.NINT(TIMWIN_L*1000.)) CYCLE LOOP1
        LOOP1n1: DO LL=1,NZZ(IS)
          L = NINT((ZZ(LL,NN,IS)-Z0(IS)-IOFFSET(ITYPE)-0.5)/
     $     LVLINCR(ITYPE))
          IF(L.LT.0.OR.L.GT.ILEVELS(ITYPE)) THEN
            write(61,*)
            write(61,'("Stn. ",A," at time ",I0,"Z is reporting a ",
     $       "height above ground outside expected range (hght=",I0,
     $       ") -- this level will not be included in statistical ",
     $       "database")') STN(IS),N,NINT(ZZ(LL,NN,IS)-Z0(IS))
            write(61,*)
            CYCLE LOOP1n1
          ENDIF
          IF(IQ(LL,NN,IS).GT.3.OR.ICQC(LL,NN,IS).GT.1) CYCLE LOOP1n1
          IF(MAX(ABS(UZ(LL,NN,IS)),ABS(VZ(LL,NN,IS))).LT.BMISS) THEN
            UZS(L,N,1,ITYPE)  = UZS(L,N,1,ITYPE)  + 1
            UZS(L,N,2,ITYPE)  = UZS(L,N,2,ITYPE)  + UZ(LL,NN,IS)
            UZS(L,N,3,ITYPE)  = UZS(L,N,3,ITYPE)  + UZ(LL,NN,IS)**2
            UZS(L,N,4,ITYPE)  = UZS(L,N,4,ITYPE)  + UZ(LL,NN,IS)**3
            UZS(L,N,5,ITYPE)  = UZS(L,N,5,ITYPE)  + UZ(LL,NN,IS)**4
            VZS(L,N,1,ITYPE)  = VZS(L,N,1,ITYPE)  + 1
            VZS(L,N,2,ITYPE)  = VZS(L,N,2,ITYPE)  + VZ(LL,NN,IS)
            VZS(L,N,3,ITYPE)  = VZS(L,N,3,ITYPE)  + VZ(LL,NN,IS)**2
            VZS(L,N,4,ITYPE)  = VZS(L,N,4,ITYPE)  + VZ(LL,NN,IS)**3
            VZS(L,N,5,ITYPE)  = VZS(L,N,5,ITYPE)  + VZ(LL,NN,IS)**4
            UZS(L,24,1,ITYPE) = UZS(L,24,1,ITYPE) + 1
            UZS(L,24,2,ITYPE) = UZS(L,24,2,ITYPE) + UZ(LL,NN,IS)
            UZS(L,24,3,ITYPE) = UZS(L,24,3,ITYPE) + UZ(LL,NN,IS)**2
            UZS(L,24,4,ITYPE) = UZS(L,24,4,ITYPE) + UZ(LL,NN,IS)**3
            UZS(L,24,5,ITYPE) = UZS(L,24,5,ITYPE) + UZ(LL,NN,IS)**4
            VZS(L,24,1,ITYPE) = VZS(L,24,1,ITYPE) + 1
            VZS(L,24,2,ITYPE) = VZS(L,24,2,ITYPE) + VZ(LL,NN,IS)
            VZS(L,24,3,ITYPE) = VZS(L,24,3,ITYPE) + VZ(LL,NN,IS)**2
            VZS(L,24,4,ITYPE) = VZS(L,24,4,ITYPE) + VZ(LL,NN,IS)**3
            VZS(L,24,5,ITYPE) = VZS(L,24,5,ITYPE) + VZ(LL,NN,IS)**4
          ENDIF
          IF(MAX(ABS(UI(LL,NN,IS)),ABS(VI(LL,NN,IS))).LT.BMISS) THEN
            UIS(L,N,1,ITYPE)  = UIS(L,N,1,ITYPE)  + 1
            UIS(L,N,2,ITYPE)  = UIS(L,N,2,ITYPE)  + UI(LL,NN,IS)
            UIS(L,N,3,ITYPE)  = UIS(L,N,3,ITYPE)  + UI(LL,NN,IS)**2
            UIS(L,N,4,ITYPE)  = UIS(L,N,4,ITYPE)  + UI(LL,NN,IS)**3
            UIS(L,N,5,ITYPE)  = UIS(L,N,5,ITYPE)  + UI(LL,NN,IS)**4
            VIS(L,N,1,ITYPE)  = VIS(L,N,1,ITYPE)  + 1
            VIS(L,N,2,ITYPE)  = VIS(L,N,2,ITYPE)  + VI(LL,NN,IS)
            VIS(L,N,3,ITYPE)  = VIS(L,N,3,ITYPE)  + VI(LL,NN,IS)**2
            VIS(L,N,4,ITYPE)  = VIS(L,N,4,ITYPE)  + VI(LL,NN,IS)**3
            VIS(L,N,5,ITYPE)  = VIS(L,N,5,ITYPE)  + VI(LL,NN,IS)**4
            UIS(L,24,1,ITYPE) = UIS(L,24,1,ITYPE) + 1
            UIS(L,24,2,ITYPE) = UIS(L,24,2,ITYPE) + UI(LL,NN,IS)
            UIS(L,24,3,ITYPE) = UIS(L,24,3,ITYPE) + UI(LL,NN,IS)**2
            UIS(L,24,4,ITYPE) = UIS(L,24,4,ITYPE) + UI(LL,NN,IS)**3
            UIS(L,24,5,ITYPE) = UIS(L,24,5,ITYPE) + UI(LL,NN,IS)**4
            VIS(L,24,1,ITYPE) = VIS(L,24,1,ITYPE) + 1
            VIS(L,24,2,ITYPE) = VIS(L,24,2,ITYPE) + VI(LL,NN,IS)
            VIS(L,24,3,ITYPE) = VIS(L,24,3,ITYPE) + VI(LL,NN,IS)**2
            VIS(L,24,4,ITYPE) = VIS(L,24,4,ITYPE) + VI(LL,NN,IS)**3
            VIS(L,24,5,ITYPE) = VIS(L,24,5,ITYPE) + VI(LL,NN,IS)**4
          ENDIF
          IF(MAX(ABS(UT(LL,NN)),ABS(VT(LL,NN))).LT.BMISS) THEN
            UTS(L,N,1,ITYPE)  = UTS(L,N,1,ITYPE)  + 1
            UTS(L,N,2,ITYPE)  = UTS(L,N,2,ITYPE)  + UT(LL,NN)
            UTS(L,N,3,ITYPE)  = UTS(L,N,3,ITYPE)  + UT(LL,NN)**2
            UTS(L,N,4,ITYPE)  = UTS(L,N,4,ITYPE)  + UT(LL,NN)**3
            UTS(L,N,5,ITYPE)  = UTS(L,N,5,ITYPE)  + UT(LL,NN)**4
            VTS(L,N,1,ITYPE)  = VTS(L,N,1,ITYPE)  + 1
            VTS(L,N,2,ITYPE)  = VTS(L,N,2,ITYPE)  + VT(LL,NN)
            VTS(L,N,3,ITYPE)  = VTS(L,N,3,ITYPE)  + VT(LL,NN)**2
            VTS(L,N,4,ITYPE)  = VTS(L,N,4,ITYPE)  + VT(LL,NN)**3
            VTS(L,N,5,ITYPE)  = VTS(L,N,5,ITYPE)  + VT(LL,NN)**4
            UTS(L,24,1,ITYPE) = UTS(L,24,1,ITYPE) + 1
            UTS(L,24,2,ITYPE) = UTS(L,24,2,ITYPE) + UT(LL,NN)
            UTS(L,24,3,ITYPE) = UTS(L,24,3,ITYPE) + UT(LL,NN)**2
            UTS(L,24,4,ITYPE) = UTS(L,24,4,ITYPE) + UT(LL,NN)**3
            UTS(L,24,5,ITYPE) = UTS(L,24,5,ITYPE) + UT(LL,NN)**4
            VTS(L,24,1,ITYPE) = VTS(L,24,1,ITYPE) + 1
            VTS(L,24,2,ITYPE) = VTS(L,24,2,ITYPE) + VT(LL,NN)
            VTS(L,24,3,ITYPE) = VTS(L,24,3,ITYPE) + VT(LL,NN)**2
            VTS(L,24,4,ITYPE) = VTS(L,24,4,ITYPE) + VT(LL,NN)**3
            VTS(L,24,5,ITYPE) = VTS(L,24,5,ITYPE) + VT(LL,NN)**4
          ENDIF
          IF(MAX(ABS(UV(LL,NN)),ABS(VV(LL,NN))).LT.BMISS) THEN
            UVS(L,N,1,ITYPE)  = UVS(L,N,1,ITYPE)  + 1
            UVS(L,N,2,ITYPE)  = UVS(L,N,2,ITYPE)  + UV(LL,NN)
            UVS(L,N,3,ITYPE)  = UVS(L,N,3,ITYPE)  + UV(LL,NN)**2
            UVS(L,N,4,ITYPE)  = UVS(L,N,4,ITYPE)  + UV(LL,NN)**3
            UVS(L,N,5,ITYPE)  = UVS(L,N,5,ITYPE)  + UV(LL,NN)**4
            VVS(L,N,1,ITYPE)  = VVS(L,N,1,ITYPE)  + 1
            VVS(L,N,2,ITYPE)  = VVS(L,N,2,ITYPE)  + VV(LL,NN)
            VVS(L,N,3,ITYPE)  = VVS(L,N,3,ITYPE)  + VV(LL,NN)**2
            VVS(L,N,4,ITYPE)  = VVS(L,N,4,ITYPE)  + VV(LL,NN)**3
            VVS(L,N,5,ITYPE)  = VVS(L,N,5,ITYPE)  + VV(LL,NN)**4
            UVS(L,24,1,ITYPE) = UVS(L,24,1,ITYPE) + 1
            UVS(L,24,2,ITYPE) = UVS(L,24,2,ITYPE) + UV(LL,NN)
            UVS(L,24,3,ITYPE) = UVS(L,24,3,ITYPE) + UV(LL,NN)**2
            UVS(L,24,4,ITYPE) = UVS(L,24,4,ITYPE) + UV(LL,NN)**3
            UVS(L,24,5,ITYPE) = UVS(L,24,5,ITYPE) + UV(LL,NN)**4
            VVS(L,24,1,ITYPE) = VVS(L,24,1,ITYPE) + 1
            VVS(L,24,2,ITYPE) = VVS(L,24,2,ITYPE) + VV(LL,NN)
            VVS(L,24,3,ITYPE) = VVS(L,24,3,ITYPE) + VV(LL,NN)**2
            VVS(L,24,4,ITYPE) = VVS(L,24,4,ITYPE) + VV(LL,NN)**3
            VVS(L,24,5,ITYPE) = VVS(L,24,5,ITYPE) + VV(LL,NN)**4
          ENDIF
          IF(MAX(ABS(UM(LL,NN)),ABS(VM(LL,NN))).LT.BMISS) THEN
            UMS(L,N,1,ITYPE)  = UMS(L,N,1,ITYPE)  + 1
            UMS(L,N,2,ITYPE)  = UMS(L,N,2,ITYPE)  + UM(LL,NN)
            UMS(L,N,3,ITYPE)  = UMS(L,N,3,ITYPE)  + UM(LL,NN)**2
            UMS(L,N,4,ITYPE)  = UMS(L,N,4,ITYPE)  + UM(LL,NN)**3
            UMS(L,N,5,ITYPE)  = UMS(L,N,5,ITYPE)  + UM(LL,NN)**4
            VMS(L,N,1,ITYPE)  = VMS(L,N,1,ITYPE)  + 1
            VMS(L,N,2,ITYPE)  = VMS(L,N,2,ITYPE)  + VM(LL,NN)
            VMS(L,N,3,ITYPE)  = VMS(L,N,3,ITYPE)  + VM(LL,NN)**2
            VMS(L,N,4,ITYPE)  = VMS(L,N,4,ITYPE)  + VM(LL,NN)**3
            VMS(L,N,5,ITYPE)  = VMS(L,N,5,ITYPE)  + VM(LL,NN)**4
            UMS(L,24,1,ITYPE) = UMS(L,24,1,ITYPE) + 1
            UMS(L,24,2,ITYPE) = UMS(L,24,2,ITYPE) + UM(LL,NN)
            UMS(L,24,3,ITYPE) = UMS(L,24,3,ITYPE) + UM(LL,NN)**2
            UMS(L,24,4,ITYPE) = UMS(L,24,4,ITYPE) + UM(LL,NN)**3
            UMS(L,24,5,ITYPE) = UMS(L,24,5,ITYPE) + UM(LL,NN)**4
            VMS(L,24,1,ITYPE) = VMS(L,24,1,ITYPE) + 1
            VMS(L,24,2,ITYPE) = VMS(L,24,2,ITYPE) + VM(LL,NN)
            VMS(L,24,3,ITYPE) = VMS(L,24,3,ITYPE) + VM(LL,NN)**2
            VMS(L,24,4,ITYPE) = VMS(L,24,4,ITYPE) + VM(LL,NN)**3
            VMS(L,24,5,ITYPE) = VMS(L,24,5,ITYPE) + VM(LL,NN)**4
          ENDIF
          IF(ABS(VVI(LL,NN)).LT.BMISS) THEN
            VVIS(L,N,1,ITYPE)  = VVIS(L,N,1,ITYPE)  + 1
            VVIS(L,N,2,ITYPE)  = VVIS(L,N,2,ITYPE)  + VVI(LL,NN)
            VVIS(L,N,3,ITYPE)  = VVIS(L,N,3,ITYPE)  + VVI(LL,NN)**2
            VVIS(L,N,4,ITYPE)  = VVIS(L,N,4,ITYPE)  + VVI(LL,NN)**3
            VVIS(L,N,5,ITYPE)  = VVIS(L,N,5,ITYPE)  + VVI(LL,NN)**4
            VVIS(L,24,1,ITYPE) = VVIS(L,24,1,ITYPE) + 1
            VVIS(L,24,2,ITYPE) = VVIS(L,24,2,ITYPE) + VVI(LL,NN)
            VVIS(L,24,3,ITYPE) = VVIS(L,24,3,ITYPE) + VVI(LL,NN)**2
            VVIS(L,24,4,ITYPE) = VVIS(L,24,4,ITYPE) + VVI(LL,NN)**3
            VVIS(L,24,5,ITYPE) = VVIS(L,24,5,ITYPE) + VVI(LL,NN)**4
          ENDIF
          IF(ABS(VVT(LL,NN)).LT.BMISS) THEN
            VVTS(L,N,1,ITYPE)  = VVTS(L,N,1,ITYPE)  + 1
            VVTS(L,N,2,ITYPE)  = VVTS(L,N,2,ITYPE)  + VVT(LL,NN)
            VVTS(L,N,3,ITYPE)  = VVTS(L,N,3,ITYPE)  + VVT(LL,NN)**2
            VVTS(L,N,4,ITYPE)  = VVTS(L,N,4,ITYPE)  + VVT(LL,NN)**3
            VVTS(L,N,5,ITYPE)  = VVTS(L,N,5,ITYPE)  + VVT(LL,NN)**4
            VVTS(L,24,1,ITYPE) = VVTS(L,24,1,ITYPE) + 1
            VVTS(L,24,2,ITYPE) = VVTS(L,24,2,ITYPE) + VVT(LL,NN)
            VVTS(L,24,3,ITYPE) = VVTS(L,24,3,ITYPE) + VVT(LL,NN)**2
            VVTS(L,24,4,ITYPE) = VVTS(L,24,4,ITYPE) + VVT(LL,NN)**3
            VVTS(L,24,5,ITYPE) = VVTS(L,24,5,ITYPE) + VVT(LL,NN)**4
          ENDIF
          IF(ABS(VVV(LL,NN)).LT.BMISS) THEN
            VVVS(L,N,1,ITYPE)  = VVVS(L,N,1,ITYPE)  + 1
            VVVS(L,N,2,ITYPE)  = VVVS(L,N,2,ITYPE)  + VVV(LL,NN)
            VVVS(L,N,3,ITYPE)  = VVVS(L,N,3,ITYPE)  + VVV(LL,NN)**2
            VVVS(L,N,4,ITYPE)  = VVVS(L,N,4,ITYPE)  + VVV(LL,NN)**3
            VVVS(L,N,5,ITYPE)  = VVVS(L,N,5,ITYPE)  + VVV(LL,NN)**4
            VVVS(L,24,1,ITYPE) = VVVS(L,24,1,ITYPE) + 1
            VVVS(L,24,2,ITYPE) = VVVS(L,24,2,ITYPE) + VVV(LL,NN)
            VVVS(L,24,3,ITYPE) = VVVS(L,24,3,ITYPE) + VVV(LL,NN)**2
            VVVS(L,24,4,ITYPE) = VVVS(L,24,4,ITYPE) + VVV(LL,NN)**3
            VVVS(L,24,5,ITYPE) = VVVS(L,24,5,ITYPE) + VVV(LL,NN)**4
          ENDIF
          IF(ABS(VVM(LL,NN)).LT.BMISS) THEN
            VVMS(L,N,1,ITYPE)  = VVMS(L,N,1,ITYPE)  + 1
            VVMS(L,N,2,ITYPE)  = VVMS(L,N,2,ITYPE)  + VVM(LL,NN)
            VVMS(L,N,3,ITYPE)  = VVMS(L,N,3,ITYPE)  + VVM(LL,NN)**2
            VVMS(L,N,4,ITYPE)  = VVMS(L,N,4,ITYPE)  + VVM(LL,NN)**3
            VVMS(L,N,5,ITYPE)  = VVMS(L,N,5,ITYPE)  + VVM(LL,NN)**4
            VVMS(L,24,1,ITYPE) = VVMS(L,24,1,ITYPE) + 1
            VVMS(L,24,2,ITYPE) = VVMS(L,24,2,ITYPE) + VVM(LL,NN)
            VVMS(L,24,3,ITYPE) = VVMS(L,24,3,ITYPE) + VVM(LL,NN)**2
            VVMS(L,24,4,ITYPE) = VVMS(L,24,4,ITYPE) + VVM(LL,NN)**3
            VVMS(L,24,5,ITYPE) = VVMS(L,24,5,ITYPE) + VVM(LL,NN)**4
          ENDIF
        ENDDO  LOOP1n1
      ENDDO  LOOP1

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    DIFS
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: COMPUTE DIFFERENCES OF RESIDUALS, USED IN DMA.
C
C PROGRAM HISTORY LOG:
C 1995-04-04  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Excessive stdout print of differencing
C     results can be removed w/ new namelist switch which controls the
C     degree of printout.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL DIFS(IS,IPRINT)
C
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C     IPRINT   - =1 INCLUDE ADDITIONAL DIAGNOSTIC PRINT IN STDOUT,
C                ELSE = 0
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C REMARKS: 
C   VARIABLE NAMES:
C     UI       - U INCREMENT
C     VI       - V INCREMENT
C     UT       - U-COMPONENT TEMPORAL RESIDUAL
C     VT       - V-COMPONENT TEMPORAL RESIDUAL
C     UV       - U-COMPONENT VERTICAL RESIDUAL
C     VV       - V-COMPONENT VERTICAL RESIDUAL
C     UM       - U-COMPONENT MEDIAN RESIDUAL
C     VM       - V-COMPONENT MEDIAN RESIDUAL
C     VVI      - VECTOR INCREMENT
C     VVT      - VECTOR TEMPORAL RESIDUAL
C     VVM      - VECTOR MEDIAN RESIDUAL
C     VVV      - VECTOR VERTICAL RESIDUAL
C     DIT      - VECTOR DIFFERENCE: INCREMENT/TEMPORAL
C     DIV      - VECTOR DIFFERENCE: INCREMENT/VERTICAL
C     DTV      - VECTOR DIFFERENCE: TEMPORAL/VERTICAL
C     DIM      - VECTOR DIFFERENCE: INCREMENT/MEDIAN
C     DVM      - VECTOR DIFFERENCE: VERTICAL/MEDIAN
C     DTM      - VECTOR DIFFERENCE: TEMPORAL/MEDIAN
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE DIFS(IS,IPRINT)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN
      REAL(8)   BMISS

      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/LIMITS/XI(9124),XT(15750),XV(15750)
      COMMON /STNLST/ STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON /BUFRLIB_MISSING/BMISS

C     SPECIFY DIT,DIV,DTV,DIM,DVM,DTM -- MEASURES OF DIFFERENCES
C     OF THE RESIDUALS.

      DO J=1,NTIMES(IS)
        DO I=1,NZZ(IS)
          IF(IPRINT.EQ.1) THEN
            IF(MIN(VVI(I,J),VVT(I,J),VVV(I,J),VVM(I,J)).LT.BMISS) THEN
               WRITE(6,100)NSCAN,J,I,VVI(I,J),VVT(I,J),VVV(I,J),VVM(I,J)
            ELSE
               WRITE(6,101)NSCAN,J,I,VVI(I,J),VVT(I,J),VVV(I,J),VVM(I,J)
            ENDIF
          ENDIF
          IF(MAX(UI(I,J,IS),VI(I,J,IS),UT(I,J),VT(I,J)).LT.BMISS
     $      .AND. VVI(I,J)+VVT(I,J).NE.0.) THEN
            DIT(I,J) = SQRT((UI(I,J,IS) - UT(I,J))**2
     $                    + (VI(I,J,IS) - VT(I,J))**2)
     $                / (0.5*(VVI(I,J) + VVT(I,J)))
          ELSE
            DIT(I,J) = BMISS
          ENDIF
          IF(MAX(UI(I,J,IS),VI(I,J,IS),UV(I,J),VV(I,J)).LT.BMISS
     $      .AND. VVI(I,J)+VVV(I,J).NE.0.) THEN
            DIV(I,J) = SQRT((UI(I,J,IS) - UV(I,J))**2
     $                    + (VI(I,J,IS) - VV(I,J))**2)
     $                / (0.5*(VVI(I,J) + VVV(I,J)))
          ELSE
            DIV(I,J) = BMISS
          ENDIF
          IF(MAX(UT(I,J),VT(I,J),UV(I,J),VV(I,J)).LT.BMISS
     $      .AND. VVT(I,J)+VVV(I,J).NE.0.) THEN
            DTV(I,J) = SQRT((UT(I,J) - UV(I,J))**2
     $                    + (VT(I,J) - VV(I,J))**2)
     $                / (0.5*(VVT(I,J) + VVV(I,J)))
          ELSE
            DTV(I,J) = BMISS
          ENDIF
          IF(MAX(UI(I,J,IS),VI(I,J,IS),UM(I,J),VM(I,J)).LT.BMISS
     $      .AND. VVI(I,J)+VVM(I,J).NE.0.) THEN
            DIM(I,J) = SQRT((UI(I,J,IS) - UM(I,J))**2
     $                    + (VI(I,J,IS) - VM(I,J))**2)
     $                / (0.5*(VVI(I,J) + VVM(I,J)))
          ELSE
            DIM(I,J) = BMISS
          ENDIF
          IF(MAX(UV(I,J),VV(I,J),UM(I,J),VM(I,J)).LT.BMISS
     $      .AND. VVV(I,J)+VVM(I,J).NE.0.) THEN
            DVM(I,J) = SQRT((UV(I,J) - UM(I,J))**2
     $                    + (VV(I,J) - VM(I,J))**2)
     $                / (0.5*(VVV(I,J) + VVM(I,J)))
          ELSE
            DVM(I,J) = BMISS
          ENDIF
          IF(MAX(UT(I,J),VT(I,J),UM(I,J),VM(I,J)).LT.BMISS
     $      .AND. VVT(I,J)+VVM(I,J).NE.0.) THEN
            DTM(I,J) = SQRT((UT(I,J) - UM(I,J))**2
     $                    + (VT(I,J) - VM(I,J))**2)
     $                / (0.5*(VVT(I,J) + VVM(I,J)))
          ELSE
            DTM(I,J) = BMISS
          ENDIF
        ENDDO
      ENDDO

      RETURN

  100 FORMAT(' DIFS: scan=',I2,', time period=',I2,', lvl=',I3,
     $ '; vector: incr=',F6.2,', temporal resid=',F6.2,', vertical ',
     $ 'resid=',F6.2,', median resid=',F6.2)
  101 FORMAT('~DIFS: scan=',I2,', time period=',I2,', lvl=',I3,
     $ '; vector: incr=',F6.2,', temporal resid=',F6.2,', vertical ',
     $ 'resid=',F6.2,', median resid=',F6.2)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    DMA
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: DECISION MAKING ALGORITHM FOR PROFILER WIND QC.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Reason codes are expanded (see MAIN program
C     remarks).
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL DMA(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C REMARKS: 
C   VARIABLE NAMES:
C     ZI       - NORMALIZED VECTOR INCREMENT
C     ZT       - NORMALIZED VECTOR TEMPORAL RESIDUAL
C     ZV       - NORMALIZED VECTOR VERTICAL RESIDUAL
C     ZM       - NORMALIZED VECTOR MEDIAN RESIDUAL
C     DIT      - VECTOR DIFFERENCE: INCREMENT/TEMPORAL
C     DIV      - VECTOR DIFFERENCE: INCREMENT/VERTICAL
C     DTV      - VECTOR DIFFERENCE: TEMPORAL/VERTICAL
C     DIM      - VECTOR DIFFERENCE: INCREMENT/MEDIAN
C     DVM      - VECTOR DIFFERENCE: VERTICAL/MEDIAN
C     DTM      - VECTOR DIFFERENCE: TEMPORAL/MEDIAN
C     ICQC     - DMA INDEX FOR WIND QUALITY CONTROL
C     NCH      - NUMBER OF CHANGED QUALITY MARKS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE DMA(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN,CID
      REAL(8)   BMISS

      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/LIMITS/XI(9125),XT(15750),XV(15750)
      COMMON /BUFRLIB_MISSING/BMISS

      DATA  R11/8.0/,R12/3.0/,R2/0.4/,R31/4.0/,R32 /1.5/

      CID = STN(IS)

C     DETERMINE FLAGS FOR QUESTIONABLE AND BAD DATA.
C     SET ICQC TO:
C       0 IF DATA ARE GOOD
C       1 IF DATA ARE QUESTIONABLE
C       2 IF DATA ARE BAD
C     ALSO RETURN IN NCH THE NUMBER OF DECISIONS THAT CHANGE.

      NCH = 0
      DO N=1,NTIMES(IS)
        DO L=1,NZZ(IS)
          ICQCO = ICQC(L,N,IS)

C         FIND AVERAGE VECTOR RESIDUAL MAGNITUDE.

          SUM = 0.
          NRES = 0
          RESMN = 0.
          IF(ZI(L,N).LT.BMISS) THEN
            NRES = NRES + 1
            SUM = SUM + ZI(L,N)
          ENDIF
          IF(ZT(L,N).LT.BMISS) THEN
            NRES = NRES + 1
            SUM = SUM + ZT(L,N)
          ENDIF
          IF(ZV(L,N).LT.BMISS) THEN
            NRES = NRES + 1
            SUM = SUM + ZV(L,N)
          ENDIF
          IF(ZM(L,N).LT.BMISS) THEN
            NRES = NRES + 1
            SUM = SUM + ZM(L,N)
          ENDIF
          IF(NRES.GT.0) THEN
            RESMN = SUM / NRES
          ENDIF

C         FIND AVERAGE VECTOR RESIDUAL DIFFERENCE.

          SUM = 0.
          NRD = 0
          RESDM = 0.
          IF(DIT(L,N).LT.BMISS) THEN
            NRD = NRD + 1
            SUM = SUM + DIT(L,N)
          ENDIF
          IF(DIV(L,N).LT.BMISS) THEN
            NRD = NRD + 1
            SUM = SUM + DIV(L,N)
          ENDIF
          IF(DTV(L,N).LT.BMISS) THEN
            NRD = NRD + 1
            SUM = SUM + DTV(L,N)
          ENDIF
          IF(DIM(L,N).LT.BMISS) THEN
            NRD = NRD + 1
            SUM = SUM + DIM(L,N)
          ENDIF
          IF(DVM(L,N).LT.BMISS) THEN
            NRD = NRD + 1
            SUM = SUM + DVM(L,N)
          ENDIF
          IF(DTM(L,N).LT.BMISS) THEN
            NRD = NRD + 1
            SUM = SUM + DTM(L,N)
          ENDIF
          IF(NRD.GT.0) THEN
            RESDM = SUM / NRD
          ENDIF

C         FOR AN ERROR, REQUIRE RESMN LARGE AND RESDM TO BE SMALL.

          Z1 = 10000.
          Z2 = 13000.
          IF(ZZ(L,N,IS).LE.Z1) THEN ! ZZ .le. 10000 m
            R1 = R11
            R3 = R31
          ELSE IF(ZZ(L,N,IS).GE.Z2) THEN ! ZZ .ge. 13000 m
            R1 = R12
            R3 = R32
          ELSE ! ZZ between 10000 and 13000 m
            R1 = ((Z2-ZZ(L,N,IS))*R11 + (ZZ(L,N,IS)-Z1)*R12)/(Z2-Z1)
            R3 = ((Z2-ZZ(L,N,IS))*R31 + (ZZ(L,N,IS)-Z1)*R32)/(Z2-Z1)
          ENDIF
          K1 = 0
          K2 = 0
          K3 = 0
          ITOT = 0
          IDIT = 0
          IDIV = 0
          IDIM = 0
          IDTV = 0
          IDTM = 0
          IDVM = 0
          IF(RESMN.GT.R1 .AND. RESDM.LT.R2  .OR.
     $      (RESMN.GT.R1 .AND. NRD.EQ.1)) THEN ! Bad
             INEW = 2
            IF(NRD.EQ.1.AND.RESDM.GE.R2) THEN
              K3 = 1
            ELSE
              IF(DIT(L,N).LT.R2) THEN
                IDIT = 1
                ITOT = ITOT + 1
              ENDIF
              IF(DIV(L,N).LT.R2) THEN
                IDIV = 1
                ITOT = ITOT + 1
              ENDIF
              IF(DIM(L,N).LT.R2) THEN
                IDIM = 1
                ITOT = ITOT + 1
              ENDIF
              IF(DTV(L,N).LT.R2) THEN
                IDTV = 1
                ITOT = ITOT + 1
              ENDIF
              IF(DTM(L,N).LT.R2) THEN
                IDTM = 1
                ITOT = ITOT + 1
              ENDIF
              IF(DVM(L,N).LT.R2) THEN
                IDVM = 1
                ITOT = ITOT + 1
              ENDIF
              IF(ITOT.GE.4) THEN
                K3 = 9
              ELSE IF(ITOT.GE.2) THEN
                K3 = 8
              ELSE IF(ITOT.EQ.1) THEN
                IF(IDIT.EQ.1) THEN
                  K3 = 2
                ELSE IF(IDIV.EQ.1) THEN
                  K3 = 3
                ELSE IF(IDIM.EQ.1) THEN
                  K3 = 4
                ELSE IF(IDTV.EQ.1) THEN
                  K3 = 5
                ELSE IF(IDTM.EQ.1) THEN
                  K3 = 6
                ELSE IF(IDVM.EQ.1) THEN
                  K3 = 7
                ENDIF
              ENDIF
            ENDIF
            K1 = 1
            IF(MAX(ZM(L,N),ZV(L,N)).LT.BMISS.AND.MIN(ZM(L,N),ZV(L,N))
     $       .GT.R1) THEN
              K1 = 7
            ELSE IF(ZV(L,N).GT.R1.AND.ZV(L,N).LT.BMISS) THEN
              K1 = 6
            ELSE IF(ZM(L,N).GT.R1.AND.ZM(L,N).LT.BMISS) THEN
              K1 = 5
            ENDIF
            K2 = 1
            IF(MAX(ZT(L,N),ZI(L,N)).LT.BMISS.AND.MIN(ZT(L,N),ZI(L,N))
     $       .GT.R1) THEN
              K2 = 7
            ELSE IF(ZI(L,N).GT.R1.AND.ZI(L,N).LT.BMISS) THEN
              K2 = 6
            ELSE IF(ZT(L,N).GT.R1.AND.ZT(L,N).LT.BMISS) THEN
              K2 = 5
            ENDIF
          ELSE IF(RESMN.GT.R3) THEN
            INEW = 1 ! Suspect
            K1 = 1
            IF(MAX(ZM(L,N),ZV(L,N)).LT.BMISS.AND.MIN(ZM(L,N),ZV(L,N))
     $       .GT.R3) THEN
              K1 = 4
            ELSE IF(ZV(L,N).GT.R3.AND.ZV(L,N).LT.BMISS) THEN
              K1 = 3
            ELSE IF(ZM(L,N).GT.R3.AND.ZM(L,N).LT.BMISS) THEN
              K1 = 2
            ENDIF
            K2 = 1
            IF(MAX(ZT(L,N),ZI(L,N)).LT.BMISS.AND.MIN(ZT(L,N),ZI(L,N))
     $       .GT.R3) THEN
              K2 = 4
            ELSE IF(ZI(L,N).GT.R3.AND.ZI(L,N).LT.BMISS) THEN
              K2 = 3
            ELSE IF(ZT(L,N).GT.R3.AND.ZT(L,N).LT.BMISS) THEN
              K2 = 2
            ENDIF
          ELSE
            INEW = 0 ! Passed checks (good)
          ENDIF
          ICQC(L,N,IS) = INEW
          IF(INEW.GT.0)  IRC(L,N,IS) = K1*100 + K2*10 + K3

C         CHECK FOR DECISION CHANGES

          IF(ICQCO.NE.ICQC(L,N,IS)) NCH = NCH + 1
        ENDDO
      ENDDO

      WRITE(6,100) NSCAN,NCH

      RETURN

  100 FORMAT('--> DMA: For scan',I3,' the total number of q.m. changes',
     $ ' is',I4)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    EVENT
C   PRGMMR: J. WOOLLEN       ORG: NP20       DATE: 1994-??-??
C
C ABSTRACT: WRITE OUT EVENTS.
C
C PROGRAM HISTORY LOG:
C 1994-??-??  J. WOOLLEN -- Original author.
C
C USAGE:    CALL EVENT(LUNIT,EVNSTR,NLV,OBS,QMS,RCS,IND,NEVN,QCPC)
C   INPUT ARGUMENT LIST:
C     LUNIT    - UNIT NUMBER
C     EVNSTR   - EVENT STREAM OF CHARACTERS
C     NLV      - NUMBER OF LEVELS
C     OBS      - OBSERVED VALUE
C     QMS      - QUALITY MARKER
C     RCS      - REASON CODE
C     IND      - INDIRECT ADDRESS OF VALUE
C     NEVN     - NUMBER OF EVENTS
C     QCPC     - PROGRAM CODE
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE EVENT(LUNIT,EVNSTR,NLV,OBS,QMS,RCS,IND,NEVN,QCPC)

      CHARACTER*(*)  EVNSTR
      REAL(8)  EVNS_8(5,255),BMISS
      DIMENSION  OBS(255,2),QMS(NEVN),RCS(NEVN),IND(NEVN)

      COMMON /BUFRLIB_MISSING/BMISS

      IF(NEVN.EQ.0) THEN
         WRITE(6,100)
         RETURN
      ENDIF

C  CLEAR THE UFB ARRAY FIRST
C  -------------------------

      EVNS_8 = BMISS

C  TRANSFER EVENT ARRAYS INTO UFB ARRAY
C  ------------------------------------

      DO I=1,NEVN
         J = IND(I)
         IF(MIN(OBS(I,1),OBS(I,2)).LT.BMISS) THEN
            EVNS_8(1,J) = OBS(I,1)
            EVNS_8(2,J) = OBS(I,2)
            EVNS_8(3,J) = QMS(I)
            EVNS_8(4,J) = QCPC
            EVNS_8(5,J) = RCS(I)
         ENDIF
      ENDDO

C  WRITE THE EVENTS AND EXIT
C  -------------------------

      CALL UFBINT(LUNIT,EVNS_8,5,NLV,IRET,EVNSTR)
      WRITE(6,101) NLV,IRET

      RETURN

  100 FORMAT('  NO EVENTS WRITTEN')
  101 FORMAT('  EVENTS WRITTEN, NLV,IRET:',2I4)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    INCR
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: CALCULATE FORECAST INCREMENTS, I.E. THE DIFFERENCE 
C   BETWEEN THE OBSERVED VALUE AND THE FORECAST VALUE (OF THE
C   WIND COMPONENTS).
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL INCR
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE INCR

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN
      REAL(8)  BMISS

      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON /QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON /STNLST/ STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON /BUFRLIB_MISSING/BMISS

      WRITE(6,100)

      DO N=1,NSTN
         DO M=1,NTIMES(N)
            DO L=1,NZZ(N)
	       IF(MAX(UZ(L,M,N),UFZ(L,M,N)).LT.BMISS) THEN
                  UI(L,M,N) = UZ(L,M,N) - UFZ(L,M,N)
               ELSE
                  UI(L,M,N) = BMISS
               ENDIF
	       IF(MAX(VZ(L,M,N),VFZ(L,M,N)).LT.BMISS) THEN
                  VI(L,M,N) = VZ(L,M,N) - VFZ(L,M,N)
               ELSE
                  VI(L,M,N) = BMISS
               ENDIF
            ENDDO
         ENDDO
      ENDDO

      RETURN

  100 FORMAT(//'CALCULATING WIND COMPONENT INCREMENTS'//)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    INDICATE
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: COMPUTE NORMALIZED RESIDUALS FOR A SINGLE UNIQUE
C   STATION.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Incr., temporal, vert. & median chk error
C     limits now directly assoc. w/ a rpted hgt above ground lvl rather
C     than w/ lvl index in arrays (ensures proper error limit used at
C     all lvls & eliminates hgt above ground vs. hgt above sea lvl
C     discrepancy - error limits values remain unchanged).
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL INDICATE(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C REMARKS: 
C   VARIABLE NAMES:
C     VVI      - VECTOR INCREMENT
C     VVT      - VECTOR TEMPORAL RESIDUAL
C     VVV      - VECTOR VERTICAL RESIDUAL
C     VVM      - VECTOR MEDIAN RESIDUAL
C     NI       - NORMALIZED VECTOR INCREMENT
C     NTMP     - NORMALIZED VECTOR TEMPORAL RESIDUAL
C     NV       - NORMALIZED VECTOR VERTICAL RESIDUAL
C     NM       - NORMALIZED MEDIAN RESIDUAL
C     ZI       - NORMALIZED VECTOR INCREMENT
C     ZT       - NORMALIZED VECTOR TEMPORAL RESIDUAL
C     ZV       - NORMALIZED VECTOR VERTICAL RESIDUAL
C     ZM       - NORMALIZED VECTOR MEDIAN RESIDUAL
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C        
C$$$
      SUBROUTINE INDICATE(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN
      REAL(8)  BMISS

      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/LIMITS/XI(9125),XT(15750),XV(15750)
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON /BUFRLIB_MISSING/BMISS

      XM(XIZ,XTZ,XVZ) = SQRT((XIZ**2+XTZ**2+XVZ**2)/3.)

C     SET INDICATORS.
C     A VALUE OF 2 CORRESPONDS TO 1.0 STANDARD DEVIATION.
C     VALUES ARE CAPPED AT 20.

      DO N=1,NTIMES(IS)
        DO L=1,NZZ(IS)

          XIZ = 3.80
          XTZ = 2.00
          XVZ = 3.00
          IF(NINT(ZZ(L,N,IS)-Z0(IS)).LT.15751) THEN
            XTZ = XT(NINT(ZZ(L,N,IS)-Z0(IS)))
            XVZ = XV(NINT(ZZ(L,N,IS)-Z0(IS)))
            IF(NINT(ZZ(L,N,IS)-Z0(IS)).LT.9126) THEN
              XIZ = XI(NINT(ZZ(L,N,IS)-Z0(IS)))
            ENDIF
          ENDIF
          IF(VVI(L,N).LT.BMISS) THEN
            NI(L,N) = VVI(L,N)/(0.5*XIZ)
            ZI(L,N) = VVI(L,N)/XIZ
          ELSE
            NI(L,N) = -1
            ZI(L,N) = BMISS
          ENDIF
          NI(L,N) = MIN(NI(L,N),20)
	
          IF(VVT(L,N).LT.BMISS) THEN
            NTMP(L,N) = VVT(L,N)/(0.5*XTZ)
            ZT(L,N) = VVT(L,N)/XTZ
          ELSE
            NTMP(L,N) = -1
            ZT(L,N) = BMISS
          ENDIF
          NTMP(L,N) = MIN(NTMP(L,N),20)
	
          IF(VVV(L,N).LT.BMISS) THEN
            NV(L,N) = VVV(L,N)/(0.5*XVZ)
            ZV(L,N) = VVV(L,N)/XVZ
          ELSE
            NV(L,N) = -1
            ZV(L,N) = BMISS
          ENDIF
          NV(L,N) = MIN(NV(L,N),20)
	
          IF(VVM(L,N).LT.BMISS) THEN
            NM(L,N) = VVM(L,N)/(0.5*XM(XIZ,XTZ,XVZ))
            ZM(L,N) = VVM(L,N)/XM(XIZ,XTZ,XVZ)
          ELSE
            NM(L,N) = -1
            ZM(L,N) = BMISS
          ENDIF
          NM(L,N) = MIN(NM(L,N),20)
	
        ENDDO
      ENDDO

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C 
C SUBPROGRAM:    INIT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: INITIALIZES SEVERAL VARIABLES.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL INIT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE INIT

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8 STN
      REAL(8)  BMISS

      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/PROFP/ZP(NL,NT,NS),UP(NL,NT,NS),VP(NL,NT,NS),QP(NL,NT,NS),
     $ PP(NL,NT,NS),UFP(NL,NT,NS),VFP(NL,NT,NS),LEVP(NL,NT,NS)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/STATZ/UZS(120,0:24,9,3:8),VZS(120,0:24,9,3:8),
     $ UIS(120,0:24,9,3:8),VIS(120,0:24,9,3:8),UTS(120,0:24,9,3:8),
     $ VTS(120,0:24,9,3:8),UVS(120,0:24,9,3:8),VVS(120,0:24,9,3:8),
     $ VVIS(120,0:24,9,3:8),VVTS(120,0:24,9,3:8),VVVS(120,0:24,9,3:8),
     $ VVMS(120,0:24,9,3:8),UMS(120,0:24,9,3:8),VMS(120,0:24,9,3:8)
      COMMON /BUFRLIB_MISSING/BMISS

      ZZ   = BMISS
      UZ   = BMISS
      VZ   = BMISS
      QZ   = BMISS
      PZ   = BMISS
      UFZ  = BMISS
      VFZ  = BMISS
      SZ   = BMISS
      DZ   = BMISS
      LEVZ = 0

      ZP   = BMISS
      UP   = BMISS
      VP   = BMISS
      QP   = BMISS
      PP   = BMISS
      UFP  = BMISS
      VFP  = BMISS
      LEVP = 0

      STN  = '99999999'
      X    = BMISS
      Y    = BMISS
      Z    = BMISS
      TIM  = BMISS
      NTIMES = 0

      UI   = BMISS
      VI   = BMISS

      QM   = 0
      IQ   = 99999
      ICQC = 0
      IQCC = 0

      IBAD_FLAG = 0
      JBAD_FLAG = 0

      IRC = 99999

      MLEV = 0

      DT   = BMISS

      UZS  = 0
      VZS  = 0
      UIS  = 0
      VIS  = 0
      UTS  = 0
      VTS  = 0
      UVS  = 0
      VVS  = 0
      VVIS = 0
      VVTS = 0
      VVVS = 0
      VVMS = 0
      UMS  = 0
      VMS  = 0

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    ISDONE
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1996-11-20
C
C ABSTRACT: TEST TO SEE IF QUALITY CONTROL IS COMPLETE FOR THIS
C   STATION.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C
C USAGE:    CALL ISDONE(DONE)
C   INPUT ARGUMENT LIST:
C     DONE     - LOGICAL VARIABLE, TRUE WHEN COMPLETE
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE ISDONE(DONE)

      LOGICAL DONE

      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT

      IF((NSCAN.GT.1 .AND. NCH.EQ.0) .OR. NSCAN.GT.8) THEN
         DONE = .TRUE.
         IF(NCH.EQ.0) THEN
            WRITE(6,100)
         ELSE
            WRITE(6,101)
         ENDIF
      ELSE
         DONE = .FALSE.
         IF(NCH.EQ.0) THEN
            WRITE(6,102)
         ELSE
            WRITE(6,103)
         ENDIF
      ENDIF

      RETURN

  100 FORMAT('NO Q.M. CHANGES IN THIS SCAN, DONE WITH THIS STN')
  101 FORMAT('HIT LIMIT OF 9 SCANS STILL WITH Q.M. CHANGES, ',
     $ 'DONE WITH THIS STN')
  102 FORMAT('NO Q.M. CHANGES IN THIS SCAN, BUT THIS IS FIRST SCAN, ',
     $ 'SCAN ONCE AGAIN')
  103 FORMAT('SINCE Q.M. CHANGES IN THIS SCAN, SCAN ONCE AGAIN')

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    ISORT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1994-03-17
C
C ABSTRACT: SORT INTEGERS IA ACCORDING TO THE ORDER SPECIFIED BY THE
C   INDICES IN INDX.
C
C PROGRAM HISTORY LOG:
C 1994-03-17  W. Collins -- Original author.
C
C USAGE:    CALL SORT(IA,INDX,N)
C   INPUT ARGUMENT LIST:
C     IA       - VARIABLE
C     INDX     - ORDER FOR REARRANGEMENT OF RA
C     N        - DIMENSION OF RA
C
C   OUTPUT ARGUMENT LIST:
C     IA       - VARIABLE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE ISORT(IA,INDX,N)

C     SORT IA ACCORDING TO THE ORDER SPECIFIED BY THE INDICES IN INDX.

      INTEGER INDX(*)
      DIMENSION IA(*), IKSP(899)

      IKSP(1:N) = IA(1:N)

      IA(1:N) = IKSP(INDX(1:N))

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    MODQUAL
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: CONVERTS THIS PROGRAM'S DMA INDEX FOR WIND QUALITY
C   CONTROL FOR SUSPECT OR BAD (1 OR 2, RESP.) TO PREPBUFR
C   QUALITY MARK FOR SUSPECT OR BAD (3 OR 13, RESP.).  PRE-
C   EXISTING BAD PREPBUFR QUALITY MARKS ARE HONORED.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL MODQUAL(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C REMARKS: 
C   VARIABLE NAMES:
C     IQ       - PRE-EXISTING PREPBUFR WIND QUALITY MARKS
C     ICQC     - DMA INDEX FOR WIND QUALITY CONTROL
C     IQCC     - EITHER 0 IF PRE-EXISTING PREPBUFR WIND QUALITY
C                MARK NOT CHANGED BY DMA (I.E., NO EVENT), 3 IF
C                DMA DETERMINES QUALITY IS SUSPECT, OR 13 IF DMA
C                DETERMINES QUALITY IS BAD
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE MODQUAL(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN

      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/TIMEO/TIMWIN_E,TIMWIN_L

      DO IT=1,NTIMES(IS)
        DO L=1,NZZ(IS)

C Honor pre-exiting PREPBUFR q.m. as follows:
C  - If it's BAD, then don't use bad or suspect q.m. from this program
C  - If it's SUSPECT, then don't use suspect q.m. from this program
C     (do use BAD q.m. from this program, however)

          IF(IQ(L,IT,IS).LT.4) THEN
            IF(ICQC(L,IT,IS).EQ.1.AND.IQ(L,IT,IS).LT.3) THEN
               IQCC(L,IT,IS) = 3  ! Suspect
            ELSE IF(ICQC(L,IT,IS).EQ.2) THEN
               IQCC(L,IT,IS) = 13 ! Bad
            ELSE
               IRC(L,IT,IS) = 99999
            ENDIF
          ELSE
            IRC(L,IT,IS) = 99999
          ENDIF
          IF(NINT(TIM(IT,IS)*1000.).LT.NINT(TIMWIN_E*1000.).OR.
     $       NINT(TIM(IT,IS)*1000.).GT.NINT(TIMWIN_L*1000.)) CYCLE
          IF((IQ(L,IT,IS).GT.2.AND.IQ(L,IT,IS).LT.16) .OR.
     $     ICQC(L,IT,IS).GT.0) THEN
            IBAD_FLAG(IT,IS) = 1
            JBAD_FLAG(IS) = 1
          ENDIF
        ENDDO
      ENDDO

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    PLINT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1995-04-05
C
C ABSTRACT: INTERPOLATE FIN AT (2,2), NOT USING VALUE AT THIS POINT.
C   INTERPOLATION IS PLANAR LEAST SQUARES FIT TO SURROUNDING DATA.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C
C USAGE:    CALL PLINT(FIN,FUT,BMISS)
C   INPUT ARGUMENT LIST:
C     FIN      - INPUT FIELD
C     BMISS    - VALUE INDICATING MISSING
C
C   OUTPUT ARGUMENT LIST:
C     FUT      - OUTPUT INTERPOLATED VALUE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE PLINT(FIN,FUT,BMISS)

      REAL FIN(3,3),F(9)
      REAL(8) BMISS
      INTEGER IX(9),IY(9)

      IPNT = 0
      FSUM = 0.

      DO I=1,3
        DO J=1,3
          FSUM = FSUM + ABS(FIN(I,J))
        ENDDO
      ENDDO
      IF(FSUM.LT..01) THEN
        FUT = BMISS
        RETURN
      ENDIF

      F  = BMISS
      IX = 99
      IY = 99

      DO J=1,3
        DO I=1,3
          IF(I.EQ.2.AND.J.EQ.2) CYCLE
          IF(FIN(I,J).EQ.BMISS) CYCLE
          IPNT = IPNT + 1
          F(IPNT) = FIN(I,J)
          IX(IPNT) = I-2
          IY(IPNT) = J-2
        ENDDO
      ENDDO

      IF(IPNT.GE.4) GOTO 30

      IF(IPNT.LE.2) THEN
        FUT = BMISS
        RETURN
      ENDIF

      IF((IX(1).EQ.IX(2).AND.IX(2).EQ.IX(3))
     &  .OR.(IY(1).EQ.IY(2).AND.IY(2).EQ.IY(3))) THEN
        FUT = BMISS
        RETURN
      ENDIF

   30 CONTINUE

      XB  = 0.
      YB  = 0.
      XYB = 0.
      ZYB = 0.
      ZXB = 0.
      YYB = 0.
      XXB = 0.
      ZB  = 0.

      DO I=1,IPNT
        XB = XB + IX(I)
        YB = YB + IY(I)
        XXB = XXB + IX(I)**2
        YYB = YYB + IY(I)**2
        XYB = XYB + IX(I)*IY(I)
        ZB = ZB + F(I)
        ZXB = ZXB + F(I)*IX(I)
        ZYB = ZYB + F(I)*IY(I)
      ENDDO

      F1=(XB*(XYB*ZYB-YYB*ZXB)-YB*(XXB*ZYB-XYB*ZXB)+ZB*(XXB*YYB-XYB**2))
      F2 = (XB*(XYB*YB-XB*YYB)-YB*(XXB*YB-XB*XYB)+IPNT*(XXB*YYB-XYB**2))

      IF(F2.EQ.0.) THEN
        FUT = BMISS
      ELSE
        FUT = F1/F2
      ENDIF

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    PRNTDATA
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: WRITE WIND PROFILER DATA TO VARIOUS UNITS FOR A SINGLE
C   UNIQUE STATION.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Stdout easier to read & more complete. Rpt
C     lvl info. in various output listings expanded & sorted into bins
C     containing both all data lvls & only lvls w/ either suspect or
C     bad q. marks; output written to text files but not incl. in
C     stdout.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL PRNTDATA(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 52  - LISTING (TYPE 1) OF ALL OUTPUT WIND PROFILER LEVELS
C     UNIT 53  - LISTING (TYPE 2) OF ALL OUTPUT WIND PROFILER LEVELS
C     UNIT 54  - LISTING (TYPE 1) OF WIND PROFILER LEVELS WITH EVENTS
C                FROM THIS PROGRAM PLUS PRE-EXISTING PREPBUFR BAD
C                LEVELS
C     UNIT 55  - LISTING (TYPE 2) OF WIND PROFILER LEVELS WITH EVENTS
C                FROM THIS PROGRAM PLUS PRE-EXISTING PREPBUFR BAD
C                LEVELS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE PRNTDATA(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN
      CHARACTER*1  CEVN

      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/DATEZ/JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/TIMEO/TIMWIN_E,TIMWIN_L

      WRITE(52,100) STN(IS)
      WRITE(53,100) STN(IS)
      IF(JBAD_FLAG(IS).EQ.1) THEN
        WRITE(54,101) STN(IS)
        WRITE(55,101) STN(IS)
        WRITE(54,102)
        WRITE(55,103)
      ENDIF
      WRITE(52,102)
      WRITE(53,103)
      DO N=1,NTIMES(IS)
        IF(NINT(TIM(N,IS)*1000.).LT.NINT(TIMWIN_E*1000.).OR.
     $     NINT(TIM(N,IS)*1000.).GT.NINT(TIMWIN_L*1000.)) CYCLE

        IF(NZZ(IS).GT.0) THEN
           WRITE(6,104) STN(IS),Z0(IS),(KDATE(J,N,IS),J=1,5)
           WRITE(6,102)
        ELSE
           CYCLE
        ENDIF

C       PRINT TO VARIOUS UNITS AFTER MAKING SURE THAT
C       THE NUMBERS ARE SMALL ENOUGH TO FIT IN FORMAT.

        IW10000 = 0
        IW13000 = 0
        DO I=1,NZZ(IS)
          IF(ZZ(I,N,IS).GT.99999.) CYCLE
          IF(IQ(I,N,IS).GT.3.OR.IQCC(I,N,IS).EQ.0) THEN
             IQCCP = IQ(I,N,IS)
          ELSE
             IQCCP = IQCC(I,N,IS)
          ENDIF

          CEVN = ' '
          IF(IQCC(I,N,IS).GT.0) THEN
             CEVN = '+'
          ENDIF

C         WRITE THIS PROGRAM'S EVENTS + PRE-EXISTING PREPBUFR BAD
C          LEVELS TO UNIT 54 - TYPE 1 LISTING

          IF((IQ(I,N,IS).GT.2.AND.IQ(I,N,IS).LT.16) .OR.
     $        ICQC(I,N,IS).GT.0) THEN
            WRITE(54,105) (KDATE(J,N,IS),J=1,5),STN(IS),
     $       NINT(ZZ(I,N,IS)),NINT(SZ(I,N,IS)),NINT(DZ(I,N,IS)),
     $       UZ(I,N,IS),VZ(I,N,IS),UFZ(I,N,IS),VFZ(I,N,IS),UT(I,N),
     $       VT(I,N),UV(I,N),VV(I,N),UM(I,N),VM(I,N),VVI(I,N),VVT(I,N),
     $       VVV(I,N),VVM(I,N),IQ(I,N,IS),NI(I,N),NTMP(I,N),NV(I,N),
     $       NM(I,N),ICQC(I,N,IS),IQCCP,CEVN
          ENDIF

C         WRITE THIS PROGRAM'S EVENTS + PRE-EXISTING PREPBUFR BAD
C          LEVELS TO UNIT 55 - TYPE 2 LISTING

          IF((IQ(I,N,IS).GT.2.AND.IQ(I,N,IS).LT.16) .OR.
     $       ICQC(I,N,IS).GT.0) THEN
            IF(NINT(ZZ(I,N,IS)).GT.10000.AND.IW10000.EQ.0) THEN
               WRITE(55,106)
               IW10000 = 1
            ENDIF
            IF(NINT(ZZ(I,N,IS)).GE.13000.AND.IW13000.EQ.0) THEN
               WRITE(55,106)
               IW13000 = 1
            ENDIF
            WRITE(55,107) (KDATE(J,N,IS),J=1,5),STN(IS),
     $       NINT(ZZ(I,N,IS)),UZ(I,N,IS),VZ(I,N,IS),UFZ(I,N,IS),
     $       VFZ(I,N,IS), ZI(I,N),ZT(I,N),DT(I,N,IS),ZV(I,N),ZM(I,N),
     $       DIT(I,N),DIV(I,N),DTV(I,N),DIM(I,N),DVM(I,N),DTM(I,N),
     $       IQ(I,N,IS),ICQC(I,N,IS),IQCCP,CEVN,IRC(I,N,IS)
          ENDIF

C         WRITE ALL DATA TO STANDARD OUTPUT (UNIT 06)

          WRITE(6,105) (KDATE(J,N,IS),J=1,5),STN(IS),NINT(ZZ(I,N,IS)),
     $      NINT(SZ(I,N,IS)),NINT(DZ(I,N,IS)),UZ(I,N,IS),VZ(I,N,IS),
     $      UFZ(I,N,IS),VFZ(I,N,IS),UT(I,N),VT(I,N),UV(I,N),VV(I,N),
     $      UM(I,N),VM(I,N),VVI(I,N),VVT(I,N),VVV(I,N),VVM(I,N),
     $      IQ(I,N,IS),NI(I,N),NTMP(I,N),NV(I,N),NM(I,N),ICQC(I,N,IS),
     $      IQCCP,CEVN

C         WRITE ALL DATA TO UNIT 52 - TYPE 1 LISTING

          WRITE(52,105) (KDATE(J,N,IS),J=1,5),STN(IS),NINT(ZZ(I,N,IS)),
     $     NINT(SZ(I,N,IS)),NINT(DZ(I,N,IS)),UZ(I,N,IS),VZ(I,N,IS),
     $     UFZ(I,N,IS),VFZ(I,N,IS),UT(I,N),VT(I,N),UV(I,N),VV(I,N),
     $     UM(I,N),VM(I,N),VVI(I,N),VVT(I,N),VVV(I,N),VVM(I,N),
     $     IQ(I,N,IS),NI(I,N),NTMP(I,N),NV(I,N),NM(I,N),ICQC(I,N,IS),
     $     IQCCP,CEVN

C         WRITE ALL DATA TO UNIT 53 - TYPE 2 LISTING

           WRITE(53,107) (KDATE(J,N,IS),J=1,5),STN(IS),NINT(ZZ(I,N,IS)),
     $      UZ(I,N,IS),VZ(I,N,IS),UFZ(I,N,IS),VFZ(I,N,IS),ZI(I,N),
     $      ZT(I,N),DT(I,N,IS),ZV(I,N),ZM(I,N),DIT(I,N),DIV(I,N),
     $      DTV(I,N),DIM(I,N),DVM(I,N),DTM(I,N),IQ(I,N,IS),ICQC(I,N,IS),
     $      IQCCP,CEVN,IRC(I,N,IS)
        ENDDO
        WRITE(53,108)
        IF(IBAD_FLAG(N,IS).EQ.1) THEN
           WRITE(54,108)
           WRITE(55,108)
        ENDIF
      ENDDO

      RETURN

  100 FORMAT(/1X,128('+')/' FINAL LISTING OF ALL LVLS FOR ',A8,'(+ in ',
     $ 'QQ column means this program wrote a q.c. event)')
  101 FORMAT(/1X,128('+')/' FINAL LISTING OF ALL SUSPECT OR BAD LVLS ',
     $ 'FOR ',A8,'(+ in QQ column means this program wrote a q.c. ',
     $ 'event)')
  102 FORMAT('  DATETIME    STN        Z  SP DIR     U     V    UG    ',
     $  'VG   UT   VT   UV   VV   UM   VM  VVI  VVT  VVV  VVM IQ NI NT',
     $ ' NV NM PQ OQ')
  103 FORMAT('  DATETIME    STN        Z     U     V    UG    ',
     $  'VG    ZI    ZT(del-t)    ZV    ZM   DIT   DIV   DTV   DIM   ',
     $ 'DVM   DTM IQ PQ OQ   RC')
  104 FORMAT(' FINAL LISTING OF ALL LVLS FOR ',A8,', ELEV ',F6.1,' AT ',
     $ I4,'/',I2.2,'/',I2.2,'/',I2.2,I2.2,' (+ in QQ column means this',
     $ ' program wrote a q.c. event)')
  105 FORMAT(I4,4I2.2,1X,A8,I5,1X,I3,1X,I3,4(1X,F5.1),10(1X,F4.1),1X,I2,
     $ 4(1X,I2),2(1X,I2),A1)
  106 FORMAT(1X,64('. '))
  107 FORMAT(I4,4I2.2,1X,A8,I5,6(1X,F5.1),'(',F5.2,')',8(1X,F5.1),
     $ 3(1X,I2),A1,1X,I3.3)
  108 FORMAT(1X,128('-'))

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    PUTDATA
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: PLACE DATA FOR A SINGLE REPORT INTO COMMON BLOCKS FOR
C   USE.  THE ORIGINAL REPORTED LEVELS ARE SPLIT FROM THE AUXILIARY
C   LEVELS OPTIONALLY ADDED BY THE PREVIOUS PREPOBS_PREPDATA PROGRAM.
C   ONLY THE ORIGINAL REPORTED LEVELS ARE QC'D AND THE QUALITY OF THE
C   AUXILIARY LEVELS IS IMPLIED.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 1998-09-16  W. COLLINS -- Use W3LIB routine W3MOVDAT for date
C     change computation.
C 2004-09-09  D. Keyser  -- Max. no. of sites processed incr. from 40
C     to 120. No. of time periods input now site specific (was
C     hardwired to be same for all rpts).
C 2016-12-20  Stokes/Keyser  Increase the max allowable number of times
C     per station.  Skip reports and print warning if that limit is 
C     exceeded.
C
C USAGE:    CALL PUTDATA
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE PUTDATA

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN,CID,cNT
      REAL  RINC(5)
      REAL(8)  SID_8
      INTEGER  IDAT(8),JDAT(8)

      COMMON/DATEZ/JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON/HEADER/SID_8,XOB,YOB,DHR,ELV,XTP,TYP,T29,NLV
      COMMON/PROBS/ZOB(255),UOB(255),VOB(255),WQM(255),POB(255),
     $ UFC(255),VFC(255),CAT(255),SOB(255),DOB(255)
      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/PROFP/ZP(NL,NT,NS),UP(NL,NT,NS),VP(NL,NT,NS),QP(NL,NT,NS),
     $ PP(NL,NT,NS),UFP(NL,NT,NS),VFP(NL,NT,NS),LEVP(NL,NT,NS)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT

      EQUIVALENCE (SID_8,CID)

      data ifirst/0/

      NREP1  = NREP1  + 1

C  FIND A STATION MATCH
C  --------------------

      IF(NSTN.GT.0) THEN
         DO NN=1,NSTN
            N = NN
            IF(STN(N).EQ.CID) GOTO 10    ! We have a match
         ENDDO
      ENDIF

C  IF NO MATCH, ADD THIS STATION TO LIST
C  -------------------------------------

      NSTN  = NSTN  + 1
      NSTN1 = NSTN1 + 1
      IF(NSTN1.GT.NS) THEN
         WRITE(6,100) CID,NS
         NSTN = NS
         RETURN
      ENDIF
      N = NSTN
      STN(N)  = CID
      X(N)    = XOB
      Y(N)    = YOB
      Z0(N)   = ELV
      IRTP(N) = NINT(TYP)

   10 CONTINUE

C  PRINT WARNING IF NUMBER OF OB TIMES > LIMIT FOR A PARTICULAR STATION
C  --------------------------------------------------------------------

      NTIMES(N) = NTIMES(N) + 1
      IF(NTIMES(N).GT.NT) THEN
         WRITE(6,105) CID,NT,DHR
         NTIMES(N) = NT
         if(ifirst.eq.0) then
            write(cNT,'(i8)') NT
            call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     $       ' "$jlogfile" "***WARNING: THE NUMBER OF OB TIMES FOR 1'//
     $       ' OR MORE IDs EXCEEDS LIMIT OF '//cNT//', SOME REPORTS '//
     $       'NOT PROCESSED - INCR. SIZE OF NT"')
            ifirst = 1
         endif
         RETURN
      ENDIF
      TIM(NTIMES(N),N) = DHR

cdak  WRITE(6,101) N,CID

      NREP  = NREP  + 1

      RINC      = 0.
      RINC(2)   = DHR
      IDAT      = 0
      IDAT(1:3) = JDATE(1:3)
      IDAT(5)   = JDATE(4)

      CALL W3MOVDAT(RINC,IDAT,JDAT)

C KDATE WILL HOLD REPORT TIME

      KDATE(1:3,NTIMES(N),N) = JDAT(1:3)
      KDATE(4:5,NTIMES(N),N) = JDAT(5:6)

C MLEV WILL HOLD NUMBER OF LEVELS

      MLEV(NTIMES(N),N) = NLV

C  SEPARATE THE REPORT INTO TWO PARTS, THE ORIGINAL REPORTED LEVELS
C  (CAT. 4) AND THE OPTIONAL AUXILIARY LEVELS AT 25 MB INTERVALS
C  (CAT. 7) -- ONLY THE ORIGINAL REPORTED LEVELS WILL BE Q.C.'D
C  ----------------------------------------------------------------

      LP = 0
      DO LZ=1,NLV
         IF(CAT(LZ).EQ.4 .AND. ZOB(LZ).NE.ELV) THEN    ! Reported level
            ZZ(LZ,NTIMES(N),N)   = ZOB(LZ)
            UZ(LZ,NTIMES(N),N)   = UOB(LZ)
            VZ(LZ,NTIMES(N),N)   = VOB(LZ)
            QZ(LZ,NTIMES(N),N)   = WQM(LZ)
            IQ(LZ,NTIMES(N),N)   = NINT(WQM(LZ))
            PZ(LZ,NTIMES(N),N)   = POB(LZ)
            UFZ(LZ,NTIMES(N),N)  = UFC(LZ)
            VFZ(LZ,NTIMES(N),N)  = VFC(LZ)
            SZ(LZ,NTIMES(N),N)   = SOB(LZ)
            DZ(LZ,NTIMES(N),N)   = DOB(LZ)
            LEVZ(LZ,NTIMES(N),N) = LZ
         ELSE IF(CAT(LZ).EQ.7) THEN    ! Auxiliary level
            LP = LP + 1
            ZP(LP,NTIMES(N),N)   = ZOB(LZ)
            UP(LP,NTIMES(N),N)   = UOB(LZ)
            VP(LP,NTIMES(N),N)   = VOB(LZ)
            QP(LP,NTIMES(N),N)   = WQM(LZ)
            PP(LP,NTIMES(N),N)   = POB(LZ)
            UFP(LP,NTIMES(N),N)  = UFC(LZ)
            VFP(LP,NTIMES(N),N)  = VFC(LZ)
            LEVP(LP,NTIMES(N),N) = LZ
         ENDIF
      ENDDO

      RETURN

  100 FORMAT(/'##PUTDATA: ID ',A8,' CANNOT BE Q.C.-d BECAUSE THE ',
     $ 'NUMBER OF UNIQUE STATIONS EXCEEDS THE LIMIT OF',I4/)
  101 FORMAT(' PUTDATA: N,CID: ',I5,2X,A8)
  105 FORMAT(/'##PUTDATA: THE NUMBER OF OB TIMES FOR ID ',A8,
     $ ' EXCEEDS THE LIMIT OF ',I0,'. SKIP REPORT FOR DHR=',F7.3/)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    READPROF
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: READ PROFILER REPORTS FROM THE PREPBUFR FILE AND STORE
C   INTO MEMORY.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Namelist switches added to specify output
C     time window.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C 2020-01-09  J. Dong   Changed the windowing decade from 20 to 40
C     for cases when the year is represented by 2 digits instead of 4.
C
C USAGE:    CALL READPROF
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE READPROF

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      LOGICAL  FIRST
      CHARACTER*8  SUBSET,CID
      CHARACTER*40  HSTR,OSTR
      REAL  RINC(5)
      REAL(8)  SID_8,HDR_8(10),OBS_8(10,255)
      INTEGER  IDAT(8),JDAT(8)

      COMMON/DATEZ /JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/HEADER/SID_8,XOB,YOB,DHR,ELV,XTP,TYP,T29,NLV
      COMMON/TIMEO/TIMWIN_E,TIMWIN_L
      COMMON/PROBS/ZOB(255),UOB(255),VOB(255),WQM(255),POB(255),
     $ UFC(255),VFC(255),CAT(255),SOB(255),DOB(255)

      EQUIVALENCE  (SID_8,CID)

      DATA HSTR /'SID XOB YOB DHR ELV ITP TYP T29        '/
      DATA OSTR /'ZOB UOB VOB WQM POB UFC VFC CAT FFO DDO'/
      DATA FIRST /.TRUE./

      IF(FIRST) THEN    ! Do several things the first time in here
         CALL DATELEN(10)
         WRITE(6,100) NFIN
         CALL OPENBF(NFIN,'IN',NFIN)

   10    CONTINUE

         CALL READMG(NFIN,SUBSET,IDATEP,IRETMG)
         IF(IRETMG.NE.0)   GOTO 999
         IF(SUBSET.NE.'PROFLR  ')  GOTO 10
         WRITE(6,101) IDATEP
         IF(IDATEP.LT.1000000000) THEN

C If 2-digit year returned in IDATEP, must use "windowing" technique
C  to create a 4-digit year

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

            PRINT *,'##THE FOLLOWING SHOULD NEVER HAPPEN!!!!'
            PRINT'("##2-DIGIT YEAR IN IDATEP RETURNED FROM ",
     $       "READMG (IDATEP IS: ",I0,") - USE WINDOWING TECHNIQUE",
     $       " TO OBTAIN 4-DIGIT YEAR")', IDATEP
C IF IDATEP=41~99 THEN IDATEP=1941~1999
C IF IDATEP=00~40 THEN IDATEP=2000~2040
            IF(IDATEP/1000000.GT.40) THEN
               IDATEP = 1900000000 + IDATEP
            ELSE
               IDATEP = 2000000000 + IDATEP
            ENDIF
            PRINT *, '##CORRECTED IDATEP WITH 4-DIGIT YEAR, ',
     $       'IDATEP NOW IS: ',IDATEP
         ENDIF

C JDATE WILL HOLD PREPBUFR CENTER TIME

         JDATE(1) = IDATEP/1000000
         JDATE(2) = MOD((IDATEP/10000),100)
         JDATE(3) = MOD((IDATEP/100),100)
         JDATE(4) = MOD(IDATEP,100)

         RINC      = 0.
         RINC(2)   = TIMWIN_E
         IDAT      = 0
         IDAT(1:3) = JDATE(1:3)
         IDAT(5)   = JDATE(4)

         CALL W3MOVDAT(RINC,IDAT,JDAT)

C MDATE WILL HOLD EARLIEST ALLOWED OUTPUT REPORT TIME

         MDATE(1:3) = JDAT(1:3)
         MDATE(4:5) = JDAT(5:6)

         RINC(2) = TIMWIN_L

         CALL W3MOVDAT(RINC,IDAT,JDAT)

C NDATE WILL HOLD LATEST ALLOWED OUTPUT REPORT TIME

         NDATE(1:3) = JDAT(1:3)
         NDATE(4:5) = JDAT(5:6)

         WRITE(6,102) MDATE,NDATE

         FIRST = .FALSE.
         WRITE(6,103)
         GOTO 20    ! Read in first wind profiler report
      ENDIF

   30 CONTINUE

      CALL READMG(NFIN,SUBSET,IDATEP,IRET)
      IF(IRET.NE.0) THEN    ! All BUFR messages have been read
         CALL CLOSBF(NFIN)
         WRITE(6,104)  NFIN,NSTN1,NSTN,NREP1,NREP
         RETURN
      ENDIF
      IF(SUBSET.NE.'PROFLR  ') GOTO  30

   20 CONTINUE

      CALL READSB(NFIN,IRET)
      IF(IRET.NE.0) GOTO 30

C  READ AND STORE HEADER ELEMENTS
C  ------------------------------

      CALL UFBINT(NFIN,HDR_8,10,  1,IRET,HSTR)
      CALL UFBINT(NFIN,OBS_8,10,255,IRET,OSTR)
      SID_8 = HDR_8(1)
      XOB = HDR_8(2)
      YOB = HDR_8(3)
      DHR = HDR_8(4)
      ELV = HDR_8(5)
      XTP = HDR_8(6)
      TYP = HDR_8(7)
      T29 = HDR_8(8)

C  READ DATA OF PROPER SUBSET
C  --------------------------

      CALL UFBINT(NFIN,OBS_8,10,255,NLV,OSTR)
      ZOB(1:NLV) = OBS_8(1,1:NLV)
      UOB(1:NLV) = OBS_8(2,1:NLV)
      VOB(1:NLV) = OBS_8(3,1:NLV)
      WQM(1:NLV) = OBS_8(4,1:NLV)
      POB(1:NLV) = OBS_8(5,1:NLV)
      UFC(1:NLV) = OBS_8(6,1:NLV)
      VFC(1:NLV) = OBS_8(7,1:NLV)
      CAT(1:NLV) = OBS_8(8,1:NLV)
      SOB(1:NLV) = OBS_8(9,1:NLV)
      DOB(1:NLV) = OBS_8(10,1:NLV)

      WRITE(6,105) CID,YOB,XOB,DHR,ELV,XTP,TYP,T29,NLV,SUBSET

      WRITE(6,106)
      WRITE(6,107) (POB(L),ZOB(L),UOB(L),VOB(L),UFC(L),VFC(L),WQM(L),
     $ CAT(L),SOB(L),DOB(L),L=1,NLV)

C  PUT THE REPORT INTO MEMORY
C  -------------------------

      CALL PUTDATA

      GOTO 20

C-----------------------------------------------------------------------
  999 CONTINUE

C PREPBUFR DATA SET CONTAINS NO "PROFLR" TABLE A MSGS -- STOP 4  !!!
      WRITE(6,108)
      CALL CLOSBF(NFIN)
      CALL W3TAGE('PREPOBS_PROFCQC')
      CALL ERREXIT(4)
C-----------------------------------------------------------------------

  100 FORMAT(/'READING REPORTS FROM INPUT PREPBUFR FILE IN UNIT ',I3)
  101 FORMAT(/'First PROFLR message found ... '/'PREPBUFR File Sec. 1 ',
     $ 'message date = ',I10)
  102 FORMAT(/'Time window for outputting wind profiler reports is:',1X,
     $ I4,4I2.2,' to ',I4,4I2.2/)
  103 FORMAT(/'==> Begin listing of input wind profiler reports'/)
  104 FORMAT(/5X,'===> PREPBUFR DATA SET IN UNIT ',I3,' SUCCESSFULLY',
     $ ' CLOSED FROM INITIAL READ OF WIND PROFILER OBS.'/10X,'THERE ',
     $ 'ARE A TOTAL OF',I4,' UNIQUE WIND PROFILER STATIONS OVER ALL ',
     $ 'TIME PERIODS'/10X,'A TOTAL OF',I4,' UNIQUE STATIONS WERE ',
     $ 'Q.C.-d'/10X,'THE TOTAL NUMBER OF REPORTS UNPACKED WAS',I4/10X,
     $ 'THE TOTAL NUMPER OF REPORTS Q.C.-d WAS',I4/)
  105 FORMAT(/' ID=',A8,' LAT=',F10.2,' LON=',F10.2,' DHR=',F8.2,
     $ ' ELV=',F8.2,' ITYP=',F6.0,' RTYP=',F6.0,' T29=',F6.0,' LVLS=',
     $ I6,' SUBSET=',A8)
  106 FORMAT('       POB       ZOB       UOB       VOB       UFC',
     $       '       VFC       WQM       CAT       SOB       DOB')
  107 FORMAT(F10.1,F10.0,4F10.1,2F10.0,F10.1,F10.0)
  108 FORMAT(/' PREPBUFR DATA SET CONTAINS NO "PROFLR" TABLE A ',
     $ 'MESSAGES - STOP 4'/)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    RESIDUAL
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: CALCULATE ALL RESIDUALS FOR A SINGLE UNIQUE STATION.
C
C PROGRAM HISTORY LOG:
C 1996-11-20  W. Collins -- Original author.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL RESIDUAL(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE RESIDUAL(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT

C  PERFORM INCREMENTAL, VERTICAL AND TEMPORAL CHECKS
C  -------------------------------------------------

      CALL CHECKS(IS)

C  PERFORM PLANAR-LINEAR INTERPOLATION, GET RESIDUAL
C  -------------------------------------------------

      CALL TWODIM(IS)

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    RESTRUCT
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: VERTICALLY AND TEMPORALLY RESTRUCTURE THE DATA.
C
C PROGRAM HISTORY LOG:
C 2000-12-01  W. Collins -- Original author (vertical restructuring
C     only).
C 2004-09-09  D. Keyser  -- Lvl index in all arrays now site specific
C     to allow proper temporal checking at each individual site (each
C     site examined over all rpt times to generate hgt profile
C     containing all possible lvls, times w/ new lvls inserted get
C     missing wind).
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL RESTRUCT
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE RESTRUCT

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8     STN
      REAL(8)  BMISS

      REAL  ZZLEV(NL,NS),UZZ(NL,NT,NS),VZZ(NL,NT,NS),QZZ(NL,NT,NS),
     $ PZZ(NL,NT,NS),UFZZ(NL,NT,NS),VFZZ(NL,NT,NS),SZZ(NL,NT,NS),
     $ DZZ(NL,NT,NS),IQZZ(NL,NT,NS),LEVZZ(NL,NT,NS),WKSP(NL,NT,NS),
     $ ZLEV(NL,NT,NS)
      INTEGER  IKSP(NL,NT,NS),JKSP(5,NT,NS),NZ(NT,NS),IV(NL)

      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/PROFP/ZP(NL,NT,NS),UP(NL,NT,NS),VP(NL,NT,NS),QP(NL,NT,NS),
     $ PP(NL,NT,NS),UFP(NL,NT,NS),VFP(NL,NT,NS),LEVP(NL,NT,NS)
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/DATEZ/JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON /BUFRLIB_MISSING/BMISS

      WRITE(6,100)

C  MAKE LIST OF HEIGHTS OF OBSERVATIONS FOR EACH STATION
C  -----------------------------------------------------

      ZLEV = BMISS
      NZ = 0
      LOOP1: DO IS=1,NSTN
         LOOP1n1: DO IT=1,NTIMES(IS)
            LOOP1n2: DO IL=1,MLEV(IT,IS)
               LOOP1n3: DO I=1,MLEV(IT,IS)
                  IF(ZZ(IL,IT,IS).EQ.ZLEV(I,IT,IS)) CYCLE LOOP1n1
               ENDDO  LOOP1n3
               NZ(IT,IS) = NZ(IT,IS) + 1
               ZLEV(NZ(IT,IS),IT,IS) = ZZ(IL,IT,IS)
            ENDDO  LOOP1n2
         ENDDO  LOOP1n1
      ENDDO  LOOP1

      ZZLEV = BMISS
      NZZ = 0
      LOOP1x: DO IS=1,NSTN
         LOOP1n1x: DO IT=1,NTIMES(IS)
            LOOP1n2x: DO IL=1,MLEV(IT,IS)
               LOOP1n3x: DO I=1,NZZ(IS)
                  IF(ZZ(IL,IT,IS).EQ.ZZLEV(I,IS)) CYCLE LOOP1n2x
               ENDDO  LOOP1n3x
               NZZ(IS) = NZZ(IS) + 1
               ZZLEV(NZZ(IS),IS) = ZZ(IL,IT,IS)
            ENDDO  LOOP1n2x
         ENDDO  LOOP1n1x
      ENDDO  LOOP1x

C  SORT LIST OF HEIGHTS FOR EACH STATION
C  -------------------------------------

      IREV  = 0
      UZZ   = BMISS
      VZZ   = BMISS
      QZZ   = BMISS
      PZZ   = BMISS
      UFZZ  = BMISS
      VFZZ  = BMISS
      SZZ   = BMISS
      DZZ   = BMISS
      IQZZ  = 99999
      LEVZZ = 0

      DO IS=1,NS
         CALL SHELL(ZZLEV(1,IS),IV,NZZ(IS),IREV)
         DO IT=1,NTIMES(IS)
            DO IL=1,MLEV(IT,IS)
               DO ILL=1,NZZ(IS)
                  IF(NINT(ZZ(IL,IT,IS)).EQ.NINT(ZZLEV(ILL,IS))) THEN
                     UZZ(ILL,IT,IS)   = UZ(IL,IT,IS)
                     VZZ(ILL,IT,IS)   = VZ(IL,IT,IS)
                     QZZ(ILL,IT,IS)   = QZ(IL,IT,IS)
                     PZZ(ILL,IT,IS)   = PZ(IL,IT,IS)
                     UFZZ(ILL,IT,IS)  = UFZ(IL,IT,IS)
                     VFZZ(ILL,IT,IS)  = VFZ(IL,IT,IS)
                     SZZ(ILL,IT,IS)   = SZ(IL,IT,IS)
                     DZZ(ILL,IT,IS)   = DZ(IL,IT,IS)
                     IQZZ(ILL,IT,IS)  = IQ(IL,IT,IS)
                     LEVZZ(ILL,IT,IS) = LEVZ(IL,IT,IS)
                  ENDIF
               ENDDO
            ENDDO
            ZZ(:,IT,IS) = ZZLEV(:,IS)
         ENDDO
      ENDDO
      UZ   = UZZ
      VZ   = VZZ
      QZ   = QZZ
      PZ   = PZZ
      UFZ  = UFZZ
      VFZ  = VFZZ
      SZ   = SZZ
      DZ   = DZZ
      IQ   = IQZZ
      LEVZ = LEVZZ

C  SORT STATIONS BY D-TIME
C  -----------------------

      IREV = 0
      DO I=1,NS
         CALL SHELL(TIM(1,I),IV,NTIMES(I),IREV)
         WKSP = ZZ
         ZZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = UZ
         UZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = VZ
         VZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = QZ
         QZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = PZ
         PZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = UFZ
         UFZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = VFZ
         VFZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = SZ
         SZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         WKSP = DZ
         DZ(:,1:NTIMES(I),I) = WKSP(:,IV(1:NTIMES(I)),I)
         IKSP = LEVZ
         LEVZ(:,1:NTIMES(I),I) = IKSP(:,IV(1:NTIMES(I)),I)
         IKSP = IQ
         IQ(:,1:NTIMES(I),I) = IKSP(:,IV(1:NTIMES(I)),I)
         JKSP = KDATE
         KDATE(:,1:NTIMES(I),I) = JKSP(:,IV(1:NTIMES(I)),I)
      ENDDO

      RETURN

  100 FORMAT(//'RESTRUCTURING (SORTING) VERTICAL LEVELS AND TIME ',
     $ 'PERIODS'//)

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    SHELL
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1991-12-24
C
C ABSTRACT: SHELL SORT, BASED UPON THE VALUES OF V.  IV IS THE
C   ORIGINAL INDEX OF EACH ELEMENT OF V.
C
C PROGRAM HISTORY LOG:
C 1991-12-24  W. COLLINS -- Original author.
C
C USAGE:    CALL SHELL(V,IV,MAX,IREV)
C   INPUT ARGUMENT LIST:
C     V        - VARIABLE
C     MAX      - DIMENSION OF V
C     IREV     = 0 FOR ASCENDING ORDER
C              > or < 0 FOR DESCENDING ORDER
C
C   OUTPUT ARGUMENT LIST:
C     IV       - ORIGINAL INDEX OF VARIABLE
C     V        - VARIABLE, SORTED
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SHELL(V,IV,MAX,IREV)

      REAL V(*)
      INTEGER IV(*)

      DO I=1,MAX
        IV(I) = I
      ENDDO

      IOFSET = MAX/2

   20 CONTINUE

      LIM = MAX - IOFSET

   30 CONTINUE

      ISW = 0
      DO I=1,LIM
        IF(V(I).GT.V(I+IOFSET)) THEN
          VT = V(I)
          V(I) = V(I+IOFSET)
          V(I+IOFSET) = VT
          IVT = IV(I)
          IV(I) = IV(I+IOFSET)
          IV(I+IOFSET) = IVT
          ISW = I
        ENDIF
      ENDDO
      LIM = ISW - IOFSET
      IF(ISW.NE.0) GOTO 30
      IOFSET = IOFSET/2
      IF(IOFSET.GT.0) GOTO 20

      IF(IREV.NE.0) THEN
C        REVERSE SORT ORDER...
         NH = MAX/2
         DO I=1,NH
            ITEMP = IV(I)
            IV(I) = IV(MAX+1-I)
            IV(MAX+1-I) = ITEMP
            TEMP = V(I)
            V(I) = V(MAX+1-I)
            V(MAX+1-I) = TEMP
         ENDDO
      ENDIF

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    SORT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1994-03-17
C
C ABSTRACT: SORT RA ACCORDING TO THE ORDER SPECIFIED BY THE INDICES
C   IN INDX.
C
C PROGRAM HISTORY LOG:
C 1994-03-17  W. Collins -- Original author.
C
C USAGE:    CALL SORT(RA,INDX,N)
C   INPUT ARGUMENT LIST:
C     RA       - VARIABLE
C     INDX     - ORDER FOR REARRANGEMENT OF RA
C     N        - DIMENSION OF RA
C
C   OUTPUT ARGUMENT LIST:
C     RA       - VARIABLE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SORT(RA,INDX,N)

C     SORT RA ACCORDING TO THE ORDER SPECIFIED BY THE INDICES IN INDX.

      INTEGER  INDX(*)
      DIMENSION  RA(*),WKSP(899)

      WKSP(1:N) = RA(1:N)

      RA(1:N) = WKSP(INDX(1:N))

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    TWODIM
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: COMPUTE MEDIAN RESIDUALS FOR A SINGLE UNIQUE
C   STATION.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Lvl index in all arrays now site specific
C     to allow proper temporal checking at each individual site times
C     w/ new lvls inserted get missing wind). No. of time periods input
C     now site specific (was hardwired to be same for all rpts).
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL TWODIM(IS)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C
C REMARKS:
C   VARIABLE NAMES:
C     U        - U-COMPONENT
C     V        - V-COMPONENT
C     ICQC     - DMA INDEX FOR WIND QUALITY CONTROL
C     UM       - MEDIAN RESIDUAL FOR U-COMPONENT
C     VM       - MEDIAN RESIDUAL FOR V-COMPONENT
C     VVM      - VECTOR MEDIAN RESIDUAL
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE TWODIM(IS)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      CHARACTER*8  STN
      REAL  U(NL,NT),V(NL,NT),TIN(3,3),TUT(NL,NT)
      REAL(8)  BMISS

      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PROFZ/ZZ(NL,NT,NS),UZ(NL,NT,NS),VZ(NL,NT,NS),QZ(NL,NT,NS),
     $ PZ(NL,NT,NS),UFZ(NL,NT,NS),VFZ(NL,NT,NS),SZ(NL,NT,NS),
     $ DZ(NL,NT,NS),LEVZ(NL,NT,NS)
      COMMON/RESIDS/UI(NL,NT,NS),VI(NL,NT,NS),UT(NL,NT),VT(NL,NT),
     $ UV(NL,NT),VV(NL,NT),VVI(NL,NT),VVT(NL,NT),VVV(NL,NT),UM(NL,NT),
     $ VM(NL,NT),VVM(NL,NT),NI(NL,NT),NTMP(NL,NT),NV(NL,NT),NM(NL,NT),
     $ ZI(NL,NT),ZT(NL,NT),ZV(NL,NT),ZM(NL,NT),DIT(NL,NT),DIV(NL,NT),
     $ DTV(NL,NT),DIM(NL,NT),DVM(NL,NT),DTM(NL,NT)
      COMMON/QUAL/QM(NL,NT,NS),IQ(NL,NT,NS),ICQC(NL,NT,NS),
     $ IQCC(NL,NT,NS),MLEV(NT,NS),DT(NL,NT,NS),NZZ(NS),IBAD_FLAG(NT,NS),
     $ JBAD_FLAG(NS),IRC(NL,NT,NS)
      COMMON/PARAMS/NCH,NLEV,NSCAN,NSTN,NSTN1,NREP,NREP1,NREP_OUT,
     $ NFIN,NFOUT
      COMMON /BUFRLIB_MISSING/BMISS

      UM  = BMISS
      VM  = BMISS
      VVM = BMISS

      U(1:NL,1:NTIMES(IS)) = UZ(1:NL,1:NTIMES(IS),IS)
      V(1:NL,1:NTIMES(IS)) = VZ(1:NL,1:NTIMES(IS),IS)

C     INPUT FIELD, TIN, WILL CONTAIN MISSING FOR EITHER MISSING OR
C     'BAD' VALUES.

C     U FIRST.

      DO L=1,NTIMES(IS)
        JSTART = 1
        JEND   = 3
        IF(L.EQ.1)          JSTART=2
        IF(L.EQ.NTIMES(IS)) JEND  =2
        DO K=2,NZZ(IS)-1
          TIN = BMISS
          DO J=JSTART,JEND
            DO I=1,3
              IF(U(K+I-2,L+J-2).LT.BMISS .AND.
     $           ICQC(K+I-2,L+J-2,IS).EQ.0) THEN
                TIN(I,J) = U(K+I-2,L+J-2)
              ENDIF
            ENDDO
          ENDDO

C         DO INTERPOLATION.  TUT IS ARRAY OF INTERPOLATED VALUES.

          CALL PLINT(TIN,TUT(K,L),BMISS)

C         CALCULATE 2 D RESIDUAL, UM.

          IF(MAX(U(K,L),TUT(K,L)).LT.BMISS) THEN
            UM(K,L) = U(K,L) - TUT(K,L)
          ELSE
            UM(K,L) = BMISS
          ENDIF

C     AND NOW V.

          TIN = BMISS
          DO J=JSTART,JEND
            DO I=1,3
              IF(V(K+I-2,L+J-2).LT.BMISS .AND.
     &           ICQC(K+I-2,L+J-2,IS).EQ.0) THEN
                TIN(I,J) = V(K+I-2,L+J-2)
              ENDIF
            ENDDO
          ENDDO

C         DO INTERPOLATION.  TUT IS FIELD OF INTERPOLATED VALUES.

          CALL PLINT(TIN,TUT(K,L),BMISS)

C         COMPUTE 2 D RESIDUAL, VM.

          IF(MAX(V(K,L),TUT(K,L)).LT.BMISS) THEN
            VM(K,L) = V(K,L) - TUT(K,L)
          ELSE
            VM(K,L) = BMISS
          ENDIF

C           AND COMPUTE VECTOR RESIDUAL.
          IF(MAX(UM(K,L),VM(K,L)).LT.BMISS) THEN
            VVM(K,L) = SQRT(UM(K,L)**2 + VM(K,L)**2)
          ELSE
            VVM(K,L) = BMISS
          ENDIF
        ENDDO
      ENDDO

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    PSTAT
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: DRIVER SUBROUTINE TO COMPUTE AND PRINT MOMENT
C   STATISTICS. CALLS SUBROUTINE MSTATS TO ACTUALLY DO THE WORK
C   FOR A PARTICULAR FIELD AND REPORT TYPE.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Stats generated separately for NPN, CAP &
C     JMA rpts.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL PSTAT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE PSTAT

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      LOGICAL  STATS,MEAN,STDDEV,SKEW,KURT
      CHARACTER*8  STN

      COMMON/STATZ/UZS(120,0:24,9,3:8),VZS(120,0:24,9,3:8),
     $ UIS(120,0:24,9,3:8),VIS(120,0:24,9,3:8),UTS(120,0:24,9,3:8),
     $ VTS(120,0:24,9,3:8),UVS(120,0:24,9,3:8),VVS(120,0:24,9,3:8),
     $ VVIS(120,0:24,9,3:8),VVTS(120,0:24,9,3:8),VVVS(120,0:24,9,3:8),
     $ VVMS(120,0:24,9,3:8),UMS(120,0:24,9,3:8),VMS(120,0:24,9,3:8)
      COMMON/STNLST/STN(NS),X(NS),Y(NS),Z0(NS),NTIMES(NS),TIM(NT,NS),
     $ IRTP(NS)
      COMMON/PST/IOFFSET(3:8),LVLINCR(3:8),ILEVELS(3:8),STATS,MEAN,
     $ STDDEV,SKEW,KURT

C  CALL MSTATS TO PROCESS AND PRINT DESIRED STATISTICS
C  --------------------------------------------------

      CALL MSTATS(UZS,3,'U-COMPONENT WIND',1)
      CALL MSTATS(UZS,7,'U-COMPONENT WIND',1)
      CALL MSTATS(UZS,8,'U-COMPONENT WIND',1)

      CALL MSTATS(VZS,3,'V-COMPONENT WIND',2)
      CALL MSTATS(VZS,7,'V-COMPONENT WIND',2)
      CALL MSTATS(VZS,8,'V-COMPONENT WIND',2)

      CALL MSTATS(UIS,3,'U-INCREMENT',3)
      CALL MSTATS(UIS,7,'U-INCREMENT',3)
      CALL MSTATS(UIS,8,'U-INCREMENT',3)

      CALL MSTATS(VIS,3,'V-INCREMENT',4)
      CALL MSTATS(VIS,7,'V-INCREMENT',4)
      CALL MSTATS(VIS,8,'V-INCREMENT',4)

      CALL MSTATS(UTS,3,'U-TEMPORAL RESIDUAL',5)
      CALL MSTATS(UTS,7,'U-TEMPORAL RESIDUAL',5)
      CALL MSTATS(UTS,8,'U-TEMPORAL RESIDUAL',5)

      CALL MSTATS(VTS,3,'V-TEMPORAL RESIDUAL',6)
      CALL MSTATS(VTS,7,'V-TEMPORAL RESIDUAL',6)
      CALL MSTATS(VTS,8,'V-TEMPORAL RESIDUAL',6)

      CALL MSTATS(UVS,3,'U-VERTICAL RESIDUAL',7)
      CALL MSTATS(UVS,7,'U-VERTICAL RESIDUAL',7)
      CALL MSTATS(UVS,8,'U-VERTICAL RESIDUAL',7)

      CALL MSTATS(VVS,3,'V-VERTICAL RESIDUAL',8)
      CALL MSTATS(VVS,7,'V-VERTICAL RESIDUAL',8)
      CALL MSTATS(VVS,8,'V-VERTICAL RESIDUAL',8)

      CALL MSTATS(UMS,3,'U-2-DIM MEDIAN RESIDUAL',9)
      CALL MSTATS(UMS,7,'U-2-DIM MEDIAN RESIDUAL',9)
      CALL MSTATS(UMS,8,'U-2-DIM MEDIAN RESIDUAL',9)

      CALL MSTATS(VMS,3,'V-2-DIM MEDIAN RESIDUAL',10)
      CALL MSTATS(VMS,7,'V-2-DIM MEDIAN RESIDUAL',10)
      CALL MSTATS(VMS,8,'V-2-DIM MEDIAN RESIDUAL',10)

      CALL MSTATS(VVIS,3,'VECTOR INCREMENT',11)
      CALL MSTATS(VVIS,7,'VECTOR INCREMENT',11)
      CALL MSTATS(VVIS,8,'VECTOR INCREMENT',11)

      CALL MSTATS(VVTS,3,'VECTOR TEMPORAL RESIDUAL',12)
      CALL MSTATS(VVTS,7,'VECTOR TEMPORAL RESIDUAL',12)
      CALL MSTATS(VVTS,8,'VECTOR TEMPORAL RESIDUAL',12)

      CALL MSTATS(VVVS,3,'VECTOR VERTICAL RESIDUAL',13)
      CALL MSTATS(VVVS,7,'VECTOR VERTICAL RESIDUAL',13)
      CALL MSTATS(VVVS,8,'VECTOR VERTICAL RESIDUAL',13)

      CALL MSTATS(VVMS,3,'VECTOR 2-DIM MEDIAN RESIDUAL',14)
      CALL MSTATS(VVMS,7,'VECTOR 2-DIM MEDIAN RESIDUAL',14)
      CALL MSTATS(VVMS,8,'VECTOR 2-DIM MEDIAN RESIDUAL',14)

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    MSTATS
C   PRGMMR: D. KEYSER        ORG: NP22       DATE: 2016-12-20
C
C ABSTRACT: COMPUTES THE VARIOUS MOMENT STATISTICS AND PRINTS
C   TO FILES.
C
C PROGRAM HISTORY LOG:
C 1995-04-05  W. Collins -- Original author.
C 2004-09-09  D. Keyser  -- Kurtotis stat. now computed correctly.
C     Stat. output clarified & written to 2 text files separate from
C     stdout.  Computation & printout of stats, as well as combination
C     of stat types printed out controlled via new namelist switches.
C     Stats generated separately for NPN, CAP & JMA rpts and stratified
C     according to hgt above ground.
C 2016-12-20  D. Stokes   Increase the max allowable number of times 
C     per station.
C
C USAGE:    CALL MSTATS(FIELD,ITYPE,TITLE,NUM)
C   INPUT ARGUMENT LIST:
C     FIELD    - INPUT FIELD
C     ITYPE    - PROFILER REPORT TYPE (=3-NPN, =7-CAP, =8=JMA)
C     TITLE    - CHARACTER TITLE FOR FIELD
C     IFLD     - INDICATOR FOR TYPE OF FIELD (=1-U-COMP WIND,
C                =2-V-COMP WIND, =3-U-INCR, =4-V-INCR, =5-U-TEMPORAL
C                RESID, =6-V-TEMPORAL RESID, =7-U-VERTICAL RESID,
C                =8-V-VERTICAL RESID, =9-U-MEDIAN RESID, =10-V-MEDIAN
C                RESID, =11-VECTOR INCR, =12-VECTOR TEMPORAL RESID,
C                =13-VECTOR VERTICAL RESID, =14-VECTOR MEDIAN RESID)
C
C   OUTPUT FILES:
C     UNIT 61  - PRINTOUT OF SELECTED STATISTICS OF RESULTS ON EACH 
C                LEVEL (BY REPORT TYPE, REPORT TIME AND FIELD)
C     UNIT 62  - STATISTICS FILE CONTAINING ALL STATISTICS ON EACH
C                LEVEL (BY REPORT TYPE (BY REPORT TYPE AND FIELD, BUT
C                OVER ALL TIMES COMBINED)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE MSTATS(FIELD,ITYPE,TITLE,IFLD)

      PARAMETER  (NL=300,NT=100,NS=120)    ! (levels,times,stations)

      LOGICAL  STATS,LPRNT
      CHARACTER*8   STATISTIC(4)
      CHARACTER*(*) TITLE
      CHARACTER*36  TEXT(3:8)
      REAL  FIELD(120,0:24,9,3:8)
      INTEGER  NTIM(26),IZ(120)

      COMMON/DATEZ/JDATE(4),KDATE(5,NT,NS),MDATE(5),NDATE(5)
      COMMON/PST/IOFFSET(3:8),LVLINCR(3:8),ILEVELS(3:8),STATS,LPRNT(4)

      DATA  STATISTIC/'  MEAN  ','STD DEV.','SKEWNESS','KURTOSIS'/
      DATA  TEXT/'NOAA Profiler Network (NPN) Reports:',
     $           'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',
     $           'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',
     $           'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',
     $           'Cooperative Agency Profiler Reports:',
     $           'Jap. Met. Agency Profiler Reports:  '/

      IF(ITYPE.NE.3.AND.ITYPE.NE.7.AND.ITYPE.NE.8)  THEN
        write(61,*)
        write(61,'("#### Mean and higher order statistics for field ",
     $   A," cannot be computed or printed because wind profiler ",
     $   "report type (=",I0,") is not valid")') TITLE,ITYPE
        write(61,*)
        RETURN
      ENDIF
       
      ITEST = 0
      INDX  = 0
      IADD = 0
      IF(MDATE(5).NE.0)  THEN
         IADD = 1
         IF(MDATE(4).EQ.23)  IADD = -23
      ENDIF
      NDATE4 = NDATE(4)
      IF(NDATE(4).LT.MDATE(4)+IADD)  NDATE4 = NDATE(4) + 24
      DO NN=MDATE(4)+IADD,NDATE4+1
        IF(NN.LT.NDATE4+1) THEN
           INDX = INDX + 1
           N = NN
           IF(N.GT.23)  N = N - 24
           NTIM(INDX) = N
        ELSE
           N = 24
        ENDIF
        DO L=1,ILEVELS(ITYPE)
          IF(NINT(FIELD(L,N,1,ITYPE)).LT.1) CYCLE
          ITEST = 1
          IZ(L) = (L * LVLINCR(ITYPE)) + IOFFSET(ITYPE)
          SUM1 = FIELD(L,N,2,ITYPE)/FIELD(L,N,1,ITYPE)
          SUM2 = FIELD(L,N,3,ITYPE)/FIELD(L,N,1,ITYPE)
          SUM3 = FIELD(L,N,4,ITYPE)/FIELD(L,N,1,ITYPE)
          SUM4 = FIELD(L,N,5,ITYPE)/FIELD(L,N,1,ITYPE)

C  MEAN (m/s)
C  ----------
          FIELD(L,N,6,ITYPE) = SUM1

C  STANDARD DEVIATION (m/s)
C  ------------------------

          ARG = SUM2 - SUM1**2
          IF(ARG.GT.0.) FIELD(L,N,7,ITYPE) = SQRT(ARG)

C  SKEWNESS (m/s)
C  --------------

          S1 = SUM3 - 3.*SUM2*SUM1 + 2.*SUM1**3
          IF(SUM2.GT.0.) FIELD(L,N,8,ITYPE) = S1/(SUM2)**1.5

C  KURTOSIS (m/s)
C  --------------

          S1 = SUM4 - 4.*SUM3*SUM1 + 6.*SUM2*(SUM1**2) - 3.*SUM1**4
          IF(FIELD(L,N,7,ITYPE).GT.0.001) FIELD(L,N,9,ITYPE) =
     $     (S1/FIELD(L,N,7,ITYPE)**4) - 3.0

C  PRINT STATISTICS TO FILE (ONLY OVER ALL TIME PERIODS)
C  -----------------------------------------------------

          IF(N.EQ.24) WRITE(62,100) ITYPE,IFLD,IZ(L),
     $     (FIELD(L,24,J,ITYPE),J=1,9)

        ENDDO
      ENDDO

C  PRINT SELECTED STATISTICS (OVER SEPARATE HOURS) (USER-FRIENDLY FORM)
C  -------------------------------------------------------------------

      IF(INDX.GT.0.AND.INDX.LT.24)  THEN
        WRITE(61,101) TEXT(ITYPE),TITLE
        IF(ITEST.EQ.0)  THEN
          WRITE(61,102)
          RETURN
        ENDIF
        DO ISTAT=1,4
          IF(.NOT.LPRNT(ISTAT)) CYCLE
          JSTAT = ISTAT + 5
          WRITE(61,103) STATISTIC(ISTAT)
          WRITE(61,104) (NTIM(I),I=1,INDX)
          DO L=1,ILEVELS(ITYPE)
            IF(NINT(FIELD(L,24,1,ITYPE)).LE.1) CYCLE
            WRITE(61,105) IZ(L),(FIELD(L,NTIM(N),JSTAT,ITYPE),
     $       NINT(FIELD(L,NTIM(N),1,ITYPE)),N=1,INDX),
     $       FIELD(L,24,JSTAT,ITYPE),NINT(FIELD(L,24,1,ITYPE))
          ENDDO
          WRITE(61,106)
        ENDDO
      ENDIF

      RETURN

  100 FORMAT(1X,I3,1X,I3,',',I6,',',F8.0,',',8(F12.2,','))
  101 FORMAT(/128('*')/'==> Statistics for ',A36//'Field: ',A/)
  102 FORMAT(/'  ~~~~~> No reports of this type present'/)
  103 FORMAT(35X,A8,'/COUNT'//'~LEVEL(m)    Hour (UTC) ==============>')
  104 FORMAT('above ground',<INDX>(14X,I2.2),14X,'ALL'/'------------',
     $ <INDX>(14X,'--'),14X,'---')
  105 FORMAT(I9,6X,<INDX+1>(F12.2,'/',I3))
  106 FORMAT(//)

      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: BUFR_DATACOUNT
C   PRGMMR: KEYSER           ORG: NP22        DATE: 2017-01-10
C
C ABSTRACT: PREPARES THE NUMBER OF OBSERVATIONS DUMPED FROM THE BUFR
C   DATABASE FOR PRINTING.  THIS PRINTOUT IS USED BY THE SDM TO TRACK
C   THE RECEIPT OF DATA.  A CURRENT RECEIPT AVERAGE (NORMALLY OVER 
C   30-DAYS) FOR EACH BUFR TYPE AND SUBTYPE IS RETRIEVED AND COMPARED
C   TO THE CURRENT COUNT.  IF THE CURRENT COUNT IS LOW, A MESSAGE
C   IS WRITTEN TO UNIT 52.  THE SCRIPT CAN THEN POST THIS TO EITHER
C   THE ALERTLOG OR JOBLOG FILE (OR BOTH) IN ORDER TO NOTIFY THE SDM.
C   IN ADDITION, THIS PROGRAM WILL COMPLETE WITH RETURN CODE 4, 5 OR 6
C   DEPENDING ON THE SERIOUSNESS OF THE DEFICIENCY.  ALTERNATIVELY,
C   IF THE CURRENT COUNT IS HIGH, A MESSAGE IS WRITTEN TO UNIT 53.
C   THE SCRIPT CAN THEN POST THIS TO EITHER THE JOBLOG OR ALERTLOG
C   FILE (OR BOTH).  THIS ABUNDANCE IN A DATA TYPE WILL NOT CAUSE
C   THE PROGRAM TO COMPLETE WITH RETURN CODE 4, 5 OR 6 (THIS IS
C   RESERVED ONLY FOR LOW DATA COUNTS).  AN "UPDATED" STATUS TABLE IS
C   GENERATED CONTAINING BOTH THE COUNTS FOR EACH TYPE AND SUBTYPE
C   DUMPED AND THE CURRENT 30-DAY AVERAGE.  THOSE TYPE/SUBTYPES WHICH
C   ARE DEEMED TO BE EITHER DEFICIENT OR EXCESSIVE ARE NOTED IN THE
C   UPDATED STATUS FILE.  THE UPDATED STATUS FILE INCLUDES ONLY THOSE
C   BUFR TYPES/SUBTYPES WHICH WERE ACTUALLY DUMPED.
C           SECONDLY, THIS PROGRAM COMPARES THE CURRENT 30-DAY
C   RECEIPT AVERAGE FOR EACH BUFR TYPE/SUBTYPE DUMPED TO THE 30-DAY
C   AVERAGE FROM 3-, 6-, 9-, AND 12-MONTHS AGO.  IF THE CURRENT 30-
C   DAY AVERAGE IS ABOVE OR BELOW THE PAST 30-DAY AVERAGE BY A USER-
C   SPECIFED PERCENTAGE (DEFAULT IS 20%) FROM 3-, 6-, 9-, OR 12-MONTHS
C   AGO, A MESSAGE IS WRITTEN TO UNIT 54, 55, 56, OR 57, RESPECTIVELY.
C   THE SCRIPT CAN THEN POST THIS TO EITHER THE JOBLOG OR ALERTLOG
C   FILE (OR BOTH).  THIS SHOULD IDENTIFY LONGER-TERM TRENDS IN THE
C   DUMPS COUNTS (I.E, IF THE NUMBER OF RECEIPTS FOR A PARTICULAR
C   TYPE/SUBTYPE IS GRADUALLY DECREASING OVER TIME, THIS WILL BE
C   DETECTED IN THE 30-DAY AVERAGE RECEIPT COMPARISON; IT MAY NOT BE
C   DETECTED IN THE COMPARISON OF THE INDIVIDUAL DAY'S RECEIPT COUNT
C   TO THE CURRENT 30-DAY AVERAGE). IT SHOULD BE NOTED THAT EITHER A
C   HIGH OR LOW CURRENT AVERAGE IN A DATA TYPE WILL NOT CAUSE THE
C   PROGRAM TO COMPLETE WITH RETURN CODE 4, 5 OR 6 (THIS IS RESERVED
C   ONLY FOR LOW DATA COUNTS IN THE CURRENT RUN VS. THE CURRENT 30-DAY
C   AVERAGE).
C
C PROGRAM HISTORY LOG:
C 
C 1999-06-24  L, SAGER    ORIGINAL VERSION FOR IMPLEMENTATION
C 1999-07-24  L. SAGER    30-DAY AVERAGE FILE ADDED
C 1999-11-20  L. SAGER    CONVERT TO IBM AND ADD SATELLITES
C 2000-03-05  L. SAGER    OVERHAUL OF OUTPUT FORMAT
C 2000-07-01  L. SAGER    OVERHAUL FOR STATUS FILE CHANGES
C 2000-07-26  D. KEYSER   FIXED BUG WHICH PREVENTED W3TAGE FROM
C      BEING CALLED AT END OF PROGRAM; NOW READS DUMPJB DUMPLIST FILE
C      IN UNIT 10; 1B (SAT. RADIANCE TYPES) NOW CONTAIN 30-DAY AVERAGE
C      IN UPDATED STATUS FILE, WITH ALERTS IN PLACE AS FOR OTHER DATA
C      TYPES
C 2000-09-21  D. KEYSER   COMPLETE REDESIGN OF THIS PROGRAM (E.G.,
C      MORE ROBUST; DOES COMPARISON OF CURRENT 30-DAY AVERAGE FILE
C      AGAINST 30-DAY AVERAGE FILES FROM 3-, 6-, 9-, AND 12-MONTHS AGO;
C      MORE FLEXIBILITY IN PROGRAM, NOTES DATA TYPES WITH HIGH COUNTS
C      VS. 3-DAY AVERAGE, ETC.)
C 2000-12-05  D. KEYSER   NOW WRITES OUTPUT FROM COMPARISON TO 3-, 6-,
C      9-, AND 12-MONTHS AGO TO SEPARATE OUTPUT FILES (UNITS 54-57)
C      RATHER THAN ALL TO ONE FILE (UNIT 54); THE LIMIT FOR GENERATING
C      A MESSAGE OF HIGH OR LOW COUNTS IN THE COMPARISON BETWEEN THE
C      CURRENT 30-DAY AVERAGE AND THE PREVIOUS 30-DAY AVERAGES IS NOW
C      READ IN AS A NAMELIST SWITCH RATHER THAN BEING HARDWIRED TO 20%
C      (THE DEFAULT IS 20%)
C 2001-04-02  D. KEYSER   ADDED LOGICAL ARRAY VARIABLE "WEEK_END" TO
C      INPUT NAMELIST SWITCHES, WHEN WEEK_END IS TRUE FOR A TYPE/
C      SUBTYPE THEN THE THRESHOLD FOR GENERATING A CURRENT COUNT DUMP
C      ALERT IS REDUCED BY 10% FROM THAT READ IN FROM DUMPLIST IF
C      TODAY IS CONSIDERED TO BE A WEEKEND AND/OR REDUCED BY 15% IF
C      TODAY IS IN THE LAST WEEK OF THE YEAR (HOLIDAY SEASON) OR TODAY
C      IS THANKSGIVING (THE REASONING: CERTAIN DATA TYPES, E.G.
C      AIRCRAFT, MAY EXHIBIT LOWER COUNTS ON WEEKENDS AND/OR OVER
C      HOLIDAYS); ADDED OPTION TO RETURN WITH NEW CODE 4 WHICH
C      INDICATES A DEFICIENCY IN A "NON-CRITICAL" DATA TYPE (E.G.,
C      A TYPE THAT IS DUMPED BUT NOT ASSIMILATED BY THE ANALYSIS)
C 2002-03-19  D. KEYSER   INCREASED PARAMETER IMAX_BTYPE FROM 101
C      TO 255 TO ACCOUNT FOR NEW MESONET DATA IN BUFR TYPE 255
C 2003-03-03  D. KEYSER   CORRECTED DAY OF MONTH RANGE FOR FRIDAY
C      AFTER THANKSGIVING FROM NOV. 22-28 TO NOV. 23-29.; HOLIDAY
C      THRESHOLD REDUCTION INCREASED FROM 15% TO 20%; ADDED NEW
C      SWITCH TO ALLOW GOES (SOUNDING/RETRIEVAL/WIND/RADIANCE)
C      REPORTS TO GET A 15% THRESHOLD REDUCTION DURING ECLIPSE
C      SEASONS (AND WINDS GET SKIPPED IN NAM NETWORK)
C 2004-08-25  D. KEYSER   OFF-TIME (06, 18Z) FIXED LAND RAOBS REDUCE
C      THE CURRENT COUNT DUMP ALERT PERCENT THRESHOLD BY 10% (PREVENTS
C      SPECIAL FIELD EXPERIMENTS FROM TRIPPING ALERTS (ABUNDANCE DURING
C      EXPERIMENT, DEFICIENCY AFTER EXPERIMENT)
C 2006-03-08  D. KEYSER  REMOVED PROCESSING OF 1B SATELLITE REPORTS
C      WHICH WERE IN THE LONG-OBSOLETE IEEE DUMP STATUS FILE (THESE
C      HAVE LONG BEEN INCLUDED IN THE BUFR DUMP STATUS FILE ALONG WITH
C      ALL OTHER REPORTS); INPUT NAME LIST CHARACTER STRINGS IN
C      VARIABLES "NETWORK", "TMMARK" AND "CYCLE" ARE NOW EXPECTED TO BE
C      IN UPPER-CASE RATHER THAN IN LOWER-CASE
C 2013-03-15 JWhiting - port to WCOSS (no logic changes)
C 2017-01-10 D. Keyser  Minor changes to account for fact that NAM can
C      run at time marks other than tm00 after NAMv4 implementation
C      (only tm00 expected here).
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C              - DOCUMENTATION BELOW)
C     UNIT 10  - TABLE CONTAINING MNEMONIC NAME (A6), BUFR TYPE (I3),
C                BUFR SUBTYPE (I3), DESCRIPTION (A49) AND FLAGS FOR
C                EACH NETWORK (3(2X,A3,1X,I2,1X,I4,1X,4A1)) FOR ALL
C                CURRENTLY VALID BUFR TYPES AND SUBTYPES (THIS IS
C                GENERATED FROM THE bufr_dumplist FILE, SEE SCRIPT),
C                FORMAT:
C                '(1X,A6,8X,2(I3),5X,A49,3(2X,A3,1X,I2,1X,I4,1X,4A1))
C     UNIT 11  - TABLE CONTAINING BUFR TYPE (I3), BUFR SUBTYPE (I3) AND
C                DUMP COUNT (I7) FOR ALL OBSERVATIONS IN THIS CYCLE'S
C                NETWORK DATA DUMP RUN (THIS IS GENERATED FROM THE
C                DUMP STATUS FILE IN /com, SEE SCRIPT),
C                FORMAT: '(I3,1X,I3,1X,I7)'
C     UNIT 13  - TABLE CONTAINING THE MOST RECENT (CURRENT) 30-DAY
C                AVERAGE COUNTS AND NUMBER OF DAYS BY CYCLE (4(1X,I7,
C                1X,I3,1X)) FOR EACH BUFR TYPE (I3) AND SUBTYPE (I3)
C                (THIS IS GENERATED FROM THE FILE
C                obcount_30davg.*.current, WHERE THE SECOND QUALIFIER
C                IS THE NETWORK, SEE SCRIPT),
C                FORMAT:'(7X,I3,1X,I3,4(1X,I7,1X,I3,1X))'
C     UNIT 14  - TABLE CONTAINING 30-DAY AVERAGE COUNTS AND NUMBER OF
C                DAYS BY CYCLE FOR 3-MONTHS AGO (4(1X,I7,1X,I3,1X)) FOR
C                EACH BUFR TYPE (I3) AND SUBTYPE (I3) (THIS IS
C                GENERATED FROM THE FILE obcount_30davg.*.YYYYMM, WHERE
C                THE SECOND QUALIFIER IS THE NETWORK AND "YYYYMM" IS
C                3-MONTHS AGO, SEE SCRIPT),
C                FORMAT: '(7X,I3,1X,I3,4(1X,I7,1X,I3,1X))'
C     UNIT 15  - TABLE CONTAINING 30-DAY AVERAGE COUNTS AND NUMBER OF
C                DAYS BY CYCLE FOR 6-MONTHS AGO (4(1X,I7,1X,I3,1X)) FOR
C                EACH BUFR TYPE (I3) AND SUBTYPE (I3) (THIS IS
C                GENERATED FROM THE FILE obcount_30davg.*.YYYYMM, WHERE
C                THE SECOND QUALIFIER IS THE NETWORK AND "YYYYMM" IS
C                6-MONTHS AGO, SEE SCRIPT),
C                FORMAT: '(7X,I3,1X,I3,4(1X,I7,1X,I3,1X))'
C     UNIT 16  - TABLE CONTAINING 30-DAY AVERAGE COUNTS AND NUMBER OF
C                DAYS BY CYCLE FOR 9-MONTHS AGO (4(1X,I7,1X,I3,1X)) FOR
C                EACH BUFR TYPE (I3) AND SUBTYPE (I3) (THIS IS
C                GENERATED FROM THE FILE obcount_30davg.*.YYYYMM, WHERE
C                THE SECOND QUALIFIER IS THE NETWORK AND "YYYYMM" IS
C                9-MONTHS AGO, SEE SCRIPT),
C                FORMAT: '(7X,I3,1X,I3,4(1X,I7,1X,I3,1X))'
C     UNIT 17  - TABLE CONTAINING 30-DAY AVERAGE COUNTS AND NUMBER OF
C                DAYS BY CYCLE FOR 12-MONTHS AGO (4(1X,I7,1X,I3,1X))
C                FOR EACH BUFR TYPE (I3) AND SUBTYPE (I3) (THIS IS
C                GENERATED FROM THE FILE obcount_30davg.*.YYYYMM, WHERE
C                THE SECOND QUALIFIER IS THE NETWORK AND "YYYYMM" IS
C                12-MONTHS AGO, SEE SCRIPT),
C                FORMAT: '(7X,I3,1X,I3,4(1X,I7,1X,I3,1X))'
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C     UNIT 51  - UPDATED DATA COUNT (STATUS) TABLE FOR THIS CYCLE AND
C                NETWORK CONTAINING TODAY'S DUMP RECEIPTS AND THE
C                CURRENT 30-DAY AVERAGE VALUES FOR EACH BUFR TYPE AND
C                SUBTYPE DUMPED
C     UNIT 52  - ALERTLOG AND JOBLOG MESSAGE FILE FOR RESULTS OF
C                COMPARISON BETWEEN THIS CYCLE'S DUMP COUNTS AND THE
C                CURRENT 30-DAY AVERAGES - CONTAINS ONLY THOSE TYPES
C                WITH A DEFICIENCY IN THIS CYCLE'S DUMP
C     UNIT 53  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C                THIS CYCLE'S DUMP COUNTS AND THE CURRENT 30-DAY
C                AVERAGES - CONTAINS ONLY THOSE TYPES WITH AN
C                ABUNDANCE IN THIS CYCLE'S DUMP
C     UNIT 54  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C                THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C                3-MONTHS AGO
C     UNIT 55  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C                THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C                6-MONTHS AGO
C     UNIT 56  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C                THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C                9-MONTHS AGO
C     UNIT 57  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C                THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C                12-MONTHS AGO
C
C   SUBPROGRAMS CALLED:
C     UNIQUE:    - COMPARE_COUNTS
C     LIBRARY:
C       W3LIB    - W3TAGB W3TAGE W3DOXDAT ERREXIT
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN, NO DEFICIENCY EXISTS IN ANY DATA
C                   TYPE DUMPED IN THIS NETWORK RUN WHEN COMPARED TO
C                   THE CURRENT 30-DAY AVERAGE FILE
C          =   4 - SUCCESSFUL RUN, A DEFICIENCY EXISTS IN ONE OR MORE
C                   NON-CRITICAL DATA TYPES DUMPED IN THIS NETWORK RUN
C                   WHEN COMPARED TO THE CURRENT 30-DAY AVERAGE FILE,
C                   HOWEVER NONE OF THE DATA TYPES ARE CONSIDERED TO
C                   BE EITHER MODERATELY-CRITICAL OR CRITICAL
C          =   5 - SUCCESSFUL RUN, A DEFICIENCY EXISTS IN ONE OR MORE
C                   MODERATELY-CRITICAL DATA TYPES DUMPED IN THIS
C                   NETWORK RUN WHEN COMPARED TO THE CURRENT 30-DAY
C                   AVERAGE FILE, HOWEVER NONE OF THE DATA TYPES ARE
C                   CONSIDERED TO BE CRITICAL
C          =   6 - SUCCESSFUL RUN, A DEFICIENCY EXISTS IN ONE OR MORE
C                   CRITICAL DATA TYPES DUMPED IN THIS NETWORK RUN WHEN
C                   COMPARED TO THE CURRENT 30-DAY AVERAGE FILE
C          =  20 - FAILED RUN, BAD HOUR READ FROM STANDARD INPUT
C          =  21 - FAILED RUN, INVALID NETWORK READ FROM STANDARD INPUT
C          =  30 - FAILED RUN, ERROR READING SUBSET OF DUMPLIST FILE IN
C                   UNIT 10
C          =  31 - FAILED RUN, INVALID BUFR TYPE READ FROM SUBSET OF
C                   DUMPLIST FILE IN UNIT 10
C          =  32 - FAILED RUN, INVALID BUFR SUBTYPE READ FROM SUBSET OF
C                   DUMPLIST FILE IN UNIT 10
C          =  40 - FAILED RUN, ERROR READING SUBSET OF DUMP STATUS
C                   FILE IN UNIT 11
C          =  41 - FAILED RUN, INVALID BUFR TYPE READ FROM SUBSET OF
C                   DUMP STATUS FILE IN UNIT 11
C          =  42 - FAILED RUN, INVALID BUFR SUBTYPE READ FROM SUBSET OF
C                   DUMP STATUS FILE IN UNIT 11
C          =  60 - FAILED RUN, ERROR READING SUBSET OF EITHER THE
C                   CURRENT 30-DAY AVERAGE OR ONE OF THE PREVIOUS
C                   30-DAY AVERAGE FILES IN UNITS 13-17
C          =  61 - FAILED RUN, INVALID BUFR TYPE READ FROM SUBSET OF
C                   EITHER THE CURRENT 30-DAY AVERAGE FILE OR ONE OF
C                   THE PREVIOUS 30-DAY AVERAGE FILES IN UNIT 13-17
C          =  62 - FAILED RUN, INVALID BUFR SUBTYPE READ FROM SUBSET OF
C                   EITHER THE CURRENT 30-DAY AVERAGE FILE OR ONE OF
C                   THE PREVIOUS 30-DAY AVERAGE FILES IN UNITS 13-17
C
C REMARKS:
C     VARIABLES IN NAMELIST "INPUT" READ IN MAIN PROGRAM
C       CDATE10  - C*10, CURRENT DUMPTIME DATE ('YYYYMMDDHH')
C       NETWORK  - C*4,  NETWORK {either 'NAM ' (tm00), 'GFS ', or 'GDAS'}
C       TMMARK   - C*4,  DUMP TIME RELATIVE TO CYCLE TIME (e.g., 'TM00')
C       CYCLE    - C*3,  ANALYSIS CYCLE (e.g., '06Z')
C       JOB      - C*21, JOB NAME (e.g., 'gfs_dump_post_06' or
C                                        'nam_dump_post_tm00_06')
C       CURRDATE - C*32, CURRENT DATE
C                        (e.g.,'Wed Mar  9 08:48:44 GMT 2006')
C       KLIMIT   - THE LIMITING PERCENT FOR GENERATING A MESSAGE IN THE
C                   COMPARISON BETWEEN THE CURRENT 30-DAY AVERAGE AND
C                   THE PREVIOUS 30-DAY AVERAGES (I.E., IF THE CURRENT
C                   30-DAY AVERAGE IS ABOVE OR BELOW THE PAST 30-DAY
C                   AVERAGE BY "KLIMIT"% A MESSAGE IS WRITTEN TO
C                   APPROPRIATE OUTPUT UNIT (DEFAULT IS KLIMIT=20)
C       SKIP     - LOGICAL 5-DIM ARRAY WHERE:
C                    FIRST ELEMENT IS BUFR TYPE
C                    SECOND ELEMENT IS BUFR SUBTYPE
C                    THIRD ELEMENT IS NETWORK:
C                      1 - NAM (tm00)
C                      2 - GFS
C                      3 - GDAS
C                    FOURTH ELEMENT IS CYCLE:
C                      1 - 00Z
C                      2 - 06Z
C                      3 - 12Z
C                      4 - 18Z
C                    FIFTH ELEMENT IS DATA COUNT CHECK TYPE:
C                      1 - CURRENT COUNT VS. CURRENT 30-DAY AVERAGE FILE
C                      2 - CURRENT 30-DAY AVERAGE FILE VS. PREVIOUS
C                          30-DAY AVERAGE FILES
C                      3 - BOTH CHECKS)
C                  NO DATA COUNT CHECKING OF ANY TYPE IS PERFORMED FOR
C                   A PARTICULAR TYPE (I), SUBTYPE (J), NETWORK (K),
C                   AND CYCLE (L) IF SKIP(I,J,K,L,3) IS TRUE
C                   {DEFAULT IS SKIP(:,:,:,:,:)=FALSE}
C       WEEK_END - LOGICAL 5-DIM ARRAY WHERE:
C                    FIRST ELEMENT IS BUFR TYPE
C                    SECOND ELEMENT IS BUFR SUBTYPE
C                    THIRD ELEMENT IS NETWORK:
C                      1 - NAM (tm00)
C                      2 - GFS
C                      3 - GDAS
C                    FOURTH ELEMENT IS CYCLE:
C                      1 - 00Z
C                      2 - 06Z
C                      3 - 12Z
C                      4 - 18Z
C                    FIFTH ELEMENT IS TYPE SWITCH:
C                      1 - WEEKEND
C                      2 - HOLIDAY
C                      3 - BOTH
C                  REDUCES THE CURRENT COUNT DUMP ALERT PERCENT
C                   THRESHOLD BY 10% FOR A PARTICULAR TYPE (I), SUBTYPE
C                   (J), NETWORK (K), AND CYCLE (L) (OVER THAT READ
C                   FROM DUMPLIST) IF WEEK_END(I,J,K,L,1) OR
C                   WEEK_END(I,J,K,L,3) IS TRUE AND TODAY IS A WEEKEND
C                       -- OR --
C                  REDUCES THE CURRENT COUNT DUMP ALERT PERCENT
C                   THRESHOLD BY 20% FOR A PARTICULAR TYPE (I), SUBTYPE
C                   (J), NETWORK (K), AND CYCLE (L) (OVER THAT READ
C                   FROM DUMPLIST) IF WEEK_END(I,J,K,L,2) OR
C                   WEEK_END(I,J,K,L,3) IS TRUE AND TODAY IS EITHER:
C                     - IN THE LAST WEEK OF THE YEAR (HOLIDAY PERIOD)
C                     - THANKSGIVING
C
C                  SPECIAL CASE FOR GOES REPORTS (SOUNDINGS, WINDS,
C                   RETRIEVALS, RADIANCES):
C                    IF THE CURRENT DAY IS DURING AN ECLIPSE PERIOD,
C                     THEN TYPE SWITCH (FIFTH ELEMENT) = 4 WILL REDUCE
C                     THE DUMP ALERT THRESHOLD BY 15% IF
C                     WEEK_END(I,J,K,L,4) IS TRUE {if NAM (tm00)
C                     network, will SKIP data count checking for GOES
C                     WINDS}
C
C                   {DEFAULT IS WEEK_END(:,:,:,:,:)=FALSE}
C
C                   (NOTE1: This is useful for data types such as
C                           aircraft which may contain fewer reports on
C                           weekends and holidays and GOES soundings/
C                           winds/radiances which may contain fewer (or
C                           no) reports at certain cycles during an
C                           eclipse period)
C                   (NOTE2: For a particular I,J,K,L only one of
C                           WEEK_END(I,J,K,L,1), WEEK_END(I,J,K,L,2),
C                           WEEK_END(I,J,K,L,3), OR WEEK_END(I,J,K,L,4)
C                           should ever be TRUE)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM-SP
C
C$$$

      PROGRAM BUFR_DATACOUNT

      PARAMETER (IMAX_BTYPE=255)
      PARAMETER (IMAX_STYPE=255)
      PARAMETER (IMAX_CMNEM=27)
      PARAMETER (IMAX_CAVGS=27)

      PARAMETER (IMAX_CMNEM_ALL=(IMAX_CMNEM * 2 * 3))
      PARAMETER (IMAX_CAVGS_ALL=(IMAX_CAVGS * 2 * 4))

      PARAMETER (IMAX_BS_TYPE=(IMAX_BTYPE + 1) * (IMAX_STYPE + 1))

      COMMON /DATA/iavg_count(000:imax_btype,000:imax_stype,5),
     $ iavg_ndays(000:imax_btype,000:imax_stype,5),
     $ icur_count(000:imax_btype,000:imax_stype),
     $ iper(000:imax_btype,000:imax_stype),
     $ ilimit(000:imax_btype,000:imax_stype),
     $ ivalid_st(000:imax_btype,000:imax_stype)

      COMMON /CDATA6/mnemonic(000:imax_btype,000:imax_stype)
      COMMON /CDATA3/cred(000:imax_btype,000:imax_stype)
      COMMON /CDATA2/cflag(000:imax_btype,000:imax_stype)
      COMMON /CDATA1/clong(000:imax_btype,000:imax_stype,2:5)

      COMMON /SKIPIT/skip(000:imax_btype,000:imax_stype,3,4,3)
      COMMON /WKENDS/week_end(000:imax_btype,000:imax_stype,3,4,4)

      CHARACTER*49  description(000:imax_btype,000:imax_stype),desc
      CHARACTER*32  currdate
      CHARACTER*21  job
      CHARACTER*19  csevere(3)
      CHARACTER*10  cdate10
      CHARACTER*6   mnemonic,
     $              cmnem(imax_cmnem,2,3),cavgs(imax_cavgs,2,2:5),mnemon
      CHARACTER*4   tmmark,clohi_l(2),network,network_types(3)
      CHARACTER*3   cred,cr(3),cycle
      CHARACTER*2   cflag
      CHARACTER*1   clong,cl(3,2:5)

      LOGICAL       skip,week_end,eclipse

      INTEGER       ip(3),il(3),jreps_30d(4),ndays(4),idat(8),
     $              isub_per(4,4)

      NAMELIST      /INPUT/CDATE10,NETWORK,TMMARK,CYCLE,JOB,CURRDATE,
     $                     KLIMIT,SKIP,WEEK_END

      DATA          cmnem          /imax_cmnem_all*'      '/
      DATA          cavgs          /imax_cavgs_all*'      '/
      DATA          network_types  /'NAM ','GFS ','GDAS'/
      DATA          clohi_l        /'low ','high'/
      DATA          csevere        /'...... Non-critical',
     $                              'MODERATELY-CRITICAL',
     $                              '***** CRITICAL ****'/
      DATA  description
     $/imax_bs_type*'                                                 '/

      DATA
C  Alert threshold reduction (%)
C   week_end(i,j,k,l,M)=TRUE,
C                --weekend--   --holiday--   ---both----   --eclipse--
C     where M=    1     3          2  3       1  2  3                4
C                -- -- -- --   -- -- -- --   -- -- -- --   -- -- -- --
     $ isub_per/ 10, 0,10, 0,   0,20,20, 0,  10,20,20, 0,   0, 0, 0,15/

      CALL W3TAGB('BUFR_DATACOUNT',2017,0010,0079,'NP22')

      ierr = 0

      klimit = 20
      read(5,input)

      PRINT 101, cdate10,network,tmmark
  101 FORMAT(/'#####  Welcome to DATACOUNT - Version 01/10/2017'/3x,
     $ '--->  DUMPTIME DATE IS: ',a10/3x,'--->  NETWORK IS:',7x,a4,3x,
     $ a4//)

      idat = 0

      READ(cdate10(1:8),'(i4,i2,i2)') (idat(ii),ii=1,3)
      CALL W3DOXDAT(idat,jdow,jdoy,jday)

      READ(cdate10(9:10),'(i2)') ihour

      icycle = ihour/6 + 1

C  iwkend_fl: =0 Today is neither a weekend nor a holiday
C             =1 Today is a weekend but not a holiday
C             =2 Today is a holiday but not a weekend
C             =3 Today is a holiday and a weekend
C             =4 Today is an eclipse day {GOES radiance/sounding/
C                retrieval/wind data only (wind only if GFS or GDAS
C                network), overrides any pervious value of
C                iwkend_fl - this cannot be determined until a report
C                type/subtype is actually read in later}
C             =5 Today is an eclipse day {GOES wind data in NAM (tm00)
C                network only, overrides any previous value of iwkend_fl
C                - this cannot be determined until a report type/subtype
C                is actually read in later)


      iwkend_fl = 0
      if(ihour.eq.00) then                ! Sun, Mon for 00Z
         if(jdow.eq.1.or.jdow.eq.2) iwkend_fl = 1
      else if(ihour.eq.06) then           ! Sun, Mon for 06Z
         if(jdow.eq.1.or.jdow.eq.2) iwkend_fl = 1
      else if(ihour.eq.12) then           ! Sun, Mon for 12Z
         if(jdow.eq.1.or.jdow.eq.2) iwkend_fl = 1
      else if(ihour.eq.18) then           ! Sun, Sat for 18Z
         if(jdow.eq.1.or.jdow.eq.7) iwkend_fl = 1
      end if
      if(jdoy.gt.355 .or. jdoy.lt.3) then ! Last week of yr holiday
         if(iwkend_fl.eq.0)  then
            iwkend_fl = 2
         else
            iwkend_fl = 3
         end if
      else if(idat(2).eq.11)  then
         if(idat(3).gt.21 .and. idat(3).lt.29)  then
            if(ihour.eq.12) then
               if(jdow.eq.5)  then  ! Thanksgiving Day 12Z
                  if(iwkend_fl.eq.0)  then
                     iwkend_fl = 2
                  else
                     iwkend_fl = 3
                  end if
               end if
            end if
         end if
         if(idat(3).gt.22 .and. idat(3).lt.30)  then
            if(ihour.eq.00) then
               if(jdow.eq.6)  then  ! Fri after Thanksgiving 00Z
                  if(iwkend_fl.eq.0)  then
                     iwkend_fl = 2
                  else
                     iwkend_fl = 3
                  end if
               end if
            else if(ihour.eq.06) then
               if(jdow.eq.6)  then  ! Fri after Thanksgiving 06Z
                  if(iwkend_fl.eq.0)  then
                     iwkend_fl = 2
                  else
                     iwkend_fl = 3
                  end if
               end if
            end if
         end if
      end if
      iwkend_fl_ORIG = iwkend_fl

C  The eclipse window is expanded 10-days on each side to account for
C   NESDIS "keep-out" zones
C  ------------------------------------------------------------------

      eclipse=((jdoy.gt. 45 .and. jdoy.lt.114)!Spring Eclipse(2/25-4/13)
     $    .or. (jdoy.gt.221 .and. jdoy.lt.297))!Fall Eclipse(8/20-10/13)

      print *, ' '
      print *, 'Integer Day of Week  is ',jdow
      print *, 'Integer Day of Year  is ',jdoy
      print *, 'Weekend/holiday Flag is ',iwkend_fl,
     $ '(0-neither; 1-weekend only; 2-holiday only; 3-both)'
      if(eclipse) then
         if(network.ne.'NAM ')  then
            print *, '  - this will later be reset to 4 (eclipse) for ',
     $       'GOES retr/sndgs/rad/wind since we are in an eclipse ',
     $       'season'
         else
            print *, '  - this will later be reset to 4 (eclipse) for ',
     $       'GOES retr/sndgs/rad or 5 for GOES winds since we are in ',
     $       'an eclipse season'
         end if
      end if
      print *, ' '

      inet = 0
      DO I=1,3
         IF(network.eq.network_types(i))  THEN
            inet = i
            exit
         END IF
      END DO

      IF(mod(ihour,6).ne.0) THEN
         PRINT 102, ihour
  102 FORMAT(/' ### BAD HOUR (=',i3.2,') READ IN FROM STANDARD INPUT ',
     $ 'DATA CARDS -- STOP 20'/)
         CALL W3TAGE('BUFR_DATACOUNT')
         CALL ERREXIT(20)
      ELSE IF(inet.eq. 0) THEN
         PRINT 103, network
  103 FORMAT(/' ### INVALID NETWORK (="',a4,'") READ IN FROM STANDARD',
     $ ' INPUT DATA CARDS -- STOP 21'/)
         CALL W3TAGE('BUFR_DATACOUNT')
         CALL ERREXIT(21)
      END IF

C     Parse out information from the subset of the dumplist file
C     ----------------------------------------------------------

      PRINT 104
  104 FORMAT('  ==> Parsing through the subset of the dumplist file'/)

      DO WHILE (ierr .eq. 0)
         READ(10,105,end=10,err=996) mnemon,jtype,jsub,desc,
     $    (cr(i),ip(i),il(i),(cl(i,j),j=2,5),i=1,3)
  105 FORMAT(1x,a6,8x,i3,i3,5x,a49,3(2x,a3,1x,i2,1x,i4,1x,4a1))
         IF(jtype.lt.0. .or. jtype.gt.imax_btype) THEN
            PRINT 106,jtype
  106 FORMAT(' ###  INVALID VALUE FOR BUFR TYPE IN SUBSET OF DUMPLIST ',
     $ 'FILE (=',i3.3,') -- STOP 31')
            CALL W3TAGE('BUFR_DATACOUNT')
            CALL ERREXIT(31)
         ELSE IF(jsub.lt.0. .or. jsub.gt.imax_stype) THEN
            PRINT 107, jsub
  107 FORMAT(' ### INVALID VALUE FOR BUFR SUBTYPE IN SUBSET OF ',
     $ 'DUMPLIST FILE (=',i3.3,') -- STOP 32')
            CALL W3TAGE('BUFR_DATACOUNT')
            CALL ERREXIT(32)
         END IF

         iwkend_fl = iwkend_fl_ORIG
         if(eclipse)  then  ! Test for proper data type if eclipse
            if(jtype.eq.3)  then
               if(jsub.lt.10)  iwkend_fl = 4 ! GOES soundings all nets
            else  if(jtype.eq.5)  then   
               if(jsub.lt.21)  then
                  iwkend_fl = 4            ! GOES winds GFS or GDAS net
                  if(inet.eq.1) iwkend_fl= 5 ! GOES winds NAM (tm00) net
               end if
            else  if(jtype.eq.21) then
               if(jsub.eq.41)  iwkend_fl = 4 ! GOES imager radiances
            end if
         end if

         mnemonic(jtype,jsub)    = mnemon
         description(jtype,jsub) = desc
         cred(jtype,jsub)        = cr(inet)

         iper(jtype,jsub)        = ip(inet)
         jwkend_fl = 0
         if(iwkend_fl.eq.1 .or. iwkend_fl.eq.2)  then
            if(week_end(jtype,jsub,inet,icycle,iwkend_fl))  then
               jwkend_fl = iwkend_fl
            else  if(week_end(jtype,jsub,inet,icycle,3))  then
               jwkend_fl = 3
            end if
         else  if(iwkend_fl.eq.3)  then
            do ifl = 1,3
               if(week_end(jtype,jsub,inet,icycle,ifl)) then
                  jwkend_fl = ifl
                  exit
               end if
            end do
         else  if(iwkend_fl.eq.4)  then
            if(week_end(jtype,jsub,inet,icycle,iwkend_fl))
     $       jwkend_fl = iwkend_fl
         end if
         if(min(iwkend_fl,jwkend_fl).gt.0)  then
            if(iper(jtype,jsub).ge.isub_per(jwkend_fl,iwkend_fl))
     $       iper(jtype,jsub) = iper(jtype,jsub) -
     $                          isub_per(jwkend_fl,iwkend_fl)
         end if

C Off-time (06, 18Z) fixed land RAOBs reduce the current count dump
C  alert percent threshold by 10% (prevents special field experiments
C  from tripping alerts (abundance during exp., deficiency after exp.)
C --------------------------------------------------------------------

         if(ihour.eq.06.or.ihour.eq.18)  then
            if(jtype.eq.002.and.jsub.eq.001)  then
               if(iper(002,001).ge.10) iper(002,001) = iper(002,001) -10
            end if
         end if


         ilimit(jtype,jsub)      = il(inet)
         clong(jtype,jsub,:)     = cl(inet,:)

         PRINT 109, mnemonic(jtype,jsub),jtype,jsub,cred(jtype,jsub),
     $   iper(jtype,jsub),ilimit(jtype,jsub),(clong(jtype,jsub,i),
     $   i=2,5),jwkend_fl
  109 FORMAT(32('-')/' mnemonic "',a6,'"'/' type ',i4.3,
     $' subtype ',i4.3/' red flag "',a3,'"'/' percent ',i3/' limit ',i5,
     $ /' long-term ',4a1/' jwkend_fl ',i2)
         if(jwkend_fl.eq.1) then
            PRINT 2109
 2109 FORMAT(' ===> The percent limit has been reduced by 10% for this',
     $ ' type because it satisfies the weekend criterion')
         else  if(jwkend_fl.eq.2) then
            PRINT 2110
 2110 FORMAT(' ===> The percent limit has been reduced by 20% for this',
     $ ' type because it satisfies the holiday criterion')
         else  if(jwkend_fl.eq.3) then
            if(iwkend_fl.eq.1)  then
               PRINT 2109
            else
               PRINT 2110
            end if
         else  if(jwkend_fl.eq.4) then
            PRINT 2111
 2111 FORMAT(' ===> The percent limit has been reduced by 15% for this',
     $ ' type because it satisfies the eclipse criterion')
         else  if(iwkend_fl.eq.5)  then
            if(week_end(jtype,jsub,inet,icycle,4))  then
               SKIP(jtype,jsub,inet,icycle,1) = .TRUE.
               PRINT 2112
 2112 FORMAT(' ===> This type will not be checked because it is a GOES',
     $ ' WIND report which satisfies the eclipse criterion')
            end if
         end if
      END DO

   10 CONTINUE

      PRINT 110
  110 FORMAT('--------------------------------'/)

C     Parse out information from the subset of the dump status file
C     -------------------------------------------------------------

      DO WHILE (ierr .eq. 0)
         READ(11,*,end=20,err=997) jtype,jsub,jreps
         IF(jtype.lt.0. .or. jtype.gt.imax_btype) THEN
            PRINT 111, jtype
  111 FORMAT(' ### INVALID VALUE FOR BUFR TYPE IN SUBSET OF DUMP ',
     $ 'STATUS FILE (=',i3.3,') -- STOP 41')
            CALL W3TAGE('BUFR_DATACOUNT')
            CALL ERREXIT(41)
         ELSE IF(jsub.lt.0. .or. jsub.gt.imax_stype) THEN
            PRINT 112, jsub
  112 FORMAT(' ### INVALID VALUE FOR BUFR SUBTYPE IN SUBSET OF DUMP ',
     $ 'STATUS FILE (=',i3.3,') -- STOP 42')
            CALL W3TAGE('BUFR_DATACOUNT')
            CALL ERREXIT(42)
         END IF
C     .. this will take care of things if a type/subtype is ever split up
         icur_count(jtype,jsub) = icur_count(jtype,jsub) + jreps
         ivalid_st(jtype,jsub)  = 1
      END DO

   20 CONTINUE

C     Parse out information from the five 30-day average files
C     --------------------------------------------------------

      DO iavg = 1,5
         months_ago = (iavg - 1) * 3
         ifile = 12 + iavg
         iflag = 0

         IF(iavg.gt.1)  THEN
            PRINT 113, months_ago
  113 FORMAT(/'  ==> Parsing through the subset of the 30-day average ',
     $ 'file from ',i2,' months ago'/)
         ELSE
            PRINT 114
  114 FORMAT(/'  ==> Parsing through the subset of the current 30-day ',
     $ 'average file'/)
         END IF

         DO WHILE (ierr .eq. 0)
            READ(ifile,*,end=40,err=999) jtype,jsub,(jreps_30d(i),
     $       ndays(i),i=1,4)
            iflag = 1
            IF(jtype.lt.0. .or. jtype.gt.imax_btype) THEN
               IF(iavg.gt.1)  THEN
                  PRINT 115, months_ago,jtype
  115 FORMAT(' ### INVALID VALUE FOR BUFR TYPE IN SUBSET OF 30-DAY ',
     $ 'AVERAGE FILE FROM ',i2,' MONTHS AGO (=',i3.3,') -- STOP 61')
               ELSE
                  PRINT 116, jtype
  116 FORMAT(' ### INVALID VALUE FOR BUFR TYPE IN SUBSET OF CURRENT ',
     $ '30-DAY AVERAGE FILE (=',i3.3,') -- STOP 61')
               END IF
               CALL W3TAGE('BUFR_DATACOUNT')
               CALL ERREXIT(61)
            ELSE IF(jsub.lt.0. .or. jsub.gt.imax_stype) THEN
               IF(iavg.gt.1)  THEN
                  PRINT 117, months_ago,jsub
  117 FORMAT(' ### INVALID VALUE FOR BUFR SUBTYPE IN SUBSET OF 30-DAY ',
     $ 'AVERAGE FILE FROM ',i2,' MONTHS AGO (=',i3.3,') -- STOP 62')
               ELSE
                  PRINT 118, jsub
  118 FORMAT(' ### INVALID VALUE FOR BUFR SUBTYPE IN SUBSET OF CURRENT',
     $ ' 30-DAY AVERAGE FILE (=',i3.3,') -- STOP 62')
               END IF
               CALL W3TAGE('BUFR_DATACOUNT')
               CALL ERREXIT(62)
            END IF
            PRINT 119, jtype,jsub,(jreps_30d(i),ndays(i),i=1,4)
  119 FORMAT(32('-')/' type ',i4.3,' subtype ',i4.3/
     $ ' 00Z     ',i8,'/',i3/' 06Z     ',i8,'/',i3/' 12Z     ',i8,'/',
     $ i3/' 18Z     ',i8,'/',i3)   
            if(ndays(icycle).gt.0)
     $       iavg_count(jtype,jsub,iavg) = jreps_30d(icycle)
            iavg_ndays(jtype,jsub,iavg) = ndays(icycle)
         END DO 

   40    CONTINUE

         IF(iflag.eq.0)  PRINT 120
  120    FORMAT(7x,'-- This file is empty!!'/)

         PRINT 110

      END DO

C     Compare counts and set the return code
C     --------------------------------------

      CALL COMPARE_COUNTS(klimit,cmnem,cavgs,inet,icycle,istop)  

C     Generate the updated status file
C     --------------------------------

C        --> Headings

      WRITE(51,121) tmmark,cycle,network,job,cdate10(1:4),cdate10(5:6),
     $ cdate10(7:8),cdate10(9:10),currdate
  121 FORMAT(80('*')/'*',78(' '),'*'/'*',12x,'### ',a4,' OBSERVATIONAL',
     $ ' DATA DUMP FOR ',a3,1x,a4,' RUN ###',13x,'*'/'*',78(' '),'*'/'*'
     $,22x,'SCRIPT IS: ',a21,24x,'*'/'*',20x,'Run Date is ',a4,'/',a2,
     $ '/',a2,2x,a2,'Z',31x,'*'/'*',15x,'FILE CREATED ',a32,18x,'*'/'*',
     $ 78(' '),'*')

      nflag = 0
      LOOP1: DO isevere=3,1,-1
         IF(cmnem(1,1,isevere) .eq. '      ') THEN
            WRITE(51,122) csevere(isevere)
  122       FORMAT(80('*')/'* ',a19,' low data counts encountered: ',
     $       'none',24x,'*')
         ELSE
            WRITE(51,123) csevere(isevere)
  123       FORMAT(80('*')/'* ',a19,' low data counts encountered:',
     $       29x,'*')
            nflag = 1
            LOOP2: DO k = 1,3
               kk = (k-1)*9
               IF(cmnem(kk+1,1,isevere).ne.'      ') then
                  WRITE(51,124) (cmnem(kk+i,1,isevere),i=1,9)
  124             FORMAT('*',2x,9(2x,a6),4x,'*')
               ELSE
                  EXIT LOOP2
               END IF
            END DO LOOP2
         END IF
      END DO LOOP1 
      IF(nflag .eq. 1)  THEN
         WRITE(51,125)
  125 FORMAT(80('*')/'*   Below,  "+" next to mnemonic means ',
     $ 'deficiency in non-critical data type,   *'/'*',11x,'"*" next ',
     $ 'to mnemonic means deficiency in moderately-critical type, *'/
     $ '*',10x,'"**" next to mnemonic means deficiency in CRITICAL ',
     $ 'data type.',7x,'*')
      END IF
      IF(cmnem(1,2,1) .eq. '      ') THEN
         WRITE(51,1223)
 1223    FORMAT(80('*')/'* High data counts encountered: none',43x,
     $    '*')
      ELSE
         WRITE(51,1233)
 1233    FORMAT(80('*')/'* High data counts encountered:',48x,'*')
         LOOP3: DO k = 1,3
            kk = (k-1)*9
            IF(cmnem(kk+1,2,1).ne.'      ') then
               WRITE(51,1243) (cmnem(kk+i,2,1),i=1,9)
 1243          FORMAT('*',2x,9(2x,a6),4x,'*')
            ELSE
               EXIT LOOP3
            END IF
         END DO LOOP3
         WRITE(51,126)
  126 FORMAT('*',78('-'),'*'/'*   Below,  "!" next to mnemonic means ',
     $ 'abundance in non- or mod-critical type, *'/'*',10x,'"!!" next ',
     $ 'to mnemonic means abundance in CRITICAL data type.',8x,'*')
      END IF

      LOOP4: DO iavg = 2,5
         months_ago = (iavg - 1) * 3
         LOOP5: DO ilohi = 1,2
            IF(cavgs(1,ilohi,iavg) .ne. '      ') THEN
               WRITE(51,127) clohi_l(ilohi),months_ago
  127 FORMAT(80('*')/'* Current 30-day avg ',a4,' vs. avg from ',i2,
     $ ' months ago: ',25x,'*')
               LOOP6: DO k = 1,3
                  kk = (k-1)*9
                  IF(cavgs(kk+1,ilohi,iavg).ne.'      ') THEN
                     WRITE(51,128) (cavgs(kk+i,ilohi,iavg),i=1,9)
  128                FORMAT('*',2x,9(2x,a6),4x,'*')
                  ELSE
                     EXIT LOOP6
                  END IF
               END DO LOOP6
            END IF
         END DO LOOP5
      END DO LOOP4
      WRITE(51,129)
  129 FORMAT(80('*')/'*',78(' '),'*'/'* todays    30-day',61(' '),'*'/
     $ '* receipt   average                Data Type',35(' '),'*'/
     $ '*',78(' '),'*')

C        --> Updated data for today

      LOOP7: DO jtype = 0,imax_btype
         LOOP8: DO jsub = 0,imax_stype
            IF(mnemonic(jtype,jsub).eq.'      ')  CYCLE LOOP8
            IF(ivalid_st(jtype,jsub).eq.0) CYCLE LOOP8
            WRITE(51,130) icur_count(jtype,jsub),
     $       iavg_count(jtype,jsub,1),cflag(jtype,jsub),
     $       mnemonic(jtype,jsub),description(jtype,jsub)
  130       FORMAT('*',i7,3x,i7,1x,a2,1x,a6,1x,a49,' *')
         END DO LOOP8
      END DO LOOP7

      WRITE(51,131)
  131 FORMAT('*',78(' '),'*'/80('*'))

C     All done
C     --------

      PRINT 132, istop
  132 FORMAT(//' ** DATACOUNT ** ENDING WITH RETURN CODE ',i3/)

      CALL W3TAGE('BUFR_DATACOUNT')
      CALL ERREXIT(istop)

      STOP

C-----------------------------------------------------------------------
  996 CONTINUE
      PRINT 133
  133 FORMAT(' ###  ERROR READING SUBSET OF DUMPLIST FILE IN UNIT 10 ',
     $ '-- STOP 30')
      CALL W3TAGE('BUFR_DATACOUNT')
      CALL ERREXIT(30)
C-----------------------------------------------------------------------
  997 CONTINUE
      PRINT 134
  134 FORMAT(' ###  ERROR READING SUBSET OF DUMP STATUS FILE IN UNIT',
     $ ' 11 -- STOP 40')
      CALL W3TAGE('BUFR_DATACOUNT')
      CALL ERREXIT(40)
C-----------------------------------------------------------------------
  999 CONTINUE
      IF(iavg.gt.1)  THEN
         PRINT 136, months_ago,ifile
  136 FORMAT(' ###  ERROR READING SUBSET OF 30-DAY AVERAGE FILE FROM ',
     $ i2,' MONTHS AGO IN UNIT ',i2,' -- STOP 60')
      ELSE
         PRINT 137
  137 FORMAT(' ###  ERROR READING SUBSET OF CURRENT 30-DAY AVERAGE ',
     $ 'FILE IN UNIT 13 -- STOP 60')
      END IF
      CALL W3TAGE('BUFR_DATACOUNT')
      CALL ERREXIT(60)
C-----------------------------------------------------------------------

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    COMPARE_COUNTS
C   PRGMMR: KEYSER           ORG: NP22       DATE: 2002-03-19
C
C ABSTRACT: COMPARES THE ACTUAL NUMBER OF OBSERVATIONS DUMPED IN THE
C   CURRENT OPERATIONAL RUN AGAINST THE CURRENT 30-DAY AVERAGES.  IF
C   THERE IS A DEFICIENCY, A MESSAGE FOR THE ALERTLOG AND JOBLOG IS
C   PREPARED AND A FLAG IS SET WHICH WILL LATER RESULT IN AN EXIT
C   CODE OF EITHER 4, 5 OR 6.  IF THERE IS AN ABUNDANCE, A MESSAGE FOR
C   THE JOBLOG IS PREPARED BUT NO FUTURE RETURN CODE FLAG IS SET.
C            IN ADDITION, COMPARES THE CURRENT 30-DAY AVERAGES AGAINST
C   30-DAY AVERAGES FROM 3-, 6-, 9-, AND 12-MONTHS AGO.  IF EITHER A
C   DEFICIENCY OR ABUNDANCE OCCURS IN ANY DATA TYPE IN THE CURRENT
C   OPERATIONAL RUN, A MESSAGE FOR THE JOBLOG IS PREPARED BUT NO FUTURE
C   RETURN CODE FLAG IS SET.
C
C PROGRAM HISTORY LOG:
C 1999-06-24  L. SAGER  
C 2000-09-21  D. KEYSER   COMPLETE REDESIGN OF THIS PROGRAM (E.G.,
C      MORE ROBUST; DOES COMPARISON OF CURRENT 30-DAY AVERAGE FILE
C      AGAINST 30-DAY AVERAGE FILES FROM 3-, 6-, 9-, AND 12-MONTHS AGO;
C      MORE FLEXIBILITY IN PROGRAM, NOTES DATA TYPES WITH HIGH COUNTS
C      VS. 3-DAY AVERAGE, ETC.)
C 2000-12-05  D. KEYSER   NOW WRITES OUTPUT FROM COMPARISON TO 3-, 6-,
C      9-, AND 12-MONTHS AGO TO SEPARATE OUTPUT FILES (UNITS 54-57)
C      RATHER THAN ALL TO ONE FILE (UNIT 54); THE LIMIT FOR GENERATING
C      A MESSAGE OF HIGH OR LOW COUNTS IN THE COMPARISON BETWEEN THE
C      CURRENT 30-DAY AVERAGE AND THE PREVIOUS 30-DAY AVERAGES IS NOW
C      READ IN AS A NAMELIST SWITCH RATHER THAN BEING HARDWIRED TO 20%
C      (THE DEFAULT IS 20%)
C 2001-04-02  D. KEYSER   ADDED OPTION TO RETURN WITH NEW CODE 4 WHICH
C      INDICATES A DEFICIENCY IN A "NON-CRITICAL" DATA TYPE (E.G.,
C      A TYPE THAT IS DUMPED BUT NOT ASSIMILATED BY THE ANALYSIS)
C 2002-03-19  D. KEYSER   INCREASED PARAMETER IMAX_BTYPE FROM 101
C      TO 255 TO ACCOUNT FOR NEW MESONET DATA IN BUFR TYPE 255
C
C USAGE:    CALL COMPARE_COUNTS(KLIMIT,CMNEM,CAVGS,INET,ICYCLE,ISTOP)
C   INPUT ARGUMENT LIST:
C     KLIMIT   - THE LIMITING PERCENT FOR GENERATING A MESSAGE IN THE
C              - COMPARISON BETWEEN THE CURRENT 30-DAY AVERAGE AND THE
C              - PREVIOUS 30-DAY AVERAGES (I.E., IF THE CURRENT 30-DAY
C              - AVERAGE IS ABOVE OR BELOW THE PAST 30-DAY AVERAGE BY
C              - "KLIMIT"% A MESSAGE IS WRITTEN TO APPROPRIATE OUTPUT
C              - UNIT
C
C   OUTPUT ARGUMENT LIST:
C     CMNEM    - 3-DIM STRING ARRAY CONTAINING MNEMONIC NAME FOR ALL
C              - BUFR TYPE AND SUBTYPES WHICH ARE EITHER DEFICIENT OR
C              - EXCESSIVE (ELEMENT 2) FOR CURRENT CYCLE DUMP VS.
C              - CURRENT 30-DAY AVERAGE (ELEMENT 3) FOR THE THREE
C              - DEGREES OF DEFICIENCY SEVERITY (FOR EXCESSIVE CASES,
C              - ONLY WORD 1 IN ELEMENT 3 USED) (C*6)
C     CAVGS    - 3-DIM STRING ARRAY CONTAINING MNEMONIC NAME FOR ALL
C              - BUFR TYPE AND SUBTYPES WHICH ARE EITHER DEFICIENT OR
C              - EXCESSIVE (ELEMENT 2) FOR CURRENT 30-DAY AVERAGE VS.
C              - 30-DAY AVERAGE FROM 3-, 6-, 9-, AND 12-MONTHS AGO
C              - (ELEMENT 3) (C*6)
C     INET     - NETWORK INDICATOR {=1 - NAM (tm00); =2 - GFS;
C              -  =3 - GDAS}
C     ICYCLE   - CYCLE INDICATOR (=1 - 00Z; =2 - 06Z; =3 - 12Z;
C              - =4 - 18Z)
C     ISTOP    - FLAG WHICH WILL LATER DEFINE THE PROGRAM RETURN CODE:
C              -  =0 - SUCCESSFUL RUN, NO DEFICIENCY EXISTS IN ANY DATA
C              -        TYPE DUMPED IN THIS NETWORK RUN WHEN COMPARED
C              -        TO THE CURRENT 30-DAY AVERAGE FILE
C              -  =4 - SUCCESSFUL RUN, A DEFICIENCY EXISTS IN ONE OR
C              -        MORE NON-CRITICAL DATA TYPES DUMPED IN THIS
C              -        NETWORK RUN WHEN COMPARED TO THE CURRENT 30-DAY
C              -        AVERAGE FILE, HOWEVER NONE OF THE DATA TYPES
C              -        ARE CONSIDERED TO BE EITHER MODERATELY-CRITICAL
C              -        OR CRITICAL
C              -  =5 - SUCCESSFUL RUN, A DEFICIENCY EXISTS IN ONE OR
C              -        MORE MODERATELY-CRITICAL DATA TYPES DUMPED IN
C              -        THIS NETWORK RUN WHEN COMPARED TO THE CURRENT
C              -        30-DAY AVERAGE FILE, HOWEVER NONE OF THE DATA
C              -        TYPES ARE CONSIDERED TO BE CRITICAL
C              -  =6 - SUCCESSFUL RUN, A DEFICIENCY EXISTS IN ONE OR
C              -        MORE CRITICAL DATA TYPES DUMPED IN THIS NETWORK
C              -        WHEN COMPARED TO THE CURRENT 30-DAY AVERAGE
C              -        FILE
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C     UNIT 52  - ALERTLOG AND JOBLOG MESSAGE FILE FOR RESULTS OF
C              - COMPARISON BETWEEN THIS CYCLE'S DUMP COUNTS AND THE
C              - CURRENT 30-DAY AVERAGES - CONTAINS ONLY THOSE TYPES
C              - WITH A DEFICIENCY IN THIS CYCLE'S DUMP
C     UNIT 53  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C              - THIS CYCLE'S DUMP COUNTS AND THE CURRENT 30-DAY
C              - AVERAGES - CONTAINS ONLY THOSE TYPES WITH AN
C              - ABUNDANCE IN THIS CYCLE'S DUMP
C     UNIT 54  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C              - THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C              - 3-MONTHS AGO
C     UNIT 55  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C              - THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C              - 6-MONTHS AGO
C     UNIT 56  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C              - THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C              - 9-MONTHS AGO
C     UNIT 57  - JOBLOG MESSAGE FILE FOR RESULTS OF COMPARISON BETWEEN
C              - THE CURRENT 30-DAY AVERAGES AND 30-DAY AVERAGES FROM
C              - 12-MONTHS AGO
C
C REMARKS: NONE.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM SP
C
C$$$

      SUBROUTINE COMPARE_COUNTS(klimit,cmnem,cavgs,inet,icycle,istop)  
     
      PARAMETER (IMAX_BTYPE=255)
      PARAMETER (IMAX_STYPE=255)
      PARAMETER (IMAX_CMNEM=27)
      PARAMETER (IMAX_CAVGS=27)

      COMMON /DATA/iavg_count(000:imax_btype,000:imax_stype,5),
     $ iavg_ndays(000:imax_btype,000:imax_stype,5),
     $ icur_count(000:imax_btype,000:imax_stype),
     $ iper(000:imax_btype,000:imax_stype),
     $ ilimit(000:imax_btype,000:imax_stype),
     $ ivalid_st(000:imax_btype,000:imax_stype)

      COMMON /CDATA3/cred(000:imax_btype,000:imax_stype)
      COMMON /CDATA6/mnemonic(000:imax_btype,000:imax_stype)
      COMMON /CDATA2/cflag(000:imax_btype,000:imax_stype)
      COMMON /CDATA1/clong(000:imax_btype,000:imax_stype,2:5)

      COMMON /SKIPIT/skip(000:imax_btype,000:imax_stype,3,4,3)

      CHARACTER*7   redstring
      CHARACTER*6   cmnem(imax_cmnem,2,3),cavgs(imax_cavgs,2,2:5),
     $ mnemonic
      CHARACTER*3   cred
      CHARACTER*2   cflag
      CHARACTER*1   clong

      LOGICAL       skip

      INTEGER       isc(2,3),isa(2,2:5)

      isc   = 0
      isa   = 0
      istop = 0

      alimit_low = 1.0 - (real(klimit) * 0.01)
      IF(alimit_low .gt. 0) THEN
         alimit_hi = 1.0/alimit_low
      ELSE
         alimit_hi = 1000.
      END IF

      PRINT 201
  201 FORMAT('  ==> Ready to compare todays counts against current ',
     $ '30-day averages'/6x,'and to compare current 30-day averages ',
     $ 'against 30-day averages from 3-, 6-, 9- and 12-months ago'/)
      LOOP1: DO jtype = 0,imax_btype
         LOOP2: DO jsub = 0,imax_stype
            IF(mnemonic(jtype,jsub).eq.'      ')  CYCLE LOOP2
            IF(ivalid_st(jtype,jsub).eq.0) CYCLE LOOP2
            PRINT 202, jtype,jsub,mnemonic(jtype,jsub)
  202 FORMAT(' Type   ',i3.3,2x,i3.3,' "',a6,'" located in subset of ',
     $ 'todays status file')
            IF(skip(jtype,jsub,inet,icycle,3))  THEN
               PRINT 203, jtype,jsub
  203 FORMAT(4x,'--> type   ',i3.3,2x,i3.3,' not tested in any way ',
     $ 'because input data cards indicate it should be SKIPPED for ',
     $ 'this network and cycle')
            ELSEIF(iavg_ndays(jtype,jsub,1) .lt. 15)  THEN
               PRINT 204, jtype,jsub,iavg_ndays(jtype,jsub,1)
  204 FORMAT(4x,'--> type   ',i3.3,2x,i3.3,' not tested in any way ',
     $ 'because number of days that went into current 30-day average ',
     $ '(=',i3,') .lt. limit of 15')

            ELSEIF(iavg_count(jtype,jsub,1) .gt. ilimit(jtype,jsub))THEN
               IF(.not.skip(jtype,jsub,inet,icycle,1))  THEN
                  ilimit_count_lo = 
     $            nint(iavg_count(jtype,jsub,1)*(iper(jtype,jsub)*0.01))
                  IF(iper(jtype,jsub) .gt. 0) THEN
                     per_hi=100./iper(jtype,jsub)
                  ELSE
                     per_hi=1000.
                  END IF
                  ilimit_count_hi= nint(iavg_count(jtype,jsub,1)*per_hi)
                  IF(icur_count(jtype,jsub).lt.ilimit_count_lo)  THEN
                     IF(cred(jtype,jsub).eq.'RED') then
                        isc(1,3) = isc(1,3) + 1
                        IF(isc(1,3) .lt. 28) cmnem(isc(1,3),1,3) =
     $                   mnemonic(jtype,jsub)
                        istop = max(istop,6)
                        cflag(jtype,jsub) = '**'
                        redstring = ' !!RED!'
                        PRINT 205, mnemonic(jtype,jsub),
     $                   icur_count(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1)
  205 FORMAT(3x,125('#')/3x,'*****>  !! R E D !!  DEFICIENCY in ',
     $ 'CRITICAL data type: "',a6,'"; Todays count : ',i7,', Average/#',
     $ ' days : ',i7,'/',i3,' ###'/3x,125('#'))
                     ELSE  IF(cred(jtype,jsub).eq.'grn') then
                        isc(1,1) = isc(1,1) + 1
                        IF(isc(1,1) .lt. 28) cmnem(isc(1,1),1,1) =
     $                   mnemonic(jtype,jsub)
                        istop = max(istop,4)
                        cflag(jtype,jsub) = ' +'
                        redstring = ' green'
                        PRINT 4206, mnemonic(jtype,jsub),
     $                   icur_count(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1)
 4206 FORMAT(3x,115('#')/3x,'*****>  Deficiency in non-critical data ',
     $ 'type: "',a6,'"; Todays count : ',i7,', Average/# days : ',i7,
     $ '/',i3,' ###'/3x,115('#'))
                     ELSE
                        isc(1,2) = isc(1,2) + 1
                        IF(isc(1,2) .lt. 28) cmnem(isc(1,2),1,2) =
     $                   mnemonic(jtype,jsub)
                        istop = max(istop,5)
                        cflag(jtype,jsub) = ' *'
                        redstring = ' yellow'
                        PRINT 206, mnemonic(jtype,jsub),
     $                   icur_count(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1)
  206 FORMAT(3x,121('#')/3x,'*****> DEFICIENCY in moderately-critical ',
     $ 'data type: "',a6,'"; Todays count : ',i7,', Average/# days : ',
     $ i7,'/',i3,' ###'/3x,121('#'))
                     END IF
                     WRITE(52,207) mnemonic(jtype,jsub),
     $                icur_count(jtype,jsub),iper(jtype,jsub),
     $                iavg_count(jtype,jsub,1),redstring
  207 FORMAT('DATACOUNT-deficiency in type ',a6,';',i7,' rpts ',
     $ 'dumped, <',i3,'% of 30-day avg',i7,a7)
                  ELSE IF(icur_count(jtype,jsub).gt.ilimit_count_hi)THEN
                     isc(2,1) = isc(2,1) + 1
                     IF(isc(2,1) .lt. 28) cmnem(isc(2,1),2,1) =
     $                mnemonic(jtype,jsub)
                     cflag(jtype,jsub) = ' !'
                     redstring = ' '
                     IF(cred(jtype,jsub).eq.'RED') then
                        cflag(jtype,jsub) = '!!'
                        redstring = ' !!RED!'
                        PRINT 208, mnemonic(jtype,jsub),
     $                   icur_count(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1)
  208 FORMAT(3x,106('#')/3x,'*****>  !!!  R E D  !!!  ABUNDANCE  in ',
     $ 'CRITICAL data type: "',a6,'"; Todays count : ',i7,', Average/#',
     $ ' days : ',i7,'/',i3,' ###'/3x,106('#'))
                     ELSE
                        PRINT 209, mnemonic(jtype,jsub),
     $                   icur_count(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1)
  209 FORMAT(3x,90('#')/3x,'*****> ABUNDANCE  in: "',a6,'"; Todays ',
     $ 'count : ',i7,', Average/# days : ',i7,'/',i3,' ###'/3x,90('#'))
                     END IF
                     WRITE(53,210) mnemonic(jtype,jsub),
     $                icur_count(jtype,jsub),nint(per_hi*100.),
     $                iavg_count(jtype,jsub,1),redstring
  210 FORMAT('DATACOUNT-abundance  in type ',a6,';',i7,' rpts ',
     $ 'dumped, >',i3,'% of 30-day avg',i7,a7)
                  END IF
               ELSE
                  PRINT 211, jtype,jsub
  211 FORMAT(4x,'--> type   ',i3.3,2x,i3.3,'- current counts vs. ',
     $ 'current average not tested; input data cards set to SKIPPED ',
     $ 'for this network and cycle')
               END IF
               IF(.not.skip(jtype,jsub,inet,icycle,2))  THEN
                  LOOP3: DO iavg = 2,5
                     months_ago = (iavg - 1) * 3
                     iunit = 52 + iavg
                     IF(clong(jtype,jsub,iavg).ne.'Y')  CYCLE LOOP3
                     IF((iavg_count(jtype,jsub,iavg).le.
     $                   ilimit(jtype,jsub)) .or.
     $                  (iavg_ndays(jtype,jsub,iavg).le.14)) CYCLE LOOP3
                        ilimit_count_hi =
     $                   nint(iavg_count(jtype,jsub,iavg)*alimit_hi)
                        ilimit_count_lo =
     $                   nint(iavg_count(jtype,jsub,iavg)*alimit_low)
                     IF(iavg_count(jtype,jsub,1) .lt. ilimit_count_lo)
     $                THEN
                        isa(1,iavg) = isa(1,iavg) + 1
                        IF(isa(1,iavg) .lt. 28)
     $                   cavgs(isa(1,iavg),1,iavg)= mnemonic(jtype,jsub)
                        PRINT 212, mnemonic(jtype,jsub),klimit,
     $                   months_ago,iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1),
     $                   iavg_count(jtype,jsub,iavg),
     $                   iavg_ndays(jtype,jsub,iavg)
  212 FORMAT(3x,125('#')/3x,'=-LO-====> AVG for: "',a6,'" is >',i2,'% ',
     $'BELOW AVG FROM ',i2,'-MOS AGO; Avg/# days : Current:',i7,'/',i3,
     $ '; Previous:',i7,'/',i3,' ###'/3x,125('#'))
                        WRITE(IUNIT,213) mnemonic(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),klimit,months_ago,
     $                   iavg_count(jtype,jsub,iavg)
  213 FORMAT('DATACOUNT-Avg for ',a6,' (',i7,') is >',i2,'% BELOW ',
     $ 'avg from ',i2,' mnths ago (',i7,')')
                     ELSE  IF(iavg_count(jtype,jsub,1) .gt.
     $                        ilimit_count_hi)  THEN
                        isa(2,iavg) = isa(2,iavg) + 1
                        IF(isa(2,iavg) .lt. 28)
     $                   cavgs(isa(2,iavg),2,iavg)= mnemonic(jtype,jsub)
                        PRINT 214, mnemonic(jtype,jsub),klimit,
     $                   months_ago,iavg_count(jtype,jsub,1),
     $                   iavg_ndays(jtype,jsub,1),
     $                   iavg_count(jtype,jsub,iavg),
     $                   iavg_ndays(jtype,jsub,iavg)
  214 FORMAT(3x,125('#')/3x,'=-HI-====> AVG for: "',a6,'" is >',i2,'% ',
     $'above AVG FROM ',i2,'-MOS AGO; Avg/# days : Current:',i7,'/',i3,
     $ '; Previous:',i7,'/',i3,' ###'/3x,125('#'))
                        WRITE(IUNIT,215) mnemonic(jtype,jsub),
     $                   iavg_count(jtype,jsub,1),klimit,months_ago,
     $                   iavg_count(jtype,jsub,iavg)
  215 FORMAT('DATACOUNT-Avg for ',a6,' (',i7,') is >',i2,'% above ',
     $ 'avg from ',i2,' mnths ago (',i7,')')
                     END IF
                  END DO LOOP3
               ELSE
                  PRINT 216, jtype,jsub
  216 FORMAT(4x,'--> type   ',i3.3,2x,i3.3,'- current average vs. ',
     $ 'previous average not tested; input data cards set to SKIPPED ',
     $ 'for this network & cycle')
               END IF
            ELSE
               IF(iavg_count(jtype,jsub,1).gt.-1)  THEN
                  PRINT 217, jtype,jsub,iavg_count(jtype,jsub,1),
     $             iavg_ndays(jtype,jsub,1),ilimit(jtype,jsub)
  217 FORMAT(4x,'--> type   ',i3.3,2x,i3.3,' not tested in any way ',
     $ 'because current 30-day average {=',i6,' (over',i3,' days)} ',
     $ '.lt. limit of',i6)
               ELSE
                  PRINT 218, jtype,jsub
  218 FORMAT(4x,'--> type   ',i3.3,2x,i3.3,' not tested in any way ',
     $ 'because current 30-day average is not available')
               END IF
            END IF
         END DO LOOP2
      END DO LOOP1

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    BLOCK DATA  INITIALIZES COMMON BLOCK PARAMETERS
C   PRGMMR: KEYSER           ORG: NP22       DATE: 2000-09-21
C
C ABSTRACT: INITIALIZES COMMON BLOCK PARAMETERS.
C
C PROGRAM HISTORY LOG:
C   UNKNOWN
C 2000-09-21  D. A. KEYSER -- ORIGINAL AUTHOR
C                "FWINDO(5)" FROM 300. TO 600.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM-SP
C
C$$$
      BLOCK DATA

      PARAMETER (IMAX_BTYPE=255)
      PARAMETER (IMAX_STYPE=255)

      PARAMETER (IMAX_BS_TYPE=(IMAX_BTYPE + 1) * (IMAX_STYPE + 1))
      PARAMETER (IMAX_BS_TYPE_AVG=(IMAX_BS_TYPE * 5))
      PARAMETER (IMAX_BS_TYPE_LONG=(IMAX_BS_TYPE * 4))
      PARAMETER (IMAX_BS_TYPE_SKIP=(IMAX_BS_TYPE * 36))
      PARAMETER (IMAX_BS_TYPE_WEEKEND=(IMAX_BS_TYPE * 48))

      COMMON /DATA/iavg_count(000:imax_btype,000:imax_stype,5),
     $ iavg_ndays(000:imax_btype,000:imax_stype,5),
     $ icur_count(000:imax_btype,000:imax_stype),
     $ iper(000:imax_btype,000:imax_stype),
     $ ilimit(000:imax_btype,000:imax_stype),
     $ ivalid_st(000:imax_btype,000:imax_stype)

      COMMON /CDATA6/mnemonic(000:imax_btype,000:imax_stype)
      COMMON /CDATA3/cred(000:imax_btype,000:imax_stype)
      COMMON /CDATA2/cflag(000:imax_btype,000:imax_stype)
      COMMON /CDATA1/clong(000:imax_btype,000:imax_stype,2:5)

      COMMON /SKIPIT/skip(000:imax_btype,000:imax_stype,3,4,3)
      COMMON /WKENDS/week_end(000:imax_btype,000:imax_stype,3,4,4)

      CHARACTER*6   mnemonic
      CHARACTER*3   cred
      CHARACTER*2   cflag
      CHARACTER*1   clong

      LOGICAL       skip,week_end

      DATA  iavg_count/imax_bs_type_avg*-9999999/,
     $      iavg_ndays/imax_bs_type_avg*0/,
     $      icur_count/imax_bs_type*0/,
     $      iper/imax_bs_type*0/,ilimit/imax_bs_type*0/,
     $      ivalid_st/imax_bs_type*0/

      DATA  mnemonic  /imax_bs_type*'      '/
      DATA  cred      /imax_bs_type*'   '/
      DATA  cflag     /imax_bs_type*'  '/
      DATA  clong     /imax_bs_type_long*'N'/

      DATA  skip      /imax_bs_type_skip*.FALSE./

      DATA  week_end  /imax_bs_type_weekend*.FALSE./

      END

!
!   Author: Suranjana Saha
c--------------------------------------------------------------------------
c     the mnemonic tables are in /nwprod/prepobs/ucl/prep.bufrtable
c---------------------------------------------------------------------------
       CHARACTER*1   kdbug,kdbuga,kall,kmas,kwnd
       CHARACTER*255 infile,outfile
       CHARACTER*10  kst
       CHARACTER*6   catname
       CHARACTER*8   klonw,klone,klatn,klats,kdhr
       CHARACTER*2   kchr
       real(8) bmiss

       bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

       call getenv("idbug",kdbug)
       read(kdbug,'(i1)') idbug
       write(*,*) "idbug= ",idbug
c
       call getenv("idbuga",kdbuga)
       read(kdbuga,'(i1)') idbuga
       write(*,*) "idbuga= ",idbuga
c
       call getenv("iall",kall)
       read(kall,'(i1)') iall
       write(*,*) "iall= ",iall
C
       call getenv("iwnd",kwnd)
       read(kwnd,'(i1)') iwnd
       write(*,*) "iwnd= ",iwnd
C
       call getenv("imas",kmas)
       read(kmas,'(i1)') imas
       write(*,*) "imas= ",imas
C
       call getenv("fchr",kchr)
       read(kchr,'(i2)') ichr
       fchr=float(ichr)
       write(*,*) "fchr= ",fchr
C
       call getenv("fdhr",kdhr)
       read(kdhr,'(f8.1)') fdhr
       write(*,*) "fdhr= ",fdhr
c
       call getenv("nst",kst)
       read(kst,'(i10)') nst
       write(*,*) "nst= ",nst
c
       call getenv("infile",infile)
       write(*,*) "infile= ",infile
c
       call getenv("outfile",outfile)
       write(*,*) "outfile= ",outfile
c
       call getenv("catname",catname)
       write(*,*) "catname= ",catname
c
       call getenv("flonw",klonw)
       read(klonw,'(f8.1)') flonw
       write(*,*) "flonw= ",flonw
c
       call getenv("flone",klone)
       read(klone,'(f8.1)') flone
       write(*,*) "flone= ",flone
c
       call getenv("flatn",klatn)
       read(klatn,'(f8.1)') flatn
       write(*,*) "flatn= ",flatn
c
       call getenv("flats",klats)
       read(klats,'(f8.1)') flats
       write(*,*) "flats= ",flats
c
       if(flonw.lt.0.) flonw=360.+flonw
       if(flone.lt.0.) flone=360.+flone
c
       fhrs=fchr-fdhr
       fhre=fchr+fdhr
c
       print *,fchr,fdhr,fhrs,fhre
       call stats(infile,outfile,catname,flonw,flone,flatn,flats,
     * idbug,idbuga,iall,nst,fhrs,fhre,imas,iwnd)
c
       stop
       end
       subroutine stats(infile,outfile,catname,flonw,flone,flatn,flats,
     * idbug,idbuga,iall,nst,fhrs,fhre,imas,iwnd)
c
       CHARACTER*80 HSTR,PSTR,ZSTR,TSTR,QSTR,USTR,VSTR
       CHARACTER*8  SUBSET
C
       character*8   tstn(nst),stnidc,id
       CHARACTER*255 infile,outfile
c
       CHARACTER*10 indate
       CHARACTER*8  STNID,idj,idi
       CHARACTER*6  catname
       CHARACTER*1  labn
C
       real(8)    HDR(14)
       EQUIVALENCE  (HDR(1),STNID)
       real(8)    POB(4),ZOB(4),TOB(4),QOB(4)
       real(8)    UOB(4),VOB(4)
       DIMENSION    PPR(4),ZPR(4),TPR(4),QPR(4)
       DIMENSION    UPR(4),VPR(4)
       DIMENSION    tlon(nst),tlat(nst),thr(nst),typ(nst),elvt(nst)
       DIMENSION    typint(nst)
       DIMENSION    mmfill(nst),mwfill(nst)
C
       DIMENSION BL(nst)
       DIMENSION PO(nst),PA(nst),PF(nst),PQ(nst)
       DIMENSION ZO(nst),ZA(nst),ZF(nst),ZQ(nst)
       DIMENSION TO(nst),TA(nst),TF(nst),TQ(nst)
       DIMENSION QO(nst),QA(nst),QF(nst),QQ(nst)
       DIMENSION UO(nst),UA(nst),UF(nst),WQ(nst)
       DIMENSION VO(nst),VA(nst),VF(nst)
c
       DATA HSTR
     ./'SID XOB YOB DHR ELV TYP T29 ITP SQN RQM DUP PRG SRC RUD'/
C
       DATA STNID/'        '/
c
c...   get the ob, guess, analysis and quality mark ....
       DATA PSTR /'POB PAN PFC PQM'/
c...   mean-sea-level pressure instead of height
       DATA ZSTR /'PMO PAN PFC PMQ'/
c      DATA ZSTR /'ZOB ZAN ZFC ZQM'/
       DATA TSTR /'TOB TAN TFC TQM'/
       DATA QSTR /'QOB QAN QFC QQM'/
       DATA USTR /'UOB UAN UFC WQM'/
       DATA VSTR /'VOB VAN VFC WQM'/
C
       DATA BMISS /10E10/
       DATA rmiss /99999./
       DATA LUNIN /11/
C----------------------------------------------------
       indate='          '
c
       print *,' infile ',infile
       print *,' outfile ',outfile
       print *,' flonw ',flonw
       print *,' flone ',flone
       print *,' flatn ',flatn
       print *,' flats ',flats
       iodd=0
       if(flonw.gt.flone) then
       iodd=1
       flone=flone+360.
       print *,' iodd ',iodd
       print *,' flone ',flone
       endif
c
       open(11,file=infile,form='unformatted')
c
C  INITIALIZE
C  ----------
       DO IST=1,nst
       PO(IST)   = bmiss
       ZO(IST)   = bmiss
       TO(IST)   = bmiss
       QO(IST)   = bmiss
       UO(IST)   = bmiss
       VO(IST)   = bmiss
       PA(IST)   = bmiss
       ZA(IST)   = bmiss
       TA(IST)   = bmiss
       QA(IST)   = bmiss
       UA(IST)   = bmiss
       VA(IST)   = bmiss
       PF(IST)   = bmiss
       ZF(IST)   = bmiss
       TF(IST)   = bmiss
       QF(IST)   = bmiss
       UF(IST)   = bmiss
       VF(IST)   = bmiss
       PQ(IST)   = bmiss
       ZQ(IST)   = bmiss
       TQ(IST)   = bmiss
       QQ(IST)   = bmiss
       WQ(IST)   = bmiss
       BL(IST)   = bmiss
       mmfill(IST)   = 0
       mwfill(IST)   = 0
       ENDDO
C
       nvar=0
       if((imas.eq.1).and.(iwnd.eq.1)) nvar=1
c
       CALL DATELEN(10)
       CALL OPENBF(LUNIN,'IN ',LUNIN)
c
       IST=0
!      DO WHILE(IREADFT(LUNIN,SUBSET,IDATE).EQ.0)
       DO WHILE(IREADMG(LUNIN,SUBSET,IDATE).EQ.0)
       write(indate,'(i10)') idate
c
c... look for only upper-air data... if you want anything else, the
c    following headers can be used :
c
c    ADPSFC SFCSHP  AIRCFT AIRCAR SATWND UPABOG 
c    SFCBOG SATEMP SATBOG SYNDAT PROFLR SPSSMI
c
       IF(SUBSET.EQ.catname) THEN
C
         DO WHILE(IREADSB(LUNIN).EQ.0)
c
           CALL UFBINT(LUNIN,HDR,14,  1,NLEV,HSTR)
c
           flon=hdr(2)
           flat=hdr(3)
           hr=hdr(4)
           elvx=hdr(5)
           typx=hdr(6)
           kkx = idint(hdr(6)*.01)
           typintx=hdr(8)
c
       if((nvar.eq.0).and.(imas.eq.1).and.(kkx.ne.1)) go to 443
       if((nvar.eq.0).and.(iwnd.eq.1).and.(kkx.ne.2)) go to 443
c
c... check for window hour...
       hrx=hr*10.
       fhrsx=fhrs*10.
       fhrex=fhre*10.
           if((hrx.ge.fhrsx).and.(hrx.lt.fhrex)) then
c
c... look for all stations inside the lat/lon box specified...
c
       flonx=flon
       if((iodd.eq.1).and.(flonx.lt.flonw)) flonx=flonx+360.
c
       if((flonx.ge.flonw).and.(flonx.le.flone).and.
     *    (flat.le.flatn).and.(flat.ge.flats)) then
c
c...  first time....
       if(ist.eq.0) then
       IST=IST+1
       tstn(IST)=stnid
       tlon(IST)=flon
       tlat(IST)=flat
       thr(IST)=hr
       elvt(IST)=elvx
       typint(IST)=typintx
       if(kkx.eq.1) then
       typ(IST)=typx-100
       else
       typ(IST)=typx-200
       endif
       go to 10
       endif
c
c..   check for unique station....
       if(nvar.eq.1) then
       do n=1,ist
       dlon=abs(flon-tlon(n))
       dlat=abs(flat-tlat(n))
       dthr=abs(hr-thr(n))
       if((dlat.le.0.01).and.(dlon.le.0.01).and.(dthr.le.0.001)) then
       mmf=mmfill(n)
       mwf=mwfill(n)
c
c...  check if both wind and mass report have been read..
       if((mmf.eq.1).and.(mwf.eq.1)) go to 443
       if((mmf.eq.0).and.(mwf.eq.0)) go to 11
       if((mmf.eq.1).or.(mwf.eq.1))  go to 10
c
       endif
       enddo
       endif
c
c...  if not, then add a new station....
 11    continue
       IST=IST+1
       if(ist.gt.nst) then
       print *,'number of stations exceeded'
       print *,'increase number to more than ',nst
       go to 1555
       endif
       tstn(IST)=stnid
       tlon(IST)=flon
       tlat(IST)=flat
       thr(IST)=hr
       elvt(IST)=elvx
       typint(IST)=typintx
       if(kkx.eq.1) then
       typ(IST)=typx-100
       else
       typ(IST)=typx-200
       endif
c
 10    continue
       CALL UFBINT(LUNIN,POB, 4,1,NLEV,PSTR)
       PO(IST)=POB(1)
       PA(IST)=POB(2)
       PF(IST)=POB(3)
       PQ(IST)=POB(4)
c
       if((kkx.eq.1).and.(imas.eq.1)) then
       mmfill(ist)=1
c
       do nn=1,4
       pob(nn)=bmiss
       zob(nn)=bmiss
       tob(nn)=bmiss
       qob(nn)=bmiss
       ppr(nn)=bmiss
       zpr(nn)=bmiss
       tpr(nn)=bmiss
       qpr(nn)=bmiss
       enddo
c
       CALL UFBINT(LUNIN,ZOB, 4,1,NLEV,ZSTR)
       CALL UFBINT(LUNIN,TOB, 4,1,NLEV,TSTR)
       CALL UFBINT(LUNIN,QOB, 4,1,NLEV,QSTR)
c
       do i=1,4
       if(zob(i).ne.bmiss) zpr(i)=zob(i)
       if(zpr(i).gt.rmiss) zpr(i)=bmiss
       if(tob(i).ne.bmiss) tpr(i)=tob(i)
       if(tpr(i).gt.rmiss) tpr(i)=bmiss
       if(qob(i).ne.bmiss) qpr(i)=qob(i)
       if(qpr(i).gt.rmiss) qpr(i)=bmiss
       enddo
c
       ZO(IST) =  ZPR(1)
       ZQ(IST) =  ZPR(4)
       TQ(IST) =  TPR(4)
       QQ(IST) =  QPR(4)
c
       TO(IST) =  TPR(1)
       QO(IST) =  QPR(1)
       if(TO(IST).ne.bmiss) TO(IST) =  TO(IST)+273.159
       IF(QO(IST).ne.bmiss) QO(IST) =  QO(IST)*1.E-3
       TV =  TO(IST)
       Q  =  QO(IST)
       if(Q.ne.bmiss) Q=Q*1.E-3
       if((Q.ne.bmiss).and.(TV.ne.bmiss)) TO(IST)=TV/(1.+.608*Q)
c
       if(iall.eq.1) then
       ZA(IST) =  ZPR(2)
       ZF(IST) =  ZPR(3)
c
       TA(IST) =  TPR(2)
       QA(IST) =  QPR(2)
       if(TA(IST).ne.bmiss) TA(IST) =  TA(IST)+273.159
       IF(QA(IST).ne.bmiss) QA(IST) =  QA(IST)*1.E-3
       TV = TA(IST)
       Q = QA(IST)
       if(Q.ne.bmiss) Q=Q*1.E-3
       if((Q.ne.bmiss).and.(TV.ne.bmiss)) TA(IST)=TV/(1.+.608*Q)
c
       TF(IST) =  TPR(3)
       QF(IST) =  QPR(4)
       if(TF(IST).ne.bmiss) TF(IST) =  TF(IST)+273.159
       IF(QF(IST).ne.bmiss) QF(IST) =  QF(IST)*1.E-3
       TV =  TF(IST)
       Q  =  QF(IST)
       if(Q.ne.bmiss) Q=Q*1.E-3
       if((Q.ne.bmiss).and.(TV.ne.bmiss)) TF(IST)=TV/(1.+.608*Q)
       endif
c
       if(idbug.eq.1) then
       pval=po(ist)
       typx=typ(ist)+100
       if(iall.eq.1) then
       write(6,611) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,zo(ist),za(ist),zf(ist),zq(ist)
       write(6,612) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,to(ist),ta(ist),tf(ist),tq(ist)
       write(6,613) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,qo(ist),qa(ist),qf(ist),qq(ist)
       else
       write(6,711) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,zo(ist),zq(ist)
       write(6,712) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,to(ist),tq(ist)
       write(6,713) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,qo(ist),qq(ist)
       endif
       endif
c
       endif
c
c... now for wind report...
       if((kkx.eq.2).and.(iwnd.eq.1)) then
       mwfill(ist)=1
c
       do nn=1,4
       uob(nn)=bmiss
       vob(nn)=bmiss
       upr(nn)=bmiss
       vpr(nn)=bmiss
       enddo
c
       CALL UFBINT(LUNIN,UOB, 4,1,NLEV,USTR)
       CALL UFBINT(LUNIN,VOB, 4,1,NLEV,VSTR)
c
       do i=1,4
       if(uob(i).ne.bmiss) upr(i)=uob(i)
       if(upr(i).gt.rmiss) upr(i)=bmiss
       if(vob(i).ne.bmiss) vpr(i)=vob(i)
       if(vpr(i).gt.rmiss) vpr(i)=bmiss
       enddo
c
       UO(IST) =  UPR(1)
       WQ(IST) =  UPR(4)
       VO(IST) =  VPR(1)
c
       if(iall.eq.1) then
       UA(IST) =  UPR(2)
       UF(IST) =  UPR(3)
       VA(IST) =  VPR(2)
       VF(IST) =  VPR(3)
       endif
c
       if(idbug.eq.1) then
       pval=po(ist)
       typx=typ(ist)+200
       if(iall.eq.1) then
       write(6,614) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,uo(ist),ua(ist),uf(ist),wq(ist)
       write(6,615) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,vo(ist),va(ist),vf(ist)
       else
       write(6,714) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,uo(ist),wq(ist)
       write(6,715) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pval,vo(ist)
       endif
       endif
c
       endif
c
c... end lat/lon box section
       endif
c
c... end window-hour section
       endif
c
 443   continue
c
       ENDDO
c
c...  end report section
       endif
C
       ENDDO
c
 1555  continue
       nstns=IST
       print *,indate,' number of stations ',nstns
       if(nstns.gt.0) then
c
       open(51,file=outfile,form='unformatted')
c
c.... get unique station ids...
c
c      do j=1,nstns
c      n=0
c      idj=tstn(j)
c      do i=j+1,nstns
c      idi=tstn(i)
c      if(idj.eq.idi) then
c      n=n+1
c      write(labn,'(i1)') n
c      idi(6:6)=labn
c      tstn(i)=idi
c      endif
c      enddo
c      enddo
c
c....  write grads data out...
c
       do ist=1,nstns
c
       id=tstn(ist)
       rlon=tlon(ist)
       rlat=tlat(ist)
       hr=thr(ist)
       iflag=1
       nl=1
c      id(7:7)=' '
c      id(8:8)='\0'
c
       rt=0.0
       write(51) id,rlat,rlon,rt,nl,iflag
c
c... to plot mslp and ps to meaningful digits...
c      if(po(ist).ne.bmiss) then
c      if(po(ist).lt.1000.) then
c      diff=po(ist)-900.
c      else
c      diff=po(ist)-1000.
c      endif
c      po(ist)=10.*diff
c      endif
c      if(zo(ist).ne.bmiss) then
c      if(zo(ist).lt.1000.) then
c      diff=zo(ist)-900.
c      else
c      diff=zo(ist)-1000.
c      endif
c      zo(ist)=10.*diff
c      endif
c
       if(iall.eq.1) then
       if((imas.eq.1).and.(iwnd.eq.1)) then
       write(51) typ(ist),typint(ist),elvt(ist),
     *           po(ist),pa(ist),pf(ist),pq(ist),
     *           zo(ist),za(ist),zf(ist),zq(ist),
     *           to(ist),ta(ist),tf(ist),tq(ist),
     *           qo(ist),qa(ist),qf(ist),qq(ist),
     *           uo(ist),ua(ist),uf(ist),wq(ist),
     *           vo(ist),va(ist),vf(ist),bl(ist)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       write(6,411) indate,hr,po(ist),pa(ist),pf(ist),pq(ist),
     *              zo(ist),za(ist),zf(ist),zq(ist),
     *              to(ist),ta(ist),tf(ist),tq(ist),
     *              qo(ist),qa(ist),qf(ist),qq(ist),
     *              uo(ist),ua(ist),uf(ist),wq(ist),
     *              vo(ist),va(ist),vf(ist)
       endif
       endif
       if((imas.eq.1).and.(iwnd.eq.0)) then
       write(51) typ(ist),typint(ist),elvt(ist),
     *           po(ist),pa(ist),pf(ist),pq(ist),
     *           zo(ist),za(ist),zf(ist),zq(ist),
     *           to(ist),ta(ist),tf(ist),tq(ist),
     *           qo(ist),qa(ist),qf(ist),qq(ist),bl(ist)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       write(6,412) indate,hr,po(ist),pa(ist),pf(ist),pq(ist),
     *              zo(ist),za(ist),zf(ist),zq(ist),
     *              to(ist),ta(ist),tf(ist),tq(ist),
     *              qo(ist),qa(ist),qf(ist),qq(ist)
       endif
       endif
       if((imas.eq.0).and.(iwnd.eq.1)) then
       write(51) typ(ist),elvt(ist),
     *           po(ist),pa(ist),pf(ist),pq(ist),
     *           uo(ist),ua(ist),uf(ist),wq(ist),
     *           vo(ist),va(ist),vf(ist),bl(ist)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       write(6,413) indate,hr,po(ist),pa(ist),pf(ist),pq(ist),
     *              uo(ist),ua(ist),uf(ist),wq(ist),
     *              vo(ist),va(ist),vf(ist)
       endif
       endif
c
       else
c
       if((imas.eq.1).and.(iwnd.eq.1)) then
       write(51) typ(ist),typint(ist),elvt(ist),
     *           po(ist),pq(ist),
     *           zo(ist),zq(ist),
     *           to(ist),tq(ist),
     *           qo(ist),qq(ist),
     *           uo(ist),wq(ist),
     *           vo(ist),bl(ist)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       write(6,511) indate,hr,po(ist),pq(ist),
     *              zo(ist),zq(ist),
     *              to(ist),tq(ist),
     *              qo(ist),qq(ist),
     *              uo(ist),wq(ist),
     *              vo(ist)
       endif
       endif
       if((imas.eq.1).and.(iwnd.eq.0)) then
       write(51) typ(ist),elvt(ist),
     *           po(ist),pq(ist),
     *           zo(ist),zq(ist),
     *           to(ist),tq(ist),
     *           qo(ist),qq(ist),bl(ist)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       write(6,512) indate,hr,po(ist),pq(ist),
     *              zo(ist),zq(ist),
     *              to(ist),tq(ist),
     *              qo(ist),qq(ist)
       endif
       endif
       if((imas.eq.0).and.(iwnd.eq.1)) then
       write(51) typ(ist),typint(ist),elvt(ist),
     *           po(ist),pq(ist),
     *           uo(ist),wq(ist),
     *           vo(ist),bl(ist)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       write(6,513) indate,hr,po(ist),pq(ist),
     *              uo(ist),wq(ist),
     *              vo(ist)
       endif
       endif
c
       endif
c
c... end station-loop
        enddo
c
c..  write footer to end this time level
       id='       '
       rlat=0.
       rlon=0.
       rt=0.
       nl=0
       iflag=0
       write(51) id,rlat,rlon,rt,nl,iflag
c
       close(51)
       endif
c
       close(11)
       CALL CLOSBF(LUNIN)
c
 411   format(a10,1x,f5.2,1x,f5.0,' mb ',1x,f5.0,1x,f5.0,1x,f3.0,1x,
     *        4(3e10.2,1x,f3.0,/),3e10.2)
 412   format(a10,1x,f5.2,1x,f5.0,' mb ',1x,f5.0,1x,f5.0,1x,f3.0,1x,
     *        3(3e10.2,1x,f3.0,/))
 413   format(a10,1x,f5.2,1x,f5.0,' mb ',1x,f5.0,1x,f5.0,1x,f3.0,1x,
     *        3e10.2,1x,f3.0,/,3e10.2)
c
 511   format(a10,1x,f5.2,1x,f5.0,' mb ',1x,f3.0,1x,
     *        4(e10.2,1x,f3.0),1x,e10.2)
 512   format(a10,1x,f5.2,1x,f5.0,' mb ',1x,f3.0,1x,
     *        3(e10.2,1x,f3.0))
 513   format(a10,1x,f5.2,1x,f5.0,' mb ',1x,f3.0,1x,
     *        e10.2,1x,f3.0,1x,e10.2)
c
 611   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'z',1x,f5.0,1x,3f10.2,1x,'qf ',f4.0)
 612   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'t',1x,f5.0,1x,3f10.2,1x,'qf ',f4.0)
 613   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'q',1x,f5.0,1x,3f10.2,1x,'qf ',f4.0)
 614   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'u',1x,f5.0,1x,3f10.2,1x,'qf ',f4.0)
 615   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'v',1x,f5.0,1x,3f10.2)
c
 711   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'z',1x,f5.0,1x,f10.2,1x,'qf ',f4.0)
 712   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'t',1x,f5.0,1x,f10.2,1x,'qf ',f4.0)
 713   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'q',1x,f5.0,1x,f10.2,1x,'qf ',f4.0)
 714   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'u',1x,f5.0,1x,f10.2,1x,'qf ',f4.0)
 715   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'v',1x,f5.0,1x,f10.2)
c
       return
       end
C-----------------------------------------------------------------------
       INTEGER FUNCTION nfill(C)
       CHARACTER*(*) C
       NFILL=LEN(C)
       DO 1 J=1,NFILL
       IF(C(J:J).EQ.' ') THEN
       NFILL=J-1
       RETURN
       ENDIF
 1     CONTINUE
       RETURN
       END

C-----------------------------------------------------------------------
C  SUBROUTINE HTERPTZ - 4D LINEAR INTERPOLATION IN X,Y,Z,T
C-----------------------------------------------------------------------
C  GRID IS EXPECTED to be ORIENTED EAST/WEST AND SOUTH/NORTH.
C-----------------------------------------------------------------------
      SUBROUTINE HTERPTZ(XOB,YOB,DHR,DZ,GRID,XTRP)

      USE GBLEVN_MODULE
 
      INTEGER  IBK
      REAL     GRID(IMAX,JMAX,KMAX,NBAK)
      REAL     XOB,YOB,DHR,DZ,BAK1,BAK2,ATRP,BTRP,XTRP
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

C  CALCULATE interpolation parameters for x,y,z,t
C  ----------------------------------------------

      WX = XOB/DLON + 1.0
      I0 = WX
      I1 = MOD(I0,IMAX) + 1
      WX = WX-I0

      WY=YOB;CALL GRDCRD(WY,1,SLATS,JMAX,1)
      J0 = WY
      J1 = MIN(J0+1,JMAX)
      WY = WY-J0

      L1=DZ;L2=MIN(L1+1,KMAX);WZ=DZ-L1

      CALL TTERP(DHR,IBK,TWT)

c  interpolate from grid in x,y,t,z       
c  --------------------------------

      DO L=L1,L2 
      DO I=IBK,IBK+1; N=MIN(I,NBAK)
      P1 = GRID(I0,J0,L,N)
      P2 = GRID(I0,J1,L,N)
      P3 = GRID(I1,J0,L,N)
      P4 = GRID(I1,J1,L,N)
      P5 = P1+(P2-P1)*WY
      P6 = P3+(P4-P3)*WY
      IF(I==IBK) BAK1 = P5 + (P6-P5)*WX
      IF(I/=IBK) BAK2 = P5 + (P6-P5)*WX
      ENDDO    
      IF(L==L1) ATRP=BAK1+(BAK2-BAK1)*TWT
      IF(L/=L1) BTRP=BAK1+(BAK2-BAK1)*TWT
      ENDDO    

      XTRP = ATRP+(BTRP-ATRP)*WZ

      RETURN
      END
c------------------------------------------------------------------
c------------------------------------------------------------------
      function pilnlnpw(p,paray,kmax)

      dimension paray(kmax)

      do 10 la=1,kmax
      if(p>=paray(la)) goto 11
10    continue
11    if(la>kmax) then
         la = kmax
         lb = kmax
      else if(la==1) then
         la = 1
         lb = 1
      else
         lb = la-1
      endif
      pa = paray(la)
      pb = paray(lb)
      if(pa/=pb) then
         wk = log(p/pb) / log(pa/pb)
      else
         wk = 0.
      endif
      pilnlnpw = float(lb)+wk

      return
      end
c------------------------------------------------------------------
c------------------------------------------------------------------
      function zilnlnpw(z,zaray,kmax)

      dimension zaray(kmax)

      do 10 la=1,kmax
      if(z<=zaray(la)) goto 11
10    continue
11    if(la>kmax) then
         la = kmax
         lb = kmax
      else if(la==1) then
         la = 1
         lb = 1
      else
         lb = la-1
      endif
      za = zaray(la)
      zb = zaray(lb)
      if(za/=zb) then
         wk = (z-zb)/(za-zb)
      else
         wk = 0.
      endif
      zilnlnpw = float(lb)+wk                              

      return
      end
C-----------------------------------------------------------------------
C  SUBROUTINE HTERPZ - interpolate diagnostic pressure  linearly in z
C-----------------------------------------------------------------------
      subroutine hterpz(zob,zwt,zlev,ps,plev,pob) 

      use gblevn_module

      real plev(kmax),zlev(kmax),lnp

! Compute observation pressure (only used for diagnostics)
! Set indices of model levels below (k1) and above (k2) observation.


      if(zwt<=1.) then
         z1=0.0    ; p1=ps         
         z2=zlev(1); p2=plev(1)
      elseif (zwt>=kmax) then
         z1=zlev(kmax-1); p1=plev(kmax-1)
         z2=zlev(kmax);   p2=plev(kmax)
      else
         k=zwt  
         k1=min(max(1,k),kmax)
         k2=max(1,min(k+1,kmax))
         z1=zlev(k1); p1=plev(k1)
         z2=zlev(k2); p2=plev(k2)
      endif

      dz21     = z2-z1
      dlnp21   = log(p2/p1)
      dz       = zob-z1
      lnp      = log(p1)+(dlnp21/dz21)*dz
      pob      = exp(lnp)

      return
      end

C-----------------------------------------------------------------------
C  MAIN PROGRAM SURUFIT
!   Author: Suranjana Saha
C-----------------------------------------------------------------------
c   make sure when you change levels, you check pmandt and pmandb
C-----------------------------------------------------------------------
      PROGRAM SURUFIT
c
      PARAMETER (IDBUG=0,IPR=1)
      PARAMETER (NSTC=9)
      PARAMETER (NPLV=3)
      PARAMETER (NVAR=4)
      PARAMETER (NREG=1)
      PARAMETER (NSUB=1)
      PARAMETER (NBAK=2)
 
      CHARACTER*80 HDSTR,OBSTR,FCSTR,ANSTR,QMSTR,PSTR
      CHARACTER*8  SUBSET

      real(8)   HDR(14)
      real(8)   PSOB(4),PSPR(4)
      real(8)   BAK(10,255,NBAK)
      real(8)   OBS(10,255),QMS(10,255),BMISS

      real(8)   SPRS(NSTC,NPLV,NVAR,NREG,NSUB,NBAK)
      real(8)   CNTO,CNTN,RAT1,RAT2,WT1,WT2
      real(8)   PMANDB(NPLV),PMANDT(NPLV)
      real(8)   STC(NSTC,5,NBAK)

      real(4)   GDATA(NREG,NSUB)

      LOGICAL   MANDONLY,REGION
      INTEGER   INDEXV(NVAR)

      DATA HDSTR
     ./'SID XOB YOB DHR ELV TYP T29 ITP SQN RQM DUP PRG SRC RUD'/
      DATA PSTR /'POB PAN PFC PQM CAT=0'/
      DATA OBSTR/'POB QOB TOB ZOB UOB VOB'/
      DATA FCSTR/'PFC QFC TFC ZFC UFC VFC'/
      DATA ANSTR/'PAN QAN TAN ZAN UAN VAN'/
      DATA QMSTR/'PQM QQM TQM ZQM WQM CAT'/
 
      DATA BMISS /  10E10 /
      DATA RMISS / -9.99E+33 /
      DATA LUBFR/11/
      data indexv/2,3,4,1/
c...  t,z,w,q
c
      DATA PMANDB / 1000,700,300/
      DATA PMANDT /  700,300,150/
c
      bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

      levt1=pmandt(1)
      levb1=pmandb(1)
      levt2=pmandt(2)
      levb2=pmandb(2)
      levt3=pmandt(3)
      levb3=pmandb(3)
c
       CALL OPENBF(LUBFR,'IN ',LUBFR)
c
C-----------------------------------------------------------------------
 
C  ZERO THE FIT ARRAYS
C  -------------------
 
      SPRS = 0.
C  --------------------------------------
 
C  READ AND "SURU-FIT" THE PREPDA/BUFR RECORDS
C  -------------------------------------------
 
10    DO WHILE(IREADMG(LUBFR,SUBSET,IDATE).EQ.0)
c... check for subset...
      IF(ITYP(SUBSET).EQ.0) GOTO 10
11    DO WHILE(IREADSB(LUBFR).EQ.0)

c... check for acars only...
      CALL UFBINT(LUBFR,HDR,14,  1,NLEV,HDSTR)
c
c... check for region...
      XOB=hdr(2)
      YOB=hdr(3)
c
      IF(.NOT.REGION(XOB,YOB,0)) GOTO 11
 
C  READ THE DATA
C  -------------
C  GENERATE A PRESSURE LEVEL LOOKUP TABLE
      CALL UFBINT(LUBFR,OBS,10,255,NLEV,OBSTR)
      CALL UFBINT(LUBFR,BAK(1,1,1),10,255,NLFC,FCSTR)
      CALL UFBINT(LUBFR,BAK(1,1,2),10,255,NLAN,ANSTR)
      CALL UFBINT(LUBFR,QMS,10,255,NLQM,QMSTR)
c

C  CREATE AND ACCUMULATE THE STATISTICS ARRAY FOR EACH REALIZATION
C  ---------------------------------------------------------------
 
c... j  is level (21)
c... k  is variable (5)
c... ll is region (7)
c... m  is subset (1)
c... n  is background (2)
c
      POB = OBS(1,1)
      PQM = QMS(1,1)
      CAT = QMS(6,1)
C
      if(idbug.eq.1) print *,' pob ',pob,' pqm ',pqm,' cat ',cat
c
      if(pqm.le.3) then
      j=0
      if((pob.le.levb1).and.(pob.gt.levt1)) j=1
      if((pob.le.levb2).and.(pob.gt.levt2)) j=2
      if((pob.le.levb3).and.(pob.gt.levt3)) j=3

      if(j.gt.0) then
c
      STC = 0.
c... start forecast-loop
         DO IB=1,2
C
c... start variable-loop
         DO IQ=1,4
c
         IQQ = IQ+1
         IR = IQQ+1
C
         IF(QMS(IQQ,1).LE.3 .AND. IQ.LE.3 .AND. CAT.NE.4) THEN
c
            IF(IQ.EQ.1) THEN
            IF(OBS(IQQ,1).EQ.BMISS) GO TO 2234
            IF(IB.EQ.1) OBS(IQQ,1)=OBS(IQQ,1)*1.E-3
            IF(BAK(IQQ,1,IB).EQ.BMISS) GO TO 2234
            BAK(IQQ,1,IB)=BAK(IQQ,1,IB)*1.E-3
            ENDIF
c  count
            STC(1,IQ,IB) = 1.
c  f
            STC(2,IQ,IB) = BAK(IQQ,1,IB)
c  o
            STC(3,IQ,IB) = OBS(IQQ,1)
c  f * o
            STC(4,IQ,IB) = BAK(IQQ,1,IB)*OBS(IQQ,1)
c  f**2
            STC(5,IQ,IB) = BAK(IQQ,1,IB)**2
c  o**2
            STC(6,IQ,IB) = OBS(IQQ,1)**2
C
         ELSEIF(QMS(IQQ,1).LE.3 .AND. IQ.EQ.4) THEN
c  count
            STC(1,IQ,IB) = 1.
c  uf
            STC(2,IQ,IB) = BAK(IQQ,1,IB)
c  vf
            STC(3,IQ,IB) = BAK(IR,1,IB)
c  uo
            STC(4,IQ,IB) = OBS(IQQ,1)
c  vo
            STC(5,IQ,IB) = OBS(IR,1)
c  uf*uo + vf*vo
            STC(6,IQ,IB)=BAK(IQQ,1,IB)*OBS(IQQ,1)+BAK(IR,1,IB)*OBS(IR,1)
c  uf**2 + vf**2
            STC(7,IQ,IB) = BAK(IQQ,1,IB)**2 + BAK(IR,1,IB)**2
c  uo**2 + vo**2
            STC(8,IQ,IB) = OBS(IQQ,1)**2 + OBS(IR,1)**2
c  sqrt (uf**2 + vf**2) - sqrt (uo**2 + vo**2)
            STC(9,IQ,IB) = SQRT(STC(7,IQ,IB)) - SQRT(STC(8,IQ,IB))
C
         ENDIF
C
         if(idbug.eq.1) then
         if(j.eq.3) print *,' ib ',ib,' iq ',iq,' stc ',
     *              (stc(k,iq,ib),k=1,3)
         endif
c
 2234    continue
c
c... end variable-loop
         ENDDO
c... end forecast-loop
         ENDDO
 
         M = ITYP(SUBSET)
 
         if (m > 0) then
         DO N=1   ,NBAK
         DO LL=1  ,NREG
C
         IF(REGION(XOB,YOB,LL)) THEN
C
            DO K=1,NVAR
            nstat=6
            if(k.eq.nvar) nstat=9

            cnto = SPRS(1,J,K,LL,M,N) 
            SPRS(1,J,K,LL,M,N) = SPRS(1,J,K,LL,M,N) + STC(1,K,N)
            cntn = SPRS(1,J,K,LL,M,N) 

            if(cntn.gt.cnto) then
            wt1 = cnto/cntn
            wt2 = 1.-wt1
c
            DO I=2,nstat
c
            sprso = SPRS(I,J,K,LL,M,N)
            rat1 = wt1*SPRS(I,J,K,LL,M,N)
            rat2 = wt2*STC(I,K,N)
c
            SPRS(I,J,K,LL,M,N) = rat1 + rat2
            sprsn = SPRS(I,J,K,LL,M,N)
c
            if((idbug.eq.1).and.(i.eq.2)) then
            if((j.eq.4).and.(k.eq.2)) then
            if((m.eq.1).and.(n.eq.1)) then
            write(6,3000) ll,cnto,cntn,wt1,wt2,sprso,STC(I,K,N),
     *      rat1,rat2,sprsn
            endif
            endif
            endif
c
c... end stat-loop
            ENDDO
c
            endif

c... end variable-loop
            ENDDO
C
         ENDIF
c... end region-loop
         ENDDO
C
c... end forecast-loop
         ENDDO
         endif     ! if itype > 0
C
c...  only if correct qc flag
      ENDIF
c...  only if correct level
      ENDIF
 
      ENDDO
c... end subset-loop
      ENDDO
 
       CALL CLOSBF(LUBFR)

C  FINISH UP
C  ---------
C   write out grads data file...
 
      iw=50
      do ibak=1,nbak
      iw=iw+1
c
      do ivarx=1,nvar
      ivar=indexv(ivarx)
      nstat=6
      if(ivar.eq.nvar) nstat=9
      if(idbug.eq.1) print *,ibak,' ivar ',ivar,' nstat ',nstat
c
      do nst=1,nstat
c
      do iplv=1,nplv
c
      do isub=1,nsub
      do ireg=1,nreg
c
      gdata(ireg,isub)=sprs(nst,iplv,ivar,ireg,isub,ibak)
c
c... end region-loop
      enddo
c... end subset-loop
      enddo
c
      write(iw) gdata
c
      if(ipr.eq.1) then
      if(ibak.eq.1) then
      if(iplv.eq.1) then
      ilevt=pmandt(iplv)
      ilevb=pmandb(iplv)
      if(ivar.eq.1)
     *write(6,1231) ibak,nst,ilevt,ilevb,(gdata(ireg,1),ireg=1,nreg)
      if(ivar.eq.2)
     *write(6,1232) ibak,nst,ilevt,ilevb,(gdata(ireg,1),ireg=1,nreg)
      if(ivar.eq.3)
     *write(6,1233) ibak,nst,ilevt,ilevb,(gdata(ireg,1),ireg=1,nreg)
      if(ivar.eq.4)
     *write(6,1234) ibak,nst,ilevt,ilevb,(gdata(ireg,1),ireg=1,nreg)
      endif
      endif
      endif
c
c... end level-loop
      enddo
c... end stat-loop
      enddo
c
c... end variable-loop
      enddo
c
      close(iw)
c... end forecast-loop
      enddo
c
 1231  format('q fcs=',i2,2x,'stat = ',i2,2x,'lev = ',2i6,2x,7f12.2)
 1232  format('t fcs=',i2,2x,'stat = ',i2,2x,'lev = ',2i6,2x,7f12.2)
 1233  format('z fcs=',i2,2x,'stat = ',i2,2x,'lev = ',2i6,2x,7f12.2)
 1234  format('w fcs=',i2,2x,'stat = ',i2,2x,'lev = ',2i6,2x,7f12.2)
c
 3000  format('reg ',i2,' cnto ',f4.0,' cntn ',f4.0,
     *        ' wt1 ',f5.2,' wt2 ',f5.2,2x,5f12.2)
c
      PRINT'("SURUFIT PROCESSING COMPLETED")'
      STOP
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      LOGICAL FUNCTION REGION(X,Y,I)
 
      PARAMETER(NREG=1)
 
      DIMENSION X1(NREG),X2(NREG),Y1(NREG),Y2(NREG)
 
C.... X goes from east to west
C.... Y goes from south to north
c... north america
      DATA X1(1),X2(1),Y1(1),Y2(1) /235.,295.,25.,55./
c... global
c     DATA X1(2),X2(2),Y1(2),Y2(2) /0.,360.,-90.,90./
C-----------------------------------------------------------------------
 
C  CHECK FOR A VALID REGION INDEX AND BE OPTIMISTIC
C  ------------------------------------------------
 
      IF(I.LT.0.OR.I.GT.NREG) THEN
         REGION = .FALSE.
         RETURN
      ELSE
         REGION = .TRUE.
      ENDIF
 
C  SETUP THE SEARCH PARAMETERS
C  ---------------------------
 
      IF(I.EQ.0) THEN
         I1 = 1
         I2 = NREG
      ELSE
         I1 = I
         I2 = I
      ENDIF
 
C  LOOK FOR A REGION MATCH
C  -----------------------
 
      DO I0=I1,I2
      IF(Y.GE.Y1(I0) .AND. Y.LE.Y2(I0)) THEN
         IF(X1(I0).LE.X2(I0)) THEN
            IF(X.GE.X1(I0) .AND. X.LE.X2(I0)) RETURN
         ELSEIF(X1(I0).GT.X2(I0)) THEN
            IF(X.GE.X1(I0) .OR.  X.LE.X2(I0)) RETURN
         ENDIF
      ENDIF
      ENDDO
 
C  IF NO MATCH, RETURN FALSE
C  -------------------------
 
      REGION = .FALSE.
      RETURN
      END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER FUNCTION ITYP(SUBSET)
 
      PARAMETER(NSUB=1)
 
      CHARACTER*8 SUBSET,SUBTYP(1)
      DATA SUBTYP /'AIRCAR'/
C
C     CHARACTER*8 SUBSET,SUBTYP(15)
C     DATA SUBTYP /'ADPUPA','AIRCAR','AIRCFT','SATWND','PROFLR',
C    .             'VADWND','SATBOG','SATEMP','ADPSFC','SFCSHP',
C    .             'SFCBOG','SPSSMI','SYNDAT','ERS1DA','GOESND'/
 
C  LOOK FOR A MATCH TO RETURN NON-ZERO
C  -----------------------------------
 
      DO I=1,NSUB
      ITYP = I
      IF(SUBSET.EQ.SUBTYP(I)) RETURN
      ENDDO
 
C  IF NO MATCH, RETURN ZERO
C  ------------------------
 
      ITYP = 0
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    W3RTOVSUNP
C   PRGMMR: DONG             ORG: NP22        DATE: 2020-01-09
C
C ABSTRACT: READS AND UNPACKS ONE REPORT FROM INPUT RTOVS RETRIEVAL
C   BUFR (DUMP) FILE INTO SPECIFIED FORMAT. RETURNS INFORMATION IN THE
C   FORMAT DESCRIBED BELOW.  INCLUDES SOUNDING DATA ON 40 LEVELS AND
C   RTOVS RADIANCES FROM 32 CHANNELS (20 HIRS, 4 MSU, 3 SSU, AND 5
C   AVHRR CHANNELS).  ALSO, INFORMATION ABOUT THE INPUT DATA SET
C   ITSELF (NAME, CENTER DATE, DUMP TIME) IS RETURNED.
C
C PROGRAM HISTORY LOG:
C 1997-11-21  BERT B. KATZ/GSC -- ORIGINAL AUTHOR
C 1998-05-05  D.A. KEYSER/NP22 -- STREAMLINED, CORRECTED ERRORS
C 1998-06-15  D.A. KEYSER/NP22 -- MODIFIED TO READ IN LONGITUDE
C     (MNEMONIC "CLON") CORRECTLY WHETHER STORED IN DEG. E, OR IN
C     DEG. W (-) AND DEG. E (+)
C 1998-09-21  D.A. KEYSER/NP22 -- SUBROUTINE NOW Y2K AND FORTRAN 90
C      COMPLIANT
C 1999-01-20 D. A. KEYSER -- INCORPORATED BOB KISTLER'S CHANGES NEEDED
C      TO PORT THE CODE TO THE IBM SP
C 1999-11-02 D. A. KEYSER -- SATELLITE IDENTIFICATION RETURNED IN
C      ISATOB(1) IS NOW BUFR CODE TABLE VALUE; CHANGES TO MAKE CODE
C      MORE PORTABLE; SUBROUTINE RENAMED
C 2000-02-17 D. A. KEYSER -- IF DATE OF INPUT FILE IS PRIOR TO
C      7/1/1998, THEN DOES NOT USE "TOFF" TO GET FILTER FLAG (NOT
C      VALID AT THIS TIME), RATHER SETS OUTPUT FILTER FLAG TO "-99"
C      WHICH ALERTS CALLING PROGRAM TO PROCESS ONLY EVERY 4'TH
C      RETRIEVAL TO SIMULATE 250KM SAMPLING (NEEDED FOR HISTORICAL
C      CDAS RUNS)
C 2012-11-30 J. WOOLLEN   -- INITIAL PORT TO WCOSS; RESET BMISS TO A
C      VALUE (10E08) WHICH WILL NOT CAUSE INTEGER OVERFLOW WHICH CAN BE
C      UNPREDICTABLE (PRIOR BMISS VALUE WAS 10E10)
C 2013-02-14 D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS;  OBTAIN
C      VALUE OF BMISS SET IN CALLING PROGRAM VIA CALL TO BUFRLIB
C      ROUTINE GETBMISS RATHER THAN HARDWIRING IT TO 10E08 (OR 10E10);
C      USE BUFRLIB FUNCTION IBFMS TO DETERMINE IF A VARIABLE READ FROM
C      BUFR FILE IS MISSING (I.E. RETURNED AS BMISS);  USE FORMATTED
C      PRINT STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS USED
C      (WCOSS SPLITS UNFORMATTED PRINT AT 80 CHARACTERS)
C 2020-01-09  J. Dong -- In subroutine W3RTOVSUNP, changed the windowing
C      decade from 20 to 40 for cases when the year is represented by
C      2 digits instead of 4.
C
C USAGE:    CALL W3RTOVSUNP(IUNIT,IBDATE,PP,TT,QQ,CLAL,CLAM,NLEV,
C                           IRTCHN,RTRAD,NCHN,STNID,ISATOB,RSATOB,
C                           DSNAME,IDSDAT,IDSDMP_8,IERR)
C   INPUT ARGUMENT LIST:
C     IUNIT    - UNIT NUMBER OF INPUT FILE CONTAINING RETRIEVAL DATA
C              - IN BUFR FORMAT.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     IBDATE   - DATE IN SECTION 1 OF BUFR MESSAGE CONTAINING THIS
C              - RETRIEVAL (IN FORM YYYYMMDDHH)
C     PP       - PRESSURE IN MB AT RETRIEVAL LEVELS (MUST BE
C              - DIMENSIONED TO AT LEAST 40 WORDS BY CALLING PROGRAM
C              - - ONLY 40 WORDS WILL BE FILLED HERE)
C     TT       - VIRTUAL TEMPERATURE IN DEG. K AT RETRIEVAL LEVELS
C              - (MUST BE DIMENSIONED TO AT LEAST 40 WORDS BY CALLING
C              - PROGRAM - ONLY 40 WORDS WILL BE FILLED HERE)
C     QQ       - SPECIFIC HUMIDITY IN G/G AT RETRIEVAL LEVELS (MUST
C              - BE DIMENSIONED TO AT LEAST 40 WORDS BY CALLING
C              - PROGRAM - ONLY 40 WORDS WILL BE FILLED HERE)
C     CLAL     - CLOUD TOP ALBEDO IN PERCENT AT RETRIEVAL LEVELS (MUST
C              - BE DIMENSIONED TO AT LEAST 40 WORDS BY CALLING
C              - PROGRAM - ONLY 40 WORDS WILL BE FILLED HERE)
C     CLAM     - CLOUD AMOUNT AT RETRIEVAL LEVELS (C.T. 0-20-011)
C              - (MUST BE DIMENSIONED TO AT LEAST 40 WORDS BY CALLING
C              - PROGRAM - ONLY 40 WORDS WILL BE FILLED HERE)
C     NLEV     - NUMBER OF RETRIEVAL LEVELS (SHOULD ALWAYS BE 40)
C     IRTCHN   - RTOVS RADIANCE CHANNELS (NUMERIC) (MUST BE
C              - DIMENSIONED TO AT LEAST 32 WORDS BY CALLING PROGRAM -
C              - ONLY 32 WORDS WILL BE FILLED HERE)
C     RTRAD    - RTOVS RADIANCES IN DEG. K (MUST BE DIMENSIONED TO AT
C              - LEAST 32 WORDS BY CALLING PROGRAM - ONLY 32 WORDS
C              - WILL BE FILLED HERE)
C     NCHN     - NUMBER OF RADIANCE CHANNELS (SHOULD ALWAYS BE 32)
C     STNID    - STATION ID (CHAR*8)
C     ISATOB   - 11-WORD INTEGER ARRAY CONTAINING RETURNED DATA
C              - (SEE REMARKS FOR CONTENTS)
C     RSATOB   - 17-WORD REAL ARRAY CONTAINING RETURNED DATA
C              - (SEE REMARKS FOR CONTENTS)
C     DSNAME   - CHARACTER*8 DATA SET NAME (SAME FOR ALL REPORTS IN
C              - A COMMON INPUT DATA SET - SEE REMARKS FOR IERR=1)
C     IDSDAT   - INTEGER DATA SET CENTER DATE IN FORM YYYYMMDDHH (SAME
C              - FOR ALL REPORTS IN A COMMON input data set - see
C              - REMARKS FOR IERR=1)
C     IDSDMP_8 - INTEGER*8 DATA SET DUMP TIME IN FORM YYYYMMDDHHMM
C              - (SAME FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - REMARKS FOR IERR=1)
C     IERR     - ERROR RETURN CODE
C                 =  0 OBSERVATION READ AND UNPACKED INTO OUTPUT
C                        ARGUMENT LOCATIONS (SEE ABOVE).  SEE REMARKS
C                        FOR CONTENTS. NEXT CALL TO W3RTOVSUNP WILL
C                        RETURN NEXT OBSERVATION IN DATA SET.
C                 =  1 INFORMATION ABOUT THE BUFR DATASET IS RETURNED
C                        IN THE OUTPUT ARGUMENTS DSNAME, IDSDAT,
C                        IDSDMP_8 (SEE OUTPUT ARGUMENT LIST ABOVE)
C
C                        THIS SHOULD ALWAYS OCCUR AFTER THE FIRST CALL
C                        TO THIS SUBROUTINE.  NO REPORT IS UNPACKED AT
C                        THIS POINT, AND ONLY DSNAME, IDSDAT, AND
C                        IDSDMP_8 CONTAIN INFORMATION.  ALL SUBSEQUENT
C                        CALLS TO W3RTOVSUNP SHOULD RETURN THE
C                        OBSERVATIONS IN THIS DATA SET, SEQUENTIALLY,
C                        (IERR=0) UNTIL THE END OF FILE IS ENCOUNTERED
C                        (IERR=2).  THE VALUES STORED IN DSNAME,
C                        IDSDAT, AND IDSDMP_8 WILL CONTINUE TO BE
C                        RETURNED ALONG WITH EACH REPORT WHEN IERR = 0.
C                 =  2 FOR NORMAL END-OF-FILE ENCOUNTERED.
C                 = -1 FOR END-OF-FILE ON FIRST READ -- EMPTY FILE
C                 = -2 FOR INPUT BUFR FILE NOT Y2K COMPLIANT -- NO
C                        PROCESSING DONE
C                 = -3 CENTER DATE COULD NOT BE OBTAINED FROM INPUT
C                        FILE -- NO PROCESSING DONE
C
C   INPUT FILES:
C     UNIT "IUNIT" - FILE CONTAINING BUFR RTOVS DATA
C
C   OUTPUT FILES:
C     UNIT 06 - STANDARD OUTPUT PRINT
C
C   SUBPROGRAMS CALLED:
C     LIBRARY:
C       W3NCO       - W3DIFDAT
C       BUFRLIB     - DATELEN  DUMPBF   OPENBF   READMG   READSB
C                   - UFBINT   CLOSBF   GETBMISS IBFMS
C
C
C REMARKS:
C
C     CONTENTS OF OUTPUT ARGUMENT ISATOB (11 INTEGER WORDS) FOR EACH
C      RETRIEVAL:
C        WORD  1 - SATELLITE IDENTIFIER
C                                      (BUFR C.T. 0-01-007)
C        WORD  2 - PREPBUFR REPORT TYPE
C                     (=161 FOR CLEAR PATH OVER LAND)
C                     (=163 FOR CLOUDY PATH OVER LAND)
C                     (=171 FOR CLEAR PATH OVER OCEAN)
C                     (=173 FOR CLOUDY PATH OVER OCEAN)
C                     {NOTE: R. TYPE 162 (NSTAR PATH OVER LAND) AND
C                            R. TYPE 172 (NSTAR PATH OVER OCEAN)
C                            ARE NOT VALID FOR RTOVS}
C        WORD  3 - SWATH LOCATION :  1 INDICATES LEFT  LIMB OF SWATH
C                                   56 INDICATES RIGHT LIMB OF SWATH
C                           USED FOR DETERMINING DISTANCE FROM NADIR
C        WORD  4 - ORBIT NUMBER
C        WORD  5 - NESDIS LAND-SEA FLAG
C        WORD  6 - SATELLITE DATA PROCESSING TECHNIQUE
C                     (=12 FOR CLOUDY PATH)
C                     (=36 FOR CLEAR PATH)
C                     (= 4 FOR UNKNOWN PATH????)
C        WORD  7 - ROVS FILTER FLAG (=  0 FOR GOOD)
C                                   (=  1 FOR REDUNDANT)
C                                   (=-99 FOR PRIOR TO 07/01/1998)
C                   IMPORTANT: REDUNDANT RETRIEVALS ARE AT FULL 80 KM
C                              RESOLUTION; GOOD RETRIEVALS ARE AT
C                              250 KM RESOLUTION
C        WORD  8 - SUPERADIABATIC FLAG (=0 FOR NOT SUPERADIABATIC)
C                                      (.NE. 0 FOR SUPERADIABATIC)
C        WORD  9 - DAY/NIGHT QUALIFIER (=0 FOR NIGHT)
C                                      (=1 FOR DAY)
C        WORD 10 - VERTICAL SIGNIFICANCE (SAT OBSERVATION)
C                                      (BUFR C.T. 0-08-003)
C        WORD 11 - SNOW/ICE FLAGS (TERRAIN TYPE)
C                                      (BUFR C.T. 0-13-039)
C
C     CONTENTS OF OUTPUT ARGUMENT RSATOB (17 REAL WORDS) FOR EACH
C      RETRIEVAL:
C        WORD  1 - OBSERVATION TIME IN HOURS GOOD TO 0.01 HOUR.
C        WORD  2 - LATITUDE IN DEGREES (N+,S-)
C        WORD  3 - LONGITUDE IN DEGREES EAST (0.0 to 359.99)
C        WORD  4 - SURFACE HEIGHT IN METERS
C        WORD  5 - FIRST ABOVE-GROUND RTOVS PRESSURE LEVEL IN MB
C        WORD  6 - SKIN TEMPERATURE IN DEGREES K
C        WORD  7 - TOTAL PRECIPITABLE WATER IN MM
C        WORD  8 - TOTAL OZONE IN DOBSONS
C        WORD  9 - SEA SURFACE TEMPERATURE IN DEGREES K
C        WORD 10 - CLOUD-TOP PRESSURE IN MB
C        WORD 11 - SOLAR ZENITH ANGLE IN DEGREES
C        WORD 12 - SATELLITE ELEVATION IN DEGREES
C        WORD 13 - NESDIS AVERAGE NSTAR (CLOUDINESS PARAMETER)
C                   (NOTE: THIS IS NOT OF ANY USE SINCE NSTAR
C                         PATH NOT VALID FOR RTOVS
C                         = -1 FOR CLOUDY PATH
C                         = MISSING FOR CLEAR PATH)
C        WORD 14 - HIRS CHANNEL UTILIZATION FLAGS
C        WORD 15 - MSU CHANNEL UTILIZATION FLAGS
C        WORD 16 - SSU CHANNEL UTILIZATION FLAGS
C        WORD 17 - AVHRR CHANNEL UTILIZATION FLAGS
C
C FOR ALL DATA: MISSING VALUES ARE RETURNED AS XMISS (99999.) (REAL) OR
C               IMISS (99999) (INTEGER)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE W3RTOVSUNP(IUNIT,IBDATE,PP,TT,QQ,CLAL,CLAM,NLEV,
     $                      IRTCHN,RTRAD,NCHN,STNID,ISATOB,RSATOB,
     $                      DSNAME,IDSDAT,IDSDMP_8,IERR)
 
      DATA IFIRST/0/,KOUNTR/0/,ITOFF/0/

      REAL  PP(*),TT(*),QQ(*),CLAL(*),CLAM(*),RTRAD(*),RINC(5)

      INTEGER  IRTCHN(*),JDATE(5),JDUMP(5),NF(0:3),KDATE(8),LDATE(8)

      INTEGER(8) IDSDMP_8,JDUMP_8(5)

      CHARACTER*8 SUBSET,DSNAME

      CHARACTER*50 IDTSTR
      DATA IDTSTR/'SAID CLAT CLON TOFF HOUR MINU SECO FOVN ORBN SADF '/
      CHARACTER*5 IDTST2
      DATA IDTST2/'DNQL '/

      CHARACTER*50 INFSTR
      DATA INFSTR/'SOEL ELEV NSAV OZON SDPT HIRC MSUC SSUC AVHC TPWT '/
      CHARACTER*10 INFST1
      DATA INFST1/'CDTP VSAT '/

      CHARACTER*30 SRFSTR
      DATA SRFSTR/'PRES SELV LSQL TMSK SST1 TERR '/

      CHARACTER*25 RETSTR
      DATA RETSTR/'PRLC TMDB MIXR CLAL CLAM '/

      CHARACTER*10 BRTSTR
      DATA BRTSTR/'CHNM TMBR '/

      REAL(8) XIDENT_8(11),XINFO_8(12),SRFDAT_8(6),RETDAT_8(5,40),
     $        BRTDAT_8(2,32),AMAXIMUM_8
      REAL(8) BMISS,GETBMISS

      DIMENSION  KOUNT(0:3,0:3),ISATOB(11),RSATOB(17)
      DATA  KOUNT/16*0/,XMISS/99999./,IMISS/99999/,NF/31,13,35,17/

      CHARACTER*8   STNID

      CHARACTER*1   NMCHAR(0:35)

      SAVE

      DATA          NMCHAR/'0','1','2','3','4','5','6','7','8','9',
     $                     'A','B','C','D','E','F','G','H','I','J',
     $                     'K','L','M','N','O','P','Q','R','S','T',
     $                     'U','V','W','X','Y','Z'/

      IF(IFIRST.EQ.0) THEN

C  FIRST TIME IN, SET DATELEN, GET CENTER AND DUMP TIME FOR FILE, TEST
C   FOR CENTER FILE DATE PRIOR TO 07/01/1998, AND GET VALUE FOR "BMISS"
C  --------------------------------------------------------------------

         PRINT'("  ==> W3RTOVSUNP -- WCOSS VERSION 01-09-2020")'
         IFIRST = 1
         CALL DATELEN(10)
         CALL DUMPBF(IUNIT,JDATE,JDUMP)
cppppp
         print'("  -- CENTER DATE (JDATE) = ",5(I0,1X))', jdate
         print'("  -- DUMP DATE   (JDUMP) = ",5(I0,1X))', jdump
         print'(1X)'
cppppp
         IF(JDATE(1).LE.0)  then
            PRINT'(" ##W3RTOVSUNP - CENTER DATE COULD NOT BE OBTAINED ",
     $       "FROM INPUT FILE ON UNIT ",I0," -- IERR = -3")', IUNIT
            RETURN
         END IF
         IF(JDATE(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN JDATE(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

            PRINT'(" ##W3RTOVSUNP - THE FOLLOWING SHOULD NEVER ",
     $       "HAPPEN!!!!!")'
            PRINT'(" ##W3RTOVSUNP - 2-DIGIT YEAR IN JDATE(1) RETURNED ",
     $       "FROM DUMPBF (JDATE IS: ",I5,4I3") - USE WINDOWING ",
     $       "TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', JDATE
C IF JDATE=41~99 THEN JDATE=1941~1999
C IF JDATE=00~40 THEN JDATE=2000~2040
            IF(JDATE(1).GT.40)  THEN
               JDATE(1) = 1900 + JDATE(1)
            ELSE
               JDATE(1) = 2000 + JDATE(1)
            ENDIF
            PRINT'(" ##W3RTOVSUNP - CORRECTED JDATE(1) WITH 4-DIGIT ",
     $       "YEAR, JDATE NOW IS: ",I5,4I3)', JDATE
         ENDIF
         IDSDAT = JDATE(1)*1000000+JDATE(2)*10000+JDATE(3)*100+JDATE(4)
         IF(JDUMP(1).LE.0)  THEN
            IDSDMP_8 = 999999999999_8
         ELSE
            IF(JDUMP(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN JDUMP(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

               PRINT'(" ##W3RTOVSUNP - THE FOLLOWING SHOULD NEVER ",
     $          "HAPPEN!!!!!")'
               PRINT'(" ##W3RTOVSUNP - 2-DIGIT YEAR IN JDUMP(1) ",
     $          "RETURNED FROM DUMPBF (JDUMP IS: ",I5,4I3") - USE ",
     $          "WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', JDUMP
C IF JDUMP=41~99 THEN JDUMP=1941~1999
C IF JDUMP=00~40 THEN JDUMP=2000~2040
               IF(JDUMP(1).GT.40)  THEN
                  JDUMP(1) = 1900 + JDUMP(1)
               ELSE
                  JDUMP(1) = 2000 + JDUMP(1)
               ENDIF
               PRINT'(" ##W3RTOVSUNP - CORRECTED JDUMP(1) WITH 4-DIGIT",
     $          " YEAR, JDUMP NOW IS: ",I5,4I3)', JDUMP
            END IF
            JDUMP_8 = JDUMP
            IDSDMP_8 = JDUMP_8(1)*100000000+JDUMP_8(2)*1000000+
     $       JDUMP_8(3)*10000+JDUMP_8(4)*100+JDUMP_8(5)
         ENDIF
c-----------------------------------------------------------------------
c This logic is needed only because SUBSET is not returned in DUMPBF
c  and we need it in order to return dsname - after dsname is retrieved
c  close data set ..
         call openbf(iunit,'IN',iunit)
         call readmg(iunit,subset,ibdate,iret)
         if(subset.eq.'NC003102')  then
            dsname = 'RTOVS   '
         else
            dsname = '????????'
         end if
         call closbf(iunit)
c-----------------------------------------------------------------------
         KDATE(1:3) = JDATE(1:3)
         KDATE(4)   = 0
         KDATE(5:6) = JDATE(4:5)
         KDATE(7:8) = 0
         LDATE(1)   = 1998
         LDATE(2)   = 07
         LDATE(3)   = 01
         LDATE(4:8) = 0
         CALL W3DIFDAT(KDATE,LDATE,1,RINC)
         IF(RINC(1).LT.0.0)  THEN
            WRITE(6,3004)
 3004       FORMAT(/'##W3RTOVSUNP - DATE OF INPUT FILE IS PRIOR TO ',
     $       '07/01/1998 - VALUE IN "TOFF" NOT RELATED TO FILTER FLAG ',
     $       'SO SET'/15X,'OUTPUT FILTER FLAG TO -99 FOR ALL REPORTS'/)
            ITOFF = 1
         END IF
c-----------------------------------------------------------------------

C  GET VALUE FOR "BMISS"
C  --------------------

         BMISS = GETBMISS()
         print'(1X)'
         print'(" BUFRLIB value for missing passed into W3RTOVSUNP is:",
     $    1X,G0)', bmiss
         print'(1X)'
c-----------------------------------------------------------------------

         IERR = 1
         RETURN
      ELSE  IF(IFIRST.EQ.1) THEN

C  SECOND TIME IN, OPEN BUFR DATASET FOR INPUT AND DECODE FIRST MESSAGE
C  --------------------------------------------------------------------

         IFIRST = 2
         CALL OPENBF(IUNIT,'IN',IUNIT)
         CALL READMG(IUNIT,SUBSET,IBDATE,IRET)
         IF(IRET.NE.0) THEN
            WRITE(6,1009) IUNIT
 1009       FORMAT('##W3RTOVSUNP ERROR: EMPTY FILE IN UNIT ',I5)
            IERR = -1
            RETURN
         ENDIF
         IF(IBDATE.LT.100000000)  THEN
C IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
C  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
C  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            WRITE(6,1209) IUNIT
 1209       FORMAT('##W3RTOVSUNP ERROR: A 10-DIGIT SECT. 1 BUFR ',
     $       'MESSAGE DATE WAS NOT RETURNED IN UNIT',I5,' - PROBLEM ',
     $       'WITH BUFR FILE')
            IERR = -2
            RETURN
         END IF
      ENDIF

 1000 CONTINUE                                                          

C  EACH CALL TO READSB INCREASES "KOUNTR" BY 1 (REGARDLESS OF RESULT)
C  ------------------------------------------------------------------

      KOUNTR = KOUNTR + 1

      CALL READSB(IUNIT,IRET)
      IF(IRET.NE.0) THEN
        CALL READMG(IUNIT,SUBSET,IBDATE,IRET)
        IF(IRET.NE.0) THEN

C  ALL BUFR MESSAGES HAVE BEEN READ AND DECODED -- ALL DONE
C  --------------------------------------------------------

           WRITE(6,1001) IUNIT
 1001 FORMAT(//' ==> W3RTOVSUNP: END OF FILE ON UNIT',I3,' -- ALL DONE'
     $ /)
           IERR = 2
           RETURN
        ENDIF
         IF(IBDATE.LT.100000000)  THEN
C IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
C  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
c  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            WRITE(6,1209) IUNIT
            IERR = -2
            RETURN
         END IF
        GO TO 1000
      ENDIF

      XIDENT_8 = BMISS
      CALL UFBINT(IUNIT,XIDENT_8,11, 1,IRET,IDTSTR//IDTST2)

      XINFO_8 = BMISS
      CALL UFBINT(IUNIT,XINFO_8 ,12, 1,IRET,INFSTR//INFST1)

      SRFDAT_8 = BMISS
      CALL UFBINT(IUNIT,SRFDAT_8, 6, 1,IRET,SRFSTR)

      RETDAT_8 = BMISS
      CALL UFBINT(IUNIT,RETDAT_8, 5,40,NLEV,RETSTR)

      BRTDAT_8 = BMISS
      CALL UFBINT(IUNIT,BRTDAT_8, 2,32,NCHN,BRTSTR)

      ISATOB = IMISS
      RSATOB = XMISS
      PP(1:40) = XMISS
      TT(1:40) = XMISS
      QQ(1:40) = XMISS
      CLAL(1:40) = XMISS
      CLAM(1:40) = XMISS
      IRTCHN(1:32) = IMISS
      RTRAD(1:32) = XMISS

C  SATELLITE IDENTIFIER
C  --------------------

      IF(IBFMS(XIDENT_8(1)).EQ.0)  THEN
         ISATOB(1) = NINT(XIDENT_8(1))
         IF(ISATOB(1).LT.200.OR.ISATOB(1).GT.209) THEN
            WRITE(6,2071) KOUNTR,ISATOB(1)
 2071 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' AN UNRECOGNIZED SATELLITE ID (=',I5,') - SKIP IT')
            GO TO 1000
         ENDIF
      ELSE
         WRITE(6,2072) KOUNTR
 2072 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' A MISSING SATELLITE ID - SKIP IT')
         GO TO 1000
      ENDIF

C  LATITUDE
C  --------

      IF(IBFMS(XIDENT_8(2)).EQ.0)  THEN
         RSATOB(2) = XIDENT_8(2)
      ELSE
         WRITE(6,2073) KOUNTR
 2073 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' A MISSING LATITUDE - SKIP IT')
         GO TO 1000
      ENDIF

C  LONGITUDE
C  ---------

      IF(IBFMS(XIDENT_8(3)).EQ.0)  THEN

C Important: According to BUFR Manual, CLON (0-06-002) - represented
C  here by "XIDENT_8(3)" - should be in units of Degrees West - and
C  East + (-180.0 to +180.0); however some BUFR data sets (e.g.,
C  PREPBUFR) are known to encode 0-06-002 in units of Degrees East
C  (0.0 to 359.99)
C  -- So we use the following conversion to work in either case ...
         RSATOB(3) = 360._8 - MOD(360._8-XIDENT_8(3),360._8)
         IF(RSATOB(3).EQ.360.0)  RSATOB(3) = 0.0
      ELSE
         WRITE(6,2074) KOUNTR
 2074 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' A MISSING LONGITUDE - SKIP IT')
         GO TO 1000
      ENDIF

C  FILTER FLAG
C  -----------
c  If date of input file is prior to 7/1/1998, then "TOFF" does not
c   indicate filter flag, set filter flag to "-99" (alerts calling
c   program to process only every 4'th retrieval to simulate 250km
c   sampling - needed for historical cdas runs)

      IF(IBFMS(XIDENT_8(4)).EQ.0)  THEN
         IF(ITOFF.EQ.0)  THEN
            ISATOB(7) = NINT(XIDENT_8(4))
         ELSE
            ISATOB(7) = -99
         END IF
      ELSE
         WRITE(6,2075) KOUNTR
 2075 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' A MISSING FILTER FLAG - SKIP IT')
         GO TO 1000
       ENDIF

C  OBSERVATION TIME
C  ----------------

      AMAXIMUM_8 = MAX(XIDENT_8(5),XIDENT_8(6),XIDENT_8(7))
      IF(IBFMS(AMAXIMUM_8).EQ.0) THEN
         HRFRAC = (60.0 * XIDENT_8(6) + XIDENT_8(7)) / 3600.0
         RSATOB(1) = XIDENT_8(5) + HRFRAC
         RSATOB(1) = 0.01 * AINT(100.0 * RSATOB(1) + 0.5)
      ELSE
         WRITE(6,2076) KOUNTR
 2076 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' ONE OR MORE MISSING TIME UNITS - SKIP IT')
         GO TO 1000
      ENDIF

C  SWATH LOCATION
C  --------------

      IF(IBFMS(XIDENT_8(8)).EQ.0)  THEN
         ISATOB(3) = NINT(XIDENT_8(8))
      ELSE
         WRITE(6,2077) KOUNTR
 2077 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' A MISSING SWATH LOCATION - SKIP IT')
         GO TO 1000
      ENDIF

C  ORBIT NUMBER
C  ------------

      IF(IBFMS(XIDENT_8(9)).EQ.0)  ISATOB(4) = NINT(XIDENT_8(9))

C  SUPERADIABATIC FLAG
C  -------------------

      IF(IBFMS(XIDENT_8(10)).EQ.0)  ISATOB(8) = NINT(XIDENT_8(10))
      IF(ISATOB(8).NE.0)  THEN
         WRITE(6,2078) KOUNTR,ISATOB(8)
 2078 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') IS ',
     $ 'SUPERADIABATIC (FLAG=',I5,') - SKIP IT')
         GO TO 1000
      ENDIF

C  DAY-NIGHT INDICATOR
C  -------------------

      IF(IBFMS(XIDENT_8(11)).EQ.0)  ISATOB(9) = NINT(XIDENT_8(11))

C  SOLAR ZENITH ANGLE
C  ------------------

      IF(IBFMS(XINFO_8(1)).EQ.0)  RSATOB(11) = XINFO_8(1)

C  SOLAR ELEVATION
C  ---------------

      IF(IBFMS(XINFO_8(2)).EQ.0)  RSATOB(12) = XINFO_8(2)

C  AVERAGE NSTAR VALUE
C  -------------------

      IF(IBFMS(XINFO_8(3)).EQ.0)  RSATOB(13) = XINFO_8(3)

C  OZONE
C  -----

      IF(IBFMS(XINFO_8(4)).EQ.0)  RSATOB(8) = XINFO_8(4)

C  SATELLITE DATA PROCESSING TECHNIQUE
C  -----------------------------------

      IF(IBFMS(XINFO_8(5)).EQ.0)  THEN
         ISATOB(6) = NINT(XINFO_8(5))
      ELSE
         WRITE(6,2079) KOUNTR
 2079 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') HAS',
     $ ' A MISSING SATELLITE DATA PROCESSING TECHNIQUE - SKIP IT')
         GO TO 1000
      ENDIF

C  HIRS CHANNEL UTILIZATION FLAGS
C  ------------------------------

      IF(IBFMS(XINFO_8(6)).EQ.0)  RSATOB(14) = XINFO_8(6)

C  MSU CHANNEL UTILIZATION FLAGS
C  ------------------------------

      IF(IBFMS(XINFO_8(7)).EQ.0)  RSATOB(15) = XINFO_8(7)

C  SSU CHANNEL UTILIZATION FLAGS
C  -----------------------------

      IF(IBFMS(XINFO_8(8)).EQ.0)  RSATOB(16) = XINFO_8(8)

C  AVHRR CHANNEL UTILIZATION FLAGS
C  -------------------------------

      IF(IBFMS(XINFO_8(9)).EQ.0)  RSATOB(17) = XINFO_8(9)

C  TOTAL PRECIPITABLE WATER
C  ------------------------

      IF(IBFMS(XINFO_8(10)).EQ.0)  RSATOB(7) = XINFO_8(10) * 10.

C  CLOUD-TOP PRESSURE
C  ------------------

      IF(IBFMS(XINFO_8(11)).EQ.0)  RSATOB(10) = XINFO_8(11) * 0.01

C  VERTICAL SIGNIFICANCE INDICATOR (SATELLITE SOUNDINGS)
C  -----------------------------------------------------

      IF(IBFMS(XINFO_8(12)).EQ.0)  ISATOB(10) = NINT(XINFO_8(12))

C  STATION ID
C  ----------

      STNID = '      R '
      MODSAT = MOD(ISATOB(1),4)
      INST = IMISS
      IF(ISATOB(6).GE.32) THEN

C  CLEAR PATH
C  ----------

         INST = 1
         STNID(8:8) = NMCHAR(NF(MODSAT)-3)
      ELSE IF(ISATOB(6).GE.16) THEN

C  NSTAR PATH ===> NOT VALID FOR RTOVS!!!! - SHOULD NEVER SEE THIS
C  ---------------------------------------------------------------

         INST = 2
         STNID(8:8) = NMCHAR(NF(MODSAT)-2)
      ELSE IF(ISATOB(6).GE.8) THEN

C  CLOUDY PATH
C  -----------

         INST = 3
         STNID(8:8) = NMCHAR(NF(MODSAT)-1)
      ELSE

C  UNKNOWN PATH
C  ------------

         INST = 0
         STNID(8:8) = NMCHAR(NF(MODSAT))
         WRITE(6,2080) KOUNTR,STNID,ISATOB(6)
 2080 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,',ID=',
     $ A8,') HAS AN UNKNOWN SATELLITE DATA PROCESSING TECH. (=',I5,
     $ ') - SKIP IT')
         GO TO 1000
      ENDIF

      KOUNT(INST,MODSAT) = MIN(99999,KOUNT(INST,MODSAT) + 1)
      WRITE(STNID(2:6),'(I5.5)') KOUNT(INST,MODSAT)

      NADIR = INT(ABS(FLOAT(ISATOB(3)) - 28.5)) / 3
      IF(NADIR.LT.9) NADIR = NADIR + 1
      IF(NADIR.GT.0.AND.NADIR.LT.10)  THEN
         STNID(1:1) = NMCHAR(NADIR)
      ELSE
         WRITE(6,2081) KOUNTR,STNID,NADIR
 2081 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,',ID=',
     $ A8,') HAS AN INVALID NADIR PROX. IND. (=',I5,') - SKIP IT')
         GO TO 1000
      ENDIF

      IF(NLEV.EQ.40)  THEN

C  FILL IN THE LEVEL SOUNDING DATA - MUST HAVE 40 TEMP LEVELS TO ACCEPT
C  --------------------------------------------------------------------

         DO L = 1,NLEV
            LREV = NLEV + 1 - L
            PP(LREV) = RETDAT_8(1,L) * 0.01
            IF(IBFMS(RETDAT_8(2,L)).EQ.0) THEN
               IF(IBFMS(RETDAT_8(3,L)).NE.0) THEN
                  TT(LREV) = RETDAT_8(2,L)
               ELSE
                  QQ(LREV) = RETDAT_8(3,L) / (1.0 + RETDAT_8(3,L))
                  TT(LREV) = RETDAT_8(2,L) * (1.0 + 0.61 * QQ(LREV))
               ENDIF
            ELSE
               WRITE(6,3082) KOUNTR
 3082 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,') ',
     $ 'CONTAINS 1 OR MORE MISSING TEMERATURES IN ITS SOUNDING - SKIP ',
     $ 'IT')
               GO TO 1000
            ENDIF
            IF(IBFMS(RETDAT_8(4,L)).EQ.0)  CLAL(LREV) = RETDAT_8(4,L)
            IF(IBFMS(RETDAT_8(5,L)).EQ.0)  CLAM(LREV) = RETDAT_8(5,L)
         ENDDO
      ELSE
         WRITE(6,2082) STNID,KOUNTR,NLEV
 2082 FORMAT(/'##W3RTOVSUNP WARNING: ID ',A8,' (#',I5,') DOES NOT ',
     $ 'CONTAIN 40 SOUNDING LEVELS (HAS ',I3,' LEVELS) -- NO SOUNDING ',
     $ 'LEVEL DATA PROCESSED')
      ENDIF

      IF(NCHN.EQ.32)  THEN

C  FILL IN THE RADIANCE DATA
C  -------------------------

         DO L = 1,NCHN
            IF(IBFMS(BRTDAT_8(1,L)).EQ.0) IRTCHN(L) =NINT(BRTDAT_8(1,L))
            IF(IBFMS(BRTDAT_8(2,L)).EQ.0) RTRAD(L)  = BRTDAT_8(2,L)
         ENDDO
      ELSE
         WRITE(6,2083) STNID,KOUNTR,NCHN
 2083 FORMAT(/'##W3RTOVSUNP WARNING: ID ',A8,' (#',I5,') DOES NOT ',
     $ 'CONTAIN 32 RADIANCE CHANNELS (HAS ',I3,' CHANNELS) -- NO ',
     $ 'RADIANCE DATA PROCESSED')
      ENDIF

C  BOTTOM LEVEL PRESSURE
C  ---------------------

      IF(IBFMS(SRFDAT_8(1)).EQ.0)  THEN
         RSATOB(5) = 0.01 * SRFDAT_8(1)
      ELSE
         WRITE(6,2084) KOUNTR,STNID
 2084 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,',ID=',
     $ A8,') HAS A MISSING BOTTOM PRESSURE LEVEL - SKIP IT')
         GO TO 1000
      ENDIF

C  SURFACE HEIGHT
C  --------------

      IF(IBFMS(SRFDAT_8(2)).EQ.0)  THEN
         RSATOB(4) = SRFDAT_8(2)
      ELSE
         WRITE(6,2085) KOUNTR,STNID
 2085 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,',ID=',
     $ A8,') HAS A MISSING SURFACE HEIGHT - SKIP IT')
         GO TO 1000
      ENDIF

C  REPORT TYPE AND LAND/SEA TAG
C  ----------------------------

      IF(IBFMS(SRFDAT_8(3)).EQ.0)  THEN
         ISATOB(5) = NINT(SRFDAT_8(3))
         IF(MOD(ISATOB(5),2).EQ.0)  THEN
            IF(INST.LT.IMISS)  ISATOB(2) = 170 + INST
            ISATOB(5) = 0
         ELSE 
            IF(INST.LT.IMISS)  ISATOB(2) = 160 + INST
            ISATOB(5) = 1
         ENDIF
      ELSE
         WRITE(6,2086) KOUNTR,STNID
 2086 FORMAT(/'##W3RTOVSUNP WARNING: A DECODED RETRIEVAL (#',I5,',ID=',
     $ A8,') HAS A MISSING LAND/SEA INDICATOR - SKIP IT')
            GO TO 1000
      ENDIF

C  SKIN TEMPERATURE
C  ----------------

      IF(IBFMS(SRFDAT_8(4)).EQ.0)  RSATOB(6) = SRFDAT_8(4)

C  SEA-SURFACE  TEMPERATURE
C  ------------------------

      IF(IBFMS(SRFDAT_8(5)).EQ.0)  RSATOB(9) = SRFDAT_8(5)

C  TERRAIN INDICATOR
C  -----------------

      IF(IBFMS(SRFDAT_8(6)).EQ.0)  ISATOB(11) = NINT(SRFDAT_8(6))

C  RETURN WITH DECODED RTOVS RETRIEVAL
C  -----------------------------------

      IERR = 0

      RETURN
      END

C-----------------------------------------------------------------------
      SUBROUTINE SPTRANF(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
     &                   IP,IS,JN,JS,KW,KG,JB,JE,JC,
     &                   WAVE,GRIDN,GRIDS,IDIR)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  SPTRAN     PERFORM A SCALAR SPHERICAL TRANSFORM
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-02-29
C
C ABSTRACT: THIS SUBPROGRAM PERFORMS A SPHERICAL TRANSFORM
C           BETWEEN SPECTRAL COEFFICIENTS OF SCALAR QUANTITIES
C           AND FIELDS ON A GLOBAL CYLINDRICAL GRID.
C           THE WAVE-SPACE CAN BE EITHER TRIANGULAR OR RHOMBOIDAL.
C           THE GRID-SPACE CAN BE EITHER AN EQUALLY-SPACED GRID
C           (WITH OR WITHOUT POLE POINTS) OR A GAUSSIAN GRID.
C           THE WAVE AND GRID FIELDS MAY HAVE GENERAL INDEXING,
C           BUT EACH WAVE FIELD IS IN SEQUENTIAL 'IBM ORDER',
C           I.E. WITH ZONAL WAVENUMBER AS THE SLOWER INDEX.
C           TRANSFORMS ARE DONE IN LATITUDE PAIRS FOR EFFICIENCY;
C           THUS GRID ARRAYS FOR EACH HEMISPHERE MUST BE PASSED.
C           IF SO REQUESTED, JUST A SUBSET OF THE LATITUDE PAIRS
C           MAY BE TRANSFORMED IN EACH INVOCATION OF THE SUBPROGRAM.
C           THE TRANSFORMS ARE ALL MULTIPROCESSED OVER LATITUDE EXCEPT
C           THE TRANSFORM FROM FOURIER TO SPECTRAL IS MULTIPROCESSED
C           OVER ZONAL WAVENUMBER TO ENSURE REPRODUCIBILITY.
C           TRANSFORM SEVERAL FIELDS AT A TIME TO IMPROVE VECTORIZATION.
C           SUBPROGRAM CAN BE CALLED FROM A MULTIPROCESSING ENVIRONMENT.
C
C PROGRAM HISTORY LOG:
C   96-02-29  IREDELL
C 1998-12-15  IREDELL  GENERIC FFT USED
C                      OPENMP DIRECTIVES INSERTED
C
C USAGE:    CALL SPTRANF(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
C    &                   IP,IS,JN,JS,KW,KG,JB,JE,JC,
C    &                   WAVE,GRIDN,GRIDS,IDIR)
C   INPUT ARGUMENTS:
C     IROMB    - INTEGER SPECTRAL DOMAIN SHAPE
C                (0 FOR TRIANGULAR, 1 FOR RHOMBOIDAL)
C     MAXWV    - INTEGER SPECTRAL TRUNCATION
C     IDRT     - INTEGER GRID IDENTIFIER
C                (IDRT=4 FOR GAUSSIAN GRID,
C                 IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C                 IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
C     IMAX     - INTEGER EVEN NUMBER OF LONGITUDES.
C     JMAX     - INTEGER NUMBER OF LATITUDES.
C     KMAX     - INTEGER NUMBER OF FIELDS TO TRANSFORM.
C     IP       - INTEGER LONGITUDE INDEX FOR THE PRIME MERIDIAN
C     IS       - INTEGER SKIP NUMBER BETWEEN LONGITUDES
C     JN       - INTEGER SKIP NUMBER BETWEEN N.H. LATITUDES FROM NORTH
C     JS       - INTEGER SKIP NUMBER BETWEEN S.H. LATITUDES FROM SOUTH
C     KW       - INTEGER SKIP NUMBER BETWEEN WAVE FIELDS
C     KG       - INTEGER SKIP NUMBER BETWEEN GRID FIELDS
C     JB       - INTEGER LATITUDE INDEX (FROM POLE) TO BEGIN TRANSFORM
C     JE       - INTEGER LATITUDE INDEX (FROM POLE) TO END TRANSFORM
C     JC       - INTEGER NUMBER OF CPUS OVER WHICH TO MULTIPROCESS
C     WAVE     - REAL (*) WAVE FIELDS IF IDIR>0
C     GRIDN    - REAL (*) N.H. GRID FIELDS (STARTING AT JB) IF IDIR<0
C     GRIDS    - REAL (*) S.H. GRID FIELDS (STARTING AT JB) IF IDIR<0
C     IDIR     - INTEGER TRANSFORM FLAG
C                (IDIR>0 FOR WAVE TO GRID, IDIR<0 FOR GRID TO WAVE)
C   OUTPUT ARGUMENTS:
C     WAVE     - REAL (*) WAVE FIELDS IF IDIR<0
C     GRIDN    - REAL (*) N.H. GRID FIELDS (STARTING AT JB) IF IDIR>0
C     GRIDS    - REAL (*) S.H. GRID FIELDS (STARTING AT JB) IF IDIR>0
C
C SUBPROGRAMS CALLED:
C   SPTRANF0     SPTRANF SPECTRAL INITIALIZATION
C   SPTRANF1     SPTRANF SPECTRAL TRANSFORM
C
C REMARKS: MINIMUM GRID DIMENSIONS FOR UNALIASED TRANSFORMS TO SPECTRAL:
C   DIMENSION                    LINEAR              QUADRATIC
C   -----------------------      ---------           -------------
C   IMAX                         2*MAXWV+2           3*MAXWV/2*2+2
C   JMAX (IDRT=4,IROMB=0)        1*MAXWV+1           3*MAXWV/2+1
C   JMAX (IDRT=4,IROMB=1)        2*MAXWV+1           5*MAXWV/2+1
C   JMAX (IDRT=0,IROMB=0)        2*MAXWV+3           3*MAXWV/2*2+3
C   JMAX (IDRT=0,IROMB=1)        4*MAXWV+3           5*MAXWV/2*2+3
C   JMAX (IDRT=256,IROMB=0)      2*MAXWV+1           3*MAXWV/2*2+1
C   JMAX (IDRT=256,IROMB=1)      4*MAXWV+1           5*MAXWV/2*2+1
C   -----------------------      ---------           -------------
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      USE SP_MOD, ONLY: SPTRANF0, SPTRANF1
      REAL WAVE(*),GRIDN(*),GRIDS(*)
      REAL EPS((MAXWV+1)*((IROMB+1)*MAXWV+2)/2),EPSTOP(MAXWV+1)
      REAL ENN1((MAXWV+1)*((IROMB+1)*MAXWV+2)/2)
      REAL ELONN1((MAXWV+1)*((IROMB+1)*MAXWV+2)/2)
      REAL EON((MAXWV+1)*((IROMB+1)*MAXWV+2)/2),EONTOP(MAXWV+1)
      REAL(8) AFFT(50000+4*IMAX)
      REAL CLAT(JB:JE),SLAT(JB:JE),WLAT(JB:JE)
      REAL PLN((MAXWV+1)*((IROMB+1)*MAXWV+2)/2,JB:JE)
      REAL PLNTOP(MAXWV+1,JB:JE)
      REAL WTOP(2*(MAXWV+1))
      REAL G(IMAX,2)

      integer nth,tid,omp_get_num_threads,omp_get_thread_num

!      write(0,*) 'sptranf top'
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  SET PARAMETERS
      MP=0
!      write(0,*) 'sptranf call sptranf0'
      CALL SPTRANF0(IROMB,MAXWV,IDRT,IMAX,JMAX,JB,JE,
     &              EPS,EPSTOP,ENN1,ELONN1,EON,EONTOP,
     &              AFFT,CLAT,SLAT,WLAT,PLN,PLNTOP)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSFORM WAVE TO GRID
      IF(IDIR.GT.0) THEN

C$OMP PARALLEL 
      TID = OMP_GET_THREAD_NUM()
      NTH = OMP_GET_NUM_THREADS()
      if(tid==0) print*,'nth=',nth
C$OMP DO PRIVATE(KWS,WTOP,G,IJKN,IJKS) 

        DO K=1,KMAX
          KWS=(K-1)*KW
          WTOP=0
          DO J=JB,JE
!      write(0,*) 'sptranf call sptranf1 k,j=',k,j,kws
            CALL SPTRANF1(IROMB,MAXWV,IDRT,IMAX,JMAX,J,J,
     &                    EPS,EPSTOP,ENN1,ELONN1,EON,EONTOP,
     &                    AFFT,CLAT(J),SLAT(J),WLAT(J),
     &                    PLN(1,J),PLNTOP(1,J),MP,
     &                    WAVE(KWS+1),WTOP,G,IDIR)
!      write(0,*) 'sptranf exit sptranf1'
            IF(IP.EQ.1.AND.IS.EQ.1) THEN
              DO I=1,IMAX
                IJKN=I+(J-JB)*JN+(K-1)*KG
                IJKS=I+(J-JB)*JS+(K-1)*KG
                GRIDN(IJKN)=G(I,1)
                GRIDS(IJKS)=G(I,2)
              ENDDO
            ELSE
              DO I=1,IMAX
                IJKN=MOD(I+IP-2,IMAX)*IS+(J-JB)*JN+(K-1)*KG+1
                IJKS=MOD(I+IP-2,IMAX)*IS+(J-JB)*JS+(K-1)*KG+1
                GRIDN(IJKN)=G(I,1)
                GRIDS(IJKS)=G(I,2)
              ENDDO
            ENDIF
          ENDDO
        ENDDO
C$OMP end PARALLEL 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSFORM GRID TO WAVE
      ELSE
C$OMP PARALLEL DO PRIVATE(KWS,WTOP,G,IJKN,IJKS)
        DO K=1,KMAX
          KWS=(K-1)*KW
          WTOP=0
          DO J=JB,JE
            IF(WLAT(J).GT.0.) THEN
              IF(IP.EQ.1.AND.IS.EQ.1) THEN
                DO I=1,IMAX
                  IJKN=I+(J-JB)*JN+(K-1)*KG
                  IJKS=I+(J-JB)*JS+(K-1)*KG
                  G(I,1)=GRIDN(IJKN)
                  G(I,2)=GRIDS(IJKS)
                ENDDO
              ELSE
                DO I=1,IMAX
                  IJKN=MOD(I+IP-2,IMAX)*IS+(J-JB)*JN+(K-1)*KG+1
                  IJKS=MOD(I+IP-2,IMAX)*IS+(J-JB)*JS+(K-1)*KG+1
                  G(I,1)=GRIDN(IJKN)
                  G(I,2)=GRIDS(IJKS)
                ENDDO
              ENDIF
              CALL SPTRANF1(IROMB,MAXWV,IDRT,IMAX,JMAX,J,J,
     &                      EPS,EPSTOP,ENN1,ELONN1,EON,EONTOP,
     &                      AFFT,CLAT(J),SLAT(J),WLAT(J),
     &                      PLN(1,J),PLNTOP(1,J),MP,
     &                      WAVE(KWS+1),WTOP,G,IDIR)
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM:  PREPOBS_PREPACPF
C   PRGMMR: D. Keyser        ORG: NP22        DATE: 2017-01-12
C
C ABSTRACT: This program reads in aircraft profile data as output from
C   the NRL-based prepobs_prepacqc program and appends the nearest (in
C   time and distance) surface data available.  Surface data is pulled
C   from METAR reports in the corresponding ADPSFC dump file. 
C
C PROGRAM HISTORY LOG:
C 2011-03-10  J. Whiting -- Original code copied from offline mk_coloc
C              routine of 10 Mar 2011 15:03
C 2011-03-10  J. Whiting -- Adapted to run operationally; added W3TAG*
C              and ERREXIT calls; added docblock and comments
C 2012-11-20  J. Woollen -- Initial port to WCOSS
C 2013-02-12  D. Keyser  -- Final changes to run on WCOSS: Set BUFRLIB
C              missing (BMISS) to 10E8 rather than 10E10 to avoid
C              integer overflow; rename all REAL(8) variables as *_8;
C              use formatted print statements where previously
C              unformatted print was > 80 characters; traps to avoid
C              manipulating BUFRLIB missing values prior to encoding
C              them into output BUFR file (to avoid floating point
C              invalid error in BUFRLIB routine IPKS when debugging
C              turned on)
C 2017-01-12  D. Stokes  -- Check for, and skip, all comment lines when
C             reading contents of METAR station dictionary file ("!" in
C             character 1). Also fix to avoid a divide by zero which
C             slips by on tide/gyre with version 12.1 of the compiler,
C             but gets caught by newer compilers.
C             BENEFIT: Code more robust.  Comment lines were added to
C                      METAR dictionary on November 22, 2016 and since
C                      that time this program has been silently aborting
C                      due to an internal formatted read error.
C 2017-01-12  D. Keyser  -- Increase the maximum number of stations that
C             can be read from METAR station dictionary (MAXSTN) from
C             8000 to 20000.
C             BENEFIT: There are currently 7790 stations in the METAR
C                      dictionary. There are still stations missing that
C                      will need to be added.  A 20000 limit should
C                      suffice for quite some time,
C
C USAGE:
C   INPUT FILES:
C     UNIT 11  - METAR station dictionary file, sorted by longitude
C     UNIT 12  - ADPSFC dump file containing METAR surface reports
C     UNIT 13  - BUFR output from prepobs_prepacqc program containing
C                aircraft profile data with no surface level
C                information
C
C   OUTPUT FILES:  (INCLUDING SCRATCH FILES)
C     UNIT 51  - BUFR file as in unit 13, except now with nearest METAR
C                surface report appended to each aircraft profile
C
C   SUBPROGRAMS CALLED:
C     UNIQUE:    - GCIRC_QC (function) -- computes great circle 
C                  distances using the Haversine formula
C     UNIQUE:    - 
C     LIBRARY:
C       W3NCO    - W3TAGB  W3TAGE ERREXIT W3MOVDAT W3DIFDAT
C       W3EMC    - ORDERS
C       BUFRLIB  - DATELEN  UFBTAB UFBMEM  UFBTAM OPENBF   UFBSEQ 
C                  UFBINT   OPENMB WRITSB  COPYMG CLOSMG   CLOSBF
C                  IBFMS    SETBMISS GETBMISS
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C          =   9 - wrong input BUFR message type encounted, failure
C          =  99 - memory allocation error, failure
C
C REMARKS: None.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      program PREPOBS_PREPACPF

c quick look at msgs in BUFR files (mcl == read aircraft)

      real*8     bmiss       ! BUFR missing value
      real*8     getbmiss    ! Function to return current bmiss value

c-- station table vars
      character    line*132
      logical      eof        / .false. /
      CHARACTER    sid*8, si4*4, sname*32, st*2, cn*2, chrx*20
   
      parameter    (MAXSTN=20000 )               ! max # stations
c     character*8  stid(MAXSTN)                  ! stn ID
      character*4  stid(MAXSTN)                  ! stn ID - 4char metar
      real         slat(MAXSTN), slon(MAXSTN)    ! stn lat, lon
      integer      ishgt(MAXSTN)                 ! stn height

c     parameter    (NPTR=72 )       ! 5-degree bins
c     parameter    (NPTR=120)       ! 3-degree bins
      parameter    (NPTR=180)       ! 2-degree bins
c     parameter    (NPTR=360)       ! 1-degree bins
      integer      lptr(NPTR)       ! pointers into longitude array

c-- logical unit numbers
      integer      lunstn   / 11 /  ! input, surface station table
      integer      luntru   / 12 /  ! input, ground truth file (adpsfc)
      integer      lunpro   / 13 /  ! input, profile file
      integer      lunout   / 51 /  ! output profile file


c-- ground truth file vars
      parameter    (MXTS=9, MXPS=7)
      real(8)      usr8_8 
      character*80 tstr,pstr
      data         tstr /'YEAR MNTH DAYS HOUR MINU RPID CLAT CLON SELV'/  ! MXTS
      data         pstr /'ALSE PMSL PRLC  TMDP TMDB  WDIR WSPD'/          ! MXPS
      REAL(8),ALLOCATABLE :: gtru_t_8(:,:)
      REAL(8),ALLOCATABLE :: gtru_p_8(:,:)
      INTEGER,ALLOCATABLE :: NDX(:)
      parameter (PI=3.14159274, DEG_RAD=PI/180.)   ! conversion factors


c-- profile file vars
      character*80 cnem
      character*8  ctyp, ctyp0
      character*8  cval(5), rpid, cstr
      real*8       rval_8(5), rstr_8, prlc_8
      equivalence (cval(1),rval_8(1)), (cstr,rstr_8)
      parameter    (MXNM=25)
      real*8       hdr_8(MXNM),out1_8(MXNM),pro2_8(MXNM,255),
     &             out2_8(MXNM,255)
c     real(8)      pro3_8(MXNM,255,255)
      real*8       usr_8(MXNM),usr2_8(MXNM,255)
c     real*8       usr3d_8(20,10000,255) ! events: #mnems, #levs, #evnts
      real*8       t_tru_dp_8,t_tru_db_8,p_tru_8,altim_8,z_tru_8,pstn_8,
     &             ws_tru_8,wd_tru_8,w_u_8,w_v_8,ws_tru_k_8,x_gtru_8,
     &             x_tru_8,y_tru_8,dt_tru_8,dtlow_8,rpt_8,dhr_8


c-- time arrays
      integer idat(8)    ! cycle time (yr,mon,day,tzone,hr,min,sec,msec)
      real    rinc(5)    ! time increment (day,hr,min,sec,msec)
      integer itob(8)    ! obs time == cycle time + time increment
      integer itru0(8)   ! gr truth ob time
      integer itru(8)    ! matching gr truth ob time

c-- print output flags
      logical   bylev/.false./
      logical   wr_hdr/.true./, wr_stn/.true./, wr_match/.true./
      logical   wr_prof/.true./

c-- Function to convert Altimeter Setting to Station Pressure
c -   from prepdata.f (of Jun 03 [2008] 09:58, lines 13907-11);
C     subprogram SFCDTA
c -  formula ultimately from Smithsonian Meteorological Tables
c
C FCN P_f_A GETS PSTN (MB) FROM ALTIMETER SETTING (MB) AND ELEVATION (M)
      P_f_A(ALT,ELEV) = (ALT**0.190284 - (((1013.25**0.190284)*
     $ 0.0065/288.15)*ELEV))**5.2553026
ccccc      P_f_A(ALT,ELEV) = (ALT**0.190284 - (((1013.25**0.190284)*
ccccc     $ 0.0065/288.15)*ELEV))**5.2553026 + 0.3


c====67=10========20========30========40========50========60========70=2

      CALL W3TAGB('PREPOBS_PREPACPF',2017,012,71,'NP20')

      write(*,*) 'Welcome to PREPOBS_PREPACPF - Version 01-12-2017'

C On WCOSS should always set BUFRLIB missing (BMISS) to 10E8 to avoid
C  overflow when either an INTEGER*4 variable is set to BMISS or a
C  REAL*8 (or REAL*4) variable that is missing is NINT'd
C -------------------------------------------------------------------
ccccc call setbmiss(10E10_8)
      call setbmiss(10E8_8)
      bmiss = getbmiss()
      print *
      print *, 'BUFRLIB value for missing is: ',bmiss
      print *

c     wr_hdr=.false.
c     wr_stn=.false.
      bylev=.true.
c     wr_match=.false.
c     wr_prof=.false.

c   - read static station file (sfile) into memory, sort/index
c-------------------------------------------------------------
c--Read Station Table
      OPEN(LUNSTN,FORM='FORMATTED')

      ns=0                                         ! station counter
      do while ( .not. eof ) 
        read(lunstn,'(a)',end=200) line
        if(line(1:1).eq.'!')cycle
        ns=ns+1

        if (ns .gt. MAXSTN) then
          write(*,*) 'ERROR - too many stations', ns, MAXSTN
          exit
        endif ! ns > MAXSTN

        if ( ns .lt. 10 .and. .false. )            ! diagnostic print
     &    write(*,'(1x,i4,1x,a)') ns,"'" // line(1:96) // "'"

        read(line,1500)      ! format from subroutine tbastn.f (gemlib)
     &         sid, isn, sname,st,cn, lat,lon,   ihgt,  ispr, chrx
 1500   format( a, 1x,i6, 3(1x,a),  1x,i5,1x,i6, 1x,i5, 1x,i2, a )

        stid(ns)=sid(1:4)                          ! metar ids - 4char
        slat(ns)=float(lat)/100.
        slon(ns)=float(lon)/100.
        ishgt(ns)=ihgt

      enddo ! while not eof
      write(*,*) 'eof reached; ns=',ns

 200  continue
      write(*,*) '--rd Station Table: #stns=',ns

      nstot=ns  ! total # of stations

      close(lunstn)


c--set up pointers into lon array
c--- [ lptr(n) == metar line number of first lon w/in bin 'n' ]
c
      binwidth=360./float(NPTR)
      write(*,'(1x,a,1x,f6.2)') ' -pointer binwidth=',binwidth
      lptr0=0
      ns=1
      do j=1,NPTR
        b1=  ( float(j-1) * binwidth ) - 180.
        do while ( slon(ns) .lt. b1 )
          ns=ns+1
        enddo ! while slon(ns) < b1
        lptr(j)=ns

        if ( .false. ) then ! write diagnostic for station tbl pointers
          nl=lptr(j)-lptr0
          lptr0=lptr(j)
          b2=  b1 + binwidth
          write(*,'(1x,i3," ==",1x,i4,2(1x,f6.1),1x,i3,2f8.2)')
     &      j,ns,b1,b2,nl,slon(lptr(j)),slon(ns-1)
        endif ! true/false -- stn tbl pointers diagnostics

      enddo ! j=1,NPTR


c--Read ground truth file
c------------------------
      call DATELEN(10)                          ! set dates to 10-digit
      OPEN(luntru,FORM='UNFORMATTED')


c--Read Gr Truth value into memory
      write(*,'(a,$)') ' --rd GrTru file: ' 
      call ufbtab(-luntru,usr8_8,1,1,MXTRU,' ')      ! gets # of rpts
      call ufbmem(luntru,0,imsg,munit)
      write(*,*) ' #rpts=',MXTRU,' #msgs=',imsg

      allocate(gtru_t_8(MXTS,MXTRU),STAT=I);IF(I.NE.0) GOTO 901
      call ufbtam(gtru_t_8,MXTS,MXTRU,ntab,tstr)
      write(*,'("  -tstr=""",A,"""")') tstr

      allocate(gtru_p_8(MXPS,MXTRU),STAT=I);IF(I.NE.0) GOTO 901
      call ufbtam(gtru_p_8,MXPS,MXTRU,ntab,pstr)
      write(*,'("  -pstr=""",A,"""")') pstr

      allocate(ndx(MXTRU)        ,STAT=I);IF(I.NE.0) GOTO 901
      do i=1,MXTRU ; ndx(i)=i ; enddo



      if (.false.) then ! true/false skip (sorting)
         write(*,*) ' -gtru arrays sorted'

c--Sort GrTru values (RPID CLON CLAT DAYS HOUR MINU)
c ---sort keys go from low to high priority (ie, last call is highest)

      call orders(12,ndx,gtru_t_8(1,1),ntab,MXTS,8,2)   ! MINU
      call orders(12,ndx,gtru_t_8(2,1),ntab,MXTS,8,2)   ! HOUR
      call orders(12,ndx,gtru_t_8(3,1),ntab,MXTS,8,2)   ! DAYS
      call orders(12,ndx,gtru_t_8(7,1),ntab,MXTS,8,2)   ! CLAT
      call orders(12,ndx,gtru_t_8(8,1),ntab,MXTS,8,2)   ! CLON
      call orders(10,ndx,gtru_t_8(6,1),ntab,MXTS,8,2)   ! RPID

      write(*,'(a,$)') 'ndx(1-10): '
      write(*,'(1x,i5,$)') (ndx(i),i=1,10)
c...jaw -- sorting

      else  ! true/false skip it (sorting)
         write(*,*) ' -gtru arrays NOT sorted'
      endif ! true/false skip it (sorting)


c debug print
c     gtru_t_8      YEAR MNTH DAYS HOUR MINU RPID CLAT CLON SELV
c                     1    2    3    4    5    6    7    8    9
c     gtru_p_8      ALSE PRES PRLC  TMDP TMDB  WDIR WSPD
c     gtru_p_8      ALSE PMSL PRLC  TMDP TMDB  WDIR WSPD
c                     1    2    3     4    5     6    7
      if ( .false. ) then  ! skip it true/false -- debug gtru
      write(*,'(1x,a)') '-debug echo of gtru values'
      write(*,'(1x,a)') ' tstr >'//tstr//'<'
      write(*,'(1x,a)') ' pstr >'//pstr//'<'
      j1=16044  ; j2=j1+5
      j1=1      ; j2=j1+5
      j1=1      ; j2=MXTRU
c     nprlc=0                                      ! track PRLC content
      do j=j1,j2

        prlc_8=gtru_p_8( 3,j)                      ! track PRLC content
        if (ibfms(prlc_8).ne.0) cycle
        nprlc=nprlc+1 ; if (nprlc.gt.10) cycle

c       if ( ( j.gt.3 .and. j.lt.16046 ) .or.      ! sample each dtyp
c    &       ( j.gt.16048 .and. j.lt.16728 ) .or. 
c    &         j.gt.16730 ) cycle

c       write(*,'(2x,$)')
        write(*,'(1x,i5,$)') j                              ! rpt #
        write(*,6) (int(gtru_t_8(i,j)),i=1,5)               ! date/time
        write(*,'(2x,f6.2,1x,f7.2,$)') (gtru_t_8(i,j),i=7,8)! CLAT,CLON
        rval_8(1)=gtru_t_8(6,j) ; write(*,'(2x,a,$)')cval(1)! RPID
        write(*,'(1x,i5,$)') int( gtru_t_8(9,j) )           ! SELV


        write(*,'(1x,a,$)') '|p'
        write(*,'(3(1x,f7.0),$)') (gtru_p_8(i,j),i=1,3)! ALSE,PMSL,PRLC
        write(*,'(1x,a,$)') '|t'
        write(*,'(1x,f6.2,$)') gtru_p_8( 4,j)          ! TMDP
        write(*,'(1x,f6.2,$)') gtru_p_8( 5,j)          ! TMDB
        write(*,'(1x,a,$)') '|w'
        write(*,9) (gtru_p_8(i,j),i= 6, 7)             ! WDIR WSPD
        write(*,*) ! linefeed
      enddo
    6 format (1x,i4,2i2.2,".",2i2.2,$)
    9 format (1x,f4.0,1x,f5.1,$)

      write(*,'(1x,a,2i6)') '-nprlc,MXTRU=',nprlc,MXTRU   ! track PRLC
                                                          !  content

      write(*,'(  1x,a)') '--debug stop' ; stop
      endif ! true/false skip it -- debug gtru


      write(*,*) '--closing GrTru',luntru
      close(luntru)


      if ( .not. wr_prof ) write(*,*) '--NOT writing prof file',lunpro

c--Read aircraft profile prepbufr file
c-------------------------------------
      if ( .true. ) then ! false/true skip it (lunpro)

      dxymax=0   ! counter for max xy separation

c-- Open input a/c profile file
c     OPEN(lunpro,FORM='UNFORMATTED')
c     CALL OPENBF(0,'QUIET',1)                  ! debug
c     CALL MESGBC(lunpro,MSGT,ICOMP)

      write(*,*) '--open input a/c profile', lunpro
      call OPENBF(lunpro,'IN',lunpro)


c-- Open output a/c profile file
c     OPEN(lunout,FORM='UNFORMATTED')
      if ( wr_prof ) then
        write(*,*) '--open output a/c profile', lunout
        call OPENBF(lunout,'OUT',lunpro)
      endif ! wr_prof


c--Loop thru aircraft profile prepbufr file
      jmmin=400 ! counter for RPID matches in GTru
      jmmax=0   ! counter for RPID matches in GTru
      njm0=0    ! cntr for # profs where jm=0 -- rejected for output

      nr=0                        ! rpt counter
      nmsg=0                      ! msg counter
      nr1=0                       ! rpt counter -- non-skipped
      nmsg1=0                     ! msg counter -- non-skipped
      nhi=0                       ! rpt counter -- rejected high (idhgt)
      nrare=0                     ! rpt counter -- rejected high ( )
      nfar=0                      ! rpt counter -- rejected far (dmin)
      nt3=0                       ! rpt counter -- rejected typ=3xx
      nro=0                       ! rpt counter -- # written out

      ctyp0=" "
      do while( IREADMG(lunpro,ctyp,idate).EQ.0 )
      nmsg=nmsg+1
      msub = nmsub(lunpro)

      if ( ctyp(1:6) .ne. 'AIRCFT' .and. ctyp(1:6) .ne. 'AIRCAR' ) then 
        write(*,*)
        write(*,*) 'ctyp=>',ctyp,'< -- not supported - exiting'
c       stop 9
        CALL W3TAGE('PREPOBS_PREPACPF')
        call errexit(9)
      endif ! ctyp != AIRCFT or AIRCAR

      if ( ctyp .ne. ctyp0 ) then 
        if ( ctyp0 .ne. " " .and. .false. ) write(*,*) ! linefeed
        ctyp0=ctyp
        write(*,*) ' ctyp="'//ctyp//'" idate=',idate
      endif ! ctyp != ctyp0

c-- skip AIRCFT reports
ccc   if ( ctyp(1:6) .ne. 'AIRCAR' .and. .true. ) then 
      if ( ctyp(1:6) .eq. 'AIRCFT' .and. .false. ) then 
        nr=nr+msub
        cycle
      endif ! not AIRCFT
      nmsg1=nmsg1+1


      do while (iREADSB(lunpro) .eq. 0) 
      nr=nr+1

c     if ( nr .lt. 524                  ) cycle          ! poaf=6
ccc   if ( nr .lt. 397 .or. nr .gt. 397 ) cycle
ccc   if ( nr .lt. 236 .or. nr .gt. 238 ) cycle
ccc   if ( nr.ne.236 .and. nr.ne.237 .and. .false. .and. ! nrmin, nrmax
ccc  &     nr.ne.238 .and. nr.ne.257 .and. nr.ne.270 ) cycle
ccc   if ( nr1.gt.5 .and. nr.ne.270 .and. nr.ne.272 .and.        ! jm=0
ccc  &     nr.ne.289 .and. nr.ne.296 .and. nr.ne.302 ) cycle

c...jaw -- special prof filtering
      nr1=nr1+1

c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c AIRCFT/AIRCAR processing

c AIRCAR/AIRCFT == HEADR ACID/RCT {PRSLEVLA}
c HEADR ==
c  SID  XOB YOB DHR ELV TYP T29 TSB  ITP  SQN PROCN  RPT  TCOR <RSRD_SEQ>
c      lon lat                     instr           otime
      
      call ufbseq(lunpro,hdr_8,MXNM,1,nhdr,'HEADR')
      rval_8(1)=hdr_8(1)                               ! SID
      rlon0 = hdr_8(2)
      if ( rlon0 .gt. 180 ) rlon0=rlon0-360.
      rlat0 = hdr_8(3)

      dhr_8 = hdr_8(4)                                 ! t_ob - t_cycle
      iz0 = int( hdr_8(5) )                            ! elev (ELV)

c--         lon lat drft_t ph_flt turb Pres Temp Hgt PrQM HgtQM nrlQM
c     cnem='XDR YDR HRDR    POAF  DGOT  POB TOB  ZOB  DDO FFO UOB VOB'
       ! v1 btab

      cnem='XDR YDR HRDR    POAF  TRBX  POB TOB  ZOB  DDO FFO UOB VOB'
       ! v2 btab

      usr2_8=bmiss
      call ufbint(lunpro,usr2_8,MXNM,255,nlev,cnem)


c-- Get lat/lon/elev for minimum height ob
c--- assume minimum height obs occur at 1st replication (lev=1)

      llow=1
      izmin = int( usr2_8(8,llow) )  ! DAK: could usr2_8(8,llow) missing
                                     !      cause a problem here??
      MAXHGT=5000
      if ( izmin.gt.MAXHGT .and. .false. ) then  ! exclude 'high' rpts
        nhi=nhi+1                        ! max hgt in metar.tbl = 4057
        nr1=nr1-1   ! reset counter
        cycle
      endif ! izmin > MAXHGT

      ityp=int( hdr_8(6) )
      if ( ityp/100 .eq. 3 .and. .true. ) then        ! exclude typ=3xx 
        nt3=nt3+1
        cycle
      endif ! ityp/100 = 3

      rlonmin = usr2_8(1,llow)
      if ( rlonmin .gt. 180 ) rlonmin=rlonmin-360.
      rlatmin = usr2_8(2,llow)
        dtlow_8 = usr2_8(3,llow)                    ! hrdr of low prof


c--Begin output

c---Columns header
      if (wr_hdr) then 
        wr_hdr = .false.
        write(*,50) 'rpt','XOB','YOB','ZOB'
        write(*,51) 'stn','lon','lat','hgt'
c       write(*,52) 'dXY','dhgt'
      endif ! wr_hdr
   50 format(/,1x,a,3(4x,a),$)
   51 format(3x,a,1x,2(4x,a),3x,a,$)
   52 format(3x,a,3x,a,$)


c--Test: what is max delta xy (j-1 -> j) for lowest levs? 
      if ( .false. ) then  ! true/false skip it -- dxy
        dxyjmax=0
        do j=2,min( nlev, 6 )
          dxyj = dsqrt( ( usr2_8(1,j) - usr2_8(1,j-1) )**2 + 
     &                  ( usr2_8(2,j) - usr2_8(2,j-1) )**2 )
          if ( abs(dxyj) .gt. dxyjmax ) then 
            dxyjmax=abs(dxyj)
            jmax=j
          endif
        enddo ! j=2,nlev
        write(*,'(1x,a,1x,f6.1,1x,i3, $)') 'x=',dxyjmax*111., jmax
        if ( dxyjmax .gt. 5./111. .and. .false. ) bylev = .true.
      endif ! true/false -- dxy


c--Find Nearest Station in Table
c--- lon,lat,hgt == rlonmin, rlatmin, izmin
c ( b1 + 180 ) / binwidth + 1 = j

c-find index into station table to start search
      rlon= rlonmin - binwidth              ! backup 1 bw (ease factor)
      j=  int( (rlon + 180.)/binwidth ) + 1
      b1= slon(lptr(j))                     ! j bin start
      b2= b1 + binwidth * 3.                ! start lon + 3 bins
c     write(*,'(1x,a,1x,f7.2,1x,i3,2(1x,f7.2),$)') '|',rlon,j, b1,b2
c     write(*,'(a,3(1x,i4),$)')' ||',lptr(j),lptr(j+3),lptr(j+3)-lptr(j)

c-loop thru stations & calc xy distance.
c     write(*,*) ! linefeed
      ns=0
      dmin=1.d5
      l=lptr(j)
c     l=1                                     ! *** debug: all stns
      lmin=l
cppppppppppppppp
cdak  print *, 'initially: l,ns = ',l,ns
cppppppppppppppp
      do while (slon(l) .le. b2 .or. .false.) ! *** db: true == all stns

        slon2 = slon(l)
        slat2 = slat(l)
        d = gcirc_qc(slat2,slon2,rlatmin,rlonmin)/ 1.d3  ! dist in km
        if ( d .lt. dmin) then 
          dmin = d
          lmin = l
        endif ! d < dmin

c       write(*,'(/,3x,i4,3x,i4,1x,f7.2,1x,f6.2,1x,f9.3,$)')
c    &    ns,l,slon2,slat2,d

        l=l+1
        ns=ns+1
cppppppppppppppp
cdak  print *, 'l,ns,nstot = ',l,ns,nstot
cppppppppppppppp
        if ( l.gt.nstot ) then  ! added by DAK 3/6/13 to avoid slon array
                                !  overflow
           print *, 'WARNING: l in loop exceeds nstot - exit loop'
cccccccc   print *, ' -- Jeff Whiting needs to look into this!!!!!'
           exit
        endif
c       if ( ns.ge.nstot ) exit                  ! *** db: ck all stns
      enddo ! while slon < b2

c-write out results of search
      idhgt=izmin-ishgt(lmin)                    ! dHgt = ZOB(1)-stnHgt

      if (wr_stn) then

c     write(*,'(/,i3,i4,$)') nmsg, nr
      write(*,'(/,   i4,$)')       nr

c     write(*,'(1x,a,$)') cval(1)                ! SID
      write(*,61) rlonmin ,rlatmin               ! XOB(1), YOB(1)
   61 format(1x,f7.2,1x,f6.2,$)

      write(*,'(1x,i5,$)') izmin                 ! ZOB(1)
c     write(*,'(1x,f9.5 ,$)') dtlow_8            ! HRDR(1) (hrs)

      write(*,85)  ' |',stid(lmin),slon(lmin),slat(lmin),ishgt(lmin)
   85 format(a,1x,a,1x,f7.2,1x,f6.2,1x,i4                ,$)
      write(*,'(1x,a,i4,$)') '|| #stn chkd=',ns
      write(*,86)  ' |',dmin,idhgt                       ! Far, Hi
   86 format(                             a,1x,f4.1,1x,i5,$)
      endif ! wr_stn


c-skip profs that are too high (meters/pressure) or too far (km)
      if (.true.) then ! true/false skip it -- rejections
      LOW=300 ; RARE=30 ; rNEAR=10
      if (idhgt.gt.LOW .and. .true.) then
        if (wr_stn) write(*,'(2(1x,a,i5),$)') '||hi:',idhgt,'>',LOW
        nhi=nhi+1
        cycle
      endif ! Idhgt<LOW
          ! DAK: to avoid compiler initialization warning, set dpres to
          !      zero - appears if-test below never satisfied anyway
          !      since .false. in if-test
             dpres = 0.
      if ( dpres.gt.RARE .and. .false.) then
        if (wr_stn) write(*,'(2(1x,a,i5),$)') '||dp:',dpres,'>',RARE
        nrare=nrare+1
        cycle
      endif ! dpres<RARE
      if (dmin.gt.rNEAR .and. .true.) then
        nfar=nfar+1
        if (wr_stn) 
     &    write(*,'(1x,a,f4.1,1x,a,f4.1,$)') '||far:',dmin,'>',rNEAR
        cycle
      endif ! dmin<rNEAR
      endif ! true/false skip it -- rejections

c ---400mb total column height
c ...jaw - GDiMego suggests above filter


c--Output by level
      if ( bylev ) then 

      nlevpr=min(nlev,5)      ! number of levs to print
      nlevpr=min(nlev,255)    ! number of levs to print
c     if ( nmsg.eq.31 .and. nr.eq.117 ) nlevpr=nlev
      if ( nlevpr.gt.1 ) 
     &  write(*,'(/, 3x,a,i3,1x,2a,$)') 'n=',nlev,
     &    ' lon    lat   Z(m)     hrdr   dX(km) dt(min)',
     &    '  kph   dZ(m)  phF  P(mb)    T(c)' //
     &    '  W(deg) W(m/s)   W-u   W-v'

      do k=1,nlevpr
        j=k                               ! print out 1st nlevpr-2 levs
        if (k.eq.nlevpr-1) j=nlev-1       !  followed by the nlevpr-1 &
        if (k.eq.nlevpr) j=nlev           !  nlevpr levs

        if ( nlev.gt.1 ) then 
c         write(*,'(/,i3,i4 ,$)') nmsg, nr                  ! nmsg, nr
          write(*,'(/,3x,1x,i2 ,$)') j                      ! j

          rlon=usr2_8(1,j)
          if ( rlon .gt. 180 ) rlon=rlon-360.
          write(*,'(1x,f7.2,1x,f6.2 ,$)') rlon, usr2_8(2,j) ! lon(XDR),
                                                            ! lat(YDR)

c-- Observation height
          iz = int(usr2_8(8,j))
          write(*,'(1x,i5 ,$)') iz                  ! hgt (m) (ZOB)

c-- Drift time (t_drift - t_cycle)
          t = usr2_8(3,j)
          write(*,'(1x,f9.5 ,$)') t                 ! time (HRDR)

c-- horizontal offset in km (plane geometry)
          dxy = dsqrt( ( rlon-rlon0 )**2 + ( usr2_8(2,j)-rlat0 )**2 )
          dxy = dxy * 1.11d2
          write(*,'(1x,f6.1 ,$)') dxy               ! horiz dist (km)

          if (dxy.gt.dxymax .and. .true.) dxymax=dxy

c-- time offset in minutes
c      (t_drift-t_cycle) - (t_ob-t_cycle) == t_drift-t_ob
          dt = (usr2_8(3,j) - dhr_8) * 60.d0
          write(*,'(1x,f6.2 ,$)') dt                ! elapsed time (hr)

c-- horizontal velocity
          if ( j .gt. 1 ) then 
            dTj   = ( usr2_8(3,j) - usr2_8(3,j-1) ) * 60.d0 !! dT in min
            dlonj = usr2_8(1,j) - usr2_8(1,j-1)
            dlatj = usr2_8(2,j) - usr2_8(2,j-1)
            dXj = dsqrt( ( usr2_8(1,j) - usr2_8(1,j-1) )**2 + 
     &                   ( usr2_8(2,j) - usr2_8(2,j-1) )**2 ) * 1.11d2
                                                         !! dX in km
c           write(*,'(1x,f6.1,1x,f8.5 ,$)') dXj, dTj     ! dX(km),
                                                         ! dT(min)
            if ( dTj .gt. 1.d-5 ) then
              vj = dXj / dTj * 60.d0                       !! v in kph
              write(*,'(1x,f7.1 ,$)') vj * 1.d5 / 2.54 / 12. / 5280.
                                                    ! velocity in kph
            else
              write(*,'(1x,a7 ,$)') 'n/a '
            endif ! dTj > .00001
          else
ccccccccc   write(*,'( 8x ,$)')
            write(*,'(1x,a7 ,$)') '       '
          endif ! j ne 0

        endif ! nlev > 1

c-- hgts offset from elevation
        idz = iz - iz0                              ! ZOB - ELV
c       idz = int( float(idz) / 2.54d-2 / 12.d0 )   ! convert hgt to ft
        write(*,'(1x,i6 ,$)') idz

c-- Phase of aircraft flight
c  POAF == 0-1:RSV 2:UNS 3:LVL 4:LVw/W 5:ASC 6:DES 7:MSG' # 0-08-004
        ipoaf = int(usr2_8(4,j))
        if (ibfms(usr2_8(4,j)).ne.0) ipoaf = -1
        write(*,62) ipoaf                 ! phase of flight (POAF)
   62 format(1x,i3, $)

        write(*,63) usr2_8(6,j)           ! pressure (mb) (POB)
   63 format(1x,f7.1, $)

        write(*,64) usr2_8(7,j)           ! temperature (c) (TOB)
   64 format(1x,f7.1, $)

        write(*,65) (usr2_8(i,j),i=9,10)  ! wind dir, spd (DDO, FFO)
   65 format(2x, 1x,f4.0,1x,f5.1,$)

        write(*,66) (usr2_8(i,j),i=11,12) ! wind u-, v-  (UOB, VOB)
   66 format(2x,    2(1x,f5.1),$)

      enddo ! k=1,nlev

      endif ! bylev
c+++++

c     if ( nr .ge. 3 .and. .true.  ) then 
c       print '(/,a)', "debug stop"
c       stop
c     endif

c AIRCFT/AIRCAR processing
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


c---Get time of lowest profile observation
c --- dtlow_8 == t(1) == hrdr(1) == usr2_8(3,1) == t{lowest ob}-t{cyc} (hr)

c     write(*,'(/,8x,a,$)') 'dtlow_8, dtlow_8*60, dhr_8, dhr_8*60: '
c     write(*,'(2(1x,f9.5,1x,f6.3,$)') dtlow_8,dtlow_8*6.d1,dhr_8,
c    &                                 dhr_8*6.d1

c--cycle time (idat: year, mon, day, tzone, hr, min, sec, msec)
      iyr=idate/1000000
      imm=mod(idate/10000,100)
      idd=mod(idate/100,100)
      ihr=mod(idate,100)

c     integer idat(8)   ! cycle time (yr,mon,day,tzone,hr,min,sec,msec)
      idat=0
      idat(1)=iyr
      idat(2)=imm
      idat(3)=idd
      idat(5)=ihr

c--time increment (rinc: day, hr, min, sec, msec)
c     real    rinc(5)     ! time increment (day,hr,min,sec,msec)
      rinc=0
      rinc(2)=dtlow_8     ! HRDR(1): dt of low prof
      
c--time of (lowest) ob
c  w3movdat(rinc,idat,itob): itob(ymd/hmss)= idat(ymd/hmss)+rinc(dh/mss)
      call w3movdat(rinc,idat,itob)
      if (wr_match) then
        write(*,'(/,1x,a,$)') 't_ob_low:'
        write(*,7) (itob(i),i=1,3),(itob(i),i=5,8)! low ob date/time
        write(*,'(1x     ,f8.5,$)') dtlow_8       ! dt: low prof - cycle
      endif ! wr_match


c---Search GTru array for match
      rpid=stid(lmin) 
      jm=0                     ! counter for # of matching gtru stns
      tdif0=120.               ! minimum time diff threshold (hrs)
      do l=1,MXTRU
        j=ndx(l)
        rval_8(1)=gtru_t_8(6,j)        ! RPID
        if ( rpid.eq.cval(1) ) then 
          jm=jm+1

c-Gr Truth Time in NCEP time format (yr,mon,d,t_zone,h,min,s,ms)
          itru0=0
          itru0(1)=int(gtru_t_8(1,j))  ! year
          itru0(2)=int(gtru_t_8(2,j))  ! month
          itru0(3)=int(gtru_t_8(3,j))  ! day
          itru0(5)=int(gtru_t_8(4,j))  ! hour
          itru0(6)=int(gtru_t_8(5,j))  ! minute

c-low profile time - gr_tru time
          rinc=0
          call w3difdat(itob,itru0,0,rinc)        ! rinc = itob - itru0

          tdif = (( rinc(5)/1.d3 + rinc(4) ) / 60.d0 ! secs to minutes
     &            +                rinc(3) ) / 60.d0 ! minutes to hours
     &            +                rinc(2)           ! hours
     &            +                rinc(1) * 24.d0   ! days to hours

c-find minimum time diff & note g_tru record #
          if ( abs(tdif).lt.abs(tdif0) ) then 
            tdif0=tdif                      ! min t: low prof - gr_tru
            ngtru=j                         ! gtru record w/ min tdif
            itru=itru0                      ! matching gtru time values
          endif ! tdif < tdif0


c--Echo all matching stations
c tstr        YEAR MNTH DAYS HOUR MINU RPID CLAT CLON SELV
c gtru_t_8      1    2    3    4    5    6    7    8    9
          if ( wr_match ) then  
            write(*,'(/,2x,i2,$)') jm                      ! match #
            write(*,'(1x,i5,$)') j                         ! rpt #
c           write(*,7) (int(gtru_t_8(i,j)),i=1,5),0,0      ! date/time
            write(*,7) (itru0(i),i=1,3),(itru0(i),i=5,8)   ! date/time
c           write(*,'(2x,f6.2,1x,f7.2,$)') (gtru_t_8(i,j),i=7,8)! CLAT,
                                                                ! CLON
            write(*,'(2x,f7.2,1x,f6.2,$)')(gtru_t_8(i,j),i=8,7,-1)!CLON,
                                                                  !CLAT
                           write(*,'(2x,a,$)') cval(1)(1:4)     ! RPID
            write(*,'(1x,i5,$)') int( gtru_t_8(9,j) )           ! SELV

c           write(*,'(  1x,a,$)') '|| tdif:'
c           write(*,28) (abs(int(rinc(i))),i=1,5)
c  28 format (1x,    i2.2,".",3i2.2,'.',i3.3,$)        ! packed print
cj          write(*,18) (int(rinc(i)),i=1,5)
cj 18 format (1x,  i2,3(1x,i3.2),1x,i4.3,$)            ! unpacked print

            write(*,'(1x,a,1x,f8.5,$)') '| dt:',tdif
            write(*,'(1x,a,1x,f8.5,1x,i6,$)') '||',tdif0, ngtru

          endif ! wr_match
        endif ! rpid = cval(1) [matching gtru stns]
      enddo ! l=1,MXTRU
      if ( jm.lt.jmmin ) then ; jmmin=jm ; nrmin=nr ; endif
      if ( jm.gt.jmmax ) then ; jmmax=jm ; nrmax=nr ; endif


c Trap case where no matching station is found
      if ( jm.eq.0 ) then 
        njm0=njm0+1
        if ( .true. ) write(*,'(/,a,2(1x,i4),$)') 
     &    'ERROR -- no matches found; jm,njm0: ',jm,njm0
        cycle                               ! break out of lunpro loop
c...jaw -- is this right?
      endif ! jm=0


c--Designate parms for output
c  tstr        YEAR MNTH DAYS HOUR MINU RPID CLAT CLON SELV
c  gtru_t_8      1    2    3    4    5    6    7    8    9
c  pstr        ALSE PMSL PRLC  TMDP TMDB  WDIR WSPD        ! metar-ish
c  gtru_p_8      1    2    3     4    5     6    7

c-time (drift info)       ! DHR(rinc) = cycletime(idat) - stntime(itru)
      rinc=0
      call w3difdat(itru,idat,0,rinc)            ! dt: stn - cycle time
      dt_tru_8 =                                 ! DHR (hr)
     &           (( rinc(5)/1.d3 + rinc(4) ) / 60.d0  ! secs to minutes
     &            +                rinc(3) ) / 60.d0  ! minutes to hours
     &            +                rinc(2)            ! hours
     &            +                rinc(1) * 24.d0    ! days to hours


c-location (CLON, CLAT, ...  izmin SELV)
      x_gtru_8=gtru_t_8(8,ngtru)                  ! CLON (deg)
      x_tru_8=x_gtru_8
      if (x_tru_8.lt.0.) x_tru_8=x_tru_8+360.     ! XOB/XDR (deg 0-360)
      y_tru_8=gtru_t_8(7,ngtru)                   ! CLAT (deg)
      z_tru_8=gtru_t_8(9,ngtru)                   ! SELV (m)

c-pressure -- convert Altimeter Setting (ALSE) to Station Pressure
c     p_tru_8=gtru_p_8(2,ngtru)                   ! PMSL (P)
      altim_8=gtru_p_8(1,ngtru)                   ! ALSE (P)

      if(ibfms(z_tru_8).eq.0 .and. ibfms(altim_8).eq.0)  then
         pstn_8=p_f_a(altim_8*0.01, z_tru_8)      ! stn pres (mb)
         p_tru_8=pstn_8
      else
         p_tru_8=bmiss
      endif

c-temperature (dewpoint & dry bulb)
      t_tru_dp_8=gtru_p_8(4,ngtru)                ! TMDP (K)
      t_tru_db_8=gtru_p_8(5,ngtru)                ! TMDB (K)

c-winds (dir & spd)
      wd_tru_8=gtru_p_8(6,ngtru)                  ! WDIR (deg)
      ws_tru_8=gtru_p_8(7,ngtru)                  ! WSPD (m/s)

      if(ibfms(ws_tru_8).eq.0 .and. ibfms(wd_tru_8).eq.0) then
         w_u_8=ws_tru_8 * cos(wd_tru_8*DEG_RAD)   ! u- wind (m/s)
         w_v_8=ws_tru_8 * sin(wd_tru_8*DEG_RAD)   ! v- wind (m/s)
      else
         w_u_8=bmiss
         w_v_8=bmiss
      endif

      if(ibfms(ws_tru_8).eq.0) then
         ws_tru_k_8=ws_tru_8 * 1.944d0            ! wspd (knots)
      else                                        ! (1 m/s= 1.944 knots)
         ws_tru_k_8=bmiss
      endif

c--Echo matching station info
      if (wr_stn) then 

ccc     write(*,'(/,3x,1x,i2 ,$)') 0
ccc     write(*,'(1x,f7.2,1x,f6.2 ,$)') x_gtru_8,y_tru_8  ! stn lon,lat
ccc     write(*,'(1x,i5 ,$)') int(z_tru_8)                ! stn elv (m)
ccc     write(*,'(1x,f9.5 ,$)') t                         ! time (hrdr)

c       write(*,'(/,1x,a,1x,i5,$)') 'stn |#',ngtru
        write(*,'(/,1x,a,1x,i5,$)') 'Stn:',ngtru

c       write(*,'(1x,a,$)') '| xyz:'
        write(*,'(1x,f7.2,1x,f6.2,$)') x_gtru_8,y_tru_8  ! stn lon,lat
        write(*,'(2x,a,$)') rpid(1:4)                    ! gr stn id (rpid)
        cstr=rpid                                  ! -- equiv to rstr_8
        write(*,'(1x,i5,$)') int(z_tru_8)            ! stn elv (m)

c       write(*,'(1x,a,$)') 't_ob:'
c       write(*,7) (itob(i),i=1,3),(itob(i),i=5,8)   ! low prof time

c- Pres,Temp,Winds
        write(*,'(1x,a        ,$)') '|P'
c       write(*,'(1x     ,f6.1,$)')       p_tru_8/1.d2  ! pressure (mb)
        write(*,'(1x     ,f6.1,$)')       p_tru_8       ! pressure (mb)
c       write(*,'(1x,a        ,$)') '|T'
        write(*,'(1x     ,f5.2,$)')      t_tru_db_8-273.15 ! temp db (c)
        write(*,'(     1x,f5.2,$)')      t_tru_dp_8-273.15 ! temp dp (c)
c       write(*,'(1x,a,$)') '|W'
        write(*,9)                wd_tru_8,ws_tru_8      ! wind dir,spd
c       write(*,'(1x,a,$)') '|uv'
        write(*,'(2(1x,f5.1,$))') w_u_8,w_v_8       ! wind u-, v- (m/s)

c- Times
c       write(*,'(/,1x,a,$)') 'stn_t:'
c       write(*,'(1x,a,$)') '|t'
c       write(*,8) (idat(i),i=1,3),(idat(i),i=5,6)  ! cycle time
c...jaw -- dt_tru_8 needs work
        write(*,8) (itru(i),i=1,3),(itru(i),i=5,6)  ! matching gtru time
        write(*,'(1x     ,f8.5,$)') dt_tru_8        ! dt: cycle - gtru
c       write(*,'(1x,a,1x,f5.3,$)') '|dt',tdif0
c       write(*,'(1x,a,1x,f8.5,$)') '|td0',tdif0
        write(*,'(1x     ,f8.5,$)') tdif0           ! dt: low prof - gtru

        write(*,'(1x     ,f8.5,$)') tdif0-dt_tru_8  ! dt: low prof - cycle

    7 format (1x,i4,2i2.2,".",3i2.2,'.',i3.3,$)   ! ccyymmdd.hhmiss.msec
    8 format (1x,i4,2i2.2,".",2i2.2         ,$)   ! ccyymmdd.hhmi

c-jaw #gt_mtch sometimes = 0  -- mod: make stn tbl from gtru file
        write(*,'(1x,a,i3,$)') '|| #gt=', jm

        if ( ( nr.eq.nrmin .or. nr.eq.nrmax ) .and. .false. ) 
     &    write(*,'(/,3x,a,2x,a,4(2x,i5),$)') '-> ',
     &    rpid,jm,jmmin,jmmax,nr

        write(*,*)
      endif ! wr_stn



c-- Write output prepbufr profile records

      if ( wr_prof ) then 

c-open output message as needed
      call openmb(lunout,ctyp,idate)

c AIRCAR => HEADR ACID {PRSLEVLA}

c HEADR =>
C     SID XOB YOB DHR ELV TYP T29 TSB ITP SQN PROCN RPT TCOR <RSRD_SEQ>
c     write(*,'(/,a,$)') '-headr'
c     rval_8(1)=hdr_8(1)
c     write(*,*) cval(1),(hdr_8(i),i=2,13)
ccc   call ufbseq(lunout,hdr_8,MXNM,1,iret,'HEADR')
      usr_8=bmiss
      cnem='SID XOB YOB DHR ELV TYP T29 TSB ITP SQN PROCN RPT TCOR'
      call ufbint(lunpro,usr_8,MXNM,1,iret,cnem)
c--populate HEADR output mnems w/ ground stn info
c     usr_8(1)=bmiss                                ! stn id -> SID
      usr_8(2)=x_tru_8                              ! stn lat -> XOB
      usr_8(3)=y_tru_8                              ! stn lon -> YOB
c     usr_8(4)=dt_tru_8                             ! stn time offset -> DHR
      usr_8(4)=dtlow_8                              ! low obs time -> DHR
      if(ibfms(z_tru_8).eq.0) usr_8(5)=int(z_tru_8) ! stn SELV -> ELV

c -- synch RPT w/ ground stn time (not lev1 from prof)..done to here JAW
      rpt_8=dt_tru_8 ; if ( rpt_8.lt.0 ) rpt_8=rpt_8+24.
      usr_8(12)=rpt_8                  ! t_tru - t_cycle (24hr) -> RPT

      call ufbint(lunout,usr_8,MXNM,1,iret,cnem)

c RSRD_SEQ == RSRD EXPRSRD
      cnem='RSRD EXPRSRD'     
      call ufbint(lunpro,usr_8,MXNM,1,iret,cnem)

c SID (gr stn ID), ACID (tail #)
      cnem='SID ACID'                  ! in: SID == tail#; ACID == flt#
      call ufbint(lunpro,usr_8,MXNM,1,iret,cnem)

      usr_8(2)=usr_8(1)                  ! ACID <- tail# (SID)
      usr_8(1)=rstr_8                    ! SID <- gr stn ID (rpid)
      call ufbint(lunout,usr_8,MXNM,1,iret,cnem)

c PRSLEVLA =>
c   RCT ROLF MSTQ IALR CAT 
c       <P___INFO> <Q___INFO> <T___INFO> <Z___INFO> <W___INFO>
c       <DRFTINFO> <ACFT_SEQ> <TURB1SEQ> <TURB2SEQ> {TURB3SEQ}  ! ver2
c       {PREWXSEQ} {CLOUDSEQ} {AFIC_SEQ}  NRLQMS                ! ver2

      nnem=5        ! # of mnemonics
      cnem='RCT ROLF MSTQ IALR CAT'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss 
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
      out2_8(5,1)=0                ! CAT = 0 == surface report
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)

c P___INFO == [P__EVENT] <P__BACKG> <P__POSTP>
c == [POB PQM PPC PRC] <POE PFC <PFCMOD>> <PAN <PCL PCS> POETU PVWTG
C     PVWTA>
      nnem=13       ! # of mnemonics
      cnem='POB PQM PPC PRC POE PFC PFCMOD PAN PCL PCS ' // 
     &     'POETU PVWTG PVWTA'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     out2_8(1,1)=p_tru_8/1.d2       ! p_tru_8 (mb)
      out2_8(1,1)=p_tru_8            ! p_tru_8 (mb)
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)
c     write(*,'(a,$)') 'pr'; write(*,'(f8.2,$)')(pro2_8(1,j),j=1,nlev)
c     write(*,'(/,a,$)') 'pr'; write(*,'(f8.2,$)')(out2_8(1,j),j=1,nlev)

c Q___INFO == [Q__EVENT] TDO <Q__BACKG> <Q__POSTP>
c == [QOB QQM QPC QRC] TDO <QOE QFC <QFCMOD>> <QAN <QCL QCS> QOETU
c     QVWTG QVWTA ESBAK>
      nnem=15
      cnem='QOB QQM QPC QRC TDO QOE QFC QFCMOD QAN QCL QCS ' //
     &     'QOETU QVWTG QVWTA ESBAK'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
                                    ! t_tru_dp_8 = gtru_p_8(TMDP)-273.15
      if(ibfms(t_tru_dp_8).eq.0) out2_8(5,1)=t_tru_dp_8-273.15
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)

c T___INFO == [T__EVENT] TVO <T__BACKG> <T__POSTP>
c  == [TOB TQM TPC TRC] TVO <TOE TFC <TFCMOD>> <TAN <TCL TCS> TOETU
c      TVWTG TVWTA>

      nnem=14
      cnem='TOB TQM TPC TRC TVO TOE TFC TFCMOD TAN TCL TCS ' // 
     &     'TOETU TVWTG TVWTA'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
                                    ! t_tru_db_8 = gtru_p_8(TMDB)-273.15
      if(ibfms(t_tru_db_8).eq.0) out2_8(1,1)=t_tru_db_8-273.15
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)

c Z___INFO == [Z__EVENT] <Z__BACKG> <Z__POSTP>
c  == [ZOB ZQM ZPC ZRC] <ZFC <ZFCMOD>> <ZAN <ZCL ZCS>>
      nnem=9
      cnem='ZOB ZQM ZPC ZRC ZFC ZFCMOD ZAN ZCL ZCS'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
      out2_8(1,1)=ishgt(lmin)                  ! sfc hgt -> ZOB(1)
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)

c W___INFO == [W__EVENT] [DF_EVENT] <W__BACKG> <W__POSTP> 
c  == [UOB VOB WQM WPC WRC] [DDO FFO DFQ DFP DFR] 
c        <WOE UFC VFC <UFCMOD VFCMOD>> <UAN VAN <UCL UCS VCL VCS> 
c           WOETU WVWTG WVWTA RF10M>

      nnem=10
      cnem='UOB VOB WQM WPC WRC DDO FFO DFQ DFP DFR '
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
      out2_8(1,1)=w_u_8       ! wind u- == f(WDIR,WSPD) (m/s)
      out2_8(2,1)=w_v_8       ! wind v- == f(WDIR,WSPD) (m/s)
      out2_8(6,1)=wd_tru_8    ! ddo = wd_tru_8 = gtru_p_8(WDIR)
      out2_8(7,1)=ws_tru_k_8  ! ffo = ws_tru_k_8 = gtru_p_8(WSPD) (knots)
                              !  (1 m/s = 1.944 knots)
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)

      nnem=15
      cnem='WOE UFC VFC UFCMOD VFCMOD UAN VAN UCL UCS VCL VCS ' //
     &     'WOETU WVWTG WVWTA RF10M'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     no changes to surface level in this sequence
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)

c <DRFTINFO> <ACFT_SEQ> <TURB1SEQ> <TURB2SEQ> =>
c  == XDR YDR HRDR  PCAT POAF  TRBX  TRBX10 TRBX21 TRBX32 TRBX43
      nnem=10
      cnem='XDR YDR HRDR PCAT POAF TRBX TRBX10 TRBX21 TRBX32 TRBX43'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
      out2_8(1,1)=x_tru_8                          ! stn lat -> XDR(1)
      out2_8(2,1)=y_tru_8                          ! stn lon -> YDR(1)
      out2_8(3,1)=dt_tru_8                         ! stn dt -> HRDR(1)
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)


c {TURB3SEQ} => DGOT HBOT HTOT
      nnem=3
      cnem='DGOT HBOT HTOT'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     no changes to surface level in this sequence
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)
c ...jaw -- this needs updating for full replication output


c {PREWXSEQ} => PRWE
      nnem=1
      cnem='PRWE'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     no changes to surface level in this sequence
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)
c ...jaw -- this needs updating for full replication output

c {CLOUDSEQ} =>
c  == VSSO CLAM CLTP  HOCB HOCT
      nnem=5
      cnem='VSSO CLAM CLTP HOCB HOCT'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     no changes to surface level in this sequence
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)
c ...jaw -- this needs updating for full replication output
 

c {AFIC_SEQ} == AFIC HBOI HTOI
      nnem=3
      cnem='AFIC HBOI HTOI'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     no changes to surface level in this sequence
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)
c ...jaw -- this needs updating for full replication output


c NRLQMS
      nnem=1
      cnem='NRLQMS'
      call ufbint(lunpro,pro2_8,MXNM, 255,nlev,cnem)
      out2_8=bmiss
      out2_8(1:nnem,2:nlev+1)=pro2_8(1:nnem,1:nlev)
c     no changes to surface level in this sequence
      nlev=nlev+1
      call ufbint(lunout,out2_8,MXNM,nlev,iret,cnem)
c ...jaw -- this needs updating for full replication output


cjaw -- for writing out event stack
cjaw  *** DKeyser suggests using UFBCPY then UFBINT ***
cjaw  cnem='NRLQM'
cjaw  call ufbevn(lunpro,pro3_8,MXNM, 255,nlev,nevn,cnem)
cjaw  call ufbseq(lunout,pro3_8,MXNM,nlev,iret,nevn,'NRLQMSEQ')
cjaw  write(*,*) 'nrlqm',nlev,nevn,iret
cjaw -- for writing out event stack

c...jaw -- done to here

c *** to repeat events, use UFBIN3 ***
c ************************************
cjaw  cnem='POB PQM PPC PRC'
cjaw  call ufbin3(lunpro,pro3_8,20,10000,255,nlev,nevn,cnem)
cjaw  write(*,'(1x,a,2i3,$)') 'P_ev',nlev,nevn

cjaw  do j=1,nlev
cjaw  write(*,'(/,i2,$)')  j
cjaw  write(*,'(i2,4(1x,f7.2,$))') (k,(pro3_8(i,j,k),i=1,4),k=1,nevn)
cjaw  enddo ! j=1,nlev
c ************************************
c *** to repeat events, use UFBIN3 ***



c-commit subset/report to output file
      call writsb(lunout) 

      nro=nro+1                ! increment counter, # rpts written out

      endif ! wr_prof


c--Exit on print or outfile thresholds
      nr1max=4
      nr1max=0
      if ( nr1 .ge. nr1max .and. nr1max.ne.0 ) exit ! debug

      nromax=12
      nromax=0
      if ( nro .ge. nromax .and. nromax.ne.0 ) exit ! debug


c--- end of read subset loop -------------------------------------------
      end do ! while ireadsb

c-make exact copy to output
      if ( .false. ) then  ! skip it (copymg)
        call copymg(lunpro,lunout)
      endif ! skip it (copymg)

      nr1max=4
      nr1max=0
      if ( nr1 .ge. nr1max .and. nr1max.ne.0 ) then
        write(*,*)
        write(*,*) ' -exiting w/ nr1=',nr1
        exit ! debug
      endif ! nr1 > nr1max

      nromax=12
      nromax=0
      if ( nro .ge. nromax .and. nromax.ne.0 ) then
        write(*,*)
        write(*,*) ' -exiting w/ nro=',nro
        exit ! debug
      endif ! nro > nromax

      if ( nmsg1.ge.  3 .and. .false.) then 
        write(*,*)
        write(*,*) ' -exiting w/ nmsg1=',nmsg1
        exit ! debug
      endif ! nmsg1 > 3

      end do ! while ireadmg

      if ( wr_prof) call closmg(lunout)
      if ( wr_prof) call closbf(lunout)

      write(*,*) ! closing linefeed, debug?
      write(*,*) '# prof considered =',nr1
      if (nhi.ne.0) write(*,*) '# rejected: hgt (maxhgt) =',nhi,LOW
      if (nrare.ne.0) write(*,*) '# rejected: hgt (maxdP) =',nrare,RARE
      if (nfar.ne.0) write(*,*) '# rejected: far (maxdXY) =',nfar,rNEAR
      if (nt3.ne.0) write(*,*) '# rejected: typ 3xx =',nt3
      if (njm0.ne.0) write(*,*) '# rejected: no stn match(njm0):',njm0
      write(*,*) '# prof output=',nro

      write(*,'(" max dxy=",F12.5)'), dxymax

      endif ! false/true skip it (lunpro)


c-number of matching stations found in gtru
c     write(*,*) 'nrmin,jmmin=',nrmin,jmmin
c     write(*,*) 'nrmax,jmmax=',nrmax,jmmax

      write(*,*) 'Normal end of program PREPOBS_PREPACPF'
      CALL W3TAGE('PREPOBS_PREPACPF')
      stop

 901  write(*,*) 'error alloc gtru_*, stat=',i
      write(*,*) '######ABNORMAL end of program PREPOBS_PREPACPF'
c     stop 99
      CALL W3TAGE('PREPOBS_PREPACPF')
      call errexit(99)

      end ! program PREPOBS_PREPACPF


c ###################################################################
c                            function gcirc_qc
c ###################################################################
c
      function gcirc_qc(rlat1,rlon1,rlat2,rlon2)
c
c This fcn computes great circle distances using the Haversine formula.
c Reference: http://www.census.gov/cgi-bin/geo/gisfaq?Q5.1
c Programmer: P.M. Pauley 2/24/2000
c
c Additional reference (JAW 9/13/2007):
c   http://www.movable-type.co.uk/scripts/GIS-FAQ-5.1.html.
c
      implicit none
c
      real       pi,deg_rad,radius
      parameter (pi = 3.14159274, deg_rad = pi/180.) ! conversion factor
      parameter (radius = 6371229.)                  ! earth's radius(m)
c
      real         gcirc_qc     ! great circle distance
      real         rlat1        ! first latitude (degrees)
     $,            rlat2        ! second latitude (degrees)
     $,            rlon1        ! first longitude (degrees)
     $,            rlon2        ! second longitude (degrees)
      real         dlon         ! difference in longitude / 2 (radians)
     $,            dlat         ! difference in latitude / 2 (radians)
     $,            arg          ! argument for the arcsin
c
      dlon = (rlon2 - rlon1) * deg_rad * 0.5
      dlat = (rlat2 - rlat1) * deg_rad * 0.5
c
c What if longitudes are equal?
c -----------------------------
      if(ifix(rlon1*100.0).eq.ifix(rlon2*100.0)) then
        gcirc_qc = radius * abs(rlat2 - rlat1) * deg_rad
c
c What if latitudes are equal?
c ----------------------------
      elseif(ifix(rlat1*100.0).eq.ifix(rlat2*100.0)) then
        arg = abs(cos(rlat1*deg_rad) * sin(dlon))
        gcirc_qc = radius * 2.0 * asin(min(1.0,arg))
c
c What if neither are equal?
c --------------------------
      else
        arg = (sin(dlat))**2
     $      + cos(rlat1*deg_rad) * cos(rlat2*deg_rad) * (sin(dlon))**2
        gcirc_qc = radius * 2.0 * asin(min(1.0,sqrt(arg)))
      endif
c
      return
      end  ! function gcirc_qc
c
C-----------------------------------------------------------------------

      PROGRAM NDATE
C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: NDATE        COMPUTE VERIFYING DATE
C   PRGMMR: IREDELL          ORG: NP23        DATE: 1998-08-18
C
C ABSTRACT: PROGRAM TO COMPUTE VERIFYING DATE
C   GIVEN THE FORECAST HOUR AND THE INITIAL DATE.
C
C PROGRAM HISTORY LOG:
C   95-02-28  IREDELL
C   97-09-22  IREDELL  4-DIGIT YEAR ALLOWED; 2-DIGIT YEAR STANDARDIZED
C   98-03-25  IREDELL  4-DIGIT YEAR FOR ALL DATES.  A 2-DIGIT YEAR WILL
C                      BE INTERPRETED AS A YEAR IN THE FIRST CENTURY
C                      WHICH SHOULD BE ALL RIGHT BEFORE THE YEAR 2000.
C                      STANDARD ERROR WARNINGS WILL BE GIVEN FOR SUCH
C                      DATES UNTIL 1 SEPT 1998 AFTER WHICH NDATE ABORTS.
C                      NDATE WILL ALSO ABORT AFTER 1 SEPT 1998 IF THE
C                      NOW IRRELEVANT -Y OPTION IS INVOKED.
C                      THE NEW Y2K-COMPLIANT W3LIB PACKAGE IS USED.
C 1998-08-17  IREDELL  DROP-DEAD DATE RESET TO 1 SEPT 1999
C 1999-01-26  VUONG    CHANGED TO USE 4-DIGIT YEAR AS STANDARDIZED FOR
C                      ALL DATES AND CONVERTED TO IBM RS/6000 SP AND 
C                      MODIFIED PROGRAM TO CALL ROUTINE GETARG INSTEAD OF
C                      USING SUBROUTINE GETARG AS A FUNCTION.
C 1999-09-02  IREDELL  UNDID RESTRICTION ON FORECAST HOUR
C
C USAGE:      ndate [fhour [idate]]
C   INPUT ARGUMENT LIST
C     FHOUR    - FORECAST HOUR (MAY BE NEGATIVE)
C                FHOUR DEFAULTS TO ZERO.
C     IDATE    - INITIAL DATE IN YYYYMMDDHH FORMAT.
C                IDATE DEFAULTS TO THE CURRENT UTC DATE AND HOUR.
C                FIRST CENTURY DATES WILL CAUSE ABORT AFTER 1 SEPT 1999.
C   OUTPUT ARGUMENT LIST:
C     NDATE    - VERIFYING DATE IN YYYYMMDDHH FORMAT.
C   EXIT STATES:
C     0      - SUCCESS
C     1      - FAILURE; INVALID ARGUMENT
C     2      - FAILURE; INCORRECT NUMBER OF ARGUMENTS
C
C SUBPROGRAMS CALLED:
C   IARGC           GET NUMBER OF ARGUMENTS
C   GETARG          GET ARGUMENT
C   W3DIFDAT        RETURN A TIME INTERVAL BETWEEN TWO DATES
C   W3MOVDAT        RETURN A DATE FROM A TIME INTERVAL AND DATE
C   W3PRADAT        FORMAT A DATE AND TIME INTO CHARACTERS
C   W3UTCDAT        RETURN THE UTC DATE AND TIME
C   ERRMSG          WRITE A MESSAGE TO STDERR
C   EXIT            EXIT PROGRAM
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C
C$$$
      CHARACTER*256 CARG,CFMT
      INTEGER*4 IARG,LARG,NCARG,NARG,IARGC
      INTEGER IDAT(8),JDAT(8)
      REAL RINC(5)
      LOGICAL W3VALDAT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  GET AND CHECK OPTIONAL ARGUMENTS
      NARG=IARGC()
      IARG=1
      LSTOPT=0
      DOWHILE(IARG.LE.NARG.AND.LSTOPT.EQ.0)
        CALL GETARG(IARG,CARG)
        LARG=LEN_TRIM(CARG)
        IARG=IARG+1
        IF(CARG(1:1).NE.'-'.OR.
     &    (CARG(2:2).GE.'0'.AND.CARG(2:2).LE.'9')) THEN
          LSTOPT=1
          IARG=IARG-1
        ELSEIF(LARG.EQ.1) THEN
          CALL ERRMSG('ndate: Invalid option -')
          CALL EUSAGE
          CALL ERREXIT(1)
        ELSE
          L=2
          DOWHILE(L.LE.LARG)
            IF(CARG(L:L).EQ.'-') THEN
              LSTOPT=1
            ELSE
              CALL ERRMSG('ndate: Invalid option '//CARG(L:L))
              CALL EUSAGE
              CALL ERREXIT(1)
            ENDIF
            L=L+1
          ENDDO
        ENDIF
      ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  CHECK NUMBER OF ARGUMENTS
      MARG=NARG-IARG+1
      IF(MARG.GT.2) THEN
        CALL ERRMSG('ndate: Incorrect number of arguments')
        CALL EUSAGE
        CALL ERREXIT(2)
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  GET AND CHECK FIRST ARGUMENT (HOUR INCREMENT)
      IF(MARG.GE.1) THEN
        CALL GETARG(IARG,CARG)
        NCARG=LEN_TRIM(CARG)
        WRITE(CFMT,'("(I",I2,")")') NCARG
        READ(CARG,CFMT,IOSTAT=IRET) IHOUR
        IF(IRET.NE.0) THEN
          CALL ERRMSG('ndate: Noninteger forecast hour '//CARG(1:NCARG))
          CALL EUSAGE
          CALL ERREXIT(1)
        ENDIF
      ELSE
        IHOUR=0
      ENDIF
      RINC=0
      RINC(2)=IHOUR
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  GET AND CHECK SECOND ARGUMENT (INITIAL DATE)
      IF(MARG.GE.2) THEN
        CALL GETARG(IARG+1,CARG)
        NCARG=LEN_TRIM(CARG)
        WRITE(CFMT,'("(I",I2,",3I2)")') NCARG-6
        IDAT=0
        READ(CARG,CFMT,IOSTAT=IRET) IDAT(1),IDAT(2),IDAT(3),IDAT(5)
        IF(IRET.NE.0.OR..NOT.W3VALDAT(IDAT)) THEN
          CALL ERRMSG('ndate: Invalid date '//CARG(1:NCARG))
          CALL EUSAGE
          CALL ERREXIT(1)
        ENDIF
      ELSE
        CALL W3UTCDAT(IDAT)
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  COMPUTE AND PRINT NEW DATE
      CALL W3MOVDAT(RINC,IDAT,JDAT)
      ND=LOG10(JDAT(1)+0.5)+1
      WRITE(CFMT,'("(I",I2,",3I2.2)")') ND
      PRINT CFMT,JDAT(1),JDAT(2),JDAT(3),JDAT(5)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      CONTAINS
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  WRITE USAGE
      SUBROUTINE EUSAGE
      CALL ERRMSG('Usage: ndate [fhour [idate]]')
      ENDSUBROUTINE
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ENDPROGRAM

!  PROGRAM read_convdiag
!  read the conventional data from gsi and put into different array for
!  input to prepbufr
!  PRGMMR:   X. Su       ORG: NP20                 Date: 2007-11-15
!
! ABSTRACT:  read the conventional data from gsi and put into different
! array
!            for input to prepbufr.
!
      subroutine read_convdiag(filein,cwork,dwork,ndata,knt)

      use netcdf 

      real(4),allocatable,dimension(:,:)    :: rdiag
      character(8),allocatable,dimension(:) :: cdiag

      character(8) sid; real(8) rid; equivalence(sid,rid)

      parameter(maxn=3500000)
      character(8) ,dimension(maxn)      :: cwork
      integer(4)   ,dimension(maxn)      :: itype
      real(4)      ,dimension(maxn,0:20) :: dwork

      character(len=3)  :: dtype,type
      character(len=50) :: filein,filenn

      integer nchar,nreal,ii,mype,ntype,idate,knt(300,0:10)
      integer dimid

      logical first

      data lunin/11/
      data lunit/20/

!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------

      nn=1

!  loop over datagypes to process

      do i=1,4
      if(i==1) dtype='ps' 
      if(i==2) dtype='q'  
      if(i==3) dtype='t'  
      if(i==4) dtype='uv' 

      filenn=trim(filein)//'_'//trim(dtype); print*,filenn

!  open the file and find the dimension of the arrays

      call check( nf90_open(filenn,NF90_NOWRITE,ncid), "opening PL file")
      call check( nf90_inq_dimid(ncid,"nobs",dimid), "getting nobs dimid")
      call check( nf_inq_dimlen (ncid,dimid,nobs ),  "getting nobs dim")

!  check on the array bounds

      if(nn+nobs.gt.maxn) print*,'nn=',nn+nobs           
      if(nn+nobs.gt.maxn) call bort('maxn exceeded')
      print*,'nn=',nn+nobs,nobs

      !!nn=nn+nobs; cycle 

      jtype=0
      if(dtype == 'ps') jtype=1
      if(dtype == 'q') jtype=2
      if(dtype == 't') jtype=3
      if(dtype == 'uv') jtype=4
      if(dtype == 'spd') jtype=5
      !if(dtype == gps') jtype=6

      if(jtype==0) print*,dtype
      if(jtype==0) call bort('dtype')

!  read a dtype (jtype)  segment from netcdf into dwork

         call get_c(ncid,"Station_ID",nobs,cwork(nn))               ! station id

         call get_i(ncid,"Observation_Type    ",nobs,itype)         ! oi report type
         call get_r(ncid,"Latitude            ",nobs,dwork(nn,2))   ! observation latitude(degrees)
         call get_r(ncid,"Longitude           ",nobs,dwork(nn,3))   ! observation longitude{degrees)
         call get_r(ncid,"Station_Elevation   ",nobs,dwork(nn,4))   ! station elevation(meters)
         call get_r(ncid,"Pressure            ",nobs,dwork(nn,5))   ! observation pressure (hpa)
         call get_r(ncid,"Height              ",nobs,dwork(nn,6))   ! observation height (meters)
         call get_r(ncid,"Time                ",nobs,dwork(nn,7))   ! obs time (hours relat.  to anal. time)
         call get_r(ncid,"Prep_QC_Mark        ",nobs,dwork(nn,8))   ! input prepbufr qc or event mark
         call get_r(ncid,"Prep_Use_Flag       ",nobs,dwork(nn,9))   ! read_prepbufr data usage flag
         call get_r(ncid,"Analysis_Use_Flag   ",nobs,dwork(nn,10))  ! data usage flag((1=use, -1=not used)0
         call get_r(ncid,"Nonlinear_QC_Rel_Wgt",nobs,dwork(nn,11))  ! variational qc weight
         call get_r(ncid,"Errinv_Adjust       ",nobs,dwork(nn,12))  ! analsis adjusted observation error

         if( trim(dtype) == 'uv') then
            call get_r(ncid,"u_Observation                    ",nobs,dwork(nn,15))           ! u observation
            call get_r(ncid,"u_Obs_Minus_Forecast_adjusted    ",nobs,dwork(nn,16))           ! u background or analysis
            call get_r(ncid,"v_Observation                    ",nobs,dwork(nn,17))           ! v observation
            call get_r(ncid,"v_Obs_Minus_Forecast_adjusted    ",nobs,dwork(nn,18))           ! v background or analysis
            !!dwork(nn,19)=rdiag(23,i)             ! 10m wind reduction factor
         else if( trim(dtype) == 'q') then
            call get_r(ncid,"Observation                      ",nobs,dwork(nn,15))           ! observation
            call get_r(ncid,"Obs_Minus_Forecast_adjusted      ",nobs,dwork(nn,16))           ! background or analysis
            call get_r(ncid,"Forecast_Saturation_Spec_Hum     ",nobs,dwork(nn,17))           ! guess saturation specific humidity
         else
            call get_r(ncid,"Observation                      ",nobs,dwork(nn,15))           ! observation
            call get_r(ncid,"Obs_Minus_Forecast_adjusted      ",nobs,dwork(nn,16))           ! background or analysis
         endif

         do n=1,nobs        
         dwork(nn+n-1,0)=jtype
         dwork(nn+n-1,1)=itype(n)
         it=itype(n)
         if(it>=240.and.it<=260) cycle ! skip satwinds
         knt(it,jtype)=knt(it,jtype)+1
         knt(it,0)=knt(it,0)+1

         if( dwork(nn+n-1,0)==0) write(6,'(12(f10.2))') dwork(n,0:11)
         if( dwork(nn+n-1,1)==0) write(6,'(12(f10.2))') dwork(n,0:11)
         if( dwork(nn+n-1,0)==0) call bort('jtype=0') 
         if( dwork(nn+n-1,1)==0) call bort('itype=0') 
         enddo

         nn=nn+nobs

         enddo ! end of loop over vars (ps,q,t,uv)

         ndata=nn-1

         do n=1,ndata
         dwork(n,16)=dwork(n,15)-dwork(n,16)
         if(jtype==4)dwork(n,18)=dwork(n,17)-dwork(n,18)
         !write(6,'(a8,2x,13(f10.2))') cwork(n),dwork(n,0:12) 
         if(nint(dwork(n,1))==0) print*,n,dwork(n,1)
         enddo

         print*; print*,'data counts by report type'
         do i=1,300
         if(knt(i,0).gt.0) print'(i3,8(2x,i8))',i,(knt(i,j),j=0,5)
         enddo; print*

         return 
         end
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine get_i(ncid,varname,dim,arr)

         use netcdf
        
         character(*) varname
         integer      dim,varid
         integer      arr(dim)
         call check( nf90_inq_varid(ncid,varname,varid), "getting "//varname//" varid")
         call check( nf90_get_var(ncid,varid,arr),"reading "//varname)
         !print*,varname,arr(1:10)

      end subroutine get_i
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine get_r(ncid,varname,dim,arr)

         use netcdf
         integer :: start, count
         character(*) varname
         integer      dim,varid
         real         arr(dim)
         call check( nf90_inq_varid(ncid,varname,varid), "getting "//varname//" varid")
         call check( nf90_get_var(ncid,varid,arr),"reading "//varname)
         !print*,varname,arr(1:10)

      end subroutine get_r
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine get_c(ncid,varname,dim,arr)

         use netcdf
         integer :: start(4), count(4)
         character(*)  varname
         integer       dim,varid
         character(*)  arr(dim)
         call check( nf90_inq_varid(ncid,varname,varid), "getting "//varname//" varid")
         call check( nf90_get_var(ncid,varid,arr),"reading "//varname)
         !print*,varname,arr(1:10)

      end subroutine get_c
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------
      subroutine check(status, loc)

         use netcdf

         integer, intent(in) :: status
         character(len=*), intent(in) :: loc

         if(status /= NF90_NOERR) then
            write (*,*) "Error at ", loc
            write (*,*) NF90_STRERROR(status)
         end if

      end subroutine check
!---------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------

c$$$  Subprogram Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Subprogram: output_acqc_noprof 
c   Programmer: D. Keyser       Org: NP22       Date: 2015-12-09
c
c Abstract: Reads an input, pre-PREPACQC PREPBUFR file and matches the subsets within to the
c   "merged" reports contained within the arrays output by the NRL aircraft QC subroutine
c   acftobs_qc. Calls subroutine tranQCflags to translate the QC information (for each
c   variable: pressure, altitude, temperature and moisture for the mass piece; and pressure,
c   altitude and wind for the wind piece) from NRL standards (c_qc array) to their NCEP
c   counterparts and to establish event reason codes for each variable. All of this QC
c   information is then encoded as event stacks in the output PREPBUFR file which will be
c   identical to the input PREPBUFR file except for the new events added by this program and
c   aircraft reports that are removed (possibly) for being outside the requested time window
c   or geographical domain).
c
c Program History Log:
c 2010-11-15  S. Bender  -- Original Author
c 2012-05-08  D. Keyser  -- Prepared for operational implementation
c 2012-11-20  J. Woollen -- Initial port to WCOSS
c 2013-02-07  D. Keyser  -- If the maximum number of merged reports that can be processed
c                           ("max_reps") is exceeded when updating reports in PREPBUFR file
c                           with QC changes, program will no longer stop with r.c. 31, as
c                           though there is an indexing error, instead all original reports
c                           above "max_reps" will be written out without any QC and a message
c                           will be printed to stdout (a diagnostic will have already been
c                           sent to the production joblog file in this case when reports were
c                           first read in by subroutine INPUT_ACQC)
c 2013-02-07  D. Keyser  -- Final changes to run on WCOSS: use formatted print statements
c                           where previously unformatted print was > 80 characters
c 2014-03-06  D. Keyser  -- Moved BUFRLIB routine OPENMB call to after time window and
c                           geographic domain checks to prevent creation of an empty, but
c                           open, BUFR message (type AIRCAR) in (rare) cases where absolutely
c                           no aircraft reports pass these checks (would cause a BUFRLIB
c                           abort due to previous message being open when attempting to copy
c                           first non-aircraft message from input to output PREPBUFR file
c 2015-03-16  D. Keyser  -- Fixed a bug which, for cases where the maximum number of merged
c                           reports that can be processed ("max_reps") is exceeded, prevented
c                           any original reports above "max_reps" from being written out
c                           (without any QC).
c 2015-12-09  D. Keyser  -- 
c                    - Variables holding latitude and longitude data (including input
c                      arguments "alat" and "alon") now double precision. XOB and YOB in
c                      PREPBUFR file now scaled to 10**5 (was 10**2) to handle new v7 AMDAR
c                      and MDCRS reports which have this higher precision.
c                      BENEFIT: Retains exact precison here. Improves QC processing.
c                         - The format for all print statements containing latitude and longitude
c                           changed to print to 5 decimal places.
c
c Usage: call output_acqc_noprof(inlun,outlun,nrpts4QC_pre,max_reps,
c                                bmiss,alat,alon,ht_ft,idt,c_qc,
c                                trad,l_otw,l_nhonly,
c                                ncep_qm_p,ncep_rc_p,
c                                ncep_qm_z,ncep_rc_z,
c                                ncep_qm_t,ncep_rc_t,
c                                ncep_qm_q,ncep_rc_q,
c                                ncep_qm_w,ncep_rc_w,
c                                ncep_rej,
c                                nrlacqc_pc)
c
c   Input argument list:
c     inlun        - Unit number for the input pre-PREPACQC PREPBUFR file containing all data
c                    (separate mass/wind pieces)
c     outlun       - Unit number for the output PREPBUFR file containing all data plus now
c                    with NRLACQC events (separate mass/wind pieces)
c     nrpts4QC_pre - Number of reports in the "merged" single-level aircraft report arrays
c     max_reps     - Maximum number of reports accepted by acftobs_qc
c     bmiss        - BUFRLIB missing value (set in main program)
c     alat         - Array of latitudes for the "merged" reports 
c     alon         - Array of longitudes for the "merged" reports 
c     ht_ft        - Array of altitudes for the "merged" reports
c     idt          - Array of ob-cycle times for the "merged" reports (in seconds)
c     c_qc         - Array of NRLACQC quality information (11 char. string) ("merged" reports)
c     trad         - Time window radius for outputting reports (if l_otw=T) (read in via
c                    namelist)
c     l_otw        - Logical whether or not to eliminate reports outside the time window
c                    radius (trad) (read in via namelist)
c     l_nhonly     - Logical Whether or not to eliminate reports south of 20S latitude (i.e,
c                    outside the tropics and N. Hemisphere) (read in via namelist)
c     nrlacqc_pc   - PREPBUFR program code for the NRLACQC step
c
c   Output argument list:
c     ncep_qm_p    - Array of NCEP PREPBUFR quality marks on pressure for the "merged" reports
c     ncep_rc_p    - Array of NCEP PREPBUFR reason codes on pressure for the "merged" reports
c     ncep_qm_z    - Array of NCEP PREPBUFR quality marks on altitude for the "merged" rpts
c     ncep_rc_z    - Array of NCEP PREPBUFR reason codes on altitude for the "merged" rpts
c     ncep_qm_t    - Array of NCEP PREPBUFR quality marks on temperature for the "merged" rpts
c     ncep_rc_t    - Array of NCEP PREPBUFR reason codes on temperature for the "merged" rpts
c     ncep_qm_q    - Array of NCEP PREPBUFR quality marks on moisture for the "merged" reports
c     ncep_rc_q    - Array of NCEP PREPBUFR reason codes on moisture for the "merged" reports
c     ncep_qm_w    - Array of NCEP PREPBUFR quality marks on wind for the "merged" reports
c     ncep_rc_w    - Array of NCEP PREPBUFR reason codes on wind for the "merged" reports
c     ncep_rej     - Array indicating if "merged" report is (=0) or is not (=1) to be written
c                    to output PREPBUFR file
c   Input files:
c     Unit inlun   - PREPBUFR file containing all obs, prior to any processing by this program
c
c   Output files:
c     Unit 06      - Standard output print
c     Unit outlun  - PREPBUFR file identical to input except containing NRLACQC events
c
c   Subprograms called:
c     Unique:    TRANQCFLAGS
c     Library:
c       SYSTEM:  SYSTEM
c       W3NCO:   ERREXIT    W3TAGE
c	BUFRLIB: IREADMG    COPYMG     OPENMB     IREADSB    UFBINT     UFBCPY     WRITSB
c                WRITLC     CLOSMG     IBFMS
c
c   Exit States:
c     Cond =  0 - successful run
c            31 - indexing problem encountered when trying to match QC'd data in arrays to
c                 mass and wind pieces in original PREPBUFR file 
c
c Remarks: Called by main program.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine output_acqc_noprof(inlun,outlun,nrpts4QC_pre,max_reps,
     +                              bmiss,alat,alon,ht_ft,idt,c_qc,
     +                              trad,l_otw,l_nhonly,
     +                              ncep_qm_p,ncep_rc_p,
     +                              ncep_qm_z,ncep_rc_z,
     +                              ncep_qm_t,ncep_rc_t,
     +                              ncep_qm_q,ncep_rc_q,
     +                              ncep_qm_w,ncep_rc_w,
     +                              ncep_rej,
     +                              nrlacqc_pc)

      implicit none

c ------------------------------
c Parameter statements/constants
c ------------------------------
      integer    inlun              ! input unit number for pre-PREPACQC PREPBUFR file to
                                    !  which we are adding NRLACQC events
     +,          outlun             ! output unit number for post-PREPACQC PREPBUFR file
                                    !  with added NRLACQC events
     +,          max_reps           ! maximum number of input merged (mass + wind piece)
                                    !  aircraft-type reports allowed
      real       m2ft
      parameter (m2ft = 3.28084)    ! conversion factor to convert m to ft
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
c replace above with this in event of future switch to dynamic memory allocation

calloc  integer    max_reps           ! original number of input reports obtained from
calloc                                !  first pass through to get total for array allocation
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      real*8     bmiss              ! BUFRLIB missing value (set in main program)


c ----------------------
c Declaration statements
c ----------------------

c Variables for BUFRLIB interface
c -------------------------------
      character*8  mesgtype          ! BUFR message type (e.g., 'AIRCFT  ')
      integer      mesgdate          ! date time from BUFR message (YYYYMMDDHH)

c Indices/counters 
c ----------------
      integer      i,j               ! loop indices

      integer      nrpts4QC_pre      ! original number of input merged (mass + wind piece)
                                     !  aircraft-type reports (read in from PREPBUFR file)

c Functions
c ---------
      integer      ireadmg           ! BUFRLIB - for reading messages 
     +,            ireadsb           ! BUFRLIB - for reading subsets
     +,            ibfms             ! BUFRLIB - for testing for missing

      character*11 c_qc(max_reps)    ! character QC flags output from NRL QC code
                                     !   1st char - info about reject (if ob was rejected)
                                     !   2nd char - reason why time was rejected
                                     !   3rd char - reason why latitude was rejected
                                     !   4th char - reason why longitude was rejected
                                     !   5th char - reason why pressure/atitude was rejected
                                     !   6th char - readon why temperature was rejected
                                     !   7th char - reason why wind direction was rejected
                                     !   8th char - reason why wind speed was rejected
                                     !   9th char - reason why mixing ratio was rejected
                                     !  10th char - reason for blacklisting the aircraft
                                     !  11th char - info about flight phase

      real*8       alat(max_reps)    ! latitude
     +,            alon(max_reps)    ! longitude
      real         ht_ft(max_reps)   ! altitude in feet
      integer      idt(max_reps)     ! time in seconds to anal. time (- before, + after)
      integer      ncep_qm_p(max_reps) ! NCEP PREPBUFR quality mark pressure (PQM)
     +,            ncep_rc_p(max_reps) ! NCEP PREPBUFR NRLACQC pressure event reason code(PRC)
     +,            ncep_qm_z(max_reps) ! NCEP PREPBUFR quality mark on altitude (ZQM)
     +,            ncep_rc_z(max_reps) ! NCEP PREPBUFR NRLACQC alt/hght event reason code(ZRC)
     +,            ncep_qm_t(max_reps) ! NCEP PREPBUFR quality mark on temperature (TQM)
     +,            ncep_rc_t(max_reps) ! NCEP PREPBUFR NRLACQC temperature evnt rea. code(TRC)
     +,            ncep_qm_q(max_reps) ! NCEP PREPBUFR quality mark on moisture (QQM)
     +,            ncep_rc_q(max_reps) ! NCEP PREPBUFR NRLACQC moisture reason code (QRC)
     +,            ncep_qm_w(max_reps) ! NCEP PREPBUFR quality mark on wind (WQM)
     +,            ncep_rc_w(max_reps) ! NCEP PREPBUFR NRLACQC wind event reason code (WRC)
     +,            ncep_rej(max_reps)  ! NCEP PREPBUFR rejection indicator

c Variables for reading (writing) numeric data out of (in to) BUFR files via BUFRLIB
c ----------------------------------------------------------------------------------
      real*8       arr_8(10,10)      ! array holding BUFR subset values from BUFRLIB call to
                                     !  input PREPBUFR file
     +,            dhr_corr(2)       ! array holding rehabilitated time (DHR TCOR)
     +,            yob_corr(3)       ! array holding rehabilitated latitude (YOB YCOR YORG)
     +,            xob_corr(3)       ! array holding rehabilitated longitude (XOB XCOR XORG)

      integer      nlev              ! number of report levels returned from BUFRLIB call
                                     !  (should always be 1 !)
      integer      iret              ! return code for call to BUFRLIB routine ufbint when
                                     !  writing to PREPBUFR file

c Variables for updating input PREPBUFR reports with QC results/events from NRLACQC
c ---------------------------------------------------------------------------------
      integer      ninssrd           ! number of subsets read in from the input PREPBUFR file
     +,            QCdrptsidx        ! index for report-oriented arrays that are output from
                                     !  acftobs_qc

      real*8    p_event(4)          ! array used to update a pressure event stack
     +,         z_event(4)          ! array used to update an altitude event stack 
     +,         t_event(4)          ! array used to update a temperature event stack
     +,	        q_event(4)          ! array used to update a moisture event stack
     +,	        w_event(5)          ! array used to update a wind event stack

      logical   l_eventupdate       ! T = event was added for the last PREPBUFR report read
                                    ! F = no events were added to the last PREPBUFR rpt read

      integer   input_sqn           ! sequence number of input PREPBUFR report for which we
                                    !  are attempting to add events
     +,         input_sqn_last      ! sequence number of previous PREPBUFR report for which
                                    !  we had attempted to add events
      real*8    input_alat          ! latitude of input PREPBUFR report for which we are 
                                    !  attempting to add events
     +,         input_alon          ! longitude of input PREPBUFR report for which we are
                                    !  attempting to add events
      real      input_ht_ft         ! altitude of input PREPBUFR report for which we are
                                    !  attempting to add events
     +,         input_dhr           ! ob time - cycle time in decimal hours
 
      integer   input_idt           ! ob time - cycle time in seconds of input PREPBUFR
                                    !  report for which we are attempting to add events
     +,         input_typ           ! PREPBUFR report type for input report for which we are
                                    !  attempting to add events
      logical   l_badrpt_p          ! T = pressure/altitude is bad per NRLACQC info (c_qc)
     +,         l_badrpt_z          ! T = pressure/altitude is bad per NRLACQC info (c_qc)
     +,         l_badrpt_t          ! T = temperature is bad per NRLACQC info (c_qc)
     +,         l_badrpt_q          ! T = moisture is bad per NRLACQC info (c_qc)
     +,         l_badrpt_w          ! T = wind is bad per NRLACQC info (c_qc)

      logical   l_duprpt            ! T = report is marked as a duplicate per NRLACQC info
                                    !  (c_qc(1:1)=D/d)

      integer   ipqm_topstk         ! event PQM at top of stack before adding any events 
                                    !  containing info from NRLACQC
     +,         izqm_topstk         ! event ZQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,         itqm_topstk         ! event TQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,	        iqqm_topstk         ! event QQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,	        iwqm_topstk         ! event WQM at top of stack before adding any events
                                    !  containing info from NRLACQC

      integer   ipqm_nrlacqc     ! value for pressure q.m. (PQM) returned from tranQCflags
     +,         iprc_nrlacqc     ! value for pressure r.c. (PRC) returned from tranQCflags
     +,         izqm_nrlacqc     ! value for altitude q.m. (ZQM) returned from tranQCflags
     +,         izrc_nrlacqc     ! value for altitude r.c. (ZRC) returned from tranQCflags
     +,         itqm_nrlacqc     ! value for temperature q.m. (TQM) returned from tranQCflags
     +,         itrc_nrlacqc     ! value for temperature r.c. (TRC) returned from tranQCflags
     +,         iqqm_nrlacqc     ! value for moisture q.m. (QQM) returned from tranQCflags
     +,         iqrc_nrlacqc     ! value for moisture r.c. (QRC) returned from tranQCflags
     +,         iwqm_nrlacqc     ! value for wind q.m. (WQM) returned from tranQCflags
     +,         iwrc_nrlacqc     ! value for wind r.c. (WRC) returned from tranQCflags

c Event counters
c --------------
      integer   nevrd(5)
      integer   nevwrt(5)           ! number of [p,z,t,q,w] events written to output PREPBUFR
                                    !  file
      integer   nev_noupd(5)        ! number of subsets from input PREPBUFR file with no
                                    !  updated [p,z,t,q,w] event
      integer   qm_knt(5,0:15,0:15) ! count of [p,z,t,q,w] NCEP quality marks changed from i
                                    !  (input PREPBUFR value) to j (output PREPBUFR value)
                                    !  by NRLACQC
      integer   p_qm_knt_tot        ! total number of pressure QMs (and therefore events)
                                    !  added to the output PREPBUFR file
     +,         z_qm_knt_tot        ! total number of altitude QMs (and therefore events)
                                    !  added to the output PREPBUFR file
     +,         t_qm_knt_tot        ! total number of temperature QMs (and therefore events)
                                    !  added to the output PREPBUFR file
     +,         q_qm_knt_tot        ! total number of moisture QMs (and therefore events)
                                    !  added to the output PREPBUFR file
     +,         w_qm_knt_tot        ! total number of wind QMs (and therefore events)
                                    !  added to the output PREPBUFR file

      integer   npqm_msg_in         ! number of PQM that are missing in input PREPBUFR file
     +,         npqm_msg_out        ! number of PQM that are missing in output PREPBUFR file
     +,         nzqm_msg_in         ! number of ZQM that are missing in input PREPBUFR file
     +,         nzqm_msg_out        ! number of ZQM that are missing in output PREPBUFR file
     +,         ntqm_msg_in         ! number of TQM that are missing in input PREPBUFR file
     +,         ntqm_msg_out        ! number of TQM that are missing in output PREPBUFR file
     +,         nqqm_msg_in         ! number of QQM that are missing in input PREPBUFR file
     +,         nqqm_msg_out        ! number of QQM that are missing in output PREPBUFR file
     +,         nwqm_msg_in         ! number of WQM that are missing in input PREPBUFR file
     +,         nwqm_msg_out        ! number of WQM that are missing in output PREPBUFR file

c Switches controlling processing (read in from namelist in main program)
c -----------------------------------------------------------------------
      real      trad            ! Time window radius for outputting reports (if l_otw=T)
      logical   l_otw           ! T=eliminate reports outside cycle time window radius (trad)
     +,         l_nhonly        ! T=filter out obs outside tropics and Northern Hemisphere

c Counters
      integer   elim_knt(2,3)   ! Count of input PREPBUFR reports (subsets) eliminated from
                                !  write to output PREPBUFR file, and those kept for write to
                                !  output PREPBUFR file -
                                !  first index, message type: 1 - AIRCFT, 2 - AIRCAR
                                !  second index:
                                !    1 - # of reports (subsets) eliminated due to being
                                !         outside time window radius (prior to any
                                !         geographical domain checking)
                                !    2 - # of reports (subsets) eliminated due to being
                                !         outside geographical domain (had passed time window
                                !         radius check)
                                !    3 - # of reports (subsets) passing both time window
                                !         radius and geographical domain checks and thus
                                !         retained for processing into output PREPBUFR file


c Variables to add NRLACQC quality marks to reports
c -------------------------------------------------
      character*11 c_nrlqm                    ! variable used to store NRLACQC quality marks
                                              !  in output PREPBUFR file

c MISC
c ----
      real         nrlacqc_pc ! PREPBUFR program code for the NRLACQC step

      logical      l_skip     ! If true, skip block of code, otherwise exectute block of code
      logical      l_hit_limit! If true, hit limit for number of reports that can be QC'd

      integer      i_hit_limit_first ! flag indicating whether l_hit_limit has occurred prior
                                     !  to this point (if yes, = 1; if no, = 0)

c *******************************************************************

c Initialize variables
c --------------------
      nevwrt      =    0
      ninssrd     =    0
      ncep_qm_p   = 9999
      ncep_rc_p   = 9999
      ncep_qm_z   = 9999
      ncep_rc_z   = 9999
      ncep_qm_t   = 9999
      ncep_rc_t   = 9999
      ncep_qm_q   = 9999
      ncep_rc_q   = 9999
      ncep_qm_w   = 9999
      ncep_rc_w   = 9999
      ncep_rej    =    0
      elim_knt    =    0

      i_hit_limit_first = 0

      npqm_msg_in       = 0
      npqm_msg_out      = 0
      nzqm_msg_in       = 0
      nzqm_msg_out      = 0
      ntqm_msg_in       = 0
      ntqm_msg_out      = 0
      nqqm_msg_in       = 0
      nqqm_msg_out      = 0
      nwqm_msg_in       = 0
      nwqm_msg_out      = 0

      p_qm_knt_tot      = 0
      z_qm_knt_tot      = 0
      t_qm_knt_tot      = 0
      q_qm_knt_tot      = 0
      w_qm_knt_tot      = 0

c Start subroutine
c ----------------
      write(*,*)
      write(*,*) '******************************'
      write(*,*) 'Welcome to output_acqc_noprof.'
      call system('date')
      write(*,*) '******************************'
      write(*,*)

c ----------------------------------------------------------------------
c Translate NRLACQC flags to NCEP events and add events to PREPBUFR file
c ----------------------------------------------------------------------
      l_eventupdate = .false.

      print *
      print *, 'Input/Output PREPBUFR files are open.'
      print *
      print *, 'Reading input PREPBUFR file...'
      print *, 'Applying NRLACQC events to reports...'

      QCdrptsidx = 0       ! starting point for QC'd data arrays' index
      input_sqn_last = -99 ! initial value for last report's sequence number (ensures no
                           !  match for first report read in)

      l_hit_limit = .false.

      do while(ireadmg(inlun,mesgtype,mesgdate).eq.0)

        if(mesgtype.ne.'AIRCFT'.and.mesgtype.ne.'AIRCAR') then
          if(l_eventupdate) then ! need to close leftover AIRCAR or AIRCFT message originally
                                 !  opened by openmb before copymg can copy over an entire
                                 !  message from input to output
            call closmg(outlun)
            l_eventupdate = .false.
          endif

          call copymg(inlun,outlun) ! for non-aircraft BUFR messages, just copy to output
        else
          do while(ireadsb(inlun).eq.0)

c Initialize variables
c --------------------
            ipqm_topstk = 9999
            izqm_topstk = 9999
            itqm_topstk = 9999
            iqqm_topstk = 9999
            iwqm_topstk = 9999

            ninssrd = ninssrd + 1   ! number of input subsets read

c Unpack lat/lon, altitude, ob time, report type and sequence number - will be used to make
c  sure PREPBUFR and QC'd obs are lining up OK
c -----------------------------------------------------------------------------------------
            call ufbint(inlun,arr_8,10,10,nlev,
     +                  'YOB XOB ELV DHR TYP SQN SID')

            input_alat = arr_8(1,1)
            input_alon = arr_8(2,1)
            input_ht_ft = nint(arr_8(3,1)*m2ft)
            input_dhr = arr_8(4,1)    
            input_idt = nint(arr_8(4,1)*3600.)    
            input_typ = nint(arr_8(5,1))
            input_sqn = nint(arr_8(6,1))
            if(input_sqn.ne.input_sqn_last) then

c This input report's sequence number is different that that for the previous report read in
c  - we are at the next report in the QC'd data arrays so increment index QCdrptsidx by 1
              QCdrptsidx = QCdrptsidx + 1
ccccc         if(QCdrptsidx.eq.47955) print *,'WE ARE AT ',QCdrptsidx,'!'

              if(QCdrptsidx.gt.nrpts4QC_pre) then 

c .... the number of merged mass + wind reports read in from the input (non-QC'd) PREPBUFR
c      file exceeds the number of reports QC'd in acftobs_qc - likely due to there being more
c      than "max_reps" merged arcraft reports in the input PREPBUFR file -- in this case no
c      more input PREPBUFR aircraft reports can be QC'd - all remaining reports in input
c      PREPBUFR file will be copied to output PREPBUFR file but they will not be QC'd
                if(i_hit_limit_first.eq.0)  then
                  print *
                  print *, '#####VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV'
                  print *, 'WARNING: QD''d data array index exceeds ',
     +             'the limit of ', nrpts4QC_pre,' - no more reports ',
     +             'can be QC''d'
                  print *, '#####^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^'
                  print *
                endif
                i_hit_limit_first = 1
                l_hit_limit = .true.
                go to 3400
              endif

              if(QCdrptsidx.gt.1) then
                if(c_qc(QCdrptsidx-1)(2:2).eq.'R'.or.       ! time reabilitated
     +             c_qc(QCdrptsidx-1)(3:3).eq.'R'.or.       ! latitude reabilitated
     +             c_qc(QCdrptsidx-1)(4:4).eq.'R'.or.       ! longitude reabilitated
     +             c_qc(QCdrptsidx-1)(5:5).eq.'R'.or.       ! pressure/altitude reabilitated
     +             c_qc(QCdrptsidx-1)(6:6).eq.'R'.or.       ! temperature reabilitated
     +             c_qc(QCdrptsidx-1)(5:5).eq.'r') print 65 ! pressure/altitude reabilitated
   65 format(131('^'))
              endif
              if(c_qc(QCdrptsidx)(2:2).eq.'R'.or.           ! time reabilitated
     +           c_qc(QCdrptsidx)(3:3).eq.'R'.or.           ! latitude reabilitated
     +           c_qc(QCdrptsidx)(4:4).eq.'R'.or.           ! longitude reabilitated
     +           c_qc(QCdrptsidx)(5:5).eq.'R'.or.           ! pressure/altitude reabilitated
     +           c_qc(QCdrptsidx)(6:6).eq.'R'.or.           ! temperature reabilitated
     +           c_qc(QCdrptsidx)(5:5).eq.'r') then         ! pressure/altitude reabilitated
                print 61
   61 format(131('v'))
                if(c_qc(QCdrptsidx)(2:2).eq.'R') then

c Case where time was rehabiltated by NRLACQC, make note of it
c ------------------------------------------------------------
                  print 62,  QCdrptsidx,arr_8(7,1),input_alat,
     +                       input_alon,input_dhr,nint(arr_8(3,1)),
     +                       c_qc(QCdrptsidx)
   62 format(' TIME rehabilitated: input rpt # ',i6,': id ',A8,
     + ', lat ',f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,
     + ', NRLQMS "',A11,'"')
                  print 63, input_dhr,input_idt
   63 format(' INPUT time from PRE-QC PREPBUFR file [DHR,idt(sec)] ',
     + 'is: ',f10.5,i8)
                  print 64, idt(QCdrptsidx)/3600.,idt(QCdrptsidx)
   64 format(' REHABILITATED time from  acftobs_qc  [DHR,idt(sec)] ',
     + 'is: ',f10.5,i8)
                endif
                if(c_qc(QCdrptsidx)(3:3).eq.'R') then

c Case where latitude was rehabiltated by NRLACQC, make note of it
c ----------------------------------------------------------------
                  print 72,  QCdrptsidx,arr_8(7,1),input_alat,
     +                       input_alon,input_dhr,nint(arr_8(3,1)),
     +                       c_qc(QCdrptsidx)
   72 format(' LAT  rehabilitated: input rpt # ',i6,': id ',A8,
     + ', lat ',f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,
     + ', NRLQMS "',A11,'"')
                  print 73, input_alat
   73 format(' INPUT latitude from PRE-QC PREPBUFR file (YOB) is: ',
     + f9.5)
                  print 74, alat(QCdrptsidx)
   74 format(' REHABILITATED latitude from  acftobs_qc  (YOB) is: ',
     + f9.5)
                endif
                if(c_qc(QCdrptsidx)(4:4).eq.'R') then

c Case where longitude was rehabiltated by NRLACQC, make note of it
c -----------------------------------------------------------------
                  print 82,  QCdrptsidx,arr_8(7,1),input_alat,
     +                       input_alon,input_dhr,nint(arr_8(3,1)),
     +                       c_qc(QCdrptsidx)
   82 format(' LON  rehabilitated: input rpt # ',i6,': id ',A8,
     + ', lat ',f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,
     + ', NRLQMS "',A11,'"')
                  print 83, input_alon
   83 format(' INPUT longitude from PRE-QC PREPBUFR file (XOB) is: ',
     + f9.5)
                  print 84, alon(QCdrptsidx)
   84 format(' REHABILITATED longitude from  acftobs_qc  (XOB) is: ',
     + f9.5)
                endif
                if(c_qc(QCdrptsidx)(5:5).eq.'R'.or.
     +             c_qc(QCdrptsidx)(5:5).eq.'r') then

c Case where pressure/altitude was rehabiltated by NRLACQC, make note of it
c -------------------------------------------------------------------------
                  print 92,  QCdrptsidx,arr_8(7,1),input_alat,
     +                       input_alon,input_dhr,nint(arr_8(3,1)),
     +                       c_qc(QCdrptsidx)
   92 format(' P/A  rehabilitated: input rpt # ',i6,': id ',A8,
     + ', lat ',f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,
     + ', NRLQMS "',A11,'"')
                  print 93
   93 format(' %%%%%%%%%%'/' %%%%% WARNING: Currently not accounted ',
     +       'for in output PREPBUFR file'/' %%%%%%%%%%')
                endif
                if(c_qc(QCdrptsidx)(6:6).eq.'R') then

c Case where temperature was rehabiltated by NRLACQC, make note of it
c -------------------------------------------------------------------
                  print 102,  QCdrptsidx,arr_8(7,1),input_alat,
     +                       input_alon,input_dhr,nint(arr_8(3,1)),
     +                       c_qc(QCdrptsidx)
  102 format(' TMP  rehabilitated: input rpt # ',i6,': id ',A8,
     + ', lat ',f9.5,', lon ',f9.5,', dhr ',f10.5,', hght(m)',i6,
     + ', NRLQMS "',A11,'"')
                  print 93
                endif
              endif
            endif

            dhr_corr = bmiss
            yob_corr = bmiss
            xob_corr = bmiss
            if(c_qc(QCdrptsidx)(2:2).eq.'R') then ! Rehabilitated time
              dhr_corr(1) = idt(QCdrptsidx)/3600. ! Store updated d-time (DHR)
              dhr_corr(2) = 3                     ! Set correction indicator (TCOR) to 3
                                                  ! Original time already stored in RPT
              input_idt = idt(QCdrptsidx)         ! Prevents match check below from failing
              input_dhr = idt(QCdrptsidx)/3600.   ! Allows time window check below to use
                                                  !  rehabilitated time
            endif
            if(c_qc(QCdrptsidx)(3:3).eq.'R') then ! Rehabilitated latitude
              yob_corr(1) = alat(QCdrptsidx)      ! Store updated latitude (YOB)
              yob_corr(2) = 3                     ! Set correction indicator (YCOR) to 3
              yob_corr(3) = input_alat            ! Store original latitude (YORG)
              input_alat = alat(QCdrptsidx)       ! Prevents match check below from failing
                                                  !  and allows geographic domain check below
                                                  !  to use rehabilitated latitude
            endif
            if(c_qc(QCdrptsidx)(4:4).eq.'R') then ! Rehabilitated longitude
              xob_corr(1) = alon(QCdrptsidx)      ! Store updated longitude (XOB)
              xob_corr(2) = 3                     ! Set correction indicator (XCOR) to 3
              xob_corr(3) = input_alon            ! Store original longitude (XORG)
              input_alon = alon(QCdrptsidx)       ! Prevents match check below from failing
                                                  !  and allows geographic domain check below
                                                  !  to use rehabilitated longitude
            endif

            input_sqn_last = input_sqn

c At every 10,000'th QC'd (merged mass + wind) aircraft-type report and at last report, test
c  its lat/lon, time and altitude against corresponding PREPBUFR report values - if values DO
c  NOT match, PROBLEM!!!
c -------------------------------------------------------------------------------------------
            if(mod(QCdrptsidx,10000).eq.0.or.
     +         QCdrptsidx.eq.nrpts4QC_pre) then
              print *, 'ipoint match check at report # ',QCdrptsidx
     	      if(alat(QCdrptsidx).ne.input_alat .or.
     +	         alon(QCdrptsidx).ne.input_alon .or.
     +	         ht_ft(QCdrptsidx).ne.input_ht_ft .or.
     +	         idt(QCdrptsidx).ne. input_idt) then
                print *, 'NO MATCH AT QCdrptsidx = ',QCdrptsidx
                print'(" Indexing problem... could not find the ",
     +                 "current input PREPBUFR report in the report-",
     +	               "oriented arrays.")'
                print *, 'EXITING PROGRAM.'
     
                call w3tage('PREPOBS_PREPACQC')
                call  errexit(31)
              endif
              print *, 'MATCH AT QCdrptsidx = ',QCdrptsidx
     	    endif

 3400       continue

c Before processing this input PREPBUFR report (subset) any further, make sure it is within
c  the requested time window (defined by namelist switch trad) and it is within the requested
c  geographical domain (here north of 20S latitude, if namelist switch l_nhonly is true)
c -------------------------------------------------------------------------------------------

            if(l_otw) then ! check if report (subset) is outside time window (prior to any
                           ! geographical domain checking)
              if(input_dhr.lt.-trad.or.input_dhr.gt.trad) then
                if(mesgtype.eq.'AIRCFT') then
                  elim_knt(1,1) = elim_knt(1,1) + 1
                elseif(mesgtype.eq.'AIRCAR') then
                  elim_knt(2,1) = elim_knt(2,1) + 1
                endif
                if(.not.l_hit_limit) then
                  ncep_rej(QCdrptsidx) = 1
                endif
                cycle ! don't write this subset to output file, move on to next subset
              endif
            endif

            if(l_nhonly) then ! if report (subset) passed time window radius check, then
                              !  check to see if it is outside geographical domain (i.e.,
                              !  south of 20S)
              if(input_alat.lt.-20.0) then
                if(mesgtype.eq.'AIRCFT') then
                  elim_knt(1,2) = elim_knt(1,2) + 1
                elseif(mesgtype.eq.'AIRCAR') then
                  elim_knt(2,2) = elim_knt(2,2) + 1
                endif
                if(.not.l_hit_limit) then
                  ncep_rej(QCdrptsidx) = 1
                endif
                cycle ! don't write this subset to output file, move on to next subset
              endif
            endif

c Counter for number of PREPBUFR reports (subsets) kept
c -----------------------------------------------------
            if(mesgtype.eq.'AIRCFT') then
              elim_knt(1,3) = elim_knt(1,3) + 1
            elseif(mesgtype.eq.'AIRCAR') then
              elim_knt(2,3) = elim_knt(2,3) + 1
            endif

c If the report passes the time window and geographic domain checks, copy the subset to the
c  output PREPBUFR file in anticipation of adding events
c -----------------------------------------------------------------------------------------
            call openmb(outlun,mesgtype,mesgdate) 

            call ufbcpy(inlun,outlun)

            if(l_hit_limit) then

c If this subset exceeds the "max_rep" limit, don't attempt to add QC to it because there is
c  none, instead just write subset to the output PREPBUFR file and move on to next subset
c  (which won't be QC'd either)
c-------------------------------------------------------------------------------------------

               call writsb(outlun)
               cycle
            endif

            if(c_qc(QCdrptsidx)(2:2).eq.'R') then

c Encode rehabilitated time and time correction indicator
c -------------------------------------------------------
              print 66, dhr_corr,input_typ,QCdrptsidx
   66 format(' ENCODE REHABILITATED time ',f10.5, ' as DHR with TCOR=',
     + f3.0,' into PREPBUFR file, rtyp = ',i3,', for input report # ',
     + i8)
              call ufbint(outlun,dhr_corr,2,1,iret,'DHR TCOR')
            endif
            if(c_qc(QCdrptsidx)(3:3).eq.'R') then

c Encode rehabilitated latitude, latitude correction indicator and original latitude
c ----------------------------------------------------------------------------------
              print 76, yob_corr,input_typ,QCdrptsidx
   76 format(' ENCODE REHABILITATED latitude ',f9.5, ' as YOB with ',
     + 'YCOR=',f3.0,' and YORG=',f9.5,' into PREPBUFR file, rtyp = ',i3,
     + ', for input rpt # ',i8)
              call ufbint(outlun,yob_corr,3,1,iret,'YOB YCOR YORG')
            endif
            if(c_qc(QCdrptsidx)(4:4).eq.'R') then

c Encode rehabilitated longitude, longitude correction indicator and original longitude
c -------------------------------------------------------------------------------------
              print 86, xob_corr,input_typ,QCdrptsidx
   86 format(' ENCODE REHABILITATED longitude ',f9.5, ' as XOB with ',
     + 'XCOR=',f3.0,' and XORG=',f9.5,' into PREPBUFR file, rtyp = ',i3,
     + ', for input rpt # ',i8)
              call ufbint(outlun,xob_corr,3,1,iret,'XOB XCOR XORG')
            endif

c If the input PREPBUFR report is a mass report, update the event stack with mass events
c
c If the input PREPBUFR report is a wind rpt, update the event stack with wind events
c
c Also, first initialize the "bad report", "suspect report", and "duplicate report" flags as
c  false - these flags will be set to true if the NRLACQC quality information (array c_qc)
c  indicates that the report or any part of it is bad, suspect or a duplicate
c ------------------------------------------------------------------------------------------
            l_badrpt_p = .false.
            l_badrpt_z = .false.
            l_badrpt_t = .false.
            l_badrpt_q = .false.
            l_badrpt_w = .false.

            l_duprpt = .false.

c Pressure
c --------

c Get POB and PQM at top of stack coming in and store in array p_event, translate NRLACQC
c  quality flags in c_qc to NCEP standards for pressure and store in ipqm_nrlacqc, also store
c  reason code in iprc_nrlacqc (pressure data apply to both mass and wind obs)
c -------------------------------------------------------------------------------------------
            call ufbint(inlun,p_event,4,1,nlev,'POB PQM')
ccccc       if(QCdrptsidx.eq.47955) print *,'input p_event = ',p_event
            nevrd(1) = nevrd(1) + 1

            if(ibfms(p_event(2)).eq.0) then
              if(nint(p_event(2)).ge.0.and.nint(p_event(2)).le.15) then
c PQM for event at top of stack (prior to adding any NRLACQC events)
                ipqm_topstk = nint(p_event(2))
              else
                npqm_msg_in = npqm_msg_in + 1
              endif
            else
              npqm_msg_in = npqm_msg_in + 1
            endif

ccccc       if(QCdrptsidx.eq.47955)
ccccc+       print *,'prior to tranQCflags p_event = ',p_event
            call tranQCflags(c_qc(QCdrptsidx),'p',ipqm_nrlacqc,
     +                       iprc_nrlacqc,l_badrpt_p,l_duprpt)

c if PQM = 2 and PRC = 099 returned from tranQCflags, then can't translate!
            if(ipqm_nrlacqc.eq.2 .and. iprc_nrlacqc.eq.099) then
              print *
              print *, 'Unknown c_qc flag on pressure/altitude:',
     +                 c_qc(QCdrptsidx)(5:5)
              print *, 'PREPBUFR aircraft report number: ',ninssrd
              print *, 'QC ob array index: ',QCdrptsidx
              print *
            endif
ccccc       if(QCdrptsidx.eq.47955)
ccccc+       print *,'after call to tranQCflags PQM, PRC = ',
ccccc+      ipqm_nrlacqc,iprc_nrlacqc

c Altitude
c --------

c Get ZOB and ZQM at top of stack coming in and store in array z_event, translate NRLACQC
c  quality flags in c_qc to NCEP standards for altitude and store in izqm_nrlacqc, also store
c  reason code in izrc_nrlacqc (altitude applies to both mass and wind obs)
c
c Use same quality marks for altitude as were used for pressure - NRLACQC has one flag for
c  both (c_qc(5:5))
c -------------------------------------------------------------------------------------------
            call ufbint(inlun,z_event,4,1,nlev,'ZOB ZQM')
            nevrd(2) = nevrd(2) + 1

            if(ibfms(z_event(2)).eq.0) then
              if(nint(z_event(2)).ge.0.and.nint(z_event(2)).le.15) then
c ZQM for event at top of stack (prior to adding any NRLACQC events)
                izqm_topstk = nint(z_event(2))
              else
                nzqm_msg_in = nzqm_msg_in + 1
              endif
            else
              nzqm_msg_in = nzqm_msg_in + 1
            endif

            call tranQCflags(c_qc(QCdrptsidx),'z',izqm_nrlacqc,
     +                       izrc_nrlacqc,l_badrpt_z,l_duprpt)

c if ZQM = 2 and ZRC = 099 returned from tranQCflags, then can't translate!
            if(izqm_nrlacqc.eq.2 .and. izrc_nrlacqc.eq.099) then
              print *
              print *, 'Unknown c_qc flag on pressure/altitude:',
     +         c_qc(QCdrptsidx)(5:5)
              print *, 'PREPBUFR aircraft report number: ',ninssrd
              print *, 'QC ob array index: ',QCdrptsidx
              print *
            endif

c If the input PREPBUFR report is a mass report, then see if we need to add an event for
c  temperature and moisture - if the input PREPBUFR report is a wind report, then see if we
c  need to add an event for wind
c -----------------------------------------------------------------------------------------

            if(int(input_typ/100).eq.1) then

c -----------
c MASS REPORT
c -----------

c Temperature
c -----------

c Get TOB and TQM at top of stack coming in and store in array t_event, translate NRLACQC
c  quality flags in c_qc to NCEP standards for temperature and store in itqm_nrlacqc, also
c  store reason code in itrc_nrlacqc
c ----------------------------------------------------------------------------------------
              call ufbint(inlun,t_event,4,1,nlev,'TOB TQM')
ccccc         if(QCdrptsidx.eq.47955) print *,'input t_event = ',t_event
              nevrd(3) = nevrd(3) + 1

              if(ibfms(t_event(2)).eq.0) then
                if(nint(t_event(2)).ge.0.and.nint(t_event(2)).le.15)then
c TQM for event at top of stack (prior to adding any NRLACQC events)
                  itqm_topstk = nint(t_event(2))
                else
                  ntqm_msg_in = ntqm_msg_in + 1
                endif
              else
                ntqm_msg_in = ntqm_msg_in + 1
              endif

ccccc         if(QCdrptsidx.eq.47955)
ccccc+         print *,'prior to tranQCflags t_event = ',t_event
              call tranQCflags(c_qc(QCdrptsidx),'t',itqm_nrlacqc,
     +                         itrc_nrlacqc,l_badrpt_t,l_duprpt)

c if TQM = 2 and TRC = 099 returned from tranQCflags, then can't translate!
              if(itqm_nrlacqc.eq.2 .and. itrc_nrlacqc.eq.099) then
                print *
                print *, 'Unknown c_qc flag on temperature:',
     +           c_qc(QCdrptsidx)(6:6)
                print *, 'PREPBUFR aircraft report number: ',ninssrd
                print *, 'QC ob array index: ',QCdrptsidx
                print *
              endif
ccccc         if(QCdrptsidx.eq.47955)
ccccc+         print *,'after call to tranQCflags TQM, TRC = ',
ccccc+         itqm_nrlacqc,itrc_nrlacqc


c Moisture
c --------

c Get QOB and QQM at top of stack coming in and store in array q_event, translate NRLACQC
c  quality flags in c_qc to NCEP standards for moisture and store in iqqm_nrlacqc, also store
c  reason code in iqrc_nrlacqc
c -------------------------------------------------------------------------------------------
              call ufbint(inlun,q_event,4,1,nlev,'QOB QQM')
              nevrd(4) = nevrd(4) + 1

              if(ibfms(q_event(2)).eq.0) then
                if(nint(q_event(2)).ge.0.and.nint(q_event(2)).le.15)then
c QQM for event at top of stack (prior to adding any NRLACQC events)
                  iqqm_topstk = nint(q_event(2))
                else
                  nqqm_msg_in = nqqm_msg_in + 1
                endif
              else
                nqqm_msg_in = nqqm_msg_in + 1
              endif

              call tranQCflags(c_qc(QCdrptsidx),'q',iqqm_nrlacqc,
     +                         iqrc_nrlacqc,l_badrpt_q,l_duprpt)

c if QQM = 2 and QRC = 099 returned from tranQCflags, then can't translate!
              if(iqqm_nrlacqc.eq.2 .and. iqrc_nrlacqc.eq.099) then
                print *
                print *, 'Unknown c_qc flag on moisture:',
     +           c_qc(QCdrptsidx)(9:9)
                print *, 'PREPBUFR aircraft report number: ',ninssrd
                print *, 'QC ob array index: ',QCdrptsidx
                print *
              endif

            elseif(int(input_typ/100).eq.2) then

c -----------
c WIND REPORT
c -----------

c Wind
c ----

c Get UOB, VOB and WQM at top of stack coming in and store in array w_event, translate
c  NRLACQC quality flags in c_qc to NCEP standards for wind and store in iwqm_nrlacqc, also
c  store reason code in iwrc_nrlacqc
c -----------------------------------------------------------------------------------------
              call ufbint(inlun,w_event,5,1,nlev,'UOB VOB WQM')
              nevrd(5) = nevrd(5) + 1

              if(ibfms(w_event(3)).eq.0) then
                if(nint(w_event(3)).ge.0.and.nint(w_event(3)).le.15)then
c WQM for event at top of stack (prior to adding any NRLACQC events)
                  iwqm_topstk = nint(w_event(3))
                else
                  nwqm_msg_in = nwqm_msg_in + 1
                endif
              else
                nwqm_msg_in = nwqm_msg_in + 1
              endif

              call tranQCflags(c_qc(QCdrptsidx),'w',iwqm_nrlacqc,
     +                         iwrc_nrlacqc,l_badrpt_w,l_duprpt)

c if WQM = 2 and WRC = 099 returned from tranQCflags, then can't translate!
              if(iwqm_nrlacqc.eq.2 .and. iwrc_nrlacqc.eq.099) then
                print *
                print *, 'Unknown c_qc flag on wind:',
     +           c_qc(QCdrptsidx)(7:7),'/',c_qc(QCdrptsidx)(8:8)
                print *, 'PREPBUFR aircraft report number: ',ninssrd
                print *, 'QC ob array index: ',QCdrptsidx
                print *
              endif

            endif ! int(input_typ/100) = 1 or 2

ccccc       if(QCdrptsidx.eq.47955)
ccccc+       print *,'prior to entire rpt rej PQM, PRC = ',
ccccc+      ipqm_nrlacqc,iprc_nrlacqc

c If entire report is to be rejected, put reject flags (QM=13) on pressure, altitude,
c  temperature, moisture, and wind
c -----------------------------------------------------------------------------------
            if(l_badrpt_p .or. l_badrpt_z .or.
     +         l_badrpt_t .or. l_badrpt_q .or. l_badrpt_w) then

ccccc       if(QCdrptsidx.eq.47955)
ccccc+       print *, 'we are in reject report logic'

              ipqm_nrlacqc = 13 ! PQM
          ! PRC already encoded into iprc_nrlacqc in subr. tranQCflags

              izqm_nrlacqc = 13 ! ZQM
          ! ZRC already encoded into izrc_nrlacqc in subr. tranQCflags

              if(int(input_typ/100).eq.1) then
                itqm_nrlacqc = 13 ! TQM
          ! TRC already encoded into itrc_nrlacqc in subr. tranQCflags

                iqqm_nrlacqc = 13 ! QQM
          ! QRC already encoded into iqrc_nrlacqc in subr. tranQCflags

              elseif(int(input_typ/100).eq.2) then

                iwqm_nrlacqc = 13 ! WQM
          ! WRC already encoded into iwrc_nrlacqc in subr. tranQCflags

              endif ! int(input_typ/100) = 1 or 2
            endif ! l_badrpt_[p,z,t,q,w]

ccccc       if(QCdrptsidx.eq.47955)
ccccc+       print *,'after entire rpt rej PQM, PRC = ',
ccccc+       ipqm_nrlacqc,iprc_nrlacqc

c If report is marked as a duplicate (c_qc(1:1) = d or D), then mark the entire report with
c  a bad NCEP quality mark (=13)
c -----------------------------------------------------------------------------------------
            if(l_duprpt) then
              ipqm_nrlacqc = 13 ! PQM
          ! PRC already encoded into iprc_nrlacqc in subr. tranQCflags

              izqm_nrlacqc = 13 ! ZQM
          ! ZRC already encoded into izrc_nrlacqc in subr. tranQCflags

              if(int(input_typ/100).eq.1) then
                itqm_nrlacqc = 13 ! TQM
          ! TRC already encoded into itrc_nrlacqc in subr. tranQCflags

                iqqm_nrlacqc = 13 ! QQM
          ! QRC already encoded into iqrc_nrlacqc in subr. tranQCflags

              elseif(int(input_typ/100).eq.2) then

                iwqm_nrlacqc = 13 ! WQM
          ! WRC already encoded into iwrc_nrlacqc in subr. tranQCflags

              endif ! int(input_typ/100) = 1 or 2
            endif ! l_duprpt

c Update pressure, altitude, temperature, moisture and wind stacks with new event in output
c  PREPBUFR file when there has been a qualty mark change by NRLACQC (don't need to write out
c  an event if quality mark has not been changed by this program)
c 
c EXCEPTION: Retain (honor) the incoming quality mark at the top of the stack (i.e., do not
c            write event) when:
c
c       (1) The incoming quality mark at the top of the stack is 0 (keep flag)
c       (2) The incoming quality mark at the top of the stack is between 4 and 15 (bad) -
c           except when NRLACQC itself generates a BAD quality mark (translated to NCEP
c           value of 13), allows reason code to denote why action taken by NRLACQC to mark
c           obs as bad
c       (3) The incoming quality mark at the top of the stack is not between 0 and 15
c           (i.e.,missing)
c       (4) The incoming quality mark at the top of the stack is 3 (suspect) and the NRLACQC
c           generates a GOOD or NEUTRAL or SUSPECT quality mark (translated to NCEP values of
c           1, 2 and 3 resp.) {in other words, unless an ob previously marked as suspect was
c           marked bad by NRLACQC, don't change a suspect quality mark assigned by a PREPBUFR
c           processing step prior to the NRLACQC step}
c       (5) The quality mark translated to its NCEP value is 2 (neutral) and the reason code
c           is returned from tranQCflags is 099 - this indicates that the NRLACQC quality
c           flags in c_qc pertaining to this ob are unknown to transQCflags (the routine
c           tranQCflags may need to be updated to account for the c_qc flags that is coming
c           out of the NRLACQC QC routine for this ob - this would probably only happen if
c           NRL provides an updated/upgraded acftobs_qc module to NCEP)
c       (6) The NCEP equivalent of the NRLACQC is the same as the incoming quality mark of
c           the stack - if there is no change in the quality mark, then do not add a new
c           event and leave the event at the top of the event stack as is with TWO
c           exceptions:
c              a) NRLACQC itself generates a GOOD quality mark (translated to NCEP value of
c                 1)
c              b) NRLACQC itself generates a BAD quality mark (translated to NCEP value of
c                 13)  (see 2 above for more on this)
c -------------------------------------------------------------------------------------------

c Pressure
c --------
ccccc       if(QCdrptsidx.eq.47955)
ccccc+       print *,'prior to writing ? event p_event = ',p_event(1),
ccccc+      ipqm_nrlacqc,p_event(3),iprc_nrlacqc

            l_skip = .true. ! SKIP LOGIC TO WRITE PRESSURE EVENTS - there is no need to do so
                            !  since pressure is a vertical coordinate and it is not analyzed,
                            !  in addition, adding pressure events complicates reason code
                            !  logic

            if(.not.l_skip) then

c .... if here, include logic to write pressure events
              if(ipqm_topstk.eq.0  .or.
     +          (ipqm_topstk.ge.4 .and. ipqm_topstk.le.15) .or. ! ob has already been marked
                                                                !  bad by NCEP codes
     +           ipqm_topstk.eq.9999 .or.
     +          (ipqm_topstk.eq.3.and.ipqm_nrlacqc.le.3) .or.
     +          (ipqm_nrlacqc.eq.2.and.iprc_nrlacqc.eq.099) .or.
     +          (ipqm_topstk.eq.ipqm_nrlacqc.and.ipqm_nrlacqc.ne.1)
     +                  ) then                            ! no event needed; leave PQM as is
     
                ipqm_nrlacqc = ipqm_topstk

                nev_noupd(1) = nev_noupd(1) + 1
              else ! NRL QC produced an event; add this event to top of stack in output
                   !  PREPBUFR file
                p_event(2) = ipqm_nrlacqc
                p_event(3) = nrlacqc_pc
                p_event(4) = iprc_nrlacqc
                call ufbint(outlun,p_event,4,1,iret,'POB PQM PPC PRC') ! pressure & altitude
                                                                       !  apply to both mass
                                                                       !  & wind
                nevwrt(1) = nevwrt(1) + 1
                ncep_rc_p(QCdrptsidx) = iprc_nrlacqc
ccccc           if(QCdrptsidx.eq.47955)
ccccc+           print *,'after writing event p_event = ',p_event
ccccc           if(QCdrptsidx.eq.47955) print *,'after writing event ',
ccccc+           ncep_rc_p = ',ncep_rc_p(QCdrptsidx)
              endif
ccccc         if(QCdrptsidx.eq.47955) print *,'after writing event ',
ccccc+         ncep_qm_p = 'ncep_qm_p(QCdrptsidx)

              if((ipqm_nrlacqc.ge.0.and.ipqm_nrlacqc.le.15).and.
     +           (ipqm_topstk.ge.0.and.ipqm_topstk.le.15)) then
                ncep_qm_p(QCdrptsidx) = ipqm_nrlacqc
                qm_knt(1,ipqm_topstk,ipqm_nrlacqc) =
     +          qm_knt(1,ipqm_topstk,ipqm_nrlacqc) + 1
              else
                npqm_msg_out = npqm_msg_out + 1
              endif

            else

c .... if here, SKIP logic to write pressure events
              ipqm_nrlacqc = ipqm_topstk
              nev_noupd(1) = nev_noupd(1) + 1
              if((ipqm_nrlacqc.ge.0.and.ipqm_nrlacqc.le.15).and.
     +           (ipqm_topstk.ge.0.and.ipqm_topstk.le.15)) then
                ncep_qm_p(QCdrptsidx) = ipqm_nrlacqc
                qm_knt(1,ipqm_topstk,ipqm_nrlacqc) =
     +          qm_knt(1,ipqm_topstk,ipqm_nrlacqc) + 1
              else
                npqm_msg_out = npqm_msg_out + 1
              endif

            endif

c Altitude
c --------

            l_skip = .true. ! SKIP LOGIC TO WRITE ALTITUDE EVENTS - there is no need to do so
                            !  since altitude is a vertical coordinate and it is not analyzed,
                            !  in addition, adding altitude events complicates reason code
                            !  logic

            if(.not.l_skip) then

c .... if here, include logic to write altitude events
              if(izqm_topstk.eq.0  .or.
     +          (izqm_topstk.ge.4 .and. izqm_topstk.le.15) .or. ! ob has already been marked
                                                                !  bad by NCEP codes
     +           izqm_topstk.eq.9999 .or.
     +          (izqm_topstk.eq.3.and.izqm_nrlacqc.le.3) .or.
     +          (izqm_nrlacqc.eq.2.and.izrc_nrlacqc.eq.099) .or.
     +          (izqm_topstk.eq.izqm_nrlacqc.and.izqm_nrlacqc.ne.1)
     +                  ) then                            ! no event needed; leave ZQM as is
                izqm_nrlacqc = izqm_topstk

                nev_noupd(2) = nev_noupd(2) + 1
              else ! NRL QC produced an event; add this event to top of stack in output
                   !  PREPBUFR file
                z_event(2) = izqm_nrlacqc
                z_event(3) = nrlacqc_pc
                z_event(4) = izrc_nrlacqc
                call ufbint(outlun,z_event,4,1,iret,'ZOB ZQM ZPC ZRC') ! pressure & altitude
                                                                       !  apply to both mass
                                                                       !  & wind
                nevwrt(2) = nevwrt(2) + 1
                ncep_rc_z(QCdrptsidx) = izrc_nrlacqc
              endif

              if((izqm_nrlacqc.ge.0.and.izqm_nrlacqc.le.15).and.
     +           (izqm_topstk.ge.0.and.izqm_topstk.le.15)) then
                ncep_qm_z(QCdrptsidx) = izqm_nrlacqc
                qm_knt(2,izqm_topstk,izqm_nrlacqc) =
     +          qm_knt(2,izqm_topstk,izqm_nrlacqc) + 1
              else
                nzqm_msg_out = nzqm_msg_out + 1
              endif

            else

c .... if here, SKIP logic to write altitude events
              izqm_nrlacqc = izqm_topstk
              nev_noupd(2) = nev_noupd(2) + 1
              if((izqm_nrlacqc.ge.0.and.izqm_nrlacqc.le.15).and.
     +           (izqm_topstk.ge.0.and.izqm_topstk.le.15)) then
                ncep_qm_z(QCdrptsidx) = izqm_nrlacqc
                qm_knt(2,izqm_topstk,izqm_nrlacqc) =
     +          qm_knt(2,izqm_topstk,izqm_nrlacqc) + 1
              else
                nzqm_msg_out = nzqm_msg_out + 1
              endif

            endif

            if(int(input_typ/100).eq.1) then

c Temperature
c -----------

c Obs/Events
              if((itqm_topstk.eq.0  .or.
     +          (itqm_topstk.ge.4 .and. itqm_topstk.le.15) .or.  ! ob has already been marked
                                                                 !  bad by NCEP codes
     +           itqm_topstk.eq.9999 .or.
     +          (itqm_topstk.eq.3.and.itqm_nrlacqc.le.3) .or. 
     +          (itqm_nrlacqc.eq.2.and.itrc_nrlacqc.eq.099) .or.
     +          (itqm_topstk.eq.itqm_nrlacqc.and.itqm_nrlacqc.ne.1)
     +                ) .and. (itqm_nrlacqc.ne.13.or.
     +                         itqm_topstk.eq.9999)) then  ! no event needed; leave TQM as is
ccccc           if(QCdrptsidx.eq.47955)
ccccc+           print *,'no t_event written for ',QCdrptsidx
                itqm_nrlacqc = itqm_topstk

                nev_noupd(3) = nev_noupd(3) + 1

              else ! NRL QC produced an event; add this event to top of stack in output
                   !  PREPBUFR file
ccccc           if(QCdrptsidx.eq.47955)
ccccc+           print *,'new t_event written for ',QCdrptsidx
                if(int(itrc_nrlacqc/100).eq.9 .and.
     +             itqm_nrlacqc.eq.13)  itqm_nrlacqc = 14 ! if temperature marked bad here
                                                          !  due to it being on reject list,
                                                          !  reset TQM to 14
                t_event(2) = itqm_nrlacqc
                t_event(3) = nrlacqc_pc
                t_event(4) = itrc_nrlacqc
                call ufbint(outlun,t_event,4,1,iret,'TOB TQM TPC TRC')
                nevwrt(3) = nevwrt(3) + 1
                ncep_rc_t(QCdrptsidx) = itrc_nrlacqc
              endif

              if((itqm_nrlacqc.ge.0.and.itqm_nrlacqc.le.15).and.
     +           (itqm_topstk.ge.0.and.itqm_topstk.le.15)) then
                ncep_qm_t(QCdrptsidx) = itqm_nrlacqc
                qm_knt(3,itqm_topstk,itqm_nrlacqc) =
     +          qm_knt(3,itqm_topstk,itqm_nrlacqc) + 1
              else
                ntqm_msg_out = ntqm_msg_out + 1
              endif

c Moisture
c --------

c Obs/Events
              if((iqqm_topstk.eq.0  .or. 
     +          (iqqm_topstk.ge.4 .and. iqqm_topstk.le.15) .or.  ! ob has already been marked
                                                                 !  bad by NCEP codes
     +           iqqm_topstk.eq.9999 .or.
     +          (iqqm_topstk.eq.3 .and. iqqm_nrlacqc.le.3) .or.
     +          (iqqm_nrlacqc.eq.2.and.iqrc_nrlacqc.eq.099) .or.
     +	        (iqqm_topstk.eq.iqqm_nrlacqc.and.iqqm_nrlacqc.ne.1)
     +                ) .and. (iqqm_nrlacqc.ne.13.or.
     +                         iqqm_topstk.eq.9999)) then  ! no event needed; leave QQM as is
                iqqm_nrlacqc = iqqm_topstk

                nev_noupd(4) = nev_noupd(4) + 1

              else ! NRL QC produced a new event; add this event to top of stack in output
                   !  PREPBUFR file
                if(int(iqrc_nrlacqc/100).eq.9 .and.
     +             iqqm_nrlacqc.eq.13)  iqqm_nrlacqc = 14 ! if moisture marked bad here due
                                                          !  to temperature  being on reject
                                                          !  list, reset QQM to 14
                q_event(2) = iqqm_nrlacqc
                q_event(3) = nrlacqc_pc
                q_event(4) = iqrc_nrlacqc
                call ufbint(outlun,q_event,4,1,iret,'QOB QQM QPC QRC')
                nevwrt(4) = nevwrt(4) + 1
                ncep_rc_q(QCdrptsidx) = iqrc_nrlacqc
              endif

              if((iqqm_nrlacqc.ge.0.and.iqqm_nrlacqc.le.15).and.
     +           (iqqm_topstk.ge.0.and.iqqm_topstk.le.15))then
                ncep_qm_q(QCdrptsidx) = iqqm_nrlacqc
                qm_knt(4,iqqm_topstk,iqqm_nrlacqc) =
     +          qm_knt(4,iqqm_topstk,iqqm_nrlacqc) + 1
              else
                nqqm_msg_out = nqqm_msg_out + 1
              endif

            elseif(int(input_typ/100).eq.2) then

c Wind
C ----

c Obs/Events
              if((iwqm_topstk.eq.0  .or.
     +          (iwqm_topstk.ge.4 .and. iwqm_topstk.le.15) .or.  ! ob has already been marked
                                                                 !  bad by NCEP codes
     +           iwqm_topstk.eq.9999 .or.
     +          (iwqm_topstk.eq.3 .and. iwqm_nrlacqc.le.3) .or.
     +          (iwqm_nrlacqc.eq.2.and.iwrc_nrlacqc.eq.099) .or.
     +          (iwqm_topstk.eq.iwqm_nrlacqc.and.iwqm_nrlacqc.ne.1)
     +                ) .and. (iwqm_nrlacqc.ne.13.or.
     +                         iwqm_topstk.eq.9999)) then  ! no event needed; leave WQM as is
                iwqm_nrlacqc = iwqm_topstk

                nev_noupd(5) = nev_noupd(5) + 1

              else ! NRL QC produced a new event; add this event to top of stack in output
                   !  PREPBUFR file
                if(int(iwrc_nrlacqc/100).eq.9 .and.
     +             iwqm_nrlacqc.eq.13)  iwqm_nrlacqc = 14 ! if wind marked bad here due to it
                                                          !  being on reject list, reset WQM
                                                          !  to 14
                w_event(3) = iwqm_nrlacqc
                w_event(4) = nrlacqc_pc
                w_event(5) = iwrc_nrlacqc
              call ufbint(outlun,w_event,5,1,iret,'UOB VOB WQM WPC WRC')
                nevwrt(5) = nevwrt(5) + 1
                ncep_rc_w(QCdrptsidx) = iwrc_nrlacqc
              endif

              if((iwqm_nrlacqc.ge.0.and.iwqm_nrlacqc.le.15).and.
     +           (iwqm_topstk.ge.0.and.iwqm_topstk.le.15))then
                ncep_qm_w(QCdrptsidx) = iwqm_nrlacqc
                qm_knt(5,iwqm_topstk,iwqm_nrlacqc) =
     +          qm_knt(5,iwqm_topstk,iwqm_nrlacqc) + 1
              else
                nwqm_msg_out = nwqm_msg_out + 1
              endif

            endif

            l_eventupdate = .true.

c After updating all event stacks {pressure (maybe), altitude (maybe), temperature, moisture
c  and wind), write subset to the output PREPBUFR file - also add NRLACQC quality string to
c  this subset, since the string is of length 11 characters, must call WRITLC after call to
c  WRITSB
c ------------------------------------------------------------------------------------------
            call writsb(outlun)

c ***** ----> BUFRLIB routine WRITLC trims the string that is stored, cutting off any blank
c             (" ") characters - since blank characters have meaning in the originally-
c             defined NRLACQC quality string (usually indicating passed all tests and thus
c             good), we earlier (in subroutine acftobs_qc) replaced blank characters with dot
c             (".") characters so these would be retained by WRITLC
c -------------------------------------------------------------------------------------------
            c_nrlqm = c_qc(QCdrptsidx)

ccccc       print *, 'in *noprof.f, writing c_nrlqm=', c_nrlqm

            call writlc(outlun,c_nrlqm,'NRLQMS')

c Close loops here
c ----------------
          enddo ! ireadsb
        endif ! check for AIRCFT and AIRCAR messages
      enddo ! ireadmg

c Output counts
c -------------

c Detailed counts of reports eliminated from final PREPBUFR file
c --------------------------------------------------------------
      print *
      print *, '----------------------------------------------------'
      print *, 'Info about reports tossed from final PREPBUFR file: '
      print *, '----------------------------------------------------'
      print *
      if(l_otw) then
        print 96, trad,elim_knt(1,1)
   96 format(' Subsets from AIRCFT msgs tossed because outside req. ',
     + 'time window radius of',F6.2,'hrs (prior to geographical domain',
     + ' chking):',i6)
        print 97, trad,elim_knt(2,1)
   97 format(' Subsets from AIRCAR msgs tossed because outside req. ',
     + 'time window radius of',F6.2,'hrs (prior to geographical domain',
     + ' chking):',i6)
      else
        print *, 'Time window radius check NOT performed, l_otw=',l_otw,
     +           ' (ZERO reports tossed)'
      endif
      print *
      if(l_nhonly) then
        print'(" Subsets from AIRCFT messages passing time window ",
     +         "radius check but outside geographical domain (i.e., S ",
     +         "of 20S lat): ",I0)', elim_knt(1,2)
        print'(" Subsets from AIRCAR messages passing time window ",
     +         "radius check but outside geographical domain (i.e., S ",
     +         "of 20S lat): ",I0)', elim_knt(2,2)
      else
        print'(" Geographical domain check not performed, l_nhonly=",L,
     +         " (ZERO reports tossed)")', l_nhonly
      endif
      print *
      print'(" Number of subsets from AIRCFT messages passing checks ",
     +       "and kept: ",I0)', elim_knt(1,3)
      print'(" Number of subsets from AIRCAR messages passing checks ",
     +       "and kept: ",I0)', elim_knt(2,3)
      print *
      print'(" TOTAL NUMBER OF SUBSETS WRITTEN BACK OUT: ",I0)',
     +     elim_knt(1,3)+elim_knt(2,3)

c Pressure details
c ----------------
      print *
      print *, '***********************'
      print *, 'PQM changes/status quo: '

      print *
      print *, 'Input PQM info:'
      print *, 'PQMs read from PREPBUFR:',nevrd(1)
      print *, 'Obs with MISSING PQMs upon input:',npqm_msg_in
      print *

      print *, 'Output PQM info:'
      print *, 'PQMs written to output PREPBUFR:',nevwrt(1)
      print *, 'Obs with MISSING PQMs (not written to output):',
     +         npqm_msg_out
      print *, 'Obs with NRLACQC QM equal to previous QM (no new ',
     +         'event): ',nev_noupd(1)
 
      print *
      print *, 'Non-missing PQM Breakdown:'
      do i=0,15
        do j=0,15
          if(qm_knt(1,i,j).ne.0) then
            print 50, 'PQM:',i,'->',j,':',qm_knt(1,i,j)
            p_qm_knt_tot = p_qm_knt_tot + qm_knt(1,i,j)
          endif
        enddo
      enddo

      if(p_qm_knt_tot.eq.0) then
        print *, 'NO PQM RESULTS!'
      else
        print 51
        print 52,'TOTAL:',p_qm_knt_tot
      endif

   50 format(1x,a4,1x,i2,1x,a2,1x,i2,a1,1x,i6)
   51 format(1x,'---------------------')
   52 format(1x,a6,9x,i6)

c Altitude details
c ----------------
      print *
      print *, '***********************'
      print *, 'ZQM changes/status quo: '

      print *
      print *, 'Input ZQM info:'
      print *, 'ZQMs read from PREPBUFR:',nevrd(2)
      print *, 'Obs with MISSING ZQMs upon input:',nzqm_msg_in
      print *

      print *, 'Output ZQM info:'
      print *, 'ZQMs written to output PREPBUFR:',nevwrt(2)
      print *, 'Obs with MISSING ZQMs (not written to output):',
     +         nzqm_msg_out
      print *, 'Obs with NRLACQC QM equal to previous QM (no new ',
     +         'event): ',nev_noupd(2)

      print *
      print *, 'Non-missing ZQM Breakdown:'
      do i=0,15
        do j=0,15
          if(qm_knt(2,i,j).ne.0) then
            print 50, 'ZQM:',i,'->',j,':',qm_knt(2,i,j)
            z_qm_knt_tot = z_qm_knt_tot + qm_knt(2,i,j)
          endif
        enddo
      enddo

      if(z_qm_knt_tot.eq.0) then
        print *, 'NO ZQM RESULTS!'
      else
        print 51
        print 52,'TOTAL:',z_qm_knt_tot
      endif

c Temperature details
c -------------------
      print *
      print *, '***********************'
      print *, 'TQM changes/status quo: '

      print *
      print *, 'Input TQM info:'
      print *, 'TQMs read from PREPBUFR:',nevrd(3)
      print *, 'Obs with MISSING TQMs upon input:',ntqm_msg_in
      print *

      print *, 'Output TQM info:'
      print *, 'TQMs written to output PREPBUFR:',nevwrt(3)
      print *, 'Obs with MISSING TQMs (not written to output):',
     +         ntqm_msg_out
      print *, 'Obs with NRLACQC QM equal to previous QM (no new ',
     +         'event): ',nev_noupd(3)

      print *
      print *, 'Non-missing TQM Breakdown:'
      do i=0,15
        do j=0,15
          if(qm_knt(3,i,j).ne.0) then
            print 50, 'TQM:',i,'->',j,':',qm_knt(3,i,j)
            t_qm_knt_tot = t_qm_knt_tot + qm_knt(3,i,j)
          endif
        enddo
      enddo

      if(t_qm_knt_tot.eq.0) then
        print *, 'NO TQM RESULTS!'
      else
        print 51
        print 52,'TOTAL:',t_qm_knt_tot
      endif

c Moisture details 
c ----------------
      print *
      print *, '***********************'
      print *, 'QQM changes/status quo: '

      print *
      print *, 'Input QQM info:'
      print *, 'QQMs read from PREPBUFR:',nevrd(4)
      print *, 'Obs with MISSING QQMs upon input:',nqqm_msg_in
      print *

      print *, 'Output QQM info:'
      print *, 'QQMs written to output PREPBUFR:',nevwrt(4)
      print *, 'Obs with MISSING QQMs (not written to output):',
     +         nqqm_msg_out
      print *, 'Obs with NRLACQC QM equal to previous QM (no new ',
     +         'event): ',nev_noupd(4)

      print *
      print *, 'Non-missing QQM Breakdown:'
      do i=0,15
        do j=0,15
          if(qm_knt(4,i,j).ne.0) then
            print 50, 'QQM:',i,'->',j,':',qm_knt(4,i,j)
            q_qm_knt_tot = q_qm_knt_tot + qm_knt(4,i,j)
          endif
        enddo
      enddo

      if(q_qm_knt_tot.eq.0) then
        print *, 'NO QQM RESULTS!'
      else
        print 51
        print 52,'TOTAL:',q_qm_knt_tot
      endif

c Wind details
c ------------
      print *
      print *, '***********************'
      print *, 'WQM changes/status quo: '

      print *
      print *, 'Input WQM info:'
      print *, 'WQMs read from PREPBUFR:',nevrd(5)
      print *, 'Obs with MISSING WQMs upon input:',nwqm_msg_in
      print *

      print *, 'Output WQM info:'
      print *, 'WQMs written to output PREPBUFR:',nevwrt(5)
      print *, 'Obs with MISSING WQMs (not written to output):',
     +         nwqm_msg_out
      print *, 'Obs with NRLACQC QM equal to previous QM (no new ',
     +         'event): ',nev_noupd(5)

      print *
      print *, 'Non-missing WQM Breakdown:'
      do i=0,15
        do j=0,15
          if(qm_knt(5,i,j).ne.0) then
            print 50, 'WQM:',i,'->',j,':',qm_knt(5,i,j)
            w_qm_knt_tot = w_qm_knt_tot + qm_knt(5,i,j)
          endif
        enddo
      enddo

      if(w_qm_knt_tot.eq.0) then
        print *, 'NO WQM RESULTS!'
      else
        print 51
        print 52,'TOTAL:',w_qm_knt_tot
      endif


      write(*,*)
      write(*,*) '****************************'
      write(*,*) 'output_acqc_noprof has ended'
      call system('date')
      write(*,*) '****************************'
      write(*,*)

      return

      end

              PROGRAM PREPOBS_MPCOPYBUFR
!$$$  MAIN PROGRAM DOCUMENTATION BLOCK
!
! MAIN PROGRAM: PREPOBS_MPCOPYBUFR
!   PRGMMR: KEYSER           ORG: NP22        DATE: 2013-03-06
!
! ABSTRACT: READS THROUGH USER-SPECIFIED NUMBER OF INPUT BUFR (DATA
!   DUMP) FILES AND COPIES SELECTED MESSAGES FROM EACH INTO UNIQUE
!   OUTPUT BUFR (DATA DUMP SUBSET) FILES (1-1 INPUT/OUTPUT).
!   THIS PROGRAM IS EXECUTED WITHIN A SCRIPT WHICH RUNS IN A PARALLEL
!   ENVIRONMENT (EITHER UNDER POE/MPI) OR IN BACKGROUND THREADS). THE
!   NUMBER OF MESSAGES SELECTED IS BASED ON THE NUMBER OF PARTS INTO
!   WHICH THE INPUT BUFR (DATA DUMP) FILES ARE TO BE DIVIDED - THIS WAY
!   ALL FILES WILL BE EVENLY DIVIDED.  THE LOCATION OF THE SELECTED
!   MESSAGES IS BASED ON THE TASK NUMBER (FOR POE/MPI) OR ON THE
!   BACKGROUND THREAD NUMBER FOR THIS RUN OF THE SCRIPT. THE RESULT OF
!   RUNNING THIS PROGRAM IN A PARALLEL SCRIPTS IS TO SPLIT EACH SET OF
!   INPUT BUFR FILES INTO UNIQUE (TO EACH SCRIPT EXECUTED) SUBSETS
!   WHICH ARE THEN PASSED INTO PREPDATA (ALLOWS FOR LOAD BALANCING).
!
! PROGRAM HISTORY LOG:
! 1999-06-29  KISTLER -- ORIGINAL AUTHOR
! 2013-03-06  KEYSER  -- CHANGES TO RUN ON WCOSS
! 2022-??-??  C. Hill --
!  Dynamic memory allocation introduced (2022-05-19) to permit BUFR
!  sonde processing.  Code block introduced (2022-05-06) to read opened
!  file containing BUFR sonde data and write an external station list
!  for later reference in PREPOBS_PREPDATA.
!
!
! USAGE:
!   INPUT FILES:
!     PARM     - NAMELIST /NAMIN/ (VARIABLE "NFILES" - THE NUMBER
!              - OF INPUT BUFR FILES); NAMELIST MP (VARIABLE
!              - "MP_PROCESS" - THE TASK NUMBER (MPI/POE) OR BACKGROUND
!                THREAD NUMBER FOR THIS RUN; VARIABLE "NPROCS" - THE
!                NUMBER OF PARTS INTO WHICH THE INPUT BUFR FILES ARE TO
!                BE DIVIDED)
!     UNIT 11  - COMPLETE BUFR FILE 1
!     UNIT 12  - COMPLETE BUFR FILE 2
!       ...              ...
!       ...              ...
!     UNIT XX  - (WHERE "XX" = 10+"NFILES"), COMPLETE BUFR FILE
!              - "NFILES"
!
!   OUTPUT FILES:
!     UNIT 06  - STANDARD PRINTFILE
!     UNIT 51  - SELECTED MESSAGES FROM INPUT BUFR FILE 1
!     UNIT 52  - SELECTED MESSAGES FROM INPUT BUFR FILE 2
!       ...              ...
!       ...              ...
!     UNIT XX  - (WHERE "XX" = 50+"NFILES"), SELECTED MESSAGES FROM
!              - INPUT BUFR FILE "NFILES"
!
!   SUBPROGRAMS CALLED:
!     LIBRARY:
!       UNIQUE   - MP_IREADMG
!       W3NCO    - W3TAGB   W3TAGE
!       BUFRLIB  - DATELEN  OPENBF   IREADMG  CLOSMG   COPYMG
!                  READMG   CLOSBF
!
!   EXIT STATES:
!     COND =   0 - SUCCESSFUL RUN
!
! REMARKS: NONE.
!
! ATTRIBUTES:
!   LANGUAGE: FORTRAN 90
!   MACHINE:  NCEP WCOSS
!
!$$$

! PROGRAM PREPOBS_MPCOPYBUFR

CHARACTER*8 SUBSET,CRPID,CBUHD
REAL*8      RPID8,BUHD8

namelist /namin/nfiles


DATA LUNIN /11    /
DATA LUNOT /51    /

      CALL W3TAGB('PREPOBS_MPCOPYBUFR',2013,0065,0085,'NP22')

read(5,namin)
write(6,namin)

CALL DATELEN(10)

CALL ISETPRM ( 'MXMSGL', 600000 )  ! CH 05/19/2022
CALL ISETPRM ( 'MAXSS',  600000 )  ! CH 05/19/2022

do i=1,nfiles

    CALL OPENBF(LUNIN,'IN ',LUNIN)
    CALL OPENBF(LUNOT,'OUT',LUNIN)

        ! copy first two messages (center and dump time) to all files
        ! -----------------------------------------------------------

        do k=1,2
                if(IREADMG(LUNIN,SUBSET,IDATE).EQ.0) then
                        CALL CLOSMG(LUNOT)
                        CALL COPYMG(LUNIN,LUNOT)
                endif
        enddo

    DO WHILE(MP_IREADMG(LUNIN,SUBSET,IDATE).EQ.0)
       CALL COPYMG(LUNIN,LUNOT)
! Find UPRAIR data, read the RPID and BUHD, and write to common external file
       IF(SUBSET(1:6).EQ.'NC0021') THEN
        IRT=0
        DO WHILE(IRT.EQ.0)
         CALL READSB(LUNIN,IRT)
         IF(IRT.EQ.0) THEN
          CALL UFBINT(LUNIN,RPID8,1,1,NLEV,'RPID')
          WRITE(CRPID,'(A8)') RPID8
          IF(IBFMS(RPID8).EQ.0) THEN
           CALL UFBINT(LUNIN,BUHD8,1,1,NLEV,'BUHD')
           WRITE(CBUHD,'(A8)') BUHD8
!          IF(CBUHD(1:2).EQ.'IU') WRITE(91,'(A8,1X,A8)') CRPID, CBUHD
           WRITE(91,'(A8,1X,A8)') CRPID, CBUHD
          ENDIF
         ENDIF
        ENDDO 
       ENDIF
! End UPRAIR station content search                   CH 05/06/2022
    ENDDO

    CALL CLOSBF(LUNIN)
    CALL CLOSBF(LUNOT)

    LUNIN=LUNIN+1
    LUNOT=LUNOT+1

ENDDO

      CALL W3TAGE('PREPOBS_MPCOPYBUFR')

STOP
END

function mp_ireadmg(lunin,subset,idate)
implicit none
integer mp_ireadmg
integer lunin,idate,iret,ierr,mp_process,ifirst,n,nprocs,kount
character*8 subset
namelist /mp/mp_process,nprocs
data ifirst/0/,kount/0/
save ifirst,mp_process,nprocs

if (ifirst.eq.0) then
    read(5,mp)
    write(6,mp)
    ifirst=1
endif

do
    call readmg(lunin,subset,idate,iret)
    if (iret .ne. 0 ) then
!print*,subset,' iret,kount = ',subset,' ',iret,kount
        exit
    else
        kount=kount+1
        if (mod(kount,nprocs).eq.mp_process) then
!print*,subset,' mod(',kount,',',nprocs,') = ',mod(kount,nprocs),mp_process
            exit
        endif
    endif
enddo
mp_ireadmg=iret
return
end

      MODULE module_waitfor
        implicit none
        private
        public :: waitfor, run_command

        integer, parameter :: minage_def=30, minsize_def=1
     &                       ,maxwait_def=-1, sleeptime_def=3

      CONTAINS
        subroutine run_command(command,retval)
!         This routine uses the C system command to run a command.
!         This gets around any arbitrary command length limits in
!         fortran.
!         Also, this way we get the command return status.
          implicit none
          character(*), intent(in) :: command
          integer, intent(out) :: retval
          call run_cmd_helper(trim(command)//char(0),                   &
     &len_trim(command)+1,retval)
        end subroutine run_command

        subroutine run_cmd_helper(cmd,cmdlen,retval)
          implicit none
          integer, intent(in) :: cmdlen
          integer, intent(out) :: retval
          character(*), intent(in) :: cmd(cmdlen)

          call c_run_command(retval,cmd)
        end subroutine run_cmd_helper

        subroutine waitfor(filename,status,minage,minsize,maxwait
     &                    ,sleeptime)
          implicit none
          character(*),intent(in) :: filename
          integer, optional, intent(in) :: minage
          integer, optional, intent(in) :: minsize
          integer, optional, intent(in) :: maxwait
          integer, optional, intent(in) :: sleeptime
          integer, intent(out) :: status

          integer :: minage_in, minsize_in, maxwait_in, sleeptime_in

          status=99

          if(present(minage)) then
             minage_in=minage
          else
             minage_in=minage_def
          endif

          if(present(minsize)) then
             minsize_in=minsize
          else
             minsize_in=minsize_def
          endif

          if(present(maxwait)) then
             maxwait_in=maxwait
          else
             maxwait_in=maxwait_def
          endif

          if(present(sleeptime)) then
             sleeptime_in=sleeptime
          else
             sleeptime_in=sleeptime_def
          endif

          call waitfor_helper(status,minage_in,minsize_in 
     &      ,maxwait_in,sleeptime_in,trim(filename),len_trim(filename))
        end subroutine waitfor

        subroutine waitfor_helper(status,minage,minsize
     &        ,maxwait,sleeptime,filename,N)
          integer, intent(in) :: minage,minsize,maxwait,sleeptime,N
          character(len=N),intent(in) :: filename
          integer, intent(out) :: status

          character(len=N+1) :: filename0
          character(len=1) :: null
          integer :: np1

          null=char(0)
          filename0=filename//null
          np1=N+1

          call cwaitfor(status,minage,minsize,maxwait,sleeptime
     &                 ,filename0)
        end subroutine waitfor_helper
      END MODULE module_waitfor

!
!   Author: Suranjana Saha
c--------------------------------------------------------------------------
c    compile using : make NAME=bufrslupa
c--------------------------------------------------------------------------
c     the mnemonic tables are in /nwprod/prepobs/ucl/prep.bufrtable
c---------------------------------------------------------------------------
       CHARACTER*1   kdbug,kdbuga,kall,kprs,kmas,kwnd
       CHARACTER*2   ktol
       CHARACTER*6   catname
       CHARACTER*255 infile,outfile
       CHARACTER*5   kst,klev
       CHARACTER*8   klonw,klone,klatn,klats,kdhr
       CHARACTER*2   kchr
       real(8)       bmiss

       dimension plev(28)

       bmiss=10e10; call setbmiss(bmiss) ! this sets bufrlib missing value to 10e10

       call getenv("idbug",kdbug)
       read(kdbug,'(i1)') idbug
       write(*,*) "idbug= ",idbug
c
       call getenv("idbuga",kdbuga)
       read(kdbuga,'(i1)') idbuga
       write(*,*) "idbuga= ",idbuga
c
       call getenv("iall",kall)
       read(kall,'(i1)') iall
       write(*,*) "iall= ",iall
C
       call getenv("iwnd",kwnd)
       read(kwnd,'(i1)') iwnd
       write(*,*) "iwnd= ",iwnd
C
       call getenv("imas",kmas)
       read(kmas,'(i1)') imas
       write(*,*) "imas= ",imas
C
       call getenv("fchr",kchr)
       read(kchr,'(i2)') ichr
       fchr=float(ichr)
       write(*,*) "fchr= ",fchr
C
       call getenv("fdhr",kdhr)
       read(kdhr,'(f8.1)') fdhr
       write(*,*) "fdhr= ",fdhr
c
       call getenv("nst",kst)
       read(kst,'(i5)') nst
       write(*,*) "nst= ",nst
c
       call getenv("infile",infile)
       write(*,*) "infile= ",infile
c
       call getenv("outfile",outfile)
       write(*,*) "outfile= ",outfile
c
       call getenv("catname",catname)
       write(*,*) "catname= ",catname
c
       call getenv("flonw",klonw)
       read(klonw,'(f8.1)') flonw
       write(*,*) "flonw= ",flonw
c
       call getenv("flone",klone)
       read(klone,'(f8.1)') flone
       write(*,*) "flone= ",flone
c
       call getenv("flatn",klatn)
       read(klatn,'(f8.1)') flatn
       write(*,*) "flatn= ",flatn
c
       call getenv("flats",klats)
       read(klats,'(f8.1)') flats
       write(*,*) "flats= ",flats
c
       call getenv("ilev",klev)
       read(klev,'(i4)') ilev
       write(*,*) "ilev= ",ilev
c
       call getenv("iprs",kprs)
       read(kprs,'(i1)') iprs
       write(*,*) "iprs= ",iprs
c
       call getenv("itol",ktol)
       read(ktol,'(i2)') itol
       write(*,*) "itol= ",itol
c
c...  define mandatory levels....
       if(iprs.eq.1) then
         nlevs=21
         plev(1)= 1000
         plev(2)= 925
         plev(3)= 850
         plev(4)= 700
         plev(5)= 500
         plev(6)= 400
         plev(7)= 300
         plev(8)= 250
         plev(9)=200
         plev(10)=150
         plev(11)=100
         plev(12)=70
         plev(13)=50
         plev(14)=30
         plev(15)=20
         plev(16)=10
         plev(17)=7
         plev(18)=5
         plev(19)=3
         plev(20)=2
         plev(21)=1
       endif
c
c...  define sigma levels....
       if(iprs.eq.0) then
         nlevs=28
         plev(1)= 995
         plev(2)= 982
         plev(3)= 964
         plev(4)= 943
         plev(5)= 916
         plev(6)= 884
         plev(7)= 846
         plev(8)= 801
         plev(9)= 751
         plev(10)=694
         plev(11)=633
         plev(12)=568
         plev(13)=502
         plev(14)=436
         plev(15)=372
         plev(16)=312
         plev(17)=258
         plev(18)=210
         plev(19)=168
         plev(20)=133
         plev(21)=103
         plev(22)= 78
         plev(23)= 58
         plev(24)= 42
         plev(25)= 29
         plev(26)= 18
         plev(27)= 10
         plev(28)=  3
       endif
c
         if(iprs.eq.2) nlevs=ilev
c
       if(flonw.lt.0.) flonw=360.+flonw
       if(flone.lt.0.) flone=360.+flone
       fhrs=fchr-fdhr
       fhre=fchr+fdhr
       print *,fchr,fdhr,fhrs,fhre
c
       call stats(infile,outfile,flonw,flone,flatn,flats,
     * iprs,nlevs,plev,idbug,idbuga,itol,iall,nst,fhrs,fhre,
     * catname,imas,iwnd)
c
       stop
       end
       subroutine stats(infile,outfile,flonw,flone,flatn,flats,
     * iprs,nlevs,plev,idbug,idbuga,itol,iall,nst,fhrs,fhre,
     * catname,imas,iwnd)
c
       CHARACTER*80 HSTR,PSTR,ZSTR,TSTR,QSTR,USTR,VSTR,PSTR1
       CHARACTER*8  SUBSET
C
       character*8   tstn(nst),stnidc,id
       CHARACTER*255 infile,outfile
c
       CHARACTER*10 indate
       CHARACTER*6  catname
       CHARACTER*8  STNID,idj,idi
       CHARACTER*1  labn
C
       real(8)    HDR(14)
       EQUIVALENCE  (HDR(1),STNID)
       real(8)    POB(4,255),ZOB(4,255),TOB(4,255),QOB(4,255)
       real(8)    UOB(4,255),VOB(4,255),PSOB(4)
       DIMENSION    PPR(4,nlevs),ZPR(4,nlevs),TPR(4,nlevs),QPR(4,nlevs)
       DIMENSION    UPR(4,nlevs),VPR(4,nlevs),PSPR(4)
       DIMENSION    tlon(nst),tlat(nst),thr(nst),typ(nst),elvt(nst)
       DIMENSION    typint(nst)
C
       DIMENSION PO(nlevs,nst)
       DIMENSION POM(nlevs,nst),POW(nlevs,nst)
       DIMENSION PSO(nst),PSA(nst),PSF(nst),PSQ(nst)
       DIMENSION ZO(nlevs,nst),ZA(nlevs,nst),ZF(nlevs,nst),ZQ(nlevs,nst)
       DIMENSION TO(nlevs,nst),TA(nlevs,nst),TF(nlevs,nst),TQ(nlevs,nst)
       DIMENSION QO(nlevs,nst),QA(nlevs,nst),QF(nlevs,nst),QQ(nlevs,nst)
       DIMENSION UO(nlevs,nst),UA(nlevs,nst),UF(nlevs,nst),WQ(nlevs,nst)
       DIMENSION VO(nlevs,nst),VA(nlevs,nst),VF(nlevs,nst)
c
       DIMENSION POG(nlevs)
       DIMENSION ZOG(nlevs),ZAG(nlevs),ZFG(nlevs),ZQG(nlevs)
       DIMENSION TOG(nlevs),TAG(nlevs),TFG(nlevs),TQG(nlevs)
       DIMENSION QOG(nlevs),QAG(nlevs),QFG(nlevs),QQG(nlevs)
       DIMENSION UOG(nlevs),UAG(nlevs),UFG(nlevs),WQG(nlevs)
       DIMENSION VOG(nlevs),VAG(nlevs),VFG(nlevs)
c
       REAL    plev(nlevs)
       integer kfillm(nlevs,nst),kfillw(nlevs,nst)
       integer mmfill(nst),mwfill(nst)
       integer kmmax(nst),kwmax(nst)
c
       DATA HSTR
     ./'SID XOB YOB DHR ELV TYP T29 ITP SQN RQM DUP PRG SRC RUD'/
C
       DATA STNID/'        '/
c
c...   get the ob, guess, analysis and quality mark ....
c
       DATA PSTR1 /'POB PAN PFC PQM CAT=0'/
       DATA PSTR /'POB PAN PFC PQM'/
       DATA ZSTR /'ZOB ZAN ZFC ZQM'/
       DATA TSTR /'TOB TAN TFC TQM'/
       DATA QSTR /'QOB QAN QFC QQM'/
c      DATA USTR /'DDO UAN UFC WQM'/
c      DATA VSTR /'FFO VAN VFC WQM'/
       DATA USTR /'UOB UAN UFC WQM'/
       DATA VSTR /'VOB VAN VFC WQM'/
C
       DATA BMISS /10E10/
       DATA rmiss /99999./
       DATA LUNIN /11/
C----------------------------------------------------
       indate='          '
c
       print *,' infile ',infile
       print *,' outfile ',outfile
       print *,' catname ',catname
       print *,' flonw ',flonw
       print *,' flone ',flone
       print *,' flatn ',flatn
       print *,' flats ',flats
       iodd=0
       if(flonw.gt.flone) then
       iodd=1
       flone=flone+360.
       print *,' iodd ',iodd
       print *,' flone ',flone
       endif
c
       open(11,file=infile,form='unformatted')
c
       open(51,file=outfile,form='unformatted')
c
C  INITIALIZE
C  ----------
       DO IST=1,nst
       PSO(IST)   = bmiss
       PSA(IST)   = bmiss
       PSF(IST)   = bmiss
       PSQ(IST)   = bmiss
       ENDDO
C
       DO IST=1,nst
       DO L=1,nlevs
       PO(L,IST)   = bmiss
       POM(L,IST)   = bmiss
       POW(L,IST)   = bmiss
       ZO(L,IST)   = bmiss
       TO(L,IST)   = bmiss
       QO(L,IST)   = bmiss
       UO(L,IST)   = bmiss
       VO(L,IST)   = bmiss
       ZA(L,IST)   = bmiss
       TA(L,IST)   = bmiss
       QA(L,IST)   = bmiss
       UA(L,IST)   = bmiss
       VA(L,IST)   = bmiss
       ZF(L,IST)   = bmiss
       TF(L,IST)   = bmiss
       QF(L,IST)   = bmiss
       UF(L,IST)   = bmiss
       VF(L,IST)   = bmiss
       ZQ(L,IST)   = bmiss
       TQ(L,IST)   = bmiss
       QQ(L,IST)   = bmiss
       WQ(L,IST)   = bmiss
       KFILLM(L,IST)   = 0
       KFILLW(L,IST)   = 0
       ENDDO
       MMFILL(IST)   = 0
       MWFILL(IST)   = 0
       ENDDO
C
       nvar=0
       if((imas.eq.1).and.(iwnd.eq.1)) nvar=1
       print *,'nvar ',nvar
c
       CALL DATELEN(10)
       CALL OPENBF(LUNIN,'IN ',LUNIN)
c
       IST=0
!      DO WHILE(IREADFT(LUNIN,SUBSET,IDATE).EQ.0)
       DO WHILE(IREADMG(LUNIN,SUBSET,IDATE).EQ.0)
       write(indate,'(i10)') idate
c
c... look for only upper-air data... if you want anything else, the
c    following headers can be used :
c
c    ADPSFC SFCSHP  AIRCFT AIRCAR SATWND UPABOG 
c    SFCBOG SATEMP SATBOG SYNDAT PROFLR SPSSMI
c
       IF(SUBSET.EQ.catname) THEN
C
         DO WHILE(IREADSB(LUNIN).EQ.0)
c
           CALL UFBINT(LUNIN,HDR,14,  1,NLEV,HSTR)
c
           hr=hdr(4)
           flon=hdr(2)
           flat=hdr(3)
           typx=hdr(6)
           typintx=hdr(8)
           elvx=hdr(5)
           kkx = idint(hdr(6)*.01)
c
       if((nvar.eq.0).and.(imas.eq.1).and.(kkx.ne.1)) go to 443
       if((nvar.eq.0).and.(iwnd.eq.1).and.(kkx.ne.2)) go to 443
c
c... check for window hour...
       hrx=hr*10.
       fhrsx=fhrs*10.
       fhrex=fhre*10.
           if((hrx.ge.fhrsx).and.(hrx.le.fhrex)) then
c
c... look for all stations inside the lat/lon box specified...
c
       flonx=flon
       if((iodd.eq.1).and.(flonx.lt.flonw)) flonx=flonx+360.
c
       if((flonx.ge.flonw).and.(flonx.le.flone).and.
     *    (flat.le.flatn).and.(flat.ge.flats)) then
c
c...  first time....
       if(ist.eq.0) then
       IST=IST+1
       tstn(IST)='        '
       tstn(IST)=stnid
       tlon(IST)=flon
       tlat(IST)=flat
       thr(IST)=hr
       elvt(IST)=elvx
       typint(IST)=typintx
       if(kkx.eq.1) then
       typ(IST)=typx-100
       else
       typ(IST)=typx-200
       endif
       go to 10
       endif
c
c..   check for unique station....
       if(nvar.eq.1) then
       do n=1,ist
       dlon=abs(flon-tlon(n))
       dlat=abs(flat-tlat(n))
       dthr=abs(hr-thr(n))
       if((dlat.le.0.01).and.(dlon.le.0.01).and.(dthr.le.0.001)) then
       mmf=mmfill(n)
       mwf=mwfill(n)
c
c...  check if both wind and mass report have been read..
       if((mmf.eq.1).and.(mwf.eq.1)) go to 443
       if((mmf.eq.0).and.(mwf.eq.0)) go to 12
       if((mmf.eq.1).or.(mwf.eq.1))  go to 10
c
       endif
       enddo
       endif
c
c...  if not, then add a new station....
 12    continue
       IST=IST+1
       if(ist.gt.nst) then
       print *,'number of stations exceeded'
       print *,'increase number to more than ',nst
       go to 1555
       endif
       tstn(IST)='        '
       tstn(IST)=stnid
       tlon(IST)=flon
       tlat(IST)=flat
       thr(IST)=hr
       elvt(IST)=elvx
       typint(IST)=typintx
       if(kkx.eq.1) then
       typ(IST)=typx-100
       else
       typ(IST)=typx-200
       endif
c
 10    continue
c
       do nn=1,4
       psob(nn)=bmiss
       enddo
c
       if((kkx.eq.1).and.(imas.eq.1)) then
       do ll=1,255
       do nn=1,4
       pob(nn,ll)=bmiss
       zob(nn,ll)=bmiss
       tob(nn,ll)=bmiss
       qob(nn,ll)=bmiss
       enddo
       enddo
       do ll=1,nlevs
       do nn=1,4
       ppr(nn,ll)=bmiss
       zpr(nn,ll)=bmiss
       tpr(nn,ll)=bmiss
       qpr(nn,ll)=bmiss
       enddo
       enddo
       endif
c
       if((kkx.eq.2).and.(iwnd.eq.1)) then
       do ll=1,255
       do nn=1,4
       uob(nn,ll)=bmiss
       vob(nn,ll)=bmiss
       enddo
       enddo
       do ll=1,nlevs
       do nn=1,4
       ppr(nn,ll)=bmiss
       zpr(nn,ll)=bmiss
       tpr(nn,ll)=bmiss
       qpr(nn,ll)=bmiss
       upr(nn,ll)=bmiss
       vpr(nn,ll)=bmiss
       enddo
       enddo
       endif
c
c... get surface pressure ob
       if(kkx.eq.1) then
       CALL UFBINT(LUNIN,PSOB, 4,1,NLEV,PSTR1)
       if(nlev.eq.1) then
       do i=1,4
       if(psob(i).ne.bmiss) pspr(i)=psob(i)
       if(pspr(i).gt.rmiss) pspr(i)=bmiss
       enddo
       pso(IST) =  pspr(1)
       psa(IST) =  pspr(2)
       psf(IST) =  pspr(3)
       psq(IST) =  pspr(4)
       endif
       write(6,610) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * pso(ist),psa(ist),psf(ist),psq(ist)
       endif
c
c... get pressure at all levels..
       CALL UFBINT(LUNIN,POB, 4,255,NLEV,PSTR)
C..
       lx=0
       DO l=1,nlev
c
       pdata=POB(1,l)
c
       if(iprs.le.1) then
       if(kkx.eq.1) k=GETLEV(pdata,plev,itol,nlevs,kfillm,ist,nst)
       if(kkx.eq.2) k=GETLEV(pdata,plev,itol,nlevs,kfillw,ist,nst)
       else
       k=0
       lx=lx+1
       if(lx.gt.nlevs) then
       print *,'number of levels more than ilev ..cap at level ',pdata
       go to 443
       endif
       if((kkx.eq.1).and.(kfillm(lx,ist).eq.0)) k=lx
       if((kkx.eq.2).and.(kfillw(lx,ist).eq.0)) k=lx
       endif
c
c..  check proper level...
c
       if(k.gt.0) then
c
       if(iprs.le.1) then
       PO(K,IST) =  plev(k)
       else
       if(nvar.eq.0) then
       po(k,ist)=pob(1,l)
       else
       if(kkx.eq.1) POM(K,IST) =  pob(1,l)
       if(kkx.eq.2) POW(K,IST) =  pob(1,l)
       endif
       endif
c
c...  check for mass report....
       if((kkx.eq.1).and.(imas.eq.1)) then
       kmmax(ist)=k
       kfillm(k,ist)=1
       mmfill(ist)=1
c
       CALL UFBINT(LUNIN,ZOB, 4,255,NLEV,ZSTR)
       CALL UFBINT(LUNIN,TOB, 4,255,NLEV,TSTR)
       CALL UFBINT(LUNIN,QOB, 4,255,NLEV,QSTR)
c
       do i=1,4
       if(zob(i,l).ne.bmiss) zpr(i,k)=zob(i,l)
       if(zpr(i,k).gt.rmiss) zpr(i,k)=bmiss
       if(tob(i,l).ne.bmiss) tpr(i,k)=tob(i,l)
       if(tpr(i,k).gt.rmiss) tpr(i,k)=bmiss
       if(qob(i,l).ne.bmiss) qpr(i,k)=qob(i,l)
       if(qpr(i,k).gt.rmiss) qpr(i,k)=bmiss
       enddo
c
       ZO(K,IST) =  ZPR(1,K)
       ZQ(K,IST) =  ZPR(4,K)
       TQ(K,IST) =  TPR(4,K)
       QQ(K,IST) =  QPR(4,K)
c
       TO(K,IST) =  TPR(1,K)
       QO(K,IST) =  QPR(1,K)
       if(TO(K,IST).ne.bmiss) TO(K,IST) =  TO(K,IST)+273.159
       IF(QO(K,IST).ne.bmiss) QO(K,IST) =  QO(K,IST)*1.E-3
       TV =  TO(K,IST)
       Q  =  QO(K,IST)
       if(Q.ne.bmiss) Q=Q*1.E-3
       if((Q.ne.bmiss).and.(TV.ne.bmiss)) TO(K,IST)=TV/(1.+.608*Q)
c
       if(iall.eq.1) then
       ZA(K,IST) =  ZPR(2,K)
       ZF(K,IST) =  ZPR(3,K)
c
       TA(K,IST) =  TPR(2,K)
       QA(K,IST) =  QPR(2,K)
       if(TA(K,IST).ne.bmiss) TA(K,IST) =  TA(K,IST)+273.159
       IF(QA(K,IST).ne.bmiss) QA(K,IST) =  QA(K,IST)*1.E-3
       TV = TA(K,IST)
       Q = QA(K,IST)
       if(Q.ne.bmiss) Q=Q*1.E-3
       if((Q.ne.bmiss).and.(TV.ne.bmiss)) TA(K,IST)=TV/(1.+.608*Q)
c
       TF(K,IST) =  TPR(3,K)
       QF(K,IST) =  QPR(3,K)
       if(TF(K,IST).ne.bmiss) TF(K,IST) =  TF(K,IST)+273.159
       IF(QF(K,IST).ne.bmiss) QF(K,IST) =  QF(K,IST)*1.E-3
       TV =  TF(K,IST)
       Q  =  QF(K,IST)
       if(Q.ne.bmiss) Q=Q*1.E-3
       if((Q.ne.bmiss).and.(TV.ne.bmiss)) TF(K,IST)=TV/(1.+.608*Q)
       endif
c
       if(idbug.eq.1) then
       pval=po(k,ist)
       typx=typ(ist)+100
       if((iprs.gt.1).and.(nvar.eq.1)) pval=pom(k,ist)
       if(iall.eq.1) then
c
       write(6,611) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,zo(k,ist),za(k,ist),zf(k,ist),zq(k,ist)
       write(6,612) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,to(k,ist),ta(k,ist),tf(k,ist),tq(k,ist)
       write(6,613) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,qo(k,ist),qa(k,ist),qf(k,ist),qq(k,ist)
c
       else
c
       write(6,711) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,zo(k,ist),zq(k,ist)
       write(6,712) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,to(k,ist),tq(k,ist)
       write(6,713) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,qo(k,ist),qq(k,ist)
c
       endif
       endif
c
       endif
c
c... now for wind report...
       if((kkx.eq.2).and.(iwnd.eq.1)) then
       kwmax(ist)=k
       kfillw(k,ist)=1
       mwfill(ist)=1
c
       CALL UFBINT(LUNIN,UOB, 4,255,NLEV,USTR)
       CALL UFBINT(LUNIN,VOB, 4,255,NLEV,VSTR)
c
       do i=1,4
       if(uob(i,l).ne.bmiss) upr(i,k)=uob(i,l)
       if(upr(i,k).gt.rmiss) upr(i,k)=bmiss
       if(vob(i,l).ne.bmiss) vpr(i,k)=vob(i,l)
       if(vpr(i,k).gt.rmiss) vpr(i,k)=bmiss
       enddo
c
       UO(K,IST) =  UPR(1,K)
       VO(K,IST) =  VPR(1,K)
       WQ(K,IST) =  UPR(4,K)
c
       if(iall.eq.1) then
       UA(K,IST) =  UPR(2,K)
       UF(K,IST) =  UPR(3,K)
       VA(K,IST) =  VPR(2,K)
       VF(K,IST) =  VPR(3,K)
       endif
c
       if(idbug.eq.1) then
       pval=po(k,ist)
       typx=typ(ist)+200
       if((iprs.gt.1).and.(nvar.eq.1)) pval=pow(k,ist)
       if(iall.eq.1) then
c
       write(6,614) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,uo(k,ist),ua(k,ist),uf(k,ist),wq(k,ist)
       write(6,615) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,vo(k,ist),va(k,ist),vf(k,ist)
c
       else
c
       write(6,714) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,uo(k,ist),wq(k,ist)
       write(6,715) ist,indate,stnid,flon,flat,typx,typintx,elvx,hr,
     * k,pval,vo(k,ist)
c
       endif
       endif
c
       endif
c
c...  end proper level section
       endif
c
c...  end quality mark section
c      endif
c
c... end level-loop
		   ENDDO
c
c... end lat/lon box section
       endif
c
c... end window-hour section
       endif
c
 443   continue
c
       ENDDO
c
c...  end report section
       endif
C
       ENDDO
c
 1555  continue
       nstns=IST
       print *,indate,' number of stations ',nstns
c
c.... get unique station ids...
c
       do j=1,nstns
        n=0
        idj=tstn(j)
        do i=j+1,nstns
        idi=tstn(i)
        if(idj.eq.idi) then
        n=n+1
        print *,' unique station ',idj,idi,j,i,n
        write(labn,'(i1)') n
        idi(6:6)=labn
        tstn(i)=idi
        endif
        enddo
       enddo
c
       nstf=0
       do ist=1,nstns
c
c...   find a common set of levels
c
       if((iprs.gt.1).and.(nvar.eq.1)) then
c
       im=1
       iw=1
       nl=0
       do k=1,nlevs
c
       zog(k)=bmiss
       tog(k)=bmiss
       qog(k)=bmiss
       zag(k)=bmiss
       tag(k)=bmiss
       qag(k)=bmiss
       zfg(k)=bmiss
       tfg(k)=bmiss
       qfg(k)=bmiss
       zqg(k)=bmiss
       tqg(k)=bmiss
       qqg(k)=bmiss
       uog(k)=bmiss
       vog(k)=bmiss
       uag(k)=bmiss
       vag(k)=bmiss
       ufg(k)=bmiss
       vfg(k)=bmiss
       wqg(k)=bmiss
c
       pm=pom(im,ist)
       pw=pow(iw,ist)
       if(pm.eq.bmiss.and.pw.eq.bmiss) go to 11
       if(pm.ne.bmiss.and.pw.eq.bmiss) then
       pog(k)=pm
       zog(k)=zo(im,ist)
       tog(k)=to(im,ist)
       qog(k)=qo(im,ist)
       zag(k)=za(im,ist)
       tag(k)=ta(im,ist)
       qag(k)=qa(im,ist)
       zfg(k)=zf(im,ist)
       tfg(k)=tf(im,ist)
       qfg(k)=qf(im,ist)
       zqg(k)=zq(im,ist)
       tqg(k)=tq(im,ist)
       qqg(k)=qq(im,ist)
       im=im+1
       nl=nl+1
       go to 11
       endif
       if(pm.eq.bmiss.and.pw.ne.bmiss) then
       pog(k)=pw
       uog(k)=uo(iw,ist)
       vog(k)=vo(iw,ist)
       uag(k)=ua(iw,ist)
       vag(k)=va(iw,ist)
       ufg(k)=uf(iw,ist)
       vfg(k)=vf(iw,ist)
       wqg(k)=wq(iw,ist)
       iw=iw+1
       nl=nl+1
       go to 11
       endif
c
       nl=nl+1
       if(pm.gt.pw) then
       pog(k)=pm
       zog(k)=zo(im,ist)
       tog(k)=to(im,ist)
       qog(k)=qo(im,ist)
       zag(k)=za(im,ist)
       tag(k)=ta(im,ist)
       qag(k)=qa(im,ist)
       zfg(k)=zf(im,ist)
       tfg(k)=tf(im,ist)
       qfg(k)=qf(im,ist)
       zqg(k)=zq(im,ist)
       tqg(k)=tq(im,ist)
       qqg(k)=qq(im,ist)
       im=im+1
       endif
       if(pm.eq.pw) then
       pog(k)=pm
       zog(k)=zo(im,ist)
       tog(k)=to(im,ist)
       qog(k)=qo(im,ist)
       zag(k)=za(im,ist)
       tag(k)=ta(im,ist)
       qag(k)=qa(im,ist)
       zfg(k)=zf(im,ist)
       tfg(k)=tf(im,ist)
       qfg(k)=qf(im,ist)
       zqg(k)=zq(im,ist)
       tqg(k)=tq(im,ist)
       qqg(k)=qq(im,ist)
       uog(k)=uo(iw,ist)
       vog(k)=vo(iw,ist)
       uag(k)=ua(iw,ist)
       vag(k)=va(iw,ist)
       ufg(k)=uf(iw,ist)
       vfg(k)=vf(iw,ist)
       wqg(k)=wq(iw,ist)
       im=im+1
       iw=iw+1
       endif
       if(pm.lt.pw) then
       pog(k)=pw
       uog(k)=uo(iw,ist)
       vog(k)=vo(iw,ist)
       uag(k)=ua(iw,ist)
       vag(k)=va(iw,ist)
       ufg(k)=uf(iw,ist)
       vfg(k)=vf(iw,ist)
       wqg(k)=wq(iw,ist)
       iw=iw+1
       endif
 11    continue
       enddo
c
       else
c
c... check how many levels are there...
       nl=0
       do l=1,nlevs
       pdata=po(l,ist)
       if(ist.eq.1) print *,l,pdata
       if(pdata.ne.bmiss) then
       nl=nl+1
       pog(nl)=po(l,ist)
       if(imas.eq.1) then
       zog(nl)=zo(l,ist)
       tog(nl)=to(l,ist)
       qog(nl)=qo(l,ist)
       zag(nl)=za(l,ist)
       tag(nl)=ta(l,ist)
       qag(nl)=qa(l,ist)
       zfg(nl)=zf(l,ist)
       tfg(nl)=tf(l,ist)
       qfg(nl)=qf(l,ist)
       zqg(nl)=zq(l,ist)
       tqg(nl)=tq(l,ist)
       qqg(nl)=qq(l,ist)
       endif
       if(iwnd.eq.1) then
       uog(nl)=uo(l,ist)
       vog(nl)=vo(l,ist)
       uag(nl)=ua(l,ist)
       vag(nl)=va(l,ist)
       ufg(nl)=uf(l,ist)
       vfg(nl)=vf(l,ist)
       wqg(nl)=wq(l,ist)
       endif
       endif
       enddo
c
       endif
c
       print *,indate,' number of levels for station ',ist,' ',nl
       if(nl.eq.0) go to 1234
       nstf=nstf+1
c
c....  write grads data out...
c
       id(1:8)='        '
       id=tstn(ist)
       rlon=tlon(ist)
       rlat=tlat(ist)
       hr=thr(ist)
       typx=typ(ist)
       typintx=typint(ist)
       elvx=elvt(ist)
       psog=pso(ist)
       psag=psa(ist)
       psfg=psf(ist)
       psqg=psq(ist)
       iflag=0
       id(7:7)=' '
       id(8:8)='\0'
c
       rt=0.0
       write(51) id,rlat,rlon,rt,nl,iflag
c
       if(iall.eq.1) then
c
       if((imas.eq.1).and.(iwnd.eq.1)) then
       write(51) (pog(l),
     *            typx,typintx,elvx,psog,psag,psfg,psqg,pog(l),
     *            zog(l),zag(l),zfg(l),zqg(l),
     *            tog(l),tag(l),tfg(l),tqg(l),
     *            qog(l),qag(l),qfg(l),qqg(l),
     *            uog(l),uag(l),ufg(l),wqg(l),
     *            vog(l),vag(l),vfg(l),l=1,nl)

       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       do l=1,nl
       write(6,411) indate,hr,psog,psag,psfg,psqg,pog(l),
     *              zog(l),zag(l),zfg(l),zqg(l),
     *              tog(l),tag(l),tfg(l),tqg(l),
     *              qog(l),qag(l),qfg(l),qqg(l),
     *              uog(l),uag(l),ufg(l),wqg(l),
     *              vog(l),vag(l),vfg(l)
       enddo
       endif
       endif
       if((imas.eq.1).and.(iwnd.eq.0)) then
       write(51) (pog(l),
     *            typx,typintx,elvx,psog,psag,psfg,psqg,pog(l),
     *            zog(l),zag(l),zfg(l),zqg(l),
     *            tog(l),tag(l),tfg(l),tqg(l),
     *            qog(l),qag(l),qfg(l),qqg(l),l=1,nl)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       do l=1,nl
       write(6,412) indate,hr,psog,psag,psfg,psqg,pog(l),
     *              zog(l),zag(l),zfg(l),zqg(l),
     *              tog(l),tag(l),tfg(l),tqg(l),
     *              qog(l),qag(l),qfg(l),qqg(l)
       enddo
       endif
       endif
       if((imas.eq.0).and.(iwnd.eq.1)) then
       write(51) (pog(l),
     *            typx,typintx,elvx,psog,psag,psfg,psqg,pog(l),
     *            uog(l),uag(l),ufg(l),wqg(l),
     *            vog(l),vag(l),vfg(l),l=1,nl)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       do l=1,nl
       write(6,413) indate,hr,psog,psag,psfg,psqg,pog(l),
     *              uog(l),uag(l),ufg(l),wqg(l),
     *              vog(l),vag(l),vfg(l)
       enddo
       endif
       endif
c
       else
c
       if((imas.eq.1).and.(iwnd.eq.1)) then
       write(51) (pog(l),
     *            typx,typintx,elvx,psog,psqg,pog(l),
     *            zog(l),zqg(l),
     *            tog(l),tqg(l),
     *            qog(l),qqg(l),
     *            uog(l),wqg(l),
     *            vog(l),l=1,nl)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       do l=1,nl
       write(6,511) indate,hr,psog,psqg,pog(l),
     *              zog(l),zqg(l),
     *              tog(l),tqg(l),
     *              qog(l),qqg(l),
     *              uog(l),wqg(l),
     *              vog(l)
       enddo
       endif
       endif
       if((imas.eq.1).and.(iwnd.eq.0)) then
       write(51) (pog(l),
     *            typx,typintx,elvx,psog,psqg,pog(l),
     *            zog(l),zqg(l),
     *            tog(l),tqg(l),
     *            qog(l),qqg(l),l=1,nl)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       do l=1,nl
       write(6,512) indate,hr,psog,psqg,pog(l),
     *              zog(l),zqg(l),
     *              tog(l),tqg(l),
     *              qog(l),qqg(l)
       enddo
       endif
       endif
       if((imas.eq.0).and.(iwnd.eq.1)) then
       write(51) (pog(l),
     *            typx,typintx,elvx,psog,psqg,pog(l),
     *            uog(l),wqg(l),
     *            vog(l),l=1,nl)
       if(idbuga.eq.1) then
       print *,id,rlat,rlon,rt,nl,iflag
       do l=1,nl
       write(6,513) indate,hr,psog,psqg,pog(l),
     *              uog(l),wqg(l),
     *              vog(l)
       enddo
       endif
       endif
c
       endif
c
 1234  continue
c... end station-loop
        enddo
c
       print *,indate,' total number of stations for grads ',nstf
c
c..  write footer to end this time level
       id='       '
       rlat=0.
       rlon=0.
       rt=0.
       nlev=0
       iflag=0
       write(51) id,rlat,rlon,rt,nlev,iflag
c
       CALL CLOSBF(LUNIN)
       close(51)
c
 411   format(a10,1x,f5.2,1x,4f6.1,1x,f6.1,' mb ',1x,
     *        4(3e10.2,1x,f3.0,/),3e10.2)
 412   format(a10,1x,f5.2,1x,4f6.1,1x,f6.1,' mb ',1x,
     *        3(3e10.2,1x,f3.0,/))
 413   format(a10,1x,f5.2,1x,4f6.1,1x,f6.1,' mb ',1x,
     *        3e10.2,1x,f3.0,1x,3e10.2)
c
 511   format(a10,1x,f5.2,1x,2f6.1,1x,f6.1,' mb ',1x,
     *        2(e10.2,1x,f3.0),1x,e10.2)
 512   format(a10,1x,f5.2,1x,2f6.1,1x,f6.1,' mb ',1x,
     *        3(e10.2,1x,f3.0))
 513   format(a10,1x,f5.2,1x,2f6.1,1x,f6.1,' mb ',1x,
     *        e10.2,1x,f3.0,1x,e10.2)
c
 610   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'ps',1x,3f10.2,1x,'qf ',f4.0)
 611   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'z',1x,i2,1x,f6.1,1x,3f10.2,1x,'qf ',f4.0)
 612   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'t',1x,i2,1x,f6.1,1x,3f10.2,1x,'qf ',f4.0)
 613   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'q',1x,i2,1x,f6.1,1x,3f10.2,1x,'qf ',f4.0)
 614   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'u',1x,i2,1x,f6.1,1x,3f10.2,1x,'qf ',f4.0)
 615   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'v',1x,i2,1x,f6.1,1x,3f10.2)
c
 711   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'z',1x,i2,1x,f6.1,1x,f10.2,1x,'qf ',f4.0)
 712   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'t',1x,i2,1x,f6.1,1x,f10.2,1x,'qf ',f4.0)
 713   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'q',1x,i2,1x,f6.1,1x,f10.2,1x,'qf ',f4.0)
 714   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'u',1x,i2,1x,f6.1,1x,f10.2,1x,'qf ',f4.0)
 715   format(i6,1x,a10,1x,a8,1x,f6.2,1x,f6.2,1x,f4.0,1x,f4.0,1x,f6.1,
     * 1x,f5.2,1x,'v',1x,i2,1x,f6.1,1x,f10.2)
c
       return
       end
C-----------------------------------------------------------------------
       INTEGER FUNCTION nfill(C)
       CHARACTER*(*) C
       NFILL=LEN(C)
       DO 1 J=1,NFILL
       IF(C(J:J).EQ.' ') THEN
       NFILL=J-1
       RETURN
       ENDIF
 1     CONTINUE
       RETURN
       END
      FUNCTION GETLEV(P,plev,itol,nlevs,kfill,ist,nst)
c
      dimension plev(nlevs)
      integer kfill(nlevs,nst)
c
       IP = NINT(P)
c
c..  first check if exact match exists...
       do nl=1,nlevs
       getlev=0
       lsig=plev(nl)
c
       if((ip.eq.lsig).and.(kfill(nl,ist).eq.0)) then
       getlev=nl
c      print *,'from getlev exact ',nl,p,ip,kk,getlev
       return
       endif
c
c      print *,'from getlev exact ',nl,p,ip,kk,getlev
       enddo
c
       if(itol.eq.0) return
c
       do nl=1,nlevs
       getlev=0
       lsig=plev(nl)
c
       do kk=lsig-itol,lsig+itol
       if((ip.eq.kk).and.(kfill(nl,ist).eq.0)) then
       getlev=nl
c      print *,'from getlev tol ',nl,p,ip,kk,getlev
       return
       endif
       enddo
c
c      print *,'from getlev tol ',nl,p,ip,kk,getlev
       enddo
c
      RETURN
      END

program prepobs_glerladj

!$$$ Main Program Documentation Block
!
! Main Program: prepobs_glerladj
!   Programmer: D.Keyser/S.Levine        Org: NCEP/EMC   Date: 2017-07-14
!
! Abstract:  Performs GLERL adjustments to observations in RTMA/URMA prepbufr files.
!    It is intended to be invoked as a step within prepobs_prepdata observation
!    processing. It reads in a PREPBUFR file containing all reports, and also
!    a dictionary of stations.  Stations in the dictionary will either be re-located
!    or have a new, pseudo-ob generated based on original observed value and water 
!    temperature.  If a station is on the wrong side of the RTMA land/sea mask, it
!    will have it's observation moved to a site on the correct side.  In this case it's 
!    lat and lon withh change, but its other observed values will not change (however 
!    changes will be noted in the reason codes).  Certain land
!    observations are used to generate over-water representative conditions.  New obs,
!    with a new type, will be located at a point over the water, and the original ob
!    will remain at it's original point.  All relevant stations are near the Great Lakes.
!    The formula used to adjust the observations originated with John Kelley, formerly of GLERL.
!    The code for obs adjustment originated in glofs v1.0.3 (see edit_sfcmarobs_new.f), 
!    but had to be modified to work with prepbufr and with using both land/water 
!    obs in the RTMA/URMA.
!
! Program History Log:
!   2017-07-14  levine  new code
!
! Usage:
!  Input Files:
!    Unit 11 - water temperatures file (".../CYMD/wtxtbul/glsea-temps.dat")
!    Unit 12 - pre-generated observation 'dictionary' ("fix/glerldict.lmd")
!    Unit 13 - PREPBUFR file containing all obs, prior to any processing by this program
!    Unit 15 - text namelist file ("./dateinfo_input")
!    Unit 91 - copy of PREPBUFR file in Unit 13 (temorary, working file)
!
!  Output Files:
!    Unit 06 - Standard output print
!    Unit 51 - PREPBUFR file identical to input except containing GLERL adjusted obs
!
!   Subprograms called:
!     Unique:    - finddict2  land2water  spddir  td_to_q  uvspd  uzl  water2land 
!     LIBRARY:
!       W3NCO:   - w3fs13  w3tagb    w3tage  errexit
!       BUFRLIB: - closbf  closmg    copybf  copymg  datelen  openbf  openmb  readmg  
!                  readsb  setbmiss  ufbcnt  ufbcpy  ufbevn   ufbint  ufbpos  ufbqcd
!                  writsb 
!
!   Exit states:
!     Cond =   0 - successful run
!             31 - unable to read in lake water temperatures
!             32 - unable to read in station dictionary
!             33 - 2 piece ob with conflicting/unexpected ob type arrangement
!             34 - too many iterations on Z0 in subroutine uzl - check meteorological data
!
!   Remarks:
!      Input Namelist switches (namelist &dateinfo_input):
!            inyear     - year
!           inmonth     - month
!             inday     - day
!
! In event of failure, obsproc_prep should be re-run with the GLERL adjustment turned off
! (ie set GLERLBUFR to "NO" in prepobs_makeprepbufr.sh)
!
! Attributes:
!   Language: FORTRAN 90
!   Machine:  NCEP WCOSS
!
!$$$

!! DAK: The sequence numbers (SQN) for the new mass/wind subset pairs of type
!!      x96, x97, x98, x99 are currently the same as the original mass/wind
!!      subset pair read from the input PREPBUFR file. These new mass/wind
!!      subset pairs should have a unique SQN value (for the message type they
!!      are in since SQN identified as unique mass/wind pair!!

  use glerl_dictionary

  implicit none

  ! DAK: Need dynamic allocation on dimension of imatch

  integer(4),dimension(8000,900)::imatch
  integer(4)::isub,nmsub
  real(8)::sqn_8,sqn_8_last
  integer(4),dimension(dictmax)::types,lake,date,mask,act,anht
  integer(4)::type,stnum,lnum,dsize,iout,ifound,a,b,c,typ,idate,idatd,iret,nlevs,i,j,k
  integer(4)::t29,readvar,sbvar,actflag,maskflag
  integer(4)::recnum,subnum,amsg,asub,bmsg,bsub,amsg_last,asub_last,amsg_1
  integer(4),dimension(dictmax)::dirflaga,dirflagb,dirflagc,dirflagd,dirflage,dirflagf,dirflagg,dirflagh,elev
  integer(4)::ireadmg,ireadsb,year,doy,doyb,inyear,inmonth,inday
  real(8),dimension(6)::watertemp
  real(8),dimension(18)::arra,arrb
  real(8),dimension(255,20)::tpc
  real(8),dimension(2,255,20)::tobs
  real(8),dimension(4)::tmparr,mstarr
  real(8),dimension(3)::hdrarr
  real(8),dimension(5)::wndarr,sobarr
  real(4),dimension(dictmax)::wlat,wlon,llat,llon,olat,olon
  real(8)::bmiss,getbmiss
  integer(4)::vtcd,pcode
  real(4)::newlat,newlon,tdiff,newtyp,otyp,rpt,newrpt,newtypmass,windtyp
  real(4)::wlatnew,wlonnew,llatnew,llonnew
  real(4)::lat,lon,temp,dewpt,uob,vob,wspd,wdir,wtemp,sob,ddo
  real(4)::newtemp,newdpt,newu,newv,newspd,newdir,newq!,newlat,newlon
  real(4)::tqm,qqm,wqm,qob,dfq,pob,pqm
  real(4)::cd,ch,z0,fl,windht !vars needed for conversion to 10 m wind speed
  real(4),external::uz
  character(len=8)::stnid(dictmax),ctyp,sid,sidb,newsid,ctyp0,ctypd,tmpsid
  character(len=20),dimension(dictmax)::desc
  character(len=5)::tempchar
  character(len=80)::nems
  character(len=15)::tmpnems,mstnems,hdrnems
  character(len=30)::wndnems,sobnems
  logical::match,double,dupob,convert

  namelist/dateinfo/inyear,inmonth,inday

  data nems /"SID XOB YOB RPT TYP TOB TDO UOB VOB TQM QQM WQM QOB SOB DDO DFQ POB PQM"/
  data hdrnems /"TYP YOB XOB"/
  data tmpnems /"TOB TQM TPC TRC"/
  data mstnems /"QOB QQM QPC QRC"/
  data wndnems /"UOB VOB WQM WPC WRC"/
  data sobnems /"SOB DDO DFQ DFP DFR"/

  call w3tagb('PREPOBS_GLERLADJ',2017,0178,0070,'NP22')

  CALL SETBMISS(10E8_8)
  bmiss=getbmiss()
  print'(1X)'
  print'(" BUFRLIB value for missing is: ",G0)', bmiss
  print'(1X)'

  open(15,file="dateinfo_input",form="formatted")
  read(15,dateinfo)
  close(15)

  !read water temperatures
  print*, "Reading water temperatures..."
  do c=1,10
     read(11,'(A5)') tempchar
  enddo
  do c=1,99999
     read(11,152,end=90,err=80) year,doy,watertemp(1),watertemp(2),watertemp(3),watertemp(4),watertemp(5),watertemp(6)
     ! 1=Lake Superior, 2=Lake Michigan, 3=Lake Huron, 4=Lake Erie, 5=Lake Ontario 6=Lake St. Clair (not used)
  enddo
  ! If error in reading in water temperatures, fail and return original prepbufr file
80 print*, "FATAL ERROR: Unable to read in lake water temperatures!"
  call w3tage('PREPOBS_GLERLADJ')
  call errexit(31)
152 format (I4,1X,I3,2X,6(F6.2,2X))
111 format (A8,1X,I1,1X,I1,1X,A20,1X,I1,1X,I1,1X,6(F6.2,1X),I3,1X,I2,2X,8I1)
112 format (A8,1X,I1,1X,I1,1X,A20,1X,I1,1X,I1,1X,F5.2,2X,F6.2,2X,F6.2,2X,F6.2,2X,I2,1X,I3,2X,8I1)
90 close(11)
!check that day of year matches
  call w3fs13(inyear,inmonth,inday,doyb)
  if (doy.ne.doyb) then
     print*, "WARNING: Lake temperature date does not equal current date.  Current DOY, lake temp DOY=",doy,doyb
  endif

  !initialize dictionary values
  stnid(:)="MISSING "
  wlat(:)=bmiss
  wlon(:)=bmiss
  llat(:)=bmiss
  llon(:)=bmiss
  olat(:)=bmiss
  olon(:)=bmiss
  elev(:)=misint

  print*, "Reading in changeable stations from dictionary..."
  !read dictionary and store in array
  readdict:  do a=1,99999 !size of newerdict
     read(12,111,end=50,err=55) stnid(a),types(a),lake(a),desc(a),mask(a),act(a),olat(a),olon(a),llat(a),llon(a),wlat(a),wlon(a),elev(a),anht(a),dirflaga(a),dirflagb(a),dirflagc(a),dirflagd(a),dirflage(a),dirflagf(a),dirflagg(a),dirflagh(a) !err=55
     if (stnid(a).eq."XXXXXXXX") then
        goto 50
     endif
     ! LAKE NUMBER ADJUSTMENTXS
     ! change flag to reflect how lake obs are being read in
     ! Georgian Bay is counted as Lake Huron
     ! Lake St. Clair does not exist in land/sea mask, so counting as Lake Erie
     ! 1=Lake Superior, 2=Lake Michigan, 3=Lake Huron, 4=Lake Erie, 5=Lake Ontario
     if (lake(a).eq.3) then
        lake(a) = 4
     elseif (lake(a).eq.6) then
        lake(a) = 2
     endif
     lake(a)=lake(a)+1
     if (lake(a).gt.3) then
        lake(a)=lake(a)-1
     endif
  enddo readdict
  close(12)
! If station dictionary is not read in properly, fail and return original prepbufr file
55 print*, "FATAL ERROR: Unable to read in station dictionary!"
  call w3tage('PREPOBS_GLERLADJ')
  call errexit(32)
50 continue
  dsize=a !-1
  print*, "Number of stations in dictionary: ",dsize

  bmiss=getbmiss()
!vvvvvvvvvvvvvvvvvvvvvvvvvvvvv
! this section reads through PREPBUFR file to mark subsets that are "orphans"
!  (i.e., wind or mass "pieces" that have no partner - these get imatch=0)
! otherwise, 1st of 2 pieces (subset containing wind) gets imatch=1
!            2nd of 2 pieces (subset containing mass) gets imatch=2  
! info will be used later when we march through PREPBUFR file to actually
! generate the output GLERL adjusted PREPBUFR file

! open input PREPBUFR file, set date/time to 10-digit default
  call openbf(13,'IN',13)
  call datelen(10)

  ctyp0="abcd1234" !random default
  imatch = 0
  isub = 0
  amsg_last = 0
  asub_last = 0
  do while(ireadmg(13,ctyp,idate).eq.0)
     if (ctyp.ne.ctyp0) then
        sqn_8_last = -99
     endif
     ctyp0=ctyp
        ! skip message types that are not part of GLERL adjustment
     if (ctyp.ne."ADPSFC  ".and.ctyp.ne."MSONET  ".and.ctyp.ne."SFCSHP  ") cycle
     do while (ireadsb(13).eq.0)
        call ufbcnt(13,amsg,asub)
        !print*, "GLERL amsg= asub= ..." , amsg, asub
        isub = isub+1
        sqn_8 = bmiss
        call ufbint(13,sqn_8,1,1,iret,'SQN')
        if(isub.eq.1) then
           amsg_1 = amsg
           sqn_8_last = sqn_8
           amsg_last = amsg
           asub_last = asub
           imatch(amsg,asub) = 0
           cycle
        endif
 ! SQN (sequence number) is the same in two subsets that are a report pair
        if(sqn_8.eq.sqn_8_last) then
           imatch(amsg_last,asub_last) = 1
           imatch(amsg,asub) = 2
        else
           imatch(amsg,asub) = 0
        endif
   100  format('isub,isub-1,sqn_8,sqn_8_last,amsg,asub,amsg_last,asub_last,imatch(amsg,asub),imatch(amsg_last,asub_last): ',i7,i7,i6,i6,i10,i5,i8,i6,i5,i4)
        sqn_8_last = sqn_8
        amsg_last = amsg
        asub_last = asub
     enddo
  enddo
  call closbf(13)
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

! Copy input PREPBUFR file in unit 13 to unit 91, latter will be read in tamdem
!  with former simply to hold 1st subset (wind piece) in cases of a report pair
!  in internal memory
  call copybf(13,91)

! open input (units 13 and 91) and output (unit 51) PREPBUFR files
  print*, "Opening input prepbufr files..."
  call openbf(13,'IN',13)
  ! use internal dctnry from unit 13 for unit 91 to avoid table mismatches later
  call openbf(91,'IN',13)
  ! Obtain program code (VTCD) associated with "VIRTMP" step
  call ufbqcd(13,'VIRTMP',vtcd)
  print*, "Opening output prepbufr file..."
  call openbf(51,"OUT",13)
  print*, "Prepbufr vtcd value=",vtcd
  call ufbqcd(13,'GLERL',pcode)
  print*, "GLERL program code=",pcode

  ctyp0="abcd1234" !random default
  print*, "Reading through original prepbufr file plus its copy..."
  arra(:)=bmiss !initialize default
  arrb(:)=bmiss
  recnum=0
  print*, "==> Unless otherwise noted Ob found in dictionary was taken over land"

  moremsg: do while(ireadmg(13,ctyp,idate).eq.0)
!-------------------------------------------------------------
! read next message in unit 13 (original input PREPBUFR file)
!-------------------------------------------------------------
     if (ctyp.ne.ctyp0) print*, "New BUFR message type:",ctyp
! simply copy messages that are not part of GLERL adjustment
     if (ctyp.ne."ADPSFC  ".and.ctyp.ne."MSONET  ".and.ctyp.ne."SFCSHP  ") then
        if (ctyp0 .eq."ADPSFC  ".or.ctyp0.eq."MSONET  ".or.ctyp0.eq."SFCSHP  ") call closmg(51)
        call copymg(13,51)
        ctyp0=ctyp
        cycle moremsg
     endif

     call openmb(51,ctyp,idate)
     if (ctyp.ne.ctyp0) print*, "Opening new message due to message type change from ",ctyp0," to ",ctyp," ..."

     moresubs: do while (ireadsb(13).eq.0)
!-------------------------------------------------------------
! read next subset in unit 13 (original input PREPBUFR file)
!-------------------------------------------------------------
! amsg & asub identify location of subset read into unit 13 internal memory
           call ufbcnt(13,amsg,asub)
! using amsg & asub, read same subset into unit 91 internal memory
           call ufbpos(91,amsg,asub,ctypd,idatd)
           call ufbint(13,arra,18,1,iret,nems)
           write(sid,'(a)') arra(1)
!ppppp
!!!        print *, 'new subset read: msgn, subn, sid: ',amsg,asub,sid
!ppppp
           lat=real(arra(3),4)
           if (arra(2).gt.180) then
              lon=real(arra(2),4)-360
           else
              lon=real(arra(2),4)
           endif
! see if station id associated with this subset is in dictionary
           call finddict2(sid,stnid,lat,lon,olat,olon,stnum)
           searchdict: if (stnum.eq.misint) then
              ifound = 0
           else
              ifound = 1
              actflag=act(stnum)
              maskflag=mask(stnum)
              llatnew=llat(stnum)
              llonnew=llon(stnum)+360
              wlatnew=wlat(stnum)
              wlonnew=wlon(stnum)+360
              !assign aneometer height based on dictionary.  Default to 10 m if missing.
              if (anht(stnum).eqv."  ") then
                 windht=10.
              else
                 windht=anht(stnum)
              endif
              if (lake(stnum).eq.9) then
                 wtemp=bmiss
              else
                 wtemp=real(watertemp(lake(stnum)),4)
              endif
           endif searchdict
           indict: if (ifound.eq.0) then
              ! station id associated with this subset NOT found in dictionary
              ! copy subset as is to output PREPBUFR file and move to next subset
!ppppp
!!!           print*, "Station NOT found in dictionary:",sid
!ppppp
              call ufbcpy(13,51)
              call writsb(51)
              arra(:)=bmiss !set arra back to empty
              arrb(:)=bmiss !set arrb back to empty (just to be safe)
              cycle moresubs
           else
              ! station id associated with this subset IS FOUND in dictionary, attempt GLERL adjustment
              print'("Station found in dictionary:",A8,"; if nothing more added, this report was not adjusted/converted/moved, it was simply copied to output as is")',sid

              if(imatch(amsg,asub).eq.0) then
                 ! initial PREPBUFR file read showed this subset is an orphan (wind or mass piece
                 !  that has no partner), copy as is to output PREPBUFR file, move to next subset
                 call ufbcpy(13,51)
                 call writsb(51)
                 cycle moresubs
              endif
!ppppp
!!!           print *, 'amsg,asub,imatch(amsg,asub): ',amsg,asub,imatch(amsg,asub)
!ppppp
              if(imatch(amsg,asub).eq.2) print'("Very odd situation where apparent first piece of a pair seems to be the mass piece -= investigate!!")'
!-------------------------------------------------------------------
! this (wind) subset DOES have a mass piece in the next subset
! read next (mass) subset in unit 13 (original input PREPBUFR file)
! (note that the wind subset will remain in unit 91 internal memory)
!-------------------------------------------------------------------
              call readsb(13,iret)
              newmsg: if (iret.lt.0) then !no more subsets in this message
                                          !read next message from unit 13
                 ctyp0=ctyp
                 call readmg(13,ctyp,idate,iret)
!ppppp
!!!    print *, '*READ NEW MESSAGE: ctyp, nmsub(13): ',ctyp, nmsub(13)
!ppppp
                 if (iret.eq.0.and.ctyp.ne.ctyp0) then
! if new message just read has different type than previous message, last subset
!  read (wind, still in unit 13 internal memory) is an orphan (no subsequent
!  mass piece), copy as is to output PREPBUFR file, move to next msg or subset
! NOTE: Don't think this can actually happen since initial read through PREPBUFR
!       file would have set this subset's imatch value to ZERO and it would have
!       been trapped prior to this point.
                    call ufbcpy(13,51)
                    call writsb(51)
                    print*, "New BUFR message type:",ctyp
                    ! simply copy messages that are not part of GLERL adjustment
                    if (ctyp.ne."ADPSFC  ".and.ctyp.ne."MSONET  ".and.ctyp.ne."SFCSHP  ") then
                       if (ctyp0 .eq."ADPSFC  ".or.ctyp0.eq."MSONET  ".or.ctyp0.eq."SFCSHP  ") call closmg(51)
                       call copymg(13,51)
                       ctyp0=ctyp
                       cycle moremsg
                    endif
      ! if new message type is part of GLERL adj. then ready to read next subset
                    cycle moresubs
                 endif
                 if (iret.ne.0) then
! otherwise if there are no more messages we have hit the end of the file, last
!  subset read (wind, still in unit 13 internal memory) is an orphan (no
!  subsequent mass piece) copy as is to output PREPBUFR file & exit moremsg loop
! NOTE: Don't think this can actually happen since initial read through PREPBUFR
!       file would have set this subset's imatch value to ZERO and it would have
!       been trapped prior to this point.
                    print*, "End of file!"
                    call ufbcpy(13,51)
                    call writsb(51)
                    call closmg(51)
                    exit moremsg
                 else
! otherwise, the 2nd (mass) piece of the report pair is the first subset in the
!  next message just read, read it in now
                    call readsb(13,iret)
                    call ufbint(13,arrb,18,1,iret,nems)
                 endif
              else
                 call ufbint(13,arrb,18,1,iret,nems)
                 write(sidb,'(a)') arrb(1)
              endif newmsg
           endif indict
!+++++++++++++++++++++++++++++++++++++++++++++++++
!         GLERL ADJUSTMENT WORK BEGINS
!+++++++++++++++++++++++++++++++++++++++++++++++++
           !a (piece 1, wind) and b (piece 2, mass) have both been loaded and we know they match
           ! eventually move whole blockw of code below back 3 spaces
              write(sid,'(a)') arra(1)
              if (sid(8:8).eq.'x'.or.sid(8:8).eq.'a') then
                 tmpsid = sid(:7) // ' '
                 sid=tmpsid
              endif
              lat=real(arra(3),4)
              lon=real(arra(2),4)
              rpt=real(arra(4),4)
              checktyp: if (arra(5).ge.200.and.arrb(5).lt.200) then
                 !go into events stack to pull out sensible temperature
                 tpc(:,:)=bmiss
                 call ufbevn(13,tpc,1,255,20,nlevs,'TPC')
                 tobs(:,:,:)=bmiss
                 call ufbevn(13,tobs,2,255,20,nlevs,'TOB TQM')
                 temp = bmiss
                 tqm = bmiss
                 if(tobs(1,1,1).lt.bmiss) then
! process temperature if non-missing
                 !assume we have sensible temp with first call, but we need to check and see if it's a virtual temp.
                 !If it is a virtual temp, sensible should be next in stack
!!! DAK: Since the RTMA/URMA analyses SENSIBLE temperature, we should not encode
!!!      VIRTUAL temperature into PREPBUFR prior to this code in VIRTMP in
!!!      gblevents - it's a waste as both here, and I assume in RTMA/URMA GSI,
!!!      we have to peel back events to get to SENSIBLE temperature
                 do k=1,nlevs  ! DAK: again nlevs here should always be 1
                    do j=1,20
                       temp=real(tobs(1,k,j),4)
                       tqm=real(tobs(2,k,j),4)
                       if (nint(tpc(k,j)).eq.vtcd) then
                          temp=real(tobs(1,k,j+1),4)
                          tqm=real(tobs(2,k,j+1),4)
                          !go ahead and assume sensible sits after virtual in stack.  Use program code to check this.
                          !If not, use that value anyway (because it's probably sensible), but print this warning message:
                          if (nint(tpc(k,j+1)).ne.1) then
                             print*, "WARNING: Temp in stack after virtual may not be sensible.  TPC (k,j+1) should be 1, but it's:",tpc(k,j+1)
                          endif
                          exit !found sensible temperature, exiting loop
                       endif
                       if (tpc(k,j+1)>=bmiss) exit !end of events stack, exit loop
                    enddo
                 enddo
                 endif
                 if (wtemp.ne.bmiss) then
                    tdiff = temp-wtemp
                 else
                    tdiff=bmiss
                 endif
                 dewpt = real(arrb(7),4)
                 uob = real(arra(8),4)
                 vob = real(arra(9),4)
                 qqm = real(arrb(11),4)
                 wqm = real(arra(12),4)
                 qob = real(arrb(13),4)
                 sob = real(arra(14),4)
                 ddo = real(arra(15),4)
                 dfq = real(arra(16),4)
                 pob = real(arra(17),4)
                 pqm = real(arra(18),4)
                 call td_to_q(dewpt,pob,newq)
              else
                 print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                 call w3tage('PREPOBS_GLERLADJ')
                 call errexit(33)
              endif checktyp
              call spddir(uob,vob,wspd,wdir,bmiss)
              if ((abs(wspd-sob).gt.0.5)) then
                 print*, "WARNING: UOB/VOB not consistent with wspd/wdir.  sid,time,uob,vob,wspd,wdir,sob,ddo=",sid,rpt,uob,vob,wspd,wdir,sob,ddo
              endif
              !DOES OB NEED TO BE CONVERTED, OR JUST MOVED?
              convert=.false.
              if (wdir.le.360.) then
                 if (wdir.lt.22.5.or.wdir.ge.337.5) then
                    if (dirflaga(stnum).eq.1) then
                       convert=.true.
                    endif
                 elseif(wdir.lt.67.5) then
                    if (dirflagb(stnum).eq.1) then
                       convert=.true.
                    endif
                 elseif (wdir.lt.112.5) then
                    if (dirflagc(stnum).eq.1) then
                       convert=.true.
                    endif
                 elseif (wdir.lt.157.5) then
                    if (dirflagd(stnum).eq.1) then
                       convert=.true.
                    endif
                 elseif (wdir.lt.202.5) then
                    if (dirflage(stnum).eq.1) then
                       convert=.true.
                    endif
                 elseif (wdir.lt.247.5) then
                    if (dirflagf(stnum).eq.1) then
                       convert=.true.
                    endif
                 elseif (wdir.lt.292.5) then
                    if (dirflagg(stnum).eq.1) then
                       convert=.true.
                    endif
                 else !if wdir.lt.337.5
                    if (dirflagh(stnum).eq.1) then
                       convert=.true.
                    endif
                 endif
              endif
              if (actflag.eq.1) then
                 if (convert) then
                    print*, "Land Ob needs to be converted:",sid
                    !convert wind speed to 10 m level if needed
                    if (windht.ne.10.) then
                       call uzl(wspd,windht,tdiff,windht,cd,ch,z0,fl)
                       wspd=uz(10.,wspd,cd,z0,fl)
                    endif
                    !used new wind speed in conversion
                    print*, "Converting station (land to water):",sid,rpt
                    call land2water(temp,dewpt,wspd,wdir,wtemp,tdiff,newtemp,newdpt,newspd,newdir,bmiss)
                    call uvspd(newspd,newdir,newu,newv,bmiss)
                    newq = bmiss
                    if(newdpt.lt.bmiss) call td_to_q(newdpt,pob,newq)
                    !copy old ob
!------------------------------------------------------------------------------
!  since copy of PREPBUFR file holds 1st (wind) piece of pair in its (unit 91)
!   internal memory, don't need to waste time calling ufbpos to place previous
!   (wind) subset in unit 13 internal memory, and then later calling ufbpos
!   again to restore following (mass) subset into unit 13 internal memory
!   (since first ufbpos not called, mass subset remains in unit 13 internal
!   memory)
!  NOTE: This will happen many times from here on in code - this is only place
!        where it is commented.
                    call ufbcpy(91,51)
                    call writsb(51)
                    call ufbcpy(13,51)
                    call writsb(51)
!------------------------------------------------------------------------------
                    !copy old ob again and convert to new ob
                    call ufbcpy(91,51)
                    wndarr(1)=newu
                    wndarr(2)=newv
                    wndarr(3)=wqm !orig wqm
                    wndarr(4)=pcode !pcode=17 (new bufr table)
                    wndarr(5)=adjust
                    sobarr(1)=newspd
                    sobarr(2)=newdir
                    sobarr(3)=dfq
                    sobarr(4)=pcode
                    sobarr(5)=adjust
                    tmparr(1)=newtemp
                    tmparr(2)=tqm
                    tmparr(3)=pcode
                    tmparr(4)=adjust
                    mstarr(1)=newq
                    mstarr(2)=qqm
                    mstarr(3)=pcode
                    mstarr(4)=adjust
                    if (arra(5).ge.200) then
                       hdrarr(1)=297.
                       hdrarr(2)=wlatnew
                       hdrarr(3)=wlonnew
                       call ufbint(51,hdrarr,3,1,iret,hdrnems)
                       call ufbint(51,wndarr,5,1,iret,wndnems)
                       call ufbint(51,sobarr,5,1,iret,sobnems)
                    else
                       print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                       call w3tage('PREPOBS_GLERLADJ')
                       call errexit(33)
                    endif
                    call writsb(51)
                    !copy over and adjust b array
                    print*, "Copying over original ob again...piece b..."
                    call ufbcpy(13,51)
                    if (arrb(5).lt.200) then
                       hdrarr(1)=197.
                       hdrarr(2)=wlatnew
                       hdrarr(3)=wlonnew
                       call ufbint(51,hdrarr,3,1,iret,hdrnems)
                       call ufbint(51,tmparr,4,1,iret,tmpnems)
                       call ufbint(51,mstarr,4,1,iret,mstnems)
                    else
                       print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                       call w3tage('PREPOBS_GLERLADJ')
                       call errexit(33)
                    endif
                    call writsb(51)
                 else
                    !ob does not need to be converted
                    !does it need to be moved?
                    if (olat(stnum).eq.llat(stnum).and.olon(stnum).eq.llon(stnum)) then
                       !ob does not need to be moved
                       !copy ob and no worries
                       call ufbcpy(91,51)
                       call writsb(51)
                       call ufbcpy(13,51)
                       call writsb(51)
                    else
                       print*, "Ob needs to be relocated to match with mask..."
                       print'("Old lat/lon, new lat/lon:",4(2x,g0))', lat,lon,llatnew,llonnew
                       !ob needs to be moved
                       !get original values
                       call ufbint(91,arra,18,1,iret,nems)
                       call ufbint(13,arrb,18,1,iret,nems)
                       !assign new lat and lon
                       tmparr(1)=temp
                       tmparr(2)=tqm
                       tmparr(3)=pcode
                       tmparr(4)=moved !moved ob
                       mstarr(1)=qob
                       mstarr(2)=qqm
                       mstarr(3)=pcode
                       mstarr(4)=moved
                       wndarr(1)=uob
                       wndarr(2)=vob
                       wndarr(3)=wqm
                       wndarr(4)=pcode
                       wndarr(5)=moved
                       sobarr(1)=sob
                       sobarr(2)=ddo
                       sobarr(3)=dfq
                       sobarr(4)=pcode
                       sobarr(5)=moved
                       call ufbcpy(91,51)
                       if (arra(5).ge.200) then
                          hdrarr(1)=298.
                          hdrarr(2)=llatnew
                          hdrarr(3)=llonnew
                          call ufbint(51,hdrarr,3,1,iret,hdrnems)
                          call ufbint(51,wndarr,5,1,iret,wndnems)
                          call ufbint(51,sobarr,5,1,iret,sobnems)
                       else
                          print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                          call w3tage('PREPOBS_GLERLADJ')
                          call errexit(33)
                       endif
                       call writsb(51)
                       !now piece b
                       call ufbcpy(13,51)
                       if (arrb(5).lt.200) then
                          hdrarr(1)=198
                          hdrarr(2)=llatnew
                          hdrarr(3)=llonnew
                          call ufbint(51,hdrarr,3,1,iret,hdrnems)
                          call ufbint(51,tmparr,4,1,iret,tmpnems)
                          call ufbint(51,mstarr,4,1,iret,mstnems)
                       else
                          print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                          call w3tage('PREPOBS_GLERLADJ')
                          call errexit(33)
                       endif
                       call writsb(51)
                    endif
                 endif
              elseif (actflag.eq.0) then
                 print*, "Ob was taken over water."
                 if (convert) then
                    print*, "Water ob needs to be converted!"
                    if (windht.ne.10.) then
                       call uzl(wspd,windht,tdiff,windht,cd,ch,z0,fl)
                       wspd=uz(10.,wspd,cd,z0,fl)
                    endif
                    print*, "Converting station (water to land):",sid,rpt
                    call water2land(temp,dewpt,wspd,wdir,wtemp,tdiff,newtemp,newdpt,newspd,newdir,bmiss)
                    newq = bmiss
                    if(newdpt.lt.bmiss) call td_to_q(newdpt,pob,newq)
                    call uvspd(newspd,newdir,newu,newv,bmiss)
                    !copy old ob
                    call ufbcpy(91,51)
                    call writsb(51)
                    call ufbcpy(13,51)
                    call writsb(51)
                    !copy old ob again and convert to new ob
                    call ufbcpy(91,51)
                    !assign land lat/lon coords
                    wndarr(1)=newu
                    wndarr(2)=newv
                    wndarr(3)=wqm !orig wqm
                    wndarr(4)=pcode !pcode=17 (new bufr table)
                    wndarr(5)=adjust
                    sobarr(1)=newspd
                    sobarr(2)=newdir
                    sobarr(3)=dfq
                    sobarr(4)=pcode
                    sobarr(5)=adjust
                    tmparr(1)=newtemp
                    tmparr(2)=tqm
                    tmparr(3)=pcode
                    tmparr(4)=adjust
                    mstarr(1)=newq
                    mstarr(2)=qqm
                    mstarr(3)=pcode
                    mstarr(4)=adjust
                    if (arra(5).ge.200) then
                       hdrarr(1)=299.
                       hdrarr(2)=llatnew
                       hdrarr(3)=llonnew
                       call ufbint(51,hdrarr,3,1,iret,hdrnems)
                       call ufbint(51,wndarr,5,1,iret,wndnems)
                       call ufbint(51,sobarr,5,1,iret,sobnems)
                    else
                       print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                       call w3tage('PREPOBS_GLERLADJ')
                       call errexit(33)
                    endif
                    call writsb(51)
                    !now same with b piece
                    call ufbcpy(13,51)
                    !assign land lat/lon coords
                    if (arrb(5).lt.200) then
                       hdrarr(1)=199.
                       hdrarr(2)=llatnew
                       hdrarr(3)=llonnew
                       call ufbint(51,hdrarr,3,1,iret,hdrnems)
                       call ufbint(51,tmparr,4,1,iret,tmpnems)
                       call ufbint(51,mstarr,4,1,iret,mstnems)
                    else
                       print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                       call w3tage('PREPOBS_GLERLADJ')
                       call errexit(33)
                    endif
                    call writsb(51)
                 else
                    !ob does not need to be converted
                    !does it need to be moved
                    if (olat(stnum).eq.wlat(stnum).and.olon(stnum).eq.wlon(stnum)) then
                       !ob should not be moved
                       !copy ob and no worries
                       call ufbcpy(91,51)
                       call writsb(51)
                       call ufbcpy(13,51)
                       call writsb(51)
                    else
                       !ob needs to be moved
                       !get original values
                       print*, "Ob needs to be moved to match with mask."
                       print'("Original lat/lon, new lat/lon:",4(2x,g0))', lat,lon,wlatnew,wlonnew
                       call ufbint(91,arra,18,1,iret,nems)
                       call ufbint(13,arrb,18,1,iret,nems)
                       tmparr(1)=temp
                       tmparr(2)=tqm
                       tmparr(3)=pcode
                       tmparr(4)=moved !moved ob
                       mstarr(1)=qob
                       mstarr(2)=qqm
                       mstarr(3)=pcode
                       mstarr(4)=moved
                       wndarr(1)=uob
                       wndarr(2)=vob
                       wndarr(3)=wqm
                       wndarr(4)=pcode
                       wndarr(5)=moved
                       sobarr(1)=sob
                       sobarr(2)=ddo
                       sobarr(3)=dfq
                       sobarr(4)=pcode
                       sobarr(5)=moved
                       call ufbcpy(91,51)
                       if (arra(5).ge.200) then
                          hdrarr(1)=296.
                          hdrarr(2)=wlatnew
                          hdrarr(3)=wlonnew
                          call ufbint(51,hdrarr,3,1,iret,hdrnems)
                          call ufbint(51,wndarr,5,1,iret,wndnems)
                          call ufbint(51,sobarr,5,1,iret,sobnems)
                       else
                          print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                          call w3tage('PREPOBS_GLERLADJ')
                          call errexit(33)
                       endif
                       call writsb(51)
                       !now piece b
                       call ufbcpy(13,51)
                       if (arrb(5).lt.200) then
                          hdrarr(1)=196.
                          hdrarr(2)=wlatnew
                          hdrarr(3)=wlonnew
                          call ufbint(51,hdrarr,3,1,iret,hdrnems)
                          call ufbint(51,tmparr,4,1,iret,tmpnems)
                          call ufbint(51,mstarr,4,1,iret,mstnems)
                       else
                          print*, "FATAL ERROR: 2 piece ob with conflicting/unexpected ob type arrangement for station,typea,typeb: ",sid,arra(5),arrb(5)
                          call w3tage('PREPOBS_GLERLADJ')
                          call errexit(33)
                       endif
                       call writsb(51)
                    endif
                 endif
              else
                 print*, "FATAL ERROR: Improper actual value for station in dictionary file:",sid,a,actflag
              endif
     enddo moresubs
     ctyp0=ctyp
  enddo moremsg
! Hit end of file in unit 13 - all done, close all BUFR files and exit program
  call closbf(51)
  call closbf(13)
  call closbf(91)

  call w3tage('PREPOBS_GLERLADJ')
  stop
end program prepobs_glerladj

      module def_vitals
        type tcvcard         ! Define a new type for a TC Vitals card
          sequence
          character*4   tcv_center      ! Hurricane Center Acronym
          character*4   tcv_storm_id    ! Storm Identifier (03L, etc)
          character*9   tcv_storm_name  ! Storm name
          integer       tcv_ymd         ! Date of observation (yyyymmdd)
          integer       tcv_hhmm        ! Time of observation (UTC)
          integer       tcv_lat         ! Storm Lat (*10), always >0
          character*1   tcv_latns       ! 'N' or 'S'
          integer       tcv_lon         ! Storm Lon (*10), always >0
          character*1   tcv_lonew       ! 'E' or 'W'
          integer       tcv_stdir       ! Storm motion vector (in degr)
          integer       tcv_stspd       ! Spd of storm movement (m/s*10)
          integer       tcv_pcen        ! Min central pressure (mb)
          integer       tcv_penv        ! val outrmost closed isobar(mb)
          integer       tcv_penvrad     ! rad outrmost closed isobar(km)
          integer       tcv_vmax        ! max sfc wind speed (m/s)
          integer       tcv_vmaxrad     ! rad of max sfc wind spd (km)
          integer       tcv_r15ne       ! NE rad of 15 m/s winds (km)
          integer       tcv_r15se       ! SE rad of 15 m/s winds (km)
          integer       tcv_r15sw       ! SW rad of 15 m/s winds (km)
          integer       tcv_r15nw       ! NW rad of 15 m/s winds (km)
          character*1   tcv_depth       ! Storm depth (S,M,D) X=missing
        end type tcvcard
        type (tcvcard), save, allocatable :: storm(:)
        integer, save, allocatable :: stormswitch(:)
        real, save, allocatable    :: slonfg(:,:),slatfg(:,:)
        character*3, save, allocatable :: stcvtype(:) ! FOF or TCV
      end module def_vitals
c
      module gen_vitals
        type gencard     ! Define a new type for a genesis vitals card
          sequence
          integer       gv_gen_date    ! genesis date in yyyymmddhh
          integer       gv_gen_fhr     ! genesis fcst hour (usually 0)
          integer       gv_gen_lat     ! genesis lat (*10), always >0
          character*1   gv_gen_latns   ! 'N' or 'S'
          integer       gv_gen_lon     ! genesis lon (*10), always >0
          character*1   gv_gen_lonew   ! 'W' or 'E'
          character*3   gv_gen_type    ! 'FOF'; or TC Vitals ATCF ID
          integer       gv_obs_ymd     ! Date of observation (yyyymmdd)
          integer       gv_obs_hhmm    ! Time of observation (UTC)
          integer       gv_obs_lat     ! Storm Lat (*10), always >0
          character*1   gv_obs_latns   ! 'N' or 'S'
          integer       gv_obs_lon     ! Storm Lon (*10), always >0
          character*1   gv_obs_lonew   ! 'E' or 'W'
          integer       gv_stdir       ! Storm motion vector (in degr)
          integer       gv_stspd       ! Spd of storm movement (m/s*10)
          integer       gv_pcen        ! Min central pressure (mb)
          integer       gv_penv        ! val outrmost closed isobar(mb)
          integer       gv_penvrad     ! rad outrmost closed isobar(km)
          integer       gv_vmax        ! max sfc wind speed (m/s)
          integer       gv_vmaxrad     ! rad of max sfc wind spd (km)
          integer       gv_r15ne       ! NE rad of 15 m/s winds (km)
          integer       gv_r15se       ! SE rad of 15 m/s winds (km)
          integer       gv_r15sw       ! SW rad of 15 m/s winds (km)
          integer       gv_r15nw       ! NW rad of 15 m/s winds (km)
          character*1   gv_depth       ! Storm depth (S,M,D) X=missing
        end type gencard
        type (gencard), save, allocatable :: gstorm(:)
      end module gen_vitals
c
      module inparms
        type datecard  ! Define a new type for the input namelist parms
          sequence
          integer       bcc    ! First 2 chars of yy of date (century)
          integer       byy    ! Beginning yy of date to search for 
          integer       bmm    ! Beginning mm of date to search for 
          integer       bdd    ! Beginning dd of date to search for 
          integer       bhh    ! Beginning hh of date to search for 
          integer       model  ! integer identifier for model data used
          character*8   modtyp ! 'global' or 'regional'
          character*7   lt_units ! 'hours' or 'minutes' to indicate the
                                 ! units of lead times in grib files
          character*6   file_seq ! 'onebig' or 'multi' tells if grib
                                 ! data will be input as one big file or
                                 ! as individual files for each tau.
          character*8   nesttyp ! Either "moveable" or "fixed"
        end type datecard
      end module inparms
c
      module trkrparms
        type trackstuff  ! Define a new type for various tracker parms
          sequence
          real          westbd  ! Western boundary of search area
          real          eastbd  ! Eastern boundary of search area
          real          northbd ! Northern boundary of search area
          real          southbd ! Southern boundary of search area
          character*7   type    ! 'tracker', 'midlat' or 'tcgen'
          real          mslpthresh ! min mslp gradient to be maintained
          real          v850thresh ! min avg 850 Vt to be maintained
          character*8   gridtype ! 'global' or 'regional'
          real          contint  ! Contour interval to be used for 
                                 ! "midlat" or "tcgen" cases.     
          logical       want_oci ! Flag for whether to compute & write
                                 ! out roci for a trkrtype=tracker run
          character*1   out_vit  ! Flag for whether to write out vitals
          integer       gribver  ! Indicates whether input data is 
                                 ! GRIBv1 (1) or GRIBv2 (2)
          integer       g2_jpdtn ! Indicates GRIB2 template to use when
                                 ! reading (0 = deterministic fcst, 
                                 ! 1 = ens fcst)
        end type trackstuff
      end module trkrparms
c
      module contours
        integer, parameter :: maxconts=100 ! max # of cont. intervals
        type cint_stuff  ! Define a new type for contour interval info
          sequence
          real    :: xmaxcont ! max contour level in a field
          real    :: xmincont ! min contour level in a field
          real    :: contvals(maxconts) ! contour values in the field
          integer :: numcont  ! # of contour levels in a field
        end type cint_stuff
      end module contours
c     
      module atcf
        integer         atcfnum   ! ATCF ID of model (63 for GFDL...)
        character*4     atcfname  ! ATCF Name of model (GFSO for GFS...)
        integer         atcfymdh  ! YMDH to be used as initial date for
                                  ! output ATCF forecast records.  Will
                                  ! be equal to initial run date for all
                                  ! models except SREF; SREF will have a
                                  ! start date artificially modified to
                                  ! be 3 hours earlier in order to not
                                  ! cause the NHC interpolator to burp.
        integer         atcffreq  ! frequency (in centahours) of output
                                  ! for atcfunix and certain other
                                  ! files.  Default: 600 (six-hourly)
      end module atcf
c
      module gfilename_info
        character*4 ,save :: gmodname  ! Model ID for first part of GRIB
                                  ! file name ("gfdl","hwrf","hrs", etc)
        character*40 ,save :: rundescr ! This is descriptive and up to
                                  ! the developer (e.g., "6thdeg",
                                  ! "9km_run","1.6km_run"         
                                  ! "15km_ens_run_member_n13", etc)
        character*40 ,save :: atcfdescr ! This is optional.  If used, it
                                  ! should be something that identifies
                                  ! the particular storm, preferably
                                  ! using the atcf ID.  For example, the
                                  ! GFDL model standard is to use
                                  ! something like "ike09l", or  
                                  ! "two02e", etc.             
      end module gfilename_info
c
      module phase
        character*1 , save ::   phaseflag   ! Will phase be determined
                                            ! (y/n)                   
        character*4 , save ::   phasescheme ! What scheme to use:
                                    ! cps  = Hart's cyclone phase space
                                    ! vtt  = Vitart                    
                                    ! both = Both cps and vtt are used
        real, save  :: wcore_depth  ! The contour interval (in deg K)
                             ! used in determining if a closed contour 
                             ! exists in the 300-500 mb T data, for
                             ! use with the vtt scheme.
      end module phase
c
      module structure
        character*1 , save ::   structflag  ! Will structure be
                                            ! analyzed (y/n)?
        character*1 , save ::   ikeflag     ! Will IKE & SDP be
                                            ! computed (y/n)?
      end module structure
c     
      module tracked_parms
          real, save, allocatable  ::  zeta(:,:,:)
          real, save, allocatable  ::  u(:,:,:)
          real, save, allocatable  ::  v(:,:,:)
          real, save, allocatable  ::  hgt(:,:,:)
          real, save, allocatable  ::  slp(:,:)
          real, save, allocatable  ::  tmean(:,:)

c-J.Peng----2014-10-01----------
          real, save, allocatable  ::  ushear(:,:)
          real, save, allocatable  ::  rhumid(:,:)

          real, save, allocatable  ::  cpshgt(:,:,:)
          integer, save, allocatable :: ifhours(:)  
          integer, save, allocatable :: iftotalmins(:)
          integer, save, allocatable :: ifclockmins(:)
          integer, save, allocatable :: ltix(:)
          real, save, allocatable    :: fhreal(:)
      end module tracked_parms
c     
      module radii
c       For Barnes smoothing of parameters for tracking, e-folding
c       radius = retrk (km), influence radius = ritrk (km). Max radius
c       for searching for the max vorticity = rads (km).  There is an
c       important distinction between rads and ritrk.  rads is used to
c       determine the maximum distance from the guess position that
c       we'll allow points to be in order to be considered as a
c       candidate location for the updated fix position.  On the other
c       hand, ritrk is used once you're doing the barnes analysis on
c       data for that candidate location, so that if data is not within
c       distance ritrk of the candidate location, we ignore it.  Also, 
c       for use in find_maxmin, nhalf = the number of times to halve the
c       spacing of the search grid.  Note that different values are used
c       for the magnitude of the wind than for other parameters; this is
c       so that the search area is restricted in order to avoid a 
c       problem of the program finding one wind minimum near the center
c       and another one out near the storm's edge.
c
c       redlm and ridlm = the e-folding radius (km) and influence radius
c       (km) for Barnes analysis of u,v for updating first guess lat,lon
c       for search.  dlm = deep layer mean.
c
c        real, parameter :: retrk_most=60.0, retrk_vmag=60.0
c        real, parameter :: ritrk_most=120.0, ritrk_vmag=120.0
c        real, parameter :: rads_most=120.0, rads_vmag=120.0
c        real, parameter :: retrk_most=150.0, retrk_vmag=60.0
c        real, parameter :: ritrk_most=300.0, ritrk_vmag=120.0
c        real, parameter :: rads_most=300.0, rads_vmag=120.0
        real, parameter :: retrk_most=75.0, retrk_vmag=60.0
        real, parameter :: ritrk_most=150.0, ritrk_vmag=120.0
        real, parameter :: rads_most=300.0, rads_vmag=120.0
        real, parameter :: retrk_coarse=150.0, retrk_hres=60.0
        real, parameter :: rads_fine=200.0, rads_hres=150.0
        real, parameter :: ritrk_coarse=300.0, rads_coarse=350.0
        real, parameter :: redlm=500.0, ridlm=2000.0
c        real, parameter :: redlm=500.0, ridlm=1700.0
ctpm6/14        real, parameter :: redlm=500.0, ridlm=1000.0
      end module radii
c
      module grid_bounds
        real, save ::  glatmin, glatmax, glonmin, glonmax  ! These 
                       ! define the boundaries of the input data grid
        real, save, allocatable ::  glat(:), glon(:)  ! Will be filled
                       ! with lat/lon values for each pt on input grid
      end module grid_bounds
c
      module error_parms
        real, parameter :: err_gfs_init=275.0 ! init errmax for gfs,mrf
                                              ! and gdas
        real, parameter :: err_reg_init=300.0 ! init errmax for others
        real, parameter :: err_ecm_max=330.0  ! errmax for ecmwf
        real, parameter :: err_reg_max=225.0  ! errmax for others for
                                              ! remaining fcst times
        real, parameter :: maxspeed_tc=60  ! max speed of storm movement
                                           ! for tracker or tcgen cases
        real, parameter :: maxspeed_ml=80  ! max speed of storm movement
                                           ! for midlat cases
C        real, parameter :: errpgro=1.25, errpmax=600.0
        real, parameter :: errpgro=1.25, errpmax=485.0
        real, parameter :: stermn = 0.1   ! Min Std dev for trk errors
        real, parameter :: uverrmax = 225.0  ! For use in get_uv_guess
      end module error_parms
c
      module set_max_parms
        integer, parameter :: maxstorm_tc=15  ! max # of storms pgm can
                                           ! handle, for tc tracker case
        integer, parameter :: maxstorm_mg=2000  ! max # of storms pgm can
                                      ! handle, for midlat or tcgen case
        integer, parameter :: maxtime=500  ! max # of fcst times pgm 
        integer, parameter :: maxtp=11     ! max # of tracked parms 
        integer, parameter :: maxmodel=20  ! max # of models currently 
                                           ! available
        integer, parameter :: max_ike_cats=6 ! max # of IKE categories
        integer, save :: interval_fhr      ! # of hrs between fcst times
        integer, parameter :: maxcenters=150 ! max # of max/min centers
                                             ! to be tracked.
      end module set_max_parms
c
      module level_parms
        integer, parameter :: nlevs=4   ! max # of vert levs to be read
        integer, parameter :: nlevg=3   ! # of vert levs to be used for
                                        ! figuring next guess position
        integer, parameter :: nlevm1=2  ! # tracked levs for hgt
        integer, parameter :: nlevzeta=3 ! # tracked levs for zeta
        integer, parameter :: levsfc=4  ! array position of sfc winds.
        integer, parameter :: nlev850=1 ! array position in u and v
        integer, parameter :: nlev700=2 ! arrays for 850, 700 & 500
        integer, parameter :: nlev500=3 ! winds.  Used in get_uv_center
        integer, parameter :: nlevs_cps=13 ! # levs for Hart's CPS
        real, save      :: wgts(nlevg)  ! Wghts for use in get_next_ges
        data wgts /0.25, 0.50, 0.25/    ! 850, 700 & 500 mb wgts
      end module level_parms
c
      module trig_vals
        real, save :: pi, dtr
        real, save :: dtk = 111.1949     ! Dist (km) over 1 deg lat
                                         ! using erad=6371.0e+3
        real, save :: erad = 6371.0e+3   ! Earth's radius (m)
        real, save :: ecircum = 40030.2  ! Earth's circumference
                                         ! (km) using erad=6371.e3
        real, save :: omega = 7.292e-5
      end module trig_vals
c
      module verbose_output
        integer, save :: verb            ! Level of detail printed to terminal
                                         ! 0 = No output
                                         ! 1 = Error messages only
                                         ! 2 = 
                                         ! 3 = All      
      end module verbose_output
c
      module waitfor_parms
        character*1 :: use_waitfor ! y or n, for waiting for input files
        integer :: wait_min_age    ! min age (in seconds)... time since
                                   ! last file modification
        integer :: wait_min_size   ! minimum file size in bytes
        integer :: wait_max_wait   ! max total wait time in seconds 
        integer :: wait_sleeptime  ! number of seconds to wait between 
                                   ! checks
        integer, parameter :: pfc_cmd_len = 800
        character*1 :: use_per_fcst_command ! enable per_fcst_command
        character(pfc_cmd_len) :: per_fcst_command ! command to run every forecast time
      end module waitfor_parms
c---------------------------------------------------------------------c
c

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    W3XTOVSEDS
C   PRGMMR: DONG             ORG: NP22       DATE: 2020-01-09
C
C ABSTRACT: READS AND UNPACKS ONE REPORT FROM INPUT RTOVS OR ATOVS
C   RETRIEVAL BUFR (DUMP) FILE INTO SPECIFIED FORMAT. RETURNS
C   INFORMATION IN THE FORMAT OF AN UNPACKED NMCEDS FILE. ONLY THOSE
C   ELEMENTS OF NMCEDS NEEDED BY THE PREPDATA PROGRAM ARE ACTUALLY
C   PROCESSED INTO NMCEDS FORMAT, THE REMAINING WORDS OF THE 140-WORD
C   ARRAY ARE SET TO 7777 "MISSING". THERE IS SOME OTHER RETRIEVAL
C   INFORMATION RETURNED. ALSO, INFORMATION ABOUT THE INPUT DATA SET
C   ITSELF (NAME, CENTER DATE, DUMP TIME) IS RETURNED.
C
C PROGRAM HISTORY LOG:
C 1998-03-10  BERT B. KATZ
C 1998-05-05  D.A. KEYSER/NP22 -- STREAMLINED, CORRECTED ERRORS
C 1998-06-15  D.A. KEYSER/NP22 -- ADDED CALL TO W3FI04 FIRST TIME IN
C      TO OBTAIN MACHINE WORD LENGTH (USED TO HARDWIRE WORD LENGTH
C      OF 8 BYTES AS USED IN XMOVEX SUBROUTINE); FILTER FLAG RETURNED
C      IN IBUFTN(20) NOW HAS SAME MEANING AS FOR TOVS (250KM SUB-
C      SAMPLING), IT'S ACTUAL VALUE IS NOW RETURNED (WAS HARDWIRED
C      TO 0)
C 1998-09-21  D.A. KEYSER/NP22 -- SUBROUTINE NOW Y2K AND FORTRAN 90
C      COMPLIANT
C 1999-01-20 D. A. KEYSER -- INCORPORATED BOB KISTLER'S CHANGES NEEDED
C      TO PORT THE CODE TO THE IBM SP
C 1999-11-02  D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE
C 1999-11-19  D. A. KEYSER -- INCLUDES NOAA-15 ATOVS DATA (AS WELL AS
C      RTOVS DATA)
C 2000-02-17 D. A. KEYSER -- IF DATE OF INPUT FILE IS PRIOR TO
C      7/1/1998 (CAN ONLY BE RTOVS), THEN DOES NOT USE "TOFF" TO GET
C      FILTER FLAG (NOT VALID AT THIS TIME), RATHER SETS OUTPUT
C      FILTER FLAG TO "-99" WHICH ALERTS CALLING PROGRAM TO PROCESS
C      ONLY EVERY 4'TH RTOVS RETRIEVAL AND EVERY 11'TH ATOVS RETRIEVAL
C      TO SIMULATE 250KM SAMPLING (NEEDED FOR HISTORICAL CDAS RUNS)
C 2000-12-05  D.A. KEYSER/NP22 -- ACCOUNTS FOR NESDIS ERROR IN SCALING
C      BOTTOM PRESSURE VALUE (AND WILL STILL WORK RIGHT IF THEY FIX
C      IT);  PERFORMS A SANITY CHECK ON THE BOTTOM PRESSURE VALUE
C      (ATOVS ONLY); IF FILTER FLAG NOT FOUND FOR ATOVS, SET OUTPUT
C      FILTER FLAG TO "-99" WHICH ALERTS CALLING PROGRAM TO PROCESS
C      ONLY EVERY 11'TH RETRIEVAL TO SIMULATE 250KM SAMPLING (NEEDED
C      FOR CDAS RUNS), WAS SET TO 0
C 2001-07-16  D.A. KEYSER/NP22 -- CONSIDERS ATOVS RETRIEVALS WITH BOTH
C      CLEAR AND CLOUDY BIT "OFF" (=0) IN SATELLITE DATA PROCESSING
C      TECHNIQUE TO BE CLOUDY (BEFORE THEY WERE UNKNOWN - RTOVS ARE
C      STILL UNKNOWN IN THIS CASE)
C 2008-03-10  D.A. KEYSER/NP22 -- HANDLES METOP-2 SATELLITE (BUFR
C      SATELLITE ID 004)
C 2012-11-30  J. WOOLLEN      --  INITIAL PORT TO WCOSS; RESET BMISS TO
C      A VALUE (10E08) WHICH WILL NOT CAUSE INTEGER OVERFLOW WHICH CAN
C      BE UNPREDICTABLE (PRIOR BMISS VALUE WAS 10E10)
C 2013-02-14  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS;  OBTAIN
C      VALUE OF BMISS SET IN CALLING PROGRAM VIA CALL TO BUFRLIB
C      ROUTINE GETBMISS RATHER THAN HARDWIRING IT TO 10E08 (OR 10E10);
C      USE BUFRLIB FUNCTION IBFMS TO DETERMINE IF A VARIABLE READ FROM
C      BUFR FILE IS MISSING (I.E. RETURNED AS BMISS); ADDED BMISS AS
C      INPUT ARGUMENT TO SUBROUTINE XTOVSEDS02; USE FORMATTED PRINT
C      STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS USED (WCOSS
C      SPLITS UNFORMATTED PRINT AT 80 CHARACTERS)
C 2014-11-25  D. A. KEYSER -- HANDLES NEW SATELLITES METOP-1 (BUFR
C      SATELLITE ID 3, CONVERTED TO LOCAL SATELLITE ID 10), NOAA-19
C      (BUFR SATELLITE ID 223, CONVERTED TO LOCAL SATELLITE ID 9), AND
C      NPP (BUFR SATELLITE ID 224, CONVERTED TO LOCAL SATELLITE ID 11);
C      NOW ENCODES BUFR SATELLITE ID VALUE (CODE TABLE 0-01-007) INTO
C      IBUFTN(2) (PREVIOUSLY A SPARE SET TO MISSING) FOR DIRECT USE BY
C      SUBROUTINE W3CNVXTOVS
C 2020-01-09  J. Dong -- In subroutine W3XTOVSEDS, changed the windowing
C      decade from 20 to 40 for cases when the year is represented by
C      2 digits instead of 4.

C 2022-05-15  I. GENKOVA --  DEFINED IDSAT AS INTEGER(8) TO ACCOMODATE
C     COMPILER ON WCOSS2
C
C USAGE :   CALL W3XTOVSEDS(IUNIT,IBDATE,IBUFTN,ISATOB,PBOT,DSNAME,
C                           IDSDAT,IDSDMP_8,IERR)
C   INPUT ARGUMENT LIST:
C     IUNIT    - UNIT NUMBER OF INPUT FILE CONTAINING RETRIEVAL DATA
C              - IN BUFR FORMAT.
C     DSNAME   - CHARACTER*8 DATA SET NAME (SAME FOR ALL REPORTS IN
C              - A COMMON INPUT DATA SET - SEE REMARKS FOR IERR=1)
C              - (NOTE: ONLY DEFINED AFTER FIRST CALL TO THIS
C              - SUBROUTINE)
C
C   OUTPUT ARGUMENT LIST:
C     IBDATE   - DATE IN SECTION 1 OF BUFR MESSAGE CONTAINING THIS
C              - RETRIEVAL (IN FORM YYYYMMDDHH)
C     IBUFTN   - CONTAINS A SINGLE DECODED RETRIEVAL IN NMCEDS FORMAT
C              - (140 MACHINE WORD LENGTH INTEGER WORDS)
C     ISATOB   - 3-WORD INTEGER ARRAY CONTAINING RETURNED DATA
C              - (SEE REMARKS FOR CONTENTS)
C     PBOT     - FIRST ABOVE-GROUND RTOVS/ATOVS PRESSURE LEVEL IN MB
C              - (MISSING IS 99999.)
C     DSNAME   - CHARACTER*8 DATA SET NAME (SAME FOR ALL REPORTS IN
C              - A COMMON INPUT DATA SET - SEE REMARKS FOR IERR=1)
C     IDSDAT   - INTEGER DATA SET CENTER DATE IN FORM YYYYMMDDHH (SAME
C              - FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - REMARKS FOR IERR=1)
C     IDSDMP_8 - INTEGER*8 DATA SET DUMP TIME IN FORM YYYYMMDDHHMM
C              - (SAME FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - REMARKS FOR IERR=1)
C     IERR     - ERROR RETURN CODE
C                 =  0 OBSERVATION READ AND UNPACKED INTO LOCATIONS
C                        'IBUFTN', 'ISATOB', AND 'PBOT'.  SEE REMARKS
C                        FOR CONTENTS. NEXT CALL TO W3XTOVSEDS WILL
C                        RETURN NEXT OBSERVATION IN DATA SET.
C                 =  1 INFORMATION ABOUT THE BUFR DATASET IS RETURNED
C                        IN THE OUTPUT ARGUMENTS DSNAME, IDSDAT,
C                        IDSDMP_8 (SEE OUTPUT ARGUMENT LIST ABOVE)
C
C                        THIS SHOULD ALWAYS OCCUR AFTER THE FIRST CALL
C                        TO THIS SUBROUTINE.  NO REPORT IS UNPACKED AT
C                        THIS POINT, AND ONLY DSNAME, IDSDAT, AND
C                        IDSDMP_8 CONTAIN INFORMATION.  ALL SUBSEQUENT
C                        CALLS TO W3XTOVSEDS SHOULD RETURN THE
C                        OBSERVATIONS IN THIS DATA SET, SEQUENTIALLY,
C                        (IERR=0) UNTIL THE END OF FILE IS ENCOUNTERED
C                        (IERR=2).  THE VALUES STORED IN DSNAME,
C                        IDSDAT, AND IDSDMP_8 WILL CONTINUE TO BE
C                        RETURNED ALONG WITH EACH REPORT WHEN IERR = 0.
C                 =  2 FOR NORMAL END-OF-FILE ENCOUNTERED.)
C                 = -1 FOR END-OF-FILE ON FIRST READ -- EMPTY FILE
C                 = -2 FOR INPUT BUFR FILE NOT Y2K COMPLIANT -- NO
C                        PROCESSING DONE
C                 = -3 CENTER DATE COULD NOT BE OBTAINED FROM INPUT
C                        FILE -- NO PROCESSING DONE
C
C   INPUT FILES:
C     UNIT "IUNIT" - FILE CONTAINING BUFR RTOVS OR ATOVS DATA
C
C   OUTPUT FILES:
C     UNIT 06 - STANDARD OUTPUT PRINT
C
C   SUBPROGRAMS CALLED:
C     UNIQUE        - XTOVSEDS02 WORDLENGTH
C     LIBRARY:
C       W3NCO       - GBYTES   W3DIFDAT
C       BUFRLIB     - DATELEN  DUMPBF   OPENBF   READMG   READSB
C                   - UFBINT   UFBREP   CLOSBF   GETBMISS IBFMS
C
C REMARKS:
C
C     CONTENTS OF OUTPUT ARGUMENT IBUFTN {140 INTEGER WORDS - IN NMCEDS
C       FORMAT EXCEPT WHERE NOTED -- ONLY THE WORDS NOTED BELOW
C       ARE FILLED WITH DATA (THAT NEEDED BY THE PREPDATA PROGRAM) -
C       ALL OTHER WORDS ARE SET TO MISSING - 7777)}:
C        WORD 1 - "Local" or "NESDIS" Satellite ID:
C                   NOAA-08 -----  6
C                   NOAA-09 -----  7
C                   NOAA-10 -----  8
C                   NOAA-11 -----  1
C                   NOAA-12 -----  2
C                   NOAA-14 -----  3
C                   NOAA-15 -----  4
C                   NOAA-16 -----  5
C                   NOAA-17 -----  6
C                   NOAA-18 -----  7
C                   NOAA-19 -----  9
C                   METOP-1(B) -- 10
C                   METOP-2(A) --  8
C                   NPP --------- 11
C        * -  2 - BUFR Satellite ID (from Code Table 0-01-007):
C                   NOAA-08 ---- 200
C                   NOAA-09 ---- 201
C                   NOAA-10 ---- 202
C                   NOAA-11 ---- 203
C                   NOAA-12 ---- 204
C                   NOAA-14 ---- 205
C                   NOAA-15 ---- 206
C                   NOAA-16 ---- 207
C                   NOAA-17 ---- 208
C                   NOAA-18 ---- 209
C                   NOAA-19 ---- 223
C                   METOP-1(B) -   3
C                   METOP-2(A) -   4
C                   NPP -------- 224
C             3 - Day of month * 256 plus hour of day (UTC)
C             4 - Minute * 256 plus second (UTC)
C             5 - Latitude (degrees * 100, N+, S-)
C             6 - Longitude (degrees * 100, E+, W-)
C             8 - Land/sea indicator (Land - elev in meters, Sea - 0)
C             9 - Surface (skin) temperature (K * 10)
C            12 - Retrieval method
C        * - 16 - Nadir proximity indicator (Range: 1-9, where 1
C                  is at Nadir and 9 is at limb)
C            20 - Filter Flag {good = 0; redundant = 1;
C                  prior to 07/01/1998 (RTOVS) or missing (ATOVS only)
C                  = -99}
C            23 - Layer 1 - pressure at lower boundary (mb * 10)
C            24 - Layer 1 - pressure at upper boundary (mb * 10)
C            25 - Layer 1 - mean virtual temperature (K * 10)
C            26 - Layer 1 - always missing (7777)
C            27 - 82 - Repeat 23-27 for Layers 2 - 15
C
C        * - Definition changed from original NMCEDS documentation
C         Missings are set to 7777
C
C     CONTENTS OF OUTPUT ARGUMENT ISATOB (3 INTEGER WORDS) FOR EACH
C      RETRIEVAL:
C        WORD  1 - ORBIT NUMBER
C              2 - DAY/NIGHT QUALIFIER (=0 FOR NIGHT)
C                                      (=1 FOR DAY)
C                                      (BUFR C.T. 0-08-013)
C              3 - SNOW/ICE FLAGS (TERRAIN TYPE)
C                                      (RTOVS: BUFR C.T. 0-13-209)
C                                      (ATOVS: BUFR C.T. 0-13-039)
C         Missings are set to XMISS (99999.)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE W3XTOVSEDS(IUNIT,IBDATE,IBUFTN,ISATOB,PBOT,DSNAME,
     $ IDSDAT,IDSDMP_8,IERR)

      DATA IFIRST/0/,JFIRST/0/,IUNITL/-99/,KOUNTR/0/,LWI/0/,LWR/0/,
     $ ITOFF/0/, MFIRST/0/,nfirst/0/

      REAL GEOOPR(18),TLAYER(15),PLAYER(16),RINC(5)

      INTEGER IBUFTN(140),ISATOB(3),JDATE(5),JDUMP(5),IBIT(2)
      INTEGER(8) IDSDAT, IDSDMP_8,JDUMP_8(5),KDATE(8),LDATE(8) 

      CHARACTER*8 SUBSET,DSNAME
      DATA NUMLVL/0/,ISTLVL/0/

      CHARACTER*50 IDTSTR
      DATA IDTSTR/'FOVN SAID CLAT CLON DAYS HOUR MINU SECO ORBN DNQL '/

      CHARACTER*10 IDTST2
      DATA IDTST2/'TOFF OBQL '/

      CHARACTER*10 SATSTR
      DATA SATSTR/'SDPT LSQL '/

      CHARACTER*20 SRFSTR
      DATA SRFSTR/'PRES SELV TERR TERN '/

      CHARACTER*12 RTVSTR,ATVSTR
      DATA RTVSTR/'TMDB   MIXR '/
      DATA ATVSTR/'TMDBST MIXR '/

      REAL(8) XIDENT_8(12),SATDAT_8(2),SRFDAT_8(4),RETDAT_8(2,41),
     $        AMAXIMUM_8,WOPR_8(15),TMP_8,TMPOPR_8(40)
      REAL(8) BMISS,GETBMISS

      REAL TOVLEV(40)

      SAVE

      DATA TOVLEV/0.1,0.2,0.5,1.0,1.5,2.0,3.0,4.0,5.0,7.0,10.0,15.0,
     $            20.0,25.0,30.0,50.0,60.0,70.0,85.0,100.0,115.0,135.0,
     $            150.0,200.0,250.0,300.0,350.0,400.0,430.0,475.0,500.0,
     $            570.0,620.0,670.0,700.0,780.0,850.0,920.0,950.0,
     $            1000.0/
      DATA  XMISS/99999./,IMISS/99999/

C  FCN PR GETS STD. ATMOS. PRESSURE (MB) FROM HEIGHT (M) (HGHT < 11000M)
C  ---------------------------------------------------------------------

      PR(HGHT) = 1013.25 * (((288.15 - (.0065 * HGHT))/288.15)**5.256)

      IF(IFIRST.EQ.0) THEN

C  FIRST TIME IN, SET DATELEN, GET WORDLENGTH FOR INTEGERS AND REALS,
C   AND GET VALUE FOR "BMISS"
C  ------------------------------------------------------------------

         IFIRST = 1
         call datelen(10)
         CALL WORDLENGTH(LWI,LWR)
         PRINT 678, LWI,LWR
  678 FORMAT('  ===> W3XTOVEDS: MACHINE WORD LENGTH: INTEGERS - ',I1,
     $ '; REALS - ',I1/)

      END IF

      IF(IUNIT.NE.IUNITL)  JFIRST = 0
      IF(IUNIT.NE.IUNITL)  MFIRST = 0
      IF(IUNIT.NE.IUNITL)  NFIRST = 0


      IF(JFIRST.EQ.0) THEN

C  FIRST TIME IN FOR A NEW INPUT FILE, GET CENTER AND DUMP TIME FOR
C   FILE AND TEST FOR CENTER FILE DATE PRIOR TO 07/01/1998
C  -----------------------------------------------------------------

         PRINT'("  ==> W3XTOVSEDS -- WCOSS VERSION 01-09-2020")'
         JFIRST = 1
         IUNITL = IUNIT
         CALL DUMPBF(IUNIT,JDATE,JDUMP)
         print'(" w3xtovseds output for jdate and jdump ")'
         print'(" CENTER DATE (JDATE) = ",5(I0,1X))', jdate
         print'(" DUMP DATE   (JDUMP) = ",5(I0,1X))', jdump
         print'(1X)'
         IF(JDATE(1).LE.0)  then
            PRINT'(" ##W3XTOVSEDS - CENTER DATE COULD NOT BE OBTAINED ",
     $       "FROM INPUT FILE ON UNIT ",I0," -- IERR = -3")', IUNIT
            ierr = -3
            return
         END IF
         IF(JDATE(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN JDATE(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

            PRINT'(" ##W3XTOVSEDS - THE FOLLOWING SHOULD NEVER ",
     $       "HAPPEN!!!!!")'
            PRINT'(" ##W3XTOVSEDS - 2-DIGIT YEAR IN JDATE(1) RETURNED ",
     $       "FROM DUMPBF (JDATE IS: ",I5,4I3,") - USE WINDOWING ",
     $       "TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', JDATE
C IF JDATE=41~99 THEN JDATE=1941~1999
C IF JDATE=00~40 THEN JDATE=2000~2040
            IF(JDATE(1).GT.40)  THEN
               JDATE(1) = 1900 + JDATE(1)
            ELSE
               JDATE(1) = 2000 + JDATE(1)
            ENDIF
            PRINT'(" ##W3XTOVSEDS - CORRECTED JDATE(1) WITH 4-DIGIT ",
     $       "YEAR, JDATE NOW IS: ",I5,4I3)', JDATE
         ENDIF
         IDSDAT = JDATE(1)*1000000+JDATE(2)*10000+JDATE(3)*100+JDATE(4)
         IF(JDUMP(1).LE.0)  THEN
            IDSDMP_8 = 999999999999_8
         ELSE
            IF(JDUMP(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN JDUMP(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

               PRINT'(" ##W3XTOVSEDS - THE FOLLOWING SHOULD NEVER ",
     $          "HAPPEN!!!!!")'
               PRINT'(" ##W3XTOVSEDS - 2-DIGIT YEAR IN JDUMP(1) ",
     $          "RETURNED FROM DUMPBF (JDUMP IS: ",I5,4I3,") - USE ",
     $          "WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', JDUMP
C IF JDUMP=41~99 THEN JDUMP=1941~1999
C IF JDUMP=00~40 THEN JDUMP=2000~2040
               IF(JDUMP(1).GT.40)  THEN
                  JDUMP(1) = 1900 + JDUMP(1)
               ELSE
                  JDUMP(1) = 2000 + JDUMP(1)
               ENDIF
               PRINT'(" ##W3XTOVSEDS - CORRECTED JDUMP(1) WITH 4-DIGIT",
     $          " YEAR, JDUMP NOW IS: ",I5,4I3)', JDUMP
            END IF
            JDUMP_8 = JDUMP
            IDSDMP_8 = JDUMP_8(1)*100000000+JDUMP_8(2)*1000000+
     $       JDUMP_8(3)*10000+JDUMP_8(4)*100+JDUMP_8(5)
         ENDIF
c-----------------------------------------------------------------------
c This logic is needed only because SUBSET is not returned in DUMPBF
c  and we need it in order to return dsname - after dsname is retrieved
c  close data set ..
         call openbf(iunit,'IN',iunit)
         call readmg(iunit,subset,ibdate,iret)
         if(subset.eq.'NC003102')  then
            dsname = 'RTOVS   '
            numlvl = 40
            istlvl =  1
         else if(subset.eq.'NC003104')  then
            dsname = 'ATOVS   '
            numlvl = 41
            istlvl =  2
         else
            dsname = '????????'
         end if
         call closbf(iunit)
c-----------------------------------------------------------------------
         KDATE(1:3) = JDATE(1:3)
         KDATE(4)   = 0
         KDATE(5:6) = JDATE(4:5)
         KDATE(7:8) = 0
         LDATE(1)   = 1998
         LDATE(2)   = 07
         LDATE(3)   = 01
         LDATE(4:8) = 0
         CALL W3DIFDAT(KDATE,LDATE,1,RINC)
         IF(RINC(1).LT.0.0)  THEN
            WRITE(6,3004)
 3004       FORMAT(/'##W3XTOVSEDS - DATE OF INPUT FILE IS PRIOR TO ',
     $       '07/01/1998 - VALUE IN "TOFF" NOT RELATED TO FILTER FLAG ',
     $       'SO SET'/15X,'OUTPUT FILTER FLAG TO -99 FOR ALL REPORTS'/)
            ITOFF = 1
         END IF
c-----------------------------------------------------------------------

C  GET VALUE FOR "BMISS"
C  --------------------

         BMISS = GETBMISS()
         print'(1X)'
         print'(" BUFRLIB value for missing passed into W3XTOVSEDS is:",
     $    1X,G0)', bmiss
         print'(1X)'
c-----------------------------------------------------------------------

         IERR = 1
         RETURN
      ELSE  IF(JFIRST.EQ.1) THEN

C  SECOND TIME IN FOR A NEW INPUT FILE , OPEN BUFR DATASET FOR INPUT
C   AND DECODE FIRST MESSAGE
C  -----------------------------------------------------------------

         JFIRST = 2
         CALL OPENBF(IUNIT,'IN',IUNIT)
         CALL READMG(IUNIT,SUBSET,IBDATE,IRET)
         IF(IRET.NE.0) THEN
            WRITE(6,1009) IUNIT
 1009       FORMAT('##W3XTOVSEDS ERROR: EMPTY FILE IN UNIT ',I5)
            IERR = -1
            RETURN
         ENDIF
         IF(IBDATE.LT.100000000)  THEN
c IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
c  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
c  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            WRITE(6,1209) IUNIT
 1209       FORMAT('##W3XTOVSEDS ERROR: A 10-DIGIT SECT. 1 BUFR ',
     $       'MESSAGE DATE WAS NOT RETURNED IN UNIT',I5,' - PROBLEM ',
     $       'WITH BUFR FILE')
            IERR = -2
            RETURN
         END IF

      ENDIF

 1000 CONTINUE

C  EACH CALL TO READSB INCREASES "KOUNTR" BY 1 (REGARDLESS OF RESULT)
C  ------------------------------------------------------------------

      KOUNTR = KOUNTR + 1

      CALL READSB(IUNIT,IRET)
      IF(IRET.NE.0) THEN
         CALL READMG(IUNIT,SUBSET,IBDATE,IRET)
         IF(IRET.NE.0) THEN

C  ALL BUFR MESSAGES HAVE BEEN READ AND DECODED -- ALL DONE
C  --------------------------------------------------------

            WRITE(6,1001) IUNIT
 1001 FORMAT(//' ==> W3XTOVSEDS: END OF FILE ON UNIT',I3,' -- ALL DONE'
     $ /)
            IERR = 2
            RETURN
         ENDIF
         IF(IBDATE.LT.100000000)  THEN
c IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
c  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
c  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            WRITE(6,1209) IUNIT
            IERR = -2
            RETURN
         END IF
         GO TO 1000
      ENDIF

      IBUFTN = 7777
cppppp
cdak  print'(" INITIALLY -- IBUFTN = .....")'
cdak  print, IBUFTN
cppppp

      PBOT = XMISS
      ISATOB = IMISS

      XIDENT_8 = BMISS
      CALL UFBINT(IUNIT,XIDENT_8,12, 1,IRET,IDTSTR//IDTST2)

      SATDAT_8 = BMISS
      CALL UFBINT(IUNIT,SATDAT_8,2, 1,IRET,SATSTR)

      SRFDAT_8 = BMISS
      CALL UFBINT(IUNIT,SRFDAT_8,4, 1,IRET,SRFSTR)

      RETDAT_8 = BMISS
      IF(DSNAME.EQ.'RTOVS   ')  THEN
         CALL UFBINT(IUNIT,RETDAT_8,2,40,NLEV,RTVSTR)
      ELSE
         CALL UFBREP(IUNIT,RETDAT_8,2,41,NLEV,ATVSTR)
      END IF

C  NADIR PROXIMITY INDICATOR {IBUFTN(16)}
C  --------------------------------------

      IF(IBFMS(XIDENT_8(1)).EQ.0)  THEN
         NADIR = INT(ABS(FLOAT(NINT(XIDENT_8(1))) - 28.5)) / 3
         IF(NADIR.LT.9) NADIR = NADIR + 1
      ENDIF
      IF(NADIR.GT.0.AND.NADIR.LT.10)  THEN
         IBUFTN(16) = NADIR
      ELSE
         WRITE(6,2070) KOUNTR,NADIR
 2070 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' AN INVALID NADIR PROX. IND. (=',I5,') - SKIP IT')
         GO TO 1000
      ENDIF

C  BUFR SATELLITE IDENTIFIER (CODE TABLE 0-01-007) - IBUFTN(2)
C  -----------------------------------------------------------
C  LOCAL OR NESDIS SATELLITE IDENTIFIER -- IBUFTN(1)
C  -------------------------------------------------

      IF(IBFMS(XIDENT_8(2)).EQ.0)  THEN
         IBUFTN(2) = XIDENT_8(2)
         IF(NINT(XIDENT_8(2)).EQ.4)  THEN
            IBUFTN(1) =  8  ! METOP-A(2)
         ELSE IF(NINT(XIDENT_8(2)).EQ.223) THEN
            IBUFTN(1) =  9  ! NOAA-19
         ELSE IF(NINT(XIDENT_8(2)).EQ.3)  THEN
            IBUFTN(1) = 10  ! METOP-B(1)
         ELSE IF(NINT(XIDENT_8(2)).EQ.224)  THEN
            IBUFTN(1) = 11  ! NPP
         ELSE IF(NINT(XIDENT_8(2)).GT.199.AND.
     $           NINT(XIDENT_8(2)).LT.203)  THEN
            IBUFTN(1) = NINT(XIDENT_8(2)) - 194
                            ! NOAA-08 to 10
         ELSE IF(NINT(XIDENT_8(2)).GT.202.AND.
     $           NINT(XIDENT_8(2)).LT.210) THEN
                            ! NOAA-11 to 18
            IBUFTN(1) = NINT(XIDENT_8(2)) - 202
         ELSE
            WRITE(6,2071) KOUNTR,IBUFTN(2)
 2071 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' AN UNRECOGNIZED BUFR SATELLITE ID (=',I7,') - SKIP IT')
            GO TO 1000
         ENDIF
      ELSE
         WRITE(6,2072) KOUNTR
 2072 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING BUFR SATELLITE ID - SKIP IT')
         GO TO 1000
      ENDIF

C  LATITUDE {IBUFTN(5)}
C  --------------------

      IF(IBFMS(XIDENT_8(3)).EQ.0)  THEN
         IBUFTN(5)  = NINT(XIDENT_8(3) * 100.)
      ELSE
         WRITE(6,2073) KOUNTR
 2073 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING LATITUDE - SKIP IT')
         GO TO 1000
      ENDIF

C  LONGITUDE {IBUFTN(6)}
C  ---------------------

      IF(IBFMS(XIDENT_8(4)).EQ.0)  THEN
         IBUFTN(6)  = NINT(XIDENT_8(4) * 100.)
      ELSE
         WRITE(6,2074) KOUNTR
 2074 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING LONGITUDE - SKIP IT')
         GO TO 1000
      ENDIF

      AMAXIMUM_8 = MAX(XIDENT_8(5),XIDENT_8(6),XIDENT_8(7),XIDENT_8(8))
      IF(IBFMS(AMAXIMUM_8).EQ.0) THEN

C  DAY OF MONTH (* 256) + HOUR (UTC) {IBUFTN(3)}
C  ---------------------------------------------

         IBUFTN(3)  = (256 * NINT(XIDENT_8(5))) + NINT(XIDENT_8(6))

C  MINUTE (* 256) + SECOND (UTC) {IBUFTN(4)}
C  -----------------------------------------

         IBUFTN(4)  = (256 * NINT(XIDENT_8(7))) + NINT(XIDENT_8(8))
      ELSE
         WRITE(6,2075) KOUNTR
 2075 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' ONE OR MORE MISSING TIME UNITS - SKIP IT')
         GO TO 1000
      ENDIF

C  RETRIEVAL METHOD {IBUFTN(12)}
C  -----------------------------

      IF(IBFMS(SATDAT_8(1)).EQ.0)  THEN
         ISDPT = NINT(SATDAT_8(1))
         IOFF = (LWI * 8) - 6
         CALL GBYTES(ISDPT,IBIT,IOFF,1,1,2)
cppppp
cdak     print'(" ISDPT,IBIT,ICLR,ICDY:",4(I0,1X))',ISDPT,IBIT,ICLR,ICDY
cppppp
      ELSE
         WRITE(6,2076) KOUNTR
 2076 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING SATELLITE DATA PROCESSING TECHNIQUE - SKIP IT')
         GO TO 1000
      ENDIF

      IF(IBIT(1).EQ.1.AND.IBIT(2).EQ.0) THEN

C  --> Clear path

         MCL = 1
         ICCMVS = 1
      ELSE IF((IBIT(1).EQ.0.AND.IBIT(2).EQ.1).OR.
     $        (IBIT(1).EQ.0.AND.IBIT(2).EQ.0.AND.DSNAME.EQ.'ATOVS   '))
     $ THEN

C  --> Cloudy path

         MCL = 2
         IF(NINT(SATDAT_8(2)).EQ.1) THEN
            ICCMVS = 2
         ELSE
            ICCMVS = 3
         ENDIF
      ELSE

C  --> Unknown path

         WRITE(6,2078) KOUNTR,NINT(SATDAT_8(1)),IBIT
 2078 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' AN UNKNOWN SATELLITE DATA PROCESSING TECHNIQUE (=',I5,','/
     $ 22X,'WITH ICLR=',I1,' AND ICDY=',I1,') - SKIP IT')
         GO TO 1000
      ENDIF

      IBUFTN(12) = (256 * MCL) + (16 * MCL) + 1

C  FILTER FLAG {IBUFTN(20)}
C  ------------------------

      IF(IBFMS(XIDENT_8(11)).EQ.0)  THEN
C  ... for RTOVS and maybe ATOVS if NESDIS starts encoding filter flag
C       in "TOFF"
c  If date of input file is prior to 7/1/1998, then "TOFF" does not
c   indicate filter flag, set filter flag to "-99" (alerts calling
c   program to process only every 4'th RTOVS and every 11'th ATOVS
c   retrieval to simulate 250km sampling - needed for historical cdas
c   runs)
         IF(ITOFF.EQ.0)  THEN
            IBUFTN(20) = NINT(XIDENT_8(11))
         ELSE
            IBUFTN(20) = -99
         END IF
      ELSE IF(IBFMS(XIDENT_8(12)).EQ.0)  THEN
C  ... for ATOVS if NESDIS starts encoding filter flag in "OBQL"
         IBUFTN(20) = NINT(XIDENT_8(12))
      ELSE
         IF(DSNAME.EQ.'RTOVS   ')  THEN
            WRITE(6,3075) KOUNTR
 3075 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING FILTER FLAG - SKIP IT')
            GO TO 1000
         ELSE
C  Currently filter flag is missing for ATOVS - set to "-99" until
C   NESDIS fixes (alerts calling program to process only every 11'th
C   retrieval to simulate 250km sampling - needed for cdas runs)
            if(nfirst.eq.0)  then
               write(6,9082)
 9082 format(/'##W3XTOVSEDS WARNING: NESDIS HAS NOT STORED A FILTER ',
     $ 'FLAG SO SET OUTPUT FILTER FLAG TO -99 FOR ALL REPORTS'/)
               nfirst=1
            end if
            ibuftn(20) = -99
         END IF
      END IF

C  LAND/SEA INDICATOR (IF LAND ELEV, IF SEA 0) {IBUFTN(8)}
C  -------------------------------------------------------

      IF(IBFMS(SRFDAT_8(2)).EQ.0)  IBUFTN(8) = NINT(SRFDAT_8(2))
      IF(DSNAME.EQ.'RTOVS   ')  THEN
C  ... RTOVS defines "LSQF" incorrectly
         IF(NINT(SATDAT_8(2)).EQ.0) IBUFTN(8) = 0
      ELSE
C  ... ATOVS defines "LSQF" correctly
         IF(NINT(SATDAT_8(2)).EQ.1) IBUFTN(8) = 0
      END IF

C  SURFACE (SKIN) TEMPERATURE {IBUFTN(9)}
C  --------------------------------------

C Must set to 7777 (missing) - it is used by PREPDATA (subr. W3FA07)
C  only to the extent that if it is missing, then the surface
C  temperature is obtained from the lowest layer mean virtual temp.
c  only, rather than from the avg. of the lowest layer mean virt.
C  temperature and this surface (skin) temp. {IBUFTN(9)}.
C   - This may not be correct, but it is consistent with the TOVS
C     processing from before, where even though the skin temp.
C     in IBUFTN(9) was not missing, the 7'th bit (counting from right,
C     where rightmost bit is position 0) of the value in IBUFTN(11)
C     was always 0 (the largest value for IBUFTN(11) in TOVS was 64).
C
C  This test in W3FA07 is:
C
C      TSFC  = IBUFTN(9)/10.0
C                 ....
C                 ....
C      IF(.NOT.(BTEST(IBUFTN(11),7)).OR.IBUFTN(9).EQ.7777)
C    $ TSFC = TBAR(1) + (.0555 * (IP1(1) - PMID(1)))
C     TSFC = (TSFC + TBAR(1) + (.0555 * (IP1(1) - PMID(1))))/2
C
C  This allows us to ignore IBUFTN(11) here (set to 7777, which
C   actually yields a 0 in bit 7 anyway!!)

      IBUFTN(9) = 7777

      IF(NLEV.EQ.NUMLVL)  THEN

C  FILL IN THE LEVEL SOUNDING DATA - MUST HAVE 40 TEMP LEVELS TO ACCEPT
C  (Note: For ATOVS, Cloud-top press. is on level 1 - skip to next lvl)
C  --------------------------------------------------------------------

         LL = 0
         DO  L = ISTLVL,NLEV
            LL = LL + 1
            IF(IBFMS(RETDAT_8(1,L)).NE.0) THEN
               WRITE(6,2082) KOUNTR
 2082 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') ',
     $ 'CONTAINS 1 OR MORE MISSING TEMERATURES IN ITS SOUNDING - SKIP ',
     $ 'IT')
               GO TO 1000
            ENDIF
            TMPOPR_8(LL) = RETDAT_8(1,L)
cppppp
cdak           print'(" AT L = ",I0,"; RETDAT_8(2,L) = ",G0)',
cdak $          L,RETDAT_8(2,L)
cppppp
            TMP_8=RETDAT_8(2,L)*1000._8
            IF(LL.GT.25) WOPR_8(LL-25) = MIN(BMISS,TMP_8)
         ENDDO
         NLEV = 40
      ELSE
         WRITE(6,2081) KOUNTR,NLEV
 2081 FORMAT(/'##W3XTOVSEDS WARNING: DECODED RETR (#',I7,') DOES NOT ',
     $ 'CONTAIN 40 SNDG LVLS (PLUS 1 CLOUD-TOP LVL IF ATOVS) (HAS ',I3,
     $ ' LVLS)-SKIP IT')
         GO TO 1000
      ENDIF

      IF(IBFMS(SRFDAT_8(1)).EQ.0)  THEN
         PBOT = 0.01 * SRFDAT_8(1)
C --> NESDIS is scaling bottom pressure incorrectly, this accounts for
C      this and for a future fix on their part (fixed on 11/07/2001)
         IF(PBOT.LT.200.)  then
            IF(MFIRST.EQ.0)  THEN
               WRITE(6,9081)
 9081 FORMAT(/'##W3XTOVSEDS WARNING: NESDIS IS STORING BOTTOM PRESSURE',
     $ ' AS 0.1 PASCALS INSTEAD OF AS PASCALS, THIS SUBROUTINE WILL ',
     $ 'CORRECT'/24X,'FOR THIS UNTIL NESDIS FIXES THEIR ERROR'/)
               MFIRST=1
            END IF
            PBOT = 0.1 * SRFDAT_8(1)
         end if
         IF(DSNAME.EQ.'ATOVS   ')  THEN

C  For ATOVS (only), do a SANITY check on pressure (NESDIS can have
C   some strange values)

            DVAL = PBOT - PR(REAL(IBUFTN(8)))
            IF(DVAL.LE.-75..OR.DVAL.GE.50.)  THEN
               WRITE(6,2087) KOUNTR,PBOT,IBUFTN(8)
 2087 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A BAD BOTTOM PRES LVL (PBOT=',F6.1,' MB, ELEV=',I4,' M) - ',
     $ 'SKIP IT')
               GO TO 1000
            ENDIF
         ENDIF
         DO  L = 40,1,-1
            IF(NINT(PBOT*100.).GT.NINT(TOVLEV(L)*100.)) THEN
               LST = L
               GO TO 1850
            ENDIF
         ENDDO
         WRITE(6,3079) KOUNTR,PBOT
 3079 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A STRANGE BOTTOM PRESSURE (=',F8.2,' MB)  - SKIP IT')
         GO TO 1000
 1850    CONTINUE
         PLST = TOVLEV(LST)
      ELSE
         WRITE(6,2079) KOUNTR
 2079 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') HAS',
     $ ' A MISSING BOTTOM PRESSURE - SKIP IT')
         GO TO 1000
      ENDIF

C For now set PTRP (trop pressure) to 0.0 as we can't determine this
C  (this means we may not want to throw out superadiabatic retr. as
C   determined by subr. XTOVSEDS02 since the entire column is checked,
C   when the logic expects to only check sfc to trop for supers)

      PTRP = 0.0
cppppp
cdak  print'(" Going into XTOVSEDS02 -- IBUFTN = .....")'
cdak  print, IBUFTN
cdak  print'(" TMPOPR_8 = ",G0)', TMPOPR_8
cdak  print'(" WOPR_8 = ",G0)', WOPR_8
cdak  print'(" PLST = ",G0)', PLST
cdak  print'(" ICCMVS = ",I0)', ICCMVS
cdak  print'(" PTRP = ",G0)', PTRP
cppppp
      CALL XTOVSEDS02(TMPOPR_8,WOPR_8,PLST,ICCMVS,PTRP,TLAYER,GEOOPR,
     $ PLAYER,ISUPER,BMISS)

      IF(ISUPER.EQ.1)  THEN
         WRITE(6,2080) KOUNTR
 2080 FORMAT(/'##W3XTOVSEDS WARNING: A DECODED RETRIEVAL (#',I7,') IS ',
     $ 'SUPERADIABATIC ACCORDING TO SUBR. XTOVSEDS02- SKIP IT')
         GO TO 1000
      ENDIF

      DO  L = 1,15
        LREV = 16 - L
        IF(TLAYER(L).LT.999.99) THEN
          IBUFTN(4*L+19) = NINT(PLAYER(LREV+1) * 10.)
          IBUFTN(4*L+20) = NINT(PLAYER(LREV) * 10.)
          IBUFTN(4*L+21) = NINT((TLAYER(L) * 10.) + 0.0000001)
        ENDIF
      ENDDO

C  ORBIT NUMBER
C  ------------

      IF(IBFMS(XIDENT_8(9)).EQ.0)  ISATOB(1) = NINT(XIDENT_8(9))

C  DAY-NIGHT INDICATOR
C  -------------------

      IF(IBFMS(XIDENT_8(10)).EQ.0)  ISATOB(2) = NINT(XIDENT_8(10))

C  TERRAIN INDICATOR
C  -----------------

      IF(IBFMS(SRFDAT_8(3)).EQ.0)  THEN
C  ... for RTOVS
         ISATOB(3) = NINT(SRFDAT_8(3))
      ELSE  IF(IBFMS(SRFDAT_8(4)).EQ.0)  THEN
C  ... for ATOVS
         ISATOB(3) = NINT(SRFDAT_8(4))
      END IF

      IERR = 0

      RETURN

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    XTOVSEDS02
C   PRGMMR: KEYSER           ORG: NP22        DATE: 2013-02-14
C
C ABSTRACT: USES RTOVS OR ATOVS 18 MANDATORY-LEVEL GEOPOTENTIAL
C   HEIGHTS AND 40-LEVEL TEMPERATURES TO ARRIVE AT 15-LAYER AVERAGED
C   VIRTUAL TEMPERATURES. IF THE LOW LEVELS ARE MISSING, THEN FILLER
C   (999.99) INSERTED IN PLACE OF THE TEMPERATURES.
C
C PROGRAM HISTORY LOG:
C 1985-06-07  E. BURDSALL (NESDIS)
C 1990-04-30  T. GARDNER (NESDIS/STX)
C 1994-03-22  BERT B. KATZ   ADPATED FOR USE IN CDAS/RE-ANALYSIS
C 2012-11-30  J. WOOLLEN  INITIAL PORT TO WCOSS; RESET BMISS TO A VALUE
C      (10E08) WHICH WILL NOT CAUSE INTEGER OVERFLOW WHICH CAN BE
C      UNPREDICTABLE (PRIOR BMISS VALUE WAS 10E10)
C 2013-02-14  D. A. KEYSER   FINAL CHANGES TO RUN ON WCOSS; BMISS IS
C      NOW PASSED IN FROM CALLING PROGRAM PROGRAM (ADDED AS AN INPUT
C      ARGUMENT HERE)
C
C USAGE:    CALL XTOVSEDS02(TMPOPR_8,WOPR_8,PSFC,ICCMVS,
C                           PTRP,TKLNMC,GPHGT,PNMC,ISUPER,BMISS)
C   INPUT ARGUMENT LIST:
C     TMPOPR_8 - REAL*8 RTOVS/ATOVS 40-LEVEL RETRIEVED TEMPERATURES
C                (DEG. K).
C     WOPR_8   - REAL*8 RTOVS/ATOVS 15-LEVEL RETRIEVED MIXING RATIOS
C                (G / KG).
C     PSFC     - RTOVS/ATOVS MODEL SURFACE LEVEL (MB).
C     ICCMVS   - NESDIS CHANNEL COMBINATION FLAG FOR MVS RETRIEVALS.
C     PTRP     - TROPOPAUSE PRESSURE (MB).
C     BMISS    - REAL*8 BUFRLIB VALUE FOR MISSING
C
C   OUTPUT ARGUMENT LIST:
C     TKLNMC   - RTOVS/ATOVS 15-LAYER RETRIEVED VIRTUAL TEMPS (DEG. K).
C     GPHGT    - RTOVS/ATOVS 18 MANDATORY-LEVEL GEOPOTENTIAL HGHTS (M).
C     PNMC     - PRESSURES AT LAYER INTERFACES (MB).
C     ISUPER   - NESDIS SUPERADIABATIC FLAG.
C
C REMARKS: CALLED BY SUBROUTINE W3XTOVSEDS.
C
C   KEY LOCAL PARAMETERS-
C      VARIABLE                TYPE  FUNCTION
C      --------                ----  --------
C      NPMAN                   I*4   NUMBER OF MANDATORY LEVELS (18)
C      NPRET                   I*4   NUMBER OF RTOVS/ATOVS TEMPERATURE
C                                    RETRIEVAL LEVELS (40)
C      NPMIX                   I*4   NUMBER OF RTOVS/ATOVS MOISTURE
C                                    RETRIEVAL LEVELS (15)
C      C0 - C14                R*4   CONSTANTS USED TO CALCULATE
C                                    LAYER-MEAN TEMPERATURES
C      THK                     R*4   GEOPOTENTIAL THICKNESS (M) BETWEEN
C                                    SELECTED MANDATORY PRESSURE LEVELS
C      PLOC(16)                R*4   NCEP PRESSURE LEVELS
C      NPNMC                   I*4   NUMBER OF NCEP PRESSURE LEVELS (16)
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE XTOVSEDS02(TMPOPR_8,WOPR_8,PSFC,ICCMVS,PTRP,TKLNMC,
     $ GPHGT,PNMC,ISUPER,BMISS)

      REAL PLOC(16),GPHGT(18),PMAN(18),PRET(40)
      REAL DLP(39),TKLNMC(15),PNMC(16),TVIRT(40),ZHGT(40)

      REAL(8)  BMISS,WOPR_8(15),TMPOPR_8(40)

      DATA C0/0.257286585/,C1/0.5/,C2/0.242713415/,C3/0.20751875/,
     $ C4/0.5/,C5/0.29248125/,C6/0.3782354/,C7/0.5/,C8/0.1217646/,
     $ C9/0.1217646/,C10/0.278746475/,C11/0.3782354/,C12/0.221253525/,
     $ C13/0.2435292/,C14/0.034164751/

      LOGICAL L1,L3,L4,L5,L6

      DATA LNMC1/4/,LNMC2/5/,LNMC3/6/,LNMC4/7/,LNMC5/8/,LNMC6/9/,
     $ LNMC7/11/,LNMC8/12/,LNMC9/13/,LNMC10/14/
      DATA NPRET/40/,NPMAN/18/,NPNMC/16/,NLT/15/,FILL/999.99/,NPMIX/15/
      DATA PRET/0.1,0.2,0.5,1.0,1.5,2.0,3.0,4.0,5.0,7.0,10.0,15.0,20.0,
     $ 25.0,30.0,50.0,60.0,70.0,85.0,100.0,115.0,135.0,150.0,200.0,
     $ 250.0,300.0,350.0,400.0,430.0,475.0,500.0,570.0,620.0,670.0,
     $ 700.0,780.0,850.0,920.0,950.0,1000.0/
      DATA DLP/0.69315,0.91629,0.69315,0.40546,0.28768,0.40546,
     $ 0.28768,0.22314,0.33647,0.35667,0.40546,0.28768,0.22314,0.18232,
     $ 0.51083,0.18232,0.15415,0.19416,0.16252,0.13976,0.16034,0.10536,
     $ 0.28768,0.22314,0.18232,0.15415,0.13353,0.07232,0.09953,0.05129,
     $ 0.13103,0.08408,0.07756,0.04380,0.10821,0.08594,0.07914,0.03209,
     $ 0.05129/
      DATA PMAN/1.,3.,7.,10.,20.,30.,50.,70.,100.,150.,200.,250.,300.,
     $ 400.,500.,700.,850.,1000./
      DATA PLOC/0.4,1.0,2.0,5.0,10.0,30.0,50.0,70.0,100.0,200.0,
     $ 300.0,400.0,500.0,700.0,850.0,1000.0/

      DATA CONS/14.6435/
      DATA TSUPLM/10.0/

      INTEGER CCHLKP(7,2),CCLLKP(7),CCWLKP(7)
      DATA CCHLKP/0,2,2,2,6,6,5,0,1,1,1,3,3,4/
      DATA CCLLKP/0,1,2,5,4,6,3/
      DATA CCWLKP/0,1,0,0,0,0,2/

      INTEGER IDXSUP(18)
      DATA IDXSUP/4,7,10,11,13,15,16,18,20,23,24,25,26,28,31,35,37,40/

      DATA NTPRET/0/

      PNMC = PLOC

      L1=ANINT(PSFC).GE.ANINT(PRET(32))

      DO  I = 1,40
         IF(ANINT(PSFC).EQ.ANINT(PRET(I))) THEN
           LST = I
           EXIT
         ENDIF
      ENDDO

C  INITILIZE DO-LOOP LIMITS FOR COMPUTING GEOPOTENTIAL HEIGHTS.

      JSTRT=2
      JSTOP=LST

C  INITIALIZE VIRTUAL TEMPERATURE ARRAY.

      TVIRT = TMPOPR_8

C  ADJUST GEOPOTENTIAL HEIGHT DO-LOOP LIMITS

      ZHGT = 0.0
 
      IF(.NOT.L1) THEN
         JSTOP=NPRET-NPMIX
         GO TO 350
      ENDIF

C  COMPUTE VIRTUAL TEMPERATURES (K).

      LSTART=NPRET-NPMIX+1
      DO  L = LSTART,LST
cppppp
cdak  print'(" WOPR_8(L-NPRET+NPMIX)  = ",G0)', WOPR_8(L-NPRET+NPMIX)
cdak  print'(" TVIRT(L) = ",G0)', tvirt(l)
cppppp
         IF(WOPR_8(L-NPRET+NPMIX).LT.BMISS) TVIRT(L)=
     $    TMPOPR_8(L)*(1.0+.61*WOPR_8(L-NPRET+NPMIX)/
     $             (1000.0+WOPR_8(L-NPRET+NPMIX)))
cppppp
cdak  print'(" TVIRT(L) = ",G0)', tvirt(l)
cppppp
      ENDDO

  350 CONTINUE

C  COMPUTE GEOPOTENTIAL HEIGHTS (METERS) AT RTOVS/ATOVS LEVELS.

      DO  J = JSTRT,JSTOP
         I=JSTOP+1-J
         ZHGT(I)=ZHGT(I+1)+(TVIRT(I)+TVIRT(I+1))*DLP(I)*CONS
      ENDDO

      GPHGT(1:NPMAN) = ZHGT(IDXSUP(1:NPMAN))

      ISUPER=0
      L5=ANINT(PSFC).LT.ANINT(PRET(32))

C  DETERMINE IF NECESSARY TO CHECK FOR SUPERADIABATIC LAPSE RATES.

      IF (L5) GO TO 450

C  DETERMINE FIRST RTOVS/ATOVS PRESSURE LEVEL HIGHER THAN OR AT THE
C    TROPOPAUSE PRESSURE.

      LTROP=2
      DO  I = 2,LST
         J=NPRET+1-I
         IF (PRET(J).GT.PTRP) CYCLE
         LTROP=J
         EXIT
      ENDDO
cppppp
cdak  print'(" After trop loop, LTROP = ",I0," (should be 2)")', LTROP
cppppp

C  DETERMINE FIRST MANDATORY PRESSURE LEVEL AT OR BELOW THE RTOVS/ATOVS
C   LEVEL DETERMINED IN THE PREVIOUS STEP.

      DO  I = 1,NPMAN
         IF (PMAN(I).LT.PRET(LTROP)) CYCLE
         LTROP=I
         EXIT
      ENDDO

cppppp
cdak  print'(" After pman loop, LTROP = ",I0," (should be 1)")', LTROP
cppppp

C DETERMINE FIRST MANDATORY PRESSURE LEVEL AT OR HIGHER THAN THE SURFACE
C  PRESSURE LEVEL.

      DO  I = 1,NPMAN
         J=NPMAN+1-I
         IF (ANINT(PMAN(J)).GT.ANINT(PSFC)) CYCLE
         LSURF=J
         EXIT
      ENDDO

C  CHECK FOR SUPERADIABATIC LAPSE RATES BETWEEN MANDATORY PRESSURE
C   LEVELS 'LTROP' AND 'LSURF'.

      LSTOP=LSURF-1
      DO  J = LTROP,LSTOP

C  IF PRESSURE LEVEL AT OR ABOVE 100MB, CHANGE UNITS OF GEOPOTENTIAL
C   HEIGHTS FROM DECAMETERS TO METERS.

         GPHIGH=GPHGT(J)
         GPLOW=GPHGT(J+1)
         DZ=ABS(GPLOW-GPHIGH)
         IF (DZ.LT.0.000001) CYCLE
         K=J+1
         TMPVAL=(TMPOPR_8(IDXSUP(K))-TMPOPR_8(IDXSUP(J)))*(1000.0/DZ)
         IF (TMPVAL.LE.TSUPLM) CYCLE
         ISUPER=1
         GO TO 450
      ENDDO

C  CHECK FOR SUPERADIABATIC LAPSE RATE BETWEEN LEVELS 'LSURF' AND 'LST',
C   IF NECESSARY.

      IF (ANINT(PMAN(LSURF)).GE.ANINT(PSFC)) GO TO 450
      DO  I = 21,LST
         IF (PRET(I).NE.PMAN(LSURF)) CYCLE
         LEVEL=I
         EXIT
  445    CONTINUE
      ENDDO
      DZ=ABS(ZHGT(LEVEL)-ZHGT(LST))
      IF (DZ.LT.0.000001) GO TO 450
      TMPVAL=(TMPOPR_8(LST)-TMPOPR_8(LEVEL))*(1000.0/DZ)
      IF (TMPVAL.LE.TSUPLM) GO TO 450
      ISUPER=1

  450 CONTINUE
      IF(ISUPER.EQ.1) RETURN

      TKLNMC = FILL

      ICCTHI = CCHLKP(ICCMVS+1,2)
      ICCTLO = CCLLKP(ICCMVS+1)
      ICCW = CCWLKP(ICCMVS+1)
      IF(ICCTHI.LT.1 .OR. ICCTHI.GT.6) ICCTHI = 6
      IF(ICCTLO.LT.0 .OR. ICCTLO.GT.6) ICCTLO = 0
      IF(ICCW.LT.0 .OR. ICCW.GT.2) ICCW = 0
      L1=ISUPER.EQ.1
      L3=ICCTLO.EQ.0
      L4=ICCW.EQ.0.AND.ICCTLO.NE.0.AND.LST.LT.32
      L5=ICCTHI.NE.6
      L6=ICCTHI.EQ.6

C  CHECK FOR AVAILABILITY OF GEOPOTENTIAL HEIGHTS FROM THE SURFACE TO
C   100 MB. IF FOLLOWING TESTS ARE SATISFIED GEOPOTENTIAL HEIGHTS ARE
C   NOT AVAILABLE.

      IF (L1) GO TO 510

C  CHECK IF TROPOSPHERIC TEMPERATURES SOUTH OF 10N ARE NOT TO BE
C   COMPUTED

      IF (L3) GO TO 510

C  CHECK IF SURFACE DATA IS RELIABLE. IF TEST NOT  SATISFIED,
C   GEOPOTENTIAL HEIGHTS ARE AVAILABLE FROM THE SURFACE TO 0.4 MB.

      IF (.NOT.L4) GO TO 530

C  DATA ONLY AVAILABLE TO COMPUTE LAYER-MEAN TEMPERATURES BETWEEN
C   SELECTED NCEP PRESSURE LEVELS FROM 200 TO 0.4 MB. SET POINTER(NUMT)
C   DENOTING NUMBER OF LAYER-MEAN TEMPERATURES  TO BE CALCULATED.

      NUMT=LNMC6
      NTPRET=NTPRET+1

C  SET POINTER(NT) SPECIFYING ATMOSPHERIC LAYER AT WHICH TEMPERATURE
C   CALCULATIONS BEGIN(100-200MB LAYER).

      NT=LNMC4

C  CHECK FOR AVAILABILITY OF RETRIEVAL DATA ABOVE 10 MB.

C  DATA AVAILABLE TO COMPUTE LAYER-MEAN TEMPERATURES ONLY BETWEEN
C   SELECTED NCEP PRESSURE LEVELS FROM 200 TO 10 MB. RESET POINTER(NUMT)
C   FOR NUMBER OF MEAN-LAYER TEMPERATURES TO BE CALCULATED.

      IF (.NOT.L5) NUMT=LNMC2
      GO TO 570

  510 CONTINUE

C  RETRIEVAL DATA IS ONLY AVAILABLE TO COMPUTE LAYER-MEAN TEMPERATURES
C   BETWEEN SELECTED NCEP PRESSURE LEVELS FROM 100 TO 0.4 MB.  SET
C   POINTER(NUMT) FOR NUMBER OF LAYER-MEAN TEMPERATURES TO BE CALCULATED

      NUMT=LNMC5
      NTPRET=NTPRET+1

C  SET POINTER(NT) SPECIFYING ATMOSPHERIC LAYER AT WHICH TEMPERATURE
C   CALCULATIONS BEGIN(70-100 MB LAYER).

      NT=LNMC5

C  CHECK FOR AVAILABILITY OF RETRIEVAL DATA ABOVE 10 MB.

C  DATA AVAILABLE TO COMPUTE LAYER-MEAN TEMPERATURES ONLY BETWEEN
C   SELECTED NCEP PRESSURE LEVELS FROM 100 TO 10 MB. RESET POINTER(NUMT)
C   FOR NUMBER OF TEMPERATURES TO BE CALCULATED.

      IF (.NOT.L5) NUMT=LNMC1

C  INITIALIZE POINTER(M): SPECIFIES THE STARTING MANDATORY PRESSURE
C   LEVEL AT WHICH GEOPOTENTIAL HEIGHT DATA IS USED FOR CALCULATION OF
C   LAYER-MEAN TEMPERATURES.

      M=LNMC6
      GO TO 580

  530 CONTINUE

C  DATA AVAILABLE TO COMPUTE LAYER-MEAN TEMPERATURES BETWEEN SELECTED
C   NCEP PRESSURE LEVELS FROM THE SURFACE TO 0.4 MB. SET POINTER(NUMT)
C   FOR NUMBER OF LAYER-MEAN TEMPERATURES TO BE CALCULATED.

      NUMT=NPNMC-1

C  SET POINTER(NT) SPECIFYING ATMOSPHERIC LAYER AT WHICH TEMPERATURE
C   CALCULATIONS ARE TO BEGIN(1000-850 MB LAYER).

      NT=1

C  CHECK FOR AVAILABILITY OF RETRIEVAL DATA ABOVE 10 MB.

      IF (.NOT.L5) THEN

C  DATA AVAILABLE TO COMPUTE LAYER-MEAN TEMPERATURES BETWEEN SELECTED
C   NCEP PRESSURE LEVELS FROM THE SURFACE TO 10 MB.  RESET POINTER(NUMT)
C   FOR NUMBER OF TEMPERATURES TO BE CALCULATED.

         NUMT=LNMC7
      ENDIF

C  INITIALIZE POINTER(M): SPECIFIES STARTING MANDATORY PRESSURE LEVEL
C   AT WHICH GEOPOTENTIAL HEIGHT DATA IS TO BE USED FOR CALCULATION OF
C   LAYER-MEAN TEMPERATURES.

      M=NPMAN

C  CHECK TO DETERMINE IF SURFACE PRESSURE IS LESS THAN 1000 MB.

      IF(ANINT(PNMC(NPNMC)).EQ.ANINT(PSFC)) GO TO 580

C  ADJUST NUMBER OF NCEP PRESSURE LEVELS WHEN SURFACE PRESSURE IS LESS
C   THAN 1000 MB.

      DO  I = 1,NPNMC-1

C  REVERSE ORDERING SEQUENCE OF NCEP PRESSURE LEVELS (START WITH LEVEL
C   15: E.G. PNMC(15)=850 MB).

         J=NPNMC-I

C  RESET POINTER(NT) SPECIFYING FIRST LAYER WHERE LAYER-MEAN TEMPERATURE
C   CALCULATIONS ARE TO BEGIN.

         NT=I

C  CHECK TO DETERMINE NEW NCEP SURFACE PRESSURE.

         IF(ANINT(PSFC).GT.ANINT(PNMC(J))) EXIT
      ENDDO

C  DEFINE NEW NCEP SURFACE PRESSURE.

      PNMC(J+1)=PSFC

C  RESET POINTER(NUMT) FOR NUMBER OF LAYER-MEAN TEMPERATURES TO BE
C   CALCULATED.

      NUMT=J
      IF (L6) NUMT=NUMT-LNMC1

C  RESET POINTER(M) FOR MANDATORY PRESSURE LEVEL.

      M=J+3
      GO TO 580

  570 CONTINUE

C  RESET POINTER(M) FOR MANDATORY PRESSURE LEVELS( FOR CASES WHEN DATA
C   ONLY AVAILABLE BETWEEN 200-0.4 OR 200-10 MB.

      M=LNMC7

  580 CONTINUE

C  DEFINE LOWER AND UPPER DO-LOOP LIMITS FOR ERROR ESTIMATE CALCULATIONS
C   (USED IN SUBROUTINE CALERR).

      NTL=NT
      NTU=NTL+NUMT-1

C  CALCULATE LAYER-MEAN TEMPERATURES
C  ---------------------------------

      DO I = NTL,NTU

C  REVERSE ORDERING SEQUENCE OF NCEP PRESSURE LEVELS.

         J=NLT-I+1

C  CHECK FOR SPECIAL CASES WHEN GEOPOTENTIAL THICKNESSES MUST BE SUMMED
C   TO COMPUTE LAYER-MEAN TEMPERATURES.

         IF(I.EQ.LNMC3) GO TO 590
         IF(I.EQ.LNMC4) GO TO 600
         IF(I.EQ.LNMC7) GO TO 610

C  CHECK TO ENSURE IF DATA AVAILABLE ABOVE 10 MB. IF TEST SATISFIED
C   CALCULATION OF LAYER-MEAN TEMPERATURES NOT REQUIRED USING RETRIEVAL
C   TEMPERATURE DATA.

         IF(L6) GO TO 690
         GO TO 640

  590    CONTINUE

C  DEFINE LOWER(ML) AND UPPER(MU) DO-LOOP LIMITS FOR SUMMATION OF
C   THICKNESSES BETWEEN 300-200 MB LEVELS.

         ML=11
         MU=12
         GO TO 620

  600    CONTINUE

C  DEFINE ML AND MU FOR SUMMATION OF THICKNESSES BETWEEN 200-100 MB LVLS

         ML=9
         MU=10
         GO TO 620

  610    CONTINUE

C  DEFINE ML AND MU FOR SUMMATION OF THICKNESSES BETWEEN 30-10 MB LEVELS

         ML=4
         MU=5

  620    CONTINUE

C  INITIALIZE SUMMATION OF THICKNESSES.

         SUMTHK=0.

C  SUM THICKNESSES.

         DO  L = ML,MU
            THK=GPHGT(L)-GPHGT(L+1)
            SUMTHK=SUMTHK+THK
         ENDDO
         THK=SUMTHK

C  RESET POINTER(M) TO MANDATORY PRESSURE LEVEL FOR NEXT THICKNESS
C   CALCULATION.

         M=M-1
         GO TO 700

  640    CONTINUE

C  CHECK FOR SPECIAL CASES WHEN RTOVS/ATOVS RETRIEVAL TEMPERATURES ARE
C   REQUIRED TO COMPUTE LAYER-MEAN TEMPERATURES.

         IF(I.EQ.LNMC8) GO TO 650
         IF(I.EQ.LNMC9) GO TO 660
         IF(I.EQ.LNMC10) GO TO 670
         JJ=NPNMC-1
         IF(I.EQ.JJ) GO TO 680
         GO TO 690

  650    CONTINUE

C  COMPUTE LAYER-MEAN TEMPERATURE BETWEEN 10-5 MB LEVELS.

         TKLNMC(I)=C0*TMPOPR_8(11)+C1*TMPOPR_8(10)+C2*TMPOPR_8(9)
         GO TO 710

  660    CONTINUE

C  COMPUTE LAYER-MEAN TEMPERATURE BETWEEN 5-2 MB LEVELS.

         TKLNMC(I)=C9*TMPOPR_8(9)+C10*TMPOPR_8(8)+C11*TMPOPR_8(7)+
     $     C12*TMPOPR_8(6)
         GO TO 710

  670    CONTINUE

C  COMPUTE LAYER-MEAN TEMPERATURE BETWEEN 2-1 MB LEVELS.

         TKLNMC(I)=C3*TMPOPR_8(6)+C4*TMPOPR_8(5)+C5*TMPOPR_8(4)
         GO TO 710

  680    CONTINUE

C  INTERPOLATE RTOVS/ATOVS RETRIEVAL TEMPERATURE TO 0.4 MB LEVEL.

         TEMP=TMPOPR_8(3)+C13*(TMPOPR_8(2)-TMPOPR_8(3))

C  CALCULATE LAYER-MEAN TEMPERATURE BETWEEN 1-0.4 MB LEVEL.

         TKLNMC(I)=C6*TMPOPR_8(4)+C7*TMPOPR_8(3)+C8*TEMP
         GO TO 710

  690    CONTINUE

C  COMPUTE GEOPOTENTIAL THICKNESSES.

         THK=GPHGT(M-1)-GPHGT(M)

  700    CONTINUE

C  COMPUTE LAYER-MEAN TEMPERATURE USING HYPSOMETRIC EQUATION.

         TKLNMC(I)=-C14*THK*(1./ALOG(PNMC(J)/PNMC(J+1)))

  710    CONTINUE

C  RESET POINTER(M) TO MANDATORY PRESSURE LEVEL FOR NEXT THICKNESS
C   CALCULATION.

         M=M-1
      ENDDO

      RETURN

      END

!$$$  subprogram documentation block
!                .      .    .                                       .
! subprogram:    grdcrd
!   prgmmr: parrish          org: np22                date: 1990-10-11
!
! abstract: get grid coordinates from monotonically increasing or
!           decreasing points
!
! program history log:
!   1990-10-11  parrish
!   1998-04-07  weiyu yang
!   2004-05-17  kleist, documentation
!   2004-05-28  kleist, combine increasing/decreasing routines & fctns
!   2005-05-24  pondeca, add the special case nx=1
!
!   input argument list:
!     d      - input points
!     nd     - number of input points
!     x      - grid values
!     nx     - number of reference grid points
!     flg    - marks order of values in x 
!              (1=increasing, -1=decreasing)
!
!   output argument list:
!     d        - points converted to grid units
!
! attributes:
!   language: f90
!   machine:  ibm RS/6000 SP
!
!$$$
      subroutine grdcrd(d,nd,x,nx,flg)
      implicit none
      integer id,ix,isrchf,nd,nx,flg
      real d(nd),x(nx)

      if(nx>1) then ! "normal" case in which nx>1
         do id=1,nd
         ix=isrchf(nx-1,x,d(id),flg)-1
         if(ix<=0)then
            d(id)=1.0
         elseif(ix>=nx)then
            d(id)=nx
         else
            d(id)=float(ix)+(d(id)-x(ix))/(x(ix+1)-x(ix))
         endif
         enddo
      elseif (nx==1) then ! special case of nx=1
         do id=1,nd
         d(id) = 1
         enddo
      endif

      return
      end ! subroutine grdcrd
!$$$  subprogram documentation block
!                .      .    .                                       .
! subprogram:    isrchf
!   prgmmr: parrish          org: np22                date: 1990-10-11
!
! abstract: get grid coordinates from monotonically increasing or
!           decreasing points
!
! program history log:
!   2005-03-07  treadon - add doc block
!
!   input argument list:
!     nx1    - number of input points
!     x      - grid values
!     y      - target value
!     flg    - marks order of values in x
!              (1=increasing, -1=decreasing)
!
!   output argument list:
!     isrchf  - array index of input grid value near target value
!
! attributes:
!   language: f90
!   machine:  ibm RS/6000 SP
!
!$$$
      function isrchf(nx1,x,y,flg)
      implicit none
      integer  isrchf,nx1,flg,k
      real     x(nx1),y

      isrchf=0

      if(flg.eq.1) then
         do k=1,nx1
         if(y<=x(k)) then
            isrchf=k
            go to 100
         end if
         end do
      else
         do k=1,nx1
         if(y>=x(k)) then
            isrchf=k
            go to 100
         end if
         end do
      end if

      isrchf=nx1+1

100   continue
      return
      end

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      SUBROUTINE GBLEVN10nems(IUNITF,IDATEP,IM,JM,kbak) 
                                                    
      USE GBLEVN_MODULE
      use nemsio_module, only: nemsio_getheadvar, nemsio_gfile, 
     .                         nemsio_init, nemsio_open, 
     .                         nemsio_getfilehead,nemsio_close,
     .                         NEMSIO_READRECVw34             
      USE SIGIO_MODULE   
      USE SIGIO_R_MODULE


      IMPLICIT NONE
      INTEGER IUNITF, IDATEP, IM, JM, kbak
      REAL, PARAMETER :: PI180 = .0174532
      REAL, PARAMETER :: ROG   = 29.261
      REAL, PARAMETER :: tzero = 273.15
      REAL :: ZBLO,TMID,PWGT
      REAL :: p,q,t,virt,esph

      INTEGER*4 IDRTNEMS
      INTEGER*4 IDVC,IDSL,SFCPRESS_ID,THERMODYN_ID
      INTEGER*4 NRET,NRET1,NRETS,IMJM,KM4,IDVM,NTRAC
      INTEGER*4 JCAP,I,J,K,KK,L,IRET
      INTEGER*4 IDATE(7),NFDAY,NFHOUR,NFMINUTE,NFSECONDN,NFSECONDD
      integer nk,nlev

      CHARACTER*6  COORD(3)
      CHARACTER*20 CFILE

      DATA COORD /'SIGMA ','HYBRID','GENHYB'/

      REAL, ALLOCATABLE   :: CPI(:)
      REAL, ALLOCATABLE   :: DPRS(:,:),AK5(:),BK5(:)
      REAL, ALLOCATABLE   :: TMP(:)
      real ak5_in,bk5_in

      TYPE(NEMSIO_GFILE)  :: GFILE

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      IMAX  = IM
      JMAX  = JM

C  GET VALID-TIME DATE OF SIGMA OR HYBRID FILE(S), ALSO READ HEADERS
C  -----------------------------------------------------------------
!
      CALL NEMSIO_INIT(NRET)     !HL

      WRITE(CFILE,'("fort.",I2.2)') IUNITF

      print *,' cfile=',cfile

      CALL NEMSIO_OPEN(GFILE,trim(CFILE),'read',iret=nret)
      print *,' cfile=',cfile,'nemsio open,iret=',nret
      if(nret/=0) call bort('NEMSIO_OPEN')

      IDRTNEMS=IDRT

      CALL NEMSIO_GETFILEHEAD(GFILE,
     .  nfday=nfday,
     .  nfhour=nfhour,
     .  nfminute=nfminute,
     .  IDATE=idate,
     .  JCAP=JCAP,
     .  DIMX=IMAX,
     .  DIMY=jmax,
     .  DIMZ=KMAX, 
     .  IDVC=IDVC,
     .  IDSL=IDSL,
     .  IDVM=IDVM,        
     .  NTRAC=NTRAC,
     .  IDRT=IDRTNEMS,
     .  IRET=NRET)

      IF(NRET.NE.0) call bort('NEMSIO_GETFILEHEAD1')

      IMJM=IMAX*JMAX
      SFCPRESS_ID  = MOD(IDVM,10)
      THERMODYN_ID = MOD(IDVM/10,10)

      print *,idate 
      print *,nfday,nfhour,nfminute
      print *,imjm,SFCPRESS_ID,THERMODYN_ID
      print *,jcap,imax,jmax,kmax,idvc,idsl,idvm,ntrac,idrtnems,idrt

      ALLOCATE(CPI(NTRAC+1))
      CALL NEMSIO_GETHEADVAR(GFILE,'CPI',CPI,iret=NRET)
!!    IF(NRET.NE.0) call bort('cpi')
      if (nret/=0) then
         write(6,*)'***WARNING***  cpi not present'
      endif
      print*,cpi

      IF(THERMODYN_ID==3 .AND. IDVC==3) then
         call bort('gblenv10:id=3:thermodyn=3')
      endif

C  VALID DATES MUST MATCH
C  ----------------------

C     IF(IDATEP.NE.IDATGS_COR)  GO TO 901

C  EXTRACT HEADER INFO
C  -------------------

      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX

      print*
      PRINT 2, nfhour,JCAP,KMAX,ntrac,DLAT,DLON,COORD(IDVC)
    2 FORMAT(/' --> GBLEVENTS: GLOBAL MODEL SPECS: F',i3.3,' T',I5,' ',I3,
     .' LEVELS ',I3,' SCALARS -------> ',F5.2,' X ',F5.2,' VERT. ',
     .'COORD: ',A)
      print*

!***********************************************************************
!**********  read nemsio file
!***********************************************************************

      CALL ALLOBAKs ! aloocates the nbak background arrays

      allocate (ak5(kmax+1),bk5(kmax+1))
      allocate (dprs(imjm,kmax))
      allocate (tmp(imjm))

      CALL NEMSIO_GETHEADVAR(gfile,'AK5',ak5,iret=iret)
      CALL NEMSIO_GETHEADVAR(gfile,'BK5',bk5,iret=iret)
!!      if(iret/=0) call bort('ak5 bk5')
      if (iret/=0) then
         write(6,*)'***WARNING*** unable to extract ak5,bk5 from nemsio'
         open(17,form='formatted')
         read(17,*) nk,nlev
         write(6,*)'nk=',nk,' nlev=',nlev
         do k=1,kmax+1
            read(17,*) ak5_in,bk5_in
            kk = (kmax+1)-(k-1)
            ak5(kk) = ak5_in * 0.001
            bk5(kk) = bk5_in
            write(6,*) kk,ak5(kk),bk5(kk)
         end do
         close(17)
      endif


      CALL NEMSIO_READRECVw34(GFILE,'hgt','sfc',1,tmp,iret=nret)
      CALL GBLEVN11(IMAX,JMAX,tmp)                 
      print *,'zsfc,',maxval(tmp),minval(tmp),nret
      iarzs(:,:,kbak)=reshape(tmp,(/imax,jmax/))
      if(nret/=0) call bort('reading nems')
      print*,iarzs(1,1,1),iarzs(1,jmax,1)


      CALL NEMSIO_READRECVw34(GFILE,'pres','sfc',1,tmp,iret=nret)
      CALL GBLEVN11(IMAX,JMAX,tmp)                 
      print *,'psfc,',maxval(tmp),minval(tmp),nret
      iarps(:,:,kbak)=reshape(tmp,(/imax,jmax/))*.01
      if(nret/=0) call bort('reading nems')
      print*,iarps(1,1,1),iarps(1,jmax,1)

      Do K=1,KMAX; kk=kmax-k+1

      CALL NEMSIO_readrecvw34(GFILE,'tmp','mid layer',K,tmp,
     .iret=nret)
      CALL GBLEVN11(IMAX,JMAX,tmp)                 
      if(k==1) print *,'temp,k=',k,maxval(tmp),minval(tmp),nret
      IARTT(:,:,k,kbak)=reshape(tmp,(/imax,jmax/))
      if(nret/=0) call bort('reading nems')

      CALL NEMSIO_readrecvw34(GFILE,'ugrd','mid layer',K,tmp,
     .iret=nret)
      CALL GBLEVN11(IMAX,JMAX,tmp)                 
      if(k==1) print *,'ugrd,k=',k,maxval(tmp),minval(tmp),nret
      IARUU(:,:,k,kbak)=reshape(tmp,(/imax,jmax/))
      if(nret/=0) call bort('reading nems')

      CALL NEMSIO_readrecvw34(GFILE,'vgrd','mid layer',K,tmp,
     .iret=nret)
      CALL GBLEVN11(IMAX,JMAX,tmp)                 
      if(k==1) print *,'vgrd,k=',k,maxval(tmp),minval(tmp),nret
      IARVV(:,:,k,kbak)=reshape(tmp,(/imax,jmax/))
      if(nret/=0) call bort('reading nems')

      CALL NEMSIO_readrecvw34(GFILE,'spfh','mid layer',K,tmp,
     .iret=nret)
      CALL GBLEVN11(IMAX,JMAX,tmp)                 
      if(k==1) print *,'spfh,k=',k,maxval(tmp),minval(tmp),nret
      IARQQ(:,:,k,kbak)=reshape(tmp,(/imax,jmax/))*1.e6
      if(nret/=0) call bort('reading nems')

      do i=1,imax
      do j=1,jmax
      iarqq(i,j,k,kbak)=max(iarqq(i,j,k,kbak),0.)
      enddo
      enddo

      ENDDO

      if(kbak==1) call prttime('nemsio')

!***********************************************************************
!**********  make temperatures virtual
!***********************************************************************
!     1) ESVP(T     ) - SATURATION WATER VAPOR PRESSURE FROM T
!     2) ERLH(P,R,T ) - WATER VAPOR PRESSURE FROM P,R,T
!     3) EMIX(P,W   ) - WATER VAPOR PRESSURE FROM P,W
!     4) ESPH(P,Q   ) - WATER VAPOR PRESSURE FROM P,Q
!     5) EDEW(DP    ) - WATER VAPOR PRESSURE FROM DP
!     6) RELH(P,E,T ) - RELATIVE HUMIDITY FROM P,E,T
!     7) WMIX(P,E   ) - MIXING RATIO FROM P,E
!     8) QSPH(P,E   ) - SPECIFIC HUMIDITY FROM P,E
!     9) DPAL(E     ) - DEW POINT FROM E   (ALGEBRAIC)
!    10) VIRT(P,E,TS) - VIRTUAL  TEMPERATURE FROM P,E,TS
!    11) SENT(P,E,TV) - SENSIBLE TEMPERATURE FROM P,E,TV
!***********************************************************************

!***********************************************************************
!**********  compute mid layer pressures and heights
!***********************************************************************

! use gsm routine to derive mid layer pressures

      call hyb2pres(imjm,kmax,ak5,bk5,
     . iarps(1,1,kbak),iarpl(1,1,1,kbak),dprs)
      if(kbak==1) call prttime('hyb2pres')

! compute and store height profiles the gsi way

      do k=1,kmax
      do j=1,jmax
      do i=1,imax

      ! make temps virtual
      p=iarpl(i,j,k,kbak)
      q=iarqq(i,j,k,kbak)*1.e-6
      t=iartt(i,j,k,kbak)-tzero
      iartt(i,j,k,kbak)=virt(p,esph(p,q),t)+tzero

      ! create height profiles
      if(k==1) then
         pwgt=log(iarpl(i,j,k,kbak)/iarps(i,j,kbak))
         tmid=iartt(i,j,k,kbak) ! this is not quite right, but copied from gsi
         zblo=iarzs(i,j,kbak)
         iarzl(i,j,k,kbak)=zblo-rog*tmid*pwgt
         iarzl(i,j,k,kbak)=iarzl(i,j,k,kbak)-iarzs(i,j,kbak) ! convert to height above the surface
      else
         pwgt=log(iarpl(i,j,k,kbak)/iarpl(i,j,k-1,kbak))
         tmid=.5*(iartt(i,j,k-1,kbak)+iartt(i,j,k,kbak))
         zblo=iarzl(i,j,k-1,kbak)
         iarzl(i,j,k,kbak)=zblo-rog*tmid*pwgt
      endif

!!test
      if ((kbak==1) .and. (i==imax/2) .and. (j==jmax/2)) then
         if (k==1) then
            write(6,122) kbak,i,j,iarzs(i,j,kbak)
 122        format('kbak,i,j=',3(i6,1x),' zsfc=',g13.6)
         endif
         write(6,123) k,p,iarzl(i,j,k,kbak),t,q
 123     format('k= ',i2,' p,z,t,q= ',4(g13.6,1x))
      endif
!!test

      enddo
      enddo
      enddo

      if(kbak==1) call prttime('zprofile') 

      !print*
      !print*,iarpl(1,1,:,1)
      !print*
      !print*,iarzl(1,1,:,1)
      !print*
      !call bort('end of test')


!***********************************************************************
!**********  normal exit 
!***********************************************************************

      ! don't forget to deallocate !

      deallocate (ak5,bk5,dprs,tmp)

      CALL NEMSIO_close(gfile)  
      RETURN
      END
!***********************************************************************
!**********  subroutine to compute mid layer pressures
!***********************************************************************
      subroutine hyb2pres(imjm,levs,ak5,bk5,psmb,prsl,dprs)

      implicit none

      integer, parameter :: kind_args = 4

      real(kind=kind_args),parameter :: con_rd     =2.8705e+2      ! gas constant air    (J/kg/K)
      real(kind=kind_args),parameter :: con_cp     =1.0046e+3      ! spec heat air @p    (J/kg/K)
      real(kind=kind_args),parameter :: con_rocp   =con_rd/con_cp
      real(kind=kind_args),parameter :: rk         =con_rd/con_cp
      real(kind=kind_args),parameter :: rk1 = rk + 1.0, rkr = 1.0/rk
      real(kind=kind_args),parameter :: R1000=1000.0, R10=10., PT01=0.01

      real(kind=kind_args) tem,pressfc(imjm)
      real(kind=kind_args) ppi(imjm,levs+1),ppik(imjm,levs+1)
      real(kind=kind_args) psmb(imjm),ak5(levs+1),bk5(levs+1)
      real(kind=kind_args) prsl(imjm,levs),dprs(imjm,levs)

      integer imjm,levs
      integer i,k

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! interface pressures defined by ak and bk

      do k=1,levs+1
      do i=1,imjm
      ppi(i,levs+2-k) = ak5(k)+bk5(k)*psmb(i)*.1 ! psmb=surface pres in mb
      enddo
      enddo

! exner function for level 1

      ppik(:,1) = (ppi(:,1)*pt01) ** rk

! mid later pressures using exner function interpolation bottom to top

      do k=1,levs
      do i=1,imjm   
      ppik(i,k+1) = (ppi(i,k+1)*pt01) ** rk
      tem         = rk1 * (ppi(i,k) - ppi(i,k+1))
      ppik(i,k)   = (ppik(i,k)*ppi(i,k)-ppik(i,k+1)*ppi(i,k+1))/tem

      ! pres and dprs returned in hPa

      prsl(i,k)   = r1000 * ppik(i,k) ** rkr 
      dprs(i,k)   = r10   * (ppi(i,k) - ppi(i,k+1))

      enddo
      enddo

      !print*,prsl(1,:)
      !call bort('test')

      return
      end

      program ecmwfensh
C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: ECMWFENS
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2004-09-12
C
C ABSTRACT: This program converts GRIB ensemble header
c   extensions from ECMWF's format to NCEP's format.  It
c   also calculates ensemble mean and spread fields.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
c   99-09-29  MARCHOK     converted to run on Cray5
c   00-03-17  Wobus       IBM version
C   01-01-16  WOBUS       added DOCBLOCK, removed nonstandard
c                         output
c   04-09-12  Wobus       converted for high resolution
c                         and additional variables
C
C USAGE:
C   INPUT FILES:
c     unit 5   - Namelist NAMIN parameters:  
c                     resflag=2 for 2.5x2.5
c                     maxmem = number of members
c     unit 11  - input GRIB file for one forecast length
c     unit 21  - GRIB index file corresponding to unit 11
C
C   OUTPUT FILES:  (INCLUDING SCRATCH FILES)
C     unit   6 - standard output
C     unit  51 - GRIB output for t200
C     unit 151 - GRIB output for t200 stats
C     unit  52 - GRIB output for t500
C     unit 152 - GRIB output for t500 stats
C     unit  53 - GRIB output for t700
C     unit 153 - GRIB output for t700 stats
C     unit  54 - GRIB output for t850
C     unit 154 - GRIB output for t850 stats
C     unit  55 - GRIB output for t2m
C     unit 155 - GRIB output for t2m stats
C     unit  56 - GRIB output for t2max
C     unit 156 - GRIB output for t2max stats
C     unit  57 - GRIB output for t2min
C     unit 157 - GRIB output for t2min stats
C     unit  58 - GRIB output for td2m
C     unit 158 - GRIB output for td2m stats
C     unit  61 - GRIB output for z200
C     unit 162 - GRIB output for z200 stats
C     unit  62 - GRIB output for z500
C     unit 162 - GRIB output for z500 stats
C     unit  63 - GRIB output for z700
C     unit 162 - GRIB output for z700 stats
C     unit  64 - GRIB output for z850
C     unit 162 - GRIB output for z850 stats
C     unit  65 - GRIB output for z1000
C     unit 165 - GRIB output for z1000 stats
C     unit  71 - GRIB output for rh500
C     unit 171 - GRIB output for rh500 stats
C     unit  72 - GRIB output for rh700
C     unit 172 - GRIB output for rh700 stats
C     unit  73 - GRIB output for rh850
C     unit 173 - GRIB output for rh850 stats
C     unit  81 - GRIB output for mslp
C     unit 181 - GRIB output for mslp stats
C     unit  82 - GRIB output for psfc
C     unit 182 - GRIB output for psfc stats
C     unit  83 - GRIB output for prcp
C     unit 183 - GRIB output for prcp stats
C     unit  84 - GRIB output for tcdc 
C     unit 184 - GRIB output for tcdc stats
C     unit 101 - GRIB output for u200
C     unit 102 - GRIB output for v200
C     unit 103 - GRIB output for u500
C     unit 104 - GRIB output for v500
C     unit 105 - GRIB output for u700
C     unit 106 - GRIB output for v700
C     unit 107 - GRIB output for u850
C     unit 108 - GRIB output for v850
C     unit 109 - GRIB output for u10m
C     unit 110 - GRIB output for v10m
C
C   SUBPROGRAMS CALLED: (LIST ALL CALLED FROM ANYWHERE IN CODES)
C     UNIQUE:    - 
c       INCLUDED - create_stats, adjpds, adjext, output, output_stats,
c                  grange, srange, getgbece, ecmext,
c                  grib_close, grib_open, grib_open_wa, grib_open_r
C     LIBRARY:
C       W3LIB    - gbyte,fi632,fi633,w3fi63,w3tagb,w3tage 
c       BACIO    - baopen,baopenwa,baopenr,baclose,baread
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C
C REMARKS: 
c     Error messages from W3LIB routines will be printed but
c     will not halt execution
C
C ATTRIBUTES:
C   LANGUAGE: Fortran 90
C   MACHINE:  IBM SP
C
C$$$
c
c
c     *** 9/29/99: Due to cray-3 emergency, this program is being
c         implemented on Cray-5 and is being modified to be more
c         efficient.  It doesn't worry about what order the 
c         members are in, it just copies them over.  It still 
c         changes the height level values for the 500 mb height
c         and for mslp for GrADS purposes.  It will leave the 
c         precip fields as they are.
c
c     *** 3/17/00 IBM version
c
c     lugb         logical unit of the unblocked grib data file
c     lugi         logical unit of the unblocked grib index file
c
c     kres         1 - input file contains only high res control.
c                      This lets the program know that you're reading
c                      a "USD" file.
c                  2 - input file contains low res control and
c                      perturbations.  This lets the program know 
c                      you're reading a "USE" file, which has 1 LRC
c                      record for each parm, plus 50 perturbations
c                      for each parm.
c                 (Important to know since high res control
c                  does NOT have a PDS extension)
c
c     memberct    Keeps track of how many members have been read in
c                 for each parameter.  In this way, we can modify the
c                 height level for each successive member (in our 
c                 kludgy system) to be 1,2,3,....,50,51.  And only
c                 index this as "2" since we are only doing this 
c                 kludgy method to 2 variables, z500 and mslp.
c
c
c
      parameter(lugi=21,lugb=11,jf=512*256,nlat=181,nlon=360)
      parameter(numec=52)
      character*1 contflag
      character*1 gott200pds,gott500pds,gott700pds,gott850pds
      character*1 gott2mpds,gott2maxpds,gott2minpds,gottd2mpds
      character*1 gotz200pds,gotz500pds,gotz700pds,gotz850pds
      character*1 gotz1000pds
      character*1 gotrh500pds,gotrh700pds,gotrh850pds
      character*1 gotmslppds,gotpsfcpds,gotprcppds,gottcdcpds
      character*1 gotu200,gotv200
      character*1 gotu500,gotv500
      character*1 gotu700,gotv700
      character*1 gotu850,gotv850
      character*1 gotu10m,gotv10m
      character*8 newvar
      integer   jpds(200),jgds(200),jens(200)
      integer   kpds(200),kgds(200),kens(200)
c for overflow test
      real      rjpds(204),rjgds(204),rjens(204)
      equivalence (jpds(1),rjpds(1))
      equivalence (jgds(1),rjgds(1))
      equivalence (jens(1),rjens(1))
      real      rkpds(204),rkgds(204),rkens(204)
      equivalence (kpds(1),rkpds(1))
      equivalence (kgds(1),rkgds(1))
      equivalence (kens(1),rkens(1))
      integer   kholdt200pds(200)
      integer   kholdt500pds(200)
      integer   kholdt700pds(200)
      integer   kholdt850pds(200)
      integer   kholdt2mpds(200)
      integer   kholdt2maxpds(200)
      integer   kholdt2minpds(200)
      integer   kholdtd2mpds(200)
      integer   kholdz200pds(200)
      integer   kholdz500pds(200)
      integer   kholdz700pds(200)
      integer   kholdz850pds(200)
      integer   kholdz1000pds(200)
      integer   kholdrh500pds(200)
      integer   kholdrh700pds(200)
      integer   kholdrh850pds(200)
      integer   kholdmslppds(200)
      integer   kholdpsfcpds(200)
      integer   kholdprcppds(200)
      integer   kholdtcdcpds(200)
      integer   memberct(2)
      integer   t200ct,t500ct,t700ct,t850ct
      integer   t2mct,t2maxct,t2minct,td2mct
      integer   z200ct,z500ct,z700ct,z850ct,z1000ct
      integer   rh500ct,rh700ct,rh850ct
      integer   mslpct,psfcct,prcpct,tcdcct
      logical   lb(jf)
      real      f(jf)
      real      t200vals(numec,nlat*nlon)
      real      t200mean(nlat*nlon),t200spr(nlat*nlon)
      real      t500vals(numec,nlat*nlon)
      real      t500mean(nlat*nlon),t500spr(nlat*nlon)
      real      t700vals(numec,nlat*nlon)
      real      t700mean(nlat*nlon),t700spr(nlat*nlon)
      real      t850vals(numec,nlat*nlon)
      real      t850mean(nlat*nlon),t850spr(nlat*nlon)
      real      t2mvals(numec,nlat*nlon)
      real      t2mmean(nlat*nlon),t2mspr(nlat*nlon)
      real      t2maxvals(numec,nlat*nlon)
      real      t2maxmean(nlat*nlon),t2maxspr(nlat*nlon)
      real      t2minvals(numec,nlat*nlon)
      real      t2minmean(nlat*nlon),t2minspr(nlat*nlon)
      real      td2mvals(numec,nlat*nlon)
      real      td2mmean(nlat*nlon),td2mspr(nlat*nlon)
      real      z200vals(numec,nlat*nlon)
      real      z200mean(nlat*nlon),z200spr(nlat*nlon)
      real      z500vals(numec,nlat*nlon)
      real      z500mean(nlat*nlon),z500spr(nlat*nlon)
      real      z700vals(numec,nlat*nlon)
      real      z700mean(nlat*nlon),z700spr(nlat*nlon)
      real      z850vals(numec,nlat*nlon)
      real      z850mean(nlat*nlon),z850spr(nlat*nlon)
      real      z1000vals(numec,nlat*nlon)
      real      z1000mean(nlat*nlon),z1000spr(nlat*nlon)
      real      rh500vals(numec,nlat*nlon)
      real      rh500mean(nlat*nlon),rh500spr(nlat*nlon)
      real      rh700vals(numec,nlat*nlon)
      real      rh700mean(nlat*nlon),rh700spr(nlat*nlon)
      real      rh850vals(numec,nlat*nlon)
      real      rh850mean(nlat*nlon),rh850spr(nlat*nlon)
      real      mslpvals(numec,nlat*nlon)
      real      mslpmean(nlat*nlon),mslpspr(nlat*nlon)
      real      psfcvals(numec,nlat*nlon)
      real      psfcmean(nlat*nlon),psfcspr(nlat*nlon)
      real      prcpvals(numec,nlat*nlon)
      real      prcpmean(nlat*nlon),prcpspr(nlat*nlon)
      real      tcdcvals(numec,nlat*nlon)
      real      tcdcmean(nlat*nlon),tcdcspr(nlat*nlon)
      namelist/namin/kres,kmaxmem
c
      call w3tagb('ECMWFENS',2001,0017,0088,'NP20')
c
      read (5,namin,end=1000)
 1000 continue
c
      print *,' '
      print *,'------------------------------------------------------'
      print *,'at beginning of ecmwfens.f, kres= ',kres
     &       ,' kmaxmem= ',kmaxmem

      t200vals = 0.0
      t200mean = 0.0
      t200spr =  0.0
      t500vals = 0.0
      t500mean = 0.0
      t500spr =  0.0
      t700vals = 0.0
      t700mean = 0.0
      t700spr =  0.0
      t850vals = 0.0
      t850mean = 0.0
      t850spr =  0.0
      t2mvals = 0.0
      t2mmean = 0.0
      t2mspr =  0.0
      t2maxvals = 0.0
      t2maxmean = 0.0
      t2maxspr =  0.0
      t2minvals = 0.0
      t2minmean = 0.0
      t2minspr =  0.0
      td2mvals = 0.0
      td2mmean = 0.0
      td2mspr =  0.0

      z200vals = 0.0
      z200mean = 0.0
      z200spr =  0.0
      z500vals = 0.0
      z500mean = 0.0
      z500spr =  0.0
      z700vals = 0.0
      z700mean = 0.0
      z700spr =  0.0
      z850vals = 0.0
      z850mean = 0.0
      z850spr =  0.0
      z1000vals = 0.0
      z1000mean = 0.0
      z1000spr =  0.0

      rh500vals = 0.0
      rh500mean = 0.0
      rh500spr =  0.0
      rh700vals = 0.0
      rh700mean = 0.0
      rh700spr =  0.0
      rh850vals = 0.0
      rh850mean = 0.0
      rh850spr =  0.0

      mslpvals = 0.0
      mslpmean = 0.0
      mslpspr =  0.0
      psfcvals = 0.0
      psfcmean = 0.0
      psfcspr =  0.0
      prcpvals = 0.0
      prcpmean = 0.0
      prcpspr =  0.0
      tcdcvals = 0.0
      tcdcmean = 0.0
      tcdcspr =  0.0
c
      gott200pds = 'n'
      gott500pds = 'n'
      gott700pds = 'n'
      gott850pds = 'n'
      gott2mpds = 'n'
      gott2maxpds = 'n'
      gott2minpds = 'n'
      gottd2mpds = 'n'

      gotz200pds = 'n'
      gotz500pds = 'n'
      gotz700pds = 'n'
      gotz850pds = 'n'
      gotz1000pds = 'n'

      gotrh500pds = 'n'
      gotrh700pds = 'n'
      gotrh850pds = 'n'

      gotmslppds = 'n'
      gotpsfcpds = 'n'
      gotprcppds = 'n'
      gottcdcpds = 'n'
c
      t200ct = 0
      t500ct = 0
      t700ct = 0
      t850ct = 0
      t2mct = 0
      t2maxct = 0
      t2minct = 0
      td2mct = 0

      z200ct = 0
      z500ct = 0
      z700ct = 0
      z850ct = 0
      z1000ct = 0

      rh500ct = 0
      rh700ct = 0
      rh850ct = 0

      mslpct = 0
      psfcct = 0
      prcpct = 0
      tcdcct = 0
 
c     maxloop = number of perturbations + the LRC record.  Remember, 
c     the HRC record is in a file by itself, and is handled by the 
c     case of kres=1.

      maxloop = kmaxmem + 1
      jpds = -1
      jgds = -1
      jens = -1
      jpds(23) = 0
      kgds = 0
      memberct = 0

      kpdsread = 0

c      jpds(23) = 0
      j = 0
      iret = 0

      print *,' '
      do while (iret.eq.0)
 
	kpdsnull = -kpdsread
	kpds = kpdsnull
	kens = kpdsnull

c       Use my modified version of getgbens in this program to 
c       read the recs.  This version of getgbens reads different
c       bytes from the ECMWF PDS extension than are read from the 
c       NCEP PDS extension. *** NOTE: THE VERSION OF GETGBENS 
c       THAT IS CALLED HAS BEEN MODIFIED FROM THE W3LIB VERSION.
c  Modified getgbens has been renamed getgbece

        call getgbece(lugb,lugi,jf,j,jpds,jgds,jens,
     &                          kf,k,kpds,kgds,kens,lb,f,iret,
     &                          ktype,kfnum,ktot)
c check for kpds written out of bounds
        if (kpdsread.lt.10) then
	  print *,' '
	  print *,'check kpds before processing'
	  write(*,71) (kpds(mm),mm=1,5) 
	  write(*,72) (kpds(mm),mm=6,10) 
	  write(*,73) (kpds(mm),mm=11,15) 
	  write(*,74) (kpds(mm),mm=16,20) 
	  write(*,75) (kpds(mm),mm=21,25) 
	  write(*,76) (kgds(mm),mm=1,5) 
	  write(*,77) (kgds(mm),mm=6,10) 
	  write(*,78) (kgds(mm),mm=11,15) 
	  write(*,79) (kgds(mm),mm=16,20) 
	  write(*,80) (kgds(mm),mm=21,22) 
	  write(*,81) f(1),f(kf/4),f(kf/2)
     &               ,f(3*kf/4),f(kf)
	  call srange(kf,lb,f)
c for overflow test
	  do ichk=26,200
	    if ( jpds(ichk) .ne. -1 ) then
	      write (*,'(''kpdsread, ichk, jpds, jpds, rjpds ='',
     &                i3,i4,i23,z17,1pe32.23))')
     &               kpdsread,ichk,jpds(ichk),jpds(ichk),rjpds(ichk)
	    endif
	  enddo
	  do ichk=23,200
	    if ( jgds(ichk) .ne. -1 ) then
	      write (*,'(''kpdsread, ichk, jgds, jgds, rjgds ='',
     &                i3,i4,i23,z17,1pe32.23))')
     &               kpdsread,ichk,jgds(ichk),jgds(ichk),rjgds(ichk)
	    endif
	  enddo
	  do ichk=6,200
	    if ( jens(ichk) .ne. -1 ) then
	      write (*,'(''kpdsread, ichk, jens, jens, rjens ='',
     &                i3,i4,i23,z17,1pe32.23))')
     &               kpdsread,ichk,jens(ichk),jens(ichk),rjens(ichk)
	    endif
	  enddo
	  do ichk=26,200
	    if ( kpds(ichk) .ne. kpdsnull ) then
	      write (*,'(''kpdsread, ichk, kpds, kpds, rkpds ='',
     &                i3,i4,i23,z17,1pe32.23))')
     &               kpdsread,ichk,kpds(ichk),kpds(ichk),rkpds(ichk)
	    endif
	  enddo
	  do ichk=23,200
	    if ( kgds(ichk) .ne. 0 ) then
	      write (*,'(''kpdsread, ichk, kgds, kgds, rkgds ='',
     &                i3,i4,i23,z17,1pe32.23))')
     &               kpdsread,ichk,kgds(ichk),kgds(ichk),rkgds(ichk)
	    endif
	  enddo
	  do ichk=6,200
	    if ( kens(ichk) .ne. kpdsnull ) then
	      write (*,'(''kpdsread, ichk, kens, kens, rkens ='',
     &                i3,i4,i23,z17,1pe32.23))')
     &               kpdsread,ichk,kens(ichk),kens(ichk),rkens(ichk)
	    endif
	  enddo
	endif
	kpdsread=kpdsread+1
c
        j=k
c       print *,' '
        if (iret.eq.0) then
	  print *,'immediately after call to getgb, j=',j
     &          ,' k=',k,' kpds(5)=',kpds(5)
     &          ,' kpds(14)=',kpds(14),' kfnum=',kfnum
     &          ,' iret=',iret
	  if ((kfnum.le.2).or.(kfnum.ge.49)) then
	    if ((kpds(14).le.24).or.(kpds(14).ge.228)) then
c             print *,' '
              call srange(kf,lb,f)
	      call grange(kf,lb,f,dmin,dmax)
	      print '(4i5,4i3,2x,a1,i3,3i5,2x,i7,2g12.4)'
     &              ,k,(kpds(i),i=5,11),'f',kpds(14),ktype,kfnum
     &              ,ktot,kf,dmin,dmax
	    endif
	  endif
        else
          print *,'!!! getgb IRET= ',iret,'   j= ',j
     &           ,' .... Continuing to next loop iteration ....'
          goto 600
        endif
 
        call adjpds (kpds,contflag,lugout,memberct)

        if (contflag.eq.'n') goto 600

      call grib_open_wa (lugout,ireto)
      if (ireto.gt.0) then
        print *,'ireto,lu from grib_open_wa in ecmwfens = ',ireto,lugout
      endif
 
        call adjext (kens,ktype,kfnum,kres)
 
c	if ((kfnum.le.2).or.(kfnum.ge.49)) then
c	  if ((kpds(14).le.24).or.(kpds(14).ge.228)) then
c           print *,' '
c	    write(*,71) (kpds(mm),mm=1,5) 
c	    write(*,72) (kpds(mm),mm=6,10) 
c	    write(*,73) (kpds(mm),mm=11,15) 
c	    write(*,74) (kpds(mm),mm=16,20) 
c	    write(*,75) (kpds(mm),mm=21,25) 
c	    write(*,76) (kgds(mm),mm=1,5) 
c	    write(*,77) (kgds(mm),mm=6,10) 
c	    write(*,78) (kgds(mm),mm=11,15) 
c	    write(*,79) (kgds(mm),mm=16,20) 
c	    write(*,80) (kgds(mm),mm=21,22) 
c	    write(*,81) f(1),f(kf/4),f(kf/2)
c    &                 ,f(3*kf/4),f(kf)
c	    call srange(kf,lb,f)
c	  endif
c	endif

        kpds(23)=2

        newvar = 'none'

        if (kpds(5) .eq. 61) then
          if (gotprcppds .eq. 'n') then
            gotprcppds = 'y'
	    newvar = 'prcp    '
            do i = 1,25
              kholdprcppds(i) = kpds(i)
            enddo
          endif
          prcpct = prcpct + 1
          do ip = 1,kf
            f(ip) = f(ip) * 1000.0
            prcpvals(prcpct,ip) = prcpvals(prcpct,ip) + f(ip)
          enddo
        else if (kpds(5) .eq. 2) then
          if (gotmslppds .eq. 'n') then
            gotmslppds = 'y'
	    newvar = 'mslp    '
            do i = 1,25
              kholdmslppds(i) = kpds(i)
            enddo 
          endif
	    call srange(kf,lb,f)
          mslpct = mslpct + 1
          do ip = 1,kf
            mslpvals(mslpct,ip) = mslpvals(mslpct,ip) + f(ip)
          enddo
        else if (kpds(5) .eq. 11) then
         if (kpds(7) .eq. 850) then
          if (gott850pds .eq. 'n') then
            gott850pds = 'y'
	    newvar = 't850    '
            do i = 1,25
              kholdt850pds(i) = kpds(i)
            enddo
          endif
          t850ct = t850ct + 1
          do ip = 1,kf
            t850vals(t850ct,ip) = t850vals(t850ct,ip) + f(ip)
          enddo
         else if (kpds(7) .eq. 700) then
          if (gott700pds .eq. 'n') then
            gott700pds = 'y'
	    newvar = 't700    '
            do i = 1,25
              kholdt700pds(i) = kpds(i)
            enddo
          endif
          t700ct = t700ct + 1
          do ip = 1,kf
            t700vals(t700ct,ip) = t700vals(t700ct,ip) + f(ip)
          enddo
         else if (kpds(7) .eq. 500) then
          if (gott500pds .eq. 'n') then
            gott500pds = 'y'
	    newvar = 't500    '
            do i = 1,25
              kholdt500pds(i) = kpds(i)
            enddo
          endif
          t500ct = t500ct + 1
          do ip = 1,kf
            t500vals(t500ct,ip) = t500vals(t500ct,ip) + f(ip)
          enddo
         else if (kpds(7) .eq. 200) then
          if (gott200pds .eq. 'n') then
            gott200pds = 'y'
	    newvar = 't200    '
            do i = 1,25
              kholdt200pds(i) = kpds(i)
            enddo
          endif
          t200ct = t200ct + 1
          do ip = 1,kf
            t200vals(t200ct,ip) = t200vals(t200ct,ip) + f(ip)
          enddo
         else if (kpds(7) .eq. 2) then
          if (gott2mpds .eq. 'n') then
            gott2mpds = 'y'
	    newvar = 't2m     '
            do i = 1,25
              kholdt2mpds(i) = kpds(i)
            enddo
          endif
          t2mct = t2mct + 1
          do ip = 1,kf
            t2mvals(t2mct,ip) = t2mvals(t2mct,ip) + f(ip)
          enddo
	 endif 
c new batch 01/04
        else if (kpds(5) .eq. 15) then
         if (kpds(7) .eq. 2) then
          if (gott2maxpds .eq. 'n') then
            gott2maxpds = 'y'
	    newvar = 't2max   '
            do i = 1,25
              kholdt2maxpds(i) = kpds(i)
            enddo
          endif
          t2maxct = t2maxct + 1
          do ip = 1,kf
            t2maxvals(t2maxct,ip) = t2maxvals(t2maxct,ip) + f(ip)
          enddo
	 endif 
        else if (kpds(5) .eq. 16) then
         if (kpds(7) .eq. 2) then
          if (gott2minpds .eq. 'n') then
            gott2minpds = 'y'
	    newvar = 't2min   '
            do i = 1,25
              kholdt2minpds(i) = kpds(i)
            enddo
          endif
          t2minct = t2minct + 1
          do ip = 1,kf
            t2minvals(t2minct,ip) = t2minvals(t2minct,ip) + f(ip)
          enddo
	 endif 
        else if (kpds(5) .eq. 17) then
         if (kpds(7) .eq. 2) then
          if (gottd2mpds .eq. 'n') then
            gottd2mpds = 'y'
	    newvar = 'td2m    '
            do i = 1,25
              kholdtd2mpds(i) = kpds(i)
            enddo
          endif
          td2mct = td2mct + 1
          do ip = 1,kf
            td2mvals(td2mct,ip) = td2mvals(td2mct,ip) + f(ip)
          enddo
	 endif 
        else if (kpds(5) .eq. 1) then
         if (kpds(7) .eq. 0) then
          if (gotpsfcpds .eq. 'n') then
            gotpsfcpds = 'y'
	    newvar = 'psfc    '
            do i = 1,25
              kholdpsfcpds(i) = kpds(i)
            enddo
          endif
          psfcct = psfcct + 1
          do ip = 1,kf
cJ.Peng---2011-05-17------------NCO change Surface Pressure----
c           f(ip) = exp(f(ip))

            psfcvals(psfcct,ip) = psfcvals(psfcct,ip) + f(ip)
          enddo
	 endif 
        else if (kpds(5) .eq. 71) then
         if (kpds(7) .eq. 0) then
          if (gottcdcpds .eq. 'n') then
            gottcdcpds = 'y'
	    newvar = 'tcdc    '
            do i = 1,25
              kholdtcdcpds(i) = kpds(i)
            enddo
          endif
          tcdcct = tcdcct + 1
          do ip = 1,kf
	    f(ip) = f(ip) * 100.0
            tcdcvals(tcdcct,ip) = tcdcvals(tcdcct,ip) + f(ip)
          enddo
	 endif 
        else if (kpds(5) .eq. 7) then
         if (kpds(7) .eq. 1000) then
          if (gotz1000pds .eq. 'n') then
            gotz1000pds = 'y'
	    newvar = 'z1000   '
            do i = 1,25
              kholdz1000pds(i) = kpds(i)
            enddo 
          endif
          z1000ct = z1000ct + 1
          do ip = 1,kf
            z1000vals(z1000ct,ip) = z1000vals(z1000ct,ip) + f(ip)
          enddo
         else if (kpds(7).eq.850) then
          if (gotz850pds .eq. 'n') then
            gotz850pds = 'y'
	    newvar = 'z850    '
            do i = 1,25
              kholdz850pds(i) = kpds(i)
            enddo 
          endif
          z850ct = z850ct + 1
          do ip = 1,kf
            z850vals(z850ct,ip) = z850vals(z850ct,ip) + f(ip)
          enddo
         else if (kpds(7).eq.700) then
          if (gotz700pds .eq. 'n') then
            gotz700pds = 'y'
	    newvar = 'z700    '
            do i = 1,25
              kholdz700pds(i) = kpds(i)
            enddo 
          endif
          z700ct = z700ct + 1
          do ip = 1,kf
            z700vals(z700ct,ip) = z700vals(z700ct,ip) + f(ip)
          enddo
         else if (kpds(7).eq.500) then
          if (gotz500pds .eq. 'n') then
            gotz500pds = 'y'
	    newvar = 'z500    '
            do i = 1,25
              kholdz500pds(i) = kpds(i)
            enddo 
          endif
          z500ct = z500ct + 1
          do ip = 1,kf
            z500vals(z500ct,ip) = z500vals(z500ct,ip) + f(ip)
          enddo
         else if (kpds(7).eq.200) then
          if (gotz200pds .eq. 'n') then
            gotz200pds = 'y'
	    newvar = 'z200    '
            do i = 1,25
              kholdz200pds(i) = kpds(i)
            enddo 
          endif
          z200ct = z200ct + 1
          do ip = 1,kf
            z200vals(z200ct,ip) = z200vals(z200ct,ip) + f(ip)
          enddo
         endif
        else if (kpds(5) .eq. 52) then
         if (kpds(7) .eq. 850) then
          if (gotrh850pds .eq. 'n') then
            gotrh850pds = 'y'
	    newvar = 'rh850   '
            do i = 1,25
              kholdrh850pds(i) = kpds(i)
            enddo
          endif
          rh850ct = rh850ct + 1
          do ip = 1,kf
            rh850vals(rh850ct,ip) = rh850vals(rh850ct,ip) + f(ip)
          enddo
         else if (kpds(7) .eq. 700) then
          if (gotrh700pds .eq. 'n') then
            gotrh700pds = 'y'
	    newvar = 'rh700   '
            do i = 1,25
              kholdrh700pds(i) = kpds(i)
            enddo
          endif
          rh700ct = rh700ct + 1
          do ip = 1,kf
            rh700vals(rh700ct,ip) = rh700vals(rh700ct,ip) + f(ip)
          enddo
         else if (kpds(7) .eq. 500) then
          if (gotrh500pds .eq. 'n') then
            gotrh500pds = 'y'
	    newvar = 'rh500   '
            do i = 1,25
              kholdrh500pds(i) = kpds(i)
            enddo
          endif
          rh500ct = rh500ct + 1
          do ip = 1,kf
            rh500vals(rh500ct,ip) = rh500vals(rh500ct,ip) + f(ip)
          enddo
	 endif
	else if (kpds(5) .eq. 33) then
         if (kpds(7) .eq. 200) then
          if (gotu200 .eq. 'n') then
            gotu200 = 'y'
            newvar = 'u200'
          endif
         else if (kpds(7) .eq. 500) then
          if (gotu500 .eq. 'n') then
            gotu500 = 'y'
            newvar = 'u500'
          endif
         else if (kpds(7) .eq. 700) then
          if (gotu700 .eq. 'n') then
            gotu700 = 'y'
            newvar = 'u700'
          endif
         else if (kpds(7) .eq. 850) then
          if (gotu850 .eq. 'n') then
            gotu850 = 'y'
            newvar = 'u850'
          endif
         else if (kpds(7) .eq. 10) then
          if (gotu10m .eq. 'n') then
            gotu10m = 'y'
            newvar = 'u10m'
          endif
         endif
	else if (kpds(5) .eq. 34) then
         if (kpds(7) .eq. 200) then
          if (gotv200 .eq. 'n') then
            gotv200 = 'y'
            newvar = 'v200'
          endif
         else if (kpds(7) .eq. 500) then
          if (gotv500 .eq. 'n') then
            gotv500 = 'y'
            newvar = 'v500'
          endif
         else if (kpds(7) .eq. 700) then
          if (gotv700 .eq. 'n') then
            gotv700 = 'y'
            newvar = 'v700'
          endif
         else if (kpds(7) .eq. 850) then
          if (gotv850 .eq. 'n') then
            gotv850 = 'y'
            newvar = 'v850'
          endif
         else if (kpds(7) .eq. 10) then
          if (gotv10m .eq. 'n') then
            gotv10m = 'y'
            newvar = 'v10m'
          endif
         endif
        endif

        if ( newvar .ne. 'none') then
          print *,'new variable ',newvar
          call srange(kf,lb,f)
	  call grange(kf,lb,f,dmin,dmax)
	  print '(4i5,4i3,2x,a1,i3,3i5,2x,i7,2g12.4)'
     &              ,k,(kpds(i),i=5,11),'f',kpds(14),ktype,kfnum
     &              ,ktot,kf,dmin,dmax
	  write(*,71) (kpds(mm),mm=1,5) 
	  write(*,72) (kpds(mm),mm=6,10) 
	  write(*,73) (kpds(mm),mm=11,15) 
	  write(*,74) (kpds(mm),mm=16,20) 
	  write(*,75) (kpds(mm),mm=21,25) 
	  write(*,76) (kgds(mm),mm=1,5) 
	  write(*,77) (kgds(mm),mm=6,10) 
	  write(*,78) (kgds(mm),mm=11,15) 
	  write(*,79) (kgds(mm),mm=16,20) 
	  write(*,80) (kgds(mm),mm=21,22) 
	  write(*,81) f(1),f(kf/4),f(kf/2)
     &                 ,f(3*kf/4),f(kf)
        endif

        call output (lugout,kf,kpds,kgds,lb,f,kens)

	call grib_close (lugout,ireto)
	if (ireto.gt.0) then
	  print *,'ireto,lu from grib_close in ecmwfens = ',ireto,lugout
	endif
      

        if ( newvar .ne. 'none') then
	  print *,' '
        endif
 
 600    continue

      enddo
      call grib_close (lugb,ireto)
      if (ireto.gt.0) then
        print *,'ireto,lu from grib_close in ecmwfens = ',ireto,lugb
      endif
      call grib_close (lugi,ireto)
      if (ireto.gt.0) then
        print *,'ireto,lu from grib_close in ecmwfens = ',ireto,lugi
      endif

      if (gott200pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t200ct,t200vals,t200mean,t200spr) 
      call output_stats ('t200',151,nlat*nlon,kholdt200pds,kgds
     &                  ,lb,t200mean,t200spr)
      else
	print *,'no statistics for t200'
      endif
      if (gott500pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t500ct,t500vals,t500mean,t500spr) 
      call output_stats ('t500',152,nlat*nlon,kholdt500pds,kgds
     &                  ,lb,t500mean,t500spr)
      else
	print *,'no statistics for t500'
      endif
      if (gott700pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t700ct,t700vals,t700mean,t700spr) 
      call output_stats ('t700',153,nlat*nlon,kholdt700pds,kgds
     &                  ,lb,t700mean,t700spr)
      else
	print *,'no statistics for t700'
      endif
      if (gott850pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t850ct,t850vals,t850mean,t850spr) 
      call output_stats ('t850',154,nlat*nlon,kholdt850pds,kgds
     &                  ,lb,t850mean,t850spr)
      else
	print *,'no statistics for t850'
      endif
      if (gott2mpds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t2mct,t2mvals,t2mmean,t2mspr) 
      call output_stats ('t2m ',155,nlat*nlon,kholdt2mpds,kgds
     &                  ,lb,t2mmean,t2mspr)
      else
	print *,'no statistics for t2m'
      endif
      if (gott2maxpds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t2maxct,t2maxvals,t2maxmean,t2maxspr) 
      call output_stats ('t2mx',156,nlat*nlon,kholdt2maxpds,kgds
     &                  ,lb,t2maxmean,t2maxspr)
      else
	print *,'no statistics for t2max'
      endif
      if (gott2minpds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,t2minct,t2minvals,t2minmean,t2minspr) 
      call output_stats ('t2mn',157,nlat*nlon,kholdt2minpds,kgds
     &                  ,lb,t2minmean,t2minspr)
      else
	print *,'no statistics for t2min'
      endif
      if (gottd2mpds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,td2mct,td2mvals,td2mmean,td2mspr) 
      call output_stats ('td2m',158,nlat*nlon,kholdtd2mpds,kgds
     &                  ,lb,td2mmean,td2mspr)
      else
	print *,'no statistics for td2m'
      endif

      if (gotz200pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,z200ct,z200vals,z200mean,z200spr) 
      call output_stats ('z200',161,nlat*nlon,kholdz200pds,kgds
     &                  ,lb,z200mean,z200spr)
      else
	print *,'no statistics for z200'
      endif
      if (gotz500pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,z500ct,z500vals,z500mean,z500spr) 
      call output_stats ('z500',162,nlat*nlon,kholdz500pds,kgds
     &                  ,lb,z500mean,z500spr)
      else
	print *,'no statistics for z500'
      endif
      if (gotz700pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,z700ct,z700vals,z700mean,z700spr) 
      call output_stats ('z700',163,nlat*nlon,kholdz700pds,kgds
     &                  ,lb,z700mean,z700spr)
      else
	print *,'no statistics for z700'
      endif
      if (gotz850pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,z850ct,z850vals,z850mean,z850spr) 
      call output_stats ('z850',164,nlat*nlon,kholdz850pds,kgds
     &                  ,lb,z850mean,z850spr)
      else
	print *,'no statistics for z850'
      endif
      if (gotz1000pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,z1000ct,z1000vals,z1000mean,z1000spr) 
      call output_stats ('z1k ',165,nlat*nlon,kholdz1000pds,kgds
     &                  ,lb,z1000mean,z1000spr)
      else
	print *,'no statistics for z1000'
      endif

      if (gotrh500pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,rh500ct,rh500vals,rh500mean,rh500spr) 
      call output_stats ('r500',171,nlat*nlon,kholdrh500pds,kgds
     &                  ,lb,rh500mean,rh500spr)
      else
	print *,'no statistics for rh500'
      endif
      if (gotrh700pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,rh700ct,rh700vals,rh700mean,rh700spr) 
      call output_stats ('r700',172,nlat*nlon,kholdrh700pds,kgds
     &                  ,lb,rh700mean,rh700spr)
      else
	print *,'no statistics for rh700'
      endif
      if (gotrh850pds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,rh850ct,rh850vals,rh850mean,rh850spr) 
      call output_stats ('r850',173,nlat*nlon,kholdrh850pds,kgds
     &                  ,lb,rh850mean,rh850spr)
      else
	print *,'no statistics for rh850'
      endif

      if (gotmslppds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,mslpct,mslpvals,mslpmean,mslpspr) 
      call output_stats ('mslp',181,nlat*nlon,kholdmslppds,kgds
     &                  ,lb,mslpmean,mslpspr)
      else
	print *,'no statistics for mslp'
      endif
      if (gotpsfcpds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,psfcct,psfcvals,psfcmean,psfcspr) 
      call output_stats ('psfc',182,nlat*nlon,kholdpsfcpds,kgds
     &                  ,lb,psfcmean,psfcspr)
      else
	print *,'no statistics for psfc'
      endif
      if (gotprcppds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,prcpct,prcpvals,prcpmean,prcpspr) 
      call output_stats ('prcp',183,nlat*nlon,kholdprcppds,kgds
     &                  ,lb,prcpmean,prcpspr)
      else
	print *,'no statistics for prcp'
      endif
      if (gottcdcpds .eq. 'y') then
      call create_stats (numec,nlat,nlon
     &                  ,tcdcct,tcdcvals,tcdcmean,tcdcspr) 
      call output_stats ('tcdc',184,nlat*nlon,kholdtcdcpds,kgds
     &                  ,lb,tcdcmean,tcdcspr)
      else
	print *,'no statistics for tcdc'
      endif
 
 71   format('p1=  ',i7,' p2=  ',i7,' p3=  ',i7,' p4=  ',i7,' p5=  ',i7)
 72   format('p6=  ',i7,' p7=  ',i7,' p8=  ',i7,' p9=  ',i7,' p10= ',i7)
 73   format('p11= ',i7,' p12= ',i7,' p13= ',i7,' p14= ',i7,' p15= ',i7)
 74   format('p16= ',i7,' p17= ',i7,' p18= ',i7,' p19= ',i7,' p20= ',i7)
 75   format('p21= ',i7,' p22= ',i7,' p23= ',i7,' p24= ',i7,' p25= ',i7)
 76   format('g1=  ',i7,' g2=  ',i7,' g3=  ',i7,' g4=  ',i7,' g5=  ',i7)
 77   format('g6=  ',i7,' g7=  ',i7,' g8=  ',i7,' g9=  ',i7,' g10= ',i7)
 78   format('g11= ',i7,' g12= ',i7,' g13= ',i7,' g14= ',i7,' g15= ',i7)
 79   format('g16= ',i7,' g17= ',i7,' g18= ',i7,' g19= ',i7,' g20= ',i7)
 80   format('g21= ',i7,' g22= ',i7)
 81   format('f(1)= ',g12.4,' f(kf/4)= ',g12.4,' f(kf/2)= ',g12.4
     &      ,' f(3*kf/4)= ',g12.4,' f(kf)= ',g12.4)
c
 700  continue
      call w3tage('ECMWFENS')
      stop
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine create_stats (numec,nlat,nlon,nct,vals,vmean,vspr)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    create_stats
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2004-01-26
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C   04-01-26  WOBUS       rearranged to process one variable
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$
c
      real      vals(numec,nlat*nlon)
      real      vmean(nlat*nlon)
      real      vspr(nlat*nlon)
      integer   nct
c
      npts = nlon * nlat
      vmean = 0.0

c     -----------------------------------------------------
c        MEAN & SPREAD
c     -----------------------------------------------------
 
      if (nct .gt. 0) then

c       sum up all values from all members at all points

        do imem = 1,nct
          do n = 1,npts
            vmean(n) = vmean(n) + vals(imem,n)
          enddo
        enddo

c       calculate mean

        do n = 1,npts
          vmean(n) = vmean(n) / float(nct)
        enddo

c       calculate standard deviation

        if (nct .gt. 1) then

	  do n = 1,npts
	    varnce = 0.0
	    do imem = 1,nct
	      xdiff    = vals(imem,n) - vmean(n)
	      xdiffsqr = xdiff * xdiff
	      varnce   = varnce + xdiffsqr
	    enddo
	    vspr(n) = sqrt(varnce/float(nct))
	  enddo
	  print *,' in create_stats imem=',imem,'   nct=',nct

        else

	  do n = 1,npts
	    vspr(n)  = 0.00
	  enddo

	endif

      else

        do n = 1,npts
          vmean(n) = -99.0
	  vspr(n)  = -99.0
        enddo

      endif
          
      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine adjpds (kpds,contflag,lugout,memberct)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    adjpds
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$
c
c     ****************************************************
c     ADJUST GRIB PARAMETER FROM THE ECMWF TABLE VALUES
c     TO NCEP TABLE VALUES AS FOLLOWS:
c
c       Parameter        ECMWF Grib Parm    NCEP Grib Parm
c     -------------      ---------------    --------------
c     u-comp (std lev)        131                33
c     v-comp (std lev)        132                34
c     gp height               156                 7
c     relative humidity       157                52
c     temperature             130                11
c     mslp                    151                 2
c     total precip            228                61
c
c     - new batch 1/04
c     2 meter temp            167 1 0            11 105 2
c     2 meter tmax            201 1 0            15 105 2
c     2 meter tmin            202 1 0            16 105 2
c     2 meter td              168 1 0            17 105 2
cJ.Peng---2011-05-17------------NCO change Surface Pressure----
c     psfc                    152 109 1 (log)     1 1 0
c     psfc                    134   1 0 new       1 1 0

c     total cloud cover       164 1 0 (0-1)      71 200 0 (%)
c
c
c     - Others, which currently (1/97) are in the ECMWF
c       data sets, but are not needed for this output data
c       set (they're needed by the Ocean Modeling Branch
c       and are processed in a different program):
c       (now processed here 1/04)
c
c     u-comp (10m)            165 1 0            33 105 10
c     v-comp (10m)            166 1 0            34 105 10
c
c     -------------------------------------------------
c
c     ALSO, get the  output GRIB file number, which is 
c     based on the parameter number and vertical level.
c
c     contflag is needed because ECMWF sends a couple of 
c     additional records in their package which our Ocean
c     Modeling Branch uses, but which we do not archive,
c     so we don't want to output these to our GRIB files.
c
c     ****************************************************
c
      character*1 contflag
      integer     kpds(25),memberct(2)
c
      contflag='n'
      lugout=0

cJ.Peng---2011-05-17------------NCO change Surface Pressure----
c  152----to ----134
      if (kpds(5).ne.130 .and.
     &    kpds(5).ne.131 .and. kpds(5).ne.132 .and.
     &    kpds(5).ne.151 .and. kpds(5).ne.134 .and.
     &    kpds(5).ne.156 .and. kpds(5).ne.157 .and.
     &    kpds(5).ne.164 .and.
     &    kpds(5).ne.165 .and. kpds(5).ne.166 .and.
     &    kpds(5).ne.167 .and. kpds(5).ne.168 .and.
     &    kpds(5).ne.201 .and. kpds(5).ne.202 .and.
     &    kpds(5).ne.228) then
        goto 900
      endif

c
      if (kpds(5).eq.130) then
        kpds(5) = 11
        if (kpds(7).eq.200) lugout = 51
        if (kpds(7).eq.500) lugout = 52
        if (kpds(7).eq.700) lugout = 53
        if (kpds(7).eq.850) lugout = 54
      else if (kpds(5).eq.131) then
        kpds(5) = 33
        if (kpds(7).eq.200) lugout = 101
        if (kpds(7).eq.500) lugout = 103
        if (kpds(7).eq.700) lugout = 105
        if (kpds(7).eq.850) lugout = 107
      else if (kpds(5).eq.132) then
        kpds(5) = 34
        if (kpds(7).eq.200) lugout = 102
        if (kpds(7).eq.500) lugout = 104
        if (kpds(7).eq.700) lugout = 106
        if (kpds(7).eq.850) lugout = 108
      else if (kpds(5).eq.151) then
        lugout  = 81
        kpds(5) = 2
c       kpds(6) = 100

cJ.Peng---2011-05-17------------NCO change Surface Pressure----
c      else if (kpds(5).eq.152) then
      else if (kpds(5).eq.134) then

        kpds(5) = 1
c        if (kpds(7).eq.1) then
        if (kpds(7).eq.0) then

	  lugout = 82
	  kpds(6) = 1
	  kpds(7) = 0
	end if
      else if (kpds(5).eq.156) then
        kpds(5) = 7
        if (kpds(7).eq.1000) lugout = 65
        if (kpds(7).eq.850) lugout = 64
        if (kpds(7).eq.700) lugout = 63
        if (kpds(7).eq.500) lugout = 62
        if (kpds(7).eq.200) lugout = 61
      else if (kpds(5).eq.157) then
        kpds(5) = 52
        if (kpds(7).eq.500) lugout  = 71
        if (kpds(7).eq.700) lugout  = 72
        if (kpds(7).eq.850) lugout  = 73
      else if (kpds(5).eq.164) then
        kpds(5) = 71
        if (kpds(7).eq.0) then
	  lugout = 84
	  kpds(6) = 200
	  kpds(7) = 0
	end if
      else if (kpds(5).eq.165) then
        kpds(5) = 33
        if (kpds(7).eq.0) then
	  lugout = 109
	  kpds(6) = 105
	  kpds(7) = 10
	end if
      else if (kpds(5).eq.166) then
        kpds(5) = 34
        if (kpds(7).eq.0) then
	  lugout = 110
	  kpds(6) = 105
	  kpds(7) = 10
	end if
      else if (kpds(5).eq.167) then
        kpds(5) = 11
        if (kpds(7).eq.0) then
	  lugout = 55
	  kpds(6) = 105
	  kpds(7) = 2
	end if
      else if (kpds(5).eq.168) then
        kpds(5) = 17
        if (kpds(7).eq.0) then
	  lugout = 58
	  kpds(6) = 105
	  kpds(7) = 2
	end if
      else if (kpds(5).eq.201) then
        kpds(5) = 15
        if (kpds(7).eq.0) then
	  lugout = 56
	  kpds(6) = 105
	  kpds(7) = 2
	end if
      else if (kpds(5).eq.202) then
        kpds(5) = 16
        if (kpds(7).eq.0) then
	  lugout = 57
	  kpds(6) = 105
	  kpds(7) = 2
	end if

c     Now make adjustments for the precip GRIB PDS parms,
c     which ECMWF did not code correctly for accumulations.

      else if (kpds(5).eq.228) then
        kpds(5) = 61
        lugout  = 83
        kpds(13) = 1
        if (kpds(14).eq.0) then
          kpds(14) = 0
          kpds(15) = 0
        else
          kpds(14) = kpds(14) - 12
          kpds(15) = kpds(14) + 12
        endif
        kpds(16) = 4
        kpds(22) = 1
      endif
c
      kpds(19) = 2
c
      if (lugout .ne. 0) then
	contflag='y'
      endif
c
 900  continue
      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine adjext (kens,ktype,kfnum,kres)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    adjext
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$
c
c     This subroutine takes the ECMWF ensemble PDS header
c     extension parameters and creates the corresponding 
c     NCEP header extension.
c
c     INPUT
c     -----
c     ktype       ECMWF flag; 10 = Control, 11 = Perturbed Fcst
c     kfnum       0 = CONTROL FORECAST, 1-nn = Perturbed Fcst, 
c                  odd number is positive pert,
C                  even number is for negative pert.
c     kres        1 - input file contains only high res control
c                 2 - input file contains low res control and
c                     perturbations 
c                 (Important to know since high res control 
c                  does NOT have a PDS extension)
c
c     OUTPUT
c     ------
c     kens        NCEP ensemble PDS extension (Bytes 41-45)
c
c
c
      integer   kens(5)
c
      kens=0
      kens(1)=1
c
      if (kres.eq.1) then
 
c       If kres=1 (this is information that is passed into this program
c       via a namelist), then you know that you are reading a file that
c       contains only HRC records, so give the current record an 
c       NCEP ensemble extension to indicate such.
 
        kens(2) = 1
        kens(3) = 1

      else

c       If kres=2 and the ktype=10, then you know that you're reading
c       a LRC record from one of the "USE" files.  As such, give it an
c       NCEP LRC designation.  If ktype=11, then you're reading one of
c       the perturbation records.

        if (ktype.eq.10) then
          kens(2) = 1
          kens(3) = 2
        else
          if (mod(kfnum,2).gt.0) then
            kens(2) = 3
          else
            kens(2) = 2
          end if
        end if

      end if
c
c     CONSECUTIVELY NUMBERED ECMWF FORECASTS MAKE UP A NEGATIVELY
c     AND POSITIVELY PERTURBED PAIR.  THIS NEXT BIT OF CODE
c     ASSOCIATES AN ID NUMBER TO A MEMBER FROM EACH PAIR.
c
      if (kres.eq.2 .and. ktype.eq.11) then
        kens(3) = (kfnum + 1) / 2
      endif
c
c     SET NMCEXT ARRAY MEMBERS 4 AND 5 EQUAL TO 1 AND 255.
c
 400  continue
c
      kens(4) = 1
      kens(5) = 255
c
      return 
      end    
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine output (lugout,kf,kpds,kgds,ld,data,kens)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    output
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$
c
      integer   kpds(200),kgds(200),kens(200)
      logical   ld(kf)
      real      data(kf)
c
c     ****************************
c      WRITE GRIB FILE
c     ****************************
c
      if ((kens(3).le.1).or.(kens(3).ge.25)) then
	if ((kpds(14).le.24).or.(kpds(14).ge.228)) then
	  print *,'at beginning of output, lugout=',lugout
     &           ,' kpds(5)=',kpds(5)
     &           ,' kens(2)=',kens(2),' kens(3)=',kens(3),' kf=',kf
c         print *,' '
	endif
      endif
      call putgbe (lugout,kf,kpds,kgds,kens,ld,data,iret)
 
      if (iret.eq.0) then
c       print *,' '
	if ((kens(3).le.1).or.(kens(3).ge.25)) then
	  if ((kpds(14).le.24).or.(kpds(14).ge.228)) then
	    print *,'IRET = 0 after call to putgbe'
c	    print *,' '
	  endif
	endif
      else
        print *,' '
        print *,'!!! ERROR: IRET NE 0 AFTER CALL TO PUTGBE !!!'
     &         ,lugout,'=lugout ',iret,'=iret '
        print *,' '
      endif
c
      return 
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
c     subroutine output_stats (cparm,ctype,kf,kpds,kgds,ld,data)
      subroutine output_stats (cparm,lugout,kf,kpds,kgds,ld,datam
     &,datas)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    output_stats
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$
c
      integer   kpds(200),kgds(200),kens(200)
      logical   ld(kf)
      real      datam(kf)
      real      datas(kf)
      character cparm*4,ctype*4

      call grib_open_wa (lugout,ireto)
      if (ireto.gt.0) then
        print *,'ireto,lu from grib_open_wa in output_stats = ',
     ,     ireto,lugout
      endif

      do istat=1,2

	 if (istat .eq. 1) ctype='mean'
	 if (istat .eq. 2) ctype='spr '

	ld = .TRUE.

        iready=1
	if (cparm .eq. 't200') then
	  kpds(5)  = 11
	  kpds(6)  = 100
	  kpds(7)  = 200
	  kpds(22) = 1
	else if (cparm .eq. 't500') then
	  kpds(5)  = 11
	  kpds(6)  = 100
	  kpds(7)  = 500
	  kpds(22) = 1
	else if (cparm .eq. 't700') then
	  kpds(5)  = 11
	  kpds(6)  = 100
	  kpds(7)  = 500
	  kpds(22) = 1
	else if (cparm .eq. 't850') then
	  kpds(5)  = 11
	  kpds(6)  = 100
	  kpds(7)  = 850
	  kpds(22) = 1
	else if (cparm .eq. 't2m') then
	  kpds(5)  = 11
	  kpds(6)  = 105
	  kpds(7)  = 2
	  kpds(22) = 1
	else if (cparm .eq. 't2mx') then
	  kpds(5)  = 15
	  kpds(6)  = 105
	  kpds(7)  = 2
	  kpds(22) = 1
	else if (cparm .eq. 't2mn') then
	  kpds(5)  = 16
	  kpds(6)  = 105
	  kpds(7)  = 2
	  kpds(22) = 1
	else if (cparm .eq. 'td2m') then
	  kpds(5)  = 17
	  kpds(6)  = 105
	  kpds(7)  = 2
	  kpds(22) = 1
	else if (cparm .eq. 'z200') then
	  kpds(5)  = 7
	  kpds(6)  = 100
	  kpds(7)  = 200
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then
	    kpds(22) = 1
	  endif
	else if (cparm .eq. 'z500') then
	  kpds(5)  = 7
	  kpds(6)  = 100
	  kpds(7)  = 500
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then
	    kpds(22) = 1
	  endif
	else if (cparm .eq. 'z700') then
	  kpds(5)  = 7
	  kpds(6)  = 100
	  kpds(7)  = 700
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then
	    kpds(22) = 1
	  endif
	else if (cparm .eq. 'z850') then
	  kpds(5)  = 7
	  kpds(6)  = 850
	  kpds(7)  = 700
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then
	    kpds(22) = 1
	  endif
c new batch 01/04
	else if (cparm .eq. 'z1k ') then
	  kpds(5)  = 7
	  kpds(6)  = 100
	  kpds(7)  = 1000
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then
	    kpds(22) = 1
	  endif
	else if (cparm .eq. 'r500') then
	  kpds(5)  = 52
	  kpds(6)  = 100
	  kpds(7)  = 500
	  kpds(22) = 1
	else if (cparm .eq. 'r700') then
	  kpds(5)  = 52
	  kpds(6)  = 100
	  kpds(7)  = 700
	  kpds(22) = 1
	else if (cparm .eq. 'r850') then
	  kpds(5)  = 52
	  kpds(6)  = 100
	  kpds(7)  = 850
	  kpds(22) = 1
	else if (cparm .eq. 'mslp') then
	  kpds(5)  = 2
	  kpds(6)  = 102
	  kpds(7)  = 0
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then 
	    kpds(22) = 1
	  endif
	else if (cparm .eq. 'psfc') then
	  kpds(5)  = 1
	  kpds(6)  = 102
	  kpds(7)  = 0
	  if (ctype .eq. 'mean') then
	    kpds(22) = 0
	  else if (ctype .eq. 'spr ') then 
	    kpds(22) = 1
	  endif
	else if (cparm .eq. 'prcp') then
	  kpds(5) = 61
	  kpds(6) = 1
	  kpds(7) = 0

C          THIS NEXT STUFF IS ALREADY DONE IN ADJPDS, 
C          SO COMMENT IT OUT HERE....
C          if (kpds(14).eq.0) then
C            kpds(14) = 0
C            kpds(15) = 0
C          else
C            kpds(14) = kpds(14) - 12
C            kpds(15) = kpds(14) + 12
C          endif

	  kpds(16) = 4
	  kpds(22) = 1
	else if (cparm .eq. 'tcdc') then
	  kpds(5) = 61
	  kpds(6) = 200
	  kpds(7) = 0
	  kpds(22) = 1
	else
	  iready=no
	endif
	kens(1)=1
	kens(2)=5
	kens(3)=0
	kens(4)=0
	kens(5)=255
	if (ctype .eq. 'mean') then
	  kens(4)=1
	else if (ctype .eq. 'spr ') then
	  kens(4)=11
	endif

c       ****************************
c        WRITE GRIB FILE
c       ****************************

        print *,'In output_stats, lugout= ',lugout,' kf= ',kf
        print *,'In output_stats, cparm= ',cparm,' ctype= ',ctype
c       print *,' '

c       if ( kpds(14) .eq. 72 ) then
c         print *,' '
	  write(*,71) (kpds(mm),mm=1,5)
	  write(*,72) (kpds(mm),mm=6,10)
	  write(*,73) (kpds(mm),mm=11,15)
	  write(*,74) (kpds(mm),mm=16,20)
	  write(*,75) (kpds(mm),mm=21,25)
	  write(*,76) (kgds(mm),mm=1,5)
	  write(*,77) (kgds(mm),mm=6,10)
	  write(*,78) (kgds(mm),mm=11,15)
	  write(*,79) (kgds(mm),mm=16,20)
	  write(*,80) (kgds(mm),mm=21,22)
	  if ( ctype .eq. 'mean' ) then
	    write(*,81) datam(1),datam(kf/4),datam(kf/2)
     &                 ,datam(3*kf/4),datam(kf)
	    call srange(kf,ld,datam)
	  endif
	  if ( ctype .eq. 'spr ' ) then
	    write(*,81) datas(1),datas(kf/4),datas(kf/2)
     &                 ,datas(3*kf/4),datas(kf)
	    call srange(kf,ld,datas)
	  endif
c         print *,' '
c       endif

 71     format('p1=  ',i7,' p2=  ',i7,' p3=  ',i7,' p4=  ',i7,' p5=  '
     &        ,i7)
 72     format('p6=  ',i7,' p7=  ',i7,' p8=  ',i7,' p9=  ',i7,' p10= '
     &        ,i7)
 73     format('p11= ',i7,' p12= ',i7,' p13= ',i7,' p14= ',i7,' p15= '
     &        ,i7)
 74     format('p16= ',i7,' p17= ',i7,' p18= ',i7,' p19= ',i7,' p20= '
     &        ,i7)
 75     format('p21= ',i7,' p22= ',i7,' p23= ',i7,' p24= ',i7,' p25= '
     &        ,i7)
 76     format('g1=  ',i7,' g2=  ',i7,' g3=  ',i7,' g4=  ',i7,' g5=  '
     &        ,i7)
 77     format('g6=  ',i7,' g7=  ',i7,' g8=  ',i7,' g9=  ',i7,' g10= '
     &        ,i7)
 78     format('g11= ',i7,' g12= ',i7,' g13= ',i7,' g14= ',i7,' g15= '
     &        ,i7)
 79     format('g16= ',i7,' g17= ',i7,' g18= ',i7,' g19= ',i7,' g20= '
     &        ,i7)
 80     format('g21= ',i7,' g22= ',i7)
 81     format('f(1)= ',g12.4,' f(kf/4)= ',g12.4,' f(kf/2)= ',g12.4
     &      ,' f(3*kf/4)= ',g12.4,' f(kf)= ',g12.4)

	iret=99

        if (iready .eq. 1) then

	  if ( ctype .eq. 'mean' ) then
	    call putgbe (lugout,kf,kpds,kgds,kens,ld,datam,iret)
	  endif
	  if ( ctype .eq. 'spr ' ) then
	    call putgbe (lugout,kf,kpds,kgds,kens,ld,datas,iret)
	  endif
	  if (iret.eq.0) then
c c         print *,' '
	    print *,'IRET = 0 after call to putgbe in sub output_stats'
c c         print *,' '
	  else
	    print *,' '
	    print *,'!!! ERROR: IRET NE 0 AFTER '
     &	           ,'PUTGBE IN OUTPUT_STATS!!!'
     &             ,cparm,'= cparm',ctype,'=ctype '
     &             ,lugout,'=lugout ',iret,'=iret '
	    print *,' '
	  endif
	else
	  print *,'This variable not ready'
     &           ,cparm,'= cparm',ctype,'=ctype '
     &           ,lugout,'=lugout ',iret,'=iret '
	endif

      enddo

      call grib_close (lugout,ireto)
      if (ireto.gt.0) then
        print *,'ireto,lu from grib_close in output_stats = ',
     ,     ireto,lugout
      endif

c
      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
          subroutine srange(nlat,ld,var)
          dimension var(nlat)
          logical ld(nlat)
c produces range, mean, avg dev, std dev, skew
          ptsn=nlat
          sa=0.0
          dmin=1.e40
          dmax=-1.e40
          do j=1,nlat
	    if (ld(j)) then
	      sa=sa+var(j)
	      dmin=min(dmin,var(j))
	      dmax=max(dmax,var(j))
	    endif
          enddo
          avg=sa/ptsn
          sl=0.0
          sv=0.0
          do j=1,nlat
	    if (ld(j)) then
	      sl=sl+abs(var(j)-avg)
	      sv=sv+(var(j)-avg)**2
	    endif
          enddo
          adev=sl/ptsn
          sdev=sqrt(sv/(ptsn-1))
          if (sdev.gt.0.0) then
            ss=0.0
            do j=1,nlat
	      if (ld(j)) then
		devn=(var(j)-avg)/sdev
		ss=ss+devn**3
	      endif
            enddo
            skew=ss/ptsn
          else
            skew=0.0
          endif
c scale for cleaner output
          outmin=1.0e10
          outmax=1.0e-10
          if ( dmin.ne.0.0 ) then
            if (outmin.gt.abs(dmin)) then
                outmin =  abs(dmin)
            endif
            if (outmax.lt.abs(dmin)) then
                outmax =  abs(dmin)
            endif
          else
            if (outmin.gt.1.0) then
                outmin =  1.0
            endif
            if (outmax.lt.1.0) then
                outmax =  1.0
            endif
          endif
          if ( dmax.ne.0.0 ) then
            if (outmin.gt.abs(dmax)) then
                outmin =  abs(dmax)
            endif
            if (outmax.lt.abs(dmax)) then
                outmax =  abs(dmax)
            endif
          else
            if (outmin.gt.1.0) then
                outmin =  1.0
            endif
            if (outmax.lt.1.0) then
                outmax =  1.0
            endif
          endif
          if (  avg.ne.0.0 ) then
            if (outmin.gt.abs(avg)) then
                outmin =  abs(avg)
            endif
            if (outmax.lt.abs(avg)) then
                outmax =  abs(avg)
            endif
          else
            if (outmin.gt.1.0) then
                outmin =  1.0
            endif
            if (outmax.lt.1.0) then
                outmax =  1.0
            endif
          endif
          if ( adev.ne.0.0 ) then
            if (outmin.gt.abs(adev)) then
                outmin =  abs(adev)
            endif
            if (outmax.lt.abs(adev)) then
                outmax =  abs(adev)
            endif
          else
            if (outmin.gt.1.0) then
                outmin =  1.0
            endif
            if (outmax.lt.1.0) then
                outmax =  1.0
            endif
          endif
          if ( sdev.ne.0.0 ) then
            if (outmin.gt.abs(sdev)) then
                outmin =  abs(sdev)
            endif
            if (outmax.lt.abs(sdev)) then
                outmax =  abs(sdev)
            endif
          else
            if (outmin.gt.1.0) then
                outmin =  1.0
            endif
            if (outmax.lt.1.0) then
                outmax =  1.0
            endif
          endif
          if ( skew.ne.0.0 ) then
            if (outmin.gt.abs(skew)) then
                outmin =  abs(skew)
            endif
            if (outmax.lt.abs(skew)) then
                outmax =  abs(skew)
            endif
          else
            if (outmin.gt.1.0) then
                outmin =  1.0
            endif
            if (outmax.lt.1.0) then
                outmax =  1.0
            endif
          endif
          if ( (outmax.lt.9.9e4) .and. (outmin.gt.1.0e-5) ) then
            write(6,'('' '',6f19.13)')    dmin,dmax,avg,adev,sdev,skew
          else
            write(6,'('' '',1p,6e19.10)') dmin,dmax,avg,adev,sdev,skew
          endif
c         print *,dmin,dmax,avg,adev,sdev,skew
          return
          end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine grange(n,ld,d,dmin,dmax)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    GRANGE
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: Calculate the maximum and minimum values in an array
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
c     n        - dimension of the array
c     ld       - logical array (bit map)
c     d        - array
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
c     dmin     - minimum value in array d
c     dmin     - maximum value in array d
C
C ATTRIBUTES:
C   MACHINE:  IBM SP
C
C$$$
      logical ld
      dimension ld(n),d(n)
c
      dmin=1.e40
      dmax=-1.e40
c
      do i=1,n
        if(ld(i)) then
          dmin=min(dmin,d(i))
          dmax=max(dmax,d(i))
        endif
      enddo
c
      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      SUBROUTINE GETGBECE(LUGB,LUGI,JF,J,JPDS,JGDS,JENS,
     &                              KF,K,KPDS,KGDS,KENS,LB,F,IRET,
     &                              ktype,kfnum,ktot)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: GETGBECE       FINDS AND UNPACKS A GRIB MESSAGE
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: FIND AND UNPACK A GRIB MESSAGE, ECMWF ENSEMBLE VERSION.
C   READ AN ASSOCIATED GRIB INDEX FILE (UNLESS IT ALREADY WAS READ).
C   FIND IN THE INDEX FILE A REFERENCE TO THE GRIB MESSAGE REQUESTED.
C   THE GRIB MESSAGE REQUEST SPECIFIES THE NUMBER OF MESSAGES TO SKIP
C   AND THE UNPACKED PDS AND GDS PARAMETERS.  (A REQUESTED PARAMETER
C   OF -1 MEANS TO ALLOW ANY VALUE OF THIS PARAMETER TO BE FOUND.)
C   IF THE REQUESTED GRIB MESSAGE IS FOUND, THEN IT IS READ FROM THE
C   GRIB FILE AND UNPACKED.  ITS MESSAGE NUMBER IS RETURNED ALONG WITH
C   THE UNPACKED PDS AND GDS PARAMETERS, THE UNPACKED BITMAP (IF ANY),
C   AND THE UNPACKED DATA.  IF THE GRIB MESSAGE IS NOT FOUND, THEN THE
C   RETURN CODE WILL BE NONZERO.
C
C PROGRAM HISTORY LOG:
C   94-04-01  IREDELL
C   97-01-17  MARCHOK - modified version for ECMWF ensemble GRIB ext.
C   01-01-16  WOBUS   - renamed and updated DOCBLOCK
C
C USAGE:    CALL GETGBECE(LUGB,LUGI,JF,J,JPDS,JGDS,JENS,
C    &                              KF,K,KPDS,KGDS,KENS,LB,F,IRET)
C   INPUT ARGUMENTS:
C     LUGB         LOGICAL UNIT OF THE UNBLOCKED GRIB DATA FILE
C     LUGI         LOGICAL UNIT OF THE UNBLOCKED GRIB INDEX FILE
C     JF           INTEGER MAXIMUM NUMBER OF DATA POINTS TO UNPACK
C     J            INTEGER NUMBER OF MESSAGES TO SKIP
C                  (=0 TO SEARCH FROM BEGINNING)
C                  (<0 TO REOPEN INDEX FILE AND SEARCH FROM BEGINNING)
C     JPDS         INTEGER (25) PDS PARAMETERS FOR WHICH TO SEARCH
C                  (=-1 FOR WILDCARD)
C     JGDS         INTEGER (22) GDS PARAMETERS FOR WHICH TO SEARCH
C                  (ONLY SEARCHED IF JPDS(3)=255)
C                  (=-1 FOR WILDCARD)
C     JENS         INTEGER (5) ENSEMBLE PDS PARMS FOR WHICH TO SEARCH
C                  (ONLY SEARCHED IF JPDS(23)=3)
C                  (=-1 FOR WILDCARD)
C   OUTPUT ARGUMENTS:
C     KF           INTEGER NUMBER OF DATA POINTS UNPACKED
C     K            INTEGER MESSAGE NUMBER UNPACKED
C                  (CAN BE SAME AS J IN CALLING PROGRAM
C                  IN ORDER TO FACILITATE MULTIPLE SEARCHES)
C     KPDS         INTEGER (25) UNPACKED PDS PARAMETERS
C     KGDS         INTEGER (22) UNPACKED GDS PARAMETERS
c
c
C     KENS         INTEGER (5) UNPACKED ENSEMBLE PDS PARMS
c
c     ***********  CODE ADDED FOR ECMWF ORIGINAL ENSEMBLE FILES  ****
c
c     ktype        10 = ECMWF control forecast
c                  11 = ECMWF perturbed forecast
c     kfnum        Ensemble Forecast Number;
c                  Control Forecast is number 0,
c                  perturbed forecast are 1-nn, where
c                  positive perturbation is an odd number,
c                  negative perturbation is an even number.
c     ktot         Total number of forecast in ensemble.
c                  This number includes the control forecast.
c
C     LB           LOGICAL (KF) UNPACKED BITMAP IF PRESENT
C     F            REAL (KF) UNPACKED DATA
C     IRET         INTEGER RETURN CODE
C                    0      ALL OK
C                    96     ERROR READING INDEX FILE
C                    97     ERROR READING GRIB FILE
C                    98     NUMBER OF DATA POINTS GREATER THAN JF
C                    99     REQUEST NOT FOUND
C                    OTHER  W3FI63 GRIB UNPACKER RETURN CODE
C
C SUBPROGRAMS CALLED:
C   BAopenr        open for BYTE-ADDRESSABLE READ, read-only
C   BAopen         open for BYTE-ADDRESSABLE READ
C   BAclose        close for BYTE-ADDRESSABLE READ
C   BAREAD         BYTE-ADDRESSABLE READ
C   GBYTEC          UNPACK BYTES
C   FI632          UNPACK PDS
C   FI633          UNPACK GDS
C   PDSEUP         UNPACK PDS EXTENSION
C   W3FI63         UNPACK GRIB
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
c IMPORTANT NOTE: THIS GETGBENS SUBROUTINE HAS BEEN MODIFIED!!!  
C                 IT IS *NOT* THE SAME GETGBENS AS IS FOUND IN  
C                 /NWPROD/W3LIB.  MODIFICATIONS WERE MADE TO IT
C                 TO BE ABLE TO READ THE ECMWF PDS EXTENSION  
c  Modified getgbens has been renamed getgbece
c
C ATTRIBUTES:
C   LANGUAGE: CRAY FORTRAN
C   LANGUAGE: ibm FORTRAN
C
C$$$
      INTEGER JPDS(25),JGDS(22),KPDS(25),KGDS(22)
      PARAMETER(LPDS=23,LGDS=22)
      INTEGER JENS(5),KENS(5)
      LOGICAL LB(JF)
      REAL F(JF)
      PARAMETER(MBUF=8192*128)
      CHARACTER CBUF(MBUF)
      SAVE LUX,NSKP,NLEN,NNUM,CBUF
      DATA LUX/0/
      CHARACTER CHEAD(2)*81
      CHARACTER CPDS(80)*1,CGDS(42)*1
C     INTEGER KPTR(16)
      INTEGER KPTR(20)
      INTEGER IPDSP(LPDS),JPDSP(LPDS),IGDSP(LGDS),JGDSP(LGDS)
      INTEGER IENSP(5),JENSP(5)
      CHARACTER GRIB(200+17*JF/8)*1
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  READ INDEX FILE
      IF(J.LT.0.OR.LUGI.NE.LUX) THEN
        call grib_open_r (lugb,ireto)
        if (ireto.gt.0) then
          print *,'ireto,lu from grib_open_r in getgbece = ',ireto,lugb
        endif
        call grib_open_r (lugi,ireto)
        if (ireto.gt.0) then
          print *,'ireto,lu from grib_open_r in getgbece = ',ireto,lugi
        endif
        print *,' in getgbece:  units b,i: ',lugb,lugi
c       REWIND LUGI
c       READ(LUGI,IOSTAT=IOS) CHEAD
c             CALL BAREAD(LUGB,LSKIP,LGRIB,LREAD,GRIB)
        ios=-1
        nskp=0
        lgrib=81
        CALL BAREAD(LUGI,NSKP,LGRIB,LREAD,CHEAD(1))
         if ( lgrib.eq.lread ) ios=0
c        print *,'ios after chead read = ',ios
         print *,'chead 42-47 = ',CHEAD(1)(42:47)
         print *,'chead 38-43 = ',CHEAD(1)(38:43)
         print *,' nskp, lgrib, lread = ',nskp,lgrib,lread
        nskp=lread
        CALL BAREAD(LUGI,NSKP,LGRIB,LREAD,CHEAD(2))
         print *,' nskp, lgrib, lread = ',nskp,lgrib,lread
        IF(IOS.EQ.0.AND.CHEAD(1)(42:47).EQ.'GB1IX1') THEN
c       IF(IOS.EQ.0.AND.CHEAD(1)(38:43).EQ.'GB1IX1') THEN
          LUX=0
         READ(CHEAD(2),'(8X,3I10,2X,A40)',IOSTAT=IOS) NSKP,NLEN,NNUM
           print *,'nlen= ',nlen,' ios= ',ios,' nskp= ',nskp,' nnum= '
     &           ,nnum
          IF(IOS.EQ.0) THEN
            NBUF=NNUM*NLEN
            IF(NBUF.GT.MBUF) THEN
              PRINT *,'GETGB: INCREASE BUFFER FROM ',MBUF,' TO ',NBUF
              NNUM=MBUF/NLEN
              NBUF=NNUM*NLEN
            ENDIF
            CALL BAREAD(LUGI,NSKP,NBUF,LBUF,CBUF)
            IF(LBUF.EQ.NBUF) THEN
c              print *,'************** lux being set equal to lugi'
              LUX=LUGI
              J=MAX(J,0)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  SEARCH FOR REQUEST
      KENS=0
      LGRIB=0
      KJ=J
      K=J
      KF=0
      IF(J.GE.0.AND.LUGI.EQ.LUX) THEN
        LPDSP=0
        DO I=1,LPDS
          IF(JPDS(I).NE.-1) THEN
            LPDSP=LPDSP+1
            IPDSP(LPDSP)=I
            JPDSP(LPDSP)=JPDS(I)
          ENDIF
        ENDDO
        LGDSP=0
        IF(JPDS(3).EQ.255) THEN
          DO I=1,LGDS
            IF(JGDS(I).NE.-1) THEN
              LGDSP=LGDSP+1
              IGDSP(LGDSP)=I
              JGDSP(LGDSP)=JGDS(I)
            ENDIF
          ENDDO
        ENDIF
        LENSP=0
        IF(JPDS(23).EQ.3 .or. jpds(23).eq.0.or.jpds(23).eq.-1) THEN
          DO I=1,5
            IF(JENS(I).NE.-1) THEN
              LENSP=LENSP+1
              IENSP(LENSP)=I
              JENSP(LENSP)=JENS(I)
            ENDIF
          ENDDO
        else
          print *,'!!! jpds(23) != 0 or 3, jpds(23)= ',jpds(23)
        ENDIF
        IRET=99
        DOWHILE(LGRIB.EQ.0.AND.KJ.LT.NNUM)
          KJ=KJ+1
          LT=0
          IF(LPDSP.GT.0) THEN
            CPDS=CBUF((KJ-1)*NLEN+26:(KJ-1)*NLEN+53)
            KPTR=0
            CALL GBYTEC(CBUF,KPTR(3),(KJ-1)*NLEN*8+25*8,3*8)
            CALL FI632(CPDS,KPTR,KPDS,IRET)
c            print *, 'after fi632, iret=',iret
            DO I=1,LPDSP
              IP=IPDSP(I)
              LT=LT+ABS(JPDS(IP)-KPDS(IP))
            ENDDO
          ENDIF
          IF(LT.EQ.0.AND.LGDSP.GT.0) THEN
            CGDS=CBUF((KJ-1)*NLEN+54:(KJ-1)*NLEN+95)
            KPTR=0
            CALL FI633(CGDS,KPTR,KGDS,IRET)
c            print *, 'after fi633, iret=',iret
            DO I=1,LGDSP
              IP=IGDSP(I)
              LT=LT+ABS(JGDS(IP)-KGDS(IP))
            ENDDO
          ENDIF
c          print *, 'lt=',lt,'lensp=',lensp
          IF(LT.EQ.0.AND.LENSP.GT.0) THEN
            CPDS(41:80)=CBUF((KJ-1)*NLEN+113:(KJ-1)*NLEN+152)
c           CALL PDSEUP(KENS,KPROB,XPROB,KCLUST,KMEMBR,45,CPDS)
            CALL ecmext(ktype,kfnum,ktot,45,CPDS)
            DO I=1,LENSP
              IP=IENSP(I)
              LT=LT+ABS(JENS(IP)-KENS(IP))
            ENDDO
          ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  READ AND UNPACK GRIB DATA
          IF(LT.EQ.0) THEN
            CALL GBYTEC(CBUF,LSKIP,(KJ-1)*NLEN*8,4*8)
            CALL GBYTEC(CBUF,LGRIB,(KJ-1)*NLEN*8+20*8,4*8)
            CGDS=CBUF((KJ-1)*NLEN+54:(KJ-1)*NLEN+95)
            KPTR=0
            CALL FI633(CGDS,KPTR,KGDS,IRET)
c           print *, 'after FI633, iret=',iret
            IF(KPDS(23).EQ.3 .or. kpds(23).eq.0.or.kpds(23).eq.-1) THEN
              CPDS(41:80)=CBUF((KJ-1)*NLEN+113:(KJ-1)*NLEN+152)
c              CALL PDSEUP(KENS,KPROB,XPROB,KCLUST,KMEMBR,45,CPDS)
              CALL ecmext(ktype,kfnum,ktot,45,CPDS)
            else
              print *,'!!! kpds(23) != 0 or 3, kpds(23)= ',kpds(23)
            ENDIF
            IF(LGRIB.LE.200+17*JF/8.AND.KGDS(2)*KGDS(3).LE.JF) THEN
              CALL BAREAD(LUGB,LSKIP,LGRIB,LREAD,GRIB)
              IF(LREAD.EQ.LGRIB) THEN
                CALL W3FI63(GRIB,KPDS,KGDS,LB,F,KPTR,IRET)
c               print *, 'after W3FI63, iret=',iret
                IF(IRET.EQ.0) THEN
                  K=KJ
                  KF=KPTR(10)
                ENDIF
              ELSE
                IRET=97
              ENDIF
            ELSE
              IRET=98
            ENDIF
          ENDIF
        ENDDO
      ELSE
        IRET=96
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      RETURN
      END
c
C----------------------------------------------------------------------c
C----------------------------------------------------------------------c
c
      SUBROUTINE ecmext(ktype,kfnum,ktot,ILAST,MSGA)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    ecmext.f    UNPACKS GRIB PDS EXTENSION 41- FOR ENSEMBLE
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: unpacks GRIB pds extension starting on byte 41 for ECMWF
c           ensemble files.  NOTE that this extension format is 
c           completely different from NCEP's extension format, and
c           this subroutine will not work if you try to read NCEP 
c           ensemble files.  This subroutine will unpack bytes 
c           41-52 of the pds header extension.
C
C PROGRAM HISTORY LOG:
c   97-01-17  Tim Marchok (Most of the code, however, is taken from 
c                          the pdseup.f subroutine, originally written
c                          by Mark Iredell and Zoltan Toth).
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
c   
C
C USAGE:    call ecmext(ktype,kfnum,ktot,ILAST,MSGA)
C   INPUT ARGUMENT LIST:
C     ILAST    - LAST BYTE TO BE UNPACKED (IF GREATER/EQUAL TO FIRST BYT
C                IN ANY OF FOUR SECTIONS BELOW, WHOLE SECTION IS PACKED.
C     MSGA     - FULL PDS SECTION, INCLUDING NEW ENSEMBLE EXTENSION
C
C   OUTPUT ARGUMENT LIST:      
c
c     *********  ECMWF PDS EXTENSION BYTE LIST  ****************
c
c     ludn       Byte 41 (Local Use Definition Number; should = 1)
c     kclass     Byte 42 (1=Operations; 2=Research)
c     ktype      Byte 43 (10=Control Fcst; 11=Perturbed Forecast)
c     kstream    Bytes 44-45 (1035=Ensemble Forecasts)
c     kver       Bytes 46-49 (Version Number/Experiment Identifier;
c                             4 ascii characters, right justified)
c     kfnum      Byte 50 (Ensemble Forecast Number;
c                         Control Forecast is number 0,
c                         perturbed forecast are 1-nn, where
c                         positive perturbation is an odd number,
c                         negative perturbation is an even number.
c     ktot       Byte 51 (Total number of forecasts in ensemble.
c                         This number includeds the control forecast).
c     -----      Byte 52 (Reserved, should be set to 0).
c
C
C REMARKS: USE PDSENS.F FOR PACKING PDS ENSEMBLE EXTENSION.
C
C ATTRIBUTES:
C   LANGUAGE: CF77 FORTRAN
C   MACHINE:  CRAY, WORKSTATIONS
C
C$$$
C
      INTEGER KENS(5),KPROB(2),KCLUST(16),KMEMBR(80)
      integer ludn,kclass,ktype,kstream,kver,kfnum,ktot
      DIMENSION XPROB(2)
      CHARACTER*1 MSGA(100)
      character*1 cver(4)
c
C     CHECKING TOTAL NUMBER OF BYTES IN PDS (IBYTES)
c      print *,' '
      CALL GBYTEC(MSGA, IBYTES, 0,24)
c      PRINT *,'IBYTES (length of pds) = ',IBYTES
      IF (ILAST.GT.IBYTES) THEN
C       ILAST=IBYTES
        PRINT *,'ERROR - THERE ARE ONLY ',IBYTES, ' BYTES IN THE PDS.'
        GO TO 333
      ENDIF
      IF (ILAST.LT.41) THEN
        PRINT *,'WARNING - SUBROUTINE FOR UNPACKING BYTES 41 AND ABOVE'
        GO TO 333
      ENDIF
C     UNPACKING FIRST SECTION (GENERAL INFORMATION)
c
      CALL GBYTEC(MSGA,ludn,40*8,8)
c      print *,'ludn= ',ludn
      CALL GBYTEC(MSGA,kclass,41*8,8)
c      print *,'kclass= ',kclass
      CALL GBYTEC(MSGA,ktype,42*8,8)
c      print *,'ktype= ',ktype
      CALL GBYTEC(MSGA,kstream,43*8,16)
c      print *,'kstream= ',kstream
c      CALL GBYTEC(MSGA,kver,45*8,32)
      do ii=1,4
        cver(ii) = msga(ii+45)
      enddo
c      print '(17a,3x,4a1)','Version Number = ',cver
      CALL GBYTEC(MSGA,kfnum,49*8,8)
c      print *,'kfnum= ',kfnum
      CALL GBYTEC(MSGA,ktot,50*8,8)
c      print *,'ktot= ',ktot
      CALL GBYTEC(MSGA,junk,51*8,8)
c      print *,'Byte 52= ',junk
c
c    &             ,' str=',kstream,' ver=',kver,' mem=',kfnum
c      print '(7(a6,i6))','  lu=',ludn,' cls=',kclass,' typ=',ktype
c     &             ,' str=',kstream,' mem=',kfnum
c     &             ,' tot=',ktot,' b52=',junk
      goto 333
C
 333  CONTINUE
      RETURN
      END
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine grib_close (lug,iret)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    grib_close
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to read from the input GRIB files.  The GRIB and index files
C     are opened with a call to baopenr.  This call to baopenr was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB-reading
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lug      The Fortran unit number for the GRIB file
C     OUTPUT:
C     iret     The return code from this subroutine

      character unitname*11
      character fname*80

      unitname(1:11) = "XLFUNIT_   "
      if (lug.lt.100) then
	write(unitname(9:10),'(I2)') lug
      else
	write(unitname(9:11),'(I3)') lug
      endif
      call getenv(unitname,fname)
c     print *,' '
c     print *,' in grib_close:  unit: ',lug
c     print *,' in grib_close:  fname: ',fname
      ioret=0
      call baclose (lug,fname,ioret)

c     print *,' ' 
c     print *,'baclose: ioret= ',ioret

      iret=0
      if (ioret /= 0) then
        print *,' '
        print *,'!!! ERROR in grib_close closing grib file'
        print *,'!!! baclose return code = ioret = ',ioret
        iret = 93
        return
      endif

      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine grib_open (lug,iret)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    grib_open
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to access the GRIB file.  The GRIB file
C     is opened with a call to baopen.  This call to baopen was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB I/O
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lug      The Fortran unit number for the GRIB file
C     OUTPUT:
C     iret     The return code from this subroutine

      character unitname*11
      character fname*80

c     unitname(1:8) = "XLFUNIT_"
      unitname(1:11) = "XLFUNIT_   "
      if (lug.lt.100) then
	write(unitname(9:10),'(I2)') lug
      else
	write(unitname(9:11),'(I3)') lug
      endif
c     write(unitname(9:10),'(I2)') lug
      call getenv(unitname,fname)
c     print *,' '
c     print *,' in grib_open:  unit: ',lug
c     print *,' in grib_open:  fname: ',fname
      ioret=0
      call baopen (lug,fname,ioret)

c     print *,' ' 
c     print *,'baopen: ioret= ',ioret

      iret=0
      if (ioret /= 0) then
        print *,' '
        print *,'!!! ERROR in grib_open opening grib file'
        print *,'!!! baopen return code = ioret = ',ioret
        iret = 93
        return
      endif

      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine grib_open_wa (lug,iret)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    grib_open_wa
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: START ABSTRACT HERE AND INDENT TO COLUMN 5 ON THE
C   FOLLOWING LINES.  PLEASE PROVIDE A BRIEF DESCRIPTION OF
C   WHAT THE SUBPROGRAM DOES.
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     INARG1   - GENERIC DESCRIPTION, INCLUDING CONTENT, UNITS,
C     INARG2   - TYPE.  EXPLAIN FUNCTION IF CONTROL VARIABLE.
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     WRKARG   - GENERIC DESCRIPTION, ETC., AS ABOVE.
C     OUTARG1  - EXPLAIN COMPLETELY IF ERROR RETURN
C     ERRFLAG  - EVEN IF MANY LINES ARE NEEDED
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to write to from the output GRIB files.  The GRIB file
C     is opened with a call to baopenwa.  This call to baopenwa was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB-writing
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lug      The Fortran unit number for the GRIB file
C     OUTPUT:
C     iret     The return code from this subroutine

c     character unitname*10
      character unitname*11
      character fname*80

c     unitname(1:8) = "XLFUNIT_"
      unitname(1:11) = "XLFUNIT_   "
      if (lug.lt.100) then
	write(unitname(9:10),'(I2)') lug
      else
	write(unitname(9:11),'(I3)') lug
      endif
c     write(unitname(9:10),'(I2)') lug
      call getenv(unitname,fname)
c     print *,' '
c     print *,' in grib_open_wa:  unit: ',lug
c     print *,' in grib_open_wa:  fname: ',fname
      ioret=0
      call baopenwa (lug,fname,ioret)

c     print *,' ' 
c     print *,'baopenwa: ioret= ',ioret

      iret=0
      if (ioret /= 0) then
        print *,' '
        print *,'!!! ERROR in grib_open_wa opening grib file'
        print *,'!!! baopenwa return code = ioret = ',ioret
        iret = 93
        return
      endif

      return
      end
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
      subroutine grib_open_r (lug,iret)
c$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    grib_open_r
C   PRGMMR: WOBUS            ORG: NP20        DATE: 2001-01-16
C
C ABSTRACT: This subroutine must be called before any attempt is
C   made to read from the input GRIB files.  The GRIB and index files
C   are opened with a call to baopenr.  This call to baopenr was not
C   needed in the cray version of this program (the files could be
C   opened with a simple Cray assign statement), but the GRIB-reading
C   utilities on the SP do require calls to this subroutine (it has
C   something to do with the GRIB I/O being done in C on the SP, and
C   the C I/O package needs an explicit open statement).
C
C PROGRAM HISTORY LOG:
C   97-01-17  MARCHOK     original program
C   01-01-16  WOBUS       added DOCBLOCK
C
C USAGE:    CALL PROGRAM-NAME(INARG1, INARG2, WRKARG, OUTARG1, ... )
C   INPUT ARGUMENT LIST:
C     lug      The Fortran unit number for the GRIB file
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     iret     The return code from this subroutine
C
C   INPUT FILES:   (DELETE IF NO INPUT FILES IN SUBPROGRAM)
C     lug      The Fortran unit number for the GRIB file
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  IBM SP
C
C$$$

C
C     INPUT:
C     OUTPUT:

c     character unitname*10
      character unitname*11
      character fname*80

c     unitname(1:8) = "XLFUNIT_"
      unitname(1:11) = "XLFUNIT_   "
      if (lug.lt.100) then
	write(unitname(9:10),'(I2)') lug
      else
	write(unitname(9:11),'(I3)') lug
      endif
c     write(unitname(9:10),'(I2)') lug
      call getenv(unitname,fname)
c     print *,' '
c     print *,' in grib_open_r:  unit: ',lug
c     print *,' in grib_open_r:  fname: ',fname
      ioret=0
      call baopenr (lug,fname,ioret)

c     print *,' ' 
c     print *,'baopenr: ioret= ',ioret

      iret=0
      if (ioret /= 0) then
        print *,' '
        print *,'!!! ERROR in sub grib_open_r opening grib file'
        print *,'!!! baopenr return code = ioret = ',ioret
        iret = 93
        return
      endif

      return
      end

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE MNEMONICS(SUBSET,NEMOS,NEMS,COMPRESS)
 
      CHARACTER SUBSET*8,NEMOS(10)*80
      LOGICAL   COMPRESS
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

      NEMOS = '          '
      NEMS = 0
 
      IF(SUBSET.EQ.'METAR') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='QMPR PRES PMSL QMDD TMDP QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='CORN QMST SST1                                   '
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'SHIPS') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='CLONH CLATH                                      '
         NEMOS(4)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(5)='CORN TOST TIMW MSST ASMP QMST SST1               '
         NEMOS(6)='RSRD  EXPRSRD                                    '
         COMPRESS = .TRUE.
         NEMS = 5
      ELSEIF(SUBSET.EQ.'SHIPSB') THEN
         NEMOS(1)='RPID YEAR MNTH DAYS HOUR MINU CLATH CLONH        '
         NEMOS(2)='HSALG HSAWS TMDB MWBT TMDP REHU                  '
         NEMOS(3)='PRES PMSL 3HPC CHPT                              '
         NEMOS(4)='MSST SST1 WDIR WSPD                              '
         NEMOS(5)='RCYR RCMO RCDY RCHR RCMI CORN HSMSL HBMSL        '
         COMPRESS = .TRUE.
         NEMS=5
      ELSEIF(SUBSET.EQ.'SHIPSU') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='CORN TOST TIMW MSST ASMP QMST SST1               '
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'SHIPUB') THEN
         NEMOS(1)='RPID YEAR MNTH DAYS HOUR MINU CLATH CLONH        '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI CORN                    '
         NEMOS(3)='HSALG HSAWS TMDB MWBT TMWB TMDP REHU             '
         NEMOS(4)='MSST DBSSX SST1 DBSSX                            '
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'DBUOY') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='QCLS QDEP QBST QCIL QCTSP QCCUR                  '
         NEMOS(5)='PSYR PSMN PSDY PSHR PSMI  PLDS                   '
         NEMOS(6)='DOMO DROT DROD HPLE DLATH DLONH                  '
         NEMOS(7)='CALT BUYT ANHT AHAC ANTP  MSDM                   '
         NEMOS(8)='CORN TOST TIWM MSST                              '
         NEMOS(9)='MRMV DTCC QMST SST1                              '
c
c Sub surface DBUOY (DCOM b001-002) are stored in MODS DBUOY for now. 
c  When reports are split between DBUOY & DBUOYSUB, DBUOY can be a 
c  compressed MODS type.  For now, must be COMPRESS = .FALSE. and needs 
c  to have NEMS = 10
c
c        COMPRESS = .TRUE.
c        NEMS = 9
         NEMOS(10)='DBSS STMP SALN DROC SPOC                        '
         COMPRESS = .FALSE.
         NEMS = 10

      ELSEIF(SUBSET.EQ.'DBUOYB') THEN
         NEMOS(1)='RPID YEAR MNTH DAYS HOUR MINU                    '
         NEMOS(2)='CORN CLONH CLATHU                                '
         NEMOS(3)='DBSS SST1 SALN                                   '
         NEMOS(4)='PCAT SST0 MSDM SSS0                              '
         NEMOS(5)='PRES PMSL 3HPC CHPT                              '
         NEMOS(6)='ANTP WDIR WSPD                                   '
         NEMOS(7)='RCTS RCYR RCMO RCDY RCHR RCMI                    '
         COMPRESS = .FALSE.
         NEMS = 7
c
      ELSEIF(SUBSET.EQ.'DBUOYSUB') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='QCLS QDEP QBST QCIL QCTSP QCCUR                  '
         NEMOS(5)='PSYR PSMN PSDY PSHR PSMI  PLDS                   '
         NEMOS(6)='DOMO DROT DROD HPLE DLATH DLONH                  '
         NEMOS(7)='CALT BUYT ANHT AHAC ANTP  MSDM                   '
         NEMOS(8)='CORN TOST TIWM MSST                              '
         NEMOS(9)='MRMV DTCC QMST SST1                              '
         NEMOS(10)='DBSS STMP SALN DROC SPOC                        '
         COMPRESS = .FALSE.
         NEMS = 10
      ELSEIF(SUBSET.EQ.'MBUOY') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='CORN TOST TIWM MSST QMST SST1                    '
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'MBUOYB') THEN
         NEMOS(1)='RPID BPID WMOR WMORS4                            '
         NEMOS(2)='YEAR MNTH DAYS HOUR MINU CLONH CLATH             '
         NEMOS(3)='SST0                                             '
         NEMOS(4)='PRES PMSL HSAWS TMDB TMP REHU HSAWS TSIG TPMI    '
         NEMOS(5)='WDIR SWPD TSIG TPMI MXGS TPMI HSAWS PCAT DBSSX   '
         NEMOS(6)='RCTS RCYR RCMO RCDY RCHR RCMI CORN               '
c         NEMOS(7)='DBSS SST1 SALN                                   '
         COMPRESS = .TRUE.
         NEMS = 6
      ELSEIF(SUBSET.EQ.'LCMAN') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='CORN TOST TIWM MSST QMST SST1                    '
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'CMANB') THEN
         NEMOS(1)='RPID YEAR MNTH DAYS HOUR MINU CLATH CLONH        '
         NEMOS(2)='HSMSL HBMSL STSN                                 '
         NEMOS(3)='PRES PMSL 3HPC CHPT 24PC PRLC GPH10              '
         COMPRESS = .TRUE.
         NEMS = 3
      ELSEIF(SUBSET.EQ.'TIDEG') THEN
         NEMOS(1)='RPID SELV                                        '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='QMPR PRES PMSL QMDD TMDP QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='CORN TOST TIWM MSST AWCK MWCK AMCK MMCK QMST SST1'
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'SLPBG') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='CORN QMPR PMSL                                   '
         COMPRESS = .TRUE.
         NEMS = 3
      ELSEIF(SUBSET.EQ.'CSTGD') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)=
     &       'QMPR PRES PMSL QMDD TMDP REHU QMAT TMDB QMWN WDIR WSPD'
         NEMOS(4)='CORN TOST TIWM MSST QMST SST1 TERC TIDER         '
         COMPRESS = .TRUE.
         NEMS = 4
      ELSEIF(SUBSET.EQ.'SSTNV'   .OR.
     .       SUBSET.EQ.'SSTNS'   .OR.
     .       SUBSET.EQ.'SSTNVH') THEN
         NEMOS(1)='YEAR MNTH DAYS HOUR MINU SECO                    '
         NEMOS(2)='SSTYPE SSTSRC SST1                               '
         COMPRESS = .TRUE.
         NEMS = 2
      ELSEIF(SUBSET.EQ.'SSMIPN') THEN
         NEMOS(1)='uses definition in subroutine ssmipn             '
         COMPRESS = .TRUE.
         NEMS = 1
      ELSEIF(SUBSET.EQ.'BATHY') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='QMAT TMDB                                        '
         NEMOS(4)='TIWM QMWN WDIR WSPD                              '
         NEMOS(5)='CORN TOWD IDGT MCMS IWTEMP WTEMPR                '
         NEMOS(6)='DBSS STMP SALN DROC SPOC                         '
         COMPRESS = .FALSE.
         NEMS = 6
      ELSEIF(SUBSET.EQ.'TESAC') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='QMAT TMDB                                        '
         NEMOS(4)='TIWM QMWN WDIR WSPD                              '
         NEMOS(5)='CORN TOWD IDGT MSDM MRMV IWTEMP WTEMPR           '
         NEMOS(6)='DBSS STMP SALN DROC SPOC                         '
         COMPRESS = .FALSE.
         NEMS = 6
      ELSEIF(SUBSET.EQ.'TRKOB') THEN
         NEMOS(1)='RPID SELV YEAR MNTH DAYS HOUR MINU               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='CORN                                             '
         NEMOS(4)='AVGPER                                           '
         NEMOS(5)='DBSS STMP SALN DROC SPOC                         '
         COMPRESS = .FALSE.
         NEMS = 5
      ELSEIF(SUBSET.EQ.'ERSHAL'  .OR.
     .       SUBSET.EQ.'TOPHAL'  .OR.
     .       SUBSET.EQ.'TOPLAL'  .OR.
     .       SUBSET.EQ.'GFOHAL')  THEN
         NEMOS(1)='YEAR MNTH DAYS HOUR MINU                         '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='CORN ECLN STKO NSLR SLHD                         '
         COMPRESS = .TRUE.
         NEMS = 3
      ELSEIF(SUBSET.EQ.'NERSAL'  .OR.
     .       SUBSET.EQ.'NGFOAL'  .OR.
     .       SUBSET.EQ.'NTPXAL'  .OR.
     .       SUBSET.EQ.'NJSNAL'  .OR.
     .       SUBSET.EQ.'ENVSAL')  THEN
         NEMOS(1)='SAID YEAR MNTH DAYS HOUR MINU SECO               '
         NEMOS(2)='RCYR RCMO RCDY RCHR RCMI                         '
         NEMOS(3)='SACYLN SCLF ORBN OBQL SLHD1                      '
         COMPRESS = .TRUE.
         NEMS = 3
      ENDIF
 
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  W3UNPKB7
C   PRGMMR: KEYSER           ORG: NP22        DATE: 2016-11-30
C
C ABSTRACT: THIS SUBROUTINE DECODES A SINGLE REPORT FROM BUFR MESSAGES
C   IN AN NCEP BUFR DATA FILE.  CURRENTLY WIND PROFILER {EXCEPT FOR,
C   THOSE ORIGINATING FROM PILOT (PIBAL) FORMAT BULLETINS, SEE
C   SUBROUTINE IW3UNPBF FOR THESE}, NEXRAD (VAD) WIND (FROM BOTH RADAR
C   CODED MESSAGE AND FROM LEVEL 2 DECODER), GOES SOUNDING/RADIANCE,
C   ERS SCATTEROMETER WIND, QUIKSCAT SCATTEROMETER WIND, WINDSAT
C   SCATTEROMETER WIND (NAVY OR NESDIS), ASCAT SCATTEROMETER WIND, RASS
C   AND GPS-IPW DATA TYPES ARE VALID.  REPORT IS RETURNED IN QUASI-
C   IW3UNPBF UNPACKED FORMAT (SEE REMARKS 5) AND DIRECTLY FROM BUFR
C   FORMAT (SEE REMARKS 6).  IN ADDITION THE ASCII STATION ID IS
C   RETURNED FOR EACH DECODED REPORT.  ALSO, INFORMATION ABOUT THE
C   INPUT DATA SET ITSELF (NAME, CENTER DATE, DUMP TIME) AND THE BUFR
C   MESSAGE TYPE IS RETURNED.
C
C PROGRAM HISTORY LOG:
C 1998-02-17  D. A. KEYSER -- ORIGINAL AUTHOR (BASED ON W3LIB ROUTINE
C     W3UNPK77)
C 1998-06-14  D. A. KEYSER -- MODIFIED WIND PROFILER CAT. 11 (HEIGHT,
C     HORIZ. SIGNIFICANCE, VERT. SIGNIFICANCE) AND VAD WIND HEADER
C     (STATION ID) PROCESSING TO ACCOUNT FOR UPDATES TO BUFRTABLE
C     MNEMONICS IN /dcom; CHANGED CHAR. 6 OF GOES STNID TO BE UNIQUE
C     FOR TWO DIFFERENT EVEN OR ODD SATELLITE ID'S (EVERY OTHER EVEN OR
C     ODD SAT. ID NOW GETS SAME CHAR. 6 TAG)
C 1998-06-15  D. A. KEYSER -- REDEFINED UNITS FOR UNPACKED WORDS 1
C     (LATITUDE), 2 (LONGITUDE), 4 (OBS. TIME) AND 11 (RECEIPT TIME) -
C     ALL TO CONFORM WITH UNPACKED IW3UNPBF FORMAT AND TO STREAMLINE
C     PROCESSING IN PREPDATA PROGRAM
C 1998-09-21  D. A. KEYSER -- SUBROUTINE NOW Y2K AND FORTRAN 90
C     COMPLIANT
C 1998-10-09  D. A. KEYSER -- CORRECTED ERROR IN RETURNING GOES
C     CAT. 8 DATA WHEN GREATER THAN 9 "LEVELS" ARE PRESENT
C 1999-01-20  D. A. KEYSER -- INCORPORATED BOB KISTLER'S CHANGES NEEDED
C     TO PORT THE CODE TO THE IBM SP
C 1999-02-12  D. A. KEYSER -- ADDED ERS SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN AN NCEP BUFR FILE
C 1999-05-17  D. A. KEYSER -- MADE FURTHER CHANGES NECESSARY TO PORT
C     THIS ROUTINE TO THE IBM SP
C 1999-11-02  D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE
C 2000-03-30  D. A. KEYSER -- CHANGE TO BY-PASS TIME-WINDOW CHECKS ON
C     BUFR MESSAGES IF TIME WINDOW VALUES ARE -6 AND +6 HOURS, RESP.
C 2000-09-22  D. A. KEYSER -- ADDED QUIKSCAT SCATTEROMETER WINDS HERE
C     NOW THAT THEY ARE PACKED IN A NCEP BUFR FILE; CORRECTED VALUE
C     FOR RETURNED RAINFALL RATE IN CAT. 10 FOR WIND PROFILER REPORTS
C 2000-12-05  D. A. KEYSER -- CHANGE TO BY-PASS TIME-WINDOW CHECKS ON
C     BUFR MESSAGES IF TIME WINDOW VALUES ARE .LE. -3 AND .GE. +2
C     HOURS, RESP. (WAS .LE. -6 AND .GE. +6) SINCE NO DATA DUMPS WILL
C     EVER BE GREATER THAN THIS TIME WINDOW SPAN; GOES SOUNDING
C     PROCESSING MODIFIED TO NOT CREATE STN. ID IF IT HAS ALREADY BEEN
C     CREATED BY BUFR_DUPSAT, ERS SCATTEROMETER PROCESSING MODIFIED TO
C     NOT CREATE STN. IF IT HAS ALREADY BEEN CREATED BY WAVE_DATASORT
C     AND QUIKSCAT SCATTEROMETER PROCESSING MODIFIED TO NOT CREATE STN.
C     ID IF IT HAS ALREADY BEEN CREATED BY WAVE_DCODQUIKSCAT
C     (OTHERWISE, MODIFIED TO CREATE AN 8-CHARACTER STN. ID FOR ALL 3
C     TYPES)
C 2001-04-06  D. A. KEYSER -- RETURNS WITH IRET = 8 IF A BUFR MESSAGE
C     READ IN HAS THE SUBSET "NC002009" - THIS INDICATES THE MESSAGE
C     CONTAINS WIND PROFILER REPORTS ORIGINATING FROM PILOT (PIBAL)
C     FORMAT BULLETINS WHICH THIS SUBR. CANNOT PROCESS; ADDED "SUBSET"
C     (BUFR MESSAGE TYPE) AS AN OUTPUT ARGUMENT; THE GOES SOUNDING/
C     RADIANCE CAT. 8 TYPES ARE NO LONGER SCALED, BUT STORED IN THE
C     SAME UNITS/ SCALING AS FOUND UPON INPUT; THE GOES SOUNDING/
C     RADIANCE CAT. 13 BRIGHTNESS TEMPERATURES ARE NOW STORED AS DEG.
C     K (PRECISE TO 10**2) RATHER THAN AS DEG. K X 100; HEADER WORD 5
C     NOW RETURNS COMPLETE DATE (YYYYMMDDHH) AND HEADER WORD 6 (WAS
C     DDHH) NOW RETURNS SATELLITE ID FOR GOES, ERS AND QUIKSCAT REPORTS
C     (FOR OTHERS IT'S MISSING); FOR GOES SOUNDINGS NOW SKIPS CAT. 12
C     LEVELS WHERE RETRIEVED GEOPOTENTIAL HGHT IS .LE. ELEVATION
C     (LOWEST RETRIEVED HEIGHT); FOR GOES SOUNDINGS NOW UNPACKS SURFACE
C     PRESSURE INTO CAT. 8 CODE FIGURE 262
C 2001-06-19  D. A. KEYSER -- RECOGNIZES BUFR TYPE/SUBTYPE 003/002 AS
C     GOES 1x1 (HI-RES) DATA, PART OF THE "GOESND" DUMP FILE; STORES
C     CLOUD COVER RATHER THAN CLOUD AMOUNT IN OUTPUT CAT. 8, C.F. 258
C     FOR GOES HI-RES REPORTS; GOES HI-RES REPORTS HAVE UNKNOWN PATH
C     AND GET PROPER STNID CHAR. 8 CHARACTER IDENTIFYING THE SAT.
C     NUMBER AND GET "H" IN STNID CHAR. 1 TO UNIQUELY IDENTIFY THEM
C     (IF STNID IS GENERATED HERE)
C 2001-07-10  D. A. KEYSER -- FOR GOESND REPORTS, NOW KEEPS SEPARATE
C     COUNT OF REPORTS WITH MISSING # FOV (E.G., CLOUD-TOP REPORTS),
C     BEFORE THESE WERE GROUPED WITH # FOV 10-25
C 2001-08-20  D. A. KEYSER -- FOR QUIKSCAT REPORTS, HEADER WORD 10
C     NOW RETURNS NUMBER OF ORIGINAL REPORTS USED TO GENERATE SUPEROBS
C     SINCE THIS IS NOW AVAILABLE IN INPUT REPROCESSED QKSWND DUMP
C     FILE (FOR NON-SUPEROBS, HARDWIRED TO 1)
C 2002-01-28  D. A. KEYSER -- THE QUALITY CODE FOR WIND PROFILER LEVELS
C     IS NOW SET TO 14 IF THE DECODED QN29 WIND QUALITY MARKER IS 12
C     (REJECT LIST) OR 14 (SDM PURGE), OTHERWISE IT IS SET TO THE
C     DECODED QUALITY CODE VALUE (BEFORE THE ON29 Q.M. WAS IGNORED);
C     THE WIND Q.M. FOR VAD WINDS LEVELS IS NOW SET TO THE DECODED QN29
C     WIND QUALITY MARKER IF IT IS 12 (REJECT LIST) OR 14 (SDM PURGE),
C     OTHERWISE IT IS SET TO THE NUMERICAL INDICATOR FOR THE DECODED
C     RMS VECTOR WIND ERROR (BEFORE THE ON29 Q.M. WAS IGNORED)
C 2002-03-05  D. A. KEYSER -- ACCOUNTS FOR CHANGES IN INPUT PROFLR
C     (WIND PROFILER BUFR DUMP FILE AFTER 5/2002: CAT. 10 SURFACE DATA
C     NOW ALL MISSING (MNEMONICS "PMSL","WDIR1","WSPD1", "TMDB",
C     "REHU", "REQV" NO LONGER AVAILABLE); CAT. 11 MNEMONICS "ACAVH",
C     "ACAVV", "SPP0", AND "NPHL" NO LONGER AVAILABLE; HEADER MNEMONIC
C     "NPSM" IS NO LONGER AVAILABLE; HEADER MNEMONIC "TPSE" REPLACES
C     "TPMI" (AVG. TIME IN MINUTES STILL OUTPUT); NUMBER OF UPPER-AIR
C     LEVELS INCR. FROM 43 TO UP TO 64 (SIZE OF OUTPUT "RDATA" ARRAY
C     INCR. FROM 720 TO 1200 TO ACCOUNT FOR THIS) (WILL STILL WORK
C     PROPERLY FOR INPUT PROFLR DUMP FILES PRIOR TO 5/2002)
C 2002-07-03  D. A. KEYSER -- COMBINED INDIVIDUAL SUBROUTINES FOR
C     PROCESSING HEADER INFORMATION FOR ALL TYPES INTO A SINGLE NEW
C     SUBROUTINE SINCE ALL WERE VERY SIMILAR; ADDED PROCESSING OF GPS-
C     IPW REPORTS HERE NOW THAT THEY ARE PACKED IN AN NCEP BUFR FILE
C     (GPSIPW - RETURNED IN NEW CATEGORY 14)
C 2004-02-02  D. A. KEYSER -- ADDED COOPERATIVE AGENCY (002/011) AND
C     JAPANESE (002/013) WIND PROFILERS TO PROCESSING FOR WIND
C     PROFILERS NOT ORIGINATING FROM PILOT (PIBAL) BULLETINS; ADDED
C     PROCESSING OF NPN AND CAP RASS REPORTS HERE (002/012) NOW THAT
C     THEY ARE PACKED IN AN NCEP BUFR FILE (RASSDA - RETURNED IN NEW
C     DATA LEVEL CATEGORY 15); ADDED NEW INPUT ARGUMENT "SUBSKP" - SEE
C     DESCRIPTION BELOW
C 2004-09-09  D. A. KEYSER -- ADDED LOGIC TO HANDLE GOES 1x1 (SFOV)
C     SOUNDING (RADIANCE/RETRIEVAL) DATA: DOES NOT Q.C. ANY 1x1 DATA
C     (CLOUD AS BEFORE, BUT NOW ALSO SNDGS) BY NUMBER OF FOV's (STILL
C     DOES SO FOR NON-RADIANCE 5x5 DATA); FOR GOES PW RETRIEVALS, IF
C     TPW IS NOT FOUND UNDER LOCAL MNEMONIC "PH2O", NOW LOOKS FOR IT IN
C     WMO MNEMONIC "TPWT", THIS ALLOWS FOR TRANSITION FROM "PH2O" TO
C     "TPWT" IN REPORTS IN DUMP FILES (~ MID-2004) AND ALSO ALLOWS
C     HISTORICAL RERUNS TO READ OLD DUMP FILES
C 2005-03-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     BUG FIX: REMOVED THIRD ARG. IN CALLS TO UNPKB709 AND UNPKB710
C     (SUBROUTINES ONLY HAVE TWO ARG.)
C 2006-07-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     MODIFIED TO HANDLE NAVY WINDSAT SCATTEROMETER WINDS (READ FROM
C     MESSAGE TYPES NC012138, GETS DUMP REPORT TYPE 583, OUTPUT IN
C     "RDATA" CAT. 10 AND SOME ELEMENTS IN "RDATA2"); ADDED RETURN
C     ARGUMENT "RDATA2", 1-DIM 21-WORD ARRAY WHICH HOLDS ADDITIONAL
C     VALUES DECODED DIRECTLY FROM BUFR (AND NOT IN "RDATA" ARRAY);
C     MOVED REPORT-TYPE SPECIFIC VALUES OUT OF RETURNED HEADER IN
C     "RDATA" TO NEW "RDATA2" ARRAY (CLEANS UP HEADER PROCESSING);
C     RAINFALL RATE IN CAT. 10 NOW RETURNED IN ORIGINAL BUFR UNITS OF
C     KG/((M**2)*SEC) INSTEAD OF MM/HOUR (WINDSAT IS ONLY TYPE TO
C     RETURN THIS); FOLDED SUBROUTINE UNPKB708 INTO UNPKB704 SINCE BOTH
C     HAD PROCESSED DATA INTO CATEGORY 10 (UNPKB708 HANDLED
C     SCATTEROMETER REPORTS, UNPKB704 HANDLED WIND PROFILER REPORTS)
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     MODIFIED TO HANDLE NESDIS WINDSAT SCATTEROMETER WINDS (READ FROM
C     MESSAGE TYPE NC012139), PROCESSING IS IDENTICAL TO NAVY WINDSAT
C     SCATTEROMETER WINDS; HANDLES GOES 1x1 F-O-V SNDGS/RADIANCES IN
C     DUMP FILE "GOESFV" (SUBSET "NC003003"); CODE FIGURE 258 REFERS
C     ONLY TO CLOUD AMOUNT (HAD ALSO PREVIOUSLY REFERRED TO CLOUD COVER
C     FOR GOES 1x1 SNDGS - GOES 1x1 AND 5x5 SNDGS NOW BOTH PROCESS
C     CLOUD AMOUNT)
C 2008-09-25  D. A. KEYSER -- ADDED ASCAT SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN A NCEP BUFR FILE (GET DUMP REPORT TYPE
C     584), RETURNED IN CATEGORY 10, EXPANDED 1-DIM OUTPUT ARRAY RDATA2
C     FROM 21 TO 24 WORDS TO HOLD NEW ANCILLARY INFO FOR ASCAT REPORTS
C     {WIND VECTOR CELL QUALITY (MNEMONIC WVCQ, BUFR F.T. 0-21-155),
C     BACKSCATTER DISTANCE (MNEMONIC BSCD, NUMERIC), LIKELIHOOD
C     COMPUTED FOR SOLUTION (MNEMONIC LKCS, NUMERIC)
C 2012-11-30  J. WOOLLEN   -- INITIAL PORT TO WCOSS; RESET BMISS TO
C     A VALUE (10E08) WHICH WILL NOT CAUSE INTEGER OVERFLOW WHICH CAN
C     BE UNPREDICTABLE (PRIOR BMISS VALUE WAS 10E10)
C 2013-02-14  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS; OBTAIN
C     VALUE OF BMISS SET IN CALLING PROGRAM VIA CALL TO BUFRLIB ROUTINE
C     GETBMISS RATHER THAN HARDWIRING IT TO 10E08 (OR 10E10); USE
C     BUFRLIB FUNCTION IBFMS TO DETERMINE IF A VARIABLE READ FROM BUFR
C     FILE IS MISSING (I.E. RETURNED AS BMISS);  USE FORMATTED PRINT
C     STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS USED (WCOSS
C     SPLITS UNFORMATTED PRINT AT 80 CHARACTERS); MAXIMUM NUMBER OF
C     CAT. 11 WIND PROFILER LEVELS THAT CAN BE PROCESSED (EXCLUDING
C     BOTTOM SURFACE LEVEL) REDUCED FROM 103 TO 102 AS FORMER CAUSED AN
C     OVERFLOW OF THE CURRENT 1200 WORD LIMIT IN RDATA ARRAY; FOR ANY
C     "GOESND" OR "GOESFV" DUMP FILES WITH CENTER TIME 2013022512 OR
C     LATER, NO ATTEMPT IS MADE TO DECODE GOES SOUNDINGS (PROFILES) AS
C     THESE WERE REMOVED AT THIS TIME FROM THE 1X1 GOES RADIANCE FILES
C     PROVIDED BY NESDIS (INGESTED INTO FROM TANK b003/xx003)
C 2014-03-13  D. A. KEYSER -- MODIFIED TO HANDLE VAD WINDS FROM LEVEL
C     2 DECODER (SUBSET "NC002017") {IN ADDITION TO THOSE FROM RADAR
C     CODED MESSAGE (SUBSET "NC002008")}; PARAMETERIZED MAXIMUM NUMBER
C     OF LEVELS ALLOWED FOR EACH CATEGORY AND CALCULATED PARAMETER
C     "IDMAX" (SIZE OF OUTPUT "RDATA" ARRAY) BASED ON THESE, ALL ARE
C     NOW PLACED IN INCLUDE FILE 'inc_w3unpkb7.inc' {IN HERE, MAXIMUM
C     NUMBER OF CAT. 04 WINDS-BY-HEIGHT LEVELS (EXCLUDING FIRST,
C     SURFACE, LEVEL), "ILVLMX_04", INCREASED FROM 64 TO 254 TO ACCOUNT
C     FOR MORE LEVELS IN NEW VAD WINDS FROM LEVEL 2 DECODER, AND
C     MAXIMUM NUMBER OF CAT. 11 WIND PROFILER LEVELS (EXCLUDING FIRST,
C     SURFACE, LEVEL), "ILVLMX_11", INCREASED FROM 102 TO 200 TO
C     ACCOUNT FOR SOME MAP PROFILERS WITH MORE LEVELS THAN BEFORE, THE
C     RESULTING "IDMAX" IS NOW 2270, UP FROM 1200 BEFORE}
C 2015-04-16 JWhiting --  RDATA2 is expanded to size 25 in order to
C     store total cloud cover (TOCC) (present in dumps of GOES cloud
C     reports) (stored in subr. UNPKB707).
C 2015-12-18 D. A. Keyser -- Updated to decode variables specific to 
C     the new WMO BUFR format for GNSS ground-based data (in dump file 
C     "gpsipw" under subset "NC012004") in order to process GPS-Met 
C     reports from this feed. Namely:
C       CLATH (high-res lat) --> stored as lat in header array returned
C        to calling program
C       CLONH (high-res lon) --> stored as lon in header array returned
C        to calling program
C       STSN (station name) --> stored as STNID returned to calling
C        program
C       TMDBST (dry-bulb temperature to nearest 0.1K) --> stored in 
C        cat. 14 returned to calling program
C       APDS (atmospheric path delay in satellite signal, m, from
C        replication where azimuth angle is zero deg. and elevation
C        angle is 90 deg.) --> this is defined as ZENITH TOTAL DELAY and
C        is stored in cat. 14 returned to calling program
C       APDE (error in atmospheric path delay in satellite signal, m,
C        from replication where azimuth angle is zero deg. and elevation
C        angle is 90 deg.) --> this is defined as ERROR IN ZENITH TOTAL
C        DELAY and is stored in cat. 14 returned to calling program
C     (Note: will still also properly decode variables in current
C     production non-standard BUFR format GPS ground-based data (in dump 
C     file "gpsipw" under subset "NC012003").
C 2016-08-15 JWhiting -- Added variable 'subset' to UNPKB709 argument
C     list so as to allow its use in testing for whether reports are 
C     from new GNSS ground-based data streams (subset=NC012004); this 
C     replaces potentially ambiguous test on missing TDEL data from 
C     previous GPS-IPW data streams.
C 2016-11-30  D. A. KEYSER --
C     Added new output real, double-precision argument array RDATA8_8 of
C     length 2 to return full-precision latitude and longitude for a
C     report.
C     BENEFIT: Although lat and lon are returned in RDATA(1:2) these are
C              at machine precison, which is normally R*4.  Now that
C              many reports in the dumps store lat/lon at 0.001 or even
C              0.00001 degree precision, and now that PREPBUFR encodes
C              YOB (lat) and XOB (lon) at 0.00001 degree precision, this
C              change will ensure that lat/lon is always accurate to
C              0.00001 degrees in all downstream processing.
C 2020-01-06  J. Dong -- In subroutine W3UNPKB7, changed the windowing
C     decade from 20 to 40 for cases when the year is represented by
C     2 digits instead of 4.
C 2020-08-20 J. DONG -- 
C     - Added processing to encode BUFR format VAD  wind (NC002018)
C       profiler wind (NC002014) tanks into prepbufr files.
C     - Defined IDSDAT to eliminate Boundary Run-Time Check Failures.
C
C
C
C USAGE:    CALL W3UNPKB7(IDATE,IHE,IHL,LUNIT,RDATA,STNID,DSNAME,
C                         RDATA2,RDATA8_8,IDSDAT,IDSDMP_8,SUBSET,SUBSKP,
C                         IRET)
C   INPUT ARGUMENT LIST:
C     IDATE    - 4-WORD ARRAY HOLDING "CENTRAL" DATE TO PROCESS
C              - (YYYY, MM, DD, HH)
C     IHE      - NUMBER OF WHOLE HOURS RELATIVE TO "IDATE" FOR DATE OF
C              - EARLIEST BUFR MESSAGE THAT IS TO BE DECODED; EARLIEST
C              - DATE IS "IDATE" + "IHE" HOURS (IF "IHE" IS POSITIVE,
C              - EARLIEST MESSAGE DATE IS AFTER "IDATE"; IF "IHE" IS
C              - NEGATIVE, EARLIEST MESSAGE DATE IS PRIOR TO "IDATE")
C              - EXAMPLE: IF IHE=1, THEN EARLIEST DATE IS 1-HR AFTER
C              - IDATE; IF IHE=-2, THEN EARLIEST DATE IS 2-HR PRIOR
C              - TO IDATE
C     IHL      - NUMBER OF WHOLE HOURS RELATIVE TO "IDATE" FOR DATE OF
C              - LATEST BUFR MESSAGE THAT IS TO BE DECODED; LATEST
C              - DATE IS "IDATE" + ("IHL" HOURS PLUS 59 MIN) IF "IHL"
C              - IS POSITIVE (LATEST MESSAGE DATE IS AFTER "IDATE"),
C              - AND "IDATE" + ("IHL"+1 HOURS MINUS 1 MIN) IF "IHL"
C              - IS NEGATIVE (LATEST MESSAGE DATE IS PRIOR TO "IDATE")
C              - EXAMPLE: IF IHL=2, THEN LATEST DATE IS 2-HR 59-MIN
C              - AFTER IDATE; IF IHL=-2, THEN LATEST DATE IS 1-HR 1-MIN
C              - PRIOR TO IDATE
C       NOTE: THERE IS NO LIMIT ON THE VALUES FOR "IHE" AND "IHL",
C              HOWEVER IF IHE IS .LE. -3 AND IHL IS .GE. +2, THEN IT
C              IS ASSUMED THAT ALL BUFR MESSAGES IN THE FILE ARE TO BE
C              PROCESSED REGARDLESS OF THEIR TIME SO IT DOESN'T MAKE
C              ANY SENSE TO SPECIFY VALUES OUTSIDE THIS RANGE.
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     SUBSKP   - TWO-DIMENSIONAL LOGICAL ARRAY WHERE ELEMENT 1 REFERS
C              - TO A PARTICULAR BUFR TYPE (RANGE 0-255) AND ELEMENT 2
C              - REFERS TO A PARTICULAR BUFR SUBTYPE (RANGE 0-200). IF
C              - SUBSKP IS SET TO TRUE FOR A PARTICULAR BUFR TYPE AND
C              - SUBTYPE, THEN ANY BUFR MESSAGE OF THIS TYPE READ IN
C              - WILL BE SKIPPED OVER {NO SUBSETS (REPORTS) WILL BE
C              - DECODED OUT OF IT AND RETURNED TO THE CALLING PROGRAM,
C              - INSTEAD THIS SUBROUTINE WILL MOVE ON TO READ THE NEXT
C              - BUFR MESSAGE IN THE FILE AND AGAIN USE SUBSKP TO SEE
C              - IF ANY SUBSETS SHOULD BE DECODED OUT OF IT}. THIS
C              - ALLOWS THIS SUBROUTINE TO QUICKLY PASS BY ANY BUFR
C              - MESSAGES WITH A TYPE/SUBTYPE THAT THE CALLING PROGRAM
C              - DOES NOT WANT DECODED.  THE LENGTH OF THIS ARRAY
C              - SHOULD ALWAYS BE HARDWIRED TO (0:255,0:200).
C     IRET     - CONTROLS DEGREE OF UNIT 6 PRINTOUT (.GE. 0 -LIMITED
C              - PRINTOUT; = -1 SOME ADDITIONAL DIAGNOSTIC PRINTOUT;
C              = .LT. -1 -EXTENSIVE PRINTOUT) (SEE REMARKS 3)
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE REPORT RETURNED AN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT (SEE REMARKS 5) (MINIMUM SIZE IS
C              - 1500 WORDS) (NOTE: DOES NOT INCLUDE STATION ID)
C     STNID    - CHARACTER*8 SINGLE REPORT STATION IDENTIFICATION (UP
C              - TO 8 CHARACTERS, LEFT-JUSTIFIED) (SEE REMARKS 4 FOR
C              - INFORMATION ON STRUCTURE OF GOES SOUNDING STNID)
C     DSNAME   - CHARACTER*8 DATA SET NAME (SAME FOR ALL REPORTS IN
C              - A COMMON INPUT DATA SET - SEE OUTPUT ARGUMENT LIST
C              - BELOW FOR IRET=1 CASE)
C     RDATA2   - 25-WORD ARRAY CONTAINING ADDITIONAL REPORT DATA NOT
C              - PRESENT IN RDATA ARRAY (DECODED DIRECTLY FROM BUFR)
C              - (SEE REMARKS 6 FOR CONTENT)
C     RDATA8_8 - 2-WORD REAL*8 ARRAY CONTAINING ADDITIONAL REPORT DATA
C                (LATITUDE AND LONGITUDE) (SEE REMARKS 7 FOR CONTENT)
C     IDSDAT   - INTEGER DATA SET CENTER DATE IN FORM YYYYMMDDHH (SAME
C              - FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - OUTPUT ARGUMENT LIST BELOW FOR IRET=1 CASE)
C     IDSDMP_8 - INTEGER*8 DATA SET DUMP TIME IN FORM YYYYMMDDHHMM
C              - (SAME FOR ALL REPORTS IN A COMMON INPUT DATA SET - SEE
C              - OUTPUT ARGUMENT LIST BELOW FOR IRET=1 CASE)
C     SUBSET   - CHARACTER*8 BUFR MESSAGE TYPE (SAME FOR ALL REPORTS
C              - IN A COMMON BUFR MESSAGE)
C     IRET     - RETURN CODE AS FOLLOWS:
C            =  0 OBSERVATION READ AND UNPACKED INTO OUTPUT ARGUMENT
C                 LOCATIONS (SEE ABOVE).  SEE REMARKS FOR CONTENTS.
C                 NEXT CALL TO W3UNPKB7 WILL RETURN NEXT OBSERVATION
C                 IN DATA SET.
C            =  1 INFORMATION ABOUT THE BUFR DATASET IS RETURNED IN
C                 THE OUTPUT ARGUMENTS DSNAME, IDSDAT, IDSDMP_8 (SEE
C                 OUTPUT ARGUMENT LIST ABOVE)
C
C                 THIS SHOULD ALWAYS OCCUR AFTER THE FIRST CALL TO
C                 THIS SUBROUTINE FOR A NEW UNIT NUMBER (I.E., A NEW
C                 DATA SET) OR IF THE INPUT DATE/TIME OR RANGE IN TIME
C                 HAS BEEN CHANGED FROM LAST CALL (I.E., A DATA SET
C                 IS ABOUT TO BE READ FROM THE TOP).  NO REPORT IS
C                 UNPACKED AT THIS POINT, AND ONLY DSNAME, IDSDAT, AND
C                 IDSDMP_8 CONTAIN INFORMATION.  ALL SUBSEQUENT CALLS
C                 TO W3UNPKB7 SHOULD RETURN THE OBSERVATIONS IN THIS
C                 DATA SET, SEQUENTIALLY, (IRET=0) UNTIL THE END OF
C                 FILE IS ENCOUNTERED (IRET=2).  THE VALUES STORED IN
C                 DSNAME, IDSDAT, AND IDSDMP_8 WILL CONTINUE TO BE
C                 RETURNED ALONG WITH EACH REPORT WHEN IRET = 0.
C            =  2 FOR NORMAL END-OF-FILE ENCOUNTERED.
C            =  3 LAT AND/OR LON DATA MISSING -- NO REPORT RETURNED.
C            =  4 SOME/ALL DATE INFORMATION MISSING -- NO REPORT
C                 RETURNED.
C            =  5 NO "CATEGORY" DATA LEVELS PROCESSED (ALL LEVELS ARE
C                 MISSING) -- NO REPORT RETURNED.
C            =  6 NUMBER OF LEVELS IN REPORT HEADER IS NOT 1 -- NO
C                 REPORT RETURNED.
C            =  7 NUMBER OF LEVELS IN ANOTHER SINGLE LEVEL SEQUENCE IS
C                 NOT 1 -- NO REPORT RETURNED.
C            =  8 REPORT IS A WIND PROFILER ORIGINATING FROM PILOT
C                 (PIBAL) FORMAT BULLETINS -- NO REPORT RETURNED.
C
C   INPUT FILES:
C     UNIT AA  - (WHERE AA IS LUNIT ABOVE) FILE HOLDING THE DATA
C              - IN THE FORM OF BUFR MESSAGES
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C   SUBPROGRAMS CALLED:
C     UNIQUE        - UNPKB701 UNPKB702 UNPKB703 UNPKB704 UNPKB705
C                   - UNPKB706 UNPKB707 UNPKB709 UNPKB710
C     LIBRARY:
C       W3NCO       - W3FI04   W3MOVDAT W3DIFDAT ERREXIT
C       BUFRLIB     - DATELEN  DUMPBF   OPENBF   READMG   UFBCNT
C                   - READSB   UFBINT   CLOSBF   NMSUB    GETBMISS
C                   - IBFMS    CBFMS    READLC   UFBREP
C
C REMARKS:
C    1) A CONDITION CODE (STOP) OF 15 WILL OCCUR IF THE INPUT DATES FOR
C       START AND/OR STOP TIME ARE SPECIFIED INCORRECTLY.
C
C
C
C    2) A CONDITION CODE (STOP) OF 22 WILL OCCUR IF THE CHARACTERS ON
C       THIS MACHINE ARE NEITHER ASCII NOR EBCDIC.
C
C
C
C    3) THE INPUT ARGUMENT "IRET" SHOULD BE SET PRIOR TO EACH CALL TO
C       THIS SUBROUTINE.
C      
C      
C      
C    4) FOR GOES SOUNDING/RADIANCE REPORTS, THE EIGHTH CHARACTER OF
C       STATION ID (stnid) IS A TAGGED AS FOLLOWS:
C          "I" - GOES-EVEN-1 (252, 256, ...) SAT. , CLEAR COLUMN  RETR.
C          "J" - GOES-EVEN-1 (252, 256, ...) SAT. , CLOUDY RETRIEVAL
C          "K" - GOES-EVEN-1 (252, 256, ...) SAT. , UNKNOWN PATH
C
C          "L" - GOES-ODD-1  (253, 257, ...) SAT. , CLEAR COLUMN  RETR.
C          "M" - GOES-ODD-1  (253, 257, ...) SAT. , CLOUDY RETRIEVAL
C          "N" - GOES-ODD-1  (253, 257, ...) SAT. , UNKNOWN PATH
C
C          "O" - GOES-EVEN-2 (254, 258, ...) SAT. , CLEAR COLUMN  RETR.
C          "P" - GOES-EVEN-2 (254, 258, ...) SAT. , CLOUDY RETRIEVAL
C          "S" - GOES-EVEN-2 (254, 258, ...) SAT. , UNKNOWN PATH
C
C          "Q" - GOES-ODD-2  (251, 255, ...) SAT. , CLEAR COLUMN  RETR.
C          "R" - GOES-ODD-2  (251, 255, ...) SAT. , CLOUDY RETRIEVAL
C          "T" - GOES-ODD-2  (251, 255, ...) SAT. , UNKNOWN PATH
C
C          "?" - SATELLITE UNKNOWN
C
C
C
C    5) CONTENTS OF AN UNPACKED REPORT IN THE "RDATA" ARRAY (MISSING
C       INTEGER DATA ARE SET TO IMISS (99999); MISSING REAL DATA ARE
C       SET TO XMISS (99999.)
C
C     (NOTE: DOES NOT INCLUDE STATION IDENTIFICATION AND "RDATA2" ARRAY
C            OUTPUT; LATITUDE AND LONGITUDE IN RDATA(1:2) ARE ALSO
C            OUTPUT IN REAL*8 IN "RDATA8_8" - SEE OUTPUT ARGUMENT
C            "STNID" ABOVE, "RDATA2" CONTENTS IN REMARKS 6. BELOW AND
C            "RDATA8_8" CONTENTS IN REMARKS 7. BELOW)
C
C   ***************************************************************
C   WORD   CONTENT                   UNIT                 FORMAT
C   ----   ----------------------    -------------------  ---------
C     1    LATITUDE                  DEGREES (N+,S-)      REAL
C     2    LONGITUDE                 DEGREES EAST         REAL
C     3    NOT USED                  MISSING              REAL
C     4    OBSERVATION TIME          HOURS (UTC)          REAL
C     5    DATE                      YYYYMMDDHH           INTEGER
C     6    SATELLITE ID      (BUFR CODE TABLE 0-01-007)   INTEGER
C                                    (SEE @)
C     7    STATION ELEVATION         METERS               REAL
C     8    INSTRUMENT TYPE           (SEE $)              INTEGER
C     9    DUMP REPORT TYPE          (SEE &)              INTEGER
C    10    DUMP REPORT SUBTYPE       MISSING              INTEGER
C    11    RECEIPT TIME              HOURS (UTC)          REAL
C    12    NOT USED                  MISSING              REAL
C
C 13-18    ZEROED OUT - NOT USED
C    19    CATEGORY  4, NO. LEVELS   COUNT                INTEGER
C    20    CATEGORY  4, DATA INDEX   COUNT                INTEGER
C 21-26    ZEROED OUT - NOT USED
C    27    CATEGORY  8, NO. LEVELS   COUNT                INTEGER
C    28    CATEGORY  8, DATA INDEX   COUNT                INTEGER
C 29-34    ZEROED OUT - NOT USED                          INTEGER
C    35    CATEGORY 10, NO. LEVELS   COUNT                INTEGER
C    36    CATEGORY 10, DATA INDEX   COUNT                INTEGER
C    37    CATEGORY 11, NO. LEVELS   COUNT                INTEGER
C    38    CATEGORY 11, DATA INDEX   COUNT                INTEGER
C    39    CATEGORY 12, NO. LEVELS   COUNT                INTEGER
C    40    CATEGORY 12, DATA INDEX   COUNT                INTEGER
C    41    CATEGORY 13, NO. LEVELS   COUNT                INTEGER
C    42    CATEGORY 13, DATA INDEX   COUNT                INTEGER
C    43    CATEGORY 14, NO. LEVELS   COUNT                INTEGER
C    44    CATEGORY 14, DATA INDEX   COUNT                INTEGER
C    45    CATEGORY 15, NO. LEVELS   COUNT                INTEGER
C    46    CATEGORY 15, DATA INDEX   COUNT                INTEGER
C 47-52    ZEROED OUT - NOT USED                          INTEGER
C
C 53-END   UNPACKED DATA GROUPS      (SEE BELOW)          MIXED
C
C    @ - WORD  6, SATELLITE ID, IS CURRENTLY SET TO MISSING FOR
C         ALL TYPES EXCEPT:
C             GOES SOUNDING/RADIANCE                 (DUMP RPT TYPE 061)
C             ERS SCATTEROMETER                      (DUMP RPT TYPE 581)
C             QUIKSCAT SCATTEROMETER                 (DUMP RPT TYPE 582)
C             WINDSAT SCATTEROMETER (NAVY or NESDIS) (DUMP RPT TYPE 583)
C             ASCAT SCATTEROMETER                    (DUMP RPT TYPE 584)
C
C    $ - WORD  8, INSTRUMENT TYPE, IS CURRENTLY SET TO MISSING FOR
C         ALL TYPES EXCEPT:
C             GOES SOUNDING/RADIANCE (DUMP REPORT TYPE 061)
C               Processing technique
C                  21       Clear
C                  23       Cloudy
C
C    & - DUMP REPORT TYPES:
C          061 - GOES sounding/radiance
C          071 - NOAA Profiler Network (NPN) wind
C          072 - NEXRAD (VAD) wind (from both Radar Coded Message and
C                from Level 2 decoder)
C          074 - GPS-IPW
C          075 - Cooperative Agency Profiler (CAP) wind
C          076 - Japanese Meteological Agency (JMA) profiler wind
C          077 - NOAA Profiler Network (NPN) or Cooperative Agency
C                Profiler (CAP) RASS temperature
C          581 - ERS scatterometer
C          582 - QuikSCAT scatterometer
C          583 - WindSat scatterometer (NAVY or NESDIS)
C          584 - ASCAT scatterometer
C
C   ***************************************************************
C
C     DATA ARE UNPACKED INTO FIXED LOCATIONS IN WORDS 1-12 AND INTO
C     INDEXED LOCATIONS IN WORD 53 AND FOLLOWING.  EACH LEVEL IN
C     THE INPUT BUFR REPORT IS STORED IN THE "DATA LEVEL CATEGORIES"
C     DESCRIBED BELOW, BASED ON THE TYPE OF DATA.  EACH DATA LEVEL
C     CATEGORY HAS A LAYOUT IN LOCATIONS IN ARRAY RDATA THAT MAY BE
C     FOUND BY USING THE CORRESPONDING INDEX AMOUNT FROM WORDS 14,
C     16, ..., 46, IN ARRAY RDATA.  FOR INSTANCE, IF A REPORT IS
C     UNPACKED INTO ONE OR MORE CATEGORY 4 DATA LEVEL GROUPS (WIND
C     DATA AT VARIABLE HEIGHT LEVELS) THAT DATA WILL BE SPECIFIED IN
C     THE UNPACKED BINARY FORMAT AS DESCRIBED BELOW UNDER DATA LEVEL
C     CATEGORY 4.  THE NUMBER OF LEVELS WILL BE STORED IN WORD
C     19 OF OBS AND THE INDEX OF THE FIRST LEVEL OF UNPACKED DATA IN
C     THE OUTPUT ARRAY WILL BE STORED IN WORD 20.  THE SECOND LEVEL,
C     IF ANY, WILL BE STORED BEGINNING FIVE WORDS FURTHER ON, AND SO
C     FORTH UNTIL THE COUNT IN WORD 19 IS EXHAUSTED.  THE FIELD
C     LAYOUT IN EACH DATA LEVEL CATEGORY IS GIVEN BELOW...
C
C
C     DATA LEVEL CATEGORY 4 - WINDS AT VARIABLE HEIGHTS (FIRST LEVEL
C                             IS SURFACE) (EACH LEVEL, SEE WORD 19
C                             ABOVE)
C      (Currently used only by VAD wind reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    HEIGHT ABOVE SEA     METERS              REAL
C            LEVEL
C       2    HORIZONTAL WIND      DEGREES             REAL
C            DIRECTION (VAD FROM RADAR CODED MESSAGE)
C            U-COMPONENT WIND     METERS/SEC          REAL
C            (VAD FROM LEVEL 2 DECODER)
C       3    HORIZONTAL WIND      0.1 METERS/SEC      REAL
C            SPEED (VAD FROM RADAR CODED MESSAGE)
C            V-COMPONENT WIND     METERS/SEC          REAL
C            (VAD FROM LEVEL 2 DECODER)
C       4    QUALITY MARKER FOR   (hardwired to 2.)   REAL
C            HEIGHT
C       5    QUALITY MARKER FOR   (SEE %)             REAL
C            WIND
C
C  %-  VALUES FROM 1-7 INDICATE A "CONFIDENCE LEVEL" WHICH IS RELATED
C       TO THE ROOT-MEAN-SQUARE VECTOR ERROR FOR THE HORIZONTAL WIND.
C       IT IS DEFINED AS FOLLOWS:
C                1.0  = RMS OF  1.9 KNOTS
C                2.0  = RMS OF  3.9 KNOTS
C                3.0  = RMS OF  5.8 KNOTS
C                4.0  = RMS OF  7.8 KNOTS (DEFAULT)
C                5.0  = RMS OF  9.7 KNOTS
C                6.0  = RMS OF 11.7 KNOTS
C                7.0  = RMS  > 13.6 KNOTS
C      VALUE 12 INDICATES THE WIND IS FLAGGED DUE TO ITS BEING ON THE
C               REJECT LIST
C      VALUE 14 INDICATES THE WIND IS FLAGGED DUE TO ITS BEING PURGED
C               MANUALLY BY THE NCEP SDM
C
C
C     DATA LEVEL CATEGORY 10 - SURFACE LEVEL (EACH LEVEL, SEE WORD 35
C                              ABOVE)
C      (Currently used by wind profiler, ERS scatterometer, QuikSCAT
C       scatterometer, WindSat scatterometer and ASCAT scatterometer
C       reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    SEA-LEVEL PRESSURE   0.1 MILLIBARS       REAL
C       2    STATION PRESSURE     0.1 MILLIBARS       REAL
C       3    HORIZ. WIND DIR.     DEGREES             REAL
C       4    HORIZ. WIND SPEED    0.1 METERS/SEC      REAL
C       5    AIR TEMPERATURE      0.1 KELVIN          REAL
C       6    RELATIVE HUMIDITY    PERCENT             REAL
C       7    RAINFALL RATE        KG/((METER**2)*SEC) REAL
C
C  Note: For wind profiler, word 2 always missing; words 1, 3-7
C         no longer available after 5/2002 (missing)
C        For ERS, QuikSCAT and ASCAT scatterometer, words 1,2, 5-7
C         always missing
C        For WindSat scatterometer, words 1,2, 5-6 always missing
C
C
C     DATA LEVEL CATEGORY 11 - UPPER-AIR LEVEL (FIRST LEVEL IS SURFACE)
C                              (EACH LEVEL, SEE WORD 37 ABOVE)
C      (Currently used only by wind profiler reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    HEIGHT ABOVE SEA-LVL METERS              REAL
C       2    HORIZ. WIND DIR.     DEGREES             REAL
C       3    HORIZ. WIND SPEED    0.1 METERS/SEC      REAL
C       4    QUALITY CODE         (SEE %)             INTEGER
C       5    VERT. WIND COMP. (W) 0.01 METERS/SEC     REAL
C(SEE @)6    HORIZ. CONSENSUS NO. (SEE $)             INTEGER
C(SEE @)7    VERT.  CONSENSUS NO. (SEE $)             INTEGER
C       8 - NOAA Profiler Network (NPN) and Cooperative Agency (CAP):
C    (SEE @) SPECTRAL PEAK POWER  DB                  REAL
C         - Japanese:
C            SIG-TO-NOISE RATIO   DB                  REAL
C       9    HORIZ. WIND SPEED    0.1 METERS/SEC      REAL
C            STANDARD DEVIATION
C      10    VERT. WIND COMPONENT 0.1 METERS/SEC      REAL
C            STANDARD DEVIATION
C(SEE @)11   MODE                 (SEE #)             INTEGER
C
C  *-  ALWAYS MISSING
C  %-  0 - MEDIAN AND SHEAR CHECKS BOTH PASSED (NPN and CAP)
C        - DATA NOT SUSPECT (JAPANESE)
C      1 - DATA SUSPECT (JAPANESE)
C      2 - MEDIAN AND SHEAR CHECK RESULTS INCONCLUSIVE (NPN and CAP)
C      3 - QUALITY INFORMATION NOT GIVEN (JAPANESE)
C      4 - MEDIAN CHECK PASSED; SHEAR CHECK FAILED (NPN and CAP)
C      8 - MEDIAN CHECK FAILED; SHEAR CHECK PASSED (NPN and CAP)
C     12 - MEDIAN AND SHEAR CHECKS BOTH FAILED (NPN and CAP)
C     14 - THE WIND IS FLAGGED DUE TO EITHER:
C               BEING ON THE REJECT LIST, OR
C               BEING PURGED MANUALLY BY THE NCEP SDM
C  $-  NO. OF INDIVIDUAL 6-MINUTE AVERAGE MEASUREMENTS THAT WERE
C      INCLUDED IN FINAL ESTIMATE OF AVERAGED WIND (RANGE: 0, 2-10)
C      (BASED ON A ONE-HOUR AVERAGE)
C  #-  1 - DATA FROM LOW MODE
C      2 - DATA FROM HIGH MODE
C      3 - MISSING
C  @-  THIS PARAMETER IS NO LONGER AVAILABLE AFTER 5/2002 AND IS SET
C      TO MISSING
C
C
C     DATA LEVEL CATEGORY 12 - SATELLITE SOUNDING LEVEL (FIRST LEVEL IS
C                              SURFACE) (EACH LEVEL, SEE WORD 39 ABOVE)
C      (Currently used only by GOES sounding/radiance reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    PRESSURE             0.1 MILLIBARS       REAL
C       2    GEOPOTENTIAL         METERS              REAL
C       3    TEMPERATURE          0.1 DEGREES C       REAL
C       4    DEWPOINT TEMPERATURE 0.1 DEGREES C       REAL
C       5    NOT USED             SET TO MISSING      REAL
C       6    NOT USED             SET TO MISSING      REAL
C       7    Q.M. FOR GEOPOT      (SEE &)             REAL
C       8    Q.M. FOR TEMPERATURE (SEE &)             REAL
C       9    Q.M. FOR DEWPT TEMP  (SEE &)             REAL
C
C  &-  2.0 - INDICATES DATA NOT SUSPECT
C      3.0 - INDICATES DATA ARE SUSPECT
C     13.0 - INDICATES DATA ARE BAD
C
C
C     DATA LEVEL CATEGORY 13 - SATELLITE RADIANCE "LEVEL" (EACH
C                              "LEVEL", SEE WORD 41 ABOVE)
C      (Currently used only by GOES sounding/radiance reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    CHANNEL NUMBER       NUMERIC             INTEGER
C       2    BRIGHTNESS TEMP.     KELVIN              REAL
C       3    Q.M. FOR BTEMP       (SEE &)             REAL
C
C  &-  2.0 - INDICATES DATA NOT SUSPECT
C      3.0 - INDICATES DATA ARE SUSPECT
C     13.0 - INDICATES DATA ARE BAD
C
C
C     DATA LEVEL CATEGORY 14 - GPS-IPW DATA (FIRST LEVEL IS SURFACE)
C                              (EACH LEVEL, SEE WORD 43 ABOVE)
C      (Currently used only by GPS-IPW reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    STATION PRESSURE     MILLIBARS           REAL
C       2    AIR TEMPERATURE      KELVIN              REAL
C       3    RELATIVE HUMIDITY    PERCENT             REAL
C       4    TOTAL PRECIP. WATER  MILLIMETERS         REAL
C       5    ZENITH TOTAL DELAY   METERS              REAL
C       6    ERROR IN ZENITH      METERS              REAL
C            TOTAL DELAY
C       7    HYDROSTATIC DELAY    METERS              REAL
C       8    ERROR IN HYDROSTATIC METERS              REAL
C            DELAY
C       9    WEIGHTED MEAN        KELVIN              REAL
C            TEMPERATURE
C      10    WET DELAY MAPPING    NUMERIC             REAL
C            FUNCTION    
C
C
C     DATA LEVEL CATEGORY 15 - RASS DATA (FIRST LEVEL IS SURFACE)
C                              (EACH LEVEL, SEE WORD 45 ABOVE)
C      (Currently used only by RASS reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    HEIGHT ABOVE SEA-LVL METERS              REAL
C       2    VIRTUAL TEMPERATURE  KELVIN              REAL
C       3    QUALITY CODE         (SEE %)             INTEGER
C
C  %-  0 - MEDIAN AND SHEAR CHECKS BOTH PASSED
C      2 - MEDIAN AND SHEAR CHECK RESULTS INCONCLUSIVE
C      4 - MEDIAN CHECK PASSED; SHEAR CHECK FAILED
C      8 - MEDIAN CHECK FAILED; SHEAR CHECK PASSED
C     12 - MEDIAN AND SHEAR CHECKS BOTH FAILED
C     14 - THE WIND IS FLAGGED DUE TO EITHER:
C               BEING ON THE REJECT LIST, OR
C               BEING PURGED MANUALLY BY THE NCEP SDM
C
C
C     DATA LEVEL CATEGORY 08 - ADDITIONAL (MISCELLANEOUS) DATA (EACH
C                              "LEVEL", SEE @ BELOW)
C      (Currently used only by GOES sounding/radiance reports)
C
C     WORD   PARAMETER            UNITS               FORMAT
C     ----   ---------            -----------------   -------------
C       1    VARIABLE             (SEE @)             REAL
C       2    CODE FIGURE          (SEE @)             REAL
C       3    Q.M. FOR THE DATUM   (SEE &)             REAL
C       4    NOT USED                                 REAL
C
C  @-  NUMBER OF "LEVELS" FROM WORD 27.  MAXIMUM IS "ILVLMX_08"
C       (CURRENTLY SET TO 13), AND ARE ORDERED AS FOLLOWS (IF A DATUM
C        ARE MISSING THAT LEVEL NOT STORED)
C           1 - LIFTED INDEX ---------- KELVIN ----------- C. FIG. 250.
C           2 - TOTAL PRECIP. WATER  -- MILLIMETERS ------ C. FIG. 251.
C           3 - 1. TO .9 SIGMA P.WATER- MILLIMETERS ------ C. FIG. 252.
C           4 - .9 TO .7 SIGMA P.WATER- MILLIMETERS ------ C. FIG. 253.
C           5 - .7 TO .3 SIGMA P.WATER- MILLIMETERS ------ C. FIG. 254.
C           6 -  SKIN TEMPERATURE ----- KELVIN ----------- C. FIG. 255.
C           7 -  CLOUD TOP TEMPERATURE- KELVIN ----------- C. FIG. 256.
C           8 -  CLOUD TOP PRESSURE --- MILLIBARS -------- C. FIG. 257.
C           9 -  CLOUD AMOUNT (BUFR TBL. C.T. 0-20-011) -- C. FIG. 258.
C          10 -  INSTR. DATA USED IN PROC.
C                             (BUFR TBL. C.T. 0-02-021) -- C. FIG. 259.
C          11 -  SOLAR ZENITH ANGLE --- DEGREE ----------- C. FIG. 260.
C          12 -  SAT. ZENITH ANGLE ---- DEGREE ----------- C. FIG. 261.
C          13 -  SURFACE PRESSURE ----- MILLIBARS -------- C. FIG. 262.
C
C  &-  2.0 - INDICATES DATA NOT SUSPECT
C      3.0 - INDICATES DATA ARE SUSPECT
C     13.0 - INDICATES DATA ARE BAD
C
C
C
C    6) CONTENTS OF AN UNPACKED REPORT IN THE "RDATA2" ARRAY (DECODED
C       DIRECTLY FROM BUFR, ALL VALUES ARE IN REAL FORMAT; MISSING DATA
C       ARE SET TO "BMISS", AS IN BUFR)
C
C   WORD   CONTENT                                  BUFR FXY UNIT
C   ----   ---------------------------------------- -------- ----------
C     1    TIME SIGNIFICANCE                        0-08-021 CODE TABLE
C     2    TOTAL NUMBER (WITH RESPECT TO            0-08-022 NUMERIC
C          ACCUMULATION OR AVERAGE) (i.e., F-O-V
C          number for GOES sounding/radiance; # of
C          orig. reports used to generate superob
C          for QuikSCAT, WindSAT and ASCAT - for
C          non-superobs, hardwired to 1)
C     3    ACROSS-SWATH CELL NUMBER                 0-06-034 NUMERIC
C     4    ALONG-TRACK ROW NUMBER                   0-05-034 NUMERIC
C     5    WIND PROFILER SUBMODE INFORMATION        0-25-033 CODE TABLE
C            Note: Submode is missing after 5/2002
C                  (no longer available)
C     6    TIME PERIOD OR DISPLACEMENT              0-04-025 MINUTE
C            (i.e., AVERAGING TIME)
C            Note: A negative number means prior to
C                  observation time
C     7    QUALITY INFORMATION                      0-33-002 CODE TABLE
C     8    SEAWINDS PROBABILITY OF RAIN             0-21-120 NUMERIC
C
C     9    SEA SURFACE TEMPERATURE                  0-22-043 KELVIN
C    10    TOTAL WATER VAPOR                        0-13-096 KG/METER**2
C    11    TOTAL CLOUD LIQUID WATER                 0-13-097 KG/METER**2
C    12    WINDSAT SURFACE TYPE                     0-20-219 CODE TABLE
C    13    MODEL WIND DIRECTION AT 10 METERS        0-11-081 DEGREES
C    14    MODEL WIND SPEED AT 10 METERS            0-11-082 METERS/SEC
C    15    WINDSAT EDR Q.C. FLAG # 1                0-33-200 FLAG TABLE
C    16    CHI-SQUARED (OF THE WIND VECTOR          0-33-199 NUMERIC
C          RETRIEVAL)
C    17    ESTIMATED ERROR COVARIANCE FOR WIND      0-33-201 DEGREES
C          DIRECTION RETRIEVAL
C    18    ESTIMATED ERROR COVARIANCE FOR WIND      0-33-246 METERS/SEC
C          SPEED RETRIEVAL
C    19    ESTIMATED ERROR COVARIANCE FOR SEA       0-33-245 KELVIN
C          SURFACE TEMPERATURE RETRIEVAL
C    20    ESTIMATED ERROR COVARIANCE FOR TOTAL     0-33-248 KG/METER**2
C          CLOUD LIQUID WATER RETRIEVAL
C    21    ESTIMATED ERROR COVARIANCE FOR TOTAL     0-33-247 KG/METER**2
C          WATER VAPOR RETRIEVAL
C    22    WIND VECTOR CELL QUALITY                 0-21-155 FLAG TABLE
C    23    BACKSCATTER DISTANCE                     0-21-156 NUMERIC
C    24    LIKELIHOOD COMPUTED FOR SOLUTION         0-21-104 NUMERIC
C    25    TOTAL CLOUD COVER                        0-21-010 PERCENT
C
C
C
C    7) CONTENTS OF AN UNPACKED REPORT IN THE "RDATA8_8" ARRAY
C       (ALL VALUES ARE IN REAL*8`FORMAT; MISSING DATA ARE SET TO
C        "BMISS")
C
C   WORD   CONTENT                            UNIT
C   ----   --------------------------------   -------------------
C     1    LATITUDE                           DEGREES (N+,S-)
C     2    LONGITUDE                          DEGREES (E+,W-)
C
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE W3UNPKB7(IDATE,IHE,IHL,LUNIT,RDATA,STNID,DSNAME,RDATA2,
     $ rdata8_8,IDSDAT,IDSDMP_8,SUBSET,SUBSKP,IRET)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*8 STNID,SUBSET,DSNAME,CBUFR

      REAL        RINC_O(5),RINC_I(5),RDATA2(25),RDATA(*),RDATX(IDMAX)
      REAL(8)     RDATA2_8(25),rdata8_8(2)
      REAL(8)     BMISS,GETBMISS

      INTEGER     IDATE(4),LSDATE(4),IDATA(IDMAX),JDATE(8)
      INTEGER(8)  IDSDAT,IDSDMP_8,IDDATE_8(5)

      LOGICAL     SUBSKP(0:255,0:200),SKIP_CAT12

      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/KDATE(8),LDATE(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7CC/INDEX
      COMMON /PKB7DD/LSHE,LSHL,ICDATE(5),IDDATE(5)
      COMMON /PKB7FF/IFOV(4,2),KNTSAT(250:260)
      COMMON /PKB7HH/NPRINT(0:255,0:200)

      SAVE
 
      EQUIVALENCE (RDATX,IDATA)

      DATA ITM/0/,LUNITL/-99/

      IF(IRET.LT.0)  IPRINT = IABS(IRET)
      IRET = 0
      IF(ITM.EQ.0)  THEN
C-----------------------------------------------------------------------

C FIRST AND ONLY TIME INTO THIS SUBROUTINE DO A FEW THINGS....

         ITM = 1
         IFOV = 0
         KNTSAT = 0
C DETERMINE MACHINE WORD LENGTH IN BYTES AND TYPE OF CHARACTER SET
C  {ASCII(ICHTP=0) OR EBCDIC(ICHTP=1)}
         CALL W3FI04(IENDN,ICHTP,LW)
         PRINT 2213, LW, ICHTP, IENDN
 2213    FORMAT(/' ---> W3UNPKB7: CALL TO W3FI04 RETURNS: LW = ',I3,
     $    ', ICHTP = ',I3,', IENDN = ',I3/)
         IF(ICHTP.GT.1)  THEN
C CHARACTERS ON THIS MACHINE ARE NEITHER ASCII OR EBCDIC!! -- STOP 22
            PRINT 217
  217       FORMAT(' *** W3UNPKB7 ERROR: CHARACTERS ON THIS MACHINE ',
     $       'ARE NEITHER ASCII NOR EBCDIC - STOP 22'/)
            CALL ERREXIT(22)
         END IF
         IDAT10 = 1000000*IDATE(1)+10000*IDATE(2)+100*IDATE(3)+IDATE(4)
         SKIP_CAT12 = IDAT10.GE.2013022512
C-----------------------------------------------------------------------
      END IF
      IF(LUNIT.NE.LUNITL)  THEN
C-----------------------------------------------------------------------

C IF THE INPUT DATA UNIT NUMBER ARGUMENT IS DIFFERENT THAN THE LAST TIME
C  THIS SUBR. WAS CALLED, PRINT NEW HEADER, SET JRET = 1

         LUNITL = LUNIT
         JRET = 1
         PRINT 101, LUNIT
  101    FORMAT(//' ---> W3UNPKB7: WCOSS VERSION 01/06/2020: NCEP ',
     $    'BUFR DATA SET READ FROM UNIT ',I4/)

         BMISS = GETBMISS()
         print'(1X)'
         print'(" BUFRLIB value for missing passed into W3UNPKB7 is: ",
     $    G0)', bmiss
         print'(1X)'
         IF(IPRINT.GE.1)  THEN
            print *, 'IDATS= ',IDATS
            print *, 'ILVLMX_04= ',ILVLMX_04
            print *, 'ILVLMX_08= ',ILVLMX_08
            print *, 'ILVL_10  = ',ILVL_10
            print *, 'ILVLMX_11= ',ILVLMX_11
            print *, 'ILVLMX_12= ',ILVLMX_12
            print *, 'ILVLMX_13= ',ILVLMX_13
            print *, 'ILVL_14  = ',ILVL_14
            print *, 'ILVLMX_15= ',ILVLMX_15
            print *, 'IDMAX_VAD= ',IDMAX_VAD
            print *, 'IDMAX_PROF= ',IDMAX_PROF
            print *, 'IDMAX_SCAT= ',IDMAX_SCAT
            print *, 'IDMAX_GOES= ',IDMAX_GOES
            print *, 'IDMAX_GPS= ',IDMAX_GPS
            print *, 'IDMAX_RASS= ',IDMAX_RASS
            print *, 'IDMAX= ',IDMAX
         END IF

C-----------------------------------------------------------------------
      ELSE

C FOR SUBSEQUENT TIMES INTO THIS SUBR. W/ SAME LUNIT AS LAST TIME,
C  TEST INPUT DATE & HR RANGE ARGUMENTS AGAINST THEIR VALUES THE LAST
C  TIME SUBR. CALLED -- IF THEY ARE DIFFERENT, SET JRET = 1 (ELSE
C  JRET = 0), WILL TEST JRET SOON

         JRET = 1
         DO I = 4,1,-1
            IF(IDATE(I).NE.LSDATE(I))  GO TO 88
         ENDDO
         IF(IHE.NE.LSHE.OR.IHL.NE.LSHL)  GO TO 88
         JRET = 0
   88    CONTINUE
C-----------------------------------------------------------------------
      END IF
      IF(JRET.EQ.1)  THEN
         PRINT 6680
 6680 FORMAT(/' JRET = 1 - REWIND DATA FILE & SET-UP TO DO DATE CHECK'/)
C-----------------------------------------------------------------------

C COME HERE IF FIRST CALL TO SUBROUTINE OR IF INPUT DATA UNIT NUMBER OR
C  IF INPUT DATE/TIME OR RANGE IN TIME HAS BEEN CHANGED FROM LAST CALL
 
C           CLOSE BUFR DATA SET (IN CASE OPEN FROM PREVIOUS RUN)
C                     REWIND INPUT BUFR DATA SET

C          TEST THAT THE DATA SET IS NOT-NULL AND THAT IT IS BUFR

C         GET CENTER TIME, DUMP TIME, AND DATA SET NAME FOR RETURN

C                          OPEN BUFR DATA SET

C        SET INDEX=0, FORCES THE NEXT CALL TO THIS SUBROUTINE TO
C         READ IN A BUFR MESSAGE BEFORE ANY REPORTS ARE DECODED)

C     SET-UP TO DETERMINE IF BUFR MESSAGE IS WITHIN REQUESTED DATES

C       RETURN WITH IRET = 1 (NO REPORTS RETURNED UNTIL NEXT CALL)

C-----------------------------------------------------------------------

         CALL CLOSBF(LUNIT)

         REWIND LUNIT

         READ(LUNIT,END=9999,ERR=8888,FMT='(A8)') CBUFR
         IF(CBUFR(1:4).EQ.'BUFR') THEN
C COME HERE IF UNBLOCKED BUFR FILE IS INPUT
            PRINT'(" W3UNPKB7 - INPUT FILE ON UNIT ",I0, " IS",
     $      " UNBLOCKED NCEP BUFR"/)', LUNIT
         ELSE  IF(CBUFR(5:8).EQ.'BUFR') THEN
C COME HERE IF BLOCKED BUFR FILE IS INPUT
            PRINT'(" W3UNPKB7 - INPUT FILE ON UNIT ",I0, " IS",
     $      " BLOCKED NCEP BUFR"/)', LUNIT
         ELSE
C COME HERE IF NON-BUFR FILE IS INPUT - RETURN WITH IRET = 2
            PRINT 8764, LUNIT
 8764 FORMAT(' *** W3UNPKB7 ERROR: INPUT FILE ON UNIT  ',I2,'  IS ',
     $ 'NOT BUFR -- ALL DONE WITH THIS FILE (IRET = 2)')
            GO TO 9998
         END IF

         CALL DATELEN(10)

         CALL DUMPBF(LUNIT,ICDATE,IDDATE)
         print'(" CENTER DATE (ICDATE) = ",5(I0,1X))', icdate
         print'(" DUMP DATE (IDDATE)   = ",5(I0,1X))', iddate

         IF(ICDATE(1).LE.0)  THEN
C COME HERE IF CENTER DATE COULD NOT BE READ FROM FIRST DUMMY MESSAGE
C  - RETURN WITH IRET = 2
            PRINT'(" *** W3UNPKB7 ERROR: CENTER DATE COULD NOT BE ",
     $       "OBTAINED FROM INPUT FILE ON UNIT ",I0)', LUNIT
            GO TO 9998
         END IF
         IF(IDDATE(1).LE.0)  THEN
C COME HERE IF DUMP DATE COULD NOT BE READ FROM SECOND DUMMY MESSAGE
C  - RETURN WITH IRET = 2
            PRINT'(" *** W3UNPKB7 ERROR: DUMP DATE COULD NOT BE ",
     $       "OBTAINED FROM INPUT FILE ON UNIT ",I0)', LUNIT
            GO TO 9998
         END IF
         IF(ICDATE(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN ICDATE(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

            PRINT'(" ##W3UNPKB7 - THE FOLLOWING SHOULD NEVER ",
     $       "HAPPEN!!!!!")'
            PRINT'(" ##W3UNPKB7 - 2-DIGIT YEAR IN ICDATE(1) RETURNED ",
     $       "FROM DUMPBF (ICDATE IS: ",I5,4I3.2,") - USE WINDOWING ",
     $       "TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', ICDATE
C IF ICDATE=41~99 THEN ICDATE=1941~1999
C IF ICDATE=00~40 THEN ICDATE=2000~2040
            IF(ICDATE(1).GT.40)  THEN
               ICDATE(1) = 1900 + ICDATE(1)
            ELSE
               ICDATE(1) = 2000 + ICDATE(1)
            ENDIF
            PRINT'(" ##W3UNPKB7 - CORRECTED ICDATE(1) WITH 4-DIGIT ",
     $       "YEAR, ICDATE NOW IS: ",I5,4I3.2)', ICDATE
         ENDIF
         IDSDAT = ICDATE(1)*1000000+ICDATE(2)*10000+ICDATE(3)*100+
     $    ICDATE(4)

         IF(IDDATE(1).LT.100)  THEN

C IF 2-DIGIT YEAR RETURNED IN IDDATE(1), MUST USE "WINDOWING" TECHNIQUE
C  TO CREATE A 4-DIGIT YEAR

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

            PRINT'(" ##W3UNPKB7 - THE FOLLOWING SHOULD NEVER ",
     $       "HAPPEN!!!!!")'
            PRINT'(" ##W3UNPKB7 - 2-DIGIT YEAR IN IDDATE(1) RETURNED ",
     $       "FROM DUMPBF (IDDATE IS: ",I5,4I3.2,") - USE WINDOWING ",
     $       "TECHNIQUE TO OBTAIN 4-DIGIT YEAR")', IDDATE
C IF IDDATE=41~99 THEN IDDATE=1941~1999
C IF IDDATE=00~40 THEN IDDATE=2000~2040
            IF(IDDATE(1).GT.40)  THEN
               IDDATE(1) = 1900 + IDDATE(1)
            ELSE
               IDDATE(1) = 2000 + IDDATE(1)
            ENDIF
            PRINT'(" ##W3UNPKB7 - CORRECTED IDDATE(1) WITH 4-DIGIT ",
     $       "YEAR, IDDATE NOW IS: ",I5,4I3.2)', IDDATE
         END IF
         IDDATE_8 = IDDATE
         IDSDMP_8 = IDDATE_8(1)*100000000+IDDATE_8(2)*1000000+
     $    IDDATE_8(3)*10000+IDDATE_8(4)*100+IDDATE_8(5)
 
C  OPEN BUFR FILE - READ IN DICTIONARY MESSAGES (TABLE A, B, D ENTRIES)
 
         CALL OPENBF(LUNIT,'IN',LUNIT)
         PRINT 100, LUNIT
  100    FORMAT(/5X,'===> BUFR DATA SET IN UNIT',I3,' SUCCESSFULLY ',
     $    'OPENED FOR INPUT; DCTNY MESSAGES CONTAIN BUFR TABLES A,B,D'/)
 
c.......................................................................
C This next call, I believe, is needed only because SUBSET is not
C  returned in DUMPBF and we need it in order to return dsname -
C  after dsname is retrieved then close and reopen data set ..
 
         call readmg(lunit,subset,ibdate,kret)
         if(subset.eq.'NC002007' .or. subset.eq.'NC002009' .or. 
     $      subset.eq.'NC002011' .or. subset.eq.'NC002013' .or.
     $      subset.eq.'NC002014' )  then
            dsname = 'PROFLR  '
         else  if(subset.eq.'NC002008' .or. subset.EQ.'NC002017' .or.
     $            subset.EQ.'NC002018' )  then
            dsname = 'VADWND  '
         else  if(subset.EQ.'NC003001' .or. subset.EQ.'NC003002')  then
            dsname = 'GOESND  '
         else  if(subset.EQ.'NC003003')  then
            dsname = 'GOESFV  '
         else  if(subset.EQ.'NC012008')  then
            dsname = 'ERS1DA  '
         else  if(subset.EQ.'NC012137')  then
            dsname = 'QKSWND  '
         else  if(subset.EQ.'NC012003' .or. subset.EQ.'NC012004')  then
            dsname = 'GPSIPW  '
         else  if(subset.EQ.'NC002012')  then
            dsname = 'RASSDA  '
         else  if(subset.EQ.'NC012138' .or. subset.EQ.'NC012139')  then
            dsname = 'WDSATR  '
         else  if(subset.EQ.'NC012122')  then
            dsname = 'ASCATW  '
         else
            dsname = '????????'
         end if
         call closbf(lunit)
         call openbf(lunit,'IN',lunit)
ccccc    CALL OPENBF(0,'QUIET',1) ! will generate diagnostic print if
ccccc                             ! an embedded BUFR table is read
c.......................................................................

         INDEX = 0
         JDATE(1:3) = IDATE(1:3)
         JDATE(4) = 0
         JDATE(5) = IDATE(4)
         JDATE(6:8) = 0
         PRINT 6681, IDATE
 6681 FORMAT(/' %%% REQUESTED "CENTRAL" DATE IS :',I5,3I3,'  0'/)

         IF(IHE.LE.-3.AND.IHL.GE.2)  THEN
            KTIMCH = 0
            PRINT 6998
 6998 FORMAT(/' --> W3UNPKB7: THERE IS NO TIME WINDOW CONSTRAINT FOR ',
     $ 'ACCEPTING BUFR MESSAGES'/)
            KDATE = 0
            LDATE = 0
         ELSE
            KTIMCH    = 1
            RINC_I    = 0.
            RINC_I(2) = REAL(IHE)
C DETERMINE EARLIEST DATE FOR ACCEPTING BUFR MESSAGES FOR DECODING
            CALL W3MOVDAT(RINC_I,JDATE,KDATE)
            PRINT 6682, (KDATE(I),I=1,3),KDATE(5),KDATE(6)
 6682 FORMAT(/' --> EARLIEST DATE FOR ACCEPTING BUFR MSGS IS:',I5,4I3/)
C DETERMINE LATEST   DATE FOR ACCEPTING BUFR MESSAGES FOR DECODING
            IF(IHL.GE.0)  THEN
              XMINL = (IHL * 60) + 59
            ELSE
              XMINL = ((IHL + 1) * 60) - 1
            END IF
            RINC_I    = 0.
            RINC_I(3) = XMINL
            CALL W3MOVDAT(RINC_I,jdate,ldate)
            PRINT 6683, (LDATE(I),I=1,3),LDATE(5),LDATE(6)
 6683 FORMAT(/' -->  LATEST  DATE FOR ACCEPTING BUFR MSGS IS:',I5,4I3/)
            CALL W3DIFDAT(LDATE,KDATE,3,RINC_O)
            IF(RINC_O(3).LT.0)  THEN
               PRINT 104
  104 FORMAT(' *** W3UNPKB7 ERROR: DATES SPECIFIED INCORRECTLY - STOP ',
     $ '15'/)
               CALL ERREXIT(15)
            END IF
            NPRINT = 0
         END IF
         IRET = 1
         GO TO 99

C-----------------------------------------------------------------------
      END IF
C SUBR. UNPKB701 RETURNS A SINGLE DECODED REPORT FROM BUFR MESSAGE
      CALL UNPKB701(LUNIT,ITP,SUBSET,SUBSKP,IRET)
      IF(IRET.EQ.2)  THEN
C IRET=2 MEANS ALL DATA HAVE BEEN DECODED FOR SPECIFIED TIME PERIOD
C  (REWIND DATA FILE AND RETURN W/ IRET=2)
         REWIND LUNIT
         IF(ITP.EQ.4)  THEN
            IF(MAX(IFOV(1,1),IFOV(2,1),IFOV(3,1),IFOV(4,1)).GT.0)  THEN
               PRINT 8101, (IFOV(III,1),III=1,4)
 8101 FORMAT(/' ---> W3UNPKB7: SUMMARY OF GOES 5X5 REPORT COUNTS ',
     $ 'GROUPED BY F-O-V NO. (PRIOR TO ANY FILTERING BY CALLING ',
     $ 'PROGRAM)'/15X,
     $ '# WITH F-O-V NO. 00 TO 02:',I8,' - GET "BAD" Q.MARK'/15X,
     $ '# WITH F-O-V NO. 03 TO 09:',I8,' - GET "SUSPECT" Q.MARK'/15X,
     $ '# WITH F-O-V NO. 10 TO 25:',I8,' - GET "NEUTRAL" Q.MARK'/15X,
     $ '# WITH MISSING F-O-V:     ',I8,' - GET "NEUTRAL" Q.MARK'/20X,
     $ '(NOTE: RADIANCES ALWAYS HAVE NEUTRAL Q.MARK REGARDLESS OF FOV ',
     $ 'NUMBER)'/)
            END IF
            IF(MAX(IFOV(1,2),IFOV(2,2),IFOV(3,2),IFOV(4,2)).GT.0)  THEN
               PRINT 8201, (IFOV(III,2),III=1,4)
 8201 FORMAT(/' ---> W3UNPKB7: SUMMARY OF GOES 1X1 REPORT COUNTS ',
     $ 'GROUPED BY F-O-V NO. (PRIOR TO ANY FILTERING BY CALLING ',
     $ 'PROGRAM)'/15X,'(ALL GET "NEUTRAL" Q. MARK)'/15X,
     $ '# WITH F-O-V NO. 01:             ',I8/15X,
     $ '# WITH F-O-V NO. 02:             ',I8/15X,
     $ '# WITH F-O-V NO. 03:             ',I8/15X,
     $ '# WITH F-O-V > 3 (INCL. MISSING):',I8,/20X,
     $ '(NOTE: RADIANCES ALWAYS HAVE NEUTRAL Q.MARK REGARDLESS OF FOV ',
     $ 'NUMBER)'/)
            END IF
            PRINT 8102
 8102 FORMAT(/' ---> W3UNPKB7: SUMMARY OF GOES REPORT COUNTS GROUPED',
     $ ' BY SATELLITE ID (PRIOR TO ANY FILTERING BY CALLING PROGRAM)'/)
            DO  IDSAT = 250,259
               IF(KNTSAT(IDSAT).GT.0) PRINT 8103, IDSAT,KNTSAT(IDSAT)
            ENDDO
 8103 FORMAT(15X,'NUMBER FROM SAT. ID ',I4,' :  ',I8)
            IF(KNTSAT(260).GT.0)  PRINT 8104, KNTSAT(260)
 8104 FORMAT(15X,'NUMBER FROM UNKNOWN SAT. ID:',I8)
            PRINT 8105
 8105       FORMAT(/)
         END IF
         GO TO 99
      ELSE  IF(IRET.EQ.8)  THEN
         GO TO 99
      END IF
C INITIALIZE THE OUTPUT ARRAY
      CALL UNPKB702(RDATA,STNID,ITP)
C STORE THE HEADER INFORMATION INTO UNPACKED QUASI-IW3UNPBF FORMAT
      rdata8_8 = bmiss
      CALL UNPKB703(LUNIT,RDATA,rdata8_8,STNID,SUBSET,ITP,IRET)
C IRET.GE.3 MEANS RPT NOT RETURNED DUE TO MISSING DATA IN HEADR (RETURN)
      IF(IRET.GE.3)  GO TO 99
      IF(ITP.EQ.1.OR.ITP.EQ.2.OR.ITP.EQ.3.OR.ITP.EQ.14)  THEN
C-----------------------------------------------------------------------
C   THE FOLLOWING PERTAINS TO WIND PROFILER REPORTS NOT ORIGINATING
C                 FROM PILOT (PIBAL) FORMAT BULLETINS)
C-----------------------------------------------------------------------
C STORE THE SURFACE DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 10)
         CALL UNPKB704(LUNIT,RDATA,ITP,IRET)
C STORE THE UPPER-AIR DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 11)
         CALL UNPKB705(LUNIT,RDATA,ITP)
         RDATX(1:IDMAX) = RDATA(1:IDMAX)
         IF(IDATA(35)+IDATA(37).EQ.0)  THEN
            IRET = 5
            GO TO 99
         END IF
C STORE BUFR DATA DIRECTLY INTO RDATA2 ARRAY
         RDATA2_8 = BMISS
         CALL UFBINT(LUNIT,RDATA2_8(1),1,1,NLEV,'TSIG')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(5),2,1,NLEV,'NPSM TPSE')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
C For NPN and CAP wind profilers prior to 5/2002, AVERAGING TIME is
C  decoded in minutes, after 5/2002 it is decoded in seconds (in either
C  case it is stored in minutes)
         IF(IBFMS(RDATA2_8(6)).EQ.0)  THEN
            RDATA2_8(6) = NINT(RDATA2_8(6)/60.)
         ELSE
            CALL UFBINT(LUNIT,RDATA2_8(6),1,1,NLEV,'TPMI')
            IF(NLEV.GT.1)  THEN
               IRET = 7
               GO TO 99
            END IF
         END IF
         RDATA2 = RDATA2_8
      ELSE  IF(ITP.EQ.4)  THEN
C-----------------------------------------------------------------------
C        THE FOLLOWING PERTAINS TO GOES SOUNDING/RADIANCE REPORTS
C-----------------------------------------------------------------------
C STORE BUFR DATA DIRECTLY INTO RDATA2 ARRAY
         RDATA2_8 = BMISS
         CALL UFBINT(LUNIT,RDATA2_8(2),1,1,NLEV,'ACAV')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(7),1,1,NLEV,'QMRK')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         RDATA2 = RDATA2_8
C STORE THE UPPER-AIR DATA/RADIANCES/RETRIEVALS INTO UNPACKED QUASI-
C  IW3UNPBF FORMAT (CATEGORY 12, 13, 08)
         CALL UNPKB707(LUNIT,RDATA,RDATA2,subset,IRET)
         IF(IRET.GE.5) THEN
            RDATA2 = BMISS
            GO TO 99
         END IF
      ELSE  IF(ITP.EQ.5 .OR. ITP.EQ.12 .OR. ITP.EQ.13)  THEN
C-----------------------------------------------------------------------
C       THE FOLLOWING PERTAINS TO NEXRAD (VAD) WIND REPORTS
C           ITP =  5 - VAD WINDS FROM RADAR CODED MESSAGE
C           ITP = 12 - VAD WINDS FROM LEVEL 2 DECODER
C           ITP = 13 - VAD WINDS FROM EUROPE, NEW ZEALAND
C-----------------------------------------------------------------------
C STORE THE UPPER-AIR DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 4)
         CALL UNPKB706(LUNIT,RDATA,ITP,IRET)
      ELSE  IF(ITP.EQ.6)  THEN
C-----------------------------------------------------------------------
C     THE FOLLOWING PERTAINS TO ERS SCATTEROMETER WIND REPORTS
C-----------------------------------------------------------------------
C STORE THE SURFACE DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 10)
         CALL UNPKB704(LUNIT,RDATA,ITP,IRET)
      ELSE  IF(ITP.EQ.7)  THEN
C-----------------------------------------------------------------------
C   THE FOLLOWING PERTAINS TO QUIKSCAT SCATTEROMETER WIND REPORTS
C-----------------------------------------------------------------------
C STORE THE SURFACE DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 10)
         CALL UNPKB704(LUNIT,RDATA,ITP,IRET)
         IF(IRET.GE.5) GO TO 99
C STORE BUFR DATA DIRECTLY INTO RDATA2 ARRAY
         RDATA2_8 = BMISS
         CALL UFBINT(LUNIT,RDATA2_8(2),1,1,NLEV,'ACAV')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(3),2,1,NLEV,'CTCN ATRN')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(8),1,1,NLEV,'SPRR')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         RDATA2 = RDATA2_8
      ELSE  IF(ITP.EQ.8)  THEN
C-----------------------------------------------------------------------
C   THE FOLLOWING PERTAINS TO GPS INTEGRATED PRECIPITABLE WATER REPORTS
C-----------------------------------------------------------------------
C STORE THE GPS-IPW DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 14)
         CALL UNPKB709(LUNIT,RDATA,subset)
         RDATX(1:IDMAX) = RDATA(1:IDMAX)
         IF(IDATA(43).EQ.0)  THEN
            IRET = 5
            GO TO 99
         END IF
      ELSE  IF(ITP.EQ.9)  THEN
C-----------------------------------------------------------------------
C        THE FOLLOWING PERTAINS TO NPN AND CAP RASS REPORTS
C-----------------------------------------------------------------------
C STORE THE RASS DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 15)
         CALL UNPKB710(LUNIT,RDATA)
         RDATX(1:IDMAX) = RDATA(1:IDMAX)
         IF(IDATA(45).EQ.0)  THEN
            IRET = 5
            GO TO 99
         END IF
C STORE BUFR DATA DIRECTLY INTO RDATA2 ARRAY
         RDATA2_8 = BMISS
         CALL UFBINT(LUNIT,RDATA2_8(1),1,1,NLEV,'TSIG')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(6),1,1,NLEV,'TPSE')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
C For NPN and CAP RASS prior to 5/2002, AVERAGING TIME is decoded in
C  minutes, after 5/2002 it is decoded in seconds (in either case it is
C  stored in minutes)
         IF(IBFMS(RDATA2_8(6)).EQ.0)  THEN
            RDATA2_8(6) = NINT(RDATA2_8(6)/60.)
         ELSE
            CALL UFBINT(LUNIT,RDATA2_8(6),1,1,NLEV,'TPMI')
            IF(NLEV.GT.1)  THEN
               IRET = 7
               GO TO 99
            END IF
         END IF
         RDATA2 = RDATA2_8
      ELSE  IF(ITP.EQ.10)  THEN
C-----------------------------------------------------------------------
C   THE FOLLOWING PERTAINS TO WINDSAT SCATTEROMETER WIND REPORTS
C                         (NAVY OR NESDIS)
C-----------------------------------------------------------------------
C STORE THE SURFACE DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 10)
         CALL UNPKB704(LUNIT,RDATA,ITP,IRET)
         IF(IRET.GE.5) GO TO 99
C STORE BUFR DATA DIRECTLY INTO RDATA2 ARRAY
         RDATA2_8 = BMISS
         CALL UFBINT(LUNIT,RDATA2_8(2), 1,1,NLEV,'ACAV')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(9), 6,1,NLEV,
     $    'SST1 MRWVC MRLWC WSST MWD10 MWS10')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(15),7,1,NLEV,
     $    'WSEQC1 CHSQ PHER SPDE SSTE CLDE VPRE')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         RDATA2 = RDATA2_8
      ELSE  IF(ITP.EQ.11)  THEN
C-----------------------------------------------------------------------
C     THE FOLLOWING PERTAINS TO ASCAT SCATTEROMETER WIND REPORTS
C-----------------------------------------------------------------------
C STORE THE SURFACE DATA INTO UNPACKED QUASI-IW3UNPBF FORMAT (CAT. 10)
         CALL UNPKB704(LUNIT,RDATA,ITP,IRET)
         IF(IRET.GE.5) GO TO 99
C STORE BUFR DATA DIRECTLY INTO RDATA2 ARRAY
         RDATA2_8 = BMISS
         CALL UFBINT(LUNIT,RDATA2_8(2),1,1,NLEV,'ACAV')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(3),1,1,NLEV,'CTCN')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         CALL UFBINT(LUNIT,RDATA2_8(22),3,1,NLEV,'WVCQ BSCD LKCS')
         IF(NLEV.GT.1)  THEN
            IRET = 7
            GO TO 99
         END IF
         RDATA2 = RDATA2_8
C-----------------------------------------------------------------------
      END IF
   99 CONTINUE
C PRIOR TO RETURNING SAVE INPUT DATE & HR RANGE ARGUMENTS FROM THIS CALL
      LSDATE = IDATE
      LSHE = IHE
      LSHL = IHL
      RETURN
C-----------------------------------------------------------------------
 8888 CONTINUE
C COME HERE IF ERROR READING 1ST RECORD OF INPUT FILE- RETURN W/ IRET= 2
      PRINT 7765, LUNIT
 7765 FORMAT(' *** W3UNPKB7 ERROR: ERROR READING FIRST RECORD OF INPUT',
     $ ' FILE ON UNIT  ',I2,' -- ALL DONE WITH THIS FILE (IRET = 2)')
      GO TO 9998
C-----------------------------------------------------------------------
 9999 CONTINUE
C COME HERE IF NULL FILE IS INPUT - RETURN WITH IRET = 2
      PRINT 8765, LUNIT
 8765 FORMAT(' *** W3UNPKB7 ERROR: INPUT FILE ON UNIT  ',I2,'  IS ',
     $ 'EMPTY (NULL) -- ALL DONE WITH THIS FILE (IRET = 2)')
C-----------------------------------------------------------------------
 9998 CONTINUE
      REWIND LUNIT
      IRET = 2
      LSDATE = IDATE
      LSHE = IHE
      LSHL = IHL
      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB701
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2014-03-13
C
C ABSTRACT: CALLS BUFRLIB ROUTINES TO READ IN A BUFR MESSAGE AND THEN
C   READ A SINGLE REPORT (SUBSET) OUT OF THE MESSAGE.
C
C PROGRAM HISTORY LOG:
C 1996-12-16  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C 1999-02-12  D. A. KEYSER NP22-- ADDED ERS SCATTEROMETER WINDS HERE
C     NOW THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2000-09-22  D. A. KEYSER NP22-- ADDED QUIKSCAT SCATTEROMETER WINDS
C     HERE NOW THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2002-07-03  D. A. KEYSER NP22 -- ADDED PROCESSING OF GPS-IPW REPORTS
C     HERE NOW THAT THEY ARE PACKED IN AN NCEP BUFR FILE (GPSIPW -
C     RETURNED IN NEW CATEGORY 14)
C 2004-02-02  D. A. KEYSER -- ADDED NEW INPUT "SUBSKP" - SEE
C     DESCRIPTION BELOW
C 2006-07-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     MODIFIED TO HANDLE NAVY WINDSAT SCATTEROMETER WINDS (READ FROM
C     MESSAGE TYPE NC012138)
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     MODIFIED TO HANDLE NESDIS WINDSAT SCATTEROMETER WINDS (READ FROM
C     MESSAGE TYPE NC012139), PROCESSING IS IDENTICAL TO NAVY WINDSAT
C     SCATTEROMETER WINDS; HANDLES GOES 1x1 F-O-V SNDGS RADIANCES IN
C     SUBSET "NC003003"
C 2008-09-25  D. A. KEYSER -- ADDED ASCAT SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2014-03-13  D. A. KEYSER -- MODIFIED TO HANDLE VAD WINDS FROM LEVEL
C     2 DECODER (SUBSET "NC002017") {IN ADDITION TO THOSE FROM RADAR
C     CODED MESSAGE (SUBSET "NC002008")}
C 2020-08-20 J. DONG -- ADDED HONG KONG PROFILER WINDS (NC002014) AND
C            VAD WINDS FROM EUROPE AND NEW ZEALAND (NC002018)
C
C USAGE:    CALL UNPKB701(LUNIT,ITP,SUBSET,SUBSKP,IRET)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     SUBSKP   - TWO-DIMENSIONAL LOGICAL ARRAY WHERE ELEMENT 1 REFERS
C              - TO A PARTICULAR BUFR TYPE (RANGE 0-255) AND ELEMENT 2
C              - REFERS TO A PARTICULAR BUFR SUBTYPE (RANGE 0-200). IF
C              - SUBSKP IS SET TO TRUE FOR A PARTICULAR BUFR TYPE AND
C              - SUBTYPE, THEN ANY BUFR MESSAGE OF THIS TYPE READ IN
C              - WILL BE SKIPPED OVER {NO SUBSETS (REPORTS) WILL BE
C              - DECODED OUT OF IT AND RETURNED TO THE CALLING PROGRAM,
C              - INSTEAD THIS SUBROUTINE WILL MOVE ON TO READ THE NEXT
C              - BUFR MESSAGE IN THE FILE AND AGAIN USE SUBSKP TO SEE
C              - IF ANY SUBSETS SHOULD BE DECODED OUT OF IT}. THIS
C              - ALLOWS THIS SUBROUTINE TO QUICKLY PASS BY ANY BUFR
C              - MESSAGES WITH A TYPE/SUBTYPE THAT THE CALLING PROGRAM
C              - DOES NOT WANT DECODED.  THE LENGTH OF THIS ARRAY
C              - SHOULD ALWAYS BE HARDWIRED TO (0:255,0:200).
C
C   OUTPUT ARGUMENT LIST:
C     ITP      - THE TYPE OF REPORT THAT HAS BEEN DECODED {=1 - NPN
C              - WIND PROFILER, =2 - CAP WIND PROFILER, =3 - JMA WIND
C              - PROFILER, =4 - GOES SNDG, =5 - NEXRAD (VAD) WIND FROM
C              - RADAR CODED MESSAGE; =6 - ERS SCATTEROMETER WIND, =7 -
C              - QUIKSCAT SCATTEROMETER WIND, =8 - GPS-IPW, =9 - NPN
C              - or CAP RASS, =10 - WINDSAT SCATTEROMETER WIND (NAVY OR
C              - NESDIS), =11 - ASCAT SCATTEROMETER WIND, =12 - NEXRAD
C              - (VAD) WIND FROM LEVEL 2 DECODER, =13 - NON-NEXRAD (VAD)
C              - WIND FROM OTHER COUNTRIES (EUROPE, NEW ZEALAND), 
C              - =14 - WIND PROFILER FROM HONG KONG}
C     SUBSET   - CHARACTER*8 BUFR MESSAGE TYPE (SAME FOR ALL REPORTS
C              - IN A COMMON BUFR MESSAGE)
C     IRET     - RETURN CODE AS DESCRIBED IN W3UNPKB7 DOCBLOCK
C
C   INPUT FILES:
C     UNIT AA  - (WHERE AA IS LUNIT ABOVE) FILE HOLDING THE DATA
C              - IN THE FORM OF BUFR MESSAGES
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB701(LUNIT,ITP,SUBSET,SUBSKP,IRET)
      CHARACTER*8   SUBSET,SUBSET_LAST
      INTEGER  MDATE(4),NDATE(8)
      LOGICAL  SUBSKP(0:255,0:200),SKIP_CAT12
      DIMENSION  RINC_O(5)
      COMMON /PKB7BB/KDATE(8),LDATE(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7CC/INDEX
      COMMON /PKB7DD/LSHE,LSHL,ICDATE(5),IDDATE(5)
      COMMON /PKB7HH/NPRINT(0:255,0:200)
 
      SAVE

      DATA  IREC/0/,JREC/0/,SUBSET_LAST/'xxxxxxxx'/

   10 CONTINUE
C=======================================================================
      IF(INDEX.EQ.0)  THEN
 
C  READ IN NEXT BUFR MESSAGE
 
         CALL READMG(LUNIT,SUBSET,IBDATE,KRET)
         IF(KRET.NE.0)  THEN
C-----------------------------------------------------------------------
            PRINT 101
  101   FORMAT(' ---> W3UNPKB7: ALL BUFR MESSAGES READ IN AND DECODED'/)
            IRET = 2
            RETURN
C-----------------------------------------------------------------------
         END IF
         IF(IBDATE.LT.100000000)  THEN
C IF INPUT BUFR FILE DOES NOT RETURN MESSAGES WITH A 4-DIGIT YEAR,
C  SOMETHING IS WRONG (EVEN NON-COMPLIANT BUFR MESSAGES SHOULD
C  CONSTRUCT A 4-DIGIT YEAR AS LONG AS DATELEN(10) HAS BEEN CALLED
            PRINT'(" ##W3UNPKB7/UNPKB701 - A 10-DIGIT SECT. 1 BUFR ",
     $       "MESSAGE DATE WAS NOT RETURNED IN UNIT ",I0," - PROBLEM ",
     $       "WITH BUFR FILE - IRET = 2")', LUNIT
            IRET = 2
            RETURN
         END IF
         IF(SUBSET.NE.SUBSET_LAST)   THEN
            JREC = 0
            SUBSET_LAST = SUBSET
         END IF
         CALL UFBCNT(LUNIT,IREC,ISUB)
         JREC = JREC + 1
         MDATE(1) = IBDATE/1000000
         MDATE(2) = MOD((IBDATE/10000),100)
         MDATE(3) = MOD((IBDATE/100),100)
         MDATE(4) = MOD(IBDATE,100)
         IF(IPRINT.GE.1)  THEN
            PRINT'(" HAVE SUCCESSFULLY READ IN A BUFR MESSAGE")'
            PRINT 103
  103       FORMAT(' BUFR FOUND BEGINNING AT BYTE    1 OF MESSAGE')
            PRINT 105, IREC,MDATE,SUBSET
  105       FORMAT(8X,'HAVE READ IN A BUFR MESSAGE NO.',I3,', DATE: ',
     $      I6,3I4,'   0; TABLE A ENTRY = ',A8,' AND EDIT. NO. =    2'/)
         END IF
         IF(SUBSET.EQ.'NC002007')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS NOAA ",
     $       "PROFILER NETWORK WIND REPORTS")'
            ITP = 1
         ELSE  IF(SUBSET.EQ.'NC002011')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS ",
     $       "COOPERATIVE AGENCY PROFILER WIND REPORTS")'
            ITP = 2
         ELSE  IF(SUBSET.EQ.'NC002013')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS JAPANESE ",
     $       "METEOROLOGICAL AGENCY PROFILER WIND REPORTS")'
            ITP = 3
         ELSE  IF(SUBSET.EQ.'NC002014')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS OTHER ",
     $       "(e.g., HONG KONG) PROFILER WIND REPORTS")'
            ITP = 14
         ELSE  IF(SUBSET.EQ.'NC002008')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS NEXRAD ",
     $       "(VAD) WIND REPORTS FROM RADAR CODED MESSAGE")'
            ITP = 5
         ELSE  IF(SUBSET.EQ.'NC002017')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS NEXRAD ",
     $       "(VAD) WIND REPORTS FROM LEVEL 2 DECODER")'
            ITP = 12
         ELSE  IF(SUBSET.EQ.'NC002018')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS NEXRAD ",
     $       "(VAD) WIND REPORTS FROM EUROPE AND NEW ZEALAND")'
            ITP = 13
         ELSE  IF(SUBSET.EQ.'NC003001' .or. SUBSET.EQ.'NC003002' .or.
     $            SUBSET.EQ.'NC003003')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS GOES ",
     $       "SOUNDING/RADIANCE REPORTS")'
            ITP = 4
         ELSE  IF(SUBSET.EQ.'NC012008')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS ERS ",
     $       "SCATTEROMETER WIND REPORTS")'
            ITP = 6
         ELSE  IF(SUBSET.EQ.'NC012137')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS QUIKSCAT ",
     $       "SCATTEROMETER WIND REPORTS")'
            ITP = 7
         ELSE  IF(SUBSET.EQ.'NC002009')  THEN
            PRINT 217
  217 FORMAT(/'##W3UNPKB7: THIS MESSAGE CONTAINS WIND PROFILER ',
     $ 'REPORTS ORIGINATING FROM PILOT (PIBAL) BULLETINS - IRET = 8'/)
            IRET = 8
            RETURN
         ELSE  IF(SUBSET.EQ.'NC012003' .OR. SUBSET.EQ.'NC012004')  then
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS GPS-IPW ",
     $       "REPORTS")'
            ITP = 8
         ELSE  IF(SUBSET.EQ.'NC002012')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS NOAA ",
     $       "PROFILER NETWORK AND COOPERATIVE AGENCY RASS TEMPERATURE",
     $       " REPORTS")'
            ITP = 9
         ELSE  IF(SUBSET.EQ.'NC012138' .OR. SUBSET.EQ.'NC012139')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS WINDSAT ",
     $       "SCATTEROMETER WIND REPORTS FROM THE NAVY OR NESDIS")'
            ITP = 10
         ELSE  IF(SUBSET.EQ.'NC012122')  THEN
            IF(IPRINT.GE.1)  PRINT'(" THIS MESSAGE CONTAINS ASCAT ",
     $       "SCATTEROMETER WIND REPORTS")'
            ITP = 11
         ELSE
            PRINT 107, IREC,SUBSET
  107 FORMAT(' *** W3UNPKB7 WARNING: BUFR MESSAGE NO.',I3,' CONTAINS ',
     $ 'REPORTS THAT CANNOT BE DECODED (SUBSET = ',A8,'), TRY READING ',
     $ 'NEXT MSG'/)
            INDEX = 0
            GO TO 10
         END IF

         JSUB = NMSUB(LUNIT)
         READ(SUBSET(3:5),'(I3)') IINDEX
         READ(SUBSET(6:8),'(I3)') JINDEX
         IF(IINDEX.LE.255 .AND. JINDEX.LE.200) THEN
            IF(SUBSKP(IINDEX,JINDEX))  THEN
               IF(JSUB.GT.0.AND.NPRINT(IINDEX,JINDEX).EQ.0)  THEN

C  There may be messages with no reports present (e.g., the center time
C   and dump time messages which may be present even if no reports are
C   present in subsequent messages), so key on the FIRST message of
C   this type/subtype with reports present for the diagnostic print

                  PRINT 1234, SUBSET
 1234 FORMAT(/' ---> W3UNPKB7: BUFR MESSAGE WITH TABLE ENTRY "',A8,
     $ '" (AND CONTAINING SUBSETS) READ - ALL MESSAGES WITH THIS BUFR ',
     $ 'TYPE/SUBTYPE'/20X,'ARE SKIPPED AS DIRECTED BY CALLING PROGRAM'/)
               NPRINT(IINDEX,JINDEX) = 1
               END IF
               INDEX = 0
               GO TO 10
            END IF
         END IF

         IF(KTIMCH.EQ.1)  THEN

C CHECK DATE OF MESSAGE AGAINST SPEC. TIME RANGES IF DOING TIME CHECK

C ALL NCEP BUFR MESSAGES CURRENTLY HAVE "00" FOR MINUTES IN SECTION 1
            NDATE(1:3) = MDATE(1:3)
            NDATE(4) = 0
            NDATE(5) = MDATE(4)
            NDATE(6:8) = 0
            CALL W3DIFDAT(KDATE,NDATE,3,RINC_O)
            KMIN = RINC_O(3)
            CALL W3DIFDAT(LDATE,NDATE,3,RINC_O)
            LMIN = RINC_O(3)
            IF((KMIN.GT.0.OR.LMIN.LT.0).AND.IREC.GT.2)  THEN
               PRINT 106, IREC,MDATE
  106 FORMAT('  BUFR MESSAGE NO.',I3,' WITH DATE:',I5,3I3,'  0 NOT W/I',
     $ ' REQ. TIME RANGE, TRY READING NEXT MSG'/)
               INDEX = 0
               GO TO 10
            END IF

         END IF

      END IF
C=======================================================================
C  READ NEXT SUBSET (REPORT) IN MESSAGE
 
      IF(IPRINT.GT.1)  PRINT'(" CALL READSB")'
      CALL READSB(LUNIT,KRET)
      IF(IPRINT.GT.1)  PRINT'(" BACK FROM READSB")'
      IF(KRET.NE.0) THEN
         IF(INDEX.GT.0)  THEN
 
C ALL SUBSETS IN THIS MESSAGE PROCESSED, READ IN NEXT MESSAGE (IF ALL
C  MESSAGES READ IN NO MORE DATA TO PROCESS)
 
            IF(IPRINT.GT.1)  PRINT'(" ALL REPORTS IN THIS MESSAGE ",
     $       "DECODED, GO ON TO NEXT MESSAGE")'
         ELSE
 
C THERE WERE NO SUBSETS FOUND IN THIS BUFR MESSAGE, GOOD CHANCE IT IS
C  ONE OF TWO DUMMY MESSAGES AT TOP OF FILE INDICATING CENTER TIME AND
C  DATA DUMP TIME ONLY; READ IN NEXT MESSAGE
 
            IF(JREC.EQ.1)  THEN
               PRINT 4567, IREC,ICDATE,SUBSET
 4567 FORMAT(/'===> BUFR MESSAGE NO. ',I4,' IS A DUMMY CONTAINING ONLY',
     $ ' CENTER DATE (',I4,4I3.2,') FOR MSG TYPE ',A8,' - GO ON TO ',
     $ 'NEXT MESSAGE'/)
            ELSE IF(JREC.EQ.2)  THEN
               PRINT 4568, IREC,IDDATE,SUBSET
 4568 FORMAT(/'===> BUFR MESSAGE NO. ',I4,' IS A DUMMY CONTAINING ONLY',
     $ '  DUMP  DATE (',I4,4I3.2,') FOR MSG TYPE ',A8,' - GO ON TO ',
     $ 'NEXT MESSAGE'/)
            ELSE
               PRINT 4569, IREC,MDATE
 4569 FORMAT(/'===> BUFR MESSAGE NO.',I3,' (DATE:',I5,3I3,'  0) ',
     $ 'CONTAINS ZERO REPORTS FOR SOME UNEXPLAINED REASON - GO ON TO ',
     $ 'NEXT MESSAGE'/)
            END IF
         END IF
         INDEX = 0
         GO TO 10
      END IF
C-----------------------------------------------------------------------
      IF(IPRINT.GT.1)  PRINT'(" READY TO PROCESS NEW DECODED REPORT")'
C***********************************************************************
C            A SINGLE REPORT HAS BEEN SUCCESSFULLY DECODED
C***********************************************************************
      INDEX = INDEX + 1
      IF(IPRINT.GE.1)  PRINT'(" WORKING WITH SUBSET NUMBER ",I0)', INDEX
      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB702
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2014-03-13
C
C ABSTRACT: INITIALIZES THE OUTPUT ARRAY WHICH HOLDS A SINGLE REPORT
C   IN THE QUASI-IW3UNPBF UNPACKED FORMAT TO ALL MISSING.
C
C PROGRAM HISTORY LOG:
C 1996-12-16  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C 1999-02-12  D. A. KEYSER NP22-- ADDED ERS SCATTEROMETER WINDS HERE
C     NOW THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2000-09-22  D. A. KEYSER NP22-- ADDED QUIKSCAT SCATTEROMETER WINDS
C     HERE NOW THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2002-07-03  D. A. KEYSER NP22 -- ADDED PROCESSING OF GPS-IPW REPORTS
C     HERE NOW THAT THEY ARE PACKED IN AN NCEP BUFR FILE (GPSIPW -
C     RETURNED IN NEW CATEGORY 14)
C 2004-02-02  D. A. KEYSER NP22 -- ADDED PROCESSING OF RASS REPORTS
C     HERE NOW THAT THEY ARE PACKED IN AN NCEP BUFR FILE (RASSDA -
C     RETURNED IN NEW DATA LEVEL CATEGORY 15)
C 2008-09-25  D. A. KEYSER -- ADDED ASCAT SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2014-03-13  D. A. KEYSER -- MODIFIED TO HANDLE VAD WINDS FROM LEVEL
C     2 DECODER (SUBSET "NC002017") {IN ADDITION TO THOSE FROM RADAR
C     CODED MESSAGE (SUBSET "NC002008")}; PARAMETERIZED MAXIMUM NUMBER
C     OF LEVELS ALLOWED FOR EACH CATEGORY AND CALCULATED PARAMETER
C     "IDMAX" (SIZE OF OUTPUT "RDATA" ARRAY) BASED ON THESE, ALL ARE
C     NOW PLACED IN INCLUDE FILE 'inc_w3unpkb7.inc' {IN HERE, MAXIMUM
C     NUMBER OF CAT. 04 WINDS-BY-HEIGHT LEVELS (EXCLUDING FIRST,
C     SURFACE, LEVEL), "ILVLMX_04", INCREASED FROM 64 TO 254 TO ACCOUNT
C     FOR MORE LEVELS IN NEW VAD WINDS FROM LEVEL 2 DECODER, AND
C     MAXIMUM NUMBER OF CAT. 11 WIND PROFILER LEVELS (EXCLUDING FIRST,
C     SURFACE, LEVEL), "ILVLMX_11", INCREASED FROM 102 TO 200 TO
C     ACCOUNT FOR SOME MAP PROFILERS WITH MORE LEVELS THAN BEFORE, THE
C     RESULTING "IDMAX" IS NOW 2270, UP FROM 1200 BEFORE}
C
C USAGE:    CALL UNPKB702(RDATA,STNID,ITP)
C   INPUT ARGUMENT LIST:
C     ITP      - THE TYPE OF REPORT THAT HAS BEEN DECODED {=1 - NPN
C              - WIND PROFILER, =2 - CAP WIND PROFILER, =3 - JMA WIND
C              - PROFILER, =4 - GOES SNDG, =5 - NEXRAD (VAD) WIND FROM
C              - RADAR CODED MESSAGE; =6 - ERS SCATTEROMETER WIND, =7 -
C              - QUIKSCAT SCATTEROMETER WIND, =8 - GPS-IPW, =9 - NPN
C              - or CAP RASS, =10 - WINDSAT SCATTEROMETER WIND (NAVY OR
C              - NESDIS), =11 - ASCAT SCATTEROMETER WIND; =12 - NEXRAD
C              - (VAD) WIND FROM LEVEL 2 DECODER}
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE REPORT RETURNED AN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT; ALL DATA ARE MISSING (NOTE: DOES NOT
C              - INCLUDE STATION ID)
C     STNID    - CHARACTER*8 SINGLE REPORT STATION IDENTIFICATION (UP
C              - TO 8 CHARACTERS, LEFT-JUSTIFIED - HERE INITIALIZED AS
C              - "????????" FOR GOES SOUNDINGS, ERS SCATTEROMETER,
C              - QUIKSCAT SCATTEROMETER, WINDSAT SCATTEROMETER AND
C              - ASCAT SCATTEROMETER AND AS BLANKS FOR ALL OTHER TYPES)
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB702(RDATA,STNID,ITP)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      REAL  RDATA(*),RDATX(IDMAX)
      INTEGER  IDATA(IDMAX)
      CHARACTER*8  STNID

      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15

      SAVE

      EQUIVALENCE (RDATX,IDATA)

      DATA  XMISS/99999./,IMISS/99999/

      IDATS_04 = 0
      IDATS_08 = 0
      IDATS_10 = 0
      IDATS_11 = 0
      IDATS_12 = 0
      IDATS_13 = 0
      IDATS_14 = 0
      IDATS_15 = 0

      RDATX(1)  = XMISS
      RDATX(2)  = XMISS
      RDATA(3)  = XMISS
      RDATX(4)  = XMISS
      IDATA(5)  = 999999
      IDATA(6)  = 999999
      RDATX(7)  = XMISS
      IDATA(8)  = IMISS
      IDATA(9)  = IMISS
      IDATA(10) = IMISS
      RDATX(11) = XMISS
      RDATX(12) = XMISS
      STNID = '        '
 
C  ALL TYPES -- LOAD ZEROS INTO THE DEFINING WORD PAIRS
 
      IDATA(13:IDATS-1) = 0
 
C  ALL TYPES -- LOAD MISSINGS INTO THE DATA PORTION
 
      RDATX(IDATS:IDMAX) = XMISS

      IF(ITP.EQ.1.OR.ITP.EQ.2.OR.ITP.EQ.3.OR.ITP.EQ.14)  THEN

C  WIND PROFILER -- LOAD INTEGER MISSING WHERE APPROPRIATE
C                   {Current limit of "ILVLMX_11" Cat. 11 levels, not
C                     counting first (surface) level}
C                   (if this is expanded, "IDMAX" will increase)

         IDATS_10 = IDATS
         IDATS_11 = IDATS_10 + (ILVL_10 * 7)
         IDATA(IDATS_11+ 3:IDMAX:11) = IMISS
         IDATA(IDATS_11+ 5:IDMAX:11) = IMISS
         IDATA(IDATS_11+ 6:IDMAX:11) = IMISS
         IDATA(IDATS_11+10:IDMAX:11) = IMISS

      ELSE  IF(ITP.EQ.4)  THEN

C  GOES -- LOAD DEFAULT OF "????????" FOR STN. ID.

         STNID = '????????'

C  GOES -- LOAD DEFAULT OF 2.0 INTO CAT. 12 LEVEL QUALITY MARKERS
C          (Current limit of "ILVLMX_12" Cat. 12 levels)
C          (could be expanded somewhat w/o changing "IDMAX" if need be)

         IDATS_12 = IDATS
         RDATA(IDATS_12+6:IDATS_12+6+((ILVLMX_12-1)*9):9) = 2.0
         RDATA(IDATS_12+7:IDATS_12+7+((ILVLMX_12-1)*9):9) = 2.0
         RDATA(IDATS_12+8:IDATS_12+8+((ILVLMX_12-1)*9):9) = 2.0

C  GOES -- LOAD DEFAULT OF 2.0 INTO FIRST CAT. 08 LEVEL QUALITY MARKER
C          (Current limit of "ILVLMX_08" Cat. 08 levels)
C          (could be expanded somewhat w/o changing "IDMAX" if need be
C           but source in w3unpkb7.f would have to be changed!!)

         IDATS_08 = IDATS_12 + (ILVLMX_12 * 9)
         RDATA(IDATS_08+2:IDATS_08+2+((ILVLMX_08-1)*4):4) = 2.0

C  GOES -- LOAD INTEGER MISSING INTO CAT. 13 LEVEL CHANNEL NUMBER
C       -- LOAD DEFAULT OF 2.0 INTO CAT. 13 LEVEL QUALITY MARKER
C          (Current limit of "ILVLMX_13" Cat. 13 levels)
C          (could be expanded somewhat w/o changing "IDMAX" if need be)

         IDATS_13 = IDATS_08 + (ILVLMX_08 * 4)
         IDATA(IDATS_13+0:IDATS_13+0+((ILVLMX_13-1)*3):3) = IMISS
         RDATA(IDATS_13+2:IDATS_13+2+((ILVLMX_13-1)*3):3) = 2.0

      ELSE  IF(ITP.EQ.5 .OR. ITP.EQ.12 .OR. ITP.EQ.13)  THEN

C  VADWND -- LOAD DEFAULT OF 2.0 INTO HGHT CAT. 04 LEVEL QUALITY MARKER
C         -- LOAD DEFAULT OF 4.0 INTO WIND CAT. 04 LEVEL QUALITY MARKER
C            {Current limit of "ILVLMX_04" Cat. 04 levels, not counting
C             first (surface) level}
C          (could be expanded somewhat w/o changing "IDMAX" if need be)

         IDATS_04 = IDATS
         RDATA(IDATS_04+3:IDMAX:5)   = 2.0
         RDATA(IDATS_04+4:IDMAX:5)   = 4.0

      ELSE  IF(ITP.EQ.6.OR.ITP.EQ.7.OR.ITP.EQ.10.OR.ITP.EQ.11)  THEN

C  ERS, QUIKSCAT, WINDSAT OR ASCAT -- LOAD DEFAULT OF "????????" FOR
C   STN. ID.

         IDATS_10 = IDATS
         STNID    = '????????'

      ELSE  IF(ITP.EQ.8)  THEN

C  GPS-IPW -- 

         IDATS_14 = IDATS

      ELSE IF(ITP.EQ.9)  THEN

C          {Current limit of "ILVLMX_15" Cat. 15 levels, not counting
C           first (surface) level}
C          (could be expanded somewhat w/o changing "IDMAX" if need be)

         IDATS_15 = IDATS
         IDATA(IDATS_15+2:IDMAX:3) = IMISS
      END IF

      RDATA(1:IDMAX) = RDATX(1:IDMAX)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB703
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2016-11-30
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   HEADER DATA FOR ALL REPORTS.  THE HEADER IS THEN FILLED INTO THE
C   OUTPUT ARRAY WHICH HOLDS A SINGLE REPORT IN THE QUASI-IW3UNPBF
C   UNPACKED FORMAT.
C
C PROGRAM HISTORY LOG:
C 1996-12-16  D. A. KEYSER NP22 - ORIGINAL AUTHOR (HANDLED PROFILER
C     REPORTS ONLY
C 1997-06-02  D. A. KEYSER NP22 - WROTE SIMILAR SUBROUTINE TO HANDLE
C     VAD WINDS ONLY
C 1997-06-05  D. A. KEYSER NP22 - WROTE SIMILAR SUBROUTINE TO HANDLE
C     GOES SOUNDINGS ONLY
C 1998-06-14  D. A. KEYSER -- MODIFIED VAD WIND HEADER (STATION ID)
C     PROCESSING TO ACCOUNT FOR UPDATES TO BUFRTABLE MNEMONICS IN /dcom
C 1998-06-15  D. A. KEYSER NP22 - CHANGED CHAR. 6 OF GOES STNID TO BE
C     UNIQUE FOR TWO DIFFERENT EVEN OR ODD SATELLITE ID'S (EVERY OTHER
C     EVEN OR ODD SAT. ID NOW GETS SAME CHAR. 6 TAG)
C 1999-02-12  D. A. KEYSER NP22 - WROTE SIMILAR SUBROUTINE TO HANDLE
C     ERS SCATTEROMETER WINDS ONLY
C 2000-09-22  D. A. KEYSER NP22-- ADDED QUIKSCAT SCATTEROMETER WINDS
C     TO ERS SCATTEROMETER SUBROUTINE NOW THAT THEY ARE PACKED IN BUFR
C 2000-12-05  D. A. KEYSER -- MODIFIED GOES, ERS AND QUIKSCAT TO NOT
C     CREATE STN. ID IF IT HAS ALREADY BEEN CREATED BY BUFR_DUPSAT
C     (GOES), WAVE_DATASORT (ERS), OR WAVE_DCODQUIKSCAT (QUIKSCAT)
C     (LOOKS FOR "RPID" IN INPUT FILE) (OTHERWISE, MODIFIED TO CREATE
C     AN 8-CHARACTER STN. ID)
C 2001-04-06  D. A. KEYSER NP22 - HEADER WORD 5 NOW RETURNS COMPLETE
C     DATE (YYYYMMDDHH) AND HEADER WORD 6 IS NOW MISSING EXCEPT FOR
C     GOES, ERS AND QUIKSCAT WHERE WORD 6 NOW RETURNS SATELLITE ID
C 2001-06-19  D. A. KEYSER -- FOR GOES, RECOGNIZES BUFR TYPE/SUBTYPE
C     003/002 AS GOES 1x1 (HI-RES) DATA, PART OF THE "GOESND" DUMP FILE
C     ("SUBSET" ADDED TO INPUT ARGUMENT LIST); GOES HI-RES REPORTS HAVE
C     UNKNOWN PATH AND GET PROPER STNID CHAR. 8 CHARACTER IDENTIFYING
C     THE SAT. NUMBER (IF STNID IS GENERATED HERE)
C 2001-08-20  D. A. KEYSER -- FOR QUIKSCAT, HEADER WORD 10 NOW RETURNS
C     NUMBER OF ORIGINAL REPORTS USED TO GENERATE SUPEROBS SINCE THIS
C     IS NOW AVAILABLE IN INPUT REPROCESSED QKSWND DUMP FILE (FOR
C     NON-SUPEROBS, HARDWIRED TO 1)
C 2002-03-05  D. A. KEYSER -- ACCOUNTS FOR CHANGES IN INPUT PROFLR
C     (WIND PROFILER BUFR DUMP FILE AFTER 5/2002: MNEMONIC "NPSM" IS NO
C     LONGER AVAILABLE; MNEMONIC "TPSE" REPLACES "TPMI" (AVG. TIME IN
C     MINUTES STILL OUTPUT) (WILL STILL WORK PROPERLY FOR INPUT PROFLR
C     DUMP FILES PRIOR TO 5/2002)
C 2002-07-03  D. A. KEYSER -- COMBINED INDIVIDUAL SUBROUTINES FOR
C     PROCESSING HEADER INFORMATION FOR ALL TYPES INTO THIS SINGLE NEW
C     SUBROUTINE SINCE ALL WERE VERY SIMILAR; ADDED PROCESSING OF GPS-
C     IPW REPORTS HERE NOW THAT THEY ARE PACKED IN AN NCEP BUFR FILE
C     (GPSIPW - RETURNED IN NEW CATEGORY 14)
C 2004-02-02  D. A. KEYSER -- ADDED COOPERATIVE AGENCY (002/011) AND
C     JAPANESE (002/013) WIND PROFILERS TO PROCESSING FOR WIND
C     PROFILERS NOT ORIGINATING FROM PILOT (PIBAL) BULLETINS; ADDED
C     PROCESSING OF NPN AND CAP RASS REPORTS HERE (002/012) NOW THAT
C     THEY ARE PACKED IN AN NCEP BUFR FILE (RASSDA - RETURNED IN NEW
C     DATA LEVEL CATEGORY 15)
C 2006-07-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     MOVED REPORT-TYPE SPECIFIC VALUES OUT OF RETURNED HEADER IN
C     "RDATA" TO NEW "RDATA2" ARRAY (CLEANS UP HEADER PROCESSING)
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     HANDLES GOES 1x1 F-O-V SNDGS RADIANCES IN SUBSET "NC003003"
C 2008-09-25  D. A. KEYSER -- ADDED ASCAT SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN A NCEP BUFR FILE (GET DUMP REPORT TYPE
C     584)
C 2014-03-13  D. A. KEYSER -- MODIFIED TO HANDLE VAD WINDS FROM LEVEL
C     2 DECODER (SUBSET "NC002017") {IN ADDITION TO THOSE FROM RADAR
C     CODED MESSAGE (SUBSET "NC002008")}
C 2016-11-30  D. A. KEYSER --
C     Added new output real, double-precision argument array RDATA8_8 of
C     length 2 to return full-precision latitude and longitude for a
C     report.
C     BENEFIT: Although lat and lon are returned in RDATA(1:2) these are
C              at machine precison, which is normally R*4.  Now that
C              many reports in the dumps store lat/lon at 0.001 or even
C              0.00001 degree precision, and now that PREPBUFR encodes
C              YOB (lat) and XOB (lon) at 0.00001 degree precision, this
C              change will ensure that lat/lon is always accurate to
C              0.00001 degrees in all downstream processing.
C 2020-08-20 J. DONG --
C   - Added processing to encode newly available VAD wind (NC002018)
C     and profiler wind (NC002014) tanks into prepbufr files. 
C
C USAGE:    CALL UNPKB703(LUNIT,RDATA,RDATA8_8,STNID,SUBSET,ITP,IRET)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE REPORT IN A QUASI-IW3UNPBF UNPACKED FORMAT WITH
C              - ALL DATA INITIALIZED AS MISSING (NOTE: DOES NOT
C              - INCLUDE STATION ID)
C     RDATA8_8 - 2-WORD REAL*8 ARRAY CONTAINING ADDITIONAL REPORT DATA
C                (LATITUDE AND LONGITUDE) (SEE REMARKS 7 FOR CONTENT)
C     STNID    - CHARACTER*8 SINGLE REPORT STATION IDENTIFICATION (UP
C              - TO 8 CHARACTERS, LEFT-JUSTIFIED - HERE INITIALIZED AS
C              - EITHER BLANKS OR "????????")
C     SUBSET   - CHARACTER*8 BUFR MESSAGE TYPE (SAME FOR ALL REPORTS
C              - IN A COMMON BUFR MESSAGE)
C     ITP      - THE TYPE OF REPORT THAT HAS BEEN DECODED {=1 - NPN
C              - WIND PROFILER, =2 - CAP WIND PROFILER, =3 - JMA WIND
C              - PROFILER, =4 - GOES SNDG, =5 - NEXRAD (VAD) WIND FROM
C              - RADAR CODED MESSAGE; =6 - ERS SCATTEROMETER WIND, =7 -
C              - QUIKSCAT SCATTEROMETER WIND, =8 - GPS-IPW, =9 - NPN
C              - or CAP RASS, =10 - WINDSAT SCATTEROMETER WIND (NAVY OR
C              - NESDIS), =11 - ASCAT SCATTEROMETER WIND; =12 - NEXRAD
C              - (VAD) WIND FROM LEVEL 2 DECODER}
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE REPORT IN A QUASI-IW3UNPBF UNPACKED FORMAT WITH
C              - HEADER INFORMATION FILLED IN (ALL OTHER DATA REMAINS
C              - MISSING) (NOTE: DOES NOT INCLUDE - STATION ID)
C     STNID    - CHARACTER*8 SINGLE REPORT STATION IDENTIFICATION (UP
C              - TO 8 CHARACTERS, LEFT-JUSTIFIED - HERE FILLED IN)
C     IRET     - RETURN CODE AS DESCRIBED IN W3UNPKB7 DOCBLOCK
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB703(LUNIT,RDATA,rdata8_8,STNID,SUBSET,ITP,IRET)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*1  C8TAG(3,0:3)
      CHARACTER*8  STNID,SID,SUBSET
      character*20 sid_gnss
      CHARACTER*60 HDRSTR, HDRSTR2
      INTEGER  IDATA(IDMAX),KOUNTG(3,0:3),IRPTYP(14)
      LOGICAL  SKIP_CAT12
      REAL(8) HDR_8(12),RPID_8,VAR_8,BMISS,rdata8_8(2)
      REAL  HDR(12),RDATA(*),RDATX(IDMAX)
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/KDATE(8),LDATE(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7FF/IFOV(4,2),KNTSAT(250:260)
 
      SAVE
 
      EQUIVALENCE  (RDATX,IDATA),(RPID_8,SID)

      DATA  XMISS/99999./,YMISS/99999.8/,IRPTYP/71,75,76,61,72,581,582,
     $ 74,77,583,584,72,72,76/
      DATA  HDRSTR/
     $ 'CLAT CLON SELV YEAR MNTH DAYS HOUR MINU SECO RCHR RCMI SAID '/
      DATA  HDRSTR2/
     $'CLATH CLONH HSMSL YEAR MNTH DAYS HOUR MINU SECO RCHR RCMI SAID '/
      DATA  ITIMESG/0/,KOUNTG/12*0/,ITIMESS/0/,KOUNTS/0/

C-----------------------------------------------------------------------
C     FOR GOES SOUNDING DATA ONLY:
C     CURRENT LIST OF  SATELLITE IDENTIFIERS (BUFR C.F. 0-01-007)
C     -----------------------------------------------------------
C
C       GOES  6 -- 250     GOES  9 -- 253     GOES 12 -- 256
C       GOES  7 -- 251     GOES 10 -- 254     GOES 13 -- 257
C       GOES  8 -- 252     GOES 11 -- 255     GOES 14 -- 258
C
C  IDSAT =       -- EVEN1 --   --- ODD1 --   -- EVEN2 --   --- ODD2 --
C   Sat. No. -   252,256,...   253,257,...   250,254,...   251,255,...
C  IRTYP =       CLR COR UNKN  CLR COR UNKN  CLR COR UNKN  CLR COR UNKN
C                --- --- ----  --- --- ----  --- --- ----  --- --- ----
C
      DATA C8TAG/'I','J','K',  'L','M','N',  'O','P','S',  'Q','R','T' /
C-----------------------------------------------------------------------

      IF(ITP.EQ.4)  THEN
         IF(ITIMESG.EQ.0)  THEN
            KOUNTG = 0
            ITIMESG = 1
         END IF
      ELSE IF(ITP.EQ.6.OR.ITP.EQ.7.OR.ITP.EQ.10.OR.ITP.EQ.11)  THEN
         IF(ITIMESS.EQ.0)  THEN
            KOUNTS = 0
            ITIMESS = 1
         END IF
      END IF

      RDATX(1:IDMAX) = RDATA(1:IDMAX)
      HDR_8 = BMISS
      IF(ITP.EQ.14.OR.ITP.EQ.13)  THEN
         CALL UFBINT(LUNIT,HDR_8,12,1,NLEV,HDRSTR2);HDR=HDR_8
      ELSE
         CALL UFBINT(LUNIT,HDR_8,12,1,NLEV,HDRSTR);HDR=HDR_8
      END IF
      IF(NLEV.NE.1)  GO TO 9999

C-----------------------------------------
C Output header - Word 1 (Stored as Real)
C-----------------------------------------

C  LATITUDE
 
      M = 1
      N = 1
      if(hdr_8(m).ge.bmiss)  then
         call ufbint(lunit,HDR_8(m),12,1,nlev,'CLATH')
         hdr(m) = hdr_8(m)
      end if
      IF(IPRINT.GT.1)  PRINT 199, hdr_8(M),M
  199 FORMAT(5X,'HDR_8 HERE IS: ',F18.5,'; INDEX IS: ',I3)
      IF(hdr_8(M).LT.bmiss)  THEN
         RDATX(N) = HDR(M)
         IF(IPRINT.GT.1)  PRINT 198, N,RDATX(N)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
         rdata8_8(1) = hdr_8(M)
         if(iprint.gt.1)  print *, 'RDATA8_8(1) STORED AS: ',rdata8_8(1)
      ELSE
         IRET = 3
         PRINT 102
  102    FORMAT(' *** W3UNPKB7 ERROR: LAT MISSING'/)
         RETURN
      END IF

C-----------------------------------------
C Output header - Word 2 (Stored as Real)
C-----------------------------------------

C  LONGITUDE
 
      M = 2
      N = 2
      if(hdr_8(m).ge.bmiss)  then
         call ufbint(lunit,HDR_8(m),12,1,nlev,'CLONH')
         hdr(m) = hdr_8(m)
      end if
      IF(IPRINT.GT.1)  PRINT 199, hdr_8(M),M
      IF(hdr_8(M).LT.bmiss)  THEN

C Important: According to BUFR Manual, CLON (0-06-002) - represented
C  here by "HDR(M)" - should be in units of Degrees West - and East +
C  (-180.0 to +180.0); however some BUFR data sets (e.g., PREPBUFR) are
C  known to encode 0-06-002 in units of Degrees East (0.0 to 359.99) --
C  So we use the following conversion to work in either case ...
         RDATX(N) = 360. - MOD(360.-HDR(M),360.)
         IF(RDATX(N).EQ.360.0)  RDATX(N) = 0.0
         IF(IPRINT.GT.1)  PRINT 198, N,RDATX(N)
         rdata8_8(2) = hdr_8(M)
         if(iprint.gt.1)  print *, 'RDATA8_8(2) STORED AS: ',rdata8_8(2)
      ELSE
         IRET = 3
         PRINT 104
  104    FORMAT(' *** W3UNPKB7 ERROR: LON MISSING'/)
         RETURN
      END IF
 
C-------------------------------------------
C Output header - Word 6 (Stored as Integer)
C-------------------------------------------

C  SATELLITE ID (GOES Soundings/Radiances, ERS Scatterometer,
C                QuikSCAT Scatterometer, WindSat Scatterometer,
C                ASCAT Scatterometer)

      M = 12
      N = 6
      IF(ITP.EQ.4.OR.ITP.EQ.6.OR.ITP.EQ.7.OR.ITP.EQ.10.OR.ITP.EQ.11)THEN
         IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
         IF(ITP.EQ.4)  THEN
            IDSAT = 2
            IF(HDR(M).LT.XMISS)  THEN
cfix?       IF(HDR(M).LT.YMISS)  THEN
               IDATA(N) = NINT(HDR(M))
               IDSAT = MOD(IDATA(N),4)
               IF(IDATA(N).GT.249.AND.IDATA(N).LT.260)  THEN
                  KNTSAT(IDATA(N)) = KNTSAT(IDATA(N)) + 1
               ELSE
                  KNTSAT(260) = KNTSAT(260) + 1
               END IF
            END IF
         ELSE
            IF(HDR(M).LT.XMISS)  IDATA(N) = NINT(HDR(M))
cfix?       IF(HDR(M).LT.YMISS)  IDATA(N) = NINT(HDR(M))
         END IF
         IF(IPRINT.GT.1)  PRINT 197, N,IDATA(N)
  197 FORMAT(5X,'IDATA(',I5,') STORED AS: ',I10)
      END IF

C-----------------------------------------
C Output header - Word 7 (Stored as Real)
C-----------------------------------------

C  STATION ELEVATION

C   GOES Soundings:                 Obtained from height of first 
C                                   (surface) level, stored later in
C                                   subroutine UNPKB707
C   ERS, QuikSCAT, WindSat or ASCAT
C                   Scatterometer:  Hardwired to 10 meters
C   All other types:                Obtained from reported station
C                                   height and stored here

      M = 3
      N = 7
      IF(ITP.EQ.6.OR.ITP.EQ.7.OR.ITP.EQ.10.OR.ITP.EQ.11)  THEN
         RDATX(N)  = 10.
         IF(IPRINT.GT.1)  PRINT 198, N,RDATX(N)
      ELSE IF(ITP.NE.4)  THEN
         IF(HDR(M).LT.XMISS)  RDATX(N) = NINT(HDR(M))
cfix?    IF(HDR(M).LT.YMISS)  RDATX(N) = NINT(HDR(M))
         IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
         IF(IPRINT.GT.1)  PRINT 198, N,RDATX(N)
      END IF

C--------------------------------------------
C Output header - Word 8 (Stored as Integer)
C--------------------------------------------

C  INSTRUMENT TYPE

C  GOES Soundings:         RETRIEVAL TYPE (GEOSTATIONARY SATELLITE
C                          DATA-PROCESSING TECHNIQUE USED)
 
      M = 13
      N = 8
      IF(ITP.EQ.4)  THEN
         CALL UFBINT(LUNIT,VAR_8,1,1,NLEV,'GSDP')
         VAR = VAR_8
         IF(NLEV.GT.1)  GO TO 9999
         IF(VAR.LT.XMISS)  IDATA(N) = NINT(VAR)
cfix?    IF(VAR.LT.YMISS)  IDATA(N) = NINT(VAR)
         IF(IPRINT.GT.1)  PRINT 199, VAR,M
         IF(IPRINT.GT.1)  PRINT 197, N,IDATA(N)
      END IF

C-------------------------------------------
C Output header - Word 9 (Stored as Integer)
C-------------------------------------------

C  REPORT TYPE
 
      N = 9
      IDATA(N)  = IRPTYP(ITP)
      IF(IPRINT.GT.1)  PRINT 197, N,IDATA(N)
 
C-------------------------------------------------
C Output argument - "STNID" (Stored as Character)
C-------------------------------------------------

C  STATION IDENTIFICATION

      M = 14
      if(subset.eq.'NC012004') then
C.......................................................................
C  GPS Integrated Precipitable Water from new "GNSS" BUFR feed:
C.......................................................................
         call readlc(lunit,sid_gnss,'STSN')
         if(sid_gnss.eq.'                    ')  nlev = 0
         if(nlev.eq.0)  go to 9999
         sid = sid_gnss(1:4)//sid_gnss(6:9)
         if(iprint.gt.1)  print 299, sid,m
C    STNID is stored directly from STSN(1:4)//STSN(6:9)
         stnid = sid
      else

      CALL UFBINT(LUNIT,RPID_8,1,1,NLEV,'RPID ')

cpppppppppp
cc    print'(" rpid_8,icbfms(sid,8): ",G0,1X,I0)', rpid_8,icbfms(sid,8)
cpppppppppp
      IF(ICBFMS(SID,8).NE.0) NLEV = 0
C above line not working right - may return 0 when missing, so use next
C  two lines below temporarily until this is fixed (readlc will return
C  all blanks for sid when mnemonic "RPID" not found) - dak 2/19/13
         call readlc(lunit,sid,'RPID')
cpppppppppp
cc    print'(" sid = ",A)', sid
cpppppppppp
         if(sid.eq.'        ')  nlev = 0

      IF(ITP.LE.3.OR.ITP.EQ.14)  THEN

C.......................................................................
C  Wind Profiler:
C.......................................................................

         IF(NLEV.EQ.1)  THEN
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C            If decoded RPID is not missing set STNID to it
C   (test on "NLEV" for missing "RPID" - valid RPID_8 can be > BMISS!)
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            IF(IPRINT.GT.1)  PRINT 299, SID,M
  299 FORMAT(5X,'RPID HERE IS: ',9X,A8,'; INDEX IS: ',I3)
            IF(IPRINT.GT.1)  PRINT 2198
 2198 FORMAT(5X,'STN. ID PRESENT IN INPUT FILE, DO NOT GENERATE HERE')
            STNID = SID
         ELSE
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C       If decoded RPID is missing then generate STNID from
C                   decoded WMO block/stn numbers
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            IF(IPRINT.GT.1)  PRINT 2188
 2188 FORMAT(5X,'STN. ID NOT PRESENT IN INPUT FILE, USE WMO BLOCK/',
     $ 'STATION NUMBER TO GENERATE IT HERE'/)
            CALL UFBINT(LUNIT,VAR_8,1,1,NLEV,'WMOB') ! Block Number
            VAR = VAR_8
            IF(NLEV.GT.1)  GO TO 9999
            IF(IPRINT.GT.1)  PRINT 199, VAR,M
            IF(VAR.LT.XMISS)  WRITE(STNID(1:2),'(I2.2)') NINT(VAR)
cfix?       IF(VAR.LT.YMISS)  WRITE(STNID(1:2),'(I2.2)') NINT(VAR)
            CALL UFBINT(LUNIT,VAR_8,1,1,NLEV,'WMOS') ! Station Number
            VAR = VAR_8
            IF(NLEV.GT.1)  GO TO 9999
            IF(IPRINT.GT.1)  PRINT 199, VAR,M
            IF(VAR.LT.XMISS)  WRITE(STNID(3:5),'(I3.3)') NINT(VAR)
cfix?       IF(VAR.LT.YMISS)  WRITE(STNID(3:5),'(I3.3)') NINT(VAR)
         END IF

      ELSE IF(ITP.EQ.5 .OR. ITP.EQ.12 .OR. ITP.EQ.13)  THEN

C.......................................................................
C  NEXRAD (VAD) Wind:
C.......................................................................

         IF(NLEV.NE.1)  GO TO 9999
         IF(IPRINT.GT.1)  PRINT 299, SID,M
         IF(ITP.EQ.5 .AND. SID(5:7).EQ.'   ')  THEN
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C   RCM VAD Winds Before 02/18/1999 -->
C    Decoded RPID contains only the 4-character Product Source ID
C    STNID is stored as:
C               '99'//last 3-characters of Product Source ID//'   '
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            STNID = '99'//SID(2:4)//'   '
         ELSE
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C   After  02/18/1999 -->
C    STNID is stored directly from RPID as:
C        RCM VAD: 4-character Product Source ID//3-character RCM ID//' '
C        NEW VAD: 4-character Product Source ID//'    '
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            STNID = SID
         END IF
      ELSE IF(ITP.EQ.4)  THEN

C.......................................................................
C  GOES Soundings:
C.......................................................................

         IF(NLEV.NE.1.OR.(SID(8:8).LT.'A'.OR.SID(8:8).GT.'Z'))  THEN
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C  If decoded RPID is missing or if the eighth character of RPID is not
C             "A"-"Z", then this subr. must generate STNID
C       (indicates an input data dump file prior to Dec. 2000)
C   (test on "NLEV" for missing "RPID" - valid RPID_8 can be > BMISS!)
C
C         STNID Generated as Follows:
C          Characters 1-7 obtained from 7-digit count number (specific
C            to Satellite ID/Retrieval Type)
C            (For SFOV retrievals, character 1 replaced with "H")
C          Character 8 obtained from Satellite ID/Retrieval Type Tag
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            IRTYP = 3      ! Unknown retrieval type (default)
            IF(IDATA(8).EQ.21)  THEN
               IRTYP = 1   ! Clear retrieval type
            ELSE  IF(IDATA(8).EQ.23)  THEN
               IRTYP = 2   ! Cloudy retrieval type
            END IF
            IF(IPRINT.GT.1)  PRINT 2197, IDSAT,IRTYP
 2197 FORMAT(5X,'STN. ID NOT PRESENT IN INPUT FILE, MUST GENERATE HERE'/
     $       5X,'IDSAT IS: ',I10,', IRTYP IS: ',I10)
            STNID(8:8) = C8TAG(IRTYP,IDSAT)
            KOUNTG(IRTYP,IDSAT) = MIN(KOUNTG(IRTYP,IDSAT)+1,9999999)
            WRITE(STNID(1:7),'(I7.7)')  KOUNTG(IRTYP,IDSAT)
            IF(SUBSET.EQ.'NC003002' .or. SUBSET.EQ.'NC003003')
     $       STNID(1:1) = 'H'
         ELSE
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C     If decoded RPID is NOT missing AND if the eighth character of
C    RPID is "A"-"Z", then the dump program BUFR_DUPSAT has already
C   created the proper Station ID in RPID - generate STNID from RPID
C         (indicates an input data dump file after Dec. 2000)
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            IF(IPRINT.GT.1)  PRINT 2198
            STNID = SID
         END IF
      ELSE IF(ITP.EQ.6.OR.ITP.EQ.7.OR.ITP.EQ.10.OR.ITP.EQ.11)  THEN

C.......................................................................
C  ERS, QuikSCAT, WindSat or ASCAT Scatterometer:
C.......................................................................

         IF(NLEV.NE.1.OR.(SID(8:8).LT.'A'.OR.SID(8:8).GT.'Z'))  THEN
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C  If decoded RPID is missing or if the eighth character of RPID is not
C             "A"-"Z", then this subr. must generate STNID
C   (indicates an input reprocessed data dump file prior to Dec. 2000)
C   (test on "NLEV" for missing "RPID" - valid RPID_8 can be > BMISS!)
C
C         STNID Generated as Follows:
C          Characters 1-7 obtained from 7-digit count number
C          Character 8 is "E" for ERS, "Q" for QuikSCAT, "W" for
C           WindSat or "A" for ASCAT
C            (Note: Reprocessed QuikSCAT data dumps never contained
C                   SUPERobs and reports were always from Satellite ID
C                   281 prior to Dec. 2000 - this means 2'nd character
C                   was never "S" and 8'th character was always "Q")
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            IF(IPRINT.GT.1)  PRINT 2197
            IF(ITP.EQ.6)  THEN
               STNID(8:8) = 'E'
            ELSE IF(ITP.EQ.7)  THEN
               STNID(8:8) = 'Q'
            ELSE IF(ITP.EQ.10)  THEN
               STNID(8:8) = 'W'
            ELSE IF(ITP.EQ.11)  THEN
               STNID(8:8) = 'A'
            END IF
            KOUNTS = MIN(KOUNTS+1,9999999)
            WRITE(STNID(1:7),'(I7.7)')  KOUNTS
         ELSE
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C     If decoded RPID is NOT missing AND if the eighth character of
C     RPID is "A"-"Z", then the dump program WAVE_DATASORT (ERS),
C      WAVE_DCODQUIKSCAT (QuikSCAT, ASCAT) or BUFR_DCODWINDSAT
C      (WindSat) has already created the proper Station ID in RPID -
C      generate STNID from RPID (indicates an input reprocessed dump
C      file after Dec. 2000)
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
            IF(IPRINT.GT.1)  PRINT 2198
            STNID = SID
         END IF
      ELSE IF(ITP.EQ.8.OR.ITP.EQ.9)  THEN

C.......................................................................
C  GPS Integrated Precipitable Water or RASS:
C.......................................................................

         IF(NLEV.NE.1)  GO TO 9999
         IF(IPRINT.GT.1)  PRINT 299, SID,M
C    STNID is stored directly from RPID
         STNID = SID
C.......................................................................
      END IF
      end if
      IF(IPRINT.GT.1)  PRINT 196, STNID
  196 FORMAT(5X,'STNID STORED IN CHARACTER AS: "',A8,'"')
 
C---------------------------------------------
C Output header - Word  4 (Stored as Real)
C  OBSERVATION TIME
C Output header - Word  5 (Stored as Integer)
C  DATE (STORED IN FORM YYYYMMDDHH)
C---------------------------------------------
 
      M = 4
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      M = 5
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      M = 6
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      M = 7
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      M = 8
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      M = 9
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      IF(HDR(9).GE.XMISS)  HDR(9) = 0.
      IF(MIN(HDR(4),HDR(5),HDR(6),HDR(7),HDR(8)).GE.XMISS)  GO TO 30
cfix? IF(HDR(9).GE.YMISS)  HDR(9) = 0.
cfix? IF(MIN(HDR(4),HDR(5),HDR(6),HDR(7),HDR(8)).GE.YMISS)  GO TO 30
      N = 4
      RDATX(N) = (HDR(7) + ((HDR(8) * 60.) + HDR(9))/3600.)
cdak $ + 0.0001 ! don't make this adjustment now that we store obs time
                ! to 10**5 in PREPBUFR
      IF(IPRINT.GT.1)  PRINT 198, N,RDATX(N)
      N = 5
      IDATA(N) = (NINT(HDR(4)) * 1000000) + (NINT(HDR(5)) * 10000) +
     $ (NINT(HDR(6)) * 100) + NINT(HDR(7))
      IF(IPRINT.GT.1)  PRINT 197, N,IDATA(5)

C---------------------------------------------
C Output header - Word  11 (Stored as Real)
C  RECEIPT TIME
C---------------------------------------------

      M = 10
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      M = 11
      IF(IPRINT.GT.1)  PRINT 199, HDR(M),M
      IF(MAX(HDR(10),HDR(11)).LT.XMISS)  THEN
         N = 11
         RDATX(N) = (HDR(10) + ((HDR(11) * 60.))/3600.) + 0.0001
         IF(IPRINT.GT.1)  PRINT 198, N,RDATX(N)
      END IF

      RDATA(1:IDMAX) = RDATX(1:IDMAX)

      RETURN

C-----------------------------------------------------------------------
   30 CONTINUE
C PROBLEM: SOME OR ALL DATE INFORMATION IS MISSING --
C  SET IRET = 4 AND RETURN
      PRINT 317
  317 FORMAT(/'##W3UNPKB7: SOME OR ALL DATE INFORMATION IS MISSING - ',
     $ 'IRET = 4'/)
      IRET = 4
      RETURN
C-----------------------------------------------------------------------
 9999 CONTINUE
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS NOT WHAT IS EXPECTED --
C  SET IRET = 6 AND RETURN
      PRINT 217, NLEV
  217 FORMAT(/'##W3UNPKB7: THE NUMBER OF DECODED "LEVELS" (=',I5,') ',
     $ 'IS NOT WHAT IS EXPECTED (1) - IRET = 6'/)
      IRET = 6
      RETURN
C-----------------------------------------------------------------------

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB704
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2008-09-25
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   SURFACE DATA FOR WIND PROFILER REPORTS NOT ORIGINATING FROM PILOT
C   (PIBAL) FORMAT BULLETINS, AND 10 METER DATA FOR ERS SCATTEROMETER,
C   QUIKSCAT SCATTEROMETER, WINDSAT (NAVY OR NESDIS) SCATTEROMETER OR
C   ASCAT SCATTEROMETER WIND REPORTS.  SURFACE DATA ARE THEN FILLED
C   INTO THE OUTPUT ARRAY AS DATA LEVEL CATEGORY 10.  THE OUTPUT ARRAY
C   HOLDS A SINGLE WIND PROFILER, ERS SCATTEROMETER, QUIKSCAT
C   SCATTEROMETER, WINDSAT SCATTEROMETER OR ASCAT SCATTEROMETER REPORT
C   IN THE QUASI-IW3UNPBF UNPACKED FORMAT.
C
C PROGRAM HISTORY LOG:
C 1996-12-16  D. A. KEYSER NP22 - ORIGINAL AUTHOR (WIND PROFILER ONLY)
C 1999-02-12  D. A. KEYSER -- ADDED ERS SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2000-09-22  D. A. KEYSER -- CORRECTED VALUE FOR RETURNED RAINFALL;
C     ADDED QUIKSCAT SCATTEROMETER WINDS HERE NOW THAT THEY ARE PACKED
C     IN A NCEP BUFR FILE
C 2002-03-05  D. A. KEYSER -- ACCOUNTS FOR CHANGES IN INPUT PROFLR
C     (WIND PROFILER BUFR DUMP FILE AFTER 5/2002: SURFACE DATA NOW ALL
C     MISSING (MNEMONICS "PMSL","WDIR1","WSPD1", "TMDB", "REHU", "REQV"
C     NO LONGER AVAILABLE) (WILL STILL WORK PROPERLY FOR INPUT PROFLR
C     DUMP FILES PRIOR TO 5/2002)
C 2006-07-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     ADDED WINDSAT SCATTEROMETER WINDS HERE NOW THAT THEY ARE PACKED
C     IN A NCEP BUFR FILE; RAINFALL RATE NOW RETURNED IN ORIGINAL BUFR
C     UNITS OF KG/((M**2)*SEC) INSTEAD OF MM/HOUR (WINDSAT IS ONLY TYPE
C     TO RETURN THIS)
C 2008-09-25  D. A. KEYSER -- ADDED ASCAT SCATTEROMETER WINDS HERE NOW
C     THAT THEY ARE PACKED IN A NCEP BUFR FILE
C 2020-08-20  J. DONG -- ADDED TO HANDLE PROFILER WIND FROM HONG KONG
C
C USAGE:    CALL UNPKB704(LUNIT,RDATA,ITP,IRET)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE WIND PROFILER, ERS SCATTEROMETER, QUIKSCAT
C              - SCATTEROMETER, WINDSAT SCATTEROMETER OR ASCAT
C              - SCATTEROMETER REPORT IN A QUASI-IW3UNPBF UNPACKED
C              - FORMAT WITH ONLY HEADER INFORMATION FILLED IN (ALL
C              - OTHER DATA REMAINS MISSING)
C     ITP      - THE TYPE OF REPORT THAT HAS BEEN DECODED {=1 - NPN
C              - WIND PROFILER, =2 - CAP WIND PROFILER, =3 - JMA WIND
C              - PROFILER, =6 - ERS SCATTEROMETER WIND, =7 - QUIKSCAT
C              - SCATTEROMETER WIND, =10 - WINDSAT SCATTEROMETER WIND
C              - (NAVY OR NESDIS), =11 - ASCAT SCATTEROMETER WIND}
C              - =14 - HONG KONG WIND PROFILER
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE WIND PROFILER, ERS SCATTEROMETER, QUIKSCAT
C              - SCATTEROMETER, WINDSAT SCATTEROMETER OR ASCAT
C              - SCATTEROMETER REPORT IN A QUASI-IW3UNPBF UNPACKED
C              - FORMAT WITH SURFACE INFORMATION FILLED IN (AS WELL AS
C              - HEADER INFORMATION)
C     IRET     - RETURN CODE AS DESCRIBED IN W3UNPKB7 DOCBLOCK
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB704(LUNIT,RDATA,ITP,IRET)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*40  SRFCP,SRFCS
      INTEGER  IDATA(IDMAX)
      REAL(8) SFC_8(8),BMISS
      REAL  SFC(8),RDATA(*),RDATX(IDMAX)
      LOGICAL  SKIP_CAT12
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/kdate(8),ldate(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15
 
      SAVE
 
      EQUIVALENCE (RDATX,IDATA)
      DATA  XMISS/99999./
      DATA  SRFCP/'PMSL WDIR1 WSPD1 TMDB REHU REQV         '/
      DATA  SRFCS/'PMSL WD10  WS10  TMDB REHU REQV         '/
      RDATX(1:IDMAX) = RDATA(1:IDMAX)
      SFC_8 = BMISS
      IF(ITP.LE.3.OR.ITP.EQ.14)  THEN ! wind profiler
         CALL UFBINT(LUNIT,SFC_8,8,1,NLEV,SRFCP);SFC=SFC_8
         ILVL = 1
      ELSE               ! scatterometer
         CALL UFBINT(LUNIT,SFC_8,8,1,NLEV,SRFCS);SFC=SFC_8
         ILVL = 0
      END IF
      IF(NLEV.NE.1)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS NOT WHAT IS EXPECTED --
         IF(ITP.LE.3.OR.ITP.EQ.14)  THEN ! for wind profiler return but don't
                            ! reset iret
            PRINT 217, NLEV
  217 FORMAT(/'##W3UNPKB7: THE NUMBER OF DECODED "LEVELS" (=',I5,') ',
     $ 'IS NOT WHAT IS EXPECTED (1) - NO SFC DATA PROCESSED'/)
            GO TO 99
         ELSE               ! for scatterometer set iret = 7 and return
            PRINT 218, NLEV
  218 FORMAT(/'##W3UNPKB7: THE NUMBER OF DECODED "LEVELS" (=',I5,') ',
     $ 'IS NOT WHAT IS EXPECTED (1) - IRET = 7'/)
            IRET = 7
            RETURN
         END IF
C.......................................................................
      END IF
 

C       MSL PRESSURE (STORED AS REAL)
 
      M = 1
      IF(IPRINT.GT.1)  PRINT 199, SFC(1),M
  199 FORMAT(5X,'SFC HERE IS: ',F17.4,'; INDEX IS: ',I3)
      IF((SFC(1)*0.1).LT.XMISS)  THEN
         ILVL = 1
         RDATX(IDATS_10) = NINT(SFC(1) * 0.1)
      END IF
      NNNNN = IDATS_10
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_10)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
 
C       SURFACE HORIZONTAL WIND DIRECTION (STORED AS REAL)
 
      M = 2
      IF(IPRINT.GT.1)  PRINT 199, SFC(2),M
      IF(SFC(2).LT.XMISS)  THEN
         ILVL = 1
         RDATX(IDATS_10+2) = NINT(SFC(2))
      END IF
      NNNNN = IDATS_10 + 2
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_10+2)
 
C       SURFACE HORIZONTAL WIND SPEED (STORED AS REAL)
 
      M = 3
      IF(IPRINT.GT.1)  PRINT 199, SFC(3),M
      IF(SFC(3).LT.XMISS)  THEN
         ILVL = 1
         RDATX(IDATS_10+3) = NINT(SFC(3) * 10.)
      END IF
      NNNNN = IDATS_10 + 3
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_10+3)
 
C       SURFACE TEMPERATURE (STORED AS REAL)
 
      M = 4
      IF(IPRINT.GT.1)  PRINT 199, SFC(4),M
      IF(SFC(4).LT.XMISS)  THEN
         ILVL = 1
         RDATX(IDATS_10+4) = NINT(SFC(4) * 10.)
      END IF
      NNNNN = IDATS_10 + 4
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_10+4)
 
C       RELATIVE HUMIDITY (STORED AS REAL)
 
      M = 5
      IF(IPRINT.GT.1)  PRINT 199, SFC(5),M
      IF(SFC(5).LT.XMISS)  THEN
         ILVL = 1
         RDATX(IDATS_10+5) = NINT(SFC(5))
      END IF
      NNNNN = IDATS_10 + 5
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_10+5)
 
C       RAINFALL RATE (STORED AS REAL)
 
      M = 6
      IF(IPRINT.GT.1)  PRINT 199, SFC(6),M
      IF(SFC(6).LT.XMISS)  THEN
         ILVL = 1
         RDATX(IDATS_10+6) = SFC(6)
      END IF
      NNNNN = IDATS_10 + 6
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,(RDATX(IDATS_10+6)*3600.)
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR SURFACE DATA
 
      IDATA(35) = ILVL
      IF(IPRINT.GT.1)  PRINT'(1X,I0," CAT. 10 LEVELS PROCESSED")',
     $ IDATA(35)
      IF(IDATA(35).GT.0)  IDATA(36) = IDATS_10

      IF(IDATA(35).EQ.0)  IRET = 5 ! Can only happen for scatterometer
                                   ! because for wind profiler
                                   ! IDATA(35)=1 even if all parameters
                                   ! here are missing

   99 CONTINUE
      IF(IPRINT.GT.1)  PRINT'(" IDATA(35)=",I0,"; IDATA(36)=",I0)',
     $ IDATA(35),IDATA(36)
      RDATA(1:IDMAX) = RDATX(1:IDMAX)
      RETURN
      END
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB705
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2014-03-13
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   UPPER-AIR DATA FOR WIND PROFILER REPORT NOT ORIGINATING FROM PILOT
C   (PIBAL) FORMAT BULLETINS.  UPPER-AIR DATA ARE THEN FILLED INTO THE
C   OUTPUT ARRAY AS DATA LEVEL CATEGORY 11.  THE OUTPUT ARRAY HOLDS A
C   SINGLE WIND PROFILER REPORT IN THE QUASI-IW3UNPBF UNPACKED FORMAT.
C
C PROGRAM HISTORY LOG:
C 1996-12-16  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C 1998-06-14  D. A. KEYSER -- MODIFIED WIND PROFILER CAT. 11 (HEIGHT,
C     HORIZ. SIGNIFICANCE, VERT. SIGNIFICANCE) PROCESSING TO ACCOUNT
C     FOR UPDATES TO BUFRTABLE MNEMONICS IN /dcom
C 2002-01-28  D. A. KEYSER -- THE QUALITY CODE FOR WIND PROFILER LEVELS
C     IS NOW SET TO 14 IF THE DECODED QN29 WIND QUALITY MARKER IS 12
C     (REJECT LIST) OR 14 (SDM PURGE), OTHERWISE IT IS SET TO THE
C     DECODED QUALITY CODE VALUE (BEFORE THE ON29 Q.M. WAS IGNORED)
C 2002-03-05  D. A. KEYSER -- ACCOUNTS FOR CHANGES IN INPUT PROFLR
C     (WIND PROFILER BUFR DUMP FILE AFTER 5/2002: MNEMONICS "ACAVH",
C     "ACAVV", "SPP0", AND "NPHL" NO LONGER AVAILABLE (WILL STILL WORK
C     PROPERLY FOR INPUT PROFLR DUMP FILES PRIOR TO 5/2002)
C 2014-03-13  D. A. KEYSER -- MAXIMUM NUMBER OF CAT. 11 WIND PROFILER
C     LEVELS ALLOWED (EXCLUDING FIRST, SURFACE, LEVEL), "ILVLMX_11",
C     INCREASED FROM 102 TO 200 TO ACCOUNT FOR SOME MAP PROFILERS WITH
C     MORE LEVELS THAN BEFORE
C
C USAGE:    CALL UNPKB705(LUNIT,RDATA,ITP)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE WIND PROFILER REPORT IN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT WITH ONLY HEADER AND SURFACE
C              - INFORMATION FILLED IN (UPPER-AIR DATA MISSING)
C     ITP      - THE TYPE OF WIND PROFILER REPORT THAT HAS BEEN
C              - DECODED {=1 - NOAA Profiler Network (NPN),
C              - =2 - COOPERATIVE AGENCY PROFILERS (CAP),
C              - =3 - JAPAN AND HONG KONG}
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE WIND PROFILER REPORT IN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT WITH UPPER-AIR INFORMATION FILLED IN
C              - (ALL DATA FOR REPORT NOW FILLED)
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB705(LUNIT,RDATA,ITP)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*33  UAIR1,UAIR2,UAIR3
      INTEGER  IDATA(IDMAX)
      LOGICAL  SKIP_CAT12
      REAL(8) UAIR1_8(6,255),UAIR2_8(6,255),UAIR3_8(5,255),BMISS
      REAL  UAIR(17,255),RDATA(*),RDATX(IDMAX)
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/kdate(8),ldate(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15
 
      SAVE
 
      EQUIVALENCE (RDATX,IDATA)
      DATA  XMISS/99999./
      DATA  UAIR1/'HEIT  WDIR  WSPD  QMWN NPQC WCMP '/
      DATA  UAIR2/'ACAVH ACAVV SPP0  SDHS SDVS NPHL '/
      DATA  UAIR3/'HAST  ACAV1 ACAV2 QMRK STNR      '/
      RDATX(1:IDMAX) = RDATA(1:IDMAX)
      NSFC = 0
      ILVL = 0
      ILC =  0
C FIRST UPPER-AIR LEVEL IS THE SURFACE INFORMATION
      IF(IPRINT.GT.1)  PRINT 1078, ILC,ILVL
 1078 FORMAT(' ATTEMPTING 1ST (SFC) LVL WITH ILC =',I5,'; NO. LEVELS ',
     $ 'PROCESSED TO NOW =',I5)
      RDATX(IDATS_11+ILC) = RDATX(7)
      IF(IPRINT.GT.1)  PRINT 198, IDATS_11+ILC,RDATX(IDATS_11+ILC)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
      IF(RDATX(IDATS_11+ILC).LT.XMISS)  NSFC = 1
      IF(IDATA(35).GE.1)  THEN
         RDATX(IDATS_11+ILC+1) = RDATX(IDATA(36)+2)
         RDATX(IDATS_11+ILC+2) = RDATX(IDATA(36)+3)
      END IF
      IF(IPRINT.GT.1)  PRINT 198, IDATS_11+ILC+1,RDATX(IDATS_11+ILC+1)
      IF(RDATX(IDATS_11+ILC+1).LT.XMISS)  NSFC = 1
      IF(IPRINT.GT.1)  PRINT 198, IDATS_11+ILC+2,RDATX(IDATS_11+ILC+2)
      IF(RDATX(IDATS_11+ILC+2).LT.XMISS)  NSFC = 1
      ILVL = ILVL + 1
      ILC = ILC + 11
      IF(IPRINT.GT.1) PRINT'(" HAVE COMPLETED LEVEL ",I0," WITH NSFC=",
     $ I0,"; GOING INTO NEXT LEVEL WITH ILC=",I0)', ILVL,NSFC,ILC
      UAIR1_8 = BMISS
      UAIR2_8 = BMISS
      UAIR3_8 = BMISS
      CALL UFBINT(LUNIT,UAIR1_8,6,255,NLEV1,UAIR1)
      CALL UFBINT(LUNIT,UAIR2_8,6,255,NLEV2,UAIR2)
      CALL UFBINT(LUNIT,UAIR3_8,5,255,NLEV3,UAIR3)
      NLEV = MAX(NLEV1,NLEV2,NLEV3)
      UAIR( 1: 6,:) = UAIR1_8(:,:)
      UAIR( 7:12,:) = UAIR2_8(:,:)
      UAIR(13:17,:) = UAIR3_8(:,:)
      IF(IPRINT.GT.1)  PRINT 1068, NLEV
 1068 FORMAT(' THIS REPORT CONTAINS ',I3,' LEVELS OF DATA (NOT ',
     $ 'INCLUDING BOTTOM -SURFACE- LEVEL)')
      IF(NLEV.EQ.0)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS ZERO --
         IF(NSFC.EQ.0)  THEN
C ... NO UPPER AIR DATA PROCESSED
            PRINT 217
  217       FORMAT(/'##W3UNPKB7: NO UPPER-AIR DATA PROCESSED FOR THIS',
     $       ' REPORT -- NLEV = 0 AND NSFC = 0'/)
            GO TO 99
         ELSE
C ... ONLY FIRST (SURFACE) UPPER AIR LEVEL DATA PROCESSED
            PRINT 218
  218 FORMAT(/'##W3UNPKB7: NO UPPER-AIR DATA ABOVE FIRST (SURFACE) ',
     $ 'LEVEL PROCESSED FOR THIS REPORT -- NLEV = 0 AND NSFC > 0'/)
            GO TO 98
         END IF
C.......................................................................
      ELSE  IF(NLEV.GT.ILVLMX_11)  THEN
C PROBLEM: THE NUMBER OF DECODED "LEVELS" {EXCLUDING BOTTOM (SURFACE)
C  LEVEL} IS .GT. LIMIT OF "ILVLMX_11" --
         PRINT 2186, NLEV,ILVLMX_11,ILVLMX_11
 2186    FORMAT(/'##W3UNPKB7: NUMBER OF UPPER-AIR LEVELS FOR THIS ',
     $    'REPORT (=',I3,') EXCEEDS LIMIT OF ',I0,' CAT. 11 LEVELS ',
     $    '(EXCLUDING BOTTOM, SFC, LVL) -- '/'     ONLY FIRST ',I0,
     $    ' UPPER-AIR LEVELS PLUS THE SURFACE LEVEL WILL BE PROCESSED'/)
         NLEV = ILVLMX_11
C.......................................................................
      END IF
      DO I = 1,NLEV
         IF(IPRINT.GT.1)  PRINT 1079, ILC,ILVL
 1079 FORMAT(' ATTEMPTING NEW LEVEL WITH ILC =',I5,'; NO. LEVELS ',
     $ 'PROCESSED TO NOW =',I5)
 
C       HEIGHT ABOVE SEA-LEVEL (STORED AS REAL)
C        (NOTE: Prior to 2/18/1999, the height above sea level was
C               erroneously stored under mnemonic "HAST" when it should
C               have been stored under mnemonic "HEIT". This was
C               corrected after this date.  ("HAST" is defined as the
C               height above the station.)
C               Will test first for valid data in "HEIT" - if missing,
C               then will use data in "HAST" - this will allow this
C               routine to work properly with historical data.
 
         IF(UAIR(1,I).LT.XMISS)  THEN
            M = 1
            IF(IPRINT.GT.1)  PRINT 199, UAIR(1,I),M
  199 FORMAT(5X,'UAIR HERE IS: ',F17.4,'; INDEX IS: ',I3)
            RDATX(IDATS_11+ILC) = NINT(UAIR(1,I))
         ELSE
            M = 13
            IF(IPRINT.GT.1)  PRINT 199, UAIR(13,I),M
            IF(UAIR(13,I).LT.XMISS) RDATX(IDATS_11+ILC)=NINT(UAIR(13,I))
         END IF
         IF(IPRINT.GT.1)  PRINT 198, IDATS_11+ILC,RDATX(IDATS_11+ILC)
         ILVL = ILVL + 1
 
C       HORIZONTAL WIND DIRECTION (STORED AS REAL)
 
         M = 2
         IF(IPRINT.GT.1)  PRINT 199, UAIR(2,I),M
         IF(UAIR(2,I).LT.XMISS)  RDATX(IDATS_11+ILC+1) = NINT(UAIR(2,I))
         IF(IPRINT.GT.1) PRINT 198, IDATS_11+ILC+1,RDATX(IDATS_11+ILC+1)
 
C       HORIZONTAL WIND SPEED (STORED AS REAL)
 
         M = 3
         IF(IPRINT.GT.1)  PRINT 199, UAIR(3,I),M
         IF(UAIR(3,I).LT.XMISS)RDATX(IDATS_11+ILC+2)=NINT(UAIR(3,I)*10.)
         IF(IPRINT.GT.1) PRINT 198, IDATS_11+ILC+2,RDATX(IDATS_11+ILC+2)
 
C       QUALITY CODE (STORED AS INTEGER)
C          IF SDMEDIT/QUIPS WIND QUALITY MARKER IS 12 (REJECT LIST) OR
C          14 (SDM PURGE) THEN A VALUE OF 14 IS STORED FOR THE QUALITY
C          CODE; OTHERWISE THE DECODED QUALITY CODE IS STORED DIRECTLY
 
         M = 4
         IF(IPRINT.GT.1)  PRINT 199, UAIR(4,I),M
         M = 5
         IF(IPRINT.GT.1)  PRINT 199, UAIR(5,I),M
         M = 16
         IF(IPRINT.GT.1)  PRINT 199, UAIR(16,I),M
         IF(UAIR(4,I).EQ.12.OR.UAIR(4,I).EQ.14)  THEN
            IDATA(IDATS_11+ILC+3) = 14
         ELSE  IF(UAIR(5,I).LT.XMISS) THEN   ! NPN or CAP
            IDATA(IDATS_11+ILC+3) = NINT(UAIR(5,I))
         ELSE  IF(UAIR(16,I).LT.XMISS) THEN  ! Japanese
            IDATA(IDATS_11+ILC+3) = NINT(UAIR(16,I))
         END IF
         IF(IPRINT.GT.1) PRINT 197, IDATS_11+ILC+3,IDATA(IDATS_11+ILC+3)
  197 FORMAT(5X,'IDATA(',I5,') STORED AS: ',I10)
 
C       VERTICAL WIND COMPONENT (W) (STORED AS REAL)
 
         M = 6
         IF(IPRINT.GT.1)  PRINT 199, UAIR(6,I),M
        IF(UAIR(6,I).LT.XMISS)RDATX(IDATS_11+ILC+4)=NINT(UAIR(6,I)*100.)
         IF(IPRINT.GT.1) PRINT 198, IDATS_11+ILC+4,RDATX(IDATS_11+ILC+4)
 
C       HORIZONTAL CONSENSUS NUMBER (STORED AS INTEGER)
C        (NOTE: Prior to 2/18/1999, the horizonal consensus number was
C                stored under mnemonic "ACAV1".
C               From 2/18/1999 through 5/2002, the horizontal consensus
C                number was stored under mnemonic "ACAVH".
C               After 5/2002, the horizontal consensus number is no
C                longer stored.
C               Will test first for valid data in "ACAVH" - if missing,
C                then will test for data in "ACAV1" - this will allow
C                this routine to work properly with historical data.)
 
         IF(IPRINT.GT.1)  PRINT 199, UAIR(7,I),M
         IF(IPRINT.GT.1)  PRINT 199, UAIR(14,I),M
         IF(UAIR(7,I).LT.XMISS)  THEN
            M = 7
            IDATA(IDATS_11+ILC+5) = NINT(UAIR(7,I))
         ELSE
            M = 14
           IF(UAIR(14,I).LT.XMISS)IDATA(IDATS_11+ILC+5)=NINT(UAIR(14,I))
         END IF
         IF(IPRINT.GT.1) PRINT 197, IDATS_11+ILC+5,IDATA(IDATS_11+ILC+5)
 
C       VERTICAL CONSENSUS NUMBER (STORED AS INTEGER)
C        (NOTE: Prior to 2/18/1999, the vertical consensus number was
C                stored under mnemonic "ACAV2".
C               From 2/18/1999 through 5/2002, the vertical consensus
C                number was stored under mnemonic "ACAVV".
C               After 5/2002, the vertical consensus number is no
C                longer stored.
C               Will test first for valid data in "ACAVV" - if missing,
C                then will test for data in "ACAV2" - this will allow
C                this routine to work properly with historical data.)
 
         IF(UAIR(8,I).LT.XMISS)  THEN
            M = 8
            IF(IPRINT.GT.1)  PRINT 199, UAIR(8,I),M
            IDATA(IDATS_11+ILC+6) = NINT(UAIR(8,I))
         ELSE  IF(UAIR(15,I).LT.XMISS)  THEN
            M = 15
            IF(IPRINT.GT.1)  PRINT 199, UAIR(15,I),M
            IDATA(IDATS_11+ILC+6)=NINT(UAIR(15,I))
         END IF
         IF(IPRINT.GT.1) PRINT 197, IDATS_11+ILC+6,IDATA(IDATS_11+ILC+6)
 
         IF(ITP.NE.3)   THEN

C       NPN AND CAP: SPECTRAL PEAK POWER (STORED AS REAL)
C        (NOTE: After 5/2002, the spectral peak power is no longer
C                stored.)
 
            M = 9
         ELSE

C       JAPANESE: SIGNAL-TO-NOISE RATIO (STORED AS REAL)
 
            M = 17
         END IF
         IF(IPRINT.GT.1)  PRINT 199, UAIR(M,I),M
         IF(UAIR(M,I).LT.XMISS)  RDATX(IDATS_11+ILC+7) = NINT(UAIR(M,I))
         IF(IPRINT.GT.1) PRINT 198, IDATS_11+ILC+7,RDATX(IDATS_11+ILC+7)

C       HORIZONTAL WIND SPEED STANDARD DEVIATION (STORED AS REAL)
 
         M = 10
         IF(IPRINT.GT.1)  PRINT 199, UAIR(10,I),M
       IF(UAIR(10,I).LT.XMISS)RDATX(IDATS_11+ILC+8)=NINT(UAIR(10,I)*10.)
         IF(IPRINT.GT.1) PRINT 198, IDATS_11+ILC+8,RDATX(IDATS_11+ILC+8)
 
C       VERTICAL WIND COMPONENT STANDARD DEVIATION (STORED AS REAL)
 
         M = 11
         IF(IPRINT.GT.1)  PRINT 199, UAIR(11,I),M
       IF(UAIR(11,I).LT.XMISS)RDATX(IDATS_11+ILC+9)=NINT(UAIR(11,I)*10.)
         IF(IPRINT.GT.1) PRINT 198, IDATS_11+ILC+9,RDATX(IDATS_11+ILC+9)
 
C       MODE INFORMATION (STORED AS INTEGER)
C        (NOTE: After 5/2002, the mode information is no longer stored.)
 
         M = 12
         IF(IPRINT.GT.1)  PRINT 199, UAIR(12,I),M
         IF(UAIR(12,I).LT.XMISS) IDATA(IDATS_11+ILC+10)=NINT(UAIR(12,I))
         IF(IPRINT.GT.1)PRINT 197,IDATS_11+ILC+10,IDATA(IDATS_11+ILC+10)
C.......................................................................
         ILC = ILC + 11
         IF(IPRINT.GT.1)  PRINT'(" HAVE COMPLETED LEVEL ",I0,"; GOING ",
     $    "INTO NEXT LEVEL WITH ILC=",I0)', ILVL,ILC
      ENDDO    
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR UPPER-AIR DATA
 
   98 CONTINUE
      IDATA(37) = ILVL
      IDATA(38) = IDATS_11
   99 CONTINUE
      IF(IPRINT.GT.1)  PRINT'(" NSFC=",I0,"; IDATA(37)=",I0,
     $ "; IDATA(38)=",I0)', NSFC,IDATA(37),IDATA(38)
      RDATA(1:IDMAX) = RDATX(1:IDMAX)
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB706
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2014-03-13
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   UPPER-AIR DATA FOR NEXRAD (VAD) WIND REPORT (FROM BOTH RADAR CODED
C   MESSAGE AND FROM LEVEL 2 DECODER).  UPPER-AIR DATA ARE THEN FILLED
C   INTO THE OUTPUT ARRAY AS DATA LEVEL CATEGORY 4.  THE OUTPUT ARRAY
C   HOLDS A SINGLE VAD WIND REPORT IN THE QUASI-IW3UNPBF UNPACKED
C   FORMAT.
C
C PROGRAM HISTORY LOG:
C 1997-06-02  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C 2002-01-28  D. A. KEYSER -- THE WIND Q.M. FOR VAD WINDS LEVELS IS
C     NOW SET TO THE DECODED QN29 WIND QUALITY MARKER IF IT IS 12
C     (REJECT LIST) OR 14 (SDM PURGE), OTHERWISE IT IS SET TO THE
C     NUMERICAL INDICATOR FOR THE DECODED RMS VECTOR WIND ERROR
C     (BEFORE THE ON29 Q.M. WAS IGNORED)
C 2014-03-13  D. A. KEYSER -- MODIFIED TO HANDLE VAD WINDS FROM LEVEL
C     2 DECODER (SUBSET "NC002017") {IN ADDITION TO THOSE FROM RADAR
C     CODED MESSAGE (SUBSET "NC002008")}; MAXIMUM NUMBER OF CAT. 04
C     WINDS-BY-HEIGHT LEVELS ALLOWED (EXCLUDING FIRST, SURFACE, LEVEL),
C     "ILVLMX_04", INCREASED FROM 64 TO 254 TO ACCOUNT FOR MORE LEVELS
C     IN NEW VAD WINDS FROM LEVEL 2 DECODER
C 2020-08-20 J. DONG -- MODIFIED TO HANDLE OTHER VAD WINDS FROM EUROPE
C     AND NEW ZEALAND (NC002018)
C
C USAGE:    CALL UNPKB706(LUNIT,RDATA,ITP,IRET)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE NEXRAD (VAD) REPORT IN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT WITH ONLY HEADER INFORMATION FILLED
C              - IN (CATEGORY 4 DATA MISSING)
C     ITP      - THE TYPE OF REPORT THAT HAS BEEN DECODED {=5 -
C              - NEXRAD (VAD) WIND FROM RADAR CODED MESSAGE; =12 -
C              - NEXRAD (VAD) WIND FROM LEVEL 2 DECODER; =13 -
C              - NEXRAD (VAD) WIND FROM EUROPE AND NEW ZEALAND}
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE NEXRAD (VAD) REPORT IN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT WITH CATEGORY 4 INFORMATION FILLED IN
C              - (ALL DATA FOR REPORT NOW FILLED)
C     IRET     - RETURN CODE AS DESCRIBED IN W3UNPKB7 DOCBLOCK
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB706(LUNIT,RDATA,ITP,IRET)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*25  UAIR1,UAIR2,UAIR3
      INTEGER  IDATA(IDMAX)
      INTEGER QFV
      LOGICAL  SKIP_CAT12
      REAL(8) UAIR_8(5,255),BMISS,UFBINT2_8(10,255)
      REAL  RMS(0:12),UAIR(5,255),RDATA(*),RDATX(IDMAX)
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/kdate(8),ldate(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15
 
      SAVE
 
      EQUIVALENCE (RDATX,IDATA)
      DATA  XMISS/99999./
      DATA  UAIR1/'HEIT WDIR WSPD QMWN RMSW '/
      DATA  UAIR2/'HEIT UWND VWND QMWN QFV2 '/
      DATA  UAIR3/'HEIT WDIR WSPD QMWN QMRK '/
      DATA  RMS/1.,1.,2.,2.,3.,3.,4.,4.,5.,5.,6.,6.,7./
      RDATX(1:IDMAX) = RDATA(1:IDMAX)
      NSFC = 0
      ILVL = 0
      ILC =  0
C FIRST CATEGORY 4 DATA LEVEL CONTAINS ONLY HEIGHT (ELEV)
      IF(IPRINT.GT.1)  PRINT 1078, ILC,ILVL
 1078 FORMAT(' ATTEMPTING 1ST (SFC) LVL WITH ILC =',I5,'; NO. LEVELS ',
     $ 'PROCESSED TO NOW =',I5)
      RDATX(IDATS_04+ILC) = RDATX(7)
      IF(IPRINT.GT.1)  PRINT 198, IDATS_04+ILC,RDATX(IDATS_04+ILC)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
      IF(RDATX(IDATS_04+ILC).LT.XMISS)  NSFC = 1
      ILVL = ILVL + 1
      ILC = ILC + 5
      IF(IPRINT.GT.1) PRINT'(" HAVE COMPLETED LEVEL ",I0," WITH NSFC=",
     $ I0,"; GOING INTO NEXT LEVEL WITH ILC=",I0)', ILVL,NSFC,ILC
      UAIR_8 = BMISS
      IF(ITP.EQ.5) THEN
         CALL UFBINT(LUNIT,UAIR_8,5,255,NLEV,UAIR1);UAIR=UAIR_8
      ELSE IF(ITP.EQ.12) THEN
         CALL UFBINT(LUNIT,UAIR_8,5,255,NLEV,UAIR2);UAIR=UAIR_8
      ELSE IF(ITP.EQ.13) THEN
C         CALL UFBINT(LUNIT,UAIR_8,5,255,NLEV,UAIR3);UAIR=UAIR_8
         CALL UFBSEQ(LUNIT,UFBINT2_8(1,1),10,255,NLEV,'WPLVL')
         DO I=1,NLEV
            IF(UFBINT2_8(1,I).LT.BMISS) UAIR(1,I)=UFBINT2_8(1,I)
            IF(UFBINT2_8(4,I).LT.BMISS) UAIR(2,I)=UFBINT2_8(4,I)
            IF(UFBINT2_8(5,I).LT.BMISS) UAIR(3,I)=UFBINT2_8(5,I)
            IF(UFBINT2_8(3,I).LT.BMISS) UAIR(4,I)=UFBINT2_8(3,I)
            IF(UFBINT2_8(6,I).LT.BMISS) UAIR(5,I)=UFBINT2_8(6,I)
         ENDDO
      END IF
      IF(IPRINT.GT.1)  PRINT 1068, NLEV
 1068 FORMAT(' THIS REPORT CONTAINS ',I3,' LEVELS OF DATA (NOT ',
     $ 'INCLUDING BOTTOM -SURFACE- LEVEL)')
      IF(NLEV.EQ.0)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS ZERO --
         IF(NSFC.EQ.0)  THEN
C ... NO UPPER AIR DATA PROCESSED
            PRINT 217
  217       FORMAT(/'##W3UNPKB7: NO UPPER-AIR DATA PROCESSED FOR THIS',
     $       ' REPORT -- NLEV = 0 AND NSFC = 0'/)
            GO TO 99
         ELSE
C ... ONLY FIRST (SURFACE) UPPER AIR LEVEL DATA PROCESSED
            PRINT 218
  218 FORMAT(/'##W3UNPKB7: NO UPPER-AIR DATA ABOVE FIRST (SURFACE) ',
     $ 'LEVEL PROCESSED FOR THIS REPORT -- NLEV = 0 AND NSFC > 0'/)
            GO TO 98
         END IF
C.......................................................................
      ELSE  IF(NLEV.GT.ILVLMX_04)  THEN
C PROBLEM: THE NUMBER OF DECODED "LEVELS" {EXCLUDING BOTTOM (SURFACE)
C  LEVEL} IS .GT. LIMIT OF "ILVLMX_04" --
         PRINT 2186, NLEV,ILVLMX_04,ILVLMX_04
 2186    FORMAT(/'##W3UNPKB7: NUMBER OF UPPER-AIR LEVELS FOR THIS ',
     $    'REPORT (=',I3,') EXCEEDS LIMIT OF ',I0,' CAT. 04 LEVELS ',
     $    '(EXCLUDING BOTTOM, SFC, LVL) -- '/'     ONLY FIRST ',I0,
     $    ' UPPER-AIR LEVELS PLUS THE SURFACE LEVEL WILL BE PROCESSED'/)
         NLEV = ILVLMX_04
C.......................................................................
      END IF
      DO I = 1,NLEV
         IF(IPRINT.GT.1)  PRINT 1079, ILC,ILVL
 1079 FORMAT(' ATTEMPTING NEW LEVEL WITH ILC =',I5,'; NO. LEVELS ',
     $ 'PROCESSED TO NOW =',I5)
 
C       HEIGHT ABOVE SEA-LEVEL (STORED AS REAL)
 
         M = 1
         IF(IPRINT.GT.1)  PRINT 199, UAIR(1,I),M
  199 FORMAT(5X,'UAIR HERE IS: ',F17.4,'; INDEX IS: ',I3)
         IF(UAIR(1,I).LT.XMISS)  THEN
            RDATX(IDATS_04+ILC) = NINT(UAIR(1,I))

C       ... WE HAVE A VALID CATEGORY 4 DATA LEVEL -- THERE IS A VALID
C            HEIGHT

            ILVL = ILVL + 1
         ELSE

C       ... WE DO NOT HAVE A VALID CATEGORY 4 DATA LEVEL -- THERE IS NO
C            VALID HEIGHT GO ON TO NEXT INPUT LEVEL

            IF(IPRINT.GT.1)  PRINT'(" HEIGHT MISSING ON INPUT LEVEL ",
     $       I0,", ALL OTHER DATA SET TO MSG ON THIS LEVEL")', I
            CYCLE
         END IF
         IF(IPRINT.GT.1)  PRINT 198, IDATS_04+ILC,RDATX(IDATS_04+ILC)
 
C       HORIZONTAL WIND DIRECTION (STORED AS REAL) (VAD FROM RADAR
C        CODED MESSAGE)
C       HORIZONTAL U-COMP WIND    (STORED AS REAL) (VAD FROM LEVEL 2
C        DECODER)
 
         M = 2
         IF(IPRINT.GT.1)  PRINT 199, UAIR(2,I),M
         IF(UAIR(2,I).LT.XMISS)  RDATX(IDATS_04+ILC+1) = UAIR(2,I)
         IF(IPRINT.GT.1) PRINT 198, IDATS_04+ILC+1,RDATX(IDATS_04+ILC+1)
 
C       HORIZONTAL WIND SPEED     (STORED AS REAL) (VAD FROM RADAR
C        CODED MESSAGE)
C       HORIZONTAL V-COMP WIND    (STORED AS REAL) (VAD FROM LEVEL 2
C        DECODER)
 
         M = 3
         IF(IPRINT.GT.1)  PRINT 199, UAIR(3,I),M
         IF(UAIR(3,I).LT.XMISS) THEN
            IF(ITP.EQ.5 .OR. ITP.EQ.13) THEN
               RDATX(IDATS_04+ILC+2) = NINT(UAIR(3,I)*10.)
            ELSE IF(ITP.EQ.12) THEN
               RDATX(IDATS_04+ILC+2) = UAIR(3,I)
            END IF
         END IF
         IF(IPRINT.GT.1) PRINT 198, IDATS_04+ILC+2,RDATX(IDATS_04+ILC+2)
 
C       WIND QUALITY MARKER -- 
C          IF SDMEDIT/QUIPS WIND QUALITY MARKER IS 12 (REJECT LIST) OR
C          14 (SDM PURGE) THEN THIS VALUE IS STORED; OTHERWISE IT IS
C          BASED ON CONFIDENCE LEVEL (WHICH IS ITSELF BASED ON RMS
C          VECTOR WIND ERROR)
C          (NOTE: THE LATTER IS CONVERTED TO NUMERICAL INDICATOR --
C                 SEE W3UNPKB7 DOCBLOCK REMARKS 5 FOR UNPACKED VAD WIND
C                 REPORT LAYOUT FOR VALUES)
 
         M = 4
         IF(IPRINT.GT.1)  PRINT 199, UAIR(4,I),M
         M = 5
         IF(IPRINT.GT.1)  PRINT 199, UAIR(5,I),M
         IF(UAIR(4,I).EQ.12.OR.UAIR(4,I).EQ.14)  THEN
            RDATX(IDATS_04+ILC+4) = UAIR(4,I)
         ELSE  IF(UAIR(5,I).LT.XMISS)  THEN

C       ... CONVERT FROM METERS/SEC TO KNOTS

            IF (ITP.EQ.5) THEN
CDAKCDAK       KRMS = INT(1.93333 * UAIR(5,I))
               KRMS = INT(1.9425 * UAIR(5,I))
CDONG:DEBUG
               IF(KRMS.GE.0.AND.KRMS.LT.13)  THEN
                  RDATX(IDATS_04+ILC+4) = RMS(KRMS)
               ELSE
                 RDATX(IDATS_04+ILC+4) = 7.0
               END IF
            ELSE IF (ITP.EQ.12) THEN
               QFV = UAIR(5,I)
               IF(QFV .EQ. 0) THEN
                 RDATX(IDATS_04+ILC+4) = 1.0
               ELSE IF(QFV .EQ. 1.0) THEN
                 RDATX(IDATS_04+ILC+4) = 2.0
               ELSE
                 RDATX(IDATS_04+ILC+4) = 7.0
               END IF
            ELSE IF (ITP.EQ.13) THEN
               QFV = UAIR(5,I)
               IF(QFV .EQ. 0) THEN
                 RDATX(IDATS_04+ILC+4) = 1.0
               ELSE IF(QFV .EQ. 1.0) THEN
                 RDATX(IDATS_04+ILC+4) = 2.0
               ELSE
                 RDATX(IDATS_04+ILC+4) = 7.0
               END IF
            END IF
         END IF
         IF(IPRINT.GT.1) PRINT 198, IDATS_04+ILC+4,RDATX(IDATS_04+ILC+4)
C.......................................................................
         ILC = ILC + 5
         IF(IPRINT.GT.1)  PRINT'(" HAVE COMPLETED LEVEL ",I0,"; GOING ",
     $    "INTO NEXT LEVEL WITH ILC=",I0)', ILVL,ILC

      ENDDO    
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR UPPER-AIR DATA
 
   98 CONTINUE
      IDATA(19) = ILVL
   99 CONTINUE
      IF(IDATA(19).EQ.0)  THEN
         IDATA(20) = 0
         IRET = 5
      ELSE
         IDATA(20) = IDATS_04
      END IF
      IF(IPRINT.GT.1)  PRINT'(" NSFC=",I0,"; IDATA(37)=",I0,
     $ "; IDATA(38)=",I0)', NSFC,IDATA(37),IDATA(38)
      RDATA(1:IDMAX) = RDATX(1:IDMAX)
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB707
C   PRGMMR: WHITING          ORG: EMC        DATE: 2015-04-16
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   UPPER-AIR (SOUNDING), ADDITIONAL DATA, AND RADIANCES FOR GOES
C   SOUNDING/RADIANCE REPORT.  UPPER-AIR DATA ARE THEN FILLED INTO THE
C   OUTPUT ARRAY AS DATA LEVEL CATEGORY 12 (SATELLITE SOUNDING),
C   ADDITIONAL DATA ARE FILLED AS DATA LEVEL CATEGORY 8 (ADDITIONAL
C   DATA) AND RADIANCE DATA ARE FILLED AS DATA LEVEL CATEGORY 13
C   (SATELLITE RADIANCE) THE OUTPUT ARRAY HOLDS A SINGLE GOES SOUNDING
C   IN THE QUASI-IW3UNPBF UNPACKED FORMAT.
C
C PROGRAM HISTORY LOG:
C 1997-06-05  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C ????-??-??  D. A. KEYSER NP22 - ADDED CAT. 13 (RADIANCE) PROCESSING
C 2001-04-06  D. A. KEYSER NP22 - CAT. 8 TYPES ARE NO LONGER SCALED,
C     BUT STORED IN THE SAME UNITS/SCALING AS FOUND UPON INPUT; CAT. 13
C     BRIGHTNESS TEMPERATURES ARE NOW STORED AS DEG. K (PRECISE TO
C     10**2) RATHER THAN AS DEG. K X 100; NOW SKIPS CAT. 12 LEVELS
C     WHERE RETRIEVED GEOPOTENTIAL HGHT IS .LE. ELEVATION (LOWEST
C     RETRIEVED HEIGHT); NOW UNPACKS SURFACE PRESSURE INTO CAT. 8 CODE
C     FIGURE 262
C 2001-06-19  D. A. KEYSER -- RECOGNIZES BUFR TYPE/SUBTYPE 003/002 AS
C     GOES 1x1 (HI-RES) DATA, PART OF THE "GOESND" DUMP FILE ("SUBSET"
C     ADDED TO INPUT ARGUMENT LIST); STORES CLOUD COVER RATHER THAN
C     CLOUD AMOUNT IN OUTPUT CAT. 8, C.F. 258 FOR GOES HI-RES REPORTS
C 2001-07-10  D. A. KEYSER -- NOW KEEPS SEPARATE COUNT OF REPORTS WITH
C     MISSING # FOV (E.G., CLOUD-TOP REPORTS), BEFORE THESE WERE
C     GROUPED WITH # FOV 10-25
C 2004-09-09  D. A. KEYSER -- ADDED LOGIC TO HANDLE GOES 1x1 (SFOV)
C     SOUNDING (RADIANCE/RETRIEVAL) DATA: DOES NOT Q.C. ANY 1x1 DATA
C     (CLOUD AS BEFORE, BUT NOW ALSO SNDGS) BY NUMBER OF FOV's (STILL
C     DOES SO FOR NON-RADIANCE 5x5 DATA); FOR GOES PW RETRIEVALS, IF
C     TPW IS NOT FOUND UNDER LOCAL MNEMONIC "PH2O", NOW LOOKS FOR IT IN
C     WMO MNEMONIC "TPWT", THIS ALLOWS FOR TRANSITION FROM "PH2O" TO
C     "TPWT" IN REPORTS IN DUMP FILES (~ MID-2004) AND ALSO ALLOWS
C     HISTORICAL RERUNS TO READ OLD DUMP FILES
C 2006-07-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     NUMBER OF FIELDS-OF-VIEW (USED IN Q.C. PROCESSING) IS NOW
C     OBTAINED FROM WORD 2 OF NEW "RDATA2" ARRAY (HOLDS VALUES DECODED
C     DIRECTLY FROM BUFR) RATHER FROM WORD 3 OF HEADER IN "RDATA" ARRAY
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM BUFR_LISTDUMPS):
C 2007-09-14  D. A. KEYSER (THIS FUNCTION IN PROGRAM PREPOBS_PREPDATA):
C     HANDLES GOES 1x1 F-O-V SNDGS/RADIANCES IN SUBSET "NC003003"; CODE
C     FIGURE 258 REFERS ONLY TO CLOUD AMOUNT (HAD ALSO PREVIOUSLY
C     REFERRED TO CLOUD COVER FOR GOES 1x1 SNDGS - GOES 1x1 AND 5x5
C     SNDGS NOW BOTH PROCESS CLOUD AMOUNT)
C 2013-02-14  D. A. KEYSER -- FOR ANY "GOESND" OR "GOESFV" DUMP FILES
C     WITH CENTER TIME 2013022512 OR LATER, NO ATTEMPT IS MADE TO
C     DECODE GOES SOUNDINGS (PROFILES) AS THESE WERE REMOVED AT THIS
C     TIME FROM THE 1X1 GOES RADIANCE FILES PROVIDED BY NESDIS
C     (INGESTED INTO FROM TANK b003/xx003)
C 2015-04-16 JWhiting --  RDATA2(25) stores total cloud cover (TOCC)
C     (present in dumps of GOES cloud reports).
C
C USAGE:    CALL UNPKB707(LUNIT,RDATA,RDATA2,subset,IRET)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE GOES SNDG REPORT IN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT WITH ONLY HEADER INFORMATION FILLED
C              - IN (CATEGORY 12, 8 AND 13 8 DATA MISSING)
C     RDATA2   - 25-WORD ARRAY CONTAINING ADDITIONAL REPORT DATA NOT
C              - PRESENT IN RDATA ARRAY (DECODED DIRECTLY FROM BUFR)
C              - (ONLY WORDS 2 AND 7 FILLED IN - SEE W3UNPKB7 DOCBLOCK
C              - REMARKS 6 FOR CONTENT)
C     SUBSET   - CHARACTER*8 BUFR MESSAGE TYPE (SAME FOR ALL REPORTS
C              - IN A COMMON BUFR MESSAGE)
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE GOES SNDG REPORT IN A QUASI-IW3UNPBF
C              - UNPACKED FORMAT WITH CATEGORY 12, 8 AND 13
C              - INFORMATION FILLED IN (ALL DATA FOR REPORT NOW
C              - FILLED)
C     IRET     - RETURN CODE AS DESCRIBED IN W3UNPKB7 DOCBLOCK
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB707(LUNIT,RDATA,RDATA2,subset,IRET)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      character*8   subset
      CHARACTER*37  CAT8A,CAT8B
      CHARACTER*48  UAIR1,RAD1
      INTEGER  IDATA(IDMAX),ICDFG(ILVLMX_08)
      LOGICAL  SKIP_CAT12
      REAL(8) UAIR_8(4,255),CAT8_8(12),RTCSF_8,RAD_8(2,255),BMISS
      REAL(8) TOCC_8
      REAL UAIR(4,255),CAT8(ILVLMX_08),SCALE(ILVLMX_08),RDATA(*),
     $ RDATX(IDMAX),RAD(2,255),ZMISS(ILVLMX_08),RDATA2(25)
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/KDATE(8),LDATE(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7FF/IFOV(4,2),KNTSAT(250:260)
      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15
 
      SAVE
 
      EQUIVALENCE (RDATX,IDATA)
      DATA  XMISS/99999./,YMISS/99999.8/
      DATA  UAIR1/'PRLC HGHT TMDB TMDP                             '/
      DATA  RAD1 /'CHNM TMBR                                       '/
      DATA  CAT8A/'GLFTI PH2O PH2O19 PH2O97 PH2O73 TMSK '/
      DATA  CAT8B/'GCDTT CDTP CLAM   SIDU   SOEL   ELEV '/
      DATA  ZMISS/ 99999.,  99999.,  99999.,  99999.,  99999.,
     $             99999.,  99999., 999999.,  99999.,  99999.,
     $             99999.,  99999.,  99999./
      DATA ICDFG/   50,   51,  52,    53,    54,    55,
     $              56,   57,  58,    59,    60,    61,    62/
      DATA SCALE/  1.0,  1.0, 1.0,   1.0,   1.0,   1.0,
     $             1.0,  .01, 1.0,   1.0,   1.0,   1.0,   1.0/
      RDATX(1:IDMAX) = RDATA(1:IDMAX)

      QMFLG = 2.0

      IF(SUBSET(8:8).EQ.'1') THEN

C ALL NON-RADIANCE 5x5 FOV DATA WILL BE Q.C.'D ACCORDING TO NUMBER OF
C  FIELDS-OF-VIEW FOR RETRIEVAL:  0-2 --> BAD, 3-9 --> SUSPECT, 10-25
C  OR MISSING --> NEUTRAL

         IF(NINT(RDATA2(2)).LT.3)  THEN
            QMFLG = 13.0
            IFOV(1,1) = IFOV(1,1) + 1
         ELSE  IF(NINT(RDATA2(2)).LT.10.OR.NINT(RDATA2(7)).EQ.1)  THEN
            QMFLG = 3.0
            IF(NINT(RDATA2(2)).LT.10)  IFOV(2,1) = IFOV(2,1) + 1
         END IF
         IF(NINT(RDATA2(2)).GT.25)  THEN
            IFOV(4,1) = IFOV(4,1) + 1
         ELSE  IF(NINT(RDATA2(2)).GT.9)  THEN
            IFOV(3,1) = IFOV(3,1) + 1
         END IF

      ELSE

C ALL NON-RADIANCE 1x1 FOV DATA GET NEUTRAL Q. MARK REGARDLESS OF
C  FIELD-OF-VIEW NUMBER (BUT STILL KEEP TRACK OF COUNTS BY FOV)

         IF(NINT(RDATA2(2)).GT.0.AND.NINT(RDATA2(2)).LT.4)  THEN
            IFOV(NINT(RDATA2(2)),2) = IFOV(NINT(RDATA2(2)),2) + 1
         ELSE 
            IFOV(4,2) = IFOV(4,2) + 1
         END IF

      END IF

      PSFC   = XMISS

      IF(SKIP_CAT12) GO TO 98 ! skip attempt to process soundings if
                              ! center dump date is 2013022512 or later

C***********************************************************************
C              FILL DATA LEVEL CATEGORY 12 PART OF OUTPUT
C***********************************************************************

      ILVL = 0
      ILC  = 0
      UAIR_8 = BMISS
      ELEV   = -99999.
      CALL UFBINT(LUNIT,UAIR_8,4,255,NLEV,UAIR1);UAIR=UAIR_8
      IF(IPRINT.GT.1)  PRINT 1068, NLEV
 1068 FORMAT(' THIS REPORT CONTAINS',I4,' INPUT LEVELS OF SOUNDING ',
     $ 'DATA')
      IF(NLEV.EQ.0)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS ZERO --
         if (subset.eq.'NC003002')  go to 98  ! Currently all of the
                                              ! cloud 1x1 reports
                                              ! have none (remove this
                                              ! if NESDIS ever combines
                                              ! cloud and PW/rad. 1x1's)
         PRINT 217
  217    FORMAT(/'##W3UNPKB7: NO UPPER-AIR (SOUNDING) DATA PROCESSED ',
     $   'FOR THIS  REPORT -- NLEV = 0'/)
         GO TO 98
C.......................................................................
      ELSE  IF(NLEV.GT.ILVLMX_12)  THEN
C PROBLEM: THE NO. OF DECODED "LEVELS" IS .GT. LIMIT OF "ILVLMX_12" --
         PRINT 2186, NLEV,ILVLMX_12,ILVLMX_12
 2186    FORMAT(/'##W3UNPKB7: NUMBER OF UPPER-AIR LEVELS FOR THIS ',
     $    'REPORT (=',I3,') EXCEEDS LIMIT OF ',I0,' CAT. 12 LEVELS -- ',
     $    'ONLY FIRST ',I0,' LEVELS WILL BE PROCESSED'/)
         NLEV = ILVLMX_12
C.......................................................................
      END IF
      DO I = 1,NLEV
         IF(IPRINT.GT.1)  PRINT 1079, I,ILC,ILVL
 1079 FORMAT(' ATTEMPTING NEW CAT. 12 INPUT LEVEL NUMBER',I4,' WITH ',
     $ 'ILC =',I5,'; NO. LEVELS PROCESSED TO NOW =',I5)
 
C       LEVEL PRESSURE, ELEVATION (STORED AS REAL)
 
         M = 1
         IF(IPRINT.GT.1)  PRINT 199, UAIR(1,I),M
  199 FORMAT(5X,'UAIR HERE IS: ',F17.4,'; INDEX IS: ',I3)
         IF(I.EQ.1)  THEN
            IF(UAIR(1,I).LT.999999.) PSFC = UAIR(1,I) * 0.01
            IF(UAIR(2,1).LT.XMISS)  THEN
               ELEV = UAIR(2,1)
            ELSE
C.......................................................................
C PROBLEM: THE ELEVATION IS MISSING --
               PRINT 6217
 6217          FORMAT(/'##W3UNPKB7: NO UPPER-AIR (SOUNDING) DATA ',
     $          'PROCESSED FOR THIS  REPORT -- ELEV IS MISSING'/)
               GO TO 98
C.......................................................................
            END IF
         ELSE  IF(UAIR(1,I)*0.1.GE.YMISS)  THEN
C WE DO NOT HAVE A VALID CATEGORY 12 LEVEL -- THERE IS NO VALID PRESSURE
C  -- GO ON TO NEXT INPUT LEVEL (IF SFC LEVEL MSG, CONTINUE PROCESSING)
            IF(IPRINT.GT.1)  PRINT'(" PRESSURE MISSING ON INPUT LEVEL ",
     $       I0,", SKIP THE PROCESSING OF THIS LEVEL")', I
            CYCLE
         ELSE  IF(UAIR(1,I)*0.01.GE.PSFC)  THEN
C WE DO NOT HAVE A VALID CATEGORY 12 LEVEL -- THE INPUT LEVEL PRESSURE
C  IS BELOW THE SURFACE PRESSURE -- GO ON TO THE NEXT INPUT LEVEL
            IF(IPRINT.GT.1)  PRINT'(" PRESSURE ON INPUT LEVEL ",I0,
     $       " IS BELOW GROUND, SKIP THE PROCESSING OF THIS LEVEL")', I
            CYCLE
         ELSE  IF(UAIR(2,I).LE.ELEV)  THEN
C WE DO NOT HAVE A VALID CATEGORY 12 LEVEL -- THE INPUT LEVEL 
C  GEOPOTENTIAL HEIGHT IS NOT GREATER THAN THE ELEVATION -- GO ON TO THE
C  NEXT INPUT LEVEL
            IF(IPRINT.GT.1)  PRINT'(" GEOPOTENTIAL HEIGHT ON INPUT ",
     $       "LEVEL ",I0," IS .LE. ELEVATION, SKIP THE PROCESSING OF ",
     $       "THIS LEVEL")', I
            CYCLE
         END IF

C WE HAVE A VALID CATEGORY 12 LEVEL -- THERE IS A VALID PRESSURE AND
C  THE GEOPOTENTIAL HEIGHT IS GREATER THAN THE ELEVATION

       IF(UAIR(1,I)*0.1.LT.XMISS)RDATX(IDATS_12+ILC)=NINT(UAIR(1,I)*0.1)
         ILVL = ILVL + 1
         IF(IPRINT.GT.1)  PRINT 198, IDATS_12+ILC,RDATX(IDATS_12+ILC)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
 
C       GEOPOTENTIAL HEIGHT (STORED AS REAL)
 
         M = 2
         IF(IPRINT.GT.1)  PRINT 199, UAIR(2,I),M
         IF(UAIR(2,I).LT.XMISS)  RDATX(IDATS_12+ILC+1) = NINT(UAIR(2,I))
         IF(IPRINT.GT.1) PRINT 198, IDATS_12+ILC+1,RDATX(IDATS_12+ILC+1)
         IF(I.EQ.1)  THEN
            IF(IPRINT.GT.1)  PRINT'(" THIS IS SURFACE LEVEL, SO STORE ",
     $       "HEIGHT ALSO AS ELEVATION IN HEADER")'
            IF(UAIR(2,1).LT.XMISS)  RDATX(7) = NINT(UAIR(2,1))
            NNNNN = 7
            IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(NNNNN)
         END IF
 
C       TEMPERATURE (STORED AS REAL)
 
         M = 3
         IF(IPRINT.GT.1)  PRINT 199, UAIR(3,I),M
         ITMP = NINT(UAIR(3,I)*100.)
         IF(UAIR(3,I).LT.XMISS)
     $    RDATX(IDATS_12+ILC+2) = NINT((ITMP - 27315) * 0.1)
         IF(IPRINT.GT.1) PRINT 198, IDATS_12+ILC+2,RDATX(IDATS_12+ILC+2)
 
C       DEWPOINT TEMPERATURE (STORED AS REAL)
 
         M = 4
         IF(IPRINT.GT.1)  PRINT 199, UAIR(4,I),M
         ITMP = NINT(UAIR(4,I)*100.)
         IF(UAIR(4,I).LT.XMISS)
     $    RDATX(IDATS_12+ILC+3) = NINT((ITMP - 27315) * 0.1)
         IF(IPRINT.GT.1) PRINT 198, IDATS_12+ILC+3,RDATX(IDATS_12+ILC+3)
 
C       GEOPOTENTIAL QUALITY MARKER (STORED AS REAL)
 
         RDATX(IDATS_12+ILC+6) = QMFLG
         IF(IPRINT.GT.1) PRINT 198, IDATS_12+ILC+6,RDATX(IDATS_12+ILC+6)
 
C       TEMPERATURE QUALITY MARKER (STORED AS REAL)
 
         RDATX(IDATS_12+ILC+7) = QMFLG
         IF(IPRINT.GT.1) PRINT 198, IDATS_12+ILC+7,RDATX(IDATS_12+ILC+7)
 
C       DEWPOINT TEMPERATURE QUALITY MARKER (STORED AS REAL)
 
         RDATX(IDATS_12+ILC+8) = QMFLG
         IF(IPRINT.GT.1) PRINT 198, IDATS_12+ILC+8,RDATX(IDATS_12+ILC+8)
C.......................................................................
         ILC = ILC + 9
         IF(I+1.LE.NLEV.AND.IPRINT.GT.1)  PRINT'(" HAVE COMPLETED ",
     $    "LEVEL ",I0,"; GOING INTO NEXT LEVEL WITH ILC=",I0)', ILVL,ILC

      ENDDO    
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR CATEGORY 12 (SNDG) DATA
 
      IDATA(39) = ILVL
   98 CONTINUE
      IF(IPRINT.GT.1)  PRINT'(1X,I0," CAT. 12 LEVELS PROCESSED")',
     $ IDATA(39)
      IF(IDATA(39).GT.0)  IDATA(40) = IDATS_12
 
C***********************************************************************
C              FILL DATA LEVEL CATEGORY 8 PART OF OUTPUT
C        WILL ATTEMPT TO FILL "ILVLMX_08" (CURRENTLY 13) "LEVELS"
C
C LVL  1: LIFTED INDEX (DEG. K TO 10**2 PREC. - RELATIVE) -CODE FIG. 250
C LVL  2: TOTAL COLUMN PRECIP. WATER (MM TO 10**1 PREC.) - CODE FIG. 251
C LVL  3: 1. TO .9 SIGMA LYR P.WATER (MM TO 10**1 PREC.) - CODE FIG. 252
C LVL  4: .9 TO .7 SIGMA LYR P.WATER (MM TO 10**1 PREC.) - CODE FIG. 253
C LVL  5: .7 TO .3 SIGMA LYR P.WATER (MM TO 10**1 PREC.) - CODE FIG. 254
C LVL  6: SKIN TEMPERATURE (DEG. K TO 10**2 PREC.) ------- CODE FIG. 255
C LVL  7: CLOUD TOP TEMPERATURE (DEG. K TO 10**2 PREC.) -- CODE FIG. 256
C LVL  8: CLOUD TOP PRESSURE (MB TO 10**1 PREC.) --------- CODE FIG. 257
C LVL  9: CLOUD AMOUNT (C. FIG. BUFR TABLE 0-20-011) ----- CODE FIG. 258
C LVL 10: INSTR. DATA USED IN PROC.
C                      (C. FIG. BUFR TABLE 0-02-021) ----- CODE FIG. 259
C LVL 11: SOLAR ZENITH ANGLE (SOLAR ELEV) (DEG. TO 10**2 PREC.)
C                                                       -- CODE FIG. 260
C LVL 12: SATELLITE ZENITH ANGLE (ELEV) (DEG. TO 10**2 PREC.)
C                                                       -- CODE FIG. 261
C LVL 13: SURFACE PRESSURE (MB TO 10**1 PREC.) ----------- CODE FIG. 262
C
C     IF DATA ONE ANY LEVEL ARE MISSING, THAT LEVEL IS NOT PROCESSED
C***********************************************************************
 
      ILVL = 0
      ILC = 0
      CAT8_8 = BMISS
      nlev8 = 0
      CALL UFBINT(LUNIT,CAT8_8,12,1,NLEV8,CAT8A//CAT8B)

C  Get total cloud cover for GOES cloud reports (in msg type NC003002)
C  -------------------------------------------------------------------

      CALL UFBINT(LUNIT,TOCC_8,1,1,NRET,'TOCC')
      RDATA2(25)=TOCC_8

C  Sometime in mid-2004, "TPWT" will replace "PH2O" for tpw - if one
C   is missing, look for the other (for historical reruns)
C  -----------------------------------------------------------------

      IF(IBFMS(CAT8_8(2)).NE.0)
     $ CALL UFBINT(LUNIT,CAT8_8(2),1,1,LLEV8,'TPWT')
      CAT8(1:12)=CAT8_8
      CAT8(13) = PSFC
      IF(NLEV8.NE.1)  THEN
         IF(NLEV8.EQ.0)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS ZERO --
            PRINT 318
  318 FORMAT(/'##W3UNPKB7: NO ADDITIONAL (CAT. 8) DATA PROCESSED FOR ',
     $ 'THIS  REPORT -- NLEV8 = 0'/)
            GO TO 99
C.......................................................................
         ELSE
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS NOT WHAT IS EXPECTED --
C  SET IRET = 7 AND RETURN
            PRINT 219, NLEV8
  219 FORMAT(/'##W3UNPKB7: THE NUMBER OF DECODED "LEVELS" (=',I5,') ',
     $ 'IS NOT WHAT IS EXPECTED (1) - IRET = 7'/)
            IRET = 7
            RETURN
C.......................................................................
         END IF
      END IF

C THE TEMPERATURE CHANNEL SELECTION FLAG WILL BE USED LATER TO
C  DETERMINE Q. MARK FOR SKIN TEMPERATURE (IF 0 - OK, OTHERWISE - BAD)

      RTCSF_8 = BMISS
      CALL UFBINT(LUNIT,RTCSF_8,1,1,NLEV0,'TCSF');RTCSF=RTCSF_8
      ITCSF = 1
      M = 1
      IF(IPRINT.GT.1)  PRINT 299, RTCSF,M
  299 FORMAT(5X,'RTCSF HERE IS: ',F17.4,'; INDEX IS: ',I3)
      IF(RTCSF.LT.XMISS)  ITCSF = NINT(RTCSF)
      IF(IPRINT.GT.1)  PRINT 1798, ITCSF
 1798 FORMAT(5X,'ITCSF IS: ',I10)

C LOOP THROUGH THE "ILVLMX_08" POSSIBLE ADDITIONAL DATA "LEVELS"

      DO M = 1,ILVLMX_08
         IF(IPRINT.GT.1)  PRINT 6079, M,ILC,ILVL
 6079 FORMAT(' ATTEMPTING MISCEL. INPUT',I5,' WITH ILC =',I5,'; NO. ',
     $ 'OUTPUT CAT.  8 LVLS PROCESSED TO NOW =',I5)
         IF(IPRINT.GT.1)  PRINT 399, CAT8(M),M
  399 FORMAT(5X,'CAT8 HERE IS: ',F17.4,'; INDEX IS: ',I3)
         IF(CAT8(M).LT.ZMISS(M))  THEN

C WE HAVE A VALID CATEGORY 8 DATA "LEVEL"

            ILVL = ILVL + 1

C STORE THE DATUM IN WORD 1 OF THE CAT. 8 DATA LEVEL

            RDATX(IDATS_08+ILC) = CAT8(M)*SCALE(M)
            IF(IPRINT.GT.1)  PRINT 198, IDATS_08+ILC,RDATX(IDATS_08+ILC)

C STORE THE CAT. 8 CODE FIGURE IN WORD 2 OF THE CAT. 8 DATA LEVEL

            RDATX(IDATS_08+ILC+1) = REAL(200+ICDFG(M))
           IF(IPRINT.GT.1)PRINT 198,IDATS_08+ILC+1,RDATX(IDATS_08+ILC+1)

C STORE THE DATUM QUALITY MARKER IN WORD 3 OF THE CAT. 8 DATA LEVEL

            RDATX(IDATS_08+ILC+2) = QMFLG

C IF THIS DATUM IS SKIN TEMPERATURE AND THE TEMPERATURE CHANNEL
C  SELECTION FLAG IS BAD (.NE. 0), SET QUALITY MARKER TO 13.0 (BAD)

            IF(M.EQ.6.AND.ITCSF.NE.0)  RDATX(IDATS_08+ILC+2) = 13.0
           IF(IPRINT.GT.1)PRINT 198,IDATS_08+ILC+2,RDATX(IDATS_08+ILC+2)

C.......................................................................

            ILC = ILC + 4
            IF(M.LT.ILVLMX_08.AND.IPRINT.GT.1) PRINT'(" HAVE COMPLETED",
     $       " OUTPUT LVL",I0,"; GOING INTO NEXT INPUT DATUM WITH ILC=",
     $       I0)', ILVL,ILC
         ELSE
            IF(IPRINT.GT.1)  PRINT'(" DATUM MISSING ON INPUT ",I0,
     $       ", GO ON TO NEXT INPUT DATUM (NO. LVLS PROCESSED SO FAR=",
     $       I0,"; ILC=",I0,")")', M,ILVL,ILC
         END IF
      ENDDO
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR CATEGORY 8 (ADD'L) DATA
 
      IDATA(27) = ILVL
   99 CONTINUE
      IF(IPRINT.GT.1)  PRINT'(1X,I0," CAT. 08 LEVELS PROCESSED")',
     $ IDATA(27)
      IF(IDATA(27).GT.0)  IDATA(28) = IDATS_08

C***********************************************************************
C          FILL DATA LEVEL CATEGORY 13 PART OF OUTPUT (RADIANCES)
C***********************************************************************

      ILVL = 0
      ILC =  0
      RAD_8 = BMISS
      CALL UFBINT(LUNIT,RAD_8,2,255,NLEV13,RAD1);RAD=RAD_8
      IF(IPRINT.GT.1)  PRINT 2068, NLEV13
 2068 FORMAT(' THIS REPORT CONTAINS',I4,' INPUT LEVELS (CHANNELS) OF ',
     $ 'RADIANCE DATA')
      IF(NLEV13.EQ.0)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS ZERO --
         if (subset.eq.'NC003002')  go to 100 ! Currently all of the
                                              ! cloud 1x1 reports
                                              ! have none (remove this
                                              ! if NESDIS ever combines
                                              ! cloud and PW/rad. 1x1's)
         PRINT 417
  417    FORMAT(/'##W3UNPKB7: NO RADIANCE DATA PROCESSED FOR THIS ',
     $    'REPORT -- NLEV13 = 0'/)
         GO TO 100
C.......................................................................
      ELSE  IF(NLEV13.GT.ILVLMX_13)  THEN
C PROBLEM: THE NO. OF DECODED "LEVELS" IS .GT. LIMIT OF "ILVLMX_13" --
         PRINT 2187, NLEV13,ILVLMX_13,ILVLMX_13
 2187    FORMAT(/'##W3UNPKB7: NUMBER OF RADIANCE CHANNELS FOR THIS ',
     $    'REPORT (=',I3,') EXCEEDS LIMIT OF ',I0,' CAT. 13 CHANNELS ',
     $    '-- ONLY FIRST ',I0,' CHANNELS WILL BE PROCESSED'/)
         NLEV13 = ILVLMX_13
C.......................................................................
      END IF
      DO I = 1,NLEV13
         IF(IPRINT.GT.1)  PRINT 2079, I,ILC,ILVL
 2079 FORMAT(' ATTEMPTING NEW CAT. 13 INPUT "LEVEL" NUMBER',I4,' WITH ',
     $ 'ILC =',I5,'; NO. LEVELS (CHANNELS) PROCESSED TO NOW =',I5)
 
C       CHANNEL NUMBER (STORED AS INTEGER)
 
         M = 1
         IF(IPRINT.GT.1)  PRINT 499, RAD(1,I),M
  499 FORMAT(5X,'RAD  HERE IS: ',F17.4,'; INDEX IS: ',I3)
         IF(RAD(1,I).GE.YMISS)  THEN
C WE DO NOT HAVE A VALID CATEGORY 13 DATA LEVEL -- THERE IS NO VALID
C  CHANNEL NUMBER -- GO ON TO NEXT INPUT LEVEL
            IF(IPRINT.GT.1)  PRINT'(" CHANNEL NUMBER MISSING ON INPUT",
     $       " LEVEL ",I0,", SKIP THE PROCESSING OF THIS LEVEL")', I
            CYCLE
         END IF

C WE HAVE A VALID CATEGORY 13 DATA LEVEL -- THERE IS A VALID CHANNEL
C  NUMBER

         IDATA(IDATS_13+ILC) = NINT(RAD(1,I))
         ILVL = ILVL + 1
         IF(IPRINT.GT.1)  PRINT 197, IDATS_13+ILC,IDATA(IDATS_13+ILC)
  197 FORMAT(5X,'IDATA(',I5,') STORED AS: ',I10)
 
C       BRIGHTNESS TEMPERATURE (STORED AS REAL)
 
         M = 2
         IF(IPRINT.GT.1)  PRINT 499, RAD(2,I),M
         IF(RAD(2,I).LT.XMISS)  RDATX(IDATS_13+ILC+1) = RAD(2,I)
         IF(IPRINT.GT.1) PRINT 198, IDATS_13+ILC+1,RDATX(IDATS_13+ILC+1)
 
C       QUALITY MARKERS (STORED AS REAL) -- CURRENTLY HARDWIRED TO 2.0
C         (NEUTRAL - DEFAULT)
 
         RDATX(IDATS_13+ILC+2) = 2.0
         IF(IPRINT.GT.1) PRINT 198, IDATS_13+ILC+2,RDATX(IDATS_13+ILC+2)

C.......................................................................

         ILC = ILC + 3
         IF(I+1.LE.NLEV13.AND.IPRINT.GT.1)  PRINT'(" HAVE COMPLETED ",
     $    "LEVEL ",I0,"; GOING INTO NEXT LEVEL WITH ILC=",I0)', ILVL,ILC

  210    CONTINUE
      ENDDO    
 
C       SET CATEGORY COUNTERS FOR DATA LVL CATEGORY 13 (RADIANCE) DATA
 
      IDATA(41) = ILVL
  100 CONTINUE
      IF(IPRINT.GT.1)  PRINT'(1X,I0," CAT. 13 LEVELS PROCESSED")',
     $ IDATA(41)
      IF(IDATA(41).GT.0)  IDATA(42) = IDATS_13

      IF(IDATA(27)+IDATA(39)+IDATA(41).EQ.0)  IRET = 5

      IF(IPRINT.GT.1)  PRINT'(" IDATA(39)=",I0,"; IDATA(40)=",I0,
     $ "; IDATA(27)=",I0,"; IDATA(28)=",I0,"; IDATA(41)=",I0,
     $ "; IDATA(42)=",I0)', IDATA(39),IDATA(40),IDATA(27),IDATA(28),
     $ IDATA(41),IDATA(42)

      RDATA(1:IDMAX) = RDATX(1:IDMAX)
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB709
C   PRGMMR: JWhiting         ORG: EMC        DATE: 2016-08-15
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   GPS-IPW (INTEGRATED PRECIPITABLE WATER) DATA.  GPS-IPW DATA ARE
C   THEN FILLED INTO THE OUTPUT ARRAY AS DATA LEVEL CATEGORY 14.  THE
C   OUTPUT ARRAY HOLDS A SINGLE GPS-IPW REPORT IN THE QUASI-IW3UNPBF
C   UNPACKED FORMAT.
C
C PROGRAM HISTORY LOG:
C 2002-07-03  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C 2016-08-15  JWhiting - Added variable 'subset' to arg list; tested 
C     on 'subset' to determine if new GNSS/GPS-Met zenith total delay 
C     data fields need to be read (this replaces potentially ambiguous
C     test on missing TDEL data from previous GPS-IPW data streams).
C
C USAGE:    CALL UNPKB709(LUNIT,RDATA,SUBSET)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE GPS-IPW REPORT IN A QUASI-IW3UNPBF UNPACKED
C              - FORMAT WITH ONLY HEADER INFORMATION FILLED IN (ALL
C              - OTHER DATA REMAINS MISSING)
C     SUBSET   - CHARACTER*8 BUFR MESSAGE TYPE (SAME FOR ALL REPORTS
C              - IN A COMMON BUFR MESSAGE)
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE GPS-IPW REPORT IN A QUASI-IW3UNPBF UNPACKED
C              - FORMAT WITH GPS-IPW INFORMATION FILLED IN (ALL DATA
C              - FOR REPORT NOW FILLED)
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB709(LUNIT,RDATA,subset)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*50  CAT14S
      character*8   subset
      INTEGER  IDATA(IDMAX)
      LOGICAL  SKIP_CAT12
      REAL(8) CAT14_8(10),BMISS,gnssrpsq_8(6,255)
      REAL  CAT14(10),RDATA(*),RDATX(IDMAX)
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/kdate(8),ldate(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15
 
      SAVE
 
      EQUIVALENCE (RDATX,IDATA)
      DATA  XMISS/99999./
      DATA  CAT14S/'PRES TMDB REHU TPWT TDEL ETDL HSDL EHSD WMTM WDMF '/
      RDATX(1:IDMAX) = RDATA(1:IDMAX)
      CAT14_8 = BMISS
      CALL UFBINT(LUNIT,CAT14_8,10,1,NLEV,CAT14S);CAT14=CAT14_8
      IF(NLEV.NE.1)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS NOT WHAT IS EXPECTED --
         PRINT 217, NLEV
  217 FORMAT(/'##W3UNPKB7: THE NUMBER OF DECODED "LEVELS" (=',I5,') ',
     $ 'IS NOT WHAT IS EXPECTED (1) - NO GPS-IPW DATA PROCESSED'/)
         GO TO 99
C.......................................................................
      END IF
 
C       STATION PRESSURE (STORED AS REAL - MB TO 10**1 PRECISION)
 
      M = 1
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
  199 FORMAT(5X,'CAT14 HERE IS: ',F17.4,'; INDEX IS: ',I3)
      IF((CAT14(M)*0.01).LT.XMISS) RDATX(IDATS_14) = CAT14(M) * 0.01
      NNNNN = IDATS_14
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
 
C       AIR TEMPERATURE (STORED AS REAL - KELVIN TO 10**2 PRECISION)
 
      M = 2
      if(cat14(m).ge.xmiss)  then
         call ufbint(lunit,cat14_8(m),10,1,nlev,'TMDBST')
         cat14(m) = cat14_8(m)
      endif
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+1) = CAT14(M)
      NNNNN = IDATS_14 + 1
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+1)
 
C       RELATIVE HUMIDITY (STORED AS REAL - PERCENT TO 10**0 PRECISION)
 
      M = 3
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+2) = CAT14(M)
      NNNNN = IDATS_14 + 2
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+2)
 
C       TOTAL PRECIPITABLE WATER (STORED AS REAL - MM TO 10**3 PREC.)
 
      M = 4
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+3) = CAT14(M)
      NNNNN = IDATS_14 + 3
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+3)
 
C       ZENITH TOTAL DELAY (STORED AS REAL - M TO 10**4 PRECISION)
 
      M = 5
      if (subset.eq.'NC012004') then ! new GPS-Met feed
         call ufbrep(lunit,gnssrpsq_8,6,255,irep,
     $   'SCLF PTID BEARAZ ELEV APDS APDE')

C        ZTD is obtained from "atmospheric path delay in satellite
C         signal" (m) from replication where azimuth angle is zero deg.
C         and elevation angle is 90 deg.)
C        Likewise, the Error in ZTD (used below) is obtained from
C         "error in atmospheric path delay in satellite signal" (m) from
C         this same replication.
C         (slant angles are discarded for now)

         do jrep = 1,irep
            if(gnssrpsq_8(3,jrep).eq.0..and.gnssrpsq_8(4,jrep).eq.90.)
     $       then
               cat14_8(m:m+1) = gnssrpsq_8(5:6,jrep)
               cat14(m:m+1) = cat14_8(m:m+1)
               exit
            end if
         enddo
      end if
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+4) = CAT14(M)
      NNNNN = IDATS_14 + 4
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+4)
 
C       ERROR IN ZENITH TOTAL DELAY (STORED AS REAL - M TO 10**4 PREC.)
 
      M = 6
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+5) = CAT14(M)
      NNNNN = IDATS_14 + 5
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+5)
 
C       HYDROSTATIC DELAY (STORED AS REAL - M TO 10**4 PRECISION)
 
      M = 7
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+6) = CAT14(M)
      NNNNN = IDATS_14 + 6
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+6)
 
C       ERROR IN HYDROSTATIC DELAY (STORED AS REAL - M TO 10**4 PREC.)
 
      M = 8
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+7) = CAT14(M)
      NNNNN = IDATS_14 + 7
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+7)
 
C       WEIGHTED MEAN TEMPERATURE (STORED AS REAL - K TO 10**2 PREC.)
 
      M = 9
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+8) = CAT14(M)
      NNNNN = IDATS_14 + 8
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+8)
 
C       WET DELAY MAPPING FUNCTION (STORED AS REAL -
C        NUMERIC TO 10**3 PRECISION)
 
      M = 10
      IF(IPRINT.GT.1)  PRINT 199, CAT14(M),M
      IF(CAT14(M).LT.XMISS)  RDATX(IDATS_14+9) = CAT14(M)
      NNNNN = IDATS_14 + 9
      IF(IPRINT.GT.1)  PRINT 198, NNNNN,RDATX(IDATS_14+9)
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR GPS-IPW DATA
 
      IDATA(43) = 1
      IDATA(44) = IDATS_14
   99 CONTINUE
      IF(IPRINT.GT.1)  PRINT'("IDATA(43)=",I0)', IDATA(43)
      RDATA(1:IDMAX) = RDATX(1:IDMAX)
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    UNPKB710
C   PRGMMR: D. A. KEYSER     ORG: NP22       DATE: 2004-02-02
C
C ABSTRACT: FOR REPORT (SUBSET) READ OUT OF BUFR MESSAGE (PASSED IN
C   INTERNALLY VIA BUFRLIB STORAGE), CALLS BUFRLIB ROUTINE TO DECODE
C   UPPER-AIR DATA FOR NPN OR CAP RASS REPORT.  UPPER-AIR DATA ARE THEN
C   FILLED INTO THE OUTPUT ARRAY AS DATA LEVEL CATEGORY 15.  THE OUTPUT
C   ARRAY HOLDS A SINGLE RASS REPORT IN THE QUASI-IW3UNPBF UNPACKED
C   FORMAT.
C
C PROGRAM HISTORY LOG:
C 2004-02-02  D. A. KEYSER NP22 - ORIGINAL AUTHOR
C
C USAGE:    CALL UNPKB710(LUNIT,RDATA)
C   INPUT ARGUMENT LIST:
C     LUNIT    - FORTRAN UNIT NUMBER FOR INPUT DATA FILE
C     RDATA    - SINGLE RASS REPORT IN A QUASI-IW3UNPBF UNPACKED
C              - FORMAT WITH ONLY HEADER INFORMATION FILLED IN
C              - (CATEGORY 15 DATA MISSING)
C
C   OUTPUT ARGUMENT LIST:
C     RDATA    - SINGLE RASS REPORT IN A QUASI-IW3UNPBF UNPACKED
C              - FORMAT WITH CATEGORY 15 INFORMATION FILLED IN (ALL
C              - DATA FOR REPORT NOW FILLED)
C
C   OUTPUT FILES:
C     UNIT 06  - PRINTOUT
C
C REMARKS: CALLED BY SUBROUTINE W3UNPKB7.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE UNPKB710(LUNIT,RDATA)

C  Include parameters common to more than one subroutine
C  -----------------------------------------------------

      include 'inc_w3unpkb7.inc'

      CHARACTER*20  CAT15S
      INTEGER  IDATA(IDMAX)
      LOGICAL  SKIP_CAT12
      REAL(8) CAT15_8(4,255),BMISS
      REAL  CAT15(4,255),RDATA(*),RDATX(IDMAX)
      COMMON /PKB7AA/BMISS
      COMMON /PKB7BB/kdate(8),ldate(8),KTIMCH,IPRINT,SKIP_CAT12
      COMMON /PKB7GG/IDATS_04,IDATS_08,IDATS_10,IDATS_11,IDATS_12,
     $ IDATS_13,IDATS_14,IDATS_15
 
      SAVE
 
      EQUIVALENCE (RDATX,IDATA)
      DATA  XMISS/99999./
      DATA  CAT15S/'HEIT TMVR QMAT NPQC '/
      RDATX(1:IDMAX) = RDATA(1:IDMAX)
      NSFC = 0
      ILVL = 0
      ILC =  0
C FIRST CATEGORY 15 DATA LEVEL CONTAINS ONLY HEIGHT (ELEV)
      IF(IPRINT.GT.1)  PRINT 1078, ILC,ILVL
 1078 FORMAT(' ATTEMPTING 1ST (SFC) LVL WITH ILC =',I5,'; NO. LEVELS ',
     $ 'PROCESSED TO NOW =',I5)
      RDATX(IDATS_15+ILC) = RDATX(7)
      IF(IPRINT.GT.1)  PRINT 198, IDATS_15+ILC,RDATX(IDATS_15+ILC)
  198 FORMAT(5X,'RDATA(',I5,') STORED AS: ',F10.2)
      IF(RDATX(IDATS_15+ILC).LT.XMISS)  NSFC = 1
      ILVL = ILVL + 1
      ILC = ILC + 3
      IF(IPRINT.GT.1) PRINT'(" HAVE COMPLETED LEVEL ",I0," WITH NSFC=",
     $ I0,"; GOING INTO NEXT LEVEL WITH ILC=",I0)', ILVL,NSFC,ILC
      CAT15_8 = BMISS
      CALL UFBINT(LUNIT,CAT15_8,4,255,NLEV,CAT15S);CAT15=CAT15_8
      IF(IPRINT.GT.1)  PRINT 1068, NLEV
 1068 FORMAT(' THIS REPORT CONTAINS ',I3,' LEVELS OF DATA (NOT ',
     $ 'INCLUDING BOTTOM -SURFACE- LEVEL)')
      IF(NLEV.EQ.0)  THEN
C.......................................................................
C PROBLEM: THE NUMBER OF DECODED "LEVELS" IS ZERO --
         IF(NSFC.EQ.0)  THEN
C ... NO UPPER AIR DATA PROCESSED
            PRINT 217
  217       FORMAT(/'##W3UNPKB7: NO UPPER-AIR DATA PROCESSED FOR THIS',
     $       ' REPORT -- NLEV = 0 AND NSFC = 0'/)
            GO TO 99
         ELSE
C ... ONLY FIRST (SURFACE) UPPER AIR LEVEL DATA PROCESSED
            PRINT 218
  218 FORMAT(/'##W3UNPKB7: NO UPPER-AIR DATA ABOVE FIRST (SURFACE) ',
     $ 'LEVEL PROCESSED FOR THIS REPORT -- NLEV = 0 AND NSFC > 0'/)
            GO TO 98
         END IF
C.......................................................................
      ELSE  IF(NLEV.GT.ILVLMX_15)  THEN
C PROBLEM: THE NUMBER OF DECODED "LEVELS" {EXCLUDING BOTTOM (SURFACE)
C  LEVEL} IS .GT. LIMIT OF "ILVLMX_15" --
         PRINT 2186, NLEV,ILVLMX_15,ILVLMX_15
 2186    FORMAT(/'##W3UNPKB7: NUMBER OF UPPER-AIR LEVELS FOR THIS ',
     $    'REPORT (=',I3,') EXCEEDS LIMIT OF ',I0,' CAT. 15 LEVELS ',
     $    '(EXCLUDING BOTTOM, SFC, LVL) -- '/'     ONLY FIRST ',I0,
     $    ' UPPER-AIR LEVELS PLUS THE SURFACE LEVEL WILL BE PROCESSED'/)
         NLEV = ILVLMX_15
C.......................................................................
      END IF
      DO I = 1,NLEV
         IF(IPRINT.GT.1)  PRINT 1079, ILC,ILVL
 1079 FORMAT(' ATTEMPTING NEW LEVEL WITH ILC =',I5,'; NO. LEVELS ',
     $ 'PROCESSED TO NOW =',I5)
 
C       HEIGHT ABOVE SEA-LEVEL (STORED AS REAL - METERS TO 10**0 PREC.)
 
         M = 1
         IF(IPRINT.GT.1)  PRINT 199, CAT15(1,I),M
  199 FORMAT(5X,'CAT15 HERE IS: ',F17.4,'; INDEX IS: ',I3)
         IF(CAT15(1,I).LT.XMISS)  THEN
            RDATX(IDATS_15+ILC) = NINT(CAT15(1,I))

C       ... WE HAVE A VALID CATEGORY 15 DATA LEVEL -- THERE IS A VALID
C            HEIGHT

            ILVL = ILVL + 1
         ELSE

C       ... WE DO NOT HAVE A VALID CATEGORY 15 DATA LEVEL -- THERE IS
C            NO VALID HEIGHT GO ON TO NEXT INPUT LEVEL

            IF(IPRINT.GT.1)  PRINT'(" HEIGHT MISSING ON INPUT LEVEL ",
     $       I0,", ALL OTHER DATA SET TO MSG ON THIS LEVEL")', I
            CYCLE
         END IF
         IF(IPRINT.GT.1)  PRINT 198, IDATS_15+ILC,RDATX(IDATS_15+ILC)
 
C       VIRTUAL TEMPERATURE (STORED AS REAL - KELVIN TO 10**2 PRECISION)
 
         M = 2
         IF(IPRINT.GT.1)  PRINT 199, CAT15(2,I),M
         IF(CAT15(2,I).LT.XMISS)  RDATX(IDATS_15+ILC+1) = CAT15(2,I)
         IF(IPRINT.GT.1) PRINT 198, IDATS_15+ILC+1,RDATX(IDATS_15+ILC+1)
 
C       QUALITY CODE (STORED AS INTEGER - NUMERIC)
C          IF SDMEDIT/QUIPS TEMPERATURE QUALITY MARKER IS 12 (REJECT
C          LIST) OR 14 (SDM PURGE) THEN A VALUE OF 14 IS STORED FOR THE
C          QUALITY CODE; OTHERWISE THE DECODED QUALITY CODE IS STORED
C          DIRECTLY
 
         M = 3
         IF(IPRINT.GT.1)  PRINT 199, CAT15(3,I),M
         M = 4
         IF(IPRINT.GT.1)  PRINT 199, CAT15(4,I),M
         IF(CAT15(3,I).EQ.12.OR.CAT15(3,I).EQ.14)  THEN
            IDATA(IDATS_15+ILC+2) = 14
         ELSE  IF(CAT15(4,I).LT.XMISS) THEN
            IDATA(IDATS_15+ILC+2) = NINT(CAT15(4,I))
         END IF
         IF(IPRINT.GT.1) PRINT 197, IDATS_15+ILC+2,IDATA(IDATS_15+ILC+2)
  197 FORMAT(5X,'IDATA(',I5,') STORED AS: ',I10)
C.......................................................................
         ILC = ILC + 3
         IF(IPRINT.GT.1)  PRINT'(" HAVE COMPLETED LEVEL ",I0,"; GOING ",
     $    "INTO NEXT LEVEL WITH ILC=",I0)', ILVL,ILC
      ENDDO    
 
C       SET DATA LEVEL CATEGORY COUNTERS FOR UPPER-AIR DATA
 
   98 CONTINUE
      IDATA(45) = ILVL
      IDATA(46) = IDATS_15
   99 CONTINUE
      IF(IPRINT.GT.1)  PRINT'(" NSFC=",I0,"; IDATA(45)=",I0,
     $ "; IDATA(46)=",I0)', NSFC,IDATA(45),IDATA(46)
      RDATA(1:IDMAX) = RDATX(1:IDMAX)
      RETURN
      END

C***********************************************************************
C***********************************************************************
C  GBLEVN03 - INTERPOLATE MODEL DATA (FIRST GUESS OR ANALYSIS) TO OB
C             LOCATIONS
C-----------------------------------------------------------------------
      SUBROUTINE GBLEVN03(SUBSET) ! FORMERLY SUBROUTINE GETFC

      USE GBLEVN_MODULE

      REAL(8)   OBS,QMS,BAK,SID
      CHARACTER*8  SUBSET

      COMMON /GBEVAA/ SID,OBS(15,255),QMS(12,255),BAK(12,255),XOB,
     $ YOB,DHR,TYP,NLEV
      COMMON /GBEVEE/PSG01,ZSG01,TG01(500),UG01(500),VG01(500),
     x     QG01(500),zint(500),pint(500),pintlog(500),plev(500),
     x     plevlog(500)



      DATA TZERO / 273.15 /
      DATA BETAP / .0552  /
      DATA BETA  / .00650 /
      DATA ROG   / 29.261 /

C  CLEAR THE BACKGROUND EVENT ARRAY
C  --------------------------------

      BAK = BMISS

C  GET GUESS PROFILE AT OB LOCATION
C  --------------------------------
      CALL GBLEVN06(XOB,YOB)

      
C  INTERPOLATE GUESS PROFILES TO OB PRESSURES
C  ------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO 10 L=1,NLEV

         POB  = OBS( 1,L)
         QOB  = OBS( 2,L)
         TOB  = OBS( 3,L)
         ZOB  = OBS( 4,L)
         UOB  = OBS( 5,L)
         VOB  = OBS( 6,L)
         PWO  = OBS( 7,L)
         PW1O = OBS( 8,L)
         PW2O = OBS( 9,L)
         PW3O = OBS(10,L)
         PW4O = OBS(11,L)
         CAT  = OBS(12,L)

         IF(POB.LE.0. .OR. POB.GE.BMISS) GOTO 10

         poblog = log(pob)
         
         la = -999
         lb = -999
         do k=1,kmax-1
            if (poblog<=plevlog(k) .and. poblog>plevlog(k+1)) then
               la = k
               lb = k+1
               exit
            endif
         enddo
         if (la > 0) then
            wt = (poblog-plevlog(lb)) / (plevlog(la)-plevlog(lb))
         else
            la = 1
            lb = la+1
            wt = 0.0
         endif
         
         li=0
         do k=1,kmax-1
            if (poblog<=pintlog(k) .and. poblog>pintlog(k+1)) then
               li = k
               exit
            endif
         enddo

C  SURFACE PRESSURE
C  ----------------

         IF(CAT.EQ.0 .AND. ZOB.LT.BMISS) THEN
            TS = TG01(1) + (PSG01-PLEV(1))*BETAP
            DZ  = ZOB-ZSG01
            TM  = TS - DZ*BETA*.5
            PFC = PSG01*EXP(-DZ/(TM*ROG))
         ELSE
            PFC = BMISS
         ENDIF

C  SPECIFIC HUMIDITY
C  -----------------

         IF(QOB.LT.BMISS.OR.TOB.LT.BMISS.OR.TYP.EQ.111) THEN

C  (QFC NEEDED BY SYNDATA PROGRAM BUT ONLY FOR REPORT TYPE 111)

            QOB = QG01(LB) + (QG01(LA)-QG01(LB))*WT
         ENDIF

C  TEMPERATURE
C  -----------

         IF(TOB.LT.BMISS.OR.SUBSET.EQ.'VADWND  '.OR.TYP.EQ.111) THEN

C  (TFC NEEDED BY CQCVAD AND SYNDATA PROGRAMS, LATTER ONLY FOR REPORT
C   TYPE 111)

            IF(POB.GT.PLEV(1)) THEN
               TOB = TG01(1) + (POB-PLEV(1))*BETAP
            ELSE
               TOB = TG01(LB) + (TG01(LA)-TG01(LB))*WT
            ENDIF
            TOB = TOB - TZERO
         ENDIF

C  HEIGHT
C  ------

         IF(ZOB.LT.BMISS) THEN
            IF(POB.GT.PLEV(1)) THEN
               TM = TG01(1) + (.5*(PINT(1)+POB)-PLEV(1))*BETAP
               ZOB = ZINT(1) - ROG*TM*LOG(POB/PINT(1))
            ELSE
               TM = TG01(LB) + (TG01(LA)-TG01(LB))*WT
               ZOB = ZINT(LI) - ROG*TM*LOG(POB/PINT(LI))
            ENDIF
         ENDIF

C  U AND V COMPONENTS
C  ------------------

         IF(UOB.LT.BMISS .OR. VOB.LT.BMISS) THEN
            UOB = UG01(LB) + (UG01(LA)-UG01(LB))*WT
            VOB = VG01(LB) + (VG01(LA)-VG01(LB))*WT
         ENDIF


C  PRECIPITABLE WATER
C  ------------------

         PWO  = BMISS
         PW1O = BMISS
         PW2O = BMISS
         PW3O = BMISS
         PW4O = BMISS

C  RELATIVE HUMIDITY
C  -----------------

         RHO = BMISS

C  SCATTER THE PROPER FIRST GUESS/ANALYSIS VALUES
C  ----------------------------------------------

         BAK(1,L)  = PFC
         BAK(2,L)  = QOB
         BAK(3,L)  = TOB
         BAK(4,L)  = ZOB
         BAK(5,L)  = UOB
         BAK(6,L)  = VOB
         BAK(7,L)  = PWO
         BAK(8,L)  = PW1O
         BAK(9,L)  = PW2O
         BAK(10,L) = PW3O
         BAK(11,L) = PW4O
         BAK(12,L) = RHO

   10 ENDDO
      ENDIF

      RETURN
      END

subroutine water2land (temp,dewpt,wspd,wdir,wtemp,tdiff,newtemp,newdpt,newspd,newdir,bmiss)
  !abstract: inverse of land2wat, adjust obs over water to represent those over land

  use glerl_dictionary

  implicit none
  real(4),intent(in)::temp,dewpt,wspd,wdir,tdiff,wtemp
  real(4),intent(out)::newtemp,newdpt,newspd,newdir
  real(4)::delwd
  real(8)::bmiss

  !print original obs for record keeping/dupcheck
  print'("Orig Airtemp,WaterTemp,tdiff,dewpoint,wspd,wdir=",6(2x,g0))', temp,wtemp,tdiff,dewpt,wspd,wdir
  !adjust temp
  if (temp.lt.bmiss.and.wtemp.lt.bmiss) then
     newtemp=2.5*temp-1.5*wtemp
  elseif (temp.ge.bmiss) then
     newtemp=bmiss
     print*, "Can't make adjusted w2l temperature.  Missing observed temperature."
  elseif (wtemp.ge.bmiss) then
     newtemp=bmiss
     print*, "Can't make adjusted w2l temperature.  Missing water temperature."
  else
     newtemp=bmiss
     print*, "Can't make adjusted w2l temperature.  Invalid air and water temps:",temp,wtemp
  endif
  !adjust dewpoint
  if (dewpt.lt.bmiss.and.wtemp.lt.bmiss) then
     newdpt=1.8714+(dewpt/0.7)-(wtemp/2)
  elseif (dewpt.ge.bmiss) then
     newdpt=bmiss
     print*, "Can't make adjusted w2l dew point.  Missing observed dew point."
  elseif (wtemp.ge.bmiss) then
     newdpt=bmiss
     print*, "Can't make adjusted w2l dew point.  Missing water temperature."
  else
     newdpt=bmiss
     print*, "Can't make adjusted w2l dew point.  Invalid dew point and water temps:",dewpt,wtemp
  endif
  !adjust wind speed
  if (wspd.lt.bmiss.and.tdiff.lt.bmiss) then
     if (wspd.gt.0) then
        !first, adjust for stability  this is the inverse of the stability adjustment for l2w
        !if tdiff > 100, than one temp is missing
        !remove stability temperature adjustment
        !if (tdiff.ne.0.and.tdiff.lt.100) newspd=(1.-(tdiff/abs(tdiff))*(abs(tdiff)/1920.)**0.3333)/wspd
        newspd=(wspd-1.85)/1.21
        !adjust wind direction
        delwd=0.
        if(tdiff.ne.0) delwd=(12.5-1.5*tdiff)-(0.38 - 0.03*tdiff)*newspd
        newdir=wdir+delwd
        if(newdir.lt.0) newdir=newdir+360
        if(newdir.gt.360) newdir=newdir-360
        !if (newspd.lt.0) newspd=0
     else
        newdir=wdir
        newspd=wspd
     endif
  elseif (wspd.ge.bmiss) then
     print*, "Can't make adjusted w2l winds.  Missing observed wind speed."
     newdir=bmiss
     newspd=bmiss
  elseif (tdiff.ge.bmiss) then
     print*, "Can't make adjusted w2l winds.  Missing air-water temp difference."
     newdir=bmiss
     newspd=bmiss
  else
     print*, "Can't make adjusted w2l winds.  Invalid wind speed and air-water temp difference:",wspd,tdiff
     newdir=bmiss
     newspd=bmiss
  endif
  if (newspd.lt.0) then
     print*, "WARNING: Adjusted wind speed (w2l) is less than zero.  Defaulting to 0..."
     print*, "Adjusted wind speed value is:",newspd
     newspd=0.
  endif
  print'("Adjusted Airtemp,dewpoint,wspd,wdir=",4(2x,g0))', newtemp,newdpt,newspd,newdir

end subroutine water2land

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM:  BUFR_REMOREST
C   PRGMMR: Keyser           ORG: EMC         DATE: 2017-10-20
C
C ABSTRACT: THIS PROGRAM READS THROUGH AN INPUT BUFR FILE (NORMALLY
C   EITHER A PREPBUFR OR A DATA DUMP FILE) WHICH CAN CONTAIN A MIXTURE
C   OF REPORTS WHICH ARE UNRESTRICTED OR RESTRICTED FOR AT LEAST
C   SOME PERIOD OF TIME (W.R.T. REDISTRIBUTION OUTSIDE OF NCEP) AND
C   EITHER WRITES OUT (TO AN OTHERWISE IDENTICAL BUFR FILE) ONLY THOSE
C   REPORTS WHICH ARE NON-RESTRICTED OR WRITES OUT ALL REPORTS BUT WITH
C   MASKED REPORT ID's FOR THOSE REPORTS WHICH ARE RESTRICTED (WHAT IT
C   DOES IS BASED ON NAMELIST SWITCHES). {NOTE: WHEN A RESTRICTED
C   REPORT IS WRITTEN OUT WITH A MASKED REPORT ID, ITS RESTRICTION FLAG
C   (MNEMONIC "RSRD") AND ITS NUMBER OF HOURS UNTIL THE RESTRICTION
C   EXPIRES (MNEMONIC "EXPRSRD") ARE RE-SET TO MISSING SO THAT THE
C   REPORT IS NO LONGER CONSIDERED TO BE RESTRICTED.} IT DETERMINES 
C   WHICH REPORTS ARE RESTRICTED BASED ON EITHER THE MESSAGE TYPE AND
C   SUBTYPE (MAKING UP THE TABLE A ENTRY IN DATA DUMP FILES), THE
C   PREPBUFR TABLE A ENTRY (PREPBUFR FILES) (IN EITHER CASE WHEN THE
C   MESSAGE IS KNOWN TO CONTAIN EITHER ALL RESTRICTED OR ALL NON-
C   RESTRICTED REPORTS), THE DUMP REPORT TYPE (WHEN REPORTS IN A
C   PARTICULAR PREPBUFR TABLE A ENTRY ARE MASKED) OR THE REPORT'S
C   VALUE FOR "RSRD") AND, IF "RSRD" IS SET, ITS VALUE FOR "EXPRSRD"
C   WITHIN EACH REPORT IN A MESSAGE (WHEN THE MESSAGE MAY CONTAIN A
C   MIXTURE OF RESTRICTED AND NON-RESTRICTED REPORTS). (NOTE: THE CASE
C   OF MASKING REPORT ID's IN DATA DUMP FILES CAN ONLY BE DONE
C   CURRENTLY FOR TABLE A ENTRIES WHERE ALL REPORTS ARE CONSIDERED TO
C   BE RESTRICTED.
C
C PROGRAM HISTORY LOG:
C 2003-07-14  D. A. KEYSER -- ORIGINAL AUTHOR
C 2007-11-21  D. A. KEYSER -- ADDED OPTION TO MASK THE REPORT ID FOR
C     SPECIFIC TABLE A ENTRIES (AND POSSIBLY FOR SPECIFIC DUMP REPORT
C     TYPES WITHIN TABLE A ENTRIES WHEN PROCESSING A PREPBUFR FILE),
C     WHICH RETAINS RESTRICTED REPORTS OF THIS TYPE (RATHER THAN
C     TOSSING RESTRICTED REPORTS AS IN THE OTHER, PREVIOUS OPTIONS) BUT
C     CHANGES THEIR TRUE REPORT ID TO "MASKSTID" WHERE THE ID IS STORED
C     BY ITSELF (I.E., IN PREPBUFR FILES, MNEMONIC "SID"; IN DUMP
C     FILES, MNEMONIC "RPID" FOR ALL TYPES PLUS FOR SHIPS IN TABLE A
C     ENTRY "NC001001" MNEMONIC "SHPC8") AND REPLACES THE REPORT ID
C     WITH ALL "X"'s WHERE THE ID IS EMBEDDED IN THE REPLICATED RAW
C     BULLETIN HEADER STRING; USES NEW NAMELIST SWITCHES "MSG_MASKA"
C     TO IDENTIFY THOSE TABLE A ENTRIES FOR WHICH SOME OR ALL REPORTS
C     ARE CONSIDERED TO BE RESTRICTED AND MUST HAVE THEIR REPORT ID
C     MASKED AND, IN PREPBUFR FILES ONLY, "IMASK_T29" TO IDENTIFY THOSE
C     SPECIFIC DUMP REPORT TYPES WITHIN "MSG_MASKA" WHICH ARE
C     RESTRICTED AND MUST HAVE THEIR REPORT ID MASKED
C 2008-09-12  D. A. KEYSER -- INCREASED THE NUMBER OF MESSAGE TYPE
C     ENTRIES IN NAMELIST SWITCHES "MSG_RESTR", "MSG_MIXED" AND
C     "MSG_MASKA" FROM 10 TO 20 AND SET UP THEIR DEFAULT VALUES
C     (8 BLANK CHARACTERS) SO THAT ALL 20 VALUES DO NOT HAVE TO BE
C     SPECIFIED IN THE NAMELIST PASSED IN FROM THE EXECUTING SCRIPT
C 2013-03-15  JWhiting -- ported to WCOSS (no logic changes)
C 2017-01-06  DStokes  -- Added call of bufrlib routine SETBMISS to set
C      the missing value used for bufr reads and writes to 10E8_8.  
C      Function GETBMISS is then used to define variable BMISS rather
C      than using a hardwired value of 10E10. This change was made
C      to reduce the risk of integer overflows on WCOSS.
C 2017-10-20  D. A. KEYSER
C       - Added minutes to print statement everytime a new BUFR message
C         is read.  In the case of a PREPBUFR file this is the central
C         (analysis) time (which is the same) for every message.  In the
C         case of a DUMP file, this is the central dump time for the
C         first (dummy) message read in, the dump file creation time for
C         the second (dummy) message read in, and the message YYYYMMDDHH
C         (with minutes always zero) for all data messages read in.  The
C         minutes are obtained from Section 1 of the message read in via
C         call to BUFRLIB routine IUPVS01.
C         BENEFIT: Until now, central dump time and PREPBUFR (analysis)
C                  time minutes was always zero.  However, with the
C                  implementation of the new RTMA_RU, these times can
C                  now also have minutes = 15, 30 or 45 (since the
C                  RTMA_RU runs 4 times per hour). This change allows
C                  this print statement to reflect this new message time
C                  format.
C       -  Fixed a bug in cases where individual subsets in an input
C          message must be read in and checked/updated before being
C          written back out if not rejected altogether (see * below for
C          cases). Here code was opening output message via OPENMG which
C          does not take into account input message's Section 1 minutes
C          value (it thus opens a message with default of zero minutes
C          in Section 1 date). Updated to call BUFRLIB routine MINIMG in
C          such cases to encode non-zero minutes value (previously read
C          in via BUFRLIB routine IUPVS01, see first change above) into
C          Section 1 date when OPENMB actually does open a new message.
C          * - either the input message contains a mixture of restricted
C              and non-restricted reports or contains restricted reports
C              which can be made non-restricted by masking their id
C          BENEFIT: Applies only to PREPBUFR files for RTMA_RU runs at 
C                   15, 30 or 45 minutes past the hour: ensures that all
C                   messages in output file have the same (correct)
C                   center date out to minutes in Section 1 {rather than
C                   messages created via OPENMB (e.g., ADPSFC, SFCSHP in
C                   RTMA_RU runs) having Section 1 minutes of zero}.
C 2020-12-16  S. Melchior -- added call to bufrlib routine maxout for
C          gpsro data.  The default max message size of 10000 bytes is
C          not sufficient for GPS-RO data.
C          BENEFIT: Commercial GPS-RO data will be stripped from gpsro
C                   BUFR dump files for safe external user
C                   dissemination.
C 2021-01-26  S. MELCHIOR
C      - Included subset NC001101 in logic section that replaces station
C        ID w/ MASKSTID.
C        BENEFIT: BUFR format restricted ships data can be properly
C                 dispensed to public users.
C XXXX-XX-XX  D. A. KEYSER -- All reports in message types in namelist
C     "MSG_MIXED" are now also tested for their value for EXPRSRD
C     (number of hours until the restriction expires) when their
C     restriction flag (RSRD) is set - any reports with a non-missing
C     EXPRSRD less than the difference in hours between the current
C     UTC wall-clock date and the BUFR file center time ("DIFF_HR")
C     minus 4 are now not considered restricted and are copied (prior
C     to this, the value of EXPRSRD was ignored and all reports with
C     RSRD set were restricted and skipped), "DIFF_HR" is a new
C     imported script environment variable; Improved information that
C     is printed out for each report that is either skipped or retained
C     (latter is currently commented out); Improved information printed
C     out at end summarizing counts of reports retained, skipped or
C     masked
C XXXX-XX-XX  D. A. KEYSER -- 
C          - For PREPBUFR files only, all reports in message types in
C     namelist "MSG_MASK" (if their dump report type is listed in
C     namelist "IMASK_T29") are now tested for their values for both
C     RSRD and EXPRSRD and are only considered to be restricted if
C     RSRD is set and EXPRSRD is .GE. the difference in hours between
C     the current UTC wall-clock date and the BUFR file center time
C     (read in via imported script environment variable "DIFF_HR")
C     minus 4.  (Prior to this RSRD and EXPRSRD were not examined, ALL
C     reports from the message type having the listed dump report type
C     were considered to be restricted.  This is still the case for
C     message types in namelist "MSG_MASK" for DUMP files.)
C          - When a report coming out of "MSG_MASK" is deemed to be
C     restricted (either PREPBUFR or DUMP) and its id is masked to be
C     "MASKSTID", the report's value for RSRD is now re-set to MISSING
C     when copied to non-restricted file (EXPRSRD is also set to
C     MISSING, but it likely was already MISSING).
C          - Improved documentation and printout.
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - DATA CARDS CONTAINING NAMELIST SWITCHES (SEE REMARKS)
C     UNIT 11  - INPUT BUFR FILENAME (IN CHARACTER) (USED ONLY FOR
C                DIAGNOSTIC PRINT INFO)
C     UNIT 21  - BUFR FILE (PREPBUFR OR DUMP) CONTAINING A MIXTURE OF
C                RESTRICTED (AT LEAST FOR SOME PERIOD FO TIME) AND 
C                NON-RESTRICTED REPORTS
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - BUFR FILE (PREPBUFR OR DUMP) CONTAINING EITHER ONLY
C                NON-RESTRICTED REPORTS OR NON-RESTRICTED REPORTS AND
C                PREVIOUSLY RESTRICTED REPORTS WHOSE REPORT ID's HAVE 
C                BEEN MASKED {I.E., ALL OCCURRENCES OF ID IN A REPORT
C                ARE UNILATERALLY CHANGED TO EITHER "MASKSTID" (WHERE
C                THE ID IS STORED BY ITSELF) OR TO ALL "X"'s WHERE THE
C                NUMBER OF "X"'s CORRESPONDS TO THE THE NUMBER OF
C                CHARACTERS IN THE ORIGINAL REPORT ID (WHERE THE ID IS
C                EMBEDDED IN THE REPLICATED RAW REPORT BULLETIN HEADER
C                STRING), THE LATTER APPLY ONLY TO DUMP FILES}
C
C   SUBPROGRAMS CALLED: (LIST ALL CALLED FROM ANYWHERE IN CODES)
C
C     UNIQUE:    - NONE
C     SYSTEM:    - GET_ENVIRONMENT_VARIABLE
C     LIBRARY:
C       W3LIB    - W3TAGB   W3TAGE   ERREXIT
C       BUFR     - DATELEN  OPENBF   IREADMG  UFBCNT  NMSUB
C                  SETBMISS GETBMISS iupvs01  minimg  maxout
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C            > 0 - PROBLEM
C
C REMARKS:
C   CONTENTS OF INPUT NAMELIST "SWITCHES":
C     MSG_RESTR - 20-WORD CHARACTER*8 ARRAY CONTAINING UP TO 20 BUFR
C                 MESSAGE TABLE A ENTRIES FOR WHICH ALL REPORTS ARE
C                 CONSIDERED TO BE RESTRICTED AND WILL ALWAYS BE
C                 REMOVED (These messages are skipped over without
C                 unpacking any reports)
C     MSG_MIXED - 20-WORD CHARACTER*8 ARRAY CONTAINING UP TO 20 BUFR
C                 MESSAGE TABLE A ENTRIES WHICH MAY CONTAIN A MIXTURE
C                 OF REPORTS WITH AND WITHOUT THEIR RESTRICTION
C                 INDICATOR (BUFR MNEMONIC "RSRD") BEING SET. IF "RSRD"
C                 IS NOT SET -OR- IT IS SET AND THE TIME IN HOURS FOR
C                 THE EXPIRATION ON RESTRICTION (BUFR MNEMONIC
C                 "EXPRSRD") IS ALSO SET AND HAS A VALUE LESS THAN
C                 "DIFF_HR" (THE DIFFERENCE IN HOURS BETWEEN THE
C                 CURRENT UTC WALL-CLOCK DATE AND THE BUFR FILE CENTER
C                 TIME) MINUS 4, THE REPORT WILL BE RETAINED.
C                 OTHERWISE, IT WILL BE REMOVED. (These messages must
C                 be unpacked and values for "RSRD" and "EXPRSRD" must
C                 be checked for every report. If "EXPRSRD is missing,
C                 it is set to 99999999 hours essentially meaning the
C                 report is restricted for all time if "RSRD" is set.)
C     MSG_MASKA - FOR PREPBUFR FILES:
C                 20-WORD CHARACTER*8 ARRAY CONTAINING UP TO 20 BUFR
C                 MESSAGE TABLE A ENTRIES WHICH, IF THEIR DUMP REPORT
C                 TYPE IS ONE OF UP TO 10 POSSIBLE LISTED IN SWITCH
C                 IMASK_T29 (WHERE EACH LINE IN IMASK_T29 APPLIES TO
C                 THE TABLE A ENTRY IN THE SAME LINE NUMBER HERE), MAY
C                 CONTAIN A MIXTURE OF REPORTS WITH AND WITHOUT THEIR
C                 RESTRICTION INDICATOR (BUFR MNEMONIC "RSRD") BEING
C                 SET. IF "RSRD" IS NOT SET FOR A REPORT -OR- IT IS SET
C                 AND THE TIME IN HOURS FOR THE EXPIRATION ON
C                 RESTRICTION (BUFR MNEMONIC "EXPRSRD") IS ALSO SET AND
C                 HAS A VALUE LESS THAN "DIFF_HR" (THE DIFFERENCE IN
C                 HOURS BETWEEN THE CURRENT UTC WALL-CLOCK DATE AND THE
C                 PREPBUFR FILE CENTER TIME) MINUS 4, THE REPORT WILL
C                 BE COPIED WITHOUT ANY CHANGES.  OTHERWISE, THE REPORT
C                 WILL NOT BE REMOVED, BUT ALL OCCURRENCES OF ITS ID
C                 WILL BE CHANGED TO "MASKSTID". IN ADDITION, ITS
C                 VALUES FOR "RSRD" AND "EXPRSRD" WILL BE RE-SET TO
C                 MISSING SO THAT THE REPORT WILL NO LONGER BE
C                 CONSIDERED AS RESTRICTED.  REPORTS WITH A DUMP REPORT
C                 TYPE NOT LISTED IN SWITCH IMASK_T29 ARE CONSIDERED TO
C                 BE NON-RESTRICTED AND THEIR REPORT IDS ARE NOT
C                 CHANGED (MASKED OUT) WHEN COPIED.  (These m essages
C                 must be unpacked and the values for "T29", "RSRD" and
C                 "EXPRSRD" must be checked for every report. If
C                 "EXPRSRD" is missing, it is set to 99999999 hours
C                 essentially meaning the report is restricted for all
C                 time if "RSRD" is set.)
C                 FOR DATA DUMP FILES:
C                 20-WORD CHARACTER*8 ARRAY CONTAINING UP TO 20 BUFR
C                 MESSAGE TABLE A ENTRIES FOR WHICH ALL REPORTS ARE
C                 CONSIDERED TO BE RESTRICTED. THEY WILL NOT BE
C                 REMOVED, BUT ALL OCCURRENCES OF THEIR REPORT IDS WILL
C                 BE UNILATERALLY CHANGED TO EITHER "MASKSTID" (WHERE
C                 THE ID IS STORED BY ITSELF) OR TO ALL "X"'s WHERE THE
C                 NUMBER OF "X"'s CORRESPONDS TO THE NUMBER OF
C                 CHARACTERS IN THE ORIGINAL REPORT ID (WHERE THE ID IS
C                 EMBEDDED IN THE RAW REPORT BULLETIN HEADER STRING).
C                 IN ADDITION, THEIR VALUES FOR "RSRD" AND "EXPRSRD"
C                 WILL BE RE-SET TO MISSING SO THAT THE REPORTS WILL NO
C                 LONGER BE CONSIDERED AS RESTRICTED.  (These messages
C                 must be unpacked and every occurrence of every
C                 report's id must be changed to either "MASKSTID" or
C                 "X"'s and every report's "RSRD" and "EXPRSRD" values
C                 must be changed to missing before the report is
C                 copied.  Switch IMASK_T29 is not considered here.)
C     IMASK_T29 - (10,20) INTEGER ARRAY CONTAINING UP TO 10 POSSIBLE
C                 DUMP REPORT TYPES (1ST DIMENSION) FOR THE UP TO 20
C                 POSSIBLE PREPBUFR TABLE A ENTRIES LISTED IN SWITCH
C                 MSG_MASKA (2ND DIMENSION) (APPLIES ONLY TO PREPBUFR
C                 FILES)
C
C    Note 1: A particular Table A entry should NEVER appear in more
C            than one of MSG_RESTR, MSG_MIXED or MSG_MASKA.
C    Note 2: Any Table A entry not in either MSG_RESTR, MSG_MIXED or
C            MSG_MASKA is assumed to be a Table A entry for BUFR
C            messages for which ALL reports are NON-RESTRICTED (these
C            messages are copied intact, no reports are unpacked).
C    Note 3: Always fill in these arrays MSG_RESTR, MSG_MIXED and
C            MSG_MASKA beginning with word 1.  If there are less than
C            20 words filled in an array, either set the extra words to
C            "        " (8 blank characters) or do not specify them
C            here (they default to "        ").
C    Note 4: For data dump Table A entries in the form "NCtttsss",
C            where "ttt" is the BUFR message type and "sss" is the
C            BUFR message subtype, if the last three characters (the
C            subtype) is specified as 'xxx', then ALL BUFR messages
C            of that type are either treated as having all restricted
C            data all which is to be removed (if in MSG_RESTR), mixed
C            data some of which is to be removed (if in MSG_MIXED) or
C            all restricted data all of which is to have its report id
C            masked (if in MSG_MASKA), regardless of the message
C            subtype. (For example, if MSG_RESTR(1)='NC255xxx', then
C            ALL mesonet BUFR messages are considered to have all
C            restricted data and are all removed regardless of their
C            subtype.)
C    Note 5: For PREPBUFR files, a value of "99999" in array IMASK_T29
C            means not applicable whereas a value of "000" means
C            reports in all dump report types in the corresponding
C            Table A entry in MSG_MASKA should be considered {in this
C            case IMASK_T29(1,x) should be set to 000 and
C            IMASK_T29(2:10,x) should be set to 99999 for all reports
C            in Table A entry MSG_MASKA(x) since they would all be
C            ignored - this is the default for all Table A entries
C            MSG_MASKA(1:20) if this is not set (i.e., for data dump
C            files)}
C      
C   LIST OF REPORT ID MNEMONICS IN EACH REPORT WHICH ARE CURRENTLY
C    MASKED WHEN TABLE A ENTRY IS FOUND IN MSG_MASKA (AND FOR PREPBUFR
C    FILES DUMP REPORT TYPE MATCHES ONE OF THE TYPES IN IMASK_T29
C    AND THE REPORT IS CONSIDERED TO BE RESTRICTED BASED ON ITS VALUES
C    FOR "RSRD" and "EXPRSRD"):
C
C   PREPBUFR file: "SID"   - chgd to "MASKSTID" (all Tbl A entries)
C  (PREPBUFR file  "RSRD" and "EXPRSRD" also set to missing)
C   DUMP file:     "RPID"  - chgd to "MASKSTID" (all Tbl A entries)
C   DUMP file:     "SHPC8" - chgd to "MASKSTID" (Tbl A entry NC001001
C                            and NC001101)
C   DUMP file:     "RRSTG" - chgd to "X" (where the number of "X"'s
C                            corresponds to the the number of
C                            characters in the original report id )
C                            (all applicable Tbl A entries)
C  (DUMP file:     "RSRD" and "EXPRSRD" also set to missing)
C
C   Note: Currently for dump files, the only Table A entry where all
C         occurrences of report id in a report are known to be masked
C         is NC001001 and NC001101.  This code may have to be modified
C         to add this ability to mask all occurrences of report id for
C         other Table A entries.
C
C
C ONE SCRIPT ENVIRONMENT VARIABLE IS READ IN:
C            DIFF_HR - The difference in hours between the current UTC
C                      wall-clock date and the BUFR file center time
C                      (should always be a positive number!). This
C                      is used (after subtracting 4 hours***) to
C                      determine if a BUFR subset that is marked as
C                      restricted (via mnemonic "RSRD") is past the
C                      expiration time of the restriction (mnemonic
C                      "EXPRSRD") and should thus not be filtered out.
C                      (Note: used only for BUFR DUMP and PREPBUFR
C                      subsets in message types listed in namelist
C                      switch MSG_MIXED and for PREPBUFR subsets in
C                      applicalbe dump types and message types listed
C                      in namelist switches IMASK_T29 and MSG_MASKA.)
C                      Defaults to ZERO if not found (i.e., not
C                      exported by the executing script).
C                 *** Four hours is subtracted from DIFF_HR prior to
C                     testing against the BUFR file center time in
C                     order to account for some reports having an obx
C                     time as much as 3-4 hours prior to the center
C                     time in either a dump or PEPBUFR file.  This
C                     ensures that these reports are not inadvertently
C                     retained if the difference between the current
C                     wall-clock date and the BUFR file center time is
C                     very close to the time period of the restriction.
C                     DIFF_HR minus 4 can never be less than zero.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS (iDataPlex and Cray-XC40)
C
C$$$

      PROGRAM BUFR_REMOREST

      CHARACTER*2040 RAWRPT_STG
      CHARACTER*80 FILE
      CHARACTER*8  DIFF_HR,PREPBUFR_MSGTYP(21),PRVSTG_prep,SPRVSTG_prep,
     $             PRVSTG_dump,SPRVSTG_dump
      CHARACTER*8  SUBSET,SID,MSG_RESTR(20),MSG_MIXED(20),MSG_MASKA(20),
     $             RAWRPT(255),SID_orig
      REAL*8       RID_8(8),RASTR_8(255),LALOH_8(2),ACRN_8,ACID_8,SID_8,
     $             RPID_8,PRV_prep_8(2),PRV1_dump_8(255),
     $             PRV2_dump_8(255),BMISS,GETBMISS,rsrd_8(2)
      INTEGER      IMASK_T29(10,20),IRSUB_this_MR(20),IRSUB_this_MM(20),
     $             IMSUB_this(10,20),IRSUB_this_sub_MR(20,0:255),
     $             IRSUB_this_sub_MM(20,0:255),IUSUB_this(0:255,0:256)

      EQUIVALENCE (RID_8(1),SID),(RAWRPT,RASTR_8),
     $            (PRV_prep_8(1),PRVSTG_prep),
     $            (PRV_prep_8(2),SPRVSTG_prep),
     $            (PRV1_dump_8(1),PRVSTG_dump),
     $            (PRV2_dump_8(1),SPRVSTG_dump)

      DATA  LUBFI/21/,LUBFJ/51/,IREC/0/,IRSUB/0/,IMSUB/0/,
     $ IRSUB_this_MR/20*0/,IRSUB_this_MM/20*0/,IMSUB_this/200*0/,
     $ IUSUB/0/,IRSUB_this_sub_MR/5120*0/,IRSUB_this_sub_MM/5120*0/,
     $ IUSUB_this/65792*0/,ireco_last/0/

      DATA PREPBUFR_MSGTYP/'ADPUPA  ','AIRCAR  ','AIRCFT  ','SATWND  ',
     $                     'PROFLR  ','VADWND  ','SATEMP  ','ADPSFC  ',
     $                     'SFCSHP  ','SFCBOG  ','SPSSMI  ','SYNDAT  ',
     $                     'ERS1DA  ','GOESND  ','QKSWND  ','MSONET  ',
     $                     'GPSIPW  ','RASSDA  ','WDSATR  ','ASCATW  ',
     $                     'unknown '/
      NAMELIST/SWITCHES/MSG_RESTR,MSG_MIXED,MSG_MASKA,IMASK_T29

      CALL W3TAGB('BUFR_REMOREST',2021,0175,0012,'NP22')

      READ(11,'(Q,A)',END=1) NBYTES,FILE(1:NBYTES)

    1 CONTINUE

      PRINT 100, FILE(1:NBYTES)
  100 FORMAT(/15X,'WELCOME TO THE BUFR_REMOREST - THE PROGRAM THAT ',
     $ 'REMOVES OR MASKS RESTRICTED REPORTS FROM A BUFR FILE'/42X,
     $ 'LAST REVISION 24 Jun 2021'//30X,'INPUT BUFR FILENAME IS: ',A)

      IMASK_T29 = 99999
      IMASK_T29(1,:) = 000
      MSG_RESTR = '        '
      MSG_MIXED = '        '
      MSG_MASKA = '        '
      IDIFF_HR = 0
      READ(5,SWITCHES)

C  Set BUFRLIB missing (BMISS) to 10E8_8 to avoid integer*4 overflows
C  ------------------------------------------------------------------
      CALL SETBMISS(10E8_8)
      BMISS=GETBMISS()
      print'(1X)'
      print'(" BUFRLIB value for missing is: ",G0)', bmiss
      print'(1X)'

C  .... store rsrd_8 array as "almost" missing, will later encode back
C       into output *.nr PRPEBUFR file for reports with id masked,
C       overwriting original value (won't overwrite if exactly missing)
C       ---------------------------------------------------------------
      rsrd_8 = bmiss - 0.01_8

      IF(MSG_RESTR(1).NE.'        ')  THEN
         PRINT 107
  107 FORMAT(//' ALL BUFR MESSAGES READ IN WITH THE FOLLOWING TABLE A ',
     $ 'ENTRIES ARE SKIPPED (WITHOUT UNPACKING) BECAUSE THEY'/
     $ ' CONTAIN ONLY RESTRICTED REPORTS (FOR SOME PERIOD OF TIME) ALL',
     $ ' OF WHICH ARE TO BE REMOVED:'/)
         DO I = 1,20
            IF(MSG_RESTR(I).EQ.'        ')  EXIT
            PRINT *, MSG_RESTR(I)
         ENDDO
      END IF
      IF(MSG_MIXED(1).NE.'        ')  THEN
         PRINT 108
  108 FORMAT(//' ALL BUFR MESSAGES READ IN WITH THE FOLLOWING TABLE A ',
     $ 'ENTRIES ARE UNPACKED REPORT BY REPORT BECAUSE THEY CAN'/
     $ ' CONTAIN A MIXTURE OF BOTH NON-RESTRICTED AND RESTRICTED ',
     $ 'REPORTS - ALL RESTRICTED REPORTS WITHIN THE TIME'/' PERIOD OF ',
     $ 'THE RESTRICTION ARE TO BE REMOVED:'/)
         DO I = 1,20
            IF(MSG_MIXED(I).EQ.'        ')  EXIT
            PRINT *, MSG_MIXED(I)
         ENDDO
         CALL GET_ENVIRONMENT_VARIABLE('DIFF_HR',DIFF_HR)
         READ(DIFF_HR,'(I8)',END=88,ERR=88) IDIFF_HR
cppppp
ccc      print *
ccc      print *, 'DIFF_HR, IDIFF_HR : ',DIFF_HR, IDIFF_HR
ccc      print *
cppppp
         GO TO 89
   88    CONTINUE
         PRINT 115
  115 FORMAT(/'+++++BUFR_REMOREST: WARNING: ERROR OBTAINING IDIFF_HR -',
     $ ' SET TO ZERO AND CONTINUE'/)
         IDIFF_HR = 0
   89    CONTINUE
         IDIFF_HR_m4 = IDIFF_HR - 4
         IDIFF_HR_m4 = MAX(IDIFF_HR_m4,0)
         PRINT 118, IDIFF_HR,IDIFF_HR_m4
  118 FORMAT(/' ===> The difference between the current wall-clock ',
     $ 'date and the BUFR file center time is',I8,' hours.'/6X,
     $ 'Will consider the difference here to be only',I8,' hours when ',
     $ 'comparing against the time period of the'/6X,'restriction ',
     $ '(this takes into account that some reports may have obs times ',
     $ 'as much as 3-4 hours prior to'/6X,'the BUFR file center time, ',
     $ 'and so ensures that these reports are not inadvertently ',
     $ 'retained if the'/6X,'difference between the current wall-clock',
     $ ' date and the BUFR file center time is very close to the'/
     $ 6X,'the time period of the restriction).'/)
      END IF
      IF(MSG_MASKA(1).NE.'        ')  THEN
         if(MSG_MASKA(1)(1:2).eq.'NC') then

c .. DUMP file case
c    --------------
           PRINT 1107
 1107 FORMAT(//' ALL BUFR MESSAGES READ IN WITH THE FOLLOWING TABLE A ',
     $ 'ENTRIES CONTAIN REPORTS ALL CONSIDERED TO BE RESTRICTED. THEY '/
     $ 'ARE'/' UNPACKED REPORT BY REPORT AND EACH REPORT''S ID (ALL ',
     $ 'OCCURRENCES IN A REPORT) IS CHANGED TO "MASKSTID" OR "X"''S ',
     $ '(MASKED)'/' AND IT''S VALUES FOR "RSRD" AND "EXPRSRD" ARE RE-',
     $ 'SET TO MISSING PRIOR TO THEIR BEING WRITTEN BACK OUT:'/)

         else  

c .. PREPBUFR file case
c    ------------------
           print 3108
 3108 FORMAT(//' ALL BUFR MESSAGES READ IN WITH THE FOLLOWING TABLE A ',
     $ 'ENTRIES ARE UNPACKED REPORT BY REPORT BECAUSE THEY CAN'/
     $ ' CONTAIN A MIXTURE OF BOTH NON-RESTRICTED AND RESTRICTED ',
     $ 'REPORTS - THE ID''s FOR ALL RESTRICTED REPORTS WITHIN THE'/
     $ ' TIME PERIOD OF THE RESTRICTION ARE ALL CHANGED TO "MASKSTID" ',
     $ '(MASKED)  AND THEIR VALUES FOR "RSRD" AND "EXPRSRD"'/' ARE RE-',
     $ 'SET TO MISSING PRIOR TO THEIR BEING WRITTEN BACK OUT:'/)
         end if

         DO I = 1,20
            IF(MSG_MASKA(I).EQ.'        ')  EXIT
            PRINT *, MSG_MASKA(I)
         ENDDO

         if(MSG_MASKA(1)(1:2).ne.'NC') then

c .. PREPBUFR file case
c    ------------------
           CALL GET_ENVIRONMENT_VARIABLE('DIFF_HR',DIFF_HR)
           READ(DIFF_HR,'(I8)',END=988,ERR=988) IDIFF_HR
cppppp
ccc        print *
ccc        print *, 'DIFF_HR, IDIFF_HR : ',DIFF_HR, IDIFF_HR
ccc        print *
cppppp
           GO TO 989
  988      CONTINUE
           PRINT 115
           IDIFF_HR = 0
  989      CONTINUE
           IDIFF_HR_m4 = IDIFF_HR - 4
           IDIFF_HR_m4 = MAX(IDIFF_HR_m4,0)
           PRINT 118, IDIFF_HR,IDIFF_HR_m4
         end if 
      END IF

      PRINT 109
  109 FORMAT(//' ALL OTHER BUFR MESSAGES READ IN ARE COPIED INTACT ',
     $ '(WITHOUT UNPACKING) BECAUSE THEY CONTAIN ONLY NON-RESTRICTED ',
     $ 'REPORTS'//)

      CALL DATELEN(10)
      CALL OPENBF(LUBFI,'IN',LUBFI)
      PRINT 101, LUBFI,LUBFI
  101 FORMAT(/5X,'===> BUFR FILE IN UNIT',I3,' SUCCESSFULLY OPENED ',
     $ 'FOR INPUT; BUFR TABLE IS OBTAINED INTERNALLY FROM UNIT',I3/)
      CALL OPENBF(LUBFJ,'OUT',LUBFI)
      PRINT 102, LUBFJ,LUBFI,LUBFJ
  102 FORMAT(/5X,'===> BUFR FILE IN UNIT',I3,' SUCCESSFULLY OPENED FOR',
     $ ' OUTPUT; BUFR TABLE IS OBTAINED FROM UNIT',I3,' AND STORED'/10X,
     $ 'INTERNALLY INTO UNIT',I3/)

C  CHECK TO MAKE SURE THE SAME TABLE A ENTRY DOES NOT APPEAR IN MORE
C   THAN ONE OF THE ARRAYS MSG_RESTR, MSG_MIXED OR MSG_MASKA
C  -----------------------------------------------------------------

      DO I = 1,20
         IF(MSG_RESTR(I).EQ.'        ')  EXIT
         DO J = 1,20
            IF(MSG_MIXED(J).EQ.'        ')  EXIT
            IF(MSG_RESTR(I).EQ.MSG_MIXED(J))  THEN
               PRINT 105, I,MSG_RESTR(I),J
  105 FORMAT('#####BUFR_REMOREST: WORD ',I2,' OF NAMELIST VARIABLE ',
     $ 'MSG_RESTR CONTAINS THE SAME TABLE A ENTRY (=',A,') AS WORD ',I2,
     $  'OF NAMELIST VARIABLE MSG_MIXED - STOP 99')
               CALL W3TAGE('BUFR_REMOREST')
               CALL ERREXIT(99)
            END IF
            IF(MSG_RESTR(I).EQ.MSG_MASKA(J))  THEN
               PRINT 1105, I,MSG_RESTR(I),J
 1105 FORMAT('#####BUFR_REMOREST: WORD ',I2,' OF NAMELIST VARIABLE ',
     $ 'MSG_RESTR CONTAINS THE SAME TABLE A ENTRY (=',A,') AS WORD ',I2,
     $  'OF NAMELIST VARIABLE MSG_MASKA - STOP 99')
               CALL W3TAGE('BUFR_REMOREST')
               CALL ERREXIT(99)
            END IF
         ENDDO
      ENDDO
      DO I = 1,20
         IF(MSG_MIXED(I).EQ.'        ')  EXIT
         DO J = 1,20
            IF(MSG_MASKA(J).EQ.'        ')  EXIT
            IF(MSG_MIXED(I).EQ.MSG_MASKA(J))  THEN
               PRINT 2105, I,MSG_MIXED(I),J
 2105 FORMAT('#####BUFR_REMOREST: WORD ',I2,' OF NAMELIST VARIABLE ',
     $ 'MSG_MIXED CONTAINS THE SAME TABLE A ENTRY (=',A,') AS WORD ',I2,
     $  'OF NAMELIST VARIABLE MSG_MASKA - STOP 99')
               CALL W3TAGE('BUFR_REMOREST')
               CALL ERREXIT(99)
            END IF
         ENDDO
      ENDDO

C  READ IN NEXT INPUT BUFR MESSAGE FROM BUFR FILE
C  ----------------------------------------------

      LOOP1: DO WHILE(IREADMG(LUBFI,SUBSET,IDATE).EQ.0)
 
C  For GPS-RO, increase max message length
         if(subset.eq.'NC003010') then
           call maxout(200000)
         end if

         CALL UFBCNT(LUBFI,IREC,ISUB)
         ISUB = NMSUB(LUBFI)
         iminu = iupvs01(lubfi,'MINU')
         PRINT 103, IREC,SUBSET,IDATE,iminu,ISUB
  103    FORMAT(/5X,'===> READ IN BUFR DATA MESSAGE NO. ',I5,' - TABLE',
     $    ' A ENTRY IS ',A8,' DATE IS',I11,':',i2.2,'  NO. OF RPTS IN ',
     $    'MESSAGE IS',I6)

         LOOP1n1: DO I = 1,20
            IF(MSG_RESTR(I).EQ.MSG_MIXED(I) .AND.
     $         MSG_MIXED(I).EQ.MSG_MASKA(I))  THEN
               EXIT LOOP1n1 ! All are "        " - no need to test
C**********************************************************************
            ELSE IF(IREC.LE.2.AND.SUBSET(1:2).EQ.'NC'.AND.ISUB.EQ.0)
     $       THEN
               PRINT 111
  111 FORMAT(' This is a dummy message at the top of a data dump BUFR ',
     $ 'file containing the center dump time (record 1) or the dump'/
     $ ' processing time (record 2); irregardless of any restriction ',
     $ 'switch on this message, copy it, intact, to output BUFR file')
               CALL CLOSMG(LUBFJ)
               CALL COPYMG(LUBFI,LUBFJ)
               CYCLE LOOP1
C**********************************************************************
            ELSE IF(SUBSET.EQ.MSG_RESTR(I) .OR. (MSG_RESTR(I)(6:8).EQ.
     $       'xxx'.AND.SUBSET(1:5).EQ.MSG_RESTR(I)(1:5)))  THEN
               PRINT 112
  112 FORMAT(' #####>>>> ALL reports in this message are RESTRICTED ',
     $ 'and are REMOVED - do NOT copy this message to output BUFR file')
               IRSUB_this_MR(I) = IRSUB_this_MR(I) + ISUB
              IF(SUBSET(1:2).EQ.'NC'.AND.MSG_RESTR(I)(6:8).EQ.'xxx')THEN
                  READ(SUBSET(6:8),'(I3)') ISUBSET_678
                  IF(ISUBSET_678.GE.0.AND.ISUBSET_678.LE.255) THEN
                     IRSUB_this_sub_MR(I,ISUBSET_678) =
     $                          IRSUB_this_sub_MR(I,ISUBSET_678) + ISUB
                  ELSE
                     PRINT 7115, ISUBSET_678,SUBSET
 7115 FORMAT(/'+++++BUFR_REMOREST: WARNING: INVALID BUFR MESSAGE ',
     $ 'SUBTYPE READ IN: ',I5.3,', SUBSET = ',A,' CANNOT INCREMENT ',
     $ 'RESTRICTED REPORT'/29X,'SKIPPED COUNTER FOR THIS SUBSET'/)
                  END IF
               END IF
               IRSUB = IRSUB + ISUB
               CYCLE LOOP1
C**********************************************************************
            ELSE IF(SUBSET.EQ.MSG_MIXED(I) .OR. (MSG_MIXED(I)(6:8).EQ.
     $       'xxx'.AND.SUBSET(1:5).EQ.MSG_MIXED(I)(1:5)))  THEN
               PRINT 113
  113 FORMAT(' #####>>>> rpts in this msg mixed restr/non-restr- restr',
     $ 'data w/i exp. time REMOVED- unpk each rpt & test mnems. ',
     $ '"RSRD" & "EXPRSRD"')

C  READ A SUBSET (REPORT) IN MESSAGE
C  ---------------------------------

               LOOP1n2: DO WHILE(IREADSB(LUBFI).EQ.0)

C  DECODE THE SUBSET (REPORT) LOOKING FOR RESTRICTED FLAG (MNEMONIC
C   "RSRD") AND TIME OF EXPIRATION ON RESTRICTION (MNEMONIC "EXPRSRD")
C   (if "EXPRSRD" is missing set it to 99999999 hours essentially
C    meaning the report is restricted for all time)
C  -------------------------------------------------------------------

                  CALL UFBINT(LUBFI,RID_8,7,1,NLV,
     $                               'SID RPT YOB XOB TYP RSRD EXPRSRD')
                  IF(RID_8(6).GT.0.AND.IBFMS(RID_8(6)).EQ.0)  THEN
                     IF(IBFMS(RID_8(7)).NE.0)  RID_8(7) = 99999999.
                     IF(IDIFF_HR_m4.LE.RID_8(7))  THEN
                        IF(IBFMS(RID_8(5)).EQ.0)  THEN

C  Normally for PREPBUFR files
C  ---------------------------

                           IF(SUBSET.EQ.'MSONET  ') THEN
                              CALL UFBINT(LUBFI,PRV_prep_8,2,1,NLV,
     $                                                 'PRVSTG SPRVSTG')
                              PRINT 8104, SID,(RID_8(II),II=2,4),
     $                         (NINT(RID_8(II)),II=5,7),PRVSTG_prep,
     $                         SPRVSTG_prep
 8104 FORMAT(5X,'- **Skip ',A8,F7.2,'UTC',F7.2,'(N+/S-) LAT',F7.2,' E ',
     $ 'LON, RTYP=',I3,', RSRD=',I5,' EXPRSRD=',I5,', PRVID=',A8,
     $ ' SPRVID=',A8)
                           ELSE
                              PRINT 104, SID,(RID_8(II),II=2,4),
     $                         (NINT(RID_8(II)),II=5,7)
  104 FORMAT(5X,'- **Skip report ',A8,' at ',F6.2,' UTC, ',F6.2,
     $ ' (N+/S-) LAT, ',F7.2,' E LON, RTYP= ',I3,', RSRD=',I5,
     $ ' EXPRSRD=',I5)
                           END IF
                        ELSE

C  Normally for DATA DUMP files
C  ----------------------------

                           CALL UFBINT(LUBFI,RID_8,7,1,NLV,
     $                          'RPID HOUR MINU CLAT CLON RSRD EXPRSRD')
                           IF(IBFMS(RID_8(4)).NE.0) THEN
                              CALL UFBINT(LUBFI,LALOH_8,2,1,NLV,
     $                                                    'CLATH CLONH')
                              RID_8(4:5) = LALOH_8
                           END IF
                           IF(IBFMS(RID_8(1)).NE.0) THEN
                              IF(SUBSET.EQ.'NC004004' .OR.
     $                           SUBSET.EQ.'NC004006' .OR.
     $                           SUBSET.EQ.'NC004009' .OR.
     $                           SUBSET.EQ.'NC004010' .OR.
     $                           SUBSET.EQ.'NC004011' .OR.
     $                           SUBSET.EQ.'NC004014') THEN
                                CALL UFBINT(LUBFI,ACRN_8,1,1,NLV,'ACRN')
                                 RID_8(1) = ACRN_8
                              ELSE IF(SUBSET.EQ.'NC004008' .OR.
     $                                SUBSET.EQ.'NC004012' .OR.
     $                                SUBSET.EQ.'NC004013') THEN
                                CALL UFBINT(LUBFI,ACID_8,1,1,NLV,'ACID')
                                 RID_8(1) = ACID_8
                              ELSE IF(SUBSET.EQ.'NC007001' .OR.
     $                                SUBSET.EQ.'NC007002') THEN
                                 SID = '        '
                              ELSE
                                 SID = 'MISSING '
                              END IF
                           END IF
                           IF(SUBSET(3:5).EQ.'255') THEN
                              CALL UFBINT(LUBFI,PRV1_dump_8,1,255,NLV,
     $                                                         'PRVSTG')
                              IF(NLV.LT.1) PRVSTG_dump = '        '
                              CALL UFBINT(LUBFI,PRV2_dump_8,1,255,NLV,
     $                                                        'SPRVSTG')
                              IF(NLV.LT.1) SPRVSTG_dump = '        '
                              PRINT 8105, SID,(NINT(RID_8(II)),II=2,3),
     $                         (RID_8(II),II=4,5), NINT(RID_8(6)),
     $                         NINT(RID_8(7)),PRVSTG_dump,SPRVSTG_dump
 8105 FORMAT(5X,'- **Skip ',A8,' at ',2(I2.2),' UTC',F7.2,' (N+/S-) ',
     $ 'LAT',F8.2,' (E+/W-) LON, RSRD=',I5,' EXPRSRD=',I5,', PRVID=',A8,
     $ ' SPRVID=',A8)
                           ELSE
                              PRINT 110, SID,(NINT(RID_8(II)),II=2,3),
     $                         (RID_8(II),II=4,5), NINT(RID_8(6)),
     $                         NINT(RID_8(7))
  110 FORMAT(5X,'- **Skip report ',A8,' at ',2(I2.2),' UTC, ',F6.2,
     $ ' (N+/S-) LAT, ',F7.2,'(E+/W-) LON, RSRD=',I5,' EXPRSRD=',I5)
                           END IF
                        END IF
                        IRSUB_this_MM(I) = IRSUB_this_MM(I) + 1
                        IF(SUBSET(1:2).EQ.'NC'.AND.
     $                   MSG_MIXED(I)(6:8).EQ.'xxx') THEN
                           READ(SUBSET(6:8),'(I3)') ISUBSET_678
                           IF(ISUBSET_678.GE.0.AND.ISUBSET_678.LE.255)
     $                      THEN
                              IRSUB_this_sub_MM(I,ISUBSET_678) =
     $                             IRSUB_this_sub_MM(I,ISUBSET_678) + 1
                           ELSE
                              PRINT 7115, ISUBSET_678,SUBSET
                           END IF
                        END IF
                        IRSUB = IRSUB + 1
                        CYCLE  LOOP1n2
                     END IF
                  END IF

cppppp
ccc               IF(IBFMS(RID_8(5)).EQ.0)  THEN
ccc                  IF(SUBSET.EQ.'MSONET  ') THEN
ccc                     CALL UFBINT(LUBFI,PRV_prep_8,2,1,NLV,
ccc  $                                                 'PRVSTG SPRVSTG')
ccc                     PRINT 9104, SID,(RID_8(II),II=2,4),
ccc  $                   (NINT(RID_8(II)),II=5,7),PRVSTG_prep,
ccc  $                   SPRVSTG_prep
 9104 FORMAT(5X,'- Retain ',A8,F7.2,'UTC',F7.2,'(N+/S-) LAT',F7.2,' E ',
     $ 'LON, RTYP=',I3,', RSRD=',I5,' EXPRSRD=',I5,', PRVID=',A8,
     $ ' SPRVID=',A8)
ccc                        ELSE
ccc                           PRINT 214, SID,(RID_8(II),II=2,4),
ccc  $                        (NINT(RID_8(II)),II=5,7)
  214 FORMAT(5X,'- Retain report ',A8,' at ',F6.2,' UTC, ',F6.2,
     $ ' (N+/S-) LAT, ',F7.2,' E LON, RTYP= ',I3,', RSRD=',I5,
     $ ' EXPRSRD=',I5)
ccc                        END IF
ccc               ELSE
ccc                  CALL UFBINT(LUBFI,RID_8,7,1,NLV,
ccc  $                          'RPID HOUR MINU CLAT CLON RSRD EXPRSRD')
ccc                  IF(IBFMS(RID_8(4)).NE.0) THEN
ccc                     CALL UFBINT(LUBFI,LALOH_8,2,1,NLV,'CLATH CLONH')
ccc                     RID_8(4:5) = LALOH_8
ccc                  END IF
ccc                  IF(IBFMS(RID_8(1)).NE.0) THEN
ccc                     IF(SUBSET.EQ.'NC004004' .OR.
ccc  $                     SUBSET.EQ.'NC004006' .OR.
ccc  $                     SUBSET.EQ.'NC004009' .OR.
ccc  $                     SUBSET.EQ.'NC004010' .OR.
ccc  $                     SUBSET.EQ.'NC004011' .OR.
ccc  $                     SUBSET.EQ.'NC004014') THEN
ccc                        CALL UFBINT(LUBFI,ACRN_8,1,1,NLV,'ACRN')
ccc                        RID_8(1) = ACRN_8
ccc                     ELSE IF(SUBSET.EQ.'NC004008' .OR.
ccc  $                          SUBSET.EQ.'NC004012' .OR.
ccc  $                          SUBSET.EQ.'NC004013') THEN
ccc                        CALL UFBINT(LUBFI,ACID_8,1,1,NLV,'ACID')
ccc                        RID_8(1) = ACID_8
ccc                     ELSE IF(SUBSET.EQ.'NC007001' .OR.
ccc  $                          SUBSET.EQ.'NC007002') THEN
ccc                        SID = '        '
ccc                     ELSE
ccc                        SID = 'MISSING '
ccc                     END IF
ccc                  END IF
ccc                  IF(SUBSET(3:5).EQ.'255') THEN
ccc                     CALL UFBINT(LUBFI,PRV1_dump_8,1,255,NLV,
ccc  $                                                         'PRVSTG')
ccc                     IF(NLV.LT.1) PRVSTG_dump = '        '
ccc                     CALL UFBINT(LUBFI,PRV2_dump_8,1,255,NLV,
ccc  $                                                        'SPRVSTG')
ccc                     IF(NLV.LT.1) SPRVSTG_dump = '        '
ccc                     PRINT 9105, SID,(NINT(RID_8(II)),II=2,3),
ccc  $                   (RID_8(II),II=4,5), NINT(RID_8(6)),
ccc  $                   NINT(RID_8(7)),PRVSTG_dump,SPRVSTG_dump
 9105 FORMAT(5X,'- Retain ',A8,' at ',2(I2.2),' UTC',F7.2,' (N+/S-) ',
     $ 'LAT',F8.2,' (E+/W-) LON, RSRD=',I5,' EXPRSRD=',I5,', PRVID=',A8,
     $ ' SPRVID=',A8)
ccc                  ELSE
ccc                     PRINT 215, SID,(NINT(RID_8(II)),II=2,3),
ccc  $                   (RID_8(II),II=4,5),NINT(RID_8(6)),
ccc  $                   NINT(RID_8(7))
  215 FORMAT(5X,'- Retain report ',A8,' at ',2(I2.2),' UTC, ',F6.2,
     $ ' (N+/S-) LAT, ',F7.2,'(E+/W-) LON, RSRD=',I5,' EXPRSRD=',I5)
ccc                  END IF
ccc               END IF
cppppp
                  CALL OPENMB(LUBFJ,SUBSET,IDATE)
                  call ufbcnt(lubfj,ireco,isubo)
                  if(ireco.ne.ireco_last) then
C Encode minutes into Sec. 1 of new output message header if non-zero
                     if(iminu.ne.0) call minimg(lubfj,iminu)
                  end if
                  ireco_last  = ireco
                  CALL UFBCPY(LUBFI,LUBFJ)
                  CALL WRITSB(LUBFJ)
                  IF(SUBSET(1:2).EQ.'NC') THEN
                     READ(SUBSET(3:5),'(I3)') ISUBSET_345
                     READ(SUBSET(6:8),'(I3)') ISUBSET_678
                  ELSE
                     ISUBSET_678 = 256
                     ISUBSET_345 = -99
                     DO II = 1,20
                        IF(SUBSET.EQ.PREPBUFR_MSGTYP(II)) THEN
                           ISUBSET_345 = II
                           EXIT
                        END IF
                     ENDDO
                     IF(ISUBSET_345.EQ.-99) ISUBSET_345 = 21
                  END IF
                  IF(SUBSET(1:2).EQ.'NC' .AND.
     $               ((ISUBSET_345.LT.0.OR.ISUBSET_345.GT.255) .OR.
     $                (ISUBSET_678.LT.0.OR.ISUBSET_678.GT.255))) THEN
                     PRINT 7116, SUBSET
 7116 FORMAT(/'+++++BUFR_REMOREST: WARNING: INVALID BUFR MESSAGE ',
     $ 'TYPE AND/OR SUBTYPE READ IN, SUBSET = ',A,' CANNOT INCREMENT'
     $ /29X,'NON-RESTRICTED REPORT COPIED COUNTER FOR THIS SUBSET'/)
                  ELSE
                     IUSUB_this(ISUBSET_345,ISUBSET_678) =
     $                          IUSUB_this(ISUBSET_345,ISUBSET_678) + 1
                  END IF                  
                  IUSUB = IUSUB + 1
               ENDDO  LOOP1n2
               CYCLE  LOOP1
C**********************************************************************
            ELSE IF(SUBSET.EQ.MSG_MASKA(I) .OR. (MSG_MASKA(I)(6:8).EQ.
     $       'xxx'.AND.SUBSET(1:5).EQ.MSG_MASKA(I)(1:5)))  THEN
               IF(IMASK_T29(1,I).EQ.000)  THEN
                  if(subset(1:2).eq.'NC') then

c  .. DUMP file case
c     --------------
                     PRINT 1113
 1113 FORMAT('  ###>> ALL rpts in msg RESTRICTED - unpk each rpt, MASK ',
     $ 'all id''s (chg to "MASKSTID" or "X"''s), set to non-restr, ',
     $ ' copy to output file')
                   else

c  .. PREPBUFR file case
c     ------------------
                     print 1114
                  end if
               ELSE

c  .. PREPBUFR file case
c     ------------------
                  PRINT 1114
 1114 FORMAT('  ###>> some rpts in msg may be RESTRICTED: if so & w/i ',
     $ 'expir time, MASK id (chg to "MASKSTID"), set to non-restr, cpy',
     $ ' to output file')
                  DO J = 1,10
                     IF(IMASK_T29(J,I).NE.99999)  PRINT 1115,
     $                IMASK_T29(J,I)
 1115 FORMAT('  -- rpts in dump type ',I3,' mixed restr./non-restr.- ',
     $ 'for restr. rpts w/i expir. time, MASK id, set to non-restr & ',
     $ 'copy to output file')
                  ENDDO
               END IF

C  READ A SUBSET (REPORT) IN MESSAGE
C  ---------------------------------

               LOOP1n3: DO WHILE(IREADSB(LUBFI).EQ.0)

C  DECODE THE SUBSET (REPORT) IN ORDER TO OBTAIN THE REPORT ID
C  -----------------------------------------------------------

                  CALL OPENMB(LUBFJ,SUBSET,IDATE)
                  call ufbcnt(lubfj,ireco,isubo)
                  if(ireco.ne.ireco_last) then
C Encode minutes into Sec. 1 of new output message header if non-zero
                     if(iminu.ne.0) call minimg(lubfj,iminu)
                  end if
                  ireco_last  = ireco
                  CALL UFBCPY(LUBFI,LUBFJ)
                  CALL UFBINT(LUBFI,RID_8,8,1,NLV,
     $                        'SID RPT YOB XOB TYP T29 RSRD EXPRSRD')
                  IF(IBFMS(RID_8(5)).EQ.0)  THEN

C  Come here for PREPBUFR files (report id is in mnemonic "SID")
C   -- check for a match of dump report type
C  -------------------------------------------------------------

                     DO J = 1,10
                        IF(IMASK_T29(1,I).EQ.000.OR.
     $                     IMASK_T29(J,I).EQ.NINT(RID_8(6)))  THEN

C    .... dump report types match - look for restricted flag (mnemonic
C         "RSRD") and time of expiration on restriction (mnemonic
C         "EXPRSRD") (if "EXPRSRD" is missing set it to 99999999 hours
C          essentially meaning the report is restricted for all time)
C         ------------------------------------------------------------
                           if(rid_8(7).gt.0.and.ibfms(rid_8(7)).EQ.0)
     $                      then
                              if(ibfms(rid_8(8)).ne.0)
     $                         rid_8(8) = 99999999.
                              if(IDIFF_HR_m4.le.rid_8(8))  then
                                 PRINT 1104, SID,(RID_8(II),II=2,4),
     $                            (NINT(RID_8(II)),II=5,8)
 1104 FORMAT(5X,'- Chg ID of rpt ',A8,' at',F6.2,' UTC, ',F6.2,
     $ ' LAT,',F7.2,' E LON, RTYP=',I3,', DTYP=',I5,
     $ ', RSRD=',I5,', EXPRSRD=',I5,' TO "MASKSTID"')
                                 SID = 'MASKSTID'
                                 SID_8 = RID_8(1)
                                 IMSUB_this(J,I) = IMSUB_this(J,I) + 1

C    .... update report id to masked value - "MASKSTID"
C         ---------------------------------------------
                                 CALL UFBINT(LUBFJ,SID_8,1,1,IRET,'SID')

C    .... re-set RSRD & EXPRSRD to "almost" missing so rpt is no longer
C          restricted
C         -----------------------r-------------------------------------
                       call ufbint(lubfj,rsrd_8,2,1,iret,'RSRD EXPRSRD')
                                 EXIT
                              END IF
                           END IF
                        END IF
                     ENDDO
                  ELSE

C  Come here for DATA DUMP files where all reports are restricted
C   {report id is in mnemonic "RPID" (and for surface ship reports in
C   Table A entry 'NC001001' and 'NC001101' also in mnemonic "SHPC8"),
C   report id may also be embedded in replicated raw bulletin header
C   string if it is present}
C  -------------------------------------------------------------------

                     IUPDATE_RAWRPT = 0
                     CALL UFBINT(LUBFI,RID_8,7,1,NLV,
     $                          'RPID HOUR MINU CLAT CLON RSRD EXPRSRD')
                     PRINT 1110, SID,(NINT(RID_8(II)),II=2,3),
     $                (RID_8(II),II=4,5), NINT(RID_8(6)),NINT(RID_8(7))
 1110 FORMAT('  - Chg all instances of rpt id ',A8,' ',2(I2.2),' UTC, ',
     $ F6.2,'(N+/S-) LAT ',F7.2,'(E+/W-) LON, RSRD=',I5,', EXPRSRD=',I5,
     $ ' to MASKSTID or X''s')
                     SID_orig = SID
                     SID = 'MASKSTID'
                     RPID_8 = RID_8(1)
                     IMSUB_this(1,I) = IMSUB_this(1,I) + 1

C    .... update report id in output file to masked value - "MASKSTID"
C         ------------------------------------------------------------
                     CALL UFBINT(LUBFJ,RPID_8,1,1,IRET,'RPID')

C    .... re-set RSRD & EXPRSRD to "almost" missing so rpt is no longer
C          restricted
C         -----------------------r-------------------------------------
                     call ufbint(lubfj,rsrd_8,2,1,iret,'RSRD EXPRSRD')
                     CALL UFBINT(LUBFJ,RID_8(1),1,1,IRET,'RPID')
                     IF(SUBSET.EQ.'NC001001'.or.
     $                  subset.eq.'NC001101') THEN

C    .... update 2nd rpt id in ship rpts in output file to masked value
C         - "MASKSTID"
C         -------------------------------------------------------------
                        CALL UFBINT(LUBFJ,RPID_8,1,1,IRET,'SHPC8')
                     END IF

C    .... see if a replicated raw report bulletin header string is
C         present
C         --------------------------------------------------------
                     CALL UFBINT(LUBFI,RASTR_8,1,255,NLV,'RRSTG')
                     IST = 1
                     IF(NLV.GT.0)  THEN

C        .... it is, store entire string in character array RAWRPT_STG
C             --------------------------------------------------------
                        DO II = 1,NLV
                           IEN = IST+7
                           RAWRPT_STG(IST:IEN) = RAWRPT(II)
                           IST = IST + 8
                        ENDDO
cppppp
ccc   print *, 'orig RAWRPT_STG: "',RAWRPT_STG(1:IEN),'", IEN = ',ien
cppppp

C        .... next determine character length of report id (ICHAR_id)
C             for later check to see if it is embedded one or more
C             times in raw report bulletin header string
C             -------------------------------------------------------
                        DO II = 1,8
                           IF(SID_orig(II:II).EQ.' ')  THEN
                              ICHAR_id = II - 1
                              EXIT
                           END IF
                        ENDDO
cppppp
ccc   print *, 'original sid had ',ICHAR_id,' characters'
cppppp
                        IF(ICHAR_id.GE.1)  THEN

C        .... next parse through entire raw report bulletin header
C             string looking for one or more occurrences of report id
C             and "X" out the id
C             -------------------------------------------------------
                           DO II = 1,IEN
                              IF(II+ICHAR_id-1.GT.IEN)  EXIT
                              IF(RAWRPT_STG(II:II+ICHAR_id-1).EQ.
     $                           SID_orig(1:ICHAR_id))  THEN
cppppp
ccc   print *, 'Found a match to orig sid in RAWRPT_STG',' - in bytes ',
ccc  $ II,' to ',II+ICHAR_id-1,' - set to "X"'
cppppp
                                 DO JJ = II,II+ICHAR_id-1
                                    RAWRPT_STG(JJ:JJ) = 'X'
                                 ENDDO
                                 IUPDATE_RAWRPT = 1
                              END IF
                           ENDDO

C        .... reconstruct replicated raw report bulletin header string,
C             but now with the id "X"'d out
C             ---------------------------------------------------------
                           IF(IUPDATE_RAWRPT.EQ.1)  THEN
                              IST = 1
                              DO II = 1,NLV
                                 IEN = IST+7
                                 RAWRPT(II) = RAWRPT_STG(IST:IEN)
                                 IST = IST + 8
                              ENDDO

C        .... finally, update replicated raw report bulletin header
C             string with the id "X"'d out in output file
C             -----------------------------------------------------
                              CALL UFBINT(LUBFJ,RASTR_8,1,NLV,IRET,
     $                                    'RRSTG')
cppppp
ccc   print *, 'updt RAWRPT_STG: "',RAWRPT_STG(1:IEN),'", IEN = ',ien
cppppp
                           END IF
                        END IF
                     END IF
                  END IF
                  IF(SID.EQ.'MASKSTID')  THEN
                     IMSUB = IMSUB + 1
                  ELSE
                     IF(SUBSET(1:2).EQ.'NC') THEN
                        READ(SUBSET(3:5),'(I3)') ISUBSET_345
                        READ(SUBSET(6:8),'(I3)') ISUBSET_678
                     ELSE
                        ISUBSET_678 = 256
                        ISUBSET_345 = -99
                        DO II = 1,20
                           IF(SUBSET.EQ.PREPBUFR_MSGTYP(II)) THEN
                              ISUBSET_345 = II
                              EXIT
                           END IF
                        ENDDO
                        IF(ISUBSET_345.EQ.-99) ISUBSET_345 = 21
                     END IF
                     IF(SUBSET(1:2).EQ.'NC' .AND.
     $                  ((ISUBSET_345.LT.0.OR.ISUBSET_345.GT.255) .OR.
     $                   (ISUBSET_678.LT.0.OR.ISUBSET_678.GT.255))) THEN
                        PRINT 7116, SUBSET
                     ELSE
                        IUSUB_this(ISUBSET_345,ISUBSET_678) =
     $                          IUSUB_this(ISUBSET_345,ISUBSET_678) + 1
                     END IF
                     IUSUB = IUSUB + 1
                  END IF
                  CALL WRITSB(LUBFJ)
               ENDDO  LOOP1n3
               CYCLE  LOOP1
            END IF
         ENDDO  LOOP1n1
C**********************************************************************
         PRINT 114
  114 FORMAT(' ALL reports in this message are NON-RESTRICTED - copy',
     $ ' this message, intact, to output BUFR file')
         IF(SUBSET(1:2).EQ.'NC') THEN
            READ(SUBSET(3:5),'(I3)') ISUBSET_345
            READ(SUBSET(6:8),'(I3)') ISUBSET_678
         ELSE
            ISUBSET_678 = 256
            ISUBSET_345 = -99
            DO II = 1,20
               IF(SUBSET.EQ.PREPBUFR_MSGTYP(II)) THEN
                  ISUBSET_345 = II
                  EXIT
               END IF
            ENDDO
            IF(ISUBSET_345.EQ.-99) ISUBSET_345 = 21
         END IF
         IF(SUBSET(1:2).EQ.'NC' .AND.
     $      ((ISUBSET_345.LT.0.OR.ISUBSET_345.GT.255) .OR.
     $       (ISUBSET_678.LT.0.OR.ISUBSET_678.GT.255))) THEN
            PRINT 7116, SUBSET
         ELSE
            IUSUB_this(ISUBSET_345,ISUBSET_678) =
     $                       IUSUB_this(ISUBSET_345,ISUBSET_678) + ISUB
         END IF
         IUSUB = IUSUB + ISUB
         CALL CLOSMG(LUBFJ)
         CALL COPYMG(LUBFI,LUBFJ)
C**********************************************************************
      ENDDO  LOOP1
            
C  ALL MESSAGES IN INPUT PREPBUFR/DATA DUMP FILE HAVE BEEN READ AND
C   PROCESSED
C  ----------------------------------------------------------------

      CALL CLOSBF(LUBFI)
      CALL CLOSBF(LUBFJ)

      PRINT 106, IRSUB
  106 FORMAT(//'==> A TOTAL OF',I11,' RESTRICTED   REPORTS WERE ',
     $ 'SKIPPED')
      DO I = 1,20
         IF(IRSUB_this_MR(I).GT.0) THEN
            PRINT 1106, IRSUB_this_MR(I),MSG_RESTR(I)
            DO J = 0,255
               IF(IRSUB_this_sub_MR(I,J).GT.0) THEN
                  PRINT 2106, IRSUB_this_sub_MR(I,J),MSG_RESTR(I)(1:5),J
               END IF
            ENDDO
         END IF
      ENDDO
      DO I = 1,20
         IF(IRSUB_this_MM(I).GT.0) THEN
            PRINT 1106, IRSUB_this_MM(I),MSG_MIXED(I)
            DO J = 0,255
               IF(IRSUB_this_sub_MM(I,J).GT.0) THEN
                  PRINT 2106, IRSUB_this_sub_MM(I,J),MSG_MIXED(I)(1:5),J
               END IF
            ENDDO
         END IF
      ENDDO
 1106 FORMAT(16X,'--> ',I11,' reports from message type ',A)
 2106 FORMAT(21X,'--> ',I11,' reports from message type ',A,I3.3)

      PRINT 116, IMSUB
  116 FORMAT(//'==> A TOTAL OF',I11,' RESTRICTED   REPORTS WERE ',
     $ 'MASKED AND THEN COPIED')
      DO I = 1,20
         DO J = 1,10
            IF(IMSUB_this(J,I).GT.0) THEN
               IF(IMASK_T29(J,I).GT.0) THEN
                  PRINT 1108,IMSUB_this(J,I),MSG_MASKA(I),IMASK_T29(J,I)
               ELSE
                  PRINT 1106,IMSUB_this(J,I),MSG_MASKA(I)
               END IF
            END IF
         ENDDO
      ENDDO
 1108 FORMAT(16X,'--> ',I11,' reports from message type ',A,
     $ ', DUMP report type ',I5)

      PRINT 117, IUSUB
  117 FORMAT(//'==> A TOTAL OF',I11,' NON-RESTRICTED REPORTS WERE ',
     $ 'COPIED'/)
      IPRINT_FLAG = 0
      DO I = 1,21
         IF(IUSUB_this(I,256).GT.0) THEN
            PRINT 2108, IUSUB_this(I,256),PREPBUFR_MSGTYP(I)
            IPRINT_FLAG = 1
         END IF
      ENDDO
 2108 FORMAT(16X,'--> ',I11,' reports from message type ',A)

      IF(IPRINT_FLAG.EQ.0) THEN
         DO I = 0,255
            DO J = 0,255
               IF(IUSUB_this(I,J).GT.0) THEN
                  PRINT 2107, IUSUB_this(I,J),I,J
               END IF
            ENDDO
         ENDDO
      END IF
 2107 FORMAT(16X,'--> ',I11,' reports from message type NC',I3.3,I3.3)

      PRINT 3117
 3117 FORMAT(//'PROGRAM COMPLETED SUCCESSFULLY'/)


      CALL W3TAGE('BUFR_REMOREST')

      STOP

      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: TIMETWIN
C   PRGMMR: LILLY            ORG: NP12        DATE: 2004-04-15
C
C ABSTRACT: FINDS MODEL BUFR WINDS FOR UPPER AIR SITES AND SORTS
C           THEM BEFORE OUTPUT TO BE USED IN THE TIMETWIN CODE
C           WHICH IS LOOKING FOR CURRENT UPPER AIR DATA THAT ARE
C           REALLY DUPLICATES OF PAST DATA

C PROGRAM HISTORY LOG:
C
C 1999-09-15 BRADLEY BALLISH -- ORIGINAL AUTHOR
C 2004-07-16 STEVEN G. LILLY -- ADD SUBROUTINE TWINWIND_HIS_CHECK
C                               AND MOLLIFY/UPDATE SOURCE CODES
C 2006-02-22 BRADLEY BALLISH -- CHANGE OBSERVATION TIME TO BE THE
C                               RAW REPORTED TIME USED IN ARRAY RTIM
C
C USAGE:
C   INPUT FILES:
C     UNIT 10  - GLOBAL MODEL PREPBUFR FILE
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 61  - FILE CONTAINING CURRENT MODEL UPPERAIR WIND DATA FOR PART TTAA 
C     UNIT 62  - FILE CONTAINING CURRENT MODEL UPPERAIR WIND DATA FOR PART TTBB 
C     UNIT 63  - FILE CONTAINING CURRENT MODEL UPPERAIR WIND DATA FOR PART TTCC 
C     UNIT 64  - FILE CONTAINING CURRENT MODEL UPPERAIR WIND DATA FOR PART TTDD 
C     UNIT 65  - FILE CONTAINING CURRENT MODEL UPPERAIR WIND DATA FOR PART PPBB 
C     UNIT 66  - FILE CONTAINING CURRENT MODEL UPPERAIR WIND DATA FOR PART PPDD 

C   SUBPROGRAMS CALLED:
C     UNIQUE:  - TWINWIND_HIS_CHECK PARTID INDEX41 TWINWIND
C     LIBRARY
C       W3LIB    - DATELEN IW3JDN  W3TAGB W3FC05  W3TAGE   
C       BUFRLIB  - OPENBF READMG READSB UFBINT CLOSBF SETIM8B
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C
C REMARKS: OUTPUT WINDS ARE BINARY VERSIONS OF ASCII DATA AND ARE SORTED.
C          CURRENT WIND DATA ARE WRITTEN TO COMMON BLOCK/CURRPART/
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE : IBM-SP
C
C$$$

      PROGRAM TIMETWIN
                                                                                
C     PROGRAM TIMETWIN  BY  B. BALLISH                                             
C                                                                               

C     READ PREPBUFR FILE TO GET  ADPUPA  WINDS
                                                                                
      INTEGER       STNID , DATE                                                
      CHARACTER*41 CARD(6,100000),CARDS(6,960000),CARDT(100000)
      CHARACTER*41 HCARDS(6,960000),CCARDS(6,960000)
      CHARACTER*40 HSTR  , TSTR , VWND                                         
      CHARACTER*18 SUID(90000),UID(90000)
      CHARACTER*10 CDATE 
      CHARACTER*8  SUBSET, SID , CSID, IDS(900)
      CHARACTER*8  CDAT8
      CHARACTER*7  IDOLD
      CHARACTER*2  TTXX(6)
      CHARACTER*1   NORS,EORW
      COMMON /HISTPART/HCARDS,IIMAX(6)
      COMMON /CURRPART/CCARDS,JJMAX(6)
      COMMON /PMAXS/IMAX,JMAX,NP


      DIMENSION  HDR(7), SFC(8,255), IIDATE(5), WFC(7,255),WND(4,255)           
      DIMENSION  IGSD(90000),IGSS(90000),IOBD(90000),IOBS(90000)
      DIMENSION  JOBD(90000),JOBS(90000)
      DIMENSION  ITM(900),IQM(90000),PRS(90000),ISTOP(900),ISTART(900)
      DIMENSION  JQM(90000),PRT(90000)
      DIMENSION  FLON(900),FLAT(900),ELEV(900)
      DIMENSION  WDIF(90000),RTIM(90000),INDR(90000)
      DIMENSION  JCON(6,255),JTYP(6),IM(6)
      EQUIVALENCE  (HDR(1),CSID)                                               
                                                                                
      DATA  HSTR /'SID XOB YOB RPT ELV T29 TYP'/                                
      DATA  VWND /' UOB VOB WQM UFC VFC POB CAT '/                             
      DATA  XMSG /10E10/, INFILE/10/

C     CALL W3TAGB('TIMETWIN',??,??,??,'NP12')
      PRINT *, ' '
      PRINT *, '=====> WELCOME TO PROGRAM TIMETWIN - ',
     $ 'VERSION: 07/16/2004'

      CALL DATELEN(10) 
C     TTXX holds abreviations for the 6 upper air parts used
C     TA is short for TTAA PD is short for PPDD
      TTXX(1)='TA'
      TTXX(2)='TB'
      TTXX(3)='TC'
      TTXX(4)='TD'
      TTXX(5)='PB'
      TTXX(6)='PD'
      IM(1)=0
      IM(2)=0
      IM(3)=0
      IM(4)=0
      IM(5)=0
      IM(6)=0
      FCT=1.98
C     SET COUNTS TO ZERO
      ISTA=0
      IW=0

C     INFORM BUFR THAT ALL INTEGERS ARE 8-BYTES
      CALL SETIM8B(.TRUE.)

C     READ DATA FROM PREVIOUS CYCLE INTO COMMON/HISTPART/ and
C     CHECK THE STATUS OF THE PREVIOUS SET(S) OF WIND DATA.
      CALL TWINWIND_HIS_CHECK
C     IF FILE IS MISSING OR CORRUPT  IT DOES ERREXIT 33


C     OPEN THE BUFR FILE ...
                                                                                
      CALL OPENBF(INFILE,'IN',INFILE)                                           
                                                                                
C     FIND SUBSET 'ADPUPA' ...                                                  
                                                                                
    1 CONTINUE                                                                  
      CALL READMG(INFILE,SUBSET,IDATE,IRET)                                     
      IF(SUBSET.NE.'ADPUPA') THEN                                               
         IF(IRET.NE.0) GO TO 999                                                
         GO TO 1                                                                
      ENDIF                                                                     

C     SPLIT DATE UP INTO COMPONENTS
      WRITE (CDATE, '(I10)')  IDATE      
      CDAT8(1:8)=CDATE(3:10)                                        
      READ  (CDATE, '(5I2)') IIDATE                                             

C     NOW READ THE SUBSET (ADPUPA)                                              
                                                                                
   10 CONTINUE                                                                  
      CALL READSB(INFILE,IRET)                                                  
      IF(IRET.NE.0) THEN                                                        
   20    CONTINUE                                                               
         CALL READMG(INFILE,SUBSET,IDATE,IRET)                                  
         IF(SUBSET.NE.'ADPUPA') THEN                                            
            IF(IRET.NE.0) GO TO 999                                             
            GO TO 20                                                            
         ENDIF                                                                  
            GO TO 10                                                            
      ENDIF                                                                     

C     NOW GET THE DATA ...                                                      
                                                                                
      CALL UFBINT(INFILE,HDR,7,1,IRET,HSTR)                                     
      IRTP = IFIX(HDR(6))                                                       
      ITYP = IFIX(HDR(7))                                                       
c     WRITE(25,158) IRTP,ITYP
 158  FORMAT(' IRTP ITYP= ',2I6)
      JMATCH=0
      IF(ITYP .EQ. 220 .OR. ITYP .EQ. 221 .OR. ITYP .EQ. 232 ) THEN
      CALL UFBINT(INFILE,WFC,7,255,IRET,VWND) 
c     DATA  VWND /' UOB VOB WQM UFC VFC POB CAT '/                             
c     WRITE(25,159) IRET
 159  FORMAT(' IRET= ',I6)
      ISTA=ISTA+1                                    
       FLON(ISTA) = HDR(2)                                                             
       FLAT(ISTA) = HDR(3)                                                             
       ELEV(ISTA) = HDR(5)                                                             
       IDS(ISTA)=CSID
C     DATA  VWND /' UOB VOB WQM UFC VFC POB CAT '/ 

       DO 44 KZ=1,6
       JTYP(KZ)=0

       DO 45 KL=1,255
       JCON(KZ,KL)=0
 45    CONTINUE

 44    CONTINUE

       IW=0

       DO 46 KL=1,IRET
       IWQM=IFIX(WFC(3,KL))                                                         
       ICAT=IFIX(WFC(7,KL))                                                         
       CALL W3FC05(WFC(1,KL),WFC(2,KL),WND(1,KL),WND(2,KL))                                 
       CALL W3FC05(WFC(4,KL),WFC(5,KL),WND(3,KL),WND(4,KL)) 
       UOB=WFC(1,KL)                                
       VOB=WFC(2,KL)                                
       UGS=WFC(4,KL)                                
       VGS=WFC(5,KL)
       IF(ABS(UOB) .LT. 5.0E+10 .AND. ABS(VOB) .LT. 5.0E+10) THEN 
       IW=IW+1
       WDIF(IW)=FCT*SQRT((UOB-UGS)**2 + (VOB-VGS)**2)
       PRS(IW)=WFC(6,KL)
       RTIM(IW)=HDR(4) - FLOAT(IIDATE(5))
       CALL PARTID(UID,CSID,PRS,RTIM,ICAT,IW,ISTA)
 444   FORMAT(A18)

       DO 47 KZ=1,6
       IF(UID(IW)(1:2) .EQ. TTXX(KZ)) THEN
C JTYP(KZ) is 1 for upper air type KZ=1,6
C JCON(KZ,IW) is one for upper air type KZ and the IWth wind
       JTYP(KZ)=JTYP(KZ)+1
       JCON(KZ,IW)=1
       ENDIF 
 47    CONTINUE

       IQM(IW)=INT(WFC(3,KL))
C Make sure the direction is correct to proper 5 degree choice
       IOBD(IW)=5*INT((WND(1,KL)+1.0)/5.0)
       IGSD(IW)=INT(WND(3,KL))
       IGSS(IW)=INT(FCT*WND(4,KL))
       IOBS(IW)=INT(FCT*WND(2,KL))
       ENDIF                                                                    
  46   CONTINUE

       DO 48 KZ=1,6

       IF(JTYP(KZ) .GT. 0) THEN

       DO 49 KL=1,IW

       IF(JCON(KZ,KL) .GT. 0) THEN
       IM(KZ)=IM(KZ)+1
       WRITE(CARD(KZ,IM(KZ)),137) UID(KL)(3:7),PRS(KL),IOBD(KL),
     & IOBS(KL),WDIF(KL),IQM(KL),CDAT8,UID(KL)(8:9),JTYP(KZ)
 137   FORMAT(A5,' ',F6.1,' ',2I3,F5.1,' ',I2,' ',A8,A2,I3)
       ENDIF

  49   CONTINUE

       ENDIF

  48   CONTINUE

       ENDIF
                                                                                
      GO TO 10                                                                  
                                                                                
C     COME HERE WHEN ALL REPORTS HAVE BEEN READ IN -- CLOSE FILE                
C     AND QUIT.

  999 CONTINUE                              
      CALL CLOSBF(INFILE)                                                       
      PRINT 102, IIDATE                                                         
 101  FORMAT(I5)                                                                
 102  FORMAT(' ADPUPA EXTRACTED FOR', 4I3)

      DO 68 KZ=1,6
      MOUT=KZ+60

      
      DO 67 KJ=1,IM(KZ)
      CARDT(KJ)=CARD(KZ,KJ)
 67   CONTINUE

      IF (IM(KZ) .GT. 690000 ) THEN
       print *, 'Warning:Index IM(KZ) exceeds CARDS array size'
       print *, 'KZ=',KZ,' IM(KZ)=',IM(KZ)
       IM(KZ)=0 
      ENDIF

C Do heap sort on array CARDT, store sorted locations in INDR
      CALL INDEX41(IM(KZ),CARDT,INDR)

      DO 69 I=1,IM(KZ)
      CARDS(KZ,I)=CARDT(INDR(I))
      CCARDS(KZ,I)=CARDT(INDR(I))
 69   CONTINUE

C CARDS is now sorted
C CARDS is CHARACTER*41 and holds
C 1:5 is the site ID, 7:12 the pressure, 14:16 the wind direction of the observation
C 17:19 the observation speed in knots, 20:24 the vector difference OB - GES
C 26:27 the wind quality mark, 29:36 the last 6 characters of the date
C that is 00Z 17 March 2004 is 04031700
C 37:38 are the relative time of the observation hour plus 3
C that is 00Z is 03 02z is 05 19Z is 04 etc
C 39:41 is the number of winds in that part, a maximum of 255 is allowed

      WRITE(MOUT) IM(KZ)
      JJMAX(KZ)=IM(KZ)
      WRITE(MOUT) (CARDS(KZ,KL),KL=1,IM(KZ))
c     WRITE(MOUT,105) (CARDS(KZ,KL),KL=1,IM(KZ))
 105  FORMAT(A)
 68   CONTINUE

C      CALL TWINWIND TO COMPARES THE CURRENT WINDS WITH THE LAST 35
C      DAYS OF WINDS TO SEE IF CURRENT DATA IS REALLY OLD
C      IT USES AN INCREMENTAL SORT (INCSORT) TO MERGE ALREADY
C      SORTED OLD AND NEW DATA WHILE FINDING INDIVUAL LEVELS OF
C      WINDS FROM THE SAME ID THAT MATCH FOR OLD AND CURRENT TIMES
C      SUBROUTINE CDUPS CHECKS ALL THESE WIND MATCHES TO SEE IF
C      TWO DIFFERENT MODEL RUNS HAVE ENOUGH WIND MATCHES TO
C      QUALIFY AS A TWINWIND
      CALL TWINWIND
C      CALL W3TAGE('TIMETWIN')
      STOP                                                                      
      END

      SUBROUTINE PARTID(UID,CSID,PRS,RTIM,ICAT,IW,ISTA)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    PARTID      DESCRIPTIVE TITLE NOT PAST COL 70
C   PRGMMR: STEVE LILLY           ORG: W/NP12   DATE: 2004-04-15
C
C ABSTRACT: DOCUMENTATION WILL BE ADDED LATER.
C
C PROGRAM HISTORY LOG:
C 1999-09-15  BRAD BALLISH DEVELOPED ORIGINAL CODE
C
C USAGE:    CALL PARTID(UID,CSID,PRS,RTIM,ICAT,IW,ISTA)
C   INPUT ARGUMENT LIST:
C     CSID is CHARACTER*8 Upper Air Station ID
C     PRS is the pressure of the wind
C     RTIM is the relative time of the report compared to main analysis time
C     ICAT is a BUFR category for the winds ICAT=0 for a surface wind etc
C     IW is an integer counter for the winds
C     ISTA is an integer counter for upper air stations
C
C   OUTPUT ARGUMENT LIST:
C     UID is a CHARACTER*18 array with location 1:2 holding an
C     abbreviation for the upper air type, location 8:9 holds
C     a time used in the timetwin code
C     location 3:7 holds the first 5 characters of the station ID
C
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM
C
C$$$

      DIMENSION PRS(1),RTIM(1)
      CHARACTER*18 UID(900)
      CHARACTER*5 CSID    
      UID(IW)(1:2)='XX'

      IF(ICAT .EQ. 1) THEN
      IF(NINT(PRS(IW)) .GE. 100) UID(IW)(1:2)='TA'
      IF(NINT(PRS(IW)) .LT. 100) UID(IW)(1:2)='TC'
      ENDIF

      IF(ICAT .EQ. 3) THEN
      IF(NINT(PRS(IW)) .GE. 100) UID(IW)(1:2)='TB'
      IF(NINT(PRS(IW)) .LT. 100) UID(IW)(1:2)='TD'
      ENDIF

      IF(ICAT .EQ. 4) THEN
      IF(NINT(PRS(IW)) .GE. 100) UID(IW)(1:2)='PB'
      IF(NINT(PRS(IW)) .LT. 100) UID(IW)(1:2)='PD'
      ENDIF

      UID(IW)(3:7)=CSID
      JTIME=3+NINT(RTIM(IW))
      WRITE(UID(IW)(8:9),45) JTIME
 45   FORMAT(I2.2)
      IPRS=10*IFIX(PRS(IW))
      WRITE(UID(IW)(10:14),46) IPRS 
 46   FORMAT(I5.5)
      WRITE(UID(IW)(15:18),47) ISTA 
 47   FORMAT(I4.4)
      RETURN
      END

       SUBROUTINE INDEX41 (N,ARRIN,INDX)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    INDEX41      DO HEAP SORT FOR ARRAY ARRIN
C   PRGMMR: STEVE LILLY        ORG: W/NP12    DATE: 2004-04-15
C
C ABSTRACT: DOES HEAP SORT ON ARRAY AARIN WITH INDEX OF SORT
C           IN ARRAY INDX
C
C PROGRAM HISTORY LOG:
C   99-09-15 ORIGINAL AUTHOR BRAD BALLISH
C
C USAGE:    CALL INDEX41(IM(KZ),CARDT,INDR)
C   INPUT ARGUMENT LIST:
C     IM(KZ)  THE NUMBER OF ENTRIES IN ARRAY CARDT
C     CARDT   A CHARACTER*41 ARRAY HOLDING
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     INDX   A INTEGER ARRAY GIVING THE SORT RESULTS
C
C
C ATTRIBUTES:
C   LANGUAGE: f90
C   MACHINE:  IBM
C
C$$$

C                                                                       
C      INDEXS AN ARRAY ARRIN(1...N)                                     
C      INPUT:           N SPAN OF SORT                                  
C                                      ARRIN - ARRAY TO BE SORTED - NOT 
C      OUTPUT: INDX - ARRAY OF INDEXES SUCH THAT ARRAY(INDX(I)) IS      
C                                      IN ASCENDING ORDER FOR J = 1,... 
C                                                                       
       INTEGER INDX(*)                                                  
       CHARACTER*41 ARRIN(*),Q                                           
                 
       DO 10 J = 1,N                                                    
           INDX(J) = J                                                  
10     CONTINUE                                                         
                                                                        
       L = N/2 + 1                                                      
                                                                        
       IR = N                                                           
33     CONTINUE                                                         
       IF (L.GT.1) THEN                                                 
           L = L - 1                                                    
           INDXT=INDX(L)
c           print *,'timetwin.f/INDEX41 (if) L=',L,' INDXT=', INDXT            
           Q = ARRIN(INDXT) 
       ELSE                                                             
           INDXT = INDX(IR)
c           print *,'timetwin.f/INDEX41 (else) L=',L,' INDXT=', INDXT 
c           Should wind be missing in a report, exit gracefully
            IF (INDXT.GT.0) THEN
            Q = ARRIN(INDXT)      
            INDX(IR) = INDX(1)    
            IR = IR - 1                                                  
            IF ( IR.EQ. 1) THEN                                          
               INDX(1) = INDXT                                          
               RETURN                                                   
            ENDIF 
           ELSE ! IF (INDXT.GT.0)
c            print *,'Proceed to next iteration gracefully'
            RETURN        
           ENDIF! IF (INDXT.GT.0)           
       ENDIF                                                            
                                                                        
       I = L                                                            
       J = L*2                                                          
                                                                        
30     CONTINUE                                                         
           IF ( J.LE.IR) THEN                                           
               IF (J.LT.IR.AND.ARRIN(INDX(J)).LT.ARRIN(INDX(J+1))) THEN 
                       J = J +1                                         
               ENDIF                                                    
               IF ( Q.LT.ARRIN(INDX(J)) ) THEN                          
                   INDX(I) = INDX(J)                                    
                   I = J                                                
                   J = J + I                                            
               ELSE                                                     
                   J = IR + 1                                           
               ENDIF                                                    
           ENDIF                                                        
       IF ( J.LE.IR) GOTO 30                                            
       INDX(I) = INDXT                                                  
       GOTO 33
       RETURN
       END

      SUBROUTINE TWINWIND_HIS_CHECK
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: TWINWIND_HIS_CHECK
C   PRGMMR: LILLY            ORG: NP12        DATE: 2004-04-19
C
C ABSTRACT:  CHECKING THE STATUS OF THE PREVIOUS (-06 HR) UPPERAIR WIND DATA.
C
C PROGRAM HISTORY LOG:
C
C 1999-09-15 BRADLEY BALLISH -- ORIGINAL AUTHOR
C
C USAGE:
C   INPUT FILES:
C     UNIT 24  - FILE CONTAINING 36 DAYS OF PREVIOUS UPPERAIR WIND DATA FOR PART TTAA
C     UNIT 25  - FILE CONTAINING 36 DAYS OF PREVIOUS UPPERAIR WIND DATA FOR PART TTBB
C     UNIT 26  - FILE CONTAINING 36 DAYS OF PREVIOUS UPPERAIR WIND DATA FOR PART TTCC
C     UNIT 27  - FILE CONTAINING 36 DAYS OF PREVIOUS UPPERAIR WIND DATA FOR PART TTDD
C     UNIT 28  - FILE CONTAINING 36 DAYS OF PREVIOUS UPPERAIR WIND DATA FOR PART PPBB
C     UNIT 29  - FILE CONTAINING 36 DAYS OF PREVIOUS UPPERAIR WIND DATA FOR PART PPDD
C
C   OUTPUT FILES:
C
C   SUBPROGRAMS CALLED:
C     UNIQUE
C     LIBRARY
C
C   EXIT STATES:
C     COND =   0 - PREVIOUS UPPERAIR WIND DATA IS NON-CORRUPT
C     COND =  33 - FIRST LINE OF PREVIOUS UPPERAIR WIND DATA IS MISSING OR
C                - PREVIOUS UPPERAIR WIND DATA IS CORRUPT
C
C REMARKS: INPUT DATA FILES (UNITS 24-29) ARE PRETESTED BY SCRIPT TO BE NON-CORRUPT.
C          INPUT WINDS ARE BINARY VERSIONS OF ASCII DATA.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE : IBM-SP
C
C$$$

      CHARACTER*41 HCARDS(6,960000)
      COMMON /HISTPART/HCARDS,IIMAX(6)

      READ(24,err=910,end=910) IIIMAX
      IIMAX(1)=IIIMAX
      READ(24,err=911,end=911) (HCARDS(1,K),K=1,IIIMAX)
      READ(25,err=910,end=910) IIIMAX
      IIMAX(2)=IIIMAX
      READ(25,err=911,end=911) (HCARDS(2,K),K=1,IIIMAX)
      READ(26,err=910,end=910) IIIMAX
      IIMAX(3)=IIIMAX
      READ(26,err=911,end=911) (HCARDS(3,K),K=1,IIIMAX)
      READ(27,err=910,end=910) IIIMAX
      IIMAX(4)=IIIMAX
      READ(27,err=911,end=911) (HCARDS(4,K),K=1,IIIMAX)
      READ(28,err=910,end=910) IIIMAX
      IIMAX(5)=IIIMAX
      READ(28,err=911,end=911) (HCARDS(5,K),K=1,IIIMAX)
      READ(29,err=910,end=910) IIIMAX
      IIMAX(6)=IIIMAX
      READ(29,err=911,end=911) (HCARDS(6,K),K=1,IIIMAX)
      GO TO 999
 910  CONTINUE
      WRITE(6,*) 'First line of previous upperair wind data missing'
      CALL ERREXIT(33)
      GO TO 999
 911  CONTINUE
      WRITE(6,*) 'previous upperair wind data is corrupt'
      CALL ERREXIT(33)
 999  CONTINUE
      RETURN
      END

      SUBROUTINE TWINWIND
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: TWINWIND
C   PRGMMR: LILLY            ORG: NP12        DATE: 2004-04-15
C
C ABSTRACT: THIS SUBROUTINE COMPARES THE CURRENT WINDS WITH THE LAST 35
C           DAYS OF WINDS TO SEE IF CURRENT DATA IS REALLY OLD
C           IT USES AN INCREMENTAL SORT (INCSORT) TO MERGE ALREADY
C           SORTED OLD AND NEW DATA WHILE FINDING INDIVUAL LEVELS OF
C           WINDS FROM THE SAME ID THAT MATCH FOR OLD AND CURRENT TIMES
C           SUBROUTINE CDUPS CHECKS ALL THESE WIND MATCHES TO SEE IF
C           TWO DIFFERENT MODEL RUNS HAVE ENOUGH WIND MATCHES TO
C           QUALIFY AS A TIMETWIN

C PROGRAM HISTORY LOG:
C
C 1999-09-15 BRADLEY BALLISH -- ORIGINAL AUTHOR
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - ONE LINE OF TEXT WITH DATE INFORMATION FROM 35 DAYS AGO AND
C              - THE CURRENT DATE
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 54  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTAA 
C     UNIT 55  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTBB 
C     UNIT 56  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTCC 
C     UNIT 57  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTDD 
C     UNIT 58  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART PPBB 
C     UNIT 59  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART PPDD 
C     UNIT 74  - FILE CONTAINING DIAGNOSTIC PRINT
C     UNIT 75  - FILE CONTAINING TIME-TWIN WIND MATCHES IF FOUND
C     UNIT 76  - DEBUG DIAGNOTICS PRINTOUTS IF TURNED ON IN FORTRAN CODE
C     UNIT 77  - DEBUG DIAGNOTICS PRINTOUTS IF TURNED ON IN FORTRAN CODE INCSORT
C   SUBPROGRAMS CALLED:
C     UNIQUE:  - INCSORT CDUPS INDEX26
C     LIBRARY
C       W3LIB    - IW3JDN  W3TAGB   W3TAGE   
C       BUFRLIB  - NONE
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C
C REMARKS: PREVIOUS WIND DATA ARE PRETESTED BY TWINHIS_CHECK TO BE NON-CORRUPT
C          AND ARE IN COMMON/HISTPART/ CURRENT WINDS ARE IN COMMON/CURRPART/
C          THESE WINDS ARE BINARY VERSIONS OF ASCII DATA AND ARE SORTED.
C          OUTPUT UNIT 75 INDICATES CASES WHERE THE CURRENT DATA IS REALLY A DUPLICATE
C          OF OLD DATA
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE : IBM-SP
C
C$$$


       CHARACTER*41 CARDO(800000),CARDN(70000),CARDS(960000)
       CHARACTER*41 CARDD(90000),CARD1(90000)
       CHARACTER*41 HCARDS(6,960000),CCARDS(6,960000)
       CHARACTER*8   DATE
       CHARACTER*10  DAYL2
       CHARACTER*6   DAYL
       CHARACTER*5   IDOLD,IDMAX
       CHARACTER*4   PARTS(6)
       CHARACTER*4   PART
       COMMON /HISTPART/HCARDS,IIMAX(6)
       COMMON /CURRPART/CCARDS,JJMAX(6)
       COMMON /PMAXS/IMAX,JMAX,NP


C      DATE IS THE CURRENT DATE, WHILE DAYL IS 35 DAYS EARLIER
C      BUT WITH THE FIRST 2 CHARCTERS REMOVED
C      DAYL IS USED TO GET RID OF DATA 35 DAYS OLDER THAN TODAY
       READ(5,943) DAYL2,DATE
 943   FORMAT(A10,1X,A8)
       DAYL(1:6) = DAYL2(3:8)
       WRITE(74,944) DATE,DAYL
 944   FORMAT(' CURRENT DATE AND REMOVAL DATE ARE= ',A8,' ',A6)
       PARTS(1)='TTAA'
       PARTS(2)='TTBB'
       PARTS(3)='TTCC'
       PARTS(4)='TTDD'
       PARTS(5)='PPBB'
       PARTS(6)='PPDD'

C loop over 24-29 covers input from 6 upper air types

       DO 10 INN=24,29
       NP=INN-23
       PART=PARTS(NP)
c      WRITE(75,144) PARTS(NP)
c944   FORMAT(' DAYL= ',A6)
 144   FORMAT(' ',A4,' TIME TWINS FOLLOW ')
       JNN=74
C      THE PRESORTED OLD AND NEW WIND DATA IS PASSED TO INCSORT.
C      WITH OUTPUT ARRAY CARDS HOLDING NSORT LINES OF SORTED MERGED DATA WITH
C      CALM WINDS REMOVED AND DATA OLDER THAN 35 DAYS AGO REMOVED
C      ARRAY CARDD HAS NDUPS LINES OF WIND MATCHES THAT MAY BE DUE
C      TO TIMETWINS BUT ARE MOSTLY MATCHES BY LUCK 
       CALL INCSORT(CARDO,CARDN,CARDS,CARDD,INN,NDUPS,NSORT,DAYL)
C      CARDD HAS PAIRS OF LINES WITH MATCHING ID PRESSURE AND WIND
C      DIRECTION AND SPEED
       WRITE(74,946)
 946   FORMAT(' NDUPS is NUMBER OF WIND TWINS, NSORT is the NUMBER 
     &  of SORTED CARDS FOR OUTPUT')
       WRITE(74,947) NDUPS,NSORT
 947   FORMAT(' NDUPS NSORT= ',2I8)
 
c      DO 35 KB=1,NDUPS
c35    WRITE(74,948) CARDD(KB)
c948   FORMAT(A41)
 
       IDOLD='     '
       INUM=0
 
       DO 20 I=1,NDUPS
         IF(CARDD(I)(1:5) .NE. IDOLD) THEN
          IF(INUM .GE. 6) THEN
C         check number of new cards in twins   need 3 do run
 
 105        FORMAT(A)
 
c      WRITE(76,813)
 813   FORMAT('CARD1s for CDUP follow ')

c      DO 36 KB=1,INUM
c36    WRITE(76,948) CARD1(KB)
 
            CALL CDUPS(CARD1,INUM,PART,DATE)
          ENDIF
 
       INUM=0
       IDOLD=CARDD(I)(1:5)
       ENDIF
 
       IF(CARDD(I)(1:5) .EQ. IDOLD) THEN
       INUM=INUM+1
       CARD1(INUM)=CARDD(I)
       ENDIF
 
   20  CONTINUE
 
       IF(INUM .GE. 3) CALL CDUPS(CARD1,INUM,PART,DATE)
   10  CONTINUE
 
       RETURN
       END

      SUBROUTINE CDUPS(CARDS,KNUM,PART,DATE)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    CDUPS      DESCRIPTIVE TITLE NOT PAST COL 70
C   PRGMMR: STEVE LILLY           ORG: W/NP12   DATE: 2004-04-15
C
C ABSTRACT: THIS SUBROUTINE TAKES ALL THE MATCHING WINDS
C           FOR ONE ID TO SEE IF TWO DIFFERENT RUNS CONTAIN 
C           ENOUGH MATCHES TO BE CALLED A TIMETWIN
C           SUBROUTINE INDEX26 SORTS THE DATA FOR DIFFERENT PAIRS
C           OF RUNS
C
C PROGRAM HISTORY LOG:
C 1999-09-15  BRAD BALLISH DEVELOPED ORIGINAL CODE
C
C USAGE:    CALL CDUPS(CARD1,INUM,PART,DATE)
C   INPUT ARGUMENT LIST:
C     CARDS - HAS INUM LINES OF DATA FOR MATCHING WIND PAIRS ALL FOR ONE ID
C     INUM - HAS THE NUMBER OF LINES TO USE IN ARRAY CARD1
C     PART - CHARACTER*4 GIVES THE TYPE OF DATA (TTAA PPBB ETC.)
C     DATE - CHARACTER*10 NEEDED TO GET THE CENTURY
C
C   OUTPUT ARGUMENT LIST:      NONE
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C     FT75 TIME-TWIN INFORMATION IF ANY FOUND
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  IBM
C
C$$$

      CHARACTER*41 CARDS(1),DUPA(69000),DUPB(69000)
      CHARACTER*41 DUP1(69000),DUP2(69000)
      CHARACTER*26 CDAT(69000)
      CHARACTER*20 SDAT(69000)
      CHARACTER*20 JDOLD
      CHARACTER*19 WDOLD
      CHARACTER*8  DATE 
      CHARACTER*4  PART
      DIMENSION INDR(69000)
      II=0
      IMSTOR=0
      ISTOR=0
 500  II=II+1
      ISTART=II
      IFIN=ISTART
      WDOLD=CARDS(II)(1:19)

 600  IF(CARDS(IFIN+1)(1:19) .EQ. WDOLD(1:19)) THEN
      IFIN=IFIN+1
      GO TO 600
      ENDIF

      INUM = IFIN - ISTART + 1
      IFIN1=IFIN-1

      DO 15 KO=ISTART,IFIN1,2
      KN=KO+1
  745 FORMAT(I6)
  746 FORMAT(I2)
      ISTOR=ISTOR+1
      CDAT(ISTOR)(1:10)=CARDS(KO)(29:38)
      CDAT(ISTOR)(11:20)=CARDS(KN)(29:38)
      CDAT(ISTOR)(21:26)=CARDS(KO)(7:12)
      DUPA(ISTOR)(1:41)=CARDS(KO)(1:41)
      DUPB(ISTOR)(1:41)=CARDS(KN)(1:41)
  15  CONTINUE

      II=IFIN
      IF(II .LT. KNUM) GO TO 500
      IF(ISTOR .GE. IMSTOR) IMSTOR=ISTOR
      CALL INDEX26(ISTOR,CDAT,INDR)

c     WRITE(77,985)
c985  FORMAT('CDUP TESTS FOLLOW')

      DO 34 I=1,ISTOR
      SDAT(I)=CDAT(INDR(I))
      DUP1(I)=DUPA(INDR(I))
      DUP2(I)=DUPB(INDR(I))
c     WRITE(77,986) SDAT(I)
c     WRITE(77,987) DUP1(I)
c     WRITE(77,987) DUP2(I)
 986  FORMAT(A20)
 987  FORMAT(A41)
 34   CONTINUE

      JJ=0
      JSTOR=0
 550  JJ=JJ+1
      JSTART=JJ
      JFIN=JSTART
      JDOLD=SDAT(JJ)(1:20)
c650  IF(SDAT(JFIN+1)(1:20) .EQ. JDOLD(1:20)) THEN
 650  IF(SDAT(JFIN+1)(1:20) .EQ. JDOLD .AND. JFIN+1 .LE. ISTOR) THEN
      JFIN=JFIN+1
      GO TO 650
      ENDIF
      JNUM = JFIN - JSTART + 1
      NI=0
      NJ=0
      IF( JNUM .GE. 3) THEN
      READ(DUP1(JSTART)(40:41),746) NI
      READ(DUP2(JSTART)(40:41),746) NJ
      NN=NI
      IF(NJ .LT. NN) NN=NJ
      ENDIF
        IF(JNUM .GT. NN/2 .AND. JNUM .GE. 3) THEN
      READ(DUP1(JSTART)(29:30),772) IYR
      READ(DUP1(JSTART)(31:32),772) MONTH
      READ(DUP1(JSTART)(33:34),772) IDAY 
      READ(DUP1(JSTART)(35:36),772) IRUN
      READ(DUP1(JSTART)(37:38),772) ICHR
      READ(DATE(1:2),772) IYY
      IYEAR=100*IYY+IYR
      IJULS=IW3JDN(IYEAR,MONTH,IDAY)
      ITIME=24*IJULS+ICHR+IRUN
 703  FORMAT(' ITIME,ICDATE,ICHR,IRUN= ',I8,' ',I6,' ',I2,' ',I2)
 772  FORMAT(I2)
      IHR1=IRUN+ICHR-3
      IF(IHR1 .LT. 0) IHR1=24+IHR1
      READ(DUP2(JSTART)(29:30),772) IYR
      READ(DUP2(JSTART)(31:32),772) MONTH
      READ(DUP2(JSTART)(33:34),772) IDAY 
      READ(DUP2(JSTART)(35:36),772) JRUN
      READ(DUP2(JSTART)(37:38),772) JCHR
c     IYEAR=1900+IYR
      IYEAR=100*IYY+IYR
      IJULS=IW3JDN(IYEAR,MONTH,IDAY)
      JTIME=24*IJULS+JCHR+JRUN
      IDDT=IABS(JTIME-ITIME)
         IF(IDDT .GE. 3) THEN
      IHR2=JRUN+JCHR-3
      IF(IHR2 .LT. 0) IHR2=24+IHR2
      WRITE(75,871) 
 871  FORMAT(' ')
      WRITE(75,771) DUP2(JSTART)(1:5),DUP2(JSTART)(35:36),
     *DUP2(JSTART)(29:34),PART,IHR2
 771  FORMAT(' Station ',A5,' For ',A2,'Z',' ',A6,' Type ',A4,
     * ' Time ',I2,'Z')
      WRITE(75,872) IDDT
 872  FORMAT(' Is a',I4,' Hour Time Twin with')
      WRITE(75,771) DUP1(JSTART)(1:5),DUP1(JSTART)(35:36),
     *DUP1(JSTART)(29:34),PART,IHR1
 671  FORMAT(' TWINS= ',A6,' RUN ',A2,'Z',' TIME ',I2,'Z','    ',
     * A6,' RUN ',A2,'Z',' TIME ',I2,'Z',' Time Dif= ',I4,'Hours')
        WRITE(75,304)  
 304  FORMAT(' Wind Matches Follow ')
        WRITE(75,305)  
 305  FORMAT(' ID    Press Dir Sp  Dif QM Run Date   No')

        DO 76 KR=JSTART,JFIN
        WRITE(75,105)  DUP2(KR)
        WRITE(75,105)  DUP1(KR)
  76    CONTINUE

        ENDIF

      JJ=JFIN
      ENDIF    
c     IF(JJ .LT. ISTOR-2) GO TO 550 is key (-2)
      IF(JJ .LT. ISTOR -2) GO TO 550
 105  FORMAT(A)
      RETURN
      END

       SUBROUTINE INDEX26 (N,ARRIN,INDX)  
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    INDEX26      DO HEAP SORT FOR ARRAY AARIN
C   PRGMMR: STEVE LILLY        ORG: W/NP12    DATE: 2004-04-15
C
C ABSTRACT: DOES HEAP SORT ON ARRAY AARIN WITH INDEX OF SORT
C           IN ARRAY INDX
C
C PROGRAM HISTORY LOG:
C   99-09-15 ORIGINAL AUTHOR BRAD BALLISH 
C
C USAGE:    CALL INDEX26(ISTOR,CDAT,INDR)
C   INPUT ARGUMENT LIST:
C     ISTOR  THE NUMBER OF ENTRIES IN ARRAY CDAT
C     CDAT   A CHARACTER*41 ARRAY HOLDING 
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     INDX   A INTEGER ARRAY GIVING THE SORT RESULTS 
C
C
C ATTRIBUTES:
C   LANGUAGE: f90
C   MACHINE:  IBM
C
C$$$
C
C                                                                       
C      INDEXS AN ARRAY ARRIN(1...N)                                     
C      INPUT:           N SPAN OF SORT                                  
C                                      ARRIN - ARRAY TO BE SORTED - NOT 
C      OUTPUT: INDX - ARRAY OF INDEXES SUCH THAT ARRAY(INDX(I)) IS      
C                                      IN ASCENDING ORDER FOR J = 1,... 
C                                                                       
       INTEGER INDX(*)                                                  
       CHARACTER*26 ARRIN(*),Q                                           
                                                                        
       DO 10 J = 1,N                                                    
           INDX(J) = J                                                  
10     CONTINUE                                                         
                                                                        
       L = N/2 + 1                                                      
                                                                        
       IR = N                                                           
33     CONTINUE                                                         
       IF (L.GT.1) THEN                                                 
           L = L - 1                                                    
           INDXT=INDX(L)                                                
           Q = ARRIN(INDXT)                                             
       ELSE                                                             
           INDXT = INDX(IR)                                             
           Q = ARRIN(INDXT)                                             
           INDX(IR) = INDX(1)                                           
           IR = IR - 1                                                  
           IF ( IR.EQ. 1) THEN                                          
               INDX(1) = INDXT                                          
               RETURN                                                   
           ENDIF                                                        
       ENDIF                                                            
                                                                        
       I = L                                                            
       J = L*2                                                          
                                                                        
30     CONTINUE                                                         
           IF ( J.LE.IR) THEN                                           
               IF (J.LT.IR.AND.ARRIN(INDX(J)).LT.ARRIN(INDX(J+1))) THEN 
                       J = J +1                                         
               ENDIF                                                    
               IF ( Q.LT.ARRIN(INDX(J)) ) THEN                          
                   INDX(I) = INDX(J)                                    
                   I = J                                                
                   J = J + I                                            
               ELSE                                                     
                   J = IR + 1                                           
               ENDIF                                                    
           ENDIF                                                        
       IF ( J.LE.IR) GOTO 30                                            
       INDX(I) = INDXT                                                  
       GOTO 33                                                          
       END

       SUBROUTINE INCSORT(CARDO,CARDN,CARDS,CARDD,INN,NDUPS,NSORT,DAYL)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    INCSORT IS PASSED BOTH THE OLD AND NEW DATA CARDS ON WINDS
C   PRGMMR: STEVE LILLY        ORG: W/NP12    DATE: 2004-04-15
C
C ABSTRACT: USES OLD AND NEW PRESORTED WIND DATA
C           DOES INCREMENTAL SORT ON MERGE OF OLD AND NEW
C           ALSO FINDS CURRENT WINDS THAT MATCH OLD FOR ONE PRESSURE LEVEL
C           THESE MATCHING WINDS ARE FURTHER TESTED IN CDUPS TO
C           FIND TIME-TWINS (CURRENT SOUNDING DATA IS REALLY A DUPLICATE OF OLD)
C
C PROGRAM HISTORY LOG:
C   99-09-15 ORIGINAL AUTHOR BRAD BALLISH 
C
C USAGE:       CALL INCSORT(CARDO,CARDN,CARDS,CARDD,INN,NDUPS,NSORT,DAYL)
C   INPUT ARGUMENT LIST:
C     INN       INN=24,29 FOR 6 UPPER AIR DATA TYPES
C     DAYL      CHARACTER*6  IS A LIMIT USED TO REMOVE OLD DATA
C
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     CARDS   HAS NSORT LINES OF SORTED AND MERGED (OLD AND NEW) WIND DATA
C     CARDO   HAS THE OLD SORTED WIND DATA READ FROM INPUT
C     CARDN   HAS THE NEW SORTED WIND DATA READ FROM INPUT
C     CARDD   HAS NDUPS LINES OF WIND MATCHES BETWEEN OLD AND NEW
C     NDUPS   IS THE NUMBER OF WIND MATCHES BETWEEN OLD AND NEW
C
C   OUTPUT FILES:  (DELETE IF NO OUTPUT FILES IN SUBPROGRAM)
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 54  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTAA
C     UNIT 55  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTBB
C     UNIT 56  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTCC
C     UNIT 57  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART TTDD
C     UNIT 58  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART PPBB
C     UNIT 59  - FILE CONTAINING LATEST 36 DAYS OF UPPERAIR WIND DATA FOR PART PPDD
C     UNIT 74  - FILE CONTAINING DIAGNOSTIC PRINT
C     UNIT 75  - FILE CONTAINING TIME-TWIN WIND MATCHES IF FOUND
C     UNIT 77  - DEBUG DIAGNOTICS PRINTOUTS IF TURNED ON IN FORTRAN CODE INCSORT

C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION

C ATTRIBUTES:
C   LANGUAGE: f90
C   MACHINE:  IBM
C
C$$$
C

       CHARACTER*41 CARDO(800000)
       CHARACTER*41 CARDN(70000)
       CHARACTER*41 CARDS(960000),CARDT(960000)
       CHARACTER*41 CARDD(90000)
       CHARACTER*41 CARDX,CARDA
       CHARACTER*41 HCARDS(6,960000),CCARDS(6,960000)
       COMMON /HISTPART/HCARDS,IIMAX(6)
       COMMON /CURRPART/CCARDS,JJMAX(6)
       COMMON /PMAXS/IMAX,JMAX,NP

       CHARACTER*6 DAYL
       JNN=INN+10
       KNN=INN+20
       LNN=INN+30
       CARDO='123456789a123456789a123456789a123456789a1'
       CARDN='123456789a123456789a123456789a123456789a1'
  105  FORMAT(A)
 797   CONTINUE
C
       IMAX=IIMAX(NP)
       JMAX=JJMAX(NP)
       DO 7 IX=1,IMAX
         CARDO(IX)=HCARDS(NP,IX)
    7  CONTINUE
       DO 8 JX=1,JMAX
         CARDN(JX)=CCARDS(NP,JX)
    8  CONTINUE
c  start with incremental sort and write
        I=1
        J=1
        K=0
        N=0
   77   CONTINUE

        IF(CARDO(I) .LT. CARDN(J)) THEN

          IF(CARDO(I)(14:19) .NE. '  0  0') THEN
          K=K+1
          CARDT(K)=CARDO(I)
          ENDIF

        I=I+1

        ELSEIF(CARDO(I) .GE. CARDN(J)) THEN

          IF(CARDN(J)(14:19) .NE. '  0  0') THEN
          K=K+1
          CARDT(K)=CARDN(J)
          ENDIF

        J=J+1
        ENDIF
        IF(I .LE. IMAX .AND. J .LE. JMAX) GO TO 77
 
        IF(I .GT. IMAX ) THEN

        DO 42 JJ=J,JMAX
          IF(CARDN(JJ)(14:19) .NE. '  0  0') THEN
          K=K+1
          CARDT(K)=CARDN(JJ)
          ENDIF
  42    CONTINUE

        ENDIF

        IF(J .GT. JMAX ) THEN

        DO 43 II=I,IMAX
          IF(CARDO(II)(14:19) .NE. '  0  0') THEN
          K=K+1
          CARDT(K)=CARDO(II)
          ENDIF
  43    CONTINUE

        ENDIF
      
       CARDS(1)=CARDT(1)
       KS=1
 
       DO 44 KT=2,K
 
       IF(CARDT(KT)(1:38) .NE. CARDS(KS)(1:38)) THEN
 
       IF(CARDT(KT)(29:34) .GE. DAYL) THEN
       KS=KS+1
       CARDS(KS)=CARDT(KT)
       ENDIF
 
       ENDIF
 
  44   CONTINUE
  
       NSORT=KS
       WRITE(LNN) KS
 713   FORMAT(I8)
       WRITE(LNN) (CARDS(JJ),JJ=1,KS)
c  done with incremental sort and write
 
c  Start sort on 1:19 to find card twins only
        I=1
        J=1
        N=0
   88   CONTINUE

        IF(CARDO(I)(1:19) .LT. CARDN(J)(1:19)) THEN
        I=I+1

        ELSEIF(CARDO(I)(1:19) .EQ. CARDN(J)(1:19)) THEN
         IFIN=I

 600     IF(CARDO(IFIN+1)(1:19) .EQ. CARDO(I)(1:19)) THEN
         IF(IFIN .LT. IMAX) THEN
         IFIN=IFIN+1
         GO TO 600
         ENDIF

         ENDIF

         JFIN=J

 605     IF(CARDN(JFIN+1)(1:19) .EQ. CARDN(J)(1:19)) THEN

         IF(JFIN .LT. JMAX) THEN
         JFIN=JFIN+1
         GO TO 605
         ENDIF

         ENDIF

        DO 611 JJ=J,JFIN

        DO 612 II=I,IFIN
        N=N+1
        CARDD(N)=CARDO(II)
        N=N+1
        CARDD(N)=CARDN(JJ)
 612    CONTINUE

 611    CONTINUE

        I=IFIN+1
        J=JFIN+1

        ELSEIF(CARDO(I)(1:19) .GT. CARDN(J)(1:19)) THEN
        J=J+1
        ENDIF 

        IF(I .LE. IMAX .AND. J .LE. JMAX) GO TO 88
       NDUPS=N
 
       RETURN
       END

C***********************************************************************
C***********************************************************************
      SUBROUTINE GBLEVN02(IUNITP,IUNITS,NEWTYP)
                                         ! FORMERLY SUBROUTINE FILTAN

      DIMENSION    NFLGRT(100:299,12),OEMIN(2:6)
      CHARACTER*8  STNID
      CHARACTER*40 PEVN,QEVN,TEVN,WEVN,PWVN,PW1VN,PW2VN,PW3VN,PW4VN
      REAL(8)      PEV(4,255),QEV(4,255),TEV(4,255),WEV(5,255),
     $             PWV(4,255),PW1V(4,255),PW2V(4,255),PW3V(4,255),
     $             PW4V(4,255),OBS,QMS,BAK,SID,BMISS
      LOGICAL      FCST,REJP_PS,REJPS,REJT,REJQ,REJW,REJPW,REJPW1,
     $             REJPW2,REJPW3,REJPW4,SATMQC,SATEMP,SOLN60,SOLS60,
     $             MOERR_P,MOERR_T,ADPUPA_VIRT,DOBERR,DOFCST,SOME_FCST

      COMMON /GBEVAA/ SID,OBS(15,255),QMS(12,255),BAK(12,255),XOB,
     $ YOB,DHR,TYP,NLEV
      COMMON /GBEVBB/ IPVCD,IVTCD
      COMMON /GBEVCC/ DOVTMP,DOFCST,SOME_FCST,DOBERR,FCST,VIRT,
     $ QTOP_REJ,SATMQC,ADPUPA_VIRT
      COMMON /GBEVEE/PSG01,ZSG01,TG01(500),UG01(500),VG01(500),
     x     QG01(500),zint(500),pint(500),pintlog(500),plev(500),
     x     plevlog(500)

      EQUIVALENCE (SID,STNID)

      DATA PEVN  /'POB  PQM  PPC  PRC      '/
      DATA QEVN  /'QOB  QQM  QPC  QRC      '/
      DATA TEVN  /'TOB  TQM  TPC  TRC      '/
      DATA WEVN  /'UOB  VOB  WQM  WPC  WRC '/
      DATA PWVN  /'PWO  PWQ  PWP  PWR      '/
      DATA PW1VN /'PW1O PW1Q PW1P PW1R     '/
      DATA PW2VN /'PW2O PW2Q PW2P PW2R     '/
      DATA PW3VN /'PW3O PW3Q PW3P PW3R     '/
      DATA PW4VN /'PW4O PW4Q PW4P PW4R     '/

      DATA BMISS /10E10/,NFLGRT/2400*0/

      DATA OEMIN /0.5,0.1,1.0,0.5,1.0/

      NI  = MOD((NINT(TYP)/10),10)

      IF(NEWTYP.EQ.1)  NFLGRT = 0

C  LOGICAL SWITCHES FOR OBSERVATION LOCATION FILTERING
C  ---------------------------------------------------

      SATEMP = ((TYP.GE.160.AND.TYP.LE.179).AND.SATMQC)
      SOLN60 = ((TYP.GE.160.AND.TYP.LE.163).AND.YOB.GE.-60.AND.SATMQC)
      SOLS60 = ((TYP.EQ.160.OR.TYP.EQ.162.OR.TYP.EQ.163).AND.YOB.LT.-60
     $ .AND.SATMQC)

C  CLEAR THE EVENT ARRAYS
C  ----------------------

      PEV  = BMISS
      QEV  = BMISS
      TEV  = BMISS
      WEV  = BMISS
      PWV  = BMISS
      PW1V = BMISS
      PW2V = BMISS
      PW3V = BMISS
      PW4V = BMISS

      MAXPEV  = 0
      MAXQEV  = 0
      MAXTEV  = 0
      MAXWEV  = 0
      MAXPWV  = 0
      MAXPW1V = 0
      MAXPW2V = 0
      MAXPW3V = 0
      MAXPW4V = 0

C  LOOP OVER LEVELS APPLYING UNDERGROUND FILTERING AND SPECIAL RULES
C  -----------------------------------------------------------------

      IF(NLEV.GT.0)  THEN
      DO L=1,NLEV

         POB  = OBS( 1,L)
         QOB  = OBS( 2,L)
         TOB  = OBS( 3,L)
         UOB  = OBS( 5,L)
         VOB  = OBS( 6,L)
         PWO  = OBS( 7,L)
         PW1O = OBS( 8,L)
         PW2O = OBS( 9,L)
         PW3O = OBS(10,L)
         PW4O = OBS(11,L)
         CAT  = OBS(12,L)
         PRSS = OBS(13,L)

         PQM  = QMS( 1,L)
         QQM  = QMS( 2,L)
         TQM  = QMS( 3,L)
         ZQM  = QMS( 4,L)
         WQM  = QMS( 5,L)
         PWQ  = QMS( 6,L)
         PW1Q = QMS( 7,L)
         PW2Q = QMS( 8,L)
         PW3Q = QMS( 9,L)
         PW4Q = QMS(10,L)

         REJP_PS = .FALSE.
         MOERR_P = .FALSE.
         MOERR_T = .FALSE.
         RCD = 99999

C  -------------------------------------------------------------------
C  RULES FOR PRESSURE (ON ANY LEVEL) -- ALL DATA ON LEVEL REJECTED IF:
C    - PRESSURE MORE THAN 100 MB BELOW MODEL (GUESS) SURFACE PRESSURE
C       (AND SWITCH FCST=TRUE) -- "PREVENT" PGM REASON CODE 1
C    - PRESSURE IS ZERO OR IS NEGATIVE -- "PREVENT" PGM REASON CODE 2
C  REJECTION MEANS Q.M. SET TO 8
C  -------------------------------------------------------------------

         IF(POB.LT.BMISS)  THEN
            IF(.NOT.FCST)  PSG01 = POB
            IF(POB-PSG01.GE.100. .OR. POB.LE.0.) THEN
               IF(POB.LE.0.) THEN
                  IF(NI.EQ.8)  THEN
                     WRITE(IUNITS,302) STNID,NINT(TYP),YOB,XOB,POB
  302 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, FAILS SANITY ',
     $'CHECK')
                  ELSE
                     WRITE(IUNITS,101) STNID,NINT(TYP),YOB,XOB,POB
  101 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $'E, REJECT ALL DATA ON LVL - POB=',F6.1,' MB, FAILS SANITY CHECK')
                  ENDIF
                  RCD = 2
               ELSE
                  IF(NI.EQ.8)  THEN
                     WRITE(IUNITS,303) STNID,NINT(TYP),YOB,XOB,POB,PSG01
  303 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, > 100 MB ',
     $ 'BELOW GES PSFC(=',F6.1,'MB)')
                  ELSE
                     WRITE(IUNITS,102) STNID,NINT(TYP),YOB,XOB,POB,PSG01
  102 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON LVL - POB=',F6.1,' MB, > 100 MB BELOW ',
     $ 'GES PSFC(=',F6.1,' MB)')
                  ENDIF
                  RCD = 1
               ENDIF
               REJ = 8
               REJP_PS = .TRUE.
               PEV(1,L) = POB
               PEV(2,L) = REJ
               PEV(3,L) = IPVCD
               PEV(4,L) = RCD
               MAXPEV = L
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR SURFACE PRESSURE -- ALL DATA ON SURFACE LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - PRESSURE IS MORE THAN 100 MB ABOVE OR BELOW MODEL (GUESS)
C       SURFACE PRESSURE (AND SWITCH FCST=TRUE) -- 
C       "PREVENT" PGM REASON CODE 4
C    - PRESSURE IS REPORTED ABOVE 450 MB OR BELOW 1100 MB -- "PREVENT"
C       PGM REASON CODE 2
C    - PRESSURE VIOLATES RULES FOR PRESSURE ON ANY LEVEL (SEE ABOVE)
C  REJECTION FOR FIRST RULE MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(POB.LT.BMISS .AND. CAT.EQ.0) THEN
            IF(.NOT.FCST)  PSG01 = POB
            REJPS = OEFG01(POB,TYP,5,OEMIN(5)).GE.BMISS   .OR.
     $              ABS(POB-PSG01).GE.100.                .OR.
     $              POB.LE.450.                           .OR.
     $              POB.GE.1100.
            IF(REJPS.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS)  THEN
                  IF(ABS(POB-PSG01).GE.100.)  THEN
                     WRITE(IUNITS,104) STNID,NINT(TYP),YOB,XOB,POB,PSG01
  104 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, > 100 MB ',
     $ 'ABOVE GES PSFC(=',F6.1,'MB)')
                     RCD = 4
                  ELSE IF(POB.LE.450..OR.POB.GE.1100.)  THEN
                     WRITE(IUNITS,105) STNID,NINT(TYP),YOB,XOB,POB
  105 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,' MB, FAILS SANITY ',
     $ 'CHECK')
                     RCD = 2
                  ELSE
                     IF(NFLGRT(NINT(TYP),1).EQ.0)  THEN
                        WRITE(IUNITS,201) NINT(TYP)
  201 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'ALL DATA ON SURFACE LEVEL DUE TO MISSING SFC-P OBS ERROR'/)
                        NFLGRT(NINT(TYP),1) = 1
                     ENDIF
CDAK CDAK CDAK CDAK  WRITE(IUNITS,103) STNID,NINT(TYP),YOB,XOB,POB
CD103 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
CDAK $ 'E, REJECT ALL DATA ON SFC LVL - POB=',F6.1,'MB, MISSING OBS.',
CDAK $ ' ERROR')
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               REJP_PS = .TRUE.
               IF(RCD.EQ.3)  MOERR_P = .TRUE.
               IF(REJ.EQ.9.AND.(PQM.GT.3.AND.PQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1401) STNID,NINT(TYP),YOB,XOB,PQM
 1401 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PQM =',F4.0,' -- DO NOT APPLY PSFC QM=9 EVENT')
               ELSE
                  PEV(1,L) = POB
                  PEV(2,L) = REJ
                  PEV(3,L) = IPVCD
                  PEV(4,L) = RCD
                  MAXPEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR TEMPERATURE -- TOB AND QOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND OBSERVATION ERROR FOR SFC PRESSURE IS
C       MISSING (AND SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - REPORT IS TYPE 160-163 (LAND TOVS/RTOVS/ATOVS TEMPERATURE
C       SOUNDINGS, ALL PATHS), AND IS AT OR NORTH OF 60 DEGREES SOUTH
C       LATITUDE, AND PRESSURE ON LEVEL IS AT OR BELOW 100 MB (AND
C       SWITCH SATMQC=TRUE)  -- "PREVENT" PGM REASON CODE 6
C    - REPORT IS TYPE 160,162,163 (LAND TOVS/RTOVS/ATOVS TEMPERATURE
C       SOUNDINGS, ALL PATHS BUT CLEAR), AND IS SOUTH OF 60 DEGREES
C       SOUTH LATITUDE, AND PRESSURE ON LEVEL IS BELOW 100 MB (AND
C       SWITCH SATMQC=TRUE) -- "PREVENT" PGM REASON CODE 6
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (EXCEPT FOR MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE
C       2 ABOVE) (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR FIRST TWO RULES MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(TOB.LT.BMISS) THEN
            REJT = OEFG01(POB,TYP,2,OEMIN(2)).GE.BMISS  .OR. 
     $             (SOLN60.AND.NINT(POB*10.).GE.1000)   .OR.
     $             (SOLS60.AND.NINT(POB*10.).GT.1000)
            IF(REJT.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS)  THEN
                  IF(SOLN60.AND.NINT(POB*10.).GE.1000)  THEN
                     IF(NFLGRT(NINT(TYP),6).EQ.0)  THEN
                        WRITE(IUNITS,7304) NINT(TYP)
 7304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $'TOB/QOB AT AND BELOW 100 MB IF REPORT IS NORTH OF 60S LATITUDE'/)
                        NFLGRT(NINT(TYP),6) = 1
                     ENDIF
                     RCD = 6
                  ELSE  IF(SOLS60.AND.NINT(POB*10.).GT.1000)  THEN
                     IF(NFLGRT(NINT(TYP),7).EQ.0)  THEN
                        WRITE(IUNITS,7305) NINT(TYP)
 7305 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB BELOW 100 MB IF REPORT IS SOUTH OF 60S LATITUDE'/)
                        NFLGRT(NINT(TYP),7) = 1
                     ENDIF
                     RCD = 6
                  ELSE
                     IF(NFLGRT(NINT(TYP),2).EQ.0)  THEN
                        IF(NI.EQ.8)  THEN
                           WRITE(IUNITS,304) NINT(TYP)
  304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                        ELSE
                           WRITE(IUNITS,202) NINT(TYP)
  202 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'TOB/QOB ON AT LEAST ONE LVL (IF AVAILABLE ON THAT LVL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                        ENDIF
                        NFLGRT(NINT(TYP),2) = 1
cdak cdak cdak cdak cdakWRITE(IUNITS,106) STNID,NINT(TYP),YOB,XOB,TOB
cd106 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $ 'E, REJECT TOB/QOB ON LVL - TOB=',F5.1,'C, MISSING OBS. ERROR')
                     ENDIF
                     RCD = 3
                     REJ = 9
                  ENDIF
               ELSE
                  IF(MOERR_P)  THEN
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               IF(RCD.EQ.3)  MOERR_T = .TRUE.
               IF(REJ.EQ.9.AND.(TQM.GT.3.AND.TQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1402) STNID,NINT(TYP),YOB,XOB,TQM
 1402 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT TQM =',F4.0,' -- DO NOT APPLY TEMP QM=9 EVENT')
               ELSE
                  TEV(1,L) = TOB
                  TEV(2,L) = REJ
                  TEV(3,L) = IPVCD
                  TEV(4,L) = RCD
                  MAXTEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR SPECIFIC HUMIDITY -- QOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - PRESSURE ON LEVEL IS ABOVE "QTOP_REJ" MB {WHERE QTOP_REJ IS
C       READ IN FROM NAMELIST "PREVDATA" (SEE DOCBLOCK)} -- "PREVENT"
C       PGM REASON CODE 5
C    - OBSERVATION ERROR FOR TEMPERATURE ON LEVEL IS MISSING (AND
C       SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND OBSERVATION ERROR FOR SFC PRESSURE IS
C       MISSING (AND SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - TEMPERATURE ON LEVEL IS MISSING OR IS LESS THAN -150 DEG. C --
C       "PREVENT" PGM REASON CODE 2
C    - SPECIFIC HUMIDITY IS ZERO OR IS NEGATIVE -- "PREVENT" PGM REASON
C       CODE 2
C    - REPORT IS TYPE 160-179 (SATELLITE TEMPERATURE SOUNDINGS, ALL
C       TYPES, ALL PATHS, LAND AND SEA), ALL PRESSURE LEVELS (AND
C       SWITCH SATMQC=TRUE) -- "PREVENT" PGM REASON CODE 7
C    - TEMPERATURE ON LEVEL VIOLATES RULES FOR TEMPERATURE (EXCEPT FOR
C       MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE 2 ABOVE)
C       (SEE ABOVE)
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (EXCEPT FOR MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE
C       4 ABOVE) (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR FIRST FOUR RULES MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(QOB.LT.BMISS) THEN
            REJQ = OEFG01(POB,TYP,3,OEMIN(3)).GE.BMISS        .OR.
     $             TOB.GE.BMISS                               .OR.
     $             TOB.LE.-150.                               .OR.
     $             NINT(POB * 10.).LT.NINT(QTOP_REJ * 10.)    .OR.
     $             QOB.LE.0.                                  .OR.
     $             SATEMP                                     .OR.
     $             REJT
            IF(REJQ.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS.AND..NOT.REJT)  THEN
                  IF(SATEMP)  THEN
                     IF(NFLGRT(NINT(TYP),8).EQ.0)  THEN
                        WRITE(IUNITS,7306) NINT(TYP)
 7306 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON ALL LEVELS'/)
                        NFLGRT(NINT(TYP),8) = 1
                     ENDIF
                     RCD = 7
                  ELSE IF(QOB.LE.0..OR.TOB.GE.BMISS.OR.TOB.LE.-150.)THEN
                     WRITE(IUNITS,111) STNID,NINT(TYP),YOB,XOB,
     $                QOB/1000.,TOB
  111 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT QOB ON LVL - QOB=',F6.3,' G/KG, FAILS SANITY CHECK ',
     $ '(TOB=',F5.1,' C)')
                     RCD = 2
                  ELSE IF(OEFG01(POB,TYP,3,OEMIN(3)).GE.BMISS)  THEN
                     IF(NFLGRT(NINT(TYP),3).EQ.0)  THEN
                        IF(NI.EQ.8)  THEN
                           WRITE(IUNITS,305) NINT(TYP)
  305 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                        ELSE
                           WRITE(IUNITS,203) NINT(TYP)
  203 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'QOB ON AT LEAST ONE LEVEL (IF AVAILABLE ON THAT LEVEL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                        ENDIF
                        NFLGRT(NINT(TYP),3) = 1
                     ENDIF
                     RCD = 3
                     REJ = 9
cdak cdak cdak cdak  WRITE(IUNITS,108) STNID,NINT(TYP),YOB,XOB,QOB/1000.
cd108 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT QOB ON LVL - QOB=',F6.3,'G/KG, MISSING OBS. ERROR')
                  ELSE
                     WRITE(IUNITS,109) STNID,NINT(TYP),YOB,XOB,
     $                QOB/1000.,QTOP_REJ,POB
  109 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, REJECT QOB ON LVL - QOB=',F6.3,' G/KG, ABOVE ',F6.1,
     $ 'MB (POB=',F6.1,' MB)')
                     RCD = 5
                     REJ = 9
                  ENDIF
               ELSE
                  IF(MOERR_P.OR.MOERR_T)  THEN
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               IF(REJ.EQ.9.AND.(QQM.GT.3.AND.QQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1403) STNID,NINT(TYP),YOB,XOB,QQM
 1403 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT QQM =',F4.0,' -- DO NOT APPLY MSTR QM=9 EVENT')
               ELSE
                  QEV(1,L) = QOB
                  QEV(2,L) = REJ
                  QEV(3,L) = IPVCD
                  QEV(4,L) = RCD
                  MAXQEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR WINDS -- UOB AND VOB ON LEVEL REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND OBSERVATION ERROR FOR SFC PRESSURE IS
C       MISSING (AND SWITCH DOBERR=TRUE) -- "PREVENT" PGM REASON CODE 3
C    - THIS IS SFC LEVEL AND PRESSURE VIOLATES RULES FOR SFC PRESSURE
C       (EXCEPT FOR MISSING OBSERVATION ERROR, ALREADY COVERED IN RULE
C       2 ABOVE) (SEE ABOVE)
C    - PRESSURE ON LEVEL VIOLATES RULES FOR PRESSURE (SEE ABOVE)
C  REJECTION FOR FIRST TWO RULES MEANS Q.M. SET TO 9 UNLESS:
C      - ANY OTHER RULE CAUSES REJECTION, THEN Q.M. SET TO 8
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(MIN(UOB,VOB).LT.BMISS) THEN
            REJW = OEFG01(POB,TYP,4,OEMIN(4)).GE.BMISS
            IF(REJW.OR.REJP_PS) THEN
               REJ = 8
               IF(.NOT.REJP_PS)  THEN
                  IF(NFLGRT(NINT(TYP),4).EQ.0)  THEN
                     IF(NI.EQ.8)  THEN
                        WRITE(IUNITS,1304) NINT(TYP)
 1304 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'UOB/VOB ON SFC LVL DUE TO MISSING OBS ERROR'/)
                     ELSE
                        WRITE(IUNITS,204) NINT(TYP)
  204 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'UOB/VOB ON AT LEAST ONE LVL (IF AVAILABLE ON THAT LVL) DUE TO ',
     $ 'MISSING OBS ERROR'/)
                     ENDIF
                     NFLGRT(NINT(TYP),4) = 1
                  ENDIF
cdak cdak cdak    WRITE(IUNITS,112) STNID,NINT(TYP),YOB,XOB
cd112 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT UOB/VOB ON LVL - MISSING OBS. ERROR')
                  RCD = 3
                  REJ = 9
               ELSE
                  IF(MOERR_P)  THEN
                     RCD = 3
                     REJ = 9
                  ENDIF
               ENDIF
               IF(REJ.EQ.9.AND.(WQM.GT.3.AND.WQM.LT.15))  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1404) STNID,NINT(TYP),YOB,XOB,WQM
 1404 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT WQM =',F4.0,' -- DO NOT APPLY WIND QM=9 EVENT')
               ELSE
                  WEV(1,L) = UOB
                  WEV(2,L) = VOB
                  WEV(3,L) = REJ
                  WEV(4,L) = IPVCD
                  WEV(5,L) = RCD
                  MAXWEV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR TOTAL COLUMN PRECIPITABLE WATER -- PWO REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PWO.LT.BMISS) THEN
            REJPW = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW) THEN
               IF(NFLGRT(NINT(TYP),5).EQ.0)  THEN
                  WRITE(IUNITS,205) NINT(TYP)
  205 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PWO DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),5) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,113) STNID,NINT(TYP),YOB,XOB,PWO
cd113 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PWO ON LVL - PWO=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PWQ.GT.3.AND.PWQ.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1405) STNID,NINT(TYP),YOB,XOB,PWQ
 1405 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PWQ =',F4.0,' -- DO NOT APPLY PWtO QM=9 EVENT')
               ELSE
                  PWV(1,L) = PWO
                  PWV(2,L) = 9
                  PWV(3,L) = IPVCD
                  PWV(4,L) = 3
                  MAXPWV = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 1 PRECIPITABLE WATER -- PW1O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW1O.LT.BMISS) THEN
            REJPW1 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW1) THEN
               IF(NFLGRT(NINT(TYP),9).EQ.0)  THEN
                  WRITE(IUNITS,206) NINT(TYP)
  206 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW1O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),9) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,114) STNID,NINT(TYP),YOB,XOB,PW1O
cd114 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW1O ON LVL - PW1O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW1Q.GT.3.AND.PW1Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1406) STNID,NINT(TYP),YOB,XOB,PW1Q
 1406 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW1Q =',F4.0,' -- DO NOT APPLY PW1O QM=9 EVENT')
               ELSE
                  PW1V(1,L) = PW1O
                  PW1V(2,L) = 9
                  PW1V(3,L) = IPVCD
                  PW1V(4,L) = 3
                  MAXPW1V = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 2 PRECIPITABLE WATER -- PW2O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW2O.LT.BMISS) THEN
            REJPW2 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW2) THEN
               IF(NFLGRT(NINT(TYP),10).EQ.0)  THEN
                  WRITE(IUNITS,207) NINT(TYP)
  207 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW2O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),10) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,115) STNID,NINT(TYP),YOB,XOB,PW2O
cd115 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW2O ON LVL - PW2O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW2Q.GT.3.AND.PW2Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1407) STNID,NINT(TYP),YOB,XOB,PW2Q
 1407 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW2Q =',F4.0,' -- DO NOT APPLY PW2O QM=9 EVENT')
               ELSE
                  PW2V(1,L) = PW2O
                  PW2V(2,L) = 9
                  PW2V(3,L) = IPVCD
                  PW2V(4,L) = 3
                  MAXPW2V = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 3 PRECIPITABLE WATER -- PW3O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW3O.LT.BMISS) THEN
            REJPW3 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW3) THEN
               IF(NFLGRT(NINT(TYP),11).EQ.0)  THEN
                  WRITE(IUNITS,208) NINT(TYP)
  208 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW3O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),11) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,116) STNID,NINT(TYP),YOB,XOB,PW3O
cd116 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW3O ON LVL - PW3O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW3Q.GT.3.AND.PW3Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1408) STNID,NINT(TYP),YOB,XOB,PW3Q
 1408 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW3Q =',F4.0,' -- DO NOT APPLY PW3O QM=9 EVENT')
               ELSE
                  PW3V(1,L) = PW3O
                  PW3V(2,L) = 9
                  PW3V(3,L) = IPVCD
                  PW3V(4,L) = 3
                  MAXPW3V = L
               ENDIF
            ENDIF
         ENDIF

C  -------------------------------------------------------------------
C  RULES FOR LAYER 4 PRECIPITABLE WATER -- PW4O REJECTED IF:
C    - OBSERVATION ERROR IS MISSING (AND SWITCH DOBERR=TRUE) --
C       "PREVENT" PGM REASON CODE 3
C  REJECTION MEANS Q.M. SET TO 9 UNLESS:
C      - Q.M. IS ALREADY > 3 BUT NOT 15, THEN SKIP EVENT AND LEAVE Q.M.
C        AS IS
C  -------------------------------------------------------------------

         IF(PW4O.LT.BMISS) THEN
            REJPW4 = OEFG01(PRSS*0.01,TYP,6,OEMIN(6)).GE.BMISS
            IF(REJPW4) THEN
               IF(NFLGRT(NINT(TYP),12).EQ.0)  THEN
                  WRITE(IUNITS,209) NINT(TYP)
  209 FORMAT(/' --> FOR ALL REPORTS WITH REPORT TYPE ',I3,', REJECT ',
     $ 'PW4O DUE TO MISSING OBS ERROR'/)
                  NFLGRT(NINT(TYP),12) = 1
               ENDIF
cdakcdakcdak   WRITE(IUNITS,117) STNID,NINT(TYP),YOB,XOB,PW4O
cd117 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
cdak $'E, REJECT PW4O ON LVL - PW4O=',F5.1,'MM, MISSING OBS. ERROR')
               IF(PW4Q.GT.3.AND.PW4Q.LT.15)  THEN
CDAKCDAKCDAKCDAK  WRITE(IUNITS,1409) STNID,NINT(TYP),YOB,XOB,PW4Q
 1409 FORMAT(' ~~> ID ',A8,' (RTP ',I3,'), LAT=',F6.2,'N, LON=',F6.2,
     $ 'E, INPUT PW4Q =',F4.0,' -- DO NOT APPLY PW4O QM=9 EVENT')
               ELSE
                  PW4V(1,L) = PW4O
                  PW4V(2,L) = 9
                  PW4V(3,L) = IPVCD
                  PW4V(4,L) = 3
                  MAXPW4V = L
               ENDIF
            ENDIF
         ENDIF

      ENDDO
      ENDIF

C  APPLY THE PROPER EVENTS
C  -----------------------

      IF(MAXPEV .GT.0) CALL UFBINT(IUNITP,PEV, 4,MAXPEV, IRET,PEVN)
      IF(MAXQEV .GT.0) CALL UFBINT(IUNITP,QEV, 4,MAXQEV, IRET,QEVN)
      IF(MAXTEV .GT.0) CALL UFBINT(IUNITP,TEV, 4,MAXTEV, IRET,TEVN)
      IF(MAXWEV .GT.0) CALL UFBINT(IUNITP,WEV, 5,MAXWEV, IRET,WEVN)
      IF(MAXPWV .GT.0) CALL UFBINT(IUNITP,PWV, 4,MAXPWV, IRET,PWVN)
      IF(MAXPW1V.GT.0) CALL UFBINT(IUNITP,PW1V,4,MAXPW1V,IRET,PW1VN)
      IF(MAXPW2V.GT.0) CALL UFBINT(IUNITP,PW2V,4,MAXPW2V,IRET,PW2VN)
      IF(MAXPW3V.GT.0) CALL UFBINT(IUNITP,PW3V,4,MAXPW3V,IRET,PW3VN)
      IF(MAXPW4V.GT.0) CALL UFBINT(IUNITP,PW4V,4,MAXPW4V,IRET,PW4VN)

      RETURN
      END

      SUBROUTINE UZL(U, ZM, TD, ZTM, CD, CH, Z0, FL)
C
C PURPOSE:
C               TO CALCULATE THE BULK AERODYNAMIC COEFFICIENTS FOR
C               MOMENTUM AND HEAT OVER A LAKE SURFACE AS FUNCTIONS
C               OF WIND SPEED AND AIR-SEA TEMPERATURE DIFFERENCE.
C
C ALGORITHM:
C               THERE IS AN OUTER ITERATION IN WHICH THE ROUGHNESS
C               LENGTH IS VARIED ACCORDING TO CHARNOCK'S FORMULA AND
C               AN INNER ITERATION IN WHICH THE STABILITY LENGTH
C               (MONIN-OBUKHOV LENGTH) IS VARIED ACCORDING TO THE
C               BUSINGER-DYER FORMULATION.  THE CONSTANT IN CHARMOCK'S
C               FORMULA IS CHOSEN SO THAT UNDER NEUTRAL CONDITIONS THE
C               10 M DRAG COEFFICIENT IS 0.0016.
C
C ARGUMENTS:
C  ON INPUT:
C               U - WIND SPEED (M / S)
C               ZM - ANEMOMETER HEIGHT (M)
C               TD - AIR-SEA TEMPERATURE DIFFERENCE (DEG K)
C               ZTM - THERMOMETER HEIGHT
C                     (INITIALLY ASSUMED EQUAL TO ANEMOMETER HEIGHT)
C  ON OUTPUT:
C               CD - BULK AERODYNAMIC COEFFICIENT FOR MOMENTUM
C               CH - BULK AERODYNAMIC COEFFICIENT FOR HEAT
C               Z0 - ROUGHNESS LENGTH (M)
C               FL - STABILITY LENGTH (M)
C
C HISTORY:
C               WRITTEN BY J. R. BENNETT AND J. D. BOYD, 1979, GLERL,
C               ANN, ARBOR, MI;  BASED ON A CONSTANT ROUGHNESS VERSION
C               WRITTEN BY PAUL LONG AND WILL SHAFFER OF THE TECHNIQUES
C               DEVELOPMENT LABORATORY, NOAA, SILVER SPRINGS, MD.
C
C               MODIFIED WHEN TRANSFERRED TO VAX FROM CDC IN 1984 TO WORK
C                CORRECTLY WITH 32 BIT REALS
C
C               MODIFIED 1/86 TO PREVENT MODIFICATION OF FIRST ARGUMENT IN
C                CALLING PARAMETERS (U) WHEN U < 0.001
C
      DATA C1, C2, C3 /.684E-4, 4.28E-3, -4.43E-4/
      DATA B1, B2, B3 /1.7989E-3, 4.865E-4, 3.9028E-5/
      EPS = .01
      UM = U
      IF (UM .LT. .001) UM = .001
      FK = .35
      TBAR = 278.
      ALPHA = 4.7
      BETA = .74
      GAMM = 15.
      GAMT = 9.
      UST1 = 0.04 * UM
      H = ZM
      !IF (TD.LT.0) then
      !   DTHETA=ABS(TD)
      !ELSE
      DTHETA = TD
      !ENDIF
      IF (ABS(DTHETA) .LT. 1.E-7) DTHETA = SIGN(1.E-7,DTHETA)
C      PRINT*, "INITIAL VALUES OF UM,UST1,TDIFF=",UM,UST1,TD
C
C INITIAL GUESS FOR Z0
C
      Z0 = .00624 * UST1 * UST1
      S = UM * UM * TBAR / (9.8*DTHETA)
C      print*, "INITIAL VALUE OF S=",S
      IF (ABS(S) .GT. 1.E6) S = SIGN(1.E6,S)
      X = ALOG(H/Z0)
C      PRINT*, "Initial value of X,H,Z0=",X,H,Z0
C
C       INITIAL GUESS FOR L
C
      FL = S / X
      DO 60 ITER = 1, 20
C      PRINT*,'OUTER ITERATION',ITER,' FL=',FL
        X = ALOG(H/Z0)
        IF (ABS(FL) .GT. 500.) FL = SIGN(500.,FL)
        IF (FL .GT. 0.) GO TO 20
C
C UNSTABLE SECTION (L LT 0 OR DT LT 0)
C
        FLI = 1. / FL
C
C ASSUME 5 ITERATIONS SUFFICIENT
C
        DO 10 I = 1, 5
C      PRINT*,'INNER ITERATION',I,' FL=',FL
          X1 = GAMT * FLI
          ARG1 = SQRT(1. - X1*H)
          ARG2 = SQRT(1. - X1*Z0)
          A = BETA * ALOG((ARG1 - 1.)*(ARG2 + 1.)/((ARG1 + 1.)*
     1    (ARG2 -0.999999)))
          X1 = GAMM * FLI
          ARG1 = (1. - X1*H) ** (.25)
          ARG2 = (1. - X1*Z0) ** (.25)
          B = ALOG((ARG1 - 1.)*(ARG2 + 1.)/((ARG1 + 1.)*
     1    (ARG2 - 0.999999))) +2. * (ATAN(ARG1) - ATAN(ARG2))
          FL = S * A / (B*B)
          IF (ABS(FL) .GT. 500.) FL = SIGN(500.,FL)
          FLI = 1. / FL
   10   CONTINUE
        GO TO 50
C
C STABLE SECTION
C
C TRY MILDLY STABLE-
C
   20   CONTINUE
        AA = X * X
        X1 = H - Z0
        BB = 9.4 * X1 * X - .74 * S * X
        CC = 4.7 * X1
        CC = CC * CC - CC * S
        ROOT = BB * BB - 4. * AA * CC
        IF (ROOT .LT. 0.) GO TO 30
        FL = (-BB + SQRT(ROOT)) / (2.*AA)
        IF (FL .LE. H) GO TO 30
        B = X + 4.7 * X1 / FL
        A = BETA * X + 4.7 * X1 / FL
        GO TO 50
C
C STRONGLY STABLE-
C
   30   CONTINUE
        IF (FL .LE. Z0) FL = Z0 + 1.E-5
        DO 40 I = 1, 5
          ARG1 = FL / Z0
          X1 = ALOG(ARG1)
          X2 = ALOG(H/FL)
          ARG1 = 1. - 1. / ARG1
          A = .74 * X1 + 4.7 * ARG1 + 5.44 * X2
          B = X1 + 4.7 * ARG1 + 5.7 * X2
          FL = A * S / (B*B)
          IF (FL .LE. Z0) FL = Z0 + 1.E-5
          IF (FL .GT. H) FL = H
   40   CONTINUE
C
C CALCULATE USTAR AND Z0NEW
C
   50   CONTINUE
        TSTAR = FK * DTHETA / A
        USTAR = FK * UM / B
        Z0NEW = .00624 * USTAR * USTAR
        IF (ITER .GT. 5 .AND. ABS((USTAR - UST1)/UST1) .LT. EPS)
     1     GO TO 80
        UST1 = USTAR
        Z0 = Z0NEW
   60 CONTINUE
C
C IF COME HERE, TOO MANY ITERATIONS (UGH - UGH)
C
      WRITE (6,70)
   70 FORMAT ('0TOO MANY ITERATIONS ON Z0 IN SUBROUTINE UZL - CHECK ',
     1       'METEOROLOGICAL DATA - PROGRAM TERMINATED')
      call w3tage('PREPOBS_GLERLADJ')
      CALL ERREXIT(34)
   80 CONTINUE
      Z0 = Z0NEW
      CD = (USTAR/UM) ** 2
      CH = FK * FK / (A*B)
   90 RETURN
      END

C-----------------------------------------------------------------------
C  MOIFUN IS A SET OF MOISTURE VARIABLE CONVERSION FUNCTIONS. THE
C  FUNCTION PACKAGE RELATES ATMOSPHERIC PRESSURE, TEMPERATURE, AND
C  WATER VAPOR PRESSURE, WITH THE MOISTURE VARIABLES OF RELATIVE
C  HUMIDITY, MIXING RATIO, SPECIFIC HUMIDITY, DEWPOINT, AND VIRTUAL
C  TEMPERATURE. VARIOUS COMPONENTS OF THE FUNCTIONS ARE GIVEN BELOW.
C
C
C  SYMBOLS (AND THEIR UNITS) USED IN THE FUNCTION ARGUMENTS ARE:
C
C     P  = ATMOSPHEREIC PRESSURE     (MB)
C     E  = WATER VAPOR PRESSURE      (MB)
C     T  = TEMPERATURE               (DEG C)
C     R  = RELATIVE HUMIDITY         (PERCENT)
C     W  = MIXING RATIO              (G/G)
C     Q  = SPECIFIC HUMIDITY         (G/G)
C     DP = TEMPERATURE               (DEG C)
C     ES = SATURATION VAPOR PRESSURE (MB)
C     WS = SATURATION MIXING RATION  (G/G)
C     TV = VIRTUAL TEMPERATURE       (DEG C)
C     TS = SENSIBLE TEMPERATURE      (DEG C)
C
C  PHYSICAL CONSTANTS USED ARE:
C
C     EZERO = WATER VAPOR ES @ 0 DEG C    (   6.11  MILIBARS        )
C     EVLAT = LATENT HEAT OF EVAPORATION  (  597.3  CAL/G           )
C     VMOLW = MOLECULAR WEIGHT OF WATER   ( 18.016  G/MOL           )
C     DMOLW = MOLECULAR WEIGHT OF DRY AIR ( 28.966  G/MOL           )
C     RSTAR = UNIVERSAL GAS CONSTANT      (   1.98  CAL/(MOL*DEG K) )
C     TZERO = 0 DEG C IN DEG K            ( 273.16  DEG K           )
C     EPSLN = VMOLW/DMOLW                 (   .622  NO UNITS        )
C
C  THE SATURATION WATER VAPOR PRESSURE(ES) IS COMPUTED AS A SOLUTION
C  OF THE CLAUSIUS-CLAPEYRON EQUATION (SEE HESS,"INTRODUCTION TO
C  THEORETICAL METEOROLOGY", PGS 48-49). THE SPECIFIC FORMULATION,
C
C  ES(T)=EZERO*EXP(17.269*T/(T+237.3)),
C
C  WHERE T IS DEGREES CELSIUS, IS A FORM OF TETENS' FORMULA FOR SATURATION
C  VAPOR PRESSURE. FOR MORE DETAILS SEE NMC OFFICE NOTE 36, OR
C  TETENS, O., 1930: OBER EINIGE METEOROLOGISCHE VEGRIFFE. Z. GEOPHYS.
C
C  THE DEFINITIONS OF MOISTURE VARIABLES ARE (FROM HESS,PGS 58-60):
C
C     RELATIVE HUMIDITY    R  = W/WS
C     MIXING RATIO         W  = EPSLN*E/(P-E)
C     SPECIFIC HUMIDITY    Q  = EPSLN*E/(P-E*(1-EPSLN))    (EXACT FORM)
C     DEW POINT            DP = TEMPERATURE WHERE WS(DP,P,E) = W(T,P,E)
C     VIRTUAL TEMPERATURE  VT = T*(1+W/EPSLN)/(1+W)
C     SENSIBLE TEMPERATURE TS = T*(1+W)/(1+W/EPSLN)
C
C  MOIFUN PROVIDES ENTRY POINTS WHICH COMPUTE MOISTURE VARIABLES FROM
C  THEIR COMPONENTS. ENTRIES ARE ALSO GIVEN WHICH CALCULATE E FROM
C  THE MOISTURE VARIABLES. THIS ENABLES CONVERSIONS BETWEEN MOISTURE
C  VARIABLES. THE FUNCTION ENTRY POINTS ARE:
C
C     1) ESVP(T     ) - SATURATION WATER VAPOR PRESSURE FROM T
C     2) ERLH(P,R,T ) - WATER VAPOR PRESSURE FROM P,R,T
C     3) EMIX(P,W   ) - WATER VAPOR PRESSURE FROM P,W
C     4) ESPH(P,Q   ) - WATER VAPOR PRESSURE FROM P,Q
C     5) EDEW(DP    ) - WATER VAPOR PRESSURE FROM DP
C     6) RELH(P,E,T ) - RELATIVE HUMIDITY FROM P,E,T
C     7) WMIX(P,E   ) - MIXING RATIO FROM P,E
C     8) QSPH(P,E   ) - SPECIFIC HUMIDITY FROM P,E
C     9) DPAL(E     ) - DEW POINT FROM E   (ALGEBRAIC)
C    10) VIRT(P,E,TS) - VIRTUAL  TEMPERATURE FROM P,E,TS
C    11) SENT(P,E,TV) - SENSIBLE TEMPERATURE FROM P,E,TV
C
C  THE MAIN ENTRY POINT (MOIFUN) IS A DUMMY FUNCTION.
C
C     CALLING MOIFUN RESULTS IN AN ABORT.
C
C-----------------------------------------------------------------------
      FUNCTION MOIFUN(DUMMY)
 
      PARAMETER (RSTAR = 1.98        )
      PARAMETER (TZERO = 273.16      )
      PARAMETER (EVLAT = 597.3       )
      PARAMETER (VMOLW = 18.016      )
      PARAMETER (DMOLW = 28.966      )
      PARAMETER (EZERO = 6.11        )
      PARAMETER (EPSLN = VMOLW/DMOLW )
 
C-----------------------------------------------------------------------
      ES(T) = EZERO*EXP(17.269*T/(T+237.3))
C-----------------------------------------------------------------------
 
C  MAIN ENTRY POINT DOES NOTHING
C  -----------------------------
 
      moifun=0; RETURN
 
C  SATURATION VAPOR PRESSURE FROM T
C  --------------------------------
 
      ENTRY ESVP(T)
      ESVP = ES(T)
      RETURN
 
C  VAPOR PRESSURE FROM P,R,T
C  -------------------------
 
      ENTRY ERLH(P,R,T)
      RH   = .01*R
      ERLH = P/(1.+P/(RH*ES(T))-1./RH)
      RETURN
 
C  VAPOR PRESSURE FROM P,W
C  -----------------------
 
      ENTRY EMIX(P,W)
      EMIX = W*P/(EPSLN+W)
      RETURN
 
C  VAPOR PRESSURE FROM P,Q
C  -----------------------
 
      ENTRY ESPH(P,Q)
C     ESPH = Q*P/(1.   +Q*(1.-EPSLN))
      ESPH = Q*P/(EPSLN+Q*(1.-EPSLN))
      RETURN
 
C  VAPOR PRESSURE FROM DP
C  ----------------------
 
      ENTRY EDEW(DP)
      EDEW = ES(DP)
      RETURN
 
C  RELATIVE HUMIDITY FROM P,E,T
C  ----------------------------
 
      ENTRY RELH(P,E,T)
      EST  = ES(T)
      RELH = (E/(P-E))/(EST/(P-EST))
      RETURN
 
C  MIXING RATIO FROM P,E
C  ---------------------
 
      ENTRY WMIX(P,E)
      WMIX = EPSLN*E/(P-E)
      RETURN
 
C  SPECIFIC HUMIDITY FROM P,E
C  --------------------------
 
      ENTRY QSPH(P,E)
      QSPH = EPSLN*E/(P-E*(1.-EPSLN))
      RETURN
 
C  DEW POINT FROM ALGEBRAIC MANIPULATION OF ES FUNCTION GIVEN E
C  ------------------------------------------------------------
 
      ENTRY DPAL(E)
      XLNE = LOG(E/EZERO)
      DPAL = 237.3*XLNE/(17.269-XLNE)
      RETURN
 
C  VIRTUAL TEMPERATURE FROM P,E,TS
C  -------------------------------
 
      ENTRY VIRT(P,E,TS)
      RMIX = EPSLN*E/(P-E)
      VIRT = (TS+TZERO)*(1.+RMIX/EPSLN)/(1.+RMIX) - TZERO
      RETURN
 
C  SENSIBLE TEMPERATURE FROM P,E,TV
C  --------------------------------
 
      ENTRY SENT(P,E,TV)
      RMIX = EPSLN*E/(P-E)
      SENT = (TV+TZERO)*(1.+RMIX)/(1.+RMIX/EPSLN) - TZERO
      RETURN
 
      END

subroutine land2water (temp,dewpt,wspd,wdir,wtemp,tdiff,newtemp,newdpt,newspd,newdir,bmiss)
  !abstract: modifies ob according to Kelly paper on GLERL

  use glerl_dictionary

  implicit none
  real(4),intent(in)::temp,dewpt,wspd,wdir,tdiff,wtemp
  real(4),intent(out)::newtemp,newdpt,newspd,newdir
  real(4)::delwd
  real(8)::bmiss

  !print variables for record keeping
  print'("Original Airtemp,WaterTemp,tdiff,dewpoint,wspd,wdir=",6(2x,g0))', temp,wtemp,tdiff,dewpt,wspd,wdir
  !adjust temp
  if (temp.lt.bmiss.and.wtemp.lt.bmiss) then
     newtemp = 0.4*temp+0.6*(wtemp)
  elseif (temp.ge.bmiss) then
     newtemp=bmiss
     print*, "Can't make l2w adjusted temperature: missing observed air temperature!"
  elseif (wtemp.ge.bmiss) then
     newtemp=bmiss
     print*, "Can't make l2w adjusted temperature: missing observed water temperature!"
  else
     newtemp=bmiss
     print*, "Can't make l2w adjusted temperature: Invalid observed air temp and water temp:",temp,wtemp
  endif
  !adjust dewpoint
  if (dewpt.lt.bmiss.and.wtemp.lt.bmiss) then
     newdpt = -1.31 + 0.7*dewpt+0.35*(wtemp)
  elseif (dewpt.ge.bmiss) then
     newdpt=bmiss
     print*, "Can't make l2w adjusted dew point: missing observed dew point!"
  elseif (wtemp.ge.bmiss) then
     newdpt=bmiss
     print*, "Can't make l2w adjusted dew point: missing observed water temperature!"
  else
     newdpt=bmiss
     print*, "Can't make l2w adjusted dew point: Invalid observed dew point and water temp:",dewpt,wtemp
  endif
  !adjust wind speed
  if (wspd.lt.bmiss.and.tdiff.lt.bmiss) then
     if (wspd.gt.0) then
        newspd = wspd*(1.2+(1.85/wspd))
        if (tdiff.ne.0.and.tdiff.lt.100) newspd=newspd*(1.-(tdiff/abs(tdiff))*(abs(tdiff)/1920.)**0.3333) ! if tdiff > 100, temp is missing
        !adjust wind direction
        delwd=0.
        if(tdiff.ne.0) delwd=(12.5-1.5*tdiff)-(0.38 - 0.03*tdiff)*newspd
        newdir=wdir+delwd
        if(newdir.lt.0) newdir=newdir+360
        if(newdir.gt.360) newdir=newdir-360
     else !set to calm for calm wind or missing temperature
        newdir=wdir
        newspd=wspd
     endif
  elseif (wspd.ge.bmiss) then
     print*, "Can't make l2w adjusted wind speed: missing observed wind speed!"
     newdir=bmiss
     newspd=bmiss
  elseif (tdiff.ge.bmiss) then
     print*, "Can't make l2w adjusted wind speed: missing air-land temperature difference!"
     newdir=bmiss
     newspd=bmiss
  else
     print*, "Can't make l2w adjusted wind speed: invalid observed wind and air-land temp diff:",wspd,tdiff
     newdir=bmiss
     newspd=bmiss
  endif
  if (newspd.lt.0) then
     print*, "WARNING: Adjusted wind speed (l2w) is less than zero.  Defaulting to 0..."
     print*, "Adjusted wind speed value is:",newspd
     newspd=0.
  endif
  print'("Adjusted Airtemp,dewpoint,wspd,wdir=",4(2x,g0))', newtemp,newdpt,newspd,newdir

end subroutine land2water

subroutine spddir(u,v,spd,dir,bmiss)
  !abstract: calculates wind speed and direction given u and v
  use glerl_dictionary
  implicit none
  real(4),intent(in)::u,v
  real(4),intent(out)::spd,dir
  real(4)::tempagl,pi
  real(8)::bmiss

  !initialize temp variables
  pi = 3.14519
  tempagl=0
  !find speed
  spd=sqrt((u*u)+(v*v))
  !find direction
  if(u.eq.0.and.v.lt.0) then
     dir = 360
  elseif(u.eq.0.and.v.gt.0) then
     dir = 180
  elseif(u.lt.0.and.v.eq.0) then
     dir = 70
  elseif(u.gt.0.and.v.eq.0) then
     dir = 270
  elseif (u.eq.0.and.v.eq.0) then
     dir = 360
  elseif (u.gt.9999.or.v.gt.9999) then
     dir = bmiss
     spd = bmiss
  else
     tempagl=atan(v/u)*180/pi
     if (u.lt.0.and.v.lt.0) then
        dir=270-tempagl-180
     elseif (u.gt.0.and.v.lt.0) then
        dir = 90+tempagl+180
     elseif (u.lt.0.and.v.gt.0) then
        dir=270+tempagl-180
     elseif (u.gt.0.and.v.gt.0) then
        dir=90-tempagl+180
     endif
  endif
end subroutine spddir

      program splitac

      character(80) hdstr,obstr,qmstr,xystr
      character(8)  subset
      real(8)       typ,hdr(10),obs(10,255),qms(10,255),xyt(10,255)

      data lunin /20/
      data lunot /50/

      hdstr = 'SID XOB YOB ELV DHR TYP                        '
      obstr = 'POB QOB TOB ZOB UOB VOB CAT                    '
      qmstr = 'PQM QQM TQM ZQM WQM                            '
      xystr = 'XDR YDR HRDR                                   '

      call openbf(lunin,'IN ',lunin)
      call openbf(lunot,'OUT',lunin)

      do while(ireadmg(lunin,subset,idate)==0)
      do while(ireadsb(lunin)==0)

      call ufbint(lunin,hdr,10,1,iret,hdstr)   
      ityp=mod(nint(hdr(6)),100)

      ! do the mass part
      call ufbint(lunin,obs,10,255,nlev,'POB QOB TOB ZOB NUL NUL CAT') ! read the observation elements
      call ufbint(lunin,qms,10,255,iret,'PQM QQM TQM ZQM NUL        ') ! read the current quality marks
      call ufbint(lunin,xyt,10,255,iret,'XDR YDR HRDR               ') ! read balloon drift coordinates
      do n=1,nlev
      hdr(2)=xyt(1,n) ! reflect location in profile 
      hdr(3)=xyt(2,n)
      hdr(5)=xyt(3,n)
      hdr(6)=100+ityp
      call openmb(lunot,subset,idate)
      call ufbint(lunot,hdr,10,1,iret,hdstr)   
      call ufbint(lunot,obs(1,n),10,1,iret,obstr) 
      call ufbint(lunot,qms(1,n),10,1,iret,qmstr) 
      call writsb(lunot)
      enddo

      ! do the wind part
      call ufbint(lunin,obs,10,255,nlev,'POB NUL NUL ZOB UOB VOB CAT') ! read the observation elements
      call ufbint(lunin,qms,10,255,iret,'PQM NUL NUL ZQM WQM        ') ! read the current quality marks
      call ufbint(lunin,xyt,10,255,iret,'XDR YDR HRDR               ') ! read balloon drift coordinates
      do n=1,nlev
      hdr(2)=xyt(1,n) ! reflect location in profile 
      hdr(3)=xyt(2,n)
      hdr(5)=xyt(3,n)
      hdr(6)=200+ityp
      call openmb(lunot,subset,idate)
      call ufbint(lunot,hdr,10,1,iret,hdstr)   
      call ufbint(lunot,obs(1,n),10,1,iret,obstr) 
      call ufbint(lunot,qms(1,n),10,1,iret,qmstr) 
      call writsb(lunot)
      enddo

      enddo
      enddo

      call closbf(lunot)

      stop
      end

!
!                                 ******************************************
!                                 *             MODULE pspl                *
!                                 *  R. J. Purser, NOAA/NCEP/EMC, May 2014 * 
!                                 *  jim.purser@noaa.gov                   *
!                                 *                                        *
!                                 ******************************************
!
! A collection of handy spline routines
!
! Last modified:
!  Keyser (2014-12-12) - print written to unit 41 rather than stdout (for use in
!                        prepobs_prepacqc program - limits amount of stdout)
! 
! DIRECT DEPENDENCIES:
! Modules:   pietc, pkind, pmat2
! Libraries: pmat
!
!
!=============================================================================
module pspl
!=============================================================================
use pkind, only: dp 
use pietc, only: T,F,u0,o2,u1 ! True, False, 0., .5,  1.
implicit none
private
public:: expm,expmm,coshm,sinhm,coshmm,xcms,enbase_t,      bnewton, &
     fit_tspline,eval_tspline,int_tspline,eval_itspline,             &
     fit_uspline,eval_uspline,int_uspline,eval_iuspline,             &
     best_slalom,count_gates,set_gates,set_posts,                    &
     count_routes,list_routes,next_route,                            &
     slalom_tspline,slalom_uspline,convertd,convertd_back

integer, parameter:: ihu=1025      ! "Huge" integer parameter
real(dp),parameter:: hu=huge(hu)/2 ! "Huge" real parameter
real(dp),parameter:: eps=epsilon(eps),heps=.01 ! Small parameters

interface expm;          module procedure expm;                  end interface
interface expmm;         module procedure expmm;                 end interface
interface coshm;         module procedure coshm;                 end interface
interface sinhm;         module procedure sinhm;                 end interface
interface coshmm;        module procedure coshmm;                end interface
interface xcms;          module procedure xcms;                  end interface
interface enbase_t;      module procedure enbase_t;              end interface
interface bnewton;       module procedure tbnewton,ubnewton;     end interface
interface fit_tspline;   module procedure fit_gtspline,fit_tspline
                                                                 end interface
interface eval_tspline
   module procedure eval_tspline,eval_tsplined,eval_tsplinedd,eval_tsplineddd
                                                                 end interface
interface int_tspline;   module procedure int_tspline;           end interface
interface eval_itspline; module procedure eval_itspline;         end interface
interface fit_uspline;   module procedure fit_guspline,fit_uspline
                                                                 end interface
interface eval_uspline
   module procedure eval_uspline,eval_usplined,eval_usplinedd,eval_usplineddd
                                                                 end interface
interface int_uspline;   module procedure int_uspline;           end interface
interface eval_iuspline; module procedure eval_iuspline;         end interface
interface best_slalom;   module procedure best_tslalom,best_uslalom
                                                                 end interface
interface count_gates;   module procedure count_gates;           end interface
interface set_gates;     module procedure set_gates;             end interface
interface set_posts;     module procedure set_posts;             end interface
interface count_routes;  module procedure count_routes;          end interface
interface list_routes;   module procedure list_routes;           end interface
interface next_route;    module procedure next_route;            end interface
interface slalom_tspline;module procedure slalom_tspline;        end interface
interface slalom_uspline;module procedure slalom_uspline;        end interface
interface convertd;      module procedure convertd;              end interface
interface convertd_back; module procedure convertd_back;         end interface

contains

!=============================================================================
function expm(x) result(e)!                                             [expm]
!=============================================================================
! exp(x)-1 (approximately x for small x)
! = I^(1)exp(x), where I^(p) is the integral iterated p times
real(dp),intent(in ):: x
real(dp)            :: e
!-----------------------------------------------------------------------------
real(dp):: p
integer :: i
!=============================================================================
if(abs(x)>o2)then
   e=exp(x)-u1
else
   p=x; e=p
   do i=2,19; p=p*x/i; e=e+p; if(abs(p)<=abs(e*eps))return; enddo
endif
end function expm

!=============================================================================
function expmm(x) result(e)!                                           [expmm]
!=============================================================================
! exp(x)-1-x (approximately x^2/2 for small x)
! = I^(2)exp(x), where I^(p) is the integral iterated p times
real(dp),intent(in ):: x
real(dp)            :: e
!-----------------------------------------------------------------------------
real(dp):: p
integer :: i
!=============================================================================
if(abs(x)>o2)then
   e=exp(x)-u1-x
else
   p=x*x*o2; e=p
   do i=3,25; p=p*x/i; e=e+p; if(abs(p)<=abs(e*eps))return; enddo
endif
end function expmm

!=============================================================================
function coshm(x) result(c)!                                           [coshm]
!=============================================================================
! cosh(x)-1  (approximately x**2/2 for small x)
! =I^(2)cosh(x), where I^(p) is the integral iterated p times
real(dp),intent(in ):: x
real(dp)            :: c
!-----------------------------------------------------------------------------
c=2*sinh(x*o2)**2
end function coshm

!=============================================================================
function sinhm(x) result(s)!                                           [sinhm]
!=============================================================================
! sinh(x)-x (approximately x**3/6 for small x)
! =I^(3)cosh(x), where I^(p) is the integral iterated p times
real(dp),intent(in ):: x
real(dp)            :: s
!-----------------------------------------------------------------------------
real(dp):: p,xx
integer :: i
!=============================================================================
if(abs(x)>o2)then
   s=sinh(x)-x
else
   p=x**3/6;  s=p;  xx=x*x
   do i=5,19,2; p=p*xx/(i*(i-1)); s=s+p; if(abs(p)<=abs(s*eps))return; enddo
endif
end function sinhm

!=============================================================================
function coshmm(x) result(c)!                                         [coshmm]
!=============================================================================
! cosh(x)-1-x^2/2  (approximately x**4/24 for small x)
! =I^(4)cosh(x), where I^(p) is the integral iterated p times
real(dp),intent(in ):: x
real(dp)            :: c
!-----------------------------------------------------------------------------
real(dp)            :: xh
!=============================================================================
xh=x*o2
c=sinhm(xh)*(2*sinh(xh)+x)
end function coshmm

!=============================================================================
function xcms(x) result(e)!                                             [xcms]
!=============================================================================
real(dp),intent(in ):: x
real(dp)            :: e
!-----------------------------------------------------------------------------
real(dp):: p,xx
integer :: i,i2
!=============================================================================
! x*coshm(x)-sinhm(x) (approximately x**3/3 for small x)
if(abs(x)>o2)then
   e=x*coshm(x)-sinhm(x)
else
   p=x**3/3;  e=p;  xx=x*x
   do i=2,15
      i2=i*2; p=p*xx/(i2*(i2+1)); e=e+i*p; if(abs(p)<=abs(e*eps))return
   enddo
endif
end function xcms

!==============================================================================
function enbase_t(tspan,hspan)result(r)!                             [enbase_t]
!==============================================================================
! For a nondimensional time span, tspan, but a dimensional height
! span, hspan, return the baseline minimum possible tensioned spline
! energy integrated over the central span plus the two wings.
! If the hspan vanishes, return a nominal unit energy.
! The energy is quadratic in hspan, which can therefore be of either sign,
! but tspan must be strictly positive for a meaningful positive energy.
!==============================================================================
real(dp),intent(in ):: tspan,hspan
real(dp)            :: r
!=============================================================================
if(tspan<u0)stop 'In enbase_t; thspan must be positive'
if(hspan==u0)then; r=u1; return; endif
r=hspan**2/expmm(-tspan)*o2
end function enbase_t

!=============================================================================
subroutine tbnewton(nh,m,bigT,halfgate,hgts,hs,hgtp,p,q, te,dhdt,FF)! [bnewton]
!=============================================================================
! Perform a "bounded Newton" iteration to estimate the vertical velocity,
! dh/dt, as the trajectory passes through the nh "gates", each at height
! hs(i) and centered at time hgts(i)*halfgate with the halfwidth of the gate 
! equal to halfgate. The characteristic timescale of the fitted spline is bigT.
! the time-nodes rescaled by this bigT are at the m points tp, and the 
! corresponding "p" and "q" coefficients of the tensioned spline are p and q
! respectively. 
! The output is an array of n estimates, dh/dt, at each gate's hs. This
! involves estimating the time t of passage through each gate, and is done
! generically by Newton's method, except that the newton increments are
! bounded to be within a range "gate" = 2*halfgate, so that we eliminate
! wild excursions when dh/dt is actually very small (or vanishes). When such
! an excursion is detected, the returned value of dh/dt is simply that
! evaluated at ts(i), and no further attempt at Newton refinement is made
! at this i. (The vertical motion in such cases is essentially negligible
! in any case, and very likely is multivalued as the trajectory wavers about
! this gate's value of hs(i).)
!=============================================================================
integer,               intent(in ):: nh,m
real(dp),              intent(in ):: bigT,halfgate
integer ,dimension(nh),intent(in ):: hgts
real(dp),dimension(nh),intent(in ):: hs
integer, dimension(m), intent(in ):: hgtp
real(dp),dimension(m) ,intent(in ):: p,q
real(dp),dimension(nh),intent(out):: dhdt, te
logical,               intent(out):: FF
!-----------------------------------------------------------------------------
integer,parameter    :: nit=12
real(dp),dimension(m):: tr
real(dp)             :: gate,tee,he,hac,dhadt,dh,dt
integer              :: i,it
!=============================================================================
gate=2*halfgate/bigT
tr=hgtp*halfgate/bigT
do i=1,nh
   tee=hgts(i)*halfgate/bigT
   he=hs(i)
!  Use Newton iterations to estimate the rescaled time, tee, at which the 
!  height is he
   it = 1
   do while (it <= nit)
      call eval_tspline(m,tr,p,q, tee,hac,dhadt)
      if(it==1)dhdt(i)=dhadt/bigT
      if(dhadt==u0)exit
      dh=hac-he
      dt=-dh/dhadt
      if(abs(dt)>gate)then
         write(41,*) 'WARNING! In tbnewton; i,it,dt/gate = ',i,it,dt/gate
         exit
      endif
      if(abs(dh)<heps)then
         dhdt(i)=dhadt/bigT
         exit
      endif
      tee=tee+dt
      it = it + 1
   enddo
   FF=(it>nit)
   if(FF)then
      write(41,'("In tbnewton; Newton iterations seem not to be")')
      write(41,'("converging at i=",i3)'),i
      write(41,'("tee,he,hac,heps,dhadt:",5(1x,e11.4))'),tee,he,hac,heps,dhadt
   endif
   te(i) = tee
enddo
end subroutine tbnewton

!=============================================================================
subroutine ubnewton(nh,m,halfgate,hgts,hs,hgtp,p,q, te,dhdt,FF)!     [bnewton]
!=============================================================================
! Like tbnewton, but for the case of untensioned (i.e., cubic) splines
!=============================================================================
integer,               intent(in ):: nh,m
real(dp),              intent(in ):: halfgate
integer, dimension(nh),intent(in ):: hgts
real(dp),dimension(nh),intent(in ):: hs
integer, dimension(m), intent(in ):: hgtp
real(dp),dimension(m) ,intent(in ):: p,q
real(dp),dimension(nh),intent(out):: dhdt, te
logical,               intent(out):: FF
!-----------------------------------------------------------------------------
integer,parameter    :: nit=12
real(dp),dimension(m):: tr
real(dp)             :: gate,tee,he,hac,dhadt,dh,dt
integer              :: i,it
!=============================================================================
gate=2*halfgate
tr=hgtp*halfgate
do i=1,nh
   tee=hgts(i)*halfgate
   he=hs(i)
!  Use Newton iterations to estimate the rescaled time, tee, at which the 
!  height is he
   it = 1
   do while (it <= nit)
      call eval_uspline(m,tr,p,q, tee,hac,dhadt)
      if(it==1)dhdt(i)=dhadt
      if(dhadt==u0)exit
      dh=hac-he
      dt=-dh/dhadt
      if(abs(dt)>gate)then
         write(41,*) 'WARNING! In ubnewton; i,it,dt/gate = ',i,it,dt/gate
         exit
      endif
      if(abs(dh)<heps)then
         dhdt(i)=dhadt
         exit
      endif
      tee=tee+dt
      it = it + 1
   enddo
   FF=(it>nit)
   if(FF)then
      write(41,'("In ubnewton; Newton iterations seem not to be")')
      write(41,'("converging at i=",i3)'),i
      write(41,'("tee,he,hac,heps,dhadt:",5(1x,e11.4))'),tee,he,hac,heps,dhadt
   endif
   te(i) = tee
enddo
end subroutine ubnewton

!============================================================================
subroutine fit_gtspline(n,xs,ys,on,q,j,yac,en,FF)!              [fit_tspline]
!============================================================================
! Fit the gappy tensioned spline, where only those nodes flagged "on"
! are effective in the fitting procedure. Owing to the fact that, where
! constraints are not "on" the spline will generally depart from ys, the
! actual y (yac) is returned for all nodes, regardless of the partial
! duplication with the given ys. In other respects, this is just
! like fit_tspline.
!============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,ys
logical, dimension(n),intent(in ):: on
real(dp),dimension(n),intent(out):: q,j,yac
real(dp),             intent(out):: en
logical,              intent(out):: FF
!----------------------------------------------------------------------------
real(dp),dimension(n):: xa,ya,qa,ja
integer              :: i,k,m
!============================================================================
m=0
do i=1,n
   if(on(i))then; m=m+1; xa(m)=xs(i); ya(m)=ys(i); endif
enddo
call fit_tspline(m,xa(1:m),ya(1:m),qa(1:m),ja(1:m),en,FF)
if(FF)then
   write(41,*) 'In fit_gtspline; failure flag raised at call to fit_tspline'
   return
endif
k=0
do i=1,n
   if(on(i))then
      k=k+1
      q(i)=qa(k)
      j(i)=ja(k)
      yac(i)=ys(i)
   else
      call eval_tsplined(m,xa(1:m),ya(1:m),qa(1:m),xs(i), yac(i),q(i))
      j(i)=0
   endif
enddo
end subroutine fit_gtspline

!============================================================================
subroutine fit_tspline(n,xs,p,q,j,en,FF)!                       [fit_tspline]
!============================================================================
! Solve for the coefficients, the 3rd-derivative jumps, and the energy,
! of the standardized tensioned spline passing through the n nodes at (xs,p).
!
! The value and successive derivatives on the immediate positive side of
! each node, xs(i), are to be found as p(i), q(i), r(i), s(i), with j(i)
! being the discontinuity of 3rd-derivative s between the negative and positive
! side of the node (value itself, and other derivatives, remaining continuous).
! In addition, p(0), q(0), r(0) and s(0) are the value and derivatives on the 
! immediate negative side of xs(1). The spline solution minimizes elastic
! and tensional energy, en, defined as the integral dx of half the sum of the
! squared first and second derivatives over the whole line. Euler-Lagrange
! implies the solution is expressible in each segment between or beyond nodes:
!       y(x') = p + q*x' + r*coshm(x') + s*sinhm(x')
! where x' = x-xs(i) is the local coordinate relative to the relevant node
! (the node at the left of the segent except that, implicitly, we take
! xs(0)===xs(1), and the two functions, coshm and sinhm, are defined:
! coshm(x) = cosh(x)-1
! sinhm(x) = sinh(x)-x.
! The solution in segment 0, i.e., x< xs(1), must exponentially decay towards
! a constant as x--> -infinity, while that for segment n must likewise decay
! as x--> +infinity, in order that energy remains finite. Thus, q(0)=r(0)=s(0)
! and q(n)=-r(n)=s(n) always. Solutions in these infinite end segments are
! therefore expressible in terms only of p(0),q(0) for segment 0 and in terms
! only of p(n), q(n) for segment n and is linear in these coefficients.
! Between consecutive nodes (segments 0<i<n) the solution y(x') is expressible
! in terms only of p(i),q(i),p(i+1),q(i+1) and is linear in these coefficients.
! Being a quadratic functional, the total energy is therefore expressible
! in vector-matrix quadratic form:
! En = (1/2)*p^T*PP*p + q^T*QP*p + (1/2)*q^T^QQ*q
! where p and q are here taken as the column vectors of all their discrete
! values, i=0,..n, and PP, QP and QQ are certain tri-diagonal matrices. 
! The spline solution is found as the energy-minimizing solution to:
! QP*p + QQ*q = 0
! where the p are known (the y(i)) and q is the vector of unknowns. Having 
! solved for q, we can immediately deduce the r and s, and hence the jump, j.
! Finally, we can also return the value of the energy as well.
! The use of a tri-diagonal solver, though seemingly more complicated than
! naive "shooting" alternatives, is very much better conditioned numerically,
! and will succeed in very long data series where the naive methods invariably
! fail.
! In practice, owing to the formal symmetries of the energy in each interval,
! we need only consider the change, p(i+1)-p(i), in each interval, and
! this "odd-symmetry" part of vector, p, only couples with the corresponding
! symmetry in the q (which is the part, (q(i)+q(i+1))), so two of the
! tridiagonals actually reduce to diagonals, simplifying the algebra.
!=============================================================================
use pmat2, only: ldltb, ltdlbv
integer,                intent(in ):: n
real(dp),dimension(  n),intent(in ):: xs,p
real(dp),dimension(  n),intent(out):: q,j
real(dp),               intent(out):: en
logical,                intent(out):: FF
!----------------------------------------------------------------------------
integer                   :: i,ip
real(dp)                  :: x,ch,sh,sa,sb,sap,ccc,xcmsx2,egg,ehh
real(dp),dimension(n-1)   :: difp,sumq,cpp,cqp
real(dp),dimension(n,-1:0):: qq ! <- Tridiagonal, stored as rows of nonupper
!=============================================================================
FF=F
if(n<1)stop 'In fit_tspline; size of data array must be positive'
if(n==1)then; q=0; j=0; en=0; return; endif
! apply a strict monotonicity check on the xs:
do i=2,n
   if(xs(i-1)>=xs(i)) then
      FF=T
      write(41,*) 'In fit_tspline; xs data must increase strictly monotonically'
      return
   end if
enddo
! Initialize tri-diagonal kernels for the energy definition:
qq=0 ! <- initialize symmetric tridiagonal, kernel for q^T*QQ*q
     ! where "q" are the dp/dx at each node.
! The coefficients in the quadratic form defining the spline energy also
! include terms involving factors (p(ip)-p(i))*(q(i)+q(ip)) and
! (p(ip)-p(i))*(p(ip)-p(i)), but these can be dealt with using, respectively,
! the  matrices cqp and cpp which are simply diagonal. It is the symmetries
! in the defiition of energy that allow this simplification.

! Loop over the intervals bounded by consecutive nodes:
do i=1,n-1
   ip=i+1
   difp(i)=p(ip)-p(i)
   x=(xs(ip)-xs(i))*o2 ! Halfwidth of interval
   ch=cosh(x);  sh=sinh(x)
   xcmsx2=xcms(x)*2
! egg relates to the odd-g-basis function's energy integral coefficient
! ehh relates to the even-g-basis function's energy integral coefficient
   egg=x*sh/xcmsx2; ehh=ch/(2*sh)
! ccc is the coefficient of energy integral coupling g(i)*g(i) and g(ip)*g(ip)
   ccc=egg+ehh
   cpp(i)=ch/xcmsx2          ! Energy coefficient for difp(i)*difp(i)...
   cqp(i)=-difp(i)*sh/xcmsx2 ! ..and for difp(i)*sumq(i)
   qq(i,0)=qq(i,0)+ccc; qq(ip,-1)=qq(ip,-1)+egg-ehh; qq(ip,0)=qq(ip,0)+ccc
enddo
! Add the exterior energy contributions to qq at both ends:
qq(1,0)=qq(1,0)+1
qq(n,0)=qq(n,0)+1

! Temporarily, q is made the vector of forcings in the tridiagonal linear
! system from which the final spline coefficients, q, are solved in place.
q(1:n-1)=-cqp; q(n)=0
q(2:n)=q(2:n)-cqp

! The following 2 lines solve the tridiagonal system for q:
call ldltb(n,1,qq)    ! <- Decompose qq into factors, L*(1/D)*L^T, L=lower
call ltdlbv(n,1,qq,q) ! <- Back-substitute, thus solving for q
sumq=q(1:n-1)+q(2:n)   ! <-pairwise sums of derivatives, q:

! The minimizing energy can now be evaluated as a sum of only 2 terms:
en=o2*(dot_product(difp**2,cpp)+dot_product(sumq,cqp))

! Finally, evaluate the 3rd-derivative "jumps", j, at each node:
! Here, sb is the 3rd-derivative at the right end, sa that at the left end,
! of whichever interval is under consideration, but for interior intervals,
! sa = sap+q(i) and sb=sap+q(i+1).
sb=q(1)
do i=1,n-1
   ip=i+1
   x=o2*(xs(ip)-xs(i))
   xcmsx2=xcms(x)*2
   ch=cosh(x);  sh=sinh(x)
   sap=(sh*sumq(i)-ch*difp(i))/xcmsx2
   sa=sap+q(i)
   j(i)=sa-sb
   sb  =sap+q(ip)
enddo
j(n)=q(n)-sb ! Final "sa" is just q(n) for the right exterior
end subroutine fit_tspline
  
!=============================================================================
subroutine int_tspline(n,xs,p,q, m)!                             [int_tspline]
!=============================================================================
! Take the sets of n parameters p and q of the tensioned spline
! and return the values of its integral at the n-1 interval midpoints, and
! the value at the last node, assuming that the integral at the first node
! is set to zero.
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),dimension(n),intent(out):: m
!-----------------------------------------------------------------------------
real(dp):: a,b,c,d,e,t2,x,pa,pd,qa,qd,shx,chmx,shmx,chmmx,xcmsx
integer :: i,ip
!=============================================================================
! e is the running integral as we loop over successive nodes, so it starts out
! zero at the first node:
e=u0
! Loop over intervals:
do i=1,n-1
   ip=i+1
   x=(xs(ip)-xs(i))*o2 !<- interval half-width
   t2=x*x*o2
   shx  =sinh  (x)
   chmx =coshm (x)
   shmx =sinhm (x)
   chmmx=coshmm(x)
   xcmsx=xcms  (x)
   pa=(p(ip)+p(i))*o2
   pd=(p(ip)-p(i))*o2/x
   qa=(q(ip)+q(i))*o2
   qd=(q(ip)-q(i))*o2/shx
! a,b,c,d are analogous to the Taylor coefficients of a cubic about the 
! interval midpoint, but more precisely, c and d relate to basis functions
! coshm and sinhm (instead of x**2/2 and x**3/6 for the perfect cubic).
   c=qd
   a=pa-c*chmx
   d=(qa-pd)*x/xcmsx
   b=qa-d*chmx
   m(i)=e+a*x -b*t2 +c*shmx -d*chmmx
   e=e+2*(a*x+c*shmx)
enddo
m(n)=e
end subroutine int_tspline

!============================================================================
subroutine fit_guspline(n,xs,ys,on,q,j,yac,en,FF)!              [fit_uspline]
!============================================================================
! Fit the gappy untensioned spline, where only those nodes flagged "on"
! are effective in the fitting procedure. Owing to the fact that, where
! constraints are not "on" the spline will generally depart from ys, the
! actual y (yac) is returned for all nodes, regardless of the partial
! duplication with the given ys. In other respects, this is just
! like fit_tspline.
!============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,ys
logical, dimension(n),intent(in ):: on
real(dp),dimension(n),intent(out):: q,j,yac
real(dp),             intent(out):: en
logical,              intent(out):: FF
!----------------------------------------------------------------------------
real(dp),dimension(n):: xa,ya,qa,ja
integer              :: i,k,m
!============================================================================
m=0
do i=1,n
   if(on(i))then; m=m+1; xa(m)=xs(i); ya(m)=ys(i); endif
enddo
call fit_uspline(m,xa(1:m),ya(1:m),qa(1:m),ja(1:m),en,FF)
if(FF)then
   write(41,*) 'In fit_guspline; failure flag raised at call to fit_uspline'
   return
endif
k=0
do i=1,n
   if(on(i))then
      k=k+1
      q(i)=qa(k)
      j(i)=ja(k)
      yac(i)=ys(i)
   else
      call eval_usplined(m,xa(1:m),ya(1:m),qa(1:m),xs(i), yac(i),q(i))
      j(i)=0
   endif
enddo
end subroutine fit_guspline

!=============================================================================
subroutine fit_uspline(n,xs,p,q,j,en,FF)!                        [fit_uspline]
!=============================================================================
! Solve for the coefficients, the 3rd-derivative jumps, and the energy,
! of the untensioned (cubic) spline passing through the n nodes at (xs,p).
!
! The algorithm follows the pattern given in fit_tspline, except that the
! hyperbolic functions are all replaced by their asymptotic (x--> 0) limiting
! forms. These limiting forms are as follows:
! cosh(x) --> 1
! sinh(x) --> x
! coshm(x) --> x**2/2
! sinhm(x) --> x**3/6
! xcms(x)  --> x**3/3
!=============================================================================
use pietc, only: o3
use pmat2, only: ldltb, ltdlbv
integer,                intent(in ):: n
real(dp),dimension(  n),intent(in ):: xs,p
real(dp),dimension(  n),intent(out):: q,j
real(dp),               intent(out):: en
logical,                intent(out):: FF
!----------------------------------------------------------------------------
integer                   :: i,ip
real(dp)                  :: x,x2,sa,sb,ccc,xcmsx2
real(dp),dimension(n-1)   :: difp,sumq,cpp,cqp
real(dp),dimension(n,-1:0):: qq ! <- Tridiagonal, stored as rows of nonupper
!=============================================================================
FF=F
if(n<1)stop 'In fit_uspline; size of data array must be positive'
if(n==1)then; q=0; j=0; en=0; return; endif
! apply a strict monotonicity check on the xs:
do i=2,n
   if(xs(i-1)>=xs(i)) then
      FF=T
      write(41,*) 'In fit_uspline; xs data must increase strictly monotonically'
      return
   end if
enddo
! Initialize tri-diagonal kernels for the energy definition:
qq=0 ! <- initialize symmetric tridiagonal, kernel for q^T*QQ*q
     ! where "q" are the dp/dx at each node.
! The coefficients in the quadratic form defining the spline energy also
! include terms involving factors (p(ip)-p(i))*(q(i)+q(ip)) and
! (p(ip)-p(i))*(p(ip)-p(i)), but these can be dealt with using, respectively,
! the  matrices cqp and cpp which are simply diagonal. It is the symmetries
! in the defiition of energy that allow this simplification.

! Loop over the intervals bounded by consecutive nodes:
do i=1,n-1
   ip=i+1
   difp(i)=p(ip)-p(i)
   x2=xs(ip)-xs(i); x=o2*x2! Width, and halfwidth of interval
   xcmsx2=o3*x**3*2

! ccc is the coefficient of energy integral coupling g(i)*g(i) and g(ip)*g(ip)
   ccc=2/x
   cpp(i)=u1/xcmsx2         ! Energy coefficient for difp(i)*difp(i)...
   cqp(i)=-difp(i)*x/xcmsx2 ! ..and for difp(i)*sumq(i)
   qq(i,0)=qq(i,0)+ccc; qq(ip,-1)=qq(ip,-1)+1/x; qq(ip,0)=qq(ip,0)+ccc
enddo
! There is NO exterior energy contributions to qq at both ends:

! Temporarily, q is made the vector of forcings in the tridiagonal linear
! system from which the final spline coefficients, q, are solved in place.
q(1:n-1)=-cqp; q(n)=0
q(2:n)=q(2:n)-cqp

! The following 2 lines solve the tridiagonal system for q:
call ldltb(n,1,qq)    ! <- Decompose qq into factors, L*(1/D)*L^T, L=lower
call ltdlbv(n,1,qq,q) ! <- Back-substitute, thus solving for q
sumq=q(1:n-1)+q(2:n)  ! <-pairwise sums of derivatives, q:

! The minimizing energy can now be evaluated as a sum of only 2 terms:
en=o2*(dot_product(difp**2,cpp)+dot_product(sumq,cqp))

! Finally, evaluate the 3rd-derivative "jumps", j, at each node:
! Here, sb and sa are the 3rd-derivatives in consecutive intervals
sb=0
do i=1,n-1
   ip=i+1
   x=o2*(xs(ip)-xs(i))
   xcmsx2=o3*x**3*2
   sa=(x*sumq(i)-difp(i))/xcmsx2
   j(i)=sa-sb
   sb  =sa
enddo
j(n)=-sb ! Final "sa" is just 0 for the right exterior
end subroutine fit_uspline
  
!=============================================================================
subroutine int_uspline(n,xs,p,q, m)!                             [int_uspline]
!=============================================================================
! Take the sets of n parameters p and q of the untensioned cubic spline
! and return the values of its integral at the n-1 interval midpoints, and
! the value at the last node, assuming that the integral at the first node
! is set to zero.
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),dimension(n),intent(out):: m
!-----------------------------------------------------------------------------
real(dp),parameter:: u3o2=3*o2
real(dp):: a,b,c,d,e,t2,t3,t4,x,pa,pd,qa,qd
integer :: i,ip
!=============================================================================
! e is the running integral as we loop over successive nodes, so it starts out
! zero at the first node:
e=u0
! Loop over intervals:
do i=1,n-1
   ip=i+1
   x=(xs(ip)-xs(i))*o2 !<- interval half-width
   t2=x*x/2
   t3=t2*x/3
   t4=t3*x/4
   pa=(p(ip)+p(i))*o2
   pd=(p(ip)-p(i))*o2/x
   qa=(q(ip)+q(i))*o2
   qd=(q(ip)-q(i))*o2/x
! a,b,c,d are the Taylor coefficients of the cubic about the interval midpoint:
   c=qd
   a=pa-c*t2
   d=(qa-pd)*u3o2/t2
   b=qa-d*t2
   m(i)=e+a*x-b*t2+c*t3-d*t4
   e=e+2*(a*x+c*t3)
enddo
m(n)=e
end subroutine int_uspline

!=============================================================================
subroutine eval_tspline(n,xs,p,q, x,y)!                         [eval_tspline]
!=============================================================================
! Assuming the 1st derivatives, q, are correctly given at the n nodes, xs,
! of the standardized tensioned spline, where p are the nodal values, 
! evaluate the spline function y at the location x.
! First find the nonvanishing interval in which x resides, then expand
! y using basis functions implied by the interval-end values of p and q
! using the interval midpoint as local origin when x is interior, or the
! single interval endpoint when it is exterior.
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm
!============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=p(1)+q(1)*expm( xr); return; endif
if(x>=xs(n))then; xr=x-xs(n); y=p(n)-q(n)*expm(-xr); return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2   ! <- halfwidth of interval
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2     ! average of end values
qm=(p(ib)-p(ia))/(xh*2) ! average gradient
qah=q(ia)*o2; qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=sinh(xh);   chh=cosh(xh)
sh =sinh(xr);    ch=cosh(xr)
shm=sinhm(xr);  chm=coshm(xr)
shhm=sinhm(xh); chhm=coshm(xh)
xcmsh=xcms(xh)
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm) +  qxh*(xh*shm-xr*shhm)
end subroutine eval_tspline
   
!=============================================================================
subroutine eval_tsplined(n,xs,p,q, x,y,dydx)!                   [eval_tspline]
!=============================================================================
! Like eval_tspline, but also return the derivative dy/dx
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y,dydx
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm,&
           qemxr
!============================================================================
if(x<=xs(1))then
   xr=x-xs(1); qemxr=q(1)*expm( xr); y=p(1)+qemxr; dydx=qemxr+q(1); return
endif
if(x>=xs(n))then
   xr=x-xs(n); qemxr=q(n)*expm(-xr); y=p(n)-qemxr; dydx=qemxr+q(n); return
endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit    ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2 ! <- halfwidth of interval
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2   ! average of end values
qm=(p(ib)-p(ia))/(xh*2) ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=sinh(xh);   chh=cosh(xh)
sh =sinh(xr);   ch=cosh(xr)
shm=sinhm(xr);  chm=coshm(xr)
shhm=sinhm(xh); chhm=coshm(xh)
xcmsh=xcms(xh)
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm)  +  qxh*(xh*shm-xr*shhm)
dydx=qm+qdh*sh +qxh*(xh*chm-shhm)
end subroutine eval_tsplined

!=============================================================================
subroutine eval_tsplinedd(n,xs,p,q, x,y,dydx,ddydxx)!           [eval_tspline]
!=============================================================================
! Like eval_tspline, but also return the derivative dy/dx
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y,dydx,ddydxx
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm,&
           qemxr
!============================================================================
if(x<=xs(1))then
   xr=x-xs(1); qemxr=q(1)*expm( xr); y=p(1)+qemxr; dydx=qemxr+q(1)
   ddydxx=dydx; return
endif
if(x>=xs(n))then
   xr=x-xs(n); qemxr=q(n)*expm(-xr); y=p(n)-qemxr; dydx=qemxr+q(n)
   ddydxx=-dydx; return
endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit    ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2 ! <- halfwidth of interval
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2   ! average of end values
qm=(p(ib)-p(ia))/(xh*2) ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=sinh(xh);   chh=cosh(xh)
sh =sinh(xr);   ch=cosh(xr)
shm=sinhm(xr);  chm=coshm(xr)
shhm=sinhm(xh); chhm=coshm(xh)
xcmsh=xcms(xh)
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm)  +  qxh*(xh*shm-xr*shhm)
dydx=qm+qdh*sh +qxh*(xh*chm-shhm)
ddydxx=qdh*ch +qxh*xh*sh
end subroutine eval_tsplinedd

!=============================================================================
subroutine eval_tsplineddd(n,xs,p,q, x,y,dydx,ddydxx,dddydxxx)! [eval_tspline]
!=============================================================================
! Like eval_tspline, but also return the derivative dy/dx
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y,dydx,ddydxx,dddydxxx
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm,&
           qemxr
!============================================================================
if(x<=xs(1))then
   xr=x-xs(1); qemxr=q(1)*expm( xr); y=p(1)+qemxr; dydx=qemxr+q(1)
   ddydxx=dydx; dddydxxx=dydx; return
endif
if(x>=xs(n))then
   xr=x-xs(n); qemxr=q(n)*expm(-xr); y=p(n)-qemxr; dydx=qemxr+q(n)
   ddydxx=-dydx; dddydxxx=dydx; return
endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit    ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2 ! <- halfwidth of interval
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2   ! average of end values
qm=(p(ib)-p(ia))/(xh*2) ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=sinh(xh);   chh=cosh(xh)
sh =sinh(xr);   ch=cosh(xr)
shm=sinhm(xr);  chm=coshm(xr)
shhm=sinhm(xh); chhm=coshm(xh)
xcmsh=xcms(xh)
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y       =pm+xr*qm +qdh*(chm-chhm)  +  qxh*(xh*shm-xr*shhm)
dydx    =      qm +qdh*sh          +  qxh*(xh*chm-   shhm)
ddydxx  =          qdh*ch          +  qxh* xh*sh
dddydxxx=          qdh*sh          +  qxh* xh*ch
end subroutine eval_tsplineddd

!=============================================================================
subroutine eval_itspline(n,xs, p,q,m,  x,y)!                   [eval_itspline]
!=============================================================================
! Evaluate the integrated tension spline at x, returning the value, y.
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q,m
real(dp),             intent(in ):: x
real(dp),             intent(out):: y
!-----------------------------------------------------------------------------
real(dp):: a,b,c,d,t2,xh,shx,chmx,shmx,chmmx,xcmsx,xr,pa,pd,qa,qd
integer :: ia,ib
!=============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=     p(1)*xr+q(1)*expmm( xr); return; endif
if(x>=xs(n))then; xr=x-xs(n); y=m(n)+p(n)*xr+q(n)*expmm(-xr); return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2   ! <- halfwidth of interval
shx =sinh (xh)
chmx=coshm(xh)
xcmsx=xcms(xh)
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
pa=(p(ib)+p(ia))*o2
pd=(p(ib)-p(ia))*o2/xh
qa=(q(ib)+q(ia))*o2
qd=(q(ib)-q(ia))*o2/shx
! a,b,c,d are analogous to the Taylor coefficients about the interval midpoint
c=qd
a=pa-c*chmx
d=(qa-pd)*xh/xcmsx
b=qa-d*chmx

t2=xr**2/2
shmx =sinhm (xr)
chmmx=coshmm(xr)
y=m(ia)+a*xr+b*t2+c*shmx+d*chmmx
end subroutine eval_itspline

!=============================================================================
subroutine eval_uspline(n,xs,p,q, x,y)!                         [eval_uspline]
!=============================================================================
! Assuming the 1st derivatives, q, are correctly given at the n nodes, xs,
! of the standardized untensioned spline, where p are the nodal values, 
! evaluate the (UNtensioned) spline function y at the location x.
! First find the nonvanishing interval in which x resides, then expand
! y using basis functions implied by the interval-end values of p and q
! using the interval midpoint as local origin when x is interior, or the
! single interval endpoint when it is exterior.
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm
!============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=p(1)+q(1)*xr; return; endif
if(x>=xs(n))then; xr=x-xs(n); y=p(n)+q(n)*xr; return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2   ! <- halfwidth of interval
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2     ! average of end values
qm=(p(ib)-p(ia))/(xh*2) ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=xh;        chh=u1
sh =xr;        ch =u1
shm =xr**3/6;  chm =xr**2*o2
shhm=xh**3/6;  chhm=xh**2*o2
xcmsh=xh**3/3
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm) +  qxh*(xh*shm-xr*shhm)

end subroutine eval_uspline
   
!=============================================================================
subroutine eval_usplined(n,xs,p,q, x,y,dydx)!                   [eval_uspline]
!=============================================================================
! Like eval_uspline, but also return the derivative dy/dx
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y,dydx
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm
!============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=p(1)+q(1)*xr; dydx=q(1); return; endif
if(x>=xs(n))then; xr=x-xs(n); y=p(n)+q(n)*xr; dydx=q(n); return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2    ! <- halfwidth of interval
xr=x-xs(ia)-xh           ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2      ! average of end values
qm=(p(ib)-p(ia))/(xh*2) ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=xh;        chh=u1
sh =xr;        ch =u1
shm =xr**3/6;  chm =xr**2*o2
shhm=xh**3/6;  chhm=xh**2*o2
xcmsh=xh**3/3
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm)  +  qxh*(xh*shm-xr*shhm)
dydx=qm+qdh*sh +qxh*(xh*chm-shhm)
end subroutine eval_usplined

!=============================================================================
subroutine eval_usplinedd(n,xs,p,q, x,y,dydx,ddydxx)!           [eval_uspline]
!=============================================================================
! Like eval_uspline, but also return the derivative dy/dx
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y,dydx,ddydxx
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm
!============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=p(1)+q(1)*xr; dydx=q(1); return; endif
if(x>=xs(n))then; xr=x-xs(n); y=p(n)+q(n)*xr; dydx=q(n); return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2    ! <- halfwidth of interval
xr=x-xs(ia)-xh           ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2      ! average of end values
qm=(p(ib)-p(ia))/(xh*2)  ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=xh;        chh=u1
sh =xr;        ch =u1
shm =xr**3/6;  chm =xr**2*o2
shhm=xh**3/6;  chhm=xh**2*o2
xcmsh=xh**3/3
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm)  +  qxh*(xh*shm-xr*shhm)
dydx=qm+qdh*sh +qxh*(xh*chm-shhm)
ddydxx=qdh +qxh*xh*sh
end subroutine eval_usplinedd

!=============================================================================
subroutine eval_usplineddd(n,xs,p,q, x,y,dydx,ddydxx,dddydxxx)! [eval_uspline]
!=============================================================================
! Like eval_uspline, but also return the derivative dy/dx
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q
real(dp),             intent(in ):: x
real(dp),             intent(out):: y,dydx,ddydxx,dddydxxx
!----------------------------------------------------------------------------
integer :: ia,ib
real(dp):: xr,xh,pm,qm,qah,qbh,qxh,qdh,shh,chh,sh,ch,xcmsh,shm,chm,shhm,chhm
!============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=p(1)+q(1)*xr; dydx=q(1); return; endif
if(x>=xs(n))then; xr=x-xs(n); y=p(n)+q(n)*xr; dydx=q(n); return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2    ! <- halfwidth of interval
xr=x-xs(ia)-xh           ! <- x relative to interval midpoint
pm=(p(ia)+p(ib))*o2      ! average of end values
qm=(p(ib)-p(ia))/(xh*2)  ! average gradient
qah=q(ia)*o2;  qbh=q(ib)*o2
qxh=qah+qbh-qm ! Half the total excess q at interval ends
qdh=qbh-qah    ! Half the difference of q at interval ends
shh=xh;        chh=u1
sh =xr;        ch =u1
shm =xr**3/6;  chm =xr**2*o2
shhm=xh**3/6;  chhm=xh**2*o2
xcmsh=xh**3/3
qdh=qdh/shh; qxh=qxh/xcmsh ! <- rescale qdh, qxh
y=pm+xr*qm +qdh*(chm-chhm)  +  qxh*(xh*shm-xr*shhm)
dydx=qm+qdh*sh +qxh*(xh*chm-shhm)
ddydxx=qdh +qxh*xh*sh
dddydxxx=qxh*xh
end subroutine eval_usplineddd

!=============================================================================
subroutine eval_iuspline(n,xs, p,q,m,  x,y)!                   [eval_iuspline]
!=============================================================================
! Evaluate the integrated untensioned spline at x, returning the value, y.
!=============================================================================
integer,              intent(in ):: n
real(dp),dimension(n),intent(in ):: xs,p,q,m
real(dp),             intent(in ):: x
real(dp),             intent(out):: y
!-----------------------------------------------------------------------------
real(dp),parameter:: u3o2=3*o2
real(dp):: a,b,c,d,t2,t3,t4,xh,xr,pa,pd,qa,qd
integer :: ia,ib
!=============================================================================
if(x<=xs(1))then; xr=x-xs(1); y=p(1)*xr+q(1)*xr**2/2; return; endif
if(x>=xs(n))then; xr=x-xs(n); y=m(n)+p(n)*xr+q(n)*xr**2/2; return; endif
do ib=2,n
   if(xs(ib)<=xs(ib-1))cycle ! <- only consider intervals of positive width
   if(xs(ib)>=x)exit ! <- exit once finite interval straddling x is found
enddo
ia=ib-1
xh=(xs(ib)-xs(ia))*o2   ! <- halfwidth of interval
xr=x-xs(ia)-xh          ! <- x relative to interval midpoint
t2=xh**2/2
t3=t2*xh/3
pa=(p(ib)+p(ia))*o2
pd=(p(ib)-p(ia))*o2/xh
qa=(q(ib)+q(ia))*o2
qd=(q(ib)-q(ia))*o2/xh
! a,b,c,d are the Taylor coefficients of the cubic about the interval midpoint:
c=qd
a=pa-c*t2
d=(qa-pd)*u3o2/t2
b=qa-d*t2
t2=xr**2/2
t3=t2*xr/3
t4=t3*xr/4
y=m(ia)+a*xr+b*t2+c*t3+d*t4
end subroutine eval_iuspline

!==============================================================================
subroutine best_tslalom(nh,mh,doru,hgts,hs,halfgate,bigT, & !     [best_slalom]
   hgtp,hp,qbest,yabest,enbest,modebest,maxita,maxitb,maxit,maxrts,FF)
!==============================================================================
! Run through the different allowed routes between the slalom gates and
! select as the final solution the one whose spline has the smallest "energy".
!==============================================================================
integer,                 intent(in   ):: nh,mh,doru
integer, dimension(nh),  intent(in   ):: hgts
real(dp),dimension(nh),  intent(in   ):: hs
real(dp),                intent(in   ):: halfgate,bigT
integer, dimension(mh*2),intent(  out):: hgtp
real(dp),dimension(mh*2),intent(  out):: hp
real(dp),dimension(mh*2),intent(  out):: qbest
real(dp),dimension(mh*2),intent(  out):: yabest
real(dp),                intent(  out):: enbest
integer,dimension(mh),   intent(  out):: modebest
integer,                 intent(inout):: maxita,maxitb,maxit,maxrts
logical,                 intent(  out):: FF
!-----------------------------------------------------------------------------
integer, dimension(2,mh)  :: hgtn
real(dp),dimension(mh*2)  :: q,ya
real(dp),dimension(2,2,mh):: hn
real(dp)                  :: en,tspan,hspan,enbase,hgbigT
integer, dimension(mh)    :: code,mode
integer, dimension(mh*2)  :: bend
integer                   :: i,k,m,route_count,ita,ittot
logical, dimension(mh*2)  :: off
logical                   :: flag,descending
!==============================================================================
m=mh*2
call set_gates(nh,mh,doru,hgts,hs, hgtn,hn,code,FF)
! Examine gate posts of first and last slalom gate to determine whether
! profile is predominantly descending or ascending:
if    (hn(1,2,1)>hn(1,1,mh))then; descending=T ! definitely descending
elseif(hn(2,2,1)<hn(2,1,mh))then; descending=F ! definitely ascending
else ! Ambiguous profile -- decide by invoking the tie-breaker, doru:
   descending=(doru==1)
endif
hgbigT=bigT/halfgate ! bigT in nondimensional halfgate units
tspan=(hgtn(2,mh)-hgtn(1,1))/hgbigT
if(descending)then; hspan=(hn(1,1,1)-hn(1,2,mh))! Descending case:
else              ; hspan=(hn(2,2,mh)-hn(2,1,1))! Ascending case:
endif
enbase=enbase_t(tspan,hspan) ! Baseline energy by which en is rescaled
if(FF)then
   write(41,*) 'In best_tslalom; failure flag was raised in call to set_gates'
   return
endif
call count_routes(mh,code,route_count,FF)
maxrts=max(maxrts,route_count)
if(FF)then
   write(41,*)&
        'In best_tslalom; failure flag was raised in call to count_routes'
   return
endif
if(route_count>4)call list_routes(mh,code) ! Only bother to list them when >4
enbest=hu
flag=T
do k=1,ihu
   call next_route(mh,code,mode,flag)
   if(flag)then; flag=F; exit; endif
   call set_posts(mh,mode,hgtn,hn,bend,hgtp,hp,off)
   call slalom_tspline(m,bend,hgtp,hp,off,hgbigT, &
        q,ya,en,ita,maxitb,ittot,FF); en=en/enbase
   maxita=max(maxita,ita)
   maxit =max(maxit,ittot)
   if(FF)then
      write(41,*) &
           'In best_tslalom; failure flag was raised in call to slalom_tspline'
      return
   endif
   if(en<enbest)then
      modebest=mode
      enbest  =en
      qbest   =q
      yabest  =ya
   endif
enddo
end subroutine best_tslalom
!==============================================================================
subroutine best_uslalom(nh,mh,doru,hgts,hs,halfgate,  & !         [best_slalom]
     hgtp,hp,qbest,yabest,enbest,modebest,maxita,maxitb,maxit,maxrts,FF)
!==============================================================================
! Like best_tslalom, except this treats the special limiting case where the
! spline tension vanishes
!==============================================================================
integer,                 intent(in   ):: nh,mh,doru
integer, dimension(nh),  intent(in   ):: hgts
real(dp),dimension(nh),  intent(in   ):: hs
real(dp),                intent(in   ):: halfgate
integer, dimension(mh*2),intent(  out):: hgtp
real(dp),dimension(mh*2),intent(  out):: hp
real(dp),dimension(mh*2),intent(  out):: qbest
real(dp),dimension(mh*2),intent(  out):: yabest
real(dp),                intent(  out):: enbest
integer,dimension(mh),   intent(  out):: modebest
integer,                 intent(inout):: maxita,maxitb,maxit,maxrts
logical,                 intent(  out):: FF
!-----------------------------------------------------------------------------
integer, dimension(2,mh)  :: hgtn
real(dp),dimension(mh*2)  :: q,ya
real(dp),dimension(2,2,mh):: hn
real(dp)                  :: en
integer, dimension(mh)    :: code,mode
integer, dimension(mh*2)  :: bend
integer                   :: i,k,m,route_count,ita,ittot
logical, dimension(mh*2)  :: off
logical                   :: flag
!==============================================================================
m=mh*2
call set_gates(nh,mh,doru,hgts,hs, hgtn,hn,code,FF)
if(FF)then
   write(41,*) 'In best_uslalom; failure flag was raised in call to set_gates'
   return
endif
call count_routes(mh,code,route_count,FF)
maxrts=max(maxrts,route_count)
if(FF)then
   write(41,*)&
        'In best_uslalom; failure flag was raised in call to count_routes'
   return
endif
if(route_count>4)call list_routes(mh,code)! Only bother to list them when >4
enbest=hu
flag=T
do k=1,ihu
   call next_route(mh,code,mode,flag)
   if(flag)then; flag=F; exit; endif
   call set_posts(mh,mode,hgtn,hn,bend,hgtp,hp,off)
   call slalom_uspline(m,bend,hgtp,hp,off,halfgate, q,ya,en,ita,maxitb,ittot,FF)
   maxita=max(maxita,ita)
   maxit =max(maxit,ittot)
   if(FF)then
      write(41,*) &
           'In best_uslalom; failure flag was raised in call to slalom_uspline'
      return
   endif
   if(en<enbest)then
      modebest=mode
      enbest  =en
      qbest   =q
      yabest  =ya
   endif
enddo
end subroutine best_uslalom

!=============================================================================
subroutine count_gates(nh,hgts,mh)!                                [count_gates]
!=============================================================================
! Count the number of distinct "time gates" that can accommodate all the data
! from the given profile. This gate count is mh.
!=============================================================================
integer,              intent(in ):: nh
integer,dimension(nh),intent(in ):: hgts
integer,              intent(out):: mh
!-----------------------------------------------------------------------------
integer:: hgtp
integer:: i
!=============================================================================
hgtp=hgts(1)-1 ! <- default "time at present" in units of halfgate
mh=0
do i=1,nh
   if(hgts(i)<=hgtp)cycle
! A new nominal time of observation:
   mh=mh+1
   hgtp=hgts(i)
enddo
end subroutine count_gates

!=============================================================================
subroutine set_gates(nh,mh,doru,hgts,hs, hgtn,hn,code,FF)!         [set_gates]
!=============================================================================
! Be sure to precede this routine by a call to "count_gates" to get a
! consistent tally of the number of time gates, mh.
! Set the locations of the "gateposts" and the routing codes of allowed
! trajectories that thread through them.
! Halfgate is half the (temporal) gate width (in seconds)
! The "inferior" gatepost is at hgts - 1, the "superior" at hgts + 1.
! The aggregated data lead to a tally of gates not exceeding the tally of obs.
! the gatepost times of the aggregated data are put into array hgtn(:,:) where
! hgtn(1,:) hold the inferior, and hgtn(2,:) the superior gatepost times, in
! units of halfgate.
! In general, it is not known a priori whether the trajectory will end up
! ascending or descending though a given gate, so both alternatives are
! accounted for, with hn(:,1,:) holding the height corresponding to tn(:,:)
! assuming descending passage; hn(:,2:) likewise assuming ascending passage.
! A running "attitude code" is maintained, atti between gates i-1 and i, and
! the previous attitude code, attim between gates i-2 and i-1, where applicable.
! This code is =2 when the later gate is wholly above the earlier, =1, when
! later is wholly below the earlier, and remains 0 when altitudes of 
! the consecutive gates overlap. When the consecutive attitude codes are
! both =2, we force the mode of passage through gate i-1 to be ascending (route
! code = 8) if its route code has not already been determined by one of the
! overriding contact conditions imposed by temporal contact between gate i-1
! and its predecessor. Likewise, if consecutive attitude codes are both =1,
! we force the mode of passage through gate i-1 to be descending (route code
! 4) unless overridden by a previous temporal contact condition.
! Temporal contact conditions between gates i-1 and i force one of three
! route codes at gate i: =2 when gate i is wholly above gate i-1; =3 when
! gate i is wholly below; =5 when the gate height ranges overlap. 
!
! The purpose of the route code is to specify the possible modes of passage
! (descending, ascending, or either of these alternatives) through gate i
! when the actual mode of passage through the preceeding gate is known. It is
! based on a 2-digit trinary code. The possible modes of passage through
! gate i are enumerated by the "option code" whose values are:
! 0 when passage may be either descending or ascending (indeterminate);
! 1 when passage is definitely descending;
! 2 when passage is definitely ascending.
! The "units" digit of the trinary expansion of the route code gives the
! option code for gate i when passage through gate i-1 is prescribed to be
! DESCENDING; the "threes" digit of the trinary expansion of the route code
! gives the option code for gate i when passage through gate i-1 is 
! prescribed to be ASCENDING. These possibilities for the option code for
! gate i are summarized in the table below.
!
!    Route        ;   DESCENDING at (i-1)   ;   ASCENDING at (i-1)
!   Code(i)       ;   ==> Option code(i)    ;   ==> Option Code(i)
!............................................................................
!      0                     0                        0
!      2                     2                        0
!      3                     0                        1
!      4                     1                        1
!      5                     2                        1
!      8                     2                        2
!............................................................................. 
!
! The first route code in a chain of gates, ie., code(1), is alway set
! to 0, so at the very least, two combinations of routes are always coded
! according as whether we choose to initialize the spline solution with
! descent through gate 1 or an ascent. If all the gates are temporally 
! separated, then then final gate's route_code also has this 0 value
! signifying an indeterminate mode of passage.
! 
! In the special case where mh=1 and the given hs data are not enough to
! decide whether this trajectory is descending or ascending, the tie-breaker
! code, doru ("down or up") forces the sense of the trajectory as follows:
! doru=1 ==> descending
! doru=2 ==> ascending
!=============================================================================
integer,                   intent(in ):: nh,mh,doru
integer, dimension(nh),    intent(in ):: hgts
real(dp),dimension(nh),    intent(in ):: hs
integer, dimension(2,  mh),intent(out):: hgtn
real(dp),dimension(2,2,mh),intent(out):: hn
integer, dimension(    mh),intent(out):: code
logical,                   intent(out):: FF
!-----------------------------------------------------------------------------
real(dp):: hp
integer :: i,im,i2,i2m,imh,n,atti,attim,codeim,hgtp
!=============================================================================
FF=F
n=nh*2
hgtp=hgts(1)-1 ! <- default "time at present" in units of halfgate
imh=0
do i=1,nh
   i2=i*2
   i2m=i2-1
   hp=hs(i)
   if(hgts(i)>hgtp)then
! A new nominal time of observation:
      imh=imh+1
      hgtp=hgts(i)
      hgtn(1,imh)=hgtp-1
      hgtn(2,imh)=hgtp+1
      hn(:,:,imh)=hp
   elseif(hgts(i)<hgtp) then
      FF=T
      write(41,*) 'In set_gates; data are not temporally monotonic'
      return
   else
! The same nominal time of observation:      
      hn(1,1,imh)=max(hn(1,1,imh),hp)
      hn(1,2,imh)=min(hn(1,2,imh),hp)
      hn(2,2,imh)=max(hn(2,2,imh),hp)
      hn(2,1,imh)=min(hn(2,1,imh),hp)
   endif
enddo
if(imh/=mh)stop 'In set_gates; inconsistent gate tallies, imh and mh'
! When consecutive gates' post times overlap, adjust their hn if the height
! ranges also overlap:
if(mh==1)then
   code(1)=4*doru
   return
endif
attim=0
code=0 ! <- Default code implies switchable independently for each i
codeim=9 ! <- arbitrary nonzero number
do i=2,mh
   atti=0 ! (default, until we learn anything more definite)
   im=i-1
   if(hgtn(1,i)<=hgtn(2,im))then
! No intermission separates these consecutive gates, im and i:
      if(hn(2,2,im)<=hn(1,2,i))then
         atti=2 ! <-ascending attitude at common time
         code(i)=2
         if(attim==2.and.(codeim==0.or.codeim==2))code(im)=8
      elseif(hn(2,1,im)>=hn(1,1,i))then
         atti=1 ! <-descending attitude at common time
         code(i)=3
         if(attim==1.and.(codeim==0.or.codeim==3))code(im)=4
      else
! Overlapping, attitude at common time neither ascending nor descending,
! but sense of passage through gates must alternate (code=5).
         code(i)=5
         if(hn(2,1,im)<=hn(1,2,i))then; hn(1,2,i) =hn(2,1,im)
                                  else; hn(2,1,im)=hn(1,2,i)
         endif
         if(hn(2,2,im)<=hn(1,1,i))then; hn(2,2,im)=hn(1,1,i)
                                  else; hn(1,1,i) =hn(2,2,im)
         endif
      endif
   else
! Gates im and i separated by an intermission:
      if(hn(2,2,im)<=hn(1,2,i))then
         atti=2 ! <-ascending attitude at intermission
         if(attim==2.and.(codeim==0.or.codeim==2))code(im)=8
      elseif(hn(2,1,im)>=hn(1,1,i))then
         atti=1 ! <-descending attitude at intermission
         if(attim==1.and.(codeim==0.or.codeim==3))code(im)=4
      endif
   endif
   attim=atti
   codeim=code(i)
enddo
end subroutine set_gates

!=============================================================================
subroutine set_posts(mh,mode,hgtn,hn, bend,hgtp,hp,off)!           [set_posts]
!=============================================================================
! Given a set of mh double-gates (both descending and ascending types) and
! the array of actual passage modes (i.e., the actual route threading
! the sequence of gates), set the array of actual gateposts coordinates,
! hgtp and hp, and the corresponding set of signs, bend, by which these
! gatepost constraints, when activatived, must alter the principal
! changed derivative of the optimal spline taking the prescribed route.
! Also, flag (using logical array, "off") those gateposts that, for this
! particular route, are redundant owing to existence of duplication of 
! consecutive pairs of (hgtp,hp) sometimes occurring when no intermission
! separates consecutive gates. All times are in integer units of halfgate.
!=============================================================================
integer,                   intent(in ):: mh
integer, dimension(    mh),intent(in ):: mode
integer, dimension(2,  mh),intent(in ):: hgtn
real(dp),dimension(2,2,mh),intent(in ):: hn
integer, dimension(mh*2),  intent(out):: bend,hgtp
real(dp),dimension(mh*2),  intent(out):: hp
logical, dimension(mh*2),  intent(out):: off
!-----------------------------------------------------------------------------
real(dp):: hprev
integer :: i,i2,i2m,i2mm,im,modei,hgtprev
!=============================================================================
off=F
do i=1,mh
   im=i-1
   modei=mode(i)
   i2=i*2; i2m=i2-1; i2mm=i2-2
   hgtp(i2m)=hgtn(1,i)
   hgtp(i2 )=hgtn(2,i)
   hp(i2m)=hn(1,modei,i)
   hp(i2 )=hn(2,modei,i)
! Check whether gatepost duplications exist, or one dominates another at same t:
   if(i>1)then
      if(hgtprev==hgtp(i2m))then
         if(hprev==hp(i2m))off(i2m)=T
         if(mode(im)==2.and.modei==1)then
            if(hprev<=hp(i2m))then
               off(i2mm)=T
            else
               off(i2m)=T
            endif
         elseif(mode(im)==1.and.modei==2)then
            if(hprev<=hp(i2m))then
               off(i2m)=T
            else
               off(i2mm)=T
            endif
         endif
      endif
   endif
   bend(i2m)=modei*2-3 ! mode=1 ==> bend=-1; mode=2 ==> bend=+1 
   bend(i2 )=-bend(i2m)! mode=1 ==> bend=+1; mode=2 ==> bend=-1 
   hgtprev=hgtp(i2)
   hprev  =hp(i2)
enddo
end subroutine set_posts

!=============================================================================
subroutine count_routes(n,code,count,FF)!                       [count_routes]
!=============================================================================
! Given the route code array, "code", list all the allowed combinations
! of passage modes (descending === 1; ascending === 2) through the sequence
! of slalom gates.
!=============================================================================
integer,             intent(in ):: n
integer,dimension(n),intent(in ):: code
integer,             intent(out):: count
logical,             intent(out):: FF
!-----------------------------------------------------------------------------
integer,dimension(n):: mode
logical             :: flag
!============================================================================
FF=F
flag=T
do count=0,ihu; call next_route(n,code,mode,flag); if(flag)return; enddo
FF=(count>ihu)
if(FF) write(41,*) 'In count_routes; number of routes exceeds allowance = ',ihu
end subroutine count_routes

!=============================================================================
subroutine list_routes(n,code)!                                  [list_routes]
!=============================================================================
! Given the route code array, "code", list all the allowed combinations
! of passage modes (descending === 1; ascending === 2) through the sequence
! of slalom gates.
!=============================================================================
integer,             intent(in ):: n
integer,dimension(n),intent(in ):: code
!-----------------------------------------------------------------------------
integer,dimension(n):: mode
integer             :: i
logical             :: flag
!============================================================================
write(41,'("List all route combinations of ",i4," allowed passage modes")'),n
flag=T
do i=1,ihu
   call next_route(n,code,mode,flag)
   if(flag)then
      write(41,'(" In list_routes; List of routes complete")'); flag=F; exit
   endif
   write(41,60)i,mode
enddo
if(i>ihu) write(41,'("This list is not necessarily complete")')
60 format(i5,3x,6(2x,5i2))
end subroutine list_routes

!=============================================================================
subroutine next_route(n,code,mode,flag)!                          [next_route]
!=============================================================================
! Given the combinatoric specification of sequentially-conditional
! allowable modes of passage through the n gates encoded in array
! codes, and generically given the present sequence, modes, (a series of
! 1's and 2's denoting respectively descents and ascents through the gates)
! return the next allowed combination defining the updated modes. If instead,
! the intent is to initialize the sequence of modes, input the flag to "true" 
! and the first route (array of modes) will be returned (and the flag lowered 
! to "false").
! If there is no "next" route, the sequence having been already exhausted,
! the flag is raised to "true" on output and the route encoded in array,
! modes, is not meaningful.
! When, at gate i, the preceding gate's mode is "modeim" ( = modes(i-1)) 
! and the present gate's given route code is code=codes(i), the options
! for choosing mode(i) are encoded in the options code, 
! option = options(code,
!=============================================================================
integer,             intent(in   ):: n
integer,dimension(n),intent(in   ):: code
integer,dimension(n),intent(inout):: mode
logical,             intent(inout):: flag
!-----------------------------------------------------------------------------
integer,dimension(0:8,2):: options ! <- evaluates the trinary digit of code
integer,dimension(0:2)  :: firstmode
integer                 :: i,im,j,modeim,modejm,option
data options/0,1,2,0,1,2,0,1,2, 0,0,0,1,1,1,2,2,2/
data firstmode/1,1,2/
!=============================================================================
modeim=1 ! <-arbitrarily set mode of previous gate passage to "descent"
if(flag)then
! Initialize the route sequence and reset the flag:
   do i=1,n
      option=options(code(i),modeim)
      mode(i)=firstmode(option)
      modeim=mode(i)
   enddo
   flag=F
   return
endif

! Use the present route (array of "mode" elements), and the route code, 
! to find the next allowed route, or return with the flag raised when 
! no more allowed routes are to be found:
do i=n,1,-1
   im=i-1
   if(i>1)then
      modeim=mode(im)
   else
      modeim=1
   endif
   option=options(code(i),modeim)
   if(option>0.or.mode(i)==2)cycle
   mode(i)=2
   modejm=mode(i)
   do j=i+1,n
      option=options(code(j),modejm)
      mode(j)=firstmode(option)
      modejm=mode(j)
   enddo
   return
enddo
flag=T
end subroutine next_route

!=============================================================================
subroutine slalom_tspline(n,bend,hgxn,yn,off,bigX, &!         [slalom_tspline]
     q,ya,en,ita,maxitb,ittot,FF)                               
!=============================================================================
! Fit a tensioned spline, characteristic abscissa scale, bigX, between the
! "slalom gates" defined by successive pairs of abscissae, integer hgxn, and 
! corresponding ordinate values, real yn. Even number n is the total number
! of inequality constraints, or twice the number of gates. There is no
! assumed conditional monotonicity for the gates, but the sense in which
! they are threaded is encoded in the array of signs (-1 or +1), "bend"
! which determines, when activated, the sense in which the gatepost constraint
! changes the principal non-continuous derivative (generally 3rd derivative)
! of the spline. Some gatepost inequality constraints are disabled, as flagged
! by logical array, "off", when two consecutive gateposts constraints are
! identical.
! Subject to the linear inequality constraints, we seek the tensioned
! spline with characteristic scale, bigX, whose energy is minimized.
! The energy of the tensioned spline in the infinitesimal segment [x,x+dx]
! is proportional to half*{ (dy/dx)**2 + (bigT**2)*(ddy/dxx)**2 }*dx.
! The problem is therefore of the type: minimize a quadratic functional
! subject to finitely many (n) linear inequality constraints.
!
! The problem is first standardized by rescaling hgxn (to real xs=xn/bigX) so 
! that the characteristic scale becomes unity. We start with a feasible spline
! fitted (equality constraints) to as many of the constraints with distinct
! xs as we can. We "A" iterate from one such feasible, conditionally minimum-
! energy solution to another with a different set of equality constraints
! via an "B" iteration" as follows. The "A" solution generally may have
! constraints at the gateposts that are "pushing" when they should be
! "pulling" (specifically, the sign of the discontinuity in the spline's
! third derivative is the opposite of what it should be at that point). Take
! ALL such violations and, first,  simply switch them "off". In general, this
! will cause the energy of the spline to fall significantly, but the resulting
! spline may no longer thread all the slalom gates, so we will have to ADD
! some constraints via what we call the "B-iteration" (whereupon the energy
! increases again, but not to point where it was when we released the 
! constraints at this last A-iteration). In the spline's state space, the
! first of the new cycle of B-iterations back-tracks along the line-segment
! joining this new spline-state to the more constrained one we just departed,
! to the point on the spline-state-space segment where the solution becomes
! once again feasible. This involves adding just one more constraint where the
! spine just touches the inside of a slalom gatepost where it did not touch 
! before. This new contact is made a new constraint, the spline state is 
! recorded as the state reached at the 1st B-iteration, and a new spline
! solution is solved for. If, once again, the spline fails to thread the 
! gateposts, then in the next B-iteration, we back-track once again along a
! line segment in spline-space, but this time towards the state at the previous
! B-iteration. Again, we add a new constraint (which adds energy, but still 
! not so much that the energy exceeds that of the last A-iteration). We
! continue this process until we have added just enough new constraints to
! achieve a feasible (slalom-threading) spline. This cycle of B-iterations
! is thus complete and, in the generic case, the energy is still smaller
! than it was at the last A-iteration. But since the new configuration may
! be in violation of a new set of "jump-sign" violations, we must check
! whether another A-iteration is required -- and so on. The B-iterations
! are nested within the loop of A-iterations. To summarize: the A-iterations
! release the gatepost constraints where jump-sign violations occur and the
! energy between A-iterations decreases; the B-iterations activate new
! gatepost constraints to keep the spline between the gateposts, and the
! energy between B iterations increases. The process terminates when the
! jump-sign conditions are all satisfied in the generic case. However, we
! find that, in extremely rare and special cases of numerical coincidence,
! jump-sign condition is close enough to machine-zero to be ambiguous --
! and this seems to occur at the very last stage of the A-iterations. To
! allow for this very rare occurrence, we now check that the energy between
! A-iterations really IS decreasing and, if it is ever found not to be, we
! terminate the iteration anyway.
!
! In general, when the constraint of the final solution is not active, the
! value y of the spline differs from the yn there; it is therefore convenient
! to output what the actual y value of the spline is, which we do in the
! array, ya ("y actual").
!=============================================================================
integer,                intent(in   ):: n
integer, dimension(n),  intent(in   ):: bend,hgxn
real(dp),dimension(n),  intent(in   ):: yn
logical, dimension(n),  intent(in   ):: off
real(dp),               intent(in   ):: bigX
real(dp),dimension(n),  intent(  out):: q
real(dp),dimension(n),  intent(  out):: ya
real(dp),               intent(  out):: en
integer,                intent(  out):: ita,ittot
integer,                intent(inout):: maxitb
logical,                intent(  out):: FF
!-----------------------------------------------------------------------------
integer,parameter      :: nita=50,nitb=80
real(dp),dimension(n)  :: xs,jump,qt,yat
real(dp)               :: sj,sjmin,ena
integer                :: i,j,k,itb,hgxp
logical,dimension(n)   :: on
!=============================================================================
FF=F
! For algebraic convenience, work in terms of rescaled times, xs, of 
! the constraints whose given times, hgxn, are in integer units of halfgate
xs=hgxn/bigX

! Initialize the "A" iteration by fitting a feasible spline to as many
! "gateposts" as is possible with distinct xs. A constraint i is signified
! to be activated when logical array element, on(i), is true:
hgxp=hgxn(1)-1
do i=1,n
   if(off(i))then; on(i)=F; cycle; endif
   on(i)=(hgxn(i)>hgxp); if(on(i))hgxp=hgxn(i)
enddo
ittot=1
call fit_gtspline(n,xs,yn,on,qt,jump,yat,en,FF)! <- Make the initial fit
ena=en
if(FF)then
   write(41,*) 'In slalom_tspline; failure flag raised in call to fit_gtspline'
   write(41,*) 'at initialization of A loop'
   return
endif

! loop over steps of iteration "A" to check for jump-sign violations
do ita=1,nita
   q=qt   ! Copy solution vector q of nodal 1st-derivatives
   ya=yat ! Copy nodal intercepts

! Determine whether there exists sign-violations in any active "jumps"
! of the 3rd derviative and, if so, inactivate (on==F) the constraints
! at those points. Also, count the number, j, of such violations.
   j=0
   k=0
   sjmin=0
   do i=1,n
      if(.not.on(i))cycle
      sj=-bend(i)*jump(i)
      if(sj<0)then
         j=i
         on(i)=F
      else
         k=k+1 ! <- new tally of constraints switched "on"
      endif
   enddo
   if(j==0)exit !<-Proper conditions for a solution are met
   if(k==0)on(j)=T ! <- must leave at least one constraint "on"

! Begin a new "B" iteration that adds as many new constraints as needed
! to keep the new conditional minimum energy spline in the feasible region:
   do itb=1,nitb
      call fit_gtspline(n,xs,yn,on,qt,jump,yat,en,FF)
      if(FF)then
         write(41,*)&
              'In slalom_tspline; failure flag raised in call to fit_gtspline'
         write(41,*) 'at B loop, iterations ita,itb = ',ita,itb
         return
      endif
       ittot=ittot+1 ! Increment the running total of calls to fit_tspline

! Determine whether this "solution" wanders outside any slalom gates at
! the unconstrained locations and identify and calibrate the worst violation.
! In this case, sjmin, ends up being the under-relaxation coefficient
! by which we need to multiply this new increment in order to just stay
! within the feasible region of spline space, and constraint j must be
! switched "on":
      j=0
      sjmin=u1
      do i=1,n
         if(on(i).or.off(i))cycle
         sj=bend(i)*(yn(i)-yat(i))
         if(sj<0)then
            sj=(yn(i)-ya(i))/(yat(i)-ya(i))
            if(sj<sjmin)then
               j=i
               sjmin=sj
            endif
         endif
      enddo
      if(j==0)exit !<- spline is feasible, exit B loop and adopt solution as A

! Back off to best feasible solution along this path, which modulates the
! change just made by an underrelaxation factor, sjmin, and activate 
! constraint j
      ya=ya+sjmin*(yat-ya)
      q=q+sjmin*(qt-q)
      on(j)=T
   enddo ! itb loop
   maxitb=max(maxitb,itb)
   if(itb>nitb) then
      FF=T
      write(41,*) 'In slalom_tspline; exceeding the allocation of B iterations'
      return
   end if
   q=qt
   ya=yat
   if(en>=ena)then
      write(41,*) 'In slalom_tspline; energy failed to decrease'
      exit 
   endif
   ena=en
enddo ! ita loop
if(ita>nita)then
   FF=T
   write(41,*) 'In slalom_tspline; exceeding the allocation of A iterations'
   return
endif
end subroutine slalom_tspline

!=============================================================================
subroutine slalom_uspline(n,bend,hgxn,yn,off,halfgate,&!      [slalom_uspline]
     q, ya,en,ita,maxitb,ittot,FF)       
!=============================================================================
! Like slalom_tspline, except this treats the special case where the spline
! is untensioned, and therefore the characteristic scale in x become infinite,
! and the spline becomes piecewise cubic instead of involving hyperbolic
! (or exponential) function. In other respects, the logic follows that of
! subroutine slalom_tsline.
!=============================================================================
integer,                intent(in   ):: n
integer, dimension(n),  intent(in   ):: bend,hgxn
real(dp),dimension(n),  intent(in   ):: yn
logical, dimension(n),  intent(in   ):: off
real(dp),               intent(in   ):: halfgate
real(dp),dimension(n),  intent(  out):: q
real(dp),dimension(n),  intent(  out):: ya
real(dp),               intent(  out):: en
integer,                intent(  out):: ita,ittot
integer,                intent(inout):: maxitb
logical,                intent(  out):: FF
!-----------------------------------------------------------------------------
integer,parameter      :: nita=50,nitb=80
real(dp),dimension(n)  :: xs,jump,qt,yat
real(dp)               :: sj,sjmin,ena
integer                :: i,j,k,itb,hgxp
logical,dimension(n)   :: on
!=============================================================================
! Initialize the "A" iteration by fitting a feasible spline to as many
! "gateposts" as is possible with distinct xn. A constraint i is signified
! to be activated when logical array element, on(i), is true:
FF=F
xs=hgxn*halfgate
hgxp=hgxn(1)-1
do i=1,n
   if(off(i))then
      on(i)=F
      cycle
   endif
   on(i)=(hgxn(i)>hgxp)
   if(on(i))hgxp=hgxn(i)
enddo
ittot=1
call fit_guspline(n,xs,yn,on,qt,jump,yat,en,FF)! <- Make the initial fit
ena=en
if(FF)then
   write(41,*) 'In slalom_uspline; failure flag raised in call to fit_guspline'
   write(41,*) 'at initialization of A loop'
   return
endif

! loop over steps of iteration "A" to check for jump-sign violations
do ita=1,nita
   q=qt   ! Copy solution vector q of nodal 1st-derivatives
   ya=yat ! Copy nodal intercepts

! Determine whether there exists sign-violations in any active "jumps"
! of the 3rd derviative and, if so, inactivate (on==F) the constraints
! at those points. Also, count the number, j, of such violations.
   j=0
   k=0
   sjmin=0
   do i=1,n
      if(.not.on(i))cycle
      sj=-bend(i)*jump(i)
      if(sj<0)then
         j=i
         on(i)=F
      else
         k=k+1 ! <- new tally of constraints switched "on"
      endif
   enddo
   if(j==0)exit !<-Proper conditions for a solution are met
   if(k==0)on(j)=T ! <- must leave at least one constraint "on"

! Begin a new "B" iteration that adds as many new constraints as needed
! to keep the new conditional minimum energy spline in the feasible region:
   do itb=1,nitb
      call fit_guspline(n,xs,yn,on,qt,jump,yat,en,FF)
      if(FF)then
         write(41,*)&
              'In slalom_uspline; failure flag raised in call to fit_guspline'
         write(41,*) 'at B loop, iterations ita,itb = ',ita,itb
         return
      endif
      ittot=ittot+1 ! Increment the running total of calls to fit_uspline

! Determine whether this "solution" wanders outside any slalom gates at
! the unconstrained locations and identify and calibrate the worst violation.
! In this case, sjmin, ends up being the under-relaxation coefficient
! by which we need to multiply this new increment in order to just stay
! within the feasible region of spline space, and constraint j must be
! switched "on":
      j=0
      sjmin=u1
      do i=1,n
         if(on(i).or.off(i))cycle
         sj=bend(i)*(yn(i)-yat(i))
         if(sj<0)then
            sj=(yn(i)-ya(i))/(yat(i)-ya(i))
            if(sj<sjmin)then
               j=i
               sjmin=sj
            endif
         endif
      enddo
      if(j==0)exit !<- spline is feasible, exit B loop and adopt solution as A

! Back off to best feasible solution along this path, which modulates the
! change just made by an underrelaxation factor, sjmin, and activate 
! constraint j
      ya=ya+sjmin*(yat-ya)
      q=q+sjmin*(qt-q)
      on(j)=T
   enddo
   maxitb=max(maxitb,itb)
   if(itb>nitb) then
      FF=T
      write(41,*) 'In slalom_uspline; exceeding the allocation of B iterations'
      return
   end if
   q=qt
   ya=yat
   if(en>=ena)then
      write(41,*) 'In slalom_uspline; energy failed to decrease'
      exit
   endif
   ena=en
enddo
if(ita>nita)then
   FF=T
   write(41,*) 'In slalom_uspline; exceeding the allocation of A iterations'
   return
endif
end subroutine slalom_uspline

!=============================================================================
subroutine convertd(n,halfgate,tdata,hdata,phof,&!                  [convertd]
     doru,idx,hgts,hs,descending,FF)
!=============================================================================
! tdata (in single precision real hours) is discretized into bins of size
! gate=2*halfgate (in units of seconds) and expressed as even integer units
! hgts of halfgate that correspond to the mid-time of each bin. (The two
! limits of each time-bin are odd integers in halfgate units.)
!=============================================================================
integer,              intent(in ):: n
real(dp),             intent(in ):: halfgate
real,    dimension(n),intent(in ):: tdata,hdata
integer, dimension(n),intent(in ):: phof
integer,              intent(out):: doru
integer, dimension(n),intent(out):: idx,hgts
real(dp),dimension(n),intent(out):: hs
logical,              intent(out):: descending
logical,              intent(out):: FF
!------------------------------------------------------------------------------
integer,parameter:: hour=3600 ! 1 hour converted to S.I. units
integer          :: i,j,ii,upsign,hgs
real(dp)         :: s,gate
!=============================================================================
FF=F
if(size(hdata)/=n)stop 'In convertd; inconsistent dimensions of hdata'
if(size(tdata)/=n)stop 'In convertd; inconsistent dimensions of tdata'
if(size(hs)/=n)stop 'In convertd; inconsistent dimensions of hs'
if(size(hgts)/=n)stop 'In convertd; inconsistent dimensions of hgts'
hs=hdata
! convert to whole number of seconds rounded to the nearest gate=2*halfgate:
upsign=0
gate=halfgate*2
do i=1,n
   hgts(i)=2*nint(tdata(i)*hour/gate)! 
   if(phof(i)==5)upsign=1  ! Ascending flight
   if(phof(i)==6)upsign=-1 ! Descending flight
enddo
doru=0
if (upsign>0) then
   doru=2
else
   doru=1
endif
if(n==1)return
if(hgts(1)>hgts(n))then ! Reverse the order:
   do i=1,n/2
      j=n+1-i
      hgs=hgts(i); hgts(i)=hgts(j); hgts(j)=hgs ! Swap integer hgts
      s  =hs(i)  ; hs(i)  =hs(j)  ; hs(j)  =s   ! and swap real hs
   enddo
endif
if(upsign==1)then
   descending=F
elseif(upsign==-1)then
   descending=T
else
   descending=(hs(n)<hs(1))
   if(descending)then; upsign=-1; write(41,'("mainly DESCENDING")')
                 else; upsign=1;  write(41,'("mainly ASCENDING")')
   endif
endif

! make sure the order is in time increasing order
do i=1,n
   idx(i)=i
end do
do i=2,n
   do ii=1,i-1
      if (hgts(i)<hgts(ii).or. &
           (hgts(i)==hgts(ii).and.upsign*(hs(i)-hs(ii))<u0)) then  
         hgs=hgts(i);  hgts(i)=hgts(ii);   hgts(ii)=hgs   ! Swap integer hgts
         s  =hs(i);    hs(i)  =hs(ii);     hs(ii)  =s     ! and swap real hs
         j=idx(i);    idx(i)  =idx(ii);   idx(ii)  =j     ! and swap index idx
      end if
   end do
end do
do i=2,n
   if(hgts(i)<hgts(i-1)) then
      write(41,*)&
           'In convertd; time sequence not monotonic', i, hgts(i),hgts(i-1)
      FF=T
      return
   end if
enddo
do i=2,n
   if(upsign*(hs(i)-hs(i-1))<u0)&
        write(41,*) 'In convertd; height sequence not monotonic'
enddo
end subroutine convertd

!=============================================================================
subroutine convertd_back(n,halfgate,wdata,tdata, &!            [convertd_back]
     ws,hgts,idx,descending)
!=============================================================================
integer,              intent(in ):: n
real(dp),             intent(in ):: halfgate
integer, dimension(n),intent(in ):: hgts,idx
real(dp),dimension(n),intent(in ):: ws
logical,              intent(in ):: descending
real,dimension(n),    intent(out):: wdata
real,dimension(n),    intent(out):: tdata
!------------------------------------------------------------------------------
integer             :: i,j,ii
real(dp)            :: s
real,   dimension(n):: wn
integer,dimension(n):: hgtn
!=============================================================================
if(size(wdata)/=n)stop 'In convertd; inconsistent dimensions of wdata'
if(size(tdata)/=n)stop 'In convertd; inconsistent dimensions of tdata'
if(size(ws)/=n)stop 'In convertd; inconsistent dimensions of ws'
if(size(hgts)/=n)stop 'In convertd; inconsistent dimensions of hgts'

do i = 1, n
   ii = idx(i); hgtn(ii) = hgts(i);  wn(ii) = ws(i)
end do

wdata=wn; tdata=hgtn*halfgate
if (descending.or.n==1) return
do i=1,n/2
   j=n+1-i
   s=tdata(i); tdata(i)=tdata(j); tdata(j)=s ! Swap tdata
   s=wdata(i); wdata(i)=wdata(j); wdata(j)=s ! Swap wdata
enddo
end subroutine convertd_back

end module pspl

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: BUFR_COMBFR
C   PRGMMR: KEYSER           ORG: NP22        DATE: 2013-01-24
C
C ABSTRACT: CONCATENATES INDIVIDUAL BUFR FILES INTO A SINGLE BUFR FILE,
C   AND FOR DUMP FILES (OPTIONALLY) GENERATES TWO DUMMY MESSAGES AT THE
C   BEGINNING OF THE OUTPUT COMBINED DUMP FILE WHICH CONTAIN ONLY THE
C   DUMP CENTER TIME AND THE CURRENT PROCESSING TIME ("DUMP" TIME) IN
C   SECTION ONE.  CURRENTLY THE MAXIMUM NUMBER OF FILES THAT CAN BE
C   COMBINED IS 100.  THE PATH NAMES OF THE FILES TO COMBINE ARE READ
C   FROM STANDARD INPUT (UNIT 05) AND CONNECTED TO FORTRAN UNIT 20 VIA
C   THE FORTRAN OPEN STATEMENT. THE OUTPUT FILE (UNIT 50) MUST BE
C   CONNECTED EXTERNALLY.
C
C PROGRAM HISTORY LOG:
C 1996-09-06  J. WOOLLEN  ORIGINAL VERSION FOR IMPLEMENTATION
C 1996-11-27  J. WOOLLEN  MADE OUTPUT FILE BUFR TABLE CHOOSING MORE
C     SECURE
C 1999-06-03  D. KEYSER   MODIFIED TO PORT TO IBM SP AND RUN IN 4 OR 8
C     BYTE STORAGE
C 2006-03-02  D. KEYSER   ADDED OPTION TO WRITE "DUMMY" MESSAGES
C     CONTAINING DUMP CENTER TIME AND PROCESSING TIME, RESP. INTO FIRST
C     TWO MESSAGES OF OUTPUT COMBINED DUMP FILE (AFTER TABLE MSGS),
C     WILL ONLY DO SO IF EXECUTING SCRIPT VARIABLE "DUMMY_MSGS" (READ
C     IN VIA "GETENV") IS "YES" AND THE DUMP CENTER AND PROCESSING TIME
C     IS SUCCESSFULLY READ FROM NEW UNIT 17 - NORMALLY THIS PROGRAM
C     WILL PERFORM THIS FUNCTION ONLY WHEN IT IS EXECUTED BY DUMPJB IN
C     THE DUMP PROCESSING {IT HAD BEEN DONE IN DUMPJB PROGRAM
C     BUFR_DUMPMD, BUT SINCE THE LEVEL 2 RADAR DUMP PROCESSING NO
C     LONGER EXECUTES THIS PROGRAM IN ORDER TO SAVE TIME (BECAUSE THERE
C     IS SO MUCH DATA), IT HAS BEEN MOVED HERE FOR ALL DATA TYPES
C     (MAKES MORE SENSE TO DO IT HERE SINCE DUMMY MESSAGES WILL ONLY BE
C     WRITTEN ONCE TO A COMBINED DUMP FILE, IN BUFR_DUMPMD THEY WERE
C     WRITTEN TO THE TOP OF EACH INDIVIDUAL DUMP FILE), THE EXCEPTION
C     IS FOR CASES WHERE DUMPJB SCRIPT VARIABLE "FORM" IS SET TO "copy"
C     (IN THIS CASE, THIS PROGRAM DOES NOT RUN SO BUFR_DUMPMD MUST
C     WRITE THE DUMMY MESSAGES TO THE TOP OF THE DUMP FILE)}; MODIFIED
C     TO WRITE AN EXTERNAL BUFR TABLE INTO THE COMBINED OUTPUT FILE
C     WHEN UNIT 10 IS NOT EMPTY (IN THIS CASE UNIT 10 CONTAINS THE PATH
C     TO THE EXTERNAL BUFR TABLE WHICH IS PRINTED TO STANDARD OUTPUT
C     AND UNIT 15 CONTAINS THE EXTERNAL BUFR TABLE ITSELF), WHEN UNIT
C     10 IS EMPTY THE INTERNAL BUFR FILE IN THE FIRST FILE READ IS
C     WRITTEN INTO THE COMBINED OUTPUT FILE (THE ONLY OPTION BEFORE
C     THIS CHANGE) (NOTE: DUMPJB HAS NOT YET BEEN MODIFIED TO USE AN
C     EXTERNAL BUFR TABLE, SO UNIT 10 IS ALWAYS EMPTY); IMPROVED
C     DOCUMENTATION AND AUGMENTED STANDARD OUTPUT PRINT; REPLACED CALL
C     TO BUFRLIB ROUTINE BORT WITH CALL TO W3LIB ROUTINE ERREXIT; NOW
C     CALLS ERREXIT IF THE NUMBER OF INPUT FILES IS ZERO; INCREASED THE
C     NUMBER OF FILES THAT CAN BE COMBINED FROM 29 TO 100.
C 2012-11-20  J. WOOLLEN  INITIAL PORT TO WCOSS -- ADAPTED IBM/AIX
C     GETENV SUBPROGRAM CALL TO INTEL/LINUX SYNTAX; ADDED ERR TRAP TO
C     BUFRTAB_PATH READ
C 2013-01-13  J. WHITING  READIED FOR IMPLEMENTATION ON WCOSS LINUX
C     (UPDATED DOC-BLOCK, ETC.; NO LOGIC CHANGES)
C 2013-01-24  J. WOOLLEN  ADJUST LOGIC TO FIND TABLES TO AVOID USING 
C     BUFRLIB ROUTINE MESGBF
C 2013-01-24  D. KEYSER   A FEW MINOR MODS; USE INTRINSIC "TRIM"
C     CHARACTER STRING FUNCTION TO ELIMINATE NEED TO OBTAIN NUMBER OF
C     NON-BLANK CHARACTERS IN STRINGS; REPLACED GETENV WITH MORE
C     STANDARD GET_ENVIRONMENT_VARIABLE.
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT - RECORDS CONTAINING THE INPUT FILE
C                NAMES FOR BUFR FILES BEING COMBINED INTO A SINGLE
C                FILE - ANY RECORD BEGINNING WITH "fort" IS SKIPPED
C     UNIT 10  - TEXT WHICH CONTAINS PATH TO THE EXTERNAL BUFR TABLE
C                (PRINTED TO STANDARD OUTPUT) READ IN UNIT 15 (IF THIS
C                IS EMPTY -- AND CURRENTLY IS ALWAYS IT! --, THE
C                INTERNAL BUFR FILE IN THE FIRST FILE READ IS WRITTEN
C                INTO THE COMBINED OUTPUT FILE)
C     UNIT 15  - EXTERNAL BUFR TABLE (ONLY READ IF UNIT 10 IS NOT
C                EMPTY -- CURRENTLY UNIT 10 IS ALWAYS EMPTY!!)
C     UNIT 17  - IF PRESENT, FIRST RECORD CONTAINS YYYYMMDDHH<.HH> DATE
C                OF THE DUMP CENTER TIME, SECOND RECORD CONTAINS THE
C                YYYYMMDDHHMM DATE OF THE CURRENT WALLCLOCK TIME; THE
C                ABSENCE OF THIS FILE IS A SIGNAL THAT THIS PROGRAM
C                SHOULD NOT WRITE CENTER AND DUMP TIME DUMMY MESSAGES
C                TO THE TOP OF THE OUTPUT COMBINED DUMP FILE
C     UNIT 20  - THE VARIOUS BUFR FILES IN THE LIST TO BE COMBINED
C                (CONNECTED INTERNALLY VIA FORTRAN OPEN STATEMENT)
C
C   OUTPUT FILES:
C     UNIT 50  - COMBINED BUFR FILE, POSSIBLY WITH CENTER TIME AND DUMP
C                TIME DUMMY MESSAGES AT THE BEGINNING (TOP) (CONNECTED
C                EXTERNALLY)
C
C   SUBPROGRAMS CALLED:
C     UNIQUE     - NONE
C     SYSTEM     - GET_ENVIRONMENT_VARIABLE
C     LIBRARY:
C       W3NCO    - W3TAGB   W3TAGE   ERREXIT
C       BUFRLIB  - DATELEN  OPENBF   COPYMG   CLOSBF   IREADMG
C                  OPENMG   MINIMG
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C            > 0 - ABNORMAL RUN
C
C REMARKS:
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  WCOSS
C
C$$$

      PROGRAM BUFR_COMBFR
 
      PARAMETER (NFILES=100)  ! Number of input files being considered

      CHARACTER*500 BUFRTAB_PATH,FILI(NFILES),THIS_FILI
      CHARACTER*8   SUBSET
      CHARACTER*3   DUMMY_MSGS
      REAL(8)       CDATE,DDATE
      INTEGER(8)    LDATE_8,MDATE_8
      INTEGER       NCPY(NFILES)
      LOGICAL       COPY_DUMMY_MSGS

      DATA LUNIN,LUNDX,LUNOT/20,15,50/
 
C----------------------------------------------------------------------
C----------------------------------------------------------------------
      CALL W3TAGB('BUFR_COMBFR',2013,0024,0053,'NP22')
 
      print *
      print * ,'---> Welcome to BUFR_COMBFR - Version 01-24-2013'
      print *

      CALL DATELEN(10)

      NFIL = 0

      COPY_DUMMY_MSGS = .FALSE.

      CALL GET_ENVIRONMENT_VARIABLE('DUMMY_MSGS',DUMMY_MSGS)
      IF(DUMMY_MSGS.EQ.'YES') THEN

C  Pgm expected to generate "Dummy" msgs containing center & dump times
C  --------------------------------------------------------------------

         READ(17,*,END=8,ERR=8) CDATE
         READ(17,*,END=8,ERR=8) DDATE
         PRINT *,'REQUESTED CENTER DATE IS ... ',CDATE
         PRINT *,'DUMP PROCESSING  DATE IS ... ',DDATE
         LDATE_8 = INT(CDATE)*100_8 + NINT((CDATE-INT(CDATE))*60.)
         MDATE_8 = DDATE
         LMINS = MOD(LDATE_8,100_8)
         MMINS = MOD(MDATE_8,100_8)
         LDATE = LDATE_8/100
         MDATE = MDATE_8/100
         COPY_DUMMY_MSGS = .TRUE.
      ENDIF

      GO TO 9

8     CONTINUE

C  Center and dump times not found in unit 17, "dummy" messages can't
C   be generated
C  ------------------------------------------------------------------

      PRINT *
      PRINT *, '+++ WARNING: CENTER AND/OR DUMP DATE NOT FOUND IN ',
     $ 'UNIT 17 - "DUMMY" MESSAGES NOT WRITTEN TO TOP OF OUTPUT FILE'
      PRINT *

9     CONTINUE

C  READ THE LOCATIONS OF FILES TO COMBINE
C  --------------------------------------
 
      DO
         READ(5,'(A)',END=1) THIS_FILI
         IF(NFIL+1.GT.NFILES) THEN
            PRINT *
            PRINT *, '### BUFR_COMBFR: THE NUMBER OF INPUT FILES ',
     $       'EXCEEDS THE LIMIT OF ',NFILES,' -- STOP 99'
            PRINT *
            CALL W3TAGE('BUFR_COMBFR')
            CALL ERREXIT(99)
         ENDIF
         FILI(NFIL+1) = THIS_FILI
         IF(FILI(NFIL+1)(1:4).EQ.'fort')  CYCLE
         NFIL = NFIL+1
      ENDDO

1     CONTINUE

      IF(NFIL.EQ.0)  THEN
         PRINT *
         PRINT *, '### BUFR_COMBFR: THE NUMBER OF INPUT FILES IS ZERO',
     $    ' -- STOP 77'
         PRINT *
         CALL W3TAGE('BUFR_COMBFR')
         CALL ERREXIT(77)
      ENDIF

C  DETERMINE WHERE TO GET BUFR TABLE TO WRITE INTO OUTPUT FILE
C  -----------------------------------------------------------
 
      READ(10,'(A)',END=3,err=3) BUFRTAB_PATH

C  Come here if BUFR Table is found in an external file
C  ----------------------------------------------------

      PRINT 100, TRIM(BUFRTAB_PATH)
      CALL OPENBF(LUNOT,'OUT',LUNDX)
      GO TO 2

    3 CONTINUE

C  Come here if BUFR Table is NOT found in an external file (look for
C  first input file that has an internal table and use this table)
C  ------------------------------------------------------------------

      DO N=1,NFIL
         CALL CLOSBF(LUNIN)
         OPEN(LUNIN,FILE=TRIM(FILI(N)),FORM='UNFORMATTED')
         CALL OPENBF(LUNIN,'IN ',LUNIN)
         IF(IREADMG(LUNIN,SUBSET,IDATE)==0) THEN
            CALL OPENBF(LUNOT,'OUT',LUNIN)
            CALL CLOSBF(LUNIN)
            PRINT 101, TRIM(FILI(N))
            GO TO 2
         ENDIF
      ENDDO

      PRINT *
      PRINT *, '+++ WARNING: CANNOT FIND A BUFR TABLE TO WRITE INTO ',
     $ 'OUTPUT FILE - OUTPUT FILE MUST BE EMPTY!!'
      PRINT *

    2 CONTINUE

C  COMBINE ALL MESSAGES FROM ALL INPUT FILES
C  -----------------------------------------
 
      NCPY = 0
      DO N=1,NFIL
         CALL CLOSBF(LUNIN)
         OPEN(LUNIN,FILE=TRIM(FILI(N)),FORM='UNFORMATTED')
         CALL OPENBF(LUNIN,'IN',LUNOT)
         DO WHILE(IREADMG(LUNIN,SUBSET,IDATE).EQ.0)
            IF(COPY_DUMMY_MSGS)  THEN

C  FIRST TIME IN LOOP (ONLY), GENERATE "DUMMY" MESSAGES CONTAINING
C   CENTER AND DUMP TIMES AND WRITE TO OUTPUT COMBINED DUMP FILE
C  ---------------------------------------------------------------

C  First message in output file contains only dump center time in Sec 1
C  --------------------------------------------------------------------

               CALL OPENMG(LUNOT,SUBSET,LDATE)
               CALL MINIMG(LUNOT,LMINS)

C  Second message in output file contains only current time in Sec 1
C  -----------------------------------------------------------------

               CALL OPENMG(LUNOT,SUBSET,MDATE)
               CALL MINIMG(LUNOT,MMINS)
               CALL CLOSMG(LUNOT)
               COPY_DUMMY_MSGS = .FALSE.
               PRINT 102
            ENDIF
            CALL COPYMG(LUNIN,LUNOT)
            NCPY(N) = NCPY(N) + 1
         ENDDO
         PRINT 103, NCPY(N),TRIM(FILI(N))
      ENDDO

      IF(COPY_DUMMY_MSGS) THEN

C  Can only get here if code expected to generate and write out dummy
C   messages and this didn't happen because no data messages were found
C   in any of the input files - in this case output (dump) file must be
C   empty, otherwise some codes reading it (e.g., IW3UNPBF) will fail
C   when they cannot find values for the dump center & processing times
C  --------------------------------------------------------------------

         PRINT *
         PRINT *, 'NO INPUT DATA MESSAGES FOUND - FORCE OUTPUT (DUMP) ',
     $            'FILE TO BE EMPTY'
         PRINT *
         ENDFILE 50
         CALL SYSTEM('cp /dev/null fort.50')
      END IF

      PRINT *
      PRINT *, 'PROGRAM COMPLETED SUCCESSFULLY'
      PRINT *

      CALL W3TAGE('BUFR_COMBFR')

      STOP

  100 FORMAT(/' --> Will write output file using external BUFR table'/
     $ 5X,A/)
  101 FORMAT(/' --> Will write output file using BUFR table internal ',
     $ 'to'/5X,A/5X,'(the first non-empty input file)'/)
  102 FORMAT(/' ==> "Dummy" messages containing dump center time and ',
     $ 'wall-clock processing time successfully written to top of ',
     $ 'output file'/)
  103 FORMAT(//2X,'--',I7,' BUFR MESSAGES COPIED FROM INPUT FILE ',A,
     $ ' TO COMBINED OUTPUT FILE')

      END

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: PREPOBS_CQCVAD
C   PRGMMR: MELCHIOR         ORG: NP22        DATE: 2016-12-18
C
C ABSTRACT: PERFORM COMPLEX QUALITY CONTROL OF VAD WINDS FROM
C   WSR-88D RADARS.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS  ORIGINAL AUTHOR
C 1999-10-26  W. COLLINS  ADD DIAGNOSIS TO SCREEN BIRD INFLUENCE
C 2000-10-26  W. COLLINS  GENERALIZE TO ALLOW ANY HEIGHT UP TO
C       35,000 FT.
C 2001-10-08  D. KEYSER   CODE STREAMLINED; NOW TABULATES PERCENT
C       OF LEVELS < 18K FAILING BIRD ALGORITM CHECK ACCORDING TO
C       STATION AND 1-HOUR TIME WINDOWS CENTERED ON 30-MIN PAST
C       HOUR, THIS BIRD Q.C. INFORMATION WRITTEN TO UNIT 52 FOR
C       LATER USE BY 3DVAR IN Q.C. OF NEXRAD RADIAL VELOCITY DATA;
C       CORRECTED ERROR WHICH HAD RESULTED IN NO Q.C. PERFORMED ON
C       LEVELS WHERE EITHER THE U- OR V- INCREMENT WAS ZERO; VALID
C       DATES FOR CHECKING FOR MIGRATING BIRDS EXPANDED FROM 2/15
C       THROUGH 6/15 TO 2/1 THROUGH 6/30 IN SPRING AND FROM 8/15
C       THROUGH 11/15 TO 8/1 THROUGH 11/30 IN FALL; LIMITING
C       V-WIND INCREMENT FOR APPLYING BIRD CONTAMINATION TIGHTENED
C       FROM +8 TO +5 M/S IN SPRING AND FROM -8 TO -5 M/S IN FALL,
C       MORE LEVELS WILL NOW BE FLAGGED
C 2012-03-05  S. MELCHIOR  CODE FURTHER STREAMLINED. CORRECTED VARIOUS
C       TYPO'S IN LEGACY DOCUMENTATION. ADDED MORE CONCISE DESCRIPTIONS
C       TO LEGACY DOCUMENTATION. ADDED MORE COMPLETE DIAGNOSTIC OUTPUT
C       STATEMENTS FOR INSTANCES WHEN SPECIFIC DO LOOPS ARE OUT OF
C       BOUNDS AND WHEN CONDITIONAL STATEMENTS ARE NOT MET. ADDED MORE
C       CONCISE COMMENTS TO IDENTIFY DO LOOP BOUNDARIES. CORRECTED A DO
C       LOOP TERMINUS PARAMETER FROM NLEV TO NLV IN SUBROUTINE COMSTAT.
C       ADDED A MISSING RETURN STATEMENT TO SUBROUTINE HT. UPDATED
C       SUBROUTINE DISTR TO BE MORE FLEXIBLE AND UTILIZE NDIV AND NX AS
C       ARRAY LIMITS RATHER THAN THE HARD CODED 23 AND 899,
C       RESPECTIVELY. EXTENDED MSK ARRAY ALLOCATION FROM 899 TO 1000 IN
C       SUBROUTINES INCDIST AND RESDIST TO ALLOW FOR MORE STATION
C       STATISTICS TO BE PROCESSED - ON OCCASION THE 899 LIMIT HAD BEEN
C       MET AND EXCEEDED CAUSING MEMORY LEAKS. UPDATED SUBROUTINE
C       EVNOUT TO USE INCOMING ARGUMENT NLV TO DEFINE MEMORY ALLOCATION
C       FOR VARIOUS REAL AND INTEGER ARRAYS. THIS MAKES THE SUBROUTINE
C       MORE ROBUST AND EFFICIENT BY ONLY ALLOTTING THE MEMORY SPACE
C       NECESSARY, NOTHING MORE. CREATED SEVERAL NEW PARAMETERS FOR
C       VARIOUS SUBROUTINES TO TIDY UP THE CODE. NTIMES=6 HAS BEEN
C       ADDED TO COMSTAT, GETDAT, INCDIST, INCR, INIT, MATR, DMA,
C       RESDIST, SELECT, SOLVE, ZTOI, AND ZTRES.  NINC=3 HAS BEEN ADDED
C       TO COMSTAT, GETDAT, INCDIST, INCR, INIT, MATR, DMA, RESDIST,
C       SELECT, SOLVE, AND ZTRES.  NEVNT=160000 WAS ADDED TO DMA AND
C       EVNOUT. NDIV=23 HAS BEEN ADED TO INCDIST AND RESDIST.  RENAMED
C       PARAMETER NE TO NME FOR CLARIFICATION SINCE NE IS DIFFICULT TO
C       SEARCH ON AND IS ALSO USED FOR INEQUALITY COMPARISON TESTING
C       (.NE.).  ADDED LOGIC TO TURN OFF BIRD CHECK ALGORITHM FOR VAD
C       WIND REPORTS FROM LEVEL 2 DECODER.  INCREASED NRPT FROM 80000
C       TO 160000 TO ACCOMMODATE VAD WIND REPORTS FROM LEVEL 2 DECODER.
C       CORRECTED BUG IN SUBROUTINE GETDAT TO PROPERLY HANDLE SITUATION
C       WHEN SUBSET IS VADWND AND THE NUMBER OF LEVELS (NUM) EXCEEDS
C       NRPT (160000).
C 2012-11-20  J. WOOLLEN  INITIAL PORT TO WCOSS 
C 2013-02-05  D. Keyser   Final changes to run on WCOSS:  Set BUFRLIB
C       missing (BMISS) to 10E8 rather than 10E10 to avoid integer
C       overflow; rename all REAL(8) variables as *_8.
C 2014-01-15  S. Melchior  Increased NRPT (total number of levels
C       amongst all VAD reports that can be processed) and NEVNT (total
C       number of events amongst all VAD reports that can be processed)
C       both from 160000 to 500000 to accommodate VAD wind reports from
C       Level 2 decoder.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.  Made minor correction in GETDAT.
C
C USAGE:
C   INPUT FILES:
C     UNIT 11  - INPUT PREPBUFR FILE
C     UNIT 14  - 10-DIGIT TIME (YYYYMMDDHH)
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - OUTPUT PREPBUFR FILE
C     UNIT 52  - BIRD Q.C. INFORMATION LIST
C     UNIT 53  - FINAL LISTING OF REPORTS WITH Q.C. INFO
C     UNIT 55  - ????????????????????????????
C     UNIT 60  - LISTING OF EVENT INFORMATION
C
C   SUBPROGRAMS CALLED:
C     SYSTEM:    - SYSTEM
C     UNIQUE:    - INIT     GETDAT   INCR     ZTOI     DMA
C                  INCDIST  COMSTAT  RESDIST  CSTATS   VSOLVE
C                  EVENTW   GETOBV   EVNOUT   DISTR    HT
C                  SORTD    DRCTSL   INDEXX   SELECT   MATR
C                  SOLVE    ZTRES    CUMPROB  ANLWT    BLOCK DATA
C     LIBRARY:
C       W3NCO    - W3TAGB   W3TAGE   W3MOVDAT W3DIFDAT
C       BUFRLIB  - DATELEN  CLOSBF   OPENBF   READMG   UFBQCD
C                  CLOSMG   COPYMG   OPENMB   READSB   UFBCPY
C                  WRITSB   UFBINT   SETBMISS GETBMISS
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C
C REMARKS:
C
C    CONTENTS OF NAMELIST SWITCH "NAMLST"
C        HONOR_FLAGS - LOGICAL, IF TRUE THEN LEVELS WITH BAD Q. MARK
C                      FLAGS ARE HONORED                  (DEFAULT=TRUE)
C        PRINT_52    - LOGICAL, IF TRUE THEN WRITES BIRD QUALITY
C                      CONTROL INFORMATION TO UNIT 52     (DEFAULT=TRUE)
C        PRINT_53    - LOGICAL, IF TRUE THEN WRITES A FINAL REPORT
C                      LISTING WITH Q.C. INFORMATION TO UNIT 53
C                                                        (DEFAULT=FALSE)
C        PRINT_60    - LOGICAL, IF TRUE THEN WRITES EVENT INFORMATION
C                      TO UNIT 60                        (DEFAULT=FALSE)
C        TEST        - LOGICAL, IF TRUE THEN WRITES DIAGNOSTIC PRINT
C                      TO STDOUT (UNIT 06)               (DEFAULT=FALSE)
C        
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      PROGRAM PREPOBS_CQCVAD

      PARAMETER(NLEV=35)

      integer idat(8),jdat(8),idate_e(4,-3:3),idate_l(4,-3:3)
      real    rinc(5)
      LOGICAL HONOR_FLAGS, PRINT_52, PRINT_53, PRINT_60, TEST, guess
      character*8 stnidx
      REAL(8)   BMISS,GETBMISS

      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /BIRDST/stnidx(9999,-3:3),alatx(9999,-3:3),
     & alonx(9999,-3:3),knt_5_yes(9999,-3:3),knt_5_no(9999,-3:3),
     & numrpt(9999,-3:3)
      common /datet/  idate(4), itim(6)
      common /switches/  print_52, print_53, print_60, test
      common /flag/   guess
      COMMON /BUFRLIB_MISSING/BMISS

      NAMELIST /NAMLST/ HONOR_FLAGS, PRINT_52, PRINT_53, PRINT_60, TEST

      CALL W3TAGB('PREPOBS_CQCVAD',2016,0353,1200,'NP22')

      PRINT *, ' ==> WELCOME TO CQCVAD, VERSION 2016-12-18 <=='
      PRINT *, ' '

C  Set up default values for namelist switches
C  -------------------------------------------

      HONOR_FLAGS = .TRUE.
      PRINT_52    = .TRUE.
      PRINT_53    = .FALSE.
      PRINT_60    = .FALSE.
      TEST        = .FALSE.

      READ(5,NAMLST,ERR=10,END=10)
   10 CONTINUE
      WRITE(6,NAMLST)

C  On WCOSS should always set BUFRLIB missing (BMISS) to 10E8 to avoid
C   overflow when either an INTEGER*4 variable is set to BMISS or a
C   REAL*8 (or REAL*4) variable that is missing is NINT'd
C  -------------------------------------------------------------------
ccccc CALL SETBMISS(10E10_8)
      CALL SETBMISS(10E8_8)
      BMISS=GETBMISS()
      print *
      print *, 'BUFRLIB value for missing is: ',bmiss
      print *

C  PROGRAM TO QUALITY CONTROL VADWINDS
C  -----------------------------------

      CALL INIT

C  GET DATA AND PUT INTO LINEAR ARRAY
C  ----------------------------------

      ITIME = 1
      CALL GETDAT(ITIME)

C  OBTAIN INCREMENTS
C  -----------------

      CALL INCR

C  PERFORM OI IN HEIGHT-TIME PLANE (unless no first guess)
C  -------------------------------------------------------

      if (guess) CALL ZTOI

C  DECISION-MAKING ALGORITHM, ALSO SAVE EVENTS
C  -------------------------------------------

      CALL DMA(HONOR_FLAGS)

C  GET STATISTICAL DISTRIBUTIONS OF INCREMENTS (unless no first guess)
C  -------------------------------------------------------------------

      if (guess) CALL INCDIST

C  COMPUTE STATISTICS BASED UPON DELTA-T AND DELTA-Z
C  -------------------------------------------------

      CALL COMSTAT

C  GET STATISTICAL DISTRIBUTION OF RESIDUALS (unless no first guess)
C  -----------------------------------------------------------------

      if (guess) CALL RESDIST

C  READ DATA A SECOND TIME AND WRITE EVENTS
C  ----------------------------------------

      ITIME = 2
      CALL GETDAT(ITIME)

      if(print_52)  then

C  WRITE BIRD Q.C. INFORMATION TO UNIT 52
C  --------------------------------------

         write(52,'("===> VAD WIND BIRD MIGRATION Q.C. INFORMATION")')
         write(52,'(/6x,"Only levels below 18,000 ft are considered")')
         write(52,'(6x,"Stations are parsed into 1-hour time blocks")')
         write(52,'(/6x,"PREPBUFR CENTER TIME IS: ",i4,3i2.2//)') idate
         write(52,'(" STNID   LAT(N)   LON(E)",9x,"TIME RANGE",10x, ' //
     &    '"# LVLS =< 18K FT    # OF RPTS    % LVLS FLAGGED BY BIRD",'//
     &    '" ALG.")')
         write(52,'(1x,5("-"),3x,6("-"),3x,6("-"),3x,23("-"),3x,' //
     &    '16("-"),4x,9("-"),4x,27("-")/)')
         idate_e   = 0
         idate_l   = 0
         idat      = 0
         idat(1:3) = idate(1:3)
         idat(5)   = idate(4)
         rinc      = 0
         do  jtim = -3,3
            rinc(2)   = jtim - 1
            if(jtim.eq.-3)  then
               call w3movdat(rinc,idat,jdat)
               idate_e(1:3,jtim) = jdat(1:3)
               idate_e(4,jtim)   = jdat(5)
            else
               idate_e(:,jtim) = idate_l(:,jtim-1)
               jdat = idat
            end if
            idat = 0
            rinc(2)   = 1
            call w3movdat(rinc,jdat,idat)
            idate_l(1:3,jtim) = idat(1:3)
            idate_l(4,jtim)   = idat(5)
         end do
         do irep = 1,9999
            do jtim = -3,3
               if(stnidx(irep,jtim)(1:1).ne.'X')  then
                  if(knt_5_yes(irep,jtim)+knt_5_no(irep,jtim).gt.0) then
                     percent_5 = (knt_5_yes(irep,jtim)*100.)/
     &                        (knt_5_yes(irep,jtim)+knt_5_no(irep,jtim))
                  else
                     percent_5 = 0.
                  end if
               write(52,501) stnidx(irep,jtim),alatx(irep,jtim),
     &                       alonx(irep,jtim),idate_e(:,jtim),
     &                       idate_l(:,jtim),
     &                       knt_5_yes(irep,jtim)+knt_5_no(irep,jtim),
     &                       numrpt(irep,jtim),percent_5
 501  format(a8,1x,f6.2,3x,f6.2,3x,i4,3i2.2,' - ',i4,3i2.2,8x,i5,12x,i3,
     & 19x,f5.1)
               end if
            end do
         end do
      end if

      CALL W3TAGE('PREPOBS_CQCVAD')

      STOP
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: BLOCK DATA
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1999-08-18
C
C ABSTRACT: BLOCK DATA
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  RENAMED NE TO NME FOR EASE OF NAVIGATION AND
C       FOR CLARIFICATION SINCE NE IS ALSO USED FOR INEQUALITY TESTING
C       (.NE.). INCREASED NEV FROM 80000 TO 160000 TO ACCOMMODATE VAD
C       WIND REPORTS FROM LEVEL 2 DECODER.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      BLOCK DATA
      PARAMETER (NLEV=35)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /CONSTS/ MAT,E,AA,B,XL,R
      COMMON /BIRDST/stnidx(9999,-3:3),alatx(9999,-3:3),
     & alonx(9999,-3:3),knt_5_yes(9999,-3:3),knt_5_no(9999,-3:3),
     & numrpt(9999,-3:3)
      common /flag/   guess
      character*8 stnidx
      logical guess
      DATA IUNIT /11/, IUTIM /14/, IOUT /51/
      DATA CON /304.8/
      DATA IHE /-3/
      DATA NEV /160000/
      DATA IZLEV /1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,
     &  19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35/
      DATA MAT /9/, E /.1/, B /.67/, XL /2.3/, R /1.5/
      DATA AA /.25/
      data stnidx/69993*'XXXXXXXX'/
      data alatx/69993*99999./,alonx/69993*99999./
      data knt_5_yes/69993*0/,knt_5_no/69993*0/,numrpt/69993*0/
      data guess/.true./
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: COMSTAT
C   PRGMMR: S. Melchior      ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: COMPUTE STATISTICS FOR HEIGHT-TIME INCREMENT INTERPOLATION.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  CORRECTED DO LOOP TERMINUS PARAMETER FROM
C       NLEV TO NLV. ALSO ADDED PARAMETERS NTIMES=6 AND NINC=3 TO TIDY
C       UP THE CODE.  RENAMED NE TO NME FOR EASE OF NAVIGATION AND FOR
C       CLARIFICATION SINCE NE IS ALSO USED FOR INEQUALITY TESTING
C       (.NE.). INCREASED NEV FROM 80000 TO 160000 TO ACCOMMODATE VAD
C       WIND REPORTS FROM LEVEL 2 DECODER.
C 2014-01-15  S. Melchior  Increased NRPT (total number of levels
C       amongst all VAD reports that can be processed) from 160000 to
C       500000 to accommodate VAD wind reports from Level 2 decoder.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL COMSTAT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE COMSTAT

      PARAMETER (NL=34,NTIM=5,NTIMES=6,NRPT=500000,NSTN=300)
      PARAMETER (NLEV=35,NINC=3)
      INTEGER N12(0:NL,0:NTIM)
      REAL    U1(0:NL,0:NTIM),   V1(0:NL,0:NTIM),
     &        U1S(0:NL,0:NTIM),  V1S(0:NL,0:NTIM),
     &        U2(0:NL,0:NTIM),   V2(0:NL,0:NTIM),
     &        U2S(0:NL,0:NTIM),  V2S(0:NL,0:NTIM),
     &        U12(0:NL,0:NTIM),  V12(0:NL,0:NTIM),
     &        U1B(0:NL,0:NTIM),  U2B(0:NL,0:NTIM),
     &        V1B(0:NL,0:NTIM),  V2B(0:NL,0:NTIM),
     &        U1SD(0:NL,0:NTIM), V1SD(0:NL,0:NTIM),
     &        U2SD(0:NL,0:NTIM), V2SD(0:NL,0:NTIM),
     &        U12V(0:NL,0:NTIM), V12V(0:NL,0:NTIM),
     &        U12R(0:NL,0:NTIM), V12R(0:NL,0:NTIM)
      REAL(8)   BMISS

      COMMON /SINGLE/ ZOB(NRPT), ITM(NRPT),TIM(NRPT),
     &                UOB(NRPT), VOB(NRPT), LOB(NRPT),
     &                XLA(NRPT), XLO(NRPT), ZST(NRPT),
     &                UFF(NRPT), VFF(NRPT), TFF(NRPT),
     &                WQM(NRPT)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /DATET/  IDATE(4), ITIM(6)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /BUFRLIB_MISSING/BMISS
      COMMON /HTS/    IZLEV(NLEV), ZLEV(NLEV)
      COMMON /DMATYP/ IQC(NLEV,NTIMES,NINC,NSTN)

C  INITIALIZE STATISTICS
C  ---------------------

      N12  = 0
      U1   = 0.
      V1   = 0.
      U1S  = 0.
      V1S  = 0.
      U2   = 0.
      V2   = 0.
      U2S  = 0.
      V2S  = 0.
      U12  = 0.
      V12  = 0.
      U1B  = 0.
      U2B  = 0.
      V1B  = 0.
      V2B  = 0.
      U1SD = 0.
      V1SD = 0.
      U2SD = 0.
      V2SD = 0.
      U12V = 0.
      V12V = 0.
      U12R = 0.
      V12R = 0.

C  COLLECT STATISTICS BY TIME AND HEIGHT DIFFERENCES
C  -------------------------------------------------
      DO IS=1,NST ! nst max is nstn=300
        DO L=1,NLEV ! nlev max is 35
          DO I=1,NTIMES ! ntimes max is 6
           DO IT=1,NIN(L,I,IS) !  nin(L,I,IS) max is 3
            DO LL=1,NLEV ! nlev max is 35
              DO II=1,NTIMES ! ntimes max is 6
               DO IIT=1,NIN(LL,II,IS) !  nin(LL,II,IS) max is 3
                IF(MAX(UIN(L,I,IT,IS),UIN(LL,II,IIT,IS),VIN(L,I,IT,IS),
     &           VIN(LL,II,IIT,IS)).LT.BMISS .AND.
     &           IQC(L,I,IT,IS).EQ.0 .AND. IQC(LL,II,IIT,IS).EQ.0 .AND.
     &          .NOT.(TIMIN(L,I,IT,IS).EQ.TIMIN(LL,II,IIT,IS) .AND.
     &                                               L.EQ.LL)) THEN
                  IDL = ABS(IZLEV(L) - IZLEV(LL)) + 0.5
                  IDI = ABS(TIMIN(L,I,IT,IS) - TIMIN(LL,II,IIT,IS))+0.5
	          IF(MIN(IDL,IDI).GE.0 .AND. IDL.LE.NL 
     &               .AND. IDI.LE.NTIM) THEN
                    N12(IDL,IDI) = N12(IDL,IDI) + 1
                    U1(IDL,IDI)  = U1(IDL,IDI)  + UIN(L,I,IT,IS)
                    U1S(IDL,IDI) = U1S(IDL,IDI) + UIN(L,I,IT,IS)**2
                    V1(IDL,IDI)  = V1(IDL,IDI)  + VIN(L,I,IT,IS)
                    V1S(IDL,IDI) = V1S(IDL,IDI) + VIN(L,I,IT,IS)**2
                    U2(IDL,IDI)  = U2(IDL,IDI)  + UIN(LL,II,IIT,IS)
                    U2S(IDL,IDI) = U2S(IDL,IDI) + UIN(LL,II,IIT,IS)**2
                    V2(IDL,IDI)  = V2(IDL,IDI)  + VIN(LL,II,IIT,IS)
                    V2S(IDL,IDI) = V2S(IDL,IDI) + VIN(LL,II,IIT,IS)**2
                    U12(IDL,IDI) = U12(IDL,IDI) +
     &                                  UIN(L,I,IT,IS)*UIN(LL,II,IIT,IS)
                    V12(IDL,IDI) = V12(IDL,IDI) +
     &                                  VIN(L,I,IT,IS)*VIN(LL,II,IIT,IS)
                  else
C                   WARNING: Either IDL or IDI out of bounds
C                   Cannot calculate stats!
C                   NTIM=5, so IDI=6 will trigger boundary fault.
C                   NL=34; IDL rarely exceeds NL
                  ENDIF
                ENDIF
               ENDDO
              ENDDO
            ENDDO
           ENDDO
          ENDDO
        ENDDO
      ENDDO

C  CALCULATE MEAN, STANDARD DEVIATION, CORRELATION COEFFICIENT
C  -----------------------------------------------------------

      DO J=0,NTIM
        DO I=0,NL
          CALL CSTATS(N12(I,J),U1(I,J),U1S(I,J),U2(I,J),U2S(I,J),
     &      U12(I,J),U1B(I,J),U2B(I,J),U1SD(I,J),U2SD(I,J),U12V(I,J),
     &      U12R(I,J))
          CALL CSTATS(N12(I,J),V1(I,J),V1S(I,J),V2(I,J),V2S(I,J),
     &      V12(I,J),V1B(I,J),V2B(I,J),V1SD(I,J),V2SD(I,J),V12V(I,J),
     &      V12R(I,J))
        ENDDO
      ENDDO

C  PRINT RESULTS
C  -------------

      WRITE(6,500) (ITIM(I),I=1,NTIM+1)
  500 FORMAT(/' TIMES: ',6I12)
      WRITE(6,501)
      DO I=0,NL
        WRITE(6,502) I,(N12(I,J),J=0,NTIM)
      ENDDO
  501 FORMAT(/' Count:',/,
     &       22X,'TIME DIFFERENCE (hours)'/
     &       '   DZ         0         1         2',
     &       '         3         4         5')
  502 FORMAT(I5,6I10)

      WRITE(6,500) (ITIM(I),I=1,NTIM)
      WRITE(6,503)
      DO I=0,NL
        WRITE(6,507) I,(U1SD(I,J),J=0,NTIM)
      ENDDO
  503 FORMAT(/' Standard Deviation, u-comp for data',
     &       ' at same (dz,dt):',/,
     &       5X,'TIME DIFFERENCE (hours)'/
     &       '   DZ    0    1    2    3    4    5')

      WRITE(6,500) (ITIM(I),I=1,NTIM+1)
      WRITE(6,504)
      DO I=0,NL
        WRITE(6,507) I,(V1SD(I,J),J=0,NTIM)
      ENDDO
  504 FORMAT(/' Standard Deviation, v-comp for data',
     &       ' at same (dz,dt):',/,
     &       5X,'TIME DIFFERENCE (hours)'/
     &       '   DZ    0    1    2    3    4    5')

      WRITE(6,500) (ITIM(I),I=1,NTIM)
      WRITE(6,505)
      DO I=0,NL
        WRITE(6,508) I,(U12R(I,J),J=0,NTIM)
      ENDDO
  505 FORMAT(/' Correlation Coefficient, u-comp for data',
     &       ' at same (dz,dt):',/,
     &       5X,'TIME DIFFERENCE (hours)'/
     &       '   DZ    0    1    2    3    4    5')

      WRITE(6,500) (ITIM(I),I=1,NTIM)
      WRITE(6,506)
      DO I=0,NL
        WRITE(6,508) I,(V12R(I,J),J=0,NTIM)
      ENDDO
  506 FORMAT(/' Correlation Coefficient, v-comp for data',
     &       ' at same (dz,dt):',/,
     &       5X,'TIME DIFFERENCE (hours)'/
     &       '   DZ    0    1    2    3    4    5')

  507 FORMAT(I5,6F5.1)
  508 FORMAT(I5,6F5.2)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: CSTATS
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1999-08-18
C
C ABSTRACT: CALCULATE MEANS, STANDARD DEVIATIONS, COVARIANCE, AND
C   CORRELATION COEFFICIENT.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  CORRECTED SOME DOCUMENTATION TYPO'S.
C
C USAGE:    CALL CSTATS(N,XS,XSS,YS,YSS,XYS,XB,YB,SX,SY,SXY,RXY)
C   INPUT ARGUMENT LIST:
C     N   - COUNT
C     XS  - SUM(SERIES 1 VALUES)
C     XSS - SUM(SQUARES OF SERIES 1 VALUES)
C     YS  - SUM(SERIES 2 VALUES)
C     YSS - SUM(SQUARES OF SERIES 2 VALUES)
C     XYS - SUM(PRODUCTS OF SERIES 1 AND SERIES 2 VALUES)
C
C   OUTPUT ARGUMENT LIST:
C     XB  - MEAN FOR SERIES 1
C     YB  - MEAN FOR SERIES 2
C     SX  - STANDARD DEVIATION FOR SERIES 1
C     SY  - STANDARD DEVIATION FOR SERIES 2
C     SXY - COVARIANCE OF SERIES 1 AND SERIES 2 VALUES
C     RXY - CORRELATION COEFFICIENT FOR SERIES 1 AND SERIES 2 VALUES
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE CSTATS(N,XS,XSS,YS,YSS,XYS,XB,YB,SX,SY,SXY,RXY)

C  CALCULATE MEANS, STANDARD DEVIATIONS, COVARIANCE, AND
C  CORRELATION COEFFICIENT.
C     N   - COUNT
C     XS  - SUM(SERIES 1 VALUES)
C     XSS - SUM(SQUARES OF SERIES 1 VALUES)
C     YS  - SUM(SERIES 2 VALUES)
C     YSS - SUM(SQUARES OF SERIES 2 VALUES)
C     XYS - SUM(PRODUCTS OF SERIES 1 AND SERIES 2 VALUES)
C     XB  - MEAN FOR SERIES 1
C     YB  - MEAN FOR SERIES 2
C     SX  - STANDARD DEVIATION FOR SERIES 1
C     SY  - STANDARD DEVIATION FOR SERIES 2
C     SXY - COVARIANCE OF SERIES 1 AND SERIES 2 VALUES
C     RXY - CORRELATION COEFFICIENT FOR SERIES 1 AND SERIES 2 VALUES
C  ----------------------------------------------------------------

      IF(N.NE.0) THEN
        ON  = 1./N
        XB  = XS*ON
        YB  = YS*ON
        RAD = (XSS-ON*XS**2)*ON
        IF(RAD.GT.0.) THEN
          SX = SQRT(RAD)
        ELSE
          SX = 0.
        ENDIF
        RAD = (YSS-ON*YS**2)*ON
        IF(RAD.GT.0.) THEN
          SY = SQRT(RAD)
        ELSE
          SY = 0.
        ENDIF
        SXY = (XYS-ON*XS*YS)*ON
	IF(SX*SY.NE.0.) THEN
          RXY = SXY/(SX*SY)
        ELSE
	  RXY = 0.
        ENDIF
      ENDIF
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: CUMPROB
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1999-08-18
C
C ABSTRACT: FOR A GIVEN X, RETURN THE CUMULATIVE PROBABILITY FOR
C   ABS(VALUE <= X). X IS ASSUMED TO BE NORMAL VARIATE.
C   USE LINEAR INTERPOLATION IN A TABLE.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C
C USAGE:    Y=CUMPROB(X)
C   INPUT ARGUMENT LIST:
C     X        - NORMAL VARIATE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      FUNCTION CUMPROB(X)

C  FOR A GIVEN X, RETURN THE CUMULATIVE PROBABILITY FOR
C  ABS(VALUE <= X). X IS ASSUMED TO BE NORMAL VARIATE.
C  USE LINEAR INTERPOLATION IN A TABLE.

      REAL P(0:40)
      DATA P/.5000,.5398,.5793,.6179,.6554,.6915,
     &       .7257,.7580,.7881,.8159,.8413,
     &       .8643,.8849,.9032,.9192,.9332,
     &       .9452,.9554,.9641,.9713,.9772,
     &       .9821,.9861,.9893,.9918,.9938,
     &       .9953,.9965,.9974,.9981,.9987,
     &       .9990,.9993,.9995,.9997,.9998,
     &       .9998,.9999,.9999,1.0000,1.0000/

      IF(X.GE.4.) THEN
        CUMPROB = 1.
      ELSE
        Y  = X*10.
        IY = Y
        F  = Y-IY
        PY = (1.-F)* P(IY) + F*P(IY+1)
        CUMPROB = 2.*(PY - .5000)
      ENDIF

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: ANLWT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2000-01-07
C
C ABSTRACT: FOR A GIVEN X>0., RETURN THE ANALYSIS WEIGHT FOR AN
C   OBSERVATION WITH A GIVEN NORMALIZED RESIDUAL OF X.  IN
C   ORDER TO GET X, THE MEAN IS SUBTRACTED AND THEN DIVIDED BY
C   THE STANDARD DEVIATION.  LINEAR INTERPOLATION IS USED FROM THE
C   FOLLOWING TABLE.  IT IS ASSUMED (FROM PAST DATA) THAT PER IS
C   THE PROPORTION OF THE DATA THAT ARE IN ERROR.  ALL ROUGH
C   ERRORS ARE ASSUMED TO BE CONTAINED WITHIN B STANDARD DEVIATIONS.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2000-01-07  W. COLLINS  CHANGE TO AGREE WITH FORMULATION BY
C                         CQCBUFR.
C
C USAGE:    Y=ANLWT(X,B,PER)
C   INPUT ARGUMENT LIST:
C     X        - NORMAL VARIATE
C     B        - LIMIT WRT STANDARD DEVIATIONS FOR ROUGH ERRORS
C     PER      - ASSUMED PROPORTION OF DATA WITH ERRORS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      FUNCTION ANLWT(X,B,PER)

C  FOR A GIVEN X>0., RETURN THE ANALYSIS WEIGHT FOR AN OBSERVATION
C  WITH A GIVEN NORMALIZED RESIDUAL OF X.  IN ORDER TO GET X,
C  THE MEAN IS SUBTRACTED AND THEN DIVIDED BY THE STANDARD
C  DEVIATION.  LINEAR INTERPOLATION IS USED FROM THE FOLLOWING
C  TABLE.  IT IS ASSUMED (FROM PAST DATA) THAT PER IS THE
C  PROPORTION OF THE DATA THAT ARE IN ERROR.  ALL ROUGH ERRORS
C  ARE ASSUMED TO BE CONTAINED WITHIN B STANDARD DEVIATIONS.

      REAL W(0:50)
      DATA W/.3989,.3970,.3910,.3814,.3683,.3521,.3332,.3123,
     &       .2897,.2661,.2420,.2179,.1942,.1714,.1497,.1295,
     &       .1109,.0940,.0790,.0656,.0540,.0440,.0355,.0283,
     &       .0224,.0175,.0136,.0104,.0079,.0060,.0044,.0033,
     &       .0024,.0017,.0012,.0009,.0006,.0004,.0003,.0002,
     &       .0001,.00009,.00006,.00004,.00002,.00002,.00001,
     &       .00001,.00000,.00000,.00000/

      IF(X.GE.5.) THEN
        WINT = 0.
      ELSE
        Y  = X*10.
        IY = Y
        F  = Y-IY
        WINT = (1.-F)* W(IY) + F*W(IY+1)
      ENDIF

      PNOT = 1.-PER
      CPRIME = 0.5/B
      DENOM = PNOT*WINT + PER*CPRIME
      IF(DENOM.NE.0.) THEN
        ANLWT = PNOT*WINT/DENOM
      ELSE
        ANLWT = 1.
      ENDIF

cwgc  A = .5*PER/B
cwgc  P = (1.-A)*WINT + A*(B+X)
cwgc  S = (1.-A)*WINT

cwgc  IF(P.NE.0.) THEN
cwgc    ANLWT = S/P
cwgc  ELSE
cwgc    ANLWT = 1.
cwgc  ENDIF

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: DISTR
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1991-07-23
C
C ABSTRACT: FOR GIVEN DATA, CALCULATE THE 0TH THROUGH 4TH MOMENTS.
C   ALSO PRODUCE BINNED DISTRIBUTION.
C
C PROGRAM HISTORY LOG:
C 1991-07-23  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED FLEXIBILITY BY UTILIZING NDIV AND
C       NX AS ARRAY LIMITS RATHER THAN THE HARD-CODED 23 AND 899,
C       RESPECTIVELY. ADDED MORE DESCRIPTIVE DOCUMENTATION. ALSO 
C       ADDED DIAGNOSTIC OUTPUT STATEMENT WHEN LIMITS ARE EXCEEDED. 
C
C USAGE:    CALL DISTR(X, MSK, XLIM, XMSG, NX, N, NDIV, DDIV, NZERO,
C                      DZERO, NS, X1, SD, SK, XK)
C   INPUT ARGUMENT LIST:
C     X        - DATA
C     MSK      - MASK: VALUE = 0 -- USE IN COMPUTATIONS
C                      VALUE.NE.0 -- DONT USE
C     XLIM     - (1) MINIMUM VALUE TO USE
C                (2) MAXIMUM VALUE TO USE
C     XMSG     - MISSING VALUE FOR VARIABLE
C     NX       - DIMENSION OF X AND MSK
C     NDIV     - NUMBER OF DIVISIONS (DIMENSION OF N)
C     DDIV     - DIVISION SIZE
C     NZERO    - = 0, USE DZERO AS CENTER
C                = 1, USE MEAN AS CENTER
C     DZERO    - CENTRAL DIVISION LOCATION
C
C   OUTPUT ARGUMENT LIST:
C     N        - OUTPUT DISTRIBUTION, COUNT IN EACH DIVISION
C     NS       - COUNT OF VALUES USED
C     X1       - FIRST MOMENT (MEAN)
C     X2       - SECOND MOMENT
C     X3       - THIRD MOMENT
C     X4       - FOURTH MOMENT
C     SD       - STANDARD DEVIATION (POPULATION)
C                  = SQRT(X2 - X1**2)
C     SK       - SKEWNESS = X3/(X2)**(3/2)
C     XK       - KURTOSIS = X4/(SD**4) - 3
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE DISTR(X,MSK,XLIM,XMSG,NX,N,NDIV,DDIV,NZERO,DZERO,NS,X1,
     &                 SD,SK,XK)

      INTEGER N(NDIV), MSK(NX)
      REAL X(NX),XLIM(2)

      DZERO0 = DZERO

C     COMPUTE VARIOUS POWERS OF X.
C     ----------------------------

      NS   = 0
      SUM1 = 0.
      SUM2 = 0.
      SUM3 = 0.
      SUM4 = 0.
      DO I=1,NX
        IF(MSK(I).EQ.0.AND.ABS(X(I)).LT.XMSG
     &    .AND.X(I).GE.XLIM(1).AND.X(I).LE.XLIM(2)) THEN
          NS = NS + 1
          SUM1 = SUM1 + X(I)
          SUM2 = SUM2 + X(I)**2
          SUM3 = SUM3 + X(I)**3
          SUM4 = SUM4 + X(I)**4
        ENDIF
      END DO
      IF(NS.LT.1) THEN
        DZERO0 = 0.
        X1 = 0.
        SD = 0.
        SK = 0.
        XK = 0.
        GO TO 15
      ENDIF
      SUM1 = SUM1/NS
      SUM2 = SUM2/NS
      SUM3 = SUM3/NS
      SUM4 = SUM4/NS

C     CALCULATE VARIOUS OUTPUT STATISTICS.
C     ------------------------------------

      X1 = SUM1
      ARG = SUM2 - SUM1**2
      IF(ARG.GT.0.) THEN
        SD = SQRT(ARG)
      ELSE
        SD = 0.
      ENDIF
      X3 = SUM3 - 3.*SUM2*SUM1 + 2.*SUM1**3
      IF(SUM2.GT.0.) THEN
        SK = X3/(SUM2)**1.5
      ELSE
        SK = 0.
      ENDIF
      X4 = SUM4 - 4.*SUM3*SUM1 + 6.*SUM2*SUM1**2 - 3.*SUM1**4
      IF(SD.GT.0.) THEN
        XK = (X4/SD**4) - 3.0
      ELSE
        XK = 0.
      ENDIF

C     COUNT THE NUMBER OF OBSERVATIONS IN EACH DIVISION.
C     --------------------------------------------------

   15 CONTINUE

      IF(DDIV.EQ.0.) DDIV = 1.
      IF(NZERO.EQ.1) DZERO0 = SUM1
      N(1:NDIV) = 0
      CON = 0.5*NDIV + 1.0 - DZERO0/DDIV
      DO I=1,NX
        IF(MSK(I).EQ.0.AND.ABS(X(I)).LT.XMSG
     &          ) THEN
cwgc &    .AND.X(I).GE.XLIM(1).AND.X(I).LE.XLIM(2)) THEN
          INDEX = X(I)/DDIV + CON
          IF(INDEX.LT.1) INDEX = 1
          if(index.gt.ndiv) then
C           print *, 'WARNING: INDEX > NDIV, SET INDEX = NDIV'
            index = ndiv
          endif
          N(INDEX) = N(INDEX) + 1
        ENDIF
      END DO
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: DRCTSL
C   PRGMMR: WOOLLEN          ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: DRIVER FOR CHOLESKY TYPE LINEAR EQUATION SOLVER.
C
C PROGRAM HISTORY LOG:
C 1990-11-06  J. WOOLLEN
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:
C   INPUT ARGUMENTS:
C     FAALL      - ARRAY OF SYMMETRIC MATRIXES
C     RAALL      - ARRAY OF MATRIX RIGHT HAND SIDES
C     NDIM       - ARRAY OF MATRIX RANKS
C     MAXDIM     - MAXIMUM RANK MATRIX IN MATRIX ARRAY
C     NXXYY      - NUMBER OF MATRIXES IN MATRIX ARRAY
C     NFT        - NUMBER OF RIGHT HAND SIDE VECTORS PER MATRIX
C   OUTPUT ARGUMENTS:
C     RAALL      - ARRAY OF MATRIX SOLUTIONS
C     DOTPRD     - ARRAY OF DOT PRODUCTS OF RHS VECTORS WITH MATRIX
C                  SOLUTIONS
C
C REMARKS: ILL CONDITIONED OR NON POSITIVE DEFINITE MATRIXES ARE
C          IDENTIFIED BY DOT PRODUCTS GT 1 OR LT 0 OR BY A MESSAGE
C          FROM VSOLVE. FIVE ATTEMPTS ARE MADE TO SOLVE BAD ONES,
C          BY RIDGE REGRESSION, AFTER WHICH A NULL SOLUTION IS RETURNED.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE DRCTSL(FAALL,RAALL,DOTPRD,NDIM,MAXDIM,NXXYY,NFT)

      PARAMETER(NSTN=300)
      DIMENSION  FAALL(NSTN,45), DOTPRD(NSTN,1), RAALL(NSTN,9,1),
     &           NDIM(NSTN)
      DIMENSION  A(NSTN,45),B(NSTN,9,1),BAD(NSTN),SMOOTH(6)
      LOGICAL BAD
      DATA SMOOTH /1.00,1.01,1.02,1.05,1.10,2.00/

C----------------------------------------------------------------------

C  LOOP FOR POSSIBILITY OF BAD MATRICES
C  ------------------------------------

      DO ITRY=1,6

         NBAD = 0

C  INITIALIZE THE WORKING ARRAYS
C  -----------------------------

         A(1:NXXYY,1:MAXDIM*(MAXDIM+1)/2) =
     &                              FAALL(1:NXXYY,1:MAXDIM*(MAXDIM+1)/2)

         B(1:NXXYY,1:MAXDIM,1:NFT) = RAALL(1:NXXYY,1:MAXDIM,1:NFT)

         DOTPRD(1:NXXYY,1:NFT) = 0.

         DO J=1,MAXDIM
            JJ = J*(J+1)/2
            A(1:NXXYY,JJ) = FAALL(1:NXXYY,JJ)*SMOOTH(ITRY)
         END DO

C  CALL THE MATRIX SOLVER
C  ----------------------

         CALL VSOLVE (A,B,NDIM,BAD,NFT,NXXYY,MAXDIM)

C  MAKE THE DOT PRODUCTS OF SOLUTIONS WITH RIGHT HAND SIDES
C  --------------------------------------------------------

         DO K=1,NFT
            DO J=1,MAXDIM
               DO I=1,NXXYY
                  DOTPRD(I,K) = DOTPRD(I,K) + RAALL(I,J,K)*B(I,J,K)
               END DO
            END DO
         END DO

         DO K=1,NFT
            DO I=1,NXXYY
               IF(DOTPRD(I,K).GT.1.)THEN
                  DO J=1,MAXDIM
                     B(I,J,K) = B(I,J,K)/DOTPRD(I,K)
                  END DO
                  DOTPRD(I,K) = 1.
               ENDIF
            END DO
         END DO

C  CHECK FOR BAD ONES - DO IT AGAIN IF NECESSARY
C  ---------------------------------------------

         DO J=1,NFT
            DO I=1,NXXYY
               BAD(I) = BAD(I).OR.DOTPRD(I,J).LT.0..OR.DOTPRD(I,J).GT.1.
            END DO
         END DO

         DO I=1,NXXYY
            IF(BAD(I)) THEN
               DOTPRD(I,1:NFT) = 0.
               B(I,1:MAXDIM,1:NFT) = 0.
               NBAD = NBAD + 1
            ENDIF
         END DO

         IF(NBAD.NE.0) THEN
            PRINT*, 'NBAD=',NBAD,' ON TRY ',ITRY
         ELSE
            GOTO 55
         ENDIF

      END DO

C  COPY SOLUTIONS INTO OUTPUT ARRAY - ZERO BAD ONES OUT
C  ----------------------------------------------------

55    CONTINUE
      
      RAALL(1:NXXYY,1:MAXDIM,1:NFT) = B(1:NXXYY,1:MAXDIM,1:NFT)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: EVNOUT
C   PRGMMR: S. Melchior      ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: THE PRESENT REPORT IS IN /SINGLE/ AND STNID WITH INDICES
C   FROM NUM1 TO NUM2.  FOLLOWING CODE WILL LOOK AT THE EVENTS
C   STORED IN /EVENTS/ FOR MATCHES.  ARRAYS OF MATCHES WILL
C   BE FORMED FOR WRITING THE ACTUAL EVENTS TO THE OUTPUT
C   BUFR FILE.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2001-10-08  D. KEYSER   NOW TABULATES PERCENT OF LEVELS < 18K
C       FAILING BIRD ALGORITM CHECK ACCORDING TO STATION AND
C       1-HOUR TIME WINDOWS CENTERED ON 30-MIN PAST HOUR, THIS
C       BIRD Q.C. INFORMATION WRITTEN TO UNIT 52 FOR LATER USE
C       BY SSI IN Q.C. OF NEXRAD RADIAL VELOCITY DATA
C 2012-03-05  S. MELCHIOR  UPDATED TO USE INCOMING ARGUMENT NLV TO
C       DEFINE MEMORY ALLOCATION FOR VARIOUS REAL AND INTEGER ARRAYS.
C       THIS MAKES THE SUBROUTINE MORE ROBUST AND EFFICIENT BY ONLY
C       ALLOTTING THE MEMORY SPACE NECESSARY, NOTHING MORE.  ADDED
C       PARAMETER NEVNT=160000 TO TIDY UP THE CODE. CORRECTED  SOME
C       DOCUMENTATION TYPO'S. ADDED DIAGNOSTIC OUTPUT STATEMENT WHEN
C       LIMITS ARE EXCEEDED. RENAMED NE to NME TO EASE NAVIGATION AND
C       FOR CLARIFICATION SINCE NE IS USED FOR INEQUALITY TESTING
C       (.NE.). INCREASED NRPT FROM 80000 TO 160000 TO ACCOMMODATE VAD
C       WIND REPORTS FROM LEVEL 2 DECODER.
C 2012-03-05  D. KEYSER   UPDATED PROCESSING OF RADAR STATION IDS TO
C       ACCOMMODATE VAD WIND REPORTS FROM LEVEL 2 DECODER.  THESE
C       REPORTS COME IN WITH THE STATION ID FORMATTED WITH ONLY 4
C       CHARACTERS WHEREAS LEGACY (RADAR CODED MESSAGE) VAD WIND
C       REPORTS HAVE STATION IDS WITH 7 CHARACTERS.
C 2014-01-15  S. Melchior  Increased NRPT (total number of levels
C       amongst all VAD reports that can be processed) and NEVNT (total
C       number of events amongst all VAD reports that can be processed)
C       both from 160000 to 500000 to accommodate VAD wind reports from
C       Level 2 decoder.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL EVNOUT(NUM1,NUM2,NLV)
C   INPUT ARGUMENT LIST:
C     NUM1     - LOWER LIMIT OF EVENTS TO SCAN
C     NUM2     - UPPER LIMIT OF EVENTS TO SCAN
C     NLV      - NUMBER OF LEVELS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE EVNOUT(NUM1,NUM2,NLV)

      PARAMETER (NRPT=500000,NSTN=300,NLEV=35)
      parameter (nevnt=500000)
      REAL(8)   BMISS

      COMMON /SINGLE/ ZOB(NRPT), ITM(NRPT),TIM(NRPT),
     &                UOB(NRPT), VOB(NRPT), LOB(NRPT),
     &                XLA(NRPT), XLO(NRPT), ZST(NRPT),
     &                UFF(NRPT), VFF(NRPT), TFF(NRPT),
     &                WQM(NRPT)
      COMMON /STN/    SLAT(NSTN), SLON(NSTN), SIDS(NSTN), STNID(NRPT),
     &                ZSTN(NSTN)
      COMMON /EVENTS/ SIDEV(nevnt), HTEV(nevnt),LEV(nevnt),
     &                TIMEV(nevnt), UEV(nevnt), VEV(nevnt),
     &                QALEV(nevnt), RCEV(nevnt)
      COMMON /HTS/    IZLEV(NLEV), ZLEV(NLEV)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /BUFRLIB_MISSING/BMISS
      COMMON /FLAG/   guess
      COMMON /BIRDST/stnidx(9999,-3:3),alatx(9999,-3:3),
     & alonx(9999,-3:3),knt_5_yes(9999,-3:3),knt_5_no(9999,-3:3),
     & numrpt(9999,-3:3)
      common /switches/  print_52, print_53, print_60, test
      LOGICAL         guess, PRINT_52, PRINT_53
      REAL            UE(nlv*2), VE(nlv*2), QALE(nlv*2), RCE(nlv*2),
     &                ETYP(nlv*2)

      INTEGER         INP(nlv*2)
      CHARACTER*8     SIDS, STNID, SIDEV
      character*8     stnidx
      CHARACTER*40    WEVN
      DATA WEVN   /'UOB VOB WQM WPC WRC                     '/

      IF(NUM2.LT.NUM1 .OR. NME.EQ.0) RETURN

      INP  = 0
      UE   = BMISS
      VE   = BMISS
      QALE = BMISS
      RCE  = BMISS

C  THE PRESENT REPORT IS IN /SINGLE/ AND STNID WITH INDICES
C  FROM NUM1 TO NUM2.  FOLLOWING CODE WILL LOOK AT THE EVENTS
C  STORED IN /EVENTS/ FOR MATCHES.  ARRAYS OF MATCHES WILL
C  BE FORMED FOR WRITING THE ACTUAL EVENTS TO THE OUPUT
C  BUFR FILE.

C  LOOP THRU EVENTS
C  ----------------

      ETYP = 0
      NEVN = 0
      loop1: do n=num1,num2
       DO IEV=1,NME !  nme max is nev and nevnt
         IF(SIDEV(IEV).EQ.STNID(N) .AND.
     &      ABS(HTEV(IEV)-ZOB(N)).LT.10. .AND.
     &      TIMEV(IEV).EQ.TIM(N)) THEN
           NEVN = NEVN + 1
  500      FORMAT(' N,IEV,NEVN,NLV,NUM1,NUM2,LEV =',7I5,' FOR ',A8)
           if(nevn.gt.nlv*2) then
             print *, 'WARNING: NEVN > NLV, EXIT LOOP'
             WRITE(6,500) N,IEV,NEVN,NLV,NUM1,NUM2,LEV(IEV),STNID(N)
             nevn = nevn - 1
             exit LOOP1
           endif
           INP(NEVN) = LEV(IEV)
           UE(NEVN) = UEV(IEV)
           VE(NEVN) = VEV(IEV)
           QALE(NEVN) = QALEV(IEV)
           RCE(NEVN)  = RCEV(IEV)
           ETYP(LOB(N)) = RCEV(IEV)
         ENDIF
       ENDDO
      enddo loop1

      IF(NEVN.GT.0) CALL EVENTW(IOUT,WEVN,NLV,UE,VE,QALE,RCE,INP,NEVN,
     &                          real(ICQCPC))

      if(print_52)  then

C  KEEP TRACK OF LEVELS FAILING BIRD ALG. FOR LATER Q.C. INFO LISTING
C  ------------------------------------------------------------------

         read(stnid(num1),'(i4)',err=99)  kndx
         go to 98  ! these are ids from Radar Coded Message
   99    continue  ! these are ids from Level 2 decoder
         kndx = 0
         do iii = 1,nst
            if(stnid(num1).eq.sids(iii)) then
               kndx = iii
               exit
            endif
         enddo
   98    continue
         if(kndx.ge.1.and.kndx.le.9999)  then
            jtim = nint(tim(num1)+0.50)
            if(jtim.ge.-3.and.jtim.le.3)  then
               stnidx(kndx,jtim) = stnid(num1)
               alatx(kndx,jtim) = xla(num1)
               alonx(kndx,jtim) = xlo(num1)
               numrpt(kndx,jtim) = numrpt(kndx,jtim) + 1
            end if
         end if
      end if

      IF(PRINT_53) THEN
         WRITE(53,501) ITM(NUM1),TIM(NUM1),STNID(NUM1),XLA(NUM1),
     &     XLO(NUM1),ZST(NUM1)
         WRITE(53,502)
      END IF
      if(print_52 .or. print_53) then
         DO N=NUM1,NUM2
            IF(PRINT_53)WRITE(53,503)LOB(N),ZOB(N),UOB(N),VOB(N),UFF(N),
     &       VFF(N),TFF(N),ETYP(LOB(N))
            if(print_52) then
               if(kndx.ge.1.and.kndx.le.9999) then
                  if(jtim.ge.-3.and.jtim.le.3)  then
                     if(zob(n).lt.5487.) then ! less than 18,000 feet 
                        if(nint(etyp(lob(n))).eq.5) then
                           knt_5_yes(kndx,jtim) = knt_5_yes(kndx,jtim)+1
                        else
                           knt_5_no(kndx,jtim) = knt_5_no(kndx,jtim) + 1
                        end if
                     end if
                  end if
               end if
            end if
         ENDDO
      end if
  501 FORMAT(/,1X,I10,1X,F8.3,1X,A8,1X,F7.2,1X,F8.2,1X,F8.0)
  502 FORMAT(' LOB    ZOB    UOB    VOB    UFF    VFF    TFF',
     &       ' TYP')
  503 FORMAT(2X,I2,F7.0,5(F7.1),F4.0)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: EVENTW
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1997-05-23
C
C ABSTRACT: COMPUTE EXPANSION FACTOR FOR CORECT.
C
C PROGRAM HISTORY LOG:
C 1994-MM-DD  J. WOOLLEN
C 1997-05-23  W. COLLINS  MODIFIED FOR WIND EVENT.
C 2012-03-05  S. MELCHIOR  CLARIFIED DOCUMENTATION.
C
C USAGE:   CALL EVENTW(LUNIT,EVNSTR,NLV,UOBS,VOBS,QMS,RCS,IND,NEVN,IQCPC)
C   INPUT ARGUMENT LIST:
C     LUNIT    - UNIT NUMBER
C     EVNSTR   - EVENT STREAM OF CHARACTERS
C     NLV      - NUMBER OF LEVELS
C     UOBS     - OBSERVED U VALUES
C     VOBS     - OBSERVED V VALUES
C     QMS      - QUALITY MARKER
C     RCS      - REASON CODE
C     IND      - INDIRECT ADDRESS OF VALUE
C     NEVN     - NUMBER OF EVENTS
C     QCPC     - PROGRAM CODE
C
C   OUTPUT ARGUMENT LIST:
C     NONE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE EVENTW(LUNIT,EVNSTR,NLV,UOBS,VOBS,QMS,RCS,IND,NEVN,
     &                  QCPC)
      LOGICAL  PRINT_60
      CHARACTER*(*) EVNSTR
      DIMENSION     UOBS(NEVN),VOBS(NEVN),QMS(NEVN),RCS(NEVN),IND(NEVN)
      REAL(8)       EVNS_8(5,255),BMISS

      COMMON /BUFRLIB_MISSING/BMISS
      common /switches/  print_52, print_53, print_60, test

C-----------------------------------------------------------------------

      IF(NEVN.EQ.0) GOTO 100


C  CLEAR THE UFB ARRAY FIRST
C  -------------------------

      EVNS_8 = BMISS

C  TRANSFER EVENT ARRAYS INTO UFB ARRAY
C  ------------------------------------

      DO I=1,NEVN
        J = IND(I)
        IF(UOBS(I).LT.BMISS .AND. J.LE.255) THEN
           EVNS_8(1,J) = UOBS(I)
           EVNS_8(2,J) = VOBS(I)
           EVNS_8(3,J) = QMS(I)
           EVNS_8(4,J) = QCPC
           EVNS_8(5,J) = RCS(I)
        ENDIF
      ENDDO

C  WRITE THE EVENTS
C  ----------------

      CALL UFBINT(LUNIT,EVNS_8,5,NLV,IRET,EVNSTR)

  100 CONTINUE

      IF(PRINT_60) WRITE(60,501) LUNIT,NEVN,NLV,IRET,EVNSTR,
     & QCPC
  501 FORMAT(' EVENTW--LUNIT,NEVN,NLV,IRET,EVNSTR:',4I5,A60,
     &  ' QCPC:',F8.0)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: GETDAT
C   PRGMMR: S. Melchior      ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: READ PREPBUFR DATA
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2001-10-08  D. KEYSER   VALID DATES FOR CHECKING FOR MIGRATING
C       BIRDS EXPANDED FROM 2/15 THROUGH 6/15 TO 2/1 THROUGH 6/30
C       IN SPRING AND FROM 8/15 THROUGH 11/15 TO 8/1 THROUGH 11/30
C       IN FALL
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO
C       TIDY UP THE CODE. ADDED DIAGNOSTIC OUTPUT PRINT STATEMENTS
C       WHEN LIMITS ARE EXCEEDED. RENAMED NE TO NME TO EASE NAVIGATION
C       AND FOR CLARIFICATION SINCE NE IS USED FOR INEQUALITY TESTING
C       (.NE.).  ADDED LOGIC TO TURN OFF BIRD CHECK ALGORITHM FOR VAD
C       WIND REPORTS FROM LEVEL 2 DECODER.  CORRECTED LOGIC TO HANDLE
C       SITUATIONS WHEN THE SUBSET IS VADWND BUT THE NUMBER OF LEVELS
C       (NUM) EXCEEDS NRPT.  INCREASED NRPT FROM 80000 TO 160000 TO
C       ACCOMMODATE VAD WIND REPORTS FROM LEVEL 2 DECODER.
C 2014-01-15  S. Melchior  Increased NRPT (total number of levels
C       amongst all VAD reports that can be processed) from 160000 to
C       500000 to accommodate VAD wind reports from Level 2 decoder.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.  Also made a minor logic correction
C       so that the station info for the "NSTN'th" id is stored if
C       there are at least that many unique ids.
C
C USAGE:    CALL GETDAT(ITIME)
C   INPUT ARGUMENT LIST:
C     ITIME    - INDICTES FIRST OR SECOND READ OF DATA
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE GETDAT(ITIME)

      PARAMETER (NRPT=500000,NSTN=300,NLEV=35,NTIMES=6,NINC=3)
      PARAMETER (MLV=255)         ! no. of possible levels
      INTEGER IDAT(8), JDAT(8), ITIMES(8,4)
      REAL    TDIF(5,4), RINC(5)
      REAL(8) HDR_8(10), OBS_8(7,MLV), BMISS
      CHARACTER*2 AYR, AHR
      CHARACTER*3 ADOY
      CHARACTER*8 CDR(10),SUBSET,YYMM,DDHH,Q,SID,STNID,SIDS
      CHARACTER*10 CDATE
      EQUIVALENCE (HDR_8,CDR)
      COMMON /SINGLE/ ZOB(NRPT), ITM(NRPT),TIM(NRPT),
     &                UOB(NRPT), VOB(NRPT), LOB(NRPT),
     &                XLA(NRPT), XLO(NRPT), ZST(NRPT),
     &                UFF(NRPT), VFF(NRPT), TFF(NRPT),
     &                WQM(NRPT)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /STN/    SLAT(NSTN), SLON(NSTN), SIDS(NSTN), STNID(NRPT),
     &                ZSTN(NSTN)
      COMMON /DATET/  IDATE(4), ITIM(6)
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT,
     &                CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /BUFRLIB_MISSING/BMISS
      COMMON /BIRDS/ BIRDTIME
      DATA ITIMES/0, 2,01,0,0,0,0,0,
     &            0, 6,30,0,0,0,0,0,
     &            0, 8,01,0,0,0,0,0,
     &            0,11,30,0,0,0,0,0/

C  READ CENTRAL TIME (year,month,day,hour)
C  ---------------------------------------

      IF(ITIME.EQ.1) THEN
        CALL DATELEN(10)
        REWIND IUTIM
        READ(IUTIM,500) (IDATE(I),I=1,4)
        WRITE(6,501) (IDATE(I),I=1,4)
  500   FORMAT(I4,3I2)
  501   FORMAT(' GETDAT--IDATE (central data time): ',I4,3I2.2)

C------------------------------------------------
C  NCEP absolute date and time data structure:
C    (1)     4-digit year
C    (2)     month of year (1-12)
C    (3)     day of month (1-31)
C    (4)     hhmm time zone differential from UTC
C    (5)     hour of day in 24-hour clock (0-23)
C    (6)     minutes of hour (0-59)
C    (7)     seconds of minute (0-59)
C    (8)     milliseconds of second (0-999)
C------------------------------------------------
C  NCEP relative time interval data structure
C    (1)     number of days
C    (2)     number of hours
C    (3)     number of minutes
C    (4)     number of seconds
C    (5)     number of milliseconds
C------------------------------------------------
C  Note! IDAT and JDAT are in absolute time, while
C  RINC is in relative time.
C  IDAT and JDAT are INTEGER;  RINC is REAL.
C------------------------------------------------

        IDAT      = 0
        IDAT(1:3) = IDATE(1:3)
        IDAT(5)   = IDATE(4)
        DO I=1,6
          MIT = I-1+IHE
          RINC(1) = 0
          RINC(2) = MIT
          RINC(3) = 0
          RINC(4) = 0
          RINC(5) = 0
          CALL W3MOVDAT(RINC,IDAT,JDAT)
          ITIM(I) = JDAT(5)+100*(JDAT(3)+100*(JDAT(2)+100*JDAT(1)))
        ENDDO

        WRITE(6,505) (ITIM(I),I=1,6)
  505   FORMAT(' GETDAT--ITIM(I): ',6I12)

C  COMPARE TIMES FOR "ANTI-BIRD" ROUTINE
C  -------------------------------------

        ITIMES(1,1:4) = IDATE(1)
        DO J=1,4
          CALL W3DIFDAT(IDAT,ITIMES(1,J),1,TDIF(1,J))
          WRITE(6,511) (IDAT(II),II=1,8),(ITIMES(II,J),II=1,8),
     &                  TDIF(1,J)
  511     FORMAT(' GETDAT--IDAT,ITIMES,TDIF: ',8I5,4X,8I5,4X,F8.2)
        ENDDO
        IF(TDIF(1,1).GT.0. .AND. MAX(TDIF(1,2),TDIF(1,3),TDIF(1,4))
     &   .LT.0.) THEN
          BIRDTIME = 1.           ! between 01 Feb and 30 Jun
        ELSE IF(MIN(TDIF(1,1),TDIF(1,2),TDIF(1,3)).GT.0. .AND.
     $   TDIF(1,4).LT.0.) THEN
          BIRDTIME = 2.           ! between 01 Aug and 30 Nov
        ELSE
          BIRDTIME = 0.
        ENDIF

        WRITE(6,506) BIRDTIME
  506   FORMAT(' GETDAT--BIRDTIME: ',F5.0,/,
     &    '     1. - between 01 Feb and 30 Jun',/,
     &    '     2. - between 01 Aug and 30 Nov',/,
     &    '     0. - otherwise')

      ENDIF

C  INITIALIZE DATA COLLECITON ARRAYS
C  ---------------------------------

      NUM   = 0
      OBS_8   = BMISS
      ZOB   = BMISS
      UOB   = BMISS
      VOB   = BMISS
      UIN   = BMISS
      VIN   = BMISS
      XLA   = BMISS
      XLO   = BMISS
      ITM   = 0
      TIM   = BMISS
      STNID = '        '

      CALL CLOSBF(IUNIT)
      REWIND IUNIT
      CALL OPENBF(IUNIT,'IN',IUNIT)
      CALL READMG(IUNIT,SUBSET,KDATE,IRETMG)
      IF(IRETMG.NE.0) GOTO 6
      WRITE(CDATE,'(I10)') KDATE
      PRINT*,'DATA VALID AT ',CDATE
      CALL UFBQCD(IUNIT,'CQCVAD ',ICQCPC)
      WRITE(6,502) ICQCPC
  502 FORMAT(' PROGRAM CODE NUMBER =',I5.5)
      CALL CLOSBF(IUNIT)
      REWIND IUNIT
      CALL OPENBF(IUNIT,'IN',IUNIT)
      IF(ITIME.EQ.2) CALL OPENBF(IOUT,'OUT',IUNIT)
      IS = 0
      IRETSB = 1

C  READ A REPORT
C  -------------

    5 CONTINUE
      IF(IRETSB.NE.0) CALL READMG(IUNIT,SUBSET,KDATE,IRETMG)
    6 CONTINUE
      IF(IRETMG.NE.0) THEN
        WRITE(6,510) IUNIT, IOUT
  510   FORMAT(' GETDAT--CLOSING UNITS:',2I4)
        CALL CLOSBF(IUNIT)
        CALL CLOSBF(IOUT)
        GOTO 20
      ENDIF
      IF(ITIME.EQ.2) THEN
        IF(SUBSET.NE.'VADWND') THEN
          CALL CLOSMG(IOUT)
          CALL COPYMG(IUNIT,IOUT)
          GOTO 5
        ELSE
          if(num.ge.nrpt) then
            iretsb = -1
            go to 5
          endif
          CALL OPENMB(IOUT,SUBSET,KDATE)
        ENDIF
      ELSE IF(SUBSET.NE.'VADWND') THEN
        GOTO 5
      else if(num.ge.nrpt) then
        iretsb = -1
        go to 5
      ENDIF
   30 CONTINUE
      CALL READSB(IUNIT,IRETSB)
      IF(IRETSB.NE.0) GOTO 5
 
      CALL GETOBV(IUNIT,HDR_8,NLV,OBS_8)

C  COLLECT STATION DATA
C  --------------------

      NUM1 = NUM + 1
      RINC = 0
      IDAT = 0
      DO I=1,NLV
        IF(OBS_8(1,I).GE.CON.AND.MAX(OBS_8(2,I),OBS_8(3,I)).LT.BMISS)
     $   THEN
          NUM        = NUM + 1
          if(num.ge.nrpt) then
            print *,'WARNING: NUM>=NRPT, can''t process anymore VAD obs'
            call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     $       ' "$jlogfile" "***WARNING: NUM >= NRPT, cannot process '//
     $       'any more VAD reports"')
            iretsb = -1
            go to 5
          endif
          STNID(NUM) = CDR(1)
          XLO(NUM)   = HDR_8(2)
          XLA(NUM)   = HDR_8(3)
          ZST(NUM)   = HDR_8(5)
          IDAT(1) = ITIM(1)/1000000
          IDAT(2) = MOD(ITIM(1)/10000,100)
          IDAT(3) = MOD(ITIM(1)/100,100)
          IDAT(5) = MOD(ITIM(1),100)
          RINC(2) = HDR_8(4) - IHE
          CALL W3MOVDAT(RINC,IDAT,JDAT)
          ITM(NUM) = JDAT(5)+100*(JDAT(3)+100*(JDAT(2)+100*JDAT(1)))
          TIM(NUM)   = HDR_8(4)
          LOB(NUM)   = I
          ZOB(NUM)   = OBS_8(1,I)
          UOB(NUM)   = OBS_8(2,I)
          VOB(NUM)   = OBS_8(3,I)
          UFF(NUM)   = OBS_8(4,I)
          VFF(NUM)   = OBS_8(5,I)
          TFF(NUM)   = OBS_8(6,I)
          WQM(NUM)   = OBS_8(7,I)
        ENDIF

c     Turn off bird algorithm QC for VAD wind reports from Level 2
c      decoder
      read(stnid(num),'(i4)',err=89) kdmy
      go to 90 ! radar coded vadwnd data
   89 continue ! VAD wind reports from Level 2 decoder
      birdtime = 0. ! override regardless of season
   90 continue

      ENDDO
      NUM2 = NUM
      if(num.ge.nrpt) then
        print *,'WARNING: NUM>=NRPT, can''t process anymore VAD obs'
        call system('[ -n "$jlogfile" ] && $DATA/postmsg'//
     $  ' "$jlogfile" "***WARNING: NUM >= NRPT, cannot process '//
     $  'any more VAD reports"')
        iretsb = -1
        go to 5
      endif

      IF(ITIME.EQ.2) THEN
        CALL UFBCPY(IUNIT,IOUT)
        CALL EVNOUT(NUM1,NUM2,NLV)
        CALL WRITSB(IOUT)
      ENDIF

      GOTO 30

   20 CONTINUE

      WRITE(6,508) NUM, ITIME
  508 FORMAT(' Number of levels reported: ',I6,'  for ITIME: ',I1)

      IF(ITIME.EQ.2) RETURN

C  ALL DATA IS NOW READ IN.  DO PROCESSING ON LINEAR ARRAYS OF DATA.
C  -----------------------------------------------------------------

C  MAKE A LIST OF THE STATIONS REPORTING
C  -------------------------------------

      NST = 0
      sids(1) = '        ' ! initialize sids(1)
      LOOP1: DO I=1,NUM
        LOOP1n1: DO IS=1,NSTN
          IF(SIDS(IS).EQ.STNID(I)) CYCLE LOOP1
        ENDDO LOOP1n1
        if(nst.ge.nstn) then
          print *, 'WARNING: NST>=NSTN, EXIT LOOP'
          exit LOOP1
        endif
        NST = NST + 1
        SIDS(NST) = STNID(I)
        SLAT(NST) = XLA(I)
        SLON(NST) = XLO(I)
        ZSTN(NST) = ZST(I)
      ENDDO LOOP1

      WRITE(6,507) NST
  507 FORMAT(' Number of stations reporting: ',I5,/,
     &       '    Station     Lat     Lon  Stn Ht')
      WRITE(6,509) (SIDS(I),SLAT(I),SLON(I),ZSTN(I),I=1,NST)
  509 FORMAT(1X,A10,2F8.2,F8.0)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: GETOBV
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1997-03-18
C
C ABSTRACT: Read data for a single observation. Place the data in
C   OBS_8.
C
C PROGRAM HISTORY LOG:
C   97-03-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED MORE DESCRIPTIVE DOCUMENTATION AND
C       CORRECTED DOCUMENTATION TYPO.
C
C USAGE:    CALL GETOBV(LUBFR,HDR_8,NLEV,OBS_8)
C   INPUT ARGUMENT LIST:
C     LUBFR    - UNIT NO. OF INPUT BUFR FILE
C
C   OUTPUT ARGUMENT LIST:
C     HDR_8    - ARRAY OF OB HEADER INFORMATION
C     NLEV     - NUMBER OF LEVELS
C     OBS_8    - ARRAY OF OBSERVATIONS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      SUBROUTINE GETOBV(LUBFR,HDR_8,NLEV,OBS_8)

C     THIS SUBROUTINE RETURNS ALL EVENTS FOR AN OBSERVATION

      PARAMETER (MVR=10)       ! dimensions of header
      PARAMETER (MLV=255)      ! number of possible levels

C     Last index of OBS_8: value, fcst value, quality mark, program
c     code, reason code

      CHARACTER*28 OBSTR
      CHARACTER*40 HDSTR
      REAL(8) HDR_8(10), OBS_8(7,MLV), BMISS

      COMMON /BUFRLIB_MISSING/BMISS

      DATA HDSTR /'SID XOB YOB DHR ELV ITP TYP             '/
      DATA OBSTR /'ZOB UOB VOB UFC VFC TFC WQM '/

      HDR_8 = BMISS
      OBS_8 = BMISS

C  READ HEADER
C  -----------

      CALL UFBINT(LUBFR,HDR_8,MVR,1,IRET,HDSTR)

C  READ EVENTS
C  -----------

      CALL UFBINT(LUBFR,OBS_8,7,MLV,NLEV,OBSTR)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: HT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1999-08-18
C
C ABSTRACT: COMPUTE VERTICAL INDEX FOR HEIGHT
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED MISSING RETURN STATEMENT.
C       RENAMED NE TO NME FOR EASE OF NAVIGATION AND FOR
C       CLARIFICATION SINCE NE IS USED FOR INEQUALITY 
C       TESTING (.NE.).
C
C USAGE:    CALL HT(Z,IHT,IER)
C   INPUT ARGUMENT LIST:
C     Z        - HEIGHT (M)
C
C   OUTPUT ARGUMENT LIST:
C     IHT      - VERTICAL INDEX FOR HEIGHT
C     IER      = 0  ALL OK
C              = 1  BAD HEIGHT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE HT(Z,IHT,IER)

      PARAMETER (NLEV=35)
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME

      IHT = 0
      IER = 0
      IZ = Z/CON + 0.49
      DO L=1,NLEV
        LL = L
        IF(IZ.EQ.IZLEV(L)) THEN
           IHT = LL
           RETURN
        END IF
      ENDDO

      IER = 1
      return

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: INCDIST
C   PRGMMR: S. Melchior      ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: COMPUTE STATISTICS AND DISTRIBUTIONS FOR INCREMENTS
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  EXTENDED MSK ARRAY ALLOCATION FROM 899 TO
C       1000 TO ALLOW FOR MORE STATION STATISTICS TO BE PROCESSED - ON
C       OCCASION THE 899 LIMIT HAD BEEN MET AND EXCEEDED. ADDED
C       PARAMETERS NTIMES=6, NINC=3, AND NDIV=23  TO TIDY UP THE CODE. 
C       ADDED DIAGNOSTIC OUTPUT STATEMENTS WHEN LIMITS ARE EXCEEDED.
C       RENAMED NE TO NME TO EASE NAVIGATION AND FOR CLARIFICATION AS
C       NE IS USED FOR INEQUALITY TESTING (.NE.). INCREASED NRPT FROM
C       80000 TO 160000 TO ACCOMMODATE VAD WIND REPORTS FROM LEVEL 2
C       DECODER.
C 2014-01-15  S. Melchior Added integer "icntmx" to define the max
C       value of icnt in the multi-nested do loop that hinges on the
C       number of levels (NLEV), the number of stations (NST), the
C       number of times (NTIMES), and the number of increments (NINC).
C       Increased NRPT (total number of levels amongst all VAD reports
C       that can be processed) from 160000 to 500000 to accommodate
C       VAD wind reports from Level 2 decoder.
C 2014-08-29  S. Melchior  Extended MSK, UW, and VW array allocations
C       from 1000 to 3600 (NSTN*NTIMES*NINC) to allow for a complete
C       set of station statistics to be processed.  On occasion the
C       1000 limit had been met and exceeded, losing out on station
C       statistics.
C 2014-09-04  S. Melchior  Redefined MSK, UW, and VW arrays to
C       utilize parameters NSTN, NTIMES, and NINC rather than 
C       explicitly setting the array size at 3600. "icntmx" is no 
C       longer necessary but will be retained because it may prove
C       useful for future debugging.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL INCDIST
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE INCDIST

      PARAMETER (NRPT=500000,NSTN=300,NLEV=35,NDIV=23,NTIMES=6,NINC=3)

      COMMON /STN/    SLAT(NSTN), SLON(NSTN), SIDS(NSTN), STNID(NRPT),
     &                ZSTN(NSTN)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /DATET/  IDATE(4), ITIM(6)

      CHARACTER*8 SIDS, STNID
      COMMON /STATS/  UW(nstn*ntimes*ninc),VW(nstn*ntimes*ninc),
     &                XM(NLEV,2),SD(NLEV,2),XLIM(2)
      COMMON /DMATYP/ IQC(NLEV,NTIMES,NINC,NSTN)
      REAL        UWS(60,NSTN),VWS(60,NSTN)
      REAL        XMS(NLEV,2,NSTN),SDS(NLEV,2,NSTN)

      INTEGER     NMS(NDIV,NLEV,2,NSTN),NCS(NLEV,2,NSTN),ICNTS(NSTN)
      INTEGER     NM(NDIV,NLEV,2),MSK(nstn*ntimes*ninc),NC(NLEV,2),
     &            icntmx
      LOGICAL BYSTN
      BYSTN = .TRUE.
      DATA XMSG /99999./
      XLIM(1) = -12.
      XLIM(2) =  12.
      MSK = 0
      icntmx = nst*ntimes*ninc
      DO L=1,NLEV

C  PUT DATA INTO WORK ARRAY
C  ------------------------

	ICNT = 0
  	UW = 0.
  	VW = 0.
  	ICNTS = 0
        UWS = 0.
        VWS = 0.
        LOOP1n1: DO IS=1,NST !  nst max is nstn
          DO IT=1,NTIMES ! ntimes max is 6
            IF(NIN(L,IT,IS).GT.0) THEN
              DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
                IF(IQC(L,IT,N,IS).EQ.0) THEN
                  ICNT = ICNT + 1
                  UW(ICNT) = UIN(L,IT,N,IS)
                  VW(ICNT) = VIN(L,IT,N,IS)
                ENDIF
                IF(BYSTN .AND. (IQC(L,IT,N,IS).EQ.0 .OR.
     &            IQC(L,IT,N,IS).EQ.5)) THEN  ! Dont exclude bird winds
                  ICNTS(IS) = ICNTS(IS) + 1
                  if(icnts(is).gt.60) then
                    print *, 'WARNING: ICNTS(IS)>60, EXIT LOOP'
                    icnts(is) = icnts(is) - 1
                    exit LOOP1n1
                  endif
                  UWS(ICNTS(IS),IS) = UIN(L,IT,N,IS)
                  VWS(ICNTS(IS),IS) = VIN(L,IT,N,IS)
                ENDIF
              ENDDO
            ENDIF
          ENDDO
        ENDDO LOOP1n1

C  GET DISTRIBUTIONS
C  -----------------

	BINI = 2.0
        CALL DISTR(UW,MSK,XLIM,XMSG,ICNT,NM(1,L,1),NDIV,BINI,0,0.,
     &             NC(L,1),XM(L,1),SD(L,1),SK,XK)
        CALL DISTR(VW,MSK,XLIM,XMSG,ICNT,NM(1,L,2),NDIV,BINI,0,0.,
     &             NC(L,2),XM(L,2),SD(L,2),SK,XK)
        IF(BYSTN) THEN
          DO IS=1,NST !  nst max is nstn
            CALL DISTR(UWS(1,IS),MSK,XLIM,XMSG,ICNTS(IS),NMS(1,L,1,IS),
     &        NDIV,BINI,0,0.,NCS(L,1,IS),XMS(L,1,IS),SDS(L,1,IS),SK,XK)
            CALL DISTR(VWS(1,IS),MSK,XLIM,XMSG,ICNTS(IS),NMS(1,L,2,IS),
     &        NDIV,BINI,0,0.,NCS(L,2,IS),XMS(L,2,IS),SDS(L,2,IS),SK,XK)
          ENDDO
        ENDIF

      ENDDO

C  PRINT DISTRIBUTIONS
C  -------------------

      WRITE(6,500) (IDATE(I),I=1,4), BINI
      WRITE(6,501)
      WRITE(6,502)
      WRITE(6,503) (IZLEV(L), (NM(I,L,1),I=1,NDIV), L=1,NLEV)

      WRITE(6,504)
      WRITE(6,502)
      WRITE(6,503) (IZLEV(L), (NM(I,L,2),I=1,NDIV), L=1,NLEV)

      WRITE(6,505)
      WRITE(6,506) (IZLEV(L),NC(L,1),XM(L,1),SD(L,1),XM(L,2),
     &              SD(L,2),SQRT(SD(L,1)**2+SD(L,2)**2),L=1,NLEV)

      IF(BYSTN) THEN
       IDATE(1) = IDATE(1) - 1000
       WRITE(55) IDATE,NST,SIDS,SLAT,SLON,ZSTN
       WRITE(55) NCS,XMS,SDS,NMS,BINI,XLIM
       IDATE(1) = IDATE(1) + 1000
       DO IS=1,NST
c       WRITE(6,507) SIDS(IS), SLON(IS), SLAT(IS)
c       WRITE(6,501)
c       WRITE(6,502)
c       WRITE(6,503) (IZLEV(L), (NMS(I,L,1,IS),I=1,23), L=1,NLEV)

c       WRITE(6,507) SIDS(IS), SLON(IS), SLAT(IS)
c       WRITE(6,504)
c       WRITE(6,502)
c       WRITE(6,503) (IZLEV(L), (NMS(I,L,2,IS),I=1,23), L=1,NLEV)

        WRITE(6,507) SIDS(IS), SLON(IS), SLAT(IS)
        WRITE(6,505)
        DO L=1,NLEV
         IF(NCS(L,1,IS).GT.0) WRITE(6,506) IZLEV(L),NCS(L,1,IS),
     &    XMS(L,1,IS),SDS(L,1,IS),XMS(L,2,IS),SDS(L,2,IS),
     &    SQRT(SDS(L,1,IS)**2+SDS(L,2,IS)**2)
        ENDDO
       ENDDO
      ENDIF


  500 FORMAT(/' VAD wind increment statistics for ',I4,3I2.2,
     &       '   Bin increment = ',F8.2,' m/s',
     &       '  (bad & bird winds excluded)')
  501 FORMAT(/50X,'--------DISTRIBUTION FOR U-COMPONENT--------')
  502 FORMAT(' HEIGHT(1000s ft) <-10  -10   -9   -8   -7   -6',
     &  '   -5   -4   -3   -2   -1    0    1    2    3    4    5',
     &  '    6    7    8    9   10  >10')
  503 FORMAT(6X,I5,6X,23I5)
  504 FORMAT(/50X,'--------DISTRIBUTION FOR V-COMPONENT--------')
  505 FORMAT(/' HEIGHT(1000s ft)  Num      U-Mean  U-StdDev',
     &       '    V-Mean  V-StdDev Mag-StdDev')
  506 FORMAT(6X,I5,6X,I5,2X,5F10.1)
  507 FORMAT(/'STATISTICS FOR STATION: ',A8,'  AT (',F8.2,',',F8.2,')',
     &  '  (bad, but not bird winds excluded)')

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: INCR
C   PRGMMR: S. Melchior      ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: Compute increments (observation - guess)
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO TIDY
C       UP THE CODE. RENAMED NE TO NME TO EASE NAVIGATION AND FOR
C       CLARIFICATION AS NE IS USED FOR INEQUALITY TESTING (.NE.).
C       INCREASED NRPT FROM 80000 TO 160000 TO ACCOMMODATE VAD WIND
C       REPORTS FROM LEVEL 2 DECODER.
C 2014-01-15  S. Melchior  Increased NRPT (total number of levels
C       amongst all VAD reports that can be processed) from 160000 to
C       500000 to accommodate VAD wind reports from Level 2 decoder.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL INCR
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE INCR

      PARAMETER (NRPT=500000,NSTN=300,NLEV=35,NTIMES=6,NINC=3)

      REAL(8)  BMISS

      COMMON /DATET/  IDATE(4), ITIM(6)
      COMMON /STN/    SLAT(NSTN), SLON(NSTN), SIDS(NSTN), STNID(NRPT),
     &                ZSTN(NSTN)
      COMMON /SINGLE/ ZOB(NRPT), ITM(NRPT),TIM(NRPT),
     &                UOB(NRPT), VOB(NRPT), LOB(NRPT),
     &                XLA(NRPT), XLO(NRPT), ZST(NRPT),
     &                UFF(NRPT), VFF(NRPT), TFF(NRPT),
     &                WQM(NRPT)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /BUFRLIB_MISSING/BMISS
      COMMON /FLAG/ guess
      LOGICAL     guess, FIRST
      CHARACTER*8 SIDS, STNID
      DATA   FIRST /.TRUE./

C  CALCULATE THE INCREMENT (OBSERVATION - GUESS)
C  ---------------------------------------------

      DO I=1,NUM !  num max is nrpt
        DO J=1,NST ! nst max is nstn
          IF(STNID(I).EQ.SIDS(J)) THEN
            CALL HT(ZOB(I),IHT,IER)
            IF(IER.EQ.0 .AND. IHT.GT.0 .AND. IHT.LE.NLEV) THEN
              IT = 0
              LOOP1n2: DO II=1,6
                IF(ITIM(II).EQ.ITM(I)) THEN
	          IT = II
                  EXIT LOOP1n2
                  ENDIF
              ENDDO  LOOP1n2
              IF(IT.GE.1 .AND. IT.LE.6) THEN

C  THE USE OF N HERE WILL CAPTURE THE FIRST TWO AND LAST
C  INCREMENTS FOR EACH HOUR
C  -----------------------------------------------------

                N = NIN(IHT,IT,J)
                IF(N.LT.3) THEN
                  N = N+1
                  NIN(IHT,IT,J) = N
                ENDIF
                IF(MAX(UFF(I),VFF(I)).LT.BMISS) THEN
                  UIN(IHT,IT,N,J)   = UOB(I) - UFF(I)
                  VIN(IHT,IT,N,J)   = VOB(I) - VFF(I)
                ELSE
                  IF(FIRST) THEN
C  Since guess is missing, mark all data as bad
                     guess = .FALSE.
                     WRITE(6,500)
                     WRITE(6,500)
                     WRITE(6,500)
  500                FORMAT(' *****GUESS IS MISSING; ALL DATA ARE',
     &                      ' FLAGGED*****')
                     FIRST = .FALSE.
                  ENDIF
                ENDIF
                LLL(IHT,IT,N,J)   = LOB(I)
                UUU(IHT,IT,N,J)   = UOB(I)
                VVV(IHT,IT,N,J)   = VOB(I)
                QQQ(IHT,IT,N,J)   = WQM(I)
                TFC(IHT,IT,N,J)   = TFF(I)
                TIMIN(IHT,IT,N,J) = TIM(I)
              ENDIF
            ELSE
              PRINT *,' UNUSUAL HT: ',ZOB(I)
            ENDIF
          ENDIF
        ENDDO
      ENDDO

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: INDEXX
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1999-08-18
C
C ABSTRACT: Indexes an array arr(1:n), i.e., outputs the array
C   indx(1:n) such that arr(indx(j)) is in ascending order for
C   j=1,2,...,N.  The input quantities n and arr are not changed.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C
C USAGE:    CALL indexx(n,arr,indx)
C   INPUT ARGUMENT LIST:
C     arr      - input array
C     n        - array size
C
C   OUTPUT ARGUMENT LIST:
C     indx     - index array for ascending order of arr
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE indexx(n,arr,indx)

      INTEGER n,indx(n),M,NSTACK
      REAL arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      REAL a

C     Indexes an array arr(1:n), i.e., outputs the array indx(1:n) such
C     that arr(indx(j)) is in ascending order for j=1,2,...,N.  The
C     input quantities n and arr are not changed.

      do j=1,n
        indx(j)=j
      enddo
      jstack=0
      l=1
      ir=n
1     continue
      if(ir-l.lt.M)then
        do j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do i=j-1,1,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
          enddo
          i=0
2         continue
          indx(i+1)=indxt
        enddo
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(l)))then
          itemp=indx(l+1)
          indx(l+1)=indx(l)
          indx(l)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       continue
        indx(l)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: INIT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: Initialize some quantities.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO
C       TIDY UP THE CODE. RENAMED NE TO NME FOR EASE OF 
C       NAVIGATION AND FOR CLARIFICATION AS NE IS USED FOR 
C       INEQUALITY TESTING (.NE.).
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL INIT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE INIT

      PARAMETER(NSTN=300,NLEV=35,NTIMES=6,NINC=3)

      REAL(8)   BMISS

      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /BUFRLIB_MISSING/BMISS

      ZLEV(:) = CON * IZLEV(:)

      UIN =   BMISS
      VIN =   BMISS
      TIMIN = BMISS
      NIN   = 0

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: MATR
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: SET UP THE MATRICES FOR THE HEIGHT-TIME OI ANALYSIS
C   THE ANALYSIS EQUATION IS AW=C
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO
C       TIDY UP THE CODE. RENAMED NE TO NME FOR EASE OF 
C       NAVIGATION AND ALSO FOR CLARIFICATION AS NE IS USED FOR
C       INEQUALITY TESTING (.NE.).
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL MATR(IS,IT)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C     IT       - TIME INDEX
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE MATR(IS,IT)

      PARAMETER(NSTN=300,NLEV=35,NTIMES=6,NINC=3)
      COMMON /MATRIC/ A(NSTN,45), C(NSTN,9), NMAT(NSTN), NM
      COMMON /COLECT/ LS(NSTN,NLEV,NINC), JS(NSTN,NLEV,NINC),
     $                NS(NSTN,NLEV,NINC), NC(NLEV,NINC),
     &                DS(NSTN,NLEV,NINC),
     &                LTSCOL(9,NLEV,NTIMES,NINC,NSTN)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /HTS/  IZLEV(NLEV), ZLEV(NLEV)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /CONSTS/ MAT,E,AA,B,XL,R
      DATA IFIRST /0/

C  SET UP THE MATRICES FOR THE HEIGHT-TIME OI ANALYSIS
C  THE ANALYSIS EQUATION IS AW=C
C  ---------------------------------------------------

      DIS(T1,T2,Z1,Z2) = SQRT((T2-T1)**2 + (R*(Z2-Z1))**2)
      COV(X) = AA + B*(1.+X/XL)*EXP(-X/XL)
      IX(I,J) = I*(I-1)/2 + J

      IF(IFIRST.EQ.0) THEN
        WRITE(6,509) MAT,E,AA,B,XL,R
  509   FORMAT(/,I3,' POINTS USED IN INTERPOLATION',/,
     &       ' NOISE-TO-SIGNAL RATIO ASSUMED TO BE:',F8.2,/,
     &       ' COV(X) = A+B*(1.+X/XL)*EXP(-X/XL) WITH A = ',
     &       F8.2,'  B = ',F8.2,' AND XL = ',F8.2,/,
     &       ' DIS(T1,T2,Z1,Z2) = SQRT((T2-T1)**2 + (R*(Z2-Z1))**2)',
     &       ' WITH R = ',F8.2/)
        IFIRST = 1
      ENDIF

      NM   = 0
      A    = 0.
      C    = 0.
      NMAT = 0
      DO L=1,NLEV
        IF(NIN(L,IT,IS).NE.0) THEN
          DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
            NM = NM + 1
            MT = MIN(MAT,NC(L,N))
            NMAT(NM) = MT

C  MATRIX A DIAGONALS, USING TRIANGULAR FORM OF STORAGE
C  ----------------------------------------------------

            DO I=1,MT
              A(NM,IX(I,I)) = 1. + E
            ENDDO

C  REST OF MATRIX A
C  ----------------

            DO J=1,MT
              DO I=1,MT
                IF(I.GT.J) THEN
                  LI = LS(I,L,N)
                  NI = NS(I,L,N)
                  II = JS(I,L,N)
                  LJ = LS(J,L,N)
                  NJ = NS(J,L,N)
                  IJ = JS(J,L,N)
                  ZI = IZLEV(LI)
                  ZJ = IZLEV(LJ)
                  D  = DIS(TIMIN(LI,II,NI,IS),TIMIN(LJ,IJ,NJ,IS),
     &                     ZI,ZJ)
                  A(NM,IX(I,J)) = COV(D)
                  IF(NM.LE.2) THEN
                  ENDIF
                ENDIF
              ENDDO
            ENDDO

C  RIGHT-HAND-SIDE, MATRIX C
C  -------------------------

            DO I=1,MT
              C(NM,I) = COV(DS(I,L,N))
            ENDDO
          ENDDO
        ENDIF
      ENDDO

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: DMA
C   PRGMMR: S. Melchior      ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: THIS IS THE DECISION MAKING ALGORITHM.  IT DETERMINES
C   THE DATA QUALITY.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2001-10-08  D. KEYSER   CORRECTED ERROR WHICH HAD RESULTED IN NO
C       Q.C. PERFORMED ON LEVELS WHERE EITHER THE U- OR V- INCREMENT
C       WAS ZERO; LIMITING V-WIND INCREMENT FOR APPLYING BIRD
C       CONTAMINATION TIGHTENED FROM +8 TO +5 M/S IN SPRING AND FROM
C       -8 TO -5 M/S IN FALL, MORE LEVELS WILL NOW BE FLAGGED
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6, NINC=3, AND
C       NEVNT=160000 TO TIDY UP THE CODE. ADDED DIAGNOSTIC OUTPUT
C       STATEMENTS FOR INSTANCES WHEN LIMITS ARE EXCEEDED. RENAMED NE
C       TO NME FOR EASE OF NAVIGATION AND ALSO FOR CLARIFICATION AS NE
C       IS USED FOR INEQUALITY TESTING (.NE.). INCREASED NRPT FROM
C       80000 TO 160000 TO ACCOMMODATE VAD WIND REPORTS FROM LEVEL 2
C       DECODER.
C 2014-01-15  S. Melchior  Increased NRPT (total number of levels
C       amongst all VAD reports that can be processed) and NEVNT (total
C       number of events amongst all VAD reports that can be processed)
C       both from 160000 to 500000 to accommodate VAD wind reports from
C       Level 2 decoder.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL DMA(HONOR_FLAGS)
C   INPUT ARGUMENT LIST:
C     HONOR_FLAGS  - TRUE IF EXISTING FLAGS ARE HONORED
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE DMA(HONOR_FLAGS)

      PARAMETER (NRPT=500000,NSTN=300,NLEV=35,NTIMES=6,NINC=3)
      PARAMETER (nevnt=500000)
      CHARACTER*8 SIDS, STNID, SIDEV

      REAL(8)   BMISS

      COMMON /HTRES/  RGU(NLEV,NTIMES,NINC,NSTN),
     &                RGV(NLEV,NTIMES,NINC,NSTN)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /EVENTS/ SIDEV(nevnt), HTEV(nevnt),LEV(nevnt),
     &                TIMEV(nevnt), UEV(nevnt), VEV(nevnt),
     &                QALEV(nevnt), RCEV(nevnt)
      COMMON /STATS/  UW(nstn*ntimes*ninc),VW(nstn*ntimes*ninc),
     &                XM(NLEV,2),SD(NLEV,2),XLIM(2)
      COMMON /STN/    SLAT(NSTN), SLON(NSTN), SIDS(NSTN), STNID(NRPT),
     &                ZSTN(NSTN)
      COMMON /COLECT/ LS(NSTN,NLEV,NINC), JS(NSTN,NLEV,NINC),
     &                NS(NSTN,NLEV,NINC), NC(NLEV,NINC),
     &                DS(NSTN,NLEV,NINC),
     &                LTSCOL(9,NLEV,NTIMES,NINC,NSTN)
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /CONSTS/ MAT,E,AA,B,XL,R
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /BIRDS/  BIRDTIME
      COMMON /DMATYP/ IQC(NLEV,NTIMES,NINC,NSTN)
      COMMON /DATET/  IDATE(4), ITIM(6)
      COMMON /BUFRLIB_MISSING/BMISS
      common /switches/  print_52, print_53, print_60, test
      common /flag/ guess
      LOGICAL         VSNG, VDBL, TEST, VBIRD, VBIG,
     &                HONOR_FLAGS, guess
      integer numerr(0:9,0:NLEV), ndata(0:NLEV)

      IQC    = 0
      ndata  = 0
      numerr = 0
      NME     = 0
      nme1    = 0
      nme2    = 0
      DO IS=1,NST ! nst max is nstn
        DO IT=1,6
          VECINL = 0.
          VECZTL = 0.
          LAST   = 0
          DO L=1,NLEV
            IF(NIN(L,IT,IS).NE.0) THEN
              DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
                VSNG  = .FALSE.
                VDBL  = .FALSE.
                VBIRD = .FALSE.
                VBIG  = .FALSE.

c               count data
c               ----------

                ndata(0) = ndata(0) + 1
                ndata(l) = ndata(l) + 1

                if(guess)  then

C------------------------------------------------------------------
C  VECIN AND VECZT ARE ESTIMATES OF STANDARDIZED NORMAL VARIATE
C------------------------------------------------------------------

                   IF(SD(L,1).NE.0. .AND. SD(L,2).NE.0.) THEN
                     VECIN = SQRT(((UIN(L,IT,N,IS)-XM(L,1))/SD(L,1))**2
     &                          + ((VIN(L,IT,N,IS)-XM(L,2))/SD(L,2))**2)
                   ELSE
                     VECIN = SQRT(((UIN(L,IT,N,IS)-XM(L,1))/5.5)**2
     &                          + ((VIN(L,IT,N,IS)-XM(L,2))/5.5)**2)
                   ENDIF
                   VECZT = SQRT((RGU(L,IT,N,IS)/1.4)**2
     &                        + (RGV(L,IT,N,IS)/1.4)**2)

                   B     = 10.0        ! Max error
                   PER   = 0.07        ! Proportion of rough errors
                   WLIM1 = 0.55
                   WLIM2 = 0.3

                   WP  = 0.5*(ANLWT(VECZT ,B,PER) + ANLWT(VECIN ,B,PER))
                   WPL = 0.5*(ANLWT(VECZTL,B,PER) + ANLWT(VECINL,B,PER))
                   IF(WP.LT.WLIM2)          VSNG = .TRUE.
                   IF(MAX(WP,WPL).LT.WLIM1) VDBL = .TRUE.

                   CP  = 0.5*(CUMPROB(VECZT ) + CUMPROB(VECIN ))
                   CPL = 0.5*(CUMPROB(VECZTL) + CUMPROB(VECINL))
cwgc               IF(CP.GE..995 .OR. (UUU(L,IT,N,IS)**2
cwgc &               + VVV(L,IT,N,IS)**2).LT.1.)  VSNG = .TRUE.
cwgc               IF(MIN(CP,CPL).GE.0.995)       VDBL = .TRUE.

                   IF((UUU(L,IT,N,IS)**2 + VVV(L,IT,N,IS)**2).GT.1.)THEN
                      IF(TFC(L,IT,N,IS).GT.-3..OR.TFC(L,IT,N,IS).GE.
     &                 BMISS) THEN
cdak  10/08/2001         IF(BIRDTIME.EQ.1. AND. VIN(L,IT,N,IS).GT. 8.)
                         IF(BIRDTIME.EQ.1. AND. VIN(L,IT,N,IS).GT. 5.)
     &                    VBIRD = .TRUE.
cdak  10/08/2001         IF(BIRDTIME.EQ.2. AND. VIN(L,IT,N,IS).LT.-8.)
                         IF(BIRDTIME.EQ.2. AND. VIN(L,IT,N,IS).LT.-5.)
     &                    VBIRD = .TRUE.
                      END IF
                      IF(MAX(ABS(UIN(L,IT,N,IS)),ABS(VIN(L,IT,N,IS)))
     &                 .GT.12.) VBIG = .TRUE.
                   END IF

                   ITYP = 0
                   IF(VBIRD)  THEN
                      ITYP = 5
                   ELSE IF((UUU(L,IT,N,IS)**2+VVV(L,IT,N,IS)**2).LT.1.)
     &              THEN
                      ITYP = 4
                   ELSE IF(VSNG) THEN
                      ITYP = 1
                      IF(VDBL) ITYP = 3
                   ELSE IF(VDBL) THEN
                      ITYP = 2
                   ELSE  IF(VBIG) THEN
                      ITYP = 7
                   END IF
                else
                   ityp = 9
                end if

C  DO NOT WRITE A NEW EVENT IF PRE-EXISTING FLAG IS TO BE HONORED
C  AND INDICATES DATA BAD OR NOT TO BE USED
C  --------------------------------------------------------------

                IF(HONOR_FLAGS .AND. QQQ(L,IT,N,IS).GE.4.) THEN
                  IQC(L,IT,N,IS) = QQQ(L,IT,N,IS)
                  ITYP = 0
                ENDIF

                IF(ITYP.NE.0 .OR. .NOT.HONOR_FLAGS) THEN
                  numerr(ityp,0) = numerr(ityp,0) + 1
                  numerr(ityp,l) = numerr(ityp,l) + 1

C  SAVE EVENTS
C  -----------

                  NME  = NME + 1
                  NME1 = NME1 + 1
                  if(nme.gt.nev) then
                    print *, 'WARNING: NME > NEV, STOP PROCESSING'
                    go to 900
                  endif
                  SIDEV(NME) = SIDS(IS)
                  HTEV(NME)  = ZLEV(L)
                  LEV(NME)   = LLL(L,IT,N,IS)
                  TIMEV(NME) = TIMIN(L,IT,N,IS)
                  UEV(NME)   = UUU(L,IT,N,IS)
                  VEV(NME)   = VVV(L,IT,N,IS)
                  IF(ITYP.NE.0) THEN
                    QALEV(NME) = 13.
                  ELSE
                    QALEV(NME) = 1.
                  ENDIF
                  RCEV(NME)  = ITYP
                  IQC(L,IT,N,IS) = ITYP
                  IF(VDBL .AND. LAST.NE.0) THEN
                    NME  = NME + 1
                    NME2 = NME2 + 1
                    if(nme.gt.nev) then
                      print *, 'WARNING: NME > NEV, STOP PROCESSING'
                      go to 900
                    endif
                    SIDEV(NME) = SIDS(IS)
                    HTEV(NME)  = ZLEV(LAST)
                    LEV(NME)   = LLL(LAST,IT,N,IS)
                    TIMEV(NME) = TIMIN(LAST,IT,N,IS)
                    UEV(NME)   = UUU(LAST,IT,N,IS)
                    VEV(NME)   = VVV(LAST,IT,N,IS)
                    QALEV(NME) = 13.
                    RCEV(NME)  = ITYP
                    IQC(LAST,IT,N,IS) = ITYP
                  ENDIF

C  WRITE STATION INFORMATION
C  -------------------------

                  IF(TEST) THEN
                     WRITE(6,500)
                     WRITE(6,501) SIDS(IS),TIMIN(L,IT,N,IS),L,IT,
     &                N,UUU(L,IT,N,IS),VVV(L,IT,N,IS),UIN(L,IT,N,IS),
     &                VIN(L,IT,N,IS),RGU(L,IT,N,IS),RGV(L,IT,N,IS),
     &                CP,CPL,WP,WPL,ITYP,TFC(L,IT,N,IS)
                  END IF
                  ITEMP = 0
                  ISUBT = 0
                  IF(LTSCOL(1,L,IT,N,IS).NE.0) THEN

C  WRITE INFORMATION ABOUT DATA USED IN Z-T INTERPOLATION
C  ------------------------------------------------------

                    LOOP1: DO I=1,9
                      IF(LTSCOL(I,L,IT,N,IS).EQ.0) EXIT LOOP1
                      LL = LTSCOL(I,L,IT,N,IS)/100
                      IF(LL.LT.1 .OR. LL.GT.NLEV) EXIT LOOP1
                      ITS = LTSCOL(I,L,IT,N,IS)-100*LL
                      IF(ITS.NE.0) THEN
                         ITEMP = ITS/10
                         ISUBT = ITS-10*ITEMP
                         IF(ITEMP.LT.1 .OR. ITEMP.GT.5 .OR.
     &                      ISUBT.LT.1 .OR. ISUBT.GT.3) EXIT LOOP1
                      END IF
                      DIST = SQRT((TIMIN(L,IT,N,IS)
     &                  - TIMIN(LL,ITEMP,ISUBT,IS))**2
     &                  + (R**2) * (IZLEV(L)-IZLEV(LL))**2)
                      if(guess)  then
                         IF(SD(LL,1).NE.0. .AND. SD(LL,2).NE.0.) THEN
                            VECTIN =
     &                       SQRT(((UIN(LL,ITEMP,ISUBT,IS)-XM(LL,1))
     &                       / SD(LL,1))**2 + ((VIN(LL,ITEMP,ISUBT,IS)
     &                       - XM(LL,2))/SD(LL,2))**2)
                         ELSE
                            VECTIN =
     &                       SQRT(((UIN(LL,ITEMP,ISUBT,IS)-XM(LL,1))
     &                       / 5.5)**2 + ((VIN(LL,ITEMP,ISUBT,IS)
     &                       - XM(LL,2))/5.5)**2)
                         ENDIF
                      end if
                      IF(TEST) WRITE(6,504) DIST,LL,ITEMP,ISUBT,
     &                 UIN(LL,ITEMP,ISUBT,IS),VIN(LL,ITEMP,ISUBT,IS)
                    ENDDO  LOOP1
                  END IF
                ENDIF
                VECZTL = VECZT
                VECINL = VECIN
                LAST = L
              ENDDO
            ENDIF
          ENDDO
        ENDDO
      ENDDO

  500 FORMAT(/1X,'STN/DIST  TIME   L  IT   N (   UOB,    VOB)',
     &       ' (  UIN,    VIN) (  RGU,    RGV)     CP     CPL',
     &       '      WP     WPL ITYP     TFC')
  501 FORMAT(1X,A8,F6.2,3I4,6F8.2,4F8.3,I5,F8.1)
  504 FORMAT(1X,F8.1,3I4,16X,2F8.2)

      write(6,511) (idate(j),j=1,4),nst
      write(6,512)
      write(6,513) ndata(0),(numerr(i,0),i=1,5),numerr(7,0),numerr(9,0),
     &             nme1
      do l=1,NLEV
        nsum = 0
        do ie=1,7
          nsum = nsum + numerr(ie,l)
        enddo
        write(6,514) izlev(l),ndata(l),(numerr(i,l),i=1,5),
     &    numerr(7,l),numerr(9,l),nsum
      enddo
  511 format(/' Date: ',i4,3i2.2,'   Number of stations reporting: ',i4)
  512 format(21x,'<---------------error type------------->',/,
     &  ' Height  Data_count    1     2     3     4     5     7     9',
     &       '  Error_count')
  513 format('    all',i9,2x,7i6,i8)
  514 format(1x,i6,i9,2x,7i6,i8)

      RETURN

  900 CONTINUE
      WRITE(6,505)
  505 FORMAT(' TOO MANY EVENTS')

      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: RESDIST
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: COMPUTE STATISTICS AND DISTRIBUTIONS OF RESIDUALS OF
C   CHECKS.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  EXTENDED MSK ARRAY ALLOCATION FROM 899 TO
C       1000 TO ALLOW FOR MORE STATION STATISTICS TO BE PROCESSED -
C       ON OCCASION THE 899 LIMIT HAD BEEN MET AND EXCEEDED. ADDED
C       PARAMETERS NDIV=23, NTIMES=6, NINC=3 TO TIDY UP THE CODE.
C       ADDIED DIAGNOSTIC OUTPUT STATEMENTS FOR INSTANCES WHEN LIMITS
C       ARE EXCEEDED. RENAMED NE TO NME FOR EASE OF NAVIGATION AND 
C       FOR CLARIFICATION AS NE IS USED FOR INEQUALITY TESTING (.NE.).
C 2014-01-15  S. Melchior Added integer "icntmx" to define the max
C       value of icnt in the multi-nested do loop that hinges on the
C       number of levels (NLEV), the number of stations (NST), the
C       number of times (NTIMES), and the number of increments (NINC).
C 2014-08-29  S. Melchior  Extended MSK, UW, and VW array allocations
C       from 1000 to 3600 (NSTN*NTIMES*NINC) to allow for a complete 
C       set of station statistics to be processed.  On occasion the
C       1000 limit had been met and exceeded, losing out on station 
C       statistics.
C 2014-09-04  S. Melchior  Redefined MSK, UW, and VW arrays to
C       utilize parameters NSTN, NTIMES, and NINC rather than 
C       explicitly setting the array size at 3600. "icntmx" is no 
C       longer necessary but will be retained because it may prove
C       useful for future debugging.
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL RESDIST
C
C   OUTPUT ARGUMENT LIST:
C     UNIT 06 - STANDARD OUTPUT PRINT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE RESDIST

      PARAMETER(NSTN=300,NLEV=35,NDIV=23,NTIMES=6,NINC=3)

      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /HTRES/  RGU(NLEV,NTIMES,NINC,NSTN),
     &                RGV(NLEV,NTIMES,NINC,NSTN)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /HTS/    IZLEV(NLEV), ZLEV(NLEV)
      COMMON /DATET/  IDATE(4), ITIM(6)
      COMMON /DMATYP/ IQC(NLEV,NTIMES,NINC,NSTN)
      REAL        UW(nstn*ntimes*ninc),VW(nstn*ntimes*ninc),
     &            XM(NLEV,2),SD(NLEV,2),XLIM(2)
      INTEGER     NM(NDIV,NLEV,2),MSK(nstn*ntimes*ninc),NC(NLEV,2),
     &            icntmx
      DATA XLIM /-5.,5./, XMSG /99999./

      MSK = 0
      icntmx = nst*ntimes*ninc

      DO L=1,NLEV ! nlev max is 35

C  PUT DATA INTO WORK ARRAY
C  ------------------------

        ICNT = 0
        UW = 0
        VW = 0
        LOOP1: DO IS=1,NST !  nst max is nstn
          DO IT=1,NTIMES ! ntimes max is 6
            IF(NIN(L,IT,IS).GT.0) THEN
              DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
                IF(IQC(L,IT,N,IS).EQ.0) THEN
                  ICNT = ICNT + 1
                  UW(ICNT) = RGU(L,IT,N,IS)
                  VW(ICNT) = RGV(L,IT,N,IS)
                ENDIF
              ENDDO
            ENDIF
          ENDDO
        ENDDO  LOOP1

C  GET DISTRIBUTIONS
C  -----------------

        BINI = 0.5
        CALL DISTR(UW,MSK,XLIM,XMSG,ICNT,NM(1,L,1),NDIV,BINI,0,0.,
     &             NC(L,1),XM(L,1),SD(L,1),SK,XK)
        CALL DISTR(VW,MSK,XLIM,XMSG,ICNT,NM(1,L,2),NDIV,BINI,0,0.,
     &             NC(L,2),XM(L,2),SD(L,2),SK,XK)

      ENDDO

C  PRINT DISTRIBUTIONS
C  -------------------

      WRITE(6,500) (IDATE(I),I=1,4), BINI
  500 FORMAT(/' VAD wind z-t residual statistics for ',I4,3I2.2,
     &       '   Bin increment = ',F8.2,' m/s')
      WRITE(6,501)
  501 FORMAT(/50X,'--------DISTRIBUTION FOR U-COMPONENT--------')
      WRITE(6,502)
  502 FORMAT(' HEIGHT(1000s ft) <-10  -10   -9   -8   -7   -6',
     &  '   -5   -4   -3   -2   -1    0    1    2    3    4    5',
     &  '    6    7    8    9   10  >10')
      WRITE(6,503) (IZLEV(L), (NM(I,L,1),I=1,NDIV), L=1,NLEV)
  503 FORMAT(6X,I5,6X,23I5)

      WRITE(6,504)
  504 FORMAT(/50X,'--------DISTRIBUTION FOR V-COMPONENT--------')
      WRITE(6,502)
      WRITE(6,503) (IZLEV(L), (NM(I,L,2),I=1,NDIV), L=1,NLEV)

      WRITE(6,505)
  505 FORMAT(/' HEIGHT(1000s ft)  Num      U-Mean  U-StdDev',
     &       '    V-Mean  V-StdDev Mag-StdDev')
      WRITE(6,506) (IZLEV(L),NC(L,1),XM(L,1),SD(L,1),XM(L,2),
     &              SD(L,2),SQRT(SD(L,1)**2+SD(L,2)**2),L=1,NLEV)
  506 FORMAT(6X,I5,6X,I5,2X,5F10.1)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: SELECT
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: SELECT DATA TO BE USED IN Z-T OI ANALYSIS
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO
C       TIDY UP THE CODE. RENAMED NE TO NME FOR EASE OF 
C       NAVIGATION AND FOR CLARIFICATION SINCE NE IS USED FOR
C       INEQUALITY TESTING (.NE.).
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL SELECT(IS,IT)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C     IT       - TIME INDEX
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SELECT(IS,IT)

      PARAMETER(NSTN=300,NLEV=35,NTIMES=6,NINC=3)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /HTS/ IZLEV(NLEV), ZLEV(NLEV)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /COLECT/ LS(NSTN,NLEV,NINC), JS(NSTN,NLEV,NINC),
     &                NS(NSTN,NLEV,NINC), NC(NLEV,NINC),
     &                DS(NSTN,NLEV,NINC),
     &                LTSCOL(9,NLEV,NTIMES,NINC,NSTN)
      COMMON /CONSTS/ MAT,E,AA,B,XL,R

      DS = 0.
      LS = 0
      JS = 0
      NS = 0
      NC = 0

C  SELECT DATA TO BE USED IN Z-T OI ANALYSIS
C  -----------------------------------------

C  OBS IS AT (L,IT,IS,N).  CALCULATE DISTANCE TO NEIGHBORS.
C  --------------------------------------------------------

      DO L=1,NLEV
        IF(NIN(L,IT,IS).NE.0) THEN
          DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
            NM = 0
            L1 = MAX(L-3,1)
            L2 = MIN(L+3,NLEV)
            DO LL=L1,L2
              DO I=1,NTIMES
                IF(NIN(LL,I,IS).NE.0) THEN
                  DO NN=1,NIN(LL,I,IS) !  nin(LL,I,IS) max is 3
                    IF(.NOT. ((L.EQ.LL) .AND. (I.EQ.IT) .AND.
     &                       (N.EQ.NN))) THEN
                      NM = NM + 1
                      DS(NM,L,N) = SQRT((TIMIN(L,IT,N,IS)
     &                  - TIMIN(LL,I,NN,IS))**2 + (R**2) *
     &                  (IZLEV(L)-IZLEV(LL))**2)
                      LS(NM,L,N) = LL
                      JS(NM,L,N) = I
                      NS(NM,L,N) = NN
                    ENDIF
                  ENDDO
                ENDIF
              ENDDO
            ENDDO
            NC(L,N) = NM
          ENDDO
        ENDIF
      ENDDO

C  SORT THE QUANTITIES BY DESCENDING DISTANCE
C  ------------------------------------------

      DO L=1,NLEV
        IF(NIN(L,IT,IS).NE.0) THEN
          DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
            CALL SORTD(DS(1,L,N),LS(1,L,N),JS(1,L,N),NS(1,L,N),NC(L,N))
            LTSCOL(1:9,L,IT,N,IS) = 
     &                        100*LS(1:9,L,N)+10*JS(1:9,L,N)+NS(1:9,L,N)
          ENDDO
        ENDIF
      ENDDO

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: SOLVE
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT:  SOLVE THE MATRIX PROBLEMS
C   A IS THE SYMMETRIC MATRIX (IN TRIANGULAR FORM)
C   C IS THE RIGHT-HAND-SIDE VECTOR ON INPUT AND
C   THE ANALYSIS WEIGHTS ON OUTPUT FROM DRCTSL.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO
C       TIDY UP THE CODE. RENAMED NE TO NME FOR EASE OF
C       NAVIGATION AND FOR CLARIFICATION AS NE IS USED FOR
C       INEQUALITY TESTING (.NE.).
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL SOLVE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SOLVE

      PARAMETER(NSTN=300,NLEV=35,NTIMES=6,NINC=3)
      REAL            DPR(NSTN,1)
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /MATRIC/ A(NSTN,45), C(NSTN,9), NMAT(NSTN), NM
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME

C  SOLVE THE MATRIX PROBLEMS
C    A IS THE SYMMETRIC MATRIX (IN TRIANGULAR FORM)
C    C IS THE RIGHT-HAND-SIDE VECTOR ON INPUT AND
C    THE ANALYSIS WEIGHTS ON OUTPUT FROM DRCTSL.

      CALL DRCTSL(A,C,DPR,NMAT,9,NM,1)

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: SORTD
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C ABSTRACT: SORT D, L, J, N, ALL ACCORDING TO ORDER OF D.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C
C USAGE:    CALL SORTD(D,L,J,N,NC)
C   INPUT ARGUMENT LIST:
C     D        - ARRAY GOVERNING ORDER OF SORT FOR ALL
C     L        - ARRAY TO SORT
C     J        - ARRAY TO SORT
C     N        - ARRAY TO SORT
C     NC       - NUMBER OF ELEMENTS TO SORT
C
C   OUTPUT ARGUMENT LIST:
C     D        - SORTED ARRAY
C     L        - SORTED ARRAY
C     J        - SORTED ARRAY
C     N        - SORTED ARRAY
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE SORTD(D,L,J,N,NC)

      PARAMETER(NSTN=300)
      REAL    D(*), W(NSTN)
      INTEGER L(*), J(*), N(*), INDX(NSTN), IW(NSTN)
      INDX = 0

      CALL INDEXX(NC,D,INDX)

      W(1:NC) = D(1:NC)
      D(1:NC) = W(INDX(1:NC))

      IW(1:NC) = L(1:NC)
      L(1:NC) = IW(INDX(1:NC))

      IW(1:NC) = J(1:NC)
      J(1:NC) = IW(INDX(1:NC))

      IW(1:NC) = N(1:NC)
      N(1:NC) = IW(INDX(1:NC))

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: VSOLVE
C   PRGMMR: WOOLLEN          ORG: NMC22      DATE: 2016-12-18
C
C ABSTRACT: CHOLESKY TYPE SOLUTION FOR ARRAYS OF POSITIVE DEFINITE
C   SYMMETRIC MATRIXES.
C
C PROGRAM HISTORY LOG:
C   90-11-06  J. WOOLLEN
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:
C   INPUT ARGUMENTS:
C     A          - ARRAY OF SYMMETRIC MATRIXES
C     B          - ARRAY OF RIGHT HAND SIDE VECTORS
C     NDIM       - ARRAY OF MATRIX RANKS
C     BAD        - BAD MATRIX INDICATOR
C     NFT        - NUMBER OF RIGHT HAND SIDES PER MATRIX
C     NS         - NUMBER OF MATRIXES TO SOLVE
C     MAXDIM     - LARGEST RANK MATRIX IN STACK
C
C   OUTPUT ARGUMENTS:
C     B          - CONTAINS THE SOLUTIONS UPON RETURN
C
C REMARKS: TRIANGULAR REPRESENTATION LISTS ELEMENTS TOWARDS THE
C   DIAGONAL. ALGORITHM FROM H.CARUS.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE VSOLVE (A,B,NDIM,BAD,NFT,NS,MAXDIM)

      PARAMETER(NSTN=300)
      DIMENSION A(NSTN,45),B(NSTN,9,1),NDIM(NSTN),BAD(NSTN),T(NSTN)
      LOGICAL BAD

      DATA CNUM/1.E-15/

C----------------------------------------------------------------------
      IX (I,J) = I*(I-1)/2 + J
C----------------------------------------------------------------------

      N = MAXDIM

      BAD(1:NS) = .FALSE.

C  DECOMPOSE THE MATRIXES
C  ----------------------

      DO I=1,N
         DO J=1,I
            T(1:NS) = A(1:NS,IX(I,J))
            DO K=1,J-1
               DO M=1,NS
                  T(M) = T(M) - A(M,IX(I,K)) * A(M,IX(J,K))
               END DO
            END DO
            IF(I.GT.J) THEN
               DO M=1,NS
                  A(M,IX(I,J)) = T(M) * A(M,IX(j,J))
               END DO
            ELSE
               DO M=1,NS
                  IF(T(M).LT.CNUM .AND. NDIM(M).GE.I) BAD(M) = .TRUE.
                  IF(T(M).LE.0) T(M) = 1.
               END DO
               A(1:NS,IX(I,I)) = 1./SQRT(T(1:NS))
            ENDIF
         END DO
      END DO

C  SOLVE FOR ALL RIGHT HAND SIDES
C  ------------------------------

      DO NF=1,NFT

C  FORWARD SUBSTITUTION
C  --------------------

         DO I=1,N
            T(1:NS) = B(1:NS,I,NF)
            DO J=1,I-1
               DO M=1,NS
                  T(M) = T(M) - A(M,IX(I,J)) * B(M,J,NF)
               END DO
            END DO
            B(1:NS,I,NF) = T(1:NS) * A(1:NS,IX(I,I))
         END DO

C  BACKWARD SUBSTITUTION
C  ---------------------

         DO I=N,1,-1
            T(1:NS) = B(1:NS,I,NF)
            IF(I.NE.N) THEN
               DO J=I+1,N
                  DO M=1,NS
                     T(M) = T(M) - A(M,IX(J,I)) * B(M,J,NF)
                  END DO
               END DO
            END IF
            B(1:NS,I,NF) = T(1:NS) * A(1:NS,IX(I,I))
         END DO
      END DO

      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: ZTOI
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 1999-08-18
C
C ABSTRACT: PERFORM OI ANALYSIS IN Z-T PLANE, ONE STATION AT A TIME.
C   PERFORM OI ANALYSIS FOR ALL POSSIBLE HOURS.
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETER NTIMES=6 TO TIDY UP THE
C       CODE. RENAMED NE TO NME FOR EASE OF NAVIGATION AND FOR
C       CLARIFICATION SINCE NE IS USED FOR INEQUALITY TESTING
C       (.NE.).
C
C USAGE:    CALL ZTOI
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE ZTOI

      PARAMETER (NLEV=35,NTIMES=6)
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME

C  PERFORM OI ANALYSIS IN Z-T PLANE, ONE STATION AT A TIME.
C  PERFORM OI ANALYSIS FOR THE CENTRAL 3 HOURS
C  --------------------------------------------------------

      DO IS=1,NST !  nst max is nstn
        DO IT=1,NTIMES

C  SELECT DATA FOR THE ANALYSIS
C  ----------------------------

          CALL SELECT(IS,IT)

C  SET UP MATRICES
C  ---------------

          CALL MATR(IS,IT)

C  SOLVE MATRICES
C  --------------

          CALL SOLVE

C  GET RESIDUALS
C  -------------

          CALL ZTRES(IS,IT)

        ENDDO
      ENDDO
      RETURN
      END

C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: ZTRES
C   PRGMMR: W. COLLINS       ORG: NP22       DATE: 2016-12-18
C
C ABSTRACT: SOLVE FOR THE HEIGHT-TIME OI ANALYSIS RESIDUALS
C
C PROGRAM HISTORY LOG:
C 1999-08-18  W. COLLINS
C 2012-03-05  S. MELCHIOR  ADDED PARAMETERS NTIMES=6 AND NINC=3 TO
C       TIDY UP THE CODE. RENAMED NE TO NME FOR EASE OF 
C       NAVIGATION AND FOR CLARIFICATION AS NE IS USED FOR
C       INEQUALITY TESTING (.NE.).
C 2016-12-18  D. Stokes  Increased NSTN (maximum number of stations to
C       process) from 200 to 300.
C
C USAGE:    CALL ZTRES(IS,IT)
C   INPUT ARGUMENT LIST:
C     IS       - STATION INDEX
C     IT       - TIME INDEX
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$
      SUBROUTINE ZTRES(IS,IT)

      PARAMETER(NSTN=300,NLEV=35,NTIMES=6,NINC=3)
      REAL WU(NSTN), WV(NSTN)

      COMMON /MATRIC/ A(NSTN,45), C(NSTN,9), NMAT(NSTN), NM
      COMMON /PARAMS/ IUNIT, IUTIM, IOUT, CON, IHE, NUM, NST,
     &                ICQCPC, NEV, NME
      COMMON /INCS/   UIN(NLEV,NTIMES,NINC,NSTN),
     &                VIN(NLEV,NTIMES,NINC,NSTN),
     &                UUU(NLEV,NTIMES,NINC,NSTN),
     &                VVV(NLEV,NTIMES,NINC,NSTN),
     &                TIMIN(NLEV,NTIMES,NINC,NSTN),
     &                NIN(NLEV,NTIMES,NSTN),
     &                LLL(NLEV,NTIMES,NINC,NSTN),
     &                TFC(NLEV,NTIMES,NINC,NSTN),
     &                QQQ(NLEV,NTIMES,NINC,NSTN)
      COMMON /COLECT/ LS(NSTN,NLEV,NINC), JS(NSTN,NLEV,NINC),
     &                NS(NSTN,NLEV,NINC), NC(NLEV,NINC),
     &                DS(NSTN,NLEV,NINC),
     &                LTSCOL(9,NLEV,NTIMES,NINC,NSTN)
      COMMON /HTRES/  RGU(NLEV,NTIMES,NINC,NSTN),
     &                 RGV(NLEV,NTIMES,NINC,NSTN)

C  SOLVE FOR THE HEIGHT-TIME OI ANALYSIS RESIDUALS
C  -----------------------------------------------

      NN = 0
      DO L=1,NLEV
        IF(NIN(L,IT,IS).NE.0) THEN
          DO N=1,NIN(L,IT,IS) !  nin(L,IT,IS) max is 3
            NN = NN + 1
            RGU(L,IT,N,IS) = UIN(L,IT,N,IS)
            RGV(L,IT,N,IS) = VIN(L,IT,N,IS)
            LOOP1: DO I=1,NMAT(NN)

              IF(LTSCOL(I,L,IT,N,IS).EQ.0) CYCLE LOOP1
              LL = LTSCOL(I,L,IT,N,IS)/100
              IF(LL.LT.1 .OR. LL.GT.NLEV) CYCLE LOOP1
              ITS = LTSCOL(I,L,IT,N,IS)-100*LL
              IF(ITS.EQ.0) CYCLE LOOP1
              ITEMP = ITS/10
              ISUBT = ITS-10*ITEMP

              RGU(L,IT,N,IS) = RGU(L,IT,N,IS) -
     &            C(NN,I) * UIN(LL,ITEMP,ISUBT,IS)
              RGV(L,IT,N,IS) = RGV(L,IT,N,IS) -
     &            C(NN,I) * VIN(LL,ITEMP,ISUBT,IS)
            ENDDO  LOOP1
            WU(NN) = RGU(L,IT,N,IS)
            WV(NN) = RGV(L,IT,N,IS)
          ENDDO
        ENDIF
      ENDDO

      RETURN
      END

subroutine td_to_q (dewpt,pressure,q)

  implicit none

  !derived from https://www.eol.ucar.edu/projects/ceop/dm/documents/refdata_report/eqns.html, from Bolton 1980.

  real(4),parameter::alpha=243.5
  !real(8),parameter::beta=440.8
  !real(8),parameter::gamma=19.48
  !real(8),parameter::eta=273.15
  real(4),parameter::eps=0.62197
  real(4),intent(in)::dewpt,pressure
  real(4),intent(out)::q
  real(4)::loge,e,qv

  e=6.112*exp((17.67*dewpt)/(dewpt+alpha))
  q=(eps*e)/(pressure - (0.378*3))
  q=q*1000000 !convert from kg/kg to mg/kg

end subroutine td_to_q

!  PROGRAM read_convdiag 
!  read the conventional data from gsi and put into different array for input to prepbufr
!  PRGMMR:   X. Su       ORG: NP20                 Date: 2007-11-15
!  
! ABSTRACT:  read the conventional data from gsi and put into different array 
!            for input to prepbufr.

      subroutine read_convdiag(filein,cwork,dwork,ndata,knt)

      real(4),allocatable,dimension(:,:)    :: rdiag
      character(8),allocatable,dimension(:) :: cdiag

      character(8) sid; real(8) rid; equivalence(sid,rid)
      
      parameter(maxn=3500000)
      character(8),dimension(maxn) :: cwork
      real(4),dimension(maxn,0:20) :: dwork

      character(len=3)  :: dtype,type 
      character(len=50) :: filein
   
      integer nchar,nreal,ii,mype,ntype,idate,knt(300,0:10)

      logical first

      data lunin/11/
      data lunit/20/

!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------

      nn=0        

      close(lunin)
      call datebf(lunit,mear,mmon,mday,mour,jdate);jdate=i4dy(jdate)
      open(lunin,file=filein,form='unformatted',convert="big_endian")
      first=.true. ; goto 3
2     if(first) then
         close(lunin)
         open(lunin,file=filein,form='unformatted',convert="little_endian")
         first=.false.
         goto 3
      else
         call bort('bad diag file or wrong date')
      endif

3     rewind(lunin); read(lunin,err=2) idate; print *, idate,jdate      
      if(idate/=jdate) goto 2
      loopd: do; read(lunin,end=100,err=2) dtype,nchar,nreal,ii
      !print*,dtype,nchar,nreal,ii

      jtype=0
      if(dtype == ' ps') jtype=1
      if(dtype == '  q') jtype=2
      if(dtype == '  t') jtype=3
      if(dtype == ' uv') jtype=4
      if(dtype == 'spd') jtype=5
      !if(dtype == 'gps') jtype=6

      allocate(cdiag(ii),rdiag(nreal,ii))
      read(lunin,IOSTAT=iflag) cdiag,rdiag
      if(jtype/=0) then
         loopi: do i=1,ii
         itype=rdiag(1,i); if(itype>=240.and.itype<=260) cycle ! skip satwinds
         nn=nn+1; if(nn.gt.maxn) cycle                       ! don't overflow arrays
         cwork(nn)=cdiag(i)                   ! station id
         dwork(nn,0)=jtype                    ! observation type (ps,q,t,uv,etc) 
         dwork(nn,1)=itype                    ! oi report type 
         dwork(nn,2)=rdiag(3,i)               ! observation latitude(degrees) 
         dwork(nn,3)=rdiag(4,i)               ! observation longitude(degrees)
         dwork(nn,4)=rdiag(5,i)               ! station elevation(meters) 
         dwork(nn,5)=rdiag(6,i)               ! observation pressure (hpa) 
         dwork(nn,6)=rdiag(7,i)               ! observation height (meters) 
         dwork(nn,7)=rdiag(8,i)               ! obs time (hours relat. to anal. time) 
         dwork(nn,8)=rdiag(9,i)               ! input prepbufr qc or event mark 
         dwork(nn,9)=rdiag(11,i)              ! read_prepbufr data usage flag 
         dwork(nn,10)=rdiag(12,i)             ! data usage flag((1=use, -1=not used) 
         dwork(nn,11)=rdiag(13,i)*.25         ! variational qc weight 
         dwork(nn,12)=1.0/rdiag(16,i)             ! analsis adjusted observation error 
         if( trim(dtype) == ' uv') then
            dwork(nn,15)=rdiag(17,i)             ! u observation
            dwork(nn,16)=rdiag(17,i)-rdiag(18,i) ! u background or analysis
            dwork(nn,17)=rdiag(20,i)             ! v observation
            dwork(nn,18)=rdiag(20,i)-rdiag(21,i) ! v background or analysis
            dwork(nn,19)=rdiag(23,i)             ! 10m wind reduction factor 
         else if( trim(dtype) == '  q') then
            dwork(nn,15)=rdiag(17,i)             ! observation   
            dwork(nn,16)=rdiag(17,i)-rdiag(18,i) ! background or analysis   
            dwork(nn,17)=rdiag(20,i)             ! guess saturation specific humidity 
         else 
            dwork(nn,15)=rdiag(17,i)             ! observation   
            dwork(nn,16)=rdiag(17,i)-rdiag(18,i) ! background or analysis   
         endif
         knt(itype,jtype)=knt(itype,jtype)+1; knt(itype,0)=knt(itype,0)+1

!        if(cwork(nn)=='GSV0GBRA') then
!        if(cwork(nn)=='0S26229Q') then
         if(itype==2210000) then
            xob=rdiag(3,i);yob=rdiag(4,i);prs=rdiag(6,i)
            obs=dwork(nn,15);bak=dwork(nn,16)
            elv=dwork(nn, 4);zob=dwork(nn, 6);tim=dwork(nn,7)
            uob=dwork(nn,15);vob=dwork(nn,17)
            !!write(6,99)cwork(nn),itype,jtype,prs,xob,yob,zob,elv,tim
99          format(a8,2x,2i4,8(2x,g12.4))
            !print*,'-------------------------------------------------------------'
            !print'("a8:",a8)',cwork(nn)
            !sid=cwork(nn); print*,"r8:",rid
            !print'("z16: ",z16,11(1x,f8.2))',cwork(nn),(dwork(nn,j),j=0,8),uob,vob
            print'(a8,11(1x,f8.2))',cwork(nn),(dwork(nn,j),j=0,8),uob,vob
         endif

         enddo loopi ! end data store loop 
      else
         !print*,dtype,rdiag(1,1)
      endif
      deallocate(cdiag,rdiag)
      enddo loopd ! ending read data do loop

100   ndata=nn

      if(ndata.gt.maxn) then
         print*,'ndata=',ndata
         call bort('too many diag records')
      endif

      close(lunin)
      return

      print*,'data counts by report type'
      do i=1,300
      if(knt(i,0).gt.0) print'(i3,8(2x,i8))',i,(knt(i,j),j=0,5)
      enddo

      return
      end 
!----------------------------------------------------------------------
!----------------------------------------------------------------------
      subroutine opendian(iunit,file)
      character*(*) file
      character*15  convert,nativey,nativen,be,le
      character*1   byte                    
      integer ibyte,jbyte,iswap
      equivalence(byte,ibyte)
      data le/'little_endian'/
      data be/'big_endian   '/
!----------------------------------------------------------------------
!----------------------------------------------------------------------
! what is native?
      ibyte=1; convert='none'
      if(ichar(byte)==0) then 
         nativey=be;nativen=le
      else
         nativey=le;nativen=be
      endif
      print*,'running on ',nativey,' platform'

! try to open the file natively, if yes, report, rewind, return

      open(iunit,file=file,form='unformatted')
      read(iunit,iostat=iostat) 
      if(iostat==0)then ! file is opened as native
         print*,nativey,trim(file)
         rewind(iunit)
         return
      endif

! try to open the file non-natively, if yes, report, rewind, return

      close(iunit)
      open(iunit,file=file,form='unformatted',convert=nativen) 
      read(iunit,iostat=iostat) ibyte
      if(iostat==0)then ! file is opened as non-native
         print*,nativen,trim(file)
         rewind(iunit)
         return
      endif

      print*,'unable to open ',trim(file)
      return
      end

c$$$  Subprogram Documentation Block
c   BEST VIEWED WITH 94-CHARACTER WIDTH WINDOW
c
c Subprogram: sub2mem_um 
c   Programmer: D. Keyser       Org: NP22       Date: 2012-05-08
c
c Abstract: Adds new NRLACQC events for pressure, altitude, temperature, moisture and wind to
c   the top of event stack in memory for a single merged aircraft report. This is
c   accomplished via calls to subroutine tranQCflags to translate the QC information (for
c   each variable) from NRL standards (c_qc_stg array) to their NCEP counterparts and to
c   establish event reason codes for each variable.
c
c Program history log:
c 2010-11-15  S. Bender -- Original Author
c 2012-05-08  D. Keyser -- Prepared for operational implementation
c
c Usage: call sub2mem_um(c_qc_stg,max_reps,mxnmev,j,nevents,
c                        pob_ev,pqm_ev,ppc_ev,prc_ev,
c                        zob_ev,zqm_ev,zpc_ev,zrc_ev,
c                        tob_ev,tqm_ev,tpc_ev,trc_ev,
c                        qob_ev,qqm_ev,qpc_ev,qrc_ev,
c                        uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,
c     			 nrlacqc_pc,l_allev_pf)
c
c   Input argument list:
c     c_qc_stg    - NRLACQC quality information (11 character string)
c     max_reps    - Maximum number of reports accepted by acftobs_qc
c     mxnmev      - Maximum number of events allowed, per variable type
c     j           - Report number index
c     nevents     - Array tracking number of events for variables for each report
c     pob_ev      - Pressure event obs
c     pqm_ev      - Pressure event quality marks
c     ppc_ev      - Pressure event program codes
c     prc_ev      - Pressure event reason codes
c     zob_ev      - Altitude event obs
c     zqm_ev      - Altitude event quality marks
c     zpc_ev      - Altitude event program codes
c     zrc_ev      - Altitude event reason codes
c     tob_ev      - Temperature event obs
c     tqm_ev      - Temperature event quality marks
c     tpc_ev      - Temperature event program codes
c     trc_ev      - Temperature event reason codes
c     qob_ev      - Moisture event obs
c     qqm_ev      - Moisture event quality marks
c     qpc_ev      - Moisture event program codes
c     qrc_ev      - Moisture event reason codes
c     uob_ev      - Wind/u-comp event obs
c     vob_ev      - Wind/v-comp event obs
c     wqm_ev      - Wind event quality marks
c     wpc_ev      - Wind event program codes
c     wrc_ev      - Wind event reason codes
c     nrlacqc_pc  - PREPBUFR program code for the NRLACQC step
c     l_allev_pf  - Logical whether to process latest (likely NRLACQC) event plus all prior
c                   events (TRUE) or only latest event (FALSE) into profiles PREPBUFR-like
c                   file
c
c   Output argument list:
c     nevents     - Array tracking number of events for variables for each report
c     pob_ev      - Pressure event obs
c     ppc_ev      - Pressure event program codes
c     prc_ev      - Pressure event reason codes
c     zob_ev      - Altitude event obs
c     zqm_ev      - Altitude event quality marks
c     zpc_ev      - Altitude event program codes
c     zrc_ev      - Altitude event reason codes
c     tob_ev      - Temperature event obs
c     tqm_ev      - Temperature event quality marks
c     tpc_ev      - Temperature event program codes
c     trc_ev      - Temperature event reason codes
c     qob_ev      - Moisture event obs
c     qqm_ev      - Moisture event quality marks
c     qpc_ev      - Moisture event program codes
c     qrc_ev      - Moisture event reason codes
c     uob_ev      - Wind/u-comp event obs
c     vob_ev      - Wind/v-comp event obs
c     wqm_ev      - Wind event quality marks
c     wpc_ev      - Wind event program codes
c     wrc_ev      - Wind event reason codes
c
c   Output files:
c     Unit 06     - Standard output print
c
c   Subprograms called:
c     Unique:    TRANQCFLAGS
c     Library:
c       BUFRLIB: IBFMS
c
c   Exit States:
c     Cond =  0 - successful run
c
c Remarks: Called by subroutine output_acqc_prof.
c
c Attributes:
c   Language: FORTRAN 90
c   Machine:  NCEP WCOSS
c
c$$$
      subroutine sub2mem_um(c_qc_stg,max_reps,mxnmev,j,nevents,
     +                      pob_ev,pqm_ev,ppc_ev,prc_ev,
     +                      zob_ev,zqm_ev,zpc_ev,zrc_ev,
     +                      tob_ev,tqm_ev,tpc_ev,trc_ev,
     +                      qob_ev,qqm_ev,qpc_ev,qrc_ev,
     +                      uob_ev,vob_ev,wqm_ev,wpc_ev,wrc_ev,
     +                      nrlacqc_pc,l_allev_pf)

      implicit none

c ----------------------
c Declaration statements
c ----------------------

c Indices/counters 
c ----------------
      integer      j                 ! report number index

      character*11 c_qc_stg          ! character QC flags output from NRL QC code
                                     !   1st char - info about reject (if ob was rejected)
                                     !   2nd char - reason why time was rejected
                                     !   3rd char - reason why latitude was rejected
                                     !   4th char - reason why longitude was rejected
                                     !   5th char - reason why pressure/atitude was rejected
                                     !   6th char - readon why temperature was rejected
                                     !   7th char - reason why wind direction was rejected
                                     !   8th char - reason why wind speed was rejected
                                     !   9th char - reason why mixing ratio was rejected
                                     !  10th char - reason for blacklisting the aircraft
                                     !  11th char - info about flight phase

c Variables for updating input reports with QC results/events from NRLACQC
c ------------------------------------------------------------------------
      logical   l_badrpt_p          ! T = pressure/altitude is bad per NRLACQC info (c_qc_stg)
     +,	        l_badrpt_z          ! T = pressure/altitude is bad per NRLACQC info (c_qc_stg)
     +,         l_badrpt_t          ! T = temperature is bad per NRLACQC info (c_qc_stg)
     +,         l_badrpt_q          ! T = moisture is bad per NRLACQC info (c_qc_stg)
     +,         l_badrpt_w          ! T = wind is bad per NRLACQC info (c_qc_stg)

      logical   l_duprpt            ! T = report is marked as a duplicate per NRLACQC info
                                    !  (c_qc_stg(1:1)=D/d)

      real*8    pob_topstk          ! event POB at top of stack before adding any events 
                                    !  containing info from NRLACQC
     +,         zob_topstk          ! event ZOB at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,         tob_topstk          ! event TOB at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,	        qob_topstk          ! event QOB at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,	        uob_topstk          ! event UOB at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,	        vob_topstk          ! event VOB at top of stack before adding any events
                                    !  containing info from NRLACQC

      integer   ipqm_topstk         ! event PQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,         izqm_topstk         ! event ZQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,         itqm_topstk         ! event TQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,         iqqm_topstk         ! event QQM at top of stack before adding any events
                                    !  containing info from NRLACQC
     +,         iwqm_topstk         ! event WQM at top of stack before adding any events
                                    !  containing info from NRLACQC

      integer   ipqm_nrlacqc     ! value for pressure q.m. (PQM) returned from tranQCflags
     +,         iprc_nrlacqc     ! value for pressure r.c. (PRC) returned from tranQCflags
     +,         izqm_nrlacqc     ! value for altitude q.m. (ZQM) returned from tranQCflags
     +,         izrc_nrlacqc     ! value for altitude r.c. (ZRC) returned from tranQCflags
     +,         itqm_nrlacqc     ! value for temperature q.m. (TQM) returned from tranQCflags
     +,         itrc_nrlacqc     ! value for temperature r.c. (TRC) returned from tranQCflags
     +,         iqqm_nrlacqc     ! value for moisture q.m. (QQM) returned from tranQCflags
     +,         iqrc_nrlacqc     ! value for moisture r.c. (QRC) returned from tranQCflags
     +,         iwqm_nrlacqc     ! value for wind q.m. (WQM) returned from tranQCflags
     +,         iwrc_nrlacqc     ! value for wind r.c. (WRC) returned from tranQCflags

c Variables used to hold original aircraft data read from input PREPBUFR file - necessary for
c  carrying data through program so that it can be later written to output PREPBUFR-like
c  profiles file from memory instead of going back to input PREPBUFR file and re-reading that
c  file before adding any NRLACQC events
c -------------------------------------------------------------------------------------------
      integer nevents(max_reps,6)   ! array tracking number of events for variables for each
                                    ! report:
                                    !   1 - number of pressure events
                                    !   2 - number of moisture events
                                    !   3 - number of temperature events
                                    !   4 - number of altitude events
                                    !   5 - number of wind (u/v) events
                                    !   6 - number of wind (direction/speed) events

      real*8  pob_ev(max_reps,mxnmev) ! POB values for each report, including all events
     +,       pqm_ev(max_reps,mxnmev) ! PQM values for each report, including all events
     +,       ppc_ev(max_reps,mxnmev) ! PPC values for each report, including all events
     +,       prc_ev(max_reps,mxnmev) ! PRC values for each report, including all events
     +,       zob_ev(max_reps,mxnmev) ! ZOB values for each report, including all events
     +,       zqm_ev(max_reps,mxnmev) ! ZQM values for each report, including all events
     +,       zpc_ev(max_reps,mxnmev) ! ZPC values for each report, including all events
     +,       zrc_ev(max_reps,mxnmev) ! ZRC values for each report, including all events
     +,       tob_ev(max_reps,mxnmev) ! TOB values for each report, including all events
     +,       tqm_ev(max_reps,mxnmev) ! TQM values for each report, including all events
     +,       tpc_ev(max_reps,mxnmev) ! TPC values for each report, including all events
     +,       trc_ev(max_reps,mxnmev) ! TRC values for each report, including all events
     +,       qob_ev(max_reps,mxnmev) ! QOB values for each report, including all events
     +,       qqm_ev(max_reps,mxnmev) ! QQM values for each report, including all events
     +,       qpc_ev(max_reps,mxnmev) ! QPC values for each report, including all events
     +,       qrc_ev(max_reps,mxnmev) ! QRC values for each report, including all events
     +,       uob_ev(max_reps,mxnmev) ! UOB values for each report, including all events
     +,       vob_ev(max_reps,mxnmev) ! VOB values for each report, including all events
     +,       wqm_ev(max_reps,mxnmev) ! WQM values for each report, including all events
     +,       wpc_ev(max_reps,mxnmev) ! WPC values for each report, including all events
     +,       wrc_ev(max_reps,mxnmev) ! WRC values for each report, including all events

      integer mxnmev,max_reps

c Misc.
c -----
      real    nrlacqc_pc              ! PREPBUFR program code for the NRLACQC step

      integer ibfms                   ! BUFRLIB function for testing for missing

      logical l_skip                  ! skip (TRUE) or execute (FALSE) block of code

c Logicals controlling processing (read in from namelist in main program)
c -----------------------------------------------------------------------
      logical l_allev_pf      ! T=process latest (likely NRLACQC) events plus all prior
                              !   events into profiles PREPBUFR-like file
                              !   **CAUTION: More complete option, but will make code take
                              !              longer to run!!!
                              ! F=process ONLY latest (likely NRLACQC) events into profiles
                              !   PREPBUFR-like file (here means input latest events will
                              !   likely be written over by NRLACQC events)
                              ! Note : All pre-existing events plus latest (likely NRLACQC)
                              !        events are always encoded into full PREPBUFR file)


c *******************************************************************

c Initialize variables
c --------------------

      ipqm_topstk = 9999
      izqm_topstk = 9999
      itqm_topstk = 9999
      iqqm_topstk = 9999
      iwqm_topstk = 9999

c Start subroutine
c ----------------

c ---------------------------------------------------------------
c Translate NRLACQC flags to NCEP events and add events to memory
c ---------------------------------------------------------------

c Also, first initialize the "bad report", "suspect report", and "duplicate report" flags as
c  false - these flags will be set to true if the NRLACQC quality information (array
c  c_qc_stg) indicates that the report or any part of it is bad, suspect or a duplicate
c ------------------------------------------------------------------------------------------
      l_badrpt_p = .false.
      l_badrpt_z = .false.
      l_badrpt_t = .false.
      l_badrpt_q = .false.
      l_badrpt_w = .false.

      l_duprpt = .false.

c Pressure
c --------

c Get pressure OB and QM at top of stack coming in (from memory) and store in pob_topstk and
c  ipqm_topstk, translate NRLACQC quality flags in c_qc_stg to NCEP standards for pressure
c  and store in ipqc_nrlacqc, also store reason code in iprc_nrlacqc
c ------------------------------------------------------------------------------------------
      pob_topstk = pob_ev(j,nevents(j,1))
      if(ibfms(pqm_ev(j,nevents(j,1))).eq.0) then
        if(nint(pqm_ev(j,nevents(j,1))).ge.0.and.
     +     nint(pqm_ev(j,nevents(j,1))).le.15) then
c PQM for event at top of stack (prior to adding any NRLACQC events)
          ipqm_topstk = nint(pqm_ev(j,nevents(j,1)))
        endif
      endif

      call tranQCflags(c_qc_stg,'p',ipqm_nrlacqc,iprc_nrlacqc,
     +                 l_badrpt_p,l_duprpt)

c if PQM = 2 and PRC = 099, returned from tranQCflags, then can't translate!
      if(ipqm_nrlacqc.eq.2 .and. iprc_nrlacqc.eq.099) then
        print *
        print *, 'Unknown c_qc_stg flag on pressure/altitude:',
     +           c_qc_stg(5:5)
        print *
      endif

c Altitude
c --------

c Get altitude OB and QM at top of stack coming in (from memory) and store in zob_topstk and
c  izqm_topstk, translate NRLACQC quality flags in c_qc_stg to NCEP standards for altitude
c  and store in izqc_nrlacqc, also store reason code in izrc_nrlacqc
c
c Use same quality marks for altitude as were used for pressure - NRLACQC has one flag for
c  both (c_qc_stg(5:5))
c ------------------------------------------------------------------------------------------
      zob_topstk = zob_ev(j,nevents(j,4))
      if(ibfms(zqm_ev(j,nevents(j,4))).eq.0) then
        if(nint(zqm_ev(j,nevents(j,4))).ge.0.and.
     +     nint(zqm_ev(j,nevents(j,4))).le.15) then
c ZQM for event at top of stack (prior to adding any NRLACQC events)
          izqm_topstk = nint(zqm_ev(j,nevents(j,4)))
        endif
      endif

      call tranQCflags(c_qc_stg,'z',izqm_nrlacqc,izrc_nrlacqc,
     +                 l_badrpt_z,l_duprpt)

c if ZQM = 2 and ZRC = 099 returned from tranQCflags, then can't translate!
      if(izqm_nrlacqc.eq.2 .and. izrc_nrlacqc.eq.099) then
        print *
        print *, 'Unknown c_qc_stg flag on pressure/altitude:',
     +           c_qc_stg(5:5)
        print *
      endif

c Temperature
c -----------

c Get temperature OB and QM at top of stack coming in (from memory) and store in tob_topstk
c  and itqm_topstk, translate NRLACQC quality flags in c_qc_stg to NCEP standards for
c  temperature and store in itqc_nrlacqc, also store reason code in itrc_nrlacqc
c -----------------------------------------------------------------------------------------
      tob_topstk = tob_ev(j,nevents(j,3))
      if(ibfms(tqm_ev(j,nevents(j,3))).eq.0) then
        if(nint(tqm_ev(j,nevents(j,3))).ge.0.and.
     +     nint(tqm_ev(j,nevents(j,3))).le.15) then
c TQM for event at top of stack (prior to adding any NRLACQC events)
          itqm_topstk = nint(tqm_ev(j,nevents(j,3)))
        endif
      endif

      call tranQCflags(c_qc_stg,'t',itqm_nrlacqc,itrc_nrlacqc,
     +                 l_badrpt_t,l_duprpt)

c if TQM = 2 and TRC = 099 returned from tranQCflags, then can't translate!
      if(itqm_nrlacqc.eq.2 .and. itrc_nrlacqc.eq.099) then
        print *
        print *, 'Unknown c_qc_stg flag on temperature:',
     +           c_qc_stg(6:6)
        print *
      endif

c Moisture
c --------

c Get moisture OB and QM at top of stack coming in (from memory) and store in qob_topstk and
c  iqqm_topstk, translate NRLACQC quality flags in c_qc_stg to NCEP standards for moisture
c  and store in iqqc_nrlacqc, also store reason code in iqrc_nrlacqc
c ------------------------------------------------------------------------------------------
      qob_topstk = qob_ev(j,nevents(j,2))
      if(ibfms(qqm_ev(j,nevents(j,2))).eq.0) then
        if(nint(qqm_ev(j,nevents(j,2))).ge.0.and.
     +     nint(qqm_ev(j,nevents(j,2))).le.15) then
c QQM for event at top of stack (prior to adding any NRLACQC events)
          iqqm_topstk = nint(qqm_ev(j,nevents(j,2)))
        endif
      endif

      call tranQCflags(c_qc_stg,'q',iqqm_nrlacqc,iqrc_nrlacqc,
     +                 l_badrpt_q,l_duprpt)

c if QQM = 2 and QRC = 099 returned from tranQCflags, then can't translate!
      if(iqqm_nrlacqc.eq.2 .and. iqrc_nrlacqc.eq.099) then
        print *
        print *, 'Unknown c_qc_stg flag on moisture:',
     +           c_qc_stg(9:9)
        print *
      endif

c Wind
c ----

c Get wind OB (u- and v-) and QM at top of stack coming in (from memory) and store in
c  uob_topstk, vob_topstk, and iwqm_topstk, translate NRLACQC quality flags in c_qc_stg to
c  NCEP standards for wind and store in iwqc_nrlacqc, also store reason code in iwrc_nrlacqc
c ------------------------------------------------------------------------------------------
      uob_topstk = uob_ev(j,nevents(j,5))
      vob_topstk = vob_ev(j,nevents(j,5))
      if(ibfms(wqm_ev(j,nevents(j,5))).eq.0) then
        if(nint(wqm_ev(j,nevents(j,5))).ge.0.and.
     +     nint(wqm_ev(j,nevents(j,5))).le.15) then
c WQM for event at top of stack (prior to adding any NRLACQC events)
          iwqm_topstk = nint(wqm_ev(j,nevents(j,5)))
        endif
      endif

      call tranQCflags(c_qc_stg,'w',iwqm_nrlacqc,iwrc_nrlacqc,
     +                 l_badrpt_w,l_duprpt)

c if WQM = 2 and WRC = 099 returned from tranQCflags, then can't translate!
      if(iwqm_nrlacqc.eq.2 .and. iwrc_nrlacqc.eq.099) then
        print *
        print *, 'Unknown c_qc_stg flag on wind:',
     +           c_qc_stg(7:7),'/',c_qc_stg(8:8)
        print *
      endif

c If entire report is to be rejected, put reject flags (QM=13) on pressure, altitude,
c  temperature, moisture, and wind
c -----------------------------------------------------------------------------------
      if(l_badrpt_p .or. l_badrpt_z .or.
     +   l_badrpt_t .or. l_badrpt_q .or. l_badrpt_w) then
        ipqm_nrlacqc = 13 ! PQM
    ! PRC already encoded into iprc_nrlacqc in subr. tranQCflags

        izqm_nrlacqc = 13 ! ZQM
    ! ZRC already encoded into izrc_nrlacqc in subr. tranQCflags

        itqm_nrlacqc = 13 ! TQM
    ! TRC already encoded into itrc_nrlacqc in subr. tranQCflags

        iqqm_nrlacqc = 13 ! QQM
    ! QRC already encoded into iqrc_nrlacqc in subr. tranQCflags

        iwqm_nrlacqc = 13 ! WQM
    ! WRC already encoded into iwrc_nrlacqc in subr. tranQCflags

      endif ! l_badrpt_[p,z,t,q,w]

c If report is marked as a duplicate (c_qc_stg(1:1) = d or D), then mark the entire report
c  with a bad NCEP quality mark (=13)
c ----------------------------------------------------------------------------------------
      if(l_duprpt) then
        ipqm_nrlacqc = 13 ! PQM
    ! PRC already encoded into iprc_nrlacqc in subr. tranQCflags

        izqm_nrlacqc = 13 ! ZQM
    ! ZRC already encoded into izrc_nrlacqc in subr. tranQCflags

        itqm_nrlacqc = 13 ! TQM
    ! TRC already encoded into itrc_nrlacqc in subr. tranQCflags

        iqqm_nrlacqc = 13 ! QQM
    ! QRC already encoded into iqrc_nrlacqc in subr. tranQCflags

        iwqm_nrlacqc = 13 ! WQM
    ! WRC already encoded into iwrc_nrlacqc in subr. tranQCflags

      endif ! l_duprpt

c Update pressure, altitude, temperature, moisture and wind stacks with new event in memory
c  when there has been a qualty mark change by NRLACQC (don't need to write out an event if
c  quality mark has not been changed by this program)
c
c EXCEPTION: Retain (honor) the incoming quality mark at the top of the stack (i.e., do not
c            write event) when:
c
c       (1) The incoming quality mark at the top of the stack is 0 (keep flag)
c       (2) The incoming quality mark at the top of the stack is between 4 and 15 (bad) -
c           except when NRLACQC itself generates a BAD quality mark (translated to NCEP
c           value of 13), allows reason code to denote why action taken by NRLACQC to mark
c           obs as bad
c       (3) The incoming quality mark at the top of the stack is not between 0 and 15
c           (i.e.,missing)
c       (4) The incoming quality mark at the top of the stack is 3 (suspect) and the NRLACQC
c           generates a GOOD or NEUTRAL or SUSPECT quality mark (translated to NCEP values of
c           1, 2 and 3 resp.) {in other words, unless an ob previously marked as suspect was
c           marked bad by NRLACQC, don't change a suspect quality mark assigned by a PREPBUFR
c           processing step prior to the NRLACQC step}
c       (5) The quality mark translated to its NCEP value is 2 (neutral) and the reason code
c           is returned from tranQCflags is 099 - this indicates that the NRLACQC quality
c           flags in c_qc_stg pertaining to this ob are unknown to transQCflags (the routine
c           tranQCflags may need to be updated to account for the c_qc_stg flags that is
c           coming out of the NRLACQC QC routine for this ob - this would probably only
c           happen if NRL provides an updated/upgraded acftobs_qc module to NCEP)
c       (6) The NCEP equivalent of the NRLACQC is the same as the incoming quality mark of
c           the stack - if there is no change in the quality mark, then do not add a new
c           event and leave the event at the top of the event stack as is with TWO
c           exceptions:
c              a) NRLACQC itself generates a GOOD quality mark (translated to NCEP value of
c                 1)
c              b) NRLACQC itself generates a BAD quality mark (translated to NCEP value of
c                 13)  (see 2 above for more on this)
c -------------------------------------------------------------------------------------------

c Pressure
c --------

      l_skip = .true. ! SKIP LOGIC TO WRITE PRESSURE EVENTS - there is no need to do so since
                      !  pressure is a vertical coordinate and it is not analyzed, in
                      !  addition, adding pressure events complicates reason code logic

      if(.not.l_skip) then

c .... if here, include logic to write pressure events
        if(ipqm_topstk.eq.0  .or.
     +    (ipqm_topstk.ge.4 .and. ipqm_topstk.le.15) .or.  ! ob has already been marked bad
                                                           !  by NCEP codes
     +     ipqm_topstk.eq.9999 .or.
     +    (ipqm_topstk.eq.3.and.ipqm_nrlacqc.le.3) .or.
     +    (ipqm_nrlacqc.eq.2.and.iprc_nrlacqc.eq.099) .or.
     +    (ipqm_topstk.eq.ipqm_nrlacqc.and.ipqm_nrlacqc.ne.1)
     +            ) then                               ! no event needed; leave PQM as is

          ipqm_nrlacqc = ipqm_topstk

        else ! NRL QC produced an event; add this event to top of stack in memory
          if(l_allev_pf) nevents(j,1) = nevents(j,1) + 1 ! add new event (do not write over
                                                         !  event currently at top of stack
                                                         !  since l_allev_pf=TRUE)
          pob_ev(j,nevents(j,1)) = pob_topstk
          pqm_ev(j,nevents(j,1)) = ipqm_nrlacqc
     	  ppc_ev(j,nevents(j,1)) = nrlacqc_pc
     	  prc_ev(j,nevents(j,1)) = iprc_nrlacqc

        endif

      else

c .... if here, SKIP logic to write pressure events
        ipqm_nrlacqc = ipqm_topstk

      endif

c Altitude
c --------

      l_skip = .true. ! SKIP LOGIC TO WRITE ALTITUDE EVENTS - there is no need to do so since
                      !  altitude is a vertical coordinate and it is not analyzed, in
                      !  addition, adding altitude events complicates reason code logic

      if(.not.l_skip) then

c .... if here, include logic to write altitude events
        if(izqm_topstk.eq.0  .or.
     +    (izqm_topstk.ge.4 .and. izqm_topstk.le.15) .or.  ! ob has already been marked bad
                                                           !  by NCEP codes
     +     izqm_topstk.eq.9999 .or.
     +    (izqm_topstk.eq.3.and.izqm_nrlacqc.le.3) .or.
     +    (izqm_nrlacqc.eq.2.and.izrc_nrlacqc.eq.099) .or.
     +    (izqm_topstk.eq.izqm_nrlacqc.and.izqm_nrlacqc.ne.1)
     +            ) then                               ! no event needed; leave ZQM as is
          izqm_nrlacqc = izqm_topstk

        else ! NRL QC produced an event; add this event to top of stack in memory
          if(l_allev_pf) nevents(j,4) = nevents(j,4) + 1 ! add new event (do not write over
                                                         !  event currently at top of stack
                                                         !  since l_allev_pf=TRUE)
          zob_ev(j,nevents(j,4)) = zob_topstk
          zqm_ev(j,nevents(j,4)) = izqm_nrlacqc
          zpc_ev(j,nevents(j,4)) = nrlacqc_pc
          zrc_ev(j,nevents(j,4)) = izrc_nrlacqc
     
        endif

      else

c .... if here, SKIP logic to write altitude events
        izqm_nrlacqc = izqm_topstk

      endif

c Temperature
c -----------

c Obs/Events
      if((itqm_topstk.eq.0  .or.
     +  (itqm_topstk.ge.4 .and. itqm_topstk.le.15) .or.  ! ob has already been marked bad by
                                                         !  NCEP codes
     +   itqm_topstk.eq.9999 .or.
     +  (itqm_topstk.eq.3.and.itqm_nrlacqc.le.3) .or.
     +  (itqm_nrlacqc.eq.2.and.itrc_nrlacqc.eq.099) .or.
     +  (itqm_topstk.eq.itqm_nrlacqc.and.itqm_nrlacqc.ne.1)
     +        ) .and. (itqm_nrlacqc.ne.13.or.
     +                 itqm_topstk.eq.9999)) then  ! no event needed; leave TQM as is
        itqm_nrlacqc = itqm_topstk

      else ! NRL QC produced an event; add this event to top of stack in memory
        if(l_allev_pf) nevents(j,3) = nevents(j,3) + 1 ! add new event (do not write over
                                                       !  event currently at top of stack
                                                       !  since l_allev_pf=TRUE)
        if(int(itrc_nrlacqc/100).eq.9 .and.
     +     itqm_nrlacqc.eq.13)  itqm_nrlacqc = 14 ! if temperature marked bad here due to it
                                                  !  being on reject list, reset TQM to 14
        tob_ev(j,nevents(j,3)) = tob_topstk
        tqm_ev(j,nevents(j,3)) = itqm_nrlacqc
        tpc_ev(j,nevents(j,3)) = nrlacqc_pc
        trc_ev(j,nevents(j,3)) = itrc_nrlacqc

      endif

c Moisture
c --------

c Obs/Events
      if((iqqm_topstk.eq.0  .or.
     +  (iqqm_topstk.ge.4 .and. iqqm_topstk.le.15) .or.  ! ob has already been marked bad by
                                                         !  NCEP codes
     +   iqqm_topstk.eq.9999 .or.
     +  (iqqm_topstk.eq.3 .and. iqqm_nrlacqc.le.3) .or.
     +  (iqqm_nrlacqc.eq.2.and.iqrc_nrlacqc.eq.099) .or.
     +  (iqqm_topstk.eq.iqqm_nrlacqc.and.iqqm_nrlacqc.ne.1)
     +        ) .and. (iqqm_nrlacqc.ne.13.or.
     +                 iqqm_topstk.eq.9999)) then  ! no event needed; leave QQM as is
        iqqm_nrlacqc = iqqm_topstk

      else ! NRL QC produced a new event; add this event to top of stack in memory
        if(l_allev_pf) nevents(j,2) = nevents(j,2) + 1 ! add new event (do not write over
                                                       !  event currently at top of stack
                                                       !  since l_allev_pf=TRUE)
        if(int(iqrc_nrlacqc/100).eq.9 .and.
     +     iqqm_nrlacqc.eq.13)  iqqm_nrlacqc = 14 ! if moisture marked bad here due to
                                                  !  temperature  being on reject list, reset
                                                  !  QQM to 14
        qob_ev(j,nevents(j,2)) = qob_topstk
        qqm_ev(j,nevents(j,2)) = iqqm_nrlacqc
        qpc_ev(j,nevents(j,2)) = nrlacqc_pc
        qrc_ev(j,nevents(j,2)) = iqrc_nrlacqc

      endif

c Wind
c ----

c Obs/Events
      if((iwqm_topstk.eq.0  .or.
     +  (iwqm_topstk.ge.4 .and. iwqm_topstk.le.15) .or.  ! ob has already been marked bad by
                                                         !  NCEP codes
     +   iwqm_topstk.eq.9999 .or.
     +  (iwqm_topstk.eq.3 .and. iwqm_nrlacqc.le.3) .or.
     +  (iwqm_nrlacqc.eq.2.and.iwrc_nrlacqc.eq.099) .or.
     +  (iwqm_topstk.eq.iwqm_nrlacqc.and.iwqm_nrlacqc.ne.1)
     +        ) .and. (iwqm_nrlacqc.ne.13.or.
     +                 iwqm_topstk.eq.9999)) then  ! no event needed; leave WQM as is
        iwqm_nrlacqc = iwqm_topstk

      else ! NRL QC produced a new event; add this event to top of stack in memory
        if(l_allev_pf) nevents(j,5) = nevents(j,5) + 1 ! add new event (do not write over
                                                       !  event currently at top of stack
                                                       !  since l_allev_pf=TRUE)
        if(int(iwrc_nrlacqc/100).eq.9 .and.
     +     iwqm_nrlacqc.eq.13)  iwqm_nrlacqc = 14 ! if wind marked bad here due to it being
                                                  !  on reject list, reset WQM to 14
        uob_ev(j,nevents(j,5)) = uob_topstk
        vob_ev(j,nevents(j,5)) = vob_topstk
        wqm_ev(j,nevents(j,5)) = iwqm_nrlacqc
        wpc_ev(j,nevents(j,5)) = nrlacqc_pc
        wrc_ev(j,nevents(j,5)) = iwrc_nrlacqc

      endif

      return

      end

      module def_vitals
        type tcvcard         ! Define a new type for a TC Vitals card
          sequence
          character*4   tcv_center      ! Hurricane Center Acronym
          character*3   tcv_storm_id    ! Storm Identifier (03L, etc)
          character*9   tcv_storm_name  ! Storm name
          integer       tcv_century     ! 2-digit century id (19 or 20)
          integer       tcv_yymmdd      ! Date of observation
          integer       tcv_hhmm        ! Time of observation (UTC)
          integer       tcv_lat         ! Storm Lat (*10), always >0
          character*1   tcv_latns       ! 'N' or 'S'
          integer       tcv_lon         ! Storm Lon (*10), always >0
          character*1   tcv_lonew       ! 'E' or 'W'
          integer       tcv_stdir       ! Storm motion vector (in degr)
          integer       tcv_stspd       ! Spd of storm movement (m/s*10)
          character*85  tcv_chunk       ! Remainder of vitals record;
                                        ! will just be read & written
        end type tcvcard
      end module def_vitals
c
      module inparms
        type datecard  ! Define a new type for the input namelist parms
          sequence
          integer       yy    ! Beginning yy of date to search for
          integer       mm    ! Beginning mm of date to search for
          integer       dd    ! Beginning dd of date to search for
          integer       hh    ! Beginning hh of date to search for
        end type datecard
      end module inparms
c
      module date_checks
        integer, save  :: ymd_now,hhmm_now,ymd_6ago,hhmm_6ago
     &                   ,ymd_6ahead,hhmm_6ahead
      end module date_checks
c
      module set_max_parms
        integer, parameter :: maxstorm=300  ! max # of storms pgm can
                                            ! handle
      end module set_max_parms
c
      module trig_vals
        real, save :: pi, dtr, rtd
        real, save :: dtk = 111194.9     ! Dist (m) over 1 deg lat
                                         ! using erad=6371.0e+3
        real, save :: erad = 6371.0e+3   ! Earth's radius (m)
        real, save :: ecircum = 40030200  ! Earth's circumference
                                          ! (m) using erad=6371.e3
        real, save :: omega = 7.292e-5
        real, save :: secphr = 3600.
      end module trig_vals
c
c------------------------------------------------------
c

c###J.Peng  2013-05-09  TC track atcfunix to genesis format  cccccccccc
c-----------------------------------------------------------------------
      module define_atcfunix_rec
        type atcfunix_card    ! Define a new type for an atcfunix card
          sequence
          character*2   atx_basin       ! Hurricane Center Acronym
          character*2   atx_storm_num   ! Storm number (03, etc)
          character*10  atx_ymdh        ! Fcst start date (yyyymmddhh)
          character*2   atx_technum     ! Always equal to 03 for models
          character*4   atx_model       ! Name of forecast model
          integer       atx_fcsthr      ! Fcst hour (i3.3)
          integer       atx_lat         ! Storm Lat (*10), always >0
          character*1   atx_latns       ! 'N' or 'S'
          integer       atx_lon         ! Storm Lon (*10), always >0
          character*1   atx_lonew       ! 'E' or 'W'
          integer       atx_vmax        ! max sfc wind speed (knots)
          integer       atx_pcen        ! Min central pressure (mb)
          character*2   atx_stype       ! Storm type (= 'XX' for now)
          integer       atx_wthresh     ! Wind threshold (34, 50, 64 kt)
          character*3   atx_quad_id     ! NEQ = start with NE quadrant
          integer       atx_ne_quad     ! Wind radius in NE quad (nm)
          integer       atx_se_quad     ! Wind radius in SE quad (nm)
          integer       atx_sw_quad     ! Wind radius in SW quad (nm)
          integer       atx_nw_quad     ! Wind radius in NW quad (nm)
        end type atcfunix_card
      end module define_atcfunix_rec

      module def_vitals
        type tcvcard         ! Define a new type for a TC Vitals card
          sequence
          character*4   tcv_center      ! Hurricane Center Acronym
          character*3   tcv_storm_id    ! Storm ID Letter Identifier (03L, etc)
          character*9   tcv_storm_name  ! Storm name
          integer*4       tcv_century     ! 2-digit century id (19 or 20)
          integer*4       tcv_yymmdd      ! Date of observation
          integer*4       tcv_hhmm        ! Time of observation (UTC)
          integer*4       tcv_lat         ! Storm Lat (*10), always >0
          character*1   tcv_latns       ! 'N' or 'S'
          integer*4       tcv_lon         ! Storm Lon (*10), always >0
          character*1   tcv_lonew       ! 'E' or 'W'
          integer*4       tcv_stdir       ! Storm motion vector (in degr)
          integer*4       tcv_stspd       ! Spd of storm movement (m/s*10)
          character*85  tcv_chunk       ! Remainder of vitals record;
                                        ! will just be read & written
        end type tcvcard
      end module def_vitals

c---------------------------------------------------------------------
      program trackgen
      USE define_atcfunix_rec
      type (atcfunix_card) inprec

      character*1 tc_tail
      character*3 storm_num
      character*9 storm_name

      character*3 stormid(100)
      character*9 stormname(100)

      integer       atx_lat_id         
      character*1   atx_latns_id      
      integer       atx_lon_id       
      character*1   atx_lonew_id    

      call read_tcv_file (stormid,stormname,ict)

      ik=0
      readloop: do while (.true.)
        read (11,85,end=870) inprec
        ik=ik+1

	if(inprec%atx_basin == 'AL') then
	  tc_tail='L'
        elseif(inprec%atx_basin == 'EP') then
	  tc_tail='E'
        elseif(inprec%atx_basin == 'WP') then
	  tc_tail='W'
        elseif(inprec%atx_basin == 'CP') then
	  tc_tail='C'
        elseif(inprec%atx_basin == 'SC') then
          tc_tail='O'
        elseif(inprec%atx_basin == 'EC') then
	  tc_tail='T'
        elseif(inprec%atx_basin == 'AU') then
          tc_tail='U'
        elseif(inprec%atx_basin == 'SP') then
	  tc_tail='P'
        elseif(inprec%atx_basin == 'SI') then
	  tc_tail='S'
        elseif(inprec%atx_basin == 'BB') then
	  tc_tail='B'
        elseif(inprec%atx_basin == 'NA') then
	  tc_tail='A'
        else
	  tc_tail='X'
        endif
       
	storm_num=inprec%atx_storm_num//tc_tail
        do i=1,ict
          if(stormid(i)== storm_num) then
	    storm_name=stormname(i)
            goto 199
          else
            storm_name="No_nameTC"
          endif
        enddo
 199    continue

	if(inprec%atx_fcsthr.eq.0) then
          atx_lat_id=inprec%atx_lat
	  atx_latns_id=inprec%atx_latns
	  atx_lon_id=inprec%atx_lon
	  atx_lonew_id=inprec%atx_lonew
        endif

        write (66,87) inprec%atx_basin,storm_num
     &        ,inprec%atx_ymdh,inprec%atx_fcsthr
     &        ,atx_lat_id,atx_latns_id
     &        ,atx_lon_id,atx_lonew_id
     &        ,storm_num,inprec%atx_ymdh
     &        ,inprec%atx_model,inprec%atx_fcsthr
     &        ,inprec%atx_lat,inprec%atx_latns
     &        ,inprec%atx_lon,inprec%atx_lonew
     &        ,inprec%atx_vmax, inprec%atx_pcen
     &        ,'XX,  34, NEQ'
     &        ,inprec%atx_ne_quad,inprec%atx_se_quad
     &        ,inprec%atx_sw_quad,inprec%atx_nw_quad
     &        ,-999,-999,-99,-99,-99
     &        ,-99,-9999,-9999
     &        ,-999,-999,-999,-999
     &        ,storm_name

      enddo readloop
  870 continue

   87 format (a2,', ',a4,', ',a10,'_F',i3.3,'_',i3.3,a1,'_',i4.4,a1
     &       ,'_',a3,', ',a10,', 03, ',a4,', ',i3.3,', ',i3,a1
     &       ,', ',i4,a1,', ',i3,', ',i4,', ',a12,4(', ',i4.4)
     &       ,', ',2(i4,', '),4(i3,', '),2(i5,', '),4(i4,', '),a9)
cPENG bug fixed on 04/20/2018---------------------------------
 85   format (a2,2x,a2,2x,a10,2x,a2,2x,a4,2x,i3,2x,i3,a1,2x,i4,a1,2x
     &       ,i3,2x,i4,2x,a2,3x,i2,2x,a3,4(2x,i4))
c 85   format (a2,2x,a2,2x,a10,2x,a2,2x,a4,2x,i3,2x,i3,a1,2x,i4,a1,2x
c     &       ,i3,2x,i4,2x,a2,2x,i2,2x,a3,4(2x,i3))

      stop
      end
c-----------------------------------------------------------------------
      subroutine read_tcv_file (stormid,stormname,ict)
      USE def_vitals
      type (tcvcard) ts
      character*3 stormid(100)
      character*9 stormname(100)

      ict=0
      do while (.true.)
        read (31,21,END=801) ts
        ict=ict+1
        stormid(ict)=ts%tcv_storm_id
        stormname(ict)=ts%tcv_storm_name
      enddo
   21 format (a4,1x,a3,1x,a9,1x,i2,i6,1x,i4,1x,i3,a1,1x,i4,a1
     &       ,1x,i3,1x,i3,a85)
  801 continue
      return
      end

c tideg.f
c  process tide gauge data for MODSBUFR
c
c modification history
c   6 Feb 2013  producion implementation
c  22 Feb 2019  bug fix: trapped case of single missing tide time 
c                 field; NRPT_NCO added to arg list to support printout
c               added ibfms() checks on missing values; rm'd BMISS.
c---
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      SUBROUTINE TIDEG(LUBFR,LUBFO,SUBSET,IDATE,NRPT,NRPT_NCO)
 
      COMMON /MNEMONIC/ NEMOS(10),NEMS,COMPRESS
 
      CHARACTER*80 NEMOS
      CHARACTER*8  SUBSET
      LOGICAL      COMPRESS,NOTIME
      REAL*8             CLONH,CLATH,ADATE,DATE(5)
      REAL*8       TIMEP(2),TIDES(2,255),ARR(10,255)
 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

C  READ THE TIME PERIOD INFORMATION AND HIGH RES LON/LAT
C  -----------------------------------------------------
 
      CALL UFBINT(LUBFR,TIMEP,2,  1,IRET,'TPMI  TIMI')
      CALL UFBINT(LUBFR,TIDES,2,255,NTID,'TIDER TERC')
      CALL CLONLAT(LUBFR,CLONH,CLATH)
 
C  CHECK IF THERE IS A TIME FRAME HERE AND SETUP FIRST IDATE
C  ---------------------------------------------------------
 
      NOTIME = ibfms(TIMEP(1)).NE.0.AND.ibfms(TIMEP(2)).NE.0 ! both missing

      IF(NOTIME.AND.NTID.GT.1) THEN
         PRINT*,'>>>>>TIDEG - NO TIMES FOR MULTIPLE READINGS<<<<<'
      ENDIF

      IF(NOTIME) THEN          ! both timep() fields missing
         ADATE = IDATE
         DHR = 0
      ELSE                     ! at least 1 timep() fld non-missing

c --- trap case where only one of the time field is missing
         if ( ibfms(timep(1)).ne.0.or.ibfms(timep(2)).ne.0 ) then
           write(*,*) 'bad tide times: ',timep,notime, NRPT_NCO
         endif
         if ( ibfms(timep(1)).ne.0 ) timep(1)=0.d0
         if ( ibfms(timep(2)).ne.0 ) timep(2)=0.d0

         ADATE = IDATE
         DHR = (TIMEP(1)+TIMEP(2))/60.
         CALL RADDATE(ADATE,DHR,ADATE)
         DHR = TIMEP(2)/60.
      ENDIF
 

C  CREATE TIDE GAUGE REPORTS
C  -------------------------
 
      DO M=1,MAX(NTID,1)
 
      IF(ibfms(TIDES(1,M)).eq.0.OR.ibfms(TIDES(2,M)).eq.0.OR.M.EQ.1)THEN
         JDATE = ADATE
         DATE(1) = JDATE/1000000
         DATE(2) = MOD(JDATE/10000,100)
         DATE(3) = MOD(JDATE/100  ,100)
         DATE(4) = MOD(JDATE      ,100)
         DATE(5) = (ADATE-JDATE)*60.          

         CALL OPENMB(LUBFO,SUBSET,IDATE)
 
         CALL UFBINT(LUBFO,CLONH,1,1,IRET,'CLONH')
         CALL UFBINT(LUBFO,CLATH,1,1,IRET,'CLATH')

         CALL UFBINT(LUBFO,DATE,5,1,IRET,'YEAR MNTH DAYS HOUR MINU')
         nrpt = nrpt + 1
 
         DO N=1,NEMS
         CALL UFBINT(LUBFR,ARR,10,255,NRET,NEMOS(N))
         IF(NRET.GT.0) CALL UFBINT(LUBFO,ARR,10,NRET,IRET,NEMOS(N))
         ENDDO
 
         CALL UFBINT(LUBFO,TIDES(1,M),2,1,IRET,'TIDER TERC')
 
         CALL RADDATE(ADATE,DHR,ADATE)  ! APPLY TIME INCREMENT
      ENDIF
 
c Disable compression (due to problem porting to Cirrus; fails on wrcmps)
c  (this should be revisited after update to Cirrus BLib)
ccc   IF(.NOT.COMPRESS) CALL WRITSB(LUBFO)
ccc   IF(     COMPRESS) CALL WRITCP(LUBFO)
      CALL WRITSB(LUBFO)
 
 
      ENDDO
 
      RETURN
      END

C***********************************************************************
C***********************************************************************
      SUBROUTINE GBLEVN10(IUNITF,IDATEP,IM,JM,KBAK) ! FORMERLY
                                                    ! SUBROUTINE GESRES
      USE GBLEVN_MODULE
      USE SIGIO_MODULE
      USE SIGIO_R_MODULE
      USE SP_MOD, ONLY: SPTEZM, SPTEZMV

      IMPLICIT NONE
      INTEGER IUNITF(2), IDATEP, IM, JM, KBAK 
      REAL, PARAMETER :: PI180=.0174532
      INTEGER*4, PARAMETER :: ONE=1, TEN=10

      TYPE(SIGIO_HEAD) :: HEAD(2)
      TYPE(SIGIO_DATS) :: DATS
      TYPE(SIGIO_DATM) :: DATM

      INTEGER*4 IDVC,IDSL,NVCOORD,SFCPRESS_ID,THERMODYN_ID
      INTEGER*4 IRET,IRET1,IRETS,IMJM,KM4,IDVM,NTRAC,IUNIT4(2)

      INTEGER KFILES,IFILE,JFILE,IDATGS_COR,JCAP,JCAP1,JCAP2,JCAP1X2,
     $ MDIMA,MDIMB,MDIMC,IROMB,MAXWV,IDIR,NS,I,J,K,L,II,JJ,KK,IB,IE
     $ ,latb,lonb  

      INTEGER IDATE(8,2),JDATE(8,2),KDATE(8,2),KINDX(2)

      CHARACTER*6  COORD(3)
      CHARACTER*20 CFILE

      REAL FHOUR

      DATA COORD /'SIGMA ','HYBRID','GENHYB'/

      REAL, ALLOCATABLE :: cofs(:,:),     cofv(:,:,:)
      REAL, ALLOCATABLE :: cofs_f(:,:,:), cofv_f(:,:,:,:)
      REAL, ALLOCATABLE :: grds(:,:,:),   grdv(:,:,:,:)
      REAL, ALLOCATABLE :: wrk1(:,:),     wrk2(:,:)
      REAL, ALLOCATABLE :: dprs(:,:),ak5(:),bk5(:)

      IMAX = IM
      JMAX = JM
      IMJM = IM*JM
      IUNIT4(:) = IUNITF(:)

      IF(NBAK/=2)  THEN
         KFILES = 1
         KINDX = 0
         PRINT 331,kbak,nbak          
  331    FORMAT(/' --> GBLEVENTS: background time ',i2,' of ',i2)  
      ELSE
         KFILES = 2
         KINDX(1) = MOD(MOD(IDATEP,100),3)
         KINDX(2) = KINDX(1) - 3
         PRINT 332, MOD(IDATEP,100)
  332    FORMAT(/' --> GBLEVENTS: THE PREPBUFR CENTER HOUR (',I2.2,
     $    ') IS NOT A MULTIPLE OF 3 - TWO SPANNING GLOBAL SIGMA OR ',
     $    'HYBRID FILES'/16X,'ARE READ AND THE SPECTRAL COEFFICIENTS ',
     $    'ARE INTERPOLATED TO THE PREPBUFR CENTER TIME'/)
      ENDIF

C  GET VALID-TIME DATE OF SIGMA OR HYBRID FILE(S), ALSO READ HEADERS
C  -----------------------------------------------------------------

      JFILE = 0
      DO IFILE=1,KFILES
         JFILE = IFILE; idate(:,ifile)=0

         WRITE(CFILE,'("fort.",I2.2)') IUNITF(IFILE)

         print *,' cfile=',cfile

         CALL SIGIO_RROPEN(IUNIT4(IFILE),CFILE,IRET)
         CALL SIGIO_RRHEAD(IUNIT4(IFILE),HEAD(IFILE),IRET1)

         IF(IRET.NE.0)  GO TO 903
         IF(IRET1.NE.0) GO TO 904

         IDATE(1,IFILE)   = HEAD(IFILE)%IDATE(4)
         IDATE(2:3,IFILE) = HEAD(IFILE)%IDATE(2:3)
         IDATE(5,IFILE)   = HEAD(IFILE)%IDATE(1)

         FHOUR = HEAD(IFILE)%FHOUR
         print *,' idate=',idate(:,ifile),' fhour=',head(ifile)%fhour

         IF(IDATE(1,IFILE).LT.100)  THEN

C IF 2-DIGIT YEAR FOUND IN GLOBAL SIMGA FILE INITIAL DATE
C  (IDATE(1,IFILE)), MUST USE "WINDOWING" TECHNIQUE TO CREATE A 4-DIGIT
C  YEAR (NOTE: THE T170 IMPLEMENTATION IN JUNE 1998 WAS TO INCLUDE THE
C  WRITING OF A 4-DIGIT YEAR HERE.  PRIOR TO THIS, THE YEAR HERE WAS
C  2-DIGIT.)

            PRINT *, '##GBLEVENTS/GBLEVN10 - 2-DIGIT YEAR FOUND IN ',
     $       'GLOBAL SIGMA OR HYBRID FILE ',IFILE,'; INITIAL DATE ',
     $       '(YEAR IS: ',idate(1,IFILE),')'
            PRINT *, '     - USE WINDOWING TECHNIQUE TO OBTAIN 4-DIGIT',
     $       ' YEAR'
            IF(IDATE(1,IFILE).GT.20)  THEN
               IDATE(1,IFILE) = 1900 + IDATE(1,IFILE)
            ELSE
               IDATE(1,IFILE) = 2000 + IDATE(1,IFILE)
            ENDIF
            PRINT *,'##GBLEVENTS/GBLEVN10 - CORRECTED 4-DIGIT YEAR IS ',
     $       'NOW: ',IDATE(1,IFILE)
         ENDIF

         CALL W3MOVDAT((/0.,FHOUR,0.,0.,0./),IDATE(:,IFILE),
     $                 JDATE(:,IFILE))

         PRINT 1, kbak,HEAD(IFILE)%FHOUR,
     $    (IDATE(II,IFILE),II=1,3),IDATE(5,IFILE),(JDATE(II,IFILE),
     $    II=1,3),JDATE(5,IFILE)
    1    FORMAT(' --> GBLEVENTS: GLOBAL SIGMA OR HYBRID FILE',I2,
     $    ' HERE IS A ',F5.1,' HOUR FORECAST FROM ',I5.4,3I3.2,' VALID',
     $    ' AT ',I5.4,3I3.2)

         KDATE(:,IFILE) = JDATE(:,IFILE)

         IF(KFILES.EQ.2) CALL W3MOVDAT((/0.,REAL(KINDX(IFILE)),0.,0.,
     $    0./),JDATE(:,IFILE),KDATE(:,IFILE))

         IDATGS_COR = (KDATE(1,IFILE) * 1000000) + (KDATE(2,IFILE) *
     $    10000) + (KDATE(3,IFILE) * 100) + KDATE(5,IFILE)

C  VALID DATES MUST MATCH
C  ----------------------

         IF(IDATEP.NE.IDATGS_COR)  GO TO 901

      ENDDO


C  EXTRACT HEADER INFO
C  -------------------
 
      JCAP    = HEAD(1)%JCAP
      KMAX    = HEAD(1)%LEVS
      latb    = HEAD(1)%latb
      lonb    = HEAD(1)%lonb
      KM4     = KMAX
      IDVC    = HEAD(1)%IDVC
      IDVM    = HEAD(1)%IDVM
      NTRAC   = HEAD(1)%NTRAC
      NVCOORD = HEAD(1)%NVCOORD
      ALLOCATE (VCOORD(KMAX+1,NVCOORD))
      VCOORD  = HEAD(1)%VCOORD

      if(imax<=0) then
         IMAX  = min(2304,lonb)
         JMAX  = min(1152,latb)
         IMJM  = IMax*JMax
      endif

      if(kbak==1) then
         print*
         print*,'jcap =',jcap
         print*,'kmax =',kmax
         print*,'lonb =',lonb
         print*,'latb =',latb
         print*,'km4  =',km4 
         print*,'idvc =',idvc
         print*,'idvm =',idvm
         print*,'idrt =',idrt
         print*,'ntrac=',ntrac
         print*
         !!do i=1,kmax+1
         !!print*,'a,b',i,vcoord(i,:)
         !!enddo
         !!print*
      endif

      SFCPRESS_ID  = MOD(HEAD(1)%IDVM,TEN)
      THERMODYN_ID = MOD(HEAD(1)%IDVM/TEN,TEN)

      print*
      print*,'sfcpress_id=' ,sfcpress_id
      print*,'thermodyn_id=',thermodyn_id
      print*

      IF(IDVC == 3 .AND. THERMODYN_ID == 3) THEN
         KMAXS = (NTRAC+1)*KMAX + 2
      ELSE
         KMAXS = 2*KMAX + 2
         NTRAC = 1
      ENDIF

!  allocate the background grids

      ALLOCATE (iar12z(imax,jmax)     ,  iar13p(imax,jmax)       )
      ALLOCATE (iar14t(imax,jmax,kmax),  iar15u(imax,jmax,kmax)  )
      ALLOCATE (iar16v(imax,jmax,kmax),  iar17q(imax,jmax,kmax)  )
      ALLOCATE (iarpsl(imax,jmax,kmax),  iarpsi(imax,jmax,kmax+1))

C  DEFINE THE OTHER RESOLUTION PARAMETERS
C  --------------------------------------
 
      JCAP1   = JCAP+1
      JCAP2   = JCAP+2
      JCAP1X2 = JCAP1*2
      MDIMA   = JCAP1*JCAP2
      MDIMB   = MDIMA/2+JCAP1
      MDIMC   = MDIMB*2
 
      DLAT  = 180./(JMAX-1)
      DLON  = 360./IMAX
 
      PRINT 2, JCAP,KMAX,kmaxs,DLAT,DLON,COORD(IDVC)
    2 FORMAT(/' --> GBLEVENTS: GLOBAL MODEL SPECS: T',I5,' ',I3,
     $ ' LEVELS ',I3,' SCALARS -------> ',F5.2,' X ',F5.2,' VERT. ',
     $ 'COORD: ',A)
 
      GO TO 902

  901 CONTINUE
      PRINT 9901, JFILE,(JDATE(II,JFILE),II=1,3),JDATE(5,JFILE),IDATEP
 9901 FORMAT(/' ##GBLEVENTS/GBLEVN10 - SIGMA OR HYBRID FILE',I2,' DATE',
     $ ' (',I4.4,3(I2.2),'), DOES NOT MATCH -OR SPAN- PREPBUFR FILE ',
     $ 'CENTER DATE (',I10,') -STOP 68'/)
      CALL ERREXIT(68)
  903 CONTINUE
      PRINT 9903, JFILE,IRET
 9903 FORMAT(/' ##GBLEVENTS/GBLEVN10 - SIGMA OR HYBRID FILE',I2,
     $ ' RETURNED FROM SIGIO_RROPEN WITH R.C.',I3,' -STOP 70'/)
      CALL ERREXIT(70)
  904 CONTINUE
      PRINT 9904, JFILE,IRET1
 9904 FORMAT(/' ##GBLEVENTS/GBLEVN10 - SIGMA OR HYBRID FILE',I2,
     $ ' RETURNED FROM SIGIO_RRHEAD WITH R.C.',I3,' -STOP 71'/)
      CALL ERREXIT(71)
  902 CONTINUE
      IF(KMAX.GT.500) then
         PRINT *,'##GBLEVENTS/GBLEVN10 - KMAX TOO BIG = ',KMAX,
     $    ' - UNABLE',' TO TRANSFORM GLOBAL SIGMA FILE(S) - STOP 69'
         CALL ERREXIT(69)
      ENDIF

C***********************************************************************
C***********************************************************************

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C USAGE:    CALL SPTEZM(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,WAVE,GRID,IDIR)
C   INPUT ARGUMENTS:
C     IROMB    - INTEGER SPECTRAL DOMAIN SHAPE
C                (0 FOR TRIANGULAR, 1 FOR RHOMBOIDAL)
C     MAXWV    - INTEGER SPECTRAL TRUNCATION
C     IDRT     - INTEGER GRID IDENTIFIER
C                (IDRT=4 FOR GAUSSIAN GRID,
C                 IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C                 IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
C     IMAX     - INTEGER EVEN NUMBER OF LONGITUDES
C     JMAX     - INTEGER NUMBER OF LATITUDES
C     KMAX     - INTEGER NUMBER OF FIELDS TO TRANSFORM
C     WAVE     - REAL (2*MX,KMAX) WAVE FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRID     - REAL (IMAX,JMAX,KMAX) GRID FIELD (E->W,N->S) IF IDIR<0
C     IDIR     - INTEGER TRANSFORM FLAG
C                (IDIR>0 FOR WAVE TO GRID, IDIR<0 FOR GRID TO WAVE)
C   OUTPUT ARGUMENTS:
C     WAVE     - REAL (2*MX,KMAX) WAVE FIELD IF IDIR<0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRID     - REAL (IMAX,JMAX,KMAX) GRID FIELD (E->W,N->S) IF IDIR>0


C USAGE:    CALL SPTEZMV(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
C    &                   WAVED,WAVEZ,GRIDU,GRIDV,IDIR)
C   INPUT ARGUMENTS:
C     WAVED    - REAL (2*MX,KMAX) WAVE DIVERGENCE FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     WAVEZ    - REAL (2*MX,KMAX) WAVE VORTICITY FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRIDU    - REAL (IMAX,JMAX,KMAX) GRID U-WIND (E->W,N->S) IF IDIR<0
C     GRIDV    - REAL (IMAX,JMAX,KMAX) GRID V-WIND (E->W,N->S) IF IDIR<0
C   OUTPUT ARGUMENTS:
C     WAVED    - REAL (2*MX,KMAX) WAVE DIVERGENCE FIELD IF IDIR<0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     WAVEZ    - REAL (2*MX,KMAX) WAVE VORTICITY FIELD IF IDIR>0
C                WHERE MX=(MAXWV+1)*((IROMB+1)*MAXWV+2)/2
C     GRIDU    - REAL (IMAX,JMAX,KMAX) GRID U-WIND (E->W,N->S) IF IDIR>0
C     GRIDV    - REAL (IMAX,JMAX,KMAX) GRID V-WIND (E->W,N->S) IF IDIR>0

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      IROMB = 0
      MAXWV = JCAP
      !!if (idrt < 0 .or. idrt > 256) IDRT  = 0
      IDIR  = 1

      IF(KINDX(1).EQ.0)  THEN
         KFILES = 1
         ifile=1
      ELSE
         KFILES = 2
      ENDIF


!  copy the spectral coefficients into memory

         CALL SIGIO_ALDATS(HEAD(IFILE),DATS,IRETS)
         CALL SIGIO_ALDATM(HEAD(IFILE),ONE,KM4,DATM,IRETS)

         CALL SIGIO_RRDATS(IUNIT4(IFILE),HEAD(IFILE),DATS,IRETS)
         IF(IRETS.NE.0) THEN
            print *,' irets from sigio_rrdats = ', irets
            RETURN
         ENDIF

         CALL SIGIO_RRDATM(IUNIT4(IFILE),HEAD(IFILE),DATM,IRETS)
         IF(IRETS.NE.0) THEN
            print *,' irets from sigio_rrdatm = ', irets
            RETURN
         ENDIF

         if(kbak==1) call prttime('sigio')

!  store coefficients in allocated working memory

      ALLOCATE (COFS(MDIMA,KMAXS),     COFV(MDIMA,KMAX,2))
      ALLOCATE (GRDS(imax,jmax,KMAXS), GRDV(imax,jmax,KMAX,2))
      ALLOCATE (WRK1(imax*jmax,KMAX),  WRK2(imax,jmax))

      COFS(:,1) = DATS%HS(:)
      COFS(:,2) = DATS%PS(:)
      do k=1,kmax
      cofs(:,2+k)      = datm%t(:,k)
      cofs(:,kmax+2+k) = datm%q(:,k,1)
      cofv(:,k,1)      = datm%d(:,k)
      cofv(:,k,2)      = datm%z(:,k)
      enddo
         
!  run the transforms

      CALL SPTEZM(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAXS,COFS,GRDS,IDIR)
      if(kbak==1) call prttime('sptezm') 

      CALL SPTEZMV(IROMB,MAXWV,IDRT,IMAX,JMAX,KMAX,
     &         COFV(1,1,1),COFV(1,1,2),GRDV(1,1,1,1),GRDV(1,1,1,2),IDIR)

      if(kbak==1) call prttime('sptezmv') 

!  reverse poles in the grids

      DO NS=1, KMAXS
      CALL GBLEVN11(IMAX,JMAX,GRDS(1,1,NS))
      ENDDO

      DO L=1,KMAX
      CALL GBLEVN11(IMAX,JMAX,GRDV(1,1,L,1))
      CALL GBLEVN11(IMAX,JMAX,GRDV(1,1,L,2))
      ENDDO

!  process orography and surface pressure

      IF( SFCPRESS_ID == 2 ) GRDS(:,:,2) = 1000.0*GRDS(:,:,2)   
      IF( SFCPRESS_ID /= 2 ) GRDS(:,:,2) = 1000.0*EXP(GRDS(:,:,2))   

      IAR12Z(:,:) = GRDS(:,:,1)         ! Orography
      IAR13P(:,:) = GRDS(:,:,2) * 0.01  ! Surface Pressure in hPa

!  possibly process virtual temperature 

      IF(THERMODYN_ID == 3 .AND. IDVC == 3) THEN 
         ! Convert back to sensible temperature
         CALL SIGIO_CNVTDV(IMJM,IMJM,KM4,IDVC,IDVM,NTRAC,IRET,
     .   GRDS(1,1,3),GRDS(1,1,3+KMAX),HEAD(1)%CPI,1_4)
         ! Convert back to virtual temperature
         GRDS(:,:,3:KMAX+2) = GRDS(:,:,3:KMAX+2) *
     .   (1.+(461.50/287.05-1)*GRDS(:,:,3+KMAX:2+KMAX*2))
      ENDIF

!  use gsm routine to derive mid layer pressures

      allocate (ak5(kmax+1),bk5(kmax+1),dprs(imjm,kmax))

      do k=1,kmax+1
      kk = (kmax+1)-(k-1)
      ak5(kk) = vcoord(k,1) * 0.001
      bk5(kk) = vcoord(k,2) 
      end do

      wrk2(:,:)=IAR13P(:,:)
      call hyb2pres(imjm,kmax,ak5,bk5,wrk2,wrk1,dprs)
      if(kbak==1) call prttime('hyb2pres')

      !!print*,wrk2(1,1)
      !!print*,wrk1(1,:)

!  copy grids to working memory

      DO L=1,KMAX; J=1
      DO I=1,IMAX*jmax
      IAR14T(I,J,L) = GRDS(I,J,2+L)                     ! Temp (virtual)
      IAR15U(I,J,L) = GRDV(I,J,L,1)                     ! U component
      IAR16V(I,J,L) = GRDV(I,J,L,2)                     ! V component
      IAR17Q(I,J,L) = MAX(0.0,GRDS(I,J,2+KMAX+L)*1.0E6) ! specific humidity
      IARPSL(I,J,L) = WRK1(I,L)                         ! 3D layer pres(hPa)
      ENDDO
      !!print*,iarpsl(1,1,l)
      ENDDO

      DEALLOCATE (COFS, COFV)
      DEALLOCATE (GRDS, GRDV, WRK1, WRK2)
      DEALLOCATE ( ak5,  bk5, dprs)

      print *,' RETURNING from GBLENV10'

      RETURN

      END

      program sort_and_update_vitals
c
c$$$  MAIN PROGRAM DOCUMENTATION BLOCK
c
c Main Program: SUPVIT       Sort and Update Vitals File
C   PRGMMR: MARCHOK          ORG: NP22        DATE: 1999-04-14
c
c ABSTRACT: This program searches through the TC Vitals file and reads 
c   the records for a particular dtg.  It contains logic to eliminate
c   duplicate records and only keep the most recent one (see further
c   documentation below).  It also searches to see if a storm was
c   included in the Vitals file 6 hours earlier (or 3 hours earlier 
c   if we're tracking with the off-synoptic-time SREF) but is missing 
c   from the current Vitals records.  In this case, the program assumes
c   that the regional forecasting center was late in reporting the
c   current position, and it includes the old Vitals record with
c   the current Vitals records.  This program will also take the
c   position and heading from that old vitals record and extrapolate the
c   information to get a current first guess estimate of the storm's
c   position.  By the way, if a storm was found 3 or 6 hours earlier, 
c   logic is also included to eliminate any duplicate records of that 
c   storm in those old records.  Finally, if it turns out that the 
c   reason an old vitals is no longer on the current records is that 
c   the storm has dissipated, don't worry about including it to be 
c   passed into the tracking program; the tracking program will not be 
c   able to track it and that'll be the end of it.
c
c Program history log:
c   98-03-26  Marchok - Original operational version.
c   99-04-01  Marchok - Modified code to be able to read the year off
c                       of the TC Vitals card as a 4-digit integer, 
c                       instead of as a 2-digit integer.
c   00-06-13  Marchok - Modified code to be able to read vitals from 6h
c                       ahead (this is for use in the GDAS tropical 
c                       cyclone relocation system).
c   04-05-27  Marchok - Modified code to be able to read vitals from 3h
c                       ago.  This is for tracking with the 09z and 21z
c                       SREF ensemble.  Since there are no vitals at
c                       these offtimes, we need to update vitals from
c                       the synoptic times 3h earlier.
c
c Input files:
c   unit   31    Text file containing all vitals (including duplicates)
c                for current time and time from 3 or 6 hours ago and 
c                3 or 6 hours ahead.
c Output files:
c   unit   51    Text file containing sorted, updated vitals (without
c                any duplicates) valid at the current time only.
c
c Subprograms called:
c   read_nlists  Read input namelists for input dates
c   read_tcv_file Read TC vitals file to get initial storm positions
c   delete_dups  Delete duplicate TC vitals records from current time
c   delete_old  Delete records from 6h ago if current record exists
c   delete_old_dups  Delete duplicate records from 6h ago time
c   update_old_vits  Update position of storms from 6h ago positions
c   output       Output 1 record for each updated vitals record
c
c Attributes:
c   Language: Fortran_90
c
c$$$
c
c-------
c 
c
      USE def_vitals; USE set_max_parms; USE inparms; USE date_checks
      USE trig_vals
c
      type (tcvcard) storm(maxstorm)
      type (datecard) dnow, dold, dfuture

      logical  okstorm(maxstorm)
      integer  vit_hr_incr
c
      call w3tagb('SUPVIT  ',1999,0104,0058,'NP22   ')
c
      okstorm = .FALSE.
c
      pi = 4. * atan(1.)   ! pi, dtr and rtd were declared in module
      dtr = pi/180.0       ! trig_vals, but were not yet defined.
      rtd = 180.0/pi 
c
c     -----------------------------------------
c     Read namelists to get date information
c
      call read_nlists (dnow,dold,dfuture,vit_hr_incr)
c
c     -----------------------------------------------------------
c     Read in storm cards for current time and delete duplicates
c

      inowct = 0
      call read_tcv_file (storm,ymd_now,hhmm_now,inowct,okstorm)
 
      if (inowct > 0) then
        call delete_dups (storm,inowct,okstorm)
      else
        print *,' '
        print *,'!!! No storms on tcv card for current time.'
        print *,'!!! A check will be made for old tcv storm cards,'
        print *,'!!! and if any exist, the positions will be updated'
        print *,'!!! (extrapolated) to get a first guess position for'
        print *,'!!! the current time.'
        print *,'!!! Current forecast time = ',ymd_now,hhmm_now
        print *,'!!! Old forecast time = ',ymd_old,hhmm_old
      endif
c
c     -----------------------------------------------------------
c     Read in storm cards for 3h or 6h ago and delete duplicates
c
      rewind (31)
      itempct = inowct
      call read_tcv_file (storm,ymd_old,hhmm_old,itempct,okstorm)
      ioldct = itempct - inowct
 
      if (ioldct > 0) then
        if (inowct > 0) then
          call delete_old (storm,inowct,ioldct,okstorm)
        endif
        call delete_old_dups (storm,inowct,ioldct,okstorm)
      endif
 
c     ----------------------------------------------------------------
c     Now update any vitals records left from 3h or 6h ago by 
c     extrapolating their positions ahead to the current time.
 
      if (ioldct > 0) then
        call update_old_vits (storm,inowct,ioldct,okstorm,vit_hr_incr)
      endif


c     --------------------------------------------------------------
c     Read in storm cards for 3h or 6h ahead and delete duplicates.  
c     This is used for Qingfu's vortex relocation purposes.  If he is
c     doing the analysis/relocation for, say, 12z, he looks at the
c     first guess files from the 06z cycle and tracks from there.
c     But suppose there is a storm whose first tcvitals card is 
c     issued at 12z; then we would have no tcvitals card at 06z for
c     the tracker to use.  So this next part reads the vitals from
c     the cycle 6h ahead and, if it finds any vitals that were not
c     included with the current time's vitals, then it extrapolates
c     those vitals from the next cycle *backwards* to the current
c     time.  By the way, itempct is input/output for the  read 
c     routine.  Going in, it contains the count of the number of 
c     records read in so far.  In that read routine, itempct is 
c     incremented for every valid record read for the input time.

      rewind (31)
      iprevct = inowct + ioldct
      call read_tcv_file (storm,ymd_future,hhmm_future,itempct,okstorm)
      ifuturect = itempct - iprevct

      print *,'before d6a if, ifuturect = ',ifuturect,' iprevct= '
     &       ,iprevct
      print *,'before d6a if, inowct = ',inowct,' ioldct= ',ioldct

      if (ifuturect > 0) then
        if (iprevct > 0) then
          call delete_future (storm,iprevct,ifuturect,okstorm)
        endif
        call delete_future_dups (storm,iprevct,ifuturect,okstorm)
      endif

c     ----------------------------------------------------------------
c     Now update any vitals records not filtered out from 3h or 6h
c     ahead by extrapolating their future positions *backwards* to 
c     the current time.
 
      if (ifuturect > 0) then
        call update_future_vits (storm,iprevct,ifuturect,okstorm
     &                          ,vit_hr_incr)
      endif

 
c     ---------------------------------------------------------
c     Now output all of the sorted, updated TC Vitals records
 
      itotalct = inowct + ioldct + ifuturect
      call output (storm,itotalct,okstorm)
c
      call w3tage('SUPVIT  ')
      stop
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_tcv_file (storm,ymd,hhmm,ict,okstorm)
c
c     ABSTRACT: This routine  reads in the TC Vitals file, and stores
c     into an array those records that match the input ymd and hhmm.
c
c     INPUT:
c
c     ict     Tells at what index in the storm array to begin reading
c             the input records into.  This is important because this
c             subroutine is called twice; the first time the data are
c             for the current time and are just started at ict = 0,
c             but the second time it's called we're getting the 6h ago
c             data, and they have to be added onto the end of the
c             array, so we need to know where the current time's data
c             ends so we know what index to start the 6h ago data.
c
      USE def_vitals; USE set_max_parms
c
      type (tcvcard) storm(maxstorm), ts
c
      integer  ymd,hhmm
      logical  okstorm(maxstorm)
c
      lucard = 31

      print *,' '
      print '(a26,i6.6,a8,i4.4)',' IN READ_TCV_FILE: , ymd= ',ymd
     &      ,'  hhmm= ',hhmm
      print *,' '


      do while (.true.)
        read (lucard,21,END=801,ERR=891) ts
        if (ts%tcv_yymmdd == ymd .and. ts%tcv_hhmm == hhmm) then
          ict = ict + 1
          storm(ict) = ts
          okstorm(ict) = .TRUE.
          write (6,23) ' !!! MATCH, ict= ',ict,storm(ict)
        endif
      enddo
  801 continue

   21 format (a4,1x,a3,1x,a9,1x,i2,i6,1x,i4,1x,i3,a1,1x,i4,a1,1x,i3,1x
     &       ,i3,a85)
   23 format (a18,i3,2x,a4,1x,a3,1x,a9,1x,i2,i6.6,1x,i4.4,1x,i3,a1,1x,i4
     &       ,a1,1x,i3,1x,i3,a85)

      iret = 0
      return

  891 print *,'WARNING: Problem with syndat_tcvitals input occurred'
      print *,'in supvit_g2 program while reading unit ',lucard
      iret = 98

      return
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine output (storm,itotalct,okstorm)
c
      USE def_vitals; USE set_max_parms; USE inparms
c
      type (tcvcard) storm(maxstorm)
      type (datecard) dnow, dold, dfuture

      logical  okstorm(maxstorm)
c
      lunvit = 51

      ist = 1
      do while (ist <= itotalct)

        if (okstorm(ist)) then
          if (storm(ist)%tcv_stdir == -99 .or.
     &        storm(ist)%tcv_stspd == -99) then
            write (lunvit,23,ERR=891) storm(ist)
          else
            write (lunvit,21,ERR=891) storm(ist)
          endif
        endif

        ist = ist + 1

      enddo

   21 format (a4,1x,a3,1x,a9,1x,i2.2,i6.6,1x,i4.4,1x,i3.3,a1,1x,i4.4
     &       ,a1,1x,i3.3,1x,i3.3,a85)
   23 format (a4,1x,a3,1x,a9,1x,i2.2,i6.6,1x,i4.4,1x,i3.3,a1,1x,i4.4
     &       ,a1,1x,i3,1x,i3,a85)

      iret = 0
      return

  891 print *,'!!! WARNING in program sort_and_update_vitals.  Problem '
      print *,'!!! occurred in output while writing new vitals file '
      print *,'!!! to unit number',lunvit
      iret = 98

      return
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine update_old_vits (storm,inowct,ioldct,okstorm
     &                           ,vit_hr_incr)
c
c     ABSTRACT: This subroutine updates the vitals from 3h or 6h ago.
c     It uses the heading and direction values listed in the vitals
c     record (see Module def_vitals for specfics on where to find 
c     heading & direction in the vitals record) to get a new
c     position for the current time by extrapolating out 3h or 6h.
c
      USE def_vitals; USE set_max_parms; USE inparms; USE date_checks
      USE trig_vals
c
      type (tcvcard) storm(maxstorm)
      type (datecard) dnow, dold

      logical  okstorm(maxstorm)
      integer  vit_hr_incr
c
      ist  = inowct + 1
      iend = inowct + ioldct
      do while (ist <= iend)

        if (okstorm(ist) .and. storm(ist)%tcv_yymmdd == ymd_old .and.
     &                         storm(ist)%tcv_hhmm == hhmm_old) then

          rlat = float(storm(ist)%tcv_lat) / 10.
          rlon = float(storm(ist)%tcv_lon) / 10.
          rhdg = float(storm(ist)%tcv_stdir)
          rspd = float(storm(ist)%tcv_stspd) / 10.
 
c         ------------------------------------------
c         This first part updates the positions by simply
c         extrapolating the current motion along the current
c         heading at the current speed for 3h or 6h.  Be
c         careful with adding and subtracting these distances
c         in the different hemispheres (see the if statements).
c         Remember: In the storm message file, there are NO
c         negative signs to distinguish between hemispheres,
c         so a southern hemisphere latitude will be POSITIVE,
c         but will be distinguished by the 'S'.
          
          strmucomp = rspd * sin(dtr*rhdg)
          strmvcomp = rspd * cos(dtr*rhdg)
c
          vdistdeg = (strmvcomp * secphr * vit_hr_incr) / dtk
          if (storm(ist)%tcv_latns == 'N') then
            rnewlat = rlat + vdistdeg
          else
            rnewlat = rlat - vdistdeg
          endif
c
          avglat = 0.5 * (rlat + rnewlat)
          cosfac = cos(dtr * avglat)
          udistdeg = (strmucomp * secphr * vit_hr_incr) / (dtk * cosfac)
          if (storm(ist)%tcv_lonew == 'W') then
            rnewlon = rlon - udistdeg
          else
            rnewlon = rlon + udistdeg
          endif
 
c         ------------------------------------------
c         This part updates the E/W and N/S characters
c         in the event that a storm changes hemisphere.
c         (N to S and S to N is not really possible, but
c         we'll include the code anyway).  If a storm
c         does change hemisphere, say from W to E at 180,
c         we need to also adjust the new longitude value
c         from say 186W to 174E.  Have to include this
c         code since storm messages contain longitudes on
c         a 0-180 basis (E&W), NOT 0-360.
 
          if (storm(ist)%tcv_latns == 'N') then
            if (rnewlat < 0.) then
              storm(ist)%tcv_latns = 'S'
              rnewlat   = -1. * rnewlat
            endif
          else
            if (rnewlat < 0.) then
              storm(ist)%tcv_latns = 'N'
              rnewlat   = -1. * rnewlat
            endif
          endif
c
          if (storm(ist)%tcv_lonew == 'W') then
            if (rnewlon > 180.) then
              storm(ist)%tcv_lonew = 'E'
              rnewlon = 180. -  abs(rnewlon - 180.)
            endif
          else
            if (rnewlon > 180.) then
              storm(ist)%tcv_lonew = 'W'
              rnewlon = 180. - abs(rnewlon - 180.)
            endif
          endif

          storm(ist)%tcv_lat = int ((rnewlat + 0.05) * 10.)
          storm(ist)%tcv_lon = int ((rnewlon + 0.05) * 10.)
          storm(ist)%tcv_yymmdd = ymd_now
          storm(ist)%tcv_hhmm   = hhmm_now

        endif

        ist = ist + 1
   
      enddo
c
      return
      end

c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine update_future_vits (storm,iprevct,ifuturect,okstorm
     &                              ,vit_hr_incr)
c
c     ABSTRACT: This subroutine updates the vitals from 3h or 6h ahead.
c     It uses the heading and direction values listed in the vitals
c     record (see Module def_vitals for specfics on where to find 
c     heading & direction in the vitals record) to get a new
c     position for the current time by extrapolating *BACKWARDS*
c     3h or 6h to the current time.
c
      USE def_vitals; USE set_max_parms; USE inparms; USE date_checks
      USE trig_vals
c
      type (tcvcard) storm(maxstorm)
      type (datecard) dnow, dold, dfuture

      logical  okstorm(maxstorm)
      integer  vit_hr_incr
c
      ist  = iprevct + 1
      iend = iprevct + ifuturect
      do while (ist <= iend)

        if (okstorm(ist) .and. storm(ist)%tcv_yymmdd == ymd_future .and.
     &                         storm(ist)%tcv_hhmm == hhmm_future) then

          rlat = float(storm(ist)%tcv_lat) / 10.
          rlon = float(storm(ist)%tcv_lon) / 10.
          rhdg = float(storm(ist)%tcv_stdir)
          rspd = float(storm(ist)%tcv_stspd) / 10.

c         IMPORTANT NOTE: Since we are extrapolating *BACKWARDS* in 
c         time in this routine, we have to take that value of the 
c         storm heading in rhdg and switch it by 180 degrees so that
c         we will be pointing back in the direction the storm came
c         from....

          if (rhdg >= 0. .and. rhdg <= 180.) then
            rhdg = rhdg + 180.
          else 
            rhdg = rhdg - 180.
          endif
 
c         ------------------------------------------
c         This first part updates the positions by simply
c         extrapolating the current motion along the REVERSE of
c         the current heading at the current speed for 6 hours. 
c         Be careful with adding and subtracting these distances
c         in the different hemispheres (see the if statements).
c         Remember: In the storm message file, there are NO
c         negative signs to distinguish between hemispheres,
c         so a southern hemisphere latitude will be POSITIVE,
c         but will be distinguished by the 'S'.
          
          strmucomp = rspd * sin(dtr*rhdg)
          strmvcomp = rspd * cos(dtr*rhdg)
c
          vdistdeg = (strmvcomp * secphr * vit_hr_incr) / dtk
          if (storm(ist)%tcv_latns == 'N') then
            rnewlat = rlat + vdistdeg
          else
            rnewlat = rlat - vdistdeg
          endif
c
          avglat = 0.5 * (rlat + rnewlat)
          cosfac = cos(dtr * avglat)
          udistdeg = (strmucomp * secphr * vit_hr_incr) / (dtk * cosfac)
          if (storm(ist)%tcv_lonew == 'W') then
            rnewlon = rlon - udistdeg
          else
            rnewlon = rlon + udistdeg
          endif
 
c         ------------------------------------------
c         This part updates the E/W and N/S characters
c         in the event that a storm changes hemisphere.
c         (N to S and S to N is not really possible, but
c         we'll include the code anyway).  If a storm
c         does change hemisphere, say from W to E at 180,
c         we need to also adjust the new longitude value
c         from say 186W to 174E.  Have to include this
c         code since storm messages contain longitudes on
c         a 0-180 basis (E&W), NOT 0-360.
 
          if (storm(ist)%tcv_latns == 'N') then
            if (rnewlat < 0.) then
              storm(ist)%tcv_latns = 'S'
              rnewlat   = -1. * rnewlat
            endif
          else
            if (rnewlat < 0.) then
              storm(ist)%tcv_latns = 'N'
              rnewlat   = -1. * rnewlat
            endif
          endif
c
          if (storm(ist)%tcv_lonew == 'W') then
            if (rnewlon > 180.) then
              storm(ist)%tcv_lonew = 'E'
              rnewlon = 180. -  abs(rnewlon - 180.)
            endif
          else
            if (rnewlon > 180.) then
              storm(ist)%tcv_lonew = 'W'
              rnewlon = 180. - abs(rnewlon - 180.)
            endif
          endif

          storm(ist)%tcv_lat = int ((rnewlat + 0.05) * 10.)
          storm(ist)%tcv_lon = int ((rnewlon + 0.05) * 10.)
          storm(ist)%tcv_yymmdd = ymd_now
          storm(ist)%tcv_hhmm   = hhmm_now

        endif

        ist = ist + 1
   
      enddo
c
      return
      end

c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine delete_old_dups (storm,inowct,ioldct,okstorm)
c
c     ABSTRACT: The purpose of this subroutine is to loop through the
c     list of storms for the dtg from 3h or 6h ago to eliminate any 
c     duplicates.  Be sure to sort based on storm identifier (e.g.,
c     13L) instead of storm name, since the name may change (e.g., 
c     from "THIRTEEN" to "IRIS") for an upgrade in intensity, but the
c     storm number identifier will remain the same.
c
c     ict     Total number of storm card entries for this dtg
c
      USE def_vitals; USE set_max_parms
c 
      type (tcvcard) storm(maxstorm)
      logical okstorm(maxstorm)
      character found_dup*1
c
      ist  = inowct + 1
      iend = inowct + ioldct
      do while (ist < iend)

        isortnum  = ist + 1
        found_dup = 'n'
        if (okstorm(ist)) then

          do while (isortnum <= iend .and. found_dup == 'n')

            if (storm(ist)%tcv_storm_id == storm(isortnum)%tcv_storm_id)
     &      then
              found_dup = 'y'
            endif
            isortnum = isortnum + 1

          enddo

        endif

        if (found_dup == 'y') then
          okstorm(ist) = .FALSE.
        endif

        ist = ist + 1

      enddo

c     NOTE: The last member of the array to be checked is okay,
c     since all potential duplicates for this record were eliminated
c     in the previous sort while loop just completed, and, further,
c     the last member of this array is either already FALSE (from 
c     being checked off in delete_old), or it's TRUE because it
c     didn't get checked off in delete_old, so keep it.

      return
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine delete_old (storm,inowct,ioldct,okstorm)
c
c     ABSTRACT: This subroutine compares the list of storm card entries
c     from 3h or 6h ago to those from the current time to eliminate
c     any matching storms (i.e., if we've got a current record for a 
c     storm, we obviously don't need the old one).
c
      USE def_vitals; USE set_max_parms
c
      type (tcvcard) storm(maxstorm)
c
      logical   okstorm(maxstorm)
      character found_dup*1 
c
      ist  = inowct + 1
      iend = inowct + ioldct
      do while (ist <= iend)

        isortnum = 1
        found_dup = 'n'
        do while (isortnum <= inowct .and. found_dup == 'n')

          if (storm(ist)%tcv_storm_id == storm(isortnum)%tcv_storm_id)
     &    then
            found_dup = 'y'
          endif
          isortnum = isortnum + 1

        enddo      

        if (found_dup == 'y') then
          okstorm(ist) = .FALSE.
        endif

        ist = ist + 1

      enddo

      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine delete_future (storm,iprevct,ifuturect,okstorm)
c
c     ABSTRACT: This subroutine compares the list of storm card entries
c     from 3h or 6h ahead to those from the current time and from 3h or
c     6h ago to eliminate any matching storms (i.e., we only need the
c     record for the future time if we don't have either a current time
c     record or an old record that we've updated).
c
      USE def_vitals; USE set_max_parms
c
      type (tcvcard) storm(maxstorm)
c
      logical   okstorm(maxstorm)
      character found_dup*1
c
      ist  = iprevct + 1
      iend = iprevct + ifuturect
      do while (ist <= iend)

        isortnum = 1
        found_dup = 'n'
        do while (isortnum <= iprevct .and. found_dup == 'n')

          if (storm(ist)%tcv_storm_id == storm(isortnum)%tcv_storm_id)
     &    then
            found_dup = 'y'
          endif
          isortnum = isortnum + 1

        enddo

        if (found_dup == 'y') then
          okstorm(ist) = .FALSE.
        endif

        ist = ist + 1

      enddo

      return
      end

c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine delete_future_dups (storm,iprevct,ifuturect,okstorm)
c
c     ABSTRACT: The purpose of this subroutine is to loop through the
c     list of storms for the dtg from 3h or 6h ahead to eliminate any
c     duplicates.  Be sure to sort based on storm identifier (e.g.,
c     13L) instead of storm name, since the name may change (e.g.,
c     from "THIRTEEN" to "IRIS") for an upgrade in intensity, but the
c     storm number identifier will remain the same.
c
c     ict     Total number of storm card entries for this dtg
c
      USE def_vitals; USE set_max_parms
c
      type (tcvcard) storm(maxstorm)
      logical okstorm(maxstorm)
      character found_dup*1
c
      ist  = iprevct + 1
      iend = iprevct + ifuturect
      do while (ist < iend)

        isortnum  = ist + 1
        found_dup = 'n'
        if (okstorm(ist)) then

          do while (isortnum <= iend .and. found_dup == 'n')

            if (storm(ist)%tcv_storm_id == storm(isortnum)%tcv_storm_id)
     &      then
              found_dup = 'y'
            endif
            isortnum = isortnum + 1

          enddo

        endif

        if (found_dup == 'y') then
          okstorm(ist) = .FALSE.
        endif

        ist = ist + 1

      enddo

c     NOTE: The last member of the array to be checked is okay,
c     since all potential duplicates for this record were eliminated
c     in the previous sort while loop just completed, and, further,
c     the last member of this array is either already FALSE (from
c     being checked off in delete_future), or it's TRUE because it
c     didn't get checked off in delete_future, so keep it.

      return
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine delete_dups (storm,ict,okstorm)
c
c     ABSTRACT: The purpose of this subroutine is to loop through the
c     list of storms for the current dtg to eliminate any duplicates.
c     Be sure to sort based on storm identifier (e.g.,13L) instead of
c     storm name, since the name may change (e.g., from "THIRTEEN" to
c     "IRIS") for an upgrade in intensity, but the storm number 
c     identifier will remain the same.
c
c     ict     Total number of storm card entries for this dtg
c
      USE def_vitals; USE set_max_parms
c  
      type (tcvcard) storm(maxstorm)
      logical okstorm(maxstorm)
      character found_dup*1
c
      ist = 1
      do while (ist < ict)

        isortnum  = ist + 1
        found_dup = 'n'
        do while (isortnum <= ict .and. found_dup == 'n')

          if (storm(ist)%tcv_storm_id == storm(isortnum)%tcv_storm_id)
     &    then
            found_dup = 'y'
          endif
          isortnum = isortnum + 1

        enddo

        if (found_dup == 'y') then
          okstorm(ist) = .FALSE.
        endif

        ist = ist + 1

      enddo

c     Now set the last member of the array to be checked as okay, 
c     since all potential duplicates for this record were eliminated 
c     in the previous sort while loop just completed.

      okstorm(ict) = .TRUE.
c
      return
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_nlists (dnow,dold,dfuture,vit_hr_incr)
c
c     ABSTRACT:  Read in the namelists that contain the date for the
c     current time, the time from 3h or 6h ago, and the time from 3h
c     or 6h ahead .  It also converts the input dates for the current 
c     time, the old time and the future time into a format that can 
c     be easily compared against the dates in the TC Vitals file.
c
      USE inparms; USE date_checks
c
      type (datecard) dnow,dold,dfuture
c
      integer   vit_hr_incr
c
      namelist/datenowin/dnow
      namelist/dateoldin/dold
      namelist/datefuturein/dfuture
      namelist/hourinfo/vit_hr_incr
c
      read (5,NML=datenowin,END=801)
  801 continue
      read (5,NML=dateoldin,END=803)
  803 continue
      read (5,NML=datefuturein,END=805)
  805 continue
      read (5,NML=hourinfo,END=807)
  807 continue
c
      ymd_now     = dnow%yy * 10000 + dnow%mm * 100 + dnow%dd
      hhmm_now    = dnow%hh * 100
      ymd_old     = dold%yy * 10000 + dold%mm * 100 + dold%dd
      hhmm_old    = dold%hh * 100
      ymd_future  = dfuture%yy * 10000 + dfuture%mm * 100 + dfuture%dd
      hhmm_future = dfuture%hh * 100
c
      return
      end
c
c----------------------------------------------------------------------
c
c----------------------------------------------------------------------
      integer function char2int (charnum)
c
c     This function takes as input a character numeral and
c     returns the integer equivalent
c
      character*1 charnum,cx(10)
      data cx/'0','1','2','3','4','5','6','7','8','9'/
c
      do i=1,10
        if (charnum.eq.cx(i)) char2int = i-1
      enddo
c
      return
      end
c
c----------------------------------------------------------------------
c
c----------------------------------------------------------------------
      character function int2char (inum)
c
c     This function takes as input an integer and
c     returns the character numeral equivalent
c
      character*1 cx(10)
      data cx/'0','1','2','3','4','5','6','7','8','9'/
c
      do i=1,10
        ihold=i-1
        if (ihold.eq.inum) int2char = cx(i)
      enddo
c
      return
      end

      program vint
c
c     ABSTRACT: This program interpolates from various pressure levels
c     onto regularly-spaced, 50-mb vertical levels.  The intent is that
c     we can use data with relatively coarse vertical resolution to 
c     get data on the necessary 50-mb intervals that we need for Bob 
c     Hart's cyclone phase space.  For each model, we will need to read
c     in a control file that contains the levels that we are 
c     interpolating from.
c
c     Written by Tim Marchok

      implicit none

      integer, parameter :: lugb=11,lulv=16,lugi=31,lout=51,maxlev=200
      integer  kpds(200),kgds(200)
      integer  nlevsin,iriret,iogret,kf,iggret,igdret,iidret,ixo,k
      integer  iha,iho,iva,irfa,iodret,ifcsthour,iia,iparm,nlevsout
      integer  ilevs(maxlev)
      real, allocatable :: xinpdat(:,:),xoutdat(:,:),xoutlevs_p(:)
      logical(1), allocatable :: valid_pt(:),readflag(:)

      namelist/timein/ifcsthour,iparm
c
      read (5,NML=timein,END=201)
  201 continue
      print *,' '
      print *,'*----------------------------------------------------*'
      print *,' '
      print *,' +++ Top of vint +++'
      print *,' '
      print *,'After namelist read, input forecast hour = ',ifcsthour
      print *,'                         input grib parm = ',iparm

      if (iparm == 7 .or. iparm == 156) then
        nlevsout = 13  ! dealing with height
      else
        nlevsout =  5  ! dealing with temperature
      endif

      allocate (xoutlevs_p(nlevsout),stat=ixo)
      if (ixo /= 0) then
        print *,' '
        print *,'!!! ERROR in vint allocating the xoutlevs_p array.'
        print *,'!!! ixo= ',ixo
        print *,' '
        goto 899
      endif

      do k = 1,nlevsout
        xoutlevs_p(k) = 300. + float((k-1)*50)
      enddo

      ilevs = -999
      call read_input_levels (lulv,maxlev,nlevsin,ilevs,iriret)

      if (iriret /= 0) then
        print *,' '
        print *,'!!! ERROR in vint. '
        print *,'!!! RETURN CODE FROM read_input_levels /= 0'
        print *,'!!! RETURN CODE = iriret = ',iriret
        print *,'!!! EXITING....'
        print *,' '
        goto 899
      endif

      call open_grib_files (lugb,lugi,lout,iogret)

      if (iogret /= 0) then
        print '(/,a45,i4,/)','!!! ERROR: in vint open_grib_files, rc= '
     &        ,iogret
        STOP 93
      endif

      call getgridinfo (lugb,lugi,kf,kpds,kgds,ifcsthour,iparm,iggret)

      allocate (xinpdat(kf,nlevsin),stat=iha)
      allocate (xoutdat(kf,nlevsout),stat=iho)
      allocate (valid_pt(kf),stat=iva)
      allocate (readflag(nlevsin),stat=irfa)
      if (iha /= 0 .or. iho /= 0 .or. iva /= 0 .or. irfa /= 0) then
        print *,' '
        print *,'!!! ERROR in vint.'
        print *,'!!! ERROR allocating the xinpdat, readflag, or the'
        print *,'!!! valid_pt array, iha= ',iha,' iva= ',iva
        print *,'!!! irfa= ',irfa,' iho= ',iho
        print *,' '
        STOP 96
      endif

      call getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs,maxlev
     &             ,readflag,xinpdat,ifcsthour,iparm,igdret)

      call interp_data (kf,valid_pt,nlevsin,ilevs,maxlev,readflag
     &                 ,xinpdat,xoutdat,xoutlevs_p,nlevsout,iidret)

      call output_data (lout,kf,kpds,kgds,xoutdat,valid_pt
     &                ,xoutlevs_p,nlevsout,iodret)

      deallocate (xinpdat)
      deallocate (xoutdat)
      deallocate (valid_pt)
      deallocate (readflag)
      deallocate (xoutlevs_p)

  899 continue
c 
      stop
      end
c
c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine read_input_levels (lulv,maxlev,nlevsin,ilevs,iriret)
c 
c     ABSTRACT: This subroutine reads in a text file that contains
c     the number of input pressure levels for a given model.  The
c     format of the file goes like this, from upper levels to 
c     lower, for example:
c
c        1       200
c        2       400
c        3       500
c        4       700
c        5       850
c        6       925
c        7      1000
c
c
      implicit none

      integer    lulv,nlevsin,maxlev,iriret,inplev,ict,lvix
      integer    ilevs(maxlev)
c
      ict = 0
      do while (.true.)
        
        print *,'Top of while loop in vint read_input_levels'

        read (lulv,85,end=130) lvix,inplev

        if (inplev > 0 .and. inplev <= 1000) then
          ict = ict + 1
          ilevs(ict) = inplev
        else
          print *,' '
          print *,'!!! ERROR: Input level not between 0 and 1000'
          print *,'!!!        in vint.  inplev= ',inplev
          print *,'!!! STOPPING EXECUTION'
          STOP 91
        endif

        print *,'vint readloop, ict= ',ict,' inplev= ',inplev

      enddo

   85 format (i4,1x,i4)
  130 continue

      nlevsin = ict

      print *,' '
      print *,'Total number of vint levels read in = ',nlevsin
c 
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getgridinfo (lugb,lugi,kf,kpds,kgds,ifcsthour,iparm
     &                       ,iggret)
c
c     ABSTRACT: The purpose of this subroutine is just to get the max
c     values of i and j and the dx and dy grid spacing intervals for the
c     grid to be used in the rest of the program.  So just read the
c     grib file to get the lon and lat data.  Also, get the info for
c     the data grid's boundaries.  This boundary information will be
c     used later in the tracking algorithm, and is accessed via Module
c     grid_bounds.
c
      implicit none
c
      logical(1), allocatable :: lb(:)
      integer, parameter :: jf=4000000
      integer   jpds(200),jgds(200)
      integer   kpds(200),kgds(200)
      integer   ila,ifa,iret,ifcsthour,imax,jmax
      integer   lugb,lugi,kf,j,k,iggret,iparm
      real, allocatable :: f(:)
      real      dx,dy
c
      iggret = 0

      allocate (lb(jf),stat=ila) 
      allocate (f(jf),stat=ifa)
      if (ila /= 0 .or. ifa /= 0) then
        print *,' '
        print *,'!!! ERROR in vint.'
        print *,'!!! ERROR in getgridinfo allocating either lb or f'
        print *,'!!! ila = ',ila,' ifa= ',ifa
        iggret = 97
        return
      endif

      jpds = -1
      jgds = -1

      j=0

      jpds(5)  = iparm ! Get a record for the input parm selected
      jpds(6)  = 100   ! Get a record on a standard pressure level
      jpds(14) = ifcsthour
         
      call getgb(lugb,lugi,jf,j,jpds,jgds,
     &                     kf,k,kpds,kgds,lb,f,iret)
      
      if (iret.ne.0) then
        print *,' '
        print *,'!!! ERROR in vint getgridinfo calling getgb'
        print *,'!!! Return code from getgb = iret = ',iret
        iggret = iret
        return
      else
        iggret=0
        imax = kgds(2)
        jmax = kgds(3)
        dx   = float(kgds(9))/1000.
        dy   = float(kgds(10))/1000.
      endif
      
      print *,' '
      print *,'In vint getgridinfo, grid dimensions follow:'
      print *,'imax= ',imax,' jmax= ',jmax
      print *,'  dx= ',dx,'  dy= ',dy
      print *,'number of gridpoints = ',kf
      
      deallocate (lb); deallocate(f)
      
      return
      end

c---------------------------------------------------------------------
c
c---------------------------------------------------------------------
      subroutine getdata (lugb,lugi,kf,valid_pt,nlevsin,ilevs,maxlev
     &             ,readflag,xinpdat,ifcsthour,iparm,igdret)
c
c     ABSTRACT: This subroutine reads the input GRIB file for the
c     tracked parameters.

      implicit none
c
      logical(1)  valid_pt(kf),lb(kf),readflag(nlevsin)
      integer, parameter :: jf=4000000
      integer   ilevs(maxlev)
      integer   jpds(200),jgds(200),kpds(200),kgds(200)
      integer   lugb,lugi,kf,nlevsin,maxlev,igdret
      integer   i,j,k,ict,np,lev,ifcsthour,iret,iparm
      real      f(kf),xinpdat(kf,nlevsin)
      real      dmin,dmax
c
      ict = 0

      level_loop: do lev = 1,nlevsin

        print *,' '
        print *,'In vint getdata read loop, lev= ',lev,' level= '
     &         ,ilevs(lev)

        jpds = -1
        jgds = -1
        j=0

        jpds(5) = iparm       ! grib parameter id to read in
        jpds(6) = 100         ! level id to indicate a pressure level
        jpds(7) = ilevs(lev)  ! actual level of the layer
        jpds(14) = ifcsthour  ! lead time to search for

        call getgb (lugb,lugi,jf,j,jpds,jgds,
     &                        kf,k,kpds,kgds,lb,f,iret)

        print *,' '
        print *,'After vint getgb call, j= ',j,' k= ',k,' level= '
     &         ,ilevs(lev),' iret= ',iret

        if (iret == 0) then

          readflag(lev) = .TRUE.
          call bitmapchk(kf,lb,f,dmin,dmax)

          if (ict == 0) then
            do np = 1,kf
              valid_pt(np) = lb(np)
            enddo
            ict = ict + 1
          endif

          write (6,31)
  31      format (' rec#  parm# levt lev  byy   bmm  bdd  bhh  fhr   np'
     &           ,'ts  minval       maxval')
          print '(i4,2x,8i5,i8,2g12.4)',
     &         k,(kpds(i),i=5,11),kpds(14),kf,dmin,dmax

          do np = 1,kf
            xinpdat(np,lev) = f(np) 
          enddo

        else

          print *,' '
          print *,'!!! ERROR: VINT READ FAILED FOR LEVEL LEV= ',LEV
          print *,' '

          readflag(lev) = .FALSE.

          do np = 1,kf
            xinpdat(np,lev) = -99999.0
          enddo

        endif

      enddo level_loop
c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine interp_data (kf,valid_pt,nlevsin,ilevs,maxlev,readflag
     &                 ,xinpdat,xoutdat,xoutlevs_p,nlevsout,iidret)
c
c     ABSTRACT: This routine interpolates data in between available
c     pressure levels to get data resolution at the 50-mb
c     resolution that we need for the cyclone phase space
c     diagnostics.

      implicit none

      logical(1)   valid_pt(kf),readflag(nlevsin)
      integer      ilevs(maxlev)
      integer      nlevsin,nlevsout,maxlev,kf,kout,kin,k,n,kup,klo
      integer      iidret
      real         xinpdat(kf,nlevsin),xoutdat(kf,nlevsout)
      real         xoutlevs_p(nlevsout),xoutlevs_lnp(nlevsout)
      real         xinlevs_p(nlevsin),xinlevs_lnp(nlevsin)
      real         pdiff,pdiffmin,xu,xo,xl,yu,yl
c
      print *,' '
      print *,'*----------------------------------------------*'
      print *,' Listing of standard output levels follows....'
      print *,'*----------------------------------------------*'
      print *,' '

      do k = 1,nlevsout
        xoutlevs_lnp(k) = log(xoutlevs_p(k))
        write (6,81) k,xoutlevs_p(k),xoutlevs_lnp(k)
      enddo
   81 format (1x,'k= ',i3,'    p= ',f6.1,'   ln(p)= ',f9.6)

      do k = 1,nlevsin
        xinlevs_p(k) = float(ilevs(k))
        xinlevs_lnp(k) = log(xinlevs_p(k))
      enddo

c     -----------------------------------------------------------------
c     We want to loop through for all the *output* levels that we need.
c     We may have some input levels that match perfectly, often at 
c     least the standard levels like 500, 700, 850.  For these levels, 
c     just take the data directly from the input file.  For other 
c     output levels that fall between the input levels, we need to 
c     find the nearest upper and lower levels.

      output_loop: do kout = 1,nlevsout

        print *,' '
        print *,'+------------------------------------------------+'
        print *,'Top of vint output_loop, kout= ',kout,'  pressure= '
     &         ,xoutlevs_p(kout)
        
        ! Loop through all of the input levels and find the level 
        ! that is closest to the  output level from the *upper* side.
        ! And again, in this upper loop, if we hit a level that 
        ! exactly matches a needed output level, just copy that data
        ! and then cycle back to the top of output_loop.

        kup = -999
        klo = -999

        pdiffmin = 9999.0

        inp_loop_up: do kin = 1,nlevsin
          if (xinlevs_p(kin) == xoutlevs_p(kout)) then
            print *,' '
            print *,'+++ Exact level found.  kout= ',kout
            print *,'+++                    level= ',xoutlevs_p(kout)
            print *,'+++ Data copied.  No interpolation needed.'
            if (readflag(kin)) then
              do n = 1,kf
                xoutdat(n,kout) = xinpdat(n,kin)
              enddo
              cycle  output_loop
            else
              print *,' '
              print *,'!!! ERROR: readflag is FALSE in interp_data for'
              print *,'!!! level kin= ',kin,', which is a level that '
              print *,'!!! exactly matches a required output level, and'
              print *,'!!! the user has identified as being an input '
              print *,'!!! level with valid data for this model.  We '
              print *,'!!! will get the data from a different level.'
            endif
          else
            pdiff = xoutlevs_p(kout) - xinlevs_p(kin)
            if (pdiff > 0.) then  ! We have a level higher than outlev
              if (pdiff < pdiffmin) then
                pdiffmin = pdiff
                kup = kin
              endif
            endif
          endif
        enddo inp_loop_up

        pdiffmin = 9999.0

        inp_loop_lo: do kin = 1,nlevsin
          pdiff = xinlevs_p(kin) - xoutlevs_p(kout)
          if (pdiff > 0.) then  ! We have a level lower than outlev
            if (pdiff < pdiffmin) then
              pdiffmin = pdiff
              klo = kin
            endif
          endif 
        enddo inp_loop_lo

        if (kup == -999 .or. klo == -999) then
          print *,' '
          print *,'!!! ERROR: While interpolating, could not find '
          print *,'!!! either an upper or lower input level to use'
          print *,'!!! for interpolating *from*.'
          print *,'!!! kup= ',kup,' klo= ',klo
          print *,' '
          print *,'!!! STOPPING....'
          stop 91
        endif

        if (.not. readflag(kup) .or. .not. readflag(klo)) then
          print *,' '
          print *,'!!! ERROR: In interp_data, either the upper or the'
          print *,'!!! lower input level closest to the target output'
          print *,'!!! level did not have valid data read in.'
          print *,'!!! '
          write (6,91) '  upper level k= ',kup,xinlevs_p(kup)
     &                ,xinlevs_lnp(kup)
          write (6,101) xoutlevs_p(kout),xoutlevs_lnp(kout)
          write (6,91) '  lower level k= ',klo,xinlevs_p(klo)
     &                ,xinlevs_lnp(klo)
          print *,'!!! readflag upper = ',readflag(kup)
          print *,'!!! readflag lower = ',readflag(klo)
          print *,'!!! EXITING....'
          stop 92
        endif

        print *,' '
        write (6,91) '  upper level k= ',kup,xinlevs_p(kup)
     &              ,xinlevs_lnp(kup)
        write (6,101) xoutlevs_p(kout),xoutlevs_lnp(kout)
        write (6,91) '  lower level k= ',klo,xinlevs_p(klo)
     &              ,xinlevs_lnp(klo)

   91   format (1x,a17,1x,i3,'  pressure= ',f6.1,' ln(p)= ',f9.6)
  101   format (13x,'Target output pressure= ',f6.1,' ln(p)= ',f9.6)

        !--------------------------------------------------------------
        ! Now perform the linear interpolation.  Here is the notation 
        ! used in the interpolation:
        ! 
        !  xu = ln of pressure at upper level
        !  xo = ln of pressure at output level
        !  xl = ln of pressure at lower level
        !  yu = data value at upper level
        !  yl = data value at lower level
        !--------------------------------------------------------------

        xu = xinlevs_lnp(kup)
        xo = xoutlevs_lnp(kout)
        xl = xinlevs_lnp(klo)

        do n = 1,kf
          yu = xinpdat(n,kup)
          yl = xinpdat(n,klo)
          xoutdat(n,kout) = ((yl * (xo - xu)) - (yu * (xo - xl))) 
     &                    / (xl - xu)
        enddo

      enddo output_loop
c
      return
      end
c
c----------------------------------------------------------------------
c
c----------------------------------------------------------------------
      subroutine output_data (lout,kf,kpds,kgds,xoutdat,valid_pt
     &                      ,xoutlevs_p,nlevsout,iodret)
c
c     ABSTRACT: This routine writes out the  output data on the 
c     specified output pressure levels.

      implicit none

      logical(1) valid_pt(kf)
      integer  lout,kf,lugb,lugi,iodret,nlevsout,igoret,ipret,lev
      integer  kpds(200),kgds(200)
      real     xoutdat(kf,nlevsout),xoutlevs_p(nlevsout)
c
c      call baopenw (lout,"fort.51",igoret)
c      print *,'baopenw: igoret= ',igoret
c
c      if (igoret /= 0) then
c        print *,' '
c        print *,'!!! ERROR in vint in sub output_data opening'
c        print *,'!!! **OUTPUT** grib file.  baopenw return codes:'
c        print *,'!!! grib file 1 return code = igoret = ',igoret
c        STOP 95
c        return
c      endif

c      kpds(7)  =     850  ;    kpds(8)  =      02
c      kpds(9)  =      11  ;    kpds(10) =       4
c      kpds(11) =       0  ;    kpds(12) =       0
c      kpds(13) =       1  ;    kpds(14) =  ifcsthour
c      kpds(15) =       0  ;    kpds(16) =      10
c      kpds(17) =       0  ;    kpds(18) =       1
c      kpds(19) =       2  ;    kpds(20) =       0
c      kpds(21) =      21  ;    kpds(22) =       0
c      kpds(23) =       0  ;    kpds(24) =       0
c      kpds(25) =       0
c      kgds(1)  =       0  ;    kgds(2)  =    imax
c      kgds(3)  =    jmax  ;    kgds(4)  =   90000
c      kgds(5)  =       0  ;    kgds(6)  =     128
c      kgds(7)  =  -90000  ;    kgds(8)  =   -1000
c      kgds(9)  =    1000  ;    kgds(10) =    1000
c      kgds(11) =       0  ;    kgds(12) =       0
c      kgds(13) =       0  ;    kgds(14) =       0
c      kgds(15) =       0  ;    kgds(16) =       0
c      kgds(17) =       0  ;    kgds(18) =       0
c      kgds(19) =       0  ;    kgds(20) =     255

      do lev = 1,nlevsout 

        kpds(7) = int(xoutlevs_p(lev))

        print *,'In vint, just before call to putgb, kf= ',kf
        call putgb (lout,kf,kpds,kgds,valid_pt,xoutdat(1,lev),ipret)
        print *,'In vint, just after call to putgb, kf= ',kf
        if (ipret == 0) then
          print *,' '
          print *,'+++ IPRET = 0 after call to putgb in vint'
          print *,' '
        else
          print *,' '
          print *,'!!!!!! ERROR in vint.'
          print *,'!!!!!! ERROR: IPRET NE 0 AFTER CALL TO PUTGB !!!'
          print *,'!!!!!!        Level index= ',lev
          print *,'!!!!!!           pressure= ',xoutlevs_p(lev)
          print *,' '
        endif

        write(*,980) kpds(1),kpds(2)
        write(*,981) kpds(3),kpds(4)
        write(*,982) kpds(5),kpds(6)
        write(*,983) kpds(7),kpds(8)
        write(*,984) kpds(9),kpds(10)
        write(*,985) kpds(11),kpds(12)
        write(*,986) kpds(13),kpds(14)
        write(*,987) kpds(15),kpds(16)
        write(*,988) kpds(17),kpds(18)
        write(*,989) kpds(19),kpds(20)
        write(*,990) kpds(21),kpds(22)
        write(*,991) kpds(23),kpds(24)
        write(*,992) kpds(25)
        write(*,880) kgds(1),kgds(2)
        write(*,881) kgds(3),kgds(4)
        write(*,882) kgds(5),kgds(6)
        write(*,883) kgds(7),kgds(8)
        write(*,884) kgds(9),kgds(10)
        write(*,885) kgds(11),kgds(12)
        write(*,886) kgds(13),kgds(14)
        write(*,887) kgds(15),kgds(16)
        write(*,888) kgds(17),kgds(18)
        write(*,889) kgds(19),kgds(20)
        write(*,890) kgds(21),kgds(22)

      enddo

  980 format('    kpds(1)  = ',i7,'  kpds(2)  = ',i7)
  981 format('    kpds(3)  = ',i7,'  kpds(4)  = ',i7)
  982 format('    kpds(5)  = ',i7,'  kpds(6)  = ',i7)
  983 format('    kpds(7)  = ',i7,'  kpds(8)  = ',i7)
  984 format('    kpds(9)  = ',i7,'  kpds(10) = ',i7)
  985 format('    kpds(11) = ',i7,'  kpds(12) = ',i7)
  986 format('    kpds(13) = ',i7,'  kpds(14) = ',i7)
  987 format('    kpds(15) = ',i7,'  kpds(16) = ',i7)
  988 format('    kpds(17) = ',i7,'  kpds(18) = ',i7)
  989 format('    kpds(19) = ',i7,'  kpds(20) = ',i7)
  990 format('    kpds(21) = ',i7,'  kpds(22) = ',i7)
  991 format('    kpds(23) = ',i7,'  kpds(24) = ',i7)
  992 format('    kpds(25) = ',i7)
  880 format('    kgds(1)  = ',i7,'  kgds(2)  = ',i7)
  881 format('    kgds(3)  = ',i7,'  kgds(4)  = ',i7)
  882 format('    kgds(5)  = ',i7,'  kgds(6)  = ',i7)
  883 format('    kgds(7)  = ',i7,'  kgds(8)  = ',i7)
  884 format('    kgds(9)  = ',i7,'  kgds(10) = ',i7)
  885 format('    kgds(11) = ',i7,'  kgds(12) = ',i7)
  886 format('    kgds(13) = ',i7,'  kgds(14) = ',i7)
  887 format('    kgds(15) = ',i7,'  kgds(16) = ',i7)
  888 format('    kgds(17) = ',i7,'  kgds(18) = ',i7)
  889 format('    kgds(19) = ',i7,'  kgds(20) = ',i7)
  890 format('    kgds(20) = ',i7,'  kgds(22) = ',i7)

c
      return
      end
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
      subroutine open_grib_files (lugb,lugi,lout,iret)

C     ABSTRACT: This subroutine must be called before any attempt is
C     made to read from the input GRIB files.  The GRIB and index files
C     are opened with a call to baopenr.  This call to baopenr was not
C     needed in the cray version of this program (the files could be
C     opened with a simple Cray assign statement), but the GRIB-reading
C     utilities on the SP do require calls to this subroutine (it has
C     something to do with the GRIB I/O being done in C on the SP, and
C     the C I/O package needs an explicit open statement).
C
C     INPUT:
C     lugb     The Fortran unit number for the GRIB data file
C     lugi     The Fortran unit number for the GRIB index file
C     lout     The Fortran unit number for the  output grib file
C
C     OUTPUT:
C     iret     The return code from this subroutine

      implicit none

      character(2)   lugb_c,lugi_c,lout_c
c      character(120) fnameg,fnamei,fnameo
cPeng 05/28/2018 Bug Fixed for FV3-GFS Job Crashed
      character(255) fnameg,fnamei,fnameo
      character(6)   enameb,enamei,enameo
      integer   iret,gribver,lugb,lugi,lout,igoret,iioret,iooret

      iret=0
      write(lugb_c,'(i2)')lugb
      write(lugi_c,'(i2)')lugi
      write(lout_c,'(i2)')lout
      enameb='FORT'//adjustl(lugb_c)
      enamei='FORT'//adjustl(lugi_c)
      enameo='FORT'//adjustl(lout_c)
      call get_environment_variable(enameb, fnameg, status=igoret)
      call get_environment_variable(enamei, fnamei, status=iioret)
      call get_environment_variable(enameo, fnameo, status=iooret)
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        fnameg(1:5) = "fort."
        fnamei(1:5) = "fort."
        fnameo(1:5) = "fort."
        write(fnameg(6:7),'(I2)') lugb
        write(fnamei(6:7),'(I2)') lugi
        write(fnameo(6:7),'(I2)') lout
      endif
      call baopenr (lugb,fnameg,igoret)
      call baopenr (lugi,fnamei,iioret)
      call baopenw (lout,fnameo,iooret)

      print *,' '
      print *,'vint:  baopen: igoret= ',igoret,' iioret= ',iioret
     &       ,' iooret= ',iooret
      
      if (igoret /= 0 .or. iioret /= 0 .or. iooret /= 0) then
        print *,' '
        print *,'!!! ERROR in vint.'
        print *,'!!! ERROR in sub open_grib_files opening grib file'
        print *,'!!! or grib index file.  baopen return codes:'
        print *,'!!! grib  file return code = igoret = ',igoret
        print *,'!!! index file return code = iioret = ',iioret
        print *,'!!! output file return code = iooret = ',iooret
        iret = 93
        return
      endif

      return
      end
c
c-------------------------------------------------------------------
c
c-------------------------------------------------------------------
      subroutine bitmapchk (n,ld,d,dmin,dmax)
c
c     This subroutine checks the bitmap for non-existent data values.
c     Since the data from the regional models have been interpolated
c     from either a polar stereographic or lambert conformal grid
c     onto a lat/lon grid, there will be some gridpoints around the
c     edges of this lat/lon grid that have no data; these grid
c     points have been bitmapped out by Mark Iredell's interpolater.
c     To provide another means of checking for invalid data points
c     later in the program, set these bitmapped data values to a
c     value of -999.0.  The min and max of this array are also
c     returned if a user wants to check for reasonable values.
c
      logical(1) ld
      dimension  ld(n),d(n)
c
      dmin=1.E15
      dmax=-1.E15
c
      do i=1,n
        if (ld(i)) then
          dmin=min(dmin,d(i))
          dmax=max(dmax,d(i))
        else
          d(i) = -999.0
        endif
      enddo
c
      return
      end

C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C
C MAIN PROGRAM: PREPOBS_PREVENTS
C   PRGMMR: DONG             ORG: NP22        DATE: 2020-01-09
C
C ABSTRACT: PREPARES OBSERVATIONAL PREPBUFR FILE FOR SUBSEQUENT
C   QUALITY CONTROL AND ANALYSIS PROGRAMS.  THIS IS DONE THROUGH THE
C   FOLLOWING: INTERPOLATION OF GLOBAL SPECTRAL SIGMA OR HYBRID FIRST
C   GUESS TO PREPBUFR OBSERVATION LOCATIONS WITH ENCODING OF FIRST
C   GUESS VALUES INTO PREPBUFR REPORTS; ENCODING OF "PREVENT" AND/OR
C   "VIRTMP" EVENTS INTO PREPBUFR REPORTS; AND ENCODING OF OBSERVATION
C   ERRORS FROM THE ERROR SPECIFICATION FILE INTO PREPBUFR REPORTS.
C   FOR MORE INFORMATION ON THE DETAILS OF THE "PREVENT" AND "VIRTMP"
C   EVENTS, SEE THE DOCBLOCK FOR EITHER W3NCO ROUTINE "GBLEVENTS"
C   (WHICH CURRENTLY READS SIGMA OR HYBRID FIRST GUESS IN ALL NETWORKS
C   EXCEPT "cdas" or "cdc") OR FOR IN-LINE ROUTINE GBLEVENTS_CDAS
C   (WHICH CURRENTLY READS SIGMA GUESS IN "cdas" or "cdc" NETWORKS).
C   THIS PROGRAM CALLS GBLEVENTS OR GBLEVENTS_CDAS, WHICH RUNS HERE IN
C   THE "PREVENTS" MODE.  W3NCO ROUTINE GBLEVENTS (OR IN-LINE ROUTINE
C   GBLEVENTS_CDAS) DOES THE BULK OF THE WORK HERE.  AFTER EACH REPORT
C   IS UPDATED BY GBLEVENTS/GBLEVENTS_CDAS, IT IS WRITTEN OUT TO A
C   "PREPROCESSED" VERSION OF THE PREPBUFR FILE.  
C
C PROGRAM HISTORY LOG:
C 1994-01-06  J. WOOLLEN  ORIGINAL VERSION FOR REANALYSIS
C 1994-09-06  J. WOOLLEN  VERSION FOR IMPLEMENTATION IN GBL SYSTEM
C 1997-10-07  D.A. KEYSER -- ADDED NAMELIST SWITCH TO BYPASS VIRT.
C             TEMPERATURE EVENT FOR NON-RADIOSONDE/SATSND DATA TYPES
C             (INVOKED IN RUC VERSION - TOB NOT CHANGED FROM INPUT)
C 1997-11-24  D.A. KEYSER -- ADDED NAMELIST SWITCH "REDUCE" TO BYPASS
C             ALL PREVENTS PROCESSING (IF TRUE) FOR MESSAGE TYPES NOT
C             EQUAL TO "ADPUPA", "AIRCFT" AND "PROFLR"
C 1998-02-03  D.A. KEYSER -- CORRECTED ERROR FROM PREVIOUS CHANGE THAT
C             RESULTED IN BYPASSING THE VIRT. TEMPERATURE EVENT FOR
C             "ADPUPA" AND "SFCSHP" TYPES WHEN N-LIST SWITCH "REDUCE"
C             IS TRUE - REDUCE=TRUE WILL NOW CONTINUE TO DO ALL
C             PREVENTS PROCESSING FOR MESSAGE TYPES "ADPUPA", "AIRCFT",
C             "PROFLR" AS WELL AS NOW "ADPSFC" AND "SFCSHP"
C 1998-08-25  D.A. KEYSER -- ADDED SWITCHES 'DOBERR' AND 'DOFCST' IN
C             NAMELIST READ FROM DATA CARDS; SUBROUTINE NOW Y2K AND
C             FORTRAN 90 COMPLIANT
C 1998-09-14  J.WOOLLEN - ADDED SWITCH FOR INSTALLING ANALYSED VALUES
C 1998-09-17  D.A. KEYSER -- PROGRAM NOW CALLS EXIT PRIOR TO STOP FOR
C             NON-ZERO EXIT STATES (TRANSFERS EXIT STATE TO UNIX
C             FOREGROUND STATUS CODE)
C 1998-09-21  D. A. KEYSER -- SUBROUTINE NOW Y2K AND FORTRAN 90
C             COMPLIANT
C 1998-07-06  D. A. KEYSER -- MODIFIED TO COMPILE AND RUN ON IBM;
C             NOW CALLS NEW W3LIB ROUTINE "GBLEVENTS" TO PERFORM
C             MOST OF THE FUNCTIONS THAT THIS PROGRAM USED TO DO
C             (THIS W3LIB ROUTINE IS ALSO CALLED BY PREPDATA,
C             SYNDATA AND POSTEVENTS), ONLY THE READING IN OF
C             REPORTS IS DONE BY THIS MAIN PROGRAM NOW
C 1999-09-26  D. A. KEYSER -- CHANGES TO MAKE CODE MORE PORTABLE
C 2001-02-02  D. A. KEYSER -- MINOR HOUSKEEPING CHANGES; PICKS UP AN
C             UPDATED W3LIB ROUTINE GBLEVENTS
C 2001-10-10  D. A. KEYSER -- MODIFIED TO NOW PASS TWO SPANNING GLOBAL
C             SIGMA GUESS FILES INTO W3LIB ROUTINE GBLEVENTS IN
C             SITUATIONS WHERE THE CENTER DATE FOR THE PREPBUFR FILE
C             HAS AN HOUR THAT IS NOT A MULTIPLE OF 3 (SEE 2001-10-10
C             CHANGES TO GBLEVENTS)
C 2007-11-20  D. A. KEYSER -- CHECK NETWORK WHICH THIS CODE IS RUNNING
C             UNDER (VIA CALL TO SYSTEM ROUTINE "GETENV") - IF NETWORK
C             IS NOT "cdas" OR "cdc", CALL W3LIB ROUTINE GBLEVENTS AS
C             BEFORE, IF NETWORK IS "cdas" OR "cdc", CALL NEW IN-LINE
C             ROUTINE GBLEVENTS_CDAS WHICH IS A FROZEN VERSION OF THE
C             2006-07-14 VERSION OF GBLEVENTS NEEDED TO READ THE CDAS-
C             STYLE SIGMA FIRST GUESS (THE NEW SIGIO VERSION OF W3LIB
C             ROUTINE GBLEVENTS CANNOT READ THE OLD CDAS-STYLE SIGMA
C             FIRST GUESS)
C 2012-11-20  J. WOOLLEN   -- INITIAL PORT TO WCOSS 
C 2013-02-13  D. A. KEYSER -- FINAL CHANGES TO RUN ON WCOSS: SET
C             BUFRLIB MISSING (BMISS) TO 10E8 RATHER THAN 10E10 TO
C             AVOID INTEGER OVERFLOW;  REPLACED GETENV WITH MORE
C             STANDARD GET_ENVIRONMENT_VARIABLE; USE FORMATTED PRINT
C             STATEMENTS WHERE PREVIOUSLY UNFORMATTED PRINT WAS > 80
C             CHARACTERS
C 2020-01-06  J. Dong -- In program PREPOBS_PREVENTS, changed the
C             windowing decade from 20 to 40 for cases when the year 
C             is represented by 2 digits instead of 4.
C
C USAGE:
C   INPUT FILES:
C     UNIT 05  - STANDARD INPUT (DATA CARDS - SEE NAMELIST
C                DOCUMENTATION IN W3NCO ROUTINE GBLEVENTS OR IN-LINE
C                ROUTINE GBLEVENTS_CDAS DOCBLOCK)
C     UNIT 11  - PREPBUFR FILE
C     UNIT 12  - FIRST INPUT SPECTRAL (GLOBAL) SIGMA OR HYBRID FIRST
C                GUESS FILE; IF HOUR IN CENTER DATE FOR PREPBUFR FILE
C                IS A MULTIPLE OF 3 THEN THIS FILE IS VALID AT THE
C                CENTER DATE OF THE PREPBUFR FILE, IF THE HOUR IN
C                CENTER DATE FOR PREPBUFR FILE IS NOT A MULTIPLE OF 3
C                THEN THIS FILE IS VALID AT THE CLOSEST TIME PRIOR TO
C                THE CENTER DATE OF THE PREPBUFR FILE THAT IS A
C                MULTIPLE OF 3
C     UNIT 13  - SECOND INPUT SPECTRAL (GLOBAL) SIGMA OR HYBRID FIRST
C                GUESS FILE; IF HOUR IN CENTER DATE FOR PREPBUFR FILE
C                IS A MULTIPLE OF 3 THEN THIS FILE IS EMPTY, IF THE
C                HOUR IN CENTER DATE FOR PREPBUFR FILE IS NOT A
C                MULTIPLE OF 3 THEN THIS FILE IS VALID AT THE CLOSEST
C                TIME AFTER THE CENTER DATE OF THE PREPBUFR FILE THAT
C                IS A MULTIPLE OF 3
C     UNIT 14  - OBSERVATION ERROR FILE
C     UNIT 15  - EXPECTED CENTER DATE IN PREPBUFR FILE IN FORM
C                YYYYMMDDHH
C
C   OUTPUT FILES:
C     UNIT 06  - STANDARD OUTPUT PRINT
C     UNIT 51  - PREPBUFR FILE (NOW CONTAINING FIRST GUESS VALUES,
C              - "PREVENT" AND "VIRTMP" EVENTS, AND OBERVATIONAL ERROR
C              - VALUES)
C     UNIT 52  - "PREVENT" EVENTS DATA FILTERING SUMMARY PRINT FILE
C
C   SUBPROGRAMS CALLED:
C       UNIQUE   - GBLEVENTS_CDAS
C       W3NCO    - W3TAGB    W3TAGE    ERREXIT
C       W3EMC    - GBLEVENTS
C       BUFRLIB  - DATELEN   OPENBF    READMG    OPENMB
C                - WRITSB    CLOSBF    SETBMISS  GETBMISS
C       SYSTEM   - GET_ENVIRONMENT_VARIABLE
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C     COND =  21 - DATE DISAGREEMENT BETWEEN ACTUAL CENTER DATE IN
C                  PREPBUFR FILE AND EXPECTED CENTER DATE READ IN
C                  FROM UNIT 15
C     COND =  22 - BAD OR MISSING DATE READ IN FROM UNIT 15
C     COND =  60-79 - RESERVED FOR W3NCO ROUTINE GBLEVENTS OR IN-LINE
C                      ROUTINE GBLEVENTS_CDAS (SEE GBLEVENTS/
C                      GBLEVENTS_CDAS DOCBLOCK)
C
C
C REMARKS: NONE.
C
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE:  NCEP WCOSS
C
C$$$

      PROGRAM PREPOBS_PREVENTS

      REAL(8)   BMISS,GETBMISS

      CHARACTER*4  NET
      CHARACTER*8  SUBSET,LAST

      DIMENSION IUNITG(2)

      DATA  LAST/'XXXXXXXX'/

      CALL W3TAGB('PREPOBS_PREVENTS',2020,0283,0061,'NP22')

      PRINT 700
  700 FORMAT(/'  =====> WELCOME TO PREVENTS PROGRAM -- LAST UPDATED ',
     $ '2020-01-09'/)

C  On WCOSS should always set BUFRLIB missing (BMISS) to 10E8 to avoid
C   overflow when either an INTEGER*4 variable is set to BMISS or a
C   REAL*8 (or REAL*4) variable that is missing is NINT'd
C  -------------------------------------------------------------------
ccccc CALL SETBMISS(10E10_8)
      CALL SETBMISS(10E8_8)
      BMISS=GETBMISS()
      print *
      print *, 'BUFRLIB value for missing is: ',bmiss
      print *

      IUNITI    = 11
      IUNITG(1) = 12
      IUNITG(2) = 13
      IUNITE    = 14
      IUNITD    = 15
      IUNITP    = 51
      IUNITS    = 52

C  OPEN INPUT PREPBUFR FILE JUST TO GET MESSAGE DATE (WHICH IS THE
C   ACTUAL CENTER DATE), LATER CLOSE FILE
C  ---------------------------------------------------------------

      CALL DATELEN(10)

      CALL OPENBF(IUNITI,'IN',IUNITI)
      CALL READMG(IUNITI,SUBSET,IDATEP,IRET)

      PRINT 53, IDATEP
   53 FORMAT(/' --> ACTUAL   CENTER DATE OF PREPBUFR FILE READ FROM ',
     $ ' SEC. 1 MESSAGE DATE IS:',I11/)

      IF(IDATEP.LT.1000000000)  THEN

C If 2-digit year returned in IDATEP, must use "windowing" technique
C  to create a 4-digit year

C IMPORTANT: IF DATELEN(10) IS CALLED, THE DATE HERE SHOULD ALWAYS
C            CONTAIN A 4-DIGIT YEAR, EVEN IF INPUT FILE IS NOT
C            Y2K COMPLIANT (BUFRLIB DOES THE WINDOWING HERE)

         PRINT *, '##> THE FOLLOWING SHOULD NEVER HAPPEN!!!!!'
         PRINT'(" ##> 2-DIGIT YEAR IN IDATEP RETURNED FROM READMG ",
     $    "(IDATEP IS: ",I0,") - USE WINDOWING TECHNIQUE TO OBTAIN ",
     $    "4-DIGIT YEAR")', IDATEP
C IF IDATEP=41~99 THEN IDATEP=1941~1999
C IF IDATEP=00~40 THEN IDATEP=2000~2040
         IF(IDATEP/1000000.GT.40)  THEN
            IDATEP = 1900000000 + IDATEP
         ELSE
            IDATEP = 2000000000 + IDATEP
         ENDIF
         PRINT *, '##> CORRECTED IDATEP WITH 4-DIGIT YEAR, IDATEP NOW',
     $    ' IS: ',IDATEP
      ENDIF

C  READ IN EXPECTED CENTER DATE OF PREPBUFR FILE
C  ---------------------------------------------

      REWIND IUNITD
      READ(IUNITD,'(6X,I10)',END=904,ERR=904)  IDATED
      PRINT 3, IUNITD, IDATED
    3 FORMAT(/' --> EXPECTED CENTER DATE OF PREPBUFR FILE READ FROM ',
     $ 'UNIT',I3,' IS:',13X,I11/)

C  CHECK ACTUAL CENTER DATE OF PREPBUFR FILE VS. EXPECTED CENTER DATE
C  ------------------------------------------------------------------

      IF(IDATEP.NE.IDATED)  GO TO 901

      CALL CLOSBF(IUNITI)

C  OPEN INPUT AND OUTPUT PREPBUFR FILES FOR DATA PROCESSING
C  --------------------------------------------------------

      CALL OPENBF(IUNITI,'IN ',IUNITI)
      CALL OPENBF(IUNITP,'OUT',IUNITI)

C  DETERMINE WHICH NETWORK WE ARE RUNNING UNDER
C  --------------------------------------------

      CALL GET_ENVIRONMENT_VARIABLE('NET',NET)

      print *
      if(net.eq.'cdas' .or. net.eq.'cdc') then
         print'(" --> Running in ",A," network - CALL IN-LINE ROUTINE ",
     $    "GBLEVENTS_CDAS (expects CDAS-style sigma guess)")', net
      else
         print'(" --> Running in ",A," network - CALL W3NCO ROUTINE ",
     $    "GBLEVENTS (expects GFS-style sigma or hybrid guess)")', net
      end if
      print *

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      NEWTYP = 0

C  LOOP THROUGH THE INPUT MESSAGES
C  -------------------------------

      DO WHILE(IREADMG(IUNITI,SUBSET,JDATEP).EQ.0)
         IF(SUBSET.NE.LAST)  THEN
            NEWTYP = 1
cppppp
            print *, 'New input message type read in: ',SUBSET
cppppp
         END IF

         CALL OPENMB(IUNITP,SUBSET,JDATEP)
         DO WHILE(IREADSB(IUNITI).EQ.0)

C  COPY DECODED REPORT FROM INPUT PREPBUFR FILE TO OUTPUT PREPBUFR FILE
C  --------------------------------------------------------------------

            CALL UFBCPY(IUNITI,IUNITP)

            IF(NET.NE.'cdas' .AND. NET.NE.'cdc') THEN

C  FOR ALL NETWORKS EXCEPT CDAS AND CDC, CALL W3NCO ROUTINE GBLEVENTS
C   TO ENCODE FIRST GUESS VALUES FOR THIS REPORT (EXPECTS GFS-STYLE
C   SIGMA OR HYBRID GUESS)
C  --------------------------------------------------------------------

               CALL GBLEVENTS(IDATED,IUNITG,IUNITE,IUNITP,IUNITS,SUBSET,
     $                        NEWTYP)

            ELSE

C  FOR CDAS NETWORK, CALL IN-LINE ROUTINE GBLEVENTS_CDAS TO ENCODE
C   FIRST GUESS VALUES FOR THIS REPORT (EXPECTS CDAS-STYLE SIGMA GUESS)
C  --------------------------------------------------------------------

               CALL GBLEVENTS_CDAS(IDATED,IUNITG,IUNITE,IUNITP,IUNITS,
     $                             SUBSET,NEWTYP)

            END IF

C  WRITE THIS REPORT (SUBSET) INTO BUFR MESSAGE IN OUTPUT PREPBUFR FILE
C  --------------------------------------------------------------------

            CALL WRITSB(IUNITP)

            NEWTYP = 0

         ENDDO

         LAST = SUBSET

      ENDDO

C  CLOSE THE BUFR FILES
C  --------------------

      CALL CLOSBF(IUNITI)
      CALL CLOSBF(IUNITP)

C  ALL DONE
C  --------

      CALL W3TAGE('PREPOBS_PREVENTS')

      STOP
C-----------------------------------------------------------------------

  901 CONTINUE
      PRINT 9901, IDATEP,IDATED
 9901 FORMAT(/' ##> ACTUAL CENTER DATE OF INPUT PREPBUFR FILE (',I10,
     $ ') DOES NOT MATCH EXPECTED CENTER DATE (',I10,') - STOP 21'/)
      CALL W3TAGE('PREPOBS_PREVENTS')
      CALL ERREXIT(21)

C-----------------------------------------------------------------------

  904 CONTINUE
      PRINT 9902, IUNITD
 9902 FORMAT(/' ##> BAD OR MISSING EXPECTED PREPBUFR CENTER DATE ',
     $ 'READ FROM UNIT',I3,' - STOP 22'/)
      CALL W3TAGE('PREPOBS_PREVENTS')
      CALL ERREXIT(22)

C-----------------------------------------------------------------------

      END

#!/bin/ksh
# Run under ksh (converted to WCOSS)


# This script performs two tasks:
#   1) Execute program PREPOBS_PREPACQC to perform aircraft quality control
#      checking
#   2) Execute program PREPOBS_PREPACPF to append a surface level to profile
#      reports in the PREPBUFR-format aircraft profiles file which is output
#      from PREPOBS_PREPACQC
#  Both tasks are optional in case the executing job wants to perform only one
#  of these two tasks.  The default to to perform both tasks.
#
# This script is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# --------------------------------------------------------------------------

set -aux

qid=$$

# Positional parameters that must always be passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script
#       (note that input prepbufr file is NOT saved by this script)
#       {this can be set to "null" if PROCESS_ACQC != YES (see below), since in
#        this case it is not considered}

# Positional parameters that must be passed in if PROCESS_ACPF = YES (see
#  below):
#   2 - path to adpsfc dump file input to PREPOBS_PREPACPF {normally the same
#       one that was read in to generate the prepbufr file in positional
#       parameter 1 or, if PREPOBS_PREPACQC != YES (see below), the prepbufr
#       file processed by program PREPOBS_PREPACQC which presumably ran some
#       place outside of, and prior to, this script}

# Imported variables that must always be passed in:
#   DATA - path to working directory
#   PROCESS_ACQC - switch controlling whether or not to execute
#                  PREPOBS_PREPACQC
#   PROCESS_ACPF - switch controlling whether or not to execute
#                  PREPOBS_PREPACPF

# Imported variables that must be passed in if PROCESS_ACQC = YES:
#   AQCX - path to PREPOBS_PREPACQC program executable
#   AQCC - path to PREPOBS_PREPACQC program parm cards

# Imported variables that must be passed in if PROCESS_ACQC != YES:
#   acft_profiles - path to prepbufr.acft_profiles file output by program
#                   PREPOBS_PREPACQC (which presumably ran some place outside
#                   of, and prior to, this script)

# Imported variables that must be passed in if PROCESS_ACPF = YES:
#   DICT - path to unsorted METAR station dictionary file
#   APFX - path to PREPOBS_PREPACPF program executable

# Imported variables that can be passed in:
#   jlogfile - string indicating path to joblog file
#              (skipped over by this script if not passed in)
#              (only examined if PROCESS_ACPF = YES)
#   pgmout   - string indicating path to for standard output file
#              (skipped over by this script if not passed in)


cd $DATA

jlogfile=${jlogfile:=""}

if [ $PROCESS_ACQC = YES ]; then
   PRPI=$1
   if [ ! -s $PRPI ] ; then exit 1;fi

   rm $PRPI.prepacqc
   rm prepbufr.acft_profiles

   pgm=`basename  $AQCX`
   if [ -s $DATA/prep_step ]; then
   set +u
      . $DATA/prep_step
   set -u
   else
      [ -f errfile ] && rm errfile
      unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
   fi

   export FORT11=$PRPI
   export FORT41=vvel_info.acft_profiles.txt
   export FORT61=$PRPI.prepacqc
   export FORT62=prepbufr.acft_profiles
   TIMEIT=${TIMEIT:-""}
   [ -s $DATA/time ] && TIMEIT="$DATA/time -p"
   # The following improves performance on Cray-XC40 if $AQCX was
   #    linked to the IOBUF i/o buffering library
   export IOBUF_PARAMS='*.log:verbose,*.txt:verbose,*.sorted:verbose'
   $TIMEIT $AQCX< $AQCC > outout 2> errfile
   err=$?
   err_actual=$err
   unset IOBUF_PARAMS
######cat errfile
   cat errfile >> outout
   cat outout >> prepacqc.out
   set +u
   [ -n "$pgmout" ]  &&  cat outout >> $pgmout
   set -u
   rm outout
   set +x
   echo
   echo 'The foreground exit status for PREPOBS_PREPACQC is ' $err
   echo
   set -x
   if [ $err -eq 4 ]; then
      msg="PREPBUFR DATA SET CONTAINS NO "AIRCAR" OR "AIRCFT" TABLE A MESSAGES  --> non-fatal"
      [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
      err=0
   fi
   if [ -s $DATA/err_chk ]; then
      $DATA/err_chk
   else
      if test "$err" -gt '0'
      then
#########kill -9 ${qid} # need a WCOSS alternative to this even tho commented
                        #  out in ops
         exit 55
      fi
   fi

   if [ "$err" -gt '0' ]; then
      exit 9
   elif [ "$err_actual" -gt '0' ]; then
      PROCESS_ACPF=NO
   else
     [ ! -f $PRPI.prepacqc ] && touch $PRPI.prepacqc
      mv $PRPI.prepacqc $PRPI
   fi

else
   cp -p $acft_profiles prepbufr.acft_profiles
fi


if [ $PROCESS_ACPF = YES ]; then
   ADPSFC=$2

   sort -n +0.61 -0.67 $DICT > metar.tbl.lon_sorted

   msg=good
   if [ ! -s $ADPSFC ]; then
      msg="WARNING: PREPOBS_PREPACPF COULD NOT RUN, adpsfc FILE NOT FOUND \
--> non-fatal"
   elif [ ! -s prepbufr.acft_profiles ]; then
      msg="WARNING: PREPOBS_PREPACPF COULD NOT RUN, prepbufr.acft_profiles \
FILE NOT FOUND --> non-fatal"
   elif [ ! -s metar.tbl.lon_sorted ]; then
      msg="WARNING: PREPOBS_PREPACPF COULD NOT RUN, metar.tbl FILE NOT FOUND \
--> non-fatal"
   fi
   if [ "$msg" != 'good' ]; then
      set +x
      echo
      echo "$msg"
      echo
      set -x
      [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
      exit 0
   fi

   pgm=`basename  $APFX`
   if [ -s $DATA/prep_step ]; then
      set +u
      . $DATA/prep_step
      set -u
   else
      [ -f errfile ] && rm errfile
      unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
   fi

   export FORT11=metar.tbl.lon_sorted
   export FORT12=$ADPSFC
   export FORT13=prepbufr.acft_profiles
   export FORT51=prepbufr.acft_profiles_sfc
   TIMEIT=${TIMEIT:-""}
   [ -s $DATA/time ] && TIMEIT="$DATA/time -p"
   $TIMEIT $APFX > outout 2> errfile
   err=$?
######cat errfile
   cat errfile >> outout
   cat outout >> prepacpf.out
   set +u
   [ -n "$pgmout" ]  &&  cat outout >> $pgmout
   set -u
   rm outout
   set +x
   echo
   echo 'The foreground exit status for PREPOBS_PREPACPF is ' $err
   echo
   set -x
   if [ $err -gt 0 ]; then
      msg="WARNING: PREPOBS_PREPACPF DID NOT COMPLETE NORMALLY --> non-fatal"
      set +x
      echo
      echo "$msg"
      echo
      set -x
      [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
   else
      err=0
      [ -s $DATA/err_chk ]  &&  $DATA/err_chk
   fi
fi

exit 0

#!/bin/ksh 
set -x

export cmodel=gfs
export loopnum=1
export ymdh=${PDY}${cyc}

#export gfsdir=${COMINgfs}/${cyc}
#export gfsdir=${COMINgfs}

export COMPONENT=${COMPONENT:-atmos}
export gfsdir=${COMINgfs}/${cyc}/${COMPONENT}

export pert="p01"
pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#-----------input data checking -----------------
#${USHens_tracker}/data_check.sh 
${USHens_tracker}/data_check_gfs.sh
## exit code 6 = missing data of opportunity
if [ $? -eq 6 ]; then exit; fi
#------------------------------------------------

outfile=${pertdir}/trkr.${cmodel}.${pert}.${ymdh}.out

if [[ -d /scratch2 ]] ; then
  # We are on NOAA Hera
  machine=hera
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /work ]] ; then
  # We are on MSU Orion
  machine=orion
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs4/HFIP ]] ; then
  # We are on NOAA Jet
  machine=jet
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs/h1 ]] ; then
  # We are on NOAA WCOSS2
  machine=wcoss2
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}  

elif [[ -d /gpfs/f6 ]] ; then
  # We are on NOAA gaeac6
  machine=gaeac6
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /opt/spack-stack ]] ; then
  # We are on AWS EC2
  machine=aws-ec2
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

else
  export machine=unknown
  echo Job failed: unknown platform 1>&2
  err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"

fi
export err=$?; err_chk

#if [ "$SENDCOM" = 'YES' ]; then
#  cat ${pertdir}/trak.gfso.atcfunix.${PDY}${cyc} | \
#      sed s:GFSO:AVNO:g \
#    > ${COMOUT}/avn.t${cyc}z.cyclone.trackatcfunix
#fi

#############################################################

#!/bin/bash
#--------------------------------------------------------------------------
#
#  satellite_summary.sh
#
#  This script creats three HTML pages of satellite observational counts.  
#  These pages are summarized from the EMC counts data file and the 
#  status file from the GDAS model run.  The HTML pages summarize the 
#  received reports, selected reports and assimilated reports for many
#  different types of satellite data.
#
#  History:
#  L. Sager   09/07  Modified the script to work properly in operations.
#  D. Stokes 04/2015 Moved to vertical structure package obsproc_prep_post and
#                    updated variables pointing to other software included in
#                    this migration. Updated the parsing of info for cosmic/gps
#                    data.  Made minor changes to reduce unnecessary warnings.
#  D. Keyser 05/2015 Split imported script variables $SATCOM and $DATCOM into
#     separate input and output variables $SATCOMIN (root to $SATCOMIN_dir) and
#     $SATCOMOUT_dir, and $DATCOMIN (root to $DATCOMIN_dir) and $DATCOMOUT_dir
#     set in parent Job Script.
#     BENEFIT: Allows checkout runs to specify a production input location and
#              a local output location.
#--------------------------------------------------------------------------
#
#   Summarize the satellite counts files
#

 for hh in 00 06 12 18  
 do 
    file=`ls $SATCOMIN_dir/*t${hh}z`
    rm -f tmpsat_file
    for satfile in $file
    do
       echo copy $satfile to tmpsat_file
       echo $satfile
       cat $satfile >> tmpsat_file
    done
    sed 's/ type gps_bnd jiter   3/o-g 03 rad  gps       cosmic/' tmpsat_file > testa
    sed 's/nread//' testa > testb     
    sed 's/nkeep//' testb > testc    
    sed 's/num//' testc  > tmpsat_file    
    sort tmpsat_file > tmpsat_final${hh}     
 done
#
#   Process the gdas status file for satwnd
#     and quikscat
#
 for hh in 00 06 12 18  
 do 
    file=`ls $DATCOMIN_dir/*t${hh}z*`
    rm -f tmpdat1_file
    rm -f tmpdat2_file
    rm -f tmpdat3_file
    for datfile in $file
    do
       grep satwnd $datfile | grep -v Domain >> tmpdat1_file${hh}
       grep qkscat $datfile  >> tmpdat2_file${hh}
       grep QUIKSC $datfile  >> tmpdat3_file${hh}
    done
    days=`ls $DATCOMIN_dir/*t${hh}z* | wc -l`
###############################################################################
###############################################################################
# NOTICE: DO NOT CHANGE "iS" to "is" below as it will cause satellite_daily.pl
#         to not work properly!!
#         BE VERY CAREFUL WHEN MAKING ANY CHANGES TO THIS SCRIPT!!
###############################################################################
###############################################################################
    echo Number of days iS  $days  >> tmpdat_days${hh}
    
 done
#
#   Sum the satellites by cycle time
#
 $USHprepobs/satellite_daily.pl
  sort -u   tmpsat_list > tmpsat_types  
  sort -o   tmpsat_davg00 tmpsat_davg00  
  sort -o   tmpsat_davg06 tmpsat_davg06  
  sort -o   tmpsat_davg12 tmpsat_davg12  
  sort -o   tmpsat_davg18 tmpsat_davg18  

#
#   Create the html pages       
#
  cp $FIXprepobs/satellite_counts.tbl .
  $USHprepobs/satellite_html.pl $MONTH $YEAR

exit

          

#!/bin/ksh
################################################################################
echo "------------------------------------------------------------------------ "
echo "exrap_dump.sh     - Rapid Refresh Full and Partial Cycle Dump processing "
echo "------------------------------------------------------------------------ "
echo "History: Oct 13 2011 - Original script.                                  "
echo "         Sep 10 2014 - Use parallel scripting to process dump groups.    "
echo "         Feb  3 2015 - Dump new satwnd types NC005019, NC005080,         "
echo "                       NC005090. Reorder cfp commands and add new thread "
echo "                       to speed up run.                                  "
echo "         Apr  8 2015   Add test for number of dump groups expected in    "
echo "                       upstream job script ($num_DUMP_group). If doesn't "
echo "                       agree with what is expected here, abort (done in  "
echo "                       RUN rap_eh only).                                 "
echo "         Aug 18 2016 - GPSIPW dump window reset for new data stream.     "
echo "         Aug 24 2017 - Update to run on Cray-XC40 or IBM iDataPlex.      "
echo "                       Dump new radiance types amsr2, atmsdb, crisdb,    "
echo "                       esatms, escris, esiasi, iasidb, saphir, sevasr.   "
echo "                       Expand lghtng dump window. Copy grib2 imssnow     "
echo "                       file. Skip 002007 in dump group #3; temporary     "
echo "                       until next bufr_dumplist upgrade.                 "
echo "         Jun 04 2019, Oct 24 2019; Apr 06, 2020; Sep 14, 2020:           "
echo "                     - Update to add GOES-16/17 DMW data to satwnd dump. "
echo "                       Update to dump crisf4, gsrasr, and gsrcsr data.   "
echo "                     - Remove rap_eh processing; not required for HRRRv4."
echo "                     - Remove the skip of NPN wind profiler data.  The   "
echo "                       NPN tank has been removed from bufr_dumplist      "
echo "                       proflr definition.                                "
echo "                     - Remove radwnd processing; discontinued.           " 
echo "                     - Remove GOES-15 tanks in satwnd dump group.        "
echo "                     - Remove goesnd dump group (GOES-15 clouds &        "
echo "                       radiances).                                       "
echo "                     - Add DBN alerts for all satellite data.            "
echo "                     - Remove crisdb and escris and replace with crsfdb. "
echo "                       On Apr 22, 2020, NSR CrIS data from NPP was       "
echo "                       replaced by FSR. The cris dump group is obsolete  "
echo "                       with the change to FSR.                           "
echo "                     - Update to Dump group #2 to disable processing of  "
echo "                       legacy EUMETSAT AMV subsets 005064, 005065,       "
echo "                       and 005066.  Add DTIM settings for new BUFR format"
echo "                       EUMETSAT AMV subsets 005067, 005068, and 005069 in"
echo "                       the satwnd dump. On Oct 6, 2020, EUMETSAT AMV     "
echo "                       format changed to use new WMO BUFR sequence       " 
echo "                       3-10-077.                                         "
echo "                     - moved lghtng to it's own unique dump group, new   "
echo "                       Dump group #9.  This was done so that the lghtng  "
echo "                       bufr_d file can be available as soon as possible  "
echo "                       for HRRR.                                         "
echo "         Jun 22 2021 - Incremented subsets for sfcshp dump groups to     "
echo "                       match bufr_dumplist.  Removed tideg from sfcshp   "
echo "                       dump group to make individual dump file.          "
echo "                     - Copy bufr_dumplist to COMOUT.                     "
echo "         Dec 09 2021 - Updated to run on WCOSS2                          "
echo "         Aug 10 2022 - Added subpfl,saldn to dump #1,snocvr to dump #3.  "
echo "                       added gmi1cr dump group #7                        "
echo "                       b005/xx081 added to satwnd                        "
echo "         Sep 30 2022 - Enable dumping of UPRAIR data in group #2.        "
echo "         Oct 11 2023 - Split msonet to msonet and msone1, msone1=255.030 "
echo "                       concatenate msonet and msone1 right after dump    "
echo "                     - Pull adpupa and uprair into own Dump group        "
echo "         Mar 14 2024 - Split gsrasr and gsrcsr to own dump hroups        "
################################################################################

set -xau

# set some variables if they have not already been set

set +u

# JOB_NUMBER = 1 indicates the prepbufr dump job.
# JOB_NUMBER = 2 indicates the non-prepbufr dump job.
# JOB_NUMBER not present indicates dump BOTH prepbufr and non-prepbufr data.
# ------------------------------------------------------------------------
# Dump group #1 (non-pb) = 1bamua 1bmhs esamua esmhs atms mtiasi sevcsr
#                          gpsro esiasi iasidb esatms atmsdb sevasr amsr2
# Dump group #2 (pb) = vadwnd satwnd
# Dump group #3 (pb) = proflr rassda sfcshp adpsfc ascatt tideg snocvr
#                          subpfl saldrn
# Dump group #4 (pb) = msonet gpsipw 
# Dump group #5 (pb) = aircft aircar
# Dump group #6 (non-pb) = nexrad
# Dump group #7 (non-pb) = airsev 1bhrs4 eshrs3 lgycld ssmisu osbuv8 crsfdb
#                          saphir gmi1cr
# Dump group #8 (non-pb) = gsrasr [gsrcsr]
# Dump group #9 (non-pb) = lghtng + adpupa
# Dump group #10(pb) = msone1 # ONLY tank b255/xx030, the largest
# Dump group #11(pb) = adpupa uprair - adpupa
# Dump group #12 (non-pb)= gsrcsr
# Dump group #13 STATUS FILE
# ------------------------------------------------------------------------

#VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
# The settings below are based on a future change when the DUMP job will dump
#  only types that go into PREPBUFR and the DUMP2 job will dump only types that
#  do not go into PREPBUFR.  This will speed up the DUMP + PREP processing.
# Although the logic is in place to now do this (see below), for now we will
#  continue to run only a DUMP job which will dump ALL types (no DUMP2 job) -
#  since JOB_NUMBER is not imported to this script, the logic below will dump
#  all types ...
# -----------------------------------------------------------------------------
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

if [ -n "$JOB_NUMBER" ]; then
set -u
   if [ $JOB_NUMBER = 2 ]; then
      dump_ind=DUMP2
      DUMP_group1=${DUMP_group1:-"YES"}
      DUMP_group2=${DUMP_group2:-"NO"}
      DUMP_group3=${DUMP_group3:-"NO"}
      DUMP_group4=${DUMP_group4:-"NO"}
      DUMP_group5=${DUMP_group5:-"NO"}
      DUMP_group6=${DUMP_group6:-"YES"}
      DUMP_group7=${DUMP_group7:-"YES"}
      DUMP_group8=${DUMP_group8:-"YES"}
      DUMP_group9=${DUMP_group9:-"YES"}
      DUMP_group10=${DUMP_group10:-"NO"}
      DUMP_group11=${DUMP_group11:-"NO"}
      DUMP_group12=${DUMP_group12:-"YES"}
   else
      dump_ind=DUMP
      DUMP_group1=${DUMP_group1:-"NO"}
      DUMP_group2=${DUMP_group2:-"YES"}
      DUMP_group3=${DUMP_group3:-"YES"}
      DUMP_group4=${DUMP_group4:-"YES"}
      DUMP_group5=${DUMP_group5:-"YES"}
      DUMP_group6=${DUMP_group6:-"NO"}
      DUMP_group7=${DUMP_group7:-"NO"}
      DUMP_group8=${DUMP_group8:-"NO"}
      DUMP_group9=${DUMP_group9:-"NO"}
      DUMP_group10=${DUMP_group10:-"YES"}
      DUMP_group11=${DUMP_group11:-"YES"}
      DUMP_group12=${DUMP_group12:-"NO"}
   fi
else
   dump_ind=DUMP
   DUMP_group1=${DUMP_group1:-"YES"}
   DUMP_group2=${DUMP_group2:-"YES"}
   DUMP_group3=${DUMP_group3:-"YES"}
   DUMP_group4=${DUMP_group4:-"YES"}
   DUMP_group5=${DUMP_group5:-"YES"}
   DUMP_group6=${DUMP_group6:-"YES"}
   DUMP_group7=${DUMP_group7:-"YES"}
   DUMP_group8=${DUMP_group8:-"YES"}
   DUMP_group9=${DUMP_group9:-"YES"}
   DUMP_group10=${DUMP_group10:-"YES"}
   DUMP_group11=${DUMP_group11:-"YES"}
   DUMP_group12=${DUMP_group12:-"YES"}
fi

# Oct 2019; disable -- not needed for HRRRv4
#if [ $RUN = rap_eh ]; then
#   set +u
#   if [ $num_DUMP_group -ne 7 ]; then
#      set +x
#      echo
#      echo "The nmmber of dump groups expected in the job script does not "
#      echo "agree with the number expected here!!!. Exiting..."
#      echo
#      set -x
#      $DATA/err_exit
#      exit 9
#   fi
#   set -u
#fi

# send extra output of DUMP2 for monitoring purposes.
set +u
if [ -n "$JOB_NUMBER" ]; then
   [ $JOB_NUMBER = 2 ]  && export PS4='$SECONDS + '
fi
set -u

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"
 
cat break > $pgmout

export dumptime=`cut -c7-16 ncepdate`

RUN_uc=$(echo $RUN | tr [a-z] [A-Z])
tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="$RUN_uc ANALYSIS TIME IS $PDY$cyc"
$DATA/postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR $tmmark_uc $RUN_uc IS $dumptime"
echo
set -x
 
export COMSP=$COMOUT/$RUN.${cycle}.
 
if [ "$PROCESS_GRIBFLDS" = 'YES' ]; then

###################################
#  copy imssnow from $TANK_GRIBFLDS
###################################

   imssnow=$TANK_GRIBFLDS/$PDY/wgrbbul
   imssold=$TANK_GRIBFLDS/$PDYm1/wgrbbul
   typeset -A flarr
   flarr[imssnow]=imssnow96.grb
   flarr["imssnow.grib2"]=imssnow96.grb.grib2
   for i in "${!flarr[@]}"
   do
     if [ -s $imssnow/${flarr[$i]} ]; then
       cp $imssnow/${flarr[$i]} ${COMSP}${i}
       msg="todays IMS snow grib file (${flarr[$i]}) located and copied \
to ${COMSP}${i}"
       $DATA/postmsg "$jlogfile" "$msg"
     elif [ -s $imssold/${flarr[$i]} ]; then
       cp $imssold/${flarr[$i]} ${COMSP}${i}
       msg="**todays IMS snow grib file (${flarr[$i]}) not located - copy \
1-day old file"
       $DATA/postmsg "$jlogfile" "$msg"
     else
       set +x
       echo " "
       echo " ###############################################"
       echo " cannot locate IMS snow grib file: ${flarr[$i]} "
       echo " ###############################################"
       echo " "
       set -x
#      echo "no imssnow data availble for RAP" | mail geoffrey.manikin@noaa.gov
       msg="**CANNOT LOCATE IMS SNOW GRIB FILE: ${flarr[$i]}"
       $DATA/postmsg "$jlogfile" "$msg"
     fi
   done
fi  #  endif loop $PROCESS_GRIBFLDS

# NAP is introduced so that uprair can run early on his own
NAP=${NAP:-120} #b/c cron is moved to run 2min (120s) early

echo "=======> Dump group 1 (thread_1) not executed." > $DATA/1.out
echo "=======> Dump group 2 (thread_2) not executed." > $DATA/2.out
echo "=======> Dump group 3 (thread_3) not executed." > $DATA/3.out
echo "=======> Dump group 4 (thread_4) not executed." > $DATA/4.out
echo "=======> Dump group 5 (thread_5) not executed." > $DATA/5.out
echo "=======> Dump group 6 (thread_6) not executed." > $DATA/6.out
echo "=======> Dump group 7 (thread_7) not executed." > $DATA/7.out
echo "=======> Dump group 8 (thread_8) not executed." > $DATA/8.out
echo "=======> Dump group 9 (thread_9) not executed." > $DATA/9.out
echo "=======> Dump group 10 (thread_10) not executed." > $DATA/10.out
echo "=======> Dump group 11 (thread_11) not executed." > $DATA/11.out
echo "=======> Dump group 12 (thread_12) not executed." > $DATA/12.out
err1=0
err2=0
err3=0
err4=0
err5=0
err6=0
err7=0
err8=0
err9=0
err10=0
err11=0
err12=0

#restrict processing of unexpected big tanks
#this block appear in all /scripts/ex*_dump.sh proessing msonet and msone1 
TANK_MAX_255003=${TANK_MAX_255003:-3221225472} #3Gb
TANK_MAX_255004=${TANK_MAX_255004:-1610612736} #1.5Gb
TANK_MAX_255030=${TANK_MAX_255030:-4187593114} #3.9Gb
if [ -s ${TANK}/${PDY}/b255/xx003 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx003)" -gt "$TANK_MAX_255003" ]; then
 export SKIP_255003=YES
 msg="WARNING: TANK b255/xx003 exceeds TANK_MAX_255003 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
if [ -s ${TANK}/${PDY}/b255/xx004 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx004)" -gt "$TANK_MAX_255004" ]; then
 export SKIP_255004=YES
 msg="WARNING: TANK b255/xx004 exceeds TANK_MAX_255004 => not dumped"
 echo $msg | mail.py -s "$msg" 
# echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
 fi
if [ -s ${TANK}/${PDY}/b255/xx030 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx030)" -gt "$TANK_MAX_255030" ]; then
 export SKIP_255030=YES
 msg="WARNING: TANK b255/xx030 exceeds TANK_MAX_255030 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
#end of block


if [ "$PROCESS_DUMP" = 'YES' ]; then

##################################
##################################
#  The data "dump" script for TM00
##################################
##################################

msg="START THE $tmmark_uc $RUN_uc DATA $dump_ind CENTERED ON $dumptime"
$DATA/postmsg "$jlogfile" "$msg"

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=1

#===============================================================================
# Dump # 1 : 1BAMUA, 1BMHS,  ESAMUA, ESMHS, ATMS, MTIASI, SEVCSR, GPSRO,
#              (1)    (1)     (1)     (1)   (1)    (1)    (1)     (1)
#            ESIASI, IASIDB, ESATMS, ATMSDB, SEVASR, AMSR2, SUBPFL, SALDRN
#              (1)    (1)     (1)     (1)     (1)     (1)    (1)    (1)
#             TOTAL NUMBER OF SUBTYPES = 16
#===============================================================================
 
if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   def_time_window_1=1.0 # default time window for dump 1 is -1.0 to +1.0 hours

# Time window is -1.00 to +0.99 hours for 1BAMUA, 1BMHS, AMSR2
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_1bamua=${DTIM_latest_1bamua:-"+0.99"}      # earliest is default
    DTIM_latest_1bmhs=${DTIM_latest_1bmhs:-"+0.99"}       # earliest is default
    DTIM_latest_amsr2=${DTIM_latest_amsr2:-"+0.99"}       # earliest is default

# Time window is -1.00 to +0.99 hours for ATMS, ESATMS, ATMSDB,
#  MTIASI, ESIASI, IASIDB
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_atms=${DTIM_earliest_atms:-"-1.00"}
   DTIM_latest_atms=${DTIM_latest_atms:-"+0.99"}
   DTIM_earliest_esatms=${DTIM_earliest_esatms:-"-1.00"}
   DTIM_latest_esatms=${DTIM_latest_esatms:-"+0.99"}
   DTIM_earliest_atmsdb=${DTIM_earliest_atmsdb:-"-1.00"}
   DTIM_latest_atmsdb=${DTIM_latest_atmsdb:-"+0.99"}
   DTIM_earliest_mtiasi=${DTIM_earliest_mtiasi:-"-1.00"}
   DTIM_latest_mtiasi=${DTIM_latest_mtiasi:-"+0.99"}
   DTIM_earliest_esiasi=${DTIM_earliest_esiasi:-"-1.00"}
   DTIM_latest_esiasi=${DTIM_latest_esiasi:-"+0.99"}
   DTIM_earliest_iasidb=${DTIM_earliest_iasidb:-"-1.00"}
   DTIM_latest_iasidb=${DTIM_latest_iasidb:-"+0.99"}

# Time window is -1.00 to +0.99 hours for SEVCSR, SEVASR, GPSRO
  DTIM_earliest_sevcsr=${DTIM_earliest_sevcsr:-"-1.00"}
  DTIM_latest_sevcsr=${DTIM_latest_sevcsr:-"+0.99"}
  DTIM_earliest_sevasr=${DTIM_earliest_sevasr:-"-1.00"}
  DTIM_latest_sevasr=${DTIM_latest_sevasr:-"+0.99"}
  DTIM_earliest_gpsro=${DTIM_earliest_gpsro:-"-1.00"}
  DTIM_latest_gpsro=${DTIM_latest_gpsro:-"+0.99"}
 
# Time window is -0.50 to +0.49 hours for ESAMUA, ESMHS
   DTIM_earliest_esamua=${DTIM_earliest_esamua:-"-0.50"}
   DTIM_latest_esamua=${DTIM_latest_esamua:-"+0.49"}
    DTIM_earliest_esmhs=${DTIM_earliest_esmhs:-"-0.50"}
    DTIM_latest_esmhs=${DTIM_latest_esmhs:-"+0.49"}

# Uncertain on time window
   DTIM_earliest_subpfl=${DTIM_earliest_subpfl:-"-1.00"}
   DTIM_latest_subpfl=${DTIM_latest_subpfl:-"+0.99"}
   DTIM_earliest_saldrn=${DTIM_earliest_saldrn:-"-1.00"}
   DTIM_latest_saldrn=${DTIM_latest_saldrn:-"+0.99"}


else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

   def_time_window_1=3.0 # default time window for dump 1 is -3.0 to +3.0 hours

# Time window is -3.00 to +2.99 hours for 1BAMUA, 1BMHS
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_1bamua=${DTIM_latest_1bamua:-"+2.99"}      # earliest is default
    DTIM_latest_1bmhs=${DTIM_latest_1bmhs:-"+2.99"}       # earliest is default

# Time window is -3.00 to -2.01 hours for AMSR2
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_amsr2=${DTIM_latest_amsr2:-"-2.01"}        # earliest is default

# Time window is -2.00 to +1.99 hours for ATMS, ESATMS, ATMSDB,
#  MTIASI, ESIASI, IASIDB
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_atms=${DTIM_earliest_atms:-"-2.00"}
   DTIM_latest_atms=${DTIM_latest_atms:-"+1.99"}
   DTIM_earliest_esatms=${DTIM_earliest_esatms:-"-2.00"}
   DTIM_latest_esatms=${DTIM_latest_esatms:-"+1.99"}
   DTIM_earliest_atmsdb=${DTIM_earliest_atmsdb:-"-2.00"}
   DTIM_latest_atmsdb=${DTIM_latest_atmsdb:-"+1.99"}
   DTIM_earliest_mtiasi=${DTIM_earliest_mtiasi:-"-2.00"}
   DTIM_latest_mtiasi=${DTIM_latest_mtiasi:-"+1.99"}
   DTIM_earliest_esiasi=${DTIM_earliest_esiasi:-"-2.00"}
   DTIM_latest_esiasi=${DTIM_latest_esiasi:-"+1.99"}
   DTIM_earliest_iasidb=${DTIM_earliest_iasidb:-"-2.00"}
   DTIM_latest_iasidb=${DTIM_latest_iasidb:-"+1.99"}

# Time window is -2.00 to +1.99 hours for SEVCSR, SEVASR, GPSRO, GSRASR, GSRCSR
   DTIM_earliest_sevcsr=${DTIM_earliest_sevcsr:-"-2.00"}
   DTIM_latest_sevcsr=${DTIM_latest_sevcsr:-"+1.99"}
   DTIM_earliest_sevasr=${DTIM_earliest_sevasr:-"-2.00"}
   DTIM_latest_sevasr=${DTIM_latest_sevasr:-"+1.99"}
   DTIM_earliest_gpsro=${DTIM_earliest_gpsro:-"-2.00"}
   DTIM_latest_gpsro=${DTIM_latest_gpsro:-"+1.99"}

# Time window is -1.00 to +1.00 hours for ESAMUA, ESMHS
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_esamua=${DTIM_earliest_esamua:-"-1.00"}
   DTIM_latest_esamua=${DTIM_latest_esamua:-"+1.00"}
    DTIM_earliest_esmhs=${DTIM_earliest_esmhs:-"-1.00"}
    DTIM_latest_esmhs=${DTIM_latest_esmhs:-"+1.00"}

# Uncertain on time window
   DTIM_earliest_subpfl=${DTIM_earliest_subpfl:-"-2.00"}
   DTIM_latest_subpfl=${DTIM_latest_subpfl:-"+1.99"}
   DTIM_earliest_saldrn=${DTIM_earliest_saldrn:-"-2.00"}
   DTIM_latest_saldrn=${DTIM_latest_saldrn:-"+1.99"}

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_1} 1 1bamua \
 1bmhs esamua esmhs atms mtiasi sevcsr gpsro esiasi iasidb esatms \
 atmsdb sevasr amsr2 subpfl saldrn
error1=$?
echo "$error1" > $DATA/error1

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_2; chmod +x thread_2
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_2
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=2

#==========================================================================
# Dump # 2 : VADWND, SATWND
#              (2)    (19)    
#            -- TOTAL NUMBER OF SUBTYPES = 21
#==========================================================================

# Skip all Indian satellite winds in SATWND (not in domain)
export SKIP_005021=YES
export SKIP_005022=YES
export SKIP_005023=YES

# Skip old bufr NPP VIIRS AMVs
export SKIP_005090=YES

# Skip old bufr EUMETSAT AMVs
For testing, skip in ecflow or obsproc_rap.ver file
#export SKIP_005064=YES
#export SKIP_005065=YES
#export SKIP_005066=YES

# Add GOES-16/17/18 DMW data to SATWND
export ADD_satwnd="005030 005031 005032 005034 005039"

# Time window -1.50 to +1.49 hours for EUMETSAT SATWND for full and partial
#  cycle runs

# Time window -1.00 to -0.01 hours for GOES SATWND for full and partial cycle
#  runs

DTIM_earliest_005030=${DTIM_earliest_005030:-"-1.00"}
DTIM_latest_005030=${DTIM_latest_005030:-"-0.01"}
 DTIM_earliest_005031=${DTIM_earliest_005031:-"-1.00"}
 DTIM_latest_005031=${DTIM_latest_005031:-"-0.01"}
DTIM_earliest_005032=${DTIM_earliest_005032:-"-1.00"}
DTIM_latest_005032=${DTIM_latest_005032:-"-0.01"}
 DTIM_earliest_005034=${DTIM_earliest_005034:-"-1.00"}
 DTIM_latest_005034=${DTIM_latest_005034:-"-0.01"}
DTIM_earliest_005039=${DTIM_earliest_005039:-"-1.00"}
DTIM_latest_005039=${DTIM_latest_005039:-"-0.01"}
 DTIM_earliest_005064=${DTIM_earliest_005064:-"-1.50"}
 DTIM_latest_005064=${DTIM_latest_005064:-"+1.49"}
DTIM_earliest_005065=${DTIM_earliest_005065:-"-1.50"}
DTIM_latest_005065=${DTIM_latest_005065:-"+1.49"}
 DTIM_earliest_005066=${DTIM_earliest_005066:-"-1.50"}
 DTIM_latest_005066=${DTIM_latest_005066:-"+1.49"}
DTIM_earliest_005067=${DTIM_earliest_005067:-"-1.50"}
DTIM_latest_005067=${DTIM_latest_005067:-"+1.49"}
 DTIM_earliest_005068=${DTIM_earliest_005068:-"-1.50"}
 DTIM_latest_005068=${DTIM_latest_005068:-"+1.49"}
DTIM_earliest_005069=${DTIM_earliest_005069:-"-1.50"}
DTIM_latest_005069=${DTIM_latest_005069:-"+1.49"}
DTIM_earliest_005081=${DTIM_earliest_005081:-"-1.50"}
DTIM_latest_005081=${DTIM_latest_005081:-"+1.49"}

if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   def_time_window_2=1.5 # default time window for dump 2 is -1.5 to +1.5 hours

# Time window is -0.50 to +0.50 hours for VADWND
   DTIM_earliest_vadwnd=${DTIM_earliest_vadwnd:-"-0.50"}
   DTIM_latest_vadwnd=${DTIM_latest_vadwnd:-"+0.50"}

# Time window is -1.50 to +1.50 hours for NON-EUMETSAT & NON-GOES SATWND
#  (default)


else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

   if [ $cyc -eq 00 -o $cyc -eq 12 ]; then
      def_time_window_2=1.5  # default time window for dump 2 is -1.5 to +1.5
                             # hours for 00 or 12z
   else
      def_time_window_2=2.5  # default time window for dump 2 is -2.5 to +2.5
                             # hours for all other cycles
   fi

# Time window is -1.00 to +1.00 hours for VADWND
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_vadwnd=${DTIM_earliest_vadwnd:-"-1.00"}
   DTIM_latest_vadwnd=${DTIM_latest_vadwnd:-"+1.00"}

# Time window is -1.50 to +1.50 hours for NON-EUMETSAT & NON-GOES SATWND at 00
#  or 12z (default)

# Time window is -2.50 to +2.50 hours for NON-EUMETSAT & NON-GOES SATWND at
#  all other cycles (default)

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_2} 1 vadwnd \
 satwnd 
error2=$?
echo "$error2" > $DATA/error2

set +x
echo "********************************************************************"
echo Script thread_2
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/2.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_3; chmod +x thread_3
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_3
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=3

#========================================================================
# Dump # 3 : PROFLR, RASSDA, SFCSHP, ADPSFC, ASCATT, TIDEG, SNOCVR
#              (3)     (1)    (11)     (3)     (1)    (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 21
#
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of -0.50 to +0.50 hours in
#       rap_p and -2.00 to +2.00 hours in rap and rap_e)
#
#========================================================================

# Skip Japanese profiler reports in PROFLR (not in domain)

export SKIP_002013=YES

# Skip mobile synoptic reports in ADPSFC (not in domain)

export SKIP_000002=YES


def_time_window_3=0.5 # default time window for dump 3 is -0.5 to +0.5 hours

# Time window -1.50 to +1.50 hours for PROFLR for full and partial cycle runs
#  (note: time window increased over +/- 0.5 hr standard to improve
#         PREPOBS_PROFCQC performance, it will be winnowed back down to
#         -0.50 to +0.50 hours in output from PREPOBS_PROFCQC)
DTIM_earliest_proflr=${DTIM_earliest_proflr:-"-1.50"}
DTIM_latest_proflr=${DTIM_latest_proflr:-"+1.50"}

# Time window -0.50 to +0.50 hours for RASSDA, SFCSHP, ADPSFC, TIDEG for full
#  and partial cycle runs (default)

if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

# Time window is -0.50 to +0.50 hours for ASCATT (default)

   DTIM_earliest_snocvr=${DTIM_earliest_snocvr:-"-0.50"}
   DTIM_latest_snocvr=${DTIM_latest_snocvr:-"+0.50"}
   # dummy=idum  # dummy entry since nothing in this if-block

else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

# Time window is -2.00 to +2.00 hours for ASCATT
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_ascatt=${DTIM_earliest_ascatt:-"-2.00"}
   DTIM_latest_ascatt=${DTIM_latest_ascatt:-"+2.00"}
   DTIM_earliest_snocvr=${DTIM_earliest_snocvr:-"-2.00"}
   DTIM_latest_snocvr=${DTIM_latest_snocvr:-"+2.00"}

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_3} 1 proflr \
 rassda sfcshp adpsfc ascatt tideg snocvr
error3=$?
echo "$error3" > $DATA/error3

set +x
echo "********************************************************************"
echo Script thread_3
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/3.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_4; chmod +x thread_4
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_4
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=4

#============================================================================
# Dump # 4 : MSONET, GPSIPW -- TOTAL NUMBER OF SUBTYPES = 31
#             (30)     (1)
#============================================================================

def_time_window_4=0.5 # default time window for dump 4 is -0.5 to +0.5 hours

if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   if [ $cyc -ne 08 -a $cyc -ne 20 ]; then

# Time window -0.05 to +0.05 hours (-3 to +3 min) for GPSIPW at all cycles
#   except 08 and 20z

      DTIM_earliest_gpsipw=${DTIM_earliest_gpsipw:-"-0.05"}
      DTIM_latest_gpsipw=${DTIM_latest_gpsipw:-"+0.05"}

   else

# Time window -0.55 to -0.45 hours (-33 to -27 min) for GPSIPW for 08 or 20z
#  cycle

      DTIM_earliest_gpsipw=${DTIM_earliest_gpsipw:-"-0.55"}
      DTIM_latest_gpsipw=${DTIM_latest_gpsipw:-"-0.45"}

   fi

else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

# Time window -1.05 to -0.95 hours (-63 to -57 min) for GPSIPW

   DTIM_earliest_gpsipw=${DTIM_earliest_gpsipw:-"-1.05"}
   DTIM_latest_gpsipw=${DTIM_latest_gpsipw:-"-0.95"}

fi
#  {note: new Ground Based GPS-IPW/ZTD (from U.S.-ENI and foreign GNSS
#         providers) is currently limited to obs closest to cycle-time that
#         result in a U.S.-ENI dump count that is not too much larger than that
#         from the previous U.S. (only) GSD-feed, since the ENI reports are
#         available every 5 min while the GSD reports were available only every
#         30 min. Also accounts for an approximate 80-min latency present in
#         the U.S.-ENI reports.}


# Time window -0.50 to +0.50 hours for MSONET for full and partial cycle runs
#  (default)


$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_4} 1 msonet gpsipw
error4=$?
echo "$error4" > $DATA/error4

set +x
echo "********************************************************************"
echo Script thread_4
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/4.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_5; chmod +x thread_5
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_5
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=5

#===========================================================================
# Dump # 5 : AIRCFT, AIRCAR, GOESND -- TOTAL NUMBER OF SUBTYPES = 12
#              (8)     (2)     (2)
#===========================================================================

export LALO=0  # GLOBAL dumps here (AIRCFT and AIRCAR dumped globally to
               # improve PREPOBS_PREPACQC track-check performance; GOESND
               # dumped globally to allow job to run much quicker w/o the need
               # for geographical filtering (all GOES reports are in expanded
               # NAM domain anyway)

def_time_window_5=3.25 # default time window for dump 5 is -3.25 to +3.25 hours


# Time window -3.25 to +3.25 hours for AIRCFT and AIRCAR for full and partial
#  cycle runs (default)
#  {note: time window increased to improve PREPOBS_PREPACQC track-check
#         performance; time window will be winnowed down to +/- 1.00 hours in
#         output from PREPOBS_PREPACQC (for full and partial cycle runs), and
#         geographical domain will be limited to north of 20S latitude)


# Time window -1.25 to -0.01 hours for GOESND cloud (only) for full and partial
#  cycle runs
#  (note: going back -1.25 hours is necessary to gather a complete set of
#         GOES-E information, while the cutting off at -0.01 hours avoids a
#         duplication of GOES-W data from the next input dataset time)
DTIM_earliest_003002=${DTIM_earliest_003002:-"-1.25"}
DTIM_latest_003002=${DTIM_latest_003002:-"-0.01"}

if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

# Time window is -0.50 to +0.50 hours for GOESND soundings/radiances (only)
   DTIM_earliest_003003=${DTIM_earliest_003003:-"-0.50"}
   DTIM_latest_003003=${DTIM_latest_003003:-"+0.50"}

else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

# Time window is -1.00 to +1.00 hours for GOESND soundings/radiances (only)
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_003003=${DTIM_earliest_003003:-"-1.00"}
   DTIM_latest_003003=${DTIM_latest_003003:-"+1.00"}

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_5} 1 aircft \
 aircar
error5=$?
echo "$error5" > $DATA/error5

set +x
echo "********************************************************************"
echo Script thread_5
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/5.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_6; chmod +x thread_6
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_6
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=6

#===========================================================================
# Dump # 6 : NEXRAD -- TOTAL NUMBER OF SUBTYPES = 4
#              (4)
#===========================================================================

export LALO=0  # GLOBAL dumps here (NEXRAD dumped globally to allow job to run
               # much quicker w/o the need for geographical filtering (all
               # radar reports are over CONUS anyway)

def_time_window_6=0.5 # default time window for dump 6 is -0.5 to +0.5 hours

# Time window -0.50 to +0.49 hours for NEXRAD for full and partial cycle runs
DTIM_latest_nexrad=${DTIM_latest_nexrad:-"+0.49"}         # earliest is default

# NEXRAD tanks are hourly
# Process only those hourly tanks w/i requested dump center cycle time window

SKIP_006010=YES # radial wind  00Z
SKIP_006011=YES # radial wind  01Z
SKIP_006012=YES # radial wind  02Z
SKIP_006013=YES # radial wind  03Z
SKIP_006014=YES # radial wind  04Z
SKIP_006015=YES # radial wind  05Z
SKIP_006016=YES # radial wind  06Z
SKIP_006017=YES # radial wind  07Z
SKIP_006018=YES # radial wind  08Z
SKIP_006019=YES # radial wind  09Z
SKIP_006020=YES # radial wind  10Z
SKIP_006021=YES # radial wind  11Z
SKIP_006022=YES # radial wind  12Z
SKIP_006023=YES # radial wind  13Z
SKIP_006024=YES # radial wind  14Z
SKIP_006025=YES # radial wind  15Z
SKIP_006026=YES # radial wind  16Z
SKIP_006027=YES # radial wind  17Z
SKIP_006028=YES # radial wind  18Z
SKIP_006029=YES # radial wind  19Z
SKIP_006030=YES # radial wind  20Z
SKIP_006031=YES # radial wind  21Z
SKIP_006032=YES # radial wind  22Z
SKIP_006033=YES # radial wind  23Z

SKIP_006040=YES # reflectivity 00Z
SKIP_006041=YES # reflectivity 01Z
SKIP_006042=YES # reflectivity 02Z
SKIP_006043=YES # reflectivity 03Z
SKIP_006044=YES # reflectivity 04Z
SKIP_006045=YES # reflectivity 05Z
SKIP_006046=YES # reflectivity 06Z
SKIP_006047=YES # reflectivity 07Z
SKIP_006048=YES # reflectivity 08Z
SKIP_006049=YES # reflectivity 09Z
SKIP_006050=YES # reflectivity 10Z
SKIP_006051=YES # reflectivity 11Z
SKIP_006052=YES # reflectivity 12Z
SKIP_006053=YES # reflectivity 13Z
SKIP_006054=YES # reflectivity 14Z
SKIP_006055=YES # reflectivity 15Z
SKIP_006056=YES # reflectivity 16Z
SKIP_006057=YES # reflectivity 17Z
SKIP_006058=YES # reflectivity 18Z
SKIP_006059=YES # reflectivity 19Z
SKIP_006060=YES # reflectivity 20Z
SKIP_006061=YES # reflectivity 21Z
SKIP_006062=YES # reflectivity 22Z
SKIP_006063=YES # reflectivity 23Z

if [ $cyc -eq 00 ]; then   # (23.50 - 00.49 Z)
   unset SKIP_006033 # radial wind  23Z
   unset SKIP_006010 # radial wind  00Z
###unset SKIP_006063 # reflectivity 23Z
###unset SKIP_006040 # reflectivity 00Z
elif [ $cyc -eq 01 ]; then   # (00.50 - 01.49 Z)
   unset SKIP_006010 # radial wind  00Z
   unset SKIP_006011 # radial wind  01Z
###unset SKIP_006040 # reflectivity 00Z
###unset SKIP_006041 # reflectivity 01Z
elif [ $cyc -eq 02 ]; then   # (01.50 - 02.49 Z)
   unset SKIP_006011 # radial wind  01Z
   unset SKIP_006012 # radial wind  02Z
###unset SKIP_006041 # reflectivity 01Z
###unset SKIP_006042 # reflectivity 02Z
elif [ $cyc -eq 03 ]; then   # (02.50 - 03.49 Z)
   unset SKIP_006012 # radial wind  02Z
   unset SKIP_006013 # radial wind  03Z
###unset SKIP_006042 # reflectivity 02Z
###unset SKIP_006043 # reflectivity 03Z
elif [ $cyc -eq 04 ]; then   # (03.50 - 04.49 Z)
   unset SKIP_006013 # radial wind  03Z
   unset SKIP_006014 # radial wind  04Z
###unset SKIP_006043 # reflectivity 03Z
###unset SKIP_006044 # reflectivity 04Z
elif [ $cyc -eq 05 ]; then   # (04.50 - 05.49 Z)
   unset SKIP_006014 # radial wind  04Z
   unset SKIP_006015 # radial wind  05Z
###unset SKIP_006044 # reflectivity 04Z
###unset SKIP_006045 # reflectivity 05Z
elif [ $cyc -eq 06 ]; then   # (05.50 - 06.49 Z)
   unset SKIP_006015 # radial wind  05Z
   unset SKIP_006016 # radial wind  06Z
###unset SKIP_006045 # reflectivity 05Z
###unset SKIP_006046 # reflectivity 06Z
elif [ $cyc -eq 07 ]; then   # (06.50 - 07.49 Z)
   unset SKIP_006016 # radial wind  06Z
   unset SKIP_006017 # radial wind  07Z
###unset SKIP_006046 # reflectivity 06Z
###unset SKIP_006047 # reflectivity 07Z
elif [ $cyc -eq 08 ]; then   # (07.50 - 08.49 Z)
   unset SKIP_006017 # radial wind  07Z
   unset SKIP_006018 # radial wind  08Z
###unset SKIP_006047 # reflectivity 07Z
###unset SKIP_006048 # reflectivity 08Z
elif [ $cyc -eq 09 ]; then   # (08.50 - 09.49 Z)
   unset SKIP_006018 # radial wind  08Z
   unset SKIP_006019 # radial wind  09Z
###unset SKIP_006048 # reflectivity 08Z
###unset SKIP_006049 # reflectivity 09Z
elif [ $cyc -eq 10 ]; then   # (09.50 - 10.49 Z)
   unset SKIP_006019 # radial wind  09Z
   unset SKIP_006020 # radial wind  10Z
###unset SKIP_006049 # reflectivity 09Z
###unset SKIP_006050 # reflectivity 10Z
elif [ $cyc -eq 11 ]; then   # (10.50 - 11.49 Z)
   unset SKIP_006020 # radial wind  10Z
   unset SKIP_006021 # radial wind  11Z
###unset SKIP_006050 # reflectivity 10Z
###unset SKIP_006051 # reflectivity 11Z
elif [ $cyc -eq 12 ]; then   # (11.50 - 12.49 Z)
   unset SKIP_006021 # radial wind  11Z
   unset SKIP_006022 # radial wind  12Z
###unset SKIP_006051 # reflectivity 11Z
###unset SKIP_006052 # reflectivity 12Z
elif [ $cyc -eq 13 ]; then   # (12.50 - 13.49 Z)
   unset SKIP_006022 # radial wind  12Z
   unset SKIP_006023 # radial wind  13Z
###unset SKIP_006052 # reflectivity 12Z
###unset SKIP_006053 # reflectivity 13Z
elif [ $cyc -eq 14 ]; then   # (13.50 - 14.49 Z)
   unset SKIP_006023 # radial wind  13Z
   unset SKIP_006024 # radial wind  14Z
###unset SKIP_006053 # reflectivity 13Z
###unset SKIP_006054 # reflectivity 14Z
elif [ $cyc -eq 15 ]; then   # (14.50 - 15.49 Z)
   unset SKIP_006024 # radial wind  14Z
   unset SKIP_006025 # radial wind  15Z
###unset SKIP_006054 # reflectivity 14Z
###unset SKIP_006055 # reflectivity 15Z
elif [ $cyc -eq 16 ]; then   # (15.50 - 16.49 Z)
   unset SKIP_006025 # radial wind  15Z
   unset SKIP_006026 # radial wind  16Z
###unset SKIP_006055 # reflectivity 15Z
###unset SKIP_006056 # reflectivity 16Z
elif [ $cyc -eq 17 ]; then   # (16.50 - 17.49 Z)
   unset SKIP_006026 # radial wind  16Z
   unset SKIP_006027 # radial wind  17Z
###unset SKIP_006056 # reflectivity 16Z
###unset SKIP_006057 # reflectivity 17Z
elif [ $cyc -eq 18 ]; then   # (17.50 - 18.49 Z)
   unset SKIP_006027 # radial wind  17Z
   unset SKIP_006028 # radial wind  18Z
###unset SKIP_006057 # reflectivity 17Z
###unset SKIP_006058 # reflectivity 18Z
elif [ $cyc -eq 19 ]; then   # (18.50 - 19.49 Z)
   unset SKIP_006028 # radial wind  18Z
   unset SKIP_006029 # radial wind  19Z
###unset SKIP_006058 # reflectivity 18Z
###unset SKIP_006059 # reflectivity 19Z
elif [ $cyc -eq 20 ]; then   # (19.50 - 20.49 Z)
   unset SKIP_006029 # radial wind  19Z
   unset SKIP_006030 # radial wind  20Z
###unset SKIP_006059 # reflectivity 19Z
###unset SKIP_006060 # reflectivity 20Z
elif [ $cyc -eq 21 ]; then   # (20.50 - 21.49 Z)
   unset SKIP_006030 # radial wind  20Z
   unset SKIP_006031 # radial wind  21Z
###unset SKIP_006060 # reflectivity 20Z
###unset SKIP_006061 # reflectivity 21Z
elif [ $cyc -eq 22 ]; then   # (21.50 - 22.49 Z)
   unset SKIP_006031 # radial wind  21Z
   unset SKIP_006032 # radial wind  22Z
###unset SKIP_006061 # reflectivity 21Z
###unset SKIP_006062 # reflectivity 22Z
elif [ $cyc -eq 23 ]; then   # (22.50 - 23.49 Z)
   unset SKIP_006032 # radial wind  22Z
   unset SKIP_006033 # radial wind  23Z
###unset SKIP_006062 # reflectivity 22Z
###unset SKIP_006063 # reflectivity 23Z
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_6} 1 nexrad
error6=$?
echo "$error6" > $DATA/error6

set +x
echo "********************************************************************"
echo Script thread_6
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/6.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_7; chmod +x thread_7
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_7
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=7

#==========================================================================
# Dump # 7 : AIRSEV, 1BHRS4, ESHRS3, LGYCLD, SSMISU, OSBUV8, CRSFDB,
#              (1)     (2)     (1)     (1)     (1)     (1)     (1)
#            SAPHIR, CRISF4, GMI1CR
#              (1)     (1)   (1)
#             TOTAL NUMBER OF SUBTYPES = 11
#=========================================================================
 
# Time window -0.50 to +0.50 hours for LGYCLD for all cycle runs
DTIM_earliest_lgycld=${DTIM_earliest_lgycld:-"-0.50"}
DTIM_latest_lgycld=${DTIM_latest_lgycld:-"+0.50"}

if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   def_time_window_7=1.0 # default time window for dump 7 is -1.0 to +1.0 hours

# Time window is -1.00 to +0.99 hours for 1BHRS4
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_1bhrs4=${DTIM_latest_1bhrs4:-"+0.99"}      # earliest is default

# Time window is -1.00 to +0.99 hours for AIRSEV
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_airsev=${DTIM_latest_airsev:-"+0.99"}      # earliest is default

# Time window is -1.00 to +0.99 hours for CRSFDB, CRISF4
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_crsfdb=${DTIM_earliest_crsfdb:-"-1.00"}
   DTIM_latest_crsfdb=${DTIM_latest_crsfdb:-"+0.99"}
   DTIM_earliest_crisf4=${DTIM_earliest_crisf4:-"-1.00"}
   DTIM_latest_crisf4=${DTIM_latest_crisf4:-"+0.99"}

# Time window is -0.50 to +0.49 hours for ESHRS3
   DTIM_earliest_eshrs3=${DTIM_earliest_eshrs3:-"-0.50"}
   DTIM_latest_eshrs3=${DTIM_latest_eshrs3:-"+0.49"}

# Time window is -1.00 to +0.99 hours for SSMISU, OSBUV8, SAPHIR
   DTIM_earliest_ssmisu=${DTIM_earliest_ssmisu:-"-1.00"}
   DTIM_latest_ssmisu=${DTIM_latest_ssmisu:-"+0.99"}
   DTIM_earliest_osbuv8=${DTIM_earliest_osbuv8:-"-1.00"}
   DTIM_latest_osbuv8=${DTIM_latest_osbuv8:-"+0.99"}
   DTIM_earliest_saphir=${DTIM_earliest_saphir:-"-1.00"}
   DTIM_latest_saphir=${DTIM_latest_saphir:-"+0.99"}

# Time window is guesstimated as -1.00 to +0.99 hours for rap_p GMI1CR
   DTIM_earliest_gmi1cr=${DTIM_earliest_gmi1cr:-"-1.00"}
   DTIM_latest_gmi1cr=${DTIM_latest_gmi1cr:-"+0.99"}

else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

   def_time_window_7=3.0 # default time window for dump 7 is -3.0 to +3.0 hours

# Time window is -3.00 to +2.99 hours for 1BHRS4
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_1bhrs4=${DTIM_latest_1bhrs4:-"+2.99"}      # earliest is default

# Time window is -3.00 to +2.99 hours for AIRSEV
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_latest_airsev=${DTIM_latest_airsev:-"+2.99"}      # earliest is default

# Time window is -2.00 to +1.99 hours for CRSFDB, CRISF4
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_crsfdb=${DTIM_earliest_crsfdb:-"-2.00"}
   DTIM_latest_crsfdb=${DTIM_latest_crsfdb:-"+1.99"}
   DTIM_earliest_crisf4=${DTIM_earliest_crisf4:-"-2.00"}
   DTIM_latest_crisf4=${DTIM_latest_crisf4:-"+1.99"}

# Time window is -1.00 to +1.00 hours for ESHRS3
#  (note: time window increased over +/- 0.5 hr standard to get more data)
   DTIM_earliest_eshrs3=${DTIM_earliest_eshrs3:-"-1.00"}
   DTIM_latest_eshrs3=${DTIM_latest_eshrs3:-"+1.00"}

# Time window is -2.00 to +1.99 hours for SSMISU, OSBUV8
   DTIM_earliest_ssmisu=${DTIM_earliest_ssmisu:-"-2.00"}
   DTIM_latest_ssmisu=${DTIM_latest_ssmisu:-"+1.99"}
   DTIM_earliest_osbuv8=${DTIM_earliest_osbuv8:-"-2.00"}
   DTIM_latest_osbuv8=${DTIM_latest_osbuv8:-"+0.99"}

# Time window is -3.00 to +2.99 hours for SAPHIR
   DTIM_earliest_saphir=${DTIM_earliest_saphir:-"-3.00"}
   DTIM_latest_saphir=${DTIM_latest_saphir:-"+2.99"}

# Time window is guesstimated as -3.00 to +2.99 hours for GMI1CR
   DTIM_earliest_gmi1cr=${DTIM_earliest_gmi1cr:-"-3.00"}
   DTIM_latest_gmi1cr=${DTIM_latest_gmi1cr:-"+2.99"}

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_7} 1 1bhrs4 \
 airsev eshrs3 lgycld ssmisu osbuv8 crsfdb saphir crisf4 gmi1cr
error7=$?
echo "$error7" > $DATA/error7

set +x
echo "********************************************************************"
echo Script thread_7
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/7.out 2>&1
EOF
set -x


set +x
#----------------------------------------------------------------
cat<<\EOF>thread_8; chmod +x thread_8
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_8
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=8

#===============================================================================
# Dump # 8 : GSRASR,[ GSRCSR - moved to own group ] 
#              (1)  [  (1)]
#             TOTAL NUMBER OF SUBTYPES = 1 [2]
#===============================================================================
 
if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   def_time_window_8=1.0 # default time window for dump 8 is -1.0 to +1.0 hours

# Time window is -1.00 to +0.99 hours for GSRASR, GSRCSR
  DTIM_earliest_gsrasr=${DTIM_earliest_gsrasr:-"-1.00"}
  DTIM_latest_gsrasr=${DTIM_latest_gsrasr:-"+0.99"}
 
else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

   def_time_window_8=3.0 # default time window for dump 8 is -3.0 to +3.0 hours

# Time window is -2.00 to +1.99 hours for GSRASR, GSRCSR
   DTIM_earliest_gsrasr=${DTIM_earliest_gsrasr:-"-2.00"}
   DTIM_latest_gsrasr=${DTIM_latest_gsrasr:-"+1.99"}

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_8} 1 gsrasr
error8=$?
echo "$error8" > $DATA/error8

set +x
echo "********************************************************************"
echo Script thread_8
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/8.out 2>&1
EOF
set -x


set +x
#----------------------------------------------------------------
cat<<\EOF>thread_9; chmod +x thread_9
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_9
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=9

#==========================================================================
# Dump # 9 : LGHTNG + ADPUPA
#             TOTAL NUMBER OF SUBTYPES = 1 + 1
#=========================================================================

# Time window -1.00 to +0.50 hours for LGHTNG for all cycle runs
DTIM_earliest_lghtng=${DTIM_earliest_lghtng:-"-1.00"}
DTIM_latest_lghtng=${DTIM_latest_lghtng:-"+0.50"}

# Time window -1.00 to +1.00 hours for ADPUPA/UPRAIR w/ full & partial cycle runs
#  (note: time window increased over +/- 0.5 hr standard to get more data)

DTIM_earliest_adpupa=${DTIM_earliest_adpupa:-"-1.00"}
DTIM_latest_adpupa=${DTIM_latest_adpupa:-"+1.00"}

if [ "$RUN" = 'rap_p' ]; then
#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------
   def_time_window_9=1.0 # default time window for dump 9 is -1.0 to +1.0 hours
else
#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------
   def_time_window_9=3.0 # default time window for dump 9 is -3.0 to +3.0 hours
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_9} 1 lghtng adpupa
error9=$?
echo "$error9" > $DATA/error9

set +x
echo "********************************************************************"
echo Script thread_9
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/9.out 2>&1
EOF
set -x

### NEW GROUP MSONET IG #10
set +x
#----------------------------------------------------------------
cat<<\EOF>thread_10; chmod +x thread_10
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_10
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=10

#============================================================================
# Dump # 10 : MSONE1 -- TOTAL NUMBER OF SUBTYPES = 1
#              (1)
#============================================================================

def_time_window_10=0.5 # default time window for dump 10 is -0.5 to +0.5 hours

# Time window -0.50 to +0.50 hours for MSONET for full and partial cycle runs
#  (default)

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_10} 1 msone1
error10=$?
echo "$error10" > $DATA/error10

set +x
echo "********************************************************************"
echo Script thread_10
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/10.out 2>&1
EOF
set -x
### NEW GROUP MSONET IG end #10

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_11; chmod +x thread_11
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_11
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

# UPRAIR need to start early
#sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=11

#==========================================================================
# Dump # 11 :  ADPUPA minus UPRAIR
#               (6)   minus  (5)
#            -- TOTAL NUMBER OF SUBTYPES = 11-5
#==========================================================================
#
if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   def_time_window_11=1.5 # default time window for dump 11 is -1.5 to +1.5 hours

else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

   if [ $cyc -eq 00 -o $cyc -eq 12 ]; then
      def_time_window_11=1.5  # default time window for dump 11 is -1.5 to +1.5
                              # hours for 00 or 12z
   else
      def_time_window_11=2.5  # default time window for dump 11 is -2.5 to +2.5
                              # hours for all other cycles
   fi

fi

# Time window -1.00 to +1.00 hours for ADPUPA/UPRAIR w/ full & partial cycle runs
#  (note: time window increased over +/- 0.5 hr standard to get more data)

DTIM_earliest_uprair=${DTIM_earliest_uprair:-"-1.00"}
DTIM_latest_uprair=${DTIM_latest_uprair:-"+1.00"}

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_11} 1 uprair
error11=$?
echo "$error11" > $DATA/error11

set +x
echo "********************************************************************"
echo Script thread_11
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/11.out 2>&1
EOF
set -x


set +x
#----------------------------------------------------------------
cat<<\EOF>thread_12; chmod +x thread_12
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_12
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 2min early start of jrap_dump in cron
export STATUS=NO
export DUMP_NUMBER=12

#===============================================================================
# Dump # 12 :  GSRCSR
#              (1)
#             TOTAL NUMBER OF SUBTYPES = 1
#===============================================================================

if [ "$RUN" = 'rap_p' ]; then

#  ===> For RUN = rap_p -- partial cycle runs
#       -------------------------------------

   def_time_window_12=1.0 # default time window for dump 12 is -1.0 to +1.0 hours

# Time window is -1.00 to +0.99 hours for GSRASR, GSRCSR
  DTIM_earliest_gsrcsr=${DTIM_earliest_gsrcsr:-"-1.00"}
  DTIM_latest_gsrcsr=${DTIM_latest_gsrcsr:-"+0.99"}

else

#  ===> For RUN = rap, rap_e -- full cycle runs (including early at 00/12z)
#       -------------------------------------------------------------------

   def_time_window_12=3.0 # default time window for dump 12 is -3.0 to +3.0 hours

# Time window is -2.00 to +1.99 hours for GSRASR, GSRCSR
   DTIM_earliest_gsrcsr=${DTIM_earliest_gsrcsr:-"-2.00"}
   DTIM_latest_gsrcsr=${DTIM_latest_gsrcsr:-"+1.99"}

fi

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_12} 1 gsrcsr
error12=$?
echo "$error12" > $DATA/error12

set +x
echo "********************************************************************"
echo Script thread_12
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/12.out 2>&1
EOF
set -x


#----------------------------------------------------------------
# Now launch the threads

# determine local system name and type if available
# -------------------------------------------------
SITE=${SITE:-""}

set +u
launcher=${launcher:-"cfp"}  # if not "cfp", threads will run serially.

if [ "$launcher" = cfp ]; then
   > $DATA/poe.cmdfile

# To better take advantage of cfp, execute the longer running commands first.
# Some reordering was done here based on recent sample runtimes.
   [ $DUMP_group11 = YES ]  &&  echo ./thread_11 >> $DATA/poe.cmdfile
   [ $DUMP_group9 = YES ]  &&  echo ./thread_9 >> $DATA/poe.cmdfile  # lghtng 1st
   [ $DUMP_group7 = YES ]  &&  echo ./thread_7 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group1 = YES ]  &&  echo ./thread_1 >> $DATA/poe.cmdfile
   [ $DUMP_group4 = YES ]  &&  echo ./thread_4 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group8 = YES ]  &&  echo ./thread_8 >> $DATA/poe.cmdfile  # new
   [ $DUMP_group6 = YES ]  &&  echo ./thread_6 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group5 = YES ]  &&  echo ./thread_5 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group2 = YES ]  &&  echo ./thread_2 >> $DATA/poe.cmdfile
   [ $DUMP_group3 = YES ]  &&  echo ./thread_3 >> $DATA/poe.cmdfile
   [ $DUMP_group10 = YES ]  &&  echo ./thread_10 >> $DATA/poe.cmdfile
   #[ $DUMP_group11 = YES ]  &&  echo ./thread_11 >> $DATA/poe.cmdfile
   [ $DUMP_group12 = YES ]  &&  echo ./thread_12 >> $DATA/poe.cmdfile 

   if [ -s $DATA/poe.cmdfile ]; then
      export MP_CSS_INTERRUPT=yes  # ??
      launcher_DUMP=${launcher_DUMP:-mpiexec}
      #$launcher_DUMP -np 3 --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      NPROCS=${NPROCS:-13}
      $launcher_DUMP -np $NPROCS --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      errpoe=$?
      if [ $errpoe -ne 0 ]; then
         $DATA/err_exit "***FATAL: EXIT STATUS $errpoe RUNNING POE COMMAND FILE"
      fi
   else
      echo
      echo "==> There are no tasks in POE Command File - POE not run"
      echo
   fi
else
      echo "Runing threads serially"
      [ $DUMP_group1 = YES ]  &&  ./thread_1
      [ $DUMP_group2 = YES ]  &&  ./thread_2
      [ $DUMP_group3 = YES ]  &&  ./thread_3
      [ $DUMP_group4 = YES ]  &&  ./thread_4
      [ $DUMP_group5 = YES ]  &&  ./thread_5
      [ $DUMP_group6 = YES ]  &&  ./thread_6
      [ $DUMP_group7 = YES ]  &&  ./thread_7
      [ $DUMP_group8 = YES ]  &&  ./thread_8
      [ $DUMP_group9 = YES ]  &&  ./thread_9
      [ $DUMP_group10 = YES ]  &&  ./thread_10
      [ $DUMP_group11 = YES ]  &&  ./thread_11
      [ $DUMP_group12 = YES ]  &&  ./thread_12
fi

cat $DATA/1.out $DATA/2.out $DATA/3.out $DATA/4.out $DATA/5.out $DATA/6.out $DATA/7.out $DATA/8.out $DATA/9.out $DATA/10.out $DATA/11.out $DATA/12.out

set +x
echo " "
echo " "
set -x

[ -s $DATA/error1 ] && err1=`cat $DATA/error1`
[ -s $DATA/error2 ] && err2=`cat $DATA/error2`
[ -s $DATA/error3 ] && err3=`cat $DATA/error3`
[ -s $DATA/error4 ] && err4=`cat $DATA/error4`
[ -s $DATA/error5 ] && err5=`cat $DATA/error5`
[ -s $DATA/error6 ] && err6=`cat $DATA/error6`
[ -s $DATA/error7 ] && err7=`cat $DATA/error7`
[ -s $DATA/error8 ] && err8=`cat $DATA/error8`
[ -s $DATA/error9 ] && err9=`cat $DATA/error9`
[ -s $DATA/error10 ] && err10=`cat $DATA/error10`
[ -s $DATA/error11 ] && err11=`cat $DATA/error11`
[ -s $DATA/error12 ] && err12=`cat $DATA/error12`

#===============================================================================

export STATUS=YES
export DUMP_NUMBER=13
$ushscript_dump/bufr_dump_obs.sh $dumptime 3.00 1 null

#  endif loop $PROCESS_DUMP
fi

echo " " >> $pgmout
echo "##################################################################\
####################"  >> $pgmout
echo " " >> $pgmout

#====================================================
#====================================================

if [ "$PROCESS_DUMP" = 'YES' ]; then

   if [ "$err1" -gt '5' -o "$err2" -gt '5' -o "$err3" -gt '5' -o \
        "$err4" -gt '5' -o "$err5" -gt '5' -o "$err6" -gt '5' -o \
        "$err7" -gt '5' -o "$err8" -gt '5' -o "$err9" -gt '5' -o \
	"$err10" -gt '5' -o "$err11" -gt '5' -o "$err12" -gt '5' ]; then
      for n in $err1 $err2 $err3 $err4 $err5 $err6 $err7 $err8 $err9 $err10 $err11 $err12
      do
         if [ "$n" -gt '5' ]; then
            if [ "$n" -ne '11' -a "$n" -ne '22' ]; then

## fatal error in dumping of BUFR obs. files

               set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9, $err10, $err11, $err12"
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
               set -x
               $DATA/err_exit
               exit 9
            fi
         fi
      done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

      set +x
      echo
      echo " ###################################################### "
      echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9, $err10, $err11, $err12"
      echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
      echo " ###################################################### "
      echo
      set -x
   fi

#  endif loop $PROCESS_DUMP
fi

#  concatenate msonet and msone1, b/c prepobs only wants one file
cat ${COMSP}msone1.tm00.bufr_d >> ${COMSP}msonet.tm00.bufr_d


grep -q "004.004 in data group aircar for .............-.........\
.... HAS      0 REPORTS" ${COMSP}status.$tmmark.bufr_d
err_grep1=$?
grep -q "004.007 in data group aircar for .............-.........\
.... HAS      0 REPORTS" ${COMSP}status.$tmmark.bufr_d
err_grep2=$?
if [ $err_grep1 -eq 0 -a $err_grep2 -eq 0 ]; then
   msg="***WARNING: NO ACARS data from either ARINC (004.004) or AFWA \
(004.007), run assimilation without any ACARS data"
   $DATA/postmsg "$jlogfile" "$msg"
fi


if [ $SENDDBN = YES ]; then
   if [ -s ${COMSP}1bamua.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_1bamua $job ${COMSP}1bamua.tm00.bufr_d
   fi
   if [ -s ${COMSP}1bhrs4.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_1bhrs4 $job ${COMSP}1bhrs4.tm00.bufr_d
   fi
   if [ -s ${COMSP}1bmhs.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_1bmhs $job ${COMSP}1bmhs.tm00.bufr_d
   fi
   if [ -s ${COMSP}airsev.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_airsev $job ${COMSP}airsev.tm00.bufr_d
   fi
   if [ -s ${COMSP}amsr2.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_amsr2 $job ${COMSP}amsr2.tm00.bufr_d
   fi
   if [ -s ${COMSP}ascatt.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_ascatt $job ${COMSP}ascatt.tm00.bufr_d
   fi
   if [ -s ${COMSP}ascatw.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_ascatw $job ${COMSP}ascatw.tm00.bufr_d
   fi
   if [ -s ${COMSP}atms.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_atms $job ${COMSP}atms.tm00.bufr_d
   fi
   if [ -s ${COMSP}atmsdb.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_atmsdb $job ${COMSP}atmsdb.tm00.bufr_d
   fi
   if [ -s ${COMSP}crsfdb.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_crsfdb $job ${COMSP}crsfdb.tm00.bufr_d
   fi
   if [ -s ${COMSP}crisf4.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_crisf4 $job ${COMSP}crisf4.tm00.bufr_d
   fi
   if [ -s ${COMSP}esamua.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_esamua $job ${COMSP}esamua.tm00.bufr_d
   fi
   if [ -s ${COMSP}esatms.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_esatms $job ${COMSP}esatms.tm00.bufr_d
   fi
   if [ -s ${COMSP}eshrs3.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_eshrs3 $job ${COMSP}eshrs3.tm00.bufr_d
   fi
   if [ -s ${COMSP}esiasi.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_esiasi $job ${COMSP}esiasi.tm00.bufr_d
   fi
   if [ -s ${COMSP}esmhs.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_esmhs $job ${COMSP}esmhs.tm00.bufr_d
   fi
   if [ -s ${COMSP}gpsipw.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_gpsipw $job ${COMSP}gpsipw.tm00.bufr_d
   fi
   if [ -s ${COMSP}gsrasr.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_gsrasr $job ${COMSP}gsrasr.tm00.bufr_d
   fi
   if [ -s ${COMSP}gsrcsr.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_gsrcsr $job ${COMSP}gsrcsr.tm00.bufr_d
   fi
   if [ -s ${COMSP}iasidb.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_iasidb $job ${COMSP}iasidb.tm00.bufr_d
   fi
   if [ -s ${COMSP}lghtng.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_lghtng $job ${COMSP}lghtng.tm00.bufr_d
   fi
   if [ -s ${COMSP}lgycld.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_lgycld $job ${COMSP}lgycld.tm00.bufr_d
   fi
   if [ -s ${COMSP}mtiasi.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_mtiasi $job ${COMSP}mtiasi.tm00.bufr_d
   fi
   if [ -s ${COMSP}nexrad.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_nexrad $job ${COMSP}nexrad.tm00.bufr_d
   fi
   if [ -s ${COMSP}osbuv8.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_osbuv8 $job ${COMSP}osbuv8.tm00.bufr_d
   fi
   if [ -s ${COMSP}rassda.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_rassda $job ${COMSP}rassda.tm00.bufr_d
   fi
   if [ -s ${COMSP}saphir.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_saphir $job ${COMSP}saphir.tm00.bufr_d
   fi
   if [ -s ${COMSP}satwnd.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_satwnd $job ${COMSP}satwnd.tm00.bufr_d
   fi
   if [ -s ${COMSP}sevasr.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_sevasr $job ${COMSP}sevasr.tm00.bufr_d
   fi
   if [ -s ${COMSP}sevcsr.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_sevcsr $job ${COMSP}sevcsr.tm00.bufr_d
   fi
   if [ -s ${COMSP}ssmisu.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_ssmisu $job ${COMSP}ssmisu.tm00.bufr_d
   fi
   if [ -s ${COMSP}uprair.tm00.bufr_d ]; then
    $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_uprair $job ${COMSP}uprair.tm00.bufr_d
   fi
fi

#
# copy bufr_dumplist to $COMOUT per NCO SPA request
# -------------------------------------------------
echo "Copy bufr_dumplist to comout"
LIST_cp=$COMOUT/${RUN}.t${cyc}z.bufr_dumplist.${tmmark}
cp ${FIXbufr_dump}/bufr_dumplist $LIST_cp
chmod 644 $LIST_cp

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout
 
sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/ksh
#
###########################################################################
echo "--------------------------------------------------------------------"
echo "excdas_dump.sh - CDAS network data dump processing              "
echo "--------------------------------------------------------------------"
echo "History: Dec  3 2014 - Original script, split off from              "
echo "                       exglobal_dump.sh.ecf and tailored exclusively"
echo "                       to CDAS.                                     "
echo "         Feb  2 2015 - Dump window for GOES satwnd types from tanks "
echo "                       NC005010, NC005011 & NC005012 changed from   "
echo "                       -1.00 to -0.01 hours about center dump time  "
echo "                       to -3.00 to +2.99 hours about center dump    "
echo "                       Dump window for new satwnd types NC005091,   "
echo "                       NC005080 & NC005091 set to -3.00 to +2.99    "
echo "                       hours about center dump time.                "
echo "         Jul 17 2017 - Add cfp option and remove background threads."
echo "         Sep 06 2019 - Updated to run on Dell-p3. Change background "
echo "                       threads to serial. Skip 2 tanks in msonet    "
echo "                       dump group that CDAS will not process;       "
echo "                       disabled copy of snowdepth and sstoi from    "
echo "                       dcom to com; disabled dump of radwnd data    "
echo "                       (ROC ending this data product and not        "
echo "                       transitioned to ph3).                        "
echo "         Sep 14 2020 - Updated to remove obsolete dump mnemonic     "
echo "                       from Dump group #1: goesfv.                  "
echo "                     - Updated Dump group #8 to skip legacy Meteosat"
echo "                       AMV subsets: 005064, 005065, 005066.  These  "
echo "                       subsets are replaced by new WMO BUFR sequence"
echo "                       subsets: 005067, 005068, 005069.  The format "
echo "                       change from EUMETSAT occurs Oct 6, 2020.     "
echo "                     - Updated Dump group #8 to process new WMO BUFR"
echo "                       sequence subset for VIIRS AMVs: 005091.      "
echo "                       Removed obsolete subset: 005090.             "
echo "         Mar 09 2021 - Incremented subsets for the sfcshp dump      "
echo "                       groups to match bufr_dumplist.  Removed tideg"
echo "                       from sfcshp dump group to make unique dump   "
echo "                       file.                                        "
echo "                     - Copy bufr_dumplist to COMOUT.                "
echo "         Mar 08 2022 - Enable the dumping of 002017 in vadwnd dump  "
echo "                       group.                                       "
echo "         Jul 30 2022 - Subpfl, saldrn, snocvr, and gmi1cr added     "
echo "                       to dump group #9.    "
echo "         Sep 30 2022 - Don't / Enable dumping of UPRAIR data in     "
echo "                       group #3./ b/c it is too slow                "
echo "         Oct 17 2023 - Split msonet to msonet (#5) and msone1 (#10) "
echo "                      concatenate msonet and msone1 right after dump"
echo "                      Turn off msonet and msone1 - not needed       "
###########################################################################

set -xau

# set some variables if they have not already been set

set +u

# JOB_NUMBER = 1 indicates the prepbufr dump job.
# JOB_NUMBER = 2 indicates the non-prepbufr dump job.
# JOB_NUMBER not present indicates dump BOTH prepbufr and non-prepbufr data.
# -----------------------------------------------------------------------------
# Dump group #1 (non-pb, TIME_TRIM = OFF) =
#               1bamua 1bhrs4 1bmhs osbuv8 mtiasi
#               avcsam avcspm esamua eshrs3 esmhs 
#               airsev gome gpsro lgycld lghtng
#
# Dump group #2 (pb, TIME_TRIM = OFF) =
#               sfcshp tideg atovs adpsfc
#
# Dump group #3 (pb, TIME_TRIM = OFF) =
#               adpupa gpsipw ascatt
#               # pull out uprair, too slow
# Dump group #4 (pb, TIME_TRIM = default = ON) =
#               aircar aircft proflr vadwnd rassda
#
# Dump group #5 (pb, TIME_TRIM = OFF) =
#               msonet
#
# Dump group #6 (non-pb, TIME_TRIM = OFF) =
#               nexrad
#
# Dump group #7 (non-pb, TIME_TRIM = OFF) =
#               omi ssmisu sevcsr bathy tesac trkob atms cris mls
#
# Dump group #8 (pb, TIME_TRIM = default = ON) =
#               satwnd
#
# Dump group #9 (non-pb, TIME_TRIM = default = ON) =
#               geoimr subpfl saldrn snocvr gmi1cr
#
# Dump group #10 (pb, TIME_TRIM = OFF) =
#               msone1 # ONLY tank b255/xx030, the largest
#
# Dump group #11 STATUS FILE
# -----------------------------------------------------------------------------

#VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
# The settings below are based on a future change when the DUMP job will dump
#  only types that go into PREPBUFR and the DUMP2 job will dump only types that
#  do not go into PREPBUFR.  This will speed up the DUMP + PREP processing.
# Although the logic is in place to now do this (see below), for now we will
#  continue to run only a DUMP job which will dump ALL types (no DUMP2 job) -
#  since JOB_NUMBER is not imported to this script, the logic below will dump
#  all types ...
# -----------------------------------------------------------------------------
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

if [ -n "$JOB_NUMBER" ]; then
set -u
   if [ $JOB_NUMBER = 2 ]; then
      dump_ind=DUMP2
      DUMP_group1=${DUMP_group1:-"YES"}
      DUMP_group2=${DUMP_group2:-"NO"}
      DUMP_group3=${DUMP_group3:-"NO"}
      DUMP_group4=${DUMP_group4:-"NO"}
      DUMP_group5=${DUMP_group5:-"NO"}
      DUMP_group6=${DUMP_group6:-"YES"}
      DUMP_group7=${DUMP_group7:-"YES"}
      DUMP_group8=${DUMP_group8:-"NO"}
      DUMP_group9=${DUMP_group9:-"YES"}
      DUMP_group10=${DUMP_group10:="NO"}
   else
      dump_ind=DUMP
      DUMP_group1=${DUMP_group1:-"NO"}
      DUMP_group2=${DUMP_group2:-"YES"}
      DUMP_group3=${DUMP_group3:-"YES"}
      DUMP_group4=${DUMP_group4:-"YES"}
      #DUMP_group5=${DUMP_group5:-"YES"}
      DUMP_group5=${DUMP_group5:-"NO"}
      DUMP_group6=${DUMP_group6:-"NO"}
      DUMP_group7=${DUMP_group7:-"NO"}
      DUMP_group8=${DUMP_group8:-"YES"}
      DUMP_group9=${DUMP_group9:-"NO"}
      #DUMP_group10=${DUMP_group10:="YES"}
      DUMP_group10=${DUMP_group10:="NO"}
   fi
else
   dump_ind=DUMP
   DUMP_group1=${DUMP_group1:-"YES"}
   DUMP_group2=${DUMP_group2:-"YES"}
   DUMP_group3=${DUMP_group3:-"YES"}
   DUMP_group4=${DUMP_group4:-"YES"}
   #DUMP_group5=${DUMP_group5:-"YES"}
   DUMP_group5=${DUMP_group5:-"NO"}
   DUMP_group6=${DUMP_group6:-"YES"}
   DUMP_group7=${DUMP_group7:-"YES"}
   DUMP_group8=${DUMP_group8:-"YES"}
   DUMP_group9=${DUMP_group9:-"YES"}
   #DUMP_group10=${DUMP_group10:="YES"}
   DUMP_group10=${DUMP_group10:="NO"}
fi


# send extra output of DUMP2 for monitoring purposes.
set +u
if [ -n "$JOB_NUMBER" ]; then
   [ $JOB_NUMBER = 2 ]  && export PS4='$SECONDS + '
fi
set -u

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"

cat break > $pgmout

export dumptime=`cut -c7-16 ncepdate`
export cycp=`echo $dumptime|cut -c9-10`

export NET_uc=$(echo $NET | tr [a-z] [A-Z])
export tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="$NET_uc ANALYSIS TIME IS $PDY$cyc"
$DATA/postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR $tmmark_uc $NET_uc IS $dumptime"
echo
set -x

export COMSP=$COMOUT/$RUN.${cycle}.

if [ "$PROCESS_GRIBFLDS" = 'YES' ]; then

########################################################
########################################################
#  copy snogrb (0.5 deg) from $TANK_GRIBFLDS  # disabled in obsproc_cdas.v2.5.0
#  copy snogrb_t574      from $TANK_GRIBFLDS  # disabled in obsproc_cdas.v2.5.0
#  copy engicegrb        from $COM_ENGICE
#  copy sstgrb           from $COM_SSTOI
#  generate sstgrb index file
########################################################
########################################################
# copy of snowgrb and snogrb_t574 disabled in obsproc_cdas.v2.5.0
#  snogrb=$TANK_GRIBFLDS/$PDY/wgrbbul/snowdepth.global.grb
#  snoold=$TANK_GRIBFLDS/$PDYm1/wgrbbul/snowdepth.global.grb
#
#  if [ -s $snogrb ]; then
#     cp $snogrb ${COMSP}snogrb
#     msg="todays 0.5 degree snow grib file located and copied to ${COMSP}snogrb"
#     $DATA/postmsg "$jlogfile" "$msg"
#  elif [ -s $snoold ]; then
#     cp $snoold ${COMSP}snogrb
#     msg="**todays 0.5 degree snow grib file not located - copy 1-day old file"
#     $DATA/postmsg "$jlogfile" "$msg"
#  else
#     set +x
#     echo " "
#     echo " #####################################################"
#     echo " cannot locate 0.5 degree snow grib file - fatal error"
#     echo " #####################################################"
#     echo " "
#     set -x
#     msg="**CANNOT LOCATE 0.5 DEGREE SNOW GRIB FILE --> EXIT DATA DUMP"
#     $DATA/postmsg "$jlogfile" "$msg"
#     $DATA/err_exit
#  fi
#
#  snogrb_t574=$TANK_GRIBFLDS/$PDY/wgrbbul/snowdepth.t574.grb
#  snoold_t574=$TANK_GRIBFLDS/$PDYm1/wgrbbul/snowdepth.t574.grb
#
#  if [ -s $snogrb_t574 ]; then
#     cp $snogrb_t574 ${COMSP}snogrb_t574
#     msg="todays T574 snow grib file located and copied to ${COMSP}snogrb_t574"
#     $DATA/postmsg "$jlogfile" "$msg"
#  elif [ -s $snoold_t574 ]; then
#     cp $snoold_t574 ${COMSP}snogrb_t574
#     msg="**todays T574 snow grib file not located - copy 1-day old file"
#     $DATA/postmsg "$jlogfile" "$msg"
#  else
#     set +x
#     echo " "
#     echo " ###############################################"
#     echo " cannot locate T574 snow grib file - fatal error"
#     echo " ###############################################"
#     echo " "
#     set -x
#     msg="**CANNOT LOCATE T574 SNOW GRIB FILE --> EXIT DATA DUMP"
#     $DATA/postmsg "$jlogfile" "$msg"
#     $DATA/err_exit
#  fi

   engicegrb=${COM_ENGICE}.$PDY/engice.t00z.grb
   engiceold=${COM_ENGICE}.$PDYm1/engice.t00z.grb

   if [ -s $engicegrb ]; then
      cp $engicegrb ${COMSP}engicegrb
      msg="todays engice grib file located and copied to ${COMSP}engicegrb"
      $DATA/postmsg "$jlogfile" "$msg"
   elif [ -s $engiceold ]; then
      cp $engiceold ${COMSP}engicegrb
      msg="**todays engice grib file not located - copy 1-day old file"
      $DATA/postmsg "$jlogfile" "$msg"
   else
      set +x
      echo " "
      echo " ############################################"
      echo " cannot locate engice grib file - fatal error"
      echo " ############################################"
      echo " "
      set -x
      msg="**CANNOT LOCATE ENGICE GRIB FILE --> EXIT DATA DUMP"
      $DATA/postmsg "$jlogfile" "$msg"
      $DATA/err_exit
   fi

# copy of sstgrb and ssstold disabled in obsproc_cdas.v2.5.0
#  sstgrb=${COM_SSTOI}.$PDY/sstoi_grb
#  sstold=${COM_SSTOI}.$PDYm1/sstoi_grb

#  if [ -s $sstgrb ]; then
#     cp $sstgrb ${COMSP}sstgrb
#     msg="todays sst grib file located and copied to ${COMSP}sstgrb"
#     $DATA/postmsg "$jlogfile" "$msg"
#  elif [ -s $sstold ]; then
#     cp $sstold ${COMSP}sstgrb
#     msg="**todays sst grib file not located - copy 1-day old file"
#     $DATA/postmsg "$jlogfile" "$msg"
#  else
#     set +x
#     echo " "
#     echo " #########################################"
#     echo " cannot locate sst grib file - fatal error"
#     echo " #########################################"
#     echo " "
#     set -x
#     msg="**CANNOT LOCATE SST GRIB FILE --> EXIT DATA DUMP"
#     $DATA/postmsg "$jlogfile" "$msg"
#     $DATA/err_exit
#  fi

#  rm errfile
#  $GRBINDEX ${COMSP}sstgrb ${COMSP}sstgrb.index 2> errfile
#  errindx=$?
#  [ "$errindx" -ne '0' ] && cat errfile
#  rm errfile

fi  #  endif loop $PROCESS_GRIBFLDS


echo "=======> Dump group 1 (thread_1) not executed." > $DATA/1.out
echo "=======> Dump group 2 (thread_2) not executed." > $DATA/2.out
echo "=======> Dump group 3 (thread_3) not executed." > $DATA/3.out
echo "=======> Dump group 4 (thread_4) not executed." > $DATA/4.out
echo "=======> Dump group 5 (thread_5) not executed." > $DATA/5.out
echo "=======> Dump group 6 (thread_6) not executed." > $DATA/6.out
echo "=======> Dump group 7 (thread_7) not executed." > $DATA/7.out
echo "=======> Dump group 8 (thread_8) not executed." > $DATA/8.out
echo "=======> Dump group 9 (thread_9) not executed." > $DATA/9.out
echo "=======> Dump group 10 (thread_10) not executed." > $DATA/10.out

err1=0
err2=0
err3=0
err4=0
err5=0
err6=0
err7=0
err8=0
err9=0
err10=0

#restrict processing of unexpected big tanks
#this block appear in all /scripts/ex*_dump.sh proessing msonet and msone1
TANK_MAX_255003=${TANK_MAX_255003:-3221225472} #3Gb
TANK_MAX_255004=${TANK_MAX_255004:-1610612736} #1.5Gb
TANK_MAX_255030=${TANK_MAX_255030:-4187593114} #3.9Gb
if [ -s ${TANK}/${PDY}/b255/xx003 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx003)" -gt "$TANK_MAX_255003" ]; then
 export SKIP_255003=YES
 msg="WARNING: TANK b255/xx003 exceeds TANK_MAX_255003 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
if [ -s ${TANK}/${PDY}/b255/xx004 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx004)" -gt "$TANK_MAX_255004" ]; then
 export SKIP_255004=YES
 msg="WARNING: TANK b255/xx004 exceeds TANK_MAX_255004 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
 fi
if [ -s ${TANK}/${PDY}/b255/xx030 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx030)" -gt "$TANK_MAX_255030" ]; then
 export SKIP_255030=YES
 msg="WARNING: TANK b255/xx030 exceeds TANK_MAX_255030 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
#end of block

if [ "$PROCESS_DUMP" = 'YES' ]; then

####################################
####################################
#  The data "dump" script for tm00
####################################
####################################

msg="START THE $tmmark_uc $NET_uc DATA $dump_ind CENTERED ON $dumptime"
$DATA/postmsg "$jlogfile" "$msg"

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=1

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 1 : 1BAMUA: 1 subtype(s)
#            1BHRS4: 1 subtype(s)
#            1BMHS:  1 subtype(s)
#            RADWND: 2 subtype(s)
#            OSBUV8: 1 subtype(s)
#            MTIASI: 1 subtype(s)
#            AVCSAM: 1 subtype(s)
#            AVCSPM: 1 subtype(s)
#            ESAMUA: 1 subtype(s)
#            ESHRS3: 1 subtype(s)
#            ESMHS:  1 subtype(s)
#            AIRSEV: 1 subtype(s)
#            GOME:   1 subtype(s)
#            GPSRO:  1 subtype(s)
#            LGYCLD: 1 subtype(s)
#            LGHTNG: 2 subtype(s)
#            ----------------------
#            TOTAL NUMBER OF SUBTYPES = 18
#
#=========================================================================

DTIM_latest_lgycld=${DTIM_latest_lgycld:-"+2.99"}
DTIM_latest_lghtng=${DTIM_latest_lghtng:-"+2.99"}
DTIM_latest_1bamua=${DTIM_latest_1bamua:-"+2.99"}
DTIM_latest_1bhrs4=${DTIM_latest_1bhrs4:-"+2.99"}
DTIM_latest_1bmhs=${DTIM_latest_1bmhs:-"+2.99"}
DTIM_latest_osbuv8=${DTIM_latest_osbuv8:-"+2.99"}
DTIM_latest_mtiasi=${DTIM_latest_mtiasi:-"+2.99"}
DTIM_latest_avcsam=${DTIM_latest_avcsam:-"+2.99"}
DTIM_latest_avcspm=${DTIM_latest_avcspm:-"+2.99"}
DTIM_latest_esamua=${DTIM_latest_esamua:-"+2.99"}
DTIM_latest_eshrs3=${DTIM_latest_eshrs3:-"+2.99"}
DTIM_latest_esmhs=${DTIM_latest_esmhs:-"+2.99"}

DTIM_latest_airsev=${DTIM_latest_airsev:-"+2.99"}
DTIM_latest_gome=${DTIM_latest_gome:-"+2.99"}
DTIM_latest_gpsro=${DTIM_latest_gpsro:-"+2.99"}

TIME_TRIM=off

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 1bamua \
 1bhrs4 1bmhs osbuv8 mtiasi avcsam avcspm esamua \
 eshrs3 esmhs airsev gome gpsro lgycld lghtng
error1=$?
echo "$error1" > $DATA/error1

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_2; chmod +x thread_2
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_2
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=2

#==========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 2 : SFCSHP:11 subtype(s)
#            ATOVS:  1 subtype(s)
#            ADPSFC: 4 subtype(s)
#            TIDEG:  1 subtype(s)
#  xxxxxxxxx WNDSAT: 1 subtype(s) (if present in past 10 days of tanks)
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of -3.00 to +2.99 hours)
#            ----------------------
#            TOTAL NUMBER OF SUBTYPES = 17
#
#==========================================================================

DTIM_latest_sfcshp=${DTIM_latest_sfcshp:-"+2.99"}
DTIM_latest_tideg=${DTIM_latest_tideg:-"+2.99"}
DTIM_latest_atovs=${DTIM_latest_atovs:-"+2.99"}
DTIM_latest_adpsfc=${DTIM_latest_adpsfc:-"+2.99"}
#-----------------------------------------------
# check for wndsat tank presence in past 10 days
wndsat=""
err_check_tanks=0
##########sh $USHbufr_dump/check_tanks.sh wndsat
##########err_check_tanks=$?
err_check_tanks=99 # comment out 2 lines above & add this line to ensure wndsat
                   # is not ever dumped
if [ $err_check_tanks -eq 0 ];then
   wndsat=wndsat
   DTIM_latest_wndsat=${DTIM_latest_wndsat:-"+2.99"}
fi
#-----------------------------------------------

TIME_TRIM=off

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 sfcshp tideg atovs adpsfc $wndsat
error2=$?
echo "$error2" > $DATA/error2

set +x
echo "********************************************************************"
echo Script thread_2
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/2.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_3; chmod +x thread_3
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_3
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=3

#====================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump #3:   ADPUPA: 6 subtype(s)
#            #UPRAIR: 5 subtype(s) - pull out, too slow
#            GPSIPW: 1 subtype(s)
#            ASCATT: 1 subtype(s)
#            ---------------------
#            TOTAL NUMBER OF SUBTYPES = 13
#
#====================================================================

# other dump types
# ----------------
DTIM_latest_adpupa=${DTIM_latest_adpupa:-"+2.99"}
DTIM_latest_uprair=${DTIM_latest_uprair:-"+2.99"}
DTIM_latest_gpsipw=${DTIM_latest_gpsipw:-"+2.99"}
DTIM_latest_ascatt=${DTIM_latest_ascatt:-"+2.99"}

TIME_TRIM=off

# $ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 adpupa uprair gpsipw ascatt
$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 adpupa gpsipw ascatt
error3=$?
echo "$error3" > $DATA/error3

set +x
echo "********************************************************************"
echo Script thread_3
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/3.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_4; chmod +x thread_4
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_4
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=4

#=======================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#       EXCEPT: AIRCFT where it is +/- 3.25 hours
#               AIRCAR where it is +/- 3.25 hours
#               PROFLR where it is -4.00 to +3.99 hours
#   (2) TIME TRIMMING IS DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 4 : AIRCAR: 2 subtype(s)
#            AIRCFT: 8 subtype(s)
#            PROFLR: 4 subtype(s)
#            VADWND: 1 subtype(s)
#            RASSDA: 1 subtype(s)
#            ------------------------ 
#            TOTAL NUMBER OF SUBTYPES = 16
#
#=======================================================================

# Skip NeXRaD VAD WINDS FROM LEVEL 2 DECODER (not ready to be handled in GSI)
# 3/9/2022 -- enable the dumping of 002017 in the vadwnd dump group.
#export SKIP_002017=YES

# Dump AIRCFT and AIRCAR with wide time window to improve PREPOBS_PREPACQC
#  track-check performance
#  (time window will be winnowed down to +/- 3.00 hours in output from
#   PREPOBS_PREPACQC)

# Dump PROFLR with wide time window to improve PREPOBS_PROFCQC performance
#  (time window will be winnowed down in output from PREPOBS_PROFCQC, see
#   parm cards for output time window)

DTIM_earliest_aircft=${DTIM_earliest_aircft:-"-3.25"}
DTIM_latest_aircft=${DTIM_latest_aircft:-"+3.25"}

DTIM_earliest_aircar=${DTIM_earliest_aircar:-"-3.25"}
DTIM_latest_aircar=${DTIM_latest_aircar:-"+3.25"}

DTIM_earliest_proflr=${DTIM_earliest_proflr:-"-4.00"}
DTIM_latest_proflr=${DTIM_latest_proflr:-"+3.99"}

DTIM_latest_vadwnd=${DTIM_latest_vadwnd:-"+2.99"}
DTIM_latest_rassda=${DTIM_latest_rassda:-"+2.99"}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 aircar aircft proflr vadwnd \
 rassda
error4=$?
echo "$error4" > $DATA/error4

set +x
echo "********************************************************************"
echo Script thread_4
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/4.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_5; chmod +x thread_5
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_5
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=5

#===================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types 
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 5 : MSONET: 30 subtype(s)
#            ------------------------
#            TOTAL NUMBER OF SUBTYPES = 30
#
#===================================================================

#IG
DTIM_earliest_msonet=${DTIM_latest_msonet:-"-1.99"}
DTIM_latest_msonet=${DTIM_latest_msonet:-"+2.00"}

#DTIM_latest_msonet=${DTIM_latest_msonet:-"+2.99"}

export SKIP_255031=YES  # Skip for port to Dell since no new data allowed.
export SKIP_255101=YES  # Also, b/c CDAS has not tested these providers. 

TIME_TRIM=on
#TIME_TRIM=off

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 msonet
error5=$?
echo "$error5" > $DATA/error5

set +x
echo "********************************************************************"
echo Script thread_5
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/5.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_6; chmod +x thread_6
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_6
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=6

#===================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 6 : NEXRAD: 8 subtype(s)
#            -----------------------
#            TOTAL NUMBER OF SUBTYPES = 8
#
#===================================================================

DTIM_latest_nexrad=${DTIM_latest_nexrad:-"+2.99"}

TIME_TRIM=off

# NEXRAD tanks are hourly
# Process only those hourly tanks w/i requested dump center cycle time window

SKIP_006010=YES # radial wind  00Z
SKIP_006011=YES # radial wind  01Z
SKIP_006012=YES # radial wind  02Z
SKIP_006013=YES # radial wind  03Z
SKIP_006014=YES # radial wind  04Z
SKIP_006015=YES # radial wind  05Z
SKIP_006016=YES # radial wind  06Z
SKIP_006017=YES # radial wind  07Z
SKIP_006018=YES # radial wind  08Z
SKIP_006019=YES # radial wind  09Z
SKIP_006020=YES # radial wind  10Z
SKIP_006021=YES # radial wind  11Z
SKIP_006022=YES # radial wind  12Z
SKIP_006023=YES # radial wind  13Z
SKIP_006024=YES # radial wind  14Z
SKIP_006025=YES # radial wind  15Z
SKIP_006026=YES # radial wind  16Z
SKIP_006027=YES # radial wind  17Z
SKIP_006028=YES # radial wind  18Z
SKIP_006029=YES # radial wind  19Z
SKIP_006030=YES # radial wind  20Z
SKIP_006031=YES # radial wind  21Z
SKIP_006032=YES # radial wind  22Z
SKIP_006033=YES # radial wind  23Z

SKIP_006040=YES # reflectivity 00Z
SKIP_006041=YES # reflectivity 01Z
SKIP_006042=YES # reflectivity 02Z
SKIP_006043=YES # reflectivity 03Z
SKIP_006044=YES # reflectivity 04Z
SKIP_006045=YES # reflectivity 05Z
SKIP_006046=YES # reflectivity 06Z
SKIP_006047=YES # reflectivity 07Z
SKIP_006048=YES # reflectivity 08Z
SKIP_006049=YES # reflectivity 09Z
SKIP_006050=YES # reflectivity 10Z
SKIP_006051=YES # reflectivity 11Z
SKIP_006052=YES # reflectivity 12Z
SKIP_006053=YES # reflectivity 13Z
SKIP_006054=YES # reflectivity 14Z
SKIP_006055=YES # reflectivity 15Z
SKIP_006056=YES # reflectivity 16Z
SKIP_006057=YES # reflectivity 17Z
SKIP_006058=YES # reflectivity 18Z
SKIP_006059=YES # reflectivity 19Z
SKIP_006060=YES # reflectivity 20Z
SKIP_006061=YES # reflectivity 21Z
SKIP_006062=YES # reflectivity 22Z
SKIP_006063=YES # reflectivity 23Z

if [ $cycp -eq 00 ]; then   # (22.5 - 01.5 Z)
   unset SKIP_006032 # radial wind  22Z
   unset SKIP_006033 # radial wind  23Z
   unset SKIP_006010 # radial wind  00Z
   unset SKIP_006011 # radial wind  01Z
   unset SKIP_006062 # reflectivity 22Z
   unset SKIP_006063 # reflectivity 23Z
   unset SKIP_006040 # reflectivity 00Z
   unset SKIP_006041 # reflectivity 01Z
elif [ $cycp -eq 06 ]; then # (04.5 - 07.5 Z)
   unset SKIP_006014 # radial wind  04Z
   unset SKIP_006015 # radial wind  05Z
   unset SKIP_006016 # radial wind  06Z
   unset SKIP_006017 # radial wind  07Z
   unset SKIP_006044 # reflectivity 04Z
   unset SKIP_006045 # reflectivity 05Z
   unset SKIP_006046 # reflectivity 06Z
   unset SKIP_006047 # reflectivity 07Z
elif [ $cycp -eq 12 ]; then # (10.5 - 13.5 Z)
   unset SKIP_006020 # radial wind  10Z
   unset SKIP_006021 # radial wind  11Z
   unset SKIP_006022 # radial wind  12Z
   unset SKIP_006023 # radial wind  13Z
   unset SKIP_006050 # reflectivity 10Z
   unset SKIP_006051 # reflectivity 11Z
   unset SKIP_006052 # reflectivity 12Z
   unset SKIP_006053 # reflectivity 13Z
elif [ $cycp -eq 18 ]; then # (16.5 - 19.5 Z)
   unset SKIP_006026 # radial wind  16Z
   unset SKIP_006027 # radial wind  17Z
   unset SKIP_006028 # radial wind  18Z
   unset SKIP_006029 # radial wind  19Z
   unset SKIP_006056 # reflectivity 16Z
   unset SKIP_006057 # reflectivity 17Z
   unset SKIP_006058 # reflectivity 18Z
   unset SKIP_006059 # reflectivity 19Z
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 nexrad
error6=$?
echo "$error6" > $DATA/error6

set +x
echo "********************************************************************"
echo Script thread_6
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/6.out 2>&1
EOF
set -x

set +x
#------------------------------------------------------------------------------
cat<<\EOF>thread_7; chmod +x thread_7
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_7
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=7

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 7 : OMI:    1 subtype(s)
#            SSMISU: 1 subtype(s)
#            SEVCSR: 1 subtype(s)
#            BATHY:  1 subtype(s)
#            TESAC:  1 subtype(s)
#            TRKOB:  1 subtype(s)
#            ATMS:   1 subtype(s) (if present in past 10 days of tanks)
#            CRIS:   1 subtype(s) (if present in past 10 days of tanks)
#            MLS:    1 subtype(s) (if present in past 10 days of tanks)
#            ----------------------
#            TOTAL NUMBER OF SUBTYPES = 9 
#
#=========================================================================

DTIM_latest_omi=${DTIM_latest_omi:-"+2.99"}
DTIM_latest_ssmisu=${DTIM_latest_ssmisu:-"+2.99"}
#-----------------------------------------------
DTIM_latest_sevcsr=${DTIM_latest_sevcsr:-"+2.99"}
DTIM_latest_bathy=${DTIM_latest_bathy:-"+2.99"}
DTIM_latest_tesac=${DTIM_latest_tesac:-"+2.99"}
DTIM_latest_trkob=${DTIM_latest_trkob:-"+2.99"}
#-----------------------------------------------
# check for atms tank presence in past 10 days
atms=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh atms
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   atms=atms
   DTIM_latest_atms=${DTIM_latest_atms:-"+2.99"}
fi
#-----------------------------------------------
# check for cris tank presence in past 10 days
cris=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh cris
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   cris=cris
   DTIM_latest_cris=${DTIM_latest_cris:-"+2.99"}
fi
#-----------------------------------------------
# check for mls tank presence in past 10 days
mls=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh mls
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   mls=mls
   DTIM_latest_mls=${DTIM_latest_mls:-"+2.99"}
fi
#-----------------------------------------------

TIME_TRIM=off

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 omi ssmisu sevcsr \
 bathy tesac trkob $atms $cris $mls
error7=$?
echo "$error7" > $DATA/error7

set +x
echo "********************************************************************"
echo Script thread_7
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/7.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_8; chmod +x thread_8
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_8
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=8

#=======================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is +/- 1.5 hrs for all SATWND types
#       EXCEPT: SATWND subtypes 005/010, 005/011 and 005/12, 005/019, 005/064,
#               005/065, 005/066, 005/067, 005/068, 005/069 005/070, 005/071, 005/080 and 005/091 where
#               it is -3.00 to +2.99 hours.
#   (2) TIME TRIMMING IS DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 8 : SATWND: 17 subtype(s)
#            ------------------------ 
#            TOTAL NUMBER OF SUBTYPES = 74
#
#=======================================================================

# Skip legacy EUMETSAT AMV subsets; for testing, skipped in trigger or version file
#export SKIP_005064=YES
#export SKIP_005065=YES
#export SKIP_005066=YES

# satwnd types
# ------------
DTIM_earliest_005010=${DTIM_earliest_005010:-"-3.00"}
DTIM_latest_005010=${DTIM_latest_005010:-"+2.99"}
DTIM_earliest_005011=${DTIM_earliest_005011:-"-3.00"}
DTIM_latest_005011=${DTIM_latest_005011:-"+2.99"}
DTIM_earliest_005012=${DTIM_earliest_005012:-"-3.00"}
DTIM_latest_005012=${DTIM_latest_005012:-"+2.99"}
DTIM_earliest_005019=${DTIM_earliest_005019:-"-3.00"}
DTIM_latest_005019=${DTIM_latest_005019:-"+2.99"}

DTIM_earliest_005064=${DTIM_earliest_005064:-"-3.00"}
DTIM_latest_005064=${DTIM_latest_005064:-"+2.99"}
DTIM_earliest_005065=${DTIM_earliest_005065:-"-3.00"}
DTIM_latest_005065=${DTIM_latest_005065:-"+2.99"}
DTIM_earliest_005066=${DTIM_earliest_005066:-"-3.00"}
DTIM_latest_005066=${DTIM_latest_005066:-"+2.99"}

DTIM_earliest_005067=${DTIM_earliest_005067:-"-3.00"}
DTIM_latest_005067=${DTIM_latest_005067:-"+2.99"}
DTIM_earliest_005068=${DTIM_earliest_005068:-"-3.00"}
DTIM_latest_005068=${DTIM_latest_005068:-"+2.99"}
DTIM_earliest_005069=${DTIM_earliest_005069:-"-3.00"}
DTIM_latest_005069=${DTIM_latest_005069:-"+2.99"}

DTIM_earliest_005070=${DTIM_earliest_005070:-"-3.00"}
DTIM_latest_005070=${DTIM_latest_005070:-"+2.99"}
DTIM_earliest_005071=${DTIM_earliest_005071:-"-3.00"}
DTIM_latest_005071=${DTIM_latest_005071:-"+2.99"}
DTIM_earliest_005080=${DTIM_earliest_005080:-"-3.00"}
DTIM_latest_005080=${DTIM_latest_005080:-"+2.99"}
DTIM_earliest_005081=${DTIM_earliest_005081:-"-1.50"}
DTIM_latest_005081=${DTIM_latest_005081:-"+1.49"}
DTIM_earliest_005091=${DTIM_earliest_005091:-"-3.00"}
DTIM_latest_005091=${DTIM_latest_005091:-"+2.99"}

$ushscript_dump/bufr_dump_obs.sh $dumptime 1.5 1 satwnd
error8=$?
echo "$error8" > $DATA/error8

set +x
echo "********************************************************************"
echo Script thread_8
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/8.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_9; chmod +x thread_9
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_9
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=9

#=======================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#       EXCEPT:  GEOIMR where it is -0.50 to +0.50 hour
#   (2) TIME TRIMMING IS DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 9 : GEOIMR: 1 subtype(s)
#            SUBPFL: 1 subtype(s)
#            SALDRN: 1 subtype(s)
#            SNOCVR: 1 subtype(s)
#            GMI1CR: 1 subtype(s)
#            ------------------------ 
#            TOTAL NUMBER OF SUBTYPES = 5
#
#=======================================================================

DTIM_earliest_geoimr=${DTIM_earliest_geoimr:-"-0.50"}
DTIM_latest_geoimr=${DTIM_latest_geoimr:-"+0.50"}
DTIM_earliest_subpfl=${DTIM_earliest_subpfl:-"-3.00"}
DTIM_latest_subpfl=${DTIM_latest_subpfl:-"+2.99"}
DTIM_earliest_saldrn=${DTIM_earliest_saldrn:-"-3.00"}
DTIM_latest_saldrn=${DTIM_latest_saldrn:-"+2.99"}
DTIM_earliest_snocvr=${DTIM_earliest_snocvr:-"-3.00"}
DTIM_latest_snocvr=${DTIM_latest_snocvr:-"+2.99"}
DTIM_earliest_gmi1cr=${DTIM_earliest_gmi1cr:-"-3.00"}
DTIM_latest_gmi1cr=${DTIM_latest_gmi1cr:-"+2.99"}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 geoimr subpfl saldrn snocvr gmi1cr
error9=$?
echo "$error9" > $DATA/error9

set +x
echo "********************************************************************"
echo Script thread_9
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/9.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_10; chmod +x thread_10
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_10
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=10

#===================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types 
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP
#
#--------------------------------------------------------------------------
# Dump # 10 : MSONET: 1 subtype(s) 255/030
#            ------------------------
#            TOTAL NUMBER OF SUBTYPES = 1
#
#===================================================================

DTIM_earliest_msone1=${DTIM_latest_msone1:-"-1.99"}
DTIM_latest_msone1=${DTIM_latest_msone1:-"+2.00"}

TIME_TRIM=on #off

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 msone1
error10=$?
echo "$error10" > $DATA/error10

set +x
echo "********************************************************************"
echo Script thread_10
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/10.out 2>&1
EOF
set -x

#----------------------------------------------------------------
# Now launch the threads

# determine local system name and type if available
# -------------------------------------------------
SITE=${SITE:-""}

launcher=${launcher:-"cfp"}  # if not "cfp", threads will run serially

if [ "$launcher" = cfp ]; then
   set -u
   > $DATA/poe.cmdfile

# To better take advantage of cfp, execute the longer running commands first.
# Some reordering was done here based on recent sample runtimes.
   [ $DUMP_group5 = YES ]  &&  echo ./thread_5 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group1 = YES ]  &&  echo ./thread_1 >> $DATA/poe.cmdfile
   [ $DUMP_group8 = YES ]  &&  echo ./thread_8 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group6 = YES ]  &&  echo ./thread_6 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group2 = YES ]  &&  echo ./thread_2 >> $DATA/poe.cmdfile
   [ $DUMP_group3 = YES ]  &&  echo ./thread_3 >> $DATA/poe.cmdfile
   [ $DUMP_group4 = YES ]  &&  echo ./thread_4 >> $DATA/poe.cmdfile
   [ $DUMP_group7 = YES ]  &&  echo ./thread_7 >> $DATA/poe.cmdfile
   [ $DUMP_group9 = YES ]  &&  echo ./thread_9 >> $DATA/poe.cmdfile
   [ $DUMP_group10 = YES ] &&  echo ./thread_10 >> $DATA/poe.cmdfile #msone1

   if [ -s $DATA/poe.cmdfile ]; then
      export MP_CSS_INTERRUPT=yes  # ??
      launcher_DUMP=${launcher_DUMP:-mpiexec}
      #$launcher_DUMP -np 10 --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      NPROCS=${NPROCS:-10}
      $launcher_DUMP -np $NPROCS --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      errpoe=$?
      if [ $errpoe -ne 0 ]; then
         $DATA/err_exit "***FATAL: EXIT STATUS $errpoe RUNNING POE COMMAND FILE"
      fi
   else
      echo
      echo "==> There are no tasks in POE Command File - POE not run"
      echo
   fi
else
  echo "Running threads serially"
  [ $DUMP_group1 = YES ]  &&  ./thread_1
  [ $DUMP_group2 = YES ]  &&  ./thread_2
  [ $DUMP_group3 = YES ]  &&  ./thread_3
  [ $DUMP_group4 = YES ]  &&  ./thread_4
  [ $DUMP_group5 = YES ]  &&  ./thread_5
  [ $DUMP_group6 = YES ]  &&  ./thread_6
  [ $DUMP_group7 = YES ]  &&  ./thread_7
  [ $DUMP_group8 = YES ]  &&  ./thread_8
  [ $DUMP_group9 = YES ]  &&  ./thread_9
  [ $DUMP_group10 = YES ]  &&  ./thread_10
fi

cat $DATA/1.out $DATA/2.out $DATA/3.out $DATA/4.out $DATA/5.out $DATA/6.out $DATA/7.out $DATA/8.out $DATA/9.out $DATA/10.out

set +x
echo " "
echo " "
set -x

[ -s $DATA/error1 ] && err1=`cat $DATA/error1`
[ -s $DATA/error2 ] && err2=`cat $DATA/error2`
[ -s $DATA/error3 ] && err3=`cat $DATA/error3`
[ -s $DATA/error4 ] && err4=`cat $DATA/error4`
[ -s $DATA/error5 ] && err5=`cat $DATA/error5`
[ -s $DATA/error6 ] && err6=`cat $DATA/error6`
[ -s $DATA/error7 ] && err7=`cat $DATA/error7`
[ -s $DATA/error8 ] && err8=`cat $DATA/error8`
[ -s $DATA/error9 ] && err9=`cat $DATA/error9`
[ -s $DATA/error10 ] && err10=`cat $DATA/error10`
#===============================================================================

export STATUS=YES
export DUMP_NUMBER=11
$ushscript_dump/bufr_dump_obs.sh $dumptime 3.00 1 null

   if [ "$SENDCOM" = 'YES' -a "$COPY_TO_ARKV" = 'YES' ]; then

#=====================================================================
#=====================================================================
#  Copy dump files to arkv directory, preserving ownership & group id
#   but updating timestamp
#=====================================================================
#=====================================================================

      msg="Copy dump files to $COMARC"
      $DATA/postmsg "$jlogfile" "$msg"

      set +x
      for fil in `ls $COMOUT/cdas.${cycle}*bufr_d`; do
         set -x
         nfil="`basename $fil | awk -F. '{print $3}'`.${PDY}${cyc}.bufr_d"
         cp --preserve=mode,ownership $fil ${COMARC}/${nfil}
      done

#     endif loop $COPY_TO_ARKV
   fi


#  endif loop $PROCESS_DUMP
fi

echo " " >> $pgmout
echo "##################################################################\
####################"  >> $pgmout
echo " " >> $pgmout

#================================================================
#================================================================



if [ "$PROCESS_DUMP" = 'YES' ]; then

   if [ "$err1" -gt '5' -o "$err2" -gt '5' -o "$err3" -gt '5' -o \
        "$err4" -gt '5' -o "$err5" -gt '5' -o "$err6" -gt '5' -o \
        "$err7" -gt '5' -o "$err8" -gt '5' -o "$err9" -gt '5' -o \
        "$err10" -gt '5' ]; then
      for n in $err1 $err2 $err3 $err4 $err5 $err6 $err7 $err8 $err9 $err10
      do
         if [ "$n" -gt '5' ]; then
            if [ "$n" -ne '11' -a "$n" -ne '22' ]; then
       
## fatal error in dumping of BUFR obs. files
       
               set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9 $err10"
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
               set -x
               $DATA/err_exit
               exit 9
            fi
         fi
      done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

      set +x
      echo
      echo " ###################################################### "
      echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9 $err10 "
      echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
      echo " ###################################################### "
      echo
      set -x
   fi

#  endif loop $PROCESS_DUMP
fi

##  concatenate msonet and msone1, b/c prepobs only wants one file
#cat ${COMSP}msone1.tm00.bufr_d >> ${COMSP}msonet.tm00.bufr_d

#
# copy bufr_dumplist to $COMOUT per NCO SPA request
# -------------------------------------------------
echo "Copy bufr_dumplist to comout"
LIST_cp=$COMOUT/${RUN}.t${cyc}z.bufr_dumplist.${tmmark}
cp ${FIXbufr_dump}/bufr_dumplist $LIST_cp
chmod 644 $LIST_cp

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat  break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/ksh
export PS4=' + extrkr_g1.sh line $LINENO: '

set +x
echo "TIMING: Time at beginning of extrkr.sh for pert= $pert is `date`"
set -x
export cmodel=$2
export pert=$3
export DATA=$4

set +x
##############################################################################
echo " "
echo "------------------------------------------------"
echo "xxxx - Track vortices in model GRIB-1 output"
echo "------------------------------------------------"
echo "History: Mar 1998 - Marchok - First implementation of this new script."
echo "         Apr 1999 - Marchok - Modified to allow radii output file and"
echo "                              to allow reading of 4-digit years from"
echo "                              TC vitals file."
echo "         Oct 2000 - Marchok - Fixed bugs: (1) copygb target grid scanning mode"
echo "                              flag had an incorrect value of 64 (this prevented"
echo "                              NAM, NGM and ECMWF from being processed correctly);" 
echo "                              Set it to 0.  (2) ECMWF option was using the "
echo "                              incorrect input date (today's date instead of "
echo "                              yesterday's)."
echo "         Jan 2001 - Marchok - Hours now listed in script for each model and "
echo "                              passed into program.  Script included to process"
echo "                              GFDL & Ensemble data.  Call to DBN included to "
echo "                              pass data to OSO and the Navy.  Forecast length"
echo "                              extended to 5 days for GFS & MRF."
echo " "
echo "                    In the event of a crash, you can contact Tim "
echo "                    Marchok at GFDL at (609) 452-6534 or timothy.marchok@noaa.gov"
echo " "
echo "Current time is: `date`"
echo " "
##############################################################################
set -x

##############################################################################
#
#    FLOW OF CONTROL
#
# 1. Define data directories and file names for the input model 
# 2. Process input starting date/cycle information
# 3. Update TC Vitals file and select storms to be processed
# 4. Cut apart input GRIB files to select only the needed parms and hours
# 5. Execute the tracker
# 6. Copy the output track files to various locations
#
##############################################################################
msg="has begun for ${cmodel} ${pert} at ${cyc}z"
postmsg "$jlogfile" "$msg"

# This script runs the hurricane tracker using operational GRIB model output.  
# This script makes sure that the data files exist, it then pulls all of the 
# needed data records out of the various GRIB forecast files and puts them 
# into one, consolidated GRIB file, and then runs a program that reads the TC 
# Vitals records for the input day and updates the TC Vitals (if necessary).
# It then runs gettrk, which actually does the tracking.
# 
# Environmental variable inputs needed for this scripts:
#  PDY   -- The date for data being processed, in YYYYMMDD format
#  cyc   -- The numbers for the cycle for data being processed (00, 06, 12, 18)
#  cmodel -- Model being processed (gfs, mrf, ukmet, ecmwf, nam, ngm, ngps,
#                                   gdas, gfdl, ens (ncep ensemble), ensm (ncep
#                                   ensemble run off of the mean fields)
#  envir -- 'prod' or 'test'
#  SENDCOM -- 'YES' or 'NO'
#  stormenv -- This is only needed by the tracker run for the GFDL model.
#              'stormenv' contains the name/id that is used in the input
#              grib file names.
#  pert  -- This is only needed by the tracker run for the NCEP ensemble.
#           'pert' contains the ensemble member id (e.g., n2, p4, etc.)
#           which is used as part of the grib file names.
#
# For testing script interactively in non-production set following vars:
#     gltrkdir   - Directory for output tracks
#     archsyndir - Directory with syndir scripts/exec/fix 
#

qid=$$
#----------------------------------------------#
#   Get input date information                 #
#----------------------------------------------#


###############################################
export jobid=${jobid:-testjob}
export SENDCOM=${SENDCOM:-NO}

if [ ! -d $DATA ]
then
   mkdir -p $DATA
fi
cd $DATA

if [ ${#PDY} -eq 0 -o ${#cyc} -eq 0 -o ${#cmodel} -eq 0 ]
then
  set +x
  echo " "
  echo "FATAL ERROR:  Something wrong with input parameters."
  echo "PDY= ${PDY}, cyc= ${cyc}, cmodel= ${cmodel}"
  set -x
  err_exit "FAILED ${jobid} -- BAD INPUTS AT LINE $LINENO IN TRACKER SCRIPT - ABNORMAL EXIT"
else
  set +x
  echo " "
  echo " #-----------------------------------------------------------------#"
  echo " At beginning of tracker script, the following imported variables "
  echo " are defined: "
  echo "   PDY ................................... $PDY"
  echo "   cyc ................................... $cyc"
  echo "   cmodel ................................ $cmodel"
  echo "   jobid ................................. $jobid"
  echo "   envir ................................. $envir"
  echo "   SENDCOM ............................... $SENDCOM"
  echo " "
  set -x
fi

syy=`echo ${PDY} | cut -c3-4`
smm=`echo ${PDY} | cut -c5-6`
sdd=`echo ${PDY} | cut -c7-8`
shh=${cyc}
symd=`echo ${PDY} | cut -c3-8`
syyyy=`echo ${PDY} | cut -c1-4`
CENT=`echo ${PDY} | cut -c1-2`

#------J.Peng----01-21-2015---------
#export COMOUTatcf=${COMOUTatcf:-${COMROOT}/nhc/${envir}/atcf}
#export archsyndir=${archsyndir:-${COMROOT}/arch/prod/syndat}
archsyndir=${archsyndir:-${COMINsyn:?}}
#export gltrkdir=${gltrkdir:-${COMROOT}/hur/${envir}/global}
gltrkdir=${gltrkdir:-${COMOUThur:?}}

wgrib_parmlist=" HGT:850 HGT:700 UGRD:850 UGRD:700 UGRD:500 VGRD:850 VGRD:700 VGRD:500 SurfaceU SurfaceV ABSV:850 ABSV:700 PRMSL:MSL "
wgrib_egrep_parmlist="HGT:850|HGT:700|UGRD:850|UGRD:700|UGRD:500|VGRD:850|VGRD:700|VGRD:500|UGRD:10 m |VGRD:10 m |ABSV:850|ABSV:700|PRMSL:MSL"
wgrib_ec_hires_parmlist=" GH:850 GH:700 U:850 U:700 U:500 V:850 V:700 V:500 10U:sfc 10V:sfc MSL:sfc "
wgrib_uk_hires_parmlist=' HGT:850 HGT:700 UGRD:850 UGRD:700 UGRD:500 VGRD:850 VGRD:700 VGRD:500 UGRD:sfc VGRD:sfc ABSV:850 ABSV:700 PRMSL:MSL '

#----------------------------------------------------------------#
#
#    --- Define data directories and data file names ---
#               
# Convert the input model to lowercase letters and check to see 
# if it's a valid model, and assign a model ID number to it.  
# This model ID number is passed into the Fortran program to 
# let the program know what set of forecast hours to use in the 
# ifhours array.  Also, set the directories for the operational 
# input GRIB data files and create templates for the file names.
#
# NOTE: Do NOT try to standardize this script by changing all of 
# these various data directories' variable names to be all the 
# same, such as "datadir".  As you'll see in the data cutting 
# part of this script below, different methods are used to cut 
# apart different models, thus it is important to know the 
# difference between them....
#----------------------------------------------------------------#

cmodel=`echo ${cmodel} | tr "[A-Z]" "[a-z]"`

case ${cmodel} in 

  ukmet) set +x; echo " "                                  ;
       echo " ++ operational high-res UKMET chosen"        ;
       echo " "; set -x                                    ;
       ukmetdir=${ukmetdir:-${COMINukmet:?}}                     ;
       ukmetgfile=pgbf                                     ;
       ukmetgfileb=.ukm.${PDY}${cyc}                       ;

       fcstlen=120                                         ;
#       fcsthrs=$(seq -f%02g -s' ' 0 6 $fcstlen)            ;
       fcsthrs=' 00 12 24 36 48 60 72 84 96 108 120'       ;
       atcfnum=17                                          ;
       atcfname="ukx "                                     ;
       atcfout="ukx"                                       ;
       modtyp='global'                                     ;
       model=3                                             ;;

  ecmwf) set +x; echo " "                                  ;
       echo " ++ operational high-res ECMWF chosen"        ;
       echo " "; set -x                                    ;
#       ecmwfdir=${ecmwfdir:-${DCOMROOT}/us007003/${PDY}/wgrbbul/ecmwf};
       ecmwfdir=${ecmwfdir:-${DCOM:?}}                     ;
       fcstlen=240                                         ;
       fcsthrs=$(seq -f%02g -s' ' 0 6 $fcstlen)            ;
       atcfnum=19                                          ;
       atcfname="emx "                                     ;
       atcfout="emx"                                       ;
       modtyp='global'                                     ;
       model=4                                             ;;

  eens) set +x; echo " "                                   ;
       echo " ++ ECMWF ensemble member ${pert} chosen"     ;
       echo " "; set -x                                    ;
       pert=` echo ${pert} | tr '[A-Z]' '[a-z]'`           ;
       PERT=` echo ${pert} | tr '[a-z]' '[A-Z]'`           ;
       syy=`echo ${PDY} | cut -c3-4`                       ;
       smm=`echo ${PDY} | cut -c5-6`                       ;
       sdd=`echo ${PDY} | cut -c7-8`                       ;
       shh=${cyc}                                          ;
       symd=`echo ${PDY} | cut -c3-8`                      ;
#       ecedir=${ecedir:-${COMROOT}/gens/${envir}/ecme.${PDY}/${cyc}};
       ecedir=${ecedir:-${COMIN:?}}                        ;
       fcstlen=240                                         ;
       fcsthrs=$(seq -f%02g -s' ' 0 6 $fcstlen)            ;
       atcfnum=91                                          ;
       pert_posneg=` echo "${pert}" | cut -c1-1`           ;
       pert_num=`    echo "${pert}" | cut -c2-3`           ;
       atcfname="e${pert_posneg}${pert_num}"               ;
       atcfout="e${pert_posneg}${pert_num}"                ;
       modtyp='global'                                     ;
       model=11                                            ;;

  sref) set +x; echo " "                                   ;
       echo " ++ operational SREF ensemble member ${pert} chosen";
       echo " "; set -x                                    ;
       pert=` echo ${pert} | tr '[A-Z]' '[a-z]'`           ;
       PERT=` echo ${pert} | tr '[a-z]' '[A-Z]'`           ;
       srtype=` echo ${pert} | cut -c1-2`                  ;
       srpertnum=` echo ${pert} | cut -c3-4`               ;

#       if [ ${srtype} = 'se' ]; then
#         # Eta members
#         if [ ${srpertnum} = 'c1' ]; then
#           srefgfile=sref_eta.t${cyc}z.pgrb221.ctl1.f
#         elif [ ${srpertnum} = 'c2' ]; then
#           srefgfile=sref_eta.t${cyc}z.pgrb221.ctl2.f
#         else
#           srefgfile=sref_eta.t${cyc}z.pgrb221.${srpertnum}.f
#         fi
       if [ ${srtype} = 'em' ]; then
         # ARW members
         if [ ${srpertnum} = 'c1' ]; then
           srefgfile=sref_em.t${cyc}z.pgrb221.ctl.f
         else
           srefgfile=sref_em.t${cyc}z.pgrb221.${srpertnum}.f
         fi
       elif [ ${srtype} = 'nb' ]; then
         # RSM members
         if [ ${srpertnum} = 'c1' ]; then
           srefgfile=sref_nmb.t${cyc}z.pgrb221.ctl.f
         else
           srefgfile=sref_nmb.t${cyc}z.pgrb221.${srpertnum}.f
         fi
       elif [ ${srtype} = 'nm' ]; then
         # NMM members
         if [ ${srpertnum} = 'c1' ]; then
           srefgfile=sref_nmm.t${cyc}z.pgrb221.ctl.f
         else
           srefgfile=sref_nmm.t${cyc}z.pgrb221.${srpertnum}.f
         fi
       else
         set +x
         echo " "
         echo "FATAL ERROR:  SREF MEMBER NOT RECOGNIZED."
         echo "!!!        USER INPUT SREF MEMBER = --->${pert}<---"
         echo " "
         set -x
         err_exit "SREF MEMBER ${pert} NOT RECOGNIZED"
       fi

#       srefdir=${srefdir:-${COMROOT}/sref/prod/sref.${PDY}/${cyc}/pgrb};
       srefdir=${srefdir:-${COMINsref:?}}                  ;
       fcstlen=87                                          ;
       fcsthrs=$(seq -w -s' ' 0 3 $fcstlen)                ;
       atcfnum=92                                          ;
       atcfname="${pert}"                                  ;
       atcfout="${pert}"                                   ;
       modtyp='regional'                                   ;
       model=13                                            ;;

  *) msg="FATAL ERROR:  Model $cmodel is not recognized."  ;
     echo "$msg"; postmsg $jlogfile "$msg"                 ;
     err_exit "FAILED ${jobid} -- UNKNOWN cmodel IN TRACKER SCRIPT - ABNORMAL EXIT";;

esac

#---------------------------------------------------------------#
#
#      --------  TC Vitals processing   --------
#
# Check Steve Lord's operational tcvitals file to see if any 
# vitals records were processed for this time by his system.  
# If there were, then you'll find a file in /com/gfs/prod/gfs.yymmdd 
# with the vitals in it.  Also check the raw TC Vitals file in
# /com/arch/prod/syndat , since this may contain storms that Steve's 
# system ignored (Steve's system will ignore all storms that are 
# either over land or very close to land);  We still want to track 
# these inland storms, AS LONG AS THEY ARE NHC STORMS (don't 
# bother trying to track inland storms that are outside of NHC's 
# domain of responsibility -- we don't need that info).
# UPDATE 5/12/98 MARCHOK: The script is updated so that for the
#   global models, the gfs directory is checked for the error-
#   checked vitals file, while for the regional models, the 
#   nam directory is checked for that file.
#--------------------------------------------------------------#

d6ago_ymdh=` ${NDATE:?} -6 ${PDY}${cyc}`
d6ago_4ymd=` echo ${d6ago_ymdh} | cut -c1-8`
d6ago_ymd=` echo ${d6ago_ymdh} | cut -c3-8`
d6ago_hh=`  echo ${d6ago_ymdh} | cut -c9-10`
d6ago_str="${d6ago_ymd} ${d6ago_hh}00"

d6ahead_ymdh=` ${NDATE:?} 6 ${PDY}${cyc}`
d6ahead_4ymd=` echo ${d6ahead_ymdh} | cut -c1-8`
d6ahead_ymd=` echo ${d6ahead_ymdh} | cut -c3-8`
d6ahead_hh=`  echo ${d6ahead_ymdh} | cut -c9-10`
d6ahead_str="${d6ahead_ymd} ${d6ahead_hh}00"

if [ ${modtyp} = 'global' ]
then
#  synvitdir=${COMROOT}/gfs/prod/gfs.${PDY}
  synvitdir=${COMINgfs:?}/${cyc}
  synvitfile=gfs.t${cyc}z.syndata.tcvitals.tm00
#  synvit6ago_dir=${COMROOT}/gfs/prod/gfs.${d6ago_4ymd}
  synvit6ago_dir=${synvitdir%.*}.${d6ago_4ymd}/${d6ago_hh}
  synvit6ago_file=gfs.t${d6ago_hh}z.syndata.tcvitals.tm00
#  synvit6ahead_dir=${COMROOT}/gfs/prod/gfs.${d6ahead_4ymd}
  synvit6ahead_dir=${synvitdir%.*}.${d6ahead_4ymd}/${d6ahead_hh}
  synvit6ahead_file=gfs.t${d6ahead_hh}z.syndata.tcvitals.tm00
else
  synvitdir=${COMINnam:?}
  synvitfile=nam.t${cyc}z.syndata.tcvitals.tm00
  synvit6ago_dir=${synvitdir%.*}.${d6ago_4ymd}
  synvit6ago_file=nam.t${d6ago_hh}z.syndata.tcvitals.tm00
  synvit6ahead_dir=${synvitdir%.*}.${d6ahead_4ymd}
  synvit6ahead_file=nam.t${d6ahead_hh}z.syndata.tcvitals.tm00

#  synvitdir=/ensemble/save/Jiayi.Peng/sref_tcvital/sref.${PDY}
#  synvitfile=sref.t${cyc}z.syndata.tcvitals.tm00
#  synvit6ago_dir=/ensemble/save/Jiayi.Peng/sref_tcvital/sref.${d6ago_4ymd}
#  synvit6ago_file=sref.t${d6ago_hh}z.syndata.tcvitals.tm00
#  synvit6ahead_dir=/ensemble/save/Jiayi.Peng/sref_tcvital/sref.${d6ahead_4ymd}
#  synvit6ahead_file=sref.t${d6ahead_hh}z.syndata.tcvitals.tm00
fi

set +x
echo " "
echo "              -----------------------------"
echo " "
echo " Now sorting and updating the TC Vitals file.  Please wait...."
echo " "
set -x

dnow_str="${symd} ${cyc}00"

if [ -s ${synvitdir}/${synvitfile} -o\
     -s ${synvit6ago_dir}/${synvit6ago_file} -o\
     -s ${synvit6ahead_dir}/${synvit6ahead_file} ]
then
  grep "${d6ago_str}" ${synvit6ago_dir}/${synvit6ago_file}        \
                  >${DATA}/tmpsynvit.${atcfout}.${PDY}${cyc}
  grep "${dnow_str}"  ${synvitdir}/${synvitfile}                  \
                 >>${DATA}/tmpsynvit.${atcfout}.${PDY}${cyc}
  grep "${d6ahead_str}" ${synvit6ahead_dir}/${synvit6ahead_file}  \
                 >>${DATA}/tmpsynvit.${atcfout}.${PDY}${cyc}
else
  set +x
  echo " "
  echo " There is no (synthetic) TC vitals file for ${cyc}z in ${synvitdir},"
  echo " nor is there a TC vitals file for ${d6ago_hh}z in ${synvit6ago_dir}."
  echo " nor is there a TC vitals file for ${d6ahead_hh}z in ${synvit6ahead_dir},"
  echo " Checking the raw TC Vitals file ....."
  echo " "
  set -x
fi

# Take the vitals from Steve Lord's /com/gfs/prod tcvitals file,
# and cat them with the NHC-only vitals from the raw, original
# /com/arch/prod/synda_tcvitals file.  Do this because the nwprod
# tcvitals file is the original tcvitals file, and Steve runs a
# program that ignores the vitals for a storm that's over land or
# even just too close to land, and for tracking purposes for the
# US regional models, we need these locations.  Only include these
# "inland" storm vitals for NHC (we're not going to track inland 
# storms that are outside of NHC's domain of responsibility -- we 
# don't need that info).  
# UPDATE 5/12/98 MARCHOK: nawk logic is added to screen NHC 
#   vitals such as "91L NAMELESS" or "89E NAMELESS", since TPC 
#   does not want tracks for such storms.

grep "${d6ago_str}" ${archsyndir}/syndat_tcvitals.${CENT}${syy}   | \
      grep -v TEST | awk 'substr($0,6,1) !~ /[8]/ {print $0}' \
      >${DATA}/tmprawvit.${atcfout}.${PDY}${cyc}
grep "${dnow_str}"  ${archsyndir}/syndat_tcvitals.${CENT}${syy}   | \
      grep -v TEST | awk 'substr($0,6,1) !~ /[8]/ {print $0}' \
      >>${DATA}/tmprawvit.${atcfout}.${PDY}${cyc}
grep "${d6ahead_str}" ${archsyndir}/syndat_tcvitals.${CENT}${syy} | \
      grep -v TEST | awk 'substr($0,6,1) !~ /[8]/ {print $0}' \
      >>${DATA}/tmprawvit.${atcfout}.${PDY}${cyc}

#PRODTEST# Use the next couple lines to test the tracker on the SP.
#PRODTEST# These next couple lines use data from a test TC Vitals file that 
#PRODTEST# I generate.  When you are ready to test this system, call me and
#PRODTEST# I'll create one for the current day, and then uncomment the next
#PRODTEST# couple lines in order to access the test vitals file.
#
#ttrkdir=/nfsuser/g01/wx20tm/trak/prod/data
#ttrkdir=/nfsuser/g01/wx20tm/trak/para/scripts
#grep "${dnow_str}" ${ttrkdir}/tcvit.01l >>${DATA}/tmprawvit.${atcfout}.${PDY}${cyc}


# IMPORTANT:  When "cat-ing" these files, make sure that the vitals
# files from the "raw" TC vitals files are first in order and Steve's
# TC vitals files second.  This is because Steve's vitals file has
# been error-checked, so if we have a duplicate tc vitals record in
# these 2 files (very likely), program supvit.x below will
# only take the last vitals record listed for a particular storm in
# the vitals file (all previous duplicates are ignored, and Steve's
# error-checked vitals records are kept).

cat ${DATA}/tmprawvit.${atcfout}.${PDY}${cyc} ${DATA}/tmpsynvit.${atcfout}.${PDY}${cyc} \
        >${DATA}/vitals.${atcfout}.${PDY}${cyc}

# If we are doing the processing for the GFDL model, then we want
# to further cut down on which vitals we allow into this run of the
# tracker.  The reason is that this program will be called from 
# each individual run for a storm, so the grib files will be 
# specific to each storm.  So if 4 storms are being run at a 
# particular cycle, then this script is run 4 separate times from
# within the GFDL_POST job.

if [ ${cmodel} = 'gfdl' ]; then
  grep -i ${stormid} ${COMIN}/${ATCFNAME}.vitals.${syy}${smm}${sdd}${shh} >${DATA}/tmpvit
  mv ${DATA}/tmpvit ${DATA}/vitals.${atcfout}.${PDY}${cyc}
fi

#--------------------------------------------------------------#
# Now run a fortran program that will read all the TC vitals
# records for the current dtg and the dtg from 6h ago, and
# sort out any duplicates.  If the program finds a storm that
# was included in the vitals file 6h ago but not for the current
# dtg, this program updates the 6h-old first guess position
# and puts these updated records as well as the records from
# the current dtg into a temporary vitals file.  It is this
# temporary vitals file that is then used as the input for the
# tracking program.
#--------------------------------------------------------------#

ymdh6ago=` ${NDATE:?} -6 ${PDY}${cyc}`
syy6=`echo ${ymdh6ago} | cut -c3-4`
smm6=`echo ${ymdh6ago} | cut -c5-6`
sdd6=`echo ${ymdh6ago} | cut -c7-8`
shh6=`echo ${ymdh6ago} | cut -c9-10`
symd6=${syy6}${smm6}${sdd6}

ymdh6ahead=` ${NDATE:?} 6 ${PDY}${cyc}`
syyp6=`echo ${ymdh6ahead} | cut -c3-4`
smmp6=`echo ${ymdh6ahead} | cut -c5-6`
sddp6=`echo ${ymdh6ahead} | cut -c7-8`
shhp6=`echo ${ymdh6ahead} | cut -c9-10`
symdp6=${syyp6}${smmp6}${sddp6}

echo "&datenowin   dnow%yy=${syy}, dnow%mm=${smm},"       >${DATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "             dnow%dd=${sdd}, dnow%hh=${cyc}/"      >>${DATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "&date6agoin  d6ago%yy=${syy6}, d6ago%mm=${smm6},"  >>${DATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "             d6ago%dd=${sdd6}, d6ago%hh=${shh6}/"  >>${DATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "&date6aheadin  d6ahead%yy=${syyp6}, d6ahead%mm=${smmp6},"  >>${DATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "               d6ahead%dd=${sddp6}, d6ahead%hh=${shhp6}/"  >>${DATA}/suv_input.${atcfout}.${PDY}${cyc}

numvitrecs=`cat ${DATA}/vitals.${atcfout}.${PDY}${cyc} | wc -l`
if [ ${numvitrecs} -eq 0 ]
then
  set +x
  echo " "
  echo "!!! WARNING -- There are no vitals records for this time period."
  echo "!!! File ${DATA}/vitals.${atcfout}.${PDY}${cyc} is empty."
  echo "!!! It could just be that there are no storms for the current"
  echo "!!! time.  You may wish to check the date and submit this job again..."
  echo " "
  set -x
  exit 0
fi

# - - - - - - - - - - - - -
# Before running the program to read, sort and update the vitals,
# first run the vitals through some awk logic, the purpose of 
# which is to convert all the 2-digit years into 4-digit years.
# Beginning 4/21/99, NHC and JTWC will begin sending the vitals
# with 4-digit years, however it is unknown when other global
# forecasting centers will begin using 4-digit years, thus we
# need the following logic to ensure that all the vitals going
# into supvit.f have uniform, 4-digit years in their records.
#
# 1/8/2000: sed code added by Tim Marchok due to the fact that 
#       some of the vitals were getting past the syndata/qctropcy
#       error-checking with a colon in them; the colon appeared
#       in the character immediately to the left of the date, which
#       was messing up the "(length($4) == 8)" statement logic.
# - - - - - - - - - - - - -

sed -e "s/\:/ /g"  ${DATA}/vitals.${atcfout}.${PDY}${cyc} > ${DATA}/tempvit
mv ${DATA}/tempvit ${DATA}/vitals.${atcfout}.${PDY}${cyc}

awk '
{
  yycheck = substr($0,20,2)
  if ((yycheck == 20 || yycheck == 19) && (length($4) == 8)) {
    printf ("%s\n",$0)
  }
  else {
    if (yycheck >= 0 && yycheck <= 50) {
      printf ("%s20%s\n",substr($0,1,19),substr($0,20))
    }
    else {
      printf ("%s19%s\n",substr($0,1,19),substr($0,20))
    }
  }
} ' ${DATA}/vitals.${atcfout}.${PDY}${cyc} >${DATA}/vitals.${atcfout}.${PDY}${cyc}.y4

mv ${DATA}/vitals.${atcfout}.${PDY}${cyc}.y4 ${DATA}/vitals.${atcfout}.${PDY}${cyc}

export pgm=supvit_g1
. prep_step

# Input file
export FORT31=${DATA}/vitals.${atcfout}.${PDY}${cyc}

# Output file
export FORT51=${DATA}/vitals.upd.${atcfout}.${PDY}${cyc}

msg="$pgm start for $atcfout at ${cyc}z"
postmsg "$jlogfile" "$msg"

${EXECens_tracker}/supvit_g1 <${DATA}/suv_input.${atcfout}.${PDY}${cyc}
suvrcc=$?

if [ ${suvrcc} -eq 0 ]
then
  msg="$pgm end for $atcfout at ${cyc}z completed normally"
  postmsg "$jlogfile" "$msg"
else
  set +x
  echo " "
  echo "FATAL ERROR:  An error occurred while running supvit.x, "
  echo "!!! which is the program that updates the TC Vitals file."
  echo "!!! Return code from supvit.x = ${suvrcc}"
  echo "!!! model= ${atcfout}, forecast initial time = ${PDY}${cyc}"
  echo " "
  set -x
  err_exit "FAILED ${jobid} - ERROR RUNNING supvit_g1 IN TRACKER SCRIPT- ABNORMAL EXIT"
fi

#------------------------------------------------------------------#
# Now select all storms to be processed, that is, process every
# storm that's listed in the updated vitals file for the current
# forecast hour.  If there are no storms for the current time,
# then exit.
#------------------------------------------------------------------#

numvitrecs=`cat ${DATA}/vitals.upd.${atcfout}.${PDY}${cyc} | wc -l`
if [ ${numvitrecs} -eq 0 ]
then
  set +x
  echo " "
  echo "!!! WARNING -- There are no vitals records for this time period "
  echo "!!! in the UPDATED vitals file."
  echo "!!! It could just be that there are no storms for the current"
  echo "!!! time.  You may wish to check the date and submit this job again..."
  echo " "
  set -x
  exit 0
fi

set +x
echo " "
echo " *--------------------------------*"
echo " |        STORM SELECTION         |"
echo " *--------------------------------*"
echo " "
set -x

ict=1
while [ $ict -le 15 ]
do
  stormflag[${ict}]=3
  let ict=ict+1
done

dtg_current="${symd} ${cyc}00"
stormmax=` grep "${dtg_current}" ${DATA}/vitals.upd.${atcfout}.${PDY}${cyc} | wc -l`

if [ ${stormmax} -gt 15 ]
then
  stormmax=15
fi

sct=1
while [ ${sct} -le ${stormmax} ]
do
  stormflag[${sct}]=1
  let sct=sct+1
done


#-----------------------------------------------------------------#
#
#         ------  CUT APART INPUT GRIB FILES  -------
#
# For the selected model, cut apart the GRIB input files in order
# to pull out only the variables that we need for the tracker.  
# Put these selected variables from all forecast hours into 1 big 
# GRIB file that we'll use as input for the tracker.
# 
# The wgrib utility (/nwprod/util/exec/wgrib) is used to cut out 
# the needed parms for the GFS, MRF, GDAS, UKMET and NOGAPS files.
# The utility /nwprod/util/exec/copygb is used to interpolate the 
# NGM (polar stereographic) and NAM (Lambert Conformal) data from 
# their grids onto lat/lon grids.  Note that while the lat/lon 
# grid that I specify overlaps into areas that don't have any data 
# on the original grid, Mark Iredell wrote the copygb software so 
# that it will mask such "no-data" points with a bitmap (just be 
# sure to check the lbms in your fortran program after getgb).
#-----------------------------------------------------------------#

set +x
echo " "
echo " -----------------------------------------"
echo "   NOW CUTTING APART INPUT GRIB FILES TO "
echo "   CREATE 1 BIG GRIB INPUT FILE "
echo " -----------------------------------------"
echo " "
set -x

regflag=`grep NHC ${DATA}/vitals.upd.${atcfout}.${PDY}${cyc} | wc -l`

# ------------------------------
#   Process ECMWF, if selected
# ------------------------------

# As of Summer, 2005, ECMWF is now sending us high res (1-degree) data on
# a global grid with 12-hourly resolution out to 240h.  Previously, we 
# only got their data on a low res (2.5-degree) grid, from 35N-35S, with
# 24-hourly resolution out to only 168h.

if [ ${model} -eq 4 ]
then

  if [ -s ${DATA}/ecgribfile.${PDY}${cyc} ]
  then
    rm ${DATA}/ecgribfile.${PDY}${cyc}
  fi

  immddhh=`echo ${PDY}${cyc}| cut -c5-`
  ict=0

  for fhour in ${fcsthrs}
  do
    
    let fhr=ict*6

    echo "fhr= $fhr"
    fmmddhh=` ${NDATE:?} ${fhr} ${PDY}${cyc} | cut -c5- `
    #ec_hires_orig=ecens_DCD${immddhh}00${fmmddhh}001 # Original
    if [ ${fmmddhh} -eq ${immddhh} ]; then
      ec_hires_orig=U1D${immddhh}00${fmmddhh}011
    else
      ec_hires_orig=U1D${immddhh}00${fmmddhh}001
    fi

    ecfile=${ecmwfdir}/${ec_hires_orig}

    let attempts=1
    while [ $attempts -le 30 ]; do
       if [ -s $ecfile ]; then
          break
       else
          sleep 60
          let attempts=attempts+1
       fi
    done
    if [ $attempts -gt 30 ] && [ ! -s $ecfile ]; then
       err_exit "$ecfile still not available after waiting 30 minutes... exiting"
    fi
      
    ${WGRIB:?} -s $ecfile >ec.ix
    export err=$?; err_chk

    for parm in ${wgrib_ec_hires_parmlist}
    do
      grep "${parm}" ec.ix | ${WGRIB:?} -s $ecfile -i -grib -append \
                              -o ${DATA}/ecgribfile.${PDY}${cyc}
    done

    let ict=ict+1

  done

  ${GRBINDEX:?} ${DATA}/ecgribfile.${PDY}${cyc} ${DATA}/ecixfile.${PDY}${cyc}
  export err=$?; err_chk
  gribfile=${DATA}/ecgribfile.${PDY}${cyc}
  ixfile=${DATA}/ecixfile.${PDY}${cyc}

fi

# --------------------------------------------------
#   Process ECMWF Ensemble perturbation, if selected
# --------------------------------------------------

if [ ${model} -eq 11 ]
then
    
  if [ -s ${DATA}/ece${pert}gribfile.${PDY}${cyc} ]
  then
    rm ${DATA}/ece${pert}gribfile.${PDY}${cyc}
  fi
    
  if [ ${pert_posneg} = 'n' ]; then
    posneg=2
  elif [ ${pert_posneg} = 'p' ]; then
    posneg=3
  elif [ ${pert_posneg} = 'c' ]; then
    # low-res control
    posneg=1
  else
    set +x
    echo " "
    echo "FATAL ERROR:  ECMWF PERT ID NOT RECOGNIZED"
    echo "!!! pert_posneg=${pert_posneg}"
    echo " "
    set -x
    err_exit "ECMWF PERT ID ${pert_posneg} NOT RECOGNIZED"
  fi
    
  pnum=${pert_num}
  if [ ${pnum} -lt 10 ]; then
    pnum=` echo $pnum | cut -c2-2`
  fi

  if [ ${pnum} -eq 0 ]; then
    # low-res control
    pnum=2
  fi
    
  pert_grep_str=" 0 0 0 1 ${posneg} ${pnum} 1 "

  glo=${DATA}/ece.lores.cut.${PDY}${cyc}
  xlo=${DATA}/ece.lores.cut.${PDY}${cyc}.i

  if [ -s ${glo} ]; then rm ${glo}; fi
  if [ -s ${xlo} ]; then rm ${xlo}; fi

  grid="255 0 360 181 90000 0000 128 -90000 -1000 1000 1000 0"

  # This next part simply uses wgrib to parse out
  # the member records for each variable from each
  # respective enspost file.

  for var in u850 v850 u700 v700 z850 z700 mslp u500 v500 u10m v10m
  do
#    ecegfile=enspost.t${cyc}z.${var}
    ecegfile=ensposte.t${cyc}z.${var}hr

    if [ ! -s ${ecedir:?}/${ecegfile} ]
    then
      set +x
      echo " "
      echo "FATAL ERROR:  ECMWF ENSEMBLE POST File missing: ${ecedir}/${ecegfile}"
      echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      echo " "
      set -x
      err_exit "FAILED ${jobid} - MISSING ECMWF ENSEMBLE FILE IN TRACKER SCRIPT - ABNORMAL EXIT"
    fi
      
    ece_orig=${ecedir}/${ecegfile}
      
    ${WGRIB:?} -PDS10 ${ece_orig} | grep "${pert_grep_str}" | \
          awk -F:TR= '{print $1}'                       | \
          ${WGRIB:?} -i ${ece_orig} -grib -append -o ${glo}
    export err=$?; err_chk
      
  done
     
  # ECMWF data are 2.5-degree data, so for consistency
  # with the NCEP ensemble data, we now use copygb to
  # interpolate down to 1-degree.  The -g3 in the copygb
  # statement is for grid 3, a 1x1 global grid (AVN).
      
  ${GRBINDEX:?} ${glo} ${xlo}
  export err=$?; err_chk
  gfile=${DATA}/ece${pert}gribfile.${PDY}${cyc}

#  ${COPYGB:?} -g"${grid}" -a ${glo} ${xlo} ${gfile}
#  ${GRBINDEX:?} ${DATA}/ece${pert}gribfile.${PDY}${cyc} ${DATA}/ece${pert}ixfile.${PDY}${cyc}
#  export err=$?; err_chk
   mv ${glo} ${gfile}  
   mv ${xlo} ${DATA}/ece${pert}ixfile.${PDY}${cyc}

  gribfile=${DATA}/ece${pert}gribfile.${PDY}${cyc}
  ixfile=${DATA}/ece${pert}ixfile.${PDY}${cyc}
      
fi    

# --------------------------------------------------
#   Process SREF Ensemble perturbation, if selected
# --------------------------------------------------

if [ ${model} -eq 13 ]
then

      grid='255 0 381 161 80000 160000 128 0000 350000  500  500 0'
#    grid='255 0 301 141 70000 190000 128 0000 340000  500  500 0'
    if [ ${regflag} -eq 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR:  SREF ensemble has been selected, but there are no storms in the"
        echo "!!! TC Vitals file that can be processed.  That is, there are no"
        echo "!!! Vitals records from NHC.  The vitals records that are in the"
        echo "!!! updated vitals file must be from another cyclone forecast "
        echo "!!! center, and the SREF domain does not extend to any "
        echo "!!! region other than that covered by NHC.  Exiting....."
        set -x
        err_exit "SREF ensemble has been selected but there are no storms in the TC Vitals file."
    fi

    if [ -s ${DATA}/sref${pert}gribfile.${PDY}${cyc} ]; then
      rm ${DATA}/sref${pert}gribfile.${PDY}${cyc}
    fi

    for fhour in ${fcsthrs}
    do

      if [ ! -s ${srefdir}/${srefgfile}${fhour} ]
      then
        set +x
        echo " "
	    echo " FATAL ERROR:  SREF ENSEMBLE ${PERT} File missing ${srefdir}/${srefgfile}${fhour}"
	    echo " !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
        echo " "
        set -x
	    err_exit "SREF ENSEMBLE ${PERT} File missing ${srefdir}/${srefgfile}${fhour}"
      fi

      if [ -s ${DATA}/tmpsrefixfile ]; then rm ${DATA}/tmpsrefixfile; fi
      ${GRBINDEX:?} ${srefdir}/${srefgfile}${fhour} ${DATA}/tmpsrefixfile
      export err=$?; err_chk
      x1=${DATA}/tmpsrefixfile
		   
#      set +x
#      echo " "
#      echo " Extracting SREF GRIB data for pert ${pert} for forecast hour = $fhour"
#      echo " "
#      set -x
						  
      g1=${srefdir}/${srefgfile}${fhour}
							 
      ${COPYGB:?} -g"$grid" -k'4*-1 33 100 850' $g1 $x1 ${DATA}/srefllu850.${pert}.grb.f${fhour};   rcc1=$?
      ${COPYGB:?} -g"$grid" -k'4*-1 33 100 700' $g1 $x1 ${DATA}/srefllu700.${pert}.grb.f${fhour};   rcc2=$?
      ${COPYGB:?} -g"$grid" -k'4*-1 33 100 500' $g1 $x1 ${DATA}/srefllu500.${pert}.grb.f${fhour};   rcc3=$?
      ${COPYGB:?} -g"$grid" -k'4*-1 33 105 10'  $g1 $x1 ${DATA}/srefllu10m.${pert}.grb.f${fhour};   rcc4=$?
      ${COPYGB:?} -g"$grid" -k'4*-1 41 100 850' $g1 $x1 ${DATA}/srefllav850.${pert}.grb.f${fhour};  rcc5=$?
      ${COPYGB:?} -g"$grid" -k'4*-1 41 100 700' $g1 $x1 ${DATA}/srefllav700.${pert}.grb.f${fhour};  rcc6=$?
      ${COPYGB:?} -g"$grid" -k'4*-1  7 100 850' $g1 $x1 ${DATA}/srefllz850.${pert}.grb.f${fhour};   rcc7=$?
      ${COPYGB:?} -g"$grid" -k'4*-1  7 100 700' $g1 $x1 ${DATA}/srefllz700.${pert}.grb.f${fhour};   rcc8=$?
      ${COPYGB:?} -g"$grid" -k'4*-1  2 102   0' $g1 $x1 ${DATA}/srefllmslp.${pert}.grb.f${fhour};   rcc9=$?

      if [ $rcc1 -eq 134 -o $rcc2 -eq 134 -o $rcc3 -eq 134 -o $rcc4 -eq 134 -o $rcc5 -eq 134 -o \
           $rcc6 -eq 134 -o $rcc7 -eq 134 -o $rcc8 -eq 134 -o $rcc9 -eq 134 ]
      then
        set +x
        echo " "
        echo "FATAL ERROR:  $COPYGB interpolation of sref data.  We will stop execution because"
        echo "!!! some variables may have been copied okay, while some obviously have not, "
        echo "!!! and that could lead to unreliable results from the tracker.  Check to make"
        echo "!!! sure you've allocated enough memory for this job.  Exiting...."
        echo " "
        set -x
        err_exit "FAILED ${jobid} - ERROR INTERPOLATING SREF DATA IN TRACKER SCRIPT - ABNORMAL EXIT"
      fi

      cat ${DATA}/srefllu850.${pert}.grb.f${fhour}   ${DATA}/srefllu700.${pert}.grb.f${fhour} \
          ${DATA}/srefllu500.${pert}.grb.f${fhour}   ${DATA}/srefllz850.${pert}.grb.f${fhour} \
          ${DATA}/srefllz700.${pert}.grb.f${fhour}   ${DATA}/srefllmslp.${pert}.grb.f${fhour} \
          ${DATA}/srefllav850.${pert}.grb.f${fhour}  ${DATA}/srefllav700.${pert}.grb.f${fhour} \
          ${DATA}/srefllu10m.${pert}.grb.f${fhour} \
          >>${DATA}/sref${pert}gribfile.${PDY}${cyc}

    done

    ${GRBINDEX:?} ${DATA}/sref${pert}gribfile.${PDY}${cyc} ${DATA}/sref${pert}ixfile.${PDY}${cyc}
    export err=$?; err_chk
    gribfile=${DATA}/sref${pert}gribfile.${PDY}${cyc}
    ixfile=${DATA}/sref${pert}ixfile.${PDY}${cyc}
       
fi

# ------------------------------
#   Process UKMET, if selected
# ------------------------------
if [ ${model} -eq 3 ]
then
 
  if [ -s ${DATA}/ukmetgribfile.${PDY}${cyc} ]
  then
    rm ${DATA}/ukmetgribfile.${PDY}${cyc}
  fi

  for fhour in ${fcsthrs}
  do
    ukfile=${ukmetdir}/${ukmetgfile}${fhour}${ukmetgfileb}
    
    let attempts=1
    while [ $attempts -le 30 ]; do
      if [ -s $ukfile ]; then
        break
      else
        sleep 60
        let attempts=attempts+1
      fi
    done
    if [ $attempts -gt 30 ] && [ ! -s $ukfile ]; then
      err_exit "$ukfile still not available after waiting 30 minutes... exiting"
    fi

    ${WGRIB:?} -s $ukfile >ukmet.ix
    export err=$?; err_chk

    for parm in ${wgrib_uk_hires_parmlist}
    do
      grep "${parm}" ukmet.ix | ${WGRIB:?} -s $ukfile -i -grib -append \
                              -o ${DATA}/ukmetgribfile.${PDY}${cyc}
    done

  done

  ${GRBINDEX:?} ${DATA}/ukmetgribfile.${PDY}${cyc} ${DATA}/ukmetixfile.${PDY}${cyc}
  export err=$?; err_chk
  gribfile=${DATA}/ukmetgribfile.${PDY}${cyc}
  ixfile=${DATA}/ukmetixfile.${PDY}${cyc}

fi  

set +x
echo "TIMING: Time in extrkr.sh after gribcut for pert= $pert is `date`"
set -x

#------------------------------------------------------------------------#
#                         Now run the tracker                            #
#------------------------------------------------------------------------#
set +x
echo " "
echo " -----------------------------------------------"
echo "           NOW EXECUTING TRACKER......"
echo " -----------------------------------------------"
echo " "
set -x

ist=1
while [ $ist -le 15 ]
do
  if [ ${stormflag[${ist}]} -ne 1 ]
  then
    set +x; echo "Storm number $ist NOT selected for processing"; set -x
  else
    set +x; echo "Storm number $ist IS selected for processing...."; set -x
  fi
  let ist=ist+1
done

# Load the forecast hours for this particular model into an array 
# that will be passed into the executable via a namelist....

set -A fh $fcsthrs

namelist=${DATA}/input.${atcfout}.${PDY}${cyc}
ATCFNAME=` echo "${atcfname}" | tr '[a-z]' '[A-Z]'`
  
echo -n "&datein inp%byy=${syy},inp%bmm=${smm},inp%bdd=${sdd},"    >${namelist}
echo    "        inp%bhh=${shh},inp%model=${model}/"              >>${namelist}
echo -n "&stormlist stswitch = ${stormflag[1]},${stormflag[2]},"  >>${namelist}
echo -n " ${stormflag[3]},${stormflag[4]},${stormflag[5]},"       >>${namelist}
echo -n " ${stormflag[6]},${stormflag[7]},${stormflag[8]},"       >>${namelist}
echo -n " ${stormflag[9]},${stormflag[10]},${stormflag[11]},"     >>${namelist}
echo -n " ${stormflag[12]},${stormflag[13]},${stormflag[14]},"    >>${namelist}
echo    " ${stormflag[15]}/"                                      >>${namelist}
echo -n "&fhlist itmphrs = "                                      >>${namelist}
for ifh in {0..63}; do
  echo -n "${fh[$ifh]:-99},"                                      >>${namelist}
done
echo    "${fh[64]:-99}/"                                          >>${namelist}
echo    "&atcfinfo atcfnum=${atcfnum},atcfname='${ATCFNAME}'/"    >>${namelist}

export pgm=gettrk_g1
. prep_step

# Input files
export FORT11=${gribfile}
export FORT12=${DATA}/vitals.upd.${atcfout}.${PDY}${shh}
export FORT31=${ixfile}

# Output files
export FORT61=${DATA}/trak.${atcfout}.all.${PDY}${cyc}
export FORT62=${DATA}/trak.${atcfout}.atcf.${PDY}${cyc}
export FORT63=${DATA}/trak.${atcfout}.radii.${PDY}${cyc}
export FORT64=${DATA}/trak.${atcfout}.atcfunix.${PDY}${cyc}


msg="$pgm start for $atcfout at ${cyc}z"
postmsg "$jlogfile" "$msg"

${EXECens_tracker}/gettrk_g1 <${namelist}
gettrk_rcc=$?

if [ ${gettrk_rcc} -ne 0 ]; then
  set +x
  echo " "
  echo "FATAL ERROR:  An error occurred while running gettrk.x, "
  echo "!!! which is the program that actually gets the track."
  echo "!!! Return code from gettrk.x = ${gettrk_rcc}"
  echo "!!! model= ${atcfout}, forecast initial time = ${PDY}${cyc}"
  echo " "
  set -x
  err_exit "FAILED ${jobid} - ERROR RUNNING gettrk_g1 IN TRACKER SCRIPT- ABNORMAL EXIT"
fi

set +x
echo "TIMING: Time in extrkr.sh after gettrk for pert= $pert is `date`"
set -x

#--------------------------------------------------------------#
# Now copy the output track files to different directories
#--------------------------------------------------------------#

set +x
echo " "
echo " -----------------------------------------------"
echo "    NOW COPYING OUTPUT TRACK FILES TO COM"
echo " -----------------------------------------------"
echo " "
set -x

# Copy atcf files to NHC archives. We'll use Steve Lord's original script,
# distatcf.sh, to do this, and that script requires the input atcf file to
# have the name "attk126", so first copy the file to that name, then call
# the distatcf.sh script.  After that's done, then copy the full 0-72h
# track into the /com/hur/prod/global track archive file.

if [ "$SENDCOM" = 'YES' ]
then

  glatuxarch=${glatuxarch:-${gltrkdir}/tracks.atcfunix.${syy}}
  cat ${DATA}/trak.${atcfout}.atcfunix.${PDY}${cyc}  >>${glatuxarch}

  if [ ${cmodel} = 'gfdl' ]
  then
    cp ${DATA}/trak.${atcfout}.atcfunix.${PDY}${cyc} ${COMOUT}/${stormenv}.${PDY}${cyc}.trackeratcfunix
  else
    cp ${DATA}/trak.${atcfout}.atcfunix.${PDY}${cyc} ${COMOUT}/${atcfout}.t${cyc}z.cyclone.trackatcfunix
  fi

  # ukmet only has 12 hours interval, not alert - 02/02/2018
  #if [ "$SENDDBN" = 'YES' ]
  #then
  #  if [ ${cmodel} = 'ukmet' ]
  #  then
  #    $DBNROOT/bin/dbn_alert MODEL ENS_TRACKER $job ${COMOUT}/${atcfout}.t${cyc}z.cyclone.trackatcfunix
  #  fi
  #fi

# ------------------------------------------
# Cat atcfunix files to storm trackers files
# ------------------------------------------
#
# We need to parse apart the atcfunix file and distribute the forecasts to
# the necessary directories.  To do this, first sort the atcfunix records
# by forecast hour (k6), then sort again by ocean basin (k1), storm number (k2)
# and then quadrant radii wind threshold (k12).  Once you've got that organized
# file, break the file up by putting all the forecast records for each storm
# into a separate file.  Then, for each file, find the corresponding atcfunix
# file in the storm trackers directory and dump the atcfunix records for that storm
# in there.  NOTE: Only do this if the model run is NOT for the CMC or
# ECMWF ensemble.  The reason is that we do NOT want to write out the individual
# member tracks to the atcfunix file.  We only want to write out the ensemble
# mean track to the atcfunix file, and the mean track is calculated and written
# out in a separate script.

#  if [ $cmodel != 'ece' -a $cmodel != 'cens' -a $cmodel != gfs_enr ]; then
  if [ ${cmodel} = 'gfdl' ]
  then
    auxfile=${COMOUT}/${stormenv}.${PDY}${cyc}.trackeratcfunix
  else
    auxfile=${DATA}/trak.${atcfout}.atcfunix.${PDY}${cyc}
  fi

  sort -k6 ${auxfile} | sort -k1 -k2 -k12  >atcfunix.sorted
  old_string="XX, XX"

  ict=0
  while read unixrec
  do
    storm_string=` echo "${unixrec}" | cut -c1-6`
    if [ "${storm_string}" = "${old_string}" ]
    then
      echo "${unixrec}" >>atcfunix_file.${ict}
    else
      let ict=ict+1
      echo "${unixrec}"  >atcfunix_file.${ict}
      old_string="${storm_string}"
    fi
  done <atcfunix.sorted

  if [ $ict -gt 0 ]
  then
    mct=0
    while [ $mct -lt $ict ]
    do
      let mct=mct+1
      at=` head -1 atcfunix_file.$mct | cut -c1-2 | tr '[A-Z]' '[a-z]'`
      NO=` head -1 atcfunix_file.$mct | cut -c5-6`

      if [ ! -d ${COMOUTatcf:?}/${at}${NO}${syyyy} ]
      then
        mkdir -p $COMOUTatcf/${at}${NO}${syyyy}
      fi
      cat atcfunix_file.$mct >>$COMOUTatcf/${at}${NO}${syyyy}/ncep_a${at}${NO}${syyyy}.dat
      set +x
      echo " "
      echo "+++ Adding records to  TPC ATCFUNIX directory: $COMOUTatcf/${at}${NO}${syyyy}/ncep_${at}${NO}${syyyy}"
      echo " "
      set -x
    done
  fi
fi

#!/bin/bash
if [ $# -ne 9 ] ; then
  echo "Usage: $0 oname nst iall imas iwnd fchr fdhr dtg sfc"
  exit 1
fi

set -xeua

export HOMEcfs=${HOMEcfs:-/nwprod}
export USHcfs=${USHcfs:-$HOMEcfs/ush}
export cfss=${cfss:-/cfs}
export cfsp=${cfsp:-cfs_}
export EXECcfs=${EXECcfs:-$HOMEcfs/exec}

export oname=$1
export nst=$2
export iall=$3
export imas=$4
export iwnd=$5
export fchr=$6
export fdhr=$7
export dtg=$8
export sfc=$9

yyyy=`echo $dtg | cut -c1-4`
yy=`echo $dtg | cut -c3-4`
mm=`echo $dtg | cut -c5-6`
mon=`$USHcfs/cfs_cmon.sh $mm`
dd=`echo $dtg | cut -c7-8`
hh=`echo $dtg | cut -c9-10`

export outfile=$outdir/$oname.$typ.$dtg
export prtfile=$prtdir/$oname.$typ.$dtg.out

export outname=$oname

if [ $sfc -eq 1 ] ; then
  $EXECcfs/${cfsp}bufrslsfc.x > $prtfile
elif [ $sfc -eq 2 ] ; then
  if [ $iprs -eq 1 ] ; then
    outname=$oname.mand.$typ.$dtg
    outfile=$outdir/$outname
  elif [ $iprs -eq 0 ] ; then
    outname=$oname.mdlsig.$typ.$dtg
    outfile=$outdir/$outname
  elif [ $iprs -eq 2 ] ; then
    outname=$oname.all.$typ.$dtg
    outfile=$outdir/$outname
  fi
  $EXECcfs/${cfsp}bufrslupao.x >> $prtfile
elif [ $sfc -eq 3 ] ; then
  $EXECcfs/${cfsp}bufrslslev.x >> $prtfile
elif [ $sfc -eq 4 ] ; then
  $EXECcfs/${cfsp}bufrsltovs.x >> $prtfile
elif [ $sfc -eq 5 ] ; then
  $EXECcfs/${cfsp}bufrslssmi.x >> $prtfile
fi

###cat $prtfile

export err=$?; $DATA/err_chk

if [ "$CHGRP_RSTPROD" = 'YES' ]; then
  if [ -s $outfile ]; then
    chgrp rstprod $outfile
    chmod 640 $outfile
  fi
fi
set +e
grep 'number of stations 0' $prtfile
ese=$?
if [ $ese -eq 0 ] ; then
 echo "number of stations 0 for $dtg"
fi
set -e

#!/bin/ksh
set -x

export cmodel=fens
export loopnum=1
export ymdh=${PDY}${cyc}

export fensdir=${DCOM}

export trkrtype=tcgen
export trkrebd=350.0
export trkrwbd=105.0
export trkrnbd=30.0
export trkrsbd=5.0
export mslpthresh=0.0015
export v850thresh=1.5000
export regtype=altg

mkdir ${DATA}/${cmodel}
cd ${DATA}/${cmodel}

pertstring=' c00 p01 p02 p03 p04 p05 p06 p07 p08 p09 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20'
>trkr.cmdfile
for pert in ${pertstring}; do
  export pertdir=${DATA}/${cmodel}/${pert}
  mkdir -p $pertdir

  outfile=${pertdir}/trkr.${regtype}.${cmodel}.${pert}.${ymdh}.out
  echo "${USHens_tracker}/extrkr_gen_g2.sh ${loopnum} ${cmodel} ${pert} ${pertdir} &>${outfile}" >>trkr.cmdfile
done

chmod u+x trkr.cmdfile
export MP_PGMMODEL=mpmd
export MP_CMDFILE=${DATA}/${cmodel}/trkr.cmdfile

mac=`echo ${SITE}`
if [ $mac = TIDE -o $mac = GYRE ] ; then # For WCOSS
  machine=wcoss
  mpirun.lsf
elif [ $mac = LUNA -o $mac = SURGE ] ; then # For CRAY
  machine=cray
  ${APRUNTRACK} cfp ${MP_CMDFILE}
fi

#-------------------------------------------------------
for pert in ${pertstring}; do
  export atcfout="n${pert}"
  export TRKDATA=${DATA}/${cmodel}/${pert}
  ${USHens_tracker}/sort_tracks.gen.sh  >${TRKDATA}/sort.${regtype}.${atcfout}.${ymdh}.out
  export err=$?; err_chk

#  cp ${TRKDATA}/trak.f*.atcfunix.altg.${ymdh} ${COMOUT}/
#  cp ${TRKDATA}/storms.f*.atcf_gen.altg.${ymdh} ${COMOUT}/
done

cd ${DATA}
#rm -rf ${DATA}/${cmodel}
if [ -s "missing_fens.txt" ]; then
   mail.py -s "Missing FNMOC data in $job" --html <<ENDMSG
One or more Fleet Numerical Meteorology and Oceanography Center files are missing, including
<ul>
$(sort -u missing_fens.txt | awk '$0="<li>"$0"</li>"')
</ul>

$0 could not process all expected data.
ENDMSG
fi

#---filtering weak storms -----------------------------
for pert in ${pertstring}; do
  . prep_step

  # Input file
  export FORT41=storms.n${pert}.atcf_gen.altg.${ymdh}
  cpreq ${COMOUT}/$FORT41 .

  # Output files
  export FORT42=storms.n${pert}.atcf_gen.${ymdh}
  export FORT43=trak.n${pert}.atcfunix.${ymdh}
  
  ${EXECens_tracker}/filter_gen_navgem
  export err=$?; err_chk

  if [ "$SENDCOM" = YES ]; then
    cp $FORT42 $FORT43 ${COMOUT}/
  fi
done

##### ensemble mean calculation and plot probability ##########
${USHens_tracker}/ens_trak_ave_2d.sh 
export err=$?; err_chk

#cp ${DATA}/trak.femn.* ${COMOUT}/
#cp ${DATA}/femn.trkprob.* ${COMOUT}/

hurrlist="AL90 AL91 AL92 AL93 AL94 AL95 AL96 AL97 AL98 AL99 \
          EP90 EP91 EP92 EP93 EP94 EP95 EP96 EP97 EP98 EP99 \
          WP90 WP91 WP92 WP93 WP94 WP95 WP96 WP97 WP98 WP99 \
          HC01 HC02 HC03 HC04 HC05 HC06 HC07 HC08 HC09 HC10"
namelist=input.${ymdh}.nlist
namelist1=input.${ymdh}.nlist1

for hurr in $hurrlist; do
  if [ -s ${COMOUT}/nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.ieee ]; then
    cpreq ${COMOUT}/nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.ieee .
    cpreq ${COMOUT}/trak.nemn.atcfunix.${ymdh} .
    pert_basin=`    echo "${hurr}" | cut -c1-2`
    pert_num=`    echo "${hurr}" | cut -c3-4`
    grep "${pert_basin}, ${pert_num}" trak.nemn.atcfunix.${ymdh} > trak.nemn.atcfunix.${ymdh}.${hurr}

    . prep_step
    echo "&datain0 kymdh0='nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.ieee'/" >${namelist}
    echo "&datain1 kymdh1='nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.data'/" >>${namelist}
    ${EXECens_tracker}/readprob <${namelist}
    export err=$?; err_chk

    echo "&datain0 kymdh0='nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.ieee'/" >${namelist1}
    echo "&datain1 kymdh1='nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.gene'/" >>${namelist1}
    echo "&datain2 kymdh2='trak.nemn.atcfunix.${ymdh}.${hurr}'/" >>${namelist1}
    ${EXECens_tracker}/readprobLL <${namelist1}
    export err=$?; err_chk

    if [ "$SENDCOM" = YES ]; then
      cp nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.data ${COMOUT}/
      cp nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.gene ${COMOUT}/

      if [ "$SENDDBN" = 'YES' ]; then
        # JY $DBNROOT/bin/dbn_alert MODEL ENS_GENESIS $job ${COMOUT}/nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.data
        $DBNROOT/bin/dbn_alert MODEL ENS_GENESIS $job ${COMOUT}/nemn.trkprob.${hurr}.65nm.${ymdh}.indiv.gene
      fi
    fi
    rm $namelist $namelist1
  fi
done

#!/bin/ksh
echo
echo "-------------------------------------------------"
echo "Datacount Averaging"             
echo "-------------------------------------------------"
echo "AUTHOR: Dennis Keyser "
echo "History: AUG 2000 - First implementation of this new script."
echo "   2013-03-19 -- ported to WCOSS (Whiting)"
echo "   2013-03-20 -- RUCS removed (Keyser)"
echo "   2013-09-09 -- URMA added (Keyser)"
echo "   2014-08-31 -- Save the last 32 days rather than the last 30 days but"
echo "                 still average only over the past 30 days (Melchior)"
echo "   2016-12-02 -- Added tm00 qualifier to all status file copy"
echo "                 statements (Keyser)"
echo "   2017-03-28 -- Port to WCOSS Cray.  Replaced hardwired pathnames with"
echo "                 NCO standard variables.  Prepare for gdas filename"
echo "                 change (gdas1->gdas) (Stokes)"
echo "   2017-11-20 -- Accounts for NAM now having tm06 through tm00 time"
echo "                 markers (only tm00 is expected here for this and all"
echo "                 other networks)."
echo "   2018-04-17 -- Removed refernce to 'gdas1'.  Prepared for FV3GFS."

echo

set -aux

# Imported positional parameters:
#   $1     - string indicating network {'nam', 'gfs', 'gdas', 'rap', 'rtma',
#            'urma' or 'dump', tm00 for all networks}
#           (Note: This is not defined the same as $NET in the j-job)
#
# Imported variables that must be passed in:
#   envir  - processing environment ('prod' or 'test')
#   DATA   - path to working directory
#   PDY    - today's YYYYMMDD
#   PDYm1  - yesterday's YYYYMMDD
#   NDATE  - pointer to ndate executable (typically set via prod_util module)
#
# Imported Variables that must be passed in under certain conditions:
#   EXECobsproc
#               - formerly EXECobsproc_shared_bufr_avgdata prior to WCOSS2
#               - path to obsproc executable directory containing bufr_avgdata
#                 (invoked only if $AVGX is not imported)
#   FIXbufr_dump_
#               - formerly FIXobsproc_shared_bufr_dumplist prior to WCOSS2
#               - path to bufr_dump fix directory containing the
#                 bufr_dumplist file
#                 (invoked only if $DUMPLIST is not imported)
#
# Imported variables that can be passed in:
#   COPY       - string indicating whether status,and possibly updated status,
#                file copying should be performed, along with cleaning of "old"
#                directories
#                (Default: YES)
#   UPDATE_AVERAGE_FILE
#              - string indicating whether the data count average file(s)
#                should be updated {one might one to set this to NO if only
#                interested in performing COPY (see above)}
#                (Default: YES)
#   pgmout     - string indicating path to for standard output file
#                (Default: none, if not exported into this scipt, ignored)
#   jlogfile   - string indicating path to job log file
#                (Default: none, if not exported into this scipt, ignored)
#   COMROOTp1  - path to com directory (typically, NCO com on IBM-P1)
#                (Default: none)
#   COMROOT    - path to com directory (typically, NCO com on current system)
#                (Default: none)
#   HOMEarch   - path to archive directory
#                (Default: $COMROOTp1/arch/${envir})   (IBM phase 1)
#   OBCNTarch  - path to archive (copy) of dump status (*.t*z.status*), and
#                possibly updated status (*.t*z.updated.status*), files over
#                many (30?) days (one directory back; actual directory is
#                hardwired to $OBCNTarch/${1}); status files will be copied to
#                $OBCNTarch/${1}/${1}.YYYYMMDD directory and updated status
#                files will be copied to
#                $OBCNTarch/${1}/${1}.YYYYMMDD/updated.status directory;
#                updated status files are copied only for nam, gfs or gdas
#                networks (tm00 for all networks)
#                (Default: $HOMEarch/obcount_30day);
#   comin      - path to today's dump status and updated status files
#                (Default: $COMROOT/${qual1}/$(envir}/${qual2}.${PDY})
#   comin_m1   - path to yesterday's dump status and updated status files
#                (Default: $COMROOT/${qual1}/$(envir}/${qual2}.${PDYm1})
#   DUMPLIST   - path to the bufr_dumplist file
#                (Default: $FIXbufr_dump/bufr_dumplist)
#   AVGX       - path to bufr_avgdata executable
#                (Default: $EXECobsproc/bufr_avgdata)

err=0
net=$1
net_uc=$(echo $net | tr [a-z] [A-Z])
if [ $net = gdas ]; then
   qual1=gfs
   qual2=gdas
   qual3=gdas
else
   qual1=$net
   qual2=$net
   qual3=$net
fi


COPY=${COPY:-YES}
UPDATE_AVERAGE_FILE=${UPDATE_AVERAGE_FILE:-YES}

HOMEarch=${HOMEarch:-$COMROOTp1/arch/${envir}}
OBCNTarch=${OBCNTarch:-$HOMEarch/obcount_30day}
comin=${comin:-$COMROOT/${qual1}/${envir}/${qual2}.${PDY}}
comin_m1=${comin_m1:-$COMROOT/${qual1}/${envir}/${qual2}.${PDYm1}}
# For GFSv16, must go up two directory levels in $comin and $comin_m1 to arrive
# at the g*s.${PDY} directory to locate all cycle *status*bufr_d files
if [ $net = gfs -o $net = gdas ]; then
  comin_noatmos=$(dirname $comin)
  comin_nocyc=$(dirname $comin_noatmos)
  comin_m1_noatmos=$(dirname $comin_m1)
  comin_m1_nocyc=$(dirname $comin_m1_noatmos)
fi
DUMPLIST=${DUMPLIST:-$FIXbufr_dump/bufr_dumplist}
AVGX=${AVGX:-$EXECobsproc/bufr_avgdata}
jlogfile=${jlogfile:=""}

if [ $COPY = YES ]; then

#  Copy the status files, and possibly the updated status files, from today's
#  and yesterday's runs for this network (tm00 for all networks) (yesterday's
#  is copied just in case this didn't run yesterday) and add the EOF string to
#  the end of each status file (note: the updated status files are only copied
#  if this is the nam, gfs or gdas network - the EOF string is not added to the
#  updated status files)
#  ----------------------------------------------------------------------------

mkdir -p $OBCNTarch/${net}.${PDY}
chmod 775 $OBCNTarch/${net}.${PDY}
mkdir -p $OBCNTarch/${net}.${PDYm1}
chmod 775 $OBCNTarch/${net}.${PDYm1}
[ $net = dump -o $net = rap -o $net = rtma -o $net = urma ] && set +x
if [ $net = gfs -o $net = gdas ]; then
   cp -p ${comin_nocyc}/*/*/${qual3}.t*z.status.tm00.bufr_d $OBCNTarch/${net}.${PDY}
else
   cp -p ${comin}/${qual3}.t*z.status.tm00.bufr_d $OBCNTarch/${net}.${PDY}
fi
err_copy_status=$?
chmod 775 $OBCNTarch/${net}.${PDY}/*
if [ $err_copy_status -eq 0 ]; then
   msg="$net_uc tm00 status file(s) for today successfully copied to \
$OBCNTarch/${net}.${PDY}"
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
fi
if [ $net = gfs -o $net = gdas ]; then
   cp -p ${comin_m1_nocyc}/*/*/${qual3}.t*z.status.tm00.bufr_d $OBCNTarch/${net}.${PDYm1}
else
   cp -p ${comin_m1}/${qual3}.t*z.status.tm00.bufr_d $OBCNTarch/${net}.${PDYm1}
fi
err_copy_status_yesterday=$?
chmod 775 $OBCNTarch/${net}.${PDYm1}/*
if [ $err_copy_status_yesterday -eq 0 ]; then
   msg="$net_uc tm00 status file(s) for yesterday successfully copied to \
$OBCNTarch/${net}.${PDYm1}"
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
fi
if [ $net = nam -o $net = gfs -o $net = gdas ]; then
   mkdir -p $OBCNTarch/${net}.${PDY}/updated.status
   chmod 775 $OBCNTarch/${net}.${PDY}/updated.status
   mkdir -p $OBCNTarch/${net}.${PDYm1}/updated.status
   chmod 775 $OBCNTarch/${net}.${PDYm1}/updated.status
   if [ $net = nam ]; then
      cp -p ${comin}/${qual3}.t*z.updated.status.tm00.bufr_d \
      $OBCNTarch/${net}.${PDY}/updated.status
   else
      cp -p ${comin_nocyc}/*/*/${qual3}.t*z.updated.status.tm00.bufr_d \
       $OBCNTarch/${net}.${PDY}/updated.status
   fi
   err_copy_updated_status=$?
   chmod 775 $OBCNTarch/${net}.${PDY}/updated.status/*
   if [ $err_copy_updated_status -eq 0 ]; then
      msg="$net_uc tm00 updated status file(s) for today successfully copied \
to $OBCNTarch/${net}.${PDY}/updated.status"
      set +x
      echo
      echo "$msg"
      echo
      set -x
      [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
   fi
   if [ $net = nam ]; then
      cp -p ${comin_m1}/${qual3}.t*z.updated.status.tm00.bufr_d \
       $OBCNTarch/${net}.${PDYm1}/updated.status
   else
      cp -p ${comin_m1_nocyc}/*/*/${qual3}.t*z.updated.status.tm00.bufr_d \
       $OBCNTarch/${net}.${PDYm1}/updated.status
   fi
   err_copy_updated_status_yesterday=$?
   chmod 775 $OBCNTarch/${net}.${PDYm1}/updated.status/*
   if [ $err_copy_updated_status_yesterday -eq 0 ]; then
      msg="$net_uc tm00 updated status file(s) for yesterday successfully \
copied to $OBCNTarch/${net}.${PDYm1}/updated.status"
      set +x
      echo
      echo "$msg"
      echo
      set -x
      [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
   fi
fi
set -x

cd $OBCNTarch/${net}.${PDY}

ls *.bufr_d > $DATA/ls.files_today.bufr

for n in `cat $DATA/ls.files_today.bufr`; do
   if [ $net = gfs -o $net = gdas ]; then
      [ -s ${comin_nocyc}/*/*/${n} ] && echo "EOF @@@" >> $n
   else
      [ -s ${comin}/${n} ] && echo "EOF @@@" >> $n
   fi
done

cd $OBCNTarch/${net}.${PDYm1}

ls *.bufr_d > $DATA/ls.files_yesterday.bufr

for n in `cat $DATA/ls.files_yesterday.bufr`; do
   if [ $net = gfs -o $net = gdas ]; then
      [ -s ${comin_m1_nocyc}/*/*/${n} ] && echo "EOF @@@" >> $n
   else
      [ -s ${comin_m1}/${n} ] && echo "EOF @@@" >> $n
   fi
done

cd $DATA


#  Clean out all status and updated status file directories older than 32-days
#  ---------------------------------------------------------------------------

pdy_earliest=$($NDATE -768 ${PDY}00 | cut -c1-8)
set +x
echo
echo "pdy_earliest is " $pdy_earliest
echo
set -x

set +x
ls -d $OBCNTarch/* > ls.dir
set -x

if [ -s ls.dir ];then
   lines=`cat ls.dir | wc -l`
else
   lines=0
fi

n=1

until [ $n -gt $lines ]
do
   eval this_dir=`echo \`head -n ${n} ls.dir | tail -n 1\``
##echo "this_dir is " $this_dir
   eval this_dir_date=`echo \`head -n ${n} ls.dir | tail -n 1\` | \
    awk -F"${net}/${net}" '{print$2}' | cut -c2-9`
##echo "this_dir_date is " $this_dir_date

# make sure $this_dir is a directory w/ a date in its name and not some other
#  file/directory (which we would retain before continuing the date check)
# ---------------------------------------------------------------------------
   echo $this_dir_date|egrep '^[0-9]+$'
   if [ $? -eq 0 ]; then # this_dir_date has 8 digits, expect it to be YYYYMMDD
      if [ $this_dir_date -le $pdy_earliest ]; then
         rm -r -f $this_dir
      else
         break
      fi
   fi
   n=`expr $n + 1`
done
msg="All $net_uc tm00 status file and updated status file (where applicable) \
directories older than 32-days cleaned out"
set +x
echo
echo "$msg"
echo
set -x
[ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"

fi    # fi on COPY = YES test


if [ $UPDATE_AVERAGE_FILE = YES ]; then
 
msg="Attempt to update data count average table for $net_uc tm00 network"
set +x
echo
echo "$msg"
echo
set -x
[ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"

#  Grep out the individual counts for all types, based on cycle
#  ------------------------------------------------------------

if [ $net = dump -o $net = rap -o $net = rtma -o $net = urma ] ; then
   cycles="t00z t01z t02z t03z t04z t05z t06z t07z t08z t09z t10z t11z \
           t12z t13z t14z t15z t16z t17z t18z t19z t20z t21z t22z t23z"
else
   cycles="t00z t06z t12z t18z"
fi

# Determine the date for 30 days ago 
pdym30d=$($NDATE -720 ${PDY}00)
pdym30d=$(echo $pdym30d | sed 's/00$//')  # remove trailing 00 

# build array for last 30 days files
for dir in $OBCNTarch/$net*; do
  set +x
  netday=$(echo $dir | awk -F'/' '{print $NF}')
  # test day is no more than 30 days from $PDY
  dtg=$(echo $netday | awk -F'.' '{print $NF}')
  if [ "$dtg" -gt "$pdym30d" ]; then # "-gt" here since 30 days ago to now
                                     # contains 31 directories and we only
                                     # want the last 30 directories
    arr30d=("${arr30d[@]}" "$dtg")
  fi
  set -x
done

for cycle_avg in $cycles; do
   > accum.obs.counts.${cycle_avg}
   for dtg in "${arr30d[@]}"; do
     set +x
     grep --text -h -e " REPORTS" -e "^EOF @@@" \
     $OBCNTarch/${net}.${dtg}/*${cycle_avg}.status.*bufr_d | \
     grep -e " in data group " -e "^EOF @@@" | grep -e " HAS" -e "^EOF @@@" | \
     grep -v -e "Domain" >> delete
     awk -F" HAS" '{print$2}' delete | awk -F" REPORTS" '{print$1}' | \
      sed "s/[^0-9]/ /g" >> delete.r
     awk -F" in data group " '{print $1}' delete | \
      sed "s/[^0-9][^0-9][^0-9]^\.[^0-9][^0-9][^0-9]/ /g" | \
      sed "s/[^0-9]/ /g" >> delete.l
     paste -d" " delete.l delete.r | sed "s/^[^0-9]/EOF @@@       0/g" \
      >> accum.obs.counts.${cycle_avg}
     rm delete delete.l delete.r
     set -x
   done
done

grep --text -e "^_" -e "^:" $DUMPLIST | grep -Fe "#>" > dumplist


#  Generate a new average file
#  ---------------------------

final_yr=`echo $PDY | cut -c1-4`
final_mn=`echo $PDY | cut -c5-6`
final_dy=`echo $PDY | cut -c7-8`
final_date=${final_mn}/${final_dy}/${final_yr}


cat <<EOFd > avgdata.cards
 &INPUT
   NETWORK='$net_uc',
   CURRDATE='$final_date'
 /
EOFd

pgm=`basename  $AVGX`
if [ -s prep_step ]; then
   set +u
   . prep_step
   set -u
else
   [ -f errfile ] && rm errfile

   unset FORT00 `env | grep "FORT[0-9]\{1,\}" | awk -F= '{print $1}'`

fi

export FORT10=dumplist
# unit 21 opened internally by pgm and holds accumulated obs. for each cycle
# unit 25 opened internally by pgm and holds accumulated sat 1b for each cycle
export FORT51=obcount_30davg.${net}.current
time -p $AVGX< avgdata.cards > outout 2> errfile
err=$?
###cat errfile
cat errfile >> outout
cat outout >> avgdata.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for BUFR_AVGDATA is ' $err
echo
set -x
if [ $err -eq 0 ]; then

   set +x
   echo " -------------------------------------------------------------------- "
   echo " ***** COMPLETED PROGRAM BUFR_AVGDATA for $net_uc tm00 NETWORK *****  "
   echo " -------------------------------------------------------------------- "
   set -x
   msg="bufr_avgdata completed normally for $net_uc tm00 network"
   [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
else

msg="BUFR_AVGDATA TERMINATED ABNORMALLY WITH CONDITION CODE $err --> non-fatal"
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"

fi
fi    # fi on UPDATE_AVERAGE_FILE = YES test

if [ $COPY = YES ]; then

#  Remove any empty directories (these should never be empty unless
#   there is a problem - removing them here may help detect a 
#   "break" in the script sooner than if all 30-days are missing)
#  ----------------------------------------------------------------

   rmdir $OBCNTarch/${net}.${PDYm1}
   rmdir $OBCNTarch/${net}.${PDY}

fi

exit $err

#!/bin/bash

set -euax

exp=$1  CDATE=$2  COMROT=/dev/null

export HOMEcfs=$fitdir/..
export EXECcfs=$HOMEcfs/exec
export USHcfs=$HOMEcfs/ush
export NDATE=$EXECcfs/ndate.x

export OUTPUT_FILETYPE=${OUTPUT_FILETYPE:-netcdf}

echo $ARCDIR                 ; mkdir -p $ARCDIR
export FIT_DIR=$ARCDIR/fits  ; mkdir -p $FIT_DIR
export HORZ_DIR=$ARCDIR/horiz; mkdir -p $HORZ_DIR

export DATA=$TMPDIR/$exp.$CDATE.fit2obstmp; rm -rf $DATA; mkdir -p $DATA
export COMOUT_FITX=$DATA/fitx; mkdir -p $COMOUT_FITX

echo "echo err_chk">$DATA/err_chk; chmod 755 $DATA/err_chk
echo "echo postmsg">$DATA/postmsg; chmod 755 $DATA/postmsg
job=test

$fitdir/scripts/excfs_gdas_vrfyfits.sh

#!/bin/ksh
export PS4=' + extrkr_tcv_g2.sh line $LINENO: '

set +x
##############################################################################
echo " "
echo "------------------------------------------------"
echo "xxxx - Track vortices in model GRIB2 output"
echo "J.Peng---10-06-2014---------------------------- "
echo "Current time is: `date`"
echo " "
##############################################################################
set -x

loopnum=$1
cmodel=$2
pert=$3
TRKDATA=$4

export gribver=2
#init_flag=$5
# USE_OPER_VITALS=NO
# USE_OPER_VITALS=INIT_ONLY
USE_OPER_VITALS=YES

##############################################################################
#
#    FLOW OF CONTROL
#
# 1. Define data directories and file names for the input model 
# 2. Process input starting date/cycle information
# 3. Update TC Vitals file and select storms to be processed
# 4. Cut apart input GRIB files to select only the needed parms and hours
# 5. Execute the tracker
# 6. Copy the output track files to various locations
#
##############################################################################
msg="has begun for ${cmodel} ${pert} at ${cyc}z"
postmsg "$jlogfile" "$msg"
########################################

# This script runs the hurricane tracker using operational GRIB model output.  
# This script makes sure that the data files exist, it then pulls all of the 
# needed data records out of the various GRIB forecast files and puts them 
# into one, consolidated GRIB file, and then runs a program that reads the TC 
# Vitals records for the input day and updates the TC Vitals (if necessary).
# It then runs gettrk, which actually does the tracking.
# 
# Environmental variable inputs needed for this scripts:
#  PDY   -- The date for data being processed, in YYYYMMDD format
#  cyc   -- The numbers for the cycle for data being processed (00, 06, 12, 18)
#  cmodel -- Model being processed (gfs, mrf, ukmet, ecmwf, nam, ngm, ngps,
#                                   gdas, gfdl, ens (ncep ensemble))
#  envir -- 'prod' or 'test'
#  SENDCOM -- 'YES' or 'NO'
#  stormenv -- This is only needed by the tracker run for the GFDL model.
#              'stormenv' contains the name/id that is used in the input
#              grib file names.
#  pert  -- This is only needed by the tracker run for the NCEP ensemble.
#           'pert' contains the ensemble member id (e.g., n2, p4, etc.)
#           which is used as part of the grib file names.
#
# For testing script interactively in non-production set following vars:
#     archsyndir - Directory with syndir scripts/exec/fix 
#

qid=$$
#----------------------------------------------#
#   Get input date information                 #
#----------------------------------------------#

#export PDY=${PDY:-$1}
#export cyc=${cyc:-$2}
#export cmodel=${cmodel:-$3}
export jobid=${jobid:-testjob}
export SENDCOM=${SENDCOM:-NO}
export PHASEFLAG=y
export WCORE_DEPTH=1.0
#export PHASE_SCHEME=vtt
#export PHASE_SCHEME=cps
export PHASE_SCHEME=both
export STRUCTFLAG=n
export IKEFLAG=n

if [ ! -d $TRKDATA ]
then
   mkdir -p $TRKDATA
fi
cd $TRKDATA

if [ ${#PDY} -eq 0 -o ${#cyc} -eq 0 -o ${#cmodel} -eq 0 ]
then
  set +x
  echo " "
  echo "FATAL ERROR:  Something wrong with input parameters."
  echo "PDY= ${PDY}, cyc= ${cyc}, cmodel= ${cmodel}"
  set -x
  err_exit "FAILED ${jobid} -- BAD INPUTS AT LINE $LINENO IN TRACKER SCRIPT - ABNORMAL EXIT"
else
  set +x
  echo " "
  echo " #-----------------------------------------------------------------#"
  echo " At beginning of tracker script, the following imported variables "
  echo " are defined: "
  echo "   PDY ................................... $PDY"
  echo "   cyc ................................... $cyc"
  echo "   cmodel ................................ $cmodel"
  echo "   jobid ................................. $jobid"
  echo "   envir ................................. $envir"
  echo "   SENDCOM ............................... $SENDCOM"
  echo " "
  set -x
fi

scc=`echo ${PDY} | cut -c1-2`
syy=`echo ${PDY} | cut -c3-4`
smm=`echo ${PDY} | cut -c5-6`
sdd=`echo ${PDY} | cut -c7-8`
shh=${cyc}
symd=`echo ${PDY} | cut -c3-8`
syyyy=`echo ${PDY} | cut -c1-4`
CENT=`echo ${PDY} | cut -c1-2`

#export archsyndir=${archsyndir:-${COMROOT}/arch/prod/syndat}
archsyndir=${archsyndir:-${COMINsyn:?}}

#----------------------------------------------------------------#
#
#    --- Define data directories and data file names ---
#               
# Convert the input model to lowercase letters and check to see 
# if it's a valid model, and assign a model ID number to it.  
# This model ID number is passed into the Fortran program to 
# let the program know what set of forecast hours to use in the 
# ifhours array.  Also, set the directories for the operational 
# input GRIB data files and create templates for the file names.
# While only 1 of these sets of directories and file name 
# templates is used during a particular run of this script, 
# "gfsvitdir" is used every time, because that is the directory 
# that contains the error-checked TC vitals file that Steve Lord 
# produces, and so it is included after the case statement.
#
# NOTE: The varible PDY is now defined within the J-Jobs that
# call this script.  Therefore there is no reason to do this
# here.
#
# NOTE: The script that processes the ECMWF data defines PDY as
# the current day, and in this script we need PDY to be 
# yesterday's date (for the ecmwf ONLY).  So instead, the ecmwf
# script will pass the variable PDYm1 to this script, and in the
# case statement below we change that to PDY.
#
# NOTE: Do NOT try to standardize this script by changing all of 
# these various data directories' variable names to be all the 
# same, such as "datadir".  As you'll see in the data cutting 
# part of this script below, different methods are used to cut 
# apart different models, thus it is important to know the 
# difference between them....
#----------------------------------------------------------------#

cmodel=`echo ${cmodel} | tr "[A-Z]" "[a-z]"`

case ${cmodel} in 

  gfs) set +x; echo " "                                    ;
       echo " ++ operational GFS chosen"                   ;
       echo " "; set -x                                    ;
#       gfsdir=${gfsdir:-${COMROOT}/gfs/prod/gfs.${PDY}}   ;
       gfsdir=${gfsdir:-${COMINgfs:?}/${cyc}}                     ;
       gfsgfile=gfs.t${cyc}z.pgrb2.0p25.f                  ;
       vit_incr=6
       fcstlen=6                                           ;
       fcsthrs=$(seq -f%03g -s' ' 0 $vit_incr $fcstlen)    ;
       atcfnum=15                                          ;
       atcfname="gfso"                                     ;
       atcfout="gfso"                                      ;
       atcffreq=600                                        ;

       rundescr="xxxx"                                     ;
       atcfdescr="xxxx"                                    ;

       mslpthresh=0.0015                                   ;
       v850thresh=1.5000                                   ;
       modtyp='global'                                     ;

       file_sequence="onebig"                              ;
       lead_time_units='hours'                             ;
       g2_jpdtn=0                                          ;
       model=1                                             ;;

# g2_jpdtn sets the variable that will be used as "JPDTN" for
# the call to getgb2, if gribver=2.  jpdtn=1 for ens data,
# jpdtn=0 for deterministic data.

  ngps) set +x; echo " "                                   ;
       echo " ++ operational NAVGEM chosen"                ;
       echo " "; set -x                                    ;
#       ngpsdir=${ngpsdir:-${COMROOTp1}/fnmoc/prod/navgem.${PDY}};
       ngpsdir=${ngpsdir:-${DCOM:?}}                       ;
#J.Peng-05-12-2016       ngpsgfile=navgem_${PDY}${cyc}f    ;
#       ngemgfile=.grib2                                    ;
       ngpsgfile=US058GMET-OPSbd2.NAVGEM                    ;
       ngemgfile=-${PDY}${cyc}-NOAA-halfdeg.gr2               ;
       vit_incr=6
       fcstlen=6                                           ;
       fcsthrs=$(seq -f%03g -s' ' 0 $vit_incr $fcstlen)    ;
       atcfnum=29                                          ;
       atcfname="ngx "                                     ;
       atcfout="ngx"                                       ;
       atcffreq=600                                        ;
       mslpthresh=0.0015                                   ;
       v850thresh=1.5000                                   ;
       modtyp='global'                                     ;
       file_sequence="onebig"                              ;
       lead_time_units='hours'                             ;
       g2_jpdtn=0                                          ;
       model=7                                            ;;

  cmc) set +x; echo " "                                   ;
       echo " ++ operational CMC chosen"                ;
       echo " "; set -x                                    ;
       cmcdir=${cmcdir:-${DCOM:?}}                         ;
#       cmcdir=/gpfs/hps/emc/ensemble/noscrub/Jiayi.Peng/cmc_25km_data   ;
       cmcgfile=CMC_glb_latlon.24x.24_${PDY}${cyc}_P       ;
       cmcgfile2=_NCEP.grib2                               ;

       vit_incr=6
       fcstlen=6                                           ;
       fcsthrs=$(seq -f%03g -s' ' 0 $vit_incr $fcstlen)    ;

       atcfnum=39                                          ;
       atcfname="cmc "                                     ;
       atcfout="cmc"                                       ;
       atcffreq=600                                        ;
       mslpthresh=0.0015                                   ;
       v850thresh=1.5000                                   ;
       modtyp='global'                                     ;
       file_sequence="onebig"                              ;
       lead_time_units='hours'                             ;
       g2_jpdtn=0                                          ;
       model=15                                            ;;

  *) msg="Model $cmodel is not recognized."                ;
     echo "$msg"; postmsg $jlogfile "$msg"                 ;
     err_exit "FAILED ${jobid} -- UNKNOWN cmodel IN TRACKER SCRIPT - ABNORMAL EXIT";;

esac

if [ ${PHASEFLAG} = 'y' ]; then

#J.Peng----2014-10-28---------
  if [ ${cmodel} = "gfs" ]; then
    wgrib_parmlist="UGRD:850 UGRD:700 UGRD:500 UGRD:200 VGRD:850 VGRD:700 VGRD:500 VGRD:200 SurfaceU SurfaceV ABSV:850 ABSV:700 MSLET HGT:900 HGT:850 HGT:800 HGT:750 HGT:700 HGT:650 HGT:600 HGT:550 HGT:500 HGT:450 HGT:400 HGT:350 HGT:300 TMP:500 TMP:450 TMP:400 TMP:350 TMP:300 RH:500"
  elif [ ${cmodel} = "ngps" ]; then
    wgrib_parmlist="UGRD:850 UGRD:700 UGRD:500 UGRD:200 VGRD:850 VGRD:700 VGRD:500 VGRD:200 SurfaceU SurfaceV PRMSL HGT:925 HGT:850 HGT:700 HGT:500 HGT:400 HGT:300 TMP:500 TMP:400 TMP:300 RH:500"
  elif [ ${cmodel} = "cmc" ]; then
    wgrib_parmlist="UGRD:850 UGRD:700 UGRD:500 UGRD:200 VGRD:850 VGRD:700 VGRD:500 VGRD:200 SurfaceU SurfaceV ABSV:850 ABSV:700 PRMSL HGT:925 HGT:850 HGT:700 HGT:500 HGT:250 TMP:500 TMP:250 SPFH:500"
  fi

  wgrib_ec_hires_parmlist=" GH:850 GH:700 U:850 U:700 U:500 U:200 V:850 V:700 V:500 V:200 10U:sfc 10V:sfc MSL:sfc GH:300 GH:400 GH:500 GH:925 T:300 T:400 T:500 R:500"
else

  wgrib_parmlist=" HGT:850 HGT:700 UGRD:850 UGRD:700 UGRD:500 VGRD:850 VGRD:700 VGRD:500 SurfaceU SurfaceV ABSV:850 ABSV:700 MSLET "
  wgrib_ec_hires_parmlist=" GH:850 GH:700 U:850 U:700 U:500 V:850 V:700 V:500 10U:sfc 10V:sfc MSL:sfc"

fi

#---------------------------------------------------------------#
#
#      --------  TC Vitals processing   --------
#
# Check Steve Lord's operational tcvitals file to see if any 
# vitals records were processed for this time by his system.  
# If there were, then you'll find a file in /com/gfs/prod/gfs.yymmdd 
# with the vitals in it.  Also check the raw TC Vitals file in
# /com/arch/prod/syndat , since this may contain storms that Steve's 
# system ignored (Steve's system will ignore all storms that are 
# either over land or very close to land);  We still want to track 
# these inland storms, AS LONG AS THEY ARE NHC STORMS (don't 
# bother trying to track inland storms that are outside of NHC's 
# domain of responsibility -- we don't need that info).
# UPDATE 5/12/98 MARCHOK: The script is updated so that for the
#   global models, the gfs directory is checked for the error-
#   checked vitals file, while for the regional models, the 
#   nam directory is checked for that file.
# UPDATE 3/27/09 MARCHOK: The SREF is run at off-synoptic times
#   (03,09,15,21Z).  There are no tcvitals issued at these offtimes,
#   so the updating of the "old" tcvitals is critical for running
#   the tracker on SREF.  For updating the old tcvitals for SREF,
#   we need to look 3h back, not 6h as for the other models that
#   run at synoptic times.
#--------------------------------------------------------------#

old_ymdh=` ${NDATE:?} -${vit_incr} ${PDY}${cyc}`
old_4ymd=` echo ${old_ymdh} | cut -c1-8`
old_ymd=` echo ${old_ymdh} | cut -c3-8`
old_hh=`  echo ${old_ymdh} | cut -c9-10`
old_str="${old_ymd} ${old_hh}00"

future_ymdh=` ${NDATE:?} ${vit_incr} ${PDY}${cyc}`
future_4ymd=` echo ${future_ymdh} | cut -c1-8`
future_ymd=` echo ${future_ymdh} | cut -c3-8`
future_hh=`  echo ${future_ymdh} | cut -c9-10`
future_str="${future_ymd} ${future_hh}00"

if [ ${modtyp} = 'global' ]
then
#  synvitdir=${COMROOT}/gfs/prod/gfs.${PDY}
  synvitdir=${COMINgfs:?}/${cyc}
  synvitfile=gfs.t${cyc}z.syndata.tcvitals.tm00
#  synvitold_dir=${COMROOT}/gfs/prod/gfs.${old_4ymd}
  synvitold_dir=${synvitdir%.*}.${old_4ymd}/${old_hh}
  synvitold_file=gfs.t${old_hh}z.syndata.tcvitals.tm00
#  synvitfuture_dir=${COMROOT}/gfs/prod/gfs.${future_4ymd}
  synvitfuture_dir=${synvitdir%.*}.${future_4ymd}/${future_hh}
  synvitfuture_file=gfs.t${future_hh}z.syndata.tcvitals.tm00
else
#  synvitdir=${COMROOT}/nam/prod/nam.${PDY}
  synvitdir=${COMINnam:?}
  synvitfile=nam.t${cyc}z.syndata.tcvitals.tm00
#  synvitold_dir=${COMROOT}/nam/prod/nam.${old_4ymd}
  synvitold_dir=${synvitdir%.*}.${old_4ymd}
  synvitold_file=nam.t${old_hh}z.syndata.tcvitals.tm00
#  synvitfuture_dir=${COMROOT}/nam/prod/nam.${future_4ymd}
  synvitfuture_dir=${synvitdir%.*}.${future_4ymd}
  synvitfuture_file=nam.t${future_hh}z.syndata.tcvitals.tm00
fi

set +x
echo " "
echo "              -----------------------------"
echo " "
echo " Now sorting and updating the TC Vitals file.  Please wait...."
echo " "
set -x

current_str="${symd} ${cyc}00"

if [ -s ${synvitdir}/${synvitfile} -o\
     -s ${synvitold_dir}/${synvitold_file} -o\
     -s ${synvitfuture_dir}/${synvitfuture_file} ]
then
  grep "${old_str}" ${synvitold_dir}/${synvitold_file}        \
                  >${TRKDATA}/tmpsynvit.${atcfout}.${PDY}${cyc}
  grep "${current_str}"  ${synvitdir}/${synvitfile}                  \
                 >>${TRKDATA}/tmpsynvit.${atcfout}.${PDY}${cyc}
  grep "${future_str}" ${synvitfuture_dir}/${synvitfuture_file}  \
                 >>${TRKDATA}/tmpsynvit.${atcfout}.${PDY}${cyc}
else
  set +x
  echo " "
  echo " There is no (synthetic) TC vitals file for ${cyc}z in ${synvitdir},"
  echo " nor is there a TC vitals file for ${old_hh}z in ${synvitold_dir}."
  echo " nor is there a TC vitals file for ${future_hh}z in ${synvitfuture_dir},"
  echo " Checking the raw TC Vitals file ....."
  echo " "
  set -x
fi

# Take the vitals from Steve Lord's /com/gfs/prod tcvitals file,
# and cat them with the NHC-only vitals from the raw, original
# /com/arch/prod/synda_tcvitals file.  Do this because the nwprod
# tcvitals file is the original tcvitals file, and Steve runs a
# program that ignores the vitals for a storm that's over land or
# even just too close to land, and for tracking purposes for the
# US regional models, we need these locations.  Only include these
# "inland" storm vitals for NHC (we're not going to track inland 
# storms that are outside of NHC's domain of responsibility -- we 
# don't need that info).  
# UPDATE 5/12/98 MARCHOK: awk logic is added to screen NHC 
#   vitals such as "91L NAMELESS" or "89E NAMELESS", since TPC 
#   does not want tracks for such storms.

grep "${old_str}" ${archsyndir}/syndat_tcvitals.${CENT}${syy}   | \
      grep -v TEST | awk 'substr($0,6,1) !~ /8/ {print $0}' \
      >${TRKDATA}/tmprawvit.${atcfout}.${PDY}${cyc}
grep "${current_str}"  ${archsyndir}/syndat_tcvitals.${CENT}${syy}   | \
      grep -v TEST | awk 'substr($0,6,1) !~ /8/ {print $0}' \
      >>${TRKDATA}/tmprawvit.${atcfout}.${PDY}${cyc}
grep "${future_str}" ${archsyndir}/syndat_tcvitals.${CENT}${syy} | \
      grep -v TEST | awk 'substr($0,6,1) !~ /8/ {print $0}' \
      >>${TRKDATA}/tmprawvit.${atcfout}.${PDY}${cyc}

#J.Peng----2012-05-03---for genesis tc vitals--------------------
#export COMINgenvit=/global/save/wx20jp/genesis_vital_${syyyy}
#grep "${current_str}"  ${COMINgenvit}/gen_tc.vitals.gfs.gfso.2012 | \
#      grep -v TEST | awk 'substr($0,6,1) !~ /8/ {print $0}' \
#      >>${TRKDATA}/tmprawvit.${atcfout}.${PDY}${cyc}

#PRODTEST#
#PRODTEST# Use the next couple lines to test the tracker on the SP.
#PRODTEST# These next couple lines use data from a test TC Vitals file that 
#PRODTEST# I generate.  When you are ready to test this system, call me and
#PRODTEST# I'll create one for the current day, and then uncomment the next
#PRODTEST# couple lines in order to access the test vitals file.
#
#ttrkdir=/global/save/wx20tm/trak/prod/data
#ttrkdir=/global/save/wx20tm/trak/para/scripts
#grep "${current_str}" ${ttrkdir}/tcvit.01l >>${TRKDATA}/tmprawvit.${atcfout}.${PDY}${cyc}


# IMPORTANT:  When "cat-ing" these files, make sure that the vitals
# files from the "raw" TC vitals files are first in order and Steve's
# TC vitals files second.  This is because Steve's vitals file has
# been error-checked, so if we have a duplicate tc vitals record in
# these 2 files (very likely), program supvit.x below will
# only take the last vitals record listed for a particular storm in
# the vitals file (all previous duplicates are ignored, and Steve's
# error-checked vitals records are kept).

cat ${TRKDATA}/tmprawvit.${atcfout}.${PDY}${cyc} ${TRKDATA}/tmpsynvit.${atcfout}.${PDY}${cyc} \
        >${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}

# If we are doing the processing for the GFDL model, then we want
# to further cut down on which vitals we allow into this run of the
# tracker.  The reason is that this program will be called from 
# each individual run for a storm, so the grib files will be 
# specific to each storm.  So if 4 storms are being run at a 
# particular cycle, then this script is run 4 separate times from
# within the GFDL_POST job.

#if [ ${cmodel} = 'gfdl' ]; then
##   grep -i ${stormid} ${COMIN}/${ATCFNAME}.vitals.${syy}${smm}${sdd}${shh} >${TRKDATA}/tmpvit
##   mv ${TRKDATA}/tmpvit ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}
#echo " "
#echo "!!! ERROR:  TAKE THE COMMENTS OUT OF HERE BEFORE IMPLEMENTATION    AAAA"
#echo "!!! AND TAKE OUT THESE NEXT 2 LINES AS WELL............................"
#echo " "
#grep -i ${stormid} ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc} >${TRKDATA}/tmpvit
#mv  ${TRKDATA}/tmpvit ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}
#fi

#--------------------------------------------------------------#
# Now run a fortran program that will read all the TC vitals
# records for the current dtg and the dtg from 6h ago, and
# sort out any duplicates.  If the program finds a storm that
# was included in the vitals file 6h ago but not for the current
# dtg, this program updates the 6h-old first guess position
# and puts these updated records as well as the records from
# the current dtg into a temporary vitals file.  It is this
# temporary vitals file that is then used as the input for the
# tracking program.
#--------------------------------------------------------------#

oldymdh=` ${NDATE:?} -${vit_incr} ${PDY}${cyc}`
oldyy=`echo ${oldymdh} | cut -c3-4`
oldmm=`echo ${oldymdh} | cut -c5-6`
olddd=`echo ${oldymdh} | cut -c7-8`
oldhh=`echo ${oldymdh} | cut -c9-10`
oldymd=${oldyy}${oldmm}${olddd}

futureymdh=` ${NDATE:?} 6 ${PDY}${cyc}`
futureyy=`echo ${futureymdh} | cut -c3-4`
futuremm=`echo ${futureymdh} | cut -c5-6`
futuredd=`echo ${futureymdh} | cut -c7-8`
futurehh=`echo ${futureymdh} | cut -c9-10`
futureymd=${futureyy}${futuremm}${futuredd}

echo "&datenowin   dnow%yy=${syy}, dnow%mm=${smm},"       >${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "             dnow%dd=${sdd}, dnow%hh=${cyc}/"      >>${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "&dateoldin   dold%yy=${oldyy}, dold%mm=${oldmm},"    >>${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "             dold%dd=${olddd}, dold%hh=${oldhh}/"    >>${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "&datefuturein  dfuture%yy=${futureyy}, dfuture%mm=${futuremm},"  >>${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "               dfuture%dd=${futuredd}, dfuture%hh=${futurehh}/"  >>${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
echo "&hourinfo  vit_hr_incr=${vit_incr}/"  >>${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}

numvitrecs=`cat ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc} | wc -l`
if [ ${numvitrecs} -eq 0 ]
then

  if [ ${trkrtype} = 'tracker' ]
  then
    set +x
    echo " "
    echo "!!! WARNING -- There are no vitals records for this time period."
    echo "!!! File ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc} is empty."
    echo "!!! It could just be that there are no storms for the current"
    echo "!!! time.  You may wish to check the date and submit this job again..."
    echo " "
    set -x
    exit 0
  fi

fi

# For tcgen cases, filter to use only vitals from the ocean 
# basin of interest....
#J.Peng----2012-04-13-------------------------------------
#if [ ${trkrtype} = 'tcgen' ]
#  then

#  if [ ${numvitrecs} -gt 0 ]
#  then
    
#    fullvitfile=${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}
#    cp $fullvitfile ${TRKDATA}/vitals.all_basins.${atcfout}.${PDY}${cyc}
#    basin=` echo $regtype | cut -c1-2`

#    if [ ${basin} = 'al' ]; then
#      cat $fullvitfile | awk '{if (substr($0,8,1) == "L") print $0}' |
#               >${TRKDATA}/vitals.tcgen_al_only.${atcfout}.${PDY}${cyc}
#      cp ${TRKDATA}/vitals.tcgen_al_only.${atcfout}.${PDY}${cyc} \
#         ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}
#    fi
#    if [ ${basin} = 'ep' ]; then
#      cat $fullvitfile | awk '{if (substr($0,8,1) == "E") print $0}' |
#               >${TRKDATA}/vitals.tcgen_ep_only.${atcfout}.${PDY}${cyc}
#      cp ${TRKDATA}/vitals.tcgen_ep_only.${atcfout}.${PDY}${cyc} \
#         ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}
#    fi
#    if [ ${basin} = 'wp' ]; then
#      cat $fullvitfile | awk '{if (substr($0,8,1) == "W") print $0}' |
#               >${TRKDATA}/vitals.tcgen_wp_only.${atcfout}.${PDY}${cyc}
#      cp ${TRKDATA}/vitals.tcgen_wp_only.${atcfout}.${PDY}${cyc} \
#         ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}
#    fi

#    cat ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}

#  fi
    
#fi
#J.Peng----2012-04-13-------------------------------------

# - - - - - - - - - - - - -
# Before running the program to read, sort and update the vitals,
# first run the vitals through some awk logic, the purpose of 
# which is to convert all the 2-digit years into 4-digit years.
# Beginning 4/21/99, NHC and JTWC will begin sending the vitals
# with 4-digit years, however it is unknown when other global
# forecasting centers will begin using 4-digit years, thus we
# need the following logic to ensure that all the vitals going
# into supvit.f have uniform, 4-digit years in their records.
#
# 1/8/2000: sed code added by Tim Marchok due to the fact that 
#       some of the vitals were getting past the syndata/qctropcy
#       error-checking with a colon in them; the colon appeared
#       in the character immediately to the left of the date, which
#       was messing up the "(length($4) == 8)" statement logic.
# - - - - - - - - - - - - -

sed -e "s/\:/ /g"  ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc} > ${TRKDATA}/tempvit
mv ${TRKDATA}/tempvit ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}

awk '
{
  yycheck = substr($0,20,2)
  if ((yycheck == 20 || yycheck == 19) && (length($4) == 8)) {
    printf ("%s\n",$0)
  }
  else {
    if (yycheck >= 0 && yycheck <= 50) {
      printf ("%s20%s\n",substr($0,1,19),substr($0,20))
    }
    else {
      printf ("%s19%s\n",substr($0,1,19),substr($0,20))
    }
  }
} ' ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc} >${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}.y4

mv ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}.y4 ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}

#Added by J.Peng----2012-04-12----------------------------------------------
numvitrecs=`cat ${TRKDATA}/vitals.${atcfout}.${PDY}${cyc} | wc -l`
#-----------------------------------------------------------------
#J.Peng----2012-05-04--do not need this for TCvitals----
#numvitrecs=0

if [ ${numvitrecs} -gt 0 ]
then

  export pgm=supvit_g2
  . prep_step

  # Input file
  export FORT31=${TRKDATA}/vitals.${atcfout}.${PDY}${cyc}

  # Output file
  export FORT51=${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc}

  msg="$pgm start for $atcfout at ${cyc}z"
  postmsg "$jlogfile" "$msg"

  ${EXECens_tracker}/supvit_g2 <${TRKDATA}/suv_input.${atcfout}.${PDY}${cyc}
  suvrcc=$?

  if [ ${suvrcc} -eq 0 ]
  then
    msg="$pgm end for $atcfout at ${cyc}z completed normally"
    postmsg "$jlogfile" "$msg"
  else
    set +x
    echo " "
    echo "FATAL ERROR:  An error occurred while running supvit.x, "
    echo "!!! which is the program that updates the TC Vitals file."
    echo "!!! Return code from supvit.x = ${suvrcc}"
    echo "!!! model= ${atcfout}, forecast initial time = ${PDY}${cyc}"
    echo " "
    set -x
    err_exit "FAILED ${jobid} - ERROR RUNNING supvit_g2 IN TRACKER SCRIPT- ABNORMAL EXIT"
  fi

else
#Added by J.Peng----2012-04-12----------------------------------------------
  rm -f ${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc}

  touch ${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc}

fi

#-----------------------------------------------------------------
# In this section, check to see if the user requested the use of 
# operational TC vitals records for the initial time only.  This 
# option might be used for a retrospective medium range forecast
# in which the user wants to initialize with the storms that are
# currently there, but then let the model do its own thing for 
# the next 10 or 14 days....


if [ ${USE_OPER_VITALS} = 'INIT_ONLY' ]; then

  if [ ${init_flag} = 'yes' ]; then
    set +x
    echo " "
    echo "NOTE: User has requested that operational historical TC vitals be used,"
    echo "      but only for the initial time, which we are currently at."
    echo " "
    set -x
  else
    set +x
    echo " "
    echo "NOTE: User has requested that operational historical TC vitals be used,"
    echo "      but only for the initial time, which we are now *PAST*."
    echo " "
    set -x
    >${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc}
  fi
    
elif [ ${USE_OPER_VITALS} = 'NO' ]; then
    
  set +x
  echo " "
  echo "NOTE: User has requested that historical vitals not be used...."
  echo " "
  set -x
  >${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc}
    
fi

#------------------------------------------------------------------#
# Now select all storms to be processed, that is, process every
# storm that's listed in the updated vitals file for the current
# forecast hour.  If there are no storms for the current time,
# then exit.
#------------------------------------------------------------------#

numvitrecs=`cat ${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc} | wc -l`
if [ ${numvitrecs} -eq 0 ]
then
  if [ ${trkrtype} = 'tracker' ]
  then
    set +x
    echo " "
    echo "!!! WARNING -- There are no vitals records for this time period "
    echo "!!! in the UPDATED vitals file."
    echo "!!! It could just be that there are no storms for the current"
    echo "!!! time.  You may wish to check the date and submit this job again..."
    echo " "
    set -x
    exit 0
  fi
fi

set +x
echo " "
echo " *--------------------------------*"
echo " |        STORM SELECTION         |"
echo " *--------------------------------*"
echo " "
set -x

ict=1
while [ $ict -le 15 ]
do
  stormflag[${ict}]=3
  let ict=ict+1
done

dtg_current="${symd} ${cyc}00"
stormmax=` grep "${dtg_current}" ${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc} | wc -l`

if [ ${stormmax} -gt 15 ]
then
  stormmax=15
fi

sct=1
while [ ${sct} -le ${stormmax} ]
do
  stormflag[${sct}]=1
  let sct=sct+1
done


#---------------------------------------------------------------#
#
#    --------  "Genesis" Vitals processing   --------
#
# May 2006:  This entire genesis tracking system is being
# upgraded to more comprehensively track and categorize storms.
# One thing that has been missing from the tracking system is
# the ability to keep track of storms from one analysis cycle
# to the next.  That is, the current system has been very
# effective at tracking systems within a forecast, but we have
# no methods in place for keeping track of storms across
# difference initial times.  For example, if we are running
# the tracker on today's 00z GFS analysis, we will get a
# position for various storms at the analysis time.  But then
# if we go ahead and run again at 06z, we have no way of
# telling the tracker that we know about the 00z position of
# this storm.  We now address that problem by creating
# "genesis" vitals, that is, when a storm is found at an
# analysis time, we not only produce "atcfunix" output to
# detail the track & intensity of a found storm, but we also
# produce a vitals record that will be used for the next
# run of the tracker script.  These "genesis vitals" records
# will be of the format:
#
#  YYYYMMDDHH_AAAH_LLLLX_TYP
#
#    Where:
#
#      YYYYMMDDHH = Date the storm was FIRST identified
#                   by the tracker.
#             AAA = Abs(Latitude) * 10; integer value
#               H = 'N' for norther hem, 'S' for southern hem
#            LLLL = Abs(Longitude) * 10; integer value
#               X = 'E' for eastern hem, 'W' for western hem
#             TYP = Tropical cyclone storm id if this is a
#                   tropical cyclone (e.g., "12L", or "09W", etc).
#                   If this is one that the tracker instead "Found
#                   On the Fly (FOF)", we simply put those three
#                   "FOF" characters in there.
#J.Peng----2012-04-12--------
genvitfile=${COMINgenvit}/genesis.vitals.${cmodel}.${atcfout}.${CENT}${syy}
touch ${TRKDATA}/genvitals.${cmodel}.${atcfout}.${PDY}${cyc}

if [ -f $genvitfile ]; then
  d6ago_ymdh=` ${NDATE:?} -6 ${PDY}${cyc}`
  d6ago_4ymd=` echo ${d6ago_ymdh} | cut -c1-8`
  d6ago_ymd=` echo ${d6ago_ymdh} | cut -c3-8`
  d6ago_hh=`  echo ${d6ago_ymdh} | cut -c9-10`
  d6ago_str="${d6ago_ymd} ${d6ago_hh}00"
  
  d6ahead_ymdh=` ${NDATE:?} 6 ${PDY}${cyc}`
  d6ahead_4ymd=` echo ${d6ahead_ymdh} | cut -c1-8`
  d6ahead_ymd=` echo ${d6ahead_ymdh} | cut -c3-8`
  d6ahead_hh=`  echo ${d6ahead_ymdh} | cut -c9-10`
  d6ahead_str="${d6ahead_ymd} ${d6ahead_hh}00"
  
  set +x
  echo " "
  echo " d6ago_str=    --->${d6ago_str}<---"
  echo " current_str=  --->${current_str}<---"
  echo " d6ahead_str=  --->${d6ahead_str}<---"
  echo " "
  #echo " Listing and contents of ${genvitfile} follow "
  #echo " for the times 6h ago, current and 6h ahead:"
  #echo " "
  set -x
  
  #J.Peng----2012-04-11-----
  ##ls -la ${COMINgenvit}/genesis.vitals.${atcfout}.${CENT}${syy}
  ##cat ${COMINgenvit}/genesis.vitals.${atcfout}.${CENT}${syy}
  #ls -la ${COMINgenvit}/genesis.vitals.${cmodel}.${atcfout}.${CENT}${syy}
  #cat ${COMINgenvit}/genesis.vitals.${cmodel}.${atcfout}.${CENT}${syy}
  
  grep "${d6ago_str}"   ${genvitfile} >>${TRKDATA}/genvitals.${cmodel}.${atcfout}.${PDY}${cyc}
  grep "${current_str}" ${genvitfile} >>${TRKDATA}/genvitals.${cmodel}.${atcfout}.${PDY}${cyc}
  grep "${d6ahead_str}" ${genvitfile} >>${TRKDATA}/genvitals.${cmodel}.${atcfout}.${PDY}${cyc}

  num_gen_vits=`cat ${TRKDATA}/genvitals.${cmodel}.${atcfout}.${PDY}${cyc} | wc -l`
else
  echo "WARNING: Genesis Vitals from previous run(s) not found!"
fi

echo "&datenowin   dnow%yy=${syyyy}, dnow%mm=${smm},"       >${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}
echo "             dnow%dd=${sdd}, dnow%hh=${cyc}/"        >>${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}
echo "&date6agoin  d6ago%yy=${syyyy6}, d6ago%mm=${smm6},"  >>${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}
echo "             d6ago%dd=${sdd6}, d6ago%hh=${shh6}/"    >>${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}
echo "&date6aheadin  d6ahead%yy=${syyyyp6}, d6ahead%mm=${smmp6}," >>${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}
echo "               d6ahead%dd=${sddp6}, d6ahead%hh=${shhp6}/"  >>${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}

#J.Peng----2012-05-04--- need this for TC vitals------------------
num_gen_vits=0

if [ ${num_gen_vits} -gt 0 ]
then
  export pgm=supvit_gen
  . prep_step

  # Input file
  export FORT31=${TRKDATA}/genvitals.${cmodel}.${atcfout}.${PDY}${cyc}

  # Output file
  export FORT51=${TRKDATA}/genvitals.upd.${cmodel}.${atcfout}.${PDY}${cyc}

  msg="$pgm start for $atcfout at ${cyc}z"
  postmsg "$jlogfile" "$msg"

  ${EXECens_tracker}/supvit_gen <${TRKDATA}/sgv_input.${atcfout}.${PDY}${cyc}
  sgvrcc=$?

  if [ ${sgvrcc} -eq 0 ]
  then
    msg="$pgm end for $atcfout at ${cyc}z completed normally"
    postmsg "$jlogfile" "$msg"
  else
    set +x
    echo " "
    echo "FATAL ERROR:  An error occurred while running supvit_gen, "
    echo "!!! which is the program that updates the genesis vitals file."
    echo "!!! Return code from supvit_gen = ${sgvrcc}"
    echo "!!! model= ${atcfout}, forecast initial time = ${PDY}${cyc}"
    echo " "
    set -x
    err_exit "FAILED ${jobid} - ERROR RUNNING SUPVIT_GEN IN TRACKER SCRIPT- ABNORMAL EXIT"
  fi
    
else
  rm -f ${TRKDATA}/genvitals.upd.${cmodel}.${atcfout}.${PDY}${cyc} 
  touch ${TRKDATA}/genvitals.upd.${cmodel}.${atcfout}.${PDY}${cyc}
fi


#-----------------------------------------------------------------#
#
#         ------  CUT APART INPUT GRIB FILES  -------
#
# For the selected model, cut apart the GRIB input files in order
# to pull out only the variables that we need for the tracker.  
# Put these selected variables from all forecast hours into 1 big 
# GRIB file that we'll use as input for the tracker.
# 
# The wgrib utility (/nwprod/util/exec/wgrib) is used to cut out 
# the needed parms for the GFS, MRF, GDAS, UKMET and NOGAPS files.
# The utility /nwprod/util/exec/copygb is used to interpolate the 
# NGM (polar stereographic) and NAM (Lambert Conformal) data from 
# their grids onto lat/lon grids.  Note that while the lat/lon 
# grid that I specify overlaps into areas that don't have any data 
# on the original grid, Mark Iredell wrote the copygb software so 
# that it will mask such "no-data" points with a bitmap (just be 
# sure to check the lbms in your fortran program after getgb).
#-----------------------------------------------------------------#

set +x
echo " "
echo " -----------------------------------------"
echo "   NOW CUTTING APART INPUT GRIB FILES TO "
echo "   CREATE 1 BIG GRIB INPUT FILE "
echo " -----------------------------------------"
echo " "
set -x

regflag=`grep NHC ${TRKDATA}/vitals.upd.${atcfout}.${PDY}${cyc} | wc -l`

# ------------------------------
#   Process GFS, if selected
# ------------------------------
  
if [ ${model} -eq 1 ]
then

  if [ $loopnum -eq 1 ]
  then

    if [ -s ${TRKDATA}/gfsgribfile.${PDY}${cyc} ]
    then 
      rm ${TRKDATA}/gfsgribfile.${PDY}${cyc}
    fi

    rm -f ${TRKDATA}/master.gfsgribfile.${PDY}${cyc}.f*
    rm -f ${TRKDATA}/gfsgribfile.${PDY}${cyc}.f*
    >${TRKDATA}/gfsgribfile.${PDY}${cyc}

    set +x 
    echo " "
    echo "Time before gfs wgrib loop is `date`"
    echo " "
    set -x
  
    for fhour in ${fcsthrs}
    do
  
      if [ ! -s ${gfsdir}/${gfsgfile}${fhour} ]
      then
        set +x
        echo " "
        echo "FATAL ERROR:  GFS File missing: ${gfsdir}/${gfsgfile}${fhour}"
        echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
        echo " "
        set -x
        err_exit "FAILED ${jobid} - MISSING GFS FILE IN TRACKER SCRIPT - ABNORMAL EXIT"
      fi

      gfile=${gfsdir}/${gfsgfile}${fhour}
      ${WGRIB2:?} -s $gfile >gfs.ix
      export err=$?; err_chk
  
      for parm in ${wgrib_parmlist} 
      do
        case ${parm} in
	  "SurfaceU")
	   grep "UGRD:10 m " gfs.ix | ${WGRIB2:?} -i $gfile -append -grib \
	     ${TRKDATA}/master.gfsgribfile.${PDY}${cyc}.f${fhour} ;;
	  "SurfaceV")
	   grep "VGRD:10 m " gfs.ix | ${WGRIB2:?} -i $gfile -append -grib \
	     ${TRKDATA}/master.gfsgribfile.${PDY}${cyc}.f${fhour} ;;
	       *)
	   grep "${parm}" gfs.ix | ${WGRIB2:?} -i $gfile -append -grib \
	     ${TRKDATA}/master.gfsgribfile.${PDY}${cyc}.f${fhour} ;;
	 esac
      done

      gfs_master_file=${TRKDATA}/master.gfsgribfile.${PDY}${cyc}.f${fhour}
      gfs_cat_file=${TRKDATA}/gfsgribfile.${PDY}${cyc}
      ${GRB2INDEX:?} ${gfs_master_file} ${gfs_master_file}.ix
      export err=$?; err_chk

      g1=${gfs_master_file}
      x1=${gfs_master_file}.ix
      cat ${gfs_master_file} >>${gfs_cat_file}
    done

    ${GRB2INDEX:?} ${TRKDATA}/gfsgribfile.${PDY}${cyc} ${TRKDATA}/gfsixfile.${PDY}${cyc}
    export err=$?; err_chk

# Now run through the work to get data for phase checking....
#   --------------------------------------------
    catfile=${TRKDATA}/${cmodel}.${PDY}${cyc}.catfile
    >${catfile}

    for fhour in ${fcsthrs}
    do

      set +x
      echo " "
      echo "Date in interpolation for fhour= $fhour before = `date`"
      echo " "
      set -x

      gfile=${TRKDATA}/gfsgribfile.${PDY}${cyc}
      ifile=${TRKDATA}/gfsixfile.${PDY}${cyc}
      ${GRB2INDEX:?} $gfile $ifile
      export err=$?; err_chk

      # This next part is commented out for the GFS since we already
      # have the necessary GFS height and temperature data at 
      # 50-mb intervals.  However, we then still need to average the
      # temperature data to get the 300-500 mb mean temperature, and
      # that code is still un-commented below.

#      gparm=7
#      namelist=${TRKDATA}/vint_input.${PDY}${cyc}.z
#     . prep_step
#      echo "&timein ifcsthour=${fhour},"       >${namelist}
#      echo "        iparm=${gparm},"          >>${namelist}
#      echo "        gribver=${gribver},"      >>${namelist}
#      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
#      echo "        g2_model=${model}/"       >>${namelist}
#      ln -s -f ${gfile}                                       fort.11
#      ln -s -f ${FIXens_tracker}/gfs_hgt_levs.txt             fort.16
#      ln -s -f ${ifile}                                       fort.31
#      ln -s -f ${TRKDATA}/${cmodel}.${PDY}${cyc}.z.f${fhour}     fort.51
#      ${EXECens_tracker}/vint_g2.x <${namelist}
#      rcc=$?

#      gparm=11
#      namelist=${TRKDATA}/vint_input.${PDY}${cyc}.t
#     . prep_step
#      echo "&timein ifcsthour=${fhour},"       >${namelist}
#      echo "        iparm=${gparm},"          >>${namelist}
#      echo "        gribver=${gribver},"      >>${namelist}
#      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
#      echo "        g2_model=${model}/"       >>${namelist}
#      ln -s -f ${gfile}                                       fort.11
#      ln -s -f ${FIXens_tracker}/gfs_tmp_levs.txt             fort.16
#      ln -s -f ${ifile}                                       fort.31
#      ln -s -f ${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}     fort.51
#      ${EXECens_tracker}/vint_g2.x <${namelist}
#      rcc=$?

      gparm=11
#      ffile=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}
      ffile=${gfile}
      tavefile=${TRKDATA}/${cmodel}.tave.${PDY}${cyc}.f${fhour}

      . prep_step

      # Input files
      namelist=${TRKDATA}/tave_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}
      
      # Output file
      export FORT51=${tavefile}
#      export FORT92=${TRKDATA}/${cmodel}.tave92.${PDY}${cyc}.f${fhour}

      ${EXECens_tracker}/tave_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to tave_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -tave_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi

#      zfile=${TRKDATA}/${cmodel}.${PDY}${cyc}.z.f${fhour}
#      cat ${zfile} ${tavefile} >>${catfile}
      cat ${tavefile} >>${catfile}

#J.Peng----2012-04-18---added for U-shear-----
      gparm=33
      ffile=${gfile}

      . prep_step

      # Input files
      namelist=${TRKDATA}/ushear_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}.ushear.${PDY}${cyc}.f${fhour}

      ${EXECens_tracker}/ushear_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to ushear_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -ushear_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi

      ushearfile=${TRKDATA}/${cmodel}.ushear.${PDY}${cyc}.f${fhour}
      cat ${ushearfile} >>${catfile}
#J.Peng----2012-04-18---added for U-shear-----    

      set +x 
      echo " "
      echo "Date in interpolation for fhour= $fhour after = `date`"
      echo " "
      set -x

    done

    cat ${catfile} >>${gfile}

  fi

  gfile=${TRKDATA}/gfsgribfile.${PDY}${cyc}
  ifile=${TRKDATA}/gfsixfile.${PDY}${cyc}
  ${GRB2INDEX:?} ${gfile} ${ifile}
  export err=$?; err_chk

  gribfile=${TRKDATA}/gfsgribfile.${PDY}${cyc}
  ixfile=${TRKDATA}/gfsixfile.${PDY}${cyc}

fi

# ------------------------------
#   Process NAVGEM, if selected
# ------------------------------

if [ ${model} -eq 7 ]
then

  if [ $loopnum -eq 1 ]
  then

    if [ -s ${TRKDATA}/ngpsgribfile.${PDY}${cyc} ]
    then
      rm ${TRKDATA}/ngpsgribfile.${PDY}${cyc}
    fi
  
    for fhour in ${fcsthrs}
    do
  
      if [ ! -s ${ngpsdir}/${ngpsgfile}${fhour}${ngemgfile} ]
      then
        set +x
        echo " "
        echo "FATAL ERROR:  NAVGEM File missing ${ngpsdir}/${ngpsgfile}${fhour}${ngemgfile}"
        echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
        echo " "
        set -x
        if [ "$DCOM_STATUS" = "data of opportunity" ]; then
          echo "${ngpsdir}/${ngpsgfile}${fhour}${ngemgfile}" >> ${DATA}/missing_ngps.txt
          exit
        else
          err_exit "MISSING NAVGEM FILE at $0:$LINENO"
        fi
      fi
  
      gfile=${ngpsdir}/${ngpsgfile}${fhour}${ngemgfile}
      ${WGRIB2:?} -s $gfile >ngps.ix
      export err=$?; err_chk
  
      for parm in ${wgrib_parmlist}
      do
        case ${parm} in
           "SurfaceU")
              grep "UGRD:10 m above" ngps.ix | ${WGRIB2:?} -i $gfile -append -grib \
                             ${TRKDATA}/ngpsgribfile.${PDY}${cyc} ;; 

           "SurfaceV")
              grep "VGRD:10 m above" ngps.ix | ${WGRIB2:?} -i $gfile -append -grib \
                             ${TRKDATA}/ngpsgribfile.${PDY}${cyc} ;;
           *)
              grep "${parm}" ngps.ix | ${WGRIB2:?} -i $gfile -append -grib \
                             ${TRKDATA}/ngpsgribfile.${PDY}${cyc} ;;
        esac
      done
    done

# Now run through the work to get data for phase checking....
    ${GRB2INDEX:?} ${TRKDATA}/ngpsgribfile.${PDY}${cyc} ${TRKDATA}/ngpsixfile.${PDY}${cyc}
    export err=$?; err_chk

    if [ ${PHASEFLAG} = 'y' ]; then
    catfile=${TRKDATA}/${cmodel}.${PDY}${cyc}.catfile
    >${catfile}

    for fhour in ${fcsthrs}
    do

      set +x
      echo " "
      echo "Date in interpolation for fhour= $fhour before = `date`"
      echo " "
      set -x

      gfile=${TRKDATA}/ngpsgribfile.${PDY}${cyc}
      ifile=${TRKDATA}/ngpsixfile.${PDY}${cyc}
      ${GRB2INDEX:?} $gfile $ifile
      export err=$?; err_chk

#     ----------------------------------------------------
#     First, interpolate height data to get data from
#     300 to 900 mb, every 50 mb....

      gparm=7

      . prep_step

      # Input files
      namelist=${TRKDATA}/vint_input.${PDY}${cyc}.z
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${gfile}
      export FORT16=${FIXens_tracker}/ngps_hgt_levs.txt
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}.${PDY}${cyc}.z.f${fhour}

      ${EXECens_tracker}/vint_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to vint_g2.x for GPH at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -vint_g2.x-  for GPH AT LINE $LINENO - ABNORMAL EXIT"
      fi

#     ----------------------------------------------------
#     Now interpolate temperature data to get data from
#     300 to 500 mb, every 50 mb....

      gparm=11

      . prep_step

      # Input files
      namelist=${TRKDATA}/vint_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${gfile}
      export FORT16=${FIXens_tracker}/ngps_tmp_levs.txt
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}
      ${EXECens_tracker}/vint_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to vint_g2.x for T at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -vint_g2.x-  for T AT LINE $LINENO - ABNORMAL EXIT"
      fi

#     ----------------------------------------------------
#     Now average the temperature data that we just
#     interpolated to get the mean 300-500 mb temperature...

      gparm=11
      ffile=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}
      ifile=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}.i
      tavefile=${TRKDATA}/${cmodel}_tave.${PDY}${cyc}.f${fhour}
      zfile=${TRKDATA}/${cmodel}.${PDY}${cyc}.z.f${fhour}
      ${GRB2INDEX:?} ${ffile} ${ifile}
      export err=$?; err_chk

      . prep_step

      # Input files
      namelist=${TRKDATA}/tave_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}_tave.${PDY}${cyc}.f${fhour}

      ${EXECens_tracker}/tave_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to tave_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -tave_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi

      cat ${zfile} ${tavefile} >>${catfile}

#J.Peng----2012-06-04---added for U-shear-----
      gparm=33
      ffile=${gfile}
      ifile=${TRKDATA}/ngpsixfile.${PDY}${cyc}

      . prep_step

      # Input files
      namelist=${TRKDATA}/ushear_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}
      export FORT51=${TRKDATA}/${cmodel}_ushear.${PDY}${cyc}.f${fhour}

      ${EXECens_tracker}/ushear_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to ushear_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -ushear_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi

      ushearfile=${TRKDATA}/${cmodel}_ushear.${PDY}${cyc}.f${fhour}
      cat ${ushearfile} >>${catfile}
#J.Peng----2012-06-04---added for U-shear-----

      set +x
      echo " "
      echo "Date in interpolation for fhour= $fhour after = `date`"
      echo " "
      set -x
    done
    fi
  fi  

  gfile=${TRKDATA}/ngpsgribfile.${PDY}${cyc}
  if [ ${PHASEFLAG} = 'y' ]; then
    cat ${catfile} >>${gfile}
  fi

  gribfile=${TRKDATA}/ngpsgribfile.${PDY}${cyc}
  ixfile=${TRKDATA}/ngpsixfile.${PDY}${cyc}
  ${GRB2INDEX:?} ${gribfile} ${ixfile}
  export err=$?; err_chk
fi

# ------------------------------
#   Process CMC-deterministic forecast, if selected
# ------------------------------

if [ ${model} -eq 15 ]
then

  if [ $loopnum -eq 1 ]
  then

    if [ -s ${TRKDATA}/cmcgribfile.${PDY}${cyc} ]
    then
      rm ${TRKDATA}/cmcgribfile.${PDY}${cyc}
    fi

    for fhour in ${fcsthrs}
    do

      if [ ! -s ${cmcdir}/${cmcgfile}${fhour}${cmcgfile2} ]
      then
        set +x
        echo " "
        echo "FATAL ERROR:  CMC File missing ${cmcdir}/${cmcgfile}${fhour}${cmcgfile2}"
        echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
        echo " "
        set -x
      fi

      gfile=${cmcdir}/${cmcgfile}${fhour}${cmcgfile2}
      ${WGRIB2:?} -s $gfile >cmc.ix
      export err=$?; err_chk

      for parm in ${wgrib_parmlist}
      do
        case ${parm} in
           "SurfaceU")
              grep "UGRD:10 m above" cmc.ix | ${WGRIB2:?} -i $gfile -append -grib \
                             ${TRKDATA}/cmcgribfile.${PDY}${cyc} ;;

           "SurfaceV")
              grep "VGRD:10 m above" cmc.ix | ${WGRIB2:?} -i $gfile -append -grib \
                             ${TRKDATA}/cmcgribfile.${PDY}${cyc} ;;
           *)
              grep "${parm}" cmc.ix | ${WGRIB2:?} -i $gfile -append -grib \
                             ${TRKDATA}/cmcgribfile.${PDY}${cyc} ;;
        esac
      done
    done

# J.Peng--04-05-2017--changing grid from 180E to 0E------------
#  wgrib2 junk -small_grib 0:359.76 -90:90 junk2
# J.Peng--10-15-2019----uncomment the next 4 lines --------
    cp ${TRKDATA}/cmcgribfile.${PDY}${cyc} ${TRKDATA}/junk
    rm -f ${TRKDATA}/cmcgribfile.${PDY}${cyc}
    ${WGRIB2} ${TRKDATA}/junk -small_grib 0:359.76 -90:90 ${TRKDATA}/junk2
    cp ${TRKDATA}/junk2 ${TRKDATA}/cmcgribfile.${PDY}${cyc}

# Now run through the work to get data for phase checking....
    ${GRB2INDEX:?} ${TRKDATA}/cmcgribfile.${PDY}${cyc} ${TRKDATA}/cmcixfile.${PDY}${cyc}
    export err=$?; err_chk

    if [ ${PHASEFLAG} = 'y' ]; then
    catfile=${TRKDATA}/${cmodel}.${PDY}${cyc}.catfile
    >${catfile}

    for fhour in ${fcsthrs}
    do

      set +x
      echo " "
      echo "Date in interpolation for fhour= $fhour before = `date`"
      echo " "
      set -x

      gfile=${TRKDATA}/cmcgribfile.${PDY}${cyc}
      ifile=${TRKDATA}/cmcixfile.${PDY}${cyc}
      ${GRB2INDEX:?} $gfile $ifile
      export err=$?; err_chk

#     ----------------------------------------------------
#     First, interpolate height data to get data from
#     300 to 900 mb, every 50 mb....

      gparm=7

      . prep_step

      # Input files
      namelist=${TRKDATA}/vint_input.${PDY}${cyc}.z
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${gfile}
      export FORT16=${FIXens_tracker}/cmc_hgt_levs.txt
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}.${PDY}${cyc}.z.f${fhour}

      ${EXECens_tracker}/vint_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to vint_g2.x for GPH at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -vint_g2.x-  for GPH AT LINE $LINENO - ABNORMAL EXIT"
      fi

#     ----------------------------------------------------
#     Now interpolate temperature data to get data from
#     300 to 500 mb, every 50 mb....

      gparm=11

      . prep_step

      # Input files
      namelist=${TRKDATA}/vint_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${gfile}
      export FORT16=${FIXens_tracker}/cmc_tmp_levs.txt
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}
      ${EXECens_tracker}/vint_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to vint_g2.x for T at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -vint_g2.x-  for T AT LINE $LINENO - ABNORMAL EXIT"
      fi

#     ----------------------------------------------------
#     Now average the temperature data that we just
#     interpolated to get the mean 300-500 mb temperature...

      gparm=11
      ffile=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}
      ifile=${TRKDATA}/${cmodel}.${PDY}${cyc}.t.f${fhour}.i
      tavefile=${TRKDATA}/${cmodel}_tave.${PDY}${cyc}.f${fhour}
      zfile=${TRKDATA}/${cmodel}.${PDY}${cyc}.z.f${fhour}
      ${GRB2INDEX:?} ${ffile} ${ifile}
      export err=$?; err_chk

      . prep_step

      # Input files
      namelist=${TRKDATA}/tave_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}

      # Output file
      export FORT51=${TRKDATA}/${cmodel}_tave.${PDY}${cyc}.f${fhour}

      ${EXECens_tracker}/tave_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to tave_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -tave_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi

      cat ${zfile} ${tavefile} >>${catfile}

#J.Peng----2012-06-04---added for U-shear-----
      gparm=33
      ffile=${gfile}
      ifile=${TRKDATA}/cmcixfile.${PDY}${cyc}

      . prep_step

      # Input files
      namelist=${TRKDATA}/ushear_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparm=${gparm},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}
      export FORT51=${TRKDATA}/${cmodel}_ushear.${PDY}${cyc}.f${fhour}

      ${EXECens_tracker}/ushear_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to ushear_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -ushear_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi

      ushearfile=${TRKDATA}/${cmodel}_ushear.${PDY}${cyc}.f${fhour}
      cat ${ushearfile} >>${catfile}
#J.Peng----2012-06-04---added for U-shear-----
#
#J.Peng----2017-04-12---added for RH calculation with CMC-SPFH
      gparmq=7
      gparmt=11

      ffile=${gfile}
      ifile=${TRKDATA}/cmcixfile.${PDY}${cyc}

      . prep_step

      # Input files
      namelist=${TRKDATA}/rh_input.${PDY}${cyc}
      echo "&timein ifcsthour=${fhour},"       >${namelist}
      echo "        iparmq=${gparmq},"          >>${namelist}
      echo "        iparmt=${gparmt},"          >>${namelist}
      echo "        gribver=${gribver},"      >>${namelist}
      echo "        g2_jpdtn=${g2_jpdtn},"    >>${namelist}
      echo "        g2_model=${model}/"       >>${namelist}
      export FORT11=${ffile}
      export FORT31=${ifile}
      export FORT16=${FIXens_tracker}/cmc_rh_levs.txt

      # Output file
      export FORT51=${TRKDATA}/${cmodel}_rh.${PDY}${cyc}.f${fhour}
      ${EXECens_tracker}/rhum_g2.x <${namelist}
      rcc=$?

      if [ $rcc -ne 0 ]; then
        set +x
        echo " "
        echo "FATAL ERROR in call to rhum_g2.x at fhour= $fhour"
        echo "rcc= $rcc      EXITING.... "
        echo " "
        set -x
        err_exit "FAILED ${jobid} -rhum_g2.x-  AT LINE $LINENO - ABNORMAL EXIT"
      fi
      rhfile=${TRKDATA}/${cmodel}_rh.${PDY}${cyc}.f${fhour}
      cat ${rhfile} >>${catfile}
#J.Peng----2017-04-12---added for RH calculation with CMC-SPFH

      set +x
      echo " "
      echo "Date in interpolation for fhour= $fhour after = `date`"
      echo " "
      set -x
    done
    fi
  fi

  gfile=${TRKDATA}/cmcgribfile.${PDY}${cyc}
  if [ ${PHASEFLAG} = 'y' ]; then
    cat ${catfile} >>${gfile}
  fi

  gribfile=${TRKDATA}/cmcgribfile.${PDY}${cyc}
  ixfile=${TRKDATA}/cmcixfile.${PDY}${cyc}
  ${GRB2INDEX:?} ${gribfile} ${ixfile}
  export err=$?; err_chk
fi

#------------------------------------------------------------------------#
#                         Now run the tracker                            #
#------------------------------------------------------------------------#
set +x
echo " "
echo " -----------------------------------------------"
echo "           NOW EXECUTING TRACKER......"
echo " -----------------------------------------------"
echo " "
set -x

ist=1
while [ $ist -le 15 ]
do
  if [ ${stormflag[${ist}]} -ne 1 ]
  then
    set +x; echo "Storm number $ist NOT selected for processing"; set -x
  else
    set +x; echo "Storm number $ist IS selected for processing...."; set -x
  fi
  let ist=ist+1
done

if [ ! -s ${TRKDATA}/last_fcst_hour.${atcfout}.${PDY}${cyc} ]
then
  for fhr in $fcsthrs; do
    if [ $fhr -ne 99 ]; then
      last_fcst_hour=$fhr
    fi
  done
  echo ${last_fcst_hour} >${TRKDATA}/last_fcst_hour.${atcfout}.${PDY}${cyc}
fi

namelist=${TRKDATA}/input.${atcfout}.${PDY}${cyc}
ATCFNAME=` echo "${atcfname}" | tr '[a-z]' '[A-Z]'`

export atcfymdh=${scc}${syy}${smm}${sdd}${shh}

contour_interval=100.0
write_vit=y
want_oci=.TRUE.

echo "&datein inp%bcc=${scc},inp%byy=${syy},inp%bmm=${smm},"      >${namelist}
echo "        inp%bdd=${sdd},inp%bhh=${shh},inp%model=${model}," >>${namelist}
echo "        inp%modtyp='${modtyp}',"                           >>${namelist}
echo "        inp%lt_units='${lead_time_units}',"                >>${namelist}
echo "        inp%file_seq='${file_sequence}',"                  >>${namelist}
echo "        inp%nesttyp='${nest_type}'/"                       >>${namelist}
echo "&atcfinfo atcfnum=${atcfnum},atcfname='${ATCFNAME}',"      >>${namelist}
echo "          atcfymdh=${atcfymdh},atcffreq=${atcffreq}/"      >>${namelist}
echo "&trackerinfo trkrinfo%westbd=${trkrwbd},"                  >>${namelist}
echo "      trkrinfo%eastbd=${trkrebd},"                         >>${namelist}
echo "      trkrinfo%northbd=${trkrnbd},"                        >>${namelist}
echo "      trkrinfo%southbd=${trkrsbd},"                        >>${namelist}
echo "      trkrinfo%type='${trkrtype}',"                        >>${namelist}
echo "      trkrinfo%mslpthresh=${mslpthresh},"                  >>${namelist}
echo "      trkrinfo%v850thresh=${v850thresh},"                  >>${namelist}
echo "      trkrinfo%gridtype='${modtyp}',"                      >>${namelist}
echo "      trkrinfo%contint=${contour_interval},"               >>${namelist}
echo "      trkrinfo%want_oci=${want_oci},"                      >>${namelist}
echo "      trkrinfo%out_vit='${write_vit}',"                    >>${namelist}
echo "      trkrinfo%gribver=${gribver},"                        >>${namelist}
echo "      trkrinfo%g2_jpdtn=${g2_jpdtn}/"                      >>${namelist}
echo "&phaseinfo phaseflag='${PHASEFLAG}',"                      >>${namelist}
echo "           phasescheme='${PHASE_SCHEME}',"                 >>${namelist}
echo "           wcore_depth=${WCORE_DEPTH}/"                    >>${namelist}
echo "&structinfo structflag='${STRUCTFLAG}',"                   >>${namelist}
echo "            ikeflag='${IKEFLAG}'/"                         >>${namelist}
echo "&fnameinfo  gmodname='${atcfname}',"                       >>${namelist}
echo "            rundescr='${rundescr}',"                       >>${namelist}
echo "            atcfdescr='${atcfdescr}'/"                     >>${namelist}
echo "&verbose verb=3/"                                          >>${namelist}
echo "&waitinfo use_waitfor='n',"                                >>${namelist}
echo "          wait_min_age=10,"                                >>${namelist}
echo "          wait_min_size=100,"                              >>${namelist}
echo "          wait_max_wait=1800,"                             >>${namelist}
echo "          wait_sleeptime=5,"                               >>${namelist}
echo "          per_fcst_command=''/"                            >>${namelist}

export pgm=gettrk_gen_g2
. prep_step

export FORT11=${gribfile}
export FORT12=${TRKDATA}/vitals.upd.${atcfout}.${PDY}${shh}
export FORT14=${TRKDATA}/genvitals.upd.${cmodel}.${atcfout}.${PDY}${cyc}
export FORT15=${FIXens_tracker}/${cmodel}.genesis_leadtimes
export FORT31=${ixfile}

if [ ${trkrtype} = 'tracker' ]; then
  if [ ${atcfout} = 'gfdt' -o ${atcfout} = 'gfdl' -o \
       ${atcfout} = 'hwrf' -o ${atcfout} = 'hwft' ]; then
    export FORT61=${TRKDATA}/trak.${atcfout}.all.${stormenv}.${PDY}${cyc}
    export FORT62=${TRKDATA}/trak.${atcfout}.atcf.${stormenv}.${PDY}${cyc}
    export FORT63=${TRKDATA}/trak.${atcfout}.radii.${stormenv}.${PDY}${cyc}
    export FORT64=${TRKDATA}/trak.${atcfout}.atcfunix.${stormenv}.${PDY}${cyc}
    export FORT66=${TRKDATA}/trak.${atcfout}.atcf_gen.${stormenv}.${PDY}${cyc}
    export FORT68=${TRKDATA}/trak.${atcfout}.atcf_sink.${stormenv}.${PDY}${cyc}
    export FORT69=${TRKDATA}/trak.${atcfout}.atcf_hfip.${stormenv}.${PDY}${cyc}
  else
    export FORT61=${TRKDATA}/trak.${atcfout}.all.${PDY}${cyc}
    export FORT62=${TRKDATA}/trak.${atcfout}.atcf.${PDY}${cyc}
    export FORT63=${TRKDATA}/trak.${atcfout}.radii.${PDY}${cyc}
    export FORT64=${TRKDATA}/trak.${atcfout}.atcfunix.${PDY}${cyc}
    export FORT66=${TRKDATA}/trak.${atcfout}.atcf_gen.${PDY}${cyc}
    export FORT68=${TRKDATA}/trak.${atcfout}.atcf_sink.${PDY}${cyc}
    export FORT69=${TRKDATA}/trak.${atcfout}.atcf_hfip.${PDY}${cyc}
  fi
else
  export FORT61=${TRKDATA}/trak.${atcfout}.all.${regtype}.${PDY}${cyc}
  export FORT62=${TRKDATA}/trak.${atcfout}.atcf.${regtype}.${PDY}${cyc}
  export FORT63=${TRKDATA}/trak.${atcfout}.radii.${regtype}.${PDY}${cyc}
  export FORT64=${TRKDATA}/trak.${atcfout}.atcfunix.${regtype}.${PDY}${cyc}
  export FORT66=${TRKDATA}/trak.${atcfout}.atcf_gen.${regtype}.${PDY}${cyc}
  export FORT68=${TRKDATA}/trak.${atcfout}.atcf_sink.${regtype}.${PDY}${cyc}
  export FORT69=${TRKDATA}/trak.${atcfout}.atcf_hfip.${regtype}.${PDY}${cyc}
fi

if [ ${atcfname} = 'aear' ]
then
  export FORT65=${TRKDATA}/trak.${atcfout}.initvitl.${PDY}${cyc}
fi

if [ ${write_vit} = 'y' ]
then
  export FORT67=${TRKDATA}/output_genvitals.${atcfout}.${PDY}${shh}
fi

if [ ${PHASEFLAG} = 'y' ]; then
  if [ ${atcfout} = 'gfdt' -o ${atcfout} = 'gfdl' -o \
       ${atcfout} = 'hwrf' -o ${atcfout} = 'hwft' ]; then
    export FORT71=${TRKDATA}/trak.${atcfout}.cps_parms.${stormenv}.${PDY}${cyc}
  else
    export FORT71=${TRKDATA}/trak.${atcfout}.cps_parms.${PDY}${cyc}
  fi
fi

if [ ${STRUCTFLAG} = 'y' ]; then
  if [ ${atcfout} = 'gfdt' -o ${atcfout} = 'gfdl' -o \
       ${atcfout} = 'hwrf' -o ${atcfout} = 'hwft' ]; then
    export FORT72=${TRKDATA}/trak.${atcfout}.structure.${stormenv}.${PDY}${cyc}
    export FORT73=${TRKDATA}/trak.${atcfout}.fractwind.${stormenv}.${PDY}${cyc}
    export FORT76=${TRKDATA}/trak.${atcfout}.pdfwind.${stormenv}.${PDY}${cyc}
  else
    export FORT72=${TRKDATA}/trak.${atcfout}.structure.${PDY}${cyc}
    export FORT73=${TRKDATA}/trak.${atcfout}.fractwind.${PDY}${cyc}
    export FORT76=${TRKDATA}/trak.${atcfout}.pdfwind.${PDY}${cyc}
  fi
fi

if [ ${IKEFLAG} = 'y' ]; then
  if [ ${atcfout} = 'gfdt' -o ${atcfout} = 'gfdl' -o \
       ${atcfout} = 'hwrf' -o ${atcfout} = 'hwft' ]; then
    export FORT74=${TRKDATA}/trak.${atcfout}.ike.${stormenv}.${PDY}${cyc}
  else
    export FORT74=${TRKDATA}/trak.${atcfout}.ike.${PDY}${cyc}
  fi
fi

if [ ${trkrtype} = 'midlat' -o ${trkrtype} = 'tcgen' ]; then
  export FORT77=${TRKDATA}/trkrmask.${atcfout}.${regtype}.${PDY}${cyc}
fi

msg="$pgm start for $atcfout at ${cyc}z"
postmsg "$jlogfile" "$msg"

set +x
echo "+++ TIMING: BEFORE gettrk  ---> `date`"
set -x

ulimit -c unlimited

${EXECens_tracker}/gettrk_gen_g2 <${namelist}
gettrk_rcc=$?

set +x
echo "+++ TIMING: AFTER  gettrk  ---> `date`"
set -x

#--------------------------------------------------------------#
# Now copy the output track files to different directories
#--------------------------------------------------------------#

if [ ${gettrk_rcc} -eq 0 ]; then
  set +x
  echo " "
  echo " -----------------------------------------------"
  echo "    NOW COPYING OUTPUT TRACK FILES TO COM  "
  echo " -----------------------------------------------"
  echo " "
  set -x

  if [ -s ${TRKDATA}/output_genvitals.${atcfout}.${PDY}${shh} ]; then
    if [ "$SENDCOM" = 'YES' ]; then
      cp ${TRKDATA}/output_genvitals.${atcfout}.${PDY}${shh} ${COMOUTgenvit:?}/genesis.vitals.${cmodel}.${atcfout}.${CENT}${syy}
      #if [ "$SENDDBN" = 'YES' ]; then
      #  $DBNROOT/bin/dbn_alert ${cmodel^^} GENESIS $job ${COMOUTgenvit}/genesis.vitals.${cmodel}.${atcfout}.${CENT}${syy}
      #fi
    fi
  fi
  msg="$pgm end for $atcfout at ${cyc}z completed normally"
  postmsg "$jlogfile" "$msg"
else
  set +x
  echo " "
  echo "FATAL ERROR:  An error occurred while running gettrk_gen_g2, "
  echo "!!! which is the program that actually gets the track."
  echo "!!! Return code from gettrk_gen_g2 = ${gettrk_rcc}"
  echo "!!! model= ${atcfout}, forecast initial time = ${PDY}${cyc}"
  echo " "
  set -x
  err_exit "FAILED ${jobid} - ERROR RUNNING gettrk_gen_g2 IN TRACKER SCRIPT- ABNORMAL EXIT"
fi

#!/bin/ksh
################################################################################
#
# Name:  getges.sh            Author:  Mark Iredell
#
# Abstract:
# This script copies the valid global guess file to a given file.
# Alternatively, it writes the name of the guess file to standard output.
# Specify option "-n network" for the job network (default global).
# Other options are gdas, gfs, cdas, mrf, prx, etc.
# Specify option "-e environment" for the job environment (default prod).
# Another option is test.
# Specify option "-f fhour" for the specific forecast hour wanted (default any).
# Specify option "-q" for quiet mode to turn off script messages.
# Specify option "-r resolution" for the resolution wanted (default high).
# Other options are 25464 17042, 12628, low, 6228, namopl, any.
# Specify option "-t filetype" for the filetype wanted from among these choices:
# sigges (default), siggm3, siggm2, siggm1, siggp1, siggp2, siggp3,
# sfcges, sfcgm3, sfcgm2, sfcgm1, sfcgp1, sfcgp2, sfcgp3,
# biascr, satang, satcnt, gesfil
# pgbges, pgiges, pgbgm6, pgigm6, pgbgm3, pgigm3, pgbgp3, pgigp3,
# sigcur, sfccur, pgbcur, pgicur, prepqc, tcvg12, tcvges, tcvitl, 
# enggrb, enggri, icegrb, icegri, snogrb, snogrb_high, snogri, sstgrb, sstgri.
# Specify option "-v valid" for the valid date wanted (default $CDATE).
# Currently, the valid hours specified must be a multiple of 3.
# Either 2-digit or 4-digit years are currently allowed.
# Specify positional argument to be the file to which to copy the guess.
# If missing, the NAME of the guess file is written to standard output.
# A nonzero return code from this script means either the arguments are invalid
# or the guess could not be found; a message is written to standard error in
# this case, but neither a file copy nor a standard output write will be done.
# The file returned is guaranteed to exist and be readable.
# The script uses the utility commands NDATE and NHOUR.
#
# Example 1. Copy the production sigma guess for 1998100100 to the file sges.
#  getges.sh -e prod -t sigges -v 1998100100 sges 
#
# Example 2. Assign the pressure grib guess for the date 1998100121.
#  export CDATE=1998100121
#  export XLFUNIT_12="$(getges.sh -qt pgbges||echo /dev/null)"
#
# Example 3. Get the PRX pgb analysis or the best valid guess at 1998100112.
#  getges -e prx -t pgbcur -v 1998100112 pgbfile
#
# Example 5. Get the 24-hour GFS forecast sigma file valid at 1998100112.
#  getges -t sigcur -v 1998100112 -f 24 -e gfs sigfile
#
# History: 1996 December    Iredell       Initial implementation
#          1997 March       Iredell       Nine new filetypes
#          1997 April       Iredell       Two new filetypes and -f option
#          1997 December    Iredell       Four new filetypes
#          1998 April       Iredell       4-digit year allowed;
#                                         sigges internal date no longer checked
#          1998 May         Iredell       T170L42 defaulted; four new filetypes
#                                         and two filetypes deleted
#          1998 June        Rogers        Nam types added
#          1998 September   Iredell       high is default resolution
#          2000 March       Iredell       Cdas and -n option
#          2000 June        Iredell       Eight new filetypes
#          2002 April       Treadon       T254L64 defaulted; add angle dependent
#                                         bias correction file
#          2003 March       Iredell       GFS network out to 384 hours
#          2003 August      Iredell       Hourly global guesses
#          2005 September   Treadon       Add satellite data count file (satcnt)
#          2006 September   Gayno         Add high-res snow analysis
#          2009 January     Rogers        Added sfluxgrb file
#          2011 April       Rogers        Added GFS pg2ges file
#
################################################################################
#-------------------------------------------------------------------------------
# Set some default parameters.
fhbeg=03                         # hour to begin searching backward for guess
fhinc=03                         # hour to increment backward in search
fhend=384                        # hour to end searching backward for guess

#-------------------------------------------------------------------------------
# Get options and arguments.
netwk=global                     # default network
envir=prod                       # default environment
fhour=any                        # default forecast hour
quiet=NO                         # default quiet mode
resol=high                       # default resolution
typef=sigges                     # default filetype
valid=${CDATE:-'?'}              # default valid date
valid=$CDATE                     # default valid date
err=0
while getopts n:e:f:qr:t:v: opt;do
 case $opt in
  n) netwk="$OPTARG";;
  e) envir="$OPTARG";;
  f) fhour="$OPTARG";;
  q) quiet=YES;;
  r) resol="$OPTARG";;
  t) typef="$OPTARG";;
  v) valid="$OPTARG";;
  \?) err=1;;
 esac
done
shift $(($OPTIND-1))
gfile=$1
if [[ -z $valid ]];then
 echo "$0: either -v option or environment variable CDATE must be set" >&2
elif [[ $# -gt 1 ]];then
 echo "$0: too many positional arguments" >&2
elif [[ $err -ne 0 ]];then
 echo "$0: invalid option" >&2
fi
if [[ $gfile = '?' || $# -gt 1 || $err -ne 0 || -z $valid ||\
      $netwk = '?' || $envir = '?' || $fhour = '?' || $resol = '?' ||\
      $typef = '?' || $valid = '?' ]];then
 echo "Usage: getges.sh [-n network] [-e environment] [-f fhour] [-q] [-r resolution]" >&2
 echo "                 [-t filetype] [-v valid] [gfile]" >&2
 if [[ $netwk = '?' ]];then
  echo "         network choices:" >&2
  echo "           global (default), namopl, gdas, gfs, cdas, etc." >&2
 elif [[ $envir = '?' ]];then
  echo "         environment choices:" >&2
  echo "           prod (default), test, para, dump, prx" >&2
  echo "           (some network values allowed for compatibility)" >&2
 elif [[ $fhour = '?' ]];then
  echo "         fhour is optional specific forecast hour" >&2
 elif [[ $resol = '?' ]];then
  echo "         resolution choices:" >&2
  echo "           high (default), 25464, 17042, 12628, low, 6228, namopl, any" >&2
 elif [[ $typef = '?' ]];then
  echo "         filetype choices:" >&2
  echo "           sigges (default), siggm3, siggm2, siggm1, siggp1, siggp2, siggp3," >&2
  echo "           sfcges, sfcgm3, sfcgm2, sfcgm1, sfcgp1, sfcgp2, sfcgp3," >&2
  echo "           sfgges, sfggp3, biascr, satang, satcnt, gesfil" >&2
  echo "           pgbges, pgiges, pgbgm6, pgigm6, pgbgm3, pgigm3, pgbgp3, pgigp3," >&2
  echo "           sigcur, sfccur, pgbcur, pgicur, prepqc, tcvg12, tcvges, tcvitl," >&2
  echo "           enggrb, enggri, icegrb, icegri, snogrb, snogri, sstgrb, sstgri," >&2
  echo "           pg2cur, pg2ges, restrt" >&2
 elif [[ $valid = '?' ]];then
  echo "         valid is the valid date in yyyymmddhh or yymmddhh form" >&2
  echo "         (default is environmental variable CDATE)" >&2
 elif [[ $gfile = '?' ]];then
  echo "         gfile is the guess file to write" >&2
  echo "         (default is to write the guess file name to stdout)" >&2
 else
  echo "         (Note: set a given option to '?' for more details)" >&2 
 fi
 exit 1
fi
#[[ $quiet = NO ]]&&set -x
if [[ $envir != prod && $envir != test && $envir != para && $envir != dump && $envir != pr? && $envir != dev ]];then
 netwk=$envir
 envir=prod
 echo '************************************************************' >&2
 echo '* CAUTION: Using "-e" is deprecated in this case.          *' >&2
 echo '*          Please use "-n" instead.                        *' >&2       
 echo '************************************************************' >&2
fi
if [[ $netwk = namopl || $resol = namopl ]];then
  netwk=namopl
  typef=restrt
  resol=namopl
fi
[[ $resol = 57464 || $resol = 38264 || $resol = 19064 || $resol = 25464 || $resol = 17042 || $resol = 12628 ]]&&resol=high
[[ $resol = 6228 ]]&&resol=low
resolsuf=""
[[ $resol == *deg ]]&&resolsuf=.$resol
fhbeg=$($NHOUR $valid)
[[ $fhbeg -le 0 ]]&&fhbeg=03
((fhbeg=(10#$fhbeg-1)/3*3+3))
[[ $fhbeg -lt 10 ]]&&fhbeg=0$fhbeg
if [[ $typef = enggrb ]];then
 typef=icegrb
 echo '************************************************************' >&2
 echo '* CAUTION: Using "-t enggrb" is now deprecated.            *' >&2
 echo '*          Please use "-t icegrb".                         *' >&2       
 echo '************************************************************' >&2
elif [[ $typef = enggri ]];then
 typef=icegri
 echo '************************************************************' >&2
 echo '* CAUTION: Using "-t enggri" is now deprecated.            *' >&2
 echo '*          Please use "-t icegri".                         *' >&2       
 echo '************************************************************' >&2
fi

#-------------------------------------------------------------------------------
# Default top level directories.
export GETGES_COM=${GETGES_COM:-${COMROOT}}
export GETGES_NWG=${GETGES_NWG:-${COMROOT}/nwges}
export GETGES_GLO=${GETGES_GLO:-/gloptmp}

#-------------------------------------------------------------------------------
# Assemble guess list in descending order from the best guess.
geslist=""
geslist00=""

# GDAS
if [[ $netwk = gdas ]];then
 fhend=12
 case $typef in
  sigges)  geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.abias'
   ;;
  biascr_pc) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.abias_pc'
   ;;
  biascr_air) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.abias_air'
   ;;
  radstat) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.radstat'
   ;;
  satang) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges)  geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh'
   ;;
  sfggp3)  geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fhp3'
   ;;
  pgbges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh'
   ;;
  pg2ges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2f$fh$resolsuf'
   ;;
  pgiges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm6 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm6 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm3 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm3 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhp3 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhp3 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pg2cur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2f$fh$resolsuf'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574.1152.576'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_1534) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t1534.3072.1536'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# CFS-CDAS
elif [[ $netwk = cfs-cdas ]];then
 fhend=12
 case $typef in
  sigges)  geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fh}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fhm3}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fhm2}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fhm1}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fhp1}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fhp2}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf${fhp3}.LIS
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges)  geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sfluxgrbf$fh'
   ;;
  sfggp3)  geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sfluxgrbf$fhp3'
   ;;
  pgbges) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbh$fh 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbih$fh 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbh$fhm6 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbih$fhm6 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbh$fhm3 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbih$fhm3 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbh$fhp3 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbih$fhp3 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbh$fh 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbih$fh 
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.snogrb_t574
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.snogrb_t574'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/cfs/$envir/cdas.$day/cdas1.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# GFS
elif [[ $netwk = gfs ]];then
 fhend=384
 case $typef in
  sigges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh'
   ;;
  sfggp3)  geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fhp3'
   ;;
  pgbges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   ;;
  pg2ges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p50.f0$fh$resolsuf'
   ;;
  pgiges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pg2cur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p50.f0$fh$resolsuf'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# GFS
elif [[ $netwk = gfs ]];then
 fhend=126
 case $typef in
  sigges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh'
   ;;
  sfggp3)  geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fhp3'
   ;;
  pgbges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574 
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382' 
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac
 echo '************************************************************' >&2
 echo '* CAUTION: Using "-n gfs" is now deprecated.               *' >&2
 echo '*          Please use "-n gfs".                            *' >&2       
 echo '************************************************************' >&2

# CDAS
elif [[ $netwk = cdas ]];then
 fhbeg=06
 fhend=06
   #$GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fh'
 case $typef in
  sigges)  geslist='
   $COMINcdas/cdas.$day/cdas.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  pgbges) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/cdas/$envir/cdas.$day/cdas.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# CDC CDAS
elif [[ $netwk = cdc ]];then
 fhbeg=06
 fhend=06
 case $typef in
  sigges)  geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  pgbges) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/cdc/$envir/cdas.$day/cdas.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# MRF
elif [[ $netwk = mrf ]];then
 fhend=384
 case $typef in
  sigges) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  pgbges) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/mrf/$envir/mrf.$day/drfmr.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382' 
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574' 
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac
 echo '************************************************************' >&2
 echo '* CAUTION: Using "-n mrf" is now deprecated.               *' >&2
 echo '*          Please use "-n gfs".                            *' >&2       
 echo '************************************************************' >&2

# PRZ
elif [[ $netwk = prz ]];then
 fhend=384
 case $typef in
  sigges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.abias'
   ;;
  satang) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.satang'
   ;;
  satcnt) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.satcnt'
   ;;
  gesfil) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  pgbges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574 
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382' 
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574' 
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac
 echo '************************************************************' >&2
 echo '* CAUTION: Using "-n prz" is now deprecated.               *' >&2
 echo '*          Please use "-n gfs".                            *' >&2       
 echo '************************************************************' >&2

# High resolution production
elif [[ $netwk = global && $resol = high ]];then
 case $typef in
  sigges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.abias
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.abias
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.abias
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.abias'
   fhbeg=06
   fhinc=06
   ;;
  satang) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.satang
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satang
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.satang
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satang'
   fhbeg=06
   fhinc=06
   ;;
  satcnt) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.satcnt
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satcnt
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.satcnt
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satcnt'
   fhbeg=06
   fhinc=06
   ;;
  gesfil) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.gesfile
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.gesfile
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.gesfile
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh'
   ;;
  sfggp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fhp3'
   ;;
  pgbges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm6
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm6
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhp3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhp3'
   ;;
  pg2ges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fh'
   ;;
  pg2gm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm6'
   ;;
  pg2gm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm3'
   ;;
  pg2gp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sanl
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sanl
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sanl
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sfcanl
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfcanl
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sfcanl
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.prepbufr
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.engicegrb
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.engicegrb.index
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574 
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb.index
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sstgrb
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sstgrb.index
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# Low resolution production
elif [[ $netwk = global && $resol = low ]];then
 case $typef in
  sigges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm2
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhm1
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp1
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp2
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fhp3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm2
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhm1
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp1
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp1
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp2
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp2
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fhp3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.abias
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.abias
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.abias
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.abias'
   fhbeg=06
   fhinc=06
   ;;
  satang) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.satang
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.satang
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.satang
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.satang'
   fhbeg=06
   fhinc=06
   ;;
  satcnt) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.satcnt
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.satcnt
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.satcnt
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.satcnt'
   fhbeg=06
   fhinc=06
   ;;
  gesfil) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.gesfile
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.gesfile
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.gesfile
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh'
   ;;
  pgbges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhm6
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhm6
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhm3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhm3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fhp3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fhp3
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhp3
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fhp3'
   ;;
  pg2ges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fh'
   ;;
  pg2gm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm6'
   ;;
  pg2gm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm3'
   ;;
  pg2gp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sf$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sanl
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sanl
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sanl
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.bf$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.bf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.sfcanl
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.sfcanl
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.sfcanl
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbf$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas2.t${cyc}z.pgrbif$fh
   $GETGES_NWG/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fh
   $GETGES_COM/mrf/$envir/mrf.$day/drf01.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
 esac

# Any resolution production
elif [[ $netwk = global && $resol = any ]];then
 case $typef in
  sigges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   ;;
  siggm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm3'
   ;;
  siggm2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm2'
   ;;
  siggm1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhm1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhm1'
   ;;
  siggp1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp1'
   ;;
  siggp2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp2'
   ;;
  siggp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fhp3'
   ;;
  sfcges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   ;;
  sfcgm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm3'
   ;;
  sfcgm2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm2'
   ;;
  sfcgm1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhm1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhm1'
   ;;
  sfcgp1) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp1
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp1
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp1
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp1'
   ;;
  sfcgp2) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp2
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp2
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp2
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp2'
   ;;
  sfcgp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fhp3'
   ;;
  biascr) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.abias
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.abias
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.abias
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.abias'
   fhbeg=06
   fhinc=06
   ;;
  satang) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.satang
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satang
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.satang
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satang'
   fhbeg=06
   fhinc=06
   ;;
  satcnt) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.satcnt
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.satcnt
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.satcnt
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.satcnt'
   fhbeg=06
   fhinc=06
   ;;
  gesfil) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.gesfile
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.gesfile
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.gesfile
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.gesfile'
   fhbeg=00
   fhend=00
   ;;
  sfgges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfluxgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfluxgrbf$fh'
   ;;
  pgbges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   ;;
  pgiges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   ;;
  pgbgm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm6
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm6'
   ;;
  pgigm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm6
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm6'
   ;;
  pgbgm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhm3'
   ;;
  pgigm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhm3'
   ;;
  pgbgp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhp3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fhp3'
   ;;
  pgigp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhp3
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fhp3'
   ;;
  pg2ges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fh'
   ;;
  pg2gm6) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm6
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm6'
   ;;
  pg2gm3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhm3'
   ;;
  pg2gp3) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhp3
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrb2.0p25.f0$fhp3'
   ;;
  sigcur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sf$fh'
   getlist00='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sanl
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sanl
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sanl
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sanl'
   fhbeg=00
   ;;
  sfccur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.bf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.bf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.bf$fh'
   getlist00='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sfcanl
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sfcanl
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sfcanl
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sfcanl'
   fhbeg=00
   ;;
  pgbcur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbh$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbf$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbf$fh'
   fhbeg=00
   ;;
  pgicur) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbih$fh
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.pgrbif$fh
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.pgrbif$fh'
   fhbeg=00
   ;;
  prepqc) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.prepbufr
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.prepbufr
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.prepbufr'
   fhbeg=00
   fhend=00
   ;;
  tcvg12) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=12
   fhend=12
   ;;
  tcvges) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=06
   fhend=06
   ;;
  tcvitl) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.syndata.tcvitals.tm00'
   fhbeg=00
   fhend=00
   ;;
  icegrb) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.engicegrb
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb'
   fhbeg=00
   fhinc=06
   ;;
  icegri) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.engicegrb.index
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.engicegrb.index
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.engicegrb.index'
   fhbeg=00
   fhinc=06
   ;;
  snogrb) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_high) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574 
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_382) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t382
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t382'
   fhbeg=00
   fhinc=06
   ;;
  snogrb_574) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb_t574
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb_t574'
   fhbeg=00
   fhinc=06
   ;;
  snogri) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.snogrb.index
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.snogrb.index
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.snogrb.index'
   fhbeg=00
   fhinc=06
   ;;
  sstgrb) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sstgrb
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb'
   fhbeg=00
   fhinc=06
   ;;
  sstgri) geslist='
   $GETGES_NWG/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index
   $GETGES_COM/gfs/$envir/gdas.$day/gdas1.t${cyc}z.sstgrb.index
   $GETGES_NWG/$envir/gfs.$day/gfs.t${cyc}z.sstgrb.index
   $GETGES_COM/gfs/$envir/gfs.$day/gfs.t${cyc}z.sstgrb.index'
   fhbeg=00
   fhinc=06
   ;;
 esac

# Early nam-32 resolution
elif [[ $netwk = namopl && $resol = namopl ]];then
 fhbeg=03
 fhinc=03
 fhend=12
 case $typef in
  restrt) geslist='
   $GETGES_NWG/$envir/nam.$day/nam.t${cyc}z.restrt$fh.tm00'
   ;;
 esac
fi

# Global parallel
if [[ $envir = dump || $envir = pr? ]];then
 fhend=384
 if [[ $netwk = global ]];then
  case $typef in
   sigges) geslist='
    $GETGES_GLO/$envir/sigf$fh.gdas.$id
    $GETGES_GLO/$envir/sigf$fh.gfs.$id'
    ;;
   siggm3) geslist='
    $GETGES_GLO/$envir/sigf$fhm3.gdas.$id
    $GETGES_GLO/$envir/sigf$fhm3.gfs.$id'
    ;;
   siggm2) geslist='
    $GETGES_GLO/$envir/sigf$fhm2.gdas.$id
    $GETGES_GLO/$envir/sigf$fhm2.gfs.$id'
    ;;
   siggm1) geslist='
    $GETGES_GLO/$envir/sigf$fhm1.gdas.$id
    $GETGES_GLO/$envir/sigf$fhm1.gfs.$id'
    ;;
   siggp1) geslist='
    $GETGES_GLO/$envir/sigf$fhp1.gdas.$id
    $GETGES_GLO/$envir/sigf$fhp1.gfs.$id'
    ;;
   siggp2) geslist='
    $GETGES_GLO/$envir/sigf$fhp2.gdas.$id
    $GETGES_GLO/$envir/sigf$fhp2.gfs.$id'
    ;;
   siggp3) geslist='
    $GETGES_GLO/$envir/sigf$fhp3.gdas.$id
    $GETGES_GLO/$envir/sigf$fhp3.gfs.$id'
    ;;
   sfcges) geslist='
    $GETGES_GLO/$envir/sfcf$fh.gdas.$id
    $GETGES_GLO/$envir/sfcf$fh.gfs.$id'
    ;;
   sfcgm3) geslist='
    $GETGES_GLO/$envir/sfcf$fhm3.gdas.$id
    $GETGES_GLO/$envir/sfcf$fhm3.gfs.$id'
    ;;
   sfcgm2) geslist='
    $GETGES_GLO/$envir/sfcf$fhm2.gdas.$id
    $GETGES_GLO/$envir/sfcf$fhm2.gfs.$id'
    ;;
   sfcgm1) geslist='
    $GETGES_GLO/$envir/sfcf$fhm1.gdas.$id
    $GETGES_GLO/$envir/sfcf$fhm1.gfs.$id'
    ;;
   sfcgp1) geslist='
    $GETGES_GLO/$envir/sfcf$fhp1.gdas.$id
    $GETGES_GLO/$envir/sfcf$fhp1.gfs.$id'
    ;;
   sfcgp2) geslist='
    $GETGES_GLO/$envir/sfcf$fhp2.gdas.$id
    $GETGES_GLO/$envir/sfcf$fhp2.gfs.$id'
    ;;
   sfcgp3) geslist='
    $GETGES_GLO/$envir/sfcf$fhp3.gdas.$id
    $GETGES_GLO/$envir/sfcf$fhp3.gfs.$id'
    ;;
   biascr) geslist='
    $GETGES_GLO/$envir/biascr.gdas.$id
    $GETGES_GLO/$envir/biascr.gfs.$id'
    fhbeg=06
    fhinc=06
    ;;
   satang) geslist='
    $GETGES_GLO/$envir/satang.gdas.$id
    $GETGES_GLO/$envir/satang.gfs.$id'
    fhbeg=06
    fhinc=06
    ;;
   satcnt) geslist='
    $GETGES_GLO/$envir/satcnt.gdas.$id
    $GETGES_GLO/$envir/satcnt.gfs.$id'
    fhbeg=06
    fhinc=06
    ;;
   gesfil) geslist='
    $GETGES_GLO/$envir/gesfile.gdas.$id
    $GETGES_GLO/$envir/gesfile.gfs.$id'
    fhbeg=00
    fhend=00
    ;;
   pgbges) geslist='
    $GETGES_GLO/$envir/pgbf$fh.gdas.$id
    $GETGES_GLO/$envir/pgbf$fh.gfs.$id'
    ;;
   pgbgm6) geslist='
    $GETGES_GLO/$envir/pgbf$fhm6.gdas.$id
    $GETGES_GLO/$envir/pgbf$fhm6.gfs.$id'
    ;;
   pgbgm3) geslist='
    $GETGES_GLO/$envir/pgbf$fhm3.gdas.$id
    $GETGES_GLO/$envir/pgbf$fhm3.gfs.$id'
    ;;
   pgbgp3) geslist='
    $GETGES_GLO/$envir/pgbf$fhp3.gdas.$id
    $GETGES_GLO/$envir/pgbf$fhp3.gfs.$id'
    ;;
   sigcur) geslist='
    $GETGES_GLO/$envir/sigf$fh.gdas.$id
    $GETGES_GLO/$envir/sigf$fh.gfs.$id'
    getlist00='
    $GETGES_GLO/$envir/siganl.gdas.$id
    $GETGES_GLO/$envir/siganl.gfs.$id'
    fhbeg=00
    ;;
   sfccur) geslist='
    $GETGES_GLO/$envir/sfcf$fh.gdas.$id
    $GETGES_GLO/$envir/sfcf$fh.gfs.$id'
    getlist00='
    $GETGES_GLO/$envir/sfcanl.gdas.$id
    $GETGES_GLO/$envir/sfcanl.gfs.$id'
    fhbeg=00
    ;;
   pgbcur) geslist='
    $GETGES_GLO/$envir/pgbf$fh.gdas.$id
    $GETGES_GLO/$envir/pgbf$fh.gfs.$id'
    fhbeg=00
    ;;
   prepqc) geslist='
    $GETGES_GLO/$envir/prepqc.gdas.$id
    $GETGES_GLO/$envir/prepqc.gfs.$id'
    fhbeg=00
    fhend=00
    ;;
   tcvg12) geslist='
    $GETGES_GLO/$envir/tcvitl.gdas.$id
    $GETGES_GLO/$envir/tcvitl.gfs.$id'
    fhbeg=12
    fhend=12
    ;;
   tcvges) geslist='
    $GETGES_GLO/$envir/tcvitl.gdas.$id
    $GETGES_GLO/$envir/tcvitl.gfs.$id'
    fhbeg=06
    fhend=06
    ;;
   tcvitl) geslist='
    $GETGES_GLO/$envir/tcvitl.gdas.$id
    $GETGES_GLO/$envir/tcvitl.gfs.$id'
    fhbeg=00
    fhend=00
    ;;
   icegrb) geslist='
    $GETGES_GLO/$envir/icegrb.gdas.$id
    $GETGES_GLO/$envir/icegrb.gfs.$id'
    fhbeg=00
    fhinc=06
    ;;
   snogrb) geslist='
    $GETGES_GLO/$envir/snogrb.gdas.$id
    $GETGES_GLO/$envir/snogrb.gfs.$id'
    fhbeg=00
    fhinc=06
    ;;
   sstgrb) geslist='
    $GETGES_GLO/$envir/sstgrb.gdas.$id
    $GETGES_GLO/$envir/sstgrb.gfs.$id'
    fhbeg=00
    fhinc=06
    ;;
  esac
 else
  case $typef in
   sigges) geslist='
    $GETGES_GLO/$envir/sigf$fh.$netwk.$id'
    ;;
   siggm3) geslist='
    $GETGES_GLO/$envir/sigf$fhm3.$netwk.$id'
    ;;
   siggm2) geslist='
    $GETGES_GLO/$envir/sigf$fhm2.$netwk.$id'
    ;;
   siggm1) geslist='
    $GETGES_GLO/$envir/sigf$fhm1.$netwk.$id'
    ;;
   siggp1) geslist='
    $GETGES_GLO/$envir/sigf$fhp1.$netwk.$id'
    ;;
   siggp2) geslist='
    $GETGES_GLO/$envir/sigf$fhp2.$netwk.$id'
    ;;
   siggp3) geslist='
    $GETGES_GLO/$envir/sigf$fhp3.$netwk.$id'
    ;;
   sfcges) geslist='
    $GETGES_GLO/$envir/sfcf$fh.$netwk.$id'
    ;;
   sfcgm3) geslist='
    $GETGES_GLO/$envir/sfcf$fhm3.$netwk.$id'
    ;;
   sfcgm2) geslist='
    $GETGES_GLO/$envir/sfcf$fhm2.$netwk.$id'
    ;;
   sfcgm1) geslist='
    $GETGES_GLO/$envir/sfcf$fhm1.$netwk.$id'
    ;;
   sfcgp1) geslist='
    $GETGES_GLO/$envir/sfcf$fhp1.$netwk.$id'
    ;;
   sfcgp2) geslist='
    $GETGES_GLO/$envir/sfcf$fhp2.$netwk.$id'
    ;;
   sfcgp3) geslist='
    $GETGES_GLO/$envir/sfcf$fhp3.$netwk.$id'
    ;;
   biascr) geslist='
    $GETGES_GLO/$envir/biascr.$netwk.$id'
    fhbeg=06
    fhinc=06
    ;;
   satang) geslist='
    $GETGES_GLO/$envir/satang.$netwk.$id'
    fhbeg=06
    fhinc=06
    ;;
   satcnt) geslist='
    $GETGES_GLO/$envir/satcnt.$netwk.$id'
    fhbeg=06
    fhinc=06
    ;;
   gesfil) geslist='
    $GETGES_GLO/$envir/gesfile.$netwk.$id'
    fhbeg=00
    fhend=00
    ;;
   pgbges) geslist='
    $GETGES_GLO/$envir/pgbf$fh.$netwk.$id'
    ;;
   pgbgm6) geslist='
    $GETGES_GLO/$envir/pgbf$fhm6.$netwk.$id'
    ;;
   pgbgm3) geslist='
    $GETGES_GLO/$envir/pgbf$fhm3.$netwk.$id'
    ;;
   pgbgp3) geslist='
    $GETGES_GLO/$envir/pgbf$fhp3.$netwk.$id'
    ;;
   sigcur) geslist='
    $GETGES_GLO/$envir/sigf$fh.$netwk.$id'
    getlist00='
    $GETGES_GLO/$envir/siganl.$netwk.$id'
    fhbeg=00
    ;;
   sfccur) geslist='
    $GETGES_GLO/$envir/sfcf$fh.$netwk.$id'
    getlist00='
    $GETGES_GLO/$envir/sfcanl.$netwk.$id'
    fhbeg=00
    ;;
   pgbcur) geslist='
    $GETGES_GLO/$envir/pgbf$fh.$netwk.$id'
    fhbeg=00
    ;;
   prepqc) geslist='
    $GETGES_GLO/$envir/prepqc.$netwk.$id'
    fhbeg=00
    fhend=00
    ;;
   tcvg12) geslist='
    $GETGES_GLO/$envir/tcvitl.$netwk.$id'
    fhbeg=12
    fhend=12
    ;;
   tcvges) geslist='
    $GETGES_GLO/$envir/tcvitl.$netwk.$id'
    fhbeg=06
    fhend=06
    ;;
   tcvitl) geslist='
    $GETGES_GLO/$envir/tcvitl.$netwk.$id'
    fhbeg=00
    fhend=00
    ;;
   icegrb) geslist='
    $GETGES_GLO/$envir/icegrb.$netwk.$id'
    fhbeg=00
    fhinc=06
    ;;
   snogrb) geslist='
    $GETGES_GLO/$envir/snogrb.$netwk.$id'
    fhbeg=00
    fhinc=06
    ;;
   sstgrb) geslist='
    $GETGES_GLO/$envir/sstgrb.$netwk.$id'
    fhbeg=00
    fhinc=06
    ;;
  esac
 fi
fi

#-------------------------------------------------------------------------------
# Check validity of options.
if [[ $fhour != any ]];then
  fhbeg=$fhour
  fhend=$fhour
fi
if [[ $valid -lt 20000000 ]];then
 valid=20$valid
 echo '************************************************************' >&2
 echo '* CAUTION: A 2-digit year was converted to a 4-digit year. *' >&2
 echo '*          Please use full a 4-digit year in this utility. *' >&2
 echo '************************************************************' >&2
elif [[ $valid -lt 100000000 ]];then
 valid=19$valid
 echo '************************************************************' >&2
 echo '* CAUTION: A 2-digit year was converted to a 4-digit year. *' >&2
 echo '*          Please use full a 4-digit year in this utility. *' >&2
 echo '************************************************************' >&2
fi
if [[ $($NDATE 0 $valid 2>/dev/null) != $valid ]];then
 echo getges.sh: invalid date $valid >&2
 exit 2
fi
if [[ -z $geslist ]];then
 echo getges.sh: filetype $typef or resolution $resol not recognized >&2
 exit 2
fi

#-------------------------------------------------------------------------------
# Loop until guess is found.
fh=$fhbeg
while [[ $fh -le $fhend ]];do
 ((fhm6=10#$fh-6))
 [[ $fhm6 -lt 10 && $fhm6 -ge 0 ]]&&fhm6=0$fhm6
 ((fhm3=10#$fh-3))
 [[ $fhm3 -lt 10 && $fhm3 -ge 0 ]]&&fhm3=0$fhm3
 ((fhm2=10#$fh-2))
 [[ $fhm2 -lt 10 && $fhm2 -ge 0 ]]&&fhm2=0$fhm2
 ((fhm1=10#$fh-1))
 [[ $fhm1 -lt 10 && $fhm1 -ge 0 ]]&&fhm1=0$fhm1
 ((fhp1=10#$fh+1))
 [[ $fhp1 -lt 10 ]]&&fhp1=0$fhp1
 ((fhp2=10#$fh+2))
 [[ $fhp2 -lt 10 ]]&&fhp2=0$fhp2
 ((fhp3=10#$fh+3))
 [[ $fhp3 -lt 10 ]]&&fhp3=0$fhp3
 id=$($NDATE -$fh $valid)
 typeset -L8 day=$id
 typeset -R2 cyc=$id
 eval list=\$getlist$fh
 [[ -z $list ]]&&list=${geslist}
 for gestest in $list;do
  eval ges=$gestest
  [[ $quiet = NO ]]&&echo Checking: $ges >&2
  [[ -r $ges ]]&&break 2
 done
 fh=$((10#$fh+10#$fhinc))
 [[ $fh -lt 10 ]]&&fh=0$fh
done
if [[ $fh -gt $fhend ]];then
 echo getges.sh: unable to find $netwk.$envir.$typef.$resol.$valid >&2
 exit 8
fi

#-------------------------------------------------------------------------------
# Either copy guess to a file or write guess name to standard output.
if [[ -z "$gfile" ]];then
 echo $ges
 exit $?
else
 cp $ges $gfile
 exit $?
fi

#!/bin/bash 
set -x

export cmodel=gdas
export loopnum=1
export ymdh=${PDY}${cyc}

#export gdasdir=${COMINgdas}/${cyc}
#export gdasdir=${COMINgdas}
export COMPONENT=${COMPONENT:-atmos}
export gdasdir=${COMINgdas}/${cyc}/${COMPONENT}

export pert="p01"
pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#-----------input data checking -----------------
${USHens_tracker}/data_check_gdas.sh 
# exit code 6 = missing data of opportunity
if [ $? -eq 6 ]; then exit; fi
#------------------------------------------------

#outfile=${pertdir}/trkr.${cmodel}.${pert}.${ymdh}.out

if [[ -d /scratch2 ]] ; then
  # We are on NOAA Hera
  machine=hera
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /work ]] ; then
  # We are on MSU Orion
  machine=orion
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs4/HFIP ]] ; then
  # We are on NOAA Jet
  machine=jet
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs/h1 ]] ; then
  # We are on NOAA wcoss2
  machine=wcoss2
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /opt/spack-stack ]]; then
  # We are on NOAA wcoss2
  machine=aws-ec2
  ${USHens_tracker}/extrkr_gfs.sh ${loopnum} ${cmodel} ${ymdh} ${pert} ${pertdir} #2>&1 >${outfile}

else
  export machine=unknown
  echo Job failed: unknown platform 1>&2
  err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"

fi
export err=$?; err_chk

#!/bin/ksh
# Run under ksh

################################################################
echo "---------------------------------------------------------"
echo "exnam_makeprepbufr.sh   -   NAM model prepbufr processing"
echo "---------------------------------------------------------"
echo "History: Mar 1 2013 - Original script."
################################################################

set -x

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
postmsg "$jlogfile" "$msg"

cat break > $pgmout

CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}

export COMSP=${COMSP:-$COMIN/${RUN}.${cycle}.}
# secure turn off SYNDAT for nam
# export COMSPtcvital=${COMSPtcvital:-$COMINtcvital/${RUN}.${cycle}.}

tmhr=`echo $tmmark|cut -c3-4`
cdate10=`$NDATE -$tmhr $PDY$cyc`
cycp=`echo $cdate10|cut -c9-10`

#  Unless an overriding value for $errPREPDATA_limit is imported, the highest
#   allowed foreground exit status for program PREPOBS_PREPDATA (where any exit
#   status higher than this is considered a failure) is dependent upon the
#   center hour time in which it is running

if [ "$cycp" = '00' -o "$cycp" = '12' ]; then
   export errPREPDATA_limit=${errPREPDATA_limit:-0}
else
   export errPREPDATA_limit=${errPREPDATA_limit:-4}
fi

RUN_uc=$(echo $RUN | tr [a-z] [A-Z])
tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="$RUN_uc ANALYSIS TIME IS $PDY$cyc"
$DATA/postmsg "$jlogfile" "$msg"

msg="CENTER PREPBUFR PROCESSING TIME FOR $tmmark_uc $RUN_uc IS $cdate10"
postmsg "$jlogfile" "$msg"

ksh ${ushscript_prep}/prepobs_makeprepbufr.sh $cdate10
errsc=$?

[ "$errsc" -ne '0' ]  &&  exit $errsc

if [ "$CHGRP_RSTPROD" = 'YES' ]; then
   msg="NOTE: These files (if present) are RESTRICTED to rstprod group: \
prepbufr_pre-qc, prepbufr, prepbufr.acft_profiles*, acqc_???*, \
acqc_merged*_sorted"
   postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi
warning=no

if [ "$PREPDATA" = 'YES' ]; then

# save snapshot of prepbufr file after PREPOBS_PREPDATA in COMOUT
   cp prepda.prepdata $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc.$tmmark

   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc.$tmmark
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc.$tmmark
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc.$tmmark
         warning=yes
      fi
   fi

   if [ "$tmmark" = 'tm06' -o "$tmmark" = 'tm00' ]; then

# for tm06 or tm00 runs (only) save current prepbufr mnemonic table in
#  COMOUT if either it isn't already there for a previous cycle at tm06 or
#  tm00 or if it has changed from a previous cycle at tm06 or tm00
      if [ ! -s $COMOUT/*prep.bufrtable.$tmmark ]; then
         cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable.$tmmark
      else
         diff `ls -t  $COMOUT/*prep.bufrtable.$tmmark | head -n1` prep.bufrtable \
          > /dev/null 2>&1
         errdiff=$?
         [ "$errdiff" -ne '0' ]  &&  \
          cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable.$tmmark
      fi
   fi
fi

# save global sigma guess file valid at center PREPBUFR date/time in COMOUT if
#  it hasn't already been saved here by previous tropical cyclone relocation
#  processing (encoded into PREPBUFR file and used by q.c. programs)
if [ -s sgesprep ]; then
   if [ -s sgesprepA ]; then
      cp sgesprep  $COMOUT/${RUN}.${cycle}.sgesprep_before.$tmmark
      cp sgesprepA $COMOUT/${RUN}.${cycle}.sgesprep_after.$tmmark
   else
      [ ! -s $COMOUT/${RUN}.${cycle}.sgesprep.$tmmark ]  &&  \
       cp sgesprep $COMOUT/${RUN}.${cycle}.sgesprep.$tmmark
   fi

# save path name of this global sigma guess file in COMOUT
   if [ "$GETGUESS" = 'YES' ]; then
      if [ -s sgesprepA_pathname ]; then
         cp sgesprep_pathname  \
          $COMOUT/${RUN}.${cycle}.sgesprep_pathname_before.$tmmark
         cp sgesprepA_pathname \
          $COMOUT/${RUN}.${cycle}.sgesprep_pathname_after.$tmmark
      else

#   if the target file already exists, it was created in previous
#    tropcy_relocate.sh script because either there was an error or no
#    tcvitals were present - in this case the target file points to the orig.
#    getges global sigma guess (since the guess was not modified by relocation)
#    - otherwise sgesprep_pathname will either contain either the path to the
#      getges guess (if tropical cyclone relocation did not run previously) or
#      it will contain the path to the modified sgesprep guess (if tropical
#      cyclone relocation did run previously and did modify the guess)
#   ---------------------------------------------------------------------------

         [ ! -s $COMOUT/${RUN}.${cycle}.sgesprep_pathname.$tmmark ]  &&  \
         cp sgesprep_pathname $COMOUT/${RUN}.${cycle}.sgesprep_pathname.$tmmark
      fi
   fi
fi

# save synthetic bogus files in COMOUT
[ -s bogrept ]  &&  cp bogrept  $COMOUT/${RUN}.${cycle}.syndata.bogrept.$tmmark
[ -s bogdata ]  &&  cp bogdata  $COMOUT/${RUN}.${cycle}.syndata.bogdata.$tmmark
[ -s dthistry ] &&  cp dthistry $COMOUT/${RUN}.${cycle}.syndata.dthistry.$tmmark

if [ "$DO_QC" = 'YES' ]; then

# save final form of prepbufr file in COMOUT
   cp prepda.t${cycp}z $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
         warning=yes
      fi
   fi

# save prepacqc prepbufr.acft_profiles file in COMOUT
   if [ -s prepbufr.acft_profiles ]; then
      cp prepbufr.acft_profiles \
       $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.$tmmark
            warning=yes
         fi
      fi
   fi

# save prepacqc prepbufr.acft_profiles_sfc file in COMOUT
   if [ -s prepbufr.acft_profiles_sfc ]; then
      cp prepbufr.acft_profiles_sfc \
       $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
        chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.$tmmark
         else
            cp /dev/null \
             $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.$tmmark
            warning=yes
         fi
      fi
   fi

# save prepacqc output files in COMOUT
   if [ -s acftqc_*.sus ]; then
      mv acftqc_*.sus acftqc_sus
      cp acftqc_sus $COMOUT/${RUN}.${cycle}.acqc_sus.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_sus.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_sus.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_sus.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.stk ]; then
      mv acftqc_*.stk acftqc_stk
      cp acftqc_stk $COMOUT/${RUN}.${cycle}.acqc_stk.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_stk.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_stk.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_stk.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.spk ]; then
      mv acftqc_*.spk acftqc_spk
      cp acftqc_spk $COMOUT/${RUN}.${cycle}.acqc_spk.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_spk.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_spk.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_spk.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.ord ]; then
      mv acftqc_*.ord acftqc_ord
      cp acftqc_ord $COMOUT/${RUN}.${cycle}.acqc_ord.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_ord.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_ord.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_ord.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.lst ]; then
      mv acftqc_*.lst acftqc_lst
      cp acftqc_lst $COMOUT/${RUN}.${cycle}.acqc_lst.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_lst.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_lst.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_lst.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inv ]; then
      mv acftqc_*.inv acftqc_inv
      cp acftqc_inv $COMOUT/${RUN}.${cycle}.acqc_inv.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inv.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inv.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inv.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inc ]; then
      mv acftqc_*.inc acftqc_inc
      cp acftqc_inc $COMOUT/${RUN}.${cycle}.acqc_inc.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inc.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inc.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inc.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.grc ]; then
      mv acftqc_*.grc acftqc_grc
      cp acftqc_grc $COMOUT/${RUN}.${cycle}.acqc_grc.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_grc.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_grc.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_grc.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.dup ]; then
      mv acftqc_*.dup acftqc_dup
      cp acftqc_dup $COMOUT/${RUN}.${cycle}.acqc_dup.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_dup.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_dup.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_dup.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.log ]; then
      mv acftqc_*.log acftqc_log
      cp acftqc_log $COMOUT/${RUN}.${cycle}.acqc_log.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_log.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_log.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_log.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s merged.reports.post_acftobs_qc.sorted ]; then
      cp merged.reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.$tmmark
            warning=yes
         fi
      fi
   fi

   if [ -s merged.profile_reports.post_acftobs_qc.sorted ]; then
      cp merged.profile_reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.$tmmark
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.$tmmark
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.$tmmark
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.$tmmark
            warning=yes
         fi
      fi
   fi

# save cqcbufr output files in COMOUT
   touch cqc_events
   cp cqc_events $COMOUT/${RUN}.${cycle}.cqc_events.$tmmark
   touch cqc_stncnt
   cp cqc_stncnt $COMOUT/${RUN}.${cycle}.cqc_stncnt.$tmmark
   touch cqc_stnlst
   cp cqc_stnlst $COMOUT/${RUN}.${cycle}.cqc_stnlst.$tmmark
   touch cqc_sdm
   cp cqc_sdm $COMOUT/${RUN}.${cycle}.cqc_sdm.$tmmark
   touch cqc_radcor
   cp cqc_radcor $COMOUT/${RUN}.${cycle}.cqc_radcor.$tmmark

# save cqcvad bird algorithm q.c. info list in COMOUT
   touch cqcvad.birdqc
   cp cqcvad.birdqc  $COMOUT/${RUN}.${cycle}.cqcvad.birdqc.$tmmark

fi

if [ "$warning" = 'yes' ]; then
   msg="**WARNING: Since user $USER is not in rstprod group all RESTRICTED \
files are replaced with a null file"
   postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi

########################################################

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/bash
set -u

if [[ $MACHINE_ID = hera* ]] ; then
    # We are on NOAA Hera
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /apps/lmod/lmod/init/bash
    fi
    export LMOD_SYSTEM_DEFAULT_MODULES=contrib
    module reset

elif [[ $MACHINE_ID = ursa* ]] ; then
    # We are on NOAA Ursa
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /apps/lmod/lmod/init/bash
    fi
    module purge

elif [[ $MACHINE_ID = orion* ]] ; then
    # We are on Orion
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /apps/lmod/lmod/init/bash
    fi
    export LMOD_SYSTEM_DEFAULT_MODULES=contrib
    module reset

elif [[ $MACHINE_ID = hercules* ]] ; then
    # We are on Hercules
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /apps/other/lmod/lmod/init/bash
    fi
    export LMOD_SYSTEM_DEFAULT_MODULES=contrib
    module reset

elif [[ $MACHINE_ID = wcoss2 ]]; then
    # We are on WCOSS2
    module reset

elif [[ $MACHINE_ID = cheyenne* ]] ; then
    # We are on NCAR Cheyenne
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /glade/u/apps/ch/modulefiles/default/localinit/localinit.sh
    fi
    module purge

elif [[ $MACHINE_ID = stampede* ]] ; then
    # We are on TACC Stampede
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /opt/apps/lmod/lmod/init/bash
    fi
    module purge

elif [[ $MACHINE_ID = gaea* ]] ; then
    # We are on GAEA
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        # We cannot simply load the module command.  The GAEA
        # /etc/profile modifies a number of module-related variables
        # before loading the module command.  Without those variables,
        # the module command fails.  Hence we actually have to source
        # /etc/profile here.
        source /etc/profile
    fi
    module reset

elif [[ $MACHINE_ID = expanse* ]]; then
    # We are on SDSC Expanse
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /etc/profile.d/modules.sh
    fi
    module purge
    module load slurm/expanse/20.02.3

elif [[ $MACHINE_ID = discover* ]]; then
    # We are on NCCS discover
    export SPACK_ROOT=/discover/nobackup/mapotts1/spack
    export PATH=$PATH:$SPACK_ROOT/bin
    . $SPACK_ROOT/share/spack/setup-env.sh

elif [[ $MACHINE_ID = aws-ec2 ]] ; then
    # We are on NOAA Ursa
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        source /usr/share/lmod/lmod/init/bash
    fi
    module purge

elif [[ $MACHINE_ID == "noaacloud" ]]; then
    # We are on NOAA cloud
    module purge

else
    echo WARNING: UNKNOWN PLATFORM 1>&2
fi

#!/bin/bash
####  UNIX Script Documentation Block
#                .           .                                       .
# Script name:   combfr      Combine blocked BUFR files
#
# JIF contact:  Woollen     org: w/nmc2      date: 96-12-11
#
# Abstract: The combfr script combines (concatentes) up to thirty BUFR
#           files into one. Although the UNIX cat command will successully
#           combine byte string (-Fsystem) files, blocked files (-Fcos)
#           require special treatment, at least on the Crays. The script
#           uses the operational dump executable, combfr.x, to do the
#           combining.
#
# Script history log:
#   96-12-11  J. Woollen  original version for implementation
#
# Usage: combfr <input1> <input2> <input3> ... <inputN> <output>
#
#   Script parameters:
#     <inputn>   - list of input path/filenames to combine
#     <output>   - the BUFR output path/filename
#
#   Modules and files referenced:
#     scripts    : none
#     data cards : none
#     executables: combfr
#
# Remarks:
#
#   Note: 1) All files are assumed to have the same BUFR tables
#         2) All files to be combined must be -Fcos format"
#
#   Condition codes:
#     00 - no problem encountered
#     99 - parameter problem
#
# Attributes:
#
#   Language: UNICOS script
#   Machine:  CRAY
#
####
 
if [ $# -lt 2 ]
then
echo
echo "combfr will concatenate BUFR files"
echo
echo "Usage: combfr <input1> <input2> <input3> ... <inputN> <output>"
echo
echo "Note: 1) All files are assumed to have the same BUFR tables"
echo
exit 99
fi
 
COMX=$EXECcfs/cfs_combfr.x
COMI=combfr.in; >$COMI
 
while [ $# -gt 1 ] ; do
 echo $1 >> $COMI
 shift
done
 
ln -sf $1 fort.50; cat $COMI|$COMX
export err=$; err_chk
rm -f $COMI fort.50

#!/bin/bash
set -x

export cmodel=gfs
#export loopnum=1
#export ymdh=${PDY}${cyc}
#export gfsdir=${COMINgfs}/${cyc}
#export gfsdir=${COMINgfs}
export COMPONENT=${COMPONENT:-atmos}
#export gfsdir=${COMINgfs}/${cyc}/${COMPONENT}
export gfsdir=${gfsdir:-${COMINgfs}/${cyc}/${COMPONENT}}

#-----------input data checking -----------------
${USHens_tracker}/data_check_gfs.sh
# exit code 6 = missing data of opportunity
if [ $? -eq 6 ]; then exit; fi
#------------------------------------------------


#export cmodel=gfs
export loopnum=1
export ymdh=${PDY}${cyc}

#export gfsdir=${COMINgfs}/${cyc}

#---- first run to get GFS genesis vital at time=00 06 12 18Z -----------

#export trkrtype=tcgen
#export trkrebd=350.0
#export trkrwbd=105.0
#export trkrnbd=30.0
#export trkrsbd=5.0
#export mslpthresh=0.0015
#export v850thresh=1.5000
export regtype=altg

export pert=p01
export pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#outfile=${pertdir}/trkr.${regtype}.${cmodel}.${pert}.${ymdh}.out

if [[ -d /scratch3 ]] ; then
  # We are on NOAA Hera or Ursa
  machine=ursa
  ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /work ]] ; then
  # We are on MSU Orion or Hercules
  machine=orion
  ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs4/HFIP ]] ; then
  # We are on NOAA Jet
  machine=jet
  ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs/h1 ]] ; then
  # We are on NOAA wcoss2
  machine=wcoss2
  ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /gpfs/f6 ]] ; then
  # We are on NOAA gaeac6
  machine=gaeac6
  ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /opt/spack-stack ]] ; then
  # We are on AWS-EC2
  machine=aws-ec2
  ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ ! -z "${PW_CSP:+x}" ]]; then
   case "${PW_CSP}" in
      "aws" | "google" | "azure")
        # We are on NOAA cloud
	machine=noaacloud
        ${USHens_tracker}/extrkr_tcv_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}
	;;
      *)
        echo Job failed: unknown platform 1>&2
        err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"
        ;;
   esac

else
  export machine=unknown
  echo Job failed: unknown platform 1>&2
  err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"
fi
export err=$?; err_chk

#### NCEP/GFS genesis tcvitals  ###########################
num_gen_vits=`cat ${COMINgenvit}/genesis.vitals.gfs.gfso.${JYYYY} | wc -l`
if [ ${num_gen_vits} -gt 0 ]
then
  . prep_step

  # Input file
  export FORT41=${COMINgenvit}/genesis.vitals.gfs.gfso.${JYYYY}

  # Output files
  export FORT42=gen_tc.vitals.gfs.gfso.${JYYYY}

  ${EXECens_tracker}/tcvital_ch_gfs
  export err=$?; err_chk

  cat $FORT42 >> ${COMOUTgenvit}/all.vitals.gfs.gfso.${JYYYY}
else
  touch ${COMOUTgenvit}/all.vitals.gfs.gfso.${JYYYY}
fi

#---- second run genesis ---------------------------------------
#exit
rm -rf ${DATA}/*
export pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#outfile=${pertdir}/trkr.${regtype}.${cmodel}.${pert}.${ymdh}.out

if [[ -d /scratch3 ]] ; then
  # We are on NOAA Hera or Ursa
  machine=ursa
  ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /work ]] ; then
  # We are on MSU Orion or Hercules
  machine=orion
  ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs4/HFIP ]] ; then
  # We are on NOAA Jet
  machine=jet
  ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /lfs/h1 ]] ; then
  # We are on NOAA wcoss2
  machine=wcoss2
  ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}  

elif [[ -d /gpfs/f6 ]] ; then
  # We are on NOAA gaeac6
  machine=gaeac6
  ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ -d /opt/spack-stack ]] ; then
  # We are on AWS EC2
  machine=aws-ec2
  ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}

elif [[ ! -z "${PW_CSP:+x}" ]]; then
   case "${PW_CSP}" in
      "aws" | "google" | "azure")
        # We are on NOAA cloud
        machine=noaacloud
        ${USHens_tracker}/extrkr_gen_gfs.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}
	;;
      *)
        echo Job failed: unknown platform 1>&2
        err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"
        ;;
   esac

else
  export machine=unknown
  echo Job failed: unknown platform 1>&2
  err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"
fi
export err=$?; err_chk

export atcfout=gfso
export TRKDATA=${DATA}/${cmodel}/${pert}
${USHens_tracker}/sort_tracks.gen.sh  >${TRKDATA}/sort.${regtype}.${atcfout}.${ymdh}.out
export err=$?; err_chk

#cp ${pertdir}/trak.gfso.atcfunix.altg.${ymdh} ${COMOUT}/
#cp ${pertdir}/storms.gfso.atcf_gen.altg.${ymdh}  ${COMOUT}/

#### filtering weak storms for TC genesis #####
. prep_step

# Input file
export FORT41=storms.gfso.atcf_gen.altg.${ymdh}
cpreq ${COMOUT}/$FORT41 .

# Output files
export FORT42=storms.gfso.atcf_gen.${ymdh}
export FORT43=trak.gfso.atcfunix.${ymdh}

${EXECens_tracker}/filter_gen_gfs
export err=$?; err_chk

if [ "$SENDCOM" = YES ]; then
  cp $FORT42 $FORT43 ${COMOUT}/
  if [ $? -ne 0 ]; then
    echo "WARNING: Filtering did not produce any files... perhaps there were no storms to begin with."
  fi
fi

#!/bin/ksh
#    mstr_shp_stn_lst_update2.sh
#
#    This script updates the "Master Ship Station List" file
#     and the (modified) NDBC active ship list file and copies
#     them both into the archive so they will be ready for
#     tomorrow's run
#
# History
#      Steve Lilly 02/01/2016   -  Original script
#      Dennis Keyser 02/12/2016 -  Modifications to put into production
#
#

set -xa

 cd $DATA


#  initializing
#  ------------

 cat ship_names2 > ship_names
 cat activeShiprev2 > activeShiprev
 cat actships3 > unqiships
 ick="0"


#  checking for ships which have been renamed
#
#  prints duplicate lines once, but no unique lines
#  ------------------------------------------------

cut -c 1-9 unqiships4 | uniq -d | cat > cklst


#  ckcnt provides a count of ships that are renamed
#    if ckcnt = 0, there are no ships that have been renamed
#    if ckcnt > 0, there are ships that have been renamed
#  ---------------------------------------------------------

ckcnt=`wc -l < cklst` 


#  remove the old ship names from previous (modified) NDBC active ship list
#   file and from previous (modified) "Master Ship Station List" file
#
#  this allows the new ship names to be added to the above files 
#  --------------------------------------------------------------------------

if [ $ckcnt -gt 0 ];then
  grep -v -f cklst ship_names2 | cat > ship_names
  grep -v -f cklst activeShiprev2 | cat > activeShiprev


#  repeating the process to generate a list of ship names {found in previous
#   (modified) NDBC active ship list file and in previous (modified) "Master
#   Ship Station List" file} which are renamed 
#  -------------------------------------------------------------------------

  cat actshplst > actships3
  cat activeShiprev >> actships3
  sort -d actships3 | uniq -u | cat > unqiships
  ick="1"
fi

cut -c 1-65 activeShiprev | cut -c 1-9,15-72 | cat > actshiplst
cut -c 1-65 ship_names | cut -c 1-10,11-60 | cat > shipnames


#  $ick determines how the file "unqiships" needs to be cut
#  --------------------------------------------------------

#####echo $ick

if [ $ick -eq 0 ]; then
  set +x
  echo
  echo "ick=0, there are no ships that have been renamed -> unqiships (plus \
ancillary data) copied to unqiships2"
  echo
  set -x
  cut -c 1-65 unqiships | cut -c 1-10,11-72 | cat > unqiships2
else
  set +x
  echo
  echo "ick=1, there are ships that have been renamed -> unqiships (minus \
ancillary data) copied to unqiships2"
  echo
  set -x
  cut -c 1-65 unqiships | cut -c 1-9,15-72 | cat > unqiships2
fi

cat actshiplst > actship1
cat shipnames >> actship1

#  complete ship reports with any duplicates removed in actship1 written to
#   shipnmnew
#  ------------------------------------------------------------------------

sort -d actship1 | sort -u | cat > shipnmnew

cat unqiships2 > actship2
cat shipnmnew >> actship2


#  compare the size of the previous (modified) NDBC active ship list file to
#   the size of the current NDBC active ship list file to determine if ships
#   need to be added to or deleted from the "Master Ship Station List"
#  -------------------------------------------------------------------------

ncolst=`wc -l < activeShiprev2`
ndbclst=`wc -l < actshplst`

#####echo $ncolst
#####echo $ndbclst

if [ $ncolst -gt $ndbclst ]; then

#  ships are to be removed(/renamed) from the "Master Ship Station List"
#  unique complete ship reports in actship2 written to shipnmnew
#   (replacing existing file)
#  ---------------------------------------------------------------------

  set +x
  echo
  echo "ships are to be removed(/renamed) from the \"Master Ship Station List\""
  echo
  set -x
  sort -d actship2 | uniq -u | cat > shipnmnew
fi
 
if [ $ncolst -le $ndbclst ]; then

#  ships are to be added(/renamed) to the "Master Ship Station List"
#  complete ship reports with any duplicates removed in actship2 are
#   written to shipnmnew (replacing existing file)
#  -----------------------------------------------------------------

  set +x
  echo
  echo "ships are to be added(/renamed) to the \"Master Ship Station List\""
  echo
  set -x
  sort -d actship2 | sort -u | cat > shipnmnew
fi


#  test to determine if the number of ships in the just updated "Master Ship
#   Station List" file is greater than the limit of 90,000 set in the program
#   "marine_stats_newstats" which reads this file on the first day of each
#   month (in JRW1)
#  --------------------------------------------------------------------------

inshipcnt=`wc -l < shipnmnew`

if [ $inshipcnt -gt 90000 ]; then

  msg="**WARNING: >90K ships in updated \"Master Ship Station List\" file - \
this file and (modified) NDBC active ship list file cannot be updated in \
$VOSarch_OUT"
  msg1="**WARNING (cont.): The current NDBC active ship list file \
$SHPNAMDIR_DCOM/activeShipLst has too many reports or is corrupted"
  $DATA/postmsg "$jlogfile" "$msg"
  $DATA/postmsg "$jlogfile" "$msg1"
  set +x
  echo
  echo "$msg"
  echo
  echo "$msg1"
  echo
  set -x

  exit
fi


#  copy the updated "Master Ship Station List" and (modified) NDBC active ship
#   list files into the archive
#  ---------------------------------------------------------------------------

cp shipnmnew $VOSarch_OUT/ship_names
errcp=$?
if [ $errcp -eq 0 ]; then
  msg="UPDATED \"MASTER SHIP STATION LIST\" SUCCESSFULLY COPIED TO \
$VOSarch_OUT/ship_names"
else
  msg="**WARNING: ERROR COPYING UPDATED \"MASTER SHIP STATION LIST\" TO \
$VOSarch_OUT/ship_names"
fi
$DATA/postmsg "$jlogfile" "$msg"
set +x
echo
echo "$msg"
echo
set -x

cp actshplst $VOSarch_OUT/activeShiprev
errcp=$?
if [ $errcp -eq 0 ]; then
  msg="MODIFIED NCDC ACTIVE SHIP LIST SUCCESSFULLY COPIED TO \
$VOSarch_OUT/activeShiprev"
else
  msg="**WARNING: ERROR COPYING MODIFIED NCDC ACTIVE SHIP LIST TO \
$VOSarch_OUT/activeShiprev"
fi
$DATA/postmsg "$jlogfile" "$msg"
set +x
echo
echo "$msg"
echo
set -x

exit

#!/bin/ksh
# bufr_remorest.sh
# 
# modificaton history
#  13 Mar 2013 SMelchior - ported to WCOSS (linux) platforms:
#                - cp'd CCS ver of 5 Jan 2009
#                - updated logical unit links (rm'd XLF*)
#                - replaced "timex" w/ "time -p"
#  15 Mar 2013 JWhiting - set to run under ksh;
#                         added modification history documentation
#  09 Mar 2017 DStokes -  Changed exit values of 555 (which is out of the
#                         acceptable range) to 55 to ensure that the parent
#                         script sees the intended value.
#-----
#
# This ush script either removes reports that are restricted from
#  resdistribution, or masks the id of reports that are restricted from
#  resdistribution prior to writing out updated BUFR file (normally either
#  PREPBUFR or data dump files).
#
# It is normally executed by either the model script exprep_post.sh.sms (for
#  PREPBUFR files) or exdump_post.sh.sms (for BUFR data dump files) but it
#  can also be executed from a checkout parent script.
# --------------------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input file (which normally contains both restricted
#       and unrestricted reports --> becomes output BUFR file upon
#       successful completion of this script (note that input BUFR file is
#       NOT saved by this script)

# Imported variables that must be passed in:
#   DATA - path to working directory
#   REMX - path to BUFR_REMOREST program executable
#   REMC - path to BUFR_REMOREST program parm cards

cd $DATA
PRPI=$1
if [ ! -f $PRPI ] ; then exit 1 ;fi
if [ ! -s $PRPI ] ; then exit 0 ;fi

[ -f $PRPI.unrestricted ] && rm $PRPI.unrestricted

pgm=`basename  $REMX`
if [ -s prep_step ]; then
   set +u
   . prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   export FORT01=0
   unset `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

echo $PRPI > filename
export FORT11=filename
export FORT21=$PRPI
export FORT51=$PRPI.unrestricted
time -p $REMX< $REMC > outout 2> errfile
err=$?
##cat errfile
cat errfile >> outout
cat outout >> remorest.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for BUFR_REMOREST is ' $err
echo
set -x
if [ -s err_chk ]; then
   err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid}
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.unrestricted $PRPI
fi

exit 0

#!/bin/ksh
export PS4=' + extrkr_fsu.sh line $LINENO: '

set +x
##############################################################################
echo " "
echo "------------------------------------------------"
echo "         TC genesis Tracking from FSU         "
echo "                Models:GFS       "
echo "------------J.Peng DEC.11, 2019 ----------------"
echo "Current time is: `date`"
echo " "
##############################################################################
set -x

cmodel=$1
ymdh=$2
TRKDATA=$3
gfsdir=$4

msg="has begun for ${cmodel} at ${ymdh}z"
postmsg "$jlogfile" "$msg"

#cp $HOMEens_tracker/tclogg/genesis_guidance/model_config.cfg_bak $TRKDATA/model_config.cfg
#  creating $TRKDATA/model_config.cfg
#----------------------------------------------------
#[gfs]
#fname_template = /gpfs/dell1/nco/ops/com/gfs/prod/gfs.{date:%Y%m%d}/{date:%H}/gfs.t{date:%H}z.pgrb2.0p25.f{fhr:03}
# min_fhr = 0
# max_fhr = 120
# delta_fhr = 6
#---------------------------------------------------
cd $TRKDATA
#namelist=${TRKDATA}/model_config.cfg
#echo "[${cmodel}]"       >${namelist}
#echo "fname_template = ${gfsdir}/gfs.{date:%Y%m%d}/{date:%H}/gfs.t{date:%H}z.pgrb2.0p25.f{fhr:03}"          >>${namelist}

#unlink $HOMEens_tracker/tclogg/genesis_guidance/model_config.cfg
#ln -sf ${namelist} $HOMEens_tracker/tclogg/genesis_guidance/model_config.cfg

#export file_name=${gfsdir}/gfs.{date:%Y%m%d}/{date:%H}/gfs.t{date:%H}z.pgrb2.0p25.f{fhr:03}
export COMPONENT=${COMPONENT:-atmos}
export file_name=${gfsdir}/gfs.{date:%Y%m%d}/{date:%H}/${COMPONENT}/gfs.t{date:%H}z.pgrb2.0p25.f{fhr:03}
${BINens_tracker}/tclogg_track --date ${ymdh} --odir $TRKDATA --fname_template=${file_name}

#if [ "$SENDCOM" = 'YES' ]; then
#  cp -r ${TRKDATA}/tracker ${COMOUT}/.
#fi

  BEGIN {
  min = 1000000
  max = -1
    }
  {
  s += $1
  if ($1 <= min) min = $1
  if ($1 >= max) max = $1 
  }
#END { print FILENAME,"(",var,")","average=",s/NR,"min=", min, "max=", max  }
END { print var,"=",int(s/NR + 0.5) }

#!/bin/sh
#------------------------------------------------------------------------------
#
#  gdas_countstat.sh                         
#
#
#  This script collects gdas observational data counts from Dennis Keysers
#  status count files.
#
#  Usage: gdas_countstat.sh<start_date> <network> <num days> <hour> <month> [run]
#
#  History
#  L. Sager  09/07  Modified script to work properly in operations.
#  C. Magee  12/08  Modified script to remove REPROCESSED references.
#  D. Stokes 04/2015  Moved to vertical structure package obsproc_prep_post 
#                     and updated variables pointing to other software
#                     included in this migration.  Made additional minor 
#                     changes to reduce unnecessary warnings.
#  D. Keyser 05/2015  Split imported script variable $DATCOM into separate
#                     input and output variables $DATCOMIN (root to
#                     $DATCOMIN_dir) and $DATCOMOUT_dir set in parent Job
#                     Script.
#                     BENEFIT: Allows checkout runs to specify a production
#                              input location and a local output location.
#  D. Stokes 03/2017  Modified report count parsing in preparation for future
#                     field width increase in dump status files.  Removed
#                     unnecessary commands and rearranged some logic to improve
#                     performance on Cray-XC40.  Replaced hardwired filename 
#                     prefix "gdas1" with new variable "$run" in preparation for
#                     gdas filename change (gdas1->gdas).  Added optional 6th
#                     argument to pass in a value for $run (to aid generation of 
#                     statistics in delayed mode).
#
#------------------------------------------------------------------------------

set -x 

start=$1
net=$2
numdays=$3
hour=$4
CYCLE=t${hour}z
month=$5
run=${6:-${RUN:-gdas}}

num=`expr $numdays - 1 `
set +x; echo -e "\n---> path to finddate.sh below is: `which finddate.sh`"; set -x
string=`finddate.sh $start s+$num`
#echo "num=$num"
#echo "string=$string"

daystring="$start ""$string"
#echo $daystring 
echo "&DATA" > ${net}_${month}_dumpstats.$CYCLE
  type0="000.001 000.007"
  type1="001.001 001.002 001.003 001.004 001.005 001.006"
  type2="002.001 002.002 002.003 002.004 002.005 002.007 002.009 002.008"
  type3="003.001 003.104"
  type4="004.001 004.002 004.003 004.004 004.005"
  type5="005.010 005.012 005.013 005.041 005.042 005.043 005.064" 
  type8="008.010"
  type12="012.001 012.002 012.013 TMI 012.103 012.137 REPROCESSED"
  type21="021.021 021.022 021.023 021.024 021.025 021.041"
  type99="COMBINED"
  types="$type0 $type1 $type2 $type3 $type4 $type5 $type8 $type12 $type21 $type99"

  for type in $types
  do
      rm -f $type
  done

  for day in $daystring
  do
      echo -e "\n     DAY = $day"
      file=$DATCOMIN_dir/$run.$CYCLE.status.tm00.bufr_d.$day
#     echo file is $file
      if test -f $file
      then
        TF=$run.$CYCLE.status.tm00.bufr_d.$day.trimmed.$$
        grep -v Domain $file > $TF
        for type in $types
        do
            if test $type = '012.137'
            then
#             num=`grep $type $TF | grep -vi Global | grep qkscat | cut -c65-71`
              num=$(grep $type $TF | grep qkscat | sed -ne 's/.* HAS\( *\)\([0-9]\+\) REPORTS\( *\)$/\2/p')
#             echo num=$num
            elif test $type = 'REPROCESSED'
            then
              num=`grep 'REPROCESSED QUIKSCAT' $TF | awk '{ print $11 }'`
            elif test $type = 'COMBINED'
            then
              num=`grep 'COMBINED TOTAL' $TF | awk '{ print $9 }'`
            elif test $type = 'TMI'
            then
              num=`grep $type $TF | awk '{ print $12 } '`
            else
#             num=`grep $type $TF | grep -vi Global | cut -c65-71`
              num=$(grep $type $TF | sed -ne 's/.* HAS\( *\)\([0-9]\+\) REPORTS\( *\)$/\2/p')
            fi
            if test -n "$num";then
              if test $num -ge 0
              then
                echo $num >> $type
              fi
            fi
        done
      echo "Processing complete for $day"
      else
        echo "$file does not exist.  No processing for day $day"
      fi
  done

  for type in $types
  do
        if test -s $type
        then 
          echo "get stats for $type"
          mnemonic=`grep $type $FIXprepobs/gdascounts_types | awk '{print $2}'`
          awk -f $FIXprepobs/gdascounts_avg.awk $type var=$mnemonic >> ${net}_${month}_dumpstats.$CYCLE
        else
          echo $type is not dumped for $net
        fi
  done

mkdir $DATA/${MON}
sed -e 's/ = /=/g' ${net}_${month}_dumpstats.$CYCLE > tmps                                             
echo "/" >>tmps

cp  tmps  $DATA/${net}_${month}_dumpstats.$CYCLE

exit

#!/bin/bash
###########################################################################
echo "--------------------------------------------------------------------"
echo "exmods.sh  - MODSBUFR data dump processing                       "
echo "--------------------------------------------------------------------"
echo "History: May  7 2004 - Original script.                             "
echo "         May 25 2004 - run day-10 daily tank only, exit if missing. "
echo "         Mar  6 2012 - parameterized DCOMROOT & TANK env vars.      "
echo "         Feb 26 2019 - set for use on WCOSS phase 3 (Dell) platforms"
echo "         Dec 15 2021 - set for use on WCOSS2                        "
echo "--------------------------------------------------------------------"
###########################################################################

set -x

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
postmsg "$jlogfile" "$msg"


# Run for day today-9 only (oldest daily tank)
# exit if tank does not exist

set +x; echo -e "\n---> path to finddate.sh below is: `which finddate.sh`"; set -x
PDYm9=$(finddate.sh $PDY d-9)


# -- set default TANK env var (location of source data tanks for dumpjb)
export TANK=${TANK:-"$DCOMROOT/$dfix"}

if [ ! -d $TANK/$PDYm9 ] ; then 
  echo "exmods: tank dir not found - $PDYm9"
  set +x
  echo " "
  echo " ###################################################### "
  echo " --> SOURCE TANK $TANK/$PDYm9 NOT FOUND "
  echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
  echo " ###################################################### "
  echo " "
  set -x
  err_exit
  exit 9
fi # source tank exists

cat break > $pgmout

msg="DUMP DATE IS $PDYm9"
postmsg "$jlogfile" "$msg"

echo ; echo "exmods: calling $USHmods/bufr_prepmods.sh $PDYm9" ; echo 
$USHmods/bufr_prepmods.sh $PDYm9
err_prepmods=$?

# save standard output
cat  break $pgmout break > allout
cat allout
# rm allout

# GOOD RUN
if [[ $err_prepmods -eq 0 ]] ; then 
  set +x
  echo " "
  echo " ****** PROCESSING COMPLETED NORMALLY"
  echo " "
  set -x

  sleep 10

  msg='ENDED NORMALLY.'
  postmsg "$jlogfile" "$msg"

# BAD RUN
else # prepmods error return

  set +x ; echo " "
  echo " ****** ERROR in bufr_prepmods - rc='$err_prepmods'"
  echo " " ; set -x
  $DATA/err_exit

fi # prepmods error return

exit
################## END OF SCRIPT #######################

#!/bin/bash

set -eu

# Get the root of the cloned GFS-utils directory
readonly DIR_ROOT=$(cd "$(dirname "$(readlink -f -n "${BASH_SOURCE[0]}" )" )/.." && pwd -P)

# User Options
BUILD_TYPE=${BUILD_TYPE:-"Release"}
CMAKE_OPTS=${CMAKE_OPTS:-}
COMPILER=${COMPILER:-"intel"}
BUILD_DIR=${BUILD_DIR:-"${DIR_ROOT}/build"}
INSTALL_PREFIX=${INSTALL_PREFIX:-"${DIR_ROOT}/install"}
MODULEFILE_INSTALL_PREFIX=${MODULEFILE_INSTALL_PREFIX:-"${INSTALL_PREFIX}/modulefiles"}

#==============================================================================#

# Detect machine (sets MACHINE_ID)
source ${DIR_ROOT}/ush/detect_machine.sh

# Load modules
source ${DIR_ROOT}/ush/module-setup.sh
source ${DIR_ROOT}/versions/spack.ver
source ${DIR_ROOT}/versions/${MACHINE_ID}.ver
module use ${DIR_ROOT}/modulefiles
module load fit2obs_${MACHINE_ID}
module list

# Collect BUILD Options
CMAKE_OPTS+=" -DCMAKE_BUILD_TYPE=$BUILD_TYPE"

# Install destination for built executables, libraries, CMake Package config
CMAKE_OPTS+=" -DCMAKE_INSTALL_PREFIX=$INSTALL_PREFIX -DCMAKE_INSTALL_BINDIR=exec"
# Install destination for package modulefile
CMAKE_OPTS+=" -DMODULEFILE_INSTALL_PREFIX=$MODULEFILE_INSTALL_PREFIX"

# Re-use or create a new BUILD_DIR (Default: create new BUILD_DIR)
[[ ${BUILD_CLEAN:-"YES"} =~ [yYtT] ]] && rm -rf $BUILD_DIR
mkdir -p $BUILD_DIR && cd $BUILD_DIR

# Configure, build, install
set -x
cmake $CMAKE_OPTS $DIR_ROOT
make -j ${BUILD_JOBS:-8} VERBOSE=${BUILD_VERBOSE:-}
make install
set +x

[[ ${BUILD_LEGACY:-} =~ [yYtT] ]] || exit 0

# Move executables from INSTALL_PREFIX to DIR_ROOT/exec as is legacy
echo "Performing a legacy build where executables are placed alongside cloned source"
mkdir -p $DIR_ROOT/exec
cp -f $INSTALL_PREFIX/exec/* $DIR_ROOT/exec/
rm -rf $INSTALL_PREFIX

exit

#!/bin/bash
#####################################################################
echo "----------------------------------------------------------    "
echo "exrtma_dump.sh - RTMA model data dump processing              "
echo "----------------------------------------------------------    "
echo "History:                                                      "
echo " May 19 2006 - Original script.                               "
echo " Sep 10 2014 - Use parallel scripting to process dump groups. "
echo " Feb  3 2015 - Dump new satwnd types NC005019, NC005080,      "
echo "                NC005090. Dump new type efclam.               "
echo " Jul  2 2017 - enabled potential for minute-precison cycles   "
echo " Jun 29 2018 - removed efclam dumps in rtma_ru runs           "
echo " May 23 2019 - Updated to run on Dell-p3. Disabled background "
echo "                threading.                                    "
echo " Oct 22 2019 - Temporary bug fix to limit adpsfc processing to"
echo "                previous day's tank for rtma_ru 0000z cylce.  "
echo " Feb 13 2020 - enabled efclam dumps in rtma_ru runs           "
echo "             - disabled (SKIP) NC005090, NC005091 (VIIRS AMVs)"
echo " Sep 14 2020 - Updated Dump group #1 to skip legacy           "
echo "                Meteosat AMV subsets: 005064, 005065,         "
echo "                006066.  These subsets are replaced by        "
echo "                new WMO BUFR sequence subsets: 005067,        "
echo "                005068, 005069. The format change from        "
echo "                EUMETSAT occurs Oct 6, 2020.                  "
echo " Mar 09 2021 - Incremented subsets for the sfcshp dump groups "
echo "                to match bufr_dumplist. Removed tideg from    "
echo "                sfcshp dump group to make unique dump file.   "
echo "             - Copy bufr_dumplist to COMOUT.                  "
echo " Dec 15 2021 - set for use on WCOSS2.                         "
echo " Jul 31 2022 - Subpfl,saldrn,snocvr & gmi1cr dump group added "
echo " Oct 12 2023 - Split msonet to msonet and msone1, where       "
echo "                msone1=255.030; concatenate msonet and msone1 "
echo "                right after dump. Seperated satwnd to its own "
echo "                dump group.                                   "
#####################################################################

set -x

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
postmsg "$jlogfile" "$msg"
 
cat break > $pgmout

# Imported variable cycM, if it exists, contains cycle time minutes
#  If cycM is imported, set dumptime w/ fractional hour based on value of cycM,
#   and reset cycle to 4-digit value t<HHMM>z

hr_fraction=""
if [ -n "$cycM" ]; then
  case "$cycM" in 
    00) hr_fraction='.00' ;;
    15) hr_fraction='.25' ;;
    30) hr_fraction='.50' ;;
    45) hr_fraction='.75' ;;
     *) err_xd=9 
        msg="###FATAL ERROR in model script: incorrect cycM='${cycM}' - exiting"
        echo "$msg"
        postmsg "$jlogfile" "$msg"
        exit $err_xd ;;
  esac
  cycle=t${cyc}${cycM}z
fi

export dumptime=`cut -c7-16 ncepdate`$hr_fraction

tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="RTMA ANALYSIS TIME IS $PDY$cyc"
[ -n "$cycM" ]  &&  msg="$msg:${cycM}"
postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR $tmmark_uc RTMA IS $dumptime"
echo
set -x
 
export COMSP=$COMOUT/$RUN.${cycle}.
 
err1=0
err2=0
err3=0
err4=0
err5=0


#restrict processing of unexpected big tanks
#this block appear in all /scripts/ex*_dump.sh proessing msonet and msone1 
TANK_MAX_255003=${TANK_MAX_255003:-3221225472} #3Gb
TANK_MAX_255004=${TANK_MAX_255004:-1610612736} #1.5Gb
TANK_MAX_255030=${TANK_MAX_255030:-4187593114} #3.9Gb
if [ -s ${TANK}/${PDY}/b255/xx003 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx003)" -gt "$TANK_MAX_255003" ]; then
 export SKIP_255003=YES
 msg="WARNING: TANK b255/xx003 exceeds TANK_MAX_255003 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
if [ -s ${TANK}/${PDY}/b255/xx004 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx004)" -gt "$TANK_MAX_255004" ]; then
 export SKIP_255004=YES
 msg="WARNING: TANK b255/xx004 exceeds TANK_MAX_255004 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
 fi
if [ -s ${TANK}/${PDY}/b255/xx030 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx030)" -gt "$TANK_MAX_255030" ]; then
 export SKIP_255030=YES
 msg="WARNING: TANK b255/xx030 exceeds TANK_MAX_255030 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
#end of block

if [ "$PROCESS_DUMP" = 'YES' ]; then

###################################
###################################
#  The data "dump" script for tm00
###################################
###################################

msg="START THE $tmmark_uc RTMA DATA DUMP CENTERED ON $dumptime"
postmsg "$jlogfile" "$msg"

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=1

#========================================================================
# Dump # 1 : ASCATT, EFCLAM, SNOCVR, GMI1CR --
#              (1)    (1)     (1)     (1)
#                                  TOTAL NUMB OF SUBTYPES = 14
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of -6.00 to 0.00 hours)
#
#     * VIIRS NPP/NOAA-20 IR lg-wave cld motion data disabled (GSI only
#     monitors nc005090 and does not support nc005091).
#
#            time window radius is -6.00 to 0.00 hours for ASCATT
#            time window radius is +/- 0.5 hours for EFCLAM
#=======================================================================

DTIM_earliest_ascatt=-6.00
DTIM_latest_ascatt=0.00

DTIM_earliest_efclam=-0.50
DTIM_latest_efclam=+0.50

DTIM_earliest_snocvr=${DTIM_earliest_snocvr:-"-2.00"}
DTIM_latest_snocvr=${DTIM_latest_snocvr:-"+2.00"}
#DTIM_earliest_snocvr=-1.50
#DTIM_latest_snocvr=+1.49

DTIM_earliest_gmi1cr=-1.50
DTIM_latest_gmi1cr=+1.49

$ushscript_dump/bufr_dump_obs.sh $dumptime 2.5 1 ascatt efclam snocvr gmi1cr
error1=$?
echo "$error1" > $DATA/error1

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_2; chmod +x thread_2
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_2
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=2

#========================================================================
# Dump # 2 : SFCSHP, ADPSFC, TIDEG, SUBPFL, SALDRN
#              (11)     (6)   (1)   (1)     (1)
#            -- TOTAL NUMBER OF SUBTYPES = 20
#            time window radius is +/- 0.50 hours for SFCSHP and ADPSFC
#=======================================================================

# Skip mobile synoptic reports in ADPSFC (not in domain)

export SKIP_000002=YES

DTIM_earliest_subpfl=-0.50
DTIM_latest_subpfl=+0.50
DTIM_earliest_saldrn=-0.50
DTIM_latest_saldrn=+0.50

# for rtma_ru_0000 read only from previous day's tank
# Temporary bug fix
if [ $RUN = "rtma_ru" -a $cycle = "t0000z" ]; then
  DTIM_latest_000000=-0.01
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 sfcshp tideg adpsfc subpfl saldrn
error2=$?
echo "$error2" > $DATA/error2

set +x
echo "********************************************************************"
echo Script thread_2
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/2.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_3; chmod +x thread_3
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_3
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=3

#===========================================================================
# Dump # 3 : MSONET -- TOTAL NUMBER OF SUBTYPES = 30
#            time window radius is 0.50 hours
#===========================================================================

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 msonet
error3=$?
echo "$error3" > $DATA/error3

set +x
echo "********************************************************************"
echo Script thread_3
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/3.out 2>&1
EOF
set -x


set +x
#----------------------------------------------------------------
cat<<\EOF>thread_4; chmod +x thread_4
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_4
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=4

#===========================================================================
# Dump # 4 : SATWND -- TOTAL NUMBER OF SUBTYPES = 14
#            for SATWND subtypes 005/010, 005/011, 005/012 and 005/019 at all
#            times:
#              time window radius is -1.00 to -0.01 hours
#            for SATWND subtypes 005/064, 005/065, 005/066, 005/067, 005/068
#            and 005/069 at all times:
#              time window radius is -1.50 to +1.49 hours
#            for all other SATWND subtypes:
#              time window radius is +/- 2.5 hours
#===========================================================================

# Skip all Indian satellite winds in SATWND (not in domain)
export SKIP_005021=YES
export SKIP_005022=YES
export SKIP_005023=YES

# Skip legacy EUMETSAT AMV subsets; for testing skip in trigger or version file
#export SKIP_005064=YES
#export SKIP_005065=YES
#export SKIP_005066=YES

# Skip VIIRS NPP/NOAA-20 IR long wave derived cld motion
export SKIP_005090=YES        # old sequence (discontinued)
export SKIP_005091=YES        # new sequence (unsupported in GSI)

DTIM_earliest_005010=-1.00
DTIM_latest_005010=-0.01
DTIM_earliest_005011=-1.00
DTIM_latest_005011=-0.01
DTIM_earliest_005012=-1.00
DTIM_latest_005012=-0.01
DTIM_earliest_005019=-1.00
DTIM_latest_005019=-0.01

DTIM_earliest_005064=-1.50
DTIM_latest_005064=+1.49
DTIM_earliest_005065=-1.50
DTIM_latest_005065=+1.49
DTIM_earliest_005066=-1.50
DTIM_latest_005066=+1.49

DTIM_earliest_005067=-1.50
DTIM_latest_005067=+1.49
DTIM_earliest_005068=-1.50
DTIM_latest_005068=+1.49
DTIM_earliest_005069=-1.50
DTIM_latest_005069=+1.49

DTIM_earliest_005081=${DTIM_earliest_005081:-"-1.50"}
DTIM_latest_005081=${DTIM_latest_005081:-"+1.49"}
#DTIM_earliest_005081=-1.50
#DTIM_latest_005081=+1.49

$ushscript_dump/bufr_dump_obs.sh $dumptime 2.5 1 satwnd
error4=$?
echo "$error4" > $DATA/error4

set +x
echo "********************************************************************"
echo Script thread_4
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/4.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_5; chmod +x thread_5
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_5
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=5

#============================================================================
# Dump # 5 : MSONE1 -- TOTAL NUMBER OF SUBTYPES = 1
#              (1)
#============================================================================

def_time_window_5=0.5 # default time window for dump 5 is -0.5 to +0.5 hours

# Time window -0.50 to +0.50 hours for MSONET for full and partial cycle runs
#  (default)

$ushscript_dump/bufr_dump_obs.sh $dumptime ${def_time_window_5} 1 msone1
error5=$?
echo "$error5" > $DATA/error5

set +x
echo "********************************************************************"
echo Script thread_5
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/5.out 2>&1
EOF
set -x

#----------------------------------------------------------------
# Now launch the threads

#  determine local system name and type if available
#  -------------------------------------------------
SITE=${SITE:-""}

set +u
launcher=${launcher:-"cfp"}  # if not "cfp", threads will be run serially.

if [ "$launcher" = cfp ]; then
   > $DATA/poe.cmdfile
# To better take advantage of cfp, execute the longer running commands first.
# Some reordering was done here based on recent sample runtimes.
   echo ./thread_3 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_1 >> $DATA/poe.cmdfile
   echo ./thread_2 >> $DATA/poe.cmdfile
   echo ./thread_4 >> $DATA/poe.cmdfile
   echo ./thread_5 >> $DATA/poe.cmdfile

   if [ -s $DATA/poe.cmdfile ]; then
      export MP_CSS_INTERRUPT=yes  # ??
      launcher_DUMP=${launcher_DUMP:-mpiexec}
      $launcher_DUMP -np 5 --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      errpoe=$?
      if [ $errpoe -ne 0 ]; then
         $DATA/err_exit "***FATAL: EXIT STATUS $errpoe RUNNING POE COMMAND FILE"
      fi
   else
      echo
      echo "==> There are no tasks in POE Command File - POE not run"
      echo
   fi
else
   echo "Running serial threads"
   ./thread_1
   ./thread_2
   ./thread_3
   ./thread_4
   ./thread_5
#  wait
fi

cat $DATA/1.out $DATA/2.out $DATA/3.out $DATA/4.out $DATA/5.out

set +x
echo " "
echo " "
set -x

err1=`cat $DATA/error1`
err2=`cat $DATA/error2`
err3=`cat $DATA/error3`
err4=`cat $DATA/error4`
err5=`cat $DATA/error5` 

#================================================================

export STATUS=YES
export DUMP_NUMBER=6
$ushscript_dump/bufr_dump_obs.sh $dumptime 3.00 1 null


#  endif loop $PROCESS_DUMP
fi

#================================================================
#================================================================


if [ "$PROCESS_DUMP" = 'YES' ]; then

   if [ "$err1" -gt '5' -o "$err2" -gt '5' -o "$err3" -gt '5' \
     -o "$err4" -gt '5' -o "$err5" -gt '5' ] ; then
      for n in $err1 $err2 $err3 $err4 $err5
      do
         if [ "$n" -gt '5' ]; then
            if [ "$n" -ne '11' -a "$n" -ne '22' ]; then

## fatal error in dumping of BUFR obs. files

               set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, $err5"
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
               set -x
               err_exit
               exit 9
            fi
         fi
      done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

      set +x
      echo
      echo " ###################################################### "
      echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, $err5"
      echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
      echo " ###################################################### "
      echo
      set -x
   fi

#  endif loop $PROCESS_DUMP
fi

if [ "$RUN" == "rtma_ru" ] && [ "${SENDDBN^^}" = YES ] && [ -s ${COMSP}satwnd.tm00.bufr_d ]; then
   $DBNROOT/bin/dbn_alert MODEL RTMA_RU_BUFR_satwnd $job ${COMSP}satwnd.tm00.bufr_d
fi

#  concatenate msonet and msone1, b/c prepobs only wants one file
cat ${COMSP}msone1.tm00.bufr_d >> ${COMSP}msonet.tm00.bufr_d

#
# copy bufr_dumplist to $COMOUT per NCO SPA request
# -------------------------------------------------
echo "Copy bufr_dumplist to comout"
if [ $RUN = 'rtma_ru' ]; then
   LIST_cp=$COMOUT/${RUN}.t${cyc}${cycM}z.bufr_dumplist.${tmmark}
else
   LIST_cp=$COMOUT/${RUN}.t${cyc}z.bufr_dumplist.${tmmark}
fi
cp ${FIXbufr_dump}/bufr_dumplist $LIST_cp
chmod 644 $LIST_cp

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout
 
sleep 10

msg='ENDED NORMALLY.'
postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/sh
#
#--------------------------------------------------------------------------
#
#  gdas_summary.sh     
#
#  This script invokes script gdas_countstat.sh  each
#  of four cycle times (00,06,12,18) and then computes daily average counts
#  with monthly_ave.  In addition, counts for several satellite data types
#  are made.  These counts are written into web pages and forwarded to the 
#  WOK for display on the GDAS observational counts website.
#  
#  History:
#  L. Sager   09/07  Modified the script to work properly in operations.
#  V. Krishna Kumar 03/23 Modified the script to copy the final index file to
#                         the $DATCOM_monsum_base directory.
#                         For any reason, the final index file (for the month
#                         the stats are computed, for example, February 2009) 
#                         gets corrupted (could happen if this job is repeatedly run),
#                         please delete the corrupted index.shtml and copy over 
#                         from the previous month's backup (in this example, January 2009) 
#                         cp $DATCOM_monsum_base/index_backup.shtml
#                         $DATCOM_monsum_base/index.shtml 
#  D. Stokes  04/2015     Moved to vertical structure package obsproc_prep_post 
#                         and updated variables pointing to other software
#                         included in this migration.  Added variables in place
#                         of some hardwired settings to aid non-prod runs.  
#                         Added option to send html updates to developer 
#                         website for checkout runs.
#  D. Keyser  02/2016     Use NCO-established variable $COMROOT to point to root
#                         directory for input/output directories in order to run
#                         on WCOSS Phase 1 or Phase 2. Use NCO-established
#                         variables (presumably obtained from modules) to point
#                         to prod utilities:
#                          - ush finddate.sh where prepended-path $PATH from
#                            module prod_util (default or specified version)
#                            replaces horizontal structure utility directory
#                            path defined by imported variable $utilscript. Echo
#                            full path to finddate.sh to stdout.
#                          - ush month_name.sh where prepended-path $PATH from
#                            module util_shared/v1.0.2 (currently only specified
#                            version) replaces horizontal structure utility
#                            directory path defined by imported variable
#                            $utilscript. Echo full path to month_name.sh to
#                            stdout.
#  D. Keyser  05/2016     Split imported script variables $DATCOM1, $SATCOM and
#                         $DATCOM into separate input and output variables
#                         $DATCOM1_IN and $DATCOM1_OUT, $SATCOMIN (root to
#                         $SATCOMIN_dir, replacing $SATCOM_monsum_base which
#                         had been set here) and $SATCOMOUT_dir, and $DATCOMIN
#                         (root to $DATCOMIN_dir, replacing $DATCOM_monsum_base
#                         which had been set here) and $DATCOMOUT_dir set in
#                         parent Job Script.
#                         BENEFIT: Allows checkout runs to specify a production
#                                  input location and a local output location.
#  D. Stokes  03/2017     Removed dependency on month_name.sh utility script.
#                         (Use local arrays instead).  Corrected prep_step 
#                         placement and invocation.  Added transitional logic to
#                         pick up satcounts from either old directory structure
#                         (satcounts/$MON or satcounts_archive/$YEAR/$MON) or
#                         new monthly directories (satcounts.YYYYMM)
#  D. Stokes  08/2017     Removed logic to pick up satcounts from old $MON 
#                         directory structures.
#
#--------------------------------------------------------------------------


  set -x

# define arrays to store month names in various styles that might be used
  MONS=(null JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC)
  Mons=(null Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec)
  MONTHS=(null JANUARY FEBRUARY MARCH APRIL MAY JUNE
               JULY AUGUST SEPTEMBER OCTOBER NOVEMBER DECEMBER)
  Months=(null January February March April May June
               July August September October November December)

# Parse arguments, if any

if [ $# -eq 3 ]; then

  date=$1
  YEAR=`echo $date | cut -c1-4 `
  MM=`echo $date | cut -c5-6`
  last_mon=$MM
  month=$2
  numdays=$3

  MON=`echo $month | tr [a-z] [A-Z]`
  MONTH=${MONTHS[10#$MM]}   # get uppercase month string from array MONTHS.
  Month=${Months[10#$MM]}   # get Month string from array Months.

else

#  CUR_DAY=`date +%d`
#  CUR_DATE=`date +%Y%m%d`
  CUR_DATE=${monsummary_dat:-`date +%Y%m%d`}
  CUR_DAY=`echo $CUR_DATE|cut -c 7-8`

set +x; echo -e "\n---> path to finddate.sh below is: `which finddate.sh`"; set -x
  last_date=`sh finddate.sh ${CUR_DATE} d-${CUR_DAY}`

  numdays=`echo ${last_date} | cut -c7-8`
  YEAR=`echo ${last_date} | cut -c1-4`
  last_mon=`echo $last_date | cut -c5-6`
  MM=$last_mon                      

  date=${YEAR}${last_mon}01

  MON=${MONS[10#$last_mon]}       # get uppercase month abbrev from array MONS
  MONTH=${MONTHS[10#$last_mon]}   # get uppercase month string from array MONTHS
  Month=${Months[10#$last_mon]}   # get Month string from array Months
 
fi

  export MM MON MONTH Month YEAR
  echo -e "\n MON = ${MON}   MONTH = $MONTH   Month = $Month   YEAR = $YEAR \n"
  FIRSTDAY=$date
  NDAYS=$numdays

  echo -e "\n FIRSTDAT = $FIRSTDAY   NDAYS = $NDAYS \n" 

  export FIRSTDAY NDAYS

#  Summarize last month so reset file date to last month. 
#  SATCOMIN and DATCOMIN allow for alternate input source.

  export SATCOMIN_dir=${SATCOMIN}/satcounts.${YEAR}${last_mon}
  export DATCOMIN_dir=${DATCOMIN}/data_counts.${YEAR}${last_mon}

#  Extract the non-sat data counts from the monthly archive

#    00Z counts

  $USHprepobs/gdas_countstat.sh $date gdas $numdays 00 ${MONTH} 

#    06Z counts

  $USHprepobs/gdas_countstat.sh $date gdas $numdays 06 ${MONTH}

#    12Z counts

  $USHprepobs/gdas_countstat.sh $date gdas $numdays 12 ${MONTH} 
 
#    18Z counts

  $USHprepobs/gdas_countstat.sh $date gdas $numdays 18 ${MONTH}


#   Execute monthly_avg
#  Compute average daily non-sat counts for the month ( output is in file tmp1 )

  export pgm=gdascounts_ave
  . $DATA/prep_step

  export FORT10=gdas_${MONTH}_dumpstats.t00z
  export FORT11=gdas_${MONTH}_dumpstats.t06z
  export FORT12=gdas_${MONTH}_dumpstats.t12z
  export FORT13=gdas_${MONTH}_dumpstats.t18z
  export FORT50=tmp1

  $EXECprepobs/gdascounts_ave 1>aa.out 2>aa.out
  export err=$?; err_chk


#  Build the script that creates the html table for non-sat counts

sed -e 's/= /=/g' tmp1 > tmp2
sed -e 's/= \./=0\./g' tmp2  > tmp3
sed -e 's/= */=/g' tmp3 > ${MONTH}.gdas.outfile
echo "MONTH=${MONTH}" > ${MONTH}.htmlscript
echo "YEAR=$YEAR" >> ${MONTH}.htmlscript
cat ${MONTH}.gdas.outfile >> ${MONTH}.htmlscript
echo "cat <<EOF > ${MONTH}.html" >> ${MONTH}.htmlscript
cat $FIXprepobs/gdascounts_html  >> ${MONTH}.htmlscript


#  Run the script

  sh ${MONTH}.htmlscript
  cp ${MONTH}.html FILE_NONSAT

# Generate 3 satellite count files (received,selected,assimilated)

  $USHprepobs/satellite_summary.sh                             

# Combine 4 files ( 1 non-sat, 3 sat ) into 1

  $USHprepobs/gdascounts_combine.sh                           

  cp temp2 index.shtml           
  cp temp2 ${Month}_${YEAR}.shtml
#
# Copy the newly generated index.shtml file to $DATCOM1_OUT directory
#
 cp index.shtml $DATCOM1_OUT/.
#
# Move this over to the public web server.
#
if [ "$SENDWEB" = 'YES' ]; then
  #if [ "$USER" = nwprod ]; then # nco suggested change
  if [ "$USER" = ops.prod ]; then
    if [ $PARATEST = YES ]; then
    scp ${Month}_${YEAR}.html nwprod@ncorzdm:/home/people/nco/nwprod/pmb/nwtest/gdas/
    scp index.shtml nwprod@ncorzdm:/home/people/nco/nwprod/pmb/nwtest/gdas/
    else
    scp ${Month}_${YEAR}.html nwprod@ncorzdm:/home/people/nco/nwprod/pmb/nw${envir}/gdas/
    scp index.shtml nwprod@ncorzdm:/home/people/nco/nwprod/pmb/nw${envir}/gdas/
    fi
  elif [ $USER = ops.para ]; then
    scp ${Month}_${YEAR}.html nwprod@ncorzdm:/home/people/nco/nwprod/pmb/nw${envir}/gdas/
    scp index.shtml nwprod@ncorzdm:/home/people/nco/nwprod/pmb/nw${envir}/gdas/
  else # developer
    if [[ -z "$webhost" || -z "$webhostid" || -z "$webdir" ]]; then
      echo -e "\n*** WARNING:  Missing one or more variables required to send content to web! ***"
      echo -e " Check the following or set SENDWEB=NO"
      echo -e "   webhost: ${webhost:-"NOT SET!!  Should point to remote host."}"
      echo -e "   webhostid: ${webhostid:-"NOT SET!!  Should be userid for remote host."}"
      echo -e "   webdir: ${webdir:-"NOT SET!!  Should point to directory on remote host."}"
      echo -e "*** SKIPPING SCP TO REMOTE HOST ***\n"
      set -x
    else
      scp ${Month}_${YEAR}.html ${webhostid}@${webhost}:${webdir}/
      scp index.shtml ${webhostid}@${webhost}:${webdir}/
    fi
  fi
fi

#!/bin/ksh
# bufr_prepmods.sh - 30 Jan 2013
#  trigger for multiday dumping of MODS data
#
#  prog flow:
#   for each of select datatypes
#    -run dumpjb for 24hours around noon of input ($1) date
#    -run bufr_prepmods to create MB file
# ---------
# mods:
# 13 NOV 2003 JAW/DAK Copied from JAW's checkout version and configured
#             into a "production" ush script
#  7 May 2004 JAW  disabled metar & ssmipn processing
# 26 May 2004 JAW  enabled metar & ssmipn processing;  disabled 
#                  'monthly' datatype (bathy,tesac,trkob) processing; 
#                  trapped blank MODSDIR
# 14 Jun 2004 JAW  Disabled ERSAL processing (new BTable doesn't 
#                  support it); also, fixed invalid data type trap bug 
#                  (couldn't distiguish ERSAL from NERSAL).
# 16 Jun 2004 JAW  fixed bug in dtype parsing (quotes on grep alltypes)
#  2 Aug 2005 JAW  referenced bufrtable in /nwprod/fix (not MODSDIR)
# 15 Oct 2007 JAW  enabled Envisat Altimeter dtype (envsal, NC031109);
#                  parameterized BTABdir.
#  5 Mar 2008 JAW  enabled rstprod permissions for SHIPS dtyp
#                  removed copy of dump files in COMOUT
#  6 Mar 2012 JAW  added SHIPSU as supported data type;
#                  added SHPALL dump group support
# 30 Jan 2013 JAW  Ported to WCOSS, modified for linux platforms:
#                   replaced "timex" w/ "time -p"
#                   replaced XLF logical unit number specifications w/
#                   appropriate FORTxx logic.
# 22 Feb 2019 JAW  Ported to phase 3 (Dell) platforms:
#                   added environment variables and parameterized for vertical
#                     structure layout;
# =========

# Positional parameters passed in:
#   1 - Dump date (YYYYMMDD)

# Imported variables that must be passed in:
#   DATA         - path to working directory
#   pgmout       - string indicating path to for standard output file
#   EXECmods     - path to bufr_prepmods executable directory
#   MODSDIR      - path to MODSBUFR database directory

# Imported variables that can be passed in:
#   MODX      - path to bufr_prepmods executable (defaults to
#                 $EXECmods/bufr_prepmods)
#   jlogfile  - path to job log file (skipped over by this script if not
#                 passed in)
#   BTABdir   - path to bufrtable directory (default: $HOMEobsproc/fix/)

ver='02/26/2019 -- WCOSS phase 3 compatible'
echo "Welcome to bufr_prepmods.sh of $ver"

set -uax  # x=echo's exec; u=error on unset variables; a=auto export'

cd $DATA

err_grand=0

if [ "$#" -ne '1' ]; then
   msg="**NON-FATAL ERROR PROGRAM  BUFR_PREPMODS  dump date not in \
positional parameter 1"
   set +x
   echo
   echo $msg
   echo
   set -x
   echo $msg >> $pgmout
   set +u
   [ -n "$jlogfile" ]  &&  postmsg "$jlogfile" "$msg"
   set -u
   exit 99
fi

if [ ".$MODSDIR" = '.' ]; then
   msg="**NON-FATAL ERROR PROGRAM  BUFR_PREPMODS -- MODSDIR parameter \
not specified"
   set +x
   echo
   echo $msg
   echo
   set -x
   echo $msg >> $pgmout
   set +u
   [ -n "$jlogfile" ]  &&  postmsg "$jlogfile" "$msg"
   set -u
   exit 99
fi

MODX=${MODX:-$EXECmods/bufr_prepmods}

#  Day to dump is script argument
#  ------------------------------
cymd=$1
dhr=${dhr:-11.999}
year=`echo $cymd|cut -c 1-4`
mnth=`echo $cymd|cut -c 5-6`
days=`echo $cymd|cut -c 7-8`

set +x
echo
echo "  Dump date is $cymd"
echo
set -x

#  list of datatypes to dump a day into the mods database
#  ------------------------------------------------------
 typ000=' metar'
 typ001=' ships  shipsb  shipsu  shipub  dbuoy  dbuoyb  mbuoy  mbuoyb  lcman  cmanb  tideg  slpbg  cstgd'
 typ012='               sstns  sstnvh ssmipn'  # ersal
 typ031=' ' #'bathy  tesac  trkob'
 typHAlt='    nersal ngfoal ntpxal njsnal  envsal'
 typ031="$typ031$typHAlt"

 gtypes=' shpall'

alltypes=${typ000}${typ001}${typ012}${typ031}${gtypes}
dtypes=${dtypes:-"$alltypes"}


##echo "dtypes=>>$dtypes<<" | sed 's/  */ /g'

# Loop thru each data type
# ------------------------
for dtyp in $dtypes ; do

  if [ -z "`echo \" $alltypes \" | grep \" $dtyp \"`" ] ; then 
    msg="$dtyp not supported by BUFR_PREPMODS - skip"
    set +x
    echo
    echo $msg
    echo
    set -x
    echo $msg >> $pgmout
    set +u
    [ -n "$jlogfile" ]  &&  postmsg "$jlogfile" "$msg"
    set -u
  else

#  make and/or move to directory for this data for this day
#  --------------------------------------------------------
    #DBASE=$MODSDIR/$year/$mnth/$dtyp
    DBASE=$MODSDIR/$mnth/$dtyp
    mkdir -p $DBASE

    if [ ".$dtyp" = '.ships' -o \
         ".$dtyp" = '.shipsb' -o \
	 ".$dtyp" = '.shpall' ] ; then   # restrict access to SHIPS/SHIPSB/SHPALL directory
      chgrp rstprod $DBASE
      chmod 750     $DBASE
    fi # dtyp = ships/shipsb/shpall

#  run the dumpjb script for this datatype  
#  ---------------------------------------
    # turn off duplicate removal for mbuoyb
    if [ $dtyp = 'mbuoyb' ];
    then
	export DUPC_TAC=off
	export DUPC=off
    else
	export DUPC_TAC=on
	export DUPC=on
    fi

    > $dtyp.ibm

    time -p $DUMP ${cymd}12 $dhr $dtyp >> $pgmout 2> errfile
    errret=$?
    cat errfile >> $pgmout
    cat $dtyp.out >> $pgmout
    rm errfile
    set +x
    echo
    echo "DUMPJB error r.c. is $errret for $dtyp"
    echo
    set -x

    if [ $errret -gt 0 -a $errret -ne 11 ] ; then 
      if [ $errret -le 22 ] ; then 
         msg="$dtyp dump is EMPTY, errret=$errret - skip"
      else
        msg="DUMPJB failed attempting to dump $dtyp, errret=$errret - skip"
        err_grand=99
      fi
      set +x
      echo
      echo $msg
      echo
      set -x
      echo $msg >> $pgmout
      set +u
      [ -n "$jlogfile" ]  &&  postmsg "$jlogfile" "$msg"
      set -u
      cp -p $dtyp.out $COMOUT/$dtyp.$cymd.bufr_d.out_$errret
      continue  # to next data type
    else

      if [ $errret -eq 11 ] ; then 
        typ0=`grep 'HAS        0' $dtyp.out | cut -c1-7`
        for t in $typ0 ; do 
          msg="$dtyp dump is INCOMPLETE (rc=$errret) for type(s) $t"
          set +x ; echo ; echo $msg ; echo ; set -x
          echo $msg >> $pgmout
          set +u ; [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg" ; set -u
        done # t in typ0
      fi # errret = 11
      msg="script DUMPJB completed successfully for $cymd for $dtyp"
      set +x
      echo
      echo $msg
      echo
      set -x
      echo $msg >> $pgmout
      set +u
      [ -n "$jlogfile" ]  &&  postmsg "$jlogfile" "$msg"
      set -u
      cp -p $dtyp.out $COMOUT/$dtyp.$cymd.bufr_d.out
    fi

#  Run bufr_prepmods to make a MODSBUFR file from the dump file
#  ---------------------------------------------------------
    pgm=`basename $MODX`
    export pgm
    if [ -s prep_step ]; then
       set +u
       . prep_step
       set -u
    else
       [ -f errfile ] && rm errfile
       unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
    fi

    set +x ; echo 
    echo "prepmods: running $pgm for $dtyp $cymd"
    echo ; set -x

    BTABdir=${BTABdir:-$HOMEobsproc/fix}

    export FORT20="$dtyp.ibm"
    export FORT21="$BTABdir/bufrtab.mods"
    export FORT50="$dtyp.$cymd"

    time -p $MODX >> $pgmout 2> errfile
    errget=$?
    cat errfile >> $pgmout
    rm errfile
    set +x
    echo
    echo "The foreground exit status for $pgm is " $errget
    echo
    set -x
    if [ "$errget" -ne '0' ];then
      msg="**FATAL ERROR PROGRAM  $pgm  FOR $cymd FOR $dtyp - \
RETURN CODE $errget"
      set +x
      echo
      echo $msg
      echo
      set -x
      echo $msg >> $pgmout
      set +u
      [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
      set -u
      err_grand=99
    else
      cp -p $dtyp.$cymd $DBASE/$dtyp.$cymd
      if [ ".$dtyp" = '.ships' -o \
	   ".$dtyp" = '.shipsb' -o \
           ".$dtyp" = '.shpall' ] ; then   # restrict access to SHIPS/SHIPSB/SHPALL files
        chgrp rstprod $DBASE/$dtyp.$cymd
        chmod 640     $DBASE/$dtyp.$cymd
      fi # dtyp = ships/shipsb/shpall
      msg="program  $pgm completed normally for $cymd FOR $dtyp"
      set +x
      echo
      echo $msg
      echo
      set -x
      echo $msg >> $pgmout
      set +u
      [ -n "$jlogfile" ] && postmsg "$jlogfile" "$msg"
      set -u
    fi
    set +x
    echo
    echo "----------------------------------------------------------"
    echo "*****  COMPLETED PROGRAM $pgm for $dtyp $cymd  *****"
    echo "----------------------------------------------------------"
    echo
    set -x

#--End of loop for each data type
#--------------------------------
  fi # dtyp in alltypes
done # for dtyp in dtypes


# End of script
# -------------

err=$err_grand

if [ "$err_grand" -gt '0' ]; then
  if [ -s $DATA/err_exit ]; then
    $DATA/err_exit
  else
####kill -9 ${qid}
    exit 555
  fi
  exit 9
fi

#!/bin/bash

case $(hostname -f) in

  adecflow0[12].acorn.wcoss2.ncep.noaa.gov)  MACHINE_ID=wcoss2 ;; ### acorn
  alogin0[12].acorn.wcoss2.ncep.noaa.gov)    MACHINE_ID=wcoss2 ;; ### acorn
  clogin0[1-9].cactus.wcoss2.ncep.noaa.gov)  MACHINE_ID=wcoss2 ;; ### cactus01-9
  clogin10.cactus.wcoss2.ncep.noaa.gov)      MACHINE_ID=wcoss2 ;; ### cactus10
  dlogin0[1-9].dogwood.wcoss2.ncep.noaa.gov) MACHINE_ID=wcoss2 ;; ### dogwood01-9
  dlogin10.dogwood.wcoss2.ncep.noaa.gov)     MACHINE_ID=wcoss2 ;; ### dogwood10

  gaea5[1-8])          MACHINE_ID=gaeac5 ;; ### gaea51-58
  gaea5[1-8].ncrc.gov) MACHINE_ID=gaeac5 ;; ### gaea51-58
  gaea6[1-8])          MACHINE_ID=gaeac6 ;; ### gaea61-68
  gaea6[1-8].ncrc.gov) MACHINE_ID=gaeac6 ;; ### gaea61-68

  ufe0[1-4]) MACHINE_ID=ursa ;; ### ursa

  hfe0[1-9]) MACHINE_ID=hera ;; ### hera01-9
  hfe1[0-2]) MACHINE_ID=hera ;; ### hera10-12
  hecflow01) MACHINE_ID=hera ;; ### heraecflow01

  Orion-login-[1-4].HPC.MsState.Edu) MACHINE_ID=orion ;; ### orion1-4

  [Hh]ercules-login-[1-4].[Hh][Pp][Cc].[Mm]s[Ss]tate.[Ee]du) MACHINE_ID=hercules ;; ### hercules1-4

  login[1-4].stampede2.tacc.utexas.edu) MACHINE_ID=stampede ;; ### stampede1-4

  login0[1-2].expanse.sdsc.edu) MACHINE_ID=expanse ;; ### expanse1-2

  discover3[1-5].prv.cube) MACHINE_ID=discover ;; ### discover31-35

  *.ec2.internal) MACHINE_ID=aws-ec2 ;; ### AWS-EC2

  *) MACHINE_ID=UNKNOWN ;; ### unknown platform
esac

if [[ ${MACHINE_ID} == "UNKNOWN" ]]; then
	case ${PW_CSP:-} in
		"aws" | "google" | "azure") MACHINE_ID=noaacloud ;; ## NOAA cloud platform
		*) PW_CSP="UNKNOWN"
	esac
fi

# Overwrite auto-detect with MACHINE if set
MACHINE_ID=${MACHINE:-${MACHINE_ID}}

# Append compiler (only on machines that have multiple compilers)
if [ $MACHINE_ID = hera ] || [ $MACHINE_ID = cheyenne ]; then
    MACHINE_ID=${MACHINE_ID}.${COMPILER}
fi

#!/bin/ksh
# Run under ksh (converted to WCOSS)

####  UNIX Script Documentation Block
#
# Script name:         getges_driver.sh
# Script description:  Sets up execution of getges for FV3 & legacy NEMSIO GFS
#
# Author:       Keyser              Org: EMC          Date: 2018-03-05
#
# Abstract: This script is a driver for the ush script getges.sh.  It is needed
#   in order to handle the FV3 GFS, but it also handles the legacy (pre-FV3)
#   NEMSIO GFS.  Since the FV3 GFS directory paths ($COMINgdas and $COMINgfs)
#   now contain a suffix cycle time directory (e.g.,
#   /gpfs/hps/nco/ops/com/gfs/prod/gfs.20180305/12 vs.
#   /gpfs/hps/nco/ops/com/gfs/prod/gfs.20180305 before), the old logic in
#   getges.sh would end up looking for the global guess only in $PDY, $PDYm1,
#   $PDYm2, etc. directories with current cycle time in the suffix.  The odds
#   are that a valid global guess would not be found in the current day/cycle
#   directory, so at best a global guess would be found in a 24-hour old
#   directory and thus have a longer forecast time than a "best guess" would
#   have.  At worst, a global guess might not be found at all or be from an
#   even older initial state if there was an operational failure the previous
#   day.  In addition, a global guess would never be found in a RAP or NAM
#   network whose cycle time was not a multiple of 6 hours.
#
#   This driver essentially does the following:
#     1) First checks to see if the imported directory paths ($COMINgdas and
#        $COMINgfs) both do NOT have a cycle time directory in their suffix.  If
#        so, assumes this is a run from the legacy NEMSIO GFS.  Executes
#        getges.sh exporting a value of 384 hours for $fhend (hour to end
#        searching backward for guess, the getges default). Essentially there is
#        no change here from before in methodology for obtaining a global guess
#        from getges.sh.  This check allows this driver to be implemented prior
#        to the FV3 GFS upgrade and allows it to work for historical (pre-FV3)
#        data.  If a global guess file for the valid time is not found, this
#        driver exits with a non-zero return code (meaning the parent job will
#        likely ABORT).
#     2) If 1) above is not satisfied, next checks to see if the imported
#        directory paths ($COMINgdas and $COMINgfs) both DO have a cycle time
#        directory in their suffix.  If so, assumes this is a run from the FV3
#        NEMSIO GFS.  This driver then does the following until an acceptable
#        global guess file for the valid time is found:
#            a) First try looking for the global guess in the prior GDAS or GFS
#               cycle directory closest to, but not at, the valid cycle time
#               {e.g., if valid cycle is 2018030518, then look in GDAS and GFS
#               directories with cycle time 12 (i.e., ./<gdas><gfs>.20180305/12)
#               or if valid cycle is 2018030610 (e.g., for the RAP), then look
#               in GDAS and GFS directories with cycle time 06
#               (i.e., ./<gdas><gfs>.20180306/06)}.
#               IMPORTANT: Since the logic in getges.sh is still designed to
#                          keep marching backward in 24-hour increments if a
#                          global guess is not found for the current day, we
#                          export $fhend (hour to end searching backward for
#                          guess) as 12 hours here because, at this point, we do
#                          not want to accept a global guess from the previous
#                          day that might be a 24+ hour forecast. Instead, if
#                          no global guess is found move on to b) below.
#            b) If a global guess is still not found, next try looking for the
#               global guess in the GDAS or GFS cycle directory 6 hours prior
#               to that in a) above (i.e., in two examples above, look now in
#               ./<gdas><gfs>.20180305/06 and ./<gdas><gfs>.20180306/00).
#               IMPORTANT: Again export $fhend (hour to end searching backward
#                          for guess) as 12 hours to prevent accepting a global
#                          guess with a long forecast hour if getges.sh goes
#                          back another day.)
#            c) If a global guess is still not found, next try looking for the
#               global guess in the GDAS or GFS cycle directory 6 hours prior
#               to that in b) above (i.e., in two examples above, look now in
#               ./<gdas><gfs>.20180305/00 and ./<gdas><gfs>.20180305/18).
#               IMPORTANT: This time export $fhend (hour to end searching
#                          backward for guess) as 18 hours to allow for a
#                          slightly longer forecast hour (since we have now gone
#                          back 12+ hours) but still preventing the acceptance
#                          of a global guess with a forecast hour that becomes
#                          too long if getges.sh goes back another day.).
#            d) If a global guess is still not found, next try looking for the
#               global guess in the GDAS or GFS cycle directory 6 hours prior to
#               that in c) above (i.e., in two examples above, look now in
#               ./<gdas><gfs>.20180304/18 and ./<gdas><gfs>.20180305/12).
#               IMPORTANT: This is our last attempt to find a global guess
#                          before aborting.  Thus, export $fhend (hour to end
#                          searching backward for guess) as 384 hours (the
#                          getges default) to give it the best shot at finding a
#                          global guess, no matter what day it initiates from
#                          and no matter how long its forecast hour is.
#            e) If a global guess is still not found, exit with a non-zero
#               return code (meaning the parent job will likely ABORT).
#     3) If neither 1) nor 2) above is satisfied, exit with a non-zero return
#        code (meaning the parent job will likely ABORT).
#
#   NOTE 1: This driver will not work for the sigio global guess!!!
#
#   NOTE 2: This driver is designed to only be executed by
#           prepobs_makeprepbufr.sh.
#
#
# Script history log:
# 2018-03-05  Dennis A. Keyser -- Original version for implementation
# 2020-07-12  S. Melchior -- Modified to handle atmos suffix in $COMINgfs
#                            and $COMINgdas, introduced in GFSv16, via
#                            $COMPONENT variable.
#
#
# Usage:  getges_driver.sh
#
#   Imported Shell Variables:
#
#     These must ALWAYS be exported to this script by the parent script unless
#     otherwise noted --
#
#     COMINgdas     String indicating full path to starting location for
#                   searching for first guess (and other) files from GDAS in
#                   child script getges.sh
#     COMINgfs      String indicating full path to starting location for
#                   searching for first guess (and other) files from GFS in
#                   child script getges.sh
#     COMPONENT     String indicting coupled modeling component (e.g., atmos,
#                   wave, ocean, etc ...)
#     GETGESprep    String indicating full path to GETGES utility script
#     envir_getges  String indicating environment under which GETGES utility
#                   ush runs (see getges.sh docblock for more information)
#                   (Normally expected to be "prod".)
#     network_getges
#                   String indicating job network under which GETGES utility
#                   ush runs (see getges.sh docblock for more information)
#                   (Normally expected to be "global".)
#     fhr           String indicating specific forecast hour wanted (see
#                   getges.sh docblock for more information)
#                   (Normally expected to be "any", "-3" or "+3".)
#     stype         String indicating the filetype wanted (see getges.sh
#                   docblock for more information)
#                   (Normally expected to be "natges" if $fhr is "any", "natgm3"
#                    if $fhr is "-3", or "natgp3" if $fhr is "+3".)
#     CDATE10       String indicating the valid date wanted <YYYYMMDDHH>
#     sges          Name of file to which first guess should be copied
#                   (This is required if $fhr is "+3" or "-3". If $fhr
#                    is "any" this is ignored.))
#     LOUD          If "YES", turns on script trace (set -x)
#                   This does not have to be imported - it will default to "NO"
#
#
#   Modules and files referenced:
#     scripts    : $GETGESprep
#     executables: $NDATE (from prod_util module)
#
#
# Remarks:
#
#   Condition codes
#      0 - no problem encountered
#     >0 - some problem encountered
#
# Attributes:
#   Language: Korn shell under linux
#   Machine:  NCEP WCOSS
#
####

LOUD=${LOUD:-NO}
set -au
[ $LOUD = YES ]  &&  set -x

PDY=`echo $CDATE10 | cut -c1-8`
cyc=`echo $CDATE10 | cut -c9-10`

errges=1

bn_COMINgdas=`basename $COMINgdas`
bn_COMINgfs=`basename $COMINgfs`

#######################################################################################################
#######################################################################################################
if [[ `echo $bn_COMINgdas | cut -c1` = g && `echo $bn_COMINgfs | cut -c1` = g ]];then

# This runs the legacy NEMSIO version with no cycle time directory in the suffix of $COMINgdas and $COMINgfs

fhend=384

if [ $fhr = "-3" -o $fhr = "+3" ]; then
   $GETGESprep -e $envir_getges -n $network_getges -v $CDATE10 -t $stype $sges
   errges=$?
else
   $GETGESprep -e $envir_getges -n $network_getges -f $fhr -v $CDATE10 -t $stype > sgesprep_pathname
   errges=$?
fi

#######################################################################################################
#######################################################################################################
elif [[ `echo $bn_COMINgdas | cut -c1` != g && `echo $bn_COMINgfs | cut -c1` != g ]];then

# This runs GFS v15+ by replacing ${PDY}/${cyc} with new values.
# $COMINGgdas and $COMINgfs


# First try using closest directory cycle time (00, 06, 12 or 18) preceding cycle hour
#  if that doesn't work go back another 6 hours and try again
#  rinse and repeat until you've gone back 24 hours - if still no luck give up
# ------------------------------------------------------------------------------------

COMINgdas_orig="${COMINgdas}"
COMINgfs_orig="${COMINgfs}"

PDY_this_try=$PDY
cyc_this_try=$cyc

modhr=`expr $cyc_this_try % 6`
[ $modhr -eq 0 ]  && modhr=6

PDY_this_try=`$NDATE -$modhr ${PDY_this_try}${cyc_this_try} | cut -c1-8`
cyc_this_try=`$NDATE -$modhr ${PDY_this_try}${cyc_this_try} | cut -c9-10`

COMINgdas=${COMINgdas_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
COMINgfs=${COMINgfs_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
fhend=12

if [ $fhr = "-3" -o $fhr = "+3" ]; then
   $GETGESprep -e $envir_getges -n $network_getges -v $CDATE10 -t $stype $sges
   errges=$?
else
   $GETGESprep -e $envir_getges -n $network_getges -f $fhr -v $CDATE10 -t $stype > sgesprep_pathname
   errges=$?
fi

if test $errges -ne 0
then
#  problem obtaining global nemsio (or netcdf history) first guess so go back 6 hours in cycle directory
   set +x
   echo
   if [ $fhr = "-3" -o $fhr = "+3" ]; then
      echo "problem obtaining global nemsio-based (or netcdf history) guess valid $fhr hrs relative to center PREPBUFR date/time;"
   else
      echo "problem obtaining global nemsio-based (or netcdf history) guess;"
   fi
   echo "go back 6 hours in cycle directory and try again"
   echo
   [ $LOUD = YES ]  &&  set -x
else
 exit 0
fi


PDY_this_try=`$NDATE -6 ${PDY_this_try}${cyc_this_try} | cut -c1-8`
cyc_this_try=`$NDATE -6 ${PDY_this_try}${cyc_this_try} | cut -c9-10`

COMINgdas=${COMINgdas_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
COMINgfs=${COMINgfs_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
fhend=12

if [ $fhr = "-3" -o $fhr = "+3" ]; then
   $GETGESprep -e $envir_getges -n $network_getges -v $CDATE10 -t $stype $sges
   errges=$?
else
   $GETGESprep -e $envir_getges -n $network_getges -f $fhr -v $CDATE10 -t $stype > sgesprep_pathname
   errges=$?
fi

if test $errges -ne 0
then
#  problem obtaining global nemsio (or netcdf history) first guess so go back 6 hours in cycle directory
   set +x
   echo
   if [ $fhr = "-3" -o $fhr = "+3" ]; then
      echo "problem obtaining global nemsio-based (or netcdf history) guess valid $fhr hrs relative to center PREPBUFR date/time;"
   else
      echo "problem obtaining global nemsio-based (or netcdf history) guess;"
   fi
   echo "go back another 6 hours in cycle directory and try again"
   echo
   [ $LOUD = YES ]  &&  set -x
else
 exit 0
fi


PDY_this_try=`$NDATE -6 ${PDY_this_try}${cyc_this_try} | cut -c1-8`
cyc_this_try=`$NDATE -6 ${PDY_this_try}${cyc_this_try} | cut -c9-10`

COMINgdas=${COMINgdas_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
COMINgfs=${COMINgfs_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
fhend=18

if [ $fhr = "-3" -o $fhr = "+3" ]; then
   $GETGESprep -e $envir_getges -n $network_getges -v $CDATE10 -t $stype $sges
   errges=$?
else
   $GETGESprep -e $envir_getges -n $network_getges -f $fhr -v $CDATE10 -t $stype > sgesprep_pathname
   errges=$?
fi

if test $errges -ne 0
then
#  problem obtaining global nemsio (or netcdf history) first guess so go back 6 hours in cycle directory
   set +x
   echo
   if [ $fhr = "-3" -o $fhr = "+3" ]; then
      echo "problem obtaining global nemsio-based (or netcdf history) guess valid $fhr hrs relative to center PREPBUFR date/time;"
   else
      echo "problem obtaining global nemsio-based (or netcdf history) guess;"
   fi
   echo "go back another 6 hours in cycle directory and try again"
   echo
   [ $LOUD = YES ]  &&  set -x
else
 exit 0
fi


PDY_this_try=`$NDATE -6 ${PDY_this_try}${cyc_this_try} | cut -c1-8`
cyc_this_try=`$NDATE -6 ${PDY_this_try}${cyc_this_try} | cut -c9-10`

COMINgdas=${COMINgdas_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
COMINgfs=${COMINgfs_orig/${PDY}\/${cyc}/${PDY_this_try}/${cyc_this_try}}
fhend=384

if [ $fhr = "-3" -o $fhr = "+3" ]; then
   $GETGESprep -e $envir_getges -n $network_getges -v $CDATE10 -t $stype $sges
   errges=$?
else
   $GETGESprep -e $envir_getges -n $network_getges -f $fhr -v $CDATE10 -t $stype > sgesprep_pathname
   errges=$?
fi
#######################################################################################################
#######################################################################################################
fi

if test $errges -ne 0
then
#  problem obtaining global nemsio (or netcdf history) first guess so exit
   exit 9
fi
exit 0

#!/bin/ksh
export PS4=' + data_check_gfs.sh line $LINENO: '
set -x

####################################
# Specify Timeout Behavior for TC Track calculations
# SLEEP_TIME - Amount of time to wait for a input-data file before exiting
# SLEEP_INT  - Amount of time to wait between checking for input-data file
####################################
export SLEEP_TIME=3600
export SLEEP_INT=60
SLEEP_LOOP_MAX=`expr $SLEEP_TIME / $SLEEP_INT`

if [ ${cmodel} = "gfs" ]; then
  datdir=${gfsdir}
  vit_incr=${FHOUT_CYCLONE:-6}                        
  fcstlen=${FHMAX_CYCLONE:-240}                       
  fcsthrs=$(seq -f%03g -s' ' 0 $vit_incr $fcstlen)    
fi

ic=0
while [ $ic -lt $SLEEP_LOOP_MAX ]; do
  echo "Check for the existence of the files in ${datdir}"

  ic1=0
  for fhour in ${fcsthrs}; do
    datfile=gfs.t${cyc}z.pres_a.0p25.f${fhour}.grib2
    if [ ! -s ${datdir}/${datfile} ]; then
      set +x
      echo " "
      echo "GFS file missing: ${datdir}/${datfile}"
      echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      echo " "
      set -x
      ic1=`expr $ic1 + 1`
    fi
  done

  if [ $ic1 -eq 0 ]; then
    echo " !!!  $ic1 files missing in ${datdir} after waiting $ic minutes"
    break
  else
    sleep $SLEEP_INT
  fi
  ic=`expr $ic + 1`
###############################
# After we wait for 60 minutes, no data is available, Job will be quit. 
###############################
  if [ $ic -eq $SLEEP_LOOP_MAX ]; then
    msg="FATAL ERROR: $ic1 files missing in ${datdir}"
    echo "$msg"; postmsg "$jlogfile" "$msg"
    exit 6
  fi
done

#!/bin/ksh
PS4=' + sort_tracks.sh line $LINENO: '

echo " "
echo "+++ Top of sort script, TRKDATA= $TRKDATA"
echo " "
set -x

cd $TRKDATA

#J.Peng---2012-04-12-------------------------
model=${atcfout}
min_storm_length=24

#vdrcc=`${datecheck} ${YMDH} >/dev/null; echo $?`
#if [ ${vdrcc} -eq 0 ]; then
#  echo " "
#  echo "Imported date there, using ymdh= $YMDH"
#  echo " "
#else
#  tmpdate=`date '+%Y%m%d'`
#  indate=${tmpdate}00
#  echo " "
#  echo "!!! IMPORTED DATE NOT THERE; USING CURRENT DAY'S 00Z CYCLE"
#  echo " "
#fi
  
yyyy=`echo ${PDY} | cut -c1-4`
ymdh=${PDY}${cyc}

#J.Peng----2012-04-11-------------------
#outdir=/ptmpp1/Jiayi.Peng/hugen_g2/${ymdh}
  
trakfile=trak.${model}.atcf_gen.${regtype}.${ymdh}
# trakfile=mftrak.atcf_gen.${ymdh}
# trakfile=trak.jsg.atcf_gen.glob.2005082506

#---------------------------------------------------------------
# There can be up to 3 different forecast records for each time
# level (1 each for 34-, 50- and 64-knot wind radii).  For our
# plotting purposes, we just care about the track, so just pick
# out one of them (the records that have 34-kt winds).  The
# lat/lon information will be the same on all 3.  Sort these
# records by storm number.  Cat out the file and sort it by 
# storm ID.  The storm ID is the 3rd element in the atcf record.

#cat ${trakfile} | grep "34, NEQ" | grep FOF | sort +2 -n >${trakfile}.sorted
cat ${trakfile} | grep "34, NEQ" | grep FOF | sort -k 2 -n >${trakfile}.sorted

#---------------------------------------------------------------
# Now go through the sorted atcf file and create a list of the
# unique storm IDs.

>unique_storm_list.txt

prevstormid='xxx'
while read atcfrec
do

  stormid=` echo "${atcfrec}" | awk -F, '{print $3}'`
  if [ ${stormid} != ${prevstormid} ]; then
    echo "${stormid}" >>unique_storm_list.txt
    set +x
    echo "+++ Storm ${stormid} added to unique storm list"
    set -x
    prevstormid=${stormid}
  fi
      
done <${trakfile}.sorted

#---------------------------------------------------------------
# Now go through this list of unique storm IDs, and for each
# storm, grep out all of the atcf records from the sorted 
# atcf file.  Then check to see what the length of time is that
# each storm lived for.  If the storm lived for at least the 
# minimum storm length, then dump all the atcf records (i.e., 
# all lead times) into a final, sorted & filtered file.

>storms.${model}.atcf_gen.${regtype}.${ymdh}

while read stormid
do

  >indiv_storm.temp.txt
  grep "${stormid}" ${trakfile}.sorted >indiv_storm.temp.txt

  first_hour=` head -1 indiv_storm.temp.txt | awk -F, '{printf ("%d\n",$7)}'`
  last_hour=`  tail -1 indiv_storm.temp.txt | awk -F, '{printf ("%d\n",$7)}'`

  let storm_length=last_hour-first_hour

  if [ ${storm_length} -ge ${min_storm_length} ]; then
    set +x
    echo " "
    echo "+++ Storm $stormid lived for at least 24h.  Length= $storm_length"
    echo " "
    set -x
    cat indiv_storm.temp.txt >>storms.${model}.atcf_gen.${regtype}.${ymdh}
  else
    set +x
    echo " "
    echo "!!! Storm $stormid DID NOT LIVE at least 24h.  Length= $storm_length"
    echo " "
    set -x
  fi

done <unique_storm_list.txt

# Now add in the storms that are already being numbered and
# tracked by one of the operational forecasting centers.
# These storms have TC Vitals records issued for them.

grep -v FOF ${trakfile} | grep -v "ML, " | grep -v "TG," | \
         grep "34, NEQ" >>storms.${model}.atcf_gen.${regtype}.${ymdh}
#        grep "34, NEQ" | sort +0 -n >>storms.${model}.atcf_gen.${regtype}.${ymdh}

#archdir=${FIXens_tracker}/tracks_${yyyy}
#if [ ! -s ${archdir} ]; then
#  mkdir -p ${archdir}
#fi

#J.Peng----2012-04-12---------
#cp  storms.${model}.atcf_gen.${regtype}.${ymdh} ${gradsdir}/.
#cp  storms.${model}.atcf_gen.${regtype}.${ymdh} ${outdir}/.
#cat storms.${model}.atcf_gen.${regtype}.${ymdh} >>${archdir}/storms.${model}.atcf_gen.${regtype}.${yyyy}
##cp storms.${model}.atcf_gen.${regtype}.${ymdh} ${FIXens_tracker}/genesis_track_${yyyy}/.

if [ "$SENDCOM" = 'YES' ]; then
  cp storms.${model}.atcf_gen.${regtype}.${ymdh} ${COMOUT}/

  if [ "$SENDDBN" = 'YES' ]; then
    if [ "$cmodel" != 'eens' -a "$cmodel" != 'ecmwf' -a "$cmodel" != 'ukmet' ]; then
      $DBNROOT/bin/dbn_alert MODEL ENS_GENESIS $job ${COMOUT}/storms.${model}.atcf_gen.${regtype}.${ymdh}
    fi
  fi
fi

#!/bin/ksh
################################################################################
#
#  gdascount_combine.sh, merges 4 html files into a single file.
#  The files contain non-sat data counts and 3 sat data counts
#  (received, selected and assimilated).  The resulting html file
#  is sent to the rzdm for display in the GDAS Observational Data
#  counts website.        
#
#  History
#  Ralph Jones   10/04/2005  -  Original version.
#  L. Sager      09/30/2007  -  Modified for operations
#  V. Krishna Kumar 11/15/2008 - Modified to adjust the index html file
#                                for new years
#  D. Stokes  04/2015 Moved to vertical structure package obsproc_prep_post.
#                     Added shebang to run under ksh.  (Since WCOSS transition
#                     this script has been running under bash which does not
#                     capture output from a piped command as expected here).
#                     Removed typeset of variable last so as not to limit it to 
#                     three characters. Similarly, modified sed statement to
#                     prevent corruption of the html file should it reach more 
#                     than 999 lines.  Added checks to reduce risk main page 
#                     corruption if a month is rerun.  Add option to rebuild
#                     complete main page.
#  D. Keyser  05/2015 Split imported script variable $DATCOM1 into separate
#                     input and output variables $DATCOM1_IN and $DATCOM1_OUT
#                     set in parent Job Script.
#                     BENEFIT: Allows checkout runs to specify a production
#                              input location and a local output location.
#
################################################################################

set -x
  file0=FILE_NONSAT
  file1=received_counts.html
  file2=selected_counts.html
  file3=assimilated_counts.html

 
# Remove satellite counts from the first file

  line1=`fgrep -n "Satellite Soundings"  $file0 | cut -c1-3` 
  line2=`fgrep -n "BR WP" $file0 | cut -c1-3 | head -1`
  let line2=line2-1


    echo -e "\n line1 = ${line1}   line2 = ${line2} \n"

  sed ${line1},${line2}d $file0 > temp


# Append 3 satellite data count files

  cat ${file1} >> temp
  cat ${file2} >> temp
  cat ${file3} >> temp

  cp temp temp.sav
  mv temp ${Month}_${YEAR}.html


###############################


  HTML="          <a href=\"${Month}_${YEAR}.html\">${Month}</a>"
    echo $HTML


# Backup the index file and make a temporary working copy

  cp $DATCOM1_IN/index.shtml $DATCOM1_OUT/index_backup.shtml
  cp $DATCOM1_IN/index.shtml temp

# We have option here to rebuild the gdas counts main page starting with 
# content from $FIXprepobs/gdascounts_base.shtml.  Before doing so,
# ensure the header and footer content that will surround the new table is
# the same as (or preferred to) that in the current index.shtml file.
if [[ "$REBUILD_MAINPAGE" == YES ]]; then

  export StartYr=2002
  export EndYr=$YEAR
  export LastMon_EndYr=$MM
  $USHprepobs/build_mainpage.sh
  err=$?
  if [[ $err -eq 0 ]]; then
    cp index.shtml temp2  # this may seem odd, but parent script expects temp2
  else
    echo -e  "\n *** WARNING:  Attempt to build mainpage from scratch failed... \n "
    exit 7
  fi

else

# update content of existing index.shtml file (as has been done for years)

# If this is January, load an empty calendar in the front of the index file 

# Insert below in index.shtml after </table> and then change as counts are added 
# for a given month.  Always save old index before modifying.  This will help to 
# eliminate the shoot in foot syndrome.  Eliminate these comments in new index.
#
  if [ $MON = JAN ]; then

#  However, only load new calendar for this year if one does not already exist.
#  (One mmight exist in the event of a rerun.  Note: Must update the following
#  $YEAR check if the format for the empty calendar changes below)
#
    if [ $(grep -c "<b>$YEAR</b>" temp) -eq 0 ]; then

cat << EOF  > newyear
    <center>
    <table width="600" border="1" cellpadding="6" cellspacing="0">
      <tr align="center" bgcolor="#ffcccc">
        <td colspan="6">
          <font size="+1"><b>YEAR</b></font>
        </td>
      </tr>
      <tr>
        <td width="17%">January</td>
        <td width="17%">February</td>
        <td width="16%">March</td>
        <td width="16%">April</td>
        <td width="17%">May</td>
        <td width="17%">June</td>
      </tr>
      <tr>
        <td width="17%">July</td>
        <td width="17%">August</td>
        <td width="16%">September</td>
        <td width="16%">October</td>
        <td width="17%">November</td>
        <td width="17%">December</td>
      </tr>
    </table>

EOF

#    sed 1,3d newyear > new1
#    sed s/YEAR/$YEAR/ new1 > new2

    sed s/YEAR/$YEAR/ newyear > new2

# note, the following head statement assumes prexisting format of html file 
# with calendar table starting at or just below line 15
    head -14 temp > new1

    cat new2 >> new1

    sed -n 15,\$p temp >> new1

    cp new1 temp
    else
      echo -e "\n *** Warning: A table with header $YEAR already existed ***\n"
    fi
  fi

  
# note the following check on "$MONTH</td>" must be in sync with table format
  line=`fgrep -n "$Month</td>" temp | head -1`
  if [ -n "$line" ]; then
  echo $line | IFS=":" read line_num dum

    echo -e "\n line = $line  line_num = ${line_num}"

# note the following pattern "$MONTH</td>" must be in sync with table format
  sed ${line_num}s/"$Month<\/td>"/""/ temp > temp1

  sed -n 1,${line_num}p temp1 > temp2

  echo "$HTML" >> temp2

  echo "        </td>" >> temp2

  let next=line_num+1

  last=`wc -l < temp1`

  sed -n ${next},${last}p temp1 >> temp2

  else  # a link for this month already exists. (this is likely a rerun).
   echo -e "\n *** Warning: Link for $Month already existed ***\n"
   cp temp temp2
  fi

set +x 
  exit

fi

#!/bin/bash
set -eua
#
#   This script originally written by Jack Woollen
#

[ $# -ne 5 ] && echo "$0 <siganl file> <cnvstat file> <prepbufr.in> <prepbufr.out> <date>"
[ $# -ne 5 ] && exit

siganl=$1 cnvstat=$2 prepbufr=$3 preppost=$4 date=$5

# fill in the analysis background with prevents

DATA=`pwd` # working directory 
PREP=prepbufr_in_old_post; cp $prepbufr $PREP
$SIGEVENTSH $PREP $date 

prepbufr=$PREP # prepbufr into new post is prepbufr out of old post

# now run the new postevents to layer on the gsi events

export HOMEcfs=${HOMEcfs:-/nwprod}
export cfss=${cfss:-/cfs}
export cfsp=${cfsp:-cfs_}
export DUPREPEXEC=${DUPREPEXEC:-$EXECcfs/${cfsp}duprep.x}
export COMBFRSH=${COMBFRSH:-$USHcfs/${cfsp}combfr.sh}

# setup the convstat or convnetc files

set -x

tar -xvf $cnvstat; gunzip -v  diag_conv_*

if [[ ${CONVNETC:-NO} = NO ]]; then
   export CNVDIAGEXEC=$EXECcfs/${cfsp}post_convdiag.x
   mv diag_conv_anl.* diag_conv_anl 
   mv diag_conv_ges.* diag_conv_ges 
else
   export CNVDIAGEXEC=$EXECcfs/${cfsp}post_convnetc.x
   for bak in ges anl  ; do
   for var in ps q t uv; do
   ln -sf diag_conv_${var}_${bak}.$CDATE.nc4  diag_conv_${bak}_${var}
   [[ -s diag_conv_${var}_${bak}.$CDATE.nc4 ]] || exit 99
   done; done
fi

#link the prepbufr input and run postevents

export FORT20=$prepbufr; ln -sf $FORT20 fort.20
time $CNVDIAGEXEC ###>stdout 2>&1
export err=$?; ##$DATA/err_chk

#combine the postevents outp messages together

cat preppost_* > prep_w_dups ; rm -f preppost_*

#run the duplicate elimination
#delxy=.005 # this is the lat/lon tolerance in degrees
#delhr=.001 # this is the ob time tolerance in hundredths of an hour
#delelv=1    # this is the elevation tolerance in meters
#
#echo prep_w_dups            >dupinp
#echo $preppost             >>dupinp
#echo $delxy $delhr $delelv >>dupinp
#cat dupinp|$DUPREPEXEC

cp prep_w_dups $preppost # disable the dup check

rm -f diag_conv_anl_* diag_conv_ges_* fort.*

#!/bin/ksh
export PS4=' + atcf_2_cxml.sh line $LINENO: '
set -x

########  J.Peng 2013-05-13   ##############################
pmodel=$1
ymdh=$2
COMvit=$3
JPDATA=$4
if [ ! -d ${JPDATA} ]; then mkdir -p ${JPDATA}; fi

JYYYY=`echo ${ymdh} | cut -c1-4`
JMM=`echo ${ymdh} | cut -c5-6`
JDD=`echo ${ymdh} | cut -c7-8`
JCYC=`echo ${ymdh} | cut -c9-10`
 
export JPCXML=${JPDATA}/${JYYYY}${JMM}/${JYYYY}${JMM}${JDD}
if [ ! -d ${JPCXML} ]; then mkdir -p ${JPCXML}; fi

vitalsfile=vitals.upd.gfsx.${ymdh}
cp ${COMvit}/$vitalsfile ${JPDATA}/
#----------------------------------------------------------------------------------------------------
if [ ${pmodel} = 'ens' ]; then
#  export DATAin=/com/gens/prod/gefs.${JYYYY}${JMM}${JDD}/${JCYC}/track
  export DATAin=${COMOUT}
  memblist="c00 p01 p02 p03 p04 p05 p06 p07 p08 p09 p10 \
                p11 p12 p13 p14 p15 p16 p17 p18 p19 p20"
  hurlist="01 02 03 04 05 06 07 08 09 10 \
           11 12 13 14 15 16 17 18 19 20 \
           21 22 23 24 25 26 27 28 29 30 \
	       31 32 33 34 35 36 37 38 39 40 \
           90 91 92 93 94 95 96 97 98 99"
  basinlist="AL EP WP CP SC EC AU SP SI BB AA"

  cd ${JPDATA}

  if [ -s $vitalsfile ]; then
    for memb in $memblist; do
      cp ${DATAin}/a${memb}.t${JCYC}z.cyclone.trackatcfunix trak.a${memb}.atcfunix.${ymdh}

      for basin in $basinlist; do
      for hur in $hurlist; do
        grep "${basin}, ${hur}" trak.a${memb}.atcfunix.${ymdh} | grep "XX,  34, NEQ" > a${memb}.${basin}${hur}.${ymdh}
      done
      done
      cat a${memb}.*.${ymdh} > trak.a${memb}.atcfunix.glob.${ymdh}
      rm -f a${memb}.*.${ymdh}

      . prep_step

      # Input file
      export FORT11=trak.a${memb}.atcfunix.glob.${ymdh}
      export FORT31=$vitalsfile

      # Output file
      export FORT66=trak.a${memb}.atcf_gen.glob.${ymdh}

      ${EXECens_tracker}/track_convert
      export err=$?; err_chk

      mv $FORT66 ${JPCXML}
    done
  else
    echo "WARNING: $vitalsfile not found... perhaps due to lack of storms."
  fi

  ${USHens_tracker}/atcf2xml.pl --date ${ymdh} --model GEFS --basin glob --atcf_dir ${JPDATA} --cxml_dir ${JPDATA}
  export err=$?; err_chk

  cp ${JPCXML}/kwbc_${ymdh}0000_GEFS_glob_prod_esttr_glo.xml ${COMOUT}/

  if [ "$SENDDBN" = 'YES' ]; then
     $DBNROOT/bin/dbn_alert MODEL ENS_TRACKER $job ${COMOUT}/kwbc_${ymdh}0000_GEFS_glob_prod_esttr_glo.xml
  fi

#  rm -rf ${JPDATA}/*

#----------------------------------------------------------------------------------------------------
elif [ ${pmodel} = 'gfs' ]; then
  export DATAin=${COMOUT}
  memblist="gfsx"
  hurlist="01 02 03 04 05 06 07 08 09 10 \
           11 12 13 14 15 16 17 18 19 20 \
           21 22 23 24 25 26 27 28 29 30 \
           31 32 33 34 35 36 37 38 39 40 \
           90 91 92 93 94 95 96 97 98 99"
  basinlist="AL EP WP CP SC EC AU SP SI BB AA"

  cd ${JPDATA}

  if [ -s $vitalsfile ]; then
    for memb in $memblist; do
      cp ${DATAin}/gfsx.t${cyc}z.cyclone.trackatcfunix trak.${memb}.atcfunix.${ymdh}

      for basin in $basinlist; do
      for hur in $hurlist; do
        grep "${basin}, ${hur}" trak.${memb}.atcfunix.${ymdh} | grep "XX,  34, NEQ" > ${memb}.${basin}${hur}.${ymdh}
      done
      done
      cat ${memb}.*.${ymdh} > trak.${memb}.atcfunix.glob.${ymdh}
      rm -f ${memb}.*.${ymdh}

      . prep_step

      # Input files
      export FORT11=trak.${memb}.atcfunix.glob.${ymdh}
      export FORT31=$vitalsfile

      # Output file
      export FORT66=trak.${memb}.atcf_gen.glob.${ymdh}

      ${EXECens_tracker}/track_convert
      export err=$?; err_chk
      mv $FORT66 ${JPCXML}
    done
  else
    echo "WARNING: $vitalsfile not found... perhaps due to lack of storms."
  fi

  ${USHens_tracker}/atcf2xml.pl --date ${ymdh} --model GFS --basin glob --atcf_dir ${JPDATA} --cxml_dir ${JPDATA}
  export err=$?; err_chk

  cp ${JPCXML}/kwbc_${ymdh}0000_GFS_glob_prod_sttr_glo.xml ${COMOUT}/

  if [ "$SENDDBN" = 'YES' ]; then
    $DBNROOT/bin/dbn_alert MODEL ENS_TRACKER $job ${COMOUT}/kwbc_${ymdh}0000_GFS_glob_prod_sttr_glo.xml
  fi

#  rm -rf ${JPDATA}/*

#----------------------------------------------------------------------------------------------------
elif [ ${pmodel} = 'cens' ]; then
#  export DATAin=/com/gens/prod/cmce.${JYYYY}${JMM}${JDD}/${JCYC}/track
  export DATAin=${COMOUT}
  memblist="c00 p01 p02 p03 p04 p05 p06 p07 p08 p09 p10 \
                p11 p12 p13 p14 p15 p16 p17 p18 p19 p20"
  hurlist="01 02 03 04 05 06 07 08 09 10 \
           11 12 13 14 15 16 17 18 19 20 \
           21 22 23 24 25 26 27 28 29 30 \
           31 32 33 34 35 36 37 38 39 40 \
           90 91 92 93 94 95 96 97 98 99"
  basinlist="AL EP WP CP SC EC AU SP SI BB AA"

  cd ${JPDATA}

  if [ -s $vitalsfile ]; then
    for memb in $memblist; do
      cp ${DATAin}/c${memb}.t${JCYC}z.cyclone.trackatcfunix trak.c${memb}.atcfunix.${ymdh}

      for basin in $basinlist; do
      for hur in $hurlist; do
        grep "${basin}, ${hur}" trak.c${memb}.atcfunix.${ymdh} | grep "XX,  34, NEQ" > c${memb}.${basin}${hur}.${ymdh}
      done
      done
      cat c${memb}.*.${ymdh} > trak.c${memb}.atcfunix.glob.${ymdh}
      rm -f c${memb}.*.${ymdh}

      . prep_step

      # Input files
      export FORT11=trak.c${memb}.atcfunix.glob.${ymdh}
      export FORT31=$vitalsfile

      # Output file
      export FORT66=trak.c${memb}.atcf_gen.glob.${ymdh}

      ${EXECens_tracker}/track_convert
      export err=$?; err_chk

      mv $FORT66 ${JPCXML}
    done
  else
    echo "WARNING: $vitalsfile not found... perhaps due to lack of storms."
  fi

  ${USHens_tracker}/atcf2xml.pl --date ${ymdh} --model CENS --basin glob --atcf_dir ${JPDATA} --cxml_dir ${JPDATA}
  export err=$?; err_chk

  cp ${JPCXML}/kwbc_${ymdh}0000_CENS_glob_prod_esttr_glo.xml ${COMOUT}/

  if [ "$SENDDBN" = 'YES' ]; then
    $DBNROOT/bin/dbn_alert MODEL ENS_TRACKER $job ${COMOUT}/kwbc_${ymdh}0000_CENS_glob_prod_esttr_glo.xml  
  fi

#  rm -rf ${JPDATA}/*

#----------------------------------------------------------------------------------------------------
elif [ ${pmodel} = 'cmc' ]; then
  export DATAin=${COMOUT}
  memblist="cmc"
  hurlist="01 02 03 04 05 06 07 08 09 10 \
           11 12 13 14 15 16 17 18 19 20 \
           21 22 23 24 25 26 27 28 29 30 \
           31 32 33 34 35 36 37 38 39 40 \
           90 91 92 93 94 95 96 97 98 99"
  basinlist="AL EP WP CP SC EC AU SP SI BB AA"

  cd ${JPDATA}

  if [ -s $vitalsfile ]; then
    for memb in $memblist; do
      cp ${DATAin}/${memb}.t${JCYC}z.cyclone.trackatcfunix trak.${memb}.atcfunix.${ymdh}

      for basin in $basinlist; do
      for hur in $hurlist; do
        grep "${basin}, ${hur}" trak.${memb}.atcfunix.${ymdh} | grep "XX,  34, NEQ" > ${memb}.${basin}${hur}.${ymdh}
      done
      done
      cat ${memb}.*.${ymdh} > trak.${memb}.atcfunix.glob.${ymdh}
      rm -f ${memb}.*.${ymdh}

      . prep_step

      # Input files
      export FORT11=trak.${memb}.atcfunix.glob.${ymdh}
      export FORT31=$vitalsfile

      # Output file
      export FORT66=trak.${memb}.atcf_gen.glob.${ymdh}

      ${EXECens_tracker}/track_convert
      export err=$?; err_chk

      mv $FORT66 ${JPCXML}
    done
  else
    echo "WARNING: $vitalsfile not found... perhaps due to lack of storms."
  fi
 

  ${USHens_tracker}/atcf2xml.pl --date ${ymdh} --model CMC --basin glob --atcf_dir ${JPDATA} --cxml_dir ${JPDATA}
  export err=$?; err_chk

  cp ${JPCXML}/kwbc_${ymdh}0000_CMC_glob_prod_sttr_glo.xml ${COMOUT}/

  if [ "$SENDDBN" = 'YES' ]; then
    $DBNROOT/bin/dbn_alert MODEL ENS_TRACKER $job ${COMOUT}/kwbc_${ymdh}0000_CMC_glob_prod_sttr_glo.xml
  fi

#  rm -rf ${JPDATA}/*

fi

#!/bin/ksh
#####################################################################
echo "----------------------------------------------------------"
echo "exdump_post.sh version $obsproc_ver - If requested:       "
echo "       1) Generates combined dump STATUS file             "
echo "       2) Prepares data counts for the SDM                "
echo "       3) Removes or masks restricted data from today's   "
echo "          dump files                                      "
echo "       4) Removes restricted data from 2-day old aircar   "
echo "          and aircft dump files                           "
echo "       5) Converts dump files to unblocked format         "
echo "          (meaningless on WCOSS)                          "
echo "       6) Lists the contents of dump files                "
echo "       7) Updates dump data count average tables          "
echo "----------------------------------------------------------"
#####################################################################
#
# modification history:
# Mar 29 2000 - Original script (Keyser)
# Jul 16 2003 - Added step to remove or mask restricted 
#                 data (Keyser)
# MAR 01 2006 - Moved step to do data counts here (was in 
#                 dump job) (Keyser)
# OCT 15 2011 - RAP replaces RUC (Keyser)
# 12 Mar 2013 JWhiting - ported to WCOSS (linux) platforms:
#       cp'd fr CCS ver of 1 May 2012
#       renamed (sms -> ecf)
#       updated docblock
#       set to run under ksh (sh is bash on WCOSS)
#       updated logical unit specification (FORT* in place of XLF*)
#       replaced "timex" w/ "time -p"
# 15 Mar 2013 Keyser - remove RUCS
# 28 Apr 2014 JWhiting - config'd for Vertical Structure (VS)
#  1 May 2014          - enabled urma network
#  2 Feb 2015 Keyser   - Added new dump type "efclam" to list of dump types
#                        whose files that can potentially be unblocked.
# 10 Jan 2016 Keyser   - Added "NC004011" and "NC004103" in dump file
#                        "aircft" and "NC021242" in (just added) dump file
#                        "saphir" to the list of Table A entries for BUFR
#                        messages which contain all restricted reports in
#                        BUFR_REMOREST processing.
# 26 Mar 2017 Stokes   - Updated to run on Cray-XC40 as well as IBM iDataPlex.
#                      - Added MPMD methods to run lister threads in parallel
#                        and eliminated use of common background processes.
#                      - If creating combined dump status file, send to $COMOUT
#                        rather than $COMIN.
# 22 May 2018 Melchior - Updated to run on Dell-p3 as well as Cray-XC40 and
#                        IBM iDataPlex.
# 13 Jan 2020 SPA SH   - turn off alert of gdas.tCCz.saphir.tm00.bufr_d.nr
#                        per Dataflow/customer request
# 20 Aug 2020 Melchior - Added "NC000100" in dump file "adpsfc" to the list of
#                        Table A entries for BUFR messages which contain all
#                        restricted reports in BUFR_REMOREST processing.
#                        Added explicit path to thread, to become $DATA/thread.
# 21 Oct 2020 Melchior - Modified to include gpsro (NC003010) to remove the
#                        restricted data from gpsro dump file, which now
#                        includes commercial data. Alerts for nr gpsro dump
#                        files are not enabled for RAP and CDAS networks.
# 26 Jan 2021 Melchior - Added "NC001101" in dump file "sfcshp" to the list of
#                        Table A entries for BUFR messges which contain all
#                        restricted reports in BUFR_REMOREST processing, but
#                        whose reports are retained and instead station IDs
#                        are masked.
# 09 Dec 2021 Esposito - Updated for use on WCOSS2.
# ?? ??? 202? Keyser   - Added new "remorest" processing to remove restricted
#                        data from 2-day old "aircar" and "aircft" dump files.
#####################################################################

# NOTE: NET is changed to gdas in the parent Job script for the gdas RUN
#       (was gfs - NET remains gfs for gfs RUN)
# -----------------------------------------------------------------------

set -aux

# Make sure we are in the $DATA directory
cd $DATA

jlogfile=${jlogfile:=""}

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"
 
#  determine local system name and type if available
#  -------------------------------------------------
SITE=${SITE:-""}

cat break > $pgmout

PROCESS_REMOREST_dm2=${PROCESS_REMOREST_dm2:-NO}
MPMD=${MPMD:-YES}
CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}
UPDATE_AVERAGE_FILE=${UPDATE_AVERAGE_FILE:-YES}

hr_fraction=""
set +u
if [ -n "$cycM" ]; then
set -u
  case "$cycM" in
    00) hr_fraction='.00' ;;
    15) hr_fraction='.25' ;;
    30) hr_fraction='.50' ;;
    45) hr_fraction='.75' ;;
     *) err_xd=9
        msg="###FATAL ERROR in model script: incorrect cycM='${cycM}' - exiting"
        echo "$msg"
        postmsg "$jlogfile" "$msg"
        exit $err_xd ;;
  esac
fi

tmhr=`echo $tmmark|cut -c3-4`
export dumptime=`$NDATE -$tmhr $PDY$cyc`$hr_fraction
export dumptime10=`$NDATE -$tmhr $PDY$cyc`

net=$NET

[[ $RUN == rap_p ]]  &&  net=$RUN
[[ $RUN == rap_e ]]  &&  net=$RUN

net_uc=$(echo $net | tr [a-z] [A-Z])
set +u
[ -n "$cycM" ]  &&  net_uc=RTMA_RU
set -u
tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="$net_uc ANALYSIS TIME IS $PDY$cyc"
set +u
[ -n "$cycM" ]  &&  msg="$msg:${cycM}"
set -u
$DATA/postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR $tmmark_uc $net_uc IS $dumptime"
echo
set -x
 
retcode=0


########################################################################
#    Generate a "combined" dump STATUS file if one is not yet present  #
#     use STATUS files from TWO (SPLIT) dump jobs if they are present  #
########################################################################


if [ ! -s $COMIN/$RUN.$cycle.status.$tmmark.bufr_d ]; then

   file1=$COMIN/$RUN.$cycle.status1.$tmmark.bufr_d
   file2=$COMIN/$RUN.$cycle.status2.$tmmark.bufr_d

   if [ -s $file1 -a -s $file2 ]; then
      mcountp1=`grep -n "##################################################\
#############################" $file1 | cut -f1 -d:`
      head -n `expr $mcountp1 - 3` $file1 > status1
      mcount=`grep -n "PARENT SCRIPT IS" status1 | cut -f1 -d:`
      head -n $mcount status1 > top_part
      mcount=`expr \`cat <status1 | wc -l\` - $mcount`
      tail -n $mcount status1 > bottom_part
      grep "PARENT SCRIPT IS" $file2 > insert
      cat top_part insert bottom_part > status1
      mcount=`grep -n "THIS STATUS FILE CREATED" status1 | cut -f1 -d:`
      total=`cat <status1 | wc -l`
      head -n `expr $mcount - 1` status1 > top_part
      tail -n `expr $total - $mcount` status1 > bottom_part
      echo "             THIS STATUS FILE CREATED `date -u`" > insert
      cat top_part insert bottom_part > status1
      mcount=`grep -n "GEOGRAPHICAL DOMAIN IS DATA GROUP DEPENDENT" $file2 \
       | cut -f1 -d:`
      total2=`cat <$file2 | wc -l`
      tail -n `expr $total2 - $mcount - 1` $file2 > bottom_part
      mcount=`grep -n "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\
%%%%%%%%%%%%%%%%%%%%%%%%%%%" bottom_part | cut -f1 -d:`
      head -n `expr $mcount - 1` bottom_part > insert
      cat status1 insert > status
      total1=`cat <$file1 | wc -l`
      tail -n `expr $total1 - $mcountp1 - 2` $file1 > bottom_part
      cat status bottom_part > status1
      mcount=`grep -n " ++++ SPECIFIC INFORMATION ON EACH DATA GROUP DUMP \
++++" $file2 | cut -f1 -d:`
      tail -n `expr $total2 - $mcount - 1` $file2 > bottom_part
      cat status1 bottom_part > $COMOUT/$RUN.$cycle.status.$tmmark.bufr_d
      rm $file1 $file2 bottom_part insert status status1 top_part
   elif [ -s $file1 ]; then
      cp $file1 $COMOUT/$RUN.$cycle.status.$tmmark.bufr_d
      rm $file1
      msg="***WARNING: DUMP status file successfully generated but only from \
dump status1 file - dump status2 file not present"
      $DATA/postmsg "$jlogfile" "$msg"
   elif [ -s $file2 ]; then
      cp $file2 $COMOUT/$RUN.$cycle.status.$tmmark.bufr_d
      rm $file2
      msg="***WARNING: DUMP status file successfully generated but only from \
dump status2 file - dump status1 file not present"
      $DATA/postmsg "$jlogfile" "$msg"
   fi
   msg="DUMP status file successfully generated"
   $DATA/postmsg "$jlogfile" "$msg"
fi



########################################################################
#                  Prepare Data Counts for the SDM                     #
########################################################################

[ "$PROCESS_DATACOUNTS" = 'YES' ]  &&  $USHobsproc/bufr_datacount.sh



if [ "$PROCESS_REMOREST" = 'YES' ]; then

########################################################################
#   Remove or Mask Restricted Data from today's BUFR Data Dump Files   #
########################################################################

#  For dump files "adpsfc", "aircar", "aircft", "msonet", "lghtng" and "sfcshp"
#  for today (this network, run and cycle):
#  If either the restriction indicator (mnemonic RSRD) is set for a report, or
#  the report is in a Table A entry pre-determined to contain only restricted
#  reports, then the report is always restricted {regardless of the time in
#  hours for the expiration on restriction (mnemonic EXPRSRD)}.
#    ---> Since we are running in near-realtime, there is no need to test on
#         the value of EXPRSRD.  This will always be > current time difference.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_RESTR" (see below):
#            All reports are considered to be restricted by definition of this
#            switch. They will be skipped by program BUFR_REMOREST.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MIXED" (see below):
#            RSRD may not be set for all reports. Those with RSRD set are
#            considered to be restricted regardless of EXPRSRD because
#            "DIFF_HR" (the difference in hours between the current UTC wall-
#            clock date and the dump file center date),is exported as 0 into
#            program BUFR_REMOREST (EXPRSRD will always be > actual DIFF_HR
#            since we are running in near-realtime).  They will be skipped by
#            program BUFR_REMOREST.  Those reports that do not have RSRD set
#            are considered to be non-restricted and will be retained by
#            program BUFR_REMOREST.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MASKA" (see below):
#            All reports are considered to be restricted by definition of this
#            switch.  Reports are not removed but all occurrences of their
#            report ids are unilaterally masked out by program BUFR_REMOREST.
#            In addition, program BUFR_REMOREST re-sets their values for RSRD
#            and EXPRSRD to missing so that the reports are no longer
#            considered to be restricted.
# -----------------------------------------------------------------------------

   msg="REMOVE OR MASK RESTRICTED DATA FROM $tmmark_uc $net_uc DATA DUMPS \
CENTERED ON $dumptime"
   $DATA/postmsg "$jlogfile" "$msg"

   export DIFF_HR=0

cat <<\EOFparm > bufr_remorest.datadump.parm
=========================================================================

  Cards for DUMP Version of BUFR_REMOREST -- Version 18 November 202?

 &SWITCHES
   MSG_RESTR = 'NC000000',   ! These are the Table A Entries for BUFR messages
               'NC000100',   !  for which ALL reports are considered to be
               'NC004003',   !  restricted. All reports will be REMOVED by
               'NC004004',   !  program BUFR_REMOREST.
	       'NC004006',   !  (up to 20 Tabel A entries)
               'NC004007',
               'NC004008',
               'NC004009',
               'NC004010',
               'NC004011',
               'NC004012',
               'NC004013',
               'NC004103',
               'NC007001',
               'NC007002',
               'NC021242',
               'NC255xxx',   ! move this to MSG_MIXED when we know for sure that RSRD values are correct for each provider/sub-provider
   MSG_MIXED = 'NC012004',   ! These are the Table A Entries for BUFR messages
               'NC003010',   !  which may contain a MIXTURE of reports with and
               '        ',   !  without mnemonic "RSRD" being set. If "RSRD" is
               '        ',   !  not set -or- it is set and mnemonic "EXPRSRD"
               '        ',   !  is also set and has a value less than "DIFF_HR"
               '        ',   !  (the difference in hrs between the current UTC
	       '        ',   !  wall-clock date and the dump file center date)
               '        ',   !  minus 4, the report will be RETAINED by program
               '        ',   !  BUFR_REMOREST. Otherwise, it will be REMOVED by
               '        ',   !  program BUFR_REMOREST.
               '        ',   !  (up to 20 Tabel A entries)
               '        ',
   MSG_MASKA = 'NC001001',   ! These are the Table A Entries for BUFR messages
               'NC001101'    !  for which ALL reports are considered to be 
                             !  restricted.  They will not be removed, but all
                             !  occurrences of their report ids will be
                             !  unilaterally CHANGED, by program BUFR_REMOREST,
                             !  to either "MASKSTID" (where the id is stored by
                             !  itself)  or to all "X"'s where the number of
                             !  "X"'s corresponds to the number of characters
                             !  in the original report id (where the id is
                             !  embedded in the raw report bulletin header
                             !  string). In addition, program BUFR_REMOREST re-
                             !  sets their values for "RSRD" and "EXPRSRD" to
                             !  missing so that the reports are no longer
                             !  considered to be restricted.
                             !  (up to 20 Table A entries)

 /

    Note 1: A particular Table A entry should NEVER appear in more than one of
            MSG_RESTR, MSG_MIXED or MSG_MASKA.
    Note 2: Any Table A entry not in either MSG_RESTR, MSG_MIXED or MSG_MASKA
            is assumed to be a Table A entry for BUFR messages for which ALL
            reports are NON-RESTRICTED (these messages are copied intact, no
            reports are unpacked).
    Note 3: Always fill in these arrays beginning with word 1.  If there are
            less than 20 words filled in an array, either set the extra words
            to "        " (8 blank characters) or do not specify them here
            (they default to "        ").
    Note 4: For data dump Table A entries in the form "NCtttsss", where "ttt"
            is the BUFR message type and "sss" is the BUFR message subtype, if
            the last three characters (the subtype) is specified as 'xxx', then
            ALL BUFR messages of that type are either treated as having all
            restricted data all which is to be removed (if in MSG_RESTR), mixed
            data some of which is to be removed (if in MSG_MIXED) or all
            restricted data all of which is to have its report id masked (if in
            MSG_MASKA), regardless of the message subtype. (For example, if
            MSG_RESTR(1)='NC255xxx', then ALL mesonet BUFR messages are
            considered to have all restricted data and are all removed
            regardless of their subtype.)

=========================================================================
EOFparm

   REMX=${REMX:-$EXECobsproc/bufr_remorest}
   REMC=${REMC:-bufr_remorest.datadump.parm}

   for file in adpsfc aircar aircft msonet sfcshp lghtng gpsipw saphir gpsro
   do
      filestem=$RUN.$cycle.$file.$tmmark.bufr_d
      [ -f $COMIN/$filestem ]  ||  continue

      cp $COMIN/$filestem $filestem

      $USHobsproc/bufr_remorest.sh $filestem
      rc=$?
      if [ $rc -gt 0 ] ; then
         [ $rc -gt $retcode ]  && retcode=$rc
         msg="**WARNING: ERROR generating non-restricted $file BUFR file \
(rc = $rc)"
         $DATA/postmsg "$jlogfile" "$msg"
      else
         msg="Successful generation of non-restricted $file BUFR file"
         $DATA/postmsg "$jlogfile" "$msg"
         cp $filestem $COMOUT/$filestem.nr
         chmod 664 $COMOUT/$filestem.nr
	 if [ "$SENDDBN" = "YES" ] ; then
           NETUP=`echo $RUN | tr {a-z} {A-Z}`
           if  [[ $NETUP != 'GDAS' ]] || [[ $file != "saphir" ]]; then    ### no alert gdas.tCCz.saphir.tm00.bufr_d.nr 
             if [[ $NETUP != 'CDAS' ]] || [[ $file != "gpsro" ]]; then    ### no alert cdas.tCCz.gpsro.tm00.bufr_d.nr
               if [[ $NETUP != 'RAP' ]] || [[ $file != "gpsro" ]]; then   ### no alert rap.tCCz.gpsro.tm00.bufr_d.nr
                  $DBNROOT/bin/dbn_alert MODEL ${NETUP}_BUFR_${file}_nr $job \
                  $COMOUT/$filestem.nr
	       fi
             fi
           fi
         fi
      fi

   done

fi #  endif loop $PROCESS_REMOREST


# PROCESS_REMOREST_dm2 = YES runs only on demand, on dev machines
# Unrestrict 48h old aircraft obs(exc. TAMDAR), add *.ur file to $COMOUTm2 
dev_m=$(grep backup /lfs/h1/ops/prod/config/prodmachinefile | cut -d: -f2)
this_m=$(cat /etc/cluster_name)

if [ $PROCESS_REMOREST_dm2 = YES -a $this_m = $dev_m ]; then
########################################################################
#     Remove Restriction on Data in 2-day old "aircar" and "aircft"    #
#                         BUFR Data Dump files                         #
########################################################################

#  For dump files "aircar" and "aircft" for 2-days ago (this network, run and
#  cycle):
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MIXED" (see below):
#            If the restriction indicator (mnemonic RSRD) is set for a report,
#            then its value for time in hours for the expiration on restriction
#            (mnemonic EXPRSRD) is examined. If "DIFF_HR" (the difference in
#            hours between the current UTC wall-clock date and the dump file
#            center date, exported into program BUFR_REMOREST) minus 4 is less
#            than or equal to EXPRSRD, then the report is considered to be
#            restricted and will be skipped by program BUFR_REMOREST.
#            Otherwise, the report is considered to be non-restricted and will
#            be retained by program BUFR_REMOREST.
#    ---> Since we are running 2-days late, we want to test on the value of
#         EXPRSRD (which currently should be set to 48 hours for any reports in
#         these dumps which have RSRD set).  This will allow non-rstprod users
#         to have access to full "aircar" and "aircft" dumps after EXPRSRD + 4
#         (52) hours.
# -----------------------------------------------------------------------------

   dumptimeM2=`$NDATE -$tmhr $PDYm2$cyc`

   msg="REMOVE OR MASK RESTRICTED DATA FROM $tmmark_uc $net_uc DATA DUMPS \
CENTERED ON $dumptimeM2 (2-days ago)"
   $DATA/postmsg "$jlogfile" "$msg"

   ymdh=$(date -u +'%Y%m%d%H')
   export DIFF_HR=`$NHOUR $ymdh            $dumptimeM2`
#                         current_date       dump_date

   msg="Any reports with EXPRSRD less than `expr $DIFF_HR - 4 ` hrs will now \
be retained"
   $DATA/postmsg "$jlogfile" "$msg"

cat <<\EOF_EXPRSRDparm > bufr_remorest.datadump_EXPRSRD.parm
=========================================================================

  Cards for DUMP Version of BUFR_REMOREST -- Version 1.1.0 (09 September 2015)
  (documentation in bufr_remorest.datadump.parm above for $PROCESS_REMOREST
   also applies here)

 &SWITCHES
   MSG_RESTR = '        ',
   MSG_MIXED = 'NC004003',
               'NC004004',
               'NC004006',
               'NC004007',
               'NC004008',
               'NC004009',
               'NC004010',
               'NC004011',
               'NC004012',
               'NC004013',
               'NC004014',
               'NC004015',
               'NC004103',
   MSG_MASKA = '        '

 /

=========================================================================
EOF_EXPRSRDparm

   REMX=${REMX:-$EXECobsproc_shared_bufr_remorest/bufr_remorest}
   REMC=${REMC_EXPRSRD:-bufr_remorest.datadump_EXPRSRD.parm}

   for file in aircar aircft
   do
      filestem=$RUN.$cycle.$file.$tmmark.bufr_d
      [ -f $COMINm2/$filestem ]  ||  continue

      cp $COMINm2/$filestem $filestem

      $USHobsproc/bufr_remorest.sh $filestem
      rc=$?
      if [ $rc -gt 0 ] ; then
         [ $rc -gt $retcode ]  && retcode=$rc
         msg="**WARNING: ERROR generating non-restricted $file BUFR file \
from 2-days ago (rc = $rc) -- existing file made 2-days ago is not overwritten"
         $DATA/postmsg "$jlogfile" "$msg"
      else
         msg="Successful generation of non-restricted $file BUFR file from \
2-days ago -- overwrite existing file made 2-days ago"
         $DATA/postmsg "$jlogfile" "$msg"
         cp $filestem $COMOUTm2/$filestem.ur
         chmod 664 $COMOUTm2/$filestem.ur
	 if [ $SENDDBN = "YES" ] ; then
             NETUP=`echo $RUN | tr {a-z} {A-Z}`           # can this be net_uc?
             $DBNROOT/bin/dbn_alert MODEL ${NETUP}_BUFR_${file}_nr $job \
             $COMOUTm2/$filestem.ur 
	 fi
      fi

   done

fi #  endif loop $PROCESS_REMOREST_dm2


if [ "$PROCESS_UNBLKBUFR" = 'YES' ]; then

   msg="START THE UNBLOCKING OF $tmmark_uc $net_uc DATA DUMPS CENTERED ON \
$dumptime"
   $DATA/postmsg "$jlogfile" "$msg"

########################################################################
#                  Unblock BUFR Data Dump Files                        #
# {Note: will also unblock non-restricted aircar and aircft dump files #
#        from 2-days ago if they were overwritten in REMOREST above    #
#        (when $PROCESS_REMOREST_dm2 = YES)}                           #
# ---> ON WCOSS dump files are already unblocked, so this whole set of #
#      processing can hopefully be removed someday!!                   #
########################################################################

   aircraft_nr_dm2=""
   [ $PROCESS_REMOREST_dm2 = YES -a $this_m = $dev_m ] && \
    aircraft_nr_dm2="aircar_nr_dm2 aircft_nr_dm2"

   for file in adpsfc adpupa aircar aircft satwnd sfcshp spssmi proflr \
               vadwnd goesnd erscat sfcbog erswnd ssmip  ssmipn ssmit  \
               atovs  qkscat qkswnd trmm   sptrmm geoimr 1bamua 1bamub \
               1bhrs3 1bmhs  1bhrs4 airs   airswm amsre  gpsipw msonet \
               rassda nexrad gpsro  airsev goesfv wndsat wdsatr osbuv8 \
               ascatt ascatw mtiasi avcsam avcspm gome   lghtng omi    \
               esamua esamub eshrs3 esmhs  ssmisu sevcsr lgycld efclam \
	       $aircraft_nr_dm2
#  --> don't add any new dumps here since files are already unblocked
#      on WCOSS!!

   do
      file_orig=$file
      if [ $PROCESS_REMOREST_dm2 = YES -a $this_m = $dev_m ]; then
	 if [ $file = aircar_nr_dm2 -o $file = aircft_nr_dm2 ]; then
            file=`echo $file | cut -d"_" -f1`
	    COMIN_save=$COMIN
	    COMIN=$COMINm2
	    COMOUT_save=$COMOUT
	    COMOUT=$COMOUTm2
	 fi
      fi
      for qual in "" ".nr"
      do
	 [ \( $file_orig = aircar_nr_dm2 -o $file_orig = aircft_nr_dm2 \) -a \
	    "$qual" != .nr ] && continue
         qualdbn=$qual
         COMIN_here=$COMIN
         if [ "$qual" = .nr ]; then
            qualdbn=_nr
            COMIN_here=$COMOUT
         fi
         filestem=$RUN.$cycle.$file.$tmmark.bufr_d
         [ -f $COMIN_here/$filestem$qual ]  ||  continue

         cp $COMIN_here/$filestem$qual $file.$qual

# ---> ON WCOSS dump files are already unblocked, so for now just copy each one
#      to the unblok file location used before on CCS - hopefully this can be
#      removed someday!

         cp -p $file.$qual $file.unblock$qual >> $pgmout 2>&1
         rc=$?
         if [ $rc -gt 0 ] ; then
            [ $rc -gt $retcode ]  && retcode=$rc
            msg="**WARNING: ERROR copying $file$qual BUFR file to \
$file.unblock$qual (rc = $rc)"
            $DATA/postmsg "$jlogfile" "$msg"
         else
            if [ $file_orig = aircar_nr_dm2 -o $file_orig = aircft_nr_dm2 ];then
	       msg="$file$qual BUFR file from 2-days ago SUCCESSFULLY copied \
to $file.unblock$qual -- overwrite existing file made 2-days ago"
            else
               msg="$file$qual BUFR file SUCCESSFULLY copied to $file.unblock$qual"
	    fi
            $DATA/postmsg "$jlogfile" "$msg"
            cp $file.unblock$qual $COMOUT/$filestem.unblok$qual
            chmod 664 $COMOUT/$filestem.unblok$qual
            if [ "$SENDDBN" = "YES" ] ; then
              NETUP=`echo $RUN | tr {a-z} {A-Z}`

######################################################################
##  DO NOT alert unblocked gpsipw dump file (either restricted or   ##
##  non-restricted) until DATAFLOW adds alert types                 ##
##  ${NETUP}_BUFR_gpsipw_unblok and ${NETUP}_BUFR_gpsipw_unblok.nr  ##
######################################################################
              if [ $file != "gpsipw" ]; then
                $DBNROOT/bin/dbn_alert MODEL \
                 ${NETUP}_BUFR_${file}_unblok${qualdbn} $job \
                 $COMOUT/$filestem.unblok$qual
              fi
            fi
            if [ "$CHGRP_RSTPROD" = 'YES' ]; then
               if [ "$qual" != .nr ]; then
                  if [ -s $COMOUT/$filestem.nr ]; then
                     chgrp rstprod $COMOUT/$filestem.unblok$qual
                     errch=$?
                     if [ $errch -eq 0 ]; then
                        chmod 640 $COMOUT/$filestem.unblok$qual
                        msg="NOTE: \"unblocked\" (now really just copied) \
$file file contains RESTRICTED data, only users in rstprod group have read \
permission"
                        $DATA/postmsg "$jlogfile" "$msg"
                        echo " "
                        echo "$msg"
                        echo " "
                     else
                        cp /dev/null $COMOUT/$filestem.unblok$qual
                        msg="**WARNING: \"unblocked\" (now really just copied) \
$file file contains RESTRICTED data, since user $USER is not in rstprod group \
a null file is copied in its place"
                        $DATA/postmsg "$jlogfile" "$msg"
                        echo " "
                        echo "$msg"
                        echo " "
                     fi
                  fi
               fi
            fi
         fi

      done
      if [ $PROCESS_REMOREST_dm2 = YES -a $this_m = $dev_m ]; then
	 if [ $file_orig = aircar_nr_dm2 -o $file_orig = aircft_nr_dm2 ]; then
            COMIN=$COMIN_save
	    COMOUT=$COMOUT_save
	 fi
      fi

   done

fi #  endif loop $PROCESS_UNBLKBUFR



if [ "$PROCESS_LISTERS" = 'YES' ]; then

   msg="START THE LISTING OF $tmmark_uc $net_uc DATA DUMPS CENTERED ON \
$dumptime"
   $DATA/postmsg "$jlogfile" "$msg"

   retr=TRUE
   [ "$NET" = 'gfs' -o "$NET" = 'gdas' ]  &&  retr=FALSE
   radn=TRUE
   [ "$NET" = 'rap' ]  &&  radn=FALSE

   cat << EOFlistdumps > parms
 &PDATA
  IDAT10 = $dumptime10, IWINDE = -3, IWINDL = +2, IPRINT = 0,
  SNDG = FALSE, RETR = $retr, RADN = $radn
 /
EOFlistdumps

   cat <<\EOFthread > $DATA/thread
#VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
#  Herefile "thread" which can run in parallel (via MPMD methods) to list dumps
#VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
{ echo
      set -x
      mkdir -p $DATA/thread${1}
      cd $DATA/thread${1}
      file=$2
      filestem=$3

      cp $COMIN/$filestem $file

      cat <<EOFc > parms1
 &RDATA
  DSNAME_LC = "$file  "
 /
EOFc

      cat parms1 $DATA/parms > parms

      pgm=`basename  $LSTX`
      export pgm
      . $DATA/prep_step

      echo "  for $file BUFR file" >> $DATA/thread${1}/$pgmout

      unset FORT00 `env | grep "FORT[0-9]\{1,\}" | awk -F= '{print $1}'`
      export FORT21=$file

      time -p $LSTX < parms > $file.listing 2> errfile
      errlst=$?
      echo "$errlst" > $DATA/error${1}
      cp $file.listing $COMOUT/$filestem.listing
      chmod 664 $COMOUT/$filestem.listing
      cat errfile >> $DATA/thread${1}/$pgmout
      if [ "$errlst" -ne '0' ]; then
         set +x
         echo
         echo \
" ---------------------------------------------------------------------------"
         echo \
" ********** ERROR IN PROGRAM BUFR_LISTDUMPS for $file BUFR file **********"
         echo \
" ---------------------------------------------------------------------------"
         echo
         set -x
         msg="*WARNING: Program BUFR_LISTDUMPS DID NOT complete successfully \
for $file BUFR file (rc = $errlst)"
         $DATA/postmsg "$jlogfile" "$msg"
      else
         set +x
         echo
         echo \
" ---------------------------------------------------------------------------"
         echo \
" ********** COMPLETED PROGRAM BUFR_LISTDUMPS for $file BUFR file **********"
         echo \
" ---------------------------------------------------------------------------"
         echo
         set -x
         msg="Program BUFR_LISTDUMPS completed normally for $file BUFR file"
         $DATA/postmsg "$jlogfile" "$msg"
         if [ "$CHGRP_RSTPROD" = 'YES' ]; then
            if [ -s $COMOUT/$filestem.nr ]; then
               chgrp rstprod $COMOUT/$filestem.listing
               errch=$?
               if [ $errch -eq 0 ]; then
                  chmod 640 $COMOUT/$filestem.listing
                  msg="NOTE: $file listing file contains RESTRICTED data, \
only users in rstprod group have read permission"
                  $DATA/postmsg "$jlogfile" "$msg"
                  echo " "
                  echo "$msg"
                  echo " "
               else
                  cp /dev/null $COMOUT/$filestem.listing
                  msg="**WARNING: $file listing file contains RESTRICTED \
data, since user $USER is not in rstprod group a null file is copied in its \
place"
                  $DATA/postmsg "$jlogfile" "$msg"
                  echo " "
                  echo "$msg"
                  echo " "
               fi
            fi
         fi
      fi
} > $DATA/thread${1}.out 2>&1
#AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
#                     End of herefile "thread"
#AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
EOFthread
   chmod 775 $DATA/thread

   index=0

########################################################################
#                    List BUFR Data Dump Files                         #
########################################################################

   LSTX=${LSTX:-$EXECobsproc/bufr_listdumps}

   for file in msonet satwnd goesfv aircar ascatw adpsfc gpsipw sfcshp \
               aircft adpupa proflr vadwnd rassda goesnd wdsatr spssmi \
               sfcbog qkswnd erscat 
   do
      filestem=$RUN.$cycle.$file.$tmmark.bufr_d
      [ -f $COMIN/$filestem ]  ||  continue
      index=`expr $index + 1`
      if [[ "${MPMD}" == YES ]]; then
         echo $DATA/thread $index $file $filestem  >> $DATA/mpmd.cmdfile
      else # run serially... this may be slow!
         $DATA/thread $index $file $filestem 
      fi
   done

   if [[ "${MPMD}" == YES ]]; then
      if [ -s $DATA/mpmd.cmdfile ]; then
      echo
      echo "------------------------------------------------------------------"
      echo "Invoking poe or poe-like mpmd processing: `date -u`"
      echo

      ntasks=$(wc -l $DATA/mpmd.cmdfile | awk '{print $1}')
      if [ $ntasks -eq 1 ]; then
         # no need for overhead of aprun or mpirun.lsf and cfp if only one thread
         chmod +x $DATA/mpmd.cmdfile
         $DATA/mpmd.cmdfile 2>&1
      else
         which cfp
         which_cfp_err=$?
         mpiexec -np 14 --cpu-bind verbose,core cfp $DATA/mpmd.cmdfile   
   fi
else
   echo
   echo "==> There are no tasks in MPMD Command File - MPMD not run"
   echo
fi
echo
echo "Ending mpmd processing  : `date -u`"
echo "--------------------------------------------------------------------"
echo
echo
fi

   for n in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
   do
      [ -d $DATA/thread${n} ]  || break
      cat $DATA/thread${n}.out
      cat break $DATA/thread${n}/$pgmout break >> $pgmout
      err=`cat $DATA/error${n}`
      [ $err -gt $retcode ]  && retcode=$err
   done

fi #  endif loop $PROCESS_LISTERS



if [ "$PROCESS_AVGTABLES" = 'YES' ]; then

########################################################################
#    If this is GDAS network (normally at 18Z only) ...                #
#    Update Data Count Average Tables for gdas Network                 #
#                                                                      #
#    If this is GFS network (normally at 18Z only) ...                 #
#    Update Data Count Average Tables for gfs Network                  #
#                                                                      #
#    If this is NAM tm00 network (normally at 18Z only) ...            #
#    Update Data Count Average Tables for nam tm00 Network             #
#                                                                      #
#    If this is RAP network (normally full cycle RAP at 23Z only) ...  #
#    Update Data Count Average Tables for rap Network                  #
#                                                                      #
#    If this is RTMA network (not RTMA_RU and normally at 23Z only) ...#
#    Update Data Count Average Tables for rtma Network                 #
#                                                                      #
#    If this is URMA network (normally at 23Z only) ...                #
#    Update Data Count Average Tables for urma Network                 #
########################################################################

   if [ "$NET" = 'gdas' -o "$NET" = 'gfs' -o "$NET" = 'nam' ]; then
      networks=$NET
   elif [ "$NET" = 'rap' -a "$RUN" = 'rap' ]; then
      networks=rap
   elif [ "$NET" = 'rtma' ]; then
      networks=rtma
   elif [ "$NET" = 'urma' ]; then
      networks=urma
   fi

   mkdir -p $AVGDarch_OUT

   for network in $networks
   do
      network_uc=$(echo $network | tr [a-z] [A-Z])

      $USHobsproc/bufr_avgdata.sh $network
      errsc=$?
      if [ $UPDATE_AVERAGE_FILE = YES ]; then
      if [ "$errsc" -eq '0' ]; then
         rm $AVGDarch_OUT/obcount_30davg.${network}.current
         cp obcount_30davg.${network}.current \
          $AVGDarch_OUT/obcount_30davg.${network}.current
         chmod 775 $AVGDarch_OUT/obcount_30davg.${network}.current
         msg="Data count average table SUCCESSFULLY updated for $network_uc \
network"
         $DATA/postmsg "$jlogfile" "$msg"
         typeset -Z2 this_month last_month
         this_month=`echo $PDY | cut -c5-6`
         year=`echo $PDY | cut -c1-4`
         last_month=`expr $this_month - 1`
         if [ "$last_month" -eq '0' ]; then
            last_month=12
            year=`expr $year - 1`
         fi
         if [ "$network" = 'nam' -o "$network" = 'gfs' -o "$network" = 'gdas' ]
         then
        if [ ! -s $AVGDarch_OUT/obcount_30davg.${network}.${year}${last_month} ]
            then

#  If no data count average table found for previous month, save this one

               rm $AVGDarch_OUT/obcount_30davg.${network}.*${last_month}
               cp obcount_30davg.${network}.current \
                $AVGDarch_OUT/obcount_30davg.${network}.${year}${last_month}
              chmod 775 $AVGDarch_OUT/obcount_30davg.${network}.${year}${last_month}
               msg="DATA COUNT AVERAGE table for ${year}${last_month} saved \
for $network_uc network"
               $DATA/postmsg "$jlogfile" "$msg"
            fi
         fi
      else
         msg="Data count average table NOT updated for $network_uc network"
         $DATA/postmsg "$jlogfile" "$msg"
      fi
      else
         msg="Data count average table NOT updated for $network_uc network \
by choice"
         $DATA/postmsg "$jlogfile" "$msg"
      fi
   done

fi #  endif loop $PROCESS_AVGTABLES

#######################
 

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output

cat  break $pgmout break > allout
cat allout
# rm allout
 
if [ $retcode -eq 0 ] ; then
   msg="HAS COMPLETED NORMALLY. #################################"
   $DATA/postmsg "$jlogfile" "$msg"
else
   msg="HAS COMPLETED WITH RETURN CODE $retcode. ################"
   $DATA/postmsg "$jlogfile" "$msg"
fi

################## END OF SCRIPT #######################

#!/bin/ksh
# Run under ksh (ready for WCOSS)


# This script performs the GLERL-adjustment on a fixed set of observations near
#  the shore of the Great Lakes
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# -----------------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - expected center date in PREPBUFR file (YYYYMMDDHH)        

# Imported variables that must be passed in:
#    DATA     - path to working directory
#    GLRD     - path to GLERL dictionary file
#    GLRX     - path to PREPOBS_GLERLADJ executable
#    TANK     - Path to directory containing daily lake average temperature
#               files

# Imported variables that can be passed in:
#   jlogfile - string indicating path to joblog file (skipped over by this
#              script if not passed in)
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1;fi
CDATE10=$2

jlogfile=${jlogfile:=""}

pgm=`basename  $GLRX`
if [ -s $DATA/prep_step ]; then
    set +u
    . $DATA/prep_step
    set -u
else
    [ -f errfile ] && rm errfile
    unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi
    #confirm existance of Lake temperature file
    #file size should be 18202 bytes
    #if file not available for current date, look back up to 3 days
         #per advice from John Kelley, job should not run if lake temps are
         # more than 3 days old.
if [ -s ${TANK}/${PDY}/wtxtbul/glsea-temps.dat ] ; then
    export FORT11=${TANK}/${PDY}/wtxtbul/glsea-temps.dat
elif [ -s ${TANK}/${PDYm1}/wtxtbul/glsea-temps.dat ] ; then
    export FORT11=${TANK}/${PDYm1}/wtxtbul/glsea-temps.dat
    msg="WARNING: Lake temperatures for GLERL adjustment ${PDY} ${cyc}Z are \
dated by 1 day.  Missing lake temperature file is: \
${TANK}/${PDY}/wtxtbul/glsea-temps.dat."
#   echo "$msg" | mail.py -c ${email_GLERL}
    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
elif [ -s ${TANK}/${PDYm2}/wtxtbul/glsea-temps.dat ] ; then
    export FORT11=${TANK}/${PDYm2}/wtxtbul/glsea-temps.dat
    msg="WARNING: Lake temperatures for RTMA GLERL adjustment ${PDY} ${cyc}Z \
are dated by 2 days.  Missing lake temperature file is: \
${TANK}/${PDY}/wtxtbul/glsea-temps.dat."
    echo "$msg" | mail.py -c ${email_GLERL}
    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
elif [ -s ${TANK}/${PDYm3}/wtxtbul/glsea-temps.dat ] ; then
    export FORT11=${TANK}/${PDYm3}/wtxtbul/glsea-temps.dat
    msg="WARNING: Lake temperatures for RTMA GLERL adjustment ${PDY} ${cyc}Z \
are dated by 3 days.  Missing lake temperature file is: \
${TANK}/${PDY}/wtxtbul/glsea-temps.dat."
    echo "$msg" | mail.py -c ${email_GLERL}
    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"

#elif [ -s ${TANK}/${PDYm4}/wtxtbul/glsea-temps.dat ] ; then
#    export FORT11=${TANK}/${PDYm4}/wtxtbul/glsea-temps.dat
#    msg="WARNING: Lake temperatures for RTMA GLERL adjustment ${PDY} ${cyc}Z are dated by 4 days."
#    echo "$msg" | mail.py
#    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
#elif [ -s ${TANK}/${PDYm5}/wtxtbul/glsea-temps.dat ] ; then
#    export FORT11=${TANK}/${PDYm5}/wtxtbul/glsea-temps.dat
#    msg="WARNING: Lake temperatures for RTMA GLERL adjustment ${PDY} ${cyc}Z are dated by 5 days."
#    echo "$msg" | mail.py
#    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
#elif [ -s ${TANK}/${PDYm6}/wtxtbul/glsea-temps.dat ] ; then
#    export FORT11=${TANK}/${PDYm6}/wtxtbul/glsea-temps.dat
#    msg="WARNING: Lake temperatures for RTMA GLERL adjustment ${PDY} ${cyc}Z are dated by 6 days."
#    echo "$msg" | mail.py
#    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
#elif [ -s ${TANK}/${PDYm7}/wtxtbul/glsea-temps.dat ] ; then
#    export FORT11=${TANK}/${PDYm7}/wtxtbul/glsea-temps.dat
#    msg="WARNING: Lake temperatures for RTMA GLERL adjustment ${PDY} ${cyc}Z are dated by 7 days."
#    echo "$msg" | mail.py
#    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
else
	#procesing can't run due to missing water temps - ABORT SILENTLY
    set +x
    echo
    echo "WARNING in prepobs_glerladj.sh: Lake water temperature file is \
missing - processing can't run!  Aborting prepobs_glerladj.sh, but allowing \
prepobs_makeprepbufr.sh to run to completion.  Prepbufr file will have no \
GLERL-adjusted obs."
    echo
    set -x
    msg="prepobs_glerladj.sh ERROR: Lake temperature file glsea-temps.dat \
valid for ${PDY} is more than 3 days old, missing lake temperature file is: \
${TANK}/${PDY}/wtxtbul/glsea-temps.dat --> non-fatal"
    echo $msg | mail.py -c ${email_GLERL}
    [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
    exit 0
fi
YYYY=`echo $CDATE10 | cut -c1-4`
MM=`echo $CDATE10 | cut -c5-6`
DD=`echo $CDATE10 | cut -c7-8`

#make a namelist input file with date info - used to match day of year with YMD (w3fp12)
cat <<EOF > dateinfo_input
&dateinfo
    inyear=${YYYY},
    inmonth=${MM},
    inday=${DD}
/
EOF

export FORT12=$GLRD
export FORT13=$PRPI
export FORT51=$PRPI.glerladj
export FORT91=prepbufr.wrk
TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
$TIMEIT $GLRX > outout 2> errfile
err=$?
err_actual=$err
err=0
cat errfile >> outout
cat outout >> glerladj.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for PREPOBS_GLERLADJ is ' $err_actual
echo
set -x
if [ "$err_actual" -gt '0' ]; then
    msg="WARNING: prepobs_glerladj did not run properly --> leaving input \
file intact and passing prepbufr file without GLERL adjustments back to \
prepobs_makeprepbufr.sh --> non-fatal"
   set +x
   echo
   echo $msg
   echo
   set -x
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
   exit 0
fi

if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.glerladj $PRPI
fi

exit 0

#!/bin/bash
############################################################################
echo "-----------------------------------------------------------          "
echo "exnam_dump.sh     - NAM model data dump processing                   "
echo "-----------------------------------------------------------          "
echo "History: Jan 10 2000 - Original script.                              "
echo "         Sep 10 2014 - Use parallel scripting to process dump groups."
echo "         Feb  3 2015 - Dump cris, atms, ssmisu and sevcsr.  Dump new "
echo "                       satwnd types NC005019, NC005080, NC005090.    "
echo "                       Reorder cfp commands to speed up run.         "
echo "         Aug 16 2016 - GPSIPW dump window reset for new data stream. "
echo "         Sep 23 2016 - Dump windows adjusted  for tm06-tm00 to       "
echo "                       support NAMv4 release which runs hourly       "
echo "                       catch-up cycles with dump windows             "
echo "                       (-0.50,+0.50) with some exceptions.           "
echo "                       lghtng added to Dump group #8.                "
echo "         May 21 2019 - Updated to run on Dell-p3.                    "
echo "                       Skip 2 tanks in msonet dump group that NAM    "
echo "                       will not process; frozen code.                "
echo "                       Removed the copy of 8th mesh snow depth file. "
echo "                       Removed dumping of radwnd dump group; ingest  "
echo "                       job not being ported to Dell-p3.              "
echo "                       Disabled background threading.                "
echo "         Feb 22 2021 - Disabled DBN alerts for gpsro dump files.     "
echo "                       These gpsro dump files have the potential to  "
echo "                       contain commercial data.  The equivalent      "
echo "                       non-restricted gpsro dump files are alerted   "
echo "                       instead.                                      "
echo "         Mar 09 2021 - Incremented subsets for the sfcshp dump groups"
echo "                       to match bufr_dumplist. Removed tideg from    "
echo "                       sfcshp dump group to make unique dump file.   "
echo "                     - Copy bufr_dumplist to COMOUT.                 "
echo "         Dec 09 2021 - Updated for use on WCOSS2                     " 
echo "         Oct 17 2023 - Split msonet to msonet and msone1 (b255/xx030)"
echo "         Mar 14 2024 - Separate msonet to own dump group             "
############################################################################

set -xau

# set some variables if they have not already been set

set +u

# JOB_NUMBER = 1 indicates the prepbufr dump job.
# JOB_NUMBER = 2 indicates the non-prepbufr dump job.
# JOB_NUMBER not present indicates dump BOTH prepbufr and non-prepbufr data.
# -----------------------------------------------------------------------------
# Dump group #1 (non-pb) = 1bamua 1bmhs gpsro mtiasi esamua eshrs3 sevcsr atms
# Dump group #2 (pb) = vadwnd satwnd
# Dump group #3 (pb) = proflr rassda sfcshp tideg adpsfc ascatt
# Dump group #4 (pb) = gpsipw (moved msonet)
# Dump group #5 (pb) = aircft aircar goesnd  --> dump is GLOBAL
# Dump group #6 (non-pb) = nexrad            --> dump is GLOBAL
# Dump group #7 (non-pb) = goesfv lgycld     --> dump is GLOBAL
# Dump group #8 (non-pb) = 1bhrs4 airsev osbuv8 esmhs ssmisu cris lghtng
# Dump group #9 (pb) = adpupa
# Dump group #10 (pb)= msonet
# Dump group #11 (pb)= msone1
# Dump group #12 STATUS FILE
# -----------------------------------------------------------------------------

#VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
# The settings below are based on a future change when the DUMP job will dump
#  only types that go into PREPBUFR and the DUMP2 job will dump only types that
#  do not go into PREPBUFR.  This will speed up the DUMP + PREP processing.
# Although the logic is in place to now do this (see below), for now we will
#  continue to dump only "nexrad" in the NAM DUMP2 jobs via the following
#  switch settings ...
# -----------------------------------------------------------------------------

if [ -n "$JOB_NUMBER" ]; then  
set -u
   if [ $JOB_NUMBER = 2 ]; then
      DUMP_group1="NO"
      DUMP_group7="NO"
      DUMP_group8="NO"
   else
      DUMP_group1="YES"
      DUMP_group7="YES"
      DUMP_group8="YES"
   fi
fi
set +u
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

if [ -n "$JOB_NUMBER" ]; then  
set -u
   if [ $JOB_NUMBER = 2 ]; then
      dump_ind=DUMP2
      DUMP_group1=${DUMP_group1:-"YES"}
      DUMP_group2=${DUMP_group2:-"NO"}
      DUMP_group3=${DUMP_group3:-"NO"}
      DUMP_group4=${DUMP_group4:-"NO"}
      DUMP_group5=${DUMP_group5:-"NO"}
      DUMP_group6=${DUMP_group6:-"YES"}
      DUMP_group7=${DUMP_group7:-"YES"}
      DUMP_group8=${DUMP_group8:-"YES"}
      DUMP_group9=${DUMP_group9:-"NO"}
      DUMP_group10=${DUMP_group10:-"NO"}
      DUMP_group11=${DUMP_group11:-"NO"}
   else
      dump_ind=DUMP
      DUMP_group1=${DUMP_group1:-"NO"}
      DUMP_group2=${DUMP_group2:-"YES"}
      DUMP_group3=${DUMP_group3:-"YES"}
      DUMP_group4=${DUMP_group4:-"YES"}
      DUMP_group5=${DUMP_group5:-"YES"}
      DUMP_group6=${DUMP_group6:-"NO"}
      DUMP_group7=${DUMP_group7:-"NO"}
      DUMP_group8=${DUMP_group8:-"NO"}
      DUMP_group9=${DUMP_group9:-"YES"}
      DUMP_group10=${DUMP_group10:-"YES"}
      DUMP_group11=${DUMP_group11:-"YES"}
   fi
else
   dump_ind=DUMP
   DUMP_group1=${DUMP_group1:-"YES"}
   DUMP_group2=${DUMP_group2:-"YES"}
   DUMP_group3=${DUMP_group3:-"YES"}
   DUMP_group4=${DUMP_group4:-"YES"}
   DUMP_group5=${DUMP_group5:-"YES"}
   DUMP_group6=${DUMP_group6:-"YES"}
   DUMP_group7=${DUMP_group7:-"YES"}
   DUMP_group8=${DUMP_group8:-"YES"}
   DUMP_group9=${DUMP_group9:-"YES"}
   DUMP_group10=${DUMP_group10:-"YES"}
   DUMP_group11=${DUMP_group11:-"YES"}
fi

if [ $tmmark = tm00 ]; then
   ADPUPA_wait=${ADPUPA_wait:-"YES"}
########ADPUPA_wait=${ADPUPA_wait:-"NO"} # saves ~15 sec if ADPUPA_wait=NO
   CHECK_STATUS=${CHECK_STATUS:-"NO"}
else
   ADPUPA_wait=${ADPUPA_wait:-"NO"}
   CHECK_STATUS=${CHECK_STATUS:-"YES"}
fi


# send extra output of DUMP2 for monitoring purposes.
set +u
if [ -n "$JOB_NUMBER" ]; then  
   [ $JOB_NUMBER = 2 ]  && export PS4='$SECONDS + '
fi
set -u

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"
 
cat break > $pgmout

tmhr=`echo $tmmark|cut -c3-4`
export dumptime=`$NDATE -$tmhr $PDY$cyc`
export cycp=`echo $dumptime|cut -c9-10`

RUN_uc=$(echo $RUN | tr [a-z] [A-Z])
tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="$RUN_uc ANALYSIS TIME IS $PDY$cyc"
$DATA/postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR $tmmark_uc $RUN_uc IS $dumptime"
echo
set -x

export COMSP=$COMOUT/$RUN.${cycle}.
 
if [ "$PROCESS_GRIBFLDS" = 'YES' ]; then

####################################
####################################
#  copy imssnow from $TANK_GRIBFLDS
####################################
####################################

   imssnow=$TANK_GRIBFLDS/$PDY/wgrbbul/imssnow.grb
   imssold=$TANK_GRIBFLDS/$PDYm1/wgrbbul/imssnow.grb

   if [ -s $imssnow ]; then
      cp $imssnow ${COMSP}imssnow.grb
##### $CNVGRIB -g12 -p40 ${COMSP}imssnow.grb ${COMSP}imssnow.grb.grib2
##### $WGRIB2 ${COMSP}imssnow.grb.grib2 -s > ${COMSP}imssnow.grb.grib2.idx
      msg="todays IMS snow grib file located and copied to ${COMSP}imssnow.grb"
      $DATA/postmsg "$jlogfile" "$msg"
      if [ "$SENDDBN" = 'YES' ]; then
         $DBNROOT/bin/dbn_alert MODEL NAMIMSSNOW $job ${COMSP}imssnow.grb
      fi
##### if [ "$SENDDBN" = 'YES' ]; then
#####    $DBNROOT/bin/dbn_alert MODEL NAMIMSSNOW_GB2 $job \
#####     ${COMSP}imssnow.grb.grib2
#####    $DBNROOT/bin/dbn_alert MODEL NAMIMSSNOW_GB2_WIDX $job \
#####     ${COMSP}imssnow.grb.grib2.idx
##### fi
   elif [ -s $imssold ]; then
      cp $imssold ${COMSP}imssnow.grb
      msg="**todays IMS snow grib file not located - copy 1-day old file"
      $DATA/postmsg "$jlogfile" "$msg"
      if [ "$SENDDBN" = 'YES' ]; then
         $DBNROOT/bin/dbn_alert MODEL NAMIMSSNOW $job ${COMSP}imssnow.grb
      fi
   else
      set +x
      echo " "
      echo " ##########################################"
      echo " cannot locate IMS snow grib file "
      echo " non-fatal error (no longer used by NAM,"
      echo " but might cause failure in RCDAS)"
      echo " ##########################################"
      echo " "
      set -x
      msg="**CANNOT LOCATE IMS SNOW GRIB FILE --> non-fatal"
      $DATA/postmsg "$jlogfile" "$msg"
   fi

# US AFWA 8th mesh snow depth data discontinued 5/31/2019
#  snowdepth=$TANK_GRIBFLDS/$PDY/wgrbbul/snowdepth.grb
#  snowdeold=$TANK_GRIBFLDS/$PDYm1/wgrbbul/snowdepth.grb
#  if [ -s $snowdepth ]; then
#     cp $snowdepth ${COMSP}snowdepth.grb
#     msg="todays snow depth grib file located and copied to ${COMSP}snowdepth.grb"
#     $DATA/postmsg "$jlogfile" "$msg"
#  elif [ -s $snowdeold ]; then
#     cp $snowdeold ${COMSP}snowdepth.grb
#     msg="**todays snow depth grib file not located - copy 1-day old file"
#     $DATA/postmsg "$jlogfile" "$msg"
#  else
#     set +x
#     echo " "
#     echo " ##########################################"
#     echo " cannot locate snow depth grib file "
#     echo " non-fatal error (no longer used by NAM,"
#     echo " but might cause failure in RCDAS)"
#     echo " ##########################################"
#     echo " "
#     set -x
#     msg="**CANNOT LOCATE SNOW DEPTH GRIB FILE --> non-fatal"
#     $DATA/postmsg "$jlogfile" "$msg"
#  fi

fi  #  endif loop $PROCESS_GRIBFLDS


echo "=======> Dump group 1 (thread_1) not executed." > $DATA/1.out
echo "=======> Dump group 2 (thread_2) not executed." > $DATA/2.out
echo "=======> Dump group 3 (thread_3) not executed." > $DATA/3.out
echo "=======> Dump group 4 (thread_4) not executed." > $DATA/4.out
echo "=======> Dump group 5 (thread_5) not executed." > $DATA/5.out
echo "=======> Dump group 6 (thread_6) not executed." > $DATA/6.out
echo "=======> Dump group 7 (thread_7) not executed." > $DATA/7.out
echo "=======> Dump group 8 (thread_8) not executed." > $DATA/8.out
echo "=======> Dump group 9 (thread_9) not executed." > $DATA/9.out
echo "=======> Dump group 10 (thread_10) not executed." > $DATA/10.out
echo "=======> Dump group 11 (thread_11) not executed." > $DATA/11.out

err1=0
err2=0
err3=0
err4=0
err5=0
err6=0
err7=0
err8=0
err9=0
err10=0
err11=0
if [ "$PROCESS_DUMP" = 'YES' ]; then

#######################################################################
#######################################################################
#  The data "dump" script for tm06, tm05, tm04, tm03, tm02, tm01, tm00
#######################################################################
#######################################################################

msg="START THE $tmmark_uc $RUN_uc DATA $dump_ind CENTERED ON $dumptime"
$DATA/postmsg "$jlogfile" "$msg"

if [ $CHECK_STATUS = YES -a -s ${COMSP}status${JOB_NUMBER}.${tmmark}.bufr_d ]
then

msg="**WARNING: status${JOB_NUMBER} file already exists for $tmmark \
$PDY$cyc run - no data dumps produced"
$DATA/postmsg "$jlogfile" "$msg"

else

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=1

#============================================================================
# Dump # 1 : 1BAMUA, 1BMHS, GPSRO, MTIASI, ESAMUA, ESHRS3, SEVCSR, ATMS
#              (1)    (1)    (1)     (1)     (1)     (1)     (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 8
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for all types except
#              1BAMUA, 1BMHS, MTIASI, ATMS where it is (-1.00,+0.99) hours
#            for on-time cycles tm00:
#              time window radius is (-0.75,+1.50) hours
#============================================================================

if [ "$tmhr" = "00" ]; then
  for dump_file in 1bamua 1bmhs gpsro mtiasi esamua eshrs3 sevcsr atms; do
    eval DTIM_earliest_$dump_file=\${DTIM_earliest_$dump_file:-"-0.75"}
    eval DTIM_latest_$dump_file=\${DTIM_latest_$dump_file:-"+1.50"}
  done
else
  for dump_file in 1bamua 1bmhs mtiasi atms; do
    eval DTIM_earliest_$dump_file=\${DTIM_earliest_$dump_file:-"-1.00"}
    eval DTIM_latest_$dump_file=\${DTIM_latest_$dump_file:-"+0.99"}
  done
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 1bamua 1bmhs gpsro mtiasi \
 esamua eshrs3 sevcsr atms
error1=$?
echo "$error1" > $DATA/error1

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_1bamua $job ${COMSP}1bamua.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_1bmhs  $job ${COMSP}1bmhs.$tmmark.bufr_d
# gpsro dump file has nr version which is alerted from exdump_post.sh
# $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_gpsro  $job ${COMSP}gpsro.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_mtiasi $job ${COMSP}mtiasi.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_esamua $job ${COMSP}esamua.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_eshrs3 $job ${COMSP}eshrs3.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_sevcsr $job ${COMSP}sevcsr.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_atms   $job ${COMSP}atms.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_2; chmod +x thread_2
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_2
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=2

#============================================================================
# Dump # 2 : VADWND, SATWND
#              (2)    (14) 
#            -- TOTAL NUMBER OF SUBTYPES = 16
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for all types except
#              SATWND subtypes 005/010, 005/011, 005/012, 005/019 where it is
#              (-0.50,-0.01) hours
#            for on-time cycles tm00:
#              time window radius is (-0.75,+1.50) hours for all types except
#              SATWND subtypes 005/064, 005/065, 005/066 where it is
#              (-0.75,+1.49) hours and SATWND subtypes 005/010, 005/011,
#              005/012, 005/019 where it is (-0.75,-0.01) hours
#============================================================================

# Skip all Indian satellite winds in SATWND (not in domain)

export SKIP_005021=YES
export SKIP_005022=YES
export SKIP_005023=YES

if [ "$tmhr" = "00" ]; then
  for dump_file in vadwnd 005070 005071 005080 005090 005044 005045 005046; do
    eval DTIM_earliest_$dump_file=\${DTIM_earliest_$dump_file:-"-0.75"}
    eval DTIM_latest_$dump_file=\${DTIM_latest_$dump_file:-"+1.50"}
  done

  DTIM_earliest_005064=${DTIM_earliest_005064:-"-0.75"}
  DTIM_latest_005064=${DTIM_latest_005064:-"+1.49"}
  DTIM_earliest_005065=${DTIM_earliest_005065:-"-0.75"}
  DTIM_latest_005065=${DTIM_latest_005065:-"+1.49"}
  DTIM_earliest_005066=${DTIM_earliest_005066:-"-0.75"}
  DTIM_latest_005066=${DTIM_latest_005066:-"+1.49"}

  DTIM_earliest_005010=${DTIM_earliest_005010:-"-0.75"}
  DTIM_latest_005010=${DTIM_latest_005010:-"-0.01"}
  DTIM_earliest_005011=${DTIM_earliest_005011:-"-0.75"}
  DTIM_latest_005011=${DTIM_latest_005011:-"-0.01"}
  DTIM_earliest_005012=${DTIM_earliest_005012:-"-0.75"}
  DTIM_latest_005012=${DTIM_latest_005012:-"-0.01"}
  DTIM_earliest_005019=${DTIM_earliest_005019:-"-0.75"}
  DTIM_latest_005019=${DTIM_latest_005019:-"-0.01"}
else
  DTIM_latest_005010=${DTIM_latest_005010:-"-0.01"}
  DTIM_latest_005011=${DTIM_latest_005011:-"-0.01"}
  DTIM_latest_005012=${DTIM_latest_005012:-"-0.01"}
  DTIM_latest_005019=${DTIM_latest_005019:-"-0.01"}
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 vadwnd satwnd
error2=$?
echo "$error2" > $DATA/error2

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_vadwnd $job ${COMSP}vadwnd.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_satwnd $job ${COMSP}satwnd.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_2
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/2.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_3; chmod +x thread_3
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_3
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=3

#========================================================================
# Dump # 3 : PROFLR, RASSDA, SFCSHP, ADPSFC, ASCATT, TIDEG
#              (3)     (1)    (11)     (5)     (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 22
#
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of (-1.50,+1.50) hours in old
#       NAM/NDAS)
#
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for all types except
#              PROFLR where it is (-2.50,+2.50) hours
#            for on-time cycles tm00:
#              time window radius is (-0.75,+1.50) hours for all types except
#              PROFLR where it is (-2.50,+2.50) hours
#=======================================================================

# Dump PROFLR with wide time window to improve PREPOBS_PROFCQC performance
#  (time window will be winnowed down in output from PREPOBS_PROFCQC, see
#   parm cards for output time window)

if [ "$tmhr" = "00" ]; then
  for dump_file in rassda sfcshp tideg adpsfc ascatt; do
    eval DTIM_earliest_$dump_file=\${DTIM_earliest_$dump_file:-"-0.75"}
    eval DTIM_latest_$dump_file=\${DTIM_latest_$dump_file:-"+1.50"}
  done
fi

DTIM_earliest_proflr=${DTIM_earliest_proflr:-"-2.50"}
DTIM_latest_proflr=${DTIM_latest_proflr:-"+2.50"}

# Skip Japanese profiler reports in PROFLR (not in domain)

export SKIP_002013=YES

# Skip mobile synoptic reports in ADPSFC (not in domain)

export SKIP_000002=YES

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 proflr rassda sfcshp tideg \
 adpsfc ascatt
error3=$?
echo "$error3" > $DATA/error3

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_proflr $job ${COMSP}proflr.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_rassda $job ${COMSP}rassda.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_sfcshp $job ${COMSP}sfcshp.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_tideg $job ${COMSP}tideg.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_adpsfc $job ${COMSP}adpsfc.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_ascatt $job ${COMSP}ascatt.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_ascatw $job ${COMSP}ascatw.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_3
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/3.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_4; chmod +x thread_4
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_4
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=4

#===========================================================================
# Dump # 4 : [MSONET,] GPSIPW -- TOTAL NUMBER OF SUBTYPES = [31] 1
#             [(30)]     (1) - moved msone* to separate groups!
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for MSONET
#            for on-time tm00 cycles:
#              time window radius is (-0.75,+1.50) hours for MSONET
#            for all cycles:
#              time window radius is (-0.22,-0.12) hours (~ -13 to -7 min) for
#              GPSIPW
#            {note: new Ground Based GPS-IPW/ZTD (from U.S.-ENI and foreign
#                   GNSS providers) is currently limited to obs closest to 
#                   cycle-time that result in a U.S.-ENI dump count that is
#                   not too much larger than that from the previous U.S. (only)
#                   GSD-feed, since the ENI reports are available every 5 min
#                   while the GSD reports were available only every 30 min.
#                   Also accounts for an approximate 80-min latency present in
#                   the U.S.-ENI reports.}
#===========================================================================

DTIM_earliest_gpsipw=${DTIM_earliest_gpsipw:-"-0.22"}
DTIM_latest_gpsipw=${DTIM_latest_gpsipw:-"-0.12"}

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 gpsipw
error4=$?
echo "$error4" > $DATA/error4

#+++++++++++++++++++
#  Temporary logic to change "gpsipw" dump file's group to "rstprod" and its
#   permission to "640" so that it can only be read by users in the rstprod
#   group (new "gpsipw" dump file is restricted; currently the logic to restrict
#   dump files is done in obsproc_dump ush script bufr_dump_obs.sh, where the
#   list of files to restrict is hardwired. Since obsproc_dump is not included
#   in the bundle which includes the switch to new "gpsipw" we must do it here.
#   Future change will either be to add "gpsipw" to list of dump files to
#   restrict in next obsproc_dump release, or to parameterize the list of files
#   to be restricted in this script and pass it to bufr_dump_obs.sh.  In either
#   case, once that is done this logic can be removed.  Also, must place this
#   logic here since below a dbn_alert is issued to post the "gpsipw" dump file
#   to ftpprd server (and it must be restricted before transfer!).

if [ -f ${COMSP}gpsipw.${tmmark}.bufr_d ]; then
CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}
if [ "$CHGRP_RSTPROD" = 'YES' ]; then
   chgrp rstprod ${COMSP}gpsipw.${tmmark}.bufr_d
   errch=$?
   if [ $errch -eq 0 ]; then
      chmod 640 ${COMSP}gpsipw.${tmmark}.bufr_d
      msg="NOTE: gpsipw dump contains RESTRICTED data, only users in rstprod \
group have read permission"
      set +u
      [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
      set -u
      set +x
      echo
      echo
      echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
      echo "$msg"
      echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
      echo
      echo
      set -x
   else
      cp /dev/null ${COMSP}gpsipw.${tmmark}.bufr_d
      msg="**WARNING: gpsipw dump contains RESTRICTED data, since user $USER \
is not in rstprod group a null file is copied in its place"
      set +u
      [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
      set -u
      set +x
      echo
      echo
      echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
      echo "$msg"
      echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
      echo
      echo
      set -x
   fi
fi
fi
#+++++++++++++++++++

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_gpsipw $job ${COMSP}gpsipw.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_4
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/4.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_5; chmod +x thread_5
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_5
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=5

#===========================================================================
# Dump # 5 : AIRCFT, AIRCAR, GOESND -- TOTAL NUMBER OF SUBTYPES = 11
#              (8)     (2)     (1)
#            for all cycles:
#              time window radius is (-3.25,+3.25) hours for all types except
#              GOESND where it is (-1.25,-0.01) hours
#===========================================================================

# Dump AIRCFT and AIRCAR with wide time window and globally to improve
#  PREPOBS_PREPACQC track-check performance
#  (time window will be winnowed down to +/- 1.50 hours in output from
#   PREPOBS_PREPACQC, and limited to north of 20S latitude)

# Dump GOESND globally to allow job to run much quicker w/o the need for
#   geographical filtering (all GOES reports are in expanded NAM domain anyway)

export LALO=0  # GLOBAL dumps here

DTIM_earliest_003002=${DTIM_earliest_003002:-"-1.25"}
DTIM_latest_003002=${DTIM_latest_003002:-"-0.01"}

# Skip GOES 1x1 radiances in GOESND (already dumped in GOESFV)

export SKIP_003003=YES

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.25 1 aircft aircar goesnd
error5=$?
echo "$error5" > $DATA/error5

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_aircft $job ${COMSP}aircft.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_aircar $job ${COMSP}aircar.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_goesnd $job ${COMSP}goesnd.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_5
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/5.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_6; chmod +x thread_6
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_6
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=6

#===========================================================================
# Dump # 6 : NEXRAD -- TOTAL NUMBER OF SUBTYPES = 8
#              (8)
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for NEXRAD
#            for on-time tm00 cycles:
#              time window radius is (-0.75,+1.50) hours for NEXRAD
#===========================================================================

# Dump globally since all reports over CONUS (and geographical filtering is
#  computationally expensive)

export LALO=0

# NEXRAD tanks are hourly

# Initialize radial wind and reflectivity dumps to SKIP all hourly tanks
set +x
for dump_file in 006010 006011 006012 006013 006014 006015 006016 006017 \
                 006018 006019 006020 006021 006022 006023 006024 006025 \
                 006026 006027 006028 006029 006030 006031 006032 006033; do
set -x
  eval SKIP_$dump_file=YES
set +x
done

for dump_file in 006040 006041 006042 006043 006044 006045 006046 006047 \
                 006048 006049 006050 006051 006052 006053 006054 006055 \
                 006056 006057 006058 006059 006060 006061 006062 006063; do
set -x
  eval SKIP_$dump_file=YES
set +x
done
set -x

#-------------------------------------------------------------------------------
# Now unset the SKIP for those hourly radial wind and relectivity tanks that
#  are w/i requested dump center cycle time window so these will be read
# This is based on center data dump time and run analysis cycle time
#-------------------------------------------------------------------------------
# 00z run analysis cycle time:
#  tm06 (17.50-18.50 Z) - unsets SKIP on tanks 006/ 027, 028, 057, 058
#  tm05 (18.50-19.50 Z) - unsets SKIP on tanks 006/ 028, 029, 058, 059
#  tm04 (19.50-20.50 Z) - unsets SKIP on tanks 006/ 029, 030, 059, 060
#  tm03 (20.50-21.50 Z) - unsets SKIP on tanks 006/ 030, 031, 060, 061
#  tm02 (21.50-22.50 Z) - unsets SKIP on tanks 006/ 031, 032, 061, 062
#  tm01 (22.50-23.50 Z) - unsets SKIP on tanks 006/ 032, 033, 062, 063
#  tm00 (23.25-01.50 Z) - unsets SKIP on tanks 006/ 033, 010, 011, 063, 040, 041
# 06z run analysis cycle time:
#  tm06 (23.50-00.50 Z) - unsets SKIP on tanks 006/ 033, 010, 063, 040
#  tm05 (00.50-01.50 Z) - unsets SKIP on tanks 006/ 010, 011, 040, 041
#  tm04 (01.50-02.50 Z) - unsets SKIP on tanks 006/ 011, 012, 041, 042
#  tm03 (02.50-03.50 Z) - unsets SKIP on tanks 006/ 012, 013, 042, 043
#  tm02 (03.50-04.50 Z) - unsets SKIP on tanks 006/ 013, 014, 043, 044
#  tm01 (04.50-05.50 Z) - unsets SKIP on tanks 006/ 014, 015, 044, 045
#  tm00 (05.25-07.50 Z) - unsets SKIP on tanks 006/ 015, 016, 017, 045, 046, 047
# 12z run analysis cycle time:
#  tm06 (05.50-06.50 Z) - unsets SKIP on tanks 006/ 015, 016, 045, 046
#  tm05 (06.50-07.50 Z) - unsets SKIP on tanks 006/ 016, 017, 046, 047
#  tm04 (07.50-08.50 Z) - unsets SKIP on tanks 006/ 017, 018, 047, 048
#  tm03 (08.50-09.50 Z) - unsets SKIP on tanks 006/ 018, 019, 048, 049
#  tm02 (09.50-10.50 Z) - unsets SKIP on tanks 006/ 019, 020, 049, 050
#  tm01 (10.50-11.50 Z) - unsets SKIP on tanks 006/ 020, 021, 050, 051
#  tm00 (11.25-13.50 Z) - unsets SKIP on tanks 006/ 021, 022, 023, 051, 052, 053
# 18z run analysis cycle time:
#  tm06 (11.50-12.50 Z) - unsets SKIP on tanks 006/ 021, 022, 051, 052
#  tm05 (12.50-13.50 Z) - unsets SKIP on tanks 006/ 022, 023, 052, 053
#  tm04 (13.50-14.50 Z) - unsets SKIP on tanks 006/ 023, 024, 053, 054
#  tm03 (14.50-15.50 Z) - unsets SKIP on tanks 006/ 024, 025, 054, 055
#  tm02 (15.50-16.50 Z) - unsets SKIP on tanks 006/ 025, 026, 055, 056
#  tm01 (16.50-17.50 Z) - unsets SKIP on tanks 006/ 026, 027, 056, 057
#  tm00 (17.25-19.50 Z) - unsets SKIP on tanks 006/ 027, 028, 029, 057, 058, 059
#-------------------------------------------------------------------------------

for cycz in 00 06 12 18; do  # loop through run analysis cycle times
  [ $cyc -ne $cycz ] && continue
  cycx=$cyc
  [ $cyc -eq 00 ] &&  cycx=24
# --> # loop through catch-up cycles (tm06-tm01) for analysis cycle time
  for hrm in 6 5 4 3 2 1; do
    [ $cycp -ne `expr $cycx - $hrm` ] && continue
    subtyp1=`expr $cycp  +  9 `
    [ $subtyp1 -eq 9 ] && subtyp1=33
    subtyp2=`expr $cycp  + 10 `
    unset SKIP_0060${subtyp1}
    unset SKIP_0060${subtyp2}
    unset SKIP_0060`expr $subtyp1 + 30 `
    unset SKIP_0060`expr $subtyp2 + 30 `
    break 2
  done
  [ $cycp -ne $cyc ] && break
# --> come here if on-time cycle (tm00) for analysis cycle
  subtyp1=`expr $cycp  +  9 `
  [ $subtyp1 -eq 9 ] && subtyp1=33
  subtyp2=`expr $cycp  + 10 `
  subtyp3=`expr $cycp  + 11 `
  unset SKIP_0060${subtyp1}
  unset SKIP_0060${subtyp2}
  unset SKIP_0060${subtyp3}
  unset SKIP_0060`expr $subtyp1 + 30 `
  unset SKIP_0060`expr $subtyp2 + 30 `
  unset SKIP_0060`expr $subtyp3 + 30 `
  break
done

if [ "$tmhr" = "00" ]; then
  DTIM_earliest_nexrad=${DTIM_earliest_nexrad:-"-0.75"}
  DTIM_latest_nexrad=${DTIM_latest_nexrad:-"+1.50"}
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 nexrad
error6=$?
echo "$error6" > $DATA/error6

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_nexrad $job ${COMSP}nexrad.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_6
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/6.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_7; chmod +x thread_7
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_7
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=7

#===========================================================================
# Dump # 7 : GOESFV, LGYCLD -- TOTAL NUMBER OF SUBTYPES = 2
#              (1)     (1)
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for all types
#            for on-time tm00 cycles:
#              time window radius is (-0.75,+1.50) hours for GOESFV
#              time window radius is (-0.50,+0.50) hours for LGYCLD
#            dump is global
#              (dump is much quicker w/o geographical filtering, all GOES
#               reports are in NAM domain anyway)
#===========================================================================

export LALO=0  # GLOBAL dumps here

if [ "$tmhr" = "00" ]; then
  DTIM_earliest_goesfv=${DTIM_earliest_goesfv:-"-0.75"}
  DTIM_latest_goesfv=${DTIM_latest_goesfv:-"+1.50"}
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 goesfv lgycld
error7=$?
echo "$error7" > $DATA/error7

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_goesfv $job ${COMSP}goesfv.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_lgycld $job ${COMSP}lgycld.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_7
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/7.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_8; chmod +x thread_8
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_8
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=8
#============================================================================
# Dump # 8 : 1BHRS4, AIRSEV, OSBUV8, ESMHS, SSMISU, CRIS, LGHTNG
#              (1)     (1)     (1)    (1)     (1)    (1)    (2)
#            -- TOTAL NUMBER OF SUBTYPES = 8
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for all types except
#              1BHRS4, AIRSEV, OSBUV8, CRIS where it is (-1.00,+0.99) hours
#            for on-time cycles tm00:
#              time window radius is (-0.75,+1.50) hours for all types
#============================================================================

if [ "$tmhr" = "00" ]; then
  for dump_file in 1bhrs4 airsev osbuv8 esmhs ssmisu cris lghtng; do
    eval DTIM_earliest_$dump_file=\${DTIM_earliest_$dump_file:-"-0.75"}
    eval DTIM_latest_$dump_file=\${DTIM_latest_$dump_file:-"+1.50"}
  done
else
  for dump_file in 1bhrs4 airsev osbuv8 cris; do
    eval DTIM_earliest_$dump_file=\${DTIM_earliest_$dump_file:-"-1.00"}
    eval DTIM_latest_$dump_file=\${DTIM_latest_$dump_file:-"+0.99"}
  done
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 1bhrs4 airsev osbuv8 esmhs \
 ssmisu cris lghtng
error8=$?
echo "$error8" > $DATA/error8

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_1bhrs4 $job ${COMSP}1bhrs4.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_airsev $job ${COMSP}airsev.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_osbuv8 $job ${COMSP}osbuv8.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_esmhs  $job ${COMSP}esmhs.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_ssmisu $job ${COMSP}ssmisu.$tmmark.bufr_d
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_cris   $job ${COMSP}cris.$tmmark.bufr_d
### not needed? ##  $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_lghtng $job ${COMSP}lghtng.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_8
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/8.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_9; chmod +x thread_9
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_9
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=9

#===========================================================================
# Dump # 9 : ADPUPA -- TOTAL NUMBER OF SUBTYPES = 6
#              (6)
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for ADPUPA
#            for on-time cycles tm00:
#              time window radius is (-0.75,+1.50) hours for ADPUPA
#            (note: ADPUPA is dumped last and after all other dumping has
#                   completed in the tm00 NAM dump - ONLY - in order to
#                   maximize availability of ADPUPA data for tm00 NAM)
#===========================================================================

if [ "$tmhr" = "00" ]; then
  DTIM_earliest_adpupa=${DTIM_earliest_adpupa:-"-0.75"}
  DTIM_latest_adpupa=${DTIM_latest_adpupa:-"+1.50"}
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 adpupa
error9=$?
echo "$error9" > $DATA/error9

if [ "$SENDDBN" = 'YES' ]; then
 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_adpupa $job ${COMSP}adpupa.$tmmark.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_9
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/9.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_10; chmod +x thread_10
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_10
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=10

#===========================================================================
# Dump # 10 : MSONET -- TOTAL NUMBER OF SUBTYPES = 1
#              (1)
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for MSONET
#            for on-time tm00 cycles:
#              time window radius is (-0.75,+1.50) hours for MSONET
#===========================================================================

if [ "$tmhr" = "00" ]; then
  DTIM_earliest_msonet=${DTIM_earliest_msonet:-"-0.75"}
  DTIM_latest_msonet=${DTIM_latest_msonet:-"+1.50"}
fi

export SKIP_255031=YES  # Skip for port to Dell since no new data allowed.
export SKIP_255101=YES  # Also, b/c NAM is frozen; no new data.

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 msonet
error10=$?
echo "$error10" > $DATA/error10

#if [ "$SENDDBN" = 'YES' ]; then
# $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_msonet $job ${COMSP}msonet.$tmmark.bufr_d
#fi

set +x
echo "********************************************************************"
echo Script thread_10
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/10.out 2>&1
EOF
set -x


set +x
#----------------------------------------------------------------
cat<<\EOF>thread_11; chmod +x thread_11
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_11
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=11

#===========================================================================
# Dump # 11 : MSONE1 -- TOTAL NUMBER OF SUBTYPES = 1
#              (1)
#            for catch-up cycles tm06-01:
#              time window radius is (-0.50,+0.50) hours for MSONE1
#            for on-time tm00 cycles:
#              time window radius is (-0.75,+1.50) hours for MSONE1
#===========================================================================

if [ "$tmhr" = "00" ]; then
  DTIM_earliest_msone1=${DTIM_earliest_msone1:-"-0.75"}
  DTIM_latest_msone1=${DTIM_latest_msone1:-"+1.50"}
fi

export SKIP_255031=YES  # Skip for port to Dell since no new data allowed.
export SKIP_255101=YES  # Also, b/c NAM is frozen; no new data.

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.5 1 msone1
error11=$?
echo "$error11" > $DATA/error11

#if [ "$SENDDBN" = 'YES' ]; then
# $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_msonet $job ${COMSP}msone1.$tmmark.bufr_d
#fi

set +x
echo "********************************************************************"
echo Script thread_11
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/11.out 2>&1
EOF
set -x


#----------------------------------------------------------------
# Now launch the threads

#  determine local system name and type if available
#  -------------------------------------------------
SITE=${SITE:-""}

set +u
launcher=${launcher:-"cfp"}  # if not "cfp", threads will be run serially.

if [ "$launcher" = cfp ]; then
   > $DATA/poe.cmdfile
# To better take advantage of cfp, execute the longer running commands first.
# Some reordering was done here based on recent sample runtimes.
# (Note: this may need some re-tuning after NAMv4!)
   [ $DUMP_group4 = YES ]  &&  echo ./thread_4 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group8 = YES ]  &&  echo ./thread_8 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group1 = YES ]  &&  echo ./thread_1 >> $DATA/poe.cmdfile
   [ $DUMP_group2 = YES ]  &&  echo ./thread_2 >> $DATA/poe.cmdfile
   [ $DUMP_group3 = YES ]  &&  echo ./thread_3 >> $DATA/poe.cmdfile
   [ $DUMP_group5 = YES ]  &&  echo ./thread_5 >> $DATA/poe.cmdfile
   [ $DUMP_group6 = YES ]  &&  echo ./thread_6 >> $DATA/poe.cmdfile
   [ $DUMP_group7 = YES ]  &&  echo ./thread_7 >> $DATA/poe.cmdfile
   [ $DUMP_group9 = YES -a $ADPUPA_wait != YES ]  &&  echo ./thread_9 >> $DATA/poe.cmdfile
   [ $DUMP_group10 = YES ]  &&  echo ./thread_10 >> $DATA/poe.cmdfile
   [ $DUMP_group11 = YES ]  &&  echo ./thread_11 >> $DATA/poe.cmdfile

   if [ -s $DATA/poe.cmdfile ]; then
      export MP_CSS_INTERRUPT=yes  # ??
      launcher_DUMP=${launcher_DUMP:-mpiexec}
      #$launcher_DUMP -np 10 --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      NPROCS=${NPROCS:-11}
      $launcher_DUMP -np $NPROCS --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      errpoe=$?
      if [ $errpoe -ne 0 ]; then
         $DATA/err_exit "***FATAL: EXIT STATUS $errpoe RUNNING POE COMMAND FILE"
      fi
   else
      echo
      echo "==> There are no tasks in POE Command File - POE not run"
      echo
   fi
else
   echo "Run threads serially"
   [ $DUMP_group1 = YES ]  &&  ./thread_1
   [ $DUMP_group2 = YES ]  &&  ./thread_2
   [ $DUMP_group3 = YES ]  &&  ./thread_3
   [ $DUMP_group4 = YES ]  &&  ./thread_4
   [ $DUMP_group5 = YES ]  &&  ./thread_5
   [ $DUMP_group6 = YES ]  &&  ./thread_6
   [ $DUMP_group7 = YES ]  &&  ./thread_7
   [ $DUMP_group8 = YES ]  &&  ./thread_8
   [ $DUMP_group9 = YES -a $ADPUPA_wait != YES ]  &&  ./thread_9
   [ $DUMP_group10 = YES ]  &&  ./thread_10
   [ $DUMP_group11 = YES ]  &&  ./thread_11
fi

#  if ADPUPA_wait is YES, adpupa is dumped AFTER all other dump threads have
#   run (normally done in real-time tm00 NAM runs to dump as late as possible
#   in order to maximize data availability in tm00 NAM runs)
#  --------------------------------------------------------------------------

[ $DUMP_group9 = YES -a $ADPUPA_wait  = YES ]  &&  ./thread_9

cat $DATA/1.out $DATA/2.out $DATA/3.out $DATA/4.out $DATA/5.out $DATA/6.out \
 $DATA/7.out $DATA/8.out $DATA/9.out $DATA/10.out $DATA/11.out

set +x
echo " "
echo " "
set -x

[ -s $DATA/error1 ] && err1=`cat $DATA/error1`
[ -s $DATA/error2 ] && err2=`cat $DATA/error2`
[ -s $DATA/error3 ] && err3=`cat $DATA/error3`
[ -s $DATA/error4 ] && err4=`cat $DATA/error4`
[ -s $DATA/error5 ] && err5=`cat $DATA/error5`
[ -s $DATA/error6 ] && err6=`cat $DATA/error6`
[ -s $DATA/error7 ] && err7=`cat $DATA/error7`
[ -s $DATA/error8 ] && err8=`cat $DATA/error8`
[ -s $DATA/error9 ] && err9=`cat $DATA/error9`
[ -s $DATA/error10 ] && err10=`cat $DATA/error10`
[ -s $DATA/error11 ] && err11=`cat $DATA/error11`
#===============================================================================

export STATUS=YES
export DUMP_NUMBER=12
$ushscript_dump/bufr_dump_obs.sh $dumptime 3.00 1 null


#  endif test for existence of status file
fi

#  endif loop $PROCESS_DUMP
fi

#================================================================
#================================================================


if [ "$PROCESS_DUMP" = 'YES' ]; then

  if [ "$err1" -gt '5' -o "$err2" -gt '5' -o "$err3" -gt '5' -o \
       "$err4" -gt '5' -o "$err5" -gt '5' -o "$err6" -gt '5' -o \
       "$err7" -gt '5' -o "$err8" -gt '5' -o "$err9" -gt '5' -o \
       "$err10" -gt '5' -o "$err11" -gt '5']; then
      for n in $err1 $err2 $err3 $err4 $err5 $err6 $err7 $err8 $err9 $err10 $err11
      do
         if [ "$n" -gt '5' ]; then
            if [ "$n" -ne '11' -a "$n" -ne '22' ]; then

## fatal error in dumping of BUFR obs. files

               set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9, $err10, $err11"
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
               set -x
               $DATA/err_exit
               exit 9
            fi
         fi
      done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

      set +x
      echo
      echo " ###################################################### "
      echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9, $err10, $err11"
      echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
      echo " ###################################################### "
      echo
      set -x
   fi

#  endif loop $PROCESS_DUMP
fi

#  concatenate msonet and msone1, b/c prepobs only wants one file
cat ${COMSP}msone1.tm00.bufr_d >> ${COMSP}msonet.tm00.bufr_d

#
# copy bufr_dumplist to $COMOUT per NCO SPA request
# -------------------------------------------------
echo "Copy bufr_dumplist to comout"
LIST_cp=$COMOUT/${RUN}.t${cyc}z.bufr_dumplist.${tmmark}
cp ${FIXbufr_dump}/bufr_dumplist $LIST_cp
chmod 644 $LIST_cp

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout
 
sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/bash
#############################################################################
# This script excfs_cdas_vrfyfits.sh.sms processes fits to obs
# and generates the model verification statistis for CDAS/CFS
# Author:   Suranjana Saha -- Original Script
#           Shrinivas Moorthi -- Second version
#############################################################################
set -euax

export PATH=.:$PATH

##################################################
# Define input variables
##################################################
export CDUMPPREP=${CDUMPPREP:-gdas}
export CDUMPFCST=${CDUMPFCST:-gfs}
export CDUMPANAL=${CDUMPANAL:-$CDUMPPREP}
export cfsp=${cfsp:-cfs_}
export cfsd=${cfsd:-cfs_cdas_}
export NWPROD=${NWPROD:-/nwprod}
export SIGEVENTSH=${SIGEVENTSH:-$USHcfs/${cfsp}prevmpi.sh}
export BUFRPOSTSH=${BUFRPOSTSH:-$USHcfs/${cfsp}bufr_post.sh}
export FITSSH=${FITSSH:-$USHcfs/${cfsd}fits.sh}
export HORZSH=${HORZSH:-$USHcfs/${cfsd}horizn.sh}
export CNVDIAGEXEC=${CNVDIAGEXEC:-$EXECcfs/${cfsp}post_convdiag.x}
export COMOUT_FITX=${COMOUT_FITX:-$DATA}
export COMOUT=${COMOUT:-$DATA}
export SAVEPREP=${SAVEPREP:-NO}

##[ $NEMS = YES ] && { sig=gfn; sfc=sfn; } || { sig=sig; sfc=sfc; }

export PRVT=${PRVT:-$NWPROD/fix/prepobs_errtable.global}
export PREX=${PREX:-$EXECcfs/cfs_prevmpi.x}

export CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}

export HYBLEVS=${HYBLEVS:-/dev/null}
export PREC=$DATA/prec; echo  "&PREVDATA doanls=t,fits=t /" >$PREC

#################################################################

cd $DATA
echo "JOB $job HAS BEGUN"

# make bufr convdiag postevents for analysis only...
fh1=06
fh2=00
pdy=$(echo $CDATE | cut -c1-8)
hh=$(echo $CDATE | cut -c9-10)
cyc=$hh

set +u
eval COMIN_OBS=${COMIN_OBS:-$COMIN_ANALYSIS}
eval COMIN_ANALYSIS=${COMIN_ANALYSIS}
set -u

if [[ $OUTPUT_FILETYPE = nemsio || $OUTPUT_FILETYPE = netcdf ]] ; then
  [[ $OUTPUT_FILETYPE = nemsio ]] && suffix=nemsio || suffix=nc
  export PRPI=$COMIN_OBS/gdas.t${hh}z.prepbufr
  export PRPO=$COMOUT_FITX/gdas.t${hh}z.prepqa
  export PRPF=$COMOUT_FITX/gdas.t${hh}z.prepqf
  export sig1=$COMIN_ANALYSIS/gdas.t${hh}z.analysis.atm.a006.$suffix
  export sfc1=$COMIN_ANALYSIS/gdas.t${hh}z.analysis.atm.a006.$suffix
  export CNVS=$COMIN_ANALYSIS/gdas.t${hh}z.cnvstat.tar
elif [[ $OUTPUT_FILETYPE = cfs ]]; then
  tzz=t${hh}z
  export PRPI=$COMIN_OBS/cdas1.$tzz.prepbufr
  export PRPO=$COMOUT/cdas1.$tzz.prepqa
  export PRPF=$COMOUT_FITX/cdas1.$tzz.prepqf
  export sig1=$COMIN_ANALYSIS/cdas1.$tzz.sanl
  export sfc1=$COMIN_ANALYSIS/cdas1.$tzz.sfcanl
  export CNVS=$COMIN_ANALYSIS/cdas1.$tzz.cnvstat
else
  echo $OUTPUT_FILETYPE = unknown OUTPUT_FILETYPE; exit 999
fi

[ ${ACPROFit:-YES} != NO ] && PRPI=$($USHcfs/ACprof)

$BUFRPOSTSH $sig1 $CNVS $PRPI $PRPO $CDATE

[ "$CHGRP_RSTPROD" = 'YES' ] && chgrp rstprod $PRPO && chmod 640 $PRPO
[ $SAVEPREP = YES          ] && cp $PRPO $ARCDIR/$(basename $PRPO).06.00
[ $SAVEPREP = YES          ] && cp $PRPI $ARCDIR

$FITSSH     $CDATE $PRPO $COMOUT_FITX $DATA 06 00
$HORZSH     $CDATE $PRPO $COMOUT_FITX $DATA anl 2> horizout

#################################################################
# make prepqf file containing forecasts
#################################################################

cp $PRPO $PRPF || exit 2

if [ $hh = "00" -o $hh = "12" -o $hh = "06" -o $hh = "18" ] ; then
  fp1="fh1=12;fh2=36"
  fp2="fh1=24;fh2=48"
  fp3="fh1=60;fh2=84"
  fp4="fh1=72;fh2=96"
  fp5="fh1=108;fh2=120"
else
  exit
fi

# interpolate background from fh

tspan=6

for fp in $fp1 $fp2 $fp3 $fp4 $fp5
do
eval $fp
for fh in $fh1 $fh2
do

[ $fh = xx ] && continue

FDATE=$($NDATE -$fh $CDATE)
fdy=$(echo $FDATE|cut -c 1-8)
fzz=$(echo $FDATE|cut -c 9-10)
export COMIN_HISTORY="${COM_VRFYARCH:-${ROTDIR}}/gfs.${fdy}/${fzz}"

if [[ $OUTPUT_FILETYPE = nemsio || $OUTPUT_FILETYPE = netcdf ]] ; then
  fhm3=$((fh-$tspan)); [ $fhm3 -lt 10 ] && fhm3=0$fhm3; [ $fhm3 -lt 100 ] && fhm3=0$fhm3
  fhp3=$((fh+$tspan)); [ $fhp3 -lt 10 ] && fhp3=0$fhp3; [ $fhp3 -lt 100 ] && fhp3=0$fhp3
  fh00=$fh;            [ $fh00 -lt 10 ] && fh00=0$fh00; [ $fh00 -lt 100 ] && fh00=0$fh00
  tzz=t$(echo $FDATE|cut -c9-10)z
  [[ $OUTPUT_FILETYPE = nemsio ]] && suffix=nemsio || suffix=nc
  export sig1=$COMIN_HISTORY/gfs.$tzz.atm.f$fhm3.$suffix
  export sig2=$COMIN_HISTORY/gfs.$tzz.atm.f$fh00.$suffix
  export sig3=$COMIN_HISTORY/gfs.$tzz.atm.f$fhp3.$suffix
  export sfc1=$COMIN_HISTORY/gfs.$tzz.atm.f$fhm3.$suffix
  export sfc2=$COMIN_HISTORY/gfs.$tzz.atm.f$fh00.$suffix
  export sfc3=$COMIN_HISTORY/gfs.$tzz.atm.f$fhp3.$suffix
elif [[ $OUTPUT_FILETYPE = cfs ]]; then
  CDAM3=$($NDATE -$tspan  $CDATE)
  CDAP3=$($NDATE +$tspan  $CDATE)
  export sig1=$COMIN_HISTORY/sigf${CDAM3}.01.$FDATE
  export sig2=$COMIN_HISTORY/sigf${CDATE}.01.$FDATE
  export sig3=$COMIN_HISTORY/sigf${CDAP3}.01.$FDATE
  export sfc1=$COMIN_HISTORY/sfcf${CDAM3}.01.$FDATE
  export sfc2=$COMIN_HISTORY/sfcf${CDATE}.01.$FDATE
  export sfc3=$COMIN_HISTORY/sfcf${CDAP3}.01.$FDATE
else
  echo $OUTPUT_FILETYPE = unknown OUTPUT_FILETYPE; exit 999
fi

if [ -s $sig1 -a -s $sig2 -a -s $sig3 ] ; then
 [ -s $sfc1 -a -s $sfc2 -a -s $sfc3 ] && rsfc=t || rsfc=f
 [ $fh = $fh1 ] && echo  "&PREVDATA dofcst=t,nbax=3,span=$tspan,fits=t,rsfc=$rsfc /" >$PREC
 [ $fh = $fh2 ] && echo  "&PREVDATA doanls=t,nbax=3,span=$tspan,fits=t,rsfc=$rsfc /" >$PREC
 cp $PRPF prepqm; $SIGEVENTSH prepqm $CDATE; cp prepqm $PRPF
else
 [ $fh = $fh1 ] && fh1=xx
 [ $fh = $fh2 ] && fh2=xx
fi

done # endi of inner loop over two forecast times

if [ $fh1 != xx -o $fh2 != xx ] ; then
 [ "$CHGRP_RSTPROD" = 'YES' ] && chgrp rstprod $PRPF && chmod 640 $PRPF
 [ $SAVEPREP = YES          ] && cp $PRPF $ARCDIR/$(basename $PRPO).$fh1.$fh2
 $FITSSH $CDATE $PRPF $COMOUT_FITX $DATA $fh1 $fh2
 [ $hh = 00 -a $fh1 = 24 ] &&  $HORZSH $CDATE $PRPF $COMOUT_FITX $DATA fcs 2> horizout
 [ $hh = 12 -a $fh1 = 12 ] &&  $HORZSH $CDATE $PRPF $COMOUT_FITX $DATA fcs 2> horizout
fi

done # end of outer loop over multiple forecast times

########################################################
# copy the fit files to the FIT_DIR
########################################################

set +e

rm -f $COMOUT_FITX/fxx*

mkdir -p $FIT_DIR
cp $COMOUT_FITX/f*.raob.$CDATE  $FIT_DIR
cp $COMOUT_FITX/f*.acft.$CDATE  $FIT_DIR
cp $COMOUT_FITX/f*.acar.$CDATE  $FIT_DIR
cp $COMOUT_FITX/f*.surf.$CDATE  $FIT_DIR
cp $COMOUT_FITX/f*.sfc.$CDATE   $FIT_DIR

for typ in anl fcs
do
mkdir -p $HORZ_DIR/$typ
cp -p $COMOUT_FITX/adpupa.mand.$typ.$CDATE  $HORZ_DIR/$typ/adpupa.mand.$CDATE
cp -p $COMOUT_FITX/adpsfc.$typ.$CDATE       $HORZ_DIR/$typ/adpsfc.$CDATE
cp -p $COMOUT_FITX/sfcshp.$typ.$CDATE       $HORZ_DIR/$typ/sfcshp.$CDATE
cp -p $COMOUT_FITX/aircar.$typ.$CDATE       $HORZ_DIR/$typ/aircar.$CDATE
cp -p $COMOUT_FITX/aircft.$typ.$CDATE       $HORZ_DIR/$typ/aircft.$CDATE
done

################## END OF SCRIPT #######################
echo "ENDED NORMALLY."
cd $(dirname $DATA)
if [ ${KEEPDATA:-"NO"} = "NO" ] ; then rm -rf $DATA ; fi
################## END OF SCRIPT #######################

#!/bin/ksh
# Run under ksh (converted to WCOSS)


# This script performs wind profiler quality control checking
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# --------------------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)

# Imported variables that must be passed in:
#   DATA - path to working directory
#   PQCX - path to PREPOBS_PROFCQC program executable
#   PQCC - path to PREPOBS_PROFCQC program parm cards

# Imported variables that can be passed in:
#   jlogfile - string indicating path to joblog file (skipped over by this
#              script if not passed in)
#   pgmout   - string indicating path to standard output file (skipped
#              over by this script if not passed in)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1;fi

jlogfile=${jlogfile:=""}

rm $PRPI.profcqc
rm profcqc.monitor profcqc.events

pgm=`basename  $PQCX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

export FORT14=$PRPI
export FORT51=$PRPI.profcqc
export FORT52=profcqc.monitor1
export FORT53=profcqc.monitor2
export FORT54=profcqc.events1
export FORT55=profcqc.events2
export FORT61=profcqc.stats1
export FORT62=profcqc.stats2
TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
$TIMEIT $PQCX< $PQCC > outout 2> errfile
err=$?
###cat errfile
cat errfile >> outout
cat profcqc.events2 >> outout
cat outout >> profcqc.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for PREPOBS_PROFCQC is ' $err
echo
set -x
if [ $err -eq 4 ]; then
   msg="PREPBUFR DATA SET CONTAINS NO "PROFLR" TABLE A MESSAGES  --> non-fatal"
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
   err=0
fi
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.profcqc $PRPI
fi

exit 0

#!/bin/bash

set -eux

# Location of PWD and package source directory.
readonly pkg_root=$(cd "$(dirname "$(readlink -f -n "${BASH_SOURCE[0]}" )" )/.." && pwd -P)

INSTALL_TARGET=${INSTALL_TARGET:-"wcoss2"}
INSTALL_PREFIX=${INSTALL_PREFIX:-"${pkg_root}/install"}
MODULEFILE_INSTALL_PREFIX=${MODULEFILE_INSTALL_PREFIX:-"${INSTALL_PREFIX}/modulefiles"}

target="${INSTALL_TARGET,,}"
if [[ "${target}" =~ ^(wcoss2|hera|ursa|orion|hercules|gaeac5|gaeac6|aws-ec2|noaacloud)$ ]]; then
  # prepare the target specific build.ver and run.ver
  cd "${pkg_root}/versions" || exit 1
  rm -f build.ver run.ver
  cp "build.${target}.ver" "build.ver"
  cp "run.${target}.ver"   "run.ver"
  cd "${pkg_root}" || exit 1
  export HOMEprepobs="${pkg_root}"
  source "${pkg_root}/versions/build.ver"
  unset HOMEprepobs
#  set +x
  module purge
  module use "${pkg_root}/modulefiles"
  module load "prepobs_${target}"
  module list
  set -x
else
  echo "WARNING: Unknown target"
fi

# Create a build directory and cd into it.
[[ -d build  ]] && rm -rf build
mkdir -p build && cd build

# build and install.
cmake -DCMAKE_INSTALL_PREFIX="${INSTALL_PREFIX}" \
      -DCMAKE_INSTALL_BINDIR=exec \
      -DMODULEFILE_INSTALL_PREFIX="${MODULEFILE_INSTALL_PREFIX}" \
      ..
make -j "${BUILD_JOBS:-6}" VERBOSE="${BUILD_VERBOSE:-}"
make install

# Remove build directory upon successfull build and install
cd "${pkg_root}"
rm -rf build

exit 0

#!/bin/ksh
# Run under ksh

#############################################################################
echo "----------------------------------------------------------------------"
echo "exglobal_makeprepbufr.sh     - Global (GDAS, GFS) model prepbufr      "
echo "                               processing                             "
echo "----------------------------------------------------------------------"
echo "History:                                                              "
echo "  Mar  1 2013 - Original script.                                      "
echo "  Dec  3 2014 - CDAS network, split off into its own script           "
echo "  excdas_makeprepbufr.sh  This script now                        "
echo "  tailored exclusively to GDAS and GFS.                               "
echo "  Mar 11 2017 - Update to handle nemsio filename patterns             "
echo "  Mar 15 2019 - Added dbuoyb & mbuoyb to nsstfile content             "
echo "  Jun 10 2019 - Added *buoyb qc (MAKE_NSST_BUOYB & bufr_latlonqc.sh)  "
echo "  Jul 27 2020 - Added feature to use tstsp when generating nsstbufr   "
echo "  files. Set MAKE_NSST_BUOYB default to NO.                           "
echo "  Oct 09 2020 - Update to handle netcdf history filename patterns     "
echo "                Update to remove obsolete functionality of adding     "
echo "                bufr format buoy reports to nsstbufr file.  These data"
echo "                are now included in the sfcshp file, already included "
echo "                in the nsstbufr file.                                 " 
echo "  Dec 16 2021 - Renamed all *.sh.ecf scripts to *.sh                  "
echo "----------------------------------------------------------------------"
echo 
#############################################################################

set -x

# Make sure we are in the $DATA directory
mkdir -p $DATA
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"

cat break > $pgmout

CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}
MAKE_NSSTBUFR=${MAKE_NSSTBUFR:-YES}

export COMSP=${COMSP:-$COMIN/${RUN}.${cycle}.}
export COMSPtcvital=${COMSPtcvital:-$COMINtcvital/${RUN}.${cycle}.}
export tstsp=${tstsp:-/tmp/null/}

if [ "$DO_QC" = 'YES' -a "$CQCBUFR" = 'YES' -a -n "$COM1" -a -n "$CQCC" ]; then

# NOTE: The following logic currently does not apply to the GFS or GDAS
#       network.  (It applies only to the CDAS network.)  It is maintained here
#       in case it ever does.
# -----------------------------------------------------------------------------
# If running PREPOBS_CQCBUFR, must check its data cards to see if
#  namelist switch DOTMP is TRUE - if so, must get prepbufr_pre-qc files
#   from t-24, t-12, t+12, t+24 to feed into PREPOBS_CQCBUFR

   DOTMP=`grep DOTMP $CQCC | awk -F, \
    '{print $1; print $2; print $3; print $4; print$5}' | grep DOTMP | \
    awk -F= '{print $2}'`

   if [[ $DOTMP = *T* ]]; then
      [ -s ${COM1}${PDYm1}/${RUN}.${cycle}.prepbufr_pre-qc ]  && \
       export PRPI_m24=${COM1}${PDYm1}/${RUN}.${cycle}.prepbufr_pre-qc
      [ -s ${COM1}${PDYp1}/${RUN}.${cycle}.prepbufr_pre-qc ]  && \
       export PRPI_p24=${COM1}${PDYp1}/${RUN}.${cycle}.prepbufr_pre-qc
      tdate10=`$NDATE -12 $PDY$cyc`
      cyc_m12=`echo $tdate10|cut -c9-10`
      pdy_m12=`echo $tdate10|cut -c1-8`
      [ -s ${COM1}${pdy_m12}/${RUN}.t${cyc_m12}z.prepbufr_pre-qc ]  && \
       export PRPI_m12=${COM1}${pdy_m12}/${RUN}.t${cyc_m12}z.prepbufr_pre-qc
      tdate10=`$NDATE +12 $PDY$cyc`
      cyc_p12=`echo $tdate10|cut -c9-10`
      pdy_p12=`echo $tdate10|cut -c1-8`
      [ -s ${COM1}${pdy_p12}/${RUN}.t${cyc_p12}z.prepbufr_pre-qc ]  && \
       export PRPI_p12=${COM1}${pdy_p12}/${RUN}.t${cyc_p12}z.prepbufr_pre-qc
   fi
fi

cdate10=${cdate10:-`cut -c7-16 ncepdate`}

msg="CENTER TIME FOR PREPBUFR PROCESSING IS $cdate10"
$DATA/postmsg "$jlogfile" "$msg"

ksh $ushscript_prep/prepobs_makeprepbufr.sh $cdate10
errsc=$?

[ "$errsc" -ne '0' ]  &&  exit $errsc

if [ "$CHGRP_RSTPROD" = 'YES' ]; then
   msg="NOTE: These files (if present) are RESTRICTED to rstprod group: \
prepbufr_pre-qc, prepbufr, prepbufr.acft_profiles*, acqc_???*, \
acqc_merged*_sorted, tosslist, prepbufr.unblok"
   $DATA/postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi
warning=no

if [ "$PREPDATA" = 'YES' ]; then

# save snapshot of prepbufr file after PREPOBS_PREPDATA in COMOUT
   cp prepda.prepdata $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
   chmod 664 $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc

   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
         warning=yes
      fi
   fi

# save current prepbufr mnemonic table in COMOUT if either it isn't already
#  there for a previous cycle or if it has changed from a previous cycle
   if [ ! -s $COMOUT/*prep.bufrtable ]; then
      cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable
   else
      diff `ls -t  $COMOUT/*prep.bufrtable | head -n1` prep.bufrtable \
       > /dev/null 2>&1
      errdiff=$?
      [ "$errdiff" -ne '0' ]  &&  \
       cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable
   fi
fi

# save global guess file(s) in COMOUT if they haven't already been saved
#  here by previous tropical cyclone relocation processing
#  first block is for netcdf history input, second is for nemsio input, 
#  third block is for sigio input.
if [[ "$NETCDF_IN" == .true. ]]; then
   [ -s sgm3prep -a ! -s $COMOUT/${RUN}.${cycle}.atmgm3.nc ]  &&  \
    cp sgm3prep $COMOUT/${RUN}.${cycle}.atmgm3.nc
   [ -s sgp3prep -a ! -s $COMOUT/${RUN}.${cycle}.atmgp3.nc ]  &&  \
    cp sgp3prep $COMOUT/${RUN}.${cycle}.atmgp3.nc
   if [ -s sgesprep ]; then
      if [ -s sgesprepA ]; then
         cp sgesprep  $COMOUT/${RUN}.${cycle}.atmges.nc_before
         cp sgesprepA $COMOUT/${RUN}.${cycle}.atmges.nc_after
      else
         [ ! -s $COMOUT/${RUN}.${cycle}.atmges.nc ]  &&  \
         cp sgesprep $COMOUT/${RUN}.${cycle}.atmges.nc
      fi
   fi
elif [[ "$NEMSIO_IN" == .true. ]]; then
   [ -s sgm3prep -a ! -s $COMOUT/${RUN}.${cycle}.atmgm3.nemsio ]  &&  \
    cp sgm3prep $COMOUT/${RUN}.${cycle}.atmgm3.nemsio
   [ -s sgp3prep -a ! -s $COMOUT/${RUN}.${cycle}.atmgp3.nemsio ]  &&  \
    cp sgp3prep $COMOUT/${RUN}.${cycle}.atmgp3.nemsio
   if [ -s sgesprep ]; then
      if [ -s sgesprepA ]; then
         cp sgesprep  $COMOUT/${RUN}.${cycle}.atmges.nemsio_before
         cp sgesprepA $COMOUT/${RUN}.${cycle}.atmges.nemsio_after
      else
         [ ! -s $COMOUT/${RUN}.${cycle}.atmges.nemsio ]  &&  \
         cp sgesprep $COMOUT/${RUN}.${cycle}.atmges.nemsio
      fi
   fi
else
   [ -s sgm3prep -a ! -s $COMOUT/${RUN}.${cycle}.sgm3prep ]  &&  \
    cp sgm3prep $COMOUT/${RUN}.${cycle}.sgm3prep
   [ -s sgp3prep -a ! -s $COMOUT/${RUN}.${cycle}.sgp3prep ]  &&  \
    cp sgp3prep $COMOUT/${RUN}.${cycle}.sgp3prep
   if [ -s sgesprep ]; then
      if [ -s sgesprepA ]; then
         cp sgesprep  $COMOUT/${RUN}.${cycle}.sgesprep_before
         cp sgesprepA $COMOUT/${RUN}.${cycle}.sgesprep_after
      else
         [ ! -s $COMOUT/${RUN}.${cycle}.sgesprep ]  &&  \
          cp sgesprep $COMOUT/${RUN}.${cycle}.sgesprep
      fi
   fi
fi
# end netcdf history vs nemsio vs sigio logic to copy guess files to COMOUT

# save path name of global guess file valid at center PREPBUFR
#  date/time (encoded into PREPBUFR file and used by q.c. programs) in COMOUT
# FOR NOW, staying with term "sgesprep" for these "pathname" filenames even for
# netcdf history or nemsio (as done in tropical cyclone relocation processing) - 03/2017, 11/2019
if [ "$GETGUESS" = 'YES' ]; then
   if [[ "$NETCDF_IN" == .true. ]]; then
      set +x; echo -e "\n\"sges_pathname\" files point to netcdf history files\n";set -x
   elif [[ "$NEMSIO_IN" == .true. ]]; then
      set +x; echo -e "\n\"sges_pathname\" files point to nemsio files\n";set -x
   fi
   if [ -s sgesprepA_pathname ]; then
      cp sgesprep_pathname \
       $COMOUT/${RUN}.${cycle}.sgesprep_pathname_before.$tmmark
      cp sgesprepA_pathname \
       $COMOUT/${RUN}.${cycle}.sgesprep_pathname_after.$tmmark
   else

#   if the target file already exists, it was created in previous
#    tropcy_relocate.sh script because either there was an error or no
#    tcvitals were present - in this case the target file points to the orig.
#    getges global sigma guess (since the guess was not modified by relocation)
#    - otherwise sgesprep_pathname will either contain either the path to the
#      getges guess (if tropical cyclone relocation did not run previously) or
#      it will contain the path to the modified sgesprep guess (if tropical
#      cyclone relocation did run previously and did modify the guess)
#   ---------------------------------------------------------------------------

      [ ! -s $COMOUT/${RUN}.${cycle}.sgesprep_pathname.$tmmark ]  &&  \
      cp sgesprep_pathname $COMOUT/${RUN}.${cycle}.sgesprep_pathname.$tmmark
   fi
fi

# save synthetic bogus files in COMOUT
[ -s bogrept ]  &&  cp bogrept  $COMOUT/${RUN}.${cycle}.syndata.bogrept
[ -s bogdata ]  &&  cp bogdata  $COMOUT/${RUN}.${cycle}.syndata.bogdata
[ -s dthistry ] &&  cp dthistry $COMOUT/${RUN}.${cycle}.syndata.dthistry

if [[ "$SENDDBN" == "YES" ]]; then
   if [[ "$RUN" == "gfs" || "$RUN" == "gdas" || "$RUN" == "gdas1" ]]; then
      RUN_uc=$(echo $RUN | tr [a-z] [A-Z])
      if [[ -s bogrept ]]; then
         $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_TCI $job $COMOUT/${RUN}.${cycle}.syndata.bogrept
      fi
      if [[ -s bogdata ]]; then
         $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_TCI $job $COMOUT/${RUN}.${cycle}.syndata.bogdata
      fi
   fi
fi

if [ "$DO_QC" = 'YES' ]; then

# save final form of prepbufr file in COMOUT
   cp prepda.${cycle} $COMOUT/${RUN}.${cycle}.prepbufr
   chmod 664 $COMOUT/${RUN}.${cycle}.prepbufr
   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr
         warning=yes
      fi
   fi

# save prepacqc prepbufr.acft_profiles file in COMOUT
   if [ -s prepbufr.acft_profiles ]; then
      cp prepbufr.acft_profiles  $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
            warning=yes
         fi
      fi
   fi

# save prepacqc prepbufr.acft_profiles_sfc file in COMOUT
   if [ -s prepbufr.acft_profiles_sfc ]; then
      cp prepbufr.acft_profiles_sfc  \
       $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
            warning=yes
         fi
      fi
   fi

# save prepacqc output files in COMOUT
   if [ -s acftqc_*.sus ]; then
      mv acftqc_*.sus acftqc_sus
      cp acftqc_sus $COMOUT/${RUN}.${cycle}.acqc_sus
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_sus
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_sus
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_sus
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.stk ]; then
      mv acftqc_*.stk acftqc_stk
      cp acftqc_stk $COMOUT/${RUN}.${cycle}.acqc_stk
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_stk
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_stk
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_stk
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.spk ]; then
      mv acftqc_*.spk acftqc_spk
      cp acftqc_spk $COMOUT/${RUN}.${cycle}.acqc_spk
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_spk
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_spk
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_spk
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.ord ]; then
      mv acftqc_*.ord acftqc_ord
      cp acftqc_ord $COMOUT/${RUN}.${cycle}.acqc_ord
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_ord
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_ord
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_ord
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.lst ]; then
      mv acftqc_*.lst acftqc_lst
      cp acftqc_lst $COMOUT/${RUN}.${cycle}.acqc_lst
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_lst
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_lst
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_lst
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inv ]; then
      mv acftqc_*.inv acftqc_inv
      cp acftqc_inv $COMOUT/${RUN}.${cycle}.acqc_inv
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inv
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inv
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inv
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inc ]; then
      mv acftqc_*.inc acftqc_inc
      cp acftqc_inc $COMOUT/${RUN}.${cycle}.acqc_inc
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inc
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inc
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inc
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.grc ]; then
      mv acftqc_*.grc acftqc_grc
      cp acftqc_grc $COMOUT/${RUN}.${cycle}.acqc_grc
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_grc
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_grc
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_grc
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.dup ]; then
      mv acftqc_*.dup acftqc_dup
      cp acftqc_dup $COMOUT/${RUN}.${cycle}.acqc_dup
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_dup
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_dup
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_dup
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.log ]; then
      mv acftqc_*.log acftqc_log
      cp acftqc_log $COMOUT/${RUN}.${cycle}.acqc_log
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_log
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_log
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_log
            warning=yes
         fi
      fi
   fi

   if [ -s merged.reports.post_acftobs_qc.sorted ]; then
      cp merged.reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
            warning=yes
         fi
      fi
   fi

   if [ -s merged.profile_reports.post_acftobs_qc.sorted ]; then
      cp merged.profile_reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
            warning=yes
         fi
      fi
   fi

# save cqcbufr output files in COMOUT
   touch cqc_events
   cp cqc_events $COMOUT/${RUN}.${cycle}.cqc_events
   touch cqc_stncnt
   cp cqc_stncnt $COMOUT/${RUN}.${cycle}.cqc_stncnt
   touch cqc_stnlst
   cp cqc_stnlst $COMOUT/${RUN}.${cycle}.cqc_stnlst
   touch cqc_sdm
   cp cqc_sdm $COMOUT/${RUN}.${cycle}.cqc_sdm
   touch cqc_radcor
   cp cqc_radcor $COMOUT/${RUN}.${cycle}.cqc_radcor

# save oiqc tosslist in COMOUT (if it runs)
   if [ -s tosslist ]; then
      cp tosslist  $COMOUT/${RUN}.${cycle}.tosslist
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.tosslist
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.tosslist
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.tosslist
            warning=yes
         fi
      fi
   fi

   # Remove the following logic to create unblocked prepbufr files once we know
   #  it is definitely no longer needed.
   if [ "${PROCESS_UNBLKBUFR:-NO}" = 'YES' ]; then
# 
# make unblocked prepbufr file
# ---> ON WCOSS prepbufr is already unblocked, so for now just copy it to the
#      unblok file location used before on CCS - hopefully this can be removed
#      someday!
      cp -p  prepda.${cycle} prepda.${cycle}.unblok
      err_cp=$?
      if [ $err_cp -eq 0 ]; then
         cp prepda.${cycle}.unblok $COMOUT/${RUN}.${cycle}.prepbufr.unblok
         chmod 664 $COMOUT/${RUN}.${cycle}.prepbufr.unblok
         if [ "$CHGRP_RSTPROD" = 'YES' ]; then
            chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.unblok
            errch=$?
            if [ $errch -eq 0 ]; then
               chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.unblok
            else
               cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.unblok
               warning=yes
            fi
         fi
      fi
   fi  ## end logic to potentially create unblok version of prepbufr file

   if [[ "$SENDDBN" == "YES" ]]; then
      if [[ "$RUN" == "gdas" || "$RUN" == "gdas1" ]]; then
         RUN_uc=$(echo $RUN | tr [a-z] [A-Z])
         $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_PREPda $job \
          $COMOUT/${RUN}.${cycle}.prepbufr
         $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_acft $job \
          $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
         if [ "${PROCESS_UNBLKBUFR:-NO}" = 'YES' ]; then
            $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_PREPda_unblok $job \
             $COMOUT/${RUN}.${cycle}.prepbufr.unblok
         fi
      elif [[ "$RUN" == "gfs" ]]; then
         $DBNROOT/bin/dbn_alert MODEL GFS_BUFR_PREPda $job \
          $COMOUT/${RUN}.${cycle}.prepbufr
         if [ "${PROCESS_UNBLKBUFR:-NO}" = 'YES' ]; then
            $DBNROOT/bin/dbn_alert MODEL GFS_BUFR_PREPda_unblok $job \
            $COMOUT/${RUN}.${cycle}.prepbufr.unblok
         fi
         if [[ "$NETCDF_IN" == .true. ]]; then
            $DBNROOT/bin/dbn_alert MODEL GFS_atmges_NETCDF $job \
             $COMOUT/${RUN}.${cycle}.atmges.nc
            $DBNROOT/bin/dbn_alert MODEL GFS_atmgm3_NETCDF $job \
             $COMOUT/${RUN}.${cycle}.atmgm3.nc
            $DBNROOT/bin/dbn_alert MODEL GFS_atmgp3_NETCDF $job \
             $COMOUT/${RUN}.${cycle}.atmgp3.nc
         elif [[ "$NEMSIO_IN" == .true. ]]; then
            $DBNROOT/bin/dbn_alert MODEL GFS_atmges_NEMSIO $job \
             $COMOUT/${RUN}.${cycle}.atmges.nemsio
            $DBNROOT/bin/dbn_alert MODEL GFS_atmgm3_NEMSIO $job \
             $COMOUT/${RUN}.${cycle}.atmgm3.nemsio
            $DBNROOT/bin/dbn_alert MODEL GFS_atmgp3_NEMSIO $job \
             $COMOUT/${RUN}.${cycle}.atmgp3.nemsio
         else
            $DBNROOT/bin/dbn_alert MODEL GFS_sges_PREP $job \
             $COMOUT/${RUN}.${cycle}.sgesprep
            $DBNROOT/bin/dbn_alert MODEL GFS_sgm3_PREP $job \
             $COMOUT/${RUN}.${cycle}.sgm3prep
            $DBNROOT/bin/dbn_alert MODEL GFS_sgp3_PREP $job \
             $COMOUT/${RUN}.${cycle}.sgp3prep
         fi
      fi
   fi
fi  # end [ "$DO_QC" = 'YES' ]
## create combined ocean data dump file expected by NSST
if [[ "$MAKE_NSSTBUFR" == 'YES' ]]; then
   > nsstbufr
   chgrp rstprod nsstbufr
   err_ch=0
   if [[ "${CHGRP_RSTPROD}" == 'YES' ]]; then
      chgrp rstprod nsstbufr
      err_ch=$?
   fi
   if [ $err_ch -eq 0 ]; then

      DTYPS_nsst='sfcshp tesac bathy trkob subpfl saldrn'

      echo "xglm: DTYPS_nsst='$DTYPS_nsst'"

      for type in $DTYPS_nsst ; do
         if [ -f ${tstsp}$type.$tmmark.bufr_d ]; then
            file=${tstsp}$type.$tmmark.bufr_d
         elif [ -s ${COMSP}$type.$tmmark.bufr_d ]; then
            file=${COMSP}$type.$tmmark.bufr_d
         fi

         if [ -s $file ]; then
              cat $file >> nsstbufr
              err_cat=$?
            if [ $err_cat -ne 0 ]; then
              msg="**WARNING: exit status $err_cat from cat of $file to nsstbufr"
              $DATA/postmsg "$jlogfile" "$msg"
            fi
         else
            echo $file is empty or does not exist
         fi # [ -s $file ]

      done # for type in $DTYPS_nsst 

      cp nsstbufr $COMOUT/${RUN}.${cycle}.nsstbufr
      if [[ "${CHGRP_RSTPROD}" == 'YES' ]]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.nsstbufr
         chmod 640 $COMOUT/${RUN}.${cycle}.nsstbufr
         msg="NOTE: nsstbufr file contains RESTRICTED data, only users in rstprod group have read permission"
         $DATA/postmsg "$jlogfile" "$msg"
      fi
   else
      cp /dev/null $COMOUT/${RUN}.${cycle}.nsstbufr
      warning=yes
   fi # if [ $err_ch -eq 0 ]
fi # if [[ "$MAKE_NSSTBUFR" == 'YES' ]]

if [ "$warning" = 'yes' ]; then
   msg="**WARNING: Since user $USER is not in rstprod group all RESTRICTED \
files are replaced with a null file"
   $DATA/postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi

########################################################

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/ksh 
set -x

export cmodel=gfs
export ymdh=${PDY}${cyc}
#export gfsdir=/gpfs/dell1/nco/ops/com/gfs/prod
export gfsdir=${gfsdir:-/gpfs/dell1/nco/ops/com/gfs/prod}

export pert="p01"
pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#-----------input data checking -----------------
#${USHens_tracker}/data_check.sh 
#${USHens_tracker}/data_check_gfs.sh
${USHens_tracker}/data_check_gfs_180hr.sh
## exit code 6 = missing data of opportunity
if [ $? -eq 6 ]; then exit; fi
#------------------------------------------------

outfile=${pertdir}/fsugenesis.${cmodel}.${pert}.${ymdh}.out

if [[ -d /lfs/h1 ]] ; then  
  # We are on NOAA Cactus or Dogwood
  machine=wcoss2
  ${USHens_tracker}/extrkr_fsu.sh ${cmodel} ${ymdh} ${pertdir} ${gfsdir}  #2>&1 >${outfile}	

else
  export machine=unknown
  echo Job failed: unknown platform 1>&2
  err_exit "FAILED ${jobid} - ERROR IN unknown platform - ABNORMAL EXIT"

fi
export err=$?; err_chk

if [ "$SENDCOM" = 'YES' ]; then
  cp -r ${pertdir}/tracker/${cmodel}/* ${COMOUT}
fi

#!/bin/ksh
#############################################################################
echo "----------------------------------------------------------------------"
echo "exglobal_dump.sh - Global (GDAS, GFS) network data dump processing"
echo "----------------------------------------------------------------------"
echo "History: Jan 18 2000 - Original script.                               "
echo "         May 16 2007 - Added DBNet alerts for GFS products.           "
echo "            Apr 2014 - Pick up grib files for planned GFS upgrade.    "
echo "            Oct 2014 - Remove attempts to dump obsolete sources.      "
echo "            Nov 2014 - Use parallel scripting to process dump groups. "
echo "                       Widen hourly satwnd dump window for GFS/GDAS.  "
echo "                       Add new satwnd subtypes for GFS & GDAS.        "
echo "                       GFS/GDAS continue if surface file unavailable. "
echo "                       Remove DBNet alerts for old surface files.     "
echo "         Dec  3 2014 - CDAS network, split off into its own script    "
echo "                       excdas_dump.sh.ecf.  This script now tailored  "
echo "                       exclusively to GDAS and GFS.                   "
echo "         Feb  2 2015 - Dump window for new satwnd type NC005090 set   "
echo "                       to 3.00 to +2.99 hours about center dump time. "
echo "                       Removed ADD_satwnd=\"005019 005080\" since     "
echo "                       types are now part of "satwnd" dump group      "
echo "                       mnemonic in bufr_dumplist.                     "
echo "         Aug 22 2016 - GSPIPW dump window reset for new data stream   "
echo "                         (moved to dump group #4 where TIME_TRIM=on)  "
echo "         Jan  5 2017 - Dump new satellite data types. Reordered to    "
echo "                       improve run time with all the new data.        "
echo "         Feb  8 2017 - Update to run on Cray-XC40 or IBM iDataPlex    "
echo "         Nov 13 2017 - Add dump of GOES-16 AMV's in tanks b005/xx030, "
echo "                       b005/xx031, b005/xx032, b005/xx034 and         "
echo "                       b005/xx039.  Set dump window to -3.00 to +2.99 "
echo "                       hours for these 5 new GOES-16 tanks.           "
echo "         Aug 10 2018 - Updated to run on Dell-p3 (as well as Cray-XC40"
echo "                       and IBM iDataPlex.                             "
echo "         Oct 24 2018 - Add dump of OMPS VSN8 nadir profile (NP) and   "
echo "                       total column (TC), Indiasat AMV's in tanks     "
echo "                       b005/xx024 b005/xx025 b005/xx026.              "
echo "         Mar 15 2019 - Add dumps of BUFR-feed drifting (NC001102) &   "
echo "                       moored (NC001203) buoys to DUMP group #2       "
echo "         Aug 15 2019 - rm'd background threads; now run serially;     "
echo "                       added "./" on "thread_*", needed for Dell/ph3  "
echo "                       Disabled processing that copies sstoi files to "
echo "                       COMSP.                                         "
echo "         Oct 15 2019 - set DTIM_LATEST_00110[23]=+2.99, as in sfcshp  "
echo "         Oct 26 2019 - set DTIM_EARLIEST_005091=-3.00 and             "
echo "                       DTIM_LATEST_005091=+2.99.  DTIM_* settings for "
echo "                       005090 are obsolete; added SKIP_005090=YES     "
echo "         Jan 03 2020 - turn on gdas.tCCz.saphir.tm00.bufr_d alerts,   "
echo "                       per DF request                                 "
echo "         Apr 06 2020 - Update to remove crisdb and escris and replace "
echo "                       with crsfdb and escrsf.  On Apr 22, 2020, NSR  "
echo "                       CrIS data from NPP is being replaced by FSR.   "
echo "                       The cris dump group is obsolete with the change"
echo "                       to FSR.                                        "
echo "         Aug 20 2020 - Incremented subsets for the adpsfc and sfcshp  "
echo "                       dump groups to match bufr_dumplist.            "
echo "                       Removed mbuoyb and dbuoyb from dump group #2.  "
echo "                       Removed obsolete dump groups escrsf and goesfv "
echo "                       from dump group #7.                            "
echo "                     - In Dump group #8, disabled processing of legacy"
echo "                       EUMETSAT AMV subsets 005064, 005065, and       "
echo "                       005066. Added DTIM settings for new WMO BUFR   "
echo "                       format EUMETSAT AMV subsets 005067, 005068, and"
echo "                       005069. On Oct 6, 2020, EUMETSAT AMV format    "
echo "                       changes to use new WMO BUFR sequence, 3-10-077."
echo "         Oct 09 2020 - Update to dump gsrcsr, gsrasr, ompslp, ahicsr, "
echo "                       sstvcw, sstvpw, leogeo, hdob                   "
echo "                       Update to remove obsolete GOES-15 data.        "
echo "                       Update to remove legacy VIIRS AMV data.        "
echo "         Feb 22 2021 - Disabled DBN alerts for gpsro dump files.      "
echo "                       These gpsro dump files have the potential to   "
echo "                       contain commercial data.  The equivalent       "
echo "                       non-restricted gpsro dump files are alerted    "
echo "                       instead.                                       "
echo "         Sep 21 2020 - Incremented subsets for the sfcshp dump groups "
echo "                       to match bufr_dumplist. Removed tideg from     "
echo "                       sfcshp dump group to make individual dump file."
echo "                     - Copy bufr_dumplist to COMOUT.                  "
echo "         Dec 16 2021 - modified to work on WCOSS2                     "
echo "         Mar 09 2022 - Enable the dumping of 002017 in vadwnd dump    "
echo "                       group.                                         "
echo "         Aug 10 2022 - subpfl and saldrn added to dump group #1.      "
echo "                       gmi1cr added to dump group #9                  "
echo "                       snocvr added to dump group #2                  "
echo "                       b005/xx081 added to satwnd                     "
echo "                       subpfl aadded to nsstbufr file                 "
echo "	                     DBN alerts are also enabled for subpfl,saldrn, "
echo "                       gmi1cr,and snocvr                              "
echo "         Oct 17 2022 - Split up groups 1 and 10 into a new group 12   "
echo "                       for better optimization.                       "
echo "         Sep 30 2022 - Enable dumping of UPRAIR data in group #3.     "
#############################################################################

# NOTE: NET is changed to gdas in the parent Job script for the gdas RUN 
#       (was gfs - NET remains gfs for gfs RUN)
# -----------------------------------------------------------------------

set -xau

# function to highlight an echoed msg with surrounding hashed separator lines.
   echo_hashed_msg () {
     set +x
     msg=$*
     echo -e "\n ${msg//?/#}"
     echo " ${msg}"
     echo -e " ${msg//?/#}\n"
     set -x
   }
# end of function setup
#
# set some variables if they have not already been set

set +u

# JOB_NUMBER = 1 indicates the prepbufr dump job.
# JOB_NUMBER = 2 indicates the non-prepbufr dump job.
# JOB_NUMBER not present indicates dump BOTH prepbufr and non-prepbufr data.
# -----------------------------------------------------------------------------
# Dump group #1 (non-pb, TIME_TRIM defaults to OFF) =
#               avcsam eshrs3 ssmisu 1bhrs4 tesac mls
#               esatms gsrcsr ahicsr sstvcw subpfl saldrn
#               Stop: sevcsr, saphir in v1.2.0 
# Dump group #2 (pb, TIME_TRIM defaults to OFF) =
#               sfcshp tideg atovs* adpsfc ascatt snocvr
#                   * - for GDAS only
#
# Dump group #3 (pb, TIME_TRIM defaults to OFF) =
#               adpupa
#
# Dump group #4 (pb, TIME_TRIM defaults to ON) =
#               aircar aircft proflr vadwnd rassda gpsipw hdob 
#
# Dump group #5 (pb, TIME_TRIM defaults to OFF) =
#               msonet
#
# Dump group #6 (non-pb, TIME_TRIM defaults to OFF) =
#               nexrad
#
# Dump group #7 (non-pb, TIME_TRIM defaults to OFF) =
#               avcspm esmhs 1bmhs airsev atmsdb gome omi trkob gpsro
#               crisf4
#
# Dump group #8 (pb, TIME_TRIM defaults to ON) =
#               satwnd
#
# Dump group #9 (non-pb, TIME_TRIM defaults to ON) =
#               geoimr gmi1cr satwhr
# Dump group #10 (non-pb, TIME_TRIM defaults to OFF) =
#               esiasi mtiasi esamua sevasr 1bamua bathy
#               osbuv8 ompst8 ompsn8 gsrasr ompslp sstvpw
#
# Dump group #11 (non-pb, TIME_TRIM defaults to OFF) =
#               amsr2
#
# Dump group #12 crisfs atms (previously group1)
#                crsfdb iasidb (previously group10)
# Dump group #13 (pb, TIME_TRIM defaults to OFF) = 
#                uprair
#
# Dump group #14 STATUS FILE
# -----------------------------------------------------------------------------

#VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
# The settings below are based on a future change when the DUMP job will dump
#  only types that go into PREPBUFR and the DUMP2 job will dump only types that
#  do not go into PREPBUFR.  This will speed up the DUMP + PREP processing.
# Although the logic is in place to now do this (see below), for now we will
#  continue to run only a DUMP job which will dump ALL types (no DUMP2 job) -
#  since JOB_NUMBER is not imported to this script, the logic below will dump
#  all types ...
# -----------------------------------------------------------------------------
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

if [ -n "$JOB_NUMBER" ]; then
set -u
   if [ $JOB_NUMBER = 2 ]; then
      dump_ind=DUMP2
      DUMP_group1=${DUMP_group1:-"YES"}
      DUMP_group2=${DUMP_group2:-"NO"}
      DUMP_group3=${DUMP_group3:-"NO"}
      DUMP_group4=${DUMP_group4:-"NO"}
      DUMP_group5=${DUMP_group5:-"NO"}
      DUMP_group6=${DUMP_group6:-"NO"}
      DUMP_group7=${DUMP_group7:-"YES"}
      DUMP_group8=${DUMP_group8:-"NO"}
      DUMP_group9=${DUMP_group9:-"YES"}
      DUMP_group10=${DUMP_group10:-"YES"}
      DUMP_group11=${DUMP_group11:-"YES"}
      DUMP_group12=${DUMP_group12:-"YES"}
      DUMP_group13=${DUMP_group13:-"NO"}
   else
      dump_ind=DUMP
      DUMP_group1=${DUMP_group1:-"NO"}
      DUMP_group2=${DUMP_group2:-"YES"}
      DUMP_group3=${DUMP_group3:-"YES"}
      DUMP_group4=${DUMP_group4:-"YES"}
      DUMP_group5=${DUMP_group5:-"NO"}
      DUMP_group6=${DUMP_group6:-"NO"}
      DUMP_group7=${DUMP_group7:-"NO"}
      DUMP_group8=${DUMP_group8:-"YES"}
      DUMP_group9=${DUMP_group9:-"NO"}
      DUMP_group10=${DUMP_group10:-"NO"}
      DUMP_group11=${DUMP_group11:-"NO"}
      DUMP_group12=${DUMP_group12:-"NO"}
      DUMP_group13=${DUMP_group13:-"YES"}
   fi
else
   dump_ind=DUMP
   DUMP_group1=${DUMP_group1:-"YES"}
   DUMP_group2=${DUMP_group2:-"YES"}
   DUMP_group3=${DUMP_group3:-"YES"}
   DUMP_group4=${DUMP_group4:-"YES"}
   DUMP_group5=${DUMP_group5:-"NO"}
   DUMP_group6=${DUMP_group6:-"NO"}
   DUMP_group7=${DUMP_group7:-"YES"}
   DUMP_group8=${DUMP_group8:-"YES"}
   DUMP_group9=${DUMP_group9:-"YES"}
   DUMP_group10=${DUMP_group10:-"YES"}
   DUMP_group11=${DUMP_group11:-"YES"}
   DUMP_group12=${DUMP_group12:-"YES"}
   DUMP_group13=${DUMP_group13:-"YES"}
fi

# NAP and NAP_adpupa instroduced so that uprair can run early on his own
NAP=${NAP:-600} #b/c cron is moved to run 10min (600s) early
if [ "$NET" = 'gfs' ]; then
   ADPUPA_wait=${ADPUPA_wait:-"YES"}
   NAP_adpupa=${NAP_adpupa:-800} #600s(compensate early cron) + 300s(for adpupa data to come)
########ADPUPA_wait=${ADPUPA_wait:-"NO"} # saves time if ADPUPA_wait=NO
else
   ADPUPA_wait=${ADPUPA_wait:-"NO"}
   NAP_adpupa=${NAP_adpupa:-600} #like other dump groups
fi

# send extra output of DUMP2 for monitoring purposes.
set +u
if [ -n "$JOB_NUMBER" ]; then
   [ $JOB_NUMBER = 2 ]  && export PS4='$SECONDS + '
fi
set -u

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"

cat break > $pgmout

export dumptime=`cut -c7-16 ncepdate`
export cycp=`echo $dumptime|cut -c9-10`

export NET_uc=$(echo $NET | tr [a-z] [A-Z])
export tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])

msg="$NET_uc ANALYSIS TIME IS $PDY$cyc"
$DATA/postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR $tmmark_uc $NET_uc IS $dumptime"
echo
set -x

export COMSP=$COMOUT/$RUN.${cycle}.

if [ "$PROCESS_GRIBFLDS" = 'YES' ]; then

########################################################
########################################################
## The following files are not *required* but will still
#   be processed here for the near term (missing files
#   will not cause job to fail)
# 
#  copy snogrb (0.5 deg) from $TANK_GRIBFLDS
#  copy snogrb_t574      from $TANK_GRIBFLDS
#  copy engicegrb        from $COM_ENGICE
#  copy sstgrb           from $COM_SSTOI
#  generate sstgrb index file
########################################################
########################################################

   # JY - 05/02: remove the dependency of snowdepth files created from isnowgrib job
   #snogrb=$TANK_GRIBFLDS/$PDY/wgrbbul/snowdepth.global.grb
   #snoold=$TANK_GRIBFLDS/$PDYm1/wgrbbul/snowdepth.global.grb

   #if [ -s $snogrb ]; then
   #   cp $snogrb ${COMSP}snogrb
   #   msg="todays 0.5 degree snow grib file located and copied to ${COMSP}snogrb"
   #   $DATA/postmsg "$jlogfile" "$msg"
   #elif [ -s $snoold ]; then
   #   cp $snoold ${COMSP}snogrb
   #   msg="**todays 0.5 degree snow grib file not located - copy 1-day old file"
   #   $DATA/postmsg "$jlogfile" "$msg"
   #else
   #   set +x
   #   echo " "
   #   echo " #####################################################"
   #   echo " cannot locate 0.5 degree snow grib file"
   #   echo " #####################################################"
   #   echo " "
   #   set -x
   #   msg="***WARNING: CANNOT LOCATE 0.5 DEGREE SNOW GRIB FILE.  Not critical."
   #   $DATA/postmsg "$jlogfile" "$msg"
   #fi

   #snogrb_t574=$TANK_GRIBFLDS/$PDY/wgrbbul/snowdepth.t574.grb
   #snoold_t574=$TANK_GRIBFLDS/$PDYm1/wgrbbul/snowdepth.t574.grb

   #if [ -s $snogrb_t574 ]; then
   #   cp $snogrb_t574 ${COMSP}snogrb_t574
   #   msg="todays T574 snow grib file located and copied to ${COMSP}snogrb_t574"
   #   $DATA/postmsg "$jlogfile" "$msg"
   #elif [ -s $snoold_t574 ]; then
   #   cp $snoold_t574 ${COMSP}snogrb_t574
   #   msg="**todays T574 snow grib file not located - copy 1-day old file"
   #   $DATA/postmsg "$jlogfile" "$msg"
   #else
   #   set +x
   #   echo " "
   #   echo " ###############################################"
   #   echo " cannot locate T574 snow grib file"
   #   echo " ###############################################"
   #   echo " "
   #   set -x
   #   msg="***WARNING: CANNOT LOCATE T574 SNOW GRIB FILE.  Not critical."
   #   $DATA/postmsg "$jlogfile" "$msg"
   #fi

   engicegrb=${COM_ENGICE}.$PDY/engice.t00z.grb
   engiceold=${COM_ENGICE}.$PDYm1/engice.t00z.grb

   if [ -s $engicegrb ]; then
      cp $engicegrb ${COMSP}engicegrb
      msg="todays engice grib file located and copied to ${COMSP}engicegrb"
      $DATA/postmsg "$jlogfile" "$msg"
   elif [ -s $engiceold ]; then
      cp $engiceold ${COMSP}engicegrb
      msg="**todays engice grib file not located - copy 1-day old file"
      $DATA/postmsg "$jlogfile" "$msg"
   else
      set +x
      echo " "
      echo " ############################################"
      echo " cannot locate engice grib file"
      echo " ############################################"
      echo " "
      set -x
      msg="***WARNING: CANNOT LOCATE LOW RES ENGICE GRIB FILE.  Not critical."
      $DATA/postmsg "$jlogfile" "$msg"
   fi

# Disabled w/ GFSv15.2 b/c sstoi file no longer needed
#  sstgrb=${COM_SSTOI}.$PDY/sstoi_grb
#  sstold=${COM_SSTOI}.$PDYm1/sstoi_grb

#  if [ -s $sstgrb ]; then
#     cp $sstgrb ${COMSP}sstgrb
#     msg="todays lowres sst grib file located and copied to ${COMSP}sstgrb"
#     $DATA/postmsg "$jlogfile" "$msg"
#  elif [ -s $sstold ]; then
#     cp $sstold ${COMSP}sstgrb
#     msg="**todays lowres sst grib file not located - copy 1-day old file"
#     $DATA/postmsg "$jlogfile" "$msg"
#  else
#     set +x
#     echo " "
#     echo " #########################################"
#     echo " cannot locate lowres sst grib file"
#     echo " #########################################"
#     echo " "
#     set -x
#     msg="***WARNING: CANNOT LOCATE LOW RES SST GRIB FILE.  Not critical."
#     $DATA/postmsg "$jlogfile" "$msg"
#  fi

#  if [ -s ${COMSP}sstgrb ]; then
#     rm errfile
#     $GRBINDEX ${COMSP}sstgrb ${COMSP}sstgrb.index 2> errfile
#     errindx=$?
#     [ "$errindx" -ne '0' ] && cat errfile
#     rm errfile
#  else
#     echo_hashed_msg "cannot create grib index since sst file does not exist"
#  fi

#  The following may no longer be needed, but leave them in place for now.
#  Print msg in the rare case the grib2 files cannot be created.
   if [ "$NET" = 'gdas' ]; then
      if [ -s ${COMSP}engicegrb ]; then
         $CNVGRIB -g12 -p40 ${COMSP}engicegrb ${COMSP}engicegrb.grib2
      else
         echo_hashed_msg "Skip engicegrb.grib2 since grib1 file does not exist"
      fi
      # Disabled w/ GFSv15.2 b/c sstoi file no longer needed
      #if [ -s ${COMSP}sstgrb ]; then
      #   $CNVGRIB -g12 -p40 ${COMSP}sstgrb ${COMSP}sstgrb.grib2
      #else
      #   echo_hashed_msg "Skip sstgrb.grib2 since grib1 file does not exist"
      #fi
      #if [ -s ${COMSP}snogrb ]; then
      #   $CNVGRIB -g12 -p40 ${COMSP}snogrb ${COMSP}snogrb.grib2
      #else
      #   echo_hashed_msg "Skip snogrb.grib2 since grib1 file does not exist"
      #fi
   fi


######################################################################
######################################################################
#  For the following, try as far as $ndaysback to find recent file.  #
#  Post warning if no file found for $ndaysback_warn or beyond.      #
#  The job will continue if no suitable file is available.           #
#  ----------------------------------------------------------------  #
#  copy NPR.SNWN.SP.S1200.MESH16   from $TANK_GRIBFLDS               #
#  copy NPR.SNWS.SP.S1200.MESH16   from $TANK_GRIBFLDS               #
#  copy imssnow96.grb.grib2        from $TANK_GRIBFLDS               #
#  copy seaice.t00z.5min.grb       from $COM_ICE5MIN                 #
#  copy seaice.t00z.5min.grb.grib2 from $COM_ICE5MIN                 #
#  copy rtgssthr_grb_0.083         from $COM_SSTRTG                  #
#  copy rtgssthr_grb_0.083.grib2   from $COM_SSTRTG                  #
######################################################################
######################################################################
   for gribfile in  \
    NPR.SNWN.SP.S1200.MESH16   \
    NPR.SNWS.SP.S1200.MESH16   \
    imssnow96.grb.grib2        \
    seaice.t00z.5min.grb       \
    seaice.t00z.5min.grb.grib2 \
    rtgssthr_grb_0.083         \
    rtgssthr_grb_0.083.grib2
   do
# set the values specific to each file
      case $gribfile in
         NPR.SNWN.SP.S1200.MESH16 | NPR.SNWS.SP.S1200.MESH16 )    # AFWA snow
          grib_source='$TANK_GRIBFLDS/$DDATE/wgrbbul';
          target_filename=$gribfile.grb
          ndaysback=1;
          ndaysback_warn=1;;
         imssnow96.grb.grib2 )                     # IMS snow
          grib_source='$TANK_GRIBFLDS/$DDATE/wgrbbul';
          target_filename=imssnow96.grib2
          ndaysback=1;
          ndaysback_warn=1;;
         seaice.t00z.5min.grb )
          grib_source='${COM_ICE5MIN}.$DDATE';
          target_filename=seaice.5min.grb
          ndaysback=7;
          ndaysback_warn=1;;
         seaice.t00z.5min.grb.grib2 )
          grib_source='${COM_ICE5MIN}.$DDATE';
          target_filename=seaice.5min.grib2
          ndaysback=7;
          ndaysback_warn=1;;
         rtgssthr_grb_0.083 )
          grib_source='${COM_SSTRTG}.$DDATE';
          target_filename=rtgssthr.grb
          ndaysback=10;
          ndaysback_warn=1;;
         rtgssthr_grb_0.083.grib2 )
          grib_source='${COM_SSTRTG}.$DDATE';
          target_filename=rtgssthr.grib2
          ndaysback=10;
          ndaysback_warn=1;;
         *) 
         msg="***FATAL ERROR: unexpected grib field file $gribfile"; 
         echo_hashed_msg "$msg"
         $DATA/postmsg "$jlogfile" "$msg"
         $DATA/err_exit;;
      esac
# set up string of dates to check
      if [ $ndaysback -gt 0 ];then
set +x; echo -e "\n---> path to finddate.sh below is: `which finddate.sh`"; set -x
         CHECK_DATES="$PDY $(finddate.sh $PDY s-$ndaysback)"
      else
         CHECK_DATES=$PDY
      fi
      set +x; 
      echo -e "\nWill check as far back as ${CHECK_DATES##* } for $gribfile"
      set -x
      ndtry=0
      found=false
# loop through dates to check for this file type
      for DDATE in $CHECK_DATES;do
         ndtry=`expr $ndtry + 1`
         eval tryfile=$grib_source/$gribfile
         if [ -s $tryfile ];then
            set +x; echo -e "\nPicking up file $tryfile\n"; set -x
            cp $tryfile ${COMSP}$target_filename
            found=true
            break
         fi
         if [ $DDATE -ne ${CHECK_DATES##* } ]; then
            set +x;echo -e "\n$tryfile not available. Try previous day.\n"
            set -x
         else
            set +x;echo -e "\n$tryfile not available.\n";set -x
         fi
         if [ $ndtry -gt $ndaysback_warn ];then
            msg="***WARNING: INVESTIGATE UNEXPECTED ABSENCE OF $tryfile"
            echo_hashed_msg "$msg"
            $DATA/postmsg "$jlogfile" "$msg"
         fi   
      done
      if [ $found != true ]; then
         msg="***WARNING: NO USEFUL RECENT FILES FOUND FOR $gribfile!!!"
         echo_hashed_msg "$msg"
         $DATA/postmsg "$jlogfile" "$msg"
      fi    
   done
   if [ "$SENDECF" = "YES" ]; then
      ecflow_client --event=release_sfcprep
   fi

#  endif loop $PROCESS_GRIBFLDS
fi


echo "=======> Dump group 1 (thread_1) not executed." > $DATA/1.out
echo "=======> Dump group 2 (thread_2) not executed." > $DATA/2.out
echo "=======> Dump group 3 (thread_3) not executed." > $DATA/3.out
echo "=======> Dump group 4 (thread_4) not executed." > $DATA/4.out
echo "=======> Dump group 5 (thread_5) not executed." > $DATA/5.out
echo "=======> Dump group 6 (thread_6) not executed." > $DATA/6.out
echo "=======> Dump group 7 (thread_7) not executed." > $DATA/7.out
echo "=======> Dump group 8 (thread_8) not executed." > $DATA/8.out
echo "=======> Dump group 9 (thread_9) not executed." > $DATA/9.out
echo "=======> Dump group 10 (thread_10) not executed." > $DATA/10.out
echo "=======> Dump group 11 (thread_11) not executed." > $DATA/11.out
echo "=======> Dump group 12 (thread_12) not executed." > $DATA/12.out
echo "=======> Dump group 13 (thread_13) not executed." > $DATA/13.out

err1=0
err2=0
err3=0
err4=0
err5=0
err6=0
err7=0
err8=0
err9=0
err10=0
err11=0
err12=0
err13=0
if [ "$PROCESS_DUMP" = 'YES' ]; then

####################################
####################################
#  The data "dump" script for tm00
####################################
####################################

msg="START THE $tmmark_uc $NET_uc DATA $dump_ind CENTERED ON $dumptime"
$DATA/postmsg "$jlogfile" "$msg"

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=1

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump # 1 : AVCSAM: 1 subtype(s)
#            ESHRS3: 1 subtype(s)
#            SSMISU: 1 subtype(s)
#            SAPHIR: 1 subtype(s)
#            1BHRS4: 1 subtype(s)
#            SEVCSR: 1 subtype(s)
#            TESAC:  1 subtype(s)
#            MLS:    1 subtype(s) (if present in past 10 days of tanks)
#            ESATMS: 1 subtype(s) (if present in past 10 days of tanks)
#            GSRCSR: 1 subtype(s)
#            AHICSR: 1 subtype(s)
#            SSTVCW: 1 subtype(s)
#            SUBPFL: 1 subtype(s)
#            SALDRN: 1 subtype(s)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 14
#
#=========================================================================

DTIM_latest_avcsam=${DTIM_latest_avcsam:-"+2.99"}
DTIM_latest_eshrs3=${DTIM_latest_eshrs3:-"+2.99"}
DTIM_latest_ssmisu=${DTIM_latest_ssmisu:-"+2.99"}
#DTIM_latest_saphir=${DTIM_latest_saphir:-"+2.99"}
DTIM_latest_saldrn=${DTIM_latest_saldrn:-"+2.99"}
DTIM_latest_1bhrs4=${DTIM_latest_1bhrs4:-"+2.99"}
#DTIM_latest_sevcsr=${DTIM_latest_sevcsr:-"+2.99"}
DTIM_latest_tesac=${DTIM_latest_tesac:-"+2.99"}
#-----------------------------------------------
# check for mls tank presence in past 10 days
mls=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh mls
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   mls=mls
   DTIM_latest_mls=${DTIM_latest_mls:-"+2.99"}
fi
#-----------------------------------------------
#-----------------------------------------------
# check for esatms tank presence in past 10 days
esatms=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh esatms
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   esatms=esatms
   DTIM_latest_esatms=${DTIM_latest_esatms:-"+2.99"}
fi
#-----------------------------------------------
DTIM_latest_gsrcsr=${DTIM_latest_gsrcsr:-"+2.99"}
DTIM_latest_ahicsr=${DTIM_latest_ahicsr:-"+2.99"}
DTIM_latest_sstvcw=${DTIM_latest_sstvcw:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM1:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 avcsam eshrs3 ssmisu \
 1bhrs4 tesac $mls $esatms gsrcsr ahicsr sstvcw subpfl saldrn
error1=$?
echo "$error1" > $DATA/error1

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_avcsam $job \
    ${COMSP}avcsam.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_eshrs3 $job \
    ${COMSP}eshrs3.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ssmisu $job \
    ${COMSP}ssmisu.tm00.bufr_d
#   if [ "${NET}" = "gdas" ]; then
#      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_saphir $job \
#       ${COMSP}saphir.tm00.bufr_d    ### restricted, only GDAS, turn on 01/13/2020
#   fi
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_1bhrs4 $job \
    ${COMSP}1bhrs4.tm00.bufr_d
#   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_sevcsr $job \
#    ${COMSP}sevcsr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_tesac $job \
    ${COMSP}tesac.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_saldrn $job \
    ${COMSP}saldrn.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_subpfl $job \
    ${COMSP}subpfl.tm00.bufr_d
   if [ "$mls" = mls ];then
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_mls $job \
       ${COMSP}mls.tm00.bufr_d
   fi
   if [ "$esatms" = esatms ];then
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_esatms $job \
       ${COMSP}esatms.tm00.bufr_d
   fi
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_gsrcsr $job \
    ${COMSP}gsrcsr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ahicsr $job \
    ${COMSP}ahicsr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_sstvcw $job \
    ${COMSP}sstvcw.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_2; chmod +x thread_2
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_2
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=2

#==========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#   (3) GDAS GSI doesn't use ATOVS, but NASA/GSFC is pulling them off our
#       server, also CDAS may be running special tests using data from GDAS
#       cutoff time (ATOVS is not dumped in GFS)
#
#--------------------------------------------------------------------------
# GDAS:
# Dump # 2 : SFCSHP: 11 subtype(s) (added shipsb & shipub in dumplist)
#            TIDEG:  1 subtype(s)
#            ATOVS:  1 subtype(s)
#            ADPSFC: 7 subtype(s)
#            ASCATT: 1 subtype(s)
#            SNOCVR: 1 subtype(s)
#  xxxxxxxxx WNDSAT: 1 subtype(s) (if present in past 10 days of tanks)
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of -3.00 to +2.99 hours)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 21 - 22
#
#--------------------------------------------------------------------------
# GFS:
# Dump # 2 : SFCSHP: 11 subtype(s) (added shipsb & shipub in dumplist)
#            TIDEG:  1 subtype(s)
#            ADPSFC: 7 subtype(s)
#            ASCATT: 1 subtype(s)
#            SNOCVR: 1 subtype(s)
#  xxxxxxxxx WNDSAT: 1 subtype(s) (if present in past 10 days of tanks)
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of -3.00 to +2.99 hours)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES =  21 - 22
#
#==========================================================================
DTIM_latest_snocvr=${DTIM_latest_snocvr:-"+2.99"}
DTIM_latest_sfcshp=${DTIM_latest_sfcshp:-"+2.99"}
DTIM_latest_tideg=${DTIM_latest_tideg:-"+2.99"}

atovs=""
if [ "$NET" = 'gdas' ]; then
   atovs=atovs
   DTIM_latest_atovs=${DTIM_latest_atovs:-"+2.99"}
fi

DTIM_latest_adpsfc=${DTIM_latest_adpsfc:-"+2.99"}
DTIM_latest_ascatt=${DTIM_latest_ascatt:-"+2.99"}
#-----------------------------------------------
# check for wndsat tank presence in past 10 days
wndsat=""
err_check_tanks=0
##########sh $USHbufr_dump/check_tanks.sh wndsat
##########err_check_tanks=$?
err_check_tanks=99 # comment out 2 lines above & add this line to ensure wndsat
                   # is not ever dumped
if [ $err_check_tanks -eq 0 ];then
   wndsat=wndsat
   DTIM_latest_wndsat=${DTIM_latest_wndsat:-"+2.99"}
fi
#-----------------------------------------------

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM2:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 sfcshp tideg $atovs adpsfc snocvr ascatt $wndsat
error2=$?
echo "$error2" > $DATA/error2

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_sfcshp $job \
    ${COMSP}sfcshp.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_tideg $job \
    ${COMSP}tideg.tm00.bufr_d
   [ -f ${COMSP}atovs.tm00.bufr_d ]  &&  \
    $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_atovs $job \
    ${COMSP}atovs.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_adpsfc $job \
    ${COMSP}adpsfc.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ascatt $job \
    ${COMSP}ascatt.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_snocvr $job \
    ${COMSP}snocvr.tm00.bufr_d
   if [ "$NET" = 'gdas' ]; then
    ####### ALERT TURNED ON for GDAS only ########################
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ascatw $job \
       ${COMSP}ascatw.tm00.bufr_d
   fi
   if [ "$wndsat" = wndsat ];then
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_wndsat $job \
       ${COMSP}wndsat.tm00.bufr_d
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_wdsatr $job \
       ${COMSP}wdsatr.tm00.bufr_d
   fi
fi

set +x
echo "********************************************************************"
echo Script thread_2
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/2.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_3; chmod +x thread_3
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_3
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP_adpupa} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=3

#====================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump #3:   ADPUPA: 6 subtype(s)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 6
#
#====================================================================

DTIM_latest_adpupa=${DTIM_latest_adpupa:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM3:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 adpupa
error3=$?
echo "$error3" > $DATA/error3

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_adpupa $job \
    ${COMSP}adpupa.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_3
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/3.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_4; chmod +x thread_4
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_4
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=4

#=======================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#       EXCEPT: AIRCFT where it is +/- 3.25 hours
#               AIRCAR where it is +/- 3.25 hours
#               PROFLR where it is -4.00 to +3.99 hours
#               GSPIPW where it is +/- 0.05 hours (+/- 3min)
#   (2) TIME TRIMMING IS DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump # 4 : AIRCAR: 2 subtype(s)
#            AIRCFT: 8 subtype(s)
#            PROFLR: 4 subtype(s)
#            VADWND: 1 subtype(s)
#            RASSDA: 1 subtype(s)
#            GPSIPW: 1 subtype(s)
#            HDOB  : 1 subtype(s)
#            -------------------- 
#            TOTAL NUMBER OF SUBTYPES = 18
#
#=======================================================================

# Skip NeXRaD VAD WINDS FROM LEVEL 2 DECODER (not ready to be handled in GSI) (002017)
# 3/9/2022 -- enable the dumping of 002017 in the vadwnd dump group.
#export SKIP_002017=YES

# Dump AIRCFT and AIRCAR with wide time window to improve PREPOBS_PREPACQC
#  track-check performance
#  (time window will be winnowed down to +/- 3.00 hours in output from
#   PREPOBS_PREPACQC)

# Dump PROFLR with wide time window to improve PREPOBS_PROFCQC performance
#  (time window will be winnowed down in output from PREPOBS_PROFCQC, see
#   parm cards for output time window)

# Dump GPSIPW with narrow (+/- 3-min) time window since new Ground Based
#  GPS-IPW/ZTD (from U.S.-ENI and foreign GNSS providers) is currently limited
#  to obs only at cycle-time

DTIM_earliest_aircft=${DTIM_earliest_aircft:-"-3.25"}
DTIM_latest_aircft=${DTIM_latest_aircft:-"+3.25"}

DTIM_earliest_aircar=${DTIM_earliest_aircar:-"-3.25"}
DTIM_latest_aircar=${DTIM_latest_aircar:-"+3.25"}

DTIM_earliest_proflr=${DTIM_earliest_proflr:-"-4.00"}
DTIM_latest_proflr=${DTIM_latest_proflr:-"+3.99"}

DTIM_latest_vadwnd=${DTIM_latest_vadwnd:-"+2.99"}
DTIM_latest_rassda=${DTIM_latest_rassda:-"+2.99"}

DTIM_earliest_gpsipw=${DTIM_latest_gpsipw:-"-0.05"}
DTIM_latest_gpsipw=${DTIM_latest_gpsipw:-"+0.05"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM4:-on}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 aircar aircft proflr vadwnd \
 rassda gpsipw hdob 
error4=$?
echo "$error4" > $DATA/error4

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_aircar $job \
    ${COMSP}aircar.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_aircft $job \
    ${COMSP}aircft.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_proflr $job \
    ${COMSP}proflr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_vadwnd $job \
    ${COMSP}vadwnd.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_rassda $job \
    ${COMSP}rassda.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_gpsipw $job \
    ${COMSP}gpsipw.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_hdob $job \
    ${COMSP}hdob.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_4
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/4.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_5; chmod +x thread_5
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_5
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=5

#===================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types 
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Currently not executed in GDAS or GFS:
# Dump # 5 : MSONET: 30 subtype(s)
#            ---------------------
#            TOTAL NUMBER OF SUBTYPES = 30
#
#===================================================================

DTIM_latest_msonet=${DTIM_latest_msonet:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM5:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 msonet
error5=$?
echo "$error5" > $DATA/error5

set +x
echo "********************************************************************"
echo Script thread_5
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/5.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_6; chmod +x thread_6
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_6
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=6

#===================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Currently not executed in GDAS or GFS:
# Dump # 6 : NEXRAD: 8 subtype(s)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 8
#
#===================================================================

DTIM_latest_nexrad=${DTIM_latest_nexrad:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM6:-off}}

# NEXRAD tanks are hourly
# Process only those hourly tanks w/i requested dump center cycle time window

SKIP_006010=YES # radial wind  00Z
SKIP_006011=YES # radial wind  01Z
SKIP_006012=YES # radial wind  02Z
SKIP_006013=YES # radial wind  03Z
SKIP_006014=YES # radial wind  04Z
SKIP_006015=YES # radial wind  05Z
SKIP_006016=YES # radial wind  06Z
SKIP_006017=YES # radial wind  07Z
SKIP_006018=YES # radial wind  08Z
SKIP_006019=YES # radial wind  09Z
SKIP_006020=YES # radial wind  10Z
SKIP_006021=YES # radial wind  11Z
SKIP_006022=YES # radial wind  12Z
SKIP_006023=YES # radial wind  13Z
SKIP_006024=YES # radial wind  14Z
SKIP_006025=YES # radial wind  15Z
SKIP_006026=YES # radial wind  16Z
SKIP_006027=YES # radial wind  17Z
SKIP_006028=YES # radial wind  18Z
SKIP_006029=YES # radial wind  19Z
SKIP_006030=YES # radial wind  20Z
SKIP_006031=YES # radial wind  21Z
SKIP_006032=YES # radial wind  22Z
SKIP_006033=YES # radial wind  23Z

SKIP_006040=YES # reflectivity 00Z
SKIP_006041=YES # reflectivity 01Z
SKIP_006042=YES # reflectivity 02Z
SKIP_006043=YES # reflectivity 03Z
SKIP_006044=YES # reflectivity 04Z
SKIP_006045=YES # reflectivity 05Z
SKIP_006046=YES # reflectivity 06Z
SKIP_006047=YES # reflectivity 07Z
SKIP_006048=YES # reflectivity 08Z
SKIP_006049=YES # reflectivity 09Z
SKIP_006050=YES # reflectivity 10Z
SKIP_006051=YES # reflectivity 11Z
SKIP_006052=YES # reflectivity 12Z
SKIP_006053=YES # reflectivity 13Z
SKIP_006054=YES # reflectivity 14Z
SKIP_006055=YES # reflectivity 15Z
SKIP_006056=YES # reflectivity 16Z
SKIP_006057=YES # reflectivity 17Z
SKIP_006058=YES # reflectivity 18Z
SKIP_006059=YES # reflectivity 19Z
SKIP_006060=YES # reflectivity 20Z
SKIP_006061=YES # reflectivity 21Z
SKIP_006062=YES # reflectivity 22Z
SKIP_006063=YES # reflectivity 23Z

if [ $cycp -eq 00 ]; then   # (22.5 - 01.5 Z)
   unset SKIP_006032 # radial wind  22Z
   unset SKIP_006033 # radial wind  23Z
   unset SKIP_006010 # radial wind  00Z
   unset SKIP_006011 # radial wind  01Z
   unset SKIP_006062 # reflectivity 22Z
   unset SKIP_006063 # reflectivity 23Z
   unset SKIP_006040 # reflectivity 00Z
   unset SKIP_006041 # reflectivity 01Z
elif [ $cycp -eq 06 ]; then # (04.5 - 07.5 Z)
   unset SKIP_006014 # radial wind  04Z
   unset SKIP_006015 # radial wind  05Z
   unset SKIP_006016 # radial wind  06Z
   unset SKIP_006017 # radial wind  07Z
   unset SKIP_006044 # reflectivity 04Z
   unset SKIP_006045 # reflectivity 05Z
   unset SKIP_006046 # reflectivity 06Z
   unset SKIP_006047 # reflectivity 07Z
elif [ $cycp -eq 12 ]; then # (10.5 - 13.5 Z)
   unset SKIP_006020 # radial wind  10Z
   unset SKIP_006021 # radial wind  11Z
   unset SKIP_006022 # radial wind  12Z
   unset SKIP_006023 # radial wind  13Z
   unset SKIP_006050 # reflectivity 10Z
   unset SKIP_006051 # reflectivity 11Z
   unset SKIP_006052 # reflectivity 12Z
   unset SKIP_006053 # reflectivity 13Z
elif [ $cycp -eq 18 ]; then # (16.5 - 19.5 Z)
   unset SKIP_006026 # radial wind  16Z
   unset SKIP_006027 # radial wind  17Z
   unset SKIP_006028 # radial wind  18Z
   unset SKIP_006029 # radial wind  19Z
   unset SKIP_006056 # reflectivity 16Z
   unset SKIP_006057 # reflectivity 17Z
   unset SKIP_006058 # reflectivity 18Z
   unset SKIP_006059 # reflectivity 19Z
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 nexrad
error6=$?
echo "$error6" > $DATA/error6

set +x
echo "********************************************************************"
echo Script thread_6
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/6.out 2>&1
EOF
set -x

set +x
#------------------------------------------------------------------------------
cat<<\EOF>thread_7; chmod +x thread_7
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_7
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=7

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump # 7 : AVCSPM: 1 subtype(s)
#            ESMHS:  1 subtype(s)
#            1BMHS:  1 subtype(s)
#            AIRSEV: 1 subtype(s)
#            ATMSDB: 1 subtype(s)
#            GOME:   1 subtype(s)
#            OMI:    1 subtype(s)
#            TRKOB:  1 subtype(s)
#            GPSRO:  1 subtype(s)
#            CRISF4: 1 subtype(s) (if present in past 10 days of tanks)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 10
#
#=========================================================================

DTIM_latest_avcspm=${DTIM_latest_avcspm:-"+2.99"}
DTIM_latest_esmhs=${DTIM_latest_esmhs:-"+2.99"}
DTIM_latest_1bmhs=${DTIM_latest_1bmhs:-"+2.99"}
DTIM_latest_airsev=${DTIM_latest_airsev:-"+2.99"}
DTIM_latest_atmsdb=${DTIM_latest_atmsdb:-"+2.99"}
DTIM_latest_gome=${DTIM_latest_gome:-"+2.99"}
DTIM_latest_omi=${DTIM_latest_omi:-"+2.99"}
DTIM_latest_trkob=${DTIM_latest_trkob:-"+2.99"}
DTIM_latest_gpsro=${DTIM_latest_gpsro:-"+2.99"}
#-----------------------------------------------
# check for crisf4 tank presence in past 10 days
crisf4=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh crisf4
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   crisf4=crisf4
   DTIM_latest_crisf4=${DTIM_latest_crisf4:-"+2.99"}
fi
#-----------------------------------------------

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM7:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 avcspm esmhs 1bmhs \
 airsev atmsdb gome omi trkob gpsro $crisf4
error7=$?
echo "$error7" > $DATA/error7

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_avcspm $job \
    ${COMSP}avcspm.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_esmhs $job \
    ${COMSP}esmhs.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_1bmhs $job \
    ${COMSP}1bmhs.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_airsev $job \
    ${COMSP}airsev.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_atmsdb $job \
    ${COMSP}atmsdb.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_gome $job \
    ${COMSP}gome.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_omi $job \
    ${COMSP}omi.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_trkob $job \
    ${COMSP}trkob.tm00.bufr_d
# gpsro dump file has nr version which is alerted from
# exdump_post.sh.ecf
  $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_gpsro $job \
   ${COMSP}gpsro.tm00.bufr_d
   if [ "$crisf4" = crisf4 ];then
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_crisf4 $job \
       ${COMSP}crisf4.tm00.bufr_d
   fi
fi

set +x
echo "********************************************************************"
echo Script thread_7
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/7.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_8; chmod +x thread_8
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_8
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=8

#=======================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is +/- 1.5 hrs for all SATWND types
#       EXCEPT: SATWND subtypes 005/030, 005/031, 005/032, 005/034, 005/039,
#               005/064, 005/065, 005/066, 005/067, 005/068, 005/069,
#               005/070, 005/071, 005/072, 005/080 and 005/091
#               where it is
#               -3.00 to +2.99 hours.
#   (2) TIME TRIMMING IS DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump # 8 : SATWND: 16 subtype(s)  (bufr_dumplist.v2.3.0)
#            --------------------- 
#            TOTAL NUMBER OF SUBTYPES = 25
#
#=======================================================================

ADD_satwnd="005024 005025 005026 005030 005031 005032 005034 005039 005072"

# Skip old bufr METEOSAT AMVs; for testing skip in trigger or version file
#export SKIP_005064=YES
#export SKIP_005065=YES
#export SKIP_005066=YES

# satwnd types
# ------------
DTIM_earliest_005024=${DTIM_earliest_005024:-"-3.00"}
DTIM_latest_005024=${DTIM_latest_005024:-"+2.99"}
DTIM_earliest_005025=${DTIM_earliest_005025:-"-3.00"}
DTIM_latest_005025=${DTIM_latest_005025:-"+2.99"}
DTIM_earliest_005026=${DTIM_earliest_005026:-"-3.00"}
DTIM_latest_005026=${DTIM_latest_005026:-"+2.99"}
DTIM_earliest_005030=${DTIM_earliest_005030:-"-3.00"}
DTIM_latest_005030=${DTIM_latest_005030:-"+2.99"}
DTIM_earliest_005031=${DTIM_earliest_005031:-"-3.00"}
DTIM_latest_005031=${DTIM_latest_005031:-"+2.99"}
DTIM_earliest_005032=${DTIM_earliest_005032:-"-3.00"}
DTIM_latest_005032=${DTIM_latest_005032:-"+2.99"}
DTIM_earliest_005034=${DTIM_earliest_005034:-"-3.00"}
DTIM_latest_005034=${DTIM_latest_005034:-"+2.99"}
DTIM_earliest_005039=${DTIM_earliest_005039:-"-3.00"}
DTIM_latest_005039=${DTIM_latest_005039:-"+2.99"}
DTIM_earliest_005064=${DTIM_earliest_005064:-"-3.00"}
DTIM_latest_005064=${DTIM_latest_005064:-"+2.99"}
DTIM_earliest_005065=${DTIM_earliest_005065:-"-3.00"}
DTIM_latest_005065=${DTIM_latest_005065:-"+2.99"}
DTIM_earliest_005066=${DTIM_earliest_005066:-"-3.00"}
DTIM_latest_005066=${DTIM_latest_005066:-"+2.99"}
DTIM_earliest_005067=${DTIM_earliest_005067:-"-3.00"}
DTIM_latest_005067=${DTIM_latest_005067:-"+2.99"}
DTIM_earliest_005068=${DTIM_earliest_005068:-"-3.00"}
DTIM_latest_005068=${DTIM_latest_005068:-"+2.99"}
DTIM_earliest_005069=${DTIM_earliest_005069:-"-3.00"}
DTIM_latest_005069=${DTIM_latest_005069:-"+2.99"}
DTIM_earliest_005070=${DTIM_earliest_005070:-"-3.00"}
DTIM_latest_005070=${DTIM_latest_005070:-"+2.99"}
DTIM_earliest_005071=${DTIM_earliest_005071:-"-3.00"}
DTIM_latest_005071=${DTIM_latest_005071:-"+2.99"}
DTIM_earliest_005072=${DTIM_earliest_005072:-"-3.00"}
DTIM_latest_005072=${DTIM_latest_005072:-"+2.99"}
DTIM_earliest_005080=${DTIM_earliest_005080:-"-3.00"}
DTIM_latest_005080=${DTIM_latest_005080:-"+2.99"}
DTIM_earliest_005081=${DTIM_earliest_005081:-"-3.00"}
DTIM_latest_005081=${DTIM_latest_005081:-"+2.99"}
DTIM_earliest_005091=${DTIM_earliest_005091:-"-3.00"}
DTIM_latest_005091=${DTIM_latest_005091:-"+2.99"}



TIME_TRIM=${TIME_TRIM:-${TIME_TRIM8:-on}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 1.5 1 satwnd
error8=$?
echo "$error8" > $DATA/error8

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_satwnd $job \
    ${COMSP}satwnd.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_8
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/8.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_9; chmod +x thread_9
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_9
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=9

#=======================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#       EXCEPT:  GEOIMR where it is -0.50 to +0.50 hour
#   (2) TIME TRIMMING IS DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump # 9 : GEOIMR: 1 subtype(s)
#            GMI1CR: 1 subtype(s)
#            SATWHR: 1 subtype(s)
#            -------------------- 
#            TOTAL NUMBER OF SUBTYPES = 3
#
#=======================================================================
DTIM_earliest_gmi1cr=${DTIM_earliest_gmi1cr:-"-3.00"}
DTIM_latest_gmi1cr=${DTIM_latest_gmi1cr:-"+2.99"}

DTIM_earliest_satwhr=${DTIM_earliest_satwhr:-"-3.00"}
DTIM_latest_satwhr=${DTIM_latest_satwhr:-"+2.99"}

DTIM_earliest_geoimr=${DTIM_earliest_geoimr:-"-0.50"}
DTIM_latest_geoimr=${DTIM_latest_geoimr:-"+0.50"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM9:-on}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 geoimr gmi1cr satwhr

error9=$?
echo "$error9" > $DATA/error9

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_geoimr $job \
    ${COMSP}geoimr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_gmi1cr $job \
    ${COMSP}gmi1cr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_satwhr $job \
    ${COMSP}satwhr.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_9
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/9.out 2>&1
EOF
set -x

set +x
#------------------------------------------------------------------------------
cat<<\EOF>thread_10; chmod +x thread_10
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_10
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=10

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump #10 : ESIASI: 1 subtype(s)
#            MTIASI: 1 subtype(s)
#            ESAMUA: 1 subtype(s)
#            SEVASR: 1 subtype(s)
#            1BAMUA: 1 subtype(s)
#            BATHY:  1 subtype(s)
#            OSBUV8: 1 subtype(s)
#            OMPSN8: 1 subtype(s)
#            OMPST8: 1 subtype(s)
#            GSRASR: 1 subtype(s)
#            OMPSLP: 1 subtype(s)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 13
#
#=========================================================================

DTIM_latest_esiasi=${DTIM_latest_esiasi:-"+2.99"}
DTIM_latest_mtiasi=${DTIM_latest_mtiasi:-"+2.99"}
DTIM_latest_esamua=${DTIM_latest_esamua:-"+2.99"}
DTIM_latest_sevasr=${DTIM_latest_sevasr:-"+2.99"}
DTIM_latest_1bamua=${DTIM_latest_1bamua:-"+2.99"}
DTIM_latest_bathy=${DTIM_latest_bathy:-"+2.99"}
DTIM_latest_osbuv8=${DTIM_latest_osbuv8:-"+2.99"}
DTIM_latest_ompsn8=${DTIM_latest_ompsn8:-"+2.99"}
DTIM_latest_ompst8=${DTIM_latest_ompst8:-"+2.99"}
DTIM_latest_gsrasr=${DTIM_latest_gsrasr:-"+2.99"}
DTIM_latest_ompslp=${DTIM_latest_ompslp:-"+2.99"}
DTIM_latest_sstvpw=${DTIM_latest_sstvpw:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM10:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 esiasi mtiasi esamua \
 sevasr 1bamua bathy osbuv8 ompsn8 ompst8 gsrasr ompslp sstvpw
error10=$?
echo "$error10" > $DATA/error10

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_esiasi $job \
    ${COMSP}esiasi.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_mtiasi $job \
    ${COMSP}mtiasi.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_esamua $job \
    ${COMSP}esamua.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_sevasr $job \
    ${COMSP}sevasr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_1bamua $job \
    ${COMSP}1bamua.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_bathy $job \
    ${COMSP}bathy.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_osbuv8 $job \
    ${COMSP}osbuv8.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ompsn8 $job \
    ${COMSP}ompsn8.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ompst8 $job \
    ${COMSP}ompst8.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_gsrasr $job \
    ${COMSP}gsrasr.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_ompslp $job \
    ${COMSP}ompslp.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_sstvpw $job \
    ${COMSP}sstvpw.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_10
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/10.out 2>&1
EOF
set -x

set +x
#------------------------------------------------------------------------------
cat<<\EOF>thread_11; chmod +x thread_11
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_11
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=11

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump #11 : AMSR2:  1 subtype(s)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 1
#
#=========================================================================

DTIM_latest_amsr2=${DTIM_latest_amsr2:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM11:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 amsr2
error11=$?
echo "$error11" > $DATA/error11

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_amsr2 $job \
    ${COMSP}amsr2.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_11
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/11.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_12; chmod +x thread_12
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_12
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=12

#=========================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump # 12 : ATMS:   1 subtype(s) (if present in past 10 days of tanks)
#             CRISFS: 1 subtype(s) (if present in past 10 days of tanks)
#             CRSFDB: 1 subtype(s)
#             IASIDB: 1 subtype(s)
#             --------------------
#             TOTAL NUMBER OF SUBTYPES = 4
#
#=========================================================================
#-----------------------------------------------
#-----------------------------------------------
# check for atms tank presence in past 10 days
atms=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh atms
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   atms=atms
   DTIM_latest_atms=${DTIM_latest_atms:-"+2.99"}
fi
#-----------------------------------------------
#-----------------------------------------------
# check for crisfs tank presence in past 10 days
crisfs=""
err_check_tanks=0
sh $USHbufr_dump/check_tanks.sh crisfs
err_check_tanks=$?
if [ $err_check_tanks -eq 0 ];then
   crisfs=crisfs
   DTIM_latest_crisfs=${DTIM_latest_crisfs:-"+2.99"}
fi
#-----------------------------------------------

DTIM_latest_crsfdb=${DTIM_latest_crsfdb:-"+2.99"}
DTIM_latest_iasidb=${DTIM_latest_iasidb:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM1:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 $atms $crisfs crsfdb iasidb
error12=$?
echo "$error12" > $DATA/error12

if [ "$SENDDBN" = "YES" ]; then
   if [ "$atms" = atms ];then
      $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_atms $job \
       ${COMSP}atms.tm00.bufr_d
   fi
####### ALERTS TURNED OFF UNTIL REQUESTED BY USER #########################
#  if [ "$crisfs" = crisfs ];then
#     $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_crisfs $job \
#      ${COMSP}crisfs.tm00.bufr_d
#  fi
###########################################################################
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_crsfdb $job \
    ${COMSP}crsfdb.tm00.bufr_d
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_iasidb $job \
    ${COMSP}iasidb.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_12
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/12.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_13; chmod +x thread_13
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_13
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

# UPRAIR requires early start, no need to NAP
#sleep ${NAP} # to reverse 10min early start of jglobal_dump in cron
export STATUS=NO
export DUMP_NUMBER=13

#====================================================================
# NOTES ABOUT THIS DUMP GROUP:
#   (1) time window radius is -3.00 to +2.99 hours on all types
#   (2) TIME TRIMMING IS NOT DONE IN THIS DUMP (default, unless overridden)
#
#--------------------------------------------------------------------------
# Dump #13:   UPRAIR: 5 subtype(s)
#            --------------------
#            TOTAL NUMBER OF SUBTYPES = 5
#
#====================================================================

DTIM_latest_uprair=${DTIM_latest_uprair:-"+2.99"}

TIME_TRIM=${TIME_TRIM:-${TIME_TRIM13:-off}}

$ushscript_dump/bufr_dump_obs.sh $dumptime 3.0 1 uprair 
error13=$?
echo "$error13" > $DATA/error13

if [ "$SENDDBN" = "YES" ]; then
   $DBNROOT/bin/dbn_alert MODEL ${NET_uc}_BUFR_uprair $job \
    ${COMSP}uprair.tm00.bufr_d
fi

set +x
echo "********************************************************************"
echo Script thread_13
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/13.out 2>&1
EOF
set -x


#----------------------------------------------------------------
# Now launch the threads

#  determine local system name and type if available
#  -------------------------------------------------

SITE=${SITE:-""}

set +u
launcher=${launcher:-"cfp"}  # if not "cfp", threads will be run serially.

if [ "$launcher" = cfp ]; then
   > $DATA/poe.cmdfile
   echo "Running threads in parallel IG2023"
   myPDY=`date +\%Y\%m\%d\%H\%M\%S`
   echo "DATE IG2023 start " $myPDY
# To better take advantage of cfp, execute the longer running commands first.
# Some reordering was done here based on recent sample runtimes.

   #[ $DUMP_group3 = YES -a $ADPUPA_wait != YES ]  &&  echo ./thread_3 >> $DATA/poe.cmdfile
   [ $DUMP_group3 = YES ]  &&  echo ./thread_3 >> $DATA/poe.cmdfile # NAP_adpupa covers for ADPUPA_wait 
   [ $DUMP_group13 = YES ]  &&  echo ./thread_13 >> $DATA/poe.cmdfile
   [ $DUMP_group7 = YES ]  &&  echo ./thread_7 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group1 = YES ]  &&  echo ./thread_1 >> $DATA/poe.cmdfile
   [ $DUMP_group5 = YES ]  &&  echo ./thread_5 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group6 = YES ]  &&  echo ./thread_6 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group8 = YES ]  &&  echo ./thread_8 >> $DATA/poe.cmdfile  # moved up
   [ $DUMP_group11 = YES ] &&  echo ./thread_11 >> $DATA/poe.cmdfile # moved up
   [ $DUMP_group10 = YES ] &&  echo ./thread_10 >> $DATA/poe.cmdfile # moved up
   [ $DUMP_group2 = YES ]  &&  echo ./thread_2 >> $DATA/poe.cmdfile
   [ $DUMP_group4 = YES ]  &&  echo ./thread_4 >> $DATA/poe.cmdfile
   [ $DUMP_group9 = YES ]  &&  echo ./thread_9 >> $DATA/poe.cmdfile
   [ $DUMP_group12 = YES ]  &&  echo ./thread_12 >> $DATA/poe.cmdfile

   if [ -s $DATA/poe.cmdfile ]; then
      export MP_CSS_INTERRUPT=yes
      launcher_DUMP=${launcher_DUMP:-mpiexec}
      NPROCS=${NPROCS:-14} # was 12
      $launcher_DUMP -np ${NPROCS} --cpu-bind verbose,core cfp $DATA/poe.cmdfile 2>&1 
      #$launcher_DUMP -np 14 --cpu-bind core cfp $DATA/poe.cmdfile 2>&1 # 1) 3)
      #$launcher_DUMP -np ${NPROCS} cfp $DATA/poe.cmdfile 2>&1 # 4) Carolyn Pasti suggestions
      errpoe=$?
      if [ $errpoe -ne 0 ]; then
         $DATA/err_exit "***FATAL: EXIT STATUS $errpoe RUNNING POE COMMAND FILE"
      fi
   else
      echo
      echo "==> There are no tasks in POE Command File - POE not run"
      echo
   fi
else
   echo "Running threads serially"
   [ $DUMP_group3 = YES -a $ADPUPA_wait != YES ]  &&  ./thread_3
   [ $DUMP_group1 = YES ]  &&  ./thread_1 
   [ $DUMP_group2 = YES ]  &&  ./thread_2 
   [ $DUMP_group4 = YES ]  &&  ./thread_4 
   [ $DUMP_group5 = YES ]  &&  ./thread_5 
   [ $DUMP_group6 = YES ]  &&  ./thread_6 
   [ $DUMP_group7 = YES ]  &&  ./thread_7 
   [ $DUMP_group8 = YES ]  &&  ./thread_8 
   [ $DUMP_group9 = YES ]  &&  ./thread_9 
   [ $DUMP_group10 = YES ]  &&  ./thread_10 
   [ $DUMP_group11 = YES ]  &&  ./thread_11 
   [ $DUMP_group12 = YES ]  &&  ./thread_12 
   [ $DUMP_group13 = YES ]  &&  ./thread_13
#     wait
fi

# long run times for uprair lead to use of NAP and NAP_adpupa variables (see code above) instead of this code
#
##  if ADPUPA_wait is YES, adpupa and uprair are dumped AFTER all other dump
##   threads have run (normally done in real-time GFS runs to dump as late as
##   possible in order to maximize data availability in GFS network,
##   particularly DROPs)
##  --------------------------------------------------------------------------
##
#[ $DUMP_group3 = YES -a $ADPUPA_wait  = YES ]  &&  ./thread_3

cat $DATA/1.out $DATA/2.out $DATA/3.out $DATA/4.out $DATA/5.out $DATA/6.out $DATA/7.out $DATA/8.out $DATA/9.out $DATA/10.out $DATA/11.out $DATA/12.out $DATA/13.out

set +x
echo " "
echo " "
set -x

[ -s $DATA/error1 ] && err1=`cat $DATA/error1`
[ -s $DATA/error2 ] && err2=`cat $DATA/error2`
[ -s $DATA/error3 ] && err3=`cat $DATA/error3`
[ -s $DATA/error4 ] && err4=`cat $DATA/error4`
[ -s $DATA/error5 ] && err5=`cat $DATA/error5`
[ -s $DATA/error6 ] && err6=`cat $DATA/error6`
[ -s $DATA/error7 ] && err7=`cat $DATA/error7`
[ -s $DATA/error8 ] && err8=`cat $DATA/error8`
[ -s $DATA/error9 ] && err9=`cat $DATA/error9`
[ -s $DATA/error10 ] && err10=`cat $DATA/error10`
[ -s $DATA/error11 ] && err11=`cat $DATA/error11`
[ -s $DATA/error12 ] && err12=`cat $DATA/error12`
[ -s $DATA/error13 ] && err13=`cat $DATA/error13`


#===============================================================================

export STATUS=YES
export DUMP_NUMBER=14
$ushscript_dump/bufr_dump_obs.sh $dumptime 3.00 1 null

#  endif loop $PROCESS_DUMP
fi

echo " " >> $pgmout
echo "##################################################################\
####################"  >> $pgmout
echo " " >> $pgmout

#================================================================
#================================================================


if [ "$PROCESS_DUMP" = 'YES' ]; then

   if [ "$err1" -gt '5' -o "$err2" -gt '5' -o "$err3" -gt '5' -o \
        "$err4" -gt '5' -o "$err5" -gt '5' -o "$err6" -gt '5' -o \
        "$err7" -gt '5' -o "$err8" -gt '5' -o "$err9" -gt '5' -o \
        "$err10" -gt '5' -o "$err11" -gt '5' -o "$err12" -gt '5' -o "$err13" -gt '5']; then
      for n in $err1 $err2 $err3 $err4 $err5 $err6 $err7 $err8 $err9 $err10 $err11 $err12 $err13
      do
         if [ "$n" -gt '5' ]; then
            if [ "$n" -ne '11' -a "$n" -ne '22' ]; then
       
## fatal error in dumping of BUFR obs. files
       
               set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9, $err10, $err11, $err12, $err13 "
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
               set -x
               $DATA/err_exit
               exit 9
            fi
         fi
      done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

      set +x
      echo
      echo " ###################################################### "
      echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7, $err8, $err9, $err10, $err11, $err12, $err13 "
      echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
      echo " ###################################################### "
      echo
      set -x
   fi

#  endif loop $PROCESS_DUMP
fi

#
# copy bufr_dumplist to $COMOUT per NCO SPA request
# -------------------------------------------------
echo "Copy bufr_dumplist to comout"
LIST_cp=$COMOUT/${RUN}.t${cyc}z.bufr_dumplist.${tmmark}
cp ${FIXbufr_dump}/bufr_dumplist $LIST_cp 
chmod 644 $LIST_cp

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat  break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/ksh
#####################################################################
echo "---------------------------------------------------------------------"
echo "exairnow_dump.sh.ecf - Daily AIRNOW data dump and PREPBUFR processing"
echo "---------------------------------------------------------------------"
echo "History: Apr 26 2004 - Original script."
echo "         Jun 21 2013 - modified for WCOSS (linux) platforms"
echo "         Oct 16 2014 - modified to run under vertical structure (VS)"
echo "                       added Particulate Matter (PM) processing"
echo "         Dec 18 2019 - modified to run on WCOSS ph3"
#####################################################################
# modification history
#  26 Apr 2004 - original script
#  21 Jun 2013 - cp'd CCS:exairnow_dump.sh.ecf of 5 Jan 2009;
#                modified to run on WCOSS (linux) platforms
#                  renamed w/ ecf extension
#                  set to run under ksh
#                  replaced XLF logical unit num spec w/ FORTxx logic
#                  replaced timex w/ time -p
#  16 Oct 2014 - cp'd prod ver of Jun 17 15:57 2014
#                converted to run under vertical structure
#                added PM processing logic (fort52, pb_anowpm)
#  18 Dec 2019 - modified to run on WCOSS ph3
#---
set -ax

# Make sure we are in the $DATA directory
cd $DATA

##msg="Daily AIRNOW data dump and PREPBUFR processing has begun on `hostname`"
##postmsg "$jlogfile" "$msg"
 
cat break > $pgmout

########################################################
#  First, dump the AIRNOW data
########################################################

if [ -z "$pdy" ]; then
   tmhr=`echo $tmmark|cut -c3-5`
   export dumptime=`$NDATE -$tmhr $PDY$cyc`
else
   export dumptime=`echo $pdy`$cyc
fi

set +x
echo
echo "CENTER DATA DUMP DATE-TIME IS $dumptime"
echo
set -x
 
export COMSP=$COMOUT/${RUN}.${cycle}.
 
err1=0

msg="Start the daily AIRNOW dump centered on $dumptime - $tmmark"
postmsg "$jlogfile" "$msg"

#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=1

#============================================================================
# Dump # 1 : AIRNOW -- TOTAL NUMBER OF SUBTYPES = 1
#            time window radius is -11.00 to +12.99 hours
#============================================================================

DTIM_latest_airnow=+12.99

$ushscript_dump/bufr_dump_obs.sh $dumptime 11.00 1 airnow
error1=$?

echo "$error1" > $DATA/error1

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF

#----------------------------------------------------------------

./thread_1

cat $DATA/1.out
err1=`cat $DATA/error1`

#####msg=`grep "  HAS  " $DATA/job1/dumpjb.out`
#####$DATA/postmsg "$jlogfile" "$msg"

export STATUS=YES
export DUMP_NUMBER=2
$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 null

#================================================================
#================================================================

if [ "$err1" -gt '5' ]; then
   for n in $err1
   do
      if [ "$n" -gt '5' ]; then
         if [ "$n" -ne '11' -a "$n" -ne '22' ]; then

## fatal error in dumping of BUFR obs. files

            set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1 "
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
            set -x
            err_exit
            exit 9
         fi
      fi
   done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

   set +x
   echo
   echo " ###################################################### "
   echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1 "
   echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
   echo " ###################################################### "
   echo
   set -x
fi

if [ $err1 -gt 0 ]; then

   msg="Since AIRNOW dump file is EMPTY, NO PREPBUFR processing is performed"
   postmsg "$jlogfile" "$msg"
   touch ${COMSP}prepbufr.$tmmark

else

##########################################################################
#  Next, put the AIRNOW data into a mini-PREPBUFR file (all by itself)
##########################################################################

   EXECPREP=${EXECPREP:-$HOMEobsproc/exec}
   FIXPREP=${FIXPREP:-$HOMEobsproc/fix}

   PANX=${PANX:-$EXECPREP/prepobs_prepanow}
   PANT=${PANT:-$FIXPREP/prepobs_anow.bufrtable}

   msg="center time for PREPBUFR processing is $dumptime - $tmmark"
   postmsg "$jlogfile" "$msg"

   pgm=`basename  $PANX`
   if [ -s prep_step ]; then
      . prep_step
   else
      [ -f errfile ] && rm errfile
      unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
   fi

   cp ${COMSP}airnow.$tmmark.bufr_d airnow.dump

   echo "$dumptime"      > cdate10.dat
   export FORT21=airnow.dump
   export FORT25=$PANT
   export FORT30=cdate10.dat
   export FORT51=prepbufr
   export FORT52=pb_anowpm

   time -p $PANX > prepanow.out 2> errfile
   err=$?
   ###cat errfile
   cat errfile >> prepanow.out
   set +u
   [ -n "$pgmout" ]  &&  cat prepanow.out >> $pgmout
   set -u
   set +x
   echo
   echo 'The foreground exit status for PREPOBS_PREPANOW is ' $err
   echo
   set -x
   if [ -s err_chk ]; then
      err_chk
   else
      if test "$err" -gt '0'
      then
#########kill -9 ${qid}
         exit 555
      fi
   fi

   if [ "$err" -gt '0' ]; then
      exit 9
   else
# save final form of prepbufr file in COMSP
      cp prepbufr ${COMSP}prepbufr.$tmmark
      cp pb_anowpm ${COMSP}anowpm.pb.$tmmark
   fi

fi


# GOOD RUN
# this is done in J-job
###set +x
###echo " "
###echo " ****** AIRNOW DUMP AND PREPBUFR PROCESSING COMPLETED NORMALLY"
###echo " ****** AIRNOW DUMP AND PREPBUFR PROCESSING COMPLETED NORMALLY"
###echo " ****** AIRNOW DUMP AND PREPBUFR PROCESSING COMPLETED NORMALLY"
###echo " ****** AIRNOW DUMP AND PREPBUFR PROCESSING COMPLETED NORMALLY"
###echo " "
###set -x


# save standard output
###cat break $pgmout break > allout
cat break $pgmout break >> ../allout
###cat allout
### # rm allout

###sleep 10

###msg='ENDED NORMALLY.'
###postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/ksh
set -x

export cmodel=ukmet
export loopnum=1
export ymdh=${PDY}${cyc}

export ukmetdir=${COMINukmet}

#---- first run to get UKMET genesis vital at time=00 06 12 18Z -----------

export trkrtype=tcgen
export trkrebd=350.0
export trkrwbd=105.0
export trkrnbd=30.0
export trkrsbd=5.0
export mslpthresh=0.0015
export v850thresh=1.5000
export regtype=altg

export pert=p01
export pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#outfile=${pertdir}/trkr.${regtype}.${cmodel}.${pert}.${ymdh}.out

mac=`echo ${SITE}`
if [ $mac = TIDE -o $mac = GYRE ] ; then # For WCOSS
  machine=wcoss
  ${USHens_tracker}/extrkr_tcv_g1.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}
elif [ $mac = LUNA -o $mac = SURGE ] ; then # For CRAY
  machine=cray
  ${APRUNTRACK} ${USHens_tracker}/extrkr_tcv_g1.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}
fi
export err=$?; err_chk

#### UKMET genesis tcvitals  ###########################
num_gen_vits=`cat ${COMINgenvit}/genesis.vitals.ukmet.ukx.${JYYYY} | wc -l`
if [ ${num_gen_vits} -gt 0 ]
then
  . prep_step

  # Input file
  export FORT41=${COMINgenvit}/genesis.vitals.ukmet.ukx.${JYYYY}

  # Output file
  export FORT42=gen_tc.vitals.ukmet.ukx.${JYYYY}

  ${EXECens_tracker}/tcvital_ch_ukmet
  export err=$?; err_chk

  cat $FORT42 >> ${COMOUTgenvit}/all.vitals.ukmet.ukx.${JYYYY}
else
  touch ${COMOUTgenvit}/all.vitals.ukmet.ukx.${JYYYY}
fi

#---- second run genesis ---------------------------------------

export pertdir=${DATA}/${cmodel}/${pert}
mkdir -p $pertdir

#outfile=${pertdir}/trkr.${regtype}.${cmodel}.${pert}.${ymdh}.out

mac=`echo ${SITE}`
if [ $mac = TIDE -o $mac = GYRE ] ; then # For WCOSS
  machine=wcoss
  ${USHens_tracker}/extrkr_gen_g1.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}
elif [ $mac = LUNA -o $mac = SURGE ] ; then # For CRAY
  machine=cray
  ${APRUNTRACK} ${USHens_tracker}/extrkr_gen_g1.sh ${loopnum} ${cmodel} ${pert} ${pertdir} #2>&1 >${outfile}
fi
export err=$?; err_chk

export atcfout=ukx
export TRKDATA=${DATA}/${cmodel}/${pert}
${USHens_tracker}/sort_tracks.gen.sh  >${TRKDATA}/sort.${regtype}.${atcfout}.${ymdh}.out
export err=$?; err_chk

#cp ${pertdir}/trak.ukx.atcfunix.altg.${ymdh} ${COMOUT}/
#cp ${pertdir}/storms.ukx.atcf_gen.altg.${ymdh}  ${COMOUT}/

####filtering weak storms for TC genesis #####

. prep_step

# Input file
export FORT41=storms.ukx.atcf_gen.altg.${ymdh}
cpreq ${COMOUT}/$FORT41 .

# Output files
export FORT42=storms.ukx.atcf_gen.${ymdh}
export FORT43=trak.ukx.atcfunix.${ymdh}

${EXECens_tracker}/filter_gen_ukmet
export err=$?; err_chk

if [ "$SENDCOM" = YES ]; then
  cp $FORT42 $FORT43 ${COMOUT}/
  if [ $? -ne 0 ]; then
    echo "WARNING: Filtering did not produce any files... perhaps there were no storms to begin with."
  fi
fi

#!/bin/sh
set -xeu
source ./machine-setup.sh > /dev/null 2>&1

#Supports Debug or Release modes for the build
BUILD_MODE=${BUILD_MODE:-Release}

cwd=$(pwd)

if [ "${BUILD_MODE}" = Release ]; then
  export BUILD_TYPE=RELEASE
else
  export BUILD_TYPE=DEBUG
fi

module use ../modulefiles
module load $target.lua
module list

cd ..

if [ -d "build" ]; then
   rm -rf build
fi
mkdir build
cd build

cmake .. -DCMAKE_Fortran_COMPILER=${CMAKE_Fortran_COMPILER} -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_BUILD_TYPE=${BUILD_TYPE}

make -j ${BUILD_JOBS:-8} VERBOSE=2
make install

cd ..

exit

#!/bin/ksh
# Run under ksh (converted to WCOSS)

####  UNIX Script Documentation Block
#
# Script name:         prepobs_makeprepbufr.sh
# Script description:  Prepares & quality controls PREPBUFR file
#
# Author:       Keyser              Org: EMC          Date: 2021-04-05
#
# Abstract: This script creates the PREPBUFR file containing observational data
#   assimilated by all versions of NCEP atmospheric analyses.  It points to BUFR
#   observational data dumps as input files.  PREPOBS_PREPDATA combines them to
#   generate an initial form of the PREPBUFR file which also contains the
#   background guess as well as the observational error field.  If tropical
#   cyclone relocation processing has previously occurred, the background global
#   guess read in by PREPOBS_PREPDATA (and later by SYNDAT_SYNDATA if it runs)
#   is the relocated guess valid at the center date/time for the PREPBUFR
#   processing.  Otherwise it is the regular (unrelocated) global atmosperic
#   guess obtained via the getges utility script.  After PREPOBS_PREPDATA runs,
#   this script can execute SYNDAT_SYNDATA to generate synthetic wind bogus
#   data, as well as their background guess and observational error fields,
#   which are appended to the PREPBUFR file. 
#
#   In the global networks the decision to append synthetic wind bogus data in
#   the SYNDATA processing is determined by the outcome of the previous
#   tropical cyclone relocation processing (if it was run).  There are three
#   possible outcomes:
#      1) If all storms in the original tcvitals file have vorticies of at
#         least medium intensity such that a relocation was previously
#         performed for each, then SYNDAT_SYNDATA will still run but will not
#         append synthetic wind bogus data to the PREPBUFR file for any storm.
#         It will input the original tcvitals file (output from qctropcy
#         processing) and (if the option is set) it will flag dropwinsonde
#         winds in the vicinity of each tropical storm in the file.
#      2) If all storms in the original tcvitals file (output from qctropcy
#         processing) have weak vorticies such that a relocation was not
#         previously performed for any, then SYNDAT_SYNDATA will run, inputting
#         the original tcvitals file, and it will append synthetic wind bogus
#         data to the PREPBUFR file for each storm in it.  It will also
#         possibly flag mass pressure and/or dropwinsonde wind reports in the
#         vicinity of each storm (if requested).
#      3) If some storms in the original tcvitals file (output from qctropcy
#         processing) have weak vorticies, such that a relocation was not
#         previously performed for them, and others have vorticies of at least
#         medium intensity, such that a relocation was previously performed for
#         these, then SYNDAT_SYNDATA will run twice.  The first time, it will
#         input the relocation-generated tcvitals file, which contains all of
#         the weak storms, and it will append synthetic wind bogus data to the
#         PREPBUFR file for each storm in it.  It will also possibly flag mass
#         pressure and/or dropwinsonde wind reports in the vicinity of each of
#         these storms (if requested).  The second time SYNDAT_SYNDATA runs, it
#         will input any storm records that were in the original tcvitals file
#         but not in the relocation-generated tcvitals file (i.e., storms with
#         vorticies of at least medium intensity).  It will not append
#         synthetic wind bogus data to the PREPBUFR file for any of these
#         storms, but it will flag dropwinsonde winds in the vicinity of each
#         storm in the original tcvitals file but not in the relocation-
#         generated tcvitals file  (if requested).
#   If this is the nam network, the only reason relocation processing would
#   have been previously run would be to update the first guess read in here by
#   PREPOBS_PREPDATA and SYNDAT_SYNDATA.  In this case, SYNDAT_SYNDATA inputs
#   the original tcvitals file (output from qctropcy processing), appends
#   synthetic wind bogus data to the PREPBUFR file for each storm in it, and
#   possibly also flags mass pressure and/or dropwinsonde wind reports in the
#   vicinity of each storm in the file (if requested).
#
#   After all of this, the script then executes a series of quality control
#   programs which can change the observation value and/or its quality marker.
#   The PREPBUFR file is set up such that all changes to data are stacked on
#   top of previous values.  Such changes are considered to be "events", with
#   the event containing an associated program code and reason code to describe
#   it.  This allows the PREPBUFR file to internally contain a record of all
#   events preformed on the observations.  This script has been designed to be
#   executed by either an "operational J-job" script, a "test J-job" script, a
#   "parallel J-job" script, or a stand-alone batch run initiated by a user.
# 
# Script history log:
# 1999-07-20  Dennis A. Keyser -- Original version for implementation
# 2000-06-14  Dennis A. Keyser -- Added the tropical cyclone relocation
#     processing
# 2001-03-20  Dennis A. Keyser -- Now gets tcvitals file for t-12 as well as
#     t-06 in tropical cyclone relocation processing and passes both to ush
#     relocate_relocate_ts.sh as new pos. parameters 3 and 4
# 2004-01-15  Dennis A. Keyser -- Reads file *aircar_status_flag* in $COMSP
#     path to see whether ARINC (primary) or AFWA (backup) reports in AIRCAR
#     dump should be read and processed as ACARS data in PREPBUFR (flag file
#     generated in upstream dump process and is based on a comparison of report
#     counts), inserts proper switch in parm cards read by PREPOBS_PREPDATA
#     program
# 2004-08-30  Dennis A. Keyser -- Connects new data dumps to PREPDATA
#     processing, copies t-3 and t+3 sigma guess files for GFS and GDAS even if
#     DO_RELOCATE = NO (unless GETGUESS = NO); Copies the "PRE-QC" snapshot of
#     the PREPBUFR file AFTER SYNDAT_SYNDATA runs (if it does) rather than
#     before it runs (ensures that the PRE-QC PREPBUFR file contains ALL of the
#     observations); Variable PRVT (observational error table file path) is now
#     read by NAM network and defaults to $FIXPREP/prepobs_errtable.nam if not
#     imported (obs. errors are now read into PREPBUFR file in NAM network in
#     preparation for the switch to the GSI analysis, the operational 3DVAR
#     analysis ignores the obs errors in PREPBUFR and still reads them in from
#     $PARMPREP/nam_errtable.r3dv)
# 2005-07-01  Dennis A. Keyser -- Logic changes to run SYNDAT_SYNDATA in all
#     networks where requested regardless of outcome of relocation processing,
#     but sets new script variable DO_BOGUS to NO if SYNDAT_SYNDATA is to NOT
#     generate synthetic wind bogus reports and append them to PREPBUFR file
#     (SYNDAT_SYNDATA program also modified to read in this variable) - change
#     needed because (if requested) SYNDAT_SYNDATA will now flag all
#     dropwinsonde wind reports in vicinity of each storm in original tcvitals
#     file, regardless of whether or not bogus winds are generated
# 2006-03-22  Dennis A. Keyser -- Accounts for possibility of split dump status
#     files (status1 and status2) at the time this runs {in the test for the
#     presence of the dump status file(s)}
# 2006-06-13  Dennis A. Keyser -- Adds dump file "wdsatr" to default BUFRLIST
#      value and assigns it to unit 38 read in to PREPOBS_PREPDATA; Removed
#      tropical cyclone relocation processing, this is now done (if requested)
#      in a new script called tropcy_relocate.sh which runs in the new
#      TROPCY_QC_RELOC job prior to the PREP job that executes this script
#      (TROPCY_QC_RELOC first performs qctropcy processing, this was moved from
#      the DUMP job) - this was done to allow the TROPCY_QC_RELOC job to run at
#      the same time as the DUMP job in order to speed up overall obs
#      processing and remove variability in the PREP job executing this script
#      (i.e., this job had run faster when no tropical storms were present)
# 2007-09-14  Dennis A. Keyser -- Replaced "export XLFUNIT_xx=<filename>" with
#      "ln .sf <filename> fort.xx" in preparation for PREPOBS_PREPDATA
#      interfacing with global spectral guess files using sigio routines (via
#      W3LIB routine GBLEVENTS - sigio requires explicit open statements in the
#      code and this conflicts with XLFUNIT statements; Removed test on
#      existence of status2 file from NAM_DUMP2 and NDAS_DUMP2 jobs since dump
#      files here (currently only "nexrad") are not processed into the PREPBUFR
#      file - PREP job initiation may soon no longer be dependent upon
#      completion of DUMP2 job in NAM and NDAS networks; in the case where an
#      input (normally, pre-QC) PREPBUFR file is passed into the script via the
#      variable PREPBUFR_IN, it had been assumed that this file had already
#      been run through SYNDATA processing (but that was not the case prior to
#      12Z 25 Jan 2005) - this script changed to use the value of variable
#      SYNDATA to determine if the file in PREPBUFR_IN should be run through
#      SYNDATA processing (i.e., if SYNDATA=YES, run it through SYNDATA
#      processing) (this change will allow reanalysis runs prior to 12Z 25 Jan
#      2005 to work properly)
# 2008-09-25  Dennis A. Keyser -- Added dump file "ascatw" to default BUFRLIST
#      value and assigns it to unit 39 read in to PREPOBS_PREPDATA; in
#      preparation for future NRL aircraft QC code NRLACQC, added new script
#      variables NRLACQC (def=NO), USHNQC (def=${HOMEALL}/ush), NQCX
#      (def=$EXECPREP/prepobs_nrlacqc) and NQCC
#      (def=$PARMPREP/prepobs_nrlacqc.${NET}.parm"), if NRLACQC=YES will
#      execute script USHNQC to perform NRL aircraft QC (not yet ready)
# 2011-10-14  D.A. Keyser -- Updated to handle new "rap" (Rapid Refresh)
#    network and its model runs "rap", "rap_p" and "rap_e"
# 2012-05-09 S. Bender/D. Keyser -- Removed all prior references to "NRL"
#      aircraft QC script variables (never actually used) since the NRL
#      aircraft QC nomenclature is being dropped in place of the existing
#      PREPACQC nomenclature and will use its existing script variables;
#      removed all references to the ACARSQC processing since it is no longer
#      executed (ACARS QC is now performed within the revamped PREPACQC
#      processing); removed script variables no longer used by the new version
#      of the PREPACQC processing; added new script variables which are
#      associated with the new program PREPOBS_PREPACPF which now runs as a
#      second program within the PREPACQC processing (after program
#      PREPOBS_PREPACQC) in the ush script prepobs_prepacqc.sh {PROCESS_ACQC
#      (def=YES), PROCESS_ACPF (def=YES), DICTPREP (def=$HOMEALL/dictionaries),
#      DICT (def=$DICTPREP/metar.tbl), APFX (def=$EXECPREP/prepobs_prepacpf),
#      and the new second argument "$DATA/adpsfc" passed to
#      prepobs_prepacqc.sh}
# 2013-03-05  D.A. Keyser -- Modified to properly run on WCOSS system: replaced
#      all usage of "timex" with "time -p."; replaced script variables
#      XLFUNIT_n with FORTn (where n is the unit number connected to the
#      filename defined by the variable FORTn) - needed because ifort uses
#      FORTn; script is now set to run under ksh shell as the default; added
#      script variable "BACK" which, when YES, threads the mp_prepdata herefile
#      into background shells that run simultaneously (an alternative option
#      to poe which is not ready on WCOSS); touches all dump files not included
#      in BUFRLIST so that they will not cause a read error if PREPOBS_PREPDATA
#      tries to read them
# 2014-01-15  S. Melchior -- Placed into new OBSPROC_PREP vertical directory
#      structure/environmental equivalence paradigm.  As a result: imports new
#      environment variable $HOMEobsproc_prep which points to directory path for
#      generic prep subdirectories under version control (in production this is
#      normally /nwprod/obsproc_prep.vX.Y.Z where X.Y.Z is version number being
#      used, usually the latest); and imports new environment variable
#      $HOMEobsproc_network which points to directory path for network-specific
#      prep subdirectories under version control (in production this is normally
#      /nwprod//obsproc_NETWORK.vX.Y.Z where NETWORK is, e.g., global, namp, rap,
#      rtma, urma, and X.Y.Z is version number being used, usually the latest) -
#      these replace /nw${envir} in order to point to files moved from 
#      horizontal to vertical directory structure.
# 2014-02-25  D.A. Keyser -- Removed all references to RUC.  Removed option
#      to run on MACHINE=sgi - this is obsolete (as a result variables $MACHINE
#      and $HOMEALL are no longer used in this script).  Replaced variable
#      $EXECUTIL with $utilexec for directory path to utility program ndate
#      (both were exported from job scripts with same value, $EXECUTIL has now
#      been removed from all job scripts).  Removed all references to "cdc"
#      network (this is obsolete).
# 2014-07-23  D.A. Keyser -- Imported script environment variable DICTPREP now
#      defaults to new vertical structure directory path location for metar.tbl
#      dictionary, /nw${envir}/decoders/decod_shared/dictionaries, rather than
#      old horizontal structure location, /nw${envir}/dictionaries (the latter
#      will be removed in September 2014).
# 2016-02-05 JWhiting -- Use NCO-established variables to point to root
#      directories for main software components and input/output directories in
#      order to run on WCOSS Phase 1 or Phase 2 (here, $COMROOT which replaces
#      hardwire to "/com", $NWROOT which replaces hardwire to "/nwprod" in
#      comments only).  Use NCO-established variables (presumably obtained from
#      modules) to point to prod utilities [here, $NDATE from module prod_util
#      (default or specified version, loaded in each network which executes this
#      script) which replaces executable ndate in non-versioned, horizontal
#      structure utility directory path defined by imported variable $utilexec].
# 2016-04-29 D.A. Keyser  -- Updated logic such that when tropical cyclone
#      relocation has not run, a first guess is required, the network is gfs or
#      gdas, but the cycle time is not 00, 06, 12 or 18z, no attempt will be
#      made to obtain a guess 3-hrs before and after cycle time (since it can
#      fail).  Instead this is treated the same as any 3- or 1-hrly cycle run
#      (like rap, e.g.) meaning two guess files will be obtained at the
#      spanning 3 hour interval around any cycle time not a multiple of 3 hrs.
#      BENEFIT: Allows future hourly WAM model to run properly.
# 2016-07-12  D.C. Stokes -- Reinstated poe option to run multiple instances
#      of the PREPDATA processing script in parallel. New variable $launcher 
#      defines the parallel scripting launch mechanism (description below).
#      Added logic to create scaled down versions of err_chk and err_exit 
#      scripts if they don't exist in the working directory and eliminated 
#      similar blocks of logic that had been repeated throughout the script.
#      Updated USHGETGES default to pick up more recent versions of getges.sh.
# 2017-02-07  D.C. Stokes -- Updated to run on Cray-XC40 as well as iDataPlex.
#      If on Cray-XC40, default parallel scripting launching mechanism is cfp 
#      inovked by aprun. Variable name used for launching mechanism changed from
#      "launcher" to "launcher_PREP".  Variable COMDATEROOT is now the primary
#      default for the root of the directory containing NCEP date files.  The
#      variable NWROOTp1 is now the default root for directory DICTPREP.  Logic
#      used to determine if $COMSP points to production "com" directory was
#      updated to recognize full path name (as needed on luna/surge).
# 2017-03-19  D.C. Stokes/D.A. Keyser -- Updated to input nemsio atmopheric 
#      guess files -or- the older sigio atmospheric files.  The nemsio option
#      is triggered by flag NEMSIO_IN=.true.  For nemsio runs, a single guess
#      file valid at the prepbufr center time is picked up, even for runs with
#      center time that is not a multiple of 3.  Also the dbn_alert subtype is
#      now dependent upon $RUN (for transition from "gdas1" to "gdas").
# 2017-04-20  D.C. Stokes -- Relocated assignments of variable stype to ensure
#      it always passes the proper value to the getges utility script.
# 2017-06-10  D.C. Stokes -- Added logic to accommodate NET=cfs.  Added
#      arithmetic evaluation of "err_this" to remove any whitespace prior to
#      use of that variable in arithmetic comparison statements.
# 2017-07-02 JWhiting/D. Keyser 
#      - Added optional 2nd input script argument specifying cycle center time
#        minutes value and, if present, this value (set to CDATEMM) is written
#        into a new second line of the file cdate10.dat (later read by program
#        PREPOBS_PREPDATA) (if 2nd input script argument is not present, then
#        only YYYYMMDDHH is written into cdate10.dat as before).
#      - Added logic to execute new GLERL adjustment processing. Imports new
#        environment variables GLERLBUFR (which determines if GLERL adjustment
#        processing should be executed, default is NO), USHGLERL (path to ush
#        script prepobs_glerladj.sh), GLRX (path to executable
#        prepobs_glerladj), GLRD (path to pictionary glerldict.lmd) and TANK
#        (path to directory containing daily lake average temperature files).
# 2017-10-20  D.A. Keyser -- Added logic to change the line in file
#        prevents.filtering.prepdata listing the "CENTER DATE FOR PREPBUFR FILE"
#        to include minutes if $CDATEMM exists (see 2017-07-02 change above for
#        for info on $CDATEMM).
#        BENEFIT: File prevents.filtering.prepdata is cat'ed to stdout.  This
#                 corrects the listed PREPBUFR file center date for cases where
#                 RTMA_RU runs at 15, 30 and 45 minutes.
#        {Note: Someday w3emc routine gblevents, the code that creates
#               prevents.filtering.prepdata, should be updated to change this
#               but for now this was the easiest way to do it (although logic is
#               clumsy)}.
# 2018-03-05  D.A. Keyser -- Added new environment variable GETGESprep_driver
#        which points to the full path to the new GETGES driver script (default
#        is $USHGETGES/getges_driver.sh).  This is executed in place of the
#        getges utility script $GETGESprep in cases when NEMSIO_IN=.true.
#        BENEFIT: The GETGES driver script executes the GETGES utility script
#                 when NEMSIO_IN=.true. using new logic resulting from the file
#                 directory path changes being incorporated with the new FV3 GFS
#                 upgrade.  This driver script can handle either the legacy
#                 NEMSIO GFS or the new FV3 GFS.
# 2018-04-04  S. Melchior -- Modified default path for PRVT for GDAS or GFS
#        runs (prepobs_errtable.global) to point to the same file that is
#        managed by GFS model developers.  Default location is 
#        ${HOMEgfs}/fix/fix_gsi/prepobs_errtable.global.  $HOMEgfs is a new
#        variable exported from the parent job script, JGLOBAL_PREP.
#        BENEFIT: Only one version of the file needs to be maintained.
# 2018-08-16  S. Melchior -- Modified to run on Dell-p3 as well as Cray-XC40
#        and IBM iDataPlex.
# 2020-02-26  S. Melchior -- removed references to $NWROOTp1; no longer relevant
#        with the decommissioning of IBM ph1/ph2.
# 2020-10-09  S. Melchior -- Modified to accommodate new variable NETCDF_IN.
#        If .true., processing will obtain the NetCDF format first guess fields.
# 2021-04-05  S. Melchior -- Added diagnostic information just after the cp of
#        the global first guess file to sgesprep.
# 2021-12-12  S. Melchior
#             I. Genkova -- Prepared for transition to WCOSS2
#
#
# Usage:  prepobs_makeprepbufr.sh YYYYMMDDHH <mm>
#
#   Input script positional parameters:
#     1             String indicating the 10-digit center date/time for the
#                   PREPBUFR processing <YYYYMMDDHH> - if missing, then this
#                   time is obtained from the ${COMDATEROOT}/date/$cycle file
#                   (note: minutes value of center date/time for the PREPBUFR
#                          processing always assumed to be zero in this case)
#     2  (optional) String indicating the minutes value of the center date/time
#                   for the PREPBUFR processing <mm> - if missing, center
#                   date/time minutes are assumed to be zero.
#
#   Imported Shell Variables:
#
#     These must ALWAYS be exported to this script by the parent script --
#
#     COMROOT       Root to input/output "com" directory (in production,
#                   normally "/com", "/com2", or "/gpfs/hps/nco/ops/com")
#     NSPLIT        Number of parts into which the PREPDATA processing shell
#                   script (herefile MP_PREPDATA) will be split in order to
#                   run in parallel for computational efficiency (either using
#                   multiple tasks when POE is not "NO" or in background threads
#                   when BACK is "YES")
#                   NOTE : This is required ONLY if the imported shell variable
#                          POE is not "NO" (see below) or the imported shell
#                          variable BACK is "YES" (see below) (i.e., a parallel
#                          environment), and the imported shell variable
#                          PREPDATA=YES (see below)
#     NET           String indicating system network {either "gfs", "gdas",
#                   "cdas", "nam", "rap", "rtma" or "urma"}
#                   NOTE : NET is changed to gdas in the parent Job script for
#                          RUN=gdas or RUN=gdas1 (was gfs) 
#     RUN           String indicating model run {either "gfs", "gdas", "gdas1",
#                         "cdas", "nam", "ndas", "rap", "rap_p", "rap_e",
#                         "rtma", or "urma"}
#     cycle         String indicating the center cycle hour for PREPBUFR
#                   processing {"txxz", where xx is two-digit hour of the day
#                   (UTC)}
#                   NOTE : This is required ONLY if input script positional
#                          parameter 1 is missing (see above)
#     DATA          String indicating the working directory path (usually a
#                   temporary location)
#     COMSP         String indicating the directory/filename path to input BUFR
#                   observational data dumps, global atmos guess files, and 
#                   status files
#                   (e.g. "$COMROOT/obsproc/v1.0/gfs.20220512/00/atmos/gfs.t12z.")
#     COMSPtcvital  String indicating the directory/filename path to input BUFR
#                   tropical cyclone location (tcvitals) files
#                   (e.g. "$COMROOT/gfs/v16.2/gfs.20220512/00/atmos/gfs.t12z.")
#     DBNROOT       String indicating directory path to bin/dbn_alert file
#                   location
#                   NOTE : This is required ONLY if the imported shell variable
#                          SENDDBN is "YES" (see below)
#     job         - String indicating job name (e.g., 'gdas_prep_12')
#                   NOTE : This is required ONLY if the imported shell variable
#                          SENDDBN is "YES" (see below)
#     $HOMEobsproc         - formerly $HOMEobsproc_prep prior to WCOSS2
#                            string indicating directory path to network
#                            specific parm settings.
#     $HOMEprepobs         - formerly $HOMEobsproc_prep prior to WCOSS2
#                            string indicating directory path to prep
#                            subdirectories (fix/, sorc/, ush/) under version
#                            control (pre-WCOSS2, in production this is normally
#                            ${NWROOT}/obsproc_prep.vX.Y.Z where X.Y.Z is
#                            version number being used, usually the latest)
#                            WCOSS2: prepobs module 
#                          - formerly $HOMEobsproc_network prior to WCOSS2
#                            string indicating directory path to network-
#                            specific prep subdirectories under version control
#                            (pre-WCOSS2, in production this is normally
#                            ${NWROOT}/obsproc_NETWORK.vX.Y.Z where NETWORK is,
#                            e.g., global, nam, rap, rtma, urma, and X.Y.Z is
#                            version number being used, usually the latest)
#                            WCOSS2: $PACKAGEROOT/obsproc.vX.Y.Z
#
#     These will be set to their default value in this script if not exported
#      to this script by the parent script --
#
#     SITE          Site name (may have been set by local shell startup script)
#                   Default is ""
#     sys_tp        System type and phase.  If not imported, an attempt is made
#                   to set it using getsystem (an NCO prod_util script).
#                   A failed attempt results in an empty string.
#     NEMSIO_IN     Flag that if ".true." indicates that nemsio atmospheric 
#                   background fields will be input rather than sigio.
#                   Default is ""
#     NETCDF_IN     Flag that if ".true." indicates that netcdf atmospheric
#                   background fields will be input rather than sigio or nemsio
#                   Default is ""
#     SENDDBN       String indicating whether or not to alert an output file to
#                   the NWS/TOC (= "YES" - invoke alert; anything else - do not
#                   invoke alert)
#                   Default is "NO"
#     NPROCS        Number of "poe" tasks to use for mpmd (must be .GE. $NSPLIT)
#                   NOTE : This is applicable ONLY if the imported shell
#                          variable POE is not "NO" (see below) and variable 
#                          launcher_PREP is not "cfp" or "aprun" (see below) and
#                          the imported shell variable PREPDATA=YES (see below)
#                   For LSF jobs, the count of hosts listed in string $LSB_HOSTS
#                   will be used to set NPROCS (overriding any imported value).
#                   Default is "$NSPLIT"
#     envir         String indicating environment under which job runs ('prod'
#                   or 'test')
#                   Default is "prod"
#     envir_getges  String indicating environment under which GETGES utility
#                   ush runs (see getges.sh docblock for more information)
#                   Default is "$envir"
#     network_getges
#                   String indicating job network under which GETGES utility
#                   ush runs (see getges.sh docblock for more information)
#                   Default is "global" unless the center PREPBUFR processing
#                   date/time is not a multiple of 3-hrs and the global guess is
#                   sigio-based, then the default is "gfs"
#     pgmout        String indicating file containing standard output (output
#                   always contatenated onto this file)
#                   Default is "/dev/null"
#     tstsp         String indicating the directory/filename path to one or
#                   more BUFR observational data dumps and/or tropical cyclone
#                   location (tcvitals) files and/or global atmos guess files
#                   and/or status files that are to override the corresponding
#                   file in $COMSP (this should be imported with the same
#                   naming convention as $COMSP; e.g.,
#                   "/gpfstmp/wx22dk/test_dump/ndas.20060612/ndas.t12z." -
#                   (if tstsp is not imported, the default is used and no
#                   overriding file would exist; if tstsp is imported then any
#                   file found would override the corresponding file in $COMSP)
#                   Default is "/tmp/null/"
#     tmmark      - string indicating hour for center PREPBUFR processing date/
#                   time relative to the analysis time embedded in $tstsp or
#                   $COMSP (e.g., "tm12", "tm09", "tm06", "tm03", "tm00")
#                   Default is "tm00"
#     BUFRLIST      String indicating list of BUFR data dump file names to
#                   process
#                   Default is "uprair proflr aircar aircft satwnd adpupa \
#                   adpsfc sfcshp sfcbog vadwnd goesnd spssmi erscat qkswnd \
#                   msonet gpsipw rassda wdsatr ascatw"
#     POE           String indicating whether or not to use a poe-like launcher
#                   to spread instances of the PREPBUFR processing herefile 
#                   MP_PREPDATA over multiple pes in parallel. (= "NO" - 
#                   do not invoke invoke "poe"; anything else - invoke "poe")
#                   Default is "YES"
#     launcher_PREP Parallel scripting launch tool. Settings are in place for
#                   aprun, mpirun.lsf, and cfp but a different tool can be
#                   specified.
#                   NOTE : This is applicable ONLY if the imported shell
#                          variable POE is not "NO" and the imported shell
#                          variable PREPDATA=YES (see below)
#                   Default on Dell-p3 is "mpirun".  Default on Cray-XC40 is
#                   "aprun". Otherwise: "mpirun.lsf"
#     BACK          String indicating whether or not to run background shells
#                   (on the same task) for the PREPBUFR processing (= "YES" -
#                   run background shells; anything else - do not run
#                   background shells). IF BACK=YES on Cray-XC40, the shells
#                   are invoked by aprun.
#     USHSYND       String indicating directory path for SYNDATA ush file
#                   Default is "${HOMEprepobs}/ush"
#     USHGLERL      String indicating directory path for GLERLBUFR ush file
#                   Default is "${HOMEprepobs}/ush}"
#     USHPREV       String indicating directory path for PREVENTS ush file
#                   Default is "${HOMEprepobs}/ush"
#     USHCQC        String indicating directory path for CQCBUFR ush file
#                   Default is "${HOMEprepobs}/ush"
#     USHPQC        String indicating directory path for PROFCQC ush file
#                   Default is "${HOMEprepobs}/ush"
#     USHVQC        String indicating directory path for CQCVAD ush file
#                   Default is "${HOMEprepobs}/ush"
#     USHAQC        String indicating directory path for PREPACQC ush file
#                   Default is "${HOMEprepobs}/ush"
#     USHOIQC       String indicating directory path for OIQCBUFR ush file
#                   Default is "${HOMEprepobs}/ush"
#     EXECPREP      String indicating directory path for PREPOBS executables
#                   Default is "${HOMEprepobs}/exec"
#     PARMPREP      String indicating directory path for PREPOBS parm files
#                   Default is "${HOMEobsproc}/parm"
#     FIXPREP       String indicating directory path for PREPOBS fix-field
#                   files
#                   Default is "${HOMEprepobs}/fix"
#     DICTPREP      String indicating directory path for PREPOBS dictionary
#                   files
#                   Default is "${OPSROOT}/decoders/decod_shared/dictionaries"
#     EXECSYND      String indicating directory path for SYNTHETIC data
#                   executables
#                   Default is "${HOMEprepobs}/exec"
#     PARMSYND      String indicating directory path for SYNTHETIC parm files
#                   Default is "${HOMEobsproc}/parm"
#     FIXSYND       String indicating directory path for SYNTHETIC data fix-
#                   field files
#                   Default is "${HOMEprepobs}/fix"
#     GETGUESS      String: if = "YES" will encode first guess (background)
#                   values interpolated by the program PREPOBS_PREPDATA to
#                   observation locations in the PREPBUFR file for use by the
#                   q.c. programs.  This guess is always from a global atmos
#                   guess file valid at the center PREPBUFR processing date/
#                   time or from an interpolated guess obtained from global
#                   atmos guess files valid at times 3-hours apart which span
#                   the PREPBUFR processing date/time (the latter is performed
#                   by the program PREPOBS_PREPDATA and occurs when the guess
#                   files are sigio-based and the PREPBUFR date/time hour is not
#                   a multiple of 3, e.g. 02Z rap or tm04 nam catchup runs). The
#                   guess file (or files) may be obtained in one of two ways:
#                       1) From pre-existing files in the working directory
#                          $DATA called sgesprep and sgesprepA (either copied
#                          there prior to the execution of this script, or
#                          copied there earlier in this script from either
#                          $tstsp, or if not found there, $COMSP which was
#                          populated by the previous running of tropical
#                          cyclone relocation processing
#                           NOTE 1: sgesprepA is needed only when the guess is
#                                   sigio-based and the PREPBUFR processing
#                                   date/time is not a multiple of 3-hrs.
#                           NOTE 2: if previous tropical cyclone relocation
#                                   processing was run, then an sgesprepA file
#                                   is NEVER generated, not a problem since
#                                   previous tropical cyclone relocation
#                                   processing is not run in rap, rap_p or
#                                   rap_e runs
#                       2) Via the execution of the GETGES utility ush to
#                          obtain sgesprep (if pre-existing file $DATA/sgesprep
#                          does not exist), and possibly via the execution of
#                          the GETGES utility ush to obtain sgesprepA (if
#                          PREPBUFR processing date/time is not a multiple of
#                          3-hrs and the global guess is sigio-based, and the
#                          pre-existing file $DATA/sgesprepA does not exist)
#                   Default is "YES"
#                   NOTE: If GETGUESS=NO, then the program PREPOBS_PREPDATA
#                         will NOT call w3emc routine GBLEVENTS to perform
#                         "prevents" processing
#     PREPDATA      String: if = "YES" will perform PREPDATA processing
#                   (in either a parallel or serial environment depending upon
#                   the values for POE and BACK)
#                   Default is "YES"
#     SYNDATA       String: if = "YES" will attempt to perform synthetic bogus
#                   processing (generation of synthetic bogus winds to be
#                   appended to PREPBUFR file and, possibly, flagging of mass
#                   pressure data "near" storms; and, possibly, flagging of
#                   dropwinsonde wind data "near" storms)
#                   Default is "YES"
#     GLERLBUFR     String: if = "YES" will perform GLERL adjustment processing
#                   Default is "NO"
#     DO_QC         String: if = "YES" will perform quality control
#                   Default is "YES"
#     PREVENTS      String: if = "YES" will encode background and obs. errors
#                   into PREPBUFR file (usually this should be "NO" since the
#                   programs PREPOBS_PREPDATA and SYNDAT_SYNDATA normally are
#                   set to perform this function)
#                   NOTE: Only invoked if DO_QC=YES
#                   Default is "NO"
#     CQCBUFR       String: if = "YES" will complex quality control radiosonde
#                   data
#                   NOTE: Only invoked if DO_QC=YES
#                   Default is "YES"
#     PROFCQC       String: if = "YES" will quality control wind profiler data
#                   NOTE: Only invoked if DO_QC=YES
#                   Default is "YES"
#     CQCVAD        String: if = "YES" will quality control VAD wind data
#                   NOTE: Only invoked if DO_QC=YES
#                   Default is "YES"
#     PREPACQC      String: if = "YES" will quality control aircraft data
#                   NOTE: Only invoked if DO_QC=YES
#                   Default is "YES"
#     PROCESS_ACQC  String: if = "YES" will execute PREPOBS_PREPACQC program as
#                   part of PREPACQC processing
#                   NOTE: Only invoked if PREPACQC=YES
#                   Default is "YES"
#     PROCESS_ACPF  String: if = "YES" will execute PREPOBS_PREPACPF program as
#                   part of PREPACQC processing
#                   NOTE: Only invoked if PREPACQC=YES
#                   Default is "YES"
#     OIQCBUFR      String: if = "YES" will perform final oi-based quality
#                   control on all data
#                   NOTE: Only invoked if DO_QC=YES
#                   Default is "YES"
#     MPCOPYX       String indicating executable path for PREPOBS_MPCOPYBUFR
#                   program
#                   Default is "$EXECPREP/prepobs_mpcopybufr"
#     PRPX          String indicating executable path for PREPOBS_PREPDATA
#                   program
#                   Default is "$EXECPREP/prepobs_prepdata"
#     errPREPDATA_limit
#                   String indicating the highest allowed foreground exit
#                   status for program PREPOBS_PREPDATA (any exit status higher
#                   than this is considered a failure)
#                   (Note: errPREPDATA_limit=1 is ALWAYS considered a FAILURE)
#                   Default is "0"
#     PRPC          String indicating data card path for PREPOBS_PREPDATA
#                   program
#                   Default is "$PARMPREP/prepobs_prepdata.${NET}.parm"
#     PRPT          String indicating bufrtable file path for PREPOBS_PREPDATA
#                   program
#                   Default is "$FIXPREP/prepobs_prep.bufrtable"
#     LANDC         String indicating land/sea mask file path for
#                   PREPOBS_PREPDATA program
#                   Default is "$FIXPREP/prepobs_landc"
#     PRVT          String indicating observational error table file path for
#                   PREPOBS_PREPDATA, SYNDAT_SYNDATA and PREPOBS_PREVENTS
#                   programs (used by GBLEVENTS subroutine)
#                   NOTE: Only read by gdas, gfs, cdas and nam networks
#                   If imported "RUN=gdas" or "RUN=gfs", default is
#                   "$HOMEgfs/fix/prepobs_errtable.global";
#                   if imported "NET=cdas", default is
#                   "$HOMEprepobs/fix/prepobs_errtable.cdas";
#                   if imported "NET=nam", default is
#                   "$HOMEprepobs/fix/prepobs_errtable.nam"
#                   otherwise, default is "$DATA/scratch.PRVT" a null file
#     LISTHDX       String indicating executable path for PREPOBS_LISTHEADERS
#                   program
#                   Default is "$EXECPREP/prepobs_listheaders"
#     MONOBFRX      String indicating executable path for PREPOBS_MONOPREPBUFR
#                   program
#                   Default is "$EXECPREP/prepobs_monoprepbufr"
#     SYNDX         String indicating executable path for SYNDAT_SYNDATA
#                   program
#                   Default is "$EXECSYND/syndat_syndata"
#     SYNDC         String indicating data card path for SYNDAT_SYNDATA program
#                   Default is "$PARMSYND/syndat_syndata.${NET}.parm"
#     GLRX          String indicating executable path for PREPOBS_GLERLADJ
#                   program
#                   Default is "$EXECPREP/prepobs_glerladj"
#     GLRD          String indicating GLERL dictionary file path for
#                   PREPOBS_GLERLADJ program
#                   Default is "$FIXPREP/glerldict.lmd"
#     PREX          String indicating executable path for PREPOBS_PREVENTS
#                   program
#                   Default is "$EXECPREP/prepobs_prevents"
#     PREC          String indicating data card path for PREPOBS_PREVENTS
#                   program
#                   Default is "$PARMPREP/prepobs_prevents.${NET}.parm"
#     AQCX          String indicating executable path for PREPOBS_PREPACQC
#                   program
#                   Default is "$EXECPREP/prepobs_prepacqc"
#     AQCC          String indicating data card path for PREPOBS_PREPACQC
#                   program
#                   Default is "$PARMPREP/prepobs_prepacqc.${NET}.parm"
#     APFX          String indicating executable path for PREPOBS_PREPACPF
#                   program
#                   Default is "$EXECPREP/prepobs_prepacpf"
#     DICT          String indicating METAR station dictionary path for
#                   PREPOBS_PREPACPF program
#                   Default is "$DICTPREP/metar.tbl"
#     PQCX          String indicating executable path for PREPOBS_PROFCQC
#                   program
#                   Default is "$EXECPREP/prepobs_profcqc"
#     PQCC          String indicating data card path for PREPOBS_PROFCQC
#                   program
#                   Default is "$PARMPREP/prepobs_profcqc.${NET}.parm"
#     VQCX          String indicating executable path for PREPOBS_CQCVAD
#                   program
#                   Default is "$EXECPREP/prepobs_cqcvad"
#     CQCX          String indicating executable path for PREPOBS_CQCBUFR
#                   program
#                   Default is "$EXECPREP/prepobs_cqcbufr"
#     CQCC          String indicating data card path for PREPOBS_CQCBUFR
#                   program
#                   Default is "$PARMPREP/prepobs_cqcbufr.${NET}.parm"
#     CQCS          String indicating statbge path for PREPOBS_CQCBUFR program
#                   Default is "$FIXPREP/prepobs_cqc_statbge"
#     OIQCX         String indicating executable path for PREPOBS_OIQCBUFR
#                   program
#                   Default is "$EXECPREP/prepobs_oiqcbufr"
#     OIQCT         String indicating observational error table file path for
#                   PREPOBS_OIQCBUFR program
#                   NOTE: If imported "NET=cdas", default is
#                   "$HOMEprepobs/fix/prepobs_oiqc.oberrs.cdas"; 
#                   otherwise default is
#                   "$HOMEprepobs/fix/prepobs_oiqc.oberrs"
#     TANK          String indicating path to directory containing daily lake
#                   average temperature files (invoked only if GLERLBUFR=YES)
#                   Default is "$DCOMROOT", where default for $DCOMROOT
#                   is "/lfs/h1/ops/prod/dcom"
#
#     These do not have to be exported to this script.  If they are, they will
#      be used by the script.  If they are not, they will be skipped
#      over by the script.
#
#     PREPBUFR_APP  String indicating path to output PREPBUFR file for
#                   PREPOBS_PREPDATA program.
#                   If present and POE is "NO" and BACK is not "YES"  (i.e., a
#                    serial environment), PREPOBS_PREPDATA will append all
#                    output BUFR messages to a copy of this file (prepda) in
#                    the current working directory, using the internal BUFR
#                    mnemonic table in the first several BUFR messages at the
#                    top of the file
#                    NOTE 1: In this case, it is assumed the the switch APPEND
#                            is set to TRUE in the parm cards $PRPC (careful,
#                            if APPEND is FALSE, the original copy of
#                            $PREPBUFR_APP will be wiped out and the case below
#                            will occur)
#                    NOTE 2: When POE is not "NO" or BACK is "YES"  (i.e., a
#                            parallel environment), appending makes no sense
#                            because the original output PREPBUFR file is
#                            monolithic
#                   If not present or POE is not "NO" or BACK is "YES" (i.e., a
#                    parallel environment), PREPOBS_PREPDATA will write all
#                    output BUFR messages to a new file (prepda) in the current
#                    working directory using the external BUFR mnemonic table
#                    in the file $PRPT
#                    NOTE 3: In this case, it is assumed the the switch APPEND
#                            is set to FALSE in the parm cards $PRPC (careful,
#                            if APPEND is TRUE, PREPOBS_PREPDATA will abort
#                            because the original empty PREPBUFR file has no
#                            internal BUFR mnemonic table)
#     PREPBUFR_IN   String indicating path to input PREPBUFR file
#                   If present, this file will be used by SYNDAT_SYNDATA (if
#                    SYNDATA=YES - see @ below) and by all applicable Q.C.
#                    programs (set to to be invoked here) rather than the
#                    PREPBUFR file generated in this script by PREPOBS_PREPDATA
#                    (normally this would be used when PREPDATA=NO)
#                         @ - if the PREPBUFR_IN target file is obtained from
#                           ${COMROOT}/*/prod/*.YYYYMMDD/*.tCCz.prepbufr_pre-qc,
#                             then for all runs on and after 12Z 25 Jan 2005,
#                             SYNDATA should be NO because the target files
#                             will already contain synthetic bogus data;
#                             if the PREPBUFR_IN target file is obtained from
#                           ${COMROOT}/*/prod/*.YYYYMMDD/*.tCCz.prepbufr_pre-qc,
#                             then for all runs prior to 12Z 25 Jan 2005,
#                             SYNDATA should be YES because the target files
#                             will not have contain synthetic bogus data.
#                   If not present, then the PREPBUFR file generated in this
#                    script by PREPOBS_PREPDATA and possibly appended to by
#                    SYNDAT_SYNDATA is passed on as input to all applicable
#                    Q.C. programs
#     jlogfile      String indicating path to joblog file
#
#     These do not have be exported to this script.
#
#     COMDATEROOT   Primary default for the root of the directory containing
#                   produciton date files.
#
#     NWROOTp1      Root directory for production software on WCOSS Phase 1.
#
#     USHGETGES     String indicating directory path for both GETGES utility
#                   script and GETGES driver script.
#                   Default is $HOMEprepobs/ush.
#
#     GETGESprep    GETGES utility script. 
#                   If NETCDF_IN=.true.,  defaults to:
#                       $USHGETGES/getges_nc.sh
#                   If NEMSIO_IN=.true.,  defaults to:
#                       $USHGETGES/getges.sh 
#                     (either option above is executed by $GETGESprep_driver, see below)
#                   otherwise, defaults to:
#                       $USHGETGES/getges_sig.sh
#
#     GETGESprep_driver
#                   GETGES driver script. Defaults to:
#                       $USHGETGES/getges_driver.sh
#                   Note: Only invoked if NEMSIO_IN=.true. .
#
#     PREPDATAtpn   Tasks per node when invoking cfp on Cray-XC40.  Will be
#                   computed if needed but was not imported.
#                   
#     These do not have to be exported to this script.  If they are, they will
#      be passed on to the script $USHCQC/prepobs_cqcbufr.sh. They are not used
#      by this script.
#
#     PRPI_m24      See documentation in $USHCQC/prepobs_cqcbufr.sh
#     PRPI_m12      See documentation in $USHCQC/prepobs_cqcbufr.sh
#     PRPI_p12      See documentation in $USHCQC/prepobs_cqcbufr.sh
#     PRPI_p24      See documentation in $USHCQC/prepobs_cqcbufr.sh
#
#   Exported Shell Variables:
#     CDATE10       String indicating the center (cycle) date for the PREPBUFR
#                   processing <YYYYMMDDHH>
#     CDATEMM       String indicating the minutes value of the center (cycle)
#                   date for the PREPBUFR processing <mm> (if set in script)
#     SGES          Either ...
#                    1) String indicating the full path name for global
#                       sigio-based, nemsio-based, or NetCDF-based guess file
#                       valid at the center PREPBUFR processing date/time (in
#                       which case the center PREPBUFR processing date/time is
#                       a multiple of 3-hrs, or for any PREPBUFR center hour if
#                       global guess is nemsio-based or NetCDF-based)  - This
#                       guess file will be encoded into the PREPBUFR file for
#                       use by the q.c. programs.
#                             -- or --
#                    2) String indicating the full path name for the global
#                       atmosperic guess file valid at the nearest cycle time
#                       prior to the center PREPBUFR processing date/time which
#                       is a multiple of 3 (in which case the center PREPBUFR
#                       processing date/time is not a multiple of 3-hrs and the
#                       global guess is sigio-based) - A linear interpolation
#                       (of the spectal coefficients) between this file and the
#                       guess file indicated by SGESA case 2 below will be
#                       performed by program PREPOBS_PREPDATA and encoded into
#                       the PREPBUFR file for use by the q.c. programs.  The
#                       SGES file is always from the GFS in this case.
#                     NOTE 1: Only case 1 above is valid when tropical cyclone
#                             relocation processing previously occurred.
#                     NOTE 2: Case 2 above is necessary because the w3emc lib
#                             routine gblevents called by PREPOBS_PREPDATA
#                             expects that sigio-based guess files will only
#                             have valid hours which are a multiple of 3
#                     NOTE 3: Only case 1 above is valid when global guess is
#                             nemsio-based or NetCDF-based.
#     SGESA         Either ...
#                    1) String set to "/dev/null" for case 1 of SGES above
#                       (default)
#                             -- or --
#                    2) String indicating the full path name for the global
#                       sigma guess file valid at the nearest cycle time after
#                       the center PREPBUFR processing/date time which is a
#                       multiple of 3 for case 2 of SGES above - A linear
#                       interpolation (of the spectal coefficients) between
#                       this guess file and the guess file indicated by SGES
#                       above (see case 2 for SGES) will be performed by the
#                       program PREPOBS_PREPDATA and encoded into the PREPBUFR
#                       file for use by the q.c. programs.  The SGESA file is
#                       always from the GFS in this case and its forecast hour
#                       is 3-hrs later than the SGES file (thus both initiate
#                       at the same time).
#                     NOTE 1: Only case 1 above is valid when tropical cyclone
#                             relocation processing previously occurred.
#                     NOTE 2: Case 2 above is necessary because the w3emc lib
#                             routine gblevents called by PREPOBS_PREPDATA
#                             expects that sigio-based guess files will only
#                             have valid hours which are a multiple of 3
#                     NOTE 3: Only case 1 above is valid when global guess is
#                             nemsio-based or NetCDF-based.
#   
#
#   Modules and files referenced:
#     herefiles  : $DATA/MP_PREPDATA
#                  $DATA/MERGE_MSGS
#     scripts    : $USHGETGES/getges.sh
#                  $USHGETGES/getges_sig.sh
#                  $USHGETGES/getges_driver.sh
#                  $USHSYND/prepobs_syndata.sh
#                  $USHGLERL/prepobs_glerladj.sh
#                  $USHPREV/prepobs_prevents.sh
#                  $USHCQC/prepobs_cqcbufr.sh
#                  $USHPQC/prepobs_profcqc.sh
#                  $USHVQC/prepobs_cqcvad.sh
#                  $USHAQC/prepobs_prepacqc.sh
#                  $USHOIQC/prepobs_oiqcbufr.sh
#                  $DATA/postmsg (required ONLY if "$jlogfile" is present)
#                  $DATA/prep_step {here and by referenced script(s)}
#                  $DATA/err_exit
#                  $DATA/err_chk {here and by referenced script(s)}
#                  (NOTE: The last three scripts above are NOT REQUIRED
#                         utilities. If $DATA/prep_step not found, a scaled down
#                         version of it is executed in-line. If $DATA/err_exit
#                         or $DATA/err_chk are not found, scaled down versions,
#                         created in-line, are executed.
#     executables: $NDATE (from prod_util module)
#     programs   :
#          PREPOBS_MPCOPYBUFR   - executable: $MPCOPYX
#          PREPOBS_PREPDATA     - executable: $PRPX
#                                 land/sea mask: $LANDC
#                                 bufr mnemonic user table: $PRPT
#                                 obs. error table: $PRVT
#                                 data cards: $PRPC
#          PREPOBS_LISTHEADERS  - executable: $LISTHDX
#          PREPOBS_MONOPREPBUFR - executable: $MONOBFRX
#          SYNDAT_SYNDATA       - executable: $SYNDX
#                                 T126 gaussian land/sea mask:
#                                   $FIXSYND/syndat_syndata.slmask.t126.gaussian
#                                 weights: $FIXSYND/syndat_weight
#                                 obs. error table: $PRVT
#                                 data cards: $SYNDC
#          PREPOBS_GLERLADJ     - executable: $GLRX
#                                 dictionary: $GLRD
#                                 lake temperatures:
#                          $DCOMROOT/prod/<yyyymmdd>/wtxtbul/glsea-temps.dat
#          PREPOBS_PREVENTS     - executable: $PREX
#                                 obs. error table: $PRVT
#                                 data cards: $PREC
#          PREPOBS_PREPACQC     - executable: $AQCX
#                                 data cards: $AQCC
#          PREPOBS_PREPACPF     - executable: $APFX
#                                 dictionary: $DICT
#          PREPOBS_PROFCQC      - executable: $PQCX
#                                 data cards: $PQCC
#          PREPOBS_CQCVAD       - executable: $VQCX
#          PREPOBS_CQCBUFR      - executable: $CQCX
#                                 data cards: $CQCC
#          PREPOBS_OIQCBUFR     - executable: $OIQCX
#                                 obs. error table: $OIQCT
#
# Remarks:
#
#   Condition codes
#      0 - no problem encountered
#     >0 - some problem encountered
#
# Attributes:
#   Language: Korn shell under linux
#   Machine:  NCEP WCOSS
#
####

set -aux

NEMSIO_IN=${NEMSIO_IN:=""}
NETCDF_IN=${NETCDF_IN:=""}
jlogfile=${jlogfile:=""}
SENDDBN=${SENDDBN:-NO}

if [ ! -d $DATA ] ; then mkdir -p $DATA ;fi

cd $DATA

qid=$$

#####################################################
#####################################################
# create error check and exit utilities if necessary.
# (as may be the case for some developer runs)
#####################################################

if [ ! -x $DATA/err_exit ]; then
cat <<\EOFerrexit > $DATA/err_exit
   set -x
   if [ -n "$LSB_JOBID" ]; then
      bkill $LSB_JOBID
      sleep 60
      date
   else
      set -e
      kill -n 9 $qid
   fi
   exit 7    # for extra measure
EOFerrexit
chmod 775 $DATA/err_exit
fi

if [ ! -x $DATA/err_chk ]; then
cat <<\EOFerrchk > $DATA/err_chk
   set -x
   if [ "$err" != '0' ]; then
      $DATA/err_exit
   fi
EOFerrchk
chmod 775 $DATA/err_chk
fi

#####################################################
#####################################################


#  determine local system name and type if available
#  -------------------------------------------------
SITE=${SITE:-""}
sys_tp=${sys_tp:-$(getsystem)}
getsystp_err=$?
if [ $getsystp_err -ne 0 ]; then
   msg="***WARNING: error using getsystem to determine system type and phase"
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
fi
echo sys_tp is set to: $sys_tp

#-------------------------------------------------------------------------------

#  obtain the center (cycle) date for PREPBUFR processing
#  ------------------------------------------------------

CDATEMM=""
if [ $# -eq 0 ] ; then
   cp ${COMDATEROOT:-$COMROOT}/date/$cycle ncepdate
   err0=$?
   CDATE10=`cut -c7-16 ncepdate`
else
   CDATE10=$1
   if [ "${#CDATE10}" -ne '10' ]; then
      err0=1
   else
      cycle=t`echo $CDATE10|cut -c9-10`z
      err0=0
      if [ $# -eq 2 ]; then
         CDATEMM=$2
         if [ "${#CDATEMM}" -ne '2' ]; then
            err0=2
         fi
         cycle=t`echo $CDATE10|cut -c9-10`${CDATEMM}z
      fi
   fi
fi

if test $err0 -ne 0
then
#  problem with obtaining date record so exit
   set +x
   echo
   echo "problem with obtaining date record;"
   echo "ABNORMAL EXIT!!!!!!!!!!!"
   echo
   set -x
   $DATA/err_exit
   exit 55  # for extra measure
fi

cyc=`echo $CDATE10|cut -c9-10`
modhr=`expr $cyc % 3`

msg="CENTER DATE/TIME FOR PREPBUFR PROCESSING IS ${CDATE10}"
[ -n "$CDATEMM" ]  &&  msg="$msg:${CDATEMM}"

set +x
echo
echo $msg
echo
set -x

#----------------------------------------------------------------------------

#  Create variables needed for this script and its children
#  --------------------------------------------------------

envir=${envir:-prod}

envir_getges=${envir_getges:-$envir}
if [ $NET = cfs ]; then 
   network_getges=${network_getges:-"cfs-cdas"}
else
  if [ $modhr -eq 0 -o "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then
     network_getges=${network_getges:-global}
  else
     network_getges=${network_getges:-gfs}
  fi
fi

pgmout=${pgmout:-/dev/null}

tstsp=${tstsp:-/tmp/null/}
tmmark=${tmmark:-tm00}

BUFRLIST=${BUFRLIST:-"uprair proflr aircar aircft satwnd adpupa adpsfc \
 sfcshp sfcbog vadwnd goesnd spssmi erscat qkswnd msonet gpsipw rassda \
 wdsatr ascatw"}

PREPDATA=${PREPDATA:-YES}

if [ "$PREPDATA" != 'YES' ] ; then
   POE=NO
   BACK=NO
else
   set +u
   [ -z "$POE" -a "$BACK" = 'YES' ]  &&  POE=NO
   POE=${POE:-YES}
   if [ "$POE" != 'NO' -a "$BACK" = 'YES' ]; then
   set -u
      set +x
echo
echo "YOU have set both POE and BACK to YES - choose one or the other!!"
echo "Defaults are POE=YES and BACK=NO, as is preferable for WCOSS."
echo
      set -x
      exit 99
   fi
   BACK=${BACK:-NO}
   PARALLEL=NO
   [ "$POE" != 'NO' -o "$BACK" = 'YES' ]  &&  PARALLEL=YES
   if [ "$POE" != 'NO' ] ; then
      launcher_PREP=${launcher_PREP:-mpiexec} 
      if [ "$launcher_PREP" != 'cfp' -a "$launcher_PREP" != aprun ]; then 
         NPROCS=${NPROCS:-$NSPLIT}
         if [ $NPROCS -lt $NSPLIT ]; then 
            set +x
echo "********************************************************************"
echo "                   P  R  O  B  L  E  M   !   !   !                  "
echo "********************************************************************"
echo "        NPROCS=$NPROCS IS NOT SUFFICIENT FOR NSPLIT=$NSPLIT         "     
echo "        NPROCS must be greater than NSPLIT when using a             "     
echo "          parallel processing launcher other than cfp               "     
echo "********************************************************************"
            set -x
            msg="***FATAL ERROR:  Insufficient NPROCS for NSPLIT=$NSPLIT"
            [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
            $DATA/err_exit
            exit 55  # for extra measure
         fi
      fi
   elif [ "$BACK" = 'YES' ] ; then
      NPROCS=$NSPLIT
   fi
# fi for PREPDATA != YES
fi

USHSYND=${USHSYND:-${HOMEprepobs}/ush}
USHGLERL=${USHGLERL:-${HOMEprepobs}/ush}
USHPREV=${USHPREV:-${HOMEprepobs}/ush}
USHCQC=${USHCQC:-${HOMEprepobs}/ush}
USHPQC=${USHPQC:-${HOMEprepobs}/ush}
USHVQC=${USHVQC:-${HOMEprepobs}/ush}
USHAQC=${USHAQC:-${HOMEprepobs}/ush}
USHOIQC=${USHOIQC:-${HOMEprepobs}/ush}

EXECPREP=${EXECPREP:-${HOMEprepobs}/exec}
PARMPREP=${PARMPREP:-${HOMEobsproc}/parm}
FIXPREP=${FIXPREP:-${HOMEprepobs}/fix}
DICTPREP=${DICTPREP:-${OPSROOT}/decoders/decod_shared/dictionaries}

EXECSYND=${EXECSYND:-${HOMEprepobs}/exec}
PARMSYND=${PARMSYND:-${HOMEobsproc}/parm}
FIXSYND=${FIXSYND:-${HOMEprepobs}/fix}

GETGUESS=${GETGUESS:-YES}
if [ "$GETGUESS" = 'YES' ]; then
   USHGETGES=${USHGETGES:-${HOMEprepobs}/ush}
   if [ "$NEMSIO_IN" = .true. ]; then
      GETGESprep_driver=${GETGESprep_driver:-$USHGETGES/getges_driver.sh}
      GETGESprep=${GETGESprep:-$USHGETGES/getges.sh}
   elif [ "$NETCDF_IN" = .true. ]; then
      GETGESprep_driver=${GETGESprep_driver:-$USHGETGES/getges_driver.sh}
      GETGESprep=${GETGESprep:-$USHGETGES/getges_nc.sh}
   else
      GETGESprep=${GETGESprep:-$USHGETGES/getges_sig.sh}
   fi
fi

PREPDATA=${PREPDATA:-YES}

SYNDATA=${SYNDATA:-YES}

GLERLBUFR=${GLERLBUFR:-NO} # normally only runs in URMA

DO_QC=${DO_QC:-YES}

PREVENTS=${PREVENTS:-NO}
CQCBUFR=${CQCBUFR:-YES}
PROFCQC=${PROFCQC:-YES}
CQCVAD=${CQCVAD:-YES}
PREPACQC=${PREPACQC:-YES}
PROCESS_ACQC=${PROCESS_ACQC:-YES}
PROCESS_ACPF=${PROCESS_ACPF:-YES}
OIQCBUFR=${OIQCBUFR:-YES}

MPCOPYX=${MPCOPYX:-$EXECPREP/prepobs_mpcopybufr}
PRPX=${PRPX:-$EXECPREP/prepobs_prepdata}
errPREPDATA_limit=${errPREPDATA_limit:-0}
PRPC=${PRPC:-$PARMPREP/prepobs_prepdata.${NET}.parm}
PRPT=${PRPT:-$FIXPREP/prepobs_prep.bufrtable}
cp $PRPT prep.bufrtable
LANDC=${LANDC:-$FIXPREP/prepobs_landc}
if [ "$RUN" = 'gdas' -o "$RUN" = 'gfs' ]; then
   PRVT=${PRVT:-$HOMEgfs/fix/prepobs_errtable.global}
elif [ "$NET" = 'cdas' ]; then
   PRVT=${PRVT:-$HOMEprepobs/fix/prepobs_errtable.cdas}
elif [ "$NET" = 'nam' ]; then
   PRVT=${PRVT:-$HOMEprepobs/fix/prepobs_errtable.nam}
else
   cp /dev/null $DATA/scratch.PRVT
   PRVT=${PRVT:-$DATA/scratch.PRVT}
fi
LISTHDX=${LISTHDX:-$EXECPREP/prepobs_listheaders}
MONOBFRX=${MONOBFRX:-$EXECPREP/prepobs_monoprepbufr}
SYNDX=${SYNDX:-$EXECSYND/syndat_syndata}
SYNDC=${SYNDC:-$PARMSYND/syndat_syndata.${NET}.parm}
GLRX=${GLRX:-$EXECPREP/prepobs_glerladj}
GLRD=${GLRD:-$FIXPREP/glerldict.lmd}
PREX=${PREX:-$EXECPREP/prepobs_prevents}
PREC=${PREC:-$PARMPREP/prepobs_prevents.${NET}.parm}
AQCX=${AQCX:-$EXECPREP/prepobs_prepacqc}
AQCC=${AQCC:-$PARMPREP/prepobs_prepacqc.${NET}.parm}
APFX=${APFX:-$EXECPREP/prepobs_prepacpf}
DICT=${DICT:-$DICTPREP/metar.tbl}
PQCX=${PQCX:-$EXECPREP/prepobs_profcqc}
PQCC=${PQCC:-$PARMPREP/prepobs_profcqc.${NET}.parm}
VQCX=${VQCX:-$EXECPREP/prepobs_cqcvad}
CQCX=${CQCX:-$EXECPREP/prepobs_cqcbufr}
CQCC=${CQCC:-$PARMPREP/prepobs_cqcbufr.${NET}.parm}
CQCS=${CQCS:-$FIXPREP/prepobs_cqc_statbge}
OIQCX=${OIQCX:-$EXECPREP/prepobs_oiqcbufr}
if [ "$NET" = 'cdas' ]; then
   OIQCT=${OIQCT:-$HOMEprepobs/fix/prepobs_oiqc.oberrs.cdas}
else
   OIQCT=${OIQCT:-$HOMEprepobs/fix/prepobs_oiqc.oberrs}
fi
TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"


#  See if tropical cyclone relocation previously ran for this network and cycle
#   by checking for status file in first in $tstsp, and if not found there,
#   then in $COMSP
#  ----------------------------------------------------------------------------

relo_rec=no  # this will remain no even if relocation run, in the event it did
             #  not process an tropical cyclone records
if [ -s ${tstsp}tropcy_relocation_status.$tmmark ]; then
   RELOCATION_HAS_RUN=YES
   msg="Tropical cyclone RELOCATION RAN prior to this job - \
`cat ${tstsp}tropcy_relocation_status.$tmmark`"
   [ "`cat ${tstsp}tropcy_relocation_status.$tmmark`" = "RECORDS PROCESSED" ]  \
    && relo_rec=yes
elif [ -s ${COMSP}tropcy_relocation_status.$tmmark ]; then
   RELOCATION_HAS_RUN=YES
   msg="Tropical cyclone RELOCATION RAN prior to this job - \
`cat ${COMSP}tropcy_relocation_status.$tmmark`"
   [ "`cat ${COMSP}tropcy_relocation_status.$tmmark`" = "RECORDS PROCESSED" ]  \
    && relo_rec=yes
else
   RELOCATION_HAS_RUN=NO
   msg="Tropical cyclone RELOCATION did NOT run prior to this job"
fi
[ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"

if [ -s ${COMSP}tropcy_relocation_status.$tmmark ]; then
   if [ "$SENDDBN" = "YES" ]; then
      if [ "$RUN" = 'gfs' -o "$RUN" = 'gdas' ]; then
         RUN_uc=$(echo $RUN | tr [a-z] [A-Z])
         $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_TCI $job \
             ${COMSP}tropcy_relocation_status.$tmmark
      fi
   fi
fi

if [ "$RELOCATION_HAS_RUN" != 'YES' -a "$GETGUESS" != 'NO' ]; then

   if [ $cyc = 00 -o $cyc = 06 -o $cyc = 12 -o $cyc = 18 ]; then

# The GFS and GDAS networks at 00, 06, 12 and 18z will get the t-3 and t+3
#  atmos guess files here since they are needed by the GSI even if tropical
#  cyclone relocation was not previously performed (RELOCATION_HAS_RUN=NO)
#   (NOTE 1: Normally RELOCATION_HAS_RUN=YES for these networks)
#   (NOTE 2: If RELOCATION_HAS_RUN=YES, the t-3 and t+3 atmos guess files have
#            already been obtained for all networks including the GFS and GDAS)
#   (NOTE 3: This is not done if GETGUESS is NO)
#

   if [ "$RUN" = 'gfs' -o "$RUN" = 'gdas' ]; then
      for ihr in -3 +3 ;do
         if [ "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then 
           if [ $ihr = "-3" ] ; then
              sges=sgm3prep
              stype=natgm3
              echo $sges
           else
              sges=sgp3prep
              stype=natgp3
              echo $sges
           fi
         else
           if [ $ihr = "-3" ] ; then
              sges=sgm3prep
              stype=siggm3
              echo $sges
           else
              sges=sgp3prep
              stype=siggp3
              echo $sges
           fi
         fi
         if [ ! -s $sges ]; then
            fhr=$ihr
            set +x
            echo
echo "VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV"
echo "           Tropical cylone relocation HAS NOT previously run"
echo "     Get global atmospheric GUESS valid for $fhr hrs relative to center"
echo "                     PREPBUFR processing date/time"
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
            echo
            set -x
            if [ "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then
               $GETGESprep_driver
               errges=$?
            else
               $GETGESprep -e $envir_getges -n $network_getges \
                -v $CDATE10 -t $stype $sges
               errges=$?
            fi
            if test $errges -ne 0; then
#  problem obtaining global atmospheric first guess so exit
               set +x
               echo
               echo "problem obtaining global atmos guess valid $fhr hrs \
relative to center PREPBUFR date/time;"
               echo "ABNORMAL EXIT!!!!!!!!!!!"
               echo
               set -x
               $DATA/err_exit
               exit 55  # for extra measure
            fi
            set +x
            echo
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
            echo
            set -x
         fi
      done
   fi
   fi

elif [ "$RELOCATION_HAS_RUN" = 'YES' ]; then

#  If Tropical cyclone relocation previously ran for this network and cycle
#   copy the t-3, t+0 and t+3 atmos guess files and the tcvitals_relocate file
#   from either $tstsp or, if not found there, $COMSP to working directory
#   (Note: tcvitals_relocate file can be empty, but it must exist)
#  --------------------------------------------------------------------------

   qual_last=".$tmmark"  # need this because gfs and gdas don't add $tmmark
                         #  qualifier to end of output atmos guess files
   [ $RUN = gfs -o $RUN = gdas -o $NET = cfs ]  &&  qual_last=""
   for file in sgm3prep sgesprep sgp3prep tcvitals.relocate.$tmmark; do
      case $file in
        tcvitals.relocate.$tmmark) infile=$file; qual_last="";; #  already has $tmmark at end
        sgm3prep) if [ "$NEMSIO_IN" = .true. ];then infile=atmgm3.nemsio;elif [ "$NETCDF_IN" = .true. ];then infile=atmgm3.nc;else infile=$file;fi;;
        sgesprep) if [ "$NEMSIO_IN" = .true. ];then infile=atmges.nemsio;elif [ "$NETCDF_IN" = .true. ];then infile=atmges.nc;else infile=$file;fi;;
        sgp3prep) if [ "$NEMSIO_IN" = .true. ];then infile=atmgp3.nemsio;elif [ "$NETCDF_IN" = .true. ];then infile=atmgp3.nc;else infile=$file;fi;;
      esac
      if [ -s ${tstsp}${infile}${qual_last} ]; then
         cp ${tstsp}${infile}${qual_last} $file
         continue
      elif [ -s ${COMSP}${infile}${qual_last} ]; then
         cp ${COMSP}${infile}${qual_last} $file
         continue
      else
         if [ $file = tcvitals.relocate.$tmmark ]; then
            if [ -f ${tstsp}$file ]; then
               > $file
               continue
            elif [ -f ${COMSP}$file ]; then
               > $file
               continue
            fi
         fi
      fi
#  either t-3,t+0 or t+3 atmos guess file or the tcvitals_relocate file not
#   found in expected location so exit
      set +x
      echo
      echo "$file file not found in expected location where it should have \
populated by earlier tropical cyclone relocation processing"
      echo "ABNORMAL EXIT!!!!!!!!!!!"
      echo
      set -x
      $DATA/err_exit
      exit 55  # for extra measure
   done
   cp tcvitals.relocate.$tmmark tcvitals
   if [ $relo_rec = yes ]; then  # come here if relocation ran and processed
                                 #  1 or more records, means it updated
                                 #  sgesprep
      set +x
      echo
echo "VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV"
echo "     Center PREPBUFR processing date/time is a multiple of 3-hrs"
echo "        Global atmospheric GUESS valid for  0 hrs relative to center"
echo "             PREPBUFR processing date/time was generated by"
echo "             previous tropical cyclone relocation processing"
echo "    It will be encoded into PREPBUFR file and used by q.c. programs"
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
      echo
      set -x
   else                         # come here if relocation ran but did not
                                #  process any records, means it did not update
                                #  sgesprep (sgesprep obtained via getges used)
      set +x
      echo
echo "VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV"
echo "     Center PREPBUFR processing date/time is a multiple of 3-hrs"
echo "        Global atmospheric GUESS valid for  0 hrs relative to center"
echo "         PREPBUFR processing date/time was obtained via GETGES"
echo "    It will be encoded into PREPBUFR file and used by q.c. programs"
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
      echo
      set -x
   fi

fi

###############################################################################
# POSSIBLY OBTAIN GBL ATMOS GUESS FILE(S) FOR LATER ENCODING INTO PREPBUFR FILE
###############################################################################

if [ "$PREPDATA" = 'YES' -o "$SYNDATA" = 'YES' -o "$PREVENTS" = 'YES' ]; then

   SGES=/dev/null
   SGESA=/dev/null
   > sgesprep_pathname
   > sgesprepA_pathname

   if [ "$GETGUESS" != 'NO' ]; then

#  Either ...
#    If the global background guess will be nemsio-based or NetCDF-based -OR- if
#    the global background guess will be sigio-based and the center PREPBUFR
#    processing date/time is a multiple of 3-hrs, then get a global atmospheric
#    buess valid at the center PREPBUFR processing date/time - this will be
#    interpolated to observation locations by PREPDATA and encoded into the
#    PREPBUFR file for use by the q.c. programs; if a non-zero length file sgesprep
#    exists in the working directory, then this guess is used - otherwise: the
#    GETGES utility is executed to obtain the global atmospheric guess file here
#
#    (NOTE 1: a pre-existing sgesprep file in the working directory at this
#             point was either:
#                copied there prior to the execution of this script
#                    or
#                copied there earlier in this script from either $tstsp, or if
#                  not found there, $COMSP which was populated by the previous
#                  running of tropical cyclone relocation processing
#    (NOTE 2: If imported variable GETGUESS=NO, then bypass this step - a
#             global atmos guess valid at center PREPBUFR time is not obtained)
#
#                   -- or --
#
#       (AND THIS APPLIES ONLY TO A GLOBAL SIGIO-BASED GUESS!!)
#
#    If center PREPBUFR processing date/time is not a multiple of 3-hrs -AND-
#    global guess is sigio-based, then get a global sigma guess valid at the
#    nearest cycle time prior to the center PREPBUFR processing date/time which
#    is a multiple of 3, then get a global sigma guess valid at the nearest
#    cycle time after the center PREPBUFR processing date/time which is a
#    multiple of 3 - the spectral coefficients will be linearly interpolated to
#    the center PREPBUFR processing date/time by the program PREPOBS_PREPDATA
#    and this guess will then be interpolated to observation locations (again by
#    the program PREPOBS_PREPDATA) and encoded into the PREPBUFR file for use by
#    the q.c. programs; if a non-zero length file sgesprep exists in the working
#    directory, then this guess is used for time prior to the center PREPBUFR
#    processing date/time  - otherwise: the utility ush GETGES is executed to
#    obtain the global atmos guess file here (will always be from GFS network);
#
#    likewise if a non-zero length file sgesprepA exists in the working
#    directory, then this guess is used for time after the center PREPBUFR
#    processing date/time - otherwise: the utility ush GETGES is executed to
#    obtain the global atmos guess file here (will always be from the GFS
#    network and initiate at the same time as the guess file valid prior to the
#    PREPBUFR processing date/time)
#
#    (NOTE 1: a pre-existing sgesprep file in the working directory at this
#             point was either:
#                copied there prior to the execution of this script
#                    or
#                copied there earlier in this script from either $tstsp, or if
#                  not found there, $COMSP which was populated by the previous
#                  running of tropical cyclone relocation processing
#    (NOTE 2: a pre-existing sgesprepA file in the working directory at this
#             point was copied there prior to the execution of this script -
#             it could not have been copied from either $tstsp or $COMSP
#             because previous tropical cyclone relocation processing can run
#             only when the center tropical cyclone relocation (or PREPBUFR)
#             processing date/time is a multiple of 3)
#    (NOTE 3: this case is necessary because the gblevents subroutine used to
#             add background forecast values to the prepbufr file expects sigio-
#             based files to be valid only at hours that are a multiple of 3)
#    (NOTE 4: if imported variable GETGUESS=NO, then bypass this step - a
#             global atmos guess valid at center PREPBUFR time is not obtained)
#  ----------------------------------------------------------------------

      for sfx in "" A; do
         if [ ! -s sgesprep${sfx} ]; then
            fhr=any
            if [ "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then 
               dhr=0
               stype=natges
            else
               dhr=`expr 0 - $modhr`
               stype=sigges
            fi
            if [ $modhr -eq 0 -o "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then
               [ "$sfx" = 'A' ]  &&  break
               set +x
               echo
echo "VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV"
echo "  Either center PREPBUFR processing date/time is a multiple of 3-hrs"
echo "                                -OR-"
echo "            global guess is nemsio-based or NetCDF-based"
echo "   Use GETGES to get global sigio-based, nemsio-based, or NetCDF-based"
echo "  GUESS valid for 0 hrs relative to center PREPBUFR processing date/time"
echo "     Will be encoded into PREPBUFR file and used by q.c. programs"
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
               echo
               set -x
            else
               if [ "$sfx" = 'A' ]; then
                 typeset -Z2 fhr
                 fhr=`awk -F"sf" '{print$2}' sgesprep_pathname | cut -c1-2`
                 fhr=`expr $fhr + 03`
                 dhr=`expr 3 - $modhr`
               fi
               set +x
               echo
echo "VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV"
echo "   Center PREPBUFR processing date/time is not a multiple of 3-hrs"
               if [ "$sfx" != 'A' ]; then
echo "   Get global atmos GUESS valid at the nearest cycle time prior to"
               else
echo "     Get global atmos GUESS valid at the nearest cycle time after"
               fi
echo "    center PREPBUFR processing date/time which is a multiple of 3"
echo "     Will be used to generate an interpolated guess which will be"
echo "          encoded into PREPBUFR file and used by q.c. programs"
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
               echo
               set -x
            fi
            if [ "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then
               $GETGESprep_driver
               errges=$?
            else
               $GETGESprep -e $envir_getges -n $network_getges -t $stype\
                -f $fhr -v `${NDATE} $dhr $CDATE10` > sgesprep${sfx}_pathname
               errges=$?
            fi
            if test $errges -ne 0
            then
#  problem obtaining global sigio-based, nemsio-based, or NetCDF-based guess - exit if center
#   PREPBUFR processing date/time is a multiple of 3-hrs or if global guess is
#   nemsio-based or NetCDF-based, otherwise continue running but set GETGUESS=NO meaning a
#   first guess will NOT be encoded in PREPBUFR file
               if [ $modhr -eq 0  -o "$NEMSIO_IN" = .true. -o "$NETCDF_IN" = .true. ]; then
                  if [ "$NEMSIO_IN" = .true. ]; then
                     set +x
                     echo
echo "problem obtaining global nemsio-based or NetCDF-based guess;"
                  elif [ "$NETCDF_IN" = .true. ]; then
echo "problem obtaining global netCDF-based guess;"
                  else
                     set +x
                     echo
echo "problem obtaining global sigio-based guess valid  0 hrs relative to \
center PREPBUFR date/time;"
                  fi
echo "ABNORMAL EXIT!!!!!!!!!!!"
                  echo
                  set -x
                  $DATA/err_exit
                  exit 55  # for extra measure
               else
                  set +x
                  echo
echo "problem obtaining global atmos guess valid at the nearest cycle time "
                  if [ "$sfx" != 'A' ]; then
echo "prior to center PREPBUFR processing date/time which is a multiple of 3"
                  else
echo "after center PREPBUFR processing date/time which is a multiple of 3"
                  fi
echo "will continue running but a GUESS will NOT be encoded in PREPBUFR file!!"
                  echo
                  set -x
                  msg="PROBLEM OBTAINING ONE OR BOTH SPANNING ATMOS GUESS \
FILES, GUESS NOT ENCODED IN PREPBUFR FILE  --> non-fatal"
                  [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
                  GETGUESS=NO
                  SGES=/dev/null
                  SGESA=/dev/null
                  > sgesprep
                  > sgesprepA
                  > sgesprep_pathname
                  > sgesprepA_pathname
                  break
               fi
            fi
            date
            ls -l `cat sgesprep${sfx}_pathname | awk '{ print $1 }'`
            cp `cat sgesprep${sfx}_pathname | awk '{ print $1 }'` sgesprep${sfx}
            set +x
            echo
echo "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
            echo
            set -x
         else
            if [ $RELOCATION_HAS_RUN = YES ]; then

#  If relocation ran, then ${sfx} is always "" (null) because relocation will
#   only run on center times that are a multiple of 3-hrs - come here to
#   store the pathname for the sgesprep file in sgesprep${sfx}_pathname -
#   note that it will not be stored here if relocation did not process any
#   records, i.e., it did not update the guess, because it was already stored
#   in tropcy_relocate.sh (with the getges path)
#  --------------------------------------------------------------------------

               qual_last=".$tmmark"  # need this because gfs and gdas don't add
                                     #  $tmmark qualifer to end of output atmos
                                     #  guess files
               [ $RUN = gfs -o $RUN = gdas ]  &&  qual_last=""
               if [ "$NEMSIO_IN" = .true. ]; then 
                  gesbase="atmges.nemsio"
                elif [ "$NETCDF_IN" = .true. ]; then
                  gesbase="atmges.nc"
                else
                  gesbase="sgesprep"
               fi
               if [ -s ${tstsp}${gesbase}${qual_last} ]; then
                 echo "${tstsp}${gesbase}${qual_last}" > sgesprep${sfx}_pathname
               elif [ -s ${COMSP}${gesbase}${qual_last} ]; then
                 echo "${COMSP}${gesbase}${qual_last}" > sgesprep${sfx}_pathname
               fi
            else

#  If relocation did not run, then the guess files in $DATA were copied there
#   prior to the execution of this script by the user - just echo the path
#   to this guess file in $DATA into sgesprep${sfx}_pathname
#  --------------------------------------------------------------------------

               echo "$DATA/sgesprep${sfx}" > sgesprep${sfx}_pathname
            fi
         fi
         eval SGES${sfx}=$DATA/sgesprep${sfx}
      done
   fi
fi

################################
#  EXECUTE PREPDATA PROCESSING
################################

if [ "$PREPDATA" = 'YES' ]; then

   cd $DATA 

set +u
   if [ -z "$PREPBUFR_APP" -o "$PARALLEL" = 'YES' ]; then
set -u
      if [ ! -s ${tstsp}status.${tmmark}.bufr_d -a \
           ! -s ${COMSP}status.${tmmark}.bufr_d ]; then

#########if [ \( ! -s ${tstsp}status1.${tmmark}.bufr_d -o \
#########        ! -s ${tstsp}status2.${tmmark}.bufr_d \) -a \
#########     \( ! -s ${COMSP}status1.${tmmark}.bufr_d -o \
#########        ! -s ${COMSP}status2.${tmmark}.bufr_d \) ]; then
         if [ ! -s ${tstsp}status1.${tmmark}.bufr_d -a \
              ! -s ${COMSP}status1.${tmmark}.bufr_d ]; then

#  problem: status file not found - indicates some or all data dumps were not
#           found (produced) for requested time ...
#           If highest level directory pointing to input BUFR observational
#            data dumps is /com or /com2 then EXIT (assumes all data dumps are
#            required)
#           Otherwise, just echo a diagnostic (assumes only some data dumps are
#           required)
#  ----------------------------------------------------------------------------

echo
echo "Some or all BUFR data dumps were not found for requested time ... "
echo
            set -x

            if [[ "$COMSP" == /com/* || "$COMSP" == /com2/* || "$COMSP" == /gpfs/???/nco/ops/com/* ]] &&
               [[ "$tstsp" == /tmp/null*  ]]; then
               set +x
echo
echo "ABNORMAL EXIT!!!!!!!!!!!"
echo
               set -x
               $DATA/err_exit
               exit 55  # for extra measure
            fi
         fi
      fi

      echo $BUFRLIST | grep adpsfc
      grp_adpsfc=$?
      echo $BUFRLIST | grep adpupa
      grp_adpupa=$?
      echo $BUFRLIST | grep uprair
      grp_uprair=$?
      if [ \( ! -f ${COMSP}adpsfc.${tmmark}.bufr_d -a \
              ! -f ${tstsp}adpsfc.${tmmark}.bufr_d -a $grp_adpsfc -eq 0 \) -o \
           \( ! -f ${COMSP}adpupa.${tmmark}.bufr_d -a \
              ! -f ${tstsp}adpupa.${tmmark}.bufr_d -a $grp_adpupa -eq 0 -a \
              ! -f ${COMSP}uprair.${tmmark}.bufr_d -a \
              ! -f ${tstsp}uprair.${tmmark}.bufr_d -a $grp_uprair -eq 0 \) ]
      then

#  problem: adpsfc (surface land), adpupa (raob/pibal/recco), or uprair
#           (alt raob/pibal) file, OR ALL, not found for requested time ==> EXIT
#           (unless the culprit file was not included in the $BUFRLIST)
#  ---------------------------------------------------------------------------

         set +x
echo
echo "ADPSFC and/or ADPUPA or UPRAIR BUFR data dump was not produced for requested"
echo " time (but is in BUFRLIST); ABNORMAL EXIT!!!!!!!!!!!"
echo
         set -x
         $DATA/err_exit
         exit 55  # for extra measure
      fi

   fi

   for name in ${BUFRLIST} ;do
      > $name
      if [ -f ${tstsp}${name}.${tmmark}.bufr_d ]; then
         cp ${tstsp}${name}.${tmmark}.bufr_d $name
      elif [ -s ${COMSP}${name}.${tmmark}.bufr_d ]; then
         cp ${COMSP}${name}.${tmmark}.bufr_d $name
      fi
   done

   > prep_exec.cmd

   > prepda.${cycle}


# write center (cycle) date (YYYYMMDDHH) into local file cdate10.dat
#  if minutes available write (mm) into line 2 - this file is read by program
#  PREPOBS_PREPDATA

   echo "      $CDATE10" > cdate10.dat               # YYYYMMDDHH format(6x,i10)
   [ -n "$CDATEMM" ] && echo "      $CDATEMM" >> cdate10.dat # mm format(6x,i2.2)


# If GETGUESS=YES, then either ...
#   a global sigio-based guess file valid at the center PREPBUFR processing
#   date/time which is a multiple of 3-hrs is valid at this point
#                                 -- or --
#   global sigio-based guess files valid at times which are multiples of 3-hrs
#   and span the center PREPBUFR processing date/time which is NOT a multiple of
#   3-hrs are available and valid at this point
#                                 -- or --
#   a global nemsio-based or NetCDF-based guess file valid at the center PREPBUFR
#   processing date/time for any hour is valid at this point

#  In any case, namelist "GBLEVN" with PREVEN=T is cat'ed to the beginning
#  of the PREPOBS_PREPDATA program data cards file - this means
#  PREPOBS_PREPDATA will call w3emc routine GBLEVENTS to do the "prevents"
#  processing (otherwise PREVEN=F by default)

   > prepdata.stdin
   [ "$GETGUESS" != 'NO' ] && echo " &gblevn preven=true /" >>prepdata.stdin
   cat $PRPC >> prepdata.stdin

# Check contents of *aircar_status_flag* file in $tstsp, or if not found there,
#  $COMSP path - this was generated by previous bufr_dump_obs.sh script: if it
#  exists and indicates that there were more AFWA (backup) ACARS reports than
#  ARINC (primary) ACARS reports in the AIRCAR dump, then skip processing of
#  ARINC ACARS messages in PREPOBS_PREPDATA (meaning process ONLY AFWA ACARS
#  messages); otherwise, as is usually the case, skip processing of AFWA ACARS
#  messages (meaning process only ARINC ACARS messages in PREPOBS_PREPDATA)

   echo "   SUBSKP(004,007) = TRUE," > insert
   if [ -s ${tstsp}aircar_status_flag.${tmmark}.bufr_d ]; then
      grep -q -Fe "004.007" ${tstsp}aircar_status_flag.${tmmark}.bufr_d
      err_grep=$?
      if [ $err_grep -eq 0 ]; then
         echo "   SUBSKP(004,004) = TRUE," > insert
         msg="***WARNING: Dump count for ARINC ACARS < AFWA ACARS; encode \
backup AFWA ACARS into PREPBUFR"
         [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
      fi
   elif [ -s ${COMSP}aircar_status_flag.${tmmark}.bufr_d ]; then
      grep -q -Fe "004.007" ${COMSP}aircar_status_flag.${tmmark}.bufr_d
      err_grep=$?
      if [ $err_grep -eq 0 ]; then
         echo "   SUBSKP(004,004) = TRUE," > insert
         msg="***WARNING: Dump count for ARINC ACARS < AFWA ACARS; encode \
backup AFWA ACARS into PREPBUFR"
         [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
      fi
   fi

   grep -q -Fe "`cat insert`" prepdata.stdin
   err_grep=$?
   if [ $err_grep -ne 0 ]; then
      nlines=`cat < prepdata.stdin | wc -l`
      line=`grep -n -Fe "&LDTA" prepdata.stdin | cut -f1 -d:`
      head -n $line prepdata.stdin > top_part
      mlines=`expr $nlines - $line`
      tail -n $mlines prepdata.stdin > bottom_part
      [ $mlines -gt 2 ] && cat top_part insert bottom_part > prepdata.stdin
      rm top_part bottom_part
   fi
   rm insert


##VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV##
##                          HEREFILE MP_PREPDATA                             ##
##VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV##

# think of adding a line with "#!/bin/ksh" after the "{ echo" below IG

set +x
cat <<\EOFmpp > MP_PREPDATA
#!/bin/ksh 
{ echo

# This herefile script performs the "prepdata" processing.  It is designed to
#  run in either a parallel (e.g., poe/mpi or background threads) or serial
#  environment. In the parallel environment, it first splits the input BUFR
#  data dump files into $NSPLIT equally-sized parts (analogous to dealing
#  multiple sets of cards to $NSPLIT players, where each set of cards is a
#  different BUFR data dump file). Next, in either the parallel or serial 
#  environment, it runs PREPOBS_PREPDATA to write out prepbufr files (either
#  a single complete file in the serial environment or $NSPLIT partial
#  PREPBUFR files in the parallel environment). Finally, it generates a list of
#  PREPBUFR message headers which, in the parallel environment, is needed to
#  later merge the partial PREPBUFR files together in the proper order.
#
#  IMPORTANT: This script assumes that the BUFR data dump files it is to
#             process have been copied into the $DATA directory and that each
#             file name is the same as in $BUFRLIST. It also assumes that the
#             center (cycle) date file is present in the $DATA directory and
#             that it is called cdate10.dat.  Finally, it assumes that the
#             PREPOBS_PREPDATA program data cards (parm) file is present in the
#             $DATA directory and it is called prepdata.stdin
# -----------------------------------------------------------------------------
#
# Positional parameters passed in:
#   1 - Stream index ($multi) (0 to $NSPLIT-1)
#
# Imported variables that must be passed in:
#   DATA     - path to working directory
#   PARALLEL - indicates whether or not this script is running in a parallel
#               (e.g., poe/mpi or background threads) or serial environment
#               "YES" - running in a parallel environment; "NO" running in a 
#               serial environment)
#   NSPLIT     number of parts into which the input BUFR data dump files are to
#               be evenly divided (applicable only when PARALLEL is "YES")
#   BUFRLIST - list of BUFR data dump files to process
#   MPCOPYX  - path to PREPOBS_MPCOPYBUFR program executable
#   PRPT     - path to PREPOBS_PREPDATA bufrtable file
#   LANDC    - path to land/sea mask file
#   SGES     - path to COPY OF global sigio-based, nemsio-based, or NetCDF-based
#               first guess file valid at either center PREPBUFR processing
#               date/time or, for global sigio-based guess only, nearest 3-hrly
#               cycle time prior to center PREPBUFR processing date/time
#   SGESA    - path to COPY OF global sigio-based guess file valid at nearest
#               3-hrly cycle AFTER center PREPBUFR processing date/time (if
#               needed, otherwise /dev/null). Only used if SGES is valid at
#               3-hrly cycle time PRIOR to center PREPBUFR processing date/time
#               (and thus not used if NEMSIO_IN=.true.)
#   PRVT     - path to observation error table file
#   PRPX     - path to PREPOBS_PREPDATA program executable
#   LISTHDX  - path to PREPOBS_LISTHEADERS program executable

set -aux
multi=$1

data=$DATA/multi$multi

if [ ! -d $DATA/multi$multi ] ; then
   mkdir -p $DATA/multi$multi
fi

status=$data/mstatus ; > $status 
mp_pgmout=$data/mp_pgmout  ; > $mp_pgmout 


{ echo
set +x
echo
echo "********************************************************************"
echo "This is stream (task/thread) $multi executing on node  `hostname -s`"
echo "Starting time: `date`"
echo "********************************************************************"
echo
set -x
} >> $mp_pgmout

cd $data

if [ "$PARALLEL" = 'YES' ]; then

   n=0

   pgm=`basename  $MPCOPYX`
#-----mimics prep_step-----
   set +x
   echo $pgm > pgmname
   set +u
   [ -z "$mp_pgmout" ] && echo "Variable mp_pgmout not set"
   set -u
   [ -s $DATA/break ] && paste pgmname $DATA/break >> $mp_pgmout
   rm pgmname
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
   [ -s $DATA/tracer ] && cat $DATA/tracer > errfile
   set -x
#--------------------------

   for name in ${BUFRLIST[*]} ;do
      > $name
      if [ -s $DATA/$name ] ; then
         ((n+=1))
         export FORT$((10+n))=$DATA/$name
         export FORT$((50+n))=$name
      fi
   done

   cat<<EOF|$TIMEIT $MPCOPYX >> $mp_pgmout 2>&1
 &namin nfiles=$n /
 &mp nprocs=$NSPLIT,mp_process=$multi /
EOF
   err=$?
   set +x
   echo
   echo "The foreground exit status for PREPOBS_MPCOPYBUFR is " $err
   echo
   set -x

   [ "$err" -gt '0' ]  && exit

   dump_dir=$data

else

   dump_dir=$DATA

# fi for $PARALLEL = YES
fi


pgm=`basename  $PRPX`
#-----mimics prep_step-----
set +x
echo $pgm > pgmname
set +u
[ -z "$mp_pgmout" ] && echo "Variable mp_pgmout not set"
set -u
[ -s $DATA/break ] && paste pgmname $DATA/break >> $mp_pgmout
rm pgmname
[ -f errfile ] && rm errfile
unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
[ -s $DATA/tracer ] && cat $DATA/tracer > errfile
set -x
#--------------------------

set +u
[ -n "$PREPBUFR_APP" -a "$PARALLEL" = 'NO' ] && \
 cp $PREPBUFR_APP prepda
set -u

#  Namelist "TASK" with mp_process set to the value of $multi - either the poe/
#   mpi task number (for POE not equal to "NO") or to the background thread
#   number (for BACK equal to "YES") in the parallel environment, or hardwired
#   to zero in the serial environment, is cat'ed to the beginning of the
#   PREPOBS_PREPDATA program data cards (parm) file - this will allow
#   PREPOBS_PREPDATA to identify this stream

> prepdata.stdin
echo " &task mp_process=$multi /" >>prepdata.stdin
cat $DATA/prepdata.stdin >> prepdata.stdin

BUFRLIST_all="uprair aircar aircft satwnd proflr vadwnd rassda adpupa adpsfc \
 sfcshp sfcbog msonet spssmi erscat qkswnd wdsatr ascatw rtovs atovs goesnd \
 gpsipw"
###BUFRLIST_all_array=($BUFRLIST_all) # this does not work on all platforms
set -A BUFRLIST_all_array `echo $BUFRLIST_all` # this works on all platforms


# Any dump file not included in BUFRLIST is "touched" so that it will not
#  cause a read error in the event that PREPOBS_PREPDATA still tries to read it

for name in $BUFRLIST_all;do
[ ! -f $dump_dir/$name ]  &&  > $dump_dir/$name
done

export FORT5=prepdata.stdin 
export FORT11=$DATA/cdate10.dat
export FORT12=$PRPT
export FORT15=$LANDC
##   export FORT18=$SGES
##   export FORT19=$SGESA

# The PREPOBS_PREPDATA code opens GFS spectral coefficient guess files using 
# sigio routines or GFS gaussian grid guess files using nemsio routines (via
# W3EMC routine GBLEVENTS) or NetCDF routines in a manner that may not recognize
# the FORTxx variables above.  So, the above statements setting FORTxx vars for
# $SGES and $SGESA are replaced by the soft links below.

ln -sf $SGES              fort.18
ln -sf $SGESA             fort.19
export FORT20=$PRVT
export FORT21=$dump_dir/${BUFRLIST_all_array[0]}
export FORT22=$dump_dir/${BUFRLIST_all_array[1]}
export FORT23=$dump_dir/${BUFRLIST_all_array[2]}
export FORT24=$dump_dir/${BUFRLIST_all_array[3]}
export FORT25=$dump_dir/${BUFRLIST_all_array[4]}
export FORT26=$dump_dir/${BUFRLIST_all_array[5]}
export FORT27=$dump_dir/${BUFRLIST_all_array[6]}
export FORT28=$dump_dir/${BUFRLIST_all_array[7]}
export FORT31=$dump_dir/${BUFRLIST_all_array[8]}
export FORT32=$dump_dir/${BUFRLIST_all_array[9]}
export FORT33=$dump_dir/${BUFRLIST_all_array[10]}
export FORT34=$dump_dir/${BUFRLIST_all_array[11]}
export FORT35=$dump_dir/${BUFRLIST_all_array[12]}
export FORT36=$dump_dir/${BUFRLIST_all_array[13]}
export FORT37=$dump_dir/${BUFRLIST_all_array[14]}
export FORT38=$dump_dir/${BUFRLIST_all_array[15]}
export FORT39=$dump_dir/${BUFRLIST_all_array[16]}
export FORT41=$dump_dir/${BUFRLIST_all_array[17]}
export FORT42=$dump_dir/${BUFRLIST_all_array[18]}
export FORT46=$dump_dir/${BUFRLIST_all_array[19]}
export FORT48=$dump_dir/${BUFRLIST_all_array[20]}
export FORT51=prepda
export FORT52=prevents.filtering.prepdata

#### THE BELOW APPLIED TO THE CCS (IBM AIX)  (kept for reference)
#If program ever fails, try changing 64000000 to 20000000
#set +u
#[ -n "$LOADL_PROCESSOR_LIST" ]  &&  XLSMPOPTS=parthds=2:stack=64000000
#set -u

# The following improves performance on Cray-XC40 if $PRPX was
#    linked to the IOBUF i/o buffering library
export IOBUF_PARAMS='*prevents.filtering.prepdata:verbose'

###  Concatenate UPRAIR ID file among nodes before prepdata is executed
if [ "$PARALLEL" = 'YES' ]
then
  sleep 2
  mq=0
  nq=0
  while [ $mq -lt $NSPLIT ]
  do
  if [ -s $DATA/multi$mq/fort.91 ]
  then
   nq=`expr $nq + 1`
  fi
  mq=`expr $mq + 1`
  done
  if [ $nq -eq $NSPLIT ]
  then
   cat $DATA/multi*/fort.91 | sort -k 1,1n -k 2,2n | uniq > $data/uprairids
   ln -sf $data/uprairids $data/fort.92
  else
   echo "" > $data/fort.92
  fi
else
 if [ -s $DATA/fort.91 ]
 then
  cat $DATA/fort.91 > $DATA/uprairids
  ln -sf $DATA/uprairids $DATA/fort.92
 else
  echo "" > $DATA/fort.92
 fi
fi
###

#$TIMEIT $PRPX <prepdata.stdin >>$mp_pgmout 2>&1
$TIMEIT $PRPX  >>$mp_pgmout 2>&1
errPREPDATA=$?
unset IOBUF_PARAMS
#------------------------------------------------------------------------------
if [ -n "$CDATEMM" ]; then
# This logic changes the line in prevents.filtering.prepdata listing the
#  "CENTER DATE FOR PREPBUFR FILE" to include minutes if $CDATEMM exists
#  (Note: Someday w3emc routine gblevents, the code that creates
#         prevents.filtering.prepdata, should be updated to change this, but
#         for now this was the easiest way to do it (although logic is clumsy)
# 
   grep "CENTER DATE FOR PREPBUFR FILE IS" prevents.filtering.prepdata > grepit
   cut -c1-83 grepit > grepit_cut
   echo "$CDATEMM <--" > grepit_cut_r
   paste -d":"  grepit_cut grepit_cut_r > adjline
   aline=`grep -n "CENTER DATE FOR PREPBUFR FILE IS" prevents.filtering.prepdata | cut -f1 -d:`
   nline=`cat prevents.filtering.prepdata | wc -l`
   head -n `expr $aline - 1` prevents.filtering.prepdata > top_prevents.filtering.prepdata
   tail -n `expr $nline - $aline` prevents.filtering.prepdata > bottom_prevents.filtering.prepdata
   cat top_prevents.filtering.prepdata adjline bottom_prevents.filtering.prepdata  > prevents.filtering.prepdataX
   mv prevents.filtering.prepdataX prevents.filtering.prepdata
   rm bottom_prevents.filtering.prepdata top_prevents.filtering.prepdata adjline grepit_cut_r grepit_cut grepit
fi
#------------------------------------------------------------------------------
cat prevents.filtering.prepdata >> $mp_pgmout
set +x
echo
echo "The foreground exit status for PREPOBS_PREPDATA is " $errPREPDATA
echo
set -x

[ "$errPREPDATA" -gt '4' -o "$errPREPDATA" -eq '1' ]  && exit

# Will execute PREPOBS_LISTHEADERS even if PARALLEL is "NO", because it will
#  reorder the monolithic PREPBUFR file to ensure that all messages of the same
#  subtype will always be grouped together in sequential messages, arranged in
#  the order found in $PRPT (Note: This is a necessity when PARALLEL is "YES"
#  because the later program PREPOBS_MONOPREPBUFR must merge the $NSPLIT
#  individual (partial) PREPBUFR files together in the proper order)


# Build listhdx.stdin from bufrtable entries of possible message headers first
#  line is count, followed by list

grep "| A[0-9]\{5,\} |" $PRPT | awk '{print $2}'|wc -l|tee listhdx.stdin
grep "| A[0-9]\{5,\} |" $PRPT | awk '{print $2}'|tee -a listhdx.stdin

pgm=`basename  $LISTHDX`
#-----mimics prep_step-----
set +x
echo $pgm > pgmname
set +u
[ -z "$mp_pgmout" ] && echo "Variable mp_pgmout not set"
set -u
[ -s $DATA/break ] && paste pgmname $DATA/break >> $mp_pgmout
rm pgmname
[ -f errfile ] && rm errfile
unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
[ -s $DATA/tracer ] && cat $DATA/tracer > errfile
set -x
#--------------------------

export FORT11=prepda
export FORT51=prepda.reorder
export FORT52=prepda.hdrs

$TIMEIT $LISTHDX < listhdx.stdin >>$mp_pgmout 2>&1
err=$?
cat prepda.hdrs
set +x
echo
echo "The foreground exit status for PREPOBS_LISTHEADERS is " $err
echo
set -x

[ "$err" -gt '0' ]  && exit

mv prepda.reorder prepda
rm listhdx.stdin

echo "$multi finished -- errPREPDATA = $errPREPDATA" > $status 

{ echo
set +x
echo
echo "********************************************************************"
echo "Finished executing on node  `hostname -s`"
echo "Ending time  : `date`"
echo "********************************************************************"
echo
set -x
} >> $mp_pgmout

} 1> $DATA/mp_stream${1}.stdout 2> $DATA/mp_stream${1}.errfile

exit 0
EOFmpp
set -x

##AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA##
##                       end of HEREFILE MP_PREPDATA                         ##
##AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA##

   chmod 775 MP_PREPDATA

   if [ "$PARALLEL" = 'YES' ]; then

#  In the parallel environment, either cat the multiple MP_PREPDATA tasks
#   into a poe command file (for poe/mpi/cfp) - or - set up a script that will
#   fire off each MP_PREPDATA thread as a background process
#  -----------------------------------------------------------------------
      if [ "$POE" != 'NO' ]; then
         echo "#!/bin/ksh"|tee -a $DATA/prep_exec.cmd
         multi=-1
         while [ $((multi+=1)) -lt $NSPLIT ] ; do
            echo "$DATA/MP_PREPDATA $multi "|tee -a $DATA/prep_exec.cmd
         done
         if [ "$launcher_PREP" != cfp -a "$launcher_PREP" != aprun ]; then
            # fill in empty tasks
            multi=$((multi-=1))  #need to go back one
            while [ $((multi+=1)) -lt $NPROCS ] ; do
               echo "echo do-nothing" >> $DATA/prep_exec.cmd
            done
         fi
      elif [ $BACK = 'YES' ] ; then
         multi=-1
         echo "#!/bin/ksh" > $DATA/prepthrds.sh
         while [ $((multi+=1)) -lt $NSPLIT ] ; do
            echo "$DATA/MP_PREPDATA $multi &" >> $DATA/prepthrds.sh
            echo "echo $DATA/MP_PREPDATA $multi submitted in background" \
                                                           >> $DATA/prepthrds.sh
         done
         echo "wait" >> $DATA/prepthrds.sh
         chmod 775 $DATA/prepthrds.sh
      fi

#  In the parallel environment, next either execute the poe wrapper (for poe/
#   mpi/cfp) (do not execute a time command with poe!) - or - run prepthrds.sh
#   to kick off background processes and wait for them to complete
#  --------------------------------------------------------------------------
      if [ "$POE" != 'NO' ]; then
         if [ "$launcher_PREP" = mpirun ]; then
            chmod 755 $DATA/prep_exec.cmd
            mpirun -l cfp $DATA/prep_exec.cmd
            export err=$?; $DATA/err_chk
            [ $err != 0 ] && exit 55  # for extra measure

         elif [ "$launcher_PREP" = mpiexec ]; then
	    chmod 755 $DATA/prep_exec.cmd
            #mpiexec -n 6 -ppn 32 $DATA/prep_exec.cmd #IG
            #mpiexec -n 6 $DATA/prep_exec.cmd
            $launcher_PREP -n $NSPLIT cfp $DATA/prep_exec.cmd  
	    export err=$?; $DATA/err_chk
            [ $err != 0 ] && exit 55  # for extra measure	 
         elif [ "$launcher_PREP" = mpirun.lsf ]; then
            export MP_CMDFILE=$DATA/prep_exec.cmd
            export MP_PGMMODEL=mpmd
            export MP_PULSE=0
            export MP_DEBUG_NOTIMEOUT=yes
            export MP_LABELIO=yes
            export MP_STDOUTMODE=ordered
            mpirun.lsf
            export err=$?; $DATA/err_chk
            [ $err != 0 ] && exit 55  # for extra measure
         elif [ "$launcher_PREP" = cfp ]; then
            export MP_CSS_INTERRUPT=yes
            export MP_LABELIO=yes
            export MP_STDOUTMODE=ordered
            mpirun.lsf cfp $DATA/prep_exec.cmd
            export err=$?; $DATA/err_chk
            [ $err != 0 ] && exit 55  # for extra measure
         elif [ "$launcher_PREP" = aprun ]; then
            ## Determine tasks per node (PREPDATAtpn) and
            ##    max number of concurrent procs (PREPDATAprocs) for cfp
            typeset -i nodesall=$(echo -e "${LSB_HOSTS// /\\n}"|sort -u|wc -w)
            typeset -i ncnodes=$(($nodesall-1)) # we want compute nodes only
            if [ $ncnodes -lt 1 ]; then
               set +x
               echo
               echo " ** Could not get positive compute node count for aprun **"
               echo " ** Are we using LSF queue with compute node access? **"
               echo
               echo "ABNORMAL EXIT!!!!!!!!!!!"
               echo
               set -x
               $DATA/err_exit
               exit 55  # for extra measure
            fi
            if [[ -z ${PREPDATAtpn:-""} ]]; then
               PREPDATAtpn=$((($NSPLIT+$ncnodes-1)/$ncnodes))
               # cfp is faster with extra thread so add one if there is room.
               #  (this logic needs an update to avoid hardwired 24)
               [ $PREPDATAtpn -lt 24 ] && PREPDATAtpn=$(($PREPDATAtpn+1))
            fi
            if [[ -z ${PREPDATAprocs:-""} ]]; then
              PREPDATAprocs=$(($ncnodes*$PREPDATAtpn))  # max concurrent processes
            fi
            aprun -j 1 -n${PREPDATAprocs} -N${PREPDATAtpn} -d1 cfp $DATA/prep_exec.cmd
            export err=$?; $DATA/err_chk
            [ $err != 0 ] && exit 55  # for extra measure
         else  # unknown launcher and options (eg, for use on R&D system) 
            $launcher_PREP
            export err=$?; $DATA/err_chk
            [ $err != 0 ] && exit 55  # for extra measure
         fi
      elif [ $BACK = 'YES' ] ; then
         echo 'BACK=YES' # IG Feb2024: doesn't come here
         launcher_PREP=${launcher_PREP:-mpiexec}
	 NPROCS=${NPROCS:-6}
         if [ "$launcher_PREP" = mpiexec ]; then
	   $launcher_PREP -np $NPROCS --cpu-bind verbose,core $DATA/prepthrds.sh # Keep '-np 6' > NSPLIT=4
         else
           $DATA/prepthrds.sh
         fi	 
      fi
      totalt=$NSPLIT
   else

#  In the serial environment, just fire off a single thread of MP_PREPDATA
#  -----------------------------------------------------------------------
      multi=0
      $DATA/MP_PREPDATA $multi
      totalt=1

   # fi for $PARALLEL = YES
   fi

   set +x
   multi=0
   while [ $multi -lt $totalt ]; do
echo
echo "********************************************************************"
echo "  ++  Script STDOUT from MP_PREPDATA for stream (task/thread) $multi  ++"
echo "********************************************************************"
echo
      cat $DATA/mp_stream${multi}.stdout
echo "********************************************************************"
echo "  ++  End of Script STDOUT from MP_PREPDATA for stream $multi  ++  "
echo "********************************************************************"
      multi=`expr $multi + 1`
   done

echo
echo "********************************************************************"
echo "  ++  Script trace from MP_PREPDATA for stream (task/thread) 0  ++     "
   if [ "$PARALLEL" = 'YES' ]; then
echo
echo "      In order to conserve space, the script trace from other       "
echo "         streams is not invoked unless the stream failed.           "
   fi
echo "********************************************************************"
echo

   cat mp_stream0.errfile

echo
echo "********************************************************************"
echo "  ++  End of Script trace from MP_PREPDATA for stream  0 ++  "
echo "********************************************************************"
echo
   set -x

#  check status files
#  ------------------

   errSTATUS=0
   errPREPDATA=0
   four_check=yes
   multi=0
   while [ $multi -lt $totalt ]; do
      cat $DATA/multi$multi/mp_pgmout >> prepdata.out
      cat $DATA/multi$multi/mp_pgmout >> $pgmout
      status=$DATA/multi$multi/mstatus
      if [ ! -s $status ]; then
   set +x
echo
echo "********************************************************************"
echo "                   P  R  O  B  L  E  M   !   !   !                  "
echo "********************************************************************"
echo " ###> MP_PREPDATA stream (task/thread) $multi FAILED - Cycle date: \
$CDATE10"
echo "       Current working directory: $DATA                             "
echo
echo "      Script trace from MP_PREPDATA for stream $multi follows ...   "
echo "********************************************************************"
echo
         cat $DATA/mp_stream${multi}.errfile
echo
echo "********************************************************************"
echo "  ++  End of Script trace from MP_PREPDATA for stream $multi ++ "
echo "********************************************************************"
echo
   set -x
         errSTATUS=99
      else
         err_this=`cut -f 2 -d = $status`
         ((err_this+=0))
         [ "$err_this" -gt "$errPREPDATA" ]  && errPREPDATA=$err_this
         [ "$err_this" -eq '0' ]  && four_check=no
      fi
      multi=`expr $multi + 1`
   done

   if [ "$errSTATUS" -gt '0' ]; then
      $DATA/err_exit
      exit 55  # for extra measure
   fi

   [ "$errPREPDATA" -eq '4' -a "$four_check" = 'no' ]  && errPREPDATA=0

   set +x
   echo
   echo "For all MP_PREPDATA Streams, the largest foreground exit status \
 amongst all PREPOBS_PREPDATA runs is " $errPREPDATA
   echo
   set -x

   if [ "$errPREPDATA" -le "$errPREPDATA_limit" -a $errPREPDATA -ne 1 ]; then
      err=0
      if [ "$errPREPDATA" -eq '4' ]; then
         set +x
         echo
   echo "WARNING: PREPOBS_PREPDATA FOUND EITHER NO ADPUPA, NO UPRAIR, \
OR NO ADPSFC DATA"
   echo "-------- THESE DATA WILL NOT BE AVAILABLE TO ANALYSES"
         echo
         set -x
      fi
   else
      err=$errPREPDATA
   fi

   pgm=`basename  $PRPX`
   touch errfile
   $DATA/err_chk
   [ $err != 0 ] && exit 55  # for extra measure

   if [ "$PARALLEL" = 'YES' ]; then

##VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV##
##                          HEREFILE MERGE_MSGS                              ##
##VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV##

set +x
cat <<\EOFmrg > MERGE_MSGS

# This herefile script merges the individual partial PREPBUFR files present at
#  this point into a complete, monolithic PREPBUFR file in the proper message
#  type order.  It is the last step in the PREPDATA processing.  It runs only
#  in the parallel environment.
# ----------------------------------------------------------------------------

# Positional parameters passed in:
#   1 - Number of input partial PREPBUFR files that are going to be merged
#       ($nfiles)
#   2 - Working directory path ($DATA) (contains separate partial PREPBUFR
#       files and text files containing headers for each, one directory down)
#   3 - Beginning string of sub-directories in $DATA ($subdir) (each sub-
#       directory contains an input partial PREPBUFR file and a text file
#       containing headers for all messages in that PREPBUFR file)
#   4 - File in each sub-directory containing headers for all messages in
#       partial PREPBUFR file in same sub-directory (file name only - same name
#       in all sub-directories) ($header_file_name)
#   5 - Partial PREPBUFR file in each sub-directory (file name only - same name
#       in all sub-directories) ($prep_in)
#   6 - Output monolithic PREPBUFR file name (file name only) ($prep_out)
#
# Imported variables that must be passed in:
#   MONOBFRX - path to PREPOBS_MONOPREPBUFR program executable
#
# Imported variables that can be passed in:
#   pgmout   - string indicating path to for standard output file (skipped over
#              by this script if not passed in)


if [ $# -ne 6 ] ; then
   echo "Usage: $0 nfiles DATA subdir header_file_name prep_in prep_out"
   exit 1
fi

set -aux

qid=$$

nfiles=$1;DATA=$2;subdir=$3;header_file_name=$4;prep_in=$5;prep_out=$6


#  From all the header files, extract the header counts and names build
#   namelist input to drive $MONOBFRX program
#  ---------------------------------------------------------------------

nheaders=`cat $DATA/${subdir}*/$header_file_name|awk '{print $1}'|sort -u|wc -l`
((nheaders+=0))

>$DATA/input echo  
echo " &namin nfiles=$nfiles, nheaders=$nheaders," >>$DATA/input

cd $DATA


#  Assign the fort units to the files
#  -----------------------------------

pgm=`basename  $MONOBFRX`
if [ -s $DATA/prep_step ]; then
   . $DATA/prep_step
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi


n=-1
while [ $((n+=1)) -lt $nfiles ] ;do 
   [ ! -s $DATA/${subdir}$n/$prep_in ]  &&  exit 1 
   export FORT$((11+n))=$DATA/${subdir}$n/$prep_in
done
export FORT51=$prep_out
set +x


#  Extract the total span of headers by searching through all the header files
#  ---------------------------------------------------------------------------

n=-1
while [ $((n+=1)) -lt $nfiles ]; do 
   file=$DATA/${subdir}$n/$header_file_name
   [ ! -s $file ]  &&  exit 1 
   if [ `cat $file|awk '{print $1}'| \
    sort -u|wc -l` -eq $nheaders ] ; then
      headers="" 
      nlines=`cat $file|wc -l` 
      i=0
      while [ $((i+=1)) -le $nlines ]; do
         line=`sed -n $i,${i}p $file`
         header=`echo $line|awk '{print $1}'`
         echo " cheaders($i)='$header',">>$DATA/input
         headers="$headers $header"
      done
      break
   fi
done


#  Tranlate the hdrs file contents into namelist array 
#  ---------------------------------------------------

n=-1
while [ $((n+=1)) -lt $nfiles ]; do 
   file=$DATA/${subdir}$n/$header_file_name
   line=
   i=0
   for hdr in $headers; do
      ((i+=1))
      count=`grep $hdr $file|awk '{print $2}'`
      set +u
      [ -z "$count" ]  &&  count=0
      set -u
      line="${line}msgs($i,$((n+1)))=$count," 
   done
   echo " $line " >>$DATA/input
done

echo " &end" >>$DATA/input
set -x
cat $DATA/input

$TIMEIT $MONOBFRX <$DATA/input > outout 2> errfile
export err=$?
###cat errfile
cat errfile >> outout
cat outout >> monoprepbufr.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo "The foreground exit status for PREPOBS_MONOPREPBUFR is " $err
echo
set -x
$DATA/err_chk
[ $err != 0 ] && exit 55  # for extra measure

exit 0
EOFmrg
set -x

##AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA##
##                       end of HEREFILE MERGE_MSGS                          ##
##AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA##

   chmod 775 MERGE_MSGS

#  In parallel environment, make monolithic PREPBUFR file by meriging the
#   partial PREPBUFR files
#  ----------------------------------------------------------------------
      $TIMEIT $DATA/MERGE_MSGS $NSPLIT $DATA multi prepda.hdrs prepda \
       prepda.${cycle}
      errsc=$?
      if test $errsc -ne 0
      then
#  problem with merge script
         $DATA/err_exit
         exit 55  # for extra measure
      fi
   else

#  In serial environment, already have a monolithic PREPBUFR file - just
#   copy it to expected local monolithic PREPBUFR file location
#  ---------------------------------------------------------------------
      cp $DATA/multi0/prepda prepda.${cycle}

   # fi for $PARALLEL = YES
   fi

# fi for $PREPDATA = YES
fi

set +u
[ -n "$PREPBUFR_IN" ]  &&  cp $PREPBUFR_IN $DATA/prepda.${cycle}
set -u


############################################
# EXECUTE SYNTHETIC CYCLONE DATA PROCESSING
############################################

if [ "$SYNDATA"  = 'YES' ]; then

#  Check condition code - SDM can shut-off synthetic cyclone bogusing
#  ------------------------------------------------------------------
# ==> this switch is NOT YET in place, so it will be hardwired to "YES"

###cp ???????????? syndata_cond
   echo "YES" > syndata_cond
   SYN=`cat <syndata_cond|cut -c1-3`
   set +x
   echo
   echo "SYNTHETIC CYCLONE PROCESSING = $SYN"
   echo
   set -x
   if [ "$SYN" = 'YES' ]; then

      DO_BOGUS=YES
      run_syndat_twice=no
      if [ -f ${tstsp}syndata.tcvitals.$tmmark ]; then
         cp ${tstsp}syndata.tcvitals.$tmmark tcvitals_orig
      else
         cp ${COMSPtcvital}syndata.tcvitals.$tmmark tcvitals_orig
      fi

      if [ "$RELOCATION_HAS_RUN" != 'YES' -o "$NET" = 'nam' ]; then

# If RELOCATION_HAS_RUN=NO or NET=nam, always use original tcvitals file here
#  to ensure that SYNDATA will run if there are records in the original
#  tcvitals file (for NET=nam, RELOCATION_HAS_RUN may be YES but previous
#  tropical cyclone relocation processing was only used to update the first
#  guess read in by the various PREPBUFR processing programs and it mostly like
#  would have generated a null tcvitals file which would prevent SYNDATA from
#  running)

         cp tcvitals_orig tcvitals
      else
         if [ ! -s tcvitals ]; then

#  If RELOCATION_HAS_RUN=YES, NET is not nam (currently meaning it is gfs or
#   gdas), and the tcvitals file generated by previous tropical cyclone
#   relocation processing is null (which is usually the case) -- still want
#   SYNDATA to run but to NOT append bogus reports - it WILL flag dropwinsonde
#   winds near storms (if requested) but it will NOT flag mass pressure reports
#   near storms (regardless of requested switch)
#  Use the original tcvitals file here to ensure that SYNDATA will run if there
#   is something in the original tcvitals file

            DO_BOGUS=NO
            cp tcvitals_orig tcvitals
         else

#  If RELOCATION_HAS_RUN=YES, NET is not nam (currently meaning it is gfs or
#   gdas), and the tcvitals file generated by previous tropical cyclone
#   relocation processing has at least one record in it (which is usually NOT
#   the case) -- SYNDATA will run and WILL append bogus reports for the
#   storm(s) in the relocation-generated tcvitals file - it will also FLAG
#   dropwinsonde winds and/or mass pressure reports near the storm(s) (if
#   requested)
#
# %% But, then need to see if there were any other storms in the original
#   tcvitals file - if so, will set switch to run SYNDATA a SECOND time reading
#   in tcvitals records that were in original file but not in relocation-
#   generated tcvitals file - in this case SYNDATA will NOT append bogus
#   reports but it WILL flag dropwinsonde winds near storms (if requested) and
#   it will NOT flag mass pressure reports near storms (regardless of requested
#   switch)

            sort tcvitals_orig > tcvitals_orig_sort
            sort tcvitals > tcvitals_sort
            comm -23 tcvitals_orig_sort tcvitals_sort > tcvitals_removed
            [ -s tcvitals_removed ]  &&  run_syndat_twice=yes
         fi
      fi

      $TIMEIT $USHSYND/prepobs_syndata.sh  $DATA/prepda.${cycle} \
       $DATA/tcvitals $CDATE10

      if [ $run_syndat_twice = yes ]; then

#  Run SYNDATA a second time when switch "run_syndat_twice" was set to "yes" in
#   above logic (see %% above)

         DO_BOGUS=NO
         $TIMEIT $USHSYND/prepobs_syndata.sh  $DATA/prepda.${cycle} \
          $DATA/tcvitals_removed $CDATE10
      fi
   fi
fi


######################################
# EXECUTE GLERL ADJUSTMENT PROCESSING
######################################

if [ "$GLERLBUFR" = 'YES' ]; then
    $TIMEIT $USHGLERL/prepobs_glerladj.sh $DATA/prepda.${cycle} $CDATE10
    errsc=$?
    [ "$errsc" -ne '0' ] && exit $errsc
fi

[ "$PREPDATA" = 'YES' ]  &&  cp prepda.${cycle} prepda.prepdata

###########################################
#  EXECUTE GSI QUALITY-CONTROL PROCESSING
###########################################

if [ "$DO_QC" = 'YES' ]; then
   if [ "$PREVENTS"  = 'YES' ];then
      $TIMEIT $USHPREV/prepobs_prevents.sh  $DATA/prepda.${cycle} $CDATE10
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
   fi
   if [ "$CQCBUFR"  = 'YES' ];then
      $TIMEIT $USHCQC/prepobs_cqcbufr.sh  $DATA/prepda.${cycle}
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
   fi
   if [ "$PROFCQC"  = 'YES' ];then
      $TIMEIT $USHPQC/prepobs_profcqc.sh  $DATA/prepda.${cycle}
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
   fi
   if [ "$CQCVAD"   = 'YES' ];then
      $TIMEIT $USHVQC/prepobs_cqcvad.sh   $DATA/prepda.${cycle} $CDATE10
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
   fi
   if [ "$PREPACQC" = 'YES' ];then
      $TIMEIT $USHAQC/prepobs_prepacqc.sh $DATA/prepda.${cycle} $DATA/adpsfc
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
   fi
   if [ "$OIQCBUFR" = 'YES' ];then
      $TIMEIT $USHOIQC/prepobs_oiqcbufr.sh $DATA/prepda.${cycle} $CDATE10
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
   fi
fi


# Look for "OVERLARGE" subsets in stdout (print out of bufrlib when subset
#  discarded because it is too big to fit in a BUFR message) -- post to
#  jlogfile if appropriate

msg=`grep "OVERLARGE SUBSET DISCARDED" $pgmout`
err=$?
if [ "$err" -eq '0' ]; then
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
fi

exit 0

# Create a test function for sh vs. bash detection.  The name is
# randomly generated to reduce the chances of name collision.
__ms_function_name="setup__test_function__$$"
eval "$__ms_function_name() { /bin/true ; }"

# Determine which shell we are using
__ms_ksh_test=$( eval '__text="text" ; if [[ $__text =~ ^(t).* ]] ; then printf "%s" ${.sh.match[1]} ; fi' 2> /dev/null | cat )
__ms_bash_test=$( eval 'if ( set | grep '$__ms_function_name' | grep -v name > /dev/null 2>&1 ) ; then echo t ; fi ' 2> /dev/null | cat )

if [[ ! -z "$__ms_ksh_test" ]] ; then
    __ms_shell=ksh
elif [[ ! -z "$__ms_bash_test" ]] ; then
    __ms_shell=bash
else
    # Not bash or ksh, so assume sh.
    __ms_shell=sh
fi

target=""
USERNAME=`echo $LOGNAME | awk '{ print tolower($0)'}`

if [[ -d /lfs5 ]] ; then
     # We are on NOAA Jet
    if ( ! eval module help > /dev/null 2>&1 ) ; then
        echo load the module command 1>&2
        source /apps/lmod/lmod/init/$__ms_shell
    fi
    target=jet
    module purge
elif [[ -d /scratch3/NCEPDEV ]] ; then
    # We are on NOAA Hera or Ursa
    mount=$(findmnt -n -o SOURCE /home)
    if [[ ${mount} =~ "ursa" ]]; then
      target=ursa
    else
      target=hera
    fi
    module purge
elif [[ -d /work2/noaa ]]; then
  # We are on MSU Orion or Hercules
  mount=$(findmnt -n -o SOURCE /home)
  if [[ ${mount} =~ "hercules" ]]; then
    target=hercules
  else
    target=orion
  fi
    module purge
elif [[ -d /gpfs/f5 ]]; then
  # We are on GAEAC5.
  target=gaeac5
elif [[ -d /gpfs/f6 ]]; then
  # We are on GAEAC6.
  target=gaeac6
elif [[ -d /lfs/h1 && -d /lfs/h2 ]] ; then
    target=wcoss2
    . $MODULESHOME/init/sh
elif [[ -d /opt/spack-stack ]]; then
    target=aws-ec2
elif [[ ! -z "${PW_CSP:+x}" ]]; then
   case "${PW_CSP}" in
      "aws" | "google" | "azure")
        # We are on NOAA cloud
        target=noaacloud
        ;;
      *)
        echo "WARNING: ${PW_CSP} IS UNKNOWN CSP" 1>&2
        ;;
   esac
else
    echo WARNING: UNKNOWN PLATFORM 1>&2
fi

unset __ms_shell
unset __ms_ksh_test
unset __ms_bash_test
unset $__ms_function_name
unset __ms_function_name

#!/bin/ksh 
#    mstr_shp_stn_lst_update.sh
#
#    This script copies an updated VOS ship list from
#      NDBC and merges the file with a copy of the
#      previous ship_names list
#
# History
#      Steve Lilly 02/01/2016   -  Original script
#      Dennis Keyser 02/12/2016 -  Modifications to put into production
#      Dennis Keyser 05/05/2016 -  If input archive directory .ne. output
#            archive directory and there are no files in output archive
#            directory, then if no changes to files, copy them from input
#            archive directory to output archive directory.
#            BENEFIT:  Allows checkout runs to populate $$VOSarch_OUT even when
#                      there are no file changes.
#

set -xa

cd $DATA

date

cd $DATA


#  copy input files to temporary working directory
#  -----------------------------------------------

 # current NDBC active ship list
cp $SHPNAMDIR_DCOM/activeShipLst actshplst2

 # previous (modified) NDBC active ship list
cp $VOSarch_IN/activeShiprev activeShiprev2

 # previous updated "Master Ship Station List"
cp $VOSarch_IN/ship_names ship_names3


#  initializing
#  ------------

cat actshplst2 > actshplst
cat ship_names3 > ship_names2


#  identify ship names sharing same "call_sign" in current NDBC active ship list
#  -----------------------------------------------------------------------------

cut -c 1-9 actshplst2 | uniq -d | cat > ckids


#  if ckids = 0, indicates that each ship has a unique "call_sign"
#
#  if ckids > 0, indicates that various ships are sharing a unique "call_sign",
#                these ships are removed from current NDBC active ship list
#  ----------------------------------------------------------------------------

cckids=`wc -l < ckids`

if [ $cckids -gt 0 ]; then
  grep -v -f ckids actshplst2 | cat > actshplst
fi


#  test to determine if current NDBC active ship list contains:
#    ships which are to be added,
#    ships which are to be deleted,
#      or
#    ships which are to be renamed
#  ------------------------------------------------------------

cat actshplst > actships2
cat activeShiprev2 >> actships2

#  format required to attach current NDBC active ship list file with previous
#   (modified) NDBC active ship list file (providing a list of ships requiring
#   action)

cut -c 1-9,10-65 actships2 | sort -d | uniq -u | cat > unqiships4

#  format required to attach current NDBC active ship list file with previous
#   updated "Master Ship Station List" file (providing a list of ships requiring
#   action)

cut -c 1-9,15-65 actships2 | sort -d | uniq -u | cat > actships3

#  check to see if any of the unique "call_signs" coming out of the combined
#   current NDBC active ship list file and the previous (modified) NDBC active
#   ship list file are found in the previous updated "Master Ship Station List"
#   file
#
#  ckuniq provides a count of ships that are unique
#    if ckuq = 0, there are no similar unique "call_signs" found
#    if ckuq > 0, there are similar unique "call_signs" found

cut -c 1-10 actships3 | uniq -u | cat > ckuniq
ckuq=`wc -l < ckuniq`

#  remove ships that have the same "call_sign" from previous updated "Master
#   Ship Station List" file - this prevents duplication of "call_sign" in
#   previous updated "Master Ship Station List" file 

if [ $ckuq -gt 0 ]; then
  grep -v -f ckuniq ship_names3 | cat > ship_names2
fi

#  unshpcnt provides a count of ships requiring action
#    if unshpcnt = 0, no action is required to update previous (modified) NDBC
#                     active ship list and previous updated "Master Ship
#                     Station List" files 
#    if unshpcnt > 0, action is required to update these files

unshpcnt=`wc -l < unqiships4`

if [ $unshpcnt -eq 0 ]; then
  msg="No changes to previous (modified) NDBC active ship list file or to \
previous updated \"Master Ship Station List\" file are required" 
  $DATA/postmsg "$jlogfile" "$msg"
  set +x
  echo
  echo "$msg"
  echo
  set -x

  if [ $VOSarch_IN != $VOSarch_OUT -a ! -s $VOSarch_OUT/activeShiprev -a \
                                      ! -s $VOSarch_OUT/ship_names ]; then

# ... checkout

    msg="Input and Output VOS archive locations differ, output location is \
empty -- copy Input VOS arch files to Output location -- likely checkout" 
    $DATA/postmsg "$jlogfile" "$msg"
    set +x
    echo
    echo "$msg"
    echo
    set -x
    cp $VOSarch_IN/activeShiprev $VOSarch_OUT/activeShiprev
    cp $VOSarch_IN/ship_names $VOSarch_OUT/ship_names
  fi
  msg="VOS2_DAILY PROCESSING COMPLETED NORMALLY"
  $DATA/postmsg "$jlogfile" "$msg"
  set +x
  echo
  echo "$msg"
  echo
  set -x

  exit 
fi
     
msg="Changes to previous (modified) NDBC active ship list file and to previous \
updated \"Master Ship Station List\" file ARE REQUIRED" 
$DATA/postmsg "$jlogfile" "$msg"
set +x
echo
echo "$msg"
echo
set -x

$USHprepobs/mstr_shp_stn_lst_update2.sh

msg="VOS2_DAILY PROCESSING COMPLETED NORMALLY"
$DATA/postmsg "$jlogfile" "$msg"
set +x
echo
echo "$msg"
echo
set -x

exit

#!/bin/ksh
# Run under ksh

#############################################################################
echo "----------------------------------------------------------------------"
echo "exurma_makeprepbufr.sh - URMA model prepbufr processing"
echo "----------------------------------------------------------------------"
echo "History: Aug 30 2013 - Original script."
#############################################################################

set -x

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
postmsg "$jlogfile" "$msg"

cat break > $pgmout

CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}

export COMSP=${COMSP:-$COMIN/${RUN}.${cycle}.}

cdate10=`cut -c7-16 ncepdate`

msg="CENTER TIME FOR PREPBUFR PROCESSING IS $cdate10"
postmsg "$jlogfile" "$msg"

ksh $ushscript_prep/prepobs_makeprepbufr.sh $cdate10
errsc=$?

[ "$errsc" -ne '0' ]  &&  exit $errsc

if [ "$CHGRP_RSTPROD" = 'YES' ]; then
   msg="NOTE: These files (if present) are RESTRICTED to rstprod group: \
prepbufr"
   postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi
warning=no

if [ "$PREPDATA" = 'YES' ]; then

# save snapshot of prepbufr file after PREPOBS_PREPDATA in COMOUT
   cp prepda.prepdata $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark

   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark
         warning=yes
      fi
   fi
#bsm - troubleshooting
echo "is the prepbufr file good?"
echo `ls -l $COMOUT/${RUN}.${cycle}.prepbufr.$tmmark`

# save current prepbufr mnemonic table in COMOUT if either it isn't already
#  there for a previous cycle or if it has changed from a previous cycle
   if [ ! -s $COMOUT/*prep.bufrtable ]; then
      cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable
   else
      diff `ls -t  $COMOUT/*prep.bufrtable | head -n1` prep.bufrtable \
       > /dev/null 2>&1
      errdiff=$?
      [ "$errdiff" -ne '0' ]  &&  \
       cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable
   fi
fi

if [ "$warning" = 'yes' ]; then
   msg="**WARNING: Since user $USER is not in rstprod group all RESTRICTED \
files are replaced with a null file"
   postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi

########################################################

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/bash
###########################################################################
#
# This script encodes the background (first guess) and observational
#  errors into the PREPBUFR reports (interpolated to obs. locations)
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# -------------------------------------------------------------
# Positional parameters passed in:
#
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - expected center date in PREPBUFR file (YYYYMMDDHH)
#
# Imported variables that must be passed in:
#   DATA  - path to working directory
#   NET   - string indicating system network (either "gfs", "gdas", "cdas",
#            "cdc", "nam", "ruc" or "rtma")
#            NOTE1: NET is changed to gdas in the parent Job script for the
#                   RUN=gdas1 (was gfs - NET remains gfs for RUN=gfs).
#            NOTE2: This is read from the program PREPOBS_PREVENTS via a call
#                   to system routine "GETENV".
#
#   sig1   - path to sigma 3-hr forecast valid at t-3                      
#   sig2   - path to sigma 6-hr forecast valid at t-0                      
#   sig3   - path to sigma 9-hr forecast valid at t+3                      
#
#   sfc1   - path to surface 3-hr forecast valid at t-3
#   sfc2   - path to surface 6-hr forecast valid at t-0
#   sfc3   - path to surface 9-hr forecast valid at t+3
# 
#   PRVT  - path to observation error table file
#   PREC  - path to PREPOBS_PREVENTS program parm cards
#   PREX  - path to PREPOBS_PREVENTS program executable
#
# Imported variables that can be passed in:
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)
#
###########################################################################


set -aux

qid=$$

cd $DATA
PRPI=$1; if [ ! -s $PRPI ] ; then exit 1 ;fi
CDATE10=$2

rm -f $PRPI.prevents
rm -f prevents.filtering
rm -f fort.* mpi.*

echo "      $CDATE10" > cdate10.dat

set +u
[ -z "$sig1" ] || ln -sf $sig1   fort.20
[ -z "$sig2" ] || ln -sf $sig2   fort.21 
[ -z "$sig3" ] || ln -sf $sig3   fort.22
[ -z "$sig4" ] || ln -sf $sig4   fort.23

[ -z "$sfc1" ] || ln -sf $sfc1   fort.30
[ -z "$sfc2" ] || ln -sf $sfc2   fort.31 
[ -z "$sfc3" ] || ln -sf $sfc3   fort.32
[ -z "$sfc4" ] || ln -sf $sfc4   fort.33
set -u

export FORT11=$PRPI
export FORT14=$PRVT
export FORT15=cdate10.dat
export FORT17=$HYBLEVS
export FORT51=$PRPI.prevents
export FORT52=prevents.filtering

ln -sf $FORT11 fort.11
ln -sf $FORT14 fort.14
ln -sf $FORT15 fort.15
ln -sf $FORT17 fort.17
ln -sf $FORT51 fort.51
ln -sf $FORT52 fort.52

>outout # make outout empty

$MPIRUN $PREX $PREC  ##> outout  2> errfile
err=$?

if [ -s outout ] ; then
 cat outout errfile
 cat errfile >> outout; cat outout > checkoutout
 cat outout >> prevents.out
 set +u
 [ -n "$pgmout" ]  &&  cat outout >> $pgmout
 set -u
 rm outout
fi

set +x
echo
echo 'The foreground exit status for PREPOBS_PREVENTS is ' $err
echo
set -x
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid}
      exit 555
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.prevents $PRPI
fi

exit 0

#!/bin/ksh
export PS4=' + data_check_cens.sh line $LINENO: '
set -x

#export DCOMROOT=/dcom
#export PDY=20180601
#export cyc=00
#export cmodel=cens

####################################
# Specify Timeout Behavior for TC Track calculations
# SLEEP_TIME - Amount of time to wait for a input-data file before exiting
# SLEEP_INT  - Amount of time to wait between checking for input-data file
####################################
export SLEEP_TIME=3600
export SLEEP_INT=60
SLEEP_LOOP_MAX=`expr $SLEEP_TIME / $SLEEP_INT`

if [ ${cmodel} = "cens" ]; then
#  datdir=${ccedir:-${DCOMROOT:?}/us007003/${PDY}/wgrbbul/cmcens_gb2}
#  leadhour=${FHMAX_CYCLONE:-240}
#  datfile=${PDY}${cyc}_CMC_naefs_hr_latlon0p5x0p5_P${leadhour}_020.grib2
#  datdir=/gpfs/dell2/ptmp/Jiayi.Peng/cens_data
  datdir=${ccedir:-${DCOMROOT:?}/us007003/${PDY}/wgrbbul/cmcens_gb2}

  vit_incr=${FHOUT_CYCLONE:-6}                        
  fcstlen=${FHMAX_CYCLONE:-240}                       
  fcsthrs=$(seq -f%03g -s' ' 0 $vit_incr $fcstlen)    

  mem_incr=1
  memlen=20
  member=$(seq -f%02g -s' ' 0 $mem_incr $memlen)
fi

ic=0
while [ $ic -lt $SLEEP_LOOP_MAX ]; do
  echo "Check for the existence of the files in ${datdir}"

  ic1=0
  for fhour in ${fcsthrs}; do
  for pert_num in ${member}; do

    datfile=${PDY}${cyc}_CMC_naefs_hr_latlon0p5x0p5_P${fhour}_0${pert_num}.grib2
    if [ ! -s ${datdir}/${datfile} ]; then
      set +x
      echo " "
      echo "CANADIAN ENSEMBLE file missing: ${datdir}/${datfile}"
      echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      echo " "
      set -x
      ic1=`expr $ic1 + 1`
    fi

  done
  done

  if [ $ic1 -eq 0 ]; then
    echo " !!!  $ic1 files missing in ${datdir} after waiting $ic minutes"
    break
  else
    sleep $SLEEP_INT
  fi
  ic=`expr $ic + 1`
###############################
# After we wait for 60 minutes, no data is available, Job will be quit. 
###############################
  if [ $ic -eq $SLEEP_LOOP_MAX ]; then
    msg="FATAL ERROR: $ic1 files missing in ${datdir}"
    >&2 echo "$msg"; postmsg "$jlogfile" "$msg"
    if [ "$DCOM_STATUS" = "data of opportunity" ]; then
      mail.py <<ENDMSG
      $ic1 input data files are missing, including in ${datdir}
Exiting $0...
ENDMSG
      exit 6
    else
      err_exit "data_check_cens.sh: the files in ${datdir} are missing"
    fi
  fi
done

#!/bin/bash
set -e
if [ $# -ne 1 ] ; then
	echo "Usage: $0 MM|mmm"
	exit 8
fi
nchar=`expr $1 : '.*'`
if [ $nchar -eq 2 ] ; then
	mm=`expr $1 + 0`
	case $mm in
		1)	echo "jan";;
		2)	echo "feb";;
		3)	echo "mar";;
		4)	echo "apr";;
		5)	echo "may";;
		6)	echo "jun";;
		7)	echo "jul";;
		8)	echo "aug";;
		9)	echo "sep";;
		10) echo "oct";;
		11) echo "nov";;
		12) echo "dec";;
	esac
elif [ $nchar -eq 3 ] ; then
    mm=` echo $1| tr "[A-Z]" "[a-z]" `
	case $mm in
		"jan") echo 01;;
		"feb") echo 02;;
		"mar") echo 03;;
		"apr") echo 04;;
		"may") echo 05;;
		"jun") echo 06;;
		"jul") echo 07;;
		"aug") echo 08;;
		"sep") echo 09;;
		"oct") echo 10;;
		"nov") echo 11;;
		"dec") echo 12;;
	esac
else
	echo "Usage: $0 MM|mmm"
	exit 8
fi

#!/bin/ksh
# Run under ksh

################################################################################
echo "------------------------------------------------------------------------"
echo "exrap_makeprepbufr.sh -"
echo "                Rapid Refresh Full and Partial Cycle PREPBUFR processing"
echo "------------------------------------------------------------------------"
echo "History: Mar 1 2013 - Original script."
################################################################################

set -x

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"

cat break > $pgmout

CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}

export COMSP=${COMSP:-$COMIN/${RUN}.${cycle}.}

cdate10=`cut -c7-16 ncepdate`

#  Unless an overriding value for $errPREPDATA_limit is imported, the highest
#   allowed foreground exit status for program PREPOBS_PREPDATA (where any exit
#   status higher than this is considered a failure) is dependent upon the
#   center hour (cycle) time in which it is running

if [ "$cyc" = '00' -o "$cyc" = '12' ]; then
   export errPREPDATA_limit=${errPREPDATA_limit:-0}
else
   export errPREPDATA_limit=${errPREPDATA_limit:-4}
fi

msg="CENTER TIME FOR PREPBUFR PROCESSING IS $cdate10"
$DATA/postmsg "$jlogfile" "$msg"

ksh ${ushscript_prep}/prepobs_makeprepbufr.sh $cdate10
errsc=$?

[ "$errsc" -ne '0' ]  &&  exit $errsc

if [ "$CHGRP_RSTPROD" = 'YES' ]; then
   msg="NOTE: These files (if present) are RESTRICTED to rstprod group: \
prepbufr_pre-qc, prepbufr, prepbufr.acft_profiles*, acqc_???*, \
acqc_merged*_sorted"
      $DATA/postmsg "$jlogfile" "$msg"
set +x
      echo " "
      echo "$msg"
      echo " "
set -x
fi
warning=no

if [ "$PREPDATA" = 'YES' ]; then

# save snapshot of prepbufr file after PREPOBS_PREPDATA in COMOUT
   cp prepda.prepdata ${COMOUT}/${RUN}.${cycle}.prepbufr_pre-qc.tm00

   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod ${COMOUT}/${RUN}.${cycle}.prepbufr_pre-qc.tm00
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 ${COMOUT}/${RUN}.${cycle}.prepbufr_pre-qc.tm00
      else
         cp /dev/null ${COMOUT}/${RUN}.${cycle}.prepbufr_pre-qc.tm00
         warning=yes
      fi
   fi

# save current prepbufr mnemonic table in COMOUT if either it isn't already
#  there for a previous cycle or if it has changed from a previous cycle
   if [ ! -s ${COMOUT}/*prep.bufrtable ]; then
      cp prep.bufrtable  ${COMOUT}/${RUN}.${cycle}.prep.bufrtable
   else
      diff `ls -t  ${COMOUT}/*prep.bufrtable | head -n1` prep.bufrtable \
       > /dev/null 2>&1
      errdiff=$?
      [ "$errdiff" -ne '0' ]  &&  \
       cp prep.bufrtable  ${COMOUT}/${RUN}.${cycle}.prep.bufrtable
   fi
fi

if [ "$GETGUESS" = 'YES' ]; then

# save global sigma guess file valid at center PREPBUFR date/time (encoded
#  into PREPBUFR file and used by q.c. programs) in COMOUT
   if [ -s sgesprepA ]; then
      cp sgesprep  $COMOUT/${RUN}.${cycle}.sgesprep_before.tm00
      cp sgesprepA $COMOUT/${RUN}.${cycle}.sgesprep_after.tm00
   else
      cp sgesprep $COMOUT/${RUN}.${cycle}.sgesprep.tm00
   fi

# save path name of this global sigma guess file in COMOUT
   if [ -s sgesprepA_pathname ]; then
      cp sgesprep_pathname  \
       $COMOUT/${RUN}.${cycle}.sgesprep_pathname_before.tm00
      cp sgesprepA_pathname \
       $COMOUT/${RUN}.${cycle}.sgesprep_pathname_after.tm00
   else
      cp sgesprep_pathname $COMOUT/${RUN}.${cycle}.sgesprep_pathname.tm00
   fi
fi

if [ "$DO_QC" = 'YES' ]; then

# save final form of prepbufr file in COMOUT
   cp prepda.${cycle} $COMOUT/${RUN}.${cycle}.prepbufr.tm00
   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.tm00
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.tm00
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.tm00
         warning=yes
      fi
   fi
   if [ "$SENDDBN" = 'YES' ] ; then
      $DBNROOT/bin/dbn_alert MODEL FSL_PREPBUFR $job \
       $COMOUT/${RUN}.${cycle}.prepbufr.tm00
   fi

# save prepacqc prepbufr.acft_profiles file in COMOUT
   if [ -s prepbufr.acft_profiles ]; then
      cp prepbufr.acft_profiles  \
       $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles.tm00
            warning=yes
         fi
      fi
   fi

# save prepacqc prepbufr.acft_profiles_sfc file in COMOUT
   if [ -s prepbufr.acft_profiles_sfc ]; then
      cp prepbufr.acft_profiles_sfc \
       $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
          chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.tm00
         else
            cp /dev/null \
             $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc.tm00
            warning=yes
         fi
      fi
   fi

# save prepacqc output files in COMOUT
   if [ -s acftqc_*.sus ]; then
      mv acftqc_*.sus acftqc_sus
      cp acftqc_sus $COMOUT/${RUN}.${cycle}.acqc_sus.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_sus.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_sus.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_sus.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.stk ]; then
      mv acftqc_*.stk acftqc_stk
      cp acftqc_stk $COMOUT/${RUN}.${cycle}.acqc_stk.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_stk.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_stk.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_stk.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.spk ]; then
      mv acftqc_*.spk acftqc_spk
      cp acftqc_spk $COMOUT/${RUN}.${cycle}.acqc_spk.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_spk.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_spk.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_spk.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.ord ]; then
      mv acftqc_*.ord acftqc_ord
      cp acftqc_ord $COMOUT/${RUN}.${cycle}.acqc_ord.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_ord.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_ord.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_ord.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.lst ]; then
      mv acftqc_*.lst acftqc_lst
      cp acftqc_lst $COMOUT/${RUN}.${cycle}.acqc_lst.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_lst.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_lst.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_lst.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inv ]; then
      mv acftqc_*.inv acftqc_inv
      cp acftqc_inv $COMOUT/${RUN}.${cycle}.acqc_inv.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inv.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inv.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inv.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inc ]; then
      mv acftqc_*.inc acftqc_inc
      cp acftqc_inc $COMOUT/${RUN}.${cycle}.acqc_inc.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inc.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inc.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inc.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.grc ]; then
      mv acftqc_*.grc acftqc_grc
      cp acftqc_grc $COMOUT/${RUN}.${cycle}.acqc_grc.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_grc.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_grc.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_grc.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.dup ]; then
      mv acftqc_*.dup acftqc_dup
      cp acftqc_dup $COMOUT/${RUN}.${cycle}.acqc_dup.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_dup.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_dup.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_dup.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.log ]; then
      mv acftqc_*.log acftqc_log
      cp acftqc_log $COMOUT/${RUN}.${cycle}.acqc_log.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_log.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_log.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_log.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s merged.reports.post_acftobs_qc.sorted ]; then
      cp merged.reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged_sorted.tm00
            warning=yes
         fi
      fi
   fi

   if [ -s merged.profile_reports.post_acftobs_qc.sorted ]; then
      cp merged.profile_reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.tm00
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.tm00
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.tm00
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted.tm00
            warning=yes
         fi
      fi
   fi

# save cqcbufr output files in COMOUT
   touch cqc_events
   cp cqc_events $COMOUT/${RUN}.${cycle}.cqc_events.tm00
   touch cqc_stncnt
   cp cqc_stncnt $COMOUT/${RUN}.${cycle}.cqc_stncnt.tm00
   touch cqc_stnlst
   cp cqc_stnlst $COMOUT/${RUN}.${cycle}.cqc_stnlst.tm00
   touch cqc_sdm
   cp cqc_sdm $COMOUT/${RUN}.${cycle}.cqc_sdm.tm00
   touch cqc_radcor
   cp cqc_radcor $COMOUT/${RUN}.${cycle}.cqc_radcor.tm00

# save cqcvad bird algorithm q.c. info list in COMOUT
   touch cqcvad.birdqc
   cp cqcvad.birdqc  $COMOUT/${RUN}.${cycle}.cqcvad.birdqc.tm00

fi

if [ "$warning" = 'yes' ]; then
   msg="**WARNING: Since user $USER is not in rstprod group all RESTRICTED \
files are replaced with a null file"
   $DATA/postmsg "$jlogfile" "$msg"
set +x
   echo " "
   echo "$msg"
   echo " "
set -x
fi

###############################################################

# GOOD RUN
set +x
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
set -x



# save standard output
cat break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT ##############################

#!/bin/ksh
# Run under ksh (converted to WCOSS)


# This script performs rawinsonde upper-air complex quality control checking
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# --------------------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)

# Imported variables that must be passed in:
#   DATA - path to working directory
#   CQCS - path to PREPOBS_CQCBUFR program statbge file
#   CQCX - path to PREPOBS_CQCBUFR program executable
#   CQCC - path to PREPOBS_CQCBUFR program parm cards

# Imported variables that can be passed in:
#   pgmout   - string indicating path to for standard output file
#              (skipped over by this script if not passed in)
#   PRPI_m24 - string indicating path to prepbufr file valid 24-hours previous
#              (only needed if temporal checking is being done)
#              (skipped over by this script if not passed in)
#   PRPI_m12 - string indicating path to prepbufr file valid 12-hours previous
#              (only needed if temporal checking is being done)
#              (skipped over by this script if not passed in)
#   PRPI_p12 - string indicating path to prepbufr file valid 12-hours ahead
#              (only needed if temporal checking is being done)
#              (skipped over by this script if not passed in)
#   PRPI_p24 - string indicating path to prepbufr file valid 24-hours ahead
#              (only needed if temporal checking is being done)
#              (skipped over by this script if not passed in)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1 ;fi

cp /dev/null $DATA/prepbufr_m24
cp /dev/null $DATA/prepbufr_m12
cp /dev/null $DATA/prepbufr_p12
cp /dev/null $DATA/prepbufr_p24

set +u
[ -n "$PRPI_m24" ]  && cp $PRPI_m24 prepbufr_m24
[ -n "$PRPI_m12" ]  && cp $PRPI_m12 prepbufr_m12
[ -n "$PRPI_p12" ]  && cp $PRPI_p12 prepbufr_p12
[ -n "$PRPI_p24" ]  && cp $PRPI_p24 prepbufr_p24
set -u

rm $PRPI.cqcbufr
rm cqc_events cqc_stncnt cqc_stnlst

pgm=`basename  $CQCX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

export FORT4=cqcbufr.unit04.wrk
export FORT12=cqc_events
export FORT14=$PRPI
export FORT15=cqc_stncnt
export FORT16=cqc_stnlst
export FORT17=prepbufr_m24
export FORT18=prepbufr_m12
export FORT19=prepbufr_p12
export FORT20=prepbufr_p24
export FORT22=cqc_wndpbm
export FORT23=$CQCS
export FORT51=$PRPI.cqcbufr
export FORT52=cqc_sdm
export FORT60=cqcbufr.unit60.wrk
export FORT61=cqcbufr.unit61.wrk
export FORT62=cqcbufr.unit62.wrk
export FORT64=cqcbufr.unit64.wrk
export FORT68=cqc_radcor
export FORT80=cqcbufr.unit80.wrk
TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
# The following improves performance on Cray-XC40 if $CQCX was
#    linked to the IOBUF i/o buffering library
export IOBUF_PARAMS='*wrk:verbose,*cqc_*:verbose'
$TIMEIT $CQCX< $CQCC > outout 2> errfile
err=$?
unset IOBUF_PARAMS
###cat errfile
cat errfile >> outout
cat outout >> cqcbufr.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for PREPOBS_CQCBUFR is ' $err
echo
set -x
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.cqcbufr $PRPI
fi

exit 0

#!/bin/ksh
# Run under ksh

###########################################################################
echo "--------------------------------------------------------------------"
echo "excdas_makeprepbufr.sh - CDAS model prepbufr processing         "
echo "--------------------------------------------------------------------"
echo "History: Dec  3 2014 - Original script, split off from              "
echo "                       exglobal_makeprepbufr.sh.ecf and tailored    "
echo "                       exclusively to CDAS.                         "
echo "         Aug 18 2017 - Use variable $RUN instead of $model to define"
echo "                       input directories.                           "
###########################################################################

set -x

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"

cat break > $pgmout

CHGRP_RSTPROD=${CHGRP_RSTPROD:-YES}

export COMSP=${COMSP:-$COMIN/${RUN}.${cycle}.}


if [ "$DO_QC" = 'YES' -a "$CQCBUFR" = 'YES' -a -n "$COM_IN" -a -n "$CQCC" ];then

# If running PREPOBS_CQCBUFR, must check its data cards to see if
#  namelist switch DOTMP is TRUE - if so, must get prepbufr_pre-qc files
#   from t-24, t-12, t+12, t+24 to feed into PREPOBS_CQCBUFR

   DOTMP=`grep DOTMP $CQCC | awk -F, \
    '{print $1; print $2; print $3; print $4; print$5}' | grep DOTMP | \
    awk -F= '{print $2}'`

   if [[ $DOTMP = *T* ]]; then
      [ -s ${COM_IN}/${RUN}.${PDYm1}/${RUN}.${cycle}.prepbufr_pre-qc ] && \
       export PRPI_m24=\
${COM_IN}/${RUN}.${PDYm1}/${RUN}.${cycle}.prepbufr_pre-qc
      [ -s ${COM_IN}/${RUN}.${PDYp1}/${RUN}.${cycle}.prepbufr_pre-qc ] && \
       export PRPI_p24=\
${COM_IN}/${RUN}.${PDYp1}/${RUN}.${cycle}.prepbufr_pre-qc
      tdate10=`$NDATE -12 $PDY$cyc`
      cyc_m12=`echo $tdate10|cut -c9-10`
      pdy_m12=`echo $tdate10|cut -c1-8`
      [ -s ${COM_IN}/${RUN}.${pdy_m12}/${RUN}.t${cyc_m12}z.prepbufr_pre-qc ] \
       && export PRPI_m12=\
${COM_IN}/${RUN}.${pdy_m12}/${RUN}.t${cyc_m12}z.prepbufr_pre-qc
      tdate10=`$NDATE +12 $PDY$cyc`
      cyc_p12=`echo $tdate10|cut -c9-10`
      pdy_p12=`echo $tdate10|cut -c1-8`
      [ -s ${COM_IN}/${RUN}.${pdy_p12}/${RUN}.t${cyc_p12}z.prepbufr_pre-qc ] \
       && export PRPI_p12=\
${COM_IN}/${RUN}.${pdy_p12}/${RUN}.t${cyc_p12}z.prepbufr_pre-qc
   fi
fi

cdate10=`cut -c7-16 ncepdate`

msg="CENTER TIME FOR PREPBUFR PROCESSING IS $cdate10"
$DATA/postmsg "$jlogfile" "$msg"

ksh $ushscript_prep/prepobs_makeprepbufr.sh $cdate10
errsc=$?

[ "$errsc" -ne '0' ]  &&  exit $errsc

if [ "$CHGRP_RSTPROD" = 'YES' ]; then
   msg="NOTE: These files (if present) are RESTRICTED to rstprod group: \
prepbufr_pre-qc, prepbufr, prepbufr.acft_profiles*, acqc_???*, \
acqc_merged*_sorted, tosslist, prepbufr.unblok"
   $DATA/postmsg "$jlogfile" "$msg"
set +x
   echo
   echo "$msg"
   echo
set -x
fi
warning=no

if [ "$PREPDATA" = 'YES' ]; then

# save snapshot of prepbufr file after PREPOBS_PREPDATA in COMOUT
   cp prepda.prepdata $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
   chmod 664 $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc

   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr_pre-qc
         warning=yes
      fi
   fi

# save current prepbufr mnemonic table in COMOUT if either it isn't already
#  there for a previous cycle or if it has changed from a previous cycle
   if [ ! -s $COMOUT/*prep.bufrtable ]; then
      cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable
   else
      diff `ls -t  $COMOUT/*prep.bufrtable | head -n1` prep.bufrtable \
       > /dev/null 2>&1
      errdiff=$?
      [ "$errdiff" -ne '0' ]  &&  \
       cp prep.bufrtable  $COMOUT/${RUN}.${cycle}.prep.bufrtable
   fi
fi

# NOTE: Tropical cyclone relocation processing currently does not run in the
#       CDAS network.  This logic is copied from exglobal_makeprepbufr.sh.ecf
#       in case it ever does.
# ---------------------------------------------------------------------------
# save global sigma guess file(s) in COMOUT if they haven't already been saved
#  here by previous tropical cyclone relocation processing
[ -s sgm3prep -a ! -s $COMOUT/${RUN}.${cycle}.sgm3prep ]  &&  \
 cp sgm3prep $COMOUT/${RUN}.${cycle}.sgm3prep
[ -s sgp3prep -a ! -s $COMOUT/${RUN}.${cycle}.sgp3prep ]  &&  \
 cp sgp3prep $COMOUT/${RUN}.${cycle}.sgp3prep
if [ -s sgesprep ]; then
   if [ -s sgesprepA ]; then
      cp sgesprep  $COMOUT/${RUN}.${cycle}.sgesprep_before
      cp sgesprepA $COMOUT/${RUN}.${cycle}.sgesprep_after
   else
      [ ! -s $COMOUT/${RUN}.${cycle}.sgesprep ]  &&  \
       cp sgesprep $COMOUT/${RUN}.${cycle}.sgesprep
   fi

# save path name of global sigma guess file valid at center PREPBUFR
#  date/time (encoded into PREPBUFR file and used by q.c. programs) in COMOUT
   if [ "$GETGUESS" = 'YES' ]; then
      if [ -s sgesprepA_pathname ]; then
         cp sgesprep_pathname \
          $COMOUT/${RUN}.${cycle}.sgesprep_pathname_before.$tmmark
         cp sgesprepA_pathname \
          $COMOUT/${RUN}.${cycle}.sgesprep_pathname_after.$tmmark
      else

#   if the target file already exists, it was created in previous
#    tropcy_relocate.sh script because either there was an error or no
#    tcvitals were present - in this case the target file points to the orig.
#    getges global sigma guess (since the guess was not modified by relocation)
#    - otherwise sgesprep_pathname will either contain either the path to the
#      getges guess (if tropical cyclone relocation did not run previously) or
#      it will contain the path to the modified sgesprep guess (if tropical
#      cyclone relocation did run previously and did modify the guess)
#   ---------------------------------------------------------------------------

         [ ! -s $COMOUT/${RUN}.${cycle}.sgesprep_pathname.$tmmark ]  &&  \
         cp sgesprep_pathname $COMOUT/${RUN}.${cycle}.sgesprep_pathname.$tmmark
      fi
   fi
fi

# save synthetic bogus files in COMOUT (currently does not run in CDAS network)
[ -s bogrept ]  &&  cp bogrept  $COMOUT/${RUN}.${cycle}.syndata.bogrept
[ -s bogdata ]  &&  cp bogdata  $COMOUT/${RUN}.${cycle}.syndata.bogdata
[ -s dthistry ] &&  cp dthistry $COMOUT/${RUN}.${cycle}.syndata.dthistry

if [ "$DO_QC" = 'YES' ]; then

# save final form of prepbufr file in COMOUT
   cp prepda.${cycle} $COMOUT/${RUN}.${cycle}.prepbufr
   chmod 664 $COMOUT/${RUN}.${cycle}.prepbufr
   if [ "$CHGRP_RSTPROD" = 'YES' ]; then
      chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr
      errch=$?
      if [ $errch -eq 0 ]; then
         chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr
      else
         cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr
         warning=yes
      fi
   fi

# save prepacqc prepbufr.acft_profiles file in COMOUT
   if [ -s prepbufr.acft_profiles ]; then
      cp prepbufr.acft_profiles  $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles
            warning=yes
         fi
      fi
   fi

# save prepacqc prepbufr.acft_profiles_sfc file in COMOUT
   if [ -s prepbufr.acft_profiles_sfc ]; then
      cp prepbufr.acft_profiles_sfc  \
       $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.acft_profiles_sfc
            warning=yes
         fi
      fi
   fi

# save prepacqc output files in COMOUT
   if [ -s acftqc_*.sus ]; then
      mv acftqc_*.sus acftqc_sus
      cp acftqc_sus $COMOUT/${RUN}.${cycle}.acqc_sus
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_sus
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_sus
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_sus
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.stk ]; then
      mv acftqc_*.stk acftqc_stk
      cp acftqc_stk $COMOUT/${RUN}.${cycle}.acqc_stk
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_stk
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_stk
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_stk
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.spk ]; then
      mv acftqc_*.spk acftqc_spk
      cp acftqc_spk $COMOUT/${RUN}.${cycle}.acqc_spk
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_spk
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_spk
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_spk
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.ord ]; then
      mv acftqc_*.ord acftqc_ord
      cp acftqc_ord $COMOUT/${RUN}.${cycle}.acqc_ord
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_ord
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_ord
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_ord
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.lst ]; then
      mv acftqc_*.lst acftqc_lst
      cp acftqc_lst $COMOUT/${RUN}.${cycle}.acqc_lst
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_lst
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_lst
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_lst
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inv ]; then
      mv acftqc_*.inv acftqc_inv
      cp acftqc_inv $COMOUT/${RUN}.${cycle}.acqc_inv
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inv
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inv
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inv
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.inc ]; then
      mv acftqc_*.inc acftqc_inc
      cp acftqc_inc $COMOUT/${RUN}.${cycle}.acqc_inc
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_inc
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_inc
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_inc
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.grc ]; then
      mv acftqc_*.grc acftqc_grc
      cp acftqc_grc $COMOUT/${RUN}.${cycle}.acqc_grc
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_grc
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_grc
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_grc
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.dup ]; then
      mv acftqc_*.dup acftqc_dup
      cp acftqc_dup $COMOUT/${RUN}.${cycle}.acqc_dup
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_dup
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_dup
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_dup
            warning=yes
         fi
      fi
   fi

   if [ -s acftqc_*.log ]; then
      mv acftqc_*.log acftqc_log
      cp acftqc_log $COMOUT/${RUN}.${cycle}.acqc_log
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_log
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_log
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_log
            warning=yes
         fi
      fi
   fi

   if [ -s merged.reports.post_acftobs_qc.sorted ]; then
      cp merged.reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged_sorted
            warning=yes
         fi
      fi
   fi

   if [ -s merged.profile_reports.post_acftobs_qc.sorted ]; then
      cp merged.profile_reports.post_acftobs_qc.sorted \
       $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.acqc_merged.prof_sorted
            warning=yes
         fi
      fi
   fi

# save cqcbufr output files in COMOUT
   touch cqc_events
   cp cqc_events $COMOUT/${RUN}.${cycle}.cqc_events
   touch cqc_stncnt
   cp cqc_stncnt $COMOUT/${RUN}.${cycle}.cqc_stncnt
   touch cqc_stnlst
   cp cqc_stnlst $COMOUT/${RUN}.${cycle}.cqc_stnlst
   touch cqc_sdm
   cp cqc_sdm $COMOUT/${RUN}.${cycle}.cqc_sdm
   touch cqc_radcor
   cp cqc_radcor $COMOUT/${RUN}.${cycle}.cqc_radcor

# save oiqc tosslist in COMOUT (if it runs)
   if [ -s tosslist ]; then
      cp tosslist  $COMOUT/${RUN}.${cycle}.tosslist
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.tosslist
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.tosslist
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.tosslist
            warning=yes
         fi
      fi
   fi

# make unblocked prepbufr file
# ---> ON WCOSS prepbufr is already unblocked, so for now just copy it to the
#      unblok file location used before on CCS - hopefully this can be removed
#      someday!
   cp -p  prepda.${cycle} prepda.${cycle}.unblok
   err_cp=$?
   if [ $err_cp -eq 0 ]; then
      cp prepda.${cycle}.unblok $COMOUT/${RUN}.${cycle}.prepbufr.unblok
      chmod 664 $COMOUT/${RUN}.${cycle}.prepbufr.unblok
      if [ "$CHGRP_RSTPROD" = 'YES' ]; then
         chgrp rstprod $COMOUT/${RUN}.${cycle}.prepbufr.unblok
         errch=$?
         if [ $errch -eq 0 ]; then
            chmod 640 $COMOUT/${RUN}.${cycle}.prepbufr.unblok
         else
            cp /dev/null $COMOUT/${RUN}.${cycle}.prepbufr.unblok
            warning=yes
         fi
      fi
   fi

fi

if [ "$warning" = 'yes' ]; then
   msg="**WARNING: Since user $USER is not in rstprod group all RESTRICTED \
files are replaced with a null file"
   $DATA/postmsg "$jlogfile" "$msg"
set +x
   echo
   echo "$msg"
   echo
set -x
fi

if [ "$SENDCOM" = 'YES' -a "$COPY_TO_ARKV" = 'YES' ]; then

#=====================================================================
#=====================================================================
#  Copy PREP files to arkv directory, preserving ownership & group id
#   but updating timestamp
#=====================================================================
#=====================================================================

   msg="Copy PREP files to $COMARC"
   $DATA/postmsg "$jlogfile" "$msg"

   if [ $JOB_NUMBER -eq 1 ]; then
      cp --preserve=mode,ownership \
       $COMOUT/cdas.${cycle}.prepbufr_pre-qc ${COMARC}/prepbufr${PDY}${cyc}
######cp --preserve=mode,ownership $LSB_OUTPUTFILE \
###### ${COMARC}/prep1${PDY}${cyc}.out # moved down in script to include stdout
   elif [ $JOB_NUMBER -eq 2 ]; then
      [ -s cqc_events ] && cp --preserve=mode,ownership cqc_events \
       ${COMARC}/cqc_events.${PDY}${cyc}
      [ -s cqc_stncnt ] && cp --preserve=mode,ownership cqc_stncnt \
       ${COMARC}/cqc_stncnt.${PDY}${cyc}
      [ -s cqc_stnlst ] && cp --preserve=mode,ownership cqc_stnlst \
       ${COMARC}/cqc_stnlst.${PDY}${cyc}
      [ -s cqc_wndpbm ] && cp --preserve=mode,ownership cqc_wndpbm \
       ${COMARC}/cqc_wndpbm.${PDY}${cyc}
      [ -s tosslist ] && cp --preserve=mode,ownership tosslist \
       ${COMARC}/tosscat${PDY}${cyc}
######cp --preserve=mode,ownership $LSB_OUTPUTFILE \
###### ${COMARC}/prep2${PDY}${cyc}.out # moved down in script to include stdout
   fi
fi

########################################################

# GOOD RUN
set +x
echo
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo
set -x


# save standard output
cat break $pgmout break > allout
cat allout
# rm allout


if [ "$SENDCOM" = 'YES' -a "$COPY_TO_ARKV" = 'YES' ]; then

#===========================================================================
#===========================================================================
#  Must wait until here to copy "dayfiles" to arkv directory so that stdout
#   is included (preserve ownership & group id but update timestamp)
#===========================================================================
#===========================================================================

   msg="Copy dayfile to $COMARC"
   $DATA/postmsg "$jlogfile" "$msg"

   if [ $JOB_NUMBER -eq 1 ]; then
      cp --preserve=mode,ownership $LSB_OUTPUTFILE ${COMARC}/prep1${PDY}${cyc}.out
   elif [ $JOB_NUMBER -eq 2 ]; then
      cp --preserve=mode,ownership $LSB_OUTPUTFILE ${COMARC}/prep2${PDY}${cyc}.out
   fi
fi

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################

#!/bin/ksh
export PS4=' + exwsr_ecmwfens.sh line $LINENO: '

####################################################################
set +xa
echo "------------------------------------------------"
echo "JECMFENSH - ECMWF HR ensemble postprocessing"
echo "------------------------------------------------"
echo "History: JAN 2001 - ECMWF ensemble conversion job based on "
echo "                    Tim Marchok's Cray job by Richard Wobus "
echo "         FEB 2001 - correct headers on statistics, add rh700"
echo "         SEP 2004 - high resolution version"
echo "         May 2011 - modified by J.Peng based on ECMWF data input"
set -xa
#####################################################################

###########################################################
# Processing/Flow of script
# 1) Copy this job's input files to the working directory
# 2) Extract variables to be processed from input files
# 3) Convert ensemble header extensions and make statistics
# 4) Append results to output files
# 5) Save output files to $COMOUT
# 6) Remove files located in this job's working directory
###########################################################
export DATA=$1
export hourinc=$2

cd $DATA

msg="HAS BEGUN on `hostname`"
postmsg "$jlogfile" "$msg"

#####################################################################
# Set names of executable utilities
#####################################################################

wgribx="${WGRIB:?} -ncep_opn"

#########################################################
# !!! DEFINE MAXIMUM NUMBER OF PERTURBATION RECORDS
# (This number does NOT include the LRC or HRC)
#########################################################

maxmem=50

#####################################################################
# Set date variables to process yesterday's data
#####################################################################
cent=`echo $PDY | cut -c1-2 `
yy=`  echo $PDY | cut -c3-4 `
mm=`  echo $PDY | cut -c5-6 `
dd=`  echo $PDY | cut -c7-8 `

ymdh=${PDY}${cyc}
imdh=${mm}${dd}${cyc}
echo " Date to copy is $PDY"

prev_cycle=t${cyc}z

#export INDATA=/dcom/us007003/${PDY}/wgrbbul/ecmwf
export INDATA=${eensdcom}
#####################################################################
#
#   Now process all the records into the forecast output files.
#
#####################################################################

echo " "
echo "*----------------------------------------------------------*"
echo "        NOW COPYING RECORDS TO FORECAST FILES...."
echo "*----------------------------------------------------------*"
echo "The time just before copying begins is: `date`"

#hourix=0

#---J.Peng----2010-12-13--------------------------------------
#while [ ${hourix} -lt 21 ];
#while [ ${hourix} -lt 41 ];
#do

#  let hourinc=hourix*12
#  let hourinc=hourix*6
  vymdh=` ${NDATE:?} ${hourinc} ${ymdh}`
  vmdh=`  echo ${vymdh} | cut -c5-10`
  vhour=` ${NHOUR:?} ${vymdh} ${ymdh}`

  echo `date` begin "vmdh = $vmdh"

  # Construct the ECMWF file name.
  # Each file name contains the initial time and
  # the time at which the forecast is valid.

  #ifil=ecens_DCE${imdh}00${vmdh}001
  ifil=DCE${imdh}00${vmdh}001

#---J.Peng----2010-12-13--------------------------------------
#  ifile=${dcom}/$PDY/wgrbbul/$ifil
  ifile=${INDATA}/$ifil
  echo "ifile = $ifile"

  let attempts=1
  while [ $attempts -le 30 ]; do
     if [ -s $ifile ]; then
        break
     else
        sleep 60
        let attempts=attempts+1
     fi
  done
  if [ $attempts -gt 30 ] && [ ! -s $ifile ]; then
     set +x; echo " "
     echo "FATAL ERROR:  $ifile still not available after waiting 30 minutes... exiting"
     echo " "; set -x
     err_exit
  fi

  # Copy the file from dcom
  cpreq $ifile $ifil

  # The reason we need to use that Fortran program is we need to change
  # the GRIB file from ECMWF GRIB format to NCEP GRIB format.
  $wgribx -s $ifil -d all -grib -o eccut.${ymdh}.f${vhour}

  echo " "
  echo "*---------------------------------------------------*"
  echo "  Now in forecast part for ftime= ${hourinc}"
  echo "*---------------------------------------------------*"
  echo " "

  resflag=2

  echo "FORECAST: ftype= DCE, ftime= $hourinc"
#------J.Peng----2010-12-13-----------------------------------
  export pgm=wsr_ecmwfensh
  . prep_step

  export XLFUNIT_11="eccut.${ymdh}.f${vhour}"
  ${GRBINDEX:?} $XLFUNIT_11 eccut.${ymdh}.f${vhour}.i
  export XLFUNIT_21="eccut.${ymdh}.f${vhour}.i"

  export XLFUNIT_51="tmpt200"
  export XLFUNIT_151="tmpt200stat"
  export XLFUNIT_52="tmpt500"
  export XLFUNIT_152="tmpt500stat"
  export XLFUNIT_53="tmpt700"
  export XLFUNIT_153="tmpt700stat"
  export XLFUNIT_54="tmpt850"
  export XLFUNIT_154="tmpt850stat"
  export XLFUNIT_55="tmpt2m"
  export XLFUNIT_155="tmpt2mstat"
  export XLFUNIT_56="tmpt2max"
  export XLFUNIT_156="tmpt2maxstat"
  export XLFUNIT_57="tmpt2min"
  export XLFUNIT_157="tmpt2minstat"
  export XLFUNIT_58="tmptd2m"
  export XLFUNIT_158="tmptd2mstat"

  export XLFUNIT_61="tmpz200"
  export XLFUNIT_161="tmpz200stat"
  export XLFUNIT_62="tmpz500"
  export XLFUNIT_162="tmpz500stat"
  export XLFUNIT_63="tmpz700"
  export XLFUNIT_163="tmpz700stat"
  export XLFUNIT_64="tmpz850"
  export XLFUNIT_164="tmpz850stat"
  export XLFUNIT_65="tmpz1000"
  export XLFUNIT_165="tmpz1000stat"

  export XLFUNIT_71="tmprh500"
  export XLFUNIT_171="tmprh500stat"
  export XLFUNIT_72="tmprh700"
  export XLFUNIT_172="tmprh700stat"
  export XLFUNIT_73="tmprh850"
  export XLFUNIT_173="tmprh850stat"

  export XLFUNIT_81="tmpmslp"
  export XLFUNIT_181="tmpmslpstat"
  export XLFUNIT_82="tmppsfc"
  export XLFUNIT_182="tmppsfcstat"
  export XLFUNIT_83="tmpprcp"
  export XLFUNIT_183="tmpprcpstat"
  export XLFUNIT_84="tmptcdc"
  export XLFUNIT_184="tmptcdcstat"

  export XLFUNIT_101="tmpu200"
  export XLFUNIT_102="tmpv200"
  export XLFUNIT_103="tmpu500"
  export XLFUNIT_104="tmpv500"
  export XLFUNIT_105="tmpu700"
  export XLFUNIT_106="tmpv700"
  export XLFUNIT_107="tmpu850"
  export XLFUNIT_108="tmpv850"
  export XLFUNIT_109="tmpu10m"
  export XLFUNIT_110="tmpv10m"

  echo " &namin"                                      >input1
  echo "    kres=${resflag},kmaxmem=${maxmem}"       >>input1
  echo " /"                                          >>input1

  if [ -s eccut.${ymdh}.f${vhour} ]
  then
    set +x
    echo "File ${ifil} is copied/wgribbed as eccut.${ymdh}.f${vhour}"
    echo "Now converting format..."
    set -x

    export pgm=wsr_ecmwfensh
    msg="$pgm start for eens_grib1 at ${ymdh}_${vhour}"
    postmsg "$jlogfile" "$msg"
    . prep_step
    startmsg
    ${EXECecme}/wsr_ecmwfensh <input1 >ec.DCE.f${vhour} >> $pgmout 2> errfile
    ecmwfrcc=$?

    if [ ${ecmwfrcc} -eq 0 ]; then
      msg="$pgm end for eens_grib1 at ${ymdh}_${vhour} completed normally"
      postmsg "$jlogfile" "$msg"
    else
      set +x
      echo " "
      echo "FATAL ERROR:  An error occurred while running wsr_ecmwfensh "
      echo "!!! which is the program for ECgrib1-NCEPgrib1             "
      echo "!!! Return code from wsr_ecmwfensh = ${ecmwfrcc} "
      echo "!!! Exiting...at ${ymdh}_${vhour}"
      echo " "
      set -x
      err_exit "FAILED ${jobid} - ERROR RUNNING wsr_ecmwfensh - ABNORMAL EXIT"
    fi

#    if [[ -s tmpt200 ]]; then
#      cat tmpt200      >>ensposte.$prev_cycle.t200hr
#      cat tmpt200stat  >>ensstate.$prev_cycle.t200hr
#    fi
#    if [[ -s tmpt500 ]]; then
#      cat tmpt500      >>ensposte.$prev_cycle.t500hr
#      cat tmpt500stat  >>ensstate.$prev_cycle.t500hr
#    fi
#    if [[ -s tmpt700 ]]; then
#      cat tmpt700      >>ensposte.$prev_cycle.t700hr
#      cat tmpt700stat  >>ensstate.$prev_cycle.t700hr
#    fi
#    if [[ -s tmpt850 ]]; then
#      cat tmpt850      >>ensposte.$prev_cycle.t850hr
#      cat tmpt850stat  >>ensstate.$prev_cycle.t850hr
#    fi
#    if [[ -s tmpt2m ]]; then
#      cat tmpt2m       >>ensposte.$prev_cycle.t2mhr
#      cat tmpt2mstat   >>ensstate.$prev_cycle.t2mhr
#    fi
#    if [[ -s tmpt2max ]]; then
#      cat tmpt2max       >>ensposte.$prev_cycle.t2maxhr
#      cat tmpt2maxstat   >>ensstate.$prev_cycle.t2maxhr
#    fi
#    if [[ -s tmpt2min ]]; then
#      cat tmpt2min       >>ensposte.$prev_cycle.t2minhr
#      cat tmpt2minstat   >>ensstate.$prev_cycle.t2minhr
#    fi
#    if [[ -s tmptd2m ]]; then
#      cat tmptd2m       >>ensposte.$prev_cycle.td2mhr
#      cat tmptd2mstat   >>ensstate.$prev_cycle.td2mhr
#    fi

#    if [[ -s tmpz200 ]]; then
#      cat tmpz200      >>ensposte.$prev_cycle.z200hr
#      cat tmpz200stat  >>ensstate.$prev_cycle.z200hr
#    fi
#    if [[ -s tmpz500 ]]; then
#      cat tmpz500      >>ensposte.$prev_cycle.z500hr
#      cat tmpz500stat  >>ensstate.$prev_cycle.z500hr
#    fi
#    if [[ -s tmpz700 ]]; then
#      cat tmpz700      >>ensposte.$prev_cycle.z700hr
#      cat tmpz700stat  >>ensstate.$prev_cycle.z700hr
#    fi
#    if [[ -s tmpz850 ]]; then
#      cat tmpz850      >>ensposte.$prev_cycle.z850hr
#      cat tmpz850stat  >>ensstate.$prev_cycle.z850hr
#    fi
#    if [[ -s tmpz1000 ]]; then
#      cat tmpz1000     >>ensposte.$prev_cycle.z1000hr
#      cat tmpz1000stat >>ensstate.$prev_cycle.z1000hr
#    fi

#    if [[ -s tmprh500 ]]; then
#      cat tmprh500     >>ensposte.$prev_cycle.rh500hr
#      cat tmprh500stat >>ensstate.$prev_cycle.rh500hr
#    fi
#    if [[ -s tmprh700 ]]; then
#      cat tmprh700     >>ensposte.$prev_cycle.rh700hr
#      cat tmprh700stat >>ensstate.$prev_cycle.rh700hr
#    fi
#    if [[ -s tmprh850 ]]; then
#      cat tmprh850     >>ensposte.$prev_cycle.rh850hr
#      cat tmprh850stat >>ensstate.$prev_cycle.rh850hr
#    fi

#    if [[ -s tmpmslp ]]; then
#      cat tmpmslp      >>ensposte.$prev_cycle.mslphr
#      cat tmpmslpstat  >>ensstate.$prev_cycle.mslphr
#    fi
#    if [[ -s tmppsfc ]]; then
#      cat tmppsfc      >>ensposte.$prev_cycle.psfchr
#      cat tmppsfcstat  >>ensstate.$prev_cycle.psfchr
#    fi
#    if [[ -s tmpprcp ]]; then
#      cat tmpprcp      >>ensposte.$prev_cycle.prcphr
#      cat tmpprcpstat  >>ensstate.$prev_cycle.prcphr
#    fi
#    if [[ -s tmptcdc ]]; then
#      cat tmptcdc      >>ensposte.$prev_cycle.tcdchr
#      cat tmptcdcstat  >>ensstate.$prev_cycle.tcdchr
#    fi

#    if [[ -s tmpu200 ]]; then
#      cat tmpu200      >>ensposte.$prev_cycle.u200hr
#      cat tmpv200      >>ensposte.$prev_cycle.v200hr
#    fi
#    if [[ -s tmpu500 ]]; then
#      cat tmpu500      >>ensposte.$prev_cycle.u500hr
#      cat tmpv500      >>ensposte.$prev_cycle.v500hr
#    fi
#    if [[ -s tmpu700 ]]; then
#      cat tmpu700      >>ensposte.$prev_cycle.u700hr
#      cat tmpv700      >>ensposte.$prev_cycle.v700hr
#    fi
#    if [[ -s tmpu850 ]]; then
#      cat tmpu850      >>ensposte.$prev_cycle.u850hr
#      cat tmpv850      >>ensposte.$prev_cycle.v850hr
#    fi
#    if [[ -s tmpu10m ]]; then
#      cat tmpu10m      >>ensposte.$prev_cycle.u10mhr
#      cat tmpv10m      >>ensposte.$prev_cycle.v10mhr
#    fi

#    rm tmp*
  else
    echo "!!! file ${ifile} is not copied !!!"
    echo "   "
  fi

#--------J.Peng---2010-12-13----------------------------------------------
## test output copy may be removed
#    if (( hourix == 2 )) ; then
#      echo
#      echo "##################################" ec.DCE.f${vhour} begin
#      echo
#      cat ec.DCE.f${vhour}
#      echo
#      echo "##################################" ec.DCE.f${vhour} end
#      echo
#    fi
####e

  echo `date` end "vmdh = $vmdh"

#  let hourix=hourix+1
#done

#for file in ensposte.* ensstate.*
#do
#  ${GRBINDEX:?} ${file} ${file}.i
#done

###################################
# Copy output (ECMWF ensemble GRIB1) data to $COMOUT
###################################
#if [ "$SENDCOM" = 'YES' ]; then
#  cp ensposte.* $COMOUT
#  cp ensstate.* $COMOUT
  #if [ "$SENDDBN" = 'YES' ]; then
  #  $DBNROOT/bin/dbn_alert EENS GRIB1-Change $job 
  #fi 
#fi

#!/bin/ksh
# Run under ksh (converted to WCOSS)
# This script encodes the analysis into the PREPBUFR reports
#  (interpolated to obs. locations)
#
# It is normally executed by the script ????????????????????.sh
#  but can also be executed from a checkout parent script
# -------------------------------------------------------------
#
# Script history log:
# ????-??-??  DKeyser (???)    -- Original version for implementation
# ????-??-??  DKeyser (???)    -- Transition to WCOSS (IBM idataPlex)
# 2017-03-09  DStokes          -- Modifications to run on Cray-XC40 as
#                                 well as IBM IdataPlex.
#                              -- changed out of acceptable range "exit 555" to
#                                 "exit 55" so that the intended code would be
#                                 returned to parent (aids error diagnosis)

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - expected center date in PREPBUFR file (YYYYMMDDHH)

# Imported variables that must be passed in:
#   DATA  - path to working directory
#   SANL  - path to COPY OF global simga analysis file 1 (valid at either
#            center date of PREPBUFR file or nearest cycle time prior to
#            center date of PREPBUFR file which is a multiple of 3)
#            (Note: Right now, this file will be an analysis only if
#                   the valid cycle time is 00, 06, 12 or 18, otherwise it will
#                    be a 3-hour forecast valid at this time)
#   SANLA - path to COPY OF global simga analysis file 2 (either null if SANL
#            is valid at center date of PREPBUFR file or valid at nearest
#            cycle time after center date of PREPBUFR file which is a multiple
#            of 3 if SANL is valid at nearest cycle time prior to center date
#            of PREPBUFR file which is a multiple of 3)
#            (Note: Right now, this file will be an analysis only if
#                   the valid cycle time is 00, 06, 12 or 18, otherwise it will
#                    be a 3-hour forecast valid at this time)
#   PSTX  - path to GLOBAL_POSTEVENTS program executable

# Imported variables that can be passed in:
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1 ;fi
CDATE10=$2

rm $PRPI.postevents

pgm=`basename  $PSTX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

echo "      $CDATE10" > cdate10.dat
export FORT11=$PRPI
#####export FORT12=$SANL
#####export FORT13=$SANLA

# The GLOBAL_POSTEVENTS code will soon, or may now, open GFS spectral
# coefficient guess files using sigio routines (via W3EMC routine GBLEVENTS)
# via explicit open(unit=number,file=filename) statements.  This conflicts with
# the FORTxx statements above.  One can either remove the explicit open
# statements in the code or replace the above FORTxx lines with soft links.
# The soft link approach is taken below.

ln -sf $SANL              fort.12
ln -sf $SANLA             fort.13

export FORT15=cdate10.dat
export FORT51=$PRPI.postevents

#### THE BELOW LIKELY NO LONGER APPLIES ON WCOSS
#The choice in the first  line below MAY cause a failure
#The choice in the second line below works!
set +u
####[ -n "$LOADL_PROCESSOR_LIST" ]  &&  XLSMPOPTS=parthds=2:stack=64000000
[ -n "$LOADL_PROCESSOR_LIST" ]  &&  XLSMPOPTS=parthds=2:stack=20000000
set -u

TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
SITE=${SITE:-""}
sys_tp=${sys_tp:-$(getsystem)}
getsystp_err=$?
if [ $getsystp_err -ne 0 ]; then
   msg="***WARNING: error using getsystem to determine system type and phase"
   set +u
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
   set -u
fi
echo sys_tp is set to: $sys_tp
launcher_PSTX=${launcher_PSTX:-""}
$TIMEIT $launcher_PSTX $PSTX < /dev/null > outout  2> errfile
err=$?
###cat errfile
cat errfile >> outout
cat outout >> postevents.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for GLOBAL_POSTEVENTS is ' $err
echo
set -x
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.postevents $PRPI
fi

exit 0

#!/bin/sh
######################################################################
echo "-------------------------------------------------------------"
echo "exprep_post.sh     - Runs various post-analysis processing   "
echo "                     steps on the PREPBUFR files (removes or "
echo "                     masks restricted data from both today's "
echo "                     PREPBUFR files and from AIRCAR and      "
echo "                     AIRCFT Table A entries in 2-day old     "
echo "                     PREPBUFR files).                        "
echo "                   - GDAS only: Identify TimeTwin duplicate  "
echo "                     upper-air (RAOB, PIBAL, DROP) wind      "
echo "                     report parts.                           "
echo "                   - 18Z GDAS only: Reformat GDAS received,  "
echo "                     selected, and assimilated data counts   "
echo "                     (both satellite and non-satellite) for  "
echo "                     all four cycles for today and save the  "
echo "                     result in the monthly archive directory "
echo "                     (run monthly summary on the second day  "
echo "                     of the next month and post to web).     "
echo "                   - 18Z GDAS only: Update the Master Ship   "
echo "                     Station List based on any new           "
echo "                     info read from the updated VOS ship     "
echo "                     list from NDBC. The Master Ship Station "
echo "                     List is read within job JRW1 at 12z on  "
echo "                     the first day of each month in order to "
echo "                     generate marine monthly statistics.     "
#  -------------------------------------------------------------------------

echo "------------------------------------------------------------------------"
echo "History:                                                                "
echo "  Jul 16 2003 - Original script - D. Keyser                             "
echo "  OCT 15 2011 - RAP replaces RUC (Keyser)                               "
echo "  Mar 11 2013 - ported to WCOSS (Melchior)                              "
echo "  Jul 01 2014 - Removed obsolete PROCESS_SATELLITE_COUNTS section       "
echo "                (Melchior)                                              "
echo "  Feb 18 2015 - Removed SENDWEB wrapper around call to gdas_summary.sh. "
echo "                Updated directory variable for ob count scripts (Stokes)"
echo "  Feb 16 2016 - Add PROCESS_MASTER_SHIP_STNLST section (Keyser)         "
echo "  Apr 11 2017 - Updated pointer to timetwin executable which is now in  "
echo "                this package and export FORT_BUFFERED=TRUE to improve   "
echo "                its performance on Cray-XC40.  Added wrapper to skip the"
echo "                yearly invocation of gdascounts_archive_pyear.sh if     "
echo "                SATCOMIN is on Cray-XC40 where it should follow new     "
echo "                YYYYMM naming convention. Update to recognize gdas or   "
echo "                gdas1 as prefix for gdas filenames.  Added variable     "
echo "                PROCESS_UNBLKBUFR to control creation of 'unblok' copy  "
echo "                of unrestricted prepbufr file (Stokes)                  "
echo "  Aug 21 2017 - Removed obsolete gdascounts_archive_pyear.sh (Stokes)   "
echo "  Apr 10 2018 - Added $path variable to include CYC_HIS sub-directory   "
echo "                for location of upper air wind files used in timetwin   "
echo "                processing (Melchior)                                   "
echo "  Jul 15 2020 - Modified $path variable to include (or exclude)         "
echo "                $COMPONENT subdir based on GFS version.                 "
echo "  Dec 09 2021 - Updated for use on WCOSS2 (Esposito)                    " 
echo "  ??? ?? ???? - Added new "remorest" processing to remove restricted    "
echo "                data from 2-day old PREPBUFR files (Keyser).            "
echo "  ??? ?? ???? - Added logic to handle PREPBUFR center times that are    "
echo "                not on the whole hour (needed for new RTMA_RU runs)     "
echo "                (Keyser).                                               "
###############################################################################

# NOTE: NET is gfs for the gdas RUN (as for the gfs RUN)
# -------------------------------------------------------

set -aux

# Make sure we are in the $DATA directory
cd $DATA

msg="Post-analysis processing of PREPBUFR file has begun on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"
 
if [ ! -s break ]; then
   echo "step ############# break ##############################" > break
fi
cat break > $pgmout

PROCESS_REMOREST_dm2=${PROCESS_REMOREST_dm2:-NO}

hr_fraction=""
set +u
if [ -n "$cycM" ]; then
set -u
  case "$cycM" in
    00) hr_fraction='.00' ;;
    15) hr_fraction='.25' ;;
    30) hr_fraction='.50' ;;
    45) hr_fraction='.75' ;;
     *) err_xd=9
        msg="###FATAL ERROR in model script: incorrect cycM='${cycM}' - exiting"
        echo "$msg"
        postmsg "$jlogfile" "$msg"
        exit $err_xd ;;
  esac
fi

tmhr=`echo $tmmark|cut -c3-4`
cdate10=`$NDATE -$tmhr $PDY$cyc`$hr_fraction
cycp=`echo $cdate10|cut -c9-10`

net=$NET

[[ $RUN == rap_p ]]  &&  net=rap_p
[[ $RUN == rap_e ]]  &&  net=rap_e

net_uc=$(echo $net | tr [a-z] [A-Z])
set +u
[ -n "$cycM" ]  &&  net_uc=RTMA_RU
set -u
tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])
RUN_uc=$(echo $RUN | tr [a-z] [A-Z])

msg="$net_uc ANALYSIS TIME IS $PDY$cyc"
set +u
[ -n "$cycM" ]  &&  msg="$msg:${cycM}"
set -u
$DATA/postmsg "$jlogfile" "$msg"

set +x
echo
echo "CENTER TIME FOR PREPBUFR PROCESSING FOR $tmmark_uc $net_uc IS $cdate10"
echo
set -x



if [ "$PROCESS_REMOREST" = 'YES' ]; then  # normally YES in all runs

   msg="REMOVE OR MASK RESTRICTED DATA FROM $tmmark_uc $net_uc PREPBUFR files \
CENTERED ON $cdate10"
   $DATA/postmsg "$jlogfile" "$msg"
   set +x
   echo
   echo "$msg"
   echo
   set -x

   dot_tmmark=".$tmmark"
   [ $net = gdas -o $net = gfs -o $net = cdas ]  &&  dot_tmmark=""

##############################################################
#  Remove or mask restricted data from today's PREPBUFR files
##############################################################

#  If either the restriction indicator (mnemonic RSRD) is set for a report, or
#  the report is in a Table A entry pre-determined to contain only restricted
#  reports, then the report is always restricted {regardless of the time in
#  hours for the expiration on restriction (mnemonic EXPRSRD)}.
#    ---> Since we are running in near-realtime, there is no need to test on
#         the value of EXPRSRD.  This will always be > current time difference.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_RESTR" (see below):
#            All reports are considered to be restricted by definition of this
#            switch. They will be skipped by program BUFR_REMOREST.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MIXED" (see below):
#            RSRD may not be set for all reports. Those with RSRD set are
#            considered to be restricted regardless of EXPRSRD because
#            "DIFF_HR" (the difference in hours between the current UTC wall-
#            clock date and the PREPBUFR file center date),is exported as 0
#            into program BUFR_REMOREST (EXPRSRD will always be > actual
#            DIFF_HR since we are running in near-realtime).  They will be
#            skipped by program BUFR_REMOREST.  Those reports that do not have
#            RSRD set are considered to be non-restricted and will be retained
#            by program BUFR_REMOREST.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MASKA" (see below):
#            All reports with a dump report type listed in namelist switch
#            IMASK_T29 (see below) may have RSRD set for some reports.  Those
#            with RSRD set are considered to be restricted regardless of
#            EXPRSRD because "DIFF_HR" (the difference in hours between the
#            current UTC wall-clock date and the PREPBUFR file center date),
#            is exported as 0 into program BUFR_REMOREST (EXPRSRD will always
#            be > actual DIFF_HR since we are running in near-realtime). They
#            are not removed, but all occurrences of their ids will be masked
#            out by program BUFR_REMOREST. In addition, program BUFR_REMOREST
#            re-sets their values for RSRD and EXPRSRD to missing so that the
#            reports are no longer considered to be restricted. Reports with a
#            dump report type not listed in namelist switch IMASK_T29 are
#            considered to be non-restricted and their ids are not masked out
#            by program BUFR_REMOREST.
# -----------------------------------------------------------------------------

  export DIFF_HR=0

  cat <<\EOFparm > bufr_remorest.prepbufr.parm
=========================================================================

  Cards for PREPBUFR Version of BUFR_REMOREST -- Version ?? ??? 20??

  -->   GPSIPW can be moved from MSG_RESTR to MSG_MIXED oncw dump interface to
         PREPDATA can recognize U.S.-provider (ENI) reports which are now
         restricted

 &SWITCHES
   MSG_RESTR = 'AIRCAR  ',   ! These are the Table A Entries for BUFR messages
               'MSONET  ',   !  for which ALL reports are considered to be
               'GPSIPW  ',   !  restricted. All reports will be REMOVED by
               '        ',   !  program BUFR_REMOREST.
               '        ',   !  (up to 20 Table A entries)
               '        ',   !
               '        ',   ! Note: move MSONET to MSG_MIXED when we know for sure that RSRD values are correct for each provider/sub-provider
               '        ',   !
   MSG_MIXED = 'AIRCFT  ',   ! These are the Table A Entries for BUFR messages
               'ADPSFC  ',   !  which may contain a MIXTURE of reports with and
               '        ',   !  withough mnemonic "RSRD" being set. If "RSRD" is
               '        ',   !  not set -or- it is set and mnemonic "EXPRSRD"
               '        ',   !  is also set and has a value luess than "DIFF_HR"
               '        ',   !  (the difference in hrs between the current UTC
               '        ',   !  wall-clock date and the PREPBUFR file center
               '        ',   !  date) minus 4, the report will be RETAINED by
               '        ',   !  program BUFR_REMOREST. Otherwise, it will be
               '        ',   !  REMOVED by program BUFR_REMOREST.
               '        ',   !  (up to 20 Table A entries)
               '        ',
   MSG_MASKA = 'SFCSHP  ',   ! These are the Table A Entries for BUFR messages
               '        ',   !  which, if their dump report type is one of up
               '        ',   !  to 10 possible listed in switch IMASK_T29
               '        ',   !  (where each line in IMASK_T29 applies to the
	       '        ',   !  Table A entry in the same line number here),
               '        ',   !  may contain a mixture or reports with and
               '        ',   !  without their value for mnemonic "RSRD") being
               '        ',   !  set. If "RSRD" is not set for a report -or- it
               '        ',   !  is set and the time in mnemonic "EXPRSRD" is
               '        ',   !  also set and has a value less than "DIFF_HR"
               '        ',   !  (the difference in hours between the current
               '        ',   !  UTC wall-clock date and the PREPBUFR file
               '        ',   !  center date) minus 4, the report will be
               '        ',   !  copied without any changes by program
               '        ',   !  BUFR_REMOREST. Otherwise, the report will not
               '        ',   !  be removed, but all occurrances of its id will
               '        ',   !  be changed to "MASKSTID" by program
               '        ',   !  BUFR_REMOREST. In addition, program
               '        ',   !  BUFR_REMOREST re-sets its values for "RSRD" and
               '        ',   !  "EXPRSRD to missing so that the report is no
                             !  longer considered to be restricted. Reports
                             !  with a dump report type not listed in switch
                             !  IMASK_T29 are considered to be non-restricted
                             !  and their report ids are not changed (masked
                             !  out) when copied by program BUFR_REMOREST.
                             !  (up to 20 Table A entries)
                             ! 
   IMASK_T29 = 522,523,8*99999, ! MSG_MASKA(1) dump report types that may
                                ! contain restricted reports
               10*99999,        ! MSG_MASKA(2) dump report types that may
                                ! contain restructed reports
               10*99999         ! etc., {up to 20 for MSG_MASKA(20)}

 /

    Note 1: A particular Table A entry should NEVER appear in more than one of
            MSG_RESTR, MSG_MIXED or MSG_MASKA.
    Note 2: Any Table A entry not in either MSG_RESTR, MSG_MIXED or MSG_MASKA
            is assumed to be a Table A entry for BUFR messages for which ALL
            reports are UNRESTRICTED (these messages are copied intact, no
            reports are unpacked).
    Note 3: Always fill in the arrays MSG_RESTR, MSG_MIXED and MSG_MASKA
            beginning with word 1.  If there are less than 20 words filled in
            an array, either set the extra words to "        " (8 blank
            characters) or do not specify them here (they default to
            "        ").
    Note 4: In array IMASK_T29, a value of "99999" means not applicable whereas
            a value of "000" means reports in all dump report types in the
            corresponding Table A entry in MSG_MASKA should be considered {in 
            this case IMASK_T29(1,x) would be set to 000 and IMASK_T29(2:10,x)
            should be set to 99999 for all reports in Table A entry
            MSG_MASKA(x) since they would all be ignored - this is the default
            for all Table A entries MSG_MASKA(1:20) if this switch is not set
            (i.e., for data dump files)}.

=========================================================================
EOFparm

REMX=${REMX:-$EXECobsproc/bufr_remorest}
REMC=${REMC:-bufr_remorest.prepbufr.parm}

if [ -f $COMIN/$RUN.$cycle.prepbufr${dot_tmmark} ]; then
   if [ ! -f $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.nr ]; then
      cp $COMIN/$RUN.$cycle.prepbufr${dot_tmmark} \
       $RUN.$cycle.prepbufr${dot_tmmark}
      $USHobsproc/bufr_remorest.sh \
       $RUN.$cycle.prepbufr${dot_tmmark}
      errsc=$?
      [ "$errsc" -ne '0' ]  &&  exit $errsc
      cp $RUN.$cycle.prepbufr${dot_tmmark} \
       $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.nr
      chmod 664 $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.nr
      msg="$RUN.$cycle.prepbufr${dot_tmmark}.nr successfully created"
      $DATA/postmsg "$jlogfile" "$msg"
      if test "$SENDDBN" = "YES"; then
         if test "$net" = "gdas"; then
            $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_PREPda_nr $job \
             $COMOUT/$RUN.$cycle.prepbufr.nr
         elif test "$net" = "nam"; then
            $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_PREPda_nr $job \
             $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.nr
         elif test "$net" = "gfs"; then
            $DBNROOT/bin/dbn_alert MODEL GFS_BUFR_PREPda_nr $job \
             $COMOUT/$RUN.$cycle.prepbufr.nr
         elif test "$net" = "rap" -o "$net" = "rap_e" -o "$net" = "rap_p"; then
            $DBNROOT/bin/dbn_alert MODEL ${net_uc}_BUFR_PREPda_nr $job \
             $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.nr
         fi
      fi
   else
      msg="$RUN.$cycle.prepbufr${dot_tmmark}.nr NOT created because it \
already exists"
      $DATA/postmsg "$jlogfile" "$msg"
   fi
   # Remove the following logic to create unblocked nr prepbufr files once we
   #   know it is definitely no longer needed.
   if [ "${PROCESS_UNBLKBUFR:-YES}" = 'YES' ]; then
      if [   -f $COMIN/$RUN.$cycle.prepbufr${dot_tmmark}.unblok -a \
           ! -f $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr ]; then
# make unblocked unrestricted prebufr file
#  ---> ON WCOSS prepbufr is already unblocked, so for now just copy it to the
#       unblok file location used before on CCS - hopefully this can be removed
#       someday!
         cp -p $RUN.$cycle.prepbufr${dot_tmmark} \
$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr
         err_cp=$?
         if [ $err_cp -eq 0 ]; then
            cp $RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr \
             $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr
            chmod 664 $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr
            msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr successfully created"
            $DATA/postmsg "$jlogfile" "$msg"
            if test "$SENDDBN" = "YES"; then
               if test "$net" = "gdas"; then
                  $DBNROOT/bin/dbn_alert MODEL ${RUN_uc}_BUFR_PREPda_unblok_nr \
                   $job $COMOUT/$RUN.$cycle.prepbufr.unblok.nr
               elif test "$net" = "gfs"; then
                  $DBNROOT/bin/dbn_alert MODEL GFS_BUFR_PREPda_unblok_nr $job \
                   $COMOUT/$RUN.$cycle.prepbufr.unblok.nr
               fi
            fi
         else
            msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr NOT created \
because cp command had return code $err_cp"
         $DATA/postmsg "$jlogfile" "$msg"
         fi
      else
         if [ ! -f $COMIN/$RUN.$cycle.prepbufr${dot_tmmark}.unblok ]; then
            msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr NOT created \
because unblocked prepbufr file does not exist"
            $DATA/postmsg "$jlogfile" "$msg"
         else
            msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr NOT created \
because it already exists"
            $DATA/postmsg "$jlogfile" "$msg"
         fi
      fi
   fi
else
   msg="$RUN.$cycle.prepbufr${dot_tmmark}.nr NOT created because \
prepbufr file does not exist"
   $DATA/postmsg "$jlogfile" "$msg"
   if [   -f $COMIN/$RUN.$cycle.prepbufr${dot_tmmark}.unblok -a \
        ! -f $COMOUT/$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr ]; then
      msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr NOT created \
because prepbufr file does not exist"
   fi
fi

if [   -f $COMIN/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark} -a \
     ! -f $COMOUT/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr ]; then
   cp $COMIN/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark} \
    $RUN.$cycle.prepbufr_pre-qc${dot_tmmark}
   $USHobsproc/bufr_remorest.sh \
    $RUN.$cycle.prepbufr_pre-qc${dot_tmmark}
   errsc=$?
   [ "$errsc" -ne '0' ]  &&  exit $errsc
   cp $RUN.$cycle.prepbufr_pre-qc${dot_tmmark} \
    $COMOUT/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr
   chmod 664 $COMOUT/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr
   msg="$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr successfully created"
   $DATA/postmsg "$jlogfile" "$msg"
else
   if [ ! -f $COMIN/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark} ]; then
      msg="$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr NOT created \
because prepbufr_pre-qc file does not exist"
      $DATA/postmsg "$jlogfile" "$msg"
   else
      msg="$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr NOT created because \
it already exists"
      $DATA/postmsg "$jlogfile" "$msg"
   fi
fi

fi # test for PROCESS_REMOREST=YES

# PROCESS_REMOREST_dm2 = YES runs only on demand, on dev machines
# Unrestrict 48h old aircraft obs(exc. TAMDAR), add *.ur file to $COMOUTm2
dev_m=$(grep backup /lfs/h1/ops/prod/config/prodmachinefile | cut -d: -f2)
this_m=$(cat /etc/cluster_name)

if [ "$PROCESS_REMOREST_dm2" = 'YES' -a $this_m = $dev_m ]; then
  cdate10M2=`$NDATE -$tmhr $PDYm2$cyc`

  msg="REMOVE OR MASK RESTRICTED DATA FROM $tmmark_uc $net_uc PREPBUFR files \
CENTERED ON $cdate10M2 (2-days ago)"
  $DATA/postmsg "$jlogfile" "$msg"
  set +x
  echo
  echo "$msg"
  echo
  set -x

  dot_tmmark=".$tmmark"
  [ $net = gdas -o $net = gfs -o $net = cdas ]  &&  dot_tmmark=""

##########################################################################
#  Remove restriction on data in "AIRCAR" and "AIRCFT" Table A entries in
#   2-day old PREPBUFR files (all other data previously restricted in
#   real-time PREPBUFR files continue to be restricted here)
##########################################################################

#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_RESTR" (see below):
#            All reports are considered to be restricted by definition of this
#            switch. They will be skipped by program BUFR_REMOREST.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MIXED" (see below):
#            The restriction indicator (mnemonic RSRD) may not be set for all
#            reports. If RSRD is set for a report, then its value for time in
#            hours for the expiration on restriction (mnemonic EXPRSRD) is
#            examined. If "DIFF_HR" (the difference in hours between the
#            current UTC wall-clock date and the PREPBUFR file center date,
#            exported into program BUFR_REMOREST) minus 4 is less than or equal
#            to EXPRSRD, then the report is considered to be restricted and
#            will be skipped by program BUFR_REMOREST. Otherwise, the report is
#            considered to be non-restricted and will be retained by program
#            BUFR_REMOREST.
#    ---> For all Table A entries listed in parm card namelist switch
#         "MSG_MASKA" (see below):
#            All reports with a dump report type listed in namelist switch
#            IMASK_T29 (see below) may have RSRD set for some reports.  If RSRD
#            is set for a report, then its value for EXPRSRD is examined. If
#            "DIFF_HR" minus 4 is less than or equal to EXPRSRD, then the
#            report is considered to be restricted.  It will not be removed,
#            but all occurrences of its id will be masked out by program
#            BUFR_REMOREST.  In addition, program BUFR_REMOREST re-sets its
#            values for RSRD and EXPRSRD to missing so that the report is no
#            longer considered to be restricted.  Reports with a dump report
#            type not listed in namelist switch IMASK_T29 are considered to be
#            non-restricted and their ids are not masked out by program
#            BUFR_REMOREST.
#            (Note: All reports in Table A entry "SFCSHP" that have RSRD set
#                   also have EXPRSRD set to missing.  Thus all such reports
#                   are considered as restricted for all time.)
#    ---> Since we are running 2-days late, we want to test on the value of
#         EXPRSRD (which currently should be set to 48 hours for any reports in
#         the "AIRCAR" and "AIRCFT" Table A entries which have RSRD set).  This
#         will allow non-rstprod users to have access to all original "AIRCAR"
#         and "AIRCFT" reports in non-restricted PREPBUFR files after EXPRSRD +
#         4 (52) hours.
# -----------------------------------------------------------------------------

  ymdh=$(date -u +'%Y%m%d%H')
  export DIFF_HR=`$NHOUR  $ymdh            $cdate10M2`
#                         current_date     prepbufr_date

  msg="Any reports with EXPRSRD less than `expr $DIFF_HR - 4 ` hrs will now \
be retained"
  $DATA/postmsg "$jlogfile" "$msg"

  $DATA/postmsg "$jlogfile" "$msg"

  cat <<\EOF_EXPRSRDparm > bufr_remorest.prepbufr_EXPRSRD.parm
=========================================================================

  Cards for PREPBUFR Version of BUFR_REMOREST -- Version 1.1.0 (09 Sep 2015)
  (documentation in bufr_remorest.prepbufr.parm above for $PROCESS_REMOREST
   also applies here)

  -->   GPSIPW can be moved from MSG_RESTR to MSG_MIXED oncw dump interface to
         PREPDATA can recognize U.S.-provider (ENI) reports which are now
	 restricted

&SWITCHES
  MSG_RESTR = 'MSONET  ',   ! Note: move MSONET to MSG_MIXED when we know for sure that RSRD values are correct for each provider/sub-provider
              'GPSIPW  ',
  MSG_MIXED = 'AIRCAR  ',
              'AIRCFT  ',
	      'ADPSFC  ',
	      '        ',
  MSG_MASKA = 'SFCSHP  ',
              '        ',
  IMASK_T29 = 522,523,8*99999,
              10*99999,
	      10*99999

/

=========================================================================
EOF_EXPRSRDparm

REMX=${REMX:-$EXECobsproc/bufr_remorest}
REMC=${REMC_EXPRSRD:-bufr_remorest.prepbufr_EXPRSRD.parm}

if [ -f $COMINm2/$RUN.$cycle.prepbufr${dot_tmmark} ]; then
   cp $COMINm2/$RUN.$cycle.prepbufr${dot_tmmark} \
    $RUN.$cycle.prepbufr${dot_tmmark}
   $USHobsproc/bufr_remorest.sh \
    $RUN.$cycle.prepbufr${dot_tmmark}
   errsc=$?
   [ "$errsc" -ne '0' ]  &&  exit $errsc
   cp $RUN.$cycle.prepbufr${dot_tmmark} \
    $COMOUTm2/$RUN.$cycle.prepbufr${dot_tmmark}.ur
   chmod 664 $COMOUTm2/$RUN.$cycle.prepbufr${dot_tmmark}.ur
   msg="$RUN.$cycle.prepbufr${dot_tmmark}.nr from 2-days ago successfully \
created -- overwrite existing file made 2-days ago"
   $DATA/postmsg "$jlogfile" "$msg"
   if test "$SENDDBN" = "YES"; then
      if test "$net" = "gdas"; then
	 $DBNROOT/bin/dbn_alert MODEL GDAS1_BUFR_PREPda_nr $job \
          $COMOUTm2/$RUN.$cycle.prepbufr.nr
      elif test "$net" = "nam"; then
	 $DBNROOT/bin/dbn_alert MODEL NAM_BUFR_PREPda_nr $job \
          $COMOUTm2/$RUN.$cycle.prepbufr${dot_tmmark}.nr
      elif test "$net" = "gfs"; then
	 $DBNROOT/bin/dbn_alert MODEL GFS_BUFR_PREPda_nr $job \
          $COMOUTm2/$RUN.$cycle.prepbufr.nr
      elif test "$net" = "rap" -o "$net" = "rap_e" -o "$net" = "rap_p"; then
	 $DBNROOT/bin/dbn_alert MODEL ${net_uc}_BUFR_PREPda_nr $job \
	  $COMOUTm2/$RUN.$cycle.prepbufr${dot_tmmark}.nr
      fi
   fi
   if [ -f $COMINm2/$RUN.$cycle.prepbufr${dot_tmmark}.unblok ]; then
# make unblocked unrestricted prebufr file
#  ---> ON WCOSS prepbufr is already unblocked, so for now just copy it to the
#       unblok file location used before on CCS - hopefully this can be removed
#       someday!
      cp -p $RUN.$cycle.prepbufr${dot_tmmark} \
$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr
      err_cp=$?
      if [ $err_cp -eq 0 ]; then
	 cp $RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr \
	  $COMOUTm2/$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr
	 chmod 664 $COMOUTm2/$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr
	 msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr from 2-days ago \
successfully created - overwrite existing file made 2-days ago"
	 $DATA/postmsg "$jlogfile" "$msg"
	 if test "$SENDDBN" = "YES"; then
	    if test "$net" = "gdas"; then
	       $DBNROOT/bin/dbn_alert MODEL GDAS1_BUFR_PREPda_unblok_nr $job \
		$COMOUTm2/$RUN.$cycle.prepbufr.unblok.nr
	    elif test "$net" = "gfs"; then
	       $DBNROOT/bin/dbn_alert MODEL GFS_BUFR_PREPda_unblok_nr $job \
		$COMOUTm2/$RUN.$cycle.prepbufr.unblok.nr
	    fi
	 fi
      else
	 msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr from 2-days ago NOT \
created because cp command had return code $err_cp -- existing file made \
2-days ago is not overwritten"
	 $DATA/postmsg "$jlogfile" "$msg"
      fi
   else
      msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr from 2-days ago NOT \
created because unblocked prepbufr file from 2-days ago does not exist"
      $DATA/postmsg "$jlogfile" "$msg"
   fi
else
   msg="$RUN.$cycle.prepbufr${dot_tmmark}.nr from 2-days ago NOT created \
because prepbufr file from 2-days ago does not exist"
   $DATA/postmsg "$jlogfile" "$msg"
   if [ -f $COMINm2/$RUN.$cycle.prepbufr${dot_tmmark}.unblok ]; then
      msg="$RUN.$cycle.prepbufr${dot_tmmark}.unblok.nr from 2-days ago NOT \
created because prepbufr file from 2-days ago does not exist"
   fi
fi

if [ -f $COMINm2/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark} ]; then
   cp $COMINm2/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark} \
    $RUN.$cycle.prepbufr_pre-qc${dot_tmmark}
   $USHobsproc/bufr_remorest.sh \
    $RUN.$cycle.prepbufr_pre-qc${dot_tmmark}
   errsc=$?
   [ "$errsc" -ne '0' ]  &&  exit $errsc
#   cp $RUN.$cycle.prepbufr_pre-qc${dot_tmmark} \
#    $COMOUTm2/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr
#   chmod 664 $COMOUTm2/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr
   cp $RUN.$cycle.prepbufr_pre-qc${dot_tmmark} \
    $COMOUTm2/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.ur
   chmod 664 $COMOUTm2/$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.ur
   msg="$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr from 2-days ago \
successfully created -- overwrite existing file made 2-days ago"
   $DATA/postmsg "$jlogfile" "$msg"
else
   msg="$RUN.$cycle.prepbufr_pre-qc${dot_tmmark}.nr from 2-days ago NOT \
created because prepbufr_pre-qc file from 2-days ago does not exist"
   $DATA/postmsg "$jlogfile" "$msg"
fi

fi #  endif loop $PROCESS_REMOREST_dm2



# PROCESS_TIMETWINS can only be YES in all GDAS cycles (where default is YES)
# ---------------------------------------------------------------------------
PROCESS_TIMETWINS=${PROCESS_TIMETWINS:-YES}
[ $net != gdas ] && PROCESS_TIMETWINS=NO

if [ "$PROCESS_TIMETWINS" = 'YES' ]; then

   msg="FIND UPPER-AIR TIME-TWINS IN $tmmark_uc $net_uc PREPBUFR files \
CENTERED ON $cdate10"
   $DATA/postmsg "$jlogfile" "$msg"
   set +x
   echo
   echo "$msg"
   set -x

###########################################################################
#  Find upper-air TimeTwins (duplications in current RAOB, PIBAL, or DROP
#   wind report "parts" vs. those over the past 35 days) (executed only
#   for the GDAS run, for every cycle)
##########################################################################

   set +x
   echo "Upper-air TimeTwins are current reports that are duplicates of \
past reports"
   echo
   echo "Calculate date 35 days ago to limit old data accumulation." 
   echo
   set -x

   F35DAYL=`$NDATE -840 ${PDY}${cyc}`
   cat << EOH > cardec
${F35DAYL} ${PDY}
EOH

   if [ -f $COMIN/$RUN.t${cyc}"z".prepbufr ]; then
      BUFFILE=$COMIN/$RUN.t${cyc}"z".prepbufr
      errbufr=0
   elif [ -f $COMINGFS/gfs.t${cyc}"z".prepbufr ]; then
      BUFFILE=$COMINGFS/gfs.t${cyc}"z".prepbufr
      errbufr=0
   else
      errbufr=1
   fi

   if [ $errbufr -eq 0 ]; then
      set +x
      echo
      echo "Wind reports taken from: "
      echo    $BUFFILE
      echo
      set -x
   else
      set +x
      echo
      echo "Could not find the current" ${cyc}"z" "GFS or GDAS prepbufr file"
      echo
      set -x
      $DATA/err_exit
   fi

   pgm="timetwin"
   export pgm

   THR=6
   ICNT=1
   error=FALSE

   while [ $error = FALSE ]; do

      prevgoodcyc=`$NDATE -$THR ${PDY}${cyc}`
      DATE_HIS=`echo $prevgoodcyc | cut -c1-8`
      CYC_HIS=`echo $prevgoodcyc | cut -c9-10`
      path="${COMIN1}${DATE_HIS}/${CYC_HIS}/${COMPONENT}"

      . $DATA/prep_step
      export FORT10="$BUFFILE"
      export FORT24="${path}/upa_his_twinwind.ttaa.t${CYC_HIS}"z""
      export FORT25="${path}/upa_his_twinwind.ttbb.t${CYC_HIS}"z""
      export FORT26="${path}/upa_his_twinwind.ttcc.t${CYC_HIS}"z""
      export FORT27="${path}/upa_his_twinwind.ttdd.t${CYC_HIS}"z""
      export FORT28="${path}/upa_his_twinwind.ppbb.t${CYC_HIS}"z""
      export FORT29="${path}/upa_his_twinwind.ppdd.t${CYC_HIS}"z""
      export FORT61="upa_cur_twinwind.ttaa.t${cyc}"z""
      export FORT62="upa_cur_twinwind.ttbb.t${cyc}"z""
      export FORT63="upa_cur_twinwind.ttcc.t${cyc}"z""
      export FORT64="upa_cur_twinwind.ttdd.t${cyc}"z""
      export FORT65="upa_cur_twinwind.ppbb.t${cyc}"z""
      export FORT66="upa_cur_twinwind.ppdd.t${cyc}"z""
      export FORT54="new.ttaa.t${cyc}"z""
      export FORT55="new.ttbb.t${cyc}"z""
      export FORT56="new.ttcc.t${cyc}"z""
      export FORT57="new.ttdd.t${cyc}"z""
      export FORT58="new.ppbb.t${cyc}"z""
      export FORT59="new.ppdd.t${cyc}"z""
      export FORT74="timetwin.diags.t${cyc}"z""
      export FORT75="twin"
####  export FORT76="timetwin.debug1.diags.t${cyc}"z""
####  export FORT77="timetwin.debug2.diags.t${cyc}"z""

      startmsg
      FORT_BUFFERED=TRUE $EXECprepobs/timetwin < cardec >>$pgmout 2> errfile
      export err=$?
####  $DATA/err_chk

      if [ $err -eq 0 ]; then
         error=TRUE
      else
         cp -p errfile errfile.timetwin.$ICNT
         let ICNT=$ICNT+1
         if [ $ICNT -eq 28 ]; then
            set +x
            echo
            echo " Upperair wind reports are beyond 7 days...exit"
            echo
            set -x
            $DATA/err_chk
         fi
         let THR=$ICNT*6
         echo "THR" $THR $ICNT
      fi
   done

   if [ $SENDCOM = "YES" ]; then
      cp new.ttaa.t${cyc}"z" $COMOUT/upa_his_twinwind.ttaa.t${cyc}"z"
      cp new.ttbb.t${cyc}"z" $COMOUT/upa_his_twinwind.ttbb.t${cyc}"z"
      cp new.ttcc.t${cyc}"z" $COMOUT/upa_his_twinwind.ttcc.t${cyc}"z"
      cp new.ttdd.t${cyc}"z" $COMOUT/upa_his_twinwind.ttdd.t${cyc}"z"
      cp new.ppbb.t${cyc}"z" $COMOUT/upa_his_twinwind.ppbb.t${cyc}"z"
      cp new.ppdd.t${cyc}"z" $COMOUT/upa_his_twinwind.ppdd.t${cyc}"z"
      cp upa_cur_twinwind.ttaa.t${cyc}"z" $COMOUT/upa_cur_twinwind.ttaa.t${cyc}"z"
      cp upa_cur_twinwind.ttbb.t${cyc}"z" $COMOUT/upa_cur_twinwind.ttbb.t${cyc}"z"
      cp upa_cur_twinwind.ttcc.t${cyc}"z" $COMOUT/upa_cur_twinwind.ttcc.t${cyc}"z"
      cp upa_cur_twinwind.ttdd.t${cyc}"z" $COMOUT/upa_cur_twinwind.ttdd.t${cyc}"z"
      cp upa_cur_twinwind.ppbb.t${cyc}"z" $COMOUT/upa_cur_twinwind.ppbb.t${cyc}"z"
      cp upa_cur_twinwind.ppdd.t${cyc}"z" $COMOUT/upa_cur_twinwind.ppdd.t${cyc}"z"
      cp timetwin.diags.t${cyc}"z" $COMOUT/timetwin.diags.t${cyc}"z"

      if [ -f twin ]; then
         cp twin $COMOUT/upa_time_twin.t${cyc}"z"
      else
         echo "NO TWIN REPORTS" | cat >> upa_time_twin.t${cyc}"z"
         cp upa_time_twin.t${cyc}"z" $COMOUT/upa_time_twin.t${cyc}"z" 
      fi
   fi
fi # test for PROCESS_TIMETWINS=YES



# PROCESS_ALL_REPORT_COUNTS can only be YES in 18z GDAS (where default is YES)
# ----------------------------------------------------------------------------
PROCESS_ALL_REPORT_COUNTS=${PROCESS_ALL_REPORT_COUNTS:-YES}
[ $net != gdas -o $cyc != 18 ] && PROCESS_ALL_REPORT_COUNTS=NO

if [ "$PROCESS_ALL_REPORT_COUNTS" = 'YES' ]; then
 
   msg="ARCHIVE ALL OBS COUNTS (SAT AND NON-SAT) FOR ALL 4 $net_uc CYCLES \
FOR $PDY"
   $DATA/postmsg "$jlogfile" "$msg"
   set +x
   echo
   echo "$msg"
   echo
   set -x

#############################################################################
#  Reformat GDAS received, selected, and assimilated data counts (both
#   satellite and non-satellite) for all four cycles for today and save the
#   result in the monthly archive directory (run monthly summary on the
#   second day of the next month and post to web) (executed only for the 18z
#   GDAS run)
#############################################################################

   $USHprepobs/gdas_counts.sh

#  Run monthly summary only on the second day of the month, post to web
#  --------------------------------------------------------------------
   monsummary_dat=${monsummary_dat:-`date +"%Y%m"02`}
   if [ $monsummary_dat -eq $PDY ]; then
      msg="....it's day 2 of month - post last month's obs count summary to web"
      $DATA/postmsg "$jlogfile" "$msg"
      set +x
      echo
      echo "$msg"
      echo
      set -x
      $USHprepobs/gdas_summary.sh
   fi
fi # test for PROCESS_ALL_REPORT_COUNTS=YES



# PROCESS_MASTER_SHIP_STNLST can only be YES in 18z GDAS (where default is YES)
# -----------------------------------------------------------------------------
PROCESS_MASTER_SHIP_STNLST=${PROCESS_MASTER_SHIP_STNLST:-YES}
[ $net != gdas -o $cyc != 18 ] && PROCESS_MASTER_SHIP_STNLST=NO

if [ "$PROCESS_MASTER_SHIP_STNLST" = 'YES' ]; then
 
   msg="UPDATE MASTER SHIP STATION LIST FOR $PDY"
   $DATA/postmsg "$jlogfile" "$msg"
   set +x
   echo
   echo "$msg"
   echo
   set -x

#############################################################################
#  Update the "Master Ship Station List" based on any information read from
#   the updated VOS ship list from NDBC
#############################################################################

   $USHprepobs/mstr_shp_stn_lst_update.sh

fi # test for PROCESS_MASTER_SHIP_STNLST=YES


#######################


# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output

cat  break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"
 
################## END OF SCRIPT #######################

#!/bin/bash

set -eux

# Location of PWD and package source directory.
readonly pkg_root=$(cd "$(dirname "$(readlink -f -n "${BASH_SOURCE[0]}" )" )/.." && pwd -P)

# User Options
BUILD_TYPE=${BUILD_TYPE:-"Release"}
BUILD_DIR=${BUILD_DIR:-"${pkg_root}/build"}
CMAKE_OPTS=${CMAKE_OPTS:-}
INSTALL_TARGET=${INSTALL_TARGET:-"wcoss2"}
INSTALL_PREFIX=${INSTALL_PREFIX:-"${pkg_root}/install"}

target="${INSTALL_TARGET,,}"
if [[ "${target}" =~ ^(wcoss2|hera|orion|jet|hercules)$ ]]; then
  # prepare the target specific build.ver and run.ver
  cd "${pkg_root}/versions" || exit 1
  rm -f build.ver run.ver
  cp "build.${target}.ver" "build.ver"
  cp "run.${target}.ver"   "run.ver"
  cd "${pkg_root}" || exit 1
  export HOMEobsproc="${pkg_root}"
  source "${pkg_root}/versions/build.ver"
  unset HOMEobsproc
  set +x
  module purge
  module use "${pkg_root}/modulefiles"
  module load "obsproc_${target}"
  module list
  set -x
else
  echo "WARNING: Unknown target"
fi

# Create a build directory and cd into it.
[[ -d build  ]] && rm -rf build
mkdir -p build && cd build

# build and install.
cmake -DCMAKE_INSTALL_PREFIX="${INSTALL_PREFIX}" \
      -DCMAKE_INSTALL_BINDIR=exec \
      -DCMAKE_BUILD_TYPE="${BUILD_TYPE}" \
      ..
make -j "${BUILD_JOBS:-6}" VERBOSE="${BUILD_VERBOSE:-}"
make install

# Remove build directory upon successfull build and install
cd "${pkg_root}"
rm -rf build

exit 0

#!/bin/ksh
echo
echo "------------------------------------------------"
echo "Datacount Reporting for the SDM"
echo "------------------------------------------------"
echo "Latest update:"
echo "  Mar 2017 DStokes - Cray port: Use mail.py utility in order to send"
echo "                     dump status info to SDM from any node"
echo "------------------------------------------------"
echo
set -aux

################################################################################
#
# additional modification history
#  MAR 2000 Sager  - First implementation of this new script.
#  AUG 2000 Keyser - Redesign.
#  OCT 2010 Malone - No longer print to SDM print.  Rather e-mail SDM account.
#  12 Mar 2013 JWhiting - ported to WCOSS (Linux) platforms:
#                - cp'd CCS ver of 5 Jan 2009
#                - updated logical unit links (rm'd XLF*)
#                - replaced "timex" w/ "time -p"
#  14 Sep 2015 SMelchior - modified sed commands to allow for more
#                  generalized search matches.
#  10 Jan 2017 D, Keyser - Minor comment and echo changes to account
#                  for NAM having multiple $tmmark times after NAMv4
#                  (still consider only tm00). Added $tmmark qualifier
#                  to end of output dump alert and log filenames.
#  26 Mar 2017 DStokes   - Cray port: Replaced mail command with mail.py utility
#                  in order to send dump status info to SDM from any node
#  11 Apr 2018 SMelchior - removed final "gdas1" usage.
#  15 Dec 2021 NEsposito - update HOMEbufr_util to HOMEbufr_dump
#
################################################################################
#
# Imported variables that must be passed in:
#   DATA        - path to working directory
#   job         - job name (e.g., 'gdas_dump_post_12' or
#                                 'nam_dump_post_tm00_12')
#   NET         - network  {'nam' (tm00), 'gfs', or 'gdas'}
#                 NOTE: NET is changed to 'gdas' in the parent Job script
#                       for the 'gdas' RUN (was 'gfs' - NET remains 'gfs' for
#                       'gfs' RUN)
#   RUN         - analysis/model run  {'nam' (tm00), 'gfs', or 'gdas'}
#   COMIN       - FIRST choice for path to input $COMROOT directory containing
#                 the dump status file
#   COMOUT      - path to output $COMROOT directory; SECOND choice for path to
#                 input $COMROOT directory containing the dump status file (if dump
#                 status file not found in $COMIN)
#   PDY         - analysis YYYYMMDD
#   cycle       - analysis cycle time (e.g., 't00z')
#   tmmark      - dump time relative to cycle time (e.g., 'tm00')
#                  Note: Only 'tm00' currently valid
#   dumptime    - data dump center time in YYYYMMDDHH
#   pgmout      - string indicating path to for standard output file
#   jlogfile    - string indicating path to job log file
#   AVGDarch_IN - path to directory containing 30-day average files
#   ALERTL      - path to directory containing alert logs
#   SENDCOM     - send files to output $COMROOT directory
#   SENDECF     - flag events on ECF
#   SENDSDM     - email files to SDM 
#
# Imported Variables that must be passed in under certain conditions:
#   EXECobsproc
#               - formerly EXECobsproc_dump_post prior to WCOSS2.  Path to
#                 obsproc executable directory containing bufr_datacount.
#                 (invoked only if $DTCX is not imported)
#   FIXbufr_dump
#               - formerly FIXobsproc_shared_bufr_dumplist prior to WCOSS2
#               - path to obsproc fix directory containing the
#                 bufr_dumplist file
#                 (invoked only if $LIST_CNT is not imported)
#
# Imported variables that can be passed in:
#   DTCX        - path to bufr_datacount executable
#                  (defaults to $EXECobsproc/bufr_datacount if not passed in)
#   LIST_CNT    - path to the bufr_dumplist file
#                  (defaults to $FIXbufr_dump/bufr_dumplist
#                   if not passed in)


DTCX=${DTCX:-$EXECobsproc/bufr_datacount}
LIST_CNT=${LIST_CNT:-$FIXbufr_dump/bufr_dumplist}

cd $DATA

tmmark_uc=$(echo $tmmark | tr [a-z] [A-Z])
NET_uc=$(echo $NET | tr [a-z] [A-Z])
cycle_uc=$(echo $cycle | tr [a-z] [A-Z] | cut -c2-)

msg="CHECK DATA COUNTS FOR $tmmark_uc $NET_uc FOR $dumptime"
postmsg "$jlogfile" "$msg"

RETC=0
#  --> after NAMv4 impl. it makes sense to add $tmmark to end of below filename
#      (eventually transition JDUMP_ALERT to read new form of filename and
#       delete old form of filename)
echo $RETC > $COMOUT/${RUN}.${cycle}.dump_alert_flag
echo $RETC > $COMOUT/${RUN}.${cycle}.dump_alert_flag.$tmmark


# ------------------------------------------------------------------------
# Subset the bufr_dumplist, bufr_d status, current 30-day avg,
#  3-month ago 30-day avg, 6-month ago 30-day avg, 9-month ago 30-day avg,
#  and 12-month ago 30-day avg files
# ------------------------------------------------------------------------

grep --text -e "^_" -e "^:" $LIST_CNT | grep -Fe "#>" > dumplist

if [ -s $COMIN/${RUN}.${cycle}.status.tm00.bufr_d ]; then
   status_bufr_d=$COMIN/${RUN}.${cycle}.status.tm00.bufr_d
elif [ -s $COMOUT/${RUN}.${cycle}.status.tm00.bufr_d ]; then
   status_bufr_d=$COMOUT/${RUN}.${cycle}.status.tm00.bufr_d
else
   status_bufr_d=/dev/null
fi
grep --text -Fe " REPORTS" $status_bufr_d  | grep -Fe " in data group " | \
 grep -Fe " HAS" | grep -v -Fe "Domain" > delete
awk -F" HAS" '{print$2}' delete | awk -F" REPORTS" '{print$1}' | \
 sed "s/[^0-9]/ /g" > delete.r
awk -F" in data group " '{print $1}' delete | \
 sed "s/[^0-9][^0-9][^0-9]^\.[^0-9][^0-9][^0-9]/ /g" | \
 sed "s/[^0-9]/ /g" > delete.l
paste delete.l delete.r > ${RUN}.${cycle}.status.tm00.bufr_d
rm delete delete.l delete.r

> obcount_30davg.${NET}.current
if [ -s $AVGDarch_IN/obcount_30davg.${NET}.current ]; then
   grep --text "^#   " $AVGDarch_IN/obcount_30davg.${NET}.current | \
    sed "s/#  ......./     /g" | sed "s/[^0-9]/ /g" \
    > obcount_30davg.${NET}.current
fi

typeset -Z2 this_month arch_month
typeset -Z4 this_year  arch_year
this_month=`echo $PDY | cut -c5-6`
this_year=`echo $PDY | cut -c1-4`
for months_ago in 3 6 9 12; do
   a_month=`expr $this_month - $months_ago`
   arch_year=$this_year
   if [ "$a_month" -le '0' ]; then
      a_month=`expr $a_month + 12`
      arch_year=`expr $arch_year - 1`
   fi
   arch_month=$a_month

   > obcount_30davg.${NET}.${months_ago}months_ago
   if [ -s $AVGDarch_IN/obcount_30davg.${NET}.${arch_year}${arch_month} ]; then
     grep --text "^#   " $AVGDarch_IN/obcount_30davg.${NET}.${arch_year}${arch_month} | \
       sed "s/#  ......./     /g" | sed "s/[^0-9]/ /g" \
       > obcount_30davg.${NET}.${months_ago}months_ago
   fi
done


# ---------------------------------------------------------------------------
# Pass in script info to bufr_datacount program via standard input data cards
# ---------------------------------------------------------------------------

cat <<EOFd > datacount.cards
 &INPUT
  cdate10  = '$dumptime',
  network  = '$NET_uc',
  tmmark   = '$tmmark_uc',
  cycle    = '$cycle_uc',
  job      = '$job',
  currdate = '`date -u`',
  klimit   = 20,

  skip(021,025,1,1,1) = TRUE,  ! skip 1bhrs3 in NAM 00Z (tm00), current cnt only
  skip(021,025,1,2,1) = TRUE,  ! skip 1bhrs3 in NAM 06Z (tm00), current cnt only
  skip(021,025,1,3,1) = TRUE,  ! skip 1bhrs3 in NAM 12Z (tm00), current cnt only
  skip(021,025,2,2,1) = TRUE,  ! skip 1bhrs3 in GFS 06Z, current count only

  skip(021,024,1,1,1) = TRUE,  ! skip 1bamub in NAM 00Z (tm00), current cnt only
  skip(021,024,1,2,1) = TRUE,  ! skip 1bamub in NAM 06Z (tm00), current cnt only
  skip(021,024,1,3,1) = TRUE,  ! skip 1bamub in NAM 12Z (tm00), current cnt only
  skip(021,024,2,2,1) = TRUE,  ! skip 1bamub in GFS 06Z, current count only

  skip(005,070,2,1,1) = TRUE,  ! skip infmo  in GFS 00Z, current count only
  skip(005,070,2,2,1) = TRUE,  ! skip infmo  in GFS 06Z, current count only
  skip(005,070,2,3,1) = TRUE,  ! skip infmo  in GFS 12Z, current count only
  skip(005,070,2,4,1) = TRUE,  ! skip infmo  in GFS 18Z, current count only

  skip(005,071,2,1,1) = TRUE,  ! skip h20mo  in GFS 00Z, current count only
  skip(005,071,2,2,1) = TRUE,  ! skip h20mo  in GFS 06Z, current count only
  skip(005,071,2,3,1) = TRUE,  ! skip h20mo  in GFS 12Z, current count only
  skip(005,071,2,4,1) = TRUE,  ! skip h20mo  in GFS 18Z, current count only

  week_end(004,002,1,1,2) = TRUE, !pirep in NAM 00Z (tm00), reduce lim if hol
  week_end(004,002,1,2,3) = TRUE, !pirep in NAM 06Z (tm00), reduce lim wkend/hol
  week_end(004,002,1,3,3) = TRUE, !pirep in NAM 12Z (tm00), reduce lim wkend/hol
  week_end(004,002,1,4,2) = TRUE, !pirep in NAM 18Z (tm00), reduce lim if hol

  week_end(004,002,2,1,2) = TRUE, !pirep in GFS 00Z, reduce lim if holiday
  week_end(004,002,2,2,3) = TRUE, !pirep in GFS 06Z, reduce lim if wkend or hol
  week_end(004,002,2,3,3) = TRUE, !pirep in GFS 12Z, reduce lim if wkend or hol
  week_end(004,002,2,4,2) = TRUE, !pirep in GFS 18Z, reduce lim if holiday

  week_end(004,002,3,1,2) = TRUE, !pirep in GDAS 00Z, reduce lim if holiday
  week_end(004,002,3,2,3) = TRUE, !pirep in GDAS 06Z, reduce lim if wkend or hol
  week_end(004,002,3,3,3) = TRUE, !pirep in GDAS 12Z, reduce lim if wkend or hol
  week_end(004,002,3,4,2) = TRUE, !pirep in GDAS 18Z, reduce lim if holiday

  week_end(004,003,1,3,2) = TRUE, !asdar in NAM 12Z (tm00), reduce lim if hol
  week_end(004,003,1,4,2) = TRUE, !asdar in NAM 18Z (tm00), reduce lim if hol

  week_end(004,003,2,2,2) = TRUE, !asdar in GFS 06Z, reduce lim if holiday
  week_end(004,003,2,3,2) = TRUE, !asdar in GFS 12Z, reduce lim if holiday
  week_end(004,003,2,4,2) = TRUE, !asdar in GFS 18Z, reduce lim if holiday

  week_end(004,003,3,2,2) = TRUE, !asdar in GDAS 06Z, reduce lim if holiday
  week_end(004,003,3,3,2) = TRUE, !asdar in GDAS 12Z, reduce lim if holiday
  week_end(004,003,3,4,2) = TRUE, !asdar in GDAS 18Z, reduce lim if holiday

  week_end(004,004,1,2,3) = TRUE, !acars in NAM 06Z (tm00), reduce lim wkend/hol
  week_end(004,004,1,3,3) = TRUE, !acars in NAM 12Z (tm00), reduce lim wkend/hol

  week_end(004,004,2,2,3) = TRUE, !acars in GFS 06Z, reduce lim if wkend or hol
  week_end(004,004,2,3,3) = TRUE, !acars in GFS 12Z, reduce lim if wkend or hol

  week_end(004,004,3,2,3) = TRUE, !acars in GDAS 06Z, reduce lim if wkend or hol
  week_end(004,004,3,3,3) = TRUE  !acars in GDAS 12Z, reduce lim if wkend or hol

  week_end(003,001,1,2,4) = TRUE  !geost  in NAM 06Z (tm00), reduce lim if eclip
  week_end(003,002,1,2,4) = TRUE  !geosth in NAM 06Z (tm00), reduce lim if eclip

  week_end(005,010,1,2,4) = TRUE  !infus  in NAM 06Z (tm00), skip if eclipse
  week_end(005,011,1,2,4) = TRUE  !h2ius  in NAM 06Z (tm00), skip if eclipse
  week_end(005,012,1,2,4) = TRUE  !visus  in NAM 06Z (tm00), skip if eclipse
  week_end(005,013,1,2,4) = TRUE  !ptrus  in NAM 06Z (tm00), skip if eclipse

  week_end(021,041,2,2,4) = TRUE  !geoimr in GFS 06Z,  reduce lim if eclipse
  week_end(021,041,3,2,4) = TRUE  !geoimr in GDAS 06Z, reduce lim if eclipse

 /
  -->  skip(itype,isubt,inet,icyc,ichktp)  (SKIPS dump alert processing)

  -->  week_end(itype,isubt,inet,icyc,iwkend)  {REDUCES current count dump
        alert threshold by 10% if today is a weekend, by 20% if today is in
        the last week of the year or today is Thanksgiving, or by 15% for
        GOES sndg/rad/retr/wind reports if today is an eclipse day (wind
        for GFS or GDAS networks only) -- SKIPS dump alert processing for
        GOES wind reports for NAM (tm00) network if today is an eclipse day}

       where itype  = BUFR type
       where isubt  = BUFR subtype
       where inet   = network {1-NAM (tm00), 2-GFS, 3-GDAS}
       where icyc   = cycle   (1-00Z, 2-06Z, 3-12Z, 4-18Z)
       where ichktp = check type
                       (1-current count vs. current 30-day avg,
                        2-current 30-day avg vs. previous 30-day avg,
                        3-both checks 1 and 2)
       where iwkend = indicator when to reduce current dump count threshold
                       {1-reduce threshold only if today is a weekend,
                        2-reduce threshold only if today is a holiday,
                        3-reduce threshold if today is either a weekend
                          or a holiday or both
                        4-if today is an eclipse day, either reduce threshold
                          for GOES sndg/rad/retr/wind reports (wind for GFS
                          or GDAS networks only) or SKIP dump alert
                          processing for GOES wind reports for NAM tm00 network}

EOFd


# ---------------------------------------------------
# Execute bufr_datacount to check for low data counts
# ---------------------------------------------------


pgm=`basename  $DTCX`
set +u
. prep_step
set -u
startmsg

> deficient
> excessive
> trend_m03
> trend_m06
> trend_m09
> trend_m12

   unset FORT00 `env | grep "FORT[0-9]\{1,\}" | awk -F= '{print $1}'`
   export FORT10="dumplist"
   export FORT11="$RUN.${cycle}.status.tm00.bufr_d"
   export FORT13="obcount_30davg.${NET}.current"
   export FORT14="obcount_30davg.${NET}.3months_ago"
   export FORT15="obcount_30davg.${NET}.6months_ago"
   export FORT16="obcount_30davg.${NET}.9months_ago"
   export FORT17="obcount_30davg.${NET}.12months_ago"
   export FORT51="updated.status.tm00.bufr_d"
   export FORT52="deficient"
   export FORT53="excessive"
   export FORT54="trend_m03"
   export FORT55="trend_m06"
   export FORT56="trend_m09"
   export FORT57="trend_m12"

time -p $DTCX < datacount.cards >> $pgmout 2> errfile
RETC=$?

[ ! -s ${RUN}.${cycle}.status.tm00.bufr_d ] && RETC=99
[ ! -s obcount_30davg.${NET}.current ] && RETC=99

cat errfile >> $pgmout

if [ $RETC -eq 0 -o $RETC -eq 4 -o $RETC -eq 5 -o $RETC -eq 6 ]; then


# -------------------------------------------------------------
# Generate updated status file and post results to job log file
# -------------------------------------------------------------

   msg="bufr_datacount COMPLETED NORMALLY WITH CONDITION CODE $RETC "
   postmsg "$jlogfile" "$msg"
   [ $SENDCOM = YES ]  && cp updated.status.tm00.bufr_d  \
                           $COMOUT/${RUN}.${cycle}.updated.status.tm00.bufr_d

#  --> after NAMv4 impl. it makes sense to add $tmmark to end of below filename
#      (eventually retain new form of filename and delete old form of filename
#       which is still created further down in script)
##### echo "Alert File For $cycle_uc $NET_uc On $PDY" > $ALERTL/${NET}.${cycle}
   echo "Alert File For $tmmark_uc $cycle_uc $NET_uc On $PDY" > \
    $ALERTL/${NET}.${cycle}.$tmmark
   echo " " >> $ALERTL/${NET}.${cycle}.$tmmark
   echo "Comparison of Data Counts for This Run vs. Current 30-Day Avg. Data \
Counts" >> $ALERTL/${NET}.${cycle}.$tmmark
   echo "--------------------------------------------------------------------\
------" >> $ALERTL/${NET}.${cycle}.$tmmark
   echo " " >> $ALERTL/${NET}.${cycle}.$tmmark

   if [ $RETC -eq 4 -o $RETC -eq 5  -o  $RETC -eq 6 ]; then
      nindx=`wc deficient  | awk '{ print $1 }'`
      mindx=0
      until [ "$mindx" -eq "$nindx" ]
      do
         mindx=`expr $mindx + 1`
         msg=`head -n${mindx} deficient | tail -n1`
         postmsg "$jlogfile" "$msg"
      done

# -------------------------------------------------------
# Also post alerts to alert log file if r.c. is 4, 5 or 6
# -------------------------------------------------------

      cat deficient >> $ALERTL/${NET}.${cycle}.$tmmark
      msg="DATACOUNT low -- SDM should check ALERTLOG messages"
      postmsg "$jlogfile" "$msg"
   else
      echo "There are no low data count alerts for today." >> \
       $ALERTL/${NET}.${cycle}.$tmmark
      RETC=0
   fi

   if [ -s excessive ]; then
      nindx=`wc excessive  | awk '{ print $1 }'`
      mindx=0
      until [ "$mindx" -eq "$nindx" ]
      do
         mindx=`expr $mindx + 1`
         msg=`head -n${mindx} excessive | tail -n1`
         postmsg "$jlogfile" "$msg"
      done
   fi

#  --> for now copy new form of filename to old form,
#      but eventually delete this line
   cp -p  $ALERTL/${NET}.${cycle}.$tmmark $ALERTL/${NET}.${cycle}

# ------------------------------------------------------------------
#  Post long term alerts to alert log file (but not to job log file)
# ------------------------------------------------------------------

   kflag=0
   for months_ago in 03 06 09 12; do
      echo " "
#  --> after NAMv4 impl. it makes sense to add $tmmark to end of below filename
#      (eventually retain new form of filename and delete old form of filename
#       which is still created further down in script)
##### echo "Alert File For $cycle_uc $NET_uc" On $PDY > \
#####  $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}
      echo "Alert File For $tmmark_uc $cycle_uc $NET_uc" On $PDY > \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
      echo " " >> \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
      echo "Current 30-Day Avg. Data Counts vs. 30-Day Avg. Data Counts From \
$months_ago Months Ago" >> \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
      echo "-----------------------------------------------------------------\
-------------" >> \
      $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
      echo " " >> \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark

      if [ -s trend_m${months_ago} ]; then
         cat trend_m${months_ago} >> \
          $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
         if [ $kflag -eq 0 ]; then
            msg="one or more DATACOUNT trends high or low -- SDM should check \
ALERTLOG messages"
            postmsg "$jlogfile" "$msg"
            kflag=1
         fi
      else
         echo "There are no high or low data count alerts for today." \
          >> $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
      fi
      echo " " >> \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark
      echo "##################################################################\
#############" >> \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark

#  --> for now copy new form of filename to old form,
#      but eventually delete this line
      cp -p $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}.$tmmark \
       $ALERTL/trend_vs_${months_ago}months_ago.${NET}.${cycle}

   done

   if test "$SENDSDM" = 'YES'; then


# ---------------------------------------------
# E-mail the updated status file to the SDM
# ---------------------------------------------

      text=$COMOUT/${RUN}.${cycle}.updated.status.tm00.bufr_d
      MODEL=$(echo $RUN | tr [a-z] [A-Z])
      cat ${text} | mail.py -s "${cyc}Z ${MODEL} Updated Data Dump File" sdm@noaa.gov
      echo `hostname` 

   fi
else
      msg="bufr_datacount TERMINATED ABNORMALLY WITH C. CODE $RETC --> \
non-fatal (RETC set to 0, no alerts generated)"
      postmsg "$jlogfile" "$msg"
      RETC=0
fi


# ---------------------------------------------------
# Store return code in appropriate $COMROOT directory
# ---------------------------------------------------

#  --> after NAMv4 impl. it makes sense to add $tmmark to end of below filename
#      (eventually transition JDUMP_ALERT to read new form of filename and
#       delete old form of filename)
echo $RETC > $COMOUT/${RUN}.${cycle}.dump_alert_flag
echo $RETC > $COMOUT/${RUN}.${cycle}.dump_alert_flag.$tmmark


# ---------------------
# Release alert via ecf
# ---------------------

cyc=`echo $cycle | cut -c2-3`
[ $SENDECF = YES ] && ecflow_client --event release_${RUN}${cyc}_dump_alert

#!/bin/ksh
# Run under ksh (converted to WCOSS)


# This script performs VAD wind complex quality control checking
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# --------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - ncep production date (YYYYMMDDHH)

# Imported variables that must be passed in:
#   DATA  - path to working directory
#   VQCX  - path to PREPOBS_CQCVAD program executable

# Imported variables that can be passed in:
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1;fi
CDATE10=$2

set +x
cat <<\EOFc > cqcvad05
 &NAMLST
   HONOR_FLAGS=TRUE,  ! If TRUE then levels with bad q.m. flags are honored
   PRINT_52=TRUE,     ! If TRUE then writes bird quality control information
                      !  to unit 52
   PRINT_53=FALSE,    ! If TRUE then writes a final report listing with q.c.
                      !  information to unit 53
   PRINT_60=FALSE,    ! If TRUE then writes event information to unit 60
   TEST=FALSE         ! If TRUE then writes diagnostic print to stdout (unit 06)
 /
EOFc
set -x

rm $PRPI.cqcvad

pgm=`basename  $VQCX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

export FORT11=$PRPI
echo "$CDATE10"      > cdate10.dat
export FORT14=cdate10.dat
export FORT51=$PRPI.cqcvad
export FORT52=cqcvad.birdqc
export FORT53=cqcvad.unit53.wrk
export FORT55=cqcvad.unit55.wrk
export FORT60=cqcvad.unit60.wrk
TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
$TIMEIT $VQCX < cqcvad05 > outout 2> errfile
err=$?
###cat errfile
cat errfile >> outout
cat outout >> cqcvad.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for PREPOBS_CQCVAD is ' $err
echo
set -x
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.cqcvad $PRPI
fi

exit 0

#!/bin/bash

####  UNIX Script Documentation Block
#
# Script name:   download_fix.sh    Script for downloading binary fix files
#
# Author:        R. Mahajan         Org: NCEP/EMC       Date: 2021-10-21
#
# Abstract: This script downloads the binary fix files that used to be a part of the
# VLab repository.
# The downloaded files are:
#   prepobs_landc
#   syndat_syndata.slmask.t126.gaussian
#
# These files are currently hosted on the EMC FTP server at:
#    https://ftp.emc.ncep.noaa.gov/static_files/public/obsproc/obsproc-fix-HASH.tgz
#
# HASH is the truncated 6 character sha256sum hash of the tar file and can be obtained as:
# $> sha256sum obsproc-fix.tgz
#     1dd0bbaf7ab7452de9eb5949595540b20abc4e59439567a87c0b007de90fab3c
#
# The data can be downloaded manually and into the cloned
# repository by executing this script from the root of the cloned directory
# e.g.
# $> pwd
#     /path/to/obsproc
# $> ls -1
#    fix
#    modulefiles
#    sorc
#    ush
# $> ./ush/download_fix.sh
#
# Usage: ./ush/download_fix.sh [yes|no]
#    Script parameters:
#      yes|no - Force download of fix files to overwrite previous download [Default: NO]
#
####

set -eu

# Force option to overwrite fix binary files from a previous download
force=${1:-"NO"}

URL="https://ftp.emc.ncep.noaa.gov/static_files/public/obsproc"
SHA="1dd0bbaf7ab7452de9eb5949595540b20abc4e59439567a87c0b007de90fab3c"
SHORTSHA=$(echo $SHA | cut -c1-6)
TAR="obsproc-fix-${SHORTSHA}.tgz" # poor-man's version control

# fix files to download (contents of the $TAR should match)
fix_files=( \
  prepobs_landc \
  syndat_syndata.slmask.t126.gaussian \
)

# Toggle download if any of the fix files are not present
download=false
for file in ${fix_files[@]}; do
  if [[ ! -f fix/$file ]]; then
    echo -e "\nFix file $file not found in cloned repository!"
    download=true
    break
  fi
done

# Force download if desired
if [[ "$force" =~ [yYtY] ]]; then
  echo -e "\nUsing force to fresh download of fix files"
  download=true
fi

if $download; then
  echo -e "\nDownloading $TAR from $URL"
  rm -f $TAR
  wget -q $URL/$TAR
  SHA256=$(sha256sum $TAR 2>/dev/null | awk '{print $1}')
  if [[ ! "$SHA256" == "$SHA" ]]; then
    echo -e "\nIncorrect checksum, ABORT!"
    exit 1
  fi
  tar xzf $TAR
  rm -f $TAR
else
  echo -e "\nFix files present in the cloned repository. Nothing to download!\n"
fi

#!/bin/ksh
export PS4=' + data_check.sh line $LINENO: '
set -x

####################################
# Specify Timeout Behavior for TC Track calculations
# SLEEP_TIME - Amount of time to wait for a input-data file before exiting
# SLEEP_INT  - Amount of time to wait between checking for input-data file
####################################
export SLEEP_TIME=3600
export SLEEP_INT=60
SLEEP_LOOP_MAX=`expr $SLEEP_TIME / $SLEEP_INT`

if [ ${cmodel} = 'gfs' ]; then
  #datdir=${gfsdir:-${COMROOT}/gfs/prod/gfs.${PDY}}
  datdir=${gfsdir}
  leadhour=240
  datfile=gfs.t${cyc}z.pgrb2.0p25.f${leadhour}       

elif [ ${cmodel} = "ens" ]; then
  #datdir=${ensdir:-${COMROOT}/gens/prod/gefs.${PDY}/$cyc/pgrb2ap5}
  datdir=$ensdira
  leadhour=240
  datfile=gep20.t${cyc}z.pgrb2a.0p50.f${leadhour} 

elif [ ${cmodel} = "cmc" ]; then
  #datdir=${cmcdir:-${DCOMROOT}/us007003/${PDY}/wgrbbul/cmc}
  datdir=$DCOM
  leadhour=240
#  datfile=glb_${cyc}_${leadhour}
  datfile=CMC_glb_latlon.24x.24_${PDY}${cyc}_P${leadhour}_NCEP.grib2

elif [ ${cmodel} = "cens" ]; then
  #datdir=${ccedir:-${COMROOT}/gens/prod/cmce.${PDY}/${cyc}/pgrb2a}
  datdir=$ccedir
  leadhour=240
#  datfile=cmc_gep20.t${cyc}z.pgrb2af${leadhour}
  datfile=${PDY}${cyc}_CMC_naefs_hr_latlon0p5x0p5_P${leadhour}_020.grib2

elif [ ${cmodel} = "ngps" ]; then
  #datdir=${ngpsdir:-${COMROOT}/fnmoc/prod/navgem.${PDY}}
  datdir=$DCOM
  leadhour=180
#  datfile=navgem_${PDY}${cyc}f${leadhour}.grib2
  datfile=US058GMET-OPSbd2.NAVGEM${leadhour}-${PDY}${cyc}-NOAA-halfdeg.gr2

elif [ ${cmodel} = "fens" ]; then
  #datdir=${fensdir:-${DCOMROOT}/us007003/${PDY}/wgrbbul/fnmocens_gb2}
  datdir=$DCOM
  leadhour=240
  datfile=ENSEMBLE.MET.fcst_et020.${leadhour}.${PDY}${cyc}

elif [ ${cmodel} = "ecmwf" ]; then
  #datdir=${ecmwfdir:-${DCOMROOT}/us007003/${PDY}/wgrbbul/ecmwf}
  datdir=$DCOM
  leadhour=240
  immddhh=`echo ${PDY}${cyc}| cut -c5-`
  fmmddhh=` ${NDATE:?} ${leadhour} ${PDY}${cyc} | cut -c5- `
  #datfile=ecens_DCD${immddhh}00${fmmddhh}001 # Original
  if [ ${fmmddhh} -eq ${immddhh} ]; then
    datfile=U1D${immddhh}00${fmmddhh}011
  else
    datfile=U1D${immddhh}00${fmmddhh}001
  fi

elif [ ${cmodel} = "eens" ]; then
  #datdir=${eensdcom:-${DCOMROOT}/us007003/${PDY}/wgrbbul/ecmwf}
  datdir=$DCOM
  mm=` echo ${PDY} | cut -c5-6 `
  dd=` echo ${PDY} | cut -c7-8 `
  imdh=${mm}${dd}${cyc}
  ymdh=${PDY}${cyc}
  leadhour=240
  vymdh=` ${NDATE:?} ${leadhour} ${ymdh}`
  vmdh=`  echo ${vymdh} | cut -c5-10`
  #datfile=ecens_DCE${imdh}00${vmdh}001
  datfile=DCE${imdh}00${vmdh}001

elif [ ${cmodel} = "ukmet" ]; then
  datdir=${ukmetdcom}
  leadhour=144
  datfile=GAB${cyc}PPA.GRB

fi

ic=0
while [ $ic -lt $SLEEP_LOOP_MAX ]; do
  echo "Check for the existence of ${datdir}/${datfile}"
  if [ -s ${datdir}/${datfile} ]; then
    echo " !!! ${datdir}/${datfile} found after waiting $ic minutes"
    break
  else
    sleep $SLEEP_INT
  fi
  ic=`expr $ic + 1`
###############################
# After we wait for 30 minutes, no data is available, Job will be quit. 
###############################
  if [ $ic -eq $SLEEP_LOOP_MAX ]; then
    msg="FATAL ERROR: missing data ${datdir}/${datfile}"
    >&2 echo "$msg"; postmsg "$jlogfile" "$msg"
    if [ "$DCOM_STATUS" = "data of opportunity" ]; then
      mail.py <<ENDMSG
One or more input data files are missing, including
${datdir}/${datfile}

Exiting $0...
ENDMSG
      exit 6
    else
      err_exit "data_check.sh: ${datdir}/${datfile} is missing"
    fi
  fi
done

#!/bin/ksh
export PS4=' + data_check_ukmet.sh line $LINENO: '
set -x

####################################
#------ data checking for each hour--------------------------
export filelist="AAT BBT CCT DDT EET FFT GGT HHT IIT JJT KKT \
                 QQT LLT TTT MMT UUT NNT VVT OOT 11T PPA 22T"
for nfile in $filelist; do

  ifile=${ukmetdcom}/GAB${cyc}${nfile}.GRB
  echo "ifile = $ifile"

  let attempts=1
  while [ $attempts -le 30 ]; do
     if [ -s $ifile ]; then
        break
     else
        sleep 60
        let attempts=attempts+1
     fi
  done
  if [ $attempts -gt 30 ] && [ ! -s $ifile ]; then
     set +x; echo " "
     echo "FATAL ERROR:  $ifile still not available after waiting 30 minutes... exiting"
     echo " "; set -x
     err_exit
  fi
done

#!/bin/bash
set -xeua
if [ $# -ne 5 ] ; then
  echo "Usage: $0 date (yyyymmddhh) prepqm outdir prtdir typ"
  exit 1
fi

export HOMEcfs=${HOMEcfs:-/nwprod}
export USHcfs=${USHcfs:-$HOMEcfs/ush}

export date=$1
export prepqm=$2
export outdir=$3
export prtdir=$4
export typ=$5

export infile=$prepqm


##  iall=0 gives only obs value and quality mark
##  iall=1 gives only obs,anl,ges and quality mark
export iall=1

export idbug=0
export idbuga=0

export flonw=0.0
export flone=360.0
export flats=-90.0
export flatn=90.0

yyyy=`echo $date | cut -c1-4`
yy=`echo $date | cut -c3-4`
mm=`echo $date | cut -c5-6`
mon=`$USHcfs/cfs_cmon.sh $mm`
dd=`echo $date | cut -c7-8`
hh=`echo $date | cut -c9-10`
odate=$yy$mm$dd$hh

cd $outdir

for name in ADPSFC SFCSHP ADPUPA AIRCFT AIRCAR
do

export catname=$name
export oname=` echo $catname| tr "[A-Z]" "[a-z]" `

#####################################################################
#                  ADPSFC
#####################################################################
if [ $catname = "ADPSFC" ] ; then
nst=50000

export imas=1
export iwnd=0
export sfc=1
for hr in 0
do
export fchr=$hr
export fdhr=0.5
export dtg=`$EXECcfs/ndate.x $hr $date`
$USHcfs/cfs_horizn.sh $oname $nst $iall $imas $iwnd $fchr $fdhr $dtg $sfc
done
fi

#####################################################################
#                  SFCSHP
#####################################################################
if [ $catname = "SFCSHP" ] ; then
export nst=50000
export imas=1
export iwnd=1
export sfc=1
for hr in 0
do
export fchr=$hr
export fdhr=0.5
export dtg=`$EXECcfs/ndate.x $hr $date`
$USHcfs/cfs_horizn.sh $oname $nst $iall $imas $iwnd $fchr $fdhr $dtg $sfc
done
fi

#####################################################################
#                  ADPUPA
#####################################################################
if [ $catname = "ADPUPA" ] ; then
export imas=1
export iwnd=1
export sfc=2
##   mandatory level data...
export nst=50000
export iprs=1
export ilev=21
export itol=0
for hr in 0
do
export fchr=$hr
export fdhr=4.0
export dtg=`$EXECcfs/ndate.x $hr $date`
$USHcfs/cfs_horizn.sh $oname $nst $iall $imas $iwnd $fchr $fdhr $dtg $sfc
done
fi

#####################################################################
#                  AIRCFT
#####################################################################
if [ $catname = "AIRCFT" ] ; then
export nst=50000
export imas=1
export iwnd=1
export sfc=3
for hr in 0
do
export fchr=$hr
export fdhr=4.0
export dtg=`$EXECcfs/ndate.x $hr $date`
$USHcfs/cfs_horizn.sh $oname $nst $iall $imas $iwnd $fchr $fdhr $dtg $sfc
done
fi

#####################################################################
#                  AIRCAR
#####################################################################
if [ $catname = "AIRCAR" ] ; then
export nst=50000
export imas=1
export iwnd=1
export sfc=3
for hr in 0
do
export fchr=$hr
export fdhr=4.0
export dtg=`$EXECcfs/ndate.x $hr $date`
$USHcfs/cfs_horizn.sh $oname $nst $iall $imas $iwnd $fchr $fdhr $dtg $sfc
done
fi

#####################################################################
##  close catname-loop
done

#!/bin/ksh
export PS4=' + ens_trak_ave_2d.sh line $LINENO: '

set +x
##############################################################################
echo " "
echo "-----------------------------------------------------"
echo " +++ - Compute ensemble mean cyclone forecast track"
echo "-----------------------------------------------------"
echo "History: Jul 2005 - Marchok - First implementation of this new script."
echo " "
echo "                    In the event of a crash, you can contact Tim "
echo "                    Marchok at GFDL at (609) 452-6534 or "
echo "                    via email at timothy.marchok@noaa.gov"
echo " "
echo " "
echo "Current time is: `date`"
echo " "
##############################################################################
set -x

########################################
msg="has begun for ${cmodel} at ${cyc}z"
postmsg "$jlogfile" "$msg"
########################################

# This script computes ensemble mean cyclone tracks.  It dumps all
# the cyclone tracks for a given ensemble forecast into one file,
# then runs a fortran program to compute the ensemble mean, spread
# and mode.  In addition, strike probabilities are produced for
# any storms in the Atlantic, EastPac and WestPac basins. 
#
# Environmental variable inputs needed for this scripts:
#  PDY   -- The date for data being processed, in YYYYMMDD format
#  cycle -- The cycle for data being processed (t00z, t06z, t12z, t18z)
#  cmodel -- Model being processed: ens (ncep ensemble), cens (CMC ensemble),
#                                   ece (ECMWF ensemble).
#  envir -- 'prod' or 'test'
#  SENDCOM -- 'YES' or 'NO'
#
# For testing script interactively in non-production, set following vars:
#
#-------J.Peng---2010-09-27-------------------------
#export PDY=$1
#export cyc=$2
#export cmodel=$3
#export DATA=$4

export jlogfile=${DATA}/log_file_mean
export pgmout=${DATA}/pgm_out_mean

ymdh=${PDY}${cyc}

if [ ! -d $DATA ]
then
   mkdir -p $DATA
fi
cd $DATA

case ${cmodel} in

   ens) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ NCEP ensemble tracks will be averaged...."   ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="AEMN"                                          ;
        amodel="aemn"                                          ;
        achar="a"                                              ;;

   fens) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ FNMOC ensemble tracks will be averaged...."  ;
        echo " "                                               ;
        set -x                                                 ;
#        AMODEL="FEMN"                                          ;
#        amodel="femn"                                          ;
#        achar="f"                                              ;;
        AMODEL="NEMN"                                          ;
        amodel="nemn"                                          ;
        achar="n"                                              ;;

  cens) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ CMC ensemble tracks will be averaged...."    ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="CEMN"                                          ;
        amodel="cemn"                                          ;
        achar="c"                                              ;;

  ukes) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ UKMET ensemble tracks will be averaged...."  ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="UKMN"                                          ;
        amodel="ukmn"                                          ;
        achar="u"                                              ;;

   eens) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF ensemble tracks will be averaged...."  ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="EEMN"                                          ;
        amodel="eemn"                                          ;
        achar="e"                                              ;;

   g2c) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ NCEP+CMC ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="2EMN"                                          ;
        amodel="2emn"                                          ;
        achar="A"                                              ;;

   gce4) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF+NCEP+CMC+FNMOC ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="4EMN"                                          ;
        amodel="4emn"                                          ;
        achar="A"                                              ;;

   gce5) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF+NCEP+CMC+FNMOC+UK ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="5EMN"                                          ;
        amodel="5emn"                                          ;
        achar="A"                                              ;;

   neu3) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF+NCEP+UK ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="3NEU"                                          ;
        amodel="3neu"                                          ;
        achar="A"                                              ;;

   ncf3) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ NCEP+CMC+FNMOC ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="3NCF"                                          ;
        amodel="3ncf"                                          ;
        achar="A"                                              ;;

   gce3) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF+NCEP+CMC ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="3EMN"                                          ;
        amodel="3emn"                                          ;
        achar="A"                                              ;;

   nae2) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF+NCEP ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="2NAE"                                          ;
        amodel="2nae"                                          ;
        achar="A"                                              ;;

   gce3a) set +x                                               ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ eemn+2EMN ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="SEMN"                                          ;
        amodel="semn"                                          ;
        achar="A"                                              ;;

   gce3b) set +x                                               ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ eemn+cemn+aemn ensemble tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="PEMN"                                          ;
        amodel="pemn"                                          ;
        achar="A"                                              ;;

   sing) set +x                                                ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ AVNO+EMX+CMC tracks will be averaged...."    ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="3DET"                                          ;
        amodel="3det"                                          ;
        achar="A"                                              ;;

  tot6) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ AVNO+EMX+CMC+AEMN+CEMN+EEMN tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="6EMN"                                          ;
        amodel="6emn"                                          ;
        achar="A"                                              ;;

  totw) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ AVNO+EMX+CMC+AEMN+CEMN+EEMN tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="6EMW"                                          ;
        amodel="6emw"                                          ;
        achar="A"                                              ;;

  tot4) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ AVNO+EMX+CMC+3EMN tracks will be averaged....";
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="T4MN"                                          ;
        amodel="t4mn"                                          ;
        achar="A"                                              ;;

  tot2) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ 3EMN+3DET tracks will be averaged...."       ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="S6MN"                                          ;
        amodel="s6mn"                                          ;
        achar="A"                                              ;;

  sref) set +x                                                 ;
        echo " "                                               ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ SREF ensemble tracks will be averaged...."   ;
        echo " "                                               ;
        set -x                                                 ;
        AMODEL="SFMN"                                          ;
        amodel="sfmn"                                          ;
        achar="s"                                              ;;

     *) set +x                                                 ;
        echo " "                                               ;
        echo "FATAL ERROR: INPUT CMODEL PARAMETER IS NOT RECOGNIZED.";
        echo " !! Input cmodel parameter = ${cmodel}...."      ;
        echo " "                                               ;
        set -x                                                 ;
        err_exit "FAILED ${jobid} -- UNKNOWN cmodel IN TRACK-AVERAGING SCRIPT - ABNORMAL EXIT";;

esac

#---------------------------------------------------
# Run the program that calculates the ensemble mean
# track and generates the probability files....
#---------------------------------------------------

echo "TIMING: Time before any of the track-averaging stuff is `date`"

>trak.allperts.atcfunix.${amodel}.${ymdh}

# for tfile in `ls -1 ${COMOUT}/${achar}[np]*.t${cyc}z.cyclone.trackatcfunix`
#------J.Peng----2010-10-28-----------------------
#for tfile in `ls -1 ${COMOUT}/${achar}[np]*.t${cyc}z.cyclone.trackatcfunix`
#for tfile in `ls -1 ${COMOUT}/trak.${achar}P??.atcfunix.${PDY}${cyc}`

#----J.Peng-----2010-10-29----and 2010-11-02 ---------------------
if [ ${cmodel} = "g2c" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done
elif [ ${cmodel} = "gce4" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "gce5" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "neu3" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "ncf3" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "gce3a" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "gce3b" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "sing" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done
elif [ ${cmodel} = "tot6" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "totw" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "tot4" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "tot2" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "fens" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "fenb" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "ensb" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "cenb" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "eens" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done
elif [ ${cmodel} = "ens" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done
elif [ ${cmodel} = "cens" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "ukes" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.uk[012]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "sref" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[aenr]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "gce3" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.[ace][np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

elif [ ${cmodel} = "nae2" ]; then
  for tfile in `ls -1 ${COMOUT}/trak.[ae][np]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done

else
  for tfile in `ls -1 ${COMOUT}/trak.${achar}[NP]*.atcfunix.${PDY}${cyc}`
  do
    cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
  done
fi

####J.Peng 2012-02-28 filtering weak storms for TC genesis #####
#### Vmax>=19kts  SLP<=1010mb ####################################
#  ln -s -f ${DATA}/trak.allperts.atcfunix.${amodel}.${ymdh}     fort.41
#  ln -s -f ${DATA}/trak.allperts.atcfunix.${amodel}.${ymdh}.tcgen fort.42
#/ensemble/save/Jiayi.Peng/huprob/ens_trak_ave.fd/filter/filter

numrecs=` cat trak.allperts.atcfunix.${amodel}.${ymdh} | wc -l`
if [ ${numrecs} -eq 0 ]; then
  msg="No member tracks exist for ${ymdh}"
  echo "WARNING:  $msg"
  postmsg $jlogfile "$msg"
  exit 0
fi

for dt in 65
do

  set +x
  echo "TIMING: Time just before call to trakave for dt= $dt is `date`"
  set -x
  export pgm=ens_trak_ave_2d

  . prep_step

  # Input file
  export FORT11=${DATA}/trak.allperts.atcfunix.${amodel}.${ymdh}
  #ln -s -f ${DATA}/trak.allperts.atcfunix.${amodel}.${ymdh}.tcgen fort.11

  # Output files
  export FORT51=${DATA}/${amodel}.trkprob.${ymdh}.${dt}.ctlinfo.txt
  # Unit 52: Created internally, may be 1 to 15 files...
  export FORT53=${DATA}/trak.${amodel}.atcfunix.${ymdh}
  export FORT54=${DATA}/trak.${amodel}.atcf.${ymdh}
  export FORT55=${DATA}/trak.${amodel}.all.${ymdh}
  export FORT56=${DATA}/trak.${amodel}.spread.${ymdh}
  export FORT57=${DATA}/trak.${amodel}.mode.${ymdh}

#----J.Peng----2011-03-01-------------------------------------------
  #export FORT92=/hfip/noscrub/Jiayi.Peng/2010/super_new/weight/weight.dat

  namelist=${DATA}/input.${ymdh}.nlist
  echo "&datain dthresh=${dt}.0,cmodel='${cmodel}'/" >${namelist}

  ${EXECens_tracker}/ens_trak_ave_2d <${namelist} >${DATA}/ens_trak_ave_2d.${ymdh}.${dt}.fout
  ens_trak_ave_rcc=$?

  if [ ${ens_trak_ave_rcc} -ne 0 ]
  then
    set +x
    echo " "
    echo "FATAL ERROR:  An error occurred while running ens_trak_ave.x,"
    echo "!!! which is the program that computes the mean track."
    echo "!!! Return code from ens_trak_ave.x = ${ens_trak_ave_rcc}"
    echo "!!! model= ${amodel}, forecast initial time = ${PDY}${cyc}"
    echo " "
    set -x
    err_exit "FAILED ${jobid} - ERROR RUNNING ens_trak_ave_2d - ABNORMAL EXIT"
  fi

  set +x
  echo "TIMING: Time just after call to trakave for dt= $dt is `date`"
  set -x

done

set +x
echo "TIMING: Time after loop to get mean & probabilities for $ymdh is `date`"
set -x

#-----------------------------------------------------
# Parse out the atcfunix records and send them to the
# correct tpcprd directory and file.

if [ "$SENDCOM" = 'YES' ]; then

  cp ${DATA}/trak.${amodel}.* ${COMOUT}/
  ls ${DATA}/${amodel}.trkprob.* 1>/dev/null
  if [ $? -eq 0 ]; then
    cp ${DATA}/${amodel}.trkprob.* ${COMOUT}/
  fi

  #if [ "$SENDDBN" = 'YES' ]; then
  #  if [ $cmodel != 'eens' ]; then
  #    $DBNROOT/bin/dbn_alert MODEL ENS_GENESIS $job ${COMOUT}/trak.${amodel}.atcfunix.${ymdh}
  #  fi
  #fi  

fi

#!/bin/ksh
export PS4=' + ens_trak_ave.sh line $LINENO: '

set +x
##############################################################################
echo " "
echo "-----------------------------------------------------"
echo " +++ - Compute ensemble mean cyclone forecast track"
echo "-----------------------------------------------------"
echo "History: Jul 2005 - Marchok - First implementation of this new script."
echo " "
echo "                    In the event of a crash, you can contact Tim "
echo "                    Marchok at GFDL at (609) 452-6534 or "
echo "                    via email at timothy.marchok@noaa.gov"
echo " "
echo " "
echo "Current time is: `date`"
echo " "
##############################################################################
set -x

########################################
msg="has begun for ${cmodel} at ${cyc}z"
postmsg "$jlogfile" "$msg"
########################################

# This script computes ensemble mean cyclone tracks.  It dumps all
# the cyclone tracks for a given ensemble forecast into one file,
# then runs a fortran program to compute the ensemble mean, spread
# and mode.  In addition, strike probabilities are produced for
# any storms in the Atlantic, EastPac and WestPac basins. 
#
# Environmental variable inputs needed for this scripts:
#  PDY   -- The date for data being processed, in YYYYMMDD format
#  cycle -- The cycle for data being processed (t00z, t06z, t12z, t18z)
#  cmodel -- Model being processed: ens (ncep ensemble), cens (CMC ensemble),
#                                   ece (ECMWF ensemble).
#  envir -- 'prod' or 'test'
#  SENDCOM -- 'YES' or 'NO'
#
# For testing script interactively in non-production, set following vars:
#     gltrkdir   - Directory for output tracks
#

yy=`echo ${PDY} | cut -c3-4`
syyyy=`echo ${PDY} | cut -c1-4`
ymdh=${PDY}${cyc}

#export COMOUTatcf=${COMOUTatcf:-${COMROOT}/nhc/${envir}/atcf}
#export gltrkdir=${gltrkdir:-${COMROOT}/hur/${envir}/global}
gltrkdir=${gltrkdir:-${COMOUThur:?}}

cd $DATA

case ${cmodel} in

   ens) set +x; echo " "                                       ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ NCEP ensemble tracks will be averaged...."   ;
        echo " "; set -x                                       ;
        AMODEL="AEMN"                                          ;
        amodel="aemn"                                          ;
        achar="a"                                              ;;
        #COMOUT=${COM:-${COMROOT}/gens/${envir}/gefs.${PDY}/${cyc}/track}
 
   eens) set +x; echo " "                                      ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ ECMWF ensemble tracks will be averaged...."  ;
        echo " "; set -x                                       ;
        AMODEL="EEMN"                                          ;
        amodel="eemn"                                          ;
        achar="e"                                              ;;
        #COMOUT=${COM:-${COMROOT}/gens/${envir}/ecme.${PDY}/${cyc}/track}
 
  cens) set +x; echo " "                                       ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ CMC ensemble tracks will be averaged...."    ;
        echo " "; set -x                                       ;
        AMODEL="CEMN"                                          ;
        amodel="cemn"                                          ;
        achar="c"                                              ;;
        #COMOUT=${COM:-${COMROOT}/gens/prod/cmce.${PDY}/${cyc}/track}

  fens) set +x; echo " "                                       ;
	    echo " ++ Input cmodel parameter = ${cmodel}...."      ;
	    echo " ++ FNMOC ensemble tracks will be averaged...."  ;
        echo " "; set -x                                       ;
#           AMODEL="FEMN"                                          ;
#	    amodel="femn"                                          ;
#           achar="f"                                              ;;
            AMODEL="NEMN"                                          ;
            amodel="nemn"                                          ;
            achar="n"                                              ;;
	    #COMOUT=${COM:-${COMROOT}/gens/prod/fens.${PDY}/${cyc}/track}

  sref) set +x; echo " "                                       ;
        echo " ++ Input cmodel parameter = ${cmodel}...."      ;
        echo " ++ SREF ensemble tracks will be averaged...."   ;
        echo " "; set -x                                       ;
        AMODEL="SRMN"                                          ;
        amodel="srmn"                                          ;
        achar="s"                                              ;;
        #COMOUT=${COM:-${COMROOT}/sref/${envir}/sref.${PDY}/${cyc}/track}

     *) set +x; echo " "                                       ;
        echo "FATAL ERROR:  INPUT CMODEL PARAMETER IS NOT RECOGNIZED.";
        echo " !! Input cmodel parameter = ${cmodel}...."      ;
        echo " "                                               ;
        set -x                                                 ;
        err_exit "FAILED ${jobid} -- UNKNOWN cmodel IN TRACK-AVERAGING SCRIPT - ABNORMAL EXIT";;

esac

#---------------------------------------------------
# Run the program that calculates the ensemble mean
# track and generates the probability files....
#---------------------------------------------------

echo "TIMING: Time before any of the track-averaging stuff is `date`"

>trak.allperts.atcfunix.${amodel}.${ymdh}

for tfile in `ls -1 ${COMOUT}/${achar}[np]*.t${cyc}z.cyclone.trackatcfunix`
do
  cat $tfile >>trak.allperts.atcfunix.${amodel}.${ymdh}
done

numrecs=` cat trak.allperts.atcfunix.${amodel}.${ymdh} | wc -l`
if [ ${numrecs} -eq 0 ]; then
  msg="No member tracks exist for ${ymdh}"
  echo "WARNING:  $msg"
  postmsg $jlogfile "$msg"
  exit 0
fi

for dt in 65
do

  echo "TIMING: Time just before call to trakave for dt= $dt is `date`"
  export pgm=ens_trak_ave
  . prep_step

  # Input file
  export FORT11=${DATA}/trak.allperts.atcfunix.${amodel}.${ymdh}

  # Output files
  export FORT51=${DATA}/${amodel}.trkprob.${ymdh}.${dt}.ctlinfo.txt
  # Unit 52: Created internally, may be 1 to 15 files...
  export FORT53=${DATA}/trak.${amodel}.atcfunix.${ymdh}
  export FORT54=${DATA}/trak.${amodel}.atcf.${ymdh}
  export FORT55=${DATA}/trak.${amodel}.all.${ymdh}
  export FORT56=${DATA}/trak.${amodel}.spread.${ymdh}
  export FORT57=${DATA}/trak.${amodel}.mode.${ymdh}

  namelist=${DATA}/input.${ymdh}.nlist
  echo "&datain dthresh=${dt}.0,cmodel='${cmodel}'/" >${namelist}

  ${EXECens_tracker}/ens_trak_ave <${namelist} >${DATA}/ens_trak_ave.${ymdh}.${dt}.fout
  ens_trak_ave_rcc=$?

  if [ ${ens_trak_ave_rcc} -ne 0 ]
  then
    set +x
    echo " "
    echo "FATAL ERROR:  An error occurred while running ens_trak_ave.x,"
    echo "!!! which is the program that computes the mean track."
    echo "!!! Return code from ens_trak_ave.x = ${ens_trak_ave_rcc}"
    echo "!!! model= ${amodel}, forecast initial time = ${PDY}${cyc}"
    echo " "
    set -x
    err_exit "FAILED ${jobid} - ERROR RUNNING ens_trak_ave - ABNORMAL EXIT"
  fi

  set +x
  echo "TIMING: Time just after call to trakave for dt= $dt is  `date`"
  set -x

done

set +x
echo "TIMING: Time after loop to get mean & probabilities for $ymdh is `date`"
set -x


#-----------------------------------------------------
# Parse out the atcfunix records and send them to the
# correct storm trackers directory and file.

if [ "$SENDCOM" = 'YES' ]
then

  glatuxarch=${glatuxarch:-${gltrkdir}/tracks.atcfunix.${yy}}
  cat ${DATA}/trak.${amodel}.atcfunix.${ymdh}           >>${glatuxarch}

  glmodearch=${glmodearch:-${gltrkdir}/tracks.ens_mode.atcfunix.${yy}}
  cat ${DATA}/trak.${amodel}.mode.${ymdh}               >>${glmodearch}

# 03/03/2017  to remove STD from track file, requested by NHC ---------
  if [ -s ${DATA}/trak.${amodel}.atcfunix.${ymdh} ]; then
    cat ${DATA}/trak.${amodel}.atcfunix.${ymdh}|cut -c1-95 > ${DATA}/short.${amodel}.atcfunix.${ymdh}
    cp ${DATA}/trak.${amodel}.atcfunix.${ymdh} ${DATA}/long.${amodel}.atcfunix.${ymdh}
    cp ${DATA}/short.${amodel}.atcfunix.${ymdh} ${DATA}/trak.${amodel}.atcfunix.${ymdh}
  fi
  cp ${DATA}/long.${amodel}.atcfunix.${ymdh} ${COMOUT}/${amodel}.t${cyc}z.cyclone.trackstd

  cp ${DATA}/trak.${amodel}.atcfunix.${ymdh} ${COMOUT}/${amodel}.t${cyc}z.cyclone.trackatcfunix
  cp ${DATA}/trak.${amodel}.spread.${ymdh}   ${COMOUT}/${amodel}.t${cyc}z.cyclone.trackspread
  cp ${DATA}/trak.${amodel}.mode.${ymdh}     ${COMOUT}/${amodel}.t${cyc}z.cyclone.trackmode
  cp ${DATA}/${amodel}.trkprob.*${ymdh}*.ieee             ${COMOUT}/
  cp ${DATA}/${amodel}.trkprob.${ymdh}.${dt}.ctlinfo.txt  ${COMOUT}/

  if [ "$SENDDBN" = 'YES' ]
  then
    if [ $cmodel != 'eens' ]
    then
      $DBNROOT/bin/dbn_alert MODEL ENS_TRACKER $job ${COMOUT}/${amodel}.t${cyc}z.cyclone.trackatcfunix
    fi
  fi

  # We need to parse apart the atcfunix file and distribute the forecasts to
  # the necessary directories.  To do this, first sort the atcfunix records
  # by forecast hour (k6), then sort again by ocean basin (k1), storm number (k2)
  # and then quadrant radii wind threshold (k12).  Once you've got that organized
  # file, break the file up by putting all the forecast records for each storm
  # into a separate file.  Then, for each file, find the corresponding atcfunix
  # file in the storm trackers directory and dump the atcfunix records for that storm
  # in there.

  auxfile=${DATA}/trak.${amodel}.atcfunix.${PDY}${cyc}
  sort -k6 ${auxfile} | sort -k1 -k2 -k12  >atcfunix.sorted

  old_string="XX, XX"

  ict=0
  while read unixrec
  do
    storm_string=` echo "${unixrec}" | cut -c1-6`
    if [ "${storm_string}" = "${old_string}" ]
    then
      echo "${unixrec}" >>atcfunix_file.${ict}
    else
      let ict=ict+1
      echo "${unixrec}"  >atcfunix_file.${ict}
      old_string="${storm_string}"
    fi
  done <atcfunix.sorted

  nhcct=0
  if [ $ict -gt 0 ]
  then
    mct=0
    while [ $mct -lt $ict ]
    do
      let mct=mct+1
      at=` head -1 atcfunix_file.$mct | cut -c1-2 | tr '[A-Z]' '[a-z]'`
      NO=` head -1 atcfunix_file.$mct | cut -c5-6`
      if [ ! -d ${COMOUTatcf}/${at}${NO}${syyyy} ]
      then
          mkdir -p ${COMOUTatcf}/${at}${NO}${syyyy}
      fi
      cat atcfunix_file.$mct >>${COMOUTatcf}/${at}${NO}${syyyy}/ncep_a${at}${NO}${syyyy}.dat
      set +x
      echo " "
      echo "+++ Adding records to  TPC ATCFUNIX directory: ${COMOUTatcf}/${at}${NO}${syyyy}"
      echo " "
      set -x

      if [ $at = 'al' -o $at = 'ep' ]; then
        let nhcct=nhcct+1
      fi
    done
  fi

#  cat ${DATA}/ens_trak_ave.${ymdh}.${dt}.fout

fi

#!/bin/bash
if [ $# -ne 6 ] ; then
  echo "Usage: $0 CDATE (yyyymmddhh) PRPO COMOUT DATA fh1 fh2"
  exit 1
fi

set -xeua

export HOMEcfs=${HOMEcfs:-/nwprod}
export cfss=${cfss:-cfs}
export cfsp=${cfsp:-cfs_}
export EXECcfs=$HOMEcfs/exec

export CDATE=$1
export PRPO=$2
export COMOUT=$3
export DATA=$4
export fh1=$5
export fh2=$6

prfile=$DATA/fits.$CDATE
> $prfile

rm -f fort.*

list='raob sfc acft acar surf'
for sub in $list ; do
  ln -sf $PRPO             fort.11
  ln -sf f$fh1.$sub.$CDATE fort.51
  ln -sf f$fh2.$sub.$CDATE fort.52
  $EXECcfs/${cfsp}${sub}.x > $prfile.${sub}.f${fh1}_f${fh2}
  export err=$?; $DATA/err_chk
  mv f$fh1.$sub.$CDATE $COMOUT/.
  mv f$fh2.$sub.$CDATE $COMOUT/.

  if [ "$CHGRP_RSTPROD" = 'YES' ]; then
    chgrp rstprod $COMOUT/f$fh1.$sub.$CDATE
    chgrp rstprod $COMOUT/f$fh2.$sub.$CDATE
    chmod 640 $COMOUT/f$fh1.$sub.$CDATE
    chmod 640 $COMOUT/f$fh2.$sub.$CDATE
  fi
done

#!/bin/ksh
# exdump_alert.sh
#
# modification history
#  5 Aug 1999 ?        - original script
#    MAR 2000 ?        - Modified for implementation of the IBM SP
# 20 Mar 2013 JWhiting - ported for use on WCOSS (linux) platforms:
#                         set to run under ksh
#                         no logic changes
#  9 Sep 2014 JWhiting - removed echo reference to 'IBM SP'
#                        trapped RUN=gdas to set correct file prefix
# 18 Apr 2017 DStokes  - Updated to handle gdas file with prefix gdas or gdas1
#                      - Added logic to have job fail if the dump_alert_flag
#                        file is not available or cannot be printed via cat.
#                      - Modified to check dump_alert_flags with $tmmark suffix.
# 19 Sep 2018 SMelchior- Removed temporary logic to handle gdas1 prefix.
# 14 Dec 2021 NEsposito- Updated for use on WCOSS2; removed .ecf filename extension
#####################################################################
echo " "

set -u

cd $DATA
jlogfile=${jlogfile:-""}

########################################
set -x
msg="HAS BEGUN!"
postmsg "$jlogfile" "$msg"
########################################


# List NCEP date
export analtime=`cut -c7-16 ncepdate`

set +x
echo "CENTER DATA DUMP DATE-TIME FOR $NET IS $analtime"
set -x
 
# ---------------------------------------
# check for severly low data counts 
# ---------------------------------------


tmmark=${tmmark:-tm00}

alert_flag_file=$COMIN/$RUN.$cycle.dump_alert_flag.$tmmark

RETC=$(cat $alert_flag_file)
err=$?
if [ $err -eq 0 ]; then
   export RETC
   if [ $RETC -eq 6 ]
      then
      msg="DATACOUNT low on 1 or more CRITICAL ob types - SDM should check \
ALERTLOG messages in ${COMROOT}/logs/alertlog/$RUN.t${cyc}z"
      postmsg "$jlogfile" "$msg"
      echo $msg > errfile
      export err=6
      err_chk
   elif [ $RETC -eq 5 ]
      then
      msg="DATACOUNT low on 1 or more non-critical ob types - SDM should check \
ALERTLOG messages in ${COMROOT}/logs/alertlog/$RUN.t${cyc}z"
      postmsg "$jlogfile" "$msg"
  fi
else
  msg="FATAL ERROR:  cat of $alert_flag_file failed. status $err"
  postmsg "$jlogfile" "$msg"
  echo $msg > errfile
  err_exit
fi

#####################################################################
# GOOD RUN
set +x
echo "************** $job COMPLETED NORMALLY"
echo "************** $job COMPLETED NORMALLY"
echo "************** $job COMPLETED NORMALLY"
set -x
#####################################################################

msg="HAS COMPLETED NORMALLY!"
postmsg "$jlogfile" "$msg"
############## END OF SCRIPT #######################

#!/bin/sh
#    gdas_counts.sh
#
#    This scripts copies the files containing 
#      observational data counts to an archive  
#      for compiling at the end of month
#
# History
#      Larry Sager 06/2007   -  Implementation of
#                               Ralph Jones' script
#      Krishna Kumar 10/2012    Modified from the generic name of the 
#                               type gps to the specific type gps_bnd
#      D. Keyser     05/2015    Split imported script variables $SATCOM and
#                               $DATCOM into separate input and output
#                               variables $SATCOMIN (root to $SATCOMIN_dir) and
#                               $SATCOMOUT_dir, and $DATCOMIN (root to
#                               $DATCOMIN_dir) and $DATCOMOUT_dir set in parent
#                               Job Script.
#                               BENEFIT: Allows checkout runs to specify a
#                                        production input location and a local
#                                        output location.
#      D. Stokes     03/2017    Changed explicit gdas1 refs to $RUN
#      S. Melchior   04/2018    Modified INFILE to use $COMIN1 to accommodate
#                               the $cyc subdir in com introduced in FV3GFS.
#      S. Melchior   07/2020    Introduced logic to define INFILE based on
#                               version of GFS to determine directory structure.
#
  cd $DATA 

#  Loop through each cycle and create reformatted files

   for d_cyc in t00z t06z t12z t18z
     do
      cycdir=$(echo ${d_cyc} | sed 's/^.\(.*\).$/\1/')
      INFILE="${COMIN1}${PDY}/${cycdir}/$COMPONENT/$RUN.${d_cyc}.status.tm00.bufr_d"
      if [ ! -f $INFILE ]; then
            echo -e "\n\n  INFILE:  $INFILE  does not exist \n\n"
            break
      fi
      grep "in data group" ${INFILE}  > tmp
      grep "total for all" ${INFILE}  >> tmp
      grep "COMBINED TOTAL" ${INFILE} >> tmp
      grep "(SUPEROBED) TRMM" ${INFILE} | cut -c1-80 >> tmp
      grep "REPROCESSED QUIKSCAT" ${INFILE}   >> tmp
      cp tmp ${DATCOMOUT_dir}/$RUN.${d_cyc}.status.tm00.bufr_d.$PDY   
      echo COUNTS  created ${DATCOMOUT_dir}/$RUN.${d_cyc}.status.tm00.bufr_d.$PDY
    done


#
# Loop through the 4 gsistats files and collect the assimilated counts 
#
    for d_cyc in t00z t06z t12z t18z
    do
      cycdir=$(echo ${d_cyc} | sed 's/^.\(.*\).$/\1/')
      #INFILE=${COMIN1}${PDY}/${cycdir}/$COMPONENT/$RUN.${d_cyc}.gsistat        
      INFILE=${COMINgdas}${PDY}/${cycdir}/$COMPONENT/$RUN.${d_cyc}.gsistat # nco suggested
      if [ ! -f $INFILE ]; then
            echo -e "\n\n  INFILE:  $INFILE  does not exist \n\n"
            break
      fi
      grep "o-g 03 rad" $INFILE  > tmp
      grep "o-g 03 pcp" $INFILE  >> tmp
      grep "o-g 03 oz" $INFILE  >> tmp
#      grep "type   gps jiter   3" $INFILE >> tmp
      grep "type gps_bnd jiter   3" $INFILE >> tmp
      grep -v "0          0          0   " tmp > tmpa
      cp tmpa ${SATCOMOUT_dir}/gdas_gsistat.${PDY}.${d_cyc}
      echo COUNTS  created ${SATCOMOUT_dir}/gdas_gsistat.${PDY}.${d_cyc}
    done 

exit

#!/bin/ksh
# Run under ksh (converted to WCOSS)

# This script performs an oi-based quality control on all data
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# --------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - NCEP production date (YYYYMMDDHH)

# Imported variables that must be passed in:
#   DATA - path to working directory
#   OIQCT - path to observation error table file
#   OIQCX - path to PREPOBS_OIQCBUFR program executable

# Imported variables that can be passed in:
#   jlogfile - string indicating path to joblog file (skipped over by this
#              script if not passed in)
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)
#   sys_tp   - system type and phase.  (if not passed in, an attempt is made to
#              set this string using getsystem, an NCO script in prod_util)
#   SITE     - site name (may have been set by local shell startup script)
#   launcher_OIQCX - launcher for OIQCX executable (on Cray-XC40, defaults to
#                    aprun using 16 tasks)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1;fi
CDATE10=$2

jlogfile=${jlogfile:=""}

rm $PRPI.oiqcbufr
rm tosslist

pgm=`basename  $OIQCX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

#### THE BELOW APPLIED TO THE CCS (IBM AIX)  (kept for reference)
#set +u
#[ -n "$LOADL_PROCESSOR_LIST" ] && export XLSMPOPTS=parthds=2:usrthds=2:stack=64000000
#set -u

echo "      $CDATE10" > cdate.dat
export FORT11=cdate.dat
export FORT14=$PRPI
export FORT17=$OIQCT
export FORT18=obprt_ipoint.wrk
export FORT20=tolls.wrk
export FORT61=toss.sfc_z
export FORT62=toss.temp_wind
export FORT63=toss.sat_temp
export FORT64=toss.ssmi_wind
export FORT65=tosslist
export FORT70=$PRPI.oiqcbufr
export FORT81=obogram.out
export FORT82=obogram.bin
TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
# $TIMEIT mpirun $OIQCX > outout 2> errfile
#$TIMEIT mpirun -genvall -n $LSB_DJOB_NUMPROC -machinefile $LSB_DJOB_HOSTFILE $OIQCX > outout 2> errfile

SITE=${SITE:-""}
sys_tp=${sys_tp:-$(getsystem)}
getsystp_err=$?
if [ $getsystp_err -ne 0 ]; then
   msg="***WARNING: error using getsystem to determine system type and phase"
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
fi
echo sys_tp is set to: $sys_tp
launcher_OIQCX=${launcher_OIQCX:-"mpiexec -n $NCPUS"}
#########################module load ibmpe ics lsf uncomment if not in profile
#  seems to run ok w next 10 lines commented out (even though Jack had them in
#   his version of this script)
###export LANG=en_US
###export MP_EAGER_LIMIT=65536
###export MP_EUIDEVELOP=min
###export MP_EUIDEVICE=sn_all
###export MP_EUILIB=us
###export MP_MPILIB=mpich2
###export MP_USE_BULK_XFER=yes
###export MPICH_ALLTOALL_THROTTLE=0
###export MP_COLLECTIVE_OFFLOAD=yes
###export KMP_STACKSIZE=1024m

$TIMEIT $launcher_OIQCX $OIQCX > outout  2> errfile

err=$?
###cat errfile
cat errfile >> outout
cat outout >> oiqcbufr.out
cp outout obcnt.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for PREPOBS_OIQCBUFR is ' $err
echo
set -x
if [ "$err" -eq '4' ]; then
msg="WRNG: SOME OBS NOT QC'd BY PGM PREPOBS_OIQCBUFR - # OF OBS > LIMIT \
--> non-fatal"
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
   err=0
fi
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.oiqcbufr $PRPI
fi

exit 0

#!/bin/ksh
# Run under ksh (converted to WCOSS)


# This script has two functions:
#  1) Generates synthetic cyclone bogus near tropical storms and appends them
#     to a PREPBUFR file (based on script variable DO_BOGUS).  If may also,
#     based on user-requested switch, flag mass pressure reports "near"
#     tropical storms.
#  2) Flag dropwinsonde wind reports "near" tropical storms (based on user-
#     requested switch).
#
#  Note: It can do both 1 and 2 above or just one of them without the other.
#   
#  (NOTE: SYNDATA is currently restricted to run with T126 gaussian
#         land-sea mask)
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# -------------------------------------------------------------

set -aux

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - path to COPY OF input tcvitals file
#   3 - expected center date in PREPBUFR file (YYYYMMDDHH)


# Imported variables that must be passed in:
#   DATA  - path to working directory
#   SGES  - path to COPY OF global simga first guess file 1 (valid at
#            either center date of PREPBUFR file or nearest cycle time prior
#            to center date of PREPBUFR file which is a multiple of 3)
#   SGESA - path to COPY OF global simga first guess file 2 (either
#            null if SGES is valid at center date of PREPBUFR file or valid
#            at nearest cycle time after center date of PREPBUFR file which
#            is a multiple of 3 if SGES is valid at nearest cycle time
#            prior to center date of PREPBUFR file which is a multiple of 3)
#   PRVT  - path to observation error table file
#   FIXSYND - path to synthethic data fixed field files
#   SYNDX   - path to SYNDAT_SYNDATA program executable
#   SYNDC   - path to SYNDAT_SYNDATA program parm cards

# Imported variables that can be passed in:
#   DO_BOGUS - Generate synthetic cyclone bogus near tropical storms and
#              append them to a PREPBUFR file (and also, based on user-
#              requested switch, flag mass pressure reports "near" tropical
#              storms)?  (choices are "YES" or "NO", anything else defaults to
#              "YES", including if this is not passed in)
#   jlogfile - string indicating path to joblog file (skipped over by this
#              script if not passed in)
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)
#   sys_tp   - system type and phase.  (if not passed in, an attempt is made to
#              set this string using getsystem, an NCO script in prod_util)
#   SITE     - site name (may have been set by local shell startup script)
#   launcher_SYNDX - launcher for SYNDX executable (on Cray-XC40, defaults to
#                    aprun using single task)


cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1 ;fi
VITL=$2
CDATE10=$3

jlogfile=${jlogfile:=""}

if [ ! -s $VITL ] ; then
   msg="TCVITALS EMPTY - NO PROCESSING PERFORMED BY SYNDAT_SYNDATA for \
$CDATE10  --> non-fatal"
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"

   exit
fi

if [ $DO_BOGUS = 'YES' ]; then
   suffix_char=""
else
   suffix_char="_nobog"
fi

rm -f $PRPI.syndata bogdomn.wrk${suffix_char} alldat${suffix_char}
rm -f stmtrk.wrk${suffix_char} rawdat.wrk${suffix_char} dumcoef${suffix_char}
rm -f matcoef${suffix_char} dthistry${suffix_char} bogrept${suffix_char}
rm -f bogdata${suffix_char} fenvdta.wrk${suffix_char} stkdatb.wrk${suffix_char}
rm -f gesvit${suffix_char} bghistry.diag${suffix_char}
rm -f prevents.filtering.syndata${suffix_char}

pgm=`basename  $SYNDX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

export FORT11=$VITL
echo "      $CDATE10" > cdate10.dat
export FORT13=cdate10.dat
export FORT14=$FIXSYND/syndat_syndata.slmask.t126.gaussian
export FORT15=bogdomn.wrk${suffix_char}
export FORT16=stmtrk.wrk${suffix_char}
export FORT17=rawdat.wrk${suffix_char}
export FORT19=bghistry.diag${suffix_char}
export FORT21=gesvit${suffix_char}
export FORT22=stkdatb.wrk${suffix_char}
export FORT23=fenvdta.wrk${suffix_char}
export FORT24=bogdata${suffix_char}
export FORT25=$PRPI
#####export FORT30=$SGES
#####export FORT31=$SGESA

# The SYNDAT_SYNDATA code will soon, or may now, open GFS spectral coefficient
# guess files using sigio routines (via W3EMC routine GBLEVENTS) via explicit
# open(unit=number,file=filename) statements.  This conflicts with the FORTxx
# statements above.  One can either remove the explicit open statements in the
# code or replace the above FORTxx lines with soft links.  The soft link
# approach is taken below.

ln -sf $SGES              fort.30
ln -sf $SGESA             fort.31
export FORT32=$PRVT
export FORT40=$FIXSYND/syndat_weight
export FORT58=bogrept${suffix_char}
export FORT59=dthistry${suffix_char}
export FORT61=$PRPI.syndata
export FORT70=matcoef${suffix_char}
export FORT71=dumcoef${suffix_char}
export FORT72=rawdat.wrk${suffix_char}
export FORT73=stmtrk.wrk${suffix_char}
export FORT74=alldat${suffix_char}
export FORT80=prevents.filtering.syndata${suffix_char}
export FORT89=bogdomn.wrk${suffix_char}

#### THE BELOW APPLIED TO THE CCS (IBM AIX)  (kept for reference)
##The choice in the first  line below MAY cause a failure
##The choice in the second line below works!
#set +u
#####[ -n "$LOADL_PROCESSOR_LIST" ] && export XLSMPOPTS=parthds=2:stack=64000000
#[ -n "$LOADL_PROCESSOR_LIST" ] && export XLSMPOPTS=parthds=2:stack=20000000
#set -u

TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"

SITE=${SITE:-""}
sys_tp=${sys_tp:-$(getsystem)}
getsystp_err=$?
if [ $getsystp_err -ne 0 ]; then
   msg="***WARNING: error using getsystem to determine system type and phase"
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
fi
echo sys_tp is set to: $sys_tp
launcher_SYNDX=${launcher_SYNDX:-""}
$TIMEIT $launcher_SYNDX $SYNDX < $SYNDC > outout  2> errfile
err=$?
###cat errfile
cat errfile >> outout
[ $DO_BOGUS = 'YES' ]  &&  cat prevents.filtering.syndata >> outout
cat outout >> syndata.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for SYNDAT_SYNDATA is ' $err
echo
set -x
if [ $err -eq 0 ]; then

   set +x
   echo " --------------------------------------------- "
   echo " ********** COMPLETED PROGRAM $pgm  **********"
   echo " --------------------------------------------- "
   set -x
   msg="$pgm completed normally for $CDATE10 - DO_BOGUS= $DO_BOGUS"
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"
   mv $PRPI.syndata $PRPI

else

msg="SYNDAT_SYNDATA TERMINATED ABNORMALLY WITH CONDITION CODE $err \
--> non-fatal"
   set +x
   echo
   echo "$msg"
   echo
   set -x
   [ -n "$jlogfile" ] && $DATA/postmsg "$jlogfile" "$msg"

fi

exit 0

#!/bin/ksh
export PS4=' + ukmet_grib.sh line $LINENO: '

#--------------------------------------------------------------------------------
# Fanglin Yang    June 2014
#  merge ukm hires data in 8 patches into one global array at 1-deg resolution
#
# Jiayi Peng  05/31/2016
# Adopted into TC tracker/genesis package
# Jiayi Peng 11/14/2018
# Updated for MPMD run 
#--------------------------------------------------------------------------------
cd $DATA  
cp ${ukmetdcom}/GAB${cyc}* .

#J.Peng----11142018----split GRIB1 data---------------------------

rm -f GAB${cyc}JJT.GRB.ix GAB${cyc}KKT.GRB.ix GAB${cyc}PPA.GRB.ix
${WGRIB} -s GAB${cyc}JJT.GRB > GAB${cyc}JJT.GRB.ix
${WGRIB} -s GAB${cyc}KKT.GRB > GAB${cyc}KKT.GRB.ix
${WGRIB} -s GAB${cyc}PPA.GRB > GAB${cyc}PPA.GRB.ix

cp GAB${cyc}AAT.GRB pgbf00.ukmet.${PDY}${cyc}
cp GAB${cyc}BBT.GRB pgbf06.ukmet.${PDY}${cyc}
cp GAB${cyc}CCT.GRB pgbf12.ukmet.${PDY}${cyc}
cp GAB${cyc}DDT.GRB pgbf18.ukmet.${PDY}${cyc}
cp GAB${cyc}EET.GRB pgbf24.ukmet.${PDY}${cyc}
cp GAB${cyc}FFT.GRB pgbf30.ukmet.${PDY}${cyc}
cp GAB${cyc}GGT.GRB pgbf36.ukmet.${PDY}${cyc}
cp GAB${cyc}HHT.GRB pgbf42.ukmet.${PDY}${cyc}
cp GAB${cyc}IIT.GRB pgbf48.ukmet.${PDY}${cyc}

grep "54hr" GAB${cyc}JJT.GRB.ix | ${WGRIB} -s GAB${cyc}JJT.GRB -i -grib -append -o pgbf54.ukmet.${PDY}${cyc}
grep "60hr" GAB${cyc}JJT.GRB.ix | ${WGRIB} -s GAB${cyc}JJT.GRB -i -grib -append -o pgbf60.ukmet.${PDY}${cyc}

grep "66hr" GAB${cyc}KKT.GRB.ix | ${WGRIB} -s GAB${cyc}KKT.GRB -i -grib -append -o pgbf66.ukmet.${PDY}${cyc}
grep "72hr" GAB${cyc}KKT.GRB.ix | ${WGRIB} -s GAB${cyc}KKT.GRB -i -grib -append -o pgbf72.ukmet.${PDY}${cyc}

cp GAB${cyc}QQT.GRB pgbf78.ukmet.${PDY}${cyc}
cp GAB${cyc}LLT.GRB pgbf84.ukmet.${PDY}${cyc}
cp GAB${cyc}TTT.GRB pgbf90.ukmet.${PDY}${cyc}
cp GAB${cyc}MMT.GRB pgbf96.ukmet.${PDY}${cyc}
cp GAB${cyc}UUT.GRB pgbf102.ukmet.${PDY}${cyc}
cp GAB${cyc}NNT.GRB pgbf108.ukmet.${PDY}${cyc}
cp GAB${cyc}VVT.GRB pgbf114.ukmet.${PDY}${cyc}
cp GAB${cyc}OOT.GRB pgbf120.ukmet.${PDY}${cyc}
cp GAB${cyc}11T.GRB pgbf126.ukmet.${PDY}${cyc}

grep "132hr" GAB${cyc}PPA.GRB.ix | ${WGRIB} -s GAB${cyc}PPA.GRB -i -grib -append -o pgbf132.ukmet.${PDY}${cyc}
cp GAB${cyc}22T.GRB pgbf138.ukmet.${PDY}${cyc}
grep "144hr" GAB${cyc}PPA.GRB.ix | ${WGRIB} -s GAB${cyc}PPA.GRB -i -grib -append -o pgbf144.ukmet.${PDY}${cyc}

#-------------------------------------------------------
hrstring=" 00  06  12  18  24  30  36  42  48  54
           60  66  72  78  84  90  96 102 108 114
          120 126 132 138 144"

>trkr.cmdfile
for leadhr in ${hrstring}; do
  outfile=${DATA}/ukmetgrib.${leadhr}.out
  echo "${EXECukmet}/ukm_hires_merge pgbf${leadhr}.ukmet.${PDY}${cyc} pgbf${leadhr}.ukm.${PDY}${cyc} ${leadhr} 2>&1 >${outfile}" >>trkr.cmdfile
done

chmod u+x trkr.cmdfile
export MP_PGMMODEL=mpmd
export MP_CMDFILE=${DATA}/trkr.cmdfile

mac=`echo ${SITE}`
if [ $mac = TIDE -o $mac = GYRE ] ; then # For WCOSS
  machine=wcoss
  mpirun.lsf
elif [ $mac = LUNA -o $mac = SURGE ] ; then # For CRAY
  machine=cray
  ${APRUNTRACK} cfp ${MP_CMDFILE}
fi

cp pgb*.ukm.${PDY}${cyc} ${COMOUT}/.

#!/bin/sh
#
# build_mainpage.sh
#
# Abstract: 
#   Rebuild gdas counts main webpage such as that posted at:
#     http://www.nco.ncep.noaa.gov/pmb/nwprod/gdas/
#
# Imported Variables:
#   StartYr                 4-digit year (Optional)
#   EndYr                   4-digit year
#   LastMon_EndYr           2-digit month
#   FIXprepobs              Directory containing input base html file
#
# Fixed files:
#   $FIXprepobs/gdascounts_base.shtml
#
# Output:
#   index.shtml
#
# Condition codes
#   0 - no problem encountered
#   7 - Format of input base html file is no longer as expected.
#   >0 - some other problem encountered
#
# History:
#  D. Stokes     05/01/2015  -  Original version.
#
 
set -x

StartYr=${StartYr:-2002}
EndYr=${EndYr:?}
LastMon_EndYr=${LastMon_EndYr:?}

# Set up array containing month names
#
declare -A Month
Month[01]=January
Month[02]=February
Month[03]=March
Month[04]=April
Month[05]=May
Month[06]=June
Month[07]=July
Month[08]=August
Month[09]=September
Month[10]=October
Month[11]=November
Month[12]=December

# Bring in fresh page base.
# 
cp $FIXprepobs/gdascounts_base.shtml gdascounts_base.shtml

# Above file should have the demarcation patterns expected in following sed commands
#
nlines_header=$(grep -n "<!-- table starts below this line" gdascounts_base.shtml|cut -f1 -d":")
nlines_footer=$(grep -n "<!-- table ends above this line" gdascounts_base.shtml|cut -f1 -d":")
if [[ -z "$nlines_header" || -z "$nlines_footer" ]]; then
  echo "Warning: Unexpected content in input shtml file"
  exit 7
fi
sed -n 1,${nlines_header}p gdascounts_base.shtml | sed \$d  > page_header
sed -n ${nlines_footer},\$p gdascounts_base.shtml | sed 1d  > page_footer

# Set up empty calendar template used to create table
#
cat << EOF  > newyear
    <center>
    <table width="600" border="1" cellpadding="6" cellspacing="0">
      <tr align="center" bgcolor="#ffcccc">
        <td colspan="6">
          <font size="+1"><b>YEAR</b></font>
        </td>
      </tr>
      <tr>
        <td width="17%">January</td>
        <td width="17%">February</td>
        <td width="16%">March</td>
        <td width="16%">April</td>
        <td width="17%">May</td>
        <td width="17%">June</td>
      </tr>
      <tr>
        <td width="17%">July</td>
        <td width="17%">August</td>
        <td width="16%">September</td>
        <td width="16%">October</td>
        <td width="17%">November</td>
        <td width="17%">December</td>
      </tr>
    </table>

EOF

# Add header to new shtml file
#
cat page_header > index.shtml

# Loop through years, adding calendar to shtml file
# Add monthly links up through last requested month.
#
for YEAR in $(seq $EndYr -1 $StartYr); do
  sed s/YEAR/$YEAR/ newyear > cal$YEAR
  if [[ $YEAR -lt $EndYr ]]; then
    EndMon=12
  else
    EndMon=$LastMon_EndYr
  fi
  for MM in $(seq -w 01 $EndMon); do
    sed -i -e s/"${Month[$MM]}<\/td>"/"<a href=\"${Month[$MM]}_${YEAR}.html\">${Month[$MM]}<\/a><\/td>"/ cal$YEAR 
  done

  cat cal$YEAR >> index.shtml
done
  
# Add footer to shtml page
#
cat page_footer >> index.shtml

#!/bin/ksh
# Run under ksh (converted to WCOSS)


# This script encodes the background (first guess) and observational
#  errors into the PREPBUFR reports (interpolated to obs. locations)
#
# It is normally executed by the script prepobs_makeprepbufr.sh
#  but can also be executed from a checkout parent script
# -------------------------------------------------------------

set -aux

qid=$$

# Positional parameters passed in:
#   1 - path to COPY OF input prepbufr file --> becomes output prepbufr
#       file upon successful completion of this script (note that input
#       prepbufr file is NOT saved by this script)
#   2 - expected center date in PREPBUFR file (YYYYMMDDHH)

# Imported variables that must be passed in:
#   DATA  - path to working directory
#   NET   - string indicating system network (either "gfs", "gdas", "cdas",
#            "nam", "rap", "rtma" or "urma")
#            NOTE1: NET is changed to gdas in the parent Job script for the
#                   RUN=gdas1 (was gfs - NET remains gfs for RUN=gfs).
#            NOTE2: This is read from the program PREPOBS_PREVENTS via a call
#                   to system routine "GETENV".
#   SGES  - path to COPY OF global simga first guess file 1 (valid at
#            either center date of PREPBUFR file or nearest cycle time prior
#            to center date of PREPBUFR file which is a multiple of 3)
#   SGESA - path to COPY OF global simga first guess file 2 (either
#            null if SGES is valid at center date of PREPBUFR file or valid
#            at nearest cycle time after center date of PREPBUFR file which
#            is a multiple of 3 if SGES is valid at nearest cycle time
#            prior to center date of PREPBUFR file which is a multiple of 3)
#   PRVT  - path to observation error table file
#   PREX  - path to PREPOBS_PREVENTS program executable
#   PREC  - path to PREPOBS_PREVENTS program parm cards

# Imported variables that can be passed in:
#   pgmout   - string indicating path to for standard output file (skipped
#              over by this script if not passed in)

cd $DATA
PRPI=$1
if [ ! -s $PRPI ] ; then exit 1 ;fi
CDATE10=$2

rm $PRPI.prevents
rm prevents.filtering

pgm=`basename  $PREX`
if [ -s $DATA/prep_step ]; then
   set +u
   . $DATA/prep_step
   set -u
else
   [ -f errfile ] && rm errfile
   unset FORT00 `env | grep "^FORT[0-9]\{1,\}=" | awk -F= '{print $1}'`
fi

echo "      $CDATE10" > cdate10.dat
export FORT11=$PRPI
#####export FORT12=$SGES
#####export FORT13=$SGESA

# The PREPOBS_PREVENTS code will soon, or may now, open GFS spectral
# coefficient guess files using sigio routines (via W3EMC routine GBLEVENTS)
# via explicit open(unit=number,file=filename) statements.  This conflicts with
# the FORTxx statements above.  One can either remove the explicit open
# statements in the code or replace the above FORTxx lines with soft links.
# The soft link approach is taken below.

ln -sf $SGES              fort.12
ln -sf $SGESA             fort.13

export FORT14=$PRVT
export FORT15=cdate10.dat
export FORT51=$PRPI.prevents
export FORT52=prevents.filtering

TIMEIT=${TIMEIT:-""}
[ -s $DATA/time ] && TIMEIT="$DATA/time -p"
$TIMEIT $PREX < $PREC > outout  2> errfile
err=$?
###cat errfile
cat errfile >> outout
cat prevents.filtering >> outout
cat outout >> prevents.out
set +u
[ -n "$pgmout" ]  &&  cat outout >> $pgmout
set -u
rm outout
set +x
echo
echo 'The foreground exit status for PREPOBS_PREVENTS is ' $err
echo
set -x
if [ -s $DATA/err_chk ]; then
   $DATA/err_chk
else
   if test "$err" -gt '0'
   then
######kill -9 ${qid} # need a WCOSS alternative to this even tho commented out
                     #  in ops
      exit 55
   fi
fi

if [ "$err" -gt '0' ]; then
   exit 9
else
   mv $PRPI.prevents $PRPI
fi

exit 0

#!/bin/ksh
# Run under ksh
############################################################################
echo "-------------------------------------------------------------------- "
echo "exdump_monitor.sh - Data dump monitor processing                 "
echo "-------------------------------------------------------------------- "
echo "History: Jan 03 2001 - Original script.                              "
echo "         Sep 10 2014 - Use parallel scripting to process dump groups."
echo "         Feb  3 2015 - Dump new satwnd types NC005019, NC005080,     "
echo "                       NC005090. Dump new type efclam. Removed dump  "
echo "                       of "trmm".                                    "
echo "         Aug 16 2016 - GPSIPW dump window reset for new data stream. "
echo "         Jan 12 2017 - Dump new satellite data types.                "
echo "         Nov 07 2018 - Updated to run on Dell-p3.  Dump new satwnd   "
echo "                       types NC005024, NC005025, NC005026, NC005030, "
echo "                       NC005031, NC005032, NC005034, NC005039.  Dump "
echo "                       new ozone types ompsn8 and ompst8.            "
echo "         Sep 14 2020 - set DTIM_EARLIEST_005091=-3.00 and            "
echo "                       DTIM_LATEST_005091=+2.99.  DTIM_* settings for"
echo "                       005090 are obsolete and removed.              "
echo "                     - Update to remove crisdb and escris and replace"
echo "                       with crsfdb.  On Apr 22, 2020, NSR CrIS data  "
echo "                       from NPP was replaced by FSR. The cris dump   "
echo "                       group is obsolete with the change to FSR and  "
echo "                       has been removed.                             "
echo "                     - Update to dump gsrcsr, gsrasr, ompslp, ahicsr,"
echo "                       sstvcw, sstvpw, leogeo, hdob. leogeo is added "
echo "                       to the ADD_satwnd definition.  sstvcw and     "
echo "                       sstvpw were added to a new unique dump group, "
echo "                       #8.                                           "
echo "                     - Update to remove obsolete GOES-15 data: goesnd"
echo "                       and goesfv.                                   "
echo "                     - Update to remove obsolete dump group: radwnd. "
echo "                     - set DTIM_* settings for new WMO BUFR sequence "
echo "                       Meteosat AMV data. Subsets 005064, 005065, and"
echo "                       006066 are replaced by subsets 005067, 005068,"
echo "                       and 005069.                                   "
echo "         Jun 21 2021 - Incremented subsets for the sfcshp dump groups"
echo "                       to match bufr_dumplist.  Removed tideg from   "
echo "                       sfcshp dump group tom ake individual dump     "
echo "                       file.                                         " 
echo "                     - Copy bufr_dumplist to COMOUT.                 "
############################################################################

set -aux

# Make sure we are in the $DATA directory
cd $DATA

msg="HAS BEGUN on `hostname`"
$DATA/postmsg "$jlogfile" "$msg"

cat break > $pgmout

export dumptime=`cut -c7-16 ncepdate`
export cycp=`echo $dumptime|cut -c9-10`

# Min and max times for this job are now created, based on a plus or minus
#  3-minute window

min_min=-3
min_max=3

dumptime_min=`$MDATE $min_min ${dumptime}30`   
dumptime_max=`$MDATE $min_max ${dumptime}30`


currdate=`date -u +%Y%m%d%H%M`

set +x
echo
echo "CENTER DATA DUMP DATE-TIME FOR MONITORING IS $dumptime"
echo
echo "CURRENT DATE IS $currdate"
echo
set -x

TIME_CHECK=${TIME_CHECK:-YES}
if [ $TIME_CHECK = YES ];then
   if [ $currdate -gt $dumptime_max -o $currdate -lt $dumptime_min ];then
msg="CENTER DATA DUMP TIME OUTSIDE ALLOWABLE TIME WINDOW, NO DUMPS PRODUCED"
      set +x
      echo
      echo $msg
      echo
      set -x
      $DATA/postmsg "$jlogfile" "$msg"
      set +x
      echo " "
      echo " ****** PROCESSING COMPLETED NORMALLY BUT NO DUMPS PRODUCED"
      echo " ****** PROCESSING COMPLETED NORMALLY BUT NO DUMPS PRODUCED"
      echo " ****** PROCESSING COMPLETED NORMALLY BUT NO DUMPS PRODUCED"
      echo " ****** PROCESSING COMPLETED NORMALLY BUT NO DUMPS PRODUCED"
      echo " "
      set -x
# save standard output
      cat  break $pgmout break > allout
      cat allout
      # rm allout

      sleep 10

      msg='ENDED NORMALLY, BUT NO DUMPS PRODUCED.'
      $DATA/postmsg "$jlogfile" "$msg"
      exit
   fi
fi

export COMSP=${DATA}${COMOUT}/$RUN.${cycle}.
mkdir -p ${DATA}${COMOUT}

err1=0
err2=0
err3=0
err4=0
err5=0
err6=0
err7=0
err8=0
err9=0
err10=0

#restrict processing of unexpected big tanks
#this block appear in all /scripts/ex*_dump.sh proessing msonet and msone1
TANK_MAX_255003=${TANK_MAX_255003:-3221225472} #3Gb
TANK_MAX_255004=${TANK_MAX_255004:-1610612736} #1.5Gb
TANK_MAX_255030=${TANK_MAX_255030:-4187593114} #3.9Gb
if [ -s ${TANK}/${PDY}/b255/xx003 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx003)" -gt "$TANK_MAX_255003" ]; then
 export SKIP_255003=YES
 msg="WARNING: TANK b255/xx003 exceeds TANK_MAX_255003 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
if [ -s ${TANK}/${PDY}/b255/xx004 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx004)" -gt "$TANK_MAX_255004" ]; then
 export SKIP_255004=YES
 msg="WARNING: TANK b255/xx004 exceeds TANK_MAX_255004 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
 fi
if [ -s ${TANK}/${PDY}/b255/xx030 ] && [ "$(stat -c '%s' ${TANK}/${PDY}/b255/xx030)" -gt "$TANK_MAX_255030" ]; then
 export SKIP_255030=YES
 msg="WARNING: TANK b255/xx030 exceeds TANK_MAX_255030 => not dumped"
 echo $msg | mail.py -s "$msg" 
#echo $msg | mail.py -s "$msg" -c iliana.genkova@noaa.gov
fi
#end of block

if [ "$PROCESS_DUMP" = 'YES' ]; then
###########################
###########################
#  The data "dump" script
###########################
###########################

msg="START THE DATA DUMP CENTERED ON $dumptime"
$DATA/postmsg "$jlogfile" "$msg"

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_1; chmod +x thread_1
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_1
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=1

#=========================================================================
# Dump # 1 : ADPUPA, 1BMHS, 1BHRS4, OSBUV8, TESAC, TRKOB,
#              (6)    (1)     (1)     (1)     (1)   (1)
#            EFCLAM, SAPHIR, ATMSDB, OMPSN8, OMPST8, OMPSLP
#              (1)     (1)     (1)     (1)     (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 17
#  time window radius is -0.50 to +0.49 hours on ADPUPA, TESAC, EFCLAM,
#  time window radius is -1.50 to -0.51 hours on TRKOB,  ATMSDB
#  time window radius is -2.00 to -1.01 hours on OSBUV8, 1BMHS,  1BHRS4
#                                                OMPSN8, OMPST8
#  time window radius is -2.50 to -1.51 hours on SAPHIR
#  time window radius is -7.00 to -6.01 hours on OMPSLP
#=========================================================================

DTIM_latest_adpupa=+0.49
DTIM_latest_tesac=+0.49
DTIM_latest_efclam=+0.49

DTIM_earliest_1bmhs=-2.00
DTIM_latest_1bmhs=-1.01

DTIM_earliest_1bhrs4=-2.00
DTIM_latest_1bhrs4=-1.01

DTIM_earliest_trkob=-1.50
DTIM_latest_trkob=-0.51

DTIM_earliest_osbuv8=-2.00
DTIM_latest_osbuv8=-1.01

DTIM_earliest_ompsn8=-2.00
DTIM_latest_ompsn8=-1.01

DTIM_earliest_ompst8=-2.00
DTIM_latest_ompst8=-1.01

DTIM_earliest_ompslp=-7.00
DTIM_latest_ompslp=-6.01

DTIM_earliest_saphir=-2.50
DTIM_latest_saphir=-1.51

DTIM_earliest_atmsdb=-1.50
DTIM_latest_atmsdb=-0.51


$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 adpupa osbuv8 1bmhs \
 1bhrs4 tesac trkob efclam saphir atmsdb ompsn8 ompst8 ompslp
error1=$?
echo "$error1" > $DATA/error1

set +x
echo "********************************************************************"
echo Script thread_1
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/1.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_2; chmod +x thread_2
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_2
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=2

#==========================================================================
# Dump # 2 : SFCSHP, ADPSFC, RASSDA, AIRSEV, GOESFV, MTIASI, GOME, AVCSAM
#             (11)     (4)     (1)    (1)     (1)      (1)    (1)    (1)
#            ESIASI, ESATMS, SEVASR, TIDEG
#              (1)     (1)     (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 25
#
# ===> Dumping of WNDSAT removed from here until new ingest feed is established
#      (had been dumped with a time window radius of -3.00 to -2.01 hours)
#
#  time window radius is -0.50 to +0.49 hours on SFCSHP (all types except
#                                                tide gauge from CREX),
#                                                ADPSFC, RASSDA, GOESFV,
#                                                SEVASR
#  time window radius is -1.00 to -0.01 hours on ESIASI, SFCSHP (tide gauge
#                                                from CREX only)
#  time window radius is -1.50 to -0.51 hours on GOME, ESATMS
#  time window radius is -2.00 to -1.01 hours on MTIASI
#  time window radius is -2.50 to -1.51 hours on AIRSEV, AVCSAM
#==========================================================================

DTIM_latest_001001=+0.49
DTIM_latest_001002=+0.49
DTIM_latest_001003=+0.49
DTIM_latest_001004=+0.49
DTIM_latest_adpsfc=+0.49
DTIM_latest_rassda=+0.49
DTIM_latest_sevasr=+0.49

DTIM_earliest_001005=-1.00
DTIM_latest_001005=-0.01

DTIM_earliest_airsev=-2.50
DTIM_latest_airsev=-1.51

DTIM_earliest_mtiasi=-2.00
DTIM_latest_mtiasi=-1.01

DTIM_earliest_gome=-1.50
DTIM_latest_gome=-0.51

DTIM_earliest_avcsam=-2.50
DTIM_latest_avcsam=-1.51

DTIM_earliest_esiasi=-1.00
DTIM_latest_esiasi=-0.01

DTIM_earliest_esatms=-1.50
DTIM_latest_esatms=-0.51

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 sfcshp adpsfc rassda \
 airsev mtiasi gome avcsam esiasi esatms sevasr tideg
error2=$?
echo "$error2" > $DATA/error2

set +x
echo "********************************************************************"
echo Script thread_2
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/2.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_3; chmod +x thread_3
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_3
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=3

#===========================================================================
# Dump # 3 : SATWND, 1BAMUA, GPSRO, AVCSPM, AMSR2, CRSFDB
#             (17)     (1)    (1)     (1)    (1)     (1)
#            -- TOTAL NUMBER OF SUBTYPES = 25
#  time window radius is -1.00 to -0.01 hours on all GOES SATWND types
#  time window radius is -1.50 to -0.51 hours on all EUMETSAT SATWND types,
#                                                    CRSFDB
#  time window radius is -2.00 to -1.01 hours on 1BAMUA, AMSR2
#  time window radius is -2.50 to -1.51 hours on all other    SATWND types,
#                                                    GPSRO, AVCSPM
#  time window radius is -4.00 to -3.01 hours on all POES (MODIS, AVHRR, VIIRS)
#                                                    SATWND types
#===========================================================================

# Skip Indian water vapor satellite winds in SATWND (never any data)
SKIP_005023=YES

# Skip legacy Meteosat AMV subsets; for testing, skipping happens in trigger or version file
#SKIP_005064=YES
#SKIP_005065=YES
#SKIP_005066=YES

ADD_satwnd="005024 005025 005026 005030 005031 005032 005034 005039 005072"

DTIM_earliest_1bamua=-2.00
DTIM_latest_1bamua=-1.01

DTIM_earliest_005064=-1.50
DTIM_latest_005064=-0.51

DTIM_earliest_005065=-1.50
DTIM_latest_005065=-0.51

DTIM_earliest_005066=-1.50
DTIM_latest_005066=-0.51

DTIM_earliest_005067=-1.50
DTIM_latest_005067=-0.51

DTIM_earliest_005068=-1.50
DTIM_latest_005068=-0.51

DTIM_earliest_005069=-1.50
DTIM_latest_005069=-0.51

DTIM_earliest_005010=-1.00
DTIM_latest_005010=-0.01

DTIM_earliest_005011=-1.00
DTIM_latest_005011=-0.01

DTIM_earliest_005012=-1.00
DTIM_latest_005012=-0.01

DTIM_earliest_005019=-1.00
DTIM_latest_005019=-0.01

DTIM_earliest_005021=-2.50
DTIM_latest_005021=-1.51

DTIM_earliest_005022=-2.50
DTIM_latest_005022=-1.51

DTIM_earliest_005024=-1.00
DTIM_latest_005024=-0.01

DTIM_earliest_005025=-1.00
DTIM_latest_005025=-0.01

DTIM_earliest_005026=-1.00
DTIM_latest_005026=-0.01

DTIM_earliest_005030=-1.00
DTIM_latest_005030=-0.01

DTIM_earliest_005031=-1.00
DTIM_latest_005031=-0.01

DTIM_earliest_005032=-1.00
DTIM_latest_005032=-0.01

DTIM_earliest_005034=-1.00
DTIM_latest_005034=-0.01

DTIM_earliest_005039=-1.00
DTIM_latest_005039=-0.01

DTIM_earliest_005044=-2.50
DTIM_latest_005044=-1.51

DTIM_earliest_005045=-2.50
DTIM_latest_005045=-1.51

DTIM_earliest_005046=-2.50
DTIM_latest_005046=-1.51

DTIM_earliest_gpsro=-2.50
DTIM_latest_gpsro=-1.51

DTIM_earliest_005070=-4.00
DTIM_latest_005070=-3.01

DTIM_earliest_005071=-4.00
DTIM_latest_005071=-3.01

DTIM_earliest_005072=-4.00
DTIM_latest_005072=-3.01

DTIM_earliest_005080=-4.00
DTIM_latest_005080=-3.01

DTIM_earliest_005091=-4.00
DTIM_latest_005091=-3.01

DTIM_earliest_avcspm=-2.50
DTIM_latest_avcspm=-1.51

DTIM_earliest_amsr2=-2.00
DTIM_latest_amsr2=-1.01

DTIM_earliest_crsfdb=-1.50
DTIM_latest_crsfdb=-0.51

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 satwnd gpsro 1bamua avcspm \
 amsr2 crsfdb
error3=$?
echo "$error3" > $DATA/error3

set +x
echo "********************************************************************"
echo Script thread_3
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/3.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_4; chmod +x thread_4
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_4
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=4

#=========================================================================
# Dump # 4 : AIRCAR, AIRCFT, PROFLR, VADWND, GEOIMR, ASCATT, HDOB
#              (2)     (8)     (4)     (2)     (1)     (1)   (1)
#            -- TOTAL NUMBER OF SUBTYPES = 19
#  time window radius is -0.50 to +0.49 hours on AIRCAR, AIRCFT,
#                                                PROFLR, VADWND, HDOB
#  time window radius is -1.00 to -0.01 hours on GEOIMR
#  time window radius is -1.50 to -0.51 hours on ASCATT
#=========================================================================

DTIM_latest_aircar=+0.49
DTIM_latest_aircft=+0.49
DTIM_latest_proflr=+0.49
DTIM_latest_vadwnd=+0.49
DTIM_latest_hdob=+0.49

DTIM_earliest_geoimr=-1.00
DTIM_latest_geoimr=-0.01

DTIM_earliest_ascatt=-1.50
DTIM_latest_ascatt=-0.51

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 aircar aircft proflr vadwnd \
 geoimr ascatt hdob
error4=$?
echo "$error4" > $DATA/error4

set +x
echo "********************************************************************"
echo Script thread_4
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/4.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_5; chmod +x thread_5
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_5
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=5

#===================================================================
# Dump # 5 : MSONET, GPSIPW, GSRCSR, GSRASR, AHICSR 
#             (30)     (1)    (1)      (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 34
#  time window radius is -0.50 to +0.49 hours on MSONET, GSRCSR,
#                                                GSRASR
#  time window radius is -1.00 to -0.01 hours on GPSIPW, AHICSR
#===================================================================

DTIM_latest_msonet=+0.49
DTIM_latest_gsrcsr=+0.49
DTIM_latest_gsrasr=+0.49

DTIM_earliest_gpsipw=-1.00
DTIM_latest_gpsipw=-0.01
DTIM_earliest_ahicsr=-1.00
DTIM_latest_ahicsr=-0.01

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 msonet gpsipw \
 gsrcsr gsrasr ahicsr
error5=$?
echo "$error5" > $DATA/error5

set +x
echo "********************************************************************"
echo Script thread_5
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/5.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_6; chmod +x thread_6
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_6
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=6

#===================================================================
# Dump # 6 : NEXRAD -- TOTAL NUMBER OF SUBTYPES = 4
#             (4)
#  time window radius is -0.50 to +0.49 hours
#===================================================================

DTIM_latest_nexrad=+0.49

# NEXRAD tanks are hourly
# Process only those hourly tanks w/i requested dump center cycle time window

SKIP_006010=YES # radial wind  00Z
SKIP_006011=YES # radial wind  01Z
SKIP_006012=YES # radial wind  02Z
SKIP_006013=YES # radial wind  03Z
SKIP_006014=YES # radial wind  04Z
SKIP_006015=YES # radial wind  05Z
SKIP_006016=YES # radial wind  06Z
SKIP_006017=YES # radial wind  07Z
SKIP_006018=YES # radial wind  08Z
SKIP_006019=YES # radial wind  09Z
SKIP_006020=YES # radial wind  10Z
SKIP_006021=YES # radial wind  11Z
SKIP_006022=YES # radial wind  12Z
SKIP_006023=YES # radial wind  13Z
SKIP_006024=YES # radial wind  14Z
SKIP_006025=YES # radial wind  15Z
SKIP_006026=YES # radial wind  16Z
SKIP_006027=YES # radial wind  17Z
SKIP_006028=YES # radial wind  18Z
SKIP_006029=YES # radial wind  19Z
SKIP_006030=YES # radial wind  20Z
SKIP_006031=YES # radial wind  21Z
SKIP_006032=YES # radial wind  22Z
SKIP_006033=YES # radial wind  23Z

SKIP_006040=YES # reflectivity 00Z
SKIP_006041=YES # reflectivity 01Z
SKIP_006042=YES # reflectivity 02Z
SKIP_006043=YES # reflectivity 03Z
SKIP_006044=YES # reflectivity 04Z
SKIP_006045=YES # reflectivity 05Z
SKIP_006046=YES # reflectivity 06Z
SKIP_006047=YES # reflectivity 07Z
SKIP_006048=YES # reflectivity 08Z
SKIP_006049=YES # reflectivity 09Z
SKIP_006050=YES # reflectivity 10Z
SKIP_006051=YES # reflectivity 11Z
SKIP_006052=YES # reflectivity 12Z
SKIP_006053=YES # reflectivity 13Z
SKIP_006054=YES # reflectivity 14Z
SKIP_006055=YES # reflectivity 15Z
SKIP_006056=YES # reflectivity 16Z
SKIP_006057=YES # reflectivity 17Z
SKIP_006058=YES # reflectivity 18Z
SKIP_006059=YES # reflectivity 19Z
SKIP_006060=YES # reflectivity 20Z
SKIP_006061=YES # reflectivity 21Z
SKIP_006062=YES # reflectivity 22Z
SKIP_006063=YES # reflectivity 23Z

if [ $cycp -eq 00 ]; then   # (23.50 - 00.49 Z)
   unset SKIP_006033 # radial wind  23Z
   unset SKIP_006010 # radial wind  00Z
   unset SKIP_006063 # reflectivity 23Z
   unset SKIP_006040 # reflectivity 00Z
elif [ $cycp -eq 01 ]; then   # (00.50 - 01.49 Z)
   unset SKIP_006010 # radial wind  00Z
   unset SKIP_006011 # radial wind  01Z
   unset SKIP_006040 # reflectivity 00Z
   unset SKIP_006041 # reflectivity 01Z
elif [ $cycp -eq 02 ]; then   # (01.50 - 02.49 Z)
   unset SKIP_006011 # radial wind  01Z
   unset SKIP_006012 # radial wind  02Z
   unset SKIP_006041 # reflectivity 01Z
   unset SKIP_006042 # reflectivity 02Z
elif [ $cycp -eq 03 ]; then   # (02.50 - 03.49 Z)
   unset SKIP_006012 # radial wind  02Z
   unset SKIP_006013 # radial wind  03Z
   unset SKIP_006042 # reflectivity 02Z
   unset SKIP_006043 # reflectivity 03Z
elif [ $cycp -eq 04 ]; then   # (03.50 - 04.49 Z)
   unset SKIP_006013 # radial wind  03Z
   unset SKIP_006014 # radial wind  04Z
   unset SKIP_006043 # reflectivity 03Z
   unset SKIP_006044 # reflectivity 04Z
elif [ $cycp -eq 05 ]; then   # (04.50 - 05.49 Z)
   unset SKIP_006014 # radial wind  04Z
   unset SKIP_006015 # radial wind  05Z
   unset SKIP_006044 # reflectivity 04Z
   unset SKIP_006045 # reflectivity 05Z
elif [ $cycp -eq 06 ]; then   # (05.50 - 06.49 Z)
   unset SKIP_006015 # radial wind  05Z
   unset SKIP_006016 # radial wind  06Z
   unset SKIP_006045 # reflectivity 05Z
   unset SKIP_006046 # reflectivity 06Z
elif [ $cycp -eq 07 ]; then   # (06.50 - 07.49 Z)
   unset SKIP_006016 # radial wind  06Z
   unset SKIP_006017 # radial wind  07Z
   unset SKIP_006046 # reflectivity 06Z
   unset SKIP_006047 # reflectivity 07Z
elif [ $cycp -eq 08 ]; then   # (07.50 - 08.49 Z)
   unset SKIP_006017 # radial wind  07Z
   unset SKIP_006018 # radial wind  08Z
   unset SKIP_006047 # reflectivity 07Z
   unset SKIP_006048 # reflectivity 08Z
elif [ $cycp -eq 09 ]; then   # (08.50 - 09.49 Z)
   unset SKIP_006018 # radial wind  08Z
   unset SKIP_006019 # radial wind  09Z
   unset SKIP_006048 # reflectivity 08Z
   unset SKIP_006049 # reflectivity 09Z
elif [ $cycp -eq 10 ]; then   # (09.50 - 10.49 Z)
   unset SKIP_006019 # radial wind  09Z
   unset SKIP_006020 # radial wind  10Z
   unset SKIP_006049 # reflectivity 09Z
   unset SKIP_006050 # reflectivity 10Z
elif [ $cycp -eq 11 ]; then   # (10.50 - 11.49 Z)
   unset SKIP_006020 # radial wind  10Z
   unset SKIP_006021 # radial wind  11Z
   unset SKIP_006050 # reflectivity 10Z
   unset SKIP_006051 # reflectivity 11Z
elif [ $cycp -eq 12 ]; then   # (11.50 - 12.49 Z)
   unset SKIP_006021 # radial wind  11Z
   unset SKIP_006022 # radial wind  12Z
   unset SKIP_006051 # reflectivity 11Z
   unset SKIP_006052 # reflectivity 12Z
elif [ $cycp -eq 13 ]; then   # (12.50 - 13.49 Z)
   unset SKIP_006022 # radial wind  12Z
   unset SKIP_006023 # radial wind  13Z
   unset SKIP_006052 # reflectivity 12Z
   unset SKIP_006053 # reflectivity 13Z
elif [ $cycp -eq 14 ]; then   # (13.50 - 14.49 Z)
   unset SKIP_006023 # radial wind  13Z
   unset SKIP_006024 # radial wind  14Z
   unset SKIP_006053 # reflectivity 13Z
   unset SKIP_006054 # reflectivity 14Z
elif [ $cycp -eq 15 ]; then   # (14.50 - 15.49 Z)
   unset SKIP_006024 # radial wind  14Z
   unset SKIP_006025 # radial wind  15Z
   unset SKIP_006054 # reflectivity 14Z
   unset SKIP_006055 # reflectivity 15Z
elif [ $cycp -eq 16 ]; then   # (15.50 - 16.49 Z)
   unset SKIP_006025 # radial wind  15Z
   unset SKIP_006026 # radial wind  16Z
   unset SKIP_006055 # reflectivity 15Z
   unset SKIP_006056 # reflectivity 16Z
elif [ $cycp -eq 17 ]; then   # (16.50 - 17.49 Z)
   unset SKIP_006026 # radial wind  16Z
   unset SKIP_006027 # radial wind  17Z
   unset SKIP_006056 # reflectivity 16Z
   unset SKIP_006057 # reflectivity 17Z
elif [ $cycp -eq 18 ]; then   # (17.50 - 18.49 Z)
   unset SKIP_006027 # radial wind  17Z
   unset SKIP_006028 # radial wind  18Z
   unset SKIP_006057 # reflectivity 17Z
   unset SKIP_006058 # reflectivity 18Z
elif [ $cycp -eq 19 ]; then   # (18.50 - 19.49 Z)
   unset SKIP_006028 # radial wind  18Z
   unset SKIP_006029 # radial wind  19Z
   unset SKIP_006058 # reflectivity 18Z
   unset SKIP_006059 # reflectivity 19Z
elif [ $cycp -eq 20 ]; then   # (19.50 - 20.49 Z)
   unset SKIP_006029 # radial wind  19Z
   unset SKIP_006030 # radial wind  20Z
   unset SKIP_006059 # reflectivity 19Z
   unset SKIP_006060 # reflectivity 20Z
elif [ $cycp -eq 21 ]; then   # (20.50 - 21.49 Z)
   unset SKIP_006030 # radial wind  20Z
   unset SKIP_006031 # radial wind  21Z
   unset SKIP_006060 # reflectivity 20Z
   unset SKIP_006061 # reflectivity 21Z
elif [ $cycp -eq 22 ]; then   # (21.50 - 22.49 Z)
   unset SKIP_006031 # radial wind  21Z
   unset SKIP_006032 # radial wind  22Z
   unset SKIP_006061 # reflectivity 21Z
   unset SKIP_006062 # reflectivity 22Z
elif [ $cycp -eq 23 ]; then   # (22.50 - 23.49 Z)
   unset SKIP_006032 # radial wind  22Z
   unset SKIP_006033 # radial wind  23Z
   unset SKIP_006062 # reflectivity 22Z
   unset SKIP_006063 # reflectivity 23Z
fi

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 nexrad
error6=$?
echo "$error6" > $DATA/error6

set +x
echo "********************************************************************"
echo Script thread_6
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/6.out 2>&1
EOF
set -x

set +x
#----------------------------------------------------------------
cat<<\EOF>thread_7; chmod +x thread_7
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_7
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=7

#======================================================================
# Dump # 7 : ATOVS, OMI, ESAMUA, ESHRS3, ESMHS, SSMISU, SEVCSR, LGHTNG,
#             (1)   (1)    (1)     (1)    (1)     (1)     (1)     (2)
#            LGYCLD, ATMS, BATHY, MLS, CRISF4, IASIDB  --
#              (1)    (1)   (1)   (1)   (1)     (1)
#            -- TOTAL NUMBER OF SUBTYPES = 15
#  time window radius is -0.50 to +0.49 hours on ESAMUA, ESHRS3, ESMHS,
#                                                SEVCSR, LGHTNG, LGYCLD,
#  time window radius is -1.50 to -0.51 hours on SSMISU, ATMS,
#                                                CRISF4, IASIDB
#  time window radius is -2.00 to -1.01 hours on ATOVS, MLS
#  time window radius is -2.50 to -1.51 hours on OMI
#  time window radius is -7.00 to -6.01 hours on BATHY
#======================================================================

DTIM_latest_esamua=+0.49
DTIM_latest_eshrs3=+0.49
DTIM_latest_esmhs=+0.49
DTIM_latest_sevcsr=+0.49
DTIM_latest_lghtng=+0.49
DTIM_latest_lgycld=+0.49

DTIM_earliest_atovs=-2.00
DTIM_latest_atovs=-1.01

DTIM_earliest_omi=-2.50
DTIM_latest_omi=-1.51

DTIM_earliest_bathy=-7.00
DTIM_latest_bathy=-6.01

DTIM_earliest_ssmisu=-1.50
DTIM_latest_ssmisu=-0.51

DTIM_earliest_mls=-2.00
DTIM_latest_mls=-1.01

DTIM_earliest_atms=-1.50
DTIM_latest_atms=-0.51

DTIM_earliest_crisf4=-1.50
DTIM_latest_crisf4=-0.51

DTIM_earliest_iasidb=-1.50
DTIM_latest_iasidb=-0.51

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 atovs omi esamua \
 eshrs3 esmhs ssmisu sevcsr lghtng lgycld atms bathy mls crisf4 iasidb
error7=$?
echo "$error7" > $DATA/error7

set +x
echo "********************************************************************"
echo Script thread_7
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/7.out 2>&1
EOF
set -x


#----------------------------------------------------------------

cat<<\EOF>thread_8; chmod +x thread_8
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_8
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=8

#======================================================================
# Dump # 8 : SSTVCW, SSTVPW
#              (1)    (1)
#            -- TOTAL NUMBER OF SUBTYPES = 2 
#  time window radius is -0.50 to +0.49 hours on SSTVCW, SSTVPW
#======================================================================

DTIM_latest_sstvcw=+0.49
DTIM_latest_sstvpw=+0.49

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 sstvcw sstvpw 
error8=$?
echo "$error8" > $DATA/error8

set +x
echo "********************************************************************"
echo Script thread_8
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/8.out 2>&1
EOF
set -x

#-------NEW MESON1 

set +x
cat<<\EOF>thread_9; chmod +x thread_9
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_9
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=9

#===================================================================
# Dump # 9 : MSONE1
#            (1)
#            -- TOTAL NUMBER OF SUBTYPES = 1
#  time window radius is -0.50 to +0.49 hours on MSONET
#===================================================================
DTIM_latest_msone1=+0.49
DTIM_earliest_msone1=-1.00

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 msone1
error9=$?
echo "$error9" > $DATA/error9

set +x
echo "********************************************************************"
echo Script thread_9
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/9.out 2>&1
EOF
set -x

#-------NEW UPRAIR 

set +x
cat<<\EOF>thread_10; chmod +x thread_10
set -uax

cd $DATA

{ echo
set +x
echo "********************************************************************"
echo Script thread_10
echo Executing on node  `hostname`
echo Starting time: `date -u`
echo "********************************************************************"
echo
set -x

export STATUS=NO
export DUMP_NUMBER=10

#===================================================================
# Dump # 10: UPRAIR
#             (1)
#            -- TOTAL NUMBER OF SUBTYPES = 1
#===================================================================
DTIM_latest_uprair=+0.49
DTIM_earliest_uprair=-0.49

$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 uprair
error10=$?
echo "$error10" > $DATA/error10

set +x
echo "********************************************************************"
echo Script thread_10
echo Finished executing on node  `hostname`
echo Ending time  : `date -u`
echo "********************************************************************"
set -x
} > $DATA/10.out 2>&1
EOF
set -x

#----------------------------------------------------------------

set +u
launcher=${launcher:-"cfp"}  # if not "cfp", threads will be run serially.
if [ "$launcher" = cfp ]; then
   > $DATA/poe.cmdfile
## To better take advantage of cfp, execute the longer running commands first.
## Some reordering was done here based on recent sample runtimes.
   echo ./thread_6 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_2 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_3 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_7 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_5 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_8 >> $DATA/poe.cmdfile  # moved up
   echo ./thread_1 >> $DATA/poe.cmdfile
   echo ./thread_4 >> $DATA/poe.cmdfile
   echo ./thread_9 >> $DATA/poe.cmdfile
   echo ./thread_10 >> $DATA/poe.cmdfile

   if [ -s $DATA/poe.cmdfile ]; then
      export MP_CSS_INTERRUPT=yes  # ??
      launcher_DUMP=${launcher_DUMP:-mpiexec}
      NPROCS=${NPROCS:-10}
      $launcher_DUMP -np $NPROCS --cpu-bind verbose,core cfp $DATA/poe.cmdfile
      errpoe=$?
      if [ $errpoe -ne 0 ]; then
         $DATA/err_exit "***FATAL: EXIT STATUS $errpoe RUNNING POE COMMAND FILE"
      fi
   else
      echo
      echo "==> There are no tasks in POE Command File - POE not run"
      echo
   fi
else
   echo "Running serial threads"
   ./thread_1
   ./thread_2
   ./thread_3
   ./thread_4
   ./thread_5
   ./thread_6
   ./thread_7
   ./thread_8
   ./thread_9
   ./thread_10
fi
cat $DATA/1.out $DATA/2.out $DATA/3.out $DATA/4.out $DATA/5.out $DATA/6.out \
 $DATA/7.out $DATA/8.out  $DATA/9.out  $DATA/10.out

set +x
echo " "
echo " "
set -x

err1=`cat $DATA/error1`
err2=`cat $DATA/error2`
err3=`cat $DATA/error3`
err4=`cat $DATA/error4`
err5=`cat $DATA/error5`
err6=`cat $DATA/error6`
err7=`cat $DATA/error7`
err8=`cat $DATA/error8`
err9=`cat $DATA/error9`
err10=`cat $DATA/error10`

#===============================================================================

export STATUS=YES
export DUMP_NUMBER=11
$ushscript_dump/bufr_dump_obs.sh $dumptime 0.50 1 null


cp -p ${DATA}${COMOUT}/$RUN.${cycle}.status.tm00.bufr_d $COMOUT

#  endif loop $PROCESS_DUMP
fi

echo " " >> $pgmout
echo "##################################################################\
####################"  >> $pgmout
echo " " >> $pgmout

#================================================================
#================================================================

if [ "$PROCESS_DATACOUNTS" = 'YES' ]; then

#  Prepare the data counts for the SDM if requested
#  ------------------------------------------------

   $ushscript_datacount/bufr_datacount.sh
fi

#================================================================
#================================================================


if [ "$PROCESS_DUMP" = 'YES' ]; then

   if [ "$err1" -gt '5' -o "$err2" -gt '5' -o "$err3" -gt '5' -o \
        "$err4" -gt '5' -o "$err5" -gt '5' -o "$err6" -gt '5'  -o \
        "$err7" -gt '5' -o "$err8" -gt '5' -o \
        "$err9" -gt '5' -o "$err10" -gt '5'	]; then
      for n in $err1 $err2 $err3 $err4 $err5 $err6 $err7 $err8 $err9 $err10
      do
         if [ "$n" -gt '5' ]; then
            if [ "$n" -ne '11' -a "$n" -ne '22' ]; then
       
## fatal error in dumping of BUFR obs. files
       
               set +x
echo
echo " ###################################################### "
echo " --> > 22 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7 $err8 $err9 $err10"
echo " --> @@ F A T A L   E R R O R @@   --  ABNORMAL EXIT    "
echo " ###################################################### "
echo
               set -x
               $DATA/err_exit
               exit 9
            fi
         fi
      done

## a status code of 11 or 22 from dumping of BUFR obs. files
## is non-fatal but still worth noting

      set +x
      echo
      echo " ###################################################### "
      echo " --> > 5 RETURN CODE FROM DATA DUMP, $err1, $err2, $err3, $err4, \
$err5, $err6, $err7 $err8 $err9 $err10 "
      echo " --> NOT ALL DATA DUMP FILES ARE COMPLETE - CONTINUE    "
      echo " ###################################################### "
      echo
      set -x
   fi

#  endif loop $PROCESS_DUMP
fi


if [ "$PROCESS_AVGTABLES" = 'YES' ]; then

########################################################################
#    Update Data Count Average Tables for All Cycles in Dump Monitor   #
#               (Normally done only in 23Z run of this job)            #
########################################################################

   msg="Attempt to update data count average table dump monitoring"
   $DATA/postmsg "$jlogfile" "$msg"

   $USHobsproc/bufr_avgdata.sh $NET
   errsc=$?
   if [ "$errsc" -eq '0' ]; then
      rm $AVGDarch_OUT/obcount_30davg.${NET}.current
      cp obcount_30davg.${NET}.current \
       $AVGDarch_OUT/obcount_30davg.${NET}.current
      chmod 775 $AVGDarch_OUT/obcount_30davg.${NET}.current
      msg="Data count average table SUCCESSFULLY updated for dump monitoring"
      $DATA/postmsg "$jlogfile" "$msg"
      typeset -Z2 this_month last_month
      this_month=`echo $PDY | cut -c5-6`
      year=`echo $PDY | cut -c1-4`
      last_month=`expr $this_month - 1`
      if [ "$last_month" -eq '0' ]; then
         last_month=12
         year=`expr $year - 1`
      fi
###   if [ ! -s $AVGDarch_OUT/obcount_30davg.${NET}.${year}${last_month} ]
###   then

#  If no data count average table found for previous month, save this one
#   (Currently not done in data monitoring)

###      rm $AVGDarch_OUT/obcount_30davg.${NET}.*${last_month}
###      cp obcount_30davg.${NET}.current \
###       $AVGDarch_OUT/obcount_30davg.${NET}.${year}${last_month}
###      chmod 775 $AVGDarch_OUT/obcount_30davg.${NET}.${year}${last_month}
###      msg="DATA COUNT AVERAGE table for ${year}${last_month} saved \
###for dump monitoring"
###      $DATA/postmsg "$jlogfile" "$msg"
###   fi
   else
      msg="Data count average table NOT updated for dump monitoring"
      $DATA/postmsg "$jlogfile" "$msg"
   fi

#  endif loop $PROCESS_AVGTABLES
fi

#######################

#
# copy bufr_dumplist to $COMOUT per NCO SPA request
# -------------------------------------------------
echo "Copy bufr_dumplist to comout"
LIST_cp=$COMOUT/${RUN}.t${cyc}z.bufr_dumplist.${tmmark}
cp ${FIXbufr_dump}/bufr_dumplist $LIST_cp
chmod 644 $LIST_cp

# GOOD RUN
set +x
echo " "
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " ****** PROCESSING COMPLETED NORMALLY"
echo " "
set -x


# save standard output
cat  break $pgmout break > allout
cat allout
# rm allout

sleep 10

msg='ENDED NORMALLY.'
$DATA/postmsg "$jlogfile" "$msg"

################## END OF SCRIPT #######################
